#include "precomp.h"

# 9 "bc/src/bool.c"
Scheme_Object scheme_true [1 ] ; 
Scheme_Object scheme_false [1 ] ; 

Scheme_Object * scheme_not_proc ; 
Scheme_Object * scheme_true_object_p_proc ; 
Scheme_Object * scheme_boolean_p_proc ; 
Scheme_Object * scheme_eq_proc ; 
Scheme_Object * scheme_eqv_proc ; 
Scheme_Object * scheme_equal_proc ; 


static Scheme_Object * not_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * true_object_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * boolean_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * eq_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * eqv_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equal_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equalish_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equal_always_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equal_always_recur_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonator_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_impersonator_star_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_of (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonator_of (int argc , Scheme_Object * argv [] ) ; 

typedef struct Equal_Info {

  intptr_t depth ; 
  intptr_t car_depth ; 
  Scheme_Hash_Table * ht ; 
  Scheme_Object * recur ; 
  Scheme_Object * next , * next_next ; 
  Scheme_Object * insp ; 
  intptr_t mode ; 
}

# 44 "bc/src/bool.c"
Equal_Info ; 

static int is_equal (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) ; 
static int vector_equal (Scheme_Object * vec1 , Scheme_Object * orig_vec1 , 
Scheme_Object * vec2 , Scheme_Object * orig_vec2 , 
Equal_Info * eql ) ; 
static int struct_equal (Scheme_Object * s1 , Scheme_Object * orig_s1 , 
Scheme_Object * s2 , Scheme_Object * orig_s2 , 
Equal_Info * eql ) ; 

void scheme_init_true_false (void ) 
{
  /* No conversion */

# 56 "bc/src/bool.c"
  scheme_true -> type = scheme_true_type ; 
  scheme_false -> type = scheme_false_type ; 
  scheme_void -> type = scheme_void_type ; 
}

void scheme_init_bool (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_not_proc , sizeof (scheme_not_proc ) ) )
# 65 "bc/src/bool.c"
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_true_object_p_proc , sizeof (scheme_true_object_p_proc ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_boolean_p_proc , sizeof (scheme_boolean_p_proc ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_eq_proc , sizeof (scheme_eq_proc ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_eqv_proc , sizeof (scheme_eqv_proc ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_equal_proc , sizeof (scheme_equal_proc ) ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (not_prim , "not" , 1 , 1 , 1 ) ); 
  scheme_not_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("not" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (true_object_p_prim , "true-object?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  scheme_true_object_p_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("true-object?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (boolean_p_prim , "boolean?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  scheme_boolean_p_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("boolean?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (eq_prim , "eq?" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  scheme_eq_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("eq?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (eqv_prim , "eqv?" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  scheme_eqv_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("eqv?" , scheme_eqv_proc , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (equal_prim , "equal?" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 25 ) ) ) ; 
  scheme_equal_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("equal?" , scheme_equal_proc , env ) ); 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (equalish_prim , "equal?/recur" , 3 , 3 ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("equal?/recur" , __funcarg62 , env ) )) 
  ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (equal_always_prim , "equal-always?" , 2 , 2 ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("equal-always?" , __funcarg61 , env ) )) 
  ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (equal_always_recur_prim , "equal-always?/recur" , 3 , 3 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("equal-always?/recur" , __funcarg60 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (chaperone_p , "chaperone?" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("chaperone?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (impersonator_p , "impersonator?" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("impersonator?" , p , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (procedure_impersonator_star_p , "procedure-impersonator*?" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure-impersonator*?" , p , env ) ); 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_of , "chaperone-of?" , 2 , 2 ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-of?" , __funcarg59 , env ) )) 
  ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonator_of , "impersonator-of?" , 2 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonator-of?" , __funcarg58 , env ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 148 "bc/src/bool.c"
static Scheme_Object * 
not_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 151 "bc/src/bool.c"
  return (((argv [0 ] ) == (scheme_false ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
true_object_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 157 "bc/src/bool.c"
  return (((argv [0 ] ) == (scheme_true ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
boolean_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 163 "bc/src/bool.c"
  return ((((argv [0 ] ) == (scheme_true ) ) || ((argv [0 ] ) == (scheme_false ) ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
eq_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 169 "bc/src/bool.c"
  return (((argv [0 ] ) == (argv [1 ] ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
eqv_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 175 "bc/src/bool.c"
  return (scheme_eqv (argv [0 ] , argv [1 ] ) ? scheme_true : scheme_false ) ; 
}

__xform_nongcing__ static void init_equal_info (Equal_Info * eql ) 
{
  /* No conversion */

# 180 "bc/src/bool.c"
  eql -> depth = 1 ; 
  eql -> car_depth = 1 ; 
  eql -> ht = ((void * ) 0 ) ; 
  eql -> recur = ((void * ) 0 ) ; 
  eql -> next = ((void * ) 0 ) ; 
  eql -> next_next = ((void * ) 0 ) ; 
  eql -> insp = ((void * ) 0 ) ; 
  eql -> mode = 0 ; 
}

static Scheme_Object * 
equal_prim (int argc , Scheme_Object * argv [] ) 
{
  Equal_Info eql ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(eql.ht, 0), PUSH(eql.recur, 1), PUSH(eql.next, 2), PUSH(eql.next_next, 3), PUSH(eql.insp, 4)));
# define XfOrM9_COUNT (5)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql.next = NULLED_OUT ; 
  eql.next_next = NULLED_OUT ; 
  eql.insp = NULLED_OUT ; 
  (
# 195 "bc/src/bool.c"
  init_equal_info (& eql ) ) ; 

  RET_VALUE_START ((FUNCCALL(SETUP_XfOrM9(_), is_equal (argv [0 ] , argv [1 ] , & eql ) )? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 200 "bc/src/bool.c"
static Scheme_Object * 
equalish_prim (int argc , Scheme_Object * argv [] ) 
{
  Equal_Info eql ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(eql.ht, 1), PUSH(eql.recur, 2), PUSH(eql.next, 3), PUSH(eql.next_next, 4), PUSH(eql.insp, 5)));
# define XfOrM10_COUNT (6)
# define SETUP_XfOrM10(x) SETUP(XfOrM10_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql.next = NULLED_OUT ; 
  eql.next_next = NULLED_OUT ; 
  eql.insp = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM10(_), scheme_check_proc_arity ("equal?/recur" , 2 , 2 , argc , argv ) )
# 205 "bc/src/bool.c"
  ; 
  (
  init_equal_info (& eql ) ) ; 
  eql . next_next = argv [2 ] ; 

  RET_VALUE_START ((FUNCCALL(SETUP_XfOrM10(_), is_equal (argv [0 ] , argv [1 ] , & eql ) )? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 213 "bc/src/bool.c"
static Scheme_Object * 
equal_always_prim (int argc , Scheme_Object * argv [] ) 
{
  Equal_Info eql ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(eql.ht, 0), PUSH(eql.recur, 1), PUSH(eql.next, 2), PUSH(eql.next_next, 3), PUSH(eql.insp, 4)));
# define XfOrM11_COUNT (5)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql.next = NULLED_OUT ; 
  eql.next_next = NULLED_OUT ; 
  eql.insp = NULLED_OUT ; 
  (
# 218 "bc/src/bool.c"
  init_equal_info (& eql ) ) ; 
  eql . mode = 5 ; 

  RET_VALUE_START ((FUNCCALL(SETUP_XfOrM11(_), is_equal (argv [0 ] , argv [1 ] , & eql ) )? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 224 "bc/src/bool.c"
static Scheme_Object * 
equal_always_recur_prim (int argc , Scheme_Object * argv [] ) 
{
  Equal_Info eql ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(eql.ht, 1), PUSH(eql.recur, 2), PUSH(eql.next, 3), PUSH(eql.next_next, 4), PUSH(eql.insp, 5)));
# define XfOrM12_COUNT (6)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql.next = NULLED_OUT ; 
  eql.next_next = NULLED_OUT ; 
  eql.insp = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM12(_), scheme_check_proc_arity ("equal-always?/recur" , 2 , 2 , argc , argv ) )
# 229 "bc/src/bool.c"
  ; 
  (
  init_equal_info (& eql ) ) ; 
  eql . next_next = argv [2 ] ; 
  eql . mode = 5 ; 

  RET_VALUE_START ((FUNCCALL(SETUP_XfOrM12(_), is_equal (argv [0 ] , argv [1 ] , & eql ) )? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 238 "bc/src/bool.c"
int scheme_eq (Scheme_Object * obj1 , Scheme_Object * obj2 ) 
{
  /* No conversion */

# 240 "bc/src/bool.c"
  return ((obj1 ) == (obj2 ) ) ; 
}

# 280 "bc/src/bool.c"
__xform_nongcing__ static inline int double_eqv (double a , double b ) 
{
  /* No conversion */
  if (a != b ) {


    if (__builtin_isnan (a ) ) {
      if (__builtin_isnan (b ) )
        return 1 ; 
    }

# 305 "bc/src/bool.c"
    return 0 ; 
  }
  if (a == 0.0 ) {
    if (b == 0.0 ) {
      return scheme_minus_zero_p (a ) == scheme_minus_zero_p (b ) ; 
    }
  }
  return 1 ; 
}


__xform_nongcing__ static int is_eqv (Scheme_Object * obj1 , Scheme_Object * obj2 ) 
{
  /* No conversion */

# 318 "bc/src/bool.c"
  Scheme_Type t1 , t2 ; 

  if ((obj1 ) == (obj2 ) ) 
    return 1 ; 

  t1 = ((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ; 
  t2 = ((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ; 

  if ((Scheme_Type ) (t1 ) != (Scheme_Type ) (t2 ) )  {







    return - 1 ; 
  }

# 335 "bc/src/bool.c"
  else {
    switch (t1 ) {





      case scheme_float_type : 
      return double_eqv ((((Scheme_Float * ) (obj1 ) ) -> float_val ) , (((Scheme_Float * ) (obj2 ) ) -> float_val ) ) ; 

      case scheme_double_type : 
      return double_eqv ((((Scheme_Double * ) (obj1 ) ) -> double_val ) , (((Scheme_Double * ) (obj2 ) ) -> double_val ) ) ; 
      case scheme_bignum_type : 
      return scheme_bignum_eq (obj1 , obj2 ) ; 
      case scheme_rational_type : 
      return scheme_rational_eq (obj1 , obj2 ) ; 
      case scheme_complex_type : 
      {
        Scheme_Complex * c1 = (Scheme_Complex * ) obj1 ; 
        Scheme_Complex * c2 = (Scheme_Complex * ) obj2 ; 
        return scheme_eqv (c1 -> r , c2 -> r ) && scheme_eqv (c1 -> i , c2 -> i ) ; 
      }
      case scheme_char_type : 
      return (((Scheme_Small_Object * ) (obj1 ) ) -> u . char_val ) == (((Scheme_Small_Object * ) (obj2 ) ) -> u . char_val ) ; 
      case scheme_symbol_type : 
      case scheme_keyword_type : 

      return 0 ; 
      default : 
      return - 1 ; 
    }
  }
}

int scheme_eqv (Scheme_Object * obj1 , Scheme_Object * obj2 ) 
{
  /* No conversion */

# 371 "bc/src/bool.c"
  return (is_eqv (obj1 , obj2 ) > 0 ) ; 
}








__xform_nongcing__ int is_fast_equal (Scheme_Object * obj1 , Scheme_Object * obj2 , int for_chaperone_alw ) 
{
  /* No conversion */

# 383 "bc/src/bool.c"
  Scheme_Type t1 , t2 ; 
  int cmp ; 

  cmp = is_eqv (obj1 , obj2 ) ; 
  if (cmp > - 1 )
    return cmp ; 

  t1 = ((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ; 
  t2 = ((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ; 

  if ((Scheme_Type ) (t1 ) != (Scheme_Type ) (t2 ) ) 
    return - 1 ; 

  switch (t1 ) {
    case scheme_flvector_type : 
    {
      intptr_t l1 , l2 , i ; 
      if (for_chaperone_alw )

# 400 "bc/src/bool.c"
      return - 1 ; 
      l1 = (((Scheme_Double_Vector * ) (obj1 ) ) -> size ) ; 
      l2 = (((Scheme_Double_Vector * ) (obj2 ) ) -> size ) ; 
      if (l1 == l2 ) {
        for (i = 0 ; i < l1 ; i ++ ) {
          if (! double_eqv ((((Scheme_Double_Vector * ) (obj1 ) ) -> els ) [i ] , 
          (((Scheme_Double_Vector * ) (obj2 ) ) -> els ) [i ] ) )
            return 0 ; 
        }
        return 1 ; 
      }
      return 0 ; 
    }

# 431 "bc/src/bool.c"
    case scheme_byte_string_type : 
    case scheme_unix_path_type : 
    case scheme_windows_path_type : 
    {
      intptr_t l1 , l2 ; 
      if (for_chaperone_alw )

# 436 "bc/src/bool.c"
      return - 1 ; 
      l1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . byte_str_val . tag_val ) ; 
      l2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . byte_str_val . tag_val ) ; 
      return ((l1 == l2 ) 
      && ! memcmp ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . byte_str_val . string_val ) , l1 ) ) ; 
    }
    case scheme_char_string_type : 
    {
      intptr_t l1 , l2 ; 
      if (for_chaperone_alw )

# 445 "bc/src/bool.c"
      return - 1 ; 
      l1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . char_str_val . tag_val ) ; 
      l2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . char_str_val . tag_val ) ; 
      return ((l1 == l2 ) 
      && ! memcmp ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . char_str_val . string_val ) , l1 * sizeof (mzchar ) ) ) ; 
    }
    case scheme_cpointer_type : 
    {
      return (((char * ) (((Scheme_Cptr * ) (obj1 ) ) -> val ) + (((& ((Scheme_Cptr * ) (obj1 ) ) -> so ) -> so . keyex & 0x2 ) ? ((Scheme_Offset_Cptr * ) obj1 ) -> offset : 0 ) ) 
      == ((char * ) (((Scheme_Cptr * ) (obj2 ) ) -> val ) + (((& ((Scheme_Cptr * ) (obj2 ) ) -> so ) -> so . keyex & 0x2 ) ? ((Scheme_Offset_Cptr * ) obj2 ) -> offset : 0 ) ) ) ; 
    }
    case scheme_place_bi_channel_type : 
    {
      Scheme_Place_Bi_Channel * bc1 , * bc2 ; 
      bc1 = (Scheme_Place_Bi_Channel * ) obj1 ; 
      bc2 = (Scheme_Place_Bi_Channel * ) obj2 ; 
      return (((bc1 -> link -> recvch ) == (bc2 -> link -> recvch ) ) 
      && ((bc1 -> link -> sendch ) == (bc2 -> link -> sendch ) ) ) ; 
    }
  }

  return - 1 ; 
}

int is_slow_equal (Scheme_Object * obj1 , Scheme_Object * obj2 ) 
{
  Equal_Info eql ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(eql.ht, 0), PUSH(eql.recur, 1), PUSH(eql.next, 2), PUSH(eql.next_next, 3), PUSH(eql.insp, 4)));
# define XfOrM35_COUNT (5)
# define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql.next = NULLED_OUT ; 
  eql.next_next = NULLED_OUT ; 
  eql.insp = NULLED_OUT ; 
  (
# 473 "bc/src/bool.c"
  init_equal_info (& eql ) ) ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM35(_), is_equal (obj1 , obj2 , & eql ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 478 "bc/src/bool.c"
int scheme_equal (Scheme_Object * obj1 , Scheme_Object * obj2 ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 480 "bc/src/bool.c"
  int v ; 

  v = is_fast_equal (obj1 , obj2 , 0 ) ; 
  if (v > - 1 )
    return v ; 

  return is_slow_equal (obj1 , obj2 ) ; 
}

int is_slow_equal_always (Scheme_Object * obj1 , Scheme_Object * obj2 ) 
{
  Equal_Info eql ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(eql.ht, 0), PUSH(eql.recur, 1), PUSH(eql.next, 2), PUSH(eql.next_next, 3), PUSH(eql.insp, 4)));
# define XfOrM37_COUNT (5)
# define SETUP_XfOrM37(x) SETUP(XfOrM37_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql.next = NULLED_OUT ; 
  eql.next_next = NULLED_OUT ; 
  eql.insp = NULLED_OUT ; 
  (
# 493 "bc/src/bool.c"
  init_equal_info (& eql ) ) ; 
  eql . mode = 5 ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM37(_), is_equal (obj1 , obj2 , & eql ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 499 "bc/src/bool.c"
int scheme_equal_always (Scheme_Object * obj1 , Scheme_Object * obj2 ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 501 "bc/src/bool.c"
  int v ; 

  v = is_fast_equal (obj1 , obj2 , 1 ) ; 
  if (v > - 1 )
    return v ; 

  return is_slow_equal_always (obj1 , obj2 ) ; 
}

static Scheme_Object * union_find (Scheme_Object * obj1 , Scheme_Hash_Table * ht ) 
{
  Scheme_Object * v , * prev = obj1 , * prev_prev = obj1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(prev_prev, 1), PUSH(obj1, 2), PUSH(prev, 3), PUSH(ht, 4)));
# define XfOrM39_COUNT (5)
# define SETUP_XfOrM39(x) SETUP(XfOrM39_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 514 "bc/src/bool.c"
  while (1 ) {
#   define XfOrM44_COUNT (0+XfOrM39_COUNT)
#   define SETUP_XfOrM44(x) SETUP_XfOrM39(x)

# 515 "bc/src/bool.c"
    v = FUNCCALL(SETUP_XfOrM44(_), scheme_hash_get (ht , prev ) ); 
    if (v ) {
      prev_prev = prev ; 
      prev = v ; 
    }

# 519 "bc/src/bool.c"
    else 
    break ; 
  }


  while (obj1 != prev_prev ) {
#   define XfOrM41_COUNT (0+XfOrM39_COUNT)
#   define SETUP_XfOrM41(x) SETUP_XfOrM39(x)

# 525 "bc/src/bool.c"
    v = FUNCCALL(SETUP_XfOrM41(_), scheme_hash_get (ht , obj1 ) ); 
    FUNCCALL(SETUP_XfOrM41(_), scheme_hash_set (ht , obj1 , prev ) ); 
    obj1 = v ; 
  }

  RET_VALUE_START (prev ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 533 "bc/src/bool.c"
static int union_check (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(obj1, 0), PUSH(eql, 1), PUSH(obj2, 2)));
# define XfOrM46_COUNT (3)
# define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 535 "bc/src/bool.c"
  if (eql -> depth < 50 ) {
    if (! eql -> next_next )
      eql -> depth += 2 ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 539 "bc/src/bool.c"
  else {
    Scheme_Hash_Table * ht = eql -> ht ; 
    BLOCK_SETUP((PUSH(ht, 0+XfOrM46_COUNT)));
#   define XfOrM47_COUNT (1+XfOrM46_COUNT)
#   define SETUP_XfOrM47(x) SETUP(XfOrM47_COUNT)

# 541 "bc/src/bool.c"
    if (! ht ) {
#     define XfOrM48_COUNT (0+XfOrM47_COUNT)
#     define SETUP_XfOrM48(x) SETUP_XfOrM47(x)

# 542 "bc/src/bool.c"
      ht = FUNCCALL(SETUP_XfOrM48(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      eql -> ht = ht ; 
    }
    obj1 = FUNCCALL(SETUP_XfOrM47(_), union_find (obj1 , ht ) ); 
    obj2 = FUNCCALL(SETUP_XfOrM47(_), union_find (obj2 , ht ) ); 

    if ((obj1 ) == (obj2 ) ) 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    FUNCCALL_EMPTY(scheme_hash_set (ht , obj2 , obj1 ) )
    ; 

    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 557 "bc/src/bool.c"
static Scheme_Object * equal_k (void ) 
{
  /* No conversion */

# 559 "bc/src/bool.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * v1 = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * v2 = (Scheme_Object * ) p -> ku . k . p2 ; 
  Equal_Info * eql = (Equal_Info * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return is_equal (v1 , v2 , eql ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * equal_recur (int argc , Scheme_Object * * argv , Scheme_Object * prim ) 
{
  Equal_Info * eql = (Equal_Info * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
  int is_eq ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(eql, 0)));
# define XfOrM51_COUNT (1)
# define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 576 "bc/src/bool.c"
  eql -> insp = ((void * ) 0 ) ; 

  is_eq = FUNCCALL(SETUP_XfOrM51(_), is_equal (argv [0 ] , argv [1 ] , eql ) ); 

  eql -> insp = ((void * ) 0 ) ; 

  RET_VALUE_START ((is_eq 
  ? scheme_true 
  : scheme_false ) ) 
# 582 "bc/src/bool.c"
  RET_VALUE_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 587 "bc/src/bool.c"
static int is_equal_overflow (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Equal_Info * eql2 ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(eql2, 0), PUSH(p, 1), PUSH(v, 2), PUSH(obj1, 3), PUSH(eql, 4), PUSH(obj2, 5)));
# define XfOrM52_COUNT (6)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql2 = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 593 "bc/src/bool.c"
  eql2 = (Equal_Info * ) FUNCCALL(SETUP_XfOrM52(_), GC_malloc (sizeof (Equal_Info ) ) ); 
  (memcpy (eql2 , eql , sizeof (Equal_Info ) ) ) ; 

  p -> ku . k . p1 = (void * ) obj1 ; 
  p -> ku . k . p2 = (void * ) obj2 ; 
  p -> ku . k . p3 = (void * ) eql2 ; 

  v = FUNCCALL(SETUP_XfOrM52(_), scheme_handle_stack_overflow (equal_k ) ); 
  (
  memcpy (eql , eql2 , sizeof (Equal_Info ) ) ) ; 

  RET_VALUE_START ((! (((v ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 607 "bc/src/bool.c"
int is_equal (Scheme_Object * obj1 , Scheme_Object * obj2 , Equal_Info * eql ) 
{
  Scheme_Type t1 , t2 ; 
  int cmp ; 
  Scheme_Object * orig_obj1 , * orig_obj2 ; 
  Scheme_Config * __funcarg63 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(orig_obj1, 0), PUSH(orig_obj2, 1), PUSH(obj1, 2), PUSH(eql, 3), PUSH(obj2, 4)));
# define XfOrM53_COUNT (5)
# define SETUP_XfOrM53(x) SETUP(XfOrM53_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  orig_obj1 = NULLED_OUT ; 
  orig_obj2 = NULLED_OUT ; 

# 613 "bc/src/bool.c"
  top : 
  orig_obj1 = obj1 ; 
  orig_obj2 = obj2 ; 

  if (eql -> next_next ) {
#   define XfOrM132_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM132(x) SETUP_XfOrM53(x)

# 618 "bc/src/bool.c"
    if (eql -> next ) {
      Scheme_Object * a [2 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM132_COUNT)));
#     define XfOrM133_COUNT (3+XfOrM132_COUNT)
#     define SETUP_XfOrM133(x) SETUP(XfOrM133_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 

# 620 "bc/src/bool.c"
      a [0 ] = obj1 ; 
      a [1 ] = obj2 ; 
      obj1 = FUNCCALL(SETUP_XfOrM133(_), scheme_do_eval (eql -> next , 2 , a , 1 ) ); 
      RET_VALUE_START ((! (((obj1 ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
    }
    eql -> next = eql -> next_next ; 
  }

  top_after_next : 
  cmp = (is_fast_equal (obj1 , obj2 , (eql -> mode == 1 ) || (eql -> mode == 5 ) ) ) ; 
  if (cmp > - 1 )
    RET_VALUE_START (cmp ) RET_VALUE_END ; 

  if (((eql -> mode == 1 ) || (eql -> mode == 3 ) ) 
  && (((Scheme_Type ) (((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
  && (! ((& ((Scheme_Chaperone * ) obj2 ) -> iso ) -> so . keyex & 0x1 ) 
  || (eql -> mode == 3 ) ) 
  && FUNCCALL(SETUP_XfOrM53(_), scheme_is_noninterposing_chaperone (obj2 ) )) {
    obj2 = ((Scheme_Chaperone * ) obj2 ) -> prev ; 
    goto top_after_next ; 
  }

  if (((eql -> mode == 1 ) || (eql -> mode == 3 ) ) 
  && (((Scheme_Type ) (((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
  && (! ((& ((Scheme_Chaperone * ) obj1 ) -> iso ) -> so . keyex & 0x1 ) 
  || (eql -> mode == 3 ) ) ) {


    if (((Scheme_Type ) (((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {



      if (((((((intptr_t ) (((Scheme_Chaperone * ) obj1 ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Chaperone * ) obj1 ) -> val ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (((Scheme_Chaperone * ) obj1 ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Chaperone * ) obj1 ) -> val ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
      && ((((((intptr_t ) (((Scheme_Chaperone * ) obj2 ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Chaperone * ) obj2 ) -> val ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (((Scheme_Chaperone * ) obj2 ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Chaperone * ) obj2 ) -> val ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 

      && ((((Scheme_Chaperone * ) obj1 ) -> redirects ) == (((Scheme_Chaperone * ) obj2 ) -> redirects ) ) )

      obj2 = ((Scheme_Chaperone * ) obj2 ) -> prev ; 
    }
    obj1 = ((Scheme_Chaperone * ) obj1 ) -> prev ; 
    goto top_after_next ; 
  }

  t1 = ((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ; 
  t2 = ((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ; 

  if ((Scheme_Type ) (t1 ) != (Scheme_Type ) (t2 ) )  {
#   define XfOrM123_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM123(x) SETUP_XfOrM53(x)

# 667 "bc/src/bool.c"
    if (t1 == scheme_hash_tree_indirection_type ) {
#     define XfOrM128_COUNT (0+XfOrM123_COUNT)
#     define SETUP_XfOrM128(x) SETUP_XfOrM123(x)

# 668 "bc/src/bool.c"
      obj1 = (Scheme_Object * ) (scheme_hash_tree_resolve_placeholder ((Scheme_Hash_Tree * ) obj1 ) ) ; 
      goto top_after_next ; 
    }
    if (t2 == scheme_hash_tree_indirection_type ) {
#     define XfOrM127_COUNT (0+XfOrM123_COUNT)
#     define SETUP_XfOrM127(x) SETUP_XfOrM123(x)

# 672 "bc/src/bool.c"
      obj2 = (Scheme_Object * ) (scheme_hash_tree_resolve_placeholder ((Scheme_Hash_Tree * ) obj2 ) ) ; 
      goto top_after_next ; 
    }
    if ((eql -> mode == 0 ) || (eql -> mode == 5 ) ) {
      if (((Scheme_Type ) (((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {

        obj1 = ((Scheme_Chaperone * ) obj1 ) -> prev ; 
        goto top_after_next ; 
      }
      if (((Scheme_Type ) (((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj2 ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
        obj2 = ((Scheme_Chaperone * ) obj2 ) -> val ; 
        goto top_after_next ; 
      }
    }
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 687 "bc/src/bool.c"
  else {
#   define XfOrM54_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM54(x) SETUP_XfOrM53(x)

# 688 "bc/src/bool.c"
    switch (t1 ) {
#     define XfOrM55_COUNT (0+XfOrM54_COUNT)
#     define SETUP_XfOrM55(x) SETUP_XfOrM54(x)

# 689 "bc/src/bool.c"
      case scheme_pair_type : 
      {
#       define XfOrM117_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM117(x) SETUP_XfOrM55(x)

# 1 "bc/src/mzeqchk.inc"
        {
#         define XfOrM121_COUNT (0+XfOrM117_COUNT)
#         define SETUP_XfOrM121(x) SETUP_XfOrM117(x)

# 1 "bc/src/mzeqchk.inc"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM122_COUNT (0+XfOrM121_COUNT)
#           define SETUP_XfOrM122(x) SETUP_XfOrM121(x)
            FUNCCALL(SETUP_XfOrM122(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
            ; 
          }
        }

# 1 "bc/src/mzeqchk.inc"
        ; 

        {

# 24 "bc/src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM120_COUNT (0+XfOrM117_COUNT)
#         define SETUP_XfOrM120(x) SETUP_XfOrM117(x)

# 26 "bc/src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
        }

# 692 "bc/src/bool.c"
        if ((eql -> car_depth > 2 ) || ! (scheme_is_list (obj1 ) ) ) {
#         define XfOrM119_COUNT (0+XfOrM117_COUNT)
#         define SETUP_XfOrM119(x) SETUP_XfOrM117(x)

# 693 "bc/src/bool.c"
          if (FUNCCALL(SETUP_XfOrM119(_), union_check (obj1 , obj2 , eql ) ))
            RET_VALUE_START (1 ) RET_VALUE_END ; 
        }
        eql -> car_depth += 2 ; 
        if (FUNCCALL(SETUP_XfOrM117(_), is_equal ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . car ) , eql ) )) {
          eql -> car_depth -= 2 ; 
          obj1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . cdr ) ; 
          obj2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . cdr ) ; 
          goto top ; 
        }

# 702 "bc/src/bool.c"
        else 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      case scheme_mutable_pair_type : 
      {
#       define XfOrM112_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM112(x) SETUP_XfOrM55(x)

# 1 "bc/src/mzeqchk.inc"
        {
#         define XfOrM115_COUNT (0+XfOrM112_COUNT)
#         define SETUP_XfOrM115(x) SETUP_XfOrM112(x)

# 1 "bc/src/mzeqchk.inc"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM116_COUNT (0+XfOrM115_COUNT)
#           define SETUP_XfOrM116(x) SETUP_XfOrM115(x)
            FUNCCALL(SETUP_XfOrM116(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
            ; 
          }
        }

# 1 "bc/src/mzeqchk.inc"
        ; 

        {

# 24 "bc/src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM114_COUNT (0+XfOrM112_COUNT)
#         define SETUP_XfOrM114(x) SETUP_XfOrM112(x)

# 26 "bc/src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
        }

# 708 "bc/src/bool.c"
        if ((eql -> mode == 1 ) || (eql -> mode == 5 ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM112(_), union_check (obj1 , obj2 , eql ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM112(_), is_equal ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . car ) , eql ) )) {
          obj1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . cdr ) ; 
          obj2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . cdr ) ; 
          goto top ; 
        }

# 716 "bc/src/bool.c"
        else 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      case scheme_vector_type : 
      case scheme_fxvector_type : 
      {
#       define XfOrM108_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM108(x) SETUP_XfOrM55(x)

# 1 "bc/src/mzeqchk.inc"
        {
#         define XfOrM110_COUNT (0+XfOrM108_COUNT)
#         define SETUP_XfOrM110(x) SETUP_XfOrM108(x)

# 1 "bc/src/mzeqchk.inc"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM111_COUNT (0+XfOrM110_COUNT)
#           define SETUP_XfOrM111(x) SETUP_XfOrM110(x)
            FUNCCALL(SETUP_XfOrM111(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
            ; 
          }
        }

# 1 "bc/src/mzeqchk.inc"
        ; 

        {

# 24 "bc/src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM109_COUNT (0+XfOrM108_COUNT)
#         define SETUP_XfOrM109(x) SETUP_XfOrM108(x)

# 26 "bc/src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
        }

# 723 "bc/src/bool.c"
        if ((((eql -> mode == 1 ) || (eql -> mode == 5 ) ) ) 
        && (! (((Scheme_Inclhash_Object * ) (obj1 ) ) -> so . keyex & 0x1 ) || ! (((Scheme_Inclhash_Object * ) (obj2 ) ) -> so . keyex & 0x1 ) ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM108(_), union_check (obj1 , obj2 , eql ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(vector_equal (obj1 , orig_obj1 , obj2 , orig_obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
      }
      case scheme_stencil_vector_type : 
      {
        Scheme_Stencil_Vector * sv1 = (Scheme_Stencil_Vector * ) obj1 ; 
        Scheme_Stencil_Vector * sv2 = (Scheme_Stencil_Vector * ) obj2 ; 
        intptr_t i , len ; 
        BLOCK_SETUP((PUSH(sv1, 0+XfOrM55_COUNT), PUSH(sv2, 1+XfOrM55_COUNT)));
#       define XfOrM102_COUNT (2+XfOrM55_COUNT)
#       define SETUP_XfOrM102(x) SETUP(XfOrM102_COUNT)

# 1 "bc/src/mzeqchk.inc"
        {
#         define XfOrM106_COUNT (0+XfOrM102_COUNT)
#         define SETUP_XfOrM106(x) SETUP_XfOrM102(x)

# 1 "bc/src/mzeqchk.inc"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM107_COUNT (0+XfOrM106_COUNT)
#           define SETUP_XfOrM107(x) SETUP_XfOrM106(x)
            FUNCCALL(SETUP_XfOrM107(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
            ; 
          }
        }

# 1 "bc/src/mzeqchk.inc"
        ; 

        {

# 24 "bc/src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM105_COUNT (0+XfOrM102_COUNT)
#         define SETUP_XfOrM105(x) SETUP_XfOrM102(x)

# 26 "bc/src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
        }

# 736 "bc/src/bool.c"
        if ((eql -> mode == 1 ) || (eql -> mode == 5 ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        if (sv1 -> mask != sv2 -> mask )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM102(_), union_check (obj1 , obj2 , eql ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        len = (scheme_stencil_vector_popcount (sv1 -> mask ) ) ; 
        for (i = 0 ; i < len ; i ++ ) {
#         define XfOrM104_COUNT (0+XfOrM102_COUNT)
#         define SETUP_XfOrM104(x) SETUP_XfOrM102(x)

# 744 "bc/src/bool.c"
          if (! FUNCCALL(SETUP_XfOrM104(_), is_equal (sv1 -> els [i ] , sv2 -> els [i ] , eql ) ))
            RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }
      case scheme_byte_string_type : 
      case scheme_unix_path_type : 
      case scheme_windows_path_type : 
      {
        intptr_t l1 , l2 ; 
#       define XfOrM101_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM101(x) SETUP_XfOrM55(x)

# 754 "bc/src/bool.c"
        if (((eql -> mode == 1 ) || (eql -> mode == 5 ) ) 
        && (! (((Scheme_Inclhash_Object * ) (obj1 ) ) -> so . keyex & 0x1 ) || ! (((Scheme_Inclhash_Object * ) (obj2 ) ) -> so . keyex & 0x1 ) ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        l1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . byte_str_val . tag_val ) ; 
        l2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . byte_str_val . tag_val ) ; 
        RET_VALUE_START (((l1 == l2 ) 
        && ! (memcmp ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . byte_str_val . string_val ) , l1 ) ) ) ) 
# 759 "bc/src/bool.c"
        RET_VALUE_END 
        ; 
      }
      case scheme_char_string_type : 
      {
        intptr_t l1 , l2 ; 
#       define XfOrM100_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM100(x) SETUP_XfOrM55(x)

# 765 "bc/src/bool.c"
        if (((eql -> mode == 1 ) || (eql -> mode == 5 ) ) 
        && (! (((Scheme_Inclhash_Object * ) (obj1 ) ) -> so . keyex & 0x1 ) || ! (((Scheme_Inclhash_Object * ) (obj2 ) ) -> so . keyex & 0x1 ) ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        l1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . char_str_val . tag_val ) ; 
        l2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . char_str_val . tag_val ) ; 
        RET_VALUE_START (((l1 == l2 ) 
        && ! (memcmp ((((Scheme_Simple_Object * ) (obj1 ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (obj2 ) ) -> u . char_str_val . string_val ) , l1 * sizeof (mzchar ) ) ) ) ) 
# 770 "bc/src/bool.c"
        RET_VALUE_END 
        ; 
      }
      case scheme_regexp_type : 
      {
#       define XfOrM99_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM99(x) SETUP_XfOrM55(x)

# 775 "bc/src/bool.c"
        if (FUNCCALL(SETUP_XfOrM99(_), scheme_regexp_is_byte (obj1 ) )!= FUNCCALL(SETUP_XfOrM99(_), scheme_regexp_is_byte (obj2 ) ))
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM99(_), scheme_regexp_is_pregexp (obj1 ) )!= FUNCCALL(SETUP_XfOrM99(_), scheme_regexp_is_pregexp (obj2 ) ))
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        obj1 = (scheme_regexp_source (obj1 ) ) ; 
        obj2 = (scheme_regexp_source (obj2 ) ) ; 
        goto top ; 
      }
      case scheme_structure_type : 
      case scheme_proc_struct_type : 
      {
        Scheme_Struct_Type * st1 , * st2 ; 
        Scheme_Object * procs1 , * procs2 ; 
        BLOCK_SETUP((PUSH(procs2, 0+XfOrM55_COUNT), PUSH(st1, 1+XfOrM55_COUNT), PUSH(st2, 2+XfOrM55_COUNT), PUSH(procs1, 3+XfOrM55_COUNT)));
#       define XfOrM74_COUNT (4+XfOrM55_COUNT)
#       define SETUP_XfOrM74(x) SETUP(XfOrM74_COUNT)
        st1 = NULLED_OUT ; 
        st2 = NULLED_OUT ; 
        procs1 = NULLED_OUT ; 
        procs2 = NULLED_OUT ; 

# 789 "bc/src/bool.c"
        st1 = (((Scheme_Structure * ) obj1 ) -> stype ) ; 
        st2 = (((Scheme_Structure * ) obj2 ) -> stype ) ; 

        if (eql -> mode == 1 )
          procs1 = ((void * ) 0 ) ; 
        else 
        procs1 = (scheme_struct_type_property_ref (scheme_impersonator_of_property , (Scheme_Object * ) st1 ) ) ; 
        if (procs1 )
          procs1 = FUNCCALL(SETUP_XfOrM74(_), scheme_apply_impersonator_of (eql -> mode , procs1 , obj1 ) ); 
        if ((eql -> mode == 1 ) || (eql -> mode == 3 ) )
          procs2 = ((void * ) 0 ) ; 
        else {
#         define XfOrM98_COUNT (0+XfOrM74_COUNT)
#         define SETUP_XfOrM98(x) SETUP_XfOrM74(x)

# 801 "bc/src/bool.c"
          procs2 = (scheme_struct_type_property_ref (scheme_impersonator_of_property , (Scheme_Object * ) st2 ) ) ; 
          if (procs2 )
            procs2 = FUNCCALL(SETUP_XfOrM98(_), scheme_apply_impersonator_of (eql -> mode , procs2 , obj2 ) ); 
        }

        if (procs1 || procs2 ) {

          if (procs1 ) {

# 808 "bc/src/bool.c"
            obj1 = procs1 ; 

# 808 "bc/src/bool.c"
            orig_obj1 = obj1 ; 
          }

# 809 "bc/src/bool.c"
          if (procs2 ) {

# 809 "bc/src/bool.c"
            obj2 = procs2 ; 

# 809 "bc/src/bool.c"
            orig_obj2 = obj2 ; 
          }

# 810 "bc/src/bool.c"
          goto top_after_next ; 
        }

# 811 "bc/src/bool.c"
        else {
#         define XfOrM75_COUNT (0+XfOrM74_COUNT)
#         define SETUP_XfOrM75(x) SETUP_XfOrM74(x)
          if ((eql -> mode == 1 ) || (eql -> mode == 3 ) ) {
#           define XfOrM94_COUNT (0+XfOrM75_COUNT)
#           define SETUP_XfOrM94(x) SETUP_XfOrM75(x)

# 815 "bc/src/bool.c"
            procs2 = (scheme_struct_type_property_ref (scheme_impersonator_of_property , (Scheme_Object * ) st2 ) ) ; 
            if (procs2 && FUNCCALL(SETUP_XfOrM94(_), scheme_apply_impersonator_of (eql -> mode , procs2 , obj2 ) ))


            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

          procs1 = (scheme_struct_type_property_ref (scheme_equal_property , (Scheme_Object * ) st1 ) ) ; 
          if (procs1 && (st1 != st2 ) ) {
#           define XfOrM93_COUNT (0+XfOrM75_COUNT)
#           define SETUP_XfOrM93(x) SETUP_XfOrM75(x)

# 824 "bc/src/bool.c"
            procs2 = (scheme_struct_type_property_ref (scheme_equal_property , (Scheme_Object * ) st2 ) ) ; 
            if (! procs2 
            || ! (((((Scheme_Vector * ) (procs1 ) ) -> els ) [0 ] ) == ((((Scheme_Vector * ) (procs2 ) ) -> els ) [0 ] ) ) )
              procs1 = ((void * ) 0 ) ; 
          }

          if (procs1 ) {

            Scheme_Object * a [4 ] , * recur ; 
            Equal_Info * eql2 ; 
            BLOCK_SETUP((PUSH(eql2, 0+XfOrM75_COUNT), PUSH(recur, 1+XfOrM75_COUNT), PUSHARRAY(a, 4, 2+XfOrM75_COUNT)));
#           define XfOrM84_COUNT (5+XfOrM75_COUNT)
#           define SETUP_XfOrM84(x) SETUP(XfOrM84_COUNT)
            NULL_OUT_ARRAY (a ) ; 
            recur = NULLED_OUT ; 
            eql2 = NULLED_OUT ; 

# 1 "bc/src/mzeqchk.inc"
            {
#             define XfOrM91_COUNT (0+XfOrM84_COUNT)
#             define SETUP_XfOrM91(x) SETUP_XfOrM84(x)

# 1 "bc/src/mzeqchk.inc"
              if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#               define XfOrM92_COUNT (0+XfOrM91_COUNT)
#               define SETUP_XfOrM92(x) SETUP_XfOrM91(x)
                FUNCCALL(SETUP_XfOrM92(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
                ; 
              }
            }

# 1 "bc/src/mzeqchk.inc"
            ; 

            {

# 24 "bc/src/mzstkchk.h"
              uintptr_t _stk_pos ; 
#             define XfOrM90_COUNT (0+XfOrM84_COUNT)
#             define SETUP_XfOrM90(x) SETUP_XfOrM84(x)

# 26 "bc/src/mzstkchk.h"
              _stk_pos = (uintptr_t ) & _stk_pos ; 

              if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
              && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
              RET_VALUE_START (FUNCCALL(SETUP_XfOrM90(_), is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_END ; 
            }

# 836 "bc/src/bool.c"
            if (((eql -> mode == 5 ) || (eql -> mode == 1 ) ) 
            && ! ((& st1 -> iso ) -> so . keyex & 0x1 ) 
            && ((((Scheme_Vector * ) (procs1 ) ) -> size ) != 3 ) ) {

              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }

            if (FUNCCALL(SETUP_XfOrM84(_), union_check (obj1 , obj2 , eql ) ))
              RET_VALUE_START (1 ) RET_VALUE_END ; 


            if (eql -> recur ) {
              recur = eql -> recur ; 
              eql2 = (Equal_Info * ) ((Scheme_Primitive_Closure * ) recur ) -> val [0 ] ; 
            }

# 850 "bc/src/bool.c"
            else {
#             define XfOrM87_COUNT (0+XfOrM84_COUNT)
#             define SETUP_XfOrM87(x) SETUP_XfOrM84(x)

# 851 "bc/src/bool.c"
              eql2 = (Equal_Info * ) FUNCCALL(SETUP_XfOrM87(_), GC_malloc (sizeof (Equal_Info ) ) ); 
              a [0 ] = (Scheme_Object * ) eql2 ; 
              recur = FUNCCALL(SETUP_XfOrM87(_), scheme_make_prim_closure_w_arity (equal_recur , 1 , a , "equal?/recur" , 2 , 2 ) )


              ; 
              eql -> recur = recur ; 
            }
            (memcpy (eql2 , eql , sizeof (Equal_Info ) ) ) ; 

            a [0 ] = orig_obj1 ; 
            a [1 ] = orig_obj2 ; 
            a [2 ] = recur ; 

            if ((((Scheme_Vector * ) (procs1 ) ) -> size ) == 3 ) {
#             define XfOrM86_COUNT (0+XfOrM84_COUNT)
#             define SETUP_XfOrM86(x) SETUP_XfOrM84(x)

# 867 "bc/src/bool.c"
              procs1 = (((Scheme_Vector * ) (procs1 ) ) -> els ) [1 ] ; 
              a [3 ] = (((eql -> mode == 5 ) || (eql -> mode == 1 ) ) 
              ? scheme_false 
              : scheme_true ) ; 
              recur = FUNCCALL(SETUP_XfOrM86(_), scheme_do_eval (procs1 , 4 , a , 1 ) ); 
            }

# 872 "bc/src/bool.c"
            else {
#             define XfOrM85_COUNT (0+XfOrM84_COUNT)
#             define SETUP_XfOrM85(x) SETUP_XfOrM84(x)

# 874 "bc/src/bool.c"
              procs1 = (((Scheme_Vector * ) (procs1 ) ) -> els ) [1 ] ; 
              recur = FUNCCALL(SETUP_XfOrM85(_), scheme_do_eval (procs1 , 3 , a , 1 ) ); 
            }
            (
            memcpy (eql , eql2 , sizeof (Equal_Info ) ) ) ; 

            RET_VALUE_START ((! (((recur ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
          }

# 881 "bc/src/bool.c"
          else if (st1 != st2 ) {
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 883 "bc/src/bool.c"
          else if (((eql -> mode == 1 ) || (eql -> mode == 5 ) ) 
          && ! ((& st1 -> iso ) -> so . keyex & 0x1 ) ) {

            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 887 "bc/src/bool.c"
          else {


            Scheme_Object * insp ; 
            BLOCK_SETUP((PUSH(insp, 0+XfOrM75_COUNT)));
#           define XfOrM76_COUNT (1+XfOrM75_COUNT)
#           define SETUP_XfOrM76(x) SETUP(XfOrM76_COUNT)
            insp = NULLED_OUT ; 

# 891 "bc/src/bool.c"
            if (FUNCCALL(SETUP_XfOrM76(_), scheme_struct_is_transparent (obj1 ) ))
              insp = ((void * ) 0 ) ; 
            else {
#             define XfOrM81_COUNT (0+XfOrM76_COUNT)
#             define SETUP_XfOrM81(x) SETUP_XfOrM76(x)

# 894 "bc/src/bool.c"
              insp = (__funcarg63 = FUNCCALL(SETUP_XfOrM81(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg63 , MZCONFIG_INSPECTOR ) )) ; 
            }
            if (! insp || FUNCCALL(SETUP_XfOrM76(_), scheme_inspector_sees_part (obj1 , insp , - 2 ) )) {
#             define XfOrM77_COUNT (0+XfOrM76_COUNT)
#             define SETUP_XfOrM77(x) SETUP_XfOrM76(x)

# 1 "bc/src/mzeqchk.inc"
              {
#               define XfOrM79_COUNT (0+XfOrM77_COUNT)
#               define SETUP_XfOrM79(x) SETUP_XfOrM77(x)

# 1 "bc/src/mzeqchk.inc"
                if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#                 define XfOrM80_COUNT (0+XfOrM79_COUNT)
#                 define SETUP_XfOrM80(x) SETUP_XfOrM79(x)
                  FUNCCALL(SETUP_XfOrM80(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
                  ; 
                }
              }

# 1 "bc/src/mzeqchk.inc"
              ; 

              {

# 24 "bc/src/mzstkchk.h"
                uintptr_t _stk_pos ; 
#               define XfOrM78_COUNT (0+XfOrM77_COUNT)
#               define SETUP_XfOrM78(x) SETUP_XfOrM77(x)

# 26 "bc/src/mzstkchk.h"
                _stk_pos = (uintptr_t ) & _stk_pos ; 

                if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
                && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
                RET_VALUE_START (FUNCCALL(SETUP_XfOrM78(_), is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_END ; 
              }

# 898 "bc/src/bool.c"
              if (FUNCCALL(SETUP_XfOrM77(_), union_check (obj1 , obj2 , eql ) ))
                RET_VALUE_START (1 ) RET_VALUE_END ; 
              RET_VALUE_START (FUNCCALL(SETUP_XfOrM77(_), struct_equal (obj1 , orig_obj1 , obj2 , orig_obj2 , eql ) )) RET_VALUE_END ; 
            }

# 901 "bc/src/bool.c"
            else 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
      }
      case scheme_box_type : 
      {
#       define XfOrM71_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM71(x) SETUP_XfOrM55(x)

# 908 "bc/src/bool.c"
        {
#         define XfOrM72_COUNT (0+XfOrM71_COUNT)
#         define SETUP_XfOrM72(x) SETUP_XfOrM71(x)

# 908 "bc/src/bool.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM73_COUNT (0+XfOrM72_COUNT)
#           define SETUP_XfOrM73(x) SETUP_XfOrM72(x)
            FUNCCALL(SETUP_XfOrM73(_), scheme_out_of_fuel () )
# 908 "bc/src/bool.c"
            ; 
          }
        }

# 908 "bc/src/bool.c"
        ; 
        if (((eql -> mode == 1 ) || (eql -> mode == 5 ) ) 
        && (! (((Scheme_Inclhash_Object * ) (obj1 ) ) -> so . keyex & 0x1 ) || ! (((Scheme_Inclhash_Object * ) (obj2 ) ) -> so . keyex & 0x1 ) ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM71(_), union_check (obj1 , obj2 , eql ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        if ((obj1 ) == (orig_obj1 ) ) 
          obj1 = (((Scheme_Small_Object * ) (obj1 ) ) -> u . ptr_val ) ; 
        else 
        obj1 = FUNCCALL(SETUP_XfOrM71(_), scheme_unbox (orig_obj1 ) ); 
        if ((obj2 ) == (orig_obj2 ) ) 
          obj2 = (((Scheme_Small_Object * ) (obj2 ) ) -> u . ptr_val ) ; 
        else 
        obj2 = FUNCCALL(SETUP_XfOrM71(_), scheme_unbox (orig_obj2 ) ); 
        goto top ; 
      }

      case scheme_hash_table_type : 
      {
#       define XfOrM67_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM67(x) SETUP_XfOrM55(x)

# 1 "bc/src/mzeqchk.inc"
        {
#         define XfOrM69_COUNT (0+XfOrM67_COUNT)
#         define SETUP_XfOrM69(x) SETUP_XfOrM67(x)

# 1 "bc/src/mzeqchk.inc"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM70_COUNT (0+XfOrM69_COUNT)
#           define SETUP_XfOrM70(x) SETUP_XfOrM69(x)
            FUNCCALL(SETUP_XfOrM70(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
            ; 
          }
        }

# 1 "bc/src/mzeqchk.inc"
        ; 

        {

# 24 "bc/src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM68_COUNT (0+XfOrM67_COUNT)
#         define SETUP_XfOrM68(x) SETUP_XfOrM67(x)

# 26 "bc/src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
        }

# 928 "bc/src/bool.c"
        if ((eql -> mode == 1 ) || (eql -> mode == 5 ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM67(_), union_check (obj1 , obj2 , eql ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_hash_table_equal_rec ((Scheme_Hash_Table * ) obj1 , orig_obj1 , (Scheme_Hash_Table * ) obj2 , orig_obj2 , eql ) )) RET_VALUE_EMPTY_END 

        ; 
      }

      case scheme_hash_tree_type : 
      case scheme_eq_hash_tree_type : 
      case scheme_eqv_hash_tree_type : 
      case scheme_equal_always_hash_tree_type : 
      case scheme_hash_tree_indirection_type : 
      {
#       define XfOrM63_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM63(x) SETUP_XfOrM55(x)

# 1 "bc/src/mzeqchk.inc"
        {
#         define XfOrM65_COUNT (0+XfOrM63_COUNT)
#         define SETUP_XfOrM65(x) SETUP_XfOrM63(x)

# 1 "bc/src/mzeqchk.inc"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM66_COUNT (0+XfOrM65_COUNT)
#           define SETUP_XfOrM66(x) SETUP_XfOrM65(x)
            FUNCCALL(SETUP_XfOrM66(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
            ; 
          }
        }

# 1 "bc/src/mzeqchk.inc"
        ; 

        {

# 24 "bc/src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM64_COUNT (0+XfOrM63_COUNT)
#         define SETUP_XfOrM64(x) SETUP_XfOrM63(x)

# 26 "bc/src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
        }

# 944 "bc/src/bool.c"
        if (FUNCCALL(SETUP_XfOrM63(_), union_check (obj1 , obj2 , eql ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_hash_tree_equal_rec ((Scheme_Hash_Tree * ) obj1 , orig_obj1 , (Scheme_Hash_Tree * ) obj2 , orig_obj2 , eql ) )) RET_VALUE_EMPTY_END 

        ; 
      }

      case scheme_bucket_table_type : 
      {
#       define XfOrM59_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM59(x) SETUP_XfOrM55(x)

# 1 "bc/src/mzeqchk.inc"
        {
#         define XfOrM61_COUNT (0+XfOrM59_COUNT)
#         define SETUP_XfOrM61(x) SETUP_XfOrM59(x)

# 1 "bc/src/mzeqchk.inc"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM62_COUNT (0+XfOrM61_COUNT)
#           define SETUP_XfOrM62(x) SETUP_XfOrM61(x)
            FUNCCALL(SETUP_XfOrM62(_), scheme_out_of_fuel () )
# 1 "bc/src/mzeqchk.inc"
            ; 
          }
        }

# 1 "bc/src/mzeqchk.inc"
        ; 

        {

# 24 "bc/src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM60_COUNT (0+XfOrM59_COUNT)
#         define SETUP_XfOrM60(x) SETUP_XfOrM59(x)

# 26 "bc/src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 5 "bc/src/mzeqchk.inc"
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_equal_overflow (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
        }

# 954 "bc/src/bool.c"
        if ((eql -> mode == 1 ) || (eql -> mode == 5 ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        if (FUNCCALL(SETUP_XfOrM59(_), union_check (obj1 , obj2 , eql ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_bucket_table_equal_rec ((Scheme_Bucket_Table * ) obj1 , orig_obj1 , (Scheme_Bucket_Table * ) obj2 , orig_obj2 , eql ) )) RET_VALUE_EMPTY_END 

        ; 
      }
      default : 
      if (((eql -> mode == 0 ) || (eql -> mode == 5 ) ) 
      && ((t1 == scheme_chaperone_type ) || (t1 == scheme_proc_chaperone_type ) ) ) {

        obj1 = ((Scheme_Chaperone * ) obj1 ) -> val ; 
        obj2 = ((Scheme_Chaperone * ) obj2 ) -> val ; 
        goto top_after_next ; 
      }

# 969 "bc/src/bool.c"
      else {
        Scheme_Equal_Proc eqlp = scheme_type_equals [t1 ] ; 
#       define XfOrM56_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM56(x) SETUP_XfOrM55(x)

# 971 "bc/src/bool.c"
        if (eqlp ) {
#         define XfOrM57_COUNT (0+XfOrM56_COUNT)
#         define SETUP_XfOrM57(x) SETUP_XfOrM56(x)

# 972 "bc/src/bool.c"
          if (FUNCCALL(SETUP_XfOrM57(_), union_check (obj1 , obj2 , eql ) ))
            RET_VALUE_START (1 ) RET_VALUE_END ; 
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(eqlp (obj1 , obj2 , eql ) )) RET_VALUE_EMPTY_END ; 
        }

# 975 "bc/src/bool.c"
        else 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 982 "bc/src/bool.c"
static int vector_equal (Scheme_Object * vec1 , Scheme_Object * orig_vec1 , 
Scheme_Object * vec2 , Scheme_Object * orig_vec2 , 
Equal_Info * eql ) 
{
  intptr_t i , len ; 
  Scheme_Object * v1 , * v2 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(vec1, 0), PUSH(v1, 1), PUSH(v2, 2), PUSH(eql, 3), PUSH(orig_vec2, 4), PUSH(vec2, 5), PUSH(orig_vec1, 6)));
# define XfOrM134_COUNT (7)
# define SETUP_XfOrM134(x) SETUP(XfOrM134_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v1 = NULLED_OUT ; 
  v2 = NULLED_OUT ; 

# 989 "bc/src/bool.c"
  len = (((Scheme_Vector * ) (vec1 ) ) -> size ) ; 
  if (len != (((Scheme_Vector * ) (vec2 ) ) -> size ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 

  {
#   define XfOrM137_COUNT (0+XfOrM134_COUNT)
#   define SETUP_XfOrM137(x) SETUP_XfOrM134(x)

# 993 "bc/src/bool.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM138_COUNT (0+XfOrM137_COUNT)
#     define SETUP_XfOrM138(x) SETUP_XfOrM137(x)
      FUNCCALL(SETUP_XfOrM138(_), scheme_out_of_fuel () )
# 993 "bc/src/bool.c"
      ; 
    }
  }

# 993 "bc/src/bool.c"
  ; 

  for (i = 0 ; i < len ; i ++ ) {
#   define XfOrM136_COUNT (0+XfOrM134_COUNT)
#   define SETUP_XfOrM136(x) SETUP_XfOrM134(x)

# 996 "bc/src/bool.c"
    if ((vec1 ) == (orig_vec1 ) ) 
      v1 = (((Scheme_Vector * ) (vec1 ) ) -> els ) [i ] ; 
    else 
    v1 = FUNCCALL(SETUP_XfOrM136(_), scheme_chaperone_vector_ref (orig_vec1 , i ) ); 
    if ((vec2 ) == (orig_vec2 ) ) 
      v2 = (((Scheme_Vector * ) (vec2 ) ) -> els ) [i ] ; 
    else 
    v2 = FUNCCALL(SETUP_XfOrM136(_), scheme_chaperone_vector_ref (orig_vec2 , i ) ); 

    if (! FUNCCALL(SETUP_XfOrM136(_), is_equal (v1 , v2 , eql ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1012 "bc/src/bool.c"
int struct_equal (Scheme_Object * s1 , Scheme_Object * orig_s1 , 
Scheme_Object * s2 , Scheme_Object * orig_s2 , 
Equal_Info * eql ) 
{
  Scheme_Object * v1 , * v2 ; 
  int i ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(eql, 0), PUSH(v1, 1), PUSH(v2, 2), PUSH(orig_s2, 3), PUSH(orig_s1, 4), PUSH(s1, 5), PUSH(s2, 6)));
# define XfOrM139_COUNT (7)
# define SETUP_XfOrM139(x) SETUP(XfOrM139_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v1 = NULLED_OUT ; 
  v2 = NULLED_OUT ; 

# 1019 "bc/src/bool.c"
  for (i = ((((Scheme_Structure * ) ((Scheme_Structure * ) s1 ) ) -> stype ) -> num_slots ) ; i -- ; ) {
#   define XfOrM141_COUNT (0+XfOrM139_COUNT)
#   define SETUP_XfOrM141(x) SETUP_XfOrM139(x)

# 1020 "bc/src/bool.c"
    if ((s1 ) == (orig_s1 ) ) 
      v1 = ((Scheme_Structure * ) s1 ) -> slots [i ] ; 
    else 
    v1 = FUNCCALL(SETUP_XfOrM141(_), scheme_struct_ref (orig_s1 , i ) ); 
    if ((s2 ) == (orig_s2 ) ) 
      v2 = ((Scheme_Structure * ) s2 ) -> slots [i ] ; 
    else 
    v2 = FUNCCALL(SETUP_XfOrM141(_), scheme_struct_ref (orig_s2 , i ) ); 

    if (! FUNCCALL(SETUP_XfOrM141(_), is_equal (v1 , v2 , eql ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1036 "bc/src/bool.c"
int scheme_recur_equal (Scheme_Object * obj1 , Scheme_Object * obj2 , void * cycle_info ) 
{
  /* No conversion */

# 1038 "bc/src/bool.c"
  return is_equal (obj1 , obj2 , (Equal_Info * ) cycle_info ) ; 
}


Scheme_Object * scheme_make_true (void ) 
{
  /* No conversion */

# 1044 "bc/src/bool.c"
  return scheme_true ; 
}

Scheme_Object * scheme_make_false (void ) 
{
  /* No conversion */

# 1049 "bc/src/bool.c"
  return scheme_false ; 
}

static Scheme_Object * chaperone_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1054 "bc/src/bool.c"
  return (((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
  && ! ((& (((Scheme_Chaperone * ) argv [0 ] ) ) -> iso ) -> so . keyex & 0x1 ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * impersonator_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1062 "bc/src/bool.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? scheme_true : scheme_false ) ; 
}


static Scheme_Object * procedure_impersonator_star_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1068 "bc/src/bool.c"
  Scheme_Vector * redirects ; 
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    redirects = (Scheme_Vector * ) (((Scheme_Chaperone * ) (argv [0 ] ) ) -> redirects ) ; 
    if (((((Scheme_Vector * ) (redirects ) ) -> size ) % 2 == 1 ) 
    && (((((Scheme_Vector * ) (redirects ) ) -> size ) == 5 ) 
    || (((Scheme_Inclhash_Object * ) (redirects ) ) -> so . keyex & 0x1 ) ) ) {
      return scheme_true ; 
    }
  }
  return scheme_false ; 
}

static Scheme_Object * chaperone_of (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1082 "bc/src/bool.c"
  return (scheme_chaperone_of (argv [0 ] , argv [1 ] ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * impersonator_of (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1087 "bc/src/bool.c"
  return (scheme_impersonator_of (argv [0 ] , argv [1 ] ) ? scheme_true : scheme_false ) ; 
}

int scheme_chaperone_of (Scheme_Object * obj1 , Scheme_Object * obj2 ) 
{
  Equal_Info eql ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(eql.ht, 0), PUSH(eql.recur, 1), PUSH(eql.next, 2), PUSH(eql.next_next, 3), PUSH(eql.insp, 4)));
# define XfOrM152_COUNT (5)
# define SETUP_XfOrM152(x) SETUP(XfOrM152_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql.next = NULLED_OUT ; 
  eql.next_next = NULLED_OUT ; 
  eql.insp = NULLED_OUT ; 
  (
# 1094 "bc/src/bool.c"
  init_equal_info (& eql ) ) ; 
  eql . mode = 1 ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM152(_), is_equal (obj1 , obj2 , & eql ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1100 "bc/src/bool.c"
int scheme_impersonator_of (Scheme_Object * obj1 , Scheme_Object * obj2 ) 
{
  Equal_Info eql ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(eql.ht, 0), PUSH(eql.recur, 1), PUSH(eql.next, 2), PUSH(eql.next_next, 3), PUSH(eql.insp, 4)));
# define XfOrM153_COUNT (5)
# define SETUP_XfOrM153(x) SETUP(XfOrM153_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  eql.ht = NULLED_OUT ; 
  eql.recur = NULLED_OUT ; 
  eql.next = NULLED_OUT ; 
  eql.next_next = NULLED_OUT ; 
  eql.insp = NULLED_OUT ; 
  (
# 1104 "bc/src/bool.c"
  init_equal_info (& eql ) ) ; 
  eql . mode = 3 ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM153(_), is_equal (obj1 , obj2 , & eql ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1110 "bc/src/bool.c"
Scheme_Object * scheme_apply_impersonator_of (int mode , Scheme_Object * procs , Scheme_Object * obj ) 
{
  Scheme_Object * a [1 ] , * v , * oprocs ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSHARRAY(a, 1, 1), PUSH(procs, 4), PUSH(obj, 5), PUSH(oprocs, 6)));
# define XfOrM154_COUNT (7)
# define SETUP_XfOrM154(x) SETUP(XfOrM154_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  v = NULLED_OUT ; 
  oprocs = NULLED_OUT ; 

# 1114 "bc/src/bool.c"
  a [0 ] = obj ; 
  v = FUNCCALL(SETUP_XfOrM154(_), scheme_do_eval ((((Scheme_Simple_Object * ) (procs ) ) -> u . pair_val . cdr ) , 1 , a , 1 ) ); 

  if (((v ) ) == (scheme_false ) ) 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  oprocs = (scheme_struct_type_property_ref (scheme_impersonator_of_property , v ) ) ; 
  if (! oprocs || ! (((((Scheme_Simple_Object * ) (oprocs ) ) -> u . pair_val . car ) ) == ((((Scheme_Simple_Object * ) (procs ) ) -> u . pair_val . car ) ) ) )
    FUNCCALL(SETUP_XfOrM154(_), scheme_contract_error (((mode == 1 ) ? "chaperone-of?" : ((mode == 3 ) ? "impersonator-of?" : ((mode == 5 ) ? "equal-always?" : "equal?" ) ) ) , "impersonator-of property procedure returned a value with a different prop:impersonator-of source" , "original value" , 1 , obj , "returned value" , 1 , v , ((void * ) 0 ) ) )
# 1132 "bc/src/bool.c"
  ; 

  procs = (scheme_struct_type_property_ref (scheme_equal_property , obj ) ) ; 
  oprocs = (scheme_struct_type_property_ref (scheme_equal_property , v ) ) ; 
  if (procs || oprocs )
    if (! procs || ! oprocs || ! (((((Scheme_Vector * ) (oprocs ) ) -> els ) [0 ] ) == ((((Scheme_Vector * ) (procs ) ) -> els ) [0 ] ) ) )
    FUNCCALL(SETUP_XfOrM154(_), scheme_contract_error (((mode == 1 ) ? "chaperone-of?" : ((mode == 3 ) ? "impersonator-of?" : ((mode == 5 ) ? "equal-always?" : "equal?" ) ) ) , "impersonator-of property procedure returned a value with a different prop:equal+hash source" , "original value" , 1 , obj , "returned value" , 1 , v , ((void * ) 0 ) ) )
# 1149 "bc/src/bool.c"
  ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
