#include "precomp.h"

# 34 "bc/rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "rktio/rktio.h"
typedef struct rktio_t rktio_t ; 



__xform_nongcing__ extern rktio_t * rktio_init (void ) ; 






__xform_nongcing__ extern void rktio_destroy (rktio_t * rktio ) ; 








typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 351 "rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "rktio/rktio.h"
rktio_process_result_t ; 

# 646 "rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "rktio/rktio.h"
rktio_status_t ; 

# 669 "rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "rktio/rktio.h"
rktio_identity_t ; 

# 925 "rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "rktio/rktio.h"
rktio_date_t ; 

# 1109 "rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 

# 1378 "rktio/rktio.h"
enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 




enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

# 14 "bc/src/env.c"
int scheme_allow_set_undefined ; 
void scheme_set_allow_set_undefined (int v ) {
  /* No conversion */

# 15 "bc/src/env.c"
  scheme_allow_set_undefined = v ; 
}

# 16 "bc/src/env.c"
int scheme_get_allow_set_undefined () {
  /* No conversion */

# 16 "bc/src/env.c"
  return scheme_allow_set_undefined ; 
}

int scheme_keep_builtin_context ; 



static Scheme_Object * kernel_symbol ; 

Scheme_Startup_Env * scheme_startup_env ; 

static int builtin_ref_counter ; 
static int builtin_unsafe_start ; 

; 

; 
; 


static void init_startup_env (void ) ; 
static Scheme_Startup_Env * make_startup_env () ; 

static void init_unsafe (Scheme_Startup_Env * env ) ; 
static void init_flfxnum (Scheme_Startup_Env * env ) ; 
static void init_extfl (Scheme_Startup_Env * env ) ; 
static void init_futures (Scheme_Startup_Env * env ) ; 
static void init_foreign (Scheme_Startup_Env * env ) ; 
static void init_terminal (Scheme_Startup_Env * env ) ; 

static void skip_certain_things (Scheme_Object * o , Scheme_Close_Custodian_Client * f , void * data ) ; 

static Scheme_Env * place_instance_init (void * stack_base , int initial_main_os_thread ) ; 


static void register_traversers (void ) ; 






Scheme_Object * scheme_get_startup_export (const char * s ) 
{
  Scheme_Object * sym ; 
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sym, 0), PUSH(b, 1)));
# define XfOrM3_COUNT (2)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sym = NULLED_OUT ; 
  b = NULLED_OUT ; 

# 63 "bc/src/env.c"
  sym = FUNCCALL(SETUP_XfOrM3(_), scheme_intern_symbol (s ) ); 
  b = FUNCCALL_AGAIN(scheme_instance_variable_bucket_or_null (sym , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_startup_instance_ ) ) ); 

  if (b )
    RET_VALUE_START ((Scheme_Object * ) b -> val ) RET_VALUE_END ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 72 "bc/src/env.c"
static void boot_module_resolver () 
{
  Scheme_Object * boot ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(boot, 0)));
# define XfOrM4_COUNT (1)
# define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  boot = NULLED_OUT ; 

# 75 "bc/src/env.c"
  boot = FUNCCALL(SETUP_XfOrM4(_), scheme_get_startup_export ("boot" ) ); 
  FUNCCALL_EMPTY(scheme_apply (boot , 0 , ((void * ) 0 ) ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 79 "bc/src/env.c"
void scheme_seal_parameters () 
{
  Scheme_Object * seal ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(seal, 0)));
# define XfOrM5_COUNT (1)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  seal = NULLED_OUT ; 

# 82 "bc/src/env.c"
  seal = FUNCCALL(SETUP_XfOrM5(_), scheme_get_startup_export ("seal" ) ); 
  (void ) FUNCCALL_EMPTY(scheme_apply_multi (seal , 0 , ((void * ) 0 ) ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 86 "bc/src/env.c"
void os_platform_init () {
  /* No conversion */
}









Scheme_Env * scheme_restart_instance () 
{
  Scheme_Env * env ; 
  void * stack_base ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Env * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(stack_base, 1)));
# define XfOrM7_COUNT (2)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  env = NULLED_OUT ; 
  stack_base = NULLED_OUT ; 

# 102 "bc/src/env.c"
  stack_base = (void * ) FUNCCALL(SETUP_XfOrM7(_), scheme_get_current_os_thread_stack_base () ); 
  FUNCCALL(SETUP_XfOrM7(_), scheme_do_close_managed (((void * ) 0 ) , skip_certain_things ) )

  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM7(_), scheme_reset_finalizations () )
  ; 
  FUNCCALL_AGAIN(scheme_init_stack_check () ); 
  FUNCCALL_AGAIN(scheme_reset_overflow () )


  ; 
  FUNCCALL_AGAIN(scheme_make_thread (stack_base ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_error_escape_proc (((void * ) 0 ) ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_namespace_to_env_ ) = FUNCCALL(SETUP_XfOrM7(_), scheme_make_bucket_table (5 , SCHEME_hash_weak_ptr ) ); 
  env = FUNCCALL(SETUP_XfOrM7(_), scheme_make_empty_env () ); 
  FUNCCALL_AGAIN(scheme_init_port_config () )
  ; 
  FUNCCALL_AGAIN(scheme_init_port_fun_config () ); 
  FUNCCALL_AGAIN(scheme_init_error_config () ); 
  FUNCCALL_AGAIN(scheme_init_logger_config () ); 
  FUNCCALL_AGAIN(scheme_init_exn_config () ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_startup_instance_ ) = (__funcarg58 = FUNCCALL(SETUP_XfOrM7(_), scheme_intern_symbol ("startup" ) ), FUNCCALL_AGAIN(scheme_make_instance (__funcarg58 , scheme_false ) )) ; 
  FUNCCALL(SETUP_XfOrM7(_), scheme_init_startup_instance (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_startup_instance_ ) ) ); 
  FUNCCALL_AGAIN(boot_module_resolver () )
  ; 
  FUNCCALL_AGAIN(scheme_init_resolver_config () )
  ; 

  RET_VALUE_START (env ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 137 "bc/src/env.c"
Scheme_Env * scheme_basic_env () 
{
  Scheme_Env * env ; 
  void * stack_base ; 
  DECL_RET_SAVE (Scheme_Env * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(stack_base, 1)));
# define XfOrM8_COUNT (2)
# define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  env = NULLED_OUT ; 
  stack_base = NULLED_OUT ; 

# 142 "bc/src/env.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ) {
#   define XfOrM10_COUNT (0+XfOrM8_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM8(x)

# 143 "bc/src/env.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_restart_instance () )) RET_VALUE_EMPTY_END ; 
  }

  stack_base = (void * ) FUNCCALL(SETUP_XfOrM8(_), scheme_get_current_os_thread_stack_base () ); 
  FUNCCALL(SETUP_XfOrM8(_), os_platform_init () )
  ; 









  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) = 1 ; 
  FUNCCALL(SETUP_XfOrM8(_), scheme_init_finalization () )
  ; 
  FUNCCALL_AGAIN(scheme_init_hash_tree () )
  ; 
  FUNCCALL_AGAIN(scheme_init_portable_case () ); 
  FUNCCALL_AGAIN(scheme_init_compenv () ); 
  FUNCCALL_AGAIN(scheme_init_letrec_check () ); 
  FUNCCALL_AGAIN(scheme_init_optimize () ); 
  FUNCCALL_AGAIN(scheme_init_resolve () ); 
  FUNCCALL_AGAIN(scheme_init_sfs () ); 
  FUNCCALL_AGAIN(scheme_init_validate () ); 
  FUNCCALL_AGAIN(scheme_init_process_globals () )



  ; 
  FUNCCALL_AGAIN(scheme_init_true_false () )
  ; 
  FUNCCALL_AGAIN(register_traversers () )


  ; 
  FUNCCALL_AGAIN(scheme_init_hash_key_procs () ); 
  FUNCCALL_AGAIN(scheme_init_getenv () )

  ; 
  FUNCCALL_AGAIN(scheme_init_symbol_table () )
# 196 "bc/src/env.c"
  ; 
  FUNCCALL_AGAIN(scheme_init_type () ); 
  FUNCCALL_AGAIN(scheme_init_custodian_extractors () ); 
  FUNCCALL_AGAIN(scheme_init_foreign_globals () )
  ; 
  FUNCCALL_AGAIN(init_startup_env () )
  ; 
  FUNCCALL_AGAIN(scheme_init_logging_once () )
  ; 
  FUNCCALL_AGAIN(scheme_init_compenv_symbol () )
  ; 
  FUNCCALL_AGAIN(scheme_init_param_symbol () ); 
  FUNCCALL_AGAIN(GC_switch_out_master_gc () )

  ; 
  FUNCCALL_AGAIN(scheme_spawn_master_place () )
  ; 




  env = FUNCCALL_AGAIN(place_instance_init (stack_base , 1 ) ); 


  {
    void * signal_handle ; 
    BLOCK_SETUP((PUSH(signal_handle, 0+XfOrM8_COUNT)));
#   define XfOrM9_COUNT (1+XfOrM8_COUNT)
#   define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
    signal_handle = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM9(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ) ) )
# 222 "bc/src/env.c"
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) = (Scheme_Place_Object * ) FUNCCALL(SETUP_XfOrM9(_), scheme_make_place_object () ); 
    signal_handle = FUNCCALL(SETUP_XfOrM9(_), scheme_get_signal_handle () ); 
    FUNCCALL_AGAIN(GC_set_put_external_event_fd (signal_handle ) ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) -> signal_handle = signal_handle ; 
  }


  RET_VALUE_START (env ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 233 "bc/src/env.c"
static void init_startup_env (void ) 
{
  Scheme_Startup_Env * env ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM11_COUNT (1)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  env = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM11(_), scheme_register_static ((void * ) & kernel_symbol , sizeof (kernel_symbol ) ) )
# 240 "bc/src/env.c"
  ; 
  kernel_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("#%kernel" ) ); 

  env = FUNCCALL_AGAIN(make_startup_env () ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_startup_env , sizeof (scheme_startup_env ) ) )
  ; 
  scheme_startup_env = env ; 

  scheme_defining_primitives = 1 ; 
  builtin_ref_counter = 0 ; 
  FUNCCALL(SETUP_XfOrM11(_), scheme_init_symbol_type (env ) )
# 264 "bc/src/env.c"
  ; 
  FUNCCALL_AGAIN(scheme_init_realm () ); 
  FUNCCALL_AGAIN(scheme_init_fun (env ) ); 
  FUNCCALL_AGAIN(scheme_init_symbol (env ) ); 
  FUNCCALL_AGAIN(scheme_init_list (env ) ); 
  FUNCCALL_AGAIN(scheme_init_number (env ) ); 
  FUNCCALL_AGAIN(scheme_init_numarith (env ) ); 
  FUNCCALL_AGAIN(scheme_init_numcomp (env ) ); 
  FUNCCALL_AGAIN(scheme_init_numstr (env ) ); 
  FUNCCALL_AGAIN(scheme_init_bignum () ); 
  FUNCCALL_AGAIN(scheme_init_char_constants () ); 
  FUNCCALL_AGAIN(scheme_init_stx (env ) ); 
  FUNCCALL_AGAIN(scheme_init_port (env ) ); 
  FUNCCALL_AGAIN(scheme_init_port_fun (env ) ); 
  FUNCCALL_AGAIN(scheme_init_string (env ) ); 
  FUNCCALL_AGAIN(scheme_init_vector (env ) ); 
  FUNCCALL_AGAIN(scheme_init_char (env ) ); 
  FUNCCALL_AGAIN(scheme_init_bool (env ) ); 
  FUNCCALL_AGAIN(scheme_init_compile (env ) ); 
  FUNCCALL_AGAIN(scheme_init_eval (env ) ); 
  FUNCCALL_AGAIN(scheme_init_struct (env ) ); 
  FUNCCALL_AGAIN(scheme_init_error (env ) ); 
  FUNCCALL_AGAIN(scheme_init_exn (env ) ); 
  FUNCCALL_AGAIN(scheme_init_thread (env ) ); 
  FUNCCALL_AGAIN(scheme_init_port_wait () ); 
  FUNCCALL_AGAIN(scheme_init_inspector () ); 
  FUNCCALL_AGAIN(scheme_init_logger_wait () ); 
  FUNCCALL_AGAIN(scheme_init_struct_wait () ); 
  FUNCCALL_AGAIN(scheme_init_reduced_proc_struct (env ) ); 
  FUNCCALL_AGAIN(scheme_init_sema (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_read (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_print (env ) ); 
  FUNCCALL_AGAIN(scheme_init_file (env ) ); 
  FUNCCALL_AGAIN(scheme_init_dynamic_extension (env ) ); 
  FUNCCALL_AGAIN(scheme_regexp_initialize (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_parameterization () )
  ; 
  FUNCCALL_AGAIN(scheme_init_futures_once () ); 
  FUNCCALL_AGAIN(scheme_init_places_once () ); 
  FUNCCALL_AGAIN(scheme_init_linklet (env ) ); 
  FUNCCALL_AGAIN(scheme_init_network (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_paramz (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_place (env ) ); 
  FUNCCALL_AGAIN(scheme_register_network_evts () )
  ; 

  ; 
  FUNCCALL_AGAIN(init_flfxnum (env ) )
  ; 
  FUNCCALL_AGAIN(init_extfl (env ) ); 
  FUNCCALL_AGAIN(init_futures (env ) ); 
  FUNCCALL_AGAIN(init_terminal (env ) ); 

  builtin_unsafe_start = builtin_ref_counter ; 
  FUNCCALL(SETUP_XfOrM11(_), scheme_init_unsafe_linklet (env ) ); 
  FUNCCALL_AGAIN(init_unsafe (env ) ); 
  FUNCCALL_EMPTY(init_foreign (env ) ); 


  if (builtin_ref_counter != 1575 ) {
#   define XfOrM12_COUNT (0+XfOrM11_COUNT)
#   define SETUP_XfOrM12(x) SETUP_XfOrM11(x)
    FUNCCALL_EMPTY(fprintf (stderr , "Primitive count %d doesn't match expected count %d\n" "Update the count in src/schminc.h and bump the version in ../version/racket_version.h\n" , builtin_ref_counter , 1575 ) )
    ; 
    FUNCCALL_EMPTY(abort () ); 
  }
  FUNCCALL_EMPTY(scheme_init_variable_references_constants () )

  ; 
  FUNCCALL_EMPTY(scheme_init_longdouble_fixup () )
  ; 
  FUNCCALL_EMPTY(scheme_init_startup () )
  ; 

  scheme_defining_primitives = 0 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 346 "bc/src/env.c"
static void init_unsafe (Scheme_Startup_Env * env ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM13_COUNT (1)
# define SETUP_XfOrM13(x) SETUP(XfOrM13_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM13(_), scheme_switch_prim_instance (env , "#%unsafe" ) )
# 348 "bc/src/env.c"
  ; 
  FUNCCALL(SETUP_XfOrM13(_), scheme_init_unsafe_number (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_unsafe_numarith (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_numcomp (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_char (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_list (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_hash (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_vector (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_fun (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_thread (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_port (env ) ); 
  FUNCCALL_AGAIN(scheme_init_unsafe_error (env ) ); 
  FUNCCALL_AGAIN(scheme_init_extfl_unsafe_number (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_extfl_unsafe_numarith (env ) ); 
  FUNCCALL_AGAIN(scheme_init_extfl_unsafe_numcomp (env ) ); 
  FUNCCALL_EMPTY(scheme_restore_prim_instance (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 369 "bc/src/env.c"
static void init_flfxnum (Scheme_Startup_Env * env ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM14_COUNT (1)
# define SETUP_XfOrM14(x) SETUP(XfOrM14_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM14(_), scheme_switch_prim_instance (env , "#%flfxnum" ) )
# 371 "bc/src/env.c"
  ; 
  FUNCCALL(SETUP_XfOrM14(_), scheme_init_flfxnum_number (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_flfxnum_numarith (env ) ); 
  FUNCCALL_AGAIN(scheme_init_flfxnum_numcomp (env ) ); 
  FUNCCALL_EMPTY(scheme_restore_prim_instance (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 380 "bc/src/env.c"
static void init_extfl (Scheme_Startup_Env * env ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM15_COUNT (1)
# define SETUP_XfOrM15(x) SETUP(XfOrM15_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM15(_), scheme_switch_prim_instance (env , "#%extfl" ) )
# 382 "bc/src/env.c"
  ; 
  FUNCCALL(SETUP_XfOrM15(_), scheme_init_extfl_number (env ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_extfl_numarith (env ) ); 
  FUNCCALL_AGAIN(scheme_init_extfl_numcomp (env ) ); 
  FUNCCALL_AGAIN(scheme_init_extfl_numstr (env ) ); 
  FUNCCALL_EMPTY(scheme_restore_prim_instance (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 392 "bc/src/env.c"
static void init_futures (Scheme_Startup_Env * env ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM16_COUNT (1)
# define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM16(_), scheme_switch_prim_instance (env , "#%futures" ) )
# 394 "bc/src/env.c"
  ; 
  FUNCCALL(SETUP_XfOrM16(_), scheme_init_futures (env ) )
  ; 
  FUNCCALL_EMPTY(scheme_restore_prim_instance (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 401 "bc/src/env.c"
static void init_foreign (Scheme_Startup_Env * env ) 
{
  /* No conversion */

# 403 "bc/src/env.c"
  scheme_init_foreign (env ) ; 
}

static void init_terminal (Scheme_Startup_Env * env ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM18_COUNT (1)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM18(_), scheme_switch_prim_instance (env , "#%terminal" ) )
# 408 "bc/src/env.c"
  ; 
  FUNCCALL(SETUP_XfOrM18(_), scheme_init_terminal (env ) )
  ; 
  FUNCCALL_EMPTY(scheme_restore_prim_instance (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Env * place_instance_init (void * stack_base , int initial_main_os_thread ) 
{
  Scheme_Env * env ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Env * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(stack_base, 1)));
# define XfOrM19_COUNT (2)
# define SETUP_XfOrM19(x) SETUP(XfOrM19_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  env = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM19(_), scheme_set_current_os_thread_stack_base (stack_base ) )
# 426 "bc/src/env.c"
  ; 
  FUNCCALL_AGAIN(scheme_init_stack_check () )




  ; 
  FUNCCALL_AGAIN(scheme_init_overflow () ); 
  FUNCCALL_AGAIN(scheme_init_thread_lwc () )
  ; 
  FUNCCALL_AGAIN(scheme_init_compenv_places () )
  ; 
  FUNCCALL_AGAIN(scheme_init_file_places () )








  ; 
  FUNCCALL_AGAIN(scheme_make_thread (stack_base ) )
  ; 
  FUNCCALL_AGAIN(scheme_init_place_local_symbol_table () )


  ; 


  {
    Scheme_Object * sym ; 
    BLOCK_SETUP((PUSH(sym, 0+XfOrM19_COUNT)));
#   define XfOrM20_COUNT (1+XfOrM19_COUNT)
#   define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
    sym = NULLED_OUT ; 

# 458 "bc/src/env.c"
    sym = FUNCCALL(SETUP_XfOrM20(_), scheme_intern_symbol ("mzscheme" ) ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> name = sym ; 
  }
  FUNCCALL(SETUP_XfOrM19(_), scheme_init_stx_places (initial_main_os_thread ) )
  ; 
  FUNCCALL(SETUP_XfOrM19(_), scheme_init_fun_places () )







  ; 
  FUNCCALL_AGAIN(scheme_init_port_places () ); 
  FUNCCALL_AGAIN(scheme_init_error_escape_proc (((void * ) 0 ) ) ); 
  FUNCCALL_AGAIN(scheme_init_print_buffers_places () ); 
  FUNCCALL_AGAIN(scheme_init_thread_places () ); 
  FUNCCALL_AGAIN(scheme_init_fd_semaphores () ); 
  FUNCCALL_AGAIN(scheme_init_string_places () ); 
  FUNCCALL_AGAIN(scheme_init_logger () ); 
  FUNCCALL_AGAIN(scheme_init_eval_places () ); 
  FUNCCALL_AGAIN(scheme_init_linklet_places () ); 
  FUNCCALL_AGAIN(scheme_init_compile_places () ); 
  FUNCCALL_AGAIN(scheme_init_regexp_places () ); 
  FUNCCALL_AGAIN(scheme_init_sema_places () ); 
  FUNCCALL_AGAIN(scheme_init_gmp_places () ); 
  FUNCCALL_AGAIN(scheme_init_foreign_places () )
  ; 
  FUNCCALL_AGAIN(scheme_init_port_config () )


  ; 
  FUNCCALL_AGAIN(scheme_init_port_fun_config () ); 
  FUNCCALL_AGAIN(scheme_init_error_config () ); 
  FUNCCALL_AGAIN(scheme_init_logger_config () ); 
  FUNCCALL_AGAIN(scheme_init_exn_config () ); 
  FUNCCALL_AGAIN(scheme_init_error_config () ); 
  FUNCCALL_AGAIN(scheme_init_place_per_place () ); 
  FUNCCALL_AGAIN(scheme_init_futures_per_place () )



  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> literal_string_table_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> literal_string_table_ ) ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> literal_number_table_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> literal_number_table_ ) ) ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> literal_string_table_ ) = FUNCCALL(SETUP_XfOrM19(_), scheme_make_weak_equal_table () ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> literal_number_table_ ) = FUNCCALL(SETUP_XfOrM19(_), scheme_make_weak_eqv_table () ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) = 1 ; 
  FUNCCALL(SETUP_XfOrM19(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_startup_instance_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_startup_instance_ ) ) ) )




  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_startup_instance_ ) = (__funcarg59 = FUNCCALL(SETUP_XfOrM19(_), scheme_intern_symbol ("startup" ) ), FUNCCALL_AGAIN(scheme_make_instance (__funcarg59 , scheme_false ) )) ; 
  FUNCCALL(SETUP_XfOrM19(_), scheme_init_startup_instance (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_startup_instance_ ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_namespace_to_env_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_namespace_to_env_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_namespace_to_env_ ) = FUNCCALL(SETUP_XfOrM19(_), scheme_make_bucket_table (5 , SCHEME_hash_weak_ptr ) ); 
  env = FUNCCALL(SETUP_XfOrM19(_), scheme_make_empty_env () ); 
  FUNCCALL_AGAIN(boot_module_resolver () )
  ; 
  FUNCCALL_AGAIN(scheme_init_resolver_config () )
  ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) = 0 ; 
  FUNCCALL(SETUP_XfOrM19(_), scheme_performance_record_end ("boot" , ((void * ) 0 ) ) )
  ; 

  -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ; 
  FUNCCALL(SETUP_XfOrM19(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) ) ) )





  ; 


  RET_VALUE_START (env ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 544 "bc/src/env.c"
Scheme_Env * scheme_place_instance_init (void * stack_base , struct NewGC * parent_gc , intptr_t memory_limit ) 
{
  Scheme_Env * env ; 

  int * signal_fd ; 
  DECL_RET_SAVE (Scheme_Env * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(stack_base, 1), PUSH(signal_fd, 2)));
# define XfOrM21_COUNT (3)
# define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  env = NULLED_OUT ; 
  signal_fd = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM21(_), GC_construct_child_gc (parent_gc , memory_limit ) )
# 549 "bc/src/env.c"
  ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) = (rktio_init () ) ; 
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) )

# 552 "bc/src/env.c"
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  env = FUNCCALL(SETUP_XfOrM21(_), place_instance_init (stack_base , 0 ) ); 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) {
#   define XfOrM22_COUNT (0+XfOrM21_COUNT)
#   define SETUP_XfOrM22(x) SETUP_XfOrM21(x)

# 556 "bc/src/env.c"
    signal_fd = FUNCCALL(SETUP_XfOrM22(_), scheme_get_signal_handle () ); 
    FUNCCALL(SETUP_XfOrM22(_), GC_set_put_external_event_fd (signal_fd ) ); 
  }
  FUNCCALL(SETUP_XfOrM21(_), scheme_set_can_break (1 ) )
  ; 
  RET_VALUE_START (env ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 565 "bc/src/env.c"
static void force_more_closed (Scheme_Object * o , Scheme_Close_Custodian_Client * f , void * data ) 
{
  /* No conversion */
  if (! f || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    return ; 

  f (o , data ) ; 
}

static void force_more_closed_after (Scheme_Object * o , Scheme_Close_Custodian_Client * f , void * data ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(data, 0), PUSH(f, 1), PUSH(o, 2)));
# define XfOrM24_COUNT (3)
# define SETUP_XfOrM24(x) SETUP(XfOrM24_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM24(_), scheme_run_atexit_closers (o , f , data ) )
# 576 "bc/src/env.c"
  ; 
  FUNCCALL_EMPTY(force_more_closed (o , f , data ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 580 "bc/src/env.c"
void scheme_place_instance_destroy (int force ) 
{
  /* No conversion */

  if (force )
    scheme_run_atexit_closers_on_all (force_more_closed ) ; 
  else 
  scheme_run_atexit_closers_on_all (force_more_closed_after ) ; 

  scheme_release_fd_semaphores () ; 

  scheme_release_file_descriptor () ; 

  scheme_end_futures_per_place () ; 

  scheme_kill_green_thread_timer () ; 
  scheme_free_place_bi_channels () ; 


  GC_destruct_child_gc () ; 

  scheme_free_all_code () ; 
  scheme_clear_locale_cache () ; 
  rktio_destroy (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}


static void skip_certain_things (Scheme_Object * o , Scheme_Close_Custodian_Client * f , void * data ) 
{
  /* No conversion */

# 609 "bc/src/env.c"
  if ((o == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) ) 
  || (o == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdout_port_ ) ) 
  || (o == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stderr_port_ ) ) )
    return ; 


  if (f )
    f (o , data ) ; 
}





static Scheme_Startup_Env * make_startup_env (void ) 
{
  Scheme_Startup_Env * e ; 
  Scheme_Hash_Table * table ; 
  Scheme_Hash_Table * primitive_tables ; 
  DECL_RET_SAVE (Scheme_Startup_Env * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(primitive_tables, 0), PUSH(table, 1), PUSH(e, 2)));
# define XfOrM27_COUNT (3)
# define SETUP_XfOrM27(x) SETUP(XfOrM27_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  e = NULLED_OUT ; 
  table = NULLED_OUT ; 
  primitive_tables = NULLED_OUT ; 

# 629 "bc/src/env.c"
  e = ((Scheme_Startup_Env * ) FUNCCALL(SETUP_XfOrM27(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Startup_Env ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  e -> so . type = scheme_startup_env_type ; 

  primitive_tables = FUNCCALL(SETUP_XfOrM27(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  e -> primitive_tables = primitive_tables ; 

  table = FUNCCALL(SETUP_XfOrM27(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  e -> current_table = table ; 
  FUNCCALL(SETUP_XfOrM27(_), scheme_hash_set (e -> primitive_tables , kernel_symbol , (Scheme_Object * ) table ) ); 

  table = FUNCCALL_AGAIN(scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  e -> all_primitives_table = table ; 

  table = FUNCCALL(SETUP_XfOrM27(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  e -> primitive_ids_table = table ; 

  RET_VALUE_START (e ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 648 "bc/src/env.c"
void scheme_switch_prim_instance (Scheme_Startup_Env * env , const char * name ) 
{
  Scheme_Hash_Table * table ; 
  Scheme_Object * sym ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sym, 0), PUSH(env, 1), PUSH(table, 2)));
# define XfOrM28_COUNT (3)
# define SETUP_XfOrM28(x) SETUP(XfOrM28_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  table = NULLED_OUT ; 
  sym = NULLED_OUT ; 

# 653 "bc/src/env.c"
  sym = FUNCCALL(SETUP_XfOrM28(_), scheme_intern_symbol (name ) ); 

  table = (Scheme_Hash_Table * ) FUNCCALL(SETUP_XfOrM28(_), scheme_hash_get (env -> primitive_tables , sym ) ); 
  if (! table ) {
#   define XfOrM29_COUNT (0+XfOrM28_COUNT)
#   define SETUP_XfOrM29(x) SETUP_XfOrM28(x)

# 657 "bc/src/env.c"
    table = FUNCCALL(SETUP_XfOrM29(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    FUNCCALL(SETUP_XfOrM29(_), scheme_hash_set (env -> primitive_tables , sym , (Scheme_Object * ) table ) ); 
  }

  env -> current_table = table ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 664 "bc/src/env.c"
void scheme_restore_prim_instance (Scheme_Startup_Env * env ) 
{
  Scheme_Hash_Table * table ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(table, 1)));
# define XfOrM30_COUNT (2)
# define SETUP_XfOrM30(x) SETUP(XfOrM30_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  table = NULLED_OUT ; 

# 667 "bc/src/env.c"
  table = (Scheme_Hash_Table * ) FUNCCALL(SETUP_XfOrM30(_), scheme_hash_get (env -> primitive_tables , kernel_symbol ) ); 
  env -> current_table = table ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 671 "bc/src/env.c"
void scheme_addto_prim_instance (const char * name , Scheme_Object * obj , Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(obj, 1)));
# define XfOrM31_COUNT (2)
# define SETUP_XfOrM31(x) SETUP(XfOrM31_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  (__funcarg60 = FUNCCALL(SETUP_XfOrM31(_), scheme_intern_symbol (name ) )
# 673 "bc/src/env.c"
  , FUNCCALL_AGAIN(scheme_addto_primitive_instance_by_symbol (__funcarg60 , obj , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 676 "bc/src/env.c"
void 
scheme_addto_primitive_instance_by_symbol (Scheme_Object * name , Scheme_Object * obj , Scheme_Startup_Env * env ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(obj, 1), PUSH(name, 2)));
# define XfOrM32_COUNT (3)
# define SETUP_XfOrM32(x) SETUP(XfOrM32_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM32(_), scheme_hash_set (env -> current_table , name , obj ) )
# 679 "bc/src/env.c"
  ; 
  FUNCCALL(SETUP_XfOrM32(_), scheme_hash_set (env -> all_primitives_table , name , obj ) ); 
  FUNCCALL_EMPTY(scheme_hash_set (env -> primitive_ids_table , obj , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (builtin_ref_counter ) ) ) << 1 ) | 0x1 ) ) ) )
  ; 
  builtin_ref_counter ++ ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 686 "bc/src/env.c"
Scheme_Object * * scheme_make_builtin_references_table (int * _unsafe_start ) 
{
  Scheme_Object * * t , * v ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(_unsafe_start, 1), PUSH(t, 2)));
# define XfOrM33_COUNT (3)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 691 "bc/src/env.c"
  t = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM33(_), GC_malloc (sizeof (Scheme_Object * ) * ((builtin_ref_counter + 1 ) ) ) )) ; 




  for (i = builtin_ref_counter + 1 ; i -- ; ) {
    t [i ] = scheme_false ; 
  }

  for (i = scheme_startup_env -> primitive_ids_table -> size ; i -- ; ) {
    v = scheme_startup_env -> primitive_ids_table -> vals [i ] ; 
    if (v ) {
      t [(((intptr_t ) (v ) ) >> 1 ) ] = scheme_startup_env -> primitive_ids_table -> keys [i ] ; 
    }
  }

  * _unsafe_start = builtin_unsafe_start ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 712 "bc/src/env.c"
const char * scheme_look_for_primitive (void * code ) 
{
  /* No conversion */

# 714 "bc/src/env.c"
  intptr_t i ; 
  Scheme_Object * val ; 

  for (i = scheme_startup_env -> all_primitives_table -> size ; i -- ; ) {
    val = scheme_startup_env -> all_primitives_table -> vals [i ] ; 
    if (val && ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) ) {
      if ((((Scheme_Primitive_Proc * ) (val ) ) -> prim_val ) == code )
        return ((Scheme_Primitive_Proc * ) val ) -> name ; 
    }
  }

  return ((void * ) 0 ) ; 
}

Scheme_Object * scheme_builtin_value (const char * name ) 
{
  Scheme_Object * sym , * v ; 
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sym, 0), PUSH(b, 1), PUSH(v, 2)));
# define XfOrM45_COUNT (3)
# define SETUP_XfOrM45(x) SETUP(XfOrM45_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sym = NULLED_OUT ; 
  v = NULLED_OUT ; 
  b = NULLED_OUT ; 

# 733 "bc/src/env.c"
  sym = FUNCCALL(SETUP_XfOrM45(_), scheme_intern_symbol (name ) ); 
  v = FUNCCALL_AGAIN(scheme_hash_get (scheme_startup_env -> all_primitives_table , sym ) ); 
  if (! v ) {
#   define XfOrM46_COUNT (0+XfOrM45_COUNT)
#   define SETUP_XfOrM46(x) SETUP_XfOrM45(x)

# 736 "bc/src/env.c"
    b = FUNCCALL(SETUP_XfOrM46(_), scheme_instance_variable_bucket_or_null (sym , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_startup_instance_ ) ) ); 
    if (b )
      RET_VALUE_START (b -> val ) RET_VALUE_END ; 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Object * scheme_lookup_global (Scheme_Object * symbol , Scheme_Env * env ) 
{
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(b, 0)));
# define XfOrM47_COUNT (1)
# define SETUP_XfOrM47(x) SETUP(XfOrM47_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 751 "bc/src/env.c"
  b = FUNCCALL(SETUP_XfOrM47(_), scheme_instance_variable_bucket_or_null (symbol , env -> instance ) ); 
  if (b )
    RET_VALUE_START (b -> val ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 758 "bc/src/env.c"
Scheme_Bucket * scheme_global_bucket (Scheme_Object * symbol , Scheme_Env * env ) 
{
  /* No conversion */

# 760 "bc/src/env.c"
  return scheme_instance_variable_bucket (symbol , env -> instance ) ; 
}

void scheme_add_global (const char * name , Scheme_Object * obj , Scheme_Env * env ) 
{
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(obj, 1)));
# define XfOrM49_COUNT (2)
# define SETUP_XfOrM49(x) SETUP(XfOrM49_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  (__funcarg61 = FUNCCALL(SETUP_XfOrM49(_), scheme_intern_symbol (name ) )
# 765 "bc/src/env.c"
  , FUNCCALL_AGAIN(scheme_add_global_symbol (__funcarg61 , obj , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 768 "bc/src/env.c"
void scheme_add_global_symbol (Scheme_Object * sym , Scheme_Object * obj , Scheme_Env * env ) 
{
  Scheme_Bucket * b ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(obj, 1)));
# define XfOrM50_COUNT (2)
# define SETUP_XfOrM50(x) SETUP(XfOrM50_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 771 "bc/src/env.c"
  b = FUNCCALL(SETUP_XfOrM50(_), scheme_global_bucket (sym , env ) ); 
  b -> val = obj ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 775 "bc/src/env.c"
Scheme_Object * scheme_make_namespace (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * proc ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(proc, 1)));
# define XfOrM51_COUNT (2)
# define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  proc = NULLED_OUT ; 

# 778 "bc/src/env.c"
  proc = FUNCCALL(SETUP_XfOrM51(_), scheme_get_startup_export ("make-namespace" ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_apply (proc , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Object * scheme_intern_literal_string (Scheme_Object * str ) 
{
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(str, 1)));
# define XfOrM52_COUNT (2)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM52(_), scheme_start_atomic () )
# 790 "bc/src/env.c"
  ; 
  b = FUNCCALL_AGAIN(scheme_bucket_from_table (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> literal_string_table_ ) , (const char * ) str ) ); 
  FUNCCALL_AGAIN(scheme_end_atomic_no_swap () ); 
  if (! b -> val )
    b -> val = scheme_true ; 

  RET_VALUE_START ((Scheme_Object * ) (((Scheme_Small_Object * ) (b -> key ) ) -> u . ptr_val ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 799 "bc/src/env.c"
Scheme_Object * scheme_intern_literal_number (Scheme_Object * num ) 
{
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(num, 1)));
# define XfOrM53_COUNT (2)
# define SETUP_XfOrM53(x) SETUP(XfOrM53_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM53(_), scheme_start_atomic () )
# 803 "bc/src/env.c"
  ; 
  b = FUNCCALL_AGAIN(scheme_bucket_from_table (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> literal_number_table_ ) , (const char * ) num ) ); 
  FUNCCALL_AGAIN(scheme_end_atomic_no_swap () ); 
  if (! b -> val )
    b -> val = scheme_true ; 

  RET_VALUE_START ((Scheme_Object * ) (((Scheme_Small_Object * ) (b -> key ) ) -> u . ptr_val ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}







static void register_traversers (void ) 
{
}
