#include "precomp.h"

# 34 "bc/rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 121 "rktio/rktio.h"
typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 351 "rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "rktio/rktio.h"
rktio_process_result_t ; 

# 646 "rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "rktio/rktio.h"
rktio_status_t ; 

# 669 "rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "rktio/rktio.h"
rktio_identity_t ; 

# 925 "rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "rktio/rktio.h"
rktio_date_t ; 

# 1109 "rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 

# 1378 "rktio/rktio.h"
enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 




enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

# 5 "bc/src/future.c"
static Scheme_Object * future_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7 "bc/src/future.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_future_type ) ) 
    return scheme_true ; 
  else 
  return scheme_false ; 
}

Scheme_Object * scheme_fsemaphore_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 15 "bc/src/future.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_fsemaphore_type ) ) 
    return scheme_true ; 
  else 
  return scheme_false ; 
}

static Scheme_Object * futures_enabled (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */


  return scheme_false ; 
}




static void register_traversers (void ) ; 






typedef struct future_t {
  Scheme_Object so ; 
  Scheme_Object * running_sema ; 
  Scheme_Object * orig_lambda ; 
  Scheme_Object * retval ; 
  int multiple_count ; 
  Scheme_Object * * multiple_array ; 
  int no_retval ; 
}

# 47 "bc/src/future.c"
future_t ; 

typedef struct fsemaphore_t {
  Scheme_Object so ; 
  Scheme_Object * sema ; 
}

# 52 "bc/src/future.c"
fsemaphore_t ; 

Scheme_Object * scheme_future (int argc , Scheme_Object * argv [] ) 
{
  future_t * ft ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ft, 0), PUSH(argv, 1)));
# define XfOrM4_COUNT (2)
# define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ft = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_check_proc_arity ("future" , 0 , 0 , argc , argv ) )
# 58 "bc/src/future.c"
  ; 

  ft = ((future_t * ) FUNCCALL(SETUP_XfOrM4(_), GC_malloc_one_small_tagged ((((sizeof (future_t ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  ft -> so . type = scheme_future_type ; 

  ft -> orig_lambda = argv [0 ] ; 

  RET_VALUE_START ((Scheme_Object * ) ft ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 68 "bc/src/future.c"
static Scheme_Object * touch (int argc , Scheme_Object * argv [] ) 
{
  future_t * volatile ft ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(ft, 0)));
# define XfOrM5_COUNT (1)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ft = NULLED_OUT ; 

# 72 "bc/src/future.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_future_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("touch" , "future?" , 0 , argc , argv ) ); 

  ft = (future_t * ) argv [0 ] ; 

  while (1 ) {
#   define XfOrM14_COUNT (0+XfOrM5_COUNT)
#   define SETUP_XfOrM14(x) SETUP_XfOrM5(x)

# 78 "bc/src/future.c"
    if (ft -> retval ) {
      if ((ft -> retval ) == (((Scheme_Object * ) 0x6 ) ) )  {
        Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
        p -> ku . multiple . array = ft -> multiple_array ; 
        p -> ku . multiple . count = ft -> multiple_count ; 
      }
      RET_VALUE_START (ft -> retval ) RET_VALUE_END ; 
    }
    if (ft -> no_retval )
      FUNCCALL_EMPTY(scheme_signal_error ("touch: future previously aborted" ) ); 

    if (ft -> running_sema ) {
#     define XfOrM19_COUNT (0+XfOrM14_COUNT)
#     define SETUP_XfOrM19(x) SETUP_XfOrM14(x)
      FUNCCALL(SETUP_XfOrM19(_), scheme_wait_sema (ft -> running_sema , 0 ) )
# 90 "bc/src/future.c"
      ; 
      FUNCCALL(SETUP_XfOrM19(_), scheme_post_sema (ft -> running_sema ) ); 
    }

# 92 "bc/src/future.c"
    else {
      Scheme_Object * sema ; 
      future_t * old_ft ; 
      mz_jmp_buf newbuf , * volatile savebuf ; 
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      BLOCK_SETUP((PUSH(savebuf, 0+XfOrM14_COUNT), PUSH(sema, 1+XfOrM14_COUNT), PUSH(p, 2+XfOrM14_COUNT), PUSH(old_ft, 3+XfOrM14_COUNT)));
#     define XfOrM15_COUNT (4+XfOrM14_COUNT)
#     define SETUP_XfOrM15(x) SETUP(XfOrM15_COUNT)
      sema = NULLED_OUT ; 
      old_ft = NULLED_OUT ; 
      savebuf = NULLED_OUT ; 

# 99 "bc/src/future.c"
      sema = FUNCCALL(SETUP_XfOrM15(_), scheme_make_sema (0 ) ); 
      ft -> running_sema = sema ; 

      old_ft = p -> current_ft ; 
      p -> current_ft = ft ; 

      savebuf = p -> error_buf ; 
      p -> error_buf = & newbuf ; 
      if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM15_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#       define XfOrM18_COUNT (0+XfOrM15_COUNT)
#       define SETUP_XfOrM18(x) SETUP_XfOrM15(x)

# 108 "bc/src/future.c"
        ft -> no_retval = 1 ; 
        p -> current_ft = old_ft ; 
        FUNCCALL(SETUP_XfOrM18(_), scheme_post_sema (ft -> running_sema ) ); 
        (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
      }

# 112 "bc/src/future.c"
      else {
        GC_CAN_IGNORE Scheme_Object * retval , * proc ; 
#       define XfOrM16_COUNT (0+XfOrM15_COUNT)
#       define SETUP_XfOrM16(x) SETUP_XfOrM15(x)

# 114 "bc/src/future.c"
        proc = ft -> orig_lambda ; 
        ft -> orig_lambda = ((void * ) 0 ) ; 
        retval = FUNCCALL(SETUP_XfOrM16(_), scheme_apply_multi (proc , 0 , ((void * ) 0 ) ) ); 
        ft -> retval = retval ; 
        if ((retval ) == (((Scheme_Object * ) 0x6 ) ) )  {
          ft -> multiple_array = p -> ku . multiple . array ; 
          ft -> multiple_count = p -> ku . multiple . count ; 
          p -> ku . multiple . array = ((void * ) 0 ) ; 
        }
        FUNCCALL(SETUP_XfOrM16(_), scheme_post_sema (ft -> running_sema ) ); 
        p -> current_ft = old_ft ; 
        p -> error_buf = savebuf ; 
      }
    }
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 135 "bc/src/future.c"
static Scheme_Object * processor_count (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 137 "bc/src/future.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
}

int scheme_is_multithreaded (int now ) 
{
  /* No conversion */

# 142 "bc/src/future.c"
  return 0 ; 
}

Scheme_Object * scheme_current_future (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 147 "bc/src/future.c"
  future_t * ft = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_ft ; 

  return (ft ? (Scheme_Object * ) ft : scheme_false ) ; 
}

Scheme_Object * scheme_make_fsemaphore (int argc , Scheme_Object * argv [] ) 
{
  intptr_t v ; 
  fsemaphore_t * fsema ; 
  Scheme_Object * sema ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sema, 0), PUSH(fsema, 1)));
# define XfOrM25_COUNT (2)
# define SETUP_XfOrM25(x) SETUP(XfOrM25_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  fsema = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 158 "bc/src/future.c"
  v = FUNCCALL(SETUP_XfOrM25(_), scheme_get_semaphore_init ("make-fsemaphore" , argc , argv ) ); 

  fsema = ((fsemaphore_t * ) FUNCCALL(SETUP_XfOrM25(_), GC_malloc_one_small_tagged ((((sizeof (fsemaphore_t ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  fsema -> so . type = scheme_fsemaphore_type ; 
  sema = FUNCCALL(SETUP_XfOrM25(_), scheme_make_sema (v ) ); 
  fsema -> sema = sema ; 

  RET_VALUE_START ((Scheme_Object * ) fsema ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 168 "bc/src/future.c"
static Scheme_Object * make_fsemaphore (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 170 "bc/src/future.c"
  return scheme_make_fsemaphore (argc , argv ) ; 
}

Scheme_Object * scheme_fsemaphore_post (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 175 "bc/src/future.c"
  fsemaphore_t * fsema ; 
  if (argc != 1 || ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_fsemaphore_type ) ) )
    scheme_wrong_contract ("fsemaphore-post" , "fsemaphore?" , 0 , argc , argv ) ; 

  fsema = (fsemaphore_t * ) argv [0 ] ; 
  scheme_post_sema (fsema -> sema ) ; 

  return scheme_void ; 
}

Scheme_Object * scheme_fsemaphore_wait (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 187 "bc/src/future.c"
  fsemaphore_t * fsema ; 
  if (argc != 1 || ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_fsemaphore_type ) ) )
    scheme_wrong_contract ("fsemaphore-wait" , "fsemaphore?" , 0 , argc , argv ) ; 

  fsema = (fsemaphore_t * ) argv [0 ] ; 
  scheme_wait_sema (fsema -> sema , 0 ) ; 

  return scheme_void ; 
}

Scheme_Object * scheme_fsemaphore_try_wait (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 199 "bc/src/future.c"
  fsemaphore_t * fsema ; 
  if (argc != 1 || ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_fsemaphore_type ) ) )
    scheme_wrong_contract ("fsemaphore-try-wait?" , "fsemaphore?" , 0 , argc , argv ) ; 

  fsema = (fsemaphore_t * ) argv [0 ] ; 
  if (scheme_wait_sema (fsema -> sema , 1 ) )
    return scheme_true ; 

  return scheme_false ; 
}

Scheme_Object * scheme_fsemaphore_count (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 212 "bc/src/future.c"
  fsemaphore_t * fsema ; 
  if (argc != 1 || ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_fsemaphore_type ) ) )
    scheme_wrong_contract ("fsemaphore-count" , "fsemaphore?" , 0 , argc , argv ) ; 

  fsema = (fsemaphore_t * ) argv [0 ] ; 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (((Scheme_Sema * ) fsema -> sema ) -> value ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * would_be_future (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM31_COUNT (1)
# define SETUP_XfOrM31(x) SETUP(XfOrM31_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM31(_), scheme_check_proc_arity ("would-be-future" , 0 , 0 , argc , argv ) )
# 222 "bc/src/future.c"
  ; 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_future (argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 226 "bc/src/future.c"
static Scheme_Object * reset_future_logs_for_tracking (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 228 "bc/src/future.c"
  return scheme_void ; 
}

static Scheme_Object * mark_future_trace_end (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 233 "bc/src/future.c"
  return scheme_void ; 
}

void scheme_init_futures_once () 
{
  /* No conversion */
}
void scheme_init_futures_per_place () 
{
  /* No conversion */
  register_traversers () ; 
}


void scheme_end_futures_per_place () 
{
  /* No conversion */
}

# 442 "bc/src/future.c"
void scheme_init_futures (Scheme_Startup_Env * newenv ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(newenv, 0), PUSH(p, 1)));
# define XfOrM37_COUNT (2)
# define SETUP_XfOrM37(x) SETUP(XfOrM37_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM37(_), scheme_make_folding_prim (future_p , "future?" , 1 , 1 , 1 ) )
# 451 "bc/src/future.c"
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("future?" , __funcarg63 , newenv ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_future , "future" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("future" , p , newenv ) ); 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM37(_), scheme_make_prim_w_arity (processor_count , "processor-count" , 0 , 0 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("processor-count" , __funcarg62 , newenv ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_prim_w_arity (touch , "touch" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("touch" , p , newenv ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_current_future , "current-future" , 0 , 0 ) )


  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("current-future" , p , newenv ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_fsemaphore_p , "fsemaphore?" , 1 , 1 ) )


  ; 

  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("fsemaphore?" , p , newenv ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_fsemaphore , "make-fsemaphore" , 1 , 1 ) )


  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("make-fsemaphore" , p , newenv ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_fsemaphore_count , "fsemaphore-count" , 1 , 1 ) )


  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("fsemaphore-count" , p , newenv ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_fsemaphore_wait , "fsemaphore-wait" , 1 , 1 ) )


  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("fsemaphore-wait" , p , newenv ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_fsemaphore_post , "fsemaphore-post" , 1 , 1 ) )


  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("fsemaphore-post" , p , newenv ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_fsemaphore_try_wait , "fsemaphore-try-wait?" , 1 , 1 ) )


  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 17 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM37(_), scheme_addto_prim_instance ("fsemaphore-try-wait?" , p , newenv ) ); 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM37(_), scheme_make_prim_w_arity (would_be_future , "would-be-future" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("would-be-future" , __funcarg61 , newenv ) )) ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM37(_), scheme_make_prim_w_arity (futures_enabled , "futures-enabled?" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("futures-enabled?" , __funcarg60 , newenv ) )) ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM37(_), scheme_make_prim_w_arity (reset_future_logs_for_tracking , "reset-future-logs-for-tracing!" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("reset-future-logs-for-tracing!" , __funcarg59 , newenv ) )) ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM37(_), scheme_make_prim_w_arity (mark_future_trace_end , "mark-future-trace-end!" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("mark-future-trace-end!" , __funcarg58 , newenv ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 139 "bc/src/mzmark_future.inc"
static int sequential_future_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int sequential_future_MARK (void * p , struct NewGC * gc ) {

  future_t * f = (future_t * ) p ; 
  GC_mark2 (& (f -> orig_lambda ) , gc ) ; 
  GC_mark2 (& (f -> running_sema ) , gc ) ; 
  GC_mark2 (& (f -> retval ) , gc ) ; 
  GC_mark2 (& (f -> multiple_array ) , gc ) ; 

  return 0 ; 
}






static int sequential_future_FIXUP (void * p , struct NewGC * gc ) {

  future_t * f = (future_t * ) p ; 
  GC_fixup2 (& (f -> orig_lambda ) , gc ) ; 
  GC_fixup2 (& (f -> running_sema ) , gc ) ; 
  GC_fixup2 (& (f -> retval ) , gc ) ; 
  GC_fixup2 (& (f -> multiple_array ) , gc ) ; 

  return 0 ; 
}

# 183 "bc/src/mzmark_future.inc"
static int sequential_fsemaphore_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int sequential_fsemaphore_MARK (void * p , struct NewGC * gc ) {

  fsemaphore_t * s = (fsemaphore_t * ) p ; 
  GC_mark2 (& (s -> sema ) , gc ) ; 

  return 0 ; 
}






static int sequential_fsemaphore_FIXUP (void * p , struct NewGC * gc ) {

  fsemaphore_t * s = (fsemaphore_t * ) p ; 
  GC_fixup2 (& (s -> sema ) , gc ) ; 

  return 0 ; 
}

# 3793 "bc/src/future.c"
static void register_traversers (void ) 
{




  GC_register_traversers2 (scheme_future_type , sequential_future_SIZE , sequential_future_MARK , sequential_future_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_fsemaphore_type , sequential_fsemaphore_SIZE , sequential_fsemaphore_MARK , sequential_fsemaphore_FIXUP , 1 , 0 ) ; 
}
