#include "precomp.h"

# 78 "bc/src/letrec_check.c"
static void register_traversers (void ) ; 


void scheme_init_letrec_check () 
{
  /* No conversion */
  register_traversers () ; 
}

# 100 "bc/src/letrec_check.c"
typedef Scheme_Object Wrapped_Lhs ; 


typedef struct Letrec_Check_Frame {
  Scheme_Type type ; 


  int frame_type ; 




  int subexpr ; 


  int count ; 



  Scheme_Object * * def ; 




  int * ref ; 




  struct Scheme_Deferred_Expr * * deferred_chain ; 

  struct Letrec_Check_Frame * next ; 
}

# 132 "bc/src/letrec_check.c"
Letrec_Check_Frame ; 



typedef struct Scheme_Deferred_Expr {
  Scheme_Object so ; 



  int done ; 



  Scheme_Object * expr ; 


  Letrec_Check_Frame * frame ; 



  struct Scheme_Deferred_Expr * chain_next ; 
}

# 153 "bc/src/letrec_check.c"
Scheme_Deferred_Expr ; 

static void process_deferred_bindings (Letrec_Check_Frame * frame , int position ) ; 


static Letrec_Check_Frame * init_letrec_check_frame (int frame_type , int subexpr , 
mzshort count , 
Letrec_Check_Frame * prev , 
Letrec_Check_Frame * share_with , 
Scheme_IR_Let_Header * head , 
Scheme_Lambda * lam ) 
{
  Scheme_Deferred_Expr * * chain ; 
  Letrec_Check_Frame * frame ; 
  Scheme_Object * * def ; 
  int * ref , i , j , pos ; 
  DECL_RET_SAVE (Letrec_Check_Frame * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(lam, 0), PUSH(chain, 1), PUSH(frame, 2), PUSH(prev, 3), PUSH(def, 4), PUSH(ref, 5), PUSH(share_with, 6), PUSH(head, 7)));
# define XfOrM2_COUNT (8)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  chain = NULLED_OUT ; 
  frame = NULLED_OUT ; 
  def = NULLED_OUT ; 
  ref = NULLED_OUT ; 

# 170 "bc/src/letrec_check.c"
  frame = (Letrec_Check_Frame * ) ((Letrec_Check_Frame * ) FUNCCALL(SETUP_XfOrM2(_), GC_malloc_one_small_tagged ((((sizeof (Letrec_Check_Frame ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  frame -> type = scheme_rt_letrec_check_frame ; 


  frame -> frame_type = frame_type ; 

  frame -> count = count ; 
  frame -> next = prev ; 

  if (head ) {
    Scheme_IR_Let_Value * irlv = (Scheme_IR_Let_Value * ) head -> body ; 
    pos = 0 ; 
    for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
      for (j = 0 ; j < irlv -> count ; j ++ ) {
        irlv -> vars [j ] -> mode = 2 ; 
        irlv -> vars [j ] -> letrec_check . frame = frame ; 
        irlv -> vars [j ] -> letrec_check . frame_pos = pos ++ ; 
      }
    }
  }

# 190 "bc/src/letrec_check.c"
  else if (lam ) {
    for (j = lam -> num_params ; j -- ; ) {
      lam -> ir_info -> vars [j ] -> mode = 2 ; 
      lam -> ir_info -> vars [j ] -> letrec_check . frame = frame ; 
      lam -> ir_info -> vars [j ] -> letrec_check . frame_pos = j ; 
    }
  }

  if (share_with ) {



    frame -> def = share_with -> def ; 
    frame -> ref = share_with -> ref ; 
  }

# 204 "bc/src/letrec_check.c"
  else if ((frame_type == 4 ) 
  || (frame_type == 5 ) ) {
    frame -> def = ((void * ) 0 ) ; 
    frame -> ref = ((void * ) 0 ) ; 
  }

# 208 "bc/src/letrec_check.c"
  else {
    int init_ref ; 
#   define XfOrM3_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM3(x) SETUP_XfOrM2(x)

    def = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM3(_), GC_malloc (sizeof (Scheme_Object * ) * (count ) ) )) ; 
    for (i = 0 ; i < count ; i ++ ) {

# 214 "bc/src/letrec_check.c"
      def [i ] = scheme_null ; 
    }

# 215 "bc/src/letrec_check.c"
    frame -> def = def ; 



    ref = ((int * ) FUNCCALL(SETUP_XfOrM3(_), GC_malloc_atomic (sizeof (int ) * (count ) ) )) ; 
    if (frame_type == 1 )
      init_ref = 0 ; 
    else 
    init_ref = (0x1 << 1 ) ; 
    for (i = count ; i -- ; ) {

# 224 "bc/src/letrec_check.c"
      ref [i ] = init_ref ; 
    }

# 225 "bc/src/letrec_check.c"
    frame -> ref = ref ; 
  }




  frame -> subexpr = subexpr ; 

  if (prev )
    chain = prev -> deferred_chain ; 
  else 
  chain = ((Scheme_Deferred_Expr * * ) FUNCCALL(SETUP_XfOrM2(_), GC_malloc (sizeof (Scheme_Deferred_Expr * ) * (1 ) ) )) ; 
  frame -> deferred_chain = chain ; 

  RET_VALUE_START (frame ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 244 "bc/src/letrec_check.c"
static Letrec_Check_Frame * get_nearest_rhs (Letrec_Check_Frame * frame ) 
{
  /* No conversion */

# 246 "bc/src/letrec_check.c"
  for (; frame != ((void * ) 0 ) ; frame = frame -> next ) {
    if (frame -> subexpr == 1 )
      return frame ; 
  }

  scheme_signal_error ("get_nearest_rhs: not in a let RHS" ) ; 
  return ((void * ) 0 ) ; 
}



static Letrec_Check_Frame * get_relative_frame (int * pos , Scheme_IR_Local * var ) 
{
  /* No conversion */

# 259 "bc/src/letrec_check.c"
  * pos = var -> letrec_check . frame_pos ; 
  return var -> letrec_check . frame ; 
}


static void update_frame (Letrec_Check_Frame * outer , Letrec_Check_Frame * inner , 
int position , Scheme_Deferred_Expr * clos ) 
{
  Scheme_Object * prev_def ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(outer, 0), PUSH(prev_def, 1)));
# define XfOrM24_COUNT (2)
# define SETUP_XfOrM24(x) SETUP(XfOrM24_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prev_def = NULLED_OUT ; 

# 269 "bc/src/letrec_check.c"
  ((position < outer -> count ) ? 1 : (FUNCCALL_EMPTY(scheme_signal_error ("update_frame: position exceeds binding count" ) ), 0 ) ) ; 

  if (((outer -> def [position ] ) ) == (scheme_void ) ) 
    FUNCCALL_EMPTY(scheme_signal_error ("oops\n" ) ); 


  prev_def = outer -> def [position ] ; 
  prev_def = FUNCCALL(SETUP_XfOrM24(_), scheme_make_pair ((Scheme_Object * ) clos , prev_def ) ); 
  outer -> def [position ] = prev_def ; 

  if (outer -> ref [position ] & 0x1 )
    FUNCCALL_EMPTY(process_deferred_bindings (outer , position ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 284 "bc/src/letrec_check.c"
static Scheme_Deferred_Expr * make_deferred_expr_closure (Scheme_Object * expr , Letrec_Check_Frame * frame ) 
{
  Scheme_Deferred_Expr * clos ; 
  DECL_RET_SAVE (Scheme_Deferred_Expr * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(expr, 0), PUSH(frame, 1), PUSH(clos, 2)));
# define XfOrM25_COUNT (3)
# define SETUP_XfOrM25(x) SETUP(XfOrM25_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  clos = NULLED_OUT ; 

# 288 "bc/src/letrec_check.c"
  clos = ((Scheme_Deferred_Expr * ) FUNCCALL(SETUP_XfOrM25(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Deferred_Expr ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  clos -> so . type = scheme_deferred_expr_type ; 
  clos -> done = 0 ; 
  clos -> expr = expr ; 
  clos -> frame = frame ; 

  clos -> chain_next = * frame -> deferred_chain ; 
  * frame -> deferred_chain = clos ; 

  RET_VALUE_START (clos ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 300 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_expr (Scheme_Object * , Letrec_Check_Frame * , Scheme_Object * ) ; 

static void letrec_check_lets_resume (Letrec_Check_Frame * frame , Scheme_IR_Let_Header * head ) 
{
  /* No conversion */

# 304 "bc/src/letrec_check.c"
  Scheme_IR_Let_Value * irlv ; 
  Scheme_Object * body ; 
  int i , j , k ; 
  int was_checked ; 

  body = head -> body ; 
  if (frame -> frame_type == 1 ) {




    k = 0 ; 
    for (i = head -> num_clauses ; i -- ; ) {
      irlv = (Scheme_IR_Let_Value * ) body ; 
      for (j = 0 ; j < irlv -> count ; j ++ ) {
        was_checked = (frame -> ref [k + j ] & (0x1 << 2 ) ) ; 
        if (was_checked )
          irlv -> vars [j ] -> non_app_count = irlv -> vars [j ] -> use_count ; 
      }
      k += irlv -> count ; 
      body = irlv -> body ; 
    }
  }
}


static Scheme_Object * record_checked (Scheme_IR_Local * loc , Letrec_Check_Frame * frame ) 
{
  int position ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(loc, 0), PUSH(frame, 1)));
# define XfOrM34_COUNT (2)
# define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 334 "bc/src/letrec_check.c"
  frame = FUNCCALL(SETUP_XfOrM34(_), get_relative_frame (& position , loc ) ); 
  frame -> ref [position ] |= (0x1 << 2 ) ; 

  RET_VALUE_START (loc -> name ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 340 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_local (Scheme_Object * o , Letrec_Check_Frame * frame , 
Scheme_Object * pos ) 
{
  Letrec_Check_Frame * in_frame ; 
  Scheme_IR_Local * loc = (Scheme_IR_Local * ) o ; 
  int in_position ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(in_frame, 0), PUSH(pos, 1), PUSH(frame, 2), PUSH(loc, 3), PUSH(o, 4)));
# define XfOrM35_COUNT (5)
# define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  in_frame = NULLED_OUT ; 

# 347 "bc/src/letrec_check.c"
  in_frame = FUNCCALL(SETUP_XfOrM35(_), get_relative_frame (& in_position , loc ) ); 

  if (((pos ) ) == (scheme_false ) )  {


    if (in_frame -> ref )
      in_frame -> ref [in_position ] |= 0x1 ; 
  }

# 354 "bc/src/letrec_check.c"
  else {
#   define XfOrM37_COUNT (0+XfOrM35_COUNT)
#   define SETUP_XfOrM37(x) SETUP_XfOrM35(x)

# 356 "bc/src/letrec_check.c"
    if (! ((pos ) == (scheme_null ) ) ) {
      Letrec_Check_Frame * outer_frame ; 
      Scheme_Object * ls ; 
      BLOCK_SETUP((PUSH(outer_frame, 0+XfOrM37_COUNT), PUSH(ls, 1+XfOrM37_COUNT)));
#     define XfOrM38_COUNT (2+XfOrM37_COUNT)
#     define SETUP_XfOrM38(x) SETUP(XfOrM38_COUNT)
      outer_frame = NULLED_OUT ; 
      ls = NULLED_OUT ; 

# 359 "bc/src/letrec_check.c"
      outer_frame = FUNCCALL(SETUP_XfOrM38(_), get_nearest_rhs (frame ) ); 
      while ((((intptr_t ) (pos ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (pos ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pos ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
        int dpos ; 
#       define XfOrM42_COUNT (0+XfOrM38_COUNT)
#       define SETUP_XfOrM42(x) SETUP_XfOrM38(x)

# 363 "bc/src/letrec_check.c"
        if (((intptr_t ) (pos ) ) & 0x1 )  {
          dpos = (((intptr_t ) (pos ) ) >> 1 ) ; 
          pos = scheme_null ; 
        }

# 366 "bc/src/letrec_check.c"
        else {
          dpos = (((intptr_t ) ((((Scheme_Simple_Object * ) (pos ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
          pos = (((Scheme_Simple_Object * ) (pos ) ) -> u . pair_val . cdr ) ; 
        }

        ls = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM42(_), make_deferred_expr_closure (o , frame ) ); 
        ls = FUNCCALL(SETUP_XfOrM42(_), scheme_make_pair (ls , outer_frame -> def [dpos ] ) ); 
        outer_frame -> def [dpos ] = ls ; 




        if ((outer_frame -> ref [dpos ] & 0x1 ) 
        && in_frame -> ref )
          in_frame -> ref [in_position ] |= 0x1 ; 
      }
    }
  }




  if (in_frame -> ref 
  && (in_frame -> ref [in_position ] & 0x1 ) )
    FUNCCALL(SETUP_XfOrM35(_), process_deferred_bindings (in_frame , in_position ) ); 

  if (in_frame -> ref 
  && ! (in_frame -> ref [in_position ] & (0x1 << 1 ) ) ) {


    Scheme_App3_Rec * app3 ; 
    Scheme_Object * name ; 
    BLOCK_SETUP((PUSH(app3, 0+XfOrM35_COUNT), PUSH(name, 1+XfOrM35_COUNT)));
#   define XfOrM36_COUNT (2+XfOrM35_COUNT)
#   define SETUP_XfOrM36(x) SETUP(XfOrM36_COUNT)
    app3 = NULLED_OUT ; 
    name = NULLED_OUT ; 

# 399 "bc/src/letrec_check.c"
    name = FUNCCALL(SETUP_XfOrM36(_), record_checked (loc , frame ) ); 

    app3 = ((Scheme_App3_Rec * ) FUNCCALL(SETUP_XfOrM36(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App3_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    app3 -> iso . so . type = scheme_application3_type ; 
    app3 -> rator = scheme_check_not_undefined_proc ; 
    app3 -> rand1 = o ; 
    app3 -> rand2 = name ; 

    RET_VALUE_START ((Scheme_Object * ) app3 ) RET_VALUE_END ; 
  }


  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 414 "bc/src/letrec_check.c"
static int is_effect_free_prim (Scheme_Object * rator , int argc ) 
{
  /* No conversion */

# 416 "bc/src/letrec_check.c"
  if (((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && scheme_is_omitable_primitive (rator , argc ) )
    return 1 ; 

  return 0 ; 
}

static Scheme_Object * letrec_check_application (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  int i , n ; 
  Scheme_App_Rec * app ; 
  Scheme_Object * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(pos, 1), PUSH(app, 2), PUSH(frame, 3), PUSH(val, 4)));
# define XfOrM47_COUNT (5)
# define SETUP_XfOrM47(x) SETUP(XfOrM47_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  app = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 428 "bc/src/letrec_check.c"
  app = (Scheme_App_Rec * ) o ; 


  n = 1 + app -> num_args ; 

  if (FUNCCALL(SETUP_XfOrM47(_), is_effect_free_prim (app -> args [0 ] , app -> num_args ) )) {
  }
  else {

    pos = scheme_false ; 
  }

  for (i = 0 ; i < n ; i ++ ) {
#   define XfOrM49_COUNT (0+XfOrM47_COUNT)
#   define SETUP_XfOrM49(x) SETUP_XfOrM47(x)

# 441 "bc/src/letrec_check.c"
    val = FUNCCALL(SETUP_XfOrM49(_), letrec_check_expr (app -> args [i ] , frame , pos ) ); 
    app -> args [i ] = val ; 
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 448 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_application2 (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_App2_Rec * app ; 
  Scheme_Object * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(pos, 1), PUSH(app, 2), PUSH(frame, 3), PUSH(val, 4)));
# define XfOrM52_COUNT (5)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  app = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 453 "bc/src/letrec_check.c"
  app = (Scheme_App2_Rec * ) o ; 

  if (FUNCCALL(SETUP_XfOrM52(_), is_effect_free_prim (app -> rator , 1 ) )) {
  }
  else {

    pos = scheme_false ; 
  }

  val = FUNCCALL(SETUP_XfOrM52(_), letrec_check_expr (app -> rator , frame , pos ) ); 
  app -> rator = val ; 
  val = FUNCCALL(SETUP_XfOrM52(_), letrec_check_expr (app -> rand , frame , pos ) ); 
  app -> rand = val ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 470 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_application3 (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_App3_Rec * app ; 
  Scheme_Object * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(pos, 1), PUSH(app, 2), PUSH(frame, 3), PUSH(val, 4)));
# define XfOrM55_COUNT (5)
# define SETUP_XfOrM55(x) SETUP(XfOrM55_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  app = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 475 "bc/src/letrec_check.c"
  app = (Scheme_App3_Rec * ) o ; 

  if (FUNCCALL(SETUP_XfOrM55(_), is_effect_free_prim (app -> rator , 2 ) )) {
  }
  else {

    pos = scheme_false ; 
  }

  val = FUNCCALL(SETUP_XfOrM55(_), letrec_check_expr (app -> rator , frame , pos ) ); 
  app -> rator = val ; 
  val = FUNCCALL(SETUP_XfOrM55(_), letrec_check_expr (app -> rand1 , frame , pos ) ); 
  app -> rand1 = val ; 
  val = FUNCCALL(SETUP_XfOrM55(_), letrec_check_expr (app -> rand2 , frame , pos ) ); 
  app -> rand2 = val ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 494 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_sequence (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_Sequence * seq ; 
  Scheme_Object * val ; 
  int i , n ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(seq, 1), PUSH(pos, 2), PUSH(frame, 3), PUSH(val, 4)));
# define XfOrM58_COUNT (5)
# define SETUP_XfOrM58(x) SETUP(XfOrM58_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  seq = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 500 "bc/src/letrec_check.c"
  seq = (Scheme_Sequence * ) o ; 

  n = seq -> count ; 
  for (i = 0 ; i < n ; i ++ ) {
#   define XfOrM60_COUNT (0+XfOrM58_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM58(x)

# 504 "bc/src/letrec_check.c"
    val = FUNCCALL(SETUP_XfOrM60(_), letrec_check_expr (seq -> array [i ] , frame , pos ) ); 
    seq -> array [i ] = val ; 
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 511 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_branch (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_Branch_Rec * br ; 
  Scheme_Object * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(pos, 1), PUSH(br, 2), PUSH(frame, 3), PUSH(val, 4)));
# define XfOrM61_COUNT (5)
# define SETUP_XfOrM61(x) SETUP(XfOrM61_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  br = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 516 "bc/src/letrec_check.c"
  br = (Scheme_Branch_Rec * ) o ; 

  val = FUNCCALL(SETUP_XfOrM61(_), letrec_check_expr (br -> test , frame , pos ) ); 
  br -> test = val ; 
  val = FUNCCALL(SETUP_XfOrM61(_), letrec_check_expr (br -> tbranch , frame , pos ) ); 
  br -> tbranch = val ; 
  val = FUNCCALL(SETUP_XfOrM61(_), letrec_check_expr (br -> fbranch , frame , pos ) ); 
  br -> fbranch = val ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 528 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_wcm (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_With_Continuation_Mark * wcm ; 
  Scheme_Object * val , * val_pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(frame, 0), PUSH(pos, 1), PUSH(wcm, 2), PUSH(o, 3), PUSH(val_pos, 4), PUSH(val, 5)));
# define XfOrM62_COUNT (6)
# define SETUP_XfOrM62(x) SETUP(XfOrM62_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  wcm = NULLED_OUT ; 
  val = NULLED_OUT ; 
  val_pos = NULLED_OUT ; 

# 533 "bc/src/letrec_check.c"
  wcm = (Scheme_With_Continuation_Mark * ) o ; 

  val = FUNCCALL(SETUP_XfOrM62(_), letrec_check_expr (wcm -> key , frame , pos ) ); 
  wcm -> key = val ; 


  val_pos = scheme_false ; 
  val = FUNCCALL(SETUP_XfOrM62(_), letrec_check_expr (wcm -> val , frame , val_pos ) ); 
  wcm -> val = val ; 

  val = FUNCCALL(SETUP_XfOrM62(_), letrec_check_expr (wcm -> body , frame , pos ) ); 
  wcm -> body = val ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 549 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_lambda (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_Lambda * lam ; 
  Letrec_Check_Frame * new_frame ; 
  Scheme_Object * val ; 
  int num_params ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(lam, 1), PUSH(new_frame, 2), PUSH(pos, 3), PUSH(frame, 4), PUSH(val, 5)));
# define XfOrM63_COUNT (6)
# define SETUP_XfOrM63(x) SETUP(XfOrM63_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  lam = NULLED_OUT ; 
  new_frame = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 556 "bc/src/letrec_check.c"
  lam = (Scheme_Lambda * ) o ; 


  if (((pos ) ) == (scheme_false ) )  {
#   define XfOrM71_COUNT (0+XfOrM63_COUNT)
#   define SETUP_XfOrM71(x) SETUP_XfOrM63(x)

# 560 "bc/src/letrec_check.c"
    num_params = lam -> num_params ; 
    new_frame = FUNCCALL(SETUP_XfOrM71(_), init_letrec_check_frame (4 , 2 , num_params , frame , ((void * ) 0 ) , ((void * ) 0 ) , lam ) )

    ; 

    ((num_params >= 0 ) ? 1 : (FUNCCALL_EMPTY(scheme_signal_error ("lambda has negative arguments what do" ) ), 0 ) ) ; 

    val = FUNCCALL(SETUP_XfOrM71(_), letrec_check_expr (lam -> body , new_frame , pos ) ); 
    lam -> body = val ; 
  }

# 569 "bc/src/letrec_check.c"
  else {


    Scheme_Deferred_Expr * clos ; 
    Letrec_Check_Frame * outer_frame = ((void * ) 0 ) ; 
    BLOCK_SETUP((PUSH(outer_frame, 0+XfOrM63_COUNT), PUSH(clos, 1+XfOrM63_COUNT)));
#   define XfOrM64_COUNT (2+XfOrM63_COUNT)
#   define SETUP_XfOrM64(x) SETUP(XfOrM64_COUNT)
    clos = NULLED_OUT ; 


    outer_frame = FUNCCALL(SETUP_XfOrM64(_), get_nearest_rhs (frame ) ); 
    clos = FUNCCALL_AGAIN(make_deferred_expr_closure ((Scheme_Object * ) lam , frame ) ); 

    while ((((intptr_t ) (pos ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (pos ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pos ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      int position ; 
#     define XfOrM68_COUNT (0+XfOrM64_COUNT)
#     define SETUP_XfOrM68(x) SETUP_XfOrM64(x)

# 586 "bc/src/letrec_check.c"
      if (((intptr_t ) (pos ) ) & 0x1 )  {
        position = (((intptr_t ) (pos ) ) >> 1 ) ; 
        pos = scheme_null ; 
      }

# 589 "bc/src/letrec_check.c"
      else {
        position = (((intptr_t ) ((((Scheme_Simple_Object * ) (pos ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
        pos = (((Scheme_Simple_Object * ) (pos ) ) -> u . pair_val . cdr ) ; 
      }
      FUNCCALL(SETUP_XfOrM68(_), update_frame (outer_frame , frame , position , clos ) )


      ; 
    }
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 603 "bc/src/letrec_check.c"
static void letrec_check_deferred_expr (Scheme_Object * o ) 
{
  Scheme_Deferred_Expr * clos ; 
  Scheme_Lambda * lam ; 
  Letrec_Check_Frame * inner , * new_frame ; 
  Scheme_Object * val ; 
  int num_params ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(lam, 0), PUSH(new_frame, 1), PUSH(clos, 2), PUSH(val, 3)));
# define XfOrM72_COUNT (4)
# define SETUP_XfOrM72(x) SETUP(XfOrM72_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  clos = NULLED_OUT ; 
  lam = NULLED_OUT ; 
  inner = NULLED_OUT ; 
  new_frame = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 613 "bc/src/letrec_check.c"
  clos = (Scheme_Deferred_Expr * ) o ; 

  if (clos -> done )
    RET_NOTHING ; 
  clos -> done = 1 ; 

  ((((Scheme_Type ) (((((intptr_t ) (clos ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clos ) ) -> type ) ) == (Scheme_Type ) (scheme_deferred_expr_type ) ) ) ? 1 : (FUNCCALL_EMPTY(scheme_signal_error ("letrec_check_deferred_expr: clos is not a scheme_deferred_expr" ) ), 0 ) ) 
  ; 

  if ((Scheme_Type ) (((((intptr_t ) (clos -> expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clos -> expr ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_lambda_type ) )  {
#   define XfOrM74_COUNT (0+XfOrM72_COUNT)
#   define SETUP_XfOrM74(x) SETUP_XfOrM72(x)

# 623 "bc/src/letrec_check.c"
    lam = (Scheme_Lambda * ) clos -> expr ; 

    inner = clos -> frame ; 

    num_params = lam -> num_params ; 

    new_frame = FUNCCALL(SETUP_XfOrM74(_), init_letrec_check_frame (4 , 2 , num_params , inner , ((void * ) 0 ) , ((void * ) 0 ) , lam ) )

    ; 

    val = FUNCCALL_AGAIN(letrec_check_expr (lam -> body , new_frame , scheme_false ) ); 
    lam -> body = val ; 
  }

# 635 "bc/src/letrec_check.c"
  else {
#   define XfOrM73_COUNT (0+XfOrM72_COUNT)
#   define SETUP_XfOrM73(x) SETUP_XfOrM72(x)
    FUNCCALL_EMPTY(letrec_check_expr (clos -> expr , clos -> frame , scheme_false ) )
# 636 "bc/src/letrec_check.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 640 "bc/src/letrec_check.c"
static void clean_dead_deferred_expr (Scheme_Deferred_Expr * clos ) 
{
  /* No conversion */

# 642 "bc/src/letrec_check.c"
  Scheme_Lambda * lam ; 






  while (clos ) {
    ((((Scheme_Type ) (((((intptr_t ) (clos ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clos ) ) -> type ) ) == (Scheme_Type ) (scheme_deferred_expr_type ) ) ) ? 1 : (scheme_signal_error ("letrec_check_deferred_expr: clos is not a scheme_deferred_expr" ) , 0 ) ) 
    ; 

    if (! clos -> done ) {
      if ((Scheme_Type ) (((((intptr_t ) (clos -> expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clos -> expr ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_lambda_type ) )  {
        lam = (Scheme_Lambda * ) clos -> expr ; 
        ((((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_lambda_type ) ) ) ? 1 : (scheme_signal_error ("deferred expression does not contain a lambda" ) , 0 ) ) 
        ; 


        lam -> body = scheme_void ; 
      }

      clos -> done = 1 ; 
    }

    clos = clos -> chain_next ; 
  }
}


static void process_deferred_bindings (Letrec_Check_Frame * frame , int position ) 
{
  Scheme_Object * ls ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ls, 0)));
# define XfOrM82_COUNT (1)
# define SETUP_XfOrM82(x) SETUP(XfOrM82_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ls = NULLED_OUT ; 

# 675 "bc/src/letrec_check.c"
  if (frame -> def && ! ((frame -> def [position ] ) == (scheme_null ) ) ) {
#   define XfOrM83_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM83(x) SETUP_XfOrM82(x)

# 676 "bc/src/letrec_check.c"
    ls = frame -> def [position ] ; 
    frame -> def [position ] = scheme_null ; 
    while (! ((ls ) == (scheme_null ) ) ) {
#     define XfOrM85_COUNT (0+XfOrM83_COUNT)
#     define SETUP_XfOrM85(x) SETUP_XfOrM83(x)
      FUNCCALL(SETUP_XfOrM85(_), letrec_check_deferred_expr ((((Scheme_Simple_Object * ) (ls ) ) -> u . pair_val . car ) ) )
# 679 "bc/src/letrec_check.c"
      ; 
      ls = (((Scheme_Simple_Object * ) (ls ) ) -> u . pair_val . cdr ) ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 685 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_lets (Scheme_Object * o , Letrec_Check_Frame * old_frame , Scheme_Object * pos ) 
{
  Letrec_Check_Frame * frame , * body_frame ; 
  Scheme_IR_Let_Value * irlv ; 
  Scheme_Object * body , * val ; 
  int i , j , k ; 




  Scheme_IR_Let_Header * head = (Scheme_IR_Let_Header * ) o ; 


  int num_clauses = head -> num_clauses ; 



  int count = head -> count ; 


  int header_flags = (& head -> iso ) -> so . keyex ; 


  int frame_type ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(body, 0), PUSH(old_frame, 1), PUSH(frame, 2), PUSH(irlv, 3), PUSH(val, 4), PUSH(o, 5), PUSH(pos, 6), PUSH(body_frame, 7), PUSH(head, 8)));
# define XfOrM86_COUNT (9)
# define SETUP_XfOrM86(x) SETUP(XfOrM86_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  frame = NULLED_OUT ; 
  body_frame = NULLED_OUT ; 
  irlv = NULLED_OUT ; 
  body = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 710 "bc/src/letrec_check.c"
  if (header_flags & 0x1 )
    frame_type = 1 ; 
  else 
  frame_type = 3 ; 




  frame = FUNCCALL(SETUP_XfOrM86(_), init_letrec_check_frame (frame_type , 1 , count , old_frame , ((void * ) 0 ) , head , ((void * ) 0 ) ) )

  ; 

  body = head -> body ; 

  k = 0 ; 


  irlv = ((void * ) 0 ) ; 
  for (i = num_clauses ; i -- ; ) {
#   define XfOrM97_COUNT (0+XfOrM86_COUNT)
#   define SETUP_XfOrM97(x) SETUP_XfOrM86(x)

# 729 "bc/src/letrec_check.c"
    irlv = (Scheme_IR_Let_Value * ) body ; 

    if (irlv -> count == 0 ) {
#     define XfOrM106_COUNT (0+XfOrM97_COUNT)
#     define SETUP_XfOrM106(x) SETUP_XfOrM97(x)

# 732 "bc/src/letrec_check.c"
      val = FUNCCALL(SETUP_XfOrM106(_), letrec_check_expr (irlv -> value , frame , scheme_null ) )



      ; 
    }

# 737 "bc/src/letrec_check.c"
    else {
      Scheme_Object * new_pos ; 
      BLOCK_SETUP((PUSH(new_pos, 0+XfOrM97_COUNT)));
#     define XfOrM101_COUNT (1+XfOrM97_COUNT)
#     define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
      new_pos = NULLED_OUT ; 

# 740 "bc/src/letrec_check.c"
      if (irlv -> count == 1 ) {


        new_pos = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (k ) ) ) << 1 ) | 0x1 ) ) ; 
      }

# 744 "bc/src/letrec_check.c"
      else {




        int sub ; 
#       define XfOrM102_COUNT (0+XfOrM101_COUNT)
#       define SETUP_XfOrM102(x) SETUP_XfOrM101(x)

# 750 "bc/src/letrec_check.c"
        new_pos = scheme_null ; 
        for (sub = irlv -> count ; sub -- ; ) {
#         define XfOrM104_COUNT (0+XfOrM102_COUNT)
#         define SETUP_XfOrM104(x) SETUP_XfOrM102(x)

# 752 "bc/src/letrec_check.c"
          new_pos = FUNCCALL(SETUP_XfOrM104(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (k + sub ) ) ) << 1 ) | 0x1 ) ) , new_pos ) ); 
        }
      }

      val = FUNCCALL(SETUP_XfOrM101(_), letrec_check_expr (irlv -> value , frame , new_pos ) ); 
    }

    if (frame_type == 1 ) {
      for (j = 0 ; j < irlv -> count ; j ++ ) {
        frame -> ref [j + k ] |= (0x1 << 1 ) ; 
      }
    }

    k += irlv -> count ; 

    irlv -> value = val ; 

    body = irlv -> body ; 
  }





  body_frame = FUNCCALL(SETUP_XfOrM86(_), init_letrec_check_frame (frame_type , 2 , count , old_frame , frame , head , ((void * ) 0 ) ) )

  ; 

  val = FUNCCALL(SETUP_XfOrM86(_), letrec_check_expr (body , body_frame , pos ) ); 




  if (num_clauses > 0 )
    irlv -> body = val ; 
  else 
  head -> body = val ; 
  FUNCCALL(SETUP_XfOrM86(_), letrec_check_lets_resume (frame , head ) )
  ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 797 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_define_values (Scheme_Object * lam , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(lam, 0)));
# define XfOrM107_COUNT (1)
# define SETUP_XfOrM107(x) SETUP(XfOrM107_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 799 "bc/src/letrec_check.c"
  if ((((Scheme_Vector * ) (lam ) ) -> size ) <= 1 )
    RET_VALUE_START (lam ) RET_VALUE_END ; 
  else {
    Scheme_Object * val = (((Scheme_Vector * ) (lam ) ) -> els ) [0 ] ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM107_COUNT)));
#   define XfOrM108_COUNT (1+XfOrM107_COUNT)
#   define SETUP_XfOrM108(x) SETUP(XfOrM108_COUNT)

# 804 "bc/src/letrec_check.c"
    val = FUNCCALL(SETUP_XfOrM108(_), letrec_check_expr (val , frame , pos ) ); 

    (((Scheme_Vector * ) (lam ) ) -> els ) [0 ] = val ; 
  }

  RET_VALUE_START (lam ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 812 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_ref (Scheme_Object * lam , Letrec_Check_Frame * frame , Wrapped_Lhs * lhs ) 
{
  /* No conversion */

# 814 "bc/src/letrec_check.c"
  return lam ; 
}

static Scheme_Object * letrec_check_set (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_Set_Bang * sb ; 
  Scheme_Object * val , * rhs_pos ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(sb, 1), PUSH(frame, 2), PUSH(val, 3)));
# define XfOrM110_COUNT (4)
# define SETUP_XfOrM110(x) SETUP(XfOrM110_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  sb = NULLED_OUT ; 
  val = NULLED_OUT ; 
  rhs_pos = NULLED_OUT ; 

# 822 "bc/src/letrec_check.c"
  sb = (Scheme_Set_Bang * ) o ; 
  val = sb -> val ; 



  rhs_pos = scheme_false ; 

  val = FUNCCALL(SETUP_XfOrM110(_), letrec_check_expr (val , frame , rhs_pos ) ); 
  sb -> val = val ; 

  if ((Scheme_Type ) (((((intptr_t ) (sb -> var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sb -> var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_local_type ) )  {

    Letrec_Check_Frame * in_frame ; 
    int position ; 
    BLOCK_SETUP((PUSH(in_frame, 0+XfOrM110_COUNT)));
#   define XfOrM111_COUNT (1+XfOrM110_COUNT)
#   define SETUP_XfOrM111(x) SETUP(XfOrM111_COUNT)
    in_frame = NULLED_OUT ; 

# 837 "bc/src/letrec_check.c"
    in_frame = FUNCCALL(SETUP_XfOrM111(_), get_relative_frame (& position , (Scheme_IR_Local * ) sb -> var ) ); 

    if (in_frame -> ref 
    && ! (in_frame -> ref [position ] & (0x1 << 1 ) ) ) {

      Scheme_App3_Rec * app3 ; 
      Scheme_Object * name ; 
      Scheme_Sequence * seq ; 
      Scheme_IR_Let_Header * head ; 
      Scheme_IR_Let_Value * lv ; 
      Scheme_IR_Local * var , * * vars ; 
      BLOCK_SETUP((PUSH(seq, 0+XfOrM111_COUNT), PUSH(var, 1+XfOrM111_COUNT), PUSH(name, 2+XfOrM111_COUNT), PUSH(head, 3+XfOrM111_COUNT), PUSH(app3, 4+XfOrM111_COUNT), PUSH(vars, 5+XfOrM111_COUNT), PUSH(lv, 6+XfOrM111_COUNT)));
#     define XfOrM112_COUNT (7+XfOrM111_COUNT)
#     define SETUP_XfOrM112(x) SETUP(XfOrM112_COUNT)
      app3 = NULLED_OUT ; 
      name = NULLED_OUT ; 
      seq = NULLED_OUT ; 
      head = NULLED_OUT ; 
      lv = NULLED_OUT ; 
      var = NULLED_OUT ; 
      vars = NULLED_OUT ; 


      name = FUNCCALL(SETUP_XfOrM112(_), record_checked ((Scheme_IR_Local * ) sb -> var , frame ) ); 

      app3 = ((Scheme_App3_Rec * ) FUNCCALL(SETUP_XfOrM112(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App3_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      app3 -> iso . so . type = scheme_application3_type ; 
      app3 -> rator = scheme_check_assign_not_undefined_proc ; 
      app3 -> rand1 = sb -> var ; 
      app3 -> rand2 = name ; 

      seq = FUNCCALL(SETUP_XfOrM112(_), scheme_malloc_sequence (2 ) ); 
      seq -> so . type = scheme_sequence_type ; 
      seq -> count = 2 ; 
      seq -> array [0 ] = (Scheme_Object * ) app3 ; 
      seq -> array [1 ] = (Scheme_Object * ) sb ; 

      if (((((intptr_t ) (sb -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sb -> val ) ) -> type ) > _scheme_ir_values_types_ ) {

        RET_VALUE_START ((Scheme_Object * ) seq ) RET_VALUE_END ; 
      }

# 877 "bc/src/letrec_check.c"
      else {
#       define XfOrM113_COUNT (0+XfOrM112_COUNT)
#       define SETUP_XfOrM113(x) SETUP_XfOrM112(x)

# 878 "bc/src/letrec_check.c"
        var = (__funcarg58 = FUNCCALL(SETUP_XfOrM113(_), scheme_intern_symbol ("tmp" ) ), FUNCCALL_AGAIN(scheme_make_ir_local (__funcarg58 ) )) ; 
        vars = ((Scheme_IR_Local * * ) FUNCCALL(SETUP_XfOrM113(_), GC_malloc (sizeof (Scheme_IR_Local * ) * (1 ) ) )) ; 
        vars [0 ] = var ; 
        var -> use_count = 1 ; 
        var -> non_app_count = 1 ; 

        lv = ((Scheme_IR_Let_Value * ) FUNCCALL(SETUP_XfOrM113(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Let_Value ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        lv -> iso . so . type = scheme_ir_let_value_type ; 
        lv -> count = 1 ; 
        lv -> value = sb -> val ; 
        lv -> body = (Scheme_Object * ) seq ; 
        lv -> vars = vars ; 

        head = ((Scheme_IR_Let_Header * ) FUNCCALL(SETUP_XfOrM113(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Let_Header ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        head -> iso . so . type = scheme_ir_let_header_type ; 
        head -> count = 1 ; 
        head -> num_clauses = 1 ; 
        head -> body = (Scheme_Object * ) lv ; 

        sb -> val = (Scheme_Object * ) var ; 

        RET_VALUE_START ((Scheme_Object * ) head ) RET_VALUE_END ; 
      }
    }
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 907 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_case_lambda (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_Case_Lambda * cl ; 
  Scheme_Object * val ; 
  int i , n ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(cl, 0), PUSH(pos, 1), PUSH(o, 2), PUSH(frame, 3), PUSH(val, 4)));
# define XfOrM115_COUNT (5)
# define SETUP_XfOrM115(x) SETUP(XfOrM115_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cl = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 913 "bc/src/letrec_check.c"
  cl = (Scheme_Case_Lambda * ) o ; 

  n = cl -> count ; 
  for (i = 0 ; i < n ; i ++ ) {
#   define XfOrM117_COUNT (0+XfOrM115_COUNT)
#   define SETUP_XfOrM117(x) SETUP_XfOrM115(x)

# 917 "bc/src/letrec_check.c"
    val = FUNCCALL(SETUP_XfOrM117(_), letrec_check_expr (cl -> array [i ] , frame , pos ) ); 
    cl -> array [i ] = val ; 
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 924 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_begin0 (Scheme_Object * o , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  int i , n ; 
  Scheme_Sequence * seq ; 
  Scheme_Object * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(seq, 1), PUSH(pos, 2), PUSH(frame, 3), PUSH(val, 4)));
# define XfOrM118_COUNT (5)
# define SETUP_XfOrM118(x) SETUP(XfOrM118_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  seq = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 930 "bc/src/letrec_check.c"
  seq = (Scheme_Sequence * ) o ; 

  n = seq -> count ; 
  for (i = 0 ; i < n ; i ++ ) {
#   define XfOrM120_COUNT (0+XfOrM118_COUNT)
#   define SETUP_XfOrM120(x) SETUP_XfOrM118(x)

# 934 "bc/src/letrec_check.c"
    val = FUNCCALL(SETUP_XfOrM120(_), letrec_check_expr (seq -> array [i ] , frame , pos ) ); 
    seq -> array [i ] = val ; 
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 941 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_apply_values (Scheme_Object * lam , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  Scheme_Object * f , * e ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(lam, 0), PUSH(pos, 1), PUSH(e, 2), PUSH(frame, 3), PUSH(f, 4)));
# define XfOrM121_COUNT (5)
# define SETUP_XfOrM121(x) SETUP(XfOrM121_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  f = NULLED_OUT ; 
  e = NULLED_OUT ; 

# 945 "bc/src/letrec_check.c"
  f = (((Scheme_Simple_Object * ) (lam ) ) -> u . two_ptr_val . ptr1 ) ; 
  e = (((Scheme_Simple_Object * ) (lam ) ) -> u . two_ptr_val . ptr2 ) ; 

  f = FUNCCALL(SETUP_XfOrM121(_), letrec_check_expr (f , frame , pos ) ); 
  e = FUNCCALL_AGAIN(letrec_check_expr (e , frame , pos ) ); 

  (((Scheme_Simple_Object * ) (lam ) ) -> u . two_ptr_val . ptr1 ) = f ; 
  (((Scheme_Simple_Object * ) (lam ) ) -> u . two_ptr_val . ptr2 ) = e ; 

  RET_VALUE_START (lam ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 957 "bc/src/letrec_check.c"
static Scheme_Object * letrec_check_k (void ) 
{
  /* No conversion */

# 959 "bc/src/letrec_check.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * expr = (Scheme_Object * ) p -> ku . k . p1 ; 
  Letrec_Check_Frame * frame = (Letrec_Check_Frame * ) p -> ku . k . p2 ; 
  Scheme_Object * pos = (Scheme_Object * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return letrec_check_expr (expr , frame , pos ) ; 
}

static Scheme_Object * letrec_check_expr (Scheme_Object * expr , Letrec_Check_Frame * frame , Scheme_Object * pos ) 
{
  int type ; 

# 24 "bc/src/mzstkchk.h"
  uintptr_t _stk_pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(pos, 0), PUSH(frame, 1), PUSH(expr, 2)));
# define XfOrM123_COUNT (3)
# define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 26 "bc/src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 977 "bc/src/letrec_check.c"
  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM127_COUNT (0+XfOrM123_COUNT)
#   define SETUP_XfOrM127(x) SETUP_XfOrM123(x)

# 980 "bc/src/letrec_check.c"
    p -> ku . k . p1 = (void * ) expr ; 
    p -> ku . k . p2 = (void * ) frame ; 
    p -> ku . k . p3 = (void * ) pos ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (letrec_check_k ) )) RET_VALUE_EMPTY_END ; 
  }


  type = ((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ; 

  {
#   define XfOrM125_COUNT (0+XfOrM123_COUNT)
#   define SETUP_XfOrM125(x) SETUP_XfOrM123(x)

# 990 "bc/src/letrec_check.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM126_COUNT (0+XfOrM125_COUNT)
#     define SETUP_XfOrM126(x) SETUP_XfOrM125(x)
      FUNCCALL(SETUP_XfOrM126(_), scheme_out_of_fuel () )
# 990 "bc/src/letrec_check.c"
      ; 
    }
  }

# 990 "bc/src/letrec_check.c"
  ; 

  switch (type ) {
#   define XfOrM124_COUNT (0+XfOrM123_COUNT)
#   define SETUP_XfOrM124(x) SETUP_XfOrM123(x)

# 993 "bc/src/letrec_check.c"
    case scheme_ir_local_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_local (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_application_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_application (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_application2_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_application2 (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_application3_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_application3 (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_sequence_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_sequence (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_branch_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_branch (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_with_cont_mark_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_wcm (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_ir_lambda_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_lambda (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_ir_let_header_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_lets (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_ir_toplevel_type : 
    RET_VALUE_START (expr ) RET_VALUE_END ; 
    case scheme_variable_type : FUNCCALL_EMPTY(scheme_signal_error ("got top-level in wrong place" ) )
    ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
    case scheme_define_values_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_define_values (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_varref_form_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_ref (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_set_bang_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_set (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_case_lambda_sequence_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_case_lambda (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_begin0_sequence_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_begin0 (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_apply_values_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_check_apply_values (expr , frame , pos ) )) RET_VALUE_EMPTY_END ; 
    case scheme_with_immed_mark_type : FUNCCALL_EMPTY(scheme_signal_error ("internal error: with-immediate-mark not expected before optimization" ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    default : 
    RET_VALUE_START (expr ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1036 "bc/src/letrec_check.c"
Scheme_Linklet * scheme_letrec_check_linklet (Scheme_Linklet * linklet ) 
{
  int i , cnt ; 
  Scheme_Object * val ; 
  Scheme_Object * init_pos = scheme_false ; 
  Letrec_Check_Frame * frame ; 
  DECL_RET_SAVE (Scheme_Linklet * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(init_pos, 0), PUSH(linklet, 1), PUSH(frame, 2), PUSH(val, 3)));
# define XfOrM128_COUNT (4)
# define SETUP_XfOrM128(x) SETUP(XfOrM128_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  val = NULLED_OUT ; 
  frame = NULLED_OUT ; 

# 1043 "bc/src/letrec_check.c"
  frame = FUNCCALL(SETUP_XfOrM128(_), init_letrec_check_frame (5 , 2 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )

  ; 









  cnt = (((Scheme_Vector * ) (linklet -> bodies ) ) -> size ) ; 
  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM130_COUNT (0+XfOrM128_COUNT)
#   define SETUP_XfOrM130(x) SETUP_XfOrM128(x)

# 1057 "bc/src/letrec_check.c"
    val = (((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] ; 
    val = FUNCCALL(SETUP_XfOrM130(_), letrec_check_expr (val , frame , init_pos ) ); 
    (((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] = val ; 
  }
  FUNCCALL(SETUP_XfOrM128(_), clean_dead_deferred_expr (* frame -> deferred_chain ) )
  ; 

  RET_VALUE_START (linklet ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "bc/src/mzmark_letrec_check.inc"
static int mark_letrec_check_frame_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_letrec_check_frame_MARK (void * p , struct NewGC * gc ) {

  Letrec_Check_Frame * frame = (Letrec_Check_Frame * ) p ; 

  GC_mark2 (& (frame -> def ) , gc ) ; 
  GC_mark2 (& (frame -> next ) , gc ) ; 
  GC_mark2 (& (frame -> ref ) , gc ) ; 
  GC_mark2 (& (frame -> deferred_chain ) , gc ) ; 


  return 0 ; 
}






static int mark_letrec_check_frame_FIXUP (void * p , struct NewGC * gc ) {

  Letrec_Check_Frame * frame = (Letrec_Check_Frame * ) p ; 

  GC_fixup2 (& (frame -> def ) , gc ) ; 
  GC_fixup2 (& (frame -> next ) , gc ) ; 
  GC_fixup2 (& (frame -> ref ) , gc ) ; 
  GC_fixup2 (& (frame -> deferred_chain ) , gc ) ; 


  return 0 ; 
}

# 51 "bc/src/mzmark_letrec_check.inc"
static int mark_scheme_deferred_expr_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_scheme_deferred_expr_MARK (void * p , struct NewGC * gc ) {

  Scheme_Deferred_Expr * clos = (Scheme_Deferred_Expr * ) p ; 

  GC_mark2 (& (clos -> expr ) , gc ) ; 
  GC_mark2 (& (clos -> frame ) , gc ) ; 
  GC_mark2 (& (clos -> chain_next ) , gc ) ; 


  return 0 ; 
}






static int mark_scheme_deferred_expr_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Deferred_Expr * clos = (Scheme_Deferred_Expr * ) p ; 

  GC_fixup2 (& (clos -> expr ) , gc ) ; 
  GC_fixup2 (& (clos -> frame ) , gc ) ; 
  GC_fixup2 (& (clos -> chain_next ) , gc ) ; 


  return 0 ; 
}

# 1077 "bc/src/letrec_check.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_letrec_check_frame , mark_letrec_check_frame_SIZE , mark_letrec_check_frame_MARK , mark_letrec_check_frame_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_deferred_expr_type , mark_scheme_deferred_expr_SIZE , mark_scheme_deferred_expr_MARK , mark_scheme_deferred_expr_FIXUP , 1 , 0 ) ; 
}
