#include "precomp.h"

# 4 "bc/src/linklet.c"
Scheme_Object * scheme_varref_const_p_proc ; 
Scheme_Object * scheme_varref_unsafe_p_proc ; 

Scheme_Hash_Tree * empty_hash_tree ; 

static int validate_compile_result = 0 ; 
static int recompile_every_compile = 0 ; 
static int show_linklets = 0 ; 

static Scheme_Object * serializable_symbol ; 
static Scheme_Object * unsafe_symbol ; 
static Scheme_Object * static_symbol ; 
static Scheme_Object * use_prompt_symbol ; 
static Scheme_Object * uninterned_literal_symbol ; 
static Scheme_Object * quick_symbol ; 
static Scheme_Object * constant_symbol ; 
static Scheme_Object * consistent_symbol ; 
static Scheme_Object * noncm_symbol ; 
static Scheme_Object * immediate_symbol ; 
static Scheme_Object * omitable_symbol ; 
static Scheme_Object * folding_symbol ; 

; 
; 
; 
; 

static Scheme_Object * primitive_table (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * primitive_to_position (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * position_to_primitive (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * primitive_in_category_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * primitive_lookup (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * linklet_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * compile_linklet (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * recompile_linklet (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * eval_linklet (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * instantiate_linklet (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * linklet_import_variables (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * linklet_export_variables (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * linklet_vm_bytes (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * write_linklet_bundle_hash (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * read_linklet_bundle_hash (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * instance_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * make_instance (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * instance_name (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * instance_data (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * instance_variable_names (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * instance_variable_value (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * instance_set_variable_value (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * instance_unset_variable (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * instance_describe_variable (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * variable_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * variable_instance (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * variable_const_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * variable_unsafe_p (int argc , Scheme_Object * * argv ) ; 

static Scheme_Linklet * compile_and_or_optimize_linklet (Scheme_Object * form , Scheme_Linklet * linklet , 
Scheme_Object * name , 
Scheme_Object * * _import_keys , 
Scheme_Object * get_import , 
int unsafe_mode , int static_mode , int serializable ) ; 

static Scheme_Object * _instantiate_linklet_multi (Scheme_Linklet * linklet , Scheme_Instance * instance , 
int num_instances , Scheme_Instance * * instances , 
int use_prompt ) ; 

static Scheme_Hash_Tree * push_prefix (Scheme_Linklet * linklet , Scheme_Instance * instance , 
int num_instances , Scheme_Instance * * instances , 
Scheme_Hash_Tree * source_names ) ; 
static void pop_prefix () ; 
static Scheme_Object * suspend_prefix () ; 
static void resume_prefix (Scheme_Object * v ) ; 

static Scheme_Bucket * make_bucket (Scheme_Object * key , Scheme_Object * val , Scheme_Instance * inst ) ; 


static void mark_pruned_prefixes (struct NewGC * gc ) ; 
static int check_pruned_prefix (void * p ) ; 



static void register_traversers (void ) ; 






void scheme_init_linklet (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM1_COUNT (1)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  FUNCCALL(SETUP_XfOrM1(_), register_traversers () )
# 99 "bc/src/linklet.c"
  ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & serializable_symbol , sizeof (serializable_symbol ) ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unsafe_symbol , sizeof (unsafe_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & static_symbol , sizeof (static_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & use_prompt_symbol , sizeof (use_prompt_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & uninterned_literal_symbol , sizeof (uninterned_literal_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & quick_symbol , sizeof (quick_symbol ) ) ); 
  serializable_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("serializable" ) ); 
  unsafe_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unsafe" ) ); 
  static_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("static" ) ); 
  use_prompt_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("use-prompt" ) ); 
  uninterned_literal_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("uninterned-literal" ) ); 
  quick_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("quick" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & constant_symbol , sizeof (constant_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & consistent_symbol , sizeof (consistent_symbol ) ) ); 
  constant_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("constant" ) ); 
  consistent_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("consistent" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & noncm_symbol , sizeof (noncm_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & immediate_symbol , sizeof (immediate_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & omitable_symbol , sizeof (omitable_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & folding_symbol , sizeof (folding_symbol ) ) ); 
  noncm_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("noncm" ) ); 
  immediate_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("immediate" ) ); 
  omitable_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("omitable" ) ); 
  folding_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("folding" ) ); 
  FUNCCALL_AGAIN(scheme_switch_prim_instance (env , "#%linklet" ) )
  ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (primitive_to_position , "primitive->compiled-position" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive->compiled-position" , __funcarg81 , env ) )) ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (position_to_primitive , "compiled-position->primitive" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("compiled-position->primitive" , __funcarg80 , env ) )) ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (primitive_in_category_p , "primitive-in-category?" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive-in-category?" , __funcarg79 , env ) )) ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (primitive_lookup , "primitive-lookup" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive-lookup" , __funcarg78 , env ) )) ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (linklet_p , "linklet?" , 1 , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("linklet?" , __funcarg77 , env ) )) ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_everything (compile_linklet , 1 , "compile-linklet" , 1 , 5 , 0 , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("compile-linklet" , __funcarg76 , env ) )) ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_everything (recompile_linklet , 1 , "recompile-linklet" , 1 , 5 , 0 , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("recompile-linklet" , __funcarg75 , env ) )) ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (eval_linklet , "eval-linklet" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("eval-linklet" , __funcarg74 , env ) )) ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_everything (instantiate_linklet , 1 , "instantiate-linklet" , 2 , 4 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("instantiate-linklet" , __funcarg73 , env ) )) ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (linklet_import_variables , "linklet-import-variables" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("linklet-import-variables" , __funcarg72 , env ) )) ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (linklet_export_variables , "linklet-export-variables" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("linklet-export-variables" , __funcarg71 , env ) )) ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (linklet_vm_bytes , "linklet-virtual-machine-bytes" , 0 , 0 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("linklet-virtual-machine-bytes" , __funcarg70 , env ) )) ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (write_linklet_bundle_hash , "write-linklet-bundle-hash" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-linklet-bundle-hash" , __funcarg69 , env ) )) ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (read_linklet_bundle_hash , "read-linklet-bundle-hash" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-linklet-bundle-hash" , __funcarg68 , env ) )) ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (instance_p , "instance?" , 1 , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("instance?" , __funcarg67 , env ) )) ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_instance , "make-instance" , 1 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-instance" , __funcarg66 , env ) )) ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (instance_name , "instance-name" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("instance-name" , __funcarg65 , env ) )) ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (instance_data , "instance-data" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("instance-data" , __funcarg64 , env ) )) ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (instance_variable_names , "instance-variable-names" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("instance-variable-names" , __funcarg63 , env ) )) ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_everything (instance_variable_value , 1 , "instance-variable-value" , 2 , 3 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("instance-variable-value" , __funcarg62 , env ) )) ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (instance_set_variable_value , "instance-set-variable-value!" , 3 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("instance-set-variable-value!" , __funcarg61 , env ) )) ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (instance_unset_variable , "instance-unset-variable!" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("instance-unset-variable!" , __funcarg60 , env ) )) ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (instance_describe_variable , "instance-describe-variable!" , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("instance-describe-variable!" , __funcarg59 , env ) )) ; 

  do {

# 158 "bc/src/linklet.c"
    Scheme_Object * p ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM1_COUNT)));
#   define XfOrM8_COUNT (1+XfOrM1_COUNT)
#   define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
    p = NULLED_OUT ; 

# 158 "bc/src/linklet.c"
    p = FUNCCALL(SETUP_XfOrM8(_), scheme_make_folding_prim (variable_p , "variable-reference?" , 1 , 1 , 1 ) ); 

# 158 "bc/src/linklet.c"
    (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
    FUNCCALL(SETUP_XfOrM8(_), scheme_addto_prim_instance ("variable-reference?" , p , env ) )
# 158 "bc/src/linklet.c"
    ; 
  }

# 158 "bc/src/linklet.c"
  while (0 ) ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (variable_instance , "variable-reference->instance" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("variable-reference->instance" , __funcarg58 , env ) )) ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_varref_const_p_proc , sizeof (scheme_varref_const_p_proc ) ) )
  ; 
  scheme_varref_const_p_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (variable_const_p , "variable-reference-constant?" , 1 , 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("variable-reference-constant?" , scheme_varref_const_p_proc , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_varref_unsafe_p_proc , sizeof (scheme_varref_unsafe_p_proc ) ) )
  ; 
  scheme_varref_unsafe_p_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (variable_unsafe_p , "variable-reference-from-unsafe?" , 1 , 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("variable-reference-from-unsafe?" , scheme_varref_unsafe_p_proc , env ) ); 
  FUNCCALL_AGAIN(scheme_restore_prim_instance (env ) )
  ; 

  if (FUNCCALL(SETUP_XfOrM1(_), scheme_getenv ("PLT_VALIDATE_COMPILE" ) )) {



    validate_compile_result = 1 ; 
  }

  {

    const char * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM1_COUNT)));
#   define XfOrM2_COUNT (1+XfOrM1_COUNT)
#   define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
    s = NULLED_OUT ; 

# 185 "bc/src/linklet.c"
    s = FUNCCALL(SETUP_XfOrM2(_), scheme_getenv ("PLT_RECOMPILE_COMPILE" ) ); 
    if (s ) {
      int i = 0 ; 
      while ((s [i ] >= '0' ) && (s [i ] <= '9' ) ) {
        recompile_every_compile = (recompile_every_compile * 10 ) + (s [i ] - '0' ) ; 
        i ++ ; 
      }
      if (recompile_every_compile <= 0 )
        recompile_every_compile = 1 ; 
      else if (recompile_every_compile > 32 )
        recompile_every_compile = 32 ; 
    }
  }

  if (FUNCCALL_EMPTY(scheme_getenv ("PLT_LINKLET_SHOW" ) ))
    show_linklets = 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 203 "bc/src/linklet.c"
void scheme_init_unsafe_linklet (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM9_COUNT (1)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM9(_), register_traversers () )
# 206 "bc/src/linklet.c"
  ; 
  FUNCCALL(SETUP_XfOrM9(_), scheme_switch_prim_instance (env , "#%linklet" ) )

  ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM9(_), scheme_make_immed_prim (primitive_table , "primitive-table" , 1 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive-table" , __funcarg82 , env ) )) ; 
  FUNCCALL_EMPTY(scheme_restore_prim_instance (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 216 "bc/src/linklet.c"
void scheme_init_linklet_places (void ) 
{
  /* No conversion */
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prefix_finalize_ ) = (Scheme_Prefix * ) 0x1 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_inc_prefix_finalize_ ) = (Scheme_Prefix * ) 0x1 ; 
  GC_set_post_propagate_hook (mark_pruned_prefixes ) ; 
  GC_set_treat_as_incremental_mark (scheme_prefix_type , check_pruned_prefix ) ; 
}






static Scheme_Object * primitive_table (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Hash_Table * table ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(table, 0), PUSH(argv, 1)));
# define XfOrM11_COUNT (2)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  table = NULLED_OUT ; 

# 234 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("primitive-table" , "symbol?" , 0 , argc , argv ) ); 
  if ((argc > 1 ) && ! ((((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("primitive-table" , "(and/c hash? immutable?)" , 1 , argc , argv ) ); 

  table = (Scheme_Hash_Table * ) FUNCCALL(SETUP_XfOrM11(_), scheme_hash_get (scheme_startup_env -> primitive_tables , argv [0 ] ) ); 
  if (! table && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> local_primitive_tables_ ) )
    table = (Scheme_Hash_Table * ) FUNCCALL(SETUP_XfOrM11(_), scheme_hash_get (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> local_primitive_tables_ ) , argv [0 ] ) ); 

  if (! table ) {
#   define XfOrM12_COUNT (0+XfOrM11_COUNT)
#   define SETUP_XfOrM12(x) SETUP_XfOrM11(x)

# 244 "bc/src/linklet.c"
    if (argc > 1 ) {
#     define XfOrM13_COUNT (0+XfOrM12_COUNT)
#     define SETUP_XfOrM13(x) SETUP_XfOrM12(x)

# 245 "bc/src/linklet.c"
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> local_primitive_tables_ ) ) {
#       define XfOrM14_COUNT (0+XfOrM13_COUNT)
#       define SETUP_XfOrM14(x) SETUP_XfOrM13(x)
        FUNCCALL(SETUP_XfOrM14(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> local_primitive_tables_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> local_primitive_tables_ ) ) ) )
# 246 "bc/src/linklet.c"
        ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> local_primitive_tables_ ) = FUNCCALL(SETUP_XfOrM14(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      }
      FUNCCALL(SETUP_XfOrM13(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> local_primitive_tables_ ) , argv [0 ] , argv [1 ] ) ); 
    }

# 250 "bc/src/linklet.c"
    else 
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }

  if (argc < 2 )
    RET_VALUE_START ((Scheme_Object * ) table ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 260 "bc/src/linklet.c"
static Scheme_Object * primitive_to_position (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pos, 0)));
# define XfOrM15_COUNT (1)
# define SETUP_XfOrM15(x) SETUP(XfOrM15_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pos = NULLED_OUT ; 

# 263 "bc/src/linklet.c"
  pos = FUNCCALL(SETUP_XfOrM15(_), scheme_hash_get (scheme_startup_env -> primitive_ids_table , argv [0 ] ) ); 
  RET_VALUE_START ((pos ? pos : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 267 "bc/src/linklet.c"
static Scheme_Object * position_to_primitive (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM16_COUNT (1)
# define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 270 "bc/src/linklet.c"
  if ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((intptr_t ) (argv [0 ] ) ) >> 1 ) >= 0 ) )
    v = FUNCCALL(SETUP_XfOrM16(_), scheme_position_to_builtin ((((intptr_t ) (argv [0 ] ) ) >> 1 ) ) ); 
  else 
  v = ((void * ) 0 ) ; 
  RET_VALUE_START ((v ? v : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 277 "bc/src/linklet.c"
static Scheme_Object * primitive_in_category_p (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * v , * cat ; 
  int r ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cat, 0), PUSH(v, 1)));
# define XfOrM17_COUNT (2)
# define SETUP_XfOrM17(x) SETUP(XfOrM17_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  cat = NULLED_OUT ; 

# 282 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("primitive-in-category?" , "symbol?" , 0 , argc , argv ) ); 
  cat = argv [1 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (cat ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cat ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("primitive-in-category?" , "symbol?" , 1 , argc , argv ) ); 

  v = FUNCCALL(SETUP_XfOrM17(_), scheme_hash_get (scheme_startup_env -> all_primitives_table , argv [0 ] ) ); 
  if (! v )
    r = 0 ; 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) )  {
    int opt = ((Scheme_Prim_Proc_Header * ) v ) -> flags & (1 | 2 ) ; 
    if ((cat ) == (noncm_symbol ) )  {
      r = (opt >= 1 ) ; 

      if (((Scheme_Prim_Proc_Header * ) v ) -> flags & 16 )
        r = 0 ; 
    }

# 298 "bc/src/linklet.c"
    else if ((cat ) == (immediate_symbol ) ) 
      r = (opt >= 2 ) ; 
    else if ((cat ) == (folding_symbol ) ) 
      r = (opt >= 3 ) ; 
    else if ((cat ) == (omitable_symbol ) ) 
      r = (scheme_prim_opt_flags [((((Scheme_Prim_Proc_Header * ) v ) -> flags ) >> 9 ) & ((1 << 7 ) - 1 ) ] & ((1 << 4 ) 
    | (1 << 5 ) 
    | (1 << 3 ) 
    | (1 << 8 ) ) ) ; 
    else 
    r = 0 ; 
  }

# 309 "bc/src/linklet.c"
  else 
  r = 0 ; 

  RET_VALUE_START ((r ? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 315 "bc/src/linklet.c"
static Scheme_Object * primitive_lookup (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM20_COUNT (1)
# define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 319 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("primitive-lookup" , "symbol?" , 0 , argc , argv ) ); 

  v = FUNCCALL(SETUP_XfOrM20(_), scheme_hash_get (scheme_startup_env -> all_primitives_table , argv [0 ] ) ); 

  RET_VALUE_START ((v ? v : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 327 "bc/src/linklet.c"
static Scheme_Object * linklet_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 329 "bc/src/linklet.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static void check_linklet_allowed (const char * who , Scheme_Linklet * linklet ) 
{
  /* No conversion */

# 336 "bc/src/linklet.c"
  if (linklet -> reject_eval ) {
    scheme_raise_exn (MZEXN_FAIL , 
    "%s: cannot use unsafe linklet loaded with non-original code inspector" , 
    who ) ; 
  }
}

void extract_import_info (const char * who , int argc , Scheme_Object * * argv , 
Scheme_Object * * _import_keys , Scheme_Object * * _get_import ) 
{
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(_get_import, 0), PUSH(_import_keys, 1), PUSH(who, 2), PUSH(argv, 3)));
# define XfOrM24_COUNT (4)
# define SETUP_XfOrM24(x) SETUP(XfOrM24_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 347 "bc/src/linklet.c"
  if (argc > 2 ) {
#   define XfOrM28_COUNT (0+XfOrM24_COUNT)
#   define SETUP_XfOrM28(x) SETUP_XfOrM24(x)

# 348 "bc/src/linklet.c"
    * _import_keys = argv [2 ] ; 
    if (((* _import_keys ) ) == (scheme_false ) ) 
      * _import_keys = ((void * ) 0 ) ; 
    else if (! ((Scheme_Type ) (((((intptr_t ) (* _import_keys ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (* _import_keys ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c vector? #f)" , 2 , argc , argv ) ); 
  }

# 353 "bc/src/linklet.c"
  else 
  * _import_keys = ((void * ) 0 ) ; 

  if (argc > 3 ) {
#   define XfOrM25_COUNT (0+XfOrM24_COUNT)
#   define SETUP_XfOrM25(x) SETUP_XfOrM24(x)
    FUNCCALL(SETUP_XfOrM25(_), scheme_check_proc_arity2 (who , 1 , 3 , argc , argv , 1 ) )
# 357 "bc/src/linklet.c"
    ; 
    if (! (((argv [3 ] ) ) == (scheme_false ) ) )  {
#     define XfOrM26_COUNT (0+XfOrM25_COUNT)
#     define SETUP_XfOrM26(x) SETUP_XfOrM25(x)

# 359 "bc/src/linklet.c"
      if (! * _import_keys ) {
#       define XfOrM27_COUNT (0+XfOrM26_COUNT)
#       define SETUP_XfOrM27(x) SETUP_XfOrM26(x)
        FUNCCALL_EMPTY(scheme_contract_error (who , "no vector supplied for import keys, but import-getting function provided;\n" " the function argument must be `#f` when the vector argument is `#f`" , "import-getting function" , 1 , argv [3 ] , ((void * ) 0 ) ) )

        ; 
      }
      * _get_import = argv [3 ] ; 
    }

# 367 "bc/src/linklet.c"
    else 
    * _get_import = ((void * ) 0 ) ; 
  }

# 369 "bc/src/linklet.c"
  else 
  * _get_import = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 373 "bc/src/linklet.c"
static void parse_compile_options (const char * who , int arg_pos , 
int argc , Scheme_Object * * argv , 
int * _unsafe , int * _static_mode , 
int * _serializable ) 
{
  /* No conversion */

# 378 "bc/src/linklet.c"
  Scheme_Object * redundant = ((void * ) 0 ) , * flag , * flags = argv [arg_pos ] ; 
  int serializable = 0 ; 
  int unsafe = * _unsafe ; 
  int static_mode = * _static_mode ; 
  int use_prompt_mode = 0 ; 
  int uninterned_literal_mode = 0 ; 
  int quick_mode = 0 ; 

  while (((Scheme_Type ) (((((intptr_t ) (flags ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (flags ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    flag = (((Scheme_Simple_Object * ) (flags ) ) -> u . pair_val . car ) ; 
    if ((flag ) == (serializable_symbol ) )  {
      if (serializable && ! redundant )
        redundant = flag ; 
      serializable = 1 ; 
    }

# 392 "bc/src/linklet.c"
    else if ((flag ) == (unsafe_symbol ) )  {
      if (unsafe && ! redundant )
        redundant = flag ; 
      unsafe = 1 ; 
    }

# 396 "bc/src/linklet.c"
    else if ((flag ) == (static_symbol ) )  {
      if (static_mode && ! redundant )
        redundant = flag ; 
      static_mode = 1 ; 
    }

# 400 "bc/src/linklet.c"
    else if ((flag ) == (use_prompt_symbol ) )  {
      if (use_prompt_mode && ! redundant )
        redundant = flag ; 
      use_prompt_mode = 1 ; 
    }

# 404 "bc/src/linklet.c"
    else if ((flag ) == (uninterned_literal_symbol ) )  {
      if (uninterned_literal_mode && ! redundant )
        redundant = flag ; 
      uninterned_literal_mode = 1 ; 
    }

# 408 "bc/src/linklet.c"
    else if ((flag ) == (quick_symbol ) )  {
      if (quick_mode && ! redundant )
        redundant = flag ; 
      quick_mode = 1 ; 
    }

# 412 "bc/src/linklet.c"
    else 
    break ; 
    flags = (((Scheme_Simple_Object * ) (flags ) ) -> u . pair_val . cdr ) ; 
  }

  if (! ((flags ) == (scheme_null ) ) )
    scheme_wrong_contract ("compile-linklet" , 
  "(listof/c 'serializable 'unsafe 'static 'use-prompt 'uninterned-literal 'quick)" , 
  arg_pos , argc , argv ) ; 

  if (redundant )
    scheme_contract_error ("compile-linklet" , "redundant option" , 
  "redundant option" , 1 , redundant , 
  "supplied options" , 1 , argv [arg_pos ] , 
  ((void * ) 0 ) ) ; 

  * _unsafe = unsafe ; 
  * _static_mode = static_mode ; 
  * _serializable = serializable ; 
}

static Scheme_Object * compile_linklet (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * name , * e , * import_keys , * get_import , * a [2 ] ; 
  int unsafe = 0 , static_mode = 0 , serializable = 1 ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(e, 1), PUSH(import_keys, 2), PUSH(get_import, 3), PUSHARRAY(a, 2, 4), PUSH(argv, 7)));
# define XfOrM44_COUNT (8)
# define SETUP_XfOrM44(x) SETUP(XfOrM44_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  name = NULLED_OUT ; 
  e = NULLED_OUT ; 
  import_keys = NULLED_OUT ; 
  get_import = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM44(_), extract_import_info ("compile-linklet" , argc , argv , & import_keys , & get_import ) )
# 438 "bc/src/linklet.c"
  ; 

  if ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) )
    name = argv [1 ] ; 
  else 
  name = FUNCCALL(SETUP_XfOrM44(_), scheme_intern_symbol ("anonymous" ) ); 

  e = argv [0 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    e = FUNCCALL(SETUP_XfOrM44(_), scheme_datum_to_syntax (e , scheme_false , 0x2 ) ); 

  if (show_linklets ) {
    char * s ; 
    intptr_t s_len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM44_COUNT)));
#   define XfOrM46_COUNT (1+XfOrM44_COUNT)
#   define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
    s = NULLED_OUT ; 

# 452 "bc/src/linklet.c"
    s = (__funcarg83 = FUNCCALL(SETUP_XfOrM46(_), scheme_syntax_to_datum (e ) ), FUNCCALL_AGAIN(scheme_write_to_string (__funcarg83 , & s_len ) )) ; 
    (printf ("%s\n" , s ) ) ; 
  }

  if (argc > 4 )
    FUNCCALL(SETUP_XfOrM44(_), parse_compile_options ("compile-linklet" , 4 , argc , argv , & unsafe , & static_mode , & serializable ) ); 

  e = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM44(_), compile_and_or_optimize_linklet (e , ((void * ) 0 ) , name , & import_keys , get_import , unsafe , static_mode , serializable ) )
  ; 

  if (import_keys ) {
#   define XfOrM45_COUNT (0+XfOrM44_COUNT)
#   define SETUP_XfOrM45(x) SETUP_XfOrM44(x)

# 463 "bc/src/linklet.c"
    a [0 ] = e ; 
    a [1 ] = import_keys ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM45(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
  }

# 466 "bc/src/linklet.c"
  else 
  RET_VALUE_START (e ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 470 "bc/src/linklet.c"
static Scheme_Object * recompile_linklet (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * name , * import_keys , * get_import , * a [2 ] ; 
  Scheme_Linklet * linklet ; 
  int unsafe = 0 , static_mode = 0 , serializable = 1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSHARRAY(a, 2, 1), PUSH(import_keys, 4), PUSH(get_import, 5), PUSH(linklet, 6), PUSH(argv, 7)));
# define XfOrM47_COUNT (8)
# define SETUP_XfOrM47(x) SETUP(XfOrM47_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 
  import_keys = NULLED_OUT ; 
  get_import = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  linklet = NULLED_OUT ; 

# 476 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) )
    FUNCCALL(SETUP_XfOrM47(_), scheme_wrong_contract ("recompile-linklet" , "linklet?" , 0 , argc , argv ) ); 

  linklet = (Scheme_Linklet * ) argv [0 ] ; 
  FUNCCALL(SETUP_XfOrM47(_), check_linklet_allowed ("recompile-linklet" , linklet ) )
  ; 
  FUNCCALL_AGAIN(extract_import_info ("recompile-linklet" , argc , argv , & import_keys , & get_import ) )
  ; 

  if ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) )
    name = argv [1 ] ; 
  else 
  name = ((Scheme_Linklet * ) argv [0 ] ) -> name ; 

  if (import_keys && ((((Scheme_Vector * ) (import_keys ) ) -> size ) != (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ) ) {
#   define XfOrM49_COUNT (0+XfOrM47_COUNT)
#   define SETUP_XfOrM49(x) SETUP_XfOrM47(x)
    FUNCCALL(SETUP_XfOrM49(_), scheme_contract_error ("recompile-linklet" , "given number of import keys does not match import count of linklet" , "linklet" , 1 , linklet , "linklet imports" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ) ) ) << 1 ) | 0x1 ) ) , "given keys" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((Scheme_Vector * ) (import_keys ) ) -> size ) ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )


    ; 
  }

  if (argc > 4 )
    FUNCCALL(SETUP_XfOrM47(_), parse_compile_options ("recompile-linklet" , 4 , argc , argv , & unsafe , & static_mode , & serializable ) ); 

  linklet = FUNCCALL(SETUP_XfOrM47(_), compile_and_or_optimize_linklet (((void * ) 0 ) , linklet , name , & import_keys , get_import , unsafe , static_mode , serializable ) )
  ; 

  if (import_keys ) {
#   define XfOrM48_COUNT (0+XfOrM47_COUNT)
#   define SETUP_XfOrM48(x) SETUP_XfOrM47(x)

# 506 "bc/src/linklet.c"
    a [0 ] = (Scheme_Object * ) linklet ; 
    a [1 ] = import_keys ; 

    RET_VALUE_START (FUNCCALL(SETUP_XfOrM48(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
  }

# 510 "bc/src/linklet.c"
  else 
  RET_VALUE_START ((Scheme_Object * ) linklet ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 514 "bc/src/linklet.c"
static Scheme_Object * eval_linklet (int argc , Scheme_Object * * argv ) 
{




  Scheme_Linklet * linklet ; 
  Scheme_Config * __funcarg84 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(linklet, 0)));
# define XfOrM50_COUNT (1)
# define SETUP_XfOrM50(x) SETUP(XfOrM50_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  linklet = NULLED_OUT ; 

# 522 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("eval-linklet" , "linklet?" , 0 , argc , argv ) ); 

  linklet = (Scheme_Linklet * ) argv [0 ] ; 
  FUNCCALL(SETUP_XfOrM50(_), check_linklet_allowed ("eval-linklet" , linklet ) )
  ; 

  if (! linklet -> jit_ready ) {
    Scheme_Object * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM50_COUNT)));
#   define XfOrM51_COUNT (1+XfOrM50_COUNT)
#   define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
    b = NULLED_OUT ; 

# 531 "bc/src/linklet.c"
    b = (__funcarg84 = FUNCCALL(SETUP_XfOrM51(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg84 , MZCONFIG_USE_JIT ) )) ; 
    if (! (((b ) ) == (scheme_false ) ) )  {
#     define XfOrM52_COUNT (0+XfOrM51_COUNT)
#     define SETUP_XfOrM52(x) SETUP_XfOrM51(x)
      linklet = FUNCCALL(SETUP_XfOrM52(_), scheme_jit_linklet (linklet , 1 ) ); 
    }
  }

# 551 "bc/src/linklet.c"
  RET_VALUE_START ((Scheme_Object * ) linklet ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 554 "bc/src/linklet.c"
static Scheme_Object * linklet_vm_bytes (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 556 "bc/src/linklet.c"
  return scheme_make_byte_string ("racket" ) ; 
}

static Scheme_Object * read_linklet_bundle_hash (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 561 "bc/src/linklet.c"
  if (! scheme_is_input_port (argv [0 ] ) )
    scheme_wrong_contract ("read-linklet-bundle-hash" , "input-port?" , 0 , argc , argv ) ; 

  return scheme_read_linklet_bundle_hash (argv [0 ] ) ; 
}

static Scheme_Object * write_linklet_bundle_hash (int argc , Scheme_Object * * argv ) 
{
  mzlonglong pos ; 
  Scheme_Object * k , * v ; 
  Scheme_Hash_Tree * hash ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1)));
# define XfOrM55_COUNT (2)
# define SETUP_XfOrM55(x) SETUP(XfOrM55_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  k = NULLED_OUT ; 
  v = NULLED_OUT ; 
  hash = NULLED_OUT ; 

# 573 "bc/src/linklet.c"
  if (! ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
  || ! ((Scheme_Type ) (scheme_eq_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) argv [0 ] ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) argv [0 ] ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("write-linklet-bundle-hash" , "(and/c hash? hash-eq? immutable? (not/c impersonator?))" , 0 , argc , argv ) )

  ; 

  if (! (scheme_is_output_port (argv [1 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("write-linklet-bundle-hash" , "output-port?" , 0 , argc , argv ) ); 

  hash = (Scheme_Hash_Tree * ) argv [0 ] ; 



  pos = (scheme_hash_tree_next (hash , - 1 ) ) ; 
  while (pos != - 1 ) {
#   define XfOrM58_COUNT (0+XfOrM55_COUNT)
#   define SETUP_XfOrM58(x) SETUP_XfOrM55(x)
    (
# 588 "bc/src/linklet.c"
    scheme_hash_tree_index (hash , pos , & k , & v ) ) ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (k ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (k ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! (((intptr_t ) (k ) ) & 0x1 ) ) {
#     define XfOrM59_COUNT (0+XfOrM58_COUNT)
#     define SETUP_XfOrM59(x) SETUP_XfOrM58(x)
      FUNCCALL_EMPTY(scheme_contract_error ("write-linklet-bundle-hash" , "key in given hash is not a symbol or fixnum" , "key" , 1 , k , ((void * ) 0 ) ) )
      ; 
    }
    pos = (scheme_hash_tree_next (hash , pos ) ) ; 
  }

  v = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM55(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  v -> type = scheme_linklet_bundle_type ; 
  (((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) = argv [0 ] ; 
  FUNCCALL_EMPTY(scheme_write (v , argv [1 ] ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 607 "bc/src/linklet.c"
static Scheme_Object * instantiate_linklet (int argc , Scheme_Object * * argv ) 
{
  Scheme_Linklet * linklet ; 
  Scheme_Object * l ; 
  Scheme_Instance * inst , * * instances ; 
  int len = 0 , num_importss , use_prompt , return_instance ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(instances, 0), PUSH(inst, 1), PUSH(l, 2), PUSH(linklet, 3), PUSH(argv, 4)));
# define XfOrM60_COUNT (5)
# define SETUP_XfOrM60(x) SETUP(XfOrM60_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  linklet = NULLED_OUT ; 
  l = NULLED_OUT ; 
  inst = NULLED_OUT ; 
  instances = NULLED_OUT ; 

# 614 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instantiate-linklet" , "linklet?" , 0 , argc , argv ) ); 

  l = argv [1 ] ; 
  while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    if (! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
      break ; 
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
    len ++ ; 
  }
  if (! ((l ) == (scheme_null ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instantiate-linklet" , "(listof instance?)" , 1 , argc , argv ) ); 

  linklet = (Scheme_Linklet * ) argv [0 ] ; 
  FUNCCALL(SETUP_XfOrM60(_), check_linklet_allowed ("instantiate-linklet" , linklet ) ); 
  num_importss = (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ; 
  if (len != num_importss )
    FUNCCALL_EMPTY(scheme_contract_error ("instantiate-linklet" , "given number of instances does not match import count of linklet" , "linklet" , 1 , linklet , "expected imports" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_importss ) ) ) << 1 ) | 0x1 ) ) , "given instances" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )




  ; 

  if ((argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) {
#   define XfOrM65_COUNT (0+XfOrM60_COUNT)
#   define SETUP_XfOrM65(x) SETUP_XfOrM60(x)

# 639 "bc/src/linklet.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("instantiate-linklet" , "(or/c instance? #f)" , 2 , argc , argv ) ); 
    inst = (Scheme_Instance * ) argv [2 ] ; 
    return_instance = 0 ; 
  }

# 643 "bc/src/linklet.c"
  else {
#   define XfOrM64_COUNT (0+XfOrM60_COUNT)
#   define SETUP_XfOrM64(x) SETUP_XfOrM60(x)

# 644 "bc/src/linklet.c"
    inst = FUNCCALL(SETUP_XfOrM64(_), scheme_make_instance (linklet -> name , scheme_false ) ); 
    return_instance = 1 ; 
  }

  use_prompt = ((argc < 4 ) || (! (((argv [3 ] ) ) == (scheme_false ) ) ) ) ; 

  instances = ((Scheme_Instance * * ) FUNCCALL(SETUP_XfOrM60(_), GC_malloc (sizeof (Scheme_Instance * ) * (len ) ) )) ; 
  l = argv [1 ] ; 
  len = 0 ; 
  while (! ((l ) == (scheme_null ) ) ) {
    instances [len ++ ] = (Scheme_Instance * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  if (! return_instance )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(_instantiate_linklet_multi (linklet , inst , len , instances , use_prompt ) )) RET_VALUE_EMPTY_END ; 
  else {
#   define XfOrM61_COUNT (0+XfOrM60_COUNT)
#   define SETUP_XfOrM61(x) SETUP_XfOrM60(x)

# 661 "bc/src/linklet.c"
    (void ) FUNCCALL(SETUP_XfOrM61(_), _instantiate_linklet_multi (linklet , inst , len , instances , use_prompt ) ); 
    RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 666 "bc/src/linklet.c"
static Scheme_Object * linklet_import_variables (int argc , Scheme_Object * * argv ) 
{
  Scheme_Linklet * linklet ; 
  int i , j ; 
  Scheme_Object * l , * ll = scheme_null ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(ll, 0), PUSH(l, 1), PUSH(linklet, 2)));
# define XfOrM68_COUNT (3)
# define SETUP_XfOrM68(x) SETUP(XfOrM68_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  linklet = NULLED_OUT ; 
  l = NULLED_OUT ; 

# 672 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("linklet-import-variables" , "linklet?" , 0 , argc , argv ) ); 

  linklet = (Scheme_Linklet * ) argv [0 ] ; 

  for (i = (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ; i -- ; ) {
#   define XfOrM72_COUNT (0+XfOrM68_COUNT)
#   define SETUP_XfOrM72(x) SETUP_XfOrM68(x)

# 678 "bc/src/linklet.c"
    l = scheme_null ; 
    for (j = (((Scheme_Vector * ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ) ) -> size ) ; j -- ; ) {
#     define XfOrM74_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM74(x) SETUP_XfOrM72(x)

# 680 "bc/src/linklet.c"
      l = FUNCCALL(SETUP_XfOrM74(_), scheme_make_pair ((((Scheme_Vector * ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ) ) -> els ) [j ] , l ) ); 
    }
    ll = FUNCCALL(SETUP_XfOrM72(_), scheme_make_pair (l , ll ) ); 
  }

  RET_VALUE_START (ll ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 688 "bc/src/linklet.c"
static Scheme_Object * linklet_export_variables (int argc , Scheme_Object * * argv ) 
{
  Scheme_Linklet * linklet ; 
  int i ; 
  Scheme_Object * l = scheme_null ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(linklet, 1)));
# define XfOrM75_COUNT (2)
# define SETUP_XfOrM75(x) SETUP(XfOrM75_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  linklet = NULLED_OUT ; 

# 694 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("linklet-export-variables" , "linklet?" , 0 , argc , argv ) ); 

  linklet = (Scheme_Linklet * ) argv [0 ] ; 

  for (i = linklet -> num_exports ; i -- ; ) {
#   define XfOrM77_COUNT (0+XfOrM75_COUNT)
#   define SETUP_XfOrM77(x) SETUP_XfOrM75(x)

# 700 "bc/src/linklet.c"
    l = FUNCCALL(SETUP_XfOrM77(_), scheme_make_pair ((((Scheme_Vector * ) (linklet -> defns ) ) -> els ) [i ] , l ) ); 
  }

  RET_VALUE_START (l ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 706 "bc/src/linklet.c"
static Scheme_Object * instance_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 708 "bc/src/linklet.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static int parse_constantness_flag (const char * who , int i , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 715 "bc/src/linklet.c"
  int set_flags = 0 ; 

  if (((argv [i ] ) ) == (scheme_false ) ) 
    set_flags = 0 ; 
  else if ((argv [i ] ) == (constant_symbol ) ) 
    set_flags = 64 ; 
  else if ((argv [i ] ) == (consistent_symbol ) ) 
    set_flags = 64 | 2 ; 
  else 
  scheme_wrong_contract (who , "(or/c #f 'constant 'consistent)" , i , argc , argv ) ; 

  return set_flags ; 
}

static Scheme_Object * make_instance (int argc , Scheme_Object * * argv ) 
{
  Scheme_Instance * inst ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(argv, 1)));
# define XfOrM80_COUNT (2)
# define SETUP_XfOrM80(x) SETUP(XfOrM80_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  inst = NULLED_OUT ; 

# 734 "bc/src/linklet.c"
  inst = FUNCCALL(SETUP_XfOrM80(_), scheme_make_instance (argv [0 ] , (argc > 1 ) ? argv [1 ] : scheme_false ) ); 

  if (argc > 3 ) {
    Scheme_Bucket * * a , * b ; 
    int set_flags = 0 ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM80_COUNT), PUSH(b, 1+XfOrM80_COUNT)));
#   define XfOrM81_COUNT (2+XfOrM80_COUNT)
#   define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
    a = NULLED_OUT ; 
    b = NULLED_OUT ; 

# 740 "bc/src/linklet.c"
    set_flags = FUNCCALL(SETUP_XfOrM81(_), parse_constantness_flag ("make-instance" , 2 , argc , argv ) ); 

    i = 3 ; 
    a = ((Scheme_Bucket * * ) FUNCCALL(SETUP_XfOrM81(_), GC_malloc (sizeof (Scheme_Bucket * ) * ((argc - i ) >> 1 ) ) )) ; 

    for (; i < argc ; i += 2 ) {
#     define XfOrM83_COUNT (0+XfOrM81_COUNT)
#     define SETUP_XfOrM83(x) SETUP_XfOrM81(x)

# 746 "bc/src/linklet.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
        FUNCCALL_EMPTY(scheme_wrong_contract ("make-instance" , "symbol?" , i , argc , argv ) ); 
      if (i + 1 == argc )
        FUNCCALL_EMPTY(scheme_contract_error ("make-instance" , "value missing for variable name" , "variable name" , 1 , argv [i ] , ((void * ) 0 ) ) )


      ; 
      b = FUNCCALL(SETUP_XfOrM83(_), make_bucket (argv [i ] , argv [i + 1 ] , inst ) ); 
      if (set_flags )
        ((Scheme_Bucket_With_Flags * ) b ) -> flags |= set_flags ; 
      a [(i - 2 ) >> 1 ] = b ; 
    }

    inst -> array_size = (argc - 2 ) >> 1 ; 
    inst -> variables . a = a ; 
  }

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 766 "bc/src/linklet.c"
static Scheme_Object * instance_name (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 768 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
    scheme_wrong_contract ("instance-name" , "instance?" , 0 , argc , argv ) ; 

  return ((Scheme_Instance * ) argv [0 ] ) -> name ; 
}

static Scheme_Object * instance_data (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 776 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
    scheme_wrong_contract ("instance-data" , "instance?" , 0 , argc , argv ) ; 

  return ((Scheme_Instance * ) argv [0 ] ) -> data ; 
}

static Scheme_Object * instance_variable_names (int argc , Scheme_Object * * argv ) 
{
  Scheme_Bucket * b ; 
  int i ; 
  Scheme_Object * l = scheme_null ; 
  Scheme_Instance * inst ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(inst, 1), PUSH(b, 2)));
# define XfOrM86_COUNT (3)
# define SETUP_XfOrM86(x) SETUP(XfOrM86_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 
  inst = NULLED_OUT ; 

# 789 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instance-variable-names" , "instance?" , 0 , argc , argv ) ); 

  inst = (Scheme_Instance * ) argv [0 ] ; 

  if (inst -> array_size ) {
#   define XfOrM92_COUNT (0+XfOrM86_COUNT)
#   define SETUP_XfOrM92(x) SETUP_XfOrM86(x)

# 795 "bc/src/linklet.c"
    for (i = inst -> array_size ; i -- ; ) {
#     define XfOrM94_COUNT (0+XfOrM92_COUNT)
#     define SETUP_XfOrM94(x) SETUP_XfOrM92(x)

# 796 "bc/src/linklet.c"
      l = FUNCCALL(SETUP_XfOrM94(_), scheme_make_pair ((Scheme_Object * ) inst -> variables . a [i ] -> key , l ) ); 
    }
  }

# 798 "bc/src/linklet.c"
  else if (inst -> variables . bt ) {
#   define XfOrM87_COUNT (0+XfOrM86_COUNT)
#   define SETUP_XfOrM87(x) SETUP_XfOrM86(x)

# 799 "bc/src/linklet.c"
    for (i = inst -> variables . bt -> size ; i -- ; ) {
#     define XfOrM90_COUNT (0+XfOrM87_COUNT)
#     define SETUP_XfOrM90(x) SETUP_XfOrM87(x)

# 800 "bc/src/linklet.c"
      b = inst -> variables . bt -> buckets [i ] ; 
      if (b && b -> val ) {
#       define XfOrM91_COUNT (0+XfOrM90_COUNT)
#       define SETUP_XfOrM91(x) SETUP_XfOrM90(x)

# 802 "bc/src/linklet.c"
        l = FUNCCALL(SETUP_XfOrM91(_), scheme_make_pair ((Scheme_Object * ) b -> key , l ) ); 
      }
    }
  }

  RET_VALUE_START (l ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 810 "bc/src/linklet.c"
static Scheme_Object * instance_variable_value (int argc , Scheme_Object * * argv ) 
{
  Scheme_Instance * inst ; 
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(inst, 1), PUSH(b, 2)));
# define XfOrM95_COUNT (3)
# define SETUP_XfOrM95(x) SETUP(XfOrM95_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 
  b = NULLED_OUT ; 

# 815 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instance-variable-value" , "instance?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instance-variable-value" , "symbol?" , 1 , argc , argv ) ); 

  inst = (Scheme_Instance * ) argv [0 ] ; 

  b = FUNCCALL(SETUP_XfOrM95(_), scheme_instance_variable_bucket_or_null (argv [1 ] , inst ) ); 
  if (b && b -> val )
    RET_VALUE_START (b -> val ) RET_VALUE_END ; 

  if (argc > 2 ) {
#   define XfOrM96_COUNT (0+XfOrM95_COUNT)
#   define SETUP_XfOrM96(x) SETUP_XfOrM95(x)

# 827 "bc/src/linklet.c"
    if (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (argv [2 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
    RET_VALUE_START (argv [2 ] ) RET_VALUE_END ; 
  }
  FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "instance-variable-value: instance variable not found\n" "  instance: %V\n" "  name: %S" , inst -> name , argv [1 ] ) )





  ; 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 841 "bc/src/linklet.c"
static Scheme_Object * instance_set_variable_value (int argc , Scheme_Object * * argv ) 
{
  Scheme_Bucket * b ; 
  int set_flags = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(argv, 1)));
# define XfOrM97_COUNT (2)
# define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 846 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instance-set-variable-value!" , "instance?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instance-set-variable-value!" , "symbol?" , 1 , argc , argv ) ); 
  if (argc > 3 )
    set_flags = FUNCCALL(SETUP_XfOrM97(_), parse_constantness_flag ("instance-set-variable-value!" , 3 , argc , argv ) ); 

  b = FUNCCALL(SETUP_XfOrM97(_), scheme_instance_variable_bucket (argv [1 ] , (Scheme_Instance * ) argv [0 ] ) ); 
  FUNCCALL_AGAIN(scheme_set_global_bucket ("instance-set-variable-value!" , b , argv [2 ] , 1 ) )
  ; 

  b -> val = argv [2 ] ; 
  if (set_flags )
    ((Scheme_Bucket_With_Flags * ) b ) -> flags |= set_flags ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 864 "bc/src/linklet.c"
static Scheme_Object * instance_unset_variable (int argc , Scheme_Object * * argv ) 
{
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(b, 0)));
# define XfOrM98_COUNT (1)
# define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 868 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instance-unset-variable!" , "instance?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("instance-unset-variable!" , "symbol?" , 1 , argc , argv ) ); 

  b = FUNCCALL(SETUP_XfOrM98(_), scheme_instance_variable_bucket (argv [1 ] , (Scheme_Instance * ) argv [0 ] ) ); 
  b -> val = ((void * ) 0 ) ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 879 "bc/src/linklet.c"
static Scheme_Object * instance_describe_variable (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 881 "bc/src/linklet.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_instance_type ) ) )
    scheme_wrong_contract ("instance-describe-variable!" , "instance?" , 0 , argc , argv ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("instance-describe-variable!" , "symbol?" , 1 , argc , argv ) ; 

  return scheme_void ; 
}

static Scheme_Object * variable_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 891 "bc/src/linklet.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_global_ref_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * variable_instance (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 898 "bc/src/linklet.c"
  Scheme_Object * v ; 

  v = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_global_ref_type ) ) )
    scheme_wrong_contract ("variable-reference->instance" , "variable-reference?" , 0 , argc , argv ) ; 

  if ((argc < 2 ) || (((argv [1 ] ) ) == (scheme_false ) ) ) {

    v = (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . two_ptr_val . ptr1 ) ; 
    if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || (((v ) ) == (scheme_false ) ) )
      return v ; 
    else if ((v ) == (scheme_true ) ) 
      return (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . two_ptr_val . ptr2 ) ; 
    else {
      v = (Scheme_Object * ) scheme_get_bucket_home ((Scheme_Bucket * ) v ) ; 
      if (! v ) {

        return (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . two_ptr_val . ptr2 ) ; 
      }
      return v ; 
    }
  }

# 920 "bc/src/linklet.c"
  else {

    return (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . two_ptr_val . ptr2 ) ; 
  }
}

static Scheme_Object * variable_const_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 928 "bc/src/linklet.c"
  Scheme_Object * v ; 

  v = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_global_ref_type ) ) )
    scheme_wrong_contract ("variable-reference-constant?" , "variable-reference?" , 0 , argc , argv ) ; 

  if ((& ((Scheme_Simple_Object * ) v ) -> iso ) -> so . keyex & 0x1 )
    return scheme_true ; 

  v = (((Scheme_Simple_Object * ) (v ) ) -> u . two_ptr_val . ptr1 ) ; 
  if (! (((v ) ) == (scheme_false ) ) ) {
    if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    || (((Scheme_Bucket_With_Flags * ) v ) -> flags & 64 ) )
      return scheme_true ; 
  }

  return scheme_false ; 
}

static Scheme_Object * variable_unsafe_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 950 "bc/src/linklet.c"
  Scheme_Object * v ; 

  v = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_global_ref_type ) ) )
    scheme_wrong_contract ("variable-reference-from-unsafe?" , "variable-reference?" , 0 , argc , argv ) ; 

  if ((& ((Scheme_Simple_Object * ) v ) -> iso ) -> so . keyex & 0x2 )
    return scheme_true ; 
  else 
  return scheme_false ; 
}





Scheme_Object * scheme_get_home_weak_link (Scheme_Instance * i ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(i, 0)));
# define XfOrM109_COUNT (1)
# define SETUP_XfOrM109(x) SETUP(XfOrM109_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 969 "bc/src/linklet.c"
  if (! i -> weak_self_link ) {
    Scheme_Object * wb ; 
    BLOCK_SETUP((PUSH(wb, 0+XfOrM109_COUNT)));
#   define XfOrM110_COUNT (1+XfOrM109_COUNT)
#   define SETUP_XfOrM110(x) SETUP(XfOrM110_COUNT)
    wb = NULLED_OUT ; 

# 971 "bc/src/linklet.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) )
      wb = FUNCCALL(SETUP_XfOrM110(_), scheme_box ((Scheme_Object * ) i ) ); 
    else 
    wb = FUNCCALL(SETUP_XfOrM110(_), scheme_make_weak_box ((Scheme_Object * ) i ) ); 
    i -> weak_self_link = wb ; 
  }

  RET_VALUE_START (i -> weak_self_link ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 981 "bc/src/linklet.c"
Scheme_Instance * scheme_get_bucket_home (Scheme_Bucket * b ) 
{
  /* No conversion */

# 983 "bc/src/linklet.c"
  Scheme_Object * l ; 

  l = ((Scheme_Bucket_With_Home * ) b ) -> home_link ; 
  if (l ) {
    if (((Scheme_Bucket_With_Flags * ) b ) -> flags & 4 )
      return (Scheme_Instance * ) l ; 
    else 
    return (Scheme_Instance * ) (((Scheme_Small_Object * ) (l ) ) -> u . ptr_val ) ; 
  }

# 991 "bc/src/linklet.c"
  else 
  return ((void * ) 0 ) ; 
}

void scheme_set_bucket_home (Scheme_Bucket * b , Scheme_Instance * e ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(b, 0)));
# define XfOrM113_COUNT (1)
# define SETUP_XfOrM113(x) SETUP(XfOrM113_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 997 "bc/src/linklet.c"
  if (! ((Scheme_Bucket_With_Home * ) b ) -> home_link ) {
#   define XfOrM114_COUNT (0+XfOrM113_COUNT)
#   define SETUP_XfOrM114(x) SETUP_XfOrM113(x)

# 998 "bc/src/linklet.c"
    if (((Scheme_Bucket_With_Flags * ) b ) -> flags & 4 )
      ((Scheme_Bucket_With_Home * ) b ) -> home_link = (Scheme_Object * ) e ; 
    else {
      Scheme_Object * link ; 
      BLOCK_SETUP((PUSH(link, 0+XfOrM114_COUNT)));
#     define XfOrM115_COUNT (1+XfOrM114_COUNT)
#     define SETUP_XfOrM115(x) SETUP(XfOrM115_COUNT)
      link = NULLED_OUT ; 

# 1002 "bc/src/linklet.c"
      link = FUNCCALL(SETUP_XfOrM115(_), scheme_get_home_weak_link (e ) ); 
      ((Scheme_Bucket_With_Home * ) b ) -> home_link = link ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1008 "bc/src/linklet.c"
static Scheme_Bucket * make_bucket (Scheme_Object * key , Scheme_Object * val , Scheme_Instance * inst ) 
{
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Bucket * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(key, 1), PUSH(inst, 2), PUSH(b, 3)));
# define XfOrM116_COUNT (4)
# define SETUP_XfOrM116(x) SETUP(XfOrM116_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 1012 "bc/src/linklet.c"
  b = (Scheme_Bucket * ) ((Scheme_Bucket_With_Home * ) FUNCCALL(SETUP_XfOrM116(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Bucket_With_Home ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  b -> so . type = scheme_variable_type ; 
  b -> key = (char * ) key ; 
  b -> val = val ; 
  FUNCCALL(SETUP_XfOrM116(_), scheme_set_bucket_home (b , inst ) ); 

  RET_VALUE_START (b ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1021 "bc/src/linklet.c"
Scheme_Instance * scheme_make_instance (Scheme_Object * name , Scheme_Object * data ) 
{
  Scheme_Instance * inst ; 
  DECL_RET_SAVE (Scheme_Instance * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(data, 1), PUSH(inst, 2)));
# define XfOrM117_COUNT (3)
# define SETUP_XfOrM117(x) SETUP(XfOrM117_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 1025 "bc/src/linklet.c"
  if (! empty_hash_tree ) {
#   define XfOrM119_COUNT (0+XfOrM117_COUNT)
#   define SETUP_XfOrM119(x) SETUP_XfOrM117(x)
    FUNCCALL(SETUP_XfOrM119(_), scheme_register_static ((void * ) & empty_hash_tree , sizeof (empty_hash_tree ) ) )
# 1026 "bc/src/linklet.c"
    ; 
    empty_hash_tree = (scheme_make_hash_tree (0 ) ) ; 
  }

  inst = ((Scheme_Instance * ) FUNCCALL(SETUP_XfOrM117(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Instance ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  inst -> iso . so . type = scheme_instance_type ; 

  inst -> name = (name ? name : scheme_false ) ; 
  inst -> data = data ; 

  inst -> source_names = empty_hash_tree ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) ) {


    (& (inst ) -> iso ) -> so . keyex |= 0x1 ; 
  }

  RET_VALUE_START (inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1047 "bc/src/linklet.c"
void scheme_instance_to_hash_mode (Scheme_Instance * inst , int size_estimate ) 
{
  Scheme_Bucket_Table * variables ; 
  Scheme_Bucket * * a ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(variables, 0), PUSH(a, 1), PUSH(inst, 2)));
# define XfOrM120_COUNT (3)
# define SETUP_XfOrM120(x) SETUP(XfOrM120_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  variables = NULLED_OUT ; 
  a = NULLED_OUT ; 

# 1052 "bc/src/linklet.c"
  if (inst -> array_size ) {
    size_estimate = inst -> array_size * 2 ; 
    a = inst -> variables . a ; 
  }

# 1055 "bc/src/linklet.c"
  else 
  a = ((void * ) 0 ) ; 

  variables = FUNCCALL(SETUP_XfOrM120(_), scheme_make_bucket_table (size_estimate , SCHEME_hash_ptr ) ); 
  variables -> with_home = 1 ; 

  inst -> variables . bt = variables ; 
  inst -> array_size = 0 ; 

  if (a ) {
    size_estimate >>= 1 ; 
#   define XfOrM121_COUNT (0+XfOrM120_COUNT)
#   define SETUP_XfOrM121(x) SETUP_XfOrM120(x)

# 1066 "bc/src/linklet.c"
    while (size_estimate -- ) {
#     define XfOrM123_COUNT (0+XfOrM121_COUNT)
#     define SETUP_XfOrM123(x) SETUP_XfOrM121(x)
      FUNCCALL(SETUP_XfOrM123(_), scheme_add_bucket_to_table (inst -> variables . bt , a [size_estimate ] ) )
# 1067 "bc/src/linklet.c"
      ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1072 "bc/src/linklet.c"
Scheme_Bucket * scheme_instance_variable_bucket (Scheme_Object * symbol , Scheme_Instance * inst ) 
{
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Bucket * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(symbol, 0), PUSH(inst, 1), PUSH(b, 2)));
# define XfOrM125_COUNT (3)
# define SETUP_XfOrM125(x) SETUP(XfOrM125_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 1076 "bc/src/linklet.c"
  if (inst -> array_size ) {
    int i ; 
    for (i = inst -> array_size ; i -- ; ) {
      b = inst -> variables . a [i ] ; 
      if ((symbol ) == ((Scheme_Object * ) b -> key ) ) 
        RET_VALUE_START (b ) RET_VALUE_END ; 
    }
  }

  if (inst -> array_size || ! inst -> variables . bt )
    FUNCCALL(SETUP_XfOrM125(_), scheme_instance_to_hash_mode (inst , 0 ) ); 

  b = FUNCCALL(SETUP_XfOrM125(_), scheme_bucket_from_table (inst -> variables . bt , (char * ) symbol ) ); 
  ; 
  if (((symbol ) ) == (scheme_false ) ) 
    ((Scheme_Bucket_With_Flags * ) b ) -> flags |= 4 ; 
  FUNCCALL(SETUP_XfOrM125(_), scheme_set_bucket_home (b , inst ) )
  ; 

  RET_VALUE_START (b ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1098 "bc/src/linklet.c"
Scheme_Bucket * scheme_instance_variable_bucket_or_null (Scheme_Object * symbol , Scheme_Instance * inst ) 
{
  Scheme_Bucket * b ; 
  DECL_RET_SAVE (Scheme_Bucket * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(b, 1)));
# define XfOrM129_COUNT (2)
# define SETUP_XfOrM129(x) SETUP(XfOrM129_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 1102 "bc/src/linklet.c"
  if (inst -> array_size ) {
    int i ; 
    for (i = inst -> array_size ; i -- ; ) {
      b = inst -> variables . a [i ] ; 
      if ((symbol ) == ((Scheme_Object * ) b -> key ) ) 
        RET_VALUE_START (b ) RET_VALUE_END ; 
    }
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 1110 "bc/src/linklet.c"
  else if (! inst -> variables . bt )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  b = FUNCCALL(SETUP_XfOrM129(_), scheme_bucket_or_null_from_table (inst -> variables . bt , (char * ) symbol , 0 ) ); 
  if (b ) {
#   define XfOrM130_COUNT (0+XfOrM129_COUNT)
#   define SETUP_XfOrM130(x) SETUP_XfOrM129(x)

# 1115 "bc/src/linklet.c"
    ; 
    FUNCCALL(SETUP_XfOrM130(_), scheme_set_bucket_home (b , inst ) ); 
  }

  RET_VALUE_START (b ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * generate_bucket_name (Scheme_Object * old_name , Scheme_Instance * instance ) 
{
  int search_start = 0 ; 
  char buf [32 ] ; 
  Scheme_Object * n ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(instance, 0), PUSH(old_name, 1), PUSH(n, 2)));
# define XfOrM134_COUNT (3)
# define SETUP_XfOrM134(x) SETUP(XfOrM134_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  n = NULLED_OUT ; 

# 1132 "bc/src/linklet.c"
  while (1 ) {
#   define XfOrM136_COUNT (0+XfOrM134_COUNT)
#   define SETUP_XfOrM136(x) SETUP_XfOrM134(x)
    (
# 1133 "bc/src/linklet.c"
    sprintf (buf , ".%d" , search_start ) ) ; 
    n = FUNCCALL(SETUP_XfOrM136(_), scheme_intern_exact_parallel_symbol (buf , strlen (buf ) ) ); 
    n = FUNCCALL_AGAIN(scheme_symbol_append (old_name , n ) ); 
    if (! FUNCCALL(SETUP_XfOrM136(_), scheme_instance_variable_bucket_or_null (n , instance ) ))
      RET_VALUE_START (n ) RET_VALUE_END ; 
    search_start ++ ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1142 "bc/src/linklet.c"
static Scheme_Hash_Tree * update_source_names (Scheme_Hash_Tree * source_names , 
Scheme_Object * old_name , Scheme_Object * new_name ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Hash_Tree * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(source_names, 0), PUSH(new_name, 1), PUSH(v, 2)));
# define XfOrM137_COUNT (3)
# define SETUP_XfOrM137(x) SETUP(XfOrM137_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1147 "bc/src/linklet.c"
  v = FUNCCALL(SETUP_XfOrM137(_), scheme_hash_tree_get (source_names , old_name ) ); 
  if (v )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_hash_tree_set (source_names , new_name , v ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (source_names ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Linklet * compile_and_or_optimize_linklet (Scheme_Object * form , Scheme_Linklet * linklet , 
Scheme_Object * name , 
Scheme_Object * * _import_keys , Scheme_Object * get_import , 
int unsafe_mode , int static_mode , int serializable ) 
{
  Scheme_Config * config ; 
  int enforce_const , set_undef , can_inline ; 
  Scheme_Performance_State perf_state ; 
  Scheme_Object * realm ; 
  DECL_RET_SAVE (Scheme_Linklet * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(_import_keys, 0), PUSH(form, 1), PUSH(name, 2), PUSH(realm, 3), PUSH(get_import, 4), PUSH(config, 5), PUSH(linklet, 6)));
# define XfOrM138_COUNT (7)
# define SETUP_XfOrM138(x) SETUP(XfOrM138_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  config = NULLED_OUT ; 
  realm = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM138(_), scheme_performance_record_start (& perf_state ) )
# 1168 "bc/src/linklet.c"
  ; 

  config = FUNCCALL_AGAIN(scheme_current_config () ); 
  enforce_const = (! (((FUNCCALL(SETUP_XfOrM138(_), scheme_get_param (config , MZCONFIG_COMPILE_MODULE_CONSTS ) )) ) == (scheme_false ) ) ) ; 
  set_undef = (! (((FUNCCALL(SETUP_XfOrM138(_), scheme_get_param (config , MZCONFIG_ALLOW_SET_UNDEFINED ) )) ) == (scheme_false ) ) ) ; 
  can_inline = (((FUNCCALL(SETUP_XfOrM138(_), scheme_get_param (config , MZCONFIG_DISALLOW_INLINE ) )) ) == (scheme_false ) ) ; 
  realm = FUNCCALL(SETUP_XfOrM138(_), scheme_get_param (config , MZCONFIG_COMPILE_REALM ) ); 

  if (_import_keys && ! * _import_keys )
    _import_keys = ((void * ) 0 ) ; 

  if (! linklet ) {
#   define XfOrM143_COUNT (0+XfOrM138_COUNT)
#   define SETUP_XfOrM143(x) SETUP_XfOrM138(x)

# 1180 "bc/src/linklet.c"
    linklet = FUNCCALL(SETUP_XfOrM143(_), scheme_compile_linklet (form , set_undef , (_import_keys ? * _import_keys : ((void * ) 0 ) ) , realm ) ); 
    linklet = FUNCCALL(SETUP_XfOrM143(_), scheme_letrec_check_linklet (linklet ) ); 
  }

# 1182 "bc/src/linklet.c"
  else {
#   define XfOrM142_COUNT (0+XfOrM138_COUNT)
#   define SETUP_XfOrM142(x) SETUP_XfOrM138(x)

# 1183 "bc/src/linklet.c"
    linklet = FUNCCALL(SETUP_XfOrM142(_), scheme_unresolve_linklet (linklet , (set_undef ? 0x1 : 0 ) ) ); 
  }
  linklet -> name = name ; 
  linklet = FUNCCALL(SETUP_XfOrM138(_), scheme_optimize_linklet (linklet , enforce_const , can_inline , unsafe_mode , _import_keys , get_import ) )
  ; 

  linklet = FUNCCALL_AGAIN(scheme_resolve_linklet (linklet , enforce_const , static_mode ) ); 
  linklet = FUNCCALL_AGAIN(scheme_sfs_linklet (linklet ) ); 

  if (recompile_every_compile ) {
    int i ; 
#   define XfOrM139_COUNT (0+XfOrM138_COUNT)
#   define SETUP_XfOrM139(x) SETUP_XfOrM138(x)

# 1194 "bc/src/linklet.c"
    for (i = recompile_every_compile ; i -- ; ) {
#     define XfOrM141_COUNT (0+XfOrM139_COUNT)
#     define SETUP_XfOrM141(x) SETUP_XfOrM139(x)

# 1195 "bc/src/linklet.c"
      linklet = FUNCCALL(SETUP_XfOrM141(_), scheme_unresolve_linklet (linklet , (set_undef ? 0x1 : 0 ) ) ); 
      linklet = FUNCCALL(SETUP_XfOrM141(_), scheme_optimize_linklet (linklet , enforce_const , can_inline , unsafe_mode , _import_keys , get_import ) )
      ; 
      linklet = FUNCCALL_AGAIN(scheme_resolve_linklet (linklet , enforce_const , static_mode ) ); 
      linklet = FUNCCALL_AGAIN(scheme_sfs_linklet (linklet ) ); 
    }
  }

  if (validate_compile_result )
    FUNCCALL(SETUP_XfOrM138(_), scheme_validate_linklet (((void * ) 0 ) , linklet ) ); 
  FUNCCALL(SETUP_XfOrM138(_), scheme_performance_record_end ("compile" , & perf_state ) )
  ; 

  if (serializable )
    linklet -> serializable = 1 ; 

  RET_VALUE_START (linklet ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1214 "bc/src/linklet.c"
Scheme_Linklet * scheme_compile_and_optimize_linklet (Scheme_Object * form , Scheme_Object * name ) 
{
  /* No conversion */

# 1216 "bc/src/linklet.c"
  return compile_and_or_optimize_linklet (form , ((void * ) 0 ) , name , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , 0 ) ; 
}





static Scheme_Object * body_one_expr (void * prefix_plus_expr , int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(prefix_plus_expr, 1)));
# define XfOrM145_COUNT (2)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM145(_), resume_prefix ((((Scheme_Simple_Object * ) ((Scheme_Object * ) prefix_plus_expr ) ) -> u . pair_val . car ) ) )
# 1227 "bc/src/linklet.c"
  ; 
  v = FUNCCALL_AGAIN(scheme_do_eval ((((Scheme_Simple_Object * ) ((Scheme_Object * ) prefix_plus_expr ) ) -> u . pair_val . cdr ) , - 1 , ((void * ) 0 ) , - 1 ) ); 
  (void ) FUNCCALL(SETUP_XfOrM145(_), suspend_prefix () ); 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1234 "bc/src/linklet.c"
static int needs_prompt (Scheme_Object * e ) 
{
  /* No conversion */

# 1236 "bc/src/linklet.c"
  Scheme_Type t ; 

  while (1 ) {
    t = ((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ; 
    if (t > _scheme_values_types_ )
      return 0 ; 

    switch (t ) {
      case scheme_lambda_type : 
      case scheme_toplevel_type : 
      case scheme_local_type : 
      case scheme_local_unbox_type : 
      return 0 ; 
      case scheme_case_lambda_sequence_type : 
      return 0 ; 
      case scheme_define_values_type : 
      e = (((Scheme_Vector * ) (e ) ) -> els ) [0 ] ; 
      break ; 
      case scheme_inline_variant_type : 
      e = (((Scheme_Vector * ) (e ) ) -> els ) [0 ] ; 
      break ; 
      default : 
      return 1 ; 
    }
  }
}

Scheme_Object * scheme_linklet_run_finish (Scheme_Linklet * linklet , Scheme_Instance * instance , int use_prompt ) 
{
  Scheme_Thread * p ; 
  Scheme_Object * body , * save_prefix , * v = scheme_void ; 
  int i , cnt ; 
  mz_jmp_buf newbuf , * volatile savebuf ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(savebuf, 0), PUSH(instance, 1), PUSH(p, 2), PUSH(body, 3), PUSH(save_prefix, 4), PUSH(linklet, 5), PUSH(v, 6)));
# define XfOrM151_COUNT (7)
# define SETUP_XfOrM151(x) SETUP(XfOrM151_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  body = NULLED_OUT ; 
  save_prefix = NULLED_OUT ; 
  savebuf = NULLED_OUT ; 

# 1270 "bc/src/linklet.c"
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  savebuf = p -> error_buf ; 
  p -> error_buf = & newbuf ; 

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM151_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    Scheme_Thread * p2 ; 
    p2 = NULLED_OUT ; 

# 1276 "bc/src/linklet.c"
    p2 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    p2 -> error_buf = savebuf ; 
    (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
  }

# 1279 "bc/src/linklet.c"
  else {
#   define XfOrM152_COUNT (0+XfOrM151_COUNT)
#   define SETUP_XfOrM152(x) SETUP_XfOrM151(x)

# 1280 "bc/src/linklet.c"
    cnt = (((Scheme_Vector * ) (linklet -> bodies ) ) -> size ) ; 
    for (i = 0 ; i < cnt ; i ++ ) {
#     define XfOrM160_COUNT (0+XfOrM152_COUNT)
#     define SETUP_XfOrM160(x) SETUP_XfOrM152(x)

# 1282 "bc/src/linklet.c"
      body = (((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] ; 
      if (use_prompt && FUNCCALL(SETUP_XfOrM160(_), needs_prompt (body ) )) {
#       define XfOrM161_COUNT (0+XfOrM160_COUNT)
#       define SETUP_XfOrM161(x) SETUP_XfOrM160(x)
        save_prefix = FUNCCALL(SETUP_XfOrM161(_), suspend_prefix () ); 
        v = (__funcarg86 = FUNCCALL(SETUP_XfOrM161(_), scheme_make_raw_pair (save_prefix , body ) ), FUNCCALL_AGAIN(_scheme_call_with_prompt_multi (body_one_expr , __funcarg86 ) )) 
        ; 
        FUNCCALL_AGAIN(resume_prefix (save_prefix ) ); 









        if ((Scheme_Type ) (((((intptr_t ) (body ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (body ) ) -> type ) ) == (Scheme_Type ) (scheme_define_values_type ) )  {
          int vcnt , j ; 
#         define XfOrM162_COUNT (0+XfOrM161_COUNT)
#         define SETUP_XfOrM162(x) SETUP_XfOrM161(x)

# 1302 "bc/src/linklet.c"
          vcnt = (((Scheme_Vector * ) (body ) ) -> size ) - 1 ; 
          for (j = 0 ; j < vcnt ; j ++ ) {
            Scheme_Object * var ; 
            Scheme_Prefix * toplevels ; 
            Scheme_Bucket * b ; 
#           define XfOrM165_COUNT (0+XfOrM162_COUNT)
#           define SETUP_XfOrM165(x) SETUP_XfOrM162(x)
            var = NULLED_OUT ; 
            toplevels = NULLED_OUT ; 
            b = NULLED_OUT ; 

# 1308 "bc/src/linklet.c"
            var = (((Scheme_Vector * ) (body ) ) -> els ) [j + 1 ] ; 
            toplevels = (Scheme_Prefix * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) [(((Scheme_Toplevel * ) (var ) ) -> u . depth ) ] ; 
            b = (Scheme_Bucket * ) toplevels -> a [(((Scheme_Toplevel * ) (var ) ) -> position ) ] ; 

            if (! b -> val ) {
#             define XfOrM166_COUNT (0+XfOrM165_COUNT)
#             define SETUP_XfOrM166(x) SETUP_XfOrM165(x)
              FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , b -> key , "define-values: skipped variable definition;\n" " cannot continue without defining variable\n" "  variable: %S\n" "  in module: %D" , (Scheme_Object * ) b -> key , instance -> name ) )




              ; 
            }
          }
        }
      }

# 1324 "bc/src/linklet.c"
      else 
      v = FUNCCALL(SETUP_XfOrM160(_), scheme_do_eval (body , - 1 , ((void * ) 0 ) , - 1 ) ); 

      if (i < (cnt - 1 ) )
        (scheme_ignore_result (v ) ) ; 
    }

    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    p -> error_buf = savebuf ; 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1338 "bc/src/linklet.c"
static Scheme_Object * eval_linklet_body (Scheme_Linklet * linklet , Scheme_Instance * instance , int use_prompt ) 
{
  /* No conversion */




  return scheme_linklet_run_finish (linklet , instance , use_prompt ) ; 
}

static void * instantiate_linklet_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Linklet * linklet = (Scheme_Linklet * ) p -> ku . k . p1 ; 
  Scheme_Instance * instance = (Scheme_Instance * ) p -> ku . k . p2 ; 
  Scheme_Instance * * instances = (Scheme_Instance * * ) p -> ku . k . p3 ; 
  int multi = p -> ku . k . i1 ; 
  int num_instances = p -> ku . k . i2 ; 
  int use_prompt = p -> ku . k . i3 ; 
  int depth ; 
  Scheme_Object * b , * v ; 
  Scheme_Hash_Tree * source_names ; 
  Scheme_Performance_State perf_state ; 
  Scheme_Config * __funcarg87 = NULLED_OUT ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(source_names, 0), PUSH(instance, 1), PUSH(p, 2), PUSH(instances, 3), PUSH(v, 4), PUSH(linklet, 5), PUSH(b, 6)));
# define XfOrM169_COUNT (7)
# define SETUP_XfOrM169(x) SETUP(XfOrM169_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  b = NULLED_OUT ; 
  v = NULLED_OUT ; 
  source_names = NULLED_OUT ; 

# 1362 "bc/src/linklet.c"
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  depth = linklet -> max_let_depth ; 
  if (! FUNCCALL(SETUP_XfOrM169(_), scheme_check_runstack (depth ) )) {
#   define XfOrM176_COUNT (0+XfOrM169_COUNT)
#   define SETUP_XfOrM176(x) SETUP_XfOrM169(x)

# 1368 "bc/src/linklet.c"
    p -> ku . k . p1 = linklet ; 
    p -> ku . k . p2 = instance ; 
    p -> ku . k . p3 = instances ; 
    p -> ku . k . i1 = multi ; 
    p -> ku . k . i2 = num_instances ; 
    p -> ku . k . i3 = use_prompt ; 
    RET_VALUE_START ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM176(_), scheme_enlarge_runstack (depth , instantiate_linklet_k ) )) RET_VALUE_END ; 
  }
  FUNCCALL(SETUP_XfOrM169(_), scheme_performance_record_start (& perf_state ) )
  ; 

  if (! linklet -> jit_ready ) {
#   define XfOrM175_COUNT (0+XfOrM169_COUNT)
#   define SETUP_XfOrM175(x) SETUP_XfOrM169(x)

# 1380 "bc/src/linklet.c"
    b = (__funcarg87 = FUNCCALL(SETUP_XfOrM175(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg87 , MZCONFIG_USE_JIT ) )) ; 
    if (! (((b ) ) == (scheme_false ) ) ) 
      linklet = FUNCCALL(SETUP_XfOrM175(_), scheme_jit_linklet (linklet , 2 ) ); 
  }

# 1383 "bc/src/linklet.c"
  else {
#   define XfOrM174_COUNT (0+XfOrM169_COUNT)
#   define SETUP_XfOrM174(x) SETUP_XfOrM169(x)

# 1384 "bc/src/linklet.c"
    linklet = FUNCCALL(SETUP_XfOrM174(_), scheme_jit_linklet (linklet , 2 ) ); 
  }


  source_names = FUNCCALL(SETUP_XfOrM169(_), push_prefix (linklet , instance , num_instances , instances , linklet -> source_names ) ); 



  if (source_names -> count ) {
#   define XfOrM170_COUNT (0+XfOrM169_COUNT)
#   define SETUP_XfOrM170(x) SETUP_XfOrM169(x)

# 1393 "bc/src/linklet.c"
    if (instance -> source_names -> count ) {
      mzlonglong pos ; 
      Scheme_Hash_Tree * ht = instance -> source_names ; 
      Scheme_Object * k , * v ; 
      BLOCK_SETUP((PUSH(k, 0+XfOrM170_COUNT), PUSH(ht, 1+XfOrM170_COUNT), PUSH(v, 2+XfOrM170_COUNT)));
#     define XfOrM171_COUNT (3+XfOrM170_COUNT)
#     define SETUP_XfOrM171(x) SETUP(XfOrM171_COUNT)
      k = NULLED_OUT ; 
      v = NULLED_OUT ; 

# 1397 "bc/src/linklet.c"
      pos = (scheme_hash_tree_next (source_names , - 1 ) ) ; 
      while (pos != - 1 ) {
#       define XfOrM173_COUNT (0+XfOrM171_COUNT)
#       define SETUP_XfOrM173(x) SETUP_XfOrM171(x)
        (
# 1399 "bc/src/linklet.c"
        scheme_hash_tree_index (source_names , pos , & k , & v ) ) ; 
        ht = FUNCCALL(SETUP_XfOrM173(_), scheme_hash_tree_set (ht , k , v ) ); 
        pos = (scheme_hash_tree_next (source_names , pos ) ) ; 
      }
      instance -> source_names = ht ; 
    }

# 1404 "bc/src/linklet.c"
    else 
    instance -> source_names = source_names ; 
  }

  v = FUNCCALL(SETUP_XfOrM169(_), eval_linklet_body (linklet , instance , use_prompt ) ); 
  FUNCCALL(SETUP_XfOrM169(_), pop_prefix () )
  ; 

  if (! multi )
    v = FUNCCALL(SETUP_XfOrM169(_), scheme_check_one_value (v ) ); 
  FUNCCALL(SETUP_XfOrM169(_), scheme_performance_record_end ("instantiate" , & perf_state ) )
# 1447 "bc/src/linklet.c"
  ; 

  RET_VALUE_START ((void * ) v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1452 "bc/src/linklet.c"
static Scheme_Object * do_instantiate_linklet (Scheme_Linklet * linklet , Scheme_Instance * instance , 
int num_instances , Scheme_Instance * * instances , 
int use_prompt , int multi , int top ) 
{
  /* No conversion */

# 1456 "bc/src/linklet.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = linklet ; 
  p -> ku . k . p2 = instance ; 
  p -> ku . k . p3 = instances ; 

  p -> ku . k . i1 = multi ; 
  p -> ku . k . i2 = num_instances ; 
  p -> ku . k . i3 = use_prompt ; 

  if (top )
    return (Scheme_Object * ) scheme_top_level_do (instantiate_linklet_k , 1 ) ; 
  else 
  return (Scheme_Object * ) instantiate_linklet_k () ; 
}

static Scheme_Object * _instantiate_linklet_multi (Scheme_Linklet * linklet , Scheme_Instance * instance , 
int num_instances , Scheme_Instance * * instances , 
int use_prompt ) 
{
  /* No conversion */

# 1476 "bc/src/linklet.c"
  return do_instantiate_linklet (linklet , instance , num_instances , instances , use_prompt , 1 , 0 ) ; 
}

Scheme_Object * scheme_instantiate_linklet_multi (Scheme_Linklet * linklet , Scheme_Instance * instance , 
int num_instances , Scheme_Instance * * instances , 
int use_prompt ) 
{
  /* No conversion */

# 1483 "bc/src/linklet.c"
  return do_instantiate_linklet (linklet , instance , num_instances , instances , use_prompt , 1 , 1 ) ; 
}





Scheme_Prefix * scheme_allocate_linklet_prefix (Scheme_Linklet * linklet , int extra ) 
{
  /* No conversion */

# 1492 "bc/src/linklet.c"
  int num_defns , n ; 

  num_defns = (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) ; 

  n = 1 + linklet -> num_total_imports + num_defns + extra ; 

  return scheme_allocate_prefix (n ) ; 
}

Scheme_Prefix * scheme_allocate_prefix (intptr_t n ) 
{
  Scheme_Prefix * pf ; 
  int tl_map_len ; 
  DECL_RET_SAVE (Scheme_Prefix * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pf, 0)));
# define XfOrM181_COUNT (1)
# define SETUP_XfOrM181(x) SETUP(XfOrM181_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pf = NULLED_OUT ; 

# 1506 "bc/src/linklet.c"
  tl_map_len = (n + 31 ) / 32 ; 

  pf = FUNCCALL(SETUP_XfOrM181(_), GC_malloc_one_tagged (sizeof (Scheme_Prefix ) + ((n - 0 ) * sizeof (Scheme_Object * ) ) + (tl_map_len * sizeof (int ) ) ) )

  ; 
  pf -> iso . so . type = scheme_prefix_type ; 
  pf -> num_slots = n ; 

  RET_VALUE_START (pf ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1517 "bc/src/linklet.c"
static Scheme_Hash_Tree * push_prefix (Scheme_Linklet * linklet , Scheme_Instance * instance , 
int num_instances , Scheme_Instance * * instances , 
Scheme_Hash_Tree * source_names ) 
{
  Scheme_Object * * rs , * v ; 
  Scheme_Prefix * pf ; 
  int i , j , pos , num_importss , num_defns , starts_empty ; 
  GC_CAN_IGNORE const char * bad_reason = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Hash_Tree * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(source_names, 0), PUSH(pf, 1), PUSH(instance, 2), PUSH(instances, 3), PUSH(rs, 4), PUSH(linklet, 5), PUSH(v, 6)));
# define XfOrM182_COUNT (7)
# define SETUP_XfOrM182(x) SETUP(XfOrM182_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  rs = NULLED_OUT ; 
  v = NULLED_OUT ; 
  pf = NULLED_OUT ; 

# 1526 "bc/src/linklet.c"
  rs = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 

  num_importss = (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ; 
  num_defns = (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) ; 

  pf = linklet -> static_prefix ; 
  if (! pf )
    pf = FUNCCALL(SETUP_XfOrM182(_), scheme_allocate_linklet_prefix (linklet , 0 ) ); 

  -- rs ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = rs ; 
  rs [0 ] = (Scheme_Object * ) pf ; 

  pos = 0 ; 


  if (linklet -> need_instance_access )
    v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM182(_), scheme_instance_variable_bucket (scheme_false , instance ) ); 
  else 
  v = ((void * ) 0 ) ; 
  pf -> a [pos ++ ] = v ; 

  for (j = 0 ; j < num_importss ; j ++ ) {
    int num_imports = (((Scheme_Vector * ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [j ] ) ) -> size ) ; 
#   define XfOrM223_COUNT (0+XfOrM182_COUNT)
#   define SETUP_XfOrM223(x) SETUP_XfOrM182(x)

# 1550 "bc/src/linklet.c"
    for (i = 0 ; i < num_imports ; i ++ ) {
#     define XfOrM234_COUNT (0+XfOrM223_COUNT)
#     define SETUP_XfOrM234(x) SETUP_XfOrM223(x)

# 1551 "bc/src/linklet.c"
      v = (((Scheme_Vector * ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [j ] ) ) -> els ) [i ] ; 
      v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM234(_), scheme_instance_variable_bucket (v , (Scheme_Instance * ) instances [j ] ) ); 

      if (v ) {
#       define XfOrM236_COUNT (0+XfOrM234_COUNT)
#       define SETUP_XfOrM236(x) SETUP_XfOrM234(x)

# 1555 "bc/src/linklet.c"
        if (! ((Scheme_Bucket * ) v ) -> val ) {
          bad_reason = "is uninitialized" ; 
          v = ((void * ) 0 ) ; 
        }

# 1558 "bc/src/linklet.c"
        else if (linklet -> import_shapes ) {
          Scheme_Object * shape = (((Scheme_Vector * ) (linklet -> import_shapes ) ) -> els ) [pos - 1 ] ; 
#         define XfOrM237_COUNT (0+XfOrM236_COUNT)
#         define SETUP_XfOrM237(x) SETUP_XfOrM236(x)

# 1560 "bc/src/linklet.c"
          if ((shape ) == (scheme_void ) )  {

            bad_reason = ((void * ) 0 ) ; 
          }

# 1563 "bc/src/linklet.c"
          else if ((shape ) == (scheme_true ) )  {
            if (! (((Scheme_Bucket_With_Flags * ) v ) -> flags & 2 ) ) {
              bad_reason = "is not a procedure or structure-type constant across all instantiations" ; 
              v = ((void * ) 0 ) ; 
            }
          }

# 1568 "bc/src/linklet.c"
          else if (! (((shape ) ) == (scheme_false ) ) )  {
#           define XfOrM238_COUNT (0+XfOrM237_COUNT)
#           define SETUP_XfOrM238(x) SETUP_XfOrM237(x)

# 1569 "bc/src/linklet.c"
            if (! FUNCCALL(SETUP_XfOrM238(_), scheme_get_or_check_procedure_shape (((Scheme_Bucket * ) v ) -> val , shape , 0 ) )) {
              bad_reason = "has the wrong procedure or structure-type shape" ; 
              v = ((void * ) 0 ) ; 
            }
          }
        }
      }

# 1575 "bc/src/linklet.c"
      else 
      bad_reason = "is not exported" ; 

      if (! v ) {
#       define XfOrM235_COUNT (0+XfOrM234_COUNT)
#       define SETUP_XfOrM235(x) SETUP_XfOrM234(x)
        FUNCCALL_EMPTY(scheme_signal_error ("instantiate-linklet: mismatch;\n" " reference to a variable that %s;\n" " possibly, bytecode file needs re-compile because dependencies changed\n" "  name: %D\n" "  exporting instance: %D\n" "  importing instance: %D" , bad_reason , (((Scheme_Vector * ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [j ] ) ) -> els ) [i ] , instances [j ] -> name , instance -> name ) )






        ; 
      }
      pf -> a [pos ++ ] = v ; 
    }
  }

  starts_empty = (! instance -> array_size && ! instance -> variables . bt ) ; 

  if (! num_defns ) {
  }
  else if (starts_empty && (num_defns < 10 ) ) {


    Scheme_Bucket * * a , * b ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM182_COUNT), PUSH(b, 1+XfOrM182_COUNT)));
#   define XfOrM194_COUNT (2+XfOrM182_COUNT)
#   define SETUP_XfOrM194(x) SETUP(XfOrM194_COUNT)
    a = NULLED_OUT ; 
    b = NULLED_OUT ; 

# 1603 "bc/src/linklet.c"
    a = ((Scheme_Bucket * * ) FUNCCALL(SETUP_XfOrM194(_), GC_malloc (sizeof (Scheme_Bucket * ) * (num_defns ) ) )) ; 
    for (i = 0 ; i < num_defns ; i ++ ) {
#     define XfOrM198_COUNT (0+XfOrM194_COUNT)
#     define SETUP_XfOrM198(x) SETUP_XfOrM194(x)

# 1605 "bc/src/linklet.c"
      v = (((Scheme_Vector * ) (linklet -> defns ) ) -> els ) [i ] ; 
      if (((v ) ) == (scheme_false ) )  {
        pf -> a [pos ++ ] = ((void * ) 0 ) ; 
      }

# 1608 "bc/src/linklet.c"
      else {
#       define XfOrM199_COUNT (0+XfOrM198_COUNT)
#       define SETUP_XfOrM199(x) SETUP_XfOrM198(x)

# 1609 "bc/src/linklet.c"
        b = FUNCCALL(SETUP_XfOrM199(_), make_bucket (v , ((void * ) 0 ) , instance ) ); 
        a [i ] = b ; 
        pf -> a [pos ++ ] = (Scheme_Object * ) b ; 
      }
    }

    instance -> array_size = num_defns ; 
    instance -> variables . a = a ; 
  }

# 1617 "bc/src/linklet.c"
  else {
#   define XfOrM183_COUNT (0+XfOrM182_COUNT)
#   define SETUP_XfOrM183(x) SETUP_XfOrM182(x)

# 1619 "bc/src/linklet.c"
    for (i = 0 ; i < num_defns ; i ++ ) {
#     define XfOrM189_COUNT (0+XfOrM183_COUNT)
#     define SETUP_XfOrM189(x) SETUP_XfOrM183(x)

# 1620 "bc/src/linklet.c"
      v = (((Scheme_Vector * ) (linklet -> defns ) ) -> els ) [i ] ; 
      if (((v ) ) == (scheme_false ) )  {
        v = ((void * ) 0 ) ; 
      }

# 1623 "bc/src/linklet.c"
      else {
#       define XfOrM190_COUNT (0+XfOrM189_COUNT)
#       define SETUP_XfOrM190(x) SETUP_XfOrM189(x)

# 1624 "bc/src/linklet.c"
        if ((i >= linklet -> num_exports ) && ! starts_empty ) {
#         define XfOrM191_COUNT (0+XfOrM190_COUNT)
#         define SETUP_XfOrM191(x) SETUP_XfOrM190(x)

# 1626 "bc/src/linklet.c"
          if (FUNCCALL(SETUP_XfOrM191(_), scheme_instance_variable_bucket_or_null (v , instance ) )) {
#           define XfOrM192_COUNT (0+XfOrM191_COUNT)
#           define SETUP_XfOrM192(x) SETUP_XfOrM191(x)

# 1627 "bc/src/linklet.c"
            v = FUNCCALL(SETUP_XfOrM192(_), generate_bucket_name (v , instance ) ); 
            source_names = FUNCCALL(SETUP_XfOrM192(_), update_source_names (source_names , (((Scheme_Vector * ) (linklet -> defns ) ) -> els ) [i ] , v ) ); 
          }
        }
        v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM190(_), scheme_instance_variable_bucket (v , instance ) ); 
      }
      pf -> a [pos ++ ] = v ; 
    }
  }

  RET_VALUE_START (source_names ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1640 "bc/src/linklet.c"
static void pop_prefix () 
{
  /* No conversion */

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ++ ; 
}

static Scheme_Object * suspend_prefix () 
{
  /* No conversion */

# 1649 "bc/src/linklet.c"
  Scheme_Object * v ; 
  v = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) [0 ] ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ++ ; 
  return v ; 
}

static void resume_prefix (Scheme_Object * v ) 
{
  /* No conversion */

# 1657 "bc/src/linklet.c"
  -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) [0 ] = v ; 
}


static void mark_pruned_prefixes (struct NewGC * gc ) XFORM_SKIP_PROC 
{
  if (! GC_is_partial (gc ) ) {
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_inc_prefix_finalize_ ) != (Scheme_Prefix * ) 0x1 ) {
      Scheme_Prefix * pf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_inc_prefix_finalize_ ) ; 
      while (pf -> next_final != (Scheme_Prefix * ) 0x1 ) {
        pf = pf -> next_final ; 
      }
      pf -> next_final = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prefix_finalize_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prefix_finalize_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_inc_prefix_finalize_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_inc_prefix_finalize_ ) = (Scheme_Prefix * ) 0x1 ; 
    }
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prefix_finalize_ ) != (Scheme_Prefix * ) 0x1 ) {
    Scheme_Prefix * pf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prefix_finalize_ ) , * next ; 
    Scheme_Object * clo ; 
    int i , * use_bits , maxpos ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prefix_finalize_ ) = (Scheme_Prefix * ) 0x1 ; 
    while (pf != (Scheme_Prefix * ) 0x1 ) {

      if (! GC_is_marked2 (pf , gc ) ) {

        maxpos = pf -> num_slots ; 
        use_bits = (int * ) ((char * ) pf + sizeof (Scheme_Prefix ) + ((pf -> num_slots - 0 ) * sizeof (Scheme_Object * ) ) ) ; 
        for (i = (maxpos + 31 ) / 32 ; i -- ; ) {
          int j ; 
          for (j = 0 ; j < 32 ; j ++ ) {
            if (! (use_bits [i ] & ((unsigned ) 1 << j ) ) ) {
              int pos ; 
              pos = (i * 32 ) + j ; 
              if (pos < maxpos )
                pf -> a [pos ] = ((void * ) 0 ) ; 
            }
          }
          use_bits [i ] = 0 ; 
        }




        GC_mark_no_recur (gc , 1 ) ; 
        GC_mark2 (& (pf ) , gc ) ; 
        pf = (Scheme_Prefix * ) GC_resolve2 (pf , gc ) ; 
        GC_retract_only_mark_stack_entry (pf , gc ) ; 
        GC_mark_no_recur (gc , 0 ) ; 
        pf -> saw_num_slots = - 1 ; 
      }

# 1710 "bc/src/linklet.c"
      else 
      pf = (Scheme_Prefix * ) GC_resolve2 (pf , gc ) ; 


      use_bits = (int * ) ((char * ) pf + sizeof (Scheme_Prefix ) + ((pf -> num_slots - 0 ) * sizeof (Scheme_Object * ) ) ) ; 
      maxpos = pf -> num_slots ; 
      for (i = (maxpos + 31 ) / 32 ; i -- ; ) 
      use_bits [i ] = 0 ; 


      clo = (Scheme_Object * ) GC_resolve2 (pf -> fixup_chain , gc ) ; 
      pf -> fixup_chain = ((void * ) 0 ) ; 
      while (clo ) {
        Scheme_Object * next ; 
        if (((((intptr_t ) (clo ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clo ) ) -> type ) == scheme_closure_type ) {
          Scheme_Closure * cl = (Scheme_Closure * ) clo ; 
          int closure_size = ((Scheme_Lambda * ) GC_resolve2 (cl -> code , gc ) ) -> closure_size ; 
          next = cl -> vals [closure_size - 1 ] ; 
          cl -> vals [closure_size - 1 ] = (Scheme_Object * ) pf ; 
        }

# 1729 "bc/src/linklet.c"
        else if (((((intptr_t ) (clo ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clo ) ) -> type ) == scheme_native_closure_type ) {
          Scheme_Native_Closure * cl = (Scheme_Native_Closure * ) clo ; 
          int closure_size = ((Scheme_Native_Lambda * ) GC_resolve2 (cl -> code , gc ) ) -> closure_size ; 
          next = cl -> vals [closure_size - 1 ] ; 
          cl -> vals [closure_size - 1 ] = (Scheme_Object * ) pf ; 
        }

# 1734 "bc/src/linklet.c"
        else {
          ((void ) sizeof ((0 ) ? 1 : 0 ) , __extension__ ({

# 1735 "bc/src/linklet.c" 3
            if (0 )

# 1735 "bc/src/linklet.c" 3
            ; 

# 1735 "bc/src/linklet.c" 3
            else __assert_fail ("0" , "bc/src/linklet.c" , 1735 , __extension__ __PRETTY_FUNCTION__ ) ; 
          }
          ) ) 
# 1735 "bc/src/linklet.c"
          ; 
          next = ((void * ) 0 ) ; 
        }
        clo = (Scheme_Object * ) GC_resolve2 (next , gc ) ; 
      }
      if ((& (pf ) -> iso ) -> so . keyex & 0x1 )
        (& (pf ) -> iso ) -> so . keyex -= 0x1 ; 


      next = pf -> next_final ; 
      pf -> next_final = ((void * ) 0 ) ; 

      pf = next ; 
    }
  }
}

int check_pruned_prefix (void * p ) XFORM_SKIP_PROC 
{
  Scheme_Prefix * pf = (Scheme_Prefix * ) p ; 
  return (& (pf ) -> iso ) -> so . keyex & 0x1 ; 
}






static intptr_t nested_delta , nested_gc_delta ; 
static int perf_reg , perf_count ; 

typedef struct {
  const char * name ; 
  intptr_t accum ; 
  intptr_t gc_accum ; 
  intptr_t count ; 
}

# 1771 "bc/src/linklet.c"
Performance_Entry ; 



static Performance_Entry perf_entries [16 ] ; 




typedef struct {
  const char * name ; 
  Performance_Entry perf_entries [3 ] ; 
  int perf_count ; 
}

# 1784 "bc/src/linklet.c"
Performance_Cat ; 

typedef struct {
  const char * entry ; 
  const char * cat ; 
}

# 1789 "bc/src/linklet.c"
Performace_Recat ; 

static Performace_Recat recats [] = {

# 1791 "bc/src/linklet.c"
  {

# 1791 "bc/src/linklet.c"
    "instantiate" , "run" }

# 1791 "bc/src/linklet.c"
  , 
  {

# 1792 "bc/src/linklet.c"
    "jit" , "run" }

# 1792 "bc/src/linklet.c"
  , 
  {

# 1793 "bc/src/linklet.c"
    "comp-ffi-call" , "comp-ffi" }

# 1793 "bc/src/linklet.c"
  , 
  {

# 1794 "bc/src/linklet.c"
    "comp-ffi-back" , "comp-ffi" }

# 1794 "bc/src/linklet.c"
  , 
  {

# 1795 "bc/src/linklet.c"
    ((void * ) 0 ) , ((void * ) 0 ) }
}

# 1795 "bc/src/linklet.c"
; 

static char * do_tab (int len , char * tab , int max_len ) 
{
  /* No conversion */

# 1799 "bc/src/linklet.c"
  int i ; 

  len = max_len - len ; 
  if (len < 0 )
    len = 0 ; 
  for (i = 0 ; i < len ; i ++ ) {
    tab [i ] = ' ' ; 
  }
  tab [i ] = 0 ; 

  return tab ; 
}

static int numlen (intptr_t n ) 
{
  /* No conversion */

# 1814 "bc/src/linklet.c"
  int len = 1 ; 

  while (n >= 10 ) {
    n = n / 10 ; 
    len ++ ; 
  }

  return len ; 
}

static char * tab_number (intptr_t n , char * tab , int max_len ) 
{

# 1812 "bc/src/linklet.c"
  int __funcarg91 ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(tab, 0)));
# define XfOrM253_COUNT (1)
# define SETUP_XfOrM253(x) SETUP(XfOrM253_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)





  RET_VALUE_START ((__funcarg91 = FUNCCALL(SETUP_XfOrM253(_), numlen (n ) ), FUNCCALL_EMPTY(do_tab (__funcarg91 , tab , max_len ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1829 "bc/src/linklet.c"
static char * tab_string (const char * s , char * tab , int max_len ) 
{
  /* No conversion */

# 1831 "bc/src/linklet.c"
  return do_tab (strlen (s ) , tab , max_len ) ; 
}

static void sort_perf (Performance_Entry * pref_entries , int lo , int hi ) 
{
  /* No conversion */

# 1836 "bc/src/linklet.c"
  int i , pivot ; 

  if (lo >= hi )
    return ; 

  pivot = lo ; 
  for (i = lo + 1 ; i < hi ; i ++ ) {
    if (perf_entries [i ] . accum < perf_entries [pivot ] . accum ) {
      Performance_Entry tmp = perf_entries [pivot ] ; 
      perf_entries [pivot ] = perf_entries [i ] ; 
      perf_entries [i ] = perf_entries [pivot + 1 ] ; 
      perf_entries [pivot + 1 ] = tmp ; 
      pivot ++ ; 
    }
  }

  sort_perf (perf_entries , lo , pivot ) ; 
  sort_perf (perf_entries , pivot + 1 , hi ) ; 
}

static void show_perf (Performance_Entry * perf_entries , int perf_count , 
int len , int name_len , int gc_len , 
int depth ) 
{
  intptr_t total = 0 , gc_total = 0 ; 
  int i , j , k , m , n ; 
  char name_tab [16 ] , tab [10 ] , gc_tab [10 ] , pre_indent [8 ] , post_indent [8 ] ; 
  Performance_Cat cats [3 ] ; 
  int num_cats = 0 ; 

# 1824 "bc/src/linklet.c"
  char * __funcarg100 = NULLED_OUT ; 

# 1824 "bc/src/linklet.c"
  char * __funcarg99 = NULLED_OUT ; 




  char * __funcarg98 = NULLED_OUT ; 

# 1824 "bc/src/linklet.c"
  char * __funcarg94 = NULLED_OUT ; 




  char * __funcarg93 = NULLED_OUT ; 

# 1824 "bc/src/linklet.c"
  char * __funcarg92 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(17);
  BLOCK_SETUP_TOP((PUSH(__funcarg93, 0), PUSH(cats[0].name, 1), PUSH(cats[0].perf_entries[0].name, 2), PUSH(cats[0].perf_entries[1].name, 3), PUSH(cats[0].perf_entries[2].name, 4), PUSH(cats[1].name, 5), PUSH(cats[1].perf_entries[0].name, 6), PUSH(cats[1].perf_entries[1].name, 7), PUSH(cats[1].perf_entries[2].name, 8), PUSH(cats[2].name, 9), PUSH(cats[2].perf_entries[0].name, 10), PUSH(cats[2].perf_entries[1].name, 11), PUSH(cats[2].perf_entries[2].name, 12), PUSH(__funcarg92, 13), PUSH(perf_entries, 14), PUSH(__funcarg98, 15), PUSH(__funcarg99, 16)));
# define XfOrM260_COUNT (17)
# define SETUP_XfOrM260(x) SETUP(XfOrM260_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cats[0].name = NULLED_OUT ; 
  cats[0].perf_entries[0].name = NULLED_OUT ; 
  cats[0].perf_entries[1].name = NULLED_OUT ; 
  cats[0].perf_entries[2].name = NULLED_OUT ; 
  cats[1].name = NULLED_OUT ; 
  cats[1].perf_entries[0].name = NULLED_OUT ; 
  cats[1].perf_entries[1].name = NULLED_OUT ; 
  cats[1].perf_entries[2].name = NULLED_OUT ; 
  cats[2].name = NULLED_OUT ; 
  cats[2].perf_entries[0].name = NULLED_OUT ; 
  cats[2].perf_entries[1].name = NULLED_OUT ; 
  cats[2].perf_entries[2].name = NULLED_OUT ; 
  (
# 1866 "bc/src/linklet.c"
  memset (cats , 0 , sizeof (cats ) ) ) ; 

  if (! depth ) {
#   define XfOrM274_COUNT (0+XfOrM260_COUNT)
#   define SETUP_XfOrM274(x) SETUP_XfOrM260(x)

# 1869 "bc/src/linklet.c"
    for (i = 0 ; i < perf_count ; i ++ ) {
#     define XfOrM292_COUNT (0+XfOrM274_COUNT)
#     define SETUP_XfOrM292(x) SETUP_XfOrM274(x)

# 1870 "bc/src/linklet.c"
      for (j = 0 ; recats [j ] . entry ; j ++ ) {
#       define XfOrM301_COUNT (0+XfOrM292_COUNT)
#       define SETUP_XfOrM301(x) SETUP_XfOrM292(x)

# 1871 "bc/src/linklet.c"
        if (! (strcmp (recats [j ] . entry , perf_entries [i ] . name ) ) ) {
#         define XfOrM302_COUNT (0+XfOrM301_COUNT)
#         define SETUP_XfOrM302(x) SETUP_XfOrM301(x)

# 1872 "bc/src/linklet.c"
          for (m = 0 ; m < num_cats ; m ++ ) {
#           define XfOrM308_COUNT (0+XfOrM302_COUNT)
#           define SETUP_XfOrM308(x) SETUP_XfOrM302(x)

# 1873 "bc/src/linklet.c"
            if (! (strcmp (recats [j ] . cat , cats [m ] . name ) ) )
              break ; 
          }
          if (num_cats <= m )

# 1876 "bc/src/linklet.c"
          num_cats = m + 1 ; 
          cats [m ] . name = recats [j ] . cat ; 
          for (k = 0 ; k < perf_count ; k ++ ) {
#           define XfOrM305_COUNT (0+XfOrM302_COUNT)
#           define SETUP_XfOrM305(x) SETUP_XfOrM302(x)

# 1879 "bc/src/linklet.c"
            if (perf_entries [k ] . name ) {
#             define XfOrM306_COUNT (0+XfOrM305_COUNT)
#             define SETUP_XfOrM306(x) SETUP_XfOrM305(x)

# 1880 "bc/src/linklet.c"
              if (! (strcmp (perf_entries [k ] . name , recats [j ] . cat ) ) )
                break ; 
            }

# 1882 "bc/src/linklet.c"
            else 
            break ; 
          }
          perf_entries [k ] . name = recats [j ] . cat ; 
          if (perf_count <= k )

# 1886 "bc/src/linklet.c"
          perf_count = k + 1 ; 
          perf_entries [k ] . accum += perf_entries [i ] . accum ; 
          perf_entries [k ] . gc_accum += perf_entries [i ] . gc_accum ; 
          perf_entries [k ] . count = - 1 ; 

          n = cats [m ] . perf_count ++ ; 
          cats [m ] . perf_entries [n ] = perf_entries [i ] ; 
          perf_entries [i ] . accum = 0 ; 
          perf_entries [i ] . gc_accum = 0 ; 
          perf_entries [i ] . count = 0 ; 
        }
      }
    }
  }
  FUNCCALL(SETUP_XfOrM260(_), sort_perf (perf_entries , 0 , perf_count ) )
  ; 

  for (i = 0 ; i < perf_count ; i ++ ) {
    n = strlen (perf_entries [i ] . name ) ; 
    if (n > name_len )

# 1905 "bc/src/linklet.c"
    name_len = n ; 
    total += perf_entries [i ] . accum ; 
    gc_total += perf_entries [i ] . gc_accum ; 
  }

  n = FUNCCALL(SETUP_XfOrM260(_), numlen (total ) ); 
  if (n > len )

# 1911 "bc/src/linklet.c"
  len = n ; 
  n = FUNCCALL(SETUP_XfOrM260(_), numlen (gc_total ) ); 
  if (n > gc_len )

# 1913 "bc/src/linklet.c"
  gc_len = n ; 

  if (name_len >= sizeof (name_tab ) )
    name_len = sizeof (name_tab ) - 1 ; 
  if (len >= sizeof (tab ) )
    len = sizeof (tab ) - 1 ; 
  if (gc_len >= sizeof (gc_tab ) )
    gc_len = sizeof (gc_tab ) - 1 ; 

  for (i = 0 ; i < depth * 2 ; i ++ ) {
    pre_indent [i ] = ' ' ; 
  }
  pre_indent [i ] = 0 ; 
  for (i = 0 ; i < (3 - depth ) * 2 ; i ++ ) {
    post_indent [i ] = ' ' ; 
  }
  post_indent [i ] = 0 ; 

  if (! depth )
    FUNCCALL(SETUP_XfOrM260(_), scheme_log (((void * ) 0 ) , 2 , 0 , ";;" ) ); 




  for (i = 0 ; i < perf_count ; i ++ ) {
#   define XfOrM265_COUNT (0+XfOrM260_COUNT)
#   define SETUP_XfOrM265(x) SETUP_XfOrM260(x)

# 1938 "bc/src/linklet.c"
    if (perf_entries [i ] . count )
      (__funcarg98 = FUNCCALL(SETUP_XfOrM265(_), tab_string (perf_entries [i ] . name , name_tab , name_len ) )





    , __funcarg99 = FUNCCALL(SETUP_XfOrM265(_), tab_number (perf_entries [i ] . accum , tab , len ) )

    , __funcarg100 = FUNCCALL(SETUP_XfOrM265(_), tab_number (perf_entries [i ] . gc_accum , gc_tab , gc_len ) )

    , FUNCCALL_AGAIN(scheme_log (((void * ) 0 ) , 2 , 0 , ((perf_entries [i ] . count < 0 ) ? ";; %s%s%s%s  %s%ld [%s%ld] ms" : ";; %s%s%s%s  %s%ld [%s%ld] ms" " ; %ld times" ) , pre_indent , perf_entries [i ] . name , __funcarg98 , post_indent , __funcarg99 , perf_entries [i ] . accum , __funcarg100 , perf_entries [i ] . gc_accum , perf_entries [i ] . count ) )) 

    ; 
    for (m = 0 ; m < num_cats ; m ++ ) {
#     define XfOrM267_COUNT (0+XfOrM265_COUNT)
#     define SETUP_XfOrM267(x) SETUP_XfOrM265(x)

# 1953 "bc/src/linklet.c"
      if (! (strcmp (perf_entries [i ] . name , cats [m ] . name ) ) )
        FUNCCALL(SETUP_XfOrM267(_), show_perf (cats [m ] . perf_entries , cats [m ] . perf_count , len , name_len , gc_len , depth + 1 ) ); 
    }
  }

  if (! depth ) {
#   define XfOrM261_COUNT (0+XfOrM260_COUNT)
#   define SETUP_XfOrM261(x) SETUP_XfOrM260(x)
    (__funcarg92 = FUNCCALL(SETUP_XfOrM261(_), tab_number (total , tab , len ) ), __funcarg93 = FUNCCALL(SETUP_XfOrM261(_), tab_string ("total" , name_tab , name_len ) )
    , __funcarg94 = FUNCCALL(SETUP_XfOrM261(_), tab_number (gc_total , gc_tab , gc_len ) )


    , FUNCCALL_AGAIN(scheme_log (((void * ) 0 ) , 2 , 0 , ";; %stotal%s  %s%ld [%s%ld] ms" , __funcarg92 , __funcarg93 , post_indent , total , __funcarg94 , gc_total ) )) 
    ; 
    FUNCCALL(SETUP_XfOrM261(_), scheme_log (((void * ) 0 ) , 2 , 0 , ";;" ) )
    ; 
    FUNCCALL_AGAIN(scheme_log (((void * ) 0 ) , 2 , 0 , ";; [JIT code: %d procs  %d bytes  code+admin: %d bytes]" , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_count_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_total_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) ) )



    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1978 "bc/src/linklet.c"
static void show_all_perf () 
{
  /* No conversion */

# 1980 "bc/src/linklet.c"
  return show_perf (perf_entries , perf_count , 0 , 0 , 0 , 0 ) ; 
}

void scheme_performance_record_start (GC_CAN_IGNORE Scheme_Performance_State * perf_state ) 
{
  /* No conversion */
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) != 0 )
    return ; 


  if (! perf_reg ) {
    if (scheme_getenv ("PLT_LINKLET_TIMES" ) ) {
      perf_reg = 1 ; 
      scheme_atexit (show_all_perf ) ; 
    }

# 1994 "bc/src/linklet.c"
    else {
      perf_reg = - 1 ; 
    }
  }

  if (perf_reg < 0 )
    return ; 

  perf_state -> gc_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ; 
  perf_state -> start = scheme_get_process_milliseconds () ; 
  perf_state -> old_nested_delta = nested_delta ; 
  perf_state -> old_nested_gc_delta = nested_gc_delta ; 

  nested_delta = 0 ; 
  nested_gc_delta = 0 ; 
}

void scheme_performance_record_end (const char * who , GC_CAN_IGNORE Scheme_Performance_State * perf_state ) 
{
  /* No conversion */

# 2013 "bc/src/linklet.c"
  int i ; 
  intptr_t d , gc_d ; 
  Scheme_Performance_State zero_perf_state ; 


  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) != 0 )
    return ; 


  if (perf_reg < 0 )
    return ; 

  for (i = 0 ; i < 16 ; i ++ ) {
    if (perf_entries [i ] . name ) {
      if (! strcmp (perf_entries [i ] . name , who ) )
        break ; 
    }

# 2029 "bc/src/linklet.c"
    else 
    break ; 
  }

  if (i >= 16 )
    return ; 

  if (! perf_state ) {
    memset (& zero_perf_state , 0 , sizeof (zero_perf_state ) ) ; 
    perf_state = & zero_perf_state ; 
  }

  d = (scheme_get_process_milliseconds () - perf_state -> start ) ; 
  gc_d = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) - perf_state -> gc_start ) ; 

  perf_state -> old_nested_delta += d ; 
  perf_state -> old_nested_gc_delta += gc_d ; 

  d -= nested_delta ; 
  gc_d -= nested_gc_delta ; 

  nested_delta = perf_state -> old_nested_delta ; 
  nested_gc_delta = perf_state -> old_nested_gc_delta ; 

  if (! perf_entries [i ] . name ) {
    perf_entries [i ] . name = who ; 
    perf_count ++ ; 
  }
  perf_entries [i ] . accum += d ; 
  perf_entries [i ] . gc_accum += gc_d ; 
  perf_entries [i ] . count ++ ; 
}

# 2072 "bc/src/linklet.c"
static void register_traversers (void ) 
{
}
