#include "precomp.h"

# 34 "bc/rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 121 "rktio/rktio.h"
typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 351 "rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "rktio/rktio.h"
rktio_process_result_t ; 

# 646 "rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "rktio/rktio.h"
rktio_status_t ; 

# 669 "rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "rktio/rktio.h"
rktio_identity_t ; 

# 925 "rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "rktio/rktio.h"
rktio_date_t ; 









__xform_nongcing__ extern double rktio_get_inexact_monotonic_milliseconds (rktio_t * rktio ) ; 

# 1109 "rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 

# 1378 "rktio/rktio.h"
enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 




enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

# 6 "bc/src/sema.c"
Scheme_Object * scheme_always_ready_evt ; 
Scheme_Object * scheme_never_ready_evt ; 
; 

static Scheme_Object * make_sema (int n , Scheme_Object * * p ) ; 
static Scheme_Object * semap (int n , Scheme_Object * * p ) ; 
static Scheme_Object * hit_sema (int n , Scheme_Object * * p ) ; 
static Scheme_Object * block_sema_p (int n , Scheme_Object * * p ) ; 
static Scheme_Object * block_sema (int n , Scheme_Object * * p ) ; 
static Scheme_Object * block_sema_breakable (int n , Scheme_Object * * p ) ; 
static Scheme_Object * make_sema_repost (int n , Scheme_Object * * p ) ; 
static Scheme_Object * is_sema_repost (int n , Scheme_Object * * p ) ; 

static Scheme_Object * make_channel (int n , Scheme_Object * * p ) ; 
static Scheme_Object * make_channel_put (int n , Scheme_Object * * p ) ; 
static Scheme_Object * channel_p (int n , Scheme_Object * * p ) ; 
static Scheme_Object * channel_put_p (int n , Scheme_Object * * p ) ; 
static Scheme_Object * chaperone_channel (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_channel (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * thread_send (int n , Scheme_Object * * p ) ; 
static Scheme_Object * thread_receive (int n , Scheme_Object * * p ) ; 
static Scheme_Object * thread_try_receive (int n , Scheme_Object * * p ) ; 
static Scheme_Object * thread_receive_evt (int n , Scheme_Object * * p ) ; 
static Scheme_Object * thread_rewind_receive (int n , Scheme_Object * * p ) ; 

static Scheme_Object * make_alarm (int n , Scheme_Object * * p ) ; 
static Scheme_Object * make_sys_idle (int n , Scheme_Object * * p ) ; 

static int channel_get_ready (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) ; 
static int channel_put_ready (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) ; 
static int channel_syncer_ready (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) ; 
static int alarm_ready (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) ; 
static int always_ready (Scheme_Object * w ) ; 
static int never_ready (Scheme_Object * w ) ; 
static int thread_recv_ready (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) ; 

static int pending_break (Scheme_Thread * p ) ; 

; 
; 
static Scheme_Object * thread_recv_evt ; 


static void register_traversers (void ) ; 


typedef struct {
  Scheme_Object so ; 
  double sleep_end ; 
  int is_monotonic ; 
}

# 57 "bc/src/sema.c"
Scheme_Alarm ; 


static int sema_ready (Scheme_Object * s ) 
{
  /* No conversion */

# 62 "bc/src/sema.c"
  return scheme_wait_sema (s , 1 ) ; 
}

static Scheme_Object * sema_for_repost (Scheme_Object * s , int * repost ) 
{
  /* No conversion */

# 67 "bc/src/sema.c"
  * repost = 1 ; 
  return (((Scheme_Small_Object * ) (s ) ) -> u . ptr_val ) ; 
}

void scheme_init_sema (Scheme_Startup_Env * env ) 
{
  Scheme_Object * o ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(env, 1)));
# define XfOrM3_COUNT (2)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM3(_), register_traversers () )
# 76 "bc/src/sema.c"
  ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (make_sema , "make-semaphore" , 0 , 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-semaphore" , __funcarg79 , env ) )) 
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (semap , "semaphore?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("semaphore?" , __funcarg78 , env ) )) 
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (hit_sema , "semaphore-post" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("semaphore-post" , __funcarg77 , env ) )) 
  ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (block_sema_p , "semaphore-try-wait?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("semaphore-try-wait?" , __funcarg76 , env ) )) 
  ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (block_sema , "semaphore-wait" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("semaphore-wait" , __funcarg75 , env ) )) 
  ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (block_sema_breakable , "semaphore-wait/enable-break" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("semaphore-wait/enable-break" , __funcarg74 , env ) )) 
  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (make_sema_repost , "semaphore-peek-evt" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("semaphore-peek-evt" , __funcarg73 , env ) )) 
  ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (is_sema_repost , "semaphore-peek-evt?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("semaphore-peek-evt?" , __funcarg72 , env ) )) 
  ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (make_channel , "make-channel" , 0 , 0 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-channel" , __funcarg71 , env ) )) 
  ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (make_channel_put , "channel-put-evt" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("channel-put-evt" , __funcarg70 , env ) )) 
  ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (channel_p , "channel?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("channel?" , __funcarg69 , env ) )) 
  ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (channel_put_p , "channel-put-evt?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("channel-put-evt?" , __funcarg68 , env ) )) 
  ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (chaperone_channel , "chaperone-channel" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-channel" , __funcarg67 , env ) )) 
  ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (impersonate_channel , "impersonate-channel" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-channel" , __funcarg66 , env ) )) 
  ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (thread_send , "thread-send" , 2 , 3 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-send" , __funcarg65 , env ) )) 
  ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (thread_receive , "thread-receive" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-receive" , __funcarg64 , env ) )) 
  ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (thread_try_receive , "thread-try-receive" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-try-receive" , __funcarg63 , env ) )) 
  ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (thread_receive_evt , "thread-receive-evt" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-receive-evt" , __funcarg62 , env ) )) 
  ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (thread_rewind_receive , "thread-rewind-receive" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-rewind-receive" , __funcarg61 , env ) )) 
  ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (make_alarm , "alarm-evt" , 1 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("alarm-evt" , __funcarg60 , env ) )) 
  ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (make_sys_idle , "system-idle-evt" , 0 , 0 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("system-idle-evt" , __funcarg59 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_always_ready_evt , sizeof (scheme_always_ready_evt ) ) )
  ; 
  scheme_always_ready_evt = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM3(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  scheme_always_ready_evt -> type = scheme_always_evt_type ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("always-evt" , scheme_always_ready_evt , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_never_ready_evt , sizeof (scheme_never_ready_evt ) ) )
  ; 
  scheme_never_ready_evt = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM3(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  scheme_never_ready_evt -> type = scheme_never_evt_type ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("never-evt" , scheme_never_ready_evt , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & thread_recv_evt , sizeof (thread_recv_evt ) ) )
  ; 
  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM3(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_thread_recv_evt_type ; 
  thread_recv_evt = o ; 
  FUNCCALL_EMPTY(scheme_add_evt (scheme_sema_type , sema_ready , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) )
  ; 
  FUNCCALL_EMPTY(scheme_add_evt_through_sema (scheme_semaphore_repost_type , sema_for_repost , ((void * ) 0 ) ) ); 
  FUNCCALL_EMPTY(scheme_add_evt (scheme_channel_type , (Scheme_Ready_Fun ) channel_get_ready , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ); 
  FUNCCALL_EMPTY(scheme_add_evt (scheme_channel_put_type , (Scheme_Ready_Fun ) channel_put_ready , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ); 
  FUNCCALL_EMPTY(scheme_add_evt (scheme_channel_syncer_type , (Scheme_Ready_Fun ) channel_syncer_ready , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
  FUNCCALL_EMPTY(scheme_add_evt (scheme_alarm_type , (Scheme_Ready_Fun ) alarm_ready , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
  FUNCCALL_EMPTY(scheme_add_evt (scheme_always_evt_type , always_ready , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
  FUNCCALL_EMPTY(scheme_add_evt (scheme_never_evt_type , never_ready , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
  FUNCCALL_EMPTY(scheme_add_evt (scheme_thread_recv_evt_type , (Scheme_Ready_Fun ) thread_recv_ready , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 216 "bc/src/sema.c"
void scheme_init_sema_places () {
  /* No conversion */

# 217 "bc/src/sema.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_system_idle_channel_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_system_idle_channel_ ) ) ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_system_idle_channel_ ) = scheme_make_channel () ; 
}

Scheme_Object * scheme_make_sema (intptr_t v ) 
{
  Scheme_Sema * sema ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sema, 0)));
# define XfOrM5_COUNT (1)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 

# 225 "bc/src/sema.c"
  sema = ((Scheme_Sema * ) FUNCCALL(SETUP_XfOrM5(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Sema ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  sema -> value = v ; 

  sema -> so . type = scheme_sema_type ; 

  RET_VALUE_START ((Scheme_Object * ) sema ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 233 "bc/src/sema.c"
intptr_t scheme_get_semaphore_init (const char * who , int n , Scheme_Object * * p ) 
{
  intptr_t v ; 
  char * __funcarg80 = NULLED_OUT ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(who, 1)));
# define XfOrM6_COUNT (2)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 237 "bc/src/sema.c"
  if (n ) {
#   define XfOrM7_COUNT (0+XfOrM6_COUNT)
#   define SETUP_XfOrM7(x) SETUP_XfOrM6(x)

# 238 "bc/src/sema.c"
    if (! (((intptr_t ) (p [0 ] ) ) & 0x1 ) ) {
#     define XfOrM9_COUNT (0+XfOrM7_COUNT)
#     define SETUP_XfOrM9(x) SETUP_XfOrM7(x)

# 239 "bc/src/sema.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) || ! ((& ((Scheme_Bignum * ) p [0 ] ) -> iso ) -> so . keyex & 0x1 ) )
        FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-nonnegative-integer?" , 0 , n , p ) ); 
    }

    if (! (scheme_get_int_val (p [0 ] , & v ) ) ) {
#     define XfOrM8_COUNT (0+XfOrM7_COUNT)
#     define SETUP_XfOrM8(x) SETUP_XfOrM7(x)
      (__funcarg80 = FUNCCALL(SETUP_XfOrM8(_), scheme_make_provided_string (p [0 ] , 0 , ((void * ) 0 ) ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL , "%s: starting value %s is too large" , who , __funcarg80 ) )) 
      ; 
    }

# 248 "bc/src/sema.c"
    else if (v < 0 )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-nonnegative-integer?" , 0 , n , p ) ); 
  }

# 250 "bc/src/sema.c"
  else 
  v = 0 ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 256 "bc/src/sema.c"
static Scheme_Object * make_sema (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 258 "bc/src/sema.c"
  intptr_t v ; 
  v = scheme_get_semaphore_init ("make-semaphore" , n , p ) ; 
  return scheme_make_sema (v ) ; 
}

static Scheme_Object * make_sema_repost (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 265 "bc/src/sema.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) )
    scheme_wrong_contract ("semaphore-peek-evt" , "semaphore?" , 0 , n , p ) ; 

  return scheme_make_sema_repost (p [0 ] ) ; 
}

Scheme_Object * scheme_make_sema_repost (Scheme_Object * sema ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(sema, 1)));
# define XfOrM12_COUNT (2)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 275 "bc/src/sema.c"
  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM12(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_semaphore_repost_type ; 
  (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) = sema ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 282 "bc/src/sema.c"
static Scheme_Object * is_sema_repost (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 284 "bc/src/sema.c"
  return (((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_semaphore_repost_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * semap (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 291 "bc/src/sema.c"
  return ((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) ? scheme_true : scheme_false ; 
}

void did_post_sema (Scheme_Sema * t ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(t, 0)));
# define XfOrM15_COUNT (1)
# define SETUP_XfOrM15(x) SETUP(XfOrM15_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 296 "bc/src/sema.c"
  while (t -> first ) {
    Scheme_Channel_Syncer * w ; 
    int consumed ; 
    BLOCK_SETUP((PUSH(w, 0+XfOrM15_COUNT)));
#   define XfOrM22_COUNT (1+XfOrM15_COUNT)
#   define SETUP_XfOrM22(x) SETUP(XfOrM22_COUNT)
    w = NULLED_OUT ; 

# 300 "bc/src/sema.c"
    w = t -> first ; 

    t -> first = w -> next ; 
    if (! w -> next )
      t -> last = ((void * ) 0 ) ; 
    else 
    t -> first -> prev = ((void * ) 0 ) ; 

    if ((! w -> syncing || ! w -> syncing -> result ) && ! FUNCCALL(SETUP_XfOrM22(_), pending_break (w -> p ) )) {
#     define XfOrM24_COUNT (0+XfOrM22_COUNT)
#     define SETUP_XfOrM24(x) SETUP_XfOrM22(x)

# 309 "bc/src/sema.c"
      if (w -> syncing ) {
#       define XfOrM26_COUNT (0+XfOrM24_COUNT)
#       define SETUP_XfOrM26(x) SETUP_XfOrM24(x)

# 310 "bc/src/sema.c"
        w -> syncing -> result = w -> syncing_i + 1 ; 
        if (w -> syncing -> disable_break )
          w -> syncing -> disable_break -> suspend_break ++ ; 
        FUNCCALL(SETUP_XfOrM26(_), scheme_post_syncing_nacks (w -> syncing ) ); 
        if (! w -> syncing -> reposts || ! w -> syncing -> reposts [w -> syncing_i ] ) {
          t -> value -= 1 ; 
          consumed = 1 ; 
        }

# 317 "bc/src/sema.c"
        else 
        consumed = 0 ; 
        if (w -> syncing -> accepts && w -> syncing -> accepts [w -> syncing_i ] )
          FUNCCALL(SETUP_XfOrM26(_), scheme_accept_sync (w -> syncing , w -> syncing_i ) ); 
      }

# 321 "bc/src/sema.c"
      else {




        consumed = 1 ; 
      }
      w -> picked = 1 ; 
    }

# 329 "bc/src/sema.c"
    else 
    consumed = 0 ; 

    w -> in_line = 0 ; 
    w -> prev = ((void * ) 0 ) ; 
    w -> next = ((void * ) 0 ) ; 

    if (w -> picked ) {
#     define XfOrM23_COUNT (0+XfOrM22_COUNT)
#     define SETUP_XfOrM23(x) SETUP_XfOrM22(x)
      FUNCCALL(SETUP_XfOrM23(_), scheme_weak_resume_thread (w -> p ) )
# 337 "bc/src/sema.c"
      ; 
      if (consumed )
        break ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 345 "bc/src/sema.c"
static void sema_overflow () 
{
  /* No conversion */

# 347 "bc/src/sema.c"
  scheme_raise_exn (MZEXN_FAIL , 
  "semaphore-post: the maximum post count has already been reached" ) ; 
}

void scheme_post_sema (Scheme_Object * o ) 
{
  /* No conversion */
  Scheme_Sema * t = (Scheme_Sema * ) o ; 
  int v ; 

  if (t -> value < 0 )

# 357 "bc/src/sema.c"
  return ; 

  v = (intptr_t ) ((uintptr_t ) t -> value + 1 ) ; 
  if (v > t -> value ) {
    t -> value = v ; 

    if (t -> first )
      did_post_sema (t ) ; 
  }

# 365 "bc/src/sema.c"
  else 
  sema_overflow () ; 
}

void scheme_post_sema_all (Scheme_Object * o ) 
{
  Scheme_Sema * t = (Scheme_Sema * ) o ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(o, 1)));
# define XfOrM31_COUNT (2)
# define SETUP_XfOrM31(x) SETUP(XfOrM31_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 373 "bc/src/sema.c"
  while (t -> first ) {
#   define XfOrM33_COUNT (0+XfOrM31_COUNT)
#   define SETUP_XfOrM33(x) SETUP_XfOrM31(x)
    FUNCCALL(SETUP_XfOrM33(_), scheme_post_sema (o ) )
# 374 "bc/src/sema.c"
    ; 
  }
  t -> value = - 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 379 "bc/src/sema.c"
static Scheme_Object * hit_sema (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 381 "bc/src/sema.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) )
    scheme_wrong_contract ("semaphore-post" , "semaphore?" , 0 , n , p ) ; 

  scheme_post_sema (p [0 ] ) ; 

  return scheme_void ; 
}

static int out_of_line (Scheme_Object * a ) 
{
  Scheme_Thread * p ; 
  int n , i ; 
  Scheme_Channel_Syncer * w ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM35_COUNT (1)
# define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  w = NULLED_OUT ; 

# 396 "bc/src/sema.c"
  n = (((intptr_t ) (((Scheme_Object * * ) a ) [0 ] ) ) >> 1 ) ; 
  for (i = 0 ; i < n ; i ++ ) {
    w = (((Scheme_Channel_Syncer * * * ) a ) [1 ] ) [i ] ; 
    if (w -> picked )
      RET_VALUE_START (1 ) RET_VALUE_END ; 
  }


  p = ((Scheme_Thread * * ) a ) [2 ] ; 
  if (p -> external_break ) {
    int v ; 
#   define XfOrM36_COUNT (0+XfOrM35_COUNT)
#   define SETUP_XfOrM36(x) SETUP_XfOrM35(x)

# 407 "bc/src/sema.c"
    -- p -> suspend_break ; 
    v = FUNCCALL(SETUP_XfOrM36(_), scheme_can_break (p ) ); 
    p -> suspend_break ++ ; 
    if (v )
      RET_VALUE_START (1 ) RET_VALUE_END ; 
  }


  if ((p -> running & 0x10 ) 
  || XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_was_once_suspended_ ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 422 "bc/src/sema.c"
static void get_into_line (Scheme_Sema * sema , Scheme_Channel_Syncer * w ) 

{
  /* No conversion */

# 425 "bc/src/sema.c"
  Scheme_Channel_Syncer * last , * first ; 

  w -> in_line = 1 ; 
  w -> picked = 0 ; 

  if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_never_evt_type ) )  {
    return ; 
  }

# 432 "bc/src/sema.c"
  else if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) )  {
    last = sema -> last ; 
    first = sema -> first ; 
  }

# 435 "bc/src/sema.c"
  else if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) )  {
    last = ((Scheme_Channel * ) sema ) -> get_last ; 
    first = ((Scheme_Channel * ) sema ) -> get_first ; 
  }

# 438 "bc/src/sema.c"
  else {
    last = ((Scheme_Channel_Put * ) sema ) -> ch -> put_last ; 
    first = ((Scheme_Channel_Put * ) sema ) -> ch -> put_first ; 
  }

  w -> prev = last ; 
  if (last )
    last -> next = w ; 
  else 
  first = w ; 
  last = w ; 
  w -> next = ((void * ) 0 ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) )  {
    sema -> last = last ; 
    sema -> first = first ; 
  }

# 454 "bc/src/sema.c"
  else if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) )  {
    ((Scheme_Channel * ) sema ) -> get_last = last ; 
    ((Scheme_Channel * ) sema ) -> get_first = first ; 
  }

# 457 "bc/src/sema.c"
  else {
    ((Scheme_Channel_Put * ) sema ) -> ch -> put_last = last ; 
    ((Scheme_Channel_Put * ) sema ) -> ch -> put_first = first ; 
  }
}

static void get_outof_line (Scheme_Sema * sema , Scheme_Channel_Syncer * w ) 
{
  /* No conversion */

# 465 "bc/src/sema.c"
  Scheme_Channel_Syncer * last , * first ; 

  if (! w -> in_line )
    return ; 
  w -> in_line = 0 ; 

  if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_never_evt_type ) )  {
    return ; 
  }

# 473 "bc/src/sema.c"
  else if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) )  {
    last = sema -> last ; 
    first = sema -> first ; 
  }

# 476 "bc/src/sema.c"
  else if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) )  {
    last = ((Scheme_Channel * ) sema ) -> get_last ; 
    first = ((Scheme_Channel * ) sema ) -> get_first ; 
  }

# 479 "bc/src/sema.c"
  else {
    last = ((Scheme_Channel_Put * ) sema ) -> ch -> put_last ; 
    first = ((Scheme_Channel_Put * ) sema ) -> ch -> put_first ; 
  }

  if (w -> prev )
    w -> prev -> next = w -> next ; 
  else 
  first = w -> next ; 
  if (w -> next )
    w -> next -> prev = w -> prev ; 
  else 
  last = w -> prev ; 

  if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) )  {
    sema -> last = last ; 
    sema -> first = first ; 
  }

# 496 "bc/src/sema.c"
  else if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) )  {
    ((Scheme_Channel * ) sema ) -> get_last = last ; 
    ((Scheme_Channel * ) sema ) -> get_first = first ; 
  }

# 499 "bc/src/sema.c"
  else {
    ((Scheme_Channel_Put * ) sema ) -> ch -> put_last = last ; 
    ((Scheme_Channel_Put * ) sema ) -> ch -> put_first = first ; 
  }
}

static void ext_get_into_line (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Channel_Syncer * w ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(sinfo, 1), PUSH(w, 2)));
# define XfOrM55_COUNT (3)
# define SETUP_XfOrM55(x) SETUP(XfOrM55_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  w = NULLED_OUT ; 

# 510 "bc/src/sema.c"
  w = ((Scheme_Channel_Syncer * ) FUNCCALL(SETUP_XfOrM55(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Channel_Syncer ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  w -> so . type = scheme_channel_syncer_type ; 
  if (sinfo -> false_positive_ok )
    w -> p = sinfo -> false_positive_ok ; 
  else 
  w -> p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  w -> syncing = (Syncing * ) sinfo -> current_syncing ; 
  w -> obj = ch ; 
  w -> syncing_i = sinfo -> w_i ; 
  FUNCCALL(SETUP_XfOrM55(_), get_into_line ((Scheme_Sema * ) ch , w ) )
  ; 
  FUNCCALL_EMPTY(scheme_set_sync_target (sinfo , (Scheme_Object * ) w , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 525 "bc/src/sema.c"
void scheme_get_outof_line (Scheme_Channel_Syncer * ch_w ) 
{
  /* No conversion */

# 527 "bc/src/sema.c"
  get_outof_line ((Scheme_Sema * ) ch_w -> obj , ch_w ) ; 
}

void scheme_get_back_into_line (Scheme_Channel_Syncer * ch_w ) 
{
  /* No conversion */

# 532 "bc/src/sema.c"
  get_into_line ((Scheme_Sema * ) ch_w -> obj , ch_w ) ; 
}

static int try_channel (Scheme_Sema * sema , Syncing * syncing , int pos , Scheme_Object * * result ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(result, 0), PUSH(sema, 1), PUSH(syncing, 2)));
# define XfOrM58_COUNT (3)
# define SETUP_XfOrM58(x) SETUP(XfOrM58_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 537 "bc/src/sema.c"
  if ((Scheme_Type ) (((((intptr_t ) (sema ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sema ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) )  {

    Scheme_Channel * ch = (Scheme_Channel * ) sema ; 
    Scheme_Channel_Syncer * w = ch -> put_first , * next ; 
    int picked = 0 ; 
    BLOCK_SETUP((PUSH(w, 0+XfOrM58_COUNT), PUSH(next, 1+XfOrM58_COUNT)));
#   define XfOrM70_COUNT (2+XfOrM58_COUNT)
#   define SETUP_XfOrM70(x) SETUP(XfOrM70_COUNT)
    next = NULLED_OUT ; 

# 543 "bc/src/sema.c"
    while (w ) {
#     define XfOrM76_COUNT (0+XfOrM70_COUNT)
#     define SETUP_XfOrM76(x) SETUP_XfOrM70(x)

# 544 "bc/src/sema.c"
      if (w -> syncing == syncing ) {

        w = w -> next ; 
      }

# 547 "bc/src/sema.c"
      else {
        Scheme_Channel_Put * chp = (Scheme_Channel_Put * ) w -> obj ; 
        BLOCK_SETUP((PUSH(chp, 0+XfOrM76_COUNT)));
#       define XfOrM77_COUNT (1+XfOrM76_COUNT)
#       define SETUP_XfOrM77(x) SETUP(XfOrM77_COUNT)

# 550 "bc/src/sema.c"
        if (! w -> syncing -> result && ! FUNCCALL(SETUP_XfOrM77(_), pending_break (w -> p ) )) {
#         define XfOrM78_COUNT (0+XfOrM77_COUNT)
#         define SETUP_XfOrM78(x) SETUP_XfOrM77(x)

# 551 "bc/src/sema.c"
          w -> picked = 1 ; 
          w -> syncing -> result = w -> syncing_i + 1 ; 
          if (w -> syncing -> disable_break )
            w -> syncing -> disable_break -> suspend_break ++ ; 
          FUNCCALL(SETUP_XfOrM78(_), scheme_post_syncing_nacks (w -> syncing ) ); 
          if (result )
            * result = chp -> val ; 
          if (syncing && (pos >= 0 ) ) {
#           define XfOrM79_COUNT (0+XfOrM78_COUNT)
#           define SETUP_XfOrM79(x) SETUP_XfOrM78(x)

# 559 "bc/src/sema.c"
            syncing -> result = pos + 1 ; 
            if (syncing -> disable_break )
              syncing -> disable_break -> suspend_break ++ ; 
            FUNCCALL(SETUP_XfOrM79(_), scheme_post_syncing_nacks (syncing ) ); 
            syncing -> set -> argv [pos ] = chp -> val ; 
          }
          picked = 1 ; 
          FUNCCALL(SETUP_XfOrM78(_), scheme_weak_resume_thread (w -> p ) ); 
        }

        next = w -> next ; 
        FUNCCALL(SETUP_XfOrM77(_), get_outof_line ((Scheme_Sema * ) chp , w ) ); 
        w = next ; 

        if (picked )
          RET_VALUE_START (1 ) RET_VALUE_END ; 
      }
    }

    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 579 "bc/src/sema.c"
  else {

    Scheme_Channel_Put * chp = (Scheme_Channel_Put * ) sema ; 
    Scheme_Channel_Syncer * w = chp -> ch -> get_first , * next ; 
    int picked = 0 ; 
    BLOCK_SETUP((PUSH(w, 0+XfOrM58_COUNT), PUSH(next, 1+XfOrM58_COUNT), PUSH(chp, 2+XfOrM58_COUNT)));
#   define XfOrM59_COUNT (3+XfOrM58_COUNT)
#   define SETUP_XfOrM59(x) SETUP(XfOrM59_COUNT)
    next = NULLED_OUT ; 

# 585 "bc/src/sema.c"
    while (w ) {
#     define XfOrM65_COUNT (0+XfOrM59_COUNT)
#     define SETUP_XfOrM65(x) SETUP_XfOrM59(x)

# 586 "bc/src/sema.c"
      if (w -> syncing == syncing ) {

        w = w -> next ; 
      }

# 589 "bc/src/sema.c"
      else {
#       define XfOrM66_COUNT (0+XfOrM65_COUNT)
#       define SETUP_XfOrM66(x) SETUP_XfOrM65(x)

# 590 "bc/src/sema.c"
        if (! w -> syncing -> result && ! FUNCCALL(SETUP_XfOrM66(_), pending_break (w -> p ) )) {
#         define XfOrM67_COUNT (0+XfOrM66_COUNT)
#         define SETUP_XfOrM67(x) SETUP_XfOrM66(x)

# 591 "bc/src/sema.c"
          w -> picked = 1 ; 
          w -> syncing -> set -> argv [w -> syncing_i ] = chp -> val ; 
          w -> syncing -> result = w -> syncing_i + 1 ; 
          if (w -> syncing -> disable_break )
            w -> syncing -> disable_break -> suspend_break ++ ; 
          FUNCCALL(SETUP_XfOrM67(_), scheme_post_syncing_nacks (w -> syncing ) ); 
          if (syncing && (pos >= 0 ) ) {
#           define XfOrM68_COUNT (0+XfOrM67_COUNT)
#           define SETUP_XfOrM68(x) SETUP_XfOrM67(x)

# 598 "bc/src/sema.c"
            syncing -> result = pos + 1 ; 
            if (syncing -> disable_break )
              syncing -> disable_break -> suspend_break ++ ; 
            FUNCCALL(SETUP_XfOrM68(_), scheme_post_syncing_nacks (syncing ) ); 
          }
          picked = 1 ; 
          FUNCCALL(SETUP_XfOrM67(_), scheme_weak_resume_thread (w -> p ) ); 
        }

        next = w -> next ; 
        FUNCCALL(SETUP_XfOrM66(_), get_outof_line ((Scheme_Sema * ) chp -> ch , w ) ); 
        w = next ; 

        if (picked )
          RET_VALUE_START (1 ) RET_VALUE_END ; 
      }
    }

    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 620 "bc/src/sema.c"
__xform_nongcing__ int scheme_try_plain_sema (Scheme_Object * o ) 
{
  /* No conversion */

# 622 "bc/src/sema.c"
  Scheme_Sema * sema = (Scheme_Sema * ) o ; 

  if (sema -> value ) {
    if (sema -> value > 0 )
      -- sema -> value ; 
    return 1 ; 
  }

# 628 "bc/src/sema.c"
  else 
  return 0 ; 
}

int scheme_wait_semas_chs (int n , Scheme_Object * * o , int just_try , Syncing * syncing ) 


{
  Scheme_Sema * * semas = (Scheme_Sema * * ) o ; 
  int v , i , ii ; 
  Scheme_Config * __funcarg81 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(semas, 0), PUSH(syncing, 1)));
# define XfOrM83_COUNT (2)
# define SETUP_XfOrM83(x) SETUP(XfOrM83_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 639 "bc/src/sema.c"
  if (just_try ) {

    Scheme_Sema * sema = semas [0 ] ; 
    BLOCK_SETUP((PUSH(sema, 0+XfOrM83_COUNT)));
#   define XfOrM232_COUNT (1+XfOrM83_COUNT)
#   define SETUP_XfOrM232(x) SETUP(XfOrM232_COUNT)

# 642 "bc/src/sema.c"
    if (just_try > 0 ) {
#     define XfOrM234_COUNT (0+XfOrM232_COUNT)
#     define SETUP_XfOrM234(x) SETUP_XfOrM232(x)

# 643 "bc/src/sema.c"
      if (sema -> so . type == scheme_sema_type ) {
#       define XfOrM236_COUNT (0+XfOrM234_COUNT)
#       define SETUP_XfOrM236(x) SETUP_XfOrM234(x)

# 644 "bc/src/sema.c"
        v = (scheme_try_plain_sema ((Scheme_Object * ) sema ) ) ; 
      }

# 645 "bc/src/sema.c"
      else {
#       define XfOrM235_COUNT (0+XfOrM234_COUNT)
#       define SETUP_XfOrM235(x) SETUP_XfOrM234(x)

# 646 "bc/src/sema.c"
        v = FUNCCALL(SETUP_XfOrM235(_), try_channel (sema , syncing , 0 , ((void * ) 0 ) ) ); 
      }
    }

# 648 "bc/src/sema.c"
    else {
      Scheme_Cont_Frame_Data cframe ; 
      BLOCK_SETUP((PUSH(cframe.cache, 0+XfOrM232_COUNT)));
#     define XfOrM233_COUNT (1+XfOrM232_COUNT)
#     define SETUP_XfOrM233(x) SETUP(XfOrM233_COUNT)
      cframe.cache = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM233(_), scheme_push_break_enable (& cframe , 1 , 1 ) )
# 651 "bc/src/sema.c"
      ; 
      FUNCCALL_AGAIN(scheme_wait_sema ((Scheme_Object * ) sema , 0 ) )
      ; 
      FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe , 0 ) )
      ; 

      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

# 659 "bc/src/sema.c"
  else {
    int start_pos ; 
#   define XfOrM84_COUNT (0+XfOrM83_COUNT)
#   define SETUP_XfOrM84(x) SETUP_XfOrM83(x)

# 678 "bc/src/sema.c"
    if (n > 1 ) {
#     define XfOrM230_COUNT (0+XfOrM84_COUNT)
#     define SETUP_XfOrM230(x) SETUP_XfOrM84(x)

# 679 "bc/src/sema.c"
      if (syncing )
        start_pos = syncing -> start_pos ; 
      else {
        Scheme_Object * rand_state ; 
        BLOCK_SETUP((PUSH(rand_state, 0+XfOrM230_COUNT)));
#       define XfOrM231_COUNT (1+XfOrM230_COUNT)
#       define SETUP_XfOrM231(x) SETUP(XfOrM231_COUNT)
        rand_state = NULLED_OUT ; 

# 683 "bc/src/sema.c"
        rand_state = (__funcarg81 = FUNCCALL(SETUP_XfOrM231(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg81 , MZCONFIG_SCHEDULER_RANDOM_STATE ) )) ; 
        start_pos = FUNCCALL_AGAIN(scheme_rand ((Scheme_Random_State * ) rand_state ) ); 
      }
    }

# 686 "bc/src/sema.c"
    else 
    start_pos = 0 ; 


    while (1 ) {
#     define XfOrM213_COUNT (0+XfOrM84_COUNT)
#     define SETUP_XfOrM213(x) SETUP_XfOrM84(x)

# 691 "bc/src/sema.c"
      i = 0 ; 
      for (ii = 0 ; ii < n ; ii ++ ) {
#       define XfOrM224_COUNT (0+XfOrM213_COUNT)
#       define SETUP_XfOrM224(x) SETUP_XfOrM213(x)

# 694 "bc/src/sema.c"
        i = (start_pos + ii ) % n ; 

        if (semas [i ] -> so . type == scheme_sema_type ) {
#         define XfOrM227_COUNT (0+XfOrM224_COUNT)
#         define SETUP_XfOrM227(x) SETUP_XfOrM224(x)

# 697 "bc/src/sema.c"
          if (semas [i ] -> value ) {
#           define XfOrM228_COUNT (0+XfOrM227_COUNT)
#           define SETUP_XfOrM228(x) SETUP_XfOrM227(x)

# 698 "bc/src/sema.c"
            if ((semas [i ] -> value > 0 ) && (! syncing || ! syncing -> reposts || ! syncing -> reposts [i ] ) )
              -- semas [i ] -> value ; 
            if (syncing ) {
#             define XfOrM229_COUNT (0+XfOrM228_COUNT)
#             define SETUP_XfOrM229(x) SETUP_XfOrM228(x)

# 701 "bc/src/sema.c"
              syncing -> result = i + 1 ; 
              if (syncing -> accepts && syncing -> accepts [i ] )
                FUNCCALL(SETUP_XfOrM229(_), scheme_accept_sync (syncing , i ) ); 
            }
            break ; 
          }
        }

# 707 "bc/src/sema.c"
        else if (semas [i ] -> so . type == scheme_never_evt_type ) {
        }
        else if (semas [i ] -> so . type == scheme_channel_syncer_type ) {
          if (((Scheme_Channel_Syncer * ) semas [i ] ) -> picked )
            break ; 
        }

# 712 "bc/src/sema.c"
        else if (FUNCCALL(SETUP_XfOrM224(_), try_channel (semas [i ] , syncing , i , ((void * ) 0 ) ) ))
          break ; 
      }

      if (ii >= n ) {
#       define XfOrM214_COUNT (0+XfOrM213_COUNT)
#       define SETUP_XfOrM214(x) SETUP_XfOrM213(x)

# 717 "bc/src/sema.c"
        if (! FUNCCALL(SETUP_XfOrM214(_), scheme_wait_until_suspend_ok () )) {
          break ; 
        }

# 719 "bc/src/sema.c"
        else {


          if (syncing && syncing -> result ) {
            i = syncing -> result - 1 ; 
            ii = 0 ; 
            break ; 
          }
        }
      }

# 728 "bc/src/sema.c"
      else 
      break ; 
    }



    if (ii >= n ) {
      Scheme_Channel_Syncer * * ws , * w ; 
      BLOCK_SETUP((PUSH(w, 0+XfOrM84_COUNT), PUSH(ws, 1+XfOrM84_COUNT)));
#     define XfOrM85_COUNT (2+XfOrM84_COUNT)
#     define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
      ws = NULLED_OUT ; 
      w = NULLED_OUT ; 

# 737 "bc/src/sema.c"
      ws = ((Scheme_Channel_Syncer * * ) FUNCCALL(SETUP_XfOrM85(_), GC_malloc (sizeof (Scheme_Channel_Syncer * ) * (n ) ) )) ; 
      for (i = 0 ; i < n ; i ++ ) {
#       define XfOrM193_COUNT (0+XfOrM85_COUNT)
#       define SETUP_XfOrM193(x) SETUP_XfOrM85(x)

# 739 "bc/src/sema.c"
        if (semas [i ] -> so . type == scheme_channel_syncer_type ) {
          ws [i ] = (Scheme_Channel_Syncer * ) semas [i ] ; 
          semas [i ] = (Scheme_Sema * ) ws [i ] -> obj ; 
        }

# 742 "bc/src/sema.c"
        else {
#         define XfOrM194_COUNT (0+XfOrM193_COUNT)
#         define SETUP_XfOrM194(x) SETUP_XfOrM193(x)

# 743 "bc/src/sema.c"
          w = ((Scheme_Channel_Syncer * ) FUNCCALL(SETUP_XfOrM194(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Channel_Syncer ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
          ws [i ] = w ; 
          w -> so . type = scheme_channel_syncer_type ; 
          w -> p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
          w -> syncing = syncing ; 
          w -> obj = (Scheme_Object * ) semas [i ] ; 
          w -> syncing_i = i ; 
        }
      }

      while (1 ) {
        int out_of_a_line ; 
#       define XfOrM138_COUNT (0+XfOrM85_COUNT)
#       define SETUP_XfOrM138(x) SETUP_XfOrM85(x)
        for (i = 0 ; i < n ; i ++ ) {
#         define XfOrM188_COUNT (0+XfOrM138_COUNT)
#         define SETUP_XfOrM188(x) SETUP_XfOrM138(x)

# 758 "bc/src/sema.c"
          if (! ws [i ] -> in_line ) {
#           define XfOrM189_COUNT (0+XfOrM188_COUNT)
#           define SETUP_XfOrM189(x) SETUP_XfOrM188(x)
            FUNCCALL(SETUP_XfOrM189(_), get_into_line (semas [i ] , ws [i ] ) )
# 759 "bc/src/sema.c"
            ; 
          }
        }

        if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> next ) {
          void * * a ; 
          BLOCK_SETUP((PUSH(a, 0+XfOrM138_COUNT)));
#         define XfOrM185_COUNT (1+XfOrM138_COUNT)
#         define SETUP_XfOrM185(x) SETUP(XfOrM185_COUNT)
          a = NULLED_OUT ; 

# 768 "bc/src/sema.c"
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ++ ; 

          a = ((void * * ) FUNCCALL(SETUP_XfOrM185(_), GC_malloc (sizeof (void * ) * (3 ) ) )) ; 
          a [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
          a [1 ] = ws ; 
          a [2 ] = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_was_once_suspended_ ) = 0 ; 
          FUNCCALL(SETUP_XfOrM185(_), scheme_block_until (out_of_line , ((void * ) 0 ) , (Scheme_Object * ) a , (float ) 0.0 ) )
          ; 

          -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ; 
        }

# 780 "bc/src/sema.c"
        else {


          int old_nkc ; 
#         define XfOrM184_COUNT (0+XfOrM138_COUNT)
#         define SETUP_XfOrM184(x) SETUP_XfOrM138(x)

# 784 "bc/src/sema.c"
          old_nkc = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running & 0x8 ) ; 
          if (! old_nkc )
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running += 0x8 ; 
          FUNCCALL(SETUP_XfOrM184(_), scheme_weak_suspend_thread (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ); 
          if (! old_nkc && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running & 0x8 ) )
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running -= 0x8 ; 
        }


        out_of_a_line = 0 ; 






        if (! syncing ) {


          i = 0 ; 
          for (ii = 0 ; ii < n ; ii ++ ) {
            i = (start_pos + ii ) % n ; 
            if (ws [i ] -> picked ) {
              out_of_a_line = 1 ; 
              if (semas [i ] -> value ) {
                if (semas [i ] -> value > 0 )
                  -- (semas [i ] -> value ) ; 
                break ; 
              }
            }
          }
          if (ii >= n )
            i = n ; 
        }

# 817 "bc/src/sema.c"
        else {
          if (syncing -> result ) {
            out_of_a_line = 1 ; 
            i = syncing -> result - 1 ; 
          }

# 821 "bc/src/sema.c"
          else {
            out_of_a_line = 0 ; 
            i = n ; 
          }
        }

        if (! out_of_a_line ) {
#         define XfOrM171_COUNT (0+XfOrM138_COUNT)
#         define SETUP_XfOrM171(x) SETUP_XfOrM138(x)
          for (i = 0 ; i < n ; i ++ ) {
#           define XfOrM173_COUNT (0+XfOrM171_COUNT)
#           define SETUP_XfOrM173(x) SETUP_XfOrM171(x)

# 831 "bc/src/sema.c"
            if (ws [i ] -> in_line )
              FUNCCALL(SETUP_XfOrM173(_), get_outof_line (semas [i ] , ws [i ] ) ); 
          }
          FUNCCALL(SETUP_XfOrM171(_), scheme_thread_block (0 ) )
          ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
        }
        else {
#         define XfOrM156_COUNT (0+XfOrM138_COUNT)
#         define SETUP_XfOrM156(x) SETUP_XfOrM138(x)

# 840 "bc/src/sema.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running & 0x4 ) 
          || ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running & 0x10 ) 
          && ! (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running & 0x20 ) ) ) {

            i = - 1 ; 
          }




          if (! syncing ) {
            int j ; 
#           define XfOrM161_COUNT (0+XfOrM156_COUNT)
#           define SETUP_XfOrM161(x) SETUP_XfOrM156(x)

# 853 "bc/src/sema.c"
            for (j = 0 ; j < n ; j ++ ) {
#             define XfOrM166_COUNT (0+XfOrM161_COUNT)
#             define SETUP_XfOrM166(x) SETUP_XfOrM161(x)

# 854 "bc/src/sema.c"
              if (j != i ) {
#               define XfOrM167_COUNT (0+XfOrM166_COUNT)
#               define SETUP_XfOrM167(x) SETUP_XfOrM166(x)

# 855 "bc/src/sema.c"
                if (ws [j ] -> picked ) {
#                 define XfOrM168_COUNT (0+XfOrM167_COUNT)
#                 define SETUP_XfOrM168(x) SETUP_XfOrM167(x)

# 856 "bc/src/sema.c"
                  if (semas [j ] -> value ) {
#                   define XfOrM169_COUNT (0+XfOrM168_COUNT)
#                   define SETUP_XfOrM169(x) SETUP_XfOrM168(x)
                    if (semas [j ] -> value > 0 )
                      -- semas [j ] -> value ; 
                    FUNCCALL(SETUP_XfOrM169(_), scheme_post_sema ((Scheme_Object * ) semas [j ] ) ); 
                  }
                }
              }
            }
          }


          if (i < n ) {
            int j ; 
#           define XfOrM158_COUNT (0+XfOrM156_COUNT)
#           define SETUP_XfOrM158(x) SETUP_XfOrM156(x)

# 871 "bc/src/sema.c"
            for (j = 0 ; j < n ; j ++ ) {
#             define XfOrM160_COUNT (0+XfOrM158_COUNT)
#             define SETUP_XfOrM160(x) SETUP_XfOrM158(x)

# 872 "bc/src/sema.c"
              if (ws [j ] -> in_line )
                FUNCCALL(SETUP_XfOrM160(_), get_outof_line (semas [j ] , ws [j ] ) ); 
            }
          }

          if (i == - 1 ) {
#           define XfOrM157_COUNT (0+XfOrM156_COUNT)
#           define SETUP_XfOrM157(x) SETUP_XfOrM156(x)
            FUNCCALL(SETUP_XfOrM157(_), scheme_thread_block (0 ) )
# 878 "bc/src/sema.c"
            ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
          }

          if (i < n )
            break ; 
        }




        for (ii = 0 ; ii < n ; ii ++ ) {
#         define XfOrM151_COUNT (0+XfOrM138_COUNT)
#         define SETUP_XfOrM151(x) SETUP_XfOrM138(x)

# 890 "bc/src/sema.c"
          i = (start_pos + ii ) % n ; 

          if (semas [i ] -> so . type == scheme_sema_type ) {
#           define XfOrM153_COUNT (0+XfOrM151_COUNT)
#           define SETUP_XfOrM153(x) SETUP_XfOrM151(x)

# 893 "bc/src/sema.c"
            if (semas [i ] -> value ) {
#             define XfOrM154_COUNT (0+XfOrM153_COUNT)
#             define SETUP_XfOrM154(x) SETUP_XfOrM153(x)

# 894 "bc/src/sema.c"
              if ((semas [i ] -> value > 0 ) && (! syncing || ! syncing -> reposts || ! syncing -> reposts [i ] ) )
                -- semas [i ] -> value ; 
              if (syncing ) {
#               define XfOrM155_COUNT (0+XfOrM154_COUNT)
#               define SETUP_XfOrM155(x) SETUP_XfOrM154(x)

# 897 "bc/src/sema.c"
                syncing -> result = i + 1 ; 
                if (syncing -> accepts && syncing -> accepts [i ] )
                  FUNCCALL(SETUP_XfOrM155(_), scheme_accept_sync (syncing , i ) ); 
              }
              break ; 
            }
          }

# 903 "bc/src/sema.c"
          else if (semas [i ] -> so . type == scheme_never_evt_type ) {
          }
          else if (FUNCCALL(SETUP_XfOrM151(_), try_channel (semas [i ] , syncing , i , ((void * ) 0 ) ) ))
            break ; 
        }

        if (ii < n ) {

          int j ; 
#         define XfOrM143_COUNT (0+XfOrM138_COUNT)
#         define SETUP_XfOrM143(x) SETUP_XfOrM138(x)

# 912 "bc/src/sema.c"
          for (j = 0 ; j < n ; j ++ ) {
#           define XfOrM145_COUNT (0+XfOrM143_COUNT)
#           define SETUP_XfOrM145(x) SETUP_XfOrM143(x)

# 913 "bc/src/sema.c"
            if (ws [j ] -> in_line )
              FUNCCALL(SETUP_XfOrM145(_), get_outof_line (semas [j ] , ws [j ] ) ); 
          }

          break ; 
        }

        if (! syncing ) {
#         define XfOrM139_COUNT (0+XfOrM138_COUNT)
#         define SETUP_XfOrM139(x) SETUP_XfOrM138(x)
          syncing = ((Syncing * ) FUNCCALL(SETUP_XfOrM139(_), GC_malloc_one_small_tagged ((((sizeof (Syncing ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

          syncing -> type = scheme_rt_syncing ; 

          syncing -> start_pos = start_pos ; 


          {
            int j ; 
#           define XfOrM140_COUNT (0+XfOrM139_COUNT)
#           define SETUP_XfOrM140(x) SETUP_XfOrM139(x)

# 932 "bc/src/sema.c"
            for (j = 0 ; j < n ; j ++ ) {
#             define XfOrM142_COUNT (0+XfOrM140_COUNT)
#             define SETUP_XfOrM142(x) SETUP_XfOrM140(x)

# 933 "bc/src/sema.c"
              if (ws [j ] -> in_line )
                FUNCCALL(SETUP_XfOrM142(_), get_outof_line (semas [j ] , ws [j ] ) ); 
              ws [j ] -> syncing = syncing ; 
            }
          }
        }
      }
    }

    v = i + 1 ; 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 948 "bc/src/sema.c"
static int slow_wait_sema (Scheme_Object * o , int just_try ) 
{
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM237_COUNT (3)
# define SETUP_XfOrM237(x) SETUP(XfOrM237_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 952 "bc/src/sema.c"
  a [0 ] = o ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM237(_), scheme_wait_semas_chs (1 , a , just_try , ((void * ) 0 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 957 "bc/src/sema.c"
int scheme_wait_sema (Scheme_Object * o , int just_try ) 
{
  /* No conversion */
  if (((just_try >= 0 ) || ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> external_break ) 
  && scheme_try_plain_sema (o ) )
    return 1 ; 

  return slow_wait_sema (o , just_try ) ; 
}

static Scheme_Object * block_sema_p (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 969 "bc/src/sema.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) )
    scheme_wrong_contract ("semaphore-try-wait?" , "semaphore?" , 0 , n , p ) ; 

  return scheme_wait_sema (p [0 ] , 1 ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * block_sema (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 977 "bc/src/sema.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) )
    scheme_wrong_contract ("semaphore-wait" , "semaphore?" , 0 , n , p ) ; 

  scheme_wait_sema (p [0 ] , 0 ) ; 



  scheme_check_break_now () ; 

  return scheme_void ; 
}

static Scheme_Object * block_sema_breakable (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 991 "bc/src/sema.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) )
    scheme_wrong_contract ("semaphore-wait/enable-break" , "semaphore?" , 0 , n , p ) ; 

  scheme_wait_sema (p [0 ] , - 1 ) ; 

  return scheme_void ; 
}

static int pending_break (Scheme_Thread * p ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM242_COUNT (1)
# define SETUP_XfOrM242(x) SETUP(XfOrM242_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1001 "bc/src/sema.c"
  if (p -> running & (0x4 | 0x10 ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 

  if (p -> external_break ) {
    int v ; 
#   define XfOrM243_COUNT (0+XfOrM242_COUNT)
#   define SETUP_XfOrM243(x) SETUP_XfOrM242(x)

# 1007 "bc/src/sema.c"
    if (! p -> next ) {


      -- p -> suspend_break ; 
    }

    v = FUNCCALL(SETUP_XfOrM243(_), scheme_can_break (p ) ); 

    if (! p -> next )
      p -> suspend_break ++ ; 

    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Object * scheme_make_channel () 
{
  Scheme_Channel * c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(c, 0)));
# define XfOrM245_COUNT (1)
# define SETUP_XfOrM245(x) SETUP(XfOrM245_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  c = NULLED_OUT ; 

# 1032 "bc/src/sema.c"
  c = ((Scheme_Channel * ) FUNCCALL(SETUP_XfOrM245(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Channel ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  c -> so . type = scheme_channel_type ; 

  RET_VALUE_START ((Scheme_Object * ) c ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1038 "bc/src/sema.c"
static Scheme_Object * make_channel (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 1040 "bc/src/sema.c"
  return scheme_make_channel () ; 
}

Scheme_Object * scheme_make_channel_put_evt (Scheme_Object * ch , Scheme_Object * v ) 
{
  Scheme_Channel_Put * cp ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(v, 1), PUSH(cp, 2)));
# define XfOrM247_COUNT (3)
# define SETUP_XfOrM247(x) SETUP(XfOrM247_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cp = NULLED_OUT ; 

# 1047 "bc/src/sema.c"
  cp = ((Scheme_Channel_Put * ) FUNCCALL(SETUP_XfOrM247(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Channel_Put ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  cp -> so . type = scheme_channel_put_type ; 
  cp -> ch = (Scheme_Channel * ) ch ; 
  cp -> val = v ; 

  RET_VALUE_START ((Scheme_Object * ) cp ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1055 "bc/src/sema.c"
int scheme_try_channel_put (Scheme_Object * ch , Scheme_Object * v ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM248_COUNT (1)
# define SETUP_XfOrM248(x) SETUP(XfOrM248_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1057 "bc/src/sema.c"
  if (((Scheme_Channel * ) ch ) -> get_first ) {
    Scheme_Object * a [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM248_COUNT)));
#   define XfOrM249_COUNT (3+XfOrM248_COUNT)
#   define SETUP_XfOrM249(x) SETUP(XfOrM249_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 

# 1059 "bc/src/sema.c"
    v = FUNCCALL(SETUP_XfOrM249(_), scheme_make_channel_put_evt (ch , v ) ); 
    a [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    a [1 ] = v ; 
    v = FUNCCALL(SETUP_XfOrM249(_), scheme_sync_timeout (2 , a ) ); 
    RET_VALUE_START ((! (((v ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
  }

# 1064 "bc/src/sema.c"
  else 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1068 "bc/src/sema.c"
Scheme_Object * chaperone_put (Scheme_Object * obj , Scheme_Object * orig ) 
{
  Scheme_Chaperone * px = (Scheme_Chaperone * ) obj ; 
  Scheme_Object * val = orig ; 
  Scheme_Object * a [2 ] ; 
  Scheme_Object * redirect ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(orig, 1), PUSH(redirect, 2), PUSHARRAY(a, 2, 3), PUSH(obj, 6), PUSH(px, 7)));
# define XfOrM250_COUNT (8)
# define SETUP_XfOrM250(x) SETUP(XfOrM250_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  redirect = NULLED_OUT ; 

# 1075 "bc/src/sema.c"
  while (1 ) {
#   define XfOrM255_COUNT (0+XfOrM250_COUNT)
#   define SETUP_XfOrM255(x) SETUP_XfOrM250(x)

# 1076 "bc/src/sema.c"
    if ((Scheme_Type ) (((((intptr_t ) (px ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) )  {
      RET_VALUE_START (val ) RET_VALUE_END ; 
    }

# 1078 "bc/src/sema.c"
    else if (! (((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_nack_guard_evt_type ) ) ) ) {
#     define XfOrM257_COUNT (0+XfOrM255_COUNT)
#     define SETUP_XfOrM257(x) SETUP_XfOrM255(x)

# 1079 "bc/src/sema.c"
      a [0 ] = px -> prev ; 
      a [1 ] = val ; 
      redirect = px -> redirects ; 
      val = FUNCCALL(SETUP_XfOrM257(_), scheme_do_eval (redirect , 2 , a , 1 ) ); 

      if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
        if (! FUNCCALL(SETUP_XfOrM257(_), scheme_chaperone_of (val , orig ) ))
        FUNCCALL(SETUP_XfOrM257(_), scheme_wrong_chaperoned ("channel-put" , "result" , orig , val ) ); 

      px = (Scheme_Chaperone * ) px -> prev ; 
    }

# 1089 "bc/src/sema.c"
    else {


      px = (Scheme_Chaperone * ) px -> prev ; 
    }
  }

  RET_VALUE_START (obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1099 "bc/src/sema.c"
static Scheme_Object * make_channel_put (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * ch = argv [0 ] ; 
  Scheme_Object * val = argv [1 ] ; 
  Scheme_Object * chaperone = ((void * ) 0 ) ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(val, 1)));
# define XfOrM259_COUNT (2)
# define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1105 "bc/src/sema.c"
  if ((((Scheme_Type ) (((((intptr_t ) (ch ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ch ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) ch ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) ch ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) ) ) {
    chaperone = ch ; 
    ch = (((Scheme_Chaperone * ) chaperone ) -> val ) ; 
  }

# 1109 "bc/src/sema.c"
  else if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) ) ) {
#   define XfOrM260_COUNT (0+XfOrM259_COUNT)
#   define SETUP_XfOrM260(x) SETUP_XfOrM259(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("channel-put-evt" , "channel?" , 0 , argc , argv ) )
# 1110 "bc/src/sema.c"
    ; 
  }

  if (chaperone )
    val = FUNCCALL(SETUP_XfOrM259(_), chaperone_put (chaperone , argv [1 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_channel_put_evt (ch , val ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1119 "bc/src/sema.c"
static Scheme_Object * channel_p (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 1121 "bc/src/sema.c"
  return ((((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) ) || 
  ((((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) p [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) p [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * channel_put_p (int n , Scheme_Object * * p ) 
{
  /* No conversion */

# 1130 "bc/src/sema.c"
  return (((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_put_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static int channel_get_ready (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Object * result ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(sinfo, 1), PUSH(result, 2)));
# define XfOrM264_COUNT (3)
# define SETUP_XfOrM264(x) SETUP(XfOrM264_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  result = NULLED_OUT ; 

# 1139 "bc/src/sema.c"
  if (FUNCCALL(SETUP_XfOrM264(_), try_channel ((Scheme_Sema * ) ch , (Syncing * ) sinfo -> current_syncing , - 1 , & result ) )) {
#   define XfOrM265_COUNT (0+XfOrM264_COUNT)
#   define SETUP_XfOrM265(x) SETUP_XfOrM264(x)
    FUNCCALL(SETUP_XfOrM265(_), scheme_set_sync_target (sinfo , result , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) )
# 1140 "bc/src/sema.c"
    ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  FUNCCALL(SETUP_XfOrM264(_), ext_get_into_line (ch , sinfo ) )
  ; 

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1149 "bc/src/sema.c"
static int channel_put_ready (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(sinfo, 1)));
# define XfOrM266_COUNT (2)
# define SETUP_XfOrM266(x) SETUP(XfOrM266_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1151 "bc/src/sema.c"
  if (FUNCCALL(SETUP_XfOrM266(_), try_channel ((Scheme_Sema * ) ch , (Syncing * ) sinfo -> current_syncing , - 1 , ((void * ) 0 ) ) ))
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  FUNCCALL_EMPTY(ext_get_into_line (ch , sinfo ) )
  ; 

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1159 "bc/src/sema.c"
static int channel_syncer_ready (Scheme_Object * ch_w , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 1161 "bc/src/sema.c"
  Scheme_Channel_Syncer * w = (Scheme_Channel_Syncer * ) ch_w ; 

  if (w -> picked ) {


    return 1 ; 
  }

  return 0 ; 
}

int scheme_try_channel_get (Scheme_Object * ch ) 
{
  /* No conversion */

# 1174 "bc/src/sema.c"
  if (try_channel ((Scheme_Sema * ) ch , ((void * ) 0 ) , - 1 , ((void * ) 0 ) ) ) {
    return 1 ; 
  }
  return 0 ; 
}




Scheme_Object * do_chaperone_channel (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * evt ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(evt, 1), PUSH(val, 2), PUSH(props, 3), PUSH(argv, 4), PUSH(px, 5)));
# define XfOrM271_COUNT (6)
# define SETUP_XfOrM271(x) SETUP(XfOrM271_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  evt = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 1190 "bc/src/sema.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "channel?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM271(_), scheme_check_proc_arity (name , 1 , 1 , argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 2 , 2 , argc , argv ) ); 

  evt = FUNCCALL_AGAIN(scheme_do_chaperone_evt (name , is_impersonator , 2 , argv ) ); 

  props = FUNCCALL_AGAIN(scheme_parse_chaperone_props (name , 3 , argc , argv ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM271(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = evt ; 
  px -> props = props ; 
  px -> redirects = argv [2 ] ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1215 "bc/src/sema.c"
static Scheme_Object * chaperone_channel (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1217 "bc/src/sema.c"
  return do_chaperone_channel ("chaperone-channel" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_channel (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1222 "bc/src/sema.c"
  return do_chaperone_channel ("impersonator-channel" , 1 , argc , argv ) ; 
}





static void make_mbox_sema (Scheme_Thread * p ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM274_COUNT (1)
# define SETUP_XfOrM274(x) SETUP(XfOrM274_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1231 "bc/src/sema.c"
  if (! p -> mbox_sema ) {
    Scheme_Object * sema = ((void * ) 0 ) ; 
    BLOCK_SETUP((PUSH(sema, 0+XfOrM274_COUNT)));
#   define XfOrM275_COUNT (1+XfOrM274_COUNT)
#   define SETUP_XfOrM275(x) SETUP(XfOrM275_COUNT)

# 1233 "bc/src/sema.c"
    sema = FUNCCALL(SETUP_XfOrM275(_), scheme_make_sema (0 ) ); 
    p -> mbox_sema = sema ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1238 "bc/src/sema.c"
static void mbox_push (Scheme_Thread * p , Scheme_Object * o ) 
{
  Scheme_Object * next ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(next, 1)));
# define XfOrM276_COUNT (2)
# define SETUP_XfOrM276(x) SETUP(XfOrM276_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  next = NULLED_OUT ; 

# 1242 "bc/src/sema.c"
  next = FUNCCALL(SETUP_XfOrM276(_), scheme_make_raw_pair (o , ((void * ) 0 ) ) ); 

  if (p -> mbox_first ) {
    (((Scheme_Simple_Object * ) (p -> mbox_last ) ) -> u . pair_val . cdr ) = next ; 
    p -> mbox_last = next ; 
  }

# 1247 "bc/src/sema.c"
  else {
    p -> mbox_first = next ; 
    p -> mbox_last = next ; 
  }
  FUNCCALL(SETUP_XfOrM276(_), make_mbox_sema (p ) )
  ; 
  FUNCCALL_EMPTY(scheme_post_sema (p -> mbox_sema ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1258 "bc/src/sema.c"
static void mbox_push_front (Scheme_Thread * p , Scheme_Object * lst ) 
{
  int cnt = - 1 ; 
  Scheme_Object * next , * hd ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(next, 1), PUSH(hd, 2), PUSH(lst, 3)));
# define XfOrM279_COUNT (4)
# define SETUP_XfOrM279(x) SETUP(XfOrM279_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  next = NULLED_OUT ; 
  hd = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM279(_), make_mbox_sema (p ) )
# 1263 "bc/src/sema.c"
  ; 

  next = lst ; 
  while (! ((next ) == (scheme_null ) ) ) {
#   define XfOrM284_COUNT (0+XfOrM279_COUNT)
#   define SETUP_XfOrM284(x) SETUP_XfOrM279(x)

# 1268 "bc/src/sema.c"
    hd = FUNCCALL(SETUP_XfOrM284(_), scheme_make_raw_pair ((((Scheme_Simple_Object * ) (next ) ) -> u . pair_val . car ) , p -> mbox_first ) ); 
    if (! p -> mbox_first )
      p -> mbox_last = hd ; 
    p -> mbox_first = hd ; 

    ++ cnt ; 
    next = (((Scheme_Simple_Object * ) (next ) ) -> u . pair_val . cdr ) ; 

    if (((next ) == (scheme_null ) ) || (cnt == 256 ) ) {
#     define XfOrM285_COUNT (0+XfOrM284_COUNT)
#     define SETUP_XfOrM285(x) SETUP_XfOrM284(x)
      ((Scheme_Sema * ) p -> mbox_sema ) -> value += cnt ; 
      FUNCCALL(SETUP_XfOrM285(_), scheme_post_sema (p -> mbox_sema ) ); 
      {
#       define XfOrM286_COUNT (0+XfOrM285_COUNT)
#       define SETUP_XfOrM286(x) SETUP_XfOrM285(x)

# 1281 "bc/src/sema.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM287_COUNT (0+XfOrM286_COUNT)
#         define SETUP_XfOrM287(x) SETUP_XfOrM286(x)
          FUNCCALL(SETUP_XfOrM287(_), scheme_out_of_fuel () )
# 1281 "bc/src/sema.c"
          ; 
        }
      }

# 1281 "bc/src/sema.c"
      ; 
      cnt = - 1 ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1287 "bc/src/sema.c"
static Scheme_Object * mbox_pop (Scheme_Thread * p , int dec ) 
{
  /* No conversion */
  Scheme_Object * r = ((void * ) 0 ) ; 

  r = (((Scheme_Simple_Object * ) (p -> mbox_first ) ) -> u . pair_val . car ) ; 
  p -> mbox_first = (((Scheme_Simple_Object * ) (p -> mbox_first ) ) -> u . pair_val . cdr ) ; 
  if (! p -> mbox_first )
    p -> mbox_last = ((void * ) 0 ) ; 

  if (dec )
    scheme_try_plain_sema (p -> mbox_sema ) ; 

  return r ; 
}

static Scheme_Object * thread_send (int argc , Scheme_Object * * argv ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM289_COUNT (1)
# define SETUP_XfOrM289(x) SETUP(XfOrM289_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1305 "bc/src/sema.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) )  {
    int running ; 
#   define XfOrM290_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM290(x) SETUP_XfOrM289(x)

# 1308 "bc/src/sema.c"
    if (argc > 2 ) {
#     define XfOrM294_COUNT (0+XfOrM290_COUNT)
#     define SETUP_XfOrM294(x) SETUP_XfOrM290(x)

# 1309 "bc/src/sema.c"
      if (! (((argv [2 ] ) ) == (scheme_false ) ) )
        FUNCCALL(SETUP_XfOrM294(_), scheme_check_proc_arity2 ("thread-send" , 0 , 2 , argc , argv , 1 ) ); 
    }

    running = ((Scheme_Thread * ) argv [0 ] ) -> running ; 
    if ((running ) && ! ((running ) & 0x4 ) )  {
#     define XfOrM293_COUNT (0+XfOrM290_COUNT)
#     define SETUP_XfOrM293(x) SETUP_XfOrM290(x)
      FUNCCALL(SETUP_XfOrM293(_), mbox_push ((Scheme_Thread * ) argv [0 ] , argv [1 ] ) )
# 1315 "bc/src/sema.c"
      ; 
      RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
    }

# 1317 "bc/src/sema.c"
    else {
#     define XfOrM291_COUNT (0+XfOrM290_COUNT)
#     define SETUP_XfOrM291(x) SETUP_XfOrM290(x)

# 1318 "bc/src/sema.c"
      if (argc > 2 ) {
#       define XfOrM292_COUNT (0+XfOrM291_COUNT)
#       define SETUP_XfOrM292(x) SETUP_XfOrM291(x)

# 1319 "bc/src/sema.c"
        if (((argv [2 ] ) ) == (scheme_false ) ) 
          RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
        else 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (argv [2 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
      }

# 1323 "bc/src/sema.c"
      else FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "thread-send: target thread is not running" ) )
      ; 
    }
  }

# 1326 "bc/src/sema.c"
  else FUNCCALL_EMPTY(scheme_wrong_contract ("thread-send" , "thread?" , 0 , argc , argv ) )
  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1332 "bc/src/sema.c"
static Scheme_Object * thread_receive (int argc , Scheme_Object * * argv ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
# define XfOrM295_COUNT (0)
# define SETUP_XfOrM295(x) SETUP(XfOrM295_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1337 "bc/src/sema.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> mbox_first ) {
#   define XfOrM297_COUNT (0+XfOrM295_COUNT)
#   define SETUP_XfOrM297(x) SETUP_XfOrM295(x)

# 1338 "bc/src/sema.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(mbox_pop (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , 1 ) )) RET_VALUE_EMPTY_END ; 
  }

# 1339 "bc/src/sema.c"
  else {
    Scheme_Object * v ; 
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM295_COUNT), PUSH(p, 1+XfOrM295_COUNT)));
#   define XfOrM296_COUNT (2+XfOrM295_COUNT)
#   define SETUP_XfOrM296(x) SETUP(XfOrM296_COUNT)
    v = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM296(_), make_mbox_sema (p ) )
# 1343 "bc/src/sema.c"
    ; 
    FUNCCALL_AGAIN(scheme_wait_sema (p -> mbox_sema , 0 ) )
    ; 


    v = FUNCCALL_AGAIN(mbox_pop (p , 0 ) ); 
    FUNCCALL_AGAIN(scheme_check_break_now () )


    ; 

    RET_VALUE_START (v ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1358 "bc/src/sema.c"
static Scheme_Object * thread_try_receive (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1360 "bc/src/sema.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> mbox_first )
    return mbox_pop (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , 1 ) ; 
  else 
  return scheme_false ; 
}

static Scheme_Object * thread_receive_evt (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1368 "bc/src/sema.c"
  return thread_recv_evt ; 
}

static int thread_recv_ready (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Thread * p ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(sinfo, 1)));
# define XfOrM300_COUNT (2)
# define SETUP_XfOrM300(x) SETUP(XfOrM300_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 1375 "bc/src/sema.c"
  p = sinfo -> false_positive_ok ; 
  if (! p )
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  FUNCCALL(SETUP_XfOrM300(_), make_mbox_sema (p ) )
  ; 
  FUNCCALL_EMPTY(scheme_set_sync_target (sinfo , p -> mbox_sema , thread_recv_evt , ((void * ) 0 ) , 1 , 1 , ((void * ) 0 ) ) )
  ; 

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1386 "bc/src/sema.c"
static Scheme_Object * thread_rewind_receive (int argc , Scheme_Object * * argv ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM301_COUNT (1)
# define SETUP_XfOrM301(x) SETUP(XfOrM301_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1388 "bc/src/sema.c"
  if (scheme_is_list (argv [0 ] ) )  {
#   define XfOrM302_COUNT (0+XfOrM301_COUNT)
#   define SETUP_XfOrM302(x) SETUP_XfOrM301(x)
    FUNCCALL(SETUP_XfOrM302(_), mbox_push_front (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , argv [0 ] ) )
# 1389 "bc/src/sema.c"
    ; 
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }

# 1391 "bc/src/sema.c"
  else FUNCCALL_EMPTY(scheme_wrong_contract ("thread-rewind-receive" , "list?" , 0 , argc , argv ) )
  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * make_alarm (int argc , Scheme_Object * * argv ) 
{
  Scheme_Alarm * a ; 
  double sleep_end ; 
  int is_monotonic = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(argv, 1)));
# define XfOrM303_COUNT (2)
# define SETUP_XfOrM303(x) SETUP(XfOrM303_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 1407 "bc/src/sema.c"
  if (! ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) || ((((argv [0 ] ) -> type ) >= scheme_bignum_type ) && (((argv [0 ] ) -> type ) < scheme_complex_type ) ) ) ) {
#   define XfOrM305_COUNT (0+XfOrM303_COUNT)
#   define SETUP_XfOrM305(x) SETUP_XfOrM303(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("alarm-evt" , "real?" , 0 , argc , argv ) )
# 1408 "bc/src/sema.c"
    ; 
  }

  sleep_end = FUNCCALL(SETUP_XfOrM303(_), scheme_get_val_as_double (argv [0 ] ) ); 

  if ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) {
    is_monotonic = 1 ; 
  }

  a = ((Scheme_Alarm * ) FUNCCALL(SETUP_XfOrM303(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Alarm ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  a -> so . type = scheme_alarm_type ; 
  a -> sleep_end = sleep_end ; 
  a -> is_monotonic = is_monotonic ; 

  RET_VALUE_START ((Scheme_Object * ) a ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1425 "bc/src/sema.c"
static int alarm_ready (Scheme_Object * _a , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 1427 "bc/src/sema.c"
  Scheme_Alarm * a = (Scheme_Alarm * ) _a ; 

  double sleep_end_monotonic = a -> sleep_end ; 
  if (! a -> is_monotonic ) {
    sleep_end_monotonic = rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) 
    + a -> sleep_end - scheme_get_inexact_milliseconds () ; 
  }

  if (! sinfo -> sleep_end 
  || (sinfo -> sleep_end > sleep_end_monotonic ) )
    sinfo -> sleep_end = sleep_end_monotonic ; 

  if (sleep_end_monotonic <= rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) )
    return 1 ; 

  return 0 ; 
}

static int always_ready (Scheme_Object * w ) 
{
  /* No conversion */

# 1447 "bc/src/sema.c"
  return 1 ; 
}

static int never_ready (Scheme_Object * w ) 
{
  /* No conversion */

# 1452 "bc/src/sema.c"
  return 0 ; 
}

static Scheme_Object * make_sys_idle (int n , Scheme_Object * * p ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
# define XfOrM310_COUNT (0)
# define SETUP_XfOrM310(x) SETUP(XfOrM310_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1457 "bc/src/sema.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> system_idle_put_evt_ ) ) {
    Scheme_Object * a [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM310_COUNT)));
#   define XfOrM311_COUNT (3+XfOrM310_COUNT)
#   define SETUP_XfOrM311(x) SETUP(XfOrM311_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM311(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> system_idle_put_evt_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> system_idle_put_evt_ ) ) ) )
# 1459 "bc/src/sema.c"
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> system_idle_put_evt_ ) = FUNCCALL(SETUP_XfOrM311(_), scheme_make_channel_put_evt (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_system_idle_channel_ ) , scheme_void ) )
    ; 
    a [0 ] = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> system_idle_put_evt_ ) ; 
    a [1 ] = scheme_void_proc ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> system_idle_put_evt_ ) = FUNCCALL(SETUP_XfOrM311(_), scheme_wrap_evt (2 , a ) ); 
  }

  RET_VALUE_START (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> system_idle_put_evt_ ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "bc/src/mzmark_sema.inc"
static int mark_channel_syncer_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_channel_syncer_MARK (void * p , struct NewGC * gc ) {

  Scheme_Channel_Syncer * w = (Scheme_Channel_Syncer * ) p ; 

  GC_mark2 (& (w -> p ) , gc ) ; 
  GC_mark2 (& (w -> prev ) , gc ) ; 
  GC_mark2 (& (w -> next ) , gc ) ; 
  GC_mark2 (& (w -> syncing ) , gc ) ; 
  GC_mark2 (& (w -> obj ) , gc ) ; 


  return 0 ; 
}






static int mark_channel_syncer_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Channel_Syncer * w = (Scheme_Channel_Syncer * ) p ; 

  GC_fixup2 (& (w -> p ) , gc ) ; 
  GC_fixup2 (& (w -> prev ) , gc ) ; 
  GC_fixup2 (& (w -> next ) , gc ) ; 
  GC_fixup2 (& (w -> syncing ) , gc ) ; 
  GC_fixup2 (& (w -> obj ) , gc ) ; 


  return 0 ; 
}

# 53 "bc/src/mzmark_sema.inc"
static int mark_alarm_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_alarm_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int mark_alarm_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 1480 "bc/src/sema.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_alarm_type , mark_alarm_SIZE , mark_alarm_MARK , mark_alarm_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_channel_syncer_type , mark_channel_syncer_SIZE , mark_channel_syncer_MARK , mark_channel_syncer_FIXUP , 1 , 0 ) ; 
}
