#include "precomp.h"

# 9 "bc/src/sfs.c"
struct SFS_Info {
  Scheme_Type type ; 
  int for_linklet , pass ; 
  int tail_pos ; 
  int depth , stackpos , tlpos ; 
  int selfpos , selfstart , selflen ; 
  int ip ; 
  int abs_ip ; 
  int seqn ; 
  int max_nontail ; 
  int abs_max_nontail ; 
  int min_touch , max_touch ; 
  int * max_used ; 
  int * max_calls ; 
  Scheme_Object * saved ; 
}

# 24 "bc/src/sfs.c"
; 

static void linklet_sfs (Scheme_Linklet * linklet , SFS_Info * info ) ; 
static Scheme_Object * sfs_expr (Scheme_Object * expr , SFS_Info * info , int closure_self_pos ) ; 
static SFS_Info * new_sfs_info (int depth ) ; 

static void sfs_used (SFS_Info * info , int pos ) ; 
static void sfs_push (SFS_Info * info , int count , int track ) ; 
static void sfs_start_sequence (SFS_Info * si , int cnt , int last_is_tail ) ; 
static Scheme_Object * sfs_add_clears (Scheme_Object * expr , Scheme_Object * clears , int pre ) ; 

static Scheme_Object * sfs_passes (Scheme_Object * e , SFS_Info * info ) ; 
static void linklet_sfs (Scheme_Linklet * linklet , SFS_Info * info ) ; 


static void register_traversers (void ) ; 




void scheme_init_sfs () 
{
  /* No conversion */
  register_traversers () ; 
}







Scheme_Linklet * scheme_sfs_linklet (Scheme_Linklet * linklet ) 
{
  SFS_Info * info ; 
  DECL_RET_SAVE (Scheme_Linklet * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(linklet, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  info = NULLED_OUT ; 

# 60 "bc/src/sfs.c"
  info = FUNCCALL(SETUP_XfOrM2(_), new_sfs_info (linklet -> max_let_depth ) ); 

  RET_VALUE_START ((Scheme_Linklet * ) FUNCCALL_EMPTY(sfs_passes ((Scheme_Object * ) linklet , info ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 65 "bc/src/sfs.c"
static Scheme_Object * sfs_passes (Scheme_Object * o , SFS_Info * info ) 
{
  int init , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(o, 1)));
# define XfOrM3_COUNT (2)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 69 "bc/src/sfs.c"
  info -> pass = 0 ; 
  info -> ip = 1 ; 
  info -> abs_ip = 1 ; 
  info -> saved = scheme_null ; 
  info -> min_touch = - 1 ; 
  info -> max_touch = - 1 ; 
  info -> tail_pos = 1 ; 
  init = info -> stackpos ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) 
    FUNCCALL(SETUP_XfOrM3(_), linklet_sfs ((Scheme_Linklet * ) o , info ) ); 
  else 
  o = FUNCCALL(SETUP_XfOrM3(_), sfs_expr (o , info , - 1 ) ); 

  if (info -> seqn )
    FUNCCALL_EMPTY(scheme_signal_error ("ended in the middle of an expression?" ) ); 






  for (i = info -> depth ; i -- > init ; ) {
    info -> max_calls [i ] = info -> max_nontail ; 
  }

  {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM3_COUNT)));
#   define XfOrM4_COUNT (1+XfOrM3_COUNT)
#   define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
    v = NULLED_OUT ; 

# 97 "bc/src/sfs.c"
    v = FUNCCALL(SETUP_XfOrM4(_), scheme_reverse (info -> saved ) ); 
    info -> saved = v ; 
  }

  info -> pass = 1 ; 
  info -> seqn = 0 ; 
  info -> ip = 1 ; 
  info -> abs_ip = 1 ; 
  info -> tail_pos = 1 ; 
  info -> stackpos = init ; 
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) 
    FUNCCALL(SETUP_XfOrM3(_), linklet_sfs ((Scheme_Linklet * ) o , info ) ); 
  else 
  o = FUNCCALL(SETUP_XfOrM3(_), sfs_expr (o , info , - 1 ) ); 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 115 "bc/src/sfs.c"
static void linklet_sfs (Scheme_Linklet * linklet , SFS_Info * info ) 
{
  Scheme_Object * e ; 
  int i , cnt ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(info, 1), PUSH(linklet, 2)));
# define XfOrM7_COUNT (3)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  e = NULLED_OUT ; 

# 120 "bc/src/sfs.c"
  cnt = (((Scheme_Vector * ) (linklet -> bodies ) ) -> size ) ; 
  FUNCCALL(SETUP_XfOrM7(_), sfs_start_sequence (info , cnt , 0 ) ); 

  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM9_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM9(x) SETUP_XfOrM7(x)

# 124 "bc/src/sfs.c"
    e = FUNCCALL(SETUP_XfOrM9(_), sfs_expr ((((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] , info , - 1 ) ); 
    (((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] = e ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 129 "bc/src/sfs.c"
static SFS_Info * new_sfs_info (int depth ) 
{
  SFS_Info * info ; 
  int * max_used , * max_calls ; 
  DECL_RET_SAVE (SFS_Info * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(max_calls, 0), PUSH(info, 1), PUSH(max_used, 2)));
# define XfOrM10_COUNT (3)
# define SETUP_XfOrM10(x) SETUP(XfOrM10_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  info = NULLED_OUT ; 
  max_used = NULLED_OUT ; 
  max_calls = NULLED_OUT ; 

# 134 "bc/src/sfs.c"
  info = ((SFS_Info * ) FUNCCALL(SETUP_XfOrM10(_), GC_malloc_one_small_tagged ((((sizeof (SFS_Info ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  info -> type = scheme_rt_sfs_info ; 

  info -> depth = depth ; 
  info -> stackpos = depth ; 
  info -> tlpos = depth ; 

  max_used = (int * ) FUNCCALL(SETUP_XfOrM10(_), GC_malloc_atomic (sizeof (int ) * depth ) ); 
  max_calls = (int * ) FUNCCALL(SETUP_XfOrM10(_), GC_malloc_atomic (sizeof (int ) * depth ) ); 
  (
  memset (max_used , 0 , sizeof (int ) * depth ) ) ; 
  (memset (max_calls , 0 , sizeof (int ) * depth ) ) ; 

  info -> max_used = max_used ; 
  info -> max_calls = max_calls ; 

  RET_VALUE_START (info ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 153 "bc/src/sfs.c"
static void scheme_sfs_save (SFS_Info * info , Scheme_Object * v ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(v, 1)));
# define XfOrM11_COUNT (2)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 155 "bc/src/sfs.c"
  if (info -> pass )
    FUNCCALL_EMPTY(scheme_signal_error ("internal error: wrong pass to save info" ) ); 
  v = FUNCCALL(SETUP_XfOrM11(_), scheme_make_pair (v , info -> saved ) ); 
  info -> saved = v ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 161 "bc/src/sfs.c"
static Scheme_Object * scheme_sfs_next_saved (SFS_Info * info ) 
{
  /* No conversion */

# 163 "bc/src/sfs.c"
  Scheme_Object * v ; 

  if (! info -> pass )
    scheme_signal_error ("internal error: wrong pass to get saved info" ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (info -> saved ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (info -> saved ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
    scheme_signal_error ("internal error: no saved info" ) ; 

  v = (((Scheme_Simple_Object * ) (info -> saved ) ) -> u . pair_val . car ) ; 
  info -> saved = (((Scheme_Simple_Object * ) (info -> saved ) ) -> u . pair_val . cdr ) ; 
  return v ; 
}

static void sfs_start_sequence (SFS_Info * info , int cnt , int last_is_tail ) 
{
  /* No conversion */

# 177 "bc/src/sfs.c"
  info -> seqn += (cnt - (last_is_tail ? 1 : 0 ) ) ; 
}

static void sfs_push (SFS_Info * info , int cnt , int track ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(info, 0)));
# define XfOrM14_COUNT (1)
# define SETUP_XfOrM14(x) SETUP(XfOrM14_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 182 "bc/src/sfs.c"
  info -> stackpos -= cnt ; 

  ; 

  if (info -> stackpos < 0 )
    FUNCCALL_EMPTY(scheme_signal_error ("internal error: pushed too deep" ) ); 

  if (track ) {
#   define XfOrM15_COUNT (0+XfOrM14_COUNT)
#   define SETUP_XfOrM15(x) SETUP_XfOrM14(x)

# 190 "bc/src/sfs.c"
    while (cnt -- ) {
#     define XfOrM17_COUNT (0+XfOrM15_COUNT)
#     define SETUP_XfOrM17(x) SETUP_XfOrM15(x)
      FUNCCALL(SETUP_XfOrM17(_), sfs_used (info , cnt ) )
# 191 "bc/src/sfs.c"
      ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 196 "bc/src/sfs.c"
static void sfs_used (SFS_Info * info , int pos ) 
{
  /* No conversion */

# 198 "bc/src/sfs.c"
  if (info -> pass )
    return ; 

  pos += info -> stackpos ; 

  if ((pos < 0 ) || (pos >= info -> depth ) ) {
    scheme_signal_error ("internal error: stack use out of bounds" ) ; 
  }
  if (pos == info -> tlpos )
    scheme_signal_error ("internal error: misuse of toplevel pointer" ) ; 

  ; 

  if (info -> max_used [pos ] >= 0x3FFFFFFe ) {
    info -> max_used [pos ] = (0x3FFFFFFe + 1 ) ; 
    return ; 
  }

  if ((info -> min_touch == - 1 ) 
  || (pos < info -> min_touch ) )
    info -> min_touch = pos ; 
  if (pos > info -> max_touch )
    info -> max_touch = pos ; 

  info -> max_used [pos ] = info -> ip ; 
}

static Scheme_Object * sfs_add_clears (Scheme_Object * expr , Scheme_Object * clears , int pre ) 
{
  int len , i ; 
  Scheme_Object * loc ; 
  Scheme_Sequence * s ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(loc, 0), PUSH(clears, 1), PUSH(s, 2), PUSH(expr, 3)));
# define XfOrM21_COUNT (4)
# define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  loc = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 231 "bc/src/sfs.c"
  if ((clears ) == (scheme_null ) ) 
    RET_VALUE_START (expr ) RET_VALUE_END ; 

  len = (scheme_list_length (clears ) ) ; 

  s = FUNCCALL(SETUP_XfOrM21(_), scheme_malloc_sequence (len + 1 ) ); 
  s -> so . type = (pre ? scheme_sequence_type : scheme_begin0_sequence_type ) ; 
  s -> count = len + 1 ; 
  s -> array [pre ? len : 0 ] = expr ; 

  for (i = 0 ; i < len ; i ++ ) {
#   define XfOrM23_COUNT (0+XfOrM21_COUNT)
#   define SETUP_XfOrM23(x) SETUP_XfOrM21(x)

# 242 "bc/src/sfs.c"
    loc = FUNCCALL(SETUP_XfOrM23(_), scheme_make_local (scheme_local_type , (((intptr_t ) ((((Scheme_Simple_Object * ) (clears ) ) -> u . pair_val . car ) ) ) >> 1 ) , 1 ) )

    ; 
    s -> array [i + (pre ? 0 : 1 ) ] = loc ; 
    clears = (((Scheme_Simple_Object * ) (clears ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 252 "bc/src/sfs.c"
static void sfs_note_app (SFS_Info * info , Scheme_Object * rator , int flags ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(info, 0)));
# define XfOrM24_COUNT (1)
# define SETUP_XfOrM24(x) SETUP(XfOrM24_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 254 "bc/src/sfs.c"
  if (! info -> pass ) {
#   define XfOrM25_COUNT (0+XfOrM24_COUNT)
#   define SETUP_XfOrM25(x) SETUP_XfOrM24(x)

# 255 "bc/src/sfs.c"
    if (! info -> tail_pos ) {
      if (flags & (1 << 12 ) )
        RET_NOTHING ; 
      if ((scheme_values_proc ) == (rator ) ) 

      RET_NOTHING ; 
      if ((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) )  {

        int opt ; 
        opt = ((Scheme_Prim_Proc_Header * ) rator ) -> flags & (1 | 2 ) ; 
        if (opt >= 2 )

        RET_NOTHING ; 
      }
      info -> max_nontail = info -> ip ; 
      info -> abs_max_nontail = info -> abs_ip ; 
    }

# 271 "bc/src/sfs.c"
    else {
      int tail_ok = (flags & (1 << 13 ) ) ; 
#     define XfOrM26_COUNT (0+XfOrM25_COUNT)
#     define SETUP_XfOrM26(x) SETUP_XfOrM25(x)

# 273 "bc/src/sfs.c"
      if (! 0 && (info -> selfpos >= 0 ) ) {
#       define XfOrM28_COUNT (0+XfOrM26_COUNT)
#       define SETUP_XfOrM28(x) SETUP_XfOrM26(x)

# 274 "bc/src/sfs.c"
        if (((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_local_type ) ) 
        && ((((Scheme_Local * ) (rator ) ) -> position ) + info -> stackpos ) == info -> selfpos ) {


          int i ; 
#         define XfOrM29_COUNT (0+XfOrM28_COUNT)
#         define SETUP_XfOrM29(x) SETUP_XfOrM28(x)

# 279 "bc/src/sfs.c"
          for (i = info -> selflen ; i -- ; ) {
#           define XfOrM31_COUNT (0+XfOrM29_COUNT)
#           define SETUP_XfOrM31(x) SETUP_XfOrM29(x)

# 280 "bc/src/sfs.c"
            if ((info -> selfstart + i ) != info -> tlpos )
              FUNCCALL(SETUP_XfOrM31(_), sfs_used (info , (info -> selfstart - info -> stackpos ) + i ) ); 
          }
          tail_ok = 1 ; 
        }
      }
      if (! tail_ok ) {
        info -> max_nontail = info -> ip ; 
        info -> abs_max_nontail = info -> abs_ip ; 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 294 "bc/src/sfs.c"
static Scheme_Object * sfs_application (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_Object * orig , * naya = ((void * ) 0 ) ; 
  Scheme_App_Rec * app ; 
  int i , n ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(orig, 0), PUSH(info, 1), PUSH(o, 2), PUSH(app, 3), PUSH(naya, 4)));
# define XfOrM34_COUNT (5)
# define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  orig = NULLED_OUT ; 
  app = NULLED_OUT ; 

# 300 "bc/src/sfs.c"
  app = (Scheme_App_Rec * ) o ; 
  n = app -> num_args + 1 ; 
  FUNCCALL(SETUP_XfOrM34(_), sfs_start_sequence (info , n , 0 ) )
  ; 
  FUNCCALL_AGAIN(sfs_push (info , n - 1 , 0 ) ); 

  for (i = 0 ; i < n ; i ++ ) {
#   define XfOrM36_COUNT (0+XfOrM34_COUNT)
#   define SETUP_XfOrM36(x) SETUP_XfOrM34(x)

# 307 "bc/src/sfs.c"
    orig = app -> args [i ] ; 
    naya = FUNCCALL(SETUP_XfOrM36(_), sfs_expr (orig , info , - 1 ) ); 
    app -> args [i ] = naya ; 
  }
  FUNCCALL(SETUP_XfOrM34(_), sfs_note_app (info , app -> args [0 ] , (& (app ) -> iso ) -> so . keyex & ((1 << 11 ) | (1 << 12 ) | (1 << 13 ) ) ) )
  ; 
  FUNCCALL(SETUP_XfOrM34(_), scheme_finish_application (app ) )
  ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 319 "bc/src/sfs.c"
static Scheme_Object * sfs_application2 (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_App2_Rec * app ; 
  Scheme_Object * nrator , * nrand ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(nrand, 0), PUSH(info, 1), PUSH(nrator, 2), PUSH(o, 3), PUSH(app, 4)));
# define XfOrM37_COUNT (5)
# define SETUP_XfOrM37(x) SETUP(XfOrM37_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  app = NULLED_OUT ; 
  nrator = NULLED_OUT ; 
  nrand = NULLED_OUT ; 

# 324 "bc/src/sfs.c"
  app = (Scheme_App2_Rec * ) o ; 
  FUNCCALL(SETUP_XfOrM37(_), sfs_start_sequence (info , 2 , 0 ) )
  ; 
  FUNCCALL_AGAIN(sfs_push (info , 1 , 0 ) ); 

  nrator = FUNCCALL_AGAIN(sfs_expr (app -> rator , info , - 1 ) ); 
  nrand = FUNCCALL_AGAIN(sfs_expr (app -> rand , info , - 1 ) ); 
  app -> rator = nrator ; 
  app -> rand = nrand ; 
  FUNCCALL(SETUP_XfOrM37(_), sfs_note_app (info , app -> rator , (& (app ) -> iso ) -> so . keyex & ((1 << 11 ) | (1 << 12 ) | (1 << 13 ) ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_reset_app2_eval_type (app ) )
  ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 341 "bc/src/sfs.c"
static Scheme_Object * sfs_application3 (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_App3_Rec * app ; 
  Scheme_Object * nrator , * nrand1 , * nrand2 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(nrand2, 1), PUSH(nrand1, 2), PUSH(nrator, 3), PUSH(info, 4), PUSH(app, 5)));
# define XfOrM38_COUNT (6)
# define SETUP_XfOrM38(x) SETUP(XfOrM38_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  app = NULLED_OUT ; 
  nrator = NULLED_OUT ; 
  nrand1 = NULLED_OUT ; 
  nrand2 = NULLED_OUT ; 

# 346 "bc/src/sfs.c"
  app = (Scheme_App3_Rec * ) o ; 
  FUNCCALL(SETUP_XfOrM38(_), sfs_start_sequence (info , 3 , 0 ) )
  ; 
  FUNCCALL_AGAIN(sfs_push (info , 2 , 0 ) ); 

  nrator = FUNCCALL_AGAIN(sfs_expr (app -> rator , info , - 1 ) ); 
  nrand1 = FUNCCALL_AGAIN(sfs_expr (app -> rand1 , info , - 1 ) ); 
  nrand2 = FUNCCALL_AGAIN(sfs_expr (app -> rand2 , info , - 1 ) ); 

  app -> rator = nrator ; 
  app -> rand1 = nrand1 ; 
  app -> rand2 = nrand2 ; 
  FUNCCALL(SETUP_XfOrM38(_), sfs_note_app (info , app -> rator , (& (app ) -> iso ) -> so . keyex & ((1 << 11 ) | (1 << 12 ) | (1 << 13 ) ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_reset_app3_eval_type (app ) )
  ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 366 "bc/src/sfs.c"
static Scheme_Object * flatten_sequence (Scheme_Object * o ) 
{


  Scheme_Sequence * s = (Scheme_Sequence * ) o , * s2 ; 
  int i , extra = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s2, 0), PUSH(s, 1), PUSH(o, 2)));
# define XfOrM39_COUNT (3)
# define SETUP_XfOrM39(x) SETUP(XfOrM39_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s2 = NULLED_OUT ; 

# 373 "bc/src/sfs.c"
  o = s -> array [s -> count - 1 ] ; 

  while (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_sequence_type ) ) ) {
    s2 = (Scheme_Sequence * ) o ; 
    extra += s2 -> count - 1 ; 
    o = s2 -> array [s2 -> count - 1 ] ; 
  }

  if (extra ) {
#   define XfOrM40_COUNT (0+XfOrM39_COUNT)
#   define SETUP_XfOrM40(x) SETUP_XfOrM39(x)

# 382 "bc/src/sfs.c"
    s2 = FUNCCALL(SETUP_XfOrM40(_), scheme_malloc_sequence (s -> count + extra ) ); 
    s2 -> so . type = scheme_sequence_type ; 
    s2 -> count = s -> count + extra ; 

    extra = 0 ; 
    o = (Scheme_Object * ) s ; 
    while (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_sequence_type ) ) ) {
      s = (Scheme_Sequence * ) o ; 
      for (i = 0 ; i < s -> count - 1 ; i ++ ) {
        s2 -> array [extra ++ ] = s -> array [i ] ; 
      }
      o = s -> array [i ] ; 
    }
    s2 -> array [extra ++ ] = o ; 

    if (extra != s2 -> count )
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: flatten failed" ) )
# 397 "bc/src/sfs.c"
    ; 

    RET_VALUE_START ((Scheme_Object * ) s2 ) RET_VALUE_END ; 
  }

# 400 "bc/src/sfs.c"
  else 
  RET_VALUE_START ((Scheme_Object * ) s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 404 "bc/src/sfs.c"
static Scheme_Object * sfs_sequence (Scheme_Object * o , SFS_Info * info , int can_flatten ) 
{
  Scheme_Object * orig , * naya ; 
  Scheme_Sequence * seq ; 
  int i , n ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(orig, 1), PUSH(seq, 2), PUSH(info, 3), PUSH(naya, 4)));
# define XfOrM49_COUNT (5)
# define SETUP_XfOrM49(x) SETUP(XfOrM49_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  orig = NULLED_OUT ; 
  naya = NULLED_OUT ; 
  seq = NULLED_OUT ; 

# 410 "bc/src/sfs.c"
  seq = (Scheme_Sequence * ) o ; 
  n = seq -> count ; 
  FUNCCALL(SETUP_XfOrM49(_), sfs_start_sequence (info , n , 1 ) )
  ; 

  for (i = 0 ; i < n ; i ++ ) {
#   define XfOrM51_COUNT (0+XfOrM49_COUNT)
#   define SETUP_XfOrM51(x) SETUP_XfOrM49(x)

# 416 "bc/src/sfs.c"
    orig = seq -> array [i ] ; 
    naya = FUNCCALL(SETUP_XfOrM51(_), sfs_expr (orig , info , - 2 ) ); 
    seq -> array [i ] = naya ; 
  }

  if (can_flatten && info -> pass )
    o = FUNCCALL(SETUP_XfOrM49(_), flatten_sequence (o ) ); 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 429 "bc/src/sfs.c"
static Scheme_Object * sfs_one_branch (SFS_Info * info , int ip , 
Scheme_Object * vec , int delta , 
Scheme_Object * tbranch ) 
{
  int t_min_t , t_max_t , t_cnt , n , stackpos , i , save_nt , b_end , nt , else_end_abs ; 
  Scheme_Object * t_vec , * o ; 
  Scheme_Object * clears = scheme_null ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(clears, 0), PUSH(t_vec, 1), PUSH(info, 2), PUSH(vec, 3), PUSH(o, 4), PUSH(tbranch, 5)));
# define XfOrM52_COUNT (6)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t_vec = NULLED_OUT ; 
  o = NULLED_OUT ; 

# 437 "bc/src/sfs.c"
  info -> min_touch = - 1 ; 
  info -> max_touch = - 1 ; 
  save_nt = info -> max_nontail ; 

  ; 

  if (info -> pass ) {
#   define XfOrM62_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM62(x) SETUP_XfOrM52(x)

# 445 "bc/src/sfs.c"
    o = (((Scheme_Vector * ) (vec ) ) -> els ) [delta * 5 ] ; 
    t_min_t = (((intptr_t ) (o ) ) >> 1 ) ; 
    o = (((Scheme_Vector * ) (vec ) ) -> els ) [(delta * 5 ) + 2 ] ; 
    nt = (((intptr_t ) (o ) ) >> 1 ) ; 
    if (nt > info -> max_nontail )
      info -> max_nontail = nt ; 
    if (t_min_t > - 1 ) {
      t_vec = (((Scheme_Vector * ) (vec ) ) -> els ) [(delta * 5 ) + 1 ] ; 
      t_cnt = (((Scheme_Vector * ) (t_vec ) ) -> size ) ; 
      for (i = 0 ; i < t_cnt ; i ++ ) {
        o = (((Scheme_Vector * ) (t_vec ) ) -> els ) [i ] ; 
        if (((intptr_t ) (o ) ) & 0x1 )  {
          n = (((intptr_t ) (o ) ) >> 1 ) ; 
          ; 
          if (info -> max_used [i + t_min_t ] < n ) {
            ; 
            info -> max_used [i + t_min_t ] = n ; 
            info -> max_calls [i + t_min_t ] = info -> max_nontail ; 
          }

# 463 "bc/src/sfs.c"
          else 
          (((Scheme_Vector * ) (t_vec ) ) -> els ) [i ] = scheme_false ; 
        }
      }
    }






    o = (((Scheme_Vector * ) (vec ) ) -> els ) [(delta * 5 ) + 3 ] ; 
    b_end = (((intptr_t ) (o ) ) >> 1 ) ; 
    o = (((Scheme_Vector * ) (vec ) ) -> els ) [5 + 4 ] ; 
    else_end_abs = (((intptr_t ) (o ) ) >> 1 ) ; 
    ; 
    if (((nt > (ip + 1 ) ) && (nt < b_end ) ) 
    || (! info -> tail_pos 
    && (else_end_abs < info -> abs_max_nontail ) ) ) {
#     define XfOrM63_COUNT (0+XfOrM62_COUNT)
#     define SETUP_XfOrM63(x) SETUP_XfOrM62(x)

# 482 "bc/src/sfs.c"
      ; 
      o = (((Scheme_Vector * ) (vec ) ) -> els ) [(1 - delta ) * 5 ] ; 
      t_min_t = (((intptr_t ) (o ) ) >> 1 ) ; 
      if (t_min_t > - 1 ) {
        int at_ip , pos ; 
#       define XfOrM64_COUNT (0+XfOrM63_COUNT)
#       define SETUP_XfOrM64(x) SETUP_XfOrM63(x)

# 487 "bc/src/sfs.c"
        t_vec = (((Scheme_Vector * ) (vec ) ) -> els ) [((1 - delta ) * 5 ) + 1 ] ; 
        t_cnt = (((Scheme_Vector * ) (t_vec ) ) -> size ) ; 
        o = (((Scheme_Vector * ) (vec ) ) -> els ) [((1 - delta ) * 5 ) + 2 ] ; 
        nt = (((intptr_t ) (o ) ) >> 1 ) ; 
        o = (((Scheme_Vector * ) (vec ) ) -> els ) [((1 - delta ) * 5 ) + 3 ] ; 
        b_end = (((intptr_t ) (o ) ) >> 1 ) ; 
        for (i = 0 ; i < t_cnt ; i ++ ) {
#         define XfOrM68_COUNT (0+XfOrM64_COUNT)
#         define SETUP_XfOrM68(x) SETUP_XfOrM64(x)

# 494 "bc/src/sfs.c"
          o = (((Scheme_Vector * ) (t_vec ) ) -> els ) [i ] ; 
          if (((intptr_t ) (o ) ) & 0x1 )  {
#           define XfOrM69_COUNT (0+XfOrM68_COUNT)
#           define SETUP_XfOrM69(x) SETUP_XfOrM68(x)

# 496 "bc/src/sfs.c"
            n = (((intptr_t ) (o ) ) >> 1 ) ; 
            pos = i + t_min_t ; 
            at_ip = info -> max_used [pos ] ; 
            ; 

            if ((((! delta && (at_ip == ip ) ) 
            || (delta && (at_ip == n ) ) ) ) 

            && (info -> max_calls [pos ] > info -> max_used [pos ] ) ) {
#             define XfOrM70_COUNT (0+XfOrM69_COUNT)
#             define SETUP_XfOrM70(x) SETUP_XfOrM69(x)

# 506 "bc/src/sfs.c"
              ; 
              pos -= info -> stackpos ; 
              clears = FUNCCALL(SETUP_XfOrM70(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , clears ) )
              ; 
            }
          }
        }
      }
    }
  }

  stackpos = info -> stackpos ; 

  tbranch = FUNCCALL(SETUP_XfOrM52(_), sfs_expr (tbranch , info , - 1 ) ); 

  if (info -> pass )
    info -> max_nontail = save_nt ; 







  tbranch = FUNCCALL(SETUP_XfOrM52(_), sfs_add_clears (tbranch , clears , 1 ) ); 

  if (! info -> pass ) {
#   define XfOrM53_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM53(x) SETUP_XfOrM52(x)

# 533 "bc/src/sfs.c"
    t_min_t = info -> min_touch ; 
    t_max_t = info -> max_touch ; 
    if (t_min_t < stackpos )
      t_min_t = stackpos ; 
    if (t_max_t < stackpos )
      t_max_t = - 1 ; 

    ; 
    if (t_max_t < 0 ) {
      t_min_t = - 1 ; 
      t_vec = scheme_false ; 
    }

# 544 "bc/src/sfs.c"
    else {
#     define XfOrM54_COUNT (0+XfOrM53_COUNT)
#     define SETUP_XfOrM54(x) SETUP_XfOrM53(x)

# 545 "bc/src/sfs.c"
      t_cnt = t_max_t - t_min_t + 1 ; 
      t_vec = FUNCCALL(SETUP_XfOrM54(_), scheme_make_vector (t_cnt , ((void * ) 0 ) ) ); 
      for (i = 0 ; i < t_cnt ; i ++ ) {
        n = info -> max_used [i + t_min_t ] ; 

        ; 
        if ((n > ip ) && (n < 0x3FFFFFFe ) ) {
          (((Scheme_Vector * ) (t_vec ) ) -> els ) [i ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
          info -> max_used [i + t_min_t ] = ip ; 
        }

# 554 "bc/src/sfs.c"
        else {
          (((Scheme_Vector * ) (t_vec ) ) -> els ) [i ] = scheme_false ; 
        }
      }
    }
    (((Scheme_Vector * ) (vec ) ) -> els ) [delta * 5 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (t_min_t ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [(delta * 5 ) + 1 ] = t_vec ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [(delta * 5 ) + 2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (info -> max_nontail ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [(delta * 5 ) + 3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (info -> ip ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [(delta * 5 ) + 4 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (info -> abs_ip ) ) ) << 1 ) | 0x1 ) ) ; 
  }
  (
  memset (info -> max_used + info -> stackpos , 0 , (stackpos - info -> stackpos ) * sizeof (int ) ) ) ; 
  (memset (info -> max_calls + info -> stackpos , 0 , (stackpos - info -> stackpos ) * sizeof (int ) ) ) ; 

  info -> stackpos = stackpos ; 

  RET_VALUE_START (tbranch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 574 "bc/src/sfs.c"
static void sfs_restore_one_branch (SFS_Info * info , int ip , 
Scheme_Object * vec , int delta ) 
{
  /* No conversion */

# 577 "bc/src/sfs.c"
  int t_min_t , t_cnt , i ; 
  Scheme_Object * t_vec ; 

  t_vec = (((Scheme_Vector * ) (vec ) ) -> els ) [(delta * 5 ) + 1 ] ; 

  if (((t_vec ) ) == (scheme_false ) ) 

# 582 "bc/src/sfs.c"
  return ; 

  t_min_t = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [delta * 5 ] ) ) >> 1 ) ; 
  t_cnt = (((Scheme_Vector * ) (t_vec ) ) -> size ) ; 

  for (i = 0 ; i < t_cnt ; i ++ ) {
    if (! ((((((Scheme_Vector * ) (t_vec ) ) -> els ) [i ] ) ) == (scheme_false ) ) ) 
      info -> max_used [i + t_min_t ] = ip ; 
  }
}

static Scheme_Object * sfs_branch (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_Branch_Rec * b ; 
  Scheme_Object * t , * tb , * fb , * vec ; 
  int ip , min_t , max_t ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(tb, 1), PUSH(vec, 2), PUSH(b, 3), PUSH(info, 4), PUSH(fb, 5), PUSH(t, 6)));
# define XfOrM81_COUNT (7)
# define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 
  t = NULLED_OUT ; 
  tb = NULLED_OUT ; 
  fb = NULLED_OUT ; 
  vec = NULLED_OUT ; 

# 599 "bc/src/sfs.c"
  b = (Scheme_Branch_Rec * ) o ; 
  FUNCCALL(SETUP_XfOrM81(_), sfs_start_sequence (info , 1 , 0 ) )
  ; 

  t = FUNCCALL_AGAIN(sfs_expr (b -> test , info , - 1 ) ); 

  ip = info -> ip ; 
  info -> ip ++ ; 



  min_t = info -> min_touch ; 
  max_t = info -> max_touch ; 

  ; 

  if (! info -> pass ) {
#   define XfOrM86_COUNT (0+XfOrM81_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM81(x)

# 616 "bc/src/sfs.c"
    vec = FUNCCALL(SETUP_XfOrM86(_), scheme_make_vector (5 * 2 , ((void * ) 0 ) ) ); 
    FUNCCALL(SETUP_XfOrM86(_), scheme_sfs_save (info , vec ) ); 
  }

# 618 "bc/src/sfs.c"
  else {
#   define XfOrM85_COUNT (0+XfOrM81_COUNT)
#   define SETUP_XfOrM85(x) SETUP_XfOrM81(x)

# 619 "bc/src/sfs.c"
    vec = FUNCCALL(SETUP_XfOrM85(_), scheme_sfs_next_saved (info ) ); 
  }

  tb = FUNCCALL(SETUP_XfOrM81(_), sfs_one_branch (info , ip , vec , 0 , b -> tbranch ) ); 

  if (! info -> pass ) {
    if ((min_t == - 1 ) 
    || ((info -> min_touch > - 1 ) && (info -> min_touch < min_t ) ) )
      min_t = info -> min_touch ; 
    if (info -> max_touch > max_t )
      max_t = info -> max_touch ; 
    if (info -> max_nontail > ip + 1 )
      info -> max_nontail = ip + 1 ; 
  }

  fb = FUNCCALL(SETUP_XfOrM81(_), sfs_one_branch (info , ip , vec , 1 , b -> fbranch ) ); 

  if (! info -> pass ) {
    if ((min_t == - 1 ) 
    || ((info -> min_touch > - 1 ) && (info -> min_touch < min_t ) ) )
      min_t = info -> min_touch ; 
    if (info -> max_touch > max_t )
      max_t = info -> max_touch ; 
    if (info -> max_nontail > ip + 1 )
      info -> max_nontail = ip + 1 ; 
  }

  if (info -> pass ) {
#   define XfOrM82_COUNT (0+XfOrM81_COUNT)
#   define SETUP_XfOrM82(x) SETUP_XfOrM81(x)
    FUNCCALL(SETUP_XfOrM82(_), sfs_restore_one_branch (info , ip , vec , 0 ) )
    ; 
    FUNCCALL(SETUP_XfOrM82(_), sfs_restore_one_branch (info , ip , vec , 1 ) ); 
  }

  ; 

  info -> min_touch = min_t ; 
  info -> max_touch = max_t ; 

  b -> test = t ; 
  b -> tbranch = tb ; 
  b -> fbranch = fb ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 666 "bc/src/sfs.c"
static Scheme_Object * sfs_let_value (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_Let_Value * lv = (Scheme_Let_Value * ) o ; 
  Scheme_Object * body , * rhs , * clears = scheme_null ; 
  int i , pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(lv, 0), PUSH(clears, 1), PUSH(rhs, 2), PUSH(info, 3), PUSH(body, 4), PUSH(o, 5)));
# define XfOrM87_COUNT (6)
# define SETUP_XfOrM87(x) SETUP(XfOrM87_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  body = NULLED_OUT ; 
  rhs = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM87(_), sfs_start_sequence (info , 2 , 1 ) )
# 672 "bc/src/sfs.c"
  ; 

  rhs = FUNCCALL_AGAIN(sfs_expr (lv -> value , info , - 1 ) ); 

  if (! info -> pass 
  || (info -> ip < info -> max_nontail ) ) {
#   define XfOrM88_COUNT (0+XfOrM87_COUNT)
#   define SETUP_XfOrM88(x) SETUP_XfOrM87(x)

# 678 "bc/src/sfs.c"
    for (i = 0 ; i < lv -> count ; i ++ ) {
#     define XfOrM92_COUNT (0+XfOrM88_COUNT)
#     define SETUP_XfOrM92(x) SETUP_XfOrM88(x)

# 679 "bc/src/sfs.c"
      pos = lv -> position + i ; 
      if (! info -> pass )
        FUNCCALL(SETUP_XfOrM92(_), sfs_used (info , pos ) ); 
      else {
        int spos ; 
#       define XfOrM93_COUNT (0+XfOrM92_COUNT)
#       define SETUP_XfOrM93(x) SETUP_XfOrM92(x)

# 684 "bc/src/sfs.c"
        spos = pos + info -> stackpos ; 
        if ((info -> max_used [spos ] == info -> ip ) 
        && (info -> max_calls [spos ] > info -> ip ) ) {
#         define XfOrM94_COUNT (0+XfOrM93_COUNT)
#         define SETUP_XfOrM94(x) SETUP_XfOrM93(x)

          clears = FUNCCALL(SETUP_XfOrM94(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , clears ) )
          ; 
        }
      }
    }
  }

  body = FUNCCALL(SETUP_XfOrM87(_), sfs_expr (lv -> body , info , - 1 ) ); 

  body = FUNCCALL(SETUP_XfOrM87(_), sfs_add_clears (body , clears , 1 ) ); 

  lv -> value = rhs ; 
  lv -> body = body ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 707 "bc/src/sfs.c"
static Scheme_Object * sfs_let_one (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_Let_One * lo = (Scheme_Let_One * ) o ; 
  Scheme_Object * body , * rhs , * vec ; 
  int pos , save_mnt , ip , et ; 
  int unused = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(lo, 0), PUSH(rhs, 1), PUSH(info, 2), PUSH(vec, 3), PUSH(o, 4), PUSH(body, 5)));
# define XfOrM95_COUNT (6)
# define SETUP_XfOrM95(x) SETUP(XfOrM95_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  body = NULLED_OUT ; 
  rhs = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM95(_), sfs_start_sequence (info , 2 , 1 ) )
# 714 "bc/src/sfs.c"
  ; 
  FUNCCALL_AGAIN(sfs_push (info , 1 , 1 ) )
  ; 
  ip = info -> ip ; 
  pos = info -> stackpos ; 
  save_mnt = info -> max_nontail ; 

  if (! info -> pass ) {
#   define XfOrM102_COUNT (0+XfOrM95_COUNT)
#   define SETUP_XfOrM102(x) SETUP_XfOrM95(x)

# 722 "bc/src/sfs.c"
    if ((& lo -> iso ) -> so . keyex >> 4 )  {

      info -> max_used [pos ] = 0x3FFFFFFe ; 
    }
    vec = FUNCCALL(SETUP_XfOrM102(_), scheme_make_vector (3 , ((void * ) 0 ) ) ); 
    FUNCCALL(SETUP_XfOrM102(_), scheme_sfs_save (info , vec ) ); 
  }

# 728 "bc/src/sfs.c"
  else {
#   define XfOrM101_COUNT (0+XfOrM95_COUNT)
#   define SETUP_XfOrM101(x) SETUP_XfOrM95(x)

# 729 "bc/src/sfs.c"
    vec = FUNCCALL(SETUP_XfOrM101(_), scheme_sfs_next_saved (info ) ); 
    if ((((Scheme_Vector * ) (vec ) ) -> size ) != 3 )
      FUNCCALL(SETUP_XfOrM101(_), scheme_signal_error ("internal error: bad vector length" ) ); 
    info -> max_used [pos ] = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [0 ] ) ) >> 1 ) ; 
    info -> max_calls [pos ] = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [1 ] ) ) >> 1 ) ; 
    info -> max_nontail = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [2 ] ) ) >> 1 ) ; 
  }

  rhs = FUNCCALL(SETUP_XfOrM95(_), sfs_expr (lo -> value , info , - 1 ) ); 
  body = FUNCCALL(SETUP_XfOrM95(_), sfs_expr (lo -> body , info , - 1 ) ); 






  if (! info -> pass ) {
    int n ; 
    info -> max_calls [pos ] = info -> max_nontail ; 
    n = info -> max_used [pos ] ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
    n = info -> max_calls [pos ] ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (info -> max_nontail ) ) ) << 1 ) | 0x1 ) ) ; 
  }

# 753 "bc/src/sfs.c"
  else {
#   define XfOrM96_COUNT (0+XfOrM95_COUNT)
#   define SETUP_XfOrM96(x) SETUP_XfOrM95(x)

# 754 "bc/src/sfs.c"
    info -> max_nontail = save_mnt ; 

    if ((info -> max_used [pos ] <= ip ) 
    || (info -> max_used [pos ] == 0x3FFFFFFe ) ) {
#     define XfOrM97_COUNT (0+XfOrM96_COUNT)
#     define SETUP_XfOrM97(x) SETUP_XfOrM96(x)




      if (FUNCCALL(SETUP_XfOrM97(_), scheme_omittable_expr (rhs , 1 , - 1 , 0x1 , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
        rhs = scheme_false ; 
      }

# 766 "bc/src/sfs.c"
      else if ((ip < info -> max_calls [pos ] ) 
      && (((Scheme_Type ) (((((intptr_t ) (rhs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rhs ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
      || ((Scheme_Type ) (((((intptr_t ) (rhs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rhs ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) ) ) {




        Scheme_Sequence * s ; 
        BLOCK_SETUP((PUSH(s, 0+XfOrM97_COUNT)));
#       define XfOrM98_COUNT (1+XfOrM97_COUNT)
#       define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
        s = NULLED_OUT ; 

# 774 "bc/src/sfs.c"
        s = FUNCCALL(SETUP_XfOrM98(_), scheme_malloc_sequence (2 ) ); 
        s -> so . type = scheme_sequence_type ; 
        s -> count = 2 ; 
        s -> array [0 ] = rhs ; 
        s -> array [1 ] = body ; 
        body = (Scheme_Object * ) s ; 
        rhs = scheme_false ; 
      }
      unused = 1 ; 
    }
  }

  lo -> value = rhs ; 
  lo -> body = body ; 

  et = FUNCCALL(SETUP_XfOrM95(_), scheme_get_eval_type (lo -> value ) ); 
  (& lo -> iso ) -> so . keyex = (et 
  | (unused ? 0 : ((& lo -> iso ) -> so . keyex & (0x3 << 4 ) ) ) 
  | (unused ? 0x8 : 0 ) ) ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 797 "bc/src/sfs.c"
static Scheme_Object * sfs_let_void (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_Let_Void * lv = (Scheme_Let_Void * ) o ; 
  Scheme_Object * body ; 
  int i , pos , save_mnt ; 
  Scheme_Object * vec ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(lv, 0), PUSH(info, 1), PUSH(vec, 2), PUSH(o, 3), PUSH(body, 4)));
# define XfOrM104_COUNT (5)
# define SETUP_XfOrM104(x) SETUP(XfOrM104_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  body = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM104(_), sfs_push (info , lv -> count , 1 ) )
# 804 "bc/src/sfs.c"
  ; 
  pos = info -> stackpos ; 
  save_mnt = info -> max_nontail ; 

  if (! info -> pass ) {
#   define XfOrM112_COUNT (0+XfOrM104_COUNT)
#   define SETUP_XfOrM112(x) SETUP_XfOrM104(x)

# 809 "bc/src/sfs.c"
    vec = FUNCCALL(SETUP_XfOrM112(_), scheme_make_vector (lv -> count + 1 , ((void * ) 0 ) ) ); 
    FUNCCALL(SETUP_XfOrM112(_), scheme_sfs_save (info , vec ) ); 
  }

# 811 "bc/src/sfs.c"
  else {
#   define XfOrM109_COUNT (0+XfOrM104_COUNT)
#   define SETUP_XfOrM109(x) SETUP_XfOrM104(x)

# 812 "bc/src/sfs.c"
    vec = FUNCCALL(SETUP_XfOrM109(_), scheme_sfs_next_saved (info ) ); 
    if (! ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: not a vector" ) ); 
    for (i = 0 ; i < lv -> count ; i ++ ) {
      info -> max_used [pos + i ] = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [i ] ) ) >> 1 ) ; 
      info -> max_calls [pos + i ] = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [lv -> count ] ) ) >> 1 ) ; 
    }
    info -> max_nontail = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [lv -> count ] ) ) >> 1 ) ; 
  }

  body = FUNCCALL(SETUP_XfOrM104(_), sfs_expr (lv -> body , info , - 1 ) ); 






  if (! info -> pass ) {
    int n ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [lv -> count ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (info -> max_nontail ) ) ) << 1 ) | 0x1 ) ) ; 
    for (i = 0 ; i < lv -> count ; i ++ ) {
      n = info -> max_used [pos + i ] ; 
      (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
    }
  }

# 836 "bc/src/sfs.c"
  else {
    info -> max_nontail = save_mnt ; 
  }

  lv -> body = body ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 845 "bc/src/sfs.c"
static Scheme_Object * sfs_letrec (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_Letrec * lr = (Scheme_Letrec * ) o ; 
  Scheme_Object * * procs , * v , * clears = scheme_null ; 
  int i , count ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(lr, 0), PUSH(clears, 1), PUSH(v, 2), PUSH(info, 3), PUSH(procs, 4), PUSH(o, 5)));
# define XfOrM113_COUNT (6)
# define SETUP_XfOrM113(x) SETUP(XfOrM113_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  procs = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 851 "bc/src/sfs.c"
  count = lr -> count ; 
  FUNCCALL(SETUP_XfOrM113(_), sfs_start_sequence (info , count + 1 , 1 ) )
  ; 

  procs = lr -> procs ; 

  for (i = 0 ; i < count ; i ++ ) {
#   define XfOrM118_COUNT (0+XfOrM113_COUNT)
#   define SETUP_XfOrM118(x) SETUP_XfOrM113(x)

# 858 "bc/src/sfs.c"
    v = FUNCCALL(SETUP_XfOrM118(_), sfs_expr (procs [i ] , info , i ) ); 

    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_begin0_sequence_type ) )  {


      int j ; 
      Scheme_Sequence * cseq = (Scheme_Sequence * ) v ; 
      BLOCK_SETUP((PUSH(cseq, 0+XfOrM118_COUNT)));
#     define XfOrM119_COUNT (1+XfOrM118_COUNT)
#     define SETUP_XfOrM119(x) SETUP(XfOrM119_COUNT)

# 865 "bc/src/sfs.c"
      for (j = 1 ; j < cseq -> count ; j ++ ) {
        int pos ; 
#       define XfOrM121_COUNT (0+XfOrM119_COUNT)
#       define SETUP_XfOrM121(x) SETUP_XfOrM119(x)

# 867 "bc/src/sfs.c"
        pos = (((Scheme_Local * ) (cseq -> array [j ] ) ) -> position ) ; 
        clears = FUNCCALL(SETUP_XfOrM121(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , clears ) ); 
      }
      v = cseq -> array [0 ] ; 
    }
    procs [i ] = v ; 
  }

  v = FUNCCALL(SETUP_XfOrM113(_), sfs_expr (lr -> body , info , - 1 ) ); 

  v = FUNCCALL(SETUP_XfOrM113(_), sfs_add_clears (v , clears , 1 ) ); 

  lr -> body = v ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 884 "bc/src/sfs.c"
static Scheme_Object * sfs_wcm (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) o ; 
  Scheme_Object * k , * v , * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(wcm, 0), PUSH(o, 1), PUSH(info, 2), PUSH(v, 3), PUSH(k, 4), PUSH(b, 5)));
# define XfOrM122_COUNT (6)
# define SETUP_XfOrM122(x) SETUP(XfOrM122_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  k = NULLED_OUT ; 
  v = NULLED_OUT ; 
  b = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM122(_), sfs_start_sequence (info , 3 , 1 ) )
# 889 "bc/src/sfs.c"
  ; 

  k = FUNCCALL_AGAIN(sfs_expr (wcm -> key , info , - 1 ) ); 
  v = FUNCCALL_AGAIN(sfs_expr (wcm -> val , info , - 1 ) ); 
  b = FUNCCALL_AGAIN(sfs_expr (wcm -> body , info , - 1 ) ); 

  wcm -> key = k ; 
  wcm -> val = v ; 
  wcm -> body = b ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * 
define_values_sfs (Scheme_Object * data , SFS_Info * info ) 
{
  Scheme_Object * e ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(info, 1), PUSH(data, 2)));
# define XfOrM123_COUNT (3)
# define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  e = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM123(_), sfs_start_sequence (info , 1 , 0 ) )
# 910 "bc/src/sfs.c"
  ; 
  e = FUNCCALL_AGAIN(sfs_expr (((((Scheme_Vector * ) (data ) ) -> els ) [0 ] ) , info , - 1 ) ); 
  ((((Scheme_Vector * ) (data ) ) -> els ) [0 ] ) = e ; 
  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 916 "bc/src/sfs.c"
static Scheme_Object * 
inline_variant_sfs (Scheme_Object * data , SFS_Info * info ) 
{
  Scheme_Object * e ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(info, 1), PUSH(data, 2)));
# define XfOrM124_COUNT (3)
# define SETUP_XfOrM124(x) SETUP(XfOrM124_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  e = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM124(_), sfs_start_sequence (info , 1 , 0 ) )
# 920 "bc/src/sfs.c"
  ; 
  e = FUNCCALL_AGAIN(sfs_expr ((((Scheme_Vector * ) (data ) ) -> els ) [0 ] , info , - 1 ) ); 
  (((Scheme_Vector * ) (data ) ) -> els ) [0 ] = e ; 

  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 927 "bc/src/sfs.c"
static Scheme_Object * 
set_sfs (Scheme_Object * data , SFS_Info * info ) 
{
  Scheme_Set_Bang * sb = (Scheme_Set_Bang * ) data ; 
  Scheme_Object * var , * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(var, 0), PUSH(val, 1), PUSH(info, 2), PUSH(sb, 3)));
# define XfOrM125_COUNT (4)
# define SETUP_XfOrM125(x) SETUP(XfOrM125_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  var = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 933 "bc/src/sfs.c"
  var = sb -> var ; 
  val = sb -> val ; 
  FUNCCALL(SETUP_XfOrM125(_), sfs_start_sequence (info , 2 , 0 ) )
  ; 

  val = FUNCCALL_AGAIN(sfs_expr (val , info , - 1 ) ); 
  var = FUNCCALL_AGAIN(sfs_expr (var , info , - 1 ) ); 

  sb -> var = var ; 
  sb -> val = val ; 

  RET_VALUE_START ((Scheme_Object * ) sb ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 947 "bc/src/sfs.c"
static Scheme_Object * 
ref_sfs (Scheme_Object * data , SFS_Info * info ) 
{
  Scheme_Object * a_naya ; 
  Scheme_Object * b_naya ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(b_naya, 0), PUSH(a_naya, 1), PUSH(info, 2), PUSH(data, 3)));
# define XfOrM126_COUNT (4)
# define SETUP_XfOrM126(x) SETUP(XfOrM126_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a_naya = NULLED_OUT ; 
  b_naya = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM126(_), sfs_start_sequence (info , 1 , 0 ) )
# 953 "bc/src/sfs.c"
  ; 
  a_naya = FUNCCALL_AGAIN(sfs_expr ((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) , info , - 1 ) ); 
  b_naya = FUNCCALL_AGAIN(sfs_expr ((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) , info , - 1 ) ); 
  (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) = a_naya ; 
  (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) = b_naya ; 

  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 962 "bc/src/sfs.c"
static Scheme_Object * 
apply_values_sfs (Scheme_Object * data , SFS_Info * info ) 
{
  Scheme_Object * f , * e ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(info, 1), PUSH(data, 2), PUSH(f, 3)));
# define XfOrM127_COUNT (4)
# define SETUP_XfOrM127(x) SETUP(XfOrM127_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  f = NULLED_OUT ; 
  e = NULLED_OUT ; 

# 967 "bc/src/sfs.c"
  f = (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) ; 
  e = (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) ; 
  FUNCCALL(SETUP_XfOrM127(_), sfs_start_sequence (info , 2 , 0 ) )
  ; 

  f = FUNCCALL_AGAIN(sfs_expr (f , info , - 1 ) ); 
  e = FUNCCALL_AGAIN(sfs_expr (e , info , - 1 ) ); 

  (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) = f ; 
  (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) = e ; 

  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 981 "bc/src/sfs.c"
static Scheme_Object * with_immed_mark_sfs (Scheme_Object * o , SFS_Info * info ) 
{
  Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) o ; 
  Scheme_Object * k , * v , * b , * vec ; 
  int pos , save_mnt ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(info, 1), PUSH(vec, 2), PUSH(k, 3), PUSH(o, 4), PUSH(wcm, 5), PUSH(v, 6)));
# define XfOrM128_COUNT (7)
# define SETUP_XfOrM128(x) SETUP(XfOrM128_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  k = NULLED_OUT ; 
  v = NULLED_OUT ; 
  b = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM128(_), sfs_start_sequence (info , 3 , 1 ) )
# 987 "bc/src/sfs.c"
  ; 

  k = FUNCCALL_AGAIN(sfs_expr (wcm -> key , info , - 1 ) ); 
  v = FUNCCALL_AGAIN(sfs_expr (wcm -> val , info , - 1 ) ); 
  FUNCCALL_AGAIN(sfs_push (info , 1 , 1 ) )
  ; 

  pos = info -> stackpos ; 
  save_mnt = info -> max_nontail ; 

  if (! info -> pass ) {
#   define XfOrM132_COUNT (0+XfOrM128_COUNT)
#   define SETUP_XfOrM132(x) SETUP_XfOrM128(x)

# 998 "bc/src/sfs.c"
    vec = FUNCCALL(SETUP_XfOrM132(_), scheme_make_vector (3 , ((void * ) 0 ) ) ); 
    FUNCCALL(SETUP_XfOrM132(_), scheme_sfs_save (info , vec ) ); 
  }

# 1000 "bc/src/sfs.c"
  else {
#   define XfOrM131_COUNT (0+XfOrM128_COUNT)
#   define SETUP_XfOrM131(x) SETUP_XfOrM128(x)

# 1001 "bc/src/sfs.c"
    vec = FUNCCALL(SETUP_XfOrM131(_), scheme_sfs_next_saved (info ) ); 
    if ((((Scheme_Vector * ) (vec ) ) -> size ) != 3 )
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: bad vector length" ) ); 
    info -> max_used [pos ] = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [0 ] ) ) >> 1 ) ; 
    info -> max_calls [pos ] = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [1 ] ) ) >> 1 ) ; 
    info -> max_nontail = (((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> els ) [2 ] ) ) >> 1 ) ; 
  }

  b = FUNCCALL(SETUP_XfOrM128(_), sfs_expr (wcm -> body , info , - 1 ) ); 

  wcm -> key = k ; 
  wcm -> val = v ; 
  wcm -> body = b ; 






  if (! info -> pass ) {
    int n ; 
    info -> max_calls [pos ] = info -> max_nontail ; 
    n = info -> max_used [pos ] ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
    n = info -> max_calls [pos ] ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (info -> max_nontail ) ) ) << 1 ) | 0x1 ) ) ; 
  }

# 1028 "bc/src/sfs.c"
  else {
    info -> max_nontail = save_mnt ; 
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1035 "bc/src/sfs.c"
static Scheme_Object * 
case_lambda_sfs (Scheme_Object * expr , SFS_Info * info ) 
{
  Scheme_Case_Lambda * seq = (Scheme_Case_Lambda * ) expr ; 
  Scheme_Object * le , * clears = scheme_null ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(clears, 0), PUSH(le, 1), PUSH(info, 2), PUSH(seq, 3), PUSH(expr, 4)));
# define XfOrM133_COUNT (5)
# define SETUP_XfOrM133(x) SETUP(XfOrM133_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  le = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM133(_), sfs_start_sequence (info , seq -> count , 0 ) )
# 1042 "bc/src/sfs.c"
  ; 

  for (i = 0 ; i < seq -> count ; i ++ ) {
#   define XfOrM140_COUNT (0+XfOrM133_COUNT)
#   define SETUP_XfOrM140(x) SETUP_XfOrM133(x)

# 1045 "bc/src/sfs.c"
    le = seq -> array [i ] ; 
    le = FUNCCALL(SETUP_XfOrM140(_), sfs_expr (le , info , - 1 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (le ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (le ) ) -> type ) ) == (Scheme_Type ) (scheme_begin0_sequence_type ) )  {


      int j ; 
      Scheme_Sequence * cseq = (Scheme_Sequence * ) le ; 
      BLOCK_SETUP((PUSH(cseq, 0+XfOrM140_COUNT)));
#     define XfOrM142_COUNT (1+XfOrM140_COUNT)
#     define SETUP_XfOrM142(x) SETUP(XfOrM142_COUNT)

# 1052 "bc/src/sfs.c"
      if (! cseq -> count )
        FUNCCALL_EMPTY(scheme_signal_error ("internal error: empty sequence" ) ); 
      for (j = 1 ; j < cseq -> count ; j ++ ) {
        int pos ; 
#       define XfOrM144_COUNT (0+XfOrM142_COUNT)
#       define SETUP_XfOrM144(x) SETUP_XfOrM142(x)

# 1056 "bc/src/sfs.c"
        pos = (((Scheme_Local * ) (cseq -> array [j ] ) ) -> position ) ; 
        clears = FUNCCALL(SETUP_XfOrM144(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , clears ) ); 
      }
      le = cseq -> array [0 ] ; 
    }
    if (! ((Scheme_Type ) (((((intptr_t ) (le ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (le ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) 
    && ! ((Scheme_Type ) (((((intptr_t ) (le ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (le ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) ) {
#     define XfOrM141_COUNT (0+XfOrM140_COUNT)
#     define SETUP_XfOrM141(x) SETUP_XfOrM140(x)
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: not a lambda for case-lambda: %d" , ((((intptr_t ) (le ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (le ) ) -> type ) ) )
# 1064 "bc/src/sfs.c"
      ; 
    }
    seq -> array [i ] = le ; 
  }

  if (! ((clears ) == (scheme_null ) ) ) {
#   define XfOrM134_COUNT (0+XfOrM133_COUNT)
#   define SETUP_XfOrM134(x) SETUP_XfOrM133(x)

# 1070 "bc/src/sfs.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(sfs_add_clears (expr , clears , 0 ) )) RET_VALUE_EMPTY_END ; 
  }

# 1071 "bc/src/sfs.c"
  else 
  RET_VALUE_START (expr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1075 "bc/src/sfs.c"
static Scheme_Object * bangboxenv_sfs (Scheme_Object * data , SFS_Info * info ) 
{
  Scheme_Object * e ; 
  int spos , drop ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(data, 1)));
# define XfOrM145_COUNT (2)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  e = NULLED_OUT ; 

# 1080 "bc/src/sfs.c"
  spos = (((intptr_t ) ((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) ) ) >> 1 ) + info -> stackpos ; 
  if (info -> pass 
  && (info -> max_used [spos ] < info -> ip ) )


  drop = 1 ; 
  else 
  drop = 0 ; 

  e = FUNCCALL(SETUP_XfOrM145(_), sfs_expr ((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) , info , - 1 ) ); 

  if (drop )
    RET_VALUE_START (e ) RET_VALUE_END ; 
  else {
    (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) = e ; 
    RET_VALUE_START (data ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1099 "bc/src/sfs.c"
static Scheme_Object * flatten_begin0 (Scheme_Object * o ) 
{


  Scheme_Sequence * s = (Scheme_Sequence * ) o , * s2 ; 
  int i , extra = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s2, 0), PUSH(s, 1), PUSH(o, 2)));
# define XfOrM147_COUNT (3)
# define SETUP_XfOrM147(x) SETUP(XfOrM147_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s2 = NULLED_OUT ; 

# 1106 "bc/src/sfs.c"
  o = s -> array [0 ] ; 

  while (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_begin0_sequence_type ) ) ) {
    s2 = (Scheme_Sequence * ) o ; 
    extra += s2 -> count - 1 ; 
    o = s2 -> array [0 ] ; 
  }

  if (extra ) {
#   define XfOrM148_COUNT (0+XfOrM147_COUNT)
#   define SETUP_XfOrM148(x) SETUP_XfOrM147(x)

# 1115 "bc/src/sfs.c"
    s2 = FUNCCALL(SETUP_XfOrM148(_), scheme_malloc_sequence (s -> count + extra ) ); 
    s2 -> so . type = scheme_begin0_sequence_type ; 
    s2 -> count = s -> count + extra ; 

    extra = s2 -> count - 1 ; 
    o = (Scheme_Object * ) s ; 
    while (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_begin0_sequence_type ) ) ) {
      s = (Scheme_Sequence * ) o ; 
      for (i = s -> count - 1 ; i ; i -- ) {
        s2 -> array [extra -- ] = s -> array [i ] ; 
      }
      o = s -> array [i ] ; 
    }
    s2 -> array [extra -- ] = o ; 

    if (extra != - 1 )
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: flatten begin0 failed" ) )
# 1130 "bc/src/sfs.c"
    ; 

    RET_VALUE_START ((Scheme_Object * ) s2 ) RET_VALUE_END ; 
  }

# 1133 "bc/src/sfs.c"
  else 
  RET_VALUE_START ((Scheme_Object * ) s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1137 "bc/src/sfs.c"
static Scheme_Object * 
begin0_sfs (Scheme_Object * obj , SFS_Info * info ) 
{
  int i , cnt ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(obj, 1)));
# define XfOrM157_COUNT (2)
# define SETUP_XfOrM157(x) SETUP(XfOrM157_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1142 "bc/src/sfs.c"
  cnt = ((Scheme_Sequence * ) obj ) -> count ; 
  FUNCCALL(SETUP_XfOrM157(_), sfs_start_sequence (info , cnt , 0 ) )
  ; 

  for (i = 0 ; i < cnt ; i ++ ) {
    Scheme_Object * le ; 
    BLOCK_SETUP((PUSH(le, 0+XfOrM157_COUNT)));
#   define XfOrM159_COUNT (1+XfOrM157_COUNT)
#   define SETUP_XfOrM159(x) SETUP(XfOrM159_COUNT)
    le = NULLED_OUT ; 

# 1148 "bc/src/sfs.c"
    le = FUNCCALL(SETUP_XfOrM159(_), sfs_expr (((Scheme_Sequence * ) obj ) -> array [i ] , info , - 1 ) ); 
    ((Scheme_Sequence * ) obj ) -> array [i ] = le ; 
  }

  if (info -> pass )
    obj = FUNCCALL(SETUP_XfOrM157(_), flatten_begin0 (obj ) ); 

  RET_VALUE_START (obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * sfs_lambda (Scheme_Object * expr , SFS_Info * info , int self_pos ) 
{
  Scheme_Lambda * data = (Scheme_Lambda * ) expr ; 
  Scheme_Object * code ; 
  int i , size , has_tl = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(code, 0), PUSH(info, 1), PUSH(data, 2), PUSH(expr, 3)));
# define XfOrM160_COUNT (4)
# define SETUP_XfOrM160(x) SETUP(XfOrM160_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  code = NULLED_OUT ; 

# 1168 "bc/src/sfs.c"
  size = data -> closure_size ; 
  if (size ) {
    if (info -> stackpos + data -> closure_map [size - 1 ] == info -> tlpos ) {
      has_tl = 1 ; 
      -- size ; 
    }
  }

  if (! info -> pass ) {
#   define XfOrM185_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM185(x) SETUP_XfOrM160(x)

# 1177 "bc/src/sfs.c"
    for (i = size ; i -- ; ) {
#     define XfOrM187_COUNT (0+XfOrM185_COUNT)
#     define SETUP_XfOrM187(x) SETUP_XfOrM185(x)
      FUNCCALL(SETUP_XfOrM187(_), sfs_used (info , data -> closure_map [i ] ) )
# 1178 "bc/src/sfs.c"
      ; 
    }
  }

# 1180 "bc/src/sfs.c"
  else {


    Scheme_Object * clears = scheme_null ; 
    BLOCK_SETUP((PUSH(clears, 0+XfOrM160_COUNT)));
#   define XfOrM177_COUNT (1+XfOrM160_COUNT)
#   define SETUP_XfOrM177(x) SETUP(XfOrM177_COUNT)

# 1185 "bc/src/sfs.c"
    if (info -> ip < info -> max_nontail ) {
      int pos , ip ; 
#     define XfOrM178_COUNT (0+XfOrM177_COUNT)
#     define SETUP_XfOrM178(x) SETUP_XfOrM177(x)

# 1187 "bc/src/sfs.c"
      for (i = size ; i -- ; ) {
#       define XfOrM182_COUNT (0+XfOrM178_COUNT)
#       define SETUP_XfOrM182(x) SETUP_XfOrM178(x)

# 1188 "bc/src/sfs.c"
        pos = data -> closure_map [i ] + info -> stackpos ; 
        if (pos < info -> depth ) {
#         define XfOrM183_COUNT (0+XfOrM182_COUNT)
#         define SETUP_XfOrM183(x) SETUP_XfOrM182(x)

# 1190 "bc/src/sfs.c"
          ip = info -> max_used [pos ] ; 
          if ((ip == info -> ip ) 
          && (ip < info -> max_calls [pos ] ) ) {
#           define XfOrM184_COUNT (0+XfOrM183_COUNT)
#           define SETUP_XfOrM184(x) SETUP_XfOrM183(x)

# 1193 "bc/src/sfs.c"
            pos -= info -> stackpos ; 
            clears = FUNCCALL(SETUP_XfOrM184(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , clears ) )
            ; 
          }
        }
      }
    }

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(sfs_add_clears (expr , clears , 0 ) )) RET_VALUE_EMPTY_END ; 
  }

  if (! ((& (data ) -> iso ) -> so . keyex & 256 ) ) {
#   define XfOrM161_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM161(x) SETUP_XfOrM160(x)

# 1205 "bc/src/sfs.c"
    (& (data ) -> iso ) -> so . keyex |= 256 ; 
    info = FUNCCALL(SETUP_XfOrM161(_), new_sfs_info (data -> max_let_depth ) ); 
    FUNCCALL_AGAIN(sfs_push (info , data -> closure_size + data -> num_params , 1 ) ); 

    if (has_tl )
      info -> tlpos = info -> stackpos + data -> closure_size - 1 ; 

    if (self_pos >= 0 ) {
      for (i = size ; i -- ; ) {
        if (data -> closure_map [i ] == self_pos ) {
          info -> selfpos = info -> stackpos + i ; 
          info -> selfstart = info -> stackpos ; 
          info -> selflen = data -> closure_size ; 
          break ; 
        }
      }
    }


    if ((& (data ) -> iso ) -> so . keyex & 2 ) {
      int delta , size , ct , j , pos ; 
      mzshort * map ; 
#     define XfOrM167_COUNT (0+XfOrM161_COUNT)
#     define SETUP_XfOrM167(x) SETUP_XfOrM161(x)
      map = NULLED_OUT ; 

# 1227 "bc/src/sfs.c"
      delta = data -> closure_size ; 
      size = data -> closure_size + data -> num_params ; 
      map = data -> closure_map ; 
      for (j = 0 ; j < size ; j ++ ) {
#       define XfOrM170_COUNT (0+XfOrM167_COUNT)
#       define SETUP_XfOrM170(x) SETUP_XfOrM167(x)

# 1231 "bc/src/sfs.c"
        ct = (scheme_boxmap_get (map , j , delta ) ) ; 
        if (ct > 1 ) {
          if (j < data -> num_params )
            pos = info -> stackpos + delta + j ; 
          else 
          pos = info -> stackpos + (j - data -> num_params ) ; 
          info -> max_used [pos ] = 0x3FFFFFFe ; 
        }
      }
    }

    code = FUNCCALL(SETUP_XfOrM161(_), sfs_passes (data -> body , info ) ); 






    if (info -> max_nontail ) {
      int i , pos , cnt ; 
      Scheme_Object * clears = scheme_null ; 
      BLOCK_SETUP((PUSH(clears, 0+XfOrM161_COUNT)));
#     define XfOrM162_COUNT (1+XfOrM161_COUNT)
#     define SETUP_XfOrM162(x) SETUP(XfOrM162_COUNT)

# 1253 "bc/src/sfs.c"
      cnt = data -> num_params ; 
      for (i = 0 ; i < cnt ; i ++ ) {
#       define XfOrM165_COUNT (0+XfOrM162_COUNT)
#       define SETUP_XfOrM165(x) SETUP_XfOrM162(x)

# 1255 "bc/src/sfs.c"
        pos = data -> max_let_depth - (cnt - i ) ; 
        if (! info -> max_used [pos ] ) {
#         define XfOrM166_COUNT (0+XfOrM165_COUNT)
#         define SETUP_XfOrM166(x) SETUP_XfOrM165(x)

# 1257 "bc/src/sfs.c"
          pos = i + data -> closure_size ; 
          clears = FUNCCALL(SETUP_XfOrM166(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , clears ) )
          ; 
        }
      }

      if ((Scheme_Type ) (((((intptr_t ) (clears ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clears ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
        code = FUNCCALL(SETUP_XfOrM162(_), sfs_add_clears (code , clears , 1 ) ); 

      if ((& (data ) -> iso ) -> so . keyex & 1 )
        (& (data ) -> iso ) -> so . keyex |= 8 ; 
    }

    data -> body = code ; 
  }

  RET_VALUE_START (expr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * sfs_expr_k (void ) 
{
  /* No conversion */

# 1282 "bc/src/sfs.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * e = (Scheme_Object * ) p -> ku . k . p1 ; 
  SFS_Info * info = (SFS_Info * ) p -> ku . k . p2 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 

  return sfs_expr (e , info , p -> ku . k . i1 ) ; 
}

static Scheme_Object * sfs_expr (Scheme_Object * expr , SFS_Info * info , int closure_self_pos ) 

{
  Scheme_Type type = ((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ; 
  int seqn , stackpos , tp ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(expr, 1)));
# define XfOrM191_COUNT (2)
# define SETUP_XfOrM191(x) SETUP(XfOrM191_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1299 "bc/src/sfs.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM206_COUNT (0+XfOrM191_COUNT)
#   define SETUP_XfOrM206(x) SETUP_XfOrM191(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 1301 "bc/src/sfs.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM207_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM207(x) SETUP_XfOrM206(x)

# 1304 "bc/src/sfs.c"
      p -> ku . k . p1 = (void * ) expr ; 
      p -> ku . k . p2 = (void * ) info ; 
      p -> ku . k . i1 = closure_self_pos ; 

      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (sfs_expr_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }



  seqn = info -> seqn ; 
  stackpos = info -> stackpos ; 
  tp = info -> tail_pos ; 
  if (seqn ) {
    info -> seqn = 0 ; 
    info -> tail_pos = 0 ; 
  }
  info -> ip ++ ; 
  info -> abs_ip ++ ; 

  switch (type ) {
#   define XfOrM193_COUNT (0+XfOrM191_COUNT)
#   define SETUP_XfOrM193(x) SETUP_XfOrM191(x)

# 1325 "bc/src/sfs.c"
    case scheme_local_type : 
    case scheme_local_unbox_type : 
    if (! info -> pass )
      FUNCCALL(SETUP_XfOrM193(_), sfs_used (info , (((Scheme_Local * ) (expr ) ) -> position ) ) ); 
    else if (! ((((& ((Scheme_Local * ) (expr ) ) -> iso ) -> so . keyex & ~ 0x2000 ) > 2 ) ? (((& ((Scheme_Local * ) (expr ) ) -> iso ) -> so . keyex & ~ 0x2000 ) - 2 ) : 0 ) ) {
      int pos , at_ip ; 
#     define XfOrM200_COUNT (0+XfOrM193_COUNT)
#     define SETUP_XfOrM200(x) SETUP_XfOrM193(x)

# 1331 "bc/src/sfs.c"
      pos = (((Scheme_Local * ) (expr ) ) -> position ) ; 
      at_ip = info -> max_used [info -> stackpos + pos ] ; 
      if (at_ip < info -> max_calls [info -> stackpos + pos ] ) {
#       define XfOrM202_COUNT (0+XfOrM200_COUNT)
#       define SETUP_XfOrM202(x) SETUP_XfOrM200(x)

# 1334 "bc/src/sfs.c"
        if (at_ip == info -> ip ) {
#         define XfOrM204_COUNT (0+XfOrM202_COUNT)
#         define SETUP_XfOrM204(x) SETUP_XfOrM202(x)

# 1336 "bc/src/sfs.c"
          expr = FUNCCALL(SETUP_XfOrM204(_), scheme_make_local (type , pos , 1 ) ); 
        }

# 1337 "bc/src/sfs.c"
        else {
#         define XfOrM203_COUNT (0+XfOrM202_COUNT)
#         define SETUP_XfOrM203(x) SETUP_XfOrM202(x)

# 1339 "bc/src/sfs.c"
          expr = FUNCCALL(SETUP_XfOrM203(_), scheme_make_local (type , pos , 2 ) ); 
        }
      }

# 1341 "bc/src/sfs.c"
      else {
      }
    }



    break ; 
    case scheme_application_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_application (expr , info ) ); 
    break ; 
    case scheme_application2_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_application2 (expr , info ) ); 
    break ; 
    case scheme_application3_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_application3 (expr , info ) ); 
    break ; 
    case scheme_sequence_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_sequence (expr , info , closure_self_pos != - 2 ) ); 
    break ; 
    case scheme_branch_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_branch (expr , info ) ); 
    break ; 
    case scheme_with_cont_mark_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_wcm (expr , info ) ); 
    break ; 
    case scheme_lambda_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_lambda (expr , info , closure_self_pos ) ); 
    break ; 
    case scheme_let_value_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_let_value (expr , info ) ); 
    break ; 
    case scheme_let_void_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_let_void (expr , info ) ); 
    break ; 
    case scheme_letrec_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_letrec (expr , info ) ); 
    break ; 
    case scheme_let_one_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), sfs_let_one (expr , info ) ); 
    break ; 
    case scheme_closure_type : 
    {
      Scheme_Closure * c = (Scheme_Closure * ) expr ; 
      BLOCK_SETUP((PUSH(c, 0+XfOrM193_COUNT)));
#     define XfOrM196_COUNT (1+XfOrM193_COUNT)
#     define SETUP_XfOrM196(x) SETUP(XfOrM196_COUNT)

# 1384 "bc/src/sfs.c"
      if (! (c -> code -> closure_size ) ) {
        Scheme_Object * code ; 
        BLOCK_SETUP((PUSH(code, 0+XfOrM196_COUNT)));
#       define XfOrM197_COUNT (1+XfOrM196_COUNT)
#       define SETUP_XfOrM197(x) SETUP(XfOrM197_COUNT)
        code = NULLED_OUT ; 

# 1386 "bc/src/sfs.c"
        code = FUNCCALL(SETUP_XfOrM197(_), sfs_lambda ((Scheme_Object * ) c -> code , info , closure_self_pos ) ); 
        if ((Scheme_Type ) (((((intptr_t ) (code ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (code ) ) -> type ) ) == (Scheme_Type ) (scheme_begin0_sequence_type ) )  {
          Scheme_Sequence * seq = (Scheme_Sequence * ) code ; 
          c -> code = (Scheme_Lambda * ) seq -> array [0 ] ; 
          seq -> array [0 ] = expr ; 
          expr = code ; 
        }

# 1392 "bc/src/sfs.c"
        else {
          c -> code = (Scheme_Lambda * ) code ; 
        }
      }
    }
    break ; 
    case scheme_toplevel_type : 
    {
      int c = (((Scheme_Toplevel * ) (expr ) ) -> u . depth ) ; 
#     define XfOrM195_COUNT (0+XfOrM193_COUNT)
#     define SETUP_XfOrM195(x) SETUP_XfOrM193(x)

# 1401 "bc/src/sfs.c"
      if (info -> stackpos + c != info -> tlpos )
        FUNCCALL_EMPTY(scheme_signal_error ("toplevel access not at expected place" ) ); 
    }
    break ; 
    case scheme_static_toplevel_type : 
    break ; 
    case scheme_case_closure_type : 
    {
    }

    break ; 
    case scheme_define_values_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), define_values_sfs (expr , info ) ); 
    break ; 
    case scheme_set_bang_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), set_sfs (expr , info ) ); 
    break ; 
    case scheme_boxenv_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), bangboxenv_sfs (expr , info ) ); 
    break ; 
    case scheme_begin0_sequence_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), begin0_sfs (expr , info ) ); 
    break ; 
    case scheme_varref_form_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), ref_sfs (expr , info ) ); 
    break ; 
    case scheme_apply_values_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), apply_values_sfs (expr , info ) ); 
    break ; 
    case scheme_with_immed_mark_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), with_immed_mark_sfs (expr , info ) ); 
    break ; 
    case scheme_case_lambda_sequence_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), case_lambda_sfs (expr , info ) ); 
    break ; 
    case scheme_inline_variant_type : 
    expr = FUNCCALL(SETUP_XfOrM193(_), inline_variant_sfs (expr , info ) ); 
    break ; 
    default : 
    break ; 
  }

  info -> ip ++ ; 

  if (seqn ) {
#   define XfOrM192_COUNT (0+XfOrM191_COUNT)
#   define SETUP_XfOrM192(x) SETUP_XfOrM191(x)

# 1446 "bc/src/sfs.c"
    info -> seqn = seqn - 1 ; 
    (memset (info -> max_used + info -> stackpos , 0 , (stackpos - info -> stackpos ) * sizeof (int ) ) ) ; 
    (memset (info -> max_calls + info -> stackpos , 0 , (stackpos - info -> stackpos ) * sizeof (int ) ) ) ; 
    info -> stackpos = stackpos ; 
    info -> tail_pos = tp ; 
  }

  RET_VALUE_START (expr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "bc/src/mzmark_sfs.inc"
static int mark_sfs_info_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_sfs_info_MARK (void * p , struct NewGC * gc ) {

  SFS_Info * i = (SFS_Info * ) p ; 

  GC_mark2 (& (i -> max_used ) , gc ) ; 
  GC_mark2 (& (i -> max_calls ) , gc ) ; 
  GC_mark2 (& (i -> saved ) , gc ) ; 


  return 0 ; 
}






static int mark_sfs_info_FIXUP (void * p , struct NewGC * gc ) {

  SFS_Info * i = (SFS_Info * ) p ; 

  GC_fixup2 (& (i -> max_used ) , gc ) ; 
  GC_fixup2 (& (i -> max_calls ) , gc ) ; 
  GC_fixup2 (& (i -> saved ) , gc ) ; 


  return 0 ; 
}

# 1466 "bc/src/sfs.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_sfs_info , mark_sfs_info_SIZE , mark_sfs_info_MARK , mark_sfs_info_FIXUP , 1 , 0 ) ; 
}
