#include "precomp.h"

# 11 "bc/src/sort.c"
enum {
  sort_major_unknown , 
  sort_major_boolean , 
  sort_major_char , 
  sort_major_real , 
  sort_major_symbol , 
  sort_major_keyword , 
  sort_major_string , 
  sort_major_bytes , 
  sort_major_null , 
  sort_major_void , 
  sort_major_eof , }
; 

static int sort_major (Scheme_Object * v ) 
{
  /* No conversion */

# 27 "bc/src/sort.c"
  if (((v ) == (scheme_true ) ) || (((v ) ) == (scheme_false ) ) )
    return sort_major_boolean ; 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) 
    return sort_major_char ; 
  else if ((((intptr_t ) (v ) ) & 0x1 ) || ((((v ) -> type ) >= scheme_bignum_type ) && (((v ) -> type ) < scheme_complex_type ) ) ) 
    return sort_major_real ; 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    return sort_major_symbol ; 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) 
    return sort_major_keyword ; 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
    return sort_major_string ; 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
    return sort_major_bytes ; 
  else if ((v ) == (scheme_null ) ) 
    return sort_major_null ; 
  else if (((v ) ) == (scheme_void ) ) 
    return sort_major_void ; 
  else if (((v ) ) == (scheme_eof ) ) 
    return sort_major_eof ; 
  else 
  return sort_major_unknown ; 
}

static int compare_sym_likes (Scheme_Object * a , Scheme_Object * b ) 
{
  /* No conversion */

# 53 "bc/src/sort.c"
  intptr_t l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (a ) ) ) -> len ) , i ; 

  if ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (b ) ) ) -> len ) < l )
    l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (b ) ) ) -> len ) ; 

  for (i = 0 ; i < l ; i ++ ) {
    if ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (a ) ) ) -> s ) [i ] != (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (b ) ) ) -> s ) [i ] )
      return (((unsigned char * ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (a ) ) ) -> s ) ) [i ] - ((unsigned char * ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (b ) ) ) -> s ) ) [i ] ) ; 
  }

  return (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (a ) ) ) -> len ) - (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (b ) ) ) -> len ) ; 
}

static int compare_syms (Scheme_Object * a , Scheme_Object * b ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(a, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 68 "bc/src/sort.c"
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM11_COUNT (0+XfOrM5_COUNT)
#   define SETUP_XfOrM11(x) SETUP_XfOrM5(x)

# 68 "bc/src/sort.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 

# 68 "bc/src/sort.c" 3
    ; 

# 68 "bc/src/sort.c" 3
    else FUNCCALL(SETUP_XfOrM11(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(a)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(a))->type)) == (Scheme_Type)(scheme_symbol_type))" , "bc/src/sort.c" , 68 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 68 "bc/src/sort.c"
  ; 
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM10_COUNT (0+XfOrM5_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM5(x)

# 69 "bc/src/sort.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 

# 69 "bc/src/sort.c" 3
    ; 

# 69 "bc/src/sort.c" 3
    else FUNCCALL(SETUP_XfOrM10(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(b)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(b))->type)) == (Scheme_Type)(scheme_symbol_type))" , "bc/src/sort.c" , 69 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 69 "bc/src/sort.c"
  ; 




  if ((& ((Scheme_Symbol * ) (a ) ) -> iso ) -> so . keyex & 0x1 )  {
    if (! ((& ((Scheme_Symbol * ) (b ) ) -> iso ) -> so . keyex & 0x1 ) )
      RET_VALUE_START (- 1 ) RET_VALUE_END ; 
  }

# 77 "bc/src/sort.c"
  else {
    if ((& ((Scheme_Symbol * ) (b ) ) -> iso ) -> so . keyex & 0x1 ) 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    if ((& ((Scheme_Symbol * ) (a ) ) -> iso ) -> so . keyex & 0x2 )  {
      if (! ((& ((Scheme_Symbol * ) (b ) ) -> iso ) -> so . keyex & 0x2 ) )
        RET_VALUE_START (- 1 ) RET_VALUE_END ; 
    }

# 83 "bc/src/sort.c"
    else {
      if ((& ((Scheme_Symbol * ) (b ) ) -> iso ) -> so . keyex & 0x2 ) 
        RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compare_sym_likes (a , b ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 92 "bc/src/sort.c"
static int compare_keywords (Scheme_Object * a , Scheme_Object * b ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(a, 1)));
# define XfOrM12_COUNT (2)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 94 "bc/src/sort.c"
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM14_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM14(x) SETUP_XfOrM12(x)

# 94 "bc/src/sort.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) 

# 94 "bc/src/sort.c" 3
    ; 

# 94 "bc/src/sort.c" 3
    else FUNCCALL(SETUP_XfOrM14(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(a)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(a))->type)) == (Scheme_Type)(scheme_keyword_type))" , "bc/src/sort.c" , 94 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 94 "bc/src/sort.c"
  ; 
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM13_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM13(x) SETUP_XfOrM12(x)

# 95 "bc/src/sort.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) 

# 95 "bc/src/sort.c" 3
    ; 

# 95 "bc/src/sort.c" 3
    else FUNCCALL(SETUP_XfOrM13(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(b)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(b))->type)) == (Scheme_Type)(scheme_keyword_type))" , "bc/src/sort.c" , 95 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 95 "bc/src/sort.c"
  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compare_sym_likes (a , b ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 100 "bc/src/sort.c"
static int compare_reals (Scheme_Object * a , Scheme_Object * b ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(a, 1)));
# define XfOrM15_COUNT (2)
# define SETUP_XfOrM15(x) SETUP(XfOrM15_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 102 "bc/src/sort.c"
  ((void ) sizeof ((((((intptr_t ) (a ) ) & 0x1 ) || ((((a ) -> type ) >= scheme_bignum_type ) && (((a ) -> type ) < scheme_complex_type ) ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM17_COUNT (0+XfOrM15_COUNT)
#   define SETUP_XfOrM17(x) SETUP_XfOrM15(x)

# 102 "bc/src/sort.c" 3
    if ((((intptr_t ) (a ) ) & 0x1 ) || ((((a ) -> type ) >= scheme_bignum_type ) && (((a ) -> type ) < scheme_complex_type ) ) ) 

# 102 "bc/src/sort.c" 3
    ; 

# 102 "bc/src/sort.c" 3
    else FUNCCALL(SETUP_XfOrM17(_), __assert_fail ("((((intptr_t)(a)) & 0x1) || ((((a)->type) >= scheme_bignum_type) && (((a)->type) < scheme_complex_type)))" , "bc/src/sort.c" , 102 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 102 "bc/src/sort.c"
  ; 
  ((void ) sizeof ((((((intptr_t ) (b ) ) & 0x1 ) || ((((b ) -> type ) >= scheme_bignum_type ) && (((b ) -> type ) < scheme_complex_type ) ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM16_COUNT (0+XfOrM15_COUNT)
#   define SETUP_XfOrM16(x) SETUP_XfOrM15(x)

# 103 "bc/src/sort.c" 3
    if ((((intptr_t ) (b ) ) & 0x1 ) || ((((b ) -> type ) >= scheme_bignum_type ) && (((b ) -> type ) < scheme_complex_type ) ) ) 

# 103 "bc/src/sort.c" 3
    ; 

# 103 "bc/src/sort.c" 3
    else FUNCCALL(SETUP_XfOrM16(_), __assert_fail ("((((intptr_t)(b)) & 0x1) || ((((b)->type) >= scheme_bignum_type) && (((b)->type) < scheme_complex_type)))" , "bc/src/sort.c" , 103 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 103 "bc/src/sort.c"
  ; 

  if (FUNCCALL(SETUP_XfOrM15(_), scheme_bin_lt (a , b ) ))
    RET_VALUE_START (- 1 ) RET_VALUE_END ; 
  else if (FUNCCALL_EMPTY(scheme_bin_lt (b , a ) ))
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 113 "bc/src/sort.c"
int compare_sortable (const void * _a , const void * _b ) 
{
  Scheme_Object * a = * (Scheme_Object * * ) _a ; 
  Scheme_Object * b = * (Scheme_Object * * ) _b ; 
  int am , bm ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(a, 1)));
# define XfOrM18_COUNT (2)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 119 "bc/src/sort.c"
  am = FUNCCALL(SETUP_XfOrM18(_), sort_major (a ) ); 
  bm = FUNCCALL(SETUP_XfOrM18(_), sort_major (b ) ); 

  if (am != bm )
    RET_VALUE_START (am - bm ) RET_VALUE_END ; 
  else {
#   define XfOrM19_COUNT (0+XfOrM18_COUNT)
#   define SETUP_XfOrM19(x) SETUP_XfOrM18(x)

# 125 "bc/src/sort.c"
    switch (am ) {
#     define XfOrM20_COUNT (0+XfOrM19_COUNT)
#     define SETUP_XfOrM20(x) SETUP_XfOrM19(x)

# 126 "bc/src/sort.c"
      case sort_major_boolean : 
      if ((a ) == (b ) ) 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      else if (((a ) ) == (scheme_false ) ) 
        RET_VALUE_START (- 1 ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
      case sort_major_char : 
      RET_VALUE_START ((((Scheme_Small_Object * ) (a ) ) -> u . char_val ) - (((Scheme_Small_Object * ) (b ) ) -> u . char_val ) ) RET_VALUE_END ; 
      case sort_major_real : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compare_reals (a , b ) )) RET_VALUE_EMPTY_END ; 
      case sort_major_symbol : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compare_syms (a , b ) )) RET_VALUE_EMPTY_END ; 
      case sort_major_keyword : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compare_keywords (a , b ) )) RET_VALUE_EMPTY_END ; 
      case sort_major_string : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_string_compare (a , b ) )) RET_VALUE_EMPTY_END ; 
      case sort_major_bytes : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_bytes_compare (a , b ) )) RET_VALUE_EMPTY_END ; 
      case sort_major_null : 
      case sort_major_void : 
      case sort_major_eof : 

      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 158 "bc/src/sort.c"
static int compare_vars_at_resolve (const void * _a , const void * _b ) 
{
  /* No conversion */

# 160 "bc/src/sort.c"
  Scheme_IR_Local * a = * (Scheme_IR_Local * * ) _a ; 
  Scheme_IR_Local * b = * (Scheme_IR_Local * * ) _b ; 
  return a -> resolve . lex_depth - b -> resolve . lex_depth ; 
}

void scheme_sort_resolve_ir_local_array (Scheme_IR_Local * * a , intptr_t count ) 
{
  /* No conversion */

# 167 "bc/src/sort.c"
  qsort (a , count , sizeof (Scheme_IR_Local * ) , compare_vars_at_resolve ) ; 
}



static int all_sortable (Scheme_Object * * a , int c ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(a, 0)));
# define XfOrM23_COUNT (1)
# define SETUP_XfOrM23(x) SETUP(XfOrM23_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 174 "bc/src/sort.c"
  while (c -- ) {
#   define XfOrM25_COUNT (0+XfOrM23_COUNT)
#   define SETUP_XfOrM25(x) SETUP_XfOrM23(x)

# 175 "bc/src/sort.c"
    if (FUNCCALL(SETUP_XfOrM25(_), sort_major (a [c ] ) )== sort_major_unknown )
      RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 181 "bc/src/sort.c"
static void sort_sortable_array (Scheme_Object * * a , intptr_t count ) 
{
  /* No conversion */

# 183 "bc/src/sort.c"
  qsort (a , count , sizeof (Scheme_Object * ) , compare_sortable ) ; 
}

Scheme_Object * * scheme_extract_sorted_keys (Scheme_Object * tree ) 
{
  intptr_t j , i , count ; 
  Scheme_Object * * a , * key ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(tree, 0), PUSH(key, 1), PUSH(a, 2)));
# define XfOrM27_COUNT (3)
# define SETUP_XfOrM27(x) SETUP(XfOrM27_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  a = NULLED_OUT ; 
  key = NULLED_OUT ; 

# 191 "bc/src/sort.c"
  if ((((((intptr_t ) (tree ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (tree ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (tree ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (tree ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    Scheme_Hash_Tree * ht = (Scheme_Hash_Tree * ) tree ; 
    BLOCK_SETUP((PUSH(ht, 0+XfOrM27_COUNT)));
#   define XfOrM35_COUNT (1+XfOrM27_COUNT)
#   define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)

# 194 "bc/src/sort.c"
    count = ht -> count ; 
    if (! count )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

    a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM35(_), GC_malloc (sizeof (Scheme_Object * ) * (count ) ) )) ; 

    j = - 1 ; 
    i = 0 ; 
    while ((j = (scheme_hash_tree_next (ht , j ) ) ) != - 1 ) {
#     define XfOrM38_COUNT (0+XfOrM35_COUNT)
#     define SETUP_XfOrM38(x) SETUP_XfOrM35(x)
      (
# 203 "bc/src/sort.c"
      scheme_hash_tree_index (ht , j , & key , ((void * ) 0 ) ) ) ; 
      a [i ++ ] = key ; 
    }

    ((void ) sizeof ((i == count ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM36_COUNT (0+XfOrM35_COUNT)
#     define SETUP_XfOrM36(x) SETUP_XfOrM35(x)

# 207 "bc/src/sort.c" 3
      if (i == count )

# 207 "bc/src/sort.c" 3
      ; 

# 207 "bc/src/sort.c" 3
      else FUNCCALL(SETUP_XfOrM36(_), __assert_fail ("i == count" , "bc/src/sort.c" , 207 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 207 "bc/src/sort.c"
    ; 
  }

# 208 "bc/src/sort.c"
  else {
    Scheme_Hash_Table * t = (Scheme_Hash_Table * ) tree ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM27_COUNT)));
#   define XfOrM29_COUNT (1+XfOrM27_COUNT)
#   define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)

# 211 "bc/src/sort.c"
    count = t -> count ; 

    if (! count )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

    a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM29(_), GC_malloc (sizeof (Scheme_Object * ) * (count ) ) )) ; 
    j = 0 ; 

    for (i = t -> size ; i -- ; ) {
      if (t -> vals [i ] ) {
        a [j ++ ] = t -> keys [i ] ; 
      }
    }

    ((void ) sizeof ((j == count ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM30_COUNT (0+XfOrM29_COUNT)
#     define SETUP_XfOrM30(x) SETUP_XfOrM29(x)

# 225 "bc/src/sort.c" 3
      if (j == count )

# 225 "bc/src/sort.c" 3
      ; 

# 225 "bc/src/sort.c" 3
      else FUNCCALL(SETUP_XfOrM30(_), __assert_fail ("j == count" , "bc/src/sort.c" , 225 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 225 "bc/src/sort.c"
    ; 
  }

  if (FUNCCALL(SETUP_XfOrM27(_), all_sortable (a , count ) )) {
#   define XfOrM28_COUNT (0+XfOrM27_COUNT)
#   define SETUP_XfOrM28(x) SETUP_XfOrM27(x)
    FUNCCALL(SETUP_XfOrM28(_), sort_sortable_array (a , count ) )
# 229 "bc/src/sort.c"
    ; 
    RET_VALUE_START (a ) RET_VALUE_END ; 
  }

# 231 "bc/src/sort.c"
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  RET_VALUE_START (a ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
