#include "precomp.h"

# 46 "/usr/include/ctype.h" 3
enum 
{
  _ISupper = (1 << (0 ) ) , 
  _ISlower = (1 << (1 ) ) , 
  _ISalpha = (1 << (2 ) ) , 
  _ISdigit = (1 << (3 ) ) , 
  _ISxdigit = (1 << (4 ) ) , 
  _ISspace = (1 << (5 ) ) , 
  _ISprint = (1 << (6 ) ) , 
  _ISgraph = (1 << (7 ) ) , 
  _ISblank = (1 << (8 ) ) , 
  _IScntrl = (1 << (9 ) ) , 
  _ISpunct = (1 << (10 ) ) , 
  _ISalnum = (1 << (11 ) ) }
; 

# 79 "/usr/include/ctype.h" 3
extern const unsigned short int * * __ctype_b_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 
extern const __int32_t * * __ctype_tolower_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 
extern const __int32_t * * __ctype_toupper_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 

# 122 "/usr/include/ctype.h" 3
extern int tolower (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 


extern int toupper (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 206 "/usr/include/ctype.h" 3
extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) tolower (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_tolower_loc () ) [__c ] : __c ; 
}

extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) toupper (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_toupper_loc () ) [__c ] : __c ; 
}

# 31 "bc/src/symbol.c"
static Scheme_Hash_Table * symbol_table = ((void * ) 0 ) ; 
static Scheme_Hash_Table * keyword_table = ((void * ) 0 ) ; 
static Scheme_Hash_Table * parallel_symbol_table = ((void * ) 0 ) ; 

static uintptr_t scheme_max_symbol_length ; 


int scheme_case_sensitive = 1 ; 
; 

void scheme_set_case_sensitive (int v ) {
  /* No conversion */

# 41 "bc/src/symbol.c"
  scheme_case_sensitive = v ; 
}
Scheme_Object * scheme_symbol_p_proc ; 
Scheme_Object * scheme_keyword_p_proc ; 


static Scheme_Object * symbol_lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * symbol_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * symbol_unreadable_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * string_to_symbol_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * string_to_uninterned_symbol_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * string_to_unreadable_symbol_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * symbol_to_string_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * symbol_to_immutable_string_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * keyword_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * keyword_lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * string_to_keyword_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * keyword_to_string_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * keyword_to_immutable_string_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * gensym (int argc , Scheme_Object * argv [] ) ; 




typedef uintptr_t hash_v_t ; 

# 76 "bc/src/symbol.c"
static Scheme_Object * rehash_symbol_bucket (Scheme_Hash_Table * table , 
GC_CAN_IGNORE const char * key , uintptr_t length , 
Scheme_Object * naya , int sym_type ) ; 


static Scheme_Object * symbol_bucket (Scheme_Hash_Table * table , 
GC_CAN_IGNORE const char * key , uintptr_t length , 
Scheme_Object * naya , int sym_type ) 
XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 86 "bc/src/symbol.c"
  hash_v_t h , h2 ; 
  uintptr_t mask ; 
  Scheme_Object * bucket ; 





  mask = table -> size - 1 ; 

  {
    uintptr_t i ; 
    i = 0 ; 
    h = 0xF0E1D2C3 + sym_type ; 
    h2 = 0 ; 

    while (i < length ) {
      int c = key [i ++ ] ; 
      h ^= (h << 5 ) + (h >> 2 ) + c ; 
      h2 += c ; 
    }

    h ^= (h << 5 ) + (h >> 2 ) + 0xA0A0 ; 
    h ^= (h << 5 ) + (h >> 2 ) + 0x0505 ; 

    if (naya ) {

      scheme_install_symbol_hash_code (naya , h ) ; 
    }

    h = h & mask ; 
    h2 = h2 & mask ; 
  }

  h2 |= 0x1 ; 

  while ((bucket = table -> keys [4 + h ] ) ) {
    if ((bucket ) == (scheme_false ) )  {
      if (naya ) {


        -- table -> count ; 
        break ; 
      }
    }

# 130 "bc/src/symbol.c"
    else if (((int ) length == (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (bucket ) ) ) -> len ) ) 
    && ! memcmp (key , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (bucket ) ) ) -> s ) , length ) )
      return bucket ; 
    h = (h + h2 ) & mask ; 
  }


  key = ((void * ) 0 ) ; 

  if (! naya )
    return ((void * ) 0 ) ; 

  if (table -> count * 2 >= table -> size ) {
    return rehash_symbol_bucket (table , key , length , naya , sym_type ) ; 
  }

  table -> keys [4 + h ] = naya ; 

  table -> count ++ ; 

  return naya ; 
}

static Scheme_Object * rehash_symbol_bucket (Scheme_Hash_Table * table , 
GC_CAN_IGNORE const char * key , uintptr_t length , 
Scheme_Object * naya , int sym_type ) 
{
  int i , oldsize = table -> size , newsize , lostc ; 
  size_t asize ; 
  Scheme_Object * cb ; 
  Scheme_Object * * old = table -> keys ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(table, 0), PUSH(cb, 1), PUSH(old, 2), PUSH(naya, 3)));
# define XfOrM14_COUNT (4)
# define SETUP_XfOrM14(x) SETUP(XfOrM14_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cb = NULLED_OUT ; 

# 166 "bc/src/symbol.c"
  lostc = 0 ; 
  for (i = 0 ; i < oldsize ; i ++ ) {
    cb = old [4 + i ] ; 
    if (cb == scheme_false )
      lostc ++ ; 
  }
  if ((lostc * 2 ) < table -> count )
    newsize = oldsize << 1 ; 
  else 
  newsize = oldsize ; 

  asize = (size_t ) newsize * sizeof (Scheme_Object * ) ; 
  {
    Scheme_Object * * ba ; 
    BLOCK_SETUP((PUSH(ba, 0+XfOrM14_COUNT)));
#   define XfOrM17_COUNT (1+XfOrM14_COUNT)
#   define SETUP_XfOrM17(x) SETUP(XfOrM17_COUNT)
    ba = NULLED_OUT ; 

# 181 "bc/src/symbol.c"
    ba = (Scheme_Object * * ) FUNCCALL(SETUP_XfOrM17(_), GC_malloc_weak_array (asize , scheme_false ) ); 




    table -> keys = ba ; 
  }
  table -> size = newsize ; 

  table -> count = 0 ; 

  for (i = 0 ; i < oldsize ; i ++ ) {
#   define XfOrM16_COUNT (0+XfOrM14_COUNT)
#   define SETUP_XfOrM16(x) SETUP_XfOrM14(x)

# 193 "bc/src/symbol.c"
    cb = old [4 + i ] ; 
    if (cb && (cb != scheme_false ) )
      FUNCCALL(SETUP_XfOrM16(_), symbol_bucket (table , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (cb ) ) ) -> s ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (cb ) ) ) -> len ) , cb , sym_type ) ); 
  }


  key = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (naya ) ) ) -> s ) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(symbol_bucket (table , key , length , naya , sym_type ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 250 "bc/src/symbol.c"
static Scheme_Hash_Table * init_one_symbol_table () 
{
  Scheme_Hash_Table * table ; 
  int size ; 
  Scheme_Object * * ba ; 
  DECL_RET_SAVE (Scheme_Hash_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(table, 0), PUSH(ba, 1)));
# define XfOrM20_COUNT (2)
# define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  table = NULLED_OUT ; 
  ba = NULLED_OUT ; 

# 256 "bc/src/symbol.c"
  table = FUNCCALL(SETUP_XfOrM20(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  table -> size = 256 ; 

  size = table -> size * sizeof (Scheme_Object * ) ; 

  ba = (Scheme_Object * * ) FUNCCALL(SETUP_XfOrM20(_), GC_malloc_weak_array (size , scheme_false ) ); 




  table -> keys = ba ; 

  RET_VALUE_START (table ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 272 "bc/src/symbol.c"
void 
scheme_init_symbol_table () 
{
  /* No conversion */

# 275 "bc/src/symbol.c"
  scheme_register_static ((void * ) & symbol_table , sizeof (symbol_table ) ) ; 
  scheme_register_static ((void * ) & keyword_table , sizeof (keyword_table ) ) ; 
  scheme_register_static ((void * ) & parallel_symbol_table , sizeof (parallel_symbol_table ) ) ; 

  symbol_table = init_one_symbol_table () ; 
  keyword_table = init_one_symbol_table () ; 
  parallel_symbol_table = init_one_symbol_table () ; 
}






void 
scheme_init_place_local_symbol_table () 
{
  /* No conversion */

# 292 "bc/src/symbol.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_symbol_table_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_symbol_table_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_keyword_table_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_keyword_table_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_parallel_symbol_table_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_parallel_symbol_table_ ) ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_symbol_table_ ) = init_one_symbol_table () ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_keyword_table_ ) = init_one_symbol_table () ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_parallel_symbol_table_ ) = init_one_symbol_table () ; 
}


void 
scheme_init_symbol_type (Scheme_Startup_Env * env ) 
{
  /* No conversion */
}
void 
scheme_init_symbol (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM24_COUNT (2)
# define SETUP_XfOrM24(x) SETUP(XfOrM24_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_register_static ((void * ) & scheme_symbol_p_proc , sizeof (scheme_symbol_p_proc ) ) )
# 312 "bc/src/symbol.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (symbol_p_prim , "symbol?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  scheme_symbol_p_proc = p ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("symbol?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (symbol_unreadable_p_prim , "symbol-unreadable?" , 1 , 1 , 1 ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("symbol-unreadable?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_checked_symbol_interned_p , "symbol-interned?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("symbol-interned?" , p , env ) ); 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM24(_), scheme_make_folding_prim (symbol_lt , "symbol<?" , 1 , - 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("symbol<?" , __funcarg62 , env ) )) ; 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (string_to_symbol_prim , "string->symbol" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("string->symbol" , p , env ) ); 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM24(_), scheme_make_immed_prim (string_to_uninterned_symbol_prim , "string->uninterned-symbol" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("string->uninterned-symbol" , __funcarg61 , env ) )) ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM24(_), scheme_make_immed_prim (string_to_unreadable_symbol_prim , "string->unreadable-symbol" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("string->unreadable-symbol" , __funcarg60 , env ) )) ; 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (symbol_to_string_prim , "symbol->string" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("symbol->string" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (symbol_to_immutable_string_prim , "symbol->immutable-string" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("symbol->immutable-string" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_keyword_p_proc , sizeof (scheme_keyword_p_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (keyword_p_prim , "keyword?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  scheme_keyword_p_proc = p ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("keyword?" , p , env ) ); 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM24(_), scheme_make_folding_prim (keyword_lt , "keyword<?" , 1 , - 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("keyword<?" , __funcarg59 , env ) )) ; 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (string_to_keyword_prim , "string->keyword" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("string->keyword" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (keyword_to_string_prim , "keyword->string" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("keyword->string" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (keyword_to_immutable_string_prim , "keyword->immutable-string" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM24(_), scheme_addto_prim_instance ("keyword->immutable-string" , p , env ) ); 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM24(_), scheme_make_immed_prim (gensym , "gensym" , 0 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("gensym" , __funcarg58 , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 370 "bc/src/symbol.c"
uintptr_t scheme_get_max_symbol_length () {
  /* No conversion */
  return scheme_max_symbol_length ; 
}

void scheme_ensure_max_symbol_length (uintptr_t len ) 
{
  /* No conversion */
  mzrt_ensure_max_cas (& scheme_max_symbol_length , len ) ; 
}







static Scheme_Object * 
make_a_symbol (const char * name , uintptr_t len , int kind ) 
{
  Scheme_Symbol * sym ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(sym, 1)));
# define XfOrM27_COUNT (2)
# define SETUP_XfOrM27(x) SETUP(XfOrM27_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sym = NULLED_OUT ; 

# 392 "bc/src/symbol.c"
  sym = (Scheme_Symbol * ) FUNCCALL(SETUP_XfOrM27(_), GC_malloc_one_tagged (sizeof (Scheme_Symbol ) + len + 1 - 0 ) ); 

  sym -> iso . so . type = scheme_symbol_type ; 
  (& sym -> iso ) -> so . keyex = kind ; 
  sym -> len = len ; 
  (memcpy (sym -> s , name , len ) ) ; 
  sym -> s [len ] = 0 ; 
  FUNCCALL(SETUP_XfOrM27(_), scheme_ensure_max_symbol_length (len ) )
  ; 

  RET_VALUE_START ((Scheme_Object * ) sym ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 405 "bc/src/symbol.c"
Scheme_Object * 
scheme_make_symbol (const char * name ) 
{
  /* No conversion */

# 408 "bc/src/symbol.c"
  return make_a_symbol (name , strlen (name ) , 0x1 ) ; 
}

Scheme_Object * 
scheme_make_exact_symbol (const char * name , uintptr_t len ) 
{
  /* No conversion */

# 414 "bc/src/symbol.c"
  return make_a_symbol (name , len , 0x1 ) ; 
}

Scheme_Object * 
scheme_make_exact_char_symbol (const mzchar * name , uintptr_t len ) 
{
  char buf [64 ] , * bs ; 
  intptr_t blen ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(bs, 0)));
# define XfOrM30_COUNT (1)
# define SETUP_XfOrM30(x) SETUP(XfOrM30_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  bs = NULLED_OUT ; 

# 422 "bc/src/symbol.c"
  bs = FUNCCALL(SETUP_XfOrM30(_), scheme_utf8_encode_to_buffer_len (name , len , buf , 64 , & blen ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_a_symbol (bs , blen , 0x1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 426 "bc/src/symbol.c"
typedef enum {
  enum_symbol , 
  enum_keyword , 
  enum_parallel_symbol , }
enum_symbol_table_type ; 

static Scheme_Object * 
intern_exact_symbol_in_table_worker (enum_symbol_table_type type , int kind , const char * name , uintptr_t len ) 
{
  Scheme_Object * sym ; 
  Scheme_Hash_Table * table ; 

  Scheme_Hash_Table * place_local_table ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(table, 0), PUSH(place_local_table, 1), PUSH(name, 2), PUSH(sym, 3)));
# define XfOrM31_COUNT (4)
# define SETUP_XfOrM31(x) SETUP(XfOrM31_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  sym = NULLED_OUT ; 
  table = NULLED_OUT ; 
  place_local_table = NULLED_OUT ; 

# 441 "bc/src/symbol.c"
  sym = ((void * ) 0 ) ; 

  switch (type ) {
#   define XfOrM35_COUNT (0+XfOrM31_COUNT)
#   define SETUP_XfOrM35(x) SETUP_XfOrM31(x)

# 444 "bc/src/symbol.c"
    case enum_symbol : 
    table = symbol_table ; 

    place_local_table = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_symbol_table_ ) ; 

    break ; 
    case enum_keyword : 
    table = keyword_table ; 

    place_local_table = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_keyword_table_ ) ; 

    break ; 
    case enum_parallel_symbol : 
    table = parallel_symbol_table ; 

    place_local_table = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_parallel_symbol_table_ ) ; 

    break ; 
    default : (
    printf ("Invalid enum_symbol_table_type %i\n" , type ) ) ; 
    FUNCCALL(SETUP_XfOrM35(_), abort () ); 
  }


  if (place_local_table ) {
#   define XfOrM34_COUNT (0+XfOrM31_COUNT)
#   define SETUP_XfOrM34(x) SETUP_XfOrM31(x)

# 469 "bc/src/symbol.c"
    sym = FUNCCALL(SETUP_XfOrM34(_), symbol_bucket (place_local_table , name , len , ((void * ) 0 ) , type ) ); 
  }

  if (! sym && table ) {
#   define XfOrM33_COUNT (0+XfOrM31_COUNT)
#   define SETUP_XfOrM33(x) SETUP_XfOrM31(x)

# 473 "bc/src/symbol.c"
    sym = FUNCCALL(SETUP_XfOrM33(_), symbol_bucket (table , name , len , ((void * ) 0 ) , type ) ); 
  }
  if (! sym ) {




    Scheme_Object * newsymbol ; 
    Scheme_Hash_Table * create_table ; 
    BLOCK_SETUP((PUSH(newsymbol, 0+XfOrM31_COUNT), PUSH(create_table, 1+XfOrM31_COUNT)));
#   define XfOrM32_COUNT (2+XfOrM31_COUNT)
#   define SETUP_XfOrM32(x) SETUP(XfOrM32_COUNT)
    newsymbol = NULLED_OUT ; 
    create_table = NULLED_OUT ; 

# 483 "bc/src/symbol.c"
    create_table = place_local_table ? place_local_table : table ; 



    newsymbol = FUNCCALL(SETUP_XfOrM32(_), make_a_symbol (name , len , kind ) ); 




    sym = FUNCCALL_AGAIN(symbol_bucket (create_table , name , len , newsymbol , type ) ); 
  }

  RET_VALUE_START (sym ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 498 "bc/src/symbol.c"
static Scheme_Object * 
intern_exact_symbol_in_table (enum_symbol_table_type type , int kind , const char * name , uintptr_t len ) 
{
  /* No conversion */

# 501 "bc/src/symbol.c"
  return intern_exact_symbol_in_table_worker (type , kind , name , len ) ; 
}

Scheme_Object * 
scheme_intern_exact_symbol (const char * name , uintptr_t len ) 
{
  /* No conversion */

# 507 "bc/src/symbol.c"
  return intern_exact_symbol_in_table (enum_symbol , 0 , name , len ) ; 
}

Scheme_Object * 
scheme_intern_exact_parallel_symbol (const char * name , uintptr_t len ) 
{
  /* No conversion */

# 513 "bc/src/symbol.c"
  return intern_exact_symbol_in_table (enum_parallel_symbol , 0x2 , name , len ) ; 
}

Scheme_Object * 
scheme_intern_exact_char_symbol (const mzchar * name , uintptr_t len ) 
{
  char buf [64 ] , * bs ; 
  intptr_t blen ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(bs, 0)));
# define XfOrM39_COUNT (1)
# define SETUP_XfOrM39(x) SETUP(XfOrM39_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  bs = NULLED_OUT ; 

# 521 "bc/src/symbol.c"
  bs = FUNCCALL(SETUP_XfOrM39(_), scheme_utf8_encode_to_buffer_len (name , len , buf , 64 , & blen ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(intern_exact_symbol_in_table (enum_symbol , 0 , bs , blen ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 525 "bc/src/symbol.c"
Scheme_Object * 
scheme_intern_exact_keyword (const char * name , uintptr_t len ) 
{
  Scheme_Object * s ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM40_COUNT (1)
# define SETUP_XfOrM40(x) SETUP(XfOrM40_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 529 "bc/src/symbol.c"
  s = FUNCCALL(SETUP_XfOrM40(_), intern_exact_symbol_in_table (enum_keyword , 0 , name , len ) ); 
  if (s -> type == scheme_symbol_type )
    s -> type = scheme_keyword_type ; 
  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 535 "bc/src/symbol.c"
Scheme_Object * scheme_intern_exact_char_keyword (const mzchar * name , uintptr_t len ) 
{
  char buf [64 ] , * bs ; 
  intptr_t blen ; 
  Scheme_Object * s ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(bs, 0), PUSH(s, 1)));
# define XfOrM41_COUNT (2)
# define SETUP_XfOrM41(x) SETUP(XfOrM41_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  bs = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 540 "bc/src/symbol.c"
  bs = FUNCCALL(SETUP_XfOrM41(_), scheme_utf8_encode_to_buffer_len (name , len , buf , 64 , & blen ) ); 
  s = FUNCCALL_AGAIN(intern_exact_symbol_in_table (enum_keyword , 0 , bs , blen ) ); 
  if (s -> type == scheme_symbol_type )
    s -> type = scheme_keyword_type ; 
  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 549 "bc/src/symbol.c"
Scheme_Object * 
scheme_intern_symbol (const char * name ) 



{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(name, 0)));
# define XfOrM42_COUNT (1)
# define SETUP_XfOrM42(x) SETUP(XfOrM42_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 555 "bc/src/symbol.c"
  if (! scheme_case_sensitive ) {
    uintptr_t i , len ; 
    char * naya ; 
    char on_stack [256 ] ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM42_COUNT)));
#   define XfOrM43_COUNT (1+XfOrM42_COUNT)
#   define SETUP_XfOrM43(x) SETUP(XfOrM43_COUNT)
    naya = NULLED_OUT ; 

# 560 "bc/src/symbol.c"
    len = strlen (name ) ; 
    if (len >= 256 )
      naya = (char * ) FUNCCALL(SETUP_XfOrM43(_), GC_malloc_atomic (len + 1 ) ); 
    else 
    naya = on_stack ; 

    for (i = 0 ; i < len ; i ++ ) {
      int c = ((unsigned char * ) name ) [i ] ; 

      c = (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 

      naya [i ] = c ; 
    }

    naya [len ] = 0 ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_intern_exact_symbol (naya , len ) )) RET_VALUE_EMPTY_END ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_intern_exact_symbol (name , strlen (name ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 582 "bc/src/symbol.c"
const char * scheme_symbol_name_and_size (Scheme_Object * sym , uintptr_t * length , int flags ) 
{
  int has_space = 0 , has_special = 0 , has_pipe = 0 , has_upper = 0 , digit_start ; 
  int dz ; 
  uintptr_t i , len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) , total_length ; 
  int pipe_quote ; 
  char buf [100 ] ; 
  char * s , * result ; 
  Scheme_Config * __funcarg63 = NULLED_OUT ; 
  DECL_RET_SAVE (const char * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(sym, 0), PUSH(length, 1), PUSH(result, 2), PUSH(s, 3)));
# define XfOrM46_COUNT (4)
# define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 591 "bc/src/symbol.c"
  if ((flags & 0x2 ) || (flags & 0x1 ) )
    pipe_quote = 1 ; 
  else if (flags & 0x4 )
    pipe_quote = 0 ; 
  else {
#   define XfOrM75_COUNT (0+XfOrM46_COUNT)
#   define SETUP_XfOrM75(x) SETUP_XfOrM46(x)

# 596 "bc/src/symbol.c"
    pipe_quote = (! ((((__funcarg63 = FUNCCALL(SETUP_XfOrM75(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg63 , MZCONFIG_CAN_READ_PIPE_QUOTE ) )) ) ) == (scheme_false ) ) ) ; 
  }

  if (len < 100 ) {
#   define XfOrM74_COUNT (0+XfOrM46_COUNT)
#   define SETUP_XfOrM74(x) SETUP_XfOrM46(x)

# 600 "bc/src/symbol.c"
    s = buf ; 
    (memcpy (buf , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> s ) , len + 1 ) ) ; 
  }

# 602 "bc/src/symbol.c"
  else 
  s = FUNCCALL(SETUP_XfOrM46(_), scheme_symbol_val (sym ) ); 

# 615 "bc/src/symbol.c"
  if (len ) {
    int ch = ((unsigned char * ) s ) [0 ] ; 
#   define XfOrM73_COUNT (0+XfOrM46_COUNT)
#   define SETUP_XfOrM73(x) SETUP_XfOrM46(x)

# 617 "bc/src/symbol.c"
    digit_start = ((flags & 0x10 ) 
    ? 0 
    : (((ch < 128 ) && ((* FUNCCALL(SETUP_XfOrM73(_), __ctype_b_loc () )) [(int ) ((ch ) ) ] & (unsigned short int ) _ISdigit ) ) || (ch == '.' ) 
    || (ch == '+' ) || (ch == '-' ) ) ) ; 
    if (ch == '#' && (len == 1 || s [1 ] != '%' ) )
      has_special = 1 ; 
    if (ch == '.' && len == 1 )
      has_special = 1 ; 
  }

# 625 "bc/src/symbol.c"
  else {
    digit_start = 0 ; 
    if (! (flags & 0x10 ) )
      has_space = 1 ; 
  }

  for (i = 0 ; i < len ; i ++ ) {
    int ch = ((unsigned char * ) s ) [i ] ; 
#   define XfOrM64_COUNT (0+XfOrM46_COUNT)
#   define SETUP_XfOrM64(x) SETUP_XfOrM46(x)

# 634 "bc/src/symbol.c"
    if (ch > 127 ) {

      mzchar buf [2 ] ; 
      int ul = 2 ; 
#     define XfOrM68_COUNT (0+XfOrM64_COUNT)
#     define SETUP_XfOrM68(x) SETUP_XfOrM64(x)

# 638 "bc/src/symbol.c"
      while (1 ) {
#       define XfOrM71_COUNT (0+XfOrM68_COUNT)
#       define SETUP_XfOrM71(x) SETUP_XfOrM68(x)

# 639 "bc/src/symbol.c"
        if (FUNCCALL(SETUP_XfOrM71(_), scheme_utf8_decode ((unsigned char * ) s , i , i + ul , buf , 0 , 1 , ((void * ) 0 ) , 0 , 0 ) )

        > 0 )
          break ; 
        ul ++ ; 
      }
      ch = buf [0 ] ; 
      if ((flags & 0x8 ) && (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x2000 ) ) {
        mzchar * rc ; 
        BLOCK_SETUP((PUSH(rc, 0+XfOrM68_COUNT)));
#       define XfOrM69_COUNT (1+XfOrM68_COUNT)
#       define SETUP_XfOrM69(x) SETUP(XfOrM69_COUNT)
        rc = NULLED_OUT ; 

# 648 "bc/src/symbol.c"
        buf [1 ] = 0 ; 
        rc = FUNCCALL(SETUP_XfOrM69(_), scheme_string_recase (buf , 0 , 1 , 3 , 1 , ((void * ) 0 ) ) ); 
        if ((rc != buf ) || (rc [0 ] != ch ) )
          has_upper = 1 ; 
        ch = 'a' ; 
      }
      i += (ul - 1 ) ; 
    }

    if (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 )  {
      if ((flags & 0x1 ) && (ch == ' ' ) ) {
      }
      else 
      has_space = 1 ; 
    }

# 662 "bc/src/symbol.c"
    else if (((ch == '(' ) || (ch == '[' ) || (ch == '{' ) || (ch == ')' ) || (ch == ']' ) || (ch == '}' ) || (ch == ')' ) || (ch == '\\' ) || (ch == '"' ) || (ch == '\'' ) || (ch == '`' ) || (ch == ',' ) || (ch == ';' ) || (((ch == '>' ) || (ch == '<' ) ) && (flags & 0x1 ) ) ) 
    || (ch == 0xFEFF ) )
      has_special = 1 ; 
    else if (ch == '|' )
      has_pipe = 1 ; 
    else if (flags & 0x8 ) {
      if ((ch + scheme_uchar_folds [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) != ch )
        has_upper = 1 ; 
    }
  }

  result = ((void * ) 0 ) ; 
  total_length = 0 ; 

  if (! has_space && ! has_special && (! pipe_quote || ! has_pipe ) && ! has_upper ) {
    mzchar cbuf [100 ] , * cs ; 
    intptr_t clen ; 
    BLOCK_SETUP((PUSH(cs, 0+XfOrM46_COUNT)));
#   define XfOrM52_COUNT (1+XfOrM46_COUNT)
#   define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
    cs = NULLED_OUT ; 

# 679 "bc/src/symbol.c"
    dz = 0 ; 
    cs = FUNCCALL(SETUP_XfOrM52(_), scheme_utf8_decode_to_buffer_len ((unsigned char * ) s , len , cbuf , 100 , & clen ) ); 
    if (cs 
    && digit_start 
    && ! (flags & 0x1 ) 
    && ((! (((FUNCCALL(SETUP_XfOrM52(_), scheme_read_number (cs , clen , 0 , 0 , 1 , 10 , 0 , ((void * ) 0 ) , & dz , 1 ) )) ) == (scheme_false ) ) ) 
    || dz ) ) {
#     define XfOrM54_COUNT (0+XfOrM52_COUNT)
#     define SETUP_XfOrM54(x) SETUP_XfOrM52(x)

# 687 "bc/src/symbol.c"
      if (! pipe_quote ) {
#       define XfOrM55_COUNT (0+XfOrM54_COUNT)
#       define SETUP_XfOrM55(x) SETUP_XfOrM54(x)

# 689 "bc/src/symbol.c"
        result = (char * ) FUNCCALL(SETUP_XfOrM55(_), GC_malloc_atomic (len + 2 ) ); 
        total_length = len + 1 ; 
        (memcpy (result + 1 , s , len ) ) ; 
        result [0 ] = '\\' ; 
        result [len + 1 ] = 0 ; 
      }
    }

# 695 "bc/src/symbol.c"
    else {
      total_length = len ; 
      result = s ; 
    }
  }

  if (! result ) {
#   define XfOrM47_COUNT (0+XfOrM46_COUNT)
#   define SETUP_XfOrM47(x) SETUP_XfOrM46(x)

# 702 "bc/src/symbol.c"
    if (! has_pipe && pipe_quote ) {
#     define XfOrM51_COUNT (0+XfOrM47_COUNT)
#     define SETUP_XfOrM51(x) SETUP_XfOrM47(x)

# 703 "bc/src/symbol.c"
      result = (char * ) FUNCCALL(SETUP_XfOrM51(_), GC_malloc_atomic (len + 3 ) ); 
      total_length = len + 2 ; 
      (memcpy (result + 1 , s , len ) ) ; 
      result [0 ] = '|' ; 
      result [len + 1 ] = '|' ; 
      result [len + 2 ] = 0 ; 
    }

# 709 "bc/src/symbol.c"
    else {
      mzchar cbuf [100 ] , * cs , * cresult ; 
      intptr_t clen ; 
      int p = 0 ; 
      intptr_t i = 0 ; 
      intptr_t rlen ; 
      BLOCK_SETUP((PUSH(cresult, 0+XfOrM47_COUNT), PUSH(cs, 1+XfOrM47_COUNT)));
#     define XfOrM48_COUNT (2+XfOrM47_COUNT)
#     define SETUP_XfOrM48(x) SETUP(XfOrM48_COUNT)
      cs = NULLED_OUT ; 
      cresult = NULLED_OUT ; 

# 716 "bc/src/symbol.c"
      dz = 0 ; 
      cs = FUNCCALL(SETUP_XfOrM48(_), scheme_utf8_decode_to_buffer_len ((unsigned char * ) s , len , cbuf , 100 , & clen ) ); 

      cresult = (mzchar * ) FUNCCALL(SETUP_XfOrM48(_), GC_malloc_atomic (((2 * len ) + 1 ) * sizeof (mzchar ) ) ); 

      for (i = 0 ; i < clen ; i ++ ) {
        mzchar ch = cs [i ] ; 
        if ((((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) 
        || ((ch == '(' ) || (ch == '[' ) || (ch == '{' ) || (ch == ')' ) || (ch == ']' ) || (ch == '}' ) || (ch == ')' ) || (ch == '\\' ) || (ch == '"' ) || (ch == '\'' ) || (ch == '`' ) || (ch == ',' ) || (ch == ';' ) || (((ch == '>' ) || (ch == '<' ) ) && (flags & 0x1 ) ) ) 
        || ((ch == '|' ) && pipe_quote ) 
        || (! i && s [0 ] == '#' ) 
        || (has_upper && (ch >= 'A' ) && (ch <= 'Z' ) ) )
          cresult [p ++ ] = '\\' ; 
        cresult [p ++ ] = ch ; 
      }

      result = FUNCCALL(SETUP_XfOrM48(_), scheme_utf8_encode_to_buffer_len (cresult , p , ((void * ) 0 ) , 0 , & rlen ) ); 
      total_length = rlen ; 
    }
  }

  if (length )
    * length = total_length ; 

  RET_VALUE_START ((result == buf ) ? FUNCCALL(SETUP_XfOrM46(_), scheme_symbol_val (sym ) ): result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 743 "bc/src/symbol.c"
const char * scheme_symbol_name (Scheme_Object * sym ) 
{
  /* No conversion */

# 745 "bc/src/symbol.c"
  return scheme_symbol_name_and_size (sym , ((void * ) 0 ) , 0 ) ; 
}

char * scheme_symbol_val (Scheme_Object * sym ) 
{
  char * s ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sym, 0), PUSH(s, 1)));
# define XfOrM77_COUNT (2)
# define SETUP_XfOrM77(x) SETUP(XfOrM77_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 751 "bc/src/symbol.c"
  s = FUNCCALL(SETUP_XfOrM77(_), GC_malloc_atomic ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) + 1 ) ); 
  (memcpy (s , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> s ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) + 1 ) ) ; 
  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 758 "bc/src/symbol.c"
static Scheme_Object * 
symbol_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 761 "bc/src/symbol.c"
  return ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ? scheme_true : scheme_false ; 
}

Scheme_Object * 
scheme_checked_symbol_interned_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 767 "bc/src/symbol.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    return (((& ((Scheme_Symbol * ) (argv [0 ] ) ) -> iso ) -> so . keyex & 0x3 ) ? scheme_false : scheme_true ) ; 

  scheme_wrong_contract ("symbol-interned?" , "symbol?" , 0 , argc , argv ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * 
symbol_unreadable_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 777 "bc/src/symbol.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    return (((& ((Scheme_Symbol * ) (argv [0 ] ) ) -> iso ) -> so . keyex & 0x2 ) ? scheme_true : scheme_false ) ; 

  scheme_wrong_contract ("symbol-unreadable?" , "symbol?" , 0 , argc , argv ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * 
string_to_symbol_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 787 "bc/src/symbol.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    scheme_wrong_contract ("string->symbol" , "string?" , 0 , argc , argv ) ; 
  return scheme_intern_exact_char_symbol ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . string_val ) , 
  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . tag_val ) ) ; 
}

static Scheme_Object * 
string_to_uninterned_symbol_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 796 "bc/src/symbol.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    scheme_wrong_contract ("string->uninterned-symbol" , "string?" , 0 , argc , argv ) ; 
  return scheme_make_exact_char_symbol ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . string_val ) , 
  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . tag_val ) ) ; 
}

static Scheme_Object * 
string_to_unreadable_symbol_prim (int argc , Scheme_Object * argv [] ) 
{
  char buf [64 ] , * bs ; 
  intptr_t blen ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(bs, 0)));
# define XfOrM83_COUNT (1)
# define SETUP_XfOrM83(x) SETUP(XfOrM83_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  bs = NULLED_OUT ; 

# 808 "bc/src/symbol.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("string->unreadable-symbol" , "string?" , 0 , argc , argv ) ); 

  bs = FUNCCALL(SETUP_XfOrM83(_), scheme_utf8_encode_to_buffer_len ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . tag_val ) , buf , 64 , & blen ) )

  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_intern_exact_parallel_symbol (bs , blen ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 818 "bc/src/symbol.c"
Scheme_Object * scheme_symbol_to_string (Scheme_Object * sym ) 
{
  Scheme_Object * str ; 
  GC_CAN_IGNORE unsigned char * s ; 
  GC_CAN_IGNORE mzchar * s2 ; 
  intptr_t len , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(sym, 1)));
# define XfOrM84_COUNT (2)
# define SETUP_XfOrM84(x) SETUP(XfOrM84_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  str = NULLED_OUT ; 

# 825 "bc/src/symbol.c"
  s = (unsigned char * ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> s ) ; 
  len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) ; 
  for (i = 0 ; i < len ; i ++ ) {
    if (s [i ] >= 128 )
      break ; 
  }
  s = ((void * ) 0 ) ; 

  if (i == len ) {
#   define XfOrM86_COUNT (0+XfOrM84_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM84(x)

# 835 "bc/src/symbol.c"
    str = FUNCCALL(SETUP_XfOrM86(_), scheme_alloc_char_string (len , 0 ) ); 
    s = (unsigned char * ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> s ) ; 
    s2 = (((Scheme_Simple_Object * ) (str ) ) -> u . char_str_val . string_val ) ; 
    for (i = 0 ; i < len ; i ++ ) {
      s2 [i ] = s [i ] ; 
    }
    RET_VALUE_START (str ) RET_VALUE_END ; 
  }

# 842 "bc/src/symbol.c"
  else {
#   define XfOrM85_COUNT (0+XfOrM84_COUNT)
#   define SETUP_XfOrM85(x) SETUP_XfOrM84(x)

# 843 "bc/src/symbol.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_utf8_string ((char * ) sym , ((uintptr_t ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> s ) - (uintptr_t ) (sym ) ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) ) )) RET_VALUE_EMPTY_END 

    ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 849 "bc/src/symbol.c"
static Scheme_Object * 
symbol_to_string_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 852 "bc/src/symbol.c"
  Scheme_Object * sym ; 

  sym = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (sym ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sym ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("symbol->string" , "symbol?" , 0 , argc , argv ) ; 

  return scheme_symbol_to_string (sym ) ; 
}

static Scheme_Object * 
symbol_to_immutable_string_prim (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * sym , * str ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(str, 0)));
# define XfOrM92_COUNT (1)
# define SETUP_XfOrM92(x) SETUP(XfOrM92_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sym = NULLED_OUT ; 
  str = NULLED_OUT ; 

# 867 "bc/src/symbol.c"
  sym = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (sym ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sym ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("symbol->immutable-string" , "symbol?" , 0 , argc , argv ) ); 



  str = FUNCCALL(SETUP_XfOrM92(_), scheme_symbol_to_string (sym ) ); 
  ((((Scheme_Inclhash_Object * ) (str ) ) -> so . keyex |= 0x1 ) ) ; 

  RET_VALUE_START (str ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 881 "bc/src/symbol.c"
static Scheme_Object * 
keyword_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 884 "bc/src/symbol.c"
  return ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * symkey_lt (const char * who , Scheme_Type ty , const char * contract , 
int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 890 "bc/src/symbol.c"
  Scheme_Object * prev = argv [0 ] , * kw ; 
  GC_CAN_IGNORE unsigned char * a , * b ; 
  int i , al , bl , t ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prev ) ) -> type ) ) == (Scheme_Type ) (ty ) ) )
    scheme_wrong_contract (who , contract , 0 , argc , argv ) ; 

  for (i = 1 ; i < argc ; i ++ ) {
    kw = argv [i ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (kw ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (kw ) ) -> type ) ) == (Scheme_Type ) (ty ) ) )
      scheme_wrong_contract (who , contract , i , argc , argv ) ; 

    a = (unsigned char * ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (prev ) ) ) -> s ) ; 
    al = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (prev ) ) ) -> len ) ; 
    b = (unsigned char * ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kw ) ) ) -> s ) ; 
    bl = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kw ) ) ) -> len ) ; 
    t = ((al < bl ) ? al : bl ) ; 
    while (t -- ) {
      if (* a < * b ) {
        al = 0 ; 
        bl = 1 ; 
        break ; 
      }

# 912 "bc/src/symbol.c"
      else if (* a > * b ) {
        al = bl = 0 ; 
        break ; 
      }

# 915 "bc/src/symbol.c"
      else {
        a ++ ; 
        b ++ ; 
      }
    }
    a = b = ((void * ) 0 ) ; 

    if (al >= bl ) {

      for (i ++ ; i < argc ; i ++ ) {
        if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (ty ) ) )
          scheme_wrong_contract (who , contract , i , argc , argv ) ; 
      }
      return scheme_false ; 
    }

    prev = kw ; 
  }

  return scheme_true ; 
}

static Scheme_Object * keyword_lt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 939 "bc/src/symbol.c"
  return symkey_lt ("keyword<?" , scheme_keyword_type , "keyword?" , argc , argv ) ; 
}

static Scheme_Object * symbol_lt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 944 "bc/src/symbol.c"
  return symkey_lt ("symbol<?" , scheme_symbol_type , "symbol?" , argc , argv ) ; 
}

static Scheme_Object * 
string_to_keyword_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 950 "bc/src/symbol.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    scheme_wrong_contract ("string->keyword" , "string?" , 0 , argc , argv ) ; 
  return scheme_intern_exact_char_keyword ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . string_val ) , 
  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . tag_val ) ) ; 
}

static Scheme_Object * 
keyword_to_string_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 959 "bc/src/symbol.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) )
    scheme_wrong_contract ("keyword->string" , "keyword?" , 0 , argc , argv ) ; 

  return scheme_make_sized_offset_utf8_string ((char * ) (argv [0 ] ) , 
  ((uintptr_t ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> s ) - (uintptr_t ) (argv [0 ] ) ) , 
  (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> len ) ) ; 
}

static Scheme_Object * 
keyword_to_immutable_string_prim (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * str ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(str, 0)));
# define XfOrM123_COUNT (1)
# define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  str = NULLED_OUT ; 

# 972 "bc/src/symbol.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("keyword->immutable-string" , "keyword?" , 0 , argc , argv ) ); 



  str = FUNCCALL(SETUP_XfOrM123(_), scheme_make_sized_offset_utf8_string ((char * ) (argv [0 ] ) , ((uintptr_t ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> s ) - (uintptr_t ) (argv [0 ] ) ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> len ) ) )

  ; 

  ((((Scheme_Inclhash_Object * ) (str ) ) -> so . keyex |= 0x1 ) ) ; 

  RET_VALUE_START (str ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 986 "bc/src/symbol.c"
static Scheme_Object * gensym (int argc , Scheme_Object * argv [] ) 
{
  char buffer [100 ] , * str ; 
  Scheme_Object * r ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(r, 1)));
# define XfOrM124_COUNT (2)
# define SETUP_XfOrM124(x) SETUP(XfOrM124_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  str = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 991 "bc/src/symbol.c"
  if (argc )
    r = argv [0 ] ; 
  else 
  r = ((void * ) 0 ) ; 

  if (r && ! ((Scheme_Type ) (((((intptr_t ) (r ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (r ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (r ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (r ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("gensym" , "(or/c symbol? string?)" , 0 , argc , argv ) ); 

  if (r ) {
    char buf [64 ] ; 
#   define XfOrM125_COUNT (0+XfOrM124_COUNT)
#   define SETUP_XfOrM125(x) SETUP_XfOrM124(x)

# 1001 "bc/src/symbol.c"
    if ((Scheme_Type ) (((((intptr_t ) (r ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (r ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#     define XfOrM126_COUNT (0+XfOrM125_COUNT)
#     define SETUP_XfOrM126(x) SETUP_XfOrM125(x)

# 1002 "bc/src/symbol.c"
      str = FUNCCALL(SETUP_XfOrM126(_), scheme_utf8_encode_to_buffer ((((Scheme_Simple_Object * ) (r ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (r ) ) -> u . char_str_val . tag_val ) , buf , 64 ) )

      ; 
    }

# 1005 "bc/src/symbol.c"
    else 
    str = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (r ) ) ) -> s ) ; 
    (sprintf (buffer , "%.80s%d" , str , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gensym_counter_ ) ++ ) ) ; 
    str = ((void * ) 0 ) ; 
  }

# 1009 "bc/src/symbol.c"
  else (
  sprintf (buffer , "g%d" , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gensym_counter_ ) ++ ) ) ; 

  r = FUNCCALL(SETUP_XfOrM124(_), scheme_make_symbol (buffer ) ); 

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1017 "bc/src/symbol.c"
Scheme_Object * scheme_gensym (Scheme_Object * base ) 
{
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM127_COUNT (3)
# define SETUP_XfOrM127(x) SETUP(XfOrM127_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 1020 "bc/src/symbol.c"
  a [0 ] = base ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM127(_), gensym (1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1024 "bc/src/symbol.c"
Scheme_Object * scheme_symbol_append (Scheme_Object * s1 , Scheme_Object * s2 ) 
{
  char * s ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s2, 0), PUSH(s1, 1), PUSH(s, 2)));
# define XfOrM128_COUNT (3)
# define SETUP_XfOrM128(x) SETUP(XfOrM128_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 1027 "bc/src/symbol.c"
  s = ((char * ) FUNCCALL(SETUP_XfOrM128(_), GC_malloc_atomic (sizeof (char ) * ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s1 ) ) ) -> len ) + (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s2 ) ) ) -> len ) + 1 ) ) )) ; 
  (memcpy (s , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s1 ) ) ) -> s ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s1 ) ) ) -> len ) ) ) ; 
  (memcpy (s + (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s1 ) ) ) -> len ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s2 ) ) ) -> s ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s2 ) ) ) -> len ) + 1 ) ) ; 
  if (((& ((Scheme_Symbol * ) (s1 ) ) -> iso ) -> so . keyex & 0x1 ) || ((& ((Scheme_Symbol * ) (s2 ) ) -> iso ) -> so . keyex & 0x1 ) )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_exact_symbol (s , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s1 ) ) ) -> len ) + (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s2 ) ) ) -> len ) ) )) RET_VALUE_EMPTY_END ; 
  else if (((& ((Scheme_Symbol * ) (s1 ) ) -> iso ) -> so . keyex & 0x2 ) || ((& ((Scheme_Symbol * ) (s2 ) ) -> iso ) -> so . keyex & 0x2 ) )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_intern_exact_parallel_symbol (s , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s1 ) ) ) -> len ) + (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s2 ) ) ) -> len ) ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_intern_exact_symbol (s , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s1 ) ) ) -> len ) + (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s2 ) ) ) -> len ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
