#include "precomp.h"

# 7 "bc/src/syntax.c"
static Scheme_Object * source_symbol ; 

Scheme_Object * scheme_syntax_p_proc ; 

static Scheme_Hash_Tree * empty_hash_tree ; 

Scheme_Object * scheme_paren_shape_symbol ; 

Scheme_Hash_Tree * scheme_source_stx_props ; 
Scheme_Object * scheme_paren_shape_preserve_square ; 
Scheme_Object * scheme_paren_shape_preserve_curly ; 
static Scheme_Hash_Tree * square_stx_props ; 
static Scheme_Hash_Tree * curly_stx_props ; 

static Scheme_Stx_Srcloc * empty_srcloc ; 

static Scheme_Object * syntax_p (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * syntax_to_datum (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * datum_to_syntax (int argc , Scheme_Object * * argv ) ; 

Scheme_Object * scheme_checked_syntax_e (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * syntax_line (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * syntax_col (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * syntax_pos (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * syntax_span (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * syntax_src (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * syntax_property (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * syntax_property_keys (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * syntax_to_datum_inner (Scheme_Object * o ) ; 
static Scheme_Object * datum_to_syntax_inner (Scheme_Object * o , 
Scheme_Stx * stx_src , 
Scheme_Hash_Table * ht ) ; 


static void register_traversers (void ) ; 




__xform_nongcing__ static int prefab_p (Scheme_Object * o ) 
{
  /* No conversion */

# 51 "bc/src/syntax.c"
  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    if (((Scheme_Structure * ) o ) -> stype -> prefab_key )
      if ((& ((Scheme_Structure * ) o ) -> stype -> iso ) -> so . keyex & 0x1 )
      return 1 ; 
  }
  return 0 ; 
}

# 72 "bc/src/syntax.c"
void scheme_init_stx (Scheme_Startup_Env * env ) 
{
  Scheme_Object * o ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(o, 1)));
# define XfOrM3_COUNT (2)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM3(_), register_traversers () )
# 77 "bc/src/syntax.c"
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & empty_hash_tree , sizeof (empty_hash_tree ) ) )

  ; 
  empty_hash_tree = (scheme_make_hash_tree (0 ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_register_static ((void * ) & scheme_syntax_p_proc , sizeof (scheme_syntax_p_proc ) ) )
  ; 
  o = FUNCCALL_AGAIN(scheme_make_folding_prim (syntax_p , "syntax?" , 1 , 1 , 1 ) ); 
  scheme_syntax_p_proc = o ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("syntax?" , o , env ) ); 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (syntax_to_datum , "syntax->datum" , 1 , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("syntax->datum" , __funcarg66 , env ) )) ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_immed_prim (datum_to_syntax , "datum->syntax" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("datum->syntax" , __funcarg65 , env ) )) ; 

  o = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_checked_syntax_e , "syntax-e" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("syntax-e" , o , env ) ); 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (syntax_line , "syntax-line" , 1 , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("syntax-line" , __funcarg64 , env ) )) ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (syntax_col , "syntax-column" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("syntax-column" , __funcarg63 , env ) )) ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (syntax_pos , "syntax-position" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("syntax-position" , __funcarg62 , env ) )) ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (syntax_span , "syntax-span" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("syntax-span" , __funcarg61 , env ) )) ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (syntax_src , "syntax-source" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("syntax-source" , __funcarg60 , env ) )) ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_immed_prim (syntax_property , "syntax-property" , 2 , 3 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("syntax-property" , __funcarg59 , env ) )) ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_immed_prim (syntax_property_keys , "syntax-property-symbol-keys" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("syntax-property-symbol-keys" , __funcarg58 , env ) )) ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & source_symbol , sizeof (source_symbol ) ) )
  ; 
  source_symbol = FUNCCALL_EMPTY(scheme_make_symbol ("source" ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & empty_srcloc , sizeof (empty_srcloc ) ) )
  ; 
  empty_srcloc = ((Scheme_Stx_Srcloc * ) FUNCCALL_EMPTY(GC_malloc_one_small_tagged ((((sizeof (Scheme_Stx_Srcloc ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  empty_srcloc -> type = scheme_rt_srcloc ; 

  empty_srcloc -> src = scheme_false ; 
  empty_srcloc -> line = - 1 ; 
  empty_srcloc -> col = - 1 ; 
  empty_srcloc -> pos = - 1 ; 
  empty_srcloc -> span = - 1 ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & scheme_paren_shape_symbol , sizeof (scheme_paren_shape_symbol ) ) )
  ; 
  scheme_paren_shape_symbol = FUNCCALL_EMPTY(scheme_intern_symbol ("paren-shape" ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & scheme_paren_shape_preserve_square , sizeof (scheme_paren_shape_preserve_square ) ) )
  ; 
  scheme_paren_shape_preserve_square = scheme_char_constants [(unsigned char ) ('[' ) ] ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & scheme_paren_shape_preserve_curly , sizeof (scheme_paren_shape_preserve_curly ) ) )
  ; 
  scheme_paren_shape_preserve_curly = scheme_char_constants [(unsigned char ) ('{' ) ] ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & scheme_source_stx_props , sizeof (scheme_source_stx_props ) ) )
  ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & square_stx_props , sizeof (square_stx_props ) ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & curly_stx_props , sizeof (curly_stx_props ) ) ); 
  scheme_source_stx_props = FUNCCALL_EMPTY(scheme_hash_tree_set (empty_hash_tree , source_symbol , scheme_true ) ); 
  square_stx_props = FUNCCALL_EMPTY(scheme_hash_tree_set (empty_hash_tree , scheme_paren_shape_symbol , scheme_paren_shape_preserve_square ) ); 
  curly_stx_props = FUNCCALL_EMPTY(scheme_hash_tree_set (empty_hash_tree , scheme_paren_shape_symbol , scheme_paren_shape_preserve_curly ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 136 "bc/src/syntax.c"
void scheme_init_stx_places (int initial_main_os_thread ) {
  /* No conversion */
}




Scheme_Object * scheme_make_stx (Scheme_Object * val , 
Scheme_Stx_Srcloc * srcloc , 
Scheme_Hash_Tree * props ) 
{
  Scheme_Stx * stx ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(props, 0), PUSH(srcloc, 1), PUSH(stx, 2), PUSH(val, 3)));
# define XfOrM5_COUNT (4)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stx = NULLED_OUT ; 

# 149 "bc/src/syntax.c"
  stx = ((Scheme_Stx * ) FUNCCALL(SETUP_XfOrM5(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Stx ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  stx -> so . type = scheme_stx_type ; 
  stx -> val = val ; 
  stx -> srcloc = srcloc ; 
  stx -> props = props ; 

  RET_VALUE_START ((Scheme_Object * ) stx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 158 "bc/src/syntax.c"
Scheme_Object * clone_stx (Scheme_Object * to , GC_CAN_IGNORE int * mutate ) 

{
  Scheme_Stx * stx = (Scheme_Stx * ) to ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(stx, 0), PUSH(to, 1)));
# define XfOrM6_COUNT (2)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 163 "bc/src/syntax.c"
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (to ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (to ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM7_COUNT (0+XfOrM6_COUNT)
#   define SETUP_XfOrM7(x) SETUP_XfOrM6(x)

# 163 "bc/src/syntax.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (to ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (to ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 

# 163 "bc/src/syntax.c" 3
    ; 

# 163 "bc/src/syntax.c" 3
    else FUNCCALL(SETUP_XfOrM7(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(to)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(to))->type)) == (Scheme_Type)(scheme_stx_type))" , "bc/src/syntax.c" , 163 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 163 "bc/src/syntax.c"
  ; 

  if (mutate && (* mutate & 1 ) )
    RET_VALUE_START (to ) RET_VALUE_END ; 

  stx = (Scheme_Stx * ) FUNCCALL(SETUP_XfOrM6(_), scheme_make_stx (stx -> val , stx -> srcloc , stx -> props ) )

  ; 

  if (mutate )
    * mutate |= 1 ; 

  RET_VALUE_START ((Scheme_Object * ) stx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 178 "bc/src/syntax.c"
Scheme_Object * scheme_make_stx_w_offset (Scheme_Object * val , 
intptr_t line , intptr_t col , intptr_t pos , intptr_t span , 
Scheme_Object * src , 
Scheme_Hash_Tree * props ) 
{
  Scheme_Stx_Srcloc * srcloc ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(props, 0), PUSH(srcloc, 1), PUSH(src, 2), PUSH(val, 3)));
# define XfOrM8_COUNT (4)
# define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  srcloc = NULLED_OUT ; 

# 185 "bc/src/syntax.c"
  srcloc = ((Scheme_Stx_Srcloc * ) FUNCCALL(SETUP_XfOrM8(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Stx_Srcloc ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  srcloc -> type = scheme_rt_srcloc ; 

  srcloc -> src = src ; 
  srcloc -> line = line ; 
  srcloc -> col = col ; 
  srcloc -> pos = pos ; 
  srcloc -> span = span ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_stx (val , srcloc , props ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

int scheme_stx_list_length (Scheme_Object * list ) 
{
  /* No conversion */

# 204 "bc/src/syntax.c"
  int len ; 

  if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
    list = ((Scheme_Stx * ) list ) -> val ; 

  len = 0 ; 
  while (! ((list ) == (scheme_null ) ) ) {
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
      list = ((Scheme_Stx * ) list ) -> val ; 
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
      len ++ ; 
      list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 
    }

# 216 "bc/src/syntax.c"
    else {
      if (! ((list ) == (scheme_null ) ) )
        len ++ ; 
      break ; 
    }
  }

  return len ; 
}

int scheme_stx_proper_list_length (Scheme_Object * list ) 
{
  /* No conversion */

# 228 "bc/src/syntax.c"
  int len ; 
  Scheme_Object * turtle ; 

  if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
    list = ((Scheme_Stx * ) list ) -> val ; 

  len = 0 ; 
  turtle = list ; 
  while (((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    len ++ ; 

    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
      list = ((Scheme_Stx * ) list ) -> val ; 

    if (! ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      break ; 
    len ++ ; 
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
      list = ((Scheme_Stx * ) list ) -> val ; 

    if ((turtle ) == (list ) ) 
      break ; 

    turtle = (((Scheme_Simple_Object * ) (turtle ) ) -> u . pair_val . cdr ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (turtle ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (turtle ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
      turtle = ((Scheme_Stx * ) turtle ) -> val ; 
  }


  if ((list ) == (scheme_null ) ) 
    return len ; 

  return - 1 ; 
}






static Scheme_Object * syntax_to_datum_k (void ) 
{
  /* No conversion */

# 272 "bc/src/syntax.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  return syntax_to_datum_inner (o ) ; 
}


static Scheme_Object * syntax_to_datum_inner (Scheme_Object * o ) 


{
  Scheme_Object * v , * result ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(result, 1), PUSH(o, 2)));
# define XfOrM20_COUNT (3)
# define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 288 "bc/src/syntax.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM60_COUNT (0+XfOrM20_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM20(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 290 "bc/src/syntax.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM61_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM61(x) SETUP_XfOrM60(x)

# 292 "bc/src/syntax.c"
      p -> ku . k . p1 = (void * ) o ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (syntax_to_datum_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }

  {
#   define XfOrM58_COUNT (0+XfOrM20_COUNT)
#   define SETUP_XfOrM58(x) SETUP_XfOrM20(x)

# 297 "bc/src/syntax.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM59_COUNT (0+XfOrM58_COUNT)
#     define SETUP_XfOrM59(x) SETUP_XfOrM58(x)
      FUNCCALL(SETUP_XfOrM59(_), scheme_out_of_fuel () )
# 297 "bc/src/syntax.c"
      ; 
    }
  }

# 297 "bc/src/syntax.c"
  ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
    o = ((Scheme_Stx * ) o ) -> val ; 
  v = o ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * first = ((void * ) 0 ) , * last = ((void * ) 0 ) , * p ; 
    Scheme_Object * a ; 
    int same = 0 ; 
    BLOCK_SETUP((PUSH(last, 0+XfOrM20_COUNT), PUSH(first, 1+XfOrM20_COUNT), PUSH(a, 2+XfOrM20_COUNT), PUSH(p, 3+XfOrM20_COUNT)));
#   define XfOrM41_COUNT (4+XfOrM20_COUNT)
#   define SETUP_XfOrM41(x) SETUP(XfOrM41_COUNT)
    p = NULLED_OUT ; 
    a = NULLED_OUT ; 

# 308 "bc/src/syntax.c"
    while (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM52_COUNT (0+XfOrM41_COUNT)
#     define SETUP_XfOrM52(x) SETUP_XfOrM41(x)

# 309 "bc/src/syntax.c"
      a = FUNCCALL(SETUP_XfOrM52(_), syntax_to_datum_inner ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ); 

      if (! first && ((a ) == ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) ) {
        same ++ ; 
        v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
      }

# 314 "bc/src/syntax.c"
      else {
#       define XfOrM53_COUNT (0+XfOrM52_COUNT)
#       define SETUP_XfOrM53(x) SETUP_XfOrM52(x)

# 315 "bc/src/syntax.c"
        if (! first && (same > 0 ) ) {
#         define XfOrM54_COUNT (0+XfOrM53_COUNT)
#         define SETUP_XfOrM54(x) SETUP_XfOrM53(x)

# 316 "bc/src/syntax.c"
          v = o ; 
          while (same -- ) {
#           define XfOrM56_COUNT (0+XfOrM54_COUNT)
#           define SETUP_XfOrM56(x) SETUP_XfOrM54(x)

# 318 "bc/src/syntax.c"
            p = FUNCCALL(SETUP_XfOrM56(_), scheme_make_pair ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) , scheme_null ) ); 
            if (last )
              (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = p ; 
            else 
            first = p ; 
            last = p ; 
            v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
          }
        }

        p = FUNCCALL(SETUP_XfOrM53(_), scheme_make_pair (a , scheme_null ) ); 

        if (last )
          (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = p ; 
        else 
        first = p ; 
        last = p ; 
        v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
      }
    }
    if (! ((v ) == (scheme_null ) ) ) {
#     define XfOrM42_COUNT (0+XfOrM41_COUNT)
#     define SETUP_XfOrM42(x) SETUP_XfOrM41(x)

# 339 "bc/src/syntax.c"
      a = FUNCCALL(SETUP_XfOrM42(_), syntax_to_datum_inner (v ) ); 
      if (! first && ((v ) == (a ) ) )
        RET_VALUE_START (o ) RET_VALUE_END ; 
      else {
#       define XfOrM43_COUNT (0+XfOrM42_COUNT)
#       define SETUP_XfOrM43(x) SETUP_XfOrM42(x)

# 343 "bc/src/syntax.c"
        v = o ; 
        while (same -- ) {
#         define XfOrM45_COUNT (0+XfOrM43_COUNT)
#         define SETUP_XfOrM45(x) SETUP_XfOrM43(x)

# 345 "bc/src/syntax.c"
          p = FUNCCALL(SETUP_XfOrM45(_), scheme_make_pair ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) , scheme_null ) ); 
          if (last )
            (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = p ; 
          else 
          first = p ; 
          last = p ; 
          v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
        }

        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = a ; 
      }
    }

# 356 "bc/src/syntax.c"
    else if (! first )
      RET_VALUE_START (o ) RET_VALUE_END ; 

    result = first ; 
  }

# 360 "bc/src/syntax.c"
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) )  {
#   define XfOrM40_COUNT (0+XfOrM20_COUNT)
#   define SETUP_XfOrM40(x) SETUP_XfOrM20(x)

# 361 "bc/src/syntax.c"
    v = FUNCCALL(SETUP_XfOrM40(_), syntax_to_datum_inner ((((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) ) ); 
    if (v == (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) )
      RET_VALUE_START (o ) RET_VALUE_END ; 
    result = FUNCCALL(SETUP_XfOrM40(_), scheme_box (v ) ); 
    ((((Scheme_Inclhash_Object * ) (result ) ) -> so . keyex |= 0x1 ) ) ; 
  }

# 366 "bc/src/syntax.c"
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
    int size = (((Scheme_Vector * ) (v ) ) -> size ) , i , j ; 
    Scheme_Object * r , * a ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM20_COUNT), PUSH(a, 1+XfOrM20_COUNT)));
#   define XfOrM33_COUNT (2+XfOrM20_COUNT)
#   define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
    r = NULLED_OUT ; 
    a = NULLED_OUT ; 

# 370 "bc/src/syntax.c"
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM39_COUNT (0+XfOrM33_COUNT)
#     define SETUP_XfOrM39(x) SETUP_XfOrM33(x)

# 371 "bc/src/syntax.c"
      a = FUNCCALL(SETUP_XfOrM39(_), syntax_to_datum_inner ((((Scheme_Vector * ) (v ) ) -> els ) [i ] ) ); 
      if (! ((a ) == ((((Scheme_Vector * ) (v ) ) -> els ) [i ] ) ) )
        break ; 
    }

    if (i >= size )
      RET_VALUE_START (o ) RET_VALUE_END ; 

    r = FUNCCALL(SETUP_XfOrM33(_), scheme_make_vector (size , ((void * ) 0 ) ) ); 

    for (j = 0 ; j < i ; j ++ ) {
      (((Scheme_Vector * ) (r ) ) -> els ) [j ] = (((Scheme_Vector * ) (v ) ) -> els ) [j ] ; 
    }
    (((Scheme_Vector * ) (r ) ) -> els ) [i ] = a ; 
    for (i ++ ; i < size ; i ++ ) {
#     define XfOrM35_COUNT (0+XfOrM33_COUNT)
#     define SETUP_XfOrM35(x) SETUP_XfOrM33(x)

# 386 "bc/src/syntax.c"
      a = FUNCCALL(SETUP_XfOrM35(_), syntax_to_datum_inner ((((Scheme_Vector * ) (v ) ) -> els ) [i ] ) ); 
      (((Scheme_Vector * ) (r ) ) -> els ) [i ] = a ; 
    }

    result = r ; 
    ((((Scheme_Inclhash_Object * ) (result ) ) -> so . keyex |= 0x1 ) ) ; 
  }

# 392 "bc/src/syntax.c"
  else if ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    Scheme_Hash_Tree * ht = (Scheme_Hash_Tree * ) v , * ht2 ; 
    Scheme_Object * key , * val , * val2 ; 
    mzlonglong i , j ; 
    BLOCK_SETUP((PUSH(ht2, 0+XfOrM20_COUNT), PUSH(key, 1+XfOrM20_COUNT), PUSH(ht, 2+XfOrM20_COUNT), PUSH(val, 3+XfOrM20_COUNT), PUSH(val2, 4+XfOrM20_COUNT)));
#   define XfOrM26_COUNT (5+XfOrM20_COUNT)
#   define SETUP_XfOrM26(x) SETUP(XfOrM26_COUNT)
    ht2 = NULLED_OUT ; 
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 
    val2 = NULLED_OUT ; 

# 397 "bc/src/syntax.c"
    i = (scheme_hash_tree_next (ht , - 1 ) ) ; 
    while (i != - 1 ) {
#     define XfOrM32_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM32(x) SETUP_XfOrM26(x)
      (
# 399 "bc/src/syntax.c"
      scheme_hash_tree_index (ht , i , & key , & val ) ) ; 
      val2 = FUNCCALL(SETUP_XfOrM32(_), syntax_to_datum_inner (val ) ); 
      if (! ((val ) == (val2 ) ) )
        break ; 
      i = (scheme_hash_tree_next (ht , i ) ) ; 
    }
    if (i == - 1 )
      RET_VALUE_START (o ) RET_VALUE_END ; 

    ht2 = FUNCCALL(SETUP_XfOrM26(_), scheme_make_hash_tree_of_type ((((Scheme_Type ) (((((intptr_t ) (ht ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ht ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) ht ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) ht ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (ht ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ht ) ) -> type ) ) ) ); 

    j = (scheme_hash_tree_next (ht , - 1 ) ) ; 
    while (j != i ) {
#     define XfOrM30_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM30(x) SETUP_XfOrM26(x)
      (
# 412 "bc/src/syntax.c"
      scheme_hash_tree_index (ht , j , & key , & val ) ) ; 
      val = FUNCCALL(SETUP_XfOrM30(_), syntax_to_datum_inner (val ) ); 
      ht2 = FUNCCALL_AGAIN(scheme_hash_tree_set (ht2 , key , val ) ); 
      j = (scheme_hash_tree_next (ht , j ) ) ; 
    }
    (
    scheme_hash_tree_index (ht , i , & key , & val ) ) ; 
    ht2 = FUNCCALL(SETUP_XfOrM26(_), scheme_hash_tree_set (ht2 , key , val2 ) ); 

    i = (scheme_hash_tree_next (ht , i ) ) ; 
    while (i != - 1 ) {
#     define XfOrM28_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM28(x) SETUP_XfOrM26(x)
      (
# 423 "bc/src/syntax.c"
      scheme_hash_tree_index (ht , i , & key , & val ) ) ; 
      val = FUNCCALL(SETUP_XfOrM28(_), syntax_to_datum_inner (val ) ); 
      ht2 = FUNCCALL_AGAIN(scheme_hash_tree_set (ht2 , key , val ) ); 
      i = (scheme_hash_tree_next (ht , i ) ) ; 
    }

    result = (Scheme_Object * ) ht2 ; 
  }

# 430 "bc/src/syntax.c"
  else if (prefab_p (v ) )  {
    Scheme_Structure * s = (Scheme_Structure * ) v ; 
    Scheme_Object * a ; 
    int size = s -> stype -> num_slots , i ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM20_COUNT), PUSH(a, 1+XfOrM20_COUNT)));
#   define XfOrM21_COUNT (2+XfOrM20_COUNT)
#   define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
    a = NULLED_OUT ; 

# 435 "bc/src/syntax.c"
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM25_COUNT (0+XfOrM21_COUNT)
#     define SETUP_XfOrM25(x) SETUP_XfOrM21(x)

# 436 "bc/src/syntax.c"
      a = FUNCCALL(SETUP_XfOrM25(_), syntax_to_datum_inner (s -> slots [i ] ) ); 
      if (! ((a ) == (s -> slots [i ] ) ) )
        break ; 
    }
    if (i >= size )
      RET_VALUE_START (o ) RET_VALUE_END ; 

    s = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM21(_), scheme_clone_prefab_struct_instance (s ) ); 
    s -> slots [i ] = a ; 
    for (i ++ ; i < size ; i ++ ) {
#     define XfOrM23_COUNT (0+XfOrM21_COUNT)
#     define SETUP_XfOrM23(x) SETUP_XfOrM21(x)

# 446 "bc/src/syntax.c"
      a = FUNCCALL(SETUP_XfOrM23(_), syntax_to_datum_inner (s -> slots [i ] ) ); 
      s -> slots [i ] = a ; 
    }

    result = (Scheme_Object * ) s ; 
  }

# 451 "bc/src/syntax.c"
  else 
  result = v ; 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 457 "bc/src/syntax.c"
Scheme_Object * scheme_syntax_to_datum (Scheme_Object * stx ) 
{
  /* No conversion */

# 459 "bc/src/syntax.c"
  return syntax_to_datum_inner (stx ) ; 
}








static Scheme_Object * datum_to_syntax_k (void ) 
{
  /* No conversion */

# 471 "bc/src/syntax.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Stx * stx_src = (Scheme_Stx * ) p -> ku . k . p2 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return datum_to_syntax_inner (o , stx_src , ht ) ; 
}


static Scheme_Object * datum_to_syntax_inner (Scheme_Object * o , 
Scheme_Stx * stx_src , 
Scheme_Hash_Table * ht ) 
{
  Scheme_Object * result , * hashed ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(stx_src, 0), PUSH(hashed, 1), PUSH(ht, 2), PUSH(result, 3), PUSH(o, 4)));
# define XfOrM64_COUNT (5)
# define SETUP_XfOrM64(x) SETUP(XfOrM64_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  result = NULLED_OUT ; 
  hashed = NULLED_OUT ; 

# 490 "bc/src/syntax.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
    RET_VALUE_START (o ) RET_VALUE_END ; 


  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM92_COUNT (0+XfOrM64_COUNT)
#   define SETUP_XfOrM92(x) SETUP_XfOrM64(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 496 "bc/src/syntax.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM93_COUNT (0+XfOrM92_COUNT)
#     define SETUP_XfOrM93(x) SETUP_XfOrM92(x)

# 498 "bc/src/syntax.c"
      p -> ku . k . p1 = (void * ) o ; 
      p -> ku . k . p2 = (void * ) stx_src ; 
      p -> ku . k . p3 = (void * ) ht ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (datum_to_syntax_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  {
#   define XfOrM90_COUNT (0+XfOrM64_COUNT)
#   define SETUP_XfOrM90(x) SETUP_XfOrM64(x)

# 506 "bc/src/syntax.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM91_COUNT (0+XfOrM90_COUNT)
#     define SETUP_XfOrM91(x) SETUP_XfOrM90(x)
      FUNCCALL(SETUP_XfOrM91(_), scheme_out_of_fuel () )
# 506 "bc/src/syntax.c"
      ; 
    }
  }

# 506 "bc/src/syntax.c"
  ; 

  if (ht ) {
#   define XfOrM87_COUNT (0+XfOrM64_COUNT)
#   define SETUP_XfOrM87(x) SETUP_XfOrM64(x)

# 509 "bc/src/syntax.c"
    if ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || (prefab_p (o ) ) || ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || (prefab_p ((((Scheme_Chaperone * ) o ) -> val ) ) ) || ((((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) ) )  {
#     define XfOrM88_COUNT (0+XfOrM87_COUNT)
#     define SETUP_XfOrM88(x) SETUP_XfOrM87(x)

# 510 "bc/src/syntax.c"
      if (FUNCCALL(SETUP_XfOrM88(_), scheme_hash_get (ht , o ) )) {

        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      FUNCCALL(SETUP_XfOrM88(_), scheme_hash_set (ht , o , scheme_true ) )
      ; 
      hashed = o ; 
    }

# 517 "bc/src/syntax.c"
    else 
    hashed = ((void * ) 0 ) ; 
  }

# 519 "bc/src/syntax.c"
  else 
  hashed = ((void * ) 0 ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * first = ((void * ) 0 ) , * last = ((void * ) 0 ) , * p ; 
    BLOCK_SETUP((PUSH(last, 0+XfOrM64_COUNT), PUSH(first, 1+XfOrM64_COUNT), PUSH(p, 2+XfOrM64_COUNT)));
#   define XfOrM75_COUNT (3+XfOrM64_COUNT)
#   define SETUP_XfOrM75(x) SETUP(XfOrM75_COUNT)
    p = NULLED_OUT ; 

# 527 "bc/src/syntax.c"
    p = o ; 
    while (((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      if (! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
        break ; 
      p = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ; 
    }
    if (((p ) == (scheme_null ) ) || ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ) {
      result = o ; 
    }

# 535 "bc/src/syntax.c"
    else {
#     define XfOrM76_COUNT (0+XfOrM75_COUNT)
#     define SETUP_XfOrM76(x) SETUP_XfOrM75(x)

# 537 "bc/src/syntax.c"
      while (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
        Scheme_Object * a ; 
        BLOCK_SETUP((PUSH(a, 0+XfOrM76_COUNT)));
#       define XfOrM81_COUNT (1+XfOrM76_COUNT)
#       define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
        a = NULLED_OUT ; 

# 540 "bc/src/syntax.c"
        if (ht && last ) {
#         define XfOrM82_COUNT (0+XfOrM81_COUNT)
#         define SETUP_XfOrM82(x) SETUP_XfOrM81(x)

# 541 "bc/src/syntax.c"
          if (FUNCCALL(SETUP_XfOrM82(_), scheme_hash_get (ht , o ) )) {

            break ; 
          }
        }

        a = FUNCCALL(SETUP_XfOrM81(_), datum_to_syntax_inner ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) , stx_src , ht ) ); 
        if (! a )

# 548 "bc/src/syntax.c"
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

        p = FUNCCALL(SETUP_XfOrM81(_), scheme_make_pair (a , scheme_null ) ); 

        if (last )
          (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = p ; 
        else 
        first = p ; 
        last = p ; 
        o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
      }
      if (! first )

# 559 "bc/src/syntax.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      if (! ((o ) == (scheme_null ) ) ) {
#       define XfOrM77_COUNT (0+XfOrM76_COUNT)
#       define SETUP_XfOrM77(x) SETUP_XfOrM76(x)

# 561 "bc/src/syntax.c"
        o = FUNCCALL(SETUP_XfOrM77(_), datum_to_syntax_inner (o , stx_src , ht ) ); 
        if (! o )

# 562 "bc/src/syntax.c"
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = o ; 
      }

      result = first ; 
    }
  }

# 568 "bc/src/syntax.c"
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) )  {
#   define XfOrM74_COUNT (0+XfOrM64_COUNT)
#   define SETUP_XfOrM74(x) SETUP_XfOrM64(x)

# 569 "bc/src/syntax.c"
    if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      o = FUNCCALL(SETUP_XfOrM74(_), scheme_unbox (o ) ); 
    else 
    o = (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) ; 

    o = FUNCCALL(SETUP_XfOrM74(_), datum_to_syntax_inner (o , stx_src , ht ) ); 
    if (! o )

# 575 "bc/src/syntax.c"
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    result = FUNCCALL(SETUP_XfOrM74(_), scheme_box (o ) ); 
    ((((Scheme_Inclhash_Object * ) (result ) ) -> so . keyex |= 0x1 ) ) ; 
  }

# 578 "bc/src/syntax.c"
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) )  {
    int size , i ; 
    Scheme_Object * a , * oo ; 
    BLOCK_SETUP((PUSH(oo, 0+XfOrM64_COUNT), PUSH(a, 1+XfOrM64_COUNT)));
#   define XfOrM71_COUNT (2+XfOrM64_COUNT)
#   define SETUP_XfOrM71(x) SETUP(XfOrM71_COUNT)
    a = NULLED_OUT ; 
    oo = NULLED_OUT ; 

# 582 "bc/src/syntax.c"
    oo = o ; 
    if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      o = (((Scheme_Chaperone * ) o ) -> val ) ; 
    size = (((Scheme_Vector * ) (o ) ) -> size ) ; 

    result = FUNCCALL(SETUP_XfOrM71(_), scheme_make_vector (size , ((void * ) 0 ) ) ); 

    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM73_COUNT (0+XfOrM71_COUNT)
#     define SETUP_XfOrM73(x) SETUP_XfOrM71(x)

# 590 "bc/src/syntax.c"
      if ((o ) == (oo ) ) 
        a = (((Scheme_Vector * ) (o ) ) -> els ) [i ] ; 
      else 
      a = FUNCCALL(SETUP_XfOrM73(_), scheme_chaperone_vector_ref (oo , i ) ); 
      a = FUNCCALL(SETUP_XfOrM73(_), datum_to_syntax_inner (a , stx_src , ht ) ); 
      if (! a )

# 595 "bc/src/syntax.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      (((Scheme_Vector * ) (result ) ) -> els ) [i ] = a ; 
    }

    ((((Scheme_Inclhash_Object * ) (result ) ) -> so . keyex |= 0x1 ) ) ; 
  }

# 600 "bc/src/syntax.c"
  else if (((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) )  {
    Scheme_Hash_Tree * ht1 , * ht2 ; 
    Scheme_Object * key , * val ; 
    mzlonglong i ; 
    BLOCK_SETUP((PUSH(ht2, 0+XfOrM64_COUNT), PUSH(ht1, 1+XfOrM64_COUNT), PUSH(key, 2+XfOrM64_COUNT), PUSH(val, 3+XfOrM64_COUNT)));
#   define XfOrM68_COUNT (4+XfOrM64_COUNT)
#   define SETUP_XfOrM68(x) SETUP(XfOrM68_COUNT)
    ht1 = NULLED_OUT ; 
    ht2 = NULLED_OUT ; 
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 

# 605 "bc/src/syntax.c"
    if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      ht1 = (Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) o ) -> val ) ; 
    else 
    ht1 = (Scheme_Hash_Tree * ) o ; 

    ht2 = FUNCCALL(SETUP_XfOrM68(_), scheme_make_hash_tree_of_type ((((Scheme_Type ) (((((intptr_t ) (ht1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ht1 ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) ht1 ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) ht1 ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (ht1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ht1 ) ) -> type ) ) ) ); 

    i = (scheme_hash_tree_next (ht1 , - 1 ) ) ; 
    while (i != - 1 ) {
#     define XfOrM70_COUNT (0+XfOrM68_COUNT)
#     define SETUP_XfOrM70(x) SETUP_XfOrM68(x)
      (
# 614 "bc/src/syntax.c"
      scheme_hash_tree_index (ht1 , i , & key , & val ) ) ; 
      if (! (((Scheme_Object * ) ht1 ) == (o ) ) )
        val = FUNCCALL(SETUP_XfOrM70(_), scheme_chaperone_hash_traversal_get (o , key , & key ) ); 
      val = FUNCCALL(SETUP_XfOrM70(_), datum_to_syntax_inner (val , stx_src , ht ) ); 
      if (! val )

# 618 "bc/src/syntax.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      ht2 = FUNCCALL(SETUP_XfOrM70(_), scheme_hash_tree_set (ht2 , key , val ) ); 
      i = (scheme_hash_tree_next (ht1 , i ) ) ; 
    }

    result = (Scheme_Object * ) ht2 ; 
  }

# 624 "bc/src/syntax.c"
  else if ((prefab_p (o ) ) || ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (prefab_p ((((Scheme_Chaperone * ) o ) -> val ) ) ) ) ) {
    Scheme_Structure * s ; 
    Scheme_Object * a ; 
    int size , i ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM64_COUNT), PUSH(a, 1+XfOrM64_COUNT)));
#   define XfOrM65_COUNT (2+XfOrM64_COUNT)
#   define SETUP_XfOrM65(x) SETUP(XfOrM65_COUNT)
    s = NULLED_OUT ; 
    a = NULLED_OUT ; 

# 629 "bc/src/syntax.c"
    s = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM65(_), scheme_clone_prefab_struct_instance ((Scheme_Structure * ) o ) ); 
    size = s -> stype -> num_slots ; 

    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM67_COUNT (0+XfOrM65_COUNT)
#     define SETUP_XfOrM67(x) SETUP_XfOrM65(x)

# 633 "bc/src/syntax.c"
      a = FUNCCALL(SETUP_XfOrM67(_), datum_to_syntax_inner (s -> slots [i ] , stx_src , ht ) ); 
      if (! a )

# 634 "bc/src/syntax.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      s -> slots [i ] = a ; 
    }

    result = (Scheme_Object * ) s ; 
  }

# 639 "bc/src/syntax.c"
  else 
  result = FUNCCALL(SETUP_XfOrM64(_), scheme_read_intern (o ) ); 

  if ((((Scheme_Object * ) stx_src ) ) == (scheme_false ) ) 
    result = FUNCCALL(SETUP_XfOrM64(_), scheme_make_stx (result , empty_srcloc , ((void * ) 0 ) ) ); 
  else 
  result = FUNCCALL(SETUP_XfOrM64(_), scheme_make_stx (result , stx_src -> srcloc , ((void * ) 0 ) ) ); 

  if (hashed )
    FUNCCALL(SETUP_XfOrM64(_), scheme_hash_set (ht , hashed , ((void * ) 0 ) ) ); 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/syntax.c"
static int quick_check_graph (Scheme_Object * o , int fuel ) 
{

# 653 "bc/src/syntax.c"
  int __funcarg67 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM94_COUNT (1)
# define SETUP_XfOrM94(x) SETUP(XfOrM94_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 655 "bc/src/syntax.c"
  if (! fuel )

# 655 "bc/src/syntax.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
    RET_VALUE_START ((__funcarg67 = FUNCCALL(SETUP_XfOrM94(_), quick_check_graph ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) , fuel - 1 ) ), FUNCCALL_EMPTY(quick_check_graph ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) , __funcarg67 ) )) ) RET_VALUE_END 
  ; 

  if ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || (prefab_p (o ) ) || ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || (prefab_p ((((Scheme_Chaperone * ) o ) -> val ) ) ) || ((((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) o ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) ) ) 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (fuel ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 667 "bc/src/syntax.c"
Scheme_Object * scheme_datum_to_syntax (Scheme_Object * o , 
Scheme_Object * stx_src , 
int flags ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(stx_src, 1), PUSH(o, 2)));
# define XfOrM95_COUNT (3)
# define SETUP_XfOrM95(x) SETUP(XfOrM95_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 673 "bc/src/syntax.c"
  if (! (((stx_src ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (stx_src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (stx_src ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    RET_VALUE_START (o ) RET_VALUE_END ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
    RET_VALUE_START (o ) RET_VALUE_END ; 

  if (flags & 0x4 ) {
    Scheme_Hash_Table * ht ; 
    BLOCK_SETUP((PUSH(ht, 0+XfOrM95_COUNT)));
#   define XfOrM96_COUNT (1+XfOrM95_COUNT)
#   define SETUP_XfOrM96(x) SETUP(XfOrM96_COUNT)
    ht = NULLED_OUT ; 

# 682 "bc/src/syntax.c"
    if ((flags & 0x2 ) && ! FUNCCALL(SETUP_XfOrM96(_), quick_check_graph (o , 10 ) ))
      ht = FUNCCALL(SETUP_XfOrM96(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    else 
    ht = ((void * ) 0 ) ; 

    v = FUNCCALL(SETUP_XfOrM96(_), datum_to_syntax_inner (o , (Scheme_Stx * ) stx_src , ht ) ); 

    if (! v ) {
#     define XfOrM97_COUNT (0+XfOrM96_COUNT)
#     define SETUP_XfOrM97(x) SETUP_XfOrM96(x)
      FUNCCALL_EMPTY(scheme_contract_error ("datum->syntax" , "cannot create syntax from cyclic datum" , "datum" , 1 , o , ((void * ) 0 ) ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 697 "bc/src/syntax.c"
  else if (((stx_src ) ) == (scheme_false ) ) 
    v = FUNCCALL(SETUP_XfOrM95(_), scheme_make_stx (o , empty_srcloc , ((void * ) 0 ) ) ); 
  else 
  v = FUNCCALL(SETUP_XfOrM95(_), scheme_make_stx (o , ((Scheme_Stx * ) stx_src ) -> srcloc , ((void * ) 0 ) ) ); 

  if (flags & 0x1 )
    ((Scheme_Stx * ) v ) -> props = ((Scheme_Stx * ) stx_src ) -> props ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * syntax_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 714 "bc/src/syntax.c"
  return ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * syntax_to_datum (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 719 "bc/src/syntax.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    scheme_wrong_contract ("syntax->datum" , "syntax?" , 0 , argc , argv ) ; 

  return scheme_syntax_to_datum (argv [0 ] ) ; 
}

static int nonneg_exact_or_false_p (Scheme_Object * o ) 
{
  /* No conversion */

# 727 "bc/src/syntax.c"
  return (((o ) ) == (scheme_false ) ) || scheme_nonneg_exact_p (o ) ; 
}

static int pos_exact_or_false_p (Scheme_Object * o ) 
{
  /* No conversion */

# 732 "bc/src/syntax.c"
  return ((((o ) ) == (scheme_false ) ) 
  || ((((intptr_t ) (o ) ) & 0x1 ) && ((((intptr_t ) (o ) ) >> 1 ) > 0 ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ) ) ; 
}

static Scheme_Object * datum_to_syntax (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * src = scheme_false ; 
  Scheme_Hash_Tree * properties = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(properties, 0), PUSH(argv, 1), PUSH(src, 2)));
# define XfOrM102_COUNT (3)
# define SETUP_XfOrM102(x) SETUP(XfOrM102_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 743 "bc/src/syntax.c"
  if (! (((argv [0 ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("datum->syntax" , "(or/c syntax? #f)" , 0 , argc , argv ) ); 

  if (argc > 2 ) {
    int ll ; 
#   define XfOrM104_COUNT (0+XfOrM102_COUNT)
#   define SETUP_XfOrM104(x) SETUP_XfOrM102(x)

# 749 "bc/src/syntax.c"
    src = argv [2 ] ; 

    ll = (scheme_proper_list_length (src ) ) ; 

    if (((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
#     define XfOrM113_COUNT (0+XfOrM104_COUNT)
#     define SETUP_XfOrM113(x) SETUP_XfOrM104(x)

# 754 "bc/src/syntax.c"
      src = (((Scheme_Chaperone * ) src ) -> val ) ; 
      if (((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && ((((Scheme_Vector * ) (src ) ) -> size ) == 5 ) ) {
        Scheme_Object * a ; 
        int i ; 
        BLOCK_SETUP((PUSH(a, 0+XfOrM113_COUNT)));
#       define XfOrM114_COUNT (1+XfOrM113_COUNT)
#       define SETUP_XfOrM114(x) SETUP(XfOrM114_COUNT)
        a = NULLED_OUT ; 

# 758 "bc/src/syntax.c"
        src = FUNCCALL(SETUP_XfOrM114(_), scheme_make_vector (5 , ((void * ) 0 ) ) ); 
        for (i = 0 ; i < 5 ; i ++ ) {
#         define XfOrM116_COUNT (0+XfOrM114_COUNT)
#         define SETUP_XfOrM116(x) SETUP_XfOrM114(x)

# 760 "bc/src/syntax.c"
          a = FUNCCALL(SETUP_XfOrM116(_), scheme_chaperone_vector_ref (argv [2 ] , i ) ); 
          (((Scheme_Vector * ) (src ) ) -> els ) [i ] = a ; 
        }
      }
    }

    if (! (((src ) ) == (scheme_false ) ) 
    && ! ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
    && ! (((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
    && ((((Scheme_Vector * ) (src ) ) -> size ) == 5 ) 
    && FUNCCALL(SETUP_XfOrM104(_), pos_exact_or_false_p ((((Scheme_Vector * ) (src ) ) -> els ) [1 ] ) )
    && FUNCCALL(SETUP_XfOrM104(_), nonneg_exact_or_false_p ((((Scheme_Vector * ) (src ) ) -> els ) [2 ] ) )
    && FUNCCALL(SETUP_XfOrM104(_), pos_exact_or_false_p ((((Scheme_Vector * ) (src ) ) -> els ) [3 ] ) )
    && FUNCCALL(SETUP_XfOrM104(_), nonneg_exact_or_false_p ((((Scheme_Vector * ) (src ) ) -> els ) [4 ] ) )) 
    && ! ((ll == 5 ) 
    && FUNCCALL(SETUP_XfOrM104(_), pos_exact_or_false_p (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) )
    && FUNCCALL(SETUP_XfOrM104(_), nonneg_exact_or_false_p (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) )
    && FUNCCALL(SETUP_XfOrM104(_), pos_exact_or_false_p (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) )
    && FUNCCALL(SETUP_XfOrM104(_), nonneg_exact_or_false_p (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) )) )
      FUNCCALL_EMPTY(scheme_wrong_type ("datum->syntax" , "syntax, source location vector or list, or #f" , 2 , argc , argv ) ); 

    if ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
      ll = 5 ; 

    if (argc > 3 ) {
#     define XfOrM109_COUNT (0+XfOrM104_COUNT)
#     define SETUP_XfOrM109(x) SETUP_XfOrM104(x)

# 785 "bc/src/syntax.c"
      if (! (((argv [3 ] ) ) == (scheme_false ) ) ) {
#       define XfOrM112_COUNT (0+XfOrM109_COUNT)
#       define SETUP_XfOrM112(x) SETUP_XfOrM109(x)

# 786 "bc/src/syntax.c"
        if (! ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract ("datum->syntax" , "(or/c syntax? #f)" , 3 , argc , argv ) ); 
        properties = ((Scheme_Stx * ) argv [3 ] ) -> props ; 
      }

      if (argc > 4 ) {
#       define XfOrM110_COUNT (0+XfOrM109_COUNT)
#       define SETUP_XfOrM110(x) SETUP_XfOrM109(x)

# 793 "bc/src/syntax.c"
        if (! (((argv [4 ] ) ) == (scheme_false ) ) ) {
#         define XfOrM111_COUNT (0+XfOrM110_COUNT)
#         define SETUP_XfOrM111(x) SETUP_XfOrM110(x)

# 794 "bc/src/syntax.c"
          if (! ((Scheme_Type ) (((((intptr_t ) (argv [4 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [4 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
            FUNCCALL_EMPTY(scheme_wrong_contract ("datum->syntax" , "(or/c syntax? #f)" , 4 , argc , argv ) ); 
        }
      }
    }

    if (ll == 5 ) {

      Scheme_Object * line , * col , * pos , * span ; 
#     define XfOrM105_COUNT (0+XfOrM104_COUNT)
#     define SETUP_XfOrM105(x) SETUP_XfOrM104(x)
      line = NULLED_OUT ; 
      col = NULLED_OUT ; 
      pos = NULLED_OUT ; 
      span = NULLED_OUT ; 

# 803 "bc/src/syntax.c"
      if ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
        line = (((Scheme_Vector * ) (src ) ) -> els ) [1 ] ; 
        col = (((Scheme_Vector * ) (src ) ) -> els ) [2 ] ; 
        pos = (((Scheme_Vector * ) (src ) ) -> els ) [3 ] ; 
        span = (((Scheme_Vector * ) (src ) ) -> els ) [4 ] ; 
        src = (((Scheme_Vector * ) (src ) ) -> els ) [0 ] ; 
      }

# 809 "bc/src/syntax.c"
      else {
        line = ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ; 
        col = ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ; 
        pos = ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ; 
        span = ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ; 
        src = (((Scheme_Simple_Object * ) (src ) ) -> u . pair_val . car ) ; 
      }

      if ((((line ) ) == (scheme_false ) ) != (((col ) ) == (scheme_false ) ) )
        FUNCCALL_EMPTY(scheme_contract_error ("datum->syntax" , "line and column positions must both be numbers or #f" , "in location" , 1 , argv [2 ] , ((void * ) 0 ) ) )


      ; 


      if (((Scheme_Type ) (((((intptr_t ) (line ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (line ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) || ((Scheme_Type ) (((((intptr_t ) (col ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (col ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
        line = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ; 
        col = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ; 
      }
      if ((Scheme_Type ) (((((intptr_t ) (pos ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pos ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
        pos = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ; 
      if (span && ((Scheme_Type ) (((((intptr_t ) (span ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (span ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
        span = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ; 

      src = FUNCCALL(SETUP_XfOrM105(_), scheme_make_stx_w_offset (scheme_false , (((line ) ) == (scheme_false ) ) ? - 1 : (((intptr_t ) (line ) ) >> 1 ) , (((col ) ) == (scheme_false ) ) ? - 1 : ((((intptr_t ) (col ) ) >> 1 ) + 1 ) , (((pos ) ) == (scheme_false ) ) ? - 1 : (((intptr_t ) (pos ) ) >> 1 ) , (((span ) ) == (scheme_false ) ) ? - 1 : (((intptr_t ) (span ) ) >> 1 ) , src , ((void * ) 0 ) ) )





      ; 
    }
  }

  if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) 
    RET_VALUE_START (argv [1 ] ) RET_VALUE_END ; 

  src = FUNCCALL(SETUP_XfOrM102(_), scheme_datum_to_syntax (argv [1 ] , src , 0x2 ) ); 

  if (properties ) {
    ((Scheme_Stx * ) src ) -> props = properties ; 
  }

  RET_VALUE_START (src ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 855 "bc/src/syntax.c"
Scheme_Object * scheme_checked_syntax_e (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 857 "bc/src/syntax.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    scheme_wrong_contract ("syntax-e" , "syntax?" , 0 , argc , argv ) ; 

  return ((Scheme_Stx * ) argv [0 ] ) -> val ; 
}

static Scheme_Object * syntax_line (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 865 "bc/src/syntax.c"
  Scheme_Stx * stx = (Scheme_Stx * ) argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    scheme_wrong_contract ("syntax-line" , "syntax?" , 0 , argc , argv ) ; 

  if (stx -> srcloc -> line < 0 )
    return scheme_false ; 
  else 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stx -> srcloc -> line ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * syntax_col (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 878 "bc/src/syntax.c"
  Scheme_Stx * stx = (Scheme_Stx * ) argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    scheme_wrong_contract ("syntax-column" , "syntax?" , 0 , argc , argv ) ; 

  if (stx -> srcloc -> col <= 0 )
    return scheme_false ; 
  else 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stx -> srcloc -> col - 1 ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * syntax_pos (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 891 "bc/src/syntax.c"
  Scheme_Stx * stx = (Scheme_Stx * ) argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    scheme_wrong_contract ("syntax-position" , "syntax?" , 0 , argc , argv ) ; 

  if (stx -> srcloc -> pos < 0 )
    return scheme_false ; 
  else 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stx -> srcloc -> pos ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * syntax_span (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 904 "bc/src/syntax.c"
  Scheme_Stx * stx = (Scheme_Stx * ) argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    scheme_wrong_contract ("syntax-span" , "syntax?" , 0 , argc , argv ) ; 

  if (stx -> srcloc -> span < 0 )
    return scheme_false ; 
  else 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stx -> srcloc -> span ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * syntax_src (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 917 "bc/src/syntax.c"
  Scheme_Stx * stx = (Scheme_Stx * ) argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    scheme_wrong_contract ("syntax-source" , "syntax?" , 0 , argc , argv ) ; 

  return stx -> srcloc -> src ; 
}

Scheme_Object * scheme_stx_property (Scheme_Object * _stx , 
Scheme_Object * key , 
Scheme_Object * val ) 
{
  Scheme_Stx * stx ; 
  Scheme_Hash_Tree * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(props, 0), PUSH(stx, 1), PUSH(key, 2), PUSH(val, 3)));
# define XfOrM123_COUNT (4)
# define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stx = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 932 "bc/src/syntax.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (_stx ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (_stx ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  stx = (Scheme_Stx * ) _stx ; 

  props = stx -> props ; 
  if (! props )
    props = empty_hash_tree ; 

  if (val ) {
#   define XfOrM125_COUNT (0+XfOrM123_COUNT)
#   define SETUP_XfOrM125(x) SETUP_XfOrM123(x)

# 942 "bc/src/syntax.c"
    props = FUNCCALL(SETUP_XfOrM125(_), scheme_hash_tree_set (props , key , val ) ); 
    stx = (Scheme_Stx * ) FUNCCALL(SETUP_XfOrM125(_), clone_stx ((Scheme_Object * ) stx , ((void * ) 0 ) ) ); 
    stx -> props = props ; 
    RET_VALUE_START ((Scheme_Object * ) stx ) RET_VALUE_END ; 
  }

# 946 "bc/src/syntax.c"
  else {
#   define XfOrM124_COUNT (0+XfOrM123_COUNT)
#   define SETUP_XfOrM124(x) SETUP_XfOrM123(x)

# 947 "bc/src/syntax.c"
    val = FUNCCALL(SETUP_XfOrM124(_), scheme_hash_tree_get (props , key ) ); 
    if (! val )
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    RET_VALUE_START (val ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 954 "bc/src/syntax.c"
static Scheme_Object * syntax_property (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 956 "bc/src/syntax.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    scheme_wrong_contract ("syntax-property" , "syntax?" , 0 , argc , argv ) ; 

  if (argc > 2 )
    return scheme_stx_property (argv [0 ] , argv [1 ] , argv [2 ] ) ; 
  else 
  return scheme_stx_property (argv [0 ] , argv [1 ] , ((void * ) 0 ) ) ; 
}

static Scheme_Object * syntax_property_keys (int argc , Scheme_Object * * argv ) 
{
  Scheme_Stx * stx ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(stx, 0)));
# define XfOrM127_COUNT (1)
# define SETUP_XfOrM127(x) SETUP(XfOrM127_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  stx = NULLED_OUT ; 

# 969 "bc/src/syntax.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("syntax-property-symbol-keys" , "syntax?" , 0 , argc , argv ) ); 

  stx = (Scheme_Stx * ) argv [0 ] ; 

  if (stx -> props ) {
    mzlonglong i ; 
    Scheme_Object * key , * l = scheme_null ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM127_COUNT), PUSH(key, 1+XfOrM127_COUNT)));
#   define XfOrM128_COUNT (2+XfOrM127_COUNT)
#   define SETUP_XfOrM128(x) SETUP(XfOrM128_COUNT)
    key = NULLED_OUT ; 

# 978 "bc/src/syntax.c"
    i = (scheme_hash_tree_next (stx -> props , - 1 ) ) ; 
    while (i != - 1 ) {
#     define XfOrM130_COUNT (0+XfOrM128_COUNT)
#     define SETUP_XfOrM130(x) SETUP_XfOrM128(x)
      (
# 980 "bc/src/syntax.c"
      scheme_hash_tree_index (stx -> props , i , & key , ((void * ) 0 ) ) ) ; 
      if (((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! ((& ((Scheme_Symbol * ) (key ) ) -> iso ) -> so . keyex & 0x3 ) )
        l = FUNCCALL(SETUP_XfOrM130(_), scheme_make_pair (key , l ) ); 
      i = (scheme_hash_tree_next (stx -> props , i ) ) ; 
    }

    RET_VALUE_START (l ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "bc/src/mzmark_syntax.inc"
static int mark_srcloc_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_srcloc_MARK (void * p , struct NewGC * gc ) {

  Scheme_Stx_Srcloc * s = (Scheme_Stx_Srcloc * ) p ; 
  GC_mark2 (& (s -> src ) , gc ) ; 

  return 0 ; 
}






static int mark_srcloc_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Stx_Srcloc * s = (Scheme_Stx_Srcloc * ) p ; 
  GC_fixup2 (& (s -> src ) , gc ) ; 

  return 0 ; 
}

# 1000 "bc/src/syntax.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_srcloc , mark_srcloc_SIZE , mark_srcloc_MARK , mark_srcloc_FIXUP , 1 , 0 ) ; 
}
