#include "precomp.h"

# 6 "bc/src/type.c"
Scheme_Equal_Proc * scheme_type_equals ; 
Scheme_Primary_Hash_Proc * scheme_type_hash1s ; 
Scheme_Secondary_Hash_Proc * scheme_type_hash2s ; 

static char * * type_names ; 
static Scheme_Type maxtype , allocmax ; 






static mzrt_mutex * type_array_mutex ; 




static void init_type_arrays () 
{
  /* No conversion */

# 25 "bc/src/type.c"
  intptr_t n ; 


  mzrt_mutex_create (& type_array_mutex ) ; 


  scheme_register_static ((void * ) & type_names , sizeof (type_names ) ) ; 
  scheme_register_static ((void * ) & scheme_type_equals , sizeof (scheme_type_equals ) ) ; 
  scheme_register_static ((void * ) & scheme_type_hash1s , sizeof (scheme_type_hash1s ) ) ; 
  scheme_register_static ((void * ) & scheme_type_hash2s , sizeof (scheme_type_hash2s ) ) ; 

  maxtype = _scheme_last_type_ ; 
  allocmax = maxtype + 100 ; 

  type_names = (char * * ) malloc (allocmax * sizeof (char * ) ) ; 
  memset (type_names , 0 , allocmax * sizeof (char * ) ) ; 

# 51 "bc/src/type.c"
  scheme_type_equals = (Scheme_Equal_Proc * ) malloc (allocmax * sizeof (Scheme_Equal_Proc ) ) ; 
  n = allocmax * sizeof (Scheme_Equal_Proc ) ; 
  memset (scheme_type_equals , 0 , n ) ; 

  scheme_type_hash1s = (Scheme_Primary_Hash_Proc * ) malloc (allocmax * sizeof (Scheme_Primary_Hash_Proc ) ) ; 
  n = allocmax * sizeof (Scheme_Primary_Hash_Proc ) ; 
  memset (scheme_type_hash1s , 0 , n ) ; 

  scheme_type_hash2s = (Scheme_Secondary_Hash_Proc * ) malloc (allocmax * sizeof (Scheme_Secondary_Hash_Proc ) ) ; 
  n = allocmax * sizeof (Scheme_Secondary_Hash_Proc ) ; 
  memset (scheme_type_hash2s , 0 , n ) ; 
}

void 
scheme_init_type () 
{
  /* No conversion */

# 67 "bc/src/type.c"
  if (! type_names )
    init_type_arrays () ; 



  type_names [scheme_true_type ] = "<true>" ; 
  type_names [scheme_false_type ] = "<false>" ; 
  type_names [scheme_char_type ] = "<char>" ; 
  type_names [scheme_local_type ] = "<local-code>" ; 
  type_names [scheme_local_unbox_type ] = "<local-unbox-code>" ; 
  type_names [scheme_variable_type ] = "<global-variable-code>" ; 
  type_names [scheme_toplevel_type ] = "<variable-code>" ; 
  type_names [scheme_static_toplevel_type ] = "<variable-code>" ; 
  type_names [scheme_application_type ] = "<application-code>" ; 
  type_names [scheme_application2_type ] = "<unary-application-code>" ; 
  type_names [scheme_application3_type ] = "<binary-application-code>" ; 
  type_names [scheme_ir_lambda_type ] = "<procedure-semi-code>" ; 
  type_names [scheme_lambda_type ] = "<procedure-code>" ; 
  type_names [scheme_branch_type ] = "<branch-code>" ; 
  type_names [scheme_sequence_type ] = "<sequence-code>" ; 
  type_names [scheme_with_cont_mark_type ] = "<with-continuation-mark-code>" ; 

  type_names [scheme_define_values_type ] = "<define-values-code>" ; 
  type_names [scheme_begin0_sequence_type ] = "<begin0-code>" ; 
  type_names [scheme_inline_variant_type ] = "<inline-variant-code>" ; 
  type_names [scheme_set_bang_type ] = "<set!-code>" ; 
  type_names [scheme_boxenv_type ] = "<boxenv-code>" ; 
  type_names [scheme_varref_form_type ] = "<varref-code>" ; 
  type_names [scheme_apply_values_type ] = "<apply-values-code>" ; 
  type_names [scheme_with_immed_mark_type ] = "<with-immediate-mark-code>" ; 
  type_names [scheme_case_lambda_sequence_type ] = "<case-lambda-code>" ; 

  type_names [scheme_let_value_type ] = "<let-value-code>" ; 
  type_names [scheme_let_void_type ] = "<let-void-code>" ; 
  type_names [scheme_ir_local_type ] = "<local-semi-code>" ; 
  type_names [scheme_ir_let_value_type ] = "<let-value-semi-code>" ; 
  type_names [scheme_ir_let_header_type ] = "<let-header-semi-code>" ; 
  type_names [scheme_ir_toplevel_type ] = "<variable-semi-code>" ; 
  type_names [scheme_letrec_type ] = "<letrec-code>" ; 
  type_names [scheme_let_one_type ] = "<let-one-code>" ; 
  type_names [scheme_quote_compilation_type ] = "<quote-code>" ; 

  type_names [scheme_linklet_type ] = "<linklet>" ; 
  type_names [scheme_instance_type ] = "<instance>" ; 
  type_names [scheme_linklet_bundle_type ] = "<linklet-bundle>" ; 

  type_names [scheme_eval_waiting_type ] = "<eval-waiting>" ; 
  type_names [scheme_void_type ] = "<void>" ; 
  type_names [scheme_prim_type ] = "<procedure>" ; 
  type_names [scheme_closed_prim_type ] = "<procedure>" ; 
  type_names [scheme_closure_type ] = "<procedure>" ; 
  type_names [scheme_native_closure_type ] = "<procedure>" ; 
  type_names [scheme_cont_type ] = "<continuation>" ; 
  type_names [scheme_tail_call_waiting_type ] = "<tail-call-waiting>" ; 
  type_names [scheme_null_type ] = "<empty-list>" ; 
  type_names [scheme_pair_type ] = "<pair>" ; 
  type_names [scheme_mutable_pair_type ] = "<mutable-pair>" ; 
  type_names [scheme_raw_pair_type ] = "<raw-pair>" ; 
  type_names [scheme_box_type ] = "<box>" ; 
  type_names [scheme_integer_type ] = "<fixnum-integer>" ; 
  type_names [scheme_double_type ] = "<inexact-number>" ; 
  type_names [scheme_long_double_type ] = "<extflonum>" ; 
  type_names [scheme_float_type ] = "<inexact-number*>" ; 
  type_names [scheme_undefined_type ] = "<unsafe-undefined>" ; 
  type_names [scheme_eof_type ] = "<eof>" ; 
  type_names [scheme_input_port_type ] = "<input-port>" ; 
  type_names [scheme_output_port_type ] = "<output-port>" ; 
  type_names [scheme_thread_type ] = "<thread>" ; 
  type_names [scheme_char_string_type ] = "<string>" ; 
  type_names [scheme_byte_string_type ] = "<byte-string>" ; 
  type_names [scheme_unix_path_type ] = "<unix-path>" ; 
  type_names [scheme_windows_path_type ] = "<windows-path>" ; 
  type_names [scheme_struct_property_type ] = "<struct-property>" ; 
  type_names [scheme_chaperone_property_type ] = "<chaperone-property>" ; 
  type_names [scheme_structure_type ] = "<struct>" ; 
  type_names [scheme_proc_chaperone_type ] = "<chaperone>" ; 
  type_names [scheme_chaperone_type ] = "<chaperone>" ; 



  type_names [scheme_proc_struct_type ] = "<struct>" ; 

  type_names [scheme_symbol_type ] = "<symbol>" ; 
  type_names [scheme_keyword_type ] = "<keyword>" ; 
  type_names [scheme_primitive_syntax_type ] = "<primitive-syntax>" ; 
  type_names [scheme_macro_type ] = "<macro>" ; 
  type_names [scheme_vector_type ] = "<vector>" ; 
  type_names [scheme_flvector_type ] = "<flvector>" ; 
  type_names [scheme_extflvector_type ] = "<extflvector>" ; 
  type_names [scheme_fxvector_type ] = "<fxvector>" ; 
  type_names [scheme_bignum_type ] = "<bignum-integer>" ; 
  type_names [scheme_escaping_cont_type ] = "<escape-continuation>" ; 
  type_names [scheme_sema_type ] = "<semaphore>" ; 
  type_names [scheme_channel_type ] = "<channel>" ; 
  type_names [scheme_channel_put_type ] = "<channel-put>" ; 
  type_names [scheme_hash_table_type ] = "<hash>" ; 
  type_names [scheme_hash_tree_type ] = "<hash>" ; 
  type_names [scheme_eq_hash_tree_type ] = "<hash>" ; 
  type_names [scheme_eqv_hash_tree_type ] = "<hash>" ; 
  type_names [scheme_equal_always_hash_tree_type ] = "<hash>" ; 
  type_names [scheme_hash_tree_indirection_type ] = "<hash>" ; 
  type_names [scheme_hash_tree_subtree_type ] = "<hash-node>" ; 
  type_names [scheme_hash_tree_collision_type ] = "<hash-node>" ; 
  type_names [scheme_bucket_table_type ] = "<hash>" ; 
  type_names [scheme_stencil_vector_type ] = "<stencil-vector>" ; 
  type_names [scheme_case_closure_type ] = "<procedure>" ; 
  type_names [scheme_placeholder_type ] = "<placeholder>" ; 
  type_names [scheme_table_placeholder_type ] = "<hash-table-placeholder>" ; 
  type_names [scheme_weak_box_type ] = "<weak-box>" ; 
  type_names [scheme_ephemeron_type ] = "<ephemeron>" ; 
  type_names [scheme_rational_type ] = "<fractional-number>" ; 
  type_names [scheme_complex_type ] = "<complex-number>" ; 
  type_names [scheme_struct_type_type ] = "<struct-type>" ; 
  type_names [scheme_listener_type ] = "<tcp-listener>" ; 
  type_names [scheme_tcp_accept_evt_type ] = "<tcp-accept-evt>" ; 
  type_names [scheme_filesystem_change_evt_type ] = "<filesystem-change-evt>" ; 
  type_names [scheme_env_type ] = "<env>" ; 
  type_names [scheme_config_type ] = "<parameterization>" ; 
  type_names [scheme_will_executor_type ] = "<will-executor>" ; 
  type_names [scheme_random_state_type ] = "<pseudo-random-generator>" ; 
  type_names [scheme_regexp_type ] = "<regexp>" ; 
  type_names [scheme_bucket_type ] = "<hash-table-bucket>" ; 
  type_names [scheme_prefix_type ] = "<runtime-prefix>" ; 
  type_names [scheme_readtable_type ] = "<readtable>" ; 

  type_names [scheme_svector_type ] = "<short-vector>" ; 

  type_names [scheme_custodian_type ] = "<custodian>" ; 
  type_names [scheme_cust_box_type ] = "<custodian-box>" ; 
  type_names [scheme_plumber_type ] = "<plumber>" ; 
  type_names [scheme_plumber_handle_type ] = "<plumber-flush-handle>" ; 
  type_names [scheme_cont_mark_set_type ] = "<continuation-mark-set>" ; 
  type_names [scheme_cont_mark_chain_type ] = "<chain>" ; 

  type_names [scheme_inspector_type ] = "<inspector>" ; 

  type_names [scheme_stx_type ] = "<correlated>" ; 

  type_names [scheme_subprocess_type ] = "<subprocess>" ; 

  type_names [scheme_cpointer_type ] = "<cpointer>" ; 

  type_names [scheme_security_guard_type ] = "<security-guard>" ; 

  type_names [scheme_indent_type ] = "<internal-indentation>" ; 

  type_names [scheme_udp_type ] = "<udp-socket>" ; 
  type_names [scheme_udp_evt_type ] = "<udp-socket-evt>" ; 

  type_names [scheme_evt_set_type ] = "<evt-set>" ; 
  type_names [scheme_wrap_evt_type ] = "<evt>" ; 
  type_names [scheme_handle_evt_type ] = "<evt>" ; 
  type_names [scheme_replace_evt_type ] = "<evt>" ; 
  type_names [scheme_nack_evt_type ] = "<evt>" ; 
  type_names [scheme_nack_guard_evt_type ] = "<evt>" ; 
  type_names [scheme_poll_evt_type ] = "<evt>" ; 
  type_names [scheme_semaphore_repost_type ] = "<semaphore-peek>" ; 
  type_names [scheme_alarm_type ] = "<alarm-evt>" ; 
  type_names [scheme_progress_evt_type ] = "<progress-evt>" ; 
  type_names [scheme_write_evt_type ] = "<write-evt>" ; 
  type_names [scheme_always_evt_type ] = "<always-evt>" ; 
  type_names [scheme_never_evt_type ] = "<never-evt>" ; 
  type_names [scheme_thread_recv_evt_type ] = "<thread-receive-evt>" ; 
  type_names [scheme_port_closed_evt_type ] = "<port-closed-evt>" ; 

  type_names [scheme_thread_resume_type ] = "<thread-resume-evt>" ; 
  type_names [scheme_thread_suspend_type ] = "<thread-suspend-evt>" ; 
  type_names [scheme_thread_dead_type ] = "<thread-dead-evt>" ; 

  type_names [scheme_thread_set_type ] = "<thread-set>" ; 
  type_names [scheme_thread_cell_type ] = "<thread-cell>" ; 
  type_names [scheme_thread_cell_values_type ] = "<thread-cell-values>" ; 

  type_names [scheme_prompt_tag_type ] = "<continuation-prompt-tag>" ; 
  type_names [scheme_continuation_mark_key_type ] = "<continuation-mark-key>" ; 

  type_names [scheme_string_converter_type ] = "<string-converter>" ; 

  type_names [scheme_channel_syncer_type ] = "<channel-syncer>" ; 

  type_names [scheme_global_ref_type ] = "<variable-reference>" ; 

  type_names [scheme_delay_syntax_type ] = "<on-demand-stub>" ; 

  type_names [scheme_logger_type ] = "<logger>" ; 
  type_names [scheme_log_reader_type ] = "<log-receiver>" ; 

  type_names [scheme_future_type ] = "<future>" ; 
  type_names [scheme_fsemaphore_type ] = "<fsemaphore>" ; 

  type_names [_scheme_values_types_ ] = "<resurrected>" ; 
  type_names [_scheme_ir_values_types_ ] = "<internal>" ; 

  type_names [scheme_place_type ] = "<place>" ; 
  type_names [scheme_place_async_channel_type ] = "<place-half-channel>" ; 
  type_names [scheme_place_bi_channel_type ] = "<place-channel>" ; 
  type_names [scheme_place_dead_type ] = "<place-dead-evt>" ; 

  type_names [scheme_phantom_bytes_type ] = "<phantom-bytes>" ; 

  type_names [scheme_environment_variables_type ] = "<environment-variables>" ; 

  type_names [scheme_prompt_type ] = "<prompt>" ; 
  type_names [scheme_startup_env_type ] = "<startup-env>" ; 
  type_names [scheme_ctype_type ] = "<ctype>" ; 

  type_names [scheme_unquoted_printing_string_type ] = "<unquoted-printing-string>" ; 

  type_names [scheme_thunk_for_continue_type ] = "<thunk-for-continue>" ; 


  type_names [scheme_rt_runstack ] = "<runstack>" ; 
  type_names [scheme_rt_meta_cont ] = "<meta-continuation>" ; 
  type_names [scheme_rt_weak_array ] = "<weak-array>" ; 
  type_names [scheme_rt_resolve_info ] = "<compile-resolve-frame>" ; 
  type_names [scheme_rt_unresolve_info ] = "<compile-unresolve-frame>" ; 
  type_names [scheme_rt_optimize_info ] = "<compile-optimize-frame>" ; 
  type_names [scheme_rt_ir_lambda_info ] = "<compile-lambda-info>" ; 
  type_names [scheme_deferred_expr_type ] = "<compile-letrec-check-deferred>" ; 
  type_names [scheme_will_be_lambda_type ] = "<compile-letrec-check-lambda>" ; 
  type_names [scheme_rt_indexed_string ] = "<string-port-data>" ; 
  type_names [scheme_rt_srcloc ] = "<srcloc>" ; 
  type_names [scheme_rt_comp_prefix ] = "<compile-prefix>" ; 
  type_names [scheme_rt_native_code ] = "<native-code>" ; 
  type_names [scheme_rt_native_code_plus_case ] = "<native-code+case>" ; 
  type_names [scheme_rt_sfs_info ] = "<compile-safe-for-space-frame>" ; 
  type_names [scheme_rt_letrec_check_frame ] = "<compile-letrec-check-frame>" ; 
  type_names [scheme_rt_saved_stack ] = "<saved-stack>" ; 
  type_names [scheme_rt_overflow_jmp ] = "<overflow-jump>" ; 
  type_names [scheme_rt_dyn_wind ] = "<dynamic-wind>" ; 
  type_names [scheme_rt_dyn_wind_info ] = "<dynamic-wind-info>" ; 
  type_names [scheme_rt_dyn_wind_cell ] = "<dynamic-wind-cell>" ; 
  type_names [scheme_rt_input_fd ] = "<input-fd>" ; 
  type_names [scheme_rt_pipe ] = "<pipe>" ; 
  type_names [scheme_rt_param_data ] = "<param-data>" ; 
  type_names [scheme_rt_will ] = "<will>" ; 
  type_names [scheme_rt_finalization ] = "<finalization>" ; 
  type_names [scheme_rt_finalizations ] = "<finalizations>" ; 
  type_names [scheme_thread_hop_type ] = "<thread-hop>" ; 
  type_names [scheme_rt_evt ] = "<internal-evt>" ; 
  type_names [scheme_rt_syncing ] = "<syncing-evt>" ; 
  type_names [scheme_rt_user_input ] = "<user-input>" ; 
  type_names [scheme_rt_user_output ] = "<user-output>" ; 
  type_names [scheme_rt_compact_port ] = "<compact-port>" ; 
  type_names [scheme_rt_rx_lazy_string ] = "<rx-lazy-string>" ; 
  type_names [scheme_rt_parameterization ] = "<internal-parameterization>" ; 
  type_names [scheme_rt_delay_load_info ] = "<delay-load-info>" ; 
  type_names [scheme_rt_validate_clearing ] = "<validate-clearing>" ; 
  type_names [scheme_rt_print_params ] = "<print-params>" ; 
  type_names [scheme_rt_comp_env ] = "<compiler-env>" ; 
}


Scheme_Type scheme_make_type (const char * name ) 
{
  Scheme_Type newtype ; 
  DECL_RET_SAVE (Scheme_Type ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(name, 0)));
# define XfOrM3_COUNT (1)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 324 "bc/src/type.c"
  if (! type_names )
    FUNCCALL(SETUP_XfOrM3(_), init_type_arrays () ); 
  FUNCCALL(SETUP_XfOrM3(_), mzrt_mutex_lock (type_array_mutex ) )

  ; 


  if (maxtype == allocmax ) {

    void * naya ; 
    intptr_t n ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM3_COUNT)));
#   define XfOrM5_COUNT (1+XfOrM3_COUNT)
#   define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
    naya = NULLED_OUT ; 

# 336 "bc/src/type.c"
    allocmax += 20 ; 

    naya = malloc (allocmax * sizeof (char * ) ) ; 
    (memcpy (naya , type_names , maxtype * sizeof (char * ) ) ) ; 
    (memset (naya , 0 , maxtype * sizeof (char * ) ) ) ; 
    FUNCCALL(SETUP_XfOrM5(_), free (type_names ) ); 
    type_names = (char * * ) naya ; 

    naya = malloc (n = allocmax * sizeof (Scheme_Equal_Proc ) ) ; 
    (memset (naya , 0 , n ) ) ; 
    (memcpy (naya , scheme_type_equals , maxtype * sizeof (Scheme_Equal_Proc ) ) ) ; 
    FUNCCALL(SETUP_XfOrM5(_), free (scheme_type_equals ) ); 
    scheme_type_equals = (Scheme_Equal_Proc * ) naya ; 

    naya = malloc (n = allocmax * sizeof (Scheme_Primary_Hash_Proc ) ) ; 
    (memset (naya , 0 , n ) ) ; 
    (memcpy (naya , scheme_type_hash1s , maxtype * sizeof (Scheme_Primary_Hash_Proc ) ) ) ; 
    FUNCCALL(SETUP_XfOrM5(_), free (scheme_type_hash1s ) ); 
    scheme_type_hash1s = (Scheme_Primary_Hash_Proc * ) naya ; 

    naya = malloc (n = allocmax * sizeof (Scheme_Secondary_Hash_Proc ) ) ; 
    (memset (naya , 0 , n ) ) ; 
    (memcpy (naya , scheme_type_hash2s , maxtype * sizeof (Scheme_Secondary_Hash_Proc ) ) ) ; 
    FUNCCALL(SETUP_XfOrM5(_), free (scheme_type_hash2s ) ); 
    scheme_type_hash2s = (Scheme_Secondary_Hash_Proc * ) naya ; 
  }





  {
    char * tn ; 
    int len ; 
#   define XfOrM4_COUNT (0+XfOrM3_COUNT)
#   define SETUP_XfOrM4(x) SETUP_XfOrM3(x)
    tn = NULLED_OUT ; 

# 370 "bc/src/type.c"
    len = strlen (name ) + 1 ; 
    tn = (char * ) malloc (len ) ; 
    (memcpy (tn , name , len ) ) ; 
    type_names [maxtype ] = tn ; 
  }

  newtype = maxtype ; 
  maxtype ++ ; 
  FUNCCALL_EMPTY(mzrt_mutex_unlock (type_array_mutex ) )

  ; 


  RET_VALUE_START (newtype ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 386 "bc/src/type.c"
char * scheme_get_type_name_or_null (Scheme_Type t ) 
{
  /* No conversion */

# 388 "bc/src/type.c"
  if (t < 0 || t >= maxtype )
    return "<bad-value>" ; 
  return type_names [t ] ; 
}

char * scheme_get_type_name (Scheme_Type t ) 
{
  char * s ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM7_COUNT (1)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 396 "bc/src/type.c"
  s = FUNCCALL(SETUP_XfOrM7(_), scheme_get_type_name_or_null (t ) ); 
  RET_VALUE_START (s ? s : "???" ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 400 "bc/src/type.c"
void scheme_set_type_equality (Scheme_Type t , 
Scheme_Equal_Proc f , 
Scheme_Primary_Hash_Proc hash1 , 
Scheme_Secondary_Hash_Proc hash2 ) 
{
  /* No conversion */

# 405 "bc/src/type.c"
  if (t < 0 || t >= maxtype )
    return ; 

  scheme_type_equals [t ] = f ; 
  scheme_type_hash1s [t ] = hash1 ; 
  scheme_type_hash2s [t ] = hash2 ; 
}

int scheme_num_types (void ) 
{
  /* No conversion */

# 415 "bc/src/type.c"
  return maxtype ; 
}







static int bad_trav_SIZE (void * p , struct NewGC * gc ) 
{
  printf ("Shouldn't get here.\n" ) ; 
  exit (1 ) ; 
}

static int bad_trav_MARK (void * p , struct NewGC * gc ) 
{
  printf ("Shouldn't get here.\n" ) ; 
  exit (1 ) ; 
}

static int bad_trav_FIXUP (void * p , struct NewGC * gc ) 
{
  printf ("Shouldn't get here.\n" ) ; 
  exit (1 ) ; 
}




static void MARK_cjs (Scheme_Continuation_Jump_State * cjs , struct NewGC * gc ) 
{
  GC_mark2 (& (cjs -> jumping_to_continuation ) , gc ) ; 
  GC_mark2 (& (cjs -> alt_full_continuation ) , gc ) ; 
  GC_mark2 (& (cjs -> val ) , gc ) ; 
}

static void FIXUP_cjs (Scheme_Continuation_Jump_State * cjs , struct NewGC * gc ) 
{
  GC_fixup2 (& (cjs -> jumping_to_continuation ) , gc ) ; 
  GC_fixup2 (& (cjs -> alt_full_continuation ) , gc ) ; 
  GC_fixup2 (& (cjs -> val ) , gc ) ; 
}

static void MARK_stack_state (Scheme_Stack_State * ss , struct NewGC * gc ) 
{
}

static void FIXUP_stack_state (Scheme_Stack_State * ss , struct NewGC * gc ) 
{
}

static void MARK_jmpup (Scheme_Jumpup_Buf * buf , struct NewGC * gc ) 
{
  GC_mark2 (& (buf -> stack_copy ) , gc ) ; 
  GC_mark2 (& (buf -> cont ) , gc ) ; 
  GC_mark2 (& (buf -> external_stack ) , gc ) ; 





  if (buf -> stack_copy )
    GC_mark2_variable_stack (buf -> gc_var_stack , 
  (intptr_t ) buf -> stack_copy - (intptr_t ) buf -> stack_from , 

  (char * ) buf -> stack_copy + buf -> stack_size , 
  buf -> stack_copy , 
  gc ) ; 
}

static void FIXUP_jmpup (Scheme_Jumpup_Buf * buf , struct NewGC * gc ) 
{
  void * new_stack ; 

  new_stack = GC_resolve (buf -> stack_copy ) ; 
  GC_fixup2 (& (buf -> stack_copy ) , gc ) ; 
  GC_fixup2 (& (buf -> cont ) , gc ) ; 
  GC_fixup2 (& (buf -> external_stack ) , gc ) ; 

  if (buf -> stack_copy )
    GC_fixup2_variable_stack (buf -> gc_var_stack , 
  (intptr_t ) new_stack - (intptr_t ) buf -> stack_from , 

  (char * ) new_stack + buf -> stack_size , 
  new_stack , 
  gc ) ; 
}

# 3 "bc/src/mzmark_type.inc"
static int variable_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int variable_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Bucket * b = (Scheme_Bucket * ) p ; 

  GC_mark2 (& (b -> key ) , gc ) ; 
  GC_mark2 (& (b -> val ) , gc ) ; 
  GC_mark2 (& (((Scheme_Bucket_With_Home * ) b ) -> home_link ) , gc ) ; 


  return 0 ; 
}






static int variable_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Bucket * b = (Scheme_Bucket * ) p ; 

  GC_fixup2 (& (b -> key ) , gc ) ; 
  GC_fixup2 (& (b -> val ) , gc ) ; 
  GC_fixup2 (& (((Scheme_Bucket_With_Home * ) b ) -> home_link ) , gc ) ; 


  return 0 ; 
}

# 49 "bc/src/mzmark_type.inc"
static int bucket_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int bucket_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Bucket * b = (Scheme_Bucket * ) p ; 

  GC_mark2 (& (b -> key ) , gc ) ; 
  GC_mark2 (& (b -> val ) , gc ) ; 


  return 0 ; 
}






static int bucket_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Bucket * b = (Scheme_Bucket * ) p ; 

  GC_fixup2 (& (b -> key ) , gc ) ; 
  GC_fixup2 (& (b -> val ) , gc ) ; 


  return 0 ; 
}

# 93 "bc/src/mzmark_type.inc"
static int local_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int local_obj_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int local_obj_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 127 "bc/src/mzmark_type.inc"
static int toplevel_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int toplevel_obj_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int toplevel_obj_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 161 "bc/src/mzmark_type.inc"
static int static_toplevel_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int static_toplevel_obj_MARK (void * p , struct NewGC * gc ) {

  GC_mark2 (& ((((Scheme_Toplevel * ) (p ) ) -> u . prefix ) ) , gc ) ; 

  return 0 ; 
}






static int static_toplevel_obj_FIXUP (void * p , struct NewGC * gc ) {

  GC_fixup2 (& ((((Scheme_Toplevel * ) (p ) ) -> u . prefix ) ) , gc ) ; 

  return 0 ; 
}

# 197 "bc/src/mzmark_type.inc"
static int cpointer_obj_SIZE (void * p , struct NewGC * gc ) {





  return 0 ; 
}


static int cpointer_obj_MARK (void * p , struct NewGC * gc ) {

  if (! ((& ((Scheme_Cptr * ) (p ) ) -> so ) -> so . keyex & 0x1 ) ) {
    GC_mark2 (& ((((Scheme_Cptr * ) (p ) ) -> val ) ) , gc ) ; 
  }
  GC_mark2 (& ((((Scheme_Cptr * ) (p ) ) -> type ) ) , gc ) ; 

  return 0 ; 
}








static int cpointer_obj_FIXUP (void * p , struct NewGC * gc ) {

  if (! ((& ((Scheme_Cptr * ) (p ) ) -> so ) -> so . keyex & 0x1 ) ) {
    GC_fixup2 (& ((((Scheme_Cptr * ) (p ) ) -> val ) ) , gc ) ; 
  }
  GC_fixup2 (& ((((Scheme_Cptr * ) (p ) ) -> type ) ) , gc ) ; 

  return 0 ; 
}

# 245 "bc/src/mzmark_type.inc"
static int twoptr_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int twoptr_obj_MARK (void * p , struct NewGC * gc ) {

  GC_mark2 (& ((((Scheme_Simple_Object * ) ((Scheme_Object * ) p ) ) -> u . two_ptr_val . ptr1 ) ) , gc ) ; 
  GC_mark2 (& ((((Scheme_Simple_Object * ) ((Scheme_Object * ) p ) ) -> u . two_ptr_val . ptr2 ) ) , gc ) ; 

  return 0 ; 
}






static int twoptr_obj_FIXUP (void * p , struct NewGC * gc ) {

  GC_fixup2 (& ((((Scheme_Simple_Object * ) ((Scheme_Object * ) p ) ) -> u . two_ptr_val . ptr1 ) ) , gc ) ; 
  GC_fixup2 (& ((((Scheme_Simple_Object * ) ((Scheme_Object * ) p ) ) -> u . two_ptr_val . ptr2 ) ) , gc ) ; 

  return 0 ; 
}

# 283 "bc/src/mzmark_type.inc"
static int iptr_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int iptr_obj_MARK (void * p , struct NewGC * gc ) {

  GC_mark2 (& ((((Scheme_Simple_Object * ) ((Scheme_Object * ) p ) ) -> u . ptr_int_val . ptr ) ) , gc ) ; 

  return 0 ; 
}






static int iptr_obj_FIXUP (void * p , struct NewGC * gc ) {

  GC_fixup2 (& ((((Scheme_Simple_Object * ) ((Scheme_Object * ) p ) ) -> u . ptr_int_val . ptr ) ) , gc ) ; 

  return 0 ; 
}

# 319 "bc/src/mzmark_type.inc"
static int small_object_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int small_object_MARK (void * p , struct NewGC * gc ) {

  GC_mark2 (& (((Scheme_Small_Object * ) p ) -> u . ptr_value ) , gc ) ; 


  return 0 ; 
}






static int small_object_FIXUP (void * p , struct NewGC * gc ) {

  GC_fixup2 (& (((Scheme_Small_Object * ) p ) -> u . ptr_value ) , gc ) ; 


  return 0 ; 
}

# 357 "bc/src/mzmark_type.inc"
static int small_atomic_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int small_atomic_obj_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int small_atomic_obj_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 391 "bc/src/mzmark_type.inc"
static int app_rec_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int app_rec_MARK (void * p , struct NewGC * gc ) {

  Scheme_App_Rec * r = (Scheme_App_Rec * ) p ; 

  int i = r -> num_args + 1 ; 
  while (i -- ) 
  GC_mark2 (& (r -> args [i ] ) , gc ) ; 


  return 0 ; 
}








static int app_rec_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_App_Rec * r = (Scheme_App_Rec * ) p ; 

  int i = r -> num_args + 1 ; 
  while (i -- ) 
  GC_fixup2 (& (r -> args [i ] ) , gc ) ; 


  return 0 ; 
}

# 445 "bc/src/mzmark_type.inc"
static int app2_rec_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int app2_rec_MARK (void * p , struct NewGC * gc ) {

  Scheme_App2_Rec * r = (Scheme_App2_Rec * ) p ; 
  GC_mark2 (& (r -> rator ) , gc ) ; 
  GC_mark2 (& (r -> rand ) , gc ) ; 


  return 0 ; 
}






static int app2_rec_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_App2_Rec * r = (Scheme_App2_Rec * ) p ; 
  GC_fixup2 (& (r -> rator ) , gc ) ; 
  GC_fixup2 (& (r -> rand ) , gc ) ; 


  return 0 ; 
}

# 487 "bc/src/mzmark_type.inc"
static int app3_rec_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int app3_rec_MARK (void * p , struct NewGC * gc ) {

  Scheme_App3_Rec * r = (Scheme_App3_Rec * ) p ; 
  GC_mark2 (& (r -> rator ) , gc ) ; 
  GC_mark2 (& (r -> rand1 ) , gc ) ; 
  GC_mark2 (& (r -> rand2 ) , gc ) ; 


  return 0 ; 
}






static int app3_rec_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_App3_Rec * r = (Scheme_App3_Rec * ) p ; 
  GC_fixup2 (& (r -> rator ) , gc ) ; 
  GC_fixup2 (& (r -> rand1 ) , gc ) ; 
  GC_fixup2 (& (r -> rand2 ) , gc ) ; 


  return 0 ; 
}

# 531 "bc/src/mzmark_type.inc"
static int seq_rec_SIZE (void * p , struct NewGC * gc ) {






  return 0 ; 
}


static int seq_rec_MARK (void * p , struct NewGC * gc ) {

  Scheme_Sequence * s = (Scheme_Sequence * ) p ; 

  int i = s -> count ; 
  while (i -- ) 
  GC_mark2 (& (s -> array [i ] ) , gc ) ; 


  return 0 ; 
}







static int seq_rec_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Sequence * s = (Scheme_Sequence * ) p ; 

  int i = s -> count ; 
  while (i -- ) 
  GC_fixup2 (& (s -> array [i ] ) , gc ) ; 


  return 0 ; 
}

# 582 "bc/src/mzmark_type.inc"
static int branch_rec_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int branch_rec_MARK (void * p , struct NewGC * gc ) {

  Scheme_Branch_Rec * b = (Scheme_Branch_Rec * ) p ; 

  GC_mark2 (& (b -> test ) , gc ) ; 
  GC_mark2 (& (b -> tbranch ) , gc ) ; 
  GC_mark2 (& (b -> fbranch ) , gc ) ; 


  return 0 ; 
}






static int branch_rec_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Branch_Rec * b = (Scheme_Branch_Rec * ) p ; 

  GC_fixup2 (& (b -> test ) , gc ) ; 
  GC_fixup2 (& (b -> tbranch ) , gc ) ; 
  GC_fixup2 (& (b -> fbranch ) , gc ) ; 


  return 0 ; 
}

# 628 "bc/src/mzmark_type.inc"
static int unclosed_proc_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int unclosed_proc_MARK (void * p , struct NewGC * gc ) {

  Scheme_Lambda * d = (Scheme_Lambda * ) p ; 

  GC_mark2 (& (d -> name ) , gc ) ; 
  GC_mark2 (& (d -> body ) , gc ) ; 
  GC_mark2 (& (d -> closure_map ) , gc ) ; 
  GC_mark2 (& (d -> tl_map ) , gc ) ; 






  return 0 ; 
}






static int unclosed_proc_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Lambda * d = (Scheme_Lambda * ) p ; 

  GC_fixup2 (& (d -> name ) , gc ) ; 
  GC_fixup2 (& (d -> body ) , gc ) ; 
  GC_fixup2 (& (d -> closure_map ) , gc ) ; 
  GC_fixup2 (& (d -> tl_map ) , gc ) ; 






  return 0 ; 
}

# 684 "bc/src/mzmark_type.inc"
static int let_value_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int let_value_MARK (void * p , struct NewGC * gc ) {

  Scheme_Let_Value * l = (Scheme_Let_Value * ) p ; 

  GC_mark2 (& (l -> value ) , gc ) ; 
  GC_mark2 (& (l -> body ) , gc ) ; 


  return 0 ; 
}






static int let_value_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Let_Value * l = (Scheme_Let_Value * ) p ; 

  GC_fixup2 (& (l -> value ) , gc ) ; 
  GC_fixup2 (& (l -> body ) , gc ) ; 


  return 0 ; 
}

# 728 "bc/src/mzmark_type.inc"
static int let_void_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int let_void_MARK (void * p , struct NewGC * gc ) {

  Scheme_Let_Void * l = (Scheme_Let_Void * ) p ; 

  GC_mark2 (& (l -> body ) , gc ) ; 


  return 0 ; 
}






static int let_void_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Let_Void * l = (Scheme_Let_Void * ) p ; 

  GC_fixup2 (& (l -> body ) , gc ) ; 


  return 0 ; 
}

# 770 "bc/src/mzmark_type.inc"
static int letrec_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int letrec_MARK (void * p , struct NewGC * gc ) {

  Scheme_Letrec * l = (Scheme_Letrec * ) p ; 

  GC_mark2 (& (l -> procs ) , gc ) ; 
  GC_mark2 (& (l -> body ) , gc ) ; 


  return 0 ; 
}






static int letrec_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Letrec * l = (Scheme_Letrec * ) p ; 

  GC_fixup2 (& (l -> procs ) , gc ) ; 
  GC_fixup2 (& (l -> body ) , gc ) ; 


  return 0 ; 
}

# 814 "bc/src/mzmark_type.inc"
static int let_one_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int let_one_MARK (void * p , struct NewGC * gc ) {

  Scheme_Let_One * l = (Scheme_Let_One * ) p ; 

  GC_mark2 (& (l -> value ) , gc ) ; 
  GC_mark2 (& (l -> body ) , gc ) ; 


  return 0 ; 
}






static int let_one_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Let_One * l = (Scheme_Let_One * ) p ; 

  GC_fixup2 (& (l -> value ) , gc ) ; 
  GC_fixup2 (& (l -> body ) , gc ) ; 


  return 0 ; 
}

# 858 "bc/src/mzmark_type.inc"
static int with_cont_mark_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int with_cont_mark_MARK (void * p , struct NewGC * gc ) {

  Scheme_With_Continuation_Mark * w = (Scheme_With_Continuation_Mark * ) p ; 

  GC_mark2 (& (w -> key ) , gc ) ; 
  GC_mark2 (& (w -> val ) , gc ) ; 
  GC_mark2 (& (w -> body ) , gc ) ; 


  return 0 ; 
}






static int with_cont_mark_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_With_Continuation_Mark * w = (Scheme_With_Continuation_Mark * ) p ; 

  GC_fixup2 (& (w -> key ) , gc ) ; 
  GC_fixup2 (& (w -> val ) , gc ) ; 
  GC_fixup2 (& (w -> body ) , gc ) ; 


  return 0 ; 
}

# 904 "bc/src/mzmark_type.inc"
static int ir_local_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int ir_local_MARK (void * p , struct NewGC * gc ) {

  Scheme_IR_Local * var = (Scheme_IR_Local * ) p ; 

  GC_mark2 (& (var -> name ) , gc ) ; 
  switch (var -> mode ) {
    case 1 : 
    GC_mark2 (& (var -> compile . use_box ) , gc ) ; 
    break ; 
    case 2 : 
    GC_mark2 (& (var -> letrec_check . frame ) , gc ) ; 
    break ; 
    case 3 : 
    GC_mark2 (& (var -> optimize . known_val ) , gc ) ; 
    GC_mark2 (& (var -> optimize . transitive_uses ) , gc ) ; 
    break ; 
    case 4 : 
    GC_mark2 (& (var -> resolve . lifted ) , gc ) ; 
    break ; 
    default : 
    break ; 
  }


  return 0 ; 
}






static int ir_local_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_IR_Local * var = (Scheme_IR_Local * ) p ; 

  GC_fixup2 (& (var -> name ) , gc ) ; 
  switch (var -> mode ) {
    case 1 : 
    GC_fixup2 (& (var -> compile . use_box ) , gc ) ; 
    break ; 
    case 2 : 
    GC_fixup2 (& (var -> letrec_check . frame ) , gc ) ; 
    break ; 
    case 3 : 
    GC_fixup2 (& (var -> optimize . known_val ) , gc ) ; 
    GC_fixup2 (& (var -> optimize . transitive_uses ) , gc ) ; 
    break ; 
    case 4 : 
    GC_fixup2 (& (var -> resolve . lifted ) , gc ) ; 
    break ; 
    default : 
    break ; 
  }


  return 0 ; 
}

# 980 "bc/src/mzmark_type.inc"
static int ir_toplevel_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int ir_toplevel_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int ir_toplevel_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 1014 "bc/src/mzmark_type.inc"
static int ir_let_value_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int ir_let_value_MARK (void * p , struct NewGC * gc ) {

  Scheme_IR_Let_Value * c = (Scheme_IR_Let_Value * ) p ; 

  GC_mark2 (& (c -> value ) , gc ) ; 
  GC_mark2 (& (c -> body ) , gc ) ; 
  GC_mark2 (& (c -> vars ) , gc ) ; 


  return 0 ; 
}






static int ir_let_value_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_IR_Let_Value * c = (Scheme_IR_Let_Value * ) p ; 

  GC_fixup2 (& (c -> value ) , gc ) ; 
  GC_fixup2 (& (c -> body ) , gc ) ; 
  GC_fixup2 (& (c -> vars ) , gc ) ; 


  return 0 ; 
}

# 1060 "bc/src/mzmark_type.inc"
static int let_header_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int let_header_MARK (void * p , struct NewGC * gc ) {

  Scheme_IR_Let_Header * h = (Scheme_IR_Let_Header * ) p ; 

  GC_mark2 (& (h -> body ) , gc ) ; 


  return 0 ; 
}






static int let_header_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_IR_Let_Header * h = (Scheme_IR_Let_Header * ) p ; 

  GC_fixup2 (& (h -> body ) , gc ) ; 


  return 0 ; 
}

# 1102 "bc/src/mzmark_type.inc"
static int set_bang_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int set_bang_MARK (void * p , struct NewGC * gc ) {

  Scheme_Set_Bang * b = (Scheme_Set_Bang * ) p ; 

  GC_mark2 (& (b -> var ) , gc ) ; 
  GC_mark2 (& (b -> val ) , gc ) ; 


  return 0 ; 
}






static int set_bang_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Set_Bang * b = (Scheme_Set_Bang * ) p ; 

  GC_fixup2 (& (b -> var ) , gc ) ; 
  GC_fixup2 (& (b -> val ) , gc ) ; 


  return 0 ; 
}

# 1146 "bc/src/mzmark_type.inc"
static int prim_proc_SIZE (void * p , struct NewGC * gc ) {

# 1157 "bc/src/mzmark_type.inc"
  return 0 ; 
}


static int prim_proc_MARK (void * p , struct NewGC * gc ) {

  Scheme_Primitive_Proc * prim = (Scheme_Primitive_Proc * ) p ; 

  GC_mark2 (& (prim -> name ) , gc ) ; 
  if (prim -> mina < 0 ) {
    GC_mark2 (& (prim -> mu . cases ) , gc ) ; 
  }
  if (prim -> pp . flags & 16 ) {
    Scheme_Primitive_Closure * cc = (Scheme_Primitive_Closure * ) prim ; 
    int i ; 
    for (i = cc -> count ; i -- ; ) {
      GC_mark2 (& (cc -> val [i ] ) , gc ) ; 
    }
  }


  return 0 ; 
}

# 1191 "bc/src/mzmark_type.inc"
static int prim_proc_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Primitive_Proc * prim = (Scheme_Primitive_Proc * ) p ; 

  GC_fixup2 (& (prim -> name ) , gc ) ; 
  if (prim -> mina < 0 ) {
    GC_fixup2 (& (prim -> mu . cases ) , gc ) ; 
  }
  if (prim -> pp . flags & 16 ) {
    Scheme_Primitive_Closure * cc = (Scheme_Primitive_Closure * ) prim ; 
    int i ; 
    for (i = cc -> count ; i -- ; ) {
      GC_fixup2 (& (cc -> val [i ] ) , gc ) ; 
    }
  }


  return 0 ; 
}

# 1225 "bc/src/mzmark_type.inc"
static int closed_prim_proc_SIZE (void * p , struct NewGC * gc ) {









  return 0 ; 
}


static int closed_prim_proc_MARK (void * p , struct NewGC * gc ) {

  Scheme_Closed_Primitive_Proc * c = (Scheme_Closed_Primitive_Proc * ) p ; 

  GC_mark2 (& (c -> name ) , gc ) ; 
  GC_mark2 (& ((((Scheme_Closed_Primitive_Proc * ) (c ) ) -> data ) ) , gc ) ; 
  if (c -> mina == - 2 ) {
    GC_mark2 (& (((Scheme_Closed_Case_Primitive_Proc * ) c ) -> cases ) , gc ) ; 
  }


  return 0 ; 
}

# 1262 "bc/src/mzmark_type.inc"
static int closed_prim_proc_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Closed_Primitive_Proc * c = (Scheme_Closed_Primitive_Proc * ) p ; 

  GC_fixup2 (& (c -> name ) , gc ) ; 
  GC_fixup2 (& ((((Scheme_Closed_Primitive_Proc * ) (c ) ) -> data ) ) , gc ) ; 
  if (c -> mina == - 2 ) {
    GC_fixup2 (& (((Scheme_Closed_Case_Primitive_Proc * ) c ) -> cases ) , gc ) ; 
  }


  return 0 ; 
}

# 1289 "bc/src/mzmark_type.inc"
static int scm_closure_SIZE (void * p , struct NewGC * gc ) {









  return 0 ; 
}


static int scm_closure_MARK (void * p , struct NewGC * gc ) {

  Scheme_Closure * c = (Scheme_Closure * ) p ; 
  int closure_size = (c -> code 
  ? ((Scheme_Lambda * ) GC_resolve2 (c -> code , gc ) ) -> closure_size 
  : 0 ) ; 


  int i = closure_size ; 

# 2 "bc/src/mzclpf_decl.inc"
  Scheme_Lambda * data ; 
  int gc_mode ; 

# 1315 "bc/src/mzmark_type.inc"
  GC_mark2 (& (c -> code ) , gc ) ; 

# 2 "bc/src/mzclpf_pre.inc"
  gc_mode = GC_current_mode (gc ) ; 
  if ((gc_mode != 5 ) 
  && c -> code ) {
    data = (Scheme_Lambda * ) GC_resolve2 (c -> code , gc ) ; 
    if (data -> tl_map ) {







      if ((gc_mode == 4 ) 
      || ! GC_is_marked2 (c -> vals [closure_size - 1 ] , gc ) ) {

        i -- ; 
      }

# 18 "bc/src/mzclpf_pre.inc"
      else 
      data = ((void * ) 0 ) ; 
    }

# 20 "bc/src/mzclpf_pre.inc"
    else 
    data = ((void * ) 0 ) ; 
  }

# 22 "bc/src/mzclpf_pre.inc"
  else 
  data = ((void * ) 0 ) ; 

# 1319 "bc/src/mzmark_type.inc"
  while (i -- ) 
  GC_mark2 (& (c -> vals [i ] ) , gc ) ; 

# 13 "bc/src/mzclpf_post.inc"
  if (data && (gc_mode != 4 ) ) {

    Scheme_Prefix * pf = (Scheme_Prefix * ) c -> vals [closure_size - 1 ] ; 

    if (pf ) {
      int * use_bits ; 
      uintptr_t map ; 


      pf = (Scheme_Prefix * ) GC_resolve2 (pf , gc ) ; 
      use_bits = (int * ) ((char * ) pf + sizeof (Scheme_Prefix ) + ((pf -> num_slots - 0 ) * sizeof (Scheme_Object * ) ) ) ; 

      if (! pf -> next_final ) {



        if ((gc_mode == 2 ) 
        || (gc_mode == 3 ) ) {
          pf -> next_final = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_inc_prefix_finalize_ ) ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_inc_prefix_finalize_ ) = pf ; 
        }

# 33 "bc/src/mzclpf_post.inc"
        else {
          pf -> next_final = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prefix_finalize_ ) ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prefix_finalize_ ) = pf ; 
        }
      }







      if (gc_mode != 2 ) {
        c -> vals [closure_size - 1 ] = pf -> fixup_chain ; 
        pf -> fixup_chain = (Scheme_Object * ) c ; 
      }

# 48 "bc/src/mzclpf_post.inc"
      else {


        (& (pf ) -> iso ) -> so . keyex |= 0x1 ; 
      }


      if ((uintptr_t ) data -> tl_map & 0x1 ) {
        map = (((uintptr_t ) data -> tl_map ) >> 1 ) & 0x7FFFFFFF ; 
        if ((use_bits [0 ] & map ) != map ) {
          for (i = 0 ; i < 31 ; i ++ ) {
            if (map & ((unsigned int ) 1 << i ) ) {
              if (! (use_bits [0 ] & ((unsigned int ) 1 << i ) ) ) {
                GC_mark2 (& (pf -> a [i ] ) , gc ) ; 
              }
            }
          }
          use_bits [0 ] |= map ; 
        }
      }

# 67 "bc/src/mzclpf_post.inc"
      else {
        int * u = (int * ) GC_resolve2 (data -> tl_map , gc ) , j , pos ; 

        for (i = u [0 ] ; i -- ; ) {
          map = u [i + 1 ] ; 
          if ((use_bits [i ] & map ) != map ) {
            for (j = 0 ; j < 32 ; j ++ ) {
              if (map & ((unsigned int ) 1 << j ) ) {
                if (! (use_bits [i ] & ((unsigned int ) 1 << j ) ) ) {
                  pos = (i * 32 ) + j ; 
                  GC_mark2 (& (pf -> a [pos ] ) , gc ) ; 
                }
              }
            }
            use_bits [i ] |= map ; 
          }
        }
      }
    }
  }

# 1326 "bc/src/mzmark_type.inc"
  return 0 ; 
}







static int scm_closure_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Closure * c = (Scheme_Closure * ) p ; 
  int closure_size = (c -> code 
  ? ((Scheme_Lambda * ) GC_resolve2 (c -> code , gc ) ) -> closure_size 
  : 0 ) ; 


  int i = closure_size ; 

  GC_fixup2 (& (c -> code ) , gc ) ; 


  while (i -- ) 
  GC_fixup2 (& (c -> vals [i ] ) , gc ) ; 



  return 0 ; 
}

# 1366 "bc/src/mzmark_type.inc"
static int case_closure_SIZE (void * p , struct NewGC * gc ) {






  return 0 ; 
}


static int case_closure_MARK (void * p , struct NewGC * gc ) {

  Scheme_Case_Lambda * c = (Scheme_Case_Lambda * ) p ; 

  int i ; 

  for (i = c -> count ; i -- ; ) 
  GC_mark2 (& (c -> array [i ] ) , gc ) ; 
  GC_mark2 (& (c -> name ) , gc ) ; 





  return 0 ; 
}







static int case_closure_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Case_Lambda * c = (Scheme_Case_Lambda * ) p ; 

  int i ; 

  for (i = c -> count ; i -- ; ) 
  GC_fixup2 (& (c -> array [i ] ) , gc ) ; 
  GC_fixup2 (& (c -> name ) , gc ) ; 





  return 0 ; 
}

# 1427 "bc/src/mzmark_type.inc"
static int cont_proc_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int cont_proc_MARK (void * p , struct NewGC * gc ) {

  Scheme_Cont * c = (Scheme_Cont * ) p ; 

  GC_mark2 (& (c -> dw ) , gc ) ; 
  GC_mark2 (& (c -> prompt_tag ) , gc ) ; 
  GC_mark2 (& (c -> meta_continuation ) , gc ) ; 
  GC_mark2 (& (c -> meta_continuation_src ) , gc ) ; 
  GC_mark2 (& (c -> common_dw ) , gc ) ; 
  GC_mark2 (& (c -> save_overflow ) , gc ) ; 
  GC_mark2 (& (c -> runstack_copied ) , gc ) ; 
  GC_mark2 (& (c -> runstack_owner ) , gc ) ; 
  GC_mark2 (& (c -> cont_mark_stack_copied ) , gc ) ; 
  GC_mark2 (& (c -> cont_mark_stack_owner ) , gc ) ; 
  GC_mark2 (& (c -> init_config ) , gc ) ; 
  GC_mark2 (& (c -> init_break_cell ) , gc ) ; 




  GC_mark2 (& (c -> buf_ptr ) , gc ) ; 
  MARK_cjs (& c -> cjs , gc ) ; 
  MARK_stack_state (& c -> ss , gc ) ; 
  GC_mark2 (& (c -> barrier_prompt ) , gc ) ; 
  if (! GC_merely_accounting () ) {
    GC_mark2 (& (c -> runstack_start ) , gc ) ; 
    GC_mark2 (& (c -> runstack_saved ) , gc ) ; 
  }

  GC_mark2 (& (c -> prompt_id ) , gc ) ; 
  GC_mark2 (& (c -> prompt_buf ) , gc ) ; 

  GC_mark2 (& (c -> escape_cont ) , gc ) ; 

  GC_mark2 (& (c -> value ) , gc ) ; 
  GC_mark2 (& (c -> resume_to ) , gc ) ; 
  GC_mark2 (& (c -> use_next_cont ) , gc ) ; 
  GC_mark2 (& (c -> extra_marks ) , gc ) ; 
  GC_mark2 (& (c -> shortcut_prompt ) , gc ) ; 


  return 0 ; 
}






static int cont_proc_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Cont * c = (Scheme_Cont * ) p ; 

  GC_fixup2 (& (c -> dw ) , gc ) ; 
  GC_fixup2 (& (c -> prompt_tag ) , gc ) ; 
  GC_fixup2 (& (c -> meta_continuation ) , gc ) ; 
  GC_fixup2 (& (c -> meta_continuation_src ) , gc ) ; 
  GC_fixup2 (& (c -> common_dw ) , gc ) ; 
  GC_fixup2 (& (c -> save_overflow ) , gc ) ; 
  GC_fixup2 (& (c -> runstack_copied ) , gc ) ; 
  GC_fixup2 (& (c -> runstack_owner ) , gc ) ; 
  GC_fixup2 (& (c -> cont_mark_stack_copied ) , gc ) ; 
  GC_fixup2 (& (c -> cont_mark_stack_owner ) , gc ) ; 
  GC_fixup2 (& (c -> init_config ) , gc ) ; 
  GC_fixup2 (& (c -> init_break_cell ) , gc ) ; 




  GC_fixup2 (& (c -> buf_ptr ) , gc ) ; 
  FIXUP_cjs (& c -> cjs , gc ) ; 
  FIXUP_stack_state (& c -> ss , gc ) ; 
  GC_fixup2 (& (c -> barrier_prompt ) , gc ) ; 
  if (! GC_merely_accounting () ) {
    GC_fixup2 (& (c -> runstack_start ) , gc ) ; 
    GC_fixup2 (& (c -> runstack_saved ) , gc ) ; 
  }

  GC_fixup2 (& (c -> prompt_id ) , gc ) ; 
  GC_fixup2 (& (c -> prompt_buf ) , gc ) ; 

  GC_fixup2 (& (c -> escape_cont ) , gc ) ; 

  GC_fixup2 (& (c -> value ) , gc ) ; 
  GC_fixup2 (& (c -> resume_to ) , gc ) ; 
  GC_fixup2 (& (c -> use_next_cont ) , gc ) ; 
  GC_fixup2 (& (c -> extra_marks ) , gc ) ; 
  GC_fixup2 (& (c -> shortcut_prompt ) , gc ) ; 


  return 0 ; 
}

# 1537 "bc/src/mzmark_type.inc"
static int cont_jmp_proc_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int cont_jmp_proc_MARK (void * p , struct NewGC * gc ) {

  Scheme_Cont_Jmp * c = (Scheme_Cont_Jmp * ) p ; 

  MARK_jmpup (& c -> buf , gc ) ; 


  return 0 ; 
}






static int cont_jmp_proc_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Cont_Jmp * c = (Scheme_Cont_Jmp * ) p ; 

  FIXUP_jmpup (& c -> buf , gc ) ; 


  return 0 ; 
}

# 1579 "bc/src/mzmark_type.inc"
static int meta_cont_proc_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int meta_cont_proc_MARK (void * p , struct NewGC * gc ) {

  Scheme_Meta_Continuation * c = (Scheme_Meta_Continuation * ) p ; 

  GC_mark2 (& (c -> prompt_tag ) , gc ) ; 
  GC_mark2 (& (c -> overflow ) , gc ) ; 
  GC_mark2 (& (c -> next ) , gc ) ; 
  GC_mark2 (& (c -> cont_mark_stack_copied ) , gc ) ; 
  GC_mark2 (& (c -> cont ) , gc ) ; 


  return 0 ; 
}






static int meta_cont_proc_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Meta_Continuation * c = (Scheme_Meta_Continuation * ) p ; 

  GC_fixup2 (& (c -> prompt_tag ) , gc ) ; 
  GC_fixup2 (& (c -> overflow ) , gc ) ; 
  GC_fixup2 (& (c -> next ) , gc ) ; 
  GC_fixup2 (& (c -> cont_mark_stack_copied ) , gc ) ; 
  GC_fixup2 (& (c -> cont ) , gc ) ; 


  return 0 ; 
}

# 1629 "bc/src/mzmark_type.inc"
static int mark_dyn_wind_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_dyn_wind_MARK (void * p , struct NewGC * gc ) {

  Scheme_Dynamic_Wind * dw = (Scheme_Dynamic_Wind * ) p ; 

  GC_mark2 (& (dw -> id ) , gc ) ; 
  GC_mark2 (& (dw -> data ) , gc ) ; 
  GC_mark2 (& (dw -> prompt_tag ) , gc ) ; 
  GC_mark2 (& (dw -> prev ) , gc ) ; 

  MARK_stack_state (& dw -> envss , gc ) ; 


  return 0 ; 
}






static int mark_dyn_wind_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Dynamic_Wind * dw = (Scheme_Dynamic_Wind * ) p ; 

  GC_fixup2 (& (dw -> id ) , gc ) ; 
  GC_fixup2 (& (dw -> data ) , gc ) ; 
  GC_fixup2 (& (dw -> prompt_tag ) , gc ) ; 
  GC_fixup2 (& (dw -> prev ) , gc ) ; 

  FIXUP_stack_state (& dw -> envss , gc ) ; 


  return 0 ; 
}

# 1681 "bc/src/mzmark_type.inc"
static int mark_overflow_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_overflow_MARK (void * p , struct NewGC * gc ) {

  Scheme_Overflow * o = (Scheme_Overflow * ) p ; 

  GC_mark2 (& (o -> prev ) , gc ) ; 
  GC_mark2 (& (o -> jmp ) , gc ) ; 
  GC_mark2 (& (o -> id ) , gc ) ; 


  return 0 ; 
}






static int mark_overflow_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Overflow * o = (Scheme_Overflow * ) p ; 

  GC_fixup2 (& (o -> prev ) , gc ) ; 
  GC_fixup2 (& (o -> jmp ) , gc ) ; 
  GC_fixup2 (& (o -> id ) , gc ) ; 


  return 0 ; 
}

# 1727 "bc/src/mzmark_type.inc"
static int mark_overflow_jmp_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_overflow_jmp_MARK (void * p , struct NewGC * gc ) {

  Scheme_Overflow_Jmp * o = (Scheme_Overflow_Jmp * ) p ; 

  MARK_jmpup (& o -> cont , gc ) ; 


  return 0 ; 
}






static int mark_overflow_jmp_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Overflow_Jmp * o = (Scheme_Overflow_Jmp * ) p ; 

  FIXUP_jmpup (& o -> cont , gc ) ; 


  return 0 ; 
}

# 1769 "bc/src/mzmark_type.inc"
static int escaping_cont_proc_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int escaping_cont_proc_MARK (void * p , struct NewGC * gc ) {

  Scheme_Escaping_Cont * c = (Scheme_Escaping_Cont * ) p ; 





  GC_mark2 (& (c -> barrier_prompt ) , gc ) ; 
  MARK_stack_state (& c -> envss , gc ) ; 


  return 0 ; 
}






static int escaping_cont_proc_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Escaping_Cont * c = (Scheme_Escaping_Cont * ) p ; 





  GC_fixup2 (& (c -> barrier_prompt ) , gc ) ; 
  FIXUP_stack_state (& c -> envss , gc ) ; 


  return 0 ; 
}

# 1821 "bc/src/mzmark_type.inc"
static int bignum_obj_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int bignum_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Bignum * b = (Scheme_Bignum * ) p ; 

  if (! ((& ((Scheme_Bignum * ) b ) -> iso ) -> so . keyex & 0x2 ) ) {
    GC_mark2 (& (b -> digits ) , gc ) ; 
  }

# 1839 "bc/src/mzmark_type.inc"
  else {
    b -> digits = ((Small_Bignum * ) GC_fixup_self (b ) ) -> v ; 
  }


  return 0 ; 
}








static int bignum_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Bignum * b = (Scheme_Bignum * ) p ; 

  if (! ((& ((Scheme_Bignum * ) b ) -> iso ) -> so . keyex & 0x2 ) ) {
    GC_fixup2 (& (b -> digits ) , gc ) ; 
  }

# 1860 "bc/src/mzmark_type.inc"
  else {
    b -> digits = ((Small_Bignum * ) GC_fixup_self (b ) ) -> v ; 
  }


  return 0 ; 
}

# 1879 "bc/src/mzmark_type.inc"
static int rational_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int rational_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Rational * r = (Scheme_Rational * ) p ; 

  GC_mark2 (& (r -> num ) , gc ) ; 
  GC_mark2 (& (r -> denom ) , gc ) ; 


  return 0 ; 
}






static int rational_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Rational * r = (Scheme_Rational * ) p ; 

  GC_fixup2 (& (r -> num ) , gc ) ; 
  GC_fixup2 (& (r -> denom ) , gc ) ; 


  return 0 ; 
}

# 1923 "bc/src/mzmark_type.inc"
static int float_obj_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int float_obj_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 1950 "bc/src/mzmark_type.inc"
static int float_obj_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 1969 "bc/src/mzmark_type.inc"
static int double_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int double_obj_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int double_obj_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 2038 "bc/src/mzmark_type.inc"
static int long_double_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int long_double_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Long_Double * ld = (Scheme_Long_Double * ) p ; 
  GC_mark2 (& (ld -> printed_form ) , gc ) ; 

  return 0 ; 
}






static int long_double_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Long_Double * ld = (Scheme_Long_Double * ) p ; 
  GC_fixup2 (& (ld -> printed_form ) , gc ) ; 

  return 0 ; 
}

# 2077 "bc/src/mzmark_type.inc"
static int complex_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int complex_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Complex * c = (Scheme_Complex * ) p ; 

  GC_mark2 (& (c -> r ) , gc ) ; 
  GC_mark2 (& (c -> i ) , gc ) ; 


  return 0 ; 
}






static int complex_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Complex * c = (Scheme_Complex * ) p ; 

  GC_fixup2 (& (c -> r ) , gc ) ; 
  GC_fixup2 (& (c -> i ) , gc ) ; 


  return 0 ; 
}

# 2121 "bc/src/mzmark_type.inc"
static int string_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int string_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Object * o = (Scheme_Object * ) p ; 
  GC_mark2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . char_str_val . string_val ) ) , gc ) ; 


  return 0 ; 
}






static int string_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Object * o = (Scheme_Object * ) p ; 
  GC_fixup2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . char_str_val . string_val ) ) , gc ) ; 


  return 0 ; 
}

# 2161 "bc/src/mzmark_type.inc"
static int bstring_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int bstring_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Object * o = (Scheme_Object * ) p ; 
  GC_mark2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) ) , gc ) ; 


  return 0 ; 
}






static int bstring_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Object * o = (Scheme_Object * ) p ; 
  GC_fixup2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) ) , gc ) ; 


  return 0 ; 
}

# 2201 "bc/src/mzmark_type.inc"
static int symbol_obj_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int symbol_obj_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int symbol_obj_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 2235 "bc/src/mzmark_type.inc"
static int cons_cell_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int cons_cell_MARK (void * p , struct NewGC * gc ) {

  Scheme_Object * o = (Scheme_Object * ) p ; 

  GC_mark2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ) , gc ) ; 
  GC_mark2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ) , gc ) ; 


  return 0 ; 
}






static int cons_cell_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Object * o = (Scheme_Object * ) p ; 

  GC_fixup2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ) , gc ) ; 
  GC_fixup2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ) , gc ) ; 


  return 0 ; 
}

# 2279 "bc/src/mzmark_type.inc"
static int vector_obj_SIZE (void * p , struct NewGC * gc ) {






  return 0 ; 
}


static int vector_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Vector * vec = (Scheme_Vector * ) p ; 

  int i ; 
  for (i = vec -> size ; i -- ; ) 
  GC_mark2 (& (vec -> els [i ] ) , gc ) ; 


  return 0 ; 
}







static int vector_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Vector * vec = (Scheme_Vector * ) p ; 

  int i ; 
  for (i = vec -> size ; i -- ; ) 
  GC_fixup2 (& (vec -> els [i ] ) , gc ) ; 


  return 0 ; 
}

# 2330 "bc/src/mzmark_type.inc"
static int fxvector_obj_SIZE (void * p , struct NewGC * gc ) {




  return 0 ; 
}


static int fxvector_obj_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}







static int fxvector_obj_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 2367 "bc/src/mzmark_type.inc"
static int flvector_obj_SIZE (void * p , struct NewGC * gc ) {




  return 0 ; 
}


static int flvector_obj_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}







static int flvector_obj_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 2443 "bc/src/mzmark_type.inc"
static int stencil_vector_obj_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int stencil_vector_obj_MARK (void * p , struct NewGC * gc ) {

  Scheme_Stencil_Vector * vec = (Scheme_Stencil_Vector * ) p ; 
  intptr_t size = scheme_stencil_vector_popcount (vec -> mask ) ; 

  int i ; 
  for (i = size ; i -- ; ) 
  GC_mark2 (& (vec -> els [i ] ) , gc ) ; 


  return 0 ; 
}







static int stencil_vector_obj_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Stencil_Vector * vec = (Scheme_Stencil_Vector * ) p ; 
  intptr_t size = scheme_stencil_vector_popcount (vec -> mask ) ; 

  int i ; 
  for (i = size ; i -- ; ) 
  GC_fixup2 (& (vec -> els [i ] ) , gc ) ; 


  return 0 ; 
}

# 2497 "bc/src/mzmark_type.inc"
static int input_port_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int input_port_MARK (void * p , struct NewGC * gc ) {

  Scheme_Input_Port * ip = (Scheme_Input_Port * ) p ; 

  GC_mark2 (& (ip -> p . position_redirect ) , gc ) ; 
  GC_mark2 (& (ip -> sub_type ) , gc ) ; 
  GC_mark2 (& (ip -> port_data ) , gc ) ; 
  GC_mark2 (& (ip -> name ) , gc ) ; 
  GC_mark2 (& (ip -> peeked_read ) , gc ) ; 
  GC_mark2 (& (ip -> peeked_write ) , gc ) ; 
  GC_mark2 (& (ip -> read_handler ) , gc ) ; 
  GC_mark2 (& (ip -> closed_evt ) , gc ) ; 
  GC_mark2 (& (ip -> mref ) , gc ) ; 
  GC_mark2 (& (ip -> output_half ) , gc ) ; 
  GC_mark2 (& (ip -> special ) , gc ) ; 
  GC_mark2 (& (ip -> ungotten_special ) , gc ) ; 
  GC_mark2 (& (ip -> progress_evt ) , gc ) ; 
  GC_mark2 (& (ip -> input_lock ) , gc ) ; 
  GC_mark2 (& (ip -> input_giveup ) , gc ) ; 
  GC_mark2 (& (ip -> input_extras ) , gc ) ; 
  GC_mark2 (& (ip -> input_extras_ready ) , gc ) ; 
  GC_mark2 (& (ip -> unless ) , gc ) ; 
  GC_mark2 (& (ip -> unless_cache ) , gc ) ; 





  return 0 ; 
}






static int input_port_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Input_Port * ip = (Scheme_Input_Port * ) p ; 

  GC_fixup2 (& (ip -> p . position_redirect ) , gc ) ; 
  GC_fixup2 (& (ip -> sub_type ) , gc ) ; 
  GC_fixup2 (& (ip -> port_data ) , gc ) ; 
  GC_fixup2 (& (ip -> name ) , gc ) ; 
  GC_fixup2 (& (ip -> peeked_read ) , gc ) ; 
  GC_fixup2 (& (ip -> peeked_write ) , gc ) ; 
  GC_fixup2 (& (ip -> read_handler ) , gc ) ; 
  GC_fixup2 (& (ip -> closed_evt ) , gc ) ; 
  GC_fixup2 (& (ip -> mref ) , gc ) ; 
  GC_fixup2 (& (ip -> output_half ) , gc ) ; 
  GC_fixup2 (& (ip -> special ) , gc ) ; 
  GC_fixup2 (& (ip -> ungotten_special ) , gc ) ; 
  GC_fixup2 (& (ip -> progress_evt ) , gc ) ; 
  GC_fixup2 (& (ip -> input_lock ) , gc ) ; 
  GC_fixup2 (& (ip -> input_giveup ) , gc ) ; 
  GC_fixup2 (& (ip -> input_extras ) , gc ) ; 
  GC_fixup2 (& (ip -> input_extras_ready ) , gc ) ; 
  GC_fixup2 (& (ip -> unless ) , gc ) ; 
  GC_fixup2 (& (ip -> unless_cache ) , gc ) ; 





  return 0 ; 
}

# 2581 "bc/src/mzmark_type.inc"
static int output_port_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int output_port_MARK (void * p , struct NewGC * gc ) {

  Scheme_Output_Port * op = (Scheme_Output_Port * ) p ; 

  GC_mark2 (& (op -> p . position_redirect ) , gc ) ; 
  GC_mark2 (& (op -> sub_type ) , gc ) ; 
  GC_mark2 (& (op -> port_data ) , gc ) ; 
  GC_mark2 (& (op -> name ) , gc ) ; 
  GC_mark2 (& (op -> display_handler ) , gc ) ; 
  GC_mark2 (& (op -> write_handler ) , gc ) ; 
  GC_mark2 (& (op -> print_handler ) , gc ) ; 
  GC_mark2 (& (op -> closed_evt ) , gc ) ; 
  GC_mark2 (& (op -> mref ) , gc ) ; 
  GC_mark2 (& (op -> input_half ) , gc ) ; 


  return 0 ; 
}






static int output_port_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Output_Port * op = (Scheme_Output_Port * ) p ; 

  GC_fixup2 (& (op -> p . position_redirect ) , gc ) ; 
  GC_fixup2 (& (op -> sub_type ) , gc ) ; 
  GC_fixup2 (& (op -> port_data ) , gc ) ; 
  GC_fixup2 (& (op -> name ) , gc ) ; 
  GC_fixup2 (& (op -> display_handler ) , gc ) ; 
  GC_fixup2 (& (op -> write_handler ) , gc ) ; 
  GC_fixup2 (& (op -> print_handler ) , gc ) ; 
  GC_fixup2 (& (op -> closed_evt ) , gc ) ; 
  GC_fixup2 (& (op -> mref ) , gc ) ; 
  GC_fixup2 (& (op -> input_half ) , gc ) ; 


  return 0 ; 
}

# 2641 "bc/src/mzmark_type.inc"
static int thread_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int thread_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Thread * pr = (Scheme_Thread * ) p ; 

  GC_mark2 (& (pr -> next ) , gc ) ; 
  GC_mark2 (& (pr -> prev ) , gc ) ; 

  GC_mark2 (& (pr -> t_set_parent ) , gc ) ; 
  GC_mark2 (& (pr -> t_set_next ) , gc ) ; 
  GC_mark2 (& (pr -> t_set_prev ) , gc ) ; 

  MARK_cjs (& pr -> cjs , gc ) ; 
  GC_mark2 (& (pr -> decompose_mc ) , gc ) ; 

  GC_mark2 (& (pr -> cell_values ) , gc ) ; 
  GC_mark2 (& (pr -> init_config ) , gc ) ; 
  GC_mark2 (& (pr -> init_break_cell ) , gc ) ; 

  if (! pr -> runstack_owner 
  || ! GC_merely_accounting () 
  || (* pr -> runstack_owner == pr ) ) {
    Scheme_Object * * rs = pr -> runstack_start ; 
    GC_mark2 (& (pr -> runstack_start ) , gc ) ; 
    if (pr -> runstack != pr -> runstack_start + (pr -> runstack - rs ) )
      pr -> runstack = pr -> runstack_start + (pr -> runstack - rs ) ; 

    GC_mark2 (& (pr -> runstack_saved ) , gc ) ; 
  }
  GC_mark2 (& (pr -> runstack_owner ) , gc ) ; 
  GC_mark2 (& (pr -> runstack_swapped ) , gc ) ; 
  pr -> spare_runstack = ((void * ) 0 ) ; 

  GC_mark2 (& (pr -> meta_prompt ) , gc ) ; 
  GC_mark2 (& (pr -> meta_continuation ) , gc ) ; 
  GC_mark2 (& (pr -> acting_barrier_prompt ) , gc ) ; 

  GC_mark2 (& (pr -> cont_mark_stack_segments ) , gc ) ; 
  GC_mark2 (& (pr -> cont_mark_stack_owner ) , gc ) ; 
  GC_mark2 (& (pr -> cont_mark_stack_swapped ) , gc ) ; 

  MARK_jmpup (& pr -> jmpup_buf , gc ) ; 

  GC_mark2 (& (pr -> dw ) , gc ) ; 

  GC_mark2 (& (pr -> nester ) , gc ) ; 
  GC_mark2 (& (pr -> nestee ) , gc ) ; 

  GC_mark2 (& (pr -> current_ft ) , gc ) ; 

  GC_mark2 (& (pr -> blocker ) , gc ) ; 
  GC_mark2 (& (pr -> overflow ) , gc ) ; 

  GC_mark2 (& (pr -> return_marks_to ) , gc ) ; 
  GC_mark2 (& (pr -> returned_marks ) , gc ) ; 

  GC_mark2 (& (pr -> current_mt ) , gc ) ; 

  GC_mark2 (& (pr -> constant_folding ) , gc ) ; 
  GC_mark2 (& (pr -> reading_delayed ) , gc ) ; 

  GC_mark2 (& (pr -> overflow_reply ) , gc ) ; 

  GC_mark2 (& (pr -> values_buffer ) , gc ) ; 

  GC_mark2 (& (pr -> tail_buffer ) , gc ) ; 

  GC_mark2 (& (pr -> ku . eval . wait_expr ) , gc ) ; 

  GC_mark2 (& (pr -> ku . apply . tail_rator ) , gc ) ; 
  GC_mark2 (& (pr -> ku . apply . tail_rands ) , gc ) ; 

  GC_mark2 (& (pr -> ku . multiple . array ) , gc ) ; 

  GC_mark2 (& (pr -> ku . k . p1 ) , gc ) ; 
  GC_mark2 (& (pr -> ku . k . p2 ) , gc ) ; 
  GC_mark2 (& (pr -> ku . k . p3 ) , gc ) ; 
  GC_mark2 (& (pr -> ku . k . p4 ) , gc ) ; 
  GC_mark2 (& (pr -> ku . k . p5 ) , gc ) ; 

  GC_mark2 (& (pr -> self_for_proc_chaperone ) , gc ) ; 

  GC_mark2 (& (pr -> kill_data ) , gc ) ; 
  GC_mark2 (& (pr -> private_kill_data ) , gc ) ; 
  GC_mark2 (& (pr -> private_kill_next ) , gc ) ; 

  GC_mark2 (& (pr -> user_tls ) , gc ) ; 
  GC_mark2 (& (pr -> gmp_tls_data ) , gc ) ; 

  GC_mark2 (& (pr -> mr_hop ) , gc ) ; 
  GC_mark2 (& (pr -> mref ) , gc ) ; 
  GC_mark2 (& (pr -> extra_mrefs ) , gc ) ; 

  GC_mark2 (& (pr -> name ) , gc ) ; 

  GC_mark2 (& (pr -> transitive_resumes ) , gc ) ; 

  GC_mark2 (& (pr -> suspended_box ) , gc ) ; 
  GC_mark2 (& (pr -> resumed_box ) , gc ) ; 
  GC_mark2 (& (pr -> dead_box ) , gc ) ; 
  GC_mark2 (& (pr -> running_box ) , gc ) ; 
  GC_mark2 (& (pr -> sync_box ) , gc ) ; 

  GC_mark2 (& (pr -> mbox_first ) , gc ) ; 
  GC_mark2 (& (pr -> mbox_last ) , gc ) ; 
  GC_mark2 (& (pr -> mbox_sema ) , gc ) ; 


  {
    Scheme_Object * cpr = pr -> place_channel_msg_chain_in_flight ; 
    while (cpr ) {
      GC_mark2 (& ((((Scheme_Simple_Object * ) (cpr ) ) -> u . pair_val . car ) ) , gc ) ; 
      cpr = (((Scheme_Simple_Object * ) (cpr ) ) -> u . pair_val . cdr ) ; 
    }
  }


  return 0 ; 
}






static int thread_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Thread * pr = (Scheme_Thread * ) p ; 

  GC_fixup2 (& (pr -> next ) , gc ) ; 
  GC_fixup2 (& (pr -> prev ) , gc ) ; 

  GC_fixup2 (& (pr -> t_set_parent ) , gc ) ; 
  GC_fixup2 (& (pr -> t_set_next ) , gc ) ; 
  GC_fixup2 (& (pr -> t_set_prev ) , gc ) ; 

  FIXUP_cjs (& pr -> cjs , gc ) ; 
  GC_fixup2 (& (pr -> decompose_mc ) , gc ) ; 

  GC_fixup2 (& (pr -> cell_values ) , gc ) ; 
  GC_fixup2 (& (pr -> init_config ) , gc ) ; 
  GC_fixup2 (& (pr -> init_break_cell ) , gc ) ; 

  if (! pr -> runstack_owner 
  || ! GC_merely_accounting () 
  || (* pr -> runstack_owner == pr ) ) {
    Scheme_Object * * rs = pr -> runstack_start ; 
    GC_fixup2 (& (pr -> runstack_start ) , gc ) ; 
    if (pr -> runstack != pr -> runstack_start + (pr -> runstack - rs ) )
      pr -> runstack = pr -> runstack_start + (pr -> runstack - rs ) ; 

    GC_fixup2 (& (pr -> runstack_saved ) , gc ) ; 
  }
  GC_fixup2 (& (pr -> runstack_owner ) , gc ) ; 
  GC_fixup2 (& (pr -> runstack_swapped ) , gc ) ; 
  pr -> spare_runstack = ((void * ) 0 ) ; 

  GC_fixup2 (& (pr -> meta_prompt ) , gc ) ; 
  GC_fixup2 (& (pr -> meta_continuation ) , gc ) ; 
  GC_fixup2 (& (pr -> acting_barrier_prompt ) , gc ) ; 

  GC_fixup2 (& (pr -> cont_mark_stack_segments ) , gc ) ; 
  GC_fixup2 (& (pr -> cont_mark_stack_owner ) , gc ) ; 
  GC_fixup2 (& (pr -> cont_mark_stack_swapped ) , gc ) ; 

  FIXUP_jmpup (& pr -> jmpup_buf , gc ) ; 

  GC_fixup2 (& (pr -> dw ) , gc ) ; 

  GC_fixup2 (& (pr -> nester ) , gc ) ; 
  GC_fixup2 (& (pr -> nestee ) , gc ) ; 

  GC_fixup2 (& (pr -> current_ft ) , gc ) ; 

  GC_fixup2 (& (pr -> blocker ) , gc ) ; 
  GC_fixup2 (& (pr -> overflow ) , gc ) ; 

  GC_fixup2 (& (pr -> return_marks_to ) , gc ) ; 
  GC_fixup2 (& (pr -> returned_marks ) , gc ) ; 

  GC_fixup2 (& (pr -> current_mt ) , gc ) ; 

  GC_fixup2 (& (pr -> constant_folding ) , gc ) ; 
  GC_fixup2 (& (pr -> reading_delayed ) , gc ) ; 

  GC_fixup2 (& (pr -> overflow_reply ) , gc ) ; 

  GC_fixup2 (& (pr -> values_buffer ) , gc ) ; 

  GC_fixup2 (& (pr -> tail_buffer ) , gc ) ; 

  GC_fixup2 (& (pr -> ku . eval . wait_expr ) , gc ) ; 

  GC_fixup2 (& (pr -> ku . apply . tail_rator ) , gc ) ; 
  GC_fixup2 (& (pr -> ku . apply . tail_rands ) , gc ) ; 

  GC_fixup2 (& (pr -> ku . multiple . array ) , gc ) ; 

  GC_fixup2 (& (pr -> ku . k . p1 ) , gc ) ; 
  GC_fixup2 (& (pr -> ku . k . p2 ) , gc ) ; 
  GC_fixup2 (& (pr -> ku . k . p3 ) , gc ) ; 
  GC_fixup2 (& (pr -> ku . k . p4 ) , gc ) ; 
  GC_fixup2 (& (pr -> ku . k . p5 ) , gc ) ; 

  GC_fixup2 (& (pr -> self_for_proc_chaperone ) , gc ) ; 

  GC_fixup2 (& (pr -> kill_data ) , gc ) ; 
  GC_fixup2 (& (pr -> private_kill_data ) , gc ) ; 
  GC_fixup2 (& (pr -> private_kill_next ) , gc ) ; 

  GC_fixup2 (& (pr -> user_tls ) , gc ) ; 
  GC_fixup2 (& (pr -> gmp_tls_data ) , gc ) ; 

  GC_fixup2 (& (pr -> mr_hop ) , gc ) ; 
  GC_fixup2 (& (pr -> mref ) , gc ) ; 
  GC_fixup2 (& (pr -> extra_mrefs ) , gc ) ; 

  GC_fixup2 (& (pr -> name ) , gc ) ; 

  GC_fixup2 (& (pr -> transitive_resumes ) , gc ) ; 

  GC_fixup2 (& (pr -> suspended_box ) , gc ) ; 
  GC_fixup2 (& (pr -> resumed_box ) , gc ) ; 
  GC_fixup2 (& (pr -> dead_box ) , gc ) ; 
  GC_fixup2 (& (pr -> running_box ) , gc ) ; 
  GC_fixup2 (& (pr -> sync_box ) , gc ) ; 

  GC_fixup2 (& (pr -> mbox_first ) , gc ) ; 
  GC_fixup2 (& (pr -> mbox_last ) , gc ) ; 
  GC_fixup2 (& (pr -> mbox_sema ) , gc ) ; 


  {
    Scheme_Object * cpr = pr -> place_channel_msg_chain_in_flight ; 
    while (cpr ) {
      GC_fixup2 (& ((((Scheme_Simple_Object * ) (cpr ) ) -> u . pair_val . car ) ) , gc ) ; 
      cpr = (((Scheme_Simple_Object * ) (cpr ) ) -> u . pair_val . cdr ) ; 
    }
  }


  return 0 ; 
}

# 2901 "bc/src/mzmark_type.inc"
static int runstack_val_SIZE (void * p , struct NewGC * gc ) {




  return 0 ; 
}


static int runstack_val_MARK (void * p , struct NewGC * gc ) {

  intptr_t * s = (intptr_t * ) p ; 
  void * * a , * * b ; 
  a = (void * * ) s + 5 + s [2 ] ; 
  b = (void * * ) s + 5 + s [3 ] ; 
  while (a < b ) {
    GC_mark2 (& (* a ) , gc ) ; 
    a ++ ; 
  }



  a = (void * * ) s + 5 ; 
  b = (void * * ) s + 5 + s [2 ] ; 
  while (a < b ) {
    * a = ((void * ) 0 ) ; 
    a ++ ; 
  }
  a = (void * * ) s + 5 + s [3 ] ; 
  b = (void * * ) s + 5 + (s [1 ] - 5 ) ; 
  while (a < b ) {
    * a = ((void * ) 0 ) ; 
    a ++ ; 
  }


  return 0 ; 
}






static int runstack_val_FIXUP (void * p , struct NewGC * gc ) {

  intptr_t * s = (intptr_t * ) p ; 
  void * * a , * * b ; 
  a = (void * * ) s + 5 + s [2 ] ; 
  b = (void * * ) s + 5 + s [3 ] ; 
  while (a < b ) {
    GC_fixup2 (& (* a ) , gc ) ; 
    a ++ ; 
  }



  return 0 ; 
}

# 2970 "bc/src/mzmark_type.inc"
static int prompt_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int prompt_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Prompt * pr = (Scheme_Prompt * ) p ; 
  GC_mark2 (& (pr -> boundary_overflow_id ) , gc ) ; 
  if (! GC_merely_accounting () ) {
    if (pr -> is_barrier )
      GC_mark2 (& (pr -> u . runstack_boundary_start_ref ) , gc ) ; 
    else 
    GC_mark2 (& (pr -> u . runstack_boundary_start ) , gc ) ; 
  }
  GC_mark2 (& (pr -> tag ) , gc ) ; 
  GC_mark2 (& (pr -> id ) , gc ) ; 

  return 0 ; 
}






static int prompt_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Prompt * pr = (Scheme_Prompt * ) p ; 
  GC_fixup2 (& (pr -> boundary_overflow_id ) , gc ) ; 
  if (! GC_merely_accounting () ) {
    if (pr -> is_barrier )
      GC_fixup2 (& (pr -> u . runstack_boundary_start_ref ) , gc ) ; 
    else 
    GC_fixup2 (& (pr -> u . runstack_boundary_start ) , gc ) ; 
  }
  GC_fixup2 (& (pr -> tag ) , gc ) ; 
  GC_fixup2 (& (pr -> id ) , gc ) ; 

  return 0 ; 
}

# 3024 "bc/src/mzmark_type.inc"
static int cont_mark_set_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int cont_mark_set_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Cont_Mark_Set * s = (Scheme_Cont_Mark_Set * ) p ; 
  GC_mark2 (& (s -> chain ) , gc ) ; 
  GC_mark2 (& (s -> native_stack_trace ) , gc ) ; 


  return 0 ; 
}






static int cont_mark_set_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Cont_Mark_Set * s = (Scheme_Cont_Mark_Set * ) p ; 
  GC_fixup2 (& (s -> chain ) , gc ) ; 
  GC_fixup2 (& (s -> native_stack_trace ) , gc ) ; 


  return 0 ; 
}

# 3066 "bc/src/mzmark_type.inc"
static int sema_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int sema_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Sema * s = (Scheme_Sema * ) p ; 

  GC_mark2 (& (s -> first ) , gc ) ; 
  GC_mark2 (& (s -> last ) , gc ) ; 


  return 0 ; 
}






static int sema_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Sema * s = (Scheme_Sema * ) p ; 

  GC_fixup2 (& (s -> first ) , gc ) ; 
  GC_fixup2 (& (s -> last ) , gc ) ; 


  return 0 ; 
}

# 3110 "bc/src/mzmark_type.inc"
static int channel_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int channel_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Channel * s = (Scheme_Channel * ) p ; 

  GC_mark2 (& (s -> get_first ) , gc ) ; 
  GC_mark2 (& (s -> get_last ) , gc ) ; 
  GC_mark2 (& (s -> put_first ) , gc ) ; 
  GC_mark2 (& (s -> put_last ) , gc ) ; 


  return 0 ; 
}






static int channel_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Channel * s = (Scheme_Channel * ) p ; 

  GC_fixup2 (& (s -> get_first ) , gc ) ; 
  GC_fixup2 (& (s -> get_last ) , gc ) ; 
  GC_fixup2 (& (s -> put_first ) , gc ) ; 
  GC_fixup2 (& (s -> put_last ) , gc ) ; 


  return 0 ; 
}

# 3158 "bc/src/mzmark_type.inc"
static int channel_put_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int channel_put_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Channel_Put * s = (Scheme_Channel_Put * ) p ; 

  GC_mark2 (& (s -> ch ) , gc ) ; 
  GC_mark2 (& (s -> val ) , gc ) ; 


  return 0 ; 
}






static int channel_put_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Channel_Put * s = (Scheme_Channel_Put * ) p ; 

  GC_fixup2 (& (s -> ch ) , gc ) ; 
  GC_fixup2 (& (s -> val ) , gc ) ; 


  return 0 ; 
}

# 3202 "bc/src/mzmark_type.inc"
static int hash_table_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int hash_table_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p ; 

  GC_mark2 (& (ht -> keys ) , gc ) ; 
  GC_mark2 (& (ht -> vals ) , gc ) ; 
  GC_mark2 (& (ht -> mutex ) , gc ) ; 


  return 0 ; 
}






static int hash_table_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p ; 

  GC_fixup2 (& (ht -> keys ) , gc ) ; 
  GC_fixup2 (& (ht -> vals ) , gc ) ; 
  GC_fixup2 (& (ht -> mutex ) , gc ) ; 


  return 0 ; 
}

# 3248 "bc/src/mzmark_type.inc"
static int bucket_table_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int bucket_table_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Bucket_Table * ht = (Scheme_Bucket_Table * ) p ; 

  GC_mark2 (& (ht -> buckets ) , gc ) ; 
  GC_mark2 (& (ht -> mutex ) , gc ) ; 


  return 0 ; 
}






static int bucket_table_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Bucket_Table * ht = (Scheme_Bucket_Table * ) p ; 

  GC_fixup2 (& (ht -> buckets ) , gc ) ; 
  GC_fixup2 (& (ht -> mutex ) , gc ) ; 


  return 0 ; 
}

# 3292 "bc/src/mzmark_type.inc"
static int env_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int env_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Env * e = (Scheme_Env * ) p ; 

  GC_mark2 (& (e -> namespace ) , gc ) ; 
  GC_mark2 (& (e -> instance ) , gc ) ; 
  GC_mark2 (& (e -> protected ) , gc ) ; 

  return 0 ; 
}






static int env_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Env * e = (Scheme_Env * ) p ; 

  GC_fixup2 (& (e -> namespace ) , gc ) ; 
  GC_fixup2 (& (e -> instance ) , gc ) ; 
  GC_fixup2 (& (e -> protected ) , gc ) ; 

  return 0 ; 
}

# 3336 "bc/src/mzmark_type.inc"
static int startup_env_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int startup_env_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Startup_Env * e = (Scheme_Startup_Env * ) p ; 

  GC_mark2 (& (e -> current_table ) , gc ) ; 
  GC_mark2 (& (e -> primitive_tables ) , gc ) ; 
  GC_mark2 (& (e -> all_primitives_table ) , gc ) ; 
  GC_mark2 (& (e -> primitive_ids_table ) , gc ) ; 

  return 0 ; 
}






static int startup_env_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Startup_Env * e = (Scheme_Startup_Env * ) p ; 

  GC_fixup2 (& (e -> current_table ) , gc ) ; 
  GC_fixup2 (& (e -> primitive_tables ) , gc ) ; 
  GC_fixup2 (& (e -> all_primitives_table ) , gc ) ; 
  GC_fixup2 (& (e -> primitive_ids_table ) , gc ) ; 

  return 0 ; 
}

# 3382 "bc/src/mzmark_type.inc"
static int random_state_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int random_state_val_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int random_state_val_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 3416 "bc/src/mzmark_type.inc"
static int prefix_val_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int prefix_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Prefix * pf = (Scheme_Prefix * ) p ; 
  int i ; 
  for (i = pf -> num_slots ; i -- ; ) 
  GC_mark2 (& (pf -> a [i ] ) , gc ) ; 

  return 0 ; 
}









static int prefix_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Prefix * pf = (Scheme_Prefix * ) p ; 
  int i ; 
  for (i = pf -> num_slots ; i -- ; ) 
  GC_fixup2 (& (pf -> a [i ] ) , gc ) ; 

  return 0 ; 
}

# 3468 "bc/src/mzmark_type.inc"
static int svector_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int svector_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Object * o = (Scheme_Object * ) p ; 

  GC_mark2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . vec ) ) , gc ) ; 


  return 0 ; 
}






static int svector_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Object * o = (Scheme_Object * ) p ; 

  GC_fixup2 (& ((((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . vec ) ) , gc ) ; 


  return 0 ; 
}

# 3510 "bc/src/mzmark_type.inc"
static int stx_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int stx_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Stx * stx = (Scheme_Stx * ) p ; 
  GC_mark2 (& (stx -> val ) , gc ) ; 
  GC_mark2 (& (stx -> srcloc ) , gc ) ; 
  GC_mark2 (& (stx -> props ) , gc ) ; 

  return 0 ; 
}






static int stx_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Stx * stx = (Scheme_Stx * ) p ; 
  GC_fixup2 (& (stx -> val ) , gc ) ; 
  GC_fixup2 (& (stx -> srcloc ) , gc ) ; 
  GC_fixup2 (& (stx -> props ) , gc ) ; 

  return 0 ; 
}

# 3552 "bc/src/mzmark_type.inc"
static int linklet_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int linklet_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Linklet * l = (Scheme_Linklet * ) p ; 

  GC_mark2 (& (l -> name ) , gc ) ; 
  GC_mark2 (& (l -> importss ) , gc ) ; 
  GC_mark2 (& (l -> import_shapes ) , gc ) ; 
  GC_mark2 (& (l -> defns ) , gc ) ; 
  GC_mark2 (& (l -> source_names ) , gc ) ; 
  GC_mark2 (& (l -> bodies ) , gc ) ; 
  GC_mark2 (& (l -> constants ) , gc ) ; 
  GC_mark2 (& (l -> static_prefix ) , gc ) ; 
  GC_mark2 (& (l -> native_lambdas ) , gc ) ; 

  return 0 ; 
}






static int linklet_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Linklet * l = (Scheme_Linklet * ) p ; 

  GC_fixup2 (& (l -> name ) , gc ) ; 
  GC_fixup2 (& (l -> importss ) , gc ) ; 
  GC_fixup2 (& (l -> import_shapes ) , gc ) ; 
  GC_fixup2 (& (l -> defns ) , gc ) ; 
  GC_fixup2 (& (l -> source_names ) , gc ) ; 
  GC_fixup2 (& (l -> bodies ) , gc ) ; 
  GC_fixup2 (& (l -> constants ) , gc ) ; 
  GC_fixup2 (& (l -> static_prefix ) , gc ) ; 
  GC_fixup2 (& (l -> native_lambdas ) , gc ) ; 

  return 0 ; 
}

# 3608 "bc/src/mzmark_type.inc"
static int instance_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int instance_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Instance * i = (Scheme_Instance * ) p ; 

  GC_mark2 (& (i -> variables . a ) , gc ) ; 
  GC_mark2 (& (i -> weak_self_link ) , gc ) ; 
  GC_mark2 (& (i -> source_names ) , gc ) ; 
  GC_mark2 (& (i -> name ) , gc ) ; 
  GC_mark2 (& (i -> data ) , gc ) ; 

  return 0 ; 
}






static int instance_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Instance * i = (Scheme_Instance * ) p ; 

  GC_fixup2 (& (i -> variables . a ) , gc ) ; 
  GC_fixup2 (& (i -> weak_self_link ) , gc ) ; 
  GC_fixup2 (& (i -> source_names ) , gc ) ; 
  GC_fixup2 (& (i -> name ) , gc ) ; 
  GC_fixup2 (& (i -> data ) , gc ) ; 

  return 0 ; 
}

# 3656 "bc/src/mzmark_type.inc"
static int guard_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int guard_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Security_Guard * g = (Scheme_Security_Guard * ) p ; 

  GC_mark2 (& (g -> parent ) , gc ) ; 
  GC_mark2 (& (g -> file_proc ) , gc ) ; 
  GC_mark2 (& (g -> network_proc ) , gc ) ; 
  GC_mark2 (& (g -> link_proc ) , gc ) ; 

  return 0 ; 
}






static int guard_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Security_Guard * g = (Scheme_Security_Guard * ) p ; 

  GC_fixup2 (& (g -> parent ) , gc ) ; 
  GC_fixup2 (& (g -> file_proc ) , gc ) ; 
  GC_fixup2 (& (g -> network_proc ) , gc ) ; 
  GC_fixup2 (& (g -> link_proc ) , gc ) ; 

  return 0 ; 
}

# 3702 "bc/src/mzmark_type.inc"
static int buf_holder_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int buf_holder_MARK (void * p , struct NewGC * gc ) {

  Scheme_Jumpup_Buf_Holder * h = (Scheme_Jumpup_Buf_Holder * ) p ; 

  MARK_jmpup (& h -> buf , gc ) ; 


  return 0 ; 
}






static int buf_holder_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Jumpup_Buf_Holder * h = (Scheme_Jumpup_Buf_Holder * ) p ; 

  FIXUP_jmpup (& h -> buf , gc ) ; 


  return 0 ; 
}

# 3744 "bc/src/mzmark_type.inc"
static int mark_inspector_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_inspector_MARK (void * p , struct NewGC * gc ) {

  Scheme_Inspector * i = (Scheme_Inspector * ) p ; 
  GC_mark2 (& (i -> superior ) , gc ) ; 

  return 0 ; 
}






static int mark_inspector_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Inspector * i = (Scheme_Inspector * ) p ; 
  GC_fixup2 (& (i -> superior ) , gc ) ; 

  return 0 ; 
}

# 3782 "bc/src/mzmark_type.inc"
static int mark_pipe_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_pipe_MARK (void * p , struct NewGC * gc ) {

  Scheme_Pipe * pp = (Scheme_Pipe * ) p ; 

  GC_mark2 (& (pp -> buf ) , gc ) ; 
  GC_mark2 (& (pp -> wakeup_on_read ) , gc ) ; 
  GC_mark2 (& (pp -> wakeup_on_write ) , gc ) ; 


  return 0 ; 
}






static int mark_pipe_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Pipe * pp = (Scheme_Pipe * ) p ; 

  GC_fixup2 (& (pp -> buf ) , gc ) ; 
  GC_fixup2 (& (pp -> wakeup_on_read ) , gc ) ; 
  GC_fixup2 (& (pp -> wakeup_on_write ) , gc ) ; 


  return 0 ; 
}

# 3828 "bc/src/mzmark_type.inc"
static int mark_logger_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_logger_MARK (void * p , struct NewGC * gc ) {

  Scheme_Logger * l = (Scheme_Logger * ) p ; 
  GC_mark2 (& (l -> name ) , gc ) ; 
  GC_mark2 (& (l -> parent ) , gc ) ; 
  GC_mark2 (& (l -> want_name_level_cache ) , gc ) ; 
  GC_mark2 (& (l -> root_timestamp ) , gc ) ; 
  GC_mark2 (& (l -> syslog_level ) , gc ) ; 
  GC_mark2 (& (l -> stderr_level ) , gc ) ; 
  GC_mark2 (& (l -> stdout_level ) , gc ) ; 
  GC_mark2 (& (l -> propagate_level ) , gc ) ; 
  GC_mark2 (& (l -> readers ) , gc ) ; 

  return 0 ; 
}






static int mark_logger_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Logger * l = (Scheme_Logger * ) p ; 
  GC_fixup2 (& (l -> name ) , gc ) ; 
  GC_fixup2 (& (l -> parent ) , gc ) ; 
  GC_fixup2 (& (l -> want_name_level_cache ) , gc ) ; 
  GC_fixup2 (& (l -> root_timestamp ) , gc ) ; 
  GC_fixup2 (& (l -> syslog_level ) , gc ) ; 
  GC_fixup2 (& (l -> stderr_level ) , gc ) ; 
  GC_fixup2 (& (l -> stdout_level ) , gc ) ; 
  GC_fixup2 (& (l -> propagate_level ) , gc ) ; 
  GC_fixup2 (& (l -> readers ) , gc ) ; 

  return 0 ; 
}

# 3882 "bc/src/mzmark_type.inc"
static int mark_log_reader_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_log_reader_MARK (void * p , struct NewGC * gc ) {

  Scheme_Log_Reader * lr = (Scheme_Log_Reader * ) p ; 
  GC_mark2 (& (lr -> level ) , gc ) ; 
  GC_mark2 (& (lr -> sema ) , gc ) ; 
  GC_mark2 (& (lr -> head ) , gc ) ; 
  GC_mark2 (& (lr -> tail ) , gc ) ; 

  return 0 ; 
}






static int mark_log_reader_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Log_Reader * lr = (Scheme_Log_Reader * ) p ; 
  GC_fixup2 (& (lr -> level ) , gc ) ; 
  GC_fixup2 (& (lr -> sema ) , gc ) ; 
  GC_fixup2 (& (lr -> head ) , gc ) ; 
  GC_fixup2 (& (lr -> tail ) , gc ) ; 

  return 0 ; 
}

# 3926 "bc/src/mzmark_type.inc"
static int struct_proc_shape_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int struct_proc_shape_MARK (void * p , struct NewGC * gc ) {

  Scheme_Struct_Proc_Shape * s = (Scheme_Struct_Proc_Shape * ) p ; 
  GC_mark2 (& (s -> identity ) , gc ) ; 

  return 0 ; 
}






static int struct_proc_shape_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Struct_Proc_Shape * s = (Scheme_Struct_Proc_Shape * ) p ; 
  GC_fixup2 (& (s -> identity ) , gc ) ; 

  return 0 ; 
}

# 508 "bc/src/type.c"
void scheme_register_traversers (void ) 
{
  GC_register_traversers2 (scheme_toplevel_type , toplevel_obj_SIZE , toplevel_obj_MARK , toplevel_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_static_toplevel_type , static_toplevel_obj_SIZE , static_toplevel_obj_MARK , static_toplevel_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_variable_type , variable_obj_SIZE , variable_obj_MARK , variable_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_local_type , local_obj_SIZE , local_obj_MARK , local_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_local_unbox_type , local_obj_SIZE , local_obj_MARK , local_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_application_type , app_rec_SIZE , app_rec_MARK , app_rec_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_application2_type , app2_rec_SIZE , app2_rec_MARK , app2_rec_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_application3_type , app3_rec_SIZE , app3_rec_MARK , app3_rec_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_sequence_type , seq_rec_SIZE , seq_rec_MARK , seq_rec_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_branch_type , branch_rec_SIZE , branch_rec_MARK , branch_rec_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_lambda_type , unclosed_proc_SIZE , unclosed_proc_MARK , unclosed_proc_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_let_value_type , let_value_SIZE , let_value_MARK , let_value_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_let_void_type , let_void_SIZE , let_void_MARK , let_void_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_letrec_type , letrec_SIZE , letrec_MARK , letrec_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_let_one_type , let_one_SIZE , let_one_MARK , let_one_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_with_cont_mark_type , with_cont_mark_SIZE , with_cont_mark_MARK , with_cont_mark_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_define_values_type , vector_obj_SIZE , vector_obj_MARK , vector_obj_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_varref_form_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_apply_values_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_with_immed_mark_type , with_cont_mark_SIZE , with_cont_mark_MARK , with_cont_mark_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_boxenv_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_case_lambda_sequence_type , case_closure_SIZE , case_closure_MARK , case_closure_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_begin0_sequence_type , seq_rec_SIZE , seq_rec_MARK , seq_rec_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_set_bang_type , set_bang_SIZE , set_bang_MARK , set_bang_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_inline_variant_type , vector_obj_SIZE , vector_obj_MARK , vector_obj_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (_scheme_values_types_ , bad_trav_SIZE , bad_trav_MARK , bad_trav_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_ir_lambda_type , unclosed_proc_SIZE , unclosed_proc_MARK , unclosed_proc_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_ir_local_type , ir_local_SIZE , ir_local_MARK , ir_local_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_ir_toplevel_type , ir_toplevel_SIZE , ir_toplevel_MARK , ir_toplevel_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_ir_let_value_type , ir_let_value_SIZE , ir_let_value_MARK , ir_let_value_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_ir_let_header_type , let_header_SIZE , let_header_MARK , let_header_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_quote_compilation_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_linklet_type , linklet_val_SIZE , linklet_val_MARK , linklet_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_instance_type , instance_val_SIZE , instance_val_MARK , instance_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_linklet_bundle_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (_scheme_ir_values_types_ , bad_trav_SIZE , bad_trav_MARK , bad_trav_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_prefix_type , prefix_val_SIZE , prefix_val_MARK , prefix_val_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_prim_type , prim_proc_SIZE , prim_proc_MARK , prim_proc_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_closed_prim_type , closed_prim_proc_SIZE , closed_prim_proc_MARK , closed_prim_proc_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_closure_type , scm_closure_SIZE , scm_closure_MARK , scm_closure_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_case_closure_type , case_closure_SIZE , case_closure_MARK , case_closure_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_cont_type , cont_proc_SIZE , cont_proc_MARK , cont_proc_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_dyn_wind , mark_dyn_wind_SIZE , mark_dyn_wind_MARK , mark_dyn_wind_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_overflow , mark_overflow_SIZE , mark_overflow_MARK , mark_overflow_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_overflow_jmp , mark_overflow_jmp_SIZE , mark_overflow_jmp_MARK , mark_overflow_jmp_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_meta_cont , meta_cont_proc_SIZE , meta_cont_proc_MARK , meta_cont_proc_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_escaping_cont_type , escaping_cont_proc_SIZE , escaping_cont_proc_MARK , escaping_cont_proc_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_cont_jmp , cont_jmp_proc_SIZE , cont_jmp_proc_MARK , cont_jmp_proc_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_char_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_integer_type , bad_trav_SIZE , bad_trav_MARK , bad_trav_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_bignum_type , bignum_obj_SIZE , bignum_obj_MARK , bignum_obj_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_rational_type , rational_obj_SIZE , rational_obj_MARK , rational_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_float_type , float_obj_SIZE , float_obj_MARK , float_obj_FIXUP , 0 , 1 ) ; 
  GC_register_traversers2 (scheme_double_type , double_obj_SIZE , double_obj_MARK , double_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_long_double_type , long_double_obj_SIZE , long_double_obj_MARK , long_double_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_complex_type , complex_obj_SIZE , complex_obj_MARK , complex_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_char_string_type , string_obj_SIZE , string_obj_MARK , string_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_byte_string_type , bstring_obj_SIZE , bstring_obj_MARK , bstring_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_unix_path_type , bstring_obj_SIZE , bstring_obj_MARK , bstring_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_windows_path_type , bstring_obj_SIZE , bstring_obj_MARK , bstring_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_symbol_type , symbol_obj_SIZE , symbol_obj_MARK , symbol_obj_FIXUP , 0 , 1 ) ; 

  GC_register_traversers2 (scheme_serialized_symbol_type , bstring_obj_SIZE , bstring_obj_MARK , bstring_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_serialized_keyword_type , bstring_obj_SIZE , bstring_obj_MARK , bstring_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_place_dead_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_keyword_type , symbol_obj_SIZE , symbol_obj_MARK , symbol_obj_FIXUP , 0 , 1 ) ; 
  GC_register_traversers2 (scheme_null_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_pair_type , cons_cell_SIZE , cons_cell_MARK , cons_cell_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_mutable_pair_type , cons_cell_SIZE , cons_cell_MARK , cons_cell_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_raw_pair_type , cons_cell_SIZE , cons_cell_MARK , cons_cell_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_vector_type , vector_obj_SIZE , vector_obj_MARK , vector_obj_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_flvector_type , flvector_obj_SIZE , flvector_obj_MARK , flvector_obj_FIXUP , 0 , 1 ) ; 



  GC_register_traversers2 (scheme_fxvector_type , fxvector_obj_SIZE , fxvector_obj_MARK , fxvector_obj_FIXUP , 0 , 1 ) ; 
  GC_register_traversers2 (scheme_cpointer_type , cpointer_obj_SIZE , cpointer_obj_MARK , cpointer_obj_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_stencil_vector_type , stencil_vector_obj_SIZE , stencil_vector_obj_MARK , stencil_vector_obj_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_bucket_type , bucket_obj_SIZE , bucket_obj_MARK , bucket_obj_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_input_port_type , input_port_SIZE , input_port_MARK , input_port_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_output_port_type , output_port_SIZE , output_port_MARK , output_port_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_eof_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_true_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_false_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_void_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_box_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_thread_type , thread_val_SIZE , thread_val_MARK , thread_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_prompt_type , prompt_val_SIZE , prompt_val_MARK , prompt_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_prompt_tag_type , cons_cell_SIZE , cons_cell_MARK , cons_cell_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_continuation_mark_key_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_cont_mark_set_type , cont_mark_set_val_SIZE , cont_mark_set_val_MARK , cont_mark_set_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_sema_type , sema_val_SIZE , sema_val_MARK , sema_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_channel_type , channel_val_SIZE , channel_val_MARK , channel_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_channel_put_type , channel_put_val_SIZE , channel_put_val_MARK , channel_put_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_semaphore_repost_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_thread_suspend_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_thread_resume_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_thread_dead_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_hash_table_type , hash_table_val_SIZE , hash_table_val_MARK , hash_table_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_bucket_table_type , bucket_table_val_SIZE , bucket_table_val_MARK , bucket_table_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_env_type , env_val_SIZE , env_val_MARK , env_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_startup_env_type , startup_env_val_SIZE , startup_env_val_MARK , startup_env_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_random_state_type , random_state_val_SIZE , random_state_val_MARK , random_state_val_FIXUP , 1 , 1 ) ; 

  GC_register_traversers2 (scheme_eval_waiting_type , bad_trav_SIZE , bad_trav_MARK , bad_trav_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_tail_call_waiting_type , bad_trav_SIZE , bad_trav_MARK , bad_trav_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_undefined_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_placeholder_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_table_placeholder_type , iptr_obj_SIZE , iptr_obj_MARK , iptr_obj_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_svector_type , svector_val_SIZE , svector_val_MARK , svector_val_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_stx_type , stx_val_SIZE , stx_val_MARK , stx_val_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_security_guard_type , guard_val_SIZE , guard_val_MARK , guard_val_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_nack_evt_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_always_evt_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_never_evt_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_thread_recv_evt_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_port_closed_evt_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_inspector_type , mark_inspector_SIZE , mark_inspector_MARK , mark_inspector_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_rt_buf_holder , buf_holder_SIZE , buf_holder_MARK , buf_holder_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_pipe , mark_pipe_SIZE , mark_pipe_MARK , mark_pipe_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_tcp_accept_evt_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_progress_evt_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_will_be_lambda_type , iptr_obj_SIZE , iptr_obj_MARK , iptr_obj_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_thread_cell_values_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_thunk_for_continue_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_global_ref_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_delay_syntax_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_logger_type , mark_logger_SIZE , mark_logger_MARK , mark_logger_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_log_reader_type , mark_log_reader_SIZE , mark_log_reader_MARK , mark_log_reader_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_rt_runstack , runstack_val_SIZE , runstack_val_MARK , runstack_val_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_noninline_proc_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_proc_shape_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_struct_proc_shape_type , struct_proc_shape_SIZE , struct_proc_shape_MARK , struct_proc_shape_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_struct_prop_proc_shape_type , small_atomic_obj_SIZE , small_atomic_obj_MARK , small_atomic_obj_FIXUP , 1 , 1 ) ; 

  GC_register_traversers2 (scheme_environment_variables_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_plumber_handle_type , twoptr_obj_SIZE , twoptr_obj_MARK , twoptr_obj_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_unquoted_printing_string_type , small_object_SIZE , small_object_MARK , small_object_FIXUP , 1 , 0 ) ; 
}

# 695 "bc/src/type.c"
static int shape_str_array_size = 0 ; 
static intptr_t * * shape_strs = ((void * ) 0 ) ; 



static int shape_size (void * p , struct NewGC * gc ) {









  return 0 ; 
}


static int shape_mark (void * p , struct NewGC * gc ) {

  intptr_t * shape_str = shape_strs [* (Scheme_Type * ) p ] ; 

  while (* shape_str != 0 ) {
    if (shape_str [0 ] == 1 ) {
      GC_mark2 (& (* (void * * ) ((char * ) p + shape_str [1 ] ) ) , gc ) ; 
    }
    shape_str += 2 ; 
  }


  return 0 ; 
}





static int shape_fixup (void * p , struct NewGC * gc ) {

  intptr_t * shape_str = shape_strs [* (Scheme_Type * ) p ] ; 

  while (* shape_str != 0 ) {
    if (shape_str [0 ] == 1 ) {
      GC_fixup2 (& (* (void * * ) ((char * ) p + shape_str [1 ] ) ) , gc ) ; 
    }
    shape_str += 2 ; 
  }


  return 0 ; 
}







void scheme_register_type_gc_shape (Scheme_Type type , intptr_t * shape_str ) 
{
  /* No conversion */

# 756 "bc/src/type.c"
  intptr_t len ; 
  GC_CAN_IGNORE intptr_t * str ; 

  for (len = 0 ; shape_str [len ] != 0 ; len += 2 ) {
  }
  len ++ ; 

  str = (intptr_t * ) malloc (len * sizeof (intptr_t ) ) ; 
  memcpy (str , shape_str , len * sizeof (intptr_t ) ) ; 

  scheme_process_global_lock () ; 

  if (shape_str_array_size <= type ) {
    GC_CAN_IGNORE intptr_t * * naya ; 
    int sz = 2 * (type + 1 ) ; 
    naya = malloc (sz * sizeof (intptr_t * ) ) ; 
    memset (naya , 0 , sz * sizeof (intptr_t * ) ) ; 
    if (shape_str_array_size ) {
      memcpy (naya , shape_strs , sizeof (intptr_t * ) * shape_str_array_size ) ; 
      free (shape_strs ) ; 
    }
    shape_strs = naya ; 
    shape_str_array_size = sz ; 
  }

  if (shape_strs [type ] )
    free (shape_strs [type ] ) ; 
  shape_strs [type ] = str ; 

  scheme_process_global_unlock () ; 

  GC_register_traversers2 (type , shape_size , shape_mark , shape_fixup , 1 , 0 ) ; 
}
