#include "precomp.h"

# 13 "bc/src/validate.c"
static int validate_expr (Mz_CPort * port , Scheme_Object * expr , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
Scheme_Object * app_rator , int proc_with_refs_ok , 
int result_ignored , struct Validate_Clearing * vc , 
int tailpos , int need_local_type , Scheme_Hash_Tree * procs , 
int expected_results , 
Scheme_Hash_Table * * _st_ht ) ; 
static int validate_rator_wants_box (Scheme_Object * app_rator , int pos , 
int hope , 
Validate_TLS tls , 
int num_toplevels , int num_lifts , void * tl_use_map ) ; 


static void register_traversers (void ) ; 


void scheme_init_validate () 
{
  /* No conversion */
  register_traversers () ; 
}

# 48 "bc/src/validate.c"
typedef struct Validate_Clearing {
  Scheme_Type type ; 
  int stackpos , stacksize ; 
  int * stack ; 
  int ncstackpos , ncstacksize ; 
  int * ncstack ; 
  int self_pos , self_count , self_start ; 
}

# 55 "bc/src/validate.c"
Validate_Clearing ; 

static struct Validate_Clearing * make_clearing_stack () 
{
  Validate_Clearing * vc ; 
  DECL_RET_SAVE (struct Validate_Clearing * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(vc, 0)));
# define XfOrM2_COUNT (1)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vc = NULLED_OUT ; 

# 60 "bc/src/validate.c"
  vc = ((Validate_Clearing * ) FUNCCALL(SETUP_XfOrM2(_), GC_malloc_one_small_tagged ((((sizeof (Validate_Clearing ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  vc -> type = scheme_rt_validate_clearing ; 
  vc -> self_pos = - 1 ; 
  RET_VALUE_START (vc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 66 "bc/src/validate.c"
static void reset_clearing (struct Validate_Clearing * vc ) 
{
  /* No conversion */

# 68 "bc/src/validate.c"
  vc -> stackpos = 0 ; 
  vc -> ncstackpos = 0 ; 
}

static void clearing_stack_push (struct Validate_Clearing * vc , int pos , int val ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(vc, 0)));
# define XfOrM4_COUNT (1)
# define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 74 "bc/src/validate.c"
  if (vc -> stackpos + 2 > vc -> stacksize ) {
    int * a , sz ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM4_COUNT)));
#   define XfOrM5_COUNT (1+XfOrM4_COUNT)
#   define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
    a = NULLED_OUT ; 

# 76 "bc/src/validate.c"
    sz = (vc -> stacksize ? 2 * vc -> stacksize : 32 ) ; 
    a = (int * ) FUNCCALL(SETUP_XfOrM5(_), GC_malloc_atomic (sizeof (int ) * sz ) ); 
    if (vc -> stacksize )
      (memcpy (a , vc -> stack , vc -> stacksize * sizeof (int ) ) ) ; 
    vc -> stacksize = sz ; 
    vc -> stack = a ; 
  }
  vc -> stack [vc -> stackpos ] = pos ; 
  vc -> stack [vc -> stackpos + 1 ] = val ; 
  vc -> stackpos += 2 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 88 "bc/src/validate.c"
static void noclear_stack_push (struct Validate_Clearing * vc , int pos ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(vc, 0)));
# define XfOrM6_COUNT (1)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 90 "bc/src/validate.c"
  if (vc -> ncstackpos + 1 > vc -> ncstacksize ) {
    int * a , sz ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM6_COUNT)));
#   define XfOrM7_COUNT (1+XfOrM6_COUNT)
#   define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
    a = NULLED_OUT ; 

# 92 "bc/src/validate.c"
    sz = (vc -> ncstacksize ? 2 * vc -> ncstacksize : 32 ) ; 
    a = (int * ) FUNCCALL(SETUP_XfOrM7(_), GC_malloc_atomic (sizeof (int ) * sz ) ); 
    if (vc -> ncstacksize )
      (memcpy (a , vc -> ncstack , vc -> ncstacksize * sizeof (int ) ) ) ; 
    vc -> ncstacksize = sz ; 
    vc -> ncstack = a ; 
  }
  vc -> ncstack [vc -> ncstackpos ] = pos ; 
  vc -> ncstackpos += 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 104 "bc/src/validate.c"
static void add_struct_mapping (Scheme_Hash_Table * * _st_ht , int pos , int shape , int for_property ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0)));
# define XfOrM8_COUNT (1)
# define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 106 "bc/src/validate.c"
  if (! * _st_ht ) {
    Scheme_Hash_Table * ht ; 
    BLOCK_SETUP((PUSH(ht, 0+XfOrM8_COUNT)));
#   define XfOrM10_COUNT (1+XfOrM8_COUNT)
#   define SETUP_XfOrM10(x) SETUP(XfOrM10_COUNT)
    ht = NULLED_OUT ; 

# 108 "bc/src/validate.c"
    ht = FUNCCALL(SETUP_XfOrM10(_), scheme_make_hash_table_eqv () ); 
    * _st_ht = ht ; 
  }

  if (for_property ) {

    shape = - (shape + 1 ) ; 
  }
  FUNCCALL_EMPTY(scheme_hash_set (* _st_ht , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (shape ) ) ) << 1 ) | 0x1 ) ) ) )


  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 122 "bc/src/validate.c"
void scheme_validate_linklet (Mz_CPort * port , Scheme_Linklet * linklet ) 
{
  char * stack ; 
  int depth , delta , num_toplevels , i , j , pos ; 
  int cnt , tl_timestamp = 1 ; 
  struct Validate_Clearing * vc ; 
  Validate_TLS tls ; 
  mzshort * tl_state ; 
  Scheme_Hash_Table * * _st_ht = ((void * ) 0 ) ; 
  Scheme_Object * form , * shape ; 
  PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(tl_state, 2), PUSH(vc, 3), PUSH(form, 4), PUSH(shape, 5), PUSH(linklet, 6), PUSH(port, 7), PUSH(tls, 8)));
# define XfOrM11_COUNT (9)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stack = NULLED_OUT ; 
  vc = NULLED_OUT ; 
  tls = NULLED_OUT ; 
  tl_state = NULLED_OUT ; 
  form = NULLED_OUT ; 
  shape = NULLED_OUT ; 

# 133 "bc/src/validate.c"
  depth = linklet -> max_let_depth + 1 ; 

  stack = FUNCCALL(SETUP_XfOrM11(_), GC_malloc_atomic (depth ) ); 
  (memset (stack , 0 , depth ) ) ; 

  stack [depth - 1 ] = 4 ; 
  delta = depth - 1 ; 

  tls = ((mzshort * * ) FUNCCALL(SETUP_XfOrM11(_), GC_malloc (sizeof (mzshort * ) * (linklet -> num_lifts ) ) )) ; 
  _st_ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM11(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 

  num_toplevels = 1 + linklet -> num_total_imports + (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) ; 

  tl_state = ((mzshort * ) FUNCCALL(SETUP_XfOrM11(_), GC_malloc_atomic (sizeof (mzshort ) * (num_toplevels ) ) )) ; 
  (memset (tl_state , 0 , sizeof (mzshort ) * num_toplevels ) ) ; 

  if (linklet -> need_instance_access )
    tl_state [0 ] = 1 ; 

  pos = 1 ; 
  for (i = 0 ; i < (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ; i ++ ) {
#   define XfOrM25_COUNT (0+XfOrM11_COUNT)
#   define SETUP_XfOrM25(x) SETUP_XfOrM11(x)

# 154 "bc/src/validate.c"
    for (j = 0 ; j < (((Scheme_Vector * ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ) ) -> size ) ; j ++ , pos ++ ) {
#     define XfOrM29_COUNT (0+XfOrM25_COUNT)
#     define SETUP_XfOrM29(x) SETUP_XfOrM25(x)

# 155 "bc/src/validate.c"
      shape = (linklet -> import_shapes ? (((Scheme_Vector * ) (linklet -> import_shapes ) ) -> els ) [pos - 1 ] : scheme_false ) ; 
      if (! (((shape ) ) == (scheme_false ) ) )  {
#       define XfOrM30_COUNT (0+XfOrM29_COUNT)
#       define SETUP_XfOrM30(x) SETUP_XfOrM29(x)

# 157 "bc/src/validate.c"
        if ((shape ) == (scheme_void ) ) 
          tl_state [pos ] = 2 ; 
        else {
          intptr_t k ; 
#         define XfOrM31_COUNT (0+XfOrM30_COUNT)
#         define SETUP_XfOrM31(x) SETUP_XfOrM30(x)

# 161 "bc/src/validate.c"
          tl_state [pos ] = 3 ; 
          if (FUNCCALL(SETUP_XfOrM31(_), scheme_decode_struct_shape (shape , & k ) ))
            FUNCCALL(SETUP_XfOrM31(_), add_struct_mapping (_st_ht , pos , k , 0 ) ); 
          else if (FUNCCALL(SETUP_XfOrM31(_), scheme_decode_struct_prop_shape (shape , & k ) ))
            FUNCCALL(SETUP_XfOrM31(_), add_struct_mapping (_st_ht , pos , k , 1 ) ); 
        }
      }

# 167 "bc/src/validate.c"
      else 
      tl_state [pos ] = 1 ; 
    }
  }

  vc = FUNCCALL(SETUP_XfOrM11(_), make_clearing_stack () ); 

  cnt = (((Scheme_Vector * ) (linklet -> bodies ) ) -> size ) ; 
  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM15_COUNT (0+XfOrM11_COUNT)
#   define SETUP_XfOrM15(x) SETUP_XfOrM11(x)

# 176 "bc/src/validate.c"
    form = (((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] ; 
    FUNCCALL(SETUP_XfOrM15(_), reset_clearing (vc ) ); 
    if (! FUNCCALL(SETUP_XfOrM15(_), validate_expr (port , form , stack , tls , depth , delta , delta , num_toplevels , linklet -> num_lifts , ((void * ) 0 ) , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 1 , 0 , ((void * ) 0 ) , - 1 , _st_ht ) )) 





    {
      tl_timestamp ++ ; 
#     define XfOrM16_COUNT (0+XfOrM15_COUNT)
#     define SETUP_XfOrM16(x) SETUP_XfOrM15(x)

# 186 "bc/src/validate.c"
      if (0 ) {
#       define XfOrM17_COUNT (0+XfOrM16_COUNT)
#       define SETUP_XfOrM17(x) SETUP_XfOrM16(x)
        (
# 187 "bc/src/validate.c"
        printf ("increment to %d for %d %p\n" , tl_timestamp , 
        ((((intptr_t ) ((((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] ) ) -> type ) , 
        (((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] ) ) ; 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 195 "bc/src/validate.c"
static int validate_join (int r1 , int r2 ) 

{
  /* No conversion */

# 198 "bc/src/validate.c"
  if (! r1 || ! r2 )

# 198 "bc/src/validate.c"
  return 0 ; 
  if ((r1 == 2 ) && (r2 == 2 ) )

# 199 "bc/src/validate.c"
  return 2 ; 
  return 1 ; 
}

static int validate_join_seq (int r1 , int r2 ) 

{
  /* No conversion */

# 206 "bc/src/validate.c"
  if (! r1 || ! r2 )

# 206 "bc/src/validate.c"
  return 0 ; 
  return r2 ; 
}





static int validate_toplevel (Scheme_Object * expr , Mz_CPort * port , 
char * stack , Validate_TLS tls , 
int depth , int delta , 
int num_toplevels , int num_lifts , void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int skip_refs_check ) 
{

# 57 "bc/src/validate.c"
  struct Validate_Clearing * __funcarg58 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(expr, 1), PUSH(tl_use_map, 2), PUSH(tl_state, 3), PUSH(port, 4), PUSH(tls, 5)));
# define XfOrM34_COUNT (6)
# define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 221 "bc/src/validate.c"
  if (! ((Scheme_Type ) (scheme_toplevel_type ) == (Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) ) )
    FUNCCALL(SETUP_XfOrM34(_), scheme_ill_formed (port , "bc/src/validate.c" , 222 ) ); 

  RET_VALUE_START ((__funcarg58 = FUNCCALL(SETUP_XfOrM34(_), make_clearing_stack () )




  , FUNCCALL_EMPTY(validate_expr (port , expr , stack , tls , depth , delta , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , skip_refs_check ? 1 : 0 , 0 , __funcarg58 , 0 , 0 , ((void * ) 0 ) , 1 , ((void * ) 0 ) ) )) ) 
# 224 "bc/src/validate.c"
  RET_VALUE_END 




  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 232 "bc/src/validate.c"
static int define_values_validate (Scheme_Object * data , Mz_CPort * port , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , 
void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht ) 
{
  int i , size , flags , result , is_struct , is_struct_prop , has_guard ; 
  Simple_Struct_Type_Info stinfo ; 
  Scheme_Object * val , * only_var ; 
  intptr_t __funcarg62 ; 
  intptr_t __funcarg60 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(tl_use_map, 2), PUSH(tl_state, 3), PUSH(vc, 4), PUSH(val, 5), PUSH(data, 6), PUSH(port, 7), PUSH(only_var, 8), PUSH(tls, 9)));
# define XfOrM35_COUNT (10)
# define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  val = NULLED_OUT ; 
  only_var = NULLED_OUT ; 

# 247 "bc/src/validate.c"
  val = (((Scheme_Vector * ) (data ) ) -> els ) [0 ] ; 
  size = (((Scheme_Vector * ) (data ) ) -> size ) ; 

  if (size == 2 )
    only_var = (((Scheme_Vector * ) (data ) ) -> els ) [1 ] ; 
  else 
  only_var = ((void * ) 0 ) ; 

  for (i = 1 ; i < size ; i ++ ) {
#   define XfOrM83_COUNT (0+XfOrM35_COUNT)
#   define SETUP_XfOrM83(x) SETUP_XfOrM35(x)
    FUNCCALL(SETUP_XfOrM83(_), validate_toplevel ((((Scheme_Vector * ) (data ) ) -> els ) [i ] , port , stack , tls , depth , delta , num_toplevels , num_lifts , tl_use_map , ((void * ) 0 ) , tl_timestamp , 1 ) )
    ; 
  }

  if (only_var ) {
    int pos ; 
#   define XfOrM59_COUNT (0+XfOrM35_COUNT)
#   define SETUP_XfOrM59(x) SETUP_XfOrM35(x)

# 264 "bc/src/validate.c"
    pos = (((Scheme_Toplevel * ) (only_var ) ) -> position ) ; 
    if (pos >= (num_toplevels - num_lifts ) ) {


      Scheme_Object * app_rator ; 
      Scheme_Lambda * data = ((void * ) 0 ) ; 
      int tp = pos - (num_toplevels - num_lifts ) ; 
      mzshort * a , * new_a = ((void * ) 0 ) ; 
      BLOCK_SETUP((PUSH(data, 0+XfOrM59_COUNT), PUSH(a, 1+XfOrM59_COUNT), PUSH(app_rator, 2+XfOrM59_COUNT), PUSH(new_a, 3+XfOrM59_COUNT)));
#     define XfOrM60_COUNT (4+XfOrM59_COUNT)
#     define SETUP_XfOrM60(x) SETUP(XfOrM60_COUNT)
      app_rator = NULLED_OUT ; 
      a = NULLED_OUT ; 

# 274 "bc/src/validate.c"
      a = tls [tp ] ; 
      if (a && (a != (mzshort * ) 0x1 ) && (a [0 ] < 1 ) )
        FUNCCALL(SETUP_XfOrM60(_), scheme_ill_formed (port , "bc/src/validate.c" , 276 ) ); 


      app_rator = val ; 
      while (1 ) {
#       define XfOrM77_COUNT (0+XfOrM60_COUNT)
#       define SETUP_XfOrM77(x) SETUP_XfOrM60(x)

# 281 "bc/src/validate.c"
        if ((Scheme_Type ) (((((intptr_t ) (app_rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (app_rator ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {
          data = ((Scheme_Closure * ) app_rator ) -> code ; 
          break ; 
        }

# 284 "bc/src/validate.c"
        else if ((Scheme_Type ) (((((intptr_t ) (app_rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (app_rator ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) )  {
          data = (Scheme_Lambda * ) app_rator ; 
          break ; 
        }

# 287 "bc/src/validate.c"
        else if ((Scheme_Type ) (((((intptr_t ) (app_rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (app_rator ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) )  {
#         define XfOrM79_COUNT (0+XfOrM77_COUNT)
#         define SETUP_XfOrM79(x) SETUP_XfOrM77(x)

# 289 "bc/src/validate.c"
          data = ((void * ) 0 ) ; 
          new_a = ((mzshort * ) FUNCCALL(SETUP_XfOrM79(_), GC_malloc_atomic (sizeof (mzshort ) * (2 ) ) )) ; 
          new_a [0 ] = 0 ; 
          new_a [1 ] = (((Scheme_Toplevel * ) (app_rator ) ) -> position ) ; 
          break ; 
        }

# 294 "bc/src/validate.c"
        else {

          data = ((void * ) 0 ) ; 
          new_a = (mzshort * ) 0x1 ; 
          break ; 
        }
      }
      if (data ) {
#       define XfOrM67_COUNT (0+XfOrM60_COUNT)
#       define SETUP_XfOrM67(x) SETUP_XfOrM60(x)

# 302 "bc/src/validate.c"
        if ((& (data ) -> iso ) -> so . keyex & 2 ) {
          int sz ; 
#         define XfOrM69_COUNT (0+XfOrM67_COUNT)
#         define SETUP_XfOrM69(x) SETUP_XfOrM67(x)

# 304 "bc/src/validate.c"
          sz = data -> num_params ; 
          new_a = ((mzshort * ) FUNCCALL(SETUP_XfOrM69(_), GC_malloc_atomic (sizeof (mzshort ) * ((sz + 2 ) ) ) )) ; 
          new_a [0 ] = - sz ; 
          new_a [sz + 1 ] = ! ! ((& (data ) -> iso ) -> so . keyex & 1 ) ; 
          for (i = 0 ; i < sz ; i ++ ) {
            int ct ; 
#           define XfOrM71_COUNT (0+XfOrM69_COUNT)
#           define SETUP_XfOrM71(x) SETUP_XfOrM69(x)

# 310 "bc/src/validate.c"
            ct = (scheme_boxmap_get (data -> closure_map , i , data -> closure_size ) ) ; 
            if (ct == 1 )
              new_a [i + 1 ] = 1 ; 
            else 
            new_a [i + 1 ] = 0 ; 
          }
        }

# 316 "bc/src/validate.c"
        else {
          new_a = (mzshort * ) 0x1 ; 
        }
      }


      tls [tp ] = new_a ; 


      if (a == (mzshort * ) 0x1 ) {
#       define XfOrM66_COUNT (0+XfOrM60_COUNT)
#       define SETUP_XfOrM66(x) SETUP_XfOrM60(x)

# 326 "bc/src/validate.c"
        if (new_a != (mzshort * ) 0x1 )
          FUNCCALL(SETUP_XfOrM66(_), scheme_ill_formed (port , "bc/src/validate.c" , 327 ) ); 
      }

# 328 "bc/src/validate.c"
      else if (a ) {
        int cnt = a [0 ] , i ; 
#       define XfOrM61_COUNT (0+XfOrM60_COUNT)
#       define SETUP_XfOrM61(x) SETUP_XfOrM60(x)

# 331 "bc/src/validate.c"
        for (i = 0 ; i < cnt ; i ++ ) {
#         define XfOrM64_COUNT (0+XfOrM61_COUNT)
#         define SETUP_XfOrM64(x) SETUP_XfOrM61(x)

# 332 "bc/src/validate.c"
          if (a [i + 1 ] ) {
            int is ; 
#           define XfOrM65_COUNT (0+XfOrM64_COUNT)
#           define SETUP_XfOrM65(x) SETUP_XfOrM64(x)

# 334 "bc/src/validate.c"
            is = FUNCCALL(SETUP_XfOrM65(_), validate_rator_wants_box (val , i , a [i + 1 ] == 2 , tls , num_toplevels , num_lifts , tl_use_map ) )

            ; 
            if ((is && (a [i + 1 ] == 1 ) ) 
            || (! is && (a [i + 1 ] == 2 ) ) )
              FUNCCALL(SETUP_XfOrM65(_), scheme_ill_formed (port , "bc/src/validate.c" , 339 ) ); 
          }
        }
      }
    }

# 343 "bc/src/validate.c"
    else 
    only_var = ((void * ) 0 ) ; 
  }

  if (FUNCCALL(SETUP_XfOrM35(_), scheme_is_simple_make_struct_type (val , size - 1 , 0x1 , ((void * ) 0 ) , & stinfo , ((void * ) 0 ) , ((void * ) 0 ) , (_st_ht ? * _st_ht : ((void * ) 0 ) ) , ((void * ) 0 ) , 0 , ((void * ) 0 ) , ((void * ) 0 ) , 5 ) )) 



  {



    is_struct = 1 ; 
  }

# 356 "bc/src/validate.c"
  else {
    is_struct = 0 ; 
  }

  has_guard = 0 ; 
  if (FUNCCALL(SETUP_XfOrM35(_), scheme_is_simple_make_struct_type_property (val , size - 1 , 0x1 , & has_guard , ((void * ) 0 ) , (_st_ht ? * _st_ht : ((void * ) 0 ) ) , ((void * ) 0 ) , 0 , ((void * ) 0 ) , 5 ) )) 


  {
    is_struct_prop = 1 ; 
  }

# 366 "bc/src/validate.c"
  else {
    is_struct_prop = 0 ; 
  }

  result = FUNCCALL(SETUP_XfOrM35(_), validate_expr (port , val , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp + ((is_struct && stinfo . uses_super ) ? 1 : 0 ) , ((void * ) 0 ) , ! ! only_var , 0 , vc , 0 , 0 , ((void * ) 0 ) , size - 1 , _st_ht ) )




  ; 

  if (is_struct ) {
#   define XfOrM51_COUNT (0+XfOrM35_COUNT)
#   define SETUP_XfOrM51(x) SETUP_XfOrM35(x)

# 378 "bc/src/validate.c"
    if (_st_ht ) {
#     define XfOrM52_COUNT (0+XfOrM51_COUNT)
#     define SETUP_XfOrM52(x) SETUP_XfOrM51(x)

      for (i = 1 ; i < size ; i ++ ) {
#       define XfOrM54_COUNT (0+XfOrM52_COUNT)
#       define SETUP_XfOrM54(x) SETUP_XfOrM52(x)
        if ((i > 1 ) 
        || (stinfo . field_count == stinfo . init_field_count ) )
          (__funcarg62 = FUNCCALL(SETUP_XfOrM54(_), scheme_get_struct_proc_shape (i - 1 , & stinfo ) )

        , FUNCCALL_AGAIN(add_struct_mapping (_st_ht , (((Scheme_Toplevel * ) ((((Scheme_Vector * ) (data ) ) -> els ) [i ] ) ) -> position ) , __funcarg62 , 0 ) )) 
        ; 
      }
    }

    result = 2 ; 
  }

# 395 "bc/src/validate.c"
  else if (is_struct_prop ) {
#   define XfOrM47_COUNT (0+XfOrM35_COUNT)
#   define SETUP_XfOrM47(x) SETUP_XfOrM35(x)

# 396 "bc/src/validate.c"
    if (_st_ht ) {
#     define XfOrM48_COUNT (0+XfOrM47_COUNT)
#     define SETUP_XfOrM48(x) SETUP_XfOrM47(x)

      for (i = 1 ; i < size ; i ++ ) {
#       define XfOrM50_COUNT (0+XfOrM48_COUNT)
#       define SETUP_XfOrM50(x) SETUP_XfOrM48(x)
        (__funcarg60 = FUNCCALL(SETUP_XfOrM50(_), scheme_get_struct_property_proc_shape (i - 1 , has_guard ) ), FUNCCALL_AGAIN(add_struct_mapping (_st_ht , (((Scheme_Toplevel * ) ((((Scheme_Vector * ) (data ) ) -> els ) [i ] ) ) -> position ) , __funcarg60 , 1 ) )) 
        ; 
      }
    }

    result = 2 ; 
  }

  flags = 1 ; 
  if (result == 2 ) {



    flags = 3 ; 
  }

  for (i = 1 ; i < size ; i ++ ) {
    int ts = (tl_timestamp + (result ? 0 : 1 ) ) ; 
#   define XfOrM41_COUNT (0+XfOrM35_COUNT)
#   define SETUP_XfOrM41(x) SETUP_XfOrM35(x)

# 421 "bc/src/validate.c"
    if (tl_state ) {
      int p = (((Scheme_Toplevel * ) ((((Scheme_Vector * ) (data ) ) -> els ) [i ] ) ) -> position ) ; 
#     define XfOrM42_COUNT (0+XfOrM41_COUNT)
#     define SETUP_XfOrM42(x) SETUP_XfOrM41(x)

# 423 "bc/src/validate.c"
      if (p < (num_toplevels - num_lifts ) ) {
        int s = - tl_state [p ] ; 
        int expected_flags = s & 0x3 ; 
        int this_flags = flags ; 
#       define XfOrM43_COUNT (0+XfOrM42_COUNT)
#       define SETUP_XfOrM43(x) SETUP_XfOrM42(x)

# 427 "bc/src/validate.c"
        if ((this_flags == 1 ) 
        && ((& ((Scheme_Toplevel * ) ((((Scheme_Vector * ) (data ) ) -> els ) [i ] ) ) -> iso ) -> so . keyex & 0x1 ) )
          this_flags = 2 ; 
        if (0 ) {
#         define XfOrM45_COUNT (0+XfOrM43_COUNT)
#         define SETUP_XfOrM45(x) SETUP_XfOrM43(x)
          (
# 431 "bc/src/validate.c"
          printf ("%d is %d for %d %p; at %d\n" , p , this_flags , ((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) , val , ts ) ) ; 
        }
        if (tl_state [p ] > 0 )
          FUNCCALL(SETUP_XfOrM43(_), scheme_ill_formed (port , "bc/src/validate.c" , 434 ) ); 
        if ((expected_flags > this_flags ) 
        || (expected_flags 




        && ((s >> 2 ) <= ts ) ) ) {
#         define XfOrM44_COUNT (0+XfOrM43_COUNT)
#         define SETUP_XfOrM44(x) SETUP_XfOrM43(x)
          FUNCCALL(SETUP_XfOrM44(_), scheme_ill_formed (port , "bc/src/validate.c" , 442 ) )
# 442 "bc/src/validate.c"
          ; 
        }
        tl_state [p ] = (ts << 2 ) | this_flags ; 
      }
    }
  }

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 452 "bc/src/validate.c"
static int set_validate (Scheme_Object * data , Mz_CPort * port , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , 
void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht ) 
{
  Scheme_Set_Bang * sb = (Scheme_Set_Bang * ) data ; 
  int r1 , r2 ; 

# 203 "bc/src/validate.c"
  int __funcarg63 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(tl_use_map, 1), PUSH(sb, 2), PUSH(port, 3), PUSH(tl_state, 4), PUSH(tls, 5)));
# define XfOrM84_COUNT (6)
# define SETUP_XfOrM84(x) SETUP(XfOrM84_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 466 "bc/src/validate.c"
  r1 = FUNCCALL(SETUP_XfOrM84(_), validate_expr (port , sb -> val , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


  ; 
  r2 = FUNCCALL_EMPTY(validate_toplevel (sb -> var , port , stack , tls , depth , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , 0 ) )


  ; 

  RET_VALUE_START ((__funcarg63 = FUNCCALL_EMPTY(validate_join_seq (r1 , r2 ) ), FUNCCALL_EMPTY(validate_join (__funcarg63 , 2 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 478 "bc/src/validate.c"
static void ref_validate (Scheme_Object * data , Mz_CPort * port , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , 
void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
Scheme_Hash_Tree * procs ) 
{
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(data, 0), PUSH(stack, 1), PUSH(tl_use_map, 2), PUSH(tl_state, 3), PUSH(port, 4), PUSH(tls, 5)));
# define XfOrM85_COUNT (6)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 488 "bc/src/validate.c"
  tl_timestamp = tl_timestamp + 1 ; 

  if (! ((((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) ) ) == (scheme_false ) ) )
    FUNCCALL(SETUP_XfOrM85(_), validate_toplevel ((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) , port , stack , tls , depth , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , 0 ) )


  ; 

  if (! ((((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) ) ) == (scheme_false ) ) ) {

    int p ; 
#   define XfOrM86_COUNT (0+XfOrM85_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM85(x)

# 499 "bc/src/validate.c"
    data = (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) ; 
    if (! ((Scheme_Type ) (scheme_toplevel_type ) == (Scheme_Type ) (((((intptr_t ) (data ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (data ) ) -> type ) ) ) )
      FUNCCALL(SETUP_XfOrM86(_), scheme_ill_formed (port , "bc/src/validate.c" , 501 ) ); 
    p = (((Scheme_Toplevel * ) (data ) ) -> position ) ; 
    if (p != 0 )
      FUNCCALL(SETUP_XfOrM86(_), scheme_ill_formed (port , "bc/src/validate.c" , 504 ) ); 
    FUNCCALL_EMPTY(validate_toplevel (data , port , stack , tls , depth , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , 0 ) )



    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 513 "bc/src/validate.c"
static int apply_values_validate (Scheme_Object * data , Mz_CPort * port , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , 
void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht ) 
{
  Scheme_Object * f , * e ; 
  int r1 , r2 ; 
  PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(tl_state, 2), PUSH(tl_use_map, 3), PUSH(vc, 4), PUSH(procs, 5), PUSH(e, 6), PUSH(port, 7), PUSH(tls, 8)));
# define XfOrM87_COUNT (9)
# define SETUP_XfOrM87(x) SETUP(XfOrM87_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  f = NULLED_OUT ; 
  e = NULLED_OUT ; 

# 527 "bc/src/validate.c"
  f = (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) ; 
  e = (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) ; 

  r1 = FUNCCALL(SETUP_XfOrM87(_), validate_expr (port , f , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )



  ; 
  r2 = FUNCCALL_EMPTY(validate_expr (port , e , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , - 1 , _st_ht ) )



  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(validate_join (r1 , r2 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 544 "bc/src/validate.c"
static void inline_variant_validate (Scheme_Object * data , Mz_CPort * port , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , 
void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht ) 
{
  Scheme_Object * f1 , * f2 ; 
  PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(tl_state, 2), PUSH(tl_use_map, 3), PUSH(f2, 4), PUSH(vc, 5), PUSH(procs, 6), PUSH(port, 7), PUSH(tls, 8)));
# define XfOrM88_COUNT (9)
# define SETUP_XfOrM88(x) SETUP(XfOrM88_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  f1 = NULLED_OUT ; 
  f2 = NULLED_OUT ; 

# 557 "bc/src/validate.c"
  f1 = (((Scheme_Vector * ) (data ) ) -> els ) [0 ] ; 
  f2 = (((Scheme_Vector * ) (data ) ) -> els ) [1 ] ; 
  FUNCCALL(SETUP_XfOrM88(_), validate_expr (port , f1 , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )




  ; 
  FUNCCALL_EMPTY(validate_expr (port , f2 , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )



  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 572 "bc/src/validate.c"
static void case_lambda_validate (Scheme_Object * data , Mz_CPort * port , char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , 
void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht ) 
{
  Scheme_Case_Lambda * seq = (Scheme_Case_Lambda * ) data ; 
  Scheme_Object * e ; 
  int i ; 
  PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(seq, 2), PUSH(tl_use_map, 3), PUSH(tl_state, 4), PUSH(vc, 5), PUSH(procs, 6), PUSH(e, 7), PUSH(port, 8), PUSH(tls, 9)));
# define XfOrM89_COUNT (10)
# define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  e = NULLED_OUT ; 

# 586 "bc/src/validate.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (data ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (data ) ) -> type ) ) == (Scheme_Type ) (scheme_case_lambda_sequence_type ) ) )
    FUNCCALL(SETUP_XfOrM89(_), scheme_ill_formed (port , "bc/src/validate.c" , 587 ) ); 

  for (i = 0 ; i < seq -> count ; i ++ ) {
#   define XfOrM91_COUNT (0+XfOrM89_COUNT)
#   define SETUP_XfOrM91(x) SETUP_XfOrM89(x)

# 590 "bc/src/validate.c"
    e = seq -> array [i ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) 
    && ! ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) )
      FUNCCALL(SETUP_XfOrM91(_), scheme_ill_formed (port , "bc/src/validate.c" , 593 ) ); 
    FUNCCALL(SETUP_XfOrM91(_), validate_expr (port , e , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 601 "bc/src/validate.c"
static void validate_boxenv (int p , Mz_CPort * port , char * stack , int depth , int delta , int letlimit ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(stack, 0)));
# define XfOrM92_COUNT (1)
# define SETUP_XfOrM92(x) SETUP(XfOrM92_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 603 "bc/src/validate.c"
  if (p >= 0 )
    p += delta ; 

  if ((p < 0 ) || (p >= letlimit ) || (stack [p ] != 2 ) )
    FUNCCALL(SETUP_XfOrM92(_), scheme_ill_formed (port , "bc/src/validate.c" , 607 ) ); 

  stack [p ] = 3 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 612 "bc/src/validate.c"
static int bangboxenv_validate (Scheme_Object * data , Mz_CPort * port , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , 
void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht , 
int expected_results ) 
{
  PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(tl_state, 2), PUSH(tl_use_map, 3), PUSH(vc, 4), PUSH(data, 5), PUSH(procs, 6), PUSH(port, 7), PUSH(tls, 8)));
# define XfOrM93_COUNT (9)
# define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM93(_), validate_boxenv ((((intptr_t ) ((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) ) ) >> 1 ) , port , stack , depth , delta , letlimit ) )
# 624 "bc/src/validate.c"
  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(validate_expr (port , (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , result_ignored , vc , tailpos , 0 , procs , expected_results , _st_ht ) )) RET_VALUE_EMPTY_END 


  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 632 "bc/src/validate.c"
static int begin0_validate (Scheme_Object * data , Mz_CPort * port , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , 
void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht , 
int expected_results ) 
{
  Scheme_Sequence * seq = (Scheme_Sequence * ) data ; 
  int i , r , result = 2 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(seq, 2), PUSH(tl_state, 3), PUSH(tl_use_map, 4), PUSH(vc, 5), PUSH(procs, 6), PUSH(port, 7), PUSH(tls, 8)));
# define XfOrM94_COUNT (9)
# define SETUP_XfOrM94(x) SETUP(XfOrM94_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 647 "bc/src/validate.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (seq ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (seq ) ) -> type ) ) == (Scheme_Type ) (scheme_begin0_sequence_type ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (seq ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (seq ) ) -> type ) ) == (Scheme_Type ) (scheme_sequence_type ) ) )
    FUNCCALL(SETUP_XfOrM94(_), scheme_ill_formed (port , "bc/src/validate.c" , 649 ) ); 

  for (i = 0 ; i < seq -> count ; i ++ ) {
#   define XfOrM96_COUNT (0+XfOrM94_COUNT)
#   define SETUP_XfOrM96(x) SETUP_XfOrM94(x)

# 652 "bc/src/validate.c"
    r = FUNCCALL(SETUP_XfOrM96(_), validate_expr (port , seq -> array [i ] , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , i > 0 , vc , 0 , 0 , procs , (i > 0 ) ? - 1 : expected_results , _st_ht ) )




    ; 
    result = FUNCCALL(SETUP_XfOrM96(_), validate_join_seq (r , result ) ); 
  }

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * validate_k (void ) 
{
  /* No conversion */

# 670 "bc/src/validate.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Mz_CPort * port = (Mz_CPort * ) p -> ku . k . p1 ; 
  Scheme_Object * expr = (Scheme_Object * ) p -> ku . k . p2 ; 
  char * stack = (char * ) p -> ku . k . p3 ; 
  int * args = (int * ) (((void * * ) p -> ku . k . p5 ) [0 ] ) ; 
  Scheme_Object * app_rator = (Scheme_Object * ) (((void * * ) p -> ku . k . p5 ) [1 ] ) ; 
  Validate_TLS tls = (Validate_TLS ) (((void * * ) p -> ku . k . p5 ) [2 ] ) ; 
  Scheme_Hash_Tree * procs = (Scheme_Hash_Tree * ) (((void * * ) p -> ku . k . p5 ) [3 ] ) ; 
  struct Validate_Clearing * vc = (struct Validate_Clearing * ) p -> ku . k . p4 ; 
  void * tl_use_map = (((void * * ) p -> ku . k . p5 ) [4 ] ) ; 
  mzshort * tl_state = (((void * * ) p -> ku . k . p5 ) [5 ] ) ; 
  Scheme_Hash_Table * * _st_ht = (((void * * ) p -> ku . k . p5 ) [6 ] ) ; 
  int r ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 

  r = validate_expr (port , expr , stack , tls , 
  args [0 ] , args [1 ] , args [2 ] , 
  args [3 ] , args [5 ] , tl_use_map , 
  tl_state , args [10 ] , 
  app_rator , args [6 ] , args [7 ] , vc , args [8 ] , 
  args [9 ] , procs , args [11 ] , 
  _st_ht ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ; 
}




int validate_rator_wants_box (Scheme_Object * app_rator , int pos , 
int hope , 
Validate_TLS tls , 
int num_toplevels , int num_lifts , void * tl_use_map ) 
{
  Scheme_Lambda * data = ((void * ) 0 ) ; 
  Scheme_Type ty ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(data, 0), PUSH(app_rator, 1), PUSH(tls, 2)));
# define XfOrM98_COUNT (3)
# define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 712 "bc/src/validate.c"
  while (1 ) {
#   define XfOrM123_COUNT (0+XfOrM98_COUNT)
#   define SETUP_XfOrM123(x) SETUP_XfOrM98(x)

# 713 "bc/src/validate.c"
    ty = ((((intptr_t ) (app_rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (app_rator ) ) -> type ) ; 
    if ((Scheme_Type ) (ty ) == (Scheme_Type ) (scheme_closure_type ) )  {
      data = ((Scheme_Closure * ) app_rator ) -> code ; 
      break ; 
    }

# 717 "bc/src/validate.c"
    else if ((Scheme_Type ) (ty ) == (Scheme_Type ) (scheme_lambda_type ) )  {
      data = (Scheme_Lambda * ) app_rator ; 
      break ; 
    }

# 720 "bc/src/validate.c"
    else if ((Scheme_Type ) (ty ) == (Scheme_Type ) (scheme_toplevel_type ) )  {
      int p ; 
#     define XfOrM124_COUNT (0+XfOrM123_COUNT)
#     define SETUP_XfOrM124(x) SETUP_XfOrM123(x)

# 722 "bc/src/validate.c"
      p = (((Scheme_Toplevel * ) (app_rator ) ) -> position ) ; 
      while (1 ) {
#       define XfOrM134_COUNT (0+XfOrM124_COUNT)
#       define SETUP_XfOrM134(x) SETUP_XfOrM124(x)

# 724 "bc/src/validate.c"
        if (p >= (num_toplevels - num_lifts ) ) {


          mzshort * a ; 



          int tp ; 
          BLOCK_SETUP((PUSH(a, 0+XfOrM134_COUNT)));
#         define XfOrM135_COUNT (1+XfOrM134_COUNT)
#         define SETUP_XfOrM135(x) SETUP(XfOrM135_COUNT)
          a = NULLED_OUT ; 

# 733 "bc/src/validate.c"
          tp = (p - (num_toplevels - num_lifts ) ) ; 
          if (tp >= num_lifts )
            RET_VALUE_START (0 ) RET_VALUE_END ; 

          a = tls [tp ] ; 
          if (a == (mzshort * ) 0x1 ) {
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 740 "bc/src/validate.c"
          else if (! a || (a [0 ] > 0 ) ) {
#           define XfOrM139_COUNT (0+XfOrM135_COUNT)
#           define SETUP_XfOrM139(x) SETUP_XfOrM135(x)
            if (! a || (a [0 ] < (pos + 1 ) ) ) {
              mzshort * naya ; 
              int sz ; 
              BLOCK_SETUP((PUSH(naya, 0+XfOrM139_COUNT)));
#             define XfOrM141_COUNT (1+XfOrM139_COUNT)
#             define SETUP_XfOrM141(x) SETUP(XfOrM141_COUNT)
              naya = NULLED_OUT ; 

# 746 "bc/src/validate.c"
              if (a )
                sz = a [0 ] ; 
              else 
              sz = 3 ; 
              sz *= 2 ; 
              if (sz <= pos )
                sz = pos + 1 ; 
              naya = FUNCCALL(SETUP_XfOrM141(_), GC_malloc_atomic ((sz + 1 ) * sizeof (mzshort ) ) ); 
              (memset (naya , 0 , (sz + 1 ) * sizeof (mzshort ) ) ) ; 
              if (a )
                (memcpy (naya , a , (a [0 ] + 1 ) * sizeof (mzshort ) ) ) ; 
              naya [0 ] = sz ; 
              a = naya ; 
              tls [tp ] = a ; 
            }

            if (! a [pos + 1 ] ) {
              a [pos + 1 ] = hope ? 2 : 1 ; 
              RET_VALUE_START (hope ) RET_VALUE_END ; 
            }

# 765 "bc/src/validate.c"
            else if (a [pos + 1 ] == 2 )
              RET_VALUE_START (1 ) RET_VALUE_END ; 
            else 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 769 "bc/src/validate.c"
          else if (! a [0 ] ) {

            p = a [1 ] ; 
          }

# 772 "bc/src/validate.c"
          else {
            if (pos >= - a [0 ] ) {

              RET_VALUE_START ((a [- a [0 ] + 1 ] ? hope : ! hope ) ) RET_VALUE_END ; 
            }

# 776 "bc/src/validate.c"
            else 
            RET_VALUE_START (a [pos + 1 ] ) RET_VALUE_END ; 
          }
        }

# 779 "bc/src/validate.c"
        else 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }

# 782 "bc/src/validate.c"
    else 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  if ((& (data ) -> iso ) -> so . keyex & 2 ) {
#   define XfOrM99_COUNT (0+XfOrM98_COUNT)
#   define SETUP_XfOrM99(x) SETUP_XfOrM98(x)

# 787 "bc/src/validate.c"
    if (pos < data -> num_params ) {
      int ct ; 
#     define XfOrM100_COUNT (0+XfOrM99_COUNT)
#     define SETUP_XfOrM100(x) SETUP_XfOrM99(x)

# 789 "bc/src/validate.c"
      ct = (scheme_boxmap_get (data -> closure_map , pos , data -> closure_size ) ) ; 
      if (ct == 1 )
        RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 798 "bc/src/validate.c"
static int argument_to_arity_error (Scheme_Object * app_rator , int proc_with_refs_ok ) 
{
  /* No conversion */


  return ((proc_with_refs_ok == 2 ) 
  && ((app_rator ) == (scheme_raise_arity_error_proc ) ) ) ; 
}

void scheme_validate_closure (Mz_CPort * port , Scheme_Object * expr , 
char * closure_stack , Validate_TLS tls , 
int num_toplevels , int num_lifts , void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
int self_pos_in_closure , Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht ) 
{
  Scheme_Lambda * data = (Scheme_Lambda * ) expr ; 
  int i , sz , cnt , base , base2 ; 
  char * new_stack ; 
  struct Validate_Clearing * vc ; 
  PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(data, 1), PUSH(tl_use_map, 2), PUSH(tl_state, 3), PUSH(vc, 4), PUSH(procs, 5), PUSH(new_stack, 6), PUSH(closure_stack, 7), PUSH(port, 8), PUSH(tls, 9)));
# define XfOrM146_COUNT (10)
# define SETUP_XfOrM146(x) SETUP(XfOrM146_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  new_stack = NULLED_OUT ; 
  vc = NULLED_OUT ; 

# 819 "bc/src/validate.c"
  if (data -> max_let_depth < (data -> num_params + data -> closure_size ) )
    FUNCCALL(SETUP_XfOrM146(_), scheme_ill_formed (port , "bc/src/validate.c" , 820 ) ); 

  sz = data -> max_let_depth ; 
  new_stack = FUNCCALL(SETUP_XfOrM146(_), GC_malloc_atomic (sz ) ); 
  (memset (new_stack , 0 , sz - data -> num_params - data -> closure_size ) ) ; 

  cnt = data -> num_params ; 
  base = sz - cnt ; 

  if ((& (data ) -> iso ) -> so . keyex & 2 ) {
    base2 = data -> closure_size ; 
    for (i = 0 ; i < cnt ; i ++ ) {
      new_stack [base + i ] = closure_stack [base2 + i ] ; 
    }
  }

# 834 "bc/src/validate.c"
  else {
    for (i = 0 ; i < cnt ; i ++ ) {
      new_stack [i + base ] = 2 ; 
    }
  }

  cnt = data -> closure_size ; 
  base = base - cnt ; 
  for (i = 0 ; i < cnt ; i ++ ) {
    new_stack [i + base ] = closure_stack [i ] ; 
  }

  vc = FUNCCALL(SETUP_XfOrM146(_), make_clearing_stack () ); 
  if (self_pos_in_closure >= 0 ) {
    vc -> self_pos = base + self_pos_in_closure ; 
    vc -> self_count = data -> closure_size ; 
    vc -> self_start = base ; 
  }

  if (data -> tl_map ) {
#   define XfOrM147_COUNT (0+XfOrM146_COUNT)
#   define SETUP_XfOrM147(x) SETUP_XfOrM146(x)

# 854 "bc/src/validate.c"
    if (tl_use_map ) {

      int * a , a_buf [2 ] , len ; 
      BLOCK_SETUP((PUSH(a, 0+XfOrM147_COUNT)));
#     define XfOrM148_COUNT (1+XfOrM147_COUNT)
#     define SETUP_XfOrM148(x) SETUP(XfOrM148_COUNT)
      a = NULLED_OUT ; 

# 858 "bc/src/validate.c"
      if ((uintptr_t ) tl_use_map & 0x1 ) {
        len = 1 ; 
        a_buf [1 ] = (((uintptr_t ) data -> tl_map ) >> 1 ) & 0x7FFFFFFF ; 
        a = a_buf ; 
      }

# 862 "bc/src/validate.c"
      else {
        len = ((int * ) tl_use_map ) [0 ] ; 
        a = (int * ) tl_use_map ; 
      }

      if (tl_use_map ) {
#       define XfOrM149_COUNT (0+XfOrM148_COUNT)
#       define SETUP_XfOrM149(x) SETUP_XfOrM148(x)

# 868 "bc/src/validate.c"
        if ((uintptr_t ) data -> tl_map & 0x1 ) {
          int map = (((uintptr_t ) data -> tl_map ) >> 1 ) & 0x7FFFFFFF ; 
#         define XfOrM153_COUNT (0+XfOrM149_COUNT)
#         define SETUP_XfOrM153(x) SETUP_XfOrM149(x)

# 870 "bc/src/validate.c"
          if ((len < 1 ) || ((a [1 ] & map ) != map ) )
            FUNCCALL(SETUP_XfOrM153(_), scheme_ill_formed (port , "bc/src/validate.c" , 871 ) ); 
        }

# 872 "bc/src/validate.c"
        else {
          int * b = ((int * ) data -> tl_map ) ; 
          BLOCK_SETUP((PUSH(b, 0+XfOrM149_COUNT)));
#         define XfOrM150_COUNT (1+XfOrM149_COUNT)
#         define SETUP_XfOrM150(x) SETUP(XfOrM150_COUNT)

# 874 "bc/src/validate.c"
          for (i = b [0 ] ; i -- ; ) {
#           define XfOrM152_COUNT (0+XfOrM150_COUNT)
#           define SETUP_XfOrM152(x) SETUP_XfOrM150(x)

# 875 "bc/src/validate.c"
            if ((len <= i ) || ((a [i + 1 ] & b [i + 1 ] ) != b [i + 1 ] ) )
              FUNCCALL(SETUP_XfOrM152(_), scheme_ill_formed (port , "bc/src/validate.c" , 876 ) ); 
          }
        }
      }
    }
    tl_use_map = data -> tl_map ; 
  }
  FUNCCALL_EMPTY(validate_expr (port , data -> body , new_stack , tls , sz , sz , base , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 1 , 0 , procs , - 1 , _st_ht ) )



  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 890 "bc/src/validate.c"
static Scheme_Hash_Tree * as_nonempty_procs (Scheme_Hash_Tree * procs ) 
{
  /* No conversion */

# 892 "bc/src/validate.c"
  if (! procs )
    procs = scheme_make_hash_tree (SCHEME_hashtr_eq ) ; 
  return procs ; 
}

static void validate_lambda (Mz_CPort * port , Scheme_Object * expr , 
char * stack , Validate_TLS tls , 
int depth , int delta , 
int num_toplevels , int num_lifts , void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
Scheme_Object * app_rator , int proc_with_refs_ok , 
int self_pos , Scheme_Hash_Tree * procs , 
Scheme_Hash_Table * * _st_ht ) 
{
  Scheme_Lambda * data = (Scheme_Lambda * ) expr ; 
  int i , cnt , q , p , sz , base , stack_delta , vld , self_pos_in_closure = - 1 , typed_arg = 0 ; 
  mzshort * map ; 
  char * closure_stack ; 
  Scheme_Object * proc ; 
  Scheme_Hash_Tree * new_procs = ((void * ) 0 ) ; 

# 890 "bc/src/validate.c"
  Scheme_Hash_Tree * __funcarg65 = NULLED_OUT ; 
  PREPARE_VAR_STACK(15);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(tl_use_map, 2), PUSH(proc, 3), PUSH(expr, 4), PUSH(app_rator, 5), PUSH(data, 6), PUSH(tl_state, 7), PUSH(procs, 8), PUSH(new_procs, 9), PUSH(map, 10), PUSH(closure_stack, 11), PUSH(port, 12), PUSH(tls, 13)));
# define XfOrM166_COUNT (14)
# define SETUP_XfOrM166(x) SETUP(XfOrM166_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  map = NULLED_OUT ; 
  closure_stack = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 913 "bc/src/validate.c"
  if ((& (data ) -> iso ) -> so . keyex & 2 ) {
    sz = data -> closure_size + data -> num_params ; 
  }

# 915 "bc/src/validate.c"
  else {
    sz = data -> closure_size ; 
  }
  map = data -> closure_map ; 

  if (sz )
    closure_stack = FUNCCALL(SETUP_XfOrM166(_), GC_malloc_atomic (sz ) ); 
  else 
  closure_stack = ((void * ) 0 ) ; 

  if ((& (data ) -> iso ) -> so . keyex & 2 ) {
#   define XfOrM178_COUNT (0+XfOrM166_COUNT)
#   define SETUP_XfOrM178(x) SETUP_XfOrM166(x)

# 926 "bc/src/validate.c"
    cnt = data -> num_params ; 
    base = sz - cnt ; 
    for (i = 0 ; i < cnt ; i ++ ) {
      int ct ; 
#     define XfOrM182_COUNT (0+XfOrM178_COUNT)
#     define SETUP_XfOrM182(x) SETUP_XfOrM178(x)

# 930 "bc/src/validate.c"
      ct = (scheme_boxmap_get (map , i , data -> closure_size ) ) ; 
      if (ct == 1 ) {
        vld = 3 ; 
        typed_arg = 1 ; 
      }

# 934 "bc/src/validate.c"
      else if (ct ) {
#       define XfOrM183_COUNT (0+XfOrM182_COUNT)
#       define SETUP_XfOrM183(x) SETUP_XfOrM182(x)

# 935 "bc/src/validate.c"
        if ((ct - 1 ) > 3 )
          FUNCCALL(SETUP_XfOrM183(_), scheme_ill_formed (port , "bc/src/validate.c" , 936 ) ); 
        vld = (7 + (ct - 1 ) ) ; 
        typed_arg = 1 ; 
      }

# 939 "bc/src/validate.c"
      else 
      vld = 2 ; 
      closure_stack [i + base ] = vld ; 
    }
  }

# 943 "bc/src/validate.c"
  else {
    base = sz ; 
  }

  cnt = data -> closure_size ; 
  base = base - cnt ; 
  stack_delta = data -> max_let_depth - sz ; 

  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM173_COUNT (0+XfOrM166_COUNT)
#   define SETUP_XfOrM173(x) SETUP_XfOrM166(x)

# 952 "bc/src/validate.c"
    q = map [i ] ; 
    if (q == self_pos )
      self_pos_in_closure = i ; 
    p = q + delta ; 
    if ((q < 0 ) || (p < 0 ) || (p >= depth ) || (stack [p ] <= 1 ) )
      FUNCCALL(SETUP_XfOrM173(_), scheme_ill_formed (port , "bc/src/validate.c" , 957 ) ); 
    vld = stack [p ] ; 
    if (vld == 5 )
      vld = 2 ; 
    else if (vld == 6 )
      vld = 3 ; 

    if ((& (data ) -> iso ) -> so . keyex & 2 ) {
      int pos = data -> num_params + i ; 
      int ct ; 
#     define XfOrM175_COUNT (0+XfOrM173_COUNT)
#     define SETUP_XfOrM175(x) SETUP_XfOrM173(x)

# 967 "bc/src/validate.c"
      ct = (scheme_boxmap_get (map , pos , data -> closure_size ) ) ; 
      if (ct == 1 )
        FUNCCALL(SETUP_XfOrM175(_), scheme_ill_formed (port , "bc/src/validate.c" , 969 ) ); 
      if (ct > 1 ) {
        if (vld != (7 + (ct - 1 ) ) )
          vld = 0 ; 
      }

# 973 "bc/src/validate.c"
      else if (vld > 7 )
        vld = 0 ; 
    }

# 975 "bc/src/validate.c"
    else if (vld > 7 )
      vld = 0 ; 

    closure_stack [i + base ] = vld ; 

    if (procs ) {
#     define XfOrM174_COUNT (0+XfOrM173_COUNT)
#     define SETUP_XfOrM174(x) SETUP_XfOrM173(x)

# 981 "bc/src/validate.c"
      proc = FUNCCALL(SETUP_XfOrM174(_), scheme_hash_tree_get (procs , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (p ) ) ) << 1 ) | 0x1 ) ) ) ); 
      if (proc )
        new_procs = (__funcarg65 = FUNCCALL(SETUP_XfOrM174(_), as_nonempty_procs (new_procs ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (__funcarg65 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i + base + stack_delta ) ) ) << 1 ) | 0x1 ) ) , proc ) )) 

      ; 
    }
  }

  if (typed_arg ) {
#   define XfOrM168_COUNT (0+XfOrM166_COUNT)
#   define SETUP_XfOrM168(x) SETUP_XfOrM166(x)

# 990 "bc/src/validate.c"
    if ((proc_with_refs_ok != 1 ) 
    && ! FUNCCALL(SETUP_XfOrM168(_), argument_to_arity_error (app_rator , proc_with_refs_ok ) ))
      FUNCCALL(SETUP_XfOrM168(_), scheme_ill_formed (port , "bc/src/validate.c" , 992 ) ); 
  }

  tl_timestamp ++ ; 

  if ((Scheme_Type ) (((((intptr_t ) (data -> body ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (data -> body ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) )  {

    Scheme_Object * vec ; 
    BLOCK_SETUP((PUSH(vec, 0+XfOrM166_COUNT)));
#   define XfOrM167_COUNT (1+XfOrM166_COUNT)
#   define SETUP_XfOrM167(x) SETUP(XfOrM167_COUNT)
    vec = NULLED_OUT ; 

# 1000 "bc/src/validate.c"
    vec = FUNCCALL(SETUP_XfOrM167(_), scheme_make_vector (12 , ((void * ) 0 ) ) ); 
    (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = (((Scheme_Simple_Object * ) (data -> body ) ) -> u . pair_val . car ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (Scheme_Object * ) closure_stack ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = (Scheme_Object * ) tls ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_toplevels ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [4 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [5 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_lifts ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [6 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (self_pos_in_closure ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [7 ] = new_procs ? (Scheme_Object * ) new_procs : scheme_false ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [8 ] = tl_use_map ? tl_use_map : scheme_false ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [9 ] = tl_state ? (Scheme_Object * ) tl_state : scheme_false ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [10 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (tl_timestamp ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [11 ] = (Scheme_Object * ) _st_ht ; 
    (((Scheme_Simple_Object * ) (data -> body ) ) -> u . pair_val . car ) = vec ; 
  }

# 1014 "bc/src/validate.c"
  else FUNCCALL_EMPTY(scheme_validate_closure (port , expr , closure_stack , tls , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , self_pos_in_closure , new_procs , _st_ht ) )



  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1021 "bc/src/validate.c"
static void check_self_call_valid (Scheme_Object * rator , Mz_CPort * port , struct Validate_Clearing * vc , 
int delta , char * stack ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(port, 1), PUSH(vc, 2)));
# define XfOrM187_COUNT (3)
# define SETUP_XfOrM187(x) SETUP(XfOrM187_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1024 "bc/src/validate.c"
  if ((vc -> self_pos >= 0 ) 
  && ((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_local_type ) ) 
  && ! ((& ((Scheme_Local * ) (rator ) ) -> iso ) -> so . keyex & ~ 0x2000 ) 
  && (((((Scheme_Local * ) (rator ) ) -> position ) + delta ) == vc -> self_pos ) ) {

    int i , pos ; 
#   define XfOrM188_COUNT (0+XfOrM187_COUNT)
#   define SETUP_XfOrM188(x) SETUP_XfOrM187(x)

# 1030 "bc/src/validate.c"
    for (i = vc -> self_count ; i -- ; ) {
#     define XfOrM190_COUNT (0+XfOrM188_COUNT)
#     define SETUP_XfOrM190(x) SETUP_XfOrM188(x)

# 1031 "bc/src/validate.c"
      pos = i + vc -> self_start ; 
      if (stack [pos ] <= 1 )
        FUNCCALL(SETUP_XfOrM190(_), scheme_ill_formed (port , "bc/src/validate.c" , 1033 ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1038 "bc/src/validate.c"
static void no_typed (int need_local_type , Mz_CPort * port ) 
{
  /* No conversion */

# 1040 "bc/src/validate.c"
  if (need_local_type )

# 1040 "bc/src/validate.c"
  scheme_ill_formed (port , "bc/src/validate.c" , 1040 ) ; 
}

static void check_typed (Scheme_Object * expr , int need_local_type , Mz_CPort * port ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM192_COUNT (1)
# define SETUP_XfOrM192(x) SETUP(XfOrM192_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1045 "bc/src/validate.c"
  if (need_local_type ) {
#   define XfOrM193_COUNT (0+XfOrM192_COUNT)
#   define SETUP_XfOrM193(x) SETUP_XfOrM192(x)

# 1046 "bc/src/validate.c"
    if (FUNCCALL(SETUP_XfOrM193(_), scheme_expr_produces_local_type (expr , ((void * ) 0 ) ) )!= need_local_type )
      FUNCCALL_EMPTY(scheme_ill_formed (port , "bc/src/validate.c" , 1047 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1051 "bc/src/validate.c"
static int validate_join_const (int result , int expected_results ) 
{
  /* No conversion */

# 1053 "bc/src/validate.c"
  return validate_join_seq (result , 
  (((expected_results == 1 ) || (expected_results == - 1 ) ) 
  ? 2 
  : 0 ) ) ; 
}

static int is_functional_nonfailing_rator (Scheme_Object * rator , int num_args , int expected_results , 
Scheme_Hash_Table * * _st_ht ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(rator, 0)));
# define XfOrM195_COUNT (1)
# define SETUP_XfOrM195(x) SETUP(XfOrM195_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1062 "bc/src/validate.c"
  if (_st_ht && * _st_ht && ((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) ) {
    int flags = ((& ((Scheme_Toplevel * ) (rator ) ) -> iso ) -> so . keyex & 0x3 ) ; 
#   define XfOrM196_COUNT (0+XfOrM195_COUNT)
#   define SETUP_XfOrM196(x) SETUP_XfOrM195(x)

# 1064 "bc/src/validate.c"
    if (flags == 3 ) {

      int pos = (((Scheme_Toplevel * ) (rator ) ) -> position ) ; 
      Scheme_Object * v ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM196_COUNT)));
#     define XfOrM197_COUNT (1+XfOrM196_COUNT)
#     define SETUP_XfOrM197(x) SETUP(XfOrM197_COUNT)
      v = NULLED_OUT ; 

# 1068 "bc/src/validate.c"
      v = FUNCCALL(SETUP_XfOrM197(_), scheme_hash_get (* _st_ht , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) ) ); 
      if (v ) {
        int k = (((intptr_t ) (v ) ) >> 1 ) ; 
        if (((k & 0x7 ) == 1 ) 
        && (k & 0x20 ) ) {
          if (num_args == (k >> 7 ) )
            RET_VALUE_START (1 ) RET_VALUE_END ; 
        }

# 1075 "bc/src/validate.c"
        else if ((k & 0x7 ) == 2 ) {
          if (num_args == 1 )
            RET_VALUE_START (1 ) RET_VALUE_END ; 
        }
      }
    }
  }

  RET_VALUE_START ((scheme_is_functional_nonfailing_primitive (rator , num_args , expected_results ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}




static int validate_expr (Mz_CPort * port , Scheme_Object * expr , 
char * stack , Validate_TLS tls , 
int depth , int letlimit , int delta , 
int num_toplevels , int num_lifts , void * tl_use_map , 
mzshort * tl_state , mzshort tl_timestamp , 
Scheme_Object * app_rator , int proc_with_refs_ok , 
int result_ignored , 
struct Validate_Clearing * vc , int tailpos , 
int need_local_type , Scheme_Hash_Tree * procs , 
int expected_results , 
Scheme_Hash_Table * * _st_ht ) 




{
  Scheme_Type type ; 
  int did_one = 0 , vc_merge = 0 , vc_merge_start = 0 , result = 2 ; 

# 24 "bc/src/mzstkchk.h"
  uintptr_t _stk_pos ; 

# 890 "bc/src/validate.c"
  Scheme_Hash_Tree * __funcarg71 = NULLED_OUT ; 

# 232 "bc/src/validate.c"
  int __funcarg69 ; 

# 452 "bc/src/validate.c"
  int __funcarg68 ; 

# 612 "bc/src/validate.c"
  int __funcarg67 ; 

# 632 "bc/src/validate.c"
  int __funcarg66 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(_st_ht, 0), PUSH(stack, 1), PUSH(vc, 2), PUSH(tl_state, 3), PUSH(tl_use_map, 4), PUSH(procs, 5), PUSH(expr, 6), PUSH(app_rator, 7), PUSH(port, 8), PUSH(tls, 9)));
# define XfOrM201_COUNT (10)
# define SETUP_XfOrM201(x) SETUP(XfOrM201_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 26 "bc/src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 1114 "bc/src/validate.c"
  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    Scheme_Object * r ; 
    void * * pr ; 
    int * args ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM201_COUNT), PUSH(pr, 1+XfOrM201_COUNT), PUSH(args, 2+XfOrM201_COUNT), PUSH(p, 3+XfOrM201_COUNT)));
#   define XfOrM300_COUNT (4+XfOrM201_COUNT)
#   define SETUP_XfOrM300(x) SETUP(XfOrM300_COUNT)
    r = NULLED_OUT ; 
    pr = NULLED_OUT ; 
    args = NULLED_OUT ; 

# 1120 "bc/src/validate.c"
    args = ((int * ) FUNCCALL(SETUP_XfOrM300(_), GC_malloc_atomic (sizeof (int ) * (12 ) ) )) ; 

    p -> ku . k . p1 = (void * ) port ; 
    p -> ku . k . p2 = (void * ) expr ; 
    p -> ku . k . p3 = (void * ) stack ; 
    p -> ku . k . p4 = (void * ) vc ; 

    args [0 ] = depth ; 
    args [1 ] = letlimit ; 
    args [2 ] = delta ; 
    args [3 ] = num_toplevels ; 
    args [4 ] = 0 ; 
    args [5 ] = num_lifts ; 
    args [6 ] = proc_with_refs_ok ; 
    args [7 ] = result_ignored ; 
    args [8 ] = tailpos ; 
    args [9 ] = need_local_type ; 
    args [10 ] = tl_timestamp ; 
    args [11 ] = expected_results ; 

    pr = ((void * * ) FUNCCALL(SETUP_XfOrM300(_), GC_malloc (sizeof (void * ) * (7 ) ) )) ; 
    pr [0 ] = (void * ) args ; 
    pr [1 ] = (void * ) app_rator ; 
    pr [2 ] = (void * ) tls ; 
    pr [3 ] = (void * ) procs ; 
    pr [4 ] = tl_use_map ; 
    pr [5 ] = tl_state ; 
    pr [6 ] = _st_ht ; 

    p -> ku . k . p5 = (void * ) pr ; 

    r = FUNCCALL(SETUP_XfOrM300(_), scheme_handle_stack_overflow (validate_k ) ); 

    RET_VALUE_START ((((intptr_t ) (r ) ) >> 1 ) ) RET_VALUE_END ; 
  }


  top : 
  if (did_one ) {
#   define XfOrM298_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM298(x) SETUP_XfOrM201(x)

# 1159 "bc/src/validate.c"
    if (app_rator ) {
#     define XfOrM299_COUNT (0+XfOrM298_COUNT)
#     define SETUP_XfOrM299(x) SETUP_XfOrM298(x)

# 1160 "bc/src/validate.c"
      if (FUNCCALL(SETUP_XfOrM299(_), validate_rator_wants_box (app_rator , proc_with_refs_ok - 2 , 0 , tls , num_toplevels , num_lifts , tl_use_map ) ))
        FUNCCALL(SETUP_XfOrM299(_), scheme_ill_formed (port , "bc/src/validate.c" , 1163 ) )

      ; 
      app_rator = ((void * ) 0 ) ; 
    }
    proc_with_refs_ok = 0 ; 
  }

# 1167 "bc/src/validate.c"
  else 
  did_one = 1 ; 

  type = ((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ; 

  switch (type ) {
#   define XfOrM205_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM205(x) SETUP_XfOrM201(x)

# 1173 "bc/src/validate.c"
    case scheme_toplevel_type : 
    {
      int c = (((Scheme_Toplevel * ) (expr ) ) -> u . depth ) ; 
      int d = c + delta ; 
      int p = (((Scheme_Toplevel * ) (expr ) ) -> position ) ; 
      int flags = ((& ((Scheme_Toplevel * ) (expr ) ) -> iso ) -> so . keyex & 0x3 ) ; 
#     define XfOrM279_COUNT (0+XfOrM205_COUNT)
#     define SETUP_XfOrM279(x) SETUP_XfOrM205(x)
      FUNCCALL(SETUP_XfOrM279(_), no_typed (need_local_type , port ) )
# 1180 "bc/src/validate.c"
      ; 

      if ((c < 0 ) || (p < 0 ) || (d < 0 ) || (d >= depth ) 
      || (stack [d ] != 4 ) 
      || (p >= num_toplevels ) )
        FUNCCALL(SETUP_XfOrM279(_), scheme_ill_formed (port , "bc/src/validate.c" , 1185 ) ); 

      if (tl_use_map ) {
#       define XfOrM295_COUNT (0+XfOrM279_COUNT)
#       define SETUP_XfOrM295(x) SETUP_XfOrM279(x)

# 1188 "bc/src/validate.c"
        if ((uintptr_t ) tl_use_map & 0x1 ) {
#         define XfOrM297_COUNT (0+XfOrM295_COUNT)
#         define SETUP_XfOrM297(x) SETUP_XfOrM295(x)

# 1189 "bc/src/validate.c"
          if (p >= 31 )
            FUNCCALL(SETUP_XfOrM297(_), scheme_ill_formed (port , "bc/src/validate.c" , 1190 ) ); 
          if (! ((uintptr_t ) tl_use_map & ((unsigned int ) 1 << (p + 1 ) ) ) )
            FUNCCALL(SETUP_XfOrM297(_), scheme_ill_formed (port , "bc/src/validate.c" , 1192 ) ); 
        }

# 1193 "bc/src/validate.c"
        else {
#         define XfOrM296_COUNT (0+XfOrM295_COUNT)
#         define SETUP_XfOrM296(x) SETUP_XfOrM295(x)

# 1194 "bc/src/validate.c"
          if (p >= (* (int * ) tl_use_map * 32 ) )
            FUNCCALL(SETUP_XfOrM296(_), scheme_ill_formed (port , "bc/src/validate.c" , 1195 ) ); 
          if (! (((int * ) tl_use_map ) [1 + (p / 32 ) ] & ((unsigned int ) 1 << (p & 31 ) ) ) )
            FUNCCALL(SETUP_XfOrM296(_), scheme_ill_formed (port , "bc/src/validate.c" , 1197 ) ); 
        }
      }

      if ((flags > 0 ) && tl_state && (p < num_toplevels ) ) {
#       define XfOrM290_COUNT (0+XfOrM279_COUNT)
#       define SETUP_XfOrM290(x) SETUP_XfOrM279(x)

# 1202 "bc/src/validate.c"
        if (p < 1 ) {
#         define XfOrM294_COUNT (0+XfOrM290_COUNT)
#         define SETUP_XfOrM294(x) SETUP_XfOrM290(x)

# 1204 "bc/src/validate.c"
          if (! tl_state [p ] )
            FUNCCALL(SETUP_XfOrM294(_), scheme_ill_formed (port , "bc/src/validate.c" , 1205 ) ); 
        }

# 1206 "bc/src/validate.c"
        else if (tl_state [p ] <= 0 ) {

          int s = - tl_state [p ] ; 
          int new_flags ; 
          new_flags = ((flags > (s & 0x3 ) ) 
          ? flags 
          : (s & 0x3 ) ) ; 
          s >>= 2 ; 
          if (! s || (tl_timestamp < s ) )
            s = tl_timestamp ; 
          tl_state [p ] = - ((s << 2 ) | new_flags ) ; 
        }

# 1217 "bc/src/validate.c"
        else {
#         define XfOrM291_COUNT (0+XfOrM290_COUNT)
#         define SETUP_XfOrM291(x) SETUP_XfOrM290(x)

# 1219 "bc/src/validate.c"
          if (((tl_state [p ] & 0x3 ) < flags ) 
          || ((tl_state [p ] >> 2 ) > tl_timestamp ) ) {
#           define XfOrM292_COUNT (0+XfOrM291_COUNT)
#           define SETUP_XfOrM292(x) SETUP_XfOrM291(x)
            FUNCCALL(SETUP_XfOrM292(_), scheme_ill_formed (port , "bc/src/validate.c" , 1221 ) )
# 1221 "bc/src/validate.c"
            ; 
          }
        }
      }

      if ((proc_with_refs_ok != 1 ) 
      && ! FUNCCALL(SETUP_XfOrM279(_), argument_to_arity_error (app_rator , proc_with_refs_ok ) )) {
#       define XfOrM281_COUNT (0+XfOrM279_COUNT)
#       define SETUP_XfOrM281(x) SETUP_XfOrM279(x)

# 1228 "bc/src/validate.c"
        if (p >= (num_toplevels - num_lifts ) ) {


          int tp ; 
          mzshort * a ; 
          BLOCK_SETUP((PUSH(a, 0+XfOrM281_COUNT)));
#         define XfOrM282_COUNT (1+XfOrM281_COUNT)
#         define SETUP_XfOrM282(x) SETUP(XfOrM282_COUNT)
          a = NULLED_OUT ; 

# 1233 "bc/src/validate.c"
          tp = p - (num_toplevels - num_lifts ) ; 
          a = tls [tp ] ; 
          if (a ) {
#           define XfOrM284_COUNT (0+XfOrM282_COUNT)
#           define SETUP_XfOrM284(x) SETUP_XfOrM282(x)

# 1236 "bc/src/validate.c"
            if (a == (mzshort * ) 0x1 ) {
            }
            else if (a [0 ] > 0 ) {
              int i , cnt ; 
#             define XfOrM286_COUNT (0+XfOrM284_COUNT)
#             define SETUP_XfOrM286(x) SETUP_XfOrM284(x)

# 1240 "bc/src/validate.c"
              cnt = a [0 ] ; 
              for (i = 0 ; i < cnt ; i ++ ) {
#               define XfOrM288_COUNT (0+XfOrM286_COUNT)
#               define SETUP_XfOrM288(x) SETUP_XfOrM286(x)

# 1242 "bc/src/validate.c"
                if (a [i ] == 2 )
                  FUNCCALL(SETUP_XfOrM288(_), scheme_ill_formed (port , "bc/src/validate.c" , 1243 ) ); 
              }
              tls [tp ] = (mzshort * ) 0x1 ; 
            }

# 1246 "bc/src/validate.c"
            else {
#             define XfOrM285_COUNT (0+XfOrM284_COUNT)
#             define SETUP_XfOrM285(x) SETUP_XfOrM284(x)
              FUNCCALL(SETUP_XfOrM285(_), scheme_ill_formed (port , "bc/src/validate.c" , 1248 ) )
# 1248 "bc/src/validate.c"
              ; 
            }
          }

# 1250 "bc/src/validate.c"
          else {
            tls [tp ] = (mzshort * ) 0x1 ; 
          }
        }
      }

      if (flags == 0 )
        result = FUNCCALL(SETUP_XfOrM279(_), validate_join_seq (result , 0 ) ); 
      else {
#       define XfOrM280_COUNT (0+XfOrM279_COUNT)
#       define SETUP_XfOrM280(x) SETUP_XfOrM279(x)

# 1259 "bc/src/validate.c"
        result = FUNCCALL(SETUP_XfOrM280(_), validate_join_const (result , expected_results ) ); 
        if (flags < 3 )
          result = FUNCCALL(SETUP_XfOrM280(_), validate_join_seq (result , 1 ) ); 
      }
    }
    break ; 
    case scheme_local_type : 
    {
      int q = (((Scheme_Local * ) (expr ) ) -> position ) ; 
      int p = q + delta ; 
      int ct ; 
#     define XfOrM269_COUNT (0+XfOrM205_COUNT)
#     define SETUP_XfOrM269(x) SETUP_XfOrM205(x)

# 1271 "bc/src/validate.c"
      if ((q < 0 ) || (p >= depth ) || (p < 0 ) )
        FUNCCALL(SETUP_XfOrM269(_), scheme_ill_formed (port , "bc/src/validate.c" , 1272 ) ); 

      ct = ((((& ((Scheme_Local * ) (expr ) ) -> iso ) -> so . keyex & ~ 0x2000 ) > 2 ) ? (((& ((Scheme_Local * ) (expr ) ) -> iso ) -> so . keyex & ~ 0x2000 ) - 2 ) : 0 ) ; 
      if (! ct )
        FUNCCALL(SETUP_XfOrM269(_), no_typed (need_local_type , port ) ); 

      if (ct ) {
#       define XfOrM278_COUNT (0+XfOrM269_COUNT)
#       define SETUP_XfOrM278(x) SETUP_XfOrM269(x)

# 1279 "bc/src/validate.c"
        if (stack [p ] != (7 + ct ) )
          FUNCCALL(SETUP_XfOrM278(_), scheme_ill_formed (port , "bc/src/validate.c" , 1280 ) ); 
      }

# 1281 "bc/src/validate.c"
      else if ((stack [p ] != 2 ) && (stack [p ] != 5 ) ) {
#       define XfOrM275_COUNT (0+XfOrM269_COUNT)
#       define SETUP_XfOrM275(x) SETUP_XfOrM269(x)

# 1282 "bc/src/validate.c"
        if (result_ignored && ((stack [p ] == 3 ) 
        || (stack [p ] == 6 ) 
        || (stack [p ] >= 7 ) ) ) {
        }
        else if ((proc_with_refs_ok >= 2 ) 
        && ((stack [p ] == 3 ) || (stack [p ] == 6 ) ) 
        && FUNCCALL(SETUP_XfOrM275(_), validate_rator_wants_box (app_rator , proc_with_refs_ok - 2 , 1 , tls , num_toplevels , num_lifts , tl_use_map ) )) 

        {


          app_rator = ((void * ) 0 ) ; 
        }

# 1294 "bc/src/validate.c"
        else FUNCCALL(SETUP_XfOrM275(_), scheme_ill_formed (port , "bc/src/validate.c" , 1295 ) )
        ; 
      }

      if (((& ((Scheme_Local * ) (expr ) ) -> iso ) -> so . keyex & ~ 0x2000 ) == 1 ) {
#       define XfOrM274_COUNT (0+XfOrM269_COUNT)
#       define SETUP_XfOrM274(x) SETUP_XfOrM269(x)

# 1299 "bc/src/validate.c"
        if ((stack [p ] == 5 ) 
        || (stack [p ] == 6 ) 
        || (stack [p ] >= 7 ) )
          FUNCCALL(SETUP_XfOrM274(_), scheme_ill_formed (port , "bc/src/validate.c" , 1302 ) ); 
        if (p >= letlimit )
          FUNCCALL(SETUP_XfOrM274(_), clearing_stack_push (vc , p , stack [p ] ) ); 
        stack [p ] = 0 ; 
      }

# 1306 "bc/src/validate.c"
      else if (! (((& ((Scheme_Local * ) (expr ) ) -> iso ) -> so . keyex & ~ 0x2000 ) == 2 ) ) {
#       define XfOrM271_COUNT (0+XfOrM269_COUNT)
#       define SETUP_XfOrM271(x) SETUP_XfOrM269(x)

# 1307 "bc/src/validate.c"
        if (stack [p ] == 3 ) {
#         define XfOrM273_COUNT (0+XfOrM271_COUNT)
#         define SETUP_XfOrM273(x) SETUP_XfOrM271(x)

# 1308 "bc/src/validate.c"
          if (p >= letlimit )
            FUNCCALL(SETUP_XfOrM273(_), noclear_stack_push (vc , p ) ); 
          stack [p ] = 6 ; 
        }

# 1311 "bc/src/validate.c"
        else if (stack [p ] == 2 ) {
#         define XfOrM272_COUNT (0+XfOrM271_COUNT)
#         define SETUP_XfOrM272(x) SETUP_XfOrM271(x)

# 1312 "bc/src/validate.c"
          if (p >= letlimit )
            FUNCCALL(SETUP_XfOrM272(_), noclear_stack_push (vc , p ) ); 
          stack [p ] = 5 ; 
        }
      }

      if (procs && ! proc_with_refs_ok && ! result_ignored ) {
#       define XfOrM270_COUNT (0+XfOrM269_COUNT)
#       define SETUP_XfOrM270(x) SETUP_XfOrM269(x)

# 1319 "bc/src/validate.c"
        if (FUNCCALL(SETUP_XfOrM270(_), scheme_hash_tree_get (procs , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (p ) ) ) << 1 ) | 0x1 ) ) ) ))
          FUNCCALL(SETUP_XfOrM270(_), scheme_ill_formed (port , "bc/src/validate.c" , 1320 ) ); 
      }

      result = FUNCCALL(SETUP_XfOrM269(_), validate_join_const (result , expected_results ) ); 
    }
    break ; 
    case scheme_local_unbox_type : 
    {
      int q = (((Scheme_Local * ) (expr ) ) -> position ) ; 
      int p = q + delta ; 
#     define XfOrM265_COUNT (0+XfOrM205_COUNT)
#     define SETUP_XfOrM265(x) SETUP_XfOrM205(x)
      FUNCCALL(SETUP_XfOrM265(_), no_typed (need_local_type , port ) )
# 1331 "bc/src/validate.c"
      ; 

      if ((q < 0 ) || (p >= depth ) || (p < 0 ) 
      || ((stack [p ] != 3 ) 
      && (stack [p ] != 6 ) ) )
        FUNCCALL(SETUP_XfOrM265(_), scheme_ill_formed (port , "bc/src/validate.c" , 1336 ) ); 

      if (((& ((Scheme_Local * ) (expr ) ) -> iso ) -> so . keyex & ~ 0x2000 ) == 1 ) {
#       define XfOrM268_COUNT (0+XfOrM265_COUNT)
#       define SETUP_XfOrM268(x) SETUP_XfOrM265(x)

# 1339 "bc/src/validate.c"
        if (stack [p ] == 6 )
          FUNCCALL(SETUP_XfOrM268(_), scheme_ill_formed (port , "bc/src/validate.c" , 1340 ) ); 
        if (p >= letlimit )
          FUNCCALL(SETUP_XfOrM268(_), clearing_stack_push (vc , p , stack [p ] ) ); 
        stack [p ] = 0 ; 
      }

# 1344 "bc/src/validate.c"
      else if (! (((& ((Scheme_Local * ) (expr ) ) -> iso ) -> so . keyex & ~ 0x2000 ) == 2 ) ) {
#       define XfOrM266_COUNT (0+XfOrM265_COUNT)
#       define SETUP_XfOrM266(x) SETUP_XfOrM265(x)

# 1345 "bc/src/validate.c"
        if (stack [p ] == 3 ) {
#         define XfOrM267_COUNT (0+XfOrM266_COUNT)
#         define SETUP_XfOrM267(x) SETUP_XfOrM266(x)

# 1346 "bc/src/validate.c"
          if (p >= letlimit )
            FUNCCALL(SETUP_XfOrM267(_), noclear_stack_push (vc , p ) ); 
          stack [p ] = 6 ; 
        }
      }

      result = FUNCCALL(SETUP_XfOrM265(_), validate_join_const (result , expected_results ) ); 
    }
    break ; 
    case scheme_application_type : 
    {
      Scheme_App_Rec * app = (Scheme_App_Rec * ) expr ; 
      int i , n , r ; 
      BLOCK_SETUP((PUSH(app, 0+XfOrM205_COUNT)));
#     define XfOrM261_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM261(x) SETUP(XfOrM261_COUNT)
      FUNCCALL(SETUP_XfOrM261(_), check_typed (expr , need_local_type , port ) )
# 1360 "bc/src/validate.c"
      ; 

      n = app -> num_args + 1 ; 

      delta -= (n - 1 ) ; 
      if (delta < 0 )
        FUNCCALL(SETUP_XfOrM261(_), scheme_ill_formed (port , "bc/src/validate.c" , 1366 ) ); 
      (memset (stack + delta , 0 , n - 1 ) ) ; 

      for (i = 0 ; i < n ; i ++ ) {
#       define XfOrM264_COUNT (0+XfOrM261_COUNT)
#       define SETUP_XfOrM264(x) SETUP_XfOrM261(x)

# 1370 "bc/src/validate.c"
        r = FUNCCALL(SETUP_XfOrM264(_), validate_expr (port , app -> args [i ] , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , i ? app -> args [0 ] : ((void * ) 0 ) , i + 1 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


        ; 
        result = FUNCCALL(SETUP_XfOrM264(_), validate_join (result , r ) ); 
      }

      if (tailpos )
        FUNCCALL(SETUP_XfOrM261(_), check_self_call_valid (app -> args [0 ] , port , vc , delta , stack ) ); 

      if (result ) {
#       define XfOrM262_COUNT (0+XfOrM261_COUNT)
#       define SETUP_XfOrM262(x) SETUP_XfOrM261(x)

# 1381 "bc/src/validate.c"
        r = FUNCCALL(SETUP_XfOrM262(_), is_functional_nonfailing_rator (app -> args [0 ] , app -> num_args , expected_results , _st_ht ) ); 
        result = FUNCCALL(SETUP_XfOrM262(_), validate_join (result , r ) ); 
      }
    }
    break ; 
    case scheme_application2_type : 
    {
      Scheme_App2_Rec * app = (Scheme_App2_Rec * ) expr ; 
      int r ; 
      BLOCK_SETUP((PUSH(app, 0+XfOrM205_COUNT)));
#     define XfOrM258_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)
      FUNCCALL(SETUP_XfOrM258(_), check_typed (expr , need_local_type , port ) )
# 1391 "bc/src/validate.c"
      ; 

      delta -= 1 ; 
      if (delta < 0 )
        FUNCCALL(SETUP_XfOrM258(_), scheme_ill_formed (port , "bc/src/validate.c" , 1395 ) ); 
      stack [delta ] = 0 ; 

      r = FUNCCALL(SETUP_XfOrM258(_), validate_expr (port , app -> rator , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 1 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


      ; 
      result = FUNCCALL_AGAIN(validate_join (r , result ) ); 
      r = FUNCCALL_AGAIN(validate_expr (port , app -> rand , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , app -> rator , 2 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


      ; 
      result = FUNCCALL_AGAIN(validate_join (r , result ) ); 

      if (tailpos )
        FUNCCALL(SETUP_XfOrM258(_), check_self_call_valid (app -> rator , port , vc , delta , stack ) ); 

      if (result ) {
#       define XfOrM259_COUNT (0+XfOrM258_COUNT)
#       define SETUP_XfOrM259(x) SETUP_XfOrM258(x)

# 1413 "bc/src/validate.c"
        r = FUNCCALL(SETUP_XfOrM259(_), is_functional_nonfailing_rator (app -> rator , 1 , expected_results , _st_ht ) ); 
        if (! r 
        && ((app -> rator ) == (scheme_make_vector_proc ) ) 
        && (expected_results == 1 || expected_results == - 1 ) 
        && ((((intptr_t ) (app -> rand ) ) & 0x1 ) 
        && ((((intptr_t ) (app -> rand ) ) >> 1 ) >= 0 ) 
        && ((((((intptr_t ) (app -> rand ) ) >> 1 ) ) >= - 1073741824 ) && (((((intptr_t ) (app -> rand ) ) >> 1 ) ) <= 1073741823 ) ) ) ) {
          r = 1 ; 
        }
        result = FUNCCALL(SETUP_XfOrM259(_), validate_join (result , r ) ); 
      }
    }
    break ; 
    case scheme_application3_type : 
    {
      Scheme_App3_Rec * app = (Scheme_App3_Rec * ) expr ; 
      int r ; 
      BLOCK_SETUP((PUSH(app, 0+XfOrM205_COUNT)));
#     define XfOrM255_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM255(x) SETUP(XfOrM255_COUNT)
      FUNCCALL(SETUP_XfOrM255(_), check_typed (expr , need_local_type , port ) )
# 1431 "bc/src/validate.c"
      ; 

      delta -= 2 ; 
      if (delta < 0 )
        FUNCCALL(SETUP_XfOrM255(_), scheme_ill_formed (port , "bc/src/validate.c" , 1435 ) ); 
      stack [delta ] = 0 ; 
      stack [delta + 1 ] = 0 ; 

      r = FUNCCALL(SETUP_XfOrM255(_), validate_expr (port , app -> rator , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 1 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


      ; 
      result = FUNCCALL_AGAIN(validate_join (r , result ) ); 
      r = FUNCCALL_AGAIN(validate_expr (port , app -> rand1 , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , app -> rator , 2 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


      ; 
      result = FUNCCALL_AGAIN(validate_join (r , result ) ); 
      r = FUNCCALL_AGAIN(validate_expr (port , app -> rand2 , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , app -> rator , 3 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


      ; 
      result = FUNCCALL_AGAIN(validate_join (r , result ) ); 

      if (tailpos )
        FUNCCALL(SETUP_XfOrM255(_), check_self_call_valid (app -> rator , port , vc , delta , stack ) ); 

      if (result ) {
#       define XfOrM256_COUNT (0+XfOrM255_COUNT)
#       define SETUP_XfOrM256(x) SETUP_XfOrM255(x)

# 1459 "bc/src/validate.c"
        r = FUNCCALL(SETUP_XfOrM256(_), is_functional_nonfailing_rator (app -> rator , 2 , expected_results , _st_ht ) ); 
        if (! r 
        && ((app -> rator ) == (scheme_make_vector_proc ) ) 
        && (expected_results == 1 || expected_results == - 1 ) 
        && ((((intptr_t ) (app -> rand1 ) ) & 0x1 ) 
        && ((((intptr_t ) (app -> rand1 ) ) >> 1 ) >= 0 ) 
        && ((((((intptr_t ) (app -> rand1 ) ) >> 1 ) ) >= - 1073741824 ) && (((((intptr_t ) (app -> rand1 ) ) >> 1 ) ) <= 1073741823 ) ) ) ) {
          r = 1 ; 
        }
        result = FUNCCALL(SETUP_XfOrM256(_), validate_join (r , result ) ); 
      }
    }
    break ; 
    case scheme_sequence_type : 
    {
      Scheme_Sequence * seq = (Scheme_Sequence * ) expr ; 
      int cnt ; 
      int i , r ; 
      BLOCK_SETUP((PUSH(seq, 0+XfOrM205_COUNT)));
#     define XfOrM252_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)

# 1478 "bc/src/validate.c"
      if (type != scheme_sequence_type )
        FUNCCALL(SETUP_XfOrM252(_), no_typed (need_local_type , port ) ); 

      cnt = seq -> count ; 

      for (i = 0 ; i < cnt - 1 ; i ++ ) {
#       define XfOrM254_COUNT (0+XfOrM252_COUNT)
#       define SETUP_XfOrM254(x) SETUP_XfOrM252(x)

# 1484 "bc/src/validate.c"
        r = FUNCCALL(SETUP_XfOrM254(_), validate_expr (port , seq -> array [i ] , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 1 , vc , 0 , 0 , procs , - 1 , _st_ht ) )


        ; 
        result = FUNCCALL(SETUP_XfOrM254(_), validate_join_seq (result , r ) ); 
      }

      expr = seq -> array [cnt - 1 ] ; 
      goto top ; 
    }
    break ; 
    case scheme_branch_type : 
    {
      Scheme_Branch_Rec * b ; 
      int vc_pos , vc_ncpos , r ; 
      BLOCK_SETUP((PUSH(b, 0+XfOrM205_COUNT)));
#     define XfOrM245_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM245(x) SETUP(XfOrM245_COUNT)
      b = NULLED_OUT ; 

# 1500 "bc/src/validate.c"
      b = (Scheme_Branch_Rec * ) expr ; 
      r = FUNCCALL(SETUP_XfOrM245(_), validate_expr (port , b -> test , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


      ; 
      result = FUNCCALL_AGAIN(validate_join (r , result ) ); 




      letlimit = delta ; 
      vc_pos = vc -> stackpos ; 
      vc_ncpos = vc -> ncstackpos ; 
      r = FUNCCALL(SETUP_XfOrM245(_), validate_expr (port , b -> tbranch , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , result_ignored , vc , tailpos , need_local_type , procs , expected_results , _st_ht ) )



      ; 
      result = FUNCCALL_AGAIN(validate_join_seq (result , r ) ); 


      result = FUNCCALL_AGAIN(validate_join (1 , result ) ); 



      {
        int i , j ; 

        if (! vc_merge ) {
          vc_merge = 1 ; 
          vc_merge_start = vc_pos ; 
        }

        for (i = vc -> stackpos - 2 ; i >= vc_pos ; i -= 2 ) {
          stack [vc -> stack [i ] ] = vc -> stack [i + 1 ] ; 
        }

        for (i = vc -> ncstackpos - 1 ; i >= vc_ncpos ; i -- ) {
          j = vc -> ncstack [i ] ; 
          if (stack [j ] == 5 )
            stack [j ] = 2 ; 
          else if (stack [j ] == 6 )
            stack [j ] = 3 ; 
        }
        vc -> ncstackpos = vc_ncpos ; 
      }

      expr = b -> fbranch ; 
      goto top ; 
    }
    break ; 
    case scheme_with_cont_mark_type : 
    {
      Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) expr ; 
      int r ; 
      BLOCK_SETUP((PUSH(wcm, 0+XfOrM205_COUNT)));
#     define XfOrM244_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM244(x) SETUP(XfOrM244_COUNT)

# 1556 "bc/src/validate.c"
      r = FUNCCALL(SETUP_XfOrM244(_), validate_expr (port , wcm -> key , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


      ; 
      result = FUNCCALL(SETUP_XfOrM244(_), validate_join_seq (result , r ) ); 
      r = FUNCCALL_AGAIN(validate_expr (port , wcm -> val , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )


      ; 
      result = FUNCCALL_AGAIN(validate_join_seq (result , r ) ); 

      expr = wcm -> body ; 
      goto top ; 
    }
    break ; 
    case scheme_lambda_type : 
    {
#     define XfOrM243_COUNT (0+XfOrM205_COUNT)
#     define SETUP_XfOrM243(x) SETUP_XfOrM205(x)
      FUNCCALL(SETUP_XfOrM243(_), no_typed (need_local_type , port ) )
# 1573 "bc/src/validate.c"
      ; 
      FUNCCALL(SETUP_XfOrM243(_), validate_lambda (port , expr , stack , tls , depth , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , app_rator , proc_with_refs_ok , - 1 , procs , _st_ht ) )


      ; 

      result = FUNCCALL_AGAIN(validate_join_const (result , expected_results ) ); 
    }
    break ; 
    case scheme_let_value_type : 
    {
      Scheme_Let_Value * lv = (Scheme_Let_Value * ) expr ; 
      int q , p , c , i , r ; 
      BLOCK_SETUP((PUSH(lv, 0+XfOrM205_COUNT)));
#     define XfOrM238_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM238(x) SETUP(XfOrM238_COUNT)

# 1587 "bc/src/validate.c"
      r = FUNCCALL(SETUP_XfOrM238(_), validate_expr (port , lv -> value , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , lv -> count , _st_ht ) )


      ; 
      result = FUNCCALL(SETUP_XfOrM238(_), validate_join_seq (r , result ) ); 



      c = lv -> count ; 
      q = lv -> position ; 
      p = q + delta ; 

      for (i = 0 ; i < c ; i ++ , p ++ ) {
#       define XfOrM241_COUNT (0+XfOrM238_COUNT)
#       define SETUP_XfOrM241(x) SETUP_XfOrM238(x)

# 1600 "bc/src/validate.c"
        if ((q < 0 ) 
        || (p < 0 ) 
        || ((& lv -> iso ) -> so . keyex && ((p >= depth ) 
        || ((stack [p ] != 3 ) 
        && (stack [p ] != 6 ) ) ) ) 
        || (! (& lv -> iso ) -> so . keyex && ((p >= letlimit ) 
        || ! (0 
        || 0 
        || (stack [p ] == 1 ) ) ) ) )
          FUNCCALL(SETUP_XfOrM241(_), scheme_ill_formed (port , "bc/src/validate.c" , 1609 ) ); 

        if (! (& lv -> iso ) -> so . keyex ) {
          if (stack [p ] != 5 )
            stack [p ] = 2 ; 
        }
      }

      expr = lv -> body ; 
      goto top ; 
    }
    break ; 
    case scheme_let_void_type : 
    {
      Scheme_Let_Void * lv = (Scheme_Let_Void * ) expr ; 
      int c , i ; 
      BLOCK_SETUP((PUSH(lv, 0+XfOrM205_COUNT)));
#     define XfOrM233_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM233(x) SETUP(XfOrM233_COUNT)

# 1626 "bc/src/validate.c"
      c = lv -> count ; 

      if ((c < 0 ) || (c > delta ) )
        FUNCCALL(SETUP_XfOrM233(_), scheme_ill_formed (port , "bc/src/validate.c" , 1629 ) ); 

      if ((& lv -> iso ) -> so . keyex ) {
        for (i = 0 ; i < c ; i ++ ) {
          stack [-- delta ] = 3 ; 
        }
      }

# 1635 "bc/src/validate.c"
      else {
#       define XfOrM234_COUNT (0+XfOrM233_COUNT)
#       define SETUP_XfOrM234(x) SETUP_XfOrM233(x)

# 1636 "bc/src/validate.c"
        delta -= c ; 
        (memset (stack + delta , 1 , c ) ) ; 
      }

      expr = lv -> body ; 
      goto top ; 
    }
    break ; 
    case scheme_letrec_type : 
    {
      Scheme_Letrec * l = (Scheme_Letrec * ) expr ; 
      Scheme_Lambda * data ; 
      int i , c ; 
      BLOCK_SETUP((PUSH(data, 0+XfOrM205_COUNT), PUSH(l, 1+XfOrM205_COUNT)));
#     define XfOrM218_COUNT (2+XfOrM205_COUNT)
#     define SETUP_XfOrM218(x) SETUP(XfOrM218_COUNT)
      data = NULLED_OUT ; 

# 1650 "bc/src/validate.c"
      c = l -> count ; 

      if ((c < 0 ) || (c + delta > depth ) )
        FUNCCALL(SETUP_XfOrM218(_), scheme_ill_formed (port , "bc/src/validate.c" , 1653 ) ); 

      for (i = 0 ; i < c ; i ++ ) {
#       define XfOrM232_COUNT (0+XfOrM218_COUNT)
#       define SETUP_XfOrM232(x) SETUP_XfOrM218(x)

# 1656 "bc/src/validate.c"
        if (! ((Scheme_Type ) (((((intptr_t ) (l -> procs [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l -> procs [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) )
          FUNCCALL(SETUP_XfOrM232(_), scheme_ill_formed (port , "bc/src/validate.c" , 1657 ) ); 
      }

      for (i = 0 ; i < c ; i ++ ) {
#       define XfOrM226_COUNT (0+XfOrM218_COUNT)
#       define SETUP_XfOrM226(x) SETUP_XfOrM218(x)

# 1662 "bc/src/validate.c"
        if (stack [delta + i ] != 1 )
          FUNCCALL(SETUP_XfOrM226(_), scheme_ill_formed (port , "bc/src/validate.c" , 1663 ) ); 

        stack [delta + i ] = 2 ; 
        data = (Scheme_Lambda * ) l -> procs [i ] ; 
        if ((& (data ) -> iso ) -> so . keyex & 2 ) {


          int j ; 
#         define XfOrM227_COUNT (0+XfOrM226_COUNT)
#         define SETUP_XfOrM227(x) SETUP_XfOrM226(x)

# 1671 "bc/src/validate.c"
          for (j = data -> num_params ; j -- ; ) {
#           define XfOrM230_COUNT (0+XfOrM227_COUNT)
#           define SETUP_XfOrM230(x) SETUP_XfOrM227(x)

# 1672 "bc/src/validate.c"
            if (scheme_boxmap_get (data -> closure_map , j , data -> closure_size ) ) 
              break ; 
          }
          if (j >= 0 ) {
#           define XfOrM228_COUNT (0+XfOrM227_COUNT)
#           define SETUP_XfOrM228(x) SETUP_XfOrM227(x)

# 1676 "bc/src/validate.c"
            procs = (__funcarg71 = FUNCCALL(SETUP_XfOrM228(_), as_nonempty_procs (procs ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (__funcarg71 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (delta + i ) ) ) << 1 ) | 0x1 ) ) , l -> procs [i ] ) )) 

            ; 
          }
        }
      }

      for (i = 0 ; i < c ; i ++ ) {
#       define XfOrM220_COUNT (0+XfOrM218_COUNT)
#       define SETUP_XfOrM220(x) SETUP_XfOrM218(x)
        FUNCCALL(SETUP_XfOrM220(_), validate_lambda (port , l -> procs [i ] , stack , tls , depth , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 1 , i , procs , _st_ht ) )
        ; 
      }

      expr = l -> body ; 
      goto top ; 
    }
    break ; 
    case scheme_let_one_type : 
    {
      Scheme_Let_One * lo = (Scheme_Let_One * ) expr ; 
      int r ; 
      BLOCK_SETUP((PUSH(lo, 0+XfOrM205_COUNT)));
#     define XfOrM215_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM215(x) SETUP(XfOrM215_COUNT)

# 1699 "bc/src/validate.c"
      -- delta ; 
      if (delta < 0 )
        FUNCCALL(SETUP_XfOrM215(_), scheme_ill_formed (port , "bc/src/validate.c" , 1701 ) ); 
      stack [delta ] = 1 ; 

      r = FUNCCALL(SETUP_XfOrM215(_), validate_expr (port , lo -> value , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , ((& lo -> iso ) -> so . keyex >> 4 ) , procs , 1 , _st_ht ) )



      ; 
      result = FUNCCALL_AGAIN(validate_join_seq (r , result ) ); 


      if (stack [delta ] != 1 )
        FUNCCALL(SETUP_XfOrM215(_), scheme_ill_formed (port , "bc/src/validate.c" , 1713 ) ); 


      if ((& lo -> iso ) -> so . keyex & 0x8 ) {
        stack [delta ] = 0 ; 
      }

# 1718 "bc/src/validate.c"
      else if ((& lo -> iso ) -> so . keyex >> 4 )  {
        stack [delta ] = (7 + ((& lo -> iso ) -> so . keyex >> 4 ) ) ; 
      }
      else 
      stack [delta ] = 2 ; 

      expr = lo -> body ; 
      goto top ; 
    }
    break ; 

    case scheme_define_values_type : FUNCCALL(SETUP_XfOrM205(_), no_typed (need_local_type , port ) )
    ; 
    result = (__funcarg69 = FUNCCALL(SETUP_XfOrM205(_), define_values_validate (expr , port , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , result_ignored , vc , tailpos , procs , _st_ht ) ), FUNCCALL_AGAIN(validate_join_seq (result , __funcarg69 ) )) 




    ; 
    break ; 
    case scheme_set_bang_type : FUNCCALL(SETUP_XfOrM205(_), no_typed (need_local_type , port ) )
    ; 
    result = (__funcarg68 = FUNCCALL(SETUP_XfOrM205(_), set_validate (expr , port , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , result_ignored , vc , tailpos , procs , _st_ht ) ), FUNCCALL_AGAIN(validate_join_seq (result , __funcarg68 ) )) 



    ; 
    break ; 
    case scheme_boxenv_type : FUNCCALL(SETUP_XfOrM205(_), no_typed (need_local_type , port ) )
    ; 
    result = (__funcarg67 = FUNCCALL(SETUP_XfOrM205(_), bangboxenv_validate (expr , port , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , result_ignored , vc , tailpos , procs , _st_ht , expected_results ) ), FUNCCALL_AGAIN(validate_join_seq (result , __funcarg67 ) )) 



    ; 
    break ; 
    case scheme_begin0_sequence_type : FUNCCALL(SETUP_XfOrM205(_), no_typed (need_local_type , port ) )
    ; 
    result = (__funcarg66 = FUNCCALL(SETUP_XfOrM205(_), begin0_validate (expr , port , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , result_ignored , vc , tailpos , procs , _st_ht , expected_results ) ), FUNCCALL_AGAIN(validate_join_seq (result , __funcarg66 ) )) 



    ; 
    break ; 
    case scheme_varref_form_type : FUNCCALL(SETUP_XfOrM205(_), no_typed (need_local_type , port ) )
    ; 
    FUNCCALL(SETUP_XfOrM205(_), ref_validate (expr , port , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , result_ignored , vc , tailpos , procs ) )


    ; 
    result = FUNCCALL_AGAIN(validate_join_const (result , expected_results ) ); 
    break ; 
    case scheme_apply_values_type : FUNCCALL(SETUP_XfOrM205(_), no_typed (need_local_type , port ) )
    ; 
    FUNCCALL(SETUP_XfOrM205(_), apply_values_validate (expr , port , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , result_ignored , vc , tailpos , procs , _st_ht ) )


    ; 
    result = FUNCCALL_AGAIN(validate_join (0 , result ) ); 
    break ; 
    case scheme_with_immed_mark_type : 
    {
      Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) expr ; 
      int r ; 
      BLOCK_SETUP((PUSH(wcm, 0+XfOrM205_COUNT)));
#     define XfOrM214_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM214(x) SETUP(XfOrM214_COUNT)
      FUNCCALL(SETUP_XfOrM214(_), no_typed (need_local_type , port ) )
# 1783 "bc/src/validate.c"
      ; 

      r = FUNCCALL(SETUP_XfOrM214(_), validate_expr (port , wcm -> key , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )



      ; 
      result = FUNCCALL_AGAIN(validate_join_seq (r , result ) ); 

      r = FUNCCALL_AGAIN(validate_expr (port , wcm -> val , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )



      ; 
      result = FUNCCALL_AGAIN(validate_join_seq (r , result ) ); 

      -- delta ; 
      if (delta < 0 )
        FUNCCALL(SETUP_XfOrM214(_), scheme_ill_formed (port , "bc/src/validate.c" , 1801 ) ); 
      stack [delta ] = 2 ; 

      expr = wcm -> body ; 
      goto top ; 
    }
    break ; 
    case scheme_case_lambda_sequence_type : FUNCCALL(SETUP_XfOrM205(_), no_typed (need_local_type , port ) )
    ; 
    FUNCCALL(SETUP_XfOrM205(_), case_lambda_validate (expr , port , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , result_ignored , vc , tailpos , procs , _st_ht ) )


    ; 
    result = FUNCCALL_AGAIN(validate_join_const (result , expected_results ) ); 
    break ; 
    case scheme_inline_variant_type : FUNCCALL(SETUP_XfOrM205(_), no_typed (need_local_type , port ) )
    ; 
    FUNCCALL(SETUP_XfOrM205(_), inline_variant_validate (expr , port , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , result_ignored , vc , tailpos , procs , _st_ht ) )


    ; 
    result = FUNCCALL_AGAIN(validate_join_const (result , expected_results ) ); 
    break ; 
    case scheme_ir_local_type : 
    {
#     define XfOrM213_COUNT (0+XfOrM205_COUNT)
#     define SETUP_XfOrM213(x) SETUP_XfOrM205(x)
      FUNCCALL(SETUP_XfOrM213(_), scheme_ill_formed (port , "bc/src/validate.c" , 1826 ) )
# 1826 "bc/src/validate.c"
      ; 
    }
    default : 



    result = FUNCCALL(SETUP_XfOrM205(_), validate_join_const (result , expected_results ) ); 
    if (((Scheme_Type ) (type ) == (Scheme_Type ) (scheme_closure_type ) ) 



    && (((Scheme_Closure * ) expr ) -> code -> closure_size == 0 ) ) {
      Scheme_Lambda * data ; 
      BLOCK_SETUP((PUSH(data, 0+XfOrM205_COUNT)));
#     define XfOrM210_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM210(x) SETUP(XfOrM210_COUNT)
      data = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM210(_), no_typed (need_local_type , port ) )
# 1839 "bc/src/validate.c"
      ; 
      expr = (Scheme_Object * ) ((Scheme_Closure * ) expr ) -> code ; 
      data = (Scheme_Lambda * ) expr ; 
      if (((& (data ) -> iso ) -> so . keyex & (64 | 128 ) ) == 128 ) {
      }
      else {
        (& (data ) -> iso ) -> so . keyex = ((& (data ) -> iso ) -> so . keyex & ~ (64 | 128 ) ) | 128 ; 
        did_one = 0 ; 
        goto top ; 
      }
    }

# 1849 "bc/src/validate.c"
    else if ((Scheme_Type ) (type ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
      Scheme_Case_Lambda * seq ; 
      int i ; 
      BLOCK_SETUP((PUSH(seq, 0+XfOrM205_COUNT)));
#     define XfOrM207_COUNT (1+XfOrM205_COUNT)
#     define SETUP_XfOrM207(x) SETUP(XfOrM207_COUNT)
      seq = NULLED_OUT ; 

# 1852 "bc/src/validate.c"
      seq = (Scheme_Case_Lambda * ) expr ; 
      for (i = 0 ; i < seq -> count ; i ++ ) {
#       define XfOrM209_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM209(x) SETUP_XfOrM207(x)
        FUNCCALL(SETUP_XfOrM209(_), validate_expr (port , seq -> array [i ] , stack , tls , depth , letlimit , delta , num_toplevels , num_lifts , tl_use_map , tl_state , tl_timestamp , ((void * ) 0 ) , 0 , 0 , vc , 0 , 0 , procs , 1 , _st_ht ) )
        ; 
      }
    }

# 1859 "bc/src/validate.c"
    else if (need_local_type ) {
#     define XfOrM206_COUNT (0+XfOrM205_COUNT)
#     define SETUP_XfOrM206(x) SETUP_XfOrM205(x)

# 1860 "bc/src/validate.c"
      if (((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) && (need_local_type == 1 ) )
        need_local_type = 0 ; 




      if ((((intptr_t ) (expr ) ) & 0x1 ) && (need_local_type == 2 ) )
        need_local_type = 0 ; 
      FUNCCALL(SETUP_XfOrM206(_), no_typed (need_local_type , port ) ); 
    }
    break ; 
  }

  if (app_rator )
    if (FUNCCALL(SETUP_XfOrM201(_), validate_rator_wants_box (app_rator , proc_with_refs_ok - 2 , 0 , tls , num_toplevels , num_lifts , tl_use_map ) ))
    FUNCCALL(SETUP_XfOrM201(_), scheme_ill_formed (port , "bc/src/validate.c" , 1876 ) )
  ; 

  if (vc_merge ) {

    int i , p ; 
    for (i = vc_merge_start ; i < vc -> stackpos ; i += 2 ) {
      p = vc -> stack [i ] ; 
      stack [p ] = 0 ; 
    }
  }

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "bc/src/mzmark_validate.inc"
static int mark_validate_clearing_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_validate_clearing_MARK (void * p , struct NewGC * gc ) {

  Validate_Clearing * vc = (Validate_Clearing * ) p ; 

  GC_mark2 (& (vc -> stack ) , gc ) ; 
  GC_mark2 (& (vc -> ncstack ) , gc ) ; 


  return 0 ; 
}






static int mark_validate_clearing_FIXUP (void * p , struct NewGC * gc ) {

  Validate_Clearing * vc = (Validate_Clearing * ) p ; 

  GC_fixup2 (& (vc -> stack ) , gc ) ; 
  GC_fixup2 (& (vc -> ncstack ) , gc ) ; 


  return 0 ; 
}

# 1900 "bc/src/validate.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_validate_clearing , mark_validate_clearing_SIZE , mark_validate_clearing_MARK , mark_validate_clearing_FIXUP , 1 , 0 ) ; 
}
