#include "precomp.h"

# 5 "bc/src/vector.c"
Scheme_Object * scheme_vector_proc ; 
Scheme_Object * scheme_vector_p_proc ; 
Scheme_Object * scheme_make_vector_proc ; 
Scheme_Object * scheme_vector_immutable_proc ; 
Scheme_Object * scheme_vector_length_proc ; 
Scheme_Object * scheme_vector_star_length_proc ; 
Scheme_Object * scheme_vector_ref_proc ; 
Scheme_Object * scheme_vector_star_ref_proc ; 
Scheme_Object * scheme_vector_set_proc ; 
Scheme_Object * scheme_vector_star_set_proc ; 
Scheme_Object * scheme_vector_cas_proc ; 
Scheme_Object * scheme_list_to_vector_proc ; 
Scheme_Object * scheme_unsafe_vector_length_proc ; 
Scheme_Object * scheme_unsafe_vector_star_length_proc ; 
Scheme_Object * scheme_unsafe_vector_star_ref_proc ; 
Scheme_Object * scheme_unsafe_vector_star_set_proc ; 
Scheme_Object * scheme_unsafe_string_length_proc ; 
Scheme_Object * scheme_unsafe_string_ref_proc ; 
Scheme_Object * scheme_unsafe_string_set_proc ; 
Scheme_Object * scheme_unsafe_byte_string_length_proc ; 
Scheme_Object * scheme_unsafe_bytes_ref_proc ; 
Scheme_Object * scheme_unsafe_bytes_set_proc ; 
Scheme_Object * scheme_unsafe_struct_ref_proc ; 
Scheme_Object * scheme_unsafe_struct_star_ref_proc ; 
Scheme_Object * scheme_unsafe_struct_set_proc ; 
Scheme_Object * scheme_unsafe_struct_star_set_proc ; 


static Scheme_Object * vector_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector_immutable (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector_length (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector_star_length (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector_to_list (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * list_to_vector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector_fill (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector_copy_bang (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector_to_immutable (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * vector_to_values (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_vector (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * chaperone_vector_star (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * impersonate_vector (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * impersonate_vector_star (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_chaperone_vector (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_impersonate_vector (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * unsafe_vector_len (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_vector_ref (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_vector_set (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_vector_star_len (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_vector_star_ref (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_vector_star_set (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_vector_star_cas (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_struct_ref (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_struct_set (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_struct_star_ref (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_struct_star_set (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_struct_star_cas (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_string_len (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_string_ref (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_string_set (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bytes_len (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bytes_ref (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bytes_set (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bytes_copy_bang (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bytes_immutable_bang (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_string_immutable_bang (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_vector_immutable_bang (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * stencil_vector_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * stencil_vector (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * stencil_vector_mask (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * stencil_vector_length (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * stencil_vector_ref (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * stencil_vector_set (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * stencil_vector_update (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * stencil_vector_mask_width (int argc , Scheme_Object * * argv ) ; 

void 
scheme_init_vector (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM1_COUNT (2)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & scheme_vector_p_proc , sizeof (scheme_vector_p_proc ) ) )
# 88 "bc/src/vector.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (vector_p , "vector?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector?" , p , env ) ); 
  scheme_vector_p_proc = p ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & scheme_make_vector_proc , sizeof (scheme_make_vector_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_checked_make_vector , "make-vector" , 1 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-vector" , p , env ) ); 
  scheme_make_vector_proc = p ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & scheme_vector_proc , sizeof (scheme_vector_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (vector , "vector" , 0 , - 1 ) ); 
  scheme_vector_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_vector_immutable_proc , sizeof (scheme_vector_immutable_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (vector_immutable , "vector-immutable" , 0 , - 1 ) ); 
  scheme_vector_immutable_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector-immutable" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_vector_length_proc , sizeof (scheme_vector_length_proc ) ) )

  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (vector_length , "vector-length" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector-length" , p , env ) ); 
  scheme_vector_length_proc = p ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & scheme_vector_star_length_proc , sizeof (scheme_vector_star_length_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (vector_star_length , "vector*-length" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector*-length" , p , env ) ); 
  scheme_vector_star_length_proc = p ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & scheme_vector_ref_proc , sizeof (scheme_vector_ref_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (scheme_checked_vector_ref , "vector-ref" , 2 , 2 ) )

  ; 
  scheme_vector_ref_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector-ref" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_vector_star_ref_proc , sizeof (scheme_vector_star_ref_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (scheme_checked_vector_star_ref , "vector*-ref" , 2 , 2 ) )

  ; 
  scheme_vector_star_ref_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector*-ref" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_vector_set_proc , sizeof (scheme_vector_set_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (scheme_checked_vector_set , "vector-set!" , 3 , 3 ) )

  ; 
  scheme_vector_set_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector-set!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_vector_star_set_proc , sizeof (scheme_vector_star_set_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (scheme_checked_vector_star_set , "vector*-set!" , 3 , 3 ) )

  ; 
  scheme_vector_star_set_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector*-set!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_vector_cas_proc , sizeof (scheme_vector_cas_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (scheme_checked_vector_cas , "vector-cas!" , 4 , 4 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector-cas!" , p , env ) ); 
  scheme_vector_cas_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (vector_to_list , "vector->list" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector->list" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_list_to_vector_proc , sizeof (scheme_list_to_vector_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (list_to_vector , "list->vector" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  scheme_list_to_vector_proc = p ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("list->vector" , p , env ) ); 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (vector_fill , "vector-fill!" , 2 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("vector-fill!" , __funcarg71 , env ) )) 
  ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (vector_copy_bang , "vector-copy!" , 3 , 5 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("vector-copy!" , __funcarg70 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (vector_to_immutable , "vector->immutable-vector" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector->immutable-vector" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_prim_w_everything (vector_to_values , 1 , "vector->values" , 1 , 3 , 0 , 0 , - 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("vector->values" , p , env ) ); 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (chaperone_vector , "chaperone-vector" , 3 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-vector" , __funcarg69 , env ) )) 
  ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (chaperone_vector_star , "chaperone-vector*" , 3 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-vector*" , __funcarg68 , env ) )) 
  ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (impersonate_vector , "impersonate-vector" , 3 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-vector" , __funcarg67 , env ) )) 
  ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (impersonate_vector_star , "impersonate-vector*" , 3 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-vector*" , __funcarg66 , env ) )) 
  ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (stencil_vector_p , "stencil-vector?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("stencil-vector?" , __funcarg65 , env ) )) 
  ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (stencil_vector , "stencil-vector" , 1 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("stencil-vector" , __funcarg64 , env ) )) 
  ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (stencil_vector_length , "stencil-vector-length" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("stencil-vector-length" , __funcarg63 , env ) )) 
  ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (stencil_vector_mask , "stencil-vector-mask" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("stencil-vector-mask" , __funcarg62 , env ) )) 
  ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (stencil_vector_ref , "stencil-vector-ref" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("stencil-vector-ref" , __funcarg61 , env ) )) 
  ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (stencil_vector_set , "stencil-vector-set!" , 3 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("stencil-vector-set!" , __funcarg60 , env ) )) 
  ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (stencil_vector_update , "stencil-vector-update" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("stencil-vector-update" , __funcarg59 , env ) )) 
  ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (stencil_vector_mask_width , "stencil-vector-mask-width" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("stencil-vector-mask-width" , __funcarg58 , env ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 281 "bc/src/vector.c"
void 
scheme_init_unsafe_vector (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_vector_length_proc , sizeof (scheme_unsafe_vector_length_proc ) ) )
# 286 "bc/src/vector.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_vector_len , "unsafe-vector-length" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-vector-length" , p , env ) ); 
  scheme_unsafe_vector_length_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_vector_star_length_proc , sizeof (scheme_unsafe_vector_star_length_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_vector_star_len , "unsafe-vector*-length" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-vector*-length" , p , env ) ); 
  scheme_unsafe_vector_star_length_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (unsafe_vector_ref , "unsafe-vector-ref" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-vector-ref" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_vector_star_ref_proc , sizeof (scheme_unsafe_vector_star_ref_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_vector_star_ref , "unsafe-vector*-ref" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 3 ) 
  | (1 << 4 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-vector*-ref" , p , env ) ); 
  scheme_unsafe_vector_star_ref_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (unsafe_vector_set , "unsafe-vector-set!" , 3 , 3 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-vector-set!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_vector_star_set_proc , sizeof (scheme_unsafe_vector_star_set_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_vector_star_set , "unsafe-vector*-set!" , 3 , 3 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-vector*-set!" , p , env ) ); 
  scheme_unsafe_vector_star_set_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (unsafe_vector_star_cas , "unsafe-vector*-cas!" , 4 , 4 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-vector*-cas!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_struct_ref_proc , sizeof (scheme_unsafe_struct_ref_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_struct_ref , "unsafe-struct-ref" , 2 , 2 ) ); 
  scheme_unsafe_struct_ref_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-struct-ref" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_struct_ref_proc , sizeof (scheme_unsafe_struct_ref_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_struct_star_ref , "unsafe-struct*-ref" , 2 , 2 ) ); 
  scheme_unsafe_struct_star_ref_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 3 ) 
  | (1 << 4 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-struct*-ref" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_struct_set_proc , sizeof (scheme_unsafe_struct_set_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_struct_set , "unsafe-struct-set!" , 3 , 3 ) ); 
  scheme_unsafe_struct_set_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-struct-set!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_struct_star_set_proc , sizeof (scheme_unsafe_struct_star_set_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_struct_star_set , "unsafe-struct*-set!" , 3 , 3 ) ); 
  scheme_unsafe_struct_star_set_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-struct*-set!" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_struct_star_cas , "unsafe-struct*-cas!" , 4 , 4 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-struct*-cas!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_string_length_proc , sizeof (scheme_unsafe_string_length_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_string_len , "unsafe-string-length" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-string-length" , p , env ) ); 
  scheme_unsafe_string_length_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_string_ref_proc , sizeof (scheme_unsafe_string_ref_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_string_ref , "unsafe-string-ref" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 3 ) 
  | (1 << 4 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-string-ref" , p , env ) ); 
  scheme_unsafe_string_ref_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_string_set_proc , sizeof (scheme_unsafe_string_set_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_string_set , "unsafe-string-set!" , 3 , 3 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-string-set!" , p , env ) ); 
  scheme_unsafe_string_set_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_byte_string_length_proc , sizeof (scheme_unsafe_byte_string_length_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bytes_len , "unsafe-bytes-length" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-bytes-length" , p , env ) ); 
  scheme_unsafe_byte_string_length_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_bytes_ref_proc , sizeof (scheme_unsafe_bytes_ref_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bytes_ref , "unsafe-bytes-ref" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 3 ) 
  | (1 << 4 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-bytes-ref" , p , env ) ); 
  scheme_unsafe_bytes_ref_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_bytes_set_proc , sizeof (scheme_unsafe_bytes_set_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bytes_set , "unsafe-bytes-set!" , 3 , 3 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-bytes-set!" , p , env ) ); 
  scheme_unsafe_bytes_set_proc = p ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (unsafe_bytes_copy_bang , "unsafe-bytes-copy!" , 3 , 5 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-bytes-copy!" , __funcarg83 , env ) )) 
  ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (unsafe_bytes_immutable_bang , "unsafe-bytes->immutable-bytes!" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-bytes->immutable-bytes!" , __funcarg82 , env ) )) 
  ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (unsafe_string_immutable_bang , "unsafe-string->immutable-string!" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-string->immutable-string!" , __funcarg81 , env ) )) 
  ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (unsafe_vector_immutable_bang , "unsafe-vector*->immutable-vector!" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-vector*->immutable-vector!" , __funcarg80 , env ) )) 
  ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (unsafe_impersonate_vector , "unsafe-impersonate-vector" , 2 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-impersonate-vector" , __funcarg79 , env ) )) 
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (unsafe_chaperone_vector , "unsafe-chaperone-vector" , 2 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-chaperone-vector" , __funcarg78 , env ) )) 
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (stencil_vector , "unsafe-stencil-vector" , 1 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-stencil-vector" , __funcarg77 , env ) )) 
  ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (stencil_vector_length , "unsafe-stencil-vector-length" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-stencil-vector-length" , __funcarg76 , env ) )) 
  ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (stencil_vector_mask , "unsafe-stencil-vector-mask" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-stencil-vector-mask" , __funcarg75 , env ) )) 
  ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (stencil_vector_ref , "unsafe-stencil-vector-ref" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-stencil-vector-ref" , __funcarg74 , env ) )) 
  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (stencil_vector_set , "unsafe-stencil-vector-set!" , 3 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-stencil-vector-set!" , __funcarg73 , env ) )) 
  ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (stencil_vector_update , "unsafe-stencil-vector-update" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-stencil-vector-update" , __funcarg72 , env ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 474 "bc/src/vector.c"
Scheme_Object * 
scheme_make_vector (intptr_t size , Scheme_Object * fill ) 
{
  Scheme_Object * vec ; 
  intptr_t i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(vec, 0), PUSH(fill, 1)));
# define XfOrM3_COUNT (2)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 

# 480 "bc/src/vector.c"
  if (size < 0 ) {
#   define XfOrM9_COUNT (0+XfOrM3_COUNT)
#   define SETUP_XfOrM9(x) SETUP_XfOrM3(x)

# 481 "bc/src/vector.c"
    vec = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (size ) ) ) << 1 ) | 0x1 ) ) ; 
    FUNCCALL(SETUP_XfOrM9(_), scheme_wrong_contract ("make-vector" , "exact-nonnegative-integer?" , - 1 , 0 , & vec ) ); 
  }

  if (size < 1024 ) {
#   define XfOrM8_COUNT (0+XfOrM3_COUNT)
#   define SETUP_XfOrM8(x) SETUP_XfOrM3(x)

# 486 "bc/src/vector.c"
    vec = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM8(_), GC_malloc_one_tagged ((sizeof (Scheme_Vector ) + ((size ) - 0 ) * sizeof (Scheme_Object * ) ) ) ); 
  }

# 487 "bc/src/vector.c"
  else {
    size_t sz ; 
#   define XfOrM7_COUNT (0+XfOrM3_COUNT)
#   define SETUP_XfOrM7(x) SETUP_XfOrM3(x)

# 489 "bc/src/vector.c"
    sz = (sizeof (Scheme_Vector ) + ((size ) - 0 ) * sizeof (Scheme_Object * ) ) ; 
    if ((((sz ) - (sizeof (Scheme_Vector ) - (0 * sizeof (Scheme_Object * ) ) ) ) / sizeof (Scheme_Object * ) ) != size )
      FUNCCALL(SETUP_XfOrM7(_), scheme_raise_out_of_memory (((void * ) 0 ) , ((void * ) 0 ) ) )
    ; 
    else 
    vec = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM7(_), scheme_malloc_fail_ok (GC_malloc_one_tagged , sz ) ); 
  }

  vec -> type = scheme_vector_type ; 
  (((Scheme_Vector * ) (vec ) ) -> size ) = size ; 

  if (fill ) {
    for (i = 0 ; i < size ; i ++ ) {
      (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = fill ; 
    }
  }

  RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 511 "bc/src/vector.c"
static Scheme_Object * 
vector_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 514 "bc/src/vector.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) ? scheme_true : scheme_false ) ; 
}

Scheme_Object * 
scheme_checked_make_vector (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * vec , * fill ; 
  intptr_t len ; 
  char * __funcarg84 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(vec, 1), PUSH(fill, 2)));
# define XfOrM11_COUNT (3)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 
  fill = NULLED_OUT ; 

# 523 "bc/src/vector.c"
  len = FUNCCALL(SETUP_XfOrM11(_), scheme_extract_index ("make-vector" , 0 , argc , argv , - 1 , 0 ) ); 

  if ((len == - 1 ) 

  || (((((sizeof (Scheme_Vector ) + ((len ) - 0 ) * sizeof (Scheme_Object * ) ) ) - (sizeof (Scheme_Vector ) - (0 * sizeof (Scheme_Object * ) ) ) ) / sizeof (Scheme_Object * ) ) != len ) ) {
#   define XfOrM12_COUNT (0+XfOrM11_COUNT)
#   define SETUP_XfOrM12(x) SETUP_XfOrM11(x)
    (__funcarg84 = FUNCCALL(SETUP_XfOrM12(_), scheme_make_provided_string (argv [0 ] , 1 , ((void * ) 0 ) ) ), FUNCCALL_EMPTY(scheme_raise_out_of_memory ("make-vector" , "making vector of length %s" , __funcarg84 ) )) 
# 529 "bc/src/vector.c"
    ; 
  }

  if (argc == 2 )
    fill = argv [1 ] ; 
  else 
  fill = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

  vec = FUNCCALL(SETUP_XfOrM11(_), scheme_make_vector (len , fill ) ); 

  RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 542 "bc/src/vector.c"
static Scheme_Object * 
vector (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * vec ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(vec, 1)));
# define XfOrM13_COUNT (2)
# define SETUP_XfOrM13(x) SETUP(XfOrM13_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 

# 548 "bc/src/vector.c"
  vec = FUNCCALL(SETUP_XfOrM13(_), scheme_make_vector (argc , 0 ) ); 
  for (i = 0 ; i < argc ; i ++ ) {
    (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = argv [i ] ; 
  }

  RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 556 "bc/src/vector.c"
static Scheme_Object * 
vector_immutable (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * vec ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(vec, 0)));
# define XfOrM16_COUNT (1)
# define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 

# 561 "bc/src/vector.c"
  vec = FUNCCALL(SETUP_XfOrM16(_), vector (argc , argv ) ); 
  ((((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex |= 0x1 ) ) ; 

  RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 567 "bc/src/vector.c"
static Scheme_Object * 
vector_length (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 570 "bc/src/vector.c"
  Scheme_Object * vec = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    vec = (((Scheme_Chaperone * ) vec ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    scheme_wrong_contract ("vector-length" , "vector?" , 0 , argc , argv ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> size ) ) ) ) << 1 ) | 0x1 ) ) ; 
}

Scheme_Object * scheme_vector_length (Scheme_Object * v ) 
{
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM18_COUNT (3)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 584 "bc/src/vector.c"
  a [0 ] = v ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM18(_), vector_length (1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 588 "bc/src/vector.c"
static Scheme_Object * 
vector_star_length (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 591 "bc/src/vector.c"
  Scheme_Object * vec = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    scheme_wrong_contract ("vector*-length" , "(and/c vector? (not/c impersonator?))" , 0 , argc , argv ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((Scheme_Vector * ) (vec ) ) -> size ) ) ) ) << 1 ) | 0x1 ) ) ; 
}

Scheme_Object * scheme_vector_star_length (Scheme_Object * v ) 
{
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM20_COUNT (3)
# define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 602 "bc/src/vector.c"
  a [0 ] = v ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM20(_), vector_star_length (1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 606 "bc/src/vector.c"
void scheme_bad_vec_index (char * name , Scheme_Object * i , const char * which , Scheme_Object * vec , 
intptr_t bottom , intptr_t len ) 
{
  /* No conversion */

# 609 "bc/src/vector.c"
  const char * type ; 







  type = ((((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) 
  ? "vector" 
  : (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) 
  ? "flvector" 
  : (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) 
  ? "fxvector" 
  : (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) 
  ? "stencil vector" 
  : ((void * ) 0 ) ) ) ) ) 
  ; 

  scheme_out_of_range (name , type , which , i , vec , bottom , len - 1 ) ; 
}

static Scheme_Object * 
bad_index (char * name , const char * which , Scheme_Object * i , Scheme_Object * vec , int bottom ) 
{
  /* No conversion */

# 634 "bc/src/vector.c"
  intptr_t len ; 

  len = (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) 
  ? scheme_stencil_vector_popcount (((Scheme_Stencil_Vector * ) vec ) -> mask ) 
  : ((((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  ? (((Scheme_Vector * ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) -> size ) 
  : (((Scheme_Vector * ) (vec ) ) -> size ) ) ) ; 

  scheme_bad_vec_index (name , i , which , vec , bottom , len ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * chaperone_vector_ref_k (void ) 
{
  /* No conversion */

# 648 "bc/src/vector.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  return scheme_chaperone_vector_ref (o , p -> ku . k . i1 ) ; 
}

static Scheme_Object * chaperone_vector_ref_overflow (Scheme_Object * o , int i ) 
{
  /* No conversion */

# 658 "bc/src/vector.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = (void * ) o ; 
  p -> ku . k . i1 = i ; 

  return scheme_handle_stack_overflow (chaperone_vector_ref_k ) ; 
}

Scheme_Object * scheme_chaperone_vector_ref2 (Scheme_Object * o , int i , Scheme_Object * outermost ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(outermost, 1)));
# define XfOrM25_COUNT (2)
# define SETUP_XfOrM25(x) SETUP(XfOrM25_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 668 "bc/src/vector.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
    RET_VALUE_START ((((Scheme_Vector * ) (o ) ) -> els ) [i ] ) RET_VALUE_END ; 
  }

# 670 "bc/src/vector.c"
  else {
    Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
    Scheme_Object * a [4 ] , * red , * orig ; 
    BLOCK_SETUP((PUSH(red, 0+XfOrM25_COUNT), PUSHARRAY(a, 4, 1+XfOrM25_COUNT), PUSH(px, 4+XfOrM25_COUNT), PUSH(orig, 5+XfOrM25_COUNT)));
#   define XfOrM26_COUNT (6+XfOrM25_COUNT)
#   define SETUP_XfOrM26(x) SETUP(XfOrM26_COUNT)
    NULL_OUT_ARRAY (a ) ; 
    red = NULLED_OUT ; 
    orig = NULLED_OUT ; 

# 675 "bc/src/vector.c"
    {

# 24 "bc/src/mzstkchk.h"
      uintptr_t _stk_pos ; 
#     define XfOrM31_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM31(x) SETUP_XfOrM26(x)

# 26 "bc/src/mzstkchk.h"
      _stk_pos = (uintptr_t ) & _stk_pos ; 

      if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
      && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 677 "bc/src/vector.c"
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM31(_), chaperone_vector_ref_overflow (o , i ) )) RET_VALUE_END ; 
    }


    if (((px -> redirects ) ) == (scheme_false ) )  {
#     define XfOrM30_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM30(x) SETUP_XfOrM26(x)

# 683 "bc/src/vector.c"
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM30(_), scheme_chaperone_vector_ref2 (px -> val , i , outermost ) )) RET_VALUE_END ; 
    }

    orig = FUNCCALL(SETUP_XfOrM26(_), scheme_chaperone_vector_ref2 (px -> prev , i , outermost ) ); 

    if (((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) ) )  {


      RET_VALUE_START (orig ) RET_VALUE_END ; 
    }
    red = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . car ) ; 

    if ((& (px ) -> iso ) -> so . keyex & 0x2 ) {
#     define XfOrM28_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM28(x) SETUP_XfOrM26(x)

# 696 "bc/src/vector.c"
      a [0 ] = outermost ; 
      a [1 ] = px -> prev ; 
      a [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) ; 
      a [3 ] = orig ; 
      o = FUNCCALL(SETUP_XfOrM28(_), scheme_do_eval (red , 4 , a , 1 ) ); 
    }
    else {
#     define XfOrM27_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM27(x) SETUP_XfOrM26(x)

# 703 "bc/src/vector.c"
      a [0 ] = px -> prev ; 
      a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) ; 
      a [2 ] = orig ; 
      o = FUNCCALL(SETUP_XfOrM27(_), scheme_do_eval (red , 3 , a , 1 ) ); 
    }

    if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
      if (! FUNCCALL(SETUP_XfOrM26(_), scheme_chaperone_of (o , orig ) ))
      FUNCCALL(SETUP_XfOrM26(_), scheme_wrong_chaperoned ("vector-ref" , "result" , orig , o ) ); 

    RET_VALUE_START (o ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 717 "bc/src/vector.c"
Scheme_Object * scheme_chaperone_vector_ref (Scheme_Object * o , int i ) 
{
  /* No conversion */

# 719 "bc/src/vector.c"
  return scheme_chaperone_vector_ref2 (o , i , o ) ; 
}

Scheme_Object * 
scheme_checked_vector_ref (int argc , Scheme_Object * argv [] ) 
{
  intptr_t i , len ; 
  Scheme_Object * vec ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(vec, 1)));
# define XfOrM34_COUNT (2)
# define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 

# 728 "bc/src/vector.c"
  vec = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    vec = (((Scheme_Chaperone * ) vec ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector-ref" , "vector?" , 0 , argc , argv ) ); 

  len = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

  i = FUNCCALL(SETUP_XfOrM34(_), scheme_extract_index ("vector-ref" , 1 , argc , argv , len , 0 ) ); 

  if (i >= len )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(bad_index ("vector-ref" , "" , argv [1 ] , argv [0 ] , 0 ) )) RET_VALUE_EMPTY_END ; 

  if (! ((vec ) == (argv [0 ] ) ) )

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_chaperone_vector_ref (argv [0 ] , i ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (((((Scheme_Vector * ) (vec ) ) -> els ) ) [i ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 749 "bc/src/vector.c"
void scheme_chaperone_vector_set (Scheme_Object * o , int i , Scheme_Object * v ) 
{
  Scheme_Object * outermost = o ; 
  PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(v, 1), PUSH(outermost, 2)));
# define XfOrM35_COUNT (3)
# define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 752 "bc/src/vector.c"
  while (1 ) {
#   define XfOrM43_COUNT (0+XfOrM35_COUNT)
#   define SETUP_XfOrM43(x) SETUP_XfOrM35(x)

# 753 "bc/src/vector.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
      (((Scheme_Vector * ) (o ) ) -> els ) [i ] = v ; 
      RET_NOTHING ; 
    }

# 756 "bc/src/vector.c"
    else {
      Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
      Scheme_Object * a [4 ] , * red ; 
      int chap_star = (& (px ) -> iso ) -> so . keyex & 0x2 ? 1 : 0 ; 
      BLOCK_SETUP((PUSH(red, 0+XfOrM43_COUNT), PUSHARRAY(a, 4, 1+XfOrM43_COUNT), PUSH(px, 4+XfOrM43_COUNT)));
#     define XfOrM44_COUNT (5+XfOrM43_COUNT)
#     define SETUP_XfOrM44(x) SETUP(XfOrM44_COUNT)
      NULL_OUT_ARRAY (a ) ; 
      red = NULLED_OUT ; 

# 761 "bc/src/vector.c"
      red = px -> redirects ; 
      if (((red ) ) == (scheme_false ) )  {
        o = px -> val ; 
        continue ; 
      }

      o = px -> prev ; 

      if (! (((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && ! ((((Scheme_Vector * ) (red ) ) -> size ) ) ) ) {
#       define XfOrM45_COUNT (0+XfOrM44_COUNT)
#       define SETUP_XfOrM45(x) SETUP_XfOrM44(x)

# 771 "bc/src/vector.c"
        red = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ; 

        if (chap_star ) {
#         define XfOrM47_COUNT (0+XfOrM45_COUNT)
#         define SETUP_XfOrM47(x) SETUP_XfOrM45(x)

# 774 "bc/src/vector.c"
          a [0 ] = outermost ; 
          a [1 ] = o ; 
          a [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) ; 
          a [3 ] = v ; 
          v = FUNCCALL(SETUP_XfOrM47(_), scheme_do_eval (red , 4 , a , 1 ) ); 
        }
        else {
#         define XfOrM46_COUNT (0+XfOrM45_COUNT)
#         define SETUP_XfOrM46(x) SETUP_XfOrM45(x)

# 781 "bc/src/vector.c"
          a [0 ] = o ; 
          a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) ; 
          a [2 ] = v ; 
          v = FUNCCALL(SETUP_XfOrM46(_), scheme_do_eval (red , 3 , a , 1 ) ); 
        }

        if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
          if (! FUNCCALL(SETUP_XfOrM45(_), scheme_chaperone_of (v , a [2 + chap_star ] ) ))
          FUNCCALL(SETUP_XfOrM45(_), scheme_wrong_chaperoned ("vector-set!" , "value" , a [2 + chap_star ] , v ) ); 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 795 "bc/src/vector.c"
Scheme_Object * 
scheme_checked_vector_star_ref (int argc , Scheme_Object * argv [] ) 
{
  intptr_t i , len ; 
  Scheme_Object * vec ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(vec, 1)));
# define XfOrM50_COUNT (2)
# define SETUP_XfOrM50(x) SETUP(XfOrM50_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 

# 801 "bc/src/vector.c"
  vec = argv [0 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector*-ref" , "(and/c vector? (not impersonator?))" , 0 , argc , argv ) ); 

  len = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

  i = FUNCCALL(SETUP_XfOrM50(_), scheme_extract_index ("vector*-ref" , 1 , argc , argv , len , 0 ) ); 

  if (i >= len )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(bad_index ("vector*-ref" , "" , argv [1 ] , argv [0 ] , 0 ) )) RET_VALUE_EMPTY_END ; 

  RET_VALUE_START (((((Scheme_Vector * ) (vec ) ) -> els ) ) [i ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 815 "bc/src/vector.c"
Scheme_Object * 
scheme_checked_vector_set (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * vec = argv [0 ] ; 
  intptr_t i , len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(vec, 1)));
# define XfOrM51_COUNT (2)
# define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 821 "bc/src/vector.c"
  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    vec = (((Scheme_Chaperone * ) vec ) -> val ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (! (((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector-set!" , "(and/c vector? (not/c immutable?))" , 0 , argc , argv ) ); 

  len = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

  i = FUNCCALL(SETUP_XfOrM51(_), scheme_extract_index ("vector-set!" , 1 , argc , argv , len , 0 ) ); 

  if (i >= len )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(bad_index ("vector-set!" , "" , argv [1 ] , argv [0 ] , 0 ) )) RET_VALUE_EMPTY_END ; 

  if (! ((vec ) == (argv [0 ] ) ) )
    FUNCCALL(SETUP_XfOrM51(_), scheme_chaperone_vector_set (argv [0 ] , i , argv [2 ] ) ); 
  else 
  (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = argv [2 ] ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 842 "bc/src/vector.c"
Scheme_Object * 
scheme_checked_vector_star_set (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * vec = argv [0 ] ; 
  intptr_t i , len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(vec, 1)));
# define XfOrM52_COUNT (2)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 848 "bc/src/vector.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (! (((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector*-set!" , "(and/c vector? (not/c immutable?) (not/c impersonator?))" , 0 , argc , argv ) ); 

  len = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

  i = FUNCCALL(SETUP_XfOrM52(_), scheme_extract_index ("vector*-set!" , 1 , argc , argv , len , 0 ) ); 

  if (i >= len )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(bad_index ("vector*-set!" , "" , argv [1 ] , argv [0 ] , 0 ) )) RET_VALUE_EMPTY_END ; 

  (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = argv [2 ] ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 863 "bc/src/vector.c"
Scheme_Object * 
scheme_checked_vector_cas (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * vec = argv [0 ] ; 
  intptr_t i , len ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM53_COUNT (1)
# define SETUP_XfOrM53(x) SETUP(XfOrM53_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 869 "bc/src/vector.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (! (((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector-cas!" , "(and/c vector? (not/c immutable?) (not/c impersonator?))" , 0 , argc , argv ) ); 

  len = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

  i = FUNCCALL(SETUP_XfOrM53(_), scheme_extract_index ("vector-cas!" , 1 , argc , argv , len , 0 ) ); 

  if (i >= len )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(bad_index ("vector-cas!" , "" , argv [1 ] , argv [0 ] , 0 ) )) RET_VALUE_EMPTY_END ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unsafe_vector_star_cas (argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 884 "bc/src/vector.c"
Scheme_Object * 
scheme_vector_to_list (Scheme_Object * vec ) 
{
  int i ; 
  Scheme_Object * pair = scheme_null ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(vec, 0), PUSH(pair, 1)));
# define XfOrM54_COUNT (2)
# define SETUP_XfOrM54(x) SETUP(XfOrM54_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 890 "bc/src/vector.c"
  i = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

  if (i < 0xFFF ) {
#   define XfOrM62_COUNT (0+XfOrM54_COUNT)
#   define SETUP_XfOrM62(x) SETUP_XfOrM54(x)

# 893 "bc/src/vector.c"
    for (; i -- ; ) {
#     define XfOrM64_COUNT (0+XfOrM62_COUNT)
#     define SETUP_XfOrM64(x) SETUP_XfOrM62(x)

# 894 "bc/src/vector.c"
      pair = FUNCCALL(SETUP_XfOrM64(_), scheme_make_pair ((((Scheme_Vector * ) (vec ) ) -> els ) [i ] , pair ) ); 
    }
  }

# 896 "bc/src/vector.c"
  else {
#   define XfOrM55_COUNT (0+XfOrM54_COUNT)
#   define SETUP_XfOrM55(x) SETUP_XfOrM54(x)

# 897 "bc/src/vector.c"
    for (; i -- ; ) {
#     define XfOrM59_COUNT (0+XfOrM55_COUNT)
#     define SETUP_XfOrM59(x) SETUP_XfOrM55(x)

# 898 "bc/src/vector.c"
      if (! (i & 0xFFF ) ) 
      {
#       define XfOrM60_COUNT (0+XfOrM59_COUNT)
#       define SETUP_XfOrM60(x) SETUP_XfOrM59(x)

# 899 "bc/src/vector.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM61_COUNT (0+XfOrM60_COUNT)
#         define SETUP_XfOrM61(x) SETUP_XfOrM60(x)
          FUNCCALL(SETUP_XfOrM61(_), scheme_out_of_fuel () )
# 899 "bc/src/vector.c"
          ; 
        }
      }

# 899 "bc/src/vector.c"
      ; 
      pair = FUNCCALL(SETUP_XfOrM59(_), scheme_make_pair ((((Scheme_Vector * ) (vec ) ) -> els ) [i ] , pair ) ); 
    }
  }

  RET_VALUE_START (pair ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 908 "bc/src/vector.c"
Scheme_Object * 
chaperone_vector_to_list (Scheme_Object * vec ) 
{
  int i ; 
  Scheme_Object * pair = scheme_null ; 

# 717 "bc/src/vector.c"
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(vec, 0), PUSH(pair, 1)));
# define XfOrM65_COUNT (2)
# define SETUP_XfOrM65(x) SETUP(XfOrM65_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 914 "bc/src/vector.c"
  i = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) -> size ) ; 

  for (; i -- ; ) {
#   define XfOrM69_COUNT (0+XfOrM65_COUNT)
#   define SETUP_XfOrM69(x) SETUP_XfOrM65(x)

# 917 "bc/src/vector.c"
    if (! (i & 0xFFF ) ) 
    {
#     define XfOrM70_COUNT (0+XfOrM69_COUNT)
#     define SETUP_XfOrM70(x) SETUP_XfOrM69(x)

# 918 "bc/src/vector.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM71_COUNT (0+XfOrM70_COUNT)
#       define SETUP_XfOrM71(x) SETUP_XfOrM70(x)
        FUNCCALL(SETUP_XfOrM71(_), scheme_out_of_fuel () )
# 918 "bc/src/vector.c"
        ; 
      }
    }

# 918 "bc/src/vector.c"
    ; 
    pair = (__funcarg86 = FUNCCALL(SETUP_XfOrM69(_), scheme_chaperone_vector_ref (vec , i ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg86 , pair ) )) ; 
  }

  RET_VALUE_START (pair ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 925 "bc/src/vector.c"
static Scheme_Object * 
vector_to_list (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 928 "bc/src/vector.c"
  Scheme_Object * vec = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    vec = (((Scheme_Chaperone * ) vec ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
    scheme_wrong_contract ("vector->list" , "vector?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }

  if (! ((vec ) == (argv [0 ] ) ) )
    return chaperone_vector_to_list (argv [0 ] ) ; 
  else 
  return scheme_vector_to_list (vec ) ; 
}

static Scheme_Object * 
list_to_vector (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 947 "bc/src/vector.c"
  return scheme_list_to_vector (argv [0 ] ) ; 
}

Scheme_Object * 
scheme_list_to_vector (Scheme_Object * list ) 
{
  intptr_t len , i ; 
  Scheme_Object * vec , * orig = list ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(list, 0), PUSH(vec, 1), PUSH(orig, 2)));
# define XfOrM75_COUNT (3)
# define SETUP_XfOrM75(x) SETUP(XfOrM75_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 

# 956 "bc/src/vector.c"
  len = (scheme_proper_list_length (list ) ) ; 
  if (len < 0 )
    FUNCCALL(SETUP_XfOrM75(_), scheme_wrong_contract ("list->vector" , "list?" , - 1 , 0 , & orig ) ); 

  vec = FUNCCALL(SETUP_XfOrM75(_), scheme_make_vector (len , ((void * ) 0 ) ) ); 
  for (i = 0 ; i < len ; i ++ ) {
    (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 969 "bc/src/vector.c"
static Scheme_Object * 
vector_fill (int argc , Scheme_Object * argv [] ) 
{
  int i , sz ; 
  Scheme_Object * v , * vec = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(v, 1)));
# define XfOrM78_COUNT (2)
# define SETUP_XfOrM78(x) SETUP(XfOrM78_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 975 "bc/src/vector.c"
  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    vec = (((Scheme_Chaperone * ) vec ) -> val ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (! (((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector-fill!" , "(and/c vector? (not/c immutable?))" , 0 , argc , argv ) ); 

  v = argv [1 ] ; 
  sz = (((Scheme_Vector * ) (vec ) ) -> size ) ; 
  if ((vec ) == (argv [0 ] ) )  {
    for (i = 0 ; i < sz ; i ++ ) {
      (((Scheme_Vector * ) (argv [0 ] ) ) -> els ) [i ] = v ; 
    }
  }

# 987 "bc/src/vector.c"
  else {
#   define XfOrM79_COUNT (0+XfOrM78_COUNT)
#   define SETUP_XfOrM79(x) SETUP_XfOrM78(x)

# 988 "bc/src/vector.c"
    for (i = 0 ; i < sz ; i ++ ) {
#     define XfOrM81_COUNT (0+XfOrM79_COUNT)
#     define SETUP_XfOrM81(x) SETUP_XfOrM79(x)
      FUNCCALL(SETUP_XfOrM81(_), scheme_chaperone_vector_set (argv [0 ] , i , v ) )
# 989 "bc/src/vector.c"
      ; 
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 996 "bc/src/vector.c"
static Scheme_Object * vector_copy_bang (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * s1 , * s2 ; 
  intptr_t istart , ifinish ; 
  intptr_t ostart , ofinish ; 
  int slow = 0 ; 

# 717 "bc/src/vector.c"
  Scheme_Object * __funcarg90 = NULLED_OUT ; 

# 717 "bc/src/vector.c"
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s1, 0), PUSH(argv, 1), PUSH(s2, 2)));
# define XfOrM85_COUNT (3)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s1 = NULLED_OUT ; 
  s2 = NULLED_OUT ; 

# 1003 "bc/src/vector.c"
  s1 = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (s1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s1 ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    slow = 1 ; 
    s1 = (((Scheme_Chaperone * ) s1 ) -> val ) ; 
  }
  if (! (((Scheme_Type ) (((((intptr_t ) (s1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s1 ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (! (((Scheme_Inclhash_Object * ) (s1 ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector-copy!" , "(and/c vector? (not/c immutable?))" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM85(_), scheme_do_get_substring_indices ("vector-copy!" , s1 , argc , argv , 1 , 5 , & ostart , & ofinish , (((Scheme_Vector * ) (s1 ) ) -> size ) ) )


  ; 

  s2 = argv [2 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (s2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s2 ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    slow = 1 ; 
    s2 = (((Scheme_Chaperone * ) s2 ) -> val ) ; 
  }
  if (! ((Scheme_Type ) (((((intptr_t ) (s2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s2 ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector-copy!" , "vector?" , 2 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM85(_), scheme_do_get_substring_indices ("vector-copy!" , s2 , argc , argv , 3 , 4 , & istart , & ifinish , (((Scheme_Vector * ) (s2 ) ) -> size ) ) )


  ; 

  if ((ofinish - ostart ) < (ifinish - istart ) ) {
#   define XfOrM94_COUNT (0+XfOrM85_COUNT)
#   define SETUP_XfOrM94(x) SETUP_XfOrM85(x)
    FUNCCALL_EMPTY(scheme_contract_error ("vector-copy!" , "not enough room in target vector" , "target vector" , 1 , argv [2 ] , "starting index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (ostart ) ) ) << 1 ) | 0x1 ) ) , "element count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (ofinish - ostart ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (slow ) {
    int i , o ; 
#   define XfOrM87_COUNT (0+XfOrM85_COUNT)
#   define SETUP_XfOrM87(x) SETUP_XfOrM85(x)

# 1039 "bc/src/vector.c"
    if ((s2 == s1 ) 
    && (((istart <= ostart ) && (ifinish > ostart ) ) 
    || ((ostart <= istart ) && (ofinish > istart ) ) ) 
    && (istart < ostart ) ) {
#     define XfOrM91_COUNT (0+XfOrM87_COUNT)
#     define SETUP_XfOrM91(x) SETUP_XfOrM87(x)

# 1044 "bc/src/vector.c"
      for (i = ifinish , o = ofinish ; i -- > istart ; ) {
        o -- ; 
#       define XfOrM93_COUNT (0+XfOrM91_COUNT)
#       define SETUP_XfOrM93(x) SETUP_XfOrM91(x)
        (__funcarg90 = FUNCCALL(SETUP_XfOrM93(_), scheme_chaperone_vector_ref (argv [2 ] , i ) ), FUNCCALL_AGAIN(scheme_chaperone_vector_set (argv [0 ] , o , __funcarg90 ) )) 
# 1046 "bc/src/vector.c"
        ; 
      }
    }

# 1048 "bc/src/vector.c"
    else {
#     define XfOrM88_COUNT (0+XfOrM87_COUNT)
#     define SETUP_XfOrM88(x) SETUP_XfOrM87(x)

# 1049 "bc/src/vector.c"
      for (i = istart , o = ostart ; i < ifinish ; i ++ , o ++ ) {
#       define XfOrM90_COUNT (0+XfOrM88_COUNT)
#       define SETUP_XfOrM90(x) SETUP_XfOrM88(x)
        (__funcarg88 = FUNCCALL(SETUP_XfOrM90(_), scheme_chaperone_vector_ref (argv [2 ] , i ) ), FUNCCALL_AGAIN(scheme_chaperone_vector_set (argv [0 ] , o , __funcarg88 ) )) 
# 1050 "bc/src/vector.c"
        ; 
      }
    }
  }

# 1053 "bc/src/vector.c"
  else {
#   define XfOrM86_COUNT (0+XfOrM85_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM85(x)
    (
# 1054 "bc/src/vector.c"
    memmove ((((Scheme_Vector * ) (s1 ) ) -> els ) + ostart , 
    (((Scheme_Vector * ) (s2 ) ) -> els ) + istart , 
    (ifinish - istart ) * sizeof (Scheme_Object * ) ) ) ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1062 "bc/src/vector.c"
Scheme_Object * scheme_chaperone_vector_copy (Scheme_Object * vec ) 
{
  int len ; 
  Scheme_Object * a [3 ] , * vec2 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0), PUSH(vec, 3), PUSH(vec2, 4)));
# define XfOrM97_COUNT (5)
# define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  vec2 = NULLED_OUT ; 

# 1067 "bc/src/vector.c"
  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    len = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) -> size ) ; 
  else 
  len = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

  vec2 = FUNCCALL(SETUP_XfOrM97(_), scheme_make_vector (len , ((void * ) 0 ) ) ); 
  a [0 ] = vec2 ; 
  a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  a [2 ] = vec ; 

  (void ) FUNCCALL(SETUP_XfOrM97(_), vector_copy_bang (3 , a ) ); 

  RET_VALUE_START (vec2 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1082 "bc/src/vector.c"
static Scheme_Object * vector_to_immutable (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * vec , * ovec , * v ; 
  intptr_t len , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ovec, 1), PUSH(vec, 2), PUSH(v, 3)));
# define XfOrM98_COUNT (4)
# define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 
  ovec = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 1087 "bc/src/vector.c"
  vec = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    vec = (((Scheme_Chaperone * ) vec ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector->immutable-vector" , "vector?" , 0 , argc , argv ) ); 

  if (((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex & 0x1 ) 
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 

  ovec = vec ; 
  len = (((Scheme_Vector * ) (ovec ) ) -> size ) ; 

  vec = FUNCCALL(SETUP_XfOrM98(_), scheme_make_vector (len , ((void * ) 0 ) ) ); 
  if (! ((ovec ) == (argv [0 ] ) ) ) {
#   define XfOrM102_COUNT (0+XfOrM98_COUNT)
#   define SETUP_XfOrM102(x) SETUP_XfOrM98(x)

# 1102 "bc/src/vector.c"
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM104_COUNT (0+XfOrM102_COUNT)
#     define SETUP_XfOrM104(x) SETUP_XfOrM102(x)

# 1103 "bc/src/vector.c"
      v = FUNCCALL(SETUP_XfOrM104(_), scheme_chaperone_vector_ref (argv [0 ] , i ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = v ; 
    }
  }

# 1106 "bc/src/vector.c"
  else {
    for (i = 0 ; i < len ; i ++ ) {
      (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = (((Scheme_Vector * ) (ovec ) ) -> els ) [i ] ; 
    }
  }
  ((((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex |= 0x1 ) ) ; 

  RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1116 "bc/src/vector.c"
static Scheme_Object * vector_to_values (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p ; 
  Scheme_Object * vec , * * a , * plain_vec ; 
  intptr_t len , start , finish , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(argv, 1), PUSH(p, 2), PUSH(vec, 3), PUSH(plain_vec, 4)));
# define XfOrM105_COUNT (5)
# define SETUP_XfOrM105(x) SETUP(XfOrM105_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  a = NULLED_OUT ; 
  plain_vec = NULLED_OUT ; 

# 1122 "bc/src/vector.c"
  vec = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    vec = (((Scheme_Chaperone * ) vec ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("vector->values" , "vector?" , 0 , argc , argv ) ); 

  len = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

  if (argc > 1 )
    start = FUNCCALL(SETUP_XfOrM105(_), scheme_extract_index ("vector->values" , 1 , argc , argv , len + 1 , 0 ) ); 
  else 
  start = 0 ; 
  if (argc > 2 )
    finish = FUNCCALL(SETUP_XfOrM105(_), scheme_extract_index ("vector->values" , 2 , argc , argv , len + 1 , 0 ) ); 
  else 
  finish = len ; 

  if (! (start <= len ) ) {
#   define XfOrM114_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM114(x) SETUP_XfOrM105(x)
    FUNCCALL(SETUP_XfOrM114(_), bad_index ("vector->values" , "starting " , argv [1 ] , argv [0 ] , 0 ) )
# 1141 "bc/src/vector.c"
    ; 
  }
  if (! (finish >= start && finish <= len ) ) {
#   define XfOrM113_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM113(x) SETUP_XfOrM105(x)
    FUNCCALL(SETUP_XfOrM113(_), bad_index ("vector->values" , "ending " , argv [2 ] , argv [0 ] , start ) )
# 1144 "bc/src/vector.c"
    ; 
  }

  len = finish - start ; 
  if (len == 1 ) {
#   define XfOrM112_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM112(x) SETUP_XfOrM105(x)

# 1149 "bc/src/vector.c"
    if (! ((vec ) == (argv [0 ] ) ) )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_chaperone_vector_ref (argv [0 ] , start ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_START ((((Scheme_Vector * ) (vec ) ) -> els ) [start ] ) RET_VALUE_END ; 
  }

  if (! ((vec ) == (argv [0 ] ) ) ) {
#   define XfOrM109_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM109(x) SETUP_XfOrM105(x)

# 1156 "bc/src/vector.c"
    plain_vec = FUNCCALL(SETUP_XfOrM109(_), scheme_make_vector (len , ((void * ) 0 ) ) ); 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM111_COUNT (0+XfOrM109_COUNT)
#     define SETUP_XfOrM111(x) SETUP_XfOrM109(x)

# 1158 "bc/src/vector.c"
      vec = FUNCCALL(SETUP_XfOrM111(_), scheme_chaperone_vector_ref (argv [0 ] , start + i ) ); 
      (((Scheme_Vector * ) (plain_vec ) ) -> els ) [i ] = vec ; 
    }
    vec = plain_vec ; 
    start = 0 ; 
  }

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  if (p -> values_buffer && (p -> values_buffer_size >= len ) )
    a = p -> values_buffer ; 
  else {
#   define XfOrM108_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM108(x) SETUP_XfOrM105(x)

# 1169 "bc/src/vector.c"
    a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM108(_), GC_malloc (sizeof (Scheme_Object * ) * (len ) ) )) ; 
    p -> values_buffer = a ; 
    p -> values_buffer_size = len ; 
  }

  p -> ku . multiple . array = a ; 
  p -> ku . multiple . count = len ; 

  for (i = 0 ; i < len ; i ++ ) {
    a [i ] = (((Scheme_Vector * ) (vec ) ) -> els ) [start + i ] ; 
  }

  RET_VALUE_START (((Scheme_Object * ) 0x6 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1184 "bc/src/vector.c"
static Scheme_Object * do_chaperone_vector (const char * name , int is_impersonator , int pass_self , int unsafe , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(props, 3), PUSH(px, 4), PUSH(redirects, 5)));
# define XfOrM115_COUNT (6)
# define SETUP_XfOrM115(x) SETUP(XfOrM115_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 1191 "bc/src/vector.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 
  }

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
  || (is_impersonator && ! (! (((Scheme_Inclhash_Object * ) (val ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , is_impersonator ? "(and/c vector? (not/c immutable?))" : "vector?" , 0 , argc , argv ) ); 

  if (unsafe ) {
#   define XfOrM122_COUNT (0+XfOrM115_COUNT)
#   define SETUP_XfOrM122(x) SETUP_XfOrM115(x)

    if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
#     define XfOrM123_COUNT (0+XfOrM122_COUNT)
#     define SETUP_XfOrM123(x) SETUP_XfOrM122(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "(and/c vector? (not/c impersonator?))" , 1 , argc , argv ) )
# 1204 "bc/src/vector.c"
      ; 
    }
    val = argv [1 ] ; 
  }
  else {
#   define XfOrM120_COUNT (0+XfOrM115_COUNT)
#   define SETUP_XfOrM120(x) SETUP_XfOrM115(x)
    FUNCCALL(SETUP_XfOrM120(_), scheme_check_proc_arity2 (name , 3 + (pass_self ? 1 : 0 ) , 1 , argc , argv , 1 ) )
# 1210 "bc/src/vector.c"
    ; 
    FUNCCALL(SETUP_XfOrM120(_), scheme_check_proc_arity2 (name , 3 + (pass_self ? 1 : 0 ) , 2 , argc , argv , 1 ) ); 


    if ((((argv [1 ] ) ) == (scheme_false ) ) != (((argv [2 ] ) ) == (scheme_false ) ) ) {
#     define XfOrM121_COUNT (0+XfOrM120_COUNT)
#     define SETUP_XfOrM121(x) SETUP_XfOrM120(x)
      FUNCCALL_EMPTY(scheme_contract_error (name , "accessor and mutator wrapper must be both `#f` or neither `#f`" , "accessor wrapper" , 1 , argv [1 ] , "mutator wrapper" , 1 , argv [2 ] , ((void * ) 0 ) ) )

      ; 
    }
  }

  props = FUNCCALL(SETUP_XfOrM115(_), scheme_parse_chaperone_props (name , unsafe ? 2 : 3 , argc , argv ) ); 






  if (((argv [1 ] ) ) == (scheme_false ) )  {
#   define XfOrM119_COUNT (0+XfOrM115_COUNT)
#   define SETUP_XfOrM119(x) SETUP_XfOrM115(x)

# 1231 "bc/src/vector.c"
    redirects = FUNCCALL(SETUP_XfOrM119(_), scheme_make_vector (0 , ((void * ) 0 ) ) ); 
  }
  else if (unsafe ) {
    redirects = scheme_false ; 
  }
  else {
#   define XfOrM117_COUNT (0+XfOrM115_COUNT)
#   define SETUP_XfOrM117(x) SETUP_XfOrM115(x)

# 1237 "bc/src/vector.c"
    redirects = FUNCCALL(SETUP_XfOrM117(_), scheme_make_pair (argv [1 ] , argv [2 ] ) ); 
  }

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM115(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> props = props ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 


  if (pass_self ) {
    (& (px ) -> iso ) -> so . keyex |= 0x2 ; 
  }
  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1257 "bc/src/vector.c"
static Scheme_Object * chaperone_vector (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1259 "bc/src/vector.c"
  return do_chaperone_vector ("chaperone-vector" , 0 , 0 , 0 , argc , argv ) ; 
}

static Scheme_Object * chaperone_vector_star (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1264 "bc/src/vector.c"
  return do_chaperone_vector ("chaperone-vector*" , 0 , 1 , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_vector (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1269 "bc/src/vector.c"
  return do_chaperone_vector ("impersonate-vector" , 1 , 0 , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_vector_star (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1274 "bc/src/vector.c"
  return do_chaperone_vector ("impersonate-vector*" , 1 , 1 , 0 , argc , argv ) ; 
}

static Scheme_Object * unsafe_chaperone_vector (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1279 "bc/src/vector.c"
  return do_chaperone_vector ("unsafe-chaperone-vector" , 0 , 0 , 1 , argc , argv ) ; 
}

static Scheme_Object * unsafe_impersonate_vector (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1284 "bc/src/vector.c"
  return do_chaperone_vector ("unsafe-impersonate-vector" , 1 , 0 , 1 , argc , argv ) ; 
}





static Scheme_Object * unsafe_vector_len (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1293 "bc/src/vector.c"
  Scheme_Object * vec = argv [0 ] ; 
  intptr_t n ; 
  if (((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 

# 1295 "bc/src/vector.c"
  vec = (((Scheme_Chaperone * ) vec ) -> val ) ; 
  n = (((Scheme_Vector * ) (vec ) ) -> size ) ; 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * unsafe_vector_ref (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1302 "bc/src/vector.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    return scheme_chaperone_vector_ref (argv [0 ] , (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ; 
  else 
  return (((Scheme_Vector * ) (argv [0 ] ) ) -> els ) [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] ; 
}

static Scheme_Object * unsafe_vector_set (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM133_COUNT (1)
# define SETUP_XfOrM133(x) SETUP(XfOrM133_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1310 "bc/src/vector.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    FUNCCALL(SETUP_XfOrM133(_), scheme_chaperone_vector_set (argv [0 ] , (((intptr_t ) (argv [1 ] ) ) >> 1 ) , argv [2 ] ) ); 
  else 
  (((Scheme_Vector * ) (argv [0 ] ) ) -> els ) [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] = argv [2 ] ; 
  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1317 "bc/src/vector.c"
static Scheme_Object * unsafe_vector_star_len (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1319 "bc/src/vector.c"
  Scheme_Object * vec = argv [0 ] ; 
  intptr_t n ; 
  n = (((Scheme_Vector * ) (vec ) ) -> size ) ; 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * unsafe_vector_star_ref (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1327 "bc/src/vector.c"
  return (((Scheme_Vector * ) (argv [0 ] ) ) -> els ) [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] ; 
}

static Scheme_Object * unsafe_vector_star_set (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1332 "bc/src/vector.c"
  (((Scheme_Vector * ) (argv [0 ] ) ) -> els ) [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] = argv [2 ] ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_vector_star_cas (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1338 "bc/src/vector.c"
  Scheme_Object * vec = argv [0 ] ; 
  Scheme_Object * idx = argv [1 ] ; 
  Scheme_Object * ov = argv [2 ] ; 
  Scheme_Object * nv = argv [3 ] ; 







  if ((((Scheme_Vector * ) (vec ) ) -> els ) [(((intptr_t ) (idx ) ) >> 1 ) ] == ov ) {
    (((Scheme_Vector * ) (vec ) ) -> els ) [(((intptr_t ) (idx ) ) >> 1 ) ] = nv ; 
    return scheme_true ; 
  }

# 1352 "bc/src/vector.c"
  else {
    return scheme_false ; 
  }
}


static Scheme_Object * unsafe_struct_ref (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1360 "bc/src/vector.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    return scheme_struct_ref (argv [0 ] , (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ; 
  else 
  return ((Scheme_Structure * ) argv [0 ] ) -> slots [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] ; 
}

static Scheme_Object * unsafe_struct_set (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM141_COUNT (1)
# define SETUP_XfOrM141(x) SETUP(XfOrM141_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1368 "bc/src/vector.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    FUNCCALL(SETUP_XfOrM141(_), scheme_struct_set (argv [0 ] , (((intptr_t ) (argv [1 ] ) ) >> 1 ) , argv [2 ] ) ); 
  else 
  ((Scheme_Structure * ) argv [0 ] ) -> slots [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] = argv [2 ] ; 
  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1375 "bc/src/vector.c"
static Scheme_Object * unsafe_struct_star_ref (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1377 "bc/src/vector.c"
  return ((Scheme_Structure * ) argv [0 ] ) -> slots [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] ; 
}

static Scheme_Object * unsafe_struct_star_set (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1382 "bc/src/vector.c"
  ((Scheme_Structure * ) argv [0 ] ) -> slots [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] = argv [2 ] ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_struct_star_cas (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1388 "bc/src/vector.c"
  Scheme_Object * s = argv [0 ] ; 
  Scheme_Object * idx = argv [1 ] ; 
  Scheme_Object * ov = argv [2 ] ; 
  Scheme_Object * nv = argv [3 ] ; 







  if (((Scheme_Structure * ) s ) -> slots [(((intptr_t ) (idx ) ) >> 1 ) ] == ov ) {
    ((Scheme_Structure * ) s ) -> slots [(((intptr_t ) (idx ) ) >> 1 ) ] = nv ; 
    return scheme_true ; 
  }

# 1402 "bc/src/vector.c"
  else {
    return scheme_false ; 
  }
}


static Scheme_Object * unsafe_string_len (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1410 "bc/src/vector.c"
  intptr_t n = (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . tag_val ) ; 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * unsafe_string_ref (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1416 "bc/src/vector.c"
  mzchar v ; 
  v = (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . string_val ) [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] ; 
  return scheme_char_constants [(unsigned char ) (v ) ] ; 
}

static Scheme_Object * unsafe_string_set (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1423 "bc/src/vector.c"
  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . string_val ) [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] = (((Scheme_Small_Object * ) (argv [2 ] ) ) -> u . char_val ) ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_bytes_len (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1429 "bc/src/vector.c"
  intptr_t n = (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . tag_val ) ; 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * unsafe_bytes_ref (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1435 "bc/src/vector.c"
  intptr_t v ; 
  v = (unsigned char ) (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . string_val ) [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] ; 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * unsafe_bytes_set (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1442 "bc/src/vector.c"
  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . string_val ) [(((intptr_t ) (argv [1 ] ) ) >> 1 ) ] = (char ) (((intptr_t ) (argv [2 ] ) ) >> 1 ) ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_bytes_copy_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1448 "bc/src/vector.c"
  Scheme_Object * s1 , * s2 ; 
  intptr_t istart , ifinish ; 
  intptr_t ostart ; 

  s1 = argv [0 ] ; 
  ostart = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  s2 = argv [2 ] ; 
  if (argc > 3 ) {
    istart = (((intptr_t ) (argv [3 ] ) ) >> 1 ) ; 
    if (argc > 4 )
      ifinish = (((intptr_t ) (argv [4 ] ) ) >> 1 ) ; 
    else 
    ifinish = (((Scheme_Simple_Object * ) (s2 ) ) -> u . byte_str_val . tag_val ) ; 
  }

# 1461 "bc/src/vector.c"
  else {
    istart = 0 ; 
    ifinish = (((Scheme_Simple_Object * ) (s2 ) ) -> u . byte_str_val . tag_val ) ; 
  }

  memmove ((((Scheme_Simple_Object * ) (s1 ) ) -> u . byte_str_val . string_val ) XFORM_OK_PLUS ostart , 
  (((Scheme_Simple_Object * ) (s2 ) ) -> u . byte_str_val . string_val ) XFORM_OK_PLUS istart , 
  (ifinish - istart ) ) ; 

  return scheme_void ; 
}

static Scheme_Object * unsafe_bytes_immutable_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1475 "bc/src/vector.c"
  Scheme_Object * o = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
    scheme_wrong_contract ("unsafe-bytes->immutable-bytes!" , "bytes?" , 0 , argc , argv ) ; 

  ((((Scheme_Inclhash_Object * ) (o ) ) -> so . keyex |= 0x1 ) ) ; 

  return o ; 
}

static Scheme_Object * unsafe_string_immutable_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1487 "bc/src/vector.c"
  Scheme_Object * o = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    scheme_wrong_contract ("unsafe-string->immutable-string!" , "string?" , 0 , argc , argv ) ; 

  ((((Scheme_Inclhash_Object * ) (o ) ) -> so . keyex |= 0x1 ) ) ; 

  return o ; 
}

static Scheme_Object * unsafe_vector_immutable_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1499 "bc/src/vector.c"
  Scheme_Object * o = argv [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    scheme_wrong_contract ("unsafe-vector*->immutable-vector!" , "(and/c vector? (not/c impersonator?))" , 
  0 , argc , argv ) ; 

  ((((Scheme_Inclhash_Object * ) (o ) ) -> so . keyex |= 0x1 ) ) ; 

  return o ; 
}

# 1524 "bc/src/vector.c"
int scheme_stencil_vector_popcount (intptr_t x ) {
  /* No conversion */
  return (scheme_hamt_popcount ((hash_tree_bitmap_t ) (x & 0xFFFFFFFF ) ) 
  + scheme_hamt_popcount ((hash_tree_bitmap_t ) ((uintptr_t ) x >> 32 ) ) ) ; 
}




static Scheme_Object * stencil_vector_p (int argc , Scheme_Object * * argv ) {
  /* No conversion */

# 1534 "bc/src/vector.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * stencil_vector (int argc , Scheme_Object * * argv ) {
  Scheme_Stencil_Vector * sv ; 
  Scheme_Object * mask = argv [0 ] ; 
  intptr_t size , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(sv, 1), PUSH(mask, 2)));
# define XfOrM161_COUNT (3)
# define SETUP_XfOrM161(x) SETUP(XfOrM161_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sv = NULLED_OUT ; 

# 1542 "bc/src/vector.c"
  if (! (((intptr_t ) (mask ) ) & 0x1 ) 
  || ((((intptr_t ) (mask ) ) >> 1 ) < 0 ) 
  || ((((intptr_t ) (mask ) ) >> 1 ) > (((intptr_t ) 1 << 58 ) - 1 ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("stencil-vector" , "(integer-in 0 (sub1 (expt 2 (stencil-vector-mask-width))))" , 0 , argc , argv ) ); 

  size = (scheme_stencil_vector_popcount ((((intptr_t ) (mask ) ) >> 1 ) ) ) ; 

  if (size + 1 != argc )
    FUNCCALL_EMPTY(scheme_contract_error ("stencil-vector" , "mask does not match given number of items" , "mask" , 1 , mask , "given items" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (argc - 1 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )



  ; 

  sv = (Scheme_Stencil_Vector * ) FUNCCALL(SETUP_XfOrM161(_), GC_malloc_one_tagged ((sizeof (Scheme_Stencil_Vector ) + ((size ) - 0 ) * sizeof (Scheme_Object * ) ) ) ); 
  sv -> so . type = scheme_stencil_vector_type ; 
  sv -> mask = (((intptr_t ) (mask ) ) >> 1 ) ; 
  for (i = 0 ; i < size ; i ++ ) {
    sv -> els [i ] = argv [i + 1 ] ; 
  }

  RET_VALUE_START ((Scheme_Object * ) sv ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1566 "bc/src/vector.c"
static Scheme_Object * stencil_vector_mask (int argc , Scheme_Object * * argv ) {
  /* No conversion */

# 1567 "bc/src/vector.c"
  Scheme_Stencil_Vector * sv ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) )
    scheme_wrong_contract ("stencil-vector-mask" , "stencil-vector?" , 0 , argc , argv ) ; 
  sv = (Scheme_Stencil_Vector * ) argv [0 ] ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (sv -> mask ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * stencil_vector_length (int argc , Scheme_Object * * argv ) {
  /* No conversion */

# 1577 "bc/src/vector.c"
  Scheme_Stencil_Vector * sv ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) )
    scheme_wrong_contract ("stencil-vector-length" , "stencil-vector?" , 0 , argc , argv ) ; 
  sv = (Scheme_Stencil_Vector * ) argv [0 ] ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_stencil_vector_popcount (sv -> mask ) ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * stencil_vector_ref (int argc , Scheme_Object * * argv ) {
  Scheme_Stencil_Vector * sv ; 
  intptr_t len , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(sv, 1)));
# define XfOrM166_COUNT (2)
# define SETUP_XfOrM166(x) SETUP(XfOrM166_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sv = NULLED_OUT ; 

# 1590 "bc/src/vector.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("stencil-vector-ref" , "stencil-vector?" , 0 , argc , argv ) ); 
  sv = (Scheme_Stencil_Vector * ) argv [0 ] ; 

  len = (scheme_stencil_vector_popcount (sv -> mask ) ) ; 

  i = FUNCCALL(SETUP_XfOrM166(_), scheme_extract_index ("stencil-vector-ref" , 1 , argc , argv , len , 0 ) ); 

  if (i >= len )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(bad_index ("stencil-vector-ref" , "" , argv [1 ] , argv [0 ] , 0 ) )) RET_VALUE_EMPTY_END ; 

  RET_VALUE_START (sv -> els [i ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1604 "bc/src/vector.c"
static Scheme_Object * stencil_vector_set (int argc , Scheme_Object * * argv ) {
  Scheme_Stencil_Vector * sv ; 
  intptr_t len , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sv, 0), PUSH(argv, 1)));
# define XfOrM167_COUNT (2)
# define SETUP_XfOrM167(x) SETUP(XfOrM167_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sv = NULLED_OUT ; 

# 1608 "bc/src/vector.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("stencil-vector-set!" , "stencil-vector?" , 0 , argc , argv ) ); 
  sv = (Scheme_Stencil_Vector * ) argv [0 ] ; 

  len = (scheme_stencil_vector_popcount (sv -> mask ) ) ; 

  i = FUNCCALL(SETUP_XfOrM167(_), scheme_extract_index ("stencil-vector-set!" , 1 , argc , argv , len , 0 ) ); 

  if (i >= len )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(bad_index ("stencil-vector-ref" , "" , argv [1 ] , argv [0 ] , 0 ) )) RET_VALUE_EMPTY_END ; 

  sv -> els [i ] = argv [2 ] ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1624 "bc/src/vector.c"
static Scheme_Object * stencil_vector_update (int argc , Scheme_Object * * argv ) {
  Scheme_Stencil_Vector * sv , * new_sv ; 
  Scheme_Object * r_mask = argv [1 ] , * a_mask = argv [2 ] ; 
  intptr_t am , rm , m , size , old_i , new_i , arg_i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(sv, 1), PUSH(new_sv, 2)));
# define XfOrM168_COUNT (3)
# define SETUP_XfOrM168(x) SETUP(XfOrM168_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sv = NULLED_OUT ; 
  new_sv = NULLED_OUT ; 

# 1629 "bc/src/vector.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("stencil-vector-update" , "stencil-vector?" , 0 , argc , argv ) ); 
  sv = (Scheme_Stencil_Vector * ) argv [0 ] ; 

  if (! (((intptr_t ) (r_mask ) ) & 0x1 ) 
  || ((((intptr_t ) (r_mask ) ) >> 1 ) < 0 ) 
  || ((((intptr_t ) (r_mask ) ) >> 1 ) > (((intptr_t ) 1 << 58 ) - 1 ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("stencil-vector-update" , "(integer-in 0 (sub1 (expt 2 (stencil-vector-mask-width))))" , 1 , argc , argv ) ); 
  if (! (((intptr_t ) (a_mask ) ) & 0x1 ) 
  || ((((intptr_t ) (a_mask ) ) >> 1 ) < 0 ) 
  || ((((intptr_t ) (a_mask ) ) >> 1 ) > (((intptr_t ) 1 << 58 ) - 1 ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("stencil-vector-update" , "(integer-in 0 (sub1 (expt 2 (stencil-vector-mask-width))))" , 2 , argc , argv ) ); 

  rm = (((intptr_t ) (r_mask ) ) >> 1 ) ; 
  am = (((intptr_t ) (a_mask ) ) >> 1 ) ; 

  if ((sv -> mask & rm ) != rm )
    FUNCCALL_EMPTY(scheme_contract_error ("stencil-vector" , "mask of stencil vector does not have all bits in removal mask" , "stencil vector" , 1 , (Scheme_Object * ) sv , "removal mask" , 1 , r_mask , ((void * ) 0 ) ) )



  ; 
  if (((sv -> mask & ~ rm ) & am ) != 0 )
    FUNCCALL_EMPTY(scheme_contract_error ("stencil-vector" , "mask of stencil vector already has bits in addition mask" , "stencil vector" , 1 , (Scheme_Object * ) sv , "addition mask" , 1 , a_mask , ((void * ) 0 ) ) )



  ; 

  size = (scheme_stencil_vector_popcount (am ) ) ; 
  if (size + 3 != argc )
    FUNCCALL_EMPTY(scheme_contract_error ("stencil-vector" , "mask does not match given number of items" , "mask" , 1 , a_mask , "given items" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (argc - 3 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )



  ; 

  m = ((sv -> mask & ~ rm ) | am ) ; 
  size = (scheme_stencil_vector_popcount (m ) ) ; 

  new_sv = (Scheme_Stencil_Vector * ) FUNCCALL(SETUP_XfOrM168(_), GC_malloc_one_tagged ((sizeof (Scheme_Stencil_Vector ) + ((size ) - 0 ) * sizeof (Scheme_Object * ) ) ) ); 
  new_sv -> so . type = scheme_stencil_vector_type ; 
  new_sv -> mask = m ; 

  for (old_i = 0 , new_i = 0 , arg_i = 3 ; m ; m = m >> 1 , am = am >> 1 , rm = rm >> 1 ) {
    if (m & 0x1 ) {
      if (am & 0x1 ) {
        if (rm & 0x1 )
          old_i ++ ; 
        new_sv -> els [new_i ++ ] = argv [arg_i ++ ] ; 
      }

# 1679 "bc/src/vector.c"
      else 
      new_sv -> els [new_i ++ ] = sv -> els [old_i ++ ] ; 
    }

# 1681 "bc/src/vector.c"
    else if (rm & 0x1 )
      old_i ++ ; 
  }

  RET_VALUE_START ((Scheme_Object * ) new_sv ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1688 "bc/src/vector.c"
static Scheme_Object * stencil_vector_mask_width (int argc , Scheme_Object * * argv ) {
  /* No conversion */

# 1689 "bc/src/vector.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (58 ) ) ) << 1 ) | 0x1 ) ) ; 
}
