#include "precomp.h"

# 34 "bc/rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 121 "rktio/rktio.h"
typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 256 "rktio/rktio.h"
__xform_nongcing__ extern void rktio_forget (rktio_t * rktio , rktio_fd_t * fd ) ; 




__xform_nongcing__ extern rktio_fd_t * rktio_std_fd (rktio_t * rktio , int which ) ; 






__xform_nongcing__ extern void rktio_create_console (void ) ; 

# 351 "rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "rktio/rktio.h"
rktio_process_result_t ; 

# 646 "rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "rktio/rktio.h"
rktio_status_t ; 

# 669 "rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "rktio/rktio.h"
rktio_identity_t ; 

# 925 "rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "rktio/rktio.h"
rktio_date_t ; 

# 1109 "rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1152 "rktio/rktio.h"
__xform_nongcing__ extern rktio_ok_t rktio_syslog (rktio_t * rktio , int level , rktio_const_string_t name , rktio_const_string_t msg , 
rktio_const_string_t exec_name ) ; 






enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 









__xform_nongcing__ extern int rktio_get_last_error_kind (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 

__xform_nongcing__ extern int rktio_get_last_error (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 









__xform_nongcing__ extern void rktio_remap_last_error (rktio_t * rktio ) ; 





__xform_nongcing__ extern const char * rktio_get_error_string (rktio_t * rktio , int kind , int errid ) ; 

# 46 "/usr/include/ctype.h" 3
enum 
{
  _ISupper = (1 << (0 ) ) , 
  _ISlower = (1 << (1 ) ) , 
  _ISalpha = (1 << (2 ) ) , 
  _ISdigit = (1 << (3 ) ) , 
  _ISxdigit = (1 << (4 ) ) , 
  _ISspace = (1 << (5 ) ) , 
  _ISprint = (1 << (6 ) ) , 
  _ISgraph = (1 << (7 ) ) , 
  _ISblank = (1 << (8 ) ) , 
  _IScntrl = (1 << (9 ) ) , 
  _ISpunct = (1 << (10 ) ) , 
  _ISalnum = (1 << (11 ) ) }
; 

# 81 "/usr/include/ctype.h" 3
extern const __int32_t * * __ctype_tolower_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 
extern const __int32_t * * __ctype_toupper_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 

# 122 "/usr/include/ctype.h" 3
extern int tolower (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 


extern int toupper (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 206 "/usr/include/ctype.h" 3
extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) tolower (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_tolower_loc () ) [__c ] : __c ; 
}

extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) toupper (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_toupper_loc () ) [__c ] : __c ; 
}

# 37 "/usr/include/errno.h" 3
extern int * __errno_location (void ) __attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 

# 21 "bc/src/error.c"
scheme_console_printf_t scheme_console_printf ; 
scheme_console_printf_t scheme_get_console_printf () {
  /* No conversion */

# 22 "bc/src/error.c"
  return scheme_console_printf ; 
}

# 23 "bc/src/error.c"
void scheme_set_console_printf (scheme_console_printf_t p ) {
  /* No conversion */

# 23 "bc/src/error.c"
  scheme_console_printf = p ; 
}

# 24 "bc/src/error.c"
Scheme_Exit_Proc scheme_exit ; 
void scheme_set_exit (Scheme_Exit_Proc p ) {
  /* No conversion */

# 25 "bc/src/error.c"
  scheme_exit = p ; 
}
void (* scheme_console_output ) (char * str , intptr_t len ) ; 
void scheme_set_console_output (scheme_console_output_t p ) {
  /* No conversion */

# 28 "bc/src/error.c"
  scheme_console_output = p ; 
}
static Scheme_Object * init_syslog_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
static Scheme_Object * init_stderr_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (2 ) ) ) << 1 ) | 0x1 ) ) ; 
static Scheme_Object * init_stdout_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
; 
; 
; 
; 

Scheme_Object * scheme_default_realm ; 
Scheme_Object * scheme_primitive_realm ; 


static Scheme_Object * none_symbol ; 
static Scheme_Object * fatal_symbol ; 
static Scheme_Object * error_symbol ; 
static Scheme_Object * warning_symbol ; 
static Scheme_Object * info_symbol ; 
static Scheme_Object * debug_symbol ; 
static Scheme_Object * posix_symbol ; 
static Scheme_Object * windows_symbol ; 
static Scheme_Object * gai_symbol ; 
static Scheme_Object * local_realm_symbol ; 
static Scheme_Object * name_symbol ; 
static Scheme_Object * message_symbol ; 
static Scheme_Object * contract_symbol ; 
static Scheme_Object * arity_property ; 
static Scheme_Object * def_err_val_proc ; 
static Scheme_Object * def_err_stx_proc ; 
static Scheme_Object * def_error_esc_proc ; 
static Scheme_Object * def_err_msg_adjust_proc ; 
static Scheme_Object * def_err_msg_adjust_name_proc ; 
static Scheme_Object * def_err_msg_adjust_message_proc ; 
static Scheme_Object * def_err_msg_adjust_contract_proc ; 
static Scheme_Object * default_display_handler ; 
static Scheme_Object * emergency_display_handler ; 
static Scheme_Object * def_exe_yield_proc ; 
Scheme_Object * scheme_def_exit_proc ; 
Scheme_Object * scheme_raise_arity_error_proc ; 






static mzrt_mutex * glib_log_queue_lock ; 
typedef struct glib_log_queue_entry {
  const char * log_domain ; 
  int log_level ; 
  const char * message ; 
  struct glib_log_queue_entry * next ; 
}

# 80 "bc/src/error.c"
glib_log_queue_entry ; 
static glib_log_queue_entry * glib_log_queue ; 
static void * glib_log_signal_handle ; 



static Scheme_Object * error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * assert_unreachable (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_user_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_type_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_argument_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_argument_error_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_result_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_result_error_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_mismatch_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arguments_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arguments_error_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_range_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_range_error_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arity_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arity_error_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arity_mask_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arity_mask_error_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_result_arity_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_result_arity_error_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * error_escape_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_display_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_value_string_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_syntax_string_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * current_error_message_adjuster (int , Scheme_Object * [] ) ; 
static Scheme_Object * exit_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * exe_yield_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_print_width (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_print_context_length (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_print_srcloc (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_message_to_adjusted_string (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_contract_to_adjusted_string (int , Scheme_Object * [] ) ; 
static void def_error_escape_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_display_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * emergency_error_display_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_value_string_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_syntax_string_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_message_adjust_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_message_adjust_name_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_message_adjust_message_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_message_adjust_contract_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_exit_handler_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * default_yield_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * srcloc_to_string (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unquoted_printing_string (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unquoted_printing_string_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unquoted_printing_string_value (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * log_message (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_level_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_max_level (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_all_levels (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_level_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_logger (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * logger_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_logger (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * logger_name (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_log_reader (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_reader_p (int argc , Scheme_Object * argv [] ) ; 
static int log_reader_get (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) ; 

static void do_raise (Scheme_Object * arg , int need_debug , int barrier ) ; 
static void nested_exn_handler (void * old_exn , int argc , Scheme_Object * argv [] ) ; 

static void update_want_level (Scheme_Logger * logger , Scheme_Object * name ) ; 

static Scheme_Object * check_arity_property_value_ok (int argc , Scheme_Object * argv [] ) ; 

static char * make_provided_list (Scheme_Object * o , int count , intptr_t * lenout ) ; 

static char * init_buf (intptr_t * len , intptr_t * blen ) ; 

void scheme_set_logging2 (int syslog_level , int stderr_level , int stdout_level ) 
{
  /* No conversion */

# 159 "bc/src/error.c"
  if (syslog_level > - 1 )
    init_syslog_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (syslog_level ) ) ) << 1 ) | 0x1 ) ) ; 
  if (stderr_level > - 1 )
    init_stderr_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stderr_level ) ) ) << 1 ) | 0x1 ) ) ; 
  if (stdout_level > - 1 )
    init_stdout_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stdout_level ) ) ) << 1 ) | 0x1 ) ) ; 
}

void scheme_set_logging (int syslog_level , int stderr_level ) 
{
  /* No conversion */

# 169 "bc/src/error.c"
  scheme_set_logging2 (syslog_level , stderr_level , - 1 ) ; 
}

void scheme_set_logging2_spec (Scheme_Object * syslog_level , Scheme_Object * stderr_level , Scheme_Object * stdout_level ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(syslog_level, 0), PUSH(stderr_level, 1), PUSH(stdout_level, 2)));
# define XfOrM7_COUNT (3)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 175 "bc/src/error.c"
  if (syslog_level ) {
#   define XfOrM10_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM7(x)
    FUNCCALL(SETUP_XfOrM10(_), scheme_register_static ((void * ) & init_syslog_level , sizeof (init_syslog_level ) ) )
# 176 "bc/src/error.c"
    ; 
    init_syslog_level = syslog_level ; 
  }
  if (stderr_level ) {
#   define XfOrM9_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM9(x) SETUP_XfOrM7(x)
    FUNCCALL(SETUP_XfOrM9(_), scheme_register_static ((void * ) & init_stderr_level , sizeof (init_stderr_level ) ) )
# 180 "bc/src/error.c"
    ; 
    init_stderr_level = stderr_level ; 
  }
  if (stdout_level ) {
#   define XfOrM8_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM8(x) SETUP_XfOrM7(x)
    FUNCCALL(SETUP_XfOrM8(_), scheme_register_static ((void * ) & init_stdout_level , sizeof (init_stdout_level ) ) )
# 184 "bc/src/error.c"
    ; 
    init_stdout_level = stdout_level ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 189 "bc/src/error.c"
void scheme_set_logging_spec (Scheme_Object * syslog_level , Scheme_Object * stderr_level ) 
{
  /* No conversion */

# 191 "bc/src/error.c"
  scheme_set_logging2_spec (syslog_level , stderr_level , ((void * ) 0 ) ) ; 
}

void scheme_init_logging_once (void ) 
{

  int j ; 
  Scheme_Object * l , * s ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(l, 1)));
# define XfOrM12_COUNT (2)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 200 "bc/src/error.c"
  for (j = 0 ; j < 3 ; j ++ ) {
#   define XfOrM18_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM18(x) SETUP_XfOrM12(x)

# 201 "bc/src/error.c"
    switch (j ) {
      case 0 : l = init_syslog_level ; 

# 202 "bc/src/error.c"
      break ; 
      case 1 : l = init_stderr_level ; 

# 203 "bc/src/error.c"
      break ; 
      default : l = init_stdout_level ; 

# 204 "bc/src/error.c"
      break ; 
    }
    if (l ) {
#     define XfOrM19_COUNT (0+XfOrM18_COUNT)
#     define SETUP_XfOrM19(x) SETUP_XfOrM18(x)

# 207 "bc/src/error.c"
      while (! (((intptr_t ) (l ) ) & 0x1 ) ) {
#       define XfOrM21_COUNT (0+XfOrM19_COUNT)
#       define SETUP_XfOrM21(x) SETUP_XfOrM19(x)

# 208 "bc/src/error.c"
        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        s = FUNCCALL(SETUP_XfOrM21(_), scheme_intern_exact_symbol ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> u . byte_str_val . tag_val ) ) )
        ; 
        (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) = s ; 
        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 218 "bc/src/error.c"
typedef struct {
  int args ; 
  Scheme_Object * type ; 
  Scheme_Object * * names ; 
  int count ; 
  Scheme_Object * exptime ; 
  int super_pos ; 
}

# 225 "bc/src/error.c"
exn_rec ; 

# 63 "bc/src/schexn.h"
static exn_rec * exn_table ; 

# 231 "bc/src/error.c"
static void default_printf (char * msg , ... ) 
{
  /* No conversion */

# 233 "bc/src/error.c"
  GC_CAN_IGNORE va_list args ; 
  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  vfprintf (stderr , msg , args ) ; 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  fflush (stderr ) ; 
}

static void default_output (char * s , intptr_t len ) 
{
  /* No conversion */

# 242 "bc/src/error.c"
  fwrite (s , len , 1 , stderr ) ; 
  fflush (stderr ) ; 
}

intptr_t scheme_errno () {
  /* No conversion */


  return (* __errno_location () ) ; 
}


Scheme_Config * scheme_init_error_escape_proc (Scheme_Config * config ) 
{
  DECL_RET_SAVE (Scheme_Config * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(config, 0)));
# define XfOrM26_COUNT (1)
# define SETUP_XfOrM26(x) SETUP(XfOrM26_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 256 "bc/src/error.c"
  if (! def_error_esc_proc ) {
#   define XfOrM28_COUNT (0+XfOrM26_COUNT)
#   define SETUP_XfOrM28(x) SETUP_XfOrM26(x)
    FUNCCALL(SETUP_XfOrM28(_), scheme_register_static ((void * ) & def_error_esc_proc , sizeof (def_error_esc_proc ) ) )
# 257 "bc/src/error.c"
    ; 
    def_error_esc_proc = FUNCCALL(SETUP_XfOrM28(_), scheme_make_prim_w_arity ((Scheme_Prim * ) def_error_escape_proc , "default-error-escape-handler" , 0 , 0 ) )


    ; 
  }

  if (config )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_extend_config (config , MZCONFIG_ERROR_ESCAPE_HANDLER , def_error_esc_proc ) )) RET_VALUE_EMPTY_END ; 
  else {
#   define XfOrM27_COUNT (0+XfOrM26_COUNT)
#   define SETUP_XfOrM27(x) SETUP_XfOrM26(x)
    FUNCCALL_EMPTY(scheme_set_root_param (MZCONFIG_ERROR_ESCAPE_HANDLER , def_error_esc_proc ) )
# 267 "bc/src/error.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 318 "bc/src/error.c"
static intptr_t sch_vsprintf (char * s , intptr_t maxlen , const char * msg , va_list args , char * * _s , 
Scheme_Object * * _errno_val , int * _unsupported ) 


{
  intptr_t i , j ; 
  char buf [100 ] ; 





  int pp = 0 , ip = 0 , dp = 0 ; 
  void * ptrs [25 ] ; 
  intptr_t ints [25 ] ; 
  double dbls [25 ] ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(_errno_val, 1), PUSHARRAY(ptrs, 25, 2), PUSH(msg, 5), PUSH(_s, 6), PUSH(_unsupported, 7)));
# define XfOrM29_COUNT (8)
# define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  NULL_OUT_ARRAY (ptrs ) ; 

# 335 "bc/src/error.c"
  for (j = 0 ; msg [j ] ; j ++ ) {
    if (msg [j ] == '%' ) {
      int type ; 

      j ++ ; 
      type = msg [j ] ; 

      switch (type ) {
        case 'c' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        break ; 
        case 'd' : 
        case 'o' : 
        case '-' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        break ; 
        case 'g' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , long ) ) ; 
        break ; 
        case 'l' : 
        case 'I' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , intptr_t ) ) ; 
        break ; 
        case 'f' : 
        dbls [dp ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , double ) ) ; 
        break ; 
        case 'L' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , intptr_t ) ) ; 
        break ; 
        case 'e' : 
        case 'E' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        break ; 
        case 'N' : 
        case 'm' : 
        case 'M' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        break ; 
        case 'Z' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        ptrs [pp ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , char * ) ) ; 
        break ; 
        case 'S' : 
        case 'V' : 
        case '@' : 
        case 'D' : 
        case 'W' : 
        case 'T' : 
        case 'Q' : 
        case '_' : 
        ptrs [pp ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , Scheme_Object * ) ) ; 
        break ; 
        default : 
        ptrs [pp ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , char * ) ) ; 
        if ((type == 't' ) || (type == 'u' ) ) {
          ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , intptr_t ) ) ; 
        }
      }
    }
  }
  pp = 0 ; 
  ip = 0 ; 
  dp = 0 ; 

  if (! s ) {
#   define XfOrM134_COUNT (0+XfOrM29_COUNT)
#   define SETUP_XfOrM134(x) SETUP_XfOrM29(x)

# 401 "bc/src/error.c"
    s = FUNCCALL(SETUP_XfOrM134(_), init_buf (((void * ) 0 ) , & maxlen ) ); 
    * _s = s ; 
  }

  -- maxlen ; 

  i = j = 0 ; 
  while ((i < maxlen ) && msg [j ] ) {
#   define XfOrM82_COUNT (0+XfOrM29_COUNT)
#   define SETUP_XfOrM82(x) SETUP_XfOrM29(x)

# 409 "bc/src/error.c"
    if (msg [j ] == '%' ) {
      int type ; 

      j ++ ; 
#     define XfOrM84_COUNT (0+XfOrM82_COUNT)
#     define SETUP_XfOrM84(x) SETUP_XfOrM82(x)

# 413 "bc/src/error.c"
      type = msg [j ++ ] ; 

      if (type == '%' )
        s [i ++ ] = '%' ; 
      else {
        const char * t ; 
        intptr_t tlen ; 
        int dots = 0 ; 
        BLOCK_SETUP((PUSH(t, 0+XfOrM84_COUNT)));
#       define XfOrM85_COUNT (1+XfOrM84_COUNT)
#       define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
        t = NULLED_OUT ; 

# 422 "bc/src/error.c"
        switch (type ) {
#         define XfOrM92_COUNT (0+XfOrM85_COUNT)
#         define SETUP_XfOrM92(x) SETUP_XfOrM85(x)

# 423 "bc/src/error.c"
          case 'c' : 
          {
            int c ; 
#           define XfOrM131_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM131(x) SETUP_XfOrM92(x)

# 426 "bc/src/error.c"
            c = ints [ip ++ ] ; 
            if (c < 128 ) {
              buf [0 ] = c ; 
              tlen = 1 ; 
            }

# 430 "bc/src/error.c"
            else {
              mzchar mc ; 
#             define XfOrM132_COUNT (0+XfOrM131_COUNT)
#             define SETUP_XfOrM132(x) SETUP_XfOrM131(x)

# 432 "bc/src/error.c"
              mc = c ; 
              tlen = FUNCCALL(SETUP_XfOrM132(_), scheme_utf8_encode_all (& mc , 1 , (unsigned char * ) buf ) ); 
            }
            t = buf ; 
          }
          break ; 
          case 'd' : 
          {
            int d ; 
#           define XfOrM130_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM130(x) SETUP_XfOrM92(x)

# 441 "bc/src/error.c"
            d = ints [ip ++ ] ; 
            (sprintf (buf , "%d" , d ) ) ; 
            t = buf ; 
            tlen = strlen (t ) ; 
          }
          break ; 
          case '-' : 
          {
            ip ++ ; 
            t = "" ; 
            tlen = 0 ; 
          }
          break ; 
          case 'o' : 
          {
            int d ; 
#           define XfOrM128_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM128(x) SETUP_XfOrM92(x)

# 457 "bc/src/error.c"
            d = ints [ip ++ ] ; 
            (sprintf (buf , "%o" , d ) ) ; 
            t = buf ; 
            tlen = strlen (t ) ; 
          }
          break ; 
          case 'I' : 
          case 'l' : 
          case 'g' : 
          {
            intptr_t d ; 
            int as_hex ; 
#           define XfOrM127_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM127(x) SETUP_XfOrM92(x)

# 469 "bc/src/error.c"
            if ((type == 'I' ) && (msg [j ] == '6' ) && (msg [j + 1 ] == '4' ) )
              j ++ ; 
            as_hex = (msg [j ] == 'x' ) ; 
            j ++ ; 
            d = ints [ip ++ ] ; 
            if (as_hex )
              (sprintf (buf , "%" "l" "x" , d ) ) ; 
            else (
            sprintf (buf , "%" "l" "d" , d ) ) ; 
            t = buf ; 
            tlen = strlen (t ) ; 
          }
          break ; 
          case 'f' : 
          {
            double f ; 
#           define XfOrM126_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM126(x) SETUP_XfOrM92(x)

# 485 "bc/src/error.c"
            f = dbls [dp ++ ] ; 
            (sprintf (buf , "%f" , f ) ) ; 
            t = buf ; 
            tlen = strlen (t ) ; 
          }
          break ; 
          case 'L' : 
          {
            intptr_t d ; 
#           define XfOrM123_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM123(x) SETUP_XfOrM92(x)

# 494 "bc/src/error.c"
            d = ints [ip ++ ] ; 
            if (d >= 0 ) {
#             define XfOrM125_COUNT (0+XfOrM123_COUNT)
#             define SETUP_XfOrM125(x) SETUP_XfOrM123(x)
              (
# 496 "bc/src/error.c"
              sprintf (buf , "%" "l" "d" ":" , d ) ) ; 
              t = buf ; 
              tlen = strlen (t ) ; 
            }

# 499 "bc/src/error.c"
            else {
              t = ":" ; 
              tlen = 1 ; 
            }
          }
          break ; 
          case 'R' : 
          {
            intptr_t errid ; 
            intptr_t errkind ; 
            const char * es , * errkind_str ; 
            intptr_t elen ; 
            BLOCK_SETUP((PUSH(es, 0+XfOrM92_COUNT)));
#           define XfOrM118_COUNT (1+XfOrM92_COUNT)
#           define SETUP_XfOrM118(x) SETUP(XfOrM118_COUNT)
            es = NULLED_OUT ; 
            errkind_str = NULLED_OUT ; 

# 511 "bc/src/error.c"
            errkind = (rktio_get_last_error_kind (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
            errid = (rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
            switch (errkind ) {
              case RKTIO_ERROR_KIND_WINDOWS : 
              errkind_str = "errid" ; 
              break ; 
              case RKTIO_ERROR_KIND_POSIX : 
              errkind_str = "errno" ; 
              break ; 
              case RKTIO_ERROR_KIND_GAI : 
              errkind_str = "gai_err" ; 
              break ; 
              default : 
              errkind_str = "rktio_err" ; 
              break ; 
            }
            es = (rktio_get_error_string (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , errkind , errid ) ) ; 
            (sprintf (buf , "; %s=%" "l" "d" "" , errkind_str , errid ) ) ; 
            if (es )

# 529 "bc/src/error.c"
            elen = strlen (es ) ; 

# 529 "bc/src/error.c"
            else elen = 0 ; 
            tlen = strlen (buf ) ; 
            t = (const char * ) FUNCCALL(SETUP_XfOrM118(_), GC_malloc_atomic (tlen + elen + 1 ) ); 
            (memcpy ((char * ) t , es , elen ) ) ; 
            (memcpy ((char * ) t + elen , buf , tlen + 1 ) ) ; 
            tlen += elen ; 
            if (_errno_val ) {
              Scheme_Object * err_kind ; 
              BLOCK_SETUP((PUSH(err_kind, 0+XfOrM118_COUNT)));
#             define XfOrM119_COUNT (1+XfOrM118_COUNT)
#             define SETUP_XfOrM119(x) SETUP(XfOrM119_COUNT)
              err_kind = NULLED_OUT ; 

# 537 "bc/src/error.c"
              switch (errkind ) {
                case RKTIO_ERROR_KIND_WINDOWS : 
                err_kind = windows_symbol ; 
                break ; 
                case RKTIO_ERROR_KIND_POSIX : 
                err_kind = posix_symbol ; 
                break ; 
                case RKTIO_ERROR_KIND_GAI : 
                err_kind = gai_symbol ; 
                break ; 
                default : 
                err_kind = ((void * ) 0 ) ; 
              }
              if (err_kind ) {
#               define XfOrM120_COUNT (0+XfOrM119_COUNT)
#               define SETUP_XfOrM120(x) SETUP_XfOrM119(x)

# 551 "bc/src/error.c"
                err_kind = (__funcarg62 = FUNCCALL(SETUP_XfOrM120(_), scheme_make_integer_value (errid ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg62 , err_kind ) )) ; 
                * _errno_val = err_kind ; 
              }
            }
            if (_unsupported 
            && (errid == RKTIO_ERROR_UNSUPPORTED ) 
            && (errkind == RKTIO_ERROR_KIND_RACKET ) )
              * _unsupported = 1 ; 
          }
          break ; 
          case 'e' : 
          case 'm' : 
          case 'E' : 
          case 'M' : 
          case 'Z' : 
          case 'N' : 
          {
            int en , he , none = 0 ; 
            char * es ; 
            const char * errkind_str = ((void * ) 0 ) ; 
            Scheme_Object * err_kind = ((void * ) 0 ) ; 
            BLOCK_SETUP((PUSH(es, 0+XfOrM92_COUNT), PUSH(err_kind, 1+XfOrM92_COUNT), PUSH(errkind_str, 2+XfOrM92_COUNT)));
#           define XfOrM106_COUNT (3+XfOrM92_COUNT)
#           define SETUP_XfOrM106(x) SETUP(XfOrM106_COUNT)
            es = NULLED_OUT ; 

# 573 "bc/src/error.c"
            if (type == 'm' ) {
              none = ! ints [ip ++ ] ; 
              type = 'e' ; 
              he = 0 ; 
            }

# 577 "bc/src/error.c"
            else if (type == 'M' ) {
              none = ! ints [ip ++ ] ; 
              type = 'E' ; 
              he = 0 ; 
            }

# 581 "bc/src/error.c"
            else if (type == 'N' ) {
              he = ints [ip ++ ] ; 
              type = 'E' ; 
            }

# 584 "bc/src/error.c"
            else 
            he = 0 ; 

            en = ints [ip ++ ] ; 

            if (type == 'Z' )
              es = ptrs [pp ++ ] ; 
            else 
            es = ((void * ) 0 ) ; 

            if (he ) {
#             define XfOrM114_COUNT (0+XfOrM106_COUNT)
#             define SETUP_XfOrM114(x) SETUP_XfOrM106(x)

# 595 "bc/src/error.c"
              es = (char * ) FUNCCALL(SETUP_XfOrM114(_), scheme_hostname_error (en ) ); 
              err_kind = gai_symbol ; 
              errkind_str = "gai_err" ; 
            }

            if ((en || es ) && ! none ) {
#             define XfOrM110_COUNT (0+XfOrM106_COUNT)
#             define SETUP_XfOrM110(x) SETUP_XfOrM106(x)

# 632 "bc/src/error.c"
              if (! es ) {
#               define XfOrM113_COUNT (0+XfOrM110_COUNT)
#               define SETUP_XfOrM113(x) SETUP_XfOrM110(x)

# 633 "bc/src/error.c"
                es = FUNCCALL(SETUP_XfOrM113(_), strerror (en ) ); 
                err_kind = posix_symbol ; 
                errkind_str = "errno" ; 
              }

              tlen = strlen (es ) + 24 ; 
              t = (const char * ) FUNCCALL(SETUP_XfOrM110(_), GC_malloc_atomic (tlen ) ); 

              ((void ) sizeof ((errkind_str ) ? 1 : 0 ) , __extension__ ({
#               define XfOrM112_COUNT (0+XfOrM110_COUNT)
#               define SETUP_XfOrM112(x) SETUP_XfOrM110(x)

# 641 "bc/src/error.c" 3
                if (errkind_str )

# 641 "bc/src/error.c" 3
                ; 

# 641 "bc/src/error.c" 3
                else FUNCCALL(SETUP_XfOrM112(_), __assert_fail ("errkind_str" , "bc/src/error.c" , 641 , __extension__ __PRETTY_FUNCTION__ ) ); 
              }
              ) ) 
# 641 "bc/src/error.c"
              ; 
              (sprintf ((char * ) t , "%s; %s=%d" , es , errkind_str , en ) ) ; 
              tlen = strlen (t ) ; 
              if (_errno_val ) {
#               define XfOrM111_COUNT (0+XfOrM110_COUNT)
#               define SETUP_XfOrM111(x) SETUP_XfOrM110(x)

# 645 "bc/src/error.c"
                err_kind = (__funcarg61 = FUNCCALL(SETUP_XfOrM111(_), scheme_make_integer_value (en ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg61 , err_kind ) )) ; 
                * _errno_val = err_kind ; 
              }
            }

# 648 "bc/src/error.c"
            else {
              if (none ) {
                t = "" ; 
                tlen = 0 ; 
              }

# 652 "bc/src/error.c"
              else {
                t = "errno=?" ; 
                tlen = 7 ; 
              }
            }
          }

          break ; 
          case 'S' : 
          {
            Scheme_Object * sym ; 
#           define XfOrM105_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM105(x) SETUP_XfOrM92(x)
            sym = NULLED_OUT ; 

# 663 "bc/src/error.c"
            sym = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM105(_), scheme_symbol_name_and_size (sym , (uintptr_t * ) & tlen , 0 ) ); 
          }
          break ; 
          case 'V' : 
          {
            Scheme_Object * o ; 
#           define XfOrM104_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM104(x) SETUP_XfOrM92(x)
            o = NULLED_OUT ; 

# 670 "bc/src/error.c"
            o = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM104(_), scheme_make_provided_string (o , 1 , & tlen ) ); 
          }
          break ; 
          case '@' : 
          {
            Scheme_Object * o ; 
#           define XfOrM103_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM103(x) SETUP_XfOrM92(x)
            o = NULLED_OUT ; 

# 677 "bc/src/error.c"
            o = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM103(_), make_provided_list (o , 1 , & tlen ) ); 
          }
          break ; 
          case 'D' : 
          {
            Scheme_Object * o ; 
            intptr_t dlen ; 
#           define XfOrM102_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM102(x) SETUP_XfOrM92(x)
            o = NULLED_OUT ; 

# 685 "bc/src/error.c"
            o = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM102(_), scheme_display_to_string (o , & dlen ) ); 
            tlen = dlen ; 
          }
          break ; 
          case 'W' : 
          {
            Scheme_Object * o ; 
            intptr_t dlen ; 
#           define XfOrM101_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM101(x) SETUP_XfOrM92(x)
            o = NULLED_OUT ; 

# 694 "bc/src/error.c"
            o = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM101(_), scheme_write_to_string (o , & dlen ) ); 
            tlen = dlen ; 
          }
          break ; 
          case '_' : 
          {
            pp ++ ; 
            t = "" ; 
            tlen = 0 ; 
          }
          break ; 
          case 'T' : 
          case 'Q' : 
          {
            Scheme_Object * str ; 
            BLOCK_SETUP((PUSH(str, 0+XfOrM92_COUNT)));
#           define XfOrM99_COUNT (1+XfOrM92_COUNT)
#           define SETUP_XfOrM99(x) SETUP(XfOrM99_COUNT)
            str = NULLED_OUT ; 

# 710 "bc/src/error.c"
            str = (Scheme_Object * ) ptrs [pp ++ ] ; 
            if ((Scheme_Type ) (((((intptr_t ) (str ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (str ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
              str = FUNCCALL(SETUP_XfOrM99(_), scheme_char_string_to_byte_string (str ) ); 
            t = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) ; 
            tlen = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) ; 
          }
          break ; 
          case 'u' : 
          case '5' : 
          {
            mzchar * u ; 
            intptr_t ltlen ; 
            BLOCK_SETUP((PUSH(u, 0+XfOrM92_COUNT)));
#           define XfOrM96_COUNT (1+XfOrM92_COUNT)
#           define SETUP_XfOrM96(x) SETUP(XfOrM96_COUNT)
            u = NULLED_OUT ; 

# 722 "bc/src/error.c"
            u = (mzchar * ) ptrs [pp ++ ] ; 
            if (type == 'u' ) {
#             define XfOrM98_COUNT (0+XfOrM96_COUNT)
#             define SETUP_XfOrM98(x) SETUP_XfOrM96(x)

# 724 "bc/src/error.c"
              tlen = ints [ip ++ ] ; 
              if (tlen < 0 )
                tlen = FUNCCALL(SETUP_XfOrM98(_), scheme_char_strlen (u ) ); 
            }

# 727 "bc/src/error.c"
            else {
#             define XfOrM97_COUNT (0+XfOrM96_COUNT)
#             define SETUP_XfOrM97(x) SETUP_XfOrM96(x)

# 728 "bc/src/error.c"
              tlen = FUNCCALL(SETUP_XfOrM97(_), scheme_char_strlen (u ) ); 
            }
            t = FUNCCALL(SETUP_XfOrM96(_), scheme_utf8_encode_to_buffer_len (u , tlen , ((void * ) 0 ) , 0 , & ltlen ) ); 
            tlen = ltlen ; 
          }
          break ; 
          default : 
          {
            t = (char * ) ptrs [pp ++ ] ; 
            if (type == 't' ) {
              tlen = ints [ip ++ ] ; 
              if (tlen < 0 )
                tlen = strlen (t ) ; 
            }

# 741 "bc/src/error.c"
            else {
              tlen = strlen (t ) ; 
            }
          }
          break ; 
        }

        if ((type == 'q' ) || (type == 'Q' ) ) {
          if (tlen > 256 ) {
            tlen = 250 ; 
            dots = 1 ; 
          }
        }


        while (tlen && i < maxlen ) {
          s [i ++ ] = * t ; 
          t = t XFORM_OK_PLUS 1 ; 
          tlen -- ; 
        }

        if (dots ) {

          if (i < maxlen - 3 ) {
            s [i ++ ] = '.' ; 
            s [i ++ ] = '.' ; 
            s [i ++ ] = '.' ; 
          }
        }
      }
    }

# 771 "bc/src/error.c"
    else {
      s [i ++ ] = msg [j ++ ] ; 
    }
  }

  s [i ] = 0 ; 

  RET_VALUE_START (i ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 781 "bc/src/error.c"
intptr_t scheme_sprintf (char * s , intptr_t maxlen , const char * msg , ... ) 
{
  /* No conversion */

# 783 "bc/src/error.c"
  intptr_t len ; 
  GC_CAN_IGNORE va_list args ; 

  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = sch_vsprintf (s , maxlen , msg , args , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  return len ; 
}

int scheme_last_error_is_racket (int errid ) 
{
  /* No conversion */

# 795 "bc/src/error.c"
  return ((rktio_get_last_error_kind (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) == RKTIO_ERROR_KIND_RACKET ) 
  && (rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) == errid ) ) ; 
}






void scheme_init_unsafe_error (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM145_COUNT (2)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 807 "bc/src/error.c"
  p = FUNCCALL(SETUP_XfOrM145(_), scheme_make_noncm_prim (assert_unreachable , "unsafe-assert-unreachable" , 0 , 0 ) ); 

# 807 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("unsafe-assert-unreachable" , p , env ) )
# 807 "bc/src/error.c"
  ; 

# 807 "bc/src/error.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 810 "bc/src/error.c"
void scheme_init_error (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM146_COUNT (2)
# define SETUP_XfOrM146(x) SETUP(XfOrM146_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 

# 814 "bc/src/error.c"
  if (! scheme_console_printf )
    scheme_console_printf = default_printf ; 
  if (! scheme_console_output )
    scheme_console_output = default_output ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_register_static ((void * ) & scheme_raise_arity_error_proc , sizeof (scheme_raise_arity_error_proc ) ) )
  ; 


  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (error , "error" , 1 , - 1 ) ); 

# 822 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("error" , p , env ) )
# 822 "bc/src/error.c"
  ; 

# 822 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_user_error , "raise-user-error" , 1 , - 1 ) ); 

# 823 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-user-error" , p , env ) )
# 823 "bc/src/error.c"
  ; 

# 823 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_type_error , "raise-type-error" , 3 , - 1 ) ); 

# 824 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-type-error" , p , env ) )
# 824 "bc/src/error.c"
  ; 

# 824 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_argument_error , "raise-argument-error" , 3 , - 1 ) ); 

# 825 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-argument-error" , p , env ) )
# 825 "bc/src/error.c"
  ; 

# 825 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_argument_error_star , "raise-argument-error*" , 4 , - 1 ) ); 

# 826 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-argument-error*" , p , env ) )
# 826 "bc/src/error.c"
  ; 

# 826 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_result_error , "raise-result-error" , 3 , - 1 ) ); 

# 827 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-result-error" , p , env ) )
# 827 "bc/src/error.c"
  ; 

# 827 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_result_error_star , "raise-result-error*" , 4 , - 1 ) ); 

# 828 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-result-error*" , p , env ) )
# 828 "bc/src/error.c"
  ; 

# 828 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arguments_error , "raise-arguments-error" , 2 , - 1 ) ); 

# 829 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-arguments-error" , p , env ) )
# 829 "bc/src/error.c"
  ; 

# 829 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arguments_error_star , "raise-arguments-error*" , 3 , - 1 ) ); 

# 830 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-arguments-error*" , p , env ) )
# 830 "bc/src/error.c"
  ; 

# 830 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_mismatch_error , "raise-mismatch-error" , 3 , - 1 ) ); 

# 831 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-mismatch-error" , p , env ) )
# 831 "bc/src/error.c"
  ; 

# 831 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_range_error , "raise-range-error" , 7 , 8 ) ); 

# 832 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-range-error" , p , env ) )
# 832 "bc/src/error.c"
  ; 

# 832 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_range_error_star , "raise-range-error*" , 8 , 9 ) ); 

# 833 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-range-error*" , p , env ) )
# 833 "bc/src/error.c"
  ; 

# 833 "bc/src/error.c"
  ; 

  scheme_raise_arity_error_proc = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arity_error , "raise-arity-error" , 2 , - 1 ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("raise-arity-error" , scheme_raise_arity_error_proc , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arity_error_star , "raise-arity-error*" , 3 , - 1 ) ); 

# 837 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-arity-error*" , p , env ) )
# 837 "bc/src/error.c"
  ; 

# 837 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arity_mask_error , "raise-arity-mask-error" , 2 , - 1 ) ); 

# 838 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-arity-mask-error" , p , env ) )
# 838 "bc/src/error.c"
  ; 

# 838 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arity_mask_error_star , "raise-arity-mask-error*" , 3 , - 1 ) ); 

# 839 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-arity-mask-error*" , p , env ) )
# 839 "bc/src/error.c"
  ; 

# 839 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_result_arity_error , "raise-result-arity-error" , 3 , - 1 ) ); 

# 840 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-result-arity-error" , p , env ) )
# 840 "bc/src/error.c"
  ; 

# 840 "bc/src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_result_arity_error_star , "raise-result-arity-error*" , 4 , - 1 ) ); 

# 841 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-result-arity-error*" , p , env ) )
# 841 "bc/src/error.c"
  ; 

# 841 "bc/src/error.c"
  ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_display_handler , "error-display-handler" , MZCONFIG_ERROR_DISPLAY_HANDLER ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-display-handler" , __funcarg91 , env ) )) ; 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_value_string_handler , "error-value->string-handler" , MZCONFIG_ERROR_PRINT_VALUE_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-value->string-handler" , __funcarg90 , env ) )) ; 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_syntax_string_handler , "error-syntax->string-handler" , MZCONFIG_ERROR_PRINT_SYNTAX_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-syntax->string-handler" , __funcarg89 , env ) )) ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (current_error_message_adjuster , "current-error-message-adjuster" , MZCONFIG_ERROR_MESSAGE_ADJUSTER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-error-message-adjuster" , __funcarg88 , env ) )) ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_escape_handler , "error-escape-handler" , MZCONFIG_ERROR_ESCAPE_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-escape-handler" , __funcarg87 , env ) )) ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (exit_handler , "exit-handler" , MZCONFIG_EXIT_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("exit-handler" , __funcarg86 , env ) )) ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (exe_yield_handler , "executable-yield-handler" , MZCONFIG_EXE_YIELD_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("executable-yield-handler" , __funcarg85 , env ) )) ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_print_width , "error-print-width" , MZCONFIG_ERROR_PRINT_WIDTH ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-print-width" , __funcarg84 , env ) )) ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_print_context_length , "error-print-context-length" , MZCONFIG_ERROR_PRINT_CONTEXT_LENGTH ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-print-context-length" , __funcarg83 , env ) )) ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_print_srcloc , "error-print-source-location" , MZCONFIG_ERROR_PRINT_SRCLOC ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-print-source-location" , __funcarg82 , env ) )) ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_prim_w_arity (error_message_to_adjusted_string , "error-message->adjusted-string" , 4 , 4 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-message->adjusted-string" , __funcarg81 , env ) )) ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_prim_w_arity (error_contract_to_adjusted_string , "error-contract->adjusted-string" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-contract->adjusted-string" , __funcarg80 , env ) )) ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (scheme_do_exit , "exit" , 0 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("exit" , __funcarg79 , env ) )) ; 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (assert_unreachable , "assert-unreachable" , 0 , 0 ) ); 

# 859 "bc/src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 16 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("assert-unreachable" , p , env ) )
# 859 "bc/src/error.c"
  ; 

# 859 "bc/src/error.c"
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (log_level_p , "log-level?" , 2 , 3 ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-level?" , __funcarg78 , env ) )) ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (log_max_level , "log-max-level" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-max-level" , __funcarg77 , env ) )) ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (log_all_levels , "log-all-levels" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-all-levels" , __funcarg76 , env ) )) ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (log_level_evt , "log-level-evt" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-level-evt" , __funcarg75 , env ) )) ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (make_logger , "make-logger" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-logger" , __funcarg74 , env ) )) ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (make_log_reader , "make-log-receiver" , 2 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-log-receiver" , __funcarg73 , env ) )) ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_prim_w_arity (log_message , "log-message" , 3 , 6 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-message" , __funcarg72 , env ) )) ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_folding_prim (logger_p , "logger?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("logger?" , __funcarg71 , env ) )) ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_folding_prim (logger_name , "logger-name" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("logger-name" , __funcarg70 , env ) )) ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_folding_prim (log_reader_p , "log-receiver?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-receiver?" , __funcarg69 , env ) )) ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (current_logger , "current-logger" , MZCONFIG_LOGGER ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-logger" , __funcarg68 , env ) )) ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (srcloc_to_string , "srcloc->string" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("srcloc->string" , __funcarg67 , env ) )) ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (unquoted_printing_string , "unquoted-printing-string" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unquoted-printing-string" , __funcarg66 , env ) )) ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_folding_prim (unquoted_printing_string_p , "unquoted-printing-string?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unquoted-printing-string?" , __funcarg65 , env ) )) ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_immed_prim (unquoted_printing_string_value , "unquoted-printing-string-value" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unquoted-printing-string-value" , __funcarg64 , env ) )) ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_def_exit_proc , sizeof (scheme_def_exit_proc ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & default_display_handler , sizeof (default_display_handler ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & emergency_display_handler , sizeof (emergency_display_handler ) ) ); 

  scheme_def_exit_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_exit_handler_proc , "default-exit-handler" , 1 , 1 ) ); 
  default_display_handler = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_error_display_proc , "default-error-display-handler" , 2 , 2 ) ); 
  emergency_display_handler = FUNCCALL_AGAIN(scheme_make_prim_w_arity (emergency_error_display_proc , "emergency-error-display-handler" , 2 , 2 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & def_err_val_proc , sizeof (def_err_val_proc ) ) )
  ; 
  def_err_val_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_error_value_string_proc , "default-error-value->string-handler" , 2 , 2 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & def_err_stx_proc , sizeof (def_err_stx_proc ) ) )
  ; 
  def_err_stx_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_error_syntax_string_proc , "default-error-syntax->string-handler" , 2 , 2 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & def_err_msg_adjust_proc , sizeof (def_err_msg_adjust_proc ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & def_err_msg_adjust_name_proc , sizeof (def_err_msg_adjust_name_proc ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & def_err_msg_adjust_message_proc , sizeof (def_err_msg_adjust_message_proc ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & def_err_msg_adjust_contract_proc , sizeof (def_err_msg_adjust_contract_proc ) ) ); 
  def_err_msg_adjust_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_error_message_adjust_proc , "default-error-message-adjuster" , 1 , 1 ) )
  ; 
  def_err_msg_adjust_name_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (def_error_message_adjust_name_proc , 1 , "default-error-message-adjuster/name-mode" , 2 , 2 , 0 , 2 , 2 ) )
  ; 
  def_err_msg_adjust_message_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (def_error_message_adjust_message_proc , 1 , "default-error-message-adjuster/message-mode" , 4 , 4 , 0 , 4 , 4 ) )
  ; 
  def_err_msg_adjust_contract_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (def_error_message_adjust_contract_proc , 1 , "default-error-message-adjuster/contract-mode" , 2 , 2 , 0 , 2 , 2 ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & none_symbol , sizeof (none_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & fatal_symbol , sizeof (fatal_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & error_symbol , sizeof (error_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & warning_symbol , sizeof (warning_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & info_symbol , sizeof (info_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & debug_symbol , sizeof (debug_symbol ) ) ); 
  none_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("none" ) ); 
  fatal_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("fatal" ) ); 
  error_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("error" ) ); 
  warning_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("warning" ) ); 
  info_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("info" ) ); 
  debug_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("debug" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & posix_symbol , sizeof (posix_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & windows_symbol , sizeof (windows_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & gai_symbol , sizeof (gai_symbol ) ) ); 
  posix_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("posix" ) ); 
  windows_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("windows" ) ); 
  gai_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("gai" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & name_symbol , sizeof (name_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & message_symbol , sizeof (message_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & contract_symbol , sizeof (contract_symbol ) ) ); 
  name_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("name" ) ); 
  message_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("message" ) ); 
  contract_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("contract" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & arity_property , sizeof (arity_property ) ) )
  ; 
  {
    Scheme_Object * guard ; 
    BLOCK_SETUP((PUSH(guard, 0+XfOrM146_COUNT)));
#   define XfOrM147_COUNT (1+XfOrM146_COUNT)
#   define SETUP_XfOrM147(x) SETUP(XfOrM147_COUNT)
    guard = NULLED_OUT ; 

# 939 "bc/src/error.c"
    guard = FUNCCALL(SETUP_XfOrM147(_), scheme_make_prim_w_arity (check_arity_property_value_ok , "guard-for-prop:arity-string" , 2 , 2 ) ); 
    arity_property = (__funcarg63 = FUNCCALL(SETUP_XfOrM147(_), scheme_intern_symbol ("arity-string" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg63 , guard ) )) ; 
  }
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("prop:arity-string" , arity_property , env ) )
  ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_register_static ((void * ) & def_exe_yield_proc , sizeof (def_exe_yield_proc ) ) )
  ; 
  def_exe_yield_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (default_yield_handler , "default-executable-yield-handler" , 1 , 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_error_message_adjuster_key , sizeof (scheme_error_message_adjuster_key ) ) )
  ; 
  scheme_error_message_adjuster_key = FUNCCALL_AGAIN(scheme_make_symbol ("err-adjust" ) ); 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("error-message-adjuster-key" , scheme_error_message_adjuster_key , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 955 "bc/src/error.c"
void scheme_init_realm () 
{
  /* No conversion */

# 957 "bc/src/error.c"
  scheme_register_static ((void * ) & scheme_default_realm , sizeof (scheme_default_realm ) ) ; 
  scheme_register_static ((void * ) & scheme_primitive_realm , sizeof (scheme_primitive_realm ) ) ; 
  scheme_register_static ((void * ) & local_realm_symbol , sizeof (local_realm_symbol ) ) ; 
  scheme_default_realm = scheme_intern_symbol ("racket" ) ; 
  scheme_primitive_realm = scheme_intern_symbol ("racket/primitive" ) ; 
  local_realm_symbol = scheme_intern_symbol ("local" ) ; 
}

void scheme_init_logger_wait () 
{
  /* No conversion */

# 967 "bc/src/error.c"
  scheme_add_evt (scheme_log_reader_type , (Scheme_Ready_Fun ) log_reader_get , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

void scheme_init_logger () 
{
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(0);
# define XfOrM150_COUNT (0)
# define SETUP_XfOrM150(x) SETUP(XfOrM150_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) ) ) )
# 972 "bc/src/error.c"
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) = FUNCCALL_EMPTY(scheme_make_logger (((void * ) 0 ) , ((void * ) 0 ) ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) -> syslog_level = init_syslog_level ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) -> stderr_level = init_stderr_level ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) -> stdout_level = init_stdout_level ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_gc_logger_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_gc_logger_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_gc_logger_ ) = (__funcarg94 = FUNCCALL_EMPTY(scheme_intern_symbol ("GC" ) ), FUNCCALL_EMPTY(scheme_make_logger (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , __funcarg94 ) )) ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_future_logger_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_future_logger_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_future_logger_ ) = (__funcarg93 = FUNCCALL_EMPTY(scheme_intern_symbol ("future" ) ), FUNCCALL_EMPTY(scheme_make_logger (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , __funcarg93 ) )) ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_logger_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_logger_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_logger_ ) = (__funcarg92 = FUNCCALL_EMPTY(scheme_intern_symbol ("place" ) ), FUNCCALL_EMPTY(scheme_make_logger (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , __funcarg92 ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 988 "bc/src/error.c"
Scheme_Logger * scheme_get_main_logger () {
  /* No conversion */

# 989 "bc/src/error.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) ; 
}

Scheme_Logger * scheme_get_gc_logger () {
  /* No conversion */

# 993 "bc/src/error.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_gc_logger_ ) ; 
}

Scheme_Logger * scheme_get_future_logger () {
  /* No conversion */

# 997 "bc/src/error.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_future_logger_ ) ; 
}

Scheme_Logger * scheme_get_place_logger () {
  /* No conversion */

# 1001 "bc/src/error.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_logger_ ) ; 
}

void scheme_init_error_config (void ) 
{
  /* No conversion */

# 1006 "bc/src/error.c"
  scheme_set_root_param (MZCONFIG_EXIT_HANDLER , scheme_def_exit_proc ) ; 
  scheme_set_root_param (MZCONFIG_ERROR_DISPLAY_HANDLER , default_display_handler ) ; 
  scheme_set_root_param (MZCONFIG_ERROR_PRINT_VALUE_HANDLER , def_err_val_proc ) ; 
  scheme_set_root_param (MZCONFIG_ERROR_PRINT_SYNTAX_HANDLER , def_err_val_proc ) ; 
  scheme_set_root_param (MZCONFIG_ERROR_MESSAGE_ADJUSTER , def_err_msg_adjust_proc ) ; 
  scheme_set_root_param (MZCONFIG_EXE_YIELD_HANDLER , def_exe_yield_proc ) ; 
}

void scheme_init_logger_config () {
  /* No conversion */

# 1015 "bc/src/error.c"
  scheme_set_root_param (MZCONFIG_LOGGER , (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) ) ; 
}

static void 
call_error (char * buffer , int len , Scheme_Object * exn ) 
{
  char * __funcarg98 = NULLED_OUT ; 
  Scheme_Logger * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  PREPARE_VAR_STACK(13);
  BLOCK_SETUP_TOP((PUSH(exn, 0), PUSH(__funcarg97, 1), PUSH(buffer, 2)));
# define XfOrM157_COUNT (3)
# define SETUP_XfOrM157(x) SETUP(XfOrM157_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1021 "bc/src/error.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding ) {
#   define XfOrM163_COUNT (0+XfOrM157_COUNT)
#   define SETUP_XfOrM163(x) SETUP_XfOrM157(x)

# 1022 "bc/src/error.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding != (Optimize_Info * ) scheme_false )
      (__funcarg97 = FUNCCALL(SETUP_XfOrM163(_), scheme_optimize_info_logger (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding ) ), __funcarg98 = FUNCCALL(SETUP_XfOrM163(_), scheme_optimize_info_context (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding ) )



    , FUNCCALL_AGAIN(scheme_log (__funcarg97 , 3 , 0 , "constant-fold attempt failed%s: %s" , __funcarg98 , buffer ) )) 
    ; 
    if (((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && (scheme_is_struct_instance (exn_table [MZEXN_BREAK ] . type , exn ) ) ) {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = exn ; 
    }
    (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  }

# 1035 "bc/src/error.c"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = exn ; 
    (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  }

# 1038 "bc/src/error.c"
  else {
    mz_jmp_buf savebuf ; 
    Scheme_Object * p [2 ] , * display_handler , * escape_handler , * v ; 
    Scheme_Config * config , * orig_config ; 
    Scheme_Cont_Frame_Data cframe , cframe2 ; 
    BLOCK_SETUP((PUSH(display_handler, 0+XfOrM157_COUNT), PUSHARRAY(p, 2, 1+XfOrM157_COUNT), PUSH(v, 4+XfOrM157_COUNT), PUSH(cframe.cache, 5+XfOrM157_COUNT), PUSH(escape_handler, 6+XfOrM157_COUNT), PUSH(orig_config, 7+XfOrM157_COUNT), PUSH(config, 8+XfOrM157_COUNT), PUSH(cframe2.cache, 9+XfOrM157_COUNT)));
#   define XfOrM158_COUNT (10+XfOrM157_COUNT)
#   define SETUP_XfOrM158(x) SETUP(XfOrM158_COUNT)
    p[0] = NULLED_OUT ; 
    p[1] = NULLED_OUT ; 
    display_handler = NULLED_OUT ; 
    escape_handler = NULLED_OUT ; 
    v = NULLED_OUT ; 
    config = NULLED_OUT ; 
    orig_config = NULLED_OUT ; 
    cframe.cache = NULLED_OUT ; 
    cframe2.cache = NULLED_OUT ; 
    (
# 1045 "bc/src/error.c"
    memcpy ((void * ) & savebuf , & * (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) , sizeof (mz_jmp_buf ) ) ) ; 

    orig_config = FUNCCALL(SETUP_XfOrM158(_), scheme_current_config () ); 
    display_handler = FUNCCALL_AGAIN(scheme_get_param (orig_config , MZCONFIG_ERROR_DISPLAY_HANDLER ) ); 
    escape_handler = FUNCCALL_AGAIN(scheme_get_param (orig_config , MZCONFIG_ERROR_ESCAPE_HANDLER ) ); 

    v = FUNCCALL_AGAIN(scheme_make_byte_string_without_copying ("error display handler" ) ); 
    v = (__funcarg96 = FUNCCALL(SETUP_XfOrM158(_), scheme_make_pair (v , exn ) )
    , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity ((Scheme_Closed_Prim * ) nested_exn_handler , __funcarg96 , "nested-exception-handler" , 1 , 1 ) )) 

    ; 

    config = orig_config ; 
    if ((display_handler ) == (default_display_handler ) ) 
      config = FUNCCALL(SETUP_XfOrM158(_), scheme_extend_config (config , MZCONFIG_ERROR_DISPLAY_HANDLER , emergency_display_handler ) )

    ; 
    else 
    config = FUNCCALL(SETUP_XfOrM158(_), scheme_extend_config (config , MZCONFIG_ERROR_DISPLAY_HANDLER , default_display_handler ) )

    ; 
    FUNCCALL(SETUP_XfOrM158(_), scheme_push_continuation_frame (& cframe ) )
    ; 
    FUNCCALL_AGAIN(scheme_install_config (config ) ); 
    FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_exn_handler_key , v ) ); 
    FUNCCALL_AGAIN(scheme_push_break_enable (& cframe2 , 0 , 0 ) ); 

    if (((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && ((scheme_is_struct_instance (exn_table [MZEXN_BREAK_HANG_UP ] . type , exn ) ) ) ) {
    }
    else {
#     define XfOrM160_COUNT (0+XfOrM158_COUNT)
#     define SETUP_XfOrM160(x) SETUP_XfOrM158(x)

# 1076 "bc/src/error.c"
      p [0 ] = FUNCCALL(SETUP_XfOrM160(_), scheme_make_immutable_sized_utf8_string (buffer , len ) ); 
      p [1 ] = exn ; 
      FUNCCALL(SETUP_XfOrM160(_), scheme_apply_multi (display_handler , 2 , p ) ); 
    }

    if (((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && ((scheme_is_struct_instance (exn_table [MZEXN_BREAK_HANG_UP ] . type , exn ) ) 
    || (scheme_is_struct_instance (exn_table [MZEXN_BREAK_TERMINATE ] . type , exn ) ) ) ) {
#     define XfOrM159_COUNT (0+XfOrM158_COUNT)
#     define SETUP_XfOrM159(x) SETUP_XfOrM158(x)
      p [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
      FUNCCALL(SETUP_XfOrM159(_), scheme_do_exit (1 , p ) ); 
    }


    v = FUNCCALL(SETUP_XfOrM158(_), scheme_make_byte_string_without_copying ("error escape handler" ) ); 
    v = (__funcarg95 = FUNCCALL(SETUP_XfOrM158(_), scheme_make_pair (v , exn ) )
    , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity ((Scheme_Closed_Prim * ) nested_exn_handler , __funcarg95 , "nested-exception-handler" , 1 , 1 ) )) 

    ; 

    config = FUNCCALL_AGAIN(scheme_extend_config (config , MZCONFIG_ERROR_DISPLAY_HANDLER , default_display_handler ) )

    ; 
    config = FUNCCALL_AGAIN(scheme_extend_config (config , MZCONFIG_ERROR_ESCAPE_HANDLER , def_error_esc_proc ) )

    ; 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe2 , 0 ) )
    ; 
    FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) ); 
    FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )
    ; 
    FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_exn_handler_key , v ) ); 
    FUNCCALL_AGAIN(scheme_install_config (config ) ); 
    FUNCCALL_AGAIN(scheme_push_break_enable (& cframe2 , 0 , 0 ) ); 
    FUNCCALL_AGAIN(scheme_apply_multi (escape_handler , 0 , ((void * ) 0 ) ) )

    ; 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe2 , 0 ) )
    ; 
    FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) ); 
    FUNCCALL_AGAIN(def_error_escape_proc (0 , ((void * ) 0 ) ) )

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1123 "bc/src/error.c"
intptr_t scheme_get_print_width (void ) 
{
  intptr_t print_width ; 
  Scheme_Object * w ; 
  Scheme_Config * __funcarg99 = NULLED_OUT ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(w, 0)));
# define XfOrM165_COUNT (1)
# define SETUP_XfOrM165(x) SETUP(XfOrM165_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  w = NULLED_OUT ; 

# 1128 "bc/src/error.c"
  w = (__funcarg99 = FUNCCALL(SETUP_XfOrM165(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg99 , MZCONFIG_ERROR_PRINT_WIDTH ) )) ; 
  if (((intptr_t ) (w ) ) & 0x1 ) 
    print_width = (((intptr_t ) (w ) ) >> 1 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (w ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (w ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
    print_width = 0x7FFFFFFF ; 
  else 
  print_width = 10000 ; 

  RET_VALUE_START (print_width ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1139 "bc/src/error.c"
static char * init_buf (intptr_t * len , intptr_t * _size ) 
{
  uintptr_t local_max_symbol_length ; 
  intptr_t print_width ; 
  intptr_t size ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(len, 0), PUSH(_size, 1)));
# define XfOrM166_COUNT (2)
# define SETUP_XfOrM166(x) SETUP(XfOrM166_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1145 "bc/src/error.c"
  local_max_symbol_length = FUNCCALL(SETUP_XfOrM166(_), scheme_get_max_symbol_length () ); 
  print_width = FUNCCALL(SETUP_XfOrM166(_), scheme_get_print_width () ); 

  size = (3 * local_max_symbol_length + 500 + 2 * print_width ) ; 


  if (len )
    * len = print_width ; 
  if (_size )
    * _size = size ; 

  RET_VALUE_START ((char * ) FUNCCALL_EMPTY(GC_malloc_atomic (size ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1159 "bc/src/error.c"
void 
scheme_signal_error (const char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * buffer ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(buffer, 0)));
# define XfOrM167_COUNT (1)
# define SETUP_XfOrM167(x) SETUP(XfOrM167_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 

# 1166 "bc/src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = FUNCCALL(SETUP_XfOrM167(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  buffer [len ] = 0 ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) ) {
#   define XfOrM168_COUNT (0+XfOrM167_COUNT)
#   define SETUP_XfOrM168(x) SETUP_XfOrM167(x)

# 1173 "bc/src/error.c"
    buffer [len ++ ] = '\n' ; 
    buffer [len ] = 0 ; 
    FUNCCALL(SETUP_XfOrM168(_), scheme_console_output (buffer , len ) ); 
    FUNCCALL_AGAIN(exit (0 ) ); 
  }
  FUNCCALL(SETUP_XfOrM167(_), scheme_raise_exn (MZEXN_FAIL , "%t" , buffer , len ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1182 "bc/src/error.c"
void scheme_warning (char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * buffer ; 
  intptr_t len ; 
  Scheme_Config * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(buffer, 0)));
# define XfOrM169_COUNT (1)
# define SETUP_XfOrM169(x) SETUP(XfOrM169_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 

# 1188 "bc/src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = FUNCCALL(SETUP_XfOrM169(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  buffer [len ++ ] = '\n' ; 
  buffer [len ] = 0 ; 
  (__funcarg100 = (__funcarg101 = FUNCCALL(SETUP_XfOrM169(_), scheme_current_config () )

  , FUNCCALL_AGAIN(scheme_get_param (__funcarg101 , MZCONFIG_ERROR_PORT ) )) , FUNCCALL_AGAIN(scheme_write_byte_string (buffer , len , __funcarg100 ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1199 "bc/src/error.c"
void scheme_ensure_console_ready () 
{
  /* No conversion */

# 1201 "bc/src/error.c"
  rktio_create_console () ; 
}

void scheme_log (Scheme_Logger * logger , int level , int flags , 
const char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * buffer ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(buffer, 1)));
# define XfOrM171_COUNT (2)
# define SETUP_XfOrM171(x) SETUP(XfOrM171_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 

# 1211 "bc/src/error.c"
  if (logger ) {
    if (logger -> local_timestamp == (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
      if (logger -> want_level < level )
      RET_NOTHING ; 
  }

  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = FUNCCALL(SETUP_XfOrM171(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  buffer [len ] = 0 ; 
  FUNCCALL(SETUP_XfOrM171(_), scheme_log_message (logger , level , buffer , len , ((void * ) 0 ) ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1226 "bc/src/error.c"
void scheme_log_w_data (Scheme_Logger * logger , int level , int flags , 
Scheme_Object * data , 
const char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * buffer ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(data, 0), PUSH(logger, 1), PUSH(buffer, 2)));
# define XfOrM173_COUNT (3)
# define SETUP_XfOrM173(x) SETUP(XfOrM173_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 

# 1234 "bc/src/error.c"
  if (logger ) {
    if (logger -> local_timestamp == (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
      if (logger -> want_level < level )
      RET_NOTHING ; 
  }

  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = FUNCCALL(SETUP_XfOrM173(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  buffer [len ] = 0 ; 
  FUNCCALL(SETUP_XfOrM173(_), scheme_log_message (logger , level , buffer , len , data ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1249 "bc/src/error.c"
static char * error_write_to_string_w_max (Scheme_Object * v , int len , intptr_t * lenout ) 
{
  Scheme_Object * o , * args [2 ] ; 
  Scheme_Config * __funcarg104 = NULLED_OUT ; 
  Scheme_Config * __funcarg103 = NULLED_OUT ; 
  Scheme_Config * __funcarg102 = NULLED_OUT ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSHARRAY(args, 2, 0), PUSH(lenout, 3), PUSH(o, 4), PUSH(v, 5)));
# define XfOrM175_COUNT (6)
# define SETUP_XfOrM175(x) SETUP(XfOrM175_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 
  args[0] = NULLED_OUT ; 
  args[1] = NULLED_OUT ; 

# 1253 "bc/src/error.c"
  o = (__funcarg104 = FUNCCALL(SETUP_XfOrM175(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg104 , MZCONFIG_ERROR_PRINT_VALUE_HANDLER ) )) ; 

  if (((o ) == (def_err_val_proc ) ) 
  && (((__funcarg103 = FUNCCALL(SETUP_XfOrM175(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg103 , MZCONFIG_PORT_PRINT_HANDLER ) )) ) == (scheme_default_global_print_handler ) ) )  
  {
    intptr_t l ; 
    char * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM175_COUNT)));
#   define XfOrM181_COUNT (1+XfOrM175_COUNT)
#   define SETUP_XfOrM181(x) SETUP(XfOrM181_COUNT)
    s = NULLED_OUT ; 

# 1260 "bc/src/error.c"
    s = FUNCCALL(SETUP_XfOrM181(_), scheme_print_to_string_w_max (v , & l , len ) ); 
    if (lenout )
      * lenout = l ; 
    RET_VALUE_START (s ) RET_VALUE_END ; 
  }

# 1264 "bc/src/error.c"
  else {
    Scheme_Config * config ; 
    Scheme_Cont_Frame_Data cframe , cframe2 ; 
    BLOCK_SETUP((PUSH(cframe.cache, 0+XfOrM175_COUNT), PUSH(config, 1+XfOrM175_COUNT), PUSH(cframe2.cache, 2+XfOrM175_COUNT)));
#   define XfOrM176_COUNT (3+XfOrM175_COUNT)
#   define SETUP_XfOrM176(x) SETUP(XfOrM176_COUNT)
    config = NULLED_OUT ; 
    cframe.cache = NULLED_OUT ; 
    cframe2.cache = NULLED_OUT ; 

# 1268 "bc/src/error.c"
    args [0 ] = v ; 
    args [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) ; 

    config = (__funcarg102 = FUNCCALL(SETUP_XfOrM176(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_extend_config (__funcarg102 , MZCONFIG_ERROR_PRINT_VALUE_HANDLER , def_err_val_proc ) )) 

    ; 
    config = FUNCCALL_AGAIN(scheme_extend_config (config , MZCONFIG_PRINT_UNREADABLE , scheme_true ) )

    ; 
    FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )
    ; 
    FUNCCALL_AGAIN(scheme_install_config (config ) ); 
    FUNCCALL_AGAIN(scheme_push_break_enable (& cframe2 , 0 , 0 ) ); 

    o = FUNCCALL_AGAIN(scheme_do_eval (o , 2 , args , 1 ) ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe2 , 0 ) )
    ; 
    FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) ); 

    if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#     define XfOrM180_COUNT (0+XfOrM176_COUNT)
#     define SETUP_XfOrM180(x) SETUP_XfOrM176(x)

# 1288 "bc/src/error.c"
      o = FUNCCALL(SETUP_XfOrM180(_), scheme_char_string_to_byte_string (o ) ); 
    }

    if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
      char * s = (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM176_COUNT)));
#     define XfOrM178_COUNT (1+XfOrM176_COUNT)
#     define SETUP_XfOrM178(x) SETUP(XfOrM178_COUNT)

# 1293 "bc/src/error.c"
      if ((((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . tag_val ) > len ) {
        char * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM178_COUNT)));
#       define XfOrM179_COUNT (1+XfOrM178_COUNT)
#       define SETUP_XfOrM179(x) SETUP(XfOrM179_COUNT)
        naya = NULLED_OUT ; 

# 1295 "bc/src/error.c"
        naya = FUNCCALL(SETUP_XfOrM179(_), GC_malloc_atomic (len + 1 ) ); 
        (memcpy (naya , s , len ) ) ; 
        s [len ] = 0 ; 
        if (lenout )
          * lenout = len ; 
      }

# 1300 "bc/src/error.c"
      else if (lenout )
        * lenout = (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . tag_val ) ; 
      RET_VALUE_START (s ) RET_VALUE_END ; 
    }

# 1303 "bc/src/error.c"
    else {
      if (lenout )
        * lenout = 3 ; 
      RET_VALUE_START ("..." ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1311 "bc/src/error.c"
static Scheme_Object * check_arity_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM182_COUNT (1)
# define SETUP_XfOrM182(x) SETUP(XfOrM182_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1313 "bc/src/error.c"
  if (! FUNCCALL(SETUP_XfOrM182(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , argv ) ))
    FUNCCALL(SETUP_XfOrM182(_), scheme_arg_mismatch ("guard-for-prop:arity-string" , "property value is not a procedure (arity 1): " , argv [0 ] ) )

  ; 
  RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1320 "bc/src/error.c"
static char * make_arity_expect_string (const char * name , int namelen , 
int * _namelen , Scheme_Object * * _name_realm , 
int minc , int maxc , 
int argc , Scheme_Object * * argv , 
intptr_t * _len , int is_method , 
const char * map_name ) 


{
  intptr_t len , pos , slen ; 
  int xargc , xminc , xmaxc ; 
  char * s , * arity_str = ((void * ) 0 ) ; 
  const char * prefix_msg1 , * prefix_msg2 , * suffix_msg ; 
  int arity_len = 0 ; 
  Scheme_Object * name_realm = scheme_default_realm ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(17);
  BLOCK_SETUP_TOP((PUSH(prefix_msg1, 0), PUSH(name, 1), PUSH(_namelen, 2), PUSH(suffix_msg, 3), PUSH(_len, 4), PUSH(_name_realm, 5), PUSH(map_name, 6), PUSH(prefix_msg2, 7), PUSH(name_realm, 8), PUSH(arity_str, 9), PUSH(s, 10), PUSH(argv, 11)));
# define XfOrM183_COUNT (12)
# define SETUP_XfOrM183(x) SETUP(XfOrM183_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  prefix_msg1 = NULLED_OUT ; 
  prefix_msg2 = NULLED_OUT ; 
  suffix_msg = NULLED_OUT ; 

# 1336 "bc/src/error.c"
  s = FUNCCALL(SETUP_XfOrM183(_), init_buf (& len , & slen ) ); 

  if (! name )
    name = "#<procedure>" ; 

  xargc = argc - (is_method ? 1 : 0 ) ; 
  xminc = minc - (is_method ? 1 : 0 ) ; 
  xmaxc = maxc - (is_method ? 1 : 0 ) ; 

  if ((minc == - 1 ) && (((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) name ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) || ((((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) name ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) (Scheme_Object * ) name ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) (Scheme_Object * ) name ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) {
    Scheme_Object * arity_maker ; 
    BLOCK_SETUP((PUSH(arity_maker, 0+XfOrM183_COUNT)));
#   define XfOrM199_COUNT (1+XfOrM183_COUNT)
#   define SETUP_XfOrM199(x) SETUP(XfOrM199_COUNT)
    arity_maker = NULLED_OUT ; 

# 1348 "bc/src/error.c"
    while (1 ) {
#     define XfOrM210_COUNT (0+XfOrM199_COUNT)
#     define SETUP_XfOrM210(x) SETUP_XfOrM199(x)

# 1349 "bc/src/error.c"
      arity_maker = (scheme_struct_type_property_ref (arity_property , (Scheme_Object * ) name ) ) ; 
      if (arity_maker ) {
        Scheme_Object * v , * a [1 ] ; 
        BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM210_COUNT), PUSH(v, 3+XfOrM210_COUNT)));
#       define XfOrM214_COUNT (4+XfOrM210_COUNT)
#       define SETUP_XfOrM214(x) SETUP(XfOrM214_COUNT)
        v = NULLED_OUT ; 
        a[0] = NULLED_OUT ; 

# 1352 "bc/src/error.c"
        a [0 ] = (Scheme_Object * ) name ; 
        v = FUNCCALL(SETUP_XfOrM214(_), scheme_apply (arity_maker , 1 , a ) ); 
        if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#         define XfOrM215_COUNT (0+XfOrM214_COUNT)
#         define SETUP_XfOrM215(x) SETUP_XfOrM214(x)

# 1355 "bc/src/error.c"
          v = FUNCCALL(SETUP_XfOrM215(_), scheme_char_string_to_byte_string (v ) ); 
          arity_str = (((Scheme_Simple_Object * ) (v ) ) -> u . byte_str_val . string_val ) ; 
          arity_len = (((Scheme_Simple_Object * ) (v ) ) -> u . byte_str_val . tag_val ) ; 
          if (arity_len > len )
            arity_len = len ; 
          name_realm = FUNCCALL(SETUP_XfOrM215(_), scheme_get_proc_realm ((Scheme_Object * ) name ) ); 
          name = FUNCCALL_AGAIN(scheme_get_proc_name ((Scheme_Object * ) name , & namelen , 1 ) ); 
          if (! name ) {
            name = "#<procedure>" ; 
            namelen = strlen (name ) ; 
          }
          break ; 
        }

# 1367 "bc/src/error.c"
        else 
        break ; 
      }

# 1369 "bc/src/error.c"
      else {
        Scheme_Object * v ; 
        int is_method ; 
        BLOCK_SETUP((PUSH(v, 0+XfOrM210_COUNT)));
#       define XfOrM213_COUNT (1+XfOrM210_COUNT)
#       define SETUP_XfOrM213(x) SETUP(XfOrM213_COUNT)
        v = NULLED_OUT ; 

# 1372 "bc/src/error.c"
        v = (Scheme_Object * ) name ; 
        if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
          v = (((Scheme_Chaperone * ) v ) -> val ) ; 
        if (scheme_is_struct_instance (scheme_reduced_procedure_struct , v ) ) 
          v = ((void * ) 0 ) ; 
        else 
        v = FUNCCALL(SETUP_XfOrM213(_), scheme_extract_struct_procedure (v , - 1 , ((void * ) 0 ) , & is_method ) ); 
        if (! v || is_method || ! (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) )
          break ; 
        name = (const char * ) v ; 
      }
      {
#       define XfOrM211_COUNT (0+XfOrM210_COUNT)
#       define SETUP_XfOrM211(x) SETUP_XfOrM210(x)

# 1383 "bc/src/error.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM212_COUNT (0+XfOrM211_COUNT)
#         define SETUP_XfOrM212(x) SETUP_XfOrM211(x)
          FUNCCALL(SETUP_XfOrM212(_), scheme_out_of_fuel () )
# 1383 "bc/src/error.c"
          ; 
        }
      }

# 1383 "bc/src/error.c"
      ; 
    }

    if (! arity_str ) {



      Scheme_Object * arity ; 
      BLOCK_SETUP((PUSH(arity, 0+XfOrM199_COUNT)));
#     define XfOrM200_COUNT (1+XfOrM199_COUNT)
#     define SETUP_XfOrM200(x) SETUP(XfOrM200_COUNT)
      arity = NULLED_OUT ; 

# 1391 "bc/src/error.c"
      arity = FUNCCALL(SETUP_XfOrM200(_), scheme_arity ((Scheme_Object * ) name ) ); 
      if (((intptr_t ) (arity ) ) & 0x1 )  {
#       define XfOrM201_COUNT (0+XfOrM200_COUNT)
#       define SETUP_XfOrM201(x) SETUP_XfOrM200(x)

# 1393 "bc/src/error.c"
        minc = maxc = (((intptr_t ) (arity ) ) >> 1 ) ; 
        xmaxc = xminc = minc - (is_method ? 1 : 0 ) ; 
        name_realm = FUNCCALL(SETUP_XfOrM201(_), scheme_get_proc_realm ((Scheme_Object * ) name ) ); 
        name = FUNCCALL_AGAIN(scheme_get_proc_name ((Scheme_Object * ) name , & namelen , 1 ) ); 
        if (! name ) {
          name = "#<procedure>" ; 
          namelen = strlen (name ) ; 
        }
      }
    }
  }

  if (map_name ) {
    prefix_msg1 = map_name ; 
    prefix_msg2 = (": argument mismatch;\n" 
    " the given procedure's expected number of arguments does not match\n" 
    " the given number of lists\n" 
    "  given procedure: " ) ; 
    suffix_msg = "" ; 
  }

# 1412 "bc/src/error.c"
  else {
    prefix_msg1 = "" ; 
    prefix_msg2 = "" ; 
    suffix_msg = (": arity mismatch;\n" 
    " the expected number of arguments does not match the given number" ) ; 
  }

  if (namelen == - 1 )
    namelen = strlen (name ) ; 

  * _namelen = namelen + strlen (prefix_msg1 ) ; 

  if (arity_str ) {
#   define XfOrM196_COUNT (0+XfOrM183_COUNT)
#   define SETUP_XfOrM196(x) SETUP_XfOrM183(x)

# 1425 "bc/src/error.c"
    pos = FUNCCALL(SETUP_XfOrM196(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: %t\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , arity_str , (intptr_t ) arity_len , xargc ) )






    ; 
  }

# 1433 "bc/src/error.c"
  else if (minc < 0 ) {
    const char * n ; 
    int nlen ; 
    BLOCK_SETUP((PUSH(n, 0+XfOrM183_COUNT)));
#   define XfOrM192_COUNT (1+XfOrM183_COUNT)
#   define SETUP_XfOrM192(x) SETUP(XfOrM192_COUNT)
    n = NULLED_OUT ; 

# 1437 "bc/src/error.c"
    if (minc == - 2 ) {
      n = name ; 
      nlen = (namelen < 0 ? strlen (n ) : namelen ) ; 
    }

# 1440 "bc/src/error.c"
    else {
#     define XfOrM194_COUNT (0+XfOrM192_COUNT)
#     define SETUP_XfOrM194(x) SETUP_XfOrM192(x)

# 1441 "bc/src/error.c"
      name_realm = FUNCCALL(SETUP_XfOrM194(_), scheme_get_proc_realm ((Scheme_Object * ) name ) ); 
      n = FUNCCALL(SETUP_XfOrM194(_), scheme_get_proc_name ((Scheme_Object * ) name , & nlen , 1 ) ); 
    }

    if (! n ) {
      n = "#<case-lambda-procedure>" ; 
      nlen = strlen (n ) ; 
    }

    * _namelen = nlen + strlen (prefix_msg1 ) ; 

    pos = FUNCCALL(SETUP_XfOrM192(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  given: %d" , prefix_msg1 , prefix_msg2 , n , (intptr_t ) nlen , suffix_msg , xargc ) )





    ; 
  }

# 1459 "bc/src/error.c"
  else if (! maxc )
    pos = FUNCCALL(SETUP_XfOrM183(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: 0\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , xargc ) )






  ; 
  else if (maxc < 0 )
    pos = FUNCCALL(SETUP_XfOrM183(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: at least %d\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , xminc , xargc ) )






  ; 
  else if (minc == maxc )
    pos = FUNCCALL(SETUP_XfOrM183(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: %d\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , xminc , xargc ) )






  ; 
  else 
  pos = FUNCCALL(SETUP_XfOrM183(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: %d to %d\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , xminc , xmaxc , xargc ) )






  ; 

  if (xargc && argv ) {
#   define XfOrM184_COUNT (0+XfOrM183_COUNT)
#   define SETUP_XfOrM184(x) SETUP_XfOrM183(x)

# 1497 "bc/src/error.c"
    len -= (xargc * 4 ) ; 
    len /= xargc ; 
    if ((xargc < 50 ) && (len >= 3 ) ) {
      int i ; 
#     define XfOrM185_COUNT (0+XfOrM184_COUNT)
#     define SETUP_XfOrM185(x) SETUP_XfOrM184(x)

# 1502 "bc/src/error.c"
      for (i = (is_method ? 1 : 0 ) ; i < argc ; i ++ ) {
        intptr_t l ; 
        char * o ; 
        BLOCK_SETUP((PUSH(o, 0+XfOrM185_COUNT)));
#       define XfOrM189_COUNT (1+XfOrM185_COUNT)
#       define SETUP_XfOrM189(x) SETUP(XfOrM189_COUNT)
        o = NULLED_OUT ; 

# 1505 "bc/src/error.c"
        if (i == (is_method ? 1 : 0 ) ) {
#         define XfOrM191_COUNT (0+XfOrM189_COUNT)
#         define SETUP_XfOrM191(x) SETUP_XfOrM189(x)
          (
# 1506 "bc/src/error.c"
          strcpy (s + pos , "\n  arguments...:\n   " ) ) ; 
          pos += 20 ; 
        }

# 1508 "bc/src/error.c"
        else {
#         define XfOrM190_COUNT (0+XfOrM189_COUNT)
#         define SETUP_XfOrM190(x) SETUP_XfOrM189(x)
          (
# 1509 "bc/src/error.c"
          strcpy (s + pos , "\n   " ) ) ; 
          pos += 4 ; 
        }

        o = FUNCCALL(SETUP_XfOrM189(_), error_write_to_string_w_max (argv [i ] , len , & l ) ); 
        (memcpy (s + pos , o , l ) ) ; 
        pos += l ; 
      }

      s [pos ] = 0 ; 
    }
  }

  * _len = pos ; 

  if (_name_realm )
    * _name_realm = name_realm ; 

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1530 "bc/src/error.c"
static void wrong_count_for_realm (const char * name , Scheme_Object * realm , int minc , int maxc , 
int argc , Scheme_Object * * argv , int is_method ) 


{
  char * s ; 
  intptr_t len ; 
  int name_len ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(name, 1), PUSH(s, 2), PUSH(argv, 3)));
# define XfOrM217_COUNT (4)
# define SETUP_XfOrM217(x) SETUP(XfOrM217_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 

# 1540 "bc/src/error.c"
  if (argv == p -> tail_buffer ) {
#   define XfOrM224_COUNT (0+XfOrM217_COUNT)
#   define SETUP_XfOrM224(x) SETUP_XfOrM217(x)
    FUNCCALL(SETUP_XfOrM224(_), scheme_realloc_tail_buffer (p ) )
# 1542 "bc/src/error.c"
    ; 
  }



  if (minc == - 1 ) {
#   define XfOrM218_COUNT (0+XfOrM217_COUNT)
#   define SETUP_XfOrM218(x) SETUP_XfOrM217(x)

# 1549 "bc/src/error.c"
    if ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) name ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {
      Scheme_Lambda * data ; 
      BLOCK_SETUP((PUSH(data, 0+XfOrM218_COUNT)));
#     define XfOrM222_COUNT (1+XfOrM218_COUNT)
#     define SETUP_XfOrM222(x) SETUP(XfOrM222_COUNT)
      data = NULLED_OUT ; 

# 1551 "bc/src/error.c"
      data = ((Scheme_Closure * ) (Scheme_Object * ) name ) -> code ; 
      realm = FUNCCALL(SETUP_XfOrM222(_), scheme_get_proc_realm ((Scheme_Object * ) name ) ); 
      name = FUNCCALL_AGAIN(scheme_get_proc_name ((Scheme_Object * ) name , ((void * ) 0 ) , 1 ) ); 

      minc = data -> num_params ; 
      if ((& (data ) -> iso ) -> so . keyex & 1 ) {
        minc -= 1 ; 
        maxc = - 1 ; 
      }

# 1559 "bc/src/error.c"
      else 
      maxc = minc ; 
    }

# 1561 "bc/src/error.c"
    else if ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) name ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
      Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) name ; 
      if (cl -> count ) {
        Scheme_Lambda * data ; 
        data = NULLED_OUT ; 

# 1565 "bc/src/error.c"
        data = (Scheme_Lambda * ) ((Scheme_Closure * ) cl -> array [0 ] ) -> code ; 
        if ((& (data ) -> iso ) -> so . keyex & 16 )
          is_method = 1 ; 
      }

# 1568 "bc/src/error.c"
      else if (cl -> name && ((Scheme_Type ) (((((intptr_t ) (cl -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cl -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {

        is_method = 1 ; 
      }
    }
  }

# 1605 "bc/src/error.c"
  if (! argc || ! minc )
    is_method = 0 ; 

  if (maxc > 0x3FFFFFFE )
    maxc = - 1 ; 

  s = FUNCCALL(SETUP_XfOrM217(_), make_arity_expect_string (name , - 1 , & name_len , ((void * ) 0 ) , minc , maxc , argc , argv , & len , is_method , ((void * ) 0 ) ) ); 
  FUNCCALL_EMPTY(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT_ARITY , name_len , realm , scheme_primitive_realm , "%t" , s , len ) )


  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1618 "bc/src/error.c"
void scheme_wrong_count_m (const char * name , int minc , int maxc , 
int argc , Scheme_Object * * argv , int is_method ) 
{
  /* No conversion */
  wrong_count_for_realm (name , scheme_primitive_realm , minc , maxc , argc , argv , is_method ) ; 
}

void scheme_wrong_count (const char * name , int minc , int maxc , int argc , 
Scheme_Object * * argv ) 
{
  /* No conversion */
  scheme_wrong_count_m (name , minc , maxc , argc , argv , 0 ) ; 
}

void scheme_case_lambda_wrong_count (const char * name , 
int argc , Scheme_Object * * argv , 
int is_method , 
int count , ... ) 
{
  char * s ; 
  intptr_t len ; 
  int name_len ; 
  Scheme_Object * name_realm ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(name_realm, 1)));
# define XfOrM227_COUNT (2)
# define SETUP_XfOrM227(x) SETUP(XfOrM227_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  name_realm = NULLED_OUT ; 

# 1643 "bc/src/error.c"
  if (! argc )
    is_method = 0 ; 

  s = FUNCCALL(SETUP_XfOrM227(_), make_arity_expect_string (name , - 1 , & name_len , & name_realm , - 2 , 0 , argc , argv , & len , is_method , ((void * ) 0 ) ) ); 
  FUNCCALL_AGAIN(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT_ARITY , name_len , name_realm , scheme_primitive_realm , "%t" , s , len ) )


  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1653 "bc/src/error.c"
char * scheme_make_arity_expect_string (const char * map_name , 
Scheme_Object * proc , 
int argc , Scheme_Object * * argv , 
intptr_t * _slen ) 
{
  const char * name ; 
  char * result ; 
  int namelen = - 1 ; 
  int mina , maxa , actual_name_len ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(map_name, 0), PUSH(name, 1), PUSH(proc, 2), PUSH(_slen, 3), PUSH(argv, 4), PUSH(result, 5)));
# define XfOrM228_COUNT (6)
# define SETUP_XfOrM228(x) SETUP(XfOrM228_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 1663 "bc/src/error.c"
  if (((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    proc = (((Scheme_Chaperone * ) proc ) -> val ) ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) )  {
    name = ((Scheme_Primitive_Proc * ) proc ) -> name ; 
    mina = ((Scheme_Primitive_Proc * ) proc ) -> mina ; 
    if (mina < 0 ) {

      mina = - 2 ; 
      maxa = 0 ; 
    }

# 1674 "bc/src/error.c"
    else {
      maxa = ((Scheme_Primitive_Proc * ) proc ) -> mu . maxa ; 
      if (maxa > 0x3FFFFFFE )
        maxa = - 1 ; 
    }
  }

# 1679 "bc/src/error.c"
  else if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) )  {
    name = ((Scheme_Closed_Primitive_Proc * ) proc ) -> name ; 
    mina = ((Scheme_Closed_Primitive_Proc * ) proc ) -> mina ; 
    maxa = ((Scheme_Closed_Primitive_Proc * ) proc ) -> maxa ; 
  }

# 1683 "bc/src/error.c"
  else if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
#   define XfOrM232_COUNT (0+XfOrM228_COUNT)
#   define SETUP_XfOrM232(x) SETUP_XfOrM228(x)

# 1684 "bc/src/error.c"
    name = FUNCCALL(SETUP_XfOrM232(_), scheme_get_proc_name (proc , & namelen , 1 ) ); 
    mina = - 2 ; 
    maxa = 0 ; 
  }

# 1714 "bc/src/error.c"
  else if ((((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) proc ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) proc ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) proc ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) proc ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) )  {
    name = (const char * ) proc ; 
    mina = - 1 ; 
    maxa = 0 ; 
  }

# 1718 "bc/src/error.c"
  else {
    Scheme_Lambda * data ; 
#   define XfOrM229_COUNT (0+XfOrM228_COUNT)
#   define SETUP_XfOrM229(x) SETUP_XfOrM228(x)
    data = NULLED_OUT ; 

# 1721 "bc/src/error.c"
    data = (Scheme_Lambda * ) ((Scheme_Closure * ) proc ) -> code ; 
    mina = maxa = data -> num_params ; 
    if ((& (data ) -> iso ) -> so . keyex & 1 ) {
      -- mina ; 
      maxa = - 1 ; 
    }
    name = FUNCCALL(SETUP_XfOrM229(_), scheme_get_proc_name (proc , & namelen , 1 ) ); 
  }

  result = FUNCCALL(SETUP_XfOrM228(_), make_arity_expect_string (name , namelen , & actual_name_len , ((void * ) 0 ) , mina , maxa , argc , argv , _slen , 0 , map_name ) )
  ; 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1736 "bc/src/error.c"
char * scheme_make_args_string (const char * s , int which , int argc , Scheme_Object * * argv , intptr_t * _olen ) 
{
  char * other ; 
  intptr_t len ; 
  GC_CAN_IGNORE char * isres = "arguments" ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(_olen, 1), PUSH(other, 2), PUSH(argv, 3)));
# define XfOrM238_COUNT (4)
# define SETUP_XfOrM238(x) SETUP(XfOrM238_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  other = NULLED_OUT ; 

# 1742 "bc/src/error.c"
  other = FUNCCALL(SETUP_XfOrM238(_), init_buf (& len , ((void * ) 0 ) ) ); 

  if (argc < 0 ) {
    isres = "results" ; 
    argc = - argc ; 
  }

  len /= (argc - (((which >= 0 ) && (argc > 1 ) ) ? 1 : 0 ) ) ; 
  if ((argc < 50 ) && (len >= 3 ) ) {
    int i , pos ; 
#   define XfOrM240_COUNT (0+XfOrM238_COUNT)
#   define SETUP_XfOrM240(x) SETUP_XfOrM238(x)
    (
# 1753 "bc/src/error.c"
    sprintf (other , "; %s%s were:" , s , isres ) ) ; 
    pos = strlen (other ) ; 
    for (i = 0 ; i < argc ; i ++ ) {
#     define XfOrM243_COUNT (0+XfOrM240_COUNT)
#     define SETUP_XfOrM243(x) SETUP_XfOrM240(x)

# 1756 "bc/src/error.c"
      if (i != which ) {
        intptr_t l ; 
        char * o ; 
        BLOCK_SETUP((PUSH(o, 0+XfOrM243_COUNT)));
#       define XfOrM244_COUNT (1+XfOrM243_COUNT)
#       define SETUP_XfOrM244(x) SETUP(XfOrM244_COUNT)
        o = NULLED_OUT ; 

# 1759 "bc/src/error.c"
        o = FUNCCALL(SETUP_XfOrM244(_), error_write_to_string_w_max (argv [i ] , len , & l ) ); 
        (memcpy (other + pos , " " , 1 ) ) ; 
        (memcpy (other + pos + 1 , o , l ) ) ; 
        pos += l + 1 ; 
      }
    }
    other [pos ] = 0 ; 
    if (_olen )
      * _olen = pos ; 
  }

# 1768 "bc/src/error.c"
  else {
#   define XfOrM239_COUNT (0+XfOrM238_COUNT)
#   define SETUP_XfOrM239(x) SETUP_XfOrM238(x)
    (
# 1769 "bc/src/error.c"
    sprintf (other , "; given %d arguments total" , argc ) ) ; 
    if (_olen )
      * _olen = strlen (other ) ; 
  }

  RET_VALUE_START (other ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1777 "bc/src/error.c"
char * scheme_make_arg_lines_string (const char * indent , int which , int argc , Scheme_Object * * argv , intptr_t * _olen ) 
{
  char * other ; 
  intptr_t len , plen ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(_olen, 0), PUSH(indent, 1), PUSH(other, 2), PUSH(argv, 3)));
# define XfOrM246_COUNT (4)
# define SETUP_XfOrM246(x) SETUP(XfOrM246_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  other = NULLED_OUT ; 

# 1782 "bc/src/error.c"
  if (! argc || ((argc == 1 ) && (which == 0 ) ) ) {
    other = " [none]" ; 
    if (_olen )
      * _olen = strlen (other ) ; 
    RET_VALUE_START (other ) RET_VALUE_END ; 
  }

  other = FUNCCALL(SETUP_XfOrM246(_), init_buf (& len , ((void * ) 0 ) ) ); 

  plen = strlen (indent ) ; 

  len -= ((argc - 1 ) * (plen + 1 ) ) ; 
  len /= (argc - (((which >= 0 ) && (argc > 1 ) ) ? 1 : 0 ) ) ; 

  if (len >= 3 ) {
    int i , pos ; 
#   define XfOrM248_COUNT (0+XfOrM246_COUNT)
#   define SETUP_XfOrM248(x) SETUP_XfOrM246(x)

# 1799 "bc/src/error.c"
    pos = 0 ; 
    for (i = 0 ; i < argc ; i ++ ) {
#     define XfOrM251_COUNT (0+XfOrM248_COUNT)
#     define SETUP_XfOrM251(x) SETUP_XfOrM248(x)

# 1801 "bc/src/error.c"
      if (i != which ) {
        intptr_t l ; 
        char * o ; 
        BLOCK_SETUP((PUSH(o, 0+XfOrM251_COUNT)));
#       define XfOrM252_COUNT (1+XfOrM251_COUNT)
#       define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
        o = NULLED_OUT ; 
        (
# 1805 "bc/src/error.c"
        memcpy (other + pos , "\n" , 1 ) ) ; 
        pos ++ ; 
        (memcpy (other + pos , indent , plen ) ) ; 
        pos += plen ; 

        o = FUNCCALL(SETUP_XfOrM252(_), error_write_to_string_w_max (argv [i ] , len , & l ) ); 
        (memcpy (other + pos , o , l ) ) ; 
        pos += l ; 
      }
    }
    other [pos ] = 0 ; 
    if (_olen )
      * _olen = pos ; 
  }

# 1818 "bc/src/error.c"
  else {
#   define XfOrM247_COUNT (0+XfOrM246_COUNT)
#   define SETUP_XfOrM247(x) SETUP_XfOrM246(x)
    (
# 1819 "bc/src/error.c"
    sprintf (other , "... [%d total] ..." , argc ) ) ; 
    if (_olen )
      * _olen = strlen (other ) ; 
  }

  RET_VALUE_START (other ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1827 "bc/src/error.c"
const char * scheme_number_suffix (int which ) 
{
  /* No conversion */

# 1829 "bc/src/error.c"
  static char * ending [] = {

# 1829 "bc/src/error.c"
    "st" , "nd" , "rd" }

# 1829 "bc/src/error.c"
  ; 

  if (! which )
    return "th" ; 
  -- which ; 

  which = which % 100 ; 

  return ((which < 10 || which >= 20 ) 
  && ((which % 10 ) < 3 ) ) ? ending [which % 10 ] : "th" ; 
}

static void wrong_type_for_realm (const char * name , Scheme_Object * realm , 
const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) 
{
  Scheme_Object * o ; 
  char * s ; 
  intptr_t slen ; 
  int isres = 0 ; 
  GC_CAN_IGNORE char * isress = "argument" ; 
  GC_CAN_IGNORE char * isgiven = "given" ; 

# 1827 "bc/src/error.c"
  const char * __funcarg105 = NULLED_OUT ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(name, 1), PUSH(s, 2), PUSH(expected, 3), PUSH(argv, 4)));
# define XfOrM255_COUNT (5)
# define SETUP_XfOrM255(x) SETUP(XfOrM255_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 1853 "bc/src/error.c"
  o = argv [which < 0 ? 0 : which ] ; 
  if (argc < 0 ) {
    argc = - argc ; 
    isress = "result" ; 
    isgiven = "received" ; 
    isres = 1 ; 
  }
  if (which == - 2 ) {
    isress = "value" ; 
    isgiven = "received" ; 
  }

  s = FUNCCALL(SETUP_XfOrM255(_), scheme_make_provided_string (o , 1 , & slen ) ); 

  if ((which < 0 ) || (argc == 1 ) ) {
#   define XfOrM258_COUNT (0+XfOrM255_COUNT)
#   define SETUP_XfOrM258(x) SETUP_XfOrM255(x)
    FUNCCALL(SETUP_XfOrM258(_), scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: expect%s %s of type <%s>; " "%s: %t" , name , (which < 0 ) ? "ed" : "s" , isress , expected , isgiven , s , slen ) )




    ; 
  }

# 1876 "bc/src/error.c"
  else {
    char * other ; 
    intptr_t olen ; 
    BLOCK_SETUP((PUSH(other, 0+XfOrM255_COUNT)));
#   define XfOrM256_COUNT (1+XfOrM255_COUNT)
#   define SETUP_XfOrM256(x) SETUP(XfOrM256_COUNT)
    other = NULLED_OUT ; 

# 1880 "bc/src/error.c"
    if ((which >= 0 ) && (argc > 1 ) )
      other = FUNCCALL(SETUP_XfOrM256(_), scheme_make_args_string ("other " , which , (isres ? - argc : argc ) , argv , & olen ) )

    ; 
    else {
      other = "" ; 
      olen = 0 ; 
    }
    (__funcarg105 = FUNCCALL(SETUP_XfOrM256(_), scheme_number_suffix (which + 1 ) )





    , FUNCCALL_AGAIN(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: expects type <%s> as %d%s %s, " "given: %t%t" , name , expected , which + 1 , __funcarg105 , isress , s , slen , other , olen ) )) 

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1900 "bc/src/error.c"
void scheme_wrong_type (const char * name , const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) 
{
  /* No conversion */

# 1904 "bc/src/error.c"
  wrong_type_for_realm (name , scheme_default_realm , expected , which , argc , argv ) ; 
}

static const char * indent_lines (const char * s , intptr_t * _len , int initial_indent , int amt ) 
{
  intptr_t len , i , j , lines = 1 ; 
  int a ; 
  char * s2 ; 
  DECL_RET_SAVE (const char * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(_len, 1), PUSH(s2, 2)));
# define XfOrM262_COUNT (3)
# define SETUP_XfOrM262(x) SETUP(XfOrM262_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s2 = NULLED_OUT ; 

# 1913 "bc/src/error.c"
  if (_len )
    len = * _len ; 
  else 
  len = strlen (s ) ; 

  for (i = 0 ; i < len ; i ++ ) {
    if (s [i ] == '\n' )
      lines ++ ; 
  }

  if ((len > 72 ) || (lines > 1 ) ) {
#   define XfOrM263_COUNT (0+XfOrM262_COUNT)
#   define SETUP_XfOrM263(x) SETUP_XfOrM262(x)

# 1924 "bc/src/error.c"
    s2 = FUNCCALL(SETUP_XfOrM263(_), GC_malloc_atomic (len + (lines * (amt + 1 ) ) + 1 ) ); 

    if (initial_indent ) {
      s2 [0 ] = '\n' ; 
      j = 1 ; 
      for (a = 0 ; a < amt ; a ++ ) {
        s2 [j ++ ] = ' ' ; 
      }
    }

# 1932 "bc/src/error.c"
    else 
    j = 0 ; 

    for (i = 0 ; i < len ; i ++ ) {
      s2 [j ++ ] = s [i ] ; 
      if (s [i ] == '\n' ) {
        for (a = 0 ; a < amt ; a ++ ) {
          s2 [j ++ ] = ' ' ; 
        }
      }
    }
    s2 [j ] = 0 ; 

    if (_len )
      * _len = j ; 

    RET_VALUE_START (s2 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1954 "bc/src/error.c"
static void wrong_contract_for_realm (const char * name , Scheme_Object * realm , 
const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) 
{
  Scheme_Object * o ; 
  char * s ; 
  intptr_t slen ; 
  int isres = 0 ; 
  GC_CAN_IGNORE char * isgiven = "given" , * kind = "argument" ; 

# 1907 "bc/src/error.c"
  const char * __funcarg108 = NULLED_OUT ; 

# 1827 "bc/src/error.c"
  const char * __funcarg107 = NULLED_OUT ; 

# 1907 "bc/src/error.c"
  const char * __funcarg106 = NULLED_OUT ; 
  PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(s, 1), PUSH(name, 2), PUSH(expected, 3), PUSH(o, 4), PUSH(argv, 5), PUSH(__funcarg106, 6)));
# define XfOrM277_COUNT (7)
# define SETUP_XfOrM277(x) SETUP(XfOrM277_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 1965 "bc/src/error.c"
  expected = FUNCCALL(SETUP_XfOrM277(_), scheme_contract_realm_adjust (expected , realm ) ); 

  o = argv [which < 0 ? 0 : which ] ; 
  if (argc < 0 ) {
    argc = - argc ; 
    isgiven = "received" ; 
    kind = "result" ; 
    isres = 1 ; 
  }
  if (which == - 2 ) {
    isgiven = "received" ; 
    kind = "result" ; 
  }
  if (argc == 0 )
    kind = "value" ; 

  s = FUNCCALL(SETUP_XfOrM277(_), scheme_make_provided_string (o , 1 , & slen ) ); 

  if ((which < 0 ) || (argc <= 1 ) ) {
#   define XfOrM279_COUNT (0+XfOrM277_COUNT)
#   define SETUP_XfOrM279(x) SETUP_XfOrM277(x)
    (__funcarg108 = FUNCCALL(SETUP_XfOrM279(_), indent_lines (expected , ((void * ) 0 ) , 1 , 3 ) )



    , FUNCCALL_AGAIN(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: contract violation\n" "  expected: %s\n" "  %s: %t" , name , __funcarg108 , isgiven , s , slen ) )) 
    ; 
  }

# 1992 "bc/src/error.c"
  else {
    char * other ; 
    intptr_t olen ; 
    BLOCK_SETUP((PUSH(other, 0+XfOrM277_COUNT)));
#   define XfOrM278_COUNT (1+XfOrM277_COUNT)
#   define SETUP_XfOrM278(x) SETUP(XfOrM278_COUNT)
    other = NULLED_OUT ; 

# 1996 "bc/src/error.c"
    other = FUNCCALL(SETUP_XfOrM278(_), scheme_make_arg_lines_string ("   " , which , argc , argv , & olen ) ); 
    (__funcarg106 = FUNCCALL(SETUP_XfOrM278(_), indent_lines (expected , ((void * ) 0 ) , 1 , 3 ) )








    , __funcarg107 = FUNCCALL(SETUP_XfOrM278(_), scheme_number_suffix (which + 1 ) )

    , FUNCCALL_AGAIN(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: contract violation\n" "  expected: %s\n" "  %s: %t\n" "  %s position: %d%s\n" "  other %s...:%s" , name , __funcarg106 , isgiven , s , slen , kind , which + 1 , __funcarg107 , (! isres ? "arguments" : "results" ) , other , olen ) )) 
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2013 "bc/src/error.c"
void scheme_wrong_contract (const char * name , const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) 
{
  /* No conversion */

# 2017 "bc/src/error.c"
  wrong_contract_for_realm (name , scheme_primitive_realm , expected , which , argc , argv ) ; 
}

void scheme_wrong_contract_for_realm (const char * name , Scheme_Object * realm , const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) 
{
  /* No conversion */

# 2024 "bc/src/error.c"
  wrong_contract_for_realm (name , realm , expected , which , argc , argv ) ; 
}

void scheme_wrong_field_type (Scheme_Object * c_name , 
const char * expected , 
Scheme_Object * o ) 
{
  const char * s ; 
  Scheme_Object * a [1 ] ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(expected, 1), PUSHARRAY(a, 1, 2)));
# define XfOrM284_COUNT (5)
# define SETUP_XfOrM284(x) SETUP(XfOrM284_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 2033 "bc/src/error.c"
  a [0 ] = o ; 
  s = FUNCCALL(SETUP_XfOrM284(_), scheme_symbol_name (c_name ) ); 
  FUNCCALL_AGAIN(scheme_wrong_type (s , expected , - 1 , 0 , a ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2038 "bc/src/error.c"
void scheme_wrong_field_contract (Scheme_Object * c_name , 
const char * expected , 
Scheme_Object * o ) 
{
  const char * s ; 
  Scheme_Object * a [1 ] ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(expected, 1), PUSHARRAY(a, 1, 2)));
# define XfOrM285_COUNT (5)
# define SETUP_XfOrM285(x) SETUP(XfOrM285_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 2044 "bc/src/error.c"
  a [0 ] = o ; 
  s = FUNCCALL(SETUP_XfOrM285(_), scheme_symbol_name (c_name ) ); 
  FUNCCALL_AGAIN(scheme_wrong_contract (s , expected , - 1 , 0 , a ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2049 "bc/src/error.c"
static void arg_mismatch_at_realm (const char * name , Scheme_Object * realm , const char * msg , Scheme_Object * o ) 
{
  char * s ; 
  intptr_t slen ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(name, 1), PUSH(msg, 2), PUSH(s, 3)));
# define XfOrM286_COUNT (4)
# define SETUP_XfOrM286(x) SETUP(XfOrM286_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2054 "bc/src/error.c"
  if (o )
    s = FUNCCALL(SETUP_XfOrM286(_), scheme_make_provided_string (o , 1 , & slen ) ); 
  else {
    s = "" ; 
    slen = 0 ; 
  }
  FUNCCALL_EMPTY(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: %s%t" , name , msg , s , slen ) )



  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2067 "bc/src/error.c"
void scheme_arg_mismatch (const char * name , const char * msg , Scheme_Object * o ) 
{
  /* No conversion */

# 2069 "bc/src/error.c"
  arg_mismatch_at_realm (name , scheme_default_realm , msg , o ) ; 
}

static void do_out_of_range (const char * name , Scheme_Object * realm , const char * type , const char * which , 
int ending , 
Scheme_Object * i , Scheme_Object * s , 
Scheme_Object * low_bound , Scheme_Object * sstart , Scheme_Object * slen ) 
{
  char * __funcarg110 = NULLED_OUT ; 
  char * __funcarg109 = NULLED_OUT ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(s, 1), PUSH(low_bound, 2), PUSH(slen, 3), PUSH(name, 4), PUSH(type, 5), PUSH(which, 6), PUSH(i, 7), PUSH(sstart, 8)));
# define XfOrM289_COUNT (9)
# define SETUP_XfOrM289(x) SETUP(XfOrM289_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2077 "bc/src/error.c"
  if (! type ) {
    type = (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) ? "byte string" : "string" ) ; 
  }

  if (! FUNCCALL(SETUP_XfOrM289(_), scheme_bin_lt (slen , sstart ) )) {
    char * sstr ; 
    intptr_t sstrlen ; 
    int small_end = 0 ; 
    BLOCK_SETUP((PUSH(sstr, 0+XfOrM289_COUNT)));
#   define XfOrM291_COUNT (1+XfOrM289_COUNT)
#   define SETUP_XfOrM291(x) SETUP(XfOrM291_COUNT)
    sstr = NULLED_OUT ; 

# 2086 "bc/src/error.c"
    if (ending ) {
#     define XfOrM292_COUNT (0+XfOrM291_COUNT)
#     define SETUP_XfOrM292(x) SETUP_XfOrM291(x)

# 2087 "bc/src/error.c"
      if (FUNCCALL(SETUP_XfOrM292(_), scheme_bin_gt_eq (i , low_bound ) )
      && FUNCCALL(SETUP_XfOrM292(_), scheme_bin_lt (i , sstart ) ))
        small_end = 1 ; 
    }

    sstr = FUNCCALL(SETUP_XfOrM291(_), scheme_make_provided_string (s , 2 , & sstrlen ) ); 
    (__funcarg110 = FUNCCALL(SETUP_XfOrM291(_), scheme_make_provided_string (i , 2 , ((void * ) 0 ) ) )




    , FUNCCALL_AGAIN(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: %sindex is %s\n  %sindex: %s\n  %s%V%s%V]\n  %s: %t" , name , which , small_end ? "smaller than starting index" : "out of range" , which , __funcarg110 , ending ? "starting index: " : "valid range: [" , sstart , ending ? "\n  valid range: [0, " : ", " , slen , type , sstr , sstrlen ) )) 





    ; 
  }

# 2105 "bc/src/error.c"
  else {
#   define XfOrM290_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM290(x) SETUP_XfOrM289(x)
    (__funcarg109 = FUNCCALL(SETUP_XfOrM290(_), scheme_make_provided_string (i , 0 , ((void * ) 0 ) ) ), FUNCCALL_AGAIN(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: %sindex is out of range for empty %s\n  %sindex: %s" , name , which , type , which , __funcarg109 ) )) 


    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2115 "bc/src/error.c"
void scheme_out_of_range (const char * name , const char * type , const char * which , 
Scheme_Object * i , Scheme_Object * s , 
intptr_t start , intptr_t len ) 
{

# 156 "/usr/include/string.h" 3
  int __funcarg111 ; 
  PREPARE_VAR_STACK_ONCE(0);
# define XfOrM294_COUNT (0)
# define SETUP_XfOrM294(x) SETUP(XfOrM294_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2119 "bc/src/error.c"
  if (start < 0 ) {
    start = 0 ; 
    len = len - 1 ; 
  }
  (__funcarg111 = (
  strcmp (which , "ending " ) ) , FUNCCALL_EMPTY(do_out_of_range (name , scheme_primitive_realm , type , which , ! __funcarg111 , i , s , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (start ) ) ) << 1 ) | 0x1 ) ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2128 "bc/src/error.c"
static Scheme_Object * do_raise_range_error (const char * who , int argc , Scheme_Object * argv [] , int use_realm ) 
{
  Scheme_Object * type , * desc , * realm = scheme_default_realm ; 
  char * __funcarg112 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(type, 1), PUSH(argv, 2), PUSH(desc, 3)));
# define XfOrM296_COUNT (4)
# define SETUP_XfOrM296(x) SETUP(XfOrM296_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  type = NULLED_OUT ; 
  desc = NULLED_OUT ; 

# 2132 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 0 , argc , argv ) ); 
  if (use_realm ) {
#   define XfOrM298_COUNT (0+XfOrM296_COUNT)
#   define SETUP_XfOrM298(x) SETUP_XfOrM296(x)

# 2135 "bc/src/error.c"
    realm = argv [1 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 1 , argc , argv ) ); 
  }
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 + use_realm ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 + use_realm ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "string?" , 1 + use_realm , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 + use_realm ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 + use_realm ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "string?" , 2 + use_realm , argc , argv ) ); 
  if (! (((intptr_t ) (argv [3 + use_realm ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [3 + use_realm ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 + use_realm ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-integer?" , 3 + use_realm , argc , argv ) ); 
  if (! (((intptr_t ) (argv [5 + use_realm ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [5 + use_realm ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [5 + use_realm ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-integer?" , 5 + use_realm , argc , argv ) ); 
  if (! (((intptr_t ) (argv [6 + use_realm ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [6 + use_realm ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [6 + use_realm ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-integer?" , 6 + use_realm , argc , argv ) ); 
  if (argc > (7 + use_realm ) ) {
#   define XfOrM297_COUNT (0+XfOrM296_COUNT)
#   define SETUP_XfOrM297(x) SETUP_XfOrM296(x)

# 2150 "bc/src/error.c"
    if (! (((argv [7 + use_realm ] ) ) == (scheme_false ) ) && ! (((intptr_t ) (argv [7 + use_realm ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [7 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [7 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c exact-integer? #f)" , 7 + use_realm , argc , argv ) ); 
  }

  type = FUNCCALL(SETUP_XfOrM296(_), scheme_char_string_to_byte_string (argv [1 + use_realm ] ) ); 
  desc = FUNCCALL(SETUP_XfOrM296(_), scheme_char_string_to_byte_string (argv [2 + use_realm ] ) ); 
  (__funcarg112 = FUNCCALL(SETUP_XfOrM296(_), scheme_symbol_val (argv [0 ] ) )
  , FUNCCALL_AGAIN(do_out_of_range (__funcarg112 , realm , (((Scheme_Simple_Object * ) (type ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (desc ) ) -> u . byte_str_val . string_val ) , ((argc > (7 + use_realm ) ) && (! (((argv [7 + use_realm ] ) ) == (scheme_false ) ) ) ) , argv [3 + use_realm ] , argv [4 + use_realm ] , argv [7 + use_realm ] , argv [5 + use_realm ] , argv [6 + use_realm ] ) )) 








  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2171 "bc/src/error.c"
static Scheme_Object * raise_range_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2173 "bc/src/error.c"
  return do_raise_range_error ("raise-range-error" , argc , argv , 0 ) ; 
}

static Scheme_Object * raise_range_error_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2178 "bc/src/error.c"
  return do_raise_range_error ("raise-range-error*" , argc , argv , 1 ) ; 
}



void scheme_contract_error (const char * name , const char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  int i , cnt = 0 , kind ; 
  intptr_t len = 0 , nlen , mlen , seplen , vlen ; 
  const char * strs [5 ] , * str , * sep ; 
  Scheme_Object * vs [5 ] , * v ; 
  const char * v_strs [5 ] , * v_str ; 
  intptr_t v_str_lens [5 ] , v_str_len ; 
  char * s ; 
  Scheme_Object * realm = scheme_primitive_realm ; 
  PREPARE_VAR_STACK_ONCE(15);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(s, 1), PUSH(name, 2), PUSH(v_str, 3), PUSH(sep, 4), PUSHARRAY(vs, 5, 5), PUSH(msg, 8), PUSHARRAY(v_strs, 5, 9), PUSHARRAY(strs, 5, 12)));
# define XfOrM301_COUNT (15)
# define SETUP_XfOrM301(x) SETUP(XfOrM301_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (strs ) ; 
  str = NULLED_OUT ; 
  sep = NULLED_OUT ; 
  NULL_OUT_ARRAY (vs ) ; 
  v = NULLED_OUT ; 
  NULL_OUT_ARRAY (v_strs ) ; 
  v_str = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 2195 "bc/src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 

  if (name == ((const char * ) scheme_default_realm ) ) {
    name = HIDE_FROM_XFORM (__builtin_va_arg (args , const char * ) ) ; 
    realm = HIDE_FROM_XFORM (__builtin_va_arg (args , Scheme_Object * ) ) ; 
  }

  while (cnt < 5 ) {
    str = HIDE_FROM_XFORM (__builtin_va_arg (args , const char * ) ) ; 
    if (! str )

# 2204 "bc/src/error.c"
    break ; 
    strs [cnt ] = str ; 
    kind = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
    if (kind ) {
      v = HIDE_FROM_XFORM (__builtin_va_arg (args , Scheme_Object * ) ) ; 
      vs [cnt ++ ] = v ; 
    }

# 2210 "bc/src/error.c"
    else {
      str = HIDE_FROM_XFORM (__builtin_va_arg (args , const char * ) ) ; 
      v_strs [cnt ] = str ; 
      v_str_lens [cnt ] = strlen (str ) ; 
      vs [cnt ++ ] = ((void * ) 0 ) ; 
    }
  }
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM306_COUNT (0+XfOrM301_COUNT)
#   define SETUP_XfOrM306(x) SETUP_XfOrM301(x)

# 2220 "bc/src/error.c"
    if (vs [i ] ) {
#     define XfOrM307_COUNT (0+XfOrM306_COUNT)
#     define SETUP_XfOrM307(x) SETUP_XfOrM306(x)

# 2221 "bc/src/error.c"
      v_str = FUNCCALL(SETUP_XfOrM307(_), scheme_make_provided_string (vs [i ] , 1 , & v_str_len ) ); 
      v_strs [i ] = v_str ; 
      v_str_lens [i ] = v_str_len ; 
    }

# 2224 "bc/src/error.c"
    else 
    v_str_len = v_str_lens [i ] ; 
    len += v_str_len + 5 + strlen (strs [i ] ) ; 
  }

  sep = ": " ; 

  mlen = strlen (msg ) ; 
  nlen = strlen (name ) ; 
  seplen = strlen (sep ) ; 

  len += mlen + nlen + seplen + 10 ; 

  s = FUNCCALL(SETUP_XfOrM301(_), GC_malloc_atomic (len ) ); 
  len = 0 ; 
  (memcpy (s , name , nlen ) ) ; 
  len += nlen ; 
  (memcpy (s + len , sep , seplen ) ) ; 
  len += seplen ; 
  (memcpy (s + len , msg , mlen ) ) ; 
  len += mlen ; 
  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM303_COUNT (0+XfOrM301_COUNT)
#   define SETUP_XfOrM303(x) SETUP_XfOrM301(x)
    (
# 2246 "bc/src/error.c"
    memcpy (s + len , "\n  " , 3 ) ) ; 
    len += 3 ; 
    vlen = strlen (strs [i ] ) ; 
    (memcpy (s + len , strs [i ] , vlen ) ) ; 
    len += vlen ; 
    (memcpy (s + len , ": " , 2 ) ) ; 
    len += 2 ; 
    (memcpy (s + len , v_strs [i ] , v_str_lens [i ] ) ) ; 
    len += v_str_lens [i ] ; 
  }
  s [len ] = 0 ; 
  FUNCCALL(SETUP_XfOrM301(_), scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , nlen , realm , realm , "%t" , s , len ) )



  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2264 "bc/src/error.c"
void scheme_wrong_chaperoned (const char * who , const char * what , Scheme_Object * orig , Scheme_Object * naya ) 
{
  /* No conversion */

# 2266 "bc/src/error.c"
  char buf [128 ] ; 

  sprintf (buf , 
  "non-chaperone result;\n" 
  " received a %s that is not a chaperone of the original %s" , 
  what , what ) ; 

  scheme_contract_error (who , 
  buf , 
  "original" , 1 , orig , 
  "received" , 1 , naya , 
  ((void * ) 0 ) ) ; 
}

void scheme_system_error (const char * name , const char * what , int errid ) 
{
  /* No conversion */

# 2282 "bc/src/error.c"
  scheme_raise_realm_exn (MZEXN_FAIL , 
  strlen (name ) , scheme_primitive_realm , scheme_primitive_realm , 
  "%s: %s failed\n" 
  "  system error: %e" , 
  name , what , errid ) ; 
}

void scheme_rktio_error (const char * name , const char * what ) 
{
  /* No conversion */

# 2291 "bc/src/error.c"
  scheme_raise_realm_exn (MZEXN_FAIL , 
  strlen (name ) , scheme_primitive_realm , scheme_primitive_realm , 
  "%s: %s failed\n" 
  "  system error: %R" , 
  name , what ) ; 
}



static char * make_srcloc_string (Scheme_Object * src , intptr_t line , intptr_t col , intptr_t pos , intptr_t * len ) 
{
  char * srcstr , * result ; 
  intptr_t srclen , rlen ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(len, 0), PUSH(srcstr, 1), PUSH(src, 2), PUSH(result, 3)));
# define XfOrM318_COUNT (4)
# define SETUP_XfOrM318(x) SETUP(XfOrM318_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  srcstr = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 2305 "bc/src/error.c"
  if (! src || ((((src ) ) == (scheme_false ) ) && (pos < 0 ) ) ) {
    if (len )

# 2306 "bc/src/error.c"
    * len = 0 ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (src && ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#   define XfOrM322_COUNT (0+XfOrM318_COUNT)
#   define SETUP_XfOrM322(x) SETUP_XfOrM318(x)

# 2312 "bc/src/error.c"
    src = FUNCCALL(SETUP_XfOrM322(_), scheme_remove_current_directory_prefix (src ) ); 


    srclen = (((Scheme_Simple_Object * ) (src ) ) -> u . byte_str_val . tag_val ) ; 
    if (srclen > 100 ) {
#     define XfOrM323_COUNT (0+XfOrM322_COUNT)
#     define SETUP_XfOrM323(x) SETUP_XfOrM322(x)

# 2317 "bc/src/error.c"
      srcstr = FUNCCALL(SETUP_XfOrM323(_), GC_malloc_atomic (100 ) ); 
      (memcpy (srcstr , (((Scheme_Simple_Object * ) (src ) ) -> u . byte_str_val . string_val ) + (srclen - 100 ) , 
      100 ) ) ; 
      srcstr [0 ] = '.' ; 
      srcstr [1 ] = '.' ; 
      srcstr [2 ] = '.' ; 
      srclen = 100 ; 
    }

# 2324 "bc/src/error.c"
    else 
    srcstr = (((Scheme_Simple_Object * ) (src ) ) -> u . byte_str_val . string_val ) ; 
  }

# 2326 "bc/src/error.c"
  else 
  srcstr = FUNCCALL(SETUP_XfOrM318(_), scheme_display_to_string_w_max (src , & srclen , 100 ) ); 

  result = (char * ) FUNCCALL(SETUP_XfOrM318(_), GC_malloc_atomic (srclen + 15 ) ); 

  if (line >= 0 && col >= 0 ) {
#   define XfOrM321_COUNT (0+XfOrM318_COUNT)
#   define SETUP_XfOrM321(x) SETUP_XfOrM318(x)

# 2333 "bc/src/error.c"
    rlen = FUNCCALL(SETUP_XfOrM321(_), scheme_sprintf (result , srclen + 15 , "%t:%L%ld" , srcstr , srclen , line , col - 1 ) )
    ; 
  }

# 2335 "bc/src/error.c"
  else if (pos >= 0 ) {
#   define XfOrM320_COUNT (0+XfOrM318_COUNT)
#   define SETUP_XfOrM320(x) SETUP_XfOrM318(x)

# 2337 "bc/src/error.c"
    rlen = FUNCCALL(SETUP_XfOrM320(_), scheme_sprintf (result , srclen + 15 , "%t::%ld" , srcstr , srclen , pos ) )
    ; 
  }

# 2339 "bc/src/error.c"
  else {
#   define XfOrM319_COUNT (0+XfOrM318_COUNT)
#   define SETUP_XfOrM319(x) SETUP_XfOrM318(x)

# 2341 "bc/src/error.c"
    rlen = FUNCCALL(SETUP_XfOrM319(_), scheme_sprintf (result , srclen + 15 , "%t" , srcstr , srclen ) )
    ; 
  }

  if (len )

# 2345 "bc/src/error.c"
  * len = rlen ; 
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2349 "bc/src/error.c"
static char * make_stx_srcloc_string (Scheme_Stx_Srcloc * srcloc , intptr_t * len ) 
{
  /* No conversion */

# 2351 "bc/src/error.c"
  return make_srcloc_string (srcloc -> src , srcloc -> line , srcloc -> col , srcloc -> pos , len ) ; 
}

char * scheme_make_srcloc_string (Scheme_Object * stx , intptr_t * len ) 
{
  /* No conversion */

# 2356 "bc/src/error.c"
  return make_stx_srcloc_string (((Scheme_Stx * ) stx ) -> srcloc , len ) ; 
}

static intptr_t struct_number_ref (Scheme_Object * s , int pos ) 
{
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM327_COUNT (1)
# define SETUP_XfOrM327(x) SETUP(XfOrM327_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2361 "bc/src/error.c"
  s = FUNCCALL(SETUP_XfOrM327(_), scheme_struct_ref (s , pos ) ); 
  if (((s ) ) == (scheme_false ) ) 
    RET_VALUE_START (- 1 ) RET_VALUE_END ; 
  else 
  RET_VALUE_START ((((intptr_t ) (s ) ) >> 1 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2368 "bc/src/error.c"
Scheme_Object * srcloc_to_string (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * src ; 
  char * s ; 
  intptr_t len , line , col , pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(argv, 1), PUSH(src, 2)));
# define XfOrM328_COUNT (3)
# define SETUP_XfOrM328(x) SETUP(XfOrM328_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  src = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 2374 "bc/src/error.c"
  if (! FUNCCALL(SETUP_XfOrM328(_), scheme_is_location (argv [0 ] ) ))
    FUNCCALL_EMPTY(scheme_wrong_contract ("srcloc->string" , "srcloc?" , 0 , argc , argv ) ); 

  src = FUNCCALL(SETUP_XfOrM328(_), scheme_struct_ref (argv [0 ] , 0 ) ); 
  if (((src ) ) == (scheme_false ) ) 

# 2378 "bc/src/error.c"
  src = ((void * ) 0 ) ; 
  line = FUNCCALL(SETUP_XfOrM328(_), struct_number_ref (argv [0 ] , 1 ) ); 
  col = FUNCCALL_AGAIN(struct_number_ref (argv [0 ] , 2 ) ); 
  pos = FUNCCALL_AGAIN(struct_number_ref (argv [0 ] , 3 ) ); 

  s = FUNCCALL_AGAIN(make_srcloc_string (src , line , (col >= 0 ? col + 1 : - 1 ) , pos , & len ) ); 

  if (s )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (s , len ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2391 "bc/src/error.c"
static Scheme_Object * unquoted_printing_string (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1)));
# define XfOrM329_COUNT (2)
# define SETUP_XfOrM329(x) SETUP(XfOrM329_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 2395 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("unquoted-printing-string" , "string?" , 0 , argc , argv ) ); 

  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM329(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_unquoted_printing_string_type ; 
  (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) = argv [0 ] ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2405 "bc/src/error.c"
static Scheme_Object * unquoted_printing_string_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2407 "bc/src/error.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unquoted_printing_string_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * unquoted_printing_string_value (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2414 "bc/src/error.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unquoted_printing_string_type ) ) 
    return (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) ; 

  scheme_wrong_contract ("unquoted-printing-string-value" , "unquoted-printing-string?" , 0 , argc , argv ) ; 
  return ((void * ) 0 ) ; 
}

void scheme_read_err (Scheme_Object * port , 
const char * detail , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  Scheme_Object * pn ; 
  char * s , * fn ; 
  intptr_t slen ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(pn, 1), PUSH(s, 2), PUSH(fn, 3)));
# define XfOrM332_COUNT (4)
# define SETUP_XfOrM332(x) SETUP(XfOrM332_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pn = NULLED_OUT ; 
  s = NULLED_OUT ; 
  fn = NULLED_OUT ; 

# 2429 "bc/src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , detail ) ) ; 
  slen = FUNCCALL(SETUP_XfOrM332(_), sch_vsprintf (((void * ) 0 ) , 0 , detail , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  if (port ) {
#   define XfOrM333_COUNT (0+XfOrM332_COUNT)
#   define SETUP_XfOrM333(x) SETUP_XfOrM332(x)

# 2434 "bc/src/error.c"
    pn = FUNCCALL(SETUP_XfOrM333(_), scheme_input_port_record (port ) )-> name ; 
    if ((Scheme_Type ) (((((intptr_t ) (pn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pn ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#     define XfOrM334_COUNT (0+XfOrM333_COUNT)
#     define SETUP_XfOrM334(x) SETUP_XfOrM333(x)

# 2436 "bc/src/error.c"
      pn = FUNCCALL(SETUP_XfOrM334(_), scheme_remove_current_directory_prefix (pn ) ); 
      fn = (((Scheme_Simple_Object * ) (pn ) ) -> u . byte_str_val . string_val ) ; 
    }

# 2438 "bc/src/error.c"
    else 
    fn = ((void * ) 0 ) ; 
  }

# 2440 "bc/src/error.c"
  else 
  fn = ((void * ) 0 ) ; 

  if (fn )
    FUNCCALL(SETUP_XfOrM332(_), scheme_raise_realm_exn (MZEXN_FAIL_READ , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , scheme_null , "%t\n  in: %s" , s , slen , fn ) ); 
  else FUNCCALL(SETUP_XfOrM332(_), scheme_raise_realm_exn (MZEXN_FAIL_READ , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , scheme_null , "%t" , s , slen ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2449 "bc/src/error.c"
Scheme_Object * scheme_numr_err (Scheme_Object * complain , const char * detail , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * s ; 
  intptr_t slen ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(complain, 1)));
# define XfOrM335_COUNT (2)
# define SETUP_XfOrM335(x) SETUP(XfOrM335_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2455 "bc/src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , detail ) ) ; 
  slen = FUNCCALL(SETUP_XfOrM335(_), sch_vsprintf (((void * ) 0 ) , 0 , detail , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  if (((complain ) ) == (scheme_false ) ) 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM335(_), scheme_make_sized_utf8_string (s , slen ) )) RET_VALUE_END ; 
  FUNCCALL(SETUP_XfOrM335(_), scheme_read_err (complain , "read: %s" , s ) )
  ; 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2466 "bc/src/error.c"
static void do_wrong_syntax (const char * where , 
Scheme_Object * detail_form , 
Scheme_Object * form , 
char * s , intptr_t slen ) 
{
  intptr_t len , vlen , dvlen , blen , plen ; 
  char * buffer ; 
  char * v , * dv , * p ; 
  Scheme_Object * who ; 
  int show_src ; 
  Scheme_Config * __funcarg113 = NULLED_OUT ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(form, 1), PUSH(p, 2), PUSH(v, 3), PUSH(dv, 4), PUSH(s, 5), PUSH(buffer, 6), PUSH(detail_form, 7), PUSH(where, 8)));
# define XfOrM336_COUNT (9)
# define SETUP_XfOrM336(x) SETUP(XfOrM336_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  buffer = NULLED_OUT ; 
  v = NULLED_OUT ; 
  dv = NULLED_OUT ; 
  p = NULLED_OUT ; 
  who = NULLED_OUT ; 

# 2477 "bc/src/error.c"
  who = ((void * ) 0 ) ; 

  if (! s ) {
    s = "bad syntax" ; 
    slen = strlen (s ) ; 
  }

  buffer = FUNCCALL(SETUP_XfOrM336(_), init_buf (& len , & blen ) ); 

  p = ((void * ) 0 ) ; 
  plen = 0 ; 

  show_src = (! ((((__funcarg113 = FUNCCALL(SETUP_XfOrM336(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg113 , MZCONFIG_ERROR_PRINT_SRCLOC ) )) ) ) == (scheme_false ) ) ) ; 

  if (form ) {
    Scheme_Object * pform ; 
    BLOCK_SETUP((PUSH(pform, 0+XfOrM336_COUNT)));
#   define XfOrM345_COUNT (1+XfOrM336_COUNT)
#   define SETUP_XfOrM345(x) SETUP(XfOrM345_COUNT)
    pform = NULLED_OUT ; 

# 2493 "bc/src/error.c"
    if ((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) )  {
#     define XfOrM348_COUNT (0+XfOrM345_COUNT)
#     define SETUP_XfOrM348(x) SETUP_XfOrM345(x)

# 2494 "bc/src/error.c"
      p = FUNCCALL(SETUP_XfOrM348(_), make_stx_srcloc_string (((Scheme_Stx * ) form ) -> srcloc , & plen ) ); 
      pform = FUNCCALL(SETUP_XfOrM348(_), scheme_syntax_to_datum (form ) ); 


      if (! who && ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) ) {
        Scheme_Object * first ; 
        first = NULLED_OUT ; 

# 2500 "bc/src/error.c"
        if (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) 
          first = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
        else 
        first = form ; 
        if (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) first ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) 
          who = (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) first ) -> val : first ) ; 
      }
    }

# 2507 "bc/src/error.c"
    else {
      pform = form ; 
    }

    if (show_src )
      v = FUNCCALL(SETUP_XfOrM345(_), scheme_write_to_string_w_max (pform , & vlen , len ) ); 
    else {
      v = ((void * ) 0 ) ; 
      vlen = 0 ; 
    }
  }

# 2517 "bc/src/error.c"
  else {
    form = scheme_false ; 
    v = ((void * ) 0 ) ; 
    vlen = 0 ; 
  }

  if (detail_form ) {
    Scheme_Object * pform ; 
    BLOCK_SETUP((PUSH(pform, 0+XfOrM336_COUNT)));
#   define XfOrM341_COUNT (1+XfOrM336_COUNT)
#   define SETUP_XfOrM341(x) SETUP(XfOrM341_COUNT)
    pform = NULLED_OUT ; 

# 2525 "bc/src/error.c"
    if ((Scheme_Type ) (((((intptr_t ) (detail_form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (detail_form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) )  {
#     define XfOrM343_COUNT (0+XfOrM341_COUNT)
#     define SETUP_XfOrM343(x) SETUP_XfOrM341(x)

# 2526 "bc/src/error.c"
      if (((Scheme_Stx * ) detail_form ) -> srcloc -> line >= 0 )
        p = FUNCCALL(SETUP_XfOrM343(_), make_stx_srcloc_string (((Scheme_Stx * ) detail_form ) -> srcloc , & plen ) ); 
    }
    pform = FUNCCALL(SETUP_XfOrM341(_), scheme_syntax_to_datum (detail_form ) ); 


    if (show_src )
      dv = FUNCCALL(SETUP_XfOrM341(_), scheme_write_to_string_w_max (pform , & dvlen , len ) ); 
    else {
      dv = ((void * ) 0 ) ; 
      dvlen = 0 ; 
    }
  }

# 2538 "bc/src/error.c"
  else {
    dv = ((void * ) 0 ) ; 
    dvlen = 0 ; 
  }

  if (! who ) {
#   define XfOrM339_COUNT (0+XfOrM336_COUNT)
#   define SETUP_XfOrM339(x) SETUP_XfOrM336(x)

# 2544 "bc/src/error.c"
    if (where )
      who = FUNCCALL(SETUP_XfOrM339(_), scheme_intern_symbol (where ) ); 
    else 
    who = scheme_false ; 
  }

  if (! where ) {
#   define XfOrM338_COUNT (0+XfOrM336_COUNT)
#   define SETUP_XfOrM338(x) SETUP_XfOrM336(x)

# 2551 "bc/src/error.c"
    if (((who ) ) == (scheme_false ) ) 
      where = "?" ; 
    else 
    where = FUNCCALL(SETUP_XfOrM338(_), scheme_symbol_val (who ) ); 
  }

  if (v ) {
#   define XfOrM337_COUNT (0+XfOrM336_COUNT)
#   define SETUP_XfOrM337(x) SETUP_XfOrM336(x)

# 2558 "bc/src/error.c"
    if (dv )
      blen = FUNCCALL(SETUP_XfOrM337(_), scheme_sprintf (buffer , blen , "%t%s%s: %t\n" "  at: %t\n" "  in: %t" , p , plen , p ? ": " : "" , where , s , slen , dv , dvlen , v , vlen ) )








    ; 
    else 
    blen = FUNCCALL(SETUP_XfOrM337(_), scheme_sprintf (buffer , blen , "%t%s%s: %t\n" "  in: %t" , p , plen , p ? ": " : "" , where , s , slen , v , vlen ) )






    ; 
  }

# 2578 "bc/src/error.c"
  else if (dv )
    blen = FUNCCALL(SETUP_XfOrM336(_), scheme_sprintf (buffer , blen , "%t%s%s: %t\n" "  at: %t" , p , plen , p ? ": " : "" , where , s , slen , dv , dvlen ) )






  ; 
  else 
  blen = FUNCCALL(SETUP_XfOrM336(_), scheme_sprintf (buffer , blen , "%s: %t" , where , s , slen ) )

  ; 
  FUNCCALL_EMPTY(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , "%t" , buffer , blen ) )


  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2597 "bc/src/error.c"
void scheme_wrong_syntax (const char * where , 
Scheme_Object * detail_form , 
Scheme_Object * form , 
const char * detail , ... ) 
{
  char * s ; 
  intptr_t slen ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(form, 1), PUSH(detail_form, 2), PUSH(where, 3)));
# define XfOrM351_COUNT (4)
# define SETUP_XfOrM351(x) SETUP(XfOrM351_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2605 "bc/src/error.c"
  if (! detail ) {
    s = ((void * ) 0 ) ; 
    slen = 0 ; 
  }

# 2608 "bc/src/error.c"
  else {
    GC_CAN_IGNORE va_list args ; 
#   define XfOrM352_COUNT (0+XfOrM351_COUNT)
#   define SETUP_XfOrM352(x) SETUP_XfOrM351(x)

# 2611 "bc/src/error.c"
    HIDE_FROM_XFORM (__builtin_va_start (args , detail ) ) ; 
    slen = FUNCCALL(SETUP_XfOrM352(_), sch_vsprintf (((void * ) 0 ) , 0 , detail , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
    HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  }
  FUNCCALL(SETUP_XfOrM351(_), do_wrong_syntax (where , detail_form , form , s , slen ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2619 "bc/src/error.c"
void scheme_wrong_rator (Scheme_Object * rator , int argc , Scheme_Object * * argv ) 
{
  intptr_t slen , rlen ; 
  char * s , * r ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(argv, 1), PUSH(r, 2)));
# define XfOrM354_COUNT (3)
# define SETUP_XfOrM354(x) SETUP(XfOrM354_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 2624 "bc/src/error.c"
  r = FUNCCALL(SETUP_XfOrM354(_), scheme_make_provided_string (rator , 1 , & rlen ) ); 

  s = FUNCCALL_AGAIN(scheme_make_arg_lines_string ("   " , - 1 , argc , argv , & slen ) ); 
  FUNCCALL_EMPTY(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen ("application" ) , scheme_primitive_realm , scheme_primitive_realm , "%s: not a procedure;\n" " expected a procedure that can be applied to arguments\n" "  given: %t\n" "  arguments...:%t" , "application" , r , rlen , s , slen ) )







  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2638 "bc/src/error.c"
static void wrong_return_arity_for_realm (const char * where , 
Scheme_Object * realm , 
int expected , int got , 
Scheme_Object * * argv , 
const char * s , intptr_t slen ) 
{
  char * buffer , * v ; 
  intptr_t vlen , blen ; 
  int name_len ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(s, 1), PUSH(buffer, 2), PUSH(argv, 3), PUSH(v, 4), PUSH(where, 5)));
# define XfOrM355_COUNT (6)
# define SETUP_XfOrM355(x) SETUP(XfOrM355_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 2648 "bc/src/error.c"
  buffer = FUNCCALL(SETUP_XfOrM355(_), init_buf (((void * ) 0 ) , & blen ) ); 

  if (! got || ! argv ) {
    v = "" ; 
    vlen = 0 ; 
  }

# 2653 "bc/src/error.c"
  else {
    Scheme_Object * * array ; 
#   define XfOrM356_COUNT (0+XfOrM355_COUNT)
#   define SETUP_XfOrM356(x) SETUP_XfOrM355(x)
    array = NULLED_OUT ; 

# 2656 "bc/src/error.c"
    array = ((got == 1 ) ? (Scheme_Object * * ) (void * ) & argv : argv ) ; 

    v = FUNCCALL(SETUP_XfOrM356(_), scheme_make_arg_lines_string ("   " , - 1 , got , array , & vlen ) ); 
  }

  blen = FUNCCALL(SETUP_XfOrM355(_), scheme_sprintf (buffer , blen , "%s%sresult arity mismatch;\n" " expected number of values not received\n" "  expected: %d\n" "  received: %d" "%t\n" "  values...:%t" , where ? where : "" , where ? ": " : "" , expected , got , s , slen , v , vlen ) )
# 2674 "bc/src/error.c"
  ; 

  if (where )
    name_len = strlen (where ) ; 
  else 
  name_len = - 1 ; 
  FUNCCALL(SETUP_XfOrM355(_), scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT_ARITY , name_len , realm , scheme_primitive_realm , "%t" , buffer , blen ) )



  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2687 "bc/src/error.c"
void scheme_wrong_return_arity (const char * where , 
int expected , int got , 
Scheme_Object * * argv , 
const char * detail , ... ) 
{
  intptr_t slen ; 
  char * s ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(argv, 1), PUSH(where, 2)));
# define XfOrM358_COUNT (3)
# define SETUP_XfOrM358(x) SETUP(XfOrM358_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2695 "bc/src/error.c"
  if ((got != 1 ) && ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> values_buffer ) ) )

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> values_buffer = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array = ((void * ) 0 ) ; 

  if (! detail ) {
    s = ((void * ) 0 ) ; 
    slen = 0 ; 
  }

# 2703 "bc/src/error.c"
  else {
    GC_CAN_IGNORE va_list args ; 
#   define XfOrM359_COUNT (0+XfOrM358_COUNT)
#   define SETUP_XfOrM359(x) SETUP_XfOrM358(x)

# 2706 "bc/src/error.c"
    HIDE_FROM_XFORM (__builtin_va_start (args , detail ) ) ; 
    slen = FUNCCALL(SETUP_XfOrM359(_), sch_vsprintf (((void * ) 0 ) , 0 , detail , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
    HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  }
  FUNCCALL(SETUP_XfOrM358(_), wrong_return_arity_for_realm (where , scheme_primitive_realm , expected , got , argv , s , slen ) )



  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2717 "bc/src/error.c"
void scheme_non_fixnum_result (const char * name , Scheme_Object * o ) 
{
  /* No conversion */

# 2719 "bc/src/error.c"
  scheme_raise_exn (MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT , 
  "%s: result is not a fixnum\n" 
  "  result: %V" , 
  name , o ) ; 
}

void scheme_raise_out_of_memory (const char * where , const char * msg , ... ) 
{
  char * s ; 
  intptr_t slen , name_len ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(where, 1)));
# define XfOrM362_COUNT (2)
# define SETUP_XfOrM362(x) SETUP(XfOrM362_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2730 "bc/src/error.c"
  if (! msg ) {
    s = "" ; 
    slen = 0 ; 
  }

# 2733 "bc/src/error.c"
  else {
    GC_CAN_IGNORE va_list args ; 
#   define XfOrM363_COUNT (0+XfOrM362_COUNT)
#   define SETUP_XfOrM363(x) SETUP_XfOrM362(x)

# 2736 "bc/src/error.c"
    HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
    slen = FUNCCALL(SETUP_XfOrM363(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
    HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  }

  if (where )
    name_len = strlen (where ) + 2 ; 
  else 
  name_len = - 1 ; 
  FUNCCALL(SETUP_XfOrM362(_), scheme_raise_realm_exn (MZEXN_FAIL_OUT_OF_MEMORY , name_len , scheme_primitive_realm , scheme_primitive_realm , "%s%sout of memory %t" , where ? where : "" , where ? ": " : "" , s , slen ) )





  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2754 "bc/src/error.c"
void scheme_unbound_global (Scheme_Bucket * b ) 
{
  Scheme_Object * name = (Scheme_Object * ) b -> key ; 
  Scheme_Instance * home ; 
  Scheme_Config * __funcarg114 = NULLED_OUT ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(home, 1)));
# define XfOrM365_COUNT (2)
# define SETUP_XfOrM365(x) SETUP(XfOrM365_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  home = NULLED_OUT ; 

# 2759 "bc/src/error.c"
  home = (scheme_get_bucket_home (b ) ) ; 

  if (home ) {
    Scheme_Object * src_name ; 
    const char * errmsg ; 
    BLOCK_SETUP((PUSH(errmsg, 0+XfOrM365_COUNT), PUSH(src_name, 1+XfOrM365_COUNT)));
#   define XfOrM367_COUNT (2+XfOrM365_COUNT)
#   define SETUP_XfOrM367(x) SETUP(XfOrM367_COUNT)
    src_name = NULLED_OUT ; 
    errmsg = NULLED_OUT ; 

# 2765 "bc/src/error.c"
    src_name = FUNCCALL(SETUP_XfOrM367(_), scheme_hash_tree_get (home -> source_names , name ) ); 
    if (! src_name )
      src_name = name ; 

    if (! ((((__funcarg114 = FUNCCALL(SETUP_XfOrM367(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg114 , MZCONFIG_ERROR_PRINT_SRCLOC ) )) ) ) == (scheme_false ) ) )  {
      if (! ((name ) == (src_name ) ) )
        errmsg = ("%S: undefined;\n" 
      " cannot reference an identifier before its definition\n" 
      "  in module: %D\n" 
      "  internal name: %S" ) ; 
      else 
      errmsg = ("%S: undefined;\n" 
      " cannot reference an identifier before its definition\n" 
      "  in module: %D" ) ; 
    }

# 2779 "bc/src/error.c"
    else 
    errmsg = ("%S: undefined;\n" 
    " cannot reference an identifier before its definition%_%_" ) ; 
    FUNCCALL(SETUP_XfOrM367(_), scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT_VARIABLE , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (src_name ) ) ) -> len ) , local_realm_symbol , scheme_primitive_realm , name , errmsg , src_name , home -> name , name ) )






    ; 
  }

# 2790 "bc/src/error.c"
  else {
#   define XfOrM366_COUNT (0+XfOrM365_COUNT)
#   define SETUP_XfOrM366(x) SETUP_XfOrM365(x)
    FUNCCALL_EMPTY(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT_VARIABLE , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) , local_realm_symbol , scheme_primitive_realm , name , "%S: undefined;\n" " cannot reference undefined identifier" , name ) )


    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2800 "bc/src/error.c"
char * scheme_make_provided_string (Scheme_Object * o , int count , intptr_t * lenout ) 
{
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(lenout, 0), PUSH(o, 1)));
# define XfOrM369_COUNT (2)
# define SETUP_XfOrM369(x) SETUP(XfOrM369_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2804 "bc/src/error.c"
  len = FUNCCALL(SETUP_XfOrM369(_), scheme_get_print_width () ); 

  if (count )
    len /= count ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(error_write_to_string_w_max (o , len , lenout ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2812 "bc/src/error.c"
static char * make_provided_list (Scheme_Object * o , int count , intptr_t * lenout ) 
{
  intptr_t len , cnt , i , onelen , total , sz ; 
  char * s , * accum , * naya ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(s, 1), PUSH(lenout, 2), PUSH(o, 3), PUSH(accum, 4)));
# define XfOrM370_COUNT (5)
# define SETUP_XfOrM370(x) SETUP(XfOrM370_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  accum = NULLED_OUT ; 
  naya = NULLED_OUT ; 

# 2817 "bc/src/error.c"
  cnt = (scheme_proper_list_length (o ) ) ; 
  if (cnt < 0 )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_provided_string (o , count , lenout ) )) RET_VALUE_EMPTY_END ; 

  if (! cnt ) {
    * lenout = 0 ; 
    RET_VALUE_START ("" ) RET_VALUE_END ; 
  }

  len = FUNCCALL(SETUP_XfOrM370(_), scheme_get_print_width () ); 

  if (count )
    len /= count ; 

  total = 0 ; 
  sz = 64 ; 
  accum = (char * ) FUNCCALL(SETUP_XfOrM370(_), GC_malloc_atomic (sz ) ); 

  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM373_COUNT (0+XfOrM370_COUNT)
#   define SETUP_XfOrM373(x) SETUP_XfOrM370(x)

# 2836 "bc/src/error.c"
    s = FUNCCALL(SETUP_XfOrM373(_), scheme_write_to_string_w_max ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) , & onelen , len / cnt ) ); 
    if (total + onelen + 1 >= sz ) {
#     define XfOrM374_COUNT (0+XfOrM373_COUNT)
#     define SETUP_XfOrM374(x) SETUP_XfOrM373(x)

# 2838 "bc/src/error.c"
      sz = (2 * sz ) + onelen + 1 ; 
      naya = (char * ) FUNCCALL(SETUP_XfOrM374(_), GC_malloc_atomic (sz ) ); 
      (memcpy (naya , accum , total ) ) ; 
      accum = naya ; 
    }
    (memcpy (accum + total , s , onelen ) ) ; 
    accum [total + onelen ] = ' ' ; 
    total += onelen + 1 ; 
    o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
  }

  total -= 1 ; 
  accum [total ] = 0 ; 
  * lenout = total ; 

  RET_VALUE_START (accum ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2856 "bc/src/error.c"
static Scheme_Object * do_error (const char * who , int mode , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * newargs [2 ] ; 
  Scheme_Object * __funcarg117 = NULLED_OUT ; 
  Scheme_Object * __funcarg116 = NULLED_OUT ; 
  Scheme_Object * __funcarg115 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(__funcarg116, 0), PUSHARRAY(newargs, 2, 1), PUSH(argv, 4), PUSH(who, 5)));
# define XfOrM376_COUNT (6)
# define SETUP_XfOrM376(x) SETUP(XfOrM376_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  newargs[0] = NULLED_OUT ; 
  newargs[1] = NULLED_OUT ; 

# 2860 "bc/src/error.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#   define XfOrM380_COUNT (0+XfOrM376_COUNT)
#   define SETUP_XfOrM380(x) SETUP_XfOrM376(x)

# 2861 "bc/src/error.c"
    if (argc < 2 ) {
      const char * s ; 
      int l ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM380_COUNT)));
#     define XfOrM382_COUNT (1+XfOrM380_COUNT)
#     define SETUP_XfOrM382(x) SETUP(XfOrM382_COUNT)
      s = NULLED_OUT ; 

# 2865 "bc/src/error.c"
      s = FUNCCALL(SETUP_XfOrM382(_), scheme_symbol_val (argv [0 ] ) ); 
      l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> len ) ; 


      newargs [0 ] = (__funcarg116 = FUNCCALL(SETUP_XfOrM382(_), scheme_make_utf8_string ("error: " ) )
      , __funcarg117 = FUNCCALL(SETUP_XfOrM382(_), scheme_make_sized_utf8_string ((char * ) s , l ) ), FUNCCALL_AGAIN(scheme_append_char_string (__funcarg116 , __funcarg117 ) )) 
      ; 

      ((((Scheme_Inclhash_Object * ) (newargs [0 ] ) ) -> so . keyex |= 0x1 ) ) ; 
    }

# 2874 "bc/src/error.c"
    else {
      char * s , * r ; 
      intptr_t l , l2 ; 
      Scheme_Object * port ; 
      BLOCK_SETUP((PUSH(port, 0+XfOrM380_COUNT), PUSH(s, 1+XfOrM380_COUNT), PUSH(r, 2+XfOrM380_COUNT)));
#     define XfOrM381_COUNT (3+XfOrM380_COUNT)
#     define SETUP_XfOrM381(x) SETUP(XfOrM381_COUNT)
      s = NULLED_OUT ; 
      r = NULLED_OUT ; 
      port = NULLED_OUT ; 

# 2878 "bc/src/error.c"
      port = FUNCCALL(SETUP_XfOrM381(_), scheme_make_byte_string_output_port () ); 


      if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
        FUNCCALL(SETUP_XfOrM381(_), scheme_wrong_contract (who , "string?" , 1 , argc , argv ) ); 
      FUNCCALL(SETUP_XfOrM381(_), scheme_do_format (who , port , ((void * ) 0 ) , - 1 , 1 , 2 , argc , argv ) )
      ; 

      s = FUNCCALL_AGAIN(scheme_get_sized_byte_string_output (port , & l ) ); 

      l2 = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> len ) ; 
      r = ((char * ) FUNCCALL(SETUP_XfOrM381(_), GC_malloc_atomic (sizeof (char ) * (l + l2 + 3 ) ) )) ; 
      (memcpy (r , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> s ) , l2 ) ) ; 
      (memcpy (r + l2 , ": " , 2 ) ) ; 
      (memcpy (r + l2 + 2 , s , l + 1 ) ) ; 

      newargs [0 ] = FUNCCALL(SETUP_XfOrM381(_), scheme_make_immutable_sized_utf8_string (r , l + l2 + 2 ) ); 
    }
  }

# 2896 "bc/src/error.c"
  else {
    Scheme_Object * strout ; 
    char * str ; 
    intptr_t len , i ; 
    BLOCK_SETUP((PUSH(str, 0+XfOrM376_COUNT), PUSH(strout, 1+XfOrM376_COUNT)));
#   define XfOrM377_COUNT (2+XfOrM376_COUNT)
#   define SETUP_XfOrM377(x) SETUP(XfOrM377_COUNT)
    strout = NULLED_OUT ; 
    str = NULLED_OUT ; 

# 2902 "bc/src/error.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
      FUNCCALL(SETUP_XfOrM377(_), scheme_wrong_contract (who , "(or/c string? symbol?)" , 0 , argc , argv ) ); 

    strout = FUNCCALL(SETUP_XfOrM377(_), scheme_make_byte_string_output_port () ); 
    FUNCCALL_AGAIN(scheme_internal_display (argv [0 ] , strout ) )
    ; 
    for (i = 1 ; i < argc ; i ++ ) {
#     define XfOrM379_COUNT (0+XfOrM377_COUNT)
#     define SETUP_XfOrM379(x) SETUP_XfOrM377(x)
      FUNCCALL(SETUP_XfOrM379(_), scheme_write_byte_string (" " , 1 , strout ) )
# 2909 "bc/src/error.c"
      ; 
      FUNCCALL(SETUP_XfOrM379(_), scheme_internal_write (argv [i ] , strout ) ); 
    }

    str = FUNCCALL(SETUP_XfOrM377(_), scheme_get_sized_byte_string_output (strout , & len ) ); 
    newargs [0 ] = FUNCCALL(SETUP_XfOrM377(_), scheme_make_immutable_sized_utf8_string (str , len ) ); 
  }

  newargs [1 ] = scheme_parameterization_key ; 
  (__funcarg115 = FUNCCALL(SETUP_XfOrM376(_), scheme_make_struct_instance (exn_table [mode ] . type , 2 , newargs ) )
  , FUNCCALL_AGAIN(do_raise (__funcarg115 , 1 , 1 ) )) 

  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2926 "bc/src/error.c"
static Scheme_Object * error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2928 "bc/src/error.c"
  return do_error ("error" , MZEXN_FAIL , argc , argv ) ; 
}

static Scheme_Object * assert_unreachable (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2933 "bc/src/error.c"
  scheme_contract_error ("assert-unreachable" , "unreachable code reached" , ((void * ) 0 ) ) ; 
  return scheme_void ; 
}

static Scheme_Object * raise_user_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2939 "bc/src/error.c"
  return do_error ("raise-user-error" , MZEXN_FAIL_USER , argc , argv ) ; 
}

typedef void (* wrong_proc_t ) (const char * name , Scheme_Object * realm , const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) ; 

static Scheme_Object * do_raise_type_error (const char * name , int argc , Scheme_Object * argv [] , int mode , int realm_arg ) 
{
  wrong_proc_t wrong ; 
  int negate = 0 ; 
  Scheme_Object * realm = scheme_default_realm ; 
  char * __funcarg119 = NULLED_OUT ; 
  char * __funcarg118 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(name, 1), PUSH(argv, 2)));
# define XfOrM386_COUNT (3)
# define SETUP_XfOrM386(x) SETUP(XfOrM386_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2952 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "symbol?" , 0 , argc , argv ) ); 
  if (realm_arg ) {
#   define XfOrM392_COUNT (0+XfOrM386_COUNT)
#   define SETUP_XfOrM392(x) SETUP_XfOrM386(x)

# 2955 "bc/src/error.c"
    realm = argv [1 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "symbol?" , 1 , argc , argv ) ); 
  }
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 + realm_arg ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 + realm_arg ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "string?" , 1 + realm_arg , argc , argv ) ); 

  switch (mode ) {
    case 0 : wrong = wrong_type_for_realm ; 

# 2963 "bc/src/error.c"
    break ; 
    case 1 : wrong = wrong_contract_for_realm ; 

# 2964 "bc/src/error.c"
    break ; 
    case 2 : wrong = wrong_contract_for_realm ; 

# 2965 "bc/src/error.c"
    negate = 1 ; 

# 2965 "bc/src/error.c"
    break ; 
    default : wrong = ((void * ) 0 ) ; 

# 2966 "bc/src/error.c"
    break ; 
  }

  if (argc == (3 + realm_arg ) ) {
    Scheme_Object * v , * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM386_COUNT), PUSH(v, 1+XfOrM386_COUNT)));
#   define XfOrM390_COUNT (2+XfOrM386_COUNT)
#   define SETUP_XfOrM390(x) SETUP(XfOrM390_COUNT)
    v = NULLED_OUT ; 
    s = NULLED_OUT ; 

# 2971 "bc/src/error.c"
    v = argv [2 + realm_arg ] ; 
    s = FUNCCALL(SETUP_XfOrM390(_), scheme_char_string_to_byte_string (argv [1 + realm_arg ] ) ); 
    (__funcarg119 = FUNCCALL(SETUP_XfOrM390(_), scheme_symbol_val (argv [0 ] ) ), FUNCCALL_AGAIN(wrong (__funcarg119 , realm , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , negate ? - 2 : - 1 , 0 , & v ) )) 

    ; 
  }

# 2976 "bc/src/error.c"
  else {
    Scheme_Object * * args , * s ; 
    int i ; 
    BLOCK_SETUP((PUSH(args, 0+XfOrM386_COUNT), PUSH(s, 1+XfOrM386_COUNT)));
#   define XfOrM387_COUNT (2+XfOrM386_COUNT)
#   define SETUP_XfOrM387(x) SETUP(XfOrM387_COUNT)
    args = NULLED_OUT ; 
    s = NULLED_OUT ; 

# 2980 "bc/src/error.c"
    if (! ((((intptr_t ) (argv [2 + realm_arg ] ) ) & 0x1 ) && ((((intptr_t ) (argv [2 + realm_arg ] ) ) >> 1 ) >= 0 ) ) 
    && ! (((Scheme_Type ) (((((intptr_t ) (argv [2 + realm_arg ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 + realm_arg ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [2 + realm_arg ] ) -> iso ) -> so . keyex & 0x1 ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "exact-nonnegative-integer?" , 2 + realm_arg , argc , argv ) ); 

    if (((((intptr_t ) (argv [2 + realm_arg ] ) ) & 0x1 ) && ((((intptr_t ) (argv [2 + realm_arg ] ) ) >> 1 ) >= argc - (3 + realm_arg ) ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (argv [2 + realm_arg ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 + realm_arg ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
      FUNCCALL_EMPTY(scheme_contract_error (name , (negate ? "position index >= provided result count" : "position index >= provided argument count" ) , "position index" , 1 , argv [2 + realm_arg ] , (negate ? "provided result count" : "provided argument count" ) , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (argc - (3 + realm_arg ) ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )







    ; 

    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM387(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - (3 + realm_arg ) ) ) )) ; 
    for (i = 3 + realm_arg ; i < argc ; i ++ ) {
      args [i - (3 + realm_arg ) ] = argv [i ] ; 
    }

    s = FUNCCALL(SETUP_XfOrM387(_), scheme_char_string_to_byte_string (argv [1 + realm_arg ] ) ); 
    (__funcarg118 = FUNCCALL(SETUP_XfOrM387(_), scheme_symbol_val (argv [0 ] ) )
    , FUNCCALL_AGAIN(wrong (__funcarg118 , realm , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , (((intptr_t ) (argv [2 + realm_arg ] ) ) >> 1 ) , negate ? (3 + realm_arg - argc ) : (argc - (3 + realm_arg ) ) , args ) )) 


    ; 
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3012 "bc/src/error.c"
static Scheme_Object * raise_type_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3014 "bc/src/error.c"
  return do_raise_type_error ("raise-type-error" , argc , argv , 0 , 0 ) ; 
}

static Scheme_Object * raise_argument_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3019 "bc/src/error.c"
  return do_raise_type_error ("raise-argument-error" , argc , argv , 1 , 0 ) ; 
}

static Scheme_Object * raise_argument_error_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3024 "bc/src/error.c"
  return do_raise_type_error ("raise-argument-error*" , argc , argv , 1 , 1 ) ; 
}

static Scheme_Object * raise_result_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3029 "bc/src/error.c"
  return do_raise_type_error ("raise-result-error" , argc , argv , 2 , 0 ) ; 
}

static Scheme_Object * raise_result_error_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3034 "bc/src/error.c"
  return do_raise_type_error ("raise-result-error*" , argc , argv , 2 , 1 ) ; 
}

static Scheme_Object * do_raise_mismatch_error (const char * who , int mismatch , int argc , Scheme_Object * argv [] , 
int use_realm ) 
{
  Scheme_Object * s ; 
  int i ; 
  char * s2 ; 
  intptr_t l2 ; 
  Scheme_Object * realm = scheme_default_realm ; 
  char * __funcarg120 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(s, 1), PUSH(s2, 2), PUSH(argv, 3)));
# define XfOrM398_COUNT (4)
# define SETUP_XfOrM398(x) SETUP(XfOrM398_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  s2 = NULLED_OUT ; 

# 3046 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 0 , argc , argv ) ); 
  if (use_realm ) {
#   define XfOrM423_COUNT (0+XfOrM398_COUNT)
#   define SETUP_XfOrM423(x) SETUP_XfOrM398(x)

# 3049 "bc/src/error.c"
    realm = argv [1 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 1 , argc , argv ) ); 
  }
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 + use_realm ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 + use_realm ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "string?" , 1 + use_realm , argc , argv ) ); 


  for (i = 2 + use_realm + mismatch ; i < argc ; i += 2 ) {
#   define XfOrM422_COUNT (0+XfOrM398_COUNT)
#   define SETUP_XfOrM422(x) SETUP_XfOrM398(x)

# 3058 "bc/src/error.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "string?" , i , argc , argv ) ); 
  }

  if (! mismatch && ((argc + use_realm ) & 1 ) ) {
#   define XfOrM420_COUNT (0+XfOrM398_COUNT)
#   define SETUP_XfOrM420(x) SETUP_XfOrM398(x)
    FUNCCALL_EMPTY(scheme_contract_error (who , "missing value after field string" , "field string" , 1 , argv [argc - 1 ] , ((void * ) 0 ) ) )
    ; 
  }

  if (! mismatch && (argc == 2 ) ) {

    char * name ; 
    BLOCK_SETUP((PUSH(name, 0+XfOrM398_COUNT)));
#   define XfOrM419_COUNT (1+XfOrM398_COUNT)
#   define SETUP_XfOrM419(x) SETUP(XfOrM419_COUNT)
    name = NULLED_OUT ; 

# 3073 "bc/src/error.c"
    s = FUNCCALL(SETUP_XfOrM419(_), scheme_char_string_to_byte_string (argv [1 + use_realm ] ) ); 

    name = FUNCCALL_AGAIN(scheme_symbol_val (argv [0 ] ) ); 
    FUNCCALL_AGAIN(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: %T" , name , s ) )



    ; 
  }

# 3081 "bc/src/error.c"
  else if (mismatch && (argc == 3 ) ) {
#   define XfOrM418_COUNT (0+XfOrM398_COUNT)
#   define SETUP_XfOrM418(x) SETUP_XfOrM398(x)

# 3083 "bc/src/error.c"
    s = FUNCCALL(SETUP_XfOrM418(_), scheme_char_string_to_byte_string (argv [1 + use_realm ] ) ); 
    (__funcarg120 = FUNCCALL(SETUP_XfOrM418(_), scheme_symbol_val (argv [0 ] ) )
    , FUNCCALL_AGAIN(arg_mismatch_at_realm (__funcarg120 , realm , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , argv [2 + use_realm ] ) )) 


    ; 
  }

# 3089 "bc/src/error.c"
  else {

    char * st , * * ss , * name ; 
    intptr_t slen , * slens , total = 0 ; 
    int offset = (mismatch ? 0 : 1 ) ; 
    int scount = argc - (1 + use_realm ) - offset ; 
    BLOCK_SETUP((PUSH(slens, 0+XfOrM398_COUNT), PUSH(name, 1+XfOrM398_COUNT), PUSH(ss, 2+XfOrM398_COUNT), PUSH(st, 3+XfOrM398_COUNT)));
#   define XfOrM399_COUNT (4+XfOrM398_COUNT)
#   define SETUP_XfOrM399(x) SETUP(XfOrM399_COUNT)
    st = NULLED_OUT ; 
    ss = NULLED_OUT ; 
    name = NULLED_OUT ; 
    slens = NULLED_OUT ; 

# 3096 "bc/src/error.c"
    ss = (char * * ) ((char * * ) FUNCCALL(SETUP_XfOrM399(_), GC_malloc (sizeof (char * ) * (scount ) ) )) ; 
    slens = (intptr_t * ) ((intptr_t * ) FUNCCALL(SETUP_XfOrM399(_), GC_malloc_atomic (sizeof (intptr_t ) * (scount ) ) )) ; 

    for (i = 1 + use_realm ; (i + offset ) < argc ; i ++ ) {
#     define XfOrM413_COUNT (0+XfOrM399_COUNT)
#     define SETUP_XfOrM413(x) SETUP_XfOrM399(x)

# 3100 "bc/src/error.c"
      if ((i + use_realm ) & 1 ) {
#       define XfOrM417_COUNT (0+XfOrM413_COUNT)
#       define SETUP_XfOrM417(x) SETUP_XfOrM413(x)

# 3101 "bc/src/error.c"
        s = FUNCCALL(SETUP_XfOrM417(_), scheme_char_string_to_byte_string (argv [i + offset ] ) ); 
        st = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) ; 
        slen = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) ; 
        if (! mismatch )
          total += 5 ; 
      }

# 3106 "bc/src/error.c"
      else {
#       define XfOrM414_COUNT (0+XfOrM413_COUNT)
#       define SETUP_XfOrM414(x) SETUP_XfOrM413(x)

# 3107 "bc/src/error.c"
        s = argv [i + offset ] ; 
        if ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_unquoted_printing_string_type ) )  {
#         define XfOrM416_COUNT (0+XfOrM414_COUNT)
#         define SETUP_XfOrM416(x) SETUP_XfOrM414(x)

# 3109 "bc/src/error.c"
          s = (((Scheme_Small_Object * ) (s ) ) -> u . ptr_val ) ; 
          s = FUNCCALL(SETUP_XfOrM416(_), scheme_char_string_to_byte_string (s ) ); 
          st = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) ; 
          slen = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) ; 
        }

# 3113 "bc/src/error.c"
        else {
#         define XfOrM415_COUNT (0+XfOrM414_COUNT)
#         define SETUP_XfOrM415(x) SETUP_XfOrM414(x)

# 3114 "bc/src/error.c"
          st = FUNCCALL(SETUP_XfOrM415(_), scheme_make_provided_string (s , scount / 2 , & slen ) ); 
        }
      }
      total += slen ; 
      ss [i - (1 + use_realm ) ] = st ; 
      slens [i - (1 + use_realm ) ] = slen ; 
    }
    st = (char * ) FUNCCALL(SETUP_XfOrM399(_), GC_malloc_atomic (total + 1 ) ); 

    total = 0 ; 
    for (i = 0 ; i < scount ; i ++ ) {
#     define XfOrM405_COUNT (0+XfOrM399_COUNT)
#     define SETUP_XfOrM405(x) SETUP_XfOrM399(x)

# 3125 "bc/src/error.c"
      slen = slens [i ] ; 
      if (! mismatch && ! (i & 1 ) ) {
#       define XfOrM407_COUNT (0+XfOrM405_COUNT)
#       define SETUP_XfOrM407(x) SETUP_XfOrM405(x)
        (
# 3127 "bc/src/error.c"
        memcpy (st + total , "\n   " , 3 ) ) ; 
        total += 3 ; 
      }
      (memcpy (st + total , ss [i ] , slen ) ) ; 
      total += slen ; 
      if (! mismatch && ! (i & 1 ) ) {
#       define XfOrM406_COUNT (0+XfOrM405_COUNT)
#       define SETUP_XfOrM406(x) SETUP_XfOrM405(x)
        (
# 3133 "bc/src/error.c"
        memcpy (st + total , ": " , 2 ) ) ; 
        total += 2 ; 
      }
    }
    st [total ] = 0 ; 

    s = FUNCCALL(SETUP_XfOrM399(_), scheme_char_string_to_byte_string (argv [1 + use_realm ] ) ); 
    if (mismatch ) {
      s2 = "" ; 
      l2 = 0 ; 
    }

# 3143 "bc/src/error.c"
    else {
      s2 = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) ; 
      l2 = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) ; 
    }

    name = FUNCCALL(SETUP_XfOrM399(_), scheme_symbol_val (argv [0 ] ) ); 
    FUNCCALL_EMPTY(scheme_raise_realm_exn (MZEXN_FAIL_CONTRACT , strlen (name ) , realm , realm , "%s: %t%t" , name , s2 , l2 , st , total ) )





    ; 
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3161 "bc/src/error.c"
static Scheme_Object * raise_mismatch_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3163 "bc/src/error.c"
  return do_raise_mismatch_error ("raise-mismatch-error" , 1 , argc , argv , 0 ) ; 
}

static Scheme_Object * raise_arguments_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3168 "bc/src/error.c"
  return do_raise_mismatch_error ("raise-arguments-error" , 0 , argc , argv , 0 ) ; 
}

static Scheme_Object * raise_arguments_error_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3173 "bc/src/error.c"
  return do_raise_mismatch_error ("raise-arguments-error*" , 0 , argc , argv , 1 ) ; 
}


static int is_arity_at_least (Scheme_Object * v ) 
{
  /* No conversion */

# 3179 "bc/src/error.c"
  return (((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && scheme_is_struct_instance (scheme_arity_at_least , v ) 
  && scheme_nonneg_exact_p (((Scheme_Structure * ) v ) -> slots [0 ] ) ) ; 
}

static int is_arity_list (Scheme_Object * l ) 
{
  int c ; 
  Scheme_Object * a ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(a, 1)));
# define XfOrM428_COUNT (2)
# define SETUP_XfOrM428(x) SETUP(XfOrM428_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 3189 "bc/src/error.c"
  c = (scheme_proper_list_length (l ) ) ; 
  if (c < 0 )

# 3190 "bc/src/error.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
  while (! ((l ) == (scheme_null ) ) ) {
#   define XfOrM430_COUNT (0+XfOrM428_COUNT)
#   define SETUP_XfOrM430(x) SETUP_XfOrM428(x)

# 3192 "bc/src/error.c"
    a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    if (! FUNCCALL(SETUP_XfOrM430(_), scheme_nonneg_exact_p (a ) )
    && ! FUNCCALL(SETUP_XfOrM430(_), is_arity_at_least (a ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3202 "bc/src/error.c"
static Scheme_Object * do_raise_arity_error (const char * who , int argc , Scheme_Object * argv [] , int as_arity , int use_realm ) 
{
  Scheme_Object * * args , * arity , * realm = scheme_default_realm ; 
  const char * name ; 
  int minc , maxc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(name, 1), PUSH(args, 2), PUSH(arity, 3), PUSH(argv, 4), PUSH(who, 5)));
# define XfOrM431_COUNT (6)
# define SETUP_XfOrM431(x) SETUP(XfOrM431_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  args = NULLED_OUT ; 
  arity = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 3208 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? procedure?)" , 0 , argc , argv ) ); 
  if (use_realm ) {
#   define XfOrM440_COUNT (0+XfOrM431_COUNT)
#   define SETUP_XfOrM440(x) SETUP_XfOrM431(x)

# 3211 "bc/src/error.c"
    realm = argv [1 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 1 , argc , argv ) ); 
  }
  if (as_arity ) {
#   define XfOrM439_COUNT (0+XfOrM431_COUNT)
#   define SETUP_XfOrM439(x) SETUP_XfOrM431(x)

# 3216 "bc/src/error.c"
    arity = argv [1 + use_realm ] ; 
    if (! FUNCCALL(SETUP_XfOrM439(_), scheme_nonneg_exact_p (arity ) )
    && ! FUNCCALL(SETUP_XfOrM439(_), is_arity_at_least (arity ) )
    && ! FUNCCALL(SETUP_XfOrM439(_), is_arity_list (arity ) ))
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c exact-nonnegative-integer? arity-at-least? (listof (or/c exact-nonnegative-integer? arity-at-least?)))" , 1 + use_realm , argc , argv ) )

    ; 
  }

# 3223 "bc/src/error.c"
  else {
#   define XfOrM438_COUNT (0+XfOrM431_COUNT)
#   define SETUP_XfOrM438(x) SETUP_XfOrM431(x)

# 3224 "bc/src/error.c"
    if (! FUNCCALL(SETUP_XfOrM438(_), scheme_exact_p (argv [1 + use_realm ] ) ))
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-integer?" , 1 + use_realm , argc , argv ) )

    ; 
    arity = FUNCCALL(SETUP_XfOrM438(_), scheme_arity_mask_to_arity (argv [1 + use_realm ] , - 1 ) ); 
  }

  args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM431(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - (2 + use_realm ) ) ) )) ; 
  (memcpy (args , argv + 2 + use_realm , sizeof (Scheme_Object * ) * (argc - (2 + use_realm ) ) ) ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    name = FUNCCALL(SETUP_XfOrM431(_), scheme_symbol_val (argv [0 ] ) ); 
  else {
    int len ; 
#   define XfOrM437_COUNT (0+XfOrM431_COUNT)
#   define SETUP_XfOrM437(x) SETUP_XfOrM431(x)

# 3238 "bc/src/error.c"
    name = FUNCCALL(SETUP_XfOrM437(_), scheme_get_proc_name (argv [0 ] , & len , 1 ) ); 
    if (! use_realm && (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      realm = FUNCCALL(SETUP_XfOrM437(_), scheme_get_proc_realm (argv [1 ] ) ); 
  }

  if (((intptr_t ) (arity ) ) & 0x1 )  {
    minc = maxc = (((intptr_t ) (arity ) ) >> 1 ) ; 
  }

# 3245 "bc/src/error.c"
  else if (FUNCCALL(SETUP_XfOrM431(_), is_arity_at_least (arity ) )) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM431_COUNT)));
#   define XfOrM433_COUNT (1+XfOrM431_COUNT)
#   define SETUP_XfOrM433(x) SETUP(XfOrM433_COUNT)
    v = NULLED_OUT ; 

# 3247 "bc/src/error.c"
    v = FUNCCALL(SETUP_XfOrM433(_), scheme_struct_ref (arity , 0 ) ); 
    if (((intptr_t ) (v ) ) & 0x1 )  {
      minc = (((intptr_t ) (v ) ) >> 1 ) ; 
      maxc = - 1 ; 
    }

# 3251 "bc/src/error.c"
    else {
      minc = - 2 ; 
      maxc = 0 ; 
    }
  }

# 3255 "bc/src/error.c"
  else {
    minc = - 2 ; 
    maxc = 0 ; 
  }
  FUNCCALL_EMPTY(wrong_count_for_realm (name , realm , minc , maxc , argc - (2 + use_realm ) , args , 0 ) )
  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3265 "bc/src/error.c"
static Scheme_Object * raise_arity_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3267 "bc/src/error.c"
  return do_raise_arity_error ("raise-arity-error" , argc , argv , 1 , 0 ) ; 
}

static Scheme_Object * raise_arity_mask_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3272 "bc/src/error.c"
  return do_raise_arity_error ("raise-arity-mask-error" , argc , argv , 0 , 0 ) ; 
}

static Scheme_Object * raise_arity_error_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3277 "bc/src/error.c"
  return do_raise_arity_error ("raise-arity-error*" , argc , argv , 1 , 1 ) ; 
}

static Scheme_Object * raise_arity_mask_error_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3282 "bc/src/error.c"
  return do_raise_arity_error ("raise-arity-mask-error*" , argc , argv , 0 , 1 ) ; 
}

static Scheme_Object * do_raise_result_arity_error (const char * who , int argc , Scheme_Object * argv [] , int use_realm ) 
{
  const char * where = ((void * ) 0 ) , * detail = ((void * ) 0 ) ; 
  Scheme_Object * * got_argv , * realm = scheme_default_realm ; 
  int i , expected ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(got_argv, 1), PUSH(detail, 2), PUSH(argv, 3), PUSH(who, 4), PUSH(where, 5)));
# define XfOrM445_COUNT (6)
# define SETUP_XfOrM445(x) SETUP(XfOrM445_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  got_argv = NULLED_OUT ; 

# 3291 "bc/src/error.c"
  if (((argv [0 ] ) ) == (scheme_false ) ) 
    where = ((void * ) 0 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    where = FUNCCALL(SETUP_XfOrM445(_), scheme_symbol_val (argv [0 ] ) ); 
  else FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? #f)" , 0 , argc , argv ) )
  ; 

  if (use_realm ) {
#   define XfOrM450_COUNT (0+XfOrM445_COUNT)
#   define SETUP_XfOrM450(x) SETUP_XfOrM445(x)

# 3299 "bc/src/error.c"
    realm = argv [1 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 1 , argc , argv ) ); 
  }

  if (((intptr_t ) (argv [1 + use_realm ] ) ) & 0x1 )  {
    expected = (((intptr_t ) (argv [1 + use_realm ] ) ) >> 1 ) ; 
  }

# 3306 "bc/src/error.c"
  else if (((Scheme_Type ) (((((intptr_t ) (argv [1 + use_realm ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 + use_realm ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [1 + use_realm ] ) -> iso ) -> so . keyex & 0x1 ) )
    expected = (int ) (((unsigned ) - 1 ) >> 1 ) ; 
  else 
  expected = - 1 ; 
  if (expected < 0 )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-nonnegative-integer?" , 1 + use_realm , argc , argv ) ); 

  if (((argv [2 + use_realm ] ) ) == (scheme_false ) ) 
    detail = ((void * ) 0 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (argv [2 + use_realm ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 + use_realm ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
    Scheme_Object * bstr ; 
    BLOCK_SETUP((PUSH(bstr, 0+XfOrM445_COUNT)));
#   define XfOrM448_COUNT (1+XfOrM445_COUNT)
#   define SETUP_XfOrM448(x) SETUP(XfOrM448_COUNT)
    bstr = NULLED_OUT ; 

# 3317 "bc/src/error.c"
    bstr = FUNCCALL(SETUP_XfOrM448(_), scheme_char_string_to_byte_string (argv [2 + use_realm ] ) ); 
    detail = (((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . string_val ) ; 
  }

# 3319 "bc/src/error.c"
  else FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c string? #f)" , 2 + use_realm , argc , argv ) )
  ; 

  got_argv = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM445(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - (3 + use_realm ) ) ) )) ; 
  for (i = 3 + use_realm ; i < argc ; i ++ ) {
    got_argv [i - (3 + use_realm ) ] = argv [i ] ; 
  }
  FUNCCALL_EMPTY(wrong_return_arity_for_realm (where , realm , expected , argc - (3 + use_realm ) , got_argv , detail , detail ? strlen (detail ) : 0 ) )


  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3334 "bc/src/error.c"
static Scheme_Object * raise_result_arity_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3336 "bc/src/error.c"
  return do_raise_result_arity_error ("raise-result-arity-error" , argc , argv , 0 ) ; 
}

static Scheme_Object * raise_result_arity_error_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3341 "bc/src/error.c"
  return do_raise_result_arity_error ("raise-result-arity-error*" , argc , argv , 1 ) ; 
}

static Scheme_Object * good_print_width (int c , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3346 "bc/src/error.c"
  int ok ; 

  ok = ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
  ? ((((intptr_t ) (argv [0 ] ) ) >> 1 ) >= 3 ) 
  : (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
  ? ((& ((Scheme_Bignum * ) argv [0 ] ) -> iso ) -> so . keyex & 0x1 ) 
  : 0 ) ) ; 

  return ok ? scheme_true : scheme_false ; 
}

static Scheme_Object * error_print_width (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3359 "bc/src/error.c"
  return scheme_param_config2 ("error-print-width" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_WIDTH ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , good_print_width , "(and/c exact-integer? (>=/c 3))" , 0 ) ; 
}

static Scheme_Object * good_print_context_length (int c , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3367 "bc/src/error.c"
  int ok ; 

  ok = ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
  ? ((((intptr_t ) (argv [0 ] ) ) >> 1 ) >= 0 ) 
  : (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
  ? ((& ((Scheme_Bignum * ) argv [0 ] ) -> iso ) -> so . keyex & 0x1 ) 
  : 0 ) ) ; 

  return ok ? scheme_true : scheme_false ; 
}

static Scheme_Object * error_print_context_length (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3380 "bc/src/error.c"
  return scheme_param_config2 ("error-print-context-length" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_CONTEXT_LENGTH ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , good_print_context_length , "exact-nonnegative-integer?" , 0 ) ; 
}

static Scheme_Object * error_print_srcloc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3388 "bc/src/error.c"
  return scheme_param_config ("error-print-source-location" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_SRCLOC ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

void scheme_write_proc_context (Scheme_Object * port , int print_width , 
Scheme_Object * name , 
Scheme_Object * src , Scheme_Object * line , 
Scheme_Object * col , Scheme_Object * pos , 
int generated ) 
{
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(line, 0), PUSH(name, 1), PUSH(port, 2), PUSH(pos, 3), PUSH(col, 4)));
# define XfOrM458_COUNT (5)
# define SETUP_XfOrM458(x) SETUP(XfOrM458_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3400 "bc/src/error.c"
  if (src ) {
#   define XfOrM460_COUNT (0+XfOrM458_COUNT)
#   define SETUP_XfOrM460(x) SETUP_XfOrM458(x)
    FUNCCALL(SETUP_XfOrM460(_), scheme_display_w_max (src , port , print_width ) )
# 3401 "bc/src/error.c"
    ; 
    if (line && (! (((line ) ) == (scheme_false ) ) ) ) {
#     define XfOrM463_COUNT (0+XfOrM460_COUNT)
#     define SETUP_XfOrM463(x) SETUP_XfOrM460(x)
      FUNCCALL(SETUP_XfOrM463(_), scheme_write_byte_string (":" , 1 , port ) )
# 3404 "bc/src/error.c"
      ; 
      FUNCCALL(SETUP_XfOrM463(_), scheme_display_w_max (line , port , print_width ) ); 
      FUNCCALL_AGAIN(scheme_write_byte_string (":" , 1 , port ) ); 
      FUNCCALL_AGAIN(scheme_display_w_max (col , port , print_width ) ); 
    }

# 3408 "bc/src/error.c"
    else if (pos && (! (((pos ) ) == (scheme_false ) ) ) ) {
#     define XfOrM462_COUNT (0+XfOrM460_COUNT)
#     define SETUP_XfOrM462(x) SETUP_XfOrM460(x)
      FUNCCALL(SETUP_XfOrM462(_), scheme_write_byte_string ("::" , 2 , port ) )
# 3410 "bc/src/error.c"
      ; 
      FUNCCALL(SETUP_XfOrM462(_), scheme_display_w_max (pos , port , print_width ) ); 
    }

    if (! (((name ) ) == (scheme_false ) ) )  {
#     define XfOrM461_COUNT (0+XfOrM460_COUNT)
#     define SETUP_XfOrM461(x) SETUP_XfOrM460(x)
      FUNCCALL(SETUP_XfOrM461(_), scheme_write_byte_string (": " , 2 , port ) )
# 3415 "bc/src/error.c"
      ; 
    }
  }

  if (! (((name ) ) == (scheme_false ) ) )  {
#   define XfOrM459_COUNT (0+XfOrM458_COUNT)
#   define SETUP_XfOrM459(x) SETUP_XfOrM458(x)
    FUNCCALL_EMPTY(scheme_display_w_max (name , port , print_width ) )
# 3420 "bc/src/error.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3424 "bc/src/error.c"
static void write_context_repeats (int repeats , Scheme_Object * port ) 
{
  /* No conversion */

# 3426 "bc/src/error.c"
  char buf [64 ] ; 
  sprintf (buf , "[repeats %d more time%s]" , repeats , (repeats == 1 ) ? "" : "s" ) ; 
  scheme_write_byte_string (buf , strlen (buf ) , port ) ; 
}

static Scheme_Object * 
def_error_display_proc (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * config ; 
  Scheme_Object * port , * s ; 
  Scheme_Config * __funcarg122 = NULLED_OUT ; 
  Scheme_Object * __funcarg121 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(s, 1), PUSH(argv, 2), PUSH(config, 3)));
# define XfOrM465_COUNT (4)
# define SETUP_XfOrM465(x) SETUP(XfOrM465_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  config = NULLED_OUT ; 
  port = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 3437 "bc/src/error.c"
  config = FUNCCALL(SETUP_XfOrM465(_), scheme_current_config () ); 
  port = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_ERROR_PORT ) ); 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-error-display-handler" , "string?" , 0 , argc , argv ) ); 


  s = FUNCCALL(SETUP_XfOrM465(_), scheme_char_string_to_byte_string (argv [0 ] ) ); 
  FUNCCALL_AGAIN(scheme_write_byte_string ((((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) , port ) )


  ; 


  if (((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && (scheme_is_struct_instance (exn_table [MZEXN ] . type , argv [1 ] ) ) 
  && ! (scheme_is_struct_instance (exn_table [MZEXN_FAIL_USER ] . type , argv [1 ] ) ) ) {
    Scheme_Object * l , * w ; 
    int print_width = 1024 , max_cnt = 16 ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM465_COUNT), PUSH(w, 1+XfOrM465_COUNT)));
#   define XfOrM466_COUNT (2+XfOrM465_COUNT)
#   define SETUP_XfOrM466(x) SETUP(XfOrM466_COUNT)
    l = NULLED_OUT ; 
    w = NULLED_OUT ; 

# 3457 "bc/src/error.c"
    w = FUNCCALL(SETUP_XfOrM466(_), scheme_get_param (config , MZCONFIG_ERROR_PRINT_CONTEXT_LENGTH ) ); 
    if (((intptr_t ) (w ) ) & 0x1 ) 
      max_cnt = (((intptr_t ) (w ) ) >> 1 ) ; 
    else 
    max_cnt = 0x7FFFFFFF ; 

    if (max_cnt ) {
      Scheme_Object * prev_name ; 
      int orig_max_cnt = max_cnt , repeats ; 
      BLOCK_SETUP((PUSH(prev_name, 0+XfOrM466_COUNT)));
#     define XfOrM467_COUNT (1+XfOrM466_COUNT)
#     define SETUP_XfOrM467(x) SETUP(XfOrM467_COUNT)
      prev_name = NULLED_OUT ; 

# 3466 "bc/src/error.c"
      w = FUNCCALL(SETUP_XfOrM467(_), scheme_get_param (config , MZCONFIG_ERROR_PRINT_WIDTH ) ); 
      if (((intptr_t ) (w ) ) & 0x1 ) 
        print_width = (((intptr_t ) (w ) ) >> 1 ) ; 
      else 
      print_width = 0x7FFFFFFF ; 


      l = (scheme_struct_type_property_ref (scheme_source_property , argv [1 ] ) ) ; 
      if (l ) {
#       define XfOrM494_COUNT (0+XfOrM467_COUNT)
#       define SETUP_XfOrM494(x) SETUP_XfOrM467(x)

# 3475 "bc/src/error.c"
        l = FUNCCALL(SETUP_XfOrM494(_), scheme_do_eval (l , 1 , & (argv [1 ] ) , 1 ) ); 
        for (w = l ; ((Scheme_Type ) (((((intptr_t ) (w ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (w ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; w = (((Scheme_Simple_Object * ) (w ) ) -> u . pair_val . cdr ) ) {
#         define XfOrM496_COUNT (0+XfOrM494_COUNT)
#         define SETUP_XfOrM496(x) SETUP_XfOrM494(x)

# 3477 "bc/src/error.c"
          if (! FUNCCALL(SETUP_XfOrM496(_), scheme_is_location ((((Scheme_Simple_Object * ) (w ) ) -> u . pair_val . car ) ) ))
            break ; 
        }
        if (! ((w ) == (scheme_null ) ) )
          FUNCCALL(SETUP_XfOrM494(_), scheme_wrong_contract ("prop:exn:srclocs procedure" , "(listof srcloc?)" , - 1 , 1 , & l ) ); 
      }

      if (l && ! ((l ) == (scheme_null ) ) ) {
#       define XfOrM491_COUNT (0+XfOrM467_COUNT)
#       define SETUP_XfOrM491(x) SETUP_XfOrM467(x)

# 3486 "bc/src/error.c"
        if ((! ((((__funcarg122 = FUNCCALL(SETUP_XfOrM491(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg122 , MZCONFIG_ERROR_PRINT_SRCLOC ) )) ) ) == (scheme_false ) ) ) 
        && ((scheme_is_struct_instance (exn_table [MZEXN_FAIL_READ ] . type , argv [1 ] ) ) 
        || (scheme_is_struct_instance (exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . type , argv [1 ] ) ) ) )
          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 

        if (! ((l ) == (scheme_null ) ) )
          FUNCCALL(SETUP_XfOrM491(_), scheme_write_byte_string ("\n  location...:" , 15 , port ) ); 

        while (! ((l ) == (scheme_null ) ) ) {
#         define XfOrM493_COUNT (0+XfOrM491_COUNT)
#         define SETUP_XfOrM493(x) SETUP_XfOrM491(x)
          FUNCCALL(SETUP_XfOrM493(_), scheme_write_byte_string ("\n   " , 4 , port ) )
# 3495 "bc/src/error.c"
          ; 
          w = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          w = FUNCCALL(SETUP_XfOrM493(_), srcloc_to_string (1 , & w ) ); 
          FUNCCALL_AGAIN(scheme_display_w_max (w , port , print_width ) ); 
          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        }
      }

      prev_name = ((void * ) 0 ) ; 
      repeats = 0 ; 

      l = (__funcarg121 = FUNCCALL(SETUP_XfOrM467(_), scheme_struct_ref (argv [1 ] , 1 ) ), FUNCCALL_AGAIN(scheme_get_stack_trace (__funcarg121 , 0 ) )) ; 
      while (! ((l ) == (scheme_null ) ) ) {
#       define XfOrM480_COUNT (0+XfOrM467_COUNT)
#       define SETUP_XfOrM480(x) SETUP_XfOrM467(x)

# 3508 "bc/src/error.c"
        if (! max_cnt ) {
#         define XfOrM490_COUNT (0+XfOrM480_COUNT)
#         define SETUP_XfOrM490(x) SETUP_XfOrM480(x)
          FUNCCALL(SETUP_XfOrM490(_), scheme_write_byte_string ("\n   ..." , 7 , port ) )
# 3509 "bc/src/error.c"
          ; 
          break ; 
        }

# 3511 "bc/src/error.c"
        else {
          Scheme_Object * name , * loc ; 
          BLOCK_SETUP((PUSH(loc, 0+XfOrM480_COUNT), PUSH(name, 1+XfOrM480_COUNT)));
#         define XfOrM481_COUNT (2+XfOrM480_COUNT)
#         define SETUP_XfOrM481(x) SETUP(XfOrM481_COUNT)
          name = NULLED_OUT ; 
          loc = NULLED_OUT ; 

# 3514 "bc/src/error.c"
          name = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          if (prev_name && FUNCCALL(SETUP_XfOrM481(_), scheme_equal (name , prev_name ) )) {
            repeats ++ ; 
          }

# 3517 "bc/src/error.c"
          else {
#           define XfOrM482_COUNT (0+XfOrM481_COUNT)
#           define SETUP_XfOrM482(x) SETUP_XfOrM481(x)

# 3518 "bc/src/error.c"
            if (max_cnt == orig_max_cnt ) {
#             define XfOrM488_COUNT (0+XfOrM482_COUNT)
#             define SETUP_XfOrM488(x) SETUP_XfOrM482(x)
              FUNCCALL(SETUP_XfOrM488(_), scheme_write_byte_string ("\n  context...:\n" , 15 , port ) )
# 3520 "bc/src/error.c"
              ; 
            }

# 3521 "bc/src/error.c"
            else {
#             define XfOrM487_COUNT (0+XfOrM482_COUNT)
#             define SETUP_XfOrM487(x) SETUP_XfOrM482(x)
              FUNCCALL(SETUP_XfOrM487(_), scheme_write_byte_string ("\n" , 1 , port ) )
# 3522 "bc/src/error.c"
              ; 
            }

            if (repeats ) {
#             define XfOrM486_COUNT (0+XfOrM482_COUNT)
#             define SETUP_XfOrM486(x) SETUP_XfOrM482(x)
              FUNCCALL(SETUP_XfOrM486(_), scheme_write_byte_string ("   " , 3 , port ) )
# 3526 "bc/src/error.c"
              ; 
              FUNCCALL(SETUP_XfOrM486(_), write_context_repeats (repeats , port ) ); 
              repeats = 0 ; 
              -- max_cnt ; 
              if (max_cnt )
                FUNCCALL(SETUP_XfOrM486(_), scheme_write_byte_string ("\n" , 1 , port ) ); 
            }

            prev_name = name ; 

            if (max_cnt ) {
#             define XfOrM483_COUNT (0+XfOrM482_COUNT)
#             define SETUP_XfOrM483(x) SETUP_XfOrM482(x)

# 3537 "bc/src/error.c"
              loc = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . cdr ) ; 
              name = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . car ) ; 
              FUNCCALL(SETUP_XfOrM483(_), scheme_write_byte_string ("   " , 3 , port ) )
              ; 

              if (! (((loc ) ) == (scheme_false ) ) )  {
                Scheme_Structure * sloc = (Scheme_Structure * ) loc ; 
#               define XfOrM485_COUNT (0+XfOrM483_COUNT)
#               define SETUP_XfOrM485(x) SETUP_XfOrM483(x)
                FUNCCALL(SETUP_XfOrM485(_), scheme_write_proc_context (port , print_width , name , sloc -> slots [0 ] , sloc -> slots [1 ] , sloc -> slots [2 ] , sloc -> slots [3 ] , 0 ) )

                ; 
              }

# 3549 "bc/src/error.c"
              else {
#               define XfOrM484_COUNT (0+XfOrM483_COUNT)
#               define SETUP_XfOrM484(x) SETUP_XfOrM483(x)
                FUNCCALL(SETUP_XfOrM484(_), scheme_write_proc_context (port , print_width , name , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) )
                ; 
              }
              -- max_cnt ; 
            }
          }

          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        }
      }

      if (repeats ) {
#       define XfOrM468_COUNT (0+XfOrM467_COUNT)
#       define SETUP_XfOrM468(x) SETUP_XfOrM467(x)
        FUNCCALL(SETUP_XfOrM468(_), scheme_write_byte_string ("\n" , 1 , port ) )
# 3564 "bc/src/error.c"
        ; 
        FUNCCALL(SETUP_XfOrM468(_), scheme_write_byte_string ("   " , 3 , port ) ); 
        FUNCCALL_AGAIN(write_context_repeats (repeats , port ) ); 
      }
    }
  }
  FUNCCALL_EMPTY(scheme_write_byte_string ("\n" , 1 , port ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3576 "bc/src/error.c"
static Scheme_Object * 
emergency_error_display_proc (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * s ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM497_COUNT (1)
# define SETUP_XfOrM497(x) SETUP(XfOrM497_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 3581 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 

  s = FUNCCALL(SETUP_XfOrM497(_), scheme_char_string_to_byte_string (argv [0 ] ) ); 
  FUNCCALL_EMPTY(scheme_log_message (((void * ) 0 ) , 2 , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) , scheme_false ) )


  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3593 "bc/src/error.c"
static Scheme_Object * 
def_error_value_string_proc (int argc , Scheme_Object * argv [] ) 
{
  intptr_t origl , len , l ; 
  char * s ; 
  Scheme_Object * pph ; 
  Scheme_Config * __funcarg123 = NULLED_OUT ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(pph, 1), PUSH(argv, 2)));
# define XfOrM498_COUNT (3)
# define SETUP_XfOrM498(x) SETUP(XfOrM498_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  pph = NULLED_OUT ; 

# 3600 "bc/src/error.c"
  if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-error-value->string-handler" , "number?" , 1 , argc , argv ) ); 

  origl = len = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 

  pph = (__funcarg123 = FUNCCALL(SETUP_XfOrM498(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg123 , MZCONFIG_PORT_PRINT_HANDLER ) )) ; 
  if ((pph ) == (scheme_default_global_print_handler ) )  {
#   define XfOrM503_COUNT (0+XfOrM498_COUNT)
#   define SETUP_XfOrM503(x) SETUP_XfOrM498(x)

# 3607 "bc/src/error.c"
    if (len < 3 )
      len = 3 ; 

    s = FUNCCALL(SETUP_XfOrM503(_), scheme_print_to_string_w_max (argv [0 ] , & l , len ) ); 

    if ((origl < 3 ) && (l > origl ) )
      l = origl ; 
  }

# 3614 "bc/src/error.c"
  else {
    Scheme_Object * a [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM498_COUNT)));
#   define XfOrM499_COUNT (3+XfOrM498_COUNT)
#   define SETUP_XfOrM499(x) SETUP(XfOrM499_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 

# 3617 "bc/src/error.c"
    a [0 ] = argv [0 ] ; 
    a [1 ] = FUNCCALL(SETUP_XfOrM499(_), scheme_make_byte_string_output_port () ); 
    FUNCCALL(SETUP_XfOrM499(_), scheme_do_eval (pph , 2 , a , 1 ) ); 

    s = FUNCCALL_AGAIN(scheme_get_sized_byte_string_output (a [1 ] , & l ) ); 

    if (l > origl ) {

      l = origl ; 
      if (origl >= 1 ) {
        s [origl - 1 ] = '.' ; 
        if (origl >= 2 ) {
          s [origl - 2 ] = '.' ; 
          if (origl >= 3 )
            s [origl - 3 ] = '.' ; 
        }
      }
    }
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (s , l ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3640 "bc/src/error.c"
static Scheme_Object * 
def_error_syntax_string_proc (int argc , Scheme_Object * argv [] ) 
{
  intptr_t len , l ; 
  char * s ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM504_COUNT (1)
# define SETUP_XfOrM504(x) SETUP(XfOrM504_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 3646 "bc/src/error.c"
  if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) && ! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-error-syntax->string-handler" , "number?" , 1 , argc , argv ) ); 

  if (((intptr_t ) (argv [1 ] ) ) & 0x1 )  {
    len = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
    if (len < 3 )
      len = 3 ; 
  }

# 3653 "bc/src/error.c"
  else 
  len = - 1 ; 

  s = FUNCCALL(SETUP_XfOrM504(_), scheme_write_to_string_w_max (argv [0 ] , & l , len ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (s , l ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3661 "bc/src/error.c"
static void 
def_error_escape_proc (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * prompt ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(prompt, 0), PUSH(p, 1)));
# define XfOrM506_COUNT (2)
# define SETUP_XfOrM506(x) SETUP(XfOrM506_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt = NULLED_OUT ; 

# 3667 "bc/src/error.c"
  prompt = FUNCCALL(SETUP_XfOrM506(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (scheme_default_prompt_tag ) ) -> u . ptr_val ) ) ); 

  if (prompt ) {
    p -> cjs . jumping_to_continuation = prompt ; 
    p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
    p -> cjs . num_vals = 1 ; 
    p -> cjs . val = scheme_void_proc ; 
  }
  (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3678 "bc/src/error.c"
static Scheme_Object * 
error_display_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3681 "bc/src/error.c"
  return scheme_param_config ("error-display-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_DISPLAY_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
error_value_string_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3690 "bc/src/error.c"
  return scheme_param_config ("error-value->string-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_VALUE_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
error_syntax_string_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3699 "bc/src/error.c"
  return scheme_param_config ("error-value->syntax-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_SYNTAX_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
error_escape_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3708 "bc/src/error.c"
  return scheme_param_config ("error-escape-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_ESCAPE_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_error_message_adjuster (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3717 "bc/src/error.c"
  return scheme_param_config ("current-error-message-adjuster" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_MESSAGE_ADJUSTER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
exit_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3726 "bc/src/error.c"
  return scheme_param_config ("exit-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_EXIT_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
def_exit_handler_proc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3735 "bc/src/error.c"
  intptr_t status ; 

  if (((intptr_t ) (argv [0 ] ) ) & 0x1 )  {
    status = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
    if (status < 1 || status > 255 )
      status = 0 ; 
  }

# 3741 "bc/src/error.c"
  else 
  status = 0 ; 

  scheme_flush_managed (((void * ) 0 ) , 0 ) ; 

  if (scheme_exit )
    scheme_exit (status ) ; 
  else 
  exit (status ) ; 

  return scheme_void ; 
}

Scheme_Object * 
scheme_do_exit (int argc , Scheme_Object * argv [] ) 
{
  intptr_t status ; 
  Scheme_Object * handler ; 
  Scheme_Config * __funcarg124 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(handler, 0), PUSH(argv, 1)));
# define XfOrM516_COUNT (2)
# define SETUP_XfOrM516(x) SETUP(XfOrM516_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  handler = NULLED_OUT ; 

# 3760 "bc/src/error.c"
  if (argc == 1 ) {
    if (((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
      status = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
    else 
    status = 0 ; 
  }

# 3765 "bc/src/error.c"
  else 
  status = 0 ; 

  handler = (__funcarg124 = FUNCCALL(SETUP_XfOrM516(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg124 , MZCONFIG_EXIT_HANDLER ) )) ; 

  if (handler ) {
    Scheme_Object * p [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(p, 1, 0+XfOrM516_COUNT)));
#   define XfOrM517_COUNT (3+XfOrM516_COUNT)
#   define SETUP_XfOrM517(x) SETUP(XfOrM517_COUNT)
    p[0] = NULLED_OUT ; 

# 3773 "bc/src/error.c"
    p [0 ] = argc ? argv [0 ] : ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (status ) ) ) << 1 ) | 0x1 ) ) ; 
    FUNCCALL(SETUP_XfOrM517(_), scheme_apply_multi (handler , 1 , p ) ); 
  }

# 3775 "bc/src/error.c"
  else if (scheme_exit )
    FUNCCALL_EMPTY(scheme_exit (status ) ); 
  else FUNCCALL_EMPTY(exit (status ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_immediate_exit (int status ) 
{
  /* No conversion */

# 3788 "bc/src/error.c"
  exit (status ) ; 
}

static Scheme_Object * 
exe_yield_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3794 "bc/src/error.c"
  return scheme_param_config ("exeuctable-yield-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_EXE_YIELD_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * default_yield_handler (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3802 "bc/src/error.c"
  return scheme_void ; 
}



static Scheme_Object * level_number_to_symbol (int level ) 
{
  /* No conversion */

# 3809 "bc/src/error.c"
  switch (level ) {
    case 0 : 
    return scheme_false ; 
    break ; 
    case 1 : 
    return fatal_symbol ; 
    break ; 
    case 2 : 
    return error_symbol ; 
    break ; 
    case 3 : 
    return warning_symbol ; 
    break ; 
    case 4 : 
    return info_symbol ; 
    break ; 
    case 5 : 
    default : 
    return debug_symbol ; 
    break ; 
  }
}

static int extract_spec_level (Scheme_Object * level_spec , Scheme_Object * name ) 
{
  /* No conversion */

# 3834 "bc/src/error.c"
  if (! level_spec )

# 3834 "bc/src/error.c"
  return 0 ; 

  while (1 ) {
    if (((intptr_t ) (level_spec ) ) & 0x1 ) 
      return (((intptr_t ) (level_spec ) ) >> 1 ) ; 
    else if (name && ((((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) == (name ) ) )
      return (((intptr_t ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
    level_spec = (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
  }
}

static int extract_max_spec_level (Scheme_Object * level_spec , Scheme_Object * name ) 
{
  /* No conversion */

# 3847 "bc/src/error.c"
  int mx = 0 , v ; 

  if (name )
    return extract_spec_level (level_spec , name ) ; 

  if (level_spec ) {
    while (1 ) {
      if (((intptr_t ) (level_spec ) ) & 0x1 )  {
        v = (((intptr_t ) (level_spec ) ) >> 1 ) ; 
        if (v > mx )

# 3856 "bc/src/error.c"
        mx = v ; 
        break ; 
      }

# 3858 "bc/src/error.c"
      else {
        v = (((intptr_t ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
        if (v > mx )

# 3860 "bc/src/error.c"
        mx = v ; 
        level_spec = (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
      }
    }
  }

  return mx ; 
}

void update_want_level (Scheme_Logger * logger , Scheme_Object * name ) 
{
  Scheme_Log_Reader * lr ; 
  Scheme_Object * queue , * b , * prev ; 
  Scheme_Logger * parent = logger ; 
  int want_level , level , ceiling_level = 5 ; 
  PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(name, 1), PUSH(prev, 2), PUSH(b, 3), PUSH(parent, 4), PUSH(lr, 5), PUSH(queue, 6)));
# define XfOrM535_COUNT (7)
# define SETUP_XfOrM535(x) SETUP(XfOrM535_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lr = NULLED_OUT ; 
  queue = NULLED_OUT ; 
  b = NULLED_OUT ; 
  prev = NULLED_OUT ; 

# 3876 "bc/src/error.c"
  want_level = 0 ; 
  while (parent ) {
#   define XfOrM552_COUNT (0+XfOrM535_COUNT)
#   define SETUP_XfOrM552(x) SETUP_XfOrM535(x)

# 3878 "bc/src/error.c"
    queue = parent -> readers ; 
    prev = ((void * ) 0 ) ; 
    while (queue ) {
#     define XfOrM556_COUNT (0+XfOrM552_COUNT)
#     define SETUP_XfOrM556(x) SETUP_XfOrM552(x)

# 3881 "bc/src/error.c"
      b = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . car ) ; 
      b = (((Scheme_Simple_Object * ) (b ) ) -> u . pair_val . car ) ; 
      lr = (Scheme_Log_Reader * ) (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) ; 
      if (lr ) {
#       define XfOrM558_COUNT (0+XfOrM556_COUNT)
#       define SETUP_XfOrM558(x) SETUP_XfOrM556(x)

# 3885 "bc/src/error.c"
        level = FUNCCALL(SETUP_XfOrM558(_), extract_max_spec_level (lr -> level , name ) ); 
        if (level > ceiling_level )
          level = ceiling_level ; 
        if (level > want_level )
          want_level = level ; 
        if (want_level >= ceiling_level )
          break ; 
        prev = queue ; 
      }

# 3893 "bc/src/error.c"
      else {
        if (prev )
          (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
        else 
        parent -> readers = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
      }
      queue = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
    }

    level = FUNCCALL(SETUP_XfOrM552(_), extract_max_spec_level (parent -> syslog_level , name ) ); 
    if (level > want_level )
      want_level = level ; 
    level = FUNCCALL(SETUP_XfOrM552(_), extract_max_spec_level (parent -> stderr_level , name ) ); 
    if (level > want_level )
      want_level = level ; 
    level = FUNCCALL(SETUP_XfOrM552(_), extract_max_spec_level (parent -> stdout_level , name ) ); 
    if (level > want_level )
      want_level = level ; 

    if (parent -> propagate_level )
      level = FUNCCALL(SETUP_XfOrM552(_), extract_max_spec_level (parent -> propagate_level , name ) ); 
    else 
    level = 5 ; 
    if (level <= ceiling_level )
      ceiling_level = level ; 

    if (want_level >= ceiling_level )
      break ; 

    parent = parent -> parent ; 
  }

  if (! name ) {
    logger -> want_level = want_level ; 
    logger -> local_timestamp = (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) ; 
  }

# 3928 "bc/src/error.c"
  else {

    int i ; 
#   define XfOrM536_COUNT (0+XfOrM535_COUNT)
#   define SETUP_XfOrM536(x) SETUP_XfOrM535(x)

# 3932 "bc/src/error.c"
    b = logger -> want_name_level_cache ; 
    if (! b ) {
#     define XfOrM543_COUNT (0+XfOrM536_COUNT)
#     define SETUP_XfOrM543(x) SETUP_XfOrM536(x)

# 3934 "bc/src/error.c"
      b = FUNCCALL(SETUP_XfOrM543(_), scheme_make_vector (3 * 8 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
      logger -> want_name_level_cache = b ; 
    }


    for (i = (((Scheme_Vector * ) (b ) ) -> size ) ; (i -= 3 ) >= 0 ; ) {
      if ((name ) == ((((Scheme_Vector * ) (b ) ) -> els ) [i ] ) ) 
        break ; 
    }
    if (i == 0 )
      FUNCCALL(SETUP_XfOrM536(_), abort () )
# 3943 "bc/src/error.c"
    ; 
    if (i < 0 ) {
#     define XfOrM537_COUNT (0+XfOrM536_COUNT)
#     define SETUP_XfOrM537(x) SETUP_XfOrM536(x)

# 3946 "bc/src/error.c"
      for (i = (((Scheme_Vector * ) (b ) ) -> size ) ; (i -= 3 ) >= 0 ; ) {
        if ((((intptr_t ) ((((Scheme_Vector * ) (b ) ) -> els ) [i + 1 ] ) ) >> 1 ) < (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
          break ; 
      }
      if (i < 0 ) {
#       define XfOrM538_COUNT (0+XfOrM537_COUNT)
#       define SETUP_XfOrM538(x) SETUP_XfOrM537(x)

# 3952 "bc/src/error.c"
        i = 3 * (8 - 1 ) ; 
        (memmove (& ((((Scheme_Vector * ) (b ) ) -> els ) [0 ] ) , 
        & ((((Scheme_Vector * ) (b ) ) -> els ) [3 ] ) , 
        i * sizeof (Scheme_Object * ) ) ) ; 
      }
    }

    (((Scheme_Vector * ) (b ) ) -> els ) [i ] = name ; 
    (((Scheme_Vector * ) (b ) ) -> els ) [i + 1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (b ) ) -> els ) [i + 2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (want_level ) ) ) << 1 ) | 0x1 ) ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3965 "bc/src/error.c"
static int get_want_level (Scheme_Logger * logger , Scheme_Object * name ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(logger, 1)));
# define XfOrM559_COUNT (2)
# define SETUP_XfOrM559(x) SETUP(XfOrM559_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3967 "bc/src/error.c"
  if (name && (! (((name ) ) == (scheme_false ) ) ) ) {
#   define XfOrM561_COUNT (0+XfOrM559_COUNT)
#   define SETUP_XfOrM561(x) SETUP_XfOrM559(x)

# 3968 "bc/src/error.c"
    while (1 ) {
#     define XfOrM570_COUNT (0+XfOrM561_COUNT)
#     define SETUP_XfOrM570(x) SETUP_XfOrM561(x)

# 3969 "bc/src/error.c"
      if (logger -> want_name_level_cache ) {
        int i ; 
        for (i = (((Scheme_Vector * ) (logger -> want_name_level_cache ) ) -> size ) ; (i -= 3 ) >= 0 ; ) {
          if ((name ) == ((((Scheme_Vector * ) (logger -> want_name_level_cache ) ) -> els ) [i ] ) )  {
            if ((((intptr_t ) ((((Scheme_Vector * ) (logger -> want_name_level_cache ) ) -> els ) [i + 1 ] ) ) >> 1 ) == (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) ) {
              RET_VALUE_START ((((intptr_t ) ((((Scheme_Vector * ) (logger -> want_name_level_cache ) ) -> els ) [i + 2 ] ) ) >> 1 ) ) RET_VALUE_END ; 
            }
          }
        }
      }
      FUNCCALL(SETUP_XfOrM570(_), update_want_level (logger , name ) ); 
    }
  }

# 3981 "bc/src/error.c"
  else {
#   define XfOrM560_COUNT (0+XfOrM559_COUNT)
#   define SETUP_XfOrM560(x) SETUP_XfOrM559(x)

# 3982 "bc/src/error.c"
    if (logger -> local_timestamp < (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
      FUNCCALL(SETUP_XfOrM560(_), update_want_level (logger , ((void * ) 0 ) ) ); 

    RET_VALUE_START (logger -> want_level ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3989 "bc/src/error.c"
int scheme_log_level_topic_p (Scheme_Logger * logger , int level , Scheme_Object * name ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(logger, 1)));
# define XfOrM578_COUNT (2)
# define SETUP_XfOrM578(x) SETUP(XfOrM578_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3991 "bc/src/error.c"
  if (! logger ) {
    Scheme_Config * config ; 
    BLOCK_SETUP((PUSH(config, 0+XfOrM578_COUNT)));
#   define XfOrM581_COUNT (1+XfOrM578_COUNT)
#   define SETUP_XfOrM581(x) SETUP(XfOrM581_COUNT)
    config = NULLED_OUT ; 

# 3993 "bc/src/error.c"
    config = FUNCCALL(SETUP_XfOrM581(_), scheme_current_config () ); 
    logger = (Scheme_Logger * ) FUNCCALL(SETUP_XfOrM581(_), scheme_get_param (config , MZCONFIG_LOGGER ) ); 
  }

  if (! name ) {
#   define XfOrM580_COUNT (0+XfOrM578_COUNT)
#   define SETUP_XfOrM580(x) SETUP_XfOrM578(x)

# 3998 "bc/src/error.c"
    if (logger -> local_timestamp < (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
      FUNCCALL(SETUP_XfOrM580(_), update_want_level (logger , ((void * ) 0 ) ) ); 

    RET_VALUE_START ((logger -> want_level >= level ) ) RET_VALUE_END ; 
  }

# 4002 "bc/src/error.c"
  else {
    int want_level ; 
#   define XfOrM579_COUNT (0+XfOrM578_COUNT)
#   define SETUP_XfOrM579(x) SETUP_XfOrM578(x)

# 4005 "bc/src/error.c"
    want_level = FUNCCALL_EMPTY(get_want_level (logger , name ) ); 

    RET_VALUE_START ((want_level >= level ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4011 "bc/src/error.c"
int scheme_log_level_p (Scheme_Logger * logger , int level ) 
{
  /* No conversion */

# 4013 "bc/src/error.c"
  return scheme_log_level_topic_p (logger , level , ((void * ) 0 ) ) ; 
}

Scheme_Object * extract_all_levels (Scheme_Logger * logger ) 
{
  Scheme_Hash_Table * names ; 
  Scheme_Log_Reader * lr ; 
  Scheme_Object * queue , * b , * name , * result = scheme_null , * l ; 
  int level , default_level ; 
  Scheme_Logger * parent = logger ; 
  Scheme_Object * __funcarg142 = NULLED_OUT ; 

# 3807 "bc/src/error.c"
  Scheme_Object * __funcarg141 = NULLED_OUT ; 
  Scheme_Object * __funcarg126 = NULLED_OUT ; 

# 3807 "bc/src/error.c"
  Scheme_Object * __funcarg125 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(11);
  BLOCK_SETUP_TOP((PUSH(names, 0), PUSH(__funcarg141, 1), PUSH(name, 2), PUSH(b, 3), PUSH(parent, 4), PUSH(lr, 5), PUSH(queue, 6), PUSH(logger, 7), PUSH(l, 8), PUSH(__funcarg125, 9), PUSH(result, 10)));
# define XfOrM583_COUNT (11)
# define SETUP_XfOrM583(x) SETUP(XfOrM583_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  names = NULLED_OUT ; 
  lr = NULLED_OUT ; 
  queue = NULLED_OUT ; 
  b = NULLED_OUT ; 
  name = NULLED_OUT ; 
  l = NULLED_OUT ; 

# 4024 "bc/src/error.c"
  names = FUNCCALL(SETUP_XfOrM583(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  default_level = FUNCCALL_AGAIN(get_want_level (logger , scheme_void ) ); 

  while (parent ) {
#   define XfOrM611_COUNT (0+XfOrM583_COUNT)
#   define SETUP_XfOrM611(x) SETUP_XfOrM583(x)

# 4029 "bc/src/error.c"
    queue = parent -> readers ; 
    while (queue ) {
#     define XfOrM626_COUNT (0+XfOrM611_COUNT)
#     define SETUP_XfOrM626(x) SETUP_XfOrM611(x)

# 4031 "bc/src/error.c"
      b = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . car ) ; 
      b = (((Scheme_Simple_Object * ) (b ) ) -> u . pair_val . car ) ; 
      lr = (Scheme_Log_Reader * ) (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) ; 
      if (lr ) {
#       define XfOrM627_COUNT (0+XfOrM626_COUNT)
#       define SETUP_XfOrM627(x) SETUP_XfOrM626(x)

# 4035 "bc/src/error.c"
        for (l = lr -> level ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#         define XfOrM633_COUNT (0+XfOrM627_COUNT)
#         define SETUP_XfOrM633(x) SETUP_XfOrM627(x)

# 4036 "bc/src/error.c"
          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
          name = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          if (! ((& ((Scheme_Symbol * ) (name ) ) -> iso ) -> so . keyex & 0x3 ) && ! FUNCCALL(SETUP_XfOrM633(_), scheme_hash_get (names , name ) )) {
#           define XfOrM636_COUNT (0+XfOrM633_COUNT)
#           define SETUP_XfOrM636(x) SETUP_XfOrM633(x)

# 4039 "bc/src/error.c"
            level = FUNCCALL(SETUP_XfOrM636(_), get_want_level (logger , name ) ); 
            FUNCCALL(SETUP_XfOrM636(_), scheme_hash_set (names , name , scheme_true ) ); 
            if (level != default_level ) {
#             define XfOrM637_COUNT (0+XfOrM636_COUNT)
#             define SETUP_XfOrM637(x) SETUP_XfOrM636(x)

# 4042 "bc/src/error.c"
              result = (__funcarg141 = FUNCCALL(SETUP_XfOrM637(_), level_number_to_symbol (level ) ), __funcarg142 = FUNCCALL(SETUP_XfOrM637(_), scheme_make_pair (name , result ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg141 , __funcarg142 ) )) 
              ; 
            }
          }
          {
#           define XfOrM634_COUNT (0+XfOrM633_COUNT)
#           define SETUP_XfOrM634(x) SETUP_XfOrM633(x)

# 4046 "bc/src/error.c"
            if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#             define XfOrM635_COUNT (0+XfOrM634_COUNT)
#             define SETUP_XfOrM635(x) SETUP_XfOrM634(x)
              FUNCCALL(SETUP_XfOrM635(_), scheme_out_of_fuel () )
# 4046 "bc/src/error.c"
              ; 
            }
          }

# 4046 "bc/src/error.c"
          ; 
        }
      }
      queue = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
    }
    parent = parent -> parent ; 
    {
#     define XfOrM612_COUNT (0+XfOrM611_COUNT)
#     define SETUP_XfOrM612(x) SETUP_XfOrM611(x)

# 4052 "bc/src/error.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM613_COUNT (0+XfOrM612_COUNT)
#       define SETUP_XfOrM613(x) SETUP_XfOrM612(x)
        FUNCCALL(SETUP_XfOrM613(_), scheme_out_of_fuel () )
# 4052 "bc/src/error.c"
        ; 
      }
    }

# 4052 "bc/src/error.c"
    ; 
  }

  result = (__funcarg125 = FUNCCALL(SETUP_XfOrM583(_), level_number_to_symbol (default_level ) ), __funcarg126 = FUNCCALL(SETUP_XfOrM583(_), scheme_make_pair (scheme_false , result ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg125 , __funcarg126 ) )) 
  ; 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4061 "bc/src/error.c"
static Scheme_Object * make_log_message (int level , Scheme_Object * name , int prefix_msg , 
char * buffer , intptr_t len , Scheme_Object * data ) {
  Scheme_Object * msg ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(msg, 1), PUSH(data, 2), PUSH(v, 3), PUSH(buffer, 4)));
# define XfOrM638_COUNT (5)
# define SETUP_XfOrM638(x) SETUP(XfOrM638_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  msg = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 4066 "bc/src/error.c"
  msg = FUNCCALL(SETUP_XfOrM638(_), scheme_make_vector (4 , ((void * ) 0 ) ) ); 
  v = FUNCCALL_AGAIN(level_number_to_symbol (level ) ); 
  (((Scheme_Vector * ) (msg ) ) -> els ) [0 ] = v ; 

  if (name && prefix_msg ) {

    intptr_t slen ; 
    char * cp ; 
    BLOCK_SETUP((PUSH(cp, 0+XfOrM638_COUNT)));
#   define XfOrM639_COUNT (1+XfOrM638_COUNT)
#   define SETUP_XfOrM639(x) SETUP(XfOrM639_COUNT)
    cp = NULLED_OUT ; 

# 4074 "bc/src/error.c"
    slen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
    cp = FUNCCALL(SETUP_XfOrM639(_), GC_malloc_atomic (slen + 2 + len + 1 ) ); 
    (memcpy (cp , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) , slen ) ) ; 
    (memcpy (cp + slen , ": " , 2 ) ) ; 
    (memcpy (cp + slen + 2 , buffer , len + 1 ) ) ; 
    len += slen + 2 ; 
    buffer = cp ; 
  }

  v = FUNCCALL(SETUP_XfOrM638(_), scheme_make_sized_utf8_string (buffer , len ) ); 
  ((((Scheme_Inclhash_Object * ) (v ) ) -> so . keyex |= 0x1 ) ) ; 
  (((Scheme_Vector * ) (msg ) ) -> els ) [1 ] = v ; 
  (((Scheme_Vector * ) (msg ) ) -> els ) [2 ] = (data ? data : scheme_false ) ; 
  (((Scheme_Vector * ) (msg ) ) -> els ) [3 ] = (name ? name : scheme_false ) ; 

  ((((Scheme_Inclhash_Object * ) (msg ) ) -> so . keyex |= 0x1 ) ) ; 

  RET_VALUE_START (msg ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4094 "bc/src/error.c"
void scheme_log_name_pfx_message (Scheme_Logger * logger , int level , Scheme_Object * name , 
char * buffer , intptr_t len , Scheme_Object * data , 
int prefix_msg ) 
{


  Scheme_Object * queue , * q , * msg = ((void * ) 0 ) , * b ; 
  Scheme_Log_Reader * lr ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(name, 1), PUSH(b, 2), PUSH(lr, 3), PUSH(buffer, 4), PUSH(q, 5), PUSH(msg, 6), PUSH(data, 7), PUSH(queue, 8)));
# define XfOrM640_COUNT (9)
# define SETUP_XfOrM640(x) SETUP(XfOrM640_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  queue = NULLED_OUT ; 
  q = NULLED_OUT ; 
  b = NULLED_OUT ; 
  lr = NULLED_OUT ; 

# 4103 "bc/src/error.c"
  if (! logger ) {
    Scheme_Config * config ; 
    BLOCK_SETUP((PUSH(config, 0+XfOrM640_COUNT)));
#   define XfOrM673_COUNT (1+XfOrM640_COUNT)
#   define SETUP_XfOrM673(x) SETUP(XfOrM673_COUNT)
    config = NULLED_OUT ; 

# 4105 "bc/src/error.c"
    config = FUNCCALL(SETUP_XfOrM673(_), scheme_current_config () ); 
    logger = (Scheme_Logger * ) FUNCCALL(SETUP_XfOrM673(_), scheme_get_param (config , MZCONFIG_LOGGER ) ); 
  }

  if (logger -> local_timestamp < (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
    FUNCCALL(SETUP_XfOrM640(_), update_want_level (logger , ((void * ) 0 ) ) ); 

  if (logger -> want_level < level )
    RET_NOTHING ; 

  if (! name )
    name = logger -> name ; 

  if (((name ) ) == (scheme_false ) ) 
    name = ((void * ) 0 ) ; 

  while (logger ) {
#   define XfOrM657_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM657(x) SETUP_XfOrM640(x)

# 4122 "bc/src/error.c"
    if (FUNCCALL(SETUP_XfOrM657(_), extract_spec_level (logger -> syslog_level , name ) )>= level ) {
      int pri ; 
      Scheme_Object * cmd ; 
      BLOCK_SETUP((PUSH(cmd, 0+XfOrM657_COUNT)));
#     define XfOrM671_COUNT (1+XfOrM657_COUNT)
#     define SETUP_XfOrM671(x) SETUP(XfOrM671_COUNT)
      cmd = NULLED_OUT ; 

# 4125 "bc/src/error.c"
      switch (level ) {
        case 1 : 
        pri = RKTIO_LOG_FATAL ; 
        break ; 
        case 2 : 
        pri = RKTIO_LOG_ERROR ; 
        break ; 
        case 3 : 
        pri = RKTIO_LOG_WARNING ; 
        break ; 
        case 4 : 
        pri = RKTIO_LOG_INFO ; 
        break ; 
        case 5 : 
        default : 
        pri = RKTIO_LOG_DEBUG ; 
        break ; 
      }
      cmd = FUNCCALL(SETUP_XfOrM671(_), scheme_get_run_cmd () ); 
      (rktio_syslog (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , pri , 
      (name ? (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) : ((void * ) 0 ) ) , 
      buffer , (((Scheme_Simple_Object * ) (cmd ) ) -> u . byte_str_val . string_val ) ) ) ; 
    }

    if (FUNCCALL(SETUP_XfOrM657(_), extract_spec_level (logger -> stderr_level , name ) )>= level ) {
      rktio_fd_t * fd ; 
      BLOCK_SETUP((PUSH(fd, 0+XfOrM657_COUNT)));
#     define XfOrM668_COUNT (1+XfOrM657_COUNT)
#     define SETUP_XfOrM668(x) SETUP(XfOrM668_COUNT)
      fd = NULLED_OUT ; 

# 4151 "bc/src/error.c"
      fd = (rktio_std_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , 2 ) ) ; 
      if (fd ) {
#       define XfOrM669_COUNT (0+XfOrM668_COUNT)
#       define SETUP_XfOrM669(x) SETUP_XfOrM668(x)

# 4153 "bc/src/error.c"
        if (name && prefix_msg ) {
          intptr_t slen ; 
#         define XfOrM670_COUNT (0+XfOrM669_COUNT)
#         define SETUP_XfOrM670(x) SETUP_XfOrM669(x)

# 4155 "bc/src/error.c"
          slen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
          FUNCCALL(SETUP_XfOrM670(_), scheme_rktio_write_all (fd , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) , slen ) ); 
          FUNCCALL_AGAIN(scheme_rktio_write_all (fd , ": " , 2 ) ); 
        }
        FUNCCALL(SETUP_XfOrM669(_), scheme_rktio_write_all (fd , buffer , len ) ); 
        FUNCCALL(SETUP_XfOrM669(_), scheme_rktio_write_all (fd , "\n" , 1 ) ); 
        (rktio_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fd ) ) ; 
      }
    }

    if (FUNCCALL(SETUP_XfOrM657(_), extract_spec_level (logger -> stdout_level , name ) )>= level ) {
      rktio_fd_t * fd ; 
      BLOCK_SETUP((PUSH(fd, 0+XfOrM657_COUNT)));
#     define XfOrM665_COUNT (1+XfOrM657_COUNT)
#     define SETUP_XfOrM665(x) SETUP(XfOrM665_COUNT)
      fd = NULLED_OUT ; 

# 4167 "bc/src/error.c"
      fd = (rktio_std_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , 1 ) ) ; 
      if (fd ) {
#       define XfOrM666_COUNT (0+XfOrM665_COUNT)
#       define SETUP_XfOrM666(x) SETUP_XfOrM665(x)

# 4169 "bc/src/error.c"
        if (name && prefix_msg ) {
          intptr_t slen ; 
#         define XfOrM667_COUNT (0+XfOrM666_COUNT)
#         define SETUP_XfOrM667(x) SETUP_XfOrM666(x)

# 4171 "bc/src/error.c"
          slen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
          FUNCCALL(SETUP_XfOrM667(_), scheme_rktio_write_all (fd , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) , slen ) ); 
          FUNCCALL_AGAIN(scheme_rktio_write_all (fd , ": " , 2 ) ); 
        }
        FUNCCALL(SETUP_XfOrM666(_), scheme_rktio_write_all (fd , buffer , len ) ); 
        FUNCCALL(SETUP_XfOrM666(_), scheme_rktio_write_all (fd , "\n" , 1 ) ); 
        (rktio_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fd ) ) ; 
      }
    }

    queue = logger -> readers ; 
    while (queue ) {
#     define XfOrM662_COUNT (0+XfOrM657_COUNT)
#     define SETUP_XfOrM662(x) SETUP_XfOrM657(x)

# 4183 "bc/src/error.c"
      b = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . car ) ; 
      b = (((Scheme_Simple_Object * ) (b ) ) -> u . pair_val . car ) ; 
      lr = (Scheme_Log_Reader * ) (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) ; 
      if (lr ) {
#       define XfOrM663_COUNT (0+XfOrM662_COUNT)
#       define SETUP_XfOrM663(x) SETUP_XfOrM662(x)

# 4187 "bc/src/error.c"
        if (FUNCCALL(SETUP_XfOrM663(_), extract_spec_level (lr -> level , name ) )>= level ) {
#         define XfOrM664_COUNT (0+XfOrM663_COUNT)
#         define SETUP_XfOrM664(x) SETUP_XfOrM663(x)

# 4188 "bc/src/error.c"
          if (! msg )
            msg = FUNCCALL(SETUP_XfOrM664(_), make_log_message (level , name , prefix_msg , buffer , len , data ) ); 


          q = FUNCCALL(SETUP_XfOrM664(_), scheme_make_raw_pair (msg , ((void * ) 0 ) ) ); 
          if (lr -> tail )
            (((Scheme_Simple_Object * ) (lr -> tail ) ) -> u . pair_val . cdr ) = q ; 
          else 
          lr -> head = q ; 
          lr -> tail = q ; 
          FUNCCALL(SETUP_XfOrM664(_), scheme_post_sema (lr -> sema ) ); 
        }
      }
      queue = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
    }

    if (logger -> parent && logger -> propagate_level ) {
#     define XfOrM658_COUNT (0+XfOrM657_COUNT)
#     define SETUP_XfOrM658(x) SETUP_XfOrM657(x)

# 4205 "bc/src/error.c"
      if (FUNCCALL(SETUP_XfOrM658(_), extract_spec_level (logger -> propagate_level , name ) )< level )
        break ; 
    }

    logger = logger -> parent ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4213 "bc/src/error.c"
void scheme_log_name_message (Scheme_Logger * logger , int level , Scheme_Object * name , 
char * buffer , intptr_t len , Scheme_Object * data ) 
{
  /* No conversion */

# 4216 "bc/src/error.c"
  scheme_log_name_pfx_message (logger , level , name , buffer , len , data , 1 ) ; 
}

void scheme_log_message (Scheme_Logger * logger , int level , char * buffer , intptr_t len , Scheme_Object * data ) 
{
  /* No conversion */

# 4221 "bc/src/error.c"
  scheme_log_name_pfx_message (logger , level , ((void * ) 0 ) , buffer , len , data , 1 ) ; 
}

void scheme_log_abort (char * buffer ) 
{
  Scheme_Logger logger ; 
  Scheme_Object * ts [2 ] ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(ts, 2, 0)));
# define XfOrM676_COUNT (3)
# define SETUP_XfOrM676(x) SETUP(XfOrM676_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ts[0] = NULLED_OUT ; 
  ts[1] = NULLED_OUT ; 
  (
# 4229 "bc/src/error.c"
  memset (& logger , 0 , sizeof (logger ) ) ) ; 

  logger . name = ((void * ) 0 ) ; 
  logger . parent = ((void * ) 0 ) ; 
  logger . want_level = 1 ; 

  ts [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  ts [1 ] = ((void * ) 0 ) ; 
  logger . root_timestamp = ts ; 
  logger . local_timestamp = 0 ; 
  logger . syslog_level = init_syslog_level ; 
  logger . stderr_level = init_stderr_level ; 
  logger . stdout_level = init_stdout_level ; 
  FUNCCALL(SETUP_XfOrM676(_), scheme_log_message (& logger , 1 , buffer , strlen (buffer ) , scheme_false ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4246 "bc/src/error.c"
void scheme_log_warning (char * buffer ) 
{
  /* No conversion */

# 4248 "bc/src/error.c"
  scheme_log_message (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , 3 , buffer , strlen (buffer ) , scheme_false ) ; 
}

static void glib_log_message (const char * log_domain , 
int log_level , 
const char * message , 
void * user_data ) 

{






  int level , len1 , len2 ; 
  char * together ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(log_domain, 0), PUSH(together, 1), PUSH(message, 2)));
# define XfOrM678_COUNT (3)
# define SETUP_XfOrM678(x) SETUP(XfOrM678_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  together = NULLED_OUT ; 

# 4266 "bc/src/error.c"
  if (log_level & ((1 << 2 ) ) )
    level = 1 ; 
  else if (log_level & ((1 << 3 ) ) )
    level = 2 ; 
  else if (log_level & ((1 << 4 ) | (1 << 5 ) ) )
    level = 3 ; 
  else if (log_level & ((1 << 6 ) ) )
    level = 4 ; 
  else 
  level = 5 ; 

  len2 = strlen (message ) ; 
  if (log_domain ) {
#   define XfOrM679_COUNT (0+XfOrM678_COUNT)
#   define SETUP_XfOrM679(x) SETUP_XfOrM678(x)

# 4279 "bc/src/error.c"
    len1 = strlen (log_domain ) ; 
    together = (char * ) FUNCCALL(SETUP_XfOrM679(_), GC_malloc_atomic (len1 + len2 + 3 ) ); 
    (memcpy (together , log_domain , len1 ) ) ; 
    (memcpy (together + len1 , ": " , 2 ) ) ; 
    (memcpy (together + len1 + 2 , message , len2 ) ) ; 
    len2 += len1 + 2 ; 
  }

# 4285 "bc/src/error.c"
  else 
  together = (char * ) message ; 
  FUNCCALL_EMPTY(scheme_log_message (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , level , together , len2 , scheme_false ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4291 "bc/src/error.c"
void scheme_glib_log_message (const char * log_domain , 
int log_level , 
const char * message , 
void * user_data ) 
XFORM_SKIP_PROC 




{
  if (scheme_is_place_main_os_thread () )
    glib_log_message (log_domain , log_level , message , user_data ) ; 
  else {


    glib_log_queue_entry * e = malloc (sizeof (glib_log_queue_entry ) ) ; 
    e -> log_domain = strdup (log_domain ) ; 
    e -> log_level = log_level ; 
    e -> message = strdup (message ) ; 

    mzrt_mutex_lock (glib_log_queue_lock ) ; 
    e -> next = glib_log_queue ; 
    glib_log_queue = e ; 
    mzrt_mutex_unlock (glib_log_queue_lock ) ; 

    scheme_signal_received_at (glib_log_signal_handle ) ; 
  }
}







void * scheme_glib_log_message_test (char * str ) 
XFORM_SKIP_PROC 
{
  if (! str ) {
    scheme_glib_log_message (((void * ) 0 ) , (1 << 4 ) , "test" , ((void * ) 0 ) ) ; 
  }

# 4331 "bc/src/error.c"
  else {
    int i ; 
    for (i = 0 ; str [i ] ; i ++ ) {
      if (str [i ] == ';' ) {
        str [i ] = 0 ; 
        scheme_glib_log_message ("test" , (1 << 4 ) , str , ((void * ) 0 ) ) ; 
        str [i ] = ';' ; 
        str = str + i + 1 ; 
        i = 0 ; 
      }
    }
    scheme_glib_log_message ("test" , (1 << 4 ) , str , ((void * ) 0 ) ) ; 
  }
  return ((void * ) 0 ) ; 
}


void scheme_init_glib_log_queue (void ) 
{
  /* No conversion */

# 4350 "bc/src/error.c"
  mzrt_mutex_create (& glib_log_queue_lock ) ; 
  glib_log_signal_handle = scheme_get_signal_handle () ; 
}

void scheme_check_glib_log_messages (void ) 
{
  PREPARE_VAR_STACK(3);
# define XfOrM681_COUNT (0)
# define SETUP_XfOrM681(x) SETUP(XfOrM681_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4356 "bc/src/error.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) == 0 ) {
    glib_log_queue_entry * e , * prev = ((void * ) 0 ) , * next ; 
    BLOCK_SETUP((PUSH(e, 0+XfOrM681_COUNT), PUSH(prev, 1+XfOrM681_COUNT), PUSH(next, 2+XfOrM681_COUNT)));
#   define XfOrM682_COUNT (3+XfOrM681_COUNT)
#   define SETUP_XfOrM682(x) SETUP(XfOrM682_COUNT)
    e = NULLED_OUT ; 
    next = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM682(_), mzrt_mutex_lock (glib_log_queue_lock ) )
# 4359 "bc/src/error.c"
    ; 
    e = glib_log_queue ; 
    glib_log_queue = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM682(_), mzrt_mutex_unlock (glib_log_queue_lock ) ); 

    if (e ) {
#     define XfOrM683_COUNT (0+XfOrM682_COUNT)
#     define SETUP_XfOrM683(x) SETUP_XfOrM682(x)

# 4366 "bc/src/error.c"
      while (e -> next ) {
        next = e -> next ; 
        e -> next = prev ; 
        prev = e ; 
        e = next ; 
      }
      e -> next = prev ; 


      for (; e ; e = e -> next ) {
#       define XfOrM685_COUNT (0+XfOrM683_COUNT)
#       define SETUP_XfOrM685(x) SETUP_XfOrM683(x)
        FUNCCALL(SETUP_XfOrM685(_), glib_log_message (e -> log_domain , e -> log_level , e -> message , ((void * ) 0 ) ) )
# 4376 "bc/src/error.c"
        ; 
      }
      FUNCCALL_EMPTY(scheme_signal_received_at (glib_log_signal_handle ) )

      ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4386 "bc/src/error.c"
static int extract_level (const char * who , int none_ok , int which , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4388 "bc/src/error.c"
  Scheme_Object * v ; 
  int level ; 

  v = argv [which ] ; 
  if ((v ) == (none_symbol ) ) 
    level = 0 ; 
  else if ((v ) == (fatal_symbol ) ) 
    level = 1 ; 
  else if ((v ) == (error_symbol ) ) 
    level = 2 ; 
  else if ((v ) == (warning_symbol ) ) 
    level = 3 ; 
  else if ((v ) == (info_symbol ) ) 
    level = 4 ; 
  else if ((v ) == (debug_symbol ) ) 
    level = 5 ; 
  else {
    scheme_wrong_contract (who , 
    (none_ok 
    ? "(or/c 'none 'fatal 'error 'warning 'info 'debug)" 
    : "(or/c 'fatal 'error 'warning 'info 'debug)" ) , 
    which , argc , argv ) ; 
    return 0 ; 
  }

  return level ; 
}

static Scheme_Object * 
log_message (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Object * bytes ; 
  Scheme_Object * name ; 
  Scheme_Object * data ; 
  int level , pos , pfx ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(name, 1), PUSH(bytes, 2), PUSH(data, 3), PUSH(argv, 4)));
# define XfOrM690_COUNT (5)
# define SETUP_XfOrM690(x) SETUP(XfOrM690_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 
  bytes = NULLED_OUT ; 
  name = NULLED_OUT ; 
  data = NULLED_OUT ; 

# 4425 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-message" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  level = FUNCCALL(SETUP_XfOrM690(_), extract_level ("log-message" , 0 , 1 , argc , argv ) ); 

  pos = 2 ; 
  if (((Scheme_Type ) (((((intptr_t ) (argv [pos ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [pos ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || (((argv [pos ] ) ) == (scheme_false ) ) )
    name = argv [pos ++ ] ; 
  else 
  name = ((void * ) 0 ) ; 

  bytes = argv [pos ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (bytes ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bytes ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-message" , "string?" , pos , argc , argv ) ); 
  bytes = FUNCCALL(SETUP_XfOrM690(_), scheme_char_string_to_byte_string (bytes ) ); 
  pos ++ ; 

  if (argc > (pos + 1 ) )
    pfx = (! (((argv [pos + 1 ] ) ) == (scheme_false ) ) ) ; 
  else 
  pfx = 1 ; 

  if (pos >= argc )
    data = scheme_false ; 
  else 
  data = argv [pos ] ; 
  FUNCCALL_EMPTY(scheme_log_name_pfx_message (logger , level , name , (((Scheme_Simple_Object * ) (bytes ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (bytes ) ) -> u . byte_str_val . tag_val ) , data , pfx ) )


  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4460 "bc/src/error.c"
static Scheme_Object * 
log_level_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Object * name = scheme_false ; 
  int level , want_level ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(name, 1), PUSH(argv, 2)));
# define XfOrM691_COUNT (3)
# define SETUP_XfOrM691(x) SETUP(XfOrM691_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 

# 4467 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-level?" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  level = FUNCCALL(SETUP_XfOrM691(_), extract_level ("log-level?" , 0 , 1 , argc , argv ) ); 

  if (argc > 2 ) {
#   define XfOrM692_COUNT (0+XfOrM691_COUNT)
#   define SETUP_XfOrM692(x) SETUP_XfOrM691(x)

# 4474 "bc/src/error.c"
    if (! (((argv [2 ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("log-level?" , "(or/c f? #symbol)" , 2 , argc , argv ) ); 
    name = argv [2 ] ; 
  }

  want_level = FUNCCALL_EMPTY(get_want_level (logger , name ) ); 

  RET_VALUE_START (((want_level >= level ) ? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4484 "bc/src/error.c"
static Scheme_Object * 
log_max_level (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Object * name = scheme_false ; 

# 3965 "bc/src/error.c"
  int __funcarg143 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM693_COUNT (0)
# define SETUP_XfOrM693(x) SETUP(XfOrM693_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 

# 4490 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-max-level" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  if (argc > 1 ) {
#   define XfOrM694_COUNT (0+XfOrM693_COUNT)
#   define SETUP_XfOrM694(x) SETUP_XfOrM693(x)

# 4495 "bc/src/error.c"
    if (! (((argv [1 ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("log-max-level" , "(or/c f? #symbol)" , 1 , argc , argv ) ); 
    name = argv [1 ] ; 
  }

  RET_VALUE_START ((__funcarg143 = FUNCCALL_EMPTY(get_want_level (logger , name ) ), FUNCCALL_EMPTY(level_number_to_symbol (__funcarg143 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4503 "bc/src/error.c"
static Scheme_Object * 
log_all_levels (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4506 "bc/src/error.c"
  Scheme_Logger * logger ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    scheme_wrong_contract ("log-all-levels" , "logger?" , 0 , argc , argv ) ; 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  return extract_all_levels (logger ) ; 
}

static Scheme_Object * 
log_level_evt (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Object * sema ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(sema, 1)));
# define XfOrM696_COUNT (2)
# define SETUP_XfOrM696(x) SETUP(XfOrM696_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 4521 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-level-evt" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  sema = logger -> root_timestamp [1 ] ; 
  if (! sema ) {
#   define XfOrM697_COUNT (0+XfOrM696_COUNT)
#   define SETUP_XfOrM697(x) SETUP_XfOrM696(x)

# 4527 "bc/src/error.c"
    sema = FUNCCALL(SETUP_XfOrM697(_), scheme_make_sema (0 ) ); 
    logger -> root_timestamp [1 ] = sema ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sema_repost (sema ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4534 "bc/src/error.c"
static Scheme_Object * get_levels_and_names (const char * who , int i , int argc , Scheme_Object * * argv , 
int default_lvl ) 
{
  int lvl ; 
  Scheme_Object * level = scheme_null , * last = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(level, 0), PUSH(argv, 1), PUSH(who, 2), PUSH(last, 3)));
# define XfOrM698_COUNT (4)
# define SETUP_XfOrM698(x) SETUP(XfOrM698_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4540 "bc/src/error.c"
  for (; i < argc ; i += 2 ) {
#   define XfOrM703_COUNT (0+XfOrM698_COUNT)
#   define SETUP_XfOrM703(x) SETUP_XfOrM698(x)

# 4541 "bc/src/error.c"
    lvl = FUNCCALL(SETUP_XfOrM703(_), extract_level (who , 1 , i , argc , argv ) ); 
    if ((i + 1 ) < argc ) {
#     define XfOrM705_COUNT (0+XfOrM703_COUNT)
#     define SETUP_XfOrM705(x) SETUP_XfOrM703(x)

# 4543 "bc/src/error.c"
      if (((argv [i + 1 ] ) ) == (scheme_false ) ) 
        default_lvl = lvl ; 
      else {
#       define XfOrM706_COUNT (0+XfOrM705_COUNT)
#       define SETUP_XfOrM706(x) SETUP_XfOrM705(x)

# 4546 "bc/src/error.c"
        if (! ((Scheme_Type ) (((((intptr_t ) (argv [i + 1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + 1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? #f)" , i + 1 , argc , argv ) ); 
        level = FUNCCALL(SETUP_XfOrM706(_), scheme_make_pair (argv [i + 1 ] , level ) ); 
        if (! last )

# 4549 "bc/src/error.c"
        last = level ; 
        level = FUNCCALL(SETUP_XfOrM706(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (lvl ) ) ) << 1 ) | 0x1 ) ) , level ) ); 
      }
    }

# 4552 "bc/src/error.c"
    else {
      default_lvl = lvl ; 
    }
  }

  if (last )
    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (default_lvl ) ) ) << 1 ) | 0x1 ) ) ; 
  else 
  level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (default_lvl ) ) ) << 1 ) | 0x1 ) ) ; 

  RET_VALUE_START (level ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4565 "bc/src/error.c"
static Scheme_Object * 
make_logger (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * parent , * logger ; 
  Scheme_Object * propagate_level ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(parent, 1), PUSH(argv, 2), PUSH(propagate_level, 3)));
# define XfOrM707_COUNT (4)
# define SETUP_XfOrM707(x) SETUP(XfOrM707_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  parent = NULLED_OUT ; 
  logger = NULLED_OUT ; 
  propagate_level = NULLED_OUT ; 

# 4571 "bc/src/error.c"
  if (argc ) {
#   define XfOrM708_COUNT (0+XfOrM707_COUNT)
#   define SETUP_XfOrM708(x) SETUP_XfOrM707(x)

# 4572 "bc/src/error.c"
    if (! (((argv [0 ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-logger" , "(or/c symbol? #f)" , 0 , argc , argv ) ); 

    if (argc > 1 ) {
#     define XfOrM709_COUNT (0+XfOrM708_COUNT)
#     define SETUP_XfOrM709(x) SETUP_XfOrM708(x)

# 4576 "bc/src/error.c"
      if (((argv [1 ] ) ) == (scheme_false ) ) 
        parent = ((void * ) 0 ) ; 
      else {
#       define XfOrM710_COUNT (0+XfOrM709_COUNT)
#       define SETUP_XfOrM710(x) SETUP_XfOrM709(x)

# 4579 "bc/src/error.c"
        if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract ("make-logger" , "(or/c logger? #f)" , 1 , argc , argv ) ); 
        parent = (Scheme_Logger * ) argv [1 ] ; 
      }
    }

# 4583 "bc/src/error.c"
    else 
    parent = ((void * ) 0 ) ; 
  }

# 4585 "bc/src/error.c"
  else 
  parent = ((void * ) 0 ) ; 

  propagate_level = FUNCCALL(SETUP_XfOrM707(_), get_levels_and_names ("make-logger" , 2 , argc , argv , 5 ) )
  ; 

  logger = FUNCCALL_AGAIN(scheme_make_logger (parent , (argc ? ((((argv [0 ] ) ) == (scheme_false ) ) ? ((void * ) 0 ) : argv [0 ] ) : ((void * ) 0 ) ) ) )


  ; 

  if (parent )
    logger -> propagate_level = propagate_level ; 

  RET_VALUE_START ((Scheme_Object * ) logger ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4602 "bc/src/error.c"
Scheme_Logger * scheme_make_logger (Scheme_Logger * parent , Scheme_Object * name ) 
{
  Scheme_Logger * logger ; 
  DECL_RET_SAVE (Scheme_Logger * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(parent, 1), PUSH(logger, 2)));
# define XfOrM711_COUNT (3)
# define SETUP_XfOrM711(x) SETUP(XfOrM711_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  logger = NULLED_OUT ; 

# 4606 "bc/src/error.c"
  logger = ((Scheme_Logger * ) FUNCCALL(SETUP_XfOrM711(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Logger ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  logger -> so . type = scheme_logger_type ; 
  logger -> parent = parent ; 
  if (parent ) {
    logger -> root_timestamp = parent -> root_timestamp ; 
  }

# 4611 "bc/src/error.c"
  else {
    Scheme_Object * * root_timestamp ; 
    BLOCK_SETUP((PUSH(root_timestamp, 0+XfOrM711_COUNT)));
#   define XfOrM712_COUNT (1+XfOrM711_COUNT)
#   define SETUP_XfOrM712(x) SETUP(XfOrM712_COUNT)
    root_timestamp = NULLED_OUT ; 

# 4613 "bc/src/error.c"
    root_timestamp = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM712(_), GC_malloc (sizeof (Scheme_Object * ) * (2 ) ) )) ; 
    root_timestamp [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
    logger -> root_timestamp = root_timestamp ; 
  }
  logger -> name = name ; 

  RET_VALUE_START (logger ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4622 "bc/src/error.c"
static Scheme_Object * 
logger_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4625 "bc/src/error.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * 
current_logger (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4633 "bc/src/error.c"
  return scheme_param_config2 ("current-logger" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_LOGGER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , logger_p , "logger?" , 0 ) ; 
}

static Scheme_Object * 
logger_name (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4642 "bc/src/error.c"
  Scheme_Object * name ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    scheme_wrong_contract ("logger-name" , "logger?" , 0 , argc , argv ) ; 

  name = ((Scheme_Logger * ) argv [0 ] ) -> name ; 
  return (name ? name : scheme_false ) ; 
}

static Scheme_Object * 
make_log_reader (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Log_Reader * lr ; 
  Scheme_Object * sema , * q ; 
  Scheme_Object * level ; 
  Scheme_Object * __funcarg145 = NULLED_OUT ; 
  Scheme_Object * __funcarg144 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(lr, 0), PUSH(q, 1), PUSH(level, 2), PUSH(logger, 3), PUSH(sema, 4)));
# define XfOrM717_COUNT (5)
# define SETUP_XfOrM717(x) SETUP(XfOrM717_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 
  lr = NULLED_OUT ; 
  sema = NULLED_OUT ; 
  q = NULLED_OUT ; 
  level = NULLED_OUT ; 

# 4659 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-log-receiver" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  level = FUNCCALL(SETUP_XfOrM717(_), get_levels_and_names ("make-log-receiver" , 1 , argc , argv , 0 ) ); 

  lr = ((Scheme_Log_Reader * ) FUNCCALL(SETUP_XfOrM717(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Log_Reader ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  lr -> so . type = scheme_log_reader_type ; 
  lr -> level = level ; 

  sema = FUNCCALL(SETUP_XfOrM717(_), scheme_make_sema (0 ) ); 
  lr -> sema = sema ; 






  q = (__funcarg144 = (__funcarg145 = FUNCCALL(SETUP_XfOrM717(_), scheme_make_weak_box ((Scheme_Object * ) lr ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg145 , sema ) )) 
  , FUNCCALL_AGAIN(scheme_make_raw_pair (__funcarg144 , logger -> readers ) )) 
  ; 
  logger -> readers = q ; 
  logger -> root_timestamp [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) + 1 ) ) ) << 1 ) | 0x1 ) ) ; 
  if (logger -> root_timestamp [1 ] ) {
#   define XfOrM718_COUNT (0+XfOrM717_COUNT)
#   define SETUP_XfOrM718(x) SETUP_XfOrM717(x)
    FUNCCALL(SETUP_XfOrM718(_), scheme_post_sema_all (logger -> root_timestamp [1 ] ) )
# 4683 "bc/src/error.c"
    ; 
    logger -> root_timestamp [1 ] = ((void * ) 0 ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) lr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4690 "bc/src/error.c"
static Scheme_Object * 
log_reader_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4693 "bc/src/error.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_log_reader_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * dequeue_log (Scheme_Object * _lr ) 
{
  /* No conversion */

# 4700 "bc/src/error.c"
  Scheme_Log_Reader * lr = (Scheme_Log_Reader * ) _lr ; 

  if (lr -> head ) {
    Scheme_Object * v ; 
    v = (((Scheme_Simple_Object * ) (lr -> head ) ) -> u . pair_val . car ) ; 
    lr -> head = (((Scheme_Simple_Object * ) (lr -> head ) ) -> u . pair_val . cdr ) ; 
    if (! lr -> head )
      lr -> tail = ((void * ) 0 ) ; 
    return v ; 
  }

# 4709 "bc/src/error.c"
  else {
    scheme_signal_error ("empty log-reader queue!?" ) ; 
    return ((void * ) 0 ) ; 
  }
}

static int log_reader_get (Scheme_Object * _lr , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 4717 "bc/src/error.c"
  Scheme_Log_Reader * lr = (Scheme_Log_Reader * ) _lr ; 
  scheme_set_sync_target (sinfo , lr -> sema , (Scheme_Object * ) lr , ((void * ) 0 ) , 0 , 1 , dequeue_log ) ; 
  return 0 ; 
}



static Scheme_Object * 
def_error_message_adjust_proc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4727 "bc/src/error.c"
  if ((argv [0 ] ) == (name_symbol ) ) 
    return def_err_msg_adjust_name_proc ; 
  else if ((argv [0 ] ) == (message_symbol ) ) 
    return def_err_msg_adjust_message_proc ; 
  else if ((argv [0 ] ) == (contract_symbol ) ) 
    return def_err_msg_adjust_contract_proc ; 
  else {
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      scheme_wrong_contract ("default-error-message-adjuster" , "symbol?" , 0 , argc , argv ) ; 
    return scheme_false ; 
  }
}

static Scheme_Object * def_error_message_adjust_name_proc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4742 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("default-error-message-adjuster/name-mode" , "symbol?" , 0 , argc , argv ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("default-error-message-adjuster/name-mode" , "symbol?" , 1 , argc , argv ) ; 

  return scheme_values (2 , argv ) ; 
}

static Scheme_Object * def_error_message_adjust_message_proc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4752 "bc/src/error.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("default-error-message-adjuster/name-mode" , "(or/c symbol? #f)" , 0 , argc , argv ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("default-error-message-adjuster/name-mode" , "symbol?" , 1 , argc , argv ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    scheme_wrong_contract ("default-error-message-adjuster/name-mode" , "string?" , 2 , argc , argv ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("default-error-message-adjuster/name-mode" , "symbol?" , 3 , argc , argv ) ; 

  return scheme_values (4 , argv ) ; 
}

static Scheme_Object * def_error_message_adjust_contract_proc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4766 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    scheme_wrong_contract ("default-error-message-adjuster/name-mode" , "string?" , 0 , argc , argv ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("default-error-message-adjuster/name-mode" , "symbol?" , 1 , argc , argv ) ; 

  return scheme_values (2 , argv ) ; 
}





static void apply_one_adjuster (Scheme_Object * adjr , 
Scheme_Object * * _v1 , Scheme_Object * * _realm1 , 
Scheme_Object * * _v2 , Scheme_Object * * _realm2 , 
int mode ) {
  const char * who ; 
  Scheme_Object * proc , * a [4 ] , * r , * * vals ; 
  Scheme_Thread * p ; 
  int n , rn ; 
  PREPARE_VAR_STACK_ONCE(13);
  BLOCK_SETUP_TOP((PUSH(_realm2, 0), PUSH(who, 1), PUSH(_v1, 2), PUSH(proc, 3), PUSH(_realm1, 4), PUSH(p, 5), PUSH(r, 6), PUSH(adjr, 7), PUSHARRAY(a, 4, 8), PUSH(_v2, 11), PUSH(vals, 12)));
# define XfOrM729_COUNT (13)
# define SETUP_XfOrM729(x) SETUP(XfOrM729_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  who = NULLED_OUT ; 
  proc = NULLED_OUT ; 
  NULL_OUT_ARRAY (a ) ; 
  r = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 4787 "bc/src/error.c"
  a [0 ] = ((mode == 0 ) ? contract_symbol : message_symbol ) ; 
  proc = FUNCCALL(SETUP_XfOrM729(_), scheme_apply (adjr , 1 , a ) ); 
  if (((proc ) ) == (scheme_false ) )  {
#   define XfOrM742_COUNT (0+XfOrM729_COUNT)
#   define SETUP_XfOrM742(x) SETUP_XfOrM729(x)

# 4790 "bc/src/error.c"
    if ((mode == 1 ) && ! (((* _v1 ) ) == (scheme_false ) ) ) {
#     define XfOrM743_COUNT (0+XfOrM742_COUNT)
#     define SETUP_XfOrM743(x) SETUP_XfOrM742(x)

# 4791 "bc/src/error.c"
      mode = 2 ; 
      a [0 ] = name_symbol ; 
      proc = FUNCCALL(SETUP_XfOrM743(_), scheme_apply (adjr , 1 , a ) ); 
    }
    if (((proc ) ) == (scheme_false ) ) 
      RET_NOTHING ; 
  }

  if (mode == 0 )
    who = "current-error-message-adjuster for contract" ; 
  else if (mode == 1 )
    who = "current-error-message-adjuster for message" ; 
  else 
  who = "current-error-message-adjuster for name" ; 

  if (mode == 1 )
    n = 4 ; 
  else 
  n = 2 ; 

  if (! FUNCCALL(SETUP_XfOrM729(_), scheme_check_proc_arity (((void * ) 0 ) , n , - 1 , 0 , & proc ) )) {
#   define XfOrM741_COUNT (0+XfOrM729_COUNT)
#   define SETUP_XfOrM741(x) SETUP_XfOrM729(x)
    FUNCCALL(SETUP_XfOrM741(_), scheme_wrong_contract (who , ((n == 2 ) ? "(procedure-arity-includes/c 2)" : "(procedure-arity-includes/c 4)" ) , - 1 , 0 , & proc ) )

    ; 
  }

  a [0 ] = * _v1 ; 
  a [1 ] = * _realm1 ; 
  a [2 ] = * _v2 ; 
  a [3 ] = * _realm2 ; 

  r = FUNCCALL(SETUP_XfOrM729(_), scheme_apply_multi (proc , n , a ) ); 

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  if ((r ) == (((Scheme_Object * ) 0x6 ) ) )  {
    rn = p -> ku . multiple . count ; 
    if (rn <= 4 ) {
      int i ; 
      for (i = 0 ; i < rn ; i ++ ) {
        a [i ] = p -> ku . multiple . array [i ] ; 
      }
      vals = a ; 
    }

# 4835 "bc/src/error.c"
    else {
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
      vals = p -> ku . multiple . array ; 
    }
    p -> ku . multiple . array = ((void * ) 0 ) ; 
  }

# 4841 "bc/src/error.c"
  else {
    rn = 1 ; 
    a [0 ] = r ; 
    vals = a ; 
  }

  if (n != rn )
    FUNCCALL(SETUP_XfOrM729(_), scheme_wrong_return_arity (who , n , rn , vals , ((void * ) 0 ) ) ); 

  if (mode == 1 ) {
#   define XfOrM734_COUNT (0+XfOrM729_COUNT)
#   define SETUP_XfOrM734(x) SETUP_XfOrM729(x)

# 4851 "bc/src/error.c"
    if ((! (((vals [0 ] ) ) == (scheme_false ) ) ) && ! ((Scheme_Type ) (((((intptr_t ) (vals [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vals [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL(SETUP_XfOrM734(_), scheme_wrong_contract (who , "(or/c symbol? #f)" , - 1 , - 1 , & (vals [0 ] ) ) ); 
  }

# 4853 "bc/src/error.c"
  else if (mode == 2 ) {
#   define XfOrM733_COUNT (0+XfOrM729_COUNT)
#   define SETUP_XfOrM733(x) SETUP_XfOrM729(x)

# 4854 "bc/src/error.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (vals [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vals [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL(SETUP_XfOrM733(_), scheme_wrong_contract (who , "symbol?" , - 1 , - 1 , & (vals [0 ] ) ) ); 
  }

# 4856 "bc/src/error.c"
  else {
#   define XfOrM732_COUNT (0+XfOrM729_COUNT)
#   define SETUP_XfOrM732(x) SETUP_XfOrM729(x)

# 4857 "bc/src/error.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (vals [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vals [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
      FUNCCALL(SETUP_XfOrM732(_), scheme_wrong_contract (who , "string?" , - 1 , - 1 , & (vals [0 ] ) ) ); 
  }
  if (! ((Scheme_Type ) (((((intptr_t ) (vals [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vals [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL(SETUP_XfOrM729(_), scheme_wrong_contract (who , "symbol?" , - 1 , - 1 , & (vals [1 ] ) ) ); 
  if (mode == 1 ) {
#   define XfOrM731_COUNT (0+XfOrM729_COUNT)
#   define SETUP_XfOrM731(x) SETUP_XfOrM729(x)

# 4863 "bc/src/error.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (vals [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vals [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
      FUNCCALL(SETUP_XfOrM731(_), scheme_wrong_contract (who , "string?" , - 1 , - 1 , & (vals [2 ] ) ) ); 
    if (! ((Scheme_Type ) (((((intptr_t ) (vals [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vals [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL(SETUP_XfOrM731(_), scheme_wrong_contract (who , "symbol?" , - 1 , - 1 , & (vals [3 ] ) ) ); 
  }

  * _v1 = vals [0 ] ; 
  * _realm1 = vals [1 ] ; 
  if (mode == 1 ) {
    * _v2 = vals [2 ] ; 
    * _realm2 = vals [3 ] ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4877 "bc/src/error.c"
static Scheme_Object * apply_adjusters (Scheme_Object * v1 , Scheme_Object * realm1 , 
Scheme_Object * v2 , Scheme_Object * realm2 , 
Scheme_Object * base_adjr , 
int mode ) {
  char * __funcarg148 = NULLED_OUT ; 
  Scheme_Object * __funcarg147 = NULLED_OUT ; 
  Scheme_Object * __funcarg146 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(base_adjr, 0), PUSH(v2, 1), PUSH(realm2, 2), PUSH(v1, 3), PUSH(__funcarg146, 4), PUSH(realm1, 5)));
# define XfOrM744_COUNT (6)
# define SETUP_XfOrM744(x) SETUP(XfOrM744_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4881 "bc/src/error.c"
  if (FUNCCALL(SETUP_XfOrM744(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_error_message_adjuster_key ) )) {
    Scheme_Object * l ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM744_COUNT)));
#   define XfOrM747_COUNT (1+XfOrM744_COUNT)
#   define SETUP_XfOrM747(x) SETUP(XfOrM747_COUNT)
    l = NULLED_OUT ; 

# 4883 "bc/src/error.c"
    l = FUNCCALL(SETUP_XfOrM747(_), scheme_extract_cc_mark_list (((void * ) 0 ) , scheme_error_message_adjuster_key , scheme_root_prompt_tag ) ); 
    while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      Scheme_Object * a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      BLOCK_SETUP((PUSH(a, 0+XfOrM747_COUNT)));
#     define XfOrM749_COUNT (1+XfOrM747_COUNT)
#     define SETUP_XfOrM749(x) SETUP(XfOrM749_COUNT)

# 4886 "bc/src/error.c"
      if (FUNCCALL(SETUP_XfOrM749(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , - 1 , 0 , & a ) ))
        FUNCCALL(SETUP_XfOrM749(_), apply_one_adjuster (a , & v1 , & realm1 , & v2 , & realm2 , mode ) ); 
      l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
    }
  }
  FUNCCALL(SETUP_XfOrM744(_), apply_one_adjuster (base_adjr , & v1 , & realm1 , & v2 , & realm2 , mode ) )
  ; 

  if (mode == 0 )
    RET_VALUE_START (v1 ) RET_VALUE_END ; 
  else {
#   define XfOrM745_COUNT (0+XfOrM744_COUNT)
#   define SETUP_XfOrM745(x) SETUP_XfOrM744(x)

# 4897 "bc/src/error.c"
    if (((v1 ) ) == (scheme_false ) ) 
      RET_VALUE_START (v2 ) RET_VALUE_END ; 
    else {
#     define XfOrM746_COUNT (0+XfOrM745_COUNT)
#     define SETUP_XfOrM746(x) SETUP_XfOrM745(x)

# 4900 "bc/src/error.c"
      v1 = (__funcarg146 = (__funcarg148 = FUNCCALL(SETUP_XfOrM746(_), scheme_symbol_val (v1 ) ), FUNCCALL_AGAIN(scheme_make_utf8_string (__funcarg148 ) )) , __funcarg147 = FUNCCALL(SETUP_XfOrM746(_), scheme_make_utf8_string (": " ) ), FUNCCALL_AGAIN(scheme_append_char_string (__funcarg146 , __funcarg147 ) )) 
      ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM746(_), scheme_append_char_string (v1 , v2 ) )) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4907 "bc/src/error.c"
const char * scheme_contract_realm_adjust (const char * contract , Scheme_Object * realm ) 
{
  Scheme_Object * base_adjr , * ctc ; 
  Scheme_Config * __funcarg149 = NULLED_OUT ; 
  DECL_RET_SAVE (const char * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(base_adjr, 1), PUSH(ctc, 2), PUSH(contract, 3)));
# define XfOrM750_COUNT (4)
# define SETUP_XfOrM750(x) SETUP(XfOrM750_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  base_adjr = NULLED_OUT ; 
  ctc = NULLED_OUT ; 

# 4911 "bc/src/error.c"
  base_adjr = (__funcarg149 = FUNCCALL(SETUP_XfOrM750(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg149 , MZCONFIG_ERROR_MESSAGE_ADJUSTER ) )) ; 
  if (! FUNCCALL(SETUP_XfOrM750(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_error_message_adjuster_key ) )
  && ((base_adjr ) == (def_err_msg_adjust_proc ) ) )
    RET_VALUE_START (contract ) RET_VALUE_END ; 

  ctc = FUNCCALL(SETUP_XfOrM750(_), scheme_make_utf8_string (contract ) ); 
  ctc = FUNCCALL_AGAIN(apply_adjusters (ctc , realm , ((void * ) 0 ) , ((void * ) 0 ) , base_adjr , 0 ) ); 

  RET_VALUE_START ((((Scheme_Simple_Object * ) (FUNCCALL_EMPTY(scheme_char_string_to_byte_string (ctc ) )) ) -> u . byte_str_val . string_val ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4922 "bc/src/error.c"
static Scheme_Object * error_message_adjust (char * buffer , intptr_t alen , intptr_t namelen , Scheme_Object * name_realm , Scheme_Object * msg_realm ) 
{
  Scheme_Object * base_adjr , * name , * msg ; 
  intptr_t delta ; 
  Scheme_Config * __funcarg150 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(base_adjr, 0), PUSH(name, 1), PUSH(name_realm, 2), PUSH(msg, 3), PUSH(msg_realm, 4), PUSH(buffer, 5)));
# define XfOrM751_COUNT (6)
# define SETUP_XfOrM751(x) SETUP(XfOrM751_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  base_adjr = NULLED_OUT ; 
  name = NULLED_OUT ; 
  msg = NULLED_OUT ; 

# 4927 "bc/src/error.c"
  base_adjr = (__funcarg150 = FUNCCALL(SETUP_XfOrM751(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg150 , MZCONFIG_ERROR_MESSAGE_ADJUSTER ) )) ; 
  if (! FUNCCALL(SETUP_XfOrM751(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_error_message_adjuster_key ) )
  && ((base_adjr ) == (def_err_msg_adjust_proc ) ) )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_immutable_sized_utf8_string (buffer , alen ) )) RET_VALUE_EMPTY_END ; 

  if (namelen < 0 )
    name = scheme_false ; 
  else 
  name = FUNCCALL(SETUP_XfOrM751(_), scheme_intern_exact_symbol (buffer , namelen ) ); 

  delta = ((namelen < 0 ) ? 0 : (namelen + 2 ) ) ; 
  msg = FUNCCALL(SETUP_XfOrM751(_), scheme_make_sized_offset_utf8_string (buffer , delta , alen - delta ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(apply_adjusters (name , name_realm , msg , msg_realm , base_adjr , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4943 "bc/src/error.c"
static Scheme_Object * error_message_to_adjusted_string (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * base_adjr ; 
  Scheme_Config * __funcarg151 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(base_adjr, 0), PUSH(argv, 1)));
# define XfOrM752_COUNT (2)
# define SETUP_XfOrM752(x) SETUP(XfOrM752_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  base_adjr = NULLED_OUT ; 

# 4947 "bc/src/error.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("error-message->adjusted-string" , "(or/c symbol? #f)" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("error-message->adjusted-string" , "symbol?" , 1 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("error-message->adjusted-string" , "string?" , 2 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("error-message->adjusted-string" , "symbol?" , 3 , argc , argv ) ); 

  base_adjr = (__funcarg151 = FUNCCALL(SETUP_XfOrM752(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg151 , MZCONFIG_ERROR_MESSAGE_ADJUSTER ) )) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(apply_adjusters (argv [0 ] , argv [1 ] , argv [2 ] , argv [3 ] , base_adjr , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4961 "bc/src/error.c"
static Scheme_Object * error_contract_to_adjusted_string (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * base_adjr ; 
  Scheme_Config * __funcarg152 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(base_adjr, 0), PUSH(argv, 1)));
# define XfOrM753_COUNT (2)
# define SETUP_XfOrM753(x) SETUP(XfOrM753_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  base_adjr = NULLED_OUT ; 

# 4965 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("error-contract->adjusted-string" , "string?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("error-contract->adjusted-string" , "symbol?" , 1 , argc , argv ) ); 

  base_adjr = (__funcarg152 = FUNCCALL(SETUP_XfOrM753(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg152 , MZCONFIG_ERROR_MESSAGE_ADJUSTER ) )) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(apply_adjusters (argv [0 ] , argv [1 ] , ((void * ) 0 ) , ((void * ) 0 ) , base_adjr , 0 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4977 "bc/src/error.c"
static void finish_raise_exn (int id , int c , Scheme_Object * * eargs , 
intptr_t namelen , Scheme_Object * name_realm , Scheme_Object * msg_realm , 
char * buffer , intptr_t alen , 
Scheme_Object * errno_val , int unsupported ) 
{
  Scheme_Object * msg ; 
  Scheme_Object * __funcarg153 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(msg, 0), PUSH(errno_val, 1), PUSH(eargs, 2)));
# define XfOrM754_COUNT (3)
# define SETUP_XfOrM754(x) SETUP(XfOrM754_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  msg = NULLED_OUT ; 

# 4984 "bc/src/error.c"
  msg = FUNCCALL(SETUP_XfOrM754(_), error_message_adjust (buffer , alen , namelen , name_realm , msg_realm ) ); 
  eargs [0 ] = msg ; 

  eargs [1 ] = scheme_parameterization_key ; 
  if (errno_val ) {
    if (id == MZEXN_FAIL_FILESYSTEM ) {
      id = MZEXN_FAIL_FILESYSTEM_ERRNO ; 
      eargs [2 ] = errno_val ; 
      c ++ ; 
    }

# 4993 "bc/src/error.c"
    else if (id == MZEXN_FAIL_NETWORK ) {
      id = MZEXN_FAIL_NETWORK_ERRNO ; 
      eargs [2 ] = errno_val ; 
      c ++ ; 
    }
  }

# 4998 "bc/src/error.c"
  else if (unsupported ) {
    if (id == MZEXN_FAIL )
      id = MZEXN_FAIL_UNSUPPORTED ; 
  }
  (__funcarg153 = FUNCCALL_EMPTY(scheme_make_struct_instance (exn_table [id ] . type , c , eargs ) )

  , FUNCCALL_EMPTY(do_raise (__funcarg153 , 1 , 1 ) )) 

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5009 "bc/src/error.c"
void 
scheme_raise_exn (int id , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  intptr_t alen , namelen ; 
  char * msg ; 
  int i , c , unsupported = 0 ; 
  Scheme_Object * eargs [3 ] , * errno_val = ((void * ) 0 ) ; 
  char * buffer ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(errno_val, 0), PUSHARRAY(eargs, 3, 1), PUSH(buffer, 4)));
# define XfOrM759_COUNT (5)
# define SETUP_XfOrM759(x) SETUP(XfOrM759_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  msg = NULLED_OUT ; 
  eargs[0] = NULLED_OUT ; 
  eargs[1] = NULLED_OUT ; 
  eargs[2] = NULLED_OUT ; 
  buffer = NULLED_OUT ; 
  (
# 5019 "bc/src/error.c"
  rktio_remap_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 


  HIDE_FROM_XFORM (__builtin_va_start (args , id ) ) ; 

  if (id == MZEXN_OTHER )
    c = 3 ; 
  else 
  c = exn_table [id ] . args ; 

  for (i = 2 ; i < c ; i ++ ) {
    eargs [i ] = HIDE_FROM_XFORM (__builtin_va_arg (args , Scheme_Object * ) ) ; 
  }

  msg = HIDE_FROM_XFORM (__builtin_va_arg (args , char * ) ) ; 

  alen = FUNCCALL(SETUP_XfOrM759(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , & errno_val , & unsupported ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  namelen = - 1 ; 
  for (i = 0 ; i < alen ; i ++ ) {
    if (buffer [i ] == ':' ) {
      namelen = i ; 
      break ; 
    }
  }
  FUNCCALL(SETUP_XfOrM759(_), finish_raise_exn (id , c , eargs , namelen , scheme_primitive_realm , scheme_primitive_realm , buffer , alen , errno_val , unsupported ) )

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5050 "bc/src/error.c"
void 
scheme_raise_realm_exn (int id , 
intptr_t name_len , Scheme_Object * name_realm , Scheme_Object * msg_realm , 
... ) 
{
  GC_CAN_IGNORE va_list args ; 
  intptr_t alen ; 
  char * msg ; 
  int i , c , unsupported = 0 ; 
  Scheme_Object * eargs [3 ] , * errno_val = ((void * ) 0 ) ; 
  char * buffer ; 
  PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(name_realm, 0), PUSH(errno_val, 1), PUSHARRAY(eargs, 3, 2), PUSH(msg_realm, 5), PUSH(buffer, 6)));
# define XfOrM766_COUNT (7)
# define SETUP_XfOrM766(x) SETUP(XfOrM766_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  msg = NULLED_OUT ; 
  eargs[0] = NULLED_OUT ; 
  eargs[1] = NULLED_OUT ; 
  eargs[2] = NULLED_OUT ; 
  buffer = NULLED_OUT ; 
  (
# 5062 "bc/src/error.c"
  rktio_remap_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 


  HIDE_FROM_XFORM (__builtin_va_start (args , msg_realm ) ) ; 

  if (id == MZEXN_OTHER )
    c = 3 ; 
  else 
  c = exn_table [id ] . args ; 

  for (i = 2 ; i < c ; i ++ ) {
    eargs [i ] = HIDE_FROM_XFORM (__builtin_va_arg (args , Scheme_Object * ) ) ; 
  }

  msg = HIDE_FROM_XFORM (__builtin_va_arg (args , char * ) ) ; 

  alen = FUNCCALL(SETUP_XfOrM766(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , & errno_val , & unsupported ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  FUNCCALL(SETUP_XfOrM766(_), finish_raise_exn (id , c , eargs , name_len , name_realm , msg_realm , buffer , alen , errno_val , unsupported ) )

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5085 "bc/src/error.c"
static void 
def_exn_handler (int argc , Scheme_Object * argv [] ) 
{
  char * s ; 
  intptr_t len = - 1 ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(argv, 1)));
# define XfOrM769_COUNT (2)
# define SETUP_XfOrM769(x) SETUP(XfOrM769_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 

# 5091 "bc/src/error.c"
  if (((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && (scheme_is_struct_instance (exn_table [MZEXN ] . type , argv [0 ] ) ) ) {
    Scheme_Object * str ; 
    BLOCK_SETUP((PUSH(str, 0+XfOrM769_COUNT)));
#   define XfOrM771_COUNT (1+XfOrM769_COUNT)
#   define SETUP_XfOrM771(x) SETUP(XfOrM771_COUNT)
    str = NULLED_OUT ; 

# 5094 "bc/src/error.c"
    str = FUNCCALL(SETUP_XfOrM771(_), scheme_struct_ref (argv [0 ] , 0 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (str ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (str ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#     define XfOrM772_COUNT (0+XfOrM771_COUNT)
#     define SETUP_XfOrM772(x) SETUP_XfOrM771(x)

# 5096 "bc/src/error.c"
      str = FUNCCALL(SETUP_XfOrM772(_), scheme_char_string_to_byte_string (str ) ); 
      s = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) ; 
      len = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) ; 
    }

# 5099 "bc/src/error.c"
    else 
    s = "exception raised [message field is not a string]" ; 
  }

# 5101 "bc/src/error.c"
  else {
    char * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM769_COUNT)));
#   define XfOrM770_COUNT (1+XfOrM769_COUNT)
#   define SETUP_XfOrM770(x) SETUP(XfOrM770_COUNT)
    v = NULLED_OUT ; 

# 5104 "bc/src/error.c"
    v = FUNCCALL(SETUP_XfOrM770(_), scheme_make_provided_string (argv [0 ] , 1 , & len ) ); 
    s = FUNCCALL_AGAIN(GC_malloc_atomic (len + 21 ) ); 
    (memcpy (s , "uncaught exception: " , 20 ) ) ; 
    (memcpy (s + 20 , v , len + 1 ) ) ; 
    len += 20 ; 
  }
  FUNCCALL_EMPTY(call_error (s , len , argv [0 ] ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5114 "bc/src/error.c"
static Scheme_Object * 
init_exn_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5117 "bc/src/error.c"
  return scheme_param_config ("uncaught-exception-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_INIT_EXN_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static void 
nested_exn_handler (void * old_exn , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * arg = argv [0 ] , * orig_arg = (((Scheme_Simple_Object * ) ((Scheme_Object * ) old_exn ) ) -> u . pair_val . cdr ) ; 
  intptr_t len , mlen = - 1 , orig_mlen = - 1 , blen ; 
  char * buffer , * msg , * orig_msg , * raisetype , * orig_raisetype , * who , * sep ; 
  PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(buffer, 0), PUSH(sep, 1), PUSH(arg, 2), PUSH(who, 3), PUSH(orig_arg, 4), PUSH(old_exn, 5), PUSH(msg, 6), PUSH(raisetype, 7), PUSH(orig_msg, 8), PUSH(orig_raisetype, 9)));
# define XfOrM774_COUNT (10)
# define SETUP_XfOrM774(x) SETUP(XfOrM774_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  buffer = NULLED_OUT ; 
  msg = NULLED_OUT ; 
  orig_msg = NULLED_OUT ; 
  raisetype = NULLED_OUT ; 
  orig_raisetype = NULLED_OUT ; 
  who = NULLED_OUT ; 
  sep = NULLED_OUT ; 

# 5130 "bc/src/error.c"
  buffer = FUNCCALL(SETUP_XfOrM774(_), init_buf (& len , & blen ) ); 

  if ((((((Scheme_Simple_Object * ) ((Scheme_Object * ) old_exn ) ) -> u . pair_val . car ) ) ) == (scheme_false ) )  {
    raisetype = "" ; 
    sep = "" ; 
    who = "handler for uncaught exceptions" ; 
    msg = "did not escape" ; 
  }

# 5137 "bc/src/error.c"
  else {
#   define XfOrM777_COUNT (0+XfOrM774_COUNT)
#   define SETUP_XfOrM777(x) SETUP_XfOrM774(x)

# 5138 "bc/src/error.c"
    who = (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((Scheme_Object * ) old_exn ) ) -> u . pair_val . car ) ) ) -> u . byte_str_val . string_val ) ; 
    sep = " by " ; 

    if (((((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && (scheme_is_struct_instance (exn_table [MZEXN ] . type , arg ) ) ) {
      Scheme_Object * str ; 
      BLOCK_SETUP((PUSH(str, 0+XfOrM777_COUNT)));
#     define XfOrM779_COUNT (1+XfOrM777_COUNT)
#     define SETUP_XfOrM779(x) SETUP(XfOrM779_COUNT)
      str = NULLED_OUT ; 

# 5144 "bc/src/error.c"
      str = FUNCCALL(SETUP_XfOrM779(_), scheme_struct_ref (arg , 0 ) ); 
      raisetype = "exception raised" ; 
      str = FUNCCALL(SETUP_XfOrM779(_), scheme_char_string_to_byte_string (str ) ); 
      msg = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) ; 
      mlen = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) ; 
    }

# 5149 "bc/src/error.c"
    else {
#     define XfOrM778_COUNT (0+XfOrM777_COUNT)
#     define SETUP_XfOrM778(x) SETUP_XfOrM777(x)

# 5150 "bc/src/error.c"
      msg = FUNCCALL(SETUP_XfOrM778(_), error_write_to_string_w_max (arg , len , ((void * ) 0 ) ) ); 
      raisetype = "raise called (with non-exception value)" ; 
    }
  }

  if (((((Scheme_Type ) (((((intptr_t ) (orig_arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_arg ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (orig_arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (orig_arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_arg ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (orig_arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) orig_arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) orig_arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) orig_arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) orig_arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && (scheme_is_struct_instance (exn_table [MZEXN ] . type , orig_arg ) ) ) {
    Scheme_Object * str ; 
    BLOCK_SETUP((PUSH(str, 0+XfOrM774_COUNT)));
#   define XfOrM776_COUNT (1+XfOrM774_COUNT)
#   define SETUP_XfOrM776(x) SETUP(XfOrM776_COUNT)
    str = NULLED_OUT ; 

# 5158 "bc/src/error.c"
    str = FUNCCALL(SETUP_XfOrM776(_), scheme_struct_ref (orig_arg , 0 ) ); 
    orig_raisetype = "exception raised" ; 
    str = FUNCCALL(SETUP_XfOrM776(_), scheme_char_string_to_byte_string (str ) ); 
    orig_msg = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) ; 
    orig_mlen = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) ; 
  }

# 5163 "bc/src/error.c"
  else {
#   define XfOrM775_COUNT (0+XfOrM774_COUNT)
#   define SETUP_XfOrM775(x) SETUP_XfOrM774(x)

# 5164 "bc/src/error.c"
    orig_msg = FUNCCALL(SETUP_XfOrM775(_), error_write_to_string_w_max (orig_arg , len , ((void * ) 0 ) ) ); 
    orig_raisetype = "raise called (with non-exception value)" ; 
  }


  blen = FUNCCALL(SETUP_XfOrM774(_), scheme_sprintf (buffer , blen , "%s%s%s: %t; original %s: %t" , raisetype , sep , who , msg , mlen , orig_raisetype , orig_msg , orig_mlen ) )



  ; 
  FUNCCALL_EMPTY(call_error (buffer , blen , scheme_false ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5178 "bc/src/error.c"
static void * do_raise_inside_barrier (void ) 
{
  Scheme_Object * arg ; 
  Scheme_Object * v , * p [1 ] , * h , * marks ; 
  Scheme_Cont_Mark_Chain * chain ; 
  Scheme_Cont_Frame_Data cframe , cframe2 ; 
  int got_chain ; 
  Scheme_Config * __funcarg159 = NULLED_OUT ; 
  Scheme_Object * __funcarg158 = NULLED_OUT ; 
  Scheme_Object * __funcarg157 = NULLED_OUT ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSH(marks, 0), PUSH(h, 1), PUSHARRAY(p, 1, 2), PUSH(cframe.cache, 5), PUSH(v, 6), PUSH(chain, 7), PUSH(arg, 8), PUSH(cframe2.cache, 9)));
# define XfOrM781_COUNT (10)
# define SETUP_XfOrM781(x) SETUP(XfOrM781_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  arg = NULLED_OUT ; 
  v = NULLED_OUT ; 
  p[0] = NULLED_OUT ; 
  h = NULLED_OUT ; 
  marks = NULLED_OUT ; 
  chain = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  cframe2.cache = NULLED_OUT ; 

# 5186 "bc/src/error.c"
  arg = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 = ((void * ) 0 ) ; 

  h = FUNCCALL(SETUP_XfOrM781(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_exn_handler_key ) ); 

  chain = ((void * ) 0 ) ; 
  got_chain = 0 ; 

  while (1 ) {
#   define XfOrM791_COUNT (0+XfOrM781_COUNT)
#   define SETUP_XfOrM791(x) SETUP_XfOrM781(x)

# 5195 "bc/src/error.c"
    if (! h ) {
#     define XfOrM799_COUNT (0+XfOrM791_COUNT)
#     define SETUP_XfOrM799(x) SETUP_XfOrM791(x)

# 5196 "bc/src/error.c"
      h = (__funcarg159 = FUNCCALL(SETUP_XfOrM799(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg159 , MZCONFIG_INIT_EXN_HANDLER ) )) ; 
      chain = ((void * ) 0 ) ; 
      got_chain = 1 ; 
    }

    v = FUNCCALL(SETUP_XfOrM791(_), scheme_make_byte_string_without_copying ("exception handler" ) ); 
    v = (__funcarg158 = FUNCCALL(SETUP_XfOrM791(_), scheme_make_pair (v , arg ) )
    , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity ((Scheme_Closed_Prim * ) nested_exn_handler , __funcarg158 , "nested-exception-handler" , 1 , 1 ) )) 

    ; 
    FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )
    ; 
    FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_exn_handler_key , v ) ); 
    FUNCCALL_AGAIN(scheme_push_break_enable (& cframe2 , 0 , 0 ) ); 

    p [0 ] = arg ; 
    v = FUNCCALL(SETUP_XfOrM791(_), scheme_do_eval (h , 1 , p , 1 ) ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe2 , 0 ) )
    ; 
    FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) ); 




    if (! got_chain ) {
#     define XfOrM796_COUNT (0+XfOrM791_COUNT)
#     define SETUP_XfOrM796(x) SETUP_XfOrM791(x)

# 5221 "bc/src/error.c"
      marks = FUNCCALL(SETUP_XfOrM796(_), scheme_all_current_continuation_marks () ); 
      chain = ((Scheme_Cont_Mark_Set * ) marks ) -> chain ; 
      marks = ((void * ) 0 ) ; 


      while (chain -> key != scheme_exn_handler_key ) {
        chain = chain -> next ; 
      }
      got_chain = 1 ; 
    }

    if (chain ) {
      chain = chain -> next ; 
      while (chain && (chain -> key != scheme_exn_handler_key ) ) {
        chain = chain -> next ; 
      }

      if (! chain )
        h = ((void * ) 0 ) ; 
      else 
      h = chain -> val ; 
      arg = v ; 
    }

# 5243 "bc/src/error.c"
    else {
#     define XfOrM792_COUNT (0+XfOrM791_COUNT)
#     define SETUP_XfOrM792(x) SETUP_XfOrM791(x)

# 5245 "bc/src/error.c"
      p [0 ] = scheme_false ; 
      (__funcarg157 = FUNCCALL(SETUP_XfOrM792(_), scheme_make_pair (scheme_false , arg ) ), FUNCCALL_AGAIN(nested_exn_handler (__funcarg157 , 1 , p ) )) ; 

      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5254 "bc/src/error.c"
static void 
do_raise (Scheme_Object * arg , int need_debug , int eb ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  char * __funcarg161 = NULLED_OUT ; 
  Scheme_Logger * __funcarg160 = NULLED_OUT ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(arg, 0), PUSH(p, 1), PUSH(__funcarg160, 2)));
# define XfOrM800_COUNT (3)
# define SETUP_XfOrM800(x) SETUP(XfOrM800_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5259 "bc/src/error.c"
  if (p -> constant_folding ) {
#   define XfOrM803_COUNT (0+XfOrM800_COUNT)
#   define SETUP_XfOrM803(x) SETUP_XfOrM800(x)

# 5260 "bc/src/error.c"
    if (p -> constant_folding != (Optimize_Info * ) scheme_false ) {
      const char * msg ; 
      BLOCK_SETUP((PUSH(msg, 0+XfOrM803_COUNT)));
#     define XfOrM805_COUNT (1+XfOrM803_COUNT)
#     define SETUP_XfOrM805(x) SETUP(XfOrM805_COUNT)
      msg = NULLED_OUT ; 

# 5262 "bc/src/error.c"
      if (need_debug ) {
#       define XfOrM806_COUNT (0+XfOrM805_COUNT)
#       define SETUP_XfOrM806(x) SETUP_XfOrM805(x)

# 5263 "bc/src/error.c"
        msg = FUNCCALL(SETUP_XfOrM806(_), scheme_display_to_string (((Scheme_Structure * ) arg ) -> slots [0 ] , ((void * ) 0 ) ) ); 
      }

# 5264 "bc/src/error.c"
      else 
      msg = FUNCCALL(SETUP_XfOrM805(_), scheme_print_to_string (arg , ((void * ) 0 ) ) ); 
      (__funcarg160 = FUNCCALL(SETUP_XfOrM805(_), scheme_optimize_info_logger (p -> constant_folding ) ), __funcarg161 = FUNCCALL(SETUP_XfOrM805(_), scheme_optimize_info_context (p -> constant_folding ) )



      , FUNCCALL_AGAIN(scheme_log (__funcarg160 , 3 , 0 , "warning%s: constant-fold attempt failed: %s" , __funcarg161 , msg ) )) 
      ; 
    }
    if (((((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && (scheme_is_struct_instance (exn_table [MZEXN_BREAK ] . type , arg ) ) ) {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = arg ; 
    }
    (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  }

  if (need_debug ) {
    Scheme_Object * marks ; 
    BLOCK_SETUP((PUSH(marks, 0+XfOrM800_COUNT)));
#   define XfOrM802_COUNT (1+XfOrM800_COUNT)
#   define SETUP_XfOrM802(x) SETUP(XfOrM802_COUNT)
    marks = NULLED_OUT ; 

# 5283 "bc/src/error.c"
    marks = FUNCCALL(SETUP_XfOrM802(_), scheme_current_continuation_marks (((void * ) 0 ) ) ); 
    ((Scheme_Structure * ) arg ) -> slots [1 ] = marks ; 
  }

  p -> ku . k . p1 = arg ; 

  if (eb ) {
#   define XfOrM801_COUNT (0+XfOrM800_COUNT)
#   define SETUP_XfOrM801(x) SETUP_XfOrM800(x)
    FUNCCALL_EMPTY(scheme_top_level_do (do_raise_inside_barrier , 1 ) )
# 5290 "bc/src/error.c"
    ; 
    FUNCCALL_EMPTY(__builtin_unreachable () ); 
  }
  else FUNCCALL_EMPTY(do_raise_inside_barrier () )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5297 "bc/src/error.c"
static void 
sch_raise (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM807_COUNT (1)
# define SETUP_XfOrM807(x) SETUP(XfOrM807_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5300 "bc/src/error.c"
  if ((argc > 1 ) && (((argv [1 ] ) ) == (scheme_false ) ) )
    FUNCCALL(SETUP_XfOrM807(_), do_raise (argv [0 ] , 0 , 0 ) ); 
  else FUNCCALL_EMPTY(do_raise (argv [0 ] , 0 , 1 ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5306 "bc/src/error.c"
void scheme_raise (Scheme_Object * exn ) 
{
  /* No conversion */

# 5308 "bc/src/error.c"
  do_raise (exn , 0 , 1 ) ; 
}

typedef Scheme_Object (* Scheme_Struct_Field_Guard_Proc ) (int argc , Scheme_Object * v ) ; 

static Scheme_Object * exn_field_check (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * a [2 ] , * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(argv, 3), PUSH(v, 4)));
# define XfOrM809_COUNT (5)
# define SETUP_XfOrM809(x) SETUP(XfOrM809_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 5317 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL(SETUP_XfOrM809(_), scheme_wrong_field_contract (argv [2 ] , "string?" , argv [0 ] ) ); 
  if (! ((argv [1 ] ) == (scheme_parameterization_key ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) )
    FUNCCALL(SETUP_XfOrM809(_), scheme_wrong_field_contract (argv [2 ] , "continuation-mark-set?" , argv [1 ] ) ); 

  a [0 ] = argv [0 ] ; 
  a [1 ] = argv [1 ] ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (a [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) && (((Scheme_Inclhash_Object * ) (a [0 ] ) ) -> so . keyex & 0x1 ) ) ) {
#   define XfOrM810_COUNT (0+XfOrM809_COUNT)
#   define SETUP_XfOrM810(x) SETUP_XfOrM809(x)

# 5326 "bc/src/error.c"
    v = FUNCCALL(SETUP_XfOrM810(_), scheme_make_immutable_sized_char_string ((((Scheme_Simple_Object * ) (a [0 ] ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (a [0 ] ) ) -> u . char_str_val . tag_val ) , 1 ) )

    ; 
    a [0 ] = v ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM809(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5335 "bc/src/error.c"
static Scheme_Object * variable_field_check (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM811_COUNT (1)
# define SETUP_XfOrM811(x) SETUP(XfOrM811_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5337 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL(SETUP_XfOrM811(_), scheme_wrong_field_contract (argv [3 ] , "symbol?" , argv [2 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (3 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5343 "bc/src/error.c"
static Scheme_Object * read_field_check (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * l ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(argv, 1)));
# define XfOrM812_COUNT (2)
# define SETUP_XfOrM812(x) SETUP(XfOrM812_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 

# 5347 "bc/src/error.c"
  l = argv [2 ] ; 
  while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM814_COUNT (0+XfOrM812_COUNT)
#   define SETUP_XfOrM814(x) SETUP_XfOrM812(x)

# 5349 "bc/src/error.c"
    if (! FUNCCALL(SETUP_XfOrM814(_), scheme_is_location ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ))
      break ; 
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  if (! ((l ) == (scheme_null ) ) )
    FUNCCALL(SETUP_XfOrM812(_), scheme_wrong_field_contract (argv [3 ] , "(listof srcloc?)" , argv [2 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (3 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5360 "bc/src/error.c"
static Scheme_Object * break_field_check (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM815_COUNT (1)
# define SETUP_XfOrM815(x) SETUP(XfOrM815_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5362 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) ) )
    FUNCCALL(SETUP_XfOrM815(_), scheme_wrong_field_contract (argv [3 ] , "escape-continuation?" , argv [2 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (3 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5368 "bc/src/error.c"
static Scheme_Object * errno_field_check (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM816_COUNT (1)
# define SETUP_XfOrM816(x) SETUP(XfOrM816_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5370 "bc/src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  || ! FUNCCALL(SETUP_XfOrM816(_), scheme_exact_p ((((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . pair_val . car ) ) )
  || ! ((((((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . pair_val . cdr ) ) == (posix_symbol ) ) 
  || (((((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . pair_val . cdr ) ) == (windows_symbol ) ) 
  || (((((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . pair_val . cdr ) ) == (gai_symbol ) ) ) )
    FUNCCALL(SETUP_XfOrM816(_), scheme_wrong_field_contract (argv [3 ] , "(cons/c exact-integer? (or/c 'posix 'windows 'gai))" , argv [2 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (3 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5380 "bc/src/error.c"
static Scheme_Object * extract_read_locations (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5382 "bc/src/error.c"
  if (scheme_is_struct_instance (exn_table [MZEXN_FAIL_READ ] . type , argv [0 ] ) )
    return scheme_struct_ref (argv [0 ] , 2 ) ; 
  scheme_wrong_contract ("exn:fail:read-locations-accessor" , "exn:fail:read?" , 0 , argc , argv ) ; 
  return ((void * ) 0 ) ; 
}

void scheme_init_exn (Scheme_Startup_Env * env ) 
{
  int i , j ; 
  Scheme_Object * tmpo , * * tmpop ; 

# 100 "bc/src/schexn.h"
  static const char * MZEXN_FIELDS [2 ] = {

# 100 "bc/src/schexn.h"
    "message" , "continuation-marks" }

# 100 "bc/src/schexn.h"
  ; 
  static const char * MZEXN_FAIL_CONTRACT_VARIABLE_FIELDS [1 ] = {

# 101 "bc/src/schexn.h"
    "id" }

# 101 "bc/src/schexn.h"
  ; 
  static const char * MZEXN_FAIL_READ_FIELDS [1 ] = {

# 102 "bc/src/schexn.h"
    "srclocs" }

# 102 "bc/src/schexn.h"
  ; 
  static const char * MZEXN_FAIL_FILESYSTEM_ERRNO_FIELDS [1 ] = {

# 103 "bc/src/schexn.h"
    "errno" }

# 103 "bc/src/schexn.h"
  ; 
  static const char * MZEXN_FAIL_NETWORK_ERRNO_FIELDS [1 ] = {

# 104 "bc/src/schexn.h"
    "errno" }

# 104 "bc/src/schexn.h"
  ; 
  static const char * MZEXN_BREAK_FIELDS [1 ] = {

# 105 "bc/src/schexn.h"
    "continuation" }

# 105 "bc/src/schexn.h"
  ; 
  Scheme_Object * __funcarg172 = NULLED_OUT ; 
  Scheme_Object * __funcarg171 = NULLED_OUT ; 
  Scheme_Object * __funcarg170 = NULLED_OUT ; 
  Scheme_Object * __funcarg169 = NULLED_OUT ; 
  Scheme_Object * __funcarg168 = NULLED_OUT ; 
  Scheme_Object * __funcarg167 = NULLED_OUT ; 
  Scheme_Object * __funcarg166 = NULLED_OUT ; 
  Scheme_Object * __funcarg165 = NULLED_OUT ; 
  Scheme_Object * __funcarg164 = NULLED_OUT ; 
  Scheme_Object * __funcarg163 = NULLED_OUT ; 
  Scheme_Object * __funcarg162 = NULLED_OUT ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(tmpo, 0), PUSH(env, 1), PUSH(tmpop, 2), PUSH(__funcarg167, 3)));
# define XfOrM818_COUNT (4)
# define SETUP_XfOrM818(x) SETUP(XfOrM818_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  tmpo = NULLED_OUT ; 
  tmpop = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM818(_), scheme_register_static ((void * ) & exn_table , sizeof (exn_table ) ) )
# 5400 "bc/src/error.c"
  ; 

# 71 "bc/src/schexn.h"
  exn_table = (exn_rec * ) FUNCCALL(SETUP_XfOrM818(_), GC_malloc (sizeof (exn_rec ) * MZEXN_OTHER ) ); 
  exn_table [MZEXN ] . args = 2 ; 
  exn_table [MZEXN_FAIL ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_ARITY ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_CONTINUATION ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . args = 3 ; 
  exn_table [MZEXN_FAIL_READ ] . args = 3 ; 
  exn_table [MZEXN_FAIL_READ_EOF ] . args = 3 ; 
  exn_table [MZEXN_FAIL_READ_NON_CHAR ] . args = 3 ; 
  exn_table [MZEXN_FAIL_FILESYSTEM ] . args = 2 ; 
  exn_table [MZEXN_FAIL_FILESYSTEM_EXISTS ] . args = 2 ; 
  exn_table [MZEXN_FAIL_FILESYSTEM_VERSION ] . args = 2 ; 
  exn_table [MZEXN_FAIL_FILESYSTEM_ERRNO ] . args = 3 ; 
  exn_table [MZEXN_FAIL_NETWORK ] . args = 2 ; 
  exn_table [MZEXN_FAIL_NETWORK_ERRNO ] . args = 3 ; 
  exn_table [MZEXN_FAIL_OUT_OF_MEMORY ] . args = 2 ; 
  exn_table [MZEXN_FAIL_UNSUPPORTED ] . args = 2 ; 
  exn_table [MZEXN_FAIL_USER ] . args = 2 ; 
  exn_table [MZEXN_BREAK ] . args = 3 ; 
  exn_table [MZEXN_BREAK_HANG_UP ] . args = 3 ; 
  exn_table [MZEXN_BREAK_TERMINATE ] . args = 3 ; 

# 113 "bc/src/schexn.h"
  {
#   define XfOrM849_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM849(x) SETUP_XfOrM818(x)

# 113 "bc/src/schexn.h"
    tmpo = (__funcarg172 = FUNCCALL(SETUP_XfOrM849(_), scheme_make_prim_w_arity (exn_field_check , "exn_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn" , ((void * ) 0 ) , 2 , scheme_null , __funcarg172 , 1 ) )) ; 

# 113 "bc/src/schexn.h"
    exn_table [MZEXN ] . type = tmpo ; 

# 113 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM849(_), scheme_make_struct_names_from_array ("exn" , 2 , MZEXN_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN ] . count ) ); 

# 113 "bc/src/schexn.h"
    exn_table [MZEXN ] . names = tmpop ; 
  }

# 114 "bc/src/schexn.h"
  {
#   define XfOrM848_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM848(x) SETUP_XfOrM818(x)

# 114 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM848(_), scheme_make_struct_type_from_string ("exn:fail" , exn_table [MZEXN ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 114 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL ] . type = tmpo ; 

# 114 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM848(_), scheme_make_struct_names_from_array ("exn:fail" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL ] . count ) ); 

# 114 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL ] . names = tmpop ; 
  }

# 115 "bc/src/schexn.h"
  {
#   define XfOrM847_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM847(x) SETUP_XfOrM818(x)

# 115 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM847(_), scheme_make_struct_type_from_string ("exn:fail:contract" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 115 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT ] . type = tmpo ; 

# 115 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM847(_), scheme_make_struct_names_from_array ("exn:fail:contract" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT ] . count ) ); 

# 115 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT ] . names = tmpop ; 
  }

# 116 "bc/src/schexn.h"
  {
#   define XfOrM846_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM846(x) SETUP_XfOrM818(x)

# 116 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM846(_), scheme_make_struct_type_from_string ("exn:fail:contract:arity" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 116 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_ARITY ] . type = tmpo ; 

# 116 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM846(_), scheme_make_struct_names_from_array ("exn:fail:contract:arity" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_ARITY ] . count ) ); 

# 116 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_ARITY ] . names = tmpop ; 
  }

# 117 "bc/src/schexn.h"
  {
#   define XfOrM845_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM845(x) SETUP_XfOrM818(x)

# 117 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM845(_), scheme_make_struct_type_from_string ("exn:fail:contract:divide-by-zero" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 117 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO ] . type = tmpo ; 

# 117 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM845(_), scheme_make_struct_names_from_array ("exn:fail:contract:divide-by-zero" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO ] . count ) ); 

# 117 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO ] . names = tmpop ; 
  }

# 118 "bc/src/schexn.h"
  {
#   define XfOrM844_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM844(x) SETUP_XfOrM818(x)

# 118 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM844(_), scheme_make_struct_type_from_string ("exn:fail:contract:non-fixnum-result" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 118 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT ] . type = tmpo ; 

# 118 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM844(_), scheme_make_struct_names_from_array ("exn:fail:contract:non-fixnum-result" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT ] . count ) ); 

# 118 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT ] . names = tmpop ; 
  }

# 119 "bc/src/schexn.h"
  {
#   define XfOrM843_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM843(x) SETUP_XfOrM818(x)

# 119 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM843(_), scheme_make_struct_type_from_string ("exn:fail:contract:continuation" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 119 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_CONTINUATION ] . type = tmpo ; 

# 119 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM843(_), scheme_make_struct_names_from_array ("exn:fail:contract:continuation" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_CONTINUATION ] . count ) ); 

# 119 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_CONTINUATION ] . names = tmpop ; 
  }

# 120 "bc/src/schexn.h"
  {
#   define XfOrM842_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM842(x) SETUP_XfOrM818(x)

# 120 "bc/src/schexn.h"
    tmpo = (__funcarg171 = FUNCCALL(SETUP_XfOrM842(_), scheme_make_prim_w_arity (variable_field_check , "variable_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:fail:contract:variable" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 1 , scheme_null , __funcarg171 , 1 ) )) ; 

# 120 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . type = tmpo ; 

# 120 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM842(_), scheme_make_struct_names_from_array ("exn:fail:contract:variable" , 1 , MZEXN_FAIL_CONTRACT_VARIABLE_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . count ) ); 

# 120 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . names = tmpop ; 
  }

# 121 "bc/src/schexn.h"
  {
#   define XfOrM841_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM841(x) SETUP_XfOrM818(x)

# 121 "bc/src/schexn.h"
    tmpo = (__funcarg167 = (__funcarg169 = (__funcarg170 = FUNCCALL(SETUP_XfOrM841(_), scheme_make_prim_w_arity (extract_read_locations , "extract_read_locations" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_pair (scheme_source_property , __funcarg170 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg169 , scheme_null ) )) , __funcarg168 = FUNCCALL(SETUP_XfOrM841(_), scheme_make_prim_w_arity (read_field_check , "read_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:fail:read" , exn_table [MZEXN_FAIL ] . type , 1 , __funcarg167 , __funcarg168 , 1 ) )) ; 

# 121 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_READ ] . type = tmpo ; 

# 121 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM841(_), scheme_make_struct_names_from_array ("exn:fail:read" , 1 , MZEXN_FAIL_READ_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_READ ] . count ) ); 

# 121 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_READ ] . names = tmpop ; 
  }

# 122 "bc/src/schexn.h"
  {
#   define XfOrM840_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM840(x) SETUP_XfOrM818(x)

# 122 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM840(_), scheme_make_struct_type_from_string ("exn:fail:read:eof" , exn_table [MZEXN_FAIL_READ ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 122 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_READ_EOF ] . type = tmpo ; 

# 122 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM840(_), scheme_make_struct_names_from_array ("exn:fail:read:eof" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_READ_EOF ] . count ) ); 

# 122 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_READ_EOF ] . names = tmpop ; 
  }

# 123 "bc/src/schexn.h"
  {
#   define XfOrM839_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM839(x) SETUP_XfOrM818(x)

# 123 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM839(_), scheme_make_struct_type_from_string ("exn:fail:read:non-char" , exn_table [MZEXN_FAIL_READ ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 123 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_READ_NON_CHAR ] . type = tmpo ; 

# 123 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM839(_), scheme_make_struct_names_from_array ("exn:fail:read:non-char" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_READ_NON_CHAR ] . count ) ); 

# 123 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_READ_NON_CHAR ] . names = tmpop ; 
  }

# 124 "bc/src/schexn.h"
  {
#   define XfOrM838_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM838(x) SETUP_XfOrM818(x)

# 124 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM838(_), scheme_make_struct_type_from_string ("exn:fail:filesystem" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 124 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM ] . type = tmpo ; 

# 124 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM838(_), scheme_make_struct_names_from_array ("exn:fail:filesystem" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_FILESYSTEM ] . count ) ); 

# 124 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM ] . names = tmpop ; 
  }

# 125 "bc/src/schexn.h"
  {
#   define XfOrM837_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM837(x) SETUP_XfOrM818(x)

# 125 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM837(_), scheme_make_struct_type_from_string ("exn:fail:filesystem:exists" , exn_table [MZEXN_FAIL_FILESYSTEM ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 125 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_EXISTS ] . type = tmpo ; 

# 125 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM837(_), scheme_make_struct_names_from_array ("exn:fail:filesystem:exists" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_FILESYSTEM_EXISTS ] . count ) ); 

# 125 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_EXISTS ] . names = tmpop ; 
  }

# 126 "bc/src/schexn.h"
  {
#   define XfOrM836_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM836(x) SETUP_XfOrM818(x)

# 126 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM836(_), scheme_make_struct_type_from_string ("exn:fail:filesystem:version" , exn_table [MZEXN_FAIL_FILESYSTEM ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 126 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_VERSION ] . type = tmpo ; 

# 126 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM836(_), scheme_make_struct_names_from_array ("exn:fail:filesystem:version" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_FILESYSTEM_VERSION ] . count ) ); 

# 126 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_VERSION ] . names = tmpop ; 
  }

# 127 "bc/src/schexn.h"
  {
#   define XfOrM835_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM835(x) SETUP_XfOrM818(x)

# 127 "bc/src/schexn.h"
    tmpo = (__funcarg166 = FUNCCALL(SETUP_XfOrM835(_), scheme_make_prim_w_arity (errno_field_check , "errno_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:fail:filesystem:errno" , exn_table [MZEXN_FAIL_FILESYSTEM ] . type , 1 , scheme_null , __funcarg166 , 1 ) )) ; 

# 127 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_ERRNO ] . type = tmpo ; 

# 127 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM835(_), scheme_make_struct_names_from_array ("exn:fail:filesystem:errno" , 1 , MZEXN_FAIL_FILESYSTEM_ERRNO_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_FILESYSTEM_ERRNO ] . count ) ); 

# 127 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_ERRNO ] . names = tmpop ; 
  }

# 128 "bc/src/schexn.h"
  {
#   define XfOrM834_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM834(x) SETUP_XfOrM818(x)

# 128 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM834(_), scheme_make_struct_type_from_string ("exn:fail:network" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 128 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_NETWORK ] . type = tmpo ; 

# 128 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM834(_), scheme_make_struct_names_from_array ("exn:fail:network" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_NETWORK ] . count ) ); 

# 128 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_NETWORK ] . names = tmpop ; 
  }

# 129 "bc/src/schexn.h"
  {
#   define XfOrM833_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM833(x) SETUP_XfOrM818(x)

# 129 "bc/src/schexn.h"
    tmpo = (__funcarg165 = FUNCCALL(SETUP_XfOrM833(_), scheme_make_prim_w_arity (errno_field_check , "errno_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:fail:network:errno" , exn_table [MZEXN_FAIL_NETWORK ] . type , 1 , scheme_null , __funcarg165 , 1 ) )) ; 

# 129 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_NETWORK_ERRNO ] . type = tmpo ; 

# 129 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM833(_), scheme_make_struct_names_from_array ("exn:fail:network:errno" , 1 , MZEXN_FAIL_NETWORK_ERRNO_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_NETWORK_ERRNO ] . count ) ); 

# 129 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_NETWORK_ERRNO ] . names = tmpop ; 
  }

# 130 "bc/src/schexn.h"
  {
#   define XfOrM832_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM832(x) SETUP_XfOrM818(x)

# 130 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM832(_), scheme_make_struct_type_from_string ("exn:fail:out-of-memory" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 130 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_OUT_OF_MEMORY ] . type = tmpo ; 

# 130 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM832(_), scheme_make_struct_names_from_array ("exn:fail:out-of-memory" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_OUT_OF_MEMORY ] . count ) ); 

# 130 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_OUT_OF_MEMORY ] . names = tmpop ; 
  }

# 131 "bc/src/schexn.h"
  {
#   define XfOrM831_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM831(x) SETUP_XfOrM818(x)

# 131 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM831(_), scheme_make_struct_type_from_string ("exn:fail:unsupported" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 131 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_UNSUPPORTED ] . type = tmpo ; 

# 131 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM831(_), scheme_make_struct_names_from_array ("exn:fail:unsupported" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_UNSUPPORTED ] . count ) ); 

# 131 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_UNSUPPORTED ] . names = tmpop ; 
  }

# 132 "bc/src/schexn.h"
  {
#   define XfOrM830_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM830(x) SETUP_XfOrM818(x)

# 132 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM830(_), scheme_make_struct_type_from_string ("exn:fail:user" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 132 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_USER ] . type = tmpo ; 

# 132 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM830(_), scheme_make_struct_names_from_array ("exn:fail:user" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_USER ] . count ) ); 

# 132 "bc/src/schexn.h"
    exn_table [MZEXN_FAIL_USER ] . names = tmpop ; 
  }

# 133 "bc/src/schexn.h"
  {
#   define XfOrM829_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM829(x) SETUP_XfOrM818(x)

# 133 "bc/src/schexn.h"
    tmpo = (__funcarg164 = FUNCCALL(SETUP_XfOrM829(_), scheme_make_prim_w_arity (break_field_check , "break_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:break" , exn_table [MZEXN ] . type , 1 , scheme_null , __funcarg164 , 1 ) )) ; 

# 133 "bc/src/schexn.h"
    exn_table [MZEXN_BREAK ] . type = tmpo ; 

# 133 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM829(_), scheme_make_struct_names_from_array ("exn:break" , 1 , MZEXN_BREAK_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_BREAK ] . count ) ); 

# 133 "bc/src/schexn.h"
    exn_table [MZEXN_BREAK ] . names = tmpop ; 
  }

# 134 "bc/src/schexn.h"
  {
#   define XfOrM828_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM828(x) SETUP_XfOrM818(x)

# 134 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM828(_), scheme_make_struct_type_from_string ("exn:break:hang-up" , exn_table [MZEXN_BREAK ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 134 "bc/src/schexn.h"
    exn_table [MZEXN_BREAK_HANG_UP ] . type = tmpo ; 

# 134 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM828(_), scheme_make_struct_names_from_array ("exn:break:hang-up" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_BREAK_HANG_UP ] . count ) ); 

# 134 "bc/src/schexn.h"
    exn_table [MZEXN_BREAK_HANG_UP ] . names = tmpop ; 
  }

# 135 "bc/src/schexn.h"
  {
#   define XfOrM827_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM827(x) SETUP_XfOrM818(x)

# 135 "bc/src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM827(_), scheme_make_struct_type_from_string ("exn:break:terminate" , exn_table [MZEXN_BREAK ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 135 "bc/src/schexn.h"
    exn_table [MZEXN_BREAK_TERMINATE ] . type = tmpo ; 

# 135 "bc/src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM827(_), scheme_make_struct_names_from_array ("exn:break:terminate" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_BREAK_TERMINATE ] . count ) ); 

# 135 "bc/src/schexn.h"
    exn_table [MZEXN_BREAK_TERMINATE ] . names = tmpop ; 
  }

# 5426 "bc/src/error.c"
  for (i = 0 ; i < MZEXN_OTHER ; i ++ ) {
#   define XfOrM823_COUNT (0+XfOrM818_COUNT)
#   define SETUP_XfOrM823(x) SETUP_XfOrM818(x)

# 5427 "bc/src/error.c"
    if (exn_table [i ] . count ) {
      Scheme_Object * * values ; 
      BLOCK_SETUP((PUSH(values, 0+XfOrM823_COUNT)));
#     define XfOrM824_COUNT (1+XfOrM823_COUNT)
#     define SETUP_XfOrM824(x) SETUP(XfOrM824_COUNT)
      values = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM824(_), scheme_force_struct_type_info ((Scheme_Struct_Type * ) exn_table [i ] . type ) )
# 5430 "bc/src/error.c"
      ; 
      values = FUNCCALL_AGAIN(scheme_make_struct_values (exn_table [i ] . type , exn_table [i ] . names , exn_table [i ] . count , (0x80 | 0x10 | 0x100 | 0x400 ) ) )


      ; 
      for (j = exn_table [i ] . count - 1 ; j -- ; ) {
#       define XfOrM826_COUNT (0+XfOrM824_COUNT)
#       define SETUP_XfOrM826(x) SETUP_XfOrM824(x)
        FUNCCALL(SETUP_XfOrM826(_), scheme_addto_primitive_instance_by_symbol (exn_table [i ] . names [j ] , values [j ] , env ) ); 
      }
    }
  }
  (__funcarg163 = FUNCCALL(SETUP_XfOrM818(_), scheme_register_parameter (init_exn_handler , "uncaught-exception-handler" , MZCONFIG_INIT_EXN_HANDLER ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("uncaught-exception-handler" , __funcarg163 , env ) )) 
  ; 
  (__funcarg162 = FUNCCALL(SETUP_XfOrM818(_), scheme_make_noncm_prim ((Scheme_Prim * ) sch_raise , "raise" , 1 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("raise" , __funcarg162 , env ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5456 "bc/src/error.c"
void scheme_init_exn_config (void ) 
{
  Scheme_Object * h ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(h, 0)));
# define XfOrM850_COUNT (1)
# define SETUP_XfOrM850(x) SETUP(XfOrM850_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  h = NULLED_OUT ; 

# 5460 "bc/src/error.c"
  h = FUNCCALL(SETUP_XfOrM850(_), scheme_make_prim_w_arity ((Scheme_Prim * ) def_exn_handler , "default-exception-handler" , 1 , 1 ) ); 
  FUNCCALL_EMPTY(scheme_set_root_param (MZCONFIG_INIT_EXN_HANDLER , h ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
