#include "precomp.h"

# 34 "bc/rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 117 "rktio/rktio.h"
__xform_nongcing__ extern void rktio_free (void * p ) ; 



typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 191 "rktio/rktio.h"
__xform_nongcing__ extern rktio_fd_t * rktio_system_fd (rktio_t * rktio , intptr_t system_fd , int modes ) ; 

# 256 "rktio/rktio.h"
__xform_nongcing__ extern void rktio_forget (rktio_t * rktio , rktio_fd_t * fd ) ; 

# 351 "rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "rktio/rktio.h"
rktio_process_result_t ; 

# 646 "rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "rktio/rktio.h"
rktio_status_t ; 

# 669 "rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 821 "rktio/rktio.h"
__xform_nongcing__ extern rktio_bool_t rktio_file_exists (rktio_t * rktio , rktio_const_string_t filename ) ; 
__xform_nongcing__ extern rktio_bool_t rktio_directory_exists (rktio_t * rktio , rktio_const_string_t dirname ) ; 
__xform_nongcing__ extern rktio_bool_t rktio_link_exists (rktio_t * rktio , rktio_const_string_t filename ) ; 
__xform_nongcing__ extern rktio_bool_t rktio_is_regular_file (rktio_t * rktio , rktio_const_string_t filename ) ; 

# 835 "rktio/rktio.h"
__xform_nongcing__ extern 
int rktio_file_type (rktio_t * rktio , rktio_const_string_t filename ) ; 




__xform_nongcing__ extern rktio_ok_t rktio_delete_file (rktio_t * rktio , rktio_const_string_t fn , rktio_bool_t enable_write_on_fail ) ; 

__xform_nongcing__ extern rktio_ok_t rktio_rename_file (rktio_t * rktio , rktio_const_string_t dest , rktio_const_string_t src , rktio_bool_t exists_ok ) ; 


__xform_nongcing__ extern char * rktio_get_current_directory (rktio_t * rktio ) ; 
__xform_nongcing__ extern rktio_ok_t rktio_set_current_directory (rktio_t * rktio , rktio_const_string_t path ) ; 




__xform_nongcing__ extern rktio_ok_t rktio_make_directory_with_permissions (rktio_t * rktio , rktio_const_string_t filename , int perm_bits ) ; 



__xform_nongcing__ extern rktio_ok_t rktio_delete_directory (rktio_t * rktio , rktio_const_string_t filename , rktio_const_string_t current_directory , 
rktio_bool_t enable_write_on_fail ) ; 




__xform_nongcing__ extern char * rktio_readlink (rktio_t * rktio , rktio_const_string_t fullfilename ) ; 



__xform_nongcing__ extern rktio_ok_t rktio_make_link (rktio_t * rktio , rktio_const_string_t src , rktio_const_string_t dest , 
rktio_bool_t dest_is_directory ) ; 






typedef intptr_t rktio_timestamp_t ; 

__xform_nongcing__ extern rktio_filesize_t * rktio_file_size (rktio_t * rktio , rktio_const_string_t filename ) ; 

__xform_nongcing__ extern rktio_timestamp_t * rktio_get_file_modify_seconds (rktio_t * rktio , rktio_const_string_t file ) ; 
__xform_nongcing__ extern rktio_ok_t rktio_set_file_modify_seconds (rktio_t * rktio , rktio_const_string_t file , rktio_timestamp_t secs ) ; 

typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "rktio/rktio.h"
rktio_stat_t ; 

__xform_nongcing__ extern rktio_stat_t * rktio_file_or_directory_stat (rktio_t * rktio , rktio_const_string_t path , rktio_bool_t follow_links ) ; 

typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "rktio/rktio.h"
rktio_identity_t ; 

__xform_nongcing__ extern rktio_identity_t * rktio_fd_identity (rktio_t * rktio , rktio_fd_t * fd ) ; 
__xform_nongcing__ extern rktio_identity_t * rktio_path_identity (rktio_t * rktio , rktio_const_string_t path , rktio_bool_t follow_links ) ; 

# 913 "rktio/rktio.h"
__xform_nongcing__ extern 
int rktio_get_file_or_directory_permissions (rktio_t * rktio , rktio_const_string_t filename , rktio_bool_t all_bits ) ; 



__xform_nongcing__ extern rktio_ok_t rktio_set_file_or_directory_permissions (rktio_t * rktio , rktio_const_string_t filename , int new_bits ) ; 






typedef struct rktio_directory_list_t rktio_directory_list_t ; 

__xform_nongcing__ extern rktio_directory_list_t * rktio_directory_list_start (rktio_t * rktio , rktio_const_string_t dirname ) ; 



__xform_nongcing__ extern char * rktio_directory_list_step (rktio_t * rktio , rktio_directory_list_t * dl ) ; 




__xform_nongcing__ extern void rktio_directory_list_stop (rktio_t * rktio , rktio_directory_list_t * dl ) ; 



__xform_nongcing__ extern char * * rktio_filesystem_roots (rktio_t * rktio ) ; 






typedef struct rktio_file_copy_t rktio_file_copy_t ; 

__xform_nongcing__ extern rktio_file_copy_t * rktio_copy_file_start (rktio_t * rktio , rktio_const_string_t dest , rktio_const_string_t src , 
rktio_bool_t exists_ok ) ; 




__xform_nongcing__ extern rktio_bool_t rktio_copy_file_is_done (rktio_t * rktio , rktio_file_copy_t * fc ) ; 
__xform_nongcing__ extern rktio_ok_t rktio_copy_file_step (rktio_t * rktio , rktio_file_copy_t * fc ) ; 





__xform_nongcing__ extern rktio_ok_t rktio_copy_file_finish_permissions (rktio_t * rktio , rktio_file_copy_t * fc ) ; 






__xform_nongcing__ extern void rktio_copy_file_stop (rktio_t * rktio , rktio_file_copy_t * fc ) ; 





enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 




__xform_nongcing__ extern char * rktio_system_path (rktio_t * rktio , int which ) ; 

enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

__xform_nongcing__ extern char * rktio_expand_user_tilde (rktio_t * rktio , rktio_const_string_t filename ) ; 

# 1018 "rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "rktio/rktio.h"
rktio_date_t ; 

# 1109 "rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 

# 1378 "rktio/rktio.h"
enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 




enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

__xform_nongcing__ extern int rktio_get_last_error_step (rktio_t * rktio ) ; 

# 46 "/usr/include/ctype.h" 3
enum 
{
  _ISupper = (1 << (0 ) ) , 
  _ISlower = (1 << (1 ) ) , 
  _ISalpha = (1 << (2 ) ) , 
  _ISdigit = (1 << (3 ) ) , 
  _ISxdigit = (1 << (4 ) ) , 
  _ISspace = (1 << (5 ) ) , 
  _ISprint = (1 << (6 ) ) , 
  _ISgraph = (1 << (7 ) ) , 
  _ISblank = (1 << (8 ) ) , 
  _IScntrl = (1 << (9 ) ) , 
  _ISpunct = (1 << (10 ) ) , 
  _ISalnum = (1 << (11 ) ) }
; 

# 79 "/usr/include/ctype.h" 3
extern const unsigned short int * * __ctype_b_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 
extern const __int32_t * * __ctype_tolower_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 
extern const __int32_t * * __ctype_toupper_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 

# 122 "/usr/include/ctype.h" 3
extern int tolower (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 


extern int toupper (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 206 "/usr/include/ctype.h" 3
extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) tolower (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_tolower_loc () ) [__c ] : __c ; 
}

extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) toupper (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_toupper_loc () ) [__c ] : __c ; 
}

# 44 "bc/src/file.c"
static int check_dos_slashslash_drive (const char * next , int delta , int len , 
int * drive_end , int exact , int no_fw ) ; 
static int check_dos_slashslash_qm (const char * next , int len , int * drive_end , 
int * clean_start , int * add_sep ) ; 

# 58 "bc/src/file.c"
static Scheme_Object * path_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * general_path_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * path_to_string (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * path_to_bytes (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * path_element_to_bytes (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * path_element_to_string (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * string_to_path (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * bytes_to_path (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * bytes_to_path_element (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * string_to_path_element (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * path_kind (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * platform_path_kind (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * file_exists (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * directory_exists (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * link_exists (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * build_path_kind (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * delete_file (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * rename_file (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * copy_file (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * path_to_directory_path (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * directory_list (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * filesystem_root_list (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_directory (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * delete_directory (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_link (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * split_path (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * explode_path (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * relative_path_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * absolute_path_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * complete_path_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * path_to_complete_path (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * resolve_path (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cleanse_path (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * expand_user_path (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_drive (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * file_modify_seconds (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * file_or_dir_permissions (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * file_or_dir_type (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * file_identity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * file_stat (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * file_size (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * find_system_path (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * current_directory (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_user_directory (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_force_delete_perms (int argc , Scheme_Object * argv [] ) ; 

static int has_null (const char * s , intptr_t l ) ; 
static void raise_null_error (const char * name , Scheme_Object * path , const char * mod ) ; 

static char * do_path_to_complete_path (char * filename , intptr_t ilen , const char * wrt , intptr_t wlen , int kind ) ; 
static Scheme_Object * do_simplify_path (Scheme_Object * path , Scheme_Object * cycle_check , int skip , int use_filesystem , 
int force_rel_up , int already_cleansed , int kind , int guards ) ; 
static char * do_normal_path_seps (char * si , int * _len , int delta , int strip_trail , int kind , int * _did ) ; 
static char * remove_redundant_slashes (char * filename , int * l , int delta , int * expanded , int kind ) ; 
static Scheme_Object * do_path_to_directory_path (char * s , intptr_t offset , intptr_t len , Scheme_Object * p , int just_check , int kind ) ; 

static Scheme_Object * up_symbol ; 
static Scheme_Object * relative_symbol ; 
static Scheme_Object * same_symbol ; 
static Scheme_Object * read_symbol , * write_symbol , * execute_symbol ; 

static Scheme_Object * temp_dir_symbol , * home_dir_symbol , * pref_dir_symbol ; 
static Scheme_Object * doc_dir_symbol , * desk_dir_symbol ; 
static Scheme_Object * init_dir_symbol , * init_file_symbol , * sys_dir_symbol ; 
static Scheme_Object * exec_file_symbol , * run_file_symbol , * collects_dir_symbol ; 
static Scheme_Object * pref_file_symbol , * orig_dir_symbol , * addon_dir_symbol ; 
static Scheme_Object * config_dir_symbol , * cache_dir_symbol ; 
static Scheme_Object * host_collects_dir_symbol , * host_config_dir_symbol ; 

static Scheme_Object * exec_cmd ; 
static Scheme_Object * run_cmd ; 
static Scheme_Object * collects_path , * config_path ; 
static Scheme_Object * host_collects_path , * host_config_path ; 
; 
static Scheme_Object * addon_dir ; 

static Scheme_Object * windows_symbol , * unix_symbol ; 

static Scheme_Object * file_symbol , * directory_symbol , * link_symbol , * directory_link_symbol ; 

static Scheme_Object * device_id_symbol , * inode_symbol , * mode_symbol ; 
static Scheme_Object * hardlink_count_symbol , * user_id_symbol , * group_id_symbol ; 
static Scheme_Object * device_id_for_special_file_symbol ; 
static Scheme_Object * size_symbol , * block_size_symbol , * block_count_symbol ; 
static Scheme_Object * access_time_seconds_symbol , * access_time_nanoseconds_symbol ; 
static Scheme_Object * modify_time_seconds_symbol , * modify_time_nanoseconds_symbol ; 
static Scheme_Object * change_time_seconds_symbol , * change_time_nanoseconds_symbol ; 
static Scheme_Object * creation_time_seconds_symbol , * creation_time_nanoseconds_symbol ; 

void scheme_init_file (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM1_COUNT (2)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & up_symbol , sizeof (up_symbol ) ) )
# 154 "bc/src/file.c"
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & relative_symbol , sizeof (relative_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & same_symbol , sizeof (same_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & read_symbol , sizeof (read_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & write_symbol , sizeof (write_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & execute_symbol , sizeof (execute_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & temp_dir_symbol , sizeof (temp_dir_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & home_dir_symbol , sizeof (home_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & pref_dir_symbol , sizeof (pref_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & doc_dir_symbol , sizeof (doc_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & desk_dir_symbol , sizeof (desk_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & init_dir_symbol , sizeof (init_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & init_file_symbol , sizeof (init_file_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & sys_dir_symbol , sizeof (sys_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & pref_file_symbol , sizeof (pref_file_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & exec_file_symbol , sizeof (exec_file_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & run_file_symbol , sizeof (run_file_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & collects_dir_symbol , sizeof (collects_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & config_dir_symbol , sizeof (config_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & host_collects_dir_symbol , sizeof (host_collects_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & host_config_dir_symbol , sizeof (host_config_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & orig_dir_symbol , sizeof (orig_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & addon_dir_symbol , sizeof (addon_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & cache_dir_symbol , sizeof (cache_dir_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & windows_symbol , sizeof (windows_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unix_symbol , sizeof (unix_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & file_symbol , sizeof (file_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & directory_symbol , sizeof (directory_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & link_symbol , sizeof (link_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & directory_link_symbol , sizeof (directory_link_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & device_id_symbol , sizeof (device_id_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & inode_symbol , sizeof (inode_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & mode_symbol , sizeof (mode_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & hardlink_count_symbol , sizeof (hardlink_count_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & user_id_symbol , sizeof (user_id_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & group_id_symbol , sizeof (group_id_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & device_id_for_special_file_symbol , sizeof (device_id_for_special_file_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & size_symbol , sizeof (size_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & block_size_symbol , sizeof (block_size_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & block_count_symbol , sizeof (block_count_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & access_time_seconds_symbol , sizeof (access_time_seconds_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & access_time_nanoseconds_symbol , sizeof (access_time_nanoseconds_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & modify_time_seconds_symbol , sizeof (modify_time_seconds_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & modify_time_nanoseconds_symbol , sizeof (modify_time_nanoseconds_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & change_time_seconds_symbol , sizeof (change_time_seconds_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & change_time_nanoseconds_symbol , sizeof (change_time_nanoseconds_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & creation_time_seconds_symbol , sizeof (creation_time_seconds_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & creation_time_nanoseconds_symbol , sizeof (creation_time_nanoseconds_symbol ) ) ); 

  up_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("up" ) ); 
  relative_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("relative" ) ); 
  same_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("same" ) ); 

  read_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("read" ) ); 
  write_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("write" ) ); 
  execute_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("execute" ) ); 

  temp_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("temp-dir" ) ); 
  home_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("home-dir" ) ); 
  doc_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("doc-dir" ) ); 
  desk_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("desk-dir" ) ); 
  pref_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("pref-dir" ) ); 
  init_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("init-dir" ) ); 
  init_file_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("init-file" ) ); 
  sys_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("sys-dir" ) ); 
  pref_file_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("pref-file" ) ); 
  exec_file_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("exec-file" ) ); 
  run_file_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("run-file" ) ); 
  collects_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("collects-dir" ) ); 
  config_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("config-dir" ) ); 
  host_collects_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("host-collects-dir" ) ); 
  host_config_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("host-config-dir" ) ); 
  orig_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("orig-dir" ) ); 
  addon_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("addon-dir" ) ); 
  cache_dir_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("cache-dir" ) ); 

  windows_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("windows" ) ); 
  unix_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unix" ) ); 

  file_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("file" ) ); 
  directory_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("directory" ) ); 
  link_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("link" ) ); 
  directory_link_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("directory-link" ) ); 

  device_id_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("device-id" ) ); 
  inode_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("inode" ) ); 
  mode_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("mode" ) ); 
  hardlink_count_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("hardlink-count" ) ); 
  user_id_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("user-id" ) ); 
  group_id_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("group-id" ) ); 
  device_id_for_special_file_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("device-id-for-special-file" ) ); 
  size_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("size" ) ); 
  block_size_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("block-size" ) ); 
  block_count_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("block-count" ) ); 
  access_time_seconds_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("access-time-seconds" ) ); 
  access_time_nanoseconds_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("access-time-nanoseconds" ) ); 
  modify_time_seconds_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("modify-time-seconds" ) ); 
  modify_time_nanoseconds_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("modify-time-nanoseconds" ) ); 
  change_time_seconds_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("change-time-seconds" ) ); 
  change_time_nanoseconds_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("change-time-nanoseconds" ) ); 
  creation_time_seconds_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("creation-time-seconds" ) ); 
  creation_time_nanoseconds_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("creation-time-nanoseconds" ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (path_p , "path?" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("path?" , p , env ) ); 
  (__funcarg103 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (general_path_p , "path-for-some-system?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("path-for-some-system?" , __funcarg103 , env ) )) 
  ; 
  (__funcarg102 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (path_kind , "path-convention-type" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("path-convention-type" , __funcarg102 , env ) )) 
  ; 
  (__funcarg101 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (platform_path_kind , "system-path-convention-type" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("system-path-convention-type" , __funcarg101 , env ) )) 
  ; 
  (__funcarg100 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (path_to_string , "path->string" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("path->string" , __funcarg100 , env ) )) 
  ; 
  (__funcarg99 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (path_to_bytes , "path->bytes" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("path->bytes" , __funcarg99 , env ) )) 
  ; 
  (__funcarg98 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (path_element_to_bytes , "path-element->bytes" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("path-element->bytes" , __funcarg98 , env ) )) 
  ; 
  (__funcarg97 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (path_element_to_string , "path-element->string" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("path-element->string" , __funcarg97 , env ) )) 
  ; 
  (__funcarg96 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (string_to_path , "string->path" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("string->path" , __funcarg96 , env ) )) 
  ; 
  (__funcarg95 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (bytes_to_path , "bytes->path" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("bytes->path" , __funcarg95 , env ) )) 
  ; 
  (__funcarg94 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (bytes_to_path_element , "bytes->path-element" , 1 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("bytes->path-element" , __funcarg94 , env ) )) 
  ; 
  (__funcarg93 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (string_to_path_element , "string->path-element" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("string->path-element" , __funcarg93 , env ) )) 
  ; 
  (__funcarg92 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (file_exists , "file-exists?" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-exists?" , __funcarg92 , env ) )) 
  ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (directory_exists , "directory-exists?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("directory-exists?" , __funcarg91 , env ) )) 
  ; 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (link_exists , "link-exists?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("link-exists?" , __funcarg90 , env ) )) 
  ; 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (delete_file , "delete-file" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("delete-file" , __funcarg89 , env ) )) 
  ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (rename_file , "rename-file-or-directory" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("rename-file-or-directory" , __funcarg88 , env ) )) 
  ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (copy_file , "copy-file" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("copy-file" , __funcarg87 , env ) )) 
  ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (scheme_build_path , "build-path" , 1 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("build-path" , __funcarg86 , env ) )) 
  ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (build_path_kind , "build-path/convention-type" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("build-path/convention-type" , __funcarg85 , env ) )) 
  ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (path_to_directory_path , "path->directory-path" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("path->directory-path" , __funcarg84 , env ) )) 
  ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_everything (split_path , 1 , "split-path" , 1 , 1 , 0 , 3 , 3 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("split-path" , __funcarg83 , env ) )) 
  ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (explode_path , "explode-path" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("explode-path" , __funcarg82 , env ) )) 
  ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (relative_path_p , "relative-path?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("relative-path?" , __funcarg81 , env ) )) 
  ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (absolute_path_p , "absolute-path?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("absolute-path?" , __funcarg80 , env ) )) 
  ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (complete_path_p , "complete-path?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("complete-path?" , __funcarg79 , env ) )) 
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (path_to_complete_path , "path->complete-path" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("path->complete-path" , __funcarg78 , env ) )) 
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (resolve_path , "resolve-path" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("resolve-path" , __funcarg77 , env ) )) 
  ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (scheme_simplify_path , "simplify-path" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("simplify-path" , __funcarg76 , env ) )) 
  ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (cleanse_path , "cleanse-path" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("cleanse-path" , __funcarg75 , env ) )) 
  ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (expand_user_path , "expand-user-path" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("expand-user-path" , __funcarg74 , env ) )) 
  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (directory_list , "directory-list" , 0 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("directory-list" , __funcarg73 , env ) )) 
  ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (filesystem_root_list , "filesystem-root-list" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("filesystem-root-list" , __funcarg72 , env ) )) 
  ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_directory , "make-directory" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-directory" , __funcarg71 , env ) )) 
  ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (delete_directory , "delete-directory" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("delete-directory" , __funcarg70 , env ) )) 
  ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_link , "make-file-or-directory-link" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-file-or-directory-link" , __funcarg69 , env ) )) 
  ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (file_modify_seconds , "file-or-directory-modify-seconds" , 1 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-or-directory-modify-seconds" , __funcarg68 , env ) )) 
  ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (file_or_dir_permissions , "file-or-directory-permissions" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-or-directory-permissions" , __funcarg67 , env ) )) 
  ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (file_or_dir_type , "file-or-directory-type" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-or-directory-type" , __funcarg66 , env ) )) 
  ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (file_identity , "file-or-directory-identity" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-or-directory-identity" , __funcarg65 , env ) )) 
  ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (file_stat , "file-or-directory-stat" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-or-directory-stat" , __funcarg64 , env ) )) 
  ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (file_size , "file-size" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-size" , __funcarg63 , env ) )) 
  ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (current_drive , "current-drive" , 0 , 0 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-drive" , __funcarg62 , env ) )) 
  ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (find_system_path , "find-system-path" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("find-system-path" , __funcarg61 , env ) )) 
  ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (current_directory , "current-directory" , MZCONFIG_CURRENT_DIRECTORY ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-directory" , __funcarg60 , env ) )) 
  ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (current_user_directory , "current-directory-for-user" , MZCONFIG_CURRENT_USER_DIRECTORY ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-directory-for-user" , __funcarg59 , env ) )) 
  ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (current_force_delete_perms , "current-force-delete-permissions" , MZCONFIG_FORCE_DELETE_PERMS ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-force-delete-permissions" , __funcarg58 , env ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 504 "bc/src/file.c"
void scheme_init_file_places () 
{
  /* No conversion */

# 506 "bc/src/file.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> original_pwd_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> original_pwd_ ) ) ) ; 
}





Scheme_Object * scheme_make_sized_offset_kind_path (char * chars , intptr_t d , intptr_t len , int copy , int kind ) 
{
  Scheme_Object * s ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM3_COUNT (1)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 516 "bc/src/file.c"
  s = FUNCCALL(SETUP_XfOrM3(_), scheme_make_sized_offset_byte_string (chars , d , len , copy ) ); 
  s -> type = kind ; 
  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 521 "bc/src/file.c"
Scheme_Object * scheme_make_sized_offset_path (char * chars , intptr_t d , intptr_t len , int copy ) 
{
  /* No conversion */

# 523 "bc/src/file.c"
  return scheme_make_sized_offset_kind_path (chars , d , len , copy , scheme_unix_path_type ) ; 
}






static int is_special_filename (const char * _f , int offset , int len , int not_nul , int immediate ) ; 

static Scheme_Object * make_protected_sized_offset_path (int protect , char * chars , 
intptr_t d , intptr_t len , int copy , 
int just_check , int kind ) 


{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(chars, 0)));
# define XfOrM5_COUNT (1)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 539 "bc/src/file.c"
  if (kind == scheme_windows_path_type ) {
#   define XfOrM7_COUNT (0+XfOrM5_COUNT)
#   define SETUP_XfOrM7(x) SETUP_XfOrM5(x)

# 540 "bc/src/file.c"
    if (protect ) {
      int i ; 
#     define XfOrM8_COUNT (0+XfOrM7_COUNT)
#     define SETUP_XfOrM8(x) SETUP_XfOrM7(x)

# 543 "bc/src/file.c"
      protect = 0 ; 

      if (! protect ) {
        int at_end = 1 ; 
        for (i = len ; i -- ; ) {
          if ((just_check != 2 ) 
          && ((chars [i + d ] == '.' ) 
          || (chars [i + d ] == ' ' ) ) ) {
            if (at_end ) {
              protect = 1 ; 
              break ; 
            }
          }

# 555 "bc/src/file.c"
          else {
            at_end = 0 ; 
            if ((chars [i + d ] == '/' ) 
            || (((((chars [i + d ] ) == '/' ) || ((chars [i + d ] ) == '\\' ) ) || ((chars [i + d ] ) == '"' ) || ((chars [i + d ] ) == '|' ) || ((chars [i + d ] ) == ':' ) || ((chars [i + d ] ) == '<' ) || ((chars [i + d ] ) == '>' ) || ((chars [i + d ] ) == '?' ) || ((chars [i + d ] ) == '*' ) ) ) ) {
              protect = 1 ; 
              break ; 
            }
          }
        }
      }

      if (! protect && (len == 1 ) && (chars [d ] == '.' ) )
        protect = 1 ; 

      if (! protect && (len == 2 ) && (chars [d ] == '.' ) && (chars [d + 1 ] == '.' ) )
        protect = 1 ; 

      if (! protect )
        protect = FUNCCALL(SETUP_XfOrM8(_), is_special_filename (chars , d , len , 0 , 1 ) ); 

      if (protect ) {
        char * s2 ; 
        BLOCK_SETUP((PUSH(s2, 0+XfOrM8_COUNT)));
#       define XfOrM9_COUNT (1+XfOrM8_COUNT)
#       define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
        s2 = NULLED_OUT ; 

# 577 "bc/src/file.c"
        if (just_check )
          RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
        s2 = (char * ) FUNCCALL(SETUP_XfOrM9(_), GC_malloc_atomic (len + 9 + 1 ) ); 
        (memcpy (s2 , "\\\\?\\REL\\\\" , 9 ) ) ; 
        (memcpy (s2 + 9 , chars + d , len ) ) ; 
        s2 [9 + len ] = 0 ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (s2 , 0 , len + 9 , 0 , scheme_windows_path_type ) )) RET_VALUE_EMPTY_END ; 
      }
    }
  }

# 586 "bc/src/file.c"
  else {
  }

# 604 "bc/src/file.c"
  if (just_check )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (chars , d , len , copy , kind ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}




Scheme_Object * make_exposed_sized_offset_path (int * optional , int already_protected , 
char * chars , intptr_t d , intptr_t len , int copy , 
int kind ) 

{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(chars, 0), PUSH(optional, 1)));
# define XfOrM21_COUNT (2)
# define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 624 "bc/src/file.c"
  if (FUNCCALL(SETUP_XfOrM21(_), do_path_to_directory_path (chars , d , len - 1 , scheme_true , 1 , kind ) )) {
#   define XfOrM23_COUNT (0+XfOrM21_COUNT)
#   define SETUP_XfOrM23(x) SETUP_XfOrM21(x)
    if ((kind != scheme_windows_path_type ) 
    || ! ((len == 3 ) && (((unsigned char ) chars [d ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM23(_), __ctype_b_loc () )) [(int ) (((unsigned char ) chars [d ] ) ) ] & (unsigned short int ) _ISalpha ) ) && (chars [d + 1 ] == ':' ) ) ) {
      len -- ; 
      copy = 1 ; 
    }
  }

  if (optional ) {
    * optional = len ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (chars , d , len , copy , kind ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 642 "bc/src/file.c"
Scheme_Object * scheme_make_path (const char * chars ) 
{
  /* No conversion */

# 644 "bc/src/file.c"
  return scheme_make_sized_offset_path ((char * ) chars , 0 , - 1 , 1 ) ; 
}

Scheme_Object * scheme_make_sized_path (char * chars , intptr_t len , int copy ) 
{
  /* No conversion */

# 649 "bc/src/file.c"
  return scheme_make_sized_offset_path (chars , 0 , len , copy ) ; 
}

Scheme_Object * scheme_make_path_without_copying (char * chars ) 
{
  /* No conversion */

# 654 "bc/src/file.c"
  return scheme_make_sized_offset_path (chars , 0 , - 1 , 0 ) ; 
}

Scheme_Object * scheme_char_string_to_path (Scheme_Object * p ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM28_COUNT (1)
# define SETUP_XfOrM28(x) SETUP(XfOrM28_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 662 "bc/src/file.c"
  p = FUNCCALL(SETUP_XfOrM28(_), scheme_char_string_to_byte_string_locale (p ) ); 

  p -> type = scheme_unix_path_type ; 
  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 669 "bc/src/file.c"
static Scheme_Object * path_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 671 "bc/src/file.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * general_path_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 676 "bc/src/file.c"
  return (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * path_kind (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 681 "bc/src/file.c"
  if ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) )  {
    switch (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) {
      case scheme_windows_path_type : 
      return windows_symbol ; 
      break ; 
      default : 
      case scheme_unix_path_type : 
      return unix_symbol ; 
      break ; 
    }
  }

# 691 "bc/src/file.c"
  else {
    scheme_wrong_contract ("path-system-type" , "path-for-some-system?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
}

static Scheme_Object * platform_path_kind (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 699 "bc/src/file.c"
  switch (scheme_unix_path_type ) {
    case scheme_windows_path_type : 
    return windows_symbol ; 
    break ; 
    default : 
    case scheme_unix_path_type : 
    return unix_symbol ; 
    break ; 
  }
}

static Scheme_Object * drop_rel_prefix (Scheme_Object * p ) 

{
  int drive_end ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM37_COUNT (1)
# define SETUP_XfOrM37(x) SETUP(XfOrM37_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 714 "bc/src/file.c"
  if (FUNCCALL(SETUP_XfOrM37(_), check_dos_slashslash_qm ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) , & drive_end , ((void * ) 0 ) , ((void * ) 0 ) ) )) 

  {
#   define XfOrM38_COUNT (0+XfOrM37_COUNT)
#   define SETUP_XfOrM38(x) SETUP_XfOrM37(x)

# 717 "bc/src/file.c"
    if (drive_end < 0 ) {

      int delta ; 
#     define XfOrM39_COUNT (0+XfOrM38_COUNT)
#     define SETUP_XfOrM39(x) SETUP_XfOrM38(x)

# 720 "bc/src/file.c"
      if ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) [8 ] == '\\' )
        delta = 9 ; 
      else 
      delta = 8 ; 
      p = FUNCCALL(SETUP_XfOrM39(_), scheme_make_sized_offset_kind_path ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , delta , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) - delta , 1 , scheme_windows_path_type ) )



      ; 
    }
  }

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 735 "bc/src/file.c"
Scheme_Object * scheme_path_to_char_string (Scheme_Object * p ) 
{
  Scheme_Object * s ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM40_COUNT (1)
# define SETUP_XfOrM40(x) SETUP(XfOrM40_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 742 "bc/src/file.c"
  s = FUNCCALL(SETUP_XfOrM40(_), scheme_byte_string_to_char_string_locale (p ) ); 


  if (! (((Scheme_Simple_Object * ) (s ) ) -> u . char_str_val . tag_val ) )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_utf8_string ("?" ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 751 "bc/src/file.c"
static Scheme_Object * path_to_string (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 753 "bc/src/file.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) )
    scheme_wrong_contract ("path->string" , "path?" , 0 , argc , argv ) ; 

  return scheme_path_to_char_string (argv [0 ] ) ; 
}

static Scheme_Object * path_to_bytes (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 761 "bc/src/file.c"
  if (! ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) )
    scheme_wrong_contract ("path->bytes" , "path?" , 0 , argc , argv ) ; 

  return scheme_make_sized_byte_string ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . string_val ) , 
  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . tag_val ) , 
  1 ) ; 
}

static Scheme_Object * is_path_element (Scheme_Object * p ) 
{
  Scheme_Object * base , * fn ; 
  int isdir ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(fn, 0), PUSH(base, 1)));
# define XfOrM43_COUNT (2)
# define SETUP_XfOrM43(x) SETUP(XfOrM43_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  base = NULLED_OUT ; 
  fn = NULLED_OUT ; 

# 774 "bc/src/file.c"
  fn = FUNCCALL(SETUP_XfOrM43(_), scheme_split_path ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) , & base , & isdir , ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) )



  ; 

  if (((Scheme_Type ) (((((intptr_t ) (base ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (base ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
  && ((((((intptr_t ) (fn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (fn ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (fn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (fn ) ) -> type ) <= scheme_windows_path_type ) ) )
    RET_VALUE_START (fn ) RET_VALUE_END ; 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 786 "bc/src/file.c"
static Scheme_Object * do_path_element_to_bytes (const char * name , int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * p = argv [0 ] , * pe ; 
  int kind ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(name, 1), PUSH(pe, 2)));
# define XfOrM44_COUNT (3)
# define SETUP_XfOrM44(x) SETUP(XfOrM44_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pe = NULLED_OUT ; 

# 791 "bc/src/file.c"
  if (! ((((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) <= scheme_windows_path_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "path?" , 0 , argc , argv ) ); 

  pe = FUNCCALL(SETUP_XfOrM44(_), is_path_element (p ) ); 

  if (! pe )
    FUNCCALL_EMPTY(scheme_contract_error (name , "path can be split or is not relative" , "path" , 1 , p , ((void * ) 0 ) ) )


  ; 

  if ((Scheme_Type ) (((((intptr_t ) (pe ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pe ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#   define XfOrM47_COUNT (0+XfOrM44_COUNT)
#   define SETUP_XfOrM47(x) SETUP_XfOrM44(x)
    FUNCCALL_EMPTY(scheme_contract_error (name , (((pe ) == (up_symbol ) ) ? "path is an up-directory indicator" : "path is a same-directory indicator" ) , "path" , 1 , p , ((void * ) 0 ) ) )


    ; 
  }

  p = pe ; 

  kind = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 

  if (kind == scheme_unix_path_type ) {
  }

# 828 "bc/src/file.c"
  if (kind == scheme_windows_path_type ) {
#   define XfOrM45_COUNT (0+XfOrM44_COUNT)
#   define SETUP_XfOrM45(x) SETUP_XfOrM44(x)

# 829 "bc/src/file.c"
    p = FUNCCALL(SETUP_XfOrM45(_), drop_rel_prefix (p ) ); 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) , 1 ) )) RET_VALUE_EMPTY_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 837 "bc/src/file.c"
static Scheme_Object * path_element_to_bytes (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 839 "bc/src/file.c"
  return do_path_element_to_bytes ("path-element->bytes" , argc , argv ) ; 
}

static Scheme_Object * path_element_to_string (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * b ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(b, 0)));
# define XfOrM49_COUNT (1)
# define SETUP_XfOrM49(x) SETUP(XfOrM49_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 845 "bc/src/file.c"
  b = FUNCCALL(SETUP_XfOrM49(_), do_path_element_to_bytes ("path-element->string" , argc , argv ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_byte_string_to_char_string_locale (b ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 849 "bc/src/file.c"
static void check_path_ok (const char * who , Scheme_Object * p , Scheme_Object * o ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(o, 1)));
# define XfOrM50_COUNT (2)
# define SETUP_XfOrM50(x) SETUP(XfOrM50_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 851 "bc/src/file.c"
  if (FUNCCALL(SETUP_XfOrM50(_), has_null ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) ) )) {
#   define XfOrM51_COUNT (0+XfOrM50_COUNT)
#   define SETUP_XfOrM51(x) SETUP_XfOrM50(x)
    FUNCCALL_EMPTY(raise_null_error (who , o , "" ) )
# 852 "bc/src/file.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 856 "bc/src/file.c"
static Scheme_Object * string_to_path (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(argv, 1)));
# define XfOrM52_COUNT (2)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 860 "bc/src/file.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("string->path" , "string?" , 0 , argc , argv ) ); 

  p = FUNCCALL(SETUP_XfOrM52(_), scheme_char_string_to_path (argv [0 ] ) ); 
  FUNCCALL_AGAIN(check_path_ok ("string->path" , p , argv [0 ] ) )
  ; 

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 870 "bc/src/file.c"
static int extract_path_kind (const char * who , int which , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 872 "bc/src/file.c"
  if (which >= argc )
    return scheme_unix_path_type ; 

  if ((argv [which ] ) == (windows_symbol ) ) 
    return scheme_windows_path_type ; 
  if ((argv [which ] ) == (unix_symbol ) ) 
    return scheme_unix_path_type ; 

  scheme_wrong_contract (who , "(or/c 'unix 'windows)" , which , argc , argv ) ; 
  return 0 ; 
}

static Scheme_Object * bytes_to_path (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * s ; 
  int kind ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(argv, 1)));
# define XfOrM54_COUNT (2)
# define SETUP_XfOrM54(x) SETUP(XfOrM54_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 889 "bc/src/file.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("bytes->path" , "bytes?" , 0 , argc , argv ) ); 
  kind = FUNCCALL(SETUP_XfOrM54(_), extract_path_kind ("bytes->path" , 1 , argc , argv ) ); 

  s = FUNCCALL_AGAIN(scheme_make_sized_byte_string ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . tag_val ) , (! (((Scheme_Inclhash_Object * ) (argv [0 ] ) ) -> so . keyex & 0x1 ) ) ) )

  ; 
  s -> type = kind ; 
  FUNCCALL(SETUP_XfOrM54(_), check_path_ok ("bytes->path" , s , argv [0 ] ) )
  ; 

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 903 "bc/src/file.c"
static Scheme_Object * do_bytes_to_path_element (const char * name , Scheme_Object * s , int argc , Scheme_Object * * argv , 
int has_kind , int false_on_error ) 
{
  Scheme_Object * p ; 
  intptr_t i , len ; 
  int kind ; 
  int bad_string = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(s, 1), PUSH(argv, 2), PUSH(p, 3)));
# define XfOrM55_COUNT (4)
# define SETUP_XfOrM55(x) SETUP(XfOrM55_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 911 "bc/src/file.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "bytes?" , 0 , argc , argv ) ); 
  if (has_kind )
    kind = FUNCCALL(SETUP_XfOrM55(_), extract_path_kind (name , 1 , argc , argv ) ); 
  else 
  kind = scheme_unix_path_type ; 

  len = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) ; 
  for (i = 0 ; i < len ; i ++ ) {
    if ((((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) [i ] == 0 ) {
      bad_string = 1 ; 
      break ; 
    }

# 923 "bc/src/file.c"
    else if ((kind == scheme_unix_path_type ) ? (((((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) [i ] ) == '/' ) : (((((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) [i ] ) == '\\' ) )  {
      break ; 
    }
  }

  if (i >= len ) {
#   define XfOrM57_COUNT (0+XfOrM55_COUNT)
#   define SETUP_XfOrM57(x) SETUP_XfOrM55(x)

# 929 "bc/src/file.c"
    if (len == 0 ) {
      bad_string = 1 ; 
      p = ((void * ) 0 ) ; 
    }

# 932 "bc/src/file.c"
    else 
    p = FUNCCALL(SETUP_XfOrM57(_), make_protected_sized_offset_path (1 , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , 0 , len , (! (((Scheme_Inclhash_Object * ) (s ) ) -> so . keyex & 0x1 ) ) , 0 , kind ) )


    ; 
  }

# 937 "bc/src/file.c"
  else 
  p = ((void * ) 0 ) ; 

  if (! p || ! FUNCCALL(SETUP_XfOrM55(_), is_path_element (p ) )) {
#   define XfOrM56_COUNT (0+XfOrM55_COUNT)
#   define SETUP_XfOrM56(x) SETUP_XfOrM55(x)

# 941 "bc/src/file.c"
    if (! bad_string && false_on_error )
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    if (bad_string )
      FUNCCALL(SETUP_XfOrM56(_), raise_null_error (name , argv [0 ] , "" ) ); 
    else FUNCCALL_EMPTY(scheme_contract_error (name , "cannot be converted to a path element" , "path" , 1 , argv [0 ] , "explanation" , 0 , (len ? "path can be split, is not relative, or names a special element" : "path element cannot be empty" ) , ((void * ) 0 ) ) )






    ; 
  }

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 958 "bc/src/file.c"
static Scheme_Object * bytes_to_path_element (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 960 "bc/src/file.c"
  return do_bytes_to_path_element ("bytes->path-element" , argv [0 ] , argc , argv , 
  1 , (argc > 2 ) ? (! (((argv [2 ] ) ) == (scheme_false ) ) ) : 0 ) ; 
}

static Scheme_Object * string_to_path_element (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * b ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(argv, 1)));
# define XfOrM66_COUNT (2)
# define SETUP_XfOrM66(x) SETUP(XfOrM66_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 968 "bc/src/file.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("string->path-element" , "string?" , 0 , argc , argv ) ); 

  b = FUNCCALL(SETUP_XfOrM66(_), scheme_char_string_to_byte_string_locale (argv [0 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_bytes_to_path_element ("string->path-element" , b , argc , argv , 0 , (argc > 1 ) ? (! (((argv [1 ] ) ) == (scheme_false ) ) ) : 0 ) )) RET_VALUE_EMPTY_END 
  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

char * scheme_os_getcwd (char * buf , size_t buflen , int * actlen , int noexn ) 
{
  char * s ; 
  int slen ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(buf, 0)));
# define XfOrM67_COUNT (1)
# define SETUP_XfOrM67(x) SETUP(XfOrM67_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 986 "bc/src/file.c"
  s = (rktio_get_current_directory (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
  if (! s ) {
#   define XfOrM70_COUNT (0+XfOrM67_COUNT)
#   define SETUP_XfOrM70(x) SETUP_XfOrM67(x)

# 988 "bc/src/file.c"
    if (noexn ) {




      s = strdup ("/" ) ; 
    }
    else {
#     define XfOrM71_COUNT (0+XfOrM70_COUNT)
#     define SETUP_XfOrM71(x) SETUP_XfOrM70(x)
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "current-directory: unknown failure\n" "  system error: %R" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  slen = strlen (s ) ; 

  if (actlen )
    * actlen = slen + 1 ; 

  if (buflen < slen ) {
#   define XfOrM69_COUNT (0+XfOrM67_COUNT)
#   define SETUP_XfOrM69(x) SETUP_XfOrM67(x)

# 1009 "bc/src/file.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_strdup_and_free (s ) )) RET_VALUE_EMPTY_END ; 
  }

# 1010 "bc/src/file.c"
  else {
#   define XfOrM68_COUNT (0+XfOrM67_COUNT)
#   define SETUP_XfOrM68(x) SETUP_XfOrM67(x)
    (
# 1011 "bc/src/file.c"
    memcpy (buf , s , slen + 1 ) ) ; 
    FUNCCALL(SETUP_XfOrM68(_), free (s ) ); 
    RET_VALUE_START (buf ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1017 "bc/src/file.c"
int scheme_os_setcwd (char * expanded , int noexn ) 
{
  /* No conversion */

# 1019 "bc/src/file.c"
  if (! rktio_set_current_directory (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , expanded ) ) {
    if (! noexn )
      scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , 
    "current-directory: unable to switch to directory\n" 
    "  path: %q\n" 
    "  system error: %R" , 
    expanded ) ; 
    return 0 ; 
  }

  return 1 ; 
}

# 1065 "bc/src/file.c"
Scheme_Object * scheme_get_file_directory (const char * filename ) 
{
  int isdir ; 
  Scheme_Object * base ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(base, 0)));
# define XfOrM75_COUNT (1)
# define SETUP_XfOrM75(x) SETUP(XfOrM75_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  base = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM75(_), scheme_split_path (filename , strlen (filename ) , & base , & isdir , scheme_unix_path_type ) )
# 1070 "bc/src/file.c"
  ; 

  RET_VALUE_START (base ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1075 "bc/src/file.c"
Scheme_Object * scheme_remove_current_directory_prefix (Scheme_Object * fn ) 
{
  Scheme_Object * cwd ; 
  intptr_t len ; 
  Scheme_Config * __funcarg104 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(fn, 0), PUSH(cwd, 1)));
# define XfOrM76_COUNT (2)
# define SETUP_XfOrM76(x) SETUP(XfOrM76_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cwd = NULLED_OUT ; 

# 1080 "bc/src/file.c"
  cwd = (__funcarg104 = FUNCCALL(SETUP_XfOrM76(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg104 , MZCONFIG_CURRENT_USER_DIRECTORY ) )) ; 

  fn = (((((((intptr_t ) (fn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (fn ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (fn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (fn ) ) -> type ) <= scheme_windows_path_type ) ) ? fn : FUNCCALL(SETUP_XfOrM76(_), scheme_char_string_to_path (fn ) )) ; 

  len = (((Scheme_Simple_Object * ) (cwd ) ) -> u . byte_str_val . tag_val ) ; 
  if ((len < (((Scheme_Simple_Object * ) (fn ) ) -> u . byte_str_val . tag_val ) ) 
  && ! (scheme_strncmp ((((Scheme_Simple_Object * ) (cwd ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (fn ) ) -> u . byte_str_val . string_val ) , len ) ) ) {
#   define XfOrM77_COUNT (0+XfOrM76_COUNT)
#   define SETUP_XfOrM77(x) SETUP_XfOrM76(x)

# 1088 "bc/src/file.c"
    while (((scheme_unix_path_type == scheme_unix_path_type ) ? (((((Scheme_Simple_Object * ) (fn ) ) -> u . byte_str_val . string_val ) [len ] ) == '/' ) : ((((((Scheme_Simple_Object * ) (fn ) ) -> u . byte_str_val . string_val ) [len ] ) == '/' ) || (((((Scheme_Simple_Object * ) (fn ) ) -> u . byte_str_val . string_val ) [len ] ) == '\\' ) ) ) ) {
      len ++ ; 
    }

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_path ((((Scheme_Simple_Object * ) (fn ) ) -> u . byte_str_val . string_val ) , len , (((Scheme_Simple_Object * ) (fn ) ) -> u . byte_str_val . tag_val ) - len , 1 ) )) RET_VALUE_EMPTY_END ; 
  }

  RET_VALUE_START (fn ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1098 "bc/src/file.c"
static int has_null (const char * s , intptr_t l ) 
{
  /* No conversion */

# 1100 "bc/src/file.c"
  if (! l )
    return 1 ; 

  while (l -- ) {
    if (! s [l ] )
      return 1 ; 
  }

  return 0 ; 
}

static void raise_null_error (const char * name , Scheme_Object * path , const char * mod ) 
{
  /* No conversion */

# 1113 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ? (((Scheme_Simple_Object * ) (path ) ) -> u . char_str_val . tag_val ) : (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) ) )
    scheme_raise_exn (MZEXN_FAIL_CONTRACT , 
  "%s: path string%s is empty" , 
  name , mod ) ; 
  else 
  scheme_raise_exn (MZEXN_FAIL_CONTRACT , 
  "%s: path string%s contains a null character\n" 
  "  path string: %Q" , 
  name , mod , 
  path ) ; 
}

static int check_dos_slashslash_qm (const char * next , int len , 
int * drive_end , int * clean_start , int * add_sep ) 
# 1149 "bc/src/file.c"
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(next, 0), PUSH(add_sep, 1), PUSH(clean_start, 2), PUSH(drive_end, 3)));
# define XfOrM84_COUNT (4)
# define SETUP_XfOrM84(x) SETUP(XfOrM84_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1150 "bc/src/file.c"
  if ((len >= 4 ) 
  && (next [0 ] == '\\' ) 
  && (next [1 ] == '\\' ) 
  && (next [2 ] == '?' ) 
  && (next [3 ] == '\\' ) ) {
    int base ; 
#   define XfOrM85_COUNT (0+XfOrM84_COUNT)
#   define SETUP_XfOrM85(x) SETUP_XfOrM84(x)

# 1156 "bc/src/file.c"
    if (! drive_end && ! clean_start && ! add_sep )
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    if (next [4 ] == '\\' )
      base = 5 ; 
    else 
    base = 4 ; 



    if ((len > 5 ) 
    && (next [len - 1 ] == '\\' ) 
    && (next [len - 2 ] == '\\' ) ) {
#     define XfOrM97_COUNT (0+XfOrM85_COUNT)
#     define SETUP_XfOrM97(x) SETUP_XfOrM85(x)

# 1168 "bc/src/file.c"
      if (len == 6 ) {
      }
      else if ((len != 8 ) 
      || ! (((unsigned char ) next [base ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM97(_), __ctype_b_loc () )) [(int ) (((unsigned char ) next [base ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
      || (next [base + 1 ] != ':' ) ) {
        if (drive_end )
          * drive_end = len ; 
        if (clean_start )
          * clean_start = len ; 
        if (add_sep )
          * add_sep = len ; 
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }
    }


    if (len > 6 ) {
      int i ; 
      for (i = len ; -- i > 5 ; ) {
        if ((next [i ] == '\\' ) 
        && (next [i - 1 ] == '\\' ) 
        && (next [i - 2 ] == '\\' ) ) {
          if (drive_end )
            * drive_end = i + 1 ; 
          if (clean_start )
            * clean_start = i + 1 ; 
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        }
      }
    }

    if ((len > 6 ) 
    && (((unsigned char ) next [base ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM85(_), __ctype_b_loc () )) [(int ) (((unsigned char ) next [base ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
    && next [base + 1 ] == ':' 
    && next [base + 2 ] == '\\' ) {
      if (clean_start )
        * clean_start = base + 2 ; 
      if (drive_end ) {
        if ((len > base + 3 ) && next [base + 3 ] == '\\' )
          * drive_end = base + 4 ; 
        else 
        * drive_end = base + 3 ; 
      }
    }

# 1211 "bc/src/file.c"
    else if ((len > base + 3 ) 
    && ((next [base ] == 'U' ) || (next [base ] == 'u' ) ) 
    && ((next [base + 1 ] == 'N' ) || (next [base + 1 ] == 'n' ) ) 
    && ((next [base + 2 ] == 'C' ) || (next [base + 2 ] == 'c' ) ) 
    && (next [base + 3 ] == '\\' ) 
    && FUNCCALL(SETUP_XfOrM85(_), check_dos_slashslash_drive (next , (((len > (base + 4 ) ) && (next [base + 4 ] == '\\' ) ) ? base + 5 : base + 4 ) , len , drive_end , 0 , 1 ) )) 



    {

      if (clean_start )
        * clean_start = base + 3 ; 
    }

# 1224 "bc/src/file.c"
    else if ((base == 4 ) 
    && (len > 8 ) 
    && (next [4 ] == 'R' ) 
    && (next [5 ] == 'E' ) 
    && ((next [6 ] == 'L' ) || (next [6 ] == 'D' ) ) 
    && (next [7 ] == '\\' ) 
    && ((next [8 ] != '\\' ) 
    || (len > 9 ) ) ) {
      if (drive_end )
        * drive_end = ((next [6 ] == 'L' ) ? - 1 : - 2 ) ; 
      if (clean_start )
        * clean_start = len ; 
    }

# 1236 "bc/src/file.c"
    else {
      if (drive_end )
        * drive_end = 4 ; 
      if (clean_start ) {
        if (((len == 5 ) && (next [4 ] == '\\' ) ) 
        || ((len == 6 ) && (next [4 ] == '\\' ) && (next [5 ] == '\\' ) ) )
          * clean_start = 3 ; 
        else 
        * clean_start = 4 ; 
      }
      if (add_sep )
        * add_sep = 4 ; 
    }
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1254 "bc/src/file.c"
static int check_dos_slashslash_drive (const char * next , int delta , int len , 
int * drive_end , int exact , int no_fw ) 
# 1269 "bc/src/file.c"
{
  int j ; 
  int is_drive = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(next, 0), PUSH(drive_end, 1)));
# define XfOrM100_COUNT (2)
# define SETUP_XfOrM100(x) SETUP(XfOrM100_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1273 "bc/src/file.c"
  if (drive_end )
    * drive_end = len ; 

  if (! delta && FUNCCALL(SETUP_XfOrM100(_), check_dos_slashslash_qm (next , len , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ))
    RET_VALUE_START (0 ) RET_VALUE_END ; 



  if (delta || ((((next [0 ] ) == '/' ) || ((next [0 ] ) == '\\' ) ) && (((next [1 ] ) == '/' ) || ((next [1 ] ) == '\\' ) ) ) ) {


    j = delta ? delta : 2 ; 
    if (! (no_fw ? (next [j ] == '\\' ) : (((next [j ] ) == '/' ) || ((next [j ] ) == '\\' ) ) ) ) {

      for (; j < len ; j ++ ) {
        if (no_fw ? (next [j ] == '\\' ) : (((next [j ] ) == '/' ) || ((next [j ] ) == '\\' ) ) )  {

          j ++ ; 
          if (no_fw && (j < len ) && (no_fw ? (next [j ] == '\\' ) : (((next [j ] ) == '/' ) || ((next [j ] ) == '\\' ) ) ) )
            j ++ ; 
          if ((j == (delta ? (delta + 2 ) : 4 ) ) 
          && (next [j - 2 ] == '?' ) ) {
          }

          else if ((j < len ) && ! (no_fw ? (next [j ] == '\\' ) : (((next [j ] ) == '/' ) || ((next [j ] ) == '\\' ) ) ) ) {

            for (; j < len ; j ++ ) {
              if (no_fw ? (next [j ] == '\\' ) : (((next [j ] ) == '/' ) || ((next [j ] ) == '\\' ) ) )  {

                if (drive_end )
                  * drive_end = j ; 
                if (exact ) {
                  for (; j < len ; j ++ ) {
                    if (! (no_fw ? (next [j ] == '\\' ) : (((next [j ] ) == '/' ) || ((next [j ] ) == '\\' ) ) ) ) {


                      break ; 
                    }
                  }
                }

# 1312 "bc/src/file.c"
                else 
                is_drive = 1 ; 
                break ; 
              }
            }
            if (j >= len )
              is_drive = 1 ; 
            break ; 
          }
          break ; 
        }

# 1322 "bc/src/file.c"
        else if (((next [j ] ) == '/' ) || ((next [j ] ) == '\\' ) )  {

          break ; 
        }
      }
    }
  }

  RET_VALUE_START (is_drive ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1333 "bc/src/file.c"
static int get_slashslash_qm_dot_ups_end (const char * s , int len , int * _lit_start ) 







{
  /* No conversion */

# 1342 "bc/src/file.c"
  int pos = - 1 , j = 7 ; 

  if (s [6 ] == 'L' ) {
    while (1 ) {
      if (j + 3 > len ) {
        break ; 
      }

# 1348 "bc/src/file.c"
      else if ((s [j ] == '\\' ) && (s [j + 1 ] == '.' ) && (s [j + 2 ] == '.' ) 
      && ((j + 3 == len ) || (s [j + 3 ] == '\\' ) ) ) {
        pos = j + 3 ; 
        j += 3 ; 
      }

# 1352 "bc/src/file.c"
      else {
        break ; 
      }
    }
  }

  if (pos > 0 ) {
    if (pos == len )
      * _lit_start = len ; 
    else if ((pos + 2 < len ) 
    && s [pos + 1 ] == '\\' ) {
      * _lit_start = pos + 2 ; 
    }

# 1364 "bc/src/file.c"
    else {
      * _lit_start = pos + 1 ; 
    }
  }

# 1367 "bc/src/file.c"
  else if (len > 8 ) {
    if (s [8 ] == '\\' )
      * _lit_start = 9 ; 
    else 
    * _lit_start = 8 ; 
  }

# 1372 "bc/src/file.c"
  else 
  * _lit_start = len ; 

  return pos ; 
}

static char * convert_to_backslashbackslash_qm (char * cleaned , int * _clen , char * str , int * _alloc , int len ) 




{
  int clen = * _clen , pos ; 
  int alloc = * _alloc ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(_alloc, 0), PUSH(_clen, 1), PUSH(str, 2), PUSH(cleaned, 3)));
# define XfOrM155_COUNT (4)
# define SETUP_XfOrM155(x) SETUP(XfOrM155_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1387 "bc/src/file.c"
  if (! str ) {
#   define XfOrM164_COUNT (0+XfOrM155_COUNT)
#   define SETUP_XfOrM164(x) SETUP_XfOrM155(x)

# 1388 "bc/src/file.c"
    alloc = clen + 10 ; 
    str = FUNCCALL(SETUP_XfOrM164(_), GC_malloc_atomic (alloc ) ); 
  }

  {
    int cde = 0 ; 
#   define XfOrM163_COUNT (0+XfOrM155_COUNT)
#   define SETUP_XfOrM163(x) SETUP_XfOrM155(x)

# 1394 "bc/src/file.c"
    if (! FUNCCALL(SETUP_XfOrM163(_), check_dos_slashslash_drive (cleaned , 0 , clen , & cde , 0 , 0 ) ))
      cde = 0 ; 
    cleaned = FUNCCALL(SETUP_XfOrM163(_), remove_redundant_slashes (cleaned , & clen , cde , ((void * ) 0 ) , scheme_windows_path_type ) ); 
  }
  cleaned = FUNCCALL(SETUP_XfOrM155(_), do_normal_path_seps (cleaned , & clen , 0 , 1 , scheme_windows_path_type , ((void * ) 0 ) ) ); 
  if (FUNCCALL(SETUP_XfOrM155(_), scheme_is_relative_path (cleaned , clen , scheme_windows_path_type ) )) {
#   define XfOrM162_COUNT (0+XfOrM155_COUNT)
#   define SETUP_XfOrM162(x) SETUP_XfOrM155(x)
    (
# 1400 "bc/src/file.c"
    memcpy (str , "\\\\?\\REL\\" , 8 ) ) ; 
    (memcpy (str + 8 , cleaned , clen ) ) ; 
    pos = clen + 8 ; 
  }

# 1403 "bc/src/file.c"
  else {
    int plen , xdel = 0 ; 
#   define XfOrM156_COUNT (0+XfOrM155_COUNT)
#   define SETUP_XfOrM156(x) SETUP_XfOrM155(x)

# 1405 "bc/src/file.c"
    if (cleaned [0 ] == '\\' ) {
#     define XfOrM159_COUNT (0+XfOrM156_COUNT)
#     define SETUP_XfOrM159(x) SETUP_XfOrM156(x)

# 1406 "bc/src/file.c"
      if (cleaned [1 ] == '\\' ) {

        xdel = 1 ; 
        plen = 7 ; 
        pos = 0 ; 
      }

# 1411 "bc/src/file.c"
      else {
#       define XfOrM160_COUNT (0+XfOrM159_COUNT)
#       define SETUP_XfOrM160(x) SETUP_XfOrM159(x)
        (
# 1413 "bc/src/file.c"
        memcpy (str , "\\\\?\\RED\\" , 8 ) ) ; 
        (memcpy (str + 8 , cleaned , clen ) ) ; 
        pos = clen + 8 ; 
        plen = 0 ; 
      }
    }

# 1418 "bc/src/file.c"
    else {
      plen = 4 ; 
      pos = 0 ; 
    }
    if (plen ) {
#     define XfOrM157_COUNT (0+XfOrM156_COUNT)
#     define SETUP_XfOrM157(x) SETUP_XfOrM156(x)
      (
# 1423 "bc/src/file.c"
      memcpy (str , "\\\\?\\UNC" , plen ) ) ; 
      (memcpy (str + plen , cleaned + xdel , clen - xdel ) ) ; 
      pos = clen + plen - xdel ; 
    }
  }

  * _alloc = alloc ; 
  * _clen = pos ; 
  RET_VALUE_START (str ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1434 "bc/src/file.c"
static char * get_drive_part (const char * wds , int wdlen ) 
{
  int dend , dstart = 0 ; 
  char * naya ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(wds, 1)));
# define XfOrM165_COUNT (2)
# define SETUP_XfOrM165(x) SETUP(XfOrM165_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 1439 "bc/src/file.c"
  if (FUNCCALL(SETUP_XfOrM165(_), check_dos_slashslash_qm (wds , wdlen , & dend , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
  }
  else if (! FUNCCALL(SETUP_XfOrM165(_), check_dos_slashslash_drive (wds , 0 , wdlen , & dend , 0 , 0 ) ))
    dend = 3 ; 

  naya = FUNCCALL(SETUP_XfOrM165(_), GC_malloc_atomic (dend + 1 ) ); 
  (memcpy (naya + dstart , wds , dend ) ) ; 
  naya [dend ] = 0 ; 

  RET_VALUE_START (naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1451 "bc/src/file.c"
char * scheme_getdrive () 
{
  /* No conversion */

# 1453 "bc/src/file.c"
  scheme_security_check_file ("current-drive" , ((void * ) 0 ) , 0x10 ) ; 







  return "" ; 
}


char * strip_trailing_spaces (const char * s , int * _len , int delta , int in_place ) 

{
  int len , skip_end = 0 ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(_len, 0), PUSH(s, 1)));
# define XfOrM168_COUNT (2)
# define SETUP_XfOrM168(x) SETUP(XfOrM168_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1470 "bc/src/file.c"
  if (_len )
    len = * _len ; 
  else 
  len = strlen (s ) ; 


  if ((len - skip_end > delta ) && (((s [len - 1 - skip_end ] ) == '/' ) || ((s [len - 1 - skip_end ] ) == '\\' ) ) ) {
    RET_VALUE_START ((char * ) s ) RET_VALUE_END ; 
  }

  if ((len - skip_end > delta ) 
  && ((s [len - 1 - skip_end ] == ' ' ) || (s [len - 1 - skip_end ] == '.' ) ) ) {
    char * t ; 
    int orig_len = len ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM168_COUNT)));
#   define XfOrM169_COUNT (1+XfOrM168_COUNT)
#   define SETUP_XfOrM169(x) SETUP(XfOrM169_COUNT)
    t = NULLED_OUT ; 

# 1485 "bc/src/file.c"
    while ((len - skip_end > delta ) 
    && ((s [len - 1 - skip_end ] == ' ' ) || (s [len - 1 - skip_end ] == '.' ) ) ) {
      len -- ; 
    }



    if ((len - skip_end > delta ) && ! (((s [len - 1 - skip_end ] ) == '/' ) || ((s [len - 1 - skip_end ] ) == '\\' ) ) ) {
#     define XfOrM170_COUNT (0+XfOrM169_COUNT)
#     define SETUP_XfOrM170(x) SETUP_XfOrM169(x)

# 1493 "bc/src/file.c"
      if (in_place )
        t = (char * ) s ; 
      else {
#       define XfOrM171_COUNT (0+XfOrM170_COUNT)
#       define SETUP_XfOrM171(x) SETUP_XfOrM170(x)

# 1496 "bc/src/file.c"
        t = (char * ) FUNCCALL(SETUP_XfOrM171(_), GC_malloc_atomic (len + 1 ) ); 
        (memcpy (t , s , len - skip_end ) ) ; 
      }
      (memcpy (t + len - skip_end , t + orig_len - skip_end , skip_end ) ) ; 
      t [len ] = 0 ; 

      if (_len )
        * _len = len ; 

      RET_VALUE_START (t ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START ((char * ) s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1513 "bc/src/file.c"
static const char * special_filenames [] = {

# 1513 "bc/src/file.c"
  "NUL" , "CON" , "PRN" , "AUX" , 
  "COM1" , "COM2" , "COM3" , "COM4" , "COM5" , 
  "COM6" , "COM7" , "COM8" , "COM9" , 
  "LPT1" , "LPT2" , "LPT3" , "LPT4" , "LPT5" , 
  "LPT6" , "LPT7" , "LPT8" , "LPT9" , ((void * ) 0 ) }

# 1517 "bc/src/file.c"
; 

static int is_special_filename (const char * f , int offset , int len , int not_nul , int immediate ) 
{
  int i , j , delta ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(f, 0)));
# define XfOrM175_COUNT (1)
# define SETUP_XfOrM175(x) SETUP(XfOrM175_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1524 "bc/src/file.c"
  if (! len )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  if (! immediate ) {
#   define XfOrM188_COUNT (0+XfOrM175_COUNT)
#   define SETUP_XfOrM188(x) SETUP_XfOrM175(x)

# 1527 "bc/src/file.c"
    delta = len ; 
    if (FUNCCALL(SETUP_XfOrM188(_), check_dos_slashslash_qm (f , delta , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    delta -= 1 ; 
    while (delta && ! (((f [delta ] ) == '/' ) || ((f [delta ] ) == '\\' ) ) ) {
      -- delta ; 
    }
    if (! delta && (((unsigned char ) f [0 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM188(_), __ctype_b_loc () )) [(int ) (((unsigned char ) f [0 ] ) ) ] & (unsigned short int ) _ISalpha ) ) && f [1 ] == ':' ) {
      delta = 2 ; 
    }

# 1536 "bc/src/file.c"
    else if (((f [delta ] ) == '/' ) || ((f [delta ] ) == '\\' ) ) 
      delta ++ ; 
  }

# 1538 "bc/src/file.c"
  else 
  delta = offset ; 

  for (i = not_nul ; special_filenames [i ] ; i ++ ) {
    const char * sf = special_filenames [i ] ; 
    for (j = 0 ; sf [j ] && f [delta + j ] ; j ++ ) {
      if (((mzchar ) (unsigned char ) f [delta + j ] + scheme_uchar_ups [(scheme_uchar_cases_table [((mzchar ) (unsigned char ) f [delta + j ] >> 8 ) & 0x1FFF ] [(mzchar ) (unsigned char ) f [delta + j ] & 0xFF ] ) ] ) != sf [j ] )
        break ; 
    }
    if (j && ! sf [j ] ) {
      j += delta ; 
      if ((j >= (len + offset ) ) 
      || (f [j ] == '.' ) 
      || (f [j ] == ':' ) )
        RET_VALUE_START (i + 1 ) RET_VALUE_END ; 
      while ((j < (len + offset ) ) 
      && ((f [j ] == ' ' ) 
      || (f [j ] == '.' ) ) ) {
        j ++ ; 
      }
      if (j >= (len + offset ) )
        RET_VALUE_START (i + 1 ) RET_VALUE_END ; 

      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}



int scheme_is_special_filename (const char * f , int not_nul ) 
{
  /* No conversion */

# 1576 "bc/src/file.c"
  return 0 ; 
}


static char * remove_redundant_slashes (char * filename , int * l , int delta , int * expanded , int kind ) 
{
  int extra = 0 , i , ilen = * l ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(filename, 0), PUSH(l, 1), PUSH(expanded, 2)));
# define XfOrM193_COUNT (3)
# define SETUP_XfOrM193(x) SETUP(XfOrM193_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1584 "bc/src/file.c"
  for (i = ilen ; -- i > delta ; ) {
    if ((kind == scheme_unix_path_type ) ? ((filename [i ] ) == '/' ) : (((filename [i ] ) == '/' ) || ((filename [i ] ) == '\\' ) ) )  {
      if ((kind == scheme_unix_path_type ) ? ((filename [i - 1 ] ) == '/' ) : (((filename [i - 1 ] ) == '/' ) || ((filename [i - 1 ] ) == '\\' ) ) )  {
        extra ++ ; 
      }
    }
  }

  if (extra ) {
    char * naya ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM193_COUNT)));
#   define XfOrM194_COUNT (1+XfOrM193_COUNT)
#   define SETUP_XfOrM194(x) SETUP(XfOrM194_COUNT)
    naya = NULLED_OUT ; 

# 1594 "bc/src/file.c"
    naya = (char * ) FUNCCALL(SETUP_XfOrM194(_), GC_malloc_atomic (ilen + 1 - extra ) ); 
    extra = 0 ; 
    for (i = delta ; i < ilen ; i ++ ) {
      if (((kind == scheme_unix_path_type ) ? ((filename [i ] ) == '/' ) : (((filename [i ] ) == '/' ) || ((filename [i ] ) == '\\' ) ) ) 
      && ((kind == scheme_unix_path_type ) ? ((filename [i + 1 ] ) == '/' ) : (((filename [i + 1 ] ) == '/' ) || ((filename [i + 1 ] ) == '\\' ) ) ) ) {

        extra ++ ; 
      }

# 1601 "bc/src/file.c"
      else {
        naya [i - extra ] = filename [i ] ; 
      }
    }
    (memcpy (naya , filename , delta ) ) ; 
    ilen -= extra ; 
    naya [ilen ] = 0 ; 
    filename = naya ; 
    if (expanded )
      * expanded = 1 ; 
  }

  * l = ilen ; 
  RET_VALUE_START (filename ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1617 "bc/src/file.c"
static char * do_expand_filename (Scheme_Object * o , char * filename , int ilen , const char * errorin , 
int * expanded , 
int report_bad_user , int fullpath , 
int guards , int kind , int expand_user ) 
{

# 647 "bc/src/file.c"
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(expanded, 0), PUSH(errorin, 1), PUSH(filename, 2), PUSH(o, 3)));
# define XfOrM207_COUNT (4)
# define SETUP_XfOrM207(x) SETUP(XfOrM207_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1622 "bc/src/file.c"
  if (expanded )
    * expanded = 0 ; 

  if (o ) {
#   define XfOrM245_COUNT (0+XfOrM207_COUNT)
#   define SETUP_XfOrM245(x) SETUP_XfOrM207(x)

# 1626 "bc/src/file.c"
    o = (((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_windows_path_type ) ) ? o : FUNCCALL(SETUP_XfOrM245(_), scheme_char_string_to_path (o ) )) ; 
    filename = (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) ; 
    ilen = (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . tag_val ) ; 
  }

  if (guards )
    FUNCCALL(SETUP_XfOrM207(_), scheme_security_check_file (errorin , filename , guards ) ); 

  if (ilen < 0 )
    ilen = strlen (filename ) ; 
  else {
#   define XfOrM243_COUNT (0+XfOrM207_COUNT)
#   define SETUP_XfOrM243(x) SETUP_XfOrM207(x)

# 1637 "bc/src/file.c"
    if (FUNCCALL(SETUP_XfOrM243(_), has_null (filename , ilen ) )) {
#     define XfOrM244_COUNT (0+XfOrM243_COUNT)
#     define SETUP_XfOrM244(x) SETUP_XfOrM243(x)

# 1638 "bc/src/file.c"
      if (errorin )
        (__funcarg105 = FUNCCALL(SETUP_XfOrM244(_), scheme_make_sized_path (filename , ilen , 1 ) ), FUNCCALL_AGAIN(raise_null_error (errorin , __funcarg105 , "" ) )) ; 
      else 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (kind == scheme_unix_path_type ) {
#   define XfOrM239_COUNT (0+XfOrM207_COUNT)
#   define SETUP_XfOrM239(x) SETUP_XfOrM207(x)

    if (expand_user && (filename [0 ] == '~' ) ) {
      char * new_filename ; 
#     define XfOrM241_COUNT (0+XfOrM239_COUNT)
#     define SETUP_XfOrM241(x) SETUP_XfOrM239(x)
      new_filename = NULLED_OUT ; 

# 1651 "bc/src/file.c"
      new_filename = (rktio_expand_user_tilde (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename ) ) ; 
      if (! new_filename ) {
#       define XfOrM242_COUNT (0+XfOrM241_COUNT)
#       define SETUP_XfOrM242(x) SETUP_XfOrM241(x)
        FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "%s: bad username in path\n" "  path: %q\n" "  system error: %R" , errorin , filename ) )

        ; 
      }

      filename = FUNCCALL(SETUP_XfOrM241(_), scheme_strdup_and_free (new_filename ) ); 
      ilen = strlen (filename ) ; 
      if (expanded )
        * expanded = 1 ; 
    }



    {
      int l = ilen ; 
#     define XfOrM240_COUNT (0+XfOrM239_COUNT)
#     define SETUP_XfOrM240(x) SETUP_XfOrM239(x)

# 1670 "bc/src/file.c"
      filename = FUNCCALL(SETUP_XfOrM240(_), remove_redundant_slashes (filename , & l , 0 , expanded , scheme_unix_path_type ) ); 
      ilen = l ; 
    }
  }

# 1673 "bc/src/file.c"
  else {

    int drive_end , clean_start ; 
    int fixit = 0 , i , insert_initial_sep = 0 ; 
#   define XfOrM214_COUNT (0+XfOrM207_COUNT)
#   define SETUP_XfOrM214(x) SETUP_XfOrM207(x)

# 1678 "bc/src/file.c"
    if (! FUNCCALL(SETUP_XfOrM214(_), check_dos_slashslash_qm (filename , ilen , & drive_end , & clean_start , ((void * ) 0 ) ) ))
      drive_end = 0 ; 
    else if (drive_end < 0 ) {
#     define XfOrM237_COUNT (0+XfOrM214_COUNT)
#     define SETUP_XfOrM237(x) SETUP_XfOrM214(x)
      FUNCCALL(SETUP_XfOrM237(_), get_slashslash_qm_dot_ups_end (filename , ilen , & drive_end ) )
      ; 

      if ((drive_end != ilen ) && (filename [drive_end - 2 ] != '\\' ) ) {
        insert_initial_sep = 1 ; 
        fixit = 1 ; 
      }
    }

# 1690 "bc/src/file.c"
    else if (drive_end == 8 ) {
#     define XfOrM236_COUNT (0+XfOrM214_COUNT)
#     define SETUP_XfOrM236(x) SETUP_XfOrM214(x)

# 1692 "bc/src/file.c"
      if ((((unsigned char ) filename [4 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM236(_), __ctype_b_loc () )) [(int ) (((unsigned char ) filename [4 ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
      && (filename [5 ] == ':' ) )
        drive_end = 6 ; 
    }

# 1695 "bc/src/file.c"
    else if (drive_end == 9 ) {
#     define XfOrM235_COUNT (0+XfOrM214_COUNT)
#     define SETUP_XfOrM235(x) SETUP_XfOrM214(x)

# 1697 "bc/src/file.c"
      if ((filename [4 ] == '\\' ) 
      && (((unsigned char ) filename [5 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM235(_), __ctype_b_loc () )) [(int ) (((unsigned char ) filename [5 ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
      && (filename [6 ] == ':' ) )
        drive_end = 7 ; 
    }

# 1701 "bc/src/file.c"
    else {
      drive_end = clean_start ; 
    }



    if (! drive_end 
    && (((unsigned char ) filename [0 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM214(_), __ctype_b_loc () )) [(int ) (((unsigned char ) filename [0 ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
    && (filename [1 ] == ':' ) 
    && ! (((filename [2 ] ) == '/' ) || ((filename [2 ] ) == '\\' ) ) ) {
      drive_end = 2 ; 
      insert_initial_sep = 1 ; 
      fixit = 1 ; 
    }

# 1714 "bc/src/file.c"
    else {
      int found_slash = 0 , prim_only = drive_end ; 

      for (i = ilen ; i -- > drive_end ; ) {
        if (prim_only ? ((filename [i ] ) == '\\' ) : (((filename [i ] ) == '/' ) || ((filename [i ] ) == '\\' ) ) )  {
          if (prim_only ? ((filename [i - 1 ] ) == '\\' ) : (((filename [i - 1 ] ) == '/' ) || ((filename [i - 1 ] ) == '\\' ) ) )  {
            if ((i > 1 ) || ! found_slash )
              fixit = 1 ; 
            break ; 
          }
          found_slash = 1 ; 
        }
      }
    }

    if (fixit ) {
      int pos , prim_only = drive_end ; 
      char * naya ; 
      BLOCK_SETUP((PUSH(naya, 0+XfOrM214_COUNT)));
#     define XfOrM215_COUNT (1+XfOrM214_COUNT)
#     define SETUP_XfOrM215(x) SETUP(XfOrM215_COUNT)
      naya = NULLED_OUT ; 

# 1733 "bc/src/file.c"
      if (expanded )
        * expanded = 1 ; 

      if (! drive_end ) {
#       define XfOrM225_COUNT (0+XfOrM215_COUNT)
#       define SETUP_XfOrM225(x) SETUP_XfOrM215(x)

# 1738 "bc/src/file.c"
        if (FUNCCALL(SETUP_XfOrM225(_), check_dos_slashslash_drive (filename , 0 , ilen , ((void * ) 0 ) , 0 , 0 ) ))
          drive_end = 2 ; 
      }

      naya = (char * ) FUNCCALL(SETUP_XfOrM215(_), GC_malloc_atomic (ilen + 2 ) ); 
      (
      memcpy (naya , filename , drive_end ) ) ; 
      pos = i = drive_end ; 
      if (insert_initial_sep ) {
        naya [pos ++ ] = '\\' ; 
      }

      while (i < ilen ) {
        if ((prim_only ? ((filename [i ] ) == '\\' ) : (((filename [i ] ) == '/' ) || ((filename [i ] ) == '\\' ) ) ) 
        && ((i + 1 ) < ilen ) 
        && (prim_only ? ((filename [i + 1 ] ) == '\\' ) : (((filename [i + 1 ] ) == '/' ) || ((filename [i + 1 ] ) == '\\' ) ) ) ) {
          i ++ ; 
        }

# 1755 "bc/src/file.c"
        else 
        naya [pos ++ ] = filename [i ++ ] ; 
      }

      naya [pos ] = 0 ; 
      filename = naya ; 
      ilen = pos ; 

      if (drive_end == 4 ) {
#       define XfOrM216_COUNT (0+XfOrM215_COUNT)
#       define SETUP_XfOrM216(x) SETUP_XfOrM215(x)
        FUNCCALL(SETUP_XfOrM216(_), check_dos_slashslash_qm (filename , ilen , & drive_end , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
        if (drive_end != 4 ) {
#         define XfOrM217_COUNT (0+XfOrM216_COUNT)
#         define SETUP_XfOrM217(x) SETUP_XfOrM216(x)

# 1769 "bc/src/file.c"
          if (filename [4 ] == '\\' ) {
#           define XfOrM219_COUNT (0+XfOrM217_COUNT)
#           define SETUP_XfOrM219(x) SETUP_XfOrM217(x)
            (
# 1771 "bc/src/file.c"
            memmove (filename + 5 , filename + 4 , ilen - 3 ) ) ; 
            filename [4 ] = '\\' ; 
            ilen += 1 ; 
          }

# 1774 "bc/src/file.c"
          else {
#           define XfOrM218_COUNT (0+XfOrM217_COUNT)
#           define SETUP_XfOrM218(x) SETUP_XfOrM217(x)
            (
# 1776 "bc/src/file.c"
            memmove (filename + 6 , filename + 4 , ilen - 3 ) ) ; 
            filename [4 ] = '\\' ; 
            filename [5 ] = '\\' ; 
            ilen += 2 ; 
          }
        }
      }
    }
  }

  if (fullpath ) {
#   define XfOrM208_COUNT (0+XfOrM207_COUNT)
#   define SETUP_XfOrM208(x) SETUP_XfOrM207(x)

# 1787 "bc/src/file.c"
    if (! FUNCCALL(SETUP_XfOrM208(_), scheme_is_complete_path (filename , ilen , kind ) )) {
#     define XfOrM213_COUNT (0+XfOrM208_COUNT)
#     define SETUP_XfOrM213(x) SETUP_XfOrM208(x)

# 1788 "bc/src/file.c"
      if (expanded )
        * expanded = 1 ; 
      filename = FUNCCALL(SETUP_XfOrM213(_), do_path_to_complete_path (filename , ilen , ((void * ) 0 ) , 0 , kind ) ); 
      ilen = strlen (filename ) ; 
    }
    if (kind == scheme_windows_path_type ) {
#     define XfOrM209_COUNT (0+XfOrM208_COUNT)
#     define SETUP_XfOrM209(x) SETUP_XfOrM208(x)



      if (ilen > ((fullpath > 1 ) ? fullpath : 247 ) ) {
#       define XfOrM210_COUNT (0+XfOrM209_COUNT)
#       define SETUP_XfOrM210(x) SETUP_XfOrM209(x)

# 1800 "bc/src/file.c"
        if (! FUNCCALL(SETUP_XfOrM210(_), check_dos_slashslash_qm (filename , ilen , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) {



          int l = ilen , a = ilen + 1 ; 
          Scheme_Object * p ; 
          BLOCK_SETUP((PUSH(p, 0+XfOrM210_COUNT)));
#         define XfOrM211_COUNT (1+XfOrM210_COUNT)
#         define SETUP_XfOrM211(x) SETUP(XfOrM211_COUNT)
          p = NULLED_OUT ; 

# 1807 "bc/src/file.c"
          p = FUNCCALL(SETUP_XfOrM211(_), scheme_make_sized_path (filename , ilen , 0 ) ); 
          p = FUNCCALL_AGAIN(do_simplify_path (p , scheme_null , 0 , 0 , 0 , 1 , scheme_windows_path_type , 0 ) ); 
          filename = (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) ; 
          ilen = (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) ; 

          if (ilen > ((fullpath > 1 ) ? fullpath : 247 ) ) {
#           define XfOrM212_COUNT (0+XfOrM211_COUNT)
#           define SETUP_XfOrM212(x) SETUP_XfOrM211(x)

# 1813 "bc/src/file.c"
            filename = FUNCCALL(SETUP_XfOrM212(_), convert_to_backslashbackslash_qm (filename , & l , filename , & a , 0 ) ); 
            filename [l ] = 0 ; 
          }
        }
      }
    }
  }

  RET_VALUE_START (filename ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1824 "bc/src/file.c"
char * scheme_expand_filename (char * filename , int ilen , const char * errorin , int * expanded , int guards ) 
{
  /* No conversion */

# 1826 "bc/src/file.c"
  return do_expand_filename (((void * ) 0 ) , filename , ilen , errorin , expanded , 1 , 1 , guards , scheme_unix_path_type , 0 ) ; 
}

char * scheme_expand_user_filename (char * filename , int ilen , const char * errorin , int * expanded , int guards ) 
{
  /* No conversion */

# 1831 "bc/src/file.c"
  return do_expand_filename (((void * ) 0 ) , filename , ilen , errorin , expanded , 1 , 1 , guards , scheme_unix_path_type , 1 ) ; 
}

char * scheme_expand_string_filename (Scheme_Object * o , const char * errorin , int * expanded , int guards ) 
{
  /* No conversion */

# 1836 "bc/src/file.c"
  return do_expand_filename (o , ((void * ) 0 ) , 0 , errorin , expanded , 1 , 1 , guards , scheme_unix_path_type , 0 ) ; 
}





int scheme_file_exists (char * filename ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(filename, 0)));
# define XfOrM249_COUNT (1)
# define SETUP_XfOrM249(x) SETUP(XfOrM249_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1845 "bc/src/file.c"
  if (FUNCCALL(SETUP_XfOrM249(_), scheme_is_special_filename (filename , 0 ) ))
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START ((rktio_file_exists (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1850 "bc/src/file.c"
int scheme_directory_exists (char * dirname ) 
{
  /* No conversion */

# 1852 "bc/src/file.c"
  return rktio_directory_exists (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , dirname ) ; 
}

int scheme_is_regular_file (char * filename ) 
{
  /* No conversion */

# 1857 "bc/src/file.c"
  return rktio_is_regular_file (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename ) ; 
}

static Scheme_Object * file_exists (int argc , Scheme_Object * * argv ) 
{
  char * f ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(f, 0)));
# define XfOrM252_COUNT (1)
# define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  f = NULLED_OUT ; 

# 1864 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("file-exists?" , "path-string?" , 0 , argc , argv ) ); 

  f = FUNCCALL(SETUP_XfOrM252(_), do_expand_filename (argv [0 ] , ((void * ) 0 ) , 0 , "file-exists?" , ((void * ) 0 ) , 0 , 1 , 0x10 , scheme_unix_path_type , 0 ) )







  ; 

  RET_VALUE_START ((f && FUNCCALL_EMPTY(scheme_file_exists (f ) )) ? scheme_true : scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1880 "bc/src/file.c"
static Scheme_Object * directory_exists (int argc , Scheme_Object * * argv ) 
{
  char * f ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(f, 0)));
# define XfOrM253_COUNT (1)
# define SETUP_XfOrM253(x) SETUP(XfOrM253_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  f = NULLED_OUT ; 

# 1884 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("directory-exists?" , "path-string?" , 0 , argc , argv ) ); 

  f = FUNCCALL(SETUP_XfOrM253(_), do_expand_filename (argv [0 ] , ((void * ) 0 ) , 0 , "directory-exists?" , ((void * ) 0 ) , 0 , 1 , 0x10 , scheme_unix_path_type , 0 ) )







  ; 

  RET_VALUE_START ((f && FUNCCALL_EMPTY(scheme_directory_exists (f ) )) ? scheme_true : scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1900 "bc/src/file.c"
static Scheme_Object * link_exists (int argc , Scheme_Object * * argv ) 
{
  char * filename ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(filename, 0)));
# define XfOrM254_COUNT (1)
# define SETUP_XfOrM254(x) SETUP(XfOrM254_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 

# 1904 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("link-exists?" , "path-string?" , 0 , argc , argv ) ); 

  filename = FUNCCALL(SETUP_XfOrM254(_), do_expand_filename (argv [0 ] , ((void * ) 0 ) , 0 , "link-exists?" , ((void * ) 0 ) , 0 , 1 , 0x10 , scheme_unix_path_type , 0 ) )







  ; 

  if (rktio_link_exists (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename ) ) 
    RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1923 "bc/src/file.c"
Scheme_Object * scheme_get_fd_identity (Scheme_Object * port , intptr_t fd , char * path , int noerr ) 

{
  rktio_identity_t * ident ; 
  Scheme_Object * a , * b , * c , * args [2 ] ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(ident, 0), PUSH(a, 1), PUSH(b, 2), PUSHARRAY(args, 2, 3), PUSH(c, 6), PUSH(path, 7)));
# define XfOrM255_COUNT (8)
# define SETUP_XfOrM255(x) SETUP(XfOrM255_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ident = NULLED_OUT ; 
  a = NULLED_OUT ; 
  b = NULLED_OUT ; 
  c = NULLED_OUT ; 
  args[0] = NULLED_OUT ; 
  args[1] = NULLED_OUT ; 

# 1929 "bc/src/file.c"
  if (path )
    ident = (rktio_path_identity (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , path , fd == 0 ) ) ; 
  else {
    rktio_fd_t * rfd ; 
#   define XfOrM259_COUNT (0+XfOrM255_COUNT)
#   define SETUP_XfOrM259(x) SETUP_XfOrM255(x)
    rfd = NULLED_OUT ; 

# 1933 "bc/src/file.c"
    rfd = (rktio_system_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fd , (1 << 10 ) ) ) ; 
    ident = (rktio_fd_identity (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , rfd ) ) ; 
    (rktio_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , rfd ) ) ; 
  }

  if (! ident ) {
#   define XfOrM256_COUNT (0+XfOrM255_COUNT)
#   define SETUP_XfOrM256(x) SETUP_XfOrM255(x)

# 1939 "bc/src/file.c"
    if (noerr )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    if (! path ) {
#     define XfOrM258_COUNT (0+XfOrM256_COUNT)
#     define SETUP_XfOrM258(x) SETUP_XfOrM256(x)
      FUNCCALL(SETUP_XfOrM258(_), scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "port-file-identity: error obtaining identity\n" "  system error: %R" ) ); 
    }

# 1945 "bc/src/file.c"
    else {
#     define XfOrM257_COUNT (0+XfOrM256_COUNT)
#     define SETUP_XfOrM257(x) SETUP_XfOrM256(x)
      FUNCCALL(SETUP_XfOrM257(_), scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "file-or-directory-identity: error obtaining identity for path\n" "  path: %q\n" "  system error: %R" , path ) )

      ; 
    }
  }

  a = FUNCCALL(SETUP_XfOrM255(_), scheme_make_integer_value_from_unsigned (ident -> a ) ); 
  b = FUNCCALL(SETUP_XfOrM255(_), scheme_make_integer_value_from_unsigned (ident -> b ) ); 
  c = FUNCCALL_AGAIN(scheme_make_integer_value_from_unsigned (ident -> c ) ); 

  args [0 ] = b ; 
  args [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (ident -> c_bits ) ) ) << 1 ) | 0x1 ) ) ; 
  b = FUNCCALL(SETUP_XfOrM255(_), scheme_bitwise_shift (2 , args ) ); 

  args [0 ] = a ; 
  args [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (ident -> c_bits + ident -> b_bits ) ) ) << 1 ) | 0x1 ) ) ; 
  a = FUNCCALL(SETUP_XfOrM255(_), scheme_bitwise_shift (2 , args ) ); 
  FUNCCALL_AGAIN(free (ident ) )
  ; 

  RET_VALUE_START ((__funcarg106 = FUNCCALL(SETUP_XfOrM255(_), scheme_bin_plus (a , b ) ), FUNCCALL_AGAIN(scheme_bin_plus (__funcarg106 , c ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1971 "bc/src/file.c"
static int path_is_simple_dir_without_sep (Scheme_Object * path ) 
{
  int len ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(path, 0)));
# define XfOrM260_COUNT (1)
# define SETUP_XfOrM260(x) SETUP(XfOrM260_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1975 "bc/src/file.c"
  len = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) ; 
  if (((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) [len - 1 ] == scheme_unix_path_type ) ? ((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '/' ) : (((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '/' ) || ((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '\\' ) ) ) 
    RET_VALUE_START (0 ) RET_VALUE_END ; 




  if ((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) [len - 1 ] == '.' ) {
    if (len == 1 )
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    if (((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) [len - 2 ] == scheme_unix_path_type ) ? ((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '/' ) : (((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '/' ) || ((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '\\' ) ) ) 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    if ((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) [len - 2 ] == '.' ) {
      if (len == 2 )
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      if (((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) [len - 3 ] == scheme_unix_path_type ) ? ((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '/' ) : (((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '/' ) || ((((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) ) == '\\' ) ) ) 
        RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

# 2009 "bc/src/file.c"
  if (((((intptr_t ) (path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (path ) ) -> type ) == scheme_windows_path_type ) {
    int drive_end ; 
#   define XfOrM261_COUNT (0+XfOrM260_COUNT)
#   define SETUP_XfOrM261(x) SETUP_XfOrM260(x)

# 2011 "bc/src/file.c"
    if (FUNCCALL(SETUP_XfOrM261(_), check_dos_slashslash_drive ((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) , 0 , len , & drive_end , 1 , 0 ) ))
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    if (len == 2 
    && ((((unsigned char ) (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) [0 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM261(_), __ctype_b_loc () )) [(int ) (((unsigned char ) (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) [0 ] ) ) ] & (unsigned short int ) _ISalpha ) ) ) 
    && ((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) [1 ] == ':' ) )
      RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2022 "bc/src/file.c"
static Scheme_Object * do_path_to_directory_path (char * s , intptr_t offset , intptr_t len , Scheme_Object * p , int just_check , 
int kind ) 



{
  char * s2 ; 
  int not_a_sep = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s2, 0), PUSH(s, 1), PUSH(p, 2)));
# define XfOrM264_COUNT (3)
# define SETUP_XfOrM264(x) SETUP(XfOrM264_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s2 = NULLED_OUT ; 

# 2031 "bc/src/file.c"
  if (kind == scheme_windows_path_type ) {
    int slash_dir_sep = 1 ; 
#   define XfOrM267_COUNT (0+XfOrM264_COUNT)
#   define SETUP_XfOrM267(x) SETUP_XfOrM264(x)

# 2034 "bc/src/file.c"
    {
      int drive_end ; 
#     define XfOrM269_COUNT (0+XfOrM267_COUNT)
#     define SETUP_XfOrM269(x) SETUP_XfOrM267(x)

# 2037 "bc/src/file.c"
      if (offset ) {
#       define XfOrM276_COUNT (0+XfOrM269_COUNT)
#       define SETUP_XfOrM276(x) SETUP_XfOrM269(x)
        FUNCCALL_EMPTY(scheme_signal_error ("path->directory-path currently assumes a 0 offset" ) )
# 2038 "bc/src/file.c"
        ; 
      }

      if (FUNCCALL(SETUP_XfOrM269(_), check_dos_slashslash_qm (s , len , & drive_end , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
#       define XfOrM272_COUNT (0+XfOrM269_COUNT)
#       define SETUP_XfOrM272(x) SETUP_XfOrM269(x)

# 2042 "bc/src/file.c"
        if (just_check > 1 ) {
#         define XfOrM273_COUNT (0+XfOrM272_COUNT)
#         define SETUP_XfOrM273(x) SETUP_XfOrM272(x)

# 2043 "bc/src/file.c"
          if (drive_end < 0 ) {

            int litpos ; 
#           define XfOrM275_COUNT (0+XfOrM273_COUNT)
#           define SETUP_XfOrM275(x) SETUP_XfOrM273(x)

# 2046 "bc/src/file.c"
            drive_end = FUNCCALL(SETUP_XfOrM275(_), get_slashslash_qm_dot_ups_end (s , len , & litpos ) ); 

            if (litpos >= len )
              RET_VALUE_START (p ) RET_VALUE_END ; 
          }

# 2050 "bc/src/file.c"
          else {

            if (drive_end == len )
              RET_VALUE_START (p ) RET_VALUE_END ; 
          }
        }


        slash_dir_sep = 0 ; 


        not_a_sep = 1 ; 
      }

# 2062 "bc/src/file.c"
      else {
#       define XfOrM270_COUNT (0+XfOrM269_COUNT)
#       define SETUP_XfOrM270(x) SETUP_XfOrM269(x)

# 2063 "bc/src/file.c"
        if (just_check > 1 ) {
#         define XfOrM271_COUNT (0+XfOrM270_COUNT)
#         define SETUP_XfOrM271(x) SETUP_XfOrM270(x)

# 2065 "bc/src/file.c"
          if ((len == 2 ) 
          && (((unsigned char ) s [offset ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM271(_), __ctype_b_loc () )) [(int ) (((unsigned char ) s [offset ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
          && (s [offset + 1 ] == ':' ) )
            RET_VALUE_START (p ) RET_VALUE_END ; 
        }
      }
    }
    {
      int cs = s [offset + len - 1 ] ; 
      if (slash_dir_sep ? (((cs ) == '/' ) || ((cs ) == '\\' ) ) : (cs == '\\' ) )
        RET_VALUE_START (p ) RET_VALUE_END ; 
    }
  }

# 2077 "bc/src/file.c"
  else {
    if ((s [offset + len - 1 ] ) == '/' ) 
      RET_VALUE_START (p ) RET_VALUE_END ; 
  }

  if (just_check > 1 ) {
    if (! not_a_sep 
    && (((len > 1 ) && (s [offset + len - 1 ] == '.' ) && ((kind == scheme_unix_path_type ) ? ((s [offset + len - 2 ] ) == '/' ) : (((s [offset + len - 2 ] ) == '/' ) || ((s [offset + len - 2 ] ) == '\\' ) ) ) ) 
    || ((len == 1 ) && (s [offset ] == '.' ) ) ) )
      RET_VALUE_START (p ) RET_VALUE_END ; 
    if (! not_a_sep 
    && (((len > 2 ) 
    && (s [offset + len - 1 ] == '.' ) 
    && (s [offset + len - 2 ] == '.' ) 
    && ((kind == scheme_unix_path_type ) ? ((s [offset + len - 3 ] ) == '/' ) : (((s [offset + len - 3 ] ) == '/' ) || ((s [offset + len - 3 ] ) == '\\' ) ) ) ) 
    || ((len == 2 ) && (s [offset ] == '.' ) && (s [offset + 1 ] == '.' ) ) ) )
      RET_VALUE_START (p ) RET_VALUE_END ; 
  }

# 2110 "bc/src/file.c"
  if (just_check )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  s2 = (char * ) FUNCCALL(SETUP_XfOrM264(_), GC_malloc_atomic (len + 2 ) ); 
  (memcpy (s2 , s XFORM_OK_PLUS offset , len ) ) ; 
  s2 [len ] = ((kind == scheme_unix_path_type ) ? '/' : '\\' ) ; 
  s2 [len + 1 ] = 0 ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (s2 , 0 , len + 1 , 0 , kind ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2121 "bc/src/file.c"
Scheme_Object * scheme_path_to_directory_path (Scheme_Object * p ) 
{
  /* No conversion */

# 2123 "bc/src/file.c"
  return do_path_to_directory_path ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) , p , 0 , 
  ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) ; 
}

static char * do_normal_path_seps (char * si , int * _len , int delta , int strip_trail , int kind , int * _did ) 
{
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(_did, 0), PUSH(si, 1), PUSH(_len, 2)));
# define XfOrM278_COUNT (3)
# define SETUP_XfOrM278(x) SETUP(XfOrM278_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2129 "bc/src/file.c"
  if (kind == scheme_unix_path_type ) {
    RET_VALUE_START (si ) RET_VALUE_END ; 
  }

# 2131 "bc/src/file.c"
  else {
    int i ; 
    unsigned char * s ; 
    int len = * _len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM278_COUNT)));
#   define XfOrM279_COUNT (1+XfOrM278_COUNT)
#   define SETUP_XfOrM279(x) SETUP(XfOrM279_COUNT)
    s = NULLED_OUT ; 

# 2136 "bc/src/file.c"
    if (kind == scheme_windows_path_type ) {
#     define XfOrM285_COUNT (0+XfOrM279_COUNT)
#     define SETUP_XfOrM285(x) SETUP_XfOrM279(x)

# 2137 "bc/src/file.c"
      if (! delta && FUNCCALL(SETUP_XfOrM285(_), check_dos_slashslash_qm (si , len , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ))
        RET_VALUE_START (si ) RET_VALUE_END ; 
    }

    s = (unsigned char * ) ((char * ) FUNCCALL(SETUP_XfOrM279(_), GC_malloc_atomic (sizeof (char ) * (len + 1 ) ) )) ; 
    (memcpy (s , si , len + 1 ) ) ; 

    if (kind == scheme_windows_path_type ) {
#     define XfOrM280_COUNT (0+XfOrM279_COUNT)
#     define SETUP_XfOrM280(x) SETUP_XfOrM279(x)

# 2145 "bc/src/file.c"
      for (i = delta ; i < len ; i ++ ) {
        if (s [i ] == '/' ) {
          if (_did )
            * _did = 1 ; 
          s [i ] = '\\' ; 
        }
      }
      if (strip_trail )
        s = (unsigned char * ) FUNCCALL(SETUP_XfOrM280(_), strip_trailing_spaces ((char * ) s , _len , delta , 1 ) ); 
    }

    RET_VALUE_START ((char * ) s ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2160 "bc/src/file.c"
char * scheme_normal_path_seps (char * si , int * _len , int delta ) 
{
  /* No conversion */

# 2162 "bc/src/file.c"
  return do_normal_path_seps (si , _len , delta , 1 , scheme_unix_path_type , ((void * ) 0 ) ) ; 
}



static Scheme_Object * do_build_path (int argc , Scheme_Object * * argv , int idelta , int no_final_simplify , int kind ) 





{

  int pos , i , len , no_sep ; 
  int alloc = 256 ; 
  char buffer [256 ] , * str , * next ; 
  int rel , next_off ; 
  int first_was_drive = 0 ; 
  int first_len = 0 ; 
  int needs_extra_slash = 0 ; 
  int pre_unc = 0 ; 
  int pre_qm = 0 ; 
  const char * who = (idelta ? "build-path/convention-type" : "build-path" ) ; 
  const char * __funcarg113 = NULLED_OUT ; 

# 513 "bc/src/file.c"
  Scheme_Object * __funcarg112 = NULLED_OUT ; 

# 513 "bc/src/file.c"
  Scheme_Object * __funcarg111 = NULLED_OUT ; 

# 513 "bc/src/file.c"
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(next, 1), PUSH(str, 2), PUSH(who, 3)));
# define XfOrM288_COUNT (4)
# define SETUP_XfOrM288(x) SETUP(XfOrM288_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  str = NULLED_OUT ; 
  next = NULLED_OUT ; 

# 2186 "bc/src/file.c"
  str = buffer ; 
  pos = 0 ; 

  no_sep = 0 ; 


  for (i = 0 ; i < argc ; i ++ ) {
#   define XfOrM378_COUNT (0+XfOrM288_COUNT)
#   define SETUP_XfOrM378(x) SETUP_XfOrM288(x)

# 2193 "bc/src/file.c"
    if ((((Scheme_Type ) (((((intptr_t ) (argv [i + idelta ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + idelta ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (argv [i + idelta ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + idelta ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [i + idelta ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + idelta ] ) ) -> type ) <= scheme_windows_path_type ) ) ) 
    || (((Scheme_Type ) (((((intptr_t ) (argv [i + idelta ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + idelta ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    && (((argv [i + idelta ] ) == (up_symbol ) ) 
    || ((argv [i + idelta ] ) == (same_symbol ) ) ) ) ) {
#     define XfOrM380_COUNT (0+XfOrM378_COUNT)
#     define SETUP_XfOrM380(x) SETUP_XfOrM378(x)

# 2197 "bc/src/file.c"
      next_off = 0 ; 
      if ((argv [i + idelta ] ) == (up_symbol ) )  {
        next = ".." ; 
        len = 2 ; 
      }

# 2201 "bc/src/file.c"
      else if ((argv [i + idelta ] ) == (same_symbol ) )  {
        next = "." ; 
        len = 1 ; 
      }

# 2204 "bc/src/file.c"
      else {
        Scheme_Object * bs ; 
        BLOCK_SETUP((PUSH(bs, 0+XfOrM380_COUNT)));
#       define XfOrM457_COUNT (1+XfOrM380_COUNT)
#       define SETUP_XfOrM457(x) SETUP(XfOrM457_COUNT)
        bs = NULLED_OUT ; 

# 2207 "bc/src/file.c"
        if ((Scheme_Type ) (((((intptr_t ) (argv [i + idelta ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + idelta ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#         define XfOrM461_COUNT (0+XfOrM457_COUNT)
#         define SETUP_XfOrM461(x) SETUP_XfOrM457(x)

# 2208 "bc/src/file.c"
          if (kind != scheme_unix_path_type ) {
#           define XfOrM462_COUNT (0+XfOrM461_COUNT)
#           define SETUP_XfOrM462(x) SETUP_XfOrM461(x)
            FUNCCALL_EMPTY(scheme_contract_error (who , (idelta ? "specified convention incompatible with string path element" : "preceding path's convention incompatible with string path element" ) , "path element" , 1 , argv [i + idelta ] , (idelta ? "convention" : "preceding path's convention" ) , 0 , (kind == scheme_unix_path_type ) ? "'unix" : "'windows" , ((void * ) 0 ) ) )





            ; 
          }
        }

        bs = (((((((intptr_t ) (argv [i + idelta ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + idelta ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [i + idelta ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + idelta ] ) ) -> type ) <= scheme_windows_path_type ) ) ? argv [i + idelta ] : FUNCCALL(SETUP_XfOrM457(_), scheme_char_string_to_path (argv [i + idelta ] ) )) ; 

        if (kind != ((((intptr_t ) (bs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bs ) ) -> type ) ) {
#         define XfOrM460_COUNT (0+XfOrM457_COUNT)
#         define SETUP_XfOrM460(x) SETUP_XfOrM457(x)
          FUNCCALL_EMPTY(scheme_contract_error (who , (idelta ? "specified convention incompatible with given path element" : "preceding path's convention incompatible with given path element" ) , "path element" , 1 , argv [i + idelta ] , (idelta ? "convention" : "preceding path's convention" ) , 0 , (kind == scheme_unix_path_type ) ? "'unix" : "'windows" , ((void * ) 0 ) ) )





          ; 
        }

        next = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
        len = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 
        if (! len ) {
          char * astr ; 
          intptr_t alen ; 
          BLOCK_SETUP((PUSH(astr, 0+XfOrM457_COUNT)));
#         define XfOrM459_COUNT (1+XfOrM457_COUNT)
#         define SETUP_XfOrM459(x) SETUP(XfOrM459_COUNT)
          astr = NULLED_OUT ; 

# 2241 "bc/src/file.c"
          astr = FUNCCALL(SETUP_XfOrM459(_), scheme_make_arg_lines_string ("   " , i + idelta , argc , argv , & alen ) ); 
          (__funcarg113 = FUNCCALL(SETUP_XfOrM459(_), scheme_number_suffix (i + 1 ) )





          , FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: path element is an empty string\n" "  argument position: %d%s\n" "  other arguments...:%t" , who , i + 1 , __funcarg113 , astr , alen ) )) 
          ; 
          RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
        }

        if (FUNCCALL(SETUP_XfOrM457(_), has_null (next , len ) )) {
#         define XfOrM458_COUNT (0+XfOrM457_COUNT)
#         define SETUP_XfOrM458(x) SETUP_XfOrM457(x)
          FUNCCALL(SETUP_XfOrM458(_), raise_null_error (who , argv [i + idelta ] , " element" ) )
# 2254 "bc/src/file.c"
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }

      if (kind == scheme_windows_path_type ) {





        int p = pos ; 
#       define XfOrM456_COUNT (0+XfOrM380_COUNT)
#       define SETUP_XfOrM456(x) SETUP_XfOrM380(x)
        FUNCCALL(SETUP_XfOrM456(_), strip_trailing_spaces (str , & p , first_len , 1 ) )
# 2266 "bc/src/file.c"
        ; 
        pos = p ; 
      }


      if (pos + len + 4 >= alloc ) {
        char * naya ; 
        int newalloc ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM380_COUNT)));
#       define XfOrM455_COUNT (1+XfOrM380_COUNT)
#       define SETUP_XfOrM455(x) SETUP(XfOrM455_COUNT)
        naya = NULLED_OUT ; 

# 2275 "bc/src/file.c"
        newalloc = 2 * alloc + len + 1 ; 
        naya = (char * ) FUNCCALL(SETUP_XfOrM455(_), GC_malloc_atomic (newalloc ) ); 
        (memcpy (naya , str , pos ) ) ; 
        alloc = newalloc ; 

        str = naya ; 
      }

      if (kind == scheme_unix_path_type ) {
#       define XfOrM451_COUNT (0+XfOrM380_COUNT)
#       define SETUP_XfOrM451(x) SETUP_XfOrM380(x)

# 2284 "bc/src/file.c"
        if (next [0 ] == '/' ) {
#         define XfOrM453_COUNT (0+XfOrM451_COUNT)
#         define SETUP_XfOrM453(x) SETUP_XfOrM451(x)

# 2285 "bc/src/file.c"
          rel = 0 ; 
          if (i ) {
#           define XfOrM454_COUNT (0+XfOrM453_COUNT)
#           define SETUP_XfOrM454(x) SETUP_XfOrM453(x)
            FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: absolute path cannot be added to a path\n" "  absolute path: %q" , who , next ) )

            ; 
            RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
          }
        }

# 2294 "bc/src/file.c"
        else {
          rel = 1 ; 
        }
      }






      else {

        int is_drive ; 
#       define XfOrM414_COUNT (0+XfOrM380_COUNT)
#       define SETUP_XfOrM414(x) SETUP_XfOrM380(x)

# 2308 "bc/src/file.c"
        needs_extra_slash = 0 ; 

        if (((next [0 ] ) == '/' ) || ((next [0 ] ) == '\\' ) )  {
          int drive_end , plus_sep = 0 ; 
#         define XfOrM425_COUNT (0+XfOrM414_COUNT)
#         define SETUP_XfOrM425(x) SETUP_XfOrM414(x)

# 2312 "bc/src/file.c"
          rel = 0 ; 
          if (FUNCCALL(SETUP_XfOrM425(_), check_dos_slashslash_qm (next , len , & drive_end , ((void * ) 0 ) , & plus_sep ) )) {
#           define XfOrM426_COUNT (0+XfOrM425_COUNT)
#           define SETUP_XfOrM426(x) SETUP_XfOrM425(x)

# 2314 "bc/src/file.c"
            if (drive_end < 0 ) {
#             define XfOrM429_COUNT (0+XfOrM426_COUNT)
#             define SETUP_XfOrM429(x) SETUP_XfOrM426(x)

# 2316 "bc/src/file.c"
              rel = (next [6 ] == 'L' ) ; 
              is_drive = 0 ; 
              if (i ) {
                int dots_end , lit_start ; 
                int new_rel_base , need_simplify ; 
                int base_is_here = 0 ; 
#               define XfOrM431_COUNT (0+XfOrM429_COUNT)
#               define SETUP_XfOrM431(x) SETUP_XfOrM429(x)
                if (! FUNCCALL(SETUP_XfOrM431(_), check_dos_slashslash_qm (str , pos , & drive_end , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
                  Scheme_Object * simp ; 
                  BLOCK_SETUP((PUSH(simp, 0+XfOrM431_COUNT)));
#                 define XfOrM448_COUNT (1+XfOrM431_COUNT)
#                 define SETUP_XfOrM448(x) SETUP(XfOrM448_COUNT)
                  simp = NULLED_OUT ; 

# 2327 "bc/src/file.c"
                  str [pos ] = 0 ; 
                  simp = (__funcarg112 = FUNCCALL(SETUP_XfOrM448(_), scheme_make_sized_offset_kind_path (str , 0 , pos , 0 , scheme_windows_path_type ) )
                  , FUNCCALL_AGAIN(do_simplify_path (__funcarg112 , scheme_null , first_len , 0 , 0 , 0 , scheme_windows_path_type , 0 ) )) 

                  ; 
                  if (((simp ) ) == (scheme_false ) )  {

                    pos = 0 ; 
                    first_len = len ; 
                    if (next [len ] != '\\' )
                      first_len ++ ; 
                    no_sep = 1 ; 
                    new_rel_base = 0 ; 
                  }

# 2340 "bc/src/file.c"
                  else {
                    char * cleaned ; 
                    int clen ; 
                    int al = alloc ; 
#                   define XfOrM449_COUNT (0+XfOrM448_COUNT)
#                   define SETUP_XfOrM449(x) SETUP_XfOrM448(x)
                    cleaned = NULLED_OUT ; 

# 2345 "bc/src/file.c"
                    clen = (((Scheme_Simple_Object * ) (simp ) ) -> u . byte_str_val . tag_val ) ; 
                    cleaned = (((Scheme_Simple_Object * ) (simp ) ) -> u . byte_str_val . string_val ) ; 

                    str = FUNCCALL(SETUP_XfOrM449(_), convert_to_backslashbackslash_qm (cleaned , & clen , str , & al , len + 4 ) )
                    ; 

                    pos = clen ; 
                    alloc = al ; 

                    if ((pos > 5 ) 
                    && (str [4 ] == 'R' ) 
                    && (str [5 ] == 'E' ) )
                      new_rel_base = 1 ; 
                    else 
                    new_rel_base = 0 ; 

                    if (str [pos - 1 ] != '\\' )
                      str [pos ++ ] = '\\' ; 
                    no_sep = 1 ; 
                    first_len = pos ; 
                  }
                  need_simplify = 0 ; 
                }

# 2367 "bc/src/file.c"
                else {
                  new_rel_base = (drive_end < 0 ) ; 
                  need_simplify = 1 ; 
                }

                if (! pos ) {
                }
                else {
#                 define XfOrM432_COUNT (0+XfOrM431_COUNT)
#                 define SETUP_XfOrM432(x) SETUP_XfOrM431(x)

# 2375 "bc/src/file.c"
                  dots_end = FUNCCALL(SETUP_XfOrM432(_), get_slashslash_qm_dot_ups_end (next , len , & lit_start ) ); 

                  if (dots_end > 0 ) {
#                   define XfOrM445_COUNT (0+XfOrM432_COUNT)
#                   define SETUP_XfOrM445(x) SETUP_XfOrM432(x)

# 2379 "bc/src/file.c"
                    if (! no_sep )
                      str [pos ++ ] = '\\' ; 
                    (memcpy (str + pos , next + 8 , dots_end - 8 ) ) ; 
                    pos += dots_end - 8 ; 
                    str [pos ] = 0 ; 
                    need_simplify = 1 ; 
                  }

                  if (need_simplify ) {

                    Scheme_Object * simp ; 
                    BLOCK_SETUP((PUSH(simp, 0+XfOrM432_COUNT)));
#                   define XfOrM442_COUNT (1+XfOrM432_COUNT)
#                   define SETUP_XfOrM442(x) SETUP(XfOrM442_COUNT)
                    simp = NULLED_OUT ; 

# 2391 "bc/src/file.c"
                    simp = (__funcarg111 = FUNCCALL(SETUP_XfOrM442(_), scheme_make_sized_offset_kind_path (str , 0 , pos , 0 , scheme_windows_path_type ) )
                    , FUNCCALL_AGAIN(do_simplify_path (__funcarg111 , scheme_null , first_len , 0 , 1 , 0 , scheme_windows_path_type , 0 ) )) 

                    ; 
                    if (((simp ) ) == (scheme_false ) )  {
#                     define XfOrM444_COUNT (0+XfOrM442_COUNT)
#                     define SETUP_XfOrM444(x) SETUP_XfOrM442(x)
                      (memcpy (str , "\\\\?\\REL\\\\" , 9 ) ) ; 
                      pos = 9 ; 
                      no_sep = 1 ; 
                      base_is_here = 1 ; 
                    }

# 2402 "bc/src/file.c"
                    else {
#                     define XfOrM443_COUNT (0+XfOrM442_COUNT)
#                     define SETUP_XfOrM443(x) SETUP_XfOrM442(x)

# 2403 "bc/src/file.c"
                      pos = (((Scheme_Simple_Object * ) (simp ) ) -> u . byte_str_val . tag_val ) ; 
                      (memcpy (str , (((Scheme_Simple_Object * ) (simp ) ) -> u . byte_str_val . string_val ) , pos ) ) ; 
                      no_sep = (str [pos - 1 ] == '\\' ) ; 
                    }
                  }





                  if (new_rel_base && (lit_start < len ) ) {
                    int ls ; 
#                   define XfOrM437_COUNT (0+XfOrM432_COUNT)
#                   define SETUP_XfOrM437(x) SETUP_XfOrM432(x)

# 2415 "bc/src/file.c"
                    dots_end = FUNCCALL(SETUP_XfOrM437(_), get_slashslash_qm_dot_ups_end (str , pos , & ls ) ); 
                    if (dots_end > 0 ) {
                      if (ls == pos ) {
                        if (dots_end + 2 > pos ) {
                          if (dots_end + 1 > pos )
                            str [pos ++ ] = '\\' ; 
                          str [pos ++ ] = '\\' ; 
                          no_sep = 1 ; 
                        }
                      }
                    }

# 2425 "bc/src/file.c"
                    else if (ls == 8 ) {
#                     define XfOrM438_COUNT (0+XfOrM437_COUNT)
#                     define SETUP_XfOrM438(x) SETUP_XfOrM437(x)
                      (
# 2426 "bc/src/file.c"
                      memmove (str + 9 , str + 8 , pos - 8 ) ) ; 
                      str [8 ] = '\\' ; 
                      pos ++ ; 
                      no_sep = 1 ; 
                    }
                  }




                  next_off = lit_start ; 
                  len -= next_off ; 
                  if (! len ) {
                    if (base_is_here ) {


                      pos = 0 ; 
                      no_sep = 1 ; 
                      next = "." ; 
                      len = 1 ; 
                      next_off = 0 ; 
                    }

# 2447 "bc/src/file.c"
                    else 
                    no_sep = 1 ; 
                  }

# 2449 "bc/src/file.c"
                  else {


                    if (! new_rel_base && (pos == 4 ) ) {
                      str [pos ++ ] = '\\' ; 
                      str [pos ++ ] = '\\' ; 
                    }
                  }
                  first_len = pos + len ; 
                  if (next [next_off + len ] != '\\' )
                    first_len ++ ; 
                }
              }

# 2461 "bc/src/file.c"
              else {
                first_len = len ; 
              }
            }

# 2464 "bc/src/file.c"
            else {

              is_drive = (drive_end == len ) ; 
              needs_extra_slash = plus_sep ; 
              if (! i ) {
                first_len = len ; 
                if (next [first_len - 1 ] != '\\' )
                  first_len ++ ; 
              }
            }
          }

# 2474 "bc/src/file.c"
          else 
          is_drive = FUNCCALL(SETUP_XfOrM425(_), check_dos_slashslash_drive (next , 0 , len , ((void * ) 0 ) , 1 , 0 ) ); 
        }

# 2476 "bc/src/file.c"
        else if ((len >= 2 ) 
        && (((unsigned char ) next [0 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM414(_), __ctype_b_loc () )) [(int ) (((unsigned char ) next [0 ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
        && (next [1 ] == ':' ) ) {
          int j ; 
          rel = 0 ; 
          for (j = 2 ; j < len ; j ++ ) {
            if (! (((next [j ] ) == '/' ) || ((next [j ] ) == '\\' ) ) )
              break ; 
          }
          is_drive = (j >= len ) ; 
        }

# 2486 "bc/src/file.c"
        else {
          rel = 1 ; 
          is_drive = 0 ; 
        }

        if (! rel ) {
#         define XfOrM415_COUNT (0+XfOrM414_COUNT)
#         define SETUP_XfOrM415(x) SETUP_XfOrM414(x)

# 2492 "bc/src/file.c"
          if (i && (! first_was_drive || (i > 1 ) || is_drive ) ) {
#           define XfOrM419_COUNT (0+XfOrM415_COUNT)
#           define SETUP_XfOrM419(x) SETUP_XfOrM415(x)

# 2493 "bc/src/file.c"
            if (pos > 30 ) {
              str [27 ] = '.' ; 
              str [28 ] = '.' ; 
              str [29 ] = '.' ; 
              str [30 ] = 0 ; 
            }

# 2498 "bc/src/file.c"
            else 
            str [pos ] = 0 ; 
            FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: %s cannot be added to a base path\n" "  %s: %s\n" "  base path: %q" , who , is_drive ? "drive" : "absolute path" , is_drive ? "drive" : "absolute path" , next , str ) )






            ; 
            RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
          }

          if (i == 1 ) {

            while (len && (((next [next_off ] ) == '/' ) || ((next [next_off ] ) == '\\' ) ) ) {
              next_off ++ ; 
              len -- ; 
            }
          }
        }

        if (! i )
          first_was_drive = is_drive ; 
      }

      if (! i ) {
        no_sep = 1 ; 
      }

      if (kind == scheme_windows_path_type ) {
#       define XfOrM395_COUNT (0+XfOrM380_COUNT)
#       define SETUP_XfOrM395(x) SETUP_XfOrM380(x)

# 2529 "bc/src/file.c"
        if (i ) {
#         define XfOrM410_COUNT (0+XfOrM395_COUNT)
#         define SETUP_XfOrM410(x) SETUP_XfOrM395(x)

# 2530 "bc/src/file.c"
          pre_unc = FUNCCALL(SETUP_XfOrM410(_), check_dos_slashslash_drive (str , 0 , pos , ((void * ) 0 ) , 0 , 0 ) ); 
          if (! pre_unc ) {
            int de ; 
#           define XfOrM411_COUNT (0+XfOrM410_COUNT)
#           define SETUP_XfOrM411(x) SETUP_XfOrM410(x)

# 2533 "bc/src/file.c"
            if (FUNCCALL(SETUP_XfOrM411(_), check_dos_slashslash_qm (str , pos , & de , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
              if (de == 4 )
                pre_qm = 1 ; 
            }
          }

# 2537 "bc/src/file.c"
          else 
          pre_qm = 0 ; 
        }

# 2539 "bc/src/file.c"
        else {
          pre_unc = 1 ; 
          pre_qm = 0 ; 
        }

        if (no_final_simplify 
        && (len == 2 ) 
        && (next [next_off ] == '.' ) 
        && (next [next_off + 1 ] == '.' ) 
        && (first_len < pos + 2 ) ) {

          int de ; 
#         define XfOrM396_COUNT (0+XfOrM395_COUNT)
#         define SETUP_XfOrM396(x) SETUP_XfOrM395(x)

# 2551 "bc/src/file.c"
          if (FUNCCALL(SETUP_XfOrM396(_), check_dos_slashslash_qm (str , pos , & de , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
#           define XfOrM397_COUNT (0+XfOrM396_COUNT)
#           define SETUP_XfOrM397(x) SETUP_XfOrM396(x)

# 2552 "bc/src/file.c"
            if (de < 0 ) {




              int ls , dots_end ; 
#             define XfOrM398_COUNT (0+XfOrM397_COUNT)
#             define SETUP_XfOrM398(x) SETUP_XfOrM397(x)

# 2558 "bc/src/file.c"
              dots_end = FUNCCALL(SETUP_XfOrM398(_), get_slashslash_qm_dot_ups_end (str , pos , & ls ) ); 
              if (ls == pos ) {



                if (dots_end < ls )
                  pos = dots_end + 1 ; 
              }

# 2565 "bc/src/file.c"
              else {
                int q ; 
                for (q = pos ; q -- > ls ; ) {
                  if (str [q ] == '\\' ) {
                    break ; 
                  }
                }
                pos = q ; 
                first_len = pos ; 
                len = 0 ; 
                while (q && (str [q - 1 ] == '\\' ) ) {
                  q -- ; 
                }
                if (q == 7 ) {


                  if (i + 1 == argc ) {


                    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
                  }

                  str [0 ] = '.' ; 
                  pos = 1 ; 
                  no_sep = 1 ; 
                  first_len = 0 ; 
                }
              }
            }
          }
        }
      }

      if (! no_sep )
        str [pos ++ ] = ((kind == scheme_unix_path_type ) ? '/' : '\\' ) ; 
      (
      memcpy (str + pos , next + next_off , len ) ) ; 
      pos += len ; 

      if (kind == scheme_windows_path_type ) {
#       define XfOrM383_COUNT (0+XfOrM380_COUNT)
#       define SETUP_XfOrM383(x) SETUP_XfOrM380(x)

# 2605 "bc/src/file.c"
        if (! pre_unc 
        && FUNCCALL(SETUP_XfOrM383(_), check_dos_slashslash_drive (str , 0 , pos , ((void * ) 0 ) , 0 , 0 ) )) {
#         define XfOrM394_COUNT (0+XfOrM383_COUNT)
#         define SETUP_XfOrM394(x) SETUP_XfOrM383(x)
          (memmove (str , str + 1 , pos - 1 ) ) ; 
          -- pos ; 
        }
        if (pre_qm ) {
          int de ; 
#         define XfOrM386_COUNT (0+XfOrM383_COUNT)
#         define SETUP_XfOrM386(x) SETUP_XfOrM383(x)
          {
            int i ; 
            for (i = first_len ; i < pos ; i ++ ) {
              if (str [i ] == '/' ) {
                str [i ] = '\\' ; 
              }
            }
          }
          FUNCCALL(SETUP_XfOrM386(_), check_dos_slashslash_qm (str , pos , & de , ((void * ) 0 ) , ((void * ) 0 ) ) )

          ; 
          if (de != 4 ) {


            int amt = ((str [4 ] == '\\' ) ? 1 : 2 ) ; 
#           define XfOrM387_COUNT (0+XfOrM386_COUNT)
#           define SETUP_XfOrM387(x) SETUP_XfOrM386(x)

# 2632 "bc/src/file.c"
            if (pos + amt >= alloc ) {
              char * naya ; 
              int newalloc ; 
              BLOCK_SETUP((PUSH(naya, 0+XfOrM387_COUNT)));
#             define XfOrM388_COUNT (1+XfOrM387_COUNT)
#             define SETUP_XfOrM388(x) SETUP(XfOrM388_COUNT)
              naya = NULLED_OUT ; 

# 2636 "bc/src/file.c"
              newalloc = 2 * alloc ; 
              naya = (char * ) FUNCCALL(SETUP_XfOrM388(_), GC_malloc_atomic (newalloc ) ); 
              (memcpy (naya , str , pos ) ) ; 
              alloc = newalloc ; 

              str = naya ; 
            }
            (memmove (str + 4 + amt , str + 4 , pos - 4 ) ) ; 
            str [4 ] = '\\' ; 
            if (amt == 2 )
              str [5 ] = '\\' ; 
            pos += amt ; 
            first_len += amt ; 
          }
        }

        if (needs_extra_slash ) {
#         define XfOrM384_COUNT (0+XfOrM383_COUNT)
#         define SETUP_XfOrM384(x) SETUP_XfOrM383(x)

# 2653 "bc/src/file.c"
          if (needs_extra_slash >= pos )
            str [pos ++ ] = '\\' ; 
          else if (str [needs_extra_slash ] != '\\' ) {
#           define XfOrM385_COUNT (0+XfOrM384_COUNT)
#           define SETUP_XfOrM385(x) SETUP_XfOrM384(x)
            (
# 2656 "bc/src/file.c"
            memmove (str + needs_extra_slash + 1 , str + needs_extra_slash , pos - needs_extra_slash ) ) ; 
            str [needs_extra_slash ] = '\\' ; 
            pos ++ ; 
          }
        }
      }


      if (len ) {
        no_sep = ((kind == scheme_unix_path_type ) ? ((next [next_off + len - 1 ] ) == '/' ) : (((next [next_off + len - 1 ] ) == '/' ) || ((next [next_off + len - 1 ] ) == '\\' ) ) ) ; 
      }

# 2666 "bc/src/file.c"
      else {
        no_sep = 0 ; 
      }
    }

# 2669 "bc/src/file.c"
    else {
#     define XfOrM379_COUNT (0+XfOrM378_COUNT)
#     define SETUP_XfOrM379(x) SETUP_XfOrM378(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c path-for-some-system? path-string? 'up 'same)" , i + idelta , argc , argv ) )
# 2670 "bc/src/file.c"
      ; 
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }
  }

  str [pos ] = 0 ; 

  if (kind == scheme_windows_path_type ) {
#   define XfOrM289_COUNT (0+XfOrM288_COUNT)
#   define SETUP_XfOrM289(x) SETUP_XfOrM288(x)

# 2678 "bc/src/file.c"
    if (FUNCCALL(SETUP_XfOrM289(_), check_dos_slashslash_qm (str , pos , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )&& ! no_final_simplify ) {

      int p ; 
      Scheme_Object * simp ; 
      BLOCK_SETUP((PUSH(simp, 0+XfOrM289_COUNT)));
#     define XfOrM290_COUNT (1+XfOrM289_COUNT)
#     define SETUP_XfOrM290(x) SETUP(XfOrM290_COUNT)
      simp = NULLED_OUT ; 

# 2682 "bc/src/file.c"
      p = pos ; 
      str = FUNCCALL(SETUP_XfOrM290(_), do_normal_path_seps (str , & p , first_len , 1 , scheme_windows_path_type , ((void * ) 0 ) ) ); 
      str = FUNCCALL_AGAIN(remove_redundant_slashes (str , & p , first_len , ((void * ) 0 ) , scheme_windows_path_type ) ); 
      simp = (__funcarg107 = FUNCCALL(SETUP_XfOrM290(_), scheme_make_sized_offset_kind_path (str , 0 , p , 0 , scheme_windows_path_type ) ), FUNCCALL_AGAIN(do_simplify_path (__funcarg107 , scheme_null , first_len , 0 , 1 , 0 , scheme_windows_path_type , 0 ) )) 
      ; 
      if (((simp ) ) == (scheme_false ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (".\\" , 0 , 1 , 0 , scheme_windows_path_type ) )) RET_VALUE_EMPTY_END ; 
      else 
      RET_VALUE_START (simp ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (str , 0 , pos , alloc == 256 , kind ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2697 "bc/src/file.c"
Scheme_Object * scheme_build_path (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2699 "bc/src/file.c"
  int kind = scheme_unix_path_type , i ; 

  for (i = 0 ; i < argc ; i ++ ) {
    if ((((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) <= scheme_windows_path_type ) )  {
      kind = ((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ; 
      break ; 
    }

# 2705 "bc/src/file.c"
    else if ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
      kind = scheme_unix_path_type ; 
      break ; 
    }
  }

  return do_build_path (argc , argv , 0 , 0 , kind ) ; 
}

static Scheme_Object * build_path_kind (int argc , Scheme_Object * * argv ) 
{
  int kind ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM472_COUNT (1)
# define SETUP_XfOrM472(x) SETUP(XfOrM472_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2718 "bc/src/file.c"
  kind = FUNCCALL(SETUP_XfOrM472(_), extract_path_kind ("build-path/convention-type" , 0 , argc , argv ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_build_path (argc - 1 , argv , 1 , 0 , kind ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2722 "bc/src/file.c"
static Scheme_Object * path_to_directory_path (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * inpath ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(inpath, 0)));
# define XfOrM473_COUNT (1)
# define SETUP_XfOrM473(x) SETUP(XfOrM473_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inpath = NULLED_OUT ; 

# 2726 "bc/src/file.c"
  inpath = argv [0 ] ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) <= scheme_windows_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("path->directory-path" , "(or/c path-for-some-system? path-string?)" , 0 , argc , argv ) ); 

  inpath = (((((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) <= scheme_windows_path_type ) ) ? inpath : FUNCCALL(SETUP_XfOrM473(_), scheme_char_string_to_path (inpath ) )) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_path_to_directory_path (inpath ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2736 "bc/src/file.c"
static Scheme_Object * do_split_path (const char * path , int len , 
Scheme_Object * * base_out , char * * base_str_out , int * base_len_out , 
int * id_out , 
int * cleaned_slashes , int kind , 
int check_repeats ) 
{
  char * s ; 
  int p , last_was_sep = 0 , is_dir , no_up = 0 , not_same ; 
  Scheme_Object * file ; 
  int allow_double_before = 0 , drive_end , no_slash_sep = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(base_len_out, 0), PUSH(cleaned_slashes, 1), PUSH(file, 2), PUSH(id_out, 3), PUSH(base_str_out, 4), PUSH(base_out, 5), PUSH(s, 6)));
# define XfOrM474_COUNT (7)
# define SETUP_XfOrM474(x) SETUP(XfOrM474_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  file = NULLED_OUT ; 

# 2749 "bc/src/file.c"
  s = (char * ) path ; 

  if (kind == scheme_windows_path_type ) {
#   define XfOrM513_COUNT (0+XfOrM474_COUNT)
#   define SETUP_XfOrM513(x) SETUP_XfOrM474(x)

# 2752 "bc/src/file.c"
    if ((len > 2 ) && (((s [0 ] ) == '/' ) || ((s [0 ] ) == '\\' ) ) && (((s [1 ] ) == '/' ) || ((s [1 ] ) == '\\' ) ) ) {
#     define XfOrM515_COUNT (0+XfOrM513_COUNT)
#     define SETUP_XfOrM515(x) SETUP_XfOrM513(x)

# 2753 "bc/src/file.c"
      if (FUNCCALL(SETUP_XfOrM515(_), check_dos_slashslash_qm (s , len , & drive_end , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
#       define XfOrM517_COUNT (0+XfOrM515_COUNT)
#       define SETUP_XfOrM517(x) SETUP_XfOrM515(x)

# 2754 "bc/src/file.c"
        allow_double_before = drive_end ; 
        no_slash_sep = 1 ; 
        if (drive_end < 0 ) {

          int p , lit_start , dots_end ; 
#         define XfOrM520_COUNT (0+XfOrM517_COUNT)
#         define SETUP_XfOrM520(x) SETUP_XfOrM517(x)

# 2759 "bc/src/file.c"
          is_dir = 0 ; 
          if (s [len - 1 ] == '\\' ) {
            -- len ; 
            is_dir = 1 ; 
          }
          dots_end = FUNCCALL(SETUP_XfOrM520(_), get_slashslash_qm_dot_ups_end (s , len , & lit_start ) ); 
          if (lit_start < len ) {
#           define XfOrM527_COUNT (0+XfOrM520_COUNT)
#           define SETUP_XfOrM527(x) SETUP_XfOrM520(x)

# 2767 "bc/src/file.c"
            for (p = len ; -- p >= ((dots_end > 0 ) ? lit_start - 1 : lit_start ) ; ) {
#             define XfOrM535_COUNT (0+XfOrM527_COUNT)
#             define SETUP_XfOrM535(x) SETUP_XfOrM527(x)

# 2768 "bc/src/file.c"
              if (s [p ] == '\\' ) {
#               define XfOrM536_COUNT (0+XfOrM535_COUNT)
#               define SETUP_XfOrM536(x) SETUP_XfOrM535(x)

# 2770 "bc/src/file.c"
                {
                  int len2 , nsep ; 
                  char * s2 ; 
                  BLOCK_SETUP((PUSH(s2, 0+XfOrM536_COUNT)));
#                 define XfOrM537_COUNT (1+XfOrM536_COUNT)
#                 define SETUP_XfOrM537(x) SETUP(XfOrM537_COUNT)
                  s2 = NULLED_OUT ; 

# 2773 "bc/src/file.c"
                  len2 = len - p - 1 + 9 ; 
                  s2 = FUNCCALL(SETUP_XfOrM537(_), GC_malloc_atomic (len2 + 1 ) ); 
                  (memcpy (s2 , "\\\\?\\REL\\\\" , 9 ) ) ; 
                  (memcpy (s2 + 9 , s + p + 1 , len - p - 1 ) ) ; 
                  s2 [len2 ] = 0 ; 
                  if ((dots_end == p ) || (dots_end == p - 1 ) ) {

                    nsep = ((dots_end == p ) ? 0 : - 1 ) ; 
                  }

# 2781 "bc/src/file.c"
                  else {
                    if (s [6 ] == 'L' ) {

                      nsep = 1 ; 
                    }

# 2785 "bc/src/file.c"
                    else {

                      if (s [p - 1 ] == '\\' )
                        nsep = 0 ; 
                      else 
                      nsep = 1 ; 
                    }
                  }
                  file = FUNCCALL(SETUP_XfOrM537(_), scheme_make_sized_offset_kind_path (s2 , 0 , len2 , 0 , scheme_windows_path_type ) ); 
                  RET_VALUE_START ((* base_out = ((void * ) 0 ) , * base_str_out = s , * base_len_out = p + nsep , * id_out = is_dir , file ) ) RET_VALUE_END ; 
                }
              }
            }
          }

          if (dots_end > 0 ) {

            if (dots_end - 3 > 8 ) {
              RET_VALUE_START ((* base_out = ((void * ) 0 ) , * base_str_out = s , * base_len_out = dots_end - 3 , * id_out = 1 , up_symbol ) ) RET_VALUE_END ; 
            }

# 2804 "bc/src/file.c"
            else 
            RET_VALUE_START ((* base_out = relative_symbol , * base_str_out = ((void * ) 0 ) , * base_len_out = 0 , * id_out = 1 , up_symbol ) ) RET_VALUE_END ; 
          }

# 2806 "bc/src/file.c"
          else {
#           define XfOrM521_COUNT (0+XfOrM520_COUNT)
#           define SETUP_XfOrM521(x) SETUP_XfOrM520(x)

# 2808 "bc/src/file.c"
            if (s [6 ] == 'L' ) {
#             define XfOrM524_COUNT (0+XfOrM521_COUNT)
#             define SETUP_XfOrM524(x) SETUP_XfOrM521(x)

# 2810 "bc/src/file.c"
              RET_VALUE_START ((* base_out = relative_symbol , * base_str_out = ((void * ) 0 ) , * base_len_out = 0 , * id_out = is_dir , FUNCCALL(SETUP_XfOrM524(_), scheme_make_sized_offset_kind_path (s , 0 , len , 1 , scheme_windows_path_type ) )) ) RET_VALUE_END 


              ; 
            }

# 2814 "bc/src/file.c"
            else {

              char * naya ; 
              Scheme_Object * dir ; 
              BLOCK_SETUP((PUSH(naya, 0+XfOrM521_COUNT), PUSH(dir, 1+XfOrM521_COUNT)));
#             define XfOrM522_COUNT (2+XfOrM521_COUNT)
#             define SETUP_XfOrM522(x) SETUP(XfOrM522_COUNT)
              naya = NULLED_OUT ; 
              dir = NULLED_OUT ; 

# 2818 "bc/src/file.c"
              naya = (char * ) FUNCCALL(SETUP_XfOrM522(_), GC_malloc_atomic (len + 2 ) ); 
              (memcpy (naya , s , len + 2 ) ) ; 
              naya [6 ] = 'L' ; 
              if (naya [8 ] != '\\' ) {
#               define XfOrM523_COUNT (0+XfOrM522_COUNT)
#               define SETUP_XfOrM523(x) SETUP_XfOrM522(x)
                (memmove (naya + 9 , naya + 8 , len + 1 - 8 ) ) ; 
                naya [8 ] = '\\' ; 
                len ++ ; 
              }
              dir = FUNCCALL(SETUP_XfOrM522(_), scheme_make_sized_offset_kind_path ("\\" , 0 , 1 , 0 , scheme_windows_path_type ) )
              ; 
              RET_VALUE_START ((* base_out = dir , * base_str_out = ((void * ) 0 ) , * base_len_out = 0 , * id_out = is_dir , FUNCCALL(SETUP_XfOrM522(_), scheme_make_sized_offset_kind_path (naya , 0 , len , 0 , scheme_windows_path_type ) )) ) RET_VALUE_END 


              ; 
            }
          }
        }

# 2836 "bc/src/file.c"
        else {
          no_up = 1 ; 
          if ((drive_end < len ) && s [drive_end ] == '\\' ) {

            drive_end ++ ; 
          }
        }
      }

# 2843 "bc/src/file.c"
      else if (FUNCCALL(SETUP_XfOrM515(_), check_dos_slashslash_drive (s , 0 , len , & drive_end , 0 , 0 ) )) {
        allow_double_before = 1 ; 
        if ((drive_end < len ) && (((s [drive_end ] ) == '/' ) || ((s [drive_end ] ) == '\\' ) ) )
          drive_end ++ ; 
      }

# 2847 "bc/src/file.c"
      else 
      drive_end = 0 ; 
    }

# 2849 "bc/src/file.c"
    else if ((len > 1 ) && (((unsigned char ) s [0 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM513(_), __ctype_b_loc () )) [(int ) (((unsigned char ) s [0 ] ) ) ] & (unsigned short int ) _ISalpha ) ) && (s [1 ] == ':' ) ) {
      drive_end = 2 ; 
      if ((drive_end < len ) && (((s [drive_end ] ) == '/' ) || ((s [drive_end ] ) == '\\' ) ) )
        drive_end ++ ; 
    }

# 2853 "bc/src/file.c"
    else 
    drive_end = 0 ; 
  }

# 2855 "bc/src/file.c"
  else {
    drive_end = 0 ; 
  }


  if (check_repeats ) {
#   define XfOrM497_COUNT (0+XfOrM474_COUNT)
#   define SETUP_XfOrM497(x) SETUP_XfOrM474(x)

# 2861 "bc/src/file.c"
    for (p = len ; p -- ; ) {
#     define XfOrM505_COUNT (0+XfOrM497_COUNT)
#     define SETUP_XfOrM505(x) SETUP_XfOrM497(x)

# 2862 "bc/src/file.c"
      if (p > allow_double_before ) {
#       define XfOrM506_COUNT (0+XfOrM505_COUNT)
#       define SETUP_XfOrM506(x) SETUP_XfOrM505(x)

# 2863 "bc/src/file.c"
        if (((kind == scheme_unix_path_type ) ? ((s [p ] ) == '/' ) : (((s [p ] ) == '/' ) || ((s [p ] ) == '\\' ) ) ) && ((kind == scheme_unix_path_type ) ? ((s [p - 1 ] ) == '/' ) : (((s [p - 1 ] ) == '/' ) || ((s [p - 1 ] ) == '\\' ) ) ) ) {

          int q ; 
          char * old = s ; 
          BLOCK_SETUP((PUSH(old, 0+XfOrM506_COUNT)));
#         define XfOrM507_COUNT (1+XfOrM506_COUNT)
#         define SETUP_XfOrM507(x) SETUP(XfOrM507_COUNT)

# 2868 "bc/src/file.c"
          if (cleaned_slashes )
            * cleaned_slashes = 1 ; 

          s = (char * ) FUNCCALL(SETUP_XfOrM507(_), GC_malloc_atomic (len ) ); 
          -- len ; 

          for (p = 0 , q = 0 ; p < allow_double_before ; p ++ ) {
            s [q ++ ] = old [p ] ; 
          }

          for (; p < len ; p ++ ) {
            if (! ((kind == scheme_unix_path_type ) ? ((old [p ] ) == '/' ) : (((old [p ] ) == '/' ) || ((old [p ] ) == '\\' ) ) ) || ! ((kind == scheme_unix_path_type ) ? ((old [p + 1 ] ) == '/' ) : (((old [p + 1 ] ) == '/' ) || ((old [p + 1 ] ) == '\\' ) ) ) )
              s [q ++ ] = old [p ] ; 
          }
          s [q ++ ] = old [len ] ; 
          len = q ; 
          break ; 
        }
      }
    }
  }



  if ((kind == scheme_windows_path_type ) && (len <= drive_end ) )
    p = - 1 ; 
  else {
    for (p = len ; p -- ; ) {
      if (((kind == scheme_windows_path_type ) && no_slash_sep ) ? (s [p ] == '\\' ) : ((kind == scheme_unix_path_type ) ? ((s [p ] ) == '/' ) : (((s [p ] ) == '/' ) || ((s [p ] ) == '\\' ) ) ) )  {
        if (p != len - 1 )
          break ; 
        else 
        last_was_sep = 1 ; 
      }
      if (kind == scheme_windows_path_type ) {
        if (p < drive_end )
          break ; 
      }
    }
  }

  if (kind == scheme_unix_path_type ) {









    not_same = 0 ; 
  }

# 2920 "bc/src/file.c"
  else 
  not_same = 0 ; 

  if (p < 0 ) {
    Scheme_Object * dir ; 
    BLOCK_SETUP((PUSH(dir, 0+XfOrM474_COUNT)));
#   define XfOrM483_COUNT (1+XfOrM474_COUNT)
#   define SETUP_XfOrM483(x) SETUP(XfOrM483_COUNT)
    dir = NULLED_OUT ; 
    if (kind == scheme_unix_path_type ) {
#     define XfOrM488_COUNT (0+XfOrM483_COUNT)
#     define SETUP_XfOrM488(x) SETUP_XfOrM483(x)

# 2930 "bc/src/file.c"
      if (s [0 ] == '/' )
        RET_VALUE_START ((* base_out = scheme_false , * base_str_out = ((void * ) 0 ) , * base_len_out = 0 , * id_out = 1 , FUNCCALL(SETUP_XfOrM488(_), scheme_make_sized_offset_kind_path (s , 0 , len , 1 , kind ) )) ) RET_VALUE_END 
      ; 
    }









    else {
#     define XfOrM487_COUNT (0+XfOrM483_COUNT)
#     define SETUP_XfOrM487(x) SETUP_XfOrM483(x)

# 2944 "bc/src/file.c"
      if ((((s [0 ] ) == '/' ) || ((s [0 ] ) == '\\' ) ) || drive_end )
        RET_VALUE_START ((* base_out = scheme_false , * base_str_out = ((void * ) 0 ) , * base_len_out = 0 , * id_out = 1 , FUNCCALL(SETUP_XfOrM487(_), scheme_make_sized_offset_kind_path (s , 0 , len , 1 , kind ) )) ) RET_VALUE_END 
      ; 
    }

    dir = relative_symbol ; 


    if (! no_up && (s [0 ] == '.' ) && (s [1 ] == '.' ) 
    && (2 >= len || ((kind == scheme_unix_path_type ) ? ((s [2 ] ) == '/' ) : (((s [2 ] ) == '/' ) || ((s [2 ] ) == '\\' ) ) ) ) ) {
      file = up_symbol ; 
      is_dir = 1 ; 
    }

# 2956 "bc/src/file.c"
    else if (! no_up && ! not_same && (s [0 ] == '.' ) && (1 >= len || ((kind == scheme_unix_path_type ) ? ((s [1 ] ) == '/' ) : (((s [1 ] ) == '/' ) || ((s [1 ] ) == '\\' ) ) ) ) ) {
      file = same_symbol ; 
      is_dir = 1 ; 
    }

# 2959 "bc/src/file.c"
    else {
      int delta ; 
#     define XfOrM484_COUNT (0+XfOrM483_COUNT)
#     define SETUP_XfOrM484(x) SETUP_XfOrM483(x)

# 2961 "bc/src/file.c"
      is_dir = last_was_sep ; 
      delta = 0 ; 
      file = FUNCCALL(SETUP_XfOrM484(_), make_protected_sized_offset_path (no_up || is_dir , s , 0 , len - last_was_sep + delta , 1 , 0 , kind ) )

      ; 
    }

    RET_VALUE_START ((* base_out = dir , * base_str_out = ((void * ) 0 ) , * base_len_out = 0 , * id_out = is_dir , file ) ) RET_VALUE_END ; 
  }


  if (! no_up && (s [p + 1 ] == '.' ) && (s [p + 2 ] == '.' ) 
  && (p + 3 >= len || ((kind == scheme_unix_path_type ) ? ((s [p + 3 ] ) == '/' ) : (((s [p + 3 ] ) == '/' ) || ((s [p + 3 ] ) == '\\' ) ) ) ) ) {
    file = up_symbol ; 
    is_dir = 1 ; 
  }

# 2976 "bc/src/file.c"
  else if (! no_up && (s [p + 1 ] == '.' ) && (p + 2 >= len || ((kind == scheme_unix_path_type ) ? ((s [p + 2 ] ) == '/' ) : (((s [p + 2 ] ) == '/' ) || ((s [p + 2 ] ) == '\\' ) ) ) ) ) {
    file = same_symbol ; 
    is_dir = 1 ; 
  }

# 2979 "bc/src/file.c"
  else {
    int protected ; 
#   define XfOrM478_COUNT (0+XfOrM474_COUNT)
#   define SETUP_XfOrM478(x) SETUP_XfOrM474(x)

# 2981 "bc/src/file.c"
    if (kind == scheme_windows_path_type ) {
      protected = no_up || last_was_sep ; 
    }

# 2983 "bc/src/file.c"
    else {
      protected = 1 ; 
    }
    file = FUNCCALL(SETUP_XfOrM478(_), make_protected_sized_offset_path (protected , s , p + 1 , len - p - last_was_sep - 1 , 1 , 0 , kind ) )



    ; 
    is_dir = last_was_sep ; 
  }


  if (p > 0 ) {
    Scheme_Object * ss ; 
    int new_len ; 
    BLOCK_SETUP((PUSH(ss, 0+XfOrM474_COUNT)));
#   define XfOrM476_COUNT (1+XfOrM474_COUNT)
#   define SETUP_XfOrM476(x) SETUP(XfOrM476_COUNT)
    ss = NULLED_OUT ; 

# 2998 "bc/src/file.c"
    ss = FUNCCALL(SETUP_XfOrM476(_), make_exposed_sized_offset_path (& new_len , no_up , s , 0 , p + 1 , 1 , kind ) ); 
    if (ss ) {
      s = (((Scheme_Simple_Object * ) (ss ) ) -> u . byte_str_val . string_val ) ; 
      new_len = (((Scheme_Simple_Object * ) (ss ) ) -> u . byte_str_val . tag_val ) ; 
    }
    RET_VALUE_START ((* base_out = ((void * ) 0 ) , * base_str_out = s , * base_len_out = new_len , * id_out = is_dir , file ) ) RET_VALUE_END ; 
  }


  {
    Scheme_Object * ss ; 
    BLOCK_SETUP((PUSH(ss, 0+XfOrM474_COUNT)));
#   define XfOrM475_COUNT (1+XfOrM474_COUNT)
#   define SETUP_XfOrM475(x) SETUP(XfOrM475_COUNT)
    ss = NULLED_OUT ; 

# 3009 "bc/src/file.c"
    if (s [0 ] == '/' )
      ss = FUNCCALL(SETUP_XfOrM475(_), scheme_make_sized_offset_kind_path ("/" , 0 , 1 , 0 , kind ) ); 
    else 
    ss = FUNCCALL(SETUP_XfOrM475(_), scheme_make_sized_offset_kind_path (s , 0 , 1 , 1 , kind ) ); 
    RET_VALUE_START ((* base_out = ss , * base_str_out = ((void * ) 0 ) , * base_len_out = 0 , * id_out = is_dir , file ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3017 "bc/src/file.c"
static Scheme_Object * do_split_path_once (const char * path , int len , 
Scheme_Object * * base_out , 
int * id_out , 
int * cleaned_slashes , int kind ) 
{
  Scheme_Object * name , * base ; 
  char * base_str ; 
  int base_len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(base_out, 0), PUSH(base_str, 1), PUSH(name, 2), PUSH(base, 3)));
# define XfOrM543_COUNT (4)
# define SETUP_XfOrM543(x) SETUP(XfOrM543_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 
  base = NULLED_OUT ; 
  base_str = NULLED_OUT ; 

# 3026 "bc/src/file.c"
  name = FUNCCALL(SETUP_XfOrM543(_), do_split_path (path , len , base_out , & base_str , & base_len , id_out , cleaned_slashes , kind , 1 ) ); 

  if (! * base_out ) {
#   define XfOrM544_COUNT (0+XfOrM543_COUNT)
#   define SETUP_XfOrM544(x) SETUP_XfOrM543(x)

# 3029 "bc/src/file.c"
    base = FUNCCALL(SETUP_XfOrM544(_), scheme_make_sized_offset_kind_path (base_str , 0 , base_len , 1 , kind ) ); 
    * base_out = base ; 
  }

  RET_VALUE_START (name ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3036 "bc/src/file.c"
Scheme_Object * scheme_split_path (const char * path , int len , Scheme_Object * * base_out , int * id_out , int kind ) 
{
  /* No conversion */

# 3038 "bc/src/file.c"
  return do_split_path_once (path , len , base_out , id_out , ((void * ) 0 ) , kind ) ; 
}

static Scheme_Object * _split_path (const char * who , int argc , Scheme_Object * * argv , int multi ) 
{
  char * s ; 
  int is_dir , len ; 
  Scheme_Object * three [3 ] , * inpath ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(inpath, 0), PUSH(s, 1), PUSHARRAY(three, 3, 2), PUSH(who, 5)));
# define XfOrM546_COUNT (6)
# define SETUP_XfOrM546(x) SETUP(XfOrM546_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  three[0] = NULLED_OUT ; 
  three[1] = NULLED_OUT ; 
  three[2] = NULLED_OUT ; 
  inpath = NULLED_OUT ; 

# 3047 "bc/src/file.c"
  inpath = argv [0 ] ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) <= scheme_windows_path_type ) ) ) )
    FUNCCALL(SETUP_XfOrM546(_), scheme_wrong_contract (who , "(or/c path-for-some-system? path-string?)" , 0 , argc , argv ) ); 

  inpath = (((((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) <= scheme_windows_path_type ) ) ? inpath : FUNCCALL(SETUP_XfOrM546(_), scheme_char_string_to_path (inpath ) )) ; 

  s = (((Scheme_Simple_Object * ) (inpath ) ) -> u . byte_str_val . string_val ) ; 
  len = (((Scheme_Simple_Object * ) (inpath ) ) -> u . byte_str_val . tag_val ) ; 

  if (! len ) {
#   define XfOrM559_COUNT (0+XfOrM546_COUNT)
#   define SETUP_XfOrM559(x) SETUP_XfOrM546(x)
    FUNCCALL(SETUP_XfOrM559(_), scheme_contract_error (who , "path is an empty string" , ((void * ) 0 ) ) ); 
  }

  if (FUNCCALL(SETUP_XfOrM546(_), has_null (s , len ) ))
    FUNCCALL(SETUP_XfOrM546(_), raise_null_error (who , inpath , "" ) ); 

  if (multi ) {
    Scheme_Object * l = scheme_null , * name , * base ; 
    char * next_s ; 
    int next_len ; 
    int kind = ((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) , check = 1 ; 
    BLOCK_SETUP((PUSH(name, 0+XfOrM546_COUNT), PUSH(next_s, 1+XfOrM546_COUNT), PUSH(l, 2+XfOrM546_COUNT), PUSH(base, 3+XfOrM546_COUNT)));
#   define XfOrM548_COUNT (4+XfOrM546_COUNT)
#   define SETUP_XfOrM548(x) SETUP(XfOrM548_COUNT)
    name = NULLED_OUT ; 
    base = NULLED_OUT ; 
    next_s = NULLED_OUT ; 

# 3072 "bc/src/file.c"
    while (1 ) {
#     define XfOrM554_COUNT (0+XfOrM548_COUNT)
#     define SETUP_XfOrM554(x) SETUP_XfOrM548(x)

# 3073 "bc/src/file.c"
      name = FUNCCALL(SETUP_XfOrM554(_), do_split_path (s , len , & base , & next_s , & next_len , & is_dir , ((void * ) 0 ) , kind , check ) ); 
      l = FUNCCALL(SETUP_XfOrM554(_), scheme_make_pair (name , l ) ); 
      if (base ) {
#       define XfOrM558_COUNT (0+XfOrM554_COUNT)
#       define SETUP_XfOrM558(x) SETUP_XfOrM554(x)

# 3076 "bc/src/file.c"
        if ((((base ) ) == (scheme_false ) ) || ((base ) == (relative_symbol ) ) )

# 3076 "bc/src/file.c"
        RET_VALUE_START (l ) RET_VALUE_END ; 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM558(_), scheme_make_pair (base , l ) )) RET_VALUE_END ; 
      }

# 3078 "bc/src/file.c"
      else {
        s = next_s ; 
        len = next_len ; 
      }
      check = 0 ; 
      {
#       define XfOrM555_COUNT (0+XfOrM554_COUNT)
#       define SETUP_XfOrM555(x) SETUP_XfOrM554(x)

# 3083 "bc/src/file.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM556_COUNT (0+XfOrM555_COUNT)
#         define SETUP_XfOrM556(x) SETUP_XfOrM555(x)
          FUNCCALL(SETUP_XfOrM556(_), scheme_out_of_fuel () )
# 3083 "bc/src/file.c"
          ; 
        }
      }

# 3083 "bc/src/file.c"
      ; 
    }
  }

# 3085 "bc/src/file.c"
  else {
#   define XfOrM547_COUNT (0+XfOrM546_COUNT)
#   define SETUP_XfOrM547(x) SETUP_XfOrM546(x)

# 3086 "bc/src/file.c"
    three [1 ] = FUNCCALL(SETUP_XfOrM547(_), scheme_split_path (s , len , & three [0 ] , & is_dir , ((((intptr_t ) (inpath ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inpath ) ) -> type ) ) ); 

    three [2 ] = is_dir ? scheme_true : scheme_false ; 

    RET_VALUE_START (FUNCCALL(SETUP_XfOrM547(_), scheme_values (3 , three ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3094 "bc/src/file.c"
static Scheme_Object * split_path (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3096 "bc/src/file.c"
  return _split_path ("split-path" , argc , argv , 0 ) ; 
}

static Scheme_Object * explode_path (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3101 "bc/src/file.c"
  return _split_path ("explode-path" , argc , argv , 1 ) ; 
}

int scheme_is_relative_path (const char * s , intptr_t len , int kind ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM562_COUNT (1)
# define SETUP_XfOrM562(x) SETUP(XfOrM562_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3106 "bc/src/file.c"
  if (! len )
    RET_VALUE_START (0 ) RET_VALUE_END ; 

  if (kind == scheme_unix_path_type ) {
    RET_VALUE_START (! ((s [0 ] == '/' ) || 0 ) ) RET_VALUE_END ; 
  }

# 3111 "bc/src/file.c"
  else {
    int dlen ; 
#   define XfOrM563_COUNT (0+XfOrM562_COUNT)
#   define SETUP_XfOrM563(x) SETUP_XfOrM562(x)

# 3113 "bc/src/file.c"
    if (FUNCCALL(SETUP_XfOrM563(_), check_dos_slashslash_qm (s , len , & dlen , ((void * ) 0 ) , ((void * ) 0 ) ) )
    && (dlen < 0 ) ) {
      if (dlen == - 1 )
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

    if ((((s [0 ] ) == '/' ) || ((s [0 ] ) == '\\' ) ) 
    || ((len >= 2 ) 
    && (((unsigned char ) s [0 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM563(_), __ctype_b_loc () )) [(int ) (((unsigned char ) s [0 ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
    && (s [1 ] == ':' ) ) )
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3131 "bc/src/file.c"
int scheme_is_complete_path (const char * s , intptr_t len , int kind ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM566_COUNT (1)
# define SETUP_XfOrM566(x) SETUP(XfOrM566_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3133 "bc/src/file.c"
  if (! len )
    RET_VALUE_START (0 ) RET_VALUE_END ; 

  if (! kind )
    kind = scheme_unix_path_type ; 

  if (! FUNCCALL(SETUP_XfOrM566(_), scheme_is_relative_path (s , len , kind ) )) {
#   define XfOrM567_COUNT (0+XfOrM566_COUNT)
#   define SETUP_XfOrM567(x) SETUP_XfOrM566(x)

# 3140 "bc/src/file.c"
    if (kind == scheme_windows_path_type ) {
#     define XfOrM568_COUNT (0+XfOrM567_COUNT)
#     define SETUP_XfOrM568(x) SETUP_XfOrM567(x)

# 3141 "bc/src/file.c"
      if ((((s [0 ] ) == '/' ) || ((s [0 ] ) == '\\' ) ) && (((s [1 ] ) == '/' ) || ((s [1 ] ) == '\\' ) ) ) {
        int dlen ; 
#       define XfOrM570_COUNT (0+XfOrM568_COUNT)
#       define SETUP_XfOrM570(x) SETUP_XfOrM568(x)

# 3143 "bc/src/file.c"
        if (FUNCCALL(SETUP_XfOrM570(_), check_dos_slashslash_qm (s , len , & dlen , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
          RET_VALUE_START ((dlen >= 0 ) ) RET_VALUE_END ; 
        }

# 3145 "bc/src/file.c"
        else if (FUNCCALL(SETUP_XfOrM570(_), check_dos_slashslash_drive (s , 0 , len , ((void * ) 0 ) , 0 , 0 ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        else 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 3149 "bc/src/file.c"
      else if ((len >= 2 ) 
      && (((unsigned char ) s [0 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM568(_), __ctype_b_loc () )) [(int ) (((unsigned char ) s [0 ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
      && (s [1 ] == ':' ) ) {
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }

# 3153 "bc/src/file.c"
      else 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 3155 "bc/src/file.c"
    else 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

# 3157 "bc/src/file.c"
  else 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3161 "bc/src/file.c"
static char * do_path_to_complete_path (char * filename , intptr_t ilen , const char * wrt , intptr_t wlen , int kind ) 
{
  Scheme_Config * __funcarg114 = NULLED_OUT ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(wrt, 0), PUSH(filename, 1)));
# define XfOrM572_COUNT (2)
# define SETUP_XfOrM572(x) SETUP(XfOrM572_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3163 "bc/src/file.c"
  if (! FUNCCALL(SETUP_XfOrM572(_), scheme_is_complete_path (filename , ilen , kind ) )) {
    char * naya ; 
    int skip_sep = 0 ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM572_COUNT)));
#   define XfOrM573_COUNT (1+XfOrM572_COUNT)
#   define SETUP_XfOrM573(x) SETUP(XfOrM573_COUNT)
    naya = NULLED_OUT ; 

# 3167 "bc/src/file.c"
    if (! wrt ) {
      Scheme_Object * wd ; 
      BLOCK_SETUP((PUSH(wd, 0+XfOrM573_COUNT)));
#     define XfOrM579_COUNT (1+XfOrM573_COUNT)
#     define SETUP_XfOrM579(x) SETUP(XfOrM579_COUNT)
      wd = NULLED_OUT ; 

# 3169 "bc/src/file.c"
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
#       define XfOrM581_COUNT (0+XfOrM579_COUNT)
#       define SETUP_XfOrM581(x) SETUP_XfOrM579(x)

# 3170 "bc/src/file.c"
        wd = (__funcarg114 = FUNCCALL(SETUP_XfOrM581(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg114 , MZCONFIG_CURRENT_DIRECTORY ) )) ; 
        wrt = (((Scheme_Simple_Object * ) (wd ) ) -> u . byte_str_val . string_val ) ; 
        wlen = (((Scheme_Simple_Object * ) (wd ) ) -> u . byte_str_val . tag_val ) ; 
        FUNCCALL(SETUP_XfOrM581(_), scheme_security_check_file ("path->complete-path" , ((void * ) 0 ) , 0x10 ) ); 
      }

# 3174 "bc/src/file.c"
      else {
        int actlen ; 
#       define XfOrM580_COUNT (0+XfOrM579_COUNT)
#       define SETUP_XfOrM580(x) SETUP_XfOrM579(x)

# 3176 "bc/src/file.c"
        wrt = FUNCCALL(SETUP_XfOrM580(_), scheme_os_getcwd (((void * ) 0 ) , 0 , & actlen , 1 ) ); 
        wlen = actlen - 1 ; 
      }
    }

    if (kind == scheme_windows_path_type ) {
#     define XfOrM575_COUNT (0+XfOrM573_COUNT)
#     define SETUP_XfOrM575(x) SETUP_XfOrM573(x)

# 3182 "bc/src/file.c"
      if (! FUNCCALL(SETUP_XfOrM575(_), scheme_is_relative_path (filename , ilen , kind ) )) {
#       define XfOrM577_COUNT (0+XfOrM575_COUNT)
#       define SETUP_XfOrM577(x) SETUP_XfOrM575(x)

# 3184 "bc/src/file.c"
        wrt = FUNCCALL(SETUP_XfOrM577(_), get_drive_part (wrt , wlen ) ); 
        wlen = strlen (wrt ) ; 

        if ((((wrt [wlen - 1 ] ) == '/' ) || ((wrt [wlen - 1 ] ) == '\\' ) ) 
        && ! FUNCCALL(SETUP_XfOrM577(_), check_dos_slashslash_qm (wrt , wlen , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
          wlen -- ; 
        }
        skip_sep = 1 ; 
      }

      if (FUNCCALL(SETUP_XfOrM575(_), check_dos_slashslash_qm (wrt , wlen , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )
      || FUNCCALL(SETUP_XfOrM575(_), check_dos_slashslash_qm (filename , ilen , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) {

        Scheme_Object * a [2 ] , * p ; 
        BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM575_COUNT), PUSH(p, 3+XfOrM575_COUNT)));
#       define XfOrM576_COUNT (4+XfOrM575_COUNT)
#       define SETUP_XfOrM576(x) SETUP(XfOrM576_COUNT)
        a[0] = NULLED_OUT ; 
        a[1] = NULLED_OUT ; 
        p = NULLED_OUT ; 

# 3198 "bc/src/file.c"
        p = FUNCCALL(SETUP_XfOrM576(_), scheme_make_sized_offset_kind_path ((char * ) wrt , 0 , wlen , 1 , scheme_windows_path_type ) ); 
        a [0 ] = p ; 
        p = FUNCCALL(SETUP_XfOrM576(_), scheme_make_sized_offset_kind_path (filename , 0 , ilen , 1 , scheme_windows_path_type ) ); 
        a [1 ] = p ; 
        p = FUNCCALL(SETUP_XfOrM576(_), do_build_path (2 , a , 0 , 0 , scheme_windows_path_type ) ); 
        RET_VALUE_START ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) ) RET_VALUE_END ; 
      }
    }

    naya = (char * ) FUNCCALL(SETUP_XfOrM573(_), GC_malloc_atomic (ilen + wlen + 2 ) ); 
    (memcpy (naya , wrt , wlen ) ) ; 
    if (! skip_sep )
      if (! ((kind == scheme_unix_path_type ) ? ((naya [wlen - 1 ] ) == '/' ) : (((naya [wlen - 1 ] ) == '/' ) || ((naya [wlen - 1 ] ) == '\\' ) ) ) )
      naya [wlen ++ ] = ((kind == scheme_unix_path_type ) ? '/' : '\\' ) ; 
    if (kind == scheme_windows_path_type ) {
      int w = wlen ; 
#     define XfOrM574_COUNT (0+XfOrM573_COUNT)
#     define SETUP_XfOrM574(x) SETUP_XfOrM573(x)
      FUNCCALL(SETUP_XfOrM574(_), strip_trailing_spaces (naya , & w , 0 , 1 ) )
# 3214 "bc/src/file.c"
      ; 
      wlen = w ; 
    }
    (memcpy (naya + wlen , filename , ilen ) ) ; 
    naya [wlen + ilen ] = 0 ; 

    RET_VALUE_START (naya ) RET_VALUE_END ; 
  }

  RET_VALUE_START (filename ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3226 "bc/src/file.c"
static Scheme_Object * path_to_complete_path (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * p , * wrt ; 
  char * s ; 
  int len , kind ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(wrt, 1), PUSH(argv, 2), PUSH(p, 3)));
# define XfOrM582_COUNT (4)
# define SETUP_XfOrM582(x) SETUP(XfOrM582_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 
  wrt = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 3232 "bc/src/file.c"
  p = argv [0 ] ; 
  if (! (((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) <= scheme_windows_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("path->complete-path" , "(or/c path-for-some-system? path-string?)" , 0 , argc , argv ) ); 
  p = (((((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) <= scheme_windows_path_type ) ) ? p : FUNCCALL(SETUP_XfOrM582(_), scheme_char_string_to_path (p ) )) ; 
  if (argc > 1 ) {
#   define XfOrM589_COUNT (0+XfOrM582_COUNT)
#   define SETUP_XfOrM589(x) SETUP_XfOrM582(x)

# 3237 "bc/src/file.c"
    wrt = argv [1 ] ; 
    if (! (((Scheme_Type ) (((((intptr_t ) (wrt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (wrt ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (wrt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (wrt ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (wrt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (wrt ) ) -> type ) <= scheme_windows_path_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("path->complete-path" , "(or/c path-for-some-system? path-string?)" , 1 , argc , argv ) ); 
    wrt = (((((((intptr_t ) (wrt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (wrt ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (wrt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (wrt ) ) -> type ) <= scheme_windows_path_type ) ) ? wrt : FUNCCALL(SETUP_XfOrM589(_), scheme_char_string_to_path (wrt ) )) ; 
  }

# 3241 "bc/src/file.c"
  else 
  wrt = ((void * ) 0 ) ; 

  kind = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  if (wrt ) {
#   define XfOrM587_COUNT (0+XfOrM582_COUNT)
#   define SETUP_XfOrM587(x) SETUP_XfOrM582(x)

# 3246 "bc/src/file.c"
    if (((((intptr_t ) (wrt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (wrt ) ) -> type ) != kind ) {
#     define XfOrM588_COUNT (0+XfOrM587_COUNT)
#     define SETUP_XfOrM588(x) SETUP_XfOrM587(x)
      FUNCCALL_EMPTY(scheme_contract_error ("path->complete-path" , "convention of first path incompatible with convention of second path" , "first path" , 1 , argv [0 ] , "second path" , 1 , argv [1 ] , ((void * ) 0 ) ) )

      ; 
    }
  }

# 3253 "bc/src/file.c"
  else if (kind != scheme_unix_path_type ) {
#   define XfOrM586_COUNT (0+XfOrM582_COUNT)
#   define SETUP_XfOrM586(x) SETUP_XfOrM582(x)
    FUNCCALL_EMPTY(scheme_contract_error ("path->complete-path" , "no second path supplied, and given path is not for the current platform" , "given path" , 1 , argv [0 ] , ((void * ) 0 ) ) )
    ; 
  }

  s = (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) ; 
  len = (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) ; 

  if (FUNCCALL(SETUP_XfOrM582(_), has_null (s , len ) ))
    FUNCCALL(SETUP_XfOrM582(_), raise_null_error ("path->complete-path" , p , "" ) ); 

  if (wrt ) {
    char * ws ; 
    int wlen ; 
    BLOCK_SETUP((PUSH(ws, 0+XfOrM582_COUNT)));
#   define XfOrM584_COUNT (1+XfOrM582_COUNT)
#   define SETUP_XfOrM584(x) SETUP(XfOrM584_COUNT)
    ws = NULLED_OUT ; 

# 3270 "bc/src/file.c"
    ws = (((Scheme_Simple_Object * ) (wrt ) ) -> u . byte_str_val . string_val ) ; 
    wlen = (((Scheme_Simple_Object * ) (wrt ) ) -> u . byte_str_val . tag_val ) ; 

    if (FUNCCALL(SETUP_XfOrM584(_), has_null (ws , wlen ) ))
      FUNCCALL(SETUP_XfOrM584(_), raise_null_error ("path->complete-path" , p , "" ) ); 

    if (! FUNCCALL(SETUP_XfOrM584(_), scheme_is_complete_path (ws , wlen , kind ) ))
      FUNCCALL_EMPTY(scheme_contract_error ("path->complete-path" , "second argument is not a complete path" , "first argument" , 1 , p , "second argument" , 1 , wrt , ((void * ) 0 ) ) )


    ; 

    if (! FUNCCALL(SETUP_XfOrM584(_), scheme_is_complete_path (s , len , kind ) )) {
#     define XfOrM585_COUNT (0+XfOrM584_COUNT)
#     define SETUP_XfOrM585(x) SETUP_XfOrM584(x)

# 3283 "bc/src/file.c"
      s = FUNCCALL(SETUP_XfOrM585(_), do_path_to_complete_path (s , len , ws , wlen , kind ) ); 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (s , 0 , strlen (s ) , 0 , kind ) )) RET_VALUE_EMPTY_END ; 
    }
  }

# 3286 "bc/src/file.c"
  else if (! FUNCCALL(SETUP_XfOrM582(_), scheme_is_complete_path (s , len , kind ) )) {
#   define XfOrM583_COUNT (0+XfOrM582_COUNT)
#   define SETUP_XfOrM583(x) SETUP_XfOrM582(x)

# 3287 "bc/src/file.c"
    s = FUNCCALL(SETUP_XfOrM583(_), do_path_to_complete_path (s , len , ((void * ) 0 ) , 0 , kind ) ); 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (s , 0 , strlen (s ) , 0 , kind ) )) RET_VALUE_EMPTY_END ; 
  }

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3295 "bc/src/file.c"
Scheme_Object * scheme_path_to_complete_path (Scheme_Object * path , Scheme_Object * relto_path ) 
{
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM590_COUNT (3)
# define SETUP_XfOrM590(x) SETUP(XfOrM590_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 3298 "bc/src/file.c"
  a [0 ] = path ; 
  a [1 ] = relto_path ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM590(_), path_to_complete_path (relto_path ? 2 : 1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3303 "bc/src/file.c"
static char * filename_for_error (Scheme_Object * p ) 
{
  /* No conversion */

# 3305 "bc/src/file.c"
  return do_expand_filename (p , ((void * ) 0 ) , 0 , 
  ((void * ) 0 ) , 
  ((void * ) 0 ) , 
  1 , 1 , 
  0 , scheme_unix_path_type , 
  0 ) ; 
}

int scheme_can_enable_write_permission (void ) 
{
  /* No conversion */



  return 0 ; 
}

static Scheme_Object * delete_file (int argc , Scheme_Object * * argv ) 
{
  char * fn ; 

# 3313 "bc/src/file.c"
  int __funcarg116 ; 

# 3303 "bc/src/file.c"
  char * __funcarg115 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(fn, 0), PUSH(argv, 1)));
# define XfOrM593_COUNT (2)
# define SETUP_XfOrM593(x) SETUP(XfOrM593_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  fn = NULLED_OUT ; 

# 3326 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("delete-file" , "path-string?" , 0 , argc , argv ) ); 

  fn = FUNCCALL(SETUP_XfOrM593(_), scheme_expand_string_filename (argv [0 ] , "delete-file" , ((void * ) 0 ) , 0x8 ) )


  ; 

  if (! (__funcarg116 = FUNCCALL(SETUP_XfOrM593(_), scheme_can_enable_write_permission () ), (rktio_delete_file (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fn , __funcarg116 ) ) ) ) {
#   define XfOrM594_COUNT (0+XfOrM593_COUNT)
#   define SETUP_XfOrM594(x) SETUP_XfOrM593(x)
    (__funcarg115 = FUNCCALL_EMPTY(filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "delete-file: cannot delete file\n" "  path: %q\n" "  system error: %R" , __funcarg115 ) )) 

    ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3345 "bc/src/file.c"
static Scheme_Object * rename_file (int argc , Scheme_Object * * argv ) 
{
  int exists_ok = 0 ; 
  char * src , * dest ; 
  Scheme_Object * bss , * bsd ; 

# 3303 "bc/src/file.c"
  char * __funcarg120 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg119 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg118 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg117 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(dest, 0), PUSH(bsd, 1), PUSH(__funcarg117, 2), PUSH(__funcarg119, 3), PUSH(src, 4), PUSH(argv, 5)));
# define XfOrM595_COUNT (6)
# define SETUP_XfOrM595(x) SETUP(XfOrM595_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  src = NULLED_OUT ; 
  dest = NULLED_OUT ; 
  bss = NULLED_OUT ; 
  bsd = NULLED_OUT ; 

# 3351 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("rename-file-or-directory" , "path-string?" , 0 , argc , argv ) ); 
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("rename-file-or-directory" , "path-string?" , 1 , argc , argv ) ); 
  if (argc > 2 )
    exists_ok = (! (((argv [2 ] ) ) == (scheme_false ) ) ) ; 

  bss = argv [0 ] ; 
  bsd = argv [1 ] ; 

  src = FUNCCALL(SETUP_XfOrM595(_), scheme_expand_string_filename (bss , "rename-file-or-directory" , ((void * ) 0 ) , 0x1 ) )


  ; 
  dest = FUNCCALL_AGAIN(scheme_expand_string_filename (bsd , "rename-file-or-directory" , ((void * ) 0 ) , 0x2 ) )


  ; 

  if (! (rktio_rename_file (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , dest , src , exists_ok ) ) ) {
#   define XfOrM596_COUNT (0+XfOrM595_COUNT)
#   define SETUP_XfOrM596(x) SETUP_XfOrM595(x)

# 3371 "bc/src/file.c"
    if (FUNCCALL(SETUP_XfOrM596(_), scheme_last_error_is_racket (RKTIO_ERROR_EXISTS ) )) {
#     define XfOrM598_COUNT (0+XfOrM596_COUNT)
#     define SETUP_XfOrM598(x) SETUP_XfOrM596(x)
      (__funcarg119 = FUNCCALL(SETUP_XfOrM598(_), filename_for_error (argv [0 ] ) )




      , __funcarg120 = FUNCCALL(SETUP_XfOrM598(_), filename_for_error (argv [1 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM_EXISTS , "rename-file-or-directory: cannot rename file or directory;\n" " the destination path already exists\n" "  source path: %q\n" "  dest path: %q" , __funcarg119 , __funcarg120 ) )) 
      ; 
    }

# 3381 "bc/src/file.c"
    else {
#     define XfOrM597_COUNT (0+XfOrM596_COUNT)
#     define SETUP_XfOrM597(x) SETUP_XfOrM596(x)
      (__funcarg117 = FUNCCALL(SETUP_XfOrM597(_), filename_for_error (argv [0 ] ) )


      , __funcarg118 = FUNCCALL(SETUP_XfOrM597(_), filename_for_error (argv [1 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn ((exists_ok < 0 ) ? MZEXN_FAIL_FILESYSTEM_EXISTS : MZEXN_FAIL_FILESYSTEM , "rename-file-or-directory: cannot rename file or directory\n" "  source path: %q\n" "  dest path: %q\n" "  system error: %R" , __funcarg117 , __funcarg118 ) )) 
      ; 
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3395 "bc/src/file.c"
static void escape_during_copy (rktio_file_copy_t * cf ) 
{
  /* No conversion */

# 3397 "bc/src/file.c"
  rktio_copy_file_stop (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , cf ) ; 
}

static Scheme_Object * copy_file (int argc , Scheme_Object * * argv ) 
{
  char * src , * dest ; 
  int exists_ok = 0 ; 
  Scheme_Object * bss , * bsd ; 
  rktio_file_copy_t * cf ; 

# 3303 "bc/src/file.c"
  char * __funcarg126 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg125 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg124 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg123 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg122 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg121 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(dest, 0), PUSH(bsd, 1), PUSH(__funcarg123, 2), PUSH(cf, 3), PUSH(argv, 4), PUSH(__funcarg121, 5), PUSH(__funcarg125, 6), PUSH(src, 7)));
# define XfOrM600_COUNT (8)
# define SETUP_XfOrM600(x) SETUP(XfOrM600_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  src = NULLED_OUT ; 
  dest = NULLED_OUT ; 
  bss = NULLED_OUT ; 
  bsd = NULLED_OUT ; 
  cf = NULLED_OUT ; 

# 3407 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("copy-file" , "path-string?" , 0 , argc , argv ) ); 
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("copy-file" , "path-string?" , 1 , argc , argv ) ); 

  bss = argv [0 ] ; 
  bsd = argv [1 ] ; 
  exists_ok = ((argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) ; 

  src = FUNCCALL(SETUP_XfOrM600(_), scheme_expand_string_filename (bss , "copy-file" , ((void * ) 0 ) , 0x1 ) )


  ; 

  dest = FUNCCALL_AGAIN(scheme_expand_string_filename (bsd , "copy-file" , ((void * ) 0 ) , 0x2 | 0x8 ) )


  ; 

  cf = (rktio_copy_file_start (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , dest , src , exists_ok ) ) ; 
  if (cf ) {
    int ok = 1 ; 
#   define XfOrM604_COUNT (0+XfOrM600_COUNT)
#   define SETUP_XfOrM604(x) SETUP_XfOrM600(x)

# 3429 "bc/src/file.c"
    while (! (rktio_copy_file_is_done (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , cf ) ) ) {
#     define XfOrM616_COUNT (0+XfOrM604_COUNT)
#     define SETUP_XfOrM616(x) SETUP_XfOrM604(x)

# 3430 "bc/src/file.c"
      if (! (rktio_copy_file_step (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , cf ) ) ) {
        ok = 0 ; 
        break ; 
      }
      ok ++ ; 
      if (ok == 10 ) {
#       define XfOrM617_COUNT (0+XfOrM616_COUNT)
#       define SETUP_XfOrM617(x) SETUP_XfOrM616(x)

# 3436 "bc/src/file.c"
        {

# 3436 "bc/src/file.c"
          mz_jmp_buf * volatile savebuf , newbuf ; 

# 3436 "bc/src/file.c"
          Scheme_Thread * thread ; 
          BLOCK_SETUP((PUSH(savebuf, 0+XfOrM617_COUNT), PUSH(thread, 1+XfOrM617_COUNT)));
#         define XfOrM618_COUNT (2+XfOrM617_COUNT)
#         define SETUP_XfOrM618(x) SETUP(XfOrM618_COUNT)
          savebuf = NULLED_OUT ; 
          thread = NULLED_OUT ; 

# 3436 "bc/src/file.c"
          thread = (scheme_get_current_thread () ) ; 
          FUNCCALL(SETUP_XfOrM618(_), scheme_push_kill_action ((Scheme_Kill_Action_Func ) escape_during_copy , (void * ) cf ) )
# 3436 "bc/src/file.c"
          ; 

# 3436 "bc/src/file.c"
          savebuf = thread -> error_buf ; 

# 3436 "bc/src/file.c"
          thread -> error_buf = & newbuf ; 

# 3436 "bc/src/file.c"
          thread = ((void * ) 0 ) ; 

# 3436 "bc/src/file.c"
          if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM618_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#           define XfOrM622_COUNT (0+XfOrM618_COUNT)
#           define SETUP_XfOrM622(x) SETUP_XfOrM618(x)
            FUNCCALL(SETUP_XfOrM622(_), scheme_pop_kill_action () )
# 3436 "bc/src/file.c"
            ; 

# 3436 "bc/src/file.c"
            thread = (scheme_get_current_thread () ) ; 

# 3436 "bc/src/file.c"
            if (! thread -> cjs . skip_dws ) {
#             define XfOrM623_COUNT (0+XfOrM622_COUNT)
#             define SETUP_XfOrM623(x) SETUP_XfOrM622(x)
              FUNCCALL(SETUP_XfOrM623(_), escape_during_copy (cf ) )
# 3436 "bc/src/file.c"
              ; 
            }

# 3436 "bc/src/file.c"
            (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
          }

# 3436 "bc/src/file.c"
          else {
#           define XfOrM619_COUNT (0+XfOrM618_COUNT)
#           define SETUP_XfOrM619(x) SETUP_XfOrM618(x)

# 3436 "bc/src/file.c"
            ; 
            {
#             define XfOrM620_COUNT (0+XfOrM619_COUNT)
#             define SETUP_XfOrM620(x) SETUP_XfOrM619(x)

# 3437 "bc/src/file.c"
              if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#               define XfOrM621_COUNT (0+XfOrM620_COUNT)
#               define SETUP_XfOrM621(x) SETUP_XfOrM620(x)
                FUNCCALL(SETUP_XfOrM621(_), scheme_out_of_fuel () )
# 3437 "bc/src/file.c"
                ; 
              }
            }

# 3437 "bc/src/file.c"
            ; 
            thread = (scheme_get_current_thread () ) ; 
            FUNCCALL(SETUP_XfOrM619(_), scheme_pop_kill_action () )
# 3438 "bc/src/file.c"
            ; 

# 3438 "bc/src/file.c"
            thread -> error_buf = savebuf ; 

# 3438 "bc/src/file.c"
            thread = ((void * ) 0 ) ; 
          }
        }

# 3438 "bc/src/file.c"
        ; 
        ok = 1 ; 
      }
    }

    if (ok ) {
#     define XfOrM605_COUNT (0+XfOrM604_COUNT)
#     define SETUP_XfOrM605(x) SETUP_XfOrM604(x)

# 3444 "bc/src/file.c"
      if (! (rktio_copy_file_finish_permissions (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , cf ) ) ) {
#       define XfOrM606_COUNT (0+XfOrM605_COUNT)
#       define SETUP_XfOrM606(x) SETUP_XfOrM605(x)
        (
# 3445 "bc/src/file.c"
        rktio_copy_file_stop (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , cf ) ) ; 
        (__funcarg125 = FUNCCALL(SETUP_XfOrM606(_), filename_for_error (argv [0 ] ) )



        , __funcarg126 = FUNCCALL(SETUP_XfOrM606(_), filename_for_error (argv [1 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "copy-file: cannot set destination's permissions\n" "  source path: %q\n" "  destination path: %q" , __funcarg125 , __funcarg126 ) )) 
        ; 
      }
    }
    (rktio_copy_file_stop (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , cf ) ) ; 
    if (ok )
      RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }

  if (FUNCCALL(SETUP_XfOrM600(_), scheme_last_error_is_racket (RKTIO_ERROR_EXISTS ) )) {
#   define XfOrM603_COUNT (0+XfOrM600_COUNT)
#   define SETUP_XfOrM603(x) SETUP_XfOrM600(x)
    (__funcarg123 = FUNCCALL(SETUP_XfOrM603(_), filename_for_error (argv [0 ] ) )



    , __funcarg124 = FUNCCALL(SETUP_XfOrM603(_), filename_for_error (argv [1 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM_EXISTS , "copy-file: destination exists\n" "  source path: %q\n" "  destination path: %q" , __funcarg123 , __funcarg124 ) )) 
    ; 
  }

# 3468 "bc/src/file.c"
  else {
    const char * how ; 
    BLOCK_SETUP((PUSH(how, 0+XfOrM600_COUNT)));
#   define XfOrM601_COUNT (1+XfOrM600_COUNT)
#   define SETUP_XfOrM601(x) SETUP(XfOrM601_COUNT)
    how = NULLED_OUT ; 

# 3471 "bc/src/file.c"
    switch ((rktio_get_last_error_step (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ) {
      case RKTIO_COPY_STEP_OPEN_SRC : 
      how = "cannot open source file" ; 
      break ; 
      case RKTIO_COPY_STEP_OPEN_DEST : 
      how = "cannot open destination file" ; 
      break ; 
      case RKTIO_COPY_STEP_READ_SRC_DATA : 
      how = "error reading source file" ; 
      break ; 
      case RKTIO_COPY_STEP_WRITE_DEST_DATA : 
      how = "error writing destination file" ; 
      break ; 
      case RKTIO_COPY_STEP_READ_SRC_METADATA : 
      how = "error reading source-file metadata" ; 
      break ; 
      case RKTIO_COPY_STEP_WRITE_DEST_METADATA : 
      how = "error writing destination-file metadata" ; 
      break ; 
      default : 
      how = "copy failed" ; 
    }
    (__funcarg121 = FUNCCALL(SETUP_XfOrM601(_), filename_for_error (argv [0 ] ) )






    , __funcarg122 = FUNCCALL(SETUP_XfOrM601(_), filename_for_error (argv [1 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "copy-file: %s\n" "  source path: %q\n" "  destination path: %q\n" "  system error: %R" , how , __funcarg121 , __funcarg122 ) )) 
    ; 
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3507 "bc/src/file.c"
static Scheme_Object * relative_path_p (int argc , Scheme_Object * * argv ) 
{
  char * s ; 
  int len ; 
  Scheme_Object * bs ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(bs, 0), PUSH(s, 1)));
# define XfOrM625_COUNT (2)
# define SETUP_XfOrM625(x) SETUP(XfOrM625_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  bs = NULLED_OUT ; 

# 3513 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("relative-path?" , "(or/c path-for-some-system? path-string?)" , 0 , argc , argv ) ); 

  bs = (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ? argv [0 ] : FUNCCALL(SETUP_XfOrM625(_), scheme_char_string_to_path (argv [0 ] ) )) ; 

  s = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
  len = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 

  if (FUNCCALL(SETUP_XfOrM625(_), has_null (s , len ) ))
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  RET_VALUE_START ((FUNCCALL_EMPTY(scheme_is_relative_path (s , len , ((((intptr_t ) (bs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bs ) ) -> type ) ) )
  ? scheme_true 
  : scheme_false ) ) 
# 3524 "bc/src/file.c"
  RET_VALUE_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3529 "bc/src/file.c"
static Scheme_Object * complete_path_p (int argc , Scheme_Object * * argv ) 
{
  char * s ; 
  int len ; 
  Scheme_Object * bs ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(bs, 0), PUSH(s, 1)));
# define XfOrM626_COUNT (2)
# define SETUP_XfOrM626(x) SETUP(XfOrM626_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  bs = NULLED_OUT ; 

# 3535 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("complete-path?" , "(or/c path-for-some-system? path-string?)" , 0 , argc , argv ) ); 

  bs = (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ? argv [0 ] : FUNCCALL(SETUP_XfOrM626(_), scheme_char_string_to_path (argv [0 ] ) )) ; 

  s = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
  len = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 

  if (FUNCCALL(SETUP_XfOrM626(_), has_null (s , len ) ))
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  RET_VALUE_START ((FUNCCALL_EMPTY(scheme_is_complete_path (s , len , ((((intptr_t ) (bs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bs ) ) -> type ) ) )
  ? scheme_true 
  : scheme_false ) ) 
# 3546 "bc/src/file.c"
  RET_VALUE_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3551 "bc/src/file.c"
static Scheme_Object * absolute_path_p (int argc , Scheme_Object * * argv ) 
{
  char * s ; 
  int len ; 
  Scheme_Object * bs ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(bs, 0), PUSH(s, 1)));
# define XfOrM627_COUNT (2)
# define SETUP_XfOrM627(x) SETUP(XfOrM627_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  bs = NULLED_OUT ; 

# 3557 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("absolute-path?" , "(or/c path-for-some-system? path-string?)" , 0 , argc , argv ) ); 

  bs = (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ? argv [0 ] : FUNCCALL(SETUP_XfOrM627(_), scheme_char_string_to_path (argv [0 ] ) )) ; 

  s = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
  len = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 

  if (FUNCCALL(SETUP_XfOrM627(_), has_null (s , len ) ))
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  RET_VALUE_START ((! FUNCCALL_EMPTY(scheme_is_relative_path (s , len , ((((intptr_t ) (bs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bs ) ) -> type ) ) )
  ? scheme_true 
  : scheme_false ) ) 
# 3568 "bc/src/file.c"
  RET_VALUE_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3573 "bc/src/file.c"
static Scheme_Object * do_resolve_path (int argc , Scheme_Object * argv [] , int guards ) 
{
  char * content , * filename ; 
  int expanded ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(content, 0), PUSH(filename, 1), PUSH(argv, 2)));
# define XfOrM628_COUNT (3)
# define SETUP_XfOrM628(x) SETUP(XfOrM628_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  content = NULLED_OUT ; 
  filename = NULLED_OUT ; 

# 3578 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("resolve-path" , "path-string?" , 0 , argc , argv ) ); 

  filename = FUNCCALL(SETUP_XfOrM628(_), do_expand_filename (argv [0 ] , ((void * ) 0 ) , 0 , "resolve-path" , & expanded , 1 , 0 , guards ? 0x10 : 0 , scheme_unix_path_type , 0 ) )







  ; 

  {
    char * fullfilename = filename ; 
    intptr_t len ; 
    int copied = 0 ; 
    BLOCK_SETUP((PUSH(fullfilename, 0+XfOrM628_COUNT)));
#   define XfOrM629_COUNT (1+XfOrM628_COUNT)
#   define SETUP_XfOrM629(x) SETUP(XfOrM629_COUNT)

# 3596 "bc/src/file.c"
    len = strlen (fullfilename ) ; 
    if (! FUNCCALL(SETUP_XfOrM629(_), scheme_is_complete_path (fullfilename , len , scheme_unix_path_type ) )) {
#     define XfOrM635_COUNT (0+XfOrM629_COUNT)
#     define SETUP_XfOrM635(x) SETUP_XfOrM629(x)

# 3598 "bc/src/file.c"
      fullfilename = FUNCCALL(SETUP_XfOrM635(_), do_path_to_complete_path (fullfilename , len , ((void * ) 0 ) , 0 , scheme_unix_path_type ) ); 
      copied = 1 ; 
    }


    len = strlen (fullfilename ) ; 
    while (len && ((scheme_unix_path_type == scheme_unix_path_type ) ? ((fullfilename [len - 1 ] ) == '/' ) : (((fullfilename [len - 1 ] ) == '/' ) || ((fullfilename [len - 1 ] ) == '\\' ) ) ) ) {
#     define XfOrM633_COUNT (0+XfOrM629_COUNT)
#     define SETUP_XfOrM633(x) SETUP_XfOrM629(x)

# 3605 "bc/src/file.c"
      if (! expanded && ! copied ) {
#       define XfOrM634_COUNT (0+XfOrM633_COUNT)
#       define SETUP_XfOrM634(x) SETUP_XfOrM633(x)

# 3606 "bc/src/file.c"
        fullfilename = FUNCCALL(SETUP_XfOrM634(_), scheme_strdup (fullfilename ) ); 
        copied = 1 ; 
      }
      fullfilename [-- len ] = 0 ; 
    }

    content = (rktio_readlink (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fullfilename ) ) ; 



    if (content ) {
      Scheme_Object * r ; 
      BLOCK_SETUP((PUSH(r, 0+XfOrM629_COUNT)));
#     define XfOrM630_COUNT (1+XfOrM629_COUNT)
#     define SETUP_XfOrM630(x) SETUP(XfOrM630_COUNT)
      r = NULLED_OUT ; 

# 3618 "bc/src/file.c"
      r = FUNCCALL(SETUP_XfOrM630(_), scheme_make_sized_path (content , - 1 , 1 ) ); 
      FUNCCALL_AGAIN(free (content ) ); 
      RET_VALUE_START (r ) RET_VALUE_END ; 
    }
  }

  if (! expanded && ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_path (filename , strlen (filename ) , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3630 "bc/src/file.c"
static Scheme_Object * resolve_path (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3632 "bc/src/file.c"
  return do_resolve_path (argc , argv , 1 ) ; 
}

static Scheme_Object * convert_literal_relative (Scheme_Object * file ) 
{
  /* No conversion */

# 3637 "bc/src/file.c"
  int ln ; 
  char * f ; 
  f = (((Scheme_Simple_Object * ) (file ) ) -> u . byte_str_val . string_val ) ; 
  ln = (((Scheme_Simple_Object * ) (file ) ) -> u . byte_str_val . tag_val ) ; 
  if ((ln == 11 ) && ! strcmp (f , "\\\\?\\REL\\\\.." ) )
    return up_symbol ; 
  else if ((ln == 10 ) && ! strcmp (f , "\\\\?\\REL\\\\." ) )
    return same_symbol ; 
  return file ; 
}

static Scheme_Object * simplify_qm_path (Scheme_Object * path , int * has_rel ) 
{



  char * s = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) ; 
  int drive_end , clean_start , len = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) , fixed = 0 , i ; 
  int drop_extra_slash = - 1 , set_slash = - 1 , element_start ; 
  int found_bad = 0 , start_special_check = 0 , is_dir = 0 , norm_unc = 0 , drop_ss_slash = 0 ; 

# 513 "bc/src/file.c"
  Scheme_Object * __funcarg127 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(has_rel, 0), PUSH(s, 1), PUSH(path, 2)));
# define XfOrM638_COUNT (3)
# define SETUP_XfOrM638(x) SETUP(XfOrM638_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3658 "bc/src/file.c"
  if ((s [len - 1 ] == '\\' ) 
  && (s [len - 2 ] != '\\' ) 
  && FUNCCALL(SETUP_XfOrM638(_), do_path_to_directory_path (s , 0 , len - 1 , scheme_true , 1 , scheme_windows_path_type ) )) {
    -- len ; 
    fixed = 1 ; 
  }
  FUNCCALL(SETUP_XfOrM638(_), check_dos_slashslash_qm (s , len , & drive_end , & clean_start , ((void * ) 0 ) ) )
  ; 
  if ((drive_end == 7 ) 
  && (((unsigned char ) s [4 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM638(_), __ctype_b_loc () )) [(int ) (((unsigned char ) s [4 ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
  && (s [5 ] == ':' ) ) {

    start_special_check = 7 ; 
    drive_end = 4 ; 
  }

# 3672 "bc/src/file.c"
  else if ((drive_end == 8 ) 
  && (s [4 ] == '\\' ) 
  && (((unsigned char ) s [5 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM638(_), __ctype_b_loc () )) [(int ) (((unsigned char ) s [5 ] ) ) ] & (unsigned short int ) _ISalpha ) ) 
  && (s [6 ] == ':' ) ) {

    start_special_check = 8 ; 
    drive_end = 5 ; 
    drop_ss_slash = 1 ; 
  }

# 3680 "bc/src/file.c"
  else if (drive_end == - 2 ) {

    int lit_start ; 
#   define XfOrM673_COUNT (0+XfOrM638_COUNT)
#   define SETUP_XfOrM673(x) SETUP_XfOrM638(x)
    FUNCCALL(SETUP_XfOrM673(_), get_slashslash_qm_dot_ups_end (s , len , & lit_start ) )
# 3683 "bc/src/file.c"
    ; 
    start_special_check = lit_start ; 
    drive_end = lit_start - 1 ; 
  }

# 3686 "bc/src/file.c"
  else if (drive_end < 0 ) {

    int lit_start , dots_end ; 
#   define XfOrM670_COUNT (0+XfOrM638_COUNT)
#   define SETUP_XfOrM670(x) SETUP_XfOrM638(x)

# 3689 "bc/src/file.c"
    dots_end = FUNCCALL(SETUP_XfOrM670(_), get_slashslash_qm_dot_ups_end (s , len , & lit_start ) ); 
    if (lit_start == len ) {
#     define XfOrM672_COUNT (0+XfOrM670_COUNT)
#     define SETUP_XfOrM672(x) SETUP_XfOrM670(x)

# 3692 "bc/src/file.c"
      RET_VALUE_START ((__funcarg127 = FUNCCALL(SETUP_XfOrM672(_), scheme_make_sized_offset_kind_path (s , 8 , dots_end - 8 , 1 , scheme_windows_path_type ) ), FUNCCALL_EMPTY(scheme_path_to_directory_path (__funcarg127 ) )) ) RET_VALUE_END ; 
    }
    start_special_check = lit_start ; 
    if (dots_end < 9 )
      drive_end = lit_start ; 
    else {
      * has_rel = 1 ; 
      drive_end = 8 ; 
      drop_extra_slash = dots_end ; 
      is_dir = 1 ; 
    }
  }

# 3703 "bc/src/file.c"
  else if ((clean_start == 7 ) 
  && ((s [4 ] == 'U' ) || (s [4 ] == 'u' ) ) 
  && ((s [5 ] == 'N' ) || (s [5 ] == 'n' ) ) 
  && ((s [6 ] == 'C' ) || (s [6 ] == 'c' ) ) ) {
    if (drive_end == len ) {
      is_dir = 1 ; 
    }
    drive_end = 6 ; 
    start_special_check = 7 ; 
    set_slash = 6 ; 
    norm_unc = 1 ; 
  }

# 3714 "bc/src/file.c"
  else if ((clean_start == 8 ) 
  && (s [4 ] == '\\' ) 
  && ((s [5 ] == 'U' ) || (s [5 ] == 'u' ) ) 
  && ((s [6 ] == 'N' ) || (s [6 ] == 'n' ) ) 
  && ((s [7 ] == 'C' ) || (s [7 ] == 'c' ) ) ) {
    if (drive_end == len ) {
      is_dir = 1 ; 
    }
    drive_end = 7 ; 
    start_special_check = 8 ; 
    set_slash = 7 ; 
    norm_unc = 1 ; 
    drop_ss_slash = 1 ; 
  }

# 3727 "bc/src/file.c"
  else {

    found_bad = 1 ; 
    start_special_check = len ; 
  }

  if (! found_bad ) {
#   define XfOrM648_COUNT (0+XfOrM638_COUNT)
#   define SETUP_XfOrM648(x) SETUP_XfOrM638(x)

# 3734 "bc/src/file.c"
    element_start = start_special_check ; 
    for (i = element_start ; 1 ; i ++ ) {
#     define XfOrM657_COUNT (0+XfOrM648_COUNT)
#     define SETUP_XfOrM657(x) SETUP_XfOrM648(x)

# 3736 "bc/src/file.c"
      if ((i == len ) || (s [i ] == '\\' ) ) {
#       define XfOrM658_COUNT (0+XfOrM657_COUNT)
#       define SETUP_XfOrM658(x) SETUP_XfOrM657(x)

# 3737 "bc/src/file.c"
        if (element_start <= i - 1 ) {

          Scheme_Object * v ; 
          int any_more = 0 , j ; 
          BLOCK_SETUP((PUSH(v, 0+XfOrM658_COUNT)));
#         define XfOrM659_COUNT (1+XfOrM658_COUNT)
#         define SETUP_XfOrM659(x) SETUP(XfOrM659_COUNT)
          v = NULLED_OUT ; 

# 3742 "bc/src/file.c"
          for (j = i + 1 ; j < len ; j ++ ) {
            if (s [j ] != '\\' ) {
              any_more = 1 ; 
              break ; 
            }
          }

          v = FUNCCALL(SETUP_XfOrM659(_), make_protected_sized_offset_path (1 , s , element_start , i - element_start , 1 , (any_more ? 2 : 1 ) , scheme_windows_path_type ) )



          ; 
          if (! (((v ) ) == (scheme_false ) ) )  {
            found_bad = 1 ; 
            break ; 
          }
        }
        if (i == len )
          break ; 
        element_start = i + 1 ; 
      }
    }
  }

  if (found_bad ) {
#   define XfOrM642_COUNT (0+XfOrM638_COUNT)
#   define SETUP_XfOrM642(x) SETUP_XfOrM638(x)

# 3767 "bc/src/file.c"
    if (norm_unc ) {
      if ((s [4 + drop_ss_slash ] == 'U' ) 
      && (s [5 + drop_ss_slash ] == 'N' ) 
      && (s [6 + drop_ss_slash ] == 'C' ) )
        norm_unc = 0 ; 
    }
    if (norm_unc || drop_ss_slash ) {
#     define XfOrM643_COUNT (0+XfOrM642_COUNT)
#     define SETUP_XfOrM643(x) SETUP_XfOrM642(x)

# 3774 "bc/src/file.c"
      if (! fixed ) {
        char * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM643_COUNT)));
#       define XfOrM646_COUNT (1+XfOrM643_COUNT)
#       define SETUP_XfOrM646(x) SETUP(XfOrM646_COUNT)
        naya = NULLED_OUT ; 

# 3776 "bc/src/file.c"
        naya = (char * ) FUNCCALL(SETUP_XfOrM646(_), GC_malloc_atomic (len ) ); 
        (memcpy (naya , s , len ) ) ; 
        s = naya ; 
        fixed = 1 ; 
      }
      if (drop_ss_slash ) {
#       define XfOrM645_COUNT (0+XfOrM643_COUNT)
#       define SETUP_XfOrM645(x) SETUP_XfOrM643(x)
        (
# 3782 "bc/src/file.c"
        memmove (s + 3 , s + 4 , len - 4 ) ) ; 
        len -- ; 
      }
      if (norm_unc ) {
        s [4 ] = 'U' ; 
        s [5 ] = 'N' ; 
        s [6 ] = 'C' ; 
      }
    }
    if (fixed )
      path = FUNCCALL(SETUP_XfOrM642(_), scheme_make_sized_offset_kind_path (s , 0 , len , 1 , scheme_windows_path_type ) ); 
    RET_VALUE_START (path ) RET_VALUE_END ; 
  }

# 3794 "bc/src/file.c"
  else {
#   define XfOrM639_COUNT (0+XfOrM638_COUNT)
#   define SETUP_XfOrM639(x) SETUP_XfOrM638(x)

# 3795 "bc/src/file.c"
    if (drop_extra_slash > - 1 ) {
      char * naya ; 
      BLOCK_SETUP((PUSH(naya, 0+XfOrM639_COUNT)));
#     define XfOrM641_COUNT (1+XfOrM639_COUNT)
#     define SETUP_XfOrM641(x) SETUP(XfOrM641_COUNT)
      naya = NULLED_OUT ; 

# 3797 "bc/src/file.c"
      naya = (char * ) FUNCCALL(SETUP_XfOrM641(_), GC_malloc_atomic (len ) ); 
      (memcpy (naya , s , drop_extra_slash ) ) ; 
      (memcpy (naya + drop_extra_slash , s + drop_extra_slash + 1 , len - drop_extra_slash - 1 ) ) ; 
      s = naya ; 
      -- len ; 
    }
    if (set_slash > - 1 ) {
      char * naya ; 
      BLOCK_SETUP((PUSH(naya, 0+XfOrM639_COUNT)));
#     define XfOrM640_COUNT (1+XfOrM639_COUNT)
#     define SETUP_XfOrM640(x) SETUP(XfOrM640_COUNT)
      naya = NULLED_OUT ; 

# 3805 "bc/src/file.c"
      naya = (char * ) FUNCCALL(SETUP_XfOrM640(_), GC_malloc_atomic (len ) ); 
      (memcpy (naya , s , len ) ) ; 
      naya [set_slash ] = '\\' ; 
      s = naya ; 
    }
    path = FUNCCALL(SETUP_XfOrM639(_), scheme_make_sized_offset_kind_path (s , drive_end , len - drive_end , 1 , scheme_windows_path_type ) ); 
    if (is_dir )
      path = FUNCCALL(SETUP_XfOrM639(_), scheme_path_to_directory_path (path ) ); 
    RET_VALUE_START (path ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3817 "bc/src/file.c"
static Scheme_Object * do_simplify_path (Scheme_Object * path , Scheme_Object * cycle_check , int skip , 
int use_filesystem , 
int force_rel_up , int already_cleansed , 
int kind , int guards ) 





{
  int isdir , cleaned_slashes = 0 , must_be_dir = 0 , last_was_dir = 0 , did_first = 0 ; 
  Scheme_Object * file = scheme_false , * base ; 

# 647 "bc/src/file.c"
  Scheme_Object * __funcarg130 = NULLED_OUT ; 

# 513 "bc/src/file.c"
  Scheme_Object * __funcarg129 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(15);
  BLOCK_SETUP_TOP((PUSH(file, 0), PUSH(path, 1), PUSH(cycle_check, 2), PUSH(base, 3)));
# define XfOrM677_COUNT (4)
# define SETUP_XfOrM677(x) SETUP(XfOrM677_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  base = NULLED_OUT ; 

# 3832 "bc/src/file.c"
  if ((kind == scheme_windows_path_type ) && ! already_cleansed ) {
    char * s ; 
    int expanded , add_sep = 0 ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM677_COUNT)));
#   define XfOrM801_COUNT (1+XfOrM677_COUNT)
#   define SETUP_XfOrM801(x) SETUP(XfOrM801_COUNT)
    s = NULLED_OUT ; 

# 3835 "bc/src/file.c"
    s = FUNCCALL(SETUP_XfOrM801(_), do_expand_filename (path , (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) , ((void * ) 0 ) , & expanded , 0 , 0 , 0 , kind , 0 ) )
    ; 
    {
      int slen ; 
#     define XfOrM807_COUNT (0+XfOrM801_COUNT)
#     define SETUP_XfOrM807(x) SETUP_XfOrM801(x)

# 3839 "bc/src/file.c"
      if (expanded ) {
        cleaned_slashes = 1 ; 
        slen = strlen (s ) ; 
      }

# 3842 "bc/src/file.c"
      else 
      slen = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) ; 

      s = FUNCCALL(SETUP_XfOrM807(_), do_normal_path_seps (s , & slen , 0 , 0 , scheme_windows_path_type , & expanded ) ); 
    }
    if (expanded ) {
#     define XfOrM806_COUNT (0+XfOrM801_COUNT)
#     define SETUP_XfOrM806(x) SETUP_XfOrM801(x)

# 3848 "bc/src/file.c"
      path = FUNCCALL(SETUP_XfOrM806(_), scheme_make_sized_offset_kind_path (s , 0 , - 1 , 0 , scheme_windows_path_type ) ); 
    }
    if (! FUNCCALL(SETUP_XfOrM801(_), check_dos_slashslash_qm ((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) , ((void * ) 0 ) , ((void * ) 0 ) , & add_sep ) )) {
      int len = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) ; 
#     define XfOrM805_COUNT (0+XfOrM801_COUNT)
#     define SETUP_XfOrM805(x) SETUP_XfOrM801(x)

# 3852 "bc/src/file.c"
      s = FUNCCALL(SETUP_XfOrM805(_), strip_trailing_spaces ((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) , & len , 0 , 0 ) ); 
      if (s != (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) )
        path = FUNCCALL(SETUP_XfOrM805(_), scheme_make_sized_offset_kind_path (s , 0 , - 1 , 0 , scheme_windows_path_type ) ); 
    }

# 3855 "bc/src/file.c"
    else if (add_sep ) {
      int len = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) ; 
#     define XfOrM802_COUNT (0+XfOrM801_COUNT)
#     define SETUP_XfOrM802(x) SETUP_XfOrM801(x)

# 3857 "bc/src/file.c"
      if ((add_sep < len ) && (s [add_sep ] != '\\' ) ) {

        char * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM802_COUNT)));
#       define XfOrM804_COUNT (1+XfOrM802_COUNT)
#       define SETUP_XfOrM804(x) SETUP(XfOrM804_COUNT)
        naya = NULLED_OUT ; 

# 3860 "bc/src/file.c"
        naya = (char * ) FUNCCALL(SETUP_XfOrM804(_), GC_malloc_atomic (len + 3 ) ); 
        (memcpy (naya , s , add_sep ) ) ; 
        naya [add_sep ] = '\\' ; 
        naya [add_sep + 1 ] = '\\' ; 
        (memcpy (naya + add_sep + 2 , s + add_sep , len + 1 - add_sep ) ) ; 
        len += 2 ; 
        path = FUNCCALL(SETUP_XfOrM804(_), scheme_make_sized_offset_kind_path (naya , 0 , len , 0 , scheme_windows_path_type ) ); 
      }

# 3867 "bc/src/file.c"
      else if (((add_sep + 1 ) < len ) && (s [add_sep ] == '\\' ) && (s [add_sep + 1 ] != '\\' ) ) {

        char * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM802_COUNT)));
#       define XfOrM803_COUNT (1+XfOrM802_COUNT)
#       define SETUP_XfOrM803(x) SETUP(XfOrM803_COUNT)
        naya = NULLED_OUT ; 

# 3870 "bc/src/file.c"
        naya = (char * ) FUNCCALL(SETUP_XfOrM803(_), GC_malloc_atomic (len + 2 ) ); 
        (memcpy (naya , s , add_sep ) ) ; 
        naya [add_sep ] = '\\' ; 
        (memcpy (naya + add_sep + 1 , s + add_sep , len + 1 - add_sep ) ) ; 
        len ++ ; 
        path = FUNCCALL(SETUP_XfOrM803(_), scheme_make_sized_offset_kind_path (naya , 0 , len , 0 , scheme_windows_path_type ) ); 
      }
    }
  }





  if (! cleaned_slashes || ! use_filesystem ) {
    char * s ; 
    int len , i , saw_dot = 0 ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM677_COUNT)));
#   define XfOrM775_COUNT (1+XfOrM677_COUNT)
#   define SETUP_XfOrM775(x) SETUP(XfOrM775_COUNT)
    s = NULLED_OUT ; 

# 3887 "bc/src/file.c"
    s = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) ; 
    len = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) ; 

    if (kind == scheme_windows_path_type ) {
#     define XfOrM788_COUNT (0+XfOrM775_COUNT)
#     define SETUP_XfOrM788(x) SETUP_XfOrM775(x)

# 3891 "bc/src/file.c"
      if (! skip && FUNCCALL(SETUP_XfOrM788(_), check_dos_slashslash_qm (s , len , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
#       define XfOrM796_COUNT (0+XfOrM788_COUNT)
#       define SETUP_XfOrM796(x) SETUP_XfOrM788(x)

# 3892 "bc/src/file.c"
        if (! force_rel_up ) {
          Scheme_Object * orig_path = path ; 
          int drive_end , has_up = 0 ; 
          BLOCK_SETUP((PUSH(orig_path, 0+XfOrM796_COUNT)));
#         define XfOrM798_COUNT (1+XfOrM796_COUNT)
#         define SETUP_XfOrM798(x) SETUP(XfOrM798_COUNT)

# 3895 "bc/src/file.c"
          path = FUNCCALL(SETUP_XfOrM798(_), simplify_qm_path (path , & has_up ) ); 
          cleaned_slashes = has_up ; 
          len = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) ; 
          if (FUNCCALL(SETUP_XfOrM798(_), check_dos_slashslash_qm ((((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) , len , & drive_end , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
#           define XfOrM799_COUNT (0+XfOrM798_COUNT)
#           define SETUP_XfOrM799(x) SETUP_XfOrM798(x)

# 3900 "bc/src/file.c"
            if (drive_end == len ) {
#             define XfOrM800_COUNT (0+XfOrM799_COUNT)
#             define SETUP_XfOrM800(x) SETUP_XfOrM799(x)

# 3902 "bc/src/file.c"
              path = FUNCCALL(SETUP_XfOrM800(_), scheme_path_to_directory_path (path ) ); 
            }
          }
          if (! ((path ) == (orig_path ) ) )
            cleaned_slashes = 1 ; 
          if (! cleaned_slashes || ! use_filesystem )
            RET_VALUE_START (path ) RET_VALUE_END ; 
        }

# 3909 "bc/src/file.c"
        else {
#         define XfOrM797_COUNT (0+XfOrM796_COUNT)
#         define SETUP_XfOrM797(x) SETUP_XfOrM796(x)

# 3911 "bc/src/file.c"
          RET_VALUE_START (FUNCCALL(SETUP_XfOrM797(_), scheme_path_to_directory_path (path ) )) RET_VALUE_END ; 
        }
      }
      if (! skip && FUNCCALL(SETUP_XfOrM788(_), check_dos_slashslash_drive (s , 0 , len , ((void * ) 0 ) , 1 , 0 ) )) {
#       define XfOrM792_COUNT (0+XfOrM788_COUNT)
#       define SETUP_XfOrM792(x) SETUP_XfOrM788(x)
        for (i = len ; (((s [i - 1 ] ) == '/' ) || ((s [i - 1 ] ) == '\\' ) ) ; i -- ) {
        }

# 3918 "bc/src/file.c"
        if (i < len - 1 ) {
#         define XfOrM793_COUNT (0+XfOrM792_COUNT)
#         define SETUP_XfOrM793(x) SETUP_XfOrM792(x)

# 3919 "bc/src/file.c"
          path = FUNCCALL(SETUP_XfOrM793(_), scheme_make_sized_offset_kind_path (s , 0 , i , 1 , scheme_windows_path_type ) ); 
        }

        path = FUNCCALL(SETUP_XfOrM792(_), scheme_path_to_directory_path (path ) ); 
      }

      if (skip ) {
        while (s [skip ] == '\\' ) {
          skip ++ ; 
        }
      }
    }

    i = skip ; 
    if (kind == scheme_windows_path_type ) {
#     define XfOrM784_COUNT (0+XfOrM775_COUNT)
#     define SETUP_XfOrM784(x) SETUP_XfOrM775(x)

# 3934 "bc/src/file.c"
      if (! i && (len >= 2 ) && (((unsigned char ) s [0 ] < 128 ) && ((* FUNCCALL(SETUP_XfOrM784(_), __ctype_b_loc () )) [(int ) (((unsigned char ) s [0 ] ) ) ] & (unsigned short int ) _ISalpha ) ) && s [1 ] == ':' ) {
        i = 2 ; 
      }

# 3936 "bc/src/file.c"
      else if (! i ) {
        int drive_end ; 
#       define XfOrM785_COUNT (0+XfOrM784_COUNT)
#       define SETUP_XfOrM785(x) SETUP_XfOrM784(x)

# 3938 "bc/src/file.c"
        if (FUNCCALL(SETUP_XfOrM785(_), check_dos_slashslash_drive (s , 0 , len , & drive_end , 0 , 0 ) )) {
          i = drive_end ; 
        }
      }
    }

    for (; i < len ; i ++ ) {
      if (s [i ] == '.' )
        saw_dot ++ ; 
      else if ((kind == scheme_unix_path_type ) ? ((s [i ] ) == '/' ) : (((s [i ] ) == '/' ) || ((s [i ] ) == '\\' ) ) )  {
        if ((saw_dot == 1 ) || (saw_dot == 2 ) )
          break ; 
        if ((i + 1 < len ) && (((kind == scheme_unix_path_type ) ? ((s [i ] ) == '/' ) : (((s [i ] ) == '/' ) || ((s [i ] ) == '\\' ) ) ) ) ) {

          break ; 
        }
        saw_dot = 0 ; 
      }

# 3955 "bc/src/file.c"
      else 
      saw_dot = 3 ; 
    }

    if (i == len ) {
#     define XfOrM776_COUNT (0+XfOrM775_COUNT)
#     define SETUP_XfOrM776(x) SETUP_XfOrM775(x)

# 3960 "bc/src/file.c"
      if ((saw_dot != 1 ) && (saw_dot != 2 ) ) {
#       define XfOrM777_COUNT (0+XfOrM776_COUNT)
#       define SETUP_XfOrM777(x) SETUP_XfOrM776(x)

# 3962 "bc/src/file.c"
        if (FUNCCALL(SETUP_XfOrM777(_), path_is_simple_dir_without_sep (path ) ))
          path = FUNCCALL(SETUP_XfOrM777(_), scheme_path_to_directory_path (path ) ); 
        RET_VALUE_START (path ) RET_VALUE_END ; 
      }
    }
  }



  if (! cleaned_slashes ) {
#   define XfOrM768_COUNT (0+XfOrM677_COUNT)
#   define SETUP_XfOrM768(x) SETUP_XfOrM677(x)

# 3972 "bc/src/file.c"
    base = path ; 
    do {
      char * s ; 
      int len ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM768_COUNT)));
#     define XfOrM772_COUNT (1+XfOrM768_COUNT)
#     define SETUP_XfOrM772(x) SETUP(XfOrM772_COUNT)
      s = NULLED_OUT ; 

# 3976 "bc/src/file.c"
      s = (((Scheme_Simple_Object * ) (base ) ) -> u . byte_str_val . string_val ) ; 
      len = (((Scheme_Simple_Object * ) (base ) ) -> u . byte_str_val . tag_val ) ; 
      if (len <= skip )
        break ; 
      file = FUNCCALL(SETUP_XfOrM772(_), do_split_path_once (s , len , & base , & isdir , & cleaned_slashes , kind ) ); 
      if (kind == scheme_windows_path_type ) {
#       define XfOrM773_COUNT (0+XfOrM772_COUNT)
#       define SETUP_XfOrM773(x) SETUP_XfOrM772(x)

# 3982 "bc/src/file.c"
        if (force_rel_up ) {
#         define XfOrM774_COUNT (0+XfOrM773_COUNT)
#         define SETUP_XfOrM774(x) SETUP_XfOrM773(x)

# 3983 "bc/src/file.c"
          file = FUNCCALL(SETUP_XfOrM774(_), convert_literal_relative (file ) ); 
        }
      }
      if (((Scheme_Type ) (((((intptr_t ) (file ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (file ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || cleaned_slashes )
        break ; 
    }

# 3988 "bc/src/file.c"
    while (((((((intptr_t ) (base ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (base ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (base ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (base ) ) -> type ) <= scheme_windows_path_type ) ) ) ; 
  }

# 3989 "bc/src/file.c"
  else 
  file = scheme_false ; 

  if (((Scheme_Type ) (((((intptr_t ) (file ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (file ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || cleaned_slashes ) {

    char * s ; 
    int len ; 
    Scheme_Object * accum = scheme_null , * result ; 
    BLOCK_SETUP((PUSH(result, 0+XfOrM677_COUNT), PUSH(s, 1+XfOrM677_COUNT), PUSH(accum, 2+XfOrM677_COUNT)));
#   define XfOrM678_COUNT (3+XfOrM677_COUNT)
#   define SETUP_XfOrM678(x) SETUP(XfOrM678_COUNT)
    s = NULLED_OUT ; 
    result = NULLED_OUT ; 

# 3998 "bc/src/file.c"
    s = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . string_val ) ; 
    len = (((Scheme_Simple_Object * ) (path ) ) -> u . byte_str_val . tag_val ) ; 

    if (use_filesystem 
    && ! FUNCCALL(SETUP_XfOrM678(_), scheme_is_complete_path (s , len , kind ) )) {
#     define XfOrM767_COUNT (0+XfOrM678_COUNT)
#     define SETUP_XfOrM767(x) SETUP_XfOrM678(x)

# 4004 "bc/src/file.c"
      s = FUNCCALL(SETUP_XfOrM767(_), scheme_expand_string_filename (path , "simplify-path" , ((void * ) 0 ) , guards ? 0x10 : 0 ) )

      ; 
      len = strlen (s ) ; 
    }


    if (use_filesystem ) {
#     define XfOrM761_COUNT (0+XfOrM678_COUNT)
#     define SETUP_XfOrM761(x) SETUP_XfOrM678(x)

# 4012 "bc/src/file.c"
      {
        Scheme_Object * l = cycle_check ; 
        BLOCK_SETUP((PUSH(l, 0+XfOrM761_COUNT)));
#       define XfOrM762_COUNT (1+XfOrM761_COUNT)
#       define SETUP_XfOrM762(x) SETUP(XfOrM762_COUNT)

# 4014 "bc/src/file.c"
        while (! ((l ) == (scheme_null ) ) ) {
          Scheme_Object * p = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          BLOCK_SETUP((PUSH(p, 0+XfOrM762_COUNT)));
#         define XfOrM765_COUNT (1+XfOrM762_COUNT)
#         define SETUP_XfOrM765(x) SETUP(XfOrM765_COUNT)

# 4016 "bc/src/file.c"
          if ((len == (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) ) 
          && ! (strcmp (s , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) ) ) ) {
#           define XfOrM766_COUNT (0+XfOrM765_COUNT)
#           define SETUP_XfOrM766(x) SETUP_XfOrM765(x)
            FUNCCALL(SETUP_XfOrM766(_), scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "simplify-path: cycle detected at link\n" "  link path: %q" , s ) )

            ; 
          }
          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        }
      }

      cycle_check = (__funcarg130 = FUNCCALL(SETUP_XfOrM761(_), scheme_make_sized_path (s , len , 0 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg130 , cycle_check ) )) 
      ; 
    }


    while (1 ) {
#     define XfOrM752_COUNT (0+XfOrM678_COUNT)
#     define SETUP_XfOrM752(x) SETUP_XfOrM678(x)

# 4034 "bc/src/file.c"
      if (len <= skip ) {
#       define XfOrM760_COUNT (0+XfOrM752_COUNT)
#       define SETUP_XfOrM760(x) SETUP_XfOrM752(x)

# 4035 "bc/src/file.c"
        accum = (__funcarg129 = FUNCCALL(SETUP_XfOrM760(_), scheme_make_sized_offset_kind_path (s , 0 , len , 0 , kind ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg129 , accum ) )) ; 
        break ; 
      }

      file = FUNCCALL(SETUP_XfOrM752(_), scheme_split_path (s , len , & base , & isdir , kind ) ); 
      if (kind == scheme_windows_path_type ) {
#       define XfOrM758_COUNT (0+XfOrM752_COUNT)
#       define SETUP_XfOrM758(x) SETUP_XfOrM752(x)

# 4041 "bc/src/file.c"
        if (force_rel_up ) {
#         define XfOrM759_COUNT (0+XfOrM758_COUNT)
#         define SETUP_XfOrM759(x) SETUP_XfOrM758(x)

# 4042 "bc/src/file.c"
          file = FUNCCALL(SETUP_XfOrM759(_), convert_literal_relative (file ) ); 
          if ((Scheme_Type ) (((((intptr_t ) (file ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (file ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
            isdir = 1 ; 
        }
      }

      if (! did_first ) {
        must_be_dir = isdir ; 
        did_first = 1 ; 
      }

      if ((file ) == (same_symbol ) )  {
      }
      else 
      accum = FUNCCALL(SETUP_XfOrM752(_), scheme_make_pair (file , accum ) ); 

      if ((((((intptr_t ) (base ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (base ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (base ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (base ) ) -> type ) <= scheme_windows_path_type ) )  {
        s = (((Scheme_Simple_Object * ) (base ) ) -> u . byte_str_val . string_val ) ; 
        len = (((Scheme_Simple_Object * ) (base ) ) -> u . byte_str_val . tag_val ) ; 
      }

# 4061 "bc/src/file.c"
      else {
#       define XfOrM753_COUNT (0+XfOrM752_COUNT)
#       define SETUP_XfOrM753(x) SETUP_XfOrM752(x)

# 4062 "bc/src/file.c"
        if (use_filesystem ) {
#         define XfOrM754_COUNT (0+XfOrM753_COUNT)
#         define SETUP_XfOrM754(x) SETUP_XfOrM753(x)

# 4063 "bc/src/file.c"
          accum = FUNCCALL(SETUP_XfOrM754(_), scheme_make_pair (file , (((Scheme_Simple_Object * ) (accum ) ) -> u . pair_val . cdr ) ) ); 
        }
        break ; 
      }
    }


    if ((accum ) == (scheme_null ) )  {

      result = scheme_false ; 
    }

# 4073 "bc/src/file.c"
    else {
      result = (((Scheme_Simple_Object * ) (accum ) ) -> u . pair_val . car ) ; 
      if ((result ) == (up_symbol ) )  {

        result = scheme_false ; 
      }

# 4078 "bc/src/file.c"
      else 
      accum = (((Scheme_Simple_Object * ) (accum ) ) -> u . pair_val . cdr ) ; 
    }


    while (! ((accum ) == (scheme_null ) ) ) {
#     define XfOrM710_COUNT (0+XfOrM678_COUNT)
#     define SETUP_XfOrM710(x) SETUP_XfOrM678(x)

# 4084 "bc/src/file.c"
      if (((((Scheme_Simple_Object * ) (accum ) ) -> u . pair_val . car ) ) == (up_symbol ) )  {
#       define XfOrM713_COUNT (0+XfOrM710_COUNT)
#       define SETUP_XfOrM713(x) SETUP_XfOrM710(x)

# 4085 "bc/src/file.c"
        if (use_filesystem && (scheme_unix_path_type != scheme_windows_path_type ) ) {

          Scheme_Object * new_result , * a [1 ] ; 
          BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM713_COUNT), PUSH(new_result, 3+XfOrM713_COUNT)));
#         define XfOrM721_COUNT (4+XfOrM713_COUNT)
#         define SETUP_XfOrM721(x) SETUP(XfOrM721_COUNT)
          new_result = NULLED_OUT ; 
          a[0] = NULLED_OUT ; 

# 4089 "bc/src/file.c"
          while (1 ) {
#           define XfOrM731_COUNT (0+XfOrM721_COUNT)
#           define SETUP_XfOrM731(x) SETUP_XfOrM721(x)

# 4090 "bc/src/file.c"
            a [0 ] = result ; 
            new_result = FUNCCALL(SETUP_XfOrM731(_), do_resolve_path (1 , a , guards ) ); 


            if (result != new_result ) {
#             define XfOrM732_COUNT (0+XfOrM731_COUNT)
#             define SETUP_XfOrM732(x) SETUP_XfOrM731(x)

# 4096 "bc/src/file.c"
              if (! FUNCCALL(SETUP_XfOrM732(_), scheme_is_complete_path ((((Scheme_Simple_Object * ) (new_result ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (new_result ) ) -> u . byte_str_val . tag_val ) , kind ) )) 

              {
                Scheme_Object * aa [2 ] , * result_base ; 
                BLOCK_SETUP((PUSH(result_base, 0+XfOrM732_COUNT), PUSHARRAY(aa, 2, 1+XfOrM732_COUNT)));
#               define XfOrM739_COUNT (4+XfOrM732_COUNT)
#               define SETUP_XfOrM739(x) SETUP(XfOrM739_COUNT)
                aa[0] = NULLED_OUT ; 
                aa[1] = NULLED_OUT ; 
                result_base = NULLED_OUT ; 
                FUNCCALL(SETUP_XfOrM739(_), scheme_split_path ((((Scheme_Simple_Object * ) (result ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (result ) ) -> u . byte_str_val . tag_val ) , & result_base , & isdir , kind ) )
# 4105 "bc/src/file.c"
                ; 
                aa [0 ] = result_base ; 
                aa [1 ] = new_result ; 
                new_result = FUNCCALL(SETUP_XfOrM739(_), do_build_path (2 , aa , 0 , 0 , scheme_unix_path_type ) ); 
              }

              {
                Scheme_Object * cl , * cp ; 
#               define XfOrM734_COUNT (0+XfOrM732_COUNT)
#               define SETUP_XfOrM734(x) SETUP_XfOrM732(x)
                cl = NULLED_OUT ; 
                cp = NULLED_OUT ; 

# 4113 "bc/src/file.c"
                for (cl = cycle_check ; ! ((cl ) == (scheme_null ) ) ; cl = (((Scheme_Simple_Object * ) (cl ) ) -> u . pair_val . cdr ) ) {
#                 define XfOrM737_COUNT (0+XfOrM734_COUNT)
#                 define SETUP_XfOrM737(x) SETUP_XfOrM734(x)

# 4114 "bc/src/file.c"
                  cp = (((Scheme_Simple_Object * ) (cl ) ) -> u . pair_val . car ) ; 
                  if (((((Scheme_Simple_Object * ) (cp ) ) -> u . byte_str_val . tag_val ) == (((Scheme_Simple_Object * ) (new_result ) ) -> u . byte_str_val . tag_val ) ) 
                  && ! (strcmp ((((Scheme_Simple_Object * ) (cp ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (new_result ) ) -> u . byte_str_val . string_val ) ) ) ) {

                    new_result = ((void * ) 0 ) ; 
                    break ; 
                  }
                }
              }

              if (new_result ) {
#               define XfOrM733_COUNT (0+XfOrM732_COUNT)
#               define SETUP_XfOrM733(x) SETUP_XfOrM732(x)

# 4126 "bc/src/file.c"
                result = FUNCCALL(SETUP_XfOrM733(_), do_simplify_path (new_result , cycle_check , skip , use_filesystem , force_rel_up , 0 , kind , guards ) )

                ; 
                cycle_check = FUNCCALL(SETUP_XfOrM733(_), scheme_make_pair (new_result , cycle_check ) ); 
              }

# 4130 "bc/src/file.c"
              else 
              break ; 
            }

# 4132 "bc/src/file.c"
            else 
            break ; 
          }
        }


        {
#         define XfOrM714_COUNT (0+XfOrM713_COUNT)
#         define SETUP_XfOrM714(x) SETUP_XfOrM713(x)

# 4139 "bc/src/file.c"
          accum = (((Scheme_Simple_Object * ) (accum ) ) -> u . pair_val . cdr ) ; 
          if (((result ) ) == (scheme_false ) )  {
#           define XfOrM720_COUNT (0+XfOrM714_COUNT)
#           define SETUP_XfOrM720(x) SETUP_XfOrM714(x)

# 4142 "bc/src/file.c"
            if (skip )
              result = FUNCCALL(SETUP_XfOrM720(_), scheme_make_sized_offset_kind_path ("\\\\?\\REL\\.." , 0 , 10 , 0 , scheme_windows_path_type ) ); 
            else 
            result = FUNCCALL(SETUP_XfOrM720(_), scheme_make_sized_offset_kind_path (".." , 0 , 2 , 0 , kind ) ); 
          }

# 4146 "bc/src/file.c"
          else {
            Scheme_Object * next , * to_go ; 
            BLOCK_SETUP((PUSH(next, 0+XfOrM714_COUNT), PUSH(to_go, 1+XfOrM714_COUNT)));
#           define XfOrM715_COUNT (2+XfOrM714_COUNT)
#           define SETUP_XfOrM715(x) SETUP(XfOrM715_COUNT)
            next = NULLED_OUT ; 
            to_go = NULLED_OUT ; 

# 4148 "bc/src/file.c"
            to_go = FUNCCALL(SETUP_XfOrM715(_), scheme_split_path ((((Scheme_Simple_Object * ) (result ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (result ) ) -> u . byte_str_val . tag_val ) , & next , & isdir , kind ) )



            ; 
            if ((to_go ) == (up_symbol ) )  {

              Scheme_Object * a [2 ] ; 
              BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM715_COUNT)));
#             define XfOrM719_COUNT (3+XfOrM715_COUNT)
#             define SETUP_XfOrM719(x) SETUP(XfOrM719_COUNT)
              a[0] = NULLED_OUT ; 
              a[1] = NULLED_OUT ; 

# 4156 "bc/src/file.c"
              a [0 ] = result ; 
              a [1 ] = up_symbol ; 
              result = FUNCCALL(SETUP_XfOrM719(_), do_build_path (2 , a , 0 , 1 , kind ) ); 
            }

# 4170 "bc/src/file.c"
            else if (! (((Scheme_Type ) (((((intptr_t ) (next ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (next ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (next ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (next ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (next ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (next ) ) -> type ) <= scheme_windows_path_type ) ) ) ) {
              if (((next ) ) == (scheme_false ) )  {
              }
              else {

                result = scheme_false ; 
              }
            }

# 4177 "bc/src/file.c"
            else 
            result = next ; 
          }
        }

        last_was_dir = 1 ; 
      }

# 4183 "bc/src/file.c"
      else {
#       define XfOrM711_COUNT (0+XfOrM710_COUNT)
#       define SETUP_XfOrM711(x) SETUP_XfOrM710(x)

# 4185 "bc/src/file.c"
        if (((result ) ) == (scheme_false ) ) 
          result = (((Scheme_Simple_Object * ) (accum ) ) -> u . pair_val . car ) ; 
        else {
          Scheme_Object * a [2 ] ; 
          BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM711_COUNT)));
#         define XfOrM712_COUNT (3+XfOrM711_COUNT)
#         define SETUP_XfOrM712(x) SETUP(XfOrM712_COUNT)
          a[0] = NULLED_OUT ; 
          a[1] = NULLED_OUT ; 

# 4189 "bc/src/file.c"
          a [0 ] = result ; 
          a [1 ] = (((Scheme_Simple_Object * ) (accum ) ) -> u . pair_val . car ) ; 
          result = FUNCCALL(SETUP_XfOrM712(_), do_build_path (2 , a , 0 , 0 , kind ) ); 
        }
        accum = (((Scheme_Simple_Object * ) (accum ) ) -> u . pair_val . cdr ) ; 
        last_was_dir = 0 ; 
      }
    }

    if ((must_be_dir || last_was_dir ) && ! (((result ) ) == (scheme_false ) ) ) {
#     define XfOrM679_COUNT (0+XfOrM678_COUNT)
#     define SETUP_XfOrM679(x) SETUP_XfOrM678(x)

# 4199 "bc/src/file.c"
      result = FUNCCALL(SETUP_XfOrM679(_), scheme_path_to_directory_path (result ) ); 
    }

    RET_VALUE_START (result ) RET_VALUE_END ; 
  }

# 4203 "bc/src/file.c"
  else 
  RET_VALUE_START (path ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4207 "bc/src/file.c"
Scheme_Object * scheme_simplify_path (int argc , Scheme_Object * argv [] ) 
{
  char * s ; 
  int len , use_fs , kind ; 
  Scheme_Object * bs , * r ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(bs, 0), PUSH(r, 1), PUSH(s, 2), PUSH(argv, 3)));
# define XfOrM809_COUNT (4)
# define SETUP_XfOrM809(x) SETUP(XfOrM809_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  bs = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 4213 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("simplify-path" , "(or/c path-for-some-system? path-string?)" , 0 , argc , argv ) ); 

  bs = (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ? argv [0 ] : FUNCCALL(SETUP_XfOrM809(_), scheme_char_string_to_path (argv [0 ] ) )) ; 

  s = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
  len = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 

  if (FUNCCALL(SETUP_XfOrM809(_), has_null (s , len ) ))
    FUNCCALL(SETUP_XfOrM809(_), raise_null_error ("simplify-path" , argv [0 ] , "" ) ); 

  use_fs = ((argc <= 1 ) || (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) ; 
  kind = ((((intptr_t ) (bs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bs ) ) -> type ) ; 

  if (use_fs && (kind != scheme_unix_path_type ) ) {
#   define XfOrM811_COUNT (0+XfOrM809_COUNT)
#   define SETUP_XfOrM811(x) SETUP_XfOrM809(x)
    FUNCCALL_EMPTY(scheme_contract_error ("simplify-path" , "in use-filesystem mode, path is not for the current platform" , "path" , 1 , argv [0 ] , ((void * ) 0 ) ) )
    ; 
  }

  r = FUNCCALL(SETUP_XfOrM809(_), do_simplify_path (bs , scheme_null , 0 , use_fs , 0 , 0 , kind , 1 ) ); 

  if (((r ) ) == (scheme_false ) )  {
#   define XfOrM810_COUNT (0+XfOrM809_COUNT)
#   define SETUP_XfOrM810(x) SETUP_XfOrM809(x)

# 4238 "bc/src/file.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path ((kind == scheme_windows_path_type ) ? ".\\" : "./" , 0 , 2 , 0 , kind ) )) RET_VALUE_EMPTY_END ; 
  }

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4244 "bc/src/file.c"
static Scheme_Object * current_drive (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */






  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "current-drive: " "unsupported on this platform" ) ; 
  return ((void * ) 0 ) ; 
}


static Scheme_Object * cleanse_path (int argc , Scheme_Object * argv [] ) 
{
  char * filename ; 
  int expanded , kind ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(filename, 0), PUSH(argv, 1)));
# define XfOrM813_COUNT (2)
# define SETUP_XfOrM813(x) SETUP(XfOrM813_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 

# 4263 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("cleanse-path" , "(or/c path-for-some-system? path-string?)" , 0 , argc , argv ) ); 

  if ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) 
    kind = ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ; 
  else 
  kind = scheme_unix_path_type ; 

  filename = FUNCCALL(SETUP_XfOrM813(_), do_expand_filename (argv [0 ] , ((void * ) 0 ) , 0 , "cleanse-path" , & expanded , 1 , 0 , 0 , kind , 0 ) )







  ; 

  if (! expanded && ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_windows_path_type ) ) )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_kind_path (filename , 0 , strlen (filename ) , 1 , kind ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4287 "bc/src/file.c"
static Scheme_Object * expand_user_path (int argc , Scheme_Object * argv [] ) 
{
  char * filename ; 
  int expanded ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(filename, 0), PUSH(argv, 1)));
# define XfOrM814_COUNT (2)
# define SETUP_XfOrM814(x) SETUP(XfOrM814_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 

# 4292 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("expand-user-path" , "path-string?" , 0 , argc , argv ) ); 

  filename = FUNCCALL(SETUP_XfOrM814(_), do_expand_filename (argv [0 ] , ((void * ) 0 ) , 0 , "expand-user-path" , & expanded , 1 , 0 , 0x10 , scheme_unix_path_type , 1 ) )







  ; 

  if (! expanded && ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_path (filename , strlen (filename ) , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4311 "bc/src/file.c"
static void escape_during_directory_list (rktio_directory_list_t * dl ) 
{
  /* No conversion */

# 4313 "bc/src/file.c"
  rktio_directory_list_stop (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , dl ) ; 
}

static Scheme_Object * do_directory_list (int break_ok , int argc , Scheme_Object * argv [] ) 
{
  char * filename ; 
  Scheme_Object * first = scheme_null , * last = ((void * ) 0 ) , * n , * elem ; 
  int counter = 0 ; 
  rktio_directory_list_t * dl ; 
  char * s ; 
  Scheme_Config * __funcarg131 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(first, 0), PUSH(elem, 1), PUSH(last, 2), PUSH(dl, 3), PUSH(n, 4), PUSH(s, 5), PUSH(filename, 6)));
# define XfOrM816_COUNT (7)
# define SETUP_XfOrM816(x) SETUP(XfOrM816_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  filename = NULLED_OUT ; 
  n = NULLED_OUT ; 
  elem = NULLED_OUT ; 
  dl = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 4324 "bc/src/file.c"
  if (argc && ! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("directory-list" , "path-string?" , 0 , argc , argv ) ); 

  if (argc ) {
    Scheme_Object * path = argv [0 ] ; 
#   define XfOrM836_COUNT (0+XfOrM816_COUNT)
#   define SETUP_XfOrM836(x) SETUP_XfOrM816(x)

    filename = FUNCCALL(SETUP_XfOrM836(_), do_expand_filename (path , ((void * ) 0 ) , 0 , break_ok ? "directory-list" : ((void * ) 0 ) , ((void * ) 0 ) , 1 , 259 - 4 , break_ok ? 0x1 : 0 , scheme_unix_path_type , 0 ) )




    ; 
    if (! filename )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 4352 "bc/src/file.c"
  else {
#   define XfOrM834_COUNT (0+XfOrM816_COUNT)
#   define SETUP_XfOrM834(x) SETUP_XfOrM816(x)

# 4353 "bc/src/file.c"
    filename = (((Scheme_Simple_Object * ) ((__funcarg131 = FUNCCALL(SETUP_XfOrM834(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg131 , MZCONFIG_CURRENT_DIRECTORY ) )) ) ) -> u . byte_str_val . string_val ) ; 
    if (break_ok ) {
#     define XfOrM835_COUNT (0+XfOrM834_COUNT)
#     define SETUP_XfOrM835(x) SETUP_XfOrM834(x)
      FUNCCALL(SETUP_XfOrM835(_), scheme_security_check_file ("directory-list" , ((void * ) 0 ) , 0x10 ) )
# 4355 "bc/src/file.c"
      ; 
      FUNCCALL(SETUP_XfOrM835(_), scheme_security_check_file ("directory-list" , filename , 0x1 ) ); 
    }
  }

  dl = (rktio_directory_list_start (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename ) ) ; 
  if (! dl ) {
#   define XfOrM833_COUNT (0+XfOrM816_COUNT)
#   define SETUP_XfOrM833(x) SETUP_XfOrM816(x)

# 4362 "bc/src/file.c"
    if (break_ok )
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "directory-list: could not open directory\n" "  path: %q\n" "  system error: %R" , filename ) )



    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  do {
#   define XfOrM825_COUNT (0+XfOrM816_COUNT)
#   define SETUP_XfOrM825(x) SETUP_XfOrM816(x)

# 4372 "bc/src/file.c"
    s = (rktio_directory_list_step (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , dl ) ) ; 
    if (! * s )
      break ; 

    n = FUNCCALL(SETUP_XfOrM825(_), make_protected_sized_offset_path (1 , s , 0 , strlen (s ) , 1 , 0 , scheme_unix_path_type ) ); 
    elem = FUNCCALL_AGAIN(scheme_make_pair (n , scheme_null ) ); 
    if (last )
      (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = elem ; 
    else 
    first = elem ; 
    last = elem ; 

    counter ++ ; 
    if (break_ok && ! (counter & 0xF ) ) {
#     define XfOrM826_COUNT (0+XfOrM825_COUNT)
#     define SETUP_XfOrM826(x) SETUP_XfOrM825(x)

# 4386 "bc/src/file.c"
      {

# 4386 "bc/src/file.c"
        mz_jmp_buf * volatile savebuf , newbuf ; 

# 4386 "bc/src/file.c"
        Scheme_Thread * thread ; 
        BLOCK_SETUP((PUSH(savebuf, 0+XfOrM826_COUNT), PUSH(thread, 1+XfOrM826_COUNT)));
#       define XfOrM827_COUNT (2+XfOrM826_COUNT)
#       define SETUP_XfOrM827(x) SETUP(XfOrM827_COUNT)
        savebuf = NULLED_OUT ; 
        thread = NULLED_OUT ; 

# 4386 "bc/src/file.c"
        thread = (scheme_get_current_thread () ) ; 
        FUNCCALL(SETUP_XfOrM827(_), scheme_push_kill_action ((Scheme_Kill_Action_Func ) escape_during_directory_list , (void * ) dl ) )
# 4386 "bc/src/file.c"
        ; 

# 4386 "bc/src/file.c"
        savebuf = thread -> error_buf ; 

# 4386 "bc/src/file.c"
        thread -> error_buf = & newbuf ; 

# 4386 "bc/src/file.c"
        thread = ((void * ) 0 ) ; 

# 4386 "bc/src/file.c"
        if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM827_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#         define XfOrM831_COUNT (0+XfOrM827_COUNT)
#         define SETUP_XfOrM831(x) SETUP_XfOrM827(x)
          FUNCCALL(SETUP_XfOrM831(_), scheme_pop_kill_action () )
# 4386 "bc/src/file.c"
          ; 

# 4386 "bc/src/file.c"
          thread = (scheme_get_current_thread () ) ; 

# 4386 "bc/src/file.c"
          if (! thread -> cjs . skip_dws ) {
#           define XfOrM832_COUNT (0+XfOrM831_COUNT)
#           define SETUP_XfOrM832(x) SETUP_XfOrM831(x)
            FUNCCALL(SETUP_XfOrM832(_), escape_during_directory_list (dl ) )
# 4386 "bc/src/file.c"
            ; 
          }

# 4386 "bc/src/file.c"
          (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
        }

# 4386 "bc/src/file.c"
        else {
#         define XfOrM828_COUNT (0+XfOrM827_COUNT)
#         define SETUP_XfOrM828(x) SETUP_XfOrM827(x)

# 4386 "bc/src/file.c"
          ; 
          {
#           define XfOrM829_COUNT (0+XfOrM828_COUNT)
#           define SETUP_XfOrM829(x) SETUP_XfOrM828(x)

# 4387 "bc/src/file.c"
            if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#             define XfOrM830_COUNT (0+XfOrM829_COUNT)
#             define SETUP_XfOrM830(x) SETUP_XfOrM829(x)
              FUNCCALL(SETUP_XfOrM830(_), scheme_out_of_fuel () )
# 4387 "bc/src/file.c"
              ; 
            }
          }

# 4387 "bc/src/file.c"
          ; 
          thread = (scheme_get_current_thread () ) ; 
          FUNCCALL(SETUP_XfOrM828(_), scheme_pop_kill_action () )
# 4388 "bc/src/file.c"
          ; 

# 4388 "bc/src/file.c"
          thread -> error_buf = savebuf ; 

# 4388 "bc/src/file.c"
          thread = ((void * ) 0 ) ; 
        }
      }

# 4388 "bc/src/file.c"
      ; 
    }
  }

# 4390 "bc/src/file.c"
  while (1 ) ; 

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4395 "bc/src/file.c"
static Scheme_Object * directory_list (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4397 "bc/src/file.c"
  return do_directory_list (1 , argc , argv ) ; 
}

char * scheme_find_completion (char * fn ) 
{
  int len ; 
  Scheme_Object * p , * l , * a [2 ] , * f , * matches , * fst ; 
  int isdir , max_match ; 
  Scheme_Object * base ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(fst, 0), PUSH(p, 1), PUSHARRAY(a, 2, 2), PUSH(fn, 5), PUSH(l, 6), PUSH(f, 7), PUSH(matches, 8), PUSH(base, 9)));
# define XfOrM838_COUNT (10)
# define SETUP_XfOrM838(x) SETUP(XfOrM838_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 
  l = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  f = NULLED_OUT ; 
  matches = NULLED_OUT ; 
  fst = NULLED_OUT ; 
  base = NULLED_OUT ; 

# 4407 "bc/src/file.c"
  len = strlen (fn ) ; 

  if (! len )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  f = FUNCCALL(SETUP_XfOrM838(_), scheme_split_path (fn , len , & base , & isdir , scheme_unix_path_type ) ); 
  if (isdir ) {
#   define XfOrM857_COUNT (0+XfOrM838_COUNT)
#   define SETUP_XfOrM857(x) SETUP_XfOrM838(x)

# 4415 "bc/src/file.c"
    base = FUNCCALL(SETUP_XfOrM857(_), scheme_make_sized_path (fn , len , 0 ) ); 
    f = FUNCCALL(SETUP_XfOrM857(_), scheme_make_sized_path ("" , 0 , 0 ) ); 
  }

# 4417 "bc/src/file.c"
  else {
    if (! ((Scheme_Type ) (((((intptr_t ) (base ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (base ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  a [0 ] = base ; 
  l = FUNCCALL(SETUP_XfOrM838(_), do_directory_list (0 , 1 , a ) ); 
  if (! l )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  matches = scheme_null ; 
  while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM854_COUNT (0+XfOrM838_COUNT)
#   define SETUP_XfOrM854(x) SETUP_XfOrM838(x)

# 4429 "bc/src/file.c"
    p = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    if (((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) >= (((Scheme_Simple_Object * ) (f ) ) -> u . byte_str_val . tag_val ) ) 
    && ! (memcmp ((((Scheme_Simple_Object * ) (f ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (f ) ) -> u . byte_str_val . tag_val ) ) ) ) {
#     define XfOrM855_COUNT (0+XfOrM854_COUNT)
#     define SETUP_XfOrM855(x) SETUP_XfOrM854(x)

# 4432 "bc/src/file.c"
      matches = FUNCCALL(SETUP_XfOrM855(_), scheme_make_pair (p , matches ) ); 
    }
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  if ((matches ) == (scheme_null ) ) 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  if (((((Scheme_Simple_Object * ) (matches ) ) -> u . pair_val . cdr ) ) == (scheme_null ) )  {
#   define XfOrM849_COUNT (0+XfOrM838_COUNT)
#   define SETUP_XfOrM849(x) SETUP_XfOrM838(x)

# 4442 "bc/src/file.c"
    a [0 ] = base ; 
    a [1 ] = (((Scheme_Simple_Object * ) (matches ) ) -> u . pair_val . car ) ; 
    p = FUNCCALL(SETUP_XfOrM849(_), scheme_build_path (2 , a ) ); 
    a [0 ] = p ; 
    if (! (((FUNCCALL(SETUP_XfOrM849(_), directory_exists (1 , a ) )) ) == (scheme_false ) ) )  {
#     define XfOrM850_COUNT (0+XfOrM849_COUNT)
#     define SETUP_XfOrM850(x) SETUP_XfOrM849(x)

# 4448 "bc/src/file.c"
      fn = (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) ; 
      len = (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) ; 
      if (! ((scheme_unix_path_type == scheme_unix_path_type ) ? ((fn [len - 1 ] ) == '/' ) : (((fn [len - 1 ] ) == '/' ) || ((fn [len - 1 ] ) == '\\' ) ) ) ) {
        char * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM850_COUNT)));
#       define XfOrM851_COUNT (1+XfOrM850_COUNT)
#       define SETUP_XfOrM851(x) SETUP(XfOrM851_COUNT)
        naya = NULLED_OUT ; 

# 4452 "bc/src/file.c"
        naya = (char * ) FUNCCALL(SETUP_XfOrM851(_), GC_malloc_atomic (len + 2 ) ); 
        (memcpy (naya , fn , len ) ) ; 
        naya [len ++ ] = ((scheme_unix_path_type == scheme_unix_path_type ) ? '/' : '\\' ) ; 
        naya [len ] = 0 ; 
        fn = naya ; 
      }
    }

# 4458 "bc/src/file.c"
    else 
    fn = (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) ; 
    RET_VALUE_START (fn ) RET_VALUE_END ; 
  }

  fst = (((Scheme_Simple_Object * ) (matches ) ) -> u . pair_val . car ) ; 
  max_match = (((Scheme_Simple_Object * ) (fst ) ) -> u . byte_str_val . tag_val ) ; 
  for (l = (((Scheme_Simple_Object * ) (matches ) ) -> u . pair_val . cdr ) ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
    int i , l2 ; 
    p = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    l2 = (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) ; 
    if (max_match < l2 )
      l2 = max_match ; 
    else if (l2 < max_match )
      max_match = l2 ; 
    for (i = 0 ; i < l2 ; i ++ ) {
      if ((((Scheme_Simple_Object * ) (fst ) ) -> u . byte_str_val . string_val ) [i ] != (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) [i ] ) {
        max_match = i ; 
        break ; 
      }
    }
  }

  if (max_match <= (((Scheme_Simple_Object * ) (f ) ) -> u . byte_str_val . tag_val ) )

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 


  a [0 ] = base ; 
  a [1 ] = FUNCCALL(SETUP_XfOrM838(_), scheme_make_sized_path ((((Scheme_Simple_Object * ) (fst ) ) -> u . byte_str_val . string_val ) , max_match , 0 ) ); 
  f = FUNCCALL(SETUP_XfOrM838(_), scheme_build_path (2 , a ) ); 

  RET_VALUE_START ((((Scheme_Simple_Object * ) (f ) ) -> u . byte_str_val . string_val ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4493 "bc/src/file.c"
static Scheme_Object * do_explode_path (Scheme_Object * p ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM858_COUNT (1)
# define SETUP_XfOrM858(x) SETUP(XfOrM858_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4495 "bc/src/file.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM858(_), explode_path (1 , & p ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4498 "bc/src/file.c"
static Scheme_Object * to_bytes (Scheme_Object * p ) 
{
  /* No conversion */

# 4500 "bc/src/file.c"
  if ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
    return scheme_make_sized_byte_string ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , 
  (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) , 
  1 ) ; 
  else 
  return p ; 
}

Scheme_Object * scheme_extract_relative_to (Scheme_Object * obj , Scheme_Object * dir , Scheme_Hash_Table * cache ) 

{
  Scheme_Object * de , * be , * oe , * orig_obj = obj ; 

# 4498 "bc/src/file.c"
  Scheme_Object * __funcarg134 = NULLED_OUT ; 

# 4498 "bc/src/file.c"
  Scheme_Object * __funcarg133 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(oe, 0), PUSH(orig_obj, 1), PUSH(de, 2), PUSH(be, 3), PUSH(cache, 4), PUSH(obj, 5), PUSH(dir, 6)));
# define XfOrM860_COUNT (7)
# define SETUP_XfOrM860(x) SETUP(XfOrM860_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  de = NULLED_OUT ; 
  be = NULLED_OUT ; 
  oe = NULLED_OUT ; 



  if (cache ) {
#   define XfOrM884_COUNT (0+XfOrM860_COUNT)
#   define SETUP_XfOrM884(x) SETUP_XfOrM860(x)

# 4514 "bc/src/file.c"
    de = FUNCCALL(SETUP_XfOrM884(_), scheme_hash_get (cache , obj ) ); 
    if (de )
      RET_VALUE_START (de ) RET_VALUE_END ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (dir ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (dir ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#   define XfOrM883_COUNT (0+XfOrM860_COUNT)
#   define SETUP_XfOrM883(x) SETUP_XfOrM860(x)

# 4520 "bc/src/file.c"
    be = FUNCCALL(SETUP_XfOrM883(_), do_explode_path ((((Scheme_Simple_Object * ) (dir ) ) -> u . pair_val . car ) ) ); 
    de = FUNCCALL(SETUP_XfOrM883(_), do_explode_path ((((Scheme_Simple_Object * ) (dir ) ) -> u . pair_val . cdr ) ) ); 
  }

# 4522 "bc/src/file.c"
  else {
#   define XfOrM882_COUNT (0+XfOrM860_COUNT)
#   define SETUP_XfOrM882(x) SETUP_XfOrM860(x)

# 4523 "bc/src/file.c"
    be = FUNCCALL(SETUP_XfOrM882(_), do_explode_path (dir ) ); 
    de = be ; 
  }
  oe = FUNCCALL(SETUP_XfOrM860(_), do_explode_path (obj ) ); 

  while (((Scheme_Type ) (((((intptr_t ) (de ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (de ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  && ((Scheme_Type ) (((((intptr_t ) (oe ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (oe ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM881_COUNT (0+XfOrM860_COUNT)
#   define SETUP_XfOrM881(x) SETUP_XfOrM860(x)

# 4530 "bc/src/file.c"
    if (! FUNCCALL(SETUP_XfOrM881(_), scheme_equal ((((Scheme_Simple_Object * ) (de ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . car ) ) ))
      RET_VALUE_START (obj ) RET_VALUE_END ; 
    de = (((Scheme_Simple_Object * ) (de ) ) -> u . pair_val . cdr ) ; 
    oe = (((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . cdr ) ; 
    be = (((Scheme_Simple_Object * ) (be ) ) -> u . pair_val . cdr ) ; 
  }

  if ((de ) == (scheme_null ) )  {
    Scheme_Object * a [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM860_COUNT)));
#   define XfOrM861_COUNT (3+XfOrM860_COUNT)
#   define SETUP_XfOrM861(x) SETUP(XfOrM861_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 

# 4540 "bc/src/file.c"
    while (((Scheme_Type ) (((((intptr_t ) (be ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (be ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
    && ((Scheme_Type ) (((((intptr_t ) (oe ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (oe ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
    && FUNCCALL(SETUP_XfOrM861(_), scheme_equal ((((Scheme_Simple_Object * ) (be ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . car ) ) )) {
      oe = (((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . cdr ) ; 
      be = (((Scheme_Simple_Object * ) (be ) ) -> u . pair_val . cdr ) ; 
    }



    if ((oe ) == (scheme_null ) )  {
#     define XfOrM875_COUNT (0+XfOrM861_COUNT)
#     define SETUP_XfOrM875(x) SETUP_XfOrM861(x)

# 4550 "bc/src/file.c"
      if (cache ) {
        obj = scheme_null ; 
      }

# 4552 "bc/src/file.c"
      else {
#       define XfOrM876_COUNT (0+XfOrM875_COUNT)
#       define SETUP_XfOrM876(x) SETUP_XfOrM875(x)

# 4553 "bc/src/file.c"
        a [0 ] = same_symbol ; 
        obj = FUNCCALL(SETUP_XfOrM876(_), scheme_build_path (1 , a ) ); 
      }
    }

# 4556 "bc/src/file.c"
    else {
#     define XfOrM874_COUNT (0+XfOrM861_COUNT)
#     define SETUP_XfOrM874(x) SETUP_XfOrM861(x)

# 4557 "bc/src/file.c"
      obj = (((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . car ) ; 
      if (cache )
        obj = (__funcarg134 = FUNCCALL(SETUP_XfOrM874(_), to_bytes (obj ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg134 , scheme_null ) )) ; 
      oe = (((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . cdr ) ; 
    }

    while (((Scheme_Type ) (((((intptr_t ) (oe ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (oe ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM871_COUNT (0+XfOrM861_COUNT)
#     define SETUP_XfOrM871(x) SETUP_XfOrM861(x)

# 4564 "bc/src/file.c"
      if (cache ) {
#       define XfOrM873_COUNT (0+XfOrM871_COUNT)
#       define SETUP_XfOrM873(x) SETUP_XfOrM871(x)

# 4565 "bc/src/file.c"
        obj = (__funcarg133 = FUNCCALL(SETUP_XfOrM873(_), to_bytes ((((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . car ) ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg133 , obj ) )) ; 
      }

# 4566 "bc/src/file.c"
      else {
#       define XfOrM872_COUNT (0+XfOrM871_COUNT)
#       define SETUP_XfOrM872(x) SETUP_XfOrM871(x)

# 4567 "bc/src/file.c"
        a [0 ] = obj ; 
        a [1 ] = (((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . car ) ; 
        obj = FUNCCALL(SETUP_XfOrM872(_), scheme_build_path (2 , a ) ); 
      }
      oe = (((Scheme_Simple_Object * ) (oe ) ) -> u . pair_val . cdr ) ; 
    }

    if (cache )
      obj = FUNCCALL(SETUP_XfOrM861(_), scheme_reverse (obj ) ); 

    while (! ((be ) == (scheme_null ) ) ) {
#     define XfOrM865_COUNT (0+XfOrM861_COUNT)
#     define SETUP_XfOrM865(x) SETUP_XfOrM861(x)

# 4578 "bc/src/file.c"
      if (cache ) {
#       define XfOrM867_COUNT (0+XfOrM865_COUNT)
#       define SETUP_XfOrM867(x) SETUP_XfOrM865(x)

# 4579 "bc/src/file.c"
        obj = FUNCCALL(SETUP_XfOrM867(_), scheme_make_pair (up_symbol , obj ) ); 
      }

# 4580 "bc/src/file.c"
      else {
#       define XfOrM866_COUNT (0+XfOrM865_COUNT)
#       define SETUP_XfOrM866(x) SETUP_XfOrM865(x)

# 4581 "bc/src/file.c"
        a [0 ] = up_symbol ; 
        a [1 ] = obj ; 
        obj = FUNCCALL(SETUP_XfOrM866(_), scheme_build_path (2 , a ) ); 
      }
      be = (((Scheme_Simple_Object * ) (be ) ) -> u . pair_val . cdr ) ; 
    }
  }

  if (cache )
    FUNCCALL(SETUP_XfOrM860(_), scheme_hash_set (cache , orig_obj , obj ) ); 

  RET_VALUE_START (obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4595 "bc/src/file.c"
Scheme_Object * scheme_maybe_build_path (Scheme_Object * base , Scheme_Object * elem ) 
{
  Scheme_Object * a [2 ] ; 
  Scheme_Config * __funcarg135 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(elem, 3), PUSH(base, 4)));
# define XfOrM885_COUNT (5)
# define SETUP_XfOrM885(x) SETUP(XfOrM885_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 4599 "bc/src/file.c"
  if (! base )
    base = (__funcarg135 = FUNCCALL(SETUP_XfOrM885(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg135 , MZCONFIG_CURRENT_DIRECTORY ) )) ; 

  if (((elem ) == (same_symbol ) ) 
  || ((elem ) == (up_symbol ) ) ) {
  }
  else if ((Scheme_Type ) (((((intptr_t ) (elem ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (elem ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
#   define XfOrM887_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM887(x) SETUP_XfOrM885(x)

# 4606 "bc/src/file.c"
    a [0 ] = elem ; 
    elem = FUNCCALL(SETUP_XfOrM887(_), bytes_to_path_element (1 , a ) ); 
  }

# 4608 "bc/src/file.c"
  else 
  elem = ((void * ) 0 ) ; 

  if (elem ) {
#   define XfOrM886_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM886(x) SETUP_XfOrM885(x)

# 4612 "bc/src/file.c"
    a [0 ] = base ; 
    a [1 ] = elem ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM886(_), scheme_build_path (2 , a ) )) RET_VALUE_END ; 
  }

# 4615 "bc/src/file.c"
  else 
  RET_VALUE_START (base ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4619 "bc/src/file.c"
static Scheme_Object * filesystem_root_list (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * first = scheme_null ; 
  Scheme_Object * last = ((void * ) 0 ) , * v ; 
  char * * roots ; 
  int i ; 

# 521 "bc/src/file.c"
  Scheme_Object * __funcarg137 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(roots, 0), PUSH(first, 1), PUSH(v, 2), PUSH(last, 3)));
# define XfOrM889_COUNT (4)
# define SETUP_XfOrM889(x) SETUP(XfOrM889_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  roots = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM889(_), scheme_security_check_file ("filesystem-root-list" , ((void * ) 0 ) , 0x10 ) )
# 4626 "bc/src/file.c"
  ; 

  roots = (rktio_filesystem_roots (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
  for (i = 0 ; roots [i ] ; i ++ ) {
#   define XfOrM891_COUNT (0+XfOrM889_COUNT)
#   define SETUP_XfOrM891(x) SETUP_XfOrM889(x)

# 4630 "bc/src/file.c"
    v = (__funcarg137 = FUNCCALL(SETUP_XfOrM891(_), scheme_make_sized_offset_path (roots [i ] , 0 , - 1 , 1 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg137 , scheme_null ) )) ; 
    if (last )
      (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
    else 
    first = v ; 
    last = v ; 
    FUNCCALL(SETUP_XfOrM891(_), free (roots [i ] ) ); 
  }
  FUNCCALL(SETUP_XfOrM889(_), free (roots ) )
  ; 

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4644 "bc/src/file.c"
static Scheme_Object * make_directory (int argc , Scheme_Object * argv [] ) 
{
  char * filename ; 
  int copied ; 
  int perms = 511 ; 

# 3303 "bc/src/file.c"
  char * __funcarg139 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg138 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(filename, 0), PUSH(argv, 1)));
# define XfOrM892_COUNT (2)
# define SETUP_XfOrM892(x) SETUP(XfOrM892_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 

# 4650 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-directory" , "path-string?" , 0 , argc , argv ) ); 
  if (argc > 1 ) {
#   define XfOrM896_COUNT (0+XfOrM892_COUNT)
#   define SETUP_XfOrM896(x) SETUP_XfOrM892(x)

# 4653 "bc/src/file.c"
    if ((((intptr_t ) (argv [1 ] ) ) & 0x1 ) 
    && ((((intptr_t ) (argv [1 ] ) ) >> 1 ) >= 0 ) 
    && ((((intptr_t ) (argv [1 ] ) ) >> 1 ) <= 65535 ) ) {
      perms = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
    }

# 4657 "bc/src/file.c"
    else FUNCCALL_EMPTY(scheme_wrong_contract ("make-directory" , "(or/c symbol? (integer-in 0 65535))" , 1 , argc , argv ) )
    ; 
  }

  filename = FUNCCALL(SETUP_XfOrM892(_), scheme_expand_string_filename (argv [0 ] , "make-directory" , & copied , 0x2 ) )


  ; 

  if (! (rktio_make_directory_with_permissions (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename , perms ) ) ) {
#   define XfOrM893_COUNT (0+XfOrM892_COUNT)
#   define SETUP_XfOrM893(x) SETUP_XfOrM892(x)

# 4667 "bc/src/file.c"
    if (FUNCCALL(SETUP_XfOrM893(_), scheme_last_error_is_racket (RKTIO_ERROR_EXISTS ) )) {
#     define XfOrM895_COUNT (0+XfOrM893_COUNT)
#     define SETUP_XfOrM895(x) SETUP_XfOrM893(x)
      (__funcarg139 = FUNCCALL(SETUP_XfOrM895(_), filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM_EXISTS , "make-directory: cannot make directory;\n" " the path already exists\n" "  path: %q" , __funcarg139 ) )) 

      ; 
    }

# 4673 "bc/src/file.c"
    else {
#     define XfOrM894_COUNT (0+XfOrM893_COUNT)
#     define SETUP_XfOrM894(x) SETUP_XfOrM893(x)
      (__funcarg138 = FUNCCALL_EMPTY(filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "make-directory: cannot make directory\n" "  path: %q\n" "  system error: %R" , __funcarg138 ) )) 

      ; 
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4685 "bc/src/file.c"
static Scheme_Object * delete_directory (int argc , Scheme_Object * argv [] ) 
{
  char * filename ; 
  char * current_directory ; 

# 3313 "bc/src/file.c"
  int __funcarg141 ; 

# 3303 "bc/src/file.c"
  char * __funcarg140 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(current_directory, 0), PUSH(filename, 1), PUSH(argv, 2)));
# define XfOrM898_COUNT (3)
# define SETUP_XfOrM898(x) SETUP(XfOrM898_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 
  current_directory = NULLED_OUT ; 

# 4690 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("delete-directory" , "path-string?" , 0 , argc , argv ) ); 

  filename = FUNCCALL(SETUP_XfOrM898(_), scheme_expand_string_filename (argv [0 ] , "delete-directory" , ((void * ) 0 ) , 0x8 ) )


  ; 








  current_directory = ((void * ) 0 ) ; 


  if (! (__funcarg141 = FUNCCALL(SETUP_XfOrM898(_), scheme_can_enable_write_permission () ), (rktio_delete_directory (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename , current_directory , __funcarg141 ) ) ) ) 
  {
#   define XfOrM899_COUNT (0+XfOrM898_COUNT)
#   define SETUP_XfOrM899(x) SETUP_XfOrM898(x)
    (__funcarg140 = FUNCCALL_EMPTY(filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "delete-directory: cannot delete directory\n" "  path: %q\n" "  system error: %R" , __funcarg140 ) )) 

    ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4720 "bc/src/file.c"
static Scheme_Object * make_link (int argc , Scheme_Object * argv [] ) 
{
  char * src ; 
  Scheme_Object * dest ; 
  int dest_is_dir , copied ; 

# 3303 "bc/src/file.c"
  char * __funcarg143 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg142 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(dest, 0), PUSH(src, 1), PUSH(argv, 2)));
# define XfOrM900_COUNT (3)
# define SETUP_XfOrM900(x) SETUP(XfOrM900_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  src = NULLED_OUT ; 
  dest = NULLED_OUT ; 

# 4726 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-file-or-directory-link" , "path-string?" , 0 , argc , argv ) ); 
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-file-or-directory-link" , "path-string?" , 0 , argc , argv ) ); 

  dest = argv [0 ] ; 

  dest = (((((((intptr_t ) (dest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (dest ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (dest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (dest ) ) -> type ) <= scheme_windows_path_type ) ) ? dest : FUNCCALL(SETUP_XfOrM900(_), scheme_char_string_to_path (dest ) )) ; 
  if (FUNCCALL(SETUP_XfOrM900(_), has_null ((((Scheme_Simple_Object * ) (dest ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (dest ) ) -> u . byte_str_val . tag_val ) ) )) {
#   define XfOrM904_COUNT (0+XfOrM900_COUNT)
#   define SETUP_XfOrM904(x) SETUP_XfOrM900(x)
    FUNCCALL(SETUP_XfOrM904(_), raise_null_error ("make-file-or-directory-link" , dest , "" ) )
# 4735 "bc/src/file.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  src = FUNCCALL(SETUP_XfOrM900(_), scheme_expand_string_filename (argv [1 ] , "make-file-or-directory-link" , & copied , 0x2 ) )


  ; 
  FUNCCALL(SETUP_XfOrM900(_), scheme_security_check_file_link ("make-file-or-directory-link" , src , (((Scheme_Simple_Object * ) (dest ) ) -> u . byte_str_val . string_val ) ) )


  ; 









  dest_is_dir = 0 ; 


  if (! (rktio_make_link (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , src , (((Scheme_Simple_Object * ) (dest ) ) -> u . byte_str_val . string_val ) , dest_is_dir ) ) ) {
#   define XfOrM901_COUNT (0+XfOrM900_COUNT)
#   define SETUP_XfOrM901(x) SETUP_XfOrM900(x)

# 4760 "bc/src/file.c"
    if (FUNCCALL(SETUP_XfOrM901(_), scheme_last_error_is_racket (RKTIO_ERROR_EXISTS ) )) {
#     define XfOrM903_COUNT (0+XfOrM901_COUNT)
#     define SETUP_XfOrM903(x) SETUP_XfOrM901(x)
      (__funcarg143 = FUNCCALL(SETUP_XfOrM903(_), filename_for_error (argv [1 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM_EXISTS , "make-file-or-directory-link: cannot make link;\n" " the path already exists\n" "  path: %q" , __funcarg143 ) )) 

      ; 
    }

# 4766 "bc/src/file.c"
    else {
#     define XfOrM902_COUNT (0+XfOrM901_COUNT)
#     define SETUP_XfOrM902(x) SETUP_XfOrM901(x)
      (__funcarg142 = FUNCCALL_EMPTY(filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "make-file-or-directory-link: cannot make link\n" "  path: %q\n" "  system error: %R" , __funcarg142 ) )) 

      ; 
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4778 "bc/src/file.c"
static Scheme_Object * file_modify_seconds (int argc , Scheme_Object * * argv ) 
{
  char * file ; 
  int set_time = 0 ; 
  intptr_t mtime ; 

# 3303 "bc/src/file.c"
  char * __funcarg144 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(file, 0), PUSH(argv, 1)));
# define XfOrM905_COUNT (2)
# define SETUP_XfOrM905(x) SETUP(XfOrM905_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  file = NULLED_OUT ; 

# 4784 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("file-or-directory-modify-seconds" , "path-string?" , 0 , argc , argv ) ); 

  set_time = ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) ; 

  file = FUNCCALL(SETUP_XfOrM905(_), scheme_expand_string_filename (argv [0 ] , "file-or-directory-modify-seconds" , ((void * ) 0 ) , (set_time ? 0x2 : 0x1 ) ) )




  ; 

  if (set_time ) {
#   define XfOrM911_COUNT (0+XfOrM905_COUNT)
#   define SETUP_XfOrM911(x) SETUP_XfOrM905(x)

# 4797 "bc/src/file.c"
    if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
#     define XfOrM913_COUNT (0+XfOrM911_COUNT)
#     define SETUP_XfOrM913(x) SETUP_XfOrM911(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("file-or-directory-modify-seconds" , "(or/c exact-integer? #f)" , 1 , argc , argv ) )
# 4798 "bc/src/file.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (! (scheme_get_int_val (argv [1 ] , & mtime ) ) ) {
#     define XfOrM912_COUNT (0+XfOrM911_COUNT)
#     define SETUP_XfOrM912(x) SETUP_XfOrM911(x)
      FUNCCALL_EMPTY(scheme_contract_error ("file-or-directory-modify-seconds" , "integer value is out-of-range" , "value" , 1 , argv [1 ] , ((void * ) 0 ) ) )
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 4808 "bc/src/file.c"
  else 
  mtime = 0 ; 

  if (argc > 2 ) {
#   define XfOrM910_COUNT (0+XfOrM905_COUNT)
#   define SETUP_XfOrM910(x) SETUP_XfOrM905(x)
    FUNCCALL(SETUP_XfOrM910(_), scheme_check_proc_arity ("file-or-directory-modify-seconds" , 0 , 2 , argc , argv ) )
# 4812 "bc/src/file.c"
    ; 
  }

  if (! set_time ) {
    rktio_timestamp_t * ts ; 
#   define XfOrM908_COUNT (0+XfOrM905_COUNT)
#   define SETUP_XfOrM908(x) SETUP_XfOrM905(x)
    ts = NULLED_OUT ; 

# 4818 "bc/src/file.c"
    ts = (rktio_get_file_modify_seconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , file ) ) ; 

    if (ts ) {
      intptr_t ts_v = * ts ; 
#     define XfOrM909_COUNT (0+XfOrM908_COUNT)
#     define SETUP_XfOrM909(x) SETUP_XfOrM908(x)
      FUNCCALL(SETUP_XfOrM909(_), free (ts ) )
# 4822 "bc/src/file.c"
      ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_integer_value ((intptr_t ) ts_v ) )) RET_VALUE_EMPTY_END ; 
    }
  }

# 4825 "bc/src/file.c"
  else {
#   define XfOrM907_COUNT (0+XfOrM905_COUNT)
#   define SETUP_XfOrM907(x) SETUP_XfOrM905(x)

# 4826 "bc/src/file.c"
    if (rktio_set_file_modify_seconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , file , mtime ) ) 
      RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }

  if (argc > 2 ) {
#   define XfOrM906_COUNT (0+XfOrM905_COUNT)
#   define SETUP_XfOrM906(x) SETUP_XfOrM905(x)

# 4831 "bc/src/file.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (argv [2 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
  }
  (__funcarg144 = FUNCCALL_EMPTY(filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "file-or-directory-modify-seconds: error %s file/directory time\n" "  path: %q\n" "  system error: %R" , set_time ? "setting" : "getting" , __funcarg144 ) )) 





  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4844 "bc/src/file.c"
static Scheme_Object * file_or_dir_permissions (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * l = scheme_null ; 
  char * filename ; 
  int as_bits = 0 , set_bits = 0 , new_bits = 0 ; 
  int r = 0 ; 

# 3303 "bc/src/file.c"
  char * __funcarg146 = NULLED_OUT ; 

# 3303 "bc/src/file.c"
  char * __funcarg145 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(filename, 1), PUSH(l, 2)));
# define XfOrM914_COUNT (3)
# define SETUP_XfOrM914(x) SETUP(XfOrM914_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 

# 4851 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("file-or-directory-permissions" , "path-string?" , 0 , argc , argv ) ); 
  if (argc > 1 ) {
#   define XfOrM920_COUNT (0+XfOrM914_COUNT)
#   define SETUP_XfOrM920(x) SETUP_XfOrM914(x)

# 4854 "bc/src/file.c"
    l = argv [1 ] ; 
    if (((l ) ) == (scheme_false ) )  {
    }

# 4856 "bc/src/file.c"
    else if (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! ((& ((Scheme_Symbol * ) (l ) ) -> iso ) -> so . keyex & 0x3 ) 
    && ! (strcmp ("bits" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (l ) ) ) -> s ) ) ) ) {
      as_bits = 1 ; 
    }

# 4859 "bc/src/file.c"
    else {
#     define XfOrM921_COUNT (0+XfOrM920_COUNT)
#     define SETUP_XfOrM921(x) SETUP_XfOrM920(x)

# 4860 "bc/src/file.c"
      as_bits = - 1 ; 
      l = argv [1 ] ; 
      if ((((intptr_t ) (l ) ) & 0x1 ) 
      && ((((intptr_t ) (l ) ) >> 1 ) >= 0 ) 
      && ((((intptr_t ) (l ) ) >> 1 ) <= 0xFFFF ) ) {
        set_bits = 1 ; 
        new_bits = (((intptr_t ) (l ) ) >> 1 ) ; 
      }

# 4867 "bc/src/file.c"
      else FUNCCALL_EMPTY(scheme_wrong_contract ("file-or-directory-permissions" , "(or/c #f 'bits (integer-in 0 65535))" , 1 , argc , argv ) )


      ; 
    }
  }

  filename = FUNCCALL(SETUP_XfOrM914(_), scheme_expand_string_filename (argv [0 ] , "file-or-directory-permissions" , ((void * ) 0 ) , (set_bits ? 0x2 : 0x1 ) ) )




  ; 

  if (! set_bits ) {
#   define XfOrM917_COUNT (0+XfOrM914_COUNT)
#   define SETUP_XfOrM917(x) SETUP_XfOrM914(x)

# 4882 "bc/src/file.c"
    r = (rktio_get_file_or_directory_permissions (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename , as_bits ) ) ; 
    if (r != (- 1 ) ) {
#     define XfOrM918_COUNT (0+XfOrM917_COUNT)
#     define SETUP_XfOrM918(x) SETUP_XfOrM917(x)

# 4884 "bc/src/file.c"
      if (as_bits )
        RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
      else {
#       define XfOrM919_COUNT (0+XfOrM918_COUNT)
#       define SETUP_XfOrM919(x) SETUP_XfOrM918(x)

# 4887 "bc/src/file.c"
        if (r & 0x4 )
          l = FUNCCALL(SETUP_XfOrM919(_), scheme_make_pair (read_symbol , l ) ); 
        if (r & 0x2 )
          l = FUNCCALL(SETUP_XfOrM919(_), scheme_make_pair (write_symbol , l ) ); 
        if (r & 0x1 )
          l = FUNCCALL(SETUP_XfOrM919(_), scheme_make_pair (execute_symbol , l ) ); 
        RET_VALUE_START (l ) RET_VALUE_END ; 
      }
    }
  }

# 4896 "bc/src/file.c"
  else {
#   define XfOrM915_COUNT (0+XfOrM914_COUNT)
#   define SETUP_XfOrM915(x) SETUP_XfOrM914(x)

# 4897 "bc/src/file.c"
    if (rktio_set_file_or_directory_permissions (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename , new_bits ) ) 
      RET_VALUE_START (scheme_void ) RET_VALUE_END ; 

    if (FUNCCALL(SETUP_XfOrM915(_), scheme_last_error_is_racket (RKTIO_ERROR_BAD_PERMISSION ) )) {
#     define XfOrM916_COUNT (0+XfOrM915_COUNT)
#     define SETUP_XfOrM916(x) SETUP_XfOrM915(x)
      (__funcarg146 = FUNCCALL(SETUP_XfOrM916(_), filename_for_error (argv [0 ] ) )


      , FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "file-or-directory-permissions: update failed due to" " unsupported bit combination\n" "  path: %s\n" "  permission value: %d" , __funcarg146 , new_bits ) )) 
      ; 
    }
  }
  (__funcarg145 = FUNCCALL_EMPTY(filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "file-or-directory-permissions: %s failed\n" "  path: %q\n" "  system error: %R" , set_bits ? "update" : "access" , __funcarg145 ) )) 





  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4921 "bc/src/file.c"
static Scheme_Object * file_or_dir_type (int argc , Scheme_Object * argv [] ) 
{
  char * filename ; 
  int type ; 

# 3303 "bc/src/file.c"
  char * __funcarg147 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(filename, 0), PUSH(argv, 1)));
# define XfOrM925_COUNT (2)
# define SETUP_XfOrM925(x) SETUP(XfOrM925_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 

# 4926 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("file-or-directory-type" , "path-string?" , 0 , argc , argv ) ); 

  filename = FUNCCALL(SETUP_XfOrM925(_), scheme_expand_string_filename (argv [0 ] , "file-or-directory-type" , ((void * ) 0 ) , 0x10 ) )


  ; 

  if (FUNCCALL(SETUP_XfOrM925(_), scheme_is_special_filename (filename , 0 ) ))
    type = 1 ; 
  else 
  type = (rktio_file_type (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename ) ) ; 

  if (type == 1 )
    RET_VALUE_START (file_symbol ) RET_VALUE_END ; 
  else if (type == 2 )
    RET_VALUE_START (directory_symbol ) RET_VALUE_END ; 
  else if (type == 3 )
    RET_VALUE_START (link_symbol ) RET_VALUE_END ; 
  else if (type == 4 )
    RET_VALUE_START (directory_link_symbol ) RET_VALUE_END ; 
  else {
#   define XfOrM926_COUNT (0+XfOrM925_COUNT)
#   define SETUP_XfOrM926(x) SETUP_XfOrM925(x)

# 4948 "bc/src/file.c"
    ((void ) sizeof ((type == (- 1 ) ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM927_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM927(x) SETUP_XfOrM926(x)

# 4948 "bc/src/file.c" 3
      if (type == (- 1 ) )

# 4948 "bc/src/file.c" 3
      ; 

# 4948 "bc/src/file.c" 3
      else FUNCCALL(SETUP_XfOrM927(_), __assert_fail ("type == (-1)" , "bc/src/file.c" , 4948 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 4948 "bc/src/file.c"
    ; 
    if ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) )
      (__funcarg147 = FUNCCALL_EMPTY(filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "file-or-directory-type: access failed\n" "  path: %q\n" "  system error: %R" , __funcarg147 ) )) 



    ; 
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4959 "bc/src/file.c"
static Scheme_Object * file_identity (int argc , Scheme_Object * argv [] ) 
{
  char * filename ; 
  int as_link = 0 ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(filename, 0), PUSH(argv, 1)));
# define XfOrM928_COUNT (2)
# define SETUP_XfOrM928(x) SETUP(XfOrM928_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 

# 4964 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("file-or-directory-identity" , "path-string?" , 0 , argc , argv ) ); 

  filename = FUNCCALL(SETUP_XfOrM928(_), scheme_expand_string_filename (argv [0 ] , "file-or-directory-identity" , ((void * ) 0 ) , 0x10 ) )


  ; 

  if (argc > 1 )
    as_link = (! (((argv [1 ] ) ) == (scheme_false ) ) ) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_get_fd_identity (((void * ) 0 ) , as_link , filename , 0 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4978 "bc/src/file.c"
static Scheme_Object * make_nanoseconds (uintptr_t secs , uintptr_t nsecs ) {
  Scheme_Object * __funcarg150 = NULLED_OUT ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  Scheme_Object * __funcarg148 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(__funcarg148, 0)));
# define XfOrM929_COUNT (1)
# define SETUP_XfOrM929(x) SETUP(XfOrM929_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4979 "bc/src/file.c"
  RET_VALUE_START ((__funcarg148 = (__funcarg150 = FUNCCALL(SETUP_XfOrM929(_), scheme_make_integer_value_from_unsigned (secs ) ), FUNCCALL_AGAIN(scheme_bin_mult (__funcarg150 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1000000000 ) ) ) << 1 ) | 0x1 ) ) ) )) 
  , __funcarg149 = FUNCCALL(SETUP_XfOrM929(_), scheme_make_integer_value_from_unsigned (nsecs ) ), FUNCCALL_EMPTY(scheme_bin_plus (__funcarg148 , __funcarg149 ) )) ) 
# 4979 "bc/src/file.c"
  RET_VALUE_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4984 "bc/src/file.c"
static Scheme_Object * file_stat (int argc , Scheme_Object * argv [] ) 
{
  char * filename ; 
  int as_link = 0 ; 
  rktio_stat_t * r ; 
  Scheme_Hash_Tree * ht ; 

# 3303 "bc/src/file.c"
  char * __funcarg169 = NULLED_OUT ; 
  Scheme_Object * __funcarg168 = NULLED_OUT ; 
  Scheme_Object * __funcarg167 = NULLED_OUT ; 
  Scheme_Object * __funcarg166 = NULLED_OUT ; 
  Scheme_Object * __funcarg165 = NULLED_OUT ; 
  Scheme_Object * __funcarg164 = NULLED_OUT ; 
  Scheme_Object * __funcarg163 = NULLED_OUT ; 
  Scheme_Object * __funcarg162 = NULLED_OUT ; 
  Scheme_Object * __funcarg161 = NULLED_OUT ; 
  Scheme_Object * __funcarg160 = NULLED_OUT ; 
  Scheme_Object * __funcarg159 = NULLED_OUT ; 
  Scheme_Object * __funcarg158 = NULLED_OUT ; 

# 4978 "bc/src/file.c"
  Scheme_Object * __funcarg157 = NULLED_OUT ; 
  Scheme_Object * __funcarg156 = NULLED_OUT ; 

# 4978 "bc/src/file.c"
  Scheme_Object * __funcarg155 = NULLED_OUT ; 
  Scheme_Object * __funcarg154 = NULLED_OUT ; 

# 4978 "bc/src/file.c"
  Scheme_Object * __funcarg153 = NULLED_OUT ; 
  Scheme_Object * __funcarg152 = NULLED_OUT ; 

# 4978 "bc/src/file.c"
  Scheme_Object * __funcarg151 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(filename, 1), PUSH(argv, 2), PUSH(ht, 3)));
# define XfOrM930_COUNT (4)
# define SETUP_XfOrM930(x) SETUP(XfOrM930_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  filename = NULLED_OUT ; 
  r = NULLED_OUT ; 
  ht = NULLED_OUT ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("file-or-directory-identity" , "path-string?" , 0 , argc , argv ) ); 

  filename = FUNCCALL(SETUP_XfOrM930(_), scheme_expand_string_filename (argv [0 ] , "file-or-directory-identity" , ((void * ) 0 ) , 0x10 ) )


  ; 

  if (argc > 1 )
    as_link = (! (((argv [1 ] ) ) == (scheme_false ) ) ) ; 

  r = (rktio_file_or_directory_stat (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename , ! as_link ) ) ; 

  if (! r ) {
#   define XfOrM933_COUNT (0+XfOrM930_COUNT)
#   define SETUP_XfOrM933(x) SETUP_XfOrM930(x)
    (__funcarg169 = FUNCCALL(SETUP_XfOrM933(_), filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "file-or-directory-stat: cannot get stat result\n" "  path: %q\n" "  system error: %R" , __funcarg169 ) )) 

    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  ht = (scheme_make_hash_tree (0 ) ) ; 

  ht = (__funcarg168 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> device_id ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , device_id_symbol , __funcarg168 ) )) ; 
  ht = (__funcarg167 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> inode ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , inode_symbol , __funcarg167 ) )) ; 
  ht = (__funcarg166 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> mode ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , mode_symbol , __funcarg166 ) )) ; 
  ht = (__funcarg165 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> hardlink_count ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , hardlink_count_symbol , __funcarg165 ) )) ; 
  ht = (__funcarg164 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> user_id ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , user_id_symbol , __funcarg164 ) )) ; 
  ht = (__funcarg163 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> group_id ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , group_id_symbol , __funcarg163 ) )) ; 
  ht = (__funcarg162 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> device_id_for_special_file ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , device_id_for_special_file_symbol , __funcarg162 ) )) ; 
  ht = (__funcarg161 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> size ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , size_symbol , __funcarg161 ) )) ; 
  ht = (__funcarg160 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> block_size ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , block_size_symbol , __funcarg160 ) )) ; 
  ht = (__funcarg159 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> block_count ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , block_count_symbol , __funcarg159 ) )) ; 
  ht = (__funcarg158 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> access_time_seconds ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , access_time_seconds_symbol , __funcarg158 ) )) ; 
  ht = (__funcarg157 = FUNCCALL(SETUP_XfOrM930(_), make_nanoseconds (r -> access_time_seconds , r -> access_time_nanoseconds ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , access_time_nanoseconds_symbol , __funcarg157 ) )) ; 
  ht = (__funcarg156 = FUNCCALL(SETUP_XfOrM930(_), scheme_make_integer_value_from_unsigned (r -> modify_time_seconds ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , modify_time_seconds_symbol , __funcarg156 ) )) ; 
  ht = (__funcarg155 = FUNCCALL(SETUP_XfOrM930(_), make_nanoseconds (r -> modify_time_seconds , r -> modify_time_nanoseconds ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , modify_time_nanoseconds_symbol , __funcarg155 ) )) ; 

  if (r -> ctime_is_change_time ) {
#   define XfOrM932_COUNT (0+XfOrM930_COUNT)
#   define SETUP_XfOrM932(x) SETUP_XfOrM930(x)

# 5031 "bc/src/file.c"
    ht = (__funcarg154 = FUNCCALL(SETUP_XfOrM932(_), scheme_make_integer_value_from_unsigned (r -> ctime_seconds ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , change_time_seconds_symbol , __funcarg154 ) )) ; 
    ht = (__funcarg153 = FUNCCALL(SETUP_XfOrM932(_), make_nanoseconds (r -> ctime_seconds , r -> ctime_nanoseconds ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , change_time_nanoseconds_symbol , __funcarg153 ) )) ; 
    ht = FUNCCALL_AGAIN(scheme_hash_tree_set (ht , creation_time_seconds_symbol , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ); 
    ht = FUNCCALL_AGAIN(scheme_hash_tree_set (ht , creation_time_nanoseconds_symbol , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ); 
  }

# 5035 "bc/src/file.c"
  else {
#   define XfOrM931_COUNT (0+XfOrM930_COUNT)
#   define SETUP_XfOrM931(x) SETUP_XfOrM930(x)

# 5036 "bc/src/file.c"
    ht = (__funcarg152 = FUNCCALL(SETUP_XfOrM931(_), scheme_make_integer_value_from_unsigned (r -> ctime_seconds ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , creation_time_seconds_symbol , __funcarg152 ) )) ; 
    ht = (__funcarg151 = FUNCCALL(SETUP_XfOrM931(_), make_nanoseconds (r -> ctime_seconds , r -> ctime_nanoseconds ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (ht , creation_time_nanoseconds_symbol , __funcarg151 ) )) ; 
    ht = FUNCCALL_AGAIN(scheme_hash_tree_set (ht , change_time_seconds_symbol , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ); 
    ht = FUNCCALL_AGAIN(scheme_hash_tree_set (ht , change_time_nanoseconds_symbol , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ); 
  }
  (
  rktio_free (r ) ) ; 

  RET_VALUE_START ((Scheme_Object * ) ht ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5047 "bc/src/file.c"
static Scheme_Object * file_size (int argc , Scheme_Object * argv [] ) 
{
  rktio_filesize_t * sz ; 
  char * filename ; 

# 3303 "bc/src/file.c"
  char * __funcarg170 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sz, 0), PUSH(filename, 1), PUSH(argv, 2)));
# define XfOrM934_COUNT (3)
# define SETUP_XfOrM934(x) SETUP(XfOrM934_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sz = NULLED_OUT ; 
  filename = NULLED_OUT ; 

# 5052 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("file-size" , "path-string?" , 0 , argc , argv ) ); 

  filename = FUNCCALL(SETUP_XfOrM934(_), scheme_expand_string_filename (argv [0 ] , "file-size" , ((void * ) 0 ) , 0x1 ) )


  ; 

  sz = (rktio_file_size (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , filename ) ) ; 
  if (sz ) {
    mzlonglong szv = * sz ; 
#   define XfOrM935_COUNT (0+XfOrM934_COUNT)
#   define SETUP_XfOrM935(x) SETUP_XfOrM934(x)
    FUNCCALL(SETUP_XfOrM935(_), free (sz ) )
# 5063 "bc/src/file.c"
    ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_integer_value_from_long_long (szv ) )) RET_VALUE_EMPTY_END ; 
  }
  (__funcarg170 = FUNCCALL_EMPTY(filename_for_error (argv [0 ] ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_FILESYSTEM , "file-size: cannot get size\n" "  path: %q\n" "  system error: %R" , __funcarg170 ) )) 




  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5076 "bc/src/file.c"
static Scheme_Object * cwd_check (int argc , Scheme_Object * * argv ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
# define XfOrM936_COUNT (0)
# define SETUP_XfOrM936(x) SETUP(XfOrM936_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5078 "bc/src/file.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) ) {
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 5080 "bc/src/file.c"
  else {
    char * expanded ; 
    Scheme_Object * ed ; 
    BLOCK_SETUP((PUSH(ed, 0+XfOrM936_COUNT), PUSH(expanded, 1+XfOrM936_COUNT)));
#   define XfOrM937_COUNT (2+XfOrM936_COUNT)
#   define SETUP_XfOrM937(x) SETUP(XfOrM937_COUNT)
    expanded = NULLED_OUT ; 
    ed = NULLED_OUT ; 

# 5084 "bc/src/file.c"
    expanded = FUNCCALL(SETUP_XfOrM937(_), scheme_expand_string_filename (argv [0 ] , "current-directory" , ((void * ) 0 ) , 0x10 ) ); 
    ed = FUNCCALL_AGAIN(scheme_make_sized_path (expanded , strlen (expanded ) , 1 ) ); 

    ed = FUNCCALL_AGAIN(do_simplify_path (ed , scheme_null , 0 , 1 , 0 , 0 , scheme_unix_path_type , 1 ) ); 

    ed = FUNCCALL_AGAIN(scheme_path_to_directory_path (ed ) ); 

    RET_VALUE_START (ed ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5095 "bc/src/file.c"
static Scheme_Object * current_directory (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM939_COUNT (1)
# define SETUP_XfOrM939(x) SETUP(XfOrM939_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5097 "bc/src/file.c"
  if (! argc )
    FUNCCALL(SETUP_XfOrM939(_), scheme_security_check_file ("current-directory" , ((void * ) 0 ) , 0x10 ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_param_config2 ("current-directory" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_CURRENT_DIRECTORY ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , cwd_check , "path-string?" , 1 ) )) RET_VALUE_EMPTY_END 



  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5107 "bc/src/file.c"
Scheme_Object * scheme_current_directory (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5109 "bc/src/file.c"
  return current_directory (argc , argv ) ; 
}

static Scheme_Object * current_user_directory (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM941_COUNT (1)
# define SETUP_XfOrM941(x) SETUP(XfOrM941_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5114 "bc/src/file.c"
  if (! argc )
    FUNCCALL(SETUP_XfOrM941(_), scheme_security_check_file ("current-directory-for-user" , ((void * ) 0 ) , 0x10 ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_param_config2 ("current-directory-for-user" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_CURRENT_USER_DIRECTORY ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , cwd_check , "path-string?" , 1 ) )) RET_VALUE_EMPTY_END 



  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5124 "bc/src/file.c"
static Scheme_Object * current_force_delete_perms (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5126 "bc/src/file.c"
  return scheme_param_config ("current-force-delete-permissions" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_FORCE_DELETE_PERMS ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}



Scheme_Object * scheme_get_run_cmd (void ) 
{
  /* No conversion */

# 5135 "bc/src/file.c"
  if (! run_cmd ) {
    return scheme_make_path ("racket" ) ; 
  }
  return run_cmd ; 
}

static Scheme_Object * 
find_system_path (int argc , Scheme_Object * * argv ) 
{
  int which ; 
  int should_be_dir = 1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(1);
# define XfOrM945_COUNT (0)
# define SETUP_XfOrM945(x) SETUP(XfOrM945_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5147 "bc/src/file.c"
  if (argv [0 ] == temp_dir_symbol )
    which = RKTIO_PATH_TEMP_DIR ; 
  else if (argv [0 ] == home_dir_symbol )
    which = RKTIO_PATH_HOME_DIR ; 
  else if (argv [0 ] == doc_dir_symbol )
    which = RKTIO_PATH_DOC_DIR ; 
  else if (argv [0 ] == desk_dir_symbol )
    which = RKTIO_PATH_DESK_DIR ; 
  else if (argv [0 ] == pref_dir_symbol )
    which = RKTIO_PATH_PREF_DIR ; 
  else if (argv [0 ] == init_dir_symbol )
    which = RKTIO_PATH_INIT_DIR ; 
  else if (argv [0 ] == pref_file_symbol ) {
    which = RKTIO_PATH_PREF_FILE ; 
    should_be_dir = 0 ; 
  }

# 5162 "bc/src/file.c"
  else if (argv [0 ] == init_file_symbol ) {
    which = RKTIO_PATH_INIT_FILE ; 
    should_be_dir = 0 ; 
  }

# 5165 "bc/src/file.c"
  else if (argv [0 ] == sys_dir_symbol )
    which = RKTIO_PATH_SYS_DIR ; 
  else if (argv [0 ] == exec_file_symbol ) {
#   define XfOrM957_COUNT (0+XfOrM945_COUNT)
#   define SETUP_XfOrM957(x) SETUP_XfOrM945(x)

# 5168 "bc/src/file.c"
    if (! exec_cmd ) {
#     define XfOrM958_COUNT (0+XfOrM957_COUNT)
#     define SETUP_XfOrM958(x) SETUP_XfOrM957(x)

# 5169 "bc/src/file.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_path ("racket" ) )) RET_VALUE_EMPTY_END ; 
    }
    RET_VALUE_START (exec_cmd ) RET_VALUE_END ; 
  }

# 5172 "bc/src/file.c"
  else if (argv [0 ] == run_file_symbol ) {
#   define XfOrM956_COUNT (0+XfOrM945_COUNT)
#   define SETUP_XfOrM956(x) SETUP_XfOrM945(x)

# 5173 "bc/src/file.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_get_run_cmd () )) RET_VALUE_EMPTY_END ; 
  }

# 5174 "bc/src/file.c"
  else if ((argv [0 ] == host_collects_dir_symbol ) && host_collects_path )
    RET_VALUE_START (host_collects_path ) RET_VALUE_END ; 
  else if ((argv [0 ] == collects_dir_symbol ) || (argv [0 ] == host_collects_dir_symbol ) ) {
#   define XfOrM954_COUNT (0+XfOrM945_COUNT)
#   define SETUP_XfOrM954(x) SETUP_XfOrM945(x)

# 5177 "bc/src/file.c"
    if (! collects_path ) {
#     define XfOrM955_COUNT (0+XfOrM954_COUNT)
#     define SETUP_XfOrM955(x) SETUP_XfOrM954(x)

# 5178 "bc/src/file.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_path ("collects" ) )) RET_VALUE_EMPTY_END ; 
    }
    RET_VALUE_START (collects_path ) RET_VALUE_END ; 
  }

# 5181 "bc/src/file.c"
  else if ((argv [0 ] == host_config_dir_symbol ) && host_config_path )
    RET_VALUE_START (host_config_path ) RET_VALUE_END ; 
  else if ((argv [0 ] == config_dir_symbol ) || (argv [0 ] == host_config_dir_symbol ) ) {
#   define XfOrM952_COUNT (0+XfOrM945_COUNT)
#   define SETUP_XfOrM952(x) SETUP_XfOrM945(x)

# 5184 "bc/src/file.c"
    if (! config_path ) {
#     define XfOrM953_COUNT (0+XfOrM952_COUNT)
#     define SETUP_XfOrM953(x) SETUP_XfOrM952(x)

# 5185 "bc/src/file.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_path ("lib" ) )) RET_VALUE_EMPTY_END ; 
    }
    RET_VALUE_START (config_path ) RET_VALUE_END ; 
  }

# 5188 "bc/src/file.c"
  else if (argv [0 ] == orig_dir_symbol ) {
    RET_VALUE_START (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> original_pwd_ ) ) RET_VALUE_END ; 
  }

# 5190 "bc/src/file.c"
  else if (argv [0 ] == addon_dir_symbol ) {
    if (addon_dir )

# 5191 "bc/src/file.c"
    RET_VALUE_START (addon_dir ) RET_VALUE_END ; 
    which = RKTIO_PATH_ADDON_DIR ; 
  }

# 5193 "bc/src/file.c"
  else if (argv [0 ] == cache_dir_symbol ) {
    which = RKTIO_PATH_CACHE_DIR ; 
  }

# 5195 "bc/src/file.c"
  else {
#   define XfOrM948_COUNT (0+XfOrM945_COUNT)
#   define SETUP_XfOrM948(x) SETUP_XfOrM945(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("find-system-path" , "(or/c 'home-dir 'pref-dir 'pref-file 'temp-dir\n" "      'init-dir 'init-file 'addon-dir 'cache-dir\n" "      'doc-dir 'desk-dir 'sys-dir 'exec-file 'run-file\n" "      'collects-dir 'config-dir 'orig-dir\n" "      'host-collects-dir 'host-config-dir)" , 0 , argc , argv ) )



    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  FUNCCALL(SETUP_XfOrM945(_), scheme_security_check_file ("find-system-path" , ((void * ) 0 ) , 0x10 ) )
  ; 

  {
    Scheme_Object * p ; 
    char * s ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM945_COUNT)));
#   define XfOrM946_COUNT (1+XfOrM945_COUNT)
#   define SETUP_XfOrM946(x) SETUP(XfOrM946_COUNT)
    p = NULLED_OUT ; 
    s = NULLED_OUT ; 

# 5212 "bc/src/file.c"
    s = (rktio_system_path (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , which ) ) ; 

    p = FUNCCALL(SETUP_XfOrM946(_), scheme_make_sized_offset_path (s , 0 , - 1 , 1 ) ); 

    if (! FUNCCALL(SETUP_XfOrM946(_), scheme_is_complete_path ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) , scheme_unix_path_type ) )) {
#     define XfOrM947_COUNT (0+XfOrM946_COUNT)
#     define SETUP_XfOrM947(x) SETUP_XfOrM946(x)

# 5217 "bc/src/file.c"
      p = FUNCCALL(SETUP_XfOrM947(_), scheme_path_to_complete_path (p , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> original_pwd_ ) ) ); 
    }
    if (should_be_dir )
      p = FUNCCALL(SETUP_XfOrM946(_), scheme_path_to_directory_path (p ) ); 

    RET_VALUE_START (p ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5227 "bc/src/file.c"
Scheme_Object * scheme_set_exec_cmd (char * s ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM961_COUNT (1)
# define SETUP_XfOrM961(x) SETUP(XfOrM961_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5229 "bc/src/file.c"
  if (! exec_cmd ) {
#   define XfOrM962_COUNT (0+XfOrM961_COUNT)
#   define SETUP_XfOrM962(x) SETUP_XfOrM961(x)
    FUNCCALL(SETUP_XfOrM962(_), scheme_register_static ((void * ) & exec_cmd , sizeof (exec_cmd ) ) )
# 5230 "bc/src/file.c"
    ; 
    exec_cmd = FUNCCALL_EMPTY(scheme_make_path (s ) ); 
  }

  RET_VALUE_START (exec_cmd ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5238 "bc/src/file.c"
Scheme_Object * scheme_set_run_cmd (char * s ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM963_COUNT (1)
# define SETUP_XfOrM963(x) SETUP(XfOrM963_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5240 "bc/src/file.c"
  if (! run_cmd ) {
#   define XfOrM964_COUNT (0+XfOrM963_COUNT)
#   define SETUP_XfOrM964(x) SETUP_XfOrM963(x)
    FUNCCALL(SETUP_XfOrM964(_), scheme_register_static ((void * ) & run_cmd , sizeof (run_cmd ) ) )
# 5241 "bc/src/file.c"
    ; 
    run_cmd = FUNCCALL_EMPTY(scheme_make_path (s ) ); 
  }

  RET_VALUE_START (run_cmd ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5248 "bc/src/file.c"
char * scheme_get_exec_path (void ) 
{
  /* No conversion */

# 5250 "bc/src/file.c"
  if (exec_cmd )
    return (((Scheme_Simple_Object * ) (exec_cmd ) ) -> u . byte_str_val . string_val ) ; 
  else 
  return ((void * ) 0 ) ; 
}


void scheme_set_collects_path (Scheme_Object * p ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM966_COUNT (1)
# define SETUP_XfOrM966(x) SETUP(XfOrM966_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5259 "bc/src/file.c"
  if (! collects_path ) {
#   define XfOrM967_COUNT (0+XfOrM966_COUNT)
#   define SETUP_XfOrM967(x) SETUP_XfOrM966(x)
    FUNCCALL(SETUP_XfOrM967(_), scheme_register_static ((void * ) & collects_path , sizeof (collects_path ) ) )
# 5260 "bc/src/file.c"
    ; 
  }
  collects_path = p ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5266 "bc/src/file.c"
void scheme_set_config_path (Scheme_Object * p ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM968_COUNT (1)
# define SETUP_XfOrM968(x) SETUP(XfOrM968_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5268 "bc/src/file.c"
  if (! config_path ) {
#   define XfOrM969_COUNT (0+XfOrM968_COUNT)
#   define SETUP_XfOrM969(x) SETUP_XfOrM968(x)
    FUNCCALL(SETUP_XfOrM969(_), scheme_register_static ((void * ) & config_path , sizeof (config_path ) ) )
# 5269 "bc/src/file.c"
    ; 
  }
  config_path = p ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5275 "bc/src/file.c"
void scheme_set_host_collects_path (Scheme_Object * p ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM970_COUNT (1)
# define SETUP_XfOrM970(x) SETUP(XfOrM970_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5277 "bc/src/file.c"
  if (! host_collects_path ) {
#   define XfOrM971_COUNT (0+XfOrM970_COUNT)
#   define SETUP_XfOrM971(x) SETUP_XfOrM970(x)
    FUNCCALL(SETUP_XfOrM971(_), scheme_register_static ((void * ) & host_collects_path , sizeof (host_collects_path ) ) )
# 5278 "bc/src/file.c"
    ; 
  }
  host_collects_path = p ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5284 "bc/src/file.c"
void scheme_set_host_config_path (Scheme_Object * p ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM972_COUNT (1)
# define SETUP_XfOrM972(x) SETUP(XfOrM972_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5286 "bc/src/file.c"
  if (! host_config_path ) {
#   define XfOrM973_COUNT (0+XfOrM972_COUNT)
#   define SETUP_XfOrM973(x) SETUP_XfOrM972(x)
    FUNCCALL(SETUP_XfOrM973(_), scheme_register_static ((void * ) & host_config_path , sizeof (host_config_path ) ) )
# 5287 "bc/src/file.c"
    ; 
  }
  host_config_path = p ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5293 "bc/src/file.c"
void scheme_set_original_dir (Scheme_Object * d ) 
{
  /* No conversion */

# 5295 "bc/src/file.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> original_pwd_ ) = d ; 
}


void scheme_set_addon_dir (Scheme_Object * p ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM975_COUNT (1)
# define SETUP_XfOrM975(x) SETUP(XfOrM975_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5301 "bc/src/file.c"
  if (! addon_dir ) {
#   define XfOrM976_COUNT (0+XfOrM975_COUNT)
#   define SETUP_XfOrM976(x) SETUP_XfOrM975(x)
    FUNCCALL(SETUP_XfOrM976(_), scheme_register_static ((void * ) & addon_dir , sizeof (addon_dir ) ) )
# 5302 "bc/src/file.c"
    ; 
  }
  addon_dir = p ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
