#include "precomp.h"

# 34 "bc/rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 117 "rktio/rktio.h"
__xform_nongcing__ extern void rktio_free (void * p ) ; 



typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 351 "rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "rktio/rktio.h"
rktio_process_result_t ; 

# 646 "rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "rktio/rktio.h"
rktio_status_t ; 

# 669 "rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "rktio/rktio.h"
rktio_identity_t ; 

# 925 "rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "rktio/rktio.h"
rktio_date_t ; 

__xform_nongcing__ extern uintptr_t rktio_get_milliseconds (void ) ; 



__xform_nongcing__ extern double rktio_get_inexact_milliseconds (void ) ; 



__xform_nongcing__ extern double rktio_get_inexact_monotonic_milliseconds (rktio_t * rktio ) ; 



__xform_nongcing__ extern uintptr_t rktio_get_process_milliseconds (rktio_t * rktio ) ; 
__xform_nongcing__ extern uintptr_t rktio_get_process_children_milliseconds (rktio_t * rktio ) ; 



__xform_nongcing__ extern rktio_timestamp_t rktio_get_seconds (rktio_t * rktio ) ; 
__xform_nongcing__ extern rktio_date_t * rktio_seconds_to_date (rktio_t * rktio , rktio_timestamp_t seconds , int nanoseconds , int get_gmt ) ; 





enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 









__xform_nongcing__ extern int rktio_get_last_error_kind (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 

__xform_nongcing__ extern int rktio_get_last_error (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

# 1436 "rktio/rktio.h"
__xform_nongcing__ extern const char * rktio_get_last_error_string (rktio_t * rktio ) ; 

# 11 "bc/src/fun.c"
static void ASSERT_SUSPEND_BREAK_ZERO () {
  /* No conversion */
}





int scheme_defining_primitives ; 

int scheme_prim_opt_flags [(1 << 7 ) ] ; 

Scheme_Object scheme_void [1 ] ; 
Scheme_Object * scheme_values_proc ; 
Scheme_Object * scheme_procedure_p_proc ; 
Scheme_Object * scheme_procedure_arity_includes_proc ; 
Scheme_Object * scheme_procedure_specialize_proc ; 
Scheme_Object * scheme_void_proc ; 
Scheme_Object * scheme_void_p_proc ; 
Scheme_Object * scheme_check_not_undefined_proc ; 
Scheme_Object * scheme_check_assign_not_undefined_proc ; 
Scheme_Object * scheme_apply_proc ; 
Scheme_Object * scheme_call_with_values_proc ; 
Scheme_Object * scheme_call_with_immed_mark_proc ; 
Scheme_Object * scheme_reduced_procedure_struct ; 
Scheme_Object * scheme_tail_call_waiting ; 
Scheme_Object * scheme_default_prompt_tag ; 
Scheme_Object * scheme_root_prompt_tag ; 
Scheme_Object * scheme_chaperone_undefined_property ; 



static Scheme_Object * certify_mode_symbol ; 
static Scheme_Object * taint_mode_symbol ; 
static Scheme_Object * transparent_symbol ; 
static Scheme_Object * transparent_binding_symbol ; 
static Scheme_Object * opaque_symbol ; 
static Scheme_Object * none_symbol ; 
static Scheme_Object * subprocesses_symbol ; 
static Scheme_Object * is_method_symbol ; 
static Scheme_Object * cont_key ; 
static Scheme_Object * barrier_prompt_key ; 
static Scheme_Object * prompt_cc_guard_key ; 
static Scheme_Object * mark_symbol ; 
static Scheme_Prompt * original_default_prompt ; 
static Scheme_Object * call_with_prompt_proc ; 
static Scheme_Object * abort_continuation_proc ; 
static Scheme_Object * internal_call_cc_prim ; 
static Scheme_Object * finish_call_cc_prim ; 
static Scheme_Object * propagate_abort_prim ; 


; 
; 
; 
; 
; 
; 
; 

; 
; 




static Scheme_Object * procedure_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * apply (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * map (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * for_each (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * andmap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * ormap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_cc (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * internal_call_cc (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * finish_call_cc (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_in_continuation (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * propagate_abort (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * continuation_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_continuation_barrier (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_prompt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_control (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_prompt_tag (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * abort_continuation (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * continuation_prompt_available (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * get_default_prompt_tag (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * prompt_tag_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_prompt_tag (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_prompt_tag (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_sema (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_sema_enable_break (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_continuation_mark_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * continuation_mark_key_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_continuation_mark_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_continuation_mark_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cc_marks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cont_marks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cc_marks_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_cc_marks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_cc_markses (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_cc_iterator (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_cc_proc_marks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_one_cc_mark (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_immediate_cc_mark (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * void_func (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * void_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * dynamic_wind (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * time_apply (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_inexact_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_inexact_monotonic_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_process_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_gc_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_seconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * seconds_to_date (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * object_name (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_arity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_arity_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_arity_mask (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_reduce_arity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_reduce_arity_mask (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_rename (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_to_method (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_realm (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_equal_closure_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_specialize (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_procedure (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_chaperone_procedure (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_procedure (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_impersonate_procedure (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_procedure_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_procedure_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * primitive_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * primitive_closure_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * primitive_result_arity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_result_arity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_values (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_values (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_print (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_prompt_read (int , Scheme_Object * * ) ; 
static Scheme_Object * current_read (int , Scheme_Object * * ) ; 
static Scheme_Object * current_get_read_input_port (int , Scheme_Object * * ) ; 
static Scheme_Object * current_get_interaction_evt (int , Scheme_Object * * ) ; 

static Scheme_Object * chaperone_wrap_cc_guard (Scheme_Object * obj , Scheme_Object * proc ) ; 
static Scheme_Object * do_cc_guard (Scheme_Object * v , Scheme_Object * cc_guard , Scheme_Object * chaperone ) ; 

static Scheme_Object * chaperone_unsafe_undefined (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * unsafe_abort_continuation_no_dws (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_call_with_control_no_dws (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_root_continuation_prompt_tag (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * 
scheme_extract_one_cc_mark_with_meta (Scheme_Object * mark_set , Scheme_Object * key , 
Scheme_Object * prompt_tag , Scheme_Meta_Continuation * * _meta , 
intptr_t * _vpos ) ; 
static Scheme_Object * get_set_cont_mark_by_pos (Scheme_Object * key , 
Scheme_Thread * p , 
Scheme_Meta_Continuation * mc , 
intptr_t mpos , 
Scheme_Object * val ) ; 
static Scheme_Cont_Mark_Chain * current_mark_chain (const char * who , Scheme_Object * prompt_tag ) ; 

static Scheme_Object * jump_to_alt_continuation () ; 
static void reset_cjs (Scheme_Continuation_Jump_State * a ) ; 

typedef void (* DW_PrePost_Proc ) (void * ) ; 



static Scheme_Object * mask_to_arity (Scheme_Object * mask , int mode ) ; 


static void register_traversers (void ) ; 



typedef struct Scheme_Dynamic_Wind_List {
  Scheme_Type type ; 
  Scheme_Dynamic_Wind * dw ; 
  int meta_depth ; 
  struct Scheme_Dynamic_Wind_List * next ; 
}

# 193 "bc/src/fun.c"
Scheme_Dynamic_Wind_List ; 





void 
scheme_init_fun (Scheme_Startup_Env * env ) 
{
  Scheme_Object * o ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(o, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM2(_), register_traversers () )
# 205 "bc/src/fun.c"
  ; 



  scheme_tail_call_waiting = ((Scheme_Object * ) 0x4 ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_procedure_p_proc , sizeof (scheme_procedure_p_proc ) ) )





  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_procedure_arity_includes_proc , sizeof (scheme_procedure_arity_includes_proc ) ) ); 

  o = FUNCCALL_AGAIN(scheme_make_folding_prim (procedure_p , "procedure?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure?" , o , env ) ); 

  scheme_procedure_p_proc = o ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_apply_proc , sizeof (scheme_apply_proc ) ) )
  ; 
  scheme_apply_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (apply , 1 , "apply" , 2 , - 1 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("apply" , scheme_apply_proc , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_noncm_prim (map , "map" , 2 , - 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("map" , o , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_noncm_prim (for_each , "for-each" , 2 , - 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("for-each" , o , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (andmap , "andmap" , 2 , - 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("andmap" , o , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (ormap , "ormap" , 2 , - 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("ormap" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_call_with_values_proc , sizeof (scheme_call_with_values_proc ) ) )
  ; 
  scheme_call_with_values_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (call_with_values , 1 , "call-with-values" , 2 , 2 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-values" , scheme_call_with_values_proc , env ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_values_proc , sizeof (scheme_values_proc ) ) )
  ; 
  scheme_values_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (scheme_values , 1 , "values" , 0 , - 1 , 0 , 0 , - 1 ) )


  ; 
  (((Scheme_Prim_Proc_Header * ) scheme_values_proc ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 4 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("values" , scheme_values_proc , env ) )

  ; 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_everything (scheme_call_ec , 1 , "call-with-escape-continuation" , 1 , 1 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-escape-continuation" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & internal_call_cc_prim , sizeof (internal_call_cc_prim ) ) )
  ; 
  internal_call_cc_prim = FUNCCALL_AGAIN(scheme_make_prim_w_everything (internal_call_cc , 1 , "call-with-current-continuation" , 1 , 3 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & finish_call_cc_prim , sizeof (finish_call_cc_prim ) ) ); 
  finish_call_cc_prim = FUNCCALL_AGAIN(scheme_make_prim_w_everything (finish_call_cc , 1 , "finish-call-with-current-continuation" , 2 , 2 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & propagate_abort_prim , sizeof (propagate_abort_prim ) ) ); 
  propagate_abort_prim = FUNCCALL_AGAIN(scheme_make_prim_w_arity (propagate_abort , "propagate-abort" , 0 , - 1 ) ); 


  o = FUNCCALL_AGAIN(scheme_make_prim_w_everything (call_cc , 1 , "call-with-current-continuation" , 1 , 2 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-current-continuation" , o , env ) )
  ; 
  (__funcarg111 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_with_control , 1 , "call-with-composable-continuation" , 1 , 2 , 0 , 0 , - 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-composable-continuation" , __funcarg111 , env ) )) 
  ; 
  (__funcarg110 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (continuation_p , "continuation?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation?" , __funcarg110 , env ) )) 
  ; 
  (__funcarg109 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_with_continuation_barrier , 1 , "call-with-continuation-barrier" , 1 , 1 , 0 , 0 , - 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-continuation-barrier" , __funcarg109 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & call_with_prompt_proc , sizeof (call_with_prompt_proc ) ) )
  ; 
  call_with_prompt_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (call_with_prompt , 1 , "call-with-continuation-prompt" , 1 , - 1 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-continuation-prompt" , call_with_prompt_proc , env ) )

  ; 
  (__funcarg108 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_in_continuation , 1 , "call-in-continuation" , 2 , 2 , 0 , 0 , - 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-in-continuation" , __funcarg108 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & abort_continuation_proc , sizeof (abort_continuation_proc ) ) )
  ; 
  abort_continuation_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (abort_continuation , "abort-current-continuation" , 1 , - 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("abort-current-continuation" , abort_continuation_proc , env ) )

  ; 
  (__funcarg107 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (continuation_prompt_available , "continuation-prompt-available?" , 1 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-prompt-available?" , __funcarg107 , env ) )) 
  ; 
  (__funcarg106 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (make_prompt_tag , "make-continuation-prompt-tag" , 0 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-continuation-prompt-tag" , __funcarg106 , env ) )) 
  ; 
  (__funcarg105 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (get_default_prompt_tag , "default-continuation-prompt-tag" , 0 , 0 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("default-continuation-prompt-tag" , __funcarg105 , env ) )) 
  ; 
  (__funcarg104 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (prompt_tag_p , "continuation-prompt-tag?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-prompt-tag?" , __funcarg104 , env ) )) 
  ; 
  (__funcarg103 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_prompt_tag , "impersonate-prompt-tag" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-prompt-tag" , __funcarg103 , env ) )) 
  ; 
  (__funcarg102 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_prompt_tag , "chaperone-prompt-tag" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-prompt-tag" , __funcarg102 , env ) )) 
  ; 
  (__funcarg101 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_with_sema , 1 , "call-with-semaphore" , 2 , - 1 , 0 , 0 , - 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-semaphore" , __funcarg101 , env ) )) 
  ; 
  (__funcarg100 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_with_sema_enable_break , 1 , "call-with-semaphore/enable-break" , 2 , - 1 , 0 , 0 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-semaphore/enable-break" , __funcarg100 , env ) )) 
  ; 
  (__funcarg99 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (make_continuation_mark_key , "make-continuation-mark-key" , 0 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-continuation-mark-key" , __funcarg99 , env ) )) 
  ; 
  (__funcarg98 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (continuation_mark_key_p , "continuation-mark-key?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-key?" , __funcarg98 , env ) )) 
  ; 
  (__funcarg97 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_continuation_mark_key , "impersonate-continuation-mark-key" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-continuation-mark-key" , __funcarg97 , env ) )) 
  ; 
  (__funcarg96 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_continuation_mark_key , "chaperone-continuation-mark-key" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-continuation-mark-key" , __funcarg96 , env ) )) 
  ; 
  (__funcarg95 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (cc_marks , "current-continuation-marks" , 0 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-continuation-marks" , __funcarg95 , env ) )) 
  ; 
  (__funcarg94 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (cont_marks , "continuation-marks" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-marks" , __funcarg94 , env ) )) 
  ; 
  (__funcarg93 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (extract_cc_marks , "continuation-mark-set->list" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set->list" , __funcarg93 , env ) )) 
  ; 
  (__funcarg92 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (extract_cc_markses , "continuation-mark-set->list*" , 2 , 4 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set->list*" , __funcarg92 , env ) )) 
  ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (extract_cc_iterator , "continuation-mark-set->iterator" , 2 , 4 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set->iterator" , __funcarg91 , env ) )) 
  ; 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (extract_one_cc_mark , "continuation-mark-set-first" , 2 , 4 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("continuation-mark-set-first" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_call_with_immed_mark_proc , sizeof (scheme_call_with_immed_mark_proc ) ) )
  ; 
  scheme_call_with_immed_mark_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (call_with_immediate_cc_mark , 1 , "call-with-immediate-continuation-mark" , 2 , 3 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-immediate-continuation-mark" , scheme_call_with_immed_mark_proc , env ) )

  ; 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (cc_marks_p , "continuation-mark-set?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set?" , __funcarg90 , env ) )) 
  ; 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (extract_cc_proc_marks , "continuation-mark-set->context" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set->context" , __funcarg89 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_void_proc , sizeof (scheme_void_proc ) ) )
  ; 
  scheme_void_proc = FUNCCALL_AGAIN(scheme_make_folding_prim (void_func , "void" , 0 , - 1 , 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) scheme_void_proc ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 4 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("void" , scheme_void_proc , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_void_p_proc , sizeof (scheme_void_p_proc ) ) )

  ; 
  scheme_void_p_proc = FUNCCALL_AGAIN(scheme_make_folding_prim (void_p , "void?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) scheme_void_p_proc ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("void?" , scheme_void_p_proc , env ) ); 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (time_apply , 1 , "time-apply" , 2 , 2 , 0 , 4 , 4 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("time-apply" , __funcarg88 , env ) )) 
  ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_milliseconds , "current-milliseconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-milliseconds" , __funcarg87 , env ) )) 
  ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_inexact_milliseconds , "current-inexact-milliseconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-inexact-milliseconds" , __funcarg86 , env ) )) 
  ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_inexact_monotonic_milliseconds , "current-inexact-monotonic-milliseconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-inexact-monotonic-milliseconds" , __funcarg85 , env ) )) 
  ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_process_milliseconds , "current-process-milliseconds" , 0 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-process-milliseconds" , __funcarg84 , env ) )) 
  ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_gc_milliseconds , "current-gc-milliseconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-gc-milliseconds" , __funcarg83 , env ) )) 
  ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_seconds , "current-seconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-seconds" , __funcarg82 , env ) )) 
  ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (seconds_to_date , "seconds->date" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("seconds->date" , __funcarg81 , env ) )) 
  ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (dynamic_wind , "dynamic-wind" , 3 , 3 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("dynamic-wind" , __funcarg80 , env ) )) 
  ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (object_name , "object-name" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("object-name" , __funcarg79 , env ) )) 
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_arity , "procedure-arity" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-arity" , __funcarg78 , env ) )) 
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_arity_p , "procedure-arity?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-arity?" , __funcarg77 , env ) )) 
  ; 

  o = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_procedure_arity_includes , "procedure-arity-includes?" , 2 , 3 , 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  scheme_procedure_arity_includes_proc = o ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure-arity-includes?" , o , env ) ); 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_arity_mask , "procedure-arity-mask" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-arity-mask" , __funcarg76 , env ) )) 
  ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_reduce_arity , "procedure-reduce-arity" , 2 , 4 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-reduce-arity" , __funcarg75 , env ) )) 
  ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_rename , "procedure-rename" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-rename" , __funcarg74 , env ) )) 
  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_reduce_arity_mask , "procedure-reduce-arity-mask" , 2 , 4 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-reduce-arity-mask" , __funcarg73 , env ) )) 
  ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_to_method , "procedure->method" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure->method" , __funcarg72 , env ) )) 
  ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_realm , "procedure-realm" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-realm" , __funcarg71 , env ) )) 
  ; 

  o = FUNCCALL_AGAIN(scheme_make_folding_prim (procedure_equal_closure_p , "procedure-closure-contents-eq?" , 2 , 2 , 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure-closure-contents-eq?" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_procedure_specialize_proc , sizeof (scheme_procedure_specialize_proc ) ) )
  ; 
  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (procedure_specialize , "procedure-specialize" , 1 , 1 ) )

  ; 
  scheme_procedure_specialize_proc = o ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure-specialize" , o , env ) ); 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_procedure , "chaperone-procedure" , 2 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-procedure" , __funcarg70 , env ) )) 
  ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_procedure , "impersonate-procedure" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-procedure" , __funcarg69 , env ) )) 
  ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_procedure_star , "chaperone-procedure*" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-procedure*" , __funcarg68 , env ) )) 
  ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_procedure_star , "impersonate-procedure*" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-procedure*" , __funcarg67 , env ) )) 
  ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (primitive_p , "primitive?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive?" , __funcarg66 , env ) )) 
  ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (primitive_closure_p , "primitive-closure?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive-closure?" , __funcarg65 , env ) )) 
  ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (primitive_result_arity , "primitive-result-arity" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive-result-arity" , __funcarg64 , env ) )) 
  ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_result_arity , "procedure-result-arity" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-result-arity" , __funcarg63 , env ) )) 
  ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_print , "current-print" , MZCONFIG_PRINT_HANDLER ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-print" , __funcarg62 , env ) )) 
  ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_prompt_read , "current-prompt-read" , MZCONFIG_PROMPT_READ_HANDLER ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-prompt-read" , __funcarg61 , env ) )) 
  ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_read , "current-read-interaction" , MZCONFIG_READ_HANDLER ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-read-interaction" , __funcarg60 , env ) )) 
  ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_get_read_input_port , "current-get-interaction-input-port" , MZCONFIG_READ_INPUT_PORT_HANDLER ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-get-interaction-input-port" , __funcarg59 , env ) )) 
  ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_get_interaction_evt , "current-get-interaction-evt" , MZCONFIG_READ_GET_EVT ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-get-interaction-evt" , __funcarg58 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & certify_mode_symbol , sizeof (certify_mode_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & taint_mode_symbol , sizeof (taint_mode_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & transparent_symbol , sizeof (transparent_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & transparent_binding_symbol , sizeof (transparent_binding_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & opaque_symbol , sizeof (opaque_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & none_symbol , sizeof (none_symbol ) ) ); 
  certify_mode_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("certify-mode" ) ); 
  taint_mode_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("taint-mode" ) ); 
  transparent_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("transparent" ) ); 
  transparent_binding_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("transparent-binding" ) ); 
  opaque_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("opaque" ) ); 
  none_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("none" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & subprocesses_symbol , sizeof (subprocesses_symbol ) ) )
  ; 
  subprocesses_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("subprocesses" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & is_method_symbol , sizeof (is_method_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & cont_key , sizeof (cont_key ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & barrier_prompt_key , sizeof (barrier_prompt_key ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & prompt_cc_guard_key , sizeof (prompt_cc_guard_key ) ) ); 
  is_method_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("method-arity-error" ) ); 
  cont_key = FUNCCALL_AGAIN(scheme_make_symbol ("k" ) ); 
  barrier_prompt_key = FUNCCALL_AGAIN(scheme_make_symbol ("bar" ) ); 
  prompt_cc_guard_key = FUNCCALL_AGAIN(scheme_make_symbol ("cc" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & mark_symbol , sizeof (mark_symbol ) ) )
  ; 
  mark_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("mark" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_default_prompt_tag , sizeof (scheme_default_prompt_tag ) ) )
  ; 
  {
    Scheme_Object * a [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM2_COUNT)));
#   define XfOrM4_COUNT (3+XfOrM2_COUNT)
#   define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
    a[0] = NULLED_OUT ; 

# 700 "bc/src/fun.c"
    a [0 ] = FUNCCALL(SETUP_XfOrM4(_), scheme_intern_symbol ("default" ) ); 
    scheme_default_prompt_tag = FUNCCALL(SETUP_XfOrM4(_), make_prompt_tag (1 , a ) ); 
    (void ) (scheme_hash_key ((((Scheme_Small_Object * ) (scheme_default_prompt_tag ) ) -> u . ptr_val ) ) ) ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_root_prompt_tag , sizeof (scheme_root_prompt_tag ) ) )
  ; 
  {
    Scheme_Object * a [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM2_COUNT)));
#   define XfOrM3_COUNT (3+XfOrM2_COUNT)
#   define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
    a[0] = NULLED_OUT ; 

# 708 "bc/src/fun.c"
    a [0 ] = FUNCCALL(SETUP_XfOrM3(_), scheme_intern_symbol ("root" ) ); 
    scheme_root_prompt_tag = FUNCCALL(SETUP_XfOrM3(_), make_prompt_tag (1 , a ) ); 
    (void ) (scheme_hash_key ((((Scheme_Small_Object * ) (scheme_root_prompt_tag ) ) -> u . ptr_val ) ) ) ; 
  }
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & original_default_prompt , sizeof (original_default_prompt ) ) )
  ; 
  original_default_prompt = ((Scheme_Prompt * ) FUNCCALL_EMPTY(GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  original_default_prompt -> so . type = scheme_prompt_type ; 
  original_default_prompt -> tag = scheme_default_prompt_tag ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 719 "bc/src/fun.c"
void 
scheme_init_unsafe_fun (Scheme_Startup_Env * env ) 
{
  Scheme_Object * o ; 
  Scheme_Object * __funcarg117 = NULLED_OUT ; 
  Scheme_Object * __funcarg116 = NULLED_OUT ; 
  Scheme_Object * __funcarg115 = NULLED_OUT ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(o, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_register_static ((void * ) & scheme_check_not_undefined_proc , sizeof (scheme_check_not_undefined_proc ) ) )
# 724 "bc/src/fun.c"
  ; 
  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_check_not_undefined , "check-not-unsafe-undefined" , 2 , 2 ) ); 
  scheme_check_not_undefined_proc = o ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (2 
  | (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("check-not-unsafe-undefined" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_check_assign_not_undefined_proc , sizeof (scheme_check_assign_not_undefined_proc ) ) )
  ; 
  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_check_assign_not_undefined , "check-not-unsafe-undefined/assign" , 2 , 2 ) ); 
  scheme_check_assign_not_undefined_proc = o ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("check-not-unsafe-undefined/assign" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-undefined" , scheme_undefined , env ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_chaperone_undefined_property , sizeof (scheme_chaperone_undefined_property ) ) )
  ; 
  o = (__funcarg117 = FUNCCALL(SETUP_XfOrM5(_), scheme_intern_symbol ("chaperone-unsafe-undefined" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg117 ) )) ; 
  scheme_chaperone_undefined_property = o ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("prop:chaperone-unsafe-undefined" , o , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (chaperone_unsafe_undefined , "chaperone-struct-unsafe-undefined" , 1 , 1 ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-struct-unsafe-undefined" , o , env ) ); 
  (__funcarg116 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_chaperone_procedure , "unsafe-chaperone-procedure" , 2 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-chaperone-procedure" , __funcarg116 , env ) )) 
  ; 
  (__funcarg115 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_impersonate_procedure , "unsafe-impersonate-procedure" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-impersonate-procedure" , __funcarg115 , env ) )) 
  ; 
  (__funcarg114 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_abort_continuation_no_dws , "unsafe-abort-current-continuation/no-wind" , 2 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-abort-current-continuation/no-wind" , __funcarg114 , env ) )) ; 
  (__funcarg113 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_call_with_control_no_dws , "unsafe-call-with-composable-continuation/no-wind" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-call-with-composable-continuation/no-wind" , __funcarg113 , env ) )) ; 
  (__funcarg112 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_root_continuation_prompt_tag , "unsafe-root-continuation-prompt-tag" , 0 , 0 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-root-continuation-prompt-tag" , __funcarg112 , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 764 "bc/src/fun.c"
void 
scheme_init_fun_places () 
{
  /* No conversion */

# 767 "bc/src/fun.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) ) ) ; 
}


Scheme_Object * 
scheme_make_void (void ) 
{
  /* No conversion */

# 775 "bc/src/fun.c"
  return scheme_void ; 
}





static Scheme_Object * 
make_prim_closure (Scheme_Prim * fun , int eternal , 
const char * name , 
mzshort mina , mzshort maxa , 
int flags , 
mzshort minr , mzshort maxr , 
int closed , int count , Scheme_Object * * vals ) 
{
  Scheme_Primitive_Proc * prim ; 
  int hasr , size ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(fun, 1), PUSH(vals, 2), PUSH(prim, 3)));
# define XfOrM8_COUNT (4)
# define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prim = NULLED_OUT ; 

# 793 "bc/src/fun.c"
  hasr = ((minr != 1 ) || (maxr != 1 ) ) ; 
  size = (hasr 
  ? sizeof (Scheme_Prim_W_Result_Arity ) 
  : (closed 
  ? (sizeof (Scheme_Primitive_Closure ) 
  + ((count - 0 ) * sizeof (Scheme_Object * ) ) ) 
  : sizeof (Scheme_Primitive_Proc ) ) ) ; 

  if (eternal && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) && ! closed )
    prim = (Scheme_Primitive_Proc * ) FUNCCALL(SETUP_XfOrM8(_), GC_malloc_atomic_uncollectable (size ) ); 
  else 
  prim = (Scheme_Primitive_Proc * ) FUNCCALL(SETUP_XfOrM8(_), GC_malloc_one_tagged (size ) ); 
  prim -> pp . so . type = scheme_prim_type ; 
  prim -> prim_val = (Scheme_Primitive_Closure_Proc * ) fun ; 
  prim -> name = name ; 
  prim -> mina = mina ; 
  if (maxa < 0 )
    maxa = 0x3FFFFFFE + 1 ; 
  prim -> mu . maxa = maxa ; 
  prim -> pp . flags = (flags 
  | (scheme_defining_primitives ? 4 : 0 ) 
  | (hasr ? 8 : 0 ) 
  | (closed ? 16 : 0 ) ) ; 

  if (hasr ) {
    ((Scheme_Prim_W_Result_Arity * ) prim ) -> minr = minr ; 
    ((Scheme_Prim_W_Result_Arity * ) prim ) -> maxr = maxr ; 
  }
  if (closed ) {
#   define XfOrM9_COUNT (0+XfOrM8_COUNT)
#   define SETUP_XfOrM9(x) SETUP_XfOrM8(x)

# 823 "bc/src/fun.c"
    ((Scheme_Primitive_Closure * ) prim ) -> count = count ; 
    (
    memcpy (((Scheme_Primitive_Closure * ) prim ) -> val , 
    vals , 
    count * sizeof (Scheme_Object * ) ) ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) prim ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 833 "bc/src/fun.c"
Scheme_Object * 
scheme_make_prim_w_everything (Scheme_Prim * fun , int eternal , 
const char * name , 
mzshort mina , mzshort maxa , 
int flags , 
mzshort minr , mzshort maxr ) 
{
  /* No conversion */

# 840 "bc/src/fun.c"
  return make_prim_closure (fun , eternal , 
  name , 
  mina , maxa , 
  flags , 
  minr , maxr , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * scheme_make_prim (Scheme_Prim * fun ) 
{
  /* No conversion */

# 850 "bc/src/fun.c"
  return make_prim_closure (fun , 1 , ((void * ) 0 ) , 0 , - 1 , 0 , 1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_noneternal_prim (Scheme_Prim * fun ) 
{
  /* No conversion */

# 857 "bc/src/fun.c"
  return make_prim_closure (fun , 0 , ((void * ) 0 ) , 0 , - 1 , 0 , 1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_prim_w_arity (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 865 "bc/src/fun.c"
  return make_prim_closure (fun , 1 , name , mina , maxa , 0 , 1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_noncm_prim (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */



  return make_prim_closure (fun , 1 , name , mina , maxa , 
  1 , 
  1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_immed_prim (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */



  return make_prim_closure (fun , 1 , name , mina , maxa , 
  2 , 
  1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_folding_prim (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa , 
short folding ) 
{
  /* No conversion */

  return make_prim_closure (fun , 1 , name , mina , maxa , 
  (folding 
  ? 3 
  : 0 ) , 
  1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_noneternal_prim_w_arity (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 916 "bc/src/fun.c"
  return make_prim_closure (fun , 0 , name , mina , maxa , 0 , 1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * scheme_make_prim_closure_w_arity (Scheme_Primitive_Closure_Proc * prim , 
int size , Scheme_Object * * vals , 
const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 925 "bc/src/fun.c"
  return make_prim_closure ((Scheme_Prim * ) prim , 1 , name , mina , maxa , 0 , 1 , 1 , 
  1 , size , vals ) ; 
}


Scheme_Object * scheme_make_folding_prim_closure (Scheme_Primitive_Closure_Proc * prim , 
int size , Scheme_Object * * vals , 
const char * name , 
mzshort mina , mzshort maxa , 
short functional ) 
{
  /* No conversion */

# 936 "bc/src/fun.c"
  return make_prim_closure ((Scheme_Prim * ) prim , 1 , name , mina , maxa , 
  (functional 
  ? 3 
  : 0 ) , 
  1 , 1 , 
  1 , size , vals ) ; 
}

Scheme_Object * 
scheme_make_closed_prim_w_everything (Scheme_Closed_Prim * fun , 
void * data , 
const char * name , 
mzshort mina , mzshort maxa , 
short folding , 
mzshort minr , mzshort maxr ) 
{
  Scheme_Closed_Primitive_Proc * prim ; 
  int hasr , size ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(fun, 1), PUSH(data, 2), PUSH(prim, 3)));
# define XfOrM21_COUNT (4)
# define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prim = NULLED_OUT ; 

# 955 "bc/src/fun.c"
  hasr = ((minr != 1 ) || (maxr != 1 ) ) ; 
  size = hasr ? sizeof (Scheme_Closed_Prim_W_Result_Arity ) : sizeof (Scheme_Closed_Primitive_Proc ) ; 

  prim = (Scheme_Closed_Primitive_Proc * ) FUNCCALL(SETUP_XfOrM21(_), GC_malloc_one_tagged (size ) ); 

  prim -> pp . so . type = scheme_closed_prim_type ; 
  (((Scheme_Closed_Primitive_Proc * ) (prim ) ) -> prim_val ) = fun ; 
  (((Scheme_Closed_Primitive_Proc * ) (prim ) ) -> data ) = data ; 
  prim -> name = name ; 
  prim -> mina = mina ; 
  prim -> maxa = maxa ; 
  prim -> pp . flags = ((folding ? 3 : 0 ) 
  | (scheme_defining_primitives ? 4 : 0 ) 
  | (hasr ? 8 : 0 ) ) ; 

  if (hasr ) {
    ((Scheme_Closed_Prim_W_Result_Arity * ) prim ) -> minr = minr ; 
    ((Scheme_Closed_Prim_W_Result_Arity * ) prim ) -> maxr = maxr ; 
  }

  RET_VALUE_START ((Scheme_Object * ) prim ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 978 "bc/src/fun.c"
Scheme_Object * 
scheme_make_folding_closed_prim (Scheme_Closed_Prim * fun , 
void * data , 
const char * name , 
mzshort mina , mzshort maxa , 
short folding ) 
{
  /* No conversion */

# 985 "bc/src/fun.c"
  return scheme_make_closed_prim_w_everything (fun , data , name , mina , maxa , folding , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_make_closed_prim_w_arity (Scheme_Closed_Prim * fun , void * data , 
const char * name , mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 992 "bc/src/fun.c"
  return scheme_make_closed_prim_w_everything (fun , data , name , mina , maxa , 0 , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_make_closed_prim (Scheme_Closed_Prim * fun , void * data ) 
{
  /* No conversion */

# 998 "bc/src/fun.c"
  return scheme_make_closed_prim_w_everything (fun , data , ((void * ) 0 ) , 0 , - 1 , 0 , 1 , 1 ) ; 
}

void scheme_prim_is_method (Scheme_Object * o ) 
{
  /* No conversion */

# 1003 "bc/src/fun.c"
  scheme_signal_error ("no longer supported" ) ; 
}

int scheme_has_method_property (Scheme_Object * code ) 
{
  /* No conversion */

# 1008 "bc/src/fun.c"
  return (! (((scheme_stx_property (code , is_method_symbol , ((void * ) 0 ) ) ) ) == (scheme_false ) ) ) ; 
}

int scheme_intern_prim_opt_flags (int flags ) 
{
  /* No conversion */

# 1013 "bc/src/fun.c"
  int i ; 

  if (! flags )

# 1015 "bc/src/fun.c"
  return 0 ; 

  for (i = 1 ; i < (1 << 7 ) ; i ++ ) {
    if (scheme_prim_opt_flags [i ] == flags )
      return (i << 9 ) ; 
    else if (! scheme_prim_opt_flags [i ] ) {
      scheme_prim_opt_flags [i ] = flags ; 
      return (i << 9 ) ; 
    }
  }

  START_XFORM_SKIP ; 
  scheme_log_abort ("too many flag combinations" ) ; 
  abort () ; 
  END_XFORM_SKIP ; 

  return 0 ; 
}





static void initialize_prompt (Scheme_Thread * p , Scheme_Prompt * prompt , void * stack_boundary , int is_barrier ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(prompt, 0)));
# define XfOrM33_COUNT (1)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1040 "bc/src/fun.c"
  prompt -> is_barrier = is_barrier ; 
  prompt -> stack_boundary = stack_boundary ; 
  if (is_barrier ) {

    Scheme_Object * ref ; 
    BLOCK_SETUP((PUSH(ref, 0+XfOrM33_COUNT)));
#   define XfOrM34_COUNT (1+XfOrM33_COUNT)
#   define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
    ref = NULLED_OUT ; 

# 1045 "bc/src/fun.c"
    ref = FUNCCALL(SETUP_XfOrM34(_), scheme_make_weak_box ((Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) ); 
    prompt -> u . runstack_boundary_start_ref = ref ; 
    prompt -> weak_boundary = 1 ; 
  }

# 1048 "bc/src/fun.c"
  else 
  prompt -> u . runstack_boundary_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
  prompt -> runstack_boundary_offset = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) ; 
  prompt -> mark_boundary = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
  prompt -> boundary_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1055 "bc/src/fun.c"
Scheme_Object * * scheme_prompt_runstack_boundary_start (Scheme_Prompt * p ) 
{
  /* No conversion */

# 1057 "bc/src/fun.c"
  if (p -> weak_boundary )
    return (Scheme_Object * * ) ((((Scheme_Small_Object * ) (p -> u . runstack_boundary_start_ref ) ) -> u . ptr_val ) ) ; 
  else 
  return p -> u . runstack_boundary_start ; 
}

static void init_prompt_id (Scheme_Prompt * prompt ) 
{
  Scheme_Object * id ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(id, 0), PUSH(prompt, 1)));
# define XfOrM36_COUNT (2)
# define SETUP_XfOrM36(x) SETUP(XfOrM36_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  id = NULLED_OUT ; 

# 1067 "bc/src/fun.c"
  if (! prompt -> id ) {
#   define XfOrM37_COUNT (0+XfOrM36_COUNT)
#   define SETUP_XfOrM37(x) SETUP_XfOrM36(x)

# 1068 "bc/src/fun.c"
    id = FUNCCALL(SETUP_XfOrM37(_), scheme_make_pair (scheme_false , scheme_false ) ); 
    prompt -> id = id ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1073 "bc/src/fun.c"
Scheme_Prompt * make_weak_prompt (Scheme_Prompt * p ) 
{
  Scheme_Prompt * p2 ; 
  Scheme_Object * ref ; 
  DECL_RET_SAVE (Scheme_Prompt * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p2, 0), PUSH(p, 1), PUSH(ref, 2)));
# define XfOrM38_COUNT (3)
# define SETUP_XfOrM38(x) SETUP(XfOrM38_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p2 = NULLED_OUT ; 
  ref = NULLED_OUT ; 

# 1078 "bc/src/fun.c"
  if (p -> weak_boundary )
    RET_VALUE_START (p ) RET_VALUE_END ; 
  FUNCCALL(SETUP_XfOrM38(_), init_prompt_id (p ) )
  ; 

  p2 = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM38(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (p2 , p , sizeof (Scheme_Prompt ) ) ) ; 

  ref = FUNCCALL(SETUP_XfOrM38(_), scheme_make_weak_box ((Scheme_Object * ) p2 -> u . runstack_boundary_start ) ); 
  p2 -> u . runstack_boundary_start_ref = ref ; 
  p2 -> weak_boundary = 1 ; 

  RET_VALUE_START (p2 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

typedef Scheme_Object * (* Overflow_K_Proc ) (void ) ; 

; 
; 

void scheme_really_create_overflow (void * stack_base ) __attribute__ ((noinline ) ) ; 

void scheme_really_create_overflow (void * stack_base ) 
{
  Scheme_Overflow_Jmp * jmp ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(jmp, 0), PUSH(stack_base, 1)));
# define XfOrM39_COUNT (2)
# define SETUP_XfOrM39(x) SETUP(XfOrM39_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  jmp = NULLED_OUT ; 

# 1108 "bc/src/fun.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) )
    RET_NOTHING ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_stack_start_ ) = stack_base ; 

  jmp = ((Scheme_Overflow_Jmp * ) FUNCCALL(SETUP_XfOrM39(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow_Jmp ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  jmp -> type = scheme_rt_overflow_jmp ; 
  FUNCCALL(SETUP_XfOrM39(_), scheme_init_jmpup_buf (& jmp -> cont ) )

  ; 
  if (FUNCCALL(SETUP_XfOrM39(_), scheme_setjmpup_relative (& jmp -> cont , jmp , stack_base , ((void * ) 0 ) ) )) {





    Scheme_Thread * volatile p ; 
    Scheme_Overflow * volatile overflow ; 
    mz_jmp_buf nestedbuf ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM39_COUNT), PUSH(overflow, 1+XfOrM39_COUNT)));
#   define XfOrM41_COUNT (2+XfOrM39_COUNT)
#   define SETUP_XfOrM41(x) SETUP(XfOrM41_COUNT)
    p = NULLED_OUT ; 
    overflow = NULLED_OUT ; 

# 1129 "bc/src/fun.c"
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    overflow = p -> overflow ; 

    overflow -> jmp -> savebuf = p -> error_buf ; 
    p -> error_buf = & nestedbuf ; 
    if (((nestedbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (nestedbuf ) . gcvs_cnt = XfOrM41_COUNT , (_setjmp ((nestedbuf ) . jb ) ) ) ) {

      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      p -> overflow_reply = ((void * ) 0 ) ; 
    }

# 1138 "bc/src/fun.c"
    else {
      void * p1 , * p2 , * p3 , * p4 , * p5 ; 
      intptr_t i1 , i2 , i3 , i4 ; 
      Overflow_K_Proc f = p -> overflow_k ; 
      Scheme_Object * reply ; 
      BLOCK_SETUP((PUSH(p2, 0+XfOrM41_COUNT), PUSH(p5, 1+XfOrM41_COUNT), PUSH(p4, 2+XfOrM41_COUNT), PUSH(reply, 3+XfOrM41_COUNT), PUSH(p3, 4+XfOrM41_COUNT), PUSH(p1, 5+XfOrM41_COUNT)));
#     define XfOrM42_COUNT (6+XfOrM41_COUNT)
#     define SETUP_XfOrM42(x) SETUP(XfOrM42_COUNT)
      p1 = NULLED_OUT ; 
      p2 = NULLED_OUT ; 
      p3 = NULLED_OUT ; 
      p4 = NULLED_OUT ; 
      p5 = NULLED_OUT ; 
      reply = NULLED_OUT ; 

# 1144 "bc/src/fun.c"
      p1 = p -> ku . k . p1 ; 
      p2 = p -> ku . k . p2 ; 
      p3 = p -> ku . k . p3 ; 
      p4 = p -> ku . k . p4 ; 
      p5 = p -> ku . k . p5 ; 
      i1 = p -> ku . k . i1 ; 
      i2 = p -> ku . k . i2 ; 
      i3 = p -> ku . k . i3 ; 
      i4 = p -> ku . k . i4 ; 
      FUNCCALL(SETUP_XfOrM42(_), scheme_thread_block (0 ) )

      ; 
      p -> ran_some = 1 ; 

      p -> ku . k . p1 = p1 ; 
      p -> ku . k . p2 = p2 ; 
      p -> ku . k . p3 = p3 ; 
      p -> ku . k . p4 = p4 ; 
      p -> ku . k . p5 = p5 ; 
      p -> ku . k . i1 = i1 ; 
      p -> ku . k . i2 = i2 ; 
      p -> ku . k . i3 = i3 ; 
      p -> ku . k . i4 = i4 ; 

      reply = FUNCCALL(SETUP_XfOrM42(_), f () ); 
      (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> overflow_reply ) = reply ; 





      if (reply == ((Scheme_Object * ) 0x6 ) ) {
        p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
        if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
          p -> values_buffer = ((void * ) 0 ) ; 
      }

# 1179 "bc/src/fun.c"
      else if (reply == ((Scheme_Object * ) 0x4 ) ) {
#       define XfOrM43_COUNT (0+XfOrM42_COUNT)
#       define SETUP_XfOrM43(x) SETUP_XfOrM42(x)

# 1180 "bc/src/fun.c"
        p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
        if (p -> ku . apply . tail_rands == p -> tail_buffer )
          FUNCCALL(SETUP_XfOrM43(_), scheme_realloc_tail_buffer (p ) ); 
      }
    }

    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    overflow = p -> overflow ; 
    p -> stack_start = overflow -> stack_start ; 
    FUNCCALL(SETUP_XfOrM41(_), scheme_longjmpup (& overflow -> jmp -> cont ) )

    ; 
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) ) {
#   define XfOrM40_COUNT (0+XfOrM39_COUNT)
#   define SETUP_XfOrM40(x) SETUP_XfOrM39(x)
    FUNCCALL(SETUP_XfOrM40(_), scheme_signal_error ("shouldn't get here!" ) )
# 1195 "bc/src/fun.c"
    ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) = jmp ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1201 "bc/src/fun.c"
void scheme_create_overflow (void ) 
{
  void * stack_marker ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(stack_marker, 0)));
# define XfOrM46_COUNT (1)
# define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stack_marker = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM46(_), scheme_really_create_overflow (& __gc_var_stack__ ) )
# 1204 "bc/src/fun.c"
  ; 
  stack_marker = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1208 "bc/src/fun.c"
void scheme_init_overflow (void ) 
{
  /* No conversion */

# 1210 "bc/src/fun.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) ) ) ; 
}

void scheme_reset_overflow (void ) 
{
  /* No conversion */

# 1215 "bc/src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) = ((void * ) 0 ) ; 
}





static Scheme_Prompt * allocate_prompt (Scheme_Prompt * * cached_prompt ) {
  Scheme_Prompt * prompt ; 
  DECL_RET_SAVE (Scheme_Prompt * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(prompt, 0)));
# define XfOrM49_COUNT (1)
# define SETUP_XfOrM49(x) SETUP(XfOrM49_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt = NULLED_OUT ; 

# 1224 "bc/src/fun.c"
  if (* cached_prompt ) {
    prompt = * cached_prompt ; 
    * cached_prompt = ((void * ) 0 ) ; 
  }

# 1227 "bc/src/fun.c"
  else {
#   define XfOrM50_COUNT (0+XfOrM49_COUNT)
#   define SETUP_XfOrM50(x) SETUP_XfOrM49(x)

# 1228 "bc/src/fun.c"
    prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM50(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    prompt -> so . type = scheme_prompt_type ; 
  }
  RET_VALUE_START (prompt ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1234 "bc/src/fun.c"
static void * apply_again_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * val = p -> ku . k . p1 ; 
  int num_vals = p -> ku . k . i1 ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(val, 0)));
# define XfOrM52_COUNT (1)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1240 "bc/src/fun.c"
  p -> ku . k . p1 = ((void * ) 0 ) ; 

  if (num_vals != 1 ) {
#   define XfOrM54_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM54(x) SETUP_XfOrM52(x)
    FUNCCALL(SETUP_XfOrM54(_), scheme_wrong_return_arity ("call-with-continuation-prompt" , 1 , num_vals , (Scheme_Object * * ) val , "\n  in: application of default prompt handler" ) )
# 1244 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 1246 "bc/src/fun.c"
  else {
#   define XfOrM53_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM53(x) SETUP_XfOrM52(x)
    FUNCCALL(SETUP_XfOrM53(_), scheme_check_proc_arity ("default-continuation-prompt-handler" , 0 , 0 , 1 , & val ) )
# 1247 "bc/src/fun.c"
    ; 
    RET_VALUE_START ((void * ) FUNCCALL(SETUP_XfOrM53(_), scheme_do_eval (val , 0 , ((void * ) 0 ) , 1 ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1252 "bc/src/fun.c"
void * scheme_top_level_do (void * (* k ) (void ) , int eb ) {
  /* No conversion */

# 1253 "bc/src/fun.c"
  return scheme_top_level_do_worker (k , eb , 0 ) ; 
}

void * scheme_top_level_do_worker (void * (* k ) (void ) , int eb , int new_thread ) 
{


  void * v ; 
  Scheme_Prompt * volatile prompt = ((void * ) 0 ) ; 
  mz_jmp_buf * save ; 
  mz_jmp_buf newbuf ; 
  Scheme_Stack_State envss ; 
  Scheme_Thread * volatile p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  volatile int old_pcc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ; 
  Scheme_Cont_Frame_Data cframe ; 
  volatile int need_final_abort = 0 ; 

  void * external_stack ; 

  int num_vals = p -> ku . k . i1 ; 
  void * val = p -> ku . k . p1 ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(external_stack, 0), PUSH(prompt, 1), PUSH(save, 2), PUSH(val, 3), PUSH(v, 4), PUSH(cframe.cache, 5), PUSH(p, 6)));
# define XfOrM56_COUNT (7)
# define SETUP_XfOrM56(x) SETUP(XfOrM56_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  save = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  external_stack = NULLED_OUT ; 

# 1275 "bc/src/fun.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_active_but_sleeping_ ) )
    FUNCCALL(SETUP_XfOrM56(_), scheme_wake_up () ); 

  if (eb ) {
#   define XfOrM83_COUNT (0+XfOrM56_COUNT)
#   define SETUP_XfOrM83(x) SETUP_XfOrM56(x)

# 1279 "bc/src/fun.c"
    prompt = FUNCCALL(SETUP_XfOrM83(_), allocate_prompt (& XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_ ) ) ); 
    FUNCCALL(SETUP_XfOrM83(_), initialize_prompt (p , prompt , & __gc_var_stack__ , ! new_thread ) ); 
  }


  if (scheme_get_external_stack_val )
    external_stack = FUNCCALL(SETUP_XfOrM56(_), scheme_get_external_stack_val () ); 
  else 
  external_stack = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM56(_), scheme_create_overflow () )

  ; 

  save = p -> error_buf ; 

  while (1 ) {
#   define XfOrM72_COUNT (0+XfOrM56_COUNT)
#   define SETUP_XfOrM72(x) SETUP_XfOrM56(x)

# 1296 "bc/src/fun.c"
    (envss . runstack_offset = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , envss . cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , envss . cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ; 

    if (prompt ) {
#     define XfOrM82_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM82(x) SETUP_XfOrM72(x)
      FUNCCALL(SETUP_XfOrM82(_), scheme_push_continuation_frame (& cframe ) )
# 1299 "bc/src/fun.c"
      ; 
      FUNCCALL(SETUP_XfOrM82(_), scheme_set_cont_mark (barrier_prompt_key , (Scheme_Object * ) prompt ) ); 
    }

    p -> error_buf = & newbuf ; 

    if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM72_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
      int again ; 
#     define XfOrM75_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM75(x) SETUP_XfOrM72(x)

# 1308 "bc/src/fun.c"
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

      if ((p -> cjs . jumping_to_continuation ) == ((Scheme_Object * ) original_default_prompt ) )  {
#       define XfOrM81_COUNT (0+XfOrM75_COUNT)
#       define SETUP_XfOrM81(x) SETUP_XfOrM75(x)
        num_vals = p -> cjs . num_vals ; 
        val = p -> cjs . val ; 
        FUNCCALL(SETUP_XfOrM81(_), reset_cjs (& p -> cjs ) ); 
        k = apply_again_k ; 
        need_final_abort = 1 ; 
        again = 1 ; 
      }

# 1319 "bc/src/fun.c"
      else {
        num_vals = 0 ; 
        val = ((void * ) 0 ) ; 
        again = 0 ; 
      }

      if (! new_thread || again ) {
#       define XfOrM76_COUNT (0+XfOrM75_COUNT)
#       define SETUP_XfOrM76(x) SETUP_XfOrM75(x)

# 1326 "bc/src/fun.c"
        (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + envss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = envss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = envss . cont_mark_pos ) ; 

        if (scheme_set_external_stack_val )
          FUNCCALL(SETUP_XfOrM76(_), scheme_set_external_stack_val (external_stack ) ); 

        if (prompt ) {
#         define XfOrM77_COUNT (0+XfOrM76_COUNT)
#         define SETUP_XfOrM77(x) SETUP_XfOrM76(x)
          FUNCCALL(SETUP_XfOrM77(_), scheme_pop_continuation_frame (& cframe ) )
# 1332 "bc/src/fun.c"
          ; 
          if (! again ) {
            if (old_pcc == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ) {

              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_ ) = prompt ; 
            }
          }
        }
      }

      if (! again )
        (((intptr_t * ) (void * ) ((* save ) . gcvs ) ) [1 ] = (* save ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* save ) . gcvs , longjmp ((* save ) . jb , 1 ) ) ; 
    }

# 1344 "bc/src/fun.c"
    else {
#     define XfOrM73_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM73(x) SETUP_XfOrM72(x)

# 1345 "bc/src/fun.c"
      if (new_thread ) {
#       define XfOrM74_COUNT (0+XfOrM73_COUNT)
#       define SETUP_XfOrM74(x) SETUP_XfOrM73(x)
        FUNCCALL(SETUP_XfOrM74(_), scheme_check_break_now () )
# 1347 "bc/src/fun.c"
        ; 
      }

      p -> ku . k . i1 = num_vals ; 
      p -> ku . k . p1 = val ; 

      v = FUNCCALL(SETUP_XfOrM73(_), k () ); 

      break ; 
    }
  }





  if (! new_thread ) {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

    p -> error_buf = save ; 
  }

  if (prompt ) {
#   define XfOrM58_COUNT (0+XfOrM56_COUNT)
#   define SETUP_XfOrM58(x) SETUP_XfOrM56(x)
    FUNCCALL(SETUP_XfOrM58(_), scheme_pop_continuation_frame (& cframe ) )
# 1370 "bc/src/fun.c"
    ; 
    if (old_pcc == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ) {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_ ) = prompt ; 
    }
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_active_but_sleeping_ ) )
    FUNCCALL(SETUP_XfOrM56(_), scheme_wake_up () ); 

  if (need_final_abort ) {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1389 "bc/src/fun.c"
void scheme_clear_prompt_cache () 
{
  /* No conversion */

# 1391 "bc/src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) = ((void * ) 0 ) ; 
}

static void ensure_overflow_id (Scheme_Overflow * overflow ) 
{
  void * id ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(id, 0), PUSH(overflow, 1)));
# define XfOrM85_COUNT (2)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  id = NULLED_OUT ; 

# 1401 "bc/src/fun.c"
  if (! overflow -> id ) {
#   define XfOrM86_COUNT (0+XfOrM85_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM85(x)

# 1402 "bc/src/fun.c"
    if (overflow -> jmp ) {
      overflow -> id = overflow -> jmp ; 
    }

# 1404 "bc/src/fun.c"
    else {
#     define XfOrM87_COUNT (0+XfOrM86_COUNT)
#     define SETUP_XfOrM87(x) SETUP_XfOrM86(x)

# 1405 "bc/src/fun.c"
      id = FUNCCALL(SETUP_XfOrM87(_), GC_malloc_atomic (4 ) ); 
      overflow -> id = id ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1411 "bc/src/fun.c"
void scheme_ensure_dw_id (Scheme_Dynamic_Wind * dw ) 
{
  void * id ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(dw, 0), PUSH(id, 1)));
# define XfOrM89_COUNT (2)
# define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  id = NULLED_OUT ; 

# 1414 "bc/src/fun.c"
  if (! dw -> id ) {
#   define XfOrM90_COUNT (0+XfOrM89_COUNT)
#   define SETUP_XfOrM90(x) SETUP_XfOrM89(x)

# 1415 "bc/src/fun.c"
    id = FUNCCALL(SETUP_XfOrM90(_), GC_malloc_atomic (4 ) ); 
    dw -> id = id ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * 
force_values (Scheme_Object * obj , int multi_ok ) 


{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(obj, 0)));
# define XfOrM91_COUNT (1)
# define SETUP_XfOrM91(x) SETUP(XfOrM91_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1429 "bc/src/fun.c"
  if ((obj ) == (((Scheme_Object * ) 0x4 ) ) )  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    GC_CAN_IGNORE Scheme_Object * rator , * result ; 
    GC_CAN_IGNORE Scheme_Object * * rands ; 
    int argc = p -> ku . apply . tail_num_rands , popc = 0 ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM91_COUNT)));
#   define XfOrM93_COUNT (1+XfOrM91_COUNT)
#   define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)

# 1435 "bc/src/fun.c"
    rands = p -> ku . apply . tail_rands ; 


    if (rands == p -> tail_buffer ) {
      GC_CAN_IGNORE Scheme_Object * * runstack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
#     define XfOrM94_COUNT (0+XfOrM93_COUNT)
#     define SETUP_XfOrM94(x) SETUP_XfOrM93(x)

# 1440 "bc/src/fun.c"
      if (((runstack - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) - argc ) > 5 ) {
#       define XfOrM96_COUNT (0+XfOrM94_COUNT)
#       define SETUP_XfOrM96(x) SETUP_XfOrM94(x)

# 1442 "bc/src/fun.c"
        runstack -= argc ; 
        (memcpy (runstack , rands , argc * sizeof (Scheme_Object * ) ) ) ; 
        rands = runstack ; 
        popc = argc ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = rands ; 
      }

# 1447 "bc/src/fun.c"
      else {
#       define XfOrM95_COUNT (0+XfOrM94_COUNT)
#       define SETUP_XfOrM95(x) SETUP_XfOrM94(x)
        FUNCCALL(SETUP_XfOrM95(_), scheme_realloc_tail_buffer (p ) )
# 1448 "bc/src/fun.c"
        ; 
        rands = p -> ku . apply . tail_rands ; 
      }
    }

    rator = p -> ku . apply . tail_rator ; 
    p -> ku . apply . tail_rator = ((void * ) 0 ) ; 
    p -> ku . apply . tail_rands = ((void * ) 0 ) ; 

    if (multi_ok )
      result = FUNCCALL(SETUP_XfOrM93(_), scheme_do_eval (rator , argc , rands , - 1 ) ); 
    else 
    result = FUNCCALL(SETUP_XfOrM93(_), scheme_do_eval (rator , argc , rands , 1 ) ); 

    if (popc )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += popc ; 

    RET_VALUE_START (result ) RET_VALUE_END ; 
  }

# 1466 "bc/src/fun.c"
  else if ((obj ) == (((Scheme_Object * ) 0x2 ) ) )  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM92_COUNT (0+XfOrM91_COUNT)
#   define SETUP_XfOrM92(x) SETUP_XfOrM91(x)

# 1468 "bc/src/fun.c"
    if (multi_ok )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (p -> ku . eval . wait_expr , - 1 , ((void * ) 0 ) , - 1 ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (p -> ku . eval . wait_expr , - 1 , ((void * ) 0 ) , 1 ) )) RET_VALUE_EMPTY_END ; 
  }

# 1472 "bc/src/fun.c"
  else if (obj )
    RET_VALUE_START (obj ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1478 "bc/src/fun.c"
Scheme_Object * 
scheme_force_value (Scheme_Object * obj ) 
{
  /* No conversion */

# 1481 "bc/src/fun.c"
  return force_values (obj , 1 ) ; 
}

Scheme_Object * 
scheme_force_one_value (Scheme_Object * obj ) 
{
  /* No conversion */

# 1487 "bc/src/fun.c"
  return force_values (obj , 0 ) ; 
}

Scheme_Object * 
scheme_force_value_same_mark (Scheme_Object * obj ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM99_COUNT (1)
# define SETUP_XfOrM99(x) SETUP(XfOrM99_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1495 "bc/src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 








  v = FUNCCALL(SETUP_XfOrM99(_), force_values (obj , 1 ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1511 "bc/src/fun.c"
Scheme_Object * 
scheme_force_one_value_same_mark (Scheme_Object * obj ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM100_COUNT (1)
# define SETUP_XfOrM100(x) SETUP(XfOrM100_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1516 "bc/src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 


  v = FUNCCALL(SETUP_XfOrM100(_), force_values (obj , 0 ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1526 "bc/src/fun.c"
static void * apply_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * rator ; 
  int num_rands ; 
  Scheme_Object * * rands ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(rands, 0), PUSH(rator, 1)));
# define XfOrM101_COUNT (2)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rator = NULLED_OUT ; 
  rands = NULLED_OUT ; 

# 1533 "bc/src/fun.c"
  rator = (Scheme_Object * ) p -> ku . k . p1 ; 
  rands = (Scheme_Object * * ) p -> ku . k . p2 ; 
  num_rands = p -> ku . k . i1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 

  if (p -> ku . k . i2 )
    RET_VALUE_START ((void * ) FUNCCALL(SETUP_XfOrM101(_), scheme_do_eval (rator , num_rands , rands , - 1 ) )) RET_VALUE_END ; 
  else 
  RET_VALUE_START ((void * ) FUNCCALL_EMPTY(scheme_do_eval (rator , num_rands , rands , 1 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1546 "bc/src/fun.c"
static Scheme_Object * 
_apply (Scheme_Object * rator , int num_rands , Scheme_Object * * rands , int multi , int eb ) 
{
  /* No conversion */

# 1549 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = rator ; 
  p -> ku . k . p2 = rands ; 
  p -> ku . k . i1 = num_rands ; 
  p -> ku . k . i2 = multi ; 

  return (Scheme_Object * ) scheme_top_level_do (apply_k , eb ) ; 
}

Scheme_Object * 
scheme_apply (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1562 "bc/src/fun.c"
  return _apply (rator , num_rands , rands , 0 , 1 ) ; 
}

Scheme_Object * 
scheme_apply_multi (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1568 "bc/src/fun.c"
  return _apply (rator , num_rands , rands , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_apply_thread_thunk (Scheme_Object * rator ) 
{
  /* No conversion */

# 1574 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = rator ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . i1 = 0 ; 
  p -> ku . k . i2 = 1 ; 

  return (Scheme_Object * ) scheme_top_level_do_worker (apply_k , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_apply_no_eb (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1587 "bc/src/fun.c"
  return _apply (rator , num_rands , rands , 0 , 0 ) ; 
}

Scheme_Object * 
scheme_apply_multi_no_eb (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1593 "bc/src/fun.c"
  return _apply (rator , num_rands , rands , 1 , 0 ) ; 
}

static Scheme_Object * 
finish_apply_with_prompt (void * _data , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1599 "bc/src/fun.c"
  void * * data = (void * * ) _data ; 
  Scheme_Object * rator , * is_multi ; 

  argv = (Scheme_Object * * ) _data ; 
  for (argc = 0 ; data [argc ] ; argc ++ ) {
  }
  rator = (Scheme_Object * ) data [argc + 1 ] ; 
  is_multi = (Scheme_Object * ) data [argc + 2 ] ; 

  if (! (((is_multi ) ) == (scheme_false ) ) ) 
    return scheme_do_eval (rator , argc , argv , - 1 ) ; 
  else 
  return scheme_do_eval (rator , argc , argv , 1 ) ; 
}

static Scheme_Object * 
do_apply_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands , int multi , int top_level ) 
{
  void * * a ; 
  int i ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(rands, 0), PUSH(a, 1), PUSH(rator, 2)));
# define XfOrM111_COUNT (3)
# define SETUP_XfOrM111(x) SETUP(XfOrM111_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 1620 "bc/src/fun.c"
  a = ((void * * ) FUNCCALL(SETUP_XfOrM111(_), GC_malloc (sizeof (void * ) * (3 + num_rands ) ) )) ; 

  for (i = 0 ; i < num_rands ; i ++ ) {
    a [i ] = rands [i ] ; 
  }
  a [num_rands ] = ((void * ) 0 ) ; 
  a [num_rands + 1 ] = rator ; 
  a [num_rands + 2 ] = (multi ? scheme_true : scheme_false ) ; 

  if (top_level ) {
#   define XfOrM113_COUNT (0+XfOrM111_COUNT)
#   define SETUP_XfOrM113(x) SETUP_XfOrM111(x)

# 1630 "bc/src/fun.c"
    if (multi )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_call_with_prompt_multi (finish_apply_with_prompt , a ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_call_with_prompt (finish_apply_with_prompt , a ) )) RET_VALUE_EMPTY_END ; 
  }

# 1634 "bc/src/fun.c"
  else {
#   define XfOrM112_COUNT (0+XfOrM111_COUNT)
#   define SETUP_XfOrM112(x) SETUP_XfOrM111(x)

# 1635 "bc/src/fun.c"
    if (multi )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(_scheme_call_with_prompt_multi (finish_apply_with_prompt , a ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(_scheme_call_with_prompt (finish_apply_with_prompt , a ) )) RET_VALUE_EMPTY_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1642 "bc/src/fun.c"
Scheme_Object * 
scheme_apply_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1645 "bc/src/fun.c"
  return do_apply_with_prompt (rator , num_rands , rands , 0 , 1 ) ; 
}

Scheme_Object * 
scheme_apply_multi_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1651 "bc/src/fun.c"
  return do_apply_with_prompt (rator , num_rands , rands , 1 , 1 ) ; 
}

Scheme_Object * 
_scheme_apply_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1657 "bc/src/fun.c"
  return do_apply_with_prompt (rator , num_rands , rands , 0 , 0 ) ; 
}

Scheme_Object * _scheme_apply_multi_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1662 "bc/src/fun.c"
  return do_apply_with_prompt (rator , num_rands , rands , 1 , 0 ) ; 
}





Scheme_Object * 
scheme_tail_apply (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{




  int i ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(rands, 0), PUSH(p, 1)));
# define XfOrM120_COUNT (2)
# define SETUP_XfOrM120(x) SETUP(XfOrM120_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1679 "bc/src/fun.c"
  p -> ku . apply . tail_rator = rator ; 
  p -> ku . apply . tail_num_rands = num_rands ; 

  if (num_rands ) {
    Scheme_Object * * a ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM120_COUNT)));
#   define XfOrM121_COUNT (1+XfOrM120_COUNT)
#   define SETUP_XfOrM121(x) SETUP(XfOrM121_COUNT)
    a = NULLED_OUT ; 

# 1684 "bc/src/fun.c"
    if (num_rands > p -> tail_buffer_size ) {
#     define XfOrM124_COUNT (0+XfOrM121_COUNT)
#     define SETUP_XfOrM124(x) SETUP_XfOrM121(x)

# 1685 "bc/src/fun.c"
      a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM124(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rands ) ) )) ; 
      p -> tail_buffer = a ; 
      p -> tail_buffer_size = num_rands ; 
    }

# 1688 "bc/src/fun.c"
    else 
    a = p -> tail_buffer ; 
    p -> ku . apply . tail_rands = a ; 
    for (i = num_rands ; i -- ; ) {
      a [i ] = rands [i ] ; 
    }
  }

# 1694 "bc/src/fun.c"
  else 
  p -> ku . apply . tail_rands = ((void * ) 0 ) ; 

  RET_VALUE_START (((Scheme_Object * ) 0x4 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1700 "bc/src/fun.c"
Scheme_Object * 
scheme_tail_apply_no_copy (Scheme_Object * rator , int num_rands , 
Scheme_Object * * rands ) 
{
  /* No conversion */

# 1704 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . apply . tail_rator = rator ; 
  p -> ku . apply . tail_num_rands = num_rands ; 
  p -> ku . apply . tail_rands = rands ; 

  return ((Scheme_Object * ) 0x4 ) ; 
}

static 
Scheme_Object * 
X_scheme_apply_to_list (Scheme_Object * rator , Scheme_Object * rands , int force , 
int top_level ) 
{
  int num_rands , i ; 
  Scheme_Object * * rands_vec ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(rands_vec, 0), PUSH(rands, 1), PUSH(rator, 2)));
# define XfOrM126_COUNT (3)
# define SETUP_XfOrM126(x) SETUP(XfOrM126_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rands_vec = NULLED_OUT ; 

# 1721 "bc/src/fun.c"
  num_rands = (scheme_list_length (rands ) ) ; 
  rands_vec = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM126(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rands ) ) )) ; 

  for (i = 0 ; i < num_rands ; i ++ ) {
#   define XfOrM131_COUNT (0+XfOrM126_COUNT)
#   define SETUP_XfOrM131(x) SETUP_XfOrM126(x)

# 1725 "bc/src/fun.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (rands ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rands ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM132_COUNT (0+XfOrM131_COUNT)
#     define SETUP_XfOrM132(x) SETUP_XfOrM131(x)
      FUNCCALL_EMPTY(scheme_signal_error ("bad application form" ) )
# 1726 "bc/src/fun.c"
      ; 
    }
    rands_vec [i ] = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . car ) ; 
    rands = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . cdr ) ; 
  }

  if (top_level ) {
#   define XfOrM128_COUNT (0+XfOrM126_COUNT)
#   define SETUP_XfOrM128(x) SETUP_XfOrM126(x)

# 1733 "bc/src/fun.c"
    if (force )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_apply (rator , num_rands , rands_vec ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (rator , num_rands , rands_vec ) )) RET_VALUE_EMPTY_END ; 
  }

# 1737 "bc/src/fun.c"
  else {
#   define XfOrM127_COUNT (0+XfOrM126_COUNT)
#   define SETUP_XfOrM127(x) SETUP_XfOrM126(x)

# 1738 "bc/src/fun.c"
    if (force )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (rator , num_rands , rands_vec , 1 ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (rator , num_rands , rands_vec ) )) RET_VALUE_EMPTY_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1745 "bc/src/fun.c"
Scheme_Object * 
scheme_apply_to_list (Scheme_Object * rator , Scheme_Object * rands ) 
{
  /* No conversion */

# 1748 "bc/src/fun.c"
  return X_scheme_apply_to_list (rator , rands , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_tail_apply_to_list (Scheme_Object * rator , Scheme_Object * rands ) 
{
  /* No conversion */

# 1754 "bc/src/fun.c"
  return X_scheme_apply_to_list (rator , rands , 0 , 1 ) ; 
}

Scheme_Object * 
_scheme_apply_to_list (Scheme_Object * rator , Scheme_Object * rands ) 
{
  /* No conversion */

# 1760 "bc/src/fun.c"
  return X_scheme_apply_to_list (rator , rands , 1 , 0 ) ; 
}

Scheme_Object * 
_scheme_tail_apply_to_list (Scheme_Object * rator , Scheme_Object * rands ) 
{
  /* No conversion */

# 1766 "bc/src/fun.c"
  return X_scheme_apply_to_list (rator , rands , 0 , 0 ) ; 
}





static Scheme_Object * make_arity (intptr_t mina , intptr_t maxa , int mode ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
# define XfOrM137_COUNT (0)
# define SETUP_XfOrM137(x) SETUP(XfOrM137_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1775 "bc/src/fun.c"
  if (mina == maxa )
    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (mina ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  else if (maxa == - 1 ) {
#   define XfOrM141_COUNT (0+XfOrM137_COUNT)
#   define SETUP_XfOrM141(x) SETUP_XfOrM137(x)

# 1778 "bc/src/fun.c"
    if (mode == - 3 ) {
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- (mina + 1 ) ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    }

# 1780 "bc/src/fun.c"
    else {
      Scheme_Object * p [1 ] ; 
      BLOCK_SETUP((PUSHARRAY(p, 1, 0+XfOrM141_COUNT)));
#     define XfOrM142_COUNT (3+XfOrM141_COUNT)
#     define SETUP_XfOrM142(x) SETUP(XfOrM142_COUNT)
      p[0] = NULLED_OUT ; 

# 1782 "bc/src/fun.c"
      p [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (mina ) ) ) << 1 ) | 0x1 ) ) ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM142(_), scheme_make_struct_instance (scheme_arity_at_least , 1 , p ) )) RET_VALUE_END ; 
    }
  }

# 1785 "bc/src/fun.c"
  else {
    intptr_t i ; 
    Scheme_Object * l = scheme_null ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM137_COUNT)));
#   define XfOrM138_COUNT (1+XfOrM137_COUNT)
#   define SETUP_XfOrM138(x) SETUP(XfOrM138_COUNT)

# 1789 "bc/src/fun.c"
    for (i = maxa ; i >= mina ; -- i ) {
#     define XfOrM140_COUNT (0+XfOrM138_COUNT)
#     define SETUP_XfOrM140(x) SETUP_XfOrM138(x)

# 1790 "bc/src/fun.c"
      l = FUNCCALL(SETUP_XfOrM140(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , l ) ); 
    }

    RET_VALUE_START (l ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1797 "bc/src/fun.c"
Scheme_Object * scheme_make_arity (mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 1799 "bc/src/fun.c"
  return make_arity (mina , maxa , - 1 ) ; 
}

Scheme_Object * shift_for_drop (Scheme_Object * n , int drop ) 
{
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM145_COUNT (3)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1805 "bc/src/fun.c"
  a [0 ] = n ; 
  a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- drop ) ) ) << 1 ) | 0x1 ) ) ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM145(_), scheme_bitwise_shift (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1810 "bc/src/fun.c"
static Scheme_Object * make_shifted_one (intptr_t n ) 
{
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM146_COUNT (3)
# define SETUP_XfOrM146(x) SETUP(XfOrM146_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1813 "bc/src/fun.c"
  a [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
  a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM146(_), scheme_bitwise_shift (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1818 "bc/src/fun.c"
static Scheme_Object * make_arity_mask (intptr_t mina , intptr_t maxa ) 
{

# 1810 "bc/src/fun.c"
  Scheme_Object * __funcarg121 = NULLED_OUT ; 
  Scheme_Object * __funcarg120 = NULLED_OUT ; 

# 1810 "bc/src/fun.c"
  Scheme_Object * __funcarg119 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(1);
# define XfOrM147_COUNT (0)
# define SETUP_XfOrM147(x) SETUP(XfOrM147_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)



  if (mina == maxa ) {
#   define XfOrM154_COUNT (0+XfOrM147_COUNT)
#   define SETUP_XfOrM154(x) SETUP_XfOrM147(x)

# 1822 "bc/src/fun.c"
    if (mina < 29 )
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 << mina ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_shifted_one (mina ) )) RET_VALUE_EMPTY_END ; 
  }

# 1826 "bc/src/fun.c"
  else if (maxa == - 1 ) {
#   define XfOrM151_COUNT (0+XfOrM147_COUNT)
#   define SETUP_XfOrM151(x) SETUP_XfOrM147(x)

# 1827 "bc/src/fun.c"
    if (mina < 29 ) {
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (((1 << mina ) - 1 ) ^ (intptr_t ) - 1 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    }

# 1829 "bc/src/fun.c"
    else {
#     define XfOrM152_COUNT (0+XfOrM151_COUNT)
#     define SETUP_XfOrM152(x) SETUP_XfOrM151(x)

# 1830 "bc/src/fun.c"
      RET_VALUE_START ((__funcarg120 = (__funcarg121 = FUNCCALL(SETUP_XfOrM152(_), make_shifted_one (mina ) ), FUNCCALL_AGAIN(scheme_bin_minus (__funcarg121 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) )) , FUNCCALL_EMPTY(scheme_bin_bitwise_xor (__funcarg120 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ) )) ) RET_VALUE_END 
      ; 
    }
  }

# 1833 "bc/src/fun.c"
  else {
    mzshort i ; 
    Scheme_Object * mask = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    BLOCK_SETUP((PUSH(mask, 0+XfOrM147_COUNT)));
#   define XfOrM148_COUNT (1+XfOrM147_COUNT)
#   define SETUP_XfOrM148(x) SETUP(XfOrM148_COUNT)

# 1837 "bc/src/fun.c"
    for (i = mina ; i <= maxa ; i ++ ) {
#     define XfOrM150_COUNT (0+XfOrM148_COUNT)
#     define SETUP_XfOrM150(x) SETUP_XfOrM148(x)

# 1838 "bc/src/fun.c"
      mask = (__funcarg119 = FUNCCALL(SETUP_XfOrM150(_), make_shifted_one (i ) ), FUNCCALL_AGAIN(scheme_bin_bitwise_or (__funcarg119 , mask ) )) ; 
    }

    RET_VALUE_START (mask ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1845 "bc/src/fun.c"
Scheme_Object * scheme_make_arity_mask (intptr_t mina , intptr_t maxa ) 
{
  /* No conversion */

# 1847 "bc/src/fun.c"
  return make_arity_mask (mina , maxa ) ; 
}

int scheme_fast_check_arity (Scheme_Object * p , int a ) 


{
  /* No conversion */

# 1854 "bc/src/fun.c"
  Scheme_Type type ; 
  int mina , maxa ; 

  type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  if (type == scheme_prim_type ) {
    mina = ((Scheme_Primitive_Proc * ) p ) -> mina ; 
    maxa = ((Scheme_Primitive_Proc * ) p ) -> mu . maxa ; 
    if (mina < 0 )
      return 0 ; 
    else {
      if (maxa > 0x3FFFFFFE )
        maxa = - 1 ; 
    }
  }

# 1867 "bc/src/fun.c"
  else if (type == scheme_closed_prim_type ) {
    mina = ((Scheme_Closed_Primitive_Proc * ) p ) -> mina ; 
    maxa = ((Scheme_Closed_Primitive_Proc * ) p ) -> maxa ; 
    if (mina == - 2 )
      return 0 ; 
  }

# 1872 "bc/src/fun.c"
  else 
  return 0 ; 

  if (a >= mina && (maxa < 0 || a <= maxa ) )
    return 1 ; 

  return 0 ; 
}

static Scheme_Object * get_or_check_arity (Scheme_Object * p , intptr_t a , Scheme_Object * bign , int inc_ok ) 




{
  Scheme_Type type ; 
  mzshort mina , maxa ; 
  int drop = 0 , cases_count = 0 ; 
  mzshort * cases = ((void * ) 0 ) ; 

# 1881 "bc/src/fun.c"
  Scheme_Object * __funcarg125 = NULLED_OUT ; 

# 1818 "bc/src/fun.c"
  Scheme_Object * __funcarg123 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(cases, 0), PUSH(p, 1), PUSH(bign, 2)));
# define XfOrM160_COUNT (3)
# define SETUP_XfOrM160(x) SETUP(XfOrM160_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1892 "bc/src/fun.c"
  top : 

  type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  if (type == scheme_prim_type ) {
    mina = ((Scheme_Primitive_Proc * ) p ) -> mina ; 
    maxa = ((Scheme_Primitive_Proc * ) p ) -> mu . maxa ; 
    if (mina < 0 ) {
      cases = ((Scheme_Primitive_Proc * ) p ) -> mu . cases ; 
      cases_count = - (mina + 1 ) ; 
    }

# 1901 "bc/src/fun.c"
    else {
      if (maxa > 0x3FFFFFFE )
        maxa = - 1 ; 
    }
  }

# 1905 "bc/src/fun.c"
  else if (type == scheme_closed_prim_type ) {
    mina = ((Scheme_Closed_Primitive_Proc * ) p ) -> mina ; 
    maxa = ((Scheme_Closed_Primitive_Proc * ) p ) -> maxa ; 
    if (mina == - 2 ) {
      cases_count = - maxa ; 
      cases = ((Scheme_Closed_Case_Primitive_Proc * ) p ) -> cases ; 
    }
  }

# 1912 "bc/src/fun.c"
  else if (type == scheme_cont_type || type == scheme_escaping_cont_type ) {
    mina = 0 ; 
    maxa = - 1 ; 
  }

# 1915 "bc/src/fun.c"
  else if ((type == scheme_case_closure_type ) 
  || (type == scheme_case_lambda_sequence_type ) ) {
    Scheme_Case_Lambda * seq ; 
    Scheme_Lambda * data ; 
    int i ; 
    Scheme_Object * mask = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , * v ; 
    BLOCK_SETUP((PUSH(mask, 0+XfOrM160_COUNT), PUSH(seq, 1+XfOrM160_COUNT), PUSH(v, 2+XfOrM160_COUNT), PUSH(data, 3+XfOrM160_COUNT)));
#   define XfOrM190_COUNT (4+XfOrM160_COUNT)
#   define SETUP_XfOrM190(x) SETUP(XfOrM190_COUNT)
    seq = NULLED_OUT ; 
    data = NULLED_OUT ; 
    v = NULLED_OUT ; 

# 1922 "bc/src/fun.c"
    seq = (Scheme_Case_Lambda * ) p ; 
    for (i = 0 ; i < seq -> count ; i ++ ) {
#     define XfOrM198_COUNT (0+XfOrM190_COUNT)
#     define SETUP_XfOrM198(x) SETUP_XfOrM190(x)

# 1924 "bc/src/fun.c"
      v = seq -> array [i ] ; 
      if ((a == - 1 ) || (a == - 3 ) || (a == - 4 ) ) {
#       define XfOrM203_COUNT (0+XfOrM198_COUNT)
#       define SETUP_XfOrM203(x) SETUP_XfOrM198(x)

# 1926 "bc/src/fun.c"
        mask = (__funcarg125 = FUNCCALL(SETUP_XfOrM203(_), get_or_check_arity (v , - 4 , ((void * ) 0 ) , inc_ok ) ), FUNCCALL_AGAIN(scheme_bin_bitwise_or (__funcarg125 , mask ) )) ; 
      }

# 1927 "bc/src/fun.c"
      else {
        if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) 
          data = (Scheme_Lambda * ) v ; 
        else 
        data = ((Scheme_Closure * ) v ) -> code ; 
        mina = maxa = data -> num_params ; 
        if ((& (data ) -> iso ) -> so . keyex & 1 ) {
          if (mina )
            -- mina ; 
          maxa = - 1 ; 
        }

        if (a >= 0 ) {
          if ((a + drop ) >= mina && (maxa < 0 || (a + drop ) <= maxa ) )
            RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
        }

# 1942 "bc/src/fun.c"
        else if (a == - 2 ) {
          if (maxa < 0 )
            RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
        }
      }
    }

    if ((a == - 1 ) || (a == - 3 ) || (a == - 4 ) ) {
#     define XfOrM191_COUNT (0+XfOrM190_COUNT)
#     define SETUP_XfOrM191(x) SETUP_XfOrM190(x)

# 1950 "bc/src/fun.c"
      if (drop )
        mask = FUNCCALL(SETUP_XfOrM191(_), shift_for_drop (mask , drop ) ); 
      if (a != - 4 )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(mask_to_arity (mask , a ) )) RET_VALUE_EMPTY_END ; 
      else 
      RET_VALUE_START (mask ) RET_VALUE_END ; 
    }

# 1956 "bc/src/fun.c"
    else 
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }

# 1958 "bc/src/fun.c"
  else if (type == scheme_proc_struct_type ) {
    int is_method ; 
#   define XfOrM179_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM179(x) SETUP_XfOrM160(x)

# 1960 "bc/src/fun.c"
    if (! inc_ok 
    && scheme_no_arity_property 
    && (scheme_struct_type_property_ref (scheme_no_arity_property , p ) ) ) {
      if (a == - 4 )
        RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }
    if (scheme_reduced_procedure_struct 
    && (scheme_is_struct_instance (scheme_reduced_procedure_struct , p ) ) ) {
#     define XfOrM184_COUNT (0+XfOrM179_COUNT)
#     define SETUP_XfOrM184(x) SETUP_XfOrM179(x)

# 1970 "bc/src/fun.c"
      if (a == - 4 ) {
#       define XfOrM188_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM188(x) SETUP_XfOrM184(x)

# 1971 "bc/src/fun.c"
        p = ((Scheme_Structure * ) p ) -> slots [1 ] ; 
        if (drop )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(shift_for_drop (p , drop ) )) RET_VALUE_EMPTY_END ; 
        else 
        RET_VALUE_START (p ) RET_VALUE_END ; 
      }

      if (a >= 0 ) {
#       define XfOrM187_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM187(x) SETUP_XfOrM184(x)

# 1979 "bc/src/fun.c"
        bign = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (a ) ) ) << 1 ) | 0x1 ) ) ; 
        if (drop )
          bign = FUNCCALL(SETUP_XfOrM187(_), scheme_bin_plus (bign , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (drop ) ) ) << 1 ) | 0x1 ) ) ) ); 
      }
      if ((a == - 1 ) || (a == - 3 ) ) {
#       define XfOrM186_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM186(x) SETUP_XfOrM184(x)

# 1984 "bc/src/fun.c"
        p = ((Scheme_Structure * ) p ) -> slots [1 ] ; 
        if (drop )
          p = FUNCCALL(SETUP_XfOrM186(_), shift_for_drop (p , drop ) ); 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(mask_to_arity (p , a ) )) RET_VALUE_EMPTY_END ; 
      }

# 1988 "bc/src/fun.c"
      else {
#       define XfOrM185_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM185(x) SETUP_XfOrM184(x)

# 1989 "bc/src/fun.c"
        if (FUNCCALL(SETUP_XfOrM185(_), scheme_bin_bitwise_bit_set_p (((Scheme_Structure * ) p ) -> slots [1 ] , bign ) ))
          RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
        else 
        RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
      }
    }

# 1994 "bc/src/fun.c"
    else {
#     define XfOrM182_COUNT (0+XfOrM179_COUNT)
#     define SETUP_XfOrM182(x) SETUP_XfOrM179(x)

# 1995 "bc/src/fun.c"
      p = FUNCCALL(SETUP_XfOrM182(_), scheme_extract_struct_procedure (p , - 1 , ((void * ) 0 ) , & is_method ) ); 
      if (! (! (((intptr_t ) (p ) ) & 0x1 ) && ((((p ) -> type ) >= scheme_prim_type ) && (((p ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
        if (a == - 4 )
          RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
        else if ((a == - 1 ) || (a == - 3 ) )
          RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
        else 
        RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
      }
      if (is_method )
        drop ++ ; 
    }
    {
#     define XfOrM180_COUNT (0+XfOrM179_COUNT)
#     define SETUP_XfOrM180(x) SETUP_XfOrM179(x)

# 2007 "bc/src/fun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM181_COUNT (0+XfOrM180_COUNT)
#       define SETUP_XfOrM181(x) SETUP_XfOrM180(x)
        FUNCCALL(SETUP_XfOrM181(_), scheme_out_of_fuel () )
# 2007 "bc/src/fun.c"
        ; 
      }
    }

# 2007 "bc/src/fun.c"
    ; 
    goto top ; 
  }

# 2112 "bc/src/fun.c"
  else if (type == scheme_proc_chaperone_type ) {
#   define XfOrM176_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM176(x) SETUP_XfOrM160(x)

# 2113 "bc/src/fun.c"
    p = (((Scheme_Chaperone * ) p ) -> val ) ; 
    {
#     define XfOrM177_COUNT (0+XfOrM176_COUNT)
#     define SETUP_XfOrM177(x) SETUP_XfOrM176(x)

# 2114 "bc/src/fun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM178_COUNT (0+XfOrM177_COUNT)
#       define SETUP_XfOrM178(x) SETUP_XfOrM177(x)
        FUNCCALL(SETUP_XfOrM178(_), scheme_out_of_fuel () )
# 2114 "bc/src/fun.c"
        ; 
      }
    }

# 2114 "bc/src/fun.c"
    ; 
    goto top ; 
  }

# 2116 "bc/src/fun.c"
  else {
    Scheme_Lambda * data ; 
    data = NULLED_OUT ; 
    if (type == scheme_lambda_type )
      data = (Scheme_Lambda * ) p ; 
    else if (type == scheme_closure_type )
      data = ((Scheme_Closure * ) p ) -> code ; 
    else 
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

    mina = maxa = data -> num_params ; 
    if ((& (data ) -> iso ) -> so . keyex & 1 ) {
      if (mina )
        -- mina ; 
      maxa = - 1 ; 
    }
  }

  if (cases ) {
    int count = cases_count , i ; 
#   define XfOrM165_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM165(x) SETUP_XfOrM160(x)

# 2136 "bc/src/fun.c"
    if ((a == - 1 ) || (a == - 3 ) || (a == - 4 ) ) {

      Scheme_Object * mask = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
      BLOCK_SETUP((PUSH(mask, 0+XfOrM165_COUNT)));
#     define XfOrM171_COUNT (1+XfOrM165_COUNT)
#     define SETUP_XfOrM171(x) SETUP(XfOrM171_COUNT)

# 2140 "bc/src/fun.c"
      for (i = 0 ; i < count ; i ++ ) {
#       define XfOrM173_COUNT (0+XfOrM171_COUNT)
#       define SETUP_XfOrM173(x) SETUP_XfOrM171(x)

# 2141 "bc/src/fun.c"
        mask = (__funcarg123 = FUNCCALL(SETUP_XfOrM173(_), make_arity_mask (cases [2 * i ] , cases [(2 * i ) + 1 ] ) ), FUNCCALL_AGAIN(scheme_bin_bitwise_or (__funcarg123 , mask ) )) ; 
      }
      if (drop )
        mask = FUNCCALL(SETUP_XfOrM171(_), shift_for_drop (mask , drop ) ); 


      if (a == - 4 )
        RET_VALUE_START (mask ) RET_VALUE_END ; 
      else 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(mask_to_arity (mask , a ) )) RET_VALUE_EMPTY_END ; 
    }

    if (a == - 2 ) {
      for (i = 0 ; i < count ; i ++ ) {
        if (cases [(2 * i ) + 1 ] < 0 )
          RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
      }

      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

    a += drop ; 

    for (i = 0 ; i < count ; i ++ ) {
      int na , xa ; 
      na = cases [2 * i ] ; 
      xa = cases [(2 * i ) + 1 ] ; 
      if ((a >= na ) && ((xa < 0 ) || (a <= xa ) ) )
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    }

    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }

  if ((a == - 1 ) || (a == - 3 ) || (a == - 4 ) ) {
#   define XfOrM161_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM161(x) SETUP_XfOrM160(x)

# 2176 "bc/src/fun.c"
    if (mina < drop ) {
      if ((maxa >= 0 ) && (maxa < drop ) ) {
        if (a == - 4 )
          RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
        else 
        RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
      }

# 2182 "bc/src/fun.c"
      else 
      mina = 0 ; 
    }

# 2184 "bc/src/fun.c"
    else 
    mina -= drop ; 
    if (maxa > 0 ) {

      maxa -= drop ; 
    }

    if (a == - 4 )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity_mask (mina , maxa ) )) RET_VALUE_EMPTY_END ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity (mina , maxa , a ) )) RET_VALUE_EMPTY_END ; 
  }

  if (a == - 2 )
    RET_VALUE_START ((maxa < 0 ) ? scheme_true : scheme_false ) RET_VALUE_END ; 

  a += drop ; 

  if (a < mina || (maxa >= 0 && a > maxa ) )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2208 "bc/src/fun.c"
Scheme_Object * scheme_get_or_check_arity (Scheme_Object * p , intptr_t a ) 
{
  /* No conversion */

# 2210 "bc/src/fun.c"
  return get_or_check_arity (p , a , ((void * ) 0 ) , 1 ) ; 
}

Scheme_Object * scheme_get_arity_mask (Scheme_Object * p ) 
{
  /* No conversion */

# 2215 "bc/src/fun.c"
  return get_or_check_arity (p , - 4 , ((void * ) 0 ) , 1 ) ; 
}

int scheme_check_proc_arity2 (const char * where , int a , 
int which , int argc , Scheme_Object * * argv , 
int false_ok ) 
{
  Scheme_Object * p ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(where, 0), PUSH(argv, 1)));
# define XfOrM212_COUNT (2)
# define SETUP_XfOrM212(x) SETUP(XfOrM212_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 2224 "bc/src/fun.c"
  if (which < 0 )
    p = argv [0 ] ; 
  else 
  p = argv [which ] ; 

  if (false_ok && (((p ) ) == (scheme_false ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 

  if (! (! (((intptr_t ) (p ) ) & 0x1 ) && ((((p ) -> type ) >= scheme_prim_type ) && (((p ) -> type ) <= scheme_proc_chaperone_type ) ) ) || (((FUNCCALL(SETUP_XfOrM212(_), get_or_check_arity (p , a , ((void * ) 0 ) , 1 ) )) ) == (scheme_false ) ) ) {
#   define XfOrM213_COUNT (0+XfOrM212_COUNT)
#   define SETUP_XfOrM213(x) SETUP_XfOrM212(x)

# 2233 "bc/src/fun.c"
    if (where ) {
      char buffer [60 ] ; 
      const char * pre , * post ; 
#     define XfOrM214_COUNT (0+XfOrM213_COUNT)
#     define SETUP_XfOrM214(x) SETUP_XfOrM213(x)
      pre = NULLED_OUT ; 
      post = NULLED_OUT ; 

# 2237 "bc/src/fun.c"
      if (false_ok ) {
        pre = "(or/c " ; 
        post = " #f)" ; 
      }

# 2240 "bc/src/fun.c"
      else 
      pre = post = "" ; 

      switch (a ) {
#       define XfOrM215_COUNT (0+XfOrM214_COUNT)
#       define SETUP_XfOrM215(x) SETUP_XfOrM214(x)

# 2244 "bc/src/fun.c"
        case 0 : (
        sprintf (buffer , "%s(-> any)%s" , pre , post ) ) ; 
        break ; 
        case 1 : (
        sprintf (buffer , "%s(any/c . -> . any)%s" , pre , post ) ) ; 
        break ; 
        case 2 : (
        sprintf (buffer , "%s(any/c any/c . -> . any)%s" , pre , post ) ) ; 
        break ; 
        case 3 : (
        sprintf (buffer , "%s(any/c any/c any/c . -> . any)%s" , pre , post ) ) ; 
        break ; 
        default : (
        sprintf (buffer , "%s(procedure-arity-includes/c %d)%s" , 
        pre , a , post ) ) ; 
        break ; 
      }
      FUNCCALL_EMPTY(scheme_wrong_contract (where , buffer , which , argc , argv ) )
      ; 
    }

# 2263 "bc/src/fun.c"
    else 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2270 "bc/src/fun.c"
int scheme_check_proc_arity (const char * where , int a , 
int which , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2273 "bc/src/fun.c"
  return scheme_check_proc_arity2 (where , a , which , argc , argv , 0 ) ; 
}

int scheme_closure_preserves_marks (Scheme_Object * p ) 
{
  /* No conversion */

# 2278 "bc/src/fun.c"
  Scheme_Type type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  Scheme_Lambda * data ; 






  if (type == scheme_closure_type ) {
    data = ((Scheme_Closure * ) p ) -> code ; 
  }

# 2288 "bc/src/fun.c"
  else if (type == scheme_lambda_type ) {
    data = (Scheme_Lambda * ) p ; 
  }

# 2290 "bc/src/fun.c"
  else 
  return 0 ; 

  if ((& (data ) -> iso ) -> so . keyex & 4 )
    return 1 ; 

  return 0 ; 
}

Scheme_Object * scheme_get_or_check_procedure_shape (Scheme_Object * e , Scheme_Object * expected , int imprecise ) 

{
  Scheme_Object * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(p, 1), PUSH(expected, 2)));
# define XfOrM221_COUNT (3)
# define SETUP_XfOrM221(x) SETUP(XfOrM221_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 

# 2304 "bc/src/fun.c"
  if (expected 
  && ((Scheme_Type ) (((((intptr_t ) (expected ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expected ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#   define XfOrM231_COUNT (0+XfOrM221_COUNT)
#   define SETUP_XfOrM231(x) SETUP_XfOrM221(x)

# 2306 "bc/src/fun.c"
    if ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [0 ] == 's' ) {
#     define XfOrM233_COUNT (0+XfOrM231_COUNT)
#     define SETUP_XfOrM233(x) SETUP_XfOrM231(x)

# 2307 "bc/src/fun.c"
      RET_VALUE_START ((FUNCCALL(SETUP_XfOrM233(_), scheme_get_or_check_structure_shape (e , expected ) )
      ? expected 
      : ((void * ) 0 ) ) ) 
# 2307 "bc/src/fun.c"
      RET_VALUE_END 

      ; 
    }

# 2310 "bc/src/fun.c"
    else if ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [0 ] == 'p' ) {
#     define XfOrM232_COUNT (0+XfOrM231_COUNT)
#     define SETUP_XfOrM232(x) SETUP_XfOrM231(x)

# 2311 "bc/src/fun.c"
      RET_VALUE_START ((FUNCCALL(SETUP_XfOrM232(_), scheme_get_or_check_structure_property_shape (e , expected ) )
      ? expected 
      : ((void * ) 0 ) ) ) 
# 2311 "bc/src/fun.c"
      RET_VALUE_END 

      ; 
    }
  }

  if ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_inline_variant_type ) ) 
    e = (((Scheme_Vector * ) (e ) ) -> els ) [1 ] ; 

  if (! (! (((intptr_t ) (e ) ) & 0x1 ) && ((((e ) -> type ) >= scheme_prim_type ) && (((e ) -> type ) <= scheme_proc_chaperone_type ) ) ) && (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) >= _scheme_ir_values_types_ ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  p = FUNCCALL(SETUP_XfOrM221(_), scheme_get_or_check_arity (e , - 3 ) ); 
  if (((p ) ) == (scheme_false ) ) 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  if ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {

    int sz = 32 , c = 0 ; 
    char * b , * naya ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM221_COUNT), PUSH(naya, 1+XfOrM221_COUNT)));
#   define XfOrM226_COUNT (2+XfOrM221_COUNT)
#   define SETUP_XfOrM226(x) SETUP(XfOrM226_COUNT)
    b = NULLED_OUT ; 
    naya = NULLED_OUT ; 

# 2331 "bc/src/fun.c"
    b = (char * ) FUNCCALL(SETUP_XfOrM226(_), GC_malloc_atomic (sz ) ); 

    while (((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM229_COUNT (0+XfOrM226_COUNT)
#     define SETUP_XfOrM229(x) SETUP_XfOrM226(x)

# 2334 "bc/src/fun.c"
      if (sz - c < 10 ) {
        sz *= 2 ; 
#       define XfOrM230_COUNT (0+XfOrM229_COUNT)
#       define SETUP_XfOrM230(x) SETUP_XfOrM229(x)

# 2336 "bc/src/fun.c"
        naya = (char * ) FUNCCALL(SETUP_XfOrM230(_), GC_malloc_atomic (sz ) ); 
        (memcpy (naya , b , c ) ) ; 
        b = naya ; 
      }
      if (c )
        b [c ++ ] = ':' ; 
      c += (sprintf (b XFORM_OK_PLUS c , "%" "l" "d" , (((intptr_t ) ((((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . car ) ) ) >> 1 ) ) ) ; 

      p = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ; 
    }
    b [c ] = c ; 
    p = FUNCCALL(SETUP_XfOrM226(_), scheme_intern_exact_symbol (b , c ) ); 
  }

# 2348 "bc/src/fun.c"
  else {


    intptr_t i = (((intptr_t ) (p ) ) >> 1 ) ; 
#   define XfOrM222_COUNT (0+XfOrM221_COUNT)
#   define SETUP_XfOrM222(x) SETUP_XfOrM221(x)

# 2352 "bc/src/fun.c"
    i = ((uintptr_t ) i ) << 1 ; 
    if (expected && (((intptr_t ) (expected ) ) & 0x1 ) && ! ((((intptr_t ) (expected ) ) >> 1 ) & 0x1 ) ) {
    }

    else {
#     define XfOrM223_COUNT (0+XfOrM222_COUNT)
#     define SETUP_XfOrM223(x) SETUP_XfOrM222(x)

# 2357 "bc/src/fun.c"
      if (! imprecise && FUNCCALL(SETUP_XfOrM223(_), scheme_closure_preserves_marks (e ) )) {
        i |= 0x1 ; 
      }
    }
    p = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) ; 
  }

  if (expected && ! ((expected ) == (p ) ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * 
void_func (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2377 "bc/src/fun.c"
  return scheme_void ; 
}

static Scheme_Object * 
void_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2383 "bc/src/fun.c"
  return ((argv [0 ] ) == (scheme_void ) ) ? scheme_true : scheme_false ; 
}

Scheme_Object * 
scheme_check_not_undefined (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2389 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("check-not-unsafe-undefined" , "symbol?" , 1 , argc , argv ) ; 

  if ((argv [0 ] ) == (scheme_undefined ) )  {
    scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , 
    argv [1 ] , 
    "%S: undefined;\n cannot use before initialization" , 
    argv [1 ] ) ; 
  }

  return argv [0 ] ; 
}

Scheme_Object * 
scheme_check_assign_not_undefined (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2405 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("check-not-unsafe-undefined/assign" , "symbol?" , 1 , argc , argv ) ; 

  if ((argv [0 ] ) == (scheme_undefined ) )  {
    scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , 
    argv [1 ] , 
    "%S: assignment disallowed;\n cannot assign before initialization" , 
    argv [1 ] ) ; 
  }

  return argv [0 ] ; 
}

static Scheme_Object * chaperone_unsafe_undefined (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2420 "bc/src/fun.c"
  if ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    return scheme_chaperone_not_undefined (argv [0 ] ) ; 
  else 
  return argv [0 ] ; 
}

static Scheme_Object * 
procedure_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2429 "bc/src/fun.c"
  return ((! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * primitive_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2434 "bc/src/fun.c"
  int isprim ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) 
    isprim = (((Scheme_Primitive_Proc * ) argv [0 ] ) -> pp . flags & 4 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) 
    isprim = (((Scheme_Closed_Primitive_Proc * ) argv [0 ] ) -> pp . flags & 4 ) ; 
  else 
  isprim = 0 ; 

  return isprim ? scheme_true : scheme_false ; 
}

static Scheme_Object * primitive_closure_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2448 "bc/src/fun.c"
  int isprim ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) 
    isprim = (((Scheme_Closed_Primitive_Proc * ) argv [0 ] ) -> pp . flags & 4 ) ; 
  else 
  isprim = 0 ; 

  return isprim ? scheme_true : scheme_false ; 
}

Scheme_Object * scheme_proc_struct_name_source (Scheme_Object * a ) 
{
  Scheme_Object * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(b, 1)));
# define XfOrM244_COUNT (2)
# define SETUP_XfOrM244(x) SETUP(XfOrM244_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 2462 "bc/src/fun.c"
  while ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) {
#   define XfOrM252_COUNT (0+XfOrM244_COUNT)
#   define SETUP_XfOrM252(x) SETUP_XfOrM244(x)

# 2463 "bc/src/fun.c"
    if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
      a = (((Scheme_Chaperone * ) a ) -> val ) ; 
    if (scheme_object_name_property 
    && (scheme_struct_type_property_ref (scheme_object_name_property , a ) ) ) {
      RET_VALUE_START (a ) RET_VALUE_END ; 
    }

# 2468 "bc/src/fun.c"
    else if (scheme_reduced_procedure_struct 
    && (scheme_is_struct_instance (scheme_reduced_procedure_struct , a ) ) 
    && (! (((((Scheme_Structure * ) a ) -> slots [2 ] ) ) == (scheme_false ) ) ) ) {
      RET_VALUE_START (a ) RET_VALUE_END ; 
    }

# 2472 "bc/src/fun.c"
    else {


      int is_method ; 
#     define XfOrM253_COUNT (0+XfOrM252_COUNT)
#     define SETUP_XfOrM253(x) SETUP_XfOrM252(x)

# 2476 "bc/src/fun.c"
      b = FUNCCALL(SETUP_XfOrM253(_), scheme_extract_struct_procedure (a , - 1 , ((void * ) 0 ) , & is_method ) ); 
      if (! is_method && (! (((intptr_t ) (b ) ) & 0x1 ) && ((((b ) -> type ) >= scheme_prim_type ) && (((b ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
#       define XfOrM254_COUNT (0+XfOrM253_COUNT)
#       define SETUP_XfOrM254(x) SETUP_XfOrM253(x)

# 2478 "bc/src/fun.c"
        a = b ; 
        {
#         define XfOrM255_COUNT (0+XfOrM254_COUNT)
#         define SETUP_XfOrM255(x) SETUP_XfOrM254(x)

# 2479 "bc/src/fun.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM256_COUNT (0+XfOrM255_COUNT)
#           define SETUP_XfOrM256(x) SETUP_XfOrM255(x)
            FUNCCALL(SETUP_XfOrM256(_), scheme_out_of_fuel () )
# 2479 "bc/src/fun.c"
            ; 
          }
        }

# 2479 "bc/src/fun.c"
        ; 
      }

# 2480 "bc/src/fun.c"
      else 
      break ; 
    }
  }

  RET_VALUE_START (a ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2488 "bc/src/fun.c"
const char * scheme_get_proc_name (Scheme_Object * p , int * len , int for_error ) 


{
  Scheme_Type type ; 
  int dummy ; 
  char * s ; 
  char * __funcarg126 = NULLED_OUT ; 
  DECL_RET_SAVE (const char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(len, 1), PUSH(p, 2)));
# define XfOrM259_COUNT (3)
# define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 

# 2496 "bc/src/fun.c"
  if (! len )
    len = & dummy ; 

  top : 

  type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  if (type == scheme_prim_type ) {
    if (((Scheme_Primitive_Proc * ) p ) -> name )
      * len = strlen (((Scheme_Primitive_Proc * ) p ) -> name ) ; 
    RET_VALUE_START (((Scheme_Primitive_Proc * ) p ) -> name ) RET_VALUE_END ; 
  }

# 2506 "bc/src/fun.c"
  else if (type == scheme_closed_prim_type ) {
    if (((Scheme_Closed_Primitive_Proc * ) p ) -> name )
      * len = strlen (((Scheme_Closed_Primitive_Proc * ) p ) -> name ) ; 
    RET_VALUE_START (((Scheme_Closed_Primitive_Proc * ) p ) -> name ) RET_VALUE_END ; 
  }

# 2510 "bc/src/fun.c"
  else if (type == scheme_cont_type || type == scheme_escaping_cont_type ) {
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 2512 "bc/src/fun.c"
  else if (type == scheme_case_closure_type ) {
    Scheme_Object * n ; 
#   define XfOrM282_COUNT (0+XfOrM259_COUNT)
#   define SETUP_XfOrM282(x) SETUP_XfOrM259(x)
    n = NULLED_OUT ; 

# 2515 "bc/src/fun.c"
    n = ((Scheme_Case_Lambda * ) p ) -> name ; 
    if (n ) {
#     define XfOrM283_COUNT (0+XfOrM282_COUNT)
#     define SETUP_XfOrM283(x) SETUP_XfOrM282(x)

# 2517 "bc/src/fun.c"
      if ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) )  {

        n = (((Scheme_Small_Object * ) (n ) ) -> u . ptr_val ) ; 
        if (((n ) ) == (scheme_false ) ) 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

      if ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
        n = (((Scheme_Vector * ) (n ) ) -> els ) [0 ] ; 
        if (((n ) ) == (scheme_false ) ) 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

      if (for_error < 0 ) {
        s = (char * ) n ; 
        * len = - 1 ; 
      }

# 2533 "bc/src/fun.c"
      else {
#       define XfOrM284_COUNT (0+XfOrM283_COUNT)
#       define SETUP_XfOrM284(x) SETUP_XfOrM283(x)

# 2534 "bc/src/fun.c"
        * len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (n ) ) ) -> len ) ; 
        s = FUNCCALL(SETUP_XfOrM284(_), scheme_symbol_val (n ) ); 
      }
    }

# 2537 "bc/src/fun.c"
    else 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 2539 "bc/src/fun.c"
  else if (type == scheme_proc_struct_type ) {

    Scheme_Object * other ; 
    BLOCK_SETUP((PUSH(other, 0+XfOrM259_COUNT)));
#   define XfOrM274_COUNT (1+XfOrM259_COUNT)
#   define SETUP_XfOrM274(x) SETUP(XfOrM274_COUNT)
    other = NULLED_OUT ; 

# 2542 "bc/src/fun.c"
    other = FUNCCALL(SETUP_XfOrM274(_), scheme_proc_struct_name_source (p ) ); 
    if ((other ) == (p ) )  {
#     define XfOrM276_COUNT (0+XfOrM274_COUNT)
#     define SETUP_XfOrM276(x) SETUP_XfOrM274(x)

# 2544 "bc/src/fun.c"
      if (scheme_reduced_procedure_struct 
      && (scheme_is_struct_instance (scheme_reduced_procedure_struct , p ) ) ) {

        Scheme_Object * sym = ((Scheme_Structure * ) p ) -> slots [2 ] ; 
#       define XfOrM279_COUNT (0+XfOrM276_COUNT)
#       define SETUP_XfOrM279(x) SETUP_XfOrM276(x)

# 2548 "bc/src/fun.c"
        if (for_error < 0 ) {
          s = (char * ) sym ; 
          * len = - 1 ; 
        }

# 2551 "bc/src/fun.c"
        else {
#         define XfOrM280_COUNT (0+XfOrM279_COUNT)
#         define SETUP_XfOrM280(x) SETUP_XfOrM279(x)

# 2552 "bc/src/fun.c"
          * len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) ; 
          s = FUNCCALL(SETUP_XfOrM280(_), scheme_symbol_val (sym ) ); 
        }
      }

# 2555 "bc/src/fun.c"
      else {
        Scheme_Object * sym ; 
        intptr_t offset ; 
        BLOCK_SETUP((PUSH(sym, 0+XfOrM276_COUNT)));
#       define XfOrM277_COUNT (1+XfOrM276_COUNT)
#       define SETUP_XfOrM277(x) SETUP(XfOrM277_COUNT)
        sym = NULLED_OUT ; 

# 2558 "bc/src/fun.c"
        sym = ((((Scheme_Structure * ) p ) -> stype ) -> name ) ; 
        * len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) ; 
        s = (char * ) FUNCCALL(SETUP_XfOrM277(_), GC_malloc_atomic ((* len ) + 8 ) ); 
        if (0 ) {
#         define XfOrM278_COUNT (0+XfOrM277_COUNT)
#         define SETUP_XfOrM278(x) SETUP_XfOrM277(x)
          (
# 2562 "bc/src/fun.c"
          memcpy (s , "struct " , 7 ) ) ; 
          offset = 7 ; 
        }

# 2564 "bc/src/fun.c"
        else 
        offset = 0 ; 
        (__funcarg126 = FUNCCALL(SETUP_XfOrM277(_), scheme_symbol_val (sym ) ), (memcpy (s + offset , __funcarg126 , * len ) ) ) ; 
        (* len ) += offset ; 
        s [* len ] = 0 ; 
        RET_VALUE_START (s ) RET_VALUE_END ; 
      }
    }

# 2571 "bc/src/fun.c"
    else {
      p = other ; 
      goto top ; 
    }
  }

# 2575 "bc/src/fun.c"
  else if (type == scheme_proc_chaperone_type ) {
#   define XfOrM271_COUNT (0+XfOrM259_COUNT)
#   define SETUP_XfOrM271(x) SETUP_XfOrM259(x)

# 2576 "bc/src/fun.c"
    p = (((Scheme_Chaperone * ) p ) -> val ) ; 
    {
#     define XfOrM272_COUNT (0+XfOrM271_COUNT)
#     define SETUP_XfOrM272(x) SETUP_XfOrM271(x)

# 2577 "bc/src/fun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM273_COUNT (0+XfOrM272_COUNT)
#       define SETUP_XfOrM273(x) SETUP_XfOrM272(x)
        FUNCCALL(SETUP_XfOrM273(_), scheme_out_of_fuel () )
# 2577 "bc/src/fun.c"
        ; 
      }
    }

# 2577 "bc/src/fun.c"
    ; 
    goto top ; 
  }

# 2579 "bc/src/fun.c"
  else {
    Scheme_Object * name ; 
#   define XfOrM261_COUNT (0+XfOrM259_COUNT)
#   define SETUP_XfOrM261(x) SETUP_XfOrM259(x)
    name = NULLED_OUT ; 

# 2582 "bc/src/fun.c"
    if ((type == scheme_ir_lambda_type ) 
    || (type == scheme_lambda_type ) ) {
      name = ((Scheme_Lambda * ) p ) -> name ; 
    }

# 2585 "bc/src/fun.c"
    else if (type == scheme_closure_type ) {
      name = ((Scheme_Closure * ) p ) -> code -> name ; 
    }

# 2587 "bc/src/fun.c"
    else if (type == scheme_case_lambda_sequence_type ) {
      Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) p ; 
      if (! cl -> count )
        name = ((void * ) 0 ) ; 
      else 
      name = ((Scheme_Lambda * ) cl -> array [0 ] ) -> name ; 
    }

# 2593 "bc/src/fun.c"
    else {

      name = ((Scheme_Native_Closure * ) p ) -> code -> u2 . name ; 
      if (name && ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) ) {


        name = ((Scheme_Lambda * ) name ) -> name ; 
      }
    }

    if (name ) {
#     define XfOrM262_COUNT (0+XfOrM261_COUNT)
#     define SETUP_XfOrM262(x) SETUP_XfOrM261(x)

# 2604 "bc/src/fun.c"
      if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
        name = (((Scheme_Vector * ) (name ) ) -> els ) [0 ] ; 
        if (((name ) ) == (scheme_false ) ) 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      if (for_error < 0 ) {
        s = (char * ) name ; 
        * len = - 1 ; 
      }

# 2612 "bc/src/fun.c"
      else {
#       define XfOrM263_COUNT (0+XfOrM262_COUNT)
#       define SETUP_XfOrM263(x) SETUP_XfOrM262(x)

# 2613 "bc/src/fun.c"
        * len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
        s = FUNCCALL(SETUP_XfOrM263(_), scheme_symbol_val (name ) ); 
      }
    }

# 2616 "bc/src/fun.c"
    else 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (0 ) {
    char * r ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM259_COUNT)));
#   define XfOrM260_COUNT (1+XfOrM259_COUNT)
#   define SETUP_XfOrM260(x) SETUP(XfOrM260_COUNT)
    r = NULLED_OUT ; 

# 2623 "bc/src/fun.c"
    r = (char * ) FUNCCALL(SETUP_XfOrM260(_), GC_malloc_atomic ((* len ) + 11 ) ); 
    (memcpy (r , "procedure " , 10 ) ) ; 
    (memcpy (r + 10 , s , * len + 1 ) ) ; 
    * len += 10 ; 

    RET_VALUE_START (r ) RET_VALUE_END ; 
  }

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2634 "bc/src/fun.c"
Scheme_Object * scheme_get_proc_realm (Scheme_Object * p ) 
{
  Scheme_Type type ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM291_COUNT (1)
# define SETUP_XfOrM291(x) SETUP(XfOrM291_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2638 "bc/src/fun.c"
  top : 

  type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  if (type == scheme_prim_type ) {
    if (((((Scheme_Primitive_Proc * ) p ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == (128 | 256 ) ) 
    || ((((Scheme_Primitive_Proc * ) p ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 32 ) ) {
      Scheme_Object * name_info = ((Scheme_Primitive_Closure * ) p ) -> val [2 ] ; 
      if ((Scheme_Type ) (((((intptr_t ) (name_info ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name_info ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
        RET_VALUE_START ((((Scheme_Simple_Object * ) (name_info ) ) -> u . pair_val . car ) ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (name_info ) RET_VALUE_END ; 
    }

# 2649 "bc/src/fun.c"
    else if ((((Scheme_Primitive_Proc * ) p ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == (64 | 128 ) ) {
      Scheme_Struct_Property * prop = (Scheme_Struct_Property * ) ((Scheme_Primitive_Closure * ) p ) -> val [0 ] ; 
      RET_VALUE_START (prop -> realm ) RET_VALUE_END ; 
    }

# 2652 "bc/src/fun.c"
    else if ((((Scheme_Primitive_Proc * ) p ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 64 ) {
      RET_VALUE_START (((Scheme_Primitive_Closure * ) p ) -> val [1 ] ) RET_VALUE_END ; 
    }
    RET_VALUE_START (scheme_primitive_realm ) RET_VALUE_END ; 
  }

# 2656 "bc/src/fun.c"
  else if (type == scheme_closed_prim_type ) {
    RET_VALUE_START (scheme_primitive_realm ) RET_VALUE_END ; 
  }

# 2658 "bc/src/fun.c"
  else if (type == scheme_cont_type || type == scheme_escaping_cont_type ) {
    RET_VALUE_START (scheme_default_realm ) RET_VALUE_END ; 
  }

# 2660 "bc/src/fun.c"
  else if (type == scheme_case_closure_type ) {
    Scheme_Object * n = ((Scheme_Case_Lambda * ) p ) -> name ; 
    if (n ) {
      if ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
        n = (((Scheme_Small_Object * ) (n ) ) -> u . ptr_val ) ; 
      if (((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && ((((Scheme_Vector * ) (n ) ) -> size ) > 7 ) )
        RET_VALUE_START ((((Scheme_Vector * ) (n ) ) -> els ) [7 ] ) RET_VALUE_END ; 
    }
    RET_VALUE_START (scheme_default_realm ) RET_VALUE_END ; 
  }

# 2669 "bc/src/fun.c"
  else if (type == scheme_proc_struct_type ) {
#   define XfOrM300_COUNT (0+XfOrM291_COUNT)
#   define SETUP_XfOrM300(x) SETUP_XfOrM291(x)

# 2670 "bc/src/fun.c"
    while ((((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) p ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) p ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) {
#     define XfOrM306_COUNT (0+XfOrM300_COUNT)
#     define SETUP_XfOrM306(x) SETUP_XfOrM300(x)

# 2671 "bc/src/fun.c"
      {
#       define XfOrM309_COUNT (0+XfOrM306_COUNT)
#       define SETUP_XfOrM309(x) SETUP_XfOrM306(x)

# 2671 "bc/src/fun.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM310_COUNT (0+XfOrM309_COUNT)
#         define SETUP_XfOrM310(x) SETUP_XfOrM309(x)
          FUNCCALL(SETUP_XfOrM310(_), scheme_out_of_fuel () )
# 2671 "bc/src/fun.c"
          ; 
        }
      }

# 2671 "bc/src/fun.c"
      ; 
      if (((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        p = (((Scheme_Chaperone * ) p ) -> val ) ; 
      if (scheme_reduced_procedure_struct 
      && (scheme_is_struct_instance (scheme_reduced_procedure_struct , p ) ) ) {
        if (! (((((Scheme_Structure * ) p ) -> slots [2 ] ) ) == (scheme_false ) ) ) 
          RET_VALUE_START (((Scheme_Structure * ) p ) -> slots [4 ] ) RET_VALUE_END ; 
        p = ((Scheme_Structure * ) p ) -> slots [0 ] ; 
      }

# 2679 "bc/src/fun.c"
      else {
        int is_method ; 
#       define XfOrM307_COUNT (0+XfOrM306_COUNT)
#       define SETUP_XfOrM307(x) SETUP_XfOrM306(x)

# 2681 "bc/src/fun.c"
        p = FUNCCALL(SETUP_XfOrM307(_), scheme_extract_struct_procedure (p , - 1 , ((void * ) 0 ) , & is_method ) ); 
      }
    }
    if (! (((intptr_t ) (p ) ) & 0x1 ) && ((((p ) -> type ) >= scheme_prim_type ) && (((p ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
      goto top ; 
  }

# 2686 "bc/src/fun.c"
  else if (type == scheme_proc_chaperone_type ) {
#   define XfOrM297_COUNT (0+XfOrM291_COUNT)
#   define SETUP_XfOrM297(x) SETUP_XfOrM291(x)

# 2687 "bc/src/fun.c"
    p = (((Scheme_Chaperone * ) p ) -> val ) ; 
    {
#     define XfOrM298_COUNT (0+XfOrM297_COUNT)
#     define SETUP_XfOrM298(x) SETUP_XfOrM297(x)

# 2688 "bc/src/fun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM299_COUNT (0+XfOrM298_COUNT)
#       define SETUP_XfOrM299(x) SETUP_XfOrM298(x)
        FUNCCALL(SETUP_XfOrM299(_), scheme_out_of_fuel () )
# 2688 "bc/src/fun.c"
        ; 
      }
    }

# 2688 "bc/src/fun.c"
    ; 
    goto top ; 
  }

# 2690 "bc/src/fun.c"
  else {
    Scheme_Object * name ; 
    name = NULLED_OUT ; 
    if (type == scheme_closure_type ) {
      name = ((Scheme_Closure * ) p ) -> code -> name ; 
    }

# 2695 "bc/src/fun.c"
    else if (type == scheme_case_lambda_sequence_type ) {
      Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) p ; 
      if (! cl -> count )
        name = ((void * ) 0 ) ; 
      else 
      name = ((Scheme_Lambda * ) cl -> array [0 ] ) -> name ; 
    }

# 2701 "bc/src/fun.c"
    else {

      name = ((Scheme_Native_Closure * ) p ) -> code -> u2 . name ; 
      if (name && ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) ) {


        name = ((Scheme_Lambda * ) name ) -> name ; 
      }
    }

    if (name && ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
    && ((((Scheme_Vector * ) (name ) ) -> size ) > 7 ) )
      RET_VALUE_START ((((Scheme_Vector * ) (name ) ) -> els ) [7 ] ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_default_realm ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2719 "bc/src/fun.c"
static Scheme_Object * primitive_result_arity (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2721 "bc/src/fun.c"
  Scheme_Object * o ; 

  o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) 
  && (((Scheme_Primitive_Proc * ) o ) -> pp . flags & 4 ) ) {
    if (((Scheme_Primitive_Proc * ) o ) -> pp . flags & 8 ) {
      Scheme_Prim_W_Result_Arity * p = (Scheme_Prim_W_Result_Arity * ) o ; 
      return scheme_make_arity (p -> minr , p -> maxr ) ; 
    }
  }

# 2731 "bc/src/fun.c"
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) 
  && (((Scheme_Closed_Primitive_Proc * ) o ) -> pp . flags & 4 ) ) {
    if (((Scheme_Closed_Primitive_Proc * ) o ) -> pp . flags & 8 ) {
      Scheme_Closed_Prim_W_Result_Arity * p = (Scheme_Closed_Prim_W_Result_Arity * ) o ; 
      return scheme_make_arity (p -> minr , p -> maxr ) ; 
    }
  }

# 2737 "bc/src/fun.c"
  else {
    scheme_wrong_contract ("primitive-result-arity" , "primitive?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * procedure_result_arity (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2746 "bc/src/fun.c"
  Scheme_Object * o , * orig_o ; 

  orig_o = argv [0 ] ; 
  o = orig_o ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 



  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) 


  && ! scheme_is_struct_instance (scheme_reduced_procedure_struct , o ) ) {
    return scheme_false ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {
    if ((& (((Scheme_Closure * ) o ) -> code ) -> iso ) -> so . keyex & 32 )  {
      return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
    }
  }




  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
    Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) o ; 
    int i ; 

    for (i = cl -> count ; i -- ; ) {
      if (! ((& (((Scheme_Closure * ) cl -> array [i ] ) -> code ) -> iso ) -> so . keyex & 32 ) )
        break ; 
    }

    if (i < 0 )
      return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
  }

# 2783 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) )  {
    if (((Scheme_Primitive_Proc * ) o ) -> pp . flags & 8 ) {
      Scheme_Prim_W_Result_Arity * p = (Scheme_Prim_W_Result_Arity * ) o ; 
      return scheme_make_arity (p -> minr , p -> maxr ) ; 
    }
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
  }

# 2789 "bc/src/fun.c"
  else if ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  && scheme_is_struct_instance (scheme_reduced_procedure_struct , o ) ) {
    return procedure_result_arity (1 , & ((Scheme_Structure * ) o ) -> slots [0 ] ) ; 
  }

# 2792 "bc/src/fun.c"
  else if (! (! (((intptr_t ) (o ) ) & 0x1 ) && ((((o ) -> type ) >= scheme_prim_type ) && (((o ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
    scheme_wrong_contract ("procedure-result-arity" , "procedure?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return scheme_false ; 
}

Scheme_Object * scheme_object_name (Scheme_Object * a ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(v, 1)));
# define XfOrM336_COUNT (2)
# define SETUP_XfOrM336(x) SETUP(XfOrM336_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 2803 "bc/src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) ) ) 
    v = ((void * ) 0 ) ; 
  else 
  v = (scheme_struct_type_property_ref (scheme_object_name_property , a ) ) ; 

  if (v ) {
#   define XfOrM351_COUNT (0+XfOrM336_COUNT)
#   define SETUP_XfOrM351(x) SETUP_XfOrM336(x)

# 2809 "bc/src/fun.c"
    if (((intptr_t ) (v ) ) & 0x1 ) 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM351(_), scheme_struct_ref (a , (((intptr_t ) (v ) ) >> 1 ) ) )) RET_VALUE_END ; 
    if (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
#     define XfOrM352_COUNT (0+XfOrM351_COUNT)
#     define SETUP_XfOrM352(x) SETUP_XfOrM351(x)

# 2812 "bc/src/fun.c"
      if (FUNCCALL(SETUP_XfOrM352(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , & v ) )) {
        Scheme_Object * f = v , * arg [1 ] ; 
        BLOCK_SETUP((PUSHARRAY(arg, 1, 0+XfOrM352_COUNT)));
#       define XfOrM353_COUNT (3+XfOrM352_COUNT)
#       define SETUP_XfOrM353(x) SETUP(XfOrM353_COUNT)
        arg[0] = NULLED_OUT ; 

# 2815 "bc/src/fun.c"
        arg [0 ] = a ; 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM353(_), scheme_apply (f , 1 , arg ) )) RET_VALUE_END ; 
      }
    }
  }

  if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    a = (((Scheme_Chaperone * ) a ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) )  {
#   define XfOrM349_COUNT (0+XfOrM336_COUNT)
#   define SETUP_XfOrM349(x) SETUP_XfOrM336(x)

# 2825 "bc/src/fun.c"
    a = FUNCCALL(SETUP_XfOrM349(_), scheme_proc_struct_name_source (a ) ); 
    if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
      a = (((Scheme_Chaperone * ) a ) -> val ) ; 

    if ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
    && scheme_reduced_procedure_struct 
    && (scheme_is_struct_instance (scheme_reduced_procedure_struct , a ) ) ) {

      RET_VALUE_START (((Scheme_Structure * ) a ) -> slots [2 ] ) RET_VALUE_END ; 
    }
  }

  if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    if (! ((((Scheme_Structure * ) a ) -> stype ) -> more_flags & 0x2 ) )
      RET_VALUE_START (((((Scheme_Structure * ) a ) -> stype ) -> name ) ) RET_VALUE_END ; 
  }

# 2840 "bc/src/fun.c"
  else if (! (((intptr_t ) (a ) ) & 0x1 ) && ((((a ) -> type ) >= scheme_prim_type ) && (((a ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
    const char * s ; 
    int len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM336_COUNT)));
#   define XfOrM346_COUNT (1+XfOrM336_COUNT)
#   define SETUP_XfOrM346(x) SETUP(XfOrM346_COUNT)
    s = NULLED_OUT ; 

# 2844 "bc/src/fun.c"
    s = FUNCCALL(SETUP_XfOrM346(_), scheme_get_proc_name (a , & len , - 1 ) ); 
    if (s ) {
#     define XfOrM347_COUNT (0+XfOrM346_COUNT)
#     define SETUP_XfOrM347(x) SETUP_XfOrM346(x)

# 2846 "bc/src/fun.c"
      if (len < 0 )
        RET_VALUE_START ((Scheme_Object * ) s ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM347(_), scheme_intern_exact_symbol (s , len ) )) RET_VALUE_END ; 
    }
  }

# 2851 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) )  {
    RET_VALUE_START (((Scheme_Struct_Type * ) a ) -> name ) RET_VALUE_END ; 
  }

# 2853 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) )  {
    RET_VALUE_START (((Scheme_Struct_Property * ) a ) -> name ) RET_VALUE_END ; 
  }

# 2855 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_regexp_type ) )  {
    Scheme_Object * s ; 
#   define XfOrM343_COUNT (0+XfOrM336_COUNT)
#   define SETUP_XfOrM343(x) SETUP_XfOrM336(x)
    s = NULLED_OUT ; 

# 2857 "bc/src/fun.c"
    s = (scheme_regexp_source (a ) ) ; 
    if (s )
      RET_VALUE_START (s ) RET_VALUE_END ; 
  }

# 2860 "bc/src/fun.c"
  else if (scheme_is_input_port (a ) )  {
    Scheme_Input_Port * ip ; 
    BLOCK_SETUP((PUSH(ip, 0+XfOrM336_COUNT)));
#   define XfOrM342_COUNT (1+XfOrM336_COUNT)
#   define SETUP_XfOrM342(x) SETUP(XfOrM342_COUNT)
    ip = NULLED_OUT ; 

# 2862 "bc/src/fun.c"
    ip = FUNCCALL(SETUP_XfOrM342(_), scheme_input_port_record (a ) ); 
    RET_VALUE_START (ip -> name ) RET_VALUE_END ; 
  }

# 2864 "bc/src/fun.c"
  else if (scheme_is_output_port (a ) )  {
    Scheme_Output_Port * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM336_COUNT)));
#   define XfOrM341_COUNT (1+XfOrM336_COUNT)
#   define SETUP_XfOrM341(x) SETUP(XfOrM341_COUNT)
    op = NULLED_OUT ; 

# 2866 "bc/src/fun.c"
    op = FUNCCALL(SETUP_XfOrM341(_), scheme_output_port_record (a ) ); 
    RET_VALUE_START (op -> name ) RET_VALUE_END ; 
  }

# 2868 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) )  {
    Scheme_Thread * t = (Scheme_Thread * ) a ; 
    if (t -> name ) {
      RET_VALUE_START (t -> name ) RET_VALUE_END ; 
    }
  }

# 2873 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) )  {
    Scheme_Logger * logger = (Scheme_Logger * ) a ; 
    if (logger -> name )
      RET_VALUE_START (logger -> name ) RET_VALUE_END ; 
  }

# 2877 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) )  {

    if (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) 
      RET_VALUE_START ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2886 "bc/src/fun.c"
static Scheme_Object * object_name (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2888 "bc/src/fun.c"
  return scheme_object_name (argv [0 ] ) ; 
}

Scheme_Object * scheme_arity (Scheme_Object * p ) 
{
  /* No conversion */

# 2893 "bc/src/fun.c"
  return get_or_check_arity (p , - 1 , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * procedure_arity (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2898 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-arity" , "procedure?" , 0 , argc , argv ) ; 

  return get_or_check_arity (argv [0 ] , - 1 , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * procedure_arity_mask (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2906 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-arity-mask" , "procedure?" , 0 , argc , argv ) ; 

  return get_or_check_arity (argv [0 ] , - 4 , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * procedure_arity_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2914 "bc/src/fun.c"
  Scheme_Object * a = argv [0 ] , * v ; 

  if (((intptr_t ) (a ) ) & 0x1 )  {
    return (((((intptr_t ) (a ) ) >> 1 ) >= 0 ) ? scheme_true : scheme_false ) ; 
  }

# 2918 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
    return (((& ((Scheme_Bignum * ) a ) -> iso ) -> so . keyex & 0x1 ) ? scheme_true : scheme_false ) ; 
  }

# 2920 "bc/src/fun.c"
  else if ((a ) == (scheme_null ) )  {
    return scheme_true ; 
  }

# 2922 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    while (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      v = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 
      if (((intptr_t ) (v ) ) & 0x1 )  {
        if ((((intptr_t ) (v ) ) >> 1 ) < 0 )
          return scheme_false ; 
      }

# 2928 "bc/src/fun.c"
      else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
        if (! ((& ((Scheme_Bignum * ) v ) -> iso ) -> so . keyex & 0x1 ) )
          return scheme_false ; 
      }

# 2931 "bc/src/fun.c"
      else if (! ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
      || ! scheme_is_struct_instance (scheme_arity_at_least , v ) ) {
        return scheme_false ; 
      }
      a = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 
    }
    return ((a ) == (scheme_null ) ) ? scheme_true : scheme_false ; 
  }

# 2938 "bc/src/fun.c"
  else if (((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && scheme_is_struct_instance (scheme_arity_at_least , a ) ) {
    return scheme_true ; 
  }

# 2941 "bc/src/fun.c"
  else 
  return scheme_false ; 
}

Scheme_Object * scheme_procedure_arity_includes (int argc , Scheme_Object * argv [] ) 
{
  intptr_t n ; 
  int inc_ok ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM372_COUNT (1)
# define SETUP_XfOrM372(x) SETUP(XfOrM372_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2950 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-arity-includes?" , "procedure?" , 0 , argc , argv ) ); 

  n = FUNCCALL(SETUP_XfOrM372(_), scheme_extract_index ("procedure-arity-includes?" , 1 , argc , argv , - 2 , 0 ) ); 


  inc_ok = ((argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(get_or_check_arity (argv [0 ] , n , argv [1 ] , inc_ok ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2961 "bc/src/fun.c"
static int is_arity (Scheme_Object * a , int at_least_ok , int list_ok ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(a, 0)));
# define XfOrM373_COUNT (1)
# define SETUP_XfOrM373(x) SETUP(XfOrM373_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2963 "bc/src/fun.c"
  if (((intptr_t ) (a ) ) & 0x1 )  {
    RET_VALUE_START (((((intptr_t ) (a ) ) >> 1 ) >= 0 ) ) RET_VALUE_END ; 
  }

# 2965 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
    RET_VALUE_START (((& ((Scheme_Bignum * ) a ) -> iso ) -> so . keyex & 0x1 ) ) RET_VALUE_END ; 
  }

# 2967 "bc/src/fun.c"
  else if (at_least_ok 
  && ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && (scheme_is_struct_instance (scheme_arity_at_least , a ) ) ) {
#   define XfOrM376_COUNT (0+XfOrM373_COUNT)
#   define SETUP_XfOrM376(x) SETUP_XfOrM373(x)

# 2970 "bc/src/fun.c"
    a = FUNCCALL(SETUP_XfOrM376(_), scheme_struct_ref (a , 0 ) ); 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_arity (a , 0 , 0 ) )) RET_VALUE_EMPTY_END ; 
  }

  if (! list_ok )
    RET_VALUE_START (0 ) RET_VALUE_END ; 

  while (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM375_COUNT (0+XfOrM373_COUNT)
#   define SETUP_XfOrM375(x) SETUP_XfOrM373(x)

# 2978 "bc/src/fun.c"
    if (! FUNCCALL(SETUP_XfOrM375(_), is_arity ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) , 1 , 0 ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    a = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 
  }

  if ((a ) == (scheme_null ) ) 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2988 "bc/src/fun.c"
void scheme_init_reduced_proc_struct (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg127 = NULLED_OUT ; 
  PREPARE_VAR_STACK(1);
# define XfOrM379_COUNT (0)
# define SETUP_XfOrM379(x) SETUP(XfOrM379_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2990 "bc/src/fun.c"
  if (! scheme_reduced_procedure_struct ) {
    Scheme_Inspector * insp ; 
    BLOCK_SETUP((PUSH(insp, 0+XfOrM379_COUNT)));
#   define XfOrM380_COUNT (1+XfOrM379_COUNT)
#   define SETUP_XfOrM380(x) SETUP(XfOrM380_COUNT)
    insp = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM380(_), scheme_register_static ((void * ) & scheme_reduced_procedure_struct , sizeof (scheme_reduced_procedure_struct ) ) )
# 2993 "bc/src/fun.c"
    ; 
    insp = (Scheme_Inspector * ) FUNCCALL(SETUP_XfOrM380(_), scheme_get_current_inspector () ); 
    while (insp -> superior -> superior ) {
      insp = insp -> superior ; 
    }
    scheme_reduced_procedure_struct = (__funcarg127 = FUNCCALL(SETUP_XfOrM380(_), scheme_intern_symbol ("procedure" ) ), FUNCCALL_AGAIN(scheme_make_struct_type2 (__funcarg127 , ((void * ) 0 ) , (Scheme_Object * ) insp , 5 , 0 , scheme_false , scheme_null , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) 






    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3009 "bc/src/fun.c"
static Scheme_Object * arity_to_mask (Scheme_Object * aty ) 
{
  Scheme_Object * __funcarg130 = NULLED_OUT ; 

# 3009 "bc/src/fun.c"
  Scheme_Object * __funcarg129 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(aty, 0)));
# define XfOrM383_COUNT (1)
# define SETUP_XfOrM383(x) SETUP(XfOrM383_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3011 "bc/src/fun.c"
  if (((intptr_t ) (aty ) ) & 0x1 )  {
    intptr_t n = (((intptr_t ) (aty ) ) >> 1 ) ; 
#   define XfOrM390_COUNT (0+XfOrM383_COUNT)
#   define SETUP_XfOrM390(x) SETUP_XfOrM383(x)

# 3013 "bc/src/fun.c"
    if (n <= 29 )
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 << n ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_shifted_one (n ) )) RET_VALUE_EMPTY_END ; 
  }

# 3017 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
#   define XfOrM389_COUNT (0+XfOrM383_COUNT)
#   define SETUP_XfOrM389(x) SETUP_XfOrM383(x)
    FUNCCALL_EMPTY(scheme_raise_out_of_memory (((void * ) 0 ) , ((void * ) 0 ) ) )
# 3018 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 3020 "bc/src/fun.c"
  else if (((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    Scheme_Object * mask ; 
    BLOCK_SETUP((PUSH(mask, 0+XfOrM383_COUNT)));
#   define XfOrM387_COUNT (1+XfOrM383_COUNT)
#   define SETUP_XfOrM387(x) SETUP(XfOrM387_COUNT)
    mask = NULLED_OUT ; 

# 3023 "bc/src/fun.c"
    aty = FUNCCALL(SETUP_XfOrM387(_), scheme_struct_ref (aty , 0 ) ); 
    if (((intptr_t ) (aty ) ) & 0x1 ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity_mask ((((intptr_t ) (aty ) ) >> 1 ) , - 1 ) )) RET_VALUE_EMPTY_END ; 
    else {
#     define XfOrM388_COUNT (0+XfOrM387_COUNT)
#     define SETUP_XfOrM388(x) SETUP_XfOrM387(x)

# 3027 "bc/src/fun.c"
      mask = FUNCCALL(SETUP_XfOrM388(_), arity_to_mask (aty ) ); 
      RET_VALUE_START ((__funcarg130 = FUNCCALL(SETUP_XfOrM388(_), scheme_bin_minus (mask , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ), FUNCCALL_EMPTY(scheme_bin_bitwise_xor (__funcarg130 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ) )) ) RET_VALUE_END 
      ; 
    }
  }

# 3031 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * mask = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    BLOCK_SETUP((PUSH(mask, 0+XfOrM383_COUNT)));
#   define XfOrM384_COUNT (1+XfOrM383_COUNT)
#   define SETUP_XfOrM384(x) SETUP(XfOrM384_COUNT)

# 3033 "bc/src/fun.c"
    while (((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM386_COUNT (0+XfOrM384_COUNT)
#     define SETUP_XfOrM386(x) SETUP_XfOrM384(x)

# 3034 "bc/src/fun.c"
      mask = (__funcarg129 = FUNCCALL(SETUP_XfOrM386(_), arity_to_mask ((((Scheme_Simple_Object * ) (aty ) ) -> u . pair_val . car ) ) ), FUNCCALL_AGAIN(scheme_bin_bitwise_or (__funcarg129 , mask ) )) ; 
      aty = (((Scheme_Simple_Object * ) (aty ) ) -> u . pair_val . cdr ) ; 
    }
    RET_VALUE_START (mask ) RET_VALUE_END ; 
  }

# 3038 "bc/src/fun.c"
  else 
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3042 "bc/src/fun.c"
static Scheme_Object * mask_to_arity (Scheme_Object * mask , int mode ) 
{
  intptr_t n , pos = 0 ; 
  Scheme_Object * l = scheme_null ; 

# 1773 "bc/src/fun.c"
  Scheme_Object * __funcarg136 = NULLED_OUT ; 
  Scheme_Object * __funcarg135 = NULLED_OUT ; 
  Scheme_Object * __funcarg134 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(mask, 1)));
# define XfOrM391_COUNT (2)
# define SETUP_XfOrM391(x) SETUP(XfOrM391_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3047 "bc/src/fun.c"
  while (! (((intptr_t ) (mask ) ) & 0x1 ) ) {
    Scheme_Object * a [2 ] , * b ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM391_COUNT), PUSH(b, 3+XfOrM391_COUNT)));
#   define XfOrM404_COUNT (4+XfOrM391_COUNT)
#   define SETUP_XfOrM404(x) SETUP(XfOrM404_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    b = NULLED_OUT ; 

# 3049 "bc/src/fun.c"
    b = FUNCCALL(SETUP_XfOrM404(_), scheme_bin_bitwise_and (mask , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0xFFFF ) ) ) << 1 ) | 0x1 ) ) ) ); 
    if (((intptr_t ) (b ) ) & 0x1 )  {
#     define XfOrM406_COUNT (0+XfOrM404_COUNT)
#     define SETUP_XfOrM406(x) SETUP_XfOrM404(x)

# 3051 "bc/src/fun.c"
      b = FUNCCALL(SETUP_XfOrM406(_), scheme_bin_bitwise_and (mask , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
      if (((intptr_t ) (b ) ) & 0x1 ) 
        l = FUNCCALL(SETUP_XfOrM406(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , l ) ); 
      pos ++ ; 
      a [0 ] = mask ; 
      a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ; 
      mask = FUNCCALL(SETUP_XfOrM406(_), scheme_bitwise_shift (2 , a ) ); 
    }

# 3058 "bc/src/fun.c"
    else {
#     define XfOrM405_COUNT (0+XfOrM404_COUNT)
#     define SETUP_XfOrM405(x) SETUP_XfOrM404(x)

# 3059 "bc/src/fun.c"
      pos += 16 ; 
      a [0 ] = mask ; 
      a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 16 ) ) ) << 1 ) | 0x1 ) ) ; 
      mask = FUNCCALL(SETUP_XfOrM405(_), scheme_bitwise_shift (2 , a ) ); 
    }
  }

  n = (((intptr_t ) (mask ) ) >> 1 ) ; 
  if (! n ) {
#   define XfOrM400_COUNT (0+XfOrM391_COUNT)
#   define SETUP_XfOrM400(x) SETUP_XfOrM391(x)

# 3068 "bc/src/fun.c"
    if (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && (((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) == (scheme_null ) ) )
      RET_VALUE_START ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) RET_VALUE_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_reverse (l ) )) RET_VALUE_EMPTY_END ; 
  }

  while (1 ) {
#   define XfOrM396_COUNT (0+XfOrM391_COUNT)
#   define SETUP_XfOrM396(x) SETUP_XfOrM391(x)

# 3075 "bc/src/fun.c"
    if (n == - 1 ) {
#     define XfOrM399_COUNT (0+XfOrM396_COUNT)
#     define SETUP_XfOrM399(x) SETUP_XfOrM396(x)

# 3076 "bc/src/fun.c"
      if ((l ) == (scheme_null ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity (pos , - 1 , mode ) )) RET_VALUE_EMPTY_END ; 
      else 
      RET_VALUE_START ((__funcarg135 = (__funcarg136 = FUNCCALL(SETUP_XfOrM399(_), make_arity (pos , - 1 , mode ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg136 , l ) )) , FUNCCALL_EMPTY(scheme_reverse (__funcarg135 ) )) ) RET_VALUE_END ; 
    }

# 3080 "bc/src/fun.c"
    else if (n == 1 ) {
#     define XfOrM398_COUNT (0+XfOrM396_COUNT)
#     define SETUP_XfOrM398(x) SETUP_XfOrM396(x)

# 3081 "bc/src/fun.c"
      if ((l ) == (scheme_null ) ) 
        RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
      else 
      RET_VALUE_START ((__funcarg134 = FUNCCALL(SETUP_XfOrM398(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , l ) ), FUNCCALL_EMPTY(scheme_reverse (__funcarg134 ) )) ) RET_VALUE_END ; 
    }

# 3085 "bc/src/fun.c"
    else if (n & 0x1 ) {
#     define XfOrM397_COUNT (0+XfOrM396_COUNT)
#     define SETUP_XfOrM397(x) SETUP_XfOrM396(x)

# 3086 "bc/src/fun.c"
      l = FUNCCALL(SETUP_XfOrM397(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , l ) ); 
    }
    pos ++ ; 
    n >>= 1 ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3093 "bc/src/fun.c"
Scheme_Object * scheme_arity_mask_to_arity (Scheme_Object * mask , int mode ) 
{
  /* No conversion */

# 3095 "bc/src/fun.c"
  return mask_to_arity (mask , mode ) ; 
}

static Scheme_Object * make_reduced_proc (Scheme_Object * proc , 
Scheme_Object * mask , 
Scheme_Object * name , 
Scheme_Object * realm , 
Scheme_Object * is_meth ) 
{
  Scheme_Structure * inst ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(realm, 1), PUSH(mask, 2), PUSH(proc, 3), PUSH(inst, 4), PUSH(is_meth, 5)));
# define XfOrM408_COUNT (6)
# define SETUP_XfOrM408(x) SETUP(XfOrM408_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 3106 "bc/src/fun.c"
  if ((((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  && (scheme_is_struct_instance (scheme_reduced_procedure_struct , proc ) ) ) {

    if (! name ) {
      name = ((Scheme_Structure * ) proc ) -> slots [2 ] ; 
      realm = ((Scheme_Structure * ) proc ) -> slots [4 ] ; 
    }
    if (! is_meth )
      is_meth = ((Scheme_Structure * ) proc ) -> slots [3 ] ; 
    proc = ((Scheme_Structure * ) proc ) -> slots [0 ] ; 
  }

  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM408(_), GC_malloc_one_tagged (sizeof (Scheme_Structure ) + ((5 - 0 ) * sizeof (Scheme_Object * ) ) ) )
  ; 
  inst -> so . type = scheme_proc_struct_type ; 
  inst -> stype = (Scheme_Struct_Type * ) scheme_reduced_procedure_struct ; 

  inst -> slots [0 ] = proc ; 
  inst -> slots [1 ] = mask ; 
  inst -> slots [2 ] = (name ? name : scheme_false ) ; 
  inst -> slots [3 ] = (is_meth ? is_meth : scheme_false ) ; 
  inst -> slots [4 ] = (name ? realm : scheme_false ) ; 

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3132 "bc/src/fun.c"
static int is_subarity (Scheme_Object * req , Scheme_Object * orig , int req_delta ) 
{
  Scheme_Object * oa , * ra , * ol , * lra , * ara , * prev , * pr , * tmp , * rd ; 
  Scheme_Object * __funcarg196 = NULLED_OUT ; 
  Scheme_Object * __funcarg195 = NULLED_OUT ; 
  Scheme_Object * __funcarg194 = NULLED_OUT ; 
  Scheme_Object * __funcarg193 = NULLED_OUT ; 
  Scheme_Object * __funcarg192 = NULLED_OUT ; 
  Scheme_Object * __funcarg191 = NULLED_OUT ; 
  Scheme_Object * __funcarg190 = NULLED_OUT ; 
  Scheme_Object * __funcarg189 = NULLED_OUT ; 
  Scheme_Object * __funcarg188 = NULLED_OUT ; 
  Scheme_Object * __funcarg187 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(11);
  BLOCK_SETUP_TOP((PUSH(orig, 0), PUSH(prev, 1), PUSH(ra, 2), PUSH(pr, 3), PUSH(tmp, 4), PUSH(lra, 5), PUSH(ara, 6), PUSH(req, 7), PUSH(rd, 8), PUSH(ol, 9), PUSH(oa, 10)));
# define XfOrM411_COUNT (11)
# define SETUP_XfOrM411(x) SETUP(XfOrM411_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  oa = NULLED_OUT ; 
  ra = NULLED_OUT ; 
  ol = NULLED_OUT ; 
  lra = NULLED_OUT ; 
  ara = NULLED_OUT ; 
  prev = NULLED_OUT ; 
  pr = NULLED_OUT ; 
  tmp = NULLED_OUT ; 
  rd = NULLED_OUT ; 

# 3136 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (orig ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ! ((orig ) == (scheme_null ) ) )
    orig = FUNCCALL(SETUP_XfOrM411(_), scheme_make_pair (orig , scheme_null ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (req ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (req ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ! ((req ) == (scheme_null ) ) )
    req = FUNCCALL(SETUP_XfOrM411(_), scheme_make_pair (req , scheme_null ) ); 

  rd = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (req_delta ) ) ) << 1 ) | 0x1 ) ) ; 

  while (! ((req ) == (scheme_null ) ) ) {
#   define XfOrM481_COUNT (0+XfOrM411_COUNT)
#   define SETUP_XfOrM481(x) SETUP_XfOrM411(x)

# 3144 "bc/src/fun.c"
    ra = (((Scheme_Simple_Object * ) (req ) ) -> u . pair_val . car ) ; 
    if (((((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) ra ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) ra ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) ra ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) ra ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && (scheme_is_struct_instance (scheme_arity_at_least , ra ) ) ) {
#     define XfOrM549_COUNT (0+XfOrM481_COUNT)
#     define SETUP_XfOrM549(x) SETUP_XfOrM481(x)


      ra = (__funcarg195 = (__funcarg196 = FUNCCALL(SETUP_XfOrM549(_), scheme_struct_ref (ra , 0 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg196 , scheme_false ) )) 
      , FUNCCALL_AGAIN(scheme_make_pair (__funcarg195 , scheme_null ) )) 
      ; 
    }

    for (ol = orig ; ! ((ol ) == (scheme_null ) ) ; ol = (((Scheme_Simple_Object * ) (ol ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM516_COUNT (0+XfOrM481_COUNT)
#     define SETUP_XfOrM516(x) SETUP_XfOrM481(x)

# 3157 "bc/src/fun.c"
      oa = (((Scheme_Simple_Object * ) (ol ) ) -> u . pair_val . car ) ; 
      if ((((intptr_t ) (ra ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
#       define XfOrM546_COUNT (0+XfOrM516_COUNT)
#       define SETUP_XfOrM546(x) SETUP_XfOrM516(x)

# 3159 "bc/src/fun.c"
        if ((((intptr_t ) (oa ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (oa ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (oa ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
#         define XfOrM548_COUNT (0+XfOrM546_COUNT)
#         define SETUP_XfOrM548(x) SETUP_XfOrM546(x)

# 3160 "bc/src/fun.c"
          if ((__funcarg194 = FUNCCALL(SETUP_XfOrM548(_), scheme_bin_plus (ra , rd ) ), FUNCCALL_AGAIN(scheme_equal (__funcarg194 , oa ) )) )
            break ; 
        }

# 3162 "bc/src/fun.c"
        else {
#         define XfOrM547_COUNT (0+XfOrM546_COUNT)
#         define SETUP_XfOrM547(x) SETUP_XfOrM546(x)

# 3164 "bc/src/fun.c"
          oa = ((Scheme_Structure * ) oa ) -> slots [0 ] ; 
          if ((__funcarg193 = FUNCCALL(SETUP_XfOrM547(_), scheme_bin_plus (ra , rd ) ), FUNCCALL_AGAIN(scheme_bin_lt_eq (oa , __funcarg193 ) )) )
            break ; 
        }
      }

# 3168 "bc/src/fun.c"
      else {

        int at_least ; 
#       define XfOrM517_COUNT (0+XfOrM516_COUNT)
#       define SETUP_XfOrM517(x) SETUP_XfOrM516(x)

# 3171 "bc/src/fun.c"
        if ((((intptr_t ) (oa ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (oa ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (oa ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
          at_least = 0 ; 
        }

# 3173 "bc/src/fun.c"
        else {

          at_least = 1 ; 
          oa = ((Scheme_Structure * ) oa ) -> slots [0 ] ; 
        }

        lra = ra ; 
        prev = ((void * ) 0 ) ; 
        while (! ((lra ) == (scheme_null ) ) ) {
#         define XfOrM531_COUNT (0+XfOrM517_COUNT)
#         define SETUP_XfOrM531(x) SETUP_XfOrM517(x)

# 3183 "bc/src/fun.c"
          ara = (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . car ) ; 
          if (((((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) ) ) == (scheme_false ) ) 
          || (__funcarg192 = FUNCCALL(SETUP_XfOrM531(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) , rd ) ), FUNCCALL_AGAIN(scheme_bin_lt_eq (oa , __funcarg192 ) )) ) {
#           define XfOrM532_COUNT (0+XfOrM531_COUNT)
#           define SETUP_XfOrM532(x) SETUP_XfOrM531(x)

# 3186 "bc/src/fun.c"
            if ((__funcarg191 = FUNCCALL(SETUP_XfOrM532(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . car ) , rd ) ), FUNCCALL_AGAIN(scheme_bin_gt_eq (oa , __funcarg191 ) )) ) {
#             define XfOrM534_COUNT (0+XfOrM532_COUNT)
#             define SETUP_XfOrM534(x) SETUP_XfOrM532(x)

# 3188 "bc/src/fun.c"
              if ((__funcarg190 = FUNCCALL(SETUP_XfOrM534(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . car ) , rd ) ), FUNCCALL_AGAIN(scheme_equal (oa , __funcarg190 ) )) ) {
#               define XfOrM539_COUNT (0+XfOrM534_COUNT)
#               define SETUP_XfOrM539(x) SETUP_XfOrM534(x)

# 3190 "bc/src/fun.c"
                if (at_least ) {

                  if (prev )
                    (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = scheme_null ; 
                  else 
                  ra = scheme_null ; 
                }

# 3196 "bc/src/fun.c"
                else {
#                 define XfOrM540_COUNT (0+XfOrM539_COUNT)
#                 define SETUP_XfOrM540(x) SETUP_XfOrM539(x)

# 3197 "bc/src/fun.c"
                  if ((__funcarg189 = FUNCCALL(SETUP_XfOrM540(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) , rd ) ), FUNCCALL_AGAIN(scheme_equal (oa , __funcarg189 ) )) ) {

                    if (prev )
                      (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) ; 
                    else 
                    ra = (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) ; 
                  }

# 3203 "bc/src/fun.c"
                  else {
#                   define XfOrM541_COUNT (0+XfOrM540_COUNT)
#                   define SETUP_XfOrM541(x) SETUP_XfOrM540(x)

# 3205 "bc/src/fun.c"
                    tmp = FUNCCALL(SETUP_XfOrM541(_), scheme_bin_plus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                    tmp = FUNCCALL(SETUP_XfOrM541(_), scheme_bin_minus (tmp , rd ) ); 
                    (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . car ) = tmp ; 
                  }
                }
              }

# 3210 "bc/src/fun.c"
              else if ((__funcarg188 = FUNCCALL(SETUP_XfOrM534(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . car ) , rd ) ), FUNCCALL_AGAIN(scheme_equal (oa , __funcarg188 ) )) ) {
#               define XfOrM538_COUNT (0+XfOrM534_COUNT)
#               define SETUP_XfOrM538(x) SETUP_XfOrM534(x)

# 3212 "bc/src/fun.c"
                tmp = FUNCCALL(SETUP_XfOrM538(_), scheme_bin_minus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                tmp = FUNCCALL(SETUP_XfOrM538(_), scheme_bin_minus (tmp , rd ) ); 
                (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) = tmp ; 
                if (at_least )
                  (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) = scheme_null ; 
              }

# 3217 "bc/src/fun.c"
              else {
#               define XfOrM535_COUNT (0+XfOrM534_COUNT)
#               define SETUP_XfOrM535(x) SETUP_XfOrM534(x)

# 3219 "bc/src/fun.c"
                if (at_least ) {
#                 define XfOrM537_COUNT (0+XfOrM535_COUNT)
#                 define SETUP_XfOrM537(x) SETUP_XfOrM535(x)

# 3220 "bc/src/fun.c"
                  tmp = FUNCCALL(SETUP_XfOrM537(_), scheme_bin_minus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                  tmp = FUNCCALL(SETUP_XfOrM537(_), scheme_bin_minus (tmp , rd ) ); 
                  (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) = tmp ; 
                  (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) = scheme_null ; 
                }

# 3224 "bc/src/fun.c"
                else {
#                 define XfOrM536_COUNT (0+XfOrM535_COUNT)
#                 define SETUP_XfOrM536(x) SETUP_XfOrM535(x)

# 3225 "bc/src/fun.c"
                  tmp = FUNCCALL(SETUP_XfOrM536(_), scheme_bin_plus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                  tmp = FUNCCALL(SETUP_XfOrM536(_), scheme_bin_minus (tmp , rd ) ); 
                  pr = (__funcarg187 = FUNCCALL(SETUP_XfOrM536(_), scheme_make_pair (tmp , (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg187 , (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) ) )) 
                  ; 
                  tmp = FUNCCALL_AGAIN(scheme_bin_minus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                  tmp = FUNCCALL_AGAIN(scheme_bin_minus (tmp , rd ) ); 
                  (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) = tmp ; 
                  (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) = pr ; 
                }
              }
              break ; 
            }

# 3236 "bc/src/fun.c"
            else if (at_least ) {

              if (prev )
                (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = scheme_null ; 
              else 
              ra = scheme_null ; 
              break ; 
            }
          }
          prev = lra ; 
          lra = (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) ; 
        }
        if ((ra ) == (scheme_null ) ) 
          break ; 
      }
    }

    if ((ol ) == (scheme_null ) )  {
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

    req = (((Scheme_Simple_Object * ) (req ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3263 "bc/src/fun.c"
static int proc_is_method (Scheme_Object * proc ) 
{
  /* No conversion */

# 3265 "bc/src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    proc = (((Scheme_Chaperone * ) proc ) -> val ) ; 

  if ((((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  && scheme_is_struct_instance (scheme_reduced_procedure_struct , proc ) )
    return (! (((((Scheme_Structure * ) proc ) -> slots [3 ] ) ) == (scheme_false ) ) ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
    Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) proc ; 
    if (cl -> count )
      proc = cl -> array [0 ] ; 
    else 
    return 0 ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {
    return (((& (((Scheme_Closure * ) proc ) -> code ) -> iso ) -> so . keyex & 16 ) 
    ? 1 
    : 0 ) ; 
  }









  return 0 ; 
}

static Scheme_Object * do_procedure_reduce_arity (const char * who , int argc , Scheme_Object * argv [] , int as_arity ) 
{
  Scheme_Object * orig , * mask , * is_meth = ((void * ) 0 ) , * name = ((void * ) 0 ) , * realm = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg197 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(mask, 0), PUSH(orig, 1), PUSH(name, 2), PUSH(realm, 3), PUSH(who, 4), PUSH(argv, 5), PUSH(is_meth, 6)));
# define XfOrM553_COUNT (7)
# define SETUP_XfOrM553(x) SETUP(XfOrM553_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  orig = NULLED_OUT ; 
  mask = NULLED_OUT ; 

# 3301 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-reduce-arity" , "procedure?" , 0 , argc , argv ) ); 

  if (as_arity ) {
#   define XfOrM561_COUNT (0+XfOrM553_COUNT)
#   define SETUP_XfOrM561(x) SETUP_XfOrM553(x)

# 3305 "bc/src/fun.c"
    if (! FUNCCALL(SETUP_XfOrM561(_), is_arity (argv [1 ] , 1 , 1 ) )) {
#     define XfOrM562_COUNT (0+XfOrM561_COUNT)
#     define SETUP_XfOrM562(x) SETUP_XfOrM561(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c exact-nonnegative-integer? arity-at-least? (listof (or/c exact-nonnegative-integer? arity-at-least?)))" , 1 , argc , argv ) ); 
    }
    mask = FUNCCALL(SETUP_XfOrM561(_), arity_to_mask (argv [1 ] ) ); 
  }

# 3311 "bc/src/fun.c"
  else {
#   define XfOrM559_COUNT (0+XfOrM553_COUNT)
#   define SETUP_XfOrM559(x) SETUP_XfOrM553(x)

# 3312 "bc/src/fun.c"
    mask = argv [1 ] ; 
    if (! FUNCCALL(SETUP_XfOrM559(_), scheme_exact_p (mask ) )) {
#     define XfOrM560_COUNT (0+XfOrM559_COUNT)
#     define SETUP_XfOrM560(x) SETUP_XfOrM559(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-integer?" , 1 , argc , argv ) )
# 3314 "bc/src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (argc > 2 ) {
#   define XfOrM556_COUNT (0+XfOrM553_COUNT)
#   define SETUP_XfOrM556(x) SETUP_XfOrM553(x)

# 3320 "bc/src/fun.c"
    name = argv [2 ] ; 
    if (((name ) ) == (scheme_false ) ) 
      name = ((void * ) 0 ) ; 
    else if (! ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#     define XfOrM558_COUNT (0+XfOrM556_COUNT)
#     define SETUP_XfOrM558(x) SETUP_XfOrM556(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? #f)" , 2 , argc , argv ) )
# 3324 "bc/src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (argc > 3 ) {
#     define XfOrM557_COUNT (0+XfOrM556_COUNT)
#     define SETUP_XfOrM557(x) SETUP_XfOrM556(x)

# 3328 "bc/src/fun.c"
      realm = argv [3 ] ; 
      if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
        FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 3 , argc , argv ) ); 
    }

# 3331 "bc/src/fun.c"
    else 
    realm = scheme_default_realm ; 
  }

# 3333 "bc/src/fun.c"
  else {
    name = ((void * ) 0 ) ; 
    realm = ((void * ) 0 ) ; 
  }



  orig = FUNCCALL(SETUP_XfOrM553(_), get_or_check_arity (argv [0 ] , - 4 , ((void * ) 0 ) , 1 ) ); 

  if (! (__funcarg197 = FUNCCALL(SETUP_XfOrM553(_), scheme_bin_bitwise_and (mask , orig ) ), FUNCCALL_AGAIN(scheme_bin_eq (__funcarg197 , mask ) )) ) {
#   define XfOrM554_COUNT (0+XfOrM553_COUNT)
#   define SETUP_XfOrM554(x) SETUP_XfOrM553(x)
    FUNCCALL_EMPTY(scheme_contract_error (who , (as_arity ? "arity of procedure does not include requested arity" : "arity mask of procedure does not include requested arity mask" ) , "procedure" , 1 , argv [0 ] , (as_arity ? "requested arity" : "requested arity mask" ) , 1 , argv [1 ] , ((void * ) 0 ) ) )



    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (FUNCCALL(SETUP_XfOrM553(_), proc_is_method (argv [0 ] ) ))
    is_meth = scheme_true ; 


  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_reduced_proc (argv [0 ] , mask , name , realm , is_meth ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3360 "bc/src/fun.c"
static Scheme_Object * procedure_reduce_arity (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3362 "bc/src/fun.c"
  return do_procedure_reduce_arity ("procedure-reduce-arity" , argc , argv , 1 ) ; 
}

static Scheme_Object * procedure_reduce_arity_mask (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3367 "bc/src/fun.c"
  return do_procedure_reduce_arity ("procedure-reduce-arity-mask" , argc , argv , 0 ) ; 
}

static Scheme_Object * procedure_rename (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * p , * mask , * realm ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(mask, 1), PUSH(argv, 2), PUSH(p, 3)));
# define XfOrM565_COUNT (4)
# define SETUP_XfOrM565(x) SETUP(XfOrM565_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  mask = NULLED_OUT ; 
  realm = NULLED_OUT ; 

# 3374 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-rename" , "procedure?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-rename" , "symbol?" , 1 , argc , argv ) ); 
  if (argc > 2 ) {
#   define XfOrM566_COUNT (0+XfOrM565_COUNT)
#   define SETUP_XfOrM566(x) SETUP_XfOrM565(x)

# 3379 "bc/src/fun.c"
    realm = argv [2 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-rename" , "symbol?" , 2 , argc , argv ) ); 
  }

# 3382 "bc/src/fun.c"
  else 
  realm = scheme_default_realm ; 

  p = FUNCCALL(SETUP_XfOrM565(_), scheme_rename_struct_proc (argv [0 ] , argv [1 ] , realm ) ); 
  if (p )

# 3386 "bc/src/fun.c"
  RET_VALUE_START (p ) RET_VALUE_END ; 

  mask = FUNCCALL(SETUP_XfOrM565(_), get_or_check_arity (argv [0 ] , - 4 , ((void * ) 0 ) , 1 ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_reduced_proc (argv [0 ] , mask , argv [1 ] , realm , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3393 "bc/src/fun.c"
static Scheme_Object * procedure_to_method (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * mask ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(mask, 0), PUSH(argv, 1)));
# define XfOrM567_COUNT (2)
# define SETUP_XfOrM567(x) SETUP(XfOrM567_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  mask = NULLED_OUT ; 

# 3397 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure->method" , "procedure?" , 0 , argc , argv ) ); 

  mask = FUNCCALL(SETUP_XfOrM567(_), get_or_check_arity (argv [0 ] , - 4 , ((void * ) 0 ) , 1 ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_reduced_proc (argv [0 ] , mask , ((void * ) 0 ) , ((void * ) 0 ) , scheme_true ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3405 "bc/src/fun.c"
static Scheme_Object * procedure_realm (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3407 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-realm" , "procedure?" , 0 , argc , argv ) ; 

  return scheme_get_proc_realm (argv [0 ] ) ; 
}

static Scheme_Object * procedure_equal_closure_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3415 "bc/src/fun.c"
  Scheme_Object * v1 = argv [0 ] , * v2 = argv [1 ] ; 

  if (! (! (((intptr_t ) (v1 ) ) & 0x1 ) && ((((v1 ) -> type ) >= scheme_prim_type ) && (((v1 ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-closure-contents-eq?" , "procedure?" , 0 , argc , argv ) ; 
  if (! (! (((intptr_t ) (v2 ) ) & 0x1 ) && ((((v2 ) -> type ) >= scheme_prim_type ) && (((v2 ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-closure-contents-eq?" , "procedure?" , 1 , argc , argv ) ; 

  if ((v1 ) == (v2 ) ) 
    return scheme_true ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (v1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v1 ) ) -> type ) ) == (Scheme_Type ) (((((intptr_t ) (v2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v2 ) ) -> type ) ) ) )
    return scheme_false ; 

  switch (((((intptr_t ) (v1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v1 ) ) -> type ) ) {
    case scheme_prim_type : 
    {
      Scheme_Primitive_Proc * p1 = (Scheme_Primitive_Proc * ) v1 ; 
      Scheme_Primitive_Proc * p2 = (Scheme_Primitive_Proc * ) v2 ; 

      if (p1 -> prim_val == p2 -> prim_val ) {
        if (p1 -> pp . flags & 16 ) {
          if (! (p2 -> pp . flags & 16 ) )
            return scheme_false ; 




          return scheme_false ; 
        }

# 3443 "bc/src/fun.c"
        else if (! (p2 -> pp . flags & 16 ) )
          return scheme_true ; 
      }
    }
    break ; 
    case scheme_closure_type : 
    {
      Scheme_Closure * c1 = (Scheme_Closure * ) v1 ; 
      Scheme_Closure * c2 = (Scheme_Closure * ) v2 ; 

      if ((c1 -> code ) == (c2 -> code ) )  {
        int i ; 
        for (i = c1 -> code -> closure_size ; i -- ; ) {
          if (! ((c1 -> vals [i ] ) == (c2 -> vals [i ] ) ) )
            return scheme_false ; 
        }
        return scheme_true ; 
      }
    }
    break ; 
    case scheme_native_closure_type : 
    {
      Scheme_Native_Closure * c1 = (Scheme_Native_Closure * ) v1 ; 
      Scheme_Native_Closure * c2 = (Scheme_Native_Closure * ) v2 ; 

      if (((c1 -> code ) == (c2 -> code ) ) 
      || (c1 -> code -> eq_key && ((c1 -> code -> eq_key ) == (c2 -> code -> eq_key ) ) ) ) {
        int i ; 
        i = c1 -> code -> closure_size ; 
        if (i < 0 ) {

          Scheme_Native_Closure * sc1 , * sc2 ; 
          int j ; 
          i = - (i + 1 ) ; 
          while (i -- ) {
            sc1 = (Scheme_Native_Closure * ) c1 -> vals [i ] ; 
            sc2 = (Scheme_Native_Closure * ) c2 -> vals [i ] ; 
            j = sc1 -> code -> closure_size ; 
            while (j -- ) {
              if (! ((sc1 -> vals [j ] ) == (sc2 -> vals [j ] ) ) )
                return scheme_false ; 
            }
          }
        }

# 3486 "bc/src/fun.c"
        else {

          while (i -- ) {
            if (! ((c1 -> vals [i ] ) == (c2 -> vals [i ] ) ) )
              return scheme_false ; 
          }
        }
        return scheme_true ; 
      }
    }
    break ; 
    case scheme_case_closure_type : 
    {
      Scheme_Case_Lambda * c1 = (Scheme_Case_Lambda * ) v1 ; 
      Scheme_Case_Lambda * c2 = (Scheme_Case_Lambda * ) v2 ; 
      if (c1 -> count == c2 -> count ) {
        Scheme_Closure * sc1 , * sc2 ; 
        int i , j ; 
        for (i = c1 -> count ; i -- ; ) {
          sc1 = (Scheme_Closure * ) c1 -> array [i ] ; 
          sc2 = (Scheme_Closure * ) c2 -> array [i ] ; 
          if (! ((sc1 -> code ) == (sc2 -> code ) ) )
            return scheme_false ; 
          for (j = sc1 -> code -> closure_size ; j -- ; ) {
            if (! ((sc1 -> vals [j ] ) == (sc2 -> vals [j ] ) ) )
              return scheme_false ; 
          }
        }
        return scheme_true ; 
      }
    }
    break ; 
  }

  return scheme_false ; 
}

static Scheme_Object * procedure_specialize (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3525 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-specialize" , "procedure?" , 0 , argc , argv ) ; 

# 3547 "bc/src/fun.c"
  return argv [0 ] ; 
}

static Scheme_Object * do_chaperone_procedure (const char * name , const char * whating , 
int is_impersonator , int pass_self , 
int argc , Scheme_Object * argv [] , int is_unsafe ) 
{
  Scheme_Chaperone * px , * px2 ; 
  Scheme_Object * val = argv [0 ] , * orig , * r , * app_mark ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(px, 1), PUSH(px2, 2), PUSH(orig, 3), PUSH(props, 4), PUSH(val, 5), PUSH(argv, 6), PUSH(app_mark, 7), PUSH(name, 8)));
# define XfOrM599_COUNT (9)
# define SETUP_XfOrM599(x) SETUP(XfOrM599_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  px = NULLED_OUT ; 
  px2 = NULLED_OUT ; 
  orig = NULLED_OUT ; 
  r = NULLED_OUT ; 
  app_mark = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 3558 "bc/src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 0 , argc , argv ) ); 
  if (is_unsafe ) {
#   define XfOrM609_COUNT (0+XfOrM599_COUNT)
#   define SETUP_XfOrM609(x) SETUP_XfOrM599(x)

# 3564 "bc/src/fun.c"
    if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 1 , argc , argv ) ); 
  }

# 3566 "bc/src/fun.c"
  else {
#   define XfOrM608_COUNT (0+XfOrM599_COUNT)
#   define SETUP_XfOrM608(x) SETUP_XfOrM599(x)

# 3567 "bc/src/fun.c"
    if (! (((argv [1 ] ) ) == (scheme_false ) ) && ! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c procedure? #f)" , 1 , argc , argv ) ); 
  }

  orig = FUNCCALL(SETUP_XfOrM599(_), get_or_check_arity (val , - 1 , ((void * ) 0 ) , 1 ) ); 
  if (! (((argv [1 ] ) ) == (scheme_false ) ) ) {
    Scheme_Object * naya ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM599_COUNT)));
#   define XfOrM607_COUNT (1+XfOrM599_COUNT)
#   define SETUP_XfOrM607(x) SETUP(XfOrM607_COUNT)
    naya = NULLED_OUT ; 

# 3574 "bc/src/fun.c"
    naya = FUNCCALL(SETUP_XfOrM607(_), get_or_check_arity (argv [1 ] , - 1 , ((void * ) 0 ) , 1 ) ); 

    if (! FUNCCALL(SETUP_XfOrM607(_), is_subarity (orig , naya , pass_self ? 1 : 0 ) ))
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: arity of wrapper procedure does not cover arity of original procedure%s\n" "  wrapper: %V\n" "  original: %V" , name , (pass_self ? " (adding an extra argument)" : "" ) , argv [1 ] , argv [0 ] ) )






    ; 
  }

  props = FUNCCALL(SETUP_XfOrM599(_), scheme_parse_chaperone_props (name , 2 , argc , argv ) ); 
  if (props ) {
#   define XfOrM605_COUNT (0+XfOrM599_COUNT)
#   define SETUP_XfOrM605(x) SETUP_XfOrM599(x)

# 3589 "bc/src/fun.c"
    app_mark = FUNCCALL(SETUP_XfOrM605(_), scheme_chaperone_props_get (props , scheme_app_mark_impersonator_property ) ); 
    if (app_mark ) {
#     define XfOrM606_COUNT (0+XfOrM605_COUNT)
#     define SETUP_XfOrM606(x) SETUP_XfOrM605(x)

# 3592 "bc/src/fun.c"
      props = FUNCCALL(SETUP_XfOrM606(_), scheme_chaperone_props_remove (props , scheme_app_mark_impersonator_property ) ); 
    }

# 3593 "bc/src/fun.c"
    else 
    app_mark = scheme_false ; 
  }

# 3595 "bc/src/fun.c"
  else 
  app_mark = scheme_false ; 

  if ((((argv [1 ] ) ) == (scheme_false ) ) && (((app_mark ) ) == (scheme_false ) ) && ! props )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 


  if ((((app_mark ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (app_mark ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (app_mark ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
    app_mark = scheme_false ; 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM599(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_proc_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 

# 3626 "bc/src/fun.c"
  r = FUNCCALL(SETUP_XfOrM599(_), scheme_make_vector ((pass_self ? 5 : 3 ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ) ); 

  if (((argv [1 ] ) ) == (scheme_false ) ) 
    (((Scheme_Vector * ) (r ) ) -> els ) [0 ] = argv [0 ] ; 
  else 
  (((Scheme_Vector * ) (r ) ) -> els ) [0 ] = argv [1 ] ; 
  if (((argv [1 ] ) ) == (scheme_false ) ) 
    (((Scheme_Vector * ) (r ) ) -> els ) [1 ] = scheme_false ; 
  (((Scheme_Vector * ) (r ) ) -> els ) [2 ] = app_mark ; 

  px -> redirects = r ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 
  if (is_unsafe || (((argv [1 ] ) ) == (scheme_false ) ) )
    (& (px ) -> iso ) -> so . keyex |= 0x2 ; 

  if (! is_unsafe ) {


    for (val = px -> prev ; (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ; val = ((Scheme_Chaperone * ) val ) -> prev ) {
      px2 = (Scheme_Chaperone * ) val ; 
      if (((Scheme_Type ) (((((intptr_t ) (px2 -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px2 -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && ((((Scheme_Vector * ) (px2 -> redirects ) ) -> size ) & 1 ) )  {
        if (((((Scheme_Vector * ) (px2 -> redirects ) ) -> size ) > 3 ) 
        || (((Scheme_Inclhash_Object * ) (px2 -> redirects ) ) -> so . keyex & 0x1 ) )
          ((((Scheme_Inclhash_Object * ) (px -> redirects ) ) -> so . keyex |= 0x1 ) ) ; 
        break ; 
      }
    }
  }

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3660 "bc/src/fun.c"
static Scheme_Object * chaperone_procedure (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3662 "bc/src/fun.c"
  return do_chaperone_procedure ("chaperone-procedure" , "chaperoning" , 0 , 0 , argc , argv , 0 ) ; 
}

static Scheme_Object * unsafe_chaperone_procedure (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3667 "bc/src/fun.c"
  return do_chaperone_procedure ("unsafe-chaperone-procedure" , "chaperoning" , 0 , 0 , argc , argv , 1 ) ; 
}

static Scheme_Object * impersonate_procedure (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3672 "bc/src/fun.c"
  return do_chaperone_procedure ("impersonate-procedure" , "impersonating" , 1 , 0 , argc , argv , 0 ) ; 
}

static Scheme_Object * unsafe_impersonate_procedure (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3677 "bc/src/fun.c"
  return do_chaperone_procedure ("unsafe-impersonate-procedure" , "impersonating" , 1 , 0 , argc , argv , 1 ) ; 
}

static Scheme_Object * chaperone_procedure_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3682 "bc/src/fun.c"
  return do_chaperone_procedure ("chaperone-procedure*" , "chaperoning" , 0 , 1 , argc , argv , 0 ) ; 
}

static Scheme_Object * impersonate_procedure_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3687 "bc/src/fun.c"
  return do_chaperone_procedure ("impersonate-procedure*" , "impersonating" , 1 , 1 , argc , argv , 0 ) ; 
}

static Scheme_Object * apply_chaperone_k (void ) 
{
  /* No conversion */

# 3692 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * * argv = (Scheme_Object * * ) p -> ku . k . p2 ; 
  Scheme_Object * auto_val = (Scheme_Object * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return scheme_apply_chaperone (o , p -> ku . k . i1 , argv , auto_val , p -> ku . k . i2 ) ; 
}

static Scheme_Object * do_apply_chaperone (Scheme_Object * o , int argc , Scheme_Object * * argv , Scheme_Object * auto_val , int checks ) 
{
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(auto_val, 0), PUSH(argv, 1), PUSH(o, 2)));
# define XfOrM617_COUNT (3)
# define SETUP_XfOrM617(x) SETUP(XfOrM617_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3707 "bc/src/fun.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM618_COUNT (0+XfOrM617_COUNT)
#   define SETUP_XfOrM618(x) SETUP_XfOrM617(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 3709 "bc/src/fun.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      Scheme_Object * * argv2 ; 
      BLOCK_SETUP((PUSH(p, 0+XfOrM618_COUNT), PUSH(argv2, 1+XfOrM618_COUNT)));
#     define XfOrM619_COUNT (2+XfOrM618_COUNT)
#     define SETUP_XfOrM619(x) SETUP(XfOrM619_COUNT)
      argv2 = NULLED_OUT ; 

# 3712 "bc/src/fun.c"
      argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM619(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
      (memcpy (argv2 , argv , sizeof (Scheme_Object * ) * argc ) ) ; 
      p -> ku . k . p1 = (void * ) o ; 
      p -> ku . k . p2 = (void * ) argv2 ; 
      p -> ku . k . p3 = (void * ) auto_val ; 
      p -> ku . k . i1 = argc ; 
      p -> ku . k . i2 = checks ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (apply_chaperone_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_apply_chaperone (o , argc , argv , auto_val , checks ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3728 "bc/src/fun.c"
static Scheme_Object * _apply_native (Scheme_Object * obj , int num_rands , Scheme_Object * * rands ) 
{
  Scheme_Native_Lambda * data ; 
  GC_CAN_IGNORE intptr_t old_cont_mark_stack ; 
  GC_CAN_IGNORE Scheme_Object * * rs ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(obj, 0)));
# define XfOrM620_COUNT (1)
# define SETUP_XfOrM620(x) SETUP(XfOrM620_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  data = NULLED_OUT ; 

# 3734 "bc/src/fun.c"
  data = ((Scheme_Native_Closure * ) obj ) -> code ; 

  if ((uintptr_t ) data -> max_let_depth > ((uintptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (uintptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) ) {
#   define XfOrM621_COUNT (0+XfOrM620_COUNT)
#   define SETUP_XfOrM621(x) SETUP_XfOrM620(x)

# 3737 "bc/src/fun.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (obj , num_rands , rands , - 1 ) )) RET_VALUE_EMPTY_END ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
  old_cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
  rs = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 

  obj = FUNCCALL(SETUP_XfOrM620(_), data -> start_code (obj , num_rands , rands , & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) ) ); 

  if (obj == ((Scheme_Object * ) 0x4 ) )
    obj = FUNCCALL(SETUP_XfOrM620(_), scheme_force_value_same_mark (obj ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = old_cont_mark_stack ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = rs ; 

  RET_VALUE_START (obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3756 "bc/src/fun.c"
Scheme_Object * _scheme_apply_native (Scheme_Object * obj , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 3758 "bc/src/fun.c"
  return _apply_native (obj , num_rands , rands ) ; 
}

Scheme_Object * extract_impersonator_results (int c , int argc , Scheme_Object * * argv2 , 
const char * what , Scheme_Object * o , 
Scheme_Chaperone * px , 
Scheme_Cont_Frame_Data * cframe , int * _need_pop ) 
{
  int extra = c - argc ; 
  int i , fail_reason = 0 ; 
  Scheme_Object * post ; 
  char nth [32 ] ; 
  Scheme_Config * config = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(post, 0), PUSH(px, 1), PUSH(config, 2), PUSH(argv2, 3), PUSH(what, 4), PUSH(_need_pop, 5), PUSH(cframe, 6), PUSH(o, 7)));
# define XfOrM623_COUNT (8)
# define SETUP_XfOrM623(x) SETUP(XfOrM623_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  post = NULLED_OUT ; 

# 3772 "bc/src/fun.c"
  if (! extra )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  post = ((void * ) 0 ) ; 
  for (i = 0 ; i < extra ; ) {
#   define XfOrM636_COUNT (0+XfOrM623_COUNT)
#   define SETUP_XfOrM636(x) SETUP_XfOrM623(x)

# 3777 "bc/src/fun.c"
    if (! i && (! (((intptr_t ) (argv2 [0 ] ) ) & 0x1 ) && ((((argv2 [0 ] ) -> type ) >= scheme_prim_type ) && (((argv2 [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
      post = argv2 [i ] ; 
      i ++ ; 
    }

# 3780 "bc/src/fun.c"
    else if ((argv2 [i ] ) == (mark_symbol ) )  {
#     define XfOrM638_COUNT (0+XfOrM636_COUNT)
#     define SETUP_XfOrM638(x) SETUP_XfOrM636(x)

# 3781 "bc/src/fun.c"
      if (i + 3 > extra ) {
        fail_reason = 2 ; 
        break ; 
      }
      if (post && ! * _need_pop ) {
#       define XfOrM639_COUNT (0+XfOrM638_COUNT)
#       define SETUP_XfOrM639(x) SETUP_XfOrM638(x)
        FUNCCALL(SETUP_XfOrM639(_), scheme_push_continuation_frame (cframe ) )
# 3786 "bc/src/fun.c"
        ; 
        * _need_pop = 1 ; 
      }
      FUNCCALL(SETUP_XfOrM638(_), scheme_set_cont_mark (argv2 [i + 1 ] , argv2 [i + 2 ] ) ); 
      i += 3 ; 
    }

# 3791 "bc/src/fun.c"
    else {
      fail_reason = 1 ; 
      break ; 
    }
  }

  if (! fail_reason ) {
#   define XfOrM627_COUNT (0+XfOrM623_COUNT)
#   define SETUP_XfOrM627(x) SETUP_XfOrM623(x)

# 3798 "bc/src/fun.c"
    if (config ) {
#     define XfOrM628_COUNT (0+XfOrM627_COUNT)
#     define SETUP_XfOrM628(x) SETUP_XfOrM627(x)

# 3799 "bc/src/fun.c"
      if (post && ! * _need_pop ) {
#       define XfOrM629_COUNT (0+XfOrM628_COUNT)
#       define SETUP_XfOrM629(x) SETUP_XfOrM628(x)
        FUNCCALL(SETUP_XfOrM629(_), scheme_push_continuation_frame (cframe ) )
# 3800 "bc/src/fun.c"
        ; 
        * _need_pop = 1 ; 
      }
      FUNCCALL(SETUP_XfOrM628(_), scheme_set_cont_mark (scheme_parameterization_key , (Scheme_Object * ) config ) ); 
    }
    RET_VALUE_START (post ) RET_VALUE_END ; 
  }



  switch (i % 10 ) {
#   define XfOrM626_COUNT (0+XfOrM623_COUNT)
#   define SETUP_XfOrM626(x) SETUP_XfOrM623(x)

# 3811 "bc/src/fun.c"
    case 1 : (
    sprintf (nth , "%dst" , i ) ) ; 
    break ; 
    case 2 : (
    sprintf (nth , "%dnd" , i ) ) ; 
    break ; 
    case 3 : (
    sprintf (nth , "%drd" , i ) ) ; 
    break ; 
    default : (
    sprintf (nth , "%dth" , i ) ) ; 
  }

  if (fail_reason == 1 ) {
#   define XfOrM625_COUNT (0+XfOrM623_COUNT)
#   define SETUP_XfOrM625(x) SETUP_XfOrM623(x)
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "procedure %s: wrapper's %s result is not valid;\n" " %s extra result (before original argument count) should be\n" " 'mark%s\n" "  original: %V\n" "  wrapper: %V\n" "  received: %V" , what , nth , nth , (i ? "" : " or a wrapper for the original procedure's result" ) , o , (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] , argv2 [i ] ) )
# 3838 "bc/src/fun.c"
    ; 
  }

# 3839 "bc/src/fun.c"
  else if (fail_reason == 2 ) {
#   define XfOrM624_COUNT (0+XfOrM623_COUNT)
#   define SETUP_XfOrM624(x) SETUP_XfOrM623(x)
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "procedure %s: wrapper's %s result needs addition extra results;\n" " %s extra result (before original argument count) needs an\n" " additional %s after %V\n" "  original: %V\n" "  wrapper: %V" , what , nth , nth , ((i + 1 < extra ) ? "result" : "two results" ) , argv2 [i ] , o , (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ) )
# 3852 "bc/src/fun.c"
    ; 
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


Scheme_Object * scheme_apply_chaperone (Scheme_Object * o , int argc , Scheme_Object * * argv , Scheme_Object * auto_val , int checks ) 


{
  Scheme_Chaperone * px ; 
  Scheme_Object * v , * a [1 ] , * a2 [5 ] , * * argv2 , * post , * result_v , * orig_obj , * app_mark , * self_proc , * simple_call ; 
  int c , i , need_restore = 0 ; 
  int need_pop_mark ; 
  Scheme_Cont_Frame_Data cframe ; 
  const char * __funcarg201 = NULLED_OUT ; 
  const char * __funcarg199 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(19);
  BLOCK_SETUP_TOP((PUSH(post, 0), PUSH(auto_val, 1), PUSH(px, 2), PUSHARRAY(a2, 5, 3), PUSH(o, 6), PUSH(self_proc, 7), PUSH(argv, 8), PUSH(app_mark, 9), PUSH(argv2, 10), PUSH(orig_obj, 11), PUSHARRAY(a, 1, 12), PUSH(result_v, 15), PUSH(cframe.cache, 16), PUSH(v, 17), PUSH(simple_call, 18)));
# define XfOrM642_COUNT (19)
# define SETUP_XfOrM642(x) SETUP(XfOrM642_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  NULL_OUT_ARRAY (a2 ) ; 
  argv2 = NULLED_OUT ; 
  post = NULLED_OUT ; 
  result_v = NULLED_OUT ; 
  orig_obj = NULLED_OUT ; 
  app_mark = NULLED_OUT ; 
  self_proc = NULLED_OUT ; 
  simple_call = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 3873 "bc/src/fun.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) )  {




    orig_obj = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
    o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ; 
  }

# 3880 "bc/src/fun.c"
  else {
    orig_obj = ((void * ) 0 ) ; 
  }
  px = (Scheme_Chaperone * ) o ; 

  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    self_proc = p -> self_for_proc_chaperone ; 
    if (self_proc )
      p -> self_for_proc_chaperone = ((void * ) 0 ) ; 
    else 
    self_proc = o ; 
  }


  if (! ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) ) == (scheme_false ) ) 
  && (argc != (((intptr_t ) ((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) ) >> 1 ) ) ) {
#   define XfOrM706_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM706(x) SETUP_XfOrM642(x)

# 3897 "bc/src/fun.c"
    a [0 ] = px -> prev ; 
    if (! FUNCCALL(SETUP_XfOrM706(_), scheme_check_proc_arity (((void * ) 0 ) , argc , 0 , 0 , a ) )) {
#     define XfOrM707_COUNT (0+XfOrM706_COUNT)
#     define SETUP_XfOrM707(x) SETUP_XfOrM706(x)


      (void ) FUNCCALL(SETUP_XfOrM707(_), scheme_do_eval (px -> prev , argc , argv , - 1 ) ); 
      FUNCCALL(SETUP_XfOrM707(_), scheme_signal_error ("internal error: unexpected success applying chaperoned/proxied procedure" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }


    (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (argc ) ) ) << 1 ) | 0x1 ) ) ; 
  }

  if ((& (px ) -> iso ) -> so . keyex & 0x2 ) {
#   define XfOrM700_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM700(x) SETUP_XfOrM642(x)

# 3913 "bc/src/fun.c"
    if (auto_val )
      RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
    simple_call = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ; 

    if (((Scheme_Inclhash_Object * ) (px -> redirects ) ) -> so . keyex & 0x1 )  {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> self_for_proc_chaperone = self_proc ; 
    }
    if (checks ) {
#     define XfOrM701_COUNT (0+XfOrM700_COUNT)
#     define SETUP_XfOrM701(x) SETUP_XfOrM700(x)

# 3923 "bc/src/fun.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
      if (checks & 0x1 ) {
#       define XfOrM704_COUNT (0+XfOrM701_COUNT)
#       define SETUP_XfOrM704(x) SETUP_XfOrM701(x)

# 3925 "bc/src/fun.c"
        v = FUNCCALL(SETUP_XfOrM704(_), scheme_do_eval (simple_call , argc , argv , 1 ) ); 
      }

# 3926 "bc/src/fun.c"
      else if ((Scheme_Type ) (((((intptr_t ) (simple_call ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (simple_call ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) )  {
#       define XfOrM703_COUNT (0+XfOrM701_COUNT)
#       define SETUP_XfOrM703(x) SETUP_XfOrM701(x)

# 3927 "bc/src/fun.c"
        v = FUNCCALL(SETUP_XfOrM703(_), _apply_native (simple_call , argc , argv ) ); 
      }

# 3928 "bc/src/fun.c"
      else {
#       define XfOrM702_COUNT (0+XfOrM701_COUNT)
#       define SETUP_XfOrM702(x) SETUP_XfOrM701(x)

# 3929 "bc/src/fun.c"
        v = FUNCCALL(SETUP_XfOrM702(_), scheme_do_eval (simple_call , argc , argv , - 1 ) ); 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

# 3933 "bc/src/fun.c"
    else 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM700(_), scheme_tail_apply (simple_call , argc , argv ) )) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {
#   define XfOrM697_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM697(x) SETUP_XfOrM642(x)
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) {
      -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
      * XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = ((void * ) 0 ) ; 
      need_restore = 1 ; 
    }

# 3944 "bc/src/fun.c"
    else {
#     define XfOrM698_COUNT (0+XfOrM697_COUNT)
#     define SETUP_XfOrM698(x) SETUP_XfOrM697(x)

# 3946 "bc/src/fun.c"
      argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM698(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
      (memcpy (argv2 , argv , sizeof (Scheme_Object * ) * argc ) ) ; 
      argv = argv2 ; 
    }
  }

  app_mark = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [2 ] ; 
  if (((app_mark ) ) == (scheme_false ) ) 
    app_mark = ((void * ) 0 ) ; 

  if (app_mark ) {
#   define XfOrM695_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM695(x) SETUP_XfOrM642(x)

# 3957 "bc/src/fun.c"
    v = FUNCCALL(SETUP_XfOrM695(_), scheme_chaperone_get_immediate_cc_mark ((((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . car ) , ((void * ) 0 ) ) ); 
    if (v ) {
#     define XfOrM696_COUNT (0+XfOrM695_COUNT)
#     define SETUP_XfOrM696(x) SETUP_XfOrM695(x)
      FUNCCALL(SETUP_XfOrM696(_), scheme_push_continuation_frame (& cframe ) )
# 3959 "bc/src/fun.c"
      ; 
      FUNCCALL(SETUP_XfOrM696(_), scheme_set_cont_mark ((((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . car ) , v ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
      need_pop_mark = 1 ; 
    }

# 3963 "bc/src/fun.c"
    else 
    need_pop_mark = 0 ; 
  }

# 3965 "bc/src/fun.c"
  else 
  need_pop_mark = 0 ; 

  if ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) > 3 ) {
#   define XfOrM692_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM692(x) SETUP_XfOrM642(x)

# 3970 "bc/src/fun.c"
    c = argc + 1 ; 
    if (c <= 5 )
      argv2 = a2 ; 
    else 
    argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM692(_), GC_malloc (sizeof (Scheme_Object * ) * (5 ) ) )) ; 
    for (i = 0 ; i < argc ; i ++ ) {
      argv2 [i + 1 ] = argv [i ] ; 
    }
    argv2 [0 ] = self_proc ; 
  }

# 3979 "bc/src/fun.c"
  else {

    c = argc ; 
    argv2 = argv ; 
  }

  v = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ; 
  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) 
    v = FUNCCALL(SETUP_XfOrM642(_), _apply_native (v , c , argv2 ) ); 
  else 
  v = FUNCCALL(SETUP_XfOrM642(_), scheme_do_eval (v , c , argv2 , - 1 ) ); 

  if (v == ((Scheme_Object * ) 0x6 ) ) {
    GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    c = p -> ku . multiple . count ; 
    argv2 = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
    if ((argv2 ) == (p -> values_buffer ) )  {
      if (c <= 5 ) {
        for (i = 0 ; i < c ; i ++ ) {
          a2 [i ] = argv2 [i ] ; 
        }
        argv2 = a2 ; 
      }

# 4002 "bc/src/fun.c"
      else {
        p -> values_buffer = ((void * ) 0 ) ; 
      }
    }
  }

# 4006 "bc/src/fun.c"
  else {
    c = 1 ; 
    a2 [0 ] = v ; 
    argv2 = a2 ; 
  }

  if (need_pop_mark ) {
#   define XfOrM683_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM683(x) SETUP_XfOrM642(x)

# 4013 "bc/src/fun.c"
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
    FUNCCALL(SETUP_XfOrM683(_), scheme_pop_continuation_frame (& cframe ) ); 
  }

  if (c >= argc ) {
    int need_pop = 0 ; 
#   define XfOrM675_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM675(x) SETUP_XfOrM642(x)

# 4019 "bc/src/fun.c"
    post = FUNCCALL(SETUP_XfOrM675(_), extract_impersonator_results (c , argc , argv2 , (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ? "chaperone" : "impersonator" ) , o , px , & cframe , & need_pop ) )

    ; 
    need_pop_mark = need_pop ; 

    if (c > argc )
      (memmove (argv2 , argv2 + (c - argc ) , sizeof (Scheme_Object * ) * argc ) ) ; 
    if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ) {
#     define XfOrM676_COUNT (0+XfOrM675_COUNT)
#     define SETUP_XfOrM676(x) SETUP_XfOrM675(x)

# 4027 "bc/src/fun.c"
      for (i = 0 ; i < argc ; i ++ ) {
#       define XfOrM680_COUNT (0+XfOrM676_COUNT)
#       define SETUP_XfOrM680(x) SETUP_XfOrM676(x)

# 4028 "bc/src/fun.c"
        if (! ((argv2 [i ] ) == (argv [i ] ) ) 
        && ! FUNCCALL(SETUP_XfOrM680(_), scheme_chaperone_of (argv2 [i ] , argv [i ] ) )) {
#         define XfOrM681_COUNT (0+XfOrM680_COUNT)
#         define SETUP_XfOrM681(x) SETUP_XfOrM680(x)

# 4030 "bc/src/fun.c"
          if (argc == 1 )
            FUNCCALL(SETUP_XfOrM681(_), scheme_wrong_chaperoned ("procedure chaperone" , "argument" , argv [i ] , argv2 [i ] ) ); 
          else {
            char nbuf [32 ] ; 
#           define XfOrM682_COUNT (0+XfOrM681_COUNT)
#           define SETUP_XfOrM682(x) SETUP_XfOrM681(x)
            (__funcarg201 = FUNCCALL(SETUP_XfOrM682(_), scheme_number_suffix (i ) ), (
# 4034 "bc/src/fun.c"
            sprintf (nbuf , "%d%s argument" , i , __funcarg201 ) ) ) ; 
            FUNCCALL(SETUP_XfOrM682(_), scheme_wrong_chaperoned ("procedure chaperone" , nbuf , argv [i ] , argv2 [i ] ) ); 
          }
        }
      }
    }
  }

# 4040 "bc/src/fun.c"
  else {
#   define XfOrM674_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM674(x) SETUP_XfOrM642(x)
    FUNCCALL(SETUP_XfOrM674(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "procedure %s: arity mismatch;\n" " expected number of results not received from wrapper on the original\n" " procedure's arguments\n" "  original: %V\n" "  wrapper: %V\n" "  expected: %d or more\n" "  received: %d" , (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ? "chaperone" : "impersonator" ) , o , (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] , argc , c ) )
# 4053 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (need_restore ) {


    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ++ ; 
    for (i = 0 ; i < argc ; i ++ ) {
      argv [i ] = ((void * ) 0 ) ; 
    }
  }

# 4064 "bc/src/fun.c"
  else 
  argv = ((void * ) 0 ) ; 

  if (! post ) {
#   define XfOrM663_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM663(x) SETUP_XfOrM642(x)

# 4069 "bc/src/fun.c"
    if (app_mark )
      FUNCCALL(SETUP_XfOrM663(_), scheme_set_cont_mark ((((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . cdr ) ) ); 
    if (((Scheme_Inclhash_Object * ) (px -> redirects ) ) -> so . keyex & 0x1 )  {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> self_for_proc_chaperone = self_proc ; 
    }
    if (auto_val ) {
#     define XfOrM669_COUNT (0+XfOrM663_COUNT)
#     define SETUP_XfOrM669(x) SETUP_XfOrM663(x)

# 4076 "bc/src/fun.c"
      if (((Scheme_Type ) (((((intptr_t ) (px -> prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> prev ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (px -> prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> prev ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM669(_), do_apply_chaperone (px -> prev , argc , argv2 , auto_val , 0 ) )) RET_VALUE_END ; 
      else 
      RET_VALUE_START (argv2 [0 ] ) RET_VALUE_END ; 
    }

# 4080 "bc/src/fun.c"
    else {
#     define XfOrM664_COUNT (0+XfOrM663_COUNT)
#     define SETUP_XfOrM664(x) SETUP_XfOrM663(x)

# 4081 "bc/src/fun.c"
      if (orig_obj )

      orig_obj = FUNCCALL(SETUP_XfOrM664(_), scheme_make_raw_pair (px -> prev , orig_obj ) ); 
      else 
      orig_obj = px -> prev ; 
      if (checks ) {
#       define XfOrM665_COUNT (0+XfOrM664_COUNT)
#       define SETUP_XfOrM665(x) SETUP_XfOrM664(x)

# 4088 "bc/src/fun.c"
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
        if (checks & 0x1 ) {
#         define XfOrM668_COUNT (0+XfOrM665_COUNT)
#         define SETUP_XfOrM668(x) SETUP_XfOrM665(x)

# 4090 "bc/src/fun.c"
          v = FUNCCALL(SETUP_XfOrM668(_), scheme_do_eval (orig_obj , argc , argv2 , 1 ) ); 
        }

# 4091 "bc/src/fun.c"
        else if ((Scheme_Type ) (((((intptr_t ) (orig_obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_obj ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) )  {
#         define XfOrM667_COUNT (0+XfOrM665_COUNT)
#         define SETUP_XfOrM667(x) SETUP_XfOrM665(x)

# 4092 "bc/src/fun.c"
          v = FUNCCALL(SETUP_XfOrM667(_), _apply_native (orig_obj , argc , argv2 ) ); 
        }

# 4093 "bc/src/fun.c"
        else {
#         define XfOrM666_COUNT (0+XfOrM665_COUNT)
#         define SETUP_XfOrM666(x) SETUP_XfOrM665(x)

# 4094 "bc/src/fun.c"
          v = FUNCCALL(SETUP_XfOrM666(_), scheme_do_eval (orig_obj , argc , argv2 , - 1 ) ); 
        }
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
        RET_VALUE_START (v ) RET_VALUE_END ; 
      }

# 4098 "bc/src/fun.c"
      else 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM664(_), scheme_tail_apply (orig_obj , argc , argv2 ) )) RET_VALUE_END ; 
    }
  }

# 4101 "bc/src/fun.c"
  else {
#   define XfOrM643_COUNT (0+XfOrM642_COUNT)
#   define SETUP_XfOrM643(x) SETUP_XfOrM642(x)

# 4102 "bc/src/fun.c"
    if (app_mark ) {
#     define XfOrM662_COUNT (0+XfOrM643_COUNT)
#     define SETUP_XfOrM662(x) SETUP_XfOrM643(x)

# 4103 "bc/src/fun.c"
      if (! need_pop_mark )
        FUNCCALL(SETUP_XfOrM662(_), scheme_push_continuation_frame (& cframe ) ); 
      FUNCCALL(SETUP_XfOrM662(_), scheme_set_cont_mark ((((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . cdr ) ) ); 
      need_pop_mark = 1 ; 
    }

# 4107 "bc/src/fun.c"
    else 
    need_pop_mark = 0 ; 

    if (need_pop_mark )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 

    if (((Scheme_Inclhash_Object * ) (px -> redirects ) ) -> so . keyex & 0x1 )  {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> self_for_proc_chaperone = self_proc ; 
    }

    if (auto_val ) {
#     define XfOrM660_COUNT (0+XfOrM643_COUNT)
#     define SETUP_XfOrM660(x) SETUP_XfOrM643(x)

# 4119 "bc/src/fun.c"
      if (((Scheme_Type ) (((((intptr_t ) (px -> prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> prev ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (px -> prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> prev ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        result_v = FUNCCALL(SETUP_XfOrM660(_), do_apply_chaperone (px -> prev , argc , argv2 , auto_val , 0 ) ); 
      else 
      result_v = argv2 [0 ] ; 
      v = auto_val ; 
    }

# 4124 "bc/src/fun.c"
    else {
#     define XfOrM659_COUNT (0+XfOrM643_COUNT)
#     define SETUP_XfOrM659(x) SETUP_XfOrM643(x)

# 4125 "bc/src/fun.c"
      if (orig_obj )

      orig_obj = FUNCCALL(SETUP_XfOrM659(_), scheme_make_raw_pair (px -> prev , orig_obj ) ); 
      else 
      orig_obj = px -> prev ; 
      if ((Scheme_Type ) (((((intptr_t ) (orig_obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_obj ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) 
        v = FUNCCALL(SETUP_XfOrM659(_), _apply_native (orig_obj , argc , argv2 ) ); 
      else 
      v = FUNCCALL(SETUP_XfOrM659(_), scheme_do_eval (orig_obj , argc , argv2 , - 1 ) ); 
      result_v = ((void * ) 0 ) ; 
    }

    if (v == ((Scheme_Object * ) 0x6 ) ) {
      GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
      c = p -> ku . multiple . count ; 
      argv = p -> ku . multiple . array ; 
      p -> ku . multiple . array = ((void * ) 0 ) ; 
    }

# 4144 "bc/src/fun.c"
    else {
      c = 1 ; 
      a [0 ] = v ; 
      argv = a ; 
    }

    if (need_pop_mark ) {
#     define XfOrM656_COUNT (0+XfOrM643_COUNT)
#     define SETUP_XfOrM656(x) SETUP_XfOrM643(x)

# 4151 "bc/src/fun.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
      FUNCCALL(SETUP_XfOrM656(_), scheme_pop_continuation_frame (& cframe ) ); 
    }

    if (! FUNCCALL(SETUP_XfOrM643(_), scheme_check_proc_arity (((void * ) 0 ) , c , 0 , - 1 , & post ) ))
      FUNCCALL(SETUP_XfOrM643(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT , "procedure-result %s: arity mismatch;\n" " wrapper does not accept the number of values produced by\n" " the original procedure\n" "  original: %V\n" "  wrapper: %V\n" "  number of values: %d" , (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ? "chaperone" : "impersonator" ) , o , post , c ) )
# 4166 "bc/src/fun.c"
    ; 

    if ((Scheme_Type ) (((((intptr_t ) (post ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (post ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) 
      v = FUNCCALL(SETUP_XfOrM643(_), _apply_native (post , c , argv ) ); 
    else 
    v = FUNCCALL(SETUP_XfOrM643(_), scheme_do_eval (post , c , argv , - 1 ) ); 
    if (v == ((Scheme_Object * ) 0x6 ) ) {
      GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
      argc = p -> ku . multiple . count ; 
      argv2 = p -> ku . multiple . array ; 
      p -> ku . multiple . array = ((void * ) 0 ) ; 
    }

# 4179 "bc/src/fun.c"
    else {
      argc = 1 ; 
      a2 [0 ] = v ; 
      argv2 = a2 ; 
    }

    if (c == argc ) {
#     define XfOrM646_COUNT (0+XfOrM643_COUNT)
#     define SETUP_XfOrM646(x) SETUP_XfOrM643(x)

# 4186 "bc/src/fun.c"
      if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ) {
#       define XfOrM647_COUNT (0+XfOrM646_COUNT)
#       define SETUP_XfOrM647(x) SETUP_XfOrM646(x)

# 4187 "bc/src/fun.c"
        for (i = 0 ; i < argc ; i ++ ) {
#         define XfOrM651_COUNT (0+XfOrM647_COUNT)
#         define SETUP_XfOrM651(x) SETUP_XfOrM647(x)

# 4188 "bc/src/fun.c"
          if (! ((argv2 [i ] ) == (argv [i ] ) ) 
          && ! FUNCCALL(SETUP_XfOrM651(_), scheme_chaperone_of (argv2 [i ] , argv [i ] ) )) {
#           define XfOrM652_COUNT (0+XfOrM651_COUNT)
#           define SETUP_XfOrM652(x) SETUP_XfOrM651(x)

# 4190 "bc/src/fun.c"
            if (argc == 1 )
              FUNCCALL(SETUP_XfOrM652(_), scheme_wrong_chaperoned ("procedure-result chaperone" , "result" , argv [i ] , argv2 [i ] ) ); 
            else {
              char nbuf [32 ] ; 
#             define XfOrM653_COUNT (0+XfOrM652_COUNT)
#             define SETUP_XfOrM653(x) SETUP_XfOrM652(x)
              (__funcarg199 = FUNCCALL(SETUP_XfOrM653(_), scheme_number_suffix (i ) ), (
# 4194 "bc/src/fun.c"
              sprintf (nbuf , "%d%s result" , i , __funcarg199 ) ) ) ; 
              FUNCCALL(SETUP_XfOrM653(_), scheme_wrong_chaperoned ("procedure-result chaperone" , nbuf , argv [i ] , argv2 [i ] ) ); 
            }
          }
        }
      }
    }

# 4200 "bc/src/fun.c"
    else {
#     define XfOrM645_COUNT (0+XfOrM643_COUNT)
#     define SETUP_XfOrM645(x) SETUP_XfOrM643(x)
      FUNCCALL(SETUP_XfOrM645(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "procedure-result %s: result arity mismatch;\n" " expected number of values not received from wrapper on the original\n" " procedure's result\n" "  original: %V\n" "  wrapper: %V\n" "  expected: %d\n" "  received: %d" , (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ? "chaperone" : "impersonator" ) , o , post , c , argc ) )








      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (result_v )
      RET_VALUE_START (result_v ) RET_VALUE_END ; 
    else if (c == 1 )
      RET_VALUE_START (argv2 [0 ] ) RET_VALUE_END ; 
    else {
#     define XfOrM644_COUNT (0+XfOrM643_COUNT)
#     define SETUP_XfOrM644(x) SETUP_XfOrM643(x)

# 4221 "bc/src/fun.c"
      if (checks & 0x1 )
        FUNCCALL(SETUP_XfOrM644(_), scheme_wrong_return_arity (((void * ) 0 ) , 1 , c , argv2 , ((void * ) 0 ) ) ); 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM644(_), scheme_values (c , argv2 ) )) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4228 "bc/src/fun.c"
static Scheme_Object * 
apply (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * rands ; 
  Scheme_Object * * rand_vec ; 
  int i , num_rands ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(rands, 0), PUSH(argv, 1), PUSH(p, 2), PUSH(rand_vec, 3)));
# define XfOrM711_COUNT (4)
# define SETUP_XfOrM711(x) SETUP(XfOrM711_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rands = NULLED_OUT ; 
  rand_vec = NULLED_OUT ; 

# 4236 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
#   define XfOrM718_COUNT (0+XfOrM711_COUNT)
#   define SETUP_XfOrM718(x) SETUP_XfOrM711(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("apply" , "procedure?" , 0 , argc , argv ) )
# 4237 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  rands = argv [argc - 1 ] ; 

  num_rands = (scheme_proper_list_length (rands ) ) ; 
  if (num_rands < 0 ) {
#   define XfOrM717_COUNT (0+XfOrM711_COUNT)
#   define SETUP_XfOrM717(x) SETUP_XfOrM711(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("apply" , "list?" , argc - 1 , argc , argv ) )
# 4245 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  num_rands += (argc - 2 ) ; 

  if (num_rands > p -> tail_buffer_size ) {
#   define XfOrM716_COUNT (0+XfOrM711_COUNT)
#   define SETUP_XfOrM716(x) SETUP_XfOrM711(x)

# 4251 "bc/src/fun.c"
    rand_vec = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM716(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rands ) ) )) ; 
  }
  else 
  rand_vec = p -> tail_buffer ; 

  for (i = argc - 2 ; i -- ; ) {
    rand_vec [i ] = argv [i + 1 ] ; 
  }

  for (i = argc - 2 ; ((Scheme_Type ) (((((intptr_t ) (rands ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rands ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; i ++ , rands = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . cdr ) ) {
    rand_vec [i ] = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . car ) ; 
  }

  p -> ku . apply . tail_rator = argv [0 ] ; 
  p -> ku . apply . tail_rands = rand_vec ; 
  p -> ku . apply . tail_num_rands = num_rands ; 

  RET_VALUE_START (((Scheme_Object * ) 0x4 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 13 "bc/src/schmap.inc"
static Scheme_Object * 
map (int argc , Scheme_Object * argv [] ) 
{


  int i , size = 0 , l , pos , pop_runstack = 0 ; 
  Scheme_Object * quick1 [3 ] , * quick2 [3 ] ; 
  Scheme_Object * * working , * * args ; 

  Scheme_Object * quick3 [5 ] , * * resarray ; 


  Scheme_Object * v ; 

  Scheme_Object * proc ; 
  int cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(args, 1), PUSHARRAY(quick1, 3, 2), PUSHARRAY(quick2, 3, 5), PUSH(resarray, 8), PUSHARRAY(quick3, 5, 9), PUSH(argv, 12), PUSH(working, 13), PUSH(v, 14)));
# define XfOrM719_COUNT (15)
# define SETUP_XfOrM719(x) SETUP(XfOrM719_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  quick1[0] = NULLED_OUT ; 
  quick1[1] = NULLED_OUT ; 
  quick1[2] = NULLED_OUT ; 
  quick2[0] = NULLED_OUT ; 
  quick2[1] = NULLED_OUT ; 
  quick2[2] = NULLED_OUT ; 
  working = NULLED_OUT ; 
  args = NULLED_OUT ; 
  NULL_OUT_ARRAY (quick3 ) ; 
  resarray = NULLED_OUT ; 
  v = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 30 "bc/src/schmap.inc"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM719(_), scheme_wrong_contract ("map" , "procedure?" , 0 , argc , argv ) ); 

  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM745_COUNT (0+XfOrM719_COUNT)
#   define SETUP_XfOrM745(x) SETUP_XfOrM719(x)

# 34 "bc/src/schmap.inc"
    l = (scheme_proper_list_length (argv [i ] ) ) ; 

    if (l < 0 )
      FUNCCALL(SETUP_XfOrM745(_), scheme_wrong_contract ("map" , "list?" , i , argc , argv ) ); 

    if (i == 1 )
      size = l ; 
    else if (size != l ) {
      char * argstr ; 
      intptr_t alen ; 
      BLOCK_SETUP((PUSH(argstr, 0+XfOrM745_COUNT)));
#     define XfOrM746_COUNT (1+XfOrM745_COUNT)
#     define SETUP_XfOrM746(x) SETUP(XfOrM746_COUNT)
      argstr = NULLED_OUT ; 

# 45 "bc/src/schmap.inc"
      argstr = FUNCCALL(SETUP_XfOrM746(_), scheme_make_args_string ("" , - 1 , argc , argv , & alen ) ); 
      FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: all lists must have same size%t" , "map" , argstr , alen ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((FUNCCALL(SETUP_XfOrM719(_), scheme_get_or_check_arity (argv [0 ] , argc - 1 ) )) ) == (scheme_false ) )  {
    char * s ; 
    intptr_t aelen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM719_COUNT)));
#   define XfOrM742_COUNT (1+XfOrM719_COUNT)
#   define SETUP_XfOrM742(x) SETUP(XfOrM742_COUNT)
    s = NULLED_OUT ; 

# 58 "bc/src/schmap.inc"
    s = FUNCCALL(SETUP_XfOrM742(_), scheme_make_arity_expect_string ("map" , argv [0 ] , argc - 1 , ((void * ) 0 ) , & aelen ) ); 
    FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , aelen ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {




    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 72 "bc/src/schmap.inc"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (argc - 1 ) >= (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + 5 ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) -= (argc - 1 ) ; 
    pop_runstack = 1 ; 
    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 76 "bc/src/schmap.inc"
  else if (argc <= (3 + 1 ) ) {
    args = quick1 ; 
  }

# 78 "bc/src/schmap.inc"
  else {
#   define XfOrM738_COUNT (0+XfOrM719_COUNT)
#   define SETUP_XfOrM738(x) SETUP_XfOrM719(x)

# 79 "bc/src/schmap.inc"
    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM738(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }

  if (argc <= (3 + 1 ) ) {
    working = quick2 ; 
  }

# 84 "bc/src/schmap.inc"
  else {
#   define XfOrM736_COUNT (0+XfOrM719_COUNT)
#   define SETUP_XfOrM736(x) SETUP_XfOrM719(x)

# 85 "bc/src/schmap.inc"
    working = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM736(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }


  if (size <= 5 )
    resarray = quick3 ; 
  else 
  resarray = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM719(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 



  for (i = 1 ; i < argc ; i ++ ) {
    working [i - 1 ] = argv [i ] ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {

      argv [i ] = ((void * ) 0 ) ; 
    }
  }

  -- argc ; 
  proc = argv [0 ] ; 
  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) )
    argv [0 ] = ((void * ) 0 ) ; 
  argv = ((void * ) 0 ) ; 

  pos = 0 ; 
  while (pos < size ) {
#   define XfOrM726_COUNT (0+XfOrM719_COUNT)
#   define SETUP_XfOrM726(x) SETUP_XfOrM719(x)

# 113 "bc/src/schmap.inc"
    for (i = 0 ; i < argc ; i ++ ) {

# 124 "bc/src/schmap.inc"
      args [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . car ) ; 


      working [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . cdr ) ; 
    }

    cc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 


    v = FUNCCALL(SETUP_XfOrM726(_), scheme_do_eval (proc , argc , args , 1 ) ); 

# 149 "bc/src/schmap.inc"
    if (cc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM727_COUNT (0+XfOrM726_COUNT)
#     define SETUP_XfOrM727(x) SETUP_XfOrM726(x)
      if (size > 5 ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM727_COUNT)));
#       define XfOrM729_COUNT (1+XfOrM727_COUNT)
#       define SETUP_XfOrM729(x) SETUP(XfOrM729_COUNT)
        naya = NULLED_OUT ; 

# 154 "bc/src/schmap.inc"
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM729(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 
        (memcpy (naya , resarray , pos * sizeof (Scheme_Object * ) ) ) ; 
        resarray = naya ; 
      }

      if ((argc > 3 ) && (pos + 1 < size ) ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM727_COUNT)));
#       define XfOrM728_COUNT (1+XfOrM727_COUNT)
#       define SETUP_XfOrM728(x) SETUP(XfOrM728_COUNT)
        naya = NULLED_OUT ; 

# 161 "bc/src/schmap.inc"
        args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM728(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM728(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        (memcpy (naya , working , argc * sizeof (Scheme_Object * ) ) ) ; 
        working = naya ; 
      }
    }


    resarray [pos ] = v ; 

# 185 "bc/src/schmap.inc"
    pos ++ ; 
  }

  if (pop_runstack )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 


  RET_VALUE_START (FUNCCALL(SETUP_XfOrM719(_), scheme_build_list (size , resarray ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 13 "bc/src/schmap.inc"
static Scheme_Object * 
for_each (int argc , Scheme_Object * argv [] ) 
{


  int i , size = 0 , l , pos , pop_runstack = 0 ; 
  Scheme_Object * quick1 [3 ] , * quick2 [3 ] ; 
  Scheme_Object * * working , * * args ; 






  Scheme_Object * proc ; 
  int cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(args, 1), PUSHARRAY(quick1, 3, 2), PUSH(argv, 5), PUSH(working, 6), PUSHARRAY(quick2, 3, 7)));
# define XfOrM747_COUNT (10)
# define SETUP_XfOrM747(x) SETUP(XfOrM747_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  quick1[0] = NULLED_OUT ; 
  quick1[1] = NULLED_OUT ; 
  quick1[2] = NULLED_OUT ; 
  quick2[0] = NULLED_OUT ; 
  quick2[1] = NULLED_OUT ; 
  quick2[2] = NULLED_OUT ; 
  working = NULLED_OUT ; 
  args = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 30 "bc/src/schmap.inc"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM747(_), scheme_wrong_contract ("for-each" , "procedure?" , 0 , argc , argv ) ); 

  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM771_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM771(x) SETUP_XfOrM747(x)

# 34 "bc/src/schmap.inc"
    l = (scheme_proper_list_length (argv [i ] ) ) ; 

    if (l < 0 )
      FUNCCALL(SETUP_XfOrM771(_), scheme_wrong_contract ("for-each" , "list?" , i , argc , argv ) ); 

    if (i == 1 )
      size = l ; 
    else if (size != l ) {
      char * argstr ; 
      intptr_t alen ; 
      BLOCK_SETUP((PUSH(argstr, 0+XfOrM771_COUNT)));
#     define XfOrM772_COUNT (1+XfOrM771_COUNT)
#     define SETUP_XfOrM772(x) SETUP(XfOrM772_COUNT)
      argstr = NULLED_OUT ; 

# 45 "bc/src/schmap.inc"
      argstr = FUNCCALL(SETUP_XfOrM772(_), scheme_make_args_string ("" , - 1 , argc , argv , & alen ) ); 
      FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: all lists must have same size%t" , "for-each" , argstr , alen ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((FUNCCALL(SETUP_XfOrM747(_), scheme_get_or_check_arity (argv [0 ] , argc - 1 ) )) ) == (scheme_false ) )  {
    char * s ; 
    intptr_t aelen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM747_COUNT)));
#   define XfOrM768_COUNT (1+XfOrM747_COUNT)
#   define SETUP_XfOrM768(x) SETUP(XfOrM768_COUNT)
    s = NULLED_OUT ; 

# 58 "bc/src/schmap.inc"
    s = FUNCCALL(SETUP_XfOrM768(_), scheme_make_arity_expect_string ("for-each" , argv [0 ] , argc - 1 , ((void * ) 0 ) , & aelen ) ); 
    FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , aelen ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {




    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 72 "bc/src/schmap.inc"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (argc - 1 ) >= (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + 5 ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) -= (argc - 1 ) ; 
    pop_runstack = 1 ; 
    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 76 "bc/src/schmap.inc"
  else if (argc <= (3 + 1 ) ) {
    args = quick1 ; 
  }

# 78 "bc/src/schmap.inc"
  else {
#   define XfOrM764_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM764(x) SETUP_XfOrM747(x)

# 79 "bc/src/schmap.inc"
    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM764(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }

  if (argc <= (3 + 1 ) ) {
    working = quick2 ; 
  }

# 84 "bc/src/schmap.inc"
  else {
#   define XfOrM762_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM762(x) SETUP_XfOrM747(x)

# 85 "bc/src/schmap.inc"
    working = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM762(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }









  for (i = 1 ; i < argc ; i ++ ) {
    working [i - 1 ] = argv [i ] ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {

      argv [i ] = ((void * ) 0 ) ; 
    }
  }

  -- argc ; 
  proc = argv [0 ] ; 
  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) )
    argv [0 ] = ((void * ) 0 ) ; 
  argv = ((void * ) 0 ) ; 

  pos = 0 ; 
  while (pos < size ) {
#   define XfOrM753_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM753(x) SETUP_XfOrM747(x)

# 113 "bc/src/schmap.inc"
    for (i = 0 ; i < argc ; i ++ ) {

# 124 "bc/src/schmap.inc"
      args [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . car ) ; 


      working [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . cdr ) ; 
    }

    cc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 
    FUNCCALL(SETUP_XfOrM753(_), scheme_do_eval (proc , argc , args , - 1 ) )




    ; 

# 149 "bc/src/schmap.inc"
    if (cc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM754_COUNT (0+XfOrM753_COUNT)
#     define SETUP_XfOrM754(x) SETUP_XfOrM753(x)







      if ((argc > 3 ) && (pos + 1 < size ) ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM754_COUNT)));
#       define XfOrM755_COUNT (1+XfOrM754_COUNT)
#       define SETUP_XfOrM755(x) SETUP(XfOrM755_COUNT)
        naya = NULLED_OUT ; 

# 161 "bc/src/schmap.inc"
        args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM755(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM755(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        (memcpy (naya , working , argc * sizeof (Scheme_Object * ) ) ) ; 
        working = naya ; 
      }
    }

# 185 "bc/src/schmap.inc"
    pos ++ ; 
  }

  if (pop_runstack )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 





  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 13 "bc/src/schmap.inc"
static Scheme_Object * 
andmap (int argc , Scheme_Object * argv [] ) 
{


  int i , size = 0 , l , pos , pop_runstack = 0 ; 
  Scheme_Object * quick1 [3 ] , * quick2 [3 ] ; 
  Scheme_Object * * working , * * args ; 




  Scheme_Object * v ; 

  Scheme_Object * proc ; 
  int cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSHARRAY(quick1, 3, 0), PUSH(args, 3), PUSH(proc, 4), PUSHARRAY(quick2, 3, 5), PUSH(argv, 8), PUSH(working, 9), PUSH(v, 10)));
# define XfOrM773_COUNT (11)
# define SETUP_XfOrM773(x) SETUP(XfOrM773_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  quick1[0] = NULLED_OUT ; 
  quick1[1] = NULLED_OUT ; 
  quick1[2] = NULLED_OUT ; 
  quick2[0] = NULLED_OUT ; 
  quick2[1] = NULLED_OUT ; 
  quick2[2] = NULLED_OUT ; 
  working = NULLED_OUT ; 
  args = NULLED_OUT ; 
  v = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 30 "bc/src/schmap.inc"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM773(_), scheme_wrong_contract ("andmap" , "procedure?" , 0 , argc , argv ) ); 

  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM803_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM803(x) SETUP_XfOrM773(x)

# 34 "bc/src/schmap.inc"
    l = (scheme_proper_list_length (argv [i ] ) ) ; 

    if (l < 0 )
      FUNCCALL(SETUP_XfOrM803(_), scheme_wrong_contract ("andmap" , "list?" , i , argc , argv ) ); 

    if (i == 1 )
      size = l ; 
    else if (size != l ) {
      char * argstr ; 
      intptr_t alen ; 
      BLOCK_SETUP((PUSH(argstr, 0+XfOrM803_COUNT)));
#     define XfOrM804_COUNT (1+XfOrM803_COUNT)
#     define SETUP_XfOrM804(x) SETUP(XfOrM804_COUNT)
      argstr = NULLED_OUT ; 

# 45 "bc/src/schmap.inc"
      argstr = FUNCCALL(SETUP_XfOrM804(_), scheme_make_args_string ("" , - 1 , argc , argv , & alen ) ); 
      FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: all lists must have same size%t" , "andmap" , argstr , alen ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((FUNCCALL(SETUP_XfOrM773(_), scheme_get_or_check_arity (argv [0 ] , argc - 1 ) )) ) == (scheme_false ) )  {
    char * s ; 
    intptr_t aelen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM773_COUNT)));
#   define XfOrM800_COUNT (1+XfOrM773_COUNT)
#   define SETUP_XfOrM800(x) SETUP(XfOrM800_COUNT)
    s = NULLED_OUT ; 

# 58 "bc/src/schmap.inc"
    s = FUNCCALL(SETUP_XfOrM800(_), scheme_make_arity_expect_string ("andmap" , argv [0 ] , argc - 1 , ((void * ) 0 ) , & aelen ) ); 
    FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , aelen ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {




    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 72 "bc/src/schmap.inc"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (argc - 1 ) >= (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + 5 ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) -= (argc - 1 ) ; 
    pop_runstack = 1 ; 
    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 76 "bc/src/schmap.inc"
  else if (argc <= (3 + 1 ) ) {
    args = quick1 ; 
  }

# 78 "bc/src/schmap.inc"
  else {
#   define XfOrM796_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM796(x) SETUP_XfOrM773(x)

# 79 "bc/src/schmap.inc"
    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM796(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }

  if (argc <= (3 + 1 ) ) {
    working = quick2 ; 
  }

# 84 "bc/src/schmap.inc"
  else {
#   define XfOrM794_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM794(x) SETUP_XfOrM773(x)

# 85 "bc/src/schmap.inc"
    working = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM794(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }









  for (i = 1 ; i < argc ; i ++ ) {
    working [i - 1 ] = argv [i ] ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {

      argv [i ] = ((void * ) 0 ) ; 
    }
  }

  -- argc ; 
  proc = argv [0 ] ; 
  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) )
    argv [0 ] = ((void * ) 0 ) ; 
  argv = ((void * ) 0 ) ; 

  pos = 0 ; 
  while (pos < size ) {
#   define XfOrM782_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM782(x) SETUP_XfOrM773(x)

# 113 "bc/src/schmap.inc"
    for (i = 0 ; i < argc ; i ++ ) {

# 124 "bc/src/schmap.inc"
      args [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . car ) ; 


      working [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . cdr ) ; 
    }

    cc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 







    if (pos + 1 == size ) {
#     define XfOrM787_COUNT (0+XfOrM782_COUNT)
#     define SETUP_XfOrM787(x) SETUP_XfOrM782(x)

# 139 "bc/src/schmap.inc"
      v = FUNCCALL(SETUP_XfOrM787(_), scheme_tail_apply (proc , argc , args ) ); 
      if (pop_runstack )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

# 143 "bc/src/schmap.inc"
    else {
#     define XfOrM786_COUNT (0+XfOrM782_COUNT)
#     define SETUP_XfOrM786(x) SETUP_XfOrM782(x)

# 144 "bc/src/schmap.inc"
      v = FUNCCALL(SETUP_XfOrM786(_), scheme_do_eval (proc , argc , args , 1 ) ); 
    }



    if (cc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM784_COUNT (0+XfOrM782_COUNT)
#     define SETUP_XfOrM784(x) SETUP_XfOrM782(x)







      if ((argc > 3 ) && (pos + 1 < size ) ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM784_COUNT)));
#       define XfOrM785_COUNT (1+XfOrM784_COUNT)
#       define SETUP_XfOrM785(x) SETUP(XfOrM785_COUNT)
        naya = NULLED_OUT ; 

# 161 "bc/src/schmap.inc"
        args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM785(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM785(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        (memcpy (naya , working , argc * sizeof (Scheme_Object * ) ) ) ; 
        working = naya ; 
      }
    }





    if (((v ) ) == (scheme_false ) )  {
      if (pop_runstack )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }








    pos ++ ; 
  }

  if (pop_runstack )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 








  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 13 "bc/src/schmap.inc"
static Scheme_Object * 
ormap (int argc , Scheme_Object * argv [] ) 
{


  int i , size = 0 , l , pos , pop_runstack = 0 ; 
  Scheme_Object * quick1 [3 ] , * quick2 [3 ] ; 
  Scheme_Object * * working , * * args ; 




  Scheme_Object * v ; 

  Scheme_Object * proc ; 
  int cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSHARRAY(quick1, 3, 0), PUSH(args, 3), PUSH(proc, 4), PUSHARRAY(quick2, 3, 5), PUSH(argv, 8), PUSH(working, 9), PUSH(v, 10)));
# define XfOrM805_COUNT (11)
# define SETUP_XfOrM805(x) SETUP(XfOrM805_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  quick1[0] = NULLED_OUT ; 
  quick1[1] = NULLED_OUT ; 
  quick1[2] = NULLED_OUT ; 
  quick2[0] = NULLED_OUT ; 
  quick2[1] = NULLED_OUT ; 
  quick2[2] = NULLED_OUT ; 
  working = NULLED_OUT ; 
  args = NULLED_OUT ; 
  v = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 30 "bc/src/schmap.inc"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM805(_), scheme_wrong_contract ("ormap" , "procedure?" , 0 , argc , argv ) ); 

  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM835_COUNT (0+XfOrM805_COUNT)
#   define SETUP_XfOrM835(x) SETUP_XfOrM805(x)

# 34 "bc/src/schmap.inc"
    l = (scheme_proper_list_length (argv [i ] ) ) ; 

    if (l < 0 )
      FUNCCALL(SETUP_XfOrM835(_), scheme_wrong_contract ("ormap" , "list?" , i , argc , argv ) ); 

    if (i == 1 )
      size = l ; 
    else if (size != l ) {
      char * argstr ; 
      intptr_t alen ; 
      BLOCK_SETUP((PUSH(argstr, 0+XfOrM835_COUNT)));
#     define XfOrM836_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM836(x) SETUP(XfOrM836_COUNT)
      argstr = NULLED_OUT ; 

# 45 "bc/src/schmap.inc"
      argstr = FUNCCALL(SETUP_XfOrM836(_), scheme_make_args_string ("" , - 1 , argc , argv , & alen ) ); 
      FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: all lists must have same size%t" , "ormap" , argstr , alen ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((FUNCCALL(SETUP_XfOrM805(_), scheme_get_or_check_arity (argv [0 ] , argc - 1 ) )) ) == (scheme_false ) )  {
    char * s ; 
    intptr_t aelen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM805_COUNT)));
#   define XfOrM832_COUNT (1+XfOrM805_COUNT)
#   define SETUP_XfOrM832(x) SETUP(XfOrM832_COUNT)
    s = NULLED_OUT ; 

# 58 "bc/src/schmap.inc"
    s = FUNCCALL(SETUP_XfOrM832(_), scheme_make_arity_expect_string ("ormap" , argv [0 ] , argc - 1 , ((void * ) 0 ) , & aelen ) ); 
    FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , aelen ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {




    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 72 "bc/src/schmap.inc"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (argc - 1 ) >= (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + 5 ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) -= (argc - 1 ) ; 
    pop_runstack = 1 ; 
    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 76 "bc/src/schmap.inc"
  else if (argc <= (3 + 1 ) ) {
    args = quick1 ; 
  }

# 78 "bc/src/schmap.inc"
  else {
#   define XfOrM828_COUNT (0+XfOrM805_COUNT)
#   define SETUP_XfOrM828(x) SETUP_XfOrM805(x)

# 79 "bc/src/schmap.inc"
    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM828(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }

  if (argc <= (3 + 1 ) ) {
    working = quick2 ; 
  }

# 84 "bc/src/schmap.inc"
  else {
#   define XfOrM826_COUNT (0+XfOrM805_COUNT)
#   define SETUP_XfOrM826(x) SETUP_XfOrM805(x)

# 85 "bc/src/schmap.inc"
    working = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM826(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }









  for (i = 1 ; i < argc ; i ++ ) {
    working [i - 1 ] = argv [i ] ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {

      argv [i ] = ((void * ) 0 ) ; 
    }
  }

  -- argc ; 
  proc = argv [0 ] ; 
  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) )
    argv [0 ] = ((void * ) 0 ) ; 
  argv = ((void * ) 0 ) ; 

  pos = 0 ; 
  while (pos < size ) {
#   define XfOrM814_COUNT (0+XfOrM805_COUNT)
#   define SETUP_XfOrM814(x) SETUP_XfOrM805(x)

# 113 "bc/src/schmap.inc"
    for (i = 0 ; i < argc ; i ++ ) {

# 124 "bc/src/schmap.inc"
      args [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . car ) ; 


      working [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . cdr ) ; 
    }

    cc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 







    if (pos + 1 == size ) {
#     define XfOrM819_COUNT (0+XfOrM814_COUNT)
#     define SETUP_XfOrM819(x) SETUP_XfOrM814(x)

# 139 "bc/src/schmap.inc"
      v = FUNCCALL(SETUP_XfOrM819(_), scheme_tail_apply (proc , argc , args ) ); 
      if (pop_runstack )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

# 143 "bc/src/schmap.inc"
    else {
#     define XfOrM818_COUNT (0+XfOrM814_COUNT)
#     define SETUP_XfOrM818(x) SETUP_XfOrM814(x)

# 144 "bc/src/schmap.inc"
      v = FUNCCALL(SETUP_XfOrM818(_), scheme_do_eval (proc , argc , args , 1 ) ); 
    }



    if (cc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM816_COUNT (0+XfOrM814_COUNT)
#     define SETUP_XfOrM816(x) SETUP_XfOrM814(x)







      if ((argc > 3 ) && (pos + 1 < size ) ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM816_COUNT)));
#       define XfOrM817_COUNT (1+XfOrM816_COUNT)
#       define SETUP_XfOrM817(x) SETUP(XfOrM817_COUNT)
        naya = NULLED_OUT ; 

# 161 "bc/src/schmap.inc"
        args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM817(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM817(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        (memcpy (naya , working , argc * sizeof (Scheme_Object * ) ) ) ; 
        working = naya ; 
      }
    }

# 179 "bc/src/schmap.inc"
    if (! (((v ) ) == (scheme_false ) ) )  {
      if (pop_runstack )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

    pos ++ ; 
  }

  if (pop_runstack )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 

# 201 "bc/src/schmap.inc"
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4303 "bc/src/fun.c"
static Scheme_Object * call_with_values (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(p, 1), PUSH(v, 2)));
# define XfOrM837_COUNT (3)
# define SETUP_XfOrM837(x) SETUP(XfOrM837_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM837(_), scheme_check_proc_arity ("call-with-values" , 0 , 0 , argc , argv ) )
# 4308 "bc/src/fun.c"
  ; 
  if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("call-with-values" , "procedure?" , 1 , argc , argv ) ); 

  v = FUNCCALL(SETUP_XfOrM837(_), scheme_do_eval (argv [0 ] , 0 , ((void * ) 0 ) , - 1 ) ); 
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
    int n ; 
    Scheme_Object * * a ; 
    a = NULLED_OUT ; 

# 4317 "bc/src/fun.c"
    if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
    n = p -> ku . multiple . count ; 
    a = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
    p -> ku . apply . tail_num_rands = n ; 
    p -> ku . apply . tail_rands = a ; 
  }

# 4324 "bc/src/fun.c"
  else {
    p -> ku . apply . tail_num_rands = 1 ; 
    p -> ku . apply . tail_rands = p -> tail_buffer ; 
    p -> ku . apply . tail_rands [0 ] = v ; 
  }

  p -> ku . apply . tail_rator = argv [1 ] ; 

  RET_VALUE_START (((Scheme_Object * ) 0x4 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4335 "bc/src/fun.c"
static inline Scheme_Object * values_slow (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * * a ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(a, 1), PUSH(p, 2)));
# define XfOrM840_COUNT (3)
# define SETUP_XfOrM840(x) SETUP(XfOrM840_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 4341 "bc/src/fun.c"
  a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM840(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
  p -> values_buffer = a ; 
  p -> values_buffer_size = argc ; 

  p -> ku . multiple . array = a ; 

  for (i = 0 ; i < argc ; i ++ ) {
    a [i ] = argv [i ] ; 
  }

  RET_VALUE_START (((Scheme_Object * ) 0x6 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4354 "bc/src/fun.c"
Scheme_Object * scheme_values (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4356 "bc/src/fun.c"
  Scheme_Thread * p ; 
  int i ; 
  Scheme_Object * * a ; 

  if (argc == 1 )
    return argv [0 ] ; 

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  p -> ku . multiple . count = argc ; 
  if (p -> values_buffer && (p -> values_buffer_size >= argc ) ) {
    a = p -> values_buffer ; 
  }

# 4367 "bc/src/fun.c"
  else {
    return values_slow (argc , argv ) ; 
  }

  p -> ku . multiple . array = a ; 

  for (i = 0 ; i < argc ; i ++ ) {
    a [i ] = argv [i ] ; 
  }

  return ((Scheme_Object * ) 0x6 ) ; 
}

void scheme_detach_multple_array (Scheme_Object * * values ) 
{
  /* No conversion */

# 4382 "bc/src/fun.c"
  Scheme_Thread * t = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if ((values ) == (t -> values_buffer ) ) 
    t -> values_buffer = ((void * ) 0 ) ; 
}





static void reset_cjs (Scheme_Continuation_Jump_State * a ) 
{
  /* No conversion */

# 4394 "bc/src/fun.c"
  a -> jumping_to_continuation = ((void * ) 0 ) ; 
  a -> alt_full_continuation = ((void * ) 0 ) ; 
  a -> val = ((void * ) 0 ) ; 
  a -> num_vals = 0 ; 
  a -> is_kill = 0 ; 
  a -> is_escape = 0 ; 
  a -> skip_dws = 0 ; 
}

void scheme_clear_escape (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM850_COUNT (1)
# define SETUP_XfOrM850(x) SETUP(XfOrM850_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM850(_), reset_cjs (& p -> cjs ) )
# 4407 "bc/src/fun.c"
  ; 
  p -> suspend_break = 0 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4411 "bc/src/fun.c"
static void copy_cjs (Scheme_Continuation_Jump_State * a , Scheme_Continuation_Jump_State * b ) 
{
  /* No conversion */

# 4413 "bc/src/fun.c"
  a -> jumping_to_continuation = b -> jumping_to_continuation ; 
  a -> alt_full_continuation = b -> alt_full_continuation ; 
  a -> val = b -> val ; 
  a -> num_vals = b -> num_vals ; 
  a -> is_kill = b -> is_kill ; 
  a -> is_escape = b -> is_escape ; 
  a -> skip_dws = b -> skip_dws ; 
}

Scheme_Object * 
do_call_ec (int argc , Scheme_Object * argv [] , Scheme_Object * _for_cc ) 
{
  mz_jmp_buf newbuf ; 
  Scheme_Escaping_Cont * volatile cont ; 
  Scheme_Thread * p1 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * volatile v ; 
  Scheme_Object * a [1 ] ; 
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Prompt * barrier_prompt ; 
  Scheme_Object * volatile for_cc = _for_cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(for_cc, 0), PUSHARRAY(a, 1, 1), PUSH(cont, 4), PUSH(p1, 5), PUSH(barrier_prompt, 6), PUSH(argv, 7), PUSH(cframe.cache, 8), PUSH(v, 9)));
# define XfOrM852_COUNT (10)
# define SETUP_XfOrM852(x) SETUP(XfOrM852_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cont = NULLED_OUT ; 
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  barrier_prompt = NULLED_OUT ; 

# 4434 "bc/src/fun.c"
  cont = ((Scheme_Escaping_Cont * ) FUNCCALL(SETUP_XfOrM852(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Escaping_Cont ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  cont -> so . type = scheme_escaping_cont_type ; 
  FUNCCALL(SETUP_XfOrM852(_), ASSERT_SUSPEND_BREAK_ZERO () ); 

  cont -> saveerr = p1 -> error_buf ; 
  p1 -> error_buf = & newbuf ; 
  cont -> myerr = & newbuf ; 

  (cont -> envss . runstack_offset = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , cont -> envss . cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , cont -> envss . cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ; 

  barrier_prompt = FUNCCALL(SETUP_XfOrM852(_), scheme_get_barrier_prompt (((void * ) 0 ) , ((void * ) 0 ) ) ); 
  cont -> barrier_prompt = barrier_prompt ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ++ ; 

  if (! for_cc )
    FUNCCALL(SETUP_XfOrM852(_), scheme_push_continuation_frame (& cframe ) ); 
  FUNCCALL(SETUP_XfOrM852(_), scheme_set_cont_mark ((Scheme_Object * ) cont , scheme_true ) ); 

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM852_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    Scheme_Thread * p2 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(p2, 0+XfOrM852_COUNT)));
#   define XfOrM855_COUNT (1+XfOrM852_COUNT)
#   define SETUP_XfOrM855(x) SETUP(XfOrM855_COUNT)

# 4455 "bc/src/fun.c"
    if (p2 -> cjs . jumping_to_continuation 
    && ((p2 -> cjs . jumping_to_continuation ) == ((Scheme_Object * ) cont ) ) ) {
      Scheme_Object * alt_cont ; 
      int n ; 
#     define XfOrM857_COUNT (0+XfOrM855_COUNT)
#     define SETUP_XfOrM857(x) SETUP_XfOrM855(x)
      alt_cont = NULLED_OUT ; 

# 4460 "bc/src/fun.c"
      alt_cont = p2 -> cjs . alt_full_continuation ; 
      if (alt_cont && ! ((Scheme_Cont * ) alt_cont ) -> orig_escape_cont ) {
#       define XfOrM858_COUNT (0+XfOrM857_COUNT)
#       define SETUP_XfOrM858(x) SETUP_XfOrM857(x)


        RET_VALUE_START (FUNCCALL(SETUP_XfOrM858(_), jump_to_alt_continuation () )) RET_VALUE_END ; 
      }

      n = p2 -> cjs . num_vals ; 
      v = p2 -> cjs . val ; 
      FUNCCALL(SETUP_XfOrM857(_), reset_cjs (& p2 -> cjs ) ); 
      (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + cont -> envss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = cont -> envss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = cont -> envss . cont_mark_pos ) ; 
      p2 -> suspend_break = 0 ; 
      FUNCCALL(SETUP_XfOrM857(_), scheme_check_break_now () ); 
      if (n != 1 )
        v = FUNCCALL(SETUP_XfOrM857(_), scheme_values (n , (Scheme_Object * * ) v ) ); 
      else if (v && ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_thunk_for_continue_type ) ) )
        v = FUNCCALL(SETUP_XfOrM857(_), scheme_do_eval ((((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) , 0 , ((void * ) 0 ) , - 1 ) ); 
    }

# 4479 "bc/src/fun.c"
    else {
      (((intptr_t * ) (void * ) ((* cont -> saveerr ) . gcvs ) ) [1 ] = (* cont -> saveerr ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* cont -> saveerr ) . gcvs , longjmp ((* cont -> saveerr ) . jb , 1 ) ) ; 
    }
  }

# 4482 "bc/src/fun.c"
  else if (for_cc ) {
#   define XfOrM854_COUNT (0+XfOrM852_COUNT)
#   define SETUP_XfOrM854(x) SETUP_XfOrM852(x)

# 4483 "bc/src/fun.c"
    ((Scheme_Cont * ) for_cc ) -> escape_cont = (Scheme_Object * ) cont ; 
    ((Scheme_Cont * ) for_cc ) -> orig_escape_cont = 1 ; 
    a [0 ] = (Scheme_Object * ) for_cc ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
    v = FUNCCALL(SETUP_XfOrM854(_), scheme_do_eval (argv [0 ] , 1 , a , - 1 ) ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
  }

# 4489 "bc/src/fun.c"
  else {
#   define XfOrM853_COUNT (0+XfOrM852_COUNT)
#   define SETUP_XfOrM853(x) SETUP_XfOrM852(x)

# 4490 "bc/src/fun.c"
    a [0 ] = (Scheme_Object * ) cont ; 
    v = FUNCCALL(SETUP_XfOrM853(_), scheme_do_eval (argv [0 ] , 1 , a , - 1 ) ); 
  }

  p1 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p1 -> error_buf = cont -> saveerr ; 
  if (! for_cc )
    FUNCCALL(SETUP_XfOrM852(_), scheme_pop_continuation_frame (& cframe ) ); 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4503 "bc/src/fun.c"
Scheme_Object * 
scheme_call_ec (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM859_COUNT (1)
# define SETUP_XfOrM859(x) SETUP(XfOrM859_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM859(_), scheme_check_proc_arity ("call-with-escape-continuation" , 1 , 0 , argc , argv ) )
# 4507 "bc/src/fun.c"
  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_call_ec (argc , argv , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4512 "bc/src/fun.c"
int scheme_escape_continuation_ok (Scheme_Object * ec ) 
{
  /* No conversion */

# 4514 "bc/src/fun.c"
  Scheme_Escaping_Cont * cont = (Scheme_Escaping_Cont * ) ec ; 

  if (scheme_extract_one_cc_mark (((void * ) 0 ) , (Scheme_Object * ) cont ) )
    return 1 ; 
  else 
  return 0 ; 
}

static Scheme_Object * make_continuation_mark_key (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1)));
# define XfOrM861_COUNT (2)
# define SETUP_XfOrM861(x) SETUP(XfOrM861_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 4526 "bc/src/fun.c"
  if (argc && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-continuation-mark-key" , "symbol?" , 0 , argc , argv ) ); 

  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM861(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_continuation_mark_key_type ; 
  (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) = (argc ? argv [0 ] : ((void * ) 0 ) ) ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4536 "bc/src/fun.c"
static Scheme_Object * continuation_mark_key_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4538 "bc/src/fun.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

Scheme_Object * scheme_chaperone_do_continuation_mark (const char * name , int is_get , Scheme_Object * key , Scheme_Object * val ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * proc ; 
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(val, 1), PUSH(proc, 2), PUSH(key, 3), PUSH(px, 4), PUSHARRAY(a, 1, 5)));
# define XfOrM863_COUNT (8)
# define SETUP_XfOrM863(x) SETUP(XfOrM863_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 4549 "bc/src/fun.c"
  while (1 ) {
#   define XfOrM868_COUNT (0+XfOrM863_COUNT)
#   define SETUP_XfOrM868(x) SETUP_XfOrM863(x)

# 4550 "bc/src/fun.c"
    if ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) )  {
      RET_VALUE_START (val ) RET_VALUE_END ; 
    }

# 4552 "bc/src/fun.c"
    else {
#     define XfOrM869_COUNT (0+XfOrM868_COUNT)
#     define SETUP_XfOrM869(x) SETUP_XfOrM868(x)

# 4553 "bc/src/fun.c"
      px = (Scheme_Chaperone * ) key ; 
      key = px -> prev ; 

      if (is_get )
        proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . car ) ; 
      else 
      proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ; 

      a [0 ] = val ; 
      val = FUNCCALL(SETUP_XfOrM869(_), scheme_do_eval (proc , 1 , a , 1 ) ); 

      if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ) {
#       define XfOrM870_COUNT (0+XfOrM869_COUNT)
#       define SETUP_XfOrM870(x) SETUP_XfOrM869(x)

# 4565 "bc/src/fun.c"
        if (! FUNCCALL(SETUP_XfOrM870(_), scheme_chaperone_of (val , a [0 ] ) ))
          FUNCCALL(SETUP_XfOrM870(_), scheme_wrong_chaperoned (name , "value" , a [0 ] , val ) ); 
      }
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4572 "bc/src/fun.c"
Scheme_Object * do_chaperone_continuation_mark_key (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(px, 3), PUSH(props, 4), PUSH(redirects, 5)));
# define XfOrM872_COUNT (6)
# define SETUP_XfOrM872(x) SETUP(XfOrM872_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 4579 "bc/src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "continuation-mark-key?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM872(_), scheme_check_proc_arity (name , 1 , 1 , argc , argv ) )
  ; 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 1 , 2 , argc , argv ) ); 

  redirects = FUNCCALL_AGAIN(scheme_make_pair (argv [1 ] , argv [2 ] ) ); 

  props = FUNCCALL_AGAIN(scheme_parse_chaperone_props (name , 3 , argc , argv ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM872(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4605 "bc/src/fun.c"
static Scheme_Object * chaperone_continuation_mark_key (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4607 "bc/src/fun.c"
  return do_chaperone_continuation_mark_key ("chaperone-continuation-mark-key" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_continuation_mark_key (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4612 "bc/src/fun.c"
  return do_chaperone_continuation_mark_key ("impersonate-continuation-mark-key" , 1 , argc , argv ) ; 
}

Scheme_Object * scheme_get_immediate_cc_mark (Scheme_Object * key , Scheme_Object * def_val ) 
{
  /* No conversion */

# 4617 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  intptr_t findpos , bottom ; 

  if (p -> cont_mark_stack_segments ) {
    findpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
    bottom = (intptr_t ) p -> cont_mark_stack_bottom ; 
    while (findpos -- > bottom ) {
      Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
      intptr_t pos = findpos & ((1 << 6 ) - 1 ) ; 
      Scheme_Cont_Mark * find = seg + pos ; 

      if ((intptr_t ) find -> pos < (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) {
        break ; 
      }

# 4630 "bc/src/fun.c"
      else {
        if (find -> key == key )
          return find -> val ; 
      }
    }
  }

  return def_val ; 
}

Scheme_Object * scheme_chaperone_get_immediate_cc_mark (Scheme_Object * key , Scheme_Object * def_val ) 
{
  /* No conversion */

# 4642 "bc/src/fun.c"
  Scheme_Object * val ; 

  if ((((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) {
    val = scheme_get_immediate_cc_mark ((((Scheme_Chaperone * ) key ) -> val ) , ((void * ) 0 ) ) ; 
    if (val )
      return scheme_chaperone_do_continuation_mark ("call-with-immediate-continuation-mark" , 
    1 , key , val ) ; 
    else 
    return def_val ; 
  }

# 4652 "bc/src/fun.c"
  else 
  return scheme_get_immediate_cc_mark (key , def_val ) ; 
}

static Scheme_Object * call_with_immediate_cc_mark (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [1 ] , * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(argv, 1), PUSHARRAY(a, 1, 2)));
# define XfOrM885_COUNT (5)
# define SETUP_XfOrM885(x) SETUP(XfOrM885_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  val = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM885(_), scheme_check_proc_arity ("call-with-immediate-continuation-mark" , 1 , 1 , argc , argv ) )
# 4660 "bc/src/fun.c"
  ; 

  val = FUNCCALL_AGAIN(scheme_chaperone_get_immediate_cc_mark (argv [0 ] , ((argc > 2 ) ? argv [2 ] : scheme_false ) ) ); 
  a [0 ] = val ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM885(_), scheme_tail_apply (argv [1 ] , 1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4668 "bc/src/fun.c"
static Scheme_Object * 
do_call_with_sema (const char * who , int enable_break , int argc , Scheme_Object * argv [] ) 
{
  mz_jmp_buf newbuf , * volatile savebuf ; 
  Scheme_Prompt * volatile prompt ; 
  int i , just_try ; 
  int volatile extra ; 
  Scheme_Object * volatile sema ; 
  Scheme_Object * v , * quick_args [4 ] , * * extra_args ; 
  Scheme_Cont_Frame_Data cframe ; 
  int old_pcc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(sema, 0), PUSH(prompt, 1), PUSH(extra_args, 2), PUSH(savebuf, 3), PUSH(who, 4), PUSH(argv, 5), PUSH(cframe.cache, 6), PUSH(v, 7), PUSHARRAY(quick_args, 4, 8)));
# define XfOrM886_COUNT (11)
# define SETUP_XfOrM886(x) SETUP(XfOrM886_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  savebuf = NULLED_OUT ; 
  prompt = NULLED_OUT ; 
  sema = NULLED_OUT ; 
  v = NULLED_OUT ; 
  NULL_OUT_ARRAY (quick_args ) ; 
  extra_args = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 4680 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) ) {
#   define XfOrM898_COUNT (0+XfOrM886_COUNT)
#   define SETUP_XfOrM898(x) SETUP_XfOrM886(x)
    FUNCCALL(SETUP_XfOrM898(_), scheme_wrong_contract (who , "semaphore?" , 0 , argc , argv ) )
# 4681 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (argc > 2 )
    extra = argc - 3 ; 
  else 
  extra = 0 ; 
  if (! FUNCCALL(SETUP_XfOrM886(_), scheme_check_proc_arity (((void * ) 0 ) , extra , 1 , argc , argv ) )) {
#   define XfOrM897_COUNT (0+XfOrM886_COUNT)
#   define SETUP_XfOrM897(x) SETUP_XfOrM886(x)

# 4689 "bc/src/fun.c"
    if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL(SETUP_XfOrM897(_), scheme_wrong_contract (who , "procedure?" , 1 , argc , argv ) ); 
    else FUNCCALL(SETUP_XfOrM897(_), scheme_contract_error (who , "procedure arity does not match extra-argument count" , "procedure" , 1 , argv [1 ] , "extra-argument count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (extra ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )



    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if ((argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) {
#   define XfOrM895_COUNT (0+XfOrM886_COUNT)
#   define SETUP_XfOrM895(x) SETUP_XfOrM886(x)

# 4699 "bc/src/fun.c"
    if (! FUNCCALL(SETUP_XfOrM895(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 2 , argc , argv ) )) {
#     define XfOrM896_COUNT (0+XfOrM895_COUNT)
#     define SETUP_XfOrM896(x) SETUP_XfOrM895(x)
      FUNCCALL(SETUP_XfOrM896(_), scheme_wrong_contract (who , "(or/c (-> any) #f)" , 1 , argc , argv ) )
# 4700 "bc/src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    just_try = 1 ; 
  }

# 4704 "bc/src/fun.c"
  else 
  just_try = 0 ; 

  sema = argv [0 ] ; 

  if (just_try && enable_break && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> external_break ) {

    Scheme_Cont_Frame_Data bcframe ; 
    BLOCK_SETUP((PUSH(bcframe.cache, 0+XfOrM886_COUNT)));
#   define XfOrM894_COUNT (1+XfOrM886_COUNT)
#   define SETUP_XfOrM894(x) SETUP(XfOrM894_COUNT)
    bcframe.cache = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM894(_), scheme_push_break_enable (& bcframe , 1 , 1 ) )
# 4712 "bc/src/fun.c"
    ; 
    FUNCCALL_AGAIN(scheme_check_break_now () ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& bcframe , 0 ) ); 
  }

  if (! FUNCCALL(SETUP_XfOrM886(_), scheme_wait_sema (sema , just_try ? 1 : (enable_break ? - 1 : 0 ) ) )) {
#   define XfOrM893_COUNT (0+XfOrM886_COUNT)
#   define SETUP_XfOrM893(x) SETUP_XfOrM886(x)

# 4718 "bc/src/fun.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM893(_), scheme_tail_apply (argv [2 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_END ; 
  }

  savebuf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) ) {
    prompt = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) = ((void * ) 0 ) ; 
  }

# 4727 "bc/src/fun.c"
  else {
#   define XfOrM891_COUNT (0+XfOrM886_COUNT)
#   define SETUP_XfOrM891(x) SETUP_XfOrM886(x)

# 4728 "bc/src/fun.c"
    prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM891(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    prompt -> so . type = scheme_prompt_type ; 
  }
  FUNCCALL(SETUP_XfOrM886(_), scheme_push_continuation_frame (& cframe ) )
  ; 
  FUNCCALL(SETUP_XfOrM886(_), scheme_set_cont_mark (barrier_prompt_key , (Scheme_Object * ) prompt ) ); 

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM886_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    v = ((void * ) 0 ) ; 
  }

# 4737 "bc/src/fun.c"
  else {
#   define XfOrM887_COUNT (0+XfOrM886_COUNT)
#   define SETUP_XfOrM887(x) SETUP_XfOrM886(x)

# 4738 "bc/src/fun.c"
    if (extra > 4 )
      extra_args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM887(_), GC_malloc (sizeof (Scheme_Object * ) * (extra ) ) )) ; 
    else 
    extra_args = quick_args ; 
    for (i = 3 ; i < argc ; i ++ ) {
      extra_args [i - 3 ] = argv [i ] ; 
    }

    v = FUNCCALL(SETUP_XfOrM887(_), scheme_do_eval (argv [1 ] , extra , extra_args , - 1 ) ); 
  }
  FUNCCALL(SETUP_XfOrM886(_), scheme_pop_continuation_frame (& cframe ) )
  ; 
  FUNCCALL(SETUP_XfOrM886(_), scheme_post_sema (sema ) )
  ; 

  if (old_pcc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) = prompt ; 

  if (! v )
    (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = savebuf ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4764 "bc/src/fun.c"
static Scheme_Object * 
call_with_sema (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4767 "bc/src/fun.c"
  return do_call_with_sema ("call-with-semaphore" , 0 , argc , argv ) ; 
}

static Scheme_Object * 
call_with_sema_enable_break (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4773 "bc/src/fun.c"
  return do_call_with_sema ("call-with-semaphore/enable-break" , 1 , argc , argv ) ; 
}

static Scheme_Saved_Stack * copy_out_runstack (Scheme_Thread * p , 
Scheme_Object * * runstack , 
Scheme_Object * * runstack_start , 
Scheme_Cont * share_from , 
Scheme_Prompt * effective_prompt ) 
{
  Scheme_Saved_Stack * saved , * isaved , * csaved , * share_saved , * share_csaved , * ss ; 
  Scheme_Object * * start ; 
  intptr_t size ; 
  int done ; 
  DECL_RET_SAVE (Scheme_Saved_Stack * ) PREPARE_VAR_STACK_ONCE(12);
  BLOCK_SETUP_TOP((PUSH(share_saved, 0), PUSH(share_from, 1), PUSH(runstack_start, 2), PUSH(share_csaved, 3), PUSH(isaved, 4), PUSH(ss, 5), PUSH(effective_prompt, 6), PUSH(saved, 7), PUSH(start, 8), PUSH(p, 9), PUSH(csaved, 10), PUSH(runstack, 11)));
# define XfOrM901_COUNT (12)
# define SETUP_XfOrM901(x) SETUP(XfOrM901_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  saved = NULLED_OUT ; 
  isaved = NULLED_OUT ; 
  csaved = NULLED_OUT ; 
  share_saved = NULLED_OUT ; 
  share_csaved = NULLED_OUT ; 
  ss = NULLED_OUT ; 
  start = NULLED_OUT ; 

# 4788 "bc/src/fun.c"
  saved = ((Scheme_Saved_Stack * ) FUNCCALL(SETUP_XfOrM901(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Saved_Stack ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  saved -> type = scheme_rt_saved_stack ; 

  if (share_from && (share_from -> runstack_start == runstack_start ) ) {
    intptr_t shared_amt ; 

    size = (share_from -> ss . runstack_offset - (runstack XFORM_OK_MINUS runstack_start ) ) ; 

    shared_amt = (p -> runstack_size - share_from -> ss . runstack_offset ) ; 
    if (shared_amt > 2 )
      size += 2 ; 
    else 
    size += shared_amt ; 
  }

# 4802 "bc/src/fun.c"
  else if (effective_prompt && ((scheme_prompt_runstack_boundary_start (effective_prompt ) ) == runstack_start ) ) {

    size = effective_prompt -> runstack_boundary_offset - (runstack XFORM_OK_MINUS runstack_start ) ; 
  }

# 4805 "bc/src/fun.c"
  else {
    size = p -> runstack_size - (runstack XFORM_OK_MINUS runstack_start ) ; 
  }

  ((void ) sizeof ((size <= p -> runstack_size ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM913_COUNT (0+XfOrM901_COUNT)
#   define SETUP_XfOrM913(x) SETUP_XfOrM901(x)

# 4809 "bc/src/fun.c" 3
    if (size <= p -> runstack_size )

# 4809 "bc/src/fun.c" 3
    ; 

# 4809 "bc/src/fun.c" 3
    else FUNCCALL(SETUP_XfOrM913(_), __assert_fail ("size <= p->runstack_size" , "bc/src/fun.c" , 4809 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 4809 "bc/src/fun.c"
  ; 

  saved -> runstack_size = size ; 
  start = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM901(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 
  saved -> runstack_start = start ; 
  (memcpy (saved -> runstack_start , runstack , size * sizeof (Scheme_Object * ) ) ) ; 
  saved -> runstack_offset = (runstack XFORM_OK_MINUS runstack_start ) ; 

  if (! effective_prompt || ((scheme_prompt_runstack_boundary_start (effective_prompt ) ) != runstack_start ) ) {
#   define XfOrM902_COUNT (0+XfOrM901_COUNT)
#   define SETUP_XfOrM902(x) SETUP_XfOrM901(x)
    if (share_from ) {

      share_csaved = share_from -> runstack_saved ; 
      share_saved = share_from -> runstack_copied -> prev ; 
    }

# 4824 "bc/src/fun.c"
    else {
      share_saved = ((void * ) 0 ) ; 
      share_csaved = ((void * ) 0 ) ; 
    }
    isaved = saved ; 
    for (csaved = p -> runstack_saved ; csaved ; csaved = csaved -> prev ) {
#     define XfOrM907_COUNT (0+XfOrM902_COUNT)
#     define SETUP_XfOrM907(x) SETUP_XfOrM902(x)

# 4830 "bc/src/fun.c"
      if (share_csaved && (csaved -> runstack_start == share_csaved -> runstack_start ) ) {

        isaved -> prev = share_saved ; 
        break ; 
      }

      ss = ((Scheme_Saved_Stack * ) FUNCCALL(SETUP_XfOrM907(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Saved_Stack ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

      ss -> type = scheme_rt_saved_stack ; 

      isaved -> prev = ss ; 
      isaved = ss ; 

      if (effective_prompt && ((scheme_prompt_runstack_boundary_start (effective_prompt ) ) == csaved -> runstack_start ) ) {
        size = effective_prompt -> runstack_boundary_offset - csaved -> runstack_offset ; 
        done = 1 ; 
      }

# 4846 "bc/src/fun.c"
      else {
        size = csaved -> runstack_size - csaved -> runstack_offset ; 
        done = 0 ; 
      }

      isaved -> runstack_size = size ; 

      start = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM907(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 
      isaved -> runstack_start = start ; 
      (memcpy (isaved -> runstack_start , 
      csaved -> runstack_start XFORM_OK_PLUS csaved -> runstack_offset , 
      size * sizeof (Scheme_Object * ) ) ) ; 
      isaved -> runstack_offset = csaved -> runstack_offset ; 

      if (done )

# 4860 "bc/src/fun.c"
      break ; 
    }
  }

  RET_VALUE_START (saved ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4867 "bc/src/fun.c"
static Scheme_Cont_Mark * copy_out_mark_stack (Scheme_Thread * p , 
intptr_t pos , 
Scheme_Cont * sub_cont , 
intptr_t * _offset , 
Scheme_Prompt * effective_prompt , 
int clear_caches ) 
{
  intptr_t cmcount , offset = 0 , sub_count = 0 ; 
  Scheme_Cont_Mark * cont_mark_stack_copied ; 
  DECL_RET_SAVE (Scheme_Cont_Mark * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cont_mark_stack_copied, 0), PUSH(p, 1)));
# define XfOrM917_COUNT (2)
# define SETUP_XfOrM917(x) SETUP(XfOrM917_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cont_mark_stack_copied = NULLED_OUT ; 

# 4878 "bc/src/fun.c"
  cmcount = (intptr_t ) pos ; 
  offset = 0 ; 

  if (sub_cont ) {

    sub_count = sub_cont -> cont_mark_total - sub_cont -> cont_mark_nonshare ; 
    if (sub_count < 0 )
      sub_count = 0 ; 
  }

# 4886 "bc/src/fun.c"
  else if (effective_prompt ) {

    sub_count = effective_prompt -> mark_boundary ; 
  }
  cmcount -= sub_count ; 
  offset += sub_count ; 

  if (_offset )

# 4893 "bc/src/fun.c"
  * _offset = offset ; 

  if (cmcount ) {
#   define XfOrM918_COUNT (0+XfOrM917_COUNT)
#   define SETUP_XfOrM918(x) SETUP_XfOrM917(x)

# 4896 "bc/src/fun.c"
    cont_mark_stack_copied = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM918(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (cmcount ) ) )) ; 
    while (cmcount -- ) {
      int cms = cmcount + offset ; 
      Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [cms >> 6 ] ; 
      intptr_t pos = cms & ((1 << 6 ) - 1 ) ; 
      Scheme_Cont_Mark * cm = seg + pos ; 
#     define XfOrM920_COUNT (0+XfOrM918_COUNT)
#     define SETUP_XfOrM920(x) SETUP_XfOrM918(x)
      (
# 4903 "bc/src/fun.c"
      memcpy (cont_mark_stack_copied + cmcount , cm , sizeof (Scheme_Cont_Mark ) ) ) ; 
      if (clear_caches )
        cont_mark_stack_copied [cmcount ] . cache = ((void * ) 0 ) ; 
    }

    RET_VALUE_START (cont_mark_stack_copied ) RET_VALUE_END ; 
  }

# 4909 "bc/src/fun.c"
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4913 "bc/src/fun.c"
static void copy_in_runstack (Scheme_Thread * p , Scheme_Saved_Stack * isaved , int set_runstack ) 
{
  /* No conversion */

# 4915 "bc/src/fun.c"
  Scheme_Saved_Stack * csaved ; 
  intptr_t size ; 

  size = isaved -> runstack_size ; 
  if (set_runstack ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + (p -> runstack_size - size ) ; 
  }
  memcpy (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) , isaved -> runstack_start , size * sizeof (Scheme_Object * ) ) ; 
  for (csaved = p -> runstack_saved ; csaved ; csaved = csaved -> prev ) {
    isaved = isaved -> prev ; 
    if (! isaved ) {


      break ; 
    }
    size = isaved -> runstack_size ; 
    csaved -> runstack_offset = isaved -> runstack_offset ; 
    memcpy (csaved -> runstack_start XFORM_OK_PLUS csaved -> runstack_offset , 
    isaved -> runstack_start , 
    size * sizeof (Scheme_Object * ) ) ; 
  }
}

static void copy_in_mark_stack (Scheme_Thread * p , Scheme_Cont_Mark * cont_mark_stack_copied , 
intptr_t cms , intptr_t base_cms , 
intptr_t copied_offset , Scheme_Object * * _sub_conts , 
int clear_caches , 
intptr_t new_mark_pos ) 




{
  intptr_t cmcount , base_cmcount , cmoffset ; 
  Scheme_Cont_Mark * cm_src ; 
  Scheme_Cont * sub_cont = ((void * ) 0 ) ; 
  PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(cm_src, 0), PUSH(_sub_conts, 1), PUSH(cont_mark_stack_copied, 2), PUSH(p, 3), PUSH(sub_cont, 4)));
# define XfOrM929_COUNT (5)
# define SETUP_XfOrM929(x) SETUP(XfOrM929_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cm_src = NULLED_OUT ; 

# 4952 "bc/src/fun.c"
  cmcount = (intptr_t ) cms ; 
  base_cmcount = (intptr_t ) base_cms ; 

  if (cmcount ) {

    intptr_t needed = ((cmcount - 1 ) >> 6 ) + 1 ; 
#   define XfOrM952_COUNT (0+XfOrM929_COUNT)
#   define SETUP_XfOrM952(x) SETUP_XfOrM929(x)

# 4959 "bc/src/fun.c"
    if (needed > p -> cont_mark_seg_count ) {
      Scheme_Cont_Mark * * segs , * * old_segs = p -> cont_mark_stack_segments ; 
      int newcount = needed , oldcount = p -> cont_mark_seg_count , npos ; 
      BLOCK_SETUP((PUSH(old_segs, 0+XfOrM952_COUNT), PUSH(segs, 1+XfOrM952_COUNT)));
#     define XfOrM953_COUNT (2+XfOrM952_COUNT)
#     define SETUP_XfOrM953(x) SETUP(XfOrM953_COUNT)
      segs = NULLED_OUT ; 

# 4965 "bc/src/fun.c"
      segs = ((Scheme_Cont_Mark * * ) FUNCCALL(SETUP_XfOrM953(_), GC_malloc (sizeof (Scheme_Cont_Mark * ) * (needed ) ) )) ; 

      for (npos = needed ; npos -- ; ) {
#       define XfOrM956_COUNT (0+XfOrM953_COUNT)
#       define SETUP_XfOrM956(x) SETUP_XfOrM953(x)

# 4968 "bc/src/fun.c"
        if (npos < oldcount )
          segs [npos ] = old_segs [npos ] ; 
        else 
        segs [npos ] = ((void * ) 0 ) ; 

        if (! segs [npos ] ) {
          Scheme_Cont_Mark * cm ; 
          BLOCK_SETUP((PUSH(cm, 0+XfOrM956_COUNT)));
#         define XfOrM957_COUNT (1+XfOrM956_COUNT)
#         define SETUP_XfOrM957(x) SETUP(XfOrM957_COUNT)
          cm = NULLED_OUT ; 

# 4975 "bc/src/fun.c"
          cm = FUNCCALL(SETUP_XfOrM957(_), GC_malloc_allow_interior (sizeof (Scheme_Cont_Mark ) * (1 << 6 ) ) ); 
          segs [npos ] = cm ; 
        }
      }

      p -> cont_mark_seg_count = newcount ; 
      p -> cont_mark_stack_segments = segs ; 
    }
  }


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = new_mark_pos ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = cms ; 

  if (_sub_conts ) {
    if (* _sub_conts ) {
      sub_cont = (Scheme_Cont * ) (((Scheme_Simple_Object * ) (* _sub_conts ) ) -> u . pair_val . car ) ; 
    }
  }

  while (base_cmcount < cmcount ) {
    Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [base_cmcount >> 6 ] ; 
    intptr_t pos = base_cmcount & ((1 << 6 ) - 1 ) ; 
    GC_CAN_IGNORE Scheme_Cont_Mark * cm = seg + pos ; 
#   define XfOrM940_COUNT (0+XfOrM929_COUNT)
#   define SETUP_XfOrM940(x) SETUP_XfOrM929(x)

# 5000 "bc/src/fun.c"
    cm_src = cont_mark_stack_copied ; 
    cmoffset = base_cmcount - copied_offset ; 

    if (sub_cont ) {
      while (base_cmcount >= (sub_cont -> cont_mark_total - sub_cont -> cont_mark_nonshare ) ) {
        * _sub_conts = (((Scheme_Simple_Object * ) (* _sub_conts ) ) -> u . pair_val . cdr ) ; 
        if (* _sub_conts ) {
          sub_cont = (Scheme_Cont * ) (((Scheme_Simple_Object * ) (* _sub_conts ) ) -> u . pair_val . car ) ; 
        }

# 5008 "bc/src/fun.c"
        else {
          sub_cont = ((void * ) 0 ) ; 
          break ; 
        }
      }
      if (sub_cont ) {
        cm_src = sub_cont -> cont_mark_stack_copied ; 
        cmoffset = base_cmcount - sub_cont -> cont_mark_offset ; 
      }
    }
    (
    memcpy (cm , cm_src + cmoffset , sizeof (Scheme_Cont_Mark ) ) ) ; 
    if (clear_caches ) {
      cm -> cache = ((void * ) 0 ) ; 
    }

    base_cmcount ++ ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5028 "bc/src/fun.c"
static intptr_t find_shareable_marks () 
{
  /* No conversion */

# 5030 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  intptr_t cmcount , delta = 0 ; 

  cmcount = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 

  while (cmcount -- ) {
    Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [cmcount >> 6 ] ; 
    intptr_t pos = cmcount & ((1 << 6 ) - 1 ) ; 

    if (seg [pos ] . pos < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) )
      break ; 




    if ((seg [pos ] . key ) == (cont_key ) ) 
      delta ++ ; 
    else if ((seg [pos ] . key ) == (scheme_stack_dump_key ) ) 
      delta ++ ; 
    else 
    delta = 0 ; 
  }

  return cmcount + 1 + delta ; 
}

static Scheme_Overflow * clone_overflows (Scheme_Overflow * overflow , void * limit , Scheme_Overflow * tail ) 
{
  Scheme_Overflow * naya , * first = ((void * ) 0 ) , * prev = ((void * ) 0 ) ; 
  int stop = 0 ; 
  DECL_RET_SAVE (Scheme_Overflow * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(limit, 0), PUSH(prev, 1), PUSH(tail, 2), PUSH(first, 3), PUSH(naya, 4), PUSH(overflow, 5)));
# define XfOrM961_COUNT (6)
# define SETUP_XfOrM961(x) SETUP(XfOrM961_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 5061 "bc/src/fun.c"
  for (; overflow && ! stop ; overflow = overflow -> prev ) {
#   define XfOrM964_COUNT (0+XfOrM961_COUNT)
#   define SETUP_XfOrM964(x) SETUP_XfOrM961(x)

# 5062 "bc/src/fun.c"
    naya = ((Scheme_Overflow * ) FUNCCALL(SETUP_XfOrM964(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    (memcpy (naya , overflow , sizeof (Scheme_Overflow ) ) ) ; 
    if (prev )
      prev -> prev = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
    if (limit && overflow -> id == limit )
      stop = 1 ; 
  }

  if (first ) {
    prev -> prev = tail ; 
    RET_VALUE_START (first ) RET_VALUE_END ; 
  }

# 5076 "bc/src/fun.c"
  else 
  RET_VALUE_START (tail ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5080 "bc/src/fun.c"
static Scheme_Dynamic_Wind * clone_dyn_wind (Scheme_Dynamic_Wind * dw , 
Scheme_Object * limit_prompt_tag , int limit_depth , int limit_count , 
Scheme_Dynamic_Wind * tail , 
int keep_tail , int composable ) 
{
  Scheme_Dynamic_Wind * naya , * first = ((void * ) 0 ) , * prev = ((void * ) 0 ) ; 
  int cnt = 0 ; 
  DECL_RET_SAVE (Scheme_Dynamic_Wind * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(prev, 0), PUSH(limit_prompt_tag, 1), PUSH(tail, 2), PUSH(first, 3), PUSH(dw, 4), PUSH(naya, 5)));
# define XfOrM965_COUNT (6)
# define SETUP_XfOrM965(x) SETUP(XfOrM965_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 5088 "bc/src/fun.c"
  for (; dw ; dw = dw -> prev ) {
#   define XfOrM971_COUNT (0+XfOrM965_COUNT)
#   define SETUP_XfOrM971(x) SETUP_XfOrM965(x)

# 5089 "bc/src/fun.c"
    if (dw -> depth == limit_depth )
      break ; 
    if (composable && limit_prompt_tag && (dw -> prompt_tag == limit_prompt_tag ) )
      break ; 
    if (cnt == limit_count )
      break ; 
    FUNCCALL(SETUP_XfOrM971(_), scheme_ensure_dw_id (dw ) ); 
    naya = ((Scheme_Dynamic_Wind * ) FUNCCALL(SETUP_XfOrM971(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Dynamic_Wind ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    (memcpy (naya , dw , sizeof (Scheme_Dynamic_Wind ) ) ) ; 
    if (prev )
      prev -> prev = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
    cnt ++ ; 
    if (limit_prompt_tag && (dw -> prompt_tag == limit_prompt_tag ) ) {
      dw = dw -> prev ; 
      break ; 
    }
  }
  if (keep_tail )
    tail = dw ; 
  if (first ) {
    prev -> prev = tail ; 
    if (tail )
      cnt += tail -> depth + 1 ; 
    for (dw = first ; dw != tail ; dw = dw -> prev ) {
      dw -> depth = -- cnt ; 
    }
    RET_VALUE_START (first ) RET_VALUE_END ; 
  }

# 5119 "bc/src/fun.c"
  else 
  RET_VALUE_START (tail ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5123 "bc/src/fun.c"
static void clear_cm_copy_caches (Scheme_Cont_Mark * cp , int cnt ) 
{
  /* No conversion */

# 5125 "bc/src/fun.c"
  int i ; 
  for (i = 0 ; i < cnt ; i ++ ) {
    cp [i ] . cache = ((void * ) 0 ) ; 
  }
}

static Scheme_Saved_Stack * clone_runstack_saved (Scheme_Saved_Stack * saved , Scheme_Object * * boundary_start , 
Scheme_Saved_Stack * last ) 
{
  Scheme_Saved_Stack * naya , * first = last , * prev = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Saved_Stack * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(prev, 0), PUSH(last, 1), PUSH(saved, 2), PUSH(first, 3), PUSH(naya, 4), PUSH(boundary_start, 5)));
# define XfOrM976_COUNT (6)
# define SETUP_XfOrM976(x) SETUP(XfOrM976_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 5136 "bc/src/fun.c"
  while (saved ) {
#   define XfOrM978_COUNT (0+XfOrM976_COUNT)
#   define SETUP_XfOrM978(x) SETUP_XfOrM976(x)

# 5137 "bc/src/fun.c"
    naya = ((Scheme_Saved_Stack * ) FUNCCALL(SETUP_XfOrM978(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Saved_Stack ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    (memcpy (naya , saved , sizeof (Scheme_Saved_Stack ) ) ) ; 
    if (prev )
      prev -> prev = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
    if (saved -> runstack_start == boundary_start )
      break ; 
    saved = saved -> prev ; 
  }
  if (prev )
    prev -> prev = last ; 

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5154 "bc/src/fun.c"
static Scheme_Saved_Stack * clone_runstack_copied (Scheme_Saved_Stack * copied , 
Scheme_Object * * copied_start , 
Scheme_Saved_Stack * saved , 
Scheme_Object * * boundary_start , 
intptr_t boundary_offset ) 
{
  Scheme_Saved_Stack * naya , * first = ((void * ) 0 ) , * prev = ((void * ) 0 ) , * s ; 
  DECL_RET_SAVE (Scheme_Saved_Stack * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(prev, 0), PUSH(naya, 1), PUSH(boundary_start, 2), PUSH(s, 3), PUSH(first, 4), PUSH(saved, 5), PUSH(copied_start, 6), PUSH(copied, 7)));
# define XfOrM979_COUNT (8)
# define SETUP_XfOrM979(x) SETUP(XfOrM979_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  naya = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 5162 "bc/src/fun.c"
  if (copied_start == boundary_start ) {
    naya = copied ; 
  }

# 5164 "bc/src/fun.c"
  else {
    for (naya = copied -> prev , s = saved ; 
    s -> runstack_start != boundary_start ; 
    naya = naya -> prev , s = s -> prev ) {
    }
  }
  if ((naya -> runstack_offset + naya -> runstack_size == boundary_offset ) 
  && ! naya -> prev ) {

    RET_VALUE_START (copied ) RET_VALUE_END ; 
  }

  s = ((void * ) 0 ) ; 
  while (copied ) {
#   define XfOrM982_COUNT (0+XfOrM979_COUNT)
#   define SETUP_XfOrM982(x) SETUP_XfOrM979(x)

# 5178 "bc/src/fun.c"
    naya = ((Scheme_Saved_Stack * ) FUNCCALL(SETUP_XfOrM982(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Saved_Stack ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    (memcpy (naya , copied , sizeof (Scheme_Saved_Stack ) ) ) ; 
    naya -> prev = ((void * ) 0 ) ; 
    if (prev )
      prev -> prev = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
    if ((! s && copied_start == boundary_start ) 
    || (s && (s -> runstack_start == boundary_start ) ) ) {
      intptr_t size ; 
      Scheme_Object * * a ; 
      BLOCK_SETUP((PUSH(a, 0+XfOrM982_COUNT)));
#     define XfOrM983_COUNT (1+XfOrM982_COUNT)
#     define SETUP_XfOrM983(x) SETUP(XfOrM983_COUNT)
      a = NULLED_OUT ; 

# 5190 "bc/src/fun.c"
      size = boundary_offset - naya -> runstack_offset ; 
      if (size < 0 )
        FUNCCALL_EMPTY(scheme_signal_error ("negative stack-copy size while pruning" ) ); 
      if (size > naya -> runstack_size )
        FUNCCALL_EMPTY(scheme_signal_error ("bigger stack-copy size while pruning: %d vs. %d" , size , naya -> runstack_size ) ); 
      a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM983(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 
      (memcpy (a , naya -> runstack_start , size * sizeof (Scheme_Object * ) ) ) ; 
      naya -> runstack_start = a ; 
      naya -> runstack_size = size ; 
      break ; 
    }

    copied = copied -> prev ; 
    if (! s )
      s = saved ; 
    else 
    s = s -> prev ; 
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5212 "bc/src/fun.c"
static Scheme_Meta_Continuation * clone_meta_cont (Scheme_Meta_Continuation * mc , 
Scheme_Object * limit_tag , int limit_depth , 
Scheme_Meta_Continuation * prompt_cont , 
Scheme_Prompt * prompt , 
Scheme_Meta_Continuation * tail , 
int for_composable ) 
{
  Scheme_Meta_Continuation * naya , * first = ((void * ) 0 ) , * prev = ((void * ) 0 ) ; 
  int cnt = 0 , depth ; 

# 1055 "bc/src/fun.c"
  Scheme_Object * * __funcarg205 = NULLED_OUT ; 

# 1055 "bc/src/fun.c"
  Scheme_Object * * __funcarg204 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Meta_Continuation * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(prev, 0), PUSH(prompt, 1), PUSH(prompt_cont, 2), PUSH(naya, 3), PUSH(mc, 4), PUSH(first, 5), PUSH(tail, 6), PUSH(limit_tag, 7)));
# define XfOrM989_COUNT (8)
# define SETUP_XfOrM989(x) SETUP(XfOrM989_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  naya = NULLED_OUT ; 

# 5222 "bc/src/fun.c"
  for (; mc ; mc = mc -> next ) {
#   define XfOrM1007_COUNT (0+XfOrM989_COUNT)
#   define SETUP_XfOrM1007(x) SETUP_XfOrM989(x)

# 5223 "bc/src/fun.c"
    if (! limit_depth -- )
      break ; 
    if (! mc -> pseudo && ((mc -> prompt_tag ) == (limit_tag ) ) )
      break ; 
    if (for_composable && mc -> pseudo && mc -> empty_to_next && mc -> next 
    && ((mc -> next -> prompt_tag ) == (limit_tag ) ) ) {



      break ; 
    }

    naya = ((Scheme_Meta_Continuation * ) FUNCCALL(SETUP_XfOrM1007(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Meta_Continuation ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    cnt ++ ; 
    (memcpy (naya , mc , sizeof (Scheme_Meta_Continuation ) ) ) ; 
    if ((mc ) == (prompt_cont ) )  {

      intptr_t delta ; 
      void * stack_boundary ; 
      BLOCK_SETUP((PUSH(stack_boundary, 0+XfOrM1007_COUNT)));
#     define XfOrM1011_COUNT (1+XfOrM1007_COUNT)
#     define SETUP_XfOrM1011(x) SETUP(XfOrM1011_COUNT)
      stack_boundary = NULLED_OUT ; 

# 5243 "bc/src/fun.c"
      delta = prompt -> mark_boundary - naya -> cont_mark_offset ; 
      if (delta ) {
#       define XfOrM1017_COUNT (0+XfOrM1011_COUNT)
#       define SETUP_XfOrM1017(x) SETUP_XfOrM1011(x)

# 5245 "bc/src/fun.c"
        naya -> cont_mark_total -= delta ; 
        naya -> cont_mark_offset += delta ; 
        if (naya -> cont_mark_total ) {
          Scheme_Cont_Mark * cp ; 
          BLOCK_SETUP((PUSH(cp, 0+XfOrM1017_COUNT)));
#         define XfOrM1018_COUNT (1+XfOrM1017_COUNT)
#         define SETUP_XfOrM1018(x) SETUP(XfOrM1018_COUNT)
          cp = NULLED_OUT ; 

# 5249 "bc/src/fun.c"
          cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM1018(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (naya -> cont_mark_total ) ) )) ; 
          (memcpy (cp , mc -> cont_mark_stack_copied + delta , naya -> cont_mark_total * sizeof (Scheme_Cont_Mark ) ) ) ; 
          if (mc -> cm_caches ) {
#           define XfOrM1019_COUNT (0+XfOrM1018_COUNT)
#           define SETUP_XfOrM1019(x) SETUP_XfOrM1018(x)
            FUNCCALL(SETUP_XfOrM1019(_), clear_cm_copy_caches (cp , naya -> cont_mark_total ) )
# 5252 "bc/src/fun.c"
            ; 
          }
          naya -> cont_mark_stack_copied = cp ; 
          naya -> cm_caches = 0 ; 
          naya -> cm_shared = 0 ; 
        }

# 5257 "bc/src/fun.c"
        else 
        naya -> cont_mark_stack_copied = ((void * ) 0 ) ; 
      }
      naya -> cont_mark_pos_bottom = prompt -> boundary_mark_pos ; 

      if ((prompt -> boundary_overflow_id && (prompt -> boundary_overflow_id == naya -> overflow -> id ) ) 
      || (! prompt -> boundary_overflow_id && ! naya -> overflow -> prev ) ) {
        stack_boundary = prompt -> stack_boundary ; 
      }

# 5265 "bc/src/fun.c"
      else {
        stack_boundary = naya -> overflow -> stack_start ; 
      }

      if (naya -> cont ) {
        Scheme_Cont * cnaya ; 
        Scheme_Saved_Stack * saved ; 
        BLOCK_SETUP((PUSH(saved, 0+XfOrM1011_COUNT), PUSH(cnaya, 1+XfOrM1011_COUNT)));
#       define XfOrM1014_COUNT (2+XfOrM1011_COUNT)
#       define SETUP_XfOrM1014(x) SETUP(XfOrM1014_COUNT)
        cnaya = NULLED_OUT ; 
        saved = NULLED_OUT ; 

# 5273 "bc/src/fun.c"
        cnaya = ((Scheme_Cont * ) FUNCCALL(SETUP_XfOrM1014(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        (memcpy (cnaya , naya -> cont , sizeof (Scheme_Cont ) ) ) ; 

        naya -> cont = cnaya ; 

        cnaya -> cont_mark_total = naya -> cont_mark_total ; 
        cnaya -> cont_mark_offset = naya -> cont_mark_offset ; 
        cnaya -> cont_mark_pos_bottom = naya -> cont_mark_pos_bottom ; 
        cnaya -> cont_mark_stack_copied = naya -> cont_mark_stack_copied ; 

        cnaya -> prompt_stack_start = stack_boundary ; 


        saved = (__funcarg205 = (


        scheme_prompt_runstack_boundary_start (prompt ) ) , FUNCCALL(SETUP_XfOrM1014(_), clone_runstack_copied (cnaya -> runstack_copied , cnaya -> runstack_start , cnaya -> runstack_saved , __funcarg205 , prompt -> runstack_boundary_offset ) )) 
        ; 
        cnaya -> runstack_copied = saved ; 


        if ((scheme_prompt_runstack_boundary_start (prompt ) ) == cnaya -> runstack_start )
          saved = ((void * ) 0 ) ; 
        else 
        saved = (__funcarg204 = (
        scheme_prompt_runstack_boundary_start (prompt ) ) , FUNCCALL(SETUP_XfOrM1014(_), clone_runstack_saved (cnaya -> runstack_saved , __funcarg204 , ((void * ) 0 ) ) )) 
        ; 
        cnaya -> runstack_saved = saved ; 

        cnaya -> need_meta_prompt = 1 ; 
      }
      if (naya -> overflow && ! naya -> overflow -> eot ) {

        Scheme_Overflow * onaya ; 
        Scheme_Overflow_Jmp * jmp ; 
        BLOCK_SETUP((PUSH(jmp, 0+XfOrM1011_COUNT), PUSH(onaya, 1+XfOrM1011_COUNT)));
#       define XfOrM1012_COUNT (2+XfOrM1011_COUNT)
#       define SETUP_XfOrM1012(x) SETUP(XfOrM1012_COUNT)
        onaya = NULLED_OUT ; 
        jmp = NULLED_OUT ; 

# 5308 "bc/src/fun.c"
        jmp = FUNCCALL(SETUP_XfOrM1012(_), scheme_prune_jmpup (naya -> overflow -> jmp , stack_boundary ) ); 
        if (jmp ) {
#         define XfOrM1013_COUNT (0+XfOrM1012_COUNT)
#         define SETUP_XfOrM1013(x) SETUP_XfOrM1012(x)

# 5310 "bc/src/fun.c"
          onaya = ((Scheme_Overflow * ) FUNCCALL(SETUP_XfOrM1013(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
          (memcpy (onaya , naya -> overflow , sizeof (Scheme_Overflow ) ) ) ; 
          naya -> overflow = onaya ; 
          onaya -> jmp = jmp ; 
          onaya -> stack_start = stack_boundary ; 
        }
      }
    }

# 5317 "bc/src/fun.c"
    else {
#     define XfOrM1008_COUNT (0+XfOrM1007_COUNT)
#     define SETUP_XfOrM1008(x) SETUP_XfOrM1007(x)

# 5318 "bc/src/fun.c"
      if (! mc -> cm_caches ) {
        mc -> cm_shared = 1 ; 
        naya -> cm_shared = 1 ; 
      }

# 5321 "bc/src/fun.c"
      else {
        Scheme_Cont_Mark * cp ; 
        BLOCK_SETUP((PUSH(cp, 0+XfOrM1008_COUNT)));
#       define XfOrM1009_COUNT (1+XfOrM1008_COUNT)
#       define SETUP_XfOrM1009(x) SETUP(XfOrM1009_COUNT)
        cp = NULLED_OUT ; 

# 5323 "bc/src/fun.c"
        cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM1009(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (naya -> cont_mark_total ) ) )) ; 
        if (naya -> cont_mark_total )
          (memcpy (cp , mc -> cont_mark_stack_copied , naya -> cont_mark_total * sizeof (Scheme_Cont_Mark ) ) ) ; 
        FUNCCALL(SETUP_XfOrM1009(_), clear_cm_copy_caches (cp , naya -> cont_mark_total ) ); 
        naya -> cont_mark_stack_copied = cp ; 
        naya -> cm_caches = 0 ; 
        naya -> cm_shared = 0 ; 
      }
    }
    if (prev )
      prev -> next = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
  }

  if (first ) {
    prev -> next = tail ; 
  }

# 5341 "bc/src/fun.c"
  else 
  first = tail ; 


  if (tail )
    depth = tail -> depth + 1 ; 
  else 
  depth = 0 ; 
  for (naya = first ; cnt -- ; naya = naya -> next ) {
    naya -> depth = depth + cnt ; 
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5356 "bc/src/fun.c"
static void sync_meta_cont (Scheme_Meta_Continuation * resume_mc ) 
{
  Scheme_Cont * cnaya ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(resume_mc, 0), PUSH(cnaya, 1)));
# define XfOrM1021_COUNT (2)
# define SETUP_XfOrM1021(x) SETUP(XfOrM1021_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cnaya = NULLED_OUT ; 

# 5360 "bc/src/fun.c"
  if (! resume_mc -> cont )
    RET_NOTHING ; 

  cnaya = ((Scheme_Cont * ) FUNCCALL(SETUP_XfOrM1021(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (cnaya , resume_mc -> cont , sizeof (Scheme_Cont ) ) ) ; 

  resume_mc -> cont = cnaya ; 

  cnaya -> ss . cont_mark_stack += (resume_mc -> cont_mark_total - cnaya -> cont_mark_total ) ; 

  cnaya -> cont_mark_total = resume_mc -> cont_mark_total ; 
  cnaya -> cont_mark_offset = resume_mc -> cont_mark_offset ; 
  cnaya -> cont_mark_pos_bottom = resume_mc -> cont_mark_pos_bottom ; 
  cnaya -> cont_mark_stack_copied = resume_mc -> cont_mark_stack_copied ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5376 "bc/src/fun.c"
void prune_cont_marks (Scheme_Meta_Continuation * resume_mc , Scheme_Cont * cont , Scheme_Object * extra_marks ) 
{
  Scheme_Object * val ; 
  Scheme_Hash_Table * ht ; 
  intptr_t pos , num_overlap , num_coverlap , new_overlap , base , i ; 
  Scheme_Cont_Mark * cp ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(extra_marks, 0), PUSH(resume_mc, 1), PUSH(val, 2), PUSH(cp, 3), PUSH(ht, 4), PUSH(cont, 5)));
# define XfOrM1022_COUNT (6)
# define SETUP_XfOrM1022(x) SETUP(XfOrM1022_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  val = NULLED_OUT ; 
  ht = NULLED_OUT ; 
  cp = NULLED_OUT ; 

# 5383 "bc/src/fun.c"
  for (pos = resume_mc -> cont_mark_total , num_overlap = 0 ; 
  pos -- ; 
  num_overlap ++ ) {
    if (resume_mc -> cont_mark_stack_copied [pos ] . pos != resume_mc -> cont_mark_pos )
      break ; 
  }

  if (! num_overlap && (! extra_marks || ! (((Scheme_Vector * ) (extra_marks ) ) -> size ) ) ) {

    RET_NOTHING ; 
  }

  for (pos = 0 , num_coverlap = 0 ; 
  pos < cont -> cont_mark_total ; 
  num_coverlap ++ , pos ++ ) {
    if (cont -> cont_mark_stack_copied [pos ] . pos != (cont -> cont_mark_pos_bottom + 2 ) )
      break ; 
  }

  if (! num_coverlap && (! extra_marks || ! (((Scheme_Vector * ) (extra_marks ) ) -> size ) ) ) {

    RET_NOTHING ; 
  }


  ht = FUNCCALL(SETUP_XfOrM1022(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  for (pos = resume_mc -> cont_mark_total - 1 , i = 0 ; i < num_overlap ; i ++ , pos -- ) {
#   define XfOrM1033_COUNT (0+XfOrM1022_COUNT)
#   define SETUP_XfOrM1033(x) SETUP_XfOrM1022(x)

# 5411 "bc/src/fun.c"
    val = resume_mc -> cont_mark_stack_copied [pos ] . val ; 
    if (! val )
      val = cont_key ; 
    FUNCCALL(SETUP_XfOrM1033(_), scheme_hash_set (ht , resume_mc -> cont_mark_stack_copied [pos ] . key , val ) )

    ; 
  }
  if (extra_marks ) {
#   define XfOrM1029_COUNT (0+XfOrM1022_COUNT)
#   define SETUP_XfOrM1029(x) SETUP_XfOrM1022(x)

# 5419 "bc/src/fun.c"
    for (i = 0 ; i < (((Scheme_Vector * ) (extra_marks ) ) -> size ) ; i += 2 ) {
#     define XfOrM1031_COUNT (0+XfOrM1029_COUNT)
#     define SETUP_XfOrM1031(x) SETUP_XfOrM1029(x)

# 5420 "bc/src/fun.c"
      val = (((Scheme_Vector * ) (extra_marks ) ) -> els ) [i + 1 ] ; 
      if (! val )
        val = cont_key ; 
      FUNCCALL(SETUP_XfOrM1031(_), scheme_hash_set (ht , (((Scheme_Vector * ) (extra_marks ) ) -> els ) [i ] , val ) ); 
    }
  }
  for (pos = 0 , i = 0 ; i < num_coverlap ; i ++ , pos ++ ) {
#   define XfOrM1028_COUNT (0+XfOrM1022_COUNT)
#   define SETUP_XfOrM1028(x) SETUP_XfOrM1022(x)
    FUNCCALL(SETUP_XfOrM1028(_), scheme_hash_set (ht , cont -> cont_mark_stack_copied [pos ] . key , ((void * ) 0 ) ) ); 
  }

  new_overlap = ht -> count ; 


  base = resume_mc -> cont_mark_total - num_overlap ; 
  cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM1022(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (base + new_overlap ) ) )) ; 
  (memcpy (cp , resume_mc -> cont_mark_stack_copied , base * sizeof (Scheme_Cont_Mark ) ) ) ; 
  resume_mc -> cont_mark_stack_copied = cp ; 
  resume_mc -> cont_mark_total = base + new_overlap ; 
  resume_mc -> cm_shared = 0 ; 
  resume_mc -> cont_mark_stack += (new_overlap - num_overlap ) ; 
  for (i = 0 ; i < ht -> size ; i ++ ) {
    if (ht -> vals [i ] ) {
      cp [base ] . key = ht -> keys [i ] ; 
      val = ht -> vals [i ] ; 
      if ((val ) == (cont_key ) ) 
        val = ((void * ) 0 ) ; 
      cp [base ] . val = val ; 
      cp [base ] . pos = resume_mc -> cont_mark_pos ; 
      cp [base ] . cache = ((void * ) 0 ) ; 
      base ++ ; 
    }
  }
  FUNCCALL_EMPTY(sync_meta_cont (resume_mc ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5458 "bc/src/fun.c"
static intptr_t exec_dyn_wind_pres (Scheme_Dynamic_Wind_List * dwl , 
int dwl_len , 
Scheme_Cont * cont , 
intptr_t copied_cms , 
int clear_cm_caches , 
Scheme_Object * * _sub_conts , 
int skip_dws ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  int old_cac = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ; 
  int need_clone = 0 ; 
  Scheme_Dynamic_Wind * dw ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(dw, 0), PUSH(dwl, 1), PUSH(_sub_conts, 2), PUSH(p, 3), PUSH(cont, 4)));
# define XfOrM1040_COUNT (5)
# define SETUP_XfOrM1040(x) SETUP(XfOrM1040_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  dw = NULLED_OUT ; 

# 5471 "bc/src/fun.c"
  for (; dwl ; dwl = dwl -> next ) {
#   define XfOrM1049_COUNT (0+XfOrM1040_COUNT)
#   define SETUP_XfOrM1049(x) SETUP_XfOrM1040(x)

# 5472 "bc/src/fun.c"
    if (dwl -> dw -> pre ) {
#     define XfOrM1052_COUNT (0+XfOrM1049_COUNT)
#     define SETUP_XfOrM1052(x) SETUP_XfOrM1049(x)

# 5473 "bc/src/fun.c"
      p -> next_meta = dwl -> meta_depth + dwl -> dw -> next_meta ; 
      if (dwl -> meta_depth > 0 ) {
#       define XfOrM1056_COUNT (0+XfOrM1052_COUNT)
#       define SETUP_XfOrM1056(x) SETUP_XfOrM1052(x)

# 5475 "bc/src/fun.c"
        if (! skip_dws )
          FUNCCALL(SETUP_XfOrM1056(_), scheme_apply_dw_in_meta (dwl -> dw , 0 , dwl -> meta_depth , cont ) ); 
      }

# 5477 "bc/src/fun.c"
      else {



        DW_PrePost_Proc pre = dwl -> dw -> pre ; 
#       define XfOrM1053_COUNT (0+XfOrM1052_COUNT)
#       define SETUP_XfOrM1053(x) SETUP_XfOrM1052(x)
        FUNCCALL(SETUP_XfOrM1053(_), copy_in_mark_stack (p , cont -> cont_mark_stack_copied , dwl -> dw -> envss . cont_mark_stack , copied_cms , cont -> cont_mark_offset , _sub_conts , clear_cm_caches , dwl -> dw -> envss . cont_mark_pos ) )

        ; 
        copied_cms = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 

        if (! skip_dws )
          FUNCCALL(SETUP_XfOrM1053(_), pre (dwl -> dw -> data ) ); 

        if (! cont -> composable ) {
#         define XfOrM1054_COUNT (0+XfOrM1053_COUNT)
#         define SETUP_XfOrM1054(x) SETUP_XfOrM1053(x)

# 5493 "bc/src/fun.c"
          if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) != old_cac ) {
#           define XfOrM1055_COUNT (0+XfOrM1054_COUNT)
#           define SETUP_XfOrM1055(x) SETUP_XfOrM1054(x)

# 5494 "bc/src/fun.c"
            old_cac = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ; 
            FUNCCALL(SETUP_XfOrM1055(_), scheme_recheck_prompt_and_barrier (cont ) ); 
          }
        }
      }
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    }

    if (p -> dw != dwl -> dw -> prev ) {


      need_clone = 1 ; 
    }

    if (need_clone ) {
#     define XfOrM1050_COUNT (0+XfOrM1049_COUNT)
#     define SETUP_XfOrM1050(x) SETUP_XfOrM1049(x)

# 5509 "bc/src/fun.c"
      dw = FUNCCALL(SETUP_XfOrM1050(_), clone_dyn_wind (dwl -> dw , ((void * ) 0 ) , - 1 , 1 , p -> dw , 0 , 0 ) ); 
      dw -> next_meta = p -> next_meta ; 
    }

# 5511 "bc/src/fun.c"
    else 
    dw = dwl -> dw ; 
    p -> dw = dw ; 
  }
  RET_VALUE_START (copied_cms ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5518 "bc/src/fun.c"
static void root_prompt_tag_misuse (const char * who ) 
{
  /* No conversion */

# 5520 "bc/src/fun.c"
  scheme_signal_error ("%s: misuse of root prompt tag" , who ) ; 
}

static Scheme_Object * 
call_cc (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM1058_COUNT (1)
# define SETUP_XfOrM1058(x) SETUP(XfOrM1058_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1058(_), scheme_check_proc_arity ("call-with-current-continuation" , 1 , 0 , argc , argv ) )
# 5527 "bc/src/fun.c"
  ; 
  if (argc > 1 ) {
#   define XfOrM1059_COUNT (0+XfOrM1058_COUNT)
#   define SETUP_XfOrM1059(x) SETUP_XfOrM1058(x)

# 5529 "bc/src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) ) 
    && ! (((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("call-with-current-continuation" , "continuation-prompt-tag?" , 1 , argc , argv ) )
    ; 
  }



  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (internal_call_cc_prim , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5541 "bc/src/fun.c"
static Scheme_Cont * grab_continuation (Scheme_Thread * p , int for_prompt , int composable , 
Scheme_Object * prompt_tag , Scheme_Object * pt , 
Scheme_Cont * sub_cont , Scheme_Prompt * prompt , 
Scheme_Meta_Continuation * prompt_cont , 
Scheme_Prompt * effective_barrier_prompt , 
int cm_only , 
int argc , Scheme_Object * * argv ) 
{
  Scheme_Cont * cont ; 
  Scheme_Cont_Jmp * buf_ptr ; 

# 1055 "bc/src/fun.c"
  Scheme_Object * * __funcarg206 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Cont * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(prompt, 1), PUSH(prompt_cont, 2), PUSH(effective_barrier_prompt, 3), PUSH(cont, 4), PUSH(pt, 5), PUSH(argv, 6), PUSH(p, 7), PUSH(buf_ptr, 8), PUSH(sub_cont, 9)));
# define XfOrM1060_COUNT (10)
# define SETUP_XfOrM1060(x) SETUP(XfOrM1060_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cont = NULLED_OUT ; 
  buf_ptr = NULLED_OUT ; 

# 5552 "bc/src/fun.c"
  cont = ((Scheme_Cont * ) FUNCCALL(SETUP_XfOrM1060(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  cont -> so . type = scheme_cont_type ; 

  if (! for_prompt && ! composable && ! cm_only ) {
#   define XfOrM1084_COUNT (0+XfOrM1060_COUNT)
#   define SETUP_XfOrM1084(x) SETUP_XfOrM1060(x)
    FUNCCALL(SETUP_XfOrM1084(_), scheme_set_cont_mark (cont_key , (Scheme_Object * ) cont ) )
# 5557 "bc/src/fun.c"
    ; 
  }

  if (composable )
    cont -> composable = 1 ; 

  buf_ptr = ((Scheme_Cont_Jmp * ) FUNCCALL(SETUP_XfOrM1060(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont_Jmp ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  buf_ptr -> type = scheme_rt_cont_jmp ; 
  cont -> buf_ptr = buf_ptr ; 

  if (! cm_only ) {
#   define XfOrM1080_COUNT (0+XfOrM1060_COUNT)
#   define SETUP_XfOrM1080(x) SETUP_XfOrM1060(x)
    FUNCCALL(SETUP_XfOrM1080(_), scheme_init_jmpup_buf (& cont -> buf_ptr -> buf ) )
# 5568 "bc/src/fun.c"
    ; 
    cont -> prompt_tag = prompt_tag ; 
    if (for_prompt )
      cont -> dw = ((void * ) 0 ) ; 
    else if (prompt ) {
      Scheme_Dynamic_Wind * dw ; 
      BLOCK_SETUP((PUSH(dw, 0+XfOrM1080_COUNT)));
#     define XfOrM1082_COUNT (1+XfOrM1080_COUNT)
#     define SETUP_XfOrM1082(x) SETUP(XfOrM1082_COUNT)
      dw = NULLED_OUT ; 

# 5574 "bc/src/fun.c"
      if (p -> dw ) {
#       define XfOrM1083_COUNT (0+XfOrM1082_COUNT)
#       define SETUP_XfOrM1083(x) SETUP_XfOrM1082(x)

# 5575 "bc/src/fun.c"
        dw = FUNCCALL(SETUP_XfOrM1083(_), clone_dyn_wind (p -> dw , pt , - 1 , - 1 , ((void * ) 0 ) , 0 , composable ) ); 
        cont -> dw = dw ; 
        cont -> next_meta = p -> next_meta ; 
      }

# 5578 "bc/src/fun.c"
      else 
      cont -> dw = ((void * ) 0 ) ; 
    }

# 5580 "bc/src/fun.c"
    else {
      cont -> dw = p -> dw ; 
      cont -> next_meta = p -> next_meta ; 
    }
  }
  if (! for_prompt )
    FUNCCALL(SETUP_XfOrM1060(_), ASSERT_SUSPEND_BREAK_ZERO () ); 
  FUNCCALL(SETUP_XfOrM1060(_), copy_cjs (& cont -> cjs , & p -> cjs ) ); 
  cont -> save_overflow = p -> overflow ; 
  (cont -> ss . runstack_offset = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , cont -> ss . cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , cont -> ss . cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ; 
  cont -> runstack_size = p -> runstack_size ; 
  cont -> runstack_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
  cont -> runstack_saved = p -> runstack_saved ; 
  cont -> meta_tail_pos = (prompt ? prompt -> boundary_mark_pos + 2 : 0 ) ; 
  cont -> init_config = p -> init_config ; 
  cont -> init_break_cell = p -> init_break_cell ; 
  if (for_prompt || cm_only ) {
    cont -> meta_continuation = ((void * ) 0 ) ; 
  }

# 5598 "bc/src/fun.c"
  else if (prompt ) {
    Scheme_Meta_Continuation * mc ; 
    BLOCK_SETUP((PUSH(mc, 0+XfOrM1060_COUNT)));
#   define XfOrM1077_COUNT (1+XfOrM1060_COUNT)
#   define SETUP_XfOrM1077(x) SETUP(XfOrM1077_COUNT)
    mc = NULLED_OUT ; 

# 5600 "bc/src/fun.c"
    mc = FUNCCALL(SETUP_XfOrM1077(_), clone_meta_cont (p -> meta_continuation , pt , - 1 , prompt_cont , prompt , ((void * ) 0 ) , composable ) ); 
    cont -> meta_continuation = mc ; 
    if (! prompt_cont ) {
#     define XfOrM1078_COUNT (0+XfOrM1077_COUNT)
#     define SETUP_XfOrM1078(x) SETUP_XfOrM1077(x)
      FUNCCALL(SETUP_XfOrM1078(_), init_prompt_id (prompt ) ); 
      cont -> prompt_id = prompt -> id ; 
    }
    cont -> has_prompt_dw = 1 ; 
  }

# 5609 "bc/src/fun.c"
  else 
  cont -> meta_continuation = p -> meta_continuation ; 

  if (! cm_only ) {



    Scheme_Object * meta_continuation_src ; 
    BLOCK_SETUP((PUSH(meta_continuation_src, 0+XfOrM1060_COUNT)));
#   define XfOrM1076_COUNT (1+XfOrM1060_COUNT)
#   define SETUP_XfOrM1076(x) SETUP(XfOrM1076_COUNT)
    meta_continuation_src = NULLED_OUT ; 

# 5617 "bc/src/fun.c"
    meta_continuation_src = FUNCCALL(SETUP_XfOrM1076(_), scheme_make_weak_box ((Scheme_Object * ) p -> meta_continuation ) ); 
    cont -> meta_continuation_src = meta_continuation_src ; 
  }

  if (effective_barrier_prompt ) {
    cont -> barrier_prompt = effective_barrier_prompt ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ++ ; 
  }

  if (p -> meta_prompt && prompt_cont )
    prompt = p -> meta_prompt ; 

  if (! cm_only ) {
    Scheme_Overflow * overflow ; 
    BLOCK_SETUP((PUSH(overflow, 0+XfOrM1060_COUNT)));
#   define XfOrM1071_COUNT (1+XfOrM1060_COUNT)
#   define SETUP_XfOrM1071(x) SETUP(XfOrM1071_COUNT)
    overflow = NULLED_OUT ; 

# 5632 "bc/src/fun.c"
    for (overflow = p -> overflow ; overflow ; overflow = overflow -> prev ) {
      overflow -> jmp -> captured = 1 ; 
    }

    if (prompt ) {
#     define XfOrM1072_COUNT (0+XfOrM1071_COUNT)
#     define SETUP_XfOrM1072(x) SETUP_XfOrM1071(x)

# 5637 "bc/src/fun.c"
      overflow = FUNCCALL(SETUP_XfOrM1072(_), clone_overflows (p -> overflow , prompt -> boundary_overflow_id , ((void * ) 0 ) ) ); 
      cont -> save_overflow = overflow ; 
    }
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ++ ; 
  }

  if ((! effective_barrier_prompt || ! effective_barrier_prompt -> is_barrier ) && ! cm_only ) {
#   define XfOrM1068_COUNT (0+XfOrM1060_COUNT)
#   define SETUP_XfOrM1068(x) SETUP_XfOrM1060(x)
    if (! p -> runstack_owner ) {
      Scheme_Thread * * owner ; 
      BLOCK_SETUP((PUSH(owner, 0+XfOrM1068_COUNT)));
#     define XfOrM1070_COUNT (1+XfOrM1068_COUNT)
#     define SETUP_XfOrM1070(x) SETUP(XfOrM1070_COUNT)
      owner = NULLED_OUT ; 

# 5648 "bc/src/fun.c"
      owner = ((Scheme_Thread * * ) FUNCCALL(SETUP_XfOrM1070(_), GC_malloc (sizeof (Scheme_Thread * ) * (1 ) ) )) ; 
      p -> runstack_owner = owner ; 
      * owner = p ; 
    }
    if (cont -> ss . cont_mark_stack && ! p -> cont_mark_stack_owner ) {
      Scheme_Thread * * owner ; 
      BLOCK_SETUP((PUSH(owner, 0+XfOrM1068_COUNT)));
#     define XfOrM1069_COUNT (1+XfOrM1068_COUNT)
#     define SETUP_XfOrM1069(x) SETUP(XfOrM1069_COUNT)
      owner = NULLED_OUT ; 

# 5654 "bc/src/fun.c"
      owner = ((Scheme_Thread * * ) FUNCCALL(SETUP_XfOrM1069(_), GC_malloc (sizeof (Scheme_Thread * ) * (1 ) ) )) ; 
      p -> cont_mark_stack_owner = owner ; 
      * owner = p ; 
    }
  }

# 5670 "bc/src/fun.c"
  if (! cm_only ) {
    Scheme_Saved_Stack * saved ; 
    BLOCK_SETUP((PUSH(saved, 0+XfOrM1060_COUNT)));
#   define XfOrM1063_COUNT (1+XfOrM1060_COUNT)
#   define SETUP_XfOrM1063(x) SETUP(XfOrM1063_COUNT)
    saved = NULLED_OUT ; 

# 5672 "bc/src/fun.c"
    saved = FUNCCALL(SETUP_XfOrM1063(_), copy_out_runstack (p , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , sub_cont , (for_prompt ? p -> meta_prompt : prompt ) ) )
    ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {


      intptr_t i ; 
      for (i = 0 ; i < argc ; i ++ ) {
        saved -> runstack_start [i ] = scheme_false ; 
      }
    }
    cont -> runstack_copied = saved ; 
    if (! for_prompt && prompt ) {
#     define XfOrM1064_COUNT (0+XfOrM1063_COUNT)
#     define SETUP_XfOrM1064(x) SETUP_XfOrM1063(x)


      if ((scheme_prompt_runstack_boundary_start (prompt ) ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) )
        saved = ((void * ) 0 ) ; 
      else 
      saved = (__funcarg206 = (
      scheme_prompt_runstack_boundary_start (prompt ) ) , FUNCCALL(SETUP_XfOrM1064(_), clone_runstack_saved (cont -> runstack_saved , __funcarg206 , ((void * ) 0 ) ) )) 
      ; 
      cont -> runstack_saved = saved ; 
    }
  }

  {
    Scheme_Prompt * effective_prompt ; 
    Scheme_Cont_Mark * msaved ; 
    intptr_t offset ; 
    BLOCK_SETUP((PUSH(effective_prompt, 0+XfOrM1060_COUNT), PUSH(msaved, 1+XfOrM1060_COUNT)));
#   define XfOrM1062_COUNT (2+XfOrM1060_COUNT)
#   define SETUP_XfOrM1062(x) SETUP(XfOrM1062_COUNT)
    effective_prompt = NULLED_OUT ; 
    msaved = NULLED_OUT ; 

# 5702 "bc/src/fun.c"
    effective_prompt = (for_prompt ? p -> meta_prompt : prompt ) ; 
    msaved = FUNCCALL(SETUP_XfOrM1062(_), copy_out_mark_stack (p , cont -> ss . cont_mark_stack , sub_cont , & offset , effective_prompt , ! ! prompt ) )







    ; 
    cont -> cont_mark_stack_copied = msaved ; 
    cont -> cont_mark_offset = offset ; 
    if (effective_prompt )
      cont -> cont_mark_total = cont -> ss . cont_mark_stack - effective_prompt -> mark_boundary ; 
    else 
    cont -> cont_mark_total = cont -> ss . cont_mark_stack ; 
    offset = FUNCCALL(SETUP_XfOrM1062(_), find_shareable_marks () ); 
    cont -> cont_mark_nonshare = cont -> ss . cont_mark_stack - offset ; 




    cont -> cont_mark_pos_bottom = (effective_prompt 
    ? effective_prompt -> boundary_mark_pos 
    : 1 ) ; 
  }

  if (! cm_only ) {
    cont -> runstack_owner = p -> runstack_owner ; 
    cont -> cont_mark_stack_owner = p -> cont_mark_stack_owner ; 

    cont -> stack_start = p -> stack_start ; 

    cont -> savebuf = p -> error_buf ; 

    if (prompt )
      cont -> prompt_buf = prompt -> prompt_buf ; 
  }

  RET_VALUE_START (cont ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5744 "bc/src/fun.c"
static void restore_continuation (Scheme_Cont * cont , Scheme_Thread * p , int for_prompt , 
Scheme_Object * result , 
Scheme_Overflow * resume , int empty_to_next_mc , 
Scheme_Object * prompt_tag , 
Scheme_Dynamic_Wind * common_dw , int common_next_meta , 
Scheme_Prompt * shortcut_prompt , 
int clear_cm_caches , int do_reset_cjs , 
Scheme_Cont * cm_cont , Scheme_Object * extra_marks ) 
{
  intptr_t copied_cms = 0 ; 
  Scheme_Object * * mv , * sub_conts = ((void * ) 0 ) ; 
  Scheme_Cont * sub_cont ; 
  int mc ; 
  PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(common_dw, 0), PUSH(cm_cont, 1), PUSH(result, 2), PUSH(cont, 3), PUSH(prompt_tag, 4), PUSH(p, 5), PUSH(mv, 6), PUSH(shortcut_prompt, 7), PUSH(resume, 8), PUSH(extra_marks, 9), PUSH(sub_conts, 10), PUSH(sub_cont, 11)));
# define XfOrM1085_COUNT (12)
# define SETUP_XfOrM1085(x) SETUP(XfOrM1085_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  mv = NULLED_OUT ; 
  sub_cont = NULLED_OUT ; 

# 5758 "bc/src/fun.c"
  if ((result ) == (((Scheme_Object * ) 0x6 ) ) )  {

    mv = p -> ku . multiple . array ; 
    mc = p -> ku . multiple . count ; 
    if ((mv ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
  }

# 5765 "bc/src/fun.c"
  else {
    mv = ((void * ) 0 ) ; 
    mc = 0 ; 
  }

  p -> error_buf = cont -> savebuf ; 

  p -> init_config = cont -> init_config ; 
  p -> init_break_cell = cont -> init_break_cell ; 

  if (do_reset_cjs )
    FUNCCALL(SETUP_XfOrM1085(_), copy_cjs (& p -> cjs , & cont -> cjs ) ); 
  if (shortcut_prompt ) {
    Scheme_Overflow * overflow ; 
    BLOCK_SETUP((PUSH(overflow, 0+XfOrM1085_COUNT)));
#   define XfOrM1146_COUNT (1+XfOrM1085_COUNT)
#   define SETUP_XfOrM1146(x) SETUP(XfOrM1146_COUNT)
    overflow = NULLED_OUT ; 

# 5779 "bc/src/fun.c"
    overflow = FUNCCALL(SETUP_XfOrM1146(_), clone_overflows (cont -> save_overflow , ((void * ) 0 ) , p -> overflow ) ); 
    p -> overflow = overflow ; 
  }

# 5781 "bc/src/fun.c"
  else {
    p -> overflow = cont -> save_overflow ; 
  }
  if (for_prompt ) {
    if (p -> meta_prompt )
      cont -> need_meta_prompt = 1 ; 
  }

# 5787 "bc/src/fun.c"
  else {
    Scheme_Meta_Continuation * mc , * resume_mc ; 
    BLOCK_SETUP((PUSH(resume_mc, 0+XfOrM1085_COUNT), PUSH(mc, 1+XfOrM1085_COUNT)));
#   define XfOrM1137_COUNT (2+XfOrM1085_COUNT)
#   define SETUP_XfOrM1137(x) SETUP(XfOrM1137_COUNT)
    mc = NULLED_OUT ; 
    resume_mc = NULLED_OUT ; 

# 5789 "bc/src/fun.c"
    if (resume ) {
#     define XfOrM1141_COUNT (0+XfOrM1137_COUNT)
#     define SETUP_XfOrM1141(x) SETUP_XfOrM1137(x)

# 5790 "bc/src/fun.c"
      resume_mc = ((Scheme_Meta_Continuation * ) FUNCCALL(SETUP_XfOrM1141(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Meta_Continuation ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

      resume_mc -> type = scheme_rt_meta_cont ; 

      resume_mc -> overflow = resume ; 

      resume_mc -> prompt_tag = prompt_tag ; 
      resume_mc -> pseudo = cont -> composable ; 
      resume_mc -> empty_to_next = empty_to_next_mc ; 
      resume_mc -> meta_tail_pos = cont -> meta_tail_pos ; 

      if (! cm_cont ) {
      }

      else {
        resume_mc -> cont_mark_stack = cm_cont -> ss . cont_mark_stack ; 
        resume_mc -> cont_mark_pos = cm_cont -> ss . cont_mark_pos ; 
        resume_mc -> cont_mark_total = cm_cont -> cont_mark_total ; 
        resume_mc -> cont_mark_offset = cm_cont -> cont_mark_offset ; 
        resume_mc -> cont_mark_pos_bottom = cm_cont -> cont_mark_pos_bottom ; 
        resume_mc -> cont_mark_stack_copied = cm_cont -> cont_mark_stack_copied ; 

        resume_mc -> cont = cm_cont ; 

        resume_mc -> cm_caches = 1 ; 

        resume_mc -> next = p -> meta_continuation ; 
        if (p -> meta_continuation )
          resume_mc -> depth = p -> meta_continuation -> depth + 1 ; 
      }
    }

# 5820 "bc/src/fun.c"
    else 
    resume_mc = ((void * ) 0 ) ; 
    if (resume_mc ) {
#     define XfOrM1139_COUNT (0+XfOrM1137_COUNT)
#     define SETUP_XfOrM1139(x) SETUP_XfOrM1137(x)

# 5823 "bc/src/fun.c"
      if (cont -> composable ) {
#       define XfOrM1140_COUNT (0+XfOrM1139_COUNT)
#       define SETUP_XfOrM1140(x) SETUP_XfOrM1139(x)
        FUNCCALL(SETUP_XfOrM1140(_), prune_cont_marks (resume_mc , cont , extra_marks ) ); 
        p -> cont_mark_pos_bottom = cont -> cont_mark_pos_bottom ; 
      }

      mc = FUNCCALL(SETUP_XfOrM1139(_), clone_meta_cont (cont -> meta_continuation , ((void * ) 0 ) , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , resume_mc , 0 ) ); 
    }

# 5831 "bc/src/fun.c"
    else if (shortcut_prompt ) {
#     define XfOrM1138_COUNT (0+XfOrM1137_COUNT)
#     define SETUP_XfOrM1138(x) SETUP_XfOrM1137(x)

# 5832 "bc/src/fun.c"
      mc = FUNCCALL(SETUP_XfOrM1138(_), clone_meta_cont (cont -> meta_continuation , ((void * ) 0 ) , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , p -> meta_continuation , 0 ) ); 
    }

# 5833 "bc/src/fun.c"
    else 
    mc = cont -> meta_continuation ; 
    p -> meta_continuation = mc ; 
  }

  if (shortcut_prompt ) {


    Scheme_Saved_Stack * rs ; 
    BLOCK_SETUP((PUSH(rs, 0+XfOrM1085_COUNT)));
#   define XfOrM1133_COUNT (1+XfOrM1085_COUNT)
#   define SETUP_XfOrM1133(x) SETUP(XfOrM1133_COUNT)
    rs = NULLED_OUT ; 

# 5842 "bc/src/fun.c"
    if ((scheme_prompt_runstack_boundary_start (shortcut_prompt ) ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) )
      rs = p -> runstack_saved ; 
    else {
#     define XfOrM1134_COUNT (0+XfOrM1133_COUNT)
#     define SETUP_XfOrM1134(x) SETUP_XfOrM1133(x)

# 5845 "bc/src/fun.c"
      rs = p -> runstack_saved ; 
      while (rs && (rs -> runstack_start != (scheme_prompt_runstack_boundary_start (shortcut_prompt ) ) ) ) {
        rs = rs -> prev ; 
      }
      if (rs )
        rs = rs -> prev ; 
    }
    if (rs )
      rs = FUNCCALL(SETUP_XfOrM1133(_), clone_runstack_saved (cont -> runstack_saved , ((void * ) 0 ) , rs ) ); 
    else 
    rs = cont -> runstack_saved ; 
    p -> runstack_saved = rs ; 
  }

# 5857 "bc/src/fun.c"
  else 
  p -> runstack_saved = cont -> runstack_saved ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = cont -> runstack_start ; 
  p -> runstack_size = cont -> runstack_size ; 

  (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + cont -> ss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = cont -> ss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = cont -> ss . cont_mark_pos ) ; 

  if (p -> runstack_owner 
  && (* p -> runstack_owner == p ) ) {
    * p -> runstack_owner = ((void * ) 0 ) ; 
  }

  if (resume )
    p -> meta_prompt = ((void * ) 0 ) ; 

  p -> runstack_owner = cont -> runstack_owner ; 
  if (p -> runstack_owner && (* p -> runstack_owner != p ) ) {
    Scheme_Thread * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM1085_COUNT)));
#   define XfOrM1130_COUNT (1+XfOrM1085_COUNT)
#   define SETUP_XfOrM1130(x) SETUP(XfOrM1130_COUNT)
    op = NULLED_OUT ; 

# 5876 "bc/src/fun.c"
    op = * p -> runstack_owner ; 
    if (op ) {
      Scheme_Saved_Stack * saved ; 
      BLOCK_SETUP((PUSH(saved, 0+XfOrM1130_COUNT)));
#     define XfOrM1131_COUNT (1+XfOrM1130_COUNT)
#     define SETUP_XfOrM1131(x) SETUP(XfOrM1131_COUNT)
      saved = NULLED_OUT ; 

# 5879 "bc/src/fun.c"
      saved = FUNCCALL(SETUP_XfOrM1131(_), copy_out_runstack (op , op -> runstack , op -> runstack_start , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
      op -> runstack_swapped = saved ; 
    }
    * p -> runstack_owner = p ; 
  }
  FUNCCALL(SETUP_XfOrM1085(_), copy_in_runstack (p , cont -> runstack_copied , 0 ) )




  ; 
  {
    intptr_t done = cont -> runstack_copied -> runstack_size , size ; 
#   define XfOrM1123_COUNT (0+XfOrM1085_COUNT)
#   define SETUP_XfOrM1123(x) SETUP_XfOrM1085(x)

# 5892 "bc/src/fun.c"
    sub_cont = cont ; 
    while (sub_cont ) {
#     define XfOrM1127_COUNT (0+XfOrM1123_COUNT)
#     define SETUP_XfOrM1127(x) SETUP_XfOrM1123(x)

# 5894 "bc/src/fun.c"
      if (sub_cont -> buf_ptr -> buf . cont 
      && (sub_cont -> runstack_start == sub_cont -> buf_ptr -> buf . cont -> runstack_start ) ) {
        intptr_t delta ; 
#       define XfOrM1128_COUNT (0+XfOrM1127_COUNT)
#       define SETUP_XfOrM1128(x) SETUP_XfOrM1127(x)

# 5898 "bc/src/fun.c"
        sub_cont = sub_cont -> buf_ptr -> buf . cont ; 
        size = sub_cont -> runstack_copied -> runstack_size ; 


        if (size > 2 )
          delta = 2 ; 
        else 
        delta = size ; 
        if (size > delta ) {
#         define XfOrM1129_COUNT (0+XfOrM1128_COUNT)
#         define SETUP_XfOrM1129(x) SETUP_XfOrM1128(x)
          (
# 5907 "bc/src/fun.c"
          memcpy (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) XFORM_OK_PLUS done , 
          sub_cont -> runstack_copied -> runstack_start + delta , 
          (size - delta ) * sizeof (Scheme_Object * ) ) ) ; 
          done += (size - delta ) ; 
        }
      }

# 5912 "bc/src/fun.c"
      else 
      break ; 
    }
  }

  if (p -> cont_mark_stack_owner 
  && (* p -> cont_mark_stack_owner == p ) )
    * p -> cont_mark_stack_owner = ((void * ) 0 ) ; 

  p -> cont_mark_stack_owner = cont -> cont_mark_stack_owner ; 
  if (p -> cont_mark_stack_owner 
  && (* p -> cont_mark_stack_owner != p ) ) {
    Scheme_Thread * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM1085_COUNT)));
#   define XfOrM1121_COUNT (1+XfOrM1085_COUNT)
#   define SETUP_XfOrM1121(x) SETUP(XfOrM1121_COUNT)
    op = NULLED_OUT ; 

# 5925 "bc/src/fun.c"
    op = * p -> cont_mark_stack_owner ; 
    if (op ) {
      Scheme_Cont_Mark * msaved ; 
      BLOCK_SETUP((PUSH(msaved, 0+XfOrM1121_COUNT)));
#     define XfOrM1122_COUNT (1+XfOrM1121_COUNT)
#     define SETUP_XfOrM1122(x) SETUP(XfOrM1122_COUNT)
      msaved = NULLED_OUT ; 

# 5928 "bc/src/fun.c"
      msaved = FUNCCALL(SETUP_XfOrM1122(_), copy_out_mark_stack (op , op -> cont_mark_stack , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
      op -> cont_mark_stack_swapped = msaved ; 
    }
    * p -> cont_mark_stack_owner = p ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = 0 ; 
  }





  if (resume || (for_prompt && cont -> need_meta_prompt ) ) {
    Scheme_Prompt * meta_prompt ; 
    BLOCK_SETUP((PUSH(meta_prompt, 0+XfOrM1085_COUNT)));
#   define XfOrM1107_COUNT (1+XfOrM1085_COUNT)
#   define SETUP_XfOrM1107(x) SETUP(XfOrM1107_COUNT)
    meta_prompt = NULLED_OUT ; 

# 5943 "bc/src/fun.c"
    meta_prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1107(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    meta_prompt -> so . type = scheme_prompt_type ; 
    meta_prompt -> stack_boundary = cont -> prompt_stack_start ; 
    meta_prompt -> boundary_overflow_id = ((void * ) 0 ) ; 
    {
      Scheme_Cont * tc ; 
      tc = NULLED_OUT ; 

# 5949 "bc/src/fun.c"
      for (tc = cont ; tc -> buf_ptr -> buf . cont ; tc = tc -> buf_ptr -> buf . cont ) {
      }
      meta_prompt -> mark_boundary = tc -> cont_mark_offset ; 
    }
    meta_prompt -> prompt_buf = cont -> prompt_buf ; 
    {

      Scheme_Cont * rs_cont = cont ; 
      Scheme_Saved_Stack * saved , * actual ; 
      int delta = 0 ; 
#     define XfOrM1108_COUNT (0+XfOrM1107_COUNT)
#     define SETUP_XfOrM1108(x) SETUP_XfOrM1107(x)
      saved = NULLED_OUT ; 
      actual = NULLED_OUT ; 

# 5959 "bc/src/fun.c"
      while (rs_cont -> buf_ptr -> buf . cont 
      && (rs_cont -> buf_ptr -> buf . cont -> runstack_start == cont -> runstack_start ) ) {
        delta += rs_cont -> runstack_copied -> runstack_size ; 
        rs_cont = rs_cont -> buf_ptr -> buf . cont ; 
        if (rs_cont -> runstack_copied -> runstack_size > 2 ) {
          delta -= 2 ; 
        }
      }
      actual = ((void * ) 0 ) ; 
      for (saved = rs_cont -> runstack_copied ; saved -> prev ; saved = saved -> prev ) {
        if (! actual )
          actual = p -> runstack_saved ; 
        else 
        actual = actual -> prev ; 
      }
      if (actual ) {
        meta_prompt -> u . runstack_boundary_start = actual -> runstack_start ; 
        meta_prompt -> runstack_boundary_offset = actual -> runstack_offset + saved -> runstack_size ; 
      }

# 5977 "bc/src/fun.c"
      else {
#       define XfOrM1109_COUNT (0+XfOrM1108_COUNT)
#       define SETUP_XfOrM1109(x) SETUP_XfOrM1108(x)

# 5978 "bc/src/fun.c"
        meta_prompt -> u . runstack_boundary_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
        meta_prompt -> runstack_boundary_offset = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) + saved -> runstack_size + delta ; 
        ((void ) sizeof ((meta_prompt -> runstack_boundary_offset <= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_size ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM1110_COUNT (0+XfOrM1109_COUNT)
#         define SETUP_XfOrM1110(x) SETUP_XfOrM1109(x)

# 5980 "bc/src/fun.c" 3
          if (meta_prompt -> runstack_boundary_offset <= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_size )

# 5980 "bc/src/fun.c" 3
          ; 

# 5980 "bc/src/fun.c" 3
          else FUNCCALL(SETUP_XfOrM1110(_), __assert_fail ("meta_prompt->runstack_boundary_offset <= XFORM_OK_ASSIGN ((&scheme_thread_locals)->scheme_current_thread_)->runstack_size" , "bc/src/fun.c" , 5980 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 5980 "bc/src/fun.c"
        ; 
      }
    }

    meta_prompt -> boundary_mark_pos = cont -> cont_mark_pos_bottom ; 

    p -> meta_prompt = meta_prompt ; 
  }



  copied_cms = cont -> cont_mark_offset ; 
  for (sub_cont = cont -> buf_ptr -> buf . cont ; sub_cont ; sub_cont = sub_cont -> buf_ptr -> buf . cont ) {
#   define XfOrM1106_COUNT (0+XfOrM1085_COUNT)
#   define SETUP_XfOrM1106(x) SETUP_XfOrM1085(x)

# 5993 "bc/src/fun.c"
    copied_cms = sub_cont -> cont_mark_offset ; 
    sub_conts = FUNCCALL(SETUP_XfOrM1106(_), scheme_make_raw_pair ((Scheme_Object * ) sub_cont , sub_conts ) ); 
  }

  if (! shortcut_prompt ) {
    Scheme_Cont * tc ; 
    tc = NULLED_OUT ; 

# 5999 "bc/src/fun.c"
    for (tc = cont ; tc -> buf_ptr -> buf . cont ; tc = tc -> buf_ptr -> buf . cont ) {
    }
    p -> cont_mark_stack_bottom = tc -> cont_mark_offset ; 
    p -> cont_mark_pos_bottom = tc -> cont_mark_pos_bottom ; 
  }

  if (for_prompt ) {
  }
  else {




    Scheme_Dynamic_Wind * dw , * all_dw ; 
    Scheme_Dynamic_Wind_List * dwl = ((void * ) 0 ) ; 
    int common_depth , dwl_len = 0 ; 
    BLOCK_SETUP((PUSH(dw, 0+XfOrM1085_COUNT), PUSH(dwl, 1+XfOrM1085_COUNT), PUSH(all_dw, 2+XfOrM1085_COUNT)));
#   define XfOrM1087_COUNT (3+XfOrM1085_COUNT)
#   define SETUP_XfOrM1087(x) SETUP(XfOrM1087_COUNT)
    dw = NULLED_OUT ; 
    all_dw = NULLED_OUT ; 

# 6018 "bc/src/fun.c"
    if (resume ) {
#     define XfOrM1095_COUNT (0+XfOrM1087_COUNT)
#     define SETUP_XfOrM1095(x) SETUP_XfOrM1087(x)
      if (cont -> composable ) {

        p -> next_meta ++ ; 
      }

# 6024 "bc/src/fun.c"
      else {
#       define XfOrM1096_COUNT (0+XfOrM1095_COUNT)
#       define SETUP_XfOrM1096(x) SETUP_XfOrM1095(x)
        p -> dw = common_dw ; 
        p -> next_meta = common_next_meta ; 
        if (p -> dw ) {
#         define XfOrM1097_COUNT (0+XfOrM1096_COUNT)
#         define SETUP_XfOrM1097(x) SETUP_XfOrM1096(x)

# 6031 "bc/src/fun.c"
          all_dw = FUNCCALL(SETUP_XfOrM1097(_), clone_dyn_wind (p -> dw , cont -> prompt_tag , - 1 , - 1 , ((void * ) 0 ) , 1 , 0 ) ); 
          for (dw = all_dw ; dw && ! ((dw -> prompt_tag ) == (cont -> prompt_tag ) ) ; dw = dw -> prev ) {
            p -> dw = p -> dw -> prev ; 
          }
          if (dw )
            dw -> next_meta += 1 ; 
          p -> dw = all_dw ; 
        }
      }
    }

# 6040 "bc/src/fun.c"
    else {
      p -> dw = common_dw ; 
      p -> next_meta = common_next_meta ; 
    }

    if (cont -> dw ) {
      int meta_depth ; 
#     define XfOrM1088_COUNT (0+XfOrM1087_COUNT)
#     define SETUP_XfOrM1088(x) SETUP_XfOrM1087(x)



      common_depth = (p -> dw ? p -> dw -> depth : - 1 ) ; 
      all_dw = FUNCCALL(SETUP_XfOrM1088(_), clone_dyn_wind (cont -> dw , ((void * ) 0 ) , cont -> common_dw_depth , - 1 , p -> dw , 0 , 0 ) ); 

      if ((common_depth != - 1 ) && (common_depth != all_dw -> depth ) ) {

        for (dw = all_dw ; dw -> prev -> depth != common_depth ; dw = dw -> prev ) {
        }
        dw -> next_meta = p -> next_meta ; 
      }

      meta_depth = cont -> next_meta ; 
      for (dw = all_dw ; dw && (dw -> depth != common_depth ) ; dw = dw -> prev ) {
        Scheme_Dynamic_Wind_List * cell ; 
        BLOCK_SETUP((PUSH(cell, 0+XfOrM1088_COUNT)));
#       define XfOrM1090_COUNT (1+XfOrM1088_COUNT)
#       define SETUP_XfOrM1090(x) SETUP(XfOrM1090_COUNT)
        cell = NULLED_OUT ; 

# 6066 "bc/src/fun.c"
        cell = ((Scheme_Dynamic_Wind_List * ) FUNCCALL(SETUP_XfOrM1090(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Dynamic_Wind_List ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

        cell -> type = scheme_rt_dyn_wind_cell ; 

        cell -> dw = dw ; 
        cell -> meta_depth = meta_depth ; 
        cell -> next = dwl ; 
        dwl = cell ; 
        dwl_len ++ ; 

        meta_depth += dw -> next_meta ; 
      }
      copied_cms = FUNCCALL(SETUP_XfOrM1088(_), exec_dyn_wind_pres (dwl , dwl_len , cont , copied_cms , clear_cm_caches , & sub_conts , cont -> skip_dws ) )
      ; 
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      p -> next_meta = cont -> next_meta ; 
    }
  }

  if (! for_prompt )
    p -> suspend_break = 0 ; 
  FUNCCALL(SETUP_XfOrM1085(_), copy_in_mark_stack (p , cont -> cont_mark_stack_copied , cont -> ss . cont_mark_stack , copied_cms , cont -> cont_mark_offset , & sub_conts , clear_cm_caches , cont -> ss . cont_mark_pos ) )






  ; 

  if ((result ) == (((Scheme_Object * ) 0x6 ) ) )  {
    p -> ku . multiple . array = mv ; 
    p -> ku . multiple . count = mc ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6102 "bc/src/fun.c"
static Scheme_Object * 
internal_call_cc (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ret , * volatile pt , * prompt_tag ; 
  Scheme_Cont * volatile cont ; 
  Scheme_Cont * sub_cont ; 
  Scheme_Meta_Continuation * prompt_cont , * barrier_cont ; 
  intptr_t prompt_pos , barrier_pos ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Prompt * prompt , * barrier_prompt , * effective_barrier_prompt ; 
  Scheme_Object * ec ; 
  GC_CAN_IGNORE void * stack_start ; 
  int composable ; 
  Scheme_Config * __funcarg207 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(barrier_cont, 0), PUSH(ret, 1), PUSH(ec, 2), PUSH(barrier_prompt, 3), PUSH(argv, 4), PUSH(prompt_cont, 5), PUSH(sub_cont, 6), PUSH(prompt, 7), PUSH(prompt_tag, 8), PUSH(cont, 9), PUSH(effective_barrier_prompt, 10), PUSH(pt, 11), PUSH(p, 12)));
# define XfOrM1149_COUNT (13)
# define SETUP_XfOrM1149(x) SETUP(XfOrM1149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ret = NULLED_OUT ; 
  pt = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 
  cont = NULLED_OUT ; 
  sub_cont = NULLED_OUT ; 
  prompt_cont = NULLED_OUT ; 
  barrier_cont = NULLED_OUT ; 
  prompt = NULLED_OUT ; 
  barrier_prompt = NULLED_OUT ; 
  effective_barrier_prompt = NULLED_OUT ; 
  ec = NULLED_OUT ; 

# 6116 "bc/src/fun.c"
  if (argc > 1 )
    prompt_tag = argv [1 ] ; 
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (((Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    pt = (((Scheme_Chaperone * ) prompt_tag ) -> val ) ; 
  else 
  pt = prompt_tag ; 

  composable = (argc > 2 ) ; 

  if ((pt ) == (scheme_root_prompt_tag ) )  {
#   define XfOrM1172_COUNT (0+XfOrM1149_COUNT)
#   define SETUP_XfOrM1172(x) SETUP_XfOrM1149(x)
    FUNCCALL(SETUP_XfOrM1172(_), root_prompt_tag_misuse (composable ? "call-with-composable-continuation" : "call-with-current-continuation" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  prompt = FUNCCALL(SETUP_XfOrM1149(_), scheme_get_prompt ((((Scheme_Small_Object * ) (pt ) ) -> u . ptr_val ) , & prompt_cont , & prompt_pos ) ); 
  if (! prompt && ! ((scheme_default_prompt_tag ) == (pt ) ) ) {
#   define XfOrM1171_COUNT (0+XfOrM1149_COUNT)
#   define SETUP_XfOrM1171(x) SETUP_XfOrM1149(x)
    FUNCCALL(SETUP_XfOrM1171(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "%s: continuation includes no prompt with the given tag\n" "  tag: %V" , (composable ? "call-with-composable-continuation" : "call-with-current-continuation" ) , prompt_tag ) )



    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }





  if (prompt )
    prompt = FUNCCALL(SETUP_XfOrM1149(_), make_weak_prompt (prompt ) ); 

  barrier_prompt = FUNCCALL(SETUP_XfOrM1149(_), scheme_get_barrier_prompt (& barrier_cont , & barrier_pos ) ); 

  if (composable && (((argv [2 ] ) ) == (scheme_false ) ) ) {
#   define XfOrM1167_COUNT (0+XfOrM1149_COUNT)
#   define SETUP_XfOrM1167(x) SETUP_XfOrM1149(x)

# 6157 "bc/src/fun.c"
    if (! prompt && ! barrier_prompt -> is_barrier ) {
    }
    else {
#     define XfOrM1168_COUNT (0+XfOrM1167_COUNT)
#     define SETUP_XfOrM1168(x) SETUP_XfOrM1167(x)

# 6160 "bc/src/fun.c"
      if (! prompt 
      || FUNCCALL(SETUP_XfOrM1168(_), scheme_is_cm_deeper (prompt_cont , prompt_pos , barrier_cont , barrier_pos ) )) {
#       define XfOrM1169_COUNT (0+XfOrM1168_COUNT)
#       define SETUP_XfOrM1169(x) SETUP_XfOrM1168(x)
        FUNCCALL(SETUP_XfOrM1169(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "call-with-composable-continuation: cannot capture past continuation barrier" ) )
# 6163 "bc/src/fun.c"
        ; 
      }
    }
  }

  effective_barrier_prompt = barrier_prompt ; 
  if (effective_barrier_prompt && prompt ) {
#   define XfOrM1166_COUNT (0+XfOrM1149_COUNT)
#   define SETUP_XfOrM1166(x) SETUP_XfOrM1149(x)

# 6170 "bc/src/fun.c"
    if (FUNCCALL(SETUP_XfOrM1166(_), scheme_is_cm_deeper (barrier_cont , barrier_pos , prompt_cont , prompt_pos ) ))

    effective_barrier_prompt = ((void * ) 0 ) ; 
  }

  if (composable )
    sub_cont = ((void * ) 0 ) ; 
  else 
  sub_cont = (Scheme_Cont * ) FUNCCALL(SETUP_XfOrM1149(_), scheme_extract_one_cc_mark (((void * ) 0 ) , cont_key ) ); 
  if (sub_cont 
  && (sub_cont -> save_overflow == p -> overflow ) 
  && (sub_cont -> prompt_tag == prompt_tag ) 
  && (sub_cont -> barrier_prompt == effective_barrier_prompt ) 
  && (((Scheme_Escaping_Cont * ) sub_cont -> escape_cont ) -> myerr == p -> error_buf ) ) {




    ec = sub_cont -> escape_cont ; 
  }

# 6189 "bc/src/fun.c"
  else 
  ec = ((void * ) 0 ) ; 
  if (sub_cont && ((sub_cont -> save_overflow != p -> overflow ) 
  || (sub_cont -> prompt_tag != prompt_tag ) 
  || (sub_cont -> barrier_prompt != effective_barrier_prompt ) 
  || ((Scheme_Meta_Continuation * ) (((Scheme_Small_Object * ) (sub_cont -> meta_continuation_src ) ) -> u . ptr_val ) 
  != p -> meta_continuation ) ) ) {
    sub_cont = ((void * ) 0 ) ; 
  }
  if (sub_cont && (sub_cont -> ss . cont_mark_pos == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ) {
    Scheme_Object * argv2 [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(argv2, 1, 0+XfOrM1149_COUNT)));
#   define XfOrM1161_COUNT (3+XfOrM1149_COUNT)
#   define SETUP_XfOrM1161(x) SETUP(XfOrM1161_COUNT)
    argv2[0] = NULLED_OUT ; 






    if (! sub_cont -> cont_mark_nonshare 
    && (FUNCCALL(SETUP_XfOrM1161(_), find_shareable_marks () )== XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ) ) 
# 6223 "bc/src/fun.c"
    {

      cont = sub_cont ; 
    }

# 6226 "bc/src/fun.c"
    else {
#     define XfOrM1162_COUNT (0+XfOrM1161_COUNT)
#     define SETUP_XfOrM1162(x) SETUP_XfOrM1161(x)


      cont = FUNCCALL(SETUP_XfOrM1162(_), grab_continuation (p , 0 , 0 , prompt_tag , pt , sub_cont , prompt , prompt_cont , effective_barrier_prompt , 1 , argc , argv ) )

      ; 




      cont -> buf_ptr -> buf . cont = sub_cont ; 
      cont -> escape_cont = sub_cont -> escape_cont ; 
    }

    argv2 [0 ] = (Scheme_Object * ) cont ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1161(_), scheme_tail_apply (argv [0 ] , 1 , argv2 ) )) RET_VALUE_END ; 
  }

  cont = FUNCCALL(SETUP_XfOrM1149(_), grab_continuation (p , 0 , composable , prompt_tag , pt , sub_cont , prompt , prompt_cont , effective_barrier_prompt , 0 , argc , argv ) )

  ; 
  FUNCCALL(SETUP_XfOrM1149(_), scheme_zero_unneeded_rands (p ) )
  ; 
  (__funcarg207 = FUNCCALL(SETUP_XfOrM1149(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_flatten_config (__funcarg207 ) )) 
  ; 

  {
    void * overflow_id ; 
    overflow_id = NULLED_OUT ; 
    overflow_id = (p -> overflow 
    ? (p -> overflow -> id 
    ? p -> overflow -> id 
    : p -> overflow ) 
    : ((void * ) 0 ) ) ; 

    if (prompt 
    && ! prompt_cont 
    && (prompt -> boundary_overflow_id == overflow_id ) ) {



      stack_start = prompt -> stack_boundary ; 
    }

# 6270 "bc/src/fun.c"
    else {
      Scheme_Prompt * meta_prompt , * stack_barrier_prompt ; 
      meta_prompt = NULLED_OUT ; 
      stack_barrier_prompt = NULLED_OUT ; 

# 6273 "bc/src/fun.c"
      stack_barrier_prompt = barrier_prompt ; 

      if (! stack_barrier_prompt -> is_barrier )
        stack_barrier_prompt = ((void * ) 0 ) ; 
      else if (stack_barrier_prompt -> boundary_overflow_id != overflow_id )
        stack_barrier_prompt = ((void * ) 0 ) ; 
      meta_prompt = p -> meta_prompt ; 
      if (meta_prompt )
        if (meta_prompt -> boundary_overflow_id != overflow_id )
        meta_prompt = ((void * ) 0 ) ; 

      if (stack_barrier_prompt && meta_prompt ) {
        stack_barrier_prompt = ((void * ) 0 ) ; 
      }

      if (stack_barrier_prompt )
        stack_start = stack_barrier_prompt -> stack_boundary ; 
      else if (meta_prompt )
        stack_start = meta_prompt -> stack_boundary ; 
      else 
      stack_start = p -> stack_start ; 
    }
  }




  cont -> prompt_stack_start = stack_start ; 

  cont -> escape_cont = ec ; 





  prompt_cont = ((void * ) 0 ) ; 
  barrier_cont = ((void * ) 0 ) ; 

  if (FUNCCALL(SETUP_XfOrM1149(_), scheme_setjmpup_relative (& cont -> buf_ptr -> buf , cont -> buf_ptr , stack_start , sub_cont ) )) {

    Scheme_Object * result , * extra_marks ; 
    Scheme_Overflow * resume ; 
    Scheme_Cont * use_next_cont ; 
    Scheme_Dynamic_Wind * common_dw ; 
    Scheme_Prompt * shortcut_prompt ; 
    int common_next_meta , empty_to_next_mc ; 
    BLOCK_SETUP((PUSH(result, 0+XfOrM1149_COUNT)));
#   define XfOrM1152_COUNT (1+XfOrM1149_COUNT)
#   define SETUP_XfOrM1152(x) SETUP(XfOrM1152_COUNT)
    result = NULLED_OUT ; 
    extra_marks = NULLED_OUT ; 
    resume = NULLED_OUT ; 
    use_next_cont = NULLED_OUT ; 
    common_dw = NULLED_OUT ; 
    shortcut_prompt = NULLED_OUT ; 

# 6320 "bc/src/fun.c"
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

    result = cont -> value ; 
    cont -> value = ((void * ) 0 ) ; 

    resume = cont -> resume_to ; 
    cont -> resume_to = ((void * ) 0 ) ; 

    use_next_cont = cont -> use_next_cont ; 
    cont -> use_next_cont = ((void * ) 0 ) ; 

    extra_marks = cont -> extra_marks ; 
    cont -> extra_marks = ((void * ) 0 ) ; 

    common_dw = cont -> common_dw ; 
    cont -> common_dw = ((void * ) 0 ) ; 

    common_next_meta = cont -> common_next_meta ; 
    cont -> common_next_meta = 0 ; 

    shortcut_prompt = cont -> shortcut_prompt ; 
    cont -> shortcut_prompt = ((void * ) 0 ) ; 

    empty_to_next_mc = cont -> empty_to_next_mc ; 
    cont -> empty_to_next_mc = 0 ; 
    FUNCCALL(SETUP_XfOrM1152(_), restore_continuation (cont , p , 0 , result , resume , empty_to_next_mc , pt , common_dw , common_next_meta , shortcut_prompt , ! ! resume , 1 , use_next_cont , extra_marks ) )




    ; 
    FUNCCALL_AGAIN(scheme_check_break_now () )

    ; 

    if (! FUNCCALL(SETUP_XfOrM1152(_), scheme_get_barrier_prompt (((void * ) 0 ) , ((void * ) 0 ) ) )) {





      Scheme_Prompt * acting_barrier_prompt ; 
      BLOCK_SETUP((PUSH(acting_barrier_prompt, 0+XfOrM1152_COUNT)));
#     define XfOrM1155_COUNT (1+XfOrM1152_COUNT)
#     define SETUP_XfOrM1155(x) SETUP(XfOrM1155_COUNT)
      acting_barrier_prompt = NULLED_OUT ; 

# 6362 "bc/src/fun.c"
      if (! barrier_prompt -> is_barrier )
        acting_barrier_prompt = barrier_prompt ; 
      else {
#       define XfOrM1156_COUNT (0+XfOrM1155_COUNT)
#       define SETUP_XfOrM1156(x) SETUP_XfOrM1155(x)

# 6365 "bc/src/fun.c"
        acting_barrier_prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1156(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        (memcpy (acting_barrier_prompt , barrier_prompt , sizeof (Scheme_Prompt ) ) ) ; 
        acting_barrier_prompt -> is_barrier = 0 ; 
      }
      p -> acting_barrier_prompt = acting_barrier_prompt ; 
    }

    {
      Scheme_Meta_Continuation * mc ; 
      intptr_t pos ; 
      Scheme_Object * cc_guard ; 
      BLOCK_SETUP((PUSH(mc, 0+XfOrM1152_COUNT), PUSH(cc_guard, 1+XfOrM1152_COUNT)));
#     define XfOrM1153_COUNT (2+XfOrM1152_COUNT)
#     define SETUP_XfOrM1153(x) SETUP(XfOrM1153_COUNT)
      mc = NULLED_OUT ; 
      cc_guard = NULLED_OUT ; 

# 6377 "bc/src/fun.c"
      prompt = FUNCCALL(SETUP_XfOrM1153(_), scheme_get_prompt ((((Scheme_Small_Object * ) (pt ) ) -> u . ptr_val ) , & mc , & pos ) ); 
      if (prompt && (prompt -> has_chaperone || (((Scheme_Type ) (((((intptr_t ) (cont -> prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cont -> prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) ) {
#       define XfOrM1154_COUNT (0+XfOrM1153_COUNT)
#       define SETUP_XfOrM1154(x) SETUP_XfOrM1153(x)

# 6379 "bc/src/fun.c"
        cc_guard = FUNCCALL(SETUP_XfOrM1154(_), get_set_cont_mark_by_pos (prompt_cc_guard_key , p , mc , pos , ((void * ) 0 ) ) ); 

        if (((cc_guard ) ) == (scheme_false ) ) 
          cc_guard = scheme_values_proc ; 
        if (((Scheme_Type ) (((((intptr_t ) (cont -> prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cont -> prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
          cc_guard = FUNCCALL(SETUP_XfOrM1154(_), chaperone_wrap_cc_guard (cont -> prompt_tag , cc_guard ) ); 
        FUNCCALL(SETUP_XfOrM1154(_), get_set_cont_mark_by_pos (prompt_cc_guard_key , p , mc , pos , cc_guard ) )
        ; 
      }
    }

    if ((result != ((Scheme_Object * ) 0x6 ) ) 
    && ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_thunk_for_continue_type ) ) )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1152(_), scheme_tail_apply ((((Scheme_Small_Object * ) (result ) ) -> u . ptr_val ) , 0 , ((void * ) 0 ) ) )) RET_VALUE_END ; 
    else 
    RET_VALUE_START (result ) RET_VALUE_END ; 
  }

# 6395 "bc/src/fun.c"
  else if (composable || cont -> escape_cont ) {
    Scheme_Object * argv2 [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(argv2, 1, 0+XfOrM1149_COUNT)));
#   define XfOrM1151_COUNT (3+XfOrM1149_COUNT)
#   define SETUP_XfOrM1151(x) SETUP(XfOrM1151_COUNT)
    argv2[0] = NULLED_OUT ; 

# 6398 "bc/src/fun.c"
    if (! (((argv [2 ] ) ) == (scheme_false ) ) ) 
      cont -> skip_dws = 1 ; 

    argv2 [0 ] = (Scheme_Object * ) cont ; 
    ret = FUNCCALL(SETUP_XfOrM1151(_), scheme_tail_apply (argv [0 ] , 1 , argv2 ) ); 
    RET_VALUE_START (ret ) RET_VALUE_END ; 
  }

# 6404 "bc/src/fun.c"
  else {
    Scheme_Object * argv2 [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(argv2, 2, 0+XfOrM1149_COUNT)));
#   define XfOrM1150_COUNT (3+XfOrM1149_COUNT)
#   define SETUP_XfOrM1150(x) SETUP(XfOrM1150_COUNT)
    argv2[0] = NULLED_OUT ; 
    argv2[1] = NULLED_OUT ; 

# 6407 "bc/src/fun.c"
    argv2 [0 ] = argv [0 ] ; 
    argv2 [1 ] = (Scheme_Object * ) cont ; 

    ret = FUNCCALL(SETUP_XfOrM1150(_), scheme_tail_apply (finish_call_cc_prim , 2 , argv2 ) ); 
    RET_VALUE_START (ret ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6415 "bc/src/fun.c"
static Scheme_Object * 
finish_call_cc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6418 "bc/src/fun.c"
  return do_call_ec (1 , argv , argv [1 ] ) ; 
}

static Scheme_Object * call_in_continuation (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * k = argv [0 ] , * p , * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(k, 0), PUSH(argv, 1), PUSHARRAY(a, 1, 2), PUSH(p, 5)));
# define XfOrM1174_COUNT (6)
# define SETUP_XfOrM1174(x) SETUP(XfOrM1174_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 6425 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (k ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (k ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (k ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (k ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) ) )
    FUNCCALL(SETUP_XfOrM1174(_), scheme_wrong_contract ("call-in-continuation" , "continuation?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM1174(_), scheme_check_proc_arity ("call-in-continuation" , 0 , 1 , argc , argv ) )
  ; 





  p = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM1174(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  p -> type = scheme_thunk_for_continue_type ; 
  (((Scheme_Small_Object * ) (p ) ) -> u . ptr_val ) = argv [1 ] ; 

  a [0 ] = p ; 

  if ((Scheme_Type ) (((((intptr_t ) (k ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (k ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) )  {

    int can_escape = 0 ; 
#   define XfOrM1176_COUNT (0+XfOrM1174_COUNT)
#   define SETUP_XfOrM1176(x) SETUP_XfOrM1174(x)

# 6443 "bc/src/fun.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1176(_), scheme_jump_to_continuation (k , 1 , a , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) , can_escape ) )) RET_VALUE_END ; 
  }

# 6444 "bc/src/fun.c"
  else {
#   define XfOrM1175_COUNT (0+XfOrM1174_COUNT)
#   define SETUP_XfOrM1175(x) SETUP_XfOrM1174(x)
    FUNCCALL(SETUP_XfOrM1175(_), scheme_escape_to_continuation (k , 1 , a , ((void * ) 0 ) ) )
# 6445 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6450 "bc/src/fun.c"
static Scheme_Object * continuation_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6452 "bc/src/fun.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

void scheme_takeover_stacks (Scheme_Thread * p ) 





{
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM1178_COUNT (1)
# define SETUP_XfOrM1178(x) SETUP(XfOrM1178_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 6464 "bc/src/fun.c"
  if (p -> runstack_owner && ((* p -> runstack_owner ) != p ) ) {
    Scheme_Thread * op ; 
    Scheme_Saved_Stack * swapped ; 
    BLOCK_SETUP((PUSH(swapped, 0+XfOrM1178_COUNT), PUSH(op, 1+XfOrM1178_COUNT)));
#   define XfOrM1181_COUNT (2+XfOrM1178_COUNT)
#   define SETUP_XfOrM1181(x) SETUP(XfOrM1181_COUNT)
    op = NULLED_OUT ; 
    swapped = NULLED_OUT ; 

# 6467 "bc/src/fun.c"
    op = * p -> runstack_owner ; 
    if (op ) {
#     define XfOrM1182_COUNT (0+XfOrM1181_COUNT)
#     define SETUP_XfOrM1182(x) SETUP_XfOrM1181(x)

# 6469 "bc/src/fun.c"
      swapped = FUNCCALL(SETUP_XfOrM1182(_), copy_out_runstack (op , op -> runstack , op -> runstack_start , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
      op -> runstack_swapped = swapped ; 
    }
    * (p -> runstack_owner ) = p ; 
    FUNCCALL(SETUP_XfOrM1181(_), copy_in_runstack (p , p -> runstack_swapped , 1 ) ); 
    p -> runstack_swapped = ((void * ) 0 ) ; 
  }

  if (p -> cont_mark_stack_owner && ((* p -> cont_mark_stack_owner ) != p ) ) {
    Scheme_Thread * op ; 
    Scheme_Cont_Mark * swapped ; 
    BLOCK_SETUP((PUSH(swapped, 0+XfOrM1178_COUNT), PUSH(op, 1+XfOrM1178_COUNT)));
#   define XfOrM1179_COUNT (2+XfOrM1178_COUNT)
#   define SETUP_XfOrM1179(x) SETUP(XfOrM1179_COUNT)
    op = NULLED_OUT ; 
    swapped = NULLED_OUT ; 

# 6480 "bc/src/fun.c"
    op = * p -> cont_mark_stack_owner ; 
    if (op ) {
#     define XfOrM1180_COUNT (0+XfOrM1179_COUNT)
#     define SETUP_XfOrM1180(x) SETUP_XfOrM1179(x)

# 6482 "bc/src/fun.c"
      swapped = FUNCCALL(SETUP_XfOrM1180(_), copy_out_mark_stack (op , op -> cont_mark_stack , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
      op -> cont_mark_stack_swapped = swapped ; 
    }
    * (p -> cont_mark_stack_owner ) = p ; 
    FUNCCALL(SETUP_XfOrM1179(_), copy_in_mark_stack (p , p -> cont_mark_stack_swapped , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , 0 , 0 , ((void * ) 0 ) , 0 , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ); 
    p -> cont_mark_stack_swapped = ((void * ) 0 ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6491 "bc/src/fun.c"
static Scheme_Object * 
call_with_continuation_barrier (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM1183_COUNT (1)
# define SETUP_XfOrM1183(x) SETUP(XfOrM1183_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1183(_), scheme_check_proc_arity ("call-with-continuation-barrier" , 0 , 0 , argc , argv ) )
# 6494 "bc/src/fun.c"
  ; 



  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_apply_multi (argv [0 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6501 "bc/src/fun.c"
Scheme_Prompt * scheme_get_barrier_prompt (Scheme_Meta_Continuation * * _meta_cont , 
intptr_t * _pos ) 
{
  Scheme_Prompt * p ; 
  DECL_RET_SAVE (Scheme_Prompt * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(_meta_cont, 0), PUSH(_pos, 1), PUSH(p, 2)));
# define XfOrM1184_COUNT (3)
# define SETUP_XfOrM1184(x) SETUP(XfOrM1184_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 6506 "bc/src/fun.c"
  p = (Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1184(_), scheme_extract_one_cc_mark_with_meta (((void * ) 0 ) , barrier_prompt_key , ((void * ) 0 ) , _meta_cont , _pos ) ); 
  if (! p ) {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> acting_barrier_prompt ; 
    if (_meta_cont ) {

      Scheme_Meta_Continuation * mc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation ; 
      while (mc && mc -> next ) {
        mc = mc -> next ; 
      }
      * _meta_cont = mc ; 
      * _pos = - 1 ; 
    }
  }

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6523 "bc/src/fun.c"
Scheme_Prompt * scheme_get_prompt (Scheme_Object * prompt_tag , 
Scheme_Meta_Continuation * * _meta_cont , 
intptr_t * _pos ) 
{
  /* No conversion */

# 6527 "bc/src/fun.c"
  return (Scheme_Prompt * ) scheme_extract_one_cc_mark_with_meta (((void * ) 0 ) , prompt_tag , ((void * ) 0 ) , _meta_cont , _pos ) ; 
}

static Scheme_Meta_Continuation * scheme_get_meta_continuation (Scheme_Object * key ) 
{
  Scheme_Meta_Continuation * mc ; 
  DECL_RET_SAVE (Scheme_Meta_Continuation * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(mc, 0)));
# define XfOrM1190_COUNT (1)
# define SETUP_XfOrM1190(x) SETUP(XfOrM1190_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  mc = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1190(_), scheme_extract_one_cc_mark_with_meta (((void * ) 0 ) , key , ((void * ) 0 ) , & mc , ((void * ) 0 ) ) )
# 6533 "bc/src/fun.c"
  ; 
  RET_VALUE_START (mc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6538 "bc/src/fun.c"
static Scheme_Object * make_prompt_tag (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * o , * key ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(key, 1), PUSH(o, 2)));
# define XfOrM1191_COUNT (3)
# define SETUP_XfOrM1191(x) SETUP(XfOrM1191_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  key = NULLED_OUT ; 

# 6542 "bc/src/fun.c"
  if (argc && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-continuation-prompt-tag" , "symbol?" , 0 , argc , argv ) ); 

  key = FUNCCALL(SETUP_XfOrM1191(_), scheme_make_pair (scheme_false , scheme_false ) ); 

  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM1191(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_prompt_tag_type ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) = key ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) = (argc ? argv [0 ] : ((void * ) 0 ) ) ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6555 "bc/src/fun.c"
static Scheme_Object * get_default_prompt_tag (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6557 "bc/src/fun.c"
  return scheme_default_prompt_tag ; 
}

static Scheme_Object * prompt_tag_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6562 "bc/src/fun.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

Scheme_Object * do_chaperone_prompt_tag (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects ; 
  Scheme_Object * props ; 
  int ppos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(px, 3), PUSH(props, 4), PUSH(redirects, 5)));
# define XfOrM1194_COUNT (6)
# define SETUP_XfOrM1194(x) SETUP(XfOrM1194_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 6575 "bc/src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "prompt-tag?" , 0 , argc , argv ) ); 

  if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 1 , argc , argv ) ); 
  if (! (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 2 , argc , argv ) ); 

  if ((argc > 3 ) && ! (((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
#   define XfOrM1196_COUNT (0+XfOrM1194_COUNT)
#   define SETUP_XfOrM1196(x) SETUP_XfOrM1194(x)

# 6587 "bc/src/fun.c"
    if (! (! (((intptr_t ) (argv [3 ] ) ) & 0x1 ) && ((((argv [3 ] ) -> type ) >= scheme_prim_type ) && (((argv [3 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c procedure? impersonator-property?)" , 3 , argc , argv ) ); 
    redirects = argv [3 ] ; 
    if ((argc > 4 ) && ! (((Scheme_Type ) (((((intptr_t ) (argv [4 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [4 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [4 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [4 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
#     define XfOrM1197_COUNT (0+XfOrM1196_COUNT)
#     define SETUP_XfOrM1197(x) SETUP_XfOrM1196(x)

# 6591 "bc/src/fun.c"
      if (! FUNCCALL(SETUP_XfOrM1197(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 4 , argc , argv ) ))
        FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c (procedure-arity-includes/c 1) impersonator-property?)" , 4 , argc , argv ) ); 
      redirects = FUNCCALL(SETUP_XfOrM1197(_), scheme_make_pair (redirects , argv [4 ] ) ); 
      ppos = 5 ; 
    }

# 6595 "bc/src/fun.c"
    else 
    ppos = 4 ; 
    redirects = FUNCCALL(SETUP_XfOrM1196(_), scheme_make_pair (argv [2 ] , redirects ) ); 
  }

# 6598 "bc/src/fun.c"
  else {
    ppos = 3 ; 
    redirects = argv [2 ] ; 
  }

  redirects = FUNCCALL(SETUP_XfOrM1194(_), scheme_make_pair (argv [1 ] , redirects ) ); 

  props = FUNCCALL(SETUP_XfOrM1194(_), scheme_parse_chaperone_props (name , ppos , argc , argv ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM1194(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6620 "bc/src/fun.c"
static Scheme_Object * chaperone_prompt_tag (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6622 "bc/src/fun.c"
  return do_chaperone_prompt_tag ("chaperone-prompt-tag" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_prompt_tag (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6627 "bc/src/fun.c"
  return do_chaperone_prompt_tag ("impersonate-prompt-tag" , 1 , argc , argv ) ; 
}

Scheme_Overflow * scheme_get_thread_end_overflow (void ) 
{
  Scheme_Overflow * overflow ; 
  DECL_RET_SAVE (Scheme_Overflow * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(overflow, 0)));
# define XfOrM1200_COUNT (1)
# define SETUP_XfOrM1200(x) SETUP(XfOrM1200_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  overflow = NULLED_OUT ; 

# 6633 "bc/src/fun.c"
  overflow = ((Scheme_Overflow * ) FUNCCALL(SETUP_XfOrM1200(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  overflow -> type = scheme_rt_overflow ; 

  overflow -> eot = 1 ; 
  RET_VALUE_START (overflow ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6642 "bc/src/fun.c"
void scheme_drop_prompt_meta_continuations (Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 6644 "bc/src/fun.c"
  Scheme_Meta_Continuation * mc ; 

  mc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation ; 
  while (! ((mc -> prompt_tag ) == (prompt_tag ) ) ) {
    if (mc -> overflow ) {
      scheme_signal_error ("meta-continuation to drop is not just a placeholder?!" ) ; 
    }
    mc = mc -> next ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation = mc ; 
}

Scheme_Object * scheme_finish_apply_for_prompt (Scheme_Prompt * prompt , Scheme_Object * _prompt_tag , Scheme_Object * proc , int argc , Scheme_Object * * argv ) __attribute__ ((noinline ) ) 
; 

Scheme_Object * scheme_finish_apply_for_prompt (Scheme_Prompt * prompt , Scheme_Object * _prompt_tag , 
Scheme_Object * proc , int argc , Scheme_Object * * argv ) 
{





  Scheme_Thread * p ; 
  Scheme_Object * volatile prompt_tag = _prompt_tag ; 
  mz_jmp_buf newbuf , * volatile savebuf ; 
  Scheme_Object * val ; 
  int cc_count = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(val, 1), PUSH(proc, 2), PUSH(p, 3), PUSH(argv, 4), PUSH(savebuf, 5)));
# define XfOrM1206_COUNT (6)
# define SETUP_XfOrM1206(x) SETUP(XfOrM1206_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 
  savebuf = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 6674 "bc/src/fun.c"
  prompt -> prompt_buf = & newbuf ; 
  prompt = ((void * ) 0 ) ; 

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  savebuf = p -> error_buf ; 
  p -> error_buf = & newbuf ; 




  {
    Scheme_Meta_Continuation * resume_mc ; 
    BLOCK_SETUP((PUSH(resume_mc, 0+XfOrM1206_COUNT)));
#   define XfOrM1216_COUNT (1+XfOrM1206_COUNT)
#   define SETUP_XfOrM1216(x) SETUP(XfOrM1216_COUNT)
    resume_mc = NULLED_OUT ; 

# 6687 "bc/src/fun.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) ) {
      resume_mc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) = ((void * ) 0 ) ; 
    }

# 6690 "bc/src/fun.c"
    else 
    resume_mc = ((Scheme_Meta_Continuation * ) FUNCCALL(SETUP_XfOrM1216(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Meta_Continuation ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    resume_mc -> type = scheme_rt_meta_cont ; 

    resume_mc -> prompt_tag = prompt_tag ; 
    if (p -> meta_continuation ) {
      resume_mc -> next = p -> meta_continuation ; 
      resume_mc -> depth = p -> meta_continuation -> depth + 1 ; 
    }
    resume_mc -> meta_tail_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) + 2 ; 
    p -> meta_continuation = resume_mc ; 
  }

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM1206_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {

# 6726 "bc/src/fun.c"
    val = ((void * ) 0 ) ; 
  }

# 6727 "bc/src/fun.c"
  else {
#   define XfOrM1214_COUNT (0+XfOrM1206_COUNT)
#   define SETUP_XfOrM1214(x) SETUP_XfOrM1206(x)

# 6728 "bc/src/fun.c"
    val = FUNCCALL(SETUP_XfOrM1214(_), scheme_do_eval (proc , argc , argv , - 1 ) ); 
  }

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  p -> error_buf = savebuf ; 

  {
    Scheme_Meta_Continuation * resume_mc ; 
    Scheme_Overflow * resume ; 
    BLOCK_SETUP((PUSH(resume_mc, 0+XfOrM1206_COUNT), PUSH(resume, 1+XfOrM1206_COUNT)));
#   define XfOrM1207_COUNT (2+XfOrM1206_COUNT)
#   define SETUP_XfOrM1207(x) SETUP(XfOrM1207_COUNT)
    resume_mc = NULLED_OUT ; 
    resume = NULLED_OUT ; 

# 6738 "bc/src/fun.c"
    resume = p -> meta_continuation -> overflow ; 
    resume_mc = p -> meta_continuation ; 
    p -> meta_continuation = p -> meta_continuation -> next ; 

# 6751 "bc/src/fun.c"
    if (cc_count == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM1213_COUNT (0+XfOrM1207_COUNT)
#     define SETUP_XfOrM1213(x) SETUP_XfOrM1207(x)
      (
# 6752 "bc/src/fun.c"
      memset (resume_mc , 0 , sizeof (Scheme_Meta_Continuation ) ) ) ; 

      resume_mc -> type = scheme_rt_meta_cont ; 

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) = resume_mc ; 
    }

    if (! resume ) {


      RET_VALUE_START (val ) RET_VALUE_END ; 
    }

# 6763 "bc/src/fun.c"
    else if (resume -> eot ) {
#     define XfOrM1211_COUNT (0+XfOrM1207_COUNT)
#     define SETUP_XfOrM1211(x) SETUP_XfOrM1207(x)


      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = ((void * ) 0 ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = ((void * ) 0 ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = 0 ; 
      p -> runstack_start = ((void * ) 0 ) ; 
      p -> runstack = ((void * ) 0 ) ; 
      p -> runstack_size = 0 ; 
      p -> runstack_saved = ((void * ) 0 ) ; 
      p -> cont_mark_stack_segments = ((void * ) 0 ) ; 
      FUNCCALL(SETUP_XfOrM1211(_), scheme_end_current_thread () ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 6778 "bc/src/fun.c"
    else {
#     define XfOrM1208_COUNT (0+XfOrM1207_COUNT)
#     define SETUP_XfOrM1208(x) SETUP_XfOrM1207(x)


      if (val ) {
        if (val == ((Scheme_Object * ) 0x6 ) ) {
          if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
            p -> values_buffer = ((void * ) 0 ) ; 
        }
        p -> cjs . val = val ; 
      }
      p -> stack_start = resume -> stack_start ; 
      p -> decompose_mc = resume_mc ; 
      FUNCCALL(SETUP_XfOrM1208(_), scheme_longjmpup (& resume -> jmp -> cont ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6798 "bc/src/fun.c"
Scheme_Object * scheme_apply_for_prompt (Scheme_Prompt * prompt , Scheme_Object * prompt_tag , Scheme_Object * proc , int argc , Scheme_Object * * argv ) __attribute__ ((noinline ) ) 
; 

Scheme_Object * scheme_apply_for_prompt (Scheme_Prompt * prompt , Scheme_Object * prompt_tag , 
Scheme_Object * proc , int argc , Scheme_Object * * argv ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(proc, 0)));
# define XfOrM1219_COUNT (1)
# define SETUP_XfOrM1219(x) SETUP(XfOrM1219_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 6805 "bc/src/fun.c"
  prompt -> stack_boundary = & __gc_var_stack__ ; 

  proc = FUNCCALL(SETUP_XfOrM1219(_), scheme_finish_apply_for_prompt (prompt , prompt_tag , proc , argc , argv ) ); 

  RET_VALUE_START (proc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6812 "bc/src/fun.c"
static Scheme_Object * compose_continuation (Scheme_Cont * cont , int exec_chain , 
Scheme_Object * loop_prompt , int empty_to_next_mc ) 

{



  Scheme_Overflow * overflow ; 
  Scheme_Overflow_Jmp * jmp ; 
  Scheme_Cont * saved ; 
  Scheme_Prompt * saved_meta_prompt ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(saved_meta_prompt, 0), PUSH(cont, 1), PUSH(overflow, 2), PUSH(loop_prompt, 3), PUSH(jmp, 4), PUSH(saved, 5), PUSH(p, 6)));
# define XfOrM1220_COUNT (7)
# define SETUP_XfOrM1220(x) SETUP(XfOrM1220_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  overflow = NULLED_OUT ; 
  jmp = NULLED_OUT ; 
  saved = NULLED_OUT ; 
  saved_meta_prompt = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1220(_), scheme_about_to_move_C_stack () )
# 6825 "bc/src/fun.c"
  ; 
  FUNCCALL_AGAIN(reset_cjs (& p -> cjs ) )
  ; 

  saved_meta_prompt = p -> meta_prompt ; 



  saved = FUNCCALL(SETUP_XfOrM1220(_), grab_continuation (p , 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) ); 

  if (p -> meta_prompt )
    saved -> prompt_stack_start = p -> meta_prompt -> stack_boundary ; 

  overflow = ((Scheme_Overflow * ) FUNCCALL(SETUP_XfOrM1220(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  overflow -> type = scheme_rt_overflow ; 

  overflow -> prev = p -> overflow ; 
  overflow -> stack_start = p -> stack_start ; 

  jmp = ((Scheme_Overflow_Jmp * ) FUNCCALL(SETUP_XfOrM1220(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow_Jmp ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  jmp -> type = scheme_rt_overflow_jmp ; 

  overflow -> jmp = jmp ; 

  saved -> resume_to = overflow ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) = saved ; 
  saved = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM1220(_), scheme_init_jmpup_buf (& overflow -> jmp -> cont ) )
  ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) = overflow ; 
  overflow = ((void * ) 0 ) ; 

  if (FUNCCALL(SETUP_XfOrM1220(_), scheme_setjmpup_relative (& XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) -> jmp -> cont , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) -> jmp , p -> stack_start , ((void * ) 0 ) ) )) 

  {

# 6877 "bc/src/fun.c"
    Scheme_Object * v ; 
    Scheme_Meta_Continuation * mc , * dmc ; 
    BLOCK_SETUP((PUSH(mc, 0+XfOrM1220_COUNT), PUSH(v, 1+XfOrM1220_COUNT)));
#   define XfOrM1222_COUNT (2+XfOrM1220_COUNT)
#   define SETUP_XfOrM1222(x) SETUP(XfOrM1222_COUNT)
    v = NULLED_OUT ; 
    mc = NULLED_OUT ; 
    dmc = NULLED_OUT ; 

# 6880 "bc/src/fun.c"
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

    dmc = p -> decompose_mc ; 
    p -> decompose_mc = ((void * ) 0 ) ; 
    saved = dmc -> cont ; 
    overflow = dmc -> overflow ; 

    if (! p -> cjs . jumping_to_continuation ) {

      v = p -> cjs . val ; 
      p -> cjs . val = ((void * ) 0 ) ; 
      if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
        if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
          p -> values_buffer = ((void * ) 0 ) ; 
      }
    }

# 6895 "bc/src/fun.c"
    else {


      v = ((void * ) 0 ) ; 
    }
    mc = p -> meta_continuation ; 
    p -> meta_prompt = saved_meta_prompt ; 
    FUNCCALL(SETUP_XfOrM1222(_), restore_continuation (saved , p , 1 , v , ((void * ) 0 ) , 0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 , ((void * ) 0 ) , 1 , ! p -> cjs . jumping_to_continuation , ((void * ) 0 ) , ((void * ) 0 ) ) )





    ; 

    p -> meta_continuation = mc ; 







    if (! v && ((loop_prompt 
    && (((Scheme_Object * ) p -> cjs . jumping_to_continuation ) == (loop_prompt ) ) 

    && p -> cjs . is_escape ) 
    || (! loop_prompt 
    && p -> cjs . jumping_to_continuation 
    && ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) p -> cjs . jumping_to_continuation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) p -> cjs . jumping_to_continuation ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) ) {
#     define XfOrM1224_COUNT (0+XfOrM1222_COUNT)
#     define SETUP_XfOrM1224(x) SETUP_XfOrM1222(x)
      cont = (Scheme_Cont * ) p -> cjs . val ; 
      if ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) p -> cjs . jumping_to_continuation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) p -> cjs . jumping_to_continuation ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {


        cont -> extra_marks = (Scheme_Object * ) p -> cjs . jumping_to_continuation ; 
      }
      FUNCCALL(SETUP_XfOrM1224(_), reset_cjs (& p -> cjs ) ); 

      saved -> meta_continuation = p -> meta_continuation ; 
    }
    else {
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }
  }

# 6940 "bc/src/fun.c"
  else {
    saved = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) ; 
    overflow = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) = ((void * ) 0 ) ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ++ ; 


  cont -> use_next_cont = saved ; 
  cont -> resume_to = overflow ; 
  cont -> empty_to_next_mc = (char ) empty_to_next_mc ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> stack_start = cont -> prompt_stack_start ; 
  FUNCCALL(SETUP_XfOrM1220(_), scheme_longjmpup (& cont -> buf_ptr -> buf ) ); 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6959 "bc/src/fun.c"
static void continue_prompt_escape () 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Prompt * targetc = (Scheme_Prompt * ) p -> cjs . jumping_to_continuation ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(targetc, 0), PUSH(p, 1)));
# define XfOrM1229_COUNT (2)
# define SETUP_XfOrM1229(x) SETUP(XfOrM1229_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  FUNCCALL(SETUP_XfOrM1229(_), scheme_drop_prompt_meta_continuations (targetc -> tag ) )
# 6964 "bc/src/fun.c"
  ; 

  if ((! targetc -> boundary_overflow_id && ! p -> overflow ) 
  || (targetc -> boundary_overflow_id == p -> overflow -> id ) ) {

    (((intptr_t * ) (void * ) ((* targetc -> prompt_buf ) . gcvs ) ) [1 ] = (* targetc -> prompt_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* targetc -> prompt_buf ) . gcvs , longjmp ((* targetc -> prompt_buf ) . jb , 1 ) ) ; 
  }

# 6970 "bc/src/fun.c"
  else {

    Scheme_Overflow * overflow = p -> overflow ; 
    BLOCK_SETUP((PUSH(overflow, 0+XfOrM1229_COUNT)));
#   define XfOrM1230_COUNT (1+XfOrM1229_COUNT)
#   define SETUP_XfOrM1230(x) SETUP(XfOrM1230_COUNT)

# 6973 "bc/src/fun.c"
    while (overflow -> prev 
    && (! overflow -> prev -> id 
    || (overflow -> prev -> id != targetc -> boundary_overflow_id ) ) ) {
      overflow = overflow -> prev ; 
    }
    p -> overflow = overflow ; 
    p -> stack_start = overflow -> stack_start ; 
    FUNCCALL(SETUP_XfOrM1230(_), scheme_longjmpup (& overflow -> jmp -> cont ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6984 "bc/src/fun.c"
static void restore_from_prompt (Scheme_Prompt * prompt ) 
{
  /* No conversion */

# 6986 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) != scheme_prompt_runstack_boundary_start (prompt ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = p -> runstack_saved -> runstack_start ; 
    p -> runstack_saved = p -> runstack_saved -> prev ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + prompt -> runstack_boundary_offset ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = prompt -> mark_boundary ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = prompt -> boundary_mark_pos ; 

  p -> runstack_size = prompt -> runstack_size ; 

  if (prompt -> boundary_overflow_id ) {
    while (p -> overflow -> id != prompt -> boundary_overflow_id ) {
      p -> overflow = p -> overflow -> prev ; 
    }
  }

# 7003 "bc/src/fun.c"
  else 
  p -> overflow = ((void * ) 0 ) ; 
}

static void prompt_unwind_dw (Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 7009 "bc/src/fun.c"
  int delta = 0 ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  while (p -> dw && ! ((p -> dw -> prompt_tag ) == (prompt_tag ) ) ) {
    delta += p -> dw -> next_meta ; 
    p -> dw = p -> dw -> prev ; 
  }
  if (! p -> dw ) {
    scheme_signal_error ("Lost prompt dynamic-wind record!\n" ) ; 
  }

# 7018 "bc/src/fun.c"
  else {
    delta += p -> dw -> next_meta ; 
    p -> dw = p -> dw -> prev ; 
    p -> next_meta += delta ; 
  }
}

static void prompt_unwind_one_dw (Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 7027 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  if (! p -> dw || ! ((p -> dw -> prompt_tag ) == (prompt_tag ) ) ) {
    scheme_signal_error ("Dynamic-wind record doesn't match prompt!\n" ) ; 
  }

# 7030 "bc/src/fun.c"
  else 
  prompt_unwind_dw (prompt_tag ) ; 
}

static Scheme_Object * * chaperone_do_control (const char * name , int mode , 
Scheme_Object * init_guard , Scheme_Object * obj , 
int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * * vals = argv ; 
  Scheme_Object * v ; 
  Scheme_Object * proc ; 
  int i , num_args ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(obj, 1), PUSH(px, 2), PUSH(vals, 3), PUSH(name, 4), PUSH(argv, 5), PUSH(v, 6), PUSH(init_guard, 7)));
# define XfOrM1247_COUNT (8)
# define SETUP_XfOrM1247(x) SETUP(XfOrM1247_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  v = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 7044 "bc/src/fun.c"
  while (1 ) {
#   define XfOrM1268_COUNT (0+XfOrM1247_COUNT)
#   define SETUP_XfOrM1268(x) SETUP_XfOrM1247(x)

# 7045 "bc/src/fun.c"
    if (init_guard || ! ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
#     define XfOrM1270_COUNT (0+XfOrM1268_COUNT)
#     define SETUP_XfOrM1270(x) SETUP_XfOrM1268(x)

# 7046 "bc/src/fun.c"
      if (init_guard ) {
        proc = init_guard ; 
        if ((((void * ) 0 ) ) == (scheme_values_proc ) ) 
          proc = ((void * ) 0 ) ; 
        px = ((void * ) 0 ) ; 
      }

# 7051 "bc/src/fun.c"
      else {
        px = (Scheme_Chaperone * ) obj ; 
        obj = px -> prev ; 

        if (! mode )
          proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . car ) ; 
        else {
          proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ; 
          if (mode == 1 ) {
            if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
              proc = (((Scheme_Simple_Object * ) (proc ) ) -> u . pair_val . car ) ; 
          }

# 7062 "bc/src/fun.c"
          else {
            if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
              proc = (((Scheme_Simple_Object * ) (proc ) ) -> u . pair_val . cdr ) ; 
              if (mode == 2 ) {
                if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
                  proc = (((Scheme_Simple_Object * ) (proc ) ) -> u . pair_val . car ) ; 
              }

# 7068 "bc/src/fun.c"
              else {
                if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
                  proc = (((Scheme_Simple_Object * ) (proc ) ) -> u . pair_val . cdr ) ; 
                else 
                proc = ((void * ) 0 ) ; 
              }
            }

# 7074 "bc/src/fun.c"
            else 
            proc = ((void * ) 0 ) ; 
          }
        }
      }

      if (proc ) {
#       define XfOrM1271_COUNT (0+XfOrM1270_COUNT)
#       define SETUP_XfOrM1271(x) SETUP_XfOrM1270(x)

# 7081 "bc/src/fun.c"
        if (mode == 3 )
          v = FUNCCALL(SETUP_XfOrM1271(_), scheme_apply (proc , argc , argv ) ); 
        else 
        v = FUNCCALL(SETUP_XfOrM1271(_), scheme_do_eval (proc , argc , argv , - 1 ) ); 

        if (v == ((Scheme_Object * ) 0x6 ) ) {
          GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
          if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
            p -> values_buffer = ((void * ) 0 ) ; 
          num_args = p -> ku . multiple . count ; 
          vals = p -> ku . multiple . array ; 
          p -> ku . multiple . array = ((void * ) 0 ) ; 
        }

# 7093 "bc/src/fun.c"
        else {
#         define XfOrM1278_COUNT (0+XfOrM1271_COUNT)
#         define SETUP_XfOrM1278(x) SETUP_XfOrM1271(x)

# 7094 "bc/src/fun.c"
          num_args = 1 ; 
          vals = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1278(_), GC_malloc (sizeof (Scheme_Object * ) * (1 ) ) )) ; 
          vals [0 ] = v ; 
        }





        if (num_args == 1 && num_args != argc )
          FUNCCALL(SETUP_XfOrM1271(_), scheme_wrong_return_arity (name , argc , 1 , (Scheme_Object * * ) (vals [0 ] ) , "\n  in: use of redirecting procedure" ) ); 
        else if (num_args != argc )
          FUNCCALL(SETUP_XfOrM1271(_), scheme_wrong_return_arity (name , argc , num_args , vals , "\n   in: use of redirecting procedure" ) ); 

        if (mode == 3 ) {
#         define XfOrM1276_COUNT (0+XfOrM1271_COUNT)
#         define SETUP_XfOrM1276(x) SETUP_XfOrM1271(x)

# 7109 "bc/src/fun.c"
          if (! FUNCCALL(SETUP_XfOrM1276(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , argc , vals ) )) {
#           define XfOrM1277_COUNT (0+XfOrM1276_COUNT)
#           define SETUP_XfOrM1277(x) SETUP_XfOrM1276(x)
            FUNCCALL_EMPTY(scheme_wrong_contract ("call/cc guard-wrapping function" , "(procedure-arity-includes/c 2)" , 0 , - 1 , vals ) )
# 7110 "bc/src/fun.c"
            ; 
          }
        }

        if (! init_guard ) {
#         define XfOrM1272_COUNT (0+XfOrM1271_COUNT)
#         define SETUP_XfOrM1272(x) SETUP_XfOrM1271(x)

# 7115 "bc/src/fun.c"
          if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ) {
#           define XfOrM1273_COUNT (0+XfOrM1272_COUNT)
#           define SETUP_XfOrM1273(x) SETUP_XfOrM1272(x)

# 7116 "bc/src/fun.c"
            for (i = 0 ; i < argc ; i ++ ) {
#             define XfOrM1275_COUNT (0+XfOrM1273_COUNT)
#             define SETUP_XfOrM1275(x) SETUP_XfOrM1273(x)

# 7117 "bc/src/fun.c"
              if (! FUNCCALL(SETUP_XfOrM1275(_), scheme_chaperone_of (vals [i ] , argv [i ] ) ))
                FUNCCALL(SETUP_XfOrM1275(_), scheme_wrong_chaperoned (name , "value" , argv [i ] , vals [i ] ) ); 
            }
          }
        }

        argv = vals ; 
      }

      init_guard = ((void * ) 0 ) ; 
    }

# 7127 "bc/src/fun.c"
    else {
      RET_VALUE_START (vals ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7133 "bc/src/fun.c"
static Scheme_Object * * chaperone_do_prompt_handler (Scheme_Object * obj , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7135 "bc/src/fun.c"
  return chaperone_do_control ("call-with-continuation-prompt" , 0 , ((void * ) 0 ) , obj , argc , argv ) ; 
}

static Scheme_Object * * chaperone_do_abort (Scheme_Object * obj , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7140 "bc/src/fun.c"
  return chaperone_do_control ("abort-current-continuation" , 1 , ((void * ) 0 ) , obj , argc , argv ) ; 
}

static Scheme_Object * * chaperone_do_cc_guard (Scheme_Object * cc_guard , Scheme_Object * obj , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7145 "bc/src/fun.c"
  return chaperone_do_control ("call-with-continuation-prompt" , 2 , cc_guard , obj , argc , argv ) ; 
}

static Scheme_Object * chaperone_wrap_cc_guard (Scheme_Object * obj , Scheme_Object * proc ) 
{
  Scheme_Object * a [1 ] , * * a2 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0), PUSH(a2, 3)));
# define XfOrM1291_COUNT (4)
# define SETUP_XfOrM1291(x) SETUP(XfOrM1291_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a2 = NULLED_OUT ; 

# 7152 "bc/src/fun.c"
  a [0 ] = proc ; 
  a2 = FUNCCALL(SETUP_XfOrM1291(_), chaperone_do_control ("call-with-current-continuation" , 3 , ((void * ) 0 ) , obj , 1 , a ) ); 

  RET_VALUE_START (a2 [0 ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7158 "bc/src/fun.c"
static Scheme_Object * do_cc_guard (Scheme_Object * v , Scheme_Object * cc_guard , Scheme_Object * chaperone ) 
{
  int argc ; 
  Scheme_Object * * argv , * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSHARRAY(a, 1, 1)));
# define XfOrM1292_COUNT (4)
# define SETUP_XfOrM1292(x) SETUP(XfOrM1292_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  argv = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 7163 "bc/src/fun.c"
  if (v == ((Scheme_Object * ) 0x6 ) ) {
    GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
    argc = p -> ku . multiple . count ; 
    argv = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
  }

# 7170 "bc/src/fun.c"
  else {
    a [0 ] = v ; 
    argv = a ; 
    argc = 1 ; 
  }

  if (! chaperone )

# 7176 "bc/src/fun.c"
  chaperone = scheme_default_prompt_tag ; 

  argv = FUNCCALL(SETUP_XfOrM1292(_), chaperone_do_cc_guard (cc_guard , chaperone , argc , argv ) ); 

  if (argc == 1 )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1292(_), scheme_values (argc , argv ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7186 "bc/src/fun.c"
static Scheme_Object * call_with_prompt (int in_argc , Scheme_Object * in_argv [] ) 
{
  Scheme_Object * v ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * proc = in_argv [0 ] , * prompt_tag ; 
  Scheme_Prompt * prompt ; 
  int argc , handler_argument_error = 0 ; 

  Scheme_Object * * argv , * a [3 ] , * handler ; 
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Dynamic_Wind * prompt_dw ; 
  int cc_count = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 
  Scheme_Object * chaperone = ((void * ) 0 ) , * cc_guard = scheme_false ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(chaperone, 0), PUSH(prompt_dw, 1), PUSH(cc_guard, 2), PUSH(cframe.cache, 3), PUSH(argv, 4), PUSH(prompt, 5), PUSHARRAY(a, 3, 6), PUSH(proc, 9), PUSH(prompt_tag, 10), PUSH(v, 11), PUSH(handler, 12), PUSH(p, 13), PUSH(in_argv, 14)));
# define XfOrM1295_COUNT (15)
# define SETUP_XfOrM1295(x) SETUP(XfOrM1295_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 
  prompt = NULLED_OUT ; 
  argv = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  handler = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  prompt_dw = NULLED_OUT ; 

# 7200 "bc/src/fun.c"
  argc = in_argc - 3 ; 
  if (argc <= 0 ) {
    argc = 0 ; 
    argv = ((void * ) 0 ) ; 
  }

# 7204 "bc/src/fun.c"
  else {
    int i ; 
#   define XfOrM1377_COUNT (0+XfOrM1295_COUNT)
#   define SETUP_XfOrM1377(x) SETUP_XfOrM1295(x)

# 7206 "bc/src/fun.c"
    if (argc <= 3 )
      argv = a ; 
    else 
    argv = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1377(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
    for (i = 0 ; i < argc ; i ++ ) {
      argv [i ] = in_argv [i + 3 ] ; 
    }
  }
  FUNCCALL(SETUP_XfOrM1295(_), scheme_check_proc_arity ("call-with-continuation-prompt" , argc , 0 , in_argc , in_argv ) )
  ; 
  if (in_argc > 1 ) {
#   define XfOrM1372_COUNT (0+XfOrM1295_COUNT)
#   define SETUP_XfOrM1372(x) SETUP_XfOrM1295(x)

# 7218 "bc/src/fun.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (in_argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (in_argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
#     define XfOrM1374_COUNT (0+XfOrM1372_COUNT)
#     define SETUP_XfOrM1374(x) SETUP_XfOrM1372(x)

# 7219 "bc/src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (in_argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (in_argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) in_argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) in_argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
        chaperone = in_argv [1 ] ; 
        prompt_tag = (((Scheme_Chaperone * ) in_argv [1 ] ) -> val ) ; 
      }

# 7223 "bc/src/fun.c"
      else {
#       define XfOrM1375_COUNT (0+XfOrM1374_COUNT)
#       define SETUP_XfOrM1375(x) SETUP_XfOrM1374(x)
        FUNCCALL(SETUP_XfOrM1375(_), scheme_wrong_contract ("call-with-continuation-prompt" , "continuation-prompt-tag?" , 1 , in_argc , in_argv ) )
# 7225 "bc/src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 7228 "bc/src/fun.c"
    else 
    prompt_tag = in_argv [1 ] ; 
    if ((prompt_tag ) == (scheme_root_prompt_tag ) )  {
#     define XfOrM1373_COUNT (0+XfOrM1372_COUNT)
#     define SETUP_XfOrM1373(x) SETUP_XfOrM1372(x)
      FUNCCALL(SETUP_XfOrM1373(_), root_prompt_tag_misuse ("call-with-continuation-prompt" ) )
# 7231 "bc/src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 7234 "bc/src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (in_argc > 2 ) {
#   define XfOrM1371_COUNT (0+XfOrM1295_COUNT)
#   define SETUP_XfOrM1371(x) SETUP_XfOrM1295(x)

# 7238 "bc/src/fun.c"
    if ((! (((in_argv [2 ] ) ) == (scheme_false ) ) ) && ! (! (((intptr_t ) (in_argv [2 ] ) ) & 0x1 ) && ((((in_argv [2 ] ) -> type ) >= scheme_prim_type ) && (((in_argv [2 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL(SETUP_XfOrM1371(_), scheme_wrong_contract ("call-with-continuation-prompt" , "(or/c procedure? #f)" , 2 , in_argc , in_argv ) ); 
    handler = in_argv [2 ] ; 
  }

# 7241 "bc/src/fun.c"
  else 
  handler = scheme_false ; 

  do {
#   define XfOrM1336_COUNT (0+XfOrM1295_COUNT)
#   define SETUP_XfOrM1336(x) SETUP_XfOrM1295(x)
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) ) {



      prompt = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) = ((void * ) 0 ) ; 
    }

# 7253 "bc/src/fun.c"
    else 
    prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1336(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    prompt -> so . type = scheme_prompt_type ; 

    prompt -> tag = prompt_tag ; 
    FUNCCALL(SETUP_XfOrM1336(_), scheme_push_continuation_frame (& cframe ) )
# 7270 "bc/src/fun.c"
    ; 
    FUNCCALL_AGAIN(scheme_set_cont_mark (prompt_cc_guard_key , cc_guard ) ); 
    FUNCCALL_AGAIN(scheme_set_cont_mark ((((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) , (Scheme_Object * ) prompt ) ); 
    FUNCCALL_AGAIN(ASSERT_SUSPEND_BREAK_ZERO () )





    ; 
    FUNCCALL_AGAIN(initialize_prompt (p , prompt , ((void * ) 0 ) , 0 ) )
    ; 

    if (p -> overflow ) {
#     define XfOrM1369_COUNT (0+XfOrM1336_COUNT)
#     define SETUP_XfOrM1369(x) SETUP_XfOrM1336(x)
      FUNCCALL(SETUP_XfOrM1369(_), ensure_overflow_id (p -> overflow ) )
# 7284 "bc/src/fun.c"
      ; 
      prompt -> boundary_overflow_id = p -> overflow -> id ; 
    }

    prompt -> runstack_size = p -> runstack_size ; 

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) ) {
      prompt_dw = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) = ((void * ) 0 ) ; 
    }

# 7293 "bc/src/fun.c"
    else 
    prompt_dw = ((Scheme_Dynamic_Wind * ) FUNCCALL(SETUP_XfOrM1336(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Dynamic_Wind ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    prompt_dw -> type = scheme_rt_dyn_wind ; 

    prompt_dw -> prompt_tag = prompt_tag ; 
    if (p -> dw ) {
      prompt_dw -> next_meta = p -> next_meta ; 
      prompt_dw -> prev = p -> dw ; 
      prompt_dw -> depth = p -> dw -> depth + 1 ; 
    }

    p -> next_meta = 0 ; 
    p -> dw = prompt_dw ; 
    if (chaperone )
      prompt -> has_chaperone = 1 ; 

    v = FUNCCALL(SETUP_XfOrM1336(_), scheme_apply_for_prompt (prompt , prompt_tag , proc , argc , argv ) ); 






    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

    if (v == ((Scheme_Object * ) 0x6 ) ) {
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
    }
    FUNCCALL(SETUP_XfOrM1336(_), restore_from_prompt (prompt ) )
    ; 

    p -> suspend_break = 0 ; 

    if (! v ) {
#     define XfOrM1341_COUNT (0+XfOrM1336_COUNT)
#     define SETUP_XfOrM1341(x) SETUP_XfOrM1336(x)

# 7330 "bc/src/fun.c"
      if (((Scheme_Object * ) p -> cjs . jumping_to_continuation ) == ((Scheme_Object * ) prompt ) )  
      {
#       define XfOrM1344_COUNT (0+XfOrM1341_COUNT)
#       define SETUP_XfOrM1344(x) SETUP_XfOrM1341(x)
        if (p -> cjs . is_escape ) {




          Scheme_Cont * target ; 
          BLOCK_SETUP((PUSH(target, 0+XfOrM1344_COUNT)));
#         define XfOrM1357_COUNT (1+XfOrM1344_COUNT)
#         define SETUP_XfOrM1357(x) SETUP(XfOrM1357_COUNT)
          target = NULLED_OUT ; 

# 7341 "bc/src/fun.c"
          target = (Scheme_Cont * ) p -> cjs . val ; 
          FUNCCALL(SETUP_XfOrM1357(_), reset_cjs (& p -> cjs ) ); 

          v = FUNCCALL_AGAIN(compose_continuation (target , 1 , (Scheme_Object * ) prompt , 0 ) ); 

          if (v ) {
#           define XfOrM1364_COUNT (0+XfOrM1357_COUNT)
#           define SETUP_XfOrM1364(x) SETUP_XfOrM1357(x)

# 7348 "bc/src/fun.c"
            if (v == ((Scheme_Object * ) 0x6 ) ) {
              if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
                p -> values_buffer = ((void * ) 0 ) ; 
            }
            FUNCCALL(SETUP_XfOrM1364(_), prompt_unwind_one_dw (prompt_tag ) ); 
            handler = ((void * ) 0 ) ; 
          }

# 7354 "bc/src/fun.c"
          else {
#           define XfOrM1358_COUNT (0+XfOrM1357_COUNT)
#           define SETUP_XfOrM1358(x) SETUP_XfOrM1357(x)

# 7356 "bc/src/fun.c"
            p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
            if (((Scheme_Object * ) p -> cjs . jumping_to_continuation ) == ((Scheme_Object * ) prompt ) )  
            {
#             define XfOrM1361_COUNT (0+XfOrM1358_COUNT)
#             define SETUP_XfOrM1361(x) SETUP_XfOrM1358(x)
              if (p -> cjs . is_escape ) {
#               define XfOrM1363_COUNT (0+XfOrM1361_COUNT)
#               define SETUP_XfOrM1363(x) SETUP_XfOrM1361(x)
                FUNCCALL(SETUP_XfOrM1363(_), scheme_signal_error ("escape-to-prompt escaped!" ) )
# 7363 "bc/src/fun.c"
                ; 
                RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
              }

# 7365 "bc/src/fun.c"
              else {
#               define XfOrM1362_COUNT (0+XfOrM1361_COUNT)
#               define SETUP_XfOrM1362(x) SETUP_XfOrM1361(x)
                FUNCCALL(SETUP_XfOrM1362(_), prompt_unwind_one_dw (prompt_tag ) ); 
                v = ((void * ) 0 ) ; 
              }
            }

# 7371 "bc/src/fun.c"
            else if (p -> cjs . is_escape ) {
#             define XfOrM1360_COUNT (0+XfOrM1358_COUNT)
#             define SETUP_XfOrM1360(x) SETUP_XfOrM1358(x)
              FUNCCALL(SETUP_XfOrM1360(_), continue_prompt_escape () ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }

# 7376 "bc/src/fun.c"
            else {
#             define XfOrM1359_COUNT (0+XfOrM1358_COUNT)
#             define SETUP_XfOrM1359(x) SETUP_XfOrM1358(x)
              FUNCCALL(SETUP_XfOrM1359(_), restore_from_prompt (prompt ) )
# 7378 "bc/src/fun.c"
              ; 
              FUNCCALL(SETUP_XfOrM1359(_), prompt_unwind_one_dw (prompt_tag ) ); 
              (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
          }
        }

# 7384 "bc/src/fun.c"
        else {
#         define XfOrM1356_COUNT (0+XfOrM1344_COUNT)
#         define SETUP_XfOrM1356(x) SETUP_XfOrM1344(x)
          FUNCCALL(SETUP_XfOrM1356(_), prompt_unwind_one_dw (prompt_tag ) )
          ; 
          v = ((void * ) 0 ) ; 
        }




        if (! v ) {
#         define XfOrM1346_COUNT (0+XfOrM1344_COUNT)
#         define SETUP_XfOrM1346(x) SETUP_XfOrM1344(x)
          FUNCCALL(SETUP_XfOrM1346(_), get_set_cont_mark_by_pos (prompt_cc_guard_key , p , ((void * ) 0 ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) , scheme_false ) )
# 7397 "bc/src/fun.c"
          ; 

          argc = p -> cjs . num_vals ; 

          if (argc == 1 ) {
            a [0 ] = p -> cjs . val ; 
            argv = a ; 
          }

# 7404 "bc/src/fun.c"
          else 
          argv = (Scheme_Object * * ) p -> cjs . val ; 
          FUNCCALL(SETUP_XfOrM1346(_), reset_cjs (& p -> cjs ) )
          ; 





          if (chaperone ) {
#           define XfOrM1354_COUNT (0+XfOrM1346_COUNT)
#           define SETUP_XfOrM1354(x) SETUP_XfOrM1346(x)

# 7414 "bc/src/fun.c"
            argv = FUNCCALL(SETUP_XfOrM1354(_), chaperone_do_prompt_handler (chaperone , argc , argv ) ); 
          }

          if ((handler ) == (scheme_values_proc ) )  {
#           define XfOrM1352_COUNT (0+XfOrM1346_COUNT)
#           define SETUP_XfOrM1352(x) SETUP_XfOrM1346(x)

# 7418 "bc/src/fun.c"
            v = FUNCCALL(SETUP_XfOrM1352(_), scheme_values (argc , argv ) ); 
            if (v == ((Scheme_Object * ) 0x6 ) ) {
              if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
                p -> values_buffer = ((void * ) 0 ) ; 
            }
            handler = ((void * ) 0 ) ; 
          }

# 7424 "bc/src/fun.c"
          else if (((handler ) ) == (scheme_false ) )  {
#           define XfOrM1347_COUNT (0+XfOrM1346_COUNT)
#           define SETUP_XfOrM1347(x) SETUP_XfOrM1346(x)

# 7425 "bc/src/fun.c"
            if (argc == 1 ) {
#             define XfOrM1349_COUNT (0+XfOrM1347_COUNT)
#             define SETUP_XfOrM1349(x) SETUP_XfOrM1347(x)

# 7426 "bc/src/fun.c"
              if (! FUNCCALL(SETUP_XfOrM1349(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 0 , argc , argv ) )) {

                handler_argument_error = 1 ; 
                handler = ((void * ) 0 ) ; 
              }

# 7430 "bc/src/fun.c"
              else {
                proc = a [0 ] ; 
                argc = 0 ; 
                argv = ((void * ) 0 ) ; 
              }
            }

# 7435 "bc/src/fun.c"
            else {

              handler_argument_error = 1 ; 
              handler = ((void * ) 0 ) ; 
            }
          }
        }

# 7441 "bc/src/fun.c"
        else {
          argc = 0 ; 
          argv = ((void * ) 0 ) ; 
        }
      }

# 7445 "bc/src/fun.c"
      else {
#       define XfOrM1342_COUNT (0+XfOrM1341_COUNT)
#       define SETUP_XfOrM1342(x) SETUP_XfOrM1341(x)

# 7447 "bc/src/fun.c"
        if ((p -> dw != prompt_dw ) 
        && (! p -> dw || ! prompt_dw -> id || (p -> dw -> id != prompt_dw -> id ) ) ) {
        }

        else FUNCCALL(SETUP_XfOrM1342(_), prompt_unwind_one_dw (prompt_tag ) )
        ; 
        (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 7456 "bc/src/fun.c"
    else {
#     define XfOrM1340_COUNT (0+XfOrM1336_COUNT)
#     define SETUP_XfOrM1340(x) SETUP_XfOrM1336(x)
      FUNCCALL(SETUP_XfOrM1340(_), prompt_unwind_one_dw (prompt_tag ) )
# 7457 "bc/src/fun.c"
      ; 
      handler = ((void * ) 0 ) ; 
      argc = 0 ; 
      argv = ((void * ) 0 ) ; 
    }

    cc_guard = FUNCCALL(SETUP_XfOrM1336(_), get_set_cont_mark_by_pos (prompt_cc_guard_key , p , ((void * ) 0 ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) , ((void * ) 0 ) ) ); 
    if (((cc_guard ) ) == (scheme_false ) ) 

# 7464 "bc/src/fun.c"
    cc_guard = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM1336(_), scheme_pop_continuation_frame (& cframe ) )
    ; 

    if (cc_count == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM1337_COUNT (0+XfOrM1336_COUNT)
#     define SETUP_XfOrM1337(x) SETUP_XfOrM1336(x)

# 7469 "bc/src/fun.c"
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) ) {
#       define XfOrM1339_COUNT (0+XfOrM1337_COUNT)
#       define SETUP_XfOrM1339(x) SETUP_XfOrM1337(x)
        (
# 7470 "bc/src/fun.c"
        memset (prompt , 0 , sizeof (Scheme_Prompt ) ) ) ; 
        prompt -> so . type = scheme_prompt_type ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) = prompt ; 
      }
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) ) {
#       define XfOrM1338_COUNT (0+XfOrM1337_COUNT)
#       define SETUP_XfOrM1338(x) SETUP_XfOrM1337(x)
        (
# 7475 "bc/src/fun.c"
        memset (prompt_dw , 0 , sizeof (Scheme_Dynamic_Wind ) ) ) ; 

        prompt_dw -> type = scheme_rt_dyn_wind ; 

        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) = prompt_dw ; 
      }
    }
  }

# 7482 "bc/src/fun.c"
  while (handler && (((handler ) ) == (scheme_false ) ) ) ; 

  if (handler_argument_error ) {
#   define XfOrM1298_COUNT (0+XfOrM1295_COUNT)
#   define SETUP_XfOrM1298(x) SETUP_XfOrM1295(x)

# 7485 "bc/src/fun.c"
    if (argc == 1 ) {
#     define XfOrM1300_COUNT (0+XfOrM1298_COUNT)
#     define SETUP_XfOrM1300(x) SETUP_XfOrM1298(x)
      FUNCCALL(SETUP_XfOrM1300(_), scheme_check_proc_arity ("default-continuation-prompt-handler" , 0 , 0 , argc , argv ) )
# 7486 "bc/src/fun.c"
      ; 
    }

# 7487 "bc/src/fun.c"
    else {
#     define XfOrM1299_COUNT (0+XfOrM1298_COUNT)
#     define SETUP_XfOrM1299(x) SETUP_XfOrM1298(x)
      FUNCCALL(SETUP_XfOrM1299(_), scheme_wrong_return_arity ("call-with-continuation-prompt" , 1 , argc , argv , "\n  in: application of default prompt handler" ) )
# 7489 "bc/src/fun.c"
      ; 
    }
  }

  if (handler ) {
#   define XfOrM1297_COUNT (0+XfOrM1295_COUNT)
#   define SETUP_XfOrM1297(x) SETUP_XfOrM1295(x)

# 7494 "bc/src/fun.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1297(_), scheme_tail_apply (handler , argc , argv ) )) RET_VALUE_END ; 
  }

# 7495 "bc/src/fun.c"
  else if (cc_guard ) {
#   define XfOrM1296_COUNT (0+XfOrM1295_COUNT)
#   define SETUP_XfOrM1296(x) SETUP_XfOrM1295(x)

# 7496 "bc/src/fun.c"
    if ((cc_guard ) == (scheme_values_proc ) ) 
      cc_guard = ((void * ) 0 ) ; 
    if (cc_guard || chaperone )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1296(_), do_cc_guard (v , cc_guard , chaperone ) )) RET_VALUE_END ; 
    else 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

# 7502 "bc/src/fun.c"
  else 
  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7506 "bc/src/fun.c"
static Scheme_Object * propagate_abort (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * * argv2 ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(argv2, 1)));
# define XfOrM1381_COUNT (2)
# define SETUP_XfOrM1381(x) SETUP(XfOrM1381_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  argv2 = NULLED_OUT ; 

# 7510 "bc/src/fun.c"
  argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1381(_), GC_malloc (sizeof (Scheme_Object * ) * (argc + 1 ) ) )) ; 
  (memcpy (argv2 XFORM_OK_PLUS 1 , argv , sizeof (Scheme_Object * ) * argc ) ) ; 
  argv2 [0 ] = scheme_default_prompt_tag ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (abort_continuation_proc , argc + 1 , argv2 , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7517 "bc/src/fun.c"
static Scheme_Object * do_call_with_prompt (Scheme_Closed_Prim f , void * data , 
int multi , int top_level ) 
{
  Scheme_Object * prim , * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0), PUSH(prim, 3)));
# define XfOrM1382_COUNT (4)
# define SETUP_XfOrM1382(x) SETUP(XfOrM1382_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prim = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 7522 "bc/src/fun.c"
  prim = FUNCCALL(SETUP_XfOrM1382(_), scheme_make_closed_prim (f , data ) ); 
  a [0 ] = prim ; 
  a [1 ] = scheme_default_prompt_tag ; 
  a [2 ] = propagate_abort_prim ; 

  if (multi ) {
#   define XfOrM1384_COUNT (0+XfOrM1382_COUNT)
#   define SETUP_XfOrM1384(x) SETUP_XfOrM1382(x)

# 7528 "bc/src/fun.c"
    if (top_level )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1384(_), scheme_apply_multi (call_with_prompt_proc , 3 , a ) )) RET_VALUE_END ; 
    else 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1384(_), scheme_do_eval (call_with_prompt_proc , 3 , a , - 1 ) )) RET_VALUE_END ; 
  }

# 7532 "bc/src/fun.c"
  else {
#   define XfOrM1383_COUNT (0+XfOrM1382_COUNT)
#   define SETUP_XfOrM1383(x) SETUP_XfOrM1382(x)

# 7533 "bc/src/fun.c"
    if (top_level )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1383(_), scheme_apply (call_with_prompt_proc , 3 , a ) )) RET_VALUE_END ; 
    else 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1383(_), scheme_do_eval (call_with_prompt_proc , 3 , a , 1 ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7540 "bc/src/fun.c"
Scheme_Object * scheme_call_with_prompt (Scheme_Closed_Prim f , void * data ) 
{
  /* No conversion */

# 7542 "bc/src/fun.c"
  return do_call_with_prompt (f , data , 0 , 1 ) ; 
}

Scheme_Object * scheme_call_with_prompt_multi (Scheme_Closed_Prim f , void * data ) 
{
  /* No conversion */

# 7547 "bc/src/fun.c"
  return do_call_with_prompt (f , data , 1 , 1 ) ; 
}

Scheme_Object * _scheme_call_with_prompt (Scheme_Closed_Prim f , void * data ) 
{
  /* No conversion */

# 7552 "bc/src/fun.c"
  return do_call_with_prompt (f , data , 0 , 0 ) ; 
}

Scheme_Object * _scheme_call_with_prompt_multi (Scheme_Closed_Prim f , void * data ) 
{
  /* No conversion */

# 7557 "bc/src/fun.c"
  return do_call_with_prompt (f , data , 1 , 0 ) ; 
}

Scheme_Object * scheme_compose_continuation (Scheme_Cont * cont , int num_rands , Scheme_Object * value ) 
{
  Scheme_Meta_Continuation * mc ; 
  int empty_to_next_mc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(mc, 0), PUSH(value, 1), PUSH(cont, 2)));
# define XfOrM1389_COUNT (3)
# define SETUP_XfOrM1389(x) SETUP(XfOrM1389_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  mc = NULLED_OUT ; 

# 7565 "bc/src/fun.c"
  if (num_rands != 1 ) {
#   define XfOrM1404_COUNT (0+XfOrM1389_COUNT)
#   define SETUP_XfOrM1404(x) SETUP_XfOrM1389(x)

# 7566 "bc/src/fun.c"
    value = FUNCCALL(SETUP_XfOrM1404(_), scheme_values (num_rands , (Scheme_Object * * ) value ) ); 
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
    }
  }
  cont -> value = value ; 
  cont -> common_dw_depth = - 1 ; 

  mc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation ; 
  if (mc && mc -> pseudo && mc -> meta_tail_pos == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) {






    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    Scheme_Object * cm_info ; 
    intptr_t findpos , bottom , pos ; 
    int count , mcount , i ; 
    BLOCK_SETUP((PUSH(cm_info, 0+XfOrM1389_COUNT), PUSH(p, 1+XfOrM1389_COUNT)));
#   define XfOrM1395_COUNT (2+XfOrM1389_COUNT)
#   define SETUP_XfOrM1395(x) SETUP(XfOrM1395_COUNT)
    cm_info = NULLED_OUT ; 

# 7589 "bc/src/fun.c"
    p -> meta_continuation = mc -> next ; 

    bottom = (intptr_t ) p -> cont_mark_stack_bottom ; 
    count = 0 ; 
    for (findpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) - 1 ; findpos >= bottom ; findpos -- ) {
      GC_CAN_IGNORE Scheme_Cont_Mark * seg ; 

      seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
      pos = findpos & ((1 << 6 ) - 1 ) ; 
      if (seg [pos ] . pos != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) )
        break ; 
      count ++ ; 
    }
    mcount = 0 ; 
    for (findpos = (intptr_t ) mc -> cont_mark_total ; findpos -- ; ) {
      if (mc -> cont_mark_stack_copied [findpos ] . pos != mc -> cont_mark_pos )
        break ; 
      mcount ++ ; 
    }

    cm_info = FUNCCALL(SETUP_XfOrM1395(_), scheme_make_vector ((count + mcount ) * 2 , ((void * ) 0 ) ) ); 
    for (findpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) - 1 , i = 0 ; i < count ; findpos -- , i ++ ) {
      GC_CAN_IGNORE Scheme_Cont_Mark * seg ; 

      seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
      pos = findpos & ((1 << 6 ) - 1 ) ; 
      (((Scheme_Vector * ) (cm_info ) ) -> els ) [2 * i ] = seg [pos ] . key ; 
      (((Scheme_Vector * ) (cm_info ) ) -> els ) [(2 * i ) + 1 ] = seg [pos ] . val ; 
    }
    for (findpos = (intptr_t ) mc -> cont_mark_total - 1 , i = 0 ; i < mcount ; findpos -- , i ++ ) {
      (((Scheme_Vector * ) (cm_info ) ) -> els ) [2 * (count + i ) ] = mc -> cont_mark_stack_copied [findpos ] . key ; 
      (((Scheme_Vector * ) (cm_info ) ) -> els ) [(2 * (count + i ) ) + 1 ] = mc -> cont_mark_stack_copied [findpos ] . val ; 
    }

    p -> cjs . jumping_to_continuation = cm_info ; 
    p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
    p -> cjs . val = (Scheme_Object * ) cont ; 
    p -> cjs . num_vals = 1 ; 
    p -> cjs . is_escape = 1 ; 
    p -> cjs . skip_dws = 0 ; 

    p -> stack_start = mc -> overflow -> stack_start ; 
    p -> decompose_mc = mc ; 
    FUNCCALL(SETUP_XfOrM1395(_), scheme_longjmpup (& mc -> overflow -> jmp -> cont ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 7635 "bc/src/fun.c"
  else if (mc && mc -> meta_tail_pos == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) {
    empty_to_next_mc = 1 ; 
  }

# 7637 "bc/src/fun.c"
  else {
    empty_to_next_mc = 0 ; 
  }


  mc = ((void * ) 0 ) ; 

  value = FUNCCALL(SETUP_XfOrM1389(_), compose_continuation (cont , 0 , ((void * ) 0 ) , empty_to_next_mc ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> next_meta -= 1 ; 

  if (! value ) {


    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM1390_COUNT (0+XfOrM1389_COUNT)
#   define SETUP_XfOrM1390(x) SETUP_XfOrM1389(x)

# 7652 "bc/src/fun.c"
    if (p -> cjs . is_escape ) {
#     define XfOrM1392_COUNT (0+XfOrM1390_COUNT)
#     define SETUP_XfOrM1392(x) SETUP_XfOrM1390(x)
      FUNCCALL(SETUP_XfOrM1392(_), continue_prompt_escape () ); 
    }

# 7656 "bc/src/fun.c"
    else {
      (((intptr_t * ) (void * ) ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs ) ) [1 ] = (* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs , longjmp ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . jb , 1 ) ) ; 
    }
  }

  RET_VALUE_START (value ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7664 "bc/src/fun.c"
static Scheme_Object * do_abort_continuation (int argc , Scheme_Object * argv [] , int skip_dws ) 
{
  Scheme_Object * prompt_tag ; 
  Scheme_Prompt * prompt ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * a [1 ] ; 
  Scheme_Object * * vals ; 
  int is_chaperoned = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(p, 1), PUSH(argv, 2), PUSH(vals, 3), PUSH(prompt, 4), PUSHARRAY(a, 1, 5)));
# define XfOrM1406_COUNT (8)
# define SETUP_XfOrM1406(x) SETUP(XfOrM1406_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt_tag = NULLED_OUT ; 
  prompt = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  vals = NULLED_OUT ; 

# 7673 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
#   define XfOrM1415_COUNT (0+XfOrM1406_COUNT)
#   define SETUP_XfOrM1415(x) SETUP_XfOrM1406(x)

# 7675 "bc/src/fun.c"
    if ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
      is_chaperoned = 1 ; 
      prompt_tag = (((Scheme_Chaperone * ) argv [0 ] ) -> val ) ; 
    }

# 7679 "bc/src/fun.c"
    else {
#     define XfOrM1416_COUNT (0+XfOrM1415_COUNT)
#     define SETUP_XfOrM1416(x) SETUP_XfOrM1415(x)
      FUNCCALL(SETUP_XfOrM1416(_), scheme_wrong_contract ("abort-current-continuation" , "continuation-prompt-tag?" , 0 , argc , argv ) )
# 7681 "bc/src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 7684 "bc/src/fun.c"
  else 
  prompt_tag = argv [0 ] ; 

  if ((prompt_tag ) == (scheme_root_prompt_tag ) )  {
#   define XfOrM1414_COUNT (0+XfOrM1406_COUNT)
#   define SETUP_XfOrM1414(x) SETUP_XfOrM1406(x)
    FUNCCALL(SETUP_XfOrM1414(_), root_prompt_tag_misuse ("abort-current-continuation" ) )
# 7688 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  prompt = (Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1406(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) ); 
  if (! prompt && ((scheme_default_prompt_tag ) == (prompt_tag ) ) )
    prompt = original_default_prompt ; 

  if (! prompt ) {
#   define XfOrM1413_COUNT (0+XfOrM1406_COUNT)
#   define SETUP_XfOrM1413(x) SETUP_XfOrM1406(x)
    FUNCCALL(SETUP_XfOrM1413(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "abort-current-continuation: continuation includes no prompt with the given tag\n" "  tag: %V" , prompt_tag ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc == 2 ) {
#   define XfOrM1411_COUNT (0+XfOrM1406_COUNT)
#   define SETUP_XfOrM1411(x) SETUP_XfOrM1406(x)

# 7705 "bc/src/fun.c"
    p -> cjs . num_vals = 1 ; 





    if (! is_chaperoned )
      p -> cjs . val = argv [1 ] ; 
    else {
#     define XfOrM1412_COUNT (0+XfOrM1411_COUNT)
#     define SETUP_XfOrM1412(x) SETUP_XfOrM1411(x)

# 7714 "bc/src/fun.c"
      a [0 ] = argv [1 ] ; 
      vals = FUNCCALL(SETUP_XfOrM1412(_), chaperone_do_abort (argv [0 ] , 1 , a ) ); 
      p -> cjs . val = (Scheme_Object * ) vals [0 ] ; 
    }
  }

# 7718 "bc/src/fun.c"
  else {
    int i ; 
#   define XfOrM1407_COUNT (0+XfOrM1406_COUNT)
#   define SETUP_XfOrM1407(x) SETUP_XfOrM1406(x)

# 7720 "bc/src/fun.c"
    vals = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1407(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
    for (i = argc ; i -- > 1 ; ) {
      vals [i - 1 ] = argv [i ] ; 
    }
    p -> cjs . num_vals = argc - 1 ; 
    if (! is_chaperoned )
      p -> cjs . val = (Scheme_Object * ) vals ; 
    else {
#     define XfOrM1408_COUNT (0+XfOrM1407_COUNT)
#     define SETUP_XfOrM1408(x) SETUP_XfOrM1407(x)

# 7728 "bc/src/fun.c"
      vals = FUNCCALL(SETUP_XfOrM1408(_), chaperone_do_abort (argv [0 ] , argc - 1 , vals ) ); 
      p -> cjs . val = (Scheme_Object * ) vals ; 
    }
  }
  p -> cjs . jumping_to_continuation = (Scheme_Object * ) prompt ; 
  p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
  p -> cjs . skip_dws = skip_dws ; 

  (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7741 "bc/src/fun.c"
static Scheme_Object * abort_continuation (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7743 "bc/src/fun.c"
  return do_abort_continuation (argc , argv , 0 ) ; 
}

Scheme_Object * scheme_abort_continuation_no_dws (Scheme_Object * pt , Scheme_Object * v ) 
{


  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM1419_COUNT (3)
# define SETUP_XfOrM1419(x) SETUP(XfOrM1419_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 7752 "bc/src/fun.c"
  a [0 ] = pt ; 
  a [1 ] = v ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1419(_), do_abort_continuation (2 , a , 1 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7758 "bc/src/fun.c"
static Scheme_Object * unsafe_abort_continuation_no_dws (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */
  return do_abort_continuation (argc , argv , 1 ) ; 
}

static Scheme_Object * do_call_with_control (int argc , Scheme_Object * argv [] , int no_dws ) 
{
  Scheme_Object * prompt_tag ; 
  Scheme_Object * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(argv, 1), PUSHARRAY(a, 3, 2)));
# define XfOrM1421_COUNT (5)
# define SETUP_XfOrM1421(x) SETUP(XfOrM1421_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt_tag = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1421(_), scheme_check_proc_arity ("call-with-composable-continuation" , 1 , 0 , argc , argv ) )
# 7769 "bc/src/fun.c"
  ; 
  if (argc > 1 ) {
#   define XfOrM1422_COUNT (0+XfOrM1421_COUNT)
#   define SETUP_XfOrM1422(x) SETUP_XfOrM1421(x)

# 7771 "bc/src/fun.c"
    prompt_tag = argv [1 ] ; 
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) ) ) {
#     define XfOrM1424_COUNT (0+XfOrM1422_COUNT)
#     define SETUP_XfOrM1424(x) SETUP_XfOrM1422(x)

# 7773 "bc/src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) prompt_tag ) -> val ) ; 
      else {
#       define XfOrM1425_COUNT (0+XfOrM1424_COUNT)
#       define SETUP_XfOrM1425(x) SETUP_XfOrM1424(x)
        FUNCCALL(SETUP_XfOrM1425(_), scheme_wrong_contract ("call-with-composable-continuation" , "continuation-prompt-tag?" , 1 , argc , argv ) )
# 7778 "bc/src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
    if ((prompt_tag ) == (scheme_root_prompt_tag ) )  {
#     define XfOrM1423_COUNT (0+XfOrM1422_COUNT)
#     define SETUP_XfOrM1423(x) SETUP_XfOrM1422(x)
      FUNCCALL(SETUP_XfOrM1423(_), root_prompt_tag_misuse ("abort-current-continuation" ) )
# 7783 "bc/src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 7786 "bc/src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  a [0 ] = argv [0 ] ; 
  a [1 ] = prompt_tag ; 
  a [2 ] = (no_dws ? scheme_true : scheme_false ) ; 



  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1421(_), scheme_tail_apply (internal_call_cc_prim , 3 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7798 "bc/src/fun.c"
static Scheme_Object * call_with_control (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7800 "bc/src/fun.c"
  return do_call_with_control (argc , argv , 0 ) ; 
}

Scheme_Object * scheme_call_with_composable_no_dws (Scheme_Object * proc , Scheme_Object * pt ) 
{

  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM1427_COUNT (3)
# define SETUP_XfOrM1427(x) SETUP(XfOrM1427_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 7808 "bc/src/fun.c"
  a [0 ] = proc ; 
  a [1 ] = pt ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1427(_), do_call_with_control (2 , a , 1 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7814 "bc/src/fun.c"
static Scheme_Object * unsafe_call_with_control_no_dws (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */
  return do_call_with_control (argc , argv , 1 ) ; 
}

static Scheme_Object * unsafe_root_continuation_prompt_tag (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7822 "bc/src/fun.c"
  return scheme_root_prompt_tag ; 
}

static Scheme_Cont_Mark * copy_cm_shared_on_write (Scheme_Meta_Continuation * mc ) 
{
  Scheme_Cont_Mark * cp ; 
  DECL_RET_SAVE (Scheme_Cont_Mark * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(mc, 0), PUSH(cp, 1)));
# define XfOrM1430_COUNT (2)
# define SETUP_XfOrM1430(x) SETUP(XfOrM1430_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cp = NULLED_OUT ; 

# 7829 "bc/src/fun.c"
  cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM1430(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (mc -> cont_mark_total ) ) )) ; 
  (memcpy (cp , mc -> cont_mark_stack_copied , mc -> cont_mark_total * sizeof (Scheme_Cont_Mark ) ) ) ; 
  mc -> cont_mark_stack_copied = cp ; 
  mc -> cm_shared = 0 ; 

  RET_VALUE_START (cp ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7837 "bc/src/fun.c"
static Scheme_Object * continuation_marks (Scheme_Thread * p , 
Scheme_Object * _cont , 
Scheme_Object * econt , 
Scheme_Meta_Continuation * mc , 
Scheme_Object * prompt_tag , 
const char * who , 
int just_chain , 
int use_boundary_prompt ) 

{
  Scheme_Cont * cont = (Scheme_Cont * ) _cont , * top_cont ; 
  Scheme_Cont_Mark_Chain * first = ((void * ) 0 ) , * last = ((void * ) 0 ) ; 
  Scheme_Cont_Mark_Set * set ; 
  Scheme_Object * cache , * nt ; 
  intptr_t findpos , bottom ; 
  intptr_t cmpos , first_cmpos = 0 , cdelta = 0 ; 
  int found_tag = 0 , at_mc_boundary = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(set, 0), PUSH(cache, 1), PUSH(prompt_tag, 2), PUSH(cont, 3), PUSH(who, 4), PUSH(mc, 5), PUSH(last, 6), PUSH(econt, 7), PUSH(first, 8), PUSH(top_cont, 9), PUSH(p, 10), PUSH(nt, 11)));
# define XfOrM1431_COUNT (12)
# define SETUP_XfOrM1431(x) SETUP(XfOrM1431_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  top_cont = NULLED_OUT ; 
  set = NULLED_OUT ; 
  cache = NULLED_OUT ; 
  nt = NULLED_OUT ; 

# 7855 "bc/src/fun.c"
  if ((prompt_tag ) == (scheme_root_prompt_tag ) ) 
    prompt_tag = ((void * ) 0 ) ; 

  if (cont 
  && (use_boundary_prompt || ! cont -> composable ) 
  && ((cont -> prompt_tag ) == (prompt_tag ) ) )
    found_tag = 1 ; 
  if (! prompt_tag )
    found_tag = 1 ; 

  do {
#   define XfOrM1512_COUNT (0+XfOrM1431_COUNT)
#   define SETUP_XfOrM1512(x) SETUP_XfOrM1431(x)

# 7866 "bc/src/fun.c"
    if (econt ) {
      findpos = (intptr_t ) ((Scheme_Escaping_Cont * ) econt ) -> envss . cont_mark_stack ; 
      cmpos = (intptr_t ) ((Scheme_Escaping_Cont * ) econt ) -> envss . cont_mark_pos ; 
      if (mc ) {
        cdelta = mc -> cont_mark_offset ; 
        bottom = 0 ; 
      }

# 7872 "bc/src/fun.c"
      else 
      bottom = p -> cont_mark_stack_bottom ; 
    }

# 7874 "bc/src/fun.c"
    else if (cont ) {
      findpos = (intptr_t ) cont -> ss . cont_mark_stack ; 
      cmpos = (intptr_t ) cont -> ss . cont_mark_pos ; 
      cdelta = cont -> cont_mark_offset ; 
      bottom = 0 ; 
    }

# 7879 "bc/src/fun.c"
    else if (mc ) {
      findpos = (intptr_t ) mc -> cont_mark_stack ; 
      cmpos = (intptr_t ) mc -> cont_mark_pos ; 
      cdelta = mc -> cont_mark_offset ; 
      bottom = 0 ; 
      at_mc_boundary = 1 ; 
    }

# 7885 "bc/src/fun.c"
    else {
      findpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
      cmpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 
      if (! p -> cont_mark_stack_segments )
        findpos = 0 ; 
      bottom = p -> cont_mark_stack_bottom ; 
    }

    top_cont = cont ; 

    while (findpos -- > bottom ) {
      Scheme_Cont_Mark * find ; 
      intptr_t pos ; 
      BLOCK_SETUP((PUSH(find, 0+XfOrM1512_COUNT)));
#     define XfOrM1549_COUNT (1+XfOrM1512_COUNT)
#     define SETUP_XfOrM1549(x) SETUP(XfOrM1549_COUNT)
      find = NULLED_OUT ; 

# 7899 "bc/src/fun.c"
      if (cont ) {
        while (findpos < cdelta ) {
          if (! cont -> runstack_copied ) {


            cont = cont -> buf_ptr -> buf . cont ; 
          }
          cont = cont -> buf_ptr -> buf . cont ; 
          if (cont )
            cdelta = cont -> cont_mark_offset ; 
          else 
          break ; 
        }
        if (! cont )
          break ; 
        find = cont -> cont_mark_stack_copied ; 
        pos = findpos - cdelta ; 
      }

# 7916 "bc/src/fun.c"
      else if (mc ) {
        if (findpos < cdelta )
          break ; 
        find = mc -> cont_mark_stack_copied ; 
        pos = findpos - cdelta ; 
      }

# 7921 "bc/src/fun.c"
      else {
        GC_CAN_IGNORE Scheme_Cont_Mark * seg ; 

        seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
        pos = findpos & ((1 << 6 ) - 1 ) ; 
        find = seg ; 
      }

# 7943 "bc/src/fun.c"
      if (prompt_tag && (find [pos ] . key == (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) ) {
        found_tag = 1 ; 

        mc = ((void * ) 0 ) ; 
        p = ((void * ) 0 ) ; 
        econt = ((void * ) 0 ) ; 
        cont = ((void * ) 0 ) ; 
        top_cont = ((void * ) 0 ) ; 
        break ; 
      }

      cache = find [pos ] . cache ; 
      if (cache ) {
#       define XfOrM1570_COUNT (0+XfOrM1549_COUNT)
#       define SETUP_XfOrM1570(x) SETUP_XfOrM1549(x)

# 7956 "bc/src/fun.c"
        if (((cache ) ) == (scheme_false ) ) 
          cache = ((void * ) 0 ) ; 
        if (cache ) {
#         define XfOrM1572_COUNT (0+XfOrM1570_COUNT)
#         define SETUP_XfOrM1572(x) SETUP_XfOrM1570(x)

# 7959 "bc/src/fun.c"
          if ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
            cache = (scheme_eq_hash_get ((Scheme_Hash_Table * ) cache , prompt_tag ? prompt_tag : scheme_false ) ) ; 
          else if (prompt_tag != scheme_default_prompt_tag )
            cache = ((void * ) 0 ) ; 
        }
        if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
          cache = (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] ; 
        }
      }

      if (cache ) {
        if (((Scheme_Cont_Mark_Chain * ) cache ) -> key ) {
          if (last ) {
            last -> next = (Scheme_Cont_Mark_Chain * ) cache ; 
            if (at_mc_boundary ) {
              (& (last ) -> iso ) -> so . keyex |= 0x1 ; 
              at_mc_boundary = 0 ; 
            }
          }

# 7977 "bc/src/fun.c"
          else {
            first = (Scheme_Cont_Mark_Chain * ) cache ; 
            first_cmpos = cmpos ; 
          }

          found_tag = 1 ; 
        }

# 7983 "bc/src/fun.c"
        else {
        }



        mc = ((void * ) 0 ) ; 
        p = ((void * ) 0 ) ; 
        econt = ((void * ) 0 ) ; 
        cont = ((void * ) 0 ) ; 
        top_cont = ((void * ) 0 ) ; 

        break ; 
      }

# 7995 "bc/src/fun.c"
      else {
        Scheme_Cont_Mark_Chain * pr ; 
        BLOCK_SETUP((PUSH(pr, 0+XfOrM1549_COUNT)));
#       define XfOrM1550_COUNT (1+XfOrM1549_COUNT)
#       define SETUP_XfOrM1550(x) SETUP(XfOrM1550_COUNT)
        pr = NULLED_OUT ; 

# 7997 "bc/src/fun.c"
        pr = ((Scheme_Cont_Mark_Chain * ) FUNCCALL(SETUP_XfOrM1550(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont_Mark_Chain ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        pr -> iso . so . type = scheme_cont_mark_chain_type ; 
        pr -> key = find [pos ] . key ; 
        pr -> val = find [pos ] . val ; 
        pr -> pos = find [pos ] . pos ; 
        pr -> next = ((void * ) 0 ) ; 
        if (mc ) {
#         define XfOrM1563_COUNT (0+XfOrM1550_COUNT)
#         define SETUP_XfOrM1563(x) SETUP_XfOrM1550(x)

# 8004 "bc/src/fun.c"
          if (mc -> cm_shared )
            find = FUNCCALL(SETUP_XfOrM1563(_), copy_cm_shared_on_write (mc ) ); 
          mc -> cm_caches = 1 ; 
        }
        cache = find [pos ] . cache ; 
        if (cache && ! (((cache ) ) == (scheme_false ) ) ) {
#         define XfOrM1556_COUNT (0+XfOrM1550_COUNT)
#         define SETUP_XfOrM1556(x) SETUP_XfOrM1550(x)

# 8010 "bc/src/fun.c"
          if ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
            Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) cache ; 
#           define XfOrM1560_COUNT (0+XfOrM1556_COUNT)
#           define SETUP_XfOrM1560(x) SETUP_XfOrM1556(x)

# 8012 "bc/src/fun.c"
            cache = (scheme_eq_hash_get (ht , prompt_tag ? prompt_tag : scheme_false ) ) ; 
            if (! cache ) {
#             define XfOrM1562_COUNT (0+XfOrM1560_COUNT)
#             define SETUP_XfOrM1562(x) SETUP_XfOrM1560(x)
              FUNCCALL(SETUP_XfOrM1562(_), scheme_hash_set (ht , prompt_tag ? prompt_tag : scheme_false , (Scheme_Object * ) pr ) )
# 8014 "bc/src/fun.c"
              ; 
            }

# 8015 "bc/src/fun.c"
            else {

              (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] = (Scheme_Object * ) pr ; 
            }
          }

# 8019 "bc/src/fun.c"
          else if (! ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {

            Scheme_Hash_Table * ht ; 
            BLOCK_SETUP((PUSH(ht, 0+XfOrM1556_COUNT)));
#           define XfOrM1559_COUNT (1+XfOrM1556_COUNT)
#           define SETUP_XfOrM1559(x) SETUP(XfOrM1559_COUNT)
            ht = NULLED_OUT ; 

# 8022 "bc/src/fun.c"
            ht = FUNCCALL(SETUP_XfOrM1559(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (ht , scheme_default_prompt_tag , cache ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (ht , prompt_tag ? prompt_tag : scheme_false , (Scheme_Object * ) pr ) ); 
            find [pos ] . cache = (Scheme_Object * ) ht ; 
          }

# 8026 "bc/src/fun.c"
          else {
#           define XfOrM1557_COUNT (0+XfOrM1556_COUNT)
#           define SETUP_XfOrM1557(x) SETUP_XfOrM1556(x)

# 8028 "bc/src/fun.c"
            if (prompt_tag == scheme_default_prompt_tag )
              (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] = (Scheme_Object * ) pr ; 
            else {



              Scheme_Hash_Table * ht ; 
              Scheme_Object * vec ; 
              BLOCK_SETUP((PUSH(ht, 0+XfOrM1557_COUNT), PUSH(vec, 1+XfOrM1557_COUNT)));
#             define XfOrM1558_COUNT (2+XfOrM1557_COUNT)
#             define SETUP_XfOrM1558(x) SETUP(XfOrM1558_COUNT)
              ht = NULLED_OUT ; 
              vec = NULLED_OUT ; 

# 8036 "bc/src/fun.c"
              ht = FUNCCALL(SETUP_XfOrM1558(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
              vec = FUNCCALL_AGAIN(scheme_make_vector (4 , ((void * ) 0 ) ) ); 
              (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ; 
              (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
              (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] ; 
              FUNCCALL(SETUP_XfOrM1558(_), scheme_hash_set (ht , scheme_false , vec ) ); 
              if (! prompt_tag )
                (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = (Scheme_Object * ) pr ; 
              else FUNCCALL(SETUP_XfOrM1558(_), scheme_hash_set (ht , prompt_tag , (Scheme_Object * ) pr ) )
              ; 
              find [pos ] . cache = (Scheme_Object * ) ht ; 
            }
          }
        }

# 8049 "bc/src/fun.c"
        else if (prompt_tag == scheme_default_prompt_tag ) {
          find [pos ] . cache = (Scheme_Object * ) pr ; 
        }

# 8051 "bc/src/fun.c"
        else {
#         define XfOrM1554_COUNT (0+XfOrM1550_COUNT)
#         define SETUP_XfOrM1554(x) SETUP_XfOrM1550(x)

# 8052 "bc/src/fun.c"
          cache = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM1554(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
          FUNCCALL(SETUP_XfOrM1554(_), scheme_hash_set ((Scheme_Hash_Table * ) cache , prompt_tag ? prompt_tag : scheme_false , (Scheme_Object * ) pr ) )

          ; 
          find [pos ] . cache = cache ; 
        }
        if (last ) {
          last -> next = pr ; 
          if (at_mc_boundary ) {
            (& (last ) -> iso ) -> so . keyex |= 1 ; 
            at_mc_boundary = 0 ; 
          }
        }

# 8064 "bc/src/fun.c"
        else {
          first = pr ; 
          first_cmpos = cmpos ; 
        }

        last = pr ; 
      }
    }

    if (mc ) {
      mc = mc -> next ; 
    }

# 8075 "bc/src/fun.c"
    else if (top_cont ) {
      mc = top_cont -> meta_continuation ; 
    }

# 8077 "bc/src/fun.c"
    else if (econt ) {
      mc = p -> meta_continuation ; 
    }

# 8079 "bc/src/fun.c"
    else if (p ) {
      mc = p -> meta_continuation ; 
    }
    cont = ((void * ) 0 ) ; 
    econt = ((void * ) 0 ) ; 
    p = ((void * ) 0 ) ; 
  }

# 8085 "bc/src/fun.c"
  while (mc ) ; 

  if (! found_tag ) {
#   define XfOrM1433_COUNT (0+XfOrM1431_COUNT)
#   define SETUP_XfOrM1433(x) SETUP_XfOrM1431(x)

# 8088 "bc/src/fun.c"
    if (! ((prompt_tag ) == (scheme_default_prompt_tag ) ) ) {
#     define XfOrM1435_COUNT (0+XfOrM1433_COUNT)
#     define SETUP_XfOrM1435(x) SETUP_XfOrM1433(x)

      while (first ) {
        first -> key = ((void * ) 0 ) ; 
        first = first -> next ; 
      }
      if (! who )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "%s: no corresponding prompt in the continuation\n" "  tag: %V" , who , prompt_tag ) )


      ; 
    }

# 8102 "bc/src/fun.c"
    else if (! use_boundary_prompt ) {

      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (just_chain )
    RET_VALUE_START ((Scheme_Object * ) first ) RET_VALUE_END ; 









  nt = ((void * ) 0 ) ; 


  if (first && (first_cmpos < first -> pos ) ) {
#   define XfOrM1432_COUNT (0+XfOrM1431_COUNT)
#   define SETUP_XfOrM1432(x) SETUP_XfOrM1431(x)
    FUNCCALL(SETUP_XfOrM1432(_), scheme_log_abort ("internal error: bad mark-stack position" ) ); 
    FUNCCALL(SETUP_XfOrM1432(_), abort () ); 
  }

  set = ((Scheme_Cont_Mark_Set * ) FUNCCALL(SETUP_XfOrM1431(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont_Mark_Set ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  set -> so . type = scheme_cont_mark_set_type ; 
  set -> chain = first ; 
  set -> cmpos = first_cmpos ; 
  set -> native_stack_trace = nt ; 

  RET_VALUE_START ((Scheme_Object * ) set ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8138 "bc/src/fun.c"
static Scheme_Object * make_empty_marks () 
{

  Scheme_Cont_Mark_Set * set ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(set, 0)));
# define XfOrM1586_COUNT (1)
# define SETUP_XfOrM1586(x) SETUP(XfOrM1586_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  set = NULLED_OUT ; 

# 8143 "bc/src/fun.c"
  set = ((Scheme_Cont_Mark_Set * ) FUNCCALL(SETUP_XfOrM1586(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont_Mark_Set ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  set -> so . type = scheme_cont_mark_set_type ; 
  set -> chain = ((void * ) 0 ) ; 
  set -> cmpos = 1 ; 
  set -> native_stack_trace = ((void * ) 0 ) ; 

  RET_VALUE_START ((Scheme_Object * ) set ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8152 "bc/src/fun.c"
Scheme_Object * scheme_current_continuation_marks_as (const char * who , Scheme_Object * prompt_tag ) 

{
  /* No conversion */

# 8155 "bc/src/fun.c"
  return continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 
  prompt_tag ? prompt_tag : scheme_default_prompt_tag , 
  who , 
  0 , 1 ) ; 
}

Scheme_Object * scheme_current_continuation_marks (Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 8163 "bc/src/fun.c"
  return scheme_current_continuation_marks_as ("continuation-marks" , prompt_tag ) ; 
}

Scheme_Object * scheme_all_current_continuation_marks () 
{
  /* No conversion */

# 8168 "bc/src/fun.c"
  return continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 
  ((void * ) 0 ) , 
  "continuation-marks" , 
  0 , 1 ) ; 
}

Scheme_Cont_Mark_Chain * current_mark_chain (const char * who , Scheme_Object * prompt_tag ) {
  /* No conversion */

# 8175 "bc/src/fun.c"
  return (Scheme_Cont_Mark_Chain * ) continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 
  prompt_tag , 
  who , 
  1 , 1 ) ; 
}

static Scheme_Object * 
cc_marks (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * prompt_tag ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0)));
# define XfOrM1591_COUNT (1)
# define SETUP_XfOrM1591(x) SETUP(XfOrM1591_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt_tag = NULLED_OUT ; 

# 8186 "bc/src/fun.c"
  if (argc ) {
#   define XfOrM1592_COUNT (0+XfOrM1591_COUNT)
#   define SETUP_XfOrM1592(x) SETUP_XfOrM1591(x)

# 8187 "bc/src/fun.c"
    prompt_tag = argv [0 ] ; 
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) ) ) {
#     define XfOrM1594_COUNT (0+XfOrM1592_COUNT)
#     define SETUP_XfOrM1594(x) SETUP_XfOrM1592(x)

# 8189 "bc/src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) prompt_tag ) -> val ) ; 
      else FUNCCALL_EMPTY(scheme_wrong_contract ("current-continuation-marks" , "continuation-prompt-tag?" , 0 , argc , argv ) )

      ; 
    }

    if (! ((scheme_default_prompt_tag ) == (prompt_tag ) ) 
    && ! ((scheme_root_prompt_tag ) == (prompt_tag ) ) )
      if (! FUNCCALL(SETUP_XfOrM1592(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) )) {
#     define XfOrM1593_COUNT (0+XfOrM1592_COUNT)
#     define SETUP_XfOrM1593(x) SETUP_XfOrM1592(x)
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "current-continuation-marks: no corresponding prompt in the continuation\n" "  prompt tag: %V" , prompt_tag ) )
      ; 
    }
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_current_continuation_marks (argc ? prompt_tag : ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8210 "bc/src/fun.c"
static Scheme_Object * 
cont_marks (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * prompt_tag ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(argv, 1)));
# define XfOrM1595_COUNT (2)
# define SETUP_XfOrM1595(x) SETUP(XfOrM1595_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  prompt_tag = NULLED_OUT ; 

# 8215 "bc/src/fun.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-marks" , "(or/c continuation? thread? #f)" , 0 , argc , argv ) ); 

  if (argc > 1 ) {
#   define XfOrM1608_COUNT (0+XfOrM1595_COUNT)
#   define SETUP_XfOrM1608(x) SETUP_XfOrM1595(x)

# 8220 "bc/src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) ) ) {
#     define XfOrM1609_COUNT (0+XfOrM1608_COUNT)
#     define SETUP_XfOrM1609(x) SETUP_XfOrM1608(x)

# 8221 "bc/src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) argv [1 ] ) -> val ) ; 
      else {
#       define XfOrM1610_COUNT (0+XfOrM1609_COUNT)
#       define SETUP_XfOrM1610(x) SETUP_XfOrM1609(x)
        FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-marks" , "continuation-prompt-tag?" , 1 , argc , argv ) )
# 8226 "bc/src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 8229 "bc/src/fun.c"
    else 
    prompt_tag = argv [1 ] ; 
  }

# 8231 "bc/src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (((argv [0 ] ) ) == (scheme_false ) )  {
#   define XfOrM1607_COUNT (0+XfOrM1595_COUNT)
#   define SETUP_XfOrM1607(x) SETUP_XfOrM1595(x)

# 8235 "bc/src/fun.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_empty_marks () )) RET_VALUE_EMPTY_END ; 
  }

# 8236 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) )  {
#   define XfOrM1604_COUNT (0+XfOrM1595_COUNT)
#   define SETUP_XfOrM1604(x) SETUP_XfOrM1595(x)

# 8237 "bc/src/fun.c"
    if (! FUNCCALL(SETUP_XfOrM1604(_), scheme_escape_continuation_ok (argv [0 ] ) )) {
#     define XfOrM1606_COUNT (0+XfOrM1604_COUNT)
#     define SETUP_XfOrM1606(x) SETUP_XfOrM1604(x)
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "continuation-marks: escape continuation not in the current thread's continuation\n" "  escape continuation: %V" , argv [0 ] ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 8242 "bc/src/fun.c"
    else {
      Scheme_Meta_Continuation * mc ; 
      BLOCK_SETUP((PUSH(mc, 0+XfOrM1604_COUNT)));
#     define XfOrM1605_COUNT (1+XfOrM1604_COUNT)
#     define SETUP_XfOrM1605(x) SETUP(XfOrM1605_COUNT)
      mc = NULLED_OUT ; 

# 8244 "bc/src/fun.c"
      mc = FUNCCALL(SETUP_XfOrM1605(_), scheme_get_meta_continuation (argv [0 ] ) ); 

      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , argv [0 ] , mc , prompt_tag , "continuation-marks" , 0 , 1 ) )) RET_VALUE_EMPTY_END 
      ; 
    }
  }

# 8249 "bc/src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) )  {
    Scheme_Thread * t = (Scheme_Thread * ) argv [0 ] ; 
    Scheme_Object * m ; 
    BLOCK_SETUP((PUSH(m, 0+XfOrM1595_COUNT), PUSH(t, 1+XfOrM1595_COUNT)));
#   define XfOrM1597_COUNT (2+XfOrM1595_COUNT)
#   define SETUP_XfOrM1597(x) SETUP(XfOrM1597_COUNT)
    m = NULLED_OUT ; 

# 8253 "bc/src/fun.c"
    while (t -> nestee ) {
      t = t -> nestee ; 
    }

    if ((t ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_current_continuation_marks (prompt_tag ) )) RET_VALUE_EMPTY_END ; 

    while (t -> return_marks_to ) {
#     define XfOrM1601_COUNT (0+XfOrM1597_COUNT)
#     define SETUP_XfOrM1601(x) SETUP_XfOrM1597(x)
      FUNCCALL(SETUP_XfOrM1601(_), scheme_thread_block (0.0 ) )
# 8261 "bc/src/fun.c"
      ; 
    }

    if (! (t -> running & 0x1 ) ) {
#     define XfOrM1599_COUNT (0+XfOrM1597_COUNT)
#     define SETUP_XfOrM1599(x) SETUP_XfOrM1597(x)

# 8265 "bc/src/fun.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_empty_marks () )) RET_VALUE_EMPTY_END ; 
    }

# 8266 "bc/src/fun.c"
    else {
#     define XfOrM1598_COUNT (0+XfOrM1597_COUNT)
#     define SETUP_XfOrM1598(x) SETUP_XfOrM1597(x)
      FUNCCALL(SETUP_XfOrM1598(_), scheme_start_atomic () )
# 8267 "bc/src/fun.c"
      ; 

      t -> return_marks_to = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      t -> returned_marks = prompt_tag ; 
      FUNCCALL(SETUP_XfOrM1598(_), scheme_swap_thread (t ) ); 

      m = t -> returned_marks ; 
      t -> returned_marks = ((void * ) 0 ) ; 
      FUNCCALL(SETUP_XfOrM1598(_), scheme_end_atomic_no_swap () )
      ; 

      if (! m )
        FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "%s: no corresponding prompt in the continuation\n" "  tag: %V" , "continuation-marks" , prompt_tag ) )


      ; 

      RET_VALUE_START (m ) RET_VALUE_END ; 
    }
  }

# 8286 "bc/src/fun.c"
  else {
#   define XfOrM1596_COUNT (0+XfOrM1595_COUNT)
#   define SETUP_XfOrM1596(x) SETUP_XfOrM1595(x)

# 8287 "bc/src/fun.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(continuation_marks (((void * ) 0 ) , argv [0 ] , ((void * ) 0 ) , ((void * ) 0 ) , prompt_tag , "continuation-marks" , 0 , 1 ) )) RET_VALUE_EMPTY_END 
    ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8292 "bc/src/fun.c"
static Scheme_Object * 
cc_marks_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8295 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) )
    return scheme_false ; 
  else 
  return scheme_true ; 
}

static Scheme_Object * 
extract_cc_marks (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Cont_Mark_Chain * chain ; 
  Scheme_Object * first = scheme_null , * last = ((void * ) 0 ) , * key , * prompt_tag ; 
  Scheme_Object * v ; 
  Scheme_Object * pr ; 
  int is_chaperoned = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(pr, 1), PUSH(last, 2), PUSH(chain, 3), PUSH(prompt_tag, 4), PUSH(argv, 5), PUSH(first, 6), PUSH(v, 7)));
# define XfOrM1612_COUNT (8)
# define SETUP_XfOrM1612(x) SETUP(XfOrM1612_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  chain = NULLED_OUT ; 
  key = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 
  v = NULLED_OUT ; 
  pr = NULLED_OUT ; 

# 8310 "bc/src/fun.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) ) {
#   define XfOrM1622_COUNT (0+XfOrM1612_COUNT)
#   define SETUP_XfOrM1622(x) SETUP_XfOrM1612(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-mark-set->list" , "(or/c continuation-mark-set? #f)" , 0 , argc , argv ) )
# 8312 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (argc > 2 ) {
#   define XfOrM1619_COUNT (0+XfOrM1612_COUNT)
#   define SETUP_XfOrM1619(x) SETUP_XfOrM1612(x)

# 8316 "bc/src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) ) ) {
#     define XfOrM1620_COUNT (0+XfOrM1619_COUNT)
#     define SETUP_XfOrM1620(x) SETUP_XfOrM1619(x)

# 8317 "bc/src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [2 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [2 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) argv [2 ] ) -> val ) ; 
      else {
#       define XfOrM1621_COUNT (0+XfOrM1620_COUNT)
#       define SETUP_XfOrM1621(x) SETUP_XfOrM1620(x)
        FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-mark-set->list" , "continuation-prompt-tag?" , 2 , argc , argv ) )
# 8322 "bc/src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 8325 "bc/src/fun.c"
    else 
    prompt_tag = argv [2 ] ; 
  }

# 8327 "bc/src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (((argv [0 ] ) ) == (scheme_false ) ) 
    chain = FUNCCALL(SETUP_XfOrM1612(_), current_mark_chain ("continuation-mark-set->list" , prompt_tag ) ); 
  else 
  chain = ((Scheme_Cont_Mark_Set * ) argv [0 ] ) -> chain ; 
  key = argv [1 ] ; 

  if ((key == scheme_parameterization_key ) 
  || (key == scheme_break_enabled_key ) 
  || (key == scheme_exn_handler_key ) ) {
#   define XfOrM1618_COUNT (0+XfOrM1612_COUNT)
#   define SETUP_XfOrM1618(x) SETUP_XfOrM1612(x)
    FUNCCALL_EMPTY(scheme_signal_error ("continuation-mark-set->list: secret key leaked!" ) )
# 8339 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if ((((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) {
    is_chaperoned = 1 ; 
    key = (((Scheme_Chaperone * ) key ) -> val ) ; 
  }

  prompt_tag = (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ; 

  while (chain ) {
#   define XfOrM1615_COUNT (0+XfOrM1612_COUNT)
#   define SETUP_XfOrM1615(x) SETUP_XfOrM1612(x)

# 8352 "bc/src/fun.c"
    if (chain -> key == key ) {
#     define XfOrM1616_COUNT (0+XfOrM1615_COUNT)
#     define SETUP_XfOrM1616(x) SETUP_XfOrM1615(x)

# 8353 "bc/src/fun.c"
      if (is_chaperoned )
        v = FUNCCALL(SETUP_XfOrM1616(_), scheme_chaperone_do_continuation_mark ("continuation-mark-set->list" , 1 , argv [1 ] , chain -> val ) )
      ; 
      else 
      v = chain -> val ; 
      pr = FUNCCALL(SETUP_XfOrM1616(_), scheme_make_pair (v , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pr ; 
      else 
      first = pr ; 
      last = pr ; 
    }

# 8364 "bc/src/fun.c"
    else if (chain -> key == prompt_tag )
      break ; 

    chain = chain -> next ; 
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8373 "bc/src/fun.c"
Scheme_Object * scheme_extract_cc_mark_list (Scheme_Object * mark_set , Scheme_Object * key , Scheme_Object * prompt_tag ) 
{
  Scheme_Object * argv [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(argv, 3, 0)));
# define XfOrM1623_COUNT (3)
# define SETUP_XfOrM1623(x) SETUP(XfOrM1623_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  argv[0] = NULLED_OUT ; 
  argv[1] = NULLED_OUT ; 
  argv[2] = NULLED_OUT ; 

# 8376 "bc/src/fun.c"
  argv [0 ] = (mark_set ? mark_set : scheme_false ) ; 
  argv [1 ] = key ; 
  argv [2 ] = prompt_tag ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1623(_), extract_cc_marks (3 , argv ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8382 "bc/src/fun.c"
static Scheme_Object * 
iterate_cc_markses (const char * who , 
Scheme_Object * prompt_tag , Scheme_Object * none , 
intptr_t len , Scheme_Object * * keys , 
Scheme_Cont_Mark_Chain * * _chain ) 
{
  Scheme_Cont_Mark_Chain * chain = * _chain ; 
  intptr_t last_pos = - 1 , i ; 
  Scheme_Object * vals = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(_chain, 0), PUSH(vals, 1), PUSH(keys, 2), PUSH(chain, 3), PUSH(prompt_tag, 4), PUSH(who, 5), PUSH(none, 6)));
# define XfOrM1624_COUNT (7)
# define SETUP_XfOrM1624(x) SETUP(XfOrM1624_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 8392 "bc/src/fun.c"
  prompt_tag = (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ; 

  while (chain ) {
#   define XfOrM1637_COUNT (0+XfOrM1624_COUNT)
#   define SETUP_XfOrM1637(x) SETUP_XfOrM1624(x)

# 8395 "bc/src/fun.c"
    if (vals && (last_pos != chain -> pos ) ) {
      * _chain = chain ; 
      RET_VALUE_START (vals ) RET_VALUE_END ; 
    }

    for (i = 0 ; i < len ; i ++ ) {
      int is_chaperoned = 0 ; 
      Scheme_Object * orig_key , * val ; 
      BLOCK_SETUP((PUSH(val, 0+XfOrM1637_COUNT), PUSH(orig_key, 1+XfOrM1637_COUNT)));
#     define XfOrM1643_COUNT (2+XfOrM1637_COUNT)
#     define SETUP_XfOrM1643(x) SETUP(XfOrM1643_COUNT)
      orig_key = NULLED_OUT ; 
      val = NULLED_OUT ; 

# 8404 "bc/src/fun.c"
      if ((& (chain ) -> iso ) -> so . keyex & 0x1 )
        last_pos = - 1 ; 
      if ((((Scheme_Type ) (((((intptr_t ) (keys [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (keys [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) keys [i ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) keys [i ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) {
        is_chaperoned = 1 ; 
        orig_key = keys [i ] ; 
        keys [i ] = (((Scheme_Chaperone * ) orig_key ) -> val ) ; 
      }

# 8411 "bc/src/fun.c"
      else 
      orig_key = ((void * ) 0 ) ; 
      if ((chain -> key ) == (keys [i ] ) )  {
        intptr_t pos ; 
#       define XfOrM1644_COUNT (0+XfOrM1643_COUNT)
#       define SETUP_XfOrM1644(x) SETUP_XfOrM1643(x)

# 8415 "bc/src/fun.c"
        pos = (intptr_t ) chain -> pos ; 
        if (! vals ) {
#         define XfOrM1646_COUNT (0+XfOrM1644_COUNT)
#         define SETUP_XfOrM1646(x) SETUP_XfOrM1644(x)

# 8417 "bc/src/fun.c"
          vals = FUNCCALL(SETUP_XfOrM1646(_), scheme_make_vector (len , none ) ); 
          last_pos = pos ; 
        }
        if (is_chaperoned ) {
#         define XfOrM1645_COUNT (0+XfOrM1644_COUNT)
#         define SETUP_XfOrM1645(x) SETUP_XfOrM1644(x)

# 8421 "bc/src/fun.c"
          val = FUNCCALL(SETUP_XfOrM1645(_), scheme_chaperone_do_continuation_mark (who , 1 , orig_key , chain -> val ) )
          ; 
          (((Scheme_Vector * ) (vals ) ) -> els ) [i ] = val ; 
        }

# 8424 "bc/src/fun.c"
        else 
        (((Scheme_Vector * ) (vals ) ) -> els ) [i ] = chain -> val ; 
      }
    }

    if ((chain -> key ) == (prompt_tag ) ) 
      break ; 

    chain = chain -> next ; 
  }

  * _chain = ((void * ) 0 ) ; 

  RET_VALUE_START (vals ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8440 "bc/src/fun.c"
static Scheme_Object * iterate_step (void * data , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Cont_Mark_Chain * chain = ((void * * ) data ) [0 ] ; 
  void * * clos = ((void * * ) data ) [1 ] , * * new_state ; 
  Scheme_Object * vals , * a [2 ] ; 
  Scheme_Object * prompt_tag = ((Scheme_Object * * ) clos ) [0 ] ; 
  Scheme_Object * * keys = ((Scheme_Object * * * ) clos ) [1 ] ; 
  intptr_t len = (((intptr_t ) (((Scheme_Object * * ) clos ) [2 ] ) ) >> 1 ) ; 
  Scheme_Object * none = ((Scheme_Object * * ) clos ) [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(clos, 0), PUSHARRAY(a, 2, 1), PUSH(new_state, 4), PUSH(vals, 5), PUSH(chain, 6)));
# define XfOrM1649_COUNT (7)
# define SETUP_XfOrM1649(x) SETUP(XfOrM1649_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  new_state = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 8450 "bc/src/fun.c"
  if (! chain ) {
    a [0 ] = scheme_false ; 
    new_state = data ; 
  }

# 8453 "bc/src/fun.c"
  else {
#   define XfOrM1650_COUNT (0+XfOrM1649_COUNT)
#   define SETUP_XfOrM1650(x) SETUP_XfOrM1649(x)

# 8454 "bc/src/fun.c"
    vals = FUNCCALL(SETUP_XfOrM1650(_), iterate_cc_markses ("mark-list*-iterator" , prompt_tag , none , len , keys , & chain ) ); 
    if (! vals )
      a [0 ] = scheme_false ; 
    else 
    a [0 ] = vals ; 
    new_state = ((void * * ) FUNCCALL(SETUP_XfOrM1650(_), GC_malloc (sizeof (void * ) * (2 ) ) )) ; 
    new_state [0 ] = chain ; 
    new_state [1 ] = clos ; 
  }

  a [1 ] = FUNCCALL(SETUP_XfOrM1649(_), scheme_make_closed_prim_w_arity (iterate_step , new_state , "mark-list*-iterator" , 0 , 0 ) ); 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1649(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8468 "bc/src/fun.c"
static Scheme_Object * 
do_extract_cc_markses (const char * who , int argc , Scheme_Object * argv [] , int iterator ) 
{
  Scheme_Cont_Mark_Chain * chain ; 
  Scheme_Object * first = scheme_null , * last = ((void * ) 0 ) ; 
  Scheme_Object * pr , * * keys , * vals , * none , * prompt_tag ; 
  intptr_t len , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(vals, 0), PUSH(pr, 1), PUSH(keys, 2), PUSH(chain, 3), PUSH(prompt_tag, 4), PUSH(last, 5), PUSH(who, 6), PUSH(argv, 7), PUSH(first, 8), PUSH(none, 9)));
# define XfOrM1652_COUNT (10)
# define SETUP_XfOrM1652(x) SETUP(XfOrM1652_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  chain = NULLED_OUT ; 
  pr = NULLED_OUT ; 
  keys = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  none = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 

# 8476 "bc/src/fun.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) ) {
#   define XfOrM1667_COUNT (0+XfOrM1652_COUNT)
#   define SETUP_XfOrM1667(x) SETUP_XfOrM1652(x)
    FUNCCALL(SETUP_XfOrM1667(_), scheme_wrong_contract (who , "(or/c continuation-mark-set? #f)" , 0 , argc , argv ) )
# 8478 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  len = (scheme_proper_list_length (argv [1 ] ) ) ; 
  if (len < 0 ) {
#   define XfOrM1666_COUNT (0+XfOrM1652_COUNT)
#   define SETUP_XfOrM1666(x) SETUP_XfOrM1652(x)
    FUNCCALL(SETUP_XfOrM1666(_), scheme_wrong_contract (who , "list?" , 1 , argc , argv ) )
# 8483 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (argc > 2 )
    none = argv [2 ] ; 
  else 
  none = scheme_false ; 
  if (argc > 3 ) {
#   define XfOrM1663_COUNT (0+XfOrM1652_COUNT)
#   define SETUP_XfOrM1663(x) SETUP_XfOrM1652(x)

# 8491 "bc/src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) ) ) {
#     define XfOrM1664_COUNT (0+XfOrM1663_COUNT)
#     define SETUP_XfOrM1664(x) SETUP_XfOrM1663(x)

# 8492 "bc/src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [3 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [3 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) argv [3 ] ) -> val ) ; 
      else {
#       define XfOrM1665_COUNT (0+XfOrM1664_COUNT)
#       define SETUP_XfOrM1665(x) SETUP_XfOrM1664(x)
        FUNCCALL(SETUP_XfOrM1665(_), scheme_wrong_contract (who , "continuation-prompt-tag?" , 3 , argc , argv ) )
# 8497 "bc/src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 8500 "bc/src/fun.c"
    else 
    prompt_tag = argv [3 ] ; 
  }

# 8502 "bc/src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  keys = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1652(_), GC_malloc (sizeof (Scheme_Object * ) * (len ) ) )) ; 
  for (pr = argv [1 ] , i = 0 ; ((Scheme_Type ) (((((intptr_t ) (pr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pr ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) , i ++ ) {
#   define XfOrM1661_COUNT (0+XfOrM1652_COUNT)
#   define SETUP_XfOrM1661(x) SETUP_XfOrM1652(x)

# 8507 "bc/src/fun.c"
    keys [i ] = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ; 
    if ((keys [i ] == scheme_parameterization_key ) 
    || (keys [i ] == scheme_break_enabled_key ) ) {
#     define XfOrM1662_COUNT (0+XfOrM1661_COUNT)
#     define SETUP_XfOrM1662(x) SETUP_XfOrM1661(x)
      FUNCCALL(SETUP_XfOrM1662(_), scheme_signal_error ("%s: misuse of primitive key" , who ) )
# 8510 "bc/src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((argv [0 ] ) ) == (scheme_false ) ) 
    chain = FUNCCALL(SETUP_XfOrM1652(_), current_mark_chain (who , prompt_tag ) ); 
  else 
  chain = ((Scheme_Cont_Mark_Set * ) argv [0 ] ) -> chain ; 

  if (iterator ) {
    void * * clos , * * state ; 
    BLOCK_SETUP((PUSH(clos, 0+XfOrM1652_COUNT), PUSH(state, 1+XfOrM1652_COUNT)));
#   define XfOrM1658_COUNT (2+XfOrM1652_COUNT)
#   define SETUP_XfOrM1658(x) SETUP(XfOrM1658_COUNT)
    clos = NULLED_OUT ; 
    state = NULLED_OUT ; 

# 8522 "bc/src/fun.c"
    clos = ((void * * ) FUNCCALL(SETUP_XfOrM1658(_), GC_malloc (sizeof (void * ) * (4 ) ) )) ; 
    clos [0 ] = prompt_tag ; 
    clos [1 ] = keys ; 
    clos [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) ; 
    clos [3 ] = none ; 
    state = ((void * * ) FUNCCALL(SETUP_XfOrM1658(_), GC_malloc (sizeof (void * ) * (2 ) ) )) ; 
    state [0 ] = chain ; 
    state [1 ] = clos ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1658(_), scheme_make_closed_prim_w_arity (iterate_step , state , "mark-list*-iterator" , 0 , 0 ) )) RET_VALUE_END ; 
  }

# 8531 "bc/src/fun.c"
  else {
#   define XfOrM1653_COUNT (0+XfOrM1652_COUNT)
#   define SETUP_XfOrM1653(x) SETUP_XfOrM1652(x)

# 8532 "bc/src/fun.c"
    while (chain ) {
#     define XfOrM1656_COUNT (0+XfOrM1653_COUNT)
#     define SETUP_XfOrM1656(x) SETUP_XfOrM1653(x)

# 8533 "bc/src/fun.c"
      vals = FUNCCALL(SETUP_XfOrM1656(_), iterate_cc_markses (who , prompt_tag , none , len , keys , & chain ) ); 
      if (vals ) {
#       define XfOrM1657_COUNT (0+XfOrM1656_COUNT)
#       define SETUP_XfOrM1657(x) SETUP_XfOrM1656(x)

# 8535 "bc/src/fun.c"
        pr = FUNCCALL(SETUP_XfOrM1657(_), scheme_make_pair (vals , scheme_null ) ); 
        if (last )
          (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pr ; 
        else 
        first = pr ; 
        last = pr ; 
      }
    }

    RET_VALUE_START (first ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8548 "bc/src/fun.c"
static Scheme_Object * 
extract_cc_markses (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8551 "bc/src/fun.c"
  return do_extract_cc_markses ("continuation-mark-set->list*" , argc , argv , 0 ) ; 
}

static Scheme_Object * 
extract_cc_iterator (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8557 "bc/src/fun.c"
  return do_extract_cc_markses ("continuation-mark-set->iterator" , argc , argv , 1 ) ; 
}

Scheme_Object * 
scheme_get_stack_trace (Scheme_Object * mark_set , int with_realms ) 
{
  Scheme_Object * l , * n , * m , * name , * loc , * realm , * e ; 
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(loc, 0), PUSHARRAY(a, 2, 1), PUSH(l, 4), PUSH(e, 5), PUSH(name, 6), PUSH(realm, 7), PUSH(m, 8), PUSH(n, 9)));
# define XfOrM1670_COUNT (10)
# define SETUP_XfOrM1670(x) SETUP(XfOrM1670_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = NULLED_OUT ; 
  n = NULLED_OUT ; 
  m = NULLED_OUT ; 
  name = NULLED_OUT ; 
  loc = NULLED_OUT ; 
  realm = NULLED_OUT ; 
  e = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 8566 "bc/src/fun.c"
  l = ((Scheme_Cont_Mark_Set * ) mark_set ) -> native_stack_trace ; 

  if (! l ) {
#   define XfOrM1692_COUNT (0+XfOrM1670_COUNT)
#   define SETUP_XfOrM1692(x) SETUP_XfOrM1670(x)

# 8569 "bc/src/fun.c"
    a [0 ] = mark_set ; 
    a [1 ] = scheme_stack_dump_key ; 

    l = FUNCCALL(SETUP_XfOrM1692(_), extract_cc_marks (2 , a ) ); 
  }

# 8573 "bc/src/fun.c"
  else {

    Scheme_Object * first = scheme_null , * last = ((void * ) 0 ) ; 
    BLOCK_SETUP((PUSH(first, 0+XfOrM1670_COUNT), PUSH(last, 1+XfOrM1670_COUNT)));
#   define XfOrM1689_COUNT (2+XfOrM1670_COUNT)
#   define SETUP_XfOrM1689(x) SETUP(XfOrM1689_COUNT)

# 8576 "bc/src/fun.c"
    while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM1691_COUNT (0+XfOrM1689_COUNT)
#     define SETUP_XfOrM1691(x) SETUP_XfOrM1689(x)

# 8577 "bc/src/fun.c"
      n = FUNCCALL(SETUP_XfOrM1691(_), scheme_make_pair ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = n ; 
      else 
      first = n ; 
      last = n ; 
      l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
    }
    l = first ; 
  }


  while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ! (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) {
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }
  for (n = l ; ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ) {
    m = (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . cdr ) ; 
    if ((m ) == (scheme_null ) ) 
      break ; 
    if (((Scheme_Simple_Object * ) (m ) ) -> u . pair_val . car )  {
      n = m ; 
    }

# 8598 "bc/src/fun.c"
    else {
      (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (m ) ) -> u . pair_val . cdr ) ; 
    }
  }


  for (n = l ; ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; n = (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . cdr ) ) {
#   define XfOrM1676_COUNT (0+XfOrM1670_COUNT)
#   define SETUP_XfOrM1676(x) SETUP_XfOrM1670(x)

# 8605 "bc/src/fun.c"
    name = (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . car ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
#     define XfOrM1680_COUNT (0+XfOrM1676_COUNT)
#     define SETUP_XfOrM1680(x) SETUP_XfOrM1676(x)

# 8607 "bc/src/fun.c"
      if (! ((((((Scheme_Vector * ) (name ) ) -> els ) [1 ] ) ) == (scheme_false ) ) ) 
        loc = FUNCCALL(SETUP_XfOrM1680(_), scheme_make_location ((((Scheme_Vector * ) (name ) ) -> els ) [1 ] , (((Scheme_Vector * ) (name ) ) -> els ) [2 ] , (((Scheme_Vector * ) (name ) ) -> els ) [3 ] , (((Scheme_Vector * ) (name ) ) -> els ) [4 ] , (((Scheme_Vector * ) (name ) ) -> els ) [5 ] ) )



      ; 
      else 
      loc = scheme_false ; 
      if ((((Scheme_Vector * ) (name ) ) -> size ) > 7 )
        realm = (((Scheme_Vector * ) (name ) ) -> els ) [7 ] ; 
      else 
      realm = scheme_default_realm ; 
      if (! ((((((Scheme_Vector * ) (name ) ) -> els ) [6 ] ) ) == (scheme_false ) ) ) 
        name = scheme_false ; 
      else 
      name = (((Scheme_Vector * ) (name ) ) -> els ) [0 ] ; 
    }

# 8623 "bc/src/fun.c"
    else if (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && (((((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . cdr ) ) == (scheme_true ) ) ) {

      const char * what ; 
      BLOCK_SETUP((PUSH(what, 0+XfOrM1676_COUNT)));
#     define XfOrM1679_COUNT (1+XfOrM1676_COUNT)
#     define SETUP_XfOrM1679(x) SETUP(XfOrM1679_COUNT)
      what = NULLED_OUT ; 

# 8627 "bc/src/fun.c"
      what = "[running body]" ; 

      name = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . car ) ; 
      loc = FUNCCALL(SETUP_XfOrM1679(_), scheme_make_location (name , scheme_false , scheme_false , scheme_false , scheme_false ) ); 

      name = FUNCCALL_AGAIN(scheme_intern_symbol (what ) ); 
      realm = scheme_default_realm ; 
    }

# 8634 "bc/src/fun.c"
    else {
      loc = scheme_false ; 
      realm = scheme_default_realm ; 
    }

    if (with_realms ) {
#     define XfOrM1677_COUNT (0+XfOrM1676_COUNT)
#     define SETUP_XfOrM1677(x) SETUP_XfOrM1676(x)

# 8640 "bc/src/fun.c"
      e = FUNCCALL(SETUP_XfOrM1677(_), scheme_make_vector (3 , ((void * ) 0 ) ) ); 
      (((Scheme_Vector * ) (e ) ) -> els ) [0 ] = name ; 
      (((Scheme_Vector * ) (e ) ) -> els ) [1 ] = loc ; 
      (((Scheme_Vector * ) (e ) ) -> els ) [2 ] = realm ; 
      ((((Scheme_Inclhash_Object * ) (e ) ) -> so . keyex |= 0x1 ) ) ; 
    }

# 8645 "bc/src/fun.c"
    else 
    e = FUNCCALL(SETUP_XfOrM1676(_), scheme_make_pair (name , loc ) ); 

    (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . car ) = e ; 
  }

  RET_VALUE_START (l ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8654 "bc/src/fun.c"
static Scheme_Object * 
extract_cc_proc_marks (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8657 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) ) {
    scheme_wrong_contract ("continuation-mark-set->context" , "continuation-mark-set?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }

  return scheme_get_stack_trace (argv [0 ] , (argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) ; 
}

__xform_nongcing__ static Scheme_Object * default_mark_value (Scheme_Object * key ) 
{
  /* No conversion */

# 8667 "bc/src/fun.c"
  if (key == scheme_parameterization_key )
    return (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> init_config ; 
  else if (key == scheme_break_enabled_key )
    return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> init_break_cell ; 

  return ((void * ) 0 ) ; 
}

static Scheme_Object * 
scheme_extract_one_cc_mark_with_meta (Scheme_Object * mark_set , Scheme_Object * key_arg , 
Scheme_Object * prompt_tag , Scheme_Meta_Continuation * * _meta , 
intptr_t * _vpos ) 
{
  Scheme_Object * key = key_arg ; 
  Scheme_Object * __funcarg213 = NULLED_OUT ; 
  Scheme_Object * __funcarg212 = NULLED_OUT ; 
  Scheme_Object * __funcarg211 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(_meta, 1), PUSH(key, 2), PUSH(_vpos, 3), PUSH(key_arg, 4)));
# define XfOrM1696_COUNT (5)
# define SETUP_XfOrM1696(x) SETUP(XfOrM1696_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 8682 "bc/src/fun.c"
  if (prompt_tag && ((prompt_tag ) == ((((Scheme_Small_Object * ) (scheme_root_prompt_tag ) ) -> u . ptr_val ) ) ) )
    prompt_tag = ((void * ) 0 ) ; 

  if ((((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) {
    key = (((Scheme_Chaperone * ) key ) -> val ) ; 
  }

  if (mark_set ) {
    Scheme_Cont_Mark_Chain * chain ; 
#   define XfOrM1784_COUNT (0+XfOrM1696_COUNT)
#   define SETUP_XfOrM1784(x) SETUP_XfOrM1696(x)
    chain = NULLED_OUT ; 

# 8692 "bc/src/fun.c"
    chain = ((Scheme_Cont_Mark_Set * ) mark_set ) -> chain ; 
    while (chain ) {
#     define XfOrM1786_COUNT (0+XfOrM1784_COUNT)
#     define SETUP_XfOrM1786(x) SETUP_XfOrM1784(x)

# 8694 "bc/src/fun.c"
      if (chain -> key == key )
        if (key_arg != key )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_chaperone_do_continuation_mark ("continuation-mark-set-first" , 1 , key_arg , chain -> val ) )) RET_VALUE_EMPTY_END 
      ; 
      else 
      RET_VALUE_START (chain -> val ) RET_VALUE_END ; 
      else if ((chain -> key ) == (prompt_tag ) ) 
        break ; 
      else 
      chain = chain -> next ; 
    }
  }

# 8705 "bc/src/fun.c"
  else {
    intptr_t findpos , bottom , startpos ; 
    intptr_t pos ; 
    Scheme_Object * val = ((void * ) 0 ) ; 
    intptr_t vpos = 0 ; 
    Scheme_Object * cache ; 
    Scheme_Meta_Continuation * mc = ((void * ) 0 ) ; 
    Scheme_Cont_Mark * seg ; 
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(mc, 0+XfOrM1696_COUNT), PUSH(val, 1+XfOrM1696_COUNT), PUSH(seg, 2+XfOrM1696_COUNT), PUSH(cache, 3+XfOrM1696_COUNT), PUSH(p, 4+XfOrM1696_COUNT)));
#   define XfOrM1697_COUNT (5+XfOrM1696_COUNT)
#   define SETUP_XfOrM1697(x) SETUP(XfOrM1697_COUNT)
    cache = NULLED_OUT ; 
    seg = NULLED_OUT ; 

# 8715 "bc/src/fun.c"
    do {
#     define XfOrM1741_COUNT (0+XfOrM1697_COUNT)
#     define SETUP_XfOrM1741(x) SETUP_XfOrM1697(x)

# 8716 "bc/src/fun.c"
      if (mc ) {
        startpos = mc -> cont_mark_total ; 
        bottom = 0 ; 
      }

# 8719 "bc/src/fun.c"
      else {
        startpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
        bottom = p -> cont_mark_stack_bottom ; 
      }

      findpos = startpos ; 


      while (findpos -- > bottom ) {
#       define XfOrM1771_COUNT (0+XfOrM1741_COUNT)
#       define SETUP_XfOrM1771(x) SETUP_XfOrM1741(x)

# 8728 "bc/src/fun.c"
        if (mc ) {
          seg = mc -> cont_mark_stack_copied ; 
          pos = findpos ; 
        }

# 8731 "bc/src/fun.c"
        else {
          seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
          pos = findpos & ((1 << 6 ) - 1 ) ; 
        }

        if ((seg [pos ] . key ) == (key ) )  {
          val = seg [pos ] . val ; 
          vpos = seg [pos ] . pos ; 
          break ; 
        }

# 8740 "bc/src/fun.c"
        else if ((seg [pos ] . key ) == (prompt_tag ) )  {
          break ; 
        }

# 8742 "bc/src/fun.c"
        else {
#         define XfOrM1772_COUNT (0+XfOrM1771_COUNT)
#         define SETUP_XfOrM1772(x) SETUP_XfOrM1771(x)

# 8743 "bc/src/fun.c"
          cache = seg [pos ] . cache ; 
          if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) )
            cache = (scheme_eq_hash_get ((Scheme_Hash_Table * ) cache , 
          prompt_tag ? prompt_tag : scheme_false ) ) ; 
          else if (prompt_tag )
            cache = ((void * ) 0 ) ; 
          if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
#           define XfOrM1773_COUNT (0+XfOrM1772_COUNT)
#           define SETUP_XfOrM1773(x) SETUP_XfOrM1772(x)
            if ((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) {
              if (((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) == (key ) )  {
                val = (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
                vpos = (intptr_t ) (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] ; 
                break ; 
              }
            }

# 8758 "bc/src/fun.c"
            else {
              Scheme_Hash_Table * ht ; 
#             define XfOrM1774_COUNT (0+XfOrM1773_COUNT)
#             define SETUP_XfOrM1774(x) SETUP_XfOrM1773(x)
              ht = NULLED_OUT ; 

# 8760 "bc/src/fun.c"
              ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
              val = (scheme_eq_hash_get (ht , key ) ) ; 
              if (val ) {
                vpos = (intptr_t ) (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . cdr ) ; 
                val = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) ; 
                break ; 
              }
            }
          }
        }
      }

      if (key_arg != key && val != ((void * ) 0 ) )
        val = FUNCCALL(SETUP_XfOrM1741(_), scheme_chaperone_do_continuation_mark ("continuation-mark-set-first" , 1 , key_arg , val ) ); 

      pos = startpos - findpos ; 
      if (pos > 16 ) {
        pos >>= 1 ; 
#       define XfOrM1745_COUNT (0+XfOrM1741_COUNT)
#       define SETUP_XfOrM1745(x) SETUP_XfOrM1741(x)

# 8778 "bc/src/fun.c"
        findpos = findpos + pos ; 
        if (mc ) {
          seg = mc -> cont_mark_stack_copied ; 
          pos = findpos ; 
        }

# 8782 "bc/src/fun.c"
        else {
          seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
          pos = findpos & ((1 << 6 ) - 1 ) ; 
        }



        cache = seg [pos ] . cache ; 
        {
          Scheme_Hash_Table * cht ; 
          BLOCK_SETUP((PUSH(cht, 0+XfOrM1745_COUNT)));
#         define XfOrM1746_COUNT (1+XfOrM1745_COUNT)
#         define SETUP_XfOrM1746(x) SETUP(XfOrM1746_COUNT)
          cht = NULLED_OUT ; 

# 8792 "bc/src/fun.c"
          if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
#           define XfOrM1757_COUNT (0+XfOrM1746_COUNT)
#           define SETUP_XfOrM1757(x) SETUP_XfOrM1746(x)

# 8793 "bc/src/fun.c"
            cht = (Scheme_Hash_Table * ) cache ; 
            cache = (scheme_eq_hash_get (cht , prompt_tag ? prompt_tag : scheme_false ) ) ; 
          }

# 8795 "bc/src/fun.c"
          else if (prompt_tag ) {
#           define XfOrM1753_COUNT (0+XfOrM1746_COUNT)
#           define SETUP_XfOrM1753(x) SETUP_XfOrM1746(x)

# 8796 "bc/src/fun.c"
            cht = FUNCCALL(SETUP_XfOrM1753(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            if (cache ) {
#             define XfOrM1754_COUNT (0+XfOrM1753_COUNT)
#             define SETUP_XfOrM1754(x) SETUP_XfOrM1753(x)

# 8798 "bc/src/fun.c"
              if ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
                Scheme_Object * vec ; 
                BLOCK_SETUP((PUSH(vec, 0+XfOrM1754_COUNT)));
#               define XfOrM1756_COUNT (1+XfOrM1754_COUNT)
#               define SETUP_XfOrM1756(x) SETUP(XfOrM1756_COUNT)
                vec = NULLED_OUT ; 

# 8800 "bc/src/fun.c"
                if ((((Scheme_Vector * ) (cache ) ) -> els ) [0 ] )
                  FUNCCALL(SETUP_XfOrM1756(_), scheme_hash_set (cht , scheme_default_prompt_tag , (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] ) ); 

                vec = FUNCCALL(SETUP_XfOrM1756(_), scheme_make_vector (4 , ((void * ) 0 ) ) ); 
                (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ; 
                (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
                (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] ; 
                FUNCCALL(SETUP_XfOrM1756(_), scheme_hash_set (cht , scheme_false , vec ) ); 
              }

# 8808 "bc/src/fun.c"
              else {
#               define XfOrM1755_COUNT (0+XfOrM1754_COUNT)
#               define SETUP_XfOrM1755(x) SETUP_XfOrM1754(x)
                FUNCCALL(SETUP_XfOrM1755(_), scheme_hash_set (cht , scheme_default_prompt_tag , cache ) )
# 8809 "bc/src/fun.c"
                ; 
              }
              cache = ((void * ) 0 ) ; 
            }
            seg [pos ] . cache = (Scheme_Object * ) cht ; 
          }

# 8814 "bc/src/fun.c"
          else 
          cht = ((void * ) 0 ) ; 

          if (! cache || ! ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
#           define XfOrM1750_COUNT (0+XfOrM1746_COUNT)
#           define SETUP_XfOrM1750(x) SETUP_XfOrM1746(x)

# 8819 "bc/src/fun.c"
            cache = FUNCCALL(SETUP_XfOrM1750(_), scheme_make_vector (4 , ((void * ) 0 ) ) ); 
            (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] = key ; 
            (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] = val ; 
            (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] = (Scheme_Object * ) vpos ; 
            if (cht ) {
#             define XfOrM1752_COUNT (0+XfOrM1750_COUNT)
#             define SETUP_XfOrM1752(x) SETUP_XfOrM1750(x)
              FUNCCALL(SETUP_XfOrM1752(_), scheme_hash_set (cht , prompt_tag ? prompt_tag : scheme_false , cache ) )
# 8824 "bc/src/fun.c"
              ; 
            }

# 8825 "bc/src/fun.c"
            else {
              if (seg [pos ] . cache && ! (((seg [pos ] . cache ) ) == (scheme_false ) ) )
                (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] = seg [pos ] . cache ; 
              seg [pos ] . cache = cache ; 
            }
          }

# 8830 "bc/src/fun.c"
          else {
#           define XfOrM1747_COUNT (0+XfOrM1746_COUNT)
#           define SETUP_XfOrM1747(x) SETUP_XfOrM1746(x)

# 8831 "bc/src/fun.c"
            if ((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) {

              Scheme_Hash_Table * ht ; 
              BLOCK_SETUP((PUSH(ht, 0+XfOrM1747_COUNT)));
#             define XfOrM1749_COUNT (1+XfOrM1747_COUNT)
#             define SETUP_XfOrM1749(x) SETUP(XfOrM1749_COUNT)
              ht = NULLED_OUT ; 

# 8834 "bc/src/fun.c"
              ht = FUNCCALL(SETUP_XfOrM1749(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
              (__funcarg213 = FUNCCALL(SETUP_XfOrM1749(_), scheme_make_raw_pair (val , (Scheme_Object * ) vpos ) ), FUNCCALL_AGAIN(scheme_hash_set (ht , key , __funcarg213 ) )) ; 
              (__funcarg212 = FUNCCALL(SETUP_XfOrM1749(_), scheme_make_raw_pair ((((Scheme_Vector * ) (cache ) ) -> els ) [2 ] , (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] ) ), FUNCCALL_AGAIN(scheme_hash_set (ht , (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] , __funcarg212 ) )) 
              ; 
              (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] = ((void * ) 0 ) ; 
              (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] = (Scheme_Object * ) ht ; 
            }

# 8840 "bc/src/fun.c"
            else {

              Scheme_Hash_Table * ht ; 
              BLOCK_SETUP((PUSH(ht, 0+XfOrM1747_COUNT)));
#             define XfOrM1748_COUNT (1+XfOrM1747_COUNT)
#             define SETUP_XfOrM1748(x) SETUP(XfOrM1748_COUNT)
              ht = NULLED_OUT ; 

# 8843 "bc/src/fun.c"
              ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
              (__funcarg211 = FUNCCALL(SETUP_XfOrM1748(_), scheme_make_raw_pair (val , (Scheme_Object * ) vpos ) ), FUNCCALL_AGAIN(scheme_hash_set (ht , key , __funcarg211 ) )) ; 
            }
          }
        }
      }

      if (val ) {
        if (_meta )
          * _meta = mc ; 
        if (_vpos )
          * _vpos = vpos ; 
        RET_VALUE_START (val ) RET_VALUE_END ; 
      }

      if (mc ) {
        mc = mc -> next ; 
      }

# 8860 "bc/src/fun.c"
      else {
        mc = p -> meta_continuation ; 
      }
    }

# 8863 "bc/src/fun.c"
    while (mc ) ; 
  }

  RET_VALUE_START ((default_mark_value (key ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8869 "bc/src/fun.c"
__xform_nongcing__ static Scheme_Object * 
extract_one_cc_mark_fast (Scheme_Object * key , int * _conclusive ) 


{
  /* No conversion */

# 8874 "bc/src/fun.c"
  intptr_t findpos , bottom , startpos ; 
  intptr_t pos ; 
  Scheme_Object * val = ((void * ) 0 ) ; 
  Scheme_Object * cache ; 
  Scheme_Cont_Mark * seg ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Meta_Continuation * mc = ((void * ) 0 ) ; 

  do {
    if (mc ) {
      startpos = mc -> cont_mark_total ; 
      bottom = 0 ; 
    }

# 8886 "bc/src/fun.c"
    else {
      startpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
      bottom = p -> cont_mark_stack_bottom ; 
    }

    findpos = startpos ; 


    while (findpos -- > bottom ) {
      if ((startpos - findpos ) > 16 ) {

        return ((void * ) 0 ) ; 
      }

      if (mc ) {
        seg = mc -> cont_mark_stack_copied ; 
        pos = findpos ; 
      }

# 8903 "bc/src/fun.c"
      else {
        seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
        pos = findpos & ((1 << 6 ) - 1 ) ; 
      }

      if ((seg [pos ] . key ) == (key ) )  {
        * _conclusive = 1 ; 
        return seg [pos ] . val ; 
      }

# 8911 "bc/src/fun.c"
      else {
        cache = seg [pos ] . cache ; 
        if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) )
          cache = scheme_eq_hash_get ((Scheme_Hash_Table * ) cache , scheme_false ) ; 
        if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {


          if ((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) {
            if (((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) == (key ) )  {
              val = (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
              if (val ) {
                * _conclusive = 1 ; 
                return val ; 
              }

# 8924 "bc/src/fun.c"
              else 
              break ; 
            }
          }

# 8927 "bc/src/fun.c"
          else {
            Scheme_Hash_Table * ht ; 
            ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
            val = scheme_eq_hash_get (ht , key ) ; 
            if (val ) {
              val = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) ; 
              if (val ) {
                * _conclusive = 1 ; 
                return val ; 
              }

# 8936 "bc/src/fun.c"
              else 
              break ; 
            }
          }
        }
      }
    }

    if (mc )
      mc = mc -> next ; 
    else 
    mc = p -> meta_continuation ; 
  }

# 8948 "bc/src/fun.c"
  while (mc ) ; 



  * _conclusive = 1 ; 
  return default_mark_value (key ) ; 
}

static Scheme_Object * get_set_cont_mark_by_pos (Scheme_Object * key , 
Scheme_Thread * p , 
Scheme_Meta_Continuation * mc , 
intptr_t mpos , 
Scheme_Object * val ) 
{
  intptr_t findpos , bottom , startpos ; 
  intptr_t pos ; 
  int down_delta = 0 ; 
  Scheme_Cont_Mark * seg ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(mc, 0), PUSH(val, 1), PUSH(seg, 2), PUSH(key, 3), PUSH(p, 4)));
# define XfOrM1847_COUNT (5)
# define SETUP_XfOrM1847(x) SETUP(XfOrM1847_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  seg = NULLED_OUT ; 

# 8967 "bc/src/fun.c"
  if (mc ) {
    startpos = mc -> cont_mark_total ; 
    bottom = 0 ; 
  }

# 8970 "bc/src/fun.c"
  else {
    startpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
    bottom = p -> cont_mark_stack_bottom ; 
  }


  while (bottom < startpos ) {
#   define XfOrM1857_COUNT (0+XfOrM1847_COUNT)
#   define SETUP_XfOrM1857(x) SETUP_XfOrM1847(x)

# 8977 "bc/src/fun.c"
    findpos = ((bottom + startpos ) / 2 ) - down_delta ; 

    if (mc ) {
      seg = mc -> cont_mark_stack_copied ; 
      pos = findpos ; 
    }

# 8982 "bc/src/fun.c"
    else {
      seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
      pos = findpos & ((1 << 6 ) - 1 ) ; 
    }

    if (seg [pos ] . pos == mpos ) {
#     define XfOrM1860_COUNT (0+XfOrM1857_COUNT)
#     define SETUP_XfOrM1860(x) SETUP_XfOrM1857(x)

# 8988 "bc/src/fun.c"
      if ((seg [pos ] . key ) == (key ) )  {
#       define XfOrM1863_COUNT (0+XfOrM1860_COUNT)
#       define SETUP_XfOrM1863(x) SETUP_XfOrM1860(x)

# 8989 "bc/src/fun.c"
        if (! val )
          RET_VALUE_START (seg [pos ] . val ) RET_VALUE_END ; 

        if (mc && mc -> cm_shared )
          seg = FUNCCALL(SETUP_XfOrM1863(_), copy_cm_shared_on_write (mc ) ); 

        seg [pos ] . val = val ; 

        RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
      }

# 8998 "bc/src/fun.c"
      else if (findpos > bottom ) {
        down_delta ++ ; 
      }

# 9000 "bc/src/fun.c"
      else {
        bottom = (findpos + down_delta ) + 1 ; 
        down_delta = 0 ; 
      }
    }

# 9004 "bc/src/fun.c"
    else if (seg [pos ] . pos < mpos ) {
      bottom = findpos + 1 ; 
    }

# 9006 "bc/src/fun.c"
    else {
      startpos = findpos ; 
    }
  }
  FUNCCALL_EMPTY(scheme_signal_error ("get_set_cont_mark_by_pos: key not found" ) )
  ; 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9015 "bc/src/fun.c"
Scheme_Object * 
scheme_extract_one_cc_mark (Scheme_Object * mark_set , Scheme_Object * key ) 
{
  /* No conversion */

# 9018 "bc/src/fun.c"
  Scheme_Object * v ; 

  if (! mark_set ) {
    int conclusive = 0 ; 
    v = extract_one_cc_mark_fast (key , & conclusive ) ; 
    if (conclusive )

# 9023 "bc/src/fun.c"
    return v ; 
  }

  return scheme_extract_one_cc_mark_with_meta (mark_set , key , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_extract_one_cc_mark_to_tag (Scheme_Object * mark_set , Scheme_Object * key , 
Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 9033 "bc/src/fun.c"
  return scheme_extract_one_cc_mark_with_meta (mark_set , key , prompt_tag , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
}

static Scheme_Object * 
extract_one_cc_mark (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * r ; 
  Scheme_Object * prompt_tag ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(r, 1), PUSH(argv, 2)));
# define XfOrM1871_COUNT (3)
# define SETUP_XfOrM1871(x) SETUP(XfOrM1871_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  r = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 

# 9042 "bc/src/fun.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-mark-set-first" , "(or/c continuation-mark-set? #f)" , 0 , argc , argv ) ); 

  if ((argv [1 ] == scheme_parameterization_key ) 
  || (argv [1 ] == scheme_break_enabled_key ) ) {





    prompt_tag = ((void * ) 0 ) ; 
  }

# 9054 "bc/src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (argc > 3 ) {
#   define XfOrM1873_COUNT (0+XfOrM1871_COUNT)
#   define SETUP_XfOrM1873(x) SETUP_XfOrM1871(x)

# 9058 "bc/src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) ) ) {
#     define XfOrM1877_COUNT (0+XfOrM1873_COUNT)
#     define SETUP_XfOrM1877(x) SETUP_XfOrM1873(x)

# 9059 "bc/src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [3 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [3 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) argv [3 ] ) -> val ) ; 
      else FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-mark-set-first" , "continuation-prompt-tag?" , 3 , argc , argv ) )

      ; 
    }

# 9065 "bc/src/fun.c"
    else 
    prompt_tag = argv [3 ] ; 

    if (! ((scheme_default_prompt_tag ) == (prompt_tag ) ) 
    && ! ((scheme_root_prompt_tag ) == (prompt_tag ) ) ) {
#     define XfOrM1874_COUNT (0+XfOrM1873_COUNT)
#     define SETUP_XfOrM1874(x) SETUP_XfOrM1873(x)

# 9070 "bc/src/fun.c"
      if (((argv [0 ] ) ) == (scheme_false ) )  {
#       define XfOrM1875_COUNT (0+XfOrM1874_COUNT)
#       define SETUP_XfOrM1875(x) SETUP_XfOrM1874(x)

# 9071 "bc/src/fun.c"
        if (! FUNCCALL(SETUP_XfOrM1875(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) )) {
#         define XfOrM1876_COUNT (0+XfOrM1875_COUNT)
#         define SETUP_XfOrM1876(x) SETUP_XfOrM1875(x)
          FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "continuation-mark-set-first: no corresponding prompt in the current continuation\n" "  tag: %V" , prompt_tag ) )
          ; 
        }
      }
    }
  }

  r = FUNCCALL(SETUP_XfOrM1871(_), scheme_extract_one_cc_mark_to_tag ((! (((argv [0 ] ) ) == (scheme_false ) ) ) ? argv [0 ] : ((void * ) 0 ) , argv [1 ] , prompt_tag ? (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) : ((void * ) 0 ) ) )
  ; 
  if (! r ) {
    if (argc > 2 )
      r = argv [2 ] ; 
    else 
    r = scheme_false ; 
  }

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9093 "bc/src/fun.c"
int scheme_is_cm_deeper (Scheme_Meta_Continuation * m1 , intptr_t p1 , 
Scheme_Meta_Continuation * m2 , intptr_t p2 ) 
{
  /* No conversion */

# 9096 "bc/src/fun.c"
  if (m1 != m2 ) {
    if (! m1 )
      return 0 ; 
    if (! m2 )
      return 1 ; 
    return (m1 -> depth < m2 -> depth ) ; 
  }
  return p1 < p2 ; 
}

static Scheme_Object * continuation_prompt_available (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * prompt_tag ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(argv, 1)));
# define XfOrM1881_COUNT (2)
# define SETUP_XfOrM1881(x) SETUP(XfOrM1881_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  prompt_tag = NULLED_OUT ; 

# 9110 "bc/src/fun.c"
  prompt_tag = argv [0 ] ; 
  if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) ) ) {
#   define XfOrM1889_COUNT (0+XfOrM1881_COUNT)
#   define SETUP_XfOrM1889(x) SETUP_XfOrM1881(x)

# 9112 "bc/src/fun.c"
    if ((((Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
      prompt_tag = (((Scheme_Chaperone * ) prompt_tag ) -> val ) ; 
    else FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-prompt-available?" , "continuation-prompt-tag?" , 0 , argc , argv ) )

    ; 
  }

  if (argc > 1 ) {
#   define XfOrM1883_COUNT (0+XfOrM1881_COUNT)
#   define SETUP_XfOrM1883(x) SETUP_XfOrM1881(x)

# 9121 "bc/src/fun.c"
    if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) )  {
#     define XfOrM1886_COUNT (0+XfOrM1883_COUNT)
#     define SETUP_XfOrM1886(x) SETUP_XfOrM1883(x)

# 9122 "bc/src/fun.c"
      if (! FUNCCALL(SETUP_XfOrM1886(_), scheme_escape_continuation_ok (argv [1 ] ) )) {
#       define XfOrM1888_COUNT (0+XfOrM1886_COUNT)
#       define SETUP_XfOrM1888(x) SETUP_XfOrM1886(x)
        FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "continuation-prompt-available?: escape continuation not in the current thread's continuation\n" "  escape continuation: %V" , argv [1 ] ) )
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

# 9128 "bc/src/fun.c"
      else {
        Scheme_Meta_Continuation * mc ; 
        BLOCK_SETUP((PUSH(mc, 0+XfOrM1886_COUNT)));
#       define XfOrM1887_COUNT (1+XfOrM1886_COUNT)
#       define SETUP_XfOrM1887(x) SETUP(XfOrM1887_COUNT)
        mc = NULLED_OUT ; 

# 9131 "bc/src/fun.c"
        if (((scheme_default_prompt_tag ) == (prompt_tag ) ) 
        || ((scheme_root_prompt_tag ) == (prompt_tag ) ) )
          RET_VALUE_START (scheme_true ) RET_VALUE_END ; 

        mc = FUNCCALL(SETUP_XfOrM1887(_), scheme_get_meta_continuation (argv [1 ] ) ); 

        if (FUNCCALL(SETUP_XfOrM1887(_), continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , argv [1 ] , mc , prompt_tag , ((void * ) 0 ) , 0 , 0 ) ))

        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
      }
    }

# 9141 "bc/src/fun.c"
    else if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) )  {
#     define XfOrM1885_COUNT (0+XfOrM1883_COUNT)
#     define SETUP_XfOrM1885(x) SETUP_XfOrM1883(x)

# 9142 "bc/src/fun.c"
      if (FUNCCALL(SETUP_XfOrM1885(_), continuation_marks (((void * ) 0 ) , argv [1 ] , ((void * ) 0 ) , ((void * ) 0 ) , prompt_tag , ((void * ) 0 ) , 0 , 0 ) ))
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    }

# 9144 "bc/src/fun.c"
    else {
#     define XfOrM1884_COUNT (0+XfOrM1883_COUNT)
#     define SETUP_XfOrM1884(x) SETUP_XfOrM1883(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-prompt-available?" , "continuation?" , 1 , argc , argv ) )
# 9146 "bc/src/fun.c"
      ; 
    }
  }

# 9148 "bc/src/fun.c"
  else {
#   define XfOrM1882_COUNT (0+XfOrM1881_COUNT)
#   define SETUP_XfOrM1882(x) SETUP_XfOrM1881(x)

# 9149 "bc/src/fun.c"
    if (((scheme_default_prompt_tag ) == (prompt_tag ) ) 
    || ((scheme_root_prompt_tag ) == (prompt_tag ) ) )
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 

    if (FUNCCALL_EMPTY(scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) ))
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9521 "bc/src/fun.c"
void scheme_init_thread_lwc (void ) XFORM_SKIP_PROC {
}






typedef struct {
  Scheme_Type type ; 
  Scheme_Object * pre , * act , * post ; 
}

# 9532 "bc/src/fun.c"
Dyn_Wind ; 

static void pre_post_dyn_wind (Scheme_Object * prepost ) 
{
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Object * __funcarg215 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cframe.cache, 0), PUSH(prepost, 1)));
# define XfOrM1890_COUNT (2)
# define SETUP_XfOrM1890(x) SETUP(XfOrM1890_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cframe.cache = NULLED_OUT ; 

# 9540 "bc/src/fun.c"
  -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ; 
  FUNCCALL(SETUP_XfOrM1890(_), ASSERT_SUSPEND_BREAK_ZERO () ); 
  FUNCCALL_AGAIN(scheme_push_break_enable (& cframe , 0 , 0 ) )
  ; 
  (__funcarg215 = FUNCCALL(SETUP_XfOrM1890(_), scheme_do_eval (prepost , 0 , ((void * ) 0 ) , - 1 ) ), (

  scheme_ignore_result (__funcarg215 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1890(_), scheme_pop_break_enable (& cframe , 0 ) )
  ; 


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ++ ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9554 "bc/src/fun.c"
static Scheme_Object * do_dyn_wind (void * d ) 
{
  /* No conversion */

# 9556 "bc/src/fun.c"
  Dyn_Wind * dw ; 
  dw = (Dyn_Wind * ) d ; 

  return scheme_do_eval (dw -> act , 0 , ((void * ) 0 ) , - 1 ) ; 
}

static void pre_dyn_wind (void * d ) 
{
  /* No conversion */

# 9564 "bc/src/fun.c"
  pre_post_dyn_wind (((Dyn_Wind * ) d ) -> pre ) ; 
}

static void post_dyn_wind (void * d ) 
{
  /* No conversion */

# 9569 "bc/src/fun.c"
  pre_post_dyn_wind (((Dyn_Wind * ) d ) -> post ) ; 
}

static Scheme_Object * dynamic_wind (int c , Scheme_Object * argv [] ) 
{
  Dyn_Wind * dw ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(dw, 0), PUSH(argv, 1), PUSH(v, 2)));
# define XfOrM1894_COUNT (3)
# define SETUP_XfOrM1894(x) SETUP(XfOrM1894_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  dw = NULLED_OUT ; 
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1894(_), scheme_check_proc_arity ("dynamic-wind" , 0 , 0 , c , argv ) )
# 9577 "bc/src/fun.c"
  ; 
  FUNCCALL_AGAIN(scheme_check_proc_arity ("dynamic-wind" , 0 , 1 , c , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity ("dynamic-wind" , 0 , 2 , c , argv ) ); 

  dw = ((Dyn_Wind * ) FUNCCALL(SETUP_XfOrM1894(_), GC_malloc_one_small_tagged ((((sizeof (Dyn_Wind ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  dw -> type = scheme_rt_dyn_wind_info ; 


  dw -> pre = argv [0 ] ; 
  dw -> act = argv [1 ] ; 
  dw -> post = argv [2 ] ; 

  v = FUNCCALL(SETUP_XfOrM1894(_), scheme_dynamic_wind (pre_dyn_wind , do_dyn_wind , post_dyn_wind , ((void * ) 0 ) , (void * ) dw ) )
  ; 


  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM1894_COUNT)));
#   define XfOrM1895_COUNT (1+XfOrM1894_COUNT)
#   define SETUP_XfOrM1895(x) SETUP(XfOrM1895_COUNT)

# 9596 "bc/src/fun.c"
    if (p -> external_break && FUNCCALL(SETUP_XfOrM1895(_), scheme_can_break (p ) )) {
      Scheme_Object * * save_values ; 
      int save_count ; 
      BLOCK_SETUP((PUSH(save_values, 0+XfOrM1895_COUNT)));
#     define XfOrM1896_COUNT (1+XfOrM1895_COUNT)
#     define SETUP_XfOrM1896(x) SETUP(XfOrM1896_COUNT)
      save_values = NULLED_OUT ; 

# 9600 "bc/src/fun.c"
      if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
        save_count = p -> ku . multiple . count ; 
        save_values = p -> ku . multiple . array ; 
        p -> ku . multiple . array = ((void * ) 0 ) ; 
        if ((save_values ) == (p -> values_buffer ) ) 
          p -> values_buffer = ((void * ) 0 ) ; 
      }

# 9606 "bc/src/fun.c"
      else {
        save_count = 0 ; 
        save_values = ((void * ) 0 ) ; 
      }
      FUNCCALL(SETUP_XfOrM1896(_), scheme_thread_block (0.0 ) )
      ; 
      p -> ran_some = 1 ; 

      if (save_values ) {
        p -> ku . multiple . count = save_count ; 
        p -> ku . multiple . array = save_values ; 
      }
    }
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9624 "bc/src/fun.c"
Scheme_Object * scheme_dynamic_wind (void (* pre ) (void * ) , 
Scheme_Object * (* volatile act ) (void * ) , 
void (* volatile post ) (void * ) , 
Scheme_Object * (* jmp_handler ) (void * ) , 
void * volatile data ) 
{
  mz_jmp_buf newbuf ; 
  Scheme_Object * volatile v , * * volatile save_values ; 
  volatile int err ; 
  Scheme_Dynamic_Wind * volatile dw ; 
  volatile int save_count , old_cac ; 
  Scheme_Thread * p ; 
  int delta ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(dw, 0), PUSH(v, 1), PUSH(data, 2), PUSH(p, 3), PUSH(save_values, 4)));
# define XfOrM1900_COUNT (5)
# define SETUP_XfOrM1900(x) SETUP(XfOrM1900_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  save_values = NULLED_OUT ; 
  dw = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 9638 "bc/src/fun.c"
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (pre ) {
#   define XfOrM1922_COUNT (0+XfOrM1900_COUNT)
#   define SETUP_XfOrM1922(x) SETUP_XfOrM1900(x)
    FUNCCALL(SETUP_XfOrM1922(_), ASSERT_SUSPEND_BREAK_ZERO () )
# 9641 "bc/src/fun.c"
    ; 
    p -> suspend_break ++ ; 
    FUNCCALL(SETUP_XfOrM1922(_), pre (data ) ); 
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    -- p -> suspend_break ; 
  }




  dw = ((Scheme_Dynamic_Wind * ) FUNCCALL(SETUP_XfOrM1900(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Dynamic_Wind ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  dw -> type = scheme_rt_dyn_wind ; 


  dw -> data = data ; 
  dw -> pre = pre ; 
  dw -> post = post ; 
  dw -> prev = p -> dw ; 
  if (dw -> prev )
    dw -> depth = dw -> prev -> depth + 1 ; 
  else 
  dw -> depth = 0 ; 
  dw -> next_meta = p -> next_meta ; 

  p -> next_meta = 0 ; 
  p -> dw = dw ; 

  dw -> saveerr = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 

  (dw -> envss . runstack_offset = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , dw -> envss . cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , dw -> envss . cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ; 

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM1900_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#   define XfOrM1919_COUNT (0+XfOrM1900_COUNT)
#   define SETUP_XfOrM1919(x) SETUP_XfOrM1900(x)

# 9675 "bc/src/fun.c"
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + dw -> envss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = dw -> envss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = dw -> envss . cont_mark_pos ) ; 
    if ((p -> dw != dw ) 
    && (! p -> dw || ! dw -> id || (p -> dw -> id != dw -> id ) ) ) {







      (((intptr_t * ) (void * ) ((* dw -> saveerr ) . gcvs ) ) [1 ] = (* dw -> saveerr ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* dw -> saveerr ) . gcvs , longjmp ((* dw -> saveerr ) . jb , 1 ) ) ; 
    }

# 9687 "bc/src/fun.c"
    else {
#     define XfOrM1920_COUNT (0+XfOrM1919_COUNT)
#     define SETUP_XfOrM1920(x) SETUP_XfOrM1919(x)

# 9688 "bc/src/fun.c"
      if (jmp_handler )
        v = FUNCCALL(SETUP_XfOrM1920(_), jmp_handler (data ) ); 
      else 
      v = ((void * ) 0 ) ; 
      err = ! v ; 
    }
  }

# 9694 "bc/src/fun.c"
  else {
#   define XfOrM1917_COUNT (0+XfOrM1900_COUNT)
#   define SETUP_XfOrM1917(x) SETUP_XfOrM1900(x)

# 9695 "bc/src/fun.c"
    if (pre ) {
#     define XfOrM1918_COUNT (0+XfOrM1917_COUNT)
#     define SETUP_XfOrM1918(x) SETUP_XfOrM1917(x)
      FUNCCALL(SETUP_XfOrM1918(_), scheme_check_break_now () ); 
    }

    v = FUNCCALL(SETUP_XfOrM1917(_), act (data ) ); 

    err = 0 ; 
  }

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
    save_count = p -> ku . multiple . count ; 
    save_values = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
    if ((save_values ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
  }

# 9713 "bc/src/fun.c"
  else {
    save_count = 0 ; 
    save_values = ((void * ) 0 ) ; 
  }

  delta = p -> dw -> next_meta ; 
  p -> dw = p -> dw -> prev ; 

  p -> next_meta += delta ; 


  if (err && p -> cjs . is_kill && (post == post_dyn_wind ) )
    post = ((void * ) 0 ) ; 

  old_cac = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ; 

  if (post ) {
#   define XfOrM1911_COUNT (0+XfOrM1900_COUNT)
#   define SETUP_XfOrM1911(x) SETUP_XfOrM1900(x)

# 9730 "bc/src/fun.c"
    p -> error_buf = & newbuf ; 
    if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM1911_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + dw -> envss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = dw -> envss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = dw -> envss . cont_mark_pos ) ; 
      err = 1 ; 
    }

# 9735 "bc/src/fun.c"
    else {
      Scheme_Continuation_Jump_State cjs ; 
      BLOCK_SETUP((PUSH(cjs.jumping_to_continuation, 0+XfOrM1911_COUNT), PUSH(cjs.alt_full_continuation, 1+XfOrM1911_COUNT), PUSH(cjs.val, 2+XfOrM1911_COUNT)));
#     define XfOrM1912_COUNT (3+XfOrM1911_COUNT)
#     define SETUP_XfOrM1912(x) SETUP(XfOrM1912_COUNT)
      cjs.jumping_to_continuation = NULLED_OUT ; 
      cjs.alt_full_continuation = NULLED_OUT ; 
      cjs.val = NULLED_OUT ; 

# 9737 "bc/src/fun.c"
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      if (! p -> cjs . skip_dws ) {
#       define XfOrM1913_COUNT (0+XfOrM1912_COUNT)
#       define SETUP_XfOrM1913(x) SETUP_XfOrM1912(x)
        FUNCCALL(SETUP_XfOrM1913(_), ASSERT_SUSPEND_BREAK_ZERO () )
# 9739 "bc/src/fun.c"
        ; 
        p -> suspend_break ++ ; 
        FUNCCALL(SETUP_XfOrM1913(_), copy_cjs (& cjs , & p -> cjs ) ); 
        FUNCCALL_AGAIN(reset_cjs (& p -> cjs ) ); 
        FUNCCALL_AGAIN(post (data ) ); 
        FUNCCALL_AGAIN(copy_cjs (& p -> cjs , & cjs ) ); 
        p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
        -- p -> suspend_break ; 
      }
    }
  }

  if (err ) {
#   define XfOrM1903_COUNT (0+XfOrM1900_COUNT)
#   define SETUP_XfOrM1903(x) SETUP_XfOrM1900(x)
    if ((old_cac != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ) 
    && p -> cjs . jumping_to_continuation ) {
#     define XfOrM1904_COUNT (0+XfOrM1903_COUNT)
#     define SETUP_XfOrM1904(x) SETUP_XfOrM1903(x)

# 9756 "bc/src/fun.c"
      p -> error_buf = dw -> saveerr ; 
      if ((Scheme_Type ) (((((intptr_t ) (p -> cjs . jumping_to_continuation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p -> cjs . jumping_to_continuation ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_type ) )  {
        Scheme_Object * tag ; 
        Scheme_Prompt * prompt ; 
        BLOCK_SETUP((PUSH(prompt, 0+XfOrM1904_COUNT), PUSH(tag, 1+XfOrM1904_COUNT)));
#       define XfOrM1908_COUNT (2+XfOrM1904_COUNT)
#       define SETUP_XfOrM1908(x) SETUP(XfOrM1908_COUNT)
        tag = NULLED_OUT ; 
        prompt = NULLED_OUT ; 

# 9760 "bc/src/fun.c"
        tag = ((Scheme_Prompt * ) p -> cjs . jumping_to_continuation ) -> tag ; 
        prompt = (Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1908(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (tag ) ) -> u . ptr_val ) ) ); 
        if (! prompt && ((scheme_default_prompt_tag ) == (tag ) ) ) {
          prompt = original_default_prompt ; 
        }
        if (! prompt ) {
#         define XfOrM1909_COUNT (0+XfOrM1908_COUNT)
#         define SETUP_XfOrM1909(x) SETUP_XfOrM1908(x)
          FUNCCALL(SETUP_XfOrM1909(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "abort-current-continuation:" " abort in progress, but current continuation includes" " no prompt with the given tag" " after a `dynamic-wind' post-thunk return\n" "  tag: %V" , tag ) )



          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        p -> cjs . jumping_to_continuation = (Scheme_Object * ) prompt ; 
      }

# 9776 "bc/src/fun.c"
      else if ((Scheme_Type ) (((((intptr_t ) (p -> cjs . jumping_to_continuation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p -> cjs . jumping_to_continuation ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) )  {
#       define XfOrM1905_COUNT (0+XfOrM1904_COUNT)
#       define SETUP_XfOrM1905(x) SETUP_XfOrM1904(x)

# 9777 "bc/src/fun.c"
        if (! FUNCCALL(SETUP_XfOrM1905(_), scheme_escape_continuation_ok (p -> cjs . jumping_to_continuation ) )) {
#         define XfOrM1906_COUNT (0+XfOrM1905_COUNT)
#         define SETUP_XfOrM1906(x) SETUP_XfOrM1905(x)

# 9778 "bc/src/fun.c"
          if (p -> cjs . alt_full_continuation ) {
#           define XfOrM1907_COUNT (0+XfOrM1906_COUNT)
#           define SETUP_XfOrM1907(x) SETUP_XfOrM1906(x)
            RET_VALUE_START (FUNCCALL(SETUP_XfOrM1907(_), jump_to_alt_continuation () )) RET_VALUE_END ; 
          }
          FUNCCALL(SETUP_XfOrM1906(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "continuation application: lost target;\n" " jump to escape continuation in progress, and the target is not in the\n" " current continuation after a `dynamic-wind' post-thunk return" ) )


          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
    }

    (((intptr_t * ) (void * ) ((* dw -> saveerr ) . gcvs ) ) [1 ] = (* dw -> saveerr ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* dw -> saveerr ) . gcvs , longjmp ((* dw -> saveerr ) . jb , 1 ) ) ; 
  }

  p -> error_buf = dw -> saveerr ; 

  if (post ) {
#   define XfOrM1902_COUNT (0+XfOrM1900_COUNT)
#   define SETUP_XfOrM1902(x) SETUP_XfOrM1900(x)
    FUNCCALL(SETUP_XfOrM1902(_), scheme_check_break_now () )
# 9799 "bc/src/fun.c"
    ; 
  }

  if (v == ((Scheme_Object * ) 0x6 ) ) {
    p -> ku . multiple . count = save_count ; 
    p -> ku . multiple . array = save_values ; 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9810 "bc/src/fun.c"
void scheme_apply_dw_in_meta (Scheme_Dynamic_Wind * dw , int post_part , int meta_depth , Scheme_Cont * recheck ) 
{

# 9840 "bc/src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Meta_Continuation * mc , * old_mc , * rest ; 
  intptr_t delta ; 
  int i , actual_depth ; 
  int old_cac ; 
  PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(mc, 0), PUSH(rest, 1), PUSH(recheck, 2), PUSH(p, 3), PUSH(dw, 4), PUSH(old_mc, 5)));
# define XfOrM1923_COUNT (6)
# define SETUP_XfOrM1923(x) SETUP(XfOrM1923_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  mc = NULLED_OUT ; 
  old_mc = NULLED_OUT ; 
  rest = NULLED_OUT ; 

# 9846 "bc/src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = p -> cont_mark_stack_bottom ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = p -> meta_continuation -> meta_tail_pos + 2 ; 

  old_mc = p -> meta_continuation ; 


  for (i = 0 , actual_depth = 0 , rest = old_mc ; i < meta_depth ; actual_depth ++ ) {
    if (rest -> overflow )
      i ++ ; 
    rest = rest -> next ; 
  }
  mc = FUNCCALL(SETUP_XfOrM1923(_), clone_meta_cont (p -> meta_continuation , ((void * ) 0 ) , actual_depth , ((void * ) 0 ) , ((void * ) 0 ) , rest , 0 ) ); 
  p -> meta_continuation = mc ; 


  rest = mc ; 
  for (i = 0 ; i < actual_depth - 1 ; i ++ ) {
#   define XfOrM1933_COUNT (0+XfOrM1923_COUNT)
#   define SETUP_XfOrM1933(x) SETUP_XfOrM1923(x)

# 9863 "bc/src/fun.c"
    rest -> cont_mark_total = 0 ; 
    rest -> cont_mark_offset = rest -> cont_mark_stack ; 
    rest -> cont_mark_stack_copied = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM1933(_), sync_meta_cont (rest ) ); 
    rest = rest -> next ; 
  }


  delta = rest -> cont_mark_stack - dw -> envss . cont_mark_stack ; 
  if (delta ) {
#   define XfOrM1930_COUNT (0+XfOrM1923_COUNT)
#   define SETUP_XfOrM1930(x) SETUP_XfOrM1923(x)

# 9873 "bc/src/fun.c"
    rest -> cont_mark_total -= delta ; 
    rest -> cont_mark_stack -= delta ; 
    if (rest -> cont_mark_total ) {
      Scheme_Cont_Mark * cp ; 
      BLOCK_SETUP((PUSH(cp, 0+XfOrM1930_COUNT)));
#     define XfOrM1931_COUNT (1+XfOrM1930_COUNT)
#     define SETUP_XfOrM1931(x) SETUP(XfOrM1931_COUNT)
      cp = NULLED_OUT ; 

# 9877 "bc/src/fun.c"
      cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM1931(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (rest -> cont_mark_total ) ) )) ; 
      (memcpy (cp , rest -> cont_mark_stack_copied , rest -> cont_mark_total * sizeof (Scheme_Cont_Mark ) ) ) ; 
      rest -> cont_mark_stack_copied = cp ; 
    }

# 9880 "bc/src/fun.c"
    else 
    rest -> cont_mark_stack_copied = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM1930(_), sync_meta_cont (rest ) ); 
  }

  old_cac = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ; 


  if (post_part ) {
    DW_PrePost_Proc post = dw -> post ; 
#   define XfOrM1929_COUNT (0+XfOrM1923_COUNT)
#   define SETUP_XfOrM1929(x) SETUP_XfOrM1923(x)
    FUNCCALL(SETUP_XfOrM1929(_), post (dw -> data ) )
# 9890 "bc/src/fun.c"
    ; 
  }

# 9891 "bc/src/fun.c"
  else {
    DW_PrePost_Proc pre = dw -> pre ; 
#   define XfOrM1928_COUNT (0+XfOrM1923_COUNT)
#   define SETUP_XfOrM1928(x) SETUP_XfOrM1923(x)
    FUNCCALL(SETUP_XfOrM1928(_), pre (dw -> data ) )
# 9893 "bc/src/fun.c"
    ; 
  }

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (recheck && ! recheck -> composable ) {
#   define XfOrM1926_COUNT (0+XfOrM1923_COUNT)
#   define SETUP_XfOrM1926(x) SETUP_XfOrM1923(x)

# 9899 "bc/src/fun.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) != old_cac ) {
#     define XfOrM1927_COUNT (0+XfOrM1926_COUNT)
#     define SETUP_XfOrM1927(x) SETUP_XfOrM1926(x)
      FUNCCALL(SETUP_XfOrM1927(_), scheme_recheck_prompt_and_barrier (recheck ) )
# 9900 "bc/src/fun.c"
      ; 
    }
  }




  for (i = 0 , rest = p -> meta_continuation ; i < actual_depth ; i ++ ) {
    rest = rest -> next ; 
  }
  old_mc = FUNCCALL(SETUP_XfOrM1923(_), clone_meta_cont (old_mc , ((void * ) 0 ) , actual_depth , ((void * ) 0 ) , ((void * ) 0 ) , rest , 0 ) ); 
  p -> meta_continuation = old_mc ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9914 "bc/src/fun.c"
static Scheme_Object * jump_to_alt_continuation () 
{
  Scheme_Thread * p ; 
  Scheme_Object * a [1 ] , * * args , * fc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM1936_COUNT (3)
# define SETUP_XfOrM1936(x) SETUP(XfOrM1936_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  args = NULLED_OUT ; 
  fc = NULLED_OUT ; 

# 9919 "bc/src/fun.c"
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  a [0 ] = p -> cjs . val ; 
  fc = p -> cjs . alt_full_continuation ; 
  args = ((p -> cjs . num_vals == 1 ) ? a : (Scheme_Object * * ) p -> cjs . val ) ; 
  p -> cjs . jumping_to_continuation = ((void * ) 0 ) ; 
  p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
  p -> cjs . val = ((void * ) 0 ) ; 
  p -> cjs . skip_dws = 0 ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1936(_), scheme_jump_to_continuation (fc , p -> cjs . num_vals , args , ((void * ) 0 ) , 0 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

uintptr_t scheme_get_milliseconds (void ) 

{
  /* No conversion */

# 9939 "bc/src/fun.c"
  return rktio_get_milliseconds () ; 
}

double scheme_get_inexact_milliseconds (void ) 

{
  /* No conversion */

# 9945 "bc/src/fun.c"
  return rktio_get_inexact_milliseconds () ; 
}

static double get_inexact_monotonic_milliseconds (void ) 

{
  /* No conversion */

# 9951 "bc/src/fun.c"
  return rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

intptr_t scheme_get_process_milliseconds (void ) 
{
  /* No conversion */

# 9956 "bc/src/fun.c"
  return rktio_get_process_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

intptr_t scheme_get_process_children_milliseconds (void ) 
{
  /* No conversion */

# 9961 "bc/src/fun.c"
  return rktio_get_process_children_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

intptr_t scheme_get_thread_milliseconds (Scheme_Object * thrd ) 
XFORM_SKIP_PROC 
{
  Scheme_Thread * t = thrd ? (Scheme_Thread * ) thrd : XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (t == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
    intptr_t cpm ; 
    cpm = scheme_get_process_milliseconds () ; 
    return t -> accum_process_msec + (cpm - t -> current_start_process_msec ) ; 
  }

# 9973 "bc/src/fun.c"
  else {
    return t -> accum_process_msec ; 
  }
}

intptr_t scheme_get_seconds (void ) 
{
  /* No conversion */

# 9980 "bc/src/fun.c"
  return rktio_get_seconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

static Scheme_Object * seconds_to_date (int argc , Scheme_Object * * argv ) 
{
  intptr_t lnow ; 
  int get_gmt ; 
  rktio_date_t * dt ; 
  Scheme_Object * p [12 ] , * secs , * nsecs , * zname ; 
  char * tzn ; 

# 1436 "rktio/rktio.h"
  const char * __funcarg217 = NULLED_OUT ; 

# 1385 "rktio/rktio.h"
  int __funcarg216 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(dt, 0), PUSH(nsecs, 1), PUSH(tzn, 2), PUSH(secs, 3), PUSH(zname, 4), PUSH(argv, 5), PUSHARRAY(p, 12, 6)));
# define XfOrM1943_COUNT (9)
# define SETUP_XfOrM1943(x) SETUP(XfOrM1943_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  dt = NULLED_OUT ; 
  NULL_OUT_ARRAY (p ) ; 
  secs = NULLED_OUT ; 
  nsecs = NULLED_OUT ; 
  zname = NULLED_OUT ; 
  tzn = NULLED_OUT ; 

# 9991 "bc/src/fun.c"
  secs = argv [0 ] ; 

  if (! ((((intptr_t ) (secs ) ) & 0x1 ) || ((((secs ) -> type ) >= scheme_bignum_type ) && (((secs ) -> type ) < scheme_complex_type ) ) ) ) {
#   define XfOrM1949_COUNT (0+XfOrM1943_COUNT)
#   define SETUP_XfOrM1949(x) SETUP_XfOrM1943(x)
    FUNCCALL(SETUP_XfOrM1949(_), scheme_wrong_contract ("seconds->date" , "real?" , 0 , argc , argv ) )
# 9994 "bc/src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc > 1 )
    get_gmt = (((argv [1 ] ) ) == (scheme_false ) ) ; 
  else 
  get_gmt = 0 ; 

  if ((((intptr_t ) (secs ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (secs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (secs ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
    nsecs = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  }

# 10005 "bc/src/fun.c"
  else {
#   define XfOrM1947_COUNT (0+XfOrM1943_COUNT)
#   define SETUP_XfOrM1947(x) SETUP_XfOrM1943(x)

# 10006 "bc/src/fun.c"
    p [0 ] = secs ; 
    secs = FUNCCALL(SETUP_XfOrM1947(_), scheme_inexact_to_exact (1 , p ) ); 
    nsecs = secs ; 
    p [0 ] = secs ; 
    secs = FUNCCALL(SETUP_XfOrM1947(_), scheme_floor (1 , p ) ); 
    nsecs = FUNCCALL_AGAIN(scheme_bin_minus (nsecs , secs ) ); 
    nsecs = FUNCCALL_AGAIN(scheme_bin_mult (nsecs , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1000000000 ) ) ) << 1 ) | 0x1 ) ) ) ); 
    p [0 ] = nsecs ; 
    nsecs = FUNCCALL(SETUP_XfOrM1947(_), scheme_floor (1 , p ) ); 
    p [0 ] = nsecs ; 
    nsecs = FUNCCALL(SETUP_XfOrM1947(_), scheme_inexact_to_exact (1 , p ) ); 
    p [0 ] = secs ; 
    secs = FUNCCALL(SETUP_XfOrM1947(_), scheme_inexact_to_exact (1 , p ) ); 
  }

  if (scheme_get_int_val (secs , & lnow ) )  {
#   define XfOrM1944_COUNT (0+XfOrM1943_COUNT)
#   define SETUP_XfOrM1944(x) SETUP_XfOrM1943(x)

# 10022 "bc/src/fun.c"
    dt = (rktio_seconds_to_date (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , lnow , (((intptr_t ) (nsecs ) ) >> 1 ) , get_gmt ) ) ; 
    if (dt ) {
#     define XfOrM1946_COUNT (0+XfOrM1944_COUNT)
#     define SETUP_XfOrM1946(x) SETUP_XfOrM1944(x)

# 10024 "bc/src/fun.c"
      tzn = dt -> zone_name ; 
      if (! tzn )
        tzn = "?" ; 
      zname = FUNCCALL(SETUP_XfOrM1946(_), scheme_make_utf8_string (tzn ) ); 
      ((((Scheme_Inclhash_Object * ) (zname ) ) -> so . keyex |= 0x1 ) ) ; 

      p [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> second ) ) ) << 1 ) | 0x1 ) ) ; 
      p [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> minute ) ) ) << 1 ) | 0x1 ) ) ; 
      p [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> hour ) ) ) << 1 ) | 0x1 ) ) ; 
      p [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> day ) ) ) << 1 ) | 0x1 ) ) ; 
      p [4 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> month ) ) ) << 1 ) | 0x1 ) ) ; 
      p [5 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> year ) ) ) << 1 ) | 0x1 ) ) ; 
      p [6 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> day_of_week ) ) ) << 1 ) | 0x1 ) ) ; 
      p [7 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> day_of_year ) ) ) << 1 ) | 0x1 ) ) ; 
      p [8 ] = (dt -> is_dst ? scheme_true : scheme_false ) ; 
      p [9 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> zone_offset ) ) ) << 1 ) | 0x1 ) ) ; 
      p [10 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> nanosecond ) ) ) << 1 ) | 0x1 ) ) ; 
      p [11 ] = zname ; 

      if (dt -> zone_name )
        (rktio_free (dt -> zone_name ) ) ; 
      FUNCCALL(SETUP_XfOrM1946(_), free (dt ) ); 

      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1946(_), scheme_make_struct_instance (scheme_date , 12 , p ) )) RET_VALUE_END ; 
    }

# 10048 "bc/src/fun.c"
    else if (((rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) != RKTIO_ERROR_TIME_OUT_OF_RANGE ) 
    || ((rktio_get_last_error_kind (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) != RKTIO_ERROR_KIND_RACKET ) ) {
#     define XfOrM1945_COUNT (0+XfOrM1944_COUNT)
#     define SETUP_XfOrM1945(x) SETUP_XfOrM1944(x)
      (__funcarg216 = (
      rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) , __funcarg217 = (
      rktio_get_last_error_string (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) , FUNCCALL(SETUP_XfOrM1945(_), scheme_raise_exn (MZEXN_FAIL , "seconds->date: conversion error\n" "  error: %d; %s" , __funcarg216 , __funcarg217 ) )) ; 
    }
  }
  FUNCCALL(SETUP_XfOrM1943(_), scheme_raise_exn (MZEXN_FAIL , "seconds->date: integer is out-of-range\n" "  integer: %V" , secs ) )



  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10066 "bc/src/fun.c"
static Scheme_Object * time_apply (int argc , Scheme_Object * argv [] ) 
{
  double start , end ; 
  uintptr_t cpustart , cpuend ; 
  uintptr_t gcstart , gcend ; 
  uintptr_t dur , cpudur , gcdur ; 
  int i , num_rands ; 
  Scheme_Object * v , * p [4 ] , * * rand_vec , * rands , * r ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(rands, 1), PUSH(argv, 2), PUSHARRAY(p, 4, 3), PUSH(v, 6), PUSH(rand_vec, 7)));
# define XfOrM1950_COUNT (8)
# define SETUP_XfOrM1950(x) SETUP(XfOrM1950_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  NULL_OUT_ARRAY (p ) ; 
  rand_vec = NULLED_OUT ; 
  rands = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 10075 "bc/src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM1950(_), scheme_wrong_contract ("time-apply" , "procedure?" , 0 , argc , argv ) ); 

  rands = argv [1 ] ; 

  num_rands = 0 ; 
  r = rands ; 
  while (! ((r ) == (scheme_null ) ) ) {
#   define XfOrM1956_COUNT (0+XfOrM1950_COUNT)
#   define SETUP_XfOrM1956(x) SETUP_XfOrM1950(x)

# 10083 "bc/src/fun.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (r ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (r ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      FUNCCALL(SETUP_XfOrM1956(_), scheme_wrong_contract ("time-apply" , "list?" , 1 , argc , argv ) ); 
    r = (((Scheme_Simple_Object * ) (r ) ) -> u . pair_val . cdr ) ; 
    num_rands ++ ; 
  }

  if (((FUNCCALL(SETUP_XfOrM1950(_), get_or_check_arity (argv [0 ] , num_rands , ((void * ) 0 ) , 1 ) )) ) == (scheme_false ) )  {
#   define XfOrM1954_COUNT (0+XfOrM1950_COUNT)
#   define SETUP_XfOrM1954(x) SETUP_XfOrM1950(x)
    FUNCCALL(SETUP_XfOrM1954(_), scheme_contract_error ("time-apply" , "arity mismatch between procedure and argument-list length\n" , "procedure" , 1 , argv [0 ] , "argument-list length" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_rands ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )

    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  rand_vec = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1950(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rands ) ) )) ; 
  for (i = 0 ; ((Scheme_Type ) (((((intptr_t ) (rands ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rands ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; i ++ , rands = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . cdr ) ) {
    rand_vec [i ] = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . car ) ; 
  }

  gcstart = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ; 
  start = FUNCCALL(SETUP_XfOrM1950(_), get_inexact_monotonic_milliseconds () ); 
  cpustart = (scheme_get_process_milliseconds () ) ; 
  v = FUNCCALL(SETUP_XfOrM1950(_), scheme_do_eval (argv [0 ] , num_rands , rand_vec , - 1 ) ); 
  cpuend = (scheme_get_process_milliseconds () ) ; 
  end = FUNCCALL(SETUP_XfOrM1950(_), get_inexact_monotonic_milliseconds () ); 
  gcend = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ; 

  dur = (uintptr_t ) (end - start ) ; 
  cpudur = cpuend - cpustart ; 
  gcdur = gcend - gcstart ; 

  if (v == ((Scheme_Object * ) 0x6 ) ) {
    Scheme_Thread * cp = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    Scheme_Object * * args ; 
#   define XfOrM1951_COUNT (0+XfOrM1950_COUNT)
#   define SETUP_XfOrM1951(x) SETUP_XfOrM1950(x)
    args = NULLED_OUT ; 

# 10118 "bc/src/fun.c"
    if ((cp -> ku . multiple . array ) == (cp -> values_buffer ) ) 
      cp -> values_buffer = ((void * ) 0 ) ; 
    args = cp -> ku . multiple . array ; 
    cp -> ku . multiple . array = ((void * ) 0 ) ; 
    v = FUNCCALL(SETUP_XfOrM1951(_), scheme_build_list (cp -> ku . multiple . count , args ) ); 
  }

# 10123 "bc/src/fun.c"
  else 
  v = FUNCCALL(SETUP_XfOrM1950(_), scheme_make_pair (v , scheme_null ) ); 

  p [0 ] = v ; 
  p [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cpudur ) ) ) << 1 ) | 0x1 ) ) ; 
  p [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dur ) ) ) << 1 ) | 0x1 ) ) ; 
  p [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (gcdur ) ) ) << 1 ) | 0x1 ) ) ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1950(_), scheme_values (4 , p ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10134 "bc/src/fun.c"
static Scheme_Object * current_milliseconds (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10136 "bc/src/fun.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_get_milliseconds () ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * current_inexact_milliseconds (int argc , Scheme_Object * * argv ) 
{

# 9942 "bc/src/fun.c"
  double __funcarg218 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM1958_COUNT (0)
# define SETUP_XfOrM1958(x) SETUP(XfOrM1958_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 10141 "bc/src/fun.c"
  RET_VALUE_START ((__funcarg218 = (scheme_get_inexact_milliseconds () ) , FUNCCALL_EMPTY(scheme_make_double (__funcarg218 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10144 "bc/src/fun.c"
static Scheme_Object * current_inexact_monotonic_milliseconds (int argc , Scheme_Object * * argv ) 
{

# 9948 "bc/src/fun.c"
  double __funcarg219 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM1959_COUNT (0)
# define SETUP_XfOrM1959(x) SETUP(XfOrM1959_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 10146 "bc/src/fun.c"
  RET_VALUE_START ((__funcarg219 = FUNCCALL_EMPTY(get_inexact_monotonic_milliseconds () ), FUNCCALL_EMPTY(scheme_make_double (__funcarg219 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10149 "bc/src/fun.c"
static Scheme_Object * current_process_milliseconds (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10151 "bc/src/fun.c"
  if (! argc || (((argv [0 ] ) ) == (scheme_false ) ) )
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_get_process_milliseconds () ) ) ) << 1 ) | 0x1 ) ) ; 
  else if ((argv [0 ] ) == (subprocesses_symbol ) ) 
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_get_process_children_milliseconds () ) ) ) << 1 ) | 0x1 ) ) ; 
  else {
    if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) 
      return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_get_thread_milliseconds (argv [0 ] ) ) ) ) << 1 ) | 0x1 ) ) ; 
    scheme_wrong_contract ("current-process-milliseconds" , "(or/c #f thread? 'subprocesses)" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
}

static Scheme_Object * current_gc_milliseconds (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10165 "bc/src/fun.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * current_seconds (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10170 "bc/src/fun.c"
  intptr_t secs ; 
  secs = scheme_get_seconds () ; 
  return scheme_make_integer_value ((intptr_t ) secs ) ; 
}






static Scheme_Object * 
current_print (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10183 "bc/src/fun.c"
  return scheme_param_config ("current-print" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_prompt_read (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10192 "bc/src/fun.c"
  return scheme_param_config ("current-prompt-read" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PROMPT_READ_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_read (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10201 "bc/src/fun.c"
  return scheme_param_config ("current-read-interaction" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_READ_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_get_read_input_port (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10210 "bc/src/fun.c"
  return scheme_param_config ("current-get-interaction-input-port" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_READ_INPUT_PORT_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_get_interaction_evt (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10219 "bc/src/fun.c"
  return scheme_param_config ("current-get-interaction-evt" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_READ_GET_EVT ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

Scheme_Object * 
scheme_default_print_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * obj = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSHARRAY(argv, 2, 1)));
# define XfOrM1969_COUNT (4)
# define SETUP_XfOrM1969(x) SETUP(XfOrM1969_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 10230 "bc/src/fun.c"
  if (! ((obj ) == (scheme_void ) ) ) {
    Scheme_Config * config ; 
    Scheme_Object * port ; 
    Scheme_Object * argv [2 ] ; 
    BLOCK_SETUP((PUSH(port, 0+XfOrM1969_COUNT), PUSHARRAY(argv, 2, 1+XfOrM1969_COUNT), PUSH(config, 4+XfOrM1969_COUNT)));
#   define XfOrM1970_COUNT (5+XfOrM1969_COUNT)
#   define SETUP_XfOrM1970(x) SETUP(XfOrM1970_COUNT)
    config = NULLED_OUT ; 
    port = NULLED_OUT ; 
    argv[0] = NULLED_OUT ; 
    argv[1] = NULLED_OUT ; 

# 10235 "bc/src/fun.c"
    config = FUNCCALL(SETUP_XfOrM1970(_), scheme_current_config () ); 
    port = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_OUTPUT_PORT ) ); 

    argv [0 ] = obj ; 
    argv [1 ] = port ; 
    FUNCCALL(SETUP_XfOrM1970(_), scheme_do_eval (scheme_print_proc , 2 , argv , 1 ) ); 
    FUNCCALL_AGAIN(scheme_write_byte_string ("\n" , 1 , port ) ); 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10247 "bc/src/fun.c"
Scheme_Object * 
scheme_default_read_input_port_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * inport ; 
  Scheme_Config * __funcarg220 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(inport, 0)));
# define XfOrM1971_COUNT (1)
# define SETUP_XfOrM1971(x) SETUP(XfOrM1971_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inport = NULLED_OUT ; 

# 10252 "bc/src/fun.c"
  inport = (__funcarg220 = FUNCCALL(SETUP_XfOrM1971(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg220 , MZCONFIG_INPUT_PORT ) )) ; 

  if (inport == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) )
    FUNCCALL(SETUP_XfOrM1971(_), scheme_flush_orig_outputs () ); 

  RET_VALUE_START (inport ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10260 "bc/src/fun.c"
Scheme_Object * 
scheme_default_read_get_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 10263 "bc/src/fun.c"
  return scheme_never_ready_evt ; 
}

Scheme_Object * 
scheme_default_prompt_read_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * config ; 
  Scheme_Object * port , * reader , * getter ; 
  Scheme_Object * inport , * name , * a [4 ] , * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(inport, 1), PUSH(config, 2), PUSH(reader, 3), PUSH(name, 4), PUSH(v, 5), PUSH(getter, 6), PUSHARRAY(a, 4, 7)));
# define XfOrM1973_COUNT (10)
# define SETUP_XfOrM1973(x) SETUP(XfOrM1973_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  config = NULLED_OUT ; 
  port = NULLED_OUT ; 
  reader = NULLED_OUT ; 
  getter = NULLED_OUT ; 
  inport = NULLED_OUT ; 
  name = NULLED_OUT ; 
  NULL_OUT_ARRAY (a ) ; 
  v = NULLED_OUT ; 

# 10273 "bc/src/fun.c"
  config = FUNCCALL(SETUP_XfOrM1973(_), scheme_current_config () ); 
  port = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_OUTPUT_PORT ) ); 
  FUNCCALL_AGAIN(scheme_write_byte_string ("> " , 2 , port ) )
  ; 
  FUNCCALL_AGAIN(scheme_flush_output (port ) ); 

  getter = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_READ_INPUT_PORT_HANDLER ) ); 
  inport = FUNCCALL_AGAIN(scheme_do_eval (getter , 0 , ((void * ) 0 ) , 1 ) ); 

  if (! ((Scheme_Type ) (((((intptr_t ) (inport ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inport ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) ) )
    FUNCCALL(SETUP_XfOrM1973(_), scheme_wrong_contract ("default-prompt-read-hander" , "input-port?" , - 1 , - 1 , & inport ) ); 

  name = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM1973(_), scheme_port_record (inport ) ); 
  name = ((Scheme_Input_Port * ) name ) -> name ; 

  reader = FUNCCALL(SETUP_XfOrM1973(_), scheme_get_param (config , MZCONFIG_READ_HANDLER ) ); 

  a [0 ] = name ; 
  a [1 ] = inport ; 
  v = FUNCCALL(SETUP_XfOrM1973(_), scheme_do_eval (reader , 2 , a , 1 ) ); 

  a [0 ] = inport ; 
  if (! (((FUNCCALL(SETUP_XfOrM1973(_), scheme_terminal_port_p (1 , a ) )) ) == (scheme_false ) ) )  {
#   define XfOrM1974_COUNT (0+XfOrM1973_COUNT)
#   define SETUP_XfOrM1974(x) SETUP_XfOrM1973(x)

# 10296 "bc/src/fun.c"
    a [0 ] = port ; 
    if (! (((FUNCCALL(SETUP_XfOrM1974(_), scheme_terminal_port_p (1 , a ) )) ) == (scheme_false ) ) )  {
      intptr_t line , col , pos ; 
#     define XfOrM1975_COUNT (0+XfOrM1974_COUNT)
#     define SETUP_XfOrM1975(x) SETUP_XfOrM1974(x)
      FUNCCALL(SETUP_XfOrM1975(_), scheme_tell_all (port , & line , & col , & pos ) )
# 10299 "bc/src/fun.c"
      ; 
      if ((col > 0 ) && (line > 0 ) ) {
#       define XfOrM1976_COUNT (0+XfOrM1975_COUNT)
#       define SETUP_XfOrM1976(x) SETUP_XfOrM1975(x)

        a [0 ] = port ; 
        a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (line + 1 ) ) ) << 1 ) | 0x1 ) ) ; 
        a [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
        if (pos > 0 )
          a [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos + 2 ) ) ) << 1 ) | 0x1 ) ) ; 
        else 
        a [3 ] = scheme_false ; 
        FUNCCALL(SETUP_XfOrM1976(_), scheme_set_port_location (4 , a ) ); 
      }
    }
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10319 "bc/src/fun.c"
Scheme_Object * 
scheme_default_read_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * config ; 
  Scheme_Object * name = argv [0 ] ; 
  Scheme_Object * inport = argv [1 ] ; 
  Scheme_Object * stx ; 
  Scheme_Cont_Frame_Data cframe ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(stx, 1), PUSH(cframe.cache, 2), PUSH(inport, 3), PUSH(config, 4)));
# define XfOrM1977_COUNT (5)
# define SETUP_XfOrM1977(x) SETUP(XfOrM1977_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  config = NULLED_OUT ; 
  stx = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 10328 "bc/src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (inport ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inport ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) ) )
    FUNCCALL(SETUP_XfOrM1977(_), scheme_wrong_contract ("default-read-interaction-handler" , "input-port?" , 1 , argc , argv ) )



  ; 

  config = FUNCCALL(SETUP_XfOrM1977(_), scheme_current_config () ); 
  FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )







  ; 
  FUNCCALL_AGAIN(scheme_install_config (config ) ); 

  stx = FUNCCALL_AGAIN(scheme_read_syntax (inport , name ) ); 
  FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) )
  ; 

  RET_VALUE_START (stx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "bc/src/mzmark_fun.inc"
static int mark_dyn_wind_cell_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_dyn_wind_cell_MARK (void * p , struct NewGC * gc ) {

  Scheme_Dynamic_Wind_List * l = (Scheme_Dynamic_Wind_List * ) p ; 

  GC_mark2 (& (l -> dw ) , gc ) ; 
  GC_mark2 (& (l -> next ) , gc ) ; 


  return 0 ; 
}






static int mark_dyn_wind_cell_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Dynamic_Wind_List * l = (Scheme_Dynamic_Wind_List * ) p ; 

  GC_fixup2 (& (l -> dw ) , gc ) ; 
  GC_fixup2 (& (l -> next ) , gc ) ; 


  return 0 ; 
}

# 47 "bc/src/mzmark_fun.inc"
static int mark_dyn_wind_info_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_dyn_wind_info_MARK (void * p , struct NewGC * gc ) {

  Dyn_Wind * d = (Dyn_Wind * ) p ; 

  GC_mark2 (& (d -> pre ) , gc ) ; 
  GC_mark2 (& (d -> act ) , gc ) ; 
  GC_mark2 (& (d -> post ) , gc ) ; 


  return 0 ; 
}






static int mark_dyn_wind_info_FIXUP (void * p , struct NewGC * gc ) {

  Dyn_Wind * d = (Dyn_Wind * ) p ; 

  GC_fixup2 (& (d -> pre ) , gc ) ; 
  GC_fixup2 (& (d -> act ) , gc ) ; 
  GC_fixup2 (& (d -> post ) , gc ) ; 


  return 0 ; 
}

# 93 "bc/src/mzmark_fun.inc"
static int mark_cont_mark_chain_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_cont_mark_chain_MARK (void * p , struct NewGC * gc ) {

  Scheme_Cont_Mark_Chain * c = (Scheme_Cont_Mark_Chain * ) p ; 

  GC_mark2 (& (c -> key ) , gc ) ; 
  GC_mark2 (& (c -> val ) , gc ) ; 
  GC_mark2 (& (c -> next ) , gc ) ; 


  return 0 ; 
}






static int mark_cont_mark_chain_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Cont_Mark_Chain * c = (Scheme_Cont_Mark_Chain * ) p ; 

  GC_fixup2 (& (c -> key ) , gc ) ; 
  GC_fixup2 (& (c -> val ) , gc ) ; 
  GC_fixup2 (& (c -> next ) , gc ) ; 


  return 0 ; 
}

# 10364 "bc/src/fun.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_dyn_wind_cell , mark_dyn_wind_cell_SIZE , mark_dyn_wind_cell_MARK , mark_dyn_wind_cell_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_dyn_wind_info , mark_dyn_wind_info_SIZE , mark_dyn_wind_info_MARK , mark_dyn_wind_info_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_cont_mark_chain_type , mark_cont_mark_chain_SIZE , mark_cont_mark_chain_MARK , mark_cont_mark_chain_FIXUP , 1 , 0 ) ; 
}
