#include "precomp.h"

# 5 "bc/src/list.c"
Scheme_Object scheme_null [1 ] ; 
Scheme_Object * scheme_null_p_proc ; 
Scheme_Object * scheme_pair_p_proc ; 
Scheme_Object * scheme_mpair_p_proc ; 
Scheme_Object * scheme_car_proc ; 
Scheme_Object * scheme_cdr_proc ; 
Scheme_Object * scheme_cons_proc ; 
Scheme_Object * scheme_mcons_proc ; 
Scheme_Object * scheme_list_p_proc ; 
Scheme_Object * scheme_list_proc ; 
Scheme_Object * scheme_list_star_proc ; 
Scheme_Object * scheme_list_pair_p_proc ; 
Scheme_Object * scheme_append_proc ; 
Scheme_Object * scheme_box_proc ; 
Scheme_Object * scheme_box_immutable_proc ; 
Scheme_Object * scheme_box_p_proc ; 
Scheme_Object * scheme_hash_ref_proc ; 
Scheme_Object * scheme_hash_proc ; 
Scheme_Object * scheme_hasheq_proc ; 
Scheme_Object * scheme_hasheqv_proc ; 
Scheme_Object * scheme_hashalw_proc ; 
Scheme_Object * scheme_unsafe_cons_list_proc ; 
Scheme_Object * scheme_unsafe_car_proc ; 
Scheme_Object * scheme_unsafe_cdr_proc ; 
Scheme_Object * scheme_unsafe_mcar_proc ; 
Scheme_Object * scheme_unsafe_mcdr_proc ; 
Scheme_Object * scheme_unsafe_unbox_proc ; 
Scheme_Object * scheme_unsafe_unbox_star_proc ; 
Scheme_Object * scheme_unsafe_set_box_star_proc ; 


static Scheme_Hash_Tree * empty_hash ; 
static Scheme_Hash_Tree * empty_hasheq ; 
static Scheme_Hash_Tree * empty_hasheqv ; 
static Scheme_Hash_Tree * empty_hashalw ; 


static Scheme_Object * pair_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * mpair_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cons_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * mcons_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * null_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * list_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * list_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * list_star_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * list_pair_p_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * immutablep (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * length_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * append_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * reverse_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * memv (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * memq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * assv (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * assq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * assoc (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * caaar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * caadr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cadar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cdaar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cdadr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cddar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * caddr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cdddr_prim (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * cddddr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cadddr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cdaddr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cddadr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cdddar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * caaddr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cadadr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * caddar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cdaadr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cdadar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cddaar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cdaaar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cadaar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * caadar_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * caaadr_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * caaaar_prim (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * box (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * immutable_box (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * box_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unbox (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unbox_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * set_box (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * set_box_star (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_box_cas (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_box (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * impersonate_box (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * make_hash (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_hasheq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_hasheqv (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_hashalw (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_weak_hash (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_weak_hasheq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_weak_hasheqv (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_weak_hashalw (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_ephemeron_hash (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_ephemeron_hasheq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_ephemeron_hasheqv (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_ephemeron_hashalw (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_make_immutable_hash (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_make_immutable_hasheq (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_make_immutable_hasheqv (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_make_immutable_hashalw (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * direct_hash (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * direct_hasheq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * direct_hasheqv (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * direct_hashalw (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_copy (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_p (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_eq_p (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_eqv_p (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_equal_p (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_equal_always_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_strong_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_weak_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_ephemeron_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_ref_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_put_bang (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_table_put (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_remove_bang (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_remove (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_clear_bang (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_clear (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_map (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_table_for_each (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_table_iterate_start (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_table_iterate_next (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_table_iterate_key (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_table_iterate_value (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_table_iterate_pair (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_hash_table_iterate_key_value (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * hash_keys_subset_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * eq_hash_code (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equal_hash_code (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equal_hash2_code (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equal_always_hash_code (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * equal_always_hash2_code (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * eqv_hash_code (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_hash (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * impersonate_hash (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * make_weak_box (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * weak_box_value (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * weak_boxp (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_ephemeron (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * ephemeron_value (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * ephemeronp (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonator_ephemeron (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_graph (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_placeholder (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * placeholder_set (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * placeholder_get (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * placeholder_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_hash_placeholder (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_hasheq_placeholder (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_hasheqv_placeholder (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_hashalw_placeholder (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * table_placeholder_p (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_cons_list (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_car (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_cdr (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_list_ref (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_list_tail (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_mcar (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_mcdr (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_set_mcar (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_set_mcdr (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_unbox (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_unbox_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_set_box (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_set_box_star (int argc , Scheme_Object * argv [] ) ; 


static Scheme_Object * unsafe_hash_table_iterate_start (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_table_iterate_next (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_table_iterate_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_table_iterate_value (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_table_iterate_pair (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_table_iterate_key_value (int argc , Scheme_Object * argv [] ) ; 


static Scheme_Object * unsafe_hash_tree_iterate_start (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_tree_iterate_next (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_tree_iterate_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_tree_iterate_value (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_tree_iterate_pair (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_hash_tree_iterate_key_value (int argc , Scheme_Object * argv [] ) ; 


static Scheme_Object * unsafe_bucket_table_iterate_start (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bucket_table_iterate_next (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bucket_table_iterate_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bucket_table_iterate_value (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bucket_table_iterate_pair (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_bucket_table_iterate_key_value (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * chaperone_hash_key (const char * name , Scheme_Object * table , Scheme_Object * key ) ; 
static void chaperone_hash_key_value (const char * name , Scheme_Object * obj , Scheme_Object * k , Scheme_Object * * _chap_key , Scheme_Object * * _chap_val , int ischap ) ; 
static Scheme_Object * chaperone_hash_tree_set (Scheme_Object * table , Scheme_Object * key , Scheme_Object * val ) ; 
static Scheme_Object * chaperone_hash_clear (const char * name , Scheme_Object * table ) ; 

void 
scheme_init_list (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM1_COUNT (2)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 219 "bc/src/list.c"
  scheme_null -> type = scheme_null_type ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("null" , scheme_null , env ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_pair_p_proc , sizeof (scheme_pair_p_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (pair_p_prim , "pair?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("pair?" , p , env ) ); 
  scheme_pair_p_proc = p ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & scheme_mpair_p_proc , sizeof (scheme_mpair_p_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (mpair_p_prim , "mpair?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("mpair?" , p , env ) ); 
  scheme_mpair_p_proc = p ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & scheme_cons_proc , sizeof (scheme_cons_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (cons_prim , "cons" , 2 , 2 ) ); 
  scheme_cons_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cons" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_car_proc , sizeof (scheme_car_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_checked_car , "car" , 1 , 1 , 1 ) ); 
  scheme_car_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("car" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_cdr_proc , sizeof (scheme_cdr_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_checked_cdr , "cdr" , 1 , 1 , 1 ) ); 
  scheme_cdr_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdr" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_mcons_proc , sizeof (scheme_mcons_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (mcons_prim , "mcons" , 2 , 2 ) ); 
  scheme_mcons_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 5 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("mcons" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_checked_mcar , "mcar" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("mcar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_checked_mcdr , "mcdr" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("mcdr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_checked_set_mcar , "set-mcar!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("set-mcar!" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_checked_set_mcdr , "set-mcdr!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("set-mcdr!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_null_p_proc , sizeof (scheme_null_p_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (null_p_prim , "null?" , 1 , 1 , 1 ) ); 
  scheme_null_p_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("null?" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_list_p_proc , sizeof (scheme_list_p_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (list_p_prim , "list?" , 1 , 1 , 1 ) ); 
  scheme_list_p_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("list?" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_list_proc , sizeof (scheme_list_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (list_prim , "list" , 0 , - 1 ) ); 
  scheme_list_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("list" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_list_star_proc , sizeof (scheme_list_star_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (list_star_prim , "list*" , 1 , - 1 ) ); 
  scheme_list_star_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("list*" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_list_pair_p_proc , sizeof (scheme_list_pair_p_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (list_pair_p_prim , "list-pair?" , 1 , 1 , 1 ) ); 
  scheme_list_pair_p_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("list-pair?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (immutablep , "immutable?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("immutable?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (length_prim , "length" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("length" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_append_proc , sizeof (scheme_append_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (append_prim , "append" , 0 , - 1 ) ); 
  scheme_append_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("append" , p , env ) ); 
  (__funcarg113 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (reverse_prim , "reverse" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("reverse" , __funcarg113 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_checked_list_tail , "list-tail" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("list-tail" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_checked_list_ref , "list-ref" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("list-ref" , p , env ) ); 
  (__funcarg112 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (memq , "memq" , 2 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("memq" , __funcarg112 , env ) )) 
  ; 
  (__funcarg111 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (memv , "memv" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("memv" , __funcarg111 , env ) )) 
  ; 
  (__funcarg110 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (assq , "assq" , 2 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("assq" , __funcarg110 , env ) )) 
  ; 
  (__funcarg109 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (assv , "assv" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("assv" , __funcarg109 , env ) )) 
  ; 
  (__funcarg108 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (assoc , "assoc" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("assoc" , __funcarg108 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_checked_caar , "caar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_checked_cadr , "cadr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cadr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_checked_cdar , "cdar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_checked_cddr , "cddr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cddr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (caaar_prim , "caaar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caaar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (caadr_prim , "caadr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caadr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cadar_prim , "cadar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cadar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cdaar_prim , "cdaar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdaar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cdadr_prim , "cdadr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdadr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cddar_prim , "cddar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cddar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (caddr_prim , "caddr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caddr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cdddr_prim , "cdddr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdddr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cddddr_prim , "cddddr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cddddr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cadddr_prim , "cadddr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cadddr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cdaddr_prim , "cdaddr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdaddr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cddadr_prim , "cddadr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cddadr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cdddar_prim , "cdddar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdddar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (caaddr_prim , "caaddr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caaddr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cadadr_prim , "cadadr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cadadr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (caddar_prim , "caddar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caddar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cdaadr_prim , "cdaadr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdaadr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cdadar_prim , "cdadar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdadar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cddaar_prim , "cddaar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cddaar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cdaaar_prim , "cdaaar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cdaaar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (cadaar_prim , "cadaar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("cadaar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (caadar_prim , "caadar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caadar" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (caaadr_prim , "caaadr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caaadr" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (caaaar_prim , "caaaar" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("caaaar" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_box_proc , sizeof (scheme_box_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (box , "box" , 1 , 1 ) ); 
  scheme_box_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("box" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_box_immutable_proc , sizeof (scheme_box_immutable_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (immutable_box , "box-immutable" , 1 , 1 ) ); 
  scheme_box_immutable_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("box-immutable" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_box_p_proc , sizeof (scheme_box_p_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (box_p , "box?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("box?" , p , env ) ); 
  scheme_box_p_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (unbox , "unbox" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("unbox" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (set_box , "set-box!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("set-box!" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unbox_star , "unbox*" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("unbox*" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (set_box_star , "set-box*!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("set-box*!" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_box_cas , "box-cas!" , 3 , 3 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("box-cas!" , p , env ) ); 
  (__funcarg107 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (chaperone_box , "chaperone-box" , 3 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-box" , __funcarg107 , env ) )) 
  ; 
  (__funcarg106 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (impersonate_box , "impersonate-box" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-box" , __funcarg106 , env ) )) 
  ; 


  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_hash , "make-hash" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-hash" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_hasheq , "make-hasheq" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-hasheq" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_hasheqv , "make-hasheqv" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-hasheqv" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_hashalw , "make-hashalw" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-hashalw" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_weak_hash , "make-weak-hash" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-weak-hash" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_weak_hasheq , "make-weak-hasheq" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-weak-hasheq" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_weak_hasheqv , "make-weak-hasheqv" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-weak-hasheqv" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_weak_hashalw , "make-weak-hashalw" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-weak-hashalw" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_ephemeron_hash , "make-ephemeron-hash" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-ephemeron-hash" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_ephemeron_hasheq , "make-ephemeron-hasheq" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-ephemeron-hasheq" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_ephemeron_hasheqv , "make-ephemeron-hasheqv" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-ephemeron-hasheqv" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (make_ephemeron_hashalw , "make-ephemeron-hashalw" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-ephemeron-hashalw" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_make_immutable_hash , "make-immutable-hash" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-immutable-hash" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_make_immutable_hasheq , "make-immutable-hasheq" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-immutable-hasheq" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_make_immutable_hasheqv , "make-immutable-hasheqv" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-immutable-hasheqv" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_make_immutable_hashalw , "make-immutable-hashalw" , 0 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("make-immutable-hashalw" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_hash_proc , sizeof (scheme_hash_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (direct_hash , "hash" , 0 , - 1 ) ); 
  scheme_hash_proc = p ; 

  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 6 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("hash" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_hasheq_proc , sizeof (scheme_hasheq_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (direct_hasheq , "hasheq" , 0 , - 1 ) ); 
  scheme_hasheq_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 7 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("hasheq" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_hasheqv_proc , sizeof (scheme_hasheqv_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (direct_hasheqv , "hasheqv" , 0 , - 1 ) ); 
  scheme_hasheqv_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 7 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("hasheqv" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_hashalw_proc , sizeof (scheme_hashalw_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (direct_hashalw , "hashalw" , 0 , - 1 ) ); 
  scheme_hashalw_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 7 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("hashalw" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (hash_p , "hash?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("hash?" , p , env ) ); 
  (__funcarg105 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (scheme_hash_eq_p , "hash-eq?" , 1 , 1 , 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-eq?" , __funcarg105 , env ) )) 
  ; 
  (__funcarg104 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (scheme_hash_eqv_p , "hash-eqv?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-eqv?" , __funcarg104 , env ) )) 
  ; 
  (__funcarg103 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (scheme_hash_equal_p , "hash-equal?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-equal?" , __funcarg103 , env ) )) 
  ; 
  (__funcarg102 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (scheme_hash_equal_always_p , "hash-equal-always?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-equal-always?" , __funcarg102 , env ) )) 
  ; 
  (__funcarg101 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (hash_strong_p , "hash-strong?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-strong?" , __funcarg101 , env ) )) 
  ; 
  (__funcarg100 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (hash_weak_p , "hash-weak?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-weak?" , __funcarg100 , env ) )) 
  ; 
  (__funcarg99 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (hash_ephemeron_p , "hash-ephemeron?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-ephemeron?" , __funcarg99 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (scheme_checked_hash_count , "hash-count" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("hash-count" , p , env ) ); 
  (__funcarg98 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_copy , "hash-copy" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-copy" , __funcarg98 , env ) )) 
  ; 
  (__funcarg97 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_put_bang , "hash-set!" , 3 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-set!" , __funcarg97 , env ) )) 
  ; 
  (__funcarg96 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (scheme_hash_table_put , "hash-set" , 3 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-set" , __funcarg96 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_hash_ref_proc , sizeof (scheme_hash_ref_proc ) ) ); 
  scheme_hash_ref_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_checked_hash_ref , "hash-ref" , 2 , 3 ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-ref" , scheme_hash_ref_proc , env ) ); 
  (__funcarg95 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_ref_key , "hash-ref-key" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-ref-key" , __funcarg95 , env ) )) 
  ; 
  (__funcarg94 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_remove_bang , "hash-remove!" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-remove!" , __funcarg94 , env ) )) 
  ; 
  (__funcarg93 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_remove , "hash-remove" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-remove" , __funcarg93 , env ) )) 
  ; 
  (__funcarg92 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_clear_bang , "hash-clear!" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-clear!" , __funcarg92 , env ) )) 
  ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_clear , "hash-clear" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-clear" , __funcarg91 , env ) )) 
  ; 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_map , "hash-map" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-map" , __funcarg90 , env ) )) 
  ; 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (hash_table_for_each , "hash-for-each" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-for-each" , __funcarg89 , env ) )) 
  ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (scheme_hash_table_iterate_start , "hash-iterate-first" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-iterate-first" , __funcarg88 , env ) )) 
  ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (scheme_hash_table_iterate_next , "hash-iterate-next" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-iterate-next" , __funcarg87 , env ) )) 
  ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (scheme_hash_table_iterate_value , "hash-iterate-value" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-iterate-value" , __funcarg86 , env ) )) 
  ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (scheme_hash_table_iterate_key , "hash-iterate-key" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-iterate-key" , __funcarg85 , env ) )) 
  ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (scheme_hash_table_iterate_pair , "hash-iterate-pair" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-iterate-pair" , __funcarg84 , env ) )) 
  ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_everything (scheme_hash_table_iterate_key_value , 1 , "hash-iterate-key+value" , 2 , 3 , 0 , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-iterate-key+value" , __funcarg83 , env ) )) 
  ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (hash_keys_subset_p , "hash-keys-subset?" , 2 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-keys-subset?" , __funcarg82 , env ) )) 
  ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (chaperone_hash , "chaperone-hash" , 5 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-hash" , __funcarg81 , env ) )) 
  ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (impersonate_hash , "impersonate-hash" , 5 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-hash" , __funcarg80 , env ) )) 
  ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (eq_hash_code , "eq-hash-code" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("eq-hash-code" , __funcarg79 , env ) )) 
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (eqv_hash_code , "eqv-hash-code" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("eqv-hash-code" , __funcarg78 , env ) )) 
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (equal_hash_code , "equal-hash-code" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("equal-hash-code" , __funcarg77 , env ) )) 
  ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (equal_hash2_code , "equal-secondary-hash-code" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("equal-secondary-hash-code" , __funcarg76 , env ) )) 
  ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (equal_always_hash_code , "equal-always-hash-code" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("equal-always-hash-code" , __funcarg75 , env ) )) 
  ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (equal_always_hash2_code , "equal-always-secondary-hash-code" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("equal-always-secondary-hash-code" , __funcarg74 , env ) )) 
  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (make_weak_box , "make-weak-box" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-weak-box" , __funcarg73 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (weak_box_value , "weak-box-value" , 1 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("weak-box-value" , p , env ) ); 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (weak_boxp , "weak-box?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("weak-box?" , __funcarg72 , env ) )) 
  ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (make_ephemeron , "make-ephemeron" , 2 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-ephemeron" , __funcarg71 , env ) )) 
  ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (ephemeron_value , "ephemeron-value" , 1 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("ephemeron-value" , __funcarg70 , env ) )) 
  ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (ephemeronp , "ephemeron?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("ephemeron?" , __funcarg69 , env ) )) 
  ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_immed_prim (impersonator_ephemeron , "impersonator-ephemeron" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonator-ephemeron" , __funcarg68 , env ) )) 
  ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_graph , "make-reader-graph" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-reader-graph" , __funcarg67 , env ) )) 
  ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_placeholder , "make-placeholder" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-placeholder" , __funcarg66 , env ) )) 
  ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (placeholder_get , "placeholder-get" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("placeholder-get" , __funcarg65 , env ) )) 
  ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (placeholder_set , "placeholder-set!" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("placeholder-set!" , __funcarg64 , env ) )) 
  ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (placeholder_p , "placeholder?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("placeholder?" , __funcarg63 , env ) )) 
  ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_hash_placeholder , "make-hash-placeholder" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-hash-placeholder" , __funcarg62 , env ) )) 
  ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_hasheq_placeholder , "make-hasheq-placeholder" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-hasheq-placeholder" , __funcarg61 , env ) )) 
  ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_hasheqv_placeholder , "make-hasheqv-placeholder" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-hasheqv-placeholder" , __funcarg60 , env ) )) 
  ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_hashalw_placeholder , "make-hashalw-placeholder" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-hashalw-placeholder" , __funcarg59 , env ) )) 
  ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (table_placeholder_p , "hash-placeholder?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("hash-placeholder?" , __funcarg58 , env ) )) 
  ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & empty_hash , sizeof (empty_hash ) ) )
  ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & empty_hasheq , sizeof (empty_hasheq ) ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & empty_hasheqv , sizeof (empty_hasheqv ) ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & empty_hashalw , sizeof (empty_hashalw ) ) ); 
  empty_hash = (scheme_make_hash_tree (1 ) ) ; 
  empty_hasheq = (scheme_make_hash_tree (0 ) ) ; 
  empty_hasheqv = (scheme_make_hash_tree (2 ) ) ; 
  empty_hashalw = (scheme_make_hash_tree (3 ) ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 932 "bc/src/list.c"
void 
scheme_init_unsafe_list (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 937 "bc/src/list.c"
  scheme_null -> type = scheme_null_type ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_cons_list_proc , sizeof (scheme_unsafe_cons_list_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_cons_list , "unsafe-cons-list" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-cons-list" , p , env ) ); 
  scheme_unsafe_cons_list_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_car_proc , sizeof (scheme_unsafe_car_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_car , "unsafe-car" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (1 << 15 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-car" , p , env ) ); 
  scheme_unsafe_car_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_cdr_proc , sizeof (scheme_unsafe_cdr_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_cdr , "unsafe-cdr" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (1 << 15 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-cdr" , p , env ) ); 
  scheme_unsafe_cdr_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (unsafe_set_mcar , "unsafe-set-immutable-car!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-set-immutable-car!" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_set_mcdr , "unsafe-set-immutable-cdr!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-set-immutable-cdr!" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_list_ref , "unsafe-list-ref" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (1 << 15 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-list-ref" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_list_tail , "unsafe-list-tail" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (1 << 15 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-list-tail" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_mcar_proc , sizeof (scheme_unsafe_mcar_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_mcar , "unsafe-mcar" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 3 ) 
  | (1 << 4 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-mcar" , p , env ) ); 
  scheme_unsafe_mcar_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_mcdr_proc , sizeof (scheme_unsafe_mcdr_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_mcdr , "unsafe-mcdr" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 3 ) 
  | (1 << 4 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-mcdr" , p , env ) ); 
  scheme_unsafe_mcdr_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (unsafe_set_mcar , "unsafe-set-mcar!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-set-mcar!" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_set_mcdr , "unsafe-set-mcdr!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-set-mcdr!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_unbox_proc , sizeof (scheme_unsafe_unbox_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_unbox , "unsafe-unbox" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-unbox" , p , env ) ); 
  scheme_unsafe_unbox_proc = p ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_unsafe_unbox_star_proc , sizeof (scheme_unsafe_unbox_star_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_unbox_star , "unsafe-unbox*" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 3 ) 
  | (1 << 4 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-unbox*" , p , env ) ); 
  scheme_unsafe_unbox_star_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (unsafe_set_box , "unsafe-set-box!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-set-box!" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_set_box_star_proc , sizeof (scheme_unsafe_set_box_star_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_set_box_star , "unsafe-set-box*!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("unsafe-set-box*!" , p , env ) ); 
  scheme_unsafe_set_box_star_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (scheme_box_cas , "unsafe-box*-cas!" , 3 , 3 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("unsafe-box*-cas!" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1044 "bc/src/list.c"
void 
scheme_init_unsafe_hash (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM3_COUNT (2)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 1050 "bc/src/list.c"
  p = FUNCCALL(SETUP_XfOrM3(_), scheme_make_immed_prim (unsafe_hash_table_iterate_start , "unsafe-mutable-hash-iterate-first" , 1 , 1 ) )
  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-mutable-hash-iterate-first" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_hash_tree_iterate_start , "unsafe-immutable-hash-iterate-first" , 1 , 1 ) )
  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-immutable-hash-iterate-first" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bucket_table_iterate_start , "unsafe-weak-hash-iterate-first" , 1 , 1 ) )
  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-weak-hash-iterate-first" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bucket_table_iterate_start , "unsafe-ephemeron-hash-iterate-first" , 1 , 1 ) )
  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-ephemeron-hash-iterate-first" , p , env ) ); 






  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_hash_table_iterate_next , "unsafe-mutable-hash-iterate-next" , 2 , 2 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-mutable-hash-iterate-next" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_hash_tree_iterate_next , "unsafe-immutable-hash-iterate-next" , 2 , 2 ) )
  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-immutable-hash-iterate-next" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bucket_table_iterate_next , "unsafe-weak-hash-iterate-next" , 2 , 2 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-weak-hash-iterate-next" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bucket_table_iterate_next , "unsafe-ephemeron-hash-iterate-next" , 2 , 2 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-ephemeron-hash-iterate-next" , p , env ) ); 


  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unsafe_hash_table_iterate_key , "unsafe-mutable-hash-iterate-key" , 2 , 3 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-mutable-hash-iterate-key" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unsafe_hash_tree_iterate_key , "unsafe-immutable-hash-iterate-key" , 2 , 3 ) )
  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) 
  | (1 << 15 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-immutable-hash-iterate-key" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unsafe_bucket_table_iterate_key , "unsafe-weak-hash-iterate-key" , 2 , 3 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-weak-hash-iterate-key" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unsafe_bucket_table_iterate_key , "unsafe-ephemeron-hash-iterate-key" , 2 , 3 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-ephemeron-hash-iterate-key" , p , env ) ); 


  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unsafe_hash_table_iterate_value , "unsafe-mutable-hash-iterate-value" , 2 , 3 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-mutable-hash-iterate-value" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unsafe_hash_tree_iterate_value , "unsafe-immutable-hash-iterate-value" , 2 , 3 ) )
  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) 
  | (1 << 15 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-immutable-hash-iterate-value" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unsafe_bucket_table_iterate_value , "unsafe-weak-hash-iterate-value" , 2 , 3 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-weak-hash-iterate-value" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (unsafe_bucket_table_iterate_value , "unsafe-ephemeron-hash-iterate-value" , 2 , 3 ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-ephemeron-hash-iterate-value" , p , env ) ); 


  p = FUNCCALL_AGAIN(scheme_make_prim_w_everything (unsafe_hash_table_iterate_key_value , 1 , "unsafe-mutable-hash-iterate-key+value" , 2 , 3 , 0 , 2 , 2 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-mutable-hash-iterate-key+value" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_prim_w_everything (unsafe_hash_tree_iterate_key_value , 1 , "unsafe-immutable-hash-iterate-key+value" , 2 , 3 , 0 , 2 , 2 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) 
  | (1 << 15 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-immutable-hash-iterate-key+value" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_prim_w_everything (unsafe_bucket_table_iterate_key_value , 1 , "unsafe-weak-hash-iterate-key+value" , 2 , 3 , 0 , 2 , 2 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-weak-hash-iterate-key+value" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_prim_w_everything (unsafe_bucket_table_iterate_key_value , 1 , "unsafe-ephemeron-hash-iterate-key+value" , 2 , 3 , 0 , 2 , 2 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-ephemeron-hash-iterate-key+value" , p , env ) ); 


  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_hash_table_iterate_pair , "unsafe-mutable-hash-iterate-pair" , 2 , 3 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-mutable-hash-iterate-pair" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_hash_tree_iterate_pair , "unsafe-immutable-hash-iterate-pair" , 2 , 3 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (
  scheme_intern_prim_opt_flags ((1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("unsafe-immutable-hash-iterate-pair" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bucket_table_iterate_pair , "unsafe-weak-hash-iterate-pair" , 2 , 3 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-weak-hash-iterate-pair" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_bucket_table_iterate_pair , "unsafe-ephemeron-hash-iterate-pair" , 2 , 3 ) )

  ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("unsafe-ephemeron-hash-iterate-pair" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1185 "bc/src/list.c"
Scheme_Object * scheme_make_pair (Scheme_Object * car , Scheme_Object * cdr ) 
{
  /* No conversion */
  return GC_malloc_pair (car , cdr ) ; 
}









Scheme_Object * scheme_make_list_pair (Scheme_Object * car , Scheme_Object * cdr ) 
{
  /* No conversion */

# 1201 "bc/src/list.c"
  GC_CAN_IGNORE Scheme_Object * r ; 
  r = scheme_make_pair (car , cdr ) ; 
  (& ((Scheme_Simple_Object * ) r ) -> iso ) -> so . keyex |= 0x1 ; 
  return r ; 
}

Scheme_Object * scheme_make_mutable_pair (Scheme_Object * car , Scheme_Object * cdr ) 
{
  Scheme_Object * cons ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(cons, 0)));
# define XfOrM6_COUNT (1)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cons = NULLED_OUT ; 

# 1211 "bc/src/list.c"
  cons = FUNCCALL(SETUP_XfOrM6(_), GC_malloc_pair (car , cdr ) ); 





  cons -> type = scheme_mutable_pair_type ; 
  RET_VALUE_START (cons ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1221 "bc/src/list.c"
Scheme_Object * scheme_make_raw_pair (Scheme_Object * car , Scheme_Object * cdr ) 
{
  Scheme_Object * cons ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(cons, 0)));
# define XfOrM7_COUNT (1)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cons = NULLED_OUT ; 

# 1230 "bc/src/list.c"
  cons = FUNCCALL(SETUP_XfOrM7(_), GC_malloc_pair (car , cdr ) ); 






  cons -> type = scheme_raw_pair_type ; 
  RET_VALUE_START (cons ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * scheme_build_list (int size , Scheme_Object * * argv ) 
{
  Scheme_Object * pair = scheme_null ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pair, 0), PUSH(argv, 1)));
# define XfOrM8_COUNT (2)
# define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1249 "bc/src/list.c"
  for (i = size ; i -- ; ) {
#   define XfOrM10_COUNT (0+XfOrM8_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM8(x)

# 1250 "bc/src/list.c"
    pair = FUNCCALL(SETUP_XfOrM10(_), scheme_make_list_pair (argv [i ] , pair ) ); 
  }

  RET_VALUE_START (pair ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1256 "bc/src/list.c"
Scheme_Object * scheme_build_list_offset (int size , Scheme_Object * * argv , int delta ) 

{
  Scheme_Object * pair = scheme_null ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pair, 0), PUSH(argv, 1)));
# define XfOrM11_COUNT (2)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1262 "bc/src/list.c"
  if (size < 0 ) {
#   define XfOrM15_COUNT (0+XfOrM11_COUNT)
#   define SETUP_XfOrM15(x) SETUP_XfOrM11(x)

# 1264 "bc/src/list.c"
    size = - size ; 
    for (i = size ; i -- > delta ; ) {
#     define XfOrM17_COUNT (0+XfOrM15_COUNT)
#     define SETUP_XfOrM17(x) SETUP_XfOrM15(x)

# 1266 "bc/src/list.c"
      pair = FUNCCALL(SETUP_XfOrM17(_), scheme_make_list_pair (argv [i ] , pair ) ); 
      argv [i ] = ((void * ) 0 ) ; 
    }
  }

# 1269 "bc/src/list.c"
  else {
#   define XfOrM12_COUNT (0+XfOrM11_COUNT)
#   define SETUP_XfOrM12(x) SETUP_XfOrM11(x)

# 1270 "bc/src/list.c"
    for (i = size ; i -- > delta ; ) {
#     define XfOrM14_COUNT (0+XfOrM12_COUNT)
#     define SETUP_XfOrM14(x) SETUP_XfOrM12(x)

# 1271 "bc/src/list.c"
      pair = FUNCCALL(SETUP_XfOrM14(_), scheme_make_list_pair (argv [i ] , pair ) ); 
    }
  }

  RET_VALUE_START (pair ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1278 "bc/src/list.c"
Scheme_Object * scheme_alloc_list (int size ) 
{
  Scheme_Object * pair = scheme_null ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pair, 0)));
# define XfOrM18_COUNT (1)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1283 "bc/src/list.c"
  for (i = size ; i -- ; ) {
#   define XfOrM20_COUNT (0+XfOrM18_COUNT)
#   define SETUP_XfOrM20(x) SETUP_XfOrM18(x)

# 1284 "bc/src/list.c"
    pair = FUNCCALL(SETUP_XfOrM20(_), scheme_make_list_pair (scheme_false , pair ) ); 
  }

  RET_VALUE_START (pair ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1290 "bc/src/list.c"
int 
scheme_list_length (Scheme_Object * list ) 
{
  /* No conversion */

# 1293 "bc/src/list.c"
  int len ; 

  len = 0 ; 
  while (! ((list ) == (scheme_null ) ) ) {
    len ++ ; 
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
      list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 
    else 
    list = scheme_null ; 
  }

  return len ; 
}

int 
scheme_proper_list_length (Scheme_Object * list ) 
{
  /* No conversion */

# 1310 "bc/src/list.c"
  int len ; 

  if (! scheme_is_list (list ) )
    return - 1 ; 

  len = 0 ; 
  while (((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    len ++ ; 
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 
  }

  return len ; 
}

Scheme_Object * 
scheme_named_map_1 (char * name , Scheme_Object * (* fun ) (Scheme_Object * , Scheme_Object * ) , 
Scheme_Object * lst , Scheme_Object * form ) 
{
  Scheme_Object * first = scheme_null , * last = ((void * ) 0 ) , * pr ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(first, 0), PUSH(last, 1), PUSH(form, 2), PUSH(lst, 3), PUSH(pr, 4), PUSH(name, 5)));
# define XfOrM27_COUNT (6)
# define SETUP_XfOrM27(x) SETUP(XfOrM27_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  pr = NULLED_OUT ; 

# 1330 "bc/src/list.c"
  while ((((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) lst ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) lst ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM27_COUNT)));
#   define XfOrM29_COUNT (1+XfOrM27_COUNT)
#   define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)
    v = NULLED_OUT ; 

# 1332 "bc/src/list.c"
    v = (((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) lst ) -> val ) ) -> u . pair_val . car ) ) ; 
    v = FUNCCALL(SETUP_XfOrM29(_), fun (v , form ) ); 
    pr = FUNCCALL_AGAIN(scheme_make_list_pair (v , scheme_null ) ); 
    if (last )
      (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pr ; 
    else 
    first = pr ; 
    last = pr ; 

    lst = (((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) lst ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  }

  if (! (((lst ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) lst ) -> val ) == (scheme_null ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_syntax (name , lst , form , "bad syntax (" "illegal use of `.'" ")" ) ); 

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1350 "bc/src/list.c"
Scheme_Object * 
scheme_map_1 (Scheme_Object * (* fun ) (Scheme_Object * ) , Scheme_Object * lst ) 
{
  /* No conversion */

# 1353 "bc/src/list.c"
  return scheme_named_map_1 ("map" , 
  (Scheme_Object * (* ) (Scheme_Object * , Scheme_Object * ) ) fun , 
  lst , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_car (Scheme_Object * pair ) 
{
  /* No conversion */

# 1361 "bc/src/list.c"
  return ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) ; 
}

Scheme_Object * 
scheme_cdr (Scheme_Object * pair ) 
{
  /* No conversion */

# 1367 "bc/src/list.c"
  return ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ; 
}

Scheme_Object * 
scheme_cadr (Scheme_Object * pair ) 
{
  /* No conversion */

# 1373 "bc/src/list.c"
  return ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ; 
}

Scheme_Object * 
scheme_caddr (Scheme_Object * pair ) 
{
  /* No conversion */

# 1379 "bc/src/list.c"
  return ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ; 
}

Scheme_Object * scheme_copy_list (Scheme_Object * l ) 
{
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM35_COUNT (0)
# define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1384 "bc/src/list.c"
  RET_VALUE_START ((__funcarg114 = FUNCCALL_EMPTY(scheme_list_to_vector (l ) ), FUNCCALL_EMPTY(scheme_vector_to_list (__funcarg114 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1389 "bc/src/list.c"
static Scheme_Object * 
pair_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1392 "bc/src/list.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
mpair_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1398 "bc/src/list.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
cons_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1404 "bc/src/list.c"
  return scheme_make_pair (argv [0 ] , argv [1 ] ) ; 
}

static Scheme_Object * 
mcons_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1410 "bc/src/list.c"
  return scheme_make_mutable_pair (argv [0 ] , argv [1 ] ) ; 
}

Scheme_Object * 
scheme_checked_car (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1416 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
    scheme_wrong_contract ("car" , "pair?" , 0 , argc , argv ) ; 
  return ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ; 
}

Scheme_Object * 
scheme_checked_cdr (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1424 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
    scheme_wrong_contract ("cdr" , "pair?" , 0 , argc , argv ) ; 

  return ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ; 
}

Scheme_Object * 
scheme_checked_mcar (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1433 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) )
    scheme_wrong_contract ("mcar" , "mpair?" , 0 , argc , argv ) ; 
  return ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ; 
}

Scheme_Object * 
scheme_checked_mcdr (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1441 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) )
    scheme_wrong_contract ("mcdr" , "mpair?" , 0 , argc , argv ) ; 

  return ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ; 
}

Scheme_Object * 
scheme_checked_set_mcar (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1450 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) )
    scheme_wrong_contract ("set-mcar!" , "mpair?" , 0 , argc , argv ) ; 

  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) = argv [1 ] ; 
  return scheme_void ; 
}

Scheme_Object * 
scheme_checked_set_mcdr (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1460 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) )
    scheme_wrong_contract ("set-mcdr!" , "mpair?" , 0 , argc , argv ) ; 

  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) = argv [1 ] ; 
  return scheme_void ; 
}

static Scheme_Object * 
null_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1470 "bc/src/list.c"
  return (((argv [0 ] ) == (scheme_null ) ) ? scheme_true : scheme_false ) ; 
}

int scheme_is_list (Scheme_Object * obj1 ) 
{
  /* No conversion */

# 1475 "bc/src/list.c"
  Scheme_Object * obj2 ; 
  int flags ; 

  if ((Scheme_Type ) (((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    flags = (& ((Scheme_Simple_Object * ) obj1 ) -> iso ) -> so . keyex ; 
    if (flags & 0x3 ) {
      if (flags & 0x1 )
        return 1 ; 
      else 
      return 0 ; 
    }
  }

# 1486 "bc/src/list.c"
  else if ((obj1 ) == (scheme_null ) ) 
    return 1 ; 
  else 
  return 0 ; 

  obj2 = obj1 ; 





  while (1 ) {
    obj1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . cdr ) ; 

    if ((obj1 ) == (scheme_null ) )  {
      flags = 0x1 ; 
      break ; 
    }
    if (! ((Scheme_Type ) (((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      flags = 0x2 ; 
      break ; 
    }


    flags = (& ((Scheme_Simple_Object * ) obj1 ) -> iso ) -> so . keyex ; 
    if (flags & 0x3 )
      break ; 

    obj1 = (((Scheme_Simple_Object * ) (obj1 ) ) -> u . pair_val . cdr ) ; 

    if ((obj1 ) == (scheme_null ) )  {
      flags = 0x1 ; 
      break ; 
    }
    if (! ((Scheme_Type ) (((((intptr_t ) (obj1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj1 ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      flags = 0x2 ; 
      break ; 
    }


    flags = (& ((Scheme_Simple_Object * ) obj1 ) -> iso ) -> so . keyex ; 
    if (flags & 0x3 )
      break ; 

    obj2 = (((Scheme_Simple_Object * ) (obj2 ) ) -> u . pair_val . cdr ) ; 
  }

# 1544 "bc/src/list.c"
  (& ((Scheme_Simple_Object * ) obj2 ) -> iso ) -> so . keyex |= (flags & 0x3 ) ; 


  return (flags & 0x1 ) ; 
}

static Scheme_Object * 
list_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1553 "bc/src/list.c"
  return (scheme_is_list (argv [0 ] ) 
  ? scheme_true 
  : scheme_false ) ; 
}

# 1570 "bc/src/list.c"
static Scheme_Object * 
list_prim (int argc , Scheme_Object * argv [] ) 
{
  int i ; 

# 1573 "bc/src/list.c"
  GC_CAN_IGNORE Scheme_Object * l ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM61_COUNT (1)
# define SETUP_XfOrM61(x) SETUP(XfOrM61_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1573 "bc/src/list.c"
  l = scheme_null ; 

# 1573 "bc/src/list.c"
  for (i = argc ; i -- ; ) {
#   define XfOrM63_COUNT (0+XfOrM61_COUNT)
#   define SETUP_XfOrM63(x) SETUP_XfOrM61(x)

# 1573 "bc/src/list.c"
    l = FUNCCALL(SETUP_XfOrM63(_), scheme_make_list_pair (argv [i ] , l ) ); 
  }

# 1573 "bc/src/list.c"
  RET_VALUE_START (l ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1576 "bc/src/list.c"
static Scheme_Object * 
list_star_prim (int argc , Scheme_Object * argv [] ) 
{
  int i ; 

# 1579 "bc/src/list.c"
  GC_CAN_IGNORE Scheme_Object * l ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM64_COUNT (1)
# define SETUP_XfOrM64(x) SETUP(XfOrM64_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1579 "bc/src/list.c"
  -- argc ; 

# 1579 "bc/src/list.c"
  l = argv [argc ] ; 

# 1579 "bc/src/list.c"
  for (i = argc ; i -- ; ) {
#   define XfOrM66_COUNT (0+XfOrM64_COUNT)
#   define SETUP_XfOrM66(x) SETUP_XfOrM64(x)

# 1579 "bc/src/list.c"
    l = FUNCCALL(SETUP_XfOrM66(_), scheme_make_pair (argv [i ] , l ) ); 
  }

# 1579 "bc/src/list.c"
  RET_VALUE_START (l ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1582 "bc/src/list.c"
static Scheme_Object * 
list_pair_p_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1585 "bc/src/list.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  && scheme_is_list (argv [0 ] ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * 
immutablep (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1594 "bc/src/list.c"
  Scheme_Object * v = argv [0 ] ; 

  return ((! (((intptr_t ) (v ) ) & 0x1 ) 
  && (((((Scheme_Inclhash_Object * ) (v ) ) -> so . keyex & 0x1 ) 
  && (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) 
  || ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
  || ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && (((((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
  || ((((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) 
  && (((Scheme_Inclhash_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> so . keyex & 0x1 ) ) ) ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * 
length_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1616 "bc/src/list.c"
  int l ; 

  if (! scheme_is_list (argv [0 ] ) )
    scheme_wrong_contract ("length" , "list?" , 0 , argc , argv ) ; 

  l = scheme_list_length (argv [0 ] ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (l ) ) ) << 1 ) | 0x1 ) ) ; 
}

Scheme_Object * scheme_checked_length (Scheme_Object * v ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM70_COUNT (1)
# define SETUP_XfOrM70(x) SETUP(XfOrM70_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1628 "bc/src/list.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM70(_), length_prim (1 , & v ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1631 "bc/src/list.c"
Scheme_Object * 
scheme_append (Scheme_Object * l1 , Scheme_Object * l2 ) 
{
  Scheme_Object * first , * last , * orig1 , * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(first, 0), PUSH(last, 1), PUSH(v, 2), PUSH(l1, 3), PUSH(orig1, 4), PUSH(l2, 5)));
# define XfOrM71_COUNT (6)
# define SETUP_XfOrM71(x) SETUP(XfOrM71_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  first = NULLED_OUT ; 
  last = NULLED_OUT ; 
  orig1 = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 1636 "bc/src/list.c"
  orig1 = l1 ; 

  first = last = ((void * ) 0 ) ; 
  while (((Scheme_Type ) (((((intptr_t ) (l1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l1 ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM75_COUNT (0+XfOrM71_COUNT)
#   define SETUP_XfOrM75(x) SETUP_XfOrM71(x)

# 1640 "bc/src/list.c"
    v = FUNCCALL(SETUP_XfOrM75(_), scheme_make_pair ((((Scheme_Simple_Object * ) (l1 ) ) -> u . pair_val . car ) , scheme_null ) ); 
    if (! first )
      first = v ; 
    else 
    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
    last = v ; 
    l1 = (((Scheme_Simple_Object * ) (l1 ) ) -> u . pair_val . cdr ) ; 

    {
#     define XfOrM76_COUNT (0+XfOrM75_COUNT)
#     define SETUP_XfOrM76(x) SETUP_XfOrM75(x)

# 1648 "bc/src/list.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM77_COUNT (0+XfOrM76_COUNT)
#       define SETUP_XfOrM77(x) SETUP_XfOrM76(x)
        FUNCCALL(SETUP_XfOrM77(_), scheme_out_of_fuel () )
# 1648 "bc/src/list.c"
        ; 
      }
    }

# 1648 "bc/src/list.c"
    ; 
  }

  if (! ((l1 ) == (scheme_null ) ) )
    FUNCCALL(SETUP_XfOrM71(_), scheme_wrong_contract ("append" , "list?" , - 1 , 0 , & orig1 ) ); 

  if (! last )
    RET_VALUE_START (l2 ) RET_VALUE_END ; 

  (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = l2 ; 

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1662 "bc/src/list.c"
Scheme_Object * scheme_reverse (Scheme_Object * l ) 
{
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM78_COUNT (3)
# define SETUP_XfOrM78(x) SETUP(XfOrM78_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 1665 "bc/src/list.c"
  a [0 ] = l ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM78(_), reverse_prim (1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1669 "bc/src/list.c"
static Scheme_Object * 
append_prim (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * res ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(res, 0), PUSH(argv, 1)));
# define XfOrM79_COUNT (2)
# define SETUP_XfOrM79(x) SETUP(XfOrM79_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  res = NULLED_OUT ; 

# 1675 "bc/src/list.c"
  if (! argc )
    RET_VALUE_START (scheme_null ) RET_VALUE_END ; 

  res = argv [argc - 1 ] ; 
  for (i = argc - 1 ; i -- ; ) {
#   define XfOrM81_COUNT (0+XfOrM79_COUNT)
#   define SETUP_XfOrM81(x) SETUP_XfOrM79(x)

# 1680 "bc/src/list.c"
    res = FUNCCALL(SETUP_XfOrM81(_), scheme_append (argv [i ] , res ) ); 
  }

  RET_VALUE_START (res ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1686 "bc/src/list.c"
static Scheme_Object * 
reverse_prim (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * lst , * last ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(last, 0), PUSH(lst, 1), PUSH(argv, 2)));
# define XfOrM82_COUNT (3)
# define SETUP_XfOrM82(x) SETUP(XfOrM82_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lst = NULLED_OUT ; 
  last = NULLED_OUT ; 

# 1691 "bc/src/list.c"
  last = scheme_null ; 
  lst = argv [0 ] ; 
  while (! ((lst ) == (scheme_null ) ) ) {
#   define XfOrM86_COUNT (0+XfOrM82_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM82(x)

# 1694 "bc/src/list.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("reverse" , "list?" , 0 , argc , argv ) ); 
    last = FUNCCALL(SETUP_XfOrM86(_), scheme_make_list_pair ((((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . car ) , last ) ); 
    lst = (((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . cdr ) ; 

    {
#     define XfOrM87_COUNT (0+XfOrM86_COUNT)
#     define SETUP_XfOrM87(x) SETUP_XfOrM86(x)

# 1699 "bc/src/list.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM88_COUNT (0+XfOrM87_COUNT)
#       define SETUP_XfOrM88(x) SETUP_XfOrM87(x)
        FUNCCALL(SETUP_XfOrM88(_), scheme_out_of_fuel () )
# 1699 "bc/src/list.c"
        ; 
      }
    }

# 1699 "bc/src/list.c"
    ; 
  }
  RET_VALUE_START ((last ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1704 "bc/src/list.c"
static void past_end (const char * name , Scheme_Object * lst , Scheme_Object * index , Scheme_Object * orig_lst ) 
{
  /* No conversion */

# 1706 "bc/src/list.c"
  scheme_contract_error (name , 
  (((lst ) == (scheme_null ) ) 
  ? "index too large for list" 
  : "index reaches a non-pair" ) , 
  "index" , 1 , index , 
  "in" , 1 , orig_lst , 
  ((void * ) 0 ) ) ; 
}








static Scheme_Object * 
do_list_ref (char * name , int takecar , int argc , Scheme_Object * argv [] ) 
{
  intptr_t i , k ; 
  Scheme_Object * lst , * index , * bnindex ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(index, 0), PUSH(bnindex, 1), PUSH(lst, 2), PUSH(argv, 3), PUSH(name, 4)));
# define XfOrM90_COUNT (5)
# define SETUP_XfOrM90(x) SETUP(XfOrM90_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lst = NULLED_OUT ; 
  index = NULLED_OUT ; 
  bnindex = NULLED_OUT ; 

# 1728 "bc/src/list.c"
  lst = argv [0 ] ; 
  index = argv [1 ] ; 

  if (takecar && ! ((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM121_COUNT (0+XfOrM90_COUNT)
#   define SETUP_XfOrM121(x) SETUP_XfOrM90(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "pair?" , 0 , argc , argv ) )
# 1732 "bc/src/list.c"
    ; 

# 1732 "bc/src/list.c"
    ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (index ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (index ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
    bnindex = index ; 
    k = 0 ; 
  }

# 1738 "bc/src/list.c"
  else if (! (((intptr_t ) (index ) ) & 0x1 ) ) {
#   define XfOrM119_COUNT (0+XfOrM90_COUNT)
#   define SETUP_XfOrM119(x) SETUP_XfOrM90(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "exact-nonnegative-integer?" , 1 , argc , argv ) )
# 1739 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 1741 "bc/src/list.c"
  else {
    bnindex = ((void * ) 0 ) ; 
    k = (((intptr_t ) (index ) ) >> 1 ) ; 
  }

  if ((bnindex && ! ((& ((Scheme_Bignum * ) bnindex ) -> iso ) -> so . keyex & 0x1 ) ) 
  || (! bnindex && (k < 0 ) ) ) {
#   define XfOrM117_COUNT (0+XfOrM90_COUNT)
#   define SETUP_XfOrM117(x) SETUP_XfOrM90(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "exact-nonnegative-integer?" , 1 , argc , argv ) )
# 1748 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  do {
#   define XfOrM105_COUNT (0+XfOrM90_COUNT)
#   define SETUP_XfOrM105(x) SETUP_XfOrM90(x)

# 1753 "bc/src/list.c"
    if (bnindex ) {
#     define XfOrM114_COUNT (0+XfOrM105_COUNT)
#     define SETUP_XfOrM114(x) SETUP_XfOrM105(x)

# 1754 "bc/src/list.c"
      if (((intptr_t ) (bnindex ) ) & 0x1 )  {
        k = (((intptr_t ) (bnindex ) ) >> 1 ) ; 
        bnindex = 0 ; 
      }

# 1757 "bc/src/list.c"
      else {
#       define XfOrM115_COUNT (0+XfOrM114_COUNT)
#       define SETUP_XfOrM115(x) SETUP_XfOrM114(x)

# 1758 "bc/src/list.c"
        k = 1000000 ; 
        bnindex = FUNCCALL(SETUP_XfOrM115(_), scheme_bin_minus (bnindex , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1000000 ) ) ) << 1 ) | 0x1 ) ) ) ); 
      }
    }

    for (i = 0 ; i < k ; i ++ ) {
#     define XfOrM110_COUNT (0+XfOrM105_COUNT)
#     define SETUP_XfOrM110(x) SETUP_XfOrM105(x)

# 1764 "bc/src/list.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#       define XfOrM113_COUNT (0+XfOrM110_COUNT)
#       define SETUP_XfOrM113(x) SETUP_XfOrM110(x)
        FUNCCALL(SETUP_XfOrM113(_), past_end (name , lst , index , argv [0 ] ) )
# 1765 "bc/src/list.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      lst = (((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . cdr ) ; 
      if (! (i & ((int ) 0xFF ) ) ) 
      {
#       define XfOrM111_COUNT (0+XfOrM110_COUNT)
#       define SETUP_XfOrM111(x) SETUP_XfOrM110(x)

# 1770 "bc/src/list.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM112_COUNT (0+XfOrM111_COUNT)
#         define SETUP_XfOrM112(x) SETUP_XfOrM111(x)
          FUNCCALL(SETUP_XfOrM112(_), scheme_out_of_fuel () )
# 1770 "bc/src/list.c"
          ; 
        }
      }

# 1770 "bc/src/list.c"
      ; 
    }
  }

# 1772 "bc/src/list.c"
  while (bnindex ) ; 

  if (takecar ) {
#   define XfOrM91_COUNT (0+XfOrM90_COUNT)
#   define SETUP_XfOrM91(x) SETUP_XfOrM90(x)

# 1775 "bc/src/list.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM92_COUNT (0+XfOrM91_COUNT)
#     define SETUP_XfOrM92(x) SETUP_XfOrM91(x)
      FUNCCALL(SETUP_XfOrM92(_), past_end (name , lst , index , argv [0 ] ) )
# 1776 "bc/src/list.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    RET_VALUE_START ((((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . car ) ) RET_VALUE_END ; 
  }

# 1781 "bc/src/list.c"
  else 
  RET_VALUE_START (lst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1785 "bc/src/list.c"
Scheme_Object * 
scheme_checked_list_tail (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1788 "bc/src/list.c"
  return do_list_ref ("list-tail" , 0 , argc , argv ) ; 
}

Scheme_Object * 
scheme_checked_list_ref (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1794 "bc/src/list.c"
  return do_list_ref ("list-ref" , 1 , argc , argv ) ; 
}

static void mem_past_end (const char * name , Scheme_Object * s_arg , Scheme_Object * arg ) 
{
  /* No conversion */

# 1799 "bc/src/list.c"
  scheme_contract_error (name , 
  "not a proper list" , 
  "in" , 1 , arg , 
  "looking for" , 1 , s_arg , 
  ((void * ) 0 ) ) ; 
}

# 1836 "bc/src/list.c"
static Scheme_Object * memv (int argc , Scheme_Object * argv [] ) {

# 1836 "bc/src/list.c"
  Scheme_Object * list , * turtle ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(list, 0), PUSH(argv, 1), PUSH(turtle, 2)));
# define XfOrM125_COUNT (3)
# define SETUP_XfOrM125(x) SETUP(XfOrM125_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  list = NULLED_OUT ; 
  turtle = NULLED_OUT ; 

# 1836 "bc/src/list.c"
  list = turtle = argv [1 ] ; 

# 1836 "bc/src/list.c"
  while (((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM133_COUNT (0+XfOrM125_COUNT)
#   define SETUP_XfOrM133(x) SETUP_XfOrM125(x)

# 1836 "bc/src/list.c"
    if (scheme_eqv (argv [0 ] , (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ) )  {

# 1836 "bc/src/list.c"
      RET_VALUE_START (list ) RET_VALUE_END ; 
    }

# 1836 "bc/src/list.c"
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1836 "bc/src/list.c"
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM134_COUNT (0+XfOrM133_COUNT)
#     define SETUP_XfOrM134(x) SETUP_XfOrM133(x)

# 1836 "bc/src/list.c"
      if (scheme_eqv (argv [0 ] , (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ) )  {

# 1836 "bc/src/list.c"
        RET_VALUE_START (list ) RET_VALUE_END ; 
      }

# 1836 "bc/src/list.c"
      if ((list ) == (turtle ) ) 

# 1836 "bc/src/list.c"
      break ; 

# 1836 "bc/src/list.c"
      list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1836 "bc/src/list.c"
      turtle = (((Scheme_Simple_Object * ) (turtle ) ) -> u . pair_val . cdr ) ; 

# 1836 "bc/src/list.c"
      {
#       define XfOrM135_COUNT (0+XfOrM134_COUNT)
#       define SETUP_XfOrM135(x) SETUP_XfOrM134(x)

# 1836 "bc/src/list.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM136_COUNT (0+XfOrM135_COUNT)
#         define SETUP_XfOrM136(x) SETUP_XfOrM135(x)
          FUNCCALL(SETUP_XfOrM136(_), scheme_out_of_fuel () )
# 1836 "bc/src/list.c"
          ; 
        }
      }

# 1836 "bc/src/list.c"
      ; 
    }
  }

# 1836 "bc/src/list.c"
  if (! ((list ) == (scheme_null ) ) ) {
#   define XfOrM126_COUNT (0+XfOrM125_COUNT)
#   define SETUP_XfOrM126(x) SETUP_XfOrM125(x)
    FUNCCALL_EMPTY(mem_past_end ("memv" , argv [0 ] , argv [1 ] ) )
# 1836 "bc/src/list.c"
    ; 
  }

# 1836 "bc/src/list.c"
  RET_VALUE_START ((scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1837 "bc/src/list.c"
static Scheme_Object * memq (int argc , Scheme_Object * argv [] ) {

# 1837 "bc/src/list.c"
  Scheme_Object * list , * turtle ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(list, 0), PUSH(argv, 1), PUSH(turtle, 2)));
# define XfOrM139_COUNT (3)
# define SETUP_XfOrM139(x) SETUP(XfOrM139_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  list = NULLED_OUT ; 
  turtle = NULLED_OUT ; 

# 1837 "bc/src/list.c"
  list = turtle = argv [1 ] ; 

# 1837 "bc/src/list.c"
  while (((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM147_COUNT (0+XfOrM139_COUNT)
#   define SETUP_XfOrM147(x) SETUP_XfOrM139(x)

# 1837 "bc/src/list.c"
    if ((argv [0 ] ) == ((((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ) )  {

# 1837 "bc/src/list.c"
      RET_VALUE_START (list ) RET_VALUE_END ; 
    }

# 1837 "bc/src/list.c"
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1837 "bc/src/list.c"
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM148_COUNT (0+XfOrM147_COUNT)
#     define SETUP_XfOrM148(x) SETUP_XfOrM147(x)

# 1837 "bc/src/list.c"
      if ((argv [0 ] ) == ((((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ) )  {

# 1837 "bc/src/list.c"
        RET_VALUE_START (list ) RET_VALUE_END ; 
      }

# 1837 "bc/src/list.c"
      if ((list ) == (turtle ) ) 

# 1837 "bc/src/list.c"
      break ; 

# 1837 "bc/src/list.c"
      list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1837 "bc/src/list.c"
      turtle = (((Scheme_Simple_Object * ) (turtle ) ) -> u . pair_val . cdr ) ; 

# 1837 "bc/src/list.c"
      {
#       define XfOrM149_COUNT (0+XfOrM148_COUNT)
#       define SETUP_XfOrM149(x) SETUP_XfOrM148(x)

# 1837 "bc/src/list.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM150_COUNT (0+XfOrM149_COUNT)
#         define SETUP_XfOrM150(x) SETUP_XfOrM149(x)
          FUNCCALL(SETUP_XfOrM150(_), scheme_out_of_fuel () )
# 1837 "bc/src/list.c"
          ; 
        }
      }

# 1837 "bc/src/list.c"
      ; 
    }
  }

# 1837 "bc/src/list.c"
  if (! ((list ) == (scheme_null ) ) ) {
#   define XfOrM140_COUNT (0+XfOrM139_COUNT)
#   define SETUP_XfOrM140(x) SETUP_XfOrM139(x)
    FUNCCALL_EMPTY(mem_past_end ("memq" , argv [0 ] , argv [1 ] ) )
# 1837 "bc/src/list.c"
    ; 
  }

# 1837 "bc/src/list.c"
  RET_VALUE_START ((scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1839 "bc/src/list.c"
static void ass_non_pair (const char * name , Scheme_Object * np , Scheme_Object * s_arg , Scheme_Object * arg ) 
{
  /* No conversion */

# 1841 "bc/src/list.c"
  scheme_contract_error (name , 
  "found a non-pair element" , 
  "at" , 1 , np , 
  "in" , 1 , arg , 
  "looking for" , 1 , s_arg , 
  ((void * ) 0 ) ) ; 
}

# 1884 "bc/src/list.c"
static Scheme_Object * assv (int argc , Scheme_Object * argv [] ) {

# 1884 "bc/src/list.c"
  Scheme_Object * pair , * list , * turtle ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(pair, 0), PUSH(list, 1), PUSH(argv, 2), PUSH(turtle, 3)));
# define XfOrM154_COUNT (4)
# define SETUP_XfOrM154(x) SETUP(XfOrM154_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pair = NULLED_OUT ; 
  list = NULLED_OUT ; 
  turtle = NULLED_OUT ; 

# 1884 "bc/src/list.c"
  list = turtle = argv [1 ] ; 

# 1884 "bc/src/list.c"
  while (((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM163_COUNT (0+XfOrM154_COUNT)
#   define SETUP_XfOrM163(x) SETUP_XfOrM154(x)

# 1884 "bc/src/list.c"
    pair = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 

# 1884 "bc/src/list.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (pair ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pair ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM169_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM169(x) SETUP_XfOrM163(x)
      FUNCCALL(SETUP_XfOrM169(_), ass_non_pair ("assv" , pair , argv [0 ] , argv [1 ] ) )
# 1884 "bc/src/list.c"
      ; 
    }

# 1884 "bc/src/list.c"
    if (scheme_eqv (argv [0 ] , (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) )  {

# 1884 "bc/src/list.c"
      RET_VALUE_START ((pair ) ) RET_VALUE_END ; 
    }

# 1884 "bc/src/list.c"
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1884 "bc/src/list.c"
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM164_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM164(x) SETUP_XfOrM163(x)

# 1884 "bc/src/list.c"
      pair = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 

# 1884 "bc/src/list.c"
      if ((Scheme_Type ) (((((intptr_t ) (pair ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pair ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#       define XfOrM165_COUNT (0+XfOrM164_COUNT)
#       define SETUP_XfOrM165(x) SETUP_XfOrM164(x)

# 1884 "bc/src/list.c"
        if (scheme_eqv (argv [0 ] , (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) ) 

# 1884 "bc/src/list.c"
        RET_VALUE_START (pair ) RET_VALUE_END ; 

# 1884 "bc/src/list.c"
        list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1884 "bc/src/list.c"
        if ((list ) == (turtle ) ) 

# 1884 "bc/src/list.c"
        break ; 

# 1884 "bc/src/list.c"
        turtle = (((Scheme_Simple_Object * ) (turtle ) ) -> u . pair_val . cdr ) ; 

# 1884 "bc/src/list.c"
        {
#         define XfOrM166_COUNT (0+XfOrM165_COUNT)
#         define SETUP_XfOrM166(x) SETUP_XfOrM165(x)

# 1884 "bc/src/list.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM167_COUNT (0+XfOrM166_COUNT)
#           define SETUP_XfOrM167(x) SETUP_XfOrM166(x)
            FUNCCALL(SETUP_XfOrM167(_), scheme_out_of_fuel () )
# 1884 "bc/src/list.c"
            ; 
          }
        }

# 1884 "bc/src/list.c"
        ; 
      }
    }
  }

# 1884 "bc/src/list.c"
  if (! ((list ) == (scheme_null ) ) ) {
#   define XfOrM155_COUNT (0+XfOrM154_COUNT)
#   define SETUP_XfOrM155(x) SETUP_XfOrM154(x)
    FUNCCALL_EMPTY(mem_past_end ("assv" , argv [0 ] , argv [1 ] ) )
# 1884 "bc/src/list.c"
    ; 
  }

# 1884 "bc/src/list.c"
  RET_VALUE_START ((scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1885 "bc/src/list.c"
static Scheme_Object * assq (int argc , Scheme_Object * argv [] ) {

# 1885 "bc/src/list.c"
  Scheme_Object * pair , * list , * turtle ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(pair, 0), PUSH(list, 1), PUSH(argv, 2), PUSH(turtle, 3)));
# define XfOrM170_COUNT (4)
# define SETUP_XfOrM170(x) SETUP(XfOrM170_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pair = NULLED_OUT ; 
  list = NULLED_OUT ; 
  turtle = NULLED_OUT ; 

# 1885 "bc/src/list.c"
  list = turtle = argv [1 ] ; 

# 1885 "bc/src/list.c"
  while (((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM179_COUNT (0+XfOrM170_COUNT)
#   define SETUP_XfOrM179(x) SETUP_XfOrM170(x)

# 1885 "bc/src/list.c"
    pair = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 

# 1885 "bc/src/list.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (pair ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pair ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM185_COUNT (0+XfOrM179_COUNT)
#     define SETUP_XfOrM185(x) SETUP_XfOrM179(x)
      FUNCCALL(SETUP_XfOrM185(_), ass_non_pair ("assq" , pair , argv [0 ] , argv [1 ] ) )
# 1885 "bc/src/list.c"
      ; 
    }

# 1885 "bc/src/list.c"
    if ((argv [0 ] ) == ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) )  {

# 1885 "bc/src/list.c"
      RET_VALUE_START ((pair ) ) RET_VALUE_END ; 
    }

# 1885 "bc/src/list.c"
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1885 "bc/src/list.c"
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM180_COUNT (0+XfOrM179_COUNT)
#     define SETUP_XfOrM180(x) SETUP_XfOrM179(x)

# 1885 "bc/src/list.c"
      pair = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 

# 1885 "bc/src/list.c"
      if ((Scheme_Type ) (((((intptr_t ) (pair ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pair ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#       define XfOrM181_COUNT (0+XfOrM180_COUNT)
#       define SETUP_XfOrM181(x) SETUP_XfOrM180(x)

# 1885 "bc/src/list.c"
        if ((argv [0 ] ) == ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) ) 

# 1885 "bc/src/list.c"
        RET_VALUE_START (pair ) RET_VALUE_END ; 

# 1885 "bc/src/list.c"
        list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1885 "bc/src/list.c"
        if ((list ) == (turtle ) ) 

# 1885 "bc/src/list.c"
        break ; 

# 1885 "bc/src/list.c"
        turtle = (((Scheme_Simple_Object * ) (turtle ) ) -> u . pair_val . cdr ) ; 

# 1885 "bc/src/list.c"
        {
#         define XfOrM182_COUNT (0+XfOrM181_COUNT)
#         define SETUP_XfOrM182(x) SETUP_XfOrM181(x)

# 1885 "bc/src/list.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM183_COUNT (0+XfOrM182_COUNT)
#           define SETUP_XfOrM183(x) SETUP_XfOrM182(x)
            FUNCCALL(SETUP_XfOrM183(_), scheme_out_of_fuel () )
# 1885 "bc/src/list.c"
            ; 
          }
        }

# 1885 "bc/src/list.c"
        ; 
      }
    }
  }

# 1885 "bc/src/list.c"
  if (! ((list ) == (scheme_null ) ) ) {
#   define XfOrM171_COUNT (0+XfOrM170_COUNT)
#   define SETUP_XfOrM171(x) SETUP_XfOrM170(x)
    FUNCCALL_EMPTY(mem_past_end ("assq" , argv [0 ] , argv [1 ] ) )
# 1885 "bc/src/list.c"
    ; 
  }

# 1885 "bc/src/list.c"
  RET_VALUE_START ((scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1886 "bc/src/list.c"
static Scheme_Object * assoc (int argc , Scheme_Object * argv [] ) {

# 1886 "bc/src/list.c"
  Scheme_Object * pair , * list , * turtle ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(pair, 0), PUSH(list, 1), PUSH(argv, 2), PUSH(turtle, 3)));
# define XfOrM186_COUNT (4)
# define SETUP_XfOrM186(x) SETUP(XfOrM186_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pair = NULLED_OUT ; 
  list = NULLED_OUT ; 
  turtle = NULLED_OUT ; 

# 1886 "bc/src/list.c"
  list = turtle = argv [1 ] ; 

# 1886 "bc/src/list.c"
  while (((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM195_COUNT (0+XfOrM186_COUNT)
#   define SETUP_XfOrM195(x) SETUP_XfOrM186(x)

# 1886 "bc/src/list.c"
    pair = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 

# 1886 "bc/src/list.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (pair ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pair ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM201_COUNT (0+XfOrM195_COUNT)
#     define SETUP_XfOrM201(x) SETUP_XfOrM195(x)
      FUNCCALL(SETUP_XfOrM201(_), ass_non_pair ("assoc" , pair , argv [0 ] , argv [1 ] ) )
# 1886 "bc/src/list.c"
      ; 
    }

# 1886 "bc/src/list.c"
    if (FUNCCALL(SETUP_XfOrM195(_), scheme_equal (argv [0 ] , (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) )) {

# 1886 "bc/src/list.c"
      RET_VALUE_START ((pair ) ) RET_VALUE_END ; 
    }

# 1886 "bc/src/list.c"
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1886 "bc/src/list.c"
    if ((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM196_COUNT (0+XfOrM195_COUNT)
#     define SETUP_XfOrM196(x) SETUP_XfOrM195(x)

# 1886 "bc/src/list.c"
      pair = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 

# 1886 "bc/src/list.c"
      if ((Scheme_Type ) (((((intptr_t ) (pair ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pair ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#       define XfOrM197_COUNT (0+XfOrM196_COUNT)
#       define SETUP_XfOrM197(x) SETUP_XfOrM196(x)

# 1886 "bc/src/list.c"
        if (FUNCCALL(SETUP_XfOrM197(_), scheme_equal (argv [0 ] , (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) ))

# 1886 "bc/src/list.c"
        RET_VALUE_START (pair ) RET_VALUE_END ; 

# 1886 "bc/src/list.c"
        list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 

# 1886 "bc/src/list.c"
        if ((list ) == (turtle ) ) 

# 1886 "bc/src/list.c"
        break ; 

# 1886 "bc/src/list.c"
        turtle = (((Scheme_Simple_Object * ) (turtle ) ) -> u . pair_val . cdr ) ; 

# 1886 "bc/src/list.c"
        {
#         define XfOrM198_COUNT (0+XfOrM197_COUNT)
#         define SETUP_XfOrM198(x) SETUP_XfOrM197(x)

# 1886 "bc/src/list.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM199_COUNT (0+XfOrM198_COUNT)
#           define SETUP_XfOrM199(x) SETUP_XfOrM198(x)
            FUNCCALL(SETUP_XfOrM199(_), scheme_out_of_fuel () )
# 1886 "bc/src/list.c"
            ; 
          }
        }

# 1886 "bc/src/list.c"
        ; 
      }
    }
  }

# 1886 "bc/src/list.c"
  if (! ((list ) == (scheme_null ) ) ) {
#   define XfOrM187_COUNT (0+XfOrM186_COUNT)
#   define SETUP_XfOrM187(x) SETUP_XfOrM186(x)
    FUNCCALL_EMPTY(mem_past_end ("assoc" , argv [0 ] , argv [1 ] ) )
# 1886 "bc/src/list.c"
    ; 
  }

# 1886 "bc/src/list.c"
  RET_VALUE_START ((scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}






Scheme_Object * scheme_checked_cddr (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1898 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1898 "bc/src/list.c"
  scheme_wrong_contract ("cddr" , "(cons/c any/c pair?)" , 0 , argc , argv ) ; 

# 1898 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
}

# 1899 "bc/src/list.c"
Scheme_Object * scheme_checked_cadr (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1899 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1899 "bc/src/list.c"
  scheme_wrong_contract ("cadr" , "(cons/c any/c pair?)" , 0 , argc , argv ) ; 

# 1899 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ; 
}

# 1900 "bc/src/list.c"
Scheme_Object * scheme_checked_cdar (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1900 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1900 "bc/src/list.c"
  scheme_wrong_contract ("cdar" , "(cons/c pair? any/c)" , 0 , argc , argv ) ; 

# 1900 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ; 
}

# 1901 "bc/src/list.c"
Scheme_Object * scheme_checked_caar (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1901 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1901 "bc/src/list.c"
  scheme_wrong_contract ("caar" , "(cons/c pair? any/c)" , 0 , argc , argv ) ; 

# 1901 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ; 
}

# 1914 "bc/src/list.c"
static Scheme_Object * cdddr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1914 "bc/src/list.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1914 "bc/src/list.c"
  scheme_wrong_contract ("cdddr" , "(cons/c any/c (cons/c any/c pair?))" , 0 , argc , argv ) ; 

# 1914 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
}
static Scheme_Object * caddr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1916 "bc/src/list.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1916 "bc/src/list.c"
  scheme_wrong_contract ("caddr" , "(cons/c any/c (cons/c any/c pair?))" , 0 , argc , argv ) ; 

# 1916 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ; 
}

# 1917 "bc/src/list.c"
static Scheme_Object * cdadr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1917 "bc/src/list.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1917 "bc/src/list.c"
  scheme_wrong_contract ("cdadr" , "(cons/c any/c (cons/c pair? any/c))" , 0 , argc , argv ) ; 

# 1917 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ; 
}

# 1918 "bc/src/list.c"
static Scheme_Object * cddar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1918 "bc/src/list.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1918 "bc/src/list.c"
  scheme_wrong_contract ("cddar" , "(cons/c (cons/c any/c pair?) any/c)" , 0 , argc , argv ) ; 

# 1918 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
}
static Scheme_Object * cdaar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1920 "bc/src/list.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1920 "bc/src/list.c"
  scheme_wrong_contract ("cdaar" , "(cons/c (cons/c pair? any/c) any/c)" , 0 , argc , argv ) ; 

# 1920 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ; 
}

# 1921 "bc/src/list.c"
static Scheme_Object * cadar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1921 "bc/src/list.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1921 "bc/src/list.c"
  scheme_wrong_contract ("cadar" , "(cons/c (cons/c any/c pair?) any/c)" , 0 , argc , argv ) ; 

# 1921 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ; 
}

# 1922 "bc/src/list.c"
static Scheme_Object * caadr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1922 "bc/src/list.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1922 "bc/src/list.c"
  scheme_wrong_contract ("caadr" , "(cons/c any/c (cons/c pair? any/c))" , 0 , argc , argv ) ; 

# 1922 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ; 
}
static Scheme_Object * caaar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1924 "bc/src/list.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1924 "bc/src/list.c"
  scheme_wrong_contract ("caaar" , "(cons/c (cons/c pair? any/c) any/c)" , 0 , argc , argv ) ; 

# 1924 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ; 
}

# 1939 "bc/src/list.c"
static Scheme_Object * cddddr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1939 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1939 "bc/src/list.c"
  scheme_wrong_contract ("cddddr" , "(cons/c any/c (cons/c any/c (cons/c any/c pair?)))" , 0 , argc , argv ) ; 

# 1939 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
}
static Scheme_Object * cadddr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1941 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1941 "bc/src/list.c"
  scheme_wrong_contract ("cadddr" , "(cons/c any/c (cons/c any/c (cons/c any/c pair?)))" , 0 , argc , argv ) ; 

# 1941 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ; 
}

# 1942 "bc/src/list.c"
static Scheme_Object * cdaddr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1942 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1942 "bc/src/list.c"
  scheme_wrong_contract ("cdaddr" , "(cons/c any/c (cons/c any/c (cons/c pair? any/c)))" , 0 , argc , argv ) ; 

# 1942 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ; 
}

# 1943 "bc/src/list.c"
static Scheme_Object * cddadr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1943 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1943 "bc/src/list.c"
  scheme_wrong_contract ("cddadr" , "(cons/c any/c (cons/c (cons/c any/c pair?) any/c))" , 0 , argc , argv ) ; 

# 1943 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
}

# 1944 "bc/src/list.c"
static Scheme_Object * cdddar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1944 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1944 "bc/src/list.c"
  scheme_wrong_contract ("cdddar" , "(cons/c (cons/c any/c (cons/c any/c pair?)) any/c)" , 0 , argc , argv ) ; 

# 1944 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
}
static Scheme_Object * caaddr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1946 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1946 "bc/src/list.c"
  scheme_wrong_contract ("caaddr" , "(cons/c any/c (cons/c any/c (cons/c pair? any/c)))" , 0 , argc , argv ) ; 

# 1946 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ; 
}

# 1947 "bc/src/list.c"
static Scheme_Object * cadadr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1947 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1947 "bc/src/list.c"
  scheme_wrong_contract ("cadadr" , "(cons/c any/c (cons/c (cons/c any/c pair?) any/c))" , 0 , argc , argv ) ; 

# 1947 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ; 
}

# 1948 "bc/src/list.c"
static Scheme_Object * caddar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1948 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1948 "bc/src/list.c"
  scheme_wrong_contract ("caddar" , "(cons/c (cons/c any/c (cons/c any/c pair?)) any/c)" , 0 , argc , argv ) ; 

# 1948 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ; 
}

# 1949 "bc/src/list.c"
static Scheme_Object * cdaadr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1949 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1949 "bc/src/list.c"
  scheme_wrong_contract ("cdaadr" , "(cons/c any/c (cons/c (cons/c pair? any/c) any/c))" , 0 , argc , argv ) ; 

# 1949 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ; 
}

# 1950 "bc/src/list.c"
static Scheme_Object * cdadar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1950 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1950 "bc/src/list.c"
  scheme_wrong_contract ("cdadar" , "(cons/c (cons/c any/c (cons/c pair? any/c)) any/c)" , 0 , argc , argv ) ; 

# 1950 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ; 
}

# 1951 "bc/src/list.c"
static Scheme_Object * cddaar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1951 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1951 "bc/src/list.c"
  scheme_wrong_contract ("cddaar" , "(cons/c (cons/c (cons/c any/c pair?) any/c) any/c)" , 0 , argc , argv ) ; 

# 1951 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
}
static Scheme_Object * cdaaar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1953 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1953 "bc/src/list.c"
  scheme_wrong_contract ("cdaaar" , "(cons/c (cons/c (cons/c pair? any/c) any/c) any/c)" , 0 , argc , argv ) ; 

# 1953 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ; 
}

# 1954 "bc/src/list.c"
static Scheme_Object * cadaar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1954 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1954 "bc/src/list.c"
  scheme_wrong_contract ("cadaar" , "(cons/c (cons/c (cons/c any/c pair?) any/c) any/c)" , 0 , argc , argv ) ; 

# 1954 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ; 
}

# 1955 "bc/src/list.c"
static Scheme_Object * caadar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1955 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1955 "bc/src/list.c"
  scheme_wrong_contract ("caadar" , "(cons/c (cons/c any/c (cons/c pair? any/c)) any/c)" , 0 , argc , argv ) ; 

# 1955 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ; 
}

# 1956 "bc/src/list.c"
static Scheme_Object * caaadr_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1956 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1956 "bc/src/list.c"
  scheme_wrong_contract ("caaadr" , "(cons/c any/c (cons/c (cons/c pair? any/c) any/c))" , 0 , argc , argv ) ; 

# 1956 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ; 
}
static Scheme_Object * caaaar_prim (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1958 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )

# 1958 "bc/src/list.c"
  scheme_wrong_contract ("caaaar" , "(cons/c (cons/c (cons/c pair? any/c) any/c) any/c)" , 0 , argc , argv ) ; 

# 1958 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ; 
}
Scheme_Object * scheme_box (Scheme_Object * v ) 
{
  Scheme_Object * obj ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(obj, 1)));
# define XfOrM230_COUNT (2)
# define SETUP_XfOrM230(x) SETUP(XfOrM230_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  obj = NULLED_OUT ; 

# 1964 "bc/src/list.c"
  obj = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM230(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  obj -> type = scheme_box_type ; 
  (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) = v ; 

  RET_VALUE_START (obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1971 "bc/src/list.c"
static Scheme_Object * chaperone_unbox_k (void ) 
{
  /* No conversion */

# 1973 "bc/src/list.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  return scheme_unbox (o ) ; 
}

static Scheme_Object * chaperone_unbox_overflow (Scheme_Object * o ) 
{
  /* No conversion */

# 1983 "bc/src/list.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = (void * ) o ; 

  return scheme_handle_stack_overflow (chaperone_unbox_k ) ; 
}

static Scheme_Object * chaperone_unbox (Scheme_Object * obj ) 
{
  Scheme_Chaperone * px = (Scheme_Chaperone * ) obj ; 
  Scheme_Object * a [2 ] , * orig ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(px, 3), PUSH(orig, 4), PUSH(obj, 5)));
# define XfOrM233_COUNT (6)
# define SETUP_XfOrM233(x) SETUP(XfOrM233_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  orig = NULLED_OUT ; 

# 1996 "bc/src/list.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM235_COUNT (0+XfOrM233_COUNT)
#   define SETUP_XfOrM235(x) SETUP_XfOrM233(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 1998 "bc/src/list.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM235(_), chaperone_unbox_overflow (obj ) )) RET_VALUE_END ; 
  }


  orig = FUNCCALL(SETUP_XfOrM233(_), scheme_unbox (px -> prev ) ); 

  if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {

    RET_VALUE_START (orig ) RET_VALUE_END ; 
  }

  a [0 ] = px -> prev ; 
  a [1 ] = orig ; 
  obj = FUNCCALL(SETUP_XfOrM233(_), scheme_do_eval ((((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . car ) , 2 , a , 1 ) ); 

  if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
    if (! FUNCCALL(SETUP_XfOrM233(_), scheme_chaperone_of (obj , orig ) ))
    FUNCCALL(SETUP_XfOrM233(_), scheme_wrong_chaperoned ("unbox" , "result" , orig , obj ) ); 

  RET_VALUE_START (obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2020 "bc/src/list.c"
Scheme_Object * scheme_unbox (Scheme_Object * obj ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(obj, 0)));
# define XfOrM236_COUNT (1)
# define SETUP_XfOrM236(x) SETUP(XfOrM236_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2022 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {
#   define XfOrM237_COUNT (0+XfOrM236_COUNT)
#   define SETUP_XfOrM237(x) SETUP_XfOrM236(x)

# 2023 "bc/src/list.c"
    if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM237(_), chaperone_unbox (obj ) )) RET_VALUE_END ; 
    FUNCCALL(SETUP_XfOrM237(_), scheme_wrong_contract ("unbox" , "box?" , 0 , 1 , & obj ) )
    ; 
  }

  RET_VALUE_START ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2033 "bc/src/list.c"
Scheme_Object * scheme_unbox_star (Scheme_Object * obj ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(obj, 0)));
# define XfOrM238_COUNT (1)
# define SETUP_XfOrM238(x) SETUP(XfOrM238_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2035 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) )
    FUNCCALL(SETUP_XfOrM238(_), scheme_wrong_contract ("unbox*" , "(and/c box? (not/c impersonator?))" , 0 , 1 , & obj ) ); 

  RET_VALUE_START ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2041 "bc/src/list.c"
static void bad_cas_box (Scheme_Object * box ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(box, 0)));
# define XfOrM239_COUNT (1)
# define SETUP_XfOrM239(x) SETUP(XfOrM239_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM239(_), scheme_wrong_contract ("box-cas!" , "(and/c box? (not/c immutable?) (not/c impersonator?))" , 0 , 1 , & box ) )
# 2043 "bc/src/list.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2046 "bc/src/list.c"
Scheme_Object * scheme_box_cas (int argc , Scheme_Object * argv [] ) 
XFORM_SKIP_PROC 
{
  Scheme_Object * box = argv [0 ] ; 
  Scheme_Object * ov = argv [1 ] ; 
  Scheme_Object * nv = argv [2 ] ; 




  if (! (((Scheme_Type ) (((((intptr_t ) (box ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (box ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) && (! (((Scheme_Inclhash_Object * ) (box ) ) -> so . keyex & 0x1 ) ) ) ) {
    bad_cas_box (box ) ; 
    return ((void * ) 0 ) ; 
  }







  if ((((Scheme_Small_Object * ) (box ) ) -> u . ptr_val ) == ov ) {
    (((Scheme_Small_Object * ) (box ) ) -> u . ptr_val ) = nv ; 
    return scheme_true ; 
  }

# 2070 "bc/src/list.c"
  else {
    return scheme_false ; 
  }
}


static void chaperone_set_box (Scheme_Object * obj , Scheme_Object * v ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * a [2 ] ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(v, 3), PUSH(px, 4), PUSH(obj, 5)));
# define XfOrM240_COUNT (6)
# define SETUP_XfOrM240(x) SETUP(XfOrM240_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 2081 "bc/src/list.c"
  while (1 ) {
#   define XfOrM244_COUNT (0+XfOrM240_COUNT)
#   define SETUP_XfOrM244(x) SETUP_XfOrM240(x)

# 2082 "bc/src/list.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) )  {
      (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) = v ; 
      RET_NOTHING ; 
    }

# 2085 "bc/src/list.c"
    else {
#     define XfOrM245_COUNT (0+XfOrM244_COUNT)
#     define SETUP_XfOrM245(x) SETUP_XfOrM244(x)

# 2086 "bc/src/list.c"
      px = (Scheme_Chaperone * ) obj ; 

      obj = px -> prev ; 
      a [0 ] = obj ; 
      a [1 ] = v ; 
      v = FUNCCALL(SETUP_XfOrM245(_), scheme_do_eval ((((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) , 2 , a , 1 ) ); 

      if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
        if (! FUNCCALL(SETUP_XfOrM245(_), scheme_chaperone_of (v , a [1 ] ) ))
        FUNCCALL(SETUP_XfOrM245(_), scheme_wrong_chaperoned ("set-box!" , "value" , a [1 ] , v ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2100 "bc/src/list.c"
void scheme_set_box (Scheme_Object * b , Scheme_Object * v ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(v, 1)));
# define XfOrM247_COUNT (2)
# define SETUP_XfOrM247(x) SETUP(XfOrM247_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2102 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) && (! (((Scheme_Inclhash_Object * ) (b ) ) -> so . keyex & 0x1 ) ) ) ) {
#   define XfOrM248_COUNT (0+XfOrM247_COUNT)
#   define SETUP_XfOrM248(x) SETUP_XfOrM247(x)

# 2103 "bc/src/list.c"
    if ((((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) b ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) b ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) && (! (((Scheme_Inclhash_Object * ) ((((Scheme_Chaperone * ) b ) -> val ) ) ) -> so . keyex & 0x1 ) ) ) ) {
#     define XfOrM249_COUNT (0+XfOrM248_COUNT)
#     define SETUP_XfOrM249(x) SETUP_XfOrM248(x)
      FUNCCALL(SETUP_XfOrM249(_), chaperone_set_box (b , v ) )
# 2105 "bc/src/list.c"
      ; 
      RET_NOTHING ; 
    }
    FUNCCALL(SETUP_XfOrM248(_), scheme_wrong_contract ("set-box!" , "(and/c box? (not/c immutable?))" , 0 , 1 , & b ) )
    ; 
  }
  (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) = v ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2114 "bc/src/list.c"
void scheme_set_box_star (Scheme_Object * b , Scheme_Object * v ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(v, 1)));
# define XfOrM250_COUNT (2)
# define SETUP_XfOrM250(x) SETUP(XfOrM250_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2116 "bc/src/list.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) && (! (((Scheme_Inclhash_Object * ) (b ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL(SETUP_XfOrM250(_), scheme_wrong_contract ("set-box*!" , "(and/c box? (not/c immutable?) (not/c impersonator?))" , 0 , 1 , & b ) ); 

  (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) = v ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2122 "bc/src/list.c"
static Scheme_Object * box (int c , Scheme_Object * p [] ) 
{
  /* No conversion */

# 2124 "bc/src/list.c"
  return scheme_box (p [0 ] ) ; 
}

static Scheme_Object * immutable_box (int c , Scheme_Object * p [] ) 
{
  Scheme_Object * obj ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(obj, 0)));
# define XfOrM252_COUNT (1)
# define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  obj = NULLED_OUT ; 

# 2131 "bc/src/list.c"
  obj = FUNCCALL(SETUP_XfOrM252(_), scheme_box (p [0 ] ) ); 
  ((((Scheme_Inclhash_Object * ) (obj ) ) -> so . keyex |= 0x1 ) ) ; 

  RET_VALUE_START (obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2137 "bc/src/list.c"
static Scheme_Object * box_p (int c , Scheme_Object * p [] ) 
{
  /* No conversion */

# 2139 "bc/src/list.c"
  return (((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) p [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) p [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * unbox (int c , Scheme_Object * p [] ) 
{
  /* No conversion */

# 2144 "bc/src/list.c"
  return scheme_unbox (p [0 ] ) ; 
}

static Scheme_Object * unbox_star (int c , Scheme_Object * p [] ) 
{
  /* No conversion */

# 2149 "bc/src/list.c"
  return scheme_unbox_star (p [0 ] ) ; 
}

static Scheme_Object * set_box (int c , Scheme_Object * p [] ) 
{
  /* No conversion */

# 2154 "bc/src/list.c"
  scheme_set_box (p [0 ] , p [1 ] ) ; 
  return scheme_void ; 
}

static Scheme_Object * set_box_star (int c , Scheme_Object * p [] ) 
{
  /* No conversion */

# 2160 "bc/src/list.c"
  scheme_set_box_star (p [0 ] , p [1 ] ) ; 
  return scheme_void ; 
}

static Scheme_Object * do_chaperone_box (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(redirects, 0), PUSH(props, 1), PUSH(px, 2), PUSH(val, 3), PUSH(argv, 4), PUSH(name, 5)));
# define XfOrM258_COUNT (6)
# define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 2171 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || (is_impersonator && ! (! (((Scheme_Inclhash_Object * ) (val ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , is_impersonator ? "(and/c box? (not/c immutable?))" : "box?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM258(_), scheme_check_proc_arity (name , 2 , 1 , argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 2 , 2 , argc , argv ) ); 

  redirects = FUNCCALL_AGAIN(scheme_make_pair (argv [1 ] , argv [2 ] ) ); 

  props = FUNCCALL_AGAIN(scheme_parse_chaperone_props (name , 3 , argc , argv ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM258(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2196 "bc/src/list.c"
static Scheme_Object * chaperone_box (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2198 "bc/src/list.c"
  return do_chaperone_box ("chaperone-box" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_box (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2203 "bc/src/list.c"
  return do_chaperone_box ("impersonate-box" , 1 , argc , argv ) ; 
}

int scheme_compare_equal (void * v1 , void * v2 ) 
{
  /* No conversion */

# 2208 "bc/src/list.c"
  return ! scheme_equal ((Scheme_Object * ) v1 , (Scheme_Object * ) v2 ) ; 
}

static void make_hash_indices_for_equal (void * v , intptr_t * _stk_h1 , intptr_t * _stk_h2 ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(_stk_h2, 1)));
# define XfOrM262_COUNT (2)
# define SETUP_XfOrM262(x) SETUP(XfOrM262_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2213 "bc/src/list.c"
  if (_stk_h1 )
    * _stk_h1 = FUNCCALL(SETUP_XfOrM262(_), scheme_equal_hash_key ((Scheme_Object * ) v ) ); 
  if (_stk_h2 )
    * _stk_h2 = FUNCCALL_EMPTY(scheme_equal_hash_key2 ((Scheme_Object * ) v ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2219 "bc/src/list.c"
int scheme_compare_equal_always (void * v1 , void * v2 ) 
{
  /* No conversion */

# 2221 "bc/src/list.c"
  return ! scheme_equal_always ((Scheme_Object * ) v1 , (Scheme_Object * ) v2 ) ; 
}

static void make_hash_indices_for_equal_always (void * v , intptr_t * _stk_h1 , intptr_t * _stk_h2 ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(_stk_h2, 1)));
# define XfOrM264_COUNT (2)
# define SETUP_XfOrM264(x) SETUP(XfOrM264_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2226 "bc/src/list.c"
  if (_stk_h1 )
    * _stk_h1 = FUNCCALL(SETUP_XfOrM264(_), scheme_equal_always_hash_key ((Scheme_Object * ) v ) ); 
  if (_stk_h2 )
    * _stk_h2 = FUNCCALL_EMPTY(scheme_equal_always_hash_key2 ((Scheme_Object * ) v ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2232 "bc/src/list.c"
static int compare_eqv (void * v1 , void * v2 ) 
{
  /* No conversion */

# 2234 "bc/src/list.c"
  return ! scheme_eqv ((Scheme_Object * ) v1 , (Scheme_Object * ) v2 ) ; 
}

static void make_hash_indices_for_eqv (void * v , intptr_t * _stk_h1 , intptr_t * _stk_h2 ) 
{
  /* No conversion */

# 2239 "bc/src/list.c"
  if (_stk_h1 )
    * _stk_h1 = scheme_eqv_hash_key ((Scheme_Object * ) v ) ; 
  if (_stk_h2 )
    * _stk_h2 = scheme_eqv_hash_key2 ((Scheme_Object * ) v ) ; 
}

Scheme_Bucket_Table * scheme_make_weak_equal_table (void ) 
{
  Scheme_Object * sema ; 
  Scheme_Bucket_Table * t ; 
  DECL_RET_SAVE (Scheme_Bucket_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(sema, 1)));
# define XfOrM267_COUNT (2)
# define SETUP_XfOrM267(x) SETUP(XfOrM267_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 2250 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM267(_), scheme_make_bucket_table (20 , SCHEME_hash_weak_ptr ) ); 

  sema = FUNCCALL_AGAIN(scheme_make_sema (1 ) ); 
  t -> mutex = sema ; 
  t -> compare = scheme_compare_equal ; 
  t -> make_hash_indices = make_hash_indices_for_equal ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2260 "bc/src/list.c"
Scheme_Bucket_Table * scheme_make_ephemeron_equal_table (void ) 
{
  Scheme_Object * sema ; 
  Scheme_Bucket_Table * t ; 
  DECL_RET_SAVE (Scheme_Bucket_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(sema, 1)));
# define XfOrM268_COUNT (2)
# define SETUP_XfOrM268(x) SETUP(XfOrM268_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 2265 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM268(_), scheme_make_bucket_table (20 , SCHEME_hash_ephemeron_ptr ) ); 

  sema = FUNCCALL_AGAIN(scheme_make_sema (1 ) ); 
  t -> mutex = sema ; 
  t -> compare = scheme_compare_equal ; 
  t -> make_hash_indices = make_hash_indices_for_equal ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2275 "bc/src/list.c"
Scheme_Bucket_Table * scheme_make_nonlock_equal_bucket_table (void ) 
{
  Scheme_Bucket_Table * t ; 
  DECL_RET_SAVE (Scheme_Bucket_Table * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(t, 0)));
# define XfOrM269_COUNT (1)
# define SETUP_XfOrM269(x) SETUP(XfOrM269_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t = NULLED_OUT ; 

# 2279 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM269(_), scheme_make_bucket_table (20 , SCHEME_hash_ptr ) ); 

  t -> compare = scheme_compare_equal ; 
  t -> make_hash_indices = make_hash_indices_for_equal ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2287 "bc/src/list.c"
Scheme_Bucket_Table * scheme_make_weak_equal_always_table (void ) 
{
  Scheme_Object * sema ; 
  Scheme_Bucket_Table * t ; 
  DECL_RET_SAVE (Scheme_Bucket_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(sema, 1)));
# define XfOrM270_COUNT (2)
# define SETUP_XfOrM270(x) SETUP(XfOrM270_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 2292 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM270(_), scheme_make_bucket_table (20 , SCHEME_hash_weak_ptr ) ); 

  sema = FUNCCALL_AGAIN(scheme_make_sema (1 ) ); 
  t -> mutex = sema ; 
  t -> compare = scheme_compare_equal_always ; 
  t -> make_hash_indices = make_hash_indices_for_equal_always ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2302 "bc/src/list.c"
Scheme_Bucket_Table * scheme_make_ephemeron_equal_always_table (void ) 
{
  Scheme_Object * sema ; 
  Scheme_Bucket_Table * t ; 
  DECL_RET_SAVE (Scheme_Bucket_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(sema, 1)));
# define XfOrM271_COUNT (2)
# define SETUP_XfOrM271(x) SETUP(XfOrM271_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 2307 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM271(_), scheme_make_bucket_table (20 , SCHEME_hash_ephemeron_ptr ) ); 

  sema = FUNCCALL_AGAIN(scheme_make_sema (1 ) ); 
  t -> mutex = sema ; 
  t -> compare = scheme_compare_equal_always ; 
  t -> make_hash_indices = make_hash_indices_for_equal_always ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2317 "bc/src/list.c"
Scheme_Bucket_Table * scheme_make_nonlock_equal_always_bucket_table (void ) 
{
  Scheme_Bucket_Table * t ; 
  DECL_RET_SAVE (Scheme_Bucket_Table * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(t, 0)));
# define XfOrM272_COUNT (1)
# define SETUP_XfOrM272(x) SETUP(XfOrM272_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t = NULLED_OUT ; 

# 2321 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM272(_), scheme_make_bucket_table (20 , SCHEME_hash_ptr ) ); 

  t -> compare = scheme_compare_equal_always ; 
  t -> make_hash_indices = make_hash_indices_for_equal_always ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2329 "bc/src/list.c"
Scheme_Bucket_Table * scheme_make_weak_eqv_table (void ) 
{
  Scheme_Object * sema ; 
  Scheme_Bucket_Table * t ; 
  DECL_RET_SAVE (Scheme_Bucket_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(sema, 1)));
# define XfOrM273_COUNT (2)
# define SETUP_XfOrM273(x) SETUP(XfOrM273_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 2334 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM273(_), scheme_make_bucket_table (20 , SCHEME_hash_weak_ptr ) ); 

  sema = FUNCCALL_AGAIN(scheme_make_sema (1 ) ); 
  t -> mutex = sema ; 
  t -> compare = compare_eqv ; 
  t -> make_hash_indices = make_hash_indices_for_eqv ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2344 "bc/src/list.c"
Scheme_Bucket_Table * scheme_make_ephemeron_eqv_table (void ) 
{
  Scheme_Object * sema ; 
  Scheme_Bucket_Table * t ; 
  DECL_RET_SAVE (Scheme_Bucket_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(sema, 1)));
# define XfOrM274_COUNT (2)
# define SETUP_XfOrM274(x) SETUP(XfOrM274_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 2349 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM274(_), scheme_make_bucket_table (20 , SCHEME_hash_ephemeron_ptr ) ); 

  sema = FUNCCALL_AGAIN(scheme_make_sema (1 ) ); 
  t -> mutex = sema ; 
  t -> compare = compare_eqv ; 
  t -> make_hash_indices = make_hash_indices_for_eqv ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2359 "bc/src/list.c"
static Scheme_Object * fill_table (Scheme_Object * ht , const char * who , 
int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * l , * a , * args [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(l, 1), PUSH(ht, 2), PUSHARRAY(args, 3, 3), PUSH(argv, 6)));
# define XfOrM275_COUNT (7)
# define SETUP_XfOrM275(x) SETUP(XfOrM275_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  a = NULLED_OUT ; 
  args[0] = NULLED_OUT ; 
  args[1] = NULLED_OUT ; 
  args[2] = NULLED_OUT ; 

# 2364 "bc/src/list.c"
  if (argc ) {
#   define XfOrM276_COUNT (0+XfOrM275_COUNT)
#   define SETUP_XfOrM276(x) SETUP_XfOrM275(x)

# 2365 "bc/src/list.c"
    l = argv [0 ] ; 
    if ((scheme_proper_list_length (l ) ) >= 0 ) {
      for (; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
        a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
          break ; 
      }
    }

    if (! ((l ) == (scheme_null ) ) )
      FUNCCALL(SETUP_XfOrM276(_), scheme_wrong_contract (who , "(listof pair?)" , 0 , argc , argv ) ); 

    args [0 ] = ht ; 

    for (l = argv [0 ] ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM278_COUNT (0+XfOrM276_COUNT)
#     define SETUP_XfOrM278(x) SETUP_XfOrM276(x)

# 2380 "bc/src/list.c"
      a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      args [1 ] = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 
      args [2 ] = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 
      FUNCCALL(SETUP_XfOrM278(_), hash_table_put_bang (3 , args ) ); 
    }
  }

  RET_VALUE_START (ht ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2390 "bc/src/list.c"
static Scheme_Object * make_hash (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM282_COUNT (2)
# define SETUP_XfOrM282(x) SETUP(XfOrM282_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2393 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM282(_), scheme_make_hash_table_equal () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-hash" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2397 "bc/src/list.c"
static Scheme_Object * make_hasheq (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM283_COUNT (2)
# define SETUP_XfOrM283(x) SETUP(XfOrM283_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2400 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM283(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-hasheq" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2404 "bc/src/list.c"
static Scheme_Object * make_hasheqv (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM284_COUNT (2)
# define SETUP_XfOrM284(x) SETUP(XfOrM284_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2407 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM284(_), scheme_make_hash_table_eqv () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-hasheqv" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2411 "bc/src/list.c"
static Scheme_Object * make_hashalw (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM285_COUNT (2)
# define SETUP_XfOrM285(x) SETUP(XfOrM285_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2414 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM285(_), scheme_make_hash_table_equal_always () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-hashalw" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2418 "bc/src/list.c"
static Scheme_Object * make_weak_hash (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM286_COUNT (2)
# define SETUP_XfOrM286(x) SETUP(XfOrM286_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2421 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM286(_), scheme_make_weak_equal_table () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-weak-hash" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2425 "bc/src/list.c"
static Scheme_Object * make_weak_hasheq (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM287_COUNT (2)
# define SETUP_XfOrM287(x) SETUP(XfOrM287_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2428 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM287(_), scheme_make_bucket_table (20 , SCHEME_hash_weak_ptr ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-weak-hasheq" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2432 "bc/src/list.c"
static Scheme_Object * make_weak_hasheqv (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM288_COUNT (2)
# define SETUP_XfOrM288(x) SETUP(XfOrM288_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2435 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM288(_), scheme_make_weak_eqv_table () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-weak-hasheqv" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2439 "bc/src/list.c"
static Scheme_Object * make_weak_hashalw (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM289_COUNT (2)
# define SETUP_XfOrM289(x) SETUP(XfOrM289_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2442 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM289(_), scheme_make_weak_equal_always_table () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-weak-hashalw" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2446 "bc/src/list.c"
static Scheme_Object * make_ephemeron_hash (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM290_COUNT (2)
# define SETUP_XfOrM290(x) SETUP(XfOrM290_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2449 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM290(_), scheme_make_ephemeron_equal_table () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-ephemeron-hash" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2453 "bc/src/list.c"
static Scheme_Object * make_ephemeron_hasheq (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM291_COUNT (2)
# define SETUP_XfOrM291(x) SETUP(XfOrM291_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2456 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM291(_), scheme_make_bucket_table (20 , SCHEME_hash_ephemeron_ptr ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-ephemeron-hasheq" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2460 "bc/src/list.c"
static Scheme_Object * make_ephemeron_hasheqv (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM292_COUNT (2)
# define SETUP_XfOrM292(x) SETUP(XfOrM292_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2463 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM292(_), scheme_make_ephemeron_eqv_table () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-ephemeron-hasheqv" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2467 "bc/src/list.c"
static Scheme_Object * make_ephemeron_hashalw (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM293_COUNT (2)
# define SETUP_XfOrM293(x) SETUP(XfOrM293_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2470 "bc/src/list.c"
  ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM293(_), scheme_make_ephemeron_equal_always_table () ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(fill_table (ht , "make-ephemeron-hashalw" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2474 "bc/src/list.c"
static Scheme_Object * make_immutable_table (const char * who , int kind , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * l = (argc ? argv [0 ] : scheme_null ) , * a ; 
  Scheme_Hash_Tree * ht ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(l, 1), PUSH(ht, 2), PUSH(argv, 3)));
# define XfOrM294_COUNT (4)
# define SETUP_XfOrM294(x) SETUP(XfOrM294_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 
  ht = NULLED_OUT ; 

# 2479 "bc/src/list.c"
  if ((scheme_proper_list_length (l ) ) >= 0 ) {
    for (; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
      a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
        break ; 
    }
  }

  if (! ((l ) == (scheme_null ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "(listof pair?)" , 0 , argc , argv ) ); 

  ht = (scheme_make_hash_tree (kind ) ) ; 

  for (l = (argc ? argv [0 ] : scheme_null ) ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#   define XfOrM296_COUNT (0+XfOrM294_COUNT)
#   define SETUP_XfOrM296(x) SETUP_XfOrM294(x)

# 2493 "bc/src/list.c"
    a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    ht = FUNCCALL(SETUP_XfOrM296(_), scheme_hash_tree_set (ht , (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ) ); 
  }

  RET_VALUE_START ((Scheme_Object * ) ht ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2500 "bc/src/list.c"
Scheme_Object * scheme_make_immutable_hash (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2502 "bc/src/list.c"
  return make_immutable_table ("make-immutable-hash" , 1 , argc , argv ) ; 
}

Scheme_Object * scheme_make_immutable_hasheq (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2507 "bc/src/list.c"
  return make_immutable_table ("make-immutable-hasheq" , 0 , argc , argv ) ; 
}

Scheme_Object * scheme_make_immutable_hasheqv (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2512 "bc/src/list.c"
  return make_immutable_table ("make-immutable-hasheqv" , 2 , argc , argv ) ; 
}

Scheme_Object * scheme_make_immutable_hashalw (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2517 "bc/src/list.c"
  return make_immutable_table ("make-immutable-hashalw" , 3 , argc , argv ) ; 
}

static Scheme_Object * direct_table (const char * who , int kind , Scheme_Hash_Tree * empty , int argc , Scheme_Object * argv [] ) 
{
  int i ; 
  Scheme_Hash_Tree * ht ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(argv, 1)));
# define XfOrM304_COUNT (2)
# define SETUP_XfOrM304(x) SETUP(XfOrM304_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2525 "bc/src/list.c"
  if (argc & 0x1 ) {
#   define XfOrM307_COUNT (0+XfOrM304_COUNT)
#   define SETUP_XfOrM307(x) SETUP_XfOrM304(x)
    FUNCCALL_EMPTY(scheme_contract_error (who , "key does not have a value (i.e., an odd number of arguments were provided)" , "key" , 1 , argv [argc - 1 ] , ((void * ) 0 ) ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (! argc )
    ht = (scheme_make_hash_tree (kind ) ) ; 
  else 
  ht = empty ; 

  for (i = 0 ; i < argc ; i += 2 ) {
#   define XfOrM306_COUNT (0+XfOrM304_COUNT)
#   define SETUP_XfOrM306(x) SETUP_XfOrM304(x)

# 2539 "bc/src/list.c"
    ht = FUNCCALL(SETUP_XfOrM306(_), scheme_hash_tree_set (ht , argv [i ] , argv [i + 1 ] ) ); 
  }

  RET_VALUE_START ((Scheme_Object * ) ht ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2545 "bc/src/list.c"
static Scheme_Object * direct_hash (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2547 "bc/src/list.c"
  return direct_table ("hash" , 1 , empty_hash , argc , argv ) ; 
}

static Scheme_Object * direct_hasheq (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2552 "bc/src/list.c"
  return direct_table ("hasheq" , 0 , empty_hasheq , argc , argv ) ; 
}

static Scheme_Object * direct_hasheqv (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2557 "bc/src/list.c"
  return direct_table ("hasheqv" , 2 , empty_hasheqv , argc , argv ) ; 
}

static Scheme_Object * direct_hashalw (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2562 "bc/src/list.c"
  return direct_table ("hashalw" , 3 , empty_hashalw , argc , argv ) ; 
}

Scheme_Hash_Table * scheme_make_hash_table_equal () 
{
  Scheme_Hash_Table * t ; 
  Scheme_Object * sema ; 
  DECL_RET_SAVE (Scheme_Hash_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(sema, 1)));
# define XfOrM312_COUNT (2)
# define SETUP_XfOrM312(x) SETUP(XfOrM312_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 2570 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM312(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  sema = FUNCCALL_AGAIN(scheme_make_sema (1 ) ); 
  t -> mutex = sema ; 
  t -> compare = scheme_compare_equal ; 
  t -> make_hash_indices = make_hash_indices_for_equal ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2580 "bc/src/list.c"
Scheme_Hash_Table * scheme_make_hash_table_equal_always () 
{
  Scheme_Hash_Table * t ; 
  Scheme_Object * sema ; 
  DECL_RET_SAVE (Scheme_Hash_Table * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(sema, 1)));
# define XfOrM313_COUNT (2)
# define SETUP_XfOrM313(x) SETUP(XfOrM313_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 2585 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM313(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  sema = FUNCCALL_AGAIN(scheme_make_sema (1 ) ); 
  t -> mutex = sema ; 
  t -> compare = scheme_compare_equal_always ; 
  t -> make_hash_indices = make_hash_indices_for_equal_always ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2595 "bc/src/list.c"
Scheme_Hash_Table * scheme_make_hash_table_eqv () 
{
  Scheme_Hash_Table * t ; 
  DECL_RET_SAVE (Scheme_Hash_Table * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(t, 0)));
# define XfOrM314_COUNT (1)
# define SETUP_XfOrM314(x) SETUP(XfOrM314_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t = NULLED_OUT ; 

# 2599 "bc/src/list.c"
  t = FUNCCALL(SETUP_XfOrM314(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  t -> compare = compare_eqv ; 
  t -> make_hash_indices = make_hash_indices_for_eqv ; 

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2607 "bc/src/list.c"
Scheme_Object * scheme_checked_hash_count (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM315_COUNT (1)
# define SETUP_XfOrM315(x) SETUP(XfOrM315_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2611 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    Scheme_Hash_Table * t = (Scheme_Hash_Table * ) v ; 
    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (t -> count ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  }

# 2617 "bc/src/list.c"
  else if ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    Scheme_Hash_Tree * t = (Scheme_Hash_Tree * ) v ; 
    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (t -> count ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  }

# 2620 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) v ; 
    int count = 0 , weak , i ; 
    Scheme_Bucket * * buckets , * bucket ; 
    const char * key ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM315_COUNT), PUSH(key, 1+XfOrM315_COUNT), PUSH(bucket, 2+XfOrM315_COUNT), PUSH(buckets, 3+XfOrM315_COUNT)));
#   define XfOrM317_COUNT (4+XfOrM315_COUNT)
#   define SETUP_XfOrM317(x) SETUP(XfOrM317_COUNT)
    buckets = NULLED_OUT ; 
    bucket = NULLED_OUT ; 
    key = NULLED_OUT ; 

# 2626 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM317(_), scheme_wait_sema (t -> mutex , 0 ) )
# 2626 "bc/src/list.c"
    ; 

    buckets = t -> buckets ; 
    weak = t -> weak ; 

    for (i = t -> size ; i -- ; ) {
#     define XfOrM324_COUNT (0+XfOrM317_COUNT)
#     define SETUP_XfOrM324(x) SETUP_XfOrM317(x)

# 2632 "bc/src/list.c"
      bucket = buckets [i ] ; 
      if (bucket ) {
        if (weak ) {
          key = (const char * ) (((Scheme_Small_Object * ) (bucket -> key ) ) -> u . ptr_val ) ; 
        }

# 2636 "bc/src/list.c"
        else {
          key = bucket -> key ; 
        }
        if (key )
          count ++ ; 
      }
      {
#       define XfOrM325_COUNT (0+XfOrM324_COUNT)
#       define SETUP_XfOrM325(x) SETUP_XfOrM324(x)

# 2642 "bc/src/list.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM326_COUNT (0+XfOrM325_COUNT)
#         define SETUP_XfOrM326(x) SETUP_XfOrM325(x)
          FUNCCALL(SETUP_XfOrM326(_), scheme_out_of_fuel () )
# 2642 "bc/src/list.c"
          ; 
        }
      }

# 2642 "bc/src/list.c"
      ; 
    }

    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM317(_), scheme_post_sema (t -> mutex ) )
# 2645 "bc/src/list.c"
    ; 

    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (count ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  }

# 2648 "bc/src/list.c"
  else {
#   define XfOrM316_COUNT (0+XfOrM315_COUNT)
#   define SETUP_XfOrM316(x) SETUP_XfOrM315(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-count" , "hash?" , 0 , argc , argv ) )
# 2649 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2654 "bc/src/list.c"
static Scheme_Object * hash_table_copy (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1)));
# define XfOrM332_COUNT (2)
# define SETUP_XfOrM332(x) SETUP(XfOrM332_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2658 "bc/src/list.c"
  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) ) )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_chaperone_hash_table_copy (v ) )) RET_VALUE_EMPTY_END ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    Scheme_Object * o ; 
    Scheme_Hash_Table * t = (Scheme_Hash_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM332_COUNT), PUSH(o, 1+XfOrM332_COUNT)));
#   define XfOrM336_COUNT (2+XfOrM332_COUNT)
#   define SETUP_XfOrM336(x) SETUP(XfOrM336_COUNT)
    o = NULLED_OUT ; 

# 2665 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM336(_), scheme_wait_sema (t -> mutex , 0 ) )
# 2665 "bc/src/list.c"
    ; 
    o = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM336(_), scheme_clone_hash_table (t ) ); 
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM336(_), scheme_post_sema (t -> mutex ) )
# 2667 "bc/src/list.c"
    ; 
    RET_VALUE_START (o ) RET_VALUE_END ; 
  }

# 2669 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    Scheme_Object * o ; 
    Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM332_COUNT), PUSH(o, 1+XfOrM332_COUNT)));
#   define XfOrM335_COUNT (2+XfOrM332_COUNT)
#   define SETUP_XfOrM335(x) SETUP(XfOrM335_COUNT)
    o = NULLED_OUT ; 

# 2672 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM335(_), scheme_wait_sema (t -> mutex , 0 ) )
# 2672 "bc/src/list.c"
    ; 
    o = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM335(_), scheme_clone_bucket_table (t ) ); 
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM335(_), scheme_post_sema (t -> mutex ) )
# 2674 "bc/src/list.c"
    ; 
    RET_VALUE_START (o ) RET_VALUE_END ; 
  }

# 2676 "bc/src/list.c"
  else if ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
#   define XfOrM334_COUNT (0+XfOrM332_COUNT)
#   define SETUP_XfOrM334(x) SETUP_XfOrM332(x)

# 2677 "bc/src/list.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_hash_tree_copy (v ) )) RET_VALUE_EMPTY_END ; 
  }

# 2678 "bc/src/list.c"
  else {
#   define XfOrM333_COUNT (0+XfOrM332_COUNT)
#   define SETUP_XfOrM333(x) SETUP_XfOrM332(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-copy" , "hash?" , 0 , argc , argv ) )
# 2679 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2684 "bc/src/list.c"
Scheme_Object * scheme_hash_tree_copy (Scheme_Object * v ) 
{
  Scheme_Hash_Tree * t ; 
  Scheme_Hash_Table * naya ; 
  mzlonglong i ; 
  Scheme_Object * k , * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(k, 1), PUSH(v, 2), PUSH(val, 3), PUSH(naya, 4)));
# define XfOrM337_COUNT (5)
# define SETUP_XfOrM337(x) SETUP(XfOrM337_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t = NULLED_OUT ; 
  naya = NULLED_OUT ; 
  k = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 2691 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    t = (Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) v ) -> val ) ; 
  else 
  t = (Scheme_Hash_Tree * ) v ; 

  if (FUNCCALL(SETUP_XfOrM337(_), scheme_is_hash_tree_equal ((Scheme_Object * ) t ) ))
    naya = FUNCCALL(SETUP_XfOrM337(_), scheme_make_hash_table_equal () ); 
  else if (FUNCCALL(SETUP_XfOrM337(_), scheme_is_hash_tree_equal_always ((Scheme_Object * ) t ) ))
    naya = FUNCCALL(SETUP_XfOrM337(_), scheme_make_hash_table_equal_always () ); 
  else if (FUNCCALL(SETUP_XfOrM337(_), scheme_is_hash_tree_eqv ((Scheme_Object * ) t ) ))
    naya = FUNCCALL(SETUP_XfOrM337(_), scheme_make_hash_table_eqv () ); 
  else 
  naya = FUNCCALL(SETUP_XfOrM337(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  for (i = (scheme_hash_tree_next (t , - 1 ) ) ; i != - 1 ; i = (scheme_hash_tree_next (t , i ) ) ) {
#   define XfOrM339_COUNT (0+XfOrM337_COUNT)
#   define SETUP_XfOrM339(x) SETUP_XfOrM337(x)
    (
# 2706 "bc/src/list.c"
    scheme_hash_tree_index (t , i , & k , & val ) ) ; 
    if (! (((Scheme_Object * ) t ) == (v ) ) )
      val = FUNCCALL(SETUP_XfOrM339(_), scheme_chaperone_hash_traversal_get (v , k , & k ) ); 
    if (val )
      FUNCCALL(SETUP_XfOrM339(_), scheme_hash_set (naya , k , val ) ); 
  }

  RET_VALUE_START ((Scheme_Object * ) naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2716 "bc/src/list.c"
static Scheme_Object * hash_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2718 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) )
    return scheme_true ; 
  else 
  return scheme_false ; 
}

Scheme_Object * scheme_hash_eq_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2731 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    if ((((Scheme_Hash_Table * ) o ) -> compare != scheme_compare_equal ) 
    && (((Scheme_Hash_Table * ) o ) -> compare != scheme_compare_equal_always ) 
    && (((Scheme_Hash_Table * ) o ) -> compare != compare_eqv ) )
      return scheme_true ; 
  }

# 2741 "bc/src/list.c"
  else if ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    if ((Scheme_Type ) (scheme_eq_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) ) ) 
      return scheme_true ; 
  }

# 2744 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    if ((((Scheme_Bucket_Table * ) o ) -> compare != scheme_compare_equal ) 
    && (((Scheme_Bucket_Table * ) o ) -> compare != scheme_compare_equal_always ) 
    && (((Scheme_Bucket_Table * ) o ) -> compare != compare_eqv ) )
      return scheme_true ; 
  }

# 2749 "bc/src/list.c"
  else {
    scheme_wrong_contract ("hash-eq?" , "hash?" , 0 , argc , argv ) ; 
  }

  return scheme_false ; 
}

Scheme_Object * scheme_hash_eqv_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2758 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    if (((Scheme_Hash_Table * ) o ) -> compare == compare_eqv )
      return scheme_true ; 
  }

# 2766 "bc/src/list.c"
  else if ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    if ((Scheme_Type ) (scheme_eqv_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) ) ) 
      return scheme_true ; 
  }

# 2769 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    if (((Scheme_Bucket_Table * ) o ) -> compare == compare_eqv )
      return scheme_true ; 
  }

# 2772 "bc/src/list.c"
  else {
    scheme_wrong_contract ("hash-eqv?" , "hash?" , 0 , argc , argv ) ; 
  }

  return scheme_false ; 
}

Scheme_Object * scheme_hash_equal_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2781 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    if (((Scheme_Hash_Table * ) o ) -> compare == scheme_compare_equal )
      return scheme_true ; 
  }

# 2789 "bc/src/list.c"
  else if ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    if ((Scheme_Type ) (scheme_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) ) ) 
      return scheme_true ; 
  }

# 2792 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    if (((Scheme_Bucket_Table * ) o ) -> compare == scheme_compare_equal )
      return scheme_true ; 
  }

# 2795 "bc/src/list.c"
  else {
    scheme_wrong_contract ("hash-equal?" , "hash?" , 0 , argc , argv ) ; 
  }

  return scheme_false ; 
}

Scheme_Object * scheme_hash_equal_always_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2804 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    if (((Scheme_Hash_Table * ) o ) -> compare == scheme_compare_equal_always )
      return scheme_true ; 
  }

# 2812 "bc/src/list.c"
  else if ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    if ((Scheme_Type ) (scheme_equal_always_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) ) ) 
      return scheme_true ; 
  }

# 2815 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    if (((Scheme_Bucket_Table * ) o ) -> compare == scheme_compare_equal_always )
      return scheme_true ; 
  }

# 2818 "bc/src/list.c"
  else {
    scheme_wrong_contract ("hash-equal-always?" , "hash?" , 0 , argc , argv ) ; 
  }

  return scheme_false ; 
}

static Scheme_Object * strong_weak_p (const char * who , int weak , int eph , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2827 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    if (! weak )
      return scheme_false ; 
    return ((((Scheme_Bucket_Table * ) o ) -> weak == 3 ) 
    ? (eph ? scheme_true : scheme_false ) 
    : (eph ? scheme_false : scheme_true ) ) ; 
  }

# 2838 "bc/src/list.c"
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) )
    return (weak ? scheme_false : scheme_true ) ; 

  scheme_wrong_contract (who , "hash?" , 0 , argc , argv ) ; 

  return ((void * ) 0 ) ; 
}

static Scheme_Object * hash_strong_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 2847 "bc/src/list.c"
  return strong_weak_p ("hash-strong?" , 0 , 0 , argc , argv ) ; 
}

static Scheme_Object * hash_weak_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 2851 "bc/src/list.c"
  return strong_weak_p ("hash-weak?" , 1 , 0 , argc , argv ) ; 
}

static Scheme_Object * hash_ephemeron_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 2855 "bc/src/list.c"
  return strong_weak_p ("hash-ephemeron?" , 1 , 1 , argc , argv ) ; 
}

int scheme_is_hash_table_equal (Scheme_Object * o ) 
{
  /* No conversion */

# 2860 "bc/src/list.c"
  return (((Scheme_Hash_Table * ) o ) -> compare == scheme_compare_equal ) ; 
}

int scheme_is_hash_table_eqv (Scheme_Object * o ) 
{
  /* No conversion */

# 2865 "bc/src/list.c"
  return (((Scheme_Hash_Table * ) o ) -> compare == compare_eqv ) ; 
}

int scheme_is_hash_table_equal_always (Scheme_Object * o ) 
{
  /* No conversion */

# 2870 "bc/src/list.c"
  return (((Scheme_Hash_Table * ) o ) -> compare == scheme_compare_equal_always ) ; 
}

int scheme_is_hash_tree_equal (Scheme_Object * o ) 
{
  /* No conversion */

# 2875 "bc/src/list.c"
  return ((Scheme_Type ) (scheme_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) ) ) ; 
}

int scheme_is_hash_tree_eqv (Scheme_Object * o ) 
{
  /* No conversion */

# 2880 "bc/src/list.c"
  return ((Scheme_Type ) (scheme_eqv_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) ) ) ; 
}

int scheme_is_hash_tree_equal_always (Scheme_Object * o ) 
{
  /* No conversion */

# 2885 "bc/src/list.c"
  return ((Scheme_Type ) (scheme_equal_always_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) ) ) ; 
}

static Scheme_Object * hash_table_put_bang (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1)));
# define XfOrM372_COUNT (2)
# define SETUP_XfOrM372(x) SETUP(XfOrM372_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2892 "bc/src/list.c"
  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) ) )
    FUNCCALL(SETUP_XfOrM372(_), scheme_chaperone_hash_set (v , argv [1 ] , argv [2 ] ) ); 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM372_COUNT)));
#   define XfOrM376_COUNT (1+XfOrM372_COUNT)
#   define SETUP_XfOrM376(x) SETUP(XfOrM376_COUNT)

# 2897 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM376(_), scheme_wait_sema (t -> mutex , 0 ) )
# 2897 "bc/src/list.c"
    ; 
    FUNCCALL(SETUP_XfOrM376(_), scheme_add_to_table (t , (char * ) argv [1 ] , (void * ) argv [2 ] , 0 ) ); 
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM376(_), scheme_post_sema (t -> mutex ) )
# 2899 "bc/src/list.c"
    ; 
  }

# 2900 "bc/src/list.c"
  else if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ! (! (((Scheme_Inclhash_Object * ) (v ) ) -> so . keyex & 0x1 ) ) ) {
#   define XfOrM375_COUNT (0+XfOrM372_COUNT)
#   define SETUP_XfOrM375(x) SETUP_XfOrM372(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-set!" , "(and/c hash? (not/c immutable?))" , 0 , argc , argv ) )
# 2901 "bc/src/list.c"
    ; 
  }

# 2902 "bc/src/list.c"
  else if (((Scheme_Hash_Table * ) v ) -> mutex ) {
#   define XfOrM374_COUNT (0+XfOrM372_COUNT)
#   define SETUP_XfOrM374(x) SETUP_XfOrM372(x)
    FUNCCALL(SETUP_XfOrM374(_), scheme_wait_sema (((Scheme_Hash_Table * ) v ) -> mutex , 0 ) )
# 2903 "bc/src/list.c"
    ; 
    FUNCCALL(SETUP_XfOrM374(_), scheme_hash_set ((Scheme_Hash_Table * ) v , argv [1 ] , argv [2 ] ) ); 
    FUNCCALL_AGAIN(scheme_post_sema (((Scheme_Hash_Table * ) v ) -> mutex ) ); 
  }

# 2906 "bc/src/list.c"
  else {
#   define XfOrM373_COUNT (0+XfOrM372_COUNT)
#   define SETUP_XfOrM373(x) SETUP_XfOrM372(x)
    FUNCCALL_EMPTY(scheme_hash_set ((Scheme_Hash_Table * ) v , argv [1 ] , argv [2 ] ) )
# 2907 "bc/src/list.c"
    ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2913 "bc/src/list.c"
Scheme_Object * scheme_hash_table_put (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2915 "bc/src/list.c"
  Scheme_Object * v = argv [0 ] ; 

  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) )
    return chaperone_hash_tree_set (v , argv [1 ] , argv [2 ] ) ; 

  if (! ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) {
    scheme_wrong_contract ("hash-set" , "(and hash? immutable?)" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }

  return (Scheme_Object * ) scheme_hash_tree_set ((Scheme_Hash_Tree * ) v , argv [1 ] , argv [2 ] ) ; 
}

static Scheme_Object * hash_failed (const char * who , const char * contract_error_message , 
int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(contract_error_message, 0), PUSH(v, 1), PUSH(who, 2), PUSH(argv, 3)));
# define XfOrM379_COUNT (4)
# define SETUP_XfOrM379(x) SETUP(XfOrM379_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 2933 "bc/src/list.c"
  if (argc == 3 ) {
#   define XfOrM381_COUNT (0+XfOrM379_COUNT)
#   define SETUP_XfOrM381(x) SETUP_XfOrM379(x)

# 2934 "bc/src/list.c"
    v = argv [2 ] ; 
    if (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
#     define XfOrM382_COUNT (0+XfOrM381_COUNT)
#     define SETUP_XfOrM382(x) SETUP_XfOrM381(x)

# 2936 "bc/src/list.c"
      if (! FUNCCALL(SETUP_XfOrM382(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 2 , argc , argv ) )) {
#       define XfOrM383_COUNT (0+XfOrM382_COUNT)
#       define SETUP_XfOrM383(x) SETUP_XfOrM382(x)
        FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "%s: arity mismatch for failure procedure;\n" " given procedure does not accept zero arguments\n" "  procedure: %V" , who , v ) )

        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (v , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
    }

# 2945 "bc/src/list.c"
    else 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

# 2947 "bc/src/list.c"
  else {
#   define XfOrM380_COUNT (0+XfOrM379_COUNT)
#   define SETUP_XfOrM380(x) SETUP_XfOrM379(x)
    FUNCCALL_EMPTY(scheme_contract_error (who , contract_error_message , "key" , 1 , argv [1 ] , ((void * ) 0 ) ) )
    ; 
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2956 "bc/src/list.c"
static Scheme_Object * hash_ref_failed (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2958 "bc/src/list.c"
  return hash_failed ("hash-ref" , "no value found for key" , argc , argv ) ; 
}

static int scheme_chaperoned_hashp (Scheme_Object * v ) 
{
  /* No conversion */

# 2963 "bc/src/list.c"
  return ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
  || ((((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) ) ) ; 
}

static Scheme_Object * gen_hash_table_get (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1)));
# define XfOrM386_COUNT (2)
# define SETUP_XfOrM386(x) SETUP(XfOrM386_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 2972 "bc/src/list.c"
  v = argv [0 ] ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
#   define XfOrM390_COUNT (0+XfOrM386_COUNT)
#   define SETUP_XfOrM390(x) SETUP_XfOrM386(x)

# 2975 "bc/src/list.c"
    if (((Scheme_Hash_Table * ) v ) -> mutex ) {
      Scheme_Hash_Table * t = (Scheme_Hash_Table * ) v ; 
      BLOCK_SETUP((PUSH(t, 0+XfOrM390_COUNT)));
#     define XfOrM392_COUNT (1+XfOrM390_COUNT)
#     define SETUP_XfOrM392(x) SETUP(XfOrM392_COUNT)
      FUNCCALL(SETUP_XfOrM392(_), scheme_wait_sema (t -> mutex , 0 ) )
# 2977 "bc/src/list.c"
      ; 
      v = FUNCCALL(SETUP_XfOrM392(_), scheme_hash_get (t , argv [1 ] ) ); 
      FUNCCALL_AGAIN(scheme_post_sema (t -> mutex ) ); 
    }

# 2980 "bc/src/list.c"
    else {
#     define XfOrM391_COUNT (0+XfOrM390_COUNT)
#     define SETUP_XfOrM391(x) SETUP_XfOrM390(x)

# 2981 "bc/src/list.c"
      v = FUNCCALL(SETUP_XfOrM391(_), scheme_hash_get ((Scheme_Hash_Table * ) v , argv [1 ] ) ); 
    }
  }

# 2983 "bc/src/list.c"
  else if ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
#   define XfOrM389_COUNT (0+XfOrM386_COUNT)
#   define SETUP_XfOrM389(x) SETUP_XfOrM386(x)

# 2984 "bc/src/list.c"
    v = FUNCCALL(SETUP_XfOrM389(_), scheme_hash_tree_get ((Scheme_Hash_Tree * ) v , argv [1 ] ) ); 
  }

# 2985 "bc/src/list.c"
  else if (FUNCCALL(SETUP_XfOrM386(_), scheme_chaperoned_hashp (v ) ))
    v = FUNCCALL(SETUP_XfOrM386(_), scheme_chaperone_hash_get (v , argv [1 ] ) ); 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM386_COUNT)));
#   define XfOrM388_COUNT (1+XfOrM386_COUNT)
#   define SETUP_XfOrM388(x) SETUP(XfOrM388_COUNT)

# 2989 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM388(_), scheme_wait_sema (t -> mutex , 0 ) )
# 2989 "bc/src/list.c"
    ; 
    v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM388(_), scheme_lookup_in_table (t , (char * ) argv [1 ] ) ); 
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM388(_), scheme_post_sema (t -> mutex ) )
# 2991 "bc/src/list.c"
    ; 
  }

# 2992 "bc/src/list.c"
  else {
#   define XfOrM387_COUNT (0+XfOrM386_COUNT)
#   define SETUP_XfOrM387(x) SETUP_XfOrM386(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-ref" , "hash?" , 0 , argc , argv ) )
# 2993 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (v )
    RET_VALUE_START (v ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(hash_ref_failed (argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3003 "bc/src/list.c"
Scheme_Object * scheme_checked_hash_ref (int argc , Scheme_Object * argv [] ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 3005 "bc/src/list.c"
  Scheme_Object * v ; 


  v = argv [0 ] ; 
  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    if (! ((Scheme_Hash_Table * ) v ) -> make_hash_indices ) {
      v = scheme_eq_hash_get ((Scheme_Hash_Table * ) v , argv [1 ] ) ; 
      if (v )
        return v ; 
      else 
      return hash_ref_failed (argc , argv ) ; 
    }
  }

# 3017 "bc/src/list.c"
  else if ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    if ((Scheme_Type ) (scheme_eq_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) v ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) v ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) ) )  {
      v = scheme_eq_hash_tree_get ((Scheme_Hash_Tree * ) v , argv [1 ] ) ; 
      if (v )
        return v ; 
      else 
      return hash_ref_failed (argc , argv ) ; 
    }
  }

  return gen_hash_table_get (argc , argv ) ; 
}

Scheme_Object * hash_table_ref_key (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1)));
# define XfOrM398_COUNT (2)
# define SETUP_XfOrM398(x) SETUP(XfOrM398_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3034 "bc/src/list.c"
  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    Scheme_Hash_Table * t = (Scheme_Hash_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM398_COUNT)));
#   define XfOrM403_COUNT (1+XfOrM398_COUNT)
#   define SETUP_XfOrM403(x) SETUP(XfOrM403_COUNT)

# 3036 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM403(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3036 "bc/src/list.c"
    ; 
    v = FUNCCALL(SETUP_XfOrM403(_), scheme_hash_get_key (t , argv [1 ] ) ); 
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM403(_), scheme_post_sema (t -> mutex ) )
# 3038 "bc/src/list.c"
    ; 
  }

# 3039 "bc/src/list.c"
  else if ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
#   define XfOrM402_COUNT (0+XfOrM398_COUNT)
#   define SETUP_XfOrM402(x) SETUP_XfOrM398(x)

# 3040 "bc/src/list.c"
    v = FUNCCALL(SETUP_XfOrM402(_), scheme_hash_tree_get_key ((Scheme_Hash_Tree * ) v , argv [1 ] ) ); 
  }

# 3041 "bc/src/list.c"
  else if (FUNCCALL(SETUP_XfOrM398(_), scheme_chaperoned_hashp (v ) )) {
#   define XfOrM401_COUNT (0+XfOrM398_COUNT)
#   define SETUP_XfOrM401(x) SETUP_XfOrM398(x)

# 3042 "bc/src/list.c"
    v = FUNCCALL(SETUP_XfOrM401(_), scheme_chaperone_hash_get_key (v , argv [1 ] ) ); 
  }

# 3043 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM398_COUNT)));
#   define XfOrM400_COUNT (1+XfOrM398_COUNT)
#   define SETUP_XfOrM400(x) SETUP(XfOrM400_COUNT)

# 3045 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM400(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3045 "bc/src/list.c"
    ; 
    v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM400(_), scheme_lookup_key_in_table (t , (char * ) argv [1 ] ) ); 
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM400(_), scheme_post_sema (t -> mutex ) )
# 3047 "bc/src/list.c"
    ; 
  }

# 3048 "bc/src/list.c"
  else {
#   define XfOrM399_COUNT (0+XfOrM398_COUNT)
#   define SETUP_XfOrM399(x) SETUP_XfOrM398(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-ref-key" , "hash?" , 0 , argc , argv ) )
# 3049 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (v )
    RET_VALUE_START (v ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(hash_failed ("hash-ref-key" , "hash does not contain key" , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3059 "bc/src/list.c"
static Scheme_Object * hash_table_remove_bang (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1)));
# define XfOrM404_COUNT (2)
# define SETUP_XfOrM404(x) SETUP(XfOrM404_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 3063 "bc/src/list.c"
  v = argv [0 ] ; 

  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) ) ) {
#   define XfOrM408_COUNT (0+XfOrM404_COUNT)
#   define SETUP_XfOrM408(x) SETUP_XfOrM404(x)
    FUNCCALL(SETUP_XfOrM408(_), scheme_chaperone_hash_set (v , argv [1 ] , ((void * ) 0 ) ) )
# 3067 "bc/src/list.c"
    ; 
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }

  if (! (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && (! (((Scheme_Inclhash_Object * ) (v ) ) -> so . keyex & 0x1 ) ) ) && ! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-remove!" , "(and/c hash? (not/c immutable?))" , 0 , argc , argv ) ); 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    Scheme_Bucket * b ; 
    Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM404_COUNT), PUSH(b, 1+XfOrM404_COUNT)));
#   define XfOrM406_COUNT (2+XfOrM404_COUNT)
#   define SETUP_XfOrM406(x) SETUP(XfOrM406_COUNT)
    b = NULLED_OUT ; 

# 3077 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM406(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3077 "bc/src/list.c"
    ; 
    b = FUNCCALL(SETUP_XfOrM406(_), scheme_bucket_or_null_from_table ((Scheme_Bucket_Table * ) v , (char * ) argv [1 ] , 0 ) ); 
    if (b ) {
      (((Scheme_Small_Object * ) (b -> key ) ) -> u . ptr_val ) = ((void * ) 0 ) ; 
      b -> val = ((void * ) 0 ) ; 
    }
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM406(_), scheme_post_sema (t -> mutex ) )
# 3083 "bc/src/list.c"
    ; 
  }

# 3084 "bc/src/list.c"
  else {
    Scheme_Hash_Table * t = (Scheme_Hash_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM404_COUNT)));
#   define XfOrM405_COUNT (1+XfOrM404_COUNT)
#   define SETUP_XfOrM405(x) SETUP(XfOrM405_COUNT)

# 3086 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM405(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3086 "bc/src/list.c"
    ; 
    FUNCCALL(SETUP_XfOrM405(_), scheme_hash_set (t , argv [1 ] , ((void * ) 0 ) ) ); 
    if (t -> mutex )
      FUNCCALL_EMPTY(scheme_post_sema (t -> mutex ) )
# 3088 "bc/src/list.c"
    ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3094 "bc/src/list.c"
static Scheme_Object * hash_table_remove (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3096 "bc/src/list.c"
  Scheme_Object * v = argv [0 ] ; 

  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) )
    return chaperone_hash_tree_set (v , argv [1 ] , ((void * ) 0 ) ) ; 

  if (! ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) )
    scheme_wrong_contract ("hash-remove" , "(and/c hash? immutable?)" , 0 , argc , argv ) ; 

  return (Scheme_Object * ) scheme_hash_tree_set ((Scheme_Hash_Tree * ) v , argv [1 ] , ((void * ) 0 ) ) ; 
}

static Scheme_Object * hash_table_clear_bang (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v , * v2 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(v2, 1)));
# define XfOrM410_COUNT (2)
# define SETUP_XfOrM410(x) SETUP(XfOrM410_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  v2 = NULLED_OUT ; 

# 3111 "bc/src/list.c"
  v = argv [0 ] ; 

  v2 = ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ? (((Scheme_Chaperone * ) v ) -> val ) : v ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (v2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v2 ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && (! (((Scheme_Inclhash_Object * ) (v2 ) ) -> so . keyex & 0x1 ) ) ) && ! ((Scheme_Type ) (((((intptr_t ) (v2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v2 ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-clear!" , "(and/c hash? (not/c immutable?))" , 0 , argc , argv ) ); 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
#   define XfOrM413_COUNT (0+XfOrM410_COUNT)
#   define SETUP_XfOrM413(x) SETUP_XfOrM410(x)

# 3119 "bc/src/list.c"
    if (FUNCCALL(SETUP_XfOrM413(_), chaperone_hash_clear ("hash-clear!" , v ) )) {


      v = v2 ; 
    }

# 3123 "bc/src/list.c"
    else {


      Scheme_Object * i , * a [2 ] , * key ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM413_COUNT), PUSH(key, 3+XfOrM413_COUNT), PUSH(i, 4+XfOrM413_COUNT)));
#     define XfOrM414_COUNT (5+XfOrM413_COUNT)
#     define SETUP_XfOrM414(x) SETUP(XfOrM414_COUNT)
      i = NULLED_OUT ; 
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      key = NULLED_OUT ; 

# 3127 "bc/src/list.c"
      a [0 ] = v ; 
      while (1 ) {
#       define XfOrM416_COUNT (0+XfOrM414_COUNT)
#       define SETUP_XfOrM416(x) SETUP_XfOrM414(x)

# 3129 "bc/src/list.c"
        i = FUNCCALL(SETUP_XfOrM416(_), scheme_hash_table_iterate_start (1 , a ) ); 
        if (((i ) ) == (scheme_false ) ) 
          break ; 

        a [1 ] = i ; 
        key = FUNCCALL(SETUP_XfOrM416(_), scheme_hash_table_iterate_key (2 , a ) ); 
        a [1 ] = key ; 
        FUNCCALL(SETUP_XfOrM416(_), hash_table_remove_bang (2 , a ) )
        ; 
      }

      RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
    }
  }

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM410_COUNT)));
#   define XfOrM412_COUNT (1+XfOrM410_COUNT)
#   define SETUP_XfOrM412(x) SETUP(XfOrM412_COUNT)

# 3146 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM412(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3146 "bc/src/list.c"
    ; 
    FUNCCALL(SETUP_XfOrM412(_), scheme_clear_bucket_table (t ) ); 
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM412(_), scheme_post_sema (t -> mutex ) )
# 3148 "bc/src/list.c"
    ; 
  }

# 3149 "bc/src/list.c"
  else {
    Scheme_Hash_Table * t = (Scheme_Hash_Table * ) v ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM410_COUNT)));
#   define XfOrM411_COUNT (1+XfOrM410_COUNT)
#   define SETUP_XfOrM411(x) SETUP(XfOrM411_COUNT)

# 3151 "bc/src/list.c"
    if (t -> mutex )
      FUNCCALL(SETUP_XfOrM411(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3151 "bc/src/list.c"
    ; 
    FUNCCALL(SETUP_XfOrM411(_), scheme_clear_hash_table (t ) ); 
    if (t -> mutex )
      FUNCCALL_EMPTY(scheme_post_sema (t -> mutex ) )
# 3153 "bc/src/list.c"
    ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3159 "bc/src/list.c"
static Scheme_Object * hash_table_clear (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v , * v2 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(v2, 1)));
# define XfOrM418_COUNT (2)
# define SETUP_XfOrM418(x) SETUP(XfOrM418_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  v2 = NULLED_OUT ; 

# 3163 "bc/src/list.c"
  v = argv [0 ] ; 

  v2 = ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ? (((Scheme_Chaperone * ) v ) -> val ) : v ) ; 

  if (! ((((((intptr_t ) (v2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v2 ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v2 ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-clear" , "(and/c hash? immutable?)" , 0 , argc , argv ) ); 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
#   define XfOrM420_COUNT (0+XfOrM418_COUNT)
#   define SETUP_XfOrM420(x) SETUP_XfOrM418(x)

# 3171 "bc/src/list.c"
    v2 = FUNCCALL(SETUP_XfOrM420(_), chaperone_hash_clear ("hash-clear" , v ) ); 
    if (v2 )
      RET_VALUE_START (v2 ) RET_VALUE_END ; 
    else {


      Scheme_Object * i , * a [2 ] , * key ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM420_COUNT), PUSH(key, 3+XfOrM420_COUNT), PUSH(i, 4+XfOrM420_COUNT)));
#     define XfOrM421_COUNT (5+XfOrM420_COUNT)
#     define SETUP_XfOrM421(x) SETUP(XfOrM421_COUNT)
      i = NULLED_OUT ; 
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      key = NULLED_OUT ; 

# 3178 "bc/src/list.c"
      while (1 ) {
#       define XfOrM423_COUNT (0+XfOrM421_COUNT)
#       define SETUP_XfOrM423(x) SETUP_XfOrM421(x)

# 3179 "bc/src/list.c"
        a [0 ] = v ; 
        i = FUNCCALL(SETUP_XfOrM423(_), scheme_hash_table_iterate_start (1 , a ) ); 
        if (((i ) ) == (scheme_false ) ) 
          RET_VALUE_START (v ) RET_VALUE_END ; 

        a [1 ] = i ; 
        key = FUNCCALL(SETUP_XfOrM423(_), scheme_hash_table_iterate_key (2 , a ) ); 
        a [1 ] = key ; 

        v = FUNCCALL(SETUP_XfOrM423(_), hash_table_remove_bang (2 , a ) ); 
      }
    }
  }

# 3191 "bc/src/list.c"
  else {
#   define XfOrM419_COUNT (0+XfOrM418_COUNT)
#   define SETUP_XfOrM419(x) SETUP_XfOrM418(x)

# 3192 "bc/src/list.c"
    RET_VALUE_START ((Scheme_Object * ) FUNCCALL_EMPTY(scheme_make_hash_tree_of_type ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) v ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) v ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3196 "bc/src/list.c"
static void no_post_key (const char * name , Scheme_Object * key , int chap ) 
{
  /* No conversion */

# 3198 "bc/src/list.c"
  scheme_contract_error (name , 
  (chap 
  ? "no value found for post-chaperone key" 
  : "no value found for post-impersonator key" ) , 
  "key" , 1 , key , 
  ((void * ) 0 ) ) ; 
}

static Scheme_Object * do_map_hash_table (int argc , 
Scheme_Object * argv [] , 
char * name , 
int keep , 
int try_sorted ) 
{
  int i ; 
  Scheme_Object * f , * * sorted_keys ; 
  Scheme_Object * first , * last = ((void * ) 0 ) , * v , * p [2 ] , * obj , * chaperone ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(15);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(chaperone, 1), PUSH(argv, 2), PUSH(obj, 3), PUSH(first, 4), PUSH(last, 5), PUSH(v, 6), PUSH(sorted_keys, 7), PUSHARRAY(p, 2, 8), PUSH(f, 11)));
# define XfOrM425_COUNT (12)
# define SETUP_XfOrM425(x) SETUP(XfOrM425_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  f = NULLED_OUT ; 
  sorted_keys = NULLED_OUT ; 
  first = NULLED_OUT ; 
  v = NULLED_OUT ; 
  p[0] = NULLED_OUT ; 
  p[1] = NULLED_OUT ; 
  obj = NULLED_OUT ; 
  chaperone = NULLED_OUT ; 

# 3216 "bc/src/list.c"
  obj = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    chaperone = obj ; 
    obj = (((Scheme_Chaperone * ) chaperone ) -> val ) ; 
  }

# 3220 "bc/src/list.c"
  else 
  chaperone = ((void * ) 0 ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) || ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) )
    FUNCCALL(SETUP_XfOrM425(_), scheme_wrong_contract (name , "hash?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM425(_), scheme_check_proc_arity (name , 2 , 1 , argc , argv ) ); 

  f = argv [1 ] ; 

  if (keep )
    first = scheme_null ; 
  else 
  first = scheme_void ; 



  if (try_sorted && ! chaperone && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) )
    sorted_keys = FUNCCALL(SETUP_XfOrM425(_), scheme_extract_sorted_keys (obj ) ); 
  else 
  sorted_keys = ((void * ) 0 ) ; 

  if (sorted_keys ) {
#   define XfOrM461_COUNT (0+XfOrM425_COUNT)
#   define SETUP_XfOrM461(x) SETUP_XfOrM425(x)

# 3242 "bc/src/list.c"
    if (sorted_keys ) {
      int i , count ; 
#     define XfOrM462_COUNT (0+XfOrM461_COUNT)
#     define SETUP_XfOrM462(x) SETUP_XfOrM461(x)

# 3244 "bc/src/list.c"
      count = (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ? ((Scheme_Hash_Table * ) obj ) -> count : ((Scheme_Hash_Tree * ) obj ) -> count ) ; 
      for (i = 0 ; i < count ; i ++ ) {
#       define XfOrM466_COUNT (0+XfOrM462_COUNT)
#       define SETUP_XfOrM466(x) SETUP_XfOrM462(x)

# 3246 "bc/src/list.c"
        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
          v = FUNCCALL(SETUP_XfOrM466(_), scheme_hash_get ((Scheme_Hash_Table * ) obj , sorted_keys [i ] ) ); 
        else 
        v = FUNCCALL(SETUP_XfOrM466(_), scheme_hash_tree_get ((Scheme_Hash_Tree * ) obj , sorted_keys [i ] ) ); 
        if (v ) {
#         define XfOrM467_COUNT (0+XfOrM466_COUNT)
#         define SETUP_XfOrM467(x) SETUP_XfOrM466(x)

# 3251 "bc/src/list.c"
          p [0 ] = sorted_keys [i ] ; 
          p [1 ] = v ; 
          v = FUNCCALL(SETUP_XfOrM467(_), scheme_do_eval (f , 2 , p , 1 ) ); 
          if (keep ) {
#           define XfOrM468_COUNT (0+XfOrM467_COUNT)
#           define SETUP_XfOrM468(x) SETUP_XfOrM467(x)

# 3255 "bc/src/list.c"
            v = FUNCCALL(SETUP_XfOrM468(_), scheme_make_list_pair (v , scheme_null ) ); 
            if (last )
              (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
            else 
            first = v ; 
            last = v ; 
          }
        }
      }
    }
  }

# 3265 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    Scheme_Bucket_Table * hash ; 
    Scheme_Bucket * bucket ; 
    BLOCK_SETUP((PUSH(hash, 0+XfOrM425_COUNT), PUSH(bucket, 1+XfOrM425_COUNT)));
#   define XfOrM448_COUNT (2+XfOrM425_COUNT)
#   define SETUP_XfOrM448(x) SETUP(XfOrM448_COUNT)
    hash = NULLED_OUT ; 
    bucket = NULLED_OUT ; 

# 3269 "bc/src/list.c"
    hash = (Scheme_Bucket_Table * ) obj ; 

    for (i = hash -> size ; i -- ; ) {
#     define XfOrM455_COUNT (0+XfOrM448_COUNT)
#     define SETUP_XfOrM455(x) SETUP_XfOrM448(x)

# 3272 "bc/src/list.c"
      bucket = hash -> buckets [i ] ; 
      if (bucket && bucket -> val && bucket -> key ) {
#       define XfOrM456_COUNT (0+XfOrM455_COUNT)
#       define SETUP_XfOrM456(x) SETUP_XfOrM455(x)

# 3274 "bc/src/list.c"
        if (hash -> weak )
          p [0 ] = (Scheme_Object * ) (((Scheme_Small_Object * ) (bucket -> key ) ) -> u . ptr_val ) ; 
        else 
        p [0 ] = (Scheme_Object * ) bucket -> key ; 
        if (chaperone ) {
#         define XfOrM460_COUNT (0+XfOrM456_COUNT)
#         define SETUP_XfOrM460(x) SETUP_XfOrM456(x)

# 3279 "bc/src/list.c"
          v = FUNCCALL(SETUP_XfOrM460(_), chaperone_hash_key (name , chaperone , p [0 ] ) ); 
          p [0 ] = v ; 
          v = FUNCCALL(SETUP_XfOrM460(_), scheme_chaperone_hash_get (chaperone , v ) ); 
          if (! v )
            FUNCCALL(SETUP_XfOrM460(_), no_post_key (name , p [0 ] , 0 ) ); 
        }

# 3284 "bc/src/list.c"
        else {
#         define XfOrM459_COUNT (0+XfOrM456_COUNT)
#         define SETUP_XfOrM459(x) SETUP_XfOrM456(x)

# 3285 "bc/src/list.c"
          v = (Scheme_Object * ) bucket -> val ; 
          if (hash -> weak == 3 )
            v = (scheme_ephemeron_value (v ) ) ; 
        }
        if (v ) {
#         define XfOrM457_COUNT (0+XfOrM456_COUNT)
#         define SETUP_XfOrM457(x) SETUP_XfOrM456(x)

# 3290 "bc/src/list.c"
          p [1 ] = v ; 
          if (keep ) {
#           define XfOrM458_COUNT (0+XfOrM457_COUNT)
#           define SETUP_XfOrM458(x) SETUP_XfOrM457(x)

# 3292 "bc/src/list.c"
            v = FUNCCALL(SETUP_XfOrM458(_), scheme_do_eval (f , 2 , p , 1 ) ); 
            v = FUNCCALL(SETUP_XfOrM458(_), scheme_make_list_pair (v , scheme_null ) ); 
            if (last )
              (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
            else 
            first = v ; 
            last = v ; 
          }

# 3299 "bc/src/list.c"
          else FUNCCALL(SETUP_XfOrM457(_), scheme_do_eval (f , 2 , p , - 1 ) )
          ; 
        }

        if (i > hash -> size )

# 3303 "bc/src/list.c"
        i = hash -> size ; 
      }
    }
  }

# 3306 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    Scheme_Hash_Table * hash ; 
    BLOCK_SETUP((PUSH(hash, 0+XfOrM425_COUNT)));
#   define XfOrM435_COUNT (1+XfOrM425_COUNT)
#   define SETUP_XfOrM435(x) SETUP(XfOrM435_COUNT)
    hash = NULLED_OUT ; 

# 3309 "bc/src/list.c"
    hash = (Scheme_Hash_Table * ) obj ; 

    for (i = hash -> size ; i -- ; ) {
#     define XfOrM442_COUNT (0+XfOrM435_COUNT)
#     define SETUP_XfOrM442(x) SETUP_XfOrM435(x)

# 3312 "bc/src/list.c"
      if (hash -> vals [i ] ) {
#       define XfOrM443_COUNT (0+XfOrM442_COUNT)
#       define SETUP_XfOrM443(x) SETUP_XfOrM442(x)

# 3313 "bc/src/list.c"
        p [0 ] = hash -> keys [i ] ; 
        if (chaperone ) {
#         define XfOrM447_COUNT (0+XfOrM443_COUNT)
#         define SETUP_XfOrM447(x) SETUP_XfOrM443(x)

# 3315 "bc/src/list.c"
          v = FUNCCALL(SETUP_XfOrM447(_), chaperone_hash_key (name , chaperone , p [0 ] ) ); 
          p [0 ] = v ; 
          v = FUNCCALL(SETUP_XfOrM447(_), scheme_chaperone_hash_get (chaperone , v ) ); 
          if (! v )
            FUNCCALL(SETUP_XfOrM447(_), no_post_key (name , p [0 ] , 0 ) ); 
        }

# 3320 "bc/src/list.c"
        else {
          v = hash -> vals [i ] ; 
        }
        if (v ) {
#         define XfOrM444_COUNT (0+XfOrM443_COUNT)
#         define SETUP_XfOrM444(x) SETUP_XfOrM443(x)

# 3324 "bc/src/list.c"
          p [1 ] = v ; 
          if (keep ) {
#           define XfOrM445_COUNT (0+XfOrM444_COUNT)
#           define SETUP_XfOrM445(x) SETUP_XfOrM444(x)

# 3326 "bc/src/list.c"
            v = FUNCCALL(SETUP_XfOrM445(_), scheme_do_eval (f , 2 , p , 1 ) ); 
            v = FUNCCALL(SETUP_XfOrM445(_), scheme_make_list_pair (v , scheme_null ) ); 
            if (last )
              (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
            else 
            first = v ; 
            last = v ; 
          }

# 3333 "bc/src/list.c"
          else FUNCCALL(SETUP_XfOrM444(_), scheme_do_eval (f , 2 , p , - 1 ) )
          ; 
        }

        if (i > hash -> size )

# 3337 "bc/src/list.c"
        i = hash -> size ; 
      }
    }
  }

# 3340 "bc/src/list.c"
  else {
    Scheme_Object * ik , * iv ; 
    Scheme_Hash_Tree * hash ; 
    mzlonglong pos ; 
    BLOCK_SETUP((PUSH(ik, 0+XfOrM425_COUNT), PUSH(hash, 1+XfOrM425_COUNT), PUSH(iv, 2+XfOrM425_COUNT)));
#   define XfOrM426_COUNT (3+XfOrM425_COUNT)
#   define SETUP_XfOrM426(x) SETUP(XfOrM426_COUNT)
    ik = NULLED_OUT ; 
    iv = NULLED_OUT ; 
    hash = NULLED_OUT ; 

# 3345 "bc/src/list.c"
    hash = (Scheme_Hash_Tree * ) obj ; 

    pos = (scheme_hash_tree_next (hash , - 1 ) ) ; 
    while (pos != - 1 ) {
#     define XfOrM431_COUNT (0+XfOrM426_COUNT)
#     define SETUP_XfOrM431(x) SETUP_XfOrM426(x)
      (
# 3349 "bc/src/list.c"
      scheme_hash_tree_index (hash , pos , & ik , & iv ) ) ; 
      p [0 ] = ik ; 
      if (chaperone ) {
#       define XfOrM434_COUNT (0+XfOrM431_COUNT)
#       define SETUP_XfOrM434(x) SETUP_XfOrM431(x)

# 3352 "bc/src/list.c"
        ik = FUNCCALL(SETUP_XfOrM434(_), chaperone_hash_key (name , chaperone , ik ) ); 
        iv = FUNCCALL(SETUP_XfOrM434(_), scheme_chaperone_hash_get (chaperone , ik ) ); 
        if (! iv )
          FUNCCALL(SETUP_XfOrM434(_), no_post_key (name , ik , 1 ) ); 
      }
      if (iv ) {
#       define XfOrM432_COUNT (0+XfOrM431_COUNT)
#       define SETUP_XfOrM432(x) SETUP_XfOrM431(x)

# 3358 "bc/src/list.c"
        p [1 ] = iv ; 
        if (keep ) {
#         define XfOrM433_COUNT (0+XfOrM432_COUNT)
#         define SETUP_XfOrM433(x) SETUP_XfOrM432(x)

# 3360 "bc/src/list.c"
          v = FUNCCALL(SETUP_XfOrM433(_), scheme_do_eval (f , 2 , p , 1 ) ); 
          v = FUNCCALL(SETUP_XfOrM433(_), scheme_make_list_pair (v , scheme_null ) ); 
          if (last )
            (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
          else 
          first = v ; 
          last = v ; 
        }

# 3367 "bc/src/list.c"
        else FUNCCALL(SETUP_XfOrM432(_), scheme_do_eval (f , 2 , p , - 1 ) )
        ; 
      }
      pos = (scheme_hash_tree_next (hash , pos ) ) ; 
    }
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3377 "bc/src/list.c"
static Scheme_Object * hash_table_map (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3379 "bc/src/list.c"
  return do_map_hash_table (argc , argv , "hash-map" , 1 , (argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) ; 
}

static Scheme_Object * hash_table_for_each (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3384 "bc/src/list.c"
  return do_map_hash_table (argc , argv , "hash-for-each" , 0 , (argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) ; 
}

static Scheme_Object * hash_table_next (const char * name , mzlonglong start , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3389 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    return scheme_hash_table_next ((Scheme_Hash_Table * ) o , start ) ; 
  }

# 3396 "bc/src/list.c"
  else if ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    return scheme_hash_tree_next_pos ((Scheme_Hash_Tree * ) o , start ) ; 
  }

# 3398 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    return scheme_bucket_table_next ((Scheme_Bucket_Table * ) o , start ) ; 
  }

# 3400 "bc/src/list.c"
  else {
    scheme_wrong_contract (name , "hash?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
}

Scheme_Object * scheme_hash_table_iterate_start (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3408 "bc/src/list.c"
  return hash_table_next ("hash-iterate-first" , - 1 , argc , argv ) ; 
}



Scheme_Object * scheme_hash_table_iterate_next (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * p = argv [1 ] , * v ; 
  mzlonglong pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(p, 1), PUSH(argv, 2)));
# define XfOrM478_COUNT (3)
# define SETUP_XfOrM478(x) SETUP(XfOrM478_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 3418 "bc/src/list.c"
  if (! (scheme_get_long_long_val (p , & pos ) ) )
    pos = ((mzlonglong ) 1 ) << 62 ; 
  else if (pos < 0 )
    pos = ((mzlonglong ) 1 ) << 62 ; 

  v = FUNCCALL(SETUP_XfOrM478(_), hash_table_next ("hash-iterate-next" , pos , argc , argv ) ); 

  if (v )

# 3425 "bc/src/list.c"
  RET_VALUE_START (v ) RET_VALUE_END ; 

  if (((intptr_t ) (p ) ) & 0x1 )  {
    if ((((intptr_t ) (p ) ) >> 1 ) >= 0 )
      p = ((void * ) 0 ) ; 
  }

# 3430 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
    if ((& ((Scheme_Bignum * ) p ) -> iso ) -> so . keyex & 0x1 ) 
      p = ((void * ) 0 ) ; 
  }

  if (p )
    FUNCCALL_EMPTY(scheme_wrong_contract ("hash-iterate-next" , "exact-nonnegative-integer?" , 1 , argc , argv ) )
  ; 

  if (0 ) {
#   define XfOrM479_COUNT (0+XfOrM478_COUNT)
#   define SETUP_XfOrM479(x) SETUP_XfOrM478(x)
    FUNCCALL_EMPTY(scheme_contract_error ("hash-iterate-next" , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 3444 "bc/src/list.c"
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3448 "bc/src/list.c"
static int hash_table_index (const char * name , int argc , Scheme_Object * argv [] , 
Scheme_Object * * _k , Scheme_Object * * _v , 
Scheme_Object * bad_index_v ) 
{
  /* No conversion */

# 3452 "bc/src/list.c"
  Scheme_Object * p = argv [1 ] , * obj = argv [0 ] ; 
  mzlonglong pos ; 
  int res ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 

  if (! scheme_get_long_long_val (p , & pos ) || (pos < 0 ) )
    pos = ((mzlonglong ) 1 ) << 62 ; 

  if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    res = scheme_hash_table_index ((Scheme_Hash_Table * ) obj , pos , _k , _v ) ; 
  }

# 3464 "bc/src/list.c"
  else if ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    res = scheme_hash_tree_index ((Scheme_Hash_Tree * ) obj , pos , _k , _v ) ; 
  }

# 3466 "bc/src/list.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) )  {
    res = scheme_bucket_table_index ((Scheme_Bucket_Table * ) obj , pos , _k , _v ) ; 
  }

# 3468 "bc/src/list.c"
  else {
    scheme_wrong_contract (name , "hash?" , 0 , argc , argv ) ; 
    return 0 ; 
  }

  if (res )

# 3473 "bc/src/list.c"
  return 1 ; 

  if (((((intptr_t ) (p ) ) & 0x1 ) 
  && ((((intptr_t ) (p ) ) >> 1 ) >= 0 ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
  && ((& ((Scheme_Bignum * ) p ) -> iso ) -> so . keyex & 0x1 ) ) ) {
    if (bad_index_v ) {
      if (_k )

# 3480 "bc/src/list.c"
      * _k = bad_index_v ; 
      if (_v )

# 3481 "bc/src/list.c"
      * _v = bad_index_v ; 
      return 0 ; 
    }

# 3483 "bc/src/list.c"
    else {
      scheme_contract_error (name , "no element at index" , 
      "index" , 1 , p , 
      ((void * ) 0 ) ) ; 
      return 0 ; 
    }
  }

  scheme_wrong_contract (name , "exact-nonnegative-integer?" , 1 , argc , argv ) ; 
  return 0 ; 
}

Scheme_Object * scheme_hash_table_iterate_key (int argc , Scheme_Object * argv [] ) 
{
  const char * name = "hash-iterate-key" ; 
  Scheme_Object * key ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(argv, 1), PUSH(name, 2)));
# define XfOrM490_COUNT (3)
# define SETUP_XfOrM490(x) SETUP(XfOrM490_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  key = NULLED_OUT ; 

# 3499 "bc/src/list.c"
  if (FUNCCALL(SETUP_XfOrM490(_), hash_table_index (name , argc , argv , & key , ((void * ) 0 ) , ((argc > 2 ) ? argv [2 ] : ((void * ) 0 ) ) ) )) {
    Scheme_Object * obj = argv [0 ] ; 
#   define XfOrM491_COUNT (0+XfOrM490_COUNT)
#   define SETUP_XfOrM491(x) SETUP_XfOrM490(x)

# 3501 "bc/src/list.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM491(_), chaperone_hash_key (name , obj , key ) )) RET_VALUE_END ; 
  }
  RET_VALUE_START (key ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3507 "bc/src/list.c"
Scheme_Object * scheme_hash_table_iterate_value (int argc , Scheme_Object * argv [] ) 
{
  const char * name = "hash-iterate-value" ; 
  Scheme_Object * key , * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(name, 3)));
# define XfOrM492_COUNT (4)
# define SETUP_XfOrM492(x) SETUP(XfOrM492_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 3511 "bc/src/list.c"
  if (FUNCCALL(SETUP_XfOrM492(_), hash_table_index (name , argc , argv , & key , & val , ((argc > 2 ) ? argv [2 ] : ((void * ) 0 ) ) ) )) {
    Scheme_Object * obj = argv [0 ] ; 
#   define XfOrM493_COUNT (0+XfOrM492_COUNT)
#   define SETUP_XfOrM493(x) SETUP_XfOrM492(x)

# 3513 "bc/src/list.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
      Scheme_Object * chap_key , * chap_val ; 
      int ischap = ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ; 
      BLOCK_SETUP((PUSH(chap_key, 0+XfOrM493_COUNT), PUSH(chap_val, 1+XfOrM493_COUNT)));
#     define XfOrM494_COUNT (2+XfOrM493_COUNT)
#     define SETUP_XfOrM494(x) SETUP(XfOrM494_COUNT)
      chap_key = NULLED_OUT ; 
      chap_val = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM494(_), chaperone_hash_key_value (name , obj , key , & chap_key , & chap_val , ischap ) )
# 3516 "bc/src/list.c"
      ; 
      RET_VALUE_START (chap_val ) RET_VALUE_END ; 
    }
  }
  RET_VALUE_START (val ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3523 "bc/src/list.c"
Scheme_Object * scheme_hash_table_iterate_pair (int argc , Scheme_Object * argv [] ) 
{
  const char * name = "hash-iterate-pair" ; 
  Scheme_Object * key , * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(name, 3)));
# define XfOrM495_COUNT (4)
# define SETUP_XfOrM495(x) SETUP(XfOrM495_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 3527 "bc/src/list.c"
  if (FUNCCALL(SETUP_XfOrM495(_), hash_table_index (name , argc , argv , & key , & val , ((argc > 2 ) ? argv [2 ] : ((void * ) 0 ) ) ) )) {
    Scheme_Object * obj = argv [0 ] ; 
#   define XfOrM496_COUNT (0+XfOrM495_COUNT)
#   define SETUP_XfOrM496(x) SETUP_XfOrM495(x)

# 3529 "bc/src/list.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
      Scheme_Object * chap_key , * chap_val ; 
      int ischap = ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ; 
      BLOCK_SETUP((PUSH(chap_key, 0+XfOrM496_COUNT), PUSH(chap_val, 1+XfOrM496_COUNT)));
#     define XfOrM497_COUNT (2+XfOrM496_COUNT)
#     define SETUP_XfOrM497(x) SETUP(XfOrM497_COUNT)
      chap_key = NULLED_OUT ; 
      chap_val = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM497(_), chaperone_hash_key_value (name , obj , key , & chap_key , & chap_val , ischap ) )
# 3532 "bc/src/list.c"
      ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM497(_), scheme_make_pair (chap_key , chap_val ) )) RET_VALUE_END ; 
    }
  }
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM495(_), scheme_make_pair (key , val ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3539 "bc/src/list.c"
Scheme_Object * scheme_hash_table_iterate_key_value (int argc , Scheme_Object * argv [] ) 
{
  const char * name = "hash-iterate-key+value" ; 
  Scheme_Object * key , * val , * res [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSHARRAY(res, 2, 1), PUSH(val, 4), PUSH(argv, 5), PUSH(name, 6)));
# define XfOrM498_COUNT (7)
# define SETUP_XfOrM498(x) SETUP(XfOrM498_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 
  res[0] = NULLED_OUT ; 
  res[1] = NULLED_OUT ; 

# 3543 "bc/src/list.c"
  if (FUNCCALL(SETUP_XfOrM498(_), hash_table_index (name , argc , argv , & key , & val , ((argc > 2 ) ? argv [2 ] : ((void * ) 0 ) ) ) )) {
    Scheme_Object * obj = argv [0 ] ; 
#   define XfOrM499_COUNT (0+XfOrM498_COUNT)
#   define SETUP_XfOrM499(x) SETUP_XfOrM498(x)

# 3545 "bc/src/list.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
      int ischap = ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ; 
#     define XfOrM500_COUNT (0+XfOrM499_COUNT)
#     define SETUP_XfOrM500(x) SETUP_XfOrM499(x)
      FUNCCALL(SETUP_XfOrM500(_), chaperone_hash_key_value (name , obj , key , & key , & val , ischap ) )
# 3547 "bc/src/list.c"
      ; 
    }
  }
  res [0 ] = key ; 
  res [1 ] = val ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM498(_), scheme_values (2 , res ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3555 "bc/src/list.c"
static Scheme_Object * hash_keys_subset_p_slow (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * b [2 ] , * i1 , * c2 ; 
  int kind1 , kind2 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(i1, 0), PUSHARRAY(b, 2, 1), PUSH(c2, 4), PUSH(argv, 5)));
# define XfOrM501_COUNT (6)
# define SETUP_XfOrM501(x) SETUP(XfOrM501_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b[0] = NULLED_OUT ; 
  b[1] = NULLED_OUT ; 
  i1 = NULLED_OUT ; 
  c2 = NULLED_OUT ; 

# 3560 "bc/src/list.c"
  if (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) {
#   define XfOrM505_COUNT (0+XfOrM501_COUNT)
#   define SETUP_XfOrM505(x) SETUP_XfOrM501(x)

# 3561 "bc/src/list.c"
    if ((Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) argv [0 ] ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) argv [0 ] ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) argv [1 ] ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) argv [1 ] ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) ) ) 
      RET_VALUE_START ((FUNCCALL(SETUP_XfOrM505(_), scheme_hash_tree_subset_of ((Scheme_Hash_Tree * ) argv [0 ] , (Scheme_Hash_Tree * ) argv [1 ] ) )
    ? scheme_true 
    : scheme_false ) ) 
# 3562 "bc/src/list.c"
    RET_VALUE_END 

    ; 
  }

  b [0 ] = argv [1 ] ; 
  if (! (! (((FUNCCALL(SETUP_XfOrM501(_), hash_p (1 , argv ) )) ) == (scheme_false ) ) ) )
    FUNCCALL(SETUP_XfOrM501(_), scheme_wrong_contract ("hash-keys-subset?" , "hash?" , 0 , argc , argv ) ); 
  if (! (! (((FUNCCALL(SETUP_XfOrM501(_), hash_p (1 , b ) )) ) == (scheme_false ) ) ) )
    FUNCCALL(SETUP_XfOrM501(_), scheme_wrong_contract ("hash-keys-subset?" , "hash?" , 1 , argc , argv ) ); 

  if (! (((FUNCCALL(SETUP_XfOrM501(_), scheme_hash_eq_p (1 , argv ) )) ) == (scheme_false ) ) ) 
    kind1 = 0 ; 
  else if (! (((FUNCCALL(SETUP_XfOrM501(_), scheme_hash_equal_p (1 , argv ) )) ) == (scheme_false ) ) ) 
    kind1 = 1 ; 
  else if (! (((FUNCCALL(SETUP_XfOrM501(_), scheme_hash_eqv_p (1 , argv ) )) ) == (scheme_false ) ) ) 
    kind1 = 2 ; 
  else 
  kind1 = 3 ; 

  if (! (((FUNCCALL(SETUP_XfOrM501(_), scheme_hash_eq_p (1 , b ) )) ) == (scheme_false ) ) ) 
    kind2 = 0 ; 
  else if (! (((FUNCCALL(SETUP_XfOrM501(_), scheme_hash_equal_p (1 , b ) )) ) == (scheme_false ) ) ) 
    kind2 = 1 ; 
  else if (! (((FUNCCALL(SETUP_XfOrM501(_), scheme_hash_eqv_p (1 , b ) )) ) == (scheme_false ) ) ) 
    kind2 = 2 ; 
  else 
  kind2 = 3 ; 

  if (kind1 != kind2 ) {
#   define XfOrM504_COUNT (0+XfOrM501_COUNT)
#   define SETUP_XfOrM504(x) SETUP_XfOrM501(x)
    FUNCCALL(SETUP_XfOrM504(_), scheme_contract_error ("hash-keys-subset?" , "given hash tables do not use the same key comparison" , "first table" , 1 , argv [0 ] , "second table" , 1 , argv [1 ] , ((void * ) 0 ) ) )

    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  i1 = FUNCCALL(SETUP_XfOrM501(_), scheme_checked_hash_count (1 , argv ) ); 
  c2 = FUNCCALL(SETUP_XfOrM501(_), scheme_checked_hash_count (1 , b ) ); 
  if ((((intptr_t ) (i1 ) ) >> 1 ) > (((intptr_t ) (c2 ) ) >> 1 ) )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  i1 = FUNCCALL(SETUP_XfOrM501(_), scheme_hash_table_iterate_start (1 , argv ) ); 
  b [0 ] = argv [0 ] ; 
  while (! (((i1 ) ) == (scheme_false ) ) ) {
#   define XfOrM503_COUNT (0+XfOrM501_COUNT)
#   define SETUP_XfOrM503(x) SETUP_XfOrM501(x)

# 3608 "bc/src/list.c"
    b [1 ] = i1 ; 
    c2 = FUNCCALL(SETUP_XfOrM503(_), scheme_hash_table_iterate_key (2 , b ) ); 

    if (! FUNCCALL(SETUP_XfOrM503(_), scheme_chaperone_hash_get (argv [1 ] , c2 ) ))
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

    i1 = FUNCCALL(SETUP_XfOrM503(_), scheme_hash_table_iterate_next (2 , b ) ); 
  }

  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3620 "bc/src/list.c"
static Scheme_Object * hash_keys_subset_p (int argc , Scheme_Object * argv [] ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 3622 "bc/src/list.c"
  if (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
  && ((((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
  && ((Scheme_Type ) (scheme_eq_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) argv [0 ] ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) argv [0 ] ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) ) 
  && ((Scheme_Type ) (scheme_eq_hash_tree_type ) == (Scheme_Type ) ((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) argv [1 ] ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) argv [1 ] ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) ) ) ) {
    if (scheme_eq_hash_tree_subset_of ((Scheme_Hash_Tree * ) argv [0 ] , (Scheme_Hash_Tree * ) argv [1 ] ) )
      return scheme_true ; 
    else 
    return scheme_false ; 
  }

# 3630 "bc/src/list.c"
  else 
  return hash_keys_subset_p_slow (argc , argv ) ; 
}


static Scheme_Object * do_chaperone_hash (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects , * clear , * equal_key_wrap ; 
  Scheme_Object * props ; 
  int start_props = 5 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(clear, 0), PUSH(equal_key_wrap, 1), PUSH(props, 2), PUSH(px, 3), PUSH(val, 4), PUSH(argv, 5), PUSH(name, 6), PUSH(redirects, 7)));
# define XfOrM508_COUNT (8)
# define SETUP_XfOrM508(x) SETUP(XfOrM508_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  clear = NULLED_OUT ; 
  equal_key_wrap = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 3643 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
  && (is_impersonator || ! ((((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_bucket_table_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , is_impersonator ? "(and/c hash? (not/c immutable?))" : "hash?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM508(_), scheme_check_proc_arity (name , 2 , 1 , argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 3 , 2 , argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 2 , 3 , argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 2 , 4 , argc , argv ) ); 

  if ((argc > 5 ) && ((((argv [5 ] ) ) == (scheme_false ) ) || (! (((intptr_t ) (argv [5 ] ) ) & 0x1 ) && ((((argv [5 ] ) -> type ) >= scheme_prim_type ) && (((argv [5 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) ) {
#   define XfOrM510_COUNT (0+XfOrM508_COUNT)
#   define SETUP_XfOrM510(x) SETUP_XfOrM508(x)
    FUNCCALL(SETUP_XfOrM510(_), scheme_check_proc_arity2 (name , 1 , 5 , argc , argv , 1 ) )
# 3656 "bc/src/list.c"
    ; 
    clear = argv [5 ] ; 
    start_props ++ ; 
  }

# 3659 "bc/src/list.c"
  else 
  clear = scheme_false ; 

  if ((argc > 6 ) && ((((argv [6 ] ) ) == (scheme_false ) ) || (! (((intptr_t ) (argv [6 ] ) ) & 0x1 ) && ((((argv [6 ] ) -> type ) >= scheme_prim_type ) && (((argv [6 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) ) {
#   define XfOrM509_COUNT (0+XfOrM508_COUNT)
#   define SETUP_XfOrM509(x) SETUP_XfOrM508(x)
    FUNCCALL(SETUP_XfOrM509(_), scheme_check_proc_arity2 (name , 2 , 6 , argc , argv , 1 ) )
# 3663 "bc/src/list.c"
    ; 
    equal_key_wrap = argv [6 ] ; 
    start_props ++ ; 
  }

# 3666 "bc/src/list.c"
  else 
  equal_key_wrap = scheme_false ; 




  redirects = FUNCCALL(SETUP_XfOrM508(_), scheme_make_vector (6 , ((void * ) 0 ) ) ); 
  (((Scheme_Vector * ) (redirects ) ) -> els ) [0 ] = argv [1 ] ; 
  (((Scheme_Vector * ) (redirects ) ) -> els ) [1 ] = argv [2 ] ; 
  (((Scheme_Vector * ) (redirects ) ) -> els ) [2 ] = argv [3 ] ; 
  (((Scheme_Vector * ) (redirects ) ) -> els ) [3 ] = argv [4 ] ; 
  (((Scheme_Vector * ) (redirects ) ) -> els ) [4 ] = clear ; 
  (((Scheme_Vector * ) (redirects ) ) -> els ) [5 ] = equal_key_wrap ; 
  redirects = FUNCCALL(SETUP_XfOrM508(_), scheme_box (redirects ) ); 

  props = FUNCCALL_AGAIN(scheme_parse_chaperone_props (name , start_props , argc , argv ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM508(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3696 "bc/src/list.c"
static Scheme_Object * chaperone_hash (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3698 "bc/src/list.c"
  return do_chaperone_hash ("chaperone-hash" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_hash (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3703 "bc/src/list.c"
  return do_chaperone_hash ("impersonate-hash" , 1 , argc , argv ) ; 
}

static Scheme_Object * transfer_chaperone (Scheme_Object * chaperone , Scheme_Object * v ) 
{
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(px, 1), PUSH(chaperone, 2)));
# define XfOrM513_COUNT (3)
# define SETUP_XfOrM513(x) SETUP(XfOrM513_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 

# 3710 "bc/src/list.c"
  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM513(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (px , chaperone , sizeof (Scheme_Chaperone ) ) ) ; 
  px -> prev = v ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    px -> val = (((Scheme_Chaperone * ) v ) -> val ) ; 
  else 
  px -> val = v ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3721 "bc/src/list.c"
static Scheme_Object * chaperone_hash_op (const char * who , Scheme_Object * o , Scheme_Object * k , 
Scheme_Object * v , int mode , Scheme_Object * key_wraps ) ; 

static Scheme_Object * chaperone_hash_op_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * k = (Scheme_Object * ) p -> ku . k . p2 ; 
  Scheme_Object * v = (Scheme_Object * ) p -> ku . k . p3 ; 
  const char * who = (const char * ) p -> ku . k . p4 ; 
  Scheme_Object * key_wraps = (Scheme_Object * ) p -> ku . k . p5 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM514_COUNT (1)
# define SETUP_XfOrM514(x) SETUP(XfOrM514_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3733 "bc/src/list.c"
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 

  o = FUNCCALL(SETUP_XfOrM514(_), chaperone_hash_op (who , o , k , v , p -> ku . k . i1 , key_wraps ) ); 

  if (! o )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_box (o ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3747 "bc/src/list.c"
static Scheme_Object * chaperone_hash_op_overflow (const char * who , Scheme_Object * o , Scheme_Object * k , 
Scheme_Object * v , int mode , Scheme_Object * key_wraps ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM515_COUNT (1)
# define SETUP_XfOrM515(x) SETUP(XfOrM515_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3752 "bc/src/list.c"
  p -> ku . k . p1 = (void * ) o ; 
  p -> ku . k . p2 = (void * ) k ; 
  p -> ku . k . p3 = (void * ) v ; 
  p -> ku . k . p4 = (void * ) who ; 
  p -> ku . k . i1 = mode ; 
  p -> ku . k . p5 = (void * ) key_wraps ; 

  o = FUNCCALL(SETUP_XfOrM515(_), scheme_handle_stack_overflow (chaperone_hash_op_k ) ); 

  if (((o ) ) == (scheme_false ) ) 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  else 
  RET_VALUE_START ((((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3767 "bc/src/list.c"
static Scheme_Object * chaperone_hash_op (const char * who , Scheme_Object * o , Scheme_Object * k , 
Scheme_Object * v , int mode , Scheme_Object * key_wraps ) 
{
  Scheme_Object * wraps = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(15);
  BLOCK_SETUP_TOP((PUSH(wraps, 0), PUSH(k, 1), PUSH(v, 2), PUSH(o, 3), PUSH(who, 4), PUSH(key_wraps, 5)));
# define XfOrM516_COUNT (6)
# define SETUP_XfOrM516(x) SETUP(XfOrM516_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3772 "bc/src/list.c"
  while (1 ) {
#   define XfOrM548_COUNT (0+XfOrM516_COUNT)
#   define SETUP_XfOrM548(x) SETUP_XfOrM516(x)

# 3773 "bc/src/list.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#     define XfOrM563_COUNT (0+XfOrM548_COUNT)
#     define SETUP_XfOrM563(x) SETUP_XfOrM548(x)

# 3774 "bc/src/list.c"
      if ((key_wraps ) == (scheme_null ) ) 
        key_wraps = ((void * ) 0 ) ; 
      else 
      key_wraps = FUNCCALL(SETUP_XfOrM563(_), scheme_make_raw_pair ((Scheme_Object * ) who , key_wraps ) ); 
      if (mode == 0 || mode == 5 ) {

        Scheme_Object * interned_key = ((void * ) 0 ) ; 
        BLOCK_SETUP((PUSH(interned_key, 0+XfOrM563_COUNT)));
#       define XfOrM576_COUNT (1+XfOrM563_COUNT)
#       define SETUP_XfOrM576(x) SETUP(XfOrM576_COUNT)

# 3781 "bc/src/list.c"
        if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
          Scheme_Hash_Table * t = (Scheme_Hash_Table * ) o ; 
          BLOCK_SETUP((PUSH(t, 0+XfOrM576_COUNT)));
#         define XfOrM578_COUNT (1+XfOrM576_COUNT)
#         define SETUP_XfOrM578(x) SETUP(XfOrM578_COUNT)

# 3783 "bc/src/list.c"
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM578(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3783 "bc/src/list.c"
          ; 
          v = FUNCCALL(SETUP_XfOrM578(_), scheme_hash_get_w_key_wraps (t , k , key_wraps , & interned_key ) ); 
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM578(_), scheme_post_sema (t -> mutex ) )
# 3785 "bc/src/list.c"
          ; 
        }

# 3786 "bc/src/list.c"
        else if ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
          v = FUNCCALL(SETUP_XfOrM576(_), scheme_hash_tree_get_w_key_wraps ((Scheme_Hash_Tree * ) o , k , key_wraps , & interned_key ) ); 
        else {
          Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) o ; 
          BLOCK_SETUP((PUSH(t, 0+XfOrM576_COUNT)));
#         define XfOrM577_COUNT (1+XfOrM576_COUNT)
#         define SETUP_XfOrM577(x) SETUP(XfOrM577_COUNT)

# 3790 "bc/src/list.c"
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM577(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3790 "bc/src/list.c"
          ; 
          v = FUNCCALL(SETUP_XfOrM577(_), scheme_lookup_in_table_w_key_wraps (t , (const char * ) k , key_wraps , & interned_key ) ); 
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM577(_), scheme_post_sema (t -> mutex ) )
# 3792 "bc/src/list.c"
          ; 
        }
        if (mode == 0 )
          RET_VALUE_START (v ) RET_VALUE_END ; 
        else 
        RET_VALUE_START (interned_key ) RET_VALUE_END ; 
      }

# 3798 "bc/src/list.c"
      else if ((mode == 1 ) || (mode == 2 ) ) {
#       define XfOrM568_COUNT (0+XfOrM563_COUNT)
#       define SETUP_XfOrM568(x) SETUP_XfOrM563(x)

# 3800 "bc/src/list.c"
        if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
          Scheme_Hash_Table * t = (Scheme_Hash_Table * ) o ; 
          BLOCK_SETUP((PUSH(t, 0+XfOrM568_COUNT)));
#         define XfOrM575_COUNT (1+XfOrM568_COUNT)
#         define SETUP_XfOrM575(x) SETUP(XfOrM575_COUNT)

# 3802 "bc/src/list.c"
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM575(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3802 "bc/src/list.c"
          ; 
          FUNCCALL(SETUP_XfOrM575(_), scheme_hash_set_w_key_wraps (t , k , v , key_wraps ) ); 
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM575(_), scheme_post_sema (t -> mutex ) )
# 3804 "bc/src/list.c"
          ; 
        }

# 3805 "bc/src/list.c"
        else if ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
#         define XfOrM572_COUNT (0+XfOrM568_COUNT)
#         define SETUP_XfOrM572(x) SETUP_XfOrM568(x)

# 3806 "bc/src/list.c"
          o = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM572(_), scheme_hash_tree_set_w_key_wraps ((Scheme_Hash_Tree * ) o , k , v , key_wraps ) ); 
          while (wraps ) {
#           define XfOrM574_COUNT (0+XfOrM572_COUNT)
#           define SETUP_XfOrM574(x) SETUP_XfOrM572(x)

# 3808 "bc/src/list.c"
            o = FUNCCALL(SETUP_XfOrM574(_), transfer_chaperone ((((Scheme_Simple_Object * ) (wraps ) ) -> u . pair_val . car ) , o ) ); 
            wraps = (((Scheme_Simple_Object * ) (wraps ) ) -> u . pair_val . cdr ) ; 
          }
          RET_VALUE_START (o ) RET_VALUE_END ; 
        }

# 3812 "bc/src/list.c"
        else if (! v ) {
          Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) o ; 
          Scheme_Bucket * b ; 
          BLOCK_SETUP((PUSH(t, 0+XfOrM568_COUNT), PUSH(b, 1+XfOrM568_COUNT)));
#         define XfOrM570_COUNT (2+XfOrM568_COUNT)
#         define SETUP_XfOrM570(x) SETUP(XfOrM570_COUNT)
          b = NULLED_OUT ; 

# 3815 "bc/src/list.c"
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM570(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3815 "bc/src/list.c"
          ; 
          b = FUNCCALL(SETUP_XfOrM570(_), scheme_bucket_or_null_from_table_w_key_wraps (t , (char * ) k , 0 , key_wraps ) ); 
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM570(_), scheme_post_sema (t -> mutex ) )
# 3817 "bc/src/list.c"
          ; 
          if (b ) {
            (((Scheme_Small_Object * ) (b -> key ) ) -> u . ptr_val ) = ((void * ) 0 ) ; 
            b -> val = ((void * ) 0 ) ; 
          }
        }

# 3822 "bc/src/list.c"
        else {
          Scheme_Bucket_Table * t = (Scheme_Bucket_Table * ) o ; 
          BLOCK_SETUP((PUSH(t, 0+XfOrM568_COUNT)));
#         define XfOrM569_COUNT (1+XfOrM568_COUNT)
#         define SETUP_XfOrM569(x) SETUP(XfOrM569_COUNT)

# 3824 "bc/src/list.c"
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM569(_), scheme_wait_sema (t -> mutex , 0 ) )
# 3824 "bc/src/list.c"
          ; 
          FUNCCALL(SETUP_XfOrM569(_), scheme_add_to_table_w_key_wraps (t , (const char * ) k , v , 0 , key_wraps ) ); 
          if (t -> mutex )
            FUNCCALL(SETUP_XfOrM569(_), scheme_post_sema (t -> mutex ) )
# 3826 "bc/src/list.c"
          ; 
        }
        RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
      }

# 3829 "bc/src/list.c"
      else if (mode == 3 )
        RET_VALUE_START (k ) RET_VALUE_END ; 
      else {
#       define XfOrM564_COUNT (0+XfOrM563_COUNT)
#       define SETUP_XfOrM564(x) SETUP_XfOrM563(x)

# 3833 "bc/src/list.c"
        if ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
#         define XfOrM565_COUNT (0+XfOrM564_COUNT)
#         define SETUP_XfOrM565(x) SETUP_XfOrM564(x)

# 3834 "bc/src/list.c"
          o = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM565(_), scheme_make_hash_tree_of_type ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_tree_indirection_type ) ) ? ((((intptr_t ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Hash_Tree * ) o ) -> els [0 ] ) ) -> type ) : ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) ) ); 
          while (wraps ) {
#           define XfOrM567_COUNT (0+XfOrM565_COUNT)
#           define SETUP_XfOrM567(x) SETUP_XfOrM565(x)

# 3836 "bc/src/list.c"
            o = FUNCCALL(SETUP_XfOrM567(_), transfer_chaperone ((((Scheme_Simple_Object * ) (wraps ) ) -> u . pair_val . car ) , o ) ); 
            wraps = (((Scheme_Simple_Object * ) (wraps ) ) -> u . pair_val . cdr ) ; 
          }
          RET_VALUE_START (o ) RET_VALUE_END ; 
        }

# 3840 "bc/src/list.c"
        else 
        RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
      }
    }

# 3843 "bc/src/list.c"
    else {
      Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
      Scheme_Object * a [3 ] , * red , * orig ; 
      const char * what ; 
      BLOCK_SETUP((PUSHARRAY(a, 3, 0+XfOrM548_COUNT), PUSH(what, 3+XfOrM548_COUNT), PUSH(px, 4+XfOrM548_COUNT), PUSH(orig, 5+XfOrM548_COUNT), PUSH(red, 6+XfOrM548_COUNT)));
#     define XfOrM549_COUNT (7+XfOrM548_COUNT)
#     define SETUP_XfOrM549(x) SETUP(XfOrM549_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      a[2] = NULLED_OUT ; 
      red = NULLED_OUT ; 
      orig = NULLED_OUT ; 
      what = NULLED_OUT ; 

# 3849 "bc/src/list.c"
      {

# 24 "bc/src/mzstkchk.h"
        uintptr_t _stk_pos ; 
#       define XfOrM562_COUNT (0+XfOrM549_COUNT)
#       define SETUP_XfOrM562(x) SETUP_XfOrM549(x)

# 26 "bc/src/mzstkchk.h"
        _stk_pos = (uintptr_t ) & _stk_pos ; 

        if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
        && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 3851 "bc/src/list.c"
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM562(_), chaperone_hash_op_overflow (who , o , k , v , mode , key_wraps ) )) RET_VALUE_END ; 
      }


      if ((mode != 3 ) && (mode != 4 ) ) {
#       define XfOrM561_COUNT (0+XfOrM549_COUNT)
#       define SETUP_XfOrM561(x) SETUP_XfOrM549(x)

# 3856 "bc/src/list.c"
        red = (((Scheme_Small_Object * ) (px -> redirects ) ) -> u . ptr_val ) ; 
        red = (((Scheme_Vector * ) (red ) ) -> els ) [5 ] ; 
        if (! (((red ) ) == (scheme_false ) ) )
          key_wraps = FUNCCALL(SETUP_XfOrM561(_), scheme_make_pair ((Scheme_Object * ) px , key_wraps ) ); 
      }

      if (mode == 0 )
        orig = ((void * ) 0 ) ; 
      else if (mode == 3 ) {
#       define XfOrM560_COUNT (0+XfOrM549_COUNT)
#       define SETUP_XfOrM560(x) SETUP_XfOrM549(x)

# 3865 "bc/src/list.c"
        orig = FUNCCALL(SETUP_XfOrM560(_), chaperone_hash_op (who , px -> prev , k , v , mode , key_wraps ) ); 
        k = orig ; 
      }

# 3867 "bc/src/list.c"
      else if ((mode == 2 ) || (mode == 5 ) )
        orig = k ; 
      else if (mode == 4 )
        orig = scheme_void ; 
      else 
      orig = v ; 

      if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {

        o = orig ; 
      }

# 3877 "bc/src/list.c"
      else {
        int red_idx ; 
#       define XfOrM551_COUNT (0+XfOrM549_COUNT)
#       define SETUP_XfOrM551(x) SETUP_XfOrM549(x)

# 3880 "bc/src/list.c"
        red_idx = (mode == 5 ) ? 0 : mode ; 
        red = (((Scheme_Small_Object * ) (px -> redirects ) ) -> u . ptr_val ) ; 
        red = (((Scheme_Vector * ) (red ) ) -> els ) [red_idx ] ; 

        if ((mode == 4 ) && (((red ) ) == (scheme_false ) ) )
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

        a [0 ] = px -> prev ; 
        a [1 ] = k ; 
        a [2 ] = orig ; 

        if ((mode == 0 ) || (mode == 1 ) || (mode == 5 ) ) {

          Scheme_Object * * vals ; 
          int cnt ; 
          Scheme_Thread * p ; 
          BLOCK_SETUP((PUSH(p, 0+XfOrM551_COUNT), PUSH(vals, 1+XfOrM551_COUNT)));
#         define XfOrM554_COUNT (2+XfOrM551_COUNT)
#         define SETUP_XfOrM554(x) SETUP(XfOrM554_COUNT)
          vals = NULLED_OUT ; 
          p = NULLED_OUT ; 

# 3897 "bc/src/list.c"
          o = FUNCCALL(SETUP_XfOrM554(_), scheme_do_eval (red , ((red_idx == 0 ) ? 2 : 3 ) , a , - 1 ) ); 

          if ((o ) == (((Scheme_Object * ) 0x6 ) ) )  {
            p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
            cnt = p -> ku . multiple . count ; 
            vals = p -> ku . multiple . array ; 
            p -> ku . multiple . array = ((void * ) 0 ) ; 
            if ((vals ) == (p -> values_buffer ) ) 
              p -> values_buffer = ((void * ) 0 ) ; 
            p = ((void * ) 0 ) ; 
          }

# 3907 "bc/src/list.c"
          else {
            vals = ((void * ) 0 ) ; 
            cnt = 1 ; 
          }

          if (cnt != 2 )
            FUNCCALL(SETUP_XfOrM554(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "%s: chaperone did not return 2 values\n" "  chaperone procedure: %V\n" "  number of returned values: %d" , who , red , cnt ) )





          ; 

          if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
            if (! FUNCCALL(SETUP_XfOrM554(_), scheme_chaperone_of (vals [0 ] , k ) ))
            FUNCCALL(SETUP_XfOrM554(_), scheme_wrong_chaperoned (who , "key" , k , vals [0 ] ) ); 
          k = vals [0 ] ; 
          o = vals [1 ] ; 

          if (mode == 0 ) {
#           define XfOrM556_COUNT (0+XfOrM554_COUNT)
#           define SETUP_XfOrM556(x) SETUP_XfOrM554(x)

# 3929 "bc/src/list.c"
            red = o ; 
            if (! FUNCCALL(SETUP_XfOrM556(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 1 , 2 , vals ) ))
              FUNCCALL(SETUP_XfOrM556(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: chaperone produced a second value that does not match the expected contract\n" "  expected: (procedure-arity-includes/c 3)\n" "  received: %V" , who , red ) )




            ; 

            orig = FUNCCALL(SETUP_XfOrM556(_), chaperone_hash_op (who , px -> prev , k , v , mode , key_wraps ) ); 
            if (! orig )

# 3939 "bc/src/list.c"
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 


            a [0 ] = px -> prev ; 
            a [1 ] = k ; 
            a [2 ] = orig ; 
            o = FUNCCALL(SETUP_XfOrM556(_), scheme_do_eval (red , 3 , a , 1 ) ); 
            what = "result" ; 
          }

# 3947 "bc/src/list.c"
          else if (mode == 5 ) {
#           define XfOrM555_COUNT (0+XfOrM554_COUNT)
#           define SETUP_XfOrM555(x) SETUP_XfOrM554(x)

# 3949 "bc/src/list.c"
            orig = FUNCCALL(SETUP_XfOrM555(_), chaperone_hash_op (who , px -> prev , k , v , mode , key_wraps ) ); 
            if (! orig )

# 3950 "bc/src/list.c"
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

            red = (((Scheme_Small_Object * ) (px -> redirects ) ) -> u . ptr_val ) ; 
            red = (((Scheme_Vector * ) (red ) ) -> els ) [3 ] ; 

            a [0 ] = px -> prev ; 
            a [1 ] = orig ; 

            o = FUNCCALL(SETUP_XfOrM555(_), scheme_apply (red , 2 , a ) ); 
            what = "key" ; 
          }

# 3960 "bc/src/list.c"
          else 
          what = "value" ; 
        }

# 3962 "bc/src/list.c"
        else if (mode == 4 ) {
#         define XfOrM553_COUNT (0+XfOrM551_COUNT)
#         define SETUP_XfOrM553(x) SETUP_XfOrM551(x)

# 3964 "bc/src/list.c"
          (void ) FUNCCALL(SETUP_XfOrM553(_), scheme_do_eval (red , 1 , a , - 1 ) ); 
          o = scheme_void ; 
          what = "void" ; 
        }

# 3967 "bc/src/list.c"
        else {
#         define XfOrM552_COUNT (0+XfOrM551_COUNT)
#         define SETUP_XfOrM552(x) SETUP_XfOrM551(x)

# 3969 "bc/src/list.c"
          o = FUNCCALL(SETUP_XfOrM552(_), scheme_do_eval (red , 2 , a , 1 ) ); 
          what = "key" ; 
        }

        if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
          if (! FUNCCALL(SETUP_XfOrM551(_), scheme_chaperone_of (o , orig ) ))
          FUNCCALL(SETUP_XfOrM551(_), scheme_wrong_chaperoned (who , what , orig , o ) ); 
      }

      if ((mode == 0 ) || (mode == 3 ) || (mode == 5 ) )
        RET_VALUE_START (o ) RET_VALUE_END ; 
      else {
#       define XfOrM550_COUNT (0+XfOrM549_COUNT)
#       define SETUP_XfOrM550(x) SETUP_XfOrM549(x)

# 3981 "bc/src/list.c"
        if (mode == 1 )
          v = o ; 
        else 
        k = o ; 
        if ((((((intptr_t ) (px -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> val ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (px -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> val ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
          wraps = FUNCCALL(SETUP_XfOrM550(_), scheme_make_raw_pair ((Scheme_Object * ) px , wraps ) ); 
        o = px -> prev ; 
      }
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3993 "bc/src/list.c"
Scheme_Object * scheme_chaperone_hash_get (Scheme_Object * table , Scheme_Object * key ) 
{
  /* No conversion */

# 3995 "bc/src/list.c"
  return chaperone_hash_op ("hash-ref" , table , key , ((void * ) 0 ) , 0 , scheme_null ) ; 
}

Scheme_Object * scheme_chaperone_hash_get_key (Scheme_Object * table , Scheme_Object * key ) 
{
  /* No conversion */

# 4000 "bc/src/list.c"
  return chaperone_hash_op ("hash-ref-key" , table , key , ((void * ) 0 ) , 5 , scheme_null ) ; 
}

void scheme_chaperone_hash_set (Scheme_Object * table , Scheme_Object * key , Scheme_Object * val ) 
{
  /* No conversion */

# 4005 "bc/src/list.c"
  (void ) chaperone_hash_op (val ? "hash-set!" : "hash-remove!" , table , key , val , val ? 1 : 2 , scheme_null ) ; 
}

Scheme_Object * chaperone_hash_tree_set (Scheme_Object * table , Scheme_Object * key , Scheme_Object * val ) 
{
  /* No conversion */

# 4010 "bc/src/list.c"
  return chaperone_hash_op (val ? "hash-set" : "hash-remove" , table , key , val , val ? 1 : 2 , scheme_null ) ; 
}

static Scheme_Object * chaperone_hash_key (const char * name , Scheme_Object * table , Scheme_Object * key ) 
{
  /* No conversion */

# 4015 "bc/src/list.c"
  return chaperone_hash_op (name , table , key , ((void * ) 0 ) , 3 , scheme_null ) ; 
}

Scheme_Object * scheme_chaperone_hash_key (const char * name , Scheme_Object * table , Scheme_Object * key ) 
{
  /* No conversion */

# 4020 "bc/src/list.c"
  return chaperone_hash_key (name , table , key ) ; 
}

static void chaperone_hash_key_value (const char * name , Scheme_Object * obj , Scheme_Object * key , 
Scheme_Object * * _chap_key , Scheme_Object * * _chap_val , 
int ischap ) 
{
  Scheme_Object * chap_key , * chap_val ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(chap_key, 0), PUSH(name, 1), PUSH(_chap_key, 2), PUSH(_chap_val, 3), PUSH(chap_val, 4), PUSH(obj, 5)));
# define XfOrM585_COUNT (6)
# define SETUP_XfOrM585(x) SETUP(XfOrM585_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  chap_key = NULLED_OUT ; 
  chap_val = NULLED_OUT ; 

# 4028 "bc/src/list.c"
  chap_key = FUNCCALL(SETUP_XfOrM585(_), chaperone_hash_key (name , obj , key ) ); 
  chap_val = FUNCCALL_AGAIN(scheme_chaperone_hash_get (obj , chap_key ) ); 
  if (! chap_val )
    FUNCCALL(SETUP_XfOrM585(_), no_post_key (name , chap_key , ischap ) ); 
  * _chap_key = chap_key ; 
  * _chap_val = chap_val ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4036 "bc/src/list.c"
void scheme_chaperone_hash_key_value (const char * name , Scheme_Object * obj , Scheme_Object * k , 
Scheme_Object * * _chap_key , Scheme_Object * * _chap_val , 
int ischap ) 
{
  /* No conversion */

# 4040 "bc/src/list.c"
  return chaperone_hash_key_value (name , obj , k , _chap_key , _chap_val , ischap ) ; 
}

static Scheme_Object * chaperone_hash_clear (const char * name , Scheme_Object * table ) 
{
  /* No conversion */

# 4045 "bc/src/list.c"
  return chaperone_hash_op (name , table , ((void * ) 0 ) , ((void * ) 0 ) , 4 , scheme_null ) ; 
}

Scheme_Object * scheme_chaperone_hash_traversal_get (Scheme_Object * table , Scheme_Object * key , 
Scheme_Object * * alt_key ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(table, 1), PUSH(alt_key, 2)));
# define XfOrM588_COUNT (3)
# define SETUP_XfOrM588(x) SETUP(XfOrM588_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4051 "bc/src/list.c"
  key = FUNCCALL(SETUP_XfOrM588(_), chaperone_hash_key ("hash-table-iterate-key" , table , key ) ); 
  * alt_key = key ; 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(chaperone_hash_op ("hash-ref" , table , key , ((void * ) 0 ) , 0 , scheme_null ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4057 "bc/src/list.c"
Scheme_Object * scheme_chaperone_hash_table_filtered_copy (Scheme_Object * obj , 
Hash_Table_Element_Filter_Proc filter ) 
{
  Scheme_Object * a [3 ] , * v , * v2 , * idx , * key , * val ; 
  int is_eq , is_eqv , is_equal_always ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0), PUSH(val, 3), PUSH(obj, 4), PUSH(v, 5), PUSH(key, 6), PUSH(v2, 7), PUSH(idx, 8)));
# define XfOrM589_COUNT (9)
# define SETUP_XfOrM589(x) SETUP(XfOrM589_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  v = NULLED_OUT ; 
  v2 = NULLED_OUT ; 
  idx = NULLED_OUT ; 
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 4063 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) obj ) -> val ) ; 
  else 
  v = obj ; 

  a [0 ] = obj ; 
  is_eq = (! (((FUNCCALL(SETUP_XfOrM589(_), scheme_hash_eq_p (1 , a ) )) ) == (scheme_false ) ) ) ; 
  is_eqv = (! (((FUNCCALL(SETUP_XfOrM589(_), scheme_hash_eqv_p (1 , a ) )) ) == (scheme_false ) ) ) ; 
  is_equal_always = (! (((FUNCCALL(SETUP_XfOrM589(_), scheme_hash_equal_always_p (1 , a ) )) ) == (scheme_false ) ) ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
#   define XfOrM600_COUNT (0+XfOrM589_COUNT)
#   define SETUP_XfOrM600(x) SETUP_XfOrM589(x)

# 4074 "bc/src/list.c"
    if (is_eq )
      v2 = FUNCCALL(SETUP_XfOrM600(_), make_hasheq (0 , ((void * ) 0 ) ) ); 
    else if (is_eqv )
      v2 = FUNCCALL(SETUP_XfOrM600(_), make_hasheqv (0 , ((void * ) 0 ) ) ); 
    else 
    v2 = FUNCCALL(SETUP_XfOrM600(_), make_hash (0 , ((void * ) 0 ) ) ); 
  }

# 4080 "bc/src/list.c"
  else if ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
#   define XfOrM599_COUNT (0+XfOrM589_COUNT)
#   define SETUP_XfOrM599(x) SETUP_XfOrM589(x)

# 4081 "bc/src/list.c"
    if (is_eq )
      v2 = FUNCCALL(SETUP_XfOrM599(_), scheme_make_immutable_hasheq (0 , ((void * ) 0 ) ) ); 
    else if (is_eqv )
      v2 = FUNCCALL(SETUP_XfOrM599(_), scheme_make_immutable_hasheqv (0 , ((void * ) 0 ) ) ); 
    else if (is_equal_always )
      v2 = FUNCCALL(SETUP_XfOrM599(_), scheme_make_immutable_hashalw (0 , ((void * ) 0 ) ) ); 
    else 
    v2 = FUNCCALL(SETUP_XfOrM599(_), scheme_make_immutable_hash (0 , ((void * ) 0 ) ) ); 
  }

# 4089 "bc/src/list.c"
  else {
#   define XfOrM596_COUNT (0+XfOrM589_COUNT)
#   define SETUP_XfOrM596(x) SETUP_XfOrM589(x)

# 4090 "bc/src/list.c"
    if (((Scheme_Bucket_Table * ) v ) -> weak == 3 ) {
#     define XfOrM598_COUNT (0+XfOrM596_COUNT)
#     define SETUP_XfOrM598(x) SETUP_XfOrM596(x)

# 4091 "bc/src/list.c"
      if (is_eq )
        v2 = FUNCCALL(SETUP_XfOrM598(_), make_ephemeron_hasheq (0 , ((void * ) 0 ) ) ); 
      else if (is_eqv )
        v2 = FUNCCALL(SETUP_XfOrM598(_), make_ephemeron_hasheqv (0 , ((void * ) 0 ) ) ); 
      else if (is_equal_always )
        v2 = FUNCCALL(SETUP_XfOrM598(_), make_ephemeron_hashalw (0 , ((void * ) 0 ) ) ); 
      else 
      v2 = FUNCCALL(SETUP_XfOrM598(_), make_ephemeron_hash (0 , ((void * ) 0 ) ) ); 
    }

# 4099 "bc/src/list.c"
    else {
#     define XfOrM597_COUNT (0+XfOrM596_COUNT)
#     define SETUP_XfOrM597(x) SETUP_XfOrM596(x)

# 4100 "bc/src/list.c"
      if (is_eq )
        v2 = FUNCCALL(SETUP_XfOrM597(_), make_weak_hasheq (0 , ((void * ) 0 ) ) ); 
      else if (is_eqv )
        v2 = FUNCCALL(SETUP_XfOrM597(_), make_weak_hasheqv (0 , ((void * ) 0 ) ) ); 
      else if (is_equal_always )
        v2 = FUNCCALL(SETUP_XfOrM597(_), make_weak_hashalw (0 , ((void * ) 0 ) ) ); 
      else 
      v2 = FUNCCALL(SETUP_XfOrM597(_), make_weak_hash (0 , ((void * ) 0 ) ) ); 
    }
  }

  idx = FUNCCALL(SETUP_XfOrM589(_), scheme_hash_table_iterate_start (1 , a ) ); 
  while ((! (((idx ) ) == (scheme_false ) ) ) ) {
#   define XfOrM593_COUNT (0+XfOrM589_COUNT)
#   define SETUP_XfOrM593(x) SETUP_XfOrM589(x)

# 4113 "bc/src/list.c"
    a [0 ] = v ; 
    a [1 ] = idx ; 
    key = FUNCCALL(SETUP_XfOrM593(_), scheme_hash_table_iterate_key (2 , a ) ); 

    val = FUNCCALL_AGAIN(scheme_chaperone_hash_get (obj , key ) ); 
    if (filter && val ) {
#     define XfOrM595_COUNT (0+XfOrM593_COUNT)
#     define SETUP_XfOrM595(x) SETUP_XfOrM593(x)

# 4119 "bc/src/list.c"
      key = FUNCCALL(SETUP_XfOrM595(_), filter (key ) ); 
      if (! key )

# 4120 "bc/src/list.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      val = FUNCCALL(SETUP_XfOrM595(_), filter (val ) ); 
      if (! val )

# 4122 "bc/src/list.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (val ) {
#     define XfOrM594_COUNT (0+XfOrM593_COUNT)
#     define SETUP_XfOrM594(x) SETUP_XfOrM593(x)

# 4125 "bc/src/list.c"
      a [0 ] = v2 ; 
      a [1 ] = key ; 
      a [2 ] = val ; 
      if ((((((intptr_t ) (v2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v2 ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v2 ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
        v2 = FUNCCALL(SETUP_XfOrM594(_), scheme_hash_table_put (2 , a ) ); 
      else 
      (void ) FUNCCALL(SETUP_XfOrM594(_), hash_table_put_bang (2 , a ) ); 
    }

    a [0 ] = v ; 
    a [1 ] = idx ; 
    idx = FUNCCALL(SETUP_XfOrM593(_), scheme_hash_table_iterate_next (2 , a ) ); 
  }

  RET_VALUE_START (v2 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4142 "bc/src/list.c"
Scheme_Object * scheme_chaperone_hash_table_copy (Scheme_Object * obj ) 
{
  /* No conversion */

# 4144 "bc/src/list.c"
  return scheme_chaperone_hash_table_filtered_copy (obj , ((void * ) 0 ) ) ; 
}

static Scheme_Object * eq_hash_code (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4149 "bc/src/list.c"
  intptr_t v ; 

  if (((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
    return argv [0 ] ; 


  v = scheme_hash_key (argv [0 ] ) ; 




  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * equal_hash_code (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4165 "bc/src/list.c"
  intptr_t v ; 

  if (((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
    return argv [0 ] ; 

  v = scheme_equal_hash_key (argv [0 ] ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * equal_hash2_code (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4177 "bc/src/list.c"
  intptr_t v ; 

  v = scheme_equal_hash_key2 (argv [0 ] ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * equal_always_hash_code (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4186 "bc/src/list.c"
  intptr_t v ; 

  if (((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
    return argv [0 ] ; 

  v = scheme_equal_always_hash_key (argv [0 ] ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * equal_always_hash2_code (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4198 "bc/src/list.c"
  intptr_t v ; 

  v = scheme_equal_always_hash_key2 (argv [0 ] ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * eqv_hash_code (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4207 "bc/src/list.c"
  intptr_t v ; 

  if (((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
    return argv [0 ] ; 

  v = scheme_eqv_hash_key (argv [0 ] ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

Scheme_Object * scheme_make_weak_box (Scheme_Object * v ) 
{
  /* No conversion */
  return (Scheme_Object * ) GC_malloc_weak_box (v , ((void * ) 0 ) , 0 , 0 ) ; 
}

# 4234 "bc/src/list.c"
Scheme_Object * scheme_make_late_weak_box (Scheme_Object * v ) 
{
  /* No conversion */
  return (Scheme_Object * ) GC_malloc_weak_box (v , ((void * ) 0 ) , 0 , 1 ) ; 
}

# 4252 "bc/src/list.c"
static Scheme_Object * make_weak_box (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4254 "bc/src/list.c"
  return scheme_make_weak_box (argv [0 ] ) ; 
}

static Scheme_Object * weak_box_value (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4259 "bc/src/list.c"
  Scheme_Object * o ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_weak_box_type ) ) )
    scheme_wrong_contract ("weak-box-value" , "weak-box?" , 0 , argc , argv ) ; 

  o = (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) ; 
  if (! o )
    return ((argc > 1 ) ? argv [1 ] : scheme_false ) ; 
  else 
  return o ; 
}

Scheme_Object * scheme_weak_box_value (Scheme_Object * obj ) 
{
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM612_COUNT (3)
# define SETUP_XfOrM612(x) SETUP(XfOrM612_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 4274 "bc/src/list.c"
  a [0 ] = obj ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM612(_), weak_box_value (1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4278 "bc/src/list.c"
static Scheme_Object * weak_boxp (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4280 "bc/src/list.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_weak_box_type ) ) ? scheme_true : scheme_false ) ; 
}

Scheme_Object * scheme_make_null (void ) 
{
  /* No conversion */

# 4285 "bc/src/list.c"
  return scheme_null ; 
}

static Scheme_Object * make_graph (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4290 "bc/src/list.c"
  return scheme_resolve_placeholders (argv [0 ] ) ; 
}

static Scheme_Object * make_placeholder (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ph ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ph, 1)));
# define XfOrM616_COUNT (2)
# define SETUP_XfOrM616(x) SETUP(XfOrM616_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ph = NULLED_OUT ; 

# 4297 "bc/src/list.c"
  ph = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM616(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  ph -> type = scheme_placeholder_type ; 
  (((Scheme_Small_Object * ) (ph ) ) -> u . ptr_val ) = argv [0 ] ; 

  RET_VALUE_START (ph ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4304 "bc/src/list.c"
static Scheme_Object * placeholder_set (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4306 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_placeholder_type ) ) )
    scheme_wrong_contract ("placeholder-set!" , "placeholder?" , 0 , argc , argv ) ; 
  (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) = argv [1 ] ; 
  return scheme_void ; 
}

static Scheme_Object * placeholder_get (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4314 "bc/src/list.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_placeholder_type ) ) )
    scheme_wrong_contract ("placeholder-get" , "placeholder?" , 0 , argc , argv ) ; 
  return (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) ; 
}

static Scheme_Object * placeholder_p (int c , Scheme_Object * p [] ) 
{
  /* No conversion */

# 4321 "bc/src/list.c"
  return (((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_placeholder_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * do_make_hash_placeholder (const char * who , int kind , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * l , * a , * ph ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ph, 1)));
# define XfOrM620_COUNT (2)
# define SETUP_XfOrM620(x) SETUP(XfOrM620_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  a = NULLED_OUT ; 
  ph = NULLED_OUT ; 

# 4330 "bc/src/list.c"
  for (l = argv [0 ] ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
    a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      break ; 
  }

  if (! ((l ) == (scheme_null ) ) ) {
#   define XfOrM621_COUNT (0+XfOrM620_COUNT)
#   define SETUP_XfOrM621(x) SETUP_XfOrM620(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "(listof pair?)" , 0 , argc , argv ) )
# 4337 "bc/src/list.c"
    ; 
  }

  ph = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM620(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  ph -> type = scheme_table_placeholder_type ; 
  (((Scheme_Simple_Object * ) (ph ) ) -> u . ptr_int_val . ptr ) = argv [0 ] ; 
  (((Scheme_Simple_Object * ) (ph ) ) -> u . ptr_int_val . pint ) = kind ; 

  RET_VALUE_START (ph ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4348 "bc/src/list.c"
static Scheme_Object * make_hash_placeholder (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4350 "bc/src/list.c"
  return do_make_hash_placeholder ("make-hash-placeholder" , 1 , argc , argv ) ; 
}

static Scheme_Object * make_hasheq_placeholder (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4355 "bc/src/list.c"
  return do_make_hash_placeholder ("make-hash-placeholder" , 0 , argc , argv ) ; 
}

static Scheme_Object * make_hasheqv_placeholder (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4360 "bc/src/list.c"
  return do_make_hash_placeholder ("make-hasheqv-placeholder" , 2 , argc , argv ) ; 
}

static Scheme_Object * make_hashalw_placeholder (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4365 "bc/src/list.c"
  return do_make_hash_placeholder ("make-hashalw-placeholder" , 3 , argc , argv ) ; 
}

static Scheme_Object * table_placeholder_p (int c , Scheme_Object * p [] ) 
{
  /* No conversion */

# 4370 "bc/src/list.c"
  return (((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_table_placeholder_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}







typedef struct Scheme_Ephemeron {
  Scheme_Object so ; 
  Scheme_Object * key , * val ; 
  struct Scheme_Ephemeron * next ; 
}

# 4385 "bc/src/list.c"
Scheme_Ephemeron ; 

# 4407 "bc/src/list.c"
Scheme_Object * scheme_make_ephemeron (Scheme_Object * key , Scheme_Object * val ) 
{
  /* No conversion */
  return GC_malloc_ephemeron (key , val ) ; 
}

# 4435 "bc/src/list.c"
Scheme_Object * scheme_ephemeron_value (Scheme_Object * o ) 
{
  /* No conversion */

# 4437 "bc/src/list.c"
  return ((Scheme_Ephemeron * ) o ) -> val ; 
}

Scheme_Object * scheme_ephemeron_key (Scheme_Object * o ) 
{
  /* No conversion */

# 4442 "bc/src/list.c"
  return ((Scheme_Ephemeron * ) o ) -> key ; 
}

# 4518 "bc/src/list.c"
static Scheme_Object * make_ephemeron (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4520 "bc/src/list.c"
  return scheme_make_ephemeron (argv [0 ] , argv [1 ] ) ; 
}

static Scheme_Object * ephemeron_value (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4525 "bc/src/list.c"
  Scheme_Object * v ; 





  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_ephemeron_type ) ) )
    scheme_wrong_contract ("ephemeron-value" , "ephemeron?" , 0 , argc , argv ) ; 
  v = scheme_ephemeron_value (argv [0 ] ) ; 

  if (! v )
    return ((argc > 1 ) ? argv [1 ] : scheme_false ) ; 
  else 
  return v ; 
}

static Scheme_Object * ephemeronp (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4543 "bc/src/list.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_ephemeron_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * impersonator_ephemeron (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4550 "bc/src/list.c"
  Scheme_Object * obj = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    return scheme_make_ephemeron ((((Scheme_Chaperone * ) obj ) -> val ) , obj ) ; 
  }

# 4554 "bc/src/list.c"
  else {


    return scheme_make_ephemeron (obj , obj ) ; 
  }
}

# 4595 "bc/src/list.c"
static Scheme_Object * unsafe_cons_list (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4597 "bc/src/list.c"
  return scheme_make_list_pair (argv [0 ] , argv [1 ] ) ; 
}


static Scheme_Object * unsafe_car (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4603 "bc/src/list.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 4603 "bc/src/list.c"
  return scheme_checked_car (argc , argv ) ; 
  return (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ; 
}

static Scheme_Object * unsafe_cdr (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4609 "bc/src/list.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 4609 "bc/src/list.c"
  return scheme_checked_cdr (argc , argv ) ; 
  return (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ; 
}

static Scheme_Object * unsafe_list_ref (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4615 "bc/src/list.c"
  int i ; 
  Scheme_Object * v ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 4618 "bc/src/list.c"
  return scheme_checked_list_ref (argc , argv ) ; 

  v = argv [0 ] ; 
  i = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  while (i -- ) {
    v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
  }

  return (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
}

static Scheme_Object * unsafe_list_tail (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4631 "bc/src/list.c"
  int i ; 
  Scheme_Object * v ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 4634 "bc/src/list.c"
  return scheme_checked_list_tail (argc , argv ) ; 

  v = argv [0 ] ; 
  i = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  while (i -- ) {
    v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
  }

  return v ; 
}

static Scheme_Object * unsafe_mcar (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4647 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ; 
}

static Scheme_Object * unsafe_mcdr (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4652 "bc/src/list.c"
  return (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ; 
}

static Scheme_Object * unsafe_set_mcar (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4657 "bc/src/list.c"
  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) = argv [1 ] ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_set_mcdr (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4663 "bc/src/list.c"
  (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) = argv [1 ] ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_unbox_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4669 "bc/src/list.c"
  return (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) ; 
}

static Scheme_Object * unsafe_unbox (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4674 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    return chaperone_unbox (argv [0 ] ) ; 
  else 
  return (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) ; 
}

static Scheme_Object * unsafe_set_box_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4682 "bc/src/list.c"
  (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) = argv [1 ] ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_set_box (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM654_COUNT (1)
# define SETUP_XfOrM654(x) SETUP(XfOrM654_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4688 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    FUNCCALL(SETUP_XfOrM654(_), chaperone_set_box (argv [0 ] , argv [1 ] ) ); 
  else 
  (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) = argv [1 ] ; 
  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


Scheme_Object * unsafe_hash_table_iterate_start (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4702 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 

# 4704 "bc/src/list.c"
  o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  return scheme_hash_table_next ((Scheme_Hash_Table * ) o , - 1 ) ; 
}

Scheme_Object * unsafe_hash_table_iterate_next (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4711 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] , * res ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 

# 4713 "bc/src/list.c"
  o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  res = scheme_hash_table_next ((Scheme_Hash_Table * ) o , (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ; 

  if (res )
    return res ; 
  else if (0 ) {
    scheme_contract_error ("unsafe-mutable-hash-iterate-next" , 
    "no element at index" , 
    "index" , 1 , argv [1 ] , 
    ((void * ) 0 ) ) ; 
    return ((void * ) 0 ) ; 
  }

# 4725 "bc/src/list.c"
  else 
  return scheme_false ; 
}

Scheme_Object * unsafe_hash_table_iterate_key (int argc , Scheme_Object * argv [] ) 
XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 4732 "bc/src/list.c"
  GC_CAN_IGNORE const char * name = "unsafe-mutable-hash-iterate-key" ; 
  Scheme_Object * obj = argv [0 ] , * key ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    if (scheme_hash_table_index (ht , pos , & key , ((void * ) 0 ) ) )
      return chaperone_hash_key (name , obj , key ) ; 
  }

# 4740 "bc/src/list.c"
  else {
    if (scheme_hash_table_index ((Scheme_Hash_Table * ) obj , pos , & key , ((void * ) 0 ) ) )
      return key ; 
  }

  if (argc > 2 )
    return argv [2 ] ; 
  else {
    scheme_contract_error (name , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) ; 
    return ((void * ) 0 ) ; 
  }
}

static Scheme_Object * unsafe_hash_table_iterate_value_slow (int argc , Scheme_Object * argv [] ) 
{
  GC_CAN_IGNORE const char * name = "unsafe-mutable-hash-iterate-value" ; 
  Scheme_Object * obj = argv [0 ] , * key , * val ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(obj, 3)));
# define XfOrM662_COUNT (4)
# define SETUP_XfOrM662(x) SETUP(XfOrM662_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 4759 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Object * chap_key , * chap_val ; 
    Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    BLOCK_SETUP((PUSH(chap_key, 0+XfOrM662_COUNT), PUSH(chap_val, 1+XfOrM662_COUNT)));
#   define XfOrM665_COUNT (2+XfOrM662_COUNT)
#   define SETUP_XfOrM665(x) SETUP(XfOrM665_COUNT)
    chap_key = NULLED_OUT ; 
    chap_val = NULLED_OUT ; 

# 4762 "bc/src/list.c"
    if (scheme_hash_table_index (ht , pos , & key , ((void * ) 0 ) ) )  {
#     define XfOrM666_COUNT (0+XfOrM665_COUNT)
#     define SETUP_XfOrM666(x) SETUP_XfOrM665(x)
      FUNCCALL(SETUP_XfOrM666(_), chaperone_hash_key_value (name , obj , key , & chap_key , & chap_val , 0 ) )
# 4763 "bc/src/list.c"
      ; 
      RET_VALUE_START (chap_val ) RET_VALUE_END ; 
    }
  }

# 4766 "bc/src/list.c"
  else {
#   define XfOrM664_COUNT (0+XfOrM662_COUNT)
#   define SETUP_XfOrM664(x) SETUP_XfOrM662(x)

# 4767 "bc/src/list.c"
    if (scheme_hash_table_index ((Scheme_Hash_Table * ) obj , pos , & key , & val ) ) 
      RET_VALUE_START (val ) RET_VALUE_END ; 
  }

  if (argc > 2 )
    RET_VALUE_START (argv [2 ] ) RET_VALUE_END ; 
  else {
#   define XfOrM663_COUNT (0+XfOrM662_COUNT)
#   define SETUP_XfOrM663(x) SETUP_XfOrM662(x)
    FUNCCALL_EMPTY(scheme_contract_error (name , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) )
# 4774 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4779 "bc/src/list.c"
Scheme_Object * unsafe_hash_table_iterate_value (int argc , Scheme_Object * argv [] ) 
XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 4782 "bc/src/list.c"
  Scheme_Object * obj = argv [0 ] , * key , * val ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && scheme_hash_table_index ((Scheme_Hash_Table * ) obj , pos , & key , & val ) )
    return val ; 
  else 
  return unsafe_hash_table_iterate_value_slow (argc , argv ) ; 
}

Scheme_Object * unsafe_hash_table_iterate_pair (int argc , Scheme_Object * argv [] ) 
{
  GC_CAN_IGNORE const char * name = "unsafe-mutable-hash-iterate-pair" ; 
  Scheme_Object * obj = argv [0 ] , * key , * val ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(obj, 3)));
# define XfOrM668_COUNT (4)
# define SETUP_XfOrM668(x) SETUP(XfOrM668_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 4798 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Object * chap_key , * chap_val ; 
    Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    BLOCK_SETUP((PUSH(chap_key, 0+XfOrM668_COUNT), PUSH(chap_val, 1+XfOrM668_COUNT)));
#   define XfOrM671_COUNT (2+XfOrM668_COUNT)
#   define SETUP_XfOrM671(x) SETUP(XfOrM671_COUNT)
    chap_key = NULLED_OUT ; 
    chap_val = NULLED_OUT ; 

# 4801 "bc/src/list.c"
    if (scheme_hash_table_index (ht , pos , & key , ((void * ) 0 ) ) )  {
#     define XfOrM672_COUNT (0+XfOrM671_COUNT)
#     define SETUP_XfOrM672(x) SETUP_XfOrM671(x)
      FUNCCALL(SETUP_XfOrM672(_), chaperone_hash_key_value (name , obj , key , & chap_key , & chap_val , 0 ) )
# 4802 "bc/src/list.c"
      ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM672(_), scheme_make_pair (chap_key , chap_val ) )) RET_VALUE_END ; 
    }
  }

# 4805 "bc/src/list.c"
  else {
#   define XfOrM670_COUNT (0+XfOrM668_COUNT)
#   define SETUP_XfOrM670(x) SETUP_XfOrM668(x)

# 4806 "bc/src/list.c"
    if (scheme_hash_table_index ((Scheme_Hash_Table * ) obj , pos , & key , & val ) ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (key , val ) )) RET_VALUE_EMPTY_END ; 
  }

  if (argc > 2 )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (argv [2 ] , argv [2 ] ) )) RET_VALUE_EMPTY_END ; 
  else {
#   define XfOrM669_COUNT (0+XfOrM668_COUNT)
#   define SETUP_XfOrM669(x) SETUP_XfOrM668(x)
    FUNCCALL_EMPTY(scheme_contract_error (name , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) )
# 4813 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4818 "bc/src/list.c"
Scheme_Object * unsafe_hash_table_iterate_key_value (int argc , Scheme_Object * argv [] ) 
{
  GC_CAN_IGNORE const char * name = "unsafe-mutable-hash-iterate-key+value" ; 
  Scheme_Object * obj = argv [0 ] , * res [2 ] ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSHARRAY(res, 2, 0), PUSH(argv, 3), PUSH(obj, 4)));
# define XfOrM673_COUNT (5)
# define SETUP_XfOrM673(x) SETUP(XfOrM673_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  res[0] = NULLED_OUT ; 
  res[1] = NULLED_OUT ; 

# 4824 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Object * key ; 
    Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
#   define XfOrM677_COUNT (0+XfOrM673_COUNT)
#   define SETUP_XfOrM677(x) SETUP_XfOrM673(x)
    key = NULLED_OUT ; 

# 4827 "bc/src/list.c"
    if (scheme_hash_table_index (ht , pos , & key , ((void * ) 0 ) ) )  {
#     define XfOrM678_COUNT (0+XfOrM677_COUNT)
#     define SETUP_XfOrM678(x) SETUP_XfOrM677(x)
      FUNCCALL(SETUP_XfOrM678(_), chaperone_hash_key_value (name , obj , key , & res [0 ] , & res [1 ] , 0 ) )
# 4828 "bc/src/list.c"
      ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM678(_), scheme_values (2 , res ) )) RET_VALUE_END ; 
    }
  }

# 4831 "bc/src/list.c"
  else {
#   define XfOrM676_COUNT (0+XfOrM673_COUNT)
#   define SETUP_XfOrM676(x) SETUP_XfOrM673(x)

# 4832 "bc/src/list.c"
    if (scheme_hash_table_index ((Scheme_Hash_Table * ) obj , pos , & res [0 ] , & res [1 ] ) ) 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM676(_), scheme_values (2 , res ) )) RET_VALUE_END ; 
  }

  if (argc > 2 ) {
#   define XfOrM675_COUNT (0+XfOrM673_COUNT)
#   define SETUP_XfOrM675(x) SETUP_XfOrM673(x)

# 4837 "bc/src/list.c"
    res [0 ] = argv [2 ] ; 
    res [1 ] = argv [2 ] ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM675(_), scheme_values (2 , res ) )) RET_VALUE_END ; 
  }

# 4840 "bc/src/list.c"
  else {
#   define XfOrM674_COUNT (0+XfOrM673_COUNT)
#   define SETUP_XfOrM674(x) SETUP_XfOrM673(x)
    FUNCCALL(SETUP_XfOrM674(_), scheme_contract_error (name , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) )
# 4841 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4847 "bc/src/list.c"
Scheme_Object * unsafe_hash_tree_iterate_start (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4849 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 

# 4851 "bc/src/list.c"
  o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  return scheme_unsafe_hash_tree_start ((Scheme_Hash_Tree * ) o ) ; 
}

Scheme_Object * unsafe_hash_tree_iterate_next (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4858 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 

# 4860 "bc/src/list.c"
  o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  return scheme_unsafe_hash_tree_next ((Scheme_Hash_Tree * ) o , argv [1 ] ) ; 
}

Scheme_Object * unsafe_hash_tree_iterate_key (int argc , Scheme_Object * argv [] ) 
XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 4868 "bc/src/list.c"
  Scheme_Object * obj = argv [0 ] , * args = argv [1 ] , * key ; 
  Scheme_Hash_Tree * subtree ; 
  int i ; 

  scheme_unsafe_hash_tree_subtree (obj , args , & subtree , & i ) ; 
  key = subtree -> els [i ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    return chaperone_hash_key ("unsafe-immutable-hash-iterate-key" , obj , key ) ; 
  else 
  return key ; 
}

static Scheme_Object * unsafe_hash_tree_iterate_value_slow (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * obj = argv [0 ] , * args = argv [1 ] ; 
  Scheme_Hash_Tree * subtree ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(subtree, 0)));
# define XfOrM682_COUNT (1)
# define SETUP_XfOrM682(x) SETUP(XfOrM682_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  subtree = NULLED_OUT ; 
  (
# 4887 "bc/src/list.c"
  scheme_unsafe_hash_tree_subtree (obj , args , & subtree , & i ) ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Object * chap_key , * chap_val ; 
    BLOCK_SETUP((PUSH(chap_key, 0+XfOrM682_COUNT), PUSH(chap_val, 1+XfOrM682_COUNT)));
#   define XfOrM683_COUNT (2+XfOrM682_COUNT)
#   define SETUP_XfOrM683(x) SETUP(XfOrM683_COUNT)
    chap_key = NULLED_OUT ; 
    chap_val = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM683(_), chaperone_hash_key_value ("unsafe-immutable-hash-iterate-value" , obj , subtree -> els [i ] , & chap_key , & chap_val , 0 ) )
# 4892 "bc/src/list.c"
    ; 
    RET_VALUE_START (chap_val ) RET_VALUE_END ; 
  }

# 4894 "bc/src/list.c"
  else 
  RET_VALUE_START ((scheme_unsafe_hash_tree_access (subtree , i ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4898 "bc/src/list.c"
Scheme_Object * unsafe_hash_tree_iterate_value (int argc , Scheme_Object * argv [] ) 
XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 4901 "bc/src/list.c"
  Scheme_Object * obj = argv [0 ] , * args = argv [1 ] ; 
  Scheme_Hash_Tree * subtree ; 
  int i ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
    scheme_unsafe_hash_tree_subtree (obj , args , & subtree , & i ) ; 
    return scheme_unsafe_hash_tree_access (subtree , i ) ; 
  }

# 4908 "bc/src/list.c"
  else 
  return unsafe_hash_tree_iterate_value_slow (argc , argv ) ; 
}

Scheme_Object * unsafe_hash_tree_iterate_pair (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * obj = argv [0 ] , * args = argv [1 ] , * key ; 
  Scheme_Hash_Tree * subtree ; 
  int i ; 
  Scheme_Object * __funcarg115 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(subtree, 1)));
# define XfOrM686_COUNT (2)
# define SETUP_XfOrM686(x) SETUP(XfOrM686_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  key = NULLED_OUT ; 
  subtree = NULLED_OUT ; 
  (
# 4918 "bc/src/list.c"
  scheme_unsafe_hash_tree_subtree (obj , args , & subtree , & i ) ) ; 
  key = subtree -> els [i ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Object * chap_key , * chap_val ; 
    BLOCK_SETUP((PUSH(chap_key, 0+XfOrM686_COUNT), PUSH(chap_val, 1+XfOrM686_COUNT)));
#   define XfOrM687_COUNT (2+XfOrM686_COUNT)
#   define SETUP_XfOrM687(x) SETUP(XfOrM687_COUNT)
    chap_key = NULLED_OUT ; 
    chap_val = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM687(_), chaperone_hash_key_value ("unsafe-immutable-hash-iterate-pair" , obj , subtree -> els [i ] , & chap_key , & chap_val , 0 ) )
# 4924 "bc/src/list.c"
    ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM687(_), scheme_make_pair (chap_key , chap_val ) )) RET_VALUE_END ; 
  }

# 4926 "bc/src/list.c"
  else 
  RET_VALUE_START ((__funcarg115 = (scheme_unsafe_hash_tree_access (subtree , i ) ) , FUNCCALL_EMPTY(scheme_make_pair (key , __funcarg115 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4930 "bc/src/list.c"
Scheme_Object * unsafe_hash_tree_iterate_key_value (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * obj = argv [0 ] , * args = argv [1 ] , * key , * res [2 ] ; 
  Scheme_Hash_Tree * subtree ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(subtree, 1), PUSHARRAY(res, 2, 2)));
# define XfOrM688_COUNT (5)
# define SETUP_XfOrM688(x) SETUP(XfOrM688_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  key = NULLED_OUT ; 
  res[0] = NULLED_OUT ; 
  res[1] = NULLED_OUT ; 
  subtree = NULLED_OUT ; 
  (
# 4936 "bc/src/list.c"
  scheme_unsafe_hash_tree_subtree (obj , args , & subtree , & i ) ) ; 
  key = subtree -> els [i ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
#   define XfOrM690_COUNT (0+XfOrM688_COUNT)
#   define SETUP_XfOrM690(x) SETUP_XfOrM688(x)
    FUNCCALL(SETUP_XfOrM690(_), chaperone_hash_key_value ("unsafe-immutable-hash-iterate-key+value" , obj , subtree -> els [i ] , & res [0 ] , & res [1 ] , 0 ) )
# 4941 "bc/src/list.c"
    ; 
  }

# 4942 "bc/src/list.c"
  else {
#   define XfOrM689_COUNT (0+XfOrM688_COUNT)
#   define SETUP_XfOrM689(x) SETUP_XfOrM688(x)

# 4943 "bc/src/list.c"
    res [0 ] = key ; 
    res [1 ] = (scheme_unsafe_hash_tree_access (subtree , i ) ) ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM688(_), scheme_values (2 , res ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4951 "bc/src/list.c"
Scheme_Object * unsafe_bucket_table_iterate_start (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4953 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 

# 4955 "bc/src/list.c"
  o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  return scheme_bucket_table_next ((Scheme_Bucket_Table * ) o , - 1 ) ; 
}

Scheme_Object * unsafe_bucket_table_iterate_next (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4962 "bc/src/list.c"
  Scheme_Object * o = argv [0 ] , * res ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 

# 4964 "bc/src/list.c"
  o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  res = scheme_bucket_table_next ((Scheme_Bucket_Table * ) o , 
  (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ; 
  if (res )
    return res ; 
  else if (0 ) {
    scheme_contract_error ("unsafe-weak-hash-iterate-next" , 
    "no element at index" , 
    "index" , 1 , argv [1 ] , 
    ((void * ) 0 ) ) ; 
    return ((void * ) 0 ) ; 
  }

# 4976 "bc/src/list.c"
  else 
  return scheme_false ; 
}

Scheme_Object * unsafe_bucket_table_iterate_key (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4982 "bc/src/list.c"
  GC_CAN_IGNORE const char * name = "unsafe-weak-hash-iterate-key" ; 
  Scheme_Object * obj = argv [0 ] , * key ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Bucket_Table * ht = (Scheme_Bucket_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    if (scheme_bucket_table_index (ht , pos , & key , ((void * ) 0 ) ) )
      return chaperone_hash_key (name , obj , key ) ; 
  }

# 4990 "bc/src/list.c"
  else {
    if (scheme_bucket_table_index ((Scheme_Bucket_Table * ) obj , pos , & key , ((void * ) 0 ) ) )
      return key ; 
  }

  if (argc > 2 )
    return argv [2 ] ; 
  else {
    scheme_contract_error (name , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) ; 
    return ((void * ) 0 ) ; 
  }
}

Scheme_Object * unsafe_bucket_table_iterate_value (int argc , Scheme_Object * argv [] ) 
{
  GC_CAN_IGNORE const char * name = "unsafe-weak-hash-iterate-value" ; 
  Scheme_Object * obj = argv [0 ] , * key , * val ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(obj, 3)));
# define XfOrM698_COUNT (4)
# define SETUP_XfOrM698(x) SETUP(XfOrM698_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 5009 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Bucket_Table * ht = (Scheme_Bucket_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    Scheme_Object * chap_key , * chap_val ; 
    BLOCK_SETUP((PUSH(chap_key, 0+XfOrM698_COUNT), PUSH(chap_val, 1+XfOrM698_COUNT)));
#   define XfOrM701_COUNT (2+XfOrM698_COUNT)
#   define SETUP_XfOrM701(x) SETUP(XfOrM701_COUNT)
    chap_key = NULLED_OUT ; 
    chap_val = NULLED_OUT ; 

# 5012 "bc/src/list.c"
    if (scheme_bucket_table_index (ht , pos , & key , ((void * ) 0 ) ) )  {
#     define XfOrM702_COUNT (0+XfOrM701_COUNT)
#     define SETUP_XfOrM702(x) SETUP_XfOrM701(x)
      FUNCCALL(SETUP_XfOrM702(_), chaperone_hash_key_value (name , obj , key , & chap_key , & chap_val , 0 ) )
# 5013 "bc/src/list.c"
      ; 
      RET_VALUE_START (chap_val ) RET_VALUE_END ; 
    }
  }

# 5016 "bc/src/list.c"
  else {
#   define XfOrM700_COUNT (0+XfOrM698_COUNT)
#   define SETUP_XfOrM700(x) SETUP_XfOrM698(x)

# 5017 "bc/src/list.c"
    if (scheme_bucket_table_index ((Scheme_Bucket_Table * ) obj , pos , & key , & val ) ) 
      RET_VALUE_START (val ) RET_VALUE_END ; 
  }

  if (argc > 2 )
    RET_VALUE_START (argv [2 ] ) RET_VALUE_END ; 
  else {
#   define XfOrM699_COUNT (0+XfOrM698_COUNT)
#   define SETUP_XfOrM699(x) SETUP_XfOrM698(x)
    FUNCCALL_EMPTY(scheme_contract_error (name , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) )
# 5024 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5029 "bc/src/list.c"
Scheme_Object * unsafe_bucket_table_iterate_pair (int argc , Scheme_Object * argv [] ) 
{
  GC_CAN_IGNORE const char * name = "unsafe-weak-hash-iterate-pair" ; 
  Scheme_Object * obj = argv [0 ] , * key , * val ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(obj, 3)));
# define XfOrM703_COUNT (4)
# define SETUP_XfOrM703(x) SETUP(XfOrM703_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 5035 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Bucket_Table * ht = (Scheme_Bucket_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    Scheme_Object * chap_key , * chap_val ; 
    BLOCK_SETUP((PUSH(chap_key, 0+XfOrM703_COUNT), PUSH(chap_val, 1+XfOrM703_COUNT)));
#   define XfOrM706_COUNT (2+XfOrM703_COUNT)
#   define SETUP_XfOrM706(x) SETUP(XfOrM706_COUNT)
    chap_key = NULLED_OUT ; 
    chap_val = NULLED_OUT ; 

# 5038 "bc/src/list.c"
    if (scheme_bucket_table_index (ht , pos , & key , ((void * ) 0 ) ) )  {
#     define XfOrM707_COUNT (0+XfOrM706_COUNT)
#     define SETUP_XfOrM707(x) SETUP_XfOrM706(x)
      FUNCCALL(SETUP_XfOrM707(_), chaperone_hash_key_value (name , obj , key , & chap_key , & chap_val , 0 ) )
# 5039 "bc/src/list.c"
      ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM707(_), scheme_make_pair (chap_key , chap_val ) )) RET_VALUE_END ; 
    }
  }

# 5042 "bc/src/list.c"
  else {
#   define XfOrM705_COUNT (0+XfOrM703_COUNT)
#   define SETUP_XfOrM705(x) SETUP_XfOrM703(x)

# 5043 "bc/src/list.c"
    if (scheme_bucket_table_index ((Scheme_Bucket_Table * ) obj , pos , & key , & val ) ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (key , val ) )) RET_VALUE_EMPTY_END ; 
  }

  if (argc > 2 )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (argv [2 ] , argv [2 ] ) )) RET_VALUE_EMPTY_END ; 
  else {
#   define XfOrM704_COUNT (0+XfOrM703_COUNT)
#   define SETUP_XfOrM704(x) SETUP_XfOrM703(x)
    FUNCCALL_EMPTY(scheme_contract_error (name , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) )
# 5050 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5055 "bc/src/list.c"
Scheme_Object * unsafe_bucket_table_iterate_key_value (int argc , Scheme_Object * argv [] ) 
{
  GC_CAN_IGNORE const char * name = "unsafe-weak-hash-iterate-key+value" ; 
  Scheme_Object * obj = argv [0 ] , * res [2 ] ; 
  mzlonglong pos = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSHARRAY(res, 2, 0), PUSH(argv, 3), PUSH(obj, 4)));
# define XfOrM708_COUNT (5)
# define SETUP_XfOrM708(x) SETUP(XfOrM708_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  res[0] = NULLED_OUT ; 
  res[1] = NULLED_OUT ; 

# 5061 "bc/src/list.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
    Scheme_Bucket_Table * ht = (Scheme_Bucket_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    Scheme_Object * key ; 
#   define XfOrM712_COUNT (0+XfOrM708_COUNT)
#   define SETUP_XfOrM712(x) SETUP_XfOrM708(x)
    key = NULLED_OUT ; 

# 5064 "bc/src/list.c"
    if (scheme_bucket_table_index (ht , pos , & key , ((void * ) 0 ) ) )  {
#     define XfOrM713_COUNT (0+XfOrM712_COUNT)
#     define SETUP_XfOrM713(x) SETUP_XfOrM712(x)
      FUNCCALL(SETUP_XfOrM713(_), chaperone_hash_key_value (name , obj , key , & res [0 ] , & res [1 ] , 0 ) )
# 5065 "bc/src/list.c"
      ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM713(_), scheme_values (2 , res ) )) RET_VALUE_END ; 
    }
  }

# 5068 "bc/src/list.c"
  else {
    Scheme_Bucket_Table * ht = (Scheme_Bucket_Table * ) obj ; 
#   define XfOrM711_COUNT (0+XfOrM708_COUNT)
#   define SETUP_XfOrM711(x) SETUP_XfOrM708(x)

# 5070 "bc/src/list.c"
    if (scheme_bucket_table_index (ht , pos , & res [0 ] , & res [1 ] ) ) 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM711(_), scheme_values (2 , res ) )) RET_VALUE_END ; 
  }

  if (argc > 2 ) {
#   define XfOrM710_COUNT (0+XfOrM708_COUNT)
#   define SETUP_XfOrM710(x) SETUP_XfOrM708(x)

# 5075 "bc/src/list.c"
    res [0 ] = argv [2 ] ; 
    res [1 ] = argv [2 ] ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM710(_), scheme_values (2 , res ) )) RET_VALUE_END ; 
  }

# 5078 "bc/src/list.c"
  else {
#   define XfOrM709_COUNT (0+XfOrM708_COUNT)
#   define SETUP_XfOrM709(x) SETUP_XfOrM708(x)
    FUNCCALL(SETUP_XfOrM709(_), scheme_contract_error (name , "no element at index" , "index" , 1 , argv [1 ] , ((void * ) 0 ) ) )
# 5079 "bc/src/list.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
