#include "precomp.h"

# 5 "bc/src/numarith.c"
Scheme_Object * scheme_unsafe_fx_plus_proc ; 
Scheme_Object * scheme_unsafe_fx_minus_proc ; 
Scheme_Object * scheme_unsafe_fx_times_proc ; 

static Scheme_Object * plus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * minus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * mult (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * div_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * quotient (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * rem_prim (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * quotient_remainder (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * fx_plus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_plus_wrap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_minus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_minus_wrap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_mult (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_mult_wrap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_div (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_rem (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_mod (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_abs (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_fx_plus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_plus_wrap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_minus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_minus_wrap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_mult (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_mult_wrap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_div (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_rem (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_mod (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_abs (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * fl_plus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_minus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_mult (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_div (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_abs (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_sqrt (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_fl_plus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_minus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_mult (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_div (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_abs (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_sqrt (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * extfl_plus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_minus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_mult (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_div (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_abs (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_sqrt (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_extfl_plus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_minus (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_mult (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_div (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_abs (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_sqrt (int argc , Scheme_Object * argv [] ) ; 









void scheme_init_numarith (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM1_COUNT (2)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 79 "bc/src/numarith.c"
  p = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (scheme_add1 , "add1" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 21 ) 
  | (1 << 22 ) 
  | (1 << 19 ) 
  | (1 << 23 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("add1" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_sub1 , "sub1" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 21 ) 
  | (1 << 22 ) 
  | (1 << 19 ) 
  | (1 << 23 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("sub1" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (plus , "+" , 0 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 21 ) 
  | (1 << 22 ) 
  | (1 << 19 ) 
  | (1 << 23 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("+" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (minus , "-" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 0 ) 
  | (1 << 2 ) 
  | (1 << 21 ) 
  | (1 << 22 ) 
  | (1 << 19 ) 
  | (1 << 23 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("-" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (mult , "*" , 0 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 21 ) 
  | (1 << 22 ) 
  | (1 << 19 ) 
  | (1 << 23 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("*" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (div_prim , "/" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 21 ) 
  | (1 << 19 ) 
  | (1 << 23 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("/" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_abs , "abs" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 18 ) 
  | (1 << 23 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("abs" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (quotient , "quotient" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 20 ) 
  | (1 << 18 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("quotient" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (rem_prim , "remainder" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 20 ) 
  | (1 << 18 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("remainder" , p , env ) ); 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_everything (quotient_remainder , 1 , "quotient/remainder" , 2 , 2 , 0 , 2 , 2 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("quotient/remainder" , __funcarg58 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_modulo , "modulo" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 20 ) 
  | (1 << 18 ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("modulo" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 165 "bc/src/numarith.c"
void scheme_init_flfxnum_numarith (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  int flags ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 170 "bc/src/numarith.c"
  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (fx_plus , "fx+" , 0 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx+" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_plus_wrap , "fx+/wraparound" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx+/wraparound" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_minus , "fx-" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 2 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx-" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_minus_wrap , "fx-/wraparound" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 2 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx-/wraparound" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_mult , "fx*" , 0 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx*" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_mult_wrap , "fx*/wraparound" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx*/wraparound" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_div , "fxquotient" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fxquotient" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_rem , "fxremainder" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fxremainder" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_mod , "fxmodulo" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fxmodulo" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_abs , "fxabs" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) 
  | (2 << 26 ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fxabs" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_plus , "fl+" , 0 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl+" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_minus , "fl-" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 0 ) | (1 << 1 ) 
  | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl-" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_mult , "fl*" , 0 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl*" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_div , "fl/" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl/" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_abs , "flabs" , 1 , 1 , 1 ) ); 
  if (0 )
    flags = (1 << 0 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 26 ) 
  | (1 << 9 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("flabs" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_sqrt , "flsqrt" , 1 , 1 , 1 ) ); 
  if (0 && 1 )
    flags = (1 << 0 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 26 ) 
  | (1 << 9 ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("flsqrt" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 297 "bc/src/numarith.c"
void scheme_init_extfl_numarith (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  int flags ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM3_COUNT (2)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 302 "bc/src/numarith.c"
  p = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (extfl_plus , "extfl+" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl+" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_minus , "extfl-" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl-" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_mult , "extfl*" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl*" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_div , "extfl/" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl/" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_abs , "extflabs" , 1 , 1 , 1 ) ); 
  if (0 )
    flags = (1 << 0 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (3 << 26 ) 
  | (1 << 12 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extflabs" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_sqrt , "extflsqrt" , 1 , 1 , 1 ) ); 
  if (0 )
    flags = (1 << 0 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (3 << 26 ) 
  | (1 << 12 ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("extflsqrt" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 363 "bc/src/numarith.c"
void scheme_init_unsafe_numarith (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  int flags ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM4_COUNT (2)
# define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_register_static ((void * ) & scheme_unsafe_fx_plus_proc , sizeof (scheme_unsafe_fx_plus_proc ) ) )
# 368 "bc/src/numarith.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_plus , "unsafe-fx+" , 0 , - 1 , 1 ) ); 
  scheme_unsafe_fx_plus_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx+" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_plus_wrap , "unsafe-fx+/wraparound" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx+/wraparound" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_fx_minus_proc , sizeof (scheme_unsafe_fx_minus_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_minus , "unsafe-fx-" , 1 , - 2 , 1 ) ); 
  scheme_unsafe_fx_minus_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx-" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_minus_wrap , "unsafe-fx-/wraparound" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx-/wraparound" , p , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_fx_times_proc , sizeof (scheme_unsafe_fx_times_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_mult , "unsafe-fx*" , 0 , - 1 , 1 ) ); 
  scheme_unsafe_fx_times_proc = p ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx*" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_mult_wrap , "unsafe-fx*/wraparound" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx*/wraparound" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_div , "unsafe-fxquotient" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fxquotient" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_rem , "unsafe-fxremainder" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fxremainder" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_mod , "unsafe-fxmodulo" , 2 , 2 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fxmodulo" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_abs , "unsafe-fxabs" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fxabs" , p , env ) ); 


  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_plus , "unsafe-fl+" , 0 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl+" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_minus , "unsafe-fl-" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 0 ) | (1 << 1 ) 
  | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl-" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_mult , "unsafe-fl*" , 0 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 1 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl*" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_div , "unsafe-fl/" , 1 , - 2 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl/" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_abs , "unsafe-flabs" , 1 , 1 , 1 ) ); 
  if (0 )
    flags = (1 << 0 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (1 << 26 ) 
  | (1 << 9 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-flabs" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_sqrt , "unsafe-flsqrt" , 1 , 1 , 1 ) ); 
  if (0 && 1 )
    flags = (1 << 0 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (1 << 26 ) 
  | (1 << 9 ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("unsafe-flsqrt" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 510 "bc/src/numarith.c"
void scheme_init_extfl_unsafe_numarith (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  int flags ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 515 "bc/src/numarith.c"
  p = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (unsafe_extfl_plus , "unsafe-extfl+" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl+" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_minus , "unsafe-extfl-" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl-" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_mult , "unsafe-extfl*" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl*" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_div , "unsafe-extfl/" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl/" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_abs , "unsafe-extflabs" , 1 , 1 , 1 ) ); 
  if (0 )
    flags = (1 << 0 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (3 << 26 ) 
  | (1 << 12 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extflabs" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_sqrt , "unsafe-extflsqrt" , 1 , 1 , 1 ) ); 
  if (0 )
    flags = (1 << 0 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (3 << 26 ) 
  | (1 << 12 ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("unsafe-extflsqrt" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 582 "bc/src/numarith.c"
Scheme_Object * 
scheme_add1 (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Type t ; 
  Scheme_Object * o = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1)));
# define XfOrM6_COUNT (2)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 588 "bc/src/numarith.c"
  if (((intptr_t ) (o ) ) & 0x1 )  {
    intptr_t v ; 
#   define XfOrM7_COUNT (0+XfOrM6_COUNT)
#   define SETUP_XfOrM7(x) SETUP_XfOrM6(x)

# 590 "bc/src/numarith.c"
    v = (((intptr_t ) (o ) ) >> 1 ) ; 
    if (v < 0x3FFFFFFF )
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v + 1 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    else {
      Small_Bignum b ; 
      BLOCK_SETUP((PUSH(b.o.digits, 0+XfOrM7_COUNT)));
#     define XfOrM8_COUNT (1+XfOrM7_COUNT)
#     define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
      b.o.digits = NULLED_OUT ; 

# 595 "bc/src/numarith.c"
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM8(_), scheme_bignum_add1 (scheme_make_small_bignum (v , & b ) ) )) RET_VALUE_END ; 
    }
  }
  t = ((o ) -> type ) ; 

  if (t == scheme_float_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_float ((((Scheme_Float * ) (o ) ) -> float_val ) + 1.0f ) )) RET_VALUE_EMPTY_END ; 

  if (t == scheme_double_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_double ((((Scheme_Double * ) (o ) ) -> double_val ) + 1.0 ) )) RET_VALUE_EMPTY_END ; 
  if (t == scheme_bignum_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_bignum_add1 (o ) )) RET_VALUE_EMPTY_END ; 
  if (t == scheme_rational_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_rational_add1 (o ) )) RET_VALUE_EMPTY_END ; 
  if (t == scheme_complex_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_complex_add1 (o ) )) RET_VALUE_EMPTY_END ; 
  FUNCCALL_EMPTY(scheme_wrong_contract ("add1" , "number?" , 0 , argc , argv ) )
  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 617 "bc/src/numarith.c"
Scheme_Object * 
scheme_sub1 (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Type t ; 
  Scheme_Object * o = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1)));
# define XfOrM9_COUNT (2)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 623 "bc/src/numarith.c"
  if (((intptr_t ) (o ) ) & 0x1 )  {
    intptr_t v ; 
#   define XfOrM10_COUNT (0+XfOrM9_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM9(x)

# 625 "bc/src/numarith.c"
    v = (((intptr_t ) (o ) ) >> 1 ) ; 
    if (v > - (0x3FFFFFFF ) )
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((intptr_t ) (o ) ) >> 1 ) - 1 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    else {
      Small_Bignum b ; 
      BLOCK_SETUP((PUSH(b.o.digits, 0+XfOrM10_COUNT)));
#     define XfOrM11_COUNT (1+XfOrM10_COUNT)
#     define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
      b.o.digits = NULLED_OUT ; 

# 630 "bc/src/numarith.c"
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM11(_), scheme_bignum_sub1 (scheme_make_small_bignum (v , & b ) ) )) RET_VALUE_END ; 
    }
  }
  t = ((o ) -> type ) ; 

  if (t == scheme_float_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_float ((((Scheme_Float * ) (o ) ) -> float_val ) - 1.0f ) )) RET_VALUE_EMPTY_END ; 

  if (t == scheme_double_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_double ((((Scheme_Double * ) (o ) ) -> double_val ) - 1.0 ) )) RET_VALUE_EMPTY_END ; 
  if (t == scheme_bignum_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_bignum_sub1 (o ) )) RET_VALUE_EMPTY_END ; 
  if (t == scheme_rational_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_rational_sub1 (o ) )) RET_VALUE_EMPTY_END ; 
  if (t == scheme_complex_type )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_complex_sub1 (o ) )) RET_VALUE_EMPTY_END ; 
  FUNCCALL_EMPTY(scheme_wrong_contract ("sub1" , "number?" , 0 , argc , argv ) )
  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}








static Scheme_Object * ADD_slow (intptr_t a , intptr_t b ) 
{
  Small_Bignum sa , sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0), PUSH(sa.o.digits, 1)));
# define XfOrM12_COUNT (2)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sa.o.digits = NULLED_OUT ; 
  sb.o.digits = NULLED_OUT ; 

# 666 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM12(_), scheme_bignum_add (scheme_make_small_bignum (a , & sa ) , scheme_make_small_bignum (b , & sb ) ) )) RET_VALUE_END 
  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 670 "bc/src/numarith.c"
static Scheme_Object * ADD (intptr_t a , intptr_t b ) 
{
  /* No conversion */

# 672 "bc/src/numarith.c"
  intptr_t r ; 
  Scheme_Object * o ; 

  r = (uintptr_t ) a + (uintptr_t ) b ; 

  o = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ; 
  r = (((intptr_t ) (o ) ) >> 1 ) ; 

  if (b == (uintptr_t ) r - (uintptr_t ) a )
    return o ; 
  else 
  return ADD_slow (a , b ) ; 
}

static Scheme_Object * SUBTRACT_slow (intptr_t a , intptr_t b ) 
{
  Small_Bignum sa , sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0), PUSH(sa.o.digits, 1)));
# define XfOrM14_COUNT (2)
# define SETUP_XfOrM14(x) SETUP(XfOrM14_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sa.o.digits = NULLED_OUT ; 
  sb.o.digits = NULLED_OUT ; 

# 689 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM14(_), scheme_bignum_subtract (scheme_make_small_bignum (a , & sa ) , scheme_make_small_bignum (b , & sb ) ) )) RET_VALUE_END 
  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 693 "bc/src/numarith.c"
static Scheme_Object * SUBTRACT (intptr_t a , intptr_t b ) 
{
  /* No conversion */

# 695 "bc/src/numarith.c"
  intptr_t r ; 
  Scheme_Object * o ; 

  r = (uintptr_t ) a - (uintptr_t ) b ; 

  o = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ; 
  r = (((intptr_t ) (o ) ) >> 1 ) ; 

  if (a == (uintptr_t ) r + (uintptr_t ) b )
    return o ; 
  else 
  return SUBTRACT_slow (a , b ) ; 
}

static Scheme_Object * MULTIPLY (intptr_t a , intptr_t b ) 
{
  intptr_t r ; 
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
# define XfOrM16_COUNT (0)
# define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 

# 714 "bc/src/numarith.c"
  if (! b )
    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

  r = (uintptr_t ) a * (uintptr_t ) b ; 

  o = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ; 
  r = (((intptr_t ) (o ) ) >> 1 ) ; 


  if ((b == - 1 ) 
  ? (a == (uintptr_t ) r * (uintptr_t ) - 1 ) 
  : (a == r / b ) )
    RET_VALUE_START (o ) RET_VALUE_END ; 
  else {
    Small_Bignum sa , sb ; 
    BLOCK_SETUP((PUSH(sb.o.digits, 0+XfOrM16_COUNT), PUSH(sa.o.digits, 1+XfOrM16_COUNT)));
#   define XfOrM17_COUNT (2+XfOrM16_COUNT)
#   define SETUP_XfOrM17(x) SETUP(XfOrM17_COUNT)
    sa.o.digits = NULLED_OUT ; 
    sb.o.digits = NULLED_OUT ; 

# 729 "bc/src/numarith.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM17(_), scheme_bignum_multiply (scheme_make_small_bignum (a , & sa ) , scheme_make_small_bignum (b , & sb ) ) )) RET_VALUE_END 
    ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 734 "bc/src/numarith.c"
static Scheme_Object * unary_minus (const Scheme_Object * n ) 
{
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM18_COUNT (3)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 737 "bc/src/numarith.c"
  a [0 ] = (Scheme_Object * ) n ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM18(_), minus (1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Object * scheme_bin_plus (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 745 "bc/src/numarith.c"
static Scheme_Object * scheme_bin_plus__wrong_contract (const Scheme_Object * v ) {

# 745 "bc/src/numarith.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM19_COUNT (3)
# define SETUP_XfOrM19(x) SETUP(XfOrM19_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM19(_), scheme_wrong_contract ("+" , "number?" , - 1 , 0 , a ) )
# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM20_COUNT (1)
# define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 745 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n2 ) RET_VALUE_END ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM20(_), scheme_bignum_add ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM21_COUNT (2)
# define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 745 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n2 ) RET_VALUE_END ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM21(_), scheme_rational_add ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM22_COUNT (2)
# define SETUP_XfOrM22(x) SETUP(XfOrM22_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 745 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n2 ) RET_VALUE_END ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM22(_), scheme_complex_add ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  float tmp2 ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  tmp2 = scheme_bignum_to_float (n2 ) ; 

# 745 "bc/src/numarith.c"
  return scheme_make_float (d1 + tmp2 ) ; 
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  float tmp3 ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  tmp3 = scheme_rational_to_float (n2 ) ; 

# 745 "bc/src/numarith.c"
  return scheme_make_float (d1 + tmp3 ) ; 
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__flt_comp (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM25_COUNT (2)
# define SETUP_XfOrM25(x) SETUP(XfOrM25_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM25(_), scheme_complex_add ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  double tmp4 ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  tmp4 = scheme_bignum_to_double (n2 ) ; 

# 745 "bc/src/numarith.c"
  return scheme_make_double (d1 + tmp4 ) ; 
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  double tmp5 ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  tmp5 = scheme_rational_to_double (n2 ) ; 

# 745 "bc/src/numarith.c"
  return scheme_make_double (d1 + tmp5 ) ; 
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM28_COUNT (2)
# define SETUP_XfOrM28(x) SETUP(XfOrM28_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM28(_), scheme_complex_add ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM29_COUNT (1)
# define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 745 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM29(_), scheme_bignum_add ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  float d2 ; 

# 745 "bc/src/numarith.c"
  float tmp6 ; 

# 745 "bc/src/numarith.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  tmp6 = scheme_bignum_to_float (n1 ) ; 

# 745 "bc/src/numarith.c"
  return scheme_make_float (tmp6 + d2 ) ; 
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  double d2 ; 

# 745 "bc/src/numarith.c"
  double tmp7 ; 

# 745 "bc/src/numarith.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  tmp7 = scheme_bignum_to_double (n1 ) ; 

# 745 "bc/src/numarith.c"
  return scheme_make_double (tmp7 + d2 ) ; 
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM32_COUNT (1)
# define SETUP_XfOrM32(x) SETUP(XfOrM32_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 745 "bc/src/numarith.c"
  RET_VALUE_START ((__funcarg59 = FUNCCALL(SETUP_XfOrM32(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_add (__funcarg59 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM33_COUNT (2)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM33(_), scheme_complex_add ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM34_COUNT (2)
# define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 745 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM34(_), scheme_rational_add ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  float d2 ; 

# 745 "bc/src/numarith.c"
  float tmp9 ; 

# 745 "bc/src/numarith.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  tmp9 = scheme_rational_to_float (n1 ) ; 

# 745 "bc/src/numarith.c"
  return scheme_make_float (tmp9 + d2 ) ; 
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  double d2 ; 

# 745 "bc/src/numarith.c"
  double tmp10 ; 

# 745 "bc/src/numarith.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  tmp10 = scheme_rational_to_double (n1 ) ; 

# 745 "bc/src/numarith.c"
  return scheme_make_double (tmp10 + d2 ) ; 
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM37_COUNT (1)
# define SETUP_XfOrM37(x) SETUP(XfOrM37_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 745 "bc/src/numarith.c"
  RET_VALUE_START ((__funcarg60 = FUNCCALL(SETUP_XfOrM37(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_add ((n1 ) , __funcarg60 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM38_COUNT (2)
# define SETUP_XfOrM38(x) SETUP(XfOrM38_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM38(_), scheme_complex_add ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM39_COUNT (2)
# define SETUP_XfOrM39(x) SETUP(XfOrM39_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 745 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM39(_), scheme_complex_add ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__comp_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM40_COUNT (2)
# define SETUP_XfOrM40(x) SETUP(XfOrM40_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM40(_), scheme_complex_add ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM41_COUNT (2)
# define SETUP_XfOrM41(x) SETUP(XfOrM41_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM41(_), scheme_complex_add ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM42_COUNT (2)
# define SETUP_XfOrM42(x) SETUP(XfOrM42_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM42(_), scheme_complex_add ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_plus__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 745 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM43_COUNT (2)
# define SETUP_XfOrM43(x) SETUP(XfOrM43_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 745 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM43(_), scheme_complex_add ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 745 "bc/src/numarith.c"
Scheme_Object * scheme_bin_plus (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 745 "bc/src/numarith.c"
  Scheme_Type t1 , t2 ; 

# 745 "bc/src/numarith.c"
  if (n2 == ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )

# 745 "bc/src/numarith.c"
  return (Scheme_Object * ) n1 ; 

# 745 "bc/src/numarith.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 745 "bc/src/numarith.c"
    if (n1 == ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )

# 745 "bc/src/numarith.c"
    return (Scheme_Object * ) n2 ; 

# 745 "bc/src/numarith.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 745 "bc/src/numarith.c"
    return ADD ((((intptr_t ) (n1 ) ) >> 1 ) , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 745 "bc/src/numarith.c"
    t2 = ((n2 ) -> type ) ; 

# 745 "bc/src/numarith.c"
    if (t2 == scheme_float_type ) {

# 745 "bc/src/numarith.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 745 "bc/src/numarith.c"
      ; 

# 745 "bc/src/numarith.c"
      return scheme_make_float ((((intptr_t ) (n1 ) ) >> 1 ) + d ) ; 
    }

# 745 "bc/src/numarith.c"
    if (t2 == scheme_double_type ) {

# 745 "bc/src/numarith.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 745 "bc/src/numarith.c"
      ; 

# 745 "bc/src/numarith.c"
      return scheme_make_double ((((intptr_t ) (n1 ) ) >> 1 ) + d ) ; 
    }

# 745 "bc/src/numarith.c"
    if (t2 == scheme_bignum_type ) {

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__int_big (n1 , n2 ) ; 
    }

# 745 "bc/src/numarith.c"
    if (t2 == scheme_rational_type ) {

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__int_rat (n1 , n2 ) ; 
    }

# 745 "bc/src/numarith.c"
    if (t2 == scheme_complex_type )  {

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__int_comp (n1 , n2 ) ; 
    }

# 745 "bc/src/numarith.c"
    return scheme_bin_plus__wrong_contract (n2 ) ; 
  }

# 745 "bc/src/numarith.c"
  else {

# 745 "bc/src/numarith.c"
    t1 = ((n1 ) -> type ) ; 

# 745 "bc/src/numarith.c"
    if (t1 == scheme_float_type ) {

# 745 "bc/src/numarith.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 745 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        return scheme_make_float (d1 + (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 745 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 745 "bc/src/numarith.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        return scheme_make_float (d1 + d2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 745 "bc/src/numarith.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        return scheme_make_double (d1 + d2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__flt_big (d1 , n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_rational_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__flt_rat (d1 , n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__flt_comp (d1 , n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__wrong_contract (n2 ) ; 
    }

# 745 "bc/src/numarith.c"
    else if (t1 == scheme_double_type ) {

# 745 "bc/src/numarith.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 745 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        return scheme_make_double (d1 + (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 745 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 745 "bc/src/numarith.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        return scheme_make_double (d1 + d2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 745 "bc/src/numarith.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        ; 

# 745 "bc/src/numarith.c"
        return scheme_make_double (d1 + d2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__dbl_big (d1 , n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_rational_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__dbl_comp (d1 , n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__wrong_contract (n2 ) ; 
    }

# 745 "bc/src/numarith.c"
    else if (t1 == scheme_bignum_type ) {

# 745 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__big_int (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__big_flt (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__big_dbl (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 745 "bc/src/numarith.c"
      return scheme_bignum_add ((n1 ) , (n2 ) ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__big_rat (n1 , n2 ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__big_comp (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__wrong_contract (n2 ) ; 
    }

# 745 "bc/src/numarith.c"
    else if (t1 == scheme_rational_type ) {

# 745 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__rat_int (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__rat_flt (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__rat_dbl (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__rat_big (n1 , n2 ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 745 "bc/src/numarith.c"
      return scheme_rational_add ((n1 ) , (n2 ) ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__rat_comp (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__wrong_contract (n2 ) ; 
    }

# 745 "bc/src/numarith.c"
    else if (t1 == scheme_complex_type )  {

# 745 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__comp_int (n1 , n2 ) ; 

# 745 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__comp_flt (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 745 "bc/src/numarith.c"
        return scheme_bin_plus__comp_dbl (n1 , n2 ) ; 
      }

# 745 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__comp_big (n1 , n2 ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__comp_rat (n1 , n2 ) ; 

# 745 "bc/src/numarith.c"
      if (t2 == scheme_complex_type ) 

# 745 "bc/src/numarith.c"
      return scheme_complex_add ((n1 ) , (n2 ) ) ; 

# 745 "bc/src/numarith.c"
      return scheme_bin_plus__wrong_contract (n2 ) ; 
    }

# 745 "bc/src/numarith.c"
    else return scheme_bin_plus__wrong_contract (n1 ) ; 
  }
}

# 746 "bc/src/numarith.c"
Scheme_Object * scheme_bin_minus (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 746 "bc/src/numarith.c"
static Scheme_Object * scheme_bin_minus__wrong_contract (const Scheme_Object * v ) {

# 746 "bc/src/numarith.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM79_COUNT (3)
# define SETUP_XfOrM79(x) SETUP(XfOrM79_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM79(_), scheme_wrong_contract ("-" , "number?" , - 1 , 0 , a ) )
# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM80_COUNT (1)
# define SETUP_XfOrM80(x) SETUP(XfOrM80_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM80(_), scheme_bignum_subtract ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM81_COUNT (2)
# define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM81(_), scheme_rational_subtract ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM82_COUNT (2)
# define SETUP_XfOrM82(x) SETUP(XfOrM82_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM82(_), scheme_complex_subtract ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  float tmp2 ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  tmp2 = scheme_bignum_to_float (n2 ) ; 

# 746 "bc/src/numarith.c"
  return scheme_make_float (d1 - tmp2 ) ; 
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  float tmp3 ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  tmp3 = scheme_rational_to_float (n2 ) ; 

# 746 "bc/src/numarith.c"
  return scheme_make_float (d1 - tmp3 ) ; 
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__flt_comp (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM85_COUNT (2)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM85(_), scheme_complex_subtract ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  double tmp4 ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  tmp4 = scheme_bignum_to_double (n2 ) ; 

# 746 "bc/src/numarith.c"
  return scheme_make_double (d1 - tmp4 ) ; 
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  double tmp5 ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  tmp5 = scheme_rational_to_double (n2 ) ; 

# 746 "bc/src/numarith.c"
  return scheme_make_double (d1 - tmp5 ) ; 
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM88_COUNT (2)
# define SETUP_XfOrM88(x) SETUP(XfOrM88_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM88(_), scheme_complex_subtract ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM89_COUNT (1)
# define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 746 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM89(_), scheme_bignum_subtract ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  float d2 ; 

# 746 "bc/src/numarith.c"
  float tmp6 ; 

# 746 "bc/src/numarith.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  tmp6 = scheme_bignum_to_float (n1 ) ; 

# 746 "bc/src/numarith.c"
  return scheme_make_float (tmp6 - d2 ) ; 
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  double d2 ; 

# 746 "bc/src/numarith.c"
  double tmp7 ; 

# 746 "bc/src/numarith.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  tmp7 = scheme_bignum_to_double (n1 ) ; 

# 746 "bc/src/numarith.c"
  return scheme_make_double (tmp7 - d2 ) ; 
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM92_COUNT (1)
# define SETUP_XfOrM92(x) SETUP(XfOrM92_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 746 "bc/src/numarith.c"
  RET_VALUE_START ((__funcarg61 = FUNCCALL(SETUP_XfOrM92(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_subtract (__funcarg61 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM93_COUNT (2)
# define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM93(_), scheme_complex_subtract ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM94_COUNT (2)
# define SETUP_XfOrM94(x) SETUP(XfOrM94_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 746 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM94(_), scheme_rational_subtract ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  float d2 ; 

# 746 "bc/src/numarith.c"
  float tmp9 ; 

# 746 "bc/src/numarith.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  tmp9 = scheme_rational_to_float (n1 ) ; 

# 746 "bc/src/numarith.c"
  return scheme_make_float (tmp9 - d2 ) ; 
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  double d2 ; 

# 746 "bc/src/numarith.c"
  double tmp10 ; 

# 746 "bc/src/numarith.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  tmp10 = scheme_rational_to_double (n1 ) ; 

# 746 "bc/src/numarith.c"
  return scheme_make_double (tmp10 - d2 ) ; 
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM97_COUNT (1)
# define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 746 "bc/src/numarith.c"
  RET_VALUE_START ((__funcarg62 = FUNCCALL(SETUP_XfOrM97(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_subtract ((n1 ) , __funcarg62 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM98_COUNT (2)
# define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM98(_), scheme_complex_subtract ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM99_COUNT (2)
# define SETUP_XfOrM99(x) SETUP(XfOrM99_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 746 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM99(_), scheme_complex_subtract ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__comp_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM100_COUNT (2)
# define SETUP_XfOrM100(x) SETUP(XfOrM100_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM100(_), scheme_complex_subtract ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM101_COUNT (2)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM101(_), scheme_complex_subtract ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM102_COUNT (2)
# define SETUP_XfOrM102(x) SETUP(XfOrM102_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM102(_), scheme_complex_subtract ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_minus__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 746 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM103_COUNT (2)
# define SETUP_XfOrM103(x) SETUP(XfOrM103_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 746 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM103(_), scheme_complex_subtract ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 746 "bc/src/numarith.c"
Scheme_Object * scheme_bin_minus (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 746 "bc/src/numarith.c"
  Scheme_Type t1 , t2 ; 

# 746 "bc/src/numarith.c"
  if (n2 == ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )

# 746 "bc/src/numarith.c"
  return (Scheme_Object * ) n1 ; 

# 746 "bc/src/numarith.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 746 "bc/src/numarith.c"
    if (n1 == ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )

# 746 "bc/src/numarith.c"
    if (((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) || ((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 746 "bc/src/numarith.c"
    return unary_minus (n2 ) ; 

# 746 "bc/src/numarith.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 746 "bc/src/numarith.c"
    return SUBTRACT ((((intptr_t ) (n1 ) ) >> 1 ) , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 746 "bc/src/numarith.c"
    t2 = ((n2 ) -> type ) ; 

# 746 "bc/src/numarith.c"
    if (t2 == scheme_float_type ) {

# 746 "bc/src/numarith.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 746 "bc/src/numarith.c"
      ; 

# 746 "bc/src/numarith.c"
      return scheme_make_float ((((intptr_t ) (n1 ) ) >> 1 ) - d ) ; 
    }

# 746 "bc/src/numarith.c"
    if (t2 == scheme_double_type ) {

# 746 "bc/src/numarith.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 746 "bc/src/numarith.c"
      ; 

# 746 "bc/src/numarith.c"
      return scheme_make_double ((((intptr_t ) (n1 ) ) >> 1 ) - d ) ; 
    }

# 746 "bc/src/numarith.c"
    if (t2 == scheme_bignum_type ) {

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__int_big (n1 , n2 ) ; 
    }

# 746 "bc/src/numarith.c"
    if (t2 == scheme_rational_type ) {

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__int_rat (n1 , n2 ) ; 
    }

# 746 "bc/src/numarith.c"
    if (t2 == scheme_complex_type )  {

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__int_comp (n1 , n2 ) ; 
    }

# 746 "bc/src/numarith.c"
    return scheme_bin_minus__wrong_contract (n2 ) ; 
  }

# 746 "bc/src/numarith.c"
  else {

# 746 "bc/src/numarith.c"
    t1 = ((n1 ) -> type ) ; 

# 746 "bc/src/numarith.c"
    if (t1 == scheme_float_type ) {

# 746 "bc/src/numarith.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 746 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        return scheme_make_float (d1 - (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 746 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 746 "bc/src/numarith.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        return scheme_make_float (d1 - d2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 746 "bc/src/numarith.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        return scheme_make_double (d1 - d2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__flt_big (d1 , n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_rational_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__flt_rat (d1 , n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__flt_comp (d1 , n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__wrong_contract (n2 ) ; 
    }

# 746 "bc/src/numarith.c"
    else if (t1 == scheme_double_type ) {

# 746 "bc/src/numarith.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 746 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        return scheme_make_double (d1 - (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 746 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 746 "bc/src/numarith.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        return scheme_make_double (d1 - d2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 746 "bc/src/numarith.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        ; 

# 746 "bc/src/numarith.c"
        return scheme_make_double (d1 - d2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__dbl_big (d1 , n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_rational_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__dbl_comp (d1 , n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__wrong_contract (n2 ) ; 
    }

# 746 "bc/src/numarith.c"
    else if (t1 == scheme_bignum_type ) {

# 746 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__big_int (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__big_flt (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__big_dbl (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 746 "bc/src/numarith.c"
      return scheme_bignum_subtract ((n1 ) , (n2 ) ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__big_rat (n1 , n2 ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__big_comp (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__wrong_contract (n2 ) ; 
    }

# 746 "bc/src/numarith.c"
    else if (t1 == scheme_rational_type ) {

# 746 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__rat_int (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__rat_flt (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__rat_dbl (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__rat_big (n1 , n2 ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 746 "bc/src/numarith.c"
      return scheme_rational_subtract ((n1 ) , (n2 ) ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__rat_comp (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__wrong_contract (n2 ) ; 
    }

# 746 "bc/src/numarith.c"
    else if (t1 == scheme_complex_type )  {

# 746 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__comp_int (n1 , n2 ) ; 

# 746 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__comp_flt (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 746 "bc/src/numarith.c"
        return scheme_bin_minus__comp_dbl (n1 , n2 ) ; 
      }

# 746 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__comp_big (n1 , n2 ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__comp_rat (n1 , n2 ) ; 

# 746 "bc/src/numarith.c"
      if (t2 == scheme_complex_type ) 

# 746 "bc/src/numarith.c"
      return scheme_complex_subtract ((n1 ) , (n2 ) ) ; 

# 746 "bc/src/numarith.c"
      return scheme_bin_minus__wrong_contract (n2 ) ; 
    }

# 746 "bc/src/numarith.c"
    else return scheme_bin_minus__wrong_contract (n1 ) ; 
  }
}

# 747 "bc/src/numarith.c"
Scheme_Object * scheme_bin_mult (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 747 "bc/src/numarith.c"
static Scheme_Object * scheme_bin_mult__wrong_contract (const Scheme_Object * v ) {

# 747 "bc/src/numarith.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM139_COUNT (3)
# define SETUP_XfOrM139(x) SETUP(XfOrM139_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM139(_), scheme_wrong_contract ("*" , "number?" , - 1 , 0 , a ) )
# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM140_COUNT (1)
# define SETUP_XfOrM140(x) SETUP(XfOrM140_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n2 ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM140(_), scheme_bignum_multiply ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM141_COUNT (2)
# define SETUP_XfOrM141(x) SETUP(XfOrM141_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n2 ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM141(_), scheme_rational_multiply ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM142_COUNT (2)
# define SETUP_XfOrM142(x) SETUP(XfOrM142_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n2 ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM142(_), scheme_complex_multiply ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  float tmp2 ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  tmp2 = scheme_bignum_to_float (n2 ) ; 

# 747 "bc/src/numarith.c"
  return scheme_make_float (d1 * tmp2 ) ; 
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  float tmp3 ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  tmp3 = scheme_rational_to_float (n2 ) ; 

# 747 "bc/src/numarith.c"
  return scheme_make_float (d1 * tmp3 ) ; 
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__flt_comp (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM145_COUNT (2)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM145(_), scheme_complex_multiply ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  double tmp4 ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  tmp4 = scheme_bignum_to_double (n2 ) ; 

# 747 "bc/src/numarith.c"
  return scheme_make_double (d1 * tmp4 ) ; 
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  double tmp5 ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  tmp5 = scheme_rational_to_double (n2 ) ; 

# 747 "bc/src/numarith.c"
  return scheme_make_double (d1 * tmp5 ) ; 
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM148_COUNT (2)
# define SETUP_XfOrM148(x) SETUP(XfOrM148_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM148(_), scheme_complex_multiply ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM149_COUNT (1)
# define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM149(_), scheme_bignum_multiply ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  float d2 ; 

# 747 "bc/src/numarith.c"
  float tmp6 ; 

# 747 "bc/src/numarith.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  tmp6 = scheme_bignum_to_float (n1 ) ; 

# 747 "bc/src/numarith.c"
  return scheme_make_float (tmp6 * d2 ) ; 
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  double d2 ; 

# 747 "bc/src/numarith.c"
  double tmp7 ; 

# 747 "bc/src/numarith.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  tmp7 = scheme_bignum_to_double (n1 ) ; 

# 747 "bc/src/numarith.c"
  return scheme_make_double (tmp7 * d2 ) ; 
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM152_COUNT (1)
# define SETUP_XfOrM152(x) SETUP(XfOrM152_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 747 "bc/src/numarith.c"
  RET_VALUE_START ((__funcarg63 = FUNCCALL(SETUP_XfOrM152(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_multiply (__funcarg63 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM153_COUNT (2)
# define SETUP_XfOrM153(x) SETUP(XfOrM153_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM153(_), scheme_complex_multiply ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM154_COUNT (2)
# define SETUP_XfOrM154(x) SETUP(XfOrM154_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM154(_), scheme_rational_multiply ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  float d2 ; 

# 747 "bc/src/numarith.c"
  float tmp9 ; 

# 747 "bc/src/numarith.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  tmp9 = scheme_rational_to_float (n1 ) ; 

# 747 "bc/src/numarith.c"
  return scheme_make_float (tmp9 * d2 ) ; 
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  double d2 ; 

# 747 "bc/src/numarith.c"
  double tmp10 ; 

# 747 "bc/src/numarith.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  tmp10 = scheme_rational_to_double (n1 ) ; 

# 747 "bc/src/numarith.c"
  return scheme_make_double (tmp10 * d2 ) ; 
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM157_COUNT (1)
# define SETUP_XfOrM157(x) SETUP(XfOrM157_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 747 "bc/src/numarith.c"
  RET_VALUE_START ((__funcarg64 = FUNCCALL(SETUP_XfOrM157(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_multiply ((n1 ) , __funcarg64 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM158_COUNT (2)
# define SETUP_XfOrM158(x) SETUP(XfOrM158_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM158(_), scheme_complex_multiply ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM159_COUNT (2)
# define SETUP_XfOrM159(x) SETUP(XfOrM159_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 747 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM159(_), scheme_complex_multiply ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__comp_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM160_COUNT (2)
# define SETUP_XfOrM160(x) SETUP(XfOrM160_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM160(_), scheme_complex_multiply ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM161_COUNT (2)
# define SETUP_XfOrM161(x) SETUP(XfOrM161_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM161(_), scheme_complex_multiply ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM162_COUNT (2)
# define SETUP_XfOrM162(x) SETUP(XfOrM162_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM162(_), scheme_complex_multiply ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_mult__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 747 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM163_COUNT (2)
# define SETUP_XfOrM163(x) SETUP(XfOrM163_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 747 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM163(_), scheme_complex_multiply ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "bc/src/numarith.c"
Scheme_Object * scheme_bin_mult (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 747 "bc/src/numarith.c"
  Scheme_Type t1 , t2 ; 

# 747 "bc/src/numarith.c"
  if (n2 == ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )

# 747 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

# 747 "bc/src/numarith.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 747 "bc/src/numarith.c"
    if (n1 == ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )

# 747 "bc/src/numarith.c"
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

# 747 "bc/src/numarith.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 747 "bc/src/numarith.c"
    return MULTIPLY ((((intptr_t ) (n1 ) ) >> 1 ) , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 747 "bc/src/numarith.c"
    t2 = ((n2 ) -> type ) ; 

# 747 "bc/src/numarith.c"
    if (t2 == scheme_float_type ) {

# 747 "bc/src/numarith.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 747 "bc/src/numarith.c"
      ; 

# 747 "bc/src/numarith.c"
      return scheme_make_float ((((intptr_t ) (n1 ) ) >> 1 ) * d ) ; 
    }

# 747 "bc/src/numarith.c"
    if (t2 == scheme_double_type ) {

# 747 "bc/src/numarith.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 747 "bc/src/numarith.c"
      ; 

# 747 "bc/src/numarith.c"
      return scheme_make_double ((((intptr_t ) (n1 ) ) >> 1 ) * d ) ; 
    }

# 747 "bc/src/numarith.c"
    if (t2 == scheme_bignum_type ) {

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__int_big (n1 , n2 ) ; 
    }

# 747 "bc/src/numarith.c"
    if (t2 == scheme_rational_type ) {

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__int_rat (n1 , n2 ) ; 
    }

# 747 "bc/src/numarith.c"
    if (t2 == scheme_complex_type )  {

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__int_comp (n1 , n2 ) ; 
    }

# 747 "bc/src/numarith.c"
    return scheme_bin_mult__wrong_contract (n2 ) ; 
  }

# 747 "bc/src/numarith.c"
  else {

# 747 "bc/src/numarith.c"
    t1 = ((n1 ) -> type ) ; 

# 747 "bc/src/numarith.c"
    if (t1 == scheme_float_type ) {

# 747 "bc/src/numarith.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 747 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        return scheme_make_float (d1 * (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 747 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 747 "bc/src/numarith.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        return scheme_make_float (d1 * d2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 747 "bc/src/numarith.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        return scheme_make_double (d1 * d2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__flt_big (d1 , n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_rational_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__flt_rat (d1 , n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__flt_comp (d1 , n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__wrong_contract (n2 ) ; 
    }

# 747 "bc/src/numarith.c"
    else if (t1 == scheme_double_type ) {

# 747 "bc/src/numarith.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 747 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        return scheme_make_double (d1 * (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 747 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 747 "bc/src/numarith.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        return scheme_make_double (d1 * d2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 747 "bc/src/numarith.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        ; 

# 747 "bc/src/numarith.c"
        return scheme_make_double (d1 * d2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__dbl_big (d1 , n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_rational_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__dbl_comp (d1 , n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__wrong_contract (n2 ) ; 
    }

# 747 "bc/src/numarith.c"
    else if (t1 == scheme_bignum_type ) {

# 747 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__big_int (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__big_flt (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__big_dbl (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 747 "bc/src/numarith.c"
      return scheme_bignum_multiply ((n1 ) , (n2 ) ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__big_rat (n1 , n2 ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__big_comp (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__wrong_contract (n2 ) ; 
    }

# 747 "bc/src/numarith.c"
    else if (t1 == scheme_rational_type ) {

# 747 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__rat_int (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__rat_flt (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__rat_dbl (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__rat_big (n1 , n2 ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 747 "bc/src/numarith.c"
      return scheme_rational_multiply ((n1 ) , (n2 ) ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__rat_comp (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__wrong_contract (n2 ) ; 
    }

# 747 "bc/src/numarith.c"
    else if (t1 == scheme_complex_type )  {

# 747 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__comp_int (n1 , n2 ) ; 

# 747 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__comp_flt (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 747 "bc/src/numarith.c"
        return scheme_bin_mult__comp_dbl (n1 , n2 ) ; 
      }

# 747 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__comp_big (n1 , n2 ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__comp_rat (n1 , n2 ) ; 

# 747 "bc/src/numarith.c"
      if (t2 == scheme_complex_type ) 

# 747 "bc/src/numarith.c"
      return scheme_complex_multiply ((n1 ) , (n2 ) ) ; 

# 747 "bc/src/numarith.c"
      return scheme_bin_mult__wrong_contract (n2 ) ; 
    }

# 747 "bc/src/numarith.c"
    else return scheme_bin_mult__wrong_contract (n1 ) ; 
  }
}

# 748 "bc/src/numarith.c"
Scheme_Object * scheme_bin_div (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 748 "bc/src/numarith.c"
static Scheme_Object * scheme_bin_div__wrong_contract (const Scheme_Object * v ) {

# 748 "bc/src/numarith.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM199_COUNT (3)
# define SETUP_XfOrM199(x) SETUP(XfOrM199_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM199(_), scheme_wrong_contract ("/" , "number?" , - 1 , 0 , a ) )
# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM200_COUNT (1)
# define SETUP_XfOrM200(x) SETUP(XfOrM200_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM200(_), scheme_make_rational ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM201_COUNT (2)
# define SETUP_XfOrM201(x) SETUP(XfOrM201_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM201(_), scheme_rational_divide ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM202_COUNT (2)
# define SETUP_XfOrM202(x) SETUP(XfOrM202_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  if ((n1 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM202(_), scheme_complex_divide ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  float tmp2 ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 748 "bc/src/numarith.c"
  return (scheme_is_positive (n2 ) ? scheme_single_inf_object : scheme_single_minus_inf_object ) ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n2 ) ? scheme_single_inf_object : scheme_single_minus_inf_object ) ; 

# 748 "bc/src/numarith.c"
  tmp2 = scheme_bignum_to_float (n2 ) ; 

# 748 "bc/src/numarith.c"
  return scheme_make_float ((float ) d1 / (float ) tmp2 ) ; 
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  float tmp3 ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 748 "bc/src/numarith.c"
  return (scheme_is_positive (n2 ) ? scheme_single_inf_object : scheme_single_minus_inf_object ) ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n2 ) ? scheme_single_inf_object : scheme_single_minus_inf_object ) ; 

# 748 "bc/src/numarith.c"
  if (d1 == 0.0 )

# 748 "bc/src/numarith.c"
  return (scheme_minus_zero_p (d1 ) ? (! scheme_is_positive (n2 ) ? scheme_zerof : scheme_nzerof ) : (! scheme_is_positive (n2 ) ? scheme_nzerof : scheme_zerof ) ) ; 

# 748 "bc/src/numarith.c"
  tmp3 = scheme_rational_to_float (n2 ) ; 

# 748 "bc/src/numarith.c"
  return scheme_make_float ((float ) d1 / (float ) tmp3 ) ; 
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__flt_comp (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM205_COUNT (2)
# define SETUP_XfOrM205(x) SETUP(XfOrM205_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM205(_), scheme_complex_divide ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  double tmp4 ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 748 "bc/src/numarith.c"
  return (scheme_is_positive (n2 ) ? scheme_inf_object : scheme_minus_inf_object ) ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n2 ) ? scheme_inf_object : scheme_minus_inf_object ) ; 

# 748 "bc/src/numarith.c"
  tmp4 = scheme_bignum_to_double (n2 ) ; 

# 748 "bc/src/numarith.c"
  return scheme_make_double ((double ) d1 / (double ) tmp4 ) ; 
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  double tmp5 ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 748 "bc/src/numarith.c"
  return (scheme_is_positive (n2 ) ? scheme_inf_object : scheme_minus_inf_object ) ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n2 ) ? scheme_inf_object : scheme_minus_inf_object ) ; 

# 748 "bc/src/numarith.c"
  if (d1 == 0.0 )

# 748 "bc/src/numarith.c"
  return (scheme_minus_zero_p (d1 ) ? (! scheme_is_positive (n2 ) ? scheme_zerod : scheme_nzerod ) : (! scheme_is_positive (n2 ) ? scheme_nzerod : scheme_zerod ) ) ; 

# 748 "bc/src/numarith.c"
  tmp5 = scheme_rational_to_double (n2 ) ; 

# 748 "bc/src/numarith.c"
  return scheme_make_double ((double ) d1 / (double ) tmp5 ) ; 
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM208_COUNT (2)
# define SETUP_XfOrM208(x) SETUP(XfOrM208_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM208(_), scheme_complex_divide ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM209_COUNT (1)
# define SETUP_XfOrM209(x) SETUP(XfOrM209_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 748 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM209(_), scheme_make_rational ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  float d2 ; 

# 748 "bc/src/numarith.c"
  float tmp6 ; 

# 748 "bc/src/numarith.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n1 ) ? scheme_nzerof : scheme_zerof ) ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n1 ) ? scheme_zerof : scheme_nzerof ) ; 

# 748 "bc/src/numarith.c"
  tmp6 = scheme_bignum_to_float (n1 ) ; 

# 748 "bc/src/numarith.c"
  return scheme_make_float ((float ) tmp6 / (float ) d2 ) ; 
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  double d2 ; 

# 748 "bc/src/numarith.c"
  double tmp7 ; 

# 748 "bc/src/numarith.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n1 ) ? scheme_nzerod : scheme_zerod ) ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n1 ) ? scheme_zerod : scheme_nzerod ) ; 

# 748 "bc/src/numarith.c"
  tmp7 = scheme_bignum_to_double (n1 ) ; 

# 748 "bc/src/numarith.c"
  return scheme_make_double ((double ) tmp7 / (double ) d2 ) ; 
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM212_COUNT (1)
# define SETUP_XfOrM212(x) SETUP(XfOrM212_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 748 "bc/src/numarith.c"
  RET_VALUE_START ((__funcarg65 = FUNCCALL(SETUP_XfOrM212(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_divide (__funcarg65 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM213_COUNT (2)
# define SETUP_XfOrM213(x) SETUP(XfOrM213_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM213(_), scheme_complex_divide ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM214_COUNT (2)
# define SETUP_XfOrM214(x) SETUP(XfOrM214_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 748 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM214(_), scheme_rational_divide ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  float d2 ; 

# 748 "bc/src/numarith.c"
  float tmp9 ; 

# 748 "bc/src/numarith.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n1 ) ? scheme_nzerof : scheme_zerof ) ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n1 ) ? scheme_zerof : scheme_nzerof ) ; 

# 748 "bc/src/numarith.c"
  if (d2 == 0.0 )

# 748 "bc/src/numarith.c"
  return (scheme_minus_zero_p (d2 ) ? (! scheme_is_positive (n1 ) ? scheme_single_inf_object : scheme_single_minus_inf_object ) : (scheme_is_positive (n1 ) ? scheme_single_inf_object : scheme_single_minus_inf_object ) ) ; 

# 748 "bc/src/numarith.c"
  tmp9 = scheme_rational_to_float (n1 ) ; 

# 748 "bc/src/numarith.c"
  return scheme_make_float ((float ) tmp9 / (float ) d2 ) ; 
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  double d2 ; 

# 748 "bc/src/numarith.c"
  double tmp10 ; 

# 748 "bc/src/numarith.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n1 ) ? scheme_nzerod : scheme_zerod ) ; 

# 748 "bc/src/numarith.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 748 "bc/src/numarith.c"
  return (! scheme_is_positive (n1 ) ? scheme_zerod : scheme_nzerod ) ; 

# 748 "bc/src/numarith.c"
  if (d2 == 0.0 )

# 748 "bc/src/numarith.c"
  return (scheme_minus_zero_p (d2 ) ? (! scheme_is_positive (n1 ) ? scheme_inf_object : scheme_minus_inf_object ) : (scheme_is_positive (n1 ) ? scheme_inf_object : scheme_minus_inf_object ) ) ; 

# 748 "bc/src/numarith.c"
  tmp10 = scheme_rational_to_double (n1 ) ; 

# 748 "bc/src/numarith.c"
  return scheme_make_double ((double ) tmp10 / (double ) d2 ) ; 
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM217_COUNT (1)
# define SETUP_XfOrM217(x) SETUP(XfOrM217_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 748 "bc/src/numarith.c"
  RET_VALUE_START ((__funcarg66 = FUNCCALL(SETUP_XfOrM217(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_divide ((n1 ) , __funcarg66 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM218_COUNT (2)
# define SETUP_XfOrM218(x) SETUP(XfOrM218_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM218(_), scheme_complex_divide ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM219_COUNT (2)
# define SETUP_XfOrM219(x) SETUP(XfOrM219_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  if ((n2 ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) 

# 748 "bc/src/numarith.c"
  RET_VALUE_START ((Scheme_Object * ) n1 ) RET_VALUE_END ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM219(_), scheme_complex_divide ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__comp_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM220_COUNT (2)
# define SETUP_XfOrM220(x) SETUP(XfOrM220_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM220(_), scheme_complex_divide ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM221_COUNT (2)
# define SETUP_XfOrM221(x) SETUP(XfOrM221_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM221(_), scheme_complex_divide ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM222_COUNT (2)
# define SETUP_XfOrM222(x) SETUP(XfOrM222_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM222(_), scheme_complex_divide ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
static inline Scheme_Object * scheme_bin_div__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 748 "bc/src/numarith.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM223_COUNT (2)
# define SETUP_XfOrM223(x) SETUP(XfOrM223_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 748 "bc/src/numarith.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM223(_), scheme_complex_divide ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 748 "bc/src/numarith.c"
Scheme_Object * scheme_bin_div (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 748 "bc/src/numarith.c"
  Scheme_Type t1 , t2 ; 

# 748 "bc/src/numarith.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 748 "bc/src/numarith.c"
    if (n1 == ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )

# 748 "bc/src/numarith.c"
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

# 748 "bc/src/numarith.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 748 "bc/src/numarith.c"
    return scheme_make_fixnum_rational ((((intptr_t ) (n1 ) ) >> 1 ) , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 748 "bc/src/numarith.c"
    t2 = ((n2 ) -> type ) ; 

# 748 "bc/src/numarith.c"
    if (t2 == scheme_float_type ) {

# 748 "bc/src/numarith.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 748 "bc/src/numarith.c"
      ; 

# 748 "bc/src/numarith.c"
      return scheme_make_float ((float ) (((intptr_t ) (n1 ) ) >> 1 ) / (float ) d ) ; 
    }

# 748 "bc/src/numarith.c"
    if (t2 == scheme_double_type ) {

# 748 "bc/src/numarith.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 748 "bc/src/numarith.c"
      ; 

# 748 "bc/src/numarith.c"
      return scheme_make_double ((double ) (((intptr_t ) (n1 ) ) >> 1 ) / (double ) d ) ; 
    }

# 748 "bc/src/numarith.c"
    if (t2 == scheme_bignum_type ) {

# 748 "bc/src/numarith.c"
      return scheme_bin_div__int_big (n1 , n2 ) ; 
    }

# 748 "bc/src/numarith.c"
    if (t2 == scheme_rational_type ) {

# 748 "bc/src/numarith.c"
      return scheme_bin_div__int_rat (n1 , n2 ) ; 
    }

# 748 "bc/src/numarith.c"
    if (t2 == scheme_complex_type )  {

# 748 "bc/src/numarith.c"
      return scheme_bin_div__int_comp (n1 , n2 ) ; 
    }

# 748 "bc/src/numarith.c"
    return scheme_bin_div__wrong_contract (n2 ) ; 
  }

# 748 "bc/src/numarith.c"
  else {

# 748 "bc/src/numarith.c"
    t1 = ((n1 ) -> type ) ; 

# 748 "bc/src/numarith.c"
    if (t1 == scheme_float_type ) {

# 748 "bc/src/numarith.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 748 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        return scheme_make_float ((float ) d1 / (float ) (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 748 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 748 "bc/src/numarith.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        return scheme_make_float ((float ) d1 / (float ) d2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 748 "bc/src/numarith.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        return scheme_make_double ((double ) d1 / (double ) d2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__flt_big (d1 , n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_rational_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__flt_rat (d1 , n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__flt_comp (d1 , n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      return scheme_bin_div__wrong_contract (n2 ) ; 
    }

# 748 "bc/src/numarith.c"
    else if (t1 == scheme_double_type ) {

# 748 "bc/src/numarith.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 748 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        return scheme_make_double ((double ) d1 / (double ) (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 748 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 748 "bc/src/numarith.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        return scheme_make_double ((double ) d1 / (double ) d2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 748 "bc/src/numarith.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        ; 

# 748 "bc/src/numarith.c"
        return scheme_make_double ((double ) d1 / (double ) d2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__dbl_big (d1 , n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_rational_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__dbl_comp (d1 , n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      return scheme_bin_div__wrong_contract (n2 ) ; 
    }

# 748 "bc/src/numarith.c"
    else if (t1 == scheme_bignum_type ) {

# 748 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__big_int (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__big_flt (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__big_dbl (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 748 "bc/src/numarith.c"
      return scheme_make_rational ((n1 ) , (n2 ) ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 748 "bc/src/numarith.c"
      return scheme_bin_div__big_rat (n1 , n2 ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__big_comp (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      return scheme_bin_div__wrong_contract (n2 ) ; 
    }

# 748 "bc/src/numarith.c"
    else if (t1 == scheme_rational_type ) {

# 748 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__rat_int (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__rat_flt (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__rat_dbl (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 748 "bc/src/numarith.c"
      return scheme_bin_div__rat_big (n1 , n2 ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 748 "bc/src/numarith.c"
      return scheme_rational_divide ((n1 ) , (n2 ) ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_complex_type )  {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__rat_comp (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      return scheme_bin_div__wrong_contract (n2 ) ; 
    }

# 748 "bc/src/numarith.c"
    else if (t1 == scheme_complex_type )  {

# 748 "bc/src/numarith.c"
      if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 748 "bc/src/numarith.c"
      return scheme_bin_div__comp_int (n1 , n2 ) ; 

# 748 "bc/src/numarith.c"
      t2 = ((n2 ) -> type ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_float_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__comp_flt (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_double_type ) {

# 748 "bc/src/numarith.c"
        return scheme_bin_div__comp_dbl (n1 , n2 ) ; 
      }

# 748 "bc/src/numarith.c"
      if (t2 == scheme_bignum_type )

# 748 "bc/src/numarith.c"
      return scheme_bin_div__comp_big (n1 , n2 ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_rational_type )

# 748 "bc/src/numarith.c"
      return scheme_bin_div__comp_rat (n1 , n2 ) ; 

# 748 "bc/src/numarith.c"
      if (t2 == scheme_complex_type ) 

# 748 "bc/src/numarith.c"
      return scheme_complex_divide ((n1 ) , (n2 ) ) ; 

# 748 "bc/src/numarith.c"
      return scheme_bin_div__wrong_contract (n2 ) ; 
    }

# 748 "bc/src/numarith.c"
    else return scheme_bin_div__wrong_contract (n1 ) ; 
  }
}

# 750 "bc/src/numarith.c"
static Scheme_Object * plus (int argc , Scheme_Object * argv [] ) ; 

# 750 "bc/src/numarith.c"
static inline Scheme_Object * plus__slow (Scheme_Object * ret , int argc , Scheme_Object * argv [] ) {

# 750 "bc/src/numarith.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(ret, 0), PUSH(argv, 1)));
# define XfOrM259_COUNT (2)
# define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 750 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; ++ i ) {

# 750 "bc/src/numarith.c"
    Scheme_Object * o ; 
    BLOCK_SETUP((PUSH(o, 0+XfOrM259_COUNT)));
#   define XfOrM262_COUNT (1+XfOrM259_COUNT)
#   define SETUP_XfOrM262(x) SETUP(XfOrM262_COUNT)
    o = NULLED_OUT ; 

# 750 "bc/src/numarith.c"
    o = argv [i ] ; 

# 750 "bc/src/numarith.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) <= scheme_complex_type ) ) ) ) {
#     define XfOrM263_COUNT (0+XfOrM262_COUNT)
#     define SETUP_XfOrM263(x) SETUP_XfOrM262(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("+" , "number?" , i , argc , argv ) )
# 750 "bc/src/numarith.c"
      ; 

# 750 "bc/src/numarith.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 750 "bc/src/numarith.c"
    ret = FUNCCALL(SETUP_XfOrM262(_), scheme_bin_plus (ret , o ) ); 
  }

# 750 "bc/src/numarith.c"
  RET_VALUE_START ((ret ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 750 "bc/src/numarith.c"
Scheme_Object * plus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 750 "bc/src/numarith.c"
  Scheme_Object * ret ; 

# 750 "bc/src/numarith.c"
  if (! argc )

# 750 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

# 750 "bc/src/numarith.c"
  ret = argv [0 ] ; 

# 750 "bc/src/numarith.c"
  if (! ((((intptr_t ) (ret ) ) & 0x1 ) || ((((ret ) -> type ) >= scheme_bignum_type ) && (((ret ) -> type ) <= scheme_complex_type ) ) ) ) {

# 750 "bc/src/numarith.c"
    scheme_wrong_contract ("+" , "number?" , 0 , argc , argv ) ; 

# 750 "bc/src/numarith.c"
    return ((void * ) 0 ) ; 
  }

# 750 "bc/src/numarith.c"
  if (argc == 2 ) {

# 750 "bc/src/numarith.c"
    Scheme_Object * b ; 

# 750 "bc/src/numarith.c"
    b = argv [1 ] ; 

# 750 "bc/src/numarith.c"
    if (! ((((intptr_t ) (b ) ) & 0x1 ) || ((((b ) -> type ) >= scheme_bignum_type ) && (((b ) -> type ) <= scheme_complex_type ) ) ) ) {

# 750 "bc/src/numarith.c"
      scheme_wrong_contract ("+" , "number?" , 1 , argc , argv ) ; 

# 750 "bc/src/numarith.c"
      return ((void * ) 0 ) ; 
    }

# 750 "bc/src/numarith.c"
    return scheme_bin_plus (ret , b ) ; 
  }

# 750 "bc/src/numarith.c"
  if (argc == 1 ) {

# 750 "bc/src/numarith.c"
    return ret ; 
  }

# 750 "bc/src/numarith.c"
  return plus__slow (ret , argc , argv ) ; 
}

# 751 "bc/src/numarith.c"
static Scheme_Object * mult (int argc , Scheme_Object * argv [] ) ; 

# 751 "bc/src/numarith.c"
static inline Scheme_Object * mult__slow (Scheme_Object * ret , int argc , Scheme_Object * argv [] ) {

# 751 "bc/src/numarith.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(ret, 0), PUSH(argv, 1)));
# define XfOrM269_COUNT (2)
# define SETUP_XfOrM269(x) SETUP(XfOrM269_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 751 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; ++ i ) {

# 751 "bc/src/numarith.c"
    Scheme_Object * o ; 
    BLOCK_SETUP((PUSH(o, 0+XfOrM269_COUNT)));
#   define XfOrM272_COUNT (1+XfOrM269_COUNT)
#   define SETUP_XfOrM272(x) SETUP(XfOrM272_COUNT)
    o = NULLED_OUT ; 

# 751 "bc/src/numarith.c"
    o = argv [i ] ; 

# 751 "bc/src/numarith.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) <= scheme_complex_type ) ) ) ) {
#     define XfOrM273_COUNT (0+XfOrM272_COUNT)
#     define SETUP_XfOrM273(x) SETUP_XfOrM272(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("*" , "number?" , i , argc , argv ) )
# 751 "bc/src/numarith.c"
      ; 

# 751 "bc/src/numarith.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 751 "bc/src/numarith.c"
    ret = FUNCCALL(SETUP_XfOrM272(_), scheme_bin_mult (ret , o ) ); 
  }

# 751 "bc/src/numarith.c"
  RET_VALUE_START ((ret ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 751 "bc/src/numarith.c"
Scheme_Object * mult (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 751 "bc/src/numarith.c"
  Scheme_Object * ret ; 

# 751 "bc/src/numarith.c"
  if (! argc )

# 751 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 

# 751 "bc/src/numarith.c"
  ret = argv [0 ] ; 

# 751 "bc/src/numarith.c"
  if (! ((((intptr_t ) (ret ) ) & 0x1 ) || ((((ret ) -> type ) >= scheme_bignum_type ) && (((ret ) -> type ) <= scheme_complex_type ) ) ) ) {

# 751 "bc/src/numarith.c"
    scheme_wrong_contract ("*" , "number?" , 0 , argc , argv ) ; 

# 751 "bc/src/numarith.c"
    return ((void * ) 0 ) ; 
  }

# 751 "bc/src/numarith.c"
  if (argc == 2 ) {

# 751 "bc/src/numarith.c"
    Scheme_Object * b ; 

# 751 "bc/src/numarith.c"
    b = argv [1 ] ; 

# 751 "bc/src/numarith.c"
    if (! ((((intptr_t ) (b ) ) & 0x1 ) || ((((b ) -> type ) >= scheme_bignum_type ) && (((b ) -> type ) <= scheme_complex_type ) ) ) ) {

# 751 "bc/src/numarith.c"
      scheme_wrong_contract ("*" , "number?" , 1 , argc , argv ) ; 

# 751 "bc/src/numarith.c"
      return ((void * ) 0 ) ; 
    }

# 751 "bc/src/numarith.c"
    return scheme_bin_mult (ret , b ) ; 
  }

# 751 "bc/src/numarith.c"
  if (argc == 1 ) {

# 751 "bc/src/numarith.c"
    return ret ; 
  }

# 751 "bc/src/numarith.c"
  return mult__slow (ret , argc , argv ) ; 
}
static inline Scheme_Object * 
minus_slow (Scheme_Object * ret , int argc , Scheme_Object * argv [] ) 
{
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(ret, 0), PUSH(argv, 1)));
# define XfOrM279_COUNT (2)
# define SETUP_XfOrM279(x) SETUP(XfOrM279_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 757 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {
    Scheme_Object * o = argv [i ] ; 
    BLOCK_SETUP((PUSH(o, 0+XfOrM279_COUNT)));
#   define XfOrM282_COUNT (1+XfOrM279_COUNT)
#   define SETUP_XfOrM282(x) SETUP(XfOrM282_COUNT)

# 759 "bc/src/numarith.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) <= scheme_complex_type ) ) ) ) {
#     define XfOrM283_COUNT (0+XfOrM282_COUNT)
#     define SETUP_XfOrM283(x) SETUP_XfOrM282(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("-" , "number?" , i , argc , argv ) )
# 760 "bc/src/numarith.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    ret = FUNCCALL(SETUP_XfOrM282(_), scheme_bin_minus (ret , o ) ); 
  }
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 768 "bc/src/numarith.c"
static Scheme_Object * 
minus (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 771 "bc/src/numarith.c"
  Scheme_Object * ret , * v ; 

  ret = argv [0 ] ; 
  if (! ((((intptr_t ) (ret ) ) & 0x1 ) || ((((ret ) -> type ) >= scheme_bignum_type ) && (((ret ) -> type ) <= scheme_complex_type ) ) ) ) {
    scheme_wrong_contract ("-" , "number?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  if (argc == 1 ) {
    if (((Scheme_Type ) (((((intptr_t ) (ret ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ret ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) || ((Scheme_Type ) (((((intptr_t ) (ret ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ret ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )  {

      if ((Scheme_Type ) (((((intptr_t ) (ret ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ret ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) 
        return scheme_make_float (- (((Scheme_Float * ) (ret ) ) -> float_val ) ) ; 

      return scheme_make_double (- (((Scheme_Double * ) (ret ) ) -> double_val ) ) ; 
    }
    return scheme_bin_minus (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , ret ) ; 
  }
  if (argc == 2 ) {
    v = argv [1 ] ; 
    if (! ((((intptr_t ) (v ) ) & 0x1 ) || ((((v ) -> type ) >= scheme_bignum_type ) && (((v ) -> type ) <= scheme_complex_type ) ) ) ) {
      scheme_wrong_contract ("-" , "number?" , 1 , argc , argv ) ; 
      return ((void * ) 0 ) ; 
    }
    return scheme_bin_minus (ret , v ) ; 
  }
  return minus_slow (ret , argc , argv ) ; 
}

static Scheme_Object * 
div_prim (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ret ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(ret, 0), PUSH(argv, 1)));
# define XfOrM290_COUNT (2)
# define SETUP_XfOrM290(x) SETUP(XfOrM290_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ret = NULLED_OUT ; 

# 805 "bc/src/numarith.c"
  ret = argv [0 ] ; 
  if (! ((((intptr_t ) (ret ) ) & 0x1 ) || ((((ret ) -> type ) >= scheme_bignum_type ) && (((ret ) -> type ) <= scheme_complex_type ) ) ) ) {
#   define XfOrM299_COUNT (0+XfOrM290_COUNT)
#   define SETUP_XfOrM299(x) SETUP_XfOrM290(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("/" , "number?" , 0 , argc , argv ) )
# 807 "bc/src/numarith.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (argc == 1 ) {
#   define XfOrM297_COUNT (0+XfOrM290_COUNT)
#   define SETUP_XfOrM297(x) SETUP_XfOrM290(x)

# 811 "bc/src/numarith.c"
    if (ret != ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_bin_div (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) , ret ) )) RET_VALUE_EMPTY_END ; 
    else {
#     define XfOrM298_COUNT (0+XfOrM297_COUNT)
#     define SETUP_XfOrM298(x) SETUP_XfOrM297(x)
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "/: division by zero" ) )
# 815 "bc/src/numarith.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
  for (i = 1 ; i < argc ; i ++ ) {
    Scheme_Object * o = argv [i ] ; 
    BLOCK_SETUP((PUSH(o, 0+XfOrM290_COUNT)));
#   define XfOrM294_COUNT (1+XfOrM290_COUNT)
#   define SETUP_XfOrM294(x) SETUP(XfOrM294_COUNT)

# 822 "bc/src/numarith.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) <= scheme_complex_type ) ) ) ) {
#     define XfOrM296_COUNT (0+XfOrM294_COUNT)
#     define SETUP_XfOrM296(x) SETUP_XfOrM294(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("/" , "number?" , i , argc , argv ) )
# 823 "bc/src/numarith.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (o != ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) )
      ret = FUNCCALL(SETUP_XfOrM294(_), scheme_bin_div (ret , o ) ); 
    else {
#     define XfOrM295_COUNT (0+XfOrM294_COUNT)
#     define SETUP_XfOrM295(x) SETUP_XfOrM294(x)
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "/: division by zero" ) )
# 831 "bc/src/numarith.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 840 "bc/src/numarith.c"
Scheme_Object * 
scheme_abs (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 843 "bc/src/numarith.c"
  Scheme_Type t ; 
  Scheme_Object * o ; 

  o = argv [0 ] ; 

  if (((intptr_t ) (o ) ) & 0x1 )  {
    intptr_t n = (((intptr_t ) (o ) ) >> 1 ) ; 
    return scheme_make_integer_value (((n > 0 ) ? n : - n ) ) ; 
  }
  t = ((o ) -> type ) ; 

  if (t == scheme_float_type )
    return scheme_make_float (fabs ((((Scheme_Float * ) (o ) ) -> float_val ) ) ) ; 

  if (t == scheme_double_type )
    return scheme_make_double (fabs ((((Scheme_Double * ) (o ) ) -> double_val ) ) ) ; 
  if (t == scheme_bignum_type ) {
    if ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) 
      return o ; 
    return scheme_bignum_negate (o ) ; 
  }
  if (t == scheme_rational_type ) {
    if (scheme_is_rational_positive (o ) )
      return o ; 
    else 
    return scheme_rational_negate (o ) ; 
  }

  scheme_wrong_contract ("abs" , "real?" , 0 , argc , argv ) ; 

  return ((void * ) 0 ) ; 
}

Scheme_Object * 
do_bin_quotient (const char * name , const Scheme_Object * n1 , const Scheme_Object * n2 , Scheme_Object * * bn_rem ) 
{
  Scheme_Object * q ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(n1, 1), PUSH(bn_rem, 2), PUSH(q, 3), PUSH(n2, 4)));
# define XfOrM304_COUNT (5)
# define SETUP_XfOrM304(x) SETUP(XfOrM304_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  q = NULLED_OUT ; 

# 881 "bc/src/numarith.c"
  if (! (scheme_is_integer (n1 ) ) ) {
    Scheme_Object * a [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM304_COUNT)));
#   define XfOrM311_COUNT (3+XfOrM304_COUNT)
#   define SETUP_XfOrM311(x) SETUP(XfOrM311_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 

# 883 "bc/src/numarith.c"
    a [0 ] = (Scheme_Object * ) n1 ; 
    a [1 ] = (Scheme_Object * ) n2 ; 
    FUNCCALL(SETUP_XfOrM311(_), scheme_wrong_contract (name , "integer?" , 0 , 2 , a ) ); 
  }
  if (! (scheme_is_integer (n2 ) ) ) {
    Scheme_Object * a [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM304_COUNT)));
#   define XfOrM310_COUNT (3+XfOrM304_COUNT)
#   define SETUP_XfOrM310(x) SETUP(XfOrM310_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 

# 889 "bc/src/numarith.c"
    a [0 ] = (Scheme_Object * ) n1 ; 
    a [1 ] = (Scheme_Object * ) n2 ; 
    FUNCCALL(SETUP_XfOrM310(_), scheme_wrong_contract (name , "integer?" , 1 , 2 , a ) ); 
  }

  if ((((intptr_t ) (n2 ) ) & 0x1 ) && ! (((intptr_t ) (n2 ) ) >> 1 ) )
    FUNCCALL(SETUP_XfOrM304(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "%s: undefined for 0" , name ) )
  ; 
  if (

  (((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) && ((((Scheme_Float * ) (n2 ) ) -> float_val ) == 0.0f ) ) || 

  (((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) && ((((Scheme_Double * ) (n2 ) ) -> double_val ) == 0.0 ) ) )
    FUNCCALL(SETUP_XfOrM304(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "%s: undefined for 0.0" , name ) )
  ; 

  if ((((intptr_t ) (n1 ) ) & 0x1 ) && (((intptr_t ) (n2 ) ) & 0x1 ) ) {
#   define XfOrM309_COUNT (0+XfOrM304_COUNT)
#   define SETUP_XfOrM309(x) SETUP_XfOrM304(x)
    RET_VALUE_START ((FUNCCALL(SETUP_XfOrM309(_), scheme_make_integer_value ((((intptr_t ) (n1 ) ) >> 1 ) / (((intptr_t ) (n2 ) ) >> 1 ) ) )) ) RET_VALUE_END ; 
  }
  if (((Scheme_Type ) (((((intptr_t ) (n1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n1 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) || ((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) ) {
    Scheme_Object * r ; 
    double d , d2 ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM304_COUNT)));
#   define XfOrM307_COUNT (1+XfOrM304_COUNT)
#   define SETUP_XfOrM307(x) SETUP(XfOrM307_COUNT)
    r = NULLED_OUT ; 

# 914 "bc/src/numarith.c"
    r = FUNCCALL(SETUP_XfOrM307(_), scheme_bin_div (n1 , n2 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (r ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (r ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) )  {
#     define XfOrM308_COUNT (0+XfOrM307_COUNT)
#     define SETUP_XfOrM308(x) SETUP_XfOrM307(x)

# 916 "bc/src/numarith.c"
      d = (((Scheme_Double * ) (r ) ) -> double_val ) ; 

      if (d > 0 )
        d2 = floor (d ) ; 
      else 
      d2 = ceil (d ) ; 

      if (d2 == d )
        RET_VALUE_START (r ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM308(_), scheme_make_double (d2 ) )) RET_VALUE_END ; 
    }

# 927 "bc/src/numarith.c"
    else 
    RET_VALUE_START (r ) RET_VALUE_END ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (n1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n1 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) || ((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) ) {
    Scheme_Object * r ; 
    float d , d2 ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM304_COUNT)));
#   define XfOrM305_COUNT (1+XfOrM304_COUNT)
#   define SETUP_XfOrM305(x) SETUP(XfOrM305_COUNT)
    r = NULLED_OUT ; 

# 935 "bc/src/numarith.c"
    r = FUNCCALL(SETUP_XfOrM305(_), scheme_bin_div (n1 , n2 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (r ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (r ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) )  {
#     define XfOrM306_COUNT (0+XfOrM305_COUNT)
#     define SETUP_XfOrM306(x) SETUP_XfOrM305(x)

# 937 "bc/src/numarith.c"
      d = (((Scheme_Float * ) (r ) ) -> float_val ) ; 

      if (d > 0 )
        d2 = floor (d ) ; 
      else 
      d2 = ceil (d ) ; 

      if (d2 == d )
        RET_VALUE_START (r ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM306(_), scheme_make_float (d2 ) )) RET_VALUE_END ; 
    }

# 948 "bc/src/numarith.c"
    else 
    RET_VALUE_START (r ) RET_VALUE_END ; 
  }

# 962 "bc/src/numarith.c"
  n1 = FUNCCALL(SETUP_XfOrM304(_), scheme_to_bignum (n1 ) ); 
  n2 = FUNCCALL(SETUP_XfOrM304(_), scheme_to_bignum (n2 ) ); 
  FUNCCALL_AGAIN(scheme_bignum_divide (n1 , n2 , & q , bn_rem , 1 ) )
  ; 
  RET_VALUE_START (q ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 969 "bc/src/numarith.c"
Scheme_Object * 
scheme_bin_quotient (const Scheme_Object * n1 , const Scheme_Object * n2 ) 
{
  /* No conversion */

# 972 "bc/src/numarith.c"
  return do_bin_quotient ("quotient" , n1 , n2 , ((void * ) 0 ) ) ; 
}

static Scheme_Object * 
quotient (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 978 "bc/src/numarith.c"
  return do_bin_quotient ("quotient" , argv [0 ] , argv [1 ] , ((void * ) 0 ) ) ; 
}


static Scheme_Object * 
rem_mod (int argc , Scheme_Object * argv [] , char * name , int first_sign ) ; 

static Scheme_Object * 
rem_mod (int argc , Scheme_Object * argv [] , char * name , int first_sign ) 
{
  Scheme_Object * n1 , * n2 , * r ; 
  int negate ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(n1, 1), PUSH(r, 2), PUSH(n2, 3), PUSH(argv, 4)));
# define XfOrM314_COUNT (5)
# define SETUP_XfOrM314(x) SETUP(XfOrM314_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  n1 = NULLED_OUT ; 
  n2 = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 991 "bc/src/numarith.c"
  n1 = argv [0 ] ; 
  n2 = argv [1 ] ; 

  if (! (scheme_is_integer (n1 ) ) )
    FUNCCALL(SETUP_XfOrM314(_), scheme_wrong_contract (name , "integer?" , 0 , argc , argv ) ); 
  if (! (scheme_is_integer (n2 ) ) )
    FUNCCALL(SETUP_XfOrM314(_), scheme_wrong_contract (name , "integer?" , 1 , argc , argv ) ); 

  if ((((intptr_t ) (n2 ) ) & 0x1 ) && ! (((intptr_t ) (n2 ) ) >> 1 ) )
    FUNCCALL(SETUP_XfOrM314(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "%s: undefined for 0" , name ) )
  ; 
  if (

  (((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) && ((((Scheme_Float * ) (n2 ) ) -> float_val ) == 0.0f ) ) || 

  (((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) && ((((Scheme_Double * ) (n2 ) ) -> double_val ) == 0.0 ) ) ) {
    int neg ; 
#   define XfOrM332_COUNT (0+XfOrM314_COUNT)
#   define SETUP_XfOrM332(x) SETUP_XfOrM314(x)

# 1008 "bc/src/numarith.c"
    neg = (scheme_minus_zero_p ((((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) ? (((Scheme_Double * ) (n2 ) ) -> double_val ) : (((Scheme_Float * ) (n2 ) ) -> float_val ) ) ) ) ; 
    FUNCCALL(SETUP_XfOrM332(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "%s: undefined for %s0.0" , name , neg ? "-" : "" ) )


    ; 
  }

  if ((((intptr_t ) (n1 ) ) & 0x1 ) && ! (((intptr_t ) (n1 ) ) >> 1 ) )
    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 

  if ((((intptr_t ) (n1 ) ) & 0x1 ) && (((intptr_t ) (n2 ) ) & 0x1 ) ) {
    intptr_t a , b , na , nb , v ; 
    int neg1 , neg2 ; 

    a = (((intptr_t ) (n1 ) ) >> 1 ) ; 
    b = (((intptr_t ) (n2 ) ) >> 1 ) ; 
    na = (a < 0 ) ? - a : a ; 
    nb = (b < 0 ) ? - b : b ; 

    v = na % nb ; 

    if (v ) {
      if (first_sign ) {
        if (a < 0 )
          v = - v ; 
      }

# 1033 "bc/src/numarith.c"
      else {
        neg1 = (a < 0 ) ; 
        neg2 = (b < 0 ) ; 

        if (neg1 != neg2 )
          v = nb - v ; 

        if (neg2 )
          v = - v ; 
      }
    }

    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  }

  if ((((Scheme_Type ) (((((intptr_t ) (n1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n1 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) || ((Scheme_Type ) (((((intptr_t ) (n1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n1 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) ) || (((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) || ((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) ) ) {
    double a , b , na , nb , v ; 

    int was_single = ! (((Scheme_Type ) (((((intptr_t ) (n1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n1 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) || ((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) ) ; 
#   define XfOrM321_COUNT (0+XfOrM314_COUNT)
#   define SETUP_XfOrM321(x) SETUP_XfOrM314(x)
    if (((intptr_t ) (n1 ) ) & 0x1 ) 
      a = (((intptr_t ) (n1 ) ) >> 1 ) ; 

    else if ((Scheme_Type ) (((((intptr_t ) (n1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n1 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) 
      a = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

    else if ((Scheme_Type ) (((((intptr_t ) (n1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n1 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) 
      a = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 
    else 
    a = (scheme_bignum_to_double (n1 ) ) ; 

    if (((intptr_t ) (n2 ) ) & 0x1 ) 
      b = (((intptr_t ) (n2 ) ) >> 1 ) ; 

    else if ((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_float_type ) ) 
      b = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

    else if ((Scheme_Type ) (((((intptr_t ) (n2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n2 ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) 
      b = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 
    else 
    b = (scheme_bignum_to_double (n2 ) ) ; 

    if (a == 0.0 ) {


      if (was_single )
        RET_VALUE_START (scheme_zerof ) RET_VALUE_END ; 

      RET_VALUE_START (scheme_zerod ) RET_VALUE_END ; 
    }

    na = (a < 0 ) ? - a : a ; 
    nb = (b < 0 ) ? - b : b ; 

    if (__builtin_isinf_sign (nb ) && (nb > 0 ) ) 
      v = na ; 
    else if (__builtin_isinf_sign (na ) && (na > 0 ) )  {

      if (was_single )
        RET_VALUE_START (scheme_zerof ) RET_VALUE_END ; 

      RET_VALUE_START (scheme_zerod ) RET_VALUE_END ; 
    }

# 1096 "bc/src/numarith.c"
    else {
      v = fmod (na , nb ) ; 
    }






    if (v ) {
      if (first_sign ) {

        if (a < 0 )
          v = - v ; 
      }

# 1110 "bc/src/numarith.c"
      else {

        int neg1 , neg2 ; 

        neg1 = (a < 0 ) ; 
        neg2 = (b < 0 ) ; 

        if (neg1 != neg2 )
          v = nb - v ; 

        if (neg2 )
          v = - v ; 
      }
    }


    if (was_single )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM321(_), scheme_make_float ((float ) v ) )) RET_VALUE_END ; 


    RET_VALUE_START (FUNCCALL(SETUP_XfOrM321(_), scheme_make_double (v ) )) RET_VALUE_END ; 
  }

  n1 = FUNCCALL(SETUP_XfOrM314(_), scheme_to_bignum (n1 ) ); 
  n2 = FUNCCALL(SETUP_XfOrM314(_), scheme_to_bignum (n2 ) ); 
  FUNCCALL_AGAIN(scheme_bignum_divide (n1 , n2 , ((void * ) 0 ) , & r , 1 ) )
  ; 

  negate = 0 ; 

  if (! (((intptr_t ) (r ) ) & 0x1 ) || (((intptr_t ) (r ) ) >> 1 ) ) {
#   define XfOrM315_COUNT (0+XfOrM314_COUNT)
#   define SETUP_XfOrM315(x) SETUP_XfOrM314(x)

# 1142 "bc/src/numarith.c"
    if (((intptr_t ) (r ) ) & 0x1 )  {
#     define XfOrM320_COUNT (0+XfOrM315_COUNT)
#     define SETUP_XfOrM320(x) SETUP_XfOrM315(x)

# 1143 "bc/src/numarith.c"
      if ((((intptr_t ) (r ) ) >> 1 ) < 0 )
        r = FUNCCALL(SETUP_XfOrM320(_), scheme_make_integer_value (- (((intptr_t ) (r ) ) >> 1 ) ) ); 
    }

# 1145 "bc/src/numarith.c"
    else if (! ((& ((Scheme_Bignum * ) r ) -> iso ) -> so . keyex & 0x1 ) )
      r = FUNCCALL(SETUP_XfOrM315(_), scheme_bignum_negate (r ) ); 

    if (first_sign ) {
      if (! ((& ((Scheme_Bignum * ) n1 ) -> iso ) -> so . keyex & 0x1 ) )
        negate = 1 ; 
    }

# 1151 "bc/src/numarith.c"
    else {
      int neg1 , neg2 ; 
#     define XfOrM317_COUNT (0+XfOrM315_COUNT)
#     define SETUP_XfOrM317(x) SETUP_XfOrM315(x)

# 1154 "bc/src/numarith.c"
      neg1 = ! ((& ((Scheme_Bignum * ) n1 ) -> iso ) -> so . keyex & 0x1 ) ; 
      neg2 = ! ((& ((Scheme_Bignum * ) n2 ) -> iso ) -> so . keyex & 0x1 ) ; 

      if (neg1 != neg2 ) {
#       define XfOrM318_COUNT (0+XfOrM317_COUNT)
#       define SETUP_XfOrM318(x) SETUP_XfOrM317(x)

# 1158 "bc/src/numarith.c"
        if (neg2 )
          r = FUNCCALL(SETUP_XfOrM318(_), scheme_bin_plus (n2 , r ) ); 
        else 
        r = FUNCCALL(SETUP_XfOrM318(_), scheme_bin_minus (n2 , r ) ); 
      }

# 1162 "bc/src/numarith.c"
      else if (neg2 )
        negate = 1 ; 
    }

    if (negate ) {
#     define XfOrM316_COUNT (0+XfOrM315_COUNT)
#     define SETUP_XfOrM316(x) SETUP_XfOrM315(x)

# 1167 "bc/src/numarith.c"
      if (((intptr_t ) (r ) ) & 0x1 ) 
        r = FUNCCALL(SETUP_XfOrM316(_), scheme_make_integer_value (- (((intptr_t ) (r ) ) >> 1 ) ) ); 
      else 
      r = (__funcarg67 = FUNCCALL(SETUP_XfOrM316(_), scheme_bignum_negate (r ) ), (scheme_bignum_normalize (__funcarg67 ) ) ) ; 
    }
  }

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1177 "bc/src/numarith.c"
static Scheme_Object * 
rem_prim (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1180 "bc/src/numarith.c"
  return rem_mod (argc , argv , "remainder" , 1 ) ; 
}

Scheme_Object * 
scheme_modulo (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1186 "bc/src/numarith.c"
  return rem_mod (argc , argv , "modulo" , 0 ) ; 
}

static Scheme_Object * 
do_quotient_remainder (const Scheme_Object * n1 , const Scheme_Object * n2 , Scheme_Object * * _rem ) 
{
  Scheme_Object * rem = ((void * ) 0 ) , * quot , * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(quot, 0), PUSH(rem, 1), PUSH(n1, 2), PUSH(_rem, 3), PUSHARRAY(a, 2, 4), PUSH(n2, 7)));
# define XfOrM335_COUNT (8)
# define SETUP_XfOrM335(x) SETUP(XfOrM335_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  quot = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1194 "bc/src/numarith.c"
  quot = FUNCCALL(SETUP_XfOrM335(_), do_bin_quotient ("quotient/remainder" , n1 , n2 , & rem ) ); 
  if (! rem ) {
#   define XfOrM336_COUNT (0+XfOrM335_COUNT)
#   define SETUP_XfOrM336(x) SETUP_XfOrM335(x)

# 1196 "bc/src/numarith.c"
    a [0 ] = (Scheme_Object * ) n1 ; 
    a [1 ] = (Scheme_Object * ) n2 ; 
    rem = FUNCCALL(SETUP_XfOrM336(_), rem_mod (2 , a , "remainder" , 1 ) ); 
  }
  * _rem = rem ; 

  RET_VALUE_START (quot ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1205 "bc/src/numarith.c"
Scheme_Object * 
quotient_remainder (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * rem , * quot , * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(rem, 0), PUSH(quot, 1), PUSHARRAY(a, 2, 2)));
# define XfOrM337_COUNT (5)
# define SETUP_XfOrM337(x) SETUP(XfOrM337_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rem = NULLED_OUT ; 
  quot = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1210 "bc/src/numarith.c"
  quot = FUNCCALL(SETUP_XfOrM337(_), do_quotient_remainder (argv [0 ] , argv [1 ] , & rem ) ); 
  a [0 ] = quot ; 
  a [1 ] = rem ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM337(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1216 "bc/src/numarith.c"
Scheme_Object * scheme_bin_quotient_remainder (const Scheme_Object * n1 , const Scheme_Object * n2 , 
Scheme_Object * * _rem ) 
{
  /* No conversion */

# 1219 "bc/src/numarith.c"
  return do_quotient_remainder (n1 , n2 , _rem ) ; 
}

# 1232 "bc/src/numarith.c"
static void check_always_fixnum (const char * name , Scheme_Object * o ) 
{
  /* No conversion */

# 1234 "bc/src/numarith.c"
  if (((intptr_t ) (o ) ) & 0x1 )  {
    intptr_t v = (((intptr_t ) (o ) ) >> 1 ) ; 
    if ((v < - 1073741824 ) || (v > 1073741823 ) ) {
      scheme_contract_error (name , 
      "cannot fold to result that is not a fixnum on some platforms" , 
      "result" , 1 , o , 
      ((void * ) 0 ) ) ; 
    }
  }
}

# 1264 "bc/src/numarith.c"
static Scheme_Object * fx_plus (int argc , Scheme_Object * argv [] ) {

# 1264 "bc/src/numarith.c"
  Scheme_Object * o ; 

# 1264 "bc/src/numarith.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM342_COUNT (1)
# define SETUP_XfOrM342(x) SETUP(XfOrM342_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 1264 "bc/src/numarith.c"
  for (i = 0 ; i < argc ; i ++ ) {
#   define XfOrM344_COUNT (0+XfOrM342_COUNT)
#   define SETUP_XfOrM344(x) SETUP_XfOrM342(x)

# 1264 "bc/src/numarith.c"
    if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("fx+" , "fixnum?" , i , argc , argv ) )
# 1264 "bc/src/numarith.c"
    ; 
  }

# 1264 "bc/src/numarith.c"
  o = FUNCCALL(SETUP_XfOrM342(_), plus (argc , argv ) ); 

# 1264 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )
    FUNCCALL(SETUP_XfOrM342(_), check_always_fixnum ("fx+" , o ) )
# 1264 "bc/src/numarith.c"
  ; 

# 1264 "bc/src/numarith.c"
  if (! (((intptr_t ) (o ) ) & 0x1 ) )
    FUNCCALL(SETUP_XfOrM342(_), scheme_non_fixnum_result ("fx+" , o ) )
# 1264 "bc/src/numarith.c"
  ; 

# 1264 "bc/src/numarith.c"
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1265 "bc/src/numarith.c"
static Scheme_Object * fx_minus (int argc , Scheme_Object * argv [] ) {

# 1265 "bc/src/numarith.c"
  Scheme_Object * o ; 

# 1265 "bc/src/numarith.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM345_COUNT (1)
# define SETUP_XfOrM345(x) SETUP(XfOrM345_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 1265 "bc/src/numarith.c"
  for (i = 0 ; i < argc ; i ++ ) {
#   define XfOrM347_COUNT (0+XfOrM345_COUNT)
#   define SETUP_XfOrM347(x) SETUP_XfOrM345(x)

# 1265 "bc/src/numarith.c"
    if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("fx-" , "fixnum?" , i , argc , argv ) )
# 1265 "bc/src/numarith.c"
    ; 
  }

# 1265 "bc/src/numarith.c"
  o = FUNCCALL(SETUP_XfOrM345(_), minus (argc , argv ) ); 

# 1265 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )
    FUNCCALL(SETUP_XfOrM345(_), check_always_fixnum ("fx-" , o ) )
# 1265 "bc/src/numarith.c"
  ; 

# 1265 "bc/src/numarith.c"
  if (! (((intptr_t ) (o ) ) & 0x1 ) )
    FUNCCALL(SETUP_XfOrM345(_), scheme_non_fixnum_result ("fx-" , o ) )
# 1265 "bc/src/numarith.c"
  ; 

# 1265 "bc/src/numarith.c"
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1266 "bc/src/numarith.c"
static Scheme_Object * fx_mult (int argc , Scheme_Object * argv [] ) {

# 1266 "bc/src/numarith.c"
  Scheme_Object * o ; 

# 1266 "bc/src/numarith.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM348_COUNT (1)
# define SETUP_XfOrM348(x) SETUP(XfOrM348_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 1266 "bc/src/numarith.c"
  for (i = 0 ; i < argc ; i ++ ) {
#   define XfOrM350_COUNT (0+XfOrM348_COUNT)
#   define SETUP_XfOrM350(x) SETUP_XfOrM348(x)

# 1266 "bc/src/numarith.c"
    if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("fx*" , "fixnum?" , i , argc , argv ) )
# 1266 "bc/src/numarith.c"
    ; 
  }

# 1266 "bc/src/numarith.c"
  o = FUNCCALL(SETUP_XfOrM348(_), mult (argc , argv ) ); 

# 1266 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )
    FUNCCALL(SETUP_XfOrM348(_), check_always_fixnum ("fx*" , o ) )
# 1266 "bc/src/numarith.c"
  ; 

# 1266 "bc/src/numarith.c"
  if (! (((intptr_t ) (o ) ) & 0x1 ) )
    FUNCCALL(SETUP_XfOrM348(_), scheme_non_fixnum_result ("fx*" , o ) )
# 1266 "bc/src/numarith.c"
  ; 

# 1266 "bc/src/numarith.c"
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1267 "bc/src/numarith.c"
static Scheme_Object * fx_div (int argc , Scheme_Object * argv [] ) {

# 1267 "bc/src/numarith.c"
  Scheme_Object * o ; 

# 1267 "bc/src/numarith.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM351_COUNT (1)
# define SETUP_XfOrM351(x) SETUP(XfOrM351_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 1267 "bc/src/numarith.c"
  for (i = 0 ; i < argc ; i ++ ) {
#   define XfOrM353_COUNT (0+XfOrM351_COUNT)
#   define SETUP_XfOrM353(x) SETUP_XfOrM351(x)

# 1267 "bc/src/numarith.c"
    if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("fxquotient" , "fixnum?" , i , argc , argv ) )
# 1267 "bc/src/numarith.c"
    ; 
  }

# 1267 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [1 ] ) ) >> 1 ) )
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "fxquotient" ": undefined for 0" ) )
# 1267 "bc/src/numarith.c"
  ; 

# 1267 "bc/src/numarith.c"
  o = FUNCCALL(SETUP_XfOrM351(_), quotient (argc , argv ) ); 

# 1267 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )
    FUNCCALL(SETUP_XfOrM351(_), check_always_fixnum ("fxquotient" , o ) )
# 1267 "bc/src/numarith.c"
  ; 

# 1267 "bc/src/numarith.c"
  if (! (((intptr_t ) (o ) ) & 0x1 ) )
    FUNCCALL(SETUP_XfOrM351(_), scheme_non_fixnum_result ("fxquotient" , o ) )
# 1267 "bc/src/numarith.c"
  ; 

# 1267 "bc/src/numarith.c"
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1268 "bc/src/numarith.c"
static Scheme_Object * fx_rem (int argc , Scheme_Object * argv [] ) {

# 1268 "bc/src/numarith.c"
  Scheme_Object * o ; 

# 1268 "bc/src/numarith.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM354_COUNT (1)
# define SETUP_XfOrM354(x) SETUP(XfOrM354_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 1268 "bc/src/numarith.c"
  for (i = 0 ; i < argc ; i ++ ) {
#   define XfOrM356_COUNT (0+XfOrM354_COUNT)
#   define SETUP_XfOrM356(x) SETUP_XfOrM354(x)

# 1268 "bc/src/numarith.c"
    if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("fxremainder" , "fixnum?" , i , argc , argv ) )
# 1268 "bc/src/numarith.c"
    ; 
  }

# 1268 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [1 ] ) ) >> 1 ) )
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "fxremainder" ": undefined for 0" ) )
# 1268 "bc/src/numarith.c"
  ; 

# 1268 "bc/src/numarith.c"
  o = FUNCCALL(SETUP_XfOrM354(_), rem_prim (argc , argv ) ); 

# 1268 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )
    FUNCCALL(SETUP_XfOrM354(_), check_always_fixnum ("fxremainder" , o ) )
# 1268 "bc/src/numarith.c"
  ; 

# 1268 "bc/src/numarith.c"
  if (! (((intptr_t ) (o ) ) & 0x1 ) )
    FUNCCALL(SETUP_XfOrM354(_), scheme_non_fixnum_result ("fxremainder" , o ) )
# 1268 "bc/src/numarith.c"
  ; 

# 1268 "bc/src/numarith.c"
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1269 "bc/src/numarith.c"
static Scheme_Object * fx_mod (int argc , Scheme_Object * argv [] ) {

# 1269 "bc/src/numarith.c"
  Scheme_Object * o ; 

# 1269 "bc/src/numarith.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM357_COUNT (1)
# define SETUP_XfOrM357(x) SETUP(XfOrM357_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 1269 "bc/src/numarith.c"
  for (i = 0 ; i < argc ; i ++ ) {
#   define XfOrM359_COUNT (0+XfOrM357_COUNT)
#   define SETUP_XfOrM359(x) SETUP_XfOrM357(x)

# 1269 "bc/src/numarith.c"
    if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("fxmodulo" , "fixnum?" , i , argc , argv ) )
# 1269 "bc/src/numarith.c"
    ; 
  }

# 1269 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [1 ] ) ) >> 1 ) )
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO , "fxmodulo" ": undefined for 0" ) )
# 1269 "bc/src/numarith.c"
  ; 

# 1269 "bc/src/numarith.c"
  o = FUNCCALL(SETUP_XfOrM357(_), scheme_modulo (argc , argv ) ); 

# 1269 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )
    FUNCCALL(SETUP_XfOrM357(_), check_always_fixnum ("fxmodulo" , o ) )
# 1269 "bc/src/numarith.c"
  ; 

# 1269 "bc/src/numarith.c"
  if (! (((intptr_t ) (o ) ) & 0x1 ) )
    FUNCCALL(SETUP_XfOrM357(_), scheme_non_fixnum_result ("fxmodulo" , o ) )
# 1269 "bc/src/numarith.c"
  ; 

# 1269 "bc/src/numarith.c"
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}






static Scheme_Object * fx_plus_wrap (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1281 "bc/src/numarith.c"
  uintptr_t r ; 

# 1281 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 1281 "bc/src/numarith.c"
  scheme_wrong_contract ("fx+/wraparound" , "fixnum?" , 0 , argc , argv ) ; 

# 1281 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 1281 "bc/src/numarith.c"
  scheme_wrong_contract ("fx+/wraparound" , "fixnum?" , 1 , argc , argv ) ; 

# 1281 "bc/src/numarith.c"
  r = ((uintptr_t ) (((intptr_t ) (argv [0 ] ) ) >> 1 ) + (uintptr_t ) (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ; 

# 1281 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1282 "bc/src/numarith.c"
static Scheme_Object * fx_minus_wrap (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1282 "bc/src/numarith.c"
  uintptr_t r ; 

# 1282 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 1282 "bc/src/numarith.c"
  scheme_wrong_contract ("fx-/wraparound" , "fixnum?" , 0 , argc , argv ) ; 

# 1282 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 1282 "bc/src/numarith.c"
  scheme_wrong_contract ("fx-/wraparound" , "fixnum?" , 1 , argc , argv ) ; 

# 1282 "bc/src/numarith.c"
  r = ((uintptr_t ) (((intptr_t ) (argv [0 ] ) ) >> 1 ) - (uintptr_t ) (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ; 

# 1282 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1283 "bc/src/numarith.c"
static Scheme_Object * fx_mult_wrap (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1283 "bc/src/numarith.c"
  uintptr_t r ; 

# 1283 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 1283 "bc/src/numarith.c"
  scheme_wrong_contract ("fx*/wraparound" , "fixnum?" , 0 , argc , argv ) ; 

# 1283 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 1283 "bc/src/numarith.c"
  scheme_wrong_contract ("fx*/wraparound" , "fixnum?" , 1 , argc , argv ) ; 

# 1283 "bc/src/numarith.c"
  r = ((uintptr_t ) (((intptr_t ) (argv [0 ] ) ) >> 1 ) * (uintptr_t ) (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ; 

# 1283 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ; 
}
static Scheme_Object * fx_abs (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM363_COUNT (1)
# define SETUP_XfOrM363(x) SETUP(XfOrM363_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 1288 "bc/src/numarith.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("fxabs" , "fixnum?" , 0 , argc , argv ) )
# 1288 "bc/src/numarith.c"
  ; 
  o = FUNCCALL(SETUP_XfOrM363(_), scheme_abs (argc , argv ) ); 
  if (! (((intptr_t ) (o ) ) & 0x1 ) )
    FUNCCALL(SETUP_XfOrM363(_), scheme_non_fixnum_result ("fxabs" , o ) )
# 1290 "bc/src/numarith.c"
  ; 
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1316 "bc/src/numarith.c"
__attribute__ ((no_sanitize ("signed-integer-overflow" ) ) ) static Scheme_Object * unsafe_fx_plus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1316 "bc/src/numarith.c"
  intptr_t v ; 

# 1316 "bc/src/numarith.c"
  int i ; 

# 1316 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1316 "bc/src/numarith.c"
  return fx_plus (argc , argv ) ; 

# 1316 "bc/src/numarith.c"
  if (! argc )

# 1316 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

# 1316 "bc/src/numarith.c"
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

# 1316 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1316 "bc/src/numarith.c"
    v = v + (((intptr_t ) (argv [i ] ) ) >> 1 ) ; 
  }

# 1316 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1317 "bc/src/numarith.c"
__attribute__ ((no_sanitize ("signed-integer-overflow" ) ) ) static Scheme_Object * unsafe_fx_plus_wrap (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1317 "bc/src/numarith.c"
  intptr_t v ; 

# 1317 "bc/src/numarith.c"
  int i ; 

# 1317 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1317 "bc/src/numarith.c"
  return fx_plus (argc , argv ) ; 

# 1317 "bc/src/numarith.c"
  if (! argc )

# 1317 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

# 1317 "bc/src/numarith.c"
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

# 1317 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1317 "bc/src/numarith.c"
    v = v + (((intptr_t ) (argv [i ] ) ) >> 1 ) ; 
  }

# 1317 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1318 "bc/src/numarith.c"
__attribute__ ((no_sanitize ("signed-integer-overflow" ) ) ) static Scheme_Object * unsafe_fx_minus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1318 "bc/src/numarith.c"
  intptr_t v ; 

# 1318 "bc/src/numarith.c"
  int i ; 

# 1318 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1318 "bc/src/numarith.c"
  return fx_minus (argc , argv ) ; 

# 1318 "bc/src/numarith.c"
  if (! argc )

# 1318 "bc/src/numarith.c"
  return scheme_false ; 

# 1318 "bc/src/numarith.c"
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

# 1318 "bc/src/numarith.c"
  if (argc == 1 )

# 1318 "bc/src/numarith.c"
  v = - v ; 

# 1318 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1318 "bc/src/numarith.c"
    v = v - (((intptr_t ) (argv [i ] ) ) >> 1 ) ; 
  }

# 1318 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1319 "bc/src/numarith.c"
__attribute__ ((no_sanitize ("signed-integer-overflow" ) ) ) static Scheme_Object * unsafe_fx_minus_wrap (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1319 "bc/src/numarith.c"
  intptr_t v ; 

# 1319 "bc/src/numarith.c"
  int i ; 

# 1319 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1319 "bc/src/numarith.c"
  return fx_minus (argc , argv ) ; 

# 1319 "bc/src/numarith.c"
  if (! argc )

# 1319 "bc/src/numarith.c"
  return scheme_false ; 

# 1319 "bc/src/numarith.c"
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

# 1319 "bc/src/numarith.c"
  if (argc == 1 )

# 1319 "bc/src/numarith.c"
  v = - v ; 

# 1319 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1319 "bc/src/numarith.c"
    v = v - (((intptr_t ) (argv [i ] ) ) >> 1 ) ; 
  }

# 1319 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1320 "bc/src/numarith.c"
__attribute__ ((no_sanitize ("signed-integer-overflow" ) ) ) static Scheme_Object * unsafe_fx_mult (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1320 "bc/src/numarith.c"
  intptr_t v ; 

# 1320 "bc/src/numarith.c"
  int i ; 

# 1320 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1320 "bc/src/numarith.c"
  return fx_mult (argc , argv ) ; 

# 1320 "bc/src/numarith.c"
  if (! argc )

# 1320 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 

# 1320 "bc/src/numarith.c"
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

# 1320 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1320 "bc/src/numarith.c"
    v = v * (((intptr_t ) (argv [i ] ) ) >> 1 ) ; 
  }

# 1320 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1321 "bc/src/numarith.c"
__attribute__ ((no_sanitize ("signed-integer-overflow" ) ) ) static Scheme_Object * unsafe_fx_mult_wrap (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1321 "bc/src/numarith.c"
  intptr_t v ; 

# 1321 "bc/src/numarith.c"
  int i ; 

# 1321 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1321 "bc/src/numarith.c"
  return fx_mult (argc , argv ) ; 

# 1321 "bc/src/numarith.c"
  if (! argc )

# 1321 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 

# 1321 "bc/src/numarith.c"
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

# 1321 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1321 "bc/src/numarith.c"
    v = v * (((intptr_t ) (argv [i ] ) ) >> 1 ) ; 
  }

# 1321 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1322 "bc/src/numarith.c"
__attribute__ ((no_sanitize ("signed-integer-overflow" ) ) ) static Scheme_Object * unsafe_fx_div (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1322 "bc/src/numarith.c"
  intptr_t v ; 

# 1322 "bc/src/numarith.c"
  int i ; 

# 1322 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1322 "bc/src/numarith.c"
  return fx_div (argc , argv ) ; 

# 1322 "bc/src/numarith.c"
  if (! argc )

# 1322 "bc/src/numarith.c"
  return scheme_false ; 

# 1322 "bc/src/numarith.c"
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

# 1322 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1322 "bc/src/numarith.c"
    v = v / (((intptr_t ) (argv [i ] ) ) >> 1 ) ; 
  }

# 1322 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1323 "bc/src/numarith.c"
__attribute__ ((no_sanitize ("signed-integer-overflow" ) ) ) static Scheme_Object * unsafe_fx_rem (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1323 "bc/src/numarith.c"
  intptr_t v ; 

# 1323 "bc/src/numarith.c"
  int i ; 

# 1323 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1323 "bc/src/numarith.c"
  return fx_rem (argc , argv ) ; 

# 1323 "bc/src/numarith.c"
  if (! argc )

# 1323 "bc/src/numarith.c"
  return scheme_false ; 

# 1323 "bc/src/numarith.c"
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

# 1323 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1323 "bc/src/numarith.c"
    v = v % (((intptr_t ) (argv [i ] ) ) >> 1 ) ; 
  }

# 1323 "bc/src/numarith.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}
static Scheme_Object * unsafe_fx_mod (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1327 "bc/src/numarith.c"
  int neg1 , neg2 ; 
  intptr_t v , v1 , av1 , v2 , av2 ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1329 "bc/src/numarith.c"
  return scheme_modulo (argc , argv ) ; 

  v1 = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
  v2 = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 

  av1 = (v1 < 0 ) ? - v1 : v1 ; 
  av2 = (v2 < 0 ) ? - v2 : v2 ; 

  v = av1 % av2 ; 

  if (v ) {
    neg1 = (v1 < 0 ) ; 
    neg2 = (v2 < 0 ) ; 

    if (neg1 != neg2 )
      v = av2 - v ; 

    if (neg2 )
      v = - v ; 
  }

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * unsafe_fx_abs (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1355 "bc/src/numarith.c"
  intptr_t v ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1356 "bc/src/numarith.c"
  return scheme_abs (argc , argv ) ; 
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
  if (v < 0 )

# 1358 "bc/src/numarith.c"
  v = - v ; 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 1382 "bc/src/numarith.c"
static Scheme_Object * unsafe_fl_plus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1382 "bc/src/numarith.c"
  double v ; 

# 1382 "bc/src/numarith.c"
  if (! argc )

# 1382 "bc/src/numarith.c"
  return scheme_zerod ; 

# 1382 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1382 "bc/src/numarith.c"
  return plus (argc , argv ) ; 

# 1382 "bc/src/numarith.c"
  if (argc == 2 ) {

# 1382 "bc/src/numarith.c"
    v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) + (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ; 

# 1382 "bc/src/numarith.c"
    return scheme_make_double (v ) ; 
  }

# 1382 "bc/src/numarith.c"
  else {

# 1382 "bc/src/numarith.c"
    int i ; 

# 1382 "bc/src/numarith.c"
    v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1382 "bc/src/numarith.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 1382 "bc/src/numarith.c"
      v = v + (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ; 
    }

# 1382 "bc/src/numarith.c"
    return scheme_make_double (v ) ; 
  }
}

# 1383 "bc/src/numarith.c"
static Scheme_Object * unsafe_fl_minus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1383 "bc/src/numarith.c"
  double v ; 

# 1383 "bc/src/numarith.c"
  if (! argc )

# 1383 "bc/src/numarith.c"
  return scheme_false ; 

# 1383 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1383 "bc/src/numarith.c"
  return minus (argc , argv ) ; 

# 1383 "bc/src/numarith.c"
  if (argc == 2 ) {

# 1383 "bc/src/numarith.c"
    v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) - (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ; 

# 1383 "bc/src/numarith.c"
    return scheme_make_double (v ) ; 
  }

# 1383 "bc/src/numarith.c"
  else {

# 1383 "bc/src/numarith.c"
    int i ; 

# 1383 "bc/src/numarith.c"
    v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1383 "bc/src/numarith.c"
    if (argc == 1 )

# 1383 "bc/src/numarith.c"
    v = 0.0 - v ; 

# 1383 "bc/src/numarith.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 1383 "bc/src/numarith.c"
      v = v - (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ; 
    }

# 1383 "bc/src/numarith.c"
    return scheme_make_double (v ) ; 
  }
}

# 1384 "bc/src/numarith.c"
static Scheme_Object * unsafe_fl_mult (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1384 "bc/src/numarith.c"
  double v ; 

# 1384 "bc/src/numarith.c"
  if (! argc )

# 1384 "bc/src/numarith.c"
  return scheme_make_double (1.0 ) ; 

# 1384 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1384 "bc/src/numarith.c"
  return mult (argc , argv ) ; 

# 1384 "bc/src/numarith.c"
  if (argc == 2 ) {

# 1384 "bc/src/numarith.c"
    v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) * (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ; 

# 1384 "bc/src/numarith.c"
    return scheme_make_double (v ) ; 
  }

# 1384 "bc/src/numarith.c"
  else {

# 1384 "bc/src/numarith.c"
    int i ; 

# 1384 "bc/src/numarith.c"
    v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1384 "bc/src/numarith.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 1384 "bc/src/numarith.c"
      v = v * (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ; 
    }

# 1384 "bc/src/numarith.c"
    return scheme_make_double (v ) ; 
  }
}

# 1385 "bc/src/numarith.c"
static Scheme_Object * unsafe_fl_div (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1385 "bc/src/numarith.c"
  double v ; 

# 1385 "bc/src/numarith.c"
  if (! argc )

# 1385 "bc/src/numarith.c"
  return scheme_false ; 

# 1385 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1385 "bc/src/numarith.c"
  return div_prim (argc , argv ) ; 

# 1385 "bc/src/numarith.c"
  if (argc == 2 ) {

# 1385 "bc/src/numarith.c"
    v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) / (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ; 

# 1385 "bc/src/numarith.c"
    return scheme_make_double (v ) ; 
  }

# 1385 "bc/src/numarith.c"
  else {

# 1385 "bc/src/numarith.c"
    int i ; 

# 1385 "bc/src/numarith.c"
    v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1385 "bc/src/numarith.c"
    if (argc == 1 )

# 1385 "bc/src/numarith.c"
    v = 1.0 / v ; 

# 1385 "bc/src/numarith.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 1385 "bc/src/numarith.c"
      v = v / (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ; 
    }

# 1385 "bc/src/numarith.c"
    return scheme_make_double (v ) ; 
  }
}









static Scheme_Object * unsafe_fl_abs (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1397 "bc/src/numarith.c"
  double v ; 

# 1397 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1397 "bc/src/numarith.c"
  return scheme_abs (argc , argv ) ; 

# 1397 "bc/src/numarith.c"
  v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1397 "bc/src/numarith.c"
  v = fabs (v ) ; 

# 1397 "bc/src/numarith.c"
  return scheme_make_double (v ) ; 
}
static Scheme_Object * pos_sqrt (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1401 "bc/src/numarith.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) && ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) < 0.0 ) )
    return scheme_nan_object ; 
  return scheme_sqrt (argc , argv ) ; 
}

static Scheme_Object * unsafe_fl_sqrt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1406 "bc/src/numarith.c"
  double v ; 

# 1406 "bc/src/numarith.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 1406 "bc/src/numarith.c"
  return pos_sqrt (argc , argv ) ; 

# 1406 "bc/src/numarith.c"
  v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1406 "bc/src/numarith.c"
  v = sqrt (v ) ; 

# 1406 "bc/src/numarith.c"
  return scheme_make_double (v ) ; 
}

# 1424 "bc/src/numarith.c"
static Scheme_Object * fl_plus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1424 "bc/src/numarith.c"
  double v ; 

# 1424 "bc/src/numarith.c"
  int i ; 

# 1424 "bc/src/numarith.c"
  if (! argc )

# 1424 "bc/src/numarith.c"
  return scheme_zerod ; 

# 1424 "bc/src/numarith.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1424 "bc/src/numarith.c"
  scheme_wrong_contract ("fl+" , "flonum?" , 0 , argc , argv ) ; 

# 1424 "bc/src/numarith.c"
  v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1424 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1424 "bc/src/numarith.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1424 "bc/src/numarith.c"
    scheme_wrong_contract ("fl+" , "flonum?" , i , argc , argv ) ; 

# 1424 "bc/src/numarith.c"
    v = v + (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ; 
  }

# 1424 "bc/src/numarith.c"
  return scheme_make_double (v ) ; 
}

# 1425 "bc/src/numarith.c"
static Scheme_Object * fl_minus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1425 "bc/src/numarith.c"
  double v ; 

# 1425 "bc/src/numarith.c"
  int i ; 

# 1425 "bc/src/numarith.c"
  if (! argc )

# 1425 "bc/src/numarith.c"
  return scheme_false ; 

# 1425 "bc/src/numarith.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1425 "bc/src/numarith.c"
  scheme_wrong_contract ("fl-" , "flonum?" , 0 , argc , argv ) ; 

# 1425 "bc/src/numarith.c"
  v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1425 "bc/src/numarith.c"
  if (argc == 1 )

# 1425 "bc/src/numarith.c"
  v = 0.0 - v ; 

# 1425 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1425 "bc/src/numarith.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1425 "bc/src/numarith.c"
    scheme_wrong_contract ("fl-" , "flonum?" , i , argc , argv ) ; 

# 1425 "bc/src/numarith.c"
    v = v - (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ; 
  }

# 1425 "bc/src/numarith.c"
  return scheme_make_double (v ) ; 
}

# 1426 "bc/src/numarith.c"
static Scheme_Object * fl_mult (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1426 "bc/src/numarith.c"
  double v ; 

# 1426 "bc/src/numarith.c"
  int i ; 

# 1426 "bc/src/numarith.c"
  if (! argc )

# 1426 "bc/src/numarith.c"
  return scheme_make_double (1.0 ) ; 

# 1426 "bc/src/numarith.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1426 "bc/src/numarith.c"
  scheme_wrong_contract ("fl*" , "flonum?" , 0 , argc , argv ) ; 

# 1426 "bc/src/numarith.c"
  v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1426 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1426 "bc/src/numarith.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1426 "bc/src/numarith.c"
    scheme_wrong_contract ("fl*" , "flonum?" , i , argc , argv ) ; 

# 1426 "bc/src/numarith.c"
    v = v * (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ; 
  }

# 1426 "bc/src/numarith.c"
  return scheme_make_double (v ) ; 
}

# 1427 "bc/src/numarith.c"
static Scheme_Object * fl_div (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1427 "bc/src/numarith.c"
  double v ; 

# 1427 "bc/src/numarith.c"
  int i ; 

# 1427 "bc/src/numarith.c"
  if (! argc )

# 1427 "bc/src/numarith.c"
  return scheme_false ; 

# 1427 "bc/src/numarith.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1427 "bc/src/numarith.c"
  scheme_wrong_contract ("fl/" , "flonum?" , 0 , argc , argv ) ; 

# 1427 "bc/src/numarith.c"
  v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1427 "bc/src/numarith.c"
  if (argc == 1 )

# 1427 "bc/src/numarith.c"
  v = 1.0 / v ; 

# 1427 "bc/src/numarith.c"
  for (i = 1 ; i < argc ; i ++ ) {

# 1427 "bc/src/numarith.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1427 "bc/src/numarith.c"
    scheme_wrong_contract ("fl/" , "flonum?" , i , argc , argv ) ; 

# 1427 "bc/src/numarith.c"
    v = v / (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ; 
  }

# 1427 "bc/src/numarith.c"
  return scheme_make_double (v ) ; 
}

# 1439 "bc/src/numarith.c"
static Scheme_Object * fl_abs (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1439 "bc/src/numarith.c"
  double v ; 

# 1439 "bc/src/numarith.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1439 "bc/src/numarith.c"
  scheme_wrong_contract ("flabs" , "flonum?" , 0 , argc , argv ) ; 

# 1439 "bc/src/numarith.c"
  v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1439 "bc/src/numarith.c"
  v = fabs (v ) ; 

# 1439 "bc/src/numarith.c"
  return scheme_make_double (v ) ; 
}

# 1440 "bc/src/numarith.c"
static Scheme_Object * fl_sqrt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1440 "bc/src/numarith.c"
  double v ; 

# 1440 "bc/src/numarith.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 1440 "bc/src/numarith.c"
  scheme_wrong_contract ("flsqrt" , "flonum?" , 0 , argc , argv ) ; 

# 1440 "bc/src/numarith.c"
  v = (((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ; 

# 1440 "bc/src/numarith.c"
  v = sqrt (v ) ; 

# 1440 "bc/src/numarith.c"
  return scheme_make_double (v ) ; 
}

# 1461 "bc/src/numarith.c"
static Scheme_Object * unsafe_extfl_plus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1461 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_plus" ": " "unsupported on this platform" ) ; 

# 1461 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1462 "bc/src/numarith.c"
static Scheme_Object * unsafe_extfl_minus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1462 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_minus" ": " "unsupported on this platform" ) ; 

# 1462 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1463 "bc/src/numarith.c"
static Scheme_Object * unsafe_extfl_mult (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1463 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_mult" ": " "unsupported on this platform" ) ; 

# 1463 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1464 "bc/src/numarith.c"
static Scheme_Object * unsafe_extfl_div (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1464 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_div" ": " "unsupported on this platform" ) ; 

# 1464 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1479 "bc/src/numarith.c"
static Scheme_Object * unsafe_extfl_abs (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1479 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_fabs" ": " "unsupported on this platform" ) ; 

# 1479 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1480 "bc/src/numarith.c"
static Scheme_Object * unsafe_extfl_sqrt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1480 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_sqrt" ": " "unsupported on this platform" ) ; 

# 1480 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1503 "bc/src/numarith.c"
static Scheme_Object * extfl_plus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1503 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl+" ": " "unsupported on this platform" ) ; 

# 1503 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1504 "bc/src/numarith.c"
static Scheme_Object * extfl_minus (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1504 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl-" ": " "unsupported on this platform" ) ; 

# 1504 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1505 "bc/src/numarith.c"
static Scheme_Object * extfl_mult (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1505 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl*" ": " "unsupported on this platform" ) ; 

# 1505 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1506 "bc/src/numarith.c"
static Scheme_Object * extfl_div (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1506 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl/" ": " "unsupported on this platform" ) ; 

# 1506 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1522 "bc/src/numarith.c"
static Scheme_Object * extfl_abs (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1522 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extflabs" ": " "unsupported on this platform" ) ; 

# 1522 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}

# 1523 "bc/src/numarith.c"
static Scheme_Object * extfl_sqrt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1523 "bc/src/numarith.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extflsqrt" ": " "unsupported on this platform" ) ; 

# 1523 "bc/src/numarith.c"
  return ((void * ) 0 ) ; 
}
