#include "precomp.h"

# 6 "bc/src/numcomp.c"
Scheme_Object * scheme_unsafe_fx_eq_proc ; 
Scheme_Object * scheme_unsafe_fx_lt_proc ; 
Scheme_Object * scheme_unsafe_fx_gt_proc ; 
Scheme_Object * scheme_unsafe_fx_lt_eq_proc ; 
Scheme_Object * scheme_unsafe_fx_gt_eq_proc ; 
Scheme_Object * scheme_unsafe_fx_min_proc ; 
Scheme_Object * scheme_unsafe_fx_max_proc ; 


static Scheme_Object * eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * gt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * lt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * gt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * zero_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * positive_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * negative_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_max (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_min (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * fx_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_gt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_lt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_gt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_min (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fx_max (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_fx_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_gt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_lt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_gt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_min (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fx_max (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * fl_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_gt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_lt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_gt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_min (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * fl_max (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_fl_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_gt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_lt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_gt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_min (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_fl_max (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * extfl_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_gt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_lt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_gt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_min (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extfl_max (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_extfl_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_lt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_gt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_lt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_gt_eq (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_min (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_extfl_max (int argc , Scheme_Object * argv [] ) ; 



void scheme_init_numcomp (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM1_COUNT (2)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 80 "bc/src/numcomp.c"
  p = FUNCCALL(SETUP_XfOrM1(_), scheme_make_folding_prim (eq , "=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 21 ) 
  | (1 << 22 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (lt , "<" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("<" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (gt , ">" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance (">" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (lt_eq , "<=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("<=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (gt_eq , ">=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance (">=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (zero_p , "zero?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 21 ) 
  | (1 << 22 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("zero?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (positive_p , "positive?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("positive?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (negative_p , "negative?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("negative?" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (sch_max , "max" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 18 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_addto_prim_instance ("max" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (sch_min , "min" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 20 ) 
  | (1 << 22 ) 
  | (1 << 18 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("min" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 165 "bc/src/numcomp.c"
void scheme_init_flfxnum_numcomp (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  int flags ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 170 "bc/src/numcomp.c"
  p = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (fx_eq , "fx=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_lt , "fx<" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx<" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_gt , "fx>" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx>" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_lt_eq , "fx<=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx<=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_gt_eq , "fx>=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 24 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fx>=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_min , "fxmin" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fxmin" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fx_max , "fxmax" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (2 << 26 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fxmax" , p , env ) ); 


  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_eq , "fl=" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_lt , "fl<" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl<" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_gt , "fl>" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl>" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_lt_eq , "fl<=" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl<=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_gt_eq , "fl>=" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("fl>=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_min , "flmin" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("flmin" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (fl_max , "flmax" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("flmax" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 292 "bc/src/numcomp.c"
void scheme_init_extfl_numcomp (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  int flags ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM3_COUNT (2)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 297 "bc/src/numcomp.c"
  p = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (extfl_eq , "extfl=" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_lt , "extfl<" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl<" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_gt , "extfl>" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl>" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_lt_eq , "extfl<=" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl<=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_gt_eq , "extfl>=" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extfl>=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_min , "extflmin" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("extflmin" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (extfl_max , "extflmax" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("extflmax" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 363 "bc/src/numcomp.c"
void scheme_init_unsafe_numcomp (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  int flags ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM4_COUNT (2)
# define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_register_static ((void * ) & scheme_unsafe_fx_eq_proc , sizeof (scheme_unsafe_fx_eq_proc ) ) )
# 368 "bc/src/numcomp.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_eq , "unsafe-fx=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx=" , p , env ) ); 
  scheme_unsafe_fx_eq_proc = p ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_register_static ((void * ) & scheme_unsafe_fx_lt_proc , sizeof (scheme_unsafe_fx_lt_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_lt , "unsafe-fx<" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx<" , p , env ) ); 
  scheme_unsafe_fx_lt_proc = p ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_register_static ((void * ) & scheme_unsafe_fx_gt_proc , sizeof (scheme_unsafe_fx_gt_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_gt , "unsafe-fx>" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx>" , p , env ) ); 
  scheme_unsafe_fx_gt_proc = p ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_register_static ((void * ) & scheme_unsafe_fx_lt_eq_proc , sizeof (scheme_unsafe_fx_lt_eq_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_lt_eq , "unsafe-fx<=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx<=" , p , env ) ); 
  scheme_unsafe_fx_lt_eq_proc = p ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_register_static ((void * ) & scheme_unsafe_fx_gt_eq_proc , sizeof (scheme_unsafe_fx_gt_eq_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_gt_eq , "unsafe-fx>=" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fx>=" , p , env ) ); 
  scheme_unsafe_fx_gt_eq_proc = p ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_register_static ((void * ) & scheme_unsafe_fx_min_proc , sizeof (scheme_unsafe_fx_min_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_min , "unsafe-fxmin" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fxmin" , p , env ) ); 
  scheme_unsafe_fx_min_proc = p ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_register_static ((void * ) & scheme_unsafe_fx_max_proc , sizeof (scheme_unsafe_fx_max_proc ) ) )
  ; 
  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fx_max , "unsafe-fxmax" , 1 , - 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 2 ) 
  | (1 << 8 ) 
  | (2 << 26 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fxmax" , p , env ) ); 
  scheme_unsafe_fx_max_proc = p ; 

  p = FUNCCALL(SETUP_XfOrM4(_), scheme_make_folding_prim (unsafe_fl_eq , "unsafe-fl=" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_lt , "unsafe-fl<" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl<" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_gt , "unsafe-fl>" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl>" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_lt_eq , "unsafe-fl<=" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl<=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_gt_eq , "unsafe-fl>=" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-fl>=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_min , "unsafe-flmin" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM4(_), scheme_addto_prim_instance ("unsafe-flmin" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_fl_max , "unsafe-flmax" , 1 , - 1 , 1 ) ); 
  if (0 )
    flags = ((1 << 1 ) | (1 << 2 ) ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (1 << 26 ) 
  | ((1 << 9 ) | (1 << 10 ) ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("unsafe-flmax" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 499 "bc/src/numcomp.c"
void scheme_init_extfl_unsafe_numcomp (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  int flags ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 504 "bc/src/numcomp.c"
  p = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (unsafe_extfl_eq , "unsafe-extfl=" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_lt , "unsafe-extfl<" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl<" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_gt , "unsafe-extfl>" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl>" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_lt_eq , "unsafe-extfl<=" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl<=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_gt_eq , "unsafe-extfl>=" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extfl>=" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_min , "unsafe-extflmin" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("unsafe-extflmin" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_folding_prim (unsafe_extfl_max , "unsafe-extflmax" , 2 , 2 , 1 ) ); 
  if (0 )
    flags = (1 << 1 ) ; 
  else 
  flags = (1 << 17 ) ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags (flags 
  | (1 << 8 ) 
  | (3 << 26 ) 
  | ((1 << 12 ) | (1 << 13 ) ) ) ) ; 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("unsafe-extflmax" , p , env ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 578 "bc/src/numcomp.c"
static inline Scheme_Object * force_rat (Scheme_Object * n , Small_Rational * sr ) ; 

static inline Scheme_Object * force_rat (Scheme_Object * n , Small_Rational * sr ) 
XFORM_SKIP_PROC 
{
  Scheme_Type t = ((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ; 
  if (t == scheme_rational_type )
    return n ; 
  else 
  return scheme_make_small_bn_rational (n , sr ) ; 
}

static Scheme_Object * eq (int argc , Scheme_Object * argv [] ) ; 

# 590 "bc/src/numcomp.c"
static inline Scheme_Object * eq__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {

# 590 "bc/src/numcomp.c"
  Scheme_Object * o ; 

# 590 "bc/src/numcomp.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1), PUSH(p, 2)));
# define XfOrM6_COUNT (3)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 590 "bc/src/numcomp.c"
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM12_COUNT (0+XfOrM6_COUNT)
#   define SETUP_XfOrM12(x) SETUP_XfOrM6(x)

# 590 "bc/src/numcomp.c"
    o = argv [i ] ; 

# 590 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) <= scheme_complex_type ) ) ) ) {
#     define XfOrM16_COUNT (0+XfOrM12_COUNT)
#     define SETUP_XfOrM16(x) SETUP_XfOrM12(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("=" , "number?" , i , argc , argv ) )
# 590 "bc/src/numcomp.c"
      ; 

# 590 "bc/src/numcomp.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 590 "bc/src/numcomp.c"
    if (! FUNCCALL(SETUP_XfOrM12(_), scheme_bin_eq (p , o ) )) {
#     define XfOrM13_COUNT (0+XfOrM12_COUNT)
#     define SETUP_XfOrM13(x) SETUP_XfOrM12(x)

# 590 "bc/src/numcomp.c"
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM15_COUNT (0+XfOrM13_COUNT)
#       define SETUP_XfOrM15(x) SETUP_XfOrM13(x)

# 590 "bc/src/numcomp.c"
        if (! ((((intptr_t ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) <= scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract ("=" , "number?" , i , argc , argv ) )
# 590 "bc/src/numcomp.c"
        ; 
      }

# 590 "bc/src/numcomp.c"
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

# 590 "bc/src/numcomp.c"
    p = o ; 
  }

# 590 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 590 "bc/src/numcomp.c"
static inline Scheme_Object * eq__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */

# 590 "bc/src/numcomp.c"
  return (scheme_bin_eq (a , b ) ? scheme_true : scheme_false ) ; 
}

# 590 "bc/src/numcomp.c"
Scheme_Object * eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 590 "bc/src/numcomp.c"
  Scheme_Object * p , * p2 ; 

# 590 "bc/src/numcomp.c"
  p = argv [0 ] ; 

# 590 "bc/src/numcomp.c"
  if (! ((((intptr_t ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) <= scheme_complex_type ) ) ) )

# 590 "bc/src/numcomp.c"
  scheme_wrong_contract ("=" , "number?" , 0 , argc , argv ) ; 

# 590 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 590 "bc/src/numcomp.c"
    p2 = argv [1 ] ; 

# 590 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) <= scheme_complex_type ) ) ) )

# 590 "bc/src/numcomp.c"
    scheme_wrong_contract ("=" , "number?" , 1 , argc , argv ) ; 

# 590 "bc/src/numcomp.c"
    return eq__bin (p , p2 ) ; 
  }

# 590 "bc/src/numcomp.c"
  else return eq__slow (p , argc , argv ) ; 
}

# 591 "bc/src/numcomp.c"
static Scheme_Object * lt (int argc , Scheme_Object * argv [] ) ; 

# 591 "bc/src/numcomp.c"
static inline Scheme_Object * lt__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {

# 591 "bc/src/numcomp.c"
  Scheme_Object * o ; 

# 591 "bc/src/numcomp.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1), PUSH(p, 2)));
# define XfOrM20_COUNT (3)
# define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 591 "bc/src/numcomp.c"
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM26_COUNT (0+XfOrM20_COUNT)
#   define SETUP_XfOrM26(x) SETUP_XfOrM20(x)

# 591 "bc/src/numcomp.c"
    o = argv [i ] ; 

# 591 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) < scheme_complex_type ) ) ) ) {
#     define XfOrM30_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM30(x) SETUP_XfOrM26(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("<" , "real?" , i , argc , argv ) )
# 591 "bc/src/numcomp.c"
      ; 

# 591 "bc/src/numcomp.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 591 "bc/src/numcomp.c"
    if (! FUNCCALL(SETUP_XfOrM26(_), scheme_bin_lt (p , o ) )) {
#     define XfOrM27_COUNT (0+XfOrM26_COUNT)
#     define SETUP_XfOrM27(x) SETUP_XfOrM26(x)

# 591 "bc/src/numcomp.c"
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM29_COUNT (0+XfOrM27_COUNT)
#       define SETUP_XfOrM29(x) SETUP_XfOrM27(x)

# 591 "bc/src/numcomp.c"
        if (! ((((intptr_t ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract ("<" , "real?" , i , argc , argv ) )
# 591 "bc/src/numcomp.c"
        ; 
      }

# 591 "bc/src/numcomp.c"
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

# 591 "bc/src/numcomp.c"
    p = o ; 
  }

# 591 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 591 "bc/src/numcomp.c"
static inline Scheme_Object * lt__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */

# 591 "bc/src/numcomp.c"
  return (scheme_bin_lt (a , b ) ? scheme_true : scheme_false ) ; 
}

# 591 "bc/src/numcomp.c"
Scheme_Object * lt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 591 "bc/src/numcomp.c"
  Scheme_Object * p , * p2 ; 

# 591 "bc/src/numcomp.c"
  p = argv [0 ] ; 

# 591 "bc/src/numcomp.c"
  if (! ((((intptr_t ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) < scheme_complex_type ) ) ) )

# 591 "bc/src/numcomp.c"
  scheme_wrong_contract ("<" , "real?" , 0 , argc , argv ) ; 

# 591 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 591 "bc/src/numcomp.c"
    p2 = argv [1 ] ; 

# 591 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) < scheme_complex_type ) ) ) )

# 591 "bc/src/numcomp.c"
    scheme_wrong_contract ("<" , "real?" , 1 , argc , argv ) ; 

# 591 "bc/src/numcomp.c"
    return lt__bin (p , p2 ) ; 
  }

# 591 "bc/src/numcomp.c"
  else return lt__slow (p , argc , argv ) ; 
}

# 592 "bc/src/numcomp.c"
static Scheme_Object * gt (int argc , Scheme_Object * argv [] ) ; 

# 592 "bc/src/numcomp.c"
static inline Scheme_Object * gt__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {

# 592 "bc/src/numcomp.c"
  Scheme_Object * o ; 

# 592 "bc/src/numcomp.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1), PUSH(p, 2)));
# define XfOrM34_COUNT (3)
# define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 592 "bc/src/numcomp.c"
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM40_COUNT (0+XfOrM34_COUNT)
#   define SETUP_XfOrM40(x) SETUP_XfOrM34(x)

# 592 "bc/src/numcomp.c"
    o = argv [i ] ; 

# 592 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) < scheme_complex_type ) ) ) ) {
#     define XfOrM44_COUNT (0+XfOrM40_COUNT)
#     define SETUP_XfOrM44(x) SETUP_XfOrM40(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (">" , "real?" , i , argc , argv ) )
# 592 "bc/src/numcomp.c"
      ; 

# 592 "bc/src/numcomp.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 592 "bc/src/numcomp.c"
    if (! FUNCCALL(SETUP_XfOrM40(_), scheme_bin_gt (p , o ) )) {
#     define XfOrM41_COUNT (0+XfOrM40_COUNT)
#     define SETUP_XfOrM41(x) SETUP_XfOrM40(x)

# 592 "bc/src/numcomp.c"
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM43_COUNT (0+XfOrM41_COUNT)
#       define SETUP_XfOrM43(x) SETUP_XfOrM41(x)

# 592 "bc/src/numcomp.c"
        if (! ((((intptr_t ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract (">" , "real?" , i , argc , argv ) )
# 592 "bc/src/numcomp.c"
        ; 
      }

# 592 "bc/src/numcomp.c"
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

# 592 "bc/src/numcomp.c"
    p = o ; 
  }

# 592 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 592 "bc/src/numcomp.c"
static inline Scheme_Object * gt__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */

# 592 "bc/src/numcomp.c"
  return (scheme_bin_gt (a , b ) ? scheme_true : scheme_false ) ; 
}

# 592 "bc/src/numcomp.c"
Scheme_Object * gt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 592 "bc/src/numcomp.c"
  Scheme_Object * p , * p2 ; 

# 592 "bc/src/numcomp.c"
  p = argv [0 ] ; 

# 592 "bc/src/numcomp.c"
  if (! ((((intptr_t ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) < scheme_complex_type ) ) ) )

# 592 "bc/src/numcomp.c"
  scheme_wrong_contract (">" , "real?" , 0 , argc , argv ) ; 

# 592 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 592 "bc/src/numcomp.c"
    p2 = argv [1 ] ; 

# 592 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) < scheme_complex_type ) ) ) )

# 592 "bc/src/numcomp.c"
    scheme_wrong_contract (">" , "real?" , 1 , argc , argv ) ; 

# 592 "bc/src/numcomp.c"
    return gt__bin (p , p2 ) ; 
  }

# 592 "bc/src/numcomp.c"
  else return gt__slow (p , argc , argv ) ; 
}

# 593 "bc/src/numcomp.c"
static Scheme_Object * lt_eq (int argc , Scheme_Object * argv [] ) ; 

# 593 "bc/src/numcomp.c"
static inline Scheme_Object * lt_eq__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {

# 593 "bc/src/numcomp.c"
  Scheme_Object * o ; 

# 593 "bc/src/numcomp.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1), PUSH(p, 2)));
# define XfOrM48_COUNT (3)
# define SETUP_XfOrM48(x) SETUP(XfOrM48_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 593 "bc/src/numcomp.c"
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM54_COUNT (0+XfOrM48_COUNT)
#   define SETUP_XfOrM54(x) SETUP_XfOrM48(x)

# 593 "bc/src/numcomp.c"
    o = argv [i ] ; 

# 593 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) < scheme_complex_type ) ) ) ) {
#     define XfOrM58_COUNT (0+XfOrM54_COUNT)
#     define SETUP_XfOrM58(x) SETUP_XfOrM54(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("<=" , "real?" , i , argc , argv ) )
# 593 "bc/src/numcomp.c"
      ; 

# 593 "bc/src/numcomp.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 593 "bc/src/numcomp.c"
    if (! FUNCCALL(SETUP_XfOrM54(_), scheme_bin_lt_eq (p , o ) )) {
#     define XfOrM55_COUNT (0+XfOrM54_COUNT)
#     define SETUP_XfOrM55(x) SETUP_XfOrM54(x)

# 593 "bc/src/numcomp.c"
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM57_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM57(x) SETUP_XfOrM55(x)

# 593 "bc/src/numcomp.c"
        if (! ((((intptr_t ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract ("<=" , "real?" , i , argc , argv ) )
# 593 "bc/src/numcomp.c"
        ; 
      }

# 593 "bc/src/numcomp.c"
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

# 593 "bc/src/numcomp.c"
    p = o ; 
  }

# 593 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 593 "bc/src/numcomp.c"
static inline Scheme_Object * lt_eq__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */

# 593 "bc/src/numcomp.c"
  return (scheme_bin_lt_eq (a , b ) ? scheme_true : scheme_false ) ; 
}

# 593 "bc/src/numcomp.c"
Scheme_Object * lt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 593 "bc/src/numcomp.c"
  Scheme_Object * p , * p2 ; 

# 593 "bc/src/numcomp.c"
  p = argv [0 ] ; 

# 593 "bc/src/numcomp.c"
  if (! ((((intptr_t ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) < scheme_complex_type ) ) ) )

# 593 "bc/src/numcomp.c"
  scheme_wrong_contract ("<=" , "real?" , 0 , argc , argv ) ; 

# 593 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 593 "bc/src/numcomp.c"
    p2 = argv [1 ] ; 

# 593 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) < scheme_complex_type ) ) ) )

# 593 "bc/src/numcomp.c"
    scheme_wrong_contract ("<=" , "real?" , 1 , argc , argv ) ; 

# 593 "bc/src/numcomp.c"
    return lt_eq__bin (p , p2 ) ; 
  }

# 593 "bc/src/numcomp.c"
  else return lt_eq__slow (p , argc , argv ) ; 
}

# 594 "bc/src/numcomp.c"
static Scheme_Object * gt_eq (int argc , Scheme_Object * argv [] ) ; 

# 594 "bc/src/numcomp.c"
static inline Scheme_Object * gt_eq__slow (Scheme_Object * p , int argc , Scheme_Object * argv [] ) {

# 594 "bc/src/numcomp.c"
  Scheme_Object * o ; 

# 594 "bc/src/numcomp.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1), PUSH(p, 2)));
# define XfOrM62_COUNT (3)
# define SETUP_XfOrM62(x) SETUP(XfOrM62_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 594 "bc/src/numcomp.c"
  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM68_COUNT (0+XfOrM62_COUNT)
#   define SETUP_XfOrM68(x) SETUP_XfOrM62(x)

# 594 "bc/src/numcomp.c"
    o = argv [i ] ; 

# 594 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) < scheme_complex_type ) ) ) ) {
#     define XfOrM72_COUNT (0+XfOrM68_COUNT)
#     define SETUP_XfOrM72(x) SETUP_XfOrM68(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (">=" , "real?" , i , argc , argv ) )
# 594 "bc/src/numcomp.c"
      ; 

# 594 "bc/src/numcomp.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 594 "bc/src/numcomp.c"
    if (! FUNCCALL(SETUP_XfOrM68(_), scheme_bin_gt_eq (p , o ) )) {
#     define XfOrM69_COUNT (0+XfOrM68_COUNT)
#     define SETUP_XfOrM69(x) SETUP_XfOrM68(x)

# 594 "bc/src/numcomp.c"
      for (i ++ ; i < argc ; i ++ ) {
#       define XfOrM71_COUNT (0+XfOrM69_COUNT)
#       define SETUP_XfOrM71(x) SETUP_XfOrM69(x)

# 594 "bc/src/numcomp.c"
        if (! ((((intptr_t ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract (">=" , "real?" , i , argc , argv ) )
# 594 "bc/src/numcomp.c"
        ; 
      }

# 594 "bc/src/numcomp.c"
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

# 594 "bc/src/numcomp.c"
    p = o ; 
  }

# 594 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 594 "bc/src/numcomp.c"
static inline Scheme_Object * gt_eq__bin (Scheme_Object * a , Scheme_Object * b ) {
  /* No conversion */

# 594 "bc/src/numcomp.c"
  return (scheme_bin_gt_eq (a , b ) ? scheme_true : scheme_false ) ; 
}

# 594 "bc/src/numcomp.c"
Scheme_Object * gt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 594 "bc/src/numcomp.c"
  Scheme_Object * p , * p2 ; 

# 594 "bc/src/numcomp.c"
  p = argv [0 ] ; 

# 594 "bc/src/numcomp.c"
  if (! ((((intptr_t ) (p ) ) & 0x1 ) || ((((p ) -> type ) >= scheme_bignum_type ) && (((p ) -> type ) < scheme_complex_type ) ) ) )

# 594 "bc/src/numcomp.c"
  scheme_wrong_contract (">=" , "real?" , 0 , argc , argv ) ; 

# 594 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 594 "bc/src/numcomp.c"
    p2 = argv [1 ] ; 

# 594 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (p2 ) ) & 0x1 ) || ((((p2 ) -> type ) >= scheme_bignum_type ) && (((p2 ) -> type ) < scheme_complex_type ) ) ) )

# 594 "bc/src/numcomp.c"
    scheme_wrong_contract (">=" , "real?" , 1 , argc , argv ) ; 

# 594 "bc/src/numcomp.c"
    return gt_eq__bin (p , p2 ) ; 
  }

# 594 "bc/src/numcomp.c"
  else return gt_eq__slow (p , argc , argv ) ; 
}

# 624 "bc/src/numcomp.c"
static int ieEQUAL (double x , intptr_t y ) {
  /* No conversion */

# 624 "bc/src/numcomp.c"
  if (((- ((intptr_t ) 1 << 53 ) ) <= y ) && (y <= ((intptr_t ) 1 << 53 ) ) )

# 624 "bc/src/numcomp.c"
  return (x == y ) ; 

# 624 "bc/src/numcomp.c"
  if (__builtin_isnan (x ) )

# 624 "bc/src/numcomp.c"
  return 0 ; 

# 624 "bc/src/numcomp.c"
  if (x >= scheme_double_too_positive_for_fixnum )

# 624 "bc/src/numcomp.c"
  return 0 ; 

# 624 "bc/src/numcomp.c"
  if (x <= scheme_double_too_negative_for_fixnum )

# 624 "bc/src/numcomp.c"
  return 0 ; 

# 624 "bc/src/numcomp.c"
  return ((intptr_t ) x == y ) ; 
}

# 625 "bc/src/numcomp.c"
static int ieLESS_THAN (double x , intptr_t y ) {
  /* No conversion */

# 625 "bc/src/numcomp.c"
  if (((- ((intptr_t ) 1 << 53 ) ) <= y ) && (y <= ((intptr_t ) 1 << 53 ) ) )

# 625 "bc/src/numcomp.c"
  return (x < y ) ; 

# 625 "bc/src/numcomp.c"
  if (__builtin_isnan (x ) )

# 625 "bc/src/numcomp.c"
  return 0 ; 

# 625 "bc/src/numcomp.c"
  if (x >= scheme_double_too_positive_for_fixnum )

# 625 "bc/src/numcomp.c"
  return 0 ; 

# 625 "bc/src/numcomp.c"
  if (x <= scheme_double_too_negative_for_fixnum )

# 625 "bc/src/numcomp.c"
  return 1 ; 

# 625 "bc/src/numcomp.c"
  return ((intptr_t ) x < y ) ; 
}

# 626 "bc/src/numcomp.c"
static int ieLESS_OR_EQUAL (double x , intptr_t y ) {
  /* No conversion */

# 626 "bc/src/numcomp.c"
  if (((- ((intptr_t ) 1 << 53 ) ) <= y ) && (y <= ((intptr_t ) 1 << 53 ) ) )

# 626 "bc/src/numcomp.c"
  return (x <= y ) ; 

# 626 "bc/src/numcomp.c"
  if (__builtin_isnan (x ) )

# 626 "bc/src/numcomp.c"
  return 0 ; 

# 626 "bc/src/numcomp.c"
  if (x >= scheme_double_too_positive_for_fixnum )

# 626 "bc/src/numcomp.c"
  return 0 ; 

# 626 "bc/src/numcomp.c"
  if (x <= scheme_double_too_negative_for_fixnum )

# 626 "bc/src/numcomp.c"
  return 1 ; 

# 626 "bc/src/numcomp.c"
  return ((intptr_t ) x <= y ) ; 
}

# 627 "bc/src/numcomp.c"
static int ieGREATER_THAN (double x , intptr_t y ) {
  /* No conversion */

# 627 "bc/src/numcomp.c"
  if (((- ((intptr_t ) 1 << 53 ) ) <= y ) && (y <= ((intptr_t ) 1 << 53 ) ) )

# 627 "bc/src/numcomp.c"
  return (x > y ) ; 

# 627 "bc/src/numcomp.c"
  if (__builtin_isnan (x ) )

# 627 "bc/src/numcomp.c"
  return 0 ; 

# 627 "bc/src/numcomp.c"
  if (x >= scheme_double_too_positive_for_fixnum )

# 627 "bc/src/numcomp.c"
  return 1 ; 

# 627 "bc/src/numcomp.c"
  if (x <= scheme_double_too_negative_for_fixnum )

# 627 "bc/src/numcomp.c"
  return 0 ; 

# 627 "bc/src/numcomp.c"
  return ((intptr_t ) x > y ) ; 
}

# 628 "bc/src/numcomp.c"
static int ieGREATER_OR_EQUAL (double x , intptr_t y ) {
  /* No conversion */

# 628 "bc/src/numcomp.c"
  if (((- ((intptr_t ) 1 << 53 ) ) <= y ) && (y <= ((intptr_t ) 1 << 53 ) ) )

# 628 "bc/src/numcomp.c"
  return (x >= y ) ; 

# 628 "bc/src/numcomp.c"
  if (__builtin_isnan (x ) )

# 628 "bc/src/numcomp.c"
  return 0 ; 

# 628 "bc/src/numcomp.c"
  if (x >= scheme_double_too_positive_for_fixnum )

# 628 "bc/src/numcomp.c"
  return 1 ; 

# 628 "bc/src/numcomp.c"
  if (x <= scheme_double_too_negative_for_fixnum )

# 628 "bc/src/numcomp.c"
  return 0 ; 

# 628 "bc/src/numcomp.c"
  return ((intptr_t ) x >= y ) ; 
}

# 650 "bc/src/numcomp.c"
int scheme_bin_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 650 "bc/src/numcomp.c"
static int scheme_bin_eq__wrong_contract (const Scheme_Object * v ) {

# 650 "bc/src/numcomp.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM81_COUNT (3)
# define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM81(_), scheme_wrong_contract ("=" , "number?" , - 1 , 0 , a ) )
# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 650 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  return scheme_bignum_eq ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 650 "bc/src/numcomp.c"
  Small_Rational sr1 ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  return scheme_rational_eq ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) ; 
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM84_COUNT (2)
# define SETUP_XfOrM84(x) SETUP(XfOrM84_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM84(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Rational sr2 ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg58, 0), PUSH(sr2.num, 1), PUSH(sr2.denom, 2), PUSH(n2, 3)));
# define XfOrM85_COUNT (4)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr2.num = NULLED_OUT ; 
  sr2.denom = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg58 = (__funcarg60 = FUNCCALL(SETUP_XfOrM85(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg60 , & sr2 ) )) , __funcarg59 = FUNCCALL(SETUP_XfOrM85(_), scheme_integer_to_rational (n2 ) ), (scheme_rational_eq (__funcarg58 , __funcarg59 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Rational sr3 ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr3.num, 0), PUSH(sr3.denom, 1), PUSH(n2, 2)));
# define XfOrM86_COUNT (3)
# define SETUP_XfOrM86(x) SETUP(XfOrM86_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr3.num = NULLED_OUT ; 
  sr3.denom = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_inexact (n2 ) ) ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg61 = (__funcarg62 = FUNCCALL(SETUP_XfOrM86(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg62 , & sr3 ) )) , (scheme_rational_eq (__funcarg61 , (n2 ) ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__flt_comp (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM87_COUNT (2)
# define SETUP_XfOrM87(x) SETUP(XfOrM87_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM87(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(sr4.num, 0), PUSH(sr4.denom, 1), PUSH(__funcarg63, 2), PUSH(n2, 3)));
# define XfOrM88_COUNT (4)
# define SETUP_XfOrM88(x) SETUP(XfOrM88_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg63 = (__funcarg65 = FUNCCALL(SETUP_XfOrM88(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg65 , & sr4 ) )) , __funcarg64 = FUNCCALL(SETUP_XfOrM88(_), scheme_integer_to_rational (n2 ) ), (scheme_rational_eq (__funcarg63 , __funcarg64 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM89_COUNT (3)
# define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_inexact (n2 ) ) ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg66 = (__funcarg67 = FUNCCALL(SETUP_XfOrM89(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg67 , & sr5 ) )) , (scheme_rational_eq (__funcarg66 , (n2 ) ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM90_COUNT (2)
# define SETUP_XfOrM90(x) SETUP(XfOrM90_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM90(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 650 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  return scheme_bignum_eq ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  float d2 ; 

# 650 "bc/src/numcomp.c"
  Small_Rational sr6 ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg68, 0), PUSH(sr6.num, 1), PUSH(sr6.denom, 2)));
# define XfOrM92_COUNT (3)
# define SETUP_XfOrM92(x) SETUP(XfOrM92_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr6.num = NULLED_OUT ; 
  sr6.denom = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg68 = FUNCCALL(SETUP_XfOrM92(_), scheme_integer_to_rational (n1 ) ), __funcarg69 = (__funcarg70 = FUNCCALL(SETUP_XfOrM92(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg70 , & sr6 ) )) , (scheme_rational_eq (__funcarg68 , __funcarg69 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  double d2 ; 

# 650 "bc/src/numcomp.c"
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg71, 0), PUSH(sr7.num, 1), PUSH(sr7.denom, 2)));
# define XfOrM93_COUNT (3)
# define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg71 = FUNCCALL(SETUP_XfOrM93(_), scheme_integer_to_rational (n1 ) ), __funcarg72 = (__funcarg73 = FUNCCALL(SETUP_XfOrM93(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg73 , & sr7 ) )) , (scheme_rational_eq (__funcarg71 , __funcarg72 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM94_COUNT (1)
# define SETUP_XfOrM94(x) SETUP(XfOrM94_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg74 = FUNCCALL(SETUP_XfOrM94(_), scheme_integer_to_rational (n1 ) ), (scheme_rational_eq (__funcarg74 , (n2 ) ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM95_COUNT (2)
# define SETUP_XfOrM95(x) SETUP(XfOrM95_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM95(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 650 "bc/src/numcomp.c"
  Small_Rational sr8 ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  return scheme_rational_eq ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) ; 
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  float d2 ; 

# 650 "bc/src/numcomp.c"
  Small_Rational sr9 ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr9.num, 1), PUSH(sr9.denom, 2)));
# define XfOrM97_COUNT (3)
# define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr9.num = NULLED_OUT ; 
  sr9.denom = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_inexact (n1 ) ) ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg75 = (__funcarg76 = FUNCCALL(SETUP_XfOrM97(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg76 , & sr9 ) )) , (scheme_rational_eq ((n1 ) , __funcarg75 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  double d2 ; 

# 650 "bc/src/numcomp.c"
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr10.num, 1), PUSH(sr10.denom, 2)));
# define XfOrM98_COUNT (3)
# define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_inexact (n1 ) ) ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg77 = (__funcarg78 = FUNCCALL(SETUP_XfOrM98(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg78 , & sr10 ) )) , (scheme_rational_eq ((n1 ) , __funcarg77 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM99_COUNT (1)
# define SETUP_XfOrM99(x) SETUP(XfOrM99_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 650 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg79 = FUNCCALL(SETUP_XfOrM99(_), scheme_integer_to_rational (n2 ) ), (scheme_rational_eq ((n1 ) , __funcarg79 ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM100_COUNT (2)
# define SETUP_XfOrM100(x) SETUP(XfOrM100_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM100(_), scheme_complex_eq ((scheme_make_small_complex (n1 , & sc ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM101_COUNT (2)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM101(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__comp_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM102_COUNT (2)
# define SETUP_XfOrM102(x) SETUP(XfOrM102_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan ((((Scheme_Float * ) (n2 ) ) -> float_val ) ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM102(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM103_COUNT (2)
# define SETUP_XfOrM103(x) SETUP(XfOrM103_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  if (__builtin_isnan ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) )

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM103(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM104_COUNT (2)
# define SETUP_XfOrM104(x) SETUP(XfOrM104_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM104(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
static inline int scheme_bin_eq__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 650 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM105_COUNT (2)
# define SETUP_XfOrM105(x) SETUP(XfOrM105_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 650 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM105(_), scheme_complex_eq ((n1 ) , (scheme_make_small_complex (n2 , & sc ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 650 "bc/src/numcomp.c"
int scheme_bin_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 650 "bc/src/numcomp.c"
  Scheme_Type t1 , t2 ; 

# 650 "bc/src/numcomp.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 650 "bc/src/numcomp.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 650 "bc/src/numcomp.c"
    return ((((intptr_t ) (n1 ) ) >> 1 ) == (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 650 "bc/src/numcomp.c"
    t2 = ((n2 ) -> type ) ; 

# 650 "bc/src/numcomp.c"
    if (t2 == scheme_float_type ) {

# 650 "bc/src/numcomp.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 650 "bc/src/numcomp.c"
      ; 

# 650 "bc/src/numcomp.c"
      return ieEQUAL (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 650 "bc/src/numcomp.c"
    if (t2 == scheme_double_type ) {

# 650 "bc/src/numcomp.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 650 "bc/src/numcomp.c"
      ; 

# 650 "bc/src/numcomp.c"
      return ieEQUAL (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 650 "bc/src/numcomp.c"
    if (t2 == scheme_bignum_type ) {

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__int_big (n1 , n2 ) ; 
    }

# 650 "bc/src/numcomp.c"
    if (t2 == scheme_rational_type ) {

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__int_rat (n1 , n2 ) ; 
    }

# 650 "bc/src/numcomp.c"
    if (t2 == scheme_complex_type )  {

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__int_comp (n1 , n2 ) ; 
    }

# 650 "bc/src/numcomp.c"
    return scheme_bin_eq__wrong_contract (n2 ) ; 
  }

# 650 "bc/src/numcomp.c"
  else {

# 650 "bc/src/numcomp.c"
    t1 = ((n1 ) -> type ) ; 

# 650 "bc/src/numcomp.c"
    if (t1 == scheme_float_type ) {

# 650 "bc/src/numcomp.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 650 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        return ieEQUAL (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 650 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 650 "bc/src/numcomp.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        return (d1 == d2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 650 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        return (d1 == d2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__flt_big (d1 , n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__flt_rat (d1 , n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__flt_comp (d1 , n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__wrong_contract (n2 ) ; 
    }

# 650 "bc/src/numcomp.c"
    else if (t1 == scheme_double_type ) {

# 650 "bc/src/numcomp.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 650 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        return ieEQUAL (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 650 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 650 "bc/src/numcomp.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        return (d1 == d2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 650 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        ; 

# 650 "bc/src/numcomp.c"
        return (d1 == d2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__dbl_big (d1 , n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__dbl_comp (d1 , n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__wrong_contract (n2 ) ; 
    }

# 650 "bc/src/numcomp.c"
    else if (t1 == scheme_bignum_type ) {

# 650 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__big_int (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__big_flt (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__big_dbl (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 650 "bc/src/numcomp.c"
      return scheme_bignum_eq ((n1 ) , (n2 ) ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__big_rat (n1 , n2 ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__big_comp (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__wrong_contract (n2 ) ; 
    }

# 650 "bc/src/numcomp.c"
    else if (t1 == scheme_rational_type ) {

# 650 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__rat_int (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__rat_flt (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__rat_dbl (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__rat_big (n1 , n2 ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 650 "bc/src/numcomp.c"
      return scheme_rational_eq ((n1 ) , (n2 ) ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__rat_comp (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__wrong_contract (n2 ) ; 
    }

# 650 "bc/src/numcomp.c"
    else if (t1 == scheme_complex_type )  {

# 650 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__comp_int (n1 , n2 ) ; 

# 650 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__comp_flt (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 650 "bc/src/numcomp.c"
        return scheme_bin_eq__comp_dbl (n1 , n2 ) ; 
      }

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__comp_big (n1 , n2 ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__comp_rat (n1 , n2 ) ; 

# 650 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type ) 

# 650 "bc/src/numcomp.c"
      return scheme_complex_eq ((n1 ) , (n2 ) ) ; 

# 650 "bc/src/numcomp.c"
      return scheme_bin_eq__wrong_contract (n2 ) ; 
    }

# 650 "bc/src/numcomp.c"
    else return scheme_bin_eq__wrong_contract (n1 ) ; 
  }
}

# 651 "bc/src/numcomp.c"
int scheme_bin_lt (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 651 "bc/src/numcomp.c"
static int scheme_bin_lt__wrong_contract (const Scheme_Object * v ) {

# 651 "bc/src/numcomp.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM141_COUNT (3)
# define SETUP_XfOrM141(x) SETUP(XfOrM141_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM141(_), scheme_wrong_contract ("<" , "real?" , - 1 , 0 , a ) )
# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 651 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  return scheme_bignum_lt ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM143_COUNT (2)
# define SETUP_XfOrM143(x) SETUP(XfOrM143_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM143(_), scheme_rational_lt ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  Small_Rational sr2 ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(sr2.num, 0), PUSH(sr2.denom, 1), PUSH(__funcarg80, 2), PUSH(n2, 3)));
# define XfOrM144_COUNT (4)
# define SETUP_XfOrM144(x) SETUP(XfOrM144_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr2.num = NULLED_OUT ; 
  sr2.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg80 = (__funcarg82 = FUNCCALL(SETUP_XfOrM144(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg82 , & sr2 ) )) , __funcarg81 = FUNCCALL(SETUP_XfOrM144(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_lt (__funcarg80 , __funcarg81 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  Small_Rational sr3 ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr3.num, 0), PUSH(sr3.denom, 1), PUSH(n2, 2)));
# define XfOrM145_COUNT (3)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr3.num = NULLED_OUT ; 
  sr3.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_positive (n2 ) ) ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg83 = (__funcarg84 = FUNCCALL(SETUP_XfOrM145(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg84 , & sr3 ) )) , FUNCCALL_AGAIN(scheme_rational_lt (__funcarg83 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(sr4.num, 0), PUSH(sr4.denom, 1), PUSH(__funcarg85, 2), PUSH(n2, 3)));
# define XfOrM146_COUNT (4)
# define SETUP_XfOrM146(x) SETUP(XfOrM146_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg85 = (__funcarg87 = FUNCCALL(SETUP_XfOrM146(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg87 , & sr4 ) )) , __funcarg86 = FUNCCALL(SETUP_XfOrM146(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_lt (__funcarg85 , __funcarg86 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM147_COUNT (3)
# define SETUP_XfOrM147(x) SETUP(XfOrM147_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_positive (n2 ) ) ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg88 = (__funcarg89 = FUNCCALL(SETUP_XfOrM147(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg89 , & sr5 ) )) , FUNCCALL_AGAIN(scheme_rational_lt (__funcarg88 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 651 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  return scheme_bignum_lt ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  float d2 ; 

# 651 "bc/src/numcomp.c"
  Small_Rational sr6 ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg90, 0), PUSH(sr6.num, 1), PUSH(sr6.denom, 2)));
# define XfOrM149_COUNT (3)
# define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr6.num = NULLED_OUT ; 
  sr6.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg90 = FUNCCALL(SETUP_XfOrM149(_), scheme_integer_to_rational (n1 ) ), __funcarg91 = (__funcarg92 = FUNCCALL(SETUP_XfOrM149(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg92 , & sr6 ) )) , FUNCCALL_AGAIN(scheme_rational_lt (__funcarg90 , __funcarg91 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  double d2 ; 

# 651 "bc/src/numcomp.c"
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg93, 0), PUSH(sr7.num, 1), PUSH(sr7.denom, 2)));
# define XfOrM150_COUNT (3)
# define SETUP_XfOrM150(x) SETUP(XfOrM150_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg93 = FUNCCALL(SETUP_XfOrM150(_), scheme_integer_to_rational (n1 ) ), __funcarg94 = (__funcarg95 = FUNCCALL(SETUP_XfOrM150(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg95 , & sr7 ) )) , FUNCCALL_AGAIN(scheme_rational_lt (__funcarg93 , __funcarg94 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM151_COUNT (1)
# define SETUP_XfOrM151(x) SETUP(XfOrM151_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg96 = FUNCCALL(SETUP_XfOrM151(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_lt (__funcarg96 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM152_COUNT (2)
# define SETUP_XfOrM152(x) SETUP(XfOrM152_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM152(_), scheme_rational_lt ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  float d2 ; 

# 651 "bc/src/numcomp.c"
  Small_Rational sr9 ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr9.num, 1), PUSH(sr9.denom, 2)));
# define XfOrM153_COUNT (3)
# define SETUP_XfOrM153(x) SETUP(XfOrM153_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr9.num = NULLED_OUT ; 
  sr9.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_negative (n1 ) ) ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg97 = (__funcarg98 = FUNCCALL(SETUP_XfOrM153(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg98 , & sr9 ) )) , FUNCCALL_AGAIN(scheme_rational_lt ((n1 ) , __funcarg97 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 651 "bc/src/numcomp.c"
  double d2 ; 

# 651 "bc/src/numcomp.c"
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr10.num, 1), PUSH(sr10.denom, 2)));
# define XfOrM154_COUNT (3)
# define SETUP_XfOrM154(x) SETUP(XfOrM154_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 

# 651 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_negative (n1 ) ) ) RET_VALUE_END ; 

# 651 "bc/src/numcomp.c"
  ; 

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg99 = (__funcarg100 = FUNCCALL(SETUP_XfOrM154(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg100 , & sr10 ) )) , FUNCCALL_AGAIN(scheme_rational_lt ((n1 ) , __funcarg99 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
static inline int scheme_bin_lt__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM155_COUNT (1)
# define SETUP_XfOrM155(x) SETUP(XfOrM155_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 651 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg101 = FUNCCALL(SETUP_XfOrM155(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_lt ((n1 ) , __funcarg101 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 651 "bc/src/numcomp.c"
int scheme_bin_lt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 651 "bc/src/numcomp.c"
  Scheme_Type t1 , t2 ; 

# 651 "bc/src/numcomp.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 651 "bc/src/numcomp.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 651 "bc/src/numcomp.c"
    return ((((intptr_t ) (n1 ) ) >> 1 ) < (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 651 "bc/src/numcomp.c"
    t2 = ((n2 ) -> type ) ; 

# 651 "bc/src/numcomp.c"
    if (t2 == scheme_float_type ) {

# 651 "bc/src/numcomp.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 651 "bc/src/numcomp.c"
      ; 

# 651 "bc/src/numcomp.c"
      return ieGREATER_THAN (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 651 "bc/src/numcomp.c"
    if (t2 == scheme_double_type ) {

# 651 "bc/src/numcomp.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 651 "bc/src/numcomp.c"
      ; 

# 651 "bc/src/numcomp.c"
      return ieGREATER_THAN (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 651 "bc/src/numcomp.c"
    if (t2 == scheme_bignum_type ) {

# 651 "bc/src/numcomp.c"
      return scheme_bin_lt__int_big (n1 , n2 ) ; 
    }

# 651 "bc/src/numcomp.c"
    if (t2 == scheme_rational_type ) {

# 651 "bc/src/numcomp.c"
      return scheme_bin_lt__int_rat (n1 , n2 ) ; 
    }

# 651 "bc/src/numcomp.c"
    return scheme_bin_lt__wrong_contract (n2 ) ; 
  }

# 651 "bc/src/numcomp.c"
  else {

# 651 "bc/src/numcomp.c"
    t1 = ((n1 ) -> type ) ; 

# 651 "bc/src/numcomp.c"
    if (t1 == scheme_float_type ) {

# 651 "bc/src/numcomp.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 651 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        return ieLESS_THAN (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 651 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 651 "bc/src/numcomp.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        return (d1 < d2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 651 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        return (d1 < d2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__flt_big (d1 , n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__flt_rat (d1 , n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      return scheme_bin_lt__wrong_contract (n2 ) ; 
    }

# 651 "bc/src/numcomp.c"
    else if (t1 == scheme_double_type ) {

# 651 "bc/src/numcomp.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 651 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        return ieLESS_THAN (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 651 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 651 "bc/src/numcomp.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        return (d1 < d2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 651 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        ; 

# 651 "bc/src/numcomp.c"
        return (d1 < d2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__dbl_big (d1 , n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      return scheme_bin_lt__wrong_contract (n2 ) ; 
    }

# 651 "bc/src/numcomp.c"
    else if (t1 == scheme_bignum_type ) {

# 651 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__big_int (n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__big_flt (n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__big_dbl (n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 651 "bc/src/numcomp.c"
      return scheme_bignum_lt ((n1 ) , (n2 ) ) ; 

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 651 "bc/src/numcomp.c"
      return scheme_bin_lt__big_rat (n1 , n2 ) ; 

# 651 "bc/src/numcomp.c"
      return scheme_bin_lt__wrong_contract (n2 ) ; 
    }

# 651 "bc/src/numcomp.c"
    else if (t1 == scheme_rational_type ) {

# 651 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__rat_int (n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__rat_flt (n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 651 "bc/src/numcomp.c"
        return scheme_bin_lt__rat_dbl (n1 , n2 ) ; 
      }

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 651 "bc/src/numcomp.c"
      return scheme_bin_lt__rat_big (n1 , n2 ) ; 

# 651 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 651 "bc/src/numcomp.c"
      return scheme_rational_lt ((n1 ) , (n2 ) ) ; 

# 651 "bc/src/numcomp.c"
      return scheme_bin_lt__wrong_contract (n2 ) ; 
    }

# 651 "bc/src/numcomp.c"
    else return scheme_bin_lt__wrong_contract (n1 ) ; 
  }
}

# 652 "bc/src/numcomp.c"
int scheme_bin_gt (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 652 "bc/src/numcomp.c"
static int scheme_bin_gt__wrong_contract (const Scheme_Object * v ) {

# 652 "bc/src/numcomp.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM183_COUNT (3)
# define SETUP_XfOrM183(x) SETUP(XfOrM183_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM183(_), scheme_wrong_contract (">" , "real?" , - 1 , 0 , a ) )
# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 652 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  return scheme_bignum_gt ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM185_COUNT (2)
# define SETUP_XfOrM185(x) SETUP(XfOrM185_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM185(_), scheme_rational_gt ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  Small_Rational sr2 ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg102, 0), PUSH(sr2.num, 1), PUSH(sr2.denom, 2), PUSH(n2, 3)));
# define XfOrM186_COUNT (4)
# define SETUP_XfOrM186(x) SETUP(XfOrM186_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr2.num = NULLED_OUT ; 
  sr2.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg102 = (__funcarg104 = FUNCCALL(SETUP_XfOrM186(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg104 , & sr2 ) )) , __funcarg103 = FUNCCALL(SETUP_XfOrM186(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_gt (__funcarg102 , __funcarg103 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  Small_Rational sr3 ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr3.num, 0), PUSH(sr3.denom, 1), PUSH(n2, 2)));
# define XfOrM187_COUNT (3)
# define SETUP_XfOrM187(x) SETUP(XfOrM187_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr3.num = NULLED_OUT ; 
  sr3.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_negative (n2 ) ) ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg105 = (__funcarg106 = FUNCCALL(SETUP_XfOrM187(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg106 , & sr3 ) )) , FUNCCALL_AGAIN(scheme_rational_gt (__funcarg105 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(sr4.num, 0), PUSH(sr4.denom, 1), PUSH(__funcarg107, 2), PUSH(n2, 3)));
# define XfOrM188_COUNT (4)
# define SETUP_XfOrM188(x) SETUP(XfOrM188_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg107 = (__funcarg109 = FUNCCALL(SETUP_XfOrM188(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg109 , & sr4 ) )) , __funcarg108 = FUNCCALL(SETUP_XfOrM188(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_gt (__funcarg107 , __funcarg108 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM189_COUNT (3)
# define SETUP_XfOrM189(x) SETUP(XfOrM189_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_negative (n2 ) ) ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg110 = (__funcarg111 = FUNCCALL(SETUP_XfOrM189(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg111 , & sr5 ) )) , FUNCCALL_AGAIN(scheme_rational_gt (__funcarg110 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 652 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  return scheme_bignum_gt ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  float d2 ; 

# 652 "bc/src/numcomp.c"
  Small_Rational sr6 ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr6.num, 0), PUSH(sr6.denom, 1), PUSH(__funcarg112, 2)));
# define XfOrM191_COUNT (3)
# define SETUP_XfOrM191(x) SETUP(XfOrM191_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr6.num = NULLED_OUT ; 
  sr6.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg112 = FUNCCALL(SETUP_XfOrM191(_), scheme_integer_to_rational (n1 ) ), __funcarg113 = (__funcarg114 = FUNCCALL(SETUP_XfOrM191(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg114 , & sr6 ) )) , FUNCCALL_AGAIN(scheme_rational_gt (__funcarg112 , __funcarg113 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  double d2 ; 

# 652 "bc/src/numcomp.c"
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg117 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg116 = NULLED_OUT ; 
  Scheme_Object * __funcarg115 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr7.num, 0), PUSH(sr7.denom, 1), PUSH(__funcarg115, 2)));
# define XfOrM192_COUNT (3)
# define SETUP_XfOrM192(x) SETUP(XfOrM192_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg115 = FUNCCALL(SETUP_XfOrM192(_), scheme_integer_to_rational (n1 ) ), __funcarg116 = (__funcarg117 = FUNCCALL(SETUP_XfOrM192(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg117 , & sr7 ) )) , FUNCCALL_AGAIN(scheme_rational_gt (__funcarg115 , __funcarg116 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg118 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM193_COUNT (1)
# define SETUP_XfOrM193(x) SETUP(XfOrM193_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg118 = FUNCCALL(SETUP_XfOrM193(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_gt (__funcarg118 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM194_COUNT (2)
# define SETUP_XfOrM194(x) SETUP(XfOrM194_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM194(_), scheme_rational_gt ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  float d2 ; 

# 652 "bc/src/numcomp.c"
  Small_Rational sr9 ; 
  Scheme_Object * __funcarg120 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg119 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr9.num, 1), PUSH(sr9.denom, 2)));
# define XfOrM195_COUNT (3)
# define SETUP_XfOrM195(x) SETUP(XfOrM195_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr9.num = NULLED_OUT ; 
  sr9.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_positive (n1 ) ) ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg119 = (__funcarg120 = FUNCCALL(SETUP_XfOrM195(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg120 , & sr9 ) )) , FUNCCALL_AGAIN(scheme_rational_gt ((n1 ) , __funcarg119 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 652 "bc/src/numcomp.c"
  double d2 ; 

# 652 "bc/src/numcomp.c"
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg122 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg121 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr10.num, 1), PUSH(sr10.denom, 2)));
# define XfOrM196_COUNT (3)
# define SETUP_XfOrM196(x) SETUP(XfOrM196_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 

# 652 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_positive (n1 ) ) ) RET_VALUE_END ; 

# 652 "bc/src/numcomp.c"
  ; 

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg121 = (__funcarg122 = FUNCCALL(SETUP_XfOrM196(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg122 , & sr10 ) )) , FUNCCALL_AGAIN(scheme_rational_gt ((n1 ) , __funcarg121 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
static inline int scheme_bin_gt__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg123 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM197_COUNT (1)
# define SETUP_XfOrM197(x) SETUP(XfOrM197_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 652 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg123 = FUNCCALL(SETUP_XfOrM197(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_gt ((n1 ) , __funcarg123 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 652 "bc/src/numcomp.c"
int scheme_bin_gt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 652 "bc/src/numcomp.c"
  Scheme_Type t1 , t2 ; 

# 652 "bc/src/numcomp.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 652 "bc/src/numcomp.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 652 "bc/src/numcomp.c"
    return ((((intptr_t ) (n1 ) ) >> 1 ) > (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 652 "bc/src/numcomp.c"
    t2 = ((n2 ) -> type ) ; 

# 652 "bc/src/numcomp.c"
    if (t2 == scheme_float_type ) {

# 652 "bc/src/numcomp.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 652 "bc/src/numcomp.c"
      ; 

# 652 "bc/src/numcomp.c"
      return ieLESS_THAN (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 652 "bc/src/numcomp.c"
    if (t2 == scheme_double_type ) {

# 652 "bc/src/numcomp.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 652 "bc/src/numcomp.c"
      ; 

# 652 "bc/src/numcomp.c"
      return ieLESS_THAN (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 652 "bc/src/numcomp.c"
    if (t2 == scheme_bignum_type ) {

# 652 "bc/src/numcomp.c"
      return scheme_bin_gt__int_big (n1 , n2 ) ; 
    }

# 652 "bc/src/numcomp.c"
    if (t2 == scheme_rational_type ) {

# 652 "bc/src/numcomp.c"
      return scheme_bin_gt__int_rat (n1 , n2 ) ; 
    }

# 652 "bc/src/numcomp.c"
    return scheme_bin_gt__wrong_contract (n2 ) ; 
  }

# 652 "bc/src/numcomp.c"
  else {

# 652 "bc/src/numcomp.c"
    t1 = ((n1 ) -> type ) ; 

# 652 "bc/src/numcomp.c"
    if (t1 == scheme_float_type ) {

# 652 "bc/src/numcomp.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 652 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        return ieGREATER_THAN (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 652 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 652 "bc/src/numcomp.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        return (d1 > d2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 652 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        return (d1 > d2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__flt_big (d1 , n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__flt_rat (d1 , n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      return scheme_bin_gt__wrong_contract (n2 ) ; 
    }

# 652 "bc/src/numcomp.c"
    else if (t1 == scheme_double_type ) {

# 652 "bc/src/numcomp.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 652 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        return ieGREATER_THAN (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 652 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 652 "bc/src/numcomp.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        return (d1 > d2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 652 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        ; 

# 652 "bc/src/numcomp.c"
        return (d1 > d2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__dbl_big (d1 , n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      return scheme_bin_gt__wrong_contract (n2 ) ; 
    }

# 652 "bc/src/numcomp.c"
    else if (t1 == scheme_bignum_type ) {

# 652 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__big_int (n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__big_flt (n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__big_dbl (n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 652 "bc/src/numcomp.c"
      return scheme_bignum_gt ((n1 ) , (n2 ) ) ; 

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 652 "bc/src/numcomp.c"
      return scheme_bin_gt__big_rat (n1 , n2 ) ; 

# 652 "bc/src/numcomp.c"
      return scheme_bin_gt__wrong_contract (n2 ) ; 
    }

# 652 "bc/src/numcomp.c"
    else if (t1 == scheme_rational_type ) {

# 652 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__rat_int (n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__rat_flt (n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 652 "bc/src/numcomp.c"
        return scheme_bin_gt__rat_dbl (n1 , n2 ) ; 
      }

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 652 "bc/src/numcomp.c"
      return scheme_bin_gt__rat_big (n1 , n2 ) ; 

# 652 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 652 "bc/src/numcomp.c"
      return scheme_rational_gt ((n1 ) , (n2 ) ) ; 

# 652 "bc/src/numcomp.c"
      return scheme_bin_gt__wrong_contract (n2 ) ; 
    }

# 652 "bc/src/numcomp.c"
    else return scheme_bin_gt__wrong_contract (n1 ) ; 
  }
}

# 653 "bc/src/numcomp.c"
int scheme_bin_lt_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 653 "bc/src/numcomp.c"
static int scheme_bin_lt_eq__wrong_contract (const Scheme_Object * v ) {

# 653 "bc/src/numcomp.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM225_COUNT (3)
# define SETUP_XfOrM225(x) SETUP(XfOrM225_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM225(_), scheme_wrong_contract ("<=" , "real?" , - 1 , 0 , a ) )
# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 653 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  return scheme_bignum_le ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM227_COUNT (2)
# define SETUP_XfOrM227(x) SETUP(XfOrM227_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM227(_), scheme_rational_le ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  Small_Rational sr2 ; 
  Scheme_Object * __funcarg126 = NULLED_OUT ; 
  Scheme_Object * __funcarg125 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg124 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg124, 0), PUSH(sr2.num, 1), PUSH(sr2.denom, 2), PUSH(n2, 3)));
# define XfOrM228_COUNT (4)
# define SETUP_XfOrM228(x) SETUP(XfOrM228_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr2.num = NULLED_OUT ; 
  sr2.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg124 = (__funcarg126 = FUNCCALL(SETUP_XfOrM228(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg126 , & sr2 ) )) , __funcarg125 = FUNCCALL(SETUP_XfOrM228(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_le (__funcarg124 , __funcarg125 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  Small_Rational sr3 ; 
  Scheme_Object * __funcarg128 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg127 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr3.num, 0), PUSH(sr3.denom, 1), PUSH(n2, 2)));
# define XfOrM229_COUNT (3)
# define SETUP_XfOrM229(x) SETUP(XfOrM229_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr3.num = NULLED_OUT ; 
  sr3.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_positive (n2 ) ) ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg127 = (__funcarg128 = FUNCCALL(SETUP_XfOrM229(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg128 , & sr3 ) )) , FUNCCALL_AGAIN(scheme_rational_le (__funcarg127 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg131 = NULLED_OUT ; 
  Scheme_Object * __funcarg130 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg129 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg129, 0), PUSH(sr4.num, 1), PUSH(sr4.denom, 2), PUSH(n2, 3)));
# define XfOrM230_COUNT (4)
# define SETUP_XfOrM230(x) SETUP(XfOrM230_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg129 = (__funcarg131 = FUNCCALL(SETUP_XfOrM230(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg131 , & sr4 ) )) , __funcarg130 = FUNCCALL(SETUP_XfOrM230(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_le (__funcarg129 , __funcarg130 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg133 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg132 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM231_COUNT (3)
# define SETUP_XfOrM231(x) SETUP(XfOrM231_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_positive (n2 ) ) ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg132 = (__funcarg133 = FUNCCALL(SETUP_XfOrM231(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg133 , & sr5 ) )) , FUNCCALL_AGAIN(scheme_rational_le (__funcarg132 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 653 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  return scheme_bignum_le ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  float d2 ; 

# 653 "bc/src/numcomp.c"
  Small_Rational sr6 ; 
  Scheme_Object * __funcarg136 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg135 = NULLED_OUT ; 
  Scheme_Object * __funcarg134 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg134, 0), PUSH(sr6.num, 1), PUSH(sr6.denom, 2)));
# define XfOrM233_COUNT (3)
# define SETUP_XfOrM233(x) SETUP(XfOrM233_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr6.num = NULLED_OUT ; 
  sr6.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg134 = FUNCCALL(SETUP_XfOrM233(_), scheme_integer_to_rational (n1 ) ), __funcarg135 = (__funcarg136 = FUNCCALL(SETUP_XfOrM233(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg136 , & sr6 ) )) , FUNCCALL_AGAIN(scheme_rational_le (__funcarg134 , __funcarg135 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  double d2 ; 

# 653 "bc/src/numcomp.c"
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg139 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg138 = NULLED_OUT ; 
  Scheme_Object * __funcarg137 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg137, 0), PUSH(sr7.num, 1), PUSH(sr7.denom, 2)));
# define XfOrM234_COUNT (3)
# define SETUP_XfOrM234(x) SETUP(XfOrM234_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg137 = FUNCCALL(SETUP_XfOrM234(_), scheme_integer_to_rational (n1 ) ), __funcarg138 = (__funcarg139 = FUNCCALL(SETUP_XfOrM234(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg139 , & sr7 ) )) , FUNCCALL_AGAIN(scheme_rational_le (__funcarg137 , __funcarg138 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg140 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM235_COUNT (1)
# define SETUP_XfOrM235(x) SETUP(XfOrM235_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg140 = FUNCCALL(SETUP_XfOrM235(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_le (__funcarg140 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM236_COUNT (2)
# define SETUP_XfOrM236(x) SETUP(XfOrM236_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM236(_), scheme_rational_le ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  float d2 ; 

# 653 "bc/src/numcomp.c"
  Small_Rational sr9 ; 
  Scheme_Object * __funcarg142 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg141 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr9.num, 1), PUSH(sr9.denom, 2)));
# define XfOrM237_COUNT (3)
# define SETUP_XfOrM237(x) SETUP(XfOrM237_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr9.num = NULLED_OUT ; 
  sr9.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_negative (n1 ) ) ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg141 = (__funcarg142 = FUNCCALL(SETUP_XfOrM237(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg142 , & sr9 ) )) , FUNCCALL_AGAIN(scheme_rational_le ((n1 ) , __funcarg141 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 653 "bc/src/numcomp.c"
  double d2 ; 

# 653 "bc/src/numcomp.c"
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg144 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg143 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr10.num, 1), PUSH(sr10.denom, 2)));
# define XfOrM238_COUNT (3)
# define SETUP_XfOrM238(x) SETUP(XfOrM238_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 

# 653 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_negative (n1 ) ) ) RET_VALUE_END ; 

# 653 "bc/src/numcomp.c"
  ; 

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg143 = (__funcarg144 = FUNCCALL(SETUP_XfOrM238(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg144 , & sr10 ) )) , FUNCCALL_AGAIN(scheme_rational_le ((n1 ) , __funcarg143 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
static inline int scheme_bin_lt_eq__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg145 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM239_COUNT (1)
# define SETUP_XfOrM239(x) SETUP(XfOrM239_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 653 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg145 = FUNCCALL(SETUP_XfOrM239(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_le ((n1 ) , __funcarg145 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 653 "bc/src/numcomp.c"
int scheme_bin_lt_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 653 "bc/src/numcomp.c"
  Scheme_Type t1 , t2 ; 

# 653 "bc/src/numcomp.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 653 "bc/src/numcomp.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 653 "bc/src/numcomp.c"
    return ((((intptr_t ) (n1 ) ) >> 1 ) <= (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 653 "bc/src/numcomp.c"
    t2 = ((n2 ) -> type ) ; 

# 653 "bc/src/numcomp.c"
    if (t2 == scheme_float_type ) {

# 653 "bc/src/numcomp.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 653 "bc/src/numcomp.c"
      ; 

# 653 "bc/src/numcomp.c"
      return ieGREATER_OR_EQUAL (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 653 "bc/src/numcomp.c"
    if (t2 == scheme_double_type ) {

# 653 "bc/src/numcomp.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 653 "bc/src/numcomp.c"
      ; 

# 653 "bc/src/numcomp.c"
      return ieGREATER_OR_EQUAL (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 653 "bc/src/numcomp.c"
    if (t2 == scheme_bignum_type ) {

# 653 "bc/src/numcomp.c"
      return scheme_bin_lt_eq__int_big (n1 , n2 ) ; 
    }

# 653 "bc/src/numcomp.c"
    if (t2 == scheme_rational_type ) {

# 653 "bc/src/numcomp.c"
      return scheme_bin_lt_eq__int_rat (n1 , n2 ) ; 
    }

# 653 "bc/src/numcomp.c"
    return scheme_bin_lt_eq__wrong_contract (n2 ) ; 
  }

# 653 "bc/src/numcomp.c"
  else {

# 653 "bc/src/numcomp.c"
    t1 = ((n1 ) -> type ) ; 

# 653 "bc/src/numcomp.c"
    if (t1 == scheme_float_type ) {

# 653 "bc/src/numcomp.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 653 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        return ieLESS_OR_EQUAL (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 653 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 653 "bc/src/numcomp.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        return (d1 <= d2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 653 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        return (d1 <= d2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__flt_big (d1 , n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__flt_rat (d1 , n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      return scheme_bin_lt_eq__wrong_contract (n2 ) ; 
    }

# 653 "bc/src/numcomp.c"
    else if (t1 == scheme_double_type ) {

# 653 "bc/src/numcomp.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 653 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        return ieLESS_OR_EQUAL (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 653 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 653 "bc/src/numcomp.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        return (d1 <= d2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 653 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        ; 

# 653 "bc/src/numcomp.c"
        return (d1 <= d2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__dbl_big (d1 , n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      return scheme_bin_lt_eq__wrong_contract (n2 ) ; 
    }

# 653 "bc/src/numcomp.c"
    else if (t1 == scheme_bignum_type ) {

# 653 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__big_int (n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__big_flt (n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__big_dbl (n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 653 "bc/src/numcomp.c"
      return scheme_bignum_le ((n1 ) , (n2 ) ) ; 

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 653 "bc/src/numcomp.c"
      return scheme_bin_lt_eq__big_rat (n1 , n2 ) ; 

# 653 "bc/src/numcomp.c"
      return scheme_bin_lt_eq__wrong_contract (n2 ) ; 
    }

# 653 "bc/src/numcomp.c"
    else if (t1 == scheme_rational_type ) {

# 653 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__rat_int (n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__rat_flt (n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 653 "bc/src/numcomp.c"
        return scheme_bin_lt_eq__rat_dbl (n1 , n2 ) ; 
      }

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 653 "bc/src/numcomp.c"
      return scheme_bin_lt_eq__rat_big (n1 , n2 ) ; 

# 653 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 653 "bc/src/numcomp.c"
      return scheme_rational_le ((n1 ) , (n2 ) ) ; 

# 653 "bc/src/numcomp.c"
      return scheme_bin_lt_eq__wrong_contract (n2 ) ; 
    }

# 653 "bc/src/numcomp.c"
    else return scheme_bin_lt_eq__wrong_contract (n1 ) ; 
  }
}

# 654 "bc/src/numcomp.c"
int scheme_bin_gt_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 654 "bc/src/numcomp.c"
static int scheme_bin_gt_eq__wrong_contract (const Scheme_Object * v ) {

# 654 "bc/src/numcomp.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM267_COUNT (3)
# define SETUP_XfOrM267(x) SETUP(XfOrM267_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM267(_), scheme_wrong_contract (">=" , "real?" , - 1 , 0 , a ) )
# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 654 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  return scheme_bignum_ge ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) ; 
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM269_COUNT (2)
# define SETUP_XfOrM269(x) SETUP(XfOrM269_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM269(_), scheme_rational_ge ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  Small_Rational sr2 ; 
  Scheme_Object * __funcarg148 = NULLED_OUT ; 
  Scheme_Object * __funcarg147 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg146 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg146, 0), PUSH(sr2.num, 1), PUSH(sr2.denom, 2), PUSH(n2, 3)));
# define XfOrM270_COUNT (4)
# define SETUP_XfOrM270(x) SETUP(XfOrM270_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr2.num = NULLED_OUT ; 
  sr2.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg146 = (__funcarg148 = FUNCCALL(SETUP_XfOrM270(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg148 , & sr2 ) )) , __funcarg147 = FUNCCALL(SETUP_XfOrM270(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_ge (__funcarg146 , __funcarg147 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  Small_Rational sr3 ; 
  Scheme_Object * __funcarg150 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr3.num, 0), PUSH(sr3.denom, 1), PUSH(n2, 2)));
# define XfOrM271_COUNT (3)
# define SETUP_XfOrM271(x) SETUP(XfOrM271_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr3.num = NULLED_OUT ; 
  sr3.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_negative (n2 ) ) ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg149 = (__funcarg150 = FUNCCALL(SETUP_XfOrM271(_), scheme_rational_from_float (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg150 , & sr3 ) )) , FUNCCALL_AGAIN(scheme_rational_ge (__funcarg149 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  Small_Rational sr4 ; 
  Scheme_Object * __funcarg153 = NULLED_OUT ; 
  Scheme_Object * __funcarg152 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg151 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg151, 0), PUSH(sr4.num, 1), PUSH(sr4.denom, 2), PUSH(n2, 3)));
# define XfOrM272_COUNT (4)
# define SETUP_XfOrM272(x) SETUP(XfOrM272_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr4.num = NULLED_OUT ; 
  sr4.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg151 = (__funcarg153 = FUNCCALL(SETUP_XfOrM272(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg153 , & sr4 ) )) , __funcarg152 = FUNCCALL(SETUP_XfOrM272(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_AGAIN(scheme_rational_ge (__funcarg151 , __funcarg152 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  Small_Rational sr5 ; 
  Scheme_Object * __funcarg155 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg154 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(sr5.num, 0), PUSH(sr5.denom, 1), PUSH(n2, 2)));
# define XfOrM273_COUNT (3)
# define SETUP_XfOrM273(x) SETUP(XfOrM273_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr5.num = NULLED_OUT ; 
  sr5.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 > 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d1 ) && (d1 < 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (d1 == 0.0 )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_negative (n2 ) ) ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg154 = (__funcarg155 = FUNCCALL(SETUP_XfOrM273(_), scheme_rational_from_double (d1 ) ), FUNCCALL_AGAIN(force_rat (__funcarg155 , & sr5 ) )) , FUNCCALL_AGAIN(scheme_rational_ge (__funcarg154 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 654 "bc/src/numcomp.c"
  Small_Bignum sb ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  return scheme_bignum_ge ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) ; 
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  float d2 ; 

# 654 "bc/src/numcomp.c"
  Small_Rational sr6 ; 
  Scheme_Object * __funcarg158 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg157 = NULLED_OUT ; 
  Scheme_Object * __funcarg156 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg156, 0), PUSH(sr6.num, 1), PUSH(sr6.denom, 2)));
# define XfOrM275_COUNT (3)
# define SETUP_XfOrM275(x) SETUP(XfOrM275_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr6.num = NULLED_OUT ; 
  sr6.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg156 = FUNCCALL(SETUP_XfOrM275(_), scheme_integer_to_rational (n1 ) ), __funcarg157 = (__funcarg158 = FUNCCALL(SETUP_XfOrM275(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg158 , & sr6 ) )) , FUNCCALL_AGAIN(scheme_rational_ge (__funcarg156 , __funcarg157 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  double d2 ; 

# 654 "bc/src/numcomp.c"
  Small_Rational sr7 ; 
  Scheme_Object * __funcarg161 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg160 = NULLED_OUT ; 
  Scheme_Object * __funcarg159 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(__funcarg159, 0), PUSH(sr7.num, 1), PUSH(sr7.denom, 2)));
# define XfOrM276_COUNT (3)
# define SETUP_XfOrM276(x) SETUP(XfOrM276_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr7.num = NULLED_OUT ; 
  sr7.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg159 = FUNCCALL(SETUP_XfOrM276(_), scheme_integer_to_rational (n1 ) ), __funcarg160 = (__funcarg161 = FUNCCALL(SETUP_XfOrM276(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg161 , & sr7 ) )) , FUNCCALL_AGAIN(scheme_rational_ge (__funcarg159 , __funcarg160 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg162 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM277_COUNT (1)
# define SETUP_XfOrM277(x) SETUP(XfOrM277_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg162 = FUNCCALL(SETUP_XfOrM277(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_ge (__funcarg162 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM278_COUNT (2)
# define SETUP_XfOrM278(x) SETUP(XfOrM278_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM278(_), scheme_rational_ge ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  float d2 ; 

# 654 "bc/src/numcomp.c"
  Small_Rational sr9 ; 
  Scheme_Object * __funcarg164 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg163 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr9.num, 1), PUSH(sr9.denom, 2)));
# define XfOrM279_COUNT (3)
# define SETUP_XfOrM279(x) SETUP(XfOrM279_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr9.num = NULLED_OUT ; 
  sr9.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_positive (n1 ) ) ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg163 = (__funcarg164 = FUNCCALL(SETUP_XfOrM279(_), scheme_rational_from_float (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg164 , & sr9 ) )) , FUNCCALL_AGAIN(scheme_rational_ge ((n1 ) , __funcarg163 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 654 "bc/src/numcomp.c"
  double d2 ; 

# 654 "bc/src/numcomp.c"
  Small_Rational sr10 ; 
  Scheme_Object * __funcarg166 = NULLED_OUT ; 

# 580 "bc/src/numcomp.c"
  Scheme_Object * __funcarg165 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(n1, 0), PUSH(sr10.num, 1), PUSH(sr10.denom, 2)));
# define XfOrM280_COUNT (3)
# define SETUP_XfOrM280(x) SETUP(XfOrM280_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr10.num = NULLED_OUT ; 
  sr10.denom = NULLED_OUT ; 

# 654 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 > 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (__builtin_isinf_sign (d2 ) && (d2 < 0 ) ) 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  if (d2 == 0.0 )

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((scheme_is_positive (n1 ) ) ) RET_VALUE_END ; 

# 654 "bc/src/numcomp.c"
  ; 

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg165 = (__funcarg166 = FUNCCALL(SETUP_XfOrM280(_), scheme_rational_from_double (d2 ) ), FUNCCALL_AGAIN(force_rat (__funcarg166 , & sr10 ) )) , FUNCCALL_AGAIN(scheme_rational_ge ((n1 ) , __funcarg165 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
static inline int scheme_bin_gt_eq__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg167 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM281_COUNT (1)
# define SETUP_XfOrM281(x) SETUP(XfOrM281_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 654 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg167 = FUNCCALL(SETUP_XfOrM281(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_ge ((n1 ) , __funcarg167 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 654 "bc/src/numcomp.c"
int scheme_bin_gt_eq (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 654 "bc/src/numcomp.c"
  Scheme_Type t1 , t2 ; 

# 654 "bc/src/numcomp.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 654 "bc/src/numcomp.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 654 "bc/src/numcomp.c"
    return ((((intptr_t ) (n1 ) ) >> 1 ) >= (((intptr_t ) (n2 ) ) >> 1 ) ) ; 

# 654 "bc/src/numcomp.c"
    t2 = ((n2 ) -> type ) ; 

# 654 "bc/src/numcomp.c"
    if (t2 == scheme_float_type ) {

# 654 "bc/src/numcomp.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 654 "bc/src/numcomp.c"
      ; 

# 654 "bc/src/numcomp.c"
      return ieLESS_OR_EQUAL (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 654 "bc/src/numcomp.c"
    if (t2 == scheme_double_type ) {

# 654 "bc/src/numcomp.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 654 "bc/src/numcomp.c"
      ; 

# 654 "bc/src/numcomp.c"
      return ieLESS_OR_EQUAL (d , (((intptr_t ) (n1 ) ) >> 1 ) ) ; 
    }

# 654 "bc/src/numcomp.c"
    if (t2 == scheme_bignum_type ) {

# 654 "bc/src/numcomp.c"
      return scheme_bin_gt_eq__int_big (n1 , n2 ) ; 
    }

# 654 "bc/src/numcomp.c"
    if (t2 == scheme_rational_type ) {

# 654 "bc/src/numcomp.c"
      return scheme_bin_gt_eq__int_rat (n1 , n2 ) ; 
    }

# 654 "bc/src/numcomp.c"
    return scheme_bin_gt_eq__wrong_contract (n2 ) ; 
  }

# 654 "bc/src/numcomp.c"
  else {

# 654 "bc/src/numcomp.c"
    t1 = ((n1 ) -> type ) ; 

# 654 "bc/src/numcomp.c"
    if (t1 == scheme_float_type ) {

# 654 "bc/src/numcomp.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 654 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        return ieGREATER_OR_EQUAL (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 654 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 654 "bc/src/numcomp.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        return (d1 >= d2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 654 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        return (d1 >= d2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__flt_big (d1 , n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__flt_rat (d1 , n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      return scheme_bin_gt_eq__wrong_contract (n2 ) ; 
    }

# 654 "bc/src/numcomp.c"
    else if (t1 == scheme_double_type ) {

# 654 "bc/src/numcomp.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 654 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        return ieGREATER_OR_EQUAL (d1 , (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 654 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 654 "bc/src/numcomp.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        return (d1 >= d2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 654 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        ; 

# 654 "bc/src/numcomp.c"
        return (d1 >= d2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__dbl_big (d1 , n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      return scheme_bin_gt_eq__wrong_contract (n2 ) ; 
    }

# 654 "bc/src/numcomp.c"
    else if (t1 == scheme_bignum_type ) {

# 654 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__big_int (n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__big_flt (n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__big_dbl (n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 654 "bc/src/numcomp.c"
      return scheme_bignum_ge ((n1 ) , (n2 ) ) ; 

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 654 "bc/src/numcomp.c"
      return scheme_bin_gt_eq__big_rat (n1 , n2 ) ; 

# 654 "bc/src/numcomp.c"
      return scheme_bin_gt_eq__wrong_contract (n2 ) ; 
    }

# 654 "bc/src/numcomp.c"
    else if (t1 == scheme_rational_type ) {

# 654 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__rat_int (n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__rat_flt (n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 654 "bc/src/numcomp.c"
        return scheme_bin_gt_eq__rat_dbl (n1 , n2 ) ; 
      }

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 654 "bc/src/numcomp.c"
      return scheme_bin_gt_eq__rat_big (n1 , n2 ) ; 

# 654 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 654 "bc/src/numcomp.c"
      return scheme_rational_ge ((n1 ) , (n2 ) ) ; 

# 654 "bc/src/numcomp.c"
      return scheme_bin_gt_eq__wrong_contract (n2 ) ; 
    }

# 654 "bc/src/numcomp.c"
    else return scheme_bin_gt_eq__wrong_contract (n1 ) ; 
  }
}

# 656 "bc/src/numcomp.c"
int 
scheme_is_zero (const Scheme_Object * o ) 
{
  /* No conversion */

# 659 "bc/src/numcomp.c"
  Scheme_Type t ; 

  if (((intptr_t ) (o ) ) & 0x1 ) 
    return o == ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  t = ((o ) -> type ) ; 

  if (t == scheme_float_type ) {




    return (((Scheme_Float * ) (o ) ) -> float_val ) == 0.0f ; 
  }

  if (t == scheme_double_type ) {




    return (((Scheme_Double * ) (o ) ) -> double_val ) == 0.0 ; 
  }
  if (t == scheme_complex_type ) {
    if (scheme_is_zero (scheme_complex_imaginary_part (o ) ) )
      return scheme_is_zero (scheme_complex_real_part (o ) ) ; 
    return 0 ; 
  }

  if ((t >= scheme_bignum_type ) && (t <= scheme_complex_type ) )
    return 0 ; 

  return - 1 ; 
}

Scheme_Object * 
zero_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 695 "bc/src/numcomp.c"
  int v ; 
  v = scheme_is_zero (argv [0 ] ) ; 
  if (v < 0 ) {
    scheme_wrong_contract ("zero?" , "number?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return (v ? scheme_true : scheme_false ) ; 
}

int 
scheme_is_positive (const Scheme_Object * o ) 
{
  /* No conversion */

# 707 "bc/src/numcomp.c"
  Scheme_Type t ; 

  if (((intptr_t ) (o ) ) & 0x1 ) 
    return (((intptr_t ) (o ) ) >> 1 ) > 0 ; 
  t = ((o ) -> type ) ; 

  if (t == scheme_float_type ) {
    float d = (((Scheme_Float * ) (o ) ) -> float_val ) ; 




    return d > 0 ; 
  }

  if (t == scheme_double_type ) {
    double d = (((Scheme_Double * ) (o ) ) -> double_val ) ; 




    return d > 0 ; 
  }
  if (t == scheme_bignum_type )
    return ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ; 
  if (t == scheme_rational_type )
    return scheme_is_rational_positive (o ) ; 

  return - 1 ; 
}

Scheme_Object * 
positive_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 741 "bc/src/numcomp.c"
  int v ; 
  v = scheme_is_positive (argv [0 ] ) ; 
  if (v < 0 ) {
    scheme_wrong_contract ("positive?" , "real?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return (v ? scheme_true : scheme_false ) ; 
}

int 
scheme_is_negative (const Scheme_Object * o ) 
{
  /* No conversion */

# 753 "bc/src/numcomp.c"
  Scheme_Type t ; 

  if (((intptr_t ) (o ) ) & 0x1 ) 
    return (((intptr_t ) (o ) ) >> 1 ) < 0 ; 
  t = ((o ) -> type ) ; 

  if (t == scheme_float_type ) {
    float d = (((Scheme_Float * ) (o ) ) -> float_val ) ; 




    return d < 0 ; 
  }

  if (t == scheme_double_type ) {
    double d = (((Scheme_Double * ) (o ) ) -> double_val ) ; 




    return d < 0 ; 
  }
  if (t == scheme_bignum_type )
    return ! ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ; 
  if (t == scheme_rational_type )
    return ! scheme_is_rational_positive (o ) ; 

  return - 1 ; 
}

Scheme_Object * 
negative_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 787 "bc/src/numcomp.c"
  int v ; 
  v = scheme_is_negative (argv [0 ] ) ; 
  if (v < 0 ) {
    scheme_wrong_contract ("negative?" , "real?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return (v ? scheme_true : scheme_false ) ; 
}

# 807 "bc/src/numcomp.c"
static Scheme_Object * bin_max (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 807 "bc/src/numcomp.c"
static Scheme_Object * bin_max__wrong_contract (const Scheme_Object * v ) {

# 807 "bc/src/numcomp.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM325_COUNT (3)
# define SETUP_XfOrM325(x) SETUP(XfOrM325_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM325(_), scheme_wrong_contract ("max" , "number?" , - 1 , 0 , a ) )
# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM326_COUNT (1)
# define SETUP_XfOrM326(x) SETUP(XfOrM326_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM326(_), scheme_bignum_max ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM327_COUNT (2)
# define SETUP_XfOrM327(x) SETUP(XfOrM327_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM327(_), scheme_rational_max ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM328_COUNT (2)
# define SETUP_XfOrM328(x) SETUP(XfOrM328_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM328(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  float tmp2 ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
  return scheme_single_nan_object ; 

# 807 "bc/src/numcomp.c"
  tmp2 = scheme_bignum_to_float (n2 ) ; 

# 807 "bc/src/numcomp.c"
  return scheme_make_float ((d1 > tmp2 ) ? d1 : tmp2 ) ; 
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  float tmp3 ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
  return scheme_single_nan_object ; 

# 807 "bc/src/numcomp.c"
  tmp3 = scheme_rational_to_float (n2 ) ; 

# 807 "bc/src/numcomp.c"
  return scheme_make_float ((d1 > tmp3 ) ? d1 : tmp3 ) ; 
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__flt_comp (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM331_COUNT (2)
# define SETUP_XfOrM331(x) SETUP(XfOrM331_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_single_nan_object ) RET_VALUE_END ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM331(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  double tmp4 ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
  return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
  tmp4 = scheme_bignum_to_double (n2 ) ; 

# 807 "bc/src/numcomp.c"
  return scheme_make_double ((d1 > tmp4 ) ? d1 : tmp4 ) ; 
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  double tmp5 ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
  return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
  tmp5 = scheme_rational_to_double (n2 ) ; 

# 807 "bc/src/numcomp.c"
  return scheme_make_double ((d1 > tmp5 ) ? d1 : tmp5 ) ; 
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM334_COUNT (2)
# define SETUP_XfOrM334(x) SETUP(XfOrM334_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_nan_object ) RET_VALUE_END ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM334(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM335_COUNT (1)
# define SETUP_XfOrM335(x) SETUP(XfOrM335_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM335(_), scheme_bignum_max ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  float d2 ; 

# 807 "bc/src/numcomp.c"
  float tmp6 ; 

# 807 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 807 "bc/src/numcomp.c"
  return scheme_single_nan_object ; 

# 807 "bc/src/numcomp.c"
  tmp6 = scheme_bignum_to_float (n1 ) ; 

# 807 "bc/src/numcomp.c"
  return scheme_make_float ((tmp6 > d2 ) ? tmp6 : d2 ) ; 
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  double d2 ; 

# 807 "bc/src/numcomp.c"
  double tmp7 ; 

# 807 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 807 "bc/src/numcomp.c"
  return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
  tmp7 = scheme_bignum_to_double (n1 ) ; 

# 807 "bc/src/numcomp.c"
  return scheme_make_double ((tmp7 > d2 ) ? tmp7 : d2 ) ; 
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg170 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM338_COUNT (1)
# define SETUP_XfOrM338(x) SETUP(XfOrM338_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 807 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg170 = FUNCCALL(SETUP_XfOrM338(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_max (__funcarg170 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM339_COUNT (2)
# define SETUP_XfOrM339(x) SETUP(XfOrM339_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM339(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM340_COUNT (2)
# define SETUP_XfOrM340(x) SETUP(XfOrM340_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM340(_), scheme_rational_max ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  float d2 ; 

# 807 "bc/src/numcomp.c"
  float tmp9 ; 

# 807 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 807 "bc/src/numcomp.c"
  return scheme_single_nan_object ; 

# 807 "bc/src/numcomp.c"
  tmp9 = scheme_rational_to_float (n1 ) ; 

# 807 "bc/src/numcomp.c"
  return scheme_make_float ((tmp9 > d2 ) ? tmp9 : d2 ) ; 
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  double d2 ; 

# 807 "bc/src/numcomp.c"
  double tmp10 ; 

# 807 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 807 "bc/src/numcomp.c"
  return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
  tmp10 = scheme_rational_to_double (n1 ) ; 

# 807 "bc/src/numcomp.c"
  return scheme_make_double ((tmp10 > d2 ) ? tmp10 : d2 ) ; 
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg171 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM343_COUNT (1)
# define SETUP_XfOrM343(x) SETUP(XfOrM343_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 807 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg171 = FUNCCALL(SETUP_XfOrM343(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_max ((n1 ) , __funcarg171 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM344_COUNT (2)
# define SETUP_XfOrM344(x) SETUP(XfOrM344_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM344(_), bin_max ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM345_COUNT (2)
# define SETUP_XfOrM345(x) SETUP(XfOrM345_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM345(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__comp_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM346_COUNT (2)
# define SETUP_XfOrM346(x) SETUP(XfOrM346_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan ((((Scheme_Float * ) (n2 ) ) -> float_val ) ) )

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_single_nan_object ) RET_VALUE_END ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM346(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM347_COUNT (2)
# define SETUP_XfOrM347(x) SETUP(XfOrM347_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  if (__builtin_isnan ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) )

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_nan_object ) RET_VALUE_END ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM347(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM348_COUNT (2)
# define SETUP_XfOrM348(x) SETUP(XfOrM348_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM348(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
static inline Scheme_Object * bin_max__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 807 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM349_COUNT (2)
# define SETUP_XfOrM349(x) SETUP(XfOrM349_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 807 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM349(_), bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "bc/src/numcomp.c"
Scheme_Object * bin_max (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 807 "bc/src/numcomp.c"
  Scheme_Type t1 , t2 ; 

# 807 "bc/src/numcomp.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 807 "bc/src/numcomp.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 807 "bc/src/numcomp.c"
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (((((intptr_t ) (n1 ) ) >> 1 ) > (((intptr_t ) (n2 ) ) >> 1 ) ) ? (((intptr_t ) (n1 ) ) >> 1 ) : (((intptr_t ) (n2 ) ) >> 1 ) ) ) ) << 1 ) | 0x1 ) ) ; 

# 807 "bc/src/numcomp.c"
    t2 = ((n2 ) -> type ) ; 

# 807 "bc/src/numcomp.c"
    if (t2 == scheme_float_type ) {

# 807 "bc/src/numcomp.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 807 "bc/src/numcomp.c"
      if (__builtin_isnan (d ) )

# 807 "bc/src/numcomp.c"
      return scheme_single_nan_object ; 

# 807 "bc/src/numcomp.c"
      return scheme_make_float (((((intptr_t ) (n1 ) ) >> 1 ) > d ) ? (((intptr_t ) (n1 ) ) >> 1 ) : d ) ; 
    }

# 807 "bc/src/numcomp.c"
    if (t2 == scheme_double_type ) {

# 807 "bc/src/numcomp.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 807 "bc/src/numcomp.c"
      if (__builtin_isnan (d ) )

# 807 "bc/src/numcomp.c"
      return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
      return scheme_make_double (((((intptr_t ) (n1 ) ) >> 1 ) > d ) ? (((intptr_t ) (n1 ) ) >> 1 ) : d ) ; 
    }

# 807 "bc/src/numcomp.c"
    if (t2 == scheme_bignum_type ) {

# 807 "bc/src/numcomp.c"
      return bin_max__int_big (n1 , n2 ) ; 
    }

# 807 "bc/src/numcomp.c"
    if (t2 == scheme_rational_type ) {

# 807 "bc/src/numcomp.c"
      return bin_max__int_rat (n1 , n2 ) ; 
    }

# 807 "bc/src/numcomp.c"
    if (t2 == scheme_complex_type )  {

# 807 "bc/src/numcomp.c"
      return bin_max__int_comp (n1 , n2 ) ; 
    }

# 807 "bc/src/numcomp.c"
    return bin_max__wrong_contract (n2 ) ; 
  }

# 807 "bc/src/numcomp.c"
  else {

# 807 "bc/src/numcomp.c"
    t1 = ((n1 ) -> type ) ; 

# 807 "bc/src/numcomp.c"
    if (t1 == scheme_float_type ) {

# 807 "bc/src/numcomp.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 807 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
        return scheme_single_nan_object ; 

# 807 "bc/src/numcomp.c"
        return scheme_make_float ((d1 > (((intptr_t ) (n2 ) ) >> 1 ) ) ? d1 : (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 807 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 807 "bc/src/numcomp.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
        return scheme_single_nan_object ; 

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d2 ) )

# 807 "bc/src/numcomp.c"
        return scheme_single_nan_object ; 

# 807 "bc/src/numcomp.c"
        return scheme_make_float ((d1 > d2 ) ? d1 : d2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 807 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d2 ) )

# 807 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
        return scheme_make_double ((d1 > d2 ) ? d1 : d2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__flt_big (d1 , n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__flt_rat (d1 , n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 807 "bc/src/numcomp.c"
        return bin_max__flt_comp (d1 , n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      return bin_max__wrong_contract (n2 ) ; 
    }

# 807 "bc/src/numcomp.c"
    else if (t1 == scheme_double_type ) {

# 807 "bc/src/numcomp.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 807 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
        return scheme_make_double ((d1 > (((intptr_t ) (n2 ) ) >> 1 ) ) ? d1 : (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 807 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 807 "bc/src/numcomp.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d2 ) )

# 807 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
        return scheme_make_double ((d1 > d2 ) ? d1 : d2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 807 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 807 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
        if (__builtin_isnan (d2 ) )

# 807 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 807 "bc/src/numcomp.c"
        return scheme_make_double ((d1 > d2 ) ? d1 : d2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__dbl_big (d1 , n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 807 "bc/src/numcomp.c"
        return bin_max__dbl_comp (d1 , n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      return bin_max__wrong_contract (n2 ) ; 
    }

# 807 "bc/src/numcomp.c"
    else if (t1 == scheme_bignum_type ) {

# 807 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 807 "bc/src/numcomp.c"
        return bin_max__big_int (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__big_flt (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__big_dbl (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 807 "bc/src/numcomp.c"
      return scheme_bignum_max ((n1 ) , (n2 ) ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 807 "bc/src/numcomp.c"
      return bin_max__big_rat (n1 , n2 ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 807 "bc/src/numcomp.c"
        return bin_max__big_comp (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      return bin_max__wrong_contract (n2 ) ; 
    }

# 807 "bc/src/numcomp.c"
    else if (t1 == scheme_rational_type ) {

# 807 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 807 "bc/src/numcomp.c"
        return bin_max__rat_int (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__rat_flt (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__rat_dbl (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 807 "bc/src/numcomp.c"
      return bin_max__rat_big (n1 , n2 ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 807 "bc/src/numcomp.c"
      return scheme_rational_max ((n1 ) , (n2 ) ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 807 "bc/src/numcomp.c"
        return bin_max__rat_comp (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      return bin_max__wrong_contract (n2 ) ; 
    }

# 807 "bc/src/numcomp.c"
    else if (t1 == scheme_complex_type )  {

# 807 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 807 "bc/src/numcomp.c"
      return bin_max__comp_int (n1 , n2 ) ; 

# 807 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__comp_flt (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 807 "bc/src/numcomp.c"
        return bin_max__comp_dbl (n1 , n2 ) ; 
      }

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 807 "bc/src/numcomp.c"
      return bin_max__comp_big (n1 , n2 ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 807 "bc/src/numcomp.c"
      return bin_max__comp_rat (n1 , n2 ) ; 

# 807 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type ) 

# 807 "bc/src/numcomp.c"
      return bin_max ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) ; 

# 807 "bc/src/numcomp.c"
      return bin_max__wrong_contract (n2 ) ; 
    }

# 807 "bc/src/numcomp.c"
    else return bin_max__wrong_contract (n1 ) ; 
  }
}

# 808 "bc/src/numcomp.c"
static Scheme_Object * bin_min (const Scheme_Object * n1 , const Scheme_Object * n2 ) ; 

# 808 "bc/src/numcomp.c"
static Scheme_Object * bin_min__wrong_contract (const Scheme_Object * v ) {

# 808 "bc/src/numcomp.c"
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM385_COUNT (3)
# define SETUP_XfOrM385(x) SETUP(XfOrM385_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  a [0 ] = (Scheme_Object * ) v ; 
  FUNCCALL(SETUP_XfOrM385(_), scheme_wrong_contract ("min" , "number?" , - 1 , 0 , a ) )
# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__int_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM386_COUNT (1)
# define SETUP_XfOrM386(x) SETUP(XfOrM386_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM386(_), scheme_bignum_min ((scheme_make_small_bignum ((((intptr_t ) (n1 ) ) >> 1 ) , & sb ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__int_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Rational sr1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr1.num, 0), PUSH(sr1.denom, 1)));
# define XfOrM387_COUNT (2)
# define SETUP_XfOrM387(x) SETUP(XfOrM387_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr1.num = NULLED_OUT ; 
  sr1.denom = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM387(_), scheme_rational_min ((scheme_make_small_rational ((((intptr_t ) (n1 ) ) >> 1 ) , & sr1 ) ) , (n2 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__int_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM388_COUNT (2)
# define SETUP_XfOrM388(x) SETUP(XfOrM388_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM388(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__flt_big (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  float tmp2 ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
  return scheme_single_nan_object ; 

# 808 "bc/src/numcomp.c"
  tmp2 = scheme_bignum_to_float (n2 ) ; 

# 808 "bc/src/numcomp.c"
  return scheme_make_float ((d1 < tmp2 ) ? d1 : tmp2 ) ; 
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__flt_rat (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  float tmp3 ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
  return scheme_single_nan_object ; 

# 808 "bc/src/numcomp.c"
  tmp3 = scheme_rational_to_float (n2 ) ; 

# 808 "bc/src/numcomp.c"
  return scheme_make_float ((d1 < tmp3 ) ? d1 : tmp3 ) ; 
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__flt_comp (float d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM391_COUNT (2)
# define SETUP_XfOrM391(x) SETUP(XfOrM391_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_single_nan_object ) RET_VALUE_END ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM391(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__dbl_big (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  double tmp4 ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
  return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
  tmp4 = scheme_bignum_to_double (n2 ) ; 

# 808 "bc/src/numcomp.c"
  return scheme_make_double ((d1 < tmp4 ) ? d1 : tmp4 ) ; 
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__dbl_rat (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  double tmp5 ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
  return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
  tmp5 = scheme_rational_to_double (n2 ) ; 

# 808 "bc/src/numcomp.c"
  return scheme_make_double ((d1 < tmp5 ) ? d1 : tmp5 ) ; 
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__dbl_comp (double d1 , const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM394_COUNT (2)
# define SETUP_XfOrM394(x) SETUP(XfOrM394_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_nan_object ) RET_VALUE_END ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM394(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__big_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Bignum sb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sb.o.digits, 0)));
# define XfOrM395_COUNT (1)
# define SETUP_XfOrM395(x) SETUP(XfOrM395_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb.o.digits = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM395(_), scheme_bignum_min ((n1 ) , (scheme_make_small_bignum ((((intptr_t ) (n2 ) ) >> 1 ) , & sb ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__big_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  float d2 ; 

# 808 "bc/src/numcomp.c"
  float tmp6 ; 

# 808 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 808 "bc/src/numcomp.c"
  return scheme_single_nan_object ; 

# 808 "bc/src/numcomp.c"
  tmp6 = scheme_bignum_to_float (n1 ) ; 

# 808 "bc/src/numcomp.c"
  return scheme_make_float ((tmp6 < d2 ) ? tmp6 : d2 ) ; 
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__big_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  double d2 ; 

# 808 "bc/src/numcomp.c"
  double tmp7 ; 

# 808 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 808 "bc/src/numcomp.c"
  return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
  tmp7 = scheme_bignum_to_double (n1 ) ; 

# 808 "bc/src/numcomp.c"
  return scheme_make_double ((tmp7 < d2 ) ? tmp7 : d2 ) ; 
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__big_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg172 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n2, 0)));
# define XfOrM398_COUNT (1)
# define SETUP_XfOrM398(x) SETUP(XfOrM398_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 808 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg172 = FUNCCALL(SETUP_XfOrM398(_), scheme_integer_to_rational (n1 ) ), FUNCCALL_EMPTY(scheme_rational_min (__funcarg172 , (n2 ) ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__big_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM399_COUNT (2)
# define SETUP_XfOrM399(x) SETUP(XfOrM399_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM399(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__rat_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Rational sr8 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sr8.num, 0), PUSH(sr8.denom, 1)));
# define XfOrM400_COUNT (2)
# define SETUP_XfOrM400(x) SETUP(XfOrM400_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sr8.num = NULLED_OUT ; 
  sr8.denom = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM400(_), scheme_rational_min ((n1 ) , (scheme_make_small_rational ((((intptr_t ) (n2 ) ) >> 1 ) , & sr8 ) ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__rat_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  float d2 ; 

# 808 "bc/src/numcomp.c"
  float tmp9 ; 

# 808 "bc/src/numcomp.c"
  d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 808 "bc/src/numcomp.c"
  return scheme_single_nan_object ; 

# 808 "bc/src/numcomp.c"
  tmp9 = scheme_rational_to_float (n1 ) ; 

# 808 "bc/src/numcomp.c"
  return scheme_make_float ((tmp9 < d2 ) ? tmp9 : d2 ) ; 
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__rat_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  double d2 ; 

# 808 "bc/src/numcomp.c"
  double tmp10 ; 

# 808 "bc/src/numcomp.c"
  d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan (d2 ) )

# 808 "bc/src/numcomp.c"
  return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
  tmp10 = scheme_rational_to_double (n1 ) ; 

# 808 "bc/src/numcomp.c"
  return scheme_make_double ((tmp10 < d2 ) ? tmp10 : d2 ) ; 
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__rat_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  Scheme_Object * __funcarg173 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(n1, 0)));
# define XfOrM403_COUNT (1)
# define SETUP_XfOrM403(x) SETUP(XfOrM403_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 808 "bc/src/numcomp.c"
  RET_VALUE_START ((__funcarg173 = FUNCCALL(SETUP_XfOrM403(_), scheme_integer_to_rational (n2 ) ), FUNCCALL_EMPTY(scheme_rational_min ((n1 ) , __funcarg173 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__rat_comp (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM404_COUNT (2)
# define SETUP_XfOrM404(x) SETUP(XfOrM404_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM404(_), bin_min ((((Scheme_Complex * ) ((scheme_make_small_complex (n1 , & sc ) ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__comp_int (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM405_COUNT (2)
# define SETUP_XfOrM405(x) SETUP(XfOrM405_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM405(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__comp_flt (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM406_COUNT (2)
# define SETUP_XfOrM406(x) SETUP(XfOrM406_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan ((((Scheme_Float * ) (n2 ) ) -> float_val ) ) )

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_single_nan_object ) RET_VALUE_END ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM406(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__comp_dbl (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM407_COUNT (2)
# define SETUP_XfOrM407(x) SETUP(XfOrM407_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  if (__builtin_isnan ((((Scheme_Double * ) (n2 ) ) -> double_val ) ) )

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (scheme_nan_object ) RET_VALUE_END ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM407(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__comp_big (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM408_COUNT (2)
# define SETUP_XfOrM408(x) SETUP(XfOrM408_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM408(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
static inline Scheme_Object * bin_min__comp_rat (const Scheme_Object * n1 , const Scheme_Object * n2 ) {

# 808 "bc/src/numcomp.c"
  Small_Complex sc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sc.r, 0), PUSH(sc.i, 1)));
# define XfOrM409_COUNT (2)
# define SETUP_XfOrM409(x) SETUP(XfOrM409_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sc.r = NULLED_OUT ; 
  sc.i = NULLED_OUT ; 

# 808 "bc/src/numcomp.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM409(_), bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((scheme_make_small_complex (n2 , & sc ) ) ) ) -> r ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 808 "bc/src/numcomp.c"
Scheme_Object * bin_min (const Scheme_Object * n1 , const Scheme_Object * n2 ) {
  /* No conversion */

# 808 "bc/src/numcomp.c"
  Scheme_Type t1 , t2 ; 

# 808 "bc/src/numcomp.c"
  if (((intptr_t ) (n1 ) ) & 0x1 )  {

# 808 "bc/src/numcomp.c"
    if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 808 "bc/src/numcomp.c"
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (((((intptr_t ) (n1 ) ) >> 1 ) < (((intptr_t ) (n2 ) ) >> 1 ) ) ? (((intptr_t ) (n1 ) ) >> 1 ) : (((intptr_t ) (n2 ) ) >> 1 ) ) ) ) << 1 ) | 0x1 ) ) ; 

# 808 "bc/src/numcomp.c"
    t2 = ((n2 ) -> type ) ; 

# 808 "bc/src/numcomp.c"
    if (t2 == scheme_float_type ) {

# 808 "bc/src/numcomp.c"
      float d = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 808 "bc/src/numcomp.c"
      if (__builtin_isnan (d ) )

# 808 "bc/src/numcomp.c"
      return scheme_single_nan_object ; 

# 808 "bc/src/numcomp.c"
      return scheme_make_float (((((intptr_t ) (n1 ) ) >> 1 ) < d ) ? (((intptr_t ) (n1 ) ) >> 1 ) : d ) ; 
    }

# 808 "bc/src/numcomp.c"
    if (t2 == scheme_double_type ) {

# 808 "bc/src/numcomp.c"
      double d = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 808 "bc/src/numcomp.c"
      if (__builtin_isnan (d ) )

# 808 "bc/src/numcomp.c"
      return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
      return scheme_make_double (((((intptr_t ) (n1 ) ) >> 1 ) < d ) ? (((intptr_t ) (n1 ) ) >> 1 ) : d ) ; 
    }

# 808 "bc/src/numcomp.c"
    if (t2 == scheme_bignum_type ) {

# 808 "bc/src/numcomp.c"
      return bin_min__int_big (n1 , n2 ) ; 
    }

# 808 "bc/src/numcomp.c"
    if (t2 == scheme_rational_type ) {

# 808 "bc/src/numcomp.c"
      return bin_min__int_rat (n1 , n2 ) ; 
    }

# 808 "bc/src/numcomp.c"
    if (t2 == scheme_complex_type )  {

# 808 "bc/src/numcomp.c"
      return bin_min__int_comp (n1 , n2 ) ; 
    }

# 808 "bc/src/numcomp.c"
    return bin_min__wrong_contract (n2 ) ; 
  }

# 808 "bc/src/numcomp.c"
  else {

# 808 "bc/src/numcomp.c"
    t1 = ((n1 ) -> type ) ; 

# 808 "bc/src/numcomp.c"
    if (t1 == scheme_float_type ) {

# 808 "bc/src/numcomp.c"
      float d1 = (((Scheme_Float * ) (n1 ) ) -> float_val ) ; 

# 808 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
        return scheme_single_nan_object ; 

# 808 "bc/src/numcomp.c"
        return scheme_make_float ((d1 < (((intptr_t ) (n2 ) ) >> 1 ) ) ? d1 : (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 808 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 808 "bc/src/numcomp.c"
        float d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
        return scheme_single_nan_object ; 

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d2 ) )

# 808 "bc/src/numcomp.c"
        return scheme_single_nan_object ; 

# 808 "bc/src/numcomp.c"
        return scheme_make_float ((d1 < d2 ) ? d1 : d2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 808 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d2 ) )

# 808 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
        return scheme_make_double ((d1 < d2 ) ? d1 : d2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__flt_big (d1 , n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__flt_rat (d1 , n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 808 "bc/src/numcomp.c"
        return bin_min__flt_comp (d1 , n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      return bin_min__wrong_contract (n2 ) ; 
    }

# 808 "bc/src/numcomp.c"
    else if (t1 == scheme_double_type ) {

# 808 "bc/src/numcomp.c"
      double d1 = (((Scheme_Double * ) (n1 ) ) -> double_val ) ; 

# 808 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
        return scheme_make_double ((d1 < (((intptr_t ) (n2 ) ) >> 1 ) ) ? d1 : (((intptr_t ) (n2 ) ) >> 1 ) ) ; 
      }

# 808 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 808 "bc/src/numcomp.c"
        double d2 = (((Scheme_Float * ) (n2 ) ) -> float_val ) ; 

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d2 ) )

# 808 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
        return scheme_make_double ((d1 < d2 ) ? d1 : d2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 808 "bc/src/numcomp.c"
        double d2 = (((Scheme_Double * ) (n2 ) ) -> double_val ) ; 

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d1 ) )

# 808 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
        if (__builtin_isnan (d2 ) )

# 808 "bc/src/numcomp.c"
        return scheme_nan_object ; 

# 808 "bc/src/numcomp.c"
        return scheme_make_double ((d1 < d2 ) ? d1 : d2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__dbl_big (d1 , n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__dbl_rat (d1 , n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 808 "bc/src/numcomp.c"
        return bin_min__dbl_comp (d1 , n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      return bin_min__wrong_contract (n2 ) ; 
    }

# 808 "bc/src/numcomp.c"
    else if (t1 == scheme_bignum_type ) {

# 808 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 808 "bc/src/numcomp.c"
        return bin_min__big_int (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__big_flt (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__big_dbl (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 808 "bc/src/numcomp.c"
      return scheme_bignum_min ((n1 ) , (n2 ) ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 808 "bc/src/numcomp.c"
      return bin_min__big_rat (n1 , n2 ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 808 "bc/src/numcomp.c"
        return bin_min__big_comp (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      return bin_min__wrong_contract (n2 ) ; 
    }

# 808 "bc/src/numcomp.c"
    else if (t1 == scheme_rational_type ) {

# 808 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 )  {

# 808 "bc/src/numcomp.c"
        return bin_min__rat_int (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__rat_flt (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__rat_dbl (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 808 "bc/src/numcomp.c"
      return bin_min__rat_big (n1 , n2 ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 808 "bc/src/numcomp.c"
      return scheme_rational_min ((n1 ) , (n2 ) ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type )  {

# 808 "bc/src/numcomp.c"
        return bin_min__rat_comp (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      return bin_min__wrong_contract (n2 ) ; 
    }

# 808 "bc/src/numcomp.c"
    else if (t1 == scheme_complex_type )  {

# 808 "bc/src/numcomp.c"
      if (((intptr_t ) (n2 ) ) & 0x1 ) 

# 808 "bc/src/numcomp.c"
      return bin_min__comp_int (n1 , n2 ) ; 

# 808 "bc/src/numcomp.c"
      t2 = ((n2 ) -> type ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_float_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__comp_flt (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_double_type ) {

# 808 "bc/src/numcomp.c"
        return bin_min__comp_dbl (n1 , n2 ) ; 
      }

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_bignum_type )

# 808 "bc/src/numcomp.c"
      return bin_min__comp_big (n1 , n2 ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_rational_type )

# 808 "bc/src/numcomp.c"
      return bin_min__comp_rat (n1 , n2 ) ; 

# 808 "bc/src/numcomp.c"
      if (t2 == scheme_complex_type ) 

# 808 "bc/src/numcomp.c"
      return bin_min ((((Scheme_Complex * ) ((n1 ) ) ) -> r ) , (((Scheme_Complex * ) ((n2 ) ) ) -> r ) ) ; 

# 808 "bc/src/numcomp.c"
      return bin_min__wrong_contract (n2 ) ; 
    }

# 808 "bc/src/numcomp.c"
    else return bin_min__wrong_contract (n1 ) ; 
  }
}

# 810 "bc/src/numcomp.c"
static Scheme_Object * sch_max (int argc , Scheme_Object * argv [] ) ; 

# 810 "bc/src/numcomp.c"
static inline Scheme_Object * sch_max__slow (Scheme_Object * ret , int argc , Scheme_Object * argv [] ) {

# 810 "bc/src/numcomp.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ret, 1)));
# define XfOrM445_COUNT (2)
# define SETUP_XfOrM445(x) SETUP(XfOrM445_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 810 "bc/src/numcomp.c"
  for (i = 1 ; i < argc ; ++ i ) {
#   define XfOrM447_COUNT (0+XfOrM445_COUNT)
#   define SETUP_XfOrM447(x) SETUP_XfOrM445(x)

# 810 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("max" , "real?" , i , argc , argv ) )
# 810 "bc/src/numcomp.c"
    ; 

# 810 "bc/src/numcomp.c"
    ret = FUNCCALL(SETUP_XfOrM447(_), bin_max (ret , argv [i ] ) ); 
  }

# 810 "bc/src/numcomp.c"
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 810 "bc/src/numcomp.c"
Scheme_Object * sch_max (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 810 "bc/src/numcomp.c"
  Scheme_Object * ret = argv [0 ] ; 

# 810 "bc/src/numcomp.c"
  if (! ((((intptr_t ) (ret ) ) & 0x1 ) || ((((ret ) -> type ) >= scheme_bignum_type ) && (((ret ) -> type ) < scheme_complex_type ) ) ) )

# 810 "bc/src/numcomp.c"
  scheme_wrong_contract ("max" , "real?" , 0 , argc , argv ) ; 

# 810 "bc/src/numcomp.c"
  if (argc == 1 )

# 810 "bc/src/numcomp.c"
  return ret ; 

# 810 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 810 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (argv [1 ] ) ) & 0x1 ) || ((((argv [1 ] ) -> type ) >= scheme_bignum_type ) && (((argv [1 ] ) -> type ) < scheme_complex_type ) ) ) )

# 810 "bc/src/numcomp.c"
    scheme_wrong_contract ("max" , "real?" , 1 , argc , argv ) ; 

# 810 "bc/src/numcomp.c"
    return bin_max (ret , argv [1 ] ) ; 
  }

# 810 "bc/src/numcomp.c"
  return sch_max__slow (ret , argc , argv ) ; 
}

# 811 "bc/src/numcomp.c"
static Scheme_Object * sch_min (int argc , Scheme_Object * argv [] ) ; 

# 811 "bc/src/numcomp.c"
static inline Scheme_Object * sch_min__slow (Scheme_Object * ret , int argc , Scheme_Object * argv [] ) {

# 811 "bc/src/numcomp.c"
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ret, 1)));
# define XfOrM450_COUNT (2)
# define SETUP_XfOrM450(x) SETUP(XfOrM450_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 811 "bc/src/numcomp.c"
  for (i = 1 ; i < argc ; ++ i ) {
#   define XfOrM452_COUNT (0+XfOrM450_COUNT)
#   define SETUP_XfOrM452(x) SETUP_XfOrM450(x)

# 811 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (argv [i ] ) ) & 0x1 ) || ((((argv [i ] ) -> type ) >= scheme_bignum_type ) && (((argv [i ] ) -> type ) < scheme_complex_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("min" , "real?" , i , argc , argv ) )
# 811 "bc/src/numcomp.c"
    ; 

# 811 "bc/src/numcomp.c"
    ret = FUNCCALL(SETUP_XfOrM452(_), bin_min (ret , argv [i ] ) ); 
  }

# 811 "bc/src/numcomp.c"
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 811 "bc/src/numcomp.c"
Scheme_Object * sch_min (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 811 "bc/src/numcomp.c"
  Scheme_Object * ret = argv [0 ] ; 

# 811 "bc/src/numcomp.c"
  if (! ((((intptr_t ) (ret ) ) & 0x1 ) || ((((ret ) -> type ) >= scheme_bignum_type ) && (((ret ) -> type ) < scheme_complex_type ) ) ) )

# 811 "bc/src/numcomp.c"
  scheme_wrong_contract ("min" , "real?" , 0 , argc , argv ) ; 

# 811 "bc/src/numcomp.c"
  if (argc == 1 )

# 811 "bc/src/numcomp.c"
  return ret ; 

# 811 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 811 "bc/src/numcomp.c"
    if (! ((((intptr_t ) (argv [1 ] ) ) & 0x1 ) || ((((argv [1 ] ) -> type ) >= scheme_bignum_type ) && (((argv [1 ] ) -> type ) < scheme_complex_type ) ) ) )

# 811 "bc/src/numcomp.c"
    scheme_wrong_contract ("min" , "real?" , 1 , argc , argv ) ; 

# 811 "bc/src/numcomp.c"
    return bin_min (ret , argv [1 ] ) ; 
  }

# 811 "bc/src/numcomp.c"
  return sch_min__slow (ret , argc , argv ) ; 
}

# 841 "bc/src/numcomp.c"
static Scheme_Object * fx_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 841 "bc/src/numcomp.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 841 "bc/src/numcomp.c"
  scheme_wrong_contract ("fx=" , "fixnum?" , 0 , argc , argv ) ; 

# 841 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 841 "bc/src/numcomp.c"
    if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 841 "bc/src/numcomp.c"
    scheme_wrong_contract ("fx=" , "fixnum?" , 1 , argc , argv ) ; 

# 841 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) == (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 841 "bc/src/numcomp.c"
    return scheme_true ; 

# 841 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 841 "bc/src/numcomp.c"
  else {

# 841 "bc/src/numcomp.c"
    int i ; 

# 841 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 841 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 841 "bc/src/numcomp.c"
      if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )

# 841 "bc/src/numcomp.c"
      scheme_wrong_contract ("fx=" , "fixnum?" , i , argc , argv ) ; 

# 841 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) == (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 841 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 841 "bc/src/numcomp.c"
    return result ; 
  }
}

# 842 "bc/src/numcomp.c"
static Scheme_Object * fx_lt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 842 "bc/src/numcomp.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 842 "bc/src/numcomp.c"
  scheme_wrong_contract ("fx<" , "fixnum?" , 0 , argc , argv ) ; 

# 842 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 842 "bc/src/numcomp.c"
    if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 842 "bc/src/numcomp.c"
    scheme_wrong_contract ("fx<" , "fixnum?" , 1 , argc , argv ) ; 

# 842 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) < (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 842 "bc/src/numcomp.c"
    return scheme_true ; 

# 842 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 842 "bc/src/numcomp.c"
  else {

# 842 "bc/src/numcomp.c"
    int i ; 

# 842 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 842 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 842 "bc/src/numcomp.c"
      if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )

# 842 "bc/src/numcomp.c"
      scheme_wrong_contract ("fx<" , "fixnum?" , i , argc , argv ) ; 

# 842 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) < (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 842 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 842 "bc/src/numcomp.c"
    return result ; 
  }
}

# 843 "bc/src/numcomp.c"
static Scheme_Object * fx_gt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 843 "bc/src/numcomp.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 843 "bc/src/numcomp.c"
  scheme_wrong_contract ("fx>" , "fixnum?" , 0 , argc , argv ) ; 

# 843 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 843 "bc/src/numcomp.c"
    if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 843 "bc/src/numcomp.c"
    scheme_wrong_contract ("fx>" , "fixnum?" , 1 , argc , argv ) ; 

# 843 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) > (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 843 "bc/src/numcomp.c"
    return scheme_true ; 

# 843 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 843 "bc/src/numcomp.c"
  else {

# 843 "bc/src/numcomp.c"
    int i ; 

# 843 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 843 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 843 "bc/src/numcomp.c"
      if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )

# 843 "bc/src/numcomp.c"
      scheme_wrong_contract ("fx>" , "fixnum?" , i , argc , argv ) ; 

# 843 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) > (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 843 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 843 "bc/src/numcomp.c"
    return result ; 
  }
}

# 844 "bc/src/numcomp.c"
static Scheme_Object * fx_lt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 844 "bc/src/numcomp.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 844 "bc/src/numcomp.c"
  scheme_wrong_contract ("fx<=" , "fixnum?" , 0 , argc , argv ) ; 

# 844 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 844 "bc/src/numcomp.c"
    if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 844 "bc/src/numcomp.c"
    scheme_wrong_contract ("fx<=" , "fixnum?" , 1 , argc , argv ) ; 

# 844 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) <= (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 844 "bc/src/numcomp.c"
    return scheme_true ; 

# 844 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 844 "bc/src/numcomp.c"
  else {

# 844 "bc/src/numcomp.c"
    int i ; 

# 844 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 844 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 844 "bc/src/numcomp.c"
      if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )

# 844 "bc/src/numcomp.c"
      scheme_wrong_contract ("fx<=" , "fixnum?" , i , argc , argv ) ; 

# 844 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) <= (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 844 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 844 "bc/src/numcomp.c"
    return result ; 
  }
}

# 845 "bc/src/numcomp.c"
static Scheme_Object * fx_gt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 845 "bc/src/numcomp.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 845 "bc/src/numcomp.c"
  scheme_wrong_contract ("fx>=" , "fixnum?" , 0 , argc , argv ) ; 

# 845 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 845 "bc/src/numcomp.c"
    if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 845 "bc/src/numcomp.c"
    scheme_wrong_contract ("fx>=" , "fixnum?" , 1 , argc , argv ) ; 

# 845 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) >= (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 845 "bc/src/numcomp.c"
    return scheme_true ; 

# 845 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 845 "bc/src/numcomp.c"
  else {

# 845 "bc/src/numcomp.c"
    int i ; 

# 845 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 845 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 845 "bc/src/numcomp.c"
      if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )

# 845 "bc/src/numcomp.c"
      scheme_wrong_contract ("fx>=" , "fixnum?" , i , argc , argv ) ; 

# 845 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) >= (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 845 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 845 "bc/src/numcomp.c"
    return result ; 
  }
}

# 846 "bc/src/numcomp.c"
static Scheme_Object * fx_min (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 846 "bc/src/numcomp.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 846 "bc/src/numcomp.c"
  scheme_wrong_contract ("fxmin" , "fixnum?" , 0 , argc , argv ) ; 

# 846 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 846 "bc/src/numcomp.c"
    if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 846 "bc/src/numcomp.c"
    scheme_wrong_contract ("fxmin" , "fixnum?" , 1 , argc , argv ) ; 

# 846 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) < (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 846 "bc/src/numcomp.c"
    return argv [0 ] ; 

# 846 "bc/src/numcomp.c"
    else return argv [1 ] ; 
  }

# 846 "bc/src/numcomp.c"
  else {

# 846 "bc/src/numcomp.c"
    int i ; 

# 846 "bc/src/numcomp.c"
    Scheme_Object * result = argv [0 ] ; 

# 846 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 846 "bc/src/numcomp.c"
      if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )

# 846 "bc/src/numcomp.c"
      scheme_wrong_contract ("fxmin" , "fixnum?" , i , argc , argv ) ; 

# 846 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (result ) ) >> 1 ) < (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 846 "bc/src/numcomp.c"
      result = argv [i ] ; 
    }

# 846 "bc/src/numcomp.c"
    return result ; 
  }
}

# 847 "bc/src/numcomp.c"
static Scheme_Object * fx_max (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 847 "bc/src/numcomp.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )

# 847 "bc/src/numcomp.c"
  scheme_wrong_contract ("fxmax" , "fixnum?" , 0 , argc , argv ) ; 

# 847 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 847 "bc/src/numcomp.c"
    if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )

# 847 "bc/src/numcomp.c"
    scheme_wrong_contract ("fxmax" , "fixnum?" , 1 , argc , argv ) ; 

# 847 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) > (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 847 "bc/src/numcomp.c"
    return argv [0 ] ; 

# 847 "bc/src/numcomp.c"
    else return argv [1 ] ; 
  }

# 847 "bc/src/numcomp.c"
  else {

# 847 "bc/src/numcomp.c"
    int i ; 

# 847 "bc/src/numcomp.c"
    Scheme_Object * result = argv [0 ] ; 

# 847 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 847 "bc/src/numcomp.c"
      if (! (((intptr_t ) (argv [i ] ) ) & 0x1 ) )

# 847 "bc/src/numcomp.c"
      scheme_wrong_contract ("fxmax" , "fixnum?" , i , argc , argv ) ; 

# 847 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (result ) ) >> 1 ) > (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 847 "bc/src/numcomp.c"
      result = argv [i ] ; 
    }

# 847 "bc/src/numcomp.c"
    return result ; 
  }
}

# 871 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fx_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 871 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 871 "bc/src/numcomp.c"
  return eq (argc , argv ) ; 

# 871 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 871 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) == (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 871 "bc/src/numcomp.c"
    return scheme_true ; 

# 871 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 871 "bc/src/numcomp.c"
  else {

# 871 "bc/src/numcomp.c"
    int i ; 

# 871 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 871 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 871 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) == (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 871 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 871 "bc/src/numcomp.c"
    return result ; 
  }
}

# 872 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fx_lt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 872 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 872 "bc/src/numcomp.c"
  return lt (argc , argv ) ; 

# 872 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 872 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) < (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 872 "bc/src/numcomp.c"
    return scheme_true ; 

# 872 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 872 "bc/src/numcomp.c"
  else {

# 872 "bc/src/numcomp.c"
    int i ; 

# 872 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 872 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 872 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) < (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 872 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 872 "bc/src/numcomp.c"
    return result ; 
  }
}

# 873 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fx_gt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 873 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 873 "bc/src/numcomp.c"
  return gt (argc , argv ) ; 

# 873 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 873 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) > (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 873 "bc/src/numcomp.c"
    return scheme_true ; 

# 873 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 873 "bc/src/numcomp.c"
  else {

# 873 "bc/src/numcomp.c"
    int i ; 

# 873 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 873 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 873 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) > (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 873 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 873 "bc/src/numcomp.c"
    return result ; 
  }
}

# 874 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fx_lt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 874 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 874 "bc/src/numcomp.c"
  return lt_eq (argc , argv ) ; 

# 874 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 874 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) <= (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 874 "bc/src/numcomp.c"
    return scheme_true ; 

# 874 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 874 "bc/src/numcomp.c"
  else {

# 874 "bc/src/numcomp.c"
    int i ; 

# 874 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 874 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 874 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) <= (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 874 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 874 "bc/src/numcomp.c"
    return result ; 
  }
}

# 875 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fx_gt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 875 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 875 "bc/src/numcomp.c"
  return gt_eq (argc , argv ) ; 

# 875 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 875 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) >= (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 875 "bc/src/numcomp.c"
    return scheme_true ; 

# 875 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 875 "bc/src/numcomp.c"
  else {

# 875 "bc/src/numcomp.c"
    int i ; 

# 875 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 875 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 875 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (argv [i - 1 ] ) ) >> 1 ) >= (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 875 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 875 "bc/src/numcomp.c"
    return result ; 
  }
}

# 877 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fx_min (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 877 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 877 "bc/src/numcomp.c"
  return sch_min (argc , argv ) ; 

# 877 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 877 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) < (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 877 "bc/src/numcomp.c"
    return argv [0 ] ; 

# 877 "bc/src/numcomp.c"
    else return argv [1 ] ; 
  }

# 877 "bc/src/numcomp.c"
  else {

# 877 "bc/src/numcomp.c"
    int i ; 

# 877 "bc/src/numcomp.c"
    Scheme_Object * result = argv [0 ] ; 

# 877 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 877 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (result ) ) >> 1 ) < (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 877 "bc/src/numcomp.c"
      result = argv [i ] ; 
    }

# 877 "bc/src/numcomp.c"
    return result ; 
  }
}

# 878 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fx_max (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 878 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 878 "bc/src/numcomp.c"
  return sch_max (argc , argv ) ; 

# 878 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 878 "bc/src/numcomp.c"
    if ((((intptr_t ) (argv [0 ] ) ) >> 1 ) > (((intptr_t ) (argv [1 ] ) ) >> 1 ) )

# 878 "bc/src/numcomp.c"
    return argv [0 ] ; 

# 878 "bc/src/numcomp.c"
    else return argv [1 ] ; 
  }

# 878 "bc/src/numcomp.c"
  else {

# 878 "bc/src/numcomp.c"
    int i ; 

# 878 "bc/src/numcomp.c"
    Scheme_Object * result = argv [0 ] ; 

# 878 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 878 "bc/src/numcomp.c"
      if (! ((((intptr_t ) (result ) ) >> 1 ) > (((intptr_t ) (argv [i ] ) ) >> 1 ) ) )

# 878 "bc/src/numcomp.c"
      result = argv [i ] ; 
    }

# 878 "bc/src/numcomp.c"
    return result ; 
  }
}

# 906 "bc/src/numcomp.c"
static Scheme_Object * fl_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 906 "bc/src/numcomp.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 906 "bc/src/numcomp.c"
  scheme_wrong_contract ("fl=" , "flonum?" , 0 , argc , argv ) ; 

# 906 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 906 "bc/src/numcomp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 906 "bc/src/numcomp.c"
    scheme_wrong_contract ("fl=" , "flonum?" , 1 , argc , argv ) ; 

# 906 "bc/src/numcomp.c"
    ; 

# 906 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) == (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 906 "bc/src/numcomp.c"
    return scheme_true ; 

# 906 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 906 "bc/src/numcomp.c"
  else {

# 906 "bc/src/numcomp.c"
    int i ; 

# 906 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 906 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 906 "bc/src/numcomp.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 906 "bc/src/numcomp.c"
      scheme_wrong_contract ("fl=" , "flonum?" , i , argc , argv ) ; 

# 906 "bc/src/numcomp.c"
      ; 

# 906 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) == (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 906 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 906 "bc/src/numcomp.c"
    return result ; 
  }
}

# 907 "bc/src/numcomp.c"
static Scheme_Object * fl_lt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 907 "bc/src/numcomp.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 907 "bc/src/numcomp.c"
  scheme_wrong_contract ("fl<" , "flonum?" , 0 , argc , argv ) ; 

# 907 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 907 "bc/src/numcomp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 907 "bc/src/numcomp.c"
    scheme_wrong_contract ("fl<" , "flonum?" , 1 , argc , argv ) ; 

# 907 "bc/src/numcomp.c"
    ; 

# 907 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) < (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 907 "bc/src/numcomp.c"
    return scheme_true ; 

# 907 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 907 "bc/src/numcomp.c"
  else {

# 907 "bc/src/numcomp.c"
    int i ; 

# 907 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 907 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 907 "bc/src/numcomp.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 907 "bc/src/numcomp.c"
      scheme_wrong_contract ("fl<" , "flonum?" , i , argc , argv ) ; 

# 907 "bc/src/numcomp.c"
      ; 

# 907 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) < (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 907 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 907 "bc/src/numcomp.c"
    return result ; 
  }
}

# 908 "bc/src/numcomp.c"
static Scheme_Object * fl_gt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 908 "bc/src/numcomp.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 908 "bc/src/numcomp.c"
  scheme_wrong_contract ("fl>" , "flonum?" , 0 , argc , argv ) ; 

# 908 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 908 "bc/src/numcomp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 908 "bc/src/numcomp.c"
    scheme_wrong_contract ("fl>" , "flonum?" , 1 , argc , argv ) ; 

# 908 "bc/src/numcomp.c"
    ; 

# 908 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) > (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 908 "bc/src/numcomp.c"
    return scheme_true ; 

# 908 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 908 "bc/src/numcomp.c"
  else {

# 908 "bc/src/numcomp.c"
    int i ; 

# 908 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 908 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 908 "bc/src/numcomp.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 908 "bc/src/numcomp.c"
      scheme_wrong_contract ("fl>" , "flonum?" , i , argc , argv ) ; 

# 908 "bc/src/numcomp.c"
      ; 

# 908 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) > (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 908 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 908 "bc/src/numcomp.c"
    return result ; 
  }
}

# 909 "bc/src/numcomp.c"
static Scheme_Object * fl_lt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 909 "bc/src/numcomp.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 909 "bc/src/numcomp.c"
  scheme_wrong_contract ("fl<=" , "flonum?" , 0 , argc , argv ) ; 

# 909 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 909 "bc/src/numcomp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 909 "bc/src/numcomp.c"
    scheme_wrong_contract ("fl<=" , "flonum?" , 1 , argc , argv ) ; 

# 909 "bc/src/numcomp.c"
    ; 

# 909 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) <= (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 909 "bc/src/numcomp.c"
    return scheme_true ; 

# 909 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 909 "bc/src/numcomp.c"
  else {

# 909 "bc/src/numcomp.c"
    int i ; 

# 909 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 909 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 909 "bc/src/numcomp.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 909 "bc/src/numcomp.c"
      scheme_wrong_contract ("fl<=" , "flonum?" , i , argc , argv ) ; 

# 909 "bc/src/numcomp.c"
      ; 

# 909 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) <= (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 909 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 909 "bc/src/numcomp.c"
    return result ; 
  }
}

# 910 "bc/src/numcomp.c"
static Scheme_Object * fl_gt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 910 "bc/src/numcomp.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 910 "bc/src/numcomp.c"
  scheme_wrong_contract ("fl>=" , "flonum?" , 0 , argc , argv ) ; 

# 910 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 910 "bc/src/numcomp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 910 "bc/src/numcomp.c"
    scheme_wrong_contract ("fl>=" , "flonum?" , 1 , argc , argv ) ; 

# 910 "bc/src/numcomp.c"
    ; 

# 910 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) >= (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 910 "bc/src/numcomp.c"
    return scheme_true ; 

# 910 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 910 "bc/src/numcomp.c"
  else {

# 910 "bc/src/numcomp.c"
    int i ; 

# 910 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 910 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 910 "bc/src/numcomp.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 910 "bc/src/numcomp.c"
      scheme_wrong_contract ("fl>=" , "flonum?" , i , argc , argv ) ; 

# 910 "bc/src/numcomp.c"
      ; 

# 910 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) >= (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 910 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 910 "bc/src/numcomp.c"
    return result ; 
  }
}


static Scheme_Object * fl_min (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 915 "bc/src/numcomp.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 915 "bc/src/numcomp.c"
  scheme_wrong_contract ("flmin" , "flonum?" , 0 , argc , argv ) ; 

# 915 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 915 "bc/src/numcomp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 915 "bc/src/numcomp.c"
    scheme_wrong_contract ("flmin" , "flonum?" , 1 , argc , argv ) ; 

# 915 "bc/src/numcomp.c"
    {

# 915 "bc/src/numcomp.c"
      if (__builtin_isnan ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ) || __builtin_isnan ((((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ) )

# 915 "bc/src/numcomp.c"
      return scheme_nan_object ; 
    }

# 915 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) < (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 915 "bc/src/numcomp.c"
    return argv [0 ] ; 

# 915 "bc/src/numcomp.c"
    else return argv [1 ] ; 
  }

# 915 "bc/src/numcomp.c"
  else {

# 915 "bc/src/numcomp.c"
    int i ; 

# 915 "bc/src/numcomp.c"
    Scheme_Object * result = argv [0 ] ; 

# 915 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 915 "bc/src/numcomp.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 915 "bc/src/numcomp.c"
      scheme_wrong_contract ("flmin" , "flonum?" , i , argc , argv ) ; 

# 915 "bc/src/numcomp.c"
      if (__builtin_isnan ((((Scheme_Double * ) (result ) ) -> double_val ) ) || __builtin_isnan ((((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) ) {

# 915 "bc/src/numcomp.c"
        result = scheme_nan_object ; 
      }

# 915 "bc/src/numcomp.c"
      else if (! ((((Scheme_Double * ) (result ) ) -> double_val ) < (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 915 "bc/src/numcomp.c"
      result = argv [i ] ; 
    }

# 915 "bc/src/numcomp.c"
    return result ; 
  }
}

# 916 "bc/src/numcomp.c"
static Scheme_Object * fl_max (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 916 "bc/src/numcomp.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 916 "bc/src/numcomp.c"
  scheme_wrong_contract ("flmax" , "flonum?" , 0 , argc , argv ) ; 

# 916 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 916 "bc/src/numcomp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 916 "bc/src/numcomp.c"
    scheme_wrong_contract ("flmax" , "flonum?" , 1 , argc , argv ) ; 

# 916 "bc/src/numcomp.c"
    {

# 916 "bc/src/numcomp.c"
      if (__builtin_isnan ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ) || __builtin_isnan ((((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ) )

# 916 "bc/src/numcomp.c"
      return scheme_nan_object ; 
    }

# 916 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) > (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 916 "bc/src/numcomp.c"
    return argv [0 ] ; 

# 916 "bc/src/numcomp.c"
    else return argv [1 ] ; 
  }

# 916 "bc/src/numcomp.c"
  else {

# 916 "bc/src/numcomp.c"
    int i ; 

# 916 "bc/src/numcomp.c"
    Scheme_Object * result = argv [0 ] ; 

# 916 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 916 "bc/src/numcomp.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) )

# 916 "bc/src/numcomp.c"
      scheme_wrong_contract ("flmax" , "flonum?" , i , argc , argv ) ; 

# 916 "bc/src/numcomp.c"
      if (__builtin_isnan ((((Scheme_Double * ) (result ) ) -> double_val ) ) || __builtin_isnan ((((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) ) {

# 916 "bc/src/numcomp.c"
        result = scheme_nan_object ; 
      }

# 916 "bc/src/numcomp.c"
      else if (! ((((Scheme_Double * ) (result ) ) -> double_val ) > (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 916 "bc/src/numcomp.c"
      result = argv [i ] ; 
    }

# 916 "bc/src/numcomp.c"
    return result ; 
  }
}

# 942 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fl_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 942 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 942 "bc/src/numcomp.c"
  return eq (argc , argv ) ; 

# 942 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 942 "bc/src/numcomp.c"
    ; 

# 942 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) == (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 942 "bc/src/numcomp.c"
    return scheme_true ; 

# 942 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 942 "bc/src/numcomp.c"
  else {

# 942 "bc/src/numcomp.c"
    int i ; 

# 942 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 942 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 942 "bc/src/numcomp.c"
      ; 

# 942 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) == (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 942 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 942 "bc/src/numcomp.c"
    return result ; 
  }
}

# 943 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fl_lt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 943 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 943 "bc/src/numcomp.c"
  return lt (argc , argv ) ; 

# 943 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 943 "bc/src/numcomp.c"
    ; 

# 943 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) < (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 943 "bc/src/numcomp.c"
    return scheme_true ; 

# 943 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 943 "bc/src/numcomp.c"
  else {

# 943 "bc/src/numcomp.c"
    int i ; 

# 943 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 943 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 943 "bc/src/numcomp.c"
      ; 

# 943 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) < (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 943 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 943 "bc/src/numcomp.c"
    return result ; 
  }
}

# 944 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fl_gt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 944 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 944 "bc/src/numcomp.c"
  return gt (argc , argv ) ; 

# 944 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 944 "bc/src/numcomp.c"
    ; 

# 944 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) > (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 944 "bc/src/numcomp.c"
    return scheme_true ; 

# 944 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 944 "bc/src/numcomp.c"
  else {

# 944 "bc/src/numcomp.c"
    int i ; 

# 944 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 944 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 944 "bc/src/numcomp.c"
      ; 

# 944 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) > (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 944 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 944 "bc/src/numcomp.c"
    return result ; 
  }
}

# 945 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fl_lt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 945 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 945 "bc/src/numcomp.c"
  return lt_eq (argc , argv ) ; 

# 945 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 945 "bc/src/numcomp.c"
    ; 

# 945 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) <= (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 945 "bc/src/numcomp.c"
    return scheme_true ; 

# 945 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 945 "bc/src/numcomp.c"
  else {

# 945 "bc/src/numcomp.c"
    int i ; 

# 945 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 945 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 945 "bc/src/numcomp.c"
      ; 

# 945 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) <= (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 945 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 945 "bc/src/numcomp.c"
    return result ; 
  }
}

# 946 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fl_gt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 946 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 946 "bc/src/numcomp.c"
  return gt_eq (argc , argv ) ; 

# 946 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 946 "bc/src/numcomp.c"
    ; 

# 946 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) >= (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 946 "bc/src/numcomp.c"
    return scheme_true ; 

# 946 "bc/src/numcomp.c"
    else return scheme_false ; 
  }

# 946 "bc/src/numcomp.c"
  else {

# 946 "bc/src/numcomp.c"
    int i ; 

# 946 "bc/src/numcomp.c"
    Scheme_Object * result = scheme_true ; 

# 946 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 946 "bc/src/numcomp.c"
      ; 

# 946 "bc/src/numcomp.c"
      if (! ((((Scheme_Double * ) (argv [i - 1 ] ) ) -> double_val ) >= (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 946 "bc/src/numcomp.c"
      result = scheme_false ; 
    }

# 946 "bc/src/numcomp.c"
    return result ; 
  }
}

# 948 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fl_min (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 948 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 948 "bc/src/numcomp.c"
  return sch_min (argc , argv ) ; 

# 948 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 948 "bc/src/numcomp.c"
    {

# 948 "bc/src/numcomp.c"
      if (__builtin_isnan ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ) || __builtin_isnan ((((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ) )

# 948 "bc/src/numcomp.c"
      return scheme_nan_object ; 
    }

# 948 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) < (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 948 "bc/src/numcomp.c"
    return argv [0 ] ; 

# 948 "bc/src/numcomp.c"
    else return argv [1 ] ; 
  }

# 948 "bc/src/numcomp.c"
  else {

# 948 "bc/src/numcomp.c"
    int i ; 

# 948 "bc/src/numcomp.c"
    Scheme_Object * result = argv [0 ] ; 

# 948 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 948 "bc/src/numcomp.c"
      if (__builtin_isnan ((((Scheme_Double * ) (result ) ) -> double_val ) ) || __builtin_isnan ((((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) ) {

# 948 "bc/src/numcomp.c"
        result = scheme_nan_object ; 
      }

# 948 "bc/src/numcomp.c"
      else if (! ((((Scheme_Double * ) (result ) ) -> double_val ) < (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 948 "bc/src/numcomp.c"
      result = argv [i ] ; 
    }

# 948 "bc/src/numcomp.c"
    return result ; 
  }
}

# 949 "bc/src/numcomp.c"
static Scheme_Object * unsafe_fl_max (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 949 "bc/src/numcomp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding )

# 949 "bc/src/numcomp.c"
  return sch_max (argc , argv ) ; 

# 949 "bc/src/numcomp.c"
  if (argc == 2 ) {

# 949 "bc/src/numcomp.c"
    {

# 949 "bc/src/numcomp.c"
      if (__builtin_isnan ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ) || __builtin_isnan ((((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ) )

# 949 "bc/src/numcomp.c"
      return scheme_nan_object ; 
    }

# 949 "bc/src/numcomp.c"
    if ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) > (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) )

# 949 "bc/src/numcomp.c"
    return argv [0 ] ; 

# 949 "bc/src/numcomp.c"
    else return argv [1 ] ; 
  }

# 949 "bc/src/numcomp.c"
  else {

# 949 "bc/src/numcomp.c"
    int i ; 

# 949 "bc/src/numcomp.c"
    Scheme_Object * result = argv [0 ] ; 

# 949 "bc/src/numcomp.c"
    for (i = 1 ; i < argc ; i ++ ) {

# 949 "bc/src/numcomp.c"
      if (__builtin_isnan ((((Scheme_Double * ) (result ) ) -> double_val ) ) || __builtin_isnan ((((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) ) {

# 949 "bc/src/numcomp.c"
        result = scheme_nan_object ; 
      }

# 949 "bc/src/numcomp.c"
      else if (! ((((Scheme_Double * ) (result ) ) -> double_val ) > (((Scheme_Double * ) (argv [i ] ) ) -> double_val ) ) )

# 949 "bc/src/numcomp.c"
      result = argv [i ] ; 
    }

# 949 "bc/src/numcomp.c"
    return result ; 
  }
}

# 976 "bc/src/numcomp.c"
static Scheme_Object * extfl_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 976 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl=" ": " "unsupported on this platform" ) ; 

# 976 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 977 "bc/src/numcomp.c"
static Scheme_Object * extfl_lt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 977 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl<" ": " "unsupported on this platform" ) ; 

# 977 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 978 "bc/src/numcomp.c"
static Scheme_Object * extfl_gt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 978 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl>" ": " "unsupported on this platform" ) ; 

# 978 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 979 "bc/src/numcomp.c"
static Scheme_Object * extfl_lt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 979 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl<=" ": " "unsupported on this platform" ) ; 

# 979 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 980 "bc/src/numcomp.c"
static Scheme_Object * extfl_gt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 980 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extfl>=" ": " "unsupported on this platform" ) ; 

# 980 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}


static Scheme_Object * extfl_min (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 984 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extflmin" ": " "unsupported on this platform" ) ; 

# 984 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 985 "bc/src/numcomp.c"
static Scheme_Object * extfl_max (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 985 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "extflmax" ": " "unsupported on this platform" ) ; 

# 985 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 1022 "bc/src/numcomp.c"
static Scheme_Object * unsafe_extfl_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1022 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_eqv" ": " "unsupported on this platform" ) ; 

# 1022 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 1023 "bc/src/numcomp.c"
static Scheme_Object * unsafe_extfl_lt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1023 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_less" ": " "unsupported on this platform" ) ; 

# 1023 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 1024 "bc/src/numcomp.c"
static Scheme_Object * unsafe_extfl_gt (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1024 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_greater" ": " "unsupported on this platform" ) ; 

# 1024 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 1025 "bc/src/numcomp.c"
static Scheme_Object * unsafe_extfl_lt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1025 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_less_or_eqv" ": " "unsupported on this platform" ) ; 

# 1025 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 1026 "bc/src/numcomp.c"
static Scheme_Object * unsafe_extfl_gt_eq (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1026 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_greater_or_eqv" ": " "unsupported on this platform" ) ; 

# 1026 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}
static Scheme_Object * unsafe_extfl_min (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1028 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_less" ": " "unsupported on this platform" ) ; 

# 1028 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}

# 1029 "bc/src/numcomp.c"
static Scheme_Object * unsafe_extfl_max (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 1029 "bc/src/numcomp.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-extfl" "long_double_greater" ": " "unsupported on this platform" ) ; 

# 1029 "bc/src/numcomp.c"
  return ((void * ) 0 ) ; 
}
