#include "precomp.h"

# 34 "bc/rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 121 "rktio/rktio.h"
typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 351 "rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "rktio/rktio.h"
rktio_process_result_t ; 

# 646 "rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "rktio/rktio.h"
rktio_status_t ; 

# 669 "rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "rktio/rktio.h"
rktio_identity_t ; 

# 925 "rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "rktio/rktio.h"
rktio_date_t ; 

# 1109 "rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "rktio/rktio.h"
rktio_sha1_ctx_t ; 



__xform_nongcing__ extern void rktio_sha1_init (rktio_sha1_ctx_t * context ) ; 



__xform_nongcing__ extern void rktio_sha1_update (rktio_sha1_ctx_t * context , 
const unsigned char * data , intptr_t start , intptr_t end ) ; 


__xform_nongcing__ extern void rktio_sha1_final (rktio_sha1_ctx_t * context , unsigned char * digest ) ; 


typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "rktio/rktio.h"
rktio_sha2_ctx_t ; 




__xform_nongcing__ extern void rktio_sha2_init (rktio_sha2_ctx_t * ctx , rktio_bool_t is224 ) ; 
__xform_nongcing__ extern void rktio_sha2_update (rktio_sha2_ctx_t * ctx , 
const unsigned char * data , intptr_t start , intptr_t end ) ; 
__xform_nongcing__ extern void rktio_sha2_final (rktio_sha2_ctx_t * ctx , unsigned char * digest ) ; 




typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 

# 1378 "rktio/rktio.h"
enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 




enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

# 8 "bc/src/portfun.c"
static Scheme_Object * input_port_p (int , Scheme_Object * [] ) ; 
static Scheme_Object * output_port_p (int , Scheme_Object * [] ) ; 
static Scheme_Object * port_closed_p (int , Scheme_Object * [] ) ; 
static Scheme_Object * string_port_p (int , Scheme_Object * [] ) ; 
static Scheme_Object * current_input_port (int , Scheme_Object * [] ) ; 
static Scheme_Object * current_output_port (int , Scheme_Object * [] ) ; 
static Scheme_Object * current_error_port (int , Scheme_Object * [] ) ; 
static Scheme_Object * make_input_port (int , Scheme_Object * [] ) ; 
static Scheme_Object * make_output_port (int , Scheme_Object * [] ) ; 
static Scheme_Object * open_input_file (int , Scheme_Object * [] ) ; 
static Scheme_Object * open_output_file (int , Scheme_Object * [] ) ; 
static Scheme_Object * open_input_output_file (int , Scheme_Object * [] ) ; 
static Scheme_Object * close_input_port (int , Scheme_Object * [] ) ; 
static Scheme_Object * close_output_port (int , Scheme_Object * [] ) ; 
static Scheme_Object * call_with_output_file (int , Scheme_Object * [] ) ; 
static Scheme_Object * call_with_input_file (int , Scheme_Object * [] ) ; 
static Scheme_Object * with_input_from_file (int , Scheme_Object * [] ) ; 
static Scheme_Object * with_output_to_file (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_char (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_char_spec (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_byte (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_byte_spec (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_line (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_byte_line (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_read_string (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_read_string_bang (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_peek_string (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_peek_string_bang (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_read_bytes (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_read_bytes_bang (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_peek_bytes (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_peek_bytes_bang (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_bytes_bang (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_bytes_bang_nonblock (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_bytes_bang_break (int , Scheme_Object * [] ) ; 
static Scheme_Object * peek_bytes_bang (int , Scheme_Object * [] ) ; 
static Scheme_Object * peek_bytes_bang_nonblock (int , Scheme_Object * [] ) ; 
static Scheme_Object * peek_bytes_bang_break (int , Scheme_Object * [] ) ; 
static Scheme_Object * write_bytes (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * write_string (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * write_bytes_avail (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * write_bytes_avail_nonblock (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * write_bytes_avail_break (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * can_write_atomic (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * can_provide_progress_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * can_write_special (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * peek_char (int , Scheme_Object * [] ) ; 
static Scheme_Object * peek_char_spec (int , Scheme_Object * [] ) ; 
static Scheme_Object * peek_byte (int , Scheme_Object * [] ) ; 
static Scheme_Object * peek_byte_spec (int , Scheme_Object * [] ) ; 
static Scheme_Object * eof_object_p (int , Scheme_Object * [] ) ; 
static Scheme_Object * char_ready_p (int , Scheme_Object * [] ) ; 
static Scheme_Object * byte_ready_p (int , Scheme_Object * [] ) ; 
static Scheme_Object * peeked_read (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * progress_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * is_progress_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * closed_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * write_bytes_avail_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * write_special_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_write (int , Scheme_Object * [] ) ; 
static Scheme_Object * display (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_print (int , Scheme_Object * [] ) ; 
static Scheme_Object * newline (int , Scheme_Object * [] ) ; 
static Scheme_Object * write_char (int , Scheme_Object * [] ) ; 
static Scheme_Object * write_byte (int , Scheme_Object * [] ) ; 
static Scheme_Object * current_load_directory (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_write_directory (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * load_on_demand_enabled (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * flush_output (int , Scheme_Object * [] ) ; 
static Scheme_Object * open_input_char_string (int , Scheme_Object * [] ) ; 
static Scheme_Object * open_input_byte_string (int , Scheme_Object * [] ) ; 
static Scheme_Object * open_output_string (int , Scheme_Object * [] ) ; 
static Scheme_Object * get_output_char_string (int , Scheme_Object * [] ) ; 
static Scheme_Object * get_output_byte_string (int , Scheme_Object * [] ) ; 
static Scheme_Object * sch_pipe (int , Scheme_Object * * args ) ; 
static Scheme_Object * pipe_length (int , Scheme_Object * * args ) ; 
static Scheme_Object * port_read_handler (int , Scheme_Object * * args ) ; 
static Scheme_Object * port_display_handler (int , Scheme_Object * * args ) ; 
static Scheme_Object * port_write_handler (int , Scheme_Object * * args ) ; 
static Scheme_Object * port_print_handler (int , Scheme_Object * * args ) ; 
static Scheme_Object * global_port_print_handler (int , Scheme_Object * * args ) ; 
static Scheme_Object * global_port_count_lines (int , Scheme_Object * * args ) ; 
static Scheme_Object * port_count_lines (int , Scheme_Object * * args ) ; 
static Scheme_Object * port_counts_lines_p (int , Scheme_Object * * args ) ; 
static Scheme_Object * port_next_location (int , Scheme_Object * * args ) ; 
static Scheme_Object * set_port_next_location (int , Scheme_Object * * args ) ; 

static Scheme_Object * filesystem_change_evt (int , Scheme_Object * * args ) ; 
static Scheme_Object * filesystem_change_evt_p (int , Scheme_Object * * args ) ; 
static Scheme_Object * filesystem_change_evt_cancel (int , Scheme_Object * * args ) ; 

static Scheme_Object * sch_default_read_handler (void * ignore , int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_default_display_handler (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_default_write_handler (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_default_print_handler (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * sch_default_global_port_print_handler (int argc , Scheme_Object * argv [] ) ; 

static int pipe_input_p (Scheme_Object * o ) ; 
static int pipe_output_p (Scheme_Object * o ) ; 
static int pipe_out_ready (Scheme_Output_Port * p ) ; 

static Scheme_Object * sha1_bytes (int , Scheme_Object * * args ) ; 
static Scheme_Object * sha224_bytes (int , Scheme_Object * * args ) ; 
static Scheme_Object * sha256_bytes (int , Scheme_Object * * args ) ; 


static void register_traversers (void ) ; 


static Scheme_Object * any_symbol ; 
static Scheme_Object * any_one_symbol ; 
static Scheme_Object * cr_symbol ; 
static Scheme_Object * lf_symbol ; 
static Scheme_Object * crlf_symbol ; 
static Scheme_Object * module_symbol ; 
static Scheme_Object * string_symbol ; 
static Scheme_Object * special_symbol ; 

static Scheme_Object * default_read_handler ; 
static Scheme_Object * default_display_handler ; 
static Scheme_Object * default_write_handler ; 
static Scheme_Object * default_print_handler ; 

Scheme_Object * scheme_eof_object_p_proc ; 
Scheme_Object * scheme_default_global_print_handler ; 

Scheme_Object * scheme_write_proc ; 
Scheme_Object * scheme_display_proc ; 
Scheme_Object * scheme_print_proc ; 

Scheme_Object * initial_compiled_file_paths ; 
Scheme_Object * initial_compiled_file_roots ; 

static int compiled_file_check = 0 ; 
static Scheme_Object * initial_compiled_file_check_symbol ; 

int scheme_ignore_user_paths ; 
void scheme_set_ignore_user_paths (int v ) {
  /* No conversion */

# 147 "bc/src/portfun.c"
  scheme_ignore_user_paths = v ; 
}
int scheme_ignore_link_paths ; 
void scheme_set_ignore_link_paths (int v ) {
  /* No conversion */

# 150 "bc/src/portfun.c"
  scheme_ignore_link_paths = v ; 
}

; 







void 
scheme_init_port_fun (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg158 = NULLED_OUT ; 
  Scheme_Object * __funcarg157 = NULLED_OUT ; 
  Scheme_Object * __funcarg156 = NULLED_OUT ; 
  Scheme_Object * __funcarg155 = NULLED_OUT ; 
  Scheme_Object * __funcarg154 = NULLED_OUT ; 
  Scheme_Object * __funcarg153 = NULLED_OUT ; 
  Scheme_Object * __funcarg152 = NULLED_OUT ; 
  Scheme_Object * __funcarg151 = NULLED_OUT ; 
  Scheme_Object * __funcarg150 = NULLED_OUT ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  Scheme_Object * __funcarg148 = NULLED_OUT ; 
  Scheme_Object * __funcarg147 = NULLED_OUT ; 
  Scheme_Object * __funcarg146 = NULLED_OUT ; 
  Scheme_Object * __funcarg145 = NULLED_OUT ; 
  Scheme_Object * __funcarg144 = NULLED_OUT ; 
  Scheme_Object * __funcarg143 = NULLED_OUT ; 
  Scheme_Object * __funcarg142 = NULLED_OUT ; 
  Scheme_Object * __funcarg141 = NULLED_OUT ; 
  Scheme_Object * __funcarg140 = NULLED_OUT ; 
  Scheme_Object * __funcarg139 = NULLED_OUT ; 
  Scheme_Object * __funcarg138 = NULLED_OUT ; 
  Scheme_Object * __funcarg137 = NULLED_OUT ; 
  Scheme_Object * __funcarg136 = NULLED_OUT ; 
  Scheme_Object * __funcarg135 = NULLED_OUT ; 
  Scheme_Object * __funcarg134 = NULLED_OUT ; 
  Scheme_Object * __funcarg133 = NULLED_OUT ; 
  Scheme_Object * __funcarg132 = NULLED_OUT ; 
  Scheme_Object * __funcarg131 = NULLED_OUT ; 
  Scheme_Object * __funcarg130 = NULLED_OUT ; 
  Scheme_Object * __funcarg129 = NULLED_OUT ; 
  Scheme_Object * __funcarg128 = NULLED_OUT ; 
  Scheme_Object * __funcarg127 = NULLED_OUT ; 
  Scheme_Object * __funcarg126 = NULLED_OUT ; 
  Scheme_Object * __funcarg125 = NULLED_OUT ; 
  Scheme_Object * __funcarg124 = NULLED_OUT ; 
  Scheme_Object * __funcarg123 = NULLED_OUT ; 
  Scheme_Object * __funcarg122 = NULLED_OUT ; 
  Scheme_Object * __funcarg121 = NULLED_OUT ; 
  Scheme_Object * __funcarg120 = NULLED_OUT ; 
  Scheme_Object * __funcarg119 = NULLED_OUT ; 
  Scheme_Object * __funcarg118 = NULLED_OUT ; 
  Scheme_Object * __funcarg117 = NULLED_OUT ; 
  Scheme_Object * __funcarg116 = NULLED_OUT ; 
  Scheme_Object * __funcarg115 = NULLED_OUT ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM3_COUNT (1)
# define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM3(_), register_traversers () )
# 165 "bc/src/portfun.c"
  ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_register_static ((void * ) & default_read_handler , sizeof (default_read_handler ) ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & default_display_handler , sizeof (default_display_handler ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & default_write_handler , sizeof (default_write_handler ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & default_print_handler , sizeof (default_print_handler ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_write_proc , sizeof (scheme_write_proc ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_display_proc , sizeof (scheme_display_proc ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_print_proc , sizeof (scheme_print_proc ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & any_symbol , sizeof (any_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & any_one_symbol , sizeof (any_one_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & cr_symbol , sizeof (cr_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & lf_symbol , sizeof (lf_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & crlf_symbol , sizeof (crlf_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & module_symbol , sizeof (module_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & string_symbol , sizeof (string_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & special_symbol , sizeof (special_symbol ) ) ); 

  any_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("any" ) ); 
  any_one_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("any-one" ) ); 
  cr_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("return" ) ); 
  lf_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("linefeed" ) ); 
  crlf_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("return-linefeed" ) ); 
  module_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("module" ) ); 
  string_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("string" ) ); 
  special_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("special" ) ); 

  scheme_write_proc = FUNCCALL_AGAIN(scheme_make_noncm_prim (sch_write , "write" , 1 , 2 ) ); 
  scheme_display_proc = FUNCCALL_AGAIN(scheme_make_noncm_prim (display , "display" , 1 , 2 ) ); 
  scheme_print_proc = FUNCCALL_AGAIN(scheme_make_noncm_prim (sch_print , "print" , 1 , 3 ) ); 


  default_read_handler = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (sch_default_read_handler , ((void * ) 0 ) , "default-port-read-handler" , 1 , 2 ) ); 

  default_display_handler = FUNCCALL_AGAIN(scheme_make_prim_w_arity (sch_default_display_handler , "default-port-display-handler" , 2 , 2 ) ); 
  default_write_handler = FUNCCALL_AGAIN(scheme_make_prim_w_arity (sch_default_write_handler , "default-port-write-handler" , 2 , 2 ) ); 
  default_print_handler = FUNCCALL_AGAIN(scheme_make_prim_w_arity (sch_default_print_handler , "default-port-print-handler" , 2 , 3 ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("eof" , scheme_eof , env ) )
  ; 
  (__funcarg158 = FUNCCALL(SETUP_XfOrM3(_), scheme_register_parameter (current_input_port , "current-input-port" , MZCONFIG_INPUT_PORT ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-input-port" , __funcarg158 , env ) )) ; 
  (__funcarg157 = FUNCCALL(SETUP_XfOrM3(_), scheme_register_parameter (current_output_port , "current-output-port" , MZCONFIG_OUTPUT_PORT ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-output-port" , __funcarg157 , env ) )) ; 
  (__funcarg156 = FUNCCALL(SETUP_XfOrM3(_), scheme_register_parameter (current_error_port , "current-error-port" , MZCONFIG_ERROR_PORT ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-error-port" , __funcarg156 , env ) )) ; 
  (__funcarg155 = FUNCCALL(SETUP_XfOrM3(_), scheme_register_parameter (current_load_directory , "current-load-relative-directory" , MZCONFIG_LOAD_DIRECTORY ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-load-relative-directory" , __funcarg155 , env ) )) ; 
  (__funcarg154 = FUNCCALL(SETUP_XfOrM3(_), scheme_register_parameter (current_write_directory , "current-write-relative-directory" , MZCONFIG_WRITE_DIRECTORY ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-write-relative-directory" , __funcarg154 , env ) )) ; 
  (__funcarg153 = FUNCCALL(SETUP_XfOrM3(_), scheme_register_parameter (global_port_print_handler , "global-port-print-handler" , MZCONFIG_PORT_PRINT_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("global-port-print-handler" , __funcarg153 , env ) )) ; 
  (__funcarg152 = FUNCCALL(SETUP_XfOrM3(_), scheme_register_parameter (load_on_demand_enabled , "load-on-demand-enabled" , MZCONFIG_LOAD_DELAY_ENABLED ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("load-on-demand-enabled" , __funcarg152 , env ) )) ; 
  (__funcarg151 = FUNCCALL(SETUP_XfOrM3(_), scheme_register_parameter (global_port_count_lines , "port-count-lines-enabled" , MZCONFIG_PORT_COUNT_LINES ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-count-lines-enabled" , __funcarg151 , env ) )) ; 
  (__funcarg150 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (input_port_p , "input-port?" , 1 , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("input-port?" , __funcarg150 , env ) )) ; 
  (__funcarg149 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (output_port_p , "output-port?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("output-port?" , __funcarg149 , env ) )) ; 
  (__funcarg148 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (scheme_file_stream_port_p , "file-stream-port?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-stream-port?" , __funcarg148 , env ) )) ; 
  (__funcarg147 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (string_port_p , "string-port?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("string-port?" , __funcarg147 , env ) )) ; 
  (__funcarg146 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (scheme_terminal_port_p , "terminal-port?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("terminal-port?" , __funcarg146 , env ) )) ; 
  (__funcarg145 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_folding_prim (scheme_port_waiting_peer_p , "port-waiting-peer?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-waiting-peer?" , __funcarg145 , env ) )) ; 
  (__funcarg144 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (port_closed_p , "port-closed?" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-closed?" , __funcarg144 , env ) )) ; 
  (__funcarg143 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (open_input_file , "open-input-file" , 1 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("open-input-file" , __funcarg143 , env ) )) ; 
  (__funcarg142 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (open_input_byte_string , "open-input-bytes" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("open-input-bytes" , __funcarg142 , env ) )) ; 
  (__funcarg141 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (open_input_char_string , "open-input-string" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("open-input-string" , __funcarg141 , env ) )) ; 
  (__funcarg140 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (open_output_file , "open-output-file" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("open-output-file" , __funcarg140 , env ) )) ; 
  (__funcarg139 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (open_output_string , "open-output-bytes" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("open-output-bytes" , __funcarg139 , env ) )) ; 
  (__funcarg138 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (open_output_string , "open-output-string" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("open-output-string" , __funcarg138 , env ) )) ; 
  (__funcarg137 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (get_output_byte_string , "get-output-bytes" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("get-output-bytes" , __funcarg137 , env ) )) ; 
  (__funcarg136 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (get_output_char_string , "get-output-string" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("get-output-string" , __funcarg136 , env ) )) ; 
  (__funcarg135 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (open_input_output_file , "open-input-output-file" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("open-input-output-file" , __funcarg135 , env ) )) ; 
  (__funcarg134 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (close_input_port , "close-input-port" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("close-input-port" , __funcarg134 , env ) )) ; 
  (__funcarg133 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (close_output_port , "close-output-port" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("close-output-port" , __funcarg133 , env ) )) ; 
  (__funcarg132 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (make_input_port , "make-input-port" , 4 , 10 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-input-port" , __funcarg132 , env ) )) ; 
  (__funcarg131 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (make_output_port , "make-output-port" , 4 , 11 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-output-port" , __funcarg131 , env ) )) ; 
  (__funcarg130 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (call_with_output_file , 1 , "call-with-output-file" , 2 , 5 , 0 , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-output-file" , __funcarg130 , env ) )) ; 
  (__funcarg129 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (call_with_input_file , 1 , "call-with-input-file" , 2 , 3 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-input-file" , __funcarg129 , env ) )) ; 
  (__funcarg128 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (with_output_to_file , 1 , "with-output-to-file" , 2 , 5 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("with-output-to-file" , __funcarg128 , env ) )) ; 
  (__funcarg127 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (with_input_from_file , 1 , "with-input-from-file" , 2 , 3 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("with-input-from-file" , __funcarg127 , env ) )) ; 
  (__funcarg126 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (sch_pipe , 1 , "make-pipe" , 0 , 3 , 0 , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-pipe" , __funcarg126 , env ) )) ; 
  (__funcarg125 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (port_next_location , 1 , "port-next-location" , 1 , 1 , 0 , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-next-location" , __funcarg125 , env ) )) ; 
  (__funcarg124 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (set_port_next_location , "set-port-next-location!" , 4 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("set-port-next-location!" , __funcarg124 , env ) )) ; 
  (__funcarg123 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (filesystem_change_evt , "filesystem-change-evt" , 1 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("filesystem-change-evt" , __funcarg123 , env ) )) ; 
  (__funcarg122 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (filesystem_change_evt_p , "filesystem-change-evt?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("filesystem-change-evt?" , __funcarg122 , env ) )) ; 
  (__funcarg121 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (filesystem_change_evt_cancel , "filesystem-change-evt-cancel" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("filesystem-change-evt-cancel" , __funcarg121 , env ) )) ; 
  (__funcarg120 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (read_char , "read-char" , 0 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-char" , __funcarg120 , env ) )) ; 
  (__funcarg119 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (read_char_spec , 1 , "read-char-or-special" , 0 , 3 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-char-or-special" , __funcarg119 , env ) )) ; 
  (__funcarg118 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (read_byte , "read-byte" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-byte" , __funcarg118 , env ) )) ; 
  (__funcarg117 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (read_byte_spec , 1 , "read-byte-or-special" , 0 , 3 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-byte-or-special" , __funcarg117 , env ) )) ; 
  (__funcarg116 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (read_byte_line , "read-bytes-line" , 0 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-bytes-line" , __funcarg116 , env ) )) ; 
  (__funcarg115 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (read_line , "read-line" , 0 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-line" , __funcarg115 , env ) )) ; 
  (__funcarg114 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (sch_read_string , "read-string" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-string" , __funcarg114 , env ) )) ; 
  (__funcarg113 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (sch_read_string_bang , "read-string!" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-string!" , __funcarg113 , env ) )) ; 
  (__funcarg112 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (sch_peek_string , "peek-string" , 2 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-string" , __funcarg112 , env ) )) ; 
  (__funcarg111 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (sch_peek_string_bang , "peek-string!" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-string!" , __funcarg111 , env ) )) ; 
  (__funcarg110 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (sch_read_bytes , "read-bytes" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-bytes" , __funcarg110 , env ) )) ; 
  (__funcarg109 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (sch_read_bytes_bang , "read-bytes!" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-bytes!" , __funcarg109 , env ) )) ; 
  (__funcarg108 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (sch_peek_bytes , "peek-bytes" , 2 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-bytes" , __funcarg108 , env ) )) ; 
  (__funcarg107 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (sch_peek_bytes_bang , "peek-bytes!" , 2 , 5 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-bytes!" , __funcarg107 , env ) )) ; 
  (__funcarg106 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (read_bytes_bang , "read-bytes-avail!" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-bytes-avail!" , __funcarg106 , env ) )) ; 
  (__funcarg105 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (read_bytes_bang_nonblock , "read-bytes-avail!*" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-bytes-avail!*" , __funcarg105 , env ) )) ; 
  (__funcarg104 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (read_bytes_bang_break , "read-bytes-avail!/enable-break" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-bytes-avail!/enable-break" , __funcarg104 , env ) )) ; 
  (__funcarg103 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (peek_bytes_bang , "peek-bytes-avail!" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-bytes-avail!" , __funcarg103 , env ) )) ; 
  (__funcarg102 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (peek_bytes_bang_nonblock , "peek-bytes-avail!*" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-bytes-avail!*" , __funcarg102 , env ) )) ; 
  (__funcarg101 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (peek_bytes_bang_break , "peek-bytes-avail!/enable-break" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-bytes-avail!/enable-break" , __funcarg101 , env ) )) ; 
  (__funcarg100 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (can_provide_progress_evt , "port-provides-progress-evts?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-provides-progress-evts?" , __funcarg100 , env ) )) ; 
  (__funcarg99 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_bytes , "write-bytes" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-bytes" , __funcarg99 , env ) )) ; 
  (__funcarg98 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_string , "write-string" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-string" , __funcarg98 , env ) )) ; 
  (__funcarg97 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_bytes_avail , "write-bytes-avail" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-bytes-avail" , __funcarg97 , env ) )) ; 
  (__funcarg96 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_bytes_avail_nonblock , "write-bytes-avail*" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-bytes-avail*" , __funcarg96 , env ) )) ; 
  (__funcarg95 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_bytes_avail_break , "write-bytes-avail/enable-break" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-bytes-avail/enable-break" , __funcarg95 , env ) )) ; 
  (__funcarg94 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (can_write_atomic , "port-writes-atomic?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-writes-atomic?" , __funcarg94 , env ) )) ; 
  (__funcarg93 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (can_write_special , "port-writes-special?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-writes-special?" , __funcarg93 , env ) )) ; 
  (__funcarg92 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_write_special , "write-special" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-special" , __funcarg92 , env ) )) ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_write_special_nonblock , "write-special-avail*" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-special-avail*" , __funcarg91 , env ) )) ; 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (peek_char , "peek-char" , 0 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-char" , __funcarg90 , env ) )) ; 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (peek_char_spec , 1 , "peek-char-or-special" , 0 , 4 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-char-or-special" , __funcarg89 , env ) )) ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (peek_byte , "peek-byte" , 0 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-byte" , __funcarg88 , env ) )) ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_everything (peek_byte_spec , 1 , "peek-byte-or-special" , 0 , 5 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("peek-byte-or-special" , __funcarg87 , env ) )) ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (byte_ready_p , "byte-ready?" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("byte-ready?" , __funcarg86 , env ) )) ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (char_ready_p , "char-ready?" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("char-ready?" , __funcarg85 , env ) )) ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (newline , "newline" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("newline" , __funcarg84 , env ) )) ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_char , "write-char" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-char" , __funcarg83 , env ) )) ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_byte , "write-byte" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-byte" , __funcarg82 , env ) )) ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (peeked_read , "port-commit-peeked" , 3 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-commit-peeked" , __funcarg81 , env ) )) ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (progress_evt , "port-progress-evt" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-progress-evt" , __funcarg80 , env ) )) ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (is_progress_evt , "progress-evt?" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("progress-evt?" , __funcarg79 , env ) )) ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (closed_evt , "port-closed-evt" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-closed-evt" , __funcarg78 , env ) )) ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_bytes_avail_evt , "write-bytes-avail-evt" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-bytes-avail-evt" , __funcarg77 , env ) )) ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (write_special_evt , "write-special-evt" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("write-special-evt" , __funcarg76 , env ) )) ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (port_read_handler , "port-read-handler" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-read-handler" , __funcarg75 , env ) )) ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (port_display_handler , "port-display-handler" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-display-handler" , __funcarg74 , env ) )) ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (port_write_handler , "port-write-handler" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-write-handler" , __funcarg73 , env ) )) ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (port_print_handler , "port-print-handler" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-print-handler" , __funcarg72 , env ) )) ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (flush_output , "flush-output" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("flush-output" , __funcarg71 , env ) )) ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_file_position , "file-position" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-position" , __funcarg70 , env ) )) ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_file_position_star , "file-position*" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-position*" , __funcarg69 , env ) )) ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_file_truncate , "file-truncate" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-truncate" , __funcarg68 , env ) )) ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_file_buffer , "file-stream-buffer-mode" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("file-stream-buffer-mode" , __funcarg67 , env ) )) ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_file_try_lock , "port-try-file-lock?" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-try-file-lock?" , __funcarg66 , env ) )) ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_file_unlock , "port-file-unlock" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-file-unlock" , __funcarg65 , env ) )) ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (scheme_file_identity , "port-file-identity" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-file-identity" , __funcarg64 , env ) )) ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (port_count_lines , "port-count-lines!" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-count-lines!" , __funcarg63 , env ) )) ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_noncm_prim (port_counts_lines_p , "port-counts-lines?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("port-counts-lines?" , __funcarg62 , env ) )) ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_eof_object_p_proc , sizeof (scheme_eof_object_p_proc ) ) )
  ; 
  scheme_eof_object_p_proc = FUNCCALL_AGAIN(scheme_make_folding_prim (eof_object_p , "eof-object?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) scheme_eof_object_p_proc ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 4 ) 
  | (1 << 25 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM3(_), scheme_addto_prim_instance ("eof-object?" , scheme_eof_object_p_proc , env ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("write" , scheme_write_proc , env ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("display" , scheme_display_proc , env ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("print" , scheme_print_proc , env ) ); 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_immed_prim (pipe_length , "pipe-content-length" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("pipe-content-length" , __funcarg61 , env ) )) ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_default_global_print_handler , sizeof (scheme_default_global_print_handler ) ) )
  ; 
  scheme_default_global_print_handler 
  = FUNCCALL_AGAIN(scheme_make_prim_w_arity (sch_default_global_port_print_handler , "default-global-port-print-handler" , 2 , 3 ) ); 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (sha1_bytes , "sha1-bytes" , 1 , 3 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("sha1-bytes" , __funcarg60 , env ) )) ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (sha224_bytes , "sha224-bytes" , 1 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("sha224-bytes" , __funcarg59 , env ) )) ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM3(_), scheme_make_prim_w_arity (sha256_bytes , "sha256-bytes" , 1 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("sha256-bytes" , __funcarg58 , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 335 "bc/src/portfun.c"
void scheme_init_param_symbol () 
{
  /* No conversion */

# 337 "bc/src/portfun.c"
  scheme_register_static ((void * ) & initial_compiled_file_check_symbol , sizeof (initial_compiled_file_check_symbol ) ) ; 
  if (compiled_file_check == 0 )
    initial_compiled_file_check_symbol = scheme_intern_symbol ("modify-seconds" ) ; 
  else 
  initial_compiled_file_check_symbol = scheme_intern_symbol ("exists" ) ; 
}

void scheme_init_port_fun_config (void ) 
{
  /* No conversion */

# 346 "bc/src/portfun.c"
  scheme_set_root_param (MZCONFIG_LOAD_DIRECTORY , scheme_false ) ; 
  scheme_set_root_param (MZCONFIG_WRITE_DIRECTORY , scheme_false ) ; 

  scheme_set_root_param (MZCONFIG_PORT_PRINT_HANDLER , scheme_default_global_print_handler ) ; 


  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dummy_input_port_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dummy_input_port_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dummy_output_port_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dummy_output_port_ ) ) ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dummy_input_port_ ) = scheme_make_byte_string_input_port ("" ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dummy_output_port_ ) = scheme_make_null_output_port (1 ) ; 
}

static void set_param (const char * name , Scheme_Object * val ) 
{
  Scheme_Object * param , * a [1 ] ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(param, 0), PUSHARRAY(a, 1, 1), PUSH(val, 4)));
# define XfOrM6_COUNT (5)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  param = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 361 "bc/src/portfun.c"
  param = FUNCCALL(SETUP_XfOrM6(_), scheme_get_startup_export (name ) ); 
  a [0 ] = val ; 
  (void ) FUNCCALL(SETUP_XfOrM6(_), scheme_do_eval (param , 1 , a , - 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 366 "bc/src/portfun.c"
static Scheme_Object * get_param (const char * name ) 
{
  Scheme_Object * param ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(param, 0)));
# define XfOrM7_COUNT (1)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  param = NULLED_OUT ; 

# 369 "bc/src/portfun.c"
  param = FUNCCALL(SETUP_XfOrM7(_), scheme_get_startup_export (name ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (param , 0 , ((void * ) 0 ) , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 373 "bc/src/portfun.c"
void scheme_init_resolver_config (void ) 
{
  Scheme_Object * __funcarg162 = NULLED_OUT ; 
  Scheme_Object * __funcarg161 = NULLED_OUT ; 
  Scheme_Object * __funcarg160 = NULLED_OUT ; 
  Scheme_Object * __funcarg159 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(0);
# define XfOrM8_COUNT (0)
# define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL_EMPTY(set_param ("use-compiled-file-check" , initial_compiled_file_check_symbol ) )
# 375 "bc/src/portfun.c"
  ; 
  if (initial_compiled_file_paths )
    FUNCCALL_EMPTY(set_param ("use-compiled-file-paths" , initial_compiled_file_paths ) ); 
  else (__funcarg161 = (__funcarg162 = FUNCCALL_EMPTY(scheme_make_path ("compiled" ) )
  , FUNCCALL_EMPTY(scheme_make_pair (__funcarg162 , scheme_null ) )) , FUNCCALL_EMPTY(set_param ("use-compiled-file-paths" , __funcarg161 ) )) ; 
  if (initial_compiled_file_roots )
    FUNCCALL_EMPTY(set_param ("current-compiled-file-roots" , initial_compiled_file_roots ) ); 
  else (__funcarg159 = (__funcarg160 = FUNCCALL_EMPTY(scheme_intern_symbol ("same" ) )
  , FUNCCALL_EMPTY(scheme_make_pair (__funcarg160 , scheme_null ) )) , FUNCCALL_EMPTY(set_param ("current-compiled-file-roots" , __funcarg159 ) )) ; 
  FUNCCALL_EMPTY(set_param ("use-user-specific-search-paths" , (scheme_ignore_user_paths ? scheme_false : scheme_true ) ) ); 
  FUNCCALL_EMPTY(set_param ("use-collection-link-paths" , (scheme_ignore_link_paths ? scheme_false : scheme_true ) ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 388 "bc/src/portfun.c"
Scheme_Object * scheme_current_library_collection_paths (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 390 "bc/src/portfun.c"
  if (argc ) {
    set_param ("current-library-collection-paths" , argv [0 ] ) ; 
    return scheme_void ; 
  }

# 393 "bc/src/portfun.c"
  else 
  return get_param ("current-library-collection-paths" ) ; 
}

Scheme_Object * scheme_current_library_collection_links (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 399 "bc/src/portfun.c"
  if (argc ) {
    set_param ("current-library-collection-links" , argv [0 ] ) ; 
    return scheme_void ; 
  }

# 402 "bc/src/portfun.c"
  else 
  return get_param ("current-library-collection-links" ) ; 
}

Scheme_Object * scheme_compiled_file_roots (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 408 "bc/src/portfun.c"
  if (argc ) {
    set_param ("current-compiled-file-roots" , argv [0 ] ) ; 
    return scheme_void ; 
  }

# 411 "bc/src/portfun.c"
  else 
  return get_param ("current-compiled-file-roots" ) ; 
}

void scheme_set_compiled_file_paths (Scheme_Object * list ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(list, 0)));
# define XfOrM15_COUNT (1)
# define SETUP_XfOrM15(x) SETUP(XfOrM15_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 417 "bc/src/portfun.c"
  if (! initial_compiled_file_paths )
    FUNCCALL(SETUP_XfOrM15(_), scheme_register_static ((void * ) & initial_compiled_file_paths , sizeof (initial_compiled_file_paths ) ) ); 
  initial_compiled_file_paths = list ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 422 "bc/src/portfun.c"
void scheme_set_compiled_file_roots (Scheme_Object * list ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(list, 0)));
# define XfOrM16_COUNT (1)
# define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 424 "bc/src/portfun.c"
  if (! initial_compiled_file_roots )
    FUNCCALL(SETUP_XfOrM16(_), scheme_register_static ((void * ) & initial_compiled_file_roots , sizeof (initial_compiled_file_roots ) ) ); 
  initial_compiled_file_roots = list ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 429 "bc/src/portfun.c"
void scheme_set_compiled_file_check (int c ) 
{
  /* No conversion */

# 431 "bc/src/portfun.c"
  compiled_file_check = c ; 
}





Scheme_Port * scheme_port_record (Scheme_Object * port ) 
{
  DECL_RET_SAVE (Scheme_Port * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM18_COUNT (1)
# define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 440 "bc/src/portfun.c"
  if (scheme_is_input_port (port ) ) 
    RET_VALUE_START ((Scheme_Port * ) FUNCCALL(SETUP_XfOrM18(_), scheme_input_port_record (port ) )) RET_VALUE_END ; 
  else 
  RET_VALUE_START ((Scheme_Port * ) FUNCCALL_EMPTY(scheme_output_port_record (port ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 446 "bc/src/portfun.c"
static inline Scheme_Input_Port * input_port_record_slow (Scheme_Object * port ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Input_Port * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(port, 1)));
# define XfOrM19_COUNT (2)
# define SETUP_XfOrM19(x) SETUP(XfOrM19_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 450 "bc/src/portfun.c"
  while (1 ) {
#   define XfOrM24_COUNT (0+XfOrM19_COUNT)
#   define SETUP_XfOrM24(x) SETUP_XfOrM19(x)

# 451 "bc/src/portfun.c"
    if ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) ) 
      RET_VALUE_START ((Scheme_Input_Port * ) port ) RET_VALUE_END ; 

    if (! ((((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) ) {
      RET_VALUE_START ((Scheme_Input_Port * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dummy_input_port_ ) ) RET_VALUE_END ; 
    }

    v = (scheme_struct_type_property_ref (scheme_input_port_property , port ) ) ; 
    if (! v )
      v = scheme_false ; 
    else if (((intptr_t ) (v ) ) & 0x1 ) 
      v = FUNCCALL(SETUP_XfOrM24(_), scheme_struct_ref (port , (((intptr_t ) (v ) ) >> 1 ) ) ); 
    port = v ; 

    {
#     define XfOrM25_COUNT (0+XfOrM24_COUNT)
#     define SETUP_XfOrM25(x) SETUP_XfOrM24(x)

# 465 "bc/src/portfun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM26_COUNT (0+XfOrM25_COUNT)
#       define SETUP_XfOrM26(x) SETUP_XfOrM25(x)
        FUNCCALL(SETUP_XfOrM26(_), scheme_out_of_fuel () )
# 465 "bc/src/portfun.c"
        ; 
      }
    }

# 465 "bc/src/portfun.c"
    ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 469 "bc/src/portfun.c"
Scheme_Input_Port * scheme_input_port_record (Scheme_Object * port ) 
XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */
  if ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) ) 
    return (Scheme_Input_Port * ) port ; 
  else 
  return input_port_record_slow (port ) ; 
}

static inline Scheme_Output_Port * output_port_record_slow (Scheme_Object * port ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Output_Port * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(port, 1)));
# define XfOrM29_COUNT (2)
# define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 483 "bc/src/portfun.c"
  while (1 ) {
#   define XfOrM34_COUNT (0+XfOrM29_COUNT)
#   define SETUP_XfOrM34(x) SETUP_XfOrM29(x)

# 484 "bc/src/portfun.c"
    if ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) ) 
      RET_VALUE_START ((Scheme_Output_Port * ) port ) RET_VALUE_END ; 

    if (! ((((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) ) {
      RET_VALUE_START ((Scheme_Output_Port * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dummy_output_port_ ) ) RET_VALUE_END ; 
    }

    v = (scheme_struct_type_property_ref (scheme_output_port_property , port ) ) ; 
    if (! v )
      v = scheme_false ; 
    else if (((intptr_t ) (v ) ) & 0x1 ) 
      v = FUNCCALL(SETUP_XfOrM34(_), scheme_struct_ref (port , (((intptr_t ) (v ) ) >> 1 ) ) ); 
    port = v ; 

    {
#     define XfOrM35_COUNT (0+XfOrM34_COUNT)
#     define SETUP_XfOrM35(x) SETUP_XfOrM34(x)

# 498 "bc/src/portfun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM36_COUNT (0+XfOrM35_COUNT)
#       define SETUP_XfOrM36(x) SETUP_XfOrM35(x)
        FUNCCALL(SETUP_XfOrM36(_), scheme_out_of_fuel () )
# 498 "bc/src/portfun.c"
        ; 
      }
    }

# 498 "bc/src/portfun.c"
    ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 502 "bc/src/portfun.c"
Scheme_Output_Port * scheme_output_port_record (Scheme_Object * port ) 
XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */
  if ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) ) 
    return (Scheme_Output_Port * ) port ; 
  else 
  return output_port_record_slow (port ) ; 
}

int scheme_is_input_port (Scheme_Object * port ) 
{
  /* No conversion */

# 514 "bc/src/portfun.c"
  if ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) ) 
    return 1 ; 

  if ((((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    if (scheme_struct_type_property_ref (scheme_input_port_property , port ) )
    return 1 ; 

  return 0 ; 
}

int scheme_is_output_port (Scheme_Object * port ) 
{
  /* No conversion */

# 526 "bc/src/portfun.c"
  if ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) ) 
    return 1 ; 

  if ((((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (port ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) port ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    if (scheme_struct_type_property_ref (scheme_output_port_property , port ) )
    return 1 ; 

  return 0 ; 
}





static intptr_t 
string_get_or_peek_bytes (Scheme_Input_Port * port , 
char * buffer , intptr_t offset , intptr_t size , 
int peek , intptr_t skip , 
Scheme_Object * unless ) 
{
  /* No conversion */

# 546 "bc/src/portfun.c"
  Scheme_Indexed_String * is ; 

  if (unless && scheme_unless_ready (unless ) )
    return (- 3 ) ; 

  is = (Scheme_Indexed_String * ) port -> port_data ; 
  if (is -> index + skip >= is -> size )
    return (- 1 ) ; 
  else if (size == 1 ) {
    int pos = is -> index ; 
    if (buffer )
      buffer [offset ] = is -> string [pos + skip ] ; 
    if (! peek )
      is -> index = pos + 1 ; 
    return 1 ; 
  }

# 561 "bc/src/portfun.c"
  else {
    intptr_t l , delta ; 

    delta = is -> index + skip ; 

    if (delta + size <= is -> size )
      l = size ; 
    else 
    l = (is -> size - delta ) ; 

    if (buffer )
      memcpy (buffer + offset , is -> string + delta , l ) ; 
    if (! peek )
      is -> index += l ; 

    return l ; 
  }
}

static intptr_t 
string_get_bytes (Scheme_Input_Port * port , 
char * buffer , intptr_t offset , intptr_t size , 
int nonblock , Scheme_Object * unless ) 
{
  /* No conversion */

# 585 "bc/src/portfun.c"
  return string_get_or_peek_bytes (port , buffer , offset , size , 0 , 0 , unless ) ; 
}

static intptr_t 
string_peek_bytes (Scheme_Input_Port * port , 
char * buffer , intptr_t offset , intptr_t size , 
Scheme_Object * sskip , 
int nonblock , Scheme_Object * unless ) 
{
  /* No conversion */

# 594 "bc/src/portfun.c"
  intptr_t skip ; 

  if (((intptr_t ) (sskip ) ) & 0x1 ) 
    skip = (((intptr_t ) (sskip ) ) >> 1 ) ; 
  else 
  skip = ((Scheme_Indexed_String * ) port -> port_data ) -> size ; 

  return string_get_or_peek_bytes (port , buffer , offset , size , 1 , skip , unless ) ; 
}

static int 
string_byte_ready (Scheme_Input_Port * port ) 
{
  /* No conversion */

# 607 "bc/src/portfun.c"
  return 1 ; 
}

static void 
string_close_in (Scheme_Input_Port * port ) 
{
  /* No conversion */
}
static Scheme_Indexed_String * 
make_indexed_string (const char * str , intptr_t len ) 
{
  Scheme_Indexed_String * is ; 
  DECL_RET_SAVE (Scheme_Indexed_String * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(is, 1)));
# define XfOrM48_COUNT (2)
# define SETUP_XfOrM48(x) SETUP(XfOrM48_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  is = NULLED_OUT ; 

# 620 "bc/src/portfun.c"
  is = ((Scheme_Indexed_String * ) FUNCCALL(SETUP_XfOrM48(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Indexed_String ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  is -> type = scheme_rt_indexed_string ; 


  if (str ) {
#   define XfOrM50_COUNT (0+XfOrM48_COUNT)
#   define SETUP_XfOrM50(x) SETUP_XfOrM48(x)

# 626 "bc/src/portfun.c"
    if (len < 0 ) {
      is -> string = (char * ) str ; 
      is -> size = - len ; 
    }

# 629 "bc/src/portfun.c"
    else {
      char * ca ; 
      BLOCK_SETUP((PUSH(ca, 0+XfOrM50_COUNT)));
#     define XfOrM51_COUNT (1+XfOrM50_COUNT)
#     define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
      ca = NULLED_OUT ; 

# 631 "bc/src/portfun.c"
      ca = (char * ) FUNCCALL(SETUP_XfOrM51(_), GC_malloc_atomic (len ) ); 
      is -> string = ca ; 
      (memcpy (is -> string , str , len ) ) ; 
      is -> size = len ; 
    }
  }

# 636 "bc/src/portfun.c"
  else {
    char * ca ; 
    BLOCK_SETUP((PUSH(ca, 0+XfOrM48_COUNT)));
#   define XfOrM49_COUNT (1+XfOrM48_COUNT)
#   define SETUP_XfOrM49(x) SETUP(XfOrM49_COUNT)
    ca = NULLED_OUT ; 

# 638 "bc/src/portfun.c"
    is -> size = 100 ; 
    ca = (char * ) FUNCCALL(SETUP_XfOrM49(_), GC_malloc_atomic (is -> size + 1 ) ); 
    is -> string = ca ; 
  }
  is -> index = 0 ; 
  RET_VALUE_START ((is ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 646 "bc/src/portfun.c"
Scheme_Object * 
scheme_make_sized_byte_string_input_port (const char * str , intptr_t len ) 
{
  Scheme_Input_Port * ip ; 

# 615 "bc/src/portfun.c"
  Scheme_Indexed_String * __funcarg163 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ip, 0)));
# define XfOrM53_COUNT (1)
# define SETUP_XfOrM53(x) SETUP(XfOrM53_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ip = NULLED_OUT ; 

# 651 "bc/src/portfun.c"
  ip = (__funcarg163 = FUNCCALL(SETUP_XfOrM53(_), make_indexed_string (str , len ) )
  , FUNCCALL_AGAIN(scheme_make_input_port (scheme_string_input_port_type , __funcarg163 , string_symbol , string_get_bytes , string_peek_bytes , scheme_progress_evt_via_get , scheme_peeked_read_via_get , string_byte_ready , string_close_in , ((void * ) 0 ) , 0 ) )) 








  ; 

  RET_VALUE_START ((Scheme_Object * ) ip ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 666 "bc/src/portfun.c"
Scheme_Object * 
scheme_make_byte_string_input_port (const char * str ) 
{
  /* No conversion */

# 669 "bc/src/portfun.c"
  return scheme_make_sized_byte_string_input_port (str , strlen (str ) ) ; 
}





static intptr_t 
string_write_bytes (Scheme_Output_Port * port , 
const char * str , intptr_t d , intptr_t len , 
int rarely_block , int enable_break ) 
{
  Scheme_Indexed_String * is ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(is, 1)));
# define XfOrM55_COUNT (2)
# define SETUP_XfOrM55(x) SETUP(XfOrM55_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  is = NULLED_OUT ; 

# 683 "bc/src/portfun.c"
  is = (Scheme_Indexed_String * ) port -> port_data ; 

  if (is -> index + len >= is -> size ) {
    char * old ; 
    BLOCK_SETUP((PUSH(old, 0+XfOrM55_COUNT)));
#   define XfOrM56_COUNT (1+XfOrM55_COUNT)
#   define SETUP_XfOrM56(x) SETUP(XfOrM56_COUNT)
    old = NULLED_OUT ; 

# 688 "bc/src/portfun.c"
    old = is -> string ; 

    if (len > is -> size )
      is -> size += 2 * len ; 
    else 
    is -> size *= 2 ; 

    {
      char * ca ; 
      BLOCK_SETUP((PUSH(ca, 0+XfOrM56_COUNT)));
#     define XfOrM57_COUNT (1+XfOrM56_COUNT)
#     define SETUP_XfOrM57(x) SETUP(XfOrM57_COUNT)
      ca = NULLED_OUT ; 

# 697 "bc/src/portfun.c"
      ca = (char * ) FUNCCALL(SETUP_XfOrM57(_), GC_malloc_atomic (is -> size + 1 ) ); 
      is -> string = ca ; 
    }
    (memcpy (is -> string , old , is -> index ) ) ; 
  }

  if (len )
    (memcpy (is -> string + is -> index , str + d , len ) ) ; 
  is -> index += len ; 

  RET_VALUE_START (len ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 710 "bc/src/portfun.c"
static void 
string_close_out (Scheme_Output_Port * port ) 
{
  /* No conversion */

# 713 "bc/src/portfun.c"
  return ; 
}

Scheme_Object * 
scheme_make_byte_string_output_port (void ) 
{
  Scheme_Output_Port * op ; 
  Scheme_Object * __funcarg165 = NULLED_OUT ; 

# 615 "bc/src/portfun.c"
  Scheme_Indexed_String * __funcarg164 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(__funcarg164, 0), PUSH(op, 1)));
# define XfOrM59_COUNT (2)
# define SETUP_XfOrM59(x) SETUP(XfOrM59_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 

# 721 "bc/src/portfun.c"
  op = (__funcarg164 = FUNCCALL(SETUP_XfOrM59(_), make_indexed_string (((void * ) 0 ) , 0 ) )
  , __funcarg165 = FUNCCALL(SETUP_XfOrM59(_), scheme_intern_symbol ("string" ) )
  , FUNCCALL_AGAIN(scheme_make_output_port (scheme_string_output_port_type , __funcarg164 , __funcarg165 , scheme_write_evt_via_write , string_write_bytes , ((void * ) 0 ) , string_close_out , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) )) 







  ; 

  RET_VALUE_START ((Scheme_Object * ) op ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 736 "bc/src/portfun.c"
char * 
scheme_get_reset_sized_byte_string_output (Scheme_Object * port , intptr_t * size , int reset , intptr_t startpos , intptr_t endpos ) 
{
  Scheme_Output_Port * op ; 
  Scheme_Indexed_String * is ; 
  char * v ; 
  intptr_t len ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(is, 1), PUSH(size, 2), PUSH(op, 3)));
# define XfOrM60_COUNT (4)
# define SETUP_XfOrM60(x) SETUP(XfOrM60_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  op = NULLED_OUT ; 
  is = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 744 "bc/src/portfun.c"
  if (! (scheme_is_output_port (port ) ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  op = FUNCCALL(SETUP_XfOrM60(_), scheme_output_port_record (port ) ); 
  if (op -> sub_type != scheme_string_output_port_type )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  is = (Scheme_Indexed_String * ) op -> port_data ; 

  len = is -> index ; 
  if (is -> u . hot > len )
    len = is -> u . hot ; 

  if (endpos < 0 )
    endpos = len ; 

  if (reset ) {
    char * ca ; 
    BLOCK_SETUP((PUSH(ca, 0+XfOrM60_COUNT)));
#   define XfOrM62_COUNT (1+XfOrM60_COUNT)
#   define SETUP_XfOrM62(x) SETUP(XfOrM62_COUNT)
    ca = NULLED_OUT ; 

# 762 "bc/src/portfun.c"
    v = is -> string ; 
    is -> size = 31 ; 
    ca = (char * ) FUNCCALL(SETUP_XfOrM62(_), GC_malloc_atomic ((is -> size ) + 1 ) ); 
    is -> string = ca ; 
    is -> index = 0 ; 
    is -> u . hot = 0 ; 
    if ((startpos > 0 ) || (endpos < len ) ) {
#     define XfOrM63_COUNT (0+XfOrM62_COUNT)
#     define SETUP_XfOrM63(x) SETUP_XfOrM62(x)

# 769 "bc/src/portfun.c"
      len = endpos - startpos ; 
      ca = (char * ) FUNCCALL(SETUP_XfOrM63(_), GC_malloc_atomic (len + 1 ) ); 
      (memcpy (ca , v XFORM_OK_PLUS startpos , len ) ) ; 
      v = ca ; 
    }
  }

# 774 "bc/src/portfun.c"
  else {
#   define XfOrM61_COUNT (0+XfOrM60_COUNT)
#   define SETUP_XfOrM61(x) SETUP_XfOrM60(x)

# 775 "bc/src/portfun.c"
    len = endpos - startpos ; 
    v = (char * ) FUNCCALL(SETUP_XfOrM61(_), GC_malloc_atomic (len + 1 ) ); 
    (memcpy (v , is -> string XFORM_OK_PLUS startpos , len ) ) ; 
  }
  v [len ] = 0 ; 

  if (size )
    * size = len ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 787 "bc/src/portfun.c"
char * 
scheme_get_sized_byte_string_output (Scheme_Object * port , intptr_t * size ) 
{
  /* No conversion */

# 790 "bc/src/portfun.c"
  return scheme_get_reset_sized_byte_string_output (port , size , 0 , 0 , - 1 ) ; 
}

char * 
scheme_get_string_output (Scheme_Object * port ) 
{
  /* No conversion */

# 796 "bc/src/portfun.c"
  return scheme_get_sized_byte_string_output (port , ((void * ) 0 ) ) ; 
}





typedef struct User_Input_Port {
  Scheme_Type type ; 
  Scheme_Object * evt ; 
  Scheme_Object * read_proc ; 
  Scheme_Object * peek_proc ; 
  Scheme_Object * close_proc ; 
  Scheme_Object * progress_evt_proc ; 
  Scheme_Object * peeked_read_proc ; 
  Scheme_Object * location_proc ; 
  Scheme_Object * count_lines_proc ; 
  Scheme_Object * buffer_mode_proc ; 
  Scheme_Object * reuse_str ; 
  Scheme_Object * peeked ; 
  Scheme_Object * prefix_pipe ; 
}

# 817 "bc/src/portfun.c"
User_Input_Port ; 

# 828 "bc/src/portfun.c"
static intptr_t user_read_result (const char * who , Scheme_Input_Port * port , 
Scheme_Object * val , Scheme_Object * bstr , 
int peek , int nonblock , int evt_ok , 
int special_ok , int false_ok , 
Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(bstr, 0), PUSHARRAY(a, 2, 1), PUSH(val, 4), PUSH(port, 5), PUSH(who, 6), PUSH(sinfo, 7)));
# define XfOrM66_COUNT (8)
# define SETUP_XfOrM66(x) SETUP(XfOrM66_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 836 "bc/src/portfun.c"
  val_again : 

  if (((val ) ) == (scheme_eof ) ) 
    RET_VALUE_START ((- 1 ) ) RET_VALUE_END ; 
  else {
    int n ; 
#   define XfOrM67_COUNT (0+XfOrM66_COUNT)
#   define SETUP_XfOrM67(x) SETUP_XfOrM66(x)

# 843 "bc/src/portfun.c"
    if (! (((intptr_t ) (val ) ) & 0x1 ) || ((((intptr_t ) (val ) ) >> 1 ) < 0 ) ) {
#     define XfOrM69_COUNT (0+XfOrM67_COUNT)
#     define SETUP_XfOrM69(x) SETUP_XfOrM67(x)

# 844 "bc/src/portfun.c"
      a [0 ] = val ; 
      if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) val ) -> iso ) -> so . keyex & 0x1 ) ) {
        n = - 1 ; 
      }

# 847 "bc/src/portfun.c"
      else if (peek && (((val ) ) == (scheme_false ) ) ) {
#       define XfOrM81_COUNT (0+XfOrM69_COUNT)
#       define SETUP_XfOrM81(x) SETUP_XfOrM69(x)

# 848 "bc/src/portfun.c"
        if (false_ok )
          RET_VALUE_START ((- 3 ) ) RET_VALUE_END ; 
        FUNCCALL(SETUP_XfOrM81(_), scheme_contract_error (who , "returned #f when no progress evt was supplied" , ((void * ) 0 ) ) )

        ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 854 "bc/src/portfun.c"
      else if ((! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
      && FUNCCALL(SETUP_XfOrM69(_), scheme_check_proc_arity (((void * ) 0 ) , 4 , 0 , 1 , a ) )) {
#       define XfOrM79_COUNT (0+XfOrM69_COUNT)
#       define SETUP_XfOrM79(x) SETUP_XfOrM69(x)

# 856 "bc/src/portfun.c"
        if (! special_ok ) {
#         define XfOrM80_COUNT (0+XfOrM79_COUNT)
#         define SETUP_XfOrM80(x) SETUP_XfOrM79(x)
          FUNCCALL(SETUP_XfOrM80(_), scheme_contract_error (who , "the port has no specific peek procedure, so" " a special read result is not allowed" , "special result" , 1 , val , ((void * ) 0 ) ) )

          ; 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
        port -> special = val ; 
        RET_VALUE_START ((- 2 ) ) RET_VALUE_END ; 
      }

# 866 "bc/src/portfun.c"
      else if (evt_ok && FUNCCALL(SETUP_XfOrM69(_), pipe_input_p (val ) )) {
        ((User_Input_Port * ) port -> port_data ) -> prefix_pipe = val ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 869 "bc/src/portfun.c"
      else if (evt_ok && FUNCCALL(SETUP_XfOrM69(_), scheme_is_evt (val ) )) {
#       define XfOrM72_COUNT (0+XfOrM69_COUNT)
#       define SETUP_XfOrM72(x) SETUP_XfOrM69(x)
        if (nonblock > 0 ) {
#         define XfOrM75_COUNT (0+XfOrM72_COUNT)
#         define SETUP_XfOrM75(x) SETUP_XfOrM72(x)

# 873 "bc/src/portfun.c"
          if (sinfo ) {
#           define XfOrM77_COUNT (0+XfOrM75_COUNT)
#           define SETUP_XfOrM77(x) SETUP_XfOrM75(x)
            FUNCCALL(SETUP_XfOrM77(_), scheme_set_sync_target (sinfo , val , (Scheme_Object * ) port , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 874 "bc/src/portfun.c"
            ; 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 876 "bc/src/portfun.c"
          else {
#           define XfOrM76_COUNT (0+XfOrM75_COUNT)
#           define SETUP_XfOrM76(x) SETUP_XfOrM75(x)

# 878 "bc/src/portfun.c"
            a [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
            a [1 ] = val ; 
            val = FUNCCALL(SETUP_XfOrM76(_), scheme_sync_timeout (2 , a ) ); 
            if (! val )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            else if (FUNCCALL(SETUP_XfOrM76(_), scheme_is_evt (val ) ))
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            goto val_again ; 
          }
        }

# 887 "bc/src/portfun.c"
        else {
#         define XfOrM73_COUNT (0+XfOrM72_COUNT)
#         define SETUP_XfOrM73(x) SETUP_XfOrM72(x)

# 889 "bc/src/portfun.c"
          a [0 ] = val ; 
          if (nonblock < 0 )
            val = FUNCCALL(SETUP_XfOrM73(_), scheme_sync_enable_break (1 , a ) ); 
          else 
          val = FUNCCALL(SETUP_XfOrM73(_), scheme_sync (1 , a ) ); 


          if (port -> closed ) {
#           define XfOrM74_COUNT (0+XfOrM73_COUNT)
#           define SETUP_XfOrM74(x) SETUP_XfOrM73(x)
            if (peek )
              FUNCCALL(SETUP_XfOrM74(_), scheme_peek_byte ((Scheme_Object * ) port ) ); 
            else FUNCCALL(SETUP_XfOrM74(_), scheme_get_byte ((Scheme_Object * ) port ) )
            ; 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          goto val_again ; 
        }
      }

# 907 "bc/src/portfun.c"
      else {
        val = ((void * ) 0 ) ; 
        n = 0 ; 
      }

      if (! val ) {
#       define XfOrM70_COUNT (0+XfOrM69_COUNT)
#       define SETUP_XfOrM70(x) SETUP_XfOrM69(x)
        FUNCCALL(SETUP_XfOrM70(_), scheme_wrong_contract (who , (peek ? (evt_ok ? (special_ok ? "(or/c exact-nonnegative-integer? eof-object? evt? pipe-input-port? #f procedure?)" : "(or/c exact-nonnegative-integer? eof-object? evt? pipe-input-port? #f)" ) : "(or/c exact-nonnegative-integer? eof-object? procedure? #f)" ) : (evt_ok ? (special_ok ? "(or/c exact-nonnegative-integer? eof-object? evt? pipe-input-port? procedure?)" : "(or/c exact-nonnegative-integer? eof-object? evt? pipe-input-port?)" ) : "(or/c exact-nonnegative-integer? eof-object? procedure?)" ) ) , - 1 , - 1 , a ) )
# 925 "bc/src/portfun.c"
        ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }

# 928 "bc/src/portfun.c"
    else 
    n = (((intptr_t ) (val ) ) >> 1 ) ; 

    if ((n < 0 ) || (n > (((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . tag_val ) ) ) {
#     define XfOrM68_COUNT (0+XfOrM67_COUNT)
#     define SETUP_XfOrM68(x) SETUP_XfOrM67(x)
      FUNCCALL(SETUP_XfOrM68(_), scheme_contract_error (who , "result integer is larger than the supplied byte string" , "result" , 1 , val , "byte-string length" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . tag_val ) ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )

      ; 
    }

    RET_VALUE_START (n ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}



static intptr_t 
user_get_or_peek_bytes (Scheme_Input_Port * port , 
char * buffer , intptr_t offset , intptr_t size , 
int nonblock , 
int peek , Scheme_Object * peek_skip , 
Scheme_Object * unless , 
Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Object * fun , * val , * a [3 ] , * bstr ; 
  User_Input_Port * uip = (User_Input_Port * ) port -> port_data ; 
  intptr_t r ; 
  Scheme_Cont_Frame_Data cframe ; 

# 469 "bc/src/portfun.c"
  Scheme_Input_Port * __funcarg166 = NULLED_OUT ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(uip, 0), PUSHARRAY(a, 3, 1), PUSH(val, 4), PUSH(peek_skip, 5), PUSH(port, 6), PUSH(bstr, 7), PUSH(buffer, 8), PUSH(cframe.cache, 9), PUSH(sinfo, 10), PUSH(fun, 11), PUSH(unless, 12)));
# define XfOrM83_COUNT (13)
# define SETUP_XfOrM83(x) SETUP(XfOrM83_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  fun = NULLED_OUT ; 
  val = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  bstr = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 962 "bc/src/portfun.c"
  if (peek )
    fun = uip -> peek_proc ; 
  else 
  fun = uip -> read_proc ; 

  if (scheme_is_input_port (fun ) )  {
#   define XfOrM111_COUNT (0+XfOrM83_COUNT)
#   define SETUP_XfOrM111(x) SETUP_XfOrM83(x)

# 968 "bc/src/portfun.c"
    RET_VALUE_START ((__funcarg166 = FUNCCALL(SETUP_XfOrM111(_), scheme_input_port_record (fun ) )
    , FUNCCALL_AGAIN(scheme_redirect_get_or_peek_bytes (port , __funcarg166 , buffer , offset , size , nonblock , peek , peek_skip , unless , sinfo ) )) ) 
# 968 "bc/src/portfun.c"
    RET_VALUE_END 




    ; 
  }

  val = uip -> peeked ; 
  if (val ) {




    uip -> peeked = ((void * ) 0 ) ; 
    if (((intptr_t ) (val ) ) & 0x1 )  {
      buffer [offset ] = (char ) (((intptr_t ) (val ) ) >> 1 ) ; 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 986 "bc/src/portfun.c"
    else if (((val ) ) == (scheme_void ) )  {
      RET_VALUE_START ((- 2 ) ) RET_VALUE_END ; 
    }

# 988 "bc/src/portfun.c"
    else 
    RET_VALUE_START ((- 1 ) ) RET_VALUE_END ; 
  }

  if (unless && ((Scheme_Type ) (((((intptr_t ) (unless ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (unless ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
    unless = (((Scheme_Simple_Object * ) (unless ) ) -> u . pair_val . cdr ) ; 

  while (1 ) {
    int nb ; 
#   define XfOrM96_COUNT (0+XfOrM83_COUNT)
#   define SETUP_XfOrM96(x) SETUP_XfOrM83(x)

# 998 "bc/src/portfun.c"
    if (uip -> prefix_pipe ) {
#     define XfOrM105_COUNT (0+XfOrM96_COUNT)
#     define SETUP_XfOrM105(x) SETUP_XfOrM96(x)
      r = FUNCCALL(SETUP_XfOrM105(_), scheme_pipe_char_count (uip -> prefix_pipe ) ); 
      if (r && (! peek || ((((intptr_t ) (peek_skip ) ) & 0x1 ) && ((((intptr_t ) (peek_skip ) ) >> 1 ) < r ) ) ) ) {
#       define XfOrM107_COUNT (0+XfOrM105_COUNT)
#       define SETUP_XfOrM107(x) SETUP_XfOrM105(x)
        FUNCCALL(SETUP_XfOrM107(_), scheme_start_atomic () )

        ; 
        r = FUNCCALL(SETUP_XfOrM107(_), scheme_get_byte_string_unless ("custom-port-pipe-read" , uip -> prefix_pipe , buffer , offset , size , 2 , peek , peek_skip , unless ) )


        ; 
        FUNCCALL_AGAIN(scheme_end_atomic_no_swap () ); 
        RET_VALUE_START (r ) RET_VALUE_END ; 
      }

# 1014 "bc/src/portfun.c"
      else {



        uip -> prefix_pipe = ((void * ) 0 ) ; 
      }
    }

    if (uip -> reuse_str && (size == (((Scheme_Simple_Object * ) (uip -> reuse_str ) ) -> u . byte_str_val . tag_val ) ) ) {
      bstr = uip -> reuse_str ; 
      uip -> reuse_str = ((void * ) 0 ) ; 
    }

# 1025 "bc/src/portfun.c"
    else {
      char * vb ; 
      BLOCK_SETUP((PUSH(vb, 0+XfOrM96_COUNT)));
#     define XfOrM103_COUNT (1+XfOrM96_COUNT)
#     define SETUP_XfOrM103(x) SETUP(XfOrM103_COUNT)
      vb = NULLED_OUT ; 

# 1027 "bc/src/portfun.c"
      vb = FUNCCALL(SETUP_XfOrM103(_), GC_malloc_atomic (size + 1 ) ); 
      (memset (vb , 0 , size + 1 ) ) ; 
      bstr = FUNCCALL(SETUP_XfOrM103(_), scheme_make_sized_byte_string (vb , size , 0 ) ); 
    }
    a [0 ] = bstr ; 
    a [1 ] = peek_skip ; 
    a [2 ] = unless ? unless : scheme_false ; 

    nb = nonblock ; 
    if (! nb ) {
#     define XfOrM101_COUNT (0+XfOrM96_COUNT)
#     define SETUP_XfOrM101(x) SETUP_XfOrM96(x)

# 1037 "bc/src/portfun.c"
      if (FUNCCALL(SETUP_XfOrM101(_), scheme_can_break (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) )) {
        nb = - 1 ; 
      }
    }
    FUNCCALL(SETUP_XfOrM96(_), scheme_push_break_enable (& cframe , 0 , 0 ) )

    ; 


    val = FUNCCALL(SETUP_XfOrM96(_), scheme_apply (fun , peek ? 3 : 1 , a ) ); 

    if ((size <= 1024 ) 
    && ((((intptr_t ) (val ) ) & 0x1 ) || (((val ) ) == (scheme_eof ) ) || (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) ) {
      uip -> reuse_str = bstr ; 
    }

    r = FUNCCALL(SETUP_XfOrM96(_), user_read_result (peek ? "user port peek" : "user port read" , port , val , bstr , peek , nb , 1 , ! ! uip -> peek_proc , ! ! unless , sinfo ) )

    ; 
    FUNCCALL(SETUP_XfOrM96(_), scheme_pop_break_enable (& cframe , 1 ) )
    ; 

    if (r > 0 ) {
#     define XfOrM99_COUNT (0+XfOrM96_COUNT)
#     define SETUP_XfOrM99(x) SETUP_XfOrM96(x)
      (
# 1060 "bc/src/portfun.c"
      memcpy (buffer + offset , (((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . string_val ) , r ) ) ; 
      RET_VALUE_START (r ) RET_VALUE_END ; 
    }

# 1062 "bc/src/portfun.c"
    else if (r ) {
      RET_VALUE_START (r ) RET_VALUE_END ; 
    }
    FUNCCALL(SETUP_XfOrM96(_), scheme_thread_block_enable_break (0.0 , nonblock < 0 ) )
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 

    if (nonblock > 0 ) {
      if (sinfo )
        sinfo -> spin = 1 ; 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static intptr_t 
user_get_bytes (Scheme_Input_Port * port , 
char * buffer , intptr_t offset , intptr_t size , 
int nonblock , Scheme_Object * unless ) 
{
  /* No conversion */

# 1086 "bc/src/portfun.c"
  return user_get_or_peek_bytes (port , buffer , offset , size , 
  nonblock , 0 , ((void * ) 0 ) , 
  unless , 
  ((void * ) 0 ) ) ; 
}

static intptr_t 
user_peek_bytes (Scheme_Input_Port * port , 
char * buffer , intptr_t offset , intptr_t size , 
Scheme_Object * skip , 
int nonblock , Scheme_Object * unless ) 
{
  /* No conversion */

# 1098 "bc/src/portfun.c"
  return user_get_or_peek_bytes (port , buffer , offset , size , 
  nonblock , 1 , skip , 
  unless , 
  ((void * ) 0 ) ) ; 
}

static int 
user_peeked_read (Scheme_Input_Port * port , 
intptr_t size , 
Scheme_Object * unless_evt , 
Scheme_Object * target_evt ) 
{
  User_Input_Port * uip = (User_Input_Port * ) port -> port_data ; 
  Scheme_Object * val , * a [3 ] ; 
  Scheme_Cont_Frame_Data cframe ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(uip, 0), PUSHARRAY(a, 3, 1), PUSH(val, 4), PUSH(port, 5), PUSH(cframe.cache, 6)));
# define XfOrM114_COUNT (7)
# define SETUP_XfOrM114(x) SETUP(XfOrM114_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  val = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 1119 "bc/src/portfun.c"
  a [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (size ) ) ) << 1 ) | 0x1 ) ) ; 
  a [1 ] = unless_evt ; 
  a [2 ] = target_evt ; 
  FUNCCALL(SETUP_XfOrM114(_), scheme_push_break_enable (& cframe , 0 , 0 ) )

  ; 


  val = FUNCCALL_AGAIN(scheme_apply (uip -> peeked_read_proc , 3 , a ) ); 
  FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe , 1 ) )
  ; 

  if (! (((val ) ) == (scheme_false ) ) )  {
    char * buf ; 
    BLOCK_SETUP((PUSH(buf, 0+XfOrM114_COUNT)));
#   define XfOrM115_COUNT (1+XfOrM114_COUNT)
#   define SETUP_XfOrM115(x) SETUP(XfOrM115_COUNT)
    buf = NULLED_OUT ; 

# 1134 "bc/src/portfun.c"
    if ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
      size = (((Scheme_Simple_Object * ) (val ) ) -> u . byte_str_val . tag_val ) ; 
      buf = (((Scheme_Simple_Object * ) (val ) ) -> u . byte_str_val . string_val ) ; 
    }

# 1137 "bc/src/portfun.c"
    else 
    buf = ((void * ) 0 ) ; 

    if (port -> p . count_lines ) {
#     define XfOrM116_COUNT (0+XfOrM115_COUNT)
#     define SETUP_XfOrM116(x) SETUP_XfOrM115(x)

# 1141 "bc/src/portfun.c"
      if (! buf ) {
#       define XfOrM117_COUNT (0+XfOrM116_COUNT)
#       define SETUP_XfOrM117(x) SETUP_XfOrM116(x)

# 1142 "bc/src/portfun.c"
        buf = FUNCCALL(SETUP_XfOrM117(_), GC_malloc_atomic (size ) ); 
        (memset (buf , 'x' , size ) ) ; 
      }
    }
    FUNCCALL(SETUP_XfOrM115(_), scheme_port_count_lines ((Scheme_Port * ) port , buf , 0 , size ) )
    ; 
  }

  RET_VALUE_START ((! (((val ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1153 "bc/src/portfun.c"
static Scheme_Object * 
user_progress_evt (Scheme_Input_Port * port ) 
{
  User_Input_Port * uip = (User_Input_Port * ) port -> port_data ; 
  Scheme_Object * evt , * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(evt, 0), PUSHARRAY(a, 1, 1)));
# define XfOrM119_COUNT (4)
# define SETUP_XfOrM119(x) SETUP(XfOrM119_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  evt = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 1159 "bc/src/portfun.c"
  evt = FUNCCALL(SETUP_XfOrM119(_), scheme_do_eval (uip -> progress_evt_proc , 0 , ((void * ) 0 ) , 1 ) ); 

  if (! FUNCCALL(SETUP_XfOrM119(_), scheme_is_evt (evt ) )) {
#   define XfOrM120_COUNT (0+XfOrM119_COUNT)
#   define SETUP_XfOrM120(x) SETUP_XfOrM119(x)

# 1162 "bc/src/portfun.c"
    a [0 ] = evt ; 
    FUNCCALL(SETUP_XfOrM120(_), scheme_wrong_contract ("user port progress-evt" , "evt?" , - 1 , - 1 , a ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (evt ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1170 "bc/src/portfun.c"
static int 
user_byte_ready_sinfo (Scheme_Input_Port * port , Scheme_Schedule_Info * sinfo ) 
{
  int c , can_peek ; 
  char s [1 ] ; 
  User_Input_Port * uip = (User_Input_Port * ) port -> port_data ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(uip, 0)));
# define XfOrM121_COUNT (1)
# define SETUP_XfOrM121(x) SETUP(XfOrM121_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1182 "bc/src/portfun.c"
  can_peek = (uip -> peek_proc ? 1 : 0 ) ; 

  c = FUNCCALL(SETUP_XfOrM121(_), user_get_or_peek_bytes (port , s , 0 , 1 , 1 , can_peek , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) , sinfo ) )


  ; 

  if (c == (- 1 ) ) {
    if (! can_peek )
      uip -> peeked = scheme_true ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

# 1193 "bc/src/portfun.c"
  else if (c ) {
    if (! can_peek ) {
      if (c == (- 2 ) )
        uip -> peeked = scheme_void ; 
      else 
      uip -> peeked = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (s [0 ] ) ) ) << 1 ) | 0x1 ) ) ; 
    }
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

# 1201 "bc/src/portfun.c"
  else 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1205 "bc/src/portfun.c"
static int 
user_byte_ready (Scheme_Input_Port * port ) 
{
  /* No conversion */

# 1208 "bc/src/portfun.c"
  return user_byte_ready_sinfo (port , ((void * ) 0 ) ) ; 
}

int scheme_user_port_byte_probably_ready (Scheme_Input_Port * ip , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 1213 "bc/src/portfun.c"
  User_Input_Port * uip = (User_Input_Port * ) ip -> port_data ; 

  if (uip -> peeked )
    return 1 ; 

  if (sinfo -> false_positive_ok ) {

    sinfo -> potentially_false_positive = 1 ; 
    return 1 ; 
  }

# 1222 "bc/src/portfun.c"
  else {
    return user_byte_ready_sinfo (ip , sinfo ) ; 
  }
}

static void 
user_needs_wakeup_input (Scheme_Input_Port * port , void * fds ) 
{
  /* No conversion */
}

static void 
user_close_input (Scheme_Input_Port * port ) 
{
  /* No conversion */

# 1236 "bc/src/portfun.c"
  User_Input_Port * uip = (User_Input_Port * ) port -> port_data ; 

  scheme_apply_multi (uip -> close_proc , 0 , ((void * ) 0 ) ) ; 
}

static Scheme_Object * 
user_input_location (Scheme_Port * p ) 
{
  /* No conversion */

# 1244 "bc/src/portfun.c"
  Scheme_Input_Port * ip = (Scheme_Input_Port * ) p ; 
  User_Input_Port * uip = (User_Input_Port * ) ip -> port_data ; 

  return scheme_apply_multi (uip -> location_proc , 0 , ((void * ) 0 ) ) ; 
}

static void 
user_input_count_lines (Scheme_Port * p ) 
{
  /* No conversion */

# 1253 "bc/src/portfun.c"
  Scheme_Input_Port * ip = (Scheme_Input_Port * ) p ; 
  User_Input_Port * uip = (User_Input_Port * ) ip -> port_data ; 

  scheme_apply_multi (uip -> count_lines_proc , 0 , ((void * ) 0 ) ) ; 
}


static int 
user_buffer_mode (Scheme_Object * buffer_mode_proc , int mode , int line_ok ) 
{
  Scheme_Object * v , * a [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(buffer_mode_proc, 1), PUSHARRAY(a, 1, 2)));
# define XfOrM133_COUNT (5)
# define SETUP_XfOrM133(x) SETUP(XfOrM133_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 1265 "bc/src/portfun.c"
  if (mode < 0 ) {
#   define XfOrM136_COUNT (0+XfOrM133_COUNT)
#   define SETUP_XfOrM136(x) SETUP_XfOrM133(x)

# 1266 "bc/src/portfun.c"
    v = FUNCCALL(SETUP_XfOrM136(_), scheme_apply (buffer_mode_proc , 0 , ((void * ) 0 ) ) ); 
    if (! (((v ) ) == (scheme_false ) ) )  {
#     define XfOrM137_COUNT (0+XfOrM136_COUNT)
#     define SETUP_XfOrM137(x) SETUP_XfOrM136(x)

# 1268 "bc/src/portfun.c"
      if ((v ) == (scheme_block_symbol ) ) 
        mode = 0 ; 
      else if (line_ok && ((v ) == (scheme_line_symbol ) ) )
        mode = 1 ; 
      else if ((v ) == (scheme_none_symbol ) ) 
        mode = 2 ; 
      else {
#       define XfOrM138_COUNT (0+XfOrM137_COUNT)
#       define SETUP_XfOrM138(x) SETUP_XfOrM137(x)

# 1275 "bc/src/portfun.c"
        a [0 ] = v ; 
        FUNCCALL(SETUP_XfOrM138(_), scheme_wrong_contract ("user port buffer-mode" , line_ok ? "(or/c 'block 'line 'none #f)" : "(or/c 'block 'none #f)" , - 1 , - 1 , a ) )

        ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }
  }

# 1282 "bc/src/portfun.c"
  else {
#   define XfOrM134_COUNT (0+XfOrM133_COUNT)
#   define SETUP_XfOrM134(x) SETUP_XfOrM133(x)

# 1283 "bc/src/portfun.c"
    switch (mode ) {
      case 0 : 
      a [0 ] = scheme_block_symbol ; 
      break ; 
      case 1 : 
      a [0 ] = scheme_line_symbol ; 
      break ; 
      case 2 : 
      a [0 ] = scheme_none_symbol ; 
      break ; 
    }
    FUNCCALL(SETUP_XfOrM134(_), scheme_apply_multi (buffer_mode_proc , 1 , a ) ); 
  }

  RET_VALUE_START (mode ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1300 "bc/src/portfun.c"
static int 
user_input_buffer_mode (Scheme_Port * p , int mode ) 
{
  /* No conversion */

# 1303 "bc/src/portfun.c"
  Scheme_Input_Port * ip = (Scheme_Input_Port * ) p ; 
  User_Input_Port * uip = (User_Input_Port * ) ip -> port_data ; 

  return user_buffer_mode (uip -> buffer_mode_proc , mode , 0 ) ; 
}





typedef struct User_Output_Port {
  Scheme_Type type ; 
  Scheme_Object * evt ; 
  Scheme_Object * write_evt_proc ; 
  Scheme_Object * write_proc ; 
  Scheme_Object * flush_proc ; 
  Scheme_Object * close_proc ; 
  Scheme_Object * write_special_evt_proc ; 
  Scheme_Object * write_special_proc ; 
  Scheme_Object * location_proc ; 
  Scheme_Object * count_lines_proc ; 
  Scheme_Object * buffer_mode_proc ; 
  Scheme_Object * buffer_pipe ; 
}

# 1326 "bc/src/portfun.c"
User_Output_Port ; 

int scheme_user_port_write_probably_ready (Scheme_Output_Port * port , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 1330 "bc/src/portfun.c"
  Scheme_Object * val ; 
  User_Output_Port * uop = (User_Output_Port * ) port -> port_data ; 

  if (port -> closed )
    return 1 ; 

  val = uop -> evt ; 

  scheme_set_sync_target (sinfo , val , (Scheme_Object * ) port , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) ; 
  return 0 ; 
}


static int 
user_write_ready (Scheme_Output_Port * port ) 
{
  /* No conversion */


  return 1 ; 
}

static intptr_t 
user_write_result (const char * who , Scheme_Output_Port * port , int evt_ok , 
Scheme_Object * val , int rarely_block , int enable_break , intptr_t len ) 
{
  Scheme_Object * p [2 ] ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(port, 1), PUSH(who, 2), PUSHARRAY(p, 2, 3)));
# define XfOrM142_COUNT (6)
# define SETUP_XfOrM142(x) SETUP(XfOrM142_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p[0] = NULLED_OUT ; 
  p[1] = NULLED_OUT ; 

# 1358 "bc/src/portfun.c"
  while (1 ) {
#   define XfOrM155_COUNT (0+XfOrM142_COUNT)
#   define SETUP_XfOrM155(x) SETUP_XfOrM142(x)

# 1359 "bc/src/portfun.c"
    if (((val ) ) == (scheme_false ) )  {
#     define XfOrM166_COUNT (0+XfOrM155_COUNT)
#     define SETUP_XfOrM166(x) SETUP_XfOrM155(x)

# 1360 "bc/src/portfun.c"
      if (! rarely_block )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      else if (rarely_block == 2 )
        RET_VALUE_START (- 1 ) RET_VALUE_END ; 
      else if (! evt_ok )
        FUNCCALL(SETUP_XfOrM166(_), scheme_contract_error (who , "bad result for write event" , "result" , 1 , val , ((void * ) 0 ) ) )


      ; 
      else 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 1371 "bc/src/portfun.c"
    else if ((((intptr_t ) (val ) ) & 0x1 ) 
    && ((((intptr_t ) (val ) ) >> 1 ) >= 0 ) 
    && ((((intptr_t ) (val ) ) >> 1 ) <= len ) ) {
      int n ; 
#     define XfOrM164_COUNT (0+XfOrM155_COUNT)
#     define SETUP_XfOrM164(x) SETUP_XfOrM155(x)

# 1376 "bc/src/portfun.c"
      n = (((intptr_t ) (val ) ) >> 1 ) ; 

      if (! n && len ) {
#       define XfOrM165_COUNT (0+XfOrM164_COUNT)
#       define SETUP_XfOrM165(x) SETUP_XfOrM164(x)
        FUNCCALL(SETUP_XfOrM165(_), scheme_contract_error (who , (evt_ok ? "bad result for non-flush write" : "bad result for non-flush write event" ) , "result" , 1 , val , ((void * ) 0 ) ) )


        ; 
      }

      if (! len && ! rarely_block )
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (n ) RET_VALUE_END ; 
    }

# 1391 "bc/src/portfun.c"
    else if (evt_ok && FUNCCALL(SETUP_XfOrM155(_), pipe_output_p (val ) )) {
#     define XfOrM162_COUNT (0+XfOrM155_COUNT)
#     define SETUP_XfOrM162(x) SETUP_XfOrM155(x)

# 1392 "bc/src/portfun.c"
      if (rarely_block || ! len ) {
#       define XfOrM163_COUNT (0+XfOrM162_COUNT)
#       define SETUP_XfOrM163(x) SETUP_XfOrM162(x)
        FUNCCALL(SETUP_XfOrM163(_), scheme_contract_error (who , (rarely_block ? "bad result for a non-blocking write" : "bad result for a flushing write" ) , "result" , 1 , val , ((void * ) 0 ) ) )


        ; 
      }

      ((User_Output_Port * ) port -> port_data ) -> buffer_pipe = val ; 

      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 1404 "bc/src/portfun.c"
    else if (evt_ok && FUNCCALL(SETUP_XfOrM155(_), scheme_is_evt (val ) )) {
#     define XfOrM159_COUNT (0+XfOrM155_COUNT)
#     define SETUP_XfOrM159(x) SETUP_XfOrM155(x)
      if (rarely_block == 2 ) {
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 1409 "bc/src/portfun.c"
      else {
#       define XfOrM160_COUNT (0+XfOrM159_COUNT)
#       define SETUP_XfOrM160(x) SETUP_XfOrM159(x)

# 1411 "bc/src/portfun.c"
        p [0 ] = val ; 
        if (enable_break )
          val = FUNCCALL(SETUP_XfOrM160(_), scheme_sync_enable_break (1 , p ) ); 
        else 
        val = FUNCCALL(SETUP_XfOrM160(_), scheme_sync (1 , p ) ); 


        if (port -> closed )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }

# 1421 "bc/src/portfun.c"
    else {
#     define XfOrM156_COUNT (0+XfOrM155_COUNT)
#     define SETUP_XfOrM156(x) SETUP_XfOrM155(x)

# 1422 "bc/src/portfun.c"
      if (((((intptr_t ) (val ) ) & 0x1 ) && ((((intptr_t ) (val ) ) >> 1 ) > 0 ) ) 
      || (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) val ) -> iso ) -> so . keyex & 0x1 ) ) ) {
#       define XfOrM158_COUNT (0+XfOrM156_COUNT)
#       define SETUP_XfOrM158(x) SETUP_XfOrM156(x)
        FUNCCALL(SETUP_XfOrM158(_), scheme_contract_error (who , "result integer is larger than the supplied byte string" , "result" , 1 , val , "byte string length" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )

        ; 
      }

# 1429 "bc/src/portfun.c"
      else {
#       define XfOrM157_COUNT (0+XfOrM156_COUNT)
#       define SETUP_XfOrM157(x) SETUP_XfOrM156(x)

# 1430 "bc/src/portfun.c"
        p [0 ] = val ; 
        FUNCCALL(SETUP_XfOrM157(_), scheme_wrong_contract (who , "(or/c exact-nonnegative-integer? #f evt?)" , - 1 , - 1 , p ) )

        ; 
      }
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1440 "bc/src/portfun.c"
static intptr_t 
user_write_bytes (Scheme_Output_Port * port , const char * str , intptr_t offset , intptr_t len , 
int rarely_block , int enable_break ) 
{


  Scheme_Object * p [5 ] , * to_write , * val ; 
  User_Output_Port * uop = (User_Output_Port * ) port -> port_data ; 
  int n , re_enable_break ; 
  Scheme_Cont_Frame_Data cframe ; 

# 502 "bc/src/portfun.c"
  Scheme_Output_Port * __funcarg167 = NULLED_OUT ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(uop, 0), PUSH(str, 1), PUSH(val, 2), PUSH(port, 3), PUSH(to_write, 4), PUSH(cframe.cache, 5), PUSHARRAY(p, 5, 6)));
# define XfOrM167_COUNT (9)
# define SETUP_XfOrM167(x) SETUP(XfOrM167_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (p ) ; 
  to_write = NULLED_OUT ; 
  val = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 1451 "bc/src/portfun.c"
  if (scheme_is_output_port (uop -> write_proc ) )  {
#   define XfOrM182_COUNT (0+XfOrM167_COUNT)
#   define SETUP_XfOrM182(x) SETUP_XfOrM167(x)

# 1452 "bc/src/portfun.c"
    RET_VALUE_START ((__funcarg167 = FUNCCALL(SETUP_XfOrM182(_), scheme_output_port_record (uop -> write_proc ) ), FUNCCALL_AGAIN(scheme_redirect_write_bytes (__funcarg167 , str , offset , len , rarely_block , enable_break ) )) ) RET_VALUE_END 

    ; 
  }

  if (rarely_block )
    re_enable_break = 0 ; 
  else if (enable_break )
    re_enable_break = 1 ; 
  else 
  re_enable_break = FUNCCALL(SETUP_XfOrM167(_), scheme_can_break (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ); 

  to_write = FUNCCALL(SETUP_XfOrM167(_), scheme_make_sized_offset_byte_string ((char * ) str , offset , len , 1 ) ); 
  p [0 ] = to_write ; 
  ((((Scheme_Inclhash_Object * ) (p [0 ] ) ) -> so . keyex |= 0x1 ) ) ; 
  p [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  p [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) ; 
  p [3 ] = (rarely_block ? scheme_true : scheme_false ) ; 
  p [4 ] = (re_enable_break ? scheme_true : scheme_false ) ; 

  while (1 ) {
#   define XfOrM175_COUNT (0+XfOrM167_COUNT)
#   define SETUP_XfOrM175(x) SETUP_XfOrM167(x)

# 1474 "bc/src/portfun.c"
    if (uop -> buffer_pipe ) {
#     define XfOrM179_COUNT (0+XfOrM175_COUNT)
#     define SETUP_XfOrM179(x) SETUP_XfOrM175(x)

# 1475 "bc/src/portfun.c"
      if (! rarely_block && len ) {
#       define XfOrM180_COUNT (0+XfOrM179_COUNT)
#       define SETUP_XfOrM180(x) SETUP_XfOrM179(x)

# 1476 "bc/src/portfun.c"
        if (FUNCCALL(SETUP_XfOrM180(_), pipe_out_ready ((Scheme_Output_Port * ) uop -> buffer_pipe ) )) {
#         define XfOrM181_COUNT (0+XfOrM180_COUNT)
#         define SETUP_XfOrM181(x) SETUP_XfOrM180(x)
          FUNCCALL(SETUP_XfOrM181(_), scheme_start_atomic () )
# 1478 "bc/src/portfun.c"
          ; 
          n = FUNCCALL(SETUP_XfOrM181(_), scheme_put_byte_string ("user output pipe buffer" , uop -> buffer_pipe , str , offset , len , 1 ) )

          ; 
          FUNCCALL_AGAIN(scheme_end_atomic_no_swap () ); 
          RET_VALUE_START (n ) RET_VALUE_END ; 
        }
      }
      uop -> buffer_pipe = ((void * ) 0 ) ; 
    }
    FUNCCALL(SETUP_XfOrM175(_), scheme_push_break_enable (& cframe , 0 , 0 ) )

    ; 

    val = FUNCCALL(SETUP_XfOrM175(_), scheme_apply (uop -> write_proc , 5 , p ) ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe , 1 ) )
    ; 

    n = FUNCCALL_AGAIN(user_write_result ("user port write" , port , 1 , val , rarely_block , enable_break , len ) )
    ; 

    if (! n && ! rarely_block ) {
    }
    else {
      if (n || (rarely_block != 1 ) ) {
        if (! rarely_block && ! len )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        RET_VALUE_START (n ) RET_VALUE_END ; 
      }
    }
    FUNCCALL(SETUP_XfOrM175(_), scheme_thread_block (0.0 ) )



    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1517 "bc/src/portfun.c"
static Scheme_Object * user_write_evt_wrapper (void * d , int argc , struct Scheme_Object * argv [] ) 
{
  Scheme_Object * val , * port ; 
  intptr_t r , len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM183_COUNT (1)
# define SETUP_XfOrM183(x) SETUP(XfOrM183_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  val = NULLED_OUT ; 
  port = NULLED_OUT ; 

# 1522 "bc/src/portfun.c"
  port = (Scheme_Object * ) ((void * * ) d ) [0 ] ; 
  val = (Scheme_Object * ) ((void * * ) d ) [1 ] ; 
  len = (((intptr_t ) (val ) ) >> 1 ) ; 
  val = argv [0 ] ; 

  r = FUNCCALL(SETUP_XfOrM183(_), user_write_result ("user port write-evt" , (Scheme_Output_Port * ) port , 0 , val , 1 , 0 , len ) )
  ; 

  if (! r && len ) {
#   define XfOrM184_COUNT (0+XfOrM183_COUNT)
#   define SETUP_XfOrM184(x) SETUP_XfOrM183(x)
    FUNCCALL_EMPTY(scheme_contract_error ("user port write-evt" , "port is closed" , "port" , 1 , port , ((void * ) 0 ) ) )

    ; 
  }

  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1541 "bc/src/portfun.c"
static Scheme_Object * 
user_write_bytes_evt (Scheme_Output_Port * port , 
const char * buffer , intptr_t offset , intptr_t size ) 
{
  Scheme_Object * to_write , * wrapper ; 
  Scheme_Object * a [3 ] , * val ; 
  void * * args ; 
  User_Output_Port * uop = (User_Output_Port * ) port -> port_data ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(uop, 0), PUSH(args, 1), PUSH(val, 2), PUSH(port, 3), PUSH(to_write, 4), PUSHARRAY(a, 3, 5), PUSH(wrapper, 8)));
# define XfOrM185_COUNT (9)
# define SETUP_XfOrM185(x) SETUP(XfOrM185_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  to_write = NULLED_OUT ; 
  wrapper = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  val = NULLED_OUT ; 
  args = NULLED_OUT ; 

# 1550 "bc/src/portfun.c"
  to_write = FUNCCALL(SETUP_XfOrM185(_), scheme_make_sized_offset_byte_string ((char * ) buffer , offset , size , 1 ) ); 
  ((((Scheme_Inclhash_Object * ) (to_write ) ) -> so . keyex |= 0x1 ) ) ; 
  a [0 ] = to_write ; 
  a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  a [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (size ) ) ) << 1 ) | 0x1 ) ) ; 
  val = FUNCCALL(SETUP_XfOrM185(_), scheme_apply (uop -> write_evt_proc , 3 , a ) ); 

  if (! FUNCCALL(SETUP_XfOrM185(_), scheme_is_evt (val ) )) {
#   define XfOrM186_COUNT (0+XfOrM185_COUNT)
#   define SETUP_XfOrM186(x) SETUP_XfOrM185(x)

# 1558 "bc/src/portfun.c"
    a [0 ] = val ; 
    FUNCCALL(SETUP_XfOrM186(_), scheme_wrong_contract ("user port write-evt" , "evt?" , - 1 , - 1 , a ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }


  args = ((void * * ) FUNCCALL(SETUP_XfOrM185(_), GC_malloc (sizeof (void * ) * (2 ) ) )) ; 
  args [0 ] = port ; 
  args [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (size ) ) ) << 1 ) | 0x1 ) ) ; 
  wrapper = FUNCCALL(SETUP_XfOrM185(_), scheme_make_closed_prim (user_write_evt_wrapper , args ) ); 

  a [0 ] = val ; 
  a [1 ] = wrapper ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM185(_), scheme_wrap_evt (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1574 "bc/src/portfun.c"
static void 
user_needs_wakeup_output (Scheme_Output_Port * port , void * fds ) 
{
  /* No conversion */
}

static void 
user_close_output (Scheme_Output_Port * port ) 
{
  /* No conversion */

# 1583 "bc/src/portfun.c"
  User_Output_Port * uop = (User_Output_Port * ) port -> port_data ; 

  scheme_apply_multi (uop -> close_proc , 0 , ((void * ) 0 ) ) ; 
}

static int 
user_write_special (Scheme_Output_Port * port , Scheme_Object * v , int nonblock ) 
{
  Scheme_Object * a [3 ] ; 
  User_Output_Port * uop = (User_Output_Port * ) port -> port_data ; 
  int re_enable_break ; 
  Scheme_Cont_Frame_Data cframe ; 

# 502 "bc/src/portfun.c"
  Scheme_Output_Port * __funcarg168 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(uop, 0), PUSHARRAY(a, 3, 1), PUSH(cframe.cache, 4), PUSH(v, 5)));
# define XfOrM189_COUNT (6)
# define SETUP_XfOrM189(x) SETUP(XfOrM189_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 1596 "bc/src/portfun.c"
  if (scheme_is_output_port (uop -> write_special_proc ) )  {
#   define XfOrM196_COUNT (0+XfOrM189_COUNT)
#   define SETUP_XfOrM196(x) SETUP_XfOrM189(x)

# 1597 "bc/src/portfun.c"
    RET_VALUE_START ((__funcarg168 = FUNCCALL(SETUP_XfOrM196(_), scheme_output_port_record (uop -> write_special_proc ) ), FUNCCALL_AGAIN(scheme_redirect_write_special (__funcarg168 , v , nonblock ) )) ) RET_VALUE_END 

    ; 
  }

  if (nonblock )
    re_enable_break = 0 ; 
  else 
  re_enable_break = FUNCCALL(SETUP_XfOrM189(_), scheme_can_break (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ); 

  a [0 ] = v ; 
  a [1 ] = (nonblock ? scheme_true : scheme_false ) ; 
  a [2 ] = (re_enable_break ? scheme_true : scheme_false ) ; 
  FUNCCALL(SETUP_XfOrM189(_), scheme_push_break_enable (& cframe , 0 , 0 ) )
  ; 

  v = FUNCCALL_AGAIN(scheme_apply (uop -> write_special_proc , 3 , a ) ); 

  while (1 ) {
#   define XfOrM193_COUNT (0+XfOrM189_COUNT)
#   define SETUP_XfOrM193(x) SETUP_XfOrM189(x)

# 1616 "bc/src/portfun.c"
    if (uop -> buffer_pipe )
      uop -> buffer_pipe = ((void * ) 0 ) ; 

    if (FUNCCALL(SETUP_XfOrM193(_), scheme_is_evt (v ) )) {
#     define XfOrM194_COUNT (0+XfOrM193_COUNT)
#     define SETUP_XfOrM194(x) SETUP_XfOrM193(x)

# 1620 "bc/src/portfun.c"
      if (! nonblock ) {
#       define XfOrM195_COUNT (0+XfOrM194_COUNT)
#       define SETUP_XfOrM195(x) SETUP_XfOrM194(x)

# 1621 "bc/src/portfun.c"
        a [0 ] = v ; 
        if (re_enable_break )
          v = FUNCCALL(SETUP_XfOrM195(_), scheme_sync_enable_break (1 , a ) ); 
        else 
        v = FUNCCALL(SETUP_XfOrM195(_), scheme_sync (1 , a ) ); 
      }

# 1626 "bc/src/portfun.c"
      else 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 1628 "bc/src/portfun.c"
    else 
    break ; 
  }
  FUNCCALL(SETUP_XfOrM189(_), scheme_pop_break_enable (& cframe , 1 ) )
  ; 

  RET_VALUE_START ((! (((v ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1637 "bc/src/portfun.c"
static Scheme_Object * 
user_write_special_evt (Scheme_Output_Port * port , Scheme_Object * v ) 
{
  Scheme_Object * a [1 ] ; 
  User_Output_Port * uop = (User_Output_Port * ) port -> port_data ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSHARRAY(a, 1, 1)));
# define XfOrM197_COUNT (4)
# define SETUP_XfOrM197(x) SETUP(XfOrM197_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 1643 "bc/src/portfun.c"
  a [0 ] = v ; 
  v = FUNCCALL(SETUP_XfOrM197(_), scheme_apply (uop -> write_special_evt_proc , 1 , a ) ); 

  if (! FUNCCALL(SETUP_XfOrM197(_), scheme_is_evt (v ) )) {
#   define XfOrM198_COUNT (0+XfOrM197_COUNT)
#   define SETUP_XfOrM198(x) SETUP_XfOrM197(x)

# 1647 "bc/src/portfun.c"
    a [0 ] = v ; 
    FUNCCALL(SETUP_XfOrM198(_), scheme_wrong_contract ("user port write-special-evt" , "evt?" , - 1 , - 1 , a ) ); 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1654 "bc/src/portfun.c"
static Scheme_Object * 
user_output_location (Scheme_Port * p ) 
{
  /* No conversion */

# 1657 "bc/src/portfun.c"
  Scheme_Output_Port * op = (Scheme_Output_Port * ) p ; 
  User_Output_Port * uop = (User_Output_Port * ) op -> port_data ; 

  return scheme_apply_multi (uop -> location_proc , 0 , ((void * ) 0 ) ) ; 
}

static void 
user_output_count_lines (Scheme_Port * p ) 
{
  /* No conversion */

# 1666 "bc/src/portfun.c"
  Scheme_Output_Port * op = (Scheme_Output_Port * ) p ; 
  User_Output_Port * uop = (User_Output_Port * ) op -> port_data ; 

  scheme_apply_multi (uop -> count_lines_proc , 0 , ((void * ) 0 ) ) ; 
}

static int 
user_output_buffer_mode (Scheme_Port * p , int mode ) 
{
  /* No conversion */

# 1675 "bc/src/portfun.c"
  Scheme_Output_Port * op = (Scheme_Output_Port * ) p ; 
  User_Output_Port * uop = (User_Output_Port * ) op -> port_data ; 

  return user_buffer_mode (uop -> buffer_mode_proc , mode , 1 ) ; 
}

int scheme_is_user_port (Scheme_Object * port ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM202_COUNT (1)
# define SETUP_XfOrM202(x) SETUP(XfOrM202_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1683 "bc/src/portfun.c"
  if (scheme_is_input_port (port ) )  {
    Scheme_Input_Port * ip ; 
    BLOCK_SETUP((PUSH(ip, 0+XfOrM202_COUNT)));
#   define XfOrM204_COUNT (1+XfOrM202_COUNT)
#   define SETUP_XfOrM204(x) SETUP(XfOrM204_COUNT)
    ip = NULLED_OUT ; 

# 1685 "bc/src/portfun.c"
    ip = FUNCCALL(SETUP_XfOrM204(_), scheme_input_port_record (port ) ); 
    RET_VALUE_START (((scheme_user_input_port_type ) == (ip -> sub_type ) ) ) RET_VALUE_END ; 
  }

# 1687 "bc/src/portfun.c"
  else {
    Scheme_Output_Port * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM202_COUNT)));
#   define XfOrM203_COUNT (1+XfOrM202_COUNT)
#   define SETUP_XfOrM203(x) SETUP(XfOrM203_COUNT)
    op = NULLED_OUT ; 

# 1689 "bc/src/portfun.c"
    op = FUNCCALL(SETUP_XfOrM203(_), scheme_output_port_record (port ) ); 
    RET_VALUE_START (((scheme_user_output_port_type ) == (op -> sub_type ) ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static void pipe_did_read (Scheme_Input_Port * port , Scheme_Pipe * pipe , int peek ) 
{
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(pipe, 1)));
# define XfOrM205_COUNT (2)
# define SETUP_XfOrM205(x) SETUP(XfOrM205_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1700 "bc/src/portfun.c"
  if (port && port -> progress_evt && ! peek ) {
#   define XfOrM208_COUNT (0+XfOrM205_COUNT)
#   define SETUP_XfOrM208(x) SETUP_XfOrM205(x)
    FUNCCALL(SETUP_XfOrM208(_), scheme_post_sema_all (port -> progress_evt ) )
# 1701 "bc/src/portfun.c"
    ; 
    port -> progress_evt = ((void * ) 0 ) ; 
  }

  while (((Scheme_Type ) (((((intptr_t ) (pipe -> wakeup_on_read ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pipe -> wakeup_on_read ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    Scheme_Object * sema ; 
    BLOCK_SETUP((PUSH(sema, 0+XfOrM205_COUNT)));
#   define XfOrM207_COUNT (1+XfOrM205_COUNT)
#   define SETUP_XfOrM207(x) SETUP(XfOrM207_COUNT)
    sema = NULLED_OUT ; 

# 1707 "bc/src/portfun.c"
    sema = (((Scheme_Simple_Object * ) (pipe -> wakeup_on_read ) ) -> u . pair_val . car ) ; 
    pipe -> wakeup_on_read = (((Scheme_Simple_Object * ) (pipe -> wakeup_on_read ) ) -> u . pair_val . cdr ) ; 
    FUNCCALL(SETUP_XfOrM207(_), scheme_post_sema (sema ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1713 "bc/src/portfun.c"
static void pipe_did_write (Scheme_Pipe * pipe ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(pipe, 0)));
# define XfOrM209_COUNT (1)
# define SETUP_XfOrM209(x) SETUP(XfOrM209_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1715 "bc/src/portfun.c"
  while (((Scheme_Type ) (((((intptr_t ) (pipe -> wakeup_on_write ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pipe -> wakeup_on_write ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    Scheme_Object * sema ; 
    BLOCK_SETUP((PUSH(sema, 0+XfOrM209_COUNT)));
#   define XfOrM211_COUNT (1+XfOrM209_COUNT)
#   define SETUP_XfOrM211(x) SETUP(XfOrM211_COUNT)
    sema = NULLED_OUT ; 

# 1717 "bc/src/portfun.c"
    sema = (((Scheme_Simple_Object * ) (pipe -> wakeup_on_write ) ) -> u . pair_val . car ) ; 
    pipe -> wakeup_on_write = (((Scheme_Simple_Object * ) (pipe -> wakeup_on_write ) ) -> u . pair_val . cdr ) ; 
    FUNCCALL(SETUP_XfOrM211(_), scheme_post_sema (sema ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1723 "bc/src/portfun.c"
static intptr_t pipe_get_or_peek_bytes (Scheme_Input_Port * p , 
char * buffer , intptr_t offset , intptr_t size , 
int nonblock , 
int peek , intptr_t peek_skip , 
Scheme_Object * unless ) 
{
  Scheme_Pipe * pipe ; 
  intptr_t c , skipped = 0 ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(buffer, 0), PUSH(p, 1), PUSH(pipe, 2), PUSH(unless, 3)));
# define XfOrM212_COUNT (4)
# define SETUP_XfOrM212(x) SETUP(XfOrM212_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  pipe = NULLED_OUT ; 

# 1732 "bc/src/portfun.c"
  pipe = (Scheme_Pipe * ) (p -> port_data ) ; 

  while ((pipe -> bufstart == pipe -> bufend ) && ! pipe -> eof ) {
#   define XfOrM230_COUNT (0+XfOrM212_COUNT)
#   define SETUP_XfOrM230(x) SETUP_XfOrM212(x)

# 1735 "bc/src/portfun.c"
    if (nonblock > 0 )
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    FUNCCALL(SETUP_XfOrM230(_), scheme_block_until_unless ((Scheme_Ready_Fun ) scheme_byte_ready_or_user_port_ready , ((void * ) 0 ) , (Scheme_Object * ) p , 0.0 , unless , nonblock ) )



    ; 
    FUNCCALL_AGAIN(scheme_wait_input_allowed (p , nonblock ) )
    ; 

    if (scheme_unless_ready (unless ) ) 
      RET_VALUE_START ((- 3 ) ) RET_VALUE_END ; 
  }

  if (p -> closed ) {
#   define XfOrM228_COUNT (0+XfOrM212_COUNT)
#   define SETUP_XfOrM228(x) SETUP_XfOrM212(x)
    FUNCCALL(SETUP_XfOrM228(_), scheme_getc ((Scheme_Object * ) p ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  if (pipe -> bufstart == pipe -> bufend )
    c = (- 1 ) ; 
  else {
    intptr_t bs = pipe -> bufstart ; 
#   define XfOrM221_COUNT (0+XfOrM212_COUNT)
#   define SETUP_XfOrM221(x) SETUP_XfOrM212(x)

# 1760 "bc/src/portfun.c"
    c = 0 ; 
    if (bs > pipe -> bufend ) {
      int n ; 
#     define XfOrM225_COUNT (0+XfOrM221_COUNT)
#     define SETUP_XfOrM225(x) SETUP_XfOrM221(x)
      n = pipe -> buflen - bs ; 
      if (n < peek_skip ) {
        peek_skip -= n ; 
        bs += n ; 
        skipped += n ; 
        n = 0 ; 
      }

# 1771 "bc/src/portfun.c"
      else {
        bs += peek_skip ; 
        n -= peek_skip ; 
        skipped += peek_skip ; 
        peek_skip = 0 ; 
      }
      if (n > size )
        n = size ; 


      if (buffer )
        (memcpy (buffer + offset , pipe -> buf + bs , n ) ) ; 


      bs += n ; 
      if (bs == pipe -> buflen )
        bs = 0 ; 
      if (! peek )
        pipe -> bufstart = bs ; 
      size -= n ; 
      c += n ; 
    }
    if (bs < pipe -> bufend ) {
      int n ; 
#     define XfOrM222_COUNT (0+XfOrM221_COUNT)
#     define SETUP_XfOrM222(x) SETUP_XfOrM221(x)
      n = pipe -> bufend - bs ; 
      if (n < peek_skip ) {
        peek_skip -= n ; 
        bs += n ; 
        skipped += n ; 
        n = 0 ; 
      }

# 1803 "bc/src/portfun.c"
      else {
        bs += peek_skip ; 
        n -= peek_skip ; 
        skipped += peek_skip ; 
        peek_skip = 0 ; 
      }
      if (n > size )
        n = size ; 


      if (buffer )
        (memcpy (buffer + offset + c , pipe -> buf + bs , n ) ) ; 


      bs += n ; 
      if (! peek )
        pipe -> bufstart = bs ; 
      size -= n ; 
      c += n ; 
    }
  }

  if (! peek && (c > 0 ) ) {
#   define XfOrM219_COUNT (0+XfOrM212_COUNT)
#   define SETUP_XfOrM219(x) SETUP_XfOrM212(x)

# 1826 "bc/src/portfun.c"
    if (pipe -> bufmaxextra ) {
      if (pipe -> bufmaxextra > c )
        pipe -> bufmaxextra -= c ; 
      else 
      pipe -> bufmaxextra = 0 ; 
    }
    FUNCCALL(SETUP_XfOrM219(_), pipe_did_read (p , pipe , 0 ) ); 
  }

# 1833 "bc/src/portfun.c"
  else {
#   define XfOrM213_COUNT (0+XfOrM212_COUNT)
#   define SETUP_XfOrM213(x) SETUP_XfOrM212(x)

# 1834 "bc/src/portfun.c"
    if (! c ) {
#     define XfOrM217_COUNT (0+XfOrM213_COUNT)
#     define SETUP_XfOrM217(x) SETUP_XfOrM213(x)

# 1835 "bc/src/portfun.c"
      if (size && pipe -> eof )
        RET_VALUE_START ((- 1 ) ) RET_VALUE_END ; 
      if (! nonblock ) {


        Scheme_Object * my_sema , * wp ; 
        BLOCK_SETUP((PUSH(my_sema, 0+XfOrM217_COUNT), PUSH(wp, 1+XfOrM217_COUNT)));
#       define XfOrM218_COUNT (2+XfOrM217_COUNT)
#       define SETUP_XfOrM218(x) SETUP(XfOrM218_COUNT)
        my_sema = NULLED_OUT ; 
        wp = NULLED_OUT ; 

# 1841 "bc/src/portfun.c"
        my_sema = FUNCCALL(SETUP_XfOrM218(_), scheme_make_sema (0 ) ); 
        wp = FUNCCALL_AGAIN(scheme_make_pair (my_sema , pipe -> wakeup_on_write ) ); 
        pipe -> wakeup_on_write = wp ; 
        FUNCCALL(SETUP_XfOrM218(_), scheme_wait_sema (my_sema , (nonblock < 0 ) ? - 1 : 0 ) ); 
      }
    }

# 1846 "bc/src/portfun.c"
    else if (c > 0 ) {
#     define XfOrM214_COUNT (0+XfOrM213_COUNT)
#     define SETUP_XfOrM214(x) SETUP_XfOrM213(x)

# 1847 "bc/src/portfun.c"
      if (pipe -> bufmax ) {
        if (pipe -> bufmaxextra < c + skipped ) {
          pipe -> bufmaxextra = c + skipped ; 
        }
      }
      FUNCCALL_EMPTY(pipe_did_read (p , pipe , 1 ) ); 
    }
  }

  RET_VALUE_START (c ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1859 "bc/src/portfun.c"
static intptr_t pipe_get_bytes (Scheme_Input_Port * p , 
char * buffer , intptr_t offset , intptr_t size , 
int nonblock , 
Scheme_Object * unless ) 
{
  /* No conversion */

# 1864 "bc/src/portfun.c"
  return pipe_get_or_peek_bytes (p , buffer , offset , size , nonblock , 0 , 0 , unless ) ; 
}

static intptr_t pipe_peek_bytes (Scheme_Input_Port * p , 
char * buffer , intptr_t offset , intptr_t size , 
Scheme_Object * skip , 
int nonblock , 
Scheme_Object * unless ) 
{
  /* No conversion */

# 1873 "bc/src/portfun.c"
  intptr_t peek_skip ; 

  if (((intptr_t ) (skip ) ) & 0x1 ) 
    peek_skip = (((intptr_t ) (skip ) ) >> 1 ) ; 
  else {

    peek_skip = 0x7FFFFFFFFFFFFFFF ; 
  }




  return pipe_get_or_peek_bytes (p , buffer , offset , size , nonblock , 1 , peek_skip , unless ) ; 
}

static intptr_t pipe_write_bytes (Scheme_Output_Port * p , 
const char * str , intptr_t d , intptr_t len , 
int rarely_block , int enable_break ) 
{
  Scheme_Pipe * pipe ; 
  intptr_t avail , firstpos , firstn , secondn , endpos ; 
  intptr_t wrote = 0 ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(p, 1), PUSH(pipe, 2)));
# define XfOrM234_COUNT (3)
# define SETUP_XfOrM234(x) SETUP(XfOrM234_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  pipe = NULLED_OUT ; 

# 1896 "bc/src/portfun.c"
  pipe = (Scheme_Pipe * ) (p -> port_data ) ; 

  try_again : 

  if (pipe -> eof || ! len )
    RET_VALUE_START (len + wrote ) RET_VALUE_END ; 

  if (pipe -> bufstart <= pipe -> bufend ) {
    firstn = pipe -> buflen - pipe -> bufend ; 
    avail = firstn + pipe -> bufstart - 1 ; 
    if (! pipe -> bufstart )
      -- firstn ; 
  }

# 1908 "bc/src/portfun.c"
  else {
    firstn = avail = pipe -> bufstart - pipe -> bufend - 1 ; 
  }
  firstpos = pipe -> bufend ; 

  if (pipe -> bufmax ) {



    intptr_t extra ; 
    extra = pipe -> buflen - (pipe -> bufmax + pipe -> bufmaxextra ) ; 
    if (extra > 0 )
      avail -= extra ; 
  }

  if (pipe -> bufmax && (avail < len ) ) {

    intptr_t xavail = avail ; 
    intptr_t can_extra ; 
#   define XfOrM242_COUNT (0+XfOrM234_COUNT)
#   define SETUP_XfOrM242(x) SETUP_XfOrM234(x)

# 1928 "bc/src/portfun.c"
    can_extra = ((pipe -> bufmax + pipe -> bufmaxextra ) - pipe -> buflen ) ; 
    if (can_extra > 0 )
      xavail += can_extra ; 

    if (xavail < len ) {

      Scheme_Object * my_sema ; 
      BLOCK_SETUP((PUSH(my_sema, 0+XfOrM242_COUNT)));
#     define XfOrM243_COUNT (1+XfOrM242_COUNT)
#     define SETUP_XfOrM243(x) SETUP(XfOrM243_COUNT)
      my_sema = NULLED_OUT ; 

# 1937 "bc/src/portfun.c"
      xavail = FUNCCALL(SETUP_XfOrM243(_), pipe_write_bytes (p , str , d , xavail , rarely_block , enable_break ) ); 
      wrote += xavail ; 
      d += xavail ; 
      len -= xavail ; 
      FUNCCALL(SETUP_XfOrM243(_), pipe_did_write (pipe ) ); 



      if ((rarely_block && wrote ) || (rarely_block == 2 ) )
        RET_VALUE_START (wrote ) RET_VALUE_END ; 


      if (pipe -> bufstart <= pipe -> bufend ) {
        avail = (pipe -> buflen - pipe -> bufend ) + pipe -> bufstart - 1 ; 
      }

# 1951 "bc/src/portfun.c"
      else {
        avail = pipe -> bufstart - pipe -> bufend - 1 ; 
      }
      if (pipe -> bufmax ) {


        intptr_t extra ; 
        extra = pipe -> buflen - (pipe -> bufmax + pipe -> bufmaxextra ) ; 
        if (extra > 0 )
          avail -= extra ; 
      }

      if (avail || pipe -> eof || p -> closed )
        goto try_again ; 

      my_sema = FUNCCALL(SETUP_XfOrM243(_), scheme_make_sema (0 ) ); 
      {
        Scheme_Object * wp ; 
        BLOCK_SETUP((PUSH(wp, 0+XfOrM243_COUNT)));
#       define XfOrM244_COUNT (1+XfOrM243_COUNT)
#       define SETUP_XfOrM244(x) SETUP(XfOrM244_COUNT)
        wp = NULLED_OUT ; 

# 1969 "bc/src/portfun.c"
        wp = FUNCCALL(SETUP_XfOrM244(_), scheme_make_pair (my_sema , pipe -> wakeup_on_read ) ); 
        pipe -> wakeup_on_read = wp ; 
      }
      FUNCCALL(SETUP_XfOrM243(_), scheme_wait_sema (my_sema , enable_break ? - 1 : 0 ) )
      ; 

      goto try_again ; 
    }
  }

  if (avail < len ) {
    unsigned char * old ; 
    int newlen ; 
    BLOCK_SETUP((PUSH(old, 0+XfOrM234_COUNT)));
#   define XfOrM238_COUNT (1+XfOrM234_COUNT)
#   define SETUP_XfOrM238(x) SETUP(XfOrM238_COUNT)
    old = NULLED_OUT ; 

# 1983 "bc/src/portfun.c"
    old = pipe -> buf ; 
    newlen = 2 * (pipe -> buflen + len ) ; 
    if (pipe -> bufmax && (newlen > (pipe -> bufmax + pipe -> bufmaxextra ) ) )
      newlen = pipe -> bufmax + pipe -> bufmaxextra ; 

    {
      unsigned char * uca ; 
      BLOCK_SETUP((PUSH(uca, 0+XfOrM238_COUNT)));
#     define XfOrM241_COUNT (1+XfOrM238_COUNT)
#     define SETUP_XfOrM241(x) SETUP(XfOrM241_COUNT)
      uca = NULLED_OUT ; 

# 1990 "bc/src/portfun.c"
      uca = (unsigned char * ) FUNCCALL(SETUP_XfOrM241(_), GC_malloc_atomic (newlen ) ); 
      pipe -> buf = uca ; 
    }

    if (pipe -> bufstart <= pipe -> bufend ) {
#     define XfOrM240_COUNT (0+XfOrM238_COUNT)
#     define SETUP_XfOrM240(x) SETUP_XfOrM238(x)
      (
# 1995 "bc/src/portfun.c"
      memcpy (pipe -> buf , old + pipe -> bufstart , pipe -> bufend - pipe -> bufstart ) ) ; 
      pipe -> bufend -= pipe -> bufstart ; 
      pipe -> bufstart = 0 ; 
    }

# 1998 "bc/src/portfun.c"
    else {
      int slen ; 
#     define XfOrM239_COUNT (0+XfOrM238_COUNT)
#     define SETUP_XfOrM239(x) SETUP_XfOrM238(x)

# 2000 "bc/src/portfun.c"
      slen = pipe -> buflen - pipe -> bufstart ; 
      (memcpy (pipe -> buf , old + pipe -> bufstart , slen ) ) ; 
      (memcpy (pipe -> buf + slen , old , pipe -> bufend ) ) ; 
      pipe -> bufstart = 0 ; 
      pipe -> bufend += slen ; 
    }

    pipe -> buflen = newlen ; 

    firstpos = pipe -> bufend ; 
    firstn = len ; 
    endpos = firstpos + firstn ; 

    secondn = 0 ; 
  }

# 2014 "bc/src/portfun.c"
  else {
    if (firstn >= len ) {
      firstn = len ; 
      endpos = (firstpos + len ) % pipe -> buflen ; 
      secondn = 0 ; 
    }

# 2019 "bc/src/portfun.c"
    else {
      secondn = len - firstn ; 
      endpos = secondn ; 
    }
  }

  if (firstn )
    (memcpy (pipe -> buf + firstpos , str + d , firstn ) ) ; 
  if (secondn )
    (memcpy (pipe -> buf , str + d + firstn , secondn ) ) ; 

  pipe -> bufend = endpos ; 
  FUNCCALL_EMPTY(pipe_did_write (pipe ) )
  ; 

  RET_VALUE_START (len + wrote ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2037 "bc/src/portfun.c"
static int pipe_byte_ready (Scheme_Input_Port * p ) 
{
  /* No conversion */

# 2039 "bc/src/portfun.c"
  Scheme_Pipe * pipe ; 
  int v ; 

  pipe = (Scheme_Pipe * ) (p -> port_data ) ; 

  v = (pipe -> bufstart != pipe -> bufend || pipe -> eof ) ; 

  return v ; 
}

static void pipe_in_close (Scheme_Input_Port * p ) 
{
  Scheme_Pipe * pipe ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pipe, 0)));
# define XfOrM252_COUNT (1)
# define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pipe = NULLED_OUT ; 

# 2053 "bc/src/portfun.c"
  pipe = (Scheme_Pipe * ) (p -> port_data ) ; 

  pipe -> eof = 1 ; 
  FUNCCALL(SETUP_XfOrM252(_), pipe_did_read (p , pipe , 0 ) )

  ; 
  FUNCCALL_EMPTY(pipe_did_write (pipe ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2062 "bc/src/portfun.c"
static void pipe_out_close (Scheme_Output_Port * p ) 
{
  Scheme_Pipe * pipe ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pipe, 0)));
# define XfOrM253_COUNT (1)
# define SETUP_XfOrM253(x) SETUP(XfOrM253_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pipe = NULLED_OUT ; 

# 2066 "bc/src/portfun.c"
  pipe = (Scheme_Pipe * ) (p -> port_data ) ; 

  pipe -> eof = 1 ; 
  FUNCCALL(SETUP_XfOrM253(_), pipe_did_read (((void * ) 0 ) , pipe , 0 ) )

  ; 
  FUNCCALL_EMPTY(pipe_did_write (pipe ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2075 "bc/src/portfun.c"
static int pipe_out_ready (Scheme_Output_Port * p ) 
{
  /* No conversion */

# 2077 "bc/src/portfun.c"
  Scheme_Pipe * pipe ; 
  intptr_t avail ; 

  pipe = (Scheme_Pipe * ) (p -> port_data ) ; 

  if (pipe -> eof || ! pipe -> bufmax )
    return 1 ; 

  if (pipe -> bufend >= pipe -> bufstart ) {
    avail = pipe -> bufend - pipe -> bufstart ; 
  }

# 2087 "bc/src/portfun.c"
  else {
    avail = pipe -> bufend + (pipe -> buflen - pipe -> bufstart ) ; 
  }

  avail = pipe -> bufmax + pipe -> bufmaxextra - 1 - avail ; 

  return avail > 0 ; 
}

void scheme_pipe_with_limit (Scheme_Object * * read , Scheme_Object * * write , int queuelimit ) 
{
  Scheme_Pipe * pipe ; 
  Scheme_Input_Port * readp ; 
  Scheme_Output_Port * writep ; 
  Scheme_Object * name ; 
  PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(readp, 1), PUSH(write, 2), PUSH(writep, 3), PUSH(pipe, 4), PUSH(read, 5)));
# define XfOrM257_COUNT (6)
# define SETUP_XfOrM257(x) SETUP(XfOrM257_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  pipe = NULLED_OUT ; 
  readp = NULLED_OUT ; 
  writep = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 2103 "bc/src/portfun.c"
  if (queuelimit )

# 2103 "bc/src/portfun.c"
  queuelimit ++ ; 

  pipe = ((Scheme_Pipe * ) FUNCCALL(SETUP_XfOrM257(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Pipe ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  pipe -> type = scheme_rt_pipe ; 

  pipe -> buflen = ((queuelimit && (queuelimit < 100 ) ) ? queuelimit : 100 ) ; 
  {
    unsigned char * uca ; 
    BLOCK_SETUP((PUSH(uca, 0+XfOrM257_COUNT)));
#   define XfOrM258_COUNT (1+XfOrM257_COUNT)
#   define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)
    uca = NULLED_OUT ; 

# 2112 "bc/src/portfun.c"
    uca = (unsigned char * ) FUNCCALL(SETUP_XfOrM258(_), GC_malloc_atomic (pipe -> buflen ) ); 
    pipe -> buf = uca ; 
  }
  pipe -> bufstart = pipe -> bufend = 0 ; 
  pipe -> eof = 0 ; 
  pipe -> bufmax = queuelimit ; 
  pipe -> wakeup_on_read = scheme_null ; 
  pipe -> wakeup_on_write = scheme_null ; 

  name = FUNCCALL(SETUP_XfOrM257(_), scheme_intern_symbol ("pipe" ) ); 

  readp = FUNCCALL_AGAIN(scheme_make_input_port (scheme_pipe_read_port_type , (void * ) pipe , name , pipe_get_bytes , pipe_peek_bytes , scheme_progress_evt_via_get , scheme_peeked_read_via_get , pipe_byte_ready , pipe_in_close , ((void * ) 0 ) , 0 ) )
# 2133 "bc/src/portfun.c"
  ; 

  writep = FUNCCALL_AGAIN(scheme_make_output_port (scheme_pipe_write_port_type , (void * ) pipe , name , scheme_write_evt_via_write , pipe_write_bytes , pipe_out_ready , pipe_out_close , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) )
# 2145 "bc/src/portfun.c"
  ; 

  * read = (Scheme_Object * ) readp ; 
  * write = (Scheme_Object * ) writep ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2151 "bc/src/portfun.c"
void scheme_pipe (Scheme_Object * * read , Scheme_Object * * write ) 
{
  /* No conversion */

# 2153 "bc/src/portfun.c"
  scheme_pipe_with_limit (read , write , 0 ) ; 
}

static Scheme_Object * sch_pipe (int argc , Scheme_Object * * args ) 
{
  Scheme_Object * v [2 ] ; 
  int bufmax ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(v, 2, 0), PUSH(args, 3)));
# define XfOrM260_COUNT (4)
# define SETUP_XfOrM260(x) SETUP(XfOrM260_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v[0] = NULLED_OUT ; 
  v[1] = NULLED_OUT ; 

# 2161 "bc/src/portfun.c"
  if (argc > 0 ) {
    Scheme_Object * o = args [0 ] ; 
#   define XfOrM261_COUNT (0+XfOrM260_COUNT)
#   define SETUP_XfOrM261(x) SETUP_XfOrM260(x)

# 2163 "bc/src/portfun.c"
    if (((o ) ) == (scheme_false ) )  {
      bufmax = 0 ; 
    }

# 2165 "bc/src/portfun.c"
    else if (((((intptr_t ) (o ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) 
    && (scheme_is_positive (o ) ) ) {
      if (((intptr_t ) (o ) ) & 0x1 ) 
        bufmax = (((intptr_t ) (o ) ) >> 1 ) ; 
      else 
      bufmax = 0 ; 
    }

# 2171 "bc/src/portfun.c"
    else {
#     define XfOrM262_COUNT (0+XfOrM261_COUNT)
#     define SETUP_XfOrM262(x) SETUP_XfOrM261(x)
      FUNCCALL(SETUP_XfOrM262(_), scheme_wrong_contract ("make-pipe" , "(or/c exact-positive-integer? #f)" , 0 , argc , args ) )
# 2172 "bc/src/portfun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 2175 "bc/src/portfun.c"
  else 
  bufmax = 0 ; 
  FUNCCALL(SETUP_XfOrM260(_), scheme_pipe_with_limit (& v [0 ] , & v [1 ] , bufmax ) )
  ; 

  if (argc > 1 )
    ((Scheme_Input_Port * ) (v [0 ] ) ) -> name = args [1 ] ; 
  if (argc > 2 )
    ((Scheme_Output_Port * ) (v [1 ] ) ) -> name = args [2 ] ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM260(_), scheme_values (2 , v ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2188 "bc/src/portfun.c"
static Scheme_Object * pipe_length (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * o ; 
  Scheme_Pipe * pipe = ((void * ) 0 ) ; 
  int avail ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(pipe, 0), PUSH(argv, 1), PUSH(o, 2)));
# define XfOrM265_COUNT (3)
# define SETUP_XfOrM265(x) SETUP(XfOrM265_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 

# 2194 "bc/src/portfun.c"
  o = argv [0 ] ; 
  if (scheme_is_output_port (o ) )  {
    Scheme_Output_Port * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM265_COUNT)));
#   define XfOrM271_COUNT (1+XfOrM265_COUNT)
#   define SETUP_XfOrM271(x) SETUP(XfOrM271_COUNT)
    op = NULLED_OUT ; 

# 2197 "bc/src/portfun.c"
    op = FUNCCALL(SETUP_XfOrM271(_), scheme_output_port_record (o ) ); 
    if (op -> sub_type == scheme_pipe_write_port_type ) {
      pipe = (Scheme_Pipe * ) op -> port_data ; 
    }
  }

# 2201 "bc/src/portfun.c"
  else if (scheme_is_input_port (o ) )  {
    Scheme_Input_Port * ip ; 
    BLOCK_SETUP((PUSH(ip, 0+XfOrM265_COUNT)));
#   define XfOrM269_COUNT (1+XfOrM265_COUNT)
#   define SETUP_XfOrM269(x) SETUP(XfOrM269_COUNT)
    ip = NULLED_OUT ; 

# 2203 "bc/src/portfun.c"
    ip = FUNCCALL(SETUP_XfOrM269(_), scheme_input_port_record (o ) ); 
    if (ip -> sub_type == scheme_pipe_read_port_type ) {
      pipe = (Scheme_Pipe * ) ip -> port_data ; 
    }
  }

  if (! pipe ) {
#   define XfOrM268_COUNT (0+XfOrM265_COUNT)
#   define SETUP_XfOrM268(x) SETUP_XfOrM265(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("pipe-content-length" , "(or/c pipe-input-port? pipe-output-port?)" , 0 , argc , argv ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (pipe -> bufend >= pipe -> bufstart ) {
    avail = pipe -> bufend - pipe -> bufstart ; 
  }

# 2218 "bc/src/portfun.c"
  else {
    avail = pipe -> bufend + (pipe -> buflen - pipe -> bufstart ) ; 
  }

  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (avail ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2225 "bc/src/portfun.c"
static int pipe_input_p (Scheme_Object * o ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(1);
# define XfOrM273_COUNT (0)
# define SETUP_XfOrM273(x) SETUP(XfOrM273_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2228 "bc/src/portfun.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) )  {
    Scheme_Input_Port * ip ; 
    BLOCK_SETUP((PUSH(ip, 0+XfOrM273_COUNT)));
#   define XfOrM274_COUNT (1+XfOrM273_COUNT)
#   define SETUP_XfOrM274(x) SETUP(XfOrM274_COUNT)
    ip = NULLED_OUT ; 

# 2230 "bc/src/portfun.c"
    ip = FUNCCALL(SETUP_XfOrM274(_), scheme_input_port_record (o ) ); 
    if (ip -> sub_type == scheme_pipe_read_port_type ) {
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2239 "bc/src/portfun.c"
static int pipe_output_p (Scheme_Object * o ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(1);
# define XfOrM276_COUNT (0)
# define SETUP_XfOrM276(x) SETUP(XfOrM276_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2242 "bc/src/portfun.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) )  {
    Scheme_Output_Port * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM276_COUNT)));
#   define XfOrM277_COUNT (1+XfOrM276_COUNT)
#   define SETUP_XfOrM277(x) SETUP(XfOrM277_COUNT)
    op = NULLED_OUT ; 

# 2244 "bc/src/portfun.c"
    op = FUNCCALL(SETUP_XfOrM277(_), scheme_output_port_record (o ) ); 
    if (op -> sub_type == scheme_pipe_write_port_type ) {
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * 
input_port_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2260 "bc/src/portfun.c"
  return (scheme_is_input_port (argv [0 ] ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
output_port_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2266 "bc/src/portfun.c"
  return (scheme_is_output_port (argv [0 ] ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * port_closed_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1)));
# define XfOrM281_COUNT (2)
# define SETUP_XfOrM281(x) SETUP(XfOrM281_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2272 "bc/src/portfun.c"
  if (scheme_is_input_port (v ) )  {
    Scheme_Input_Port * ip ; 
    BLOCK_SETUP((PUSH(ip, 0+XfOrM281_COUNT)));
#   define XfOrM284_COUNT (1+XfOrM281_COUNT)
#   define SETUP_XfOrM284(x) SETUP(XfOrM284_COUNT)
    ip = NULLED_OUT ; 

# 2274 "bc/src/portfun.c"
    ip = FUNCCALL(SETUP_XfOrM284(_), scheme_input_port_record (v ) ); 
    RET_VALUE_START (ip -> closed ? scheme_true : scheme_false ) RET_VALUE_END ; 
  }

# 2276 "bc/src/portfun.c"
  else if (scheme_is_output_port (v ) )  {
    Scheme_Output_Port * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM281_COUNT)));
#   define XfOrM283_COUNT (1+XfOrM281_COUNT)
#   define SETUP_XfOrM283(x) SETUP(XfOrM283_COUNT)
    op = NULLED_OUT ; 

# 2278 "bc/src/portfun.c"
    op = FUNCCALL(SETUP_XfOrM283(_), scheme_output_port_record (v ) ); 
    RET_VALUE_START (op -> closed ? scheme_true : scheme_false ) RET_VALUE_END ; 
  }

# 2280 "bc/src/portfun.c"
  else {
#   define XfOrM282_COUNT (0+XfOrM281_COUNT)
#   define SETUP_XfOrM282(x) SETUP_XfOrM281(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-closed?" , "port?" , 0 , argc , argv ) )
# 2281 "bc/src/portfun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2286 "bc/src/portfun.c"
intptr_t scheme_port_closed_p (Scheme_Object * port ) {
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM285_COUNT (1)
# define SETUP_XfOrM285(x) SETUP(XfOrM285_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2287 "bc/src/portfun.c"
  RET_VALUE_START ((FUNCCALL(SETUP_XfOrM285(_), port_closed_p (1 , & port ) )== scheme_false ) ? 0 : 1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2290 "bc/src/portfun.c"
static Scheme_Object * current_input_port (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2292 "bc/src/portfun.c"
  return scheme_param_config2 ("current-input-port" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_INPUT_PORT ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , input_port_p , "input-port?" , 0 ) ; 
}

static Scheme_Object * current_output_port (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2299 "bc/src/portfun.c"
  return scheme_param_config2 ("current-output-port" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_OUTPUT_PORT ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , output_port_p , "output-port?" , 0 ) ; 
}

static Scheme_Object * current_error_port (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2306 "bc/src/portfun.c"
  return scheme_param_config2 ("current-error-port" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PORT ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , output_port_p , "output-port?" , 0 ) ; 
}

static Scheme_Object * 
make_input_port (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Input_Port * ip ; 
  User_Input_Port * uip ; 
  Scheme_Object * name ; 
  int read_port , peek_port ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(uip, 1), PUSH(ip, 2), PUSH(argv, 3)));
# define XfOrM289_COUNT (4)
# define SETUP_XfOrM289(x) SETUP(XfOrM289_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ip = NULLED_OUT ; 
  uip = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 2319 "bc/src/portfun.c"
  read_port = (scheme_is_input_port (argv [1 ] ) ) ; 
  if (! read_port 
  && ! FUNCCALL(SETUP_XfOrM289(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 1 , argc , argv ) )) {
#   define XfOrM296_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM296(x) SETUP_XfOrM289(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-input-port" , "(or/c (procedure-arity-includes/c 1) input-port?)" , 1 , argc , argv ) )
# 2322 "bc/src/portfun.c"
    ; 
  }
  peek_port = (scheme_is_input_port (argv [2 ] ) ) ; 
  if (! peek_port 
  && ! FUNCCALL(SETUP_XfOrM289(_), scheme_check_proc_arity2 (((void * ) 0 ) , 3 , 2 , argc , argv , 1 ) )) {
#   define XfOrM295_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM295(x) SETUP_XfOrM289(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-input-port" , "(or/c (procedure-arity-includes/c 3) input-port?)" , 2 , argc , argv ) )
# 2327 "bc/src/portfun.c"
    ; 
  }
  FUNCCALL(SETUP_XfOrM289(_), scheme_check_proc_arity ("make-input-port" , 0 , 3 , argc , argv ) ); 
  if (argc > 4 )
    FUNCCALL(SETUP_XfOrM289(_), scheme_check_proc_arity2 ("make-input-port" , 0 , 4 , argc , argv , 1 ) ); 
  if (argc > 5 )
    FUNCCALL(SETUP_XfOrM289(_), scheme_check_proc_arity2 ("make-input-port" , 3 , 5 , argc , argv , 1 ) ); 
  if (argc > 6 )
    FUNCCALL(SETUP_XfOrM289(_), scheme_check_proc_arity2 ("make-input-port" , 0 , 6 , argc , argv , 1 ) ); 
  if (argc > 7 )
    FUNCCALL(SETUP_XfOrM289(_), scheme_check_proc_arity ("make-input-port" , 0 , 7 , argc , argv ) ); 
  if (argc > 8 ) {
#   define XfOrM294_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM294(x) SETUP_XfOrM289(x)

# 2339 "bc/src/portfun.c"
    if (! (((((intptr_t ) (argv [8 ] ) ) & 0x1 ) && (((intptr_t ) (argv [8 ] ) ) >> 1 ) > 0 ) 
    || (((Scheme_Type ) (((((intptr_t ) (argv [8 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [8 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [8 ] ) -> iso ) -> so . keyex & 0x1 ) ) 
    || (((argv [8 ] ) ) == (scheme_false ) ) 
    || FUNCCALL(SETUP_XfOrM294(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 8 , argc , argv ) )
    || (scheme_is_input_port (argv [8 ] ) ) 
    || (scheme_is_output_port (argv [8 ] ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-input-port" , "(or/c exact-positive-integer? port? #f (-> (or/c exact-positive-integer? #f)))" , 8 , argc , argv ) ); 
  }
  if (argc > 9 ) {
#   define XfOrM293_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM293(x) SETUP_XfOrM289(x)

# 2348 "bc/src/portfun.c"
    if ((! (((argv [9 ] ) ) == (scheme_false ) ) ) 
    && ! FUNCCALL(SETUP_XfOrM293(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 9 , argc , argv ) )
    && ! FUNCCALL(SETUP_XfOrM293(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 9 , argc , argv ) ))
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-input-port" , "(case-> (-> any)  (any/c . -> . any))" , 9 , argc , argv ) ); 
  }
  name = argv [0 ] ; 


  if (! ! read_port != ! ! peek_port ) {
#   define XfOrM292_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM292(x) SETUP_XfOrM289(x)
    FUNCCALL_EMPTY(scheme_contract_error ("make-input-port" , (read_port ? "read argument is an input port, but peek argument is not a port" : "read argument is not an input port, but peek argument is a port" ) , "read argument" , 1 , argv [1 ] , "peek argument" , 1 , argv [2 ] , ((void * ) 0 ) ) )



    ; 
  }


  if ((argc > 5 ) && (((argv [2 ] ) ) == (scheme_false ) ) && ! (((argv [4 ] ) ) == (scheme_false ) ) )
    FUNCCALL_EMPTY(scheme_contract_error ("make-input-port" , "peek argument is #f, but progress-evt argument is not" , "progress evt" , 1 , argv [4 ] , ((void * ) 0 ) ) )


  ; 


  if ((argc > 5 ) && (((argv [4 ] ) ) == (scheme_false ) ) && ! (((argv [5 ] ) ) == (scheme_false ) ) )
    FUNCCALL_EMPTY(scheme_contract_error ("make-input-port" , "progress-evt argument is #f, but commit argument is not" , "commit" , 1 , argv [6 ] , ((void * ) 0 ) ) )


  ; 

  if ((argc > 4 ) && ! (((argv [4 ] ) ) == (scheme_false ) ) && ((argc < 6 ) || (((argv [5 ] ) ) == (scheme_false ) ) ) )
    FUNCCALL_EMPTY(scheme_contract_error ("make-input-port" , "commit argument is #f, but progress-evt argument is not" , "progress evt" , 1 , argv [4 ] , ((void * ) 0 ) ) )


  ; 

  uip = ((User_Input_Port * ) FUNCCALL(SETUP_XfOrM289(_), GC_malloc_one_small_tagged ((((sizeof (User_Input_Port ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  uip -> type = scheme_rt_user_input ; 


  uip -> read_proc = argv [1 ] ; 
  uip -> peek_proc = argv [2 ] ; 
  if (((uip -> peek_proc ) ) == (scheme_false ) ) 
    uip -> peek_proc = ((void * ) 0 ) ; 
  uip -> close_proc = argv [3 ] ; 
  uip -> progress_evt_proc = ((argc > 4 ) ? argv [4 ] : scheme_false ) ; 
  if (((uip -> progress_evt_proc ) ) == (scheme_false ) ) 
    uip -> progress_evt_proc = ((void * ) 0 ) ; 
  uip -> peeked_read_proc = ((argc > 5 ) ? argv [5 ] : scheme_false ) ; 
  if (((uip -> peeked_read_proc ) ) == (scheme_false ) ) 
    uip -> peeked_read_proc = ((void * ) 0 ) ; 
  uip -> location_proc = ((argc > 6 ) ? argv [6 ] : scheme_false ) ; 
  if (((uip -> location_proc ) ) == (scheme_false ) ) 
    uip -> location_proc = ((void * ) 0 ) ; 
  if (argc > 7 )
    uip -> count_lines_proc = argv [7 ] ; 
  uip -> buffer_mode_proc = ((argc > 9 ) ? argv [9 ] : scheme_false ) ; 
  if (((uip -> buffer_mode_proc ) ) == (scheme_false ) ) 
    uip -> buffer_mode_proc = ((void * ) 0 ) ; 

  ip = FUNCCALL(SETUP_XfOrM289(_), scheme_make_input_port (scheme_user_input_port_type , uip , name , user_get_bytes , uip -> peek_proc ? user_peek_bytes : ((void * ) 0 ) , uip -> progress_evt_proc ? user_progress_evt : ((void * ) 0 ) , uip -> peeked_read_proc ? user_peeked_read : ((void * ) 0 ) , user_byte_ready , user_close_input , user_needs_wakeup_input , 0 ) )
# 2421 "bc/src/portfun.c"
  ; 

  if (uip -> location_proc )
    FUNCCALL(SETUP_XfOrM289(_), scheme_set_port_location_fun ((Scheme_Port * ) ip , user_input_location ) ); 
  if (uip -> count_lines_proc )
    FUNCCALL(SETUP_XfOrM289(_), scheme_set_port_count_lines_fun ((Scheme_Port * ) ip , user_input_count_lines ) ); 

  if (! uip -> peek_proc )
    ip -> pending_eof = 1 ; 

  if (argc > 8 ) {
    if (((intptr_t ) (argv [8 ] ) ) & 0x1 ) 
      ip -> p . position = ((((intptr_t ) (argv [8 ] ) ) >> 1 ) - 1 ) ; 
    else if ((((argv [8 ] ) ) == (scheme_false ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [8 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [8 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
      ip -> p . position = - 1 ; 
    else {
      ip -> p . position = 0 ; 
      ip -> p . position_redirect = argv [8 ] ; 
    }
  }

  if (uip -> buffer_mode_proc )
    ip -> p . buffer_mode_fun = user_input_buffer_mode ; 

  if (ip -> p . count_lines && uip -> count_lines_proc )
    FUNCCALL(SETUP_XfOrM289(_), scheme_apply_multi (uip -> count_lines_proc , 0 , ((void * ) 0 ) ) ); 

  RET_VALUE_START ((Scheme_Object * ) ip ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2451 "bc/src/portfun.c"
static Scheme_Object * 
make_output_port (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Output_Port * op ; 
  User_Output_Port * uop ; 
  Scheme_Object * name ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(uop, 1), PUSH(argv, 2), PUSH(op, 3)));
# define XfOrM297_COUNT (4)
# define SETUP_XfOrM297(x) SETUP(XfOrM297_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 
  uop = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 2458 "bc/src/portfun.c"
  if (! FUNCCALL(SETUP_XfOrM297(_), scheme_is_evt (argv [1 ] ) )) {
#   define XfOrM307_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM307(x) SETUP_XfOrM297(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-output-port" , "evt?" , 1 , argc , argv ) )
# 2459 "bc/src/portfun.c"
    ; 
  }
  if (! (scheme_is_output_port (argv [2 ] ) ) 
  && ! FUNCCALL(SETUP_XfOrM297(_), scheme_check_proc_arity (((void * ) 0 ) , 5 , 2 , argc , argv ) )) {
#   define XfOrM306_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM306(x) SETUP_XfOrM297(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-output-port" , "(or/c (procedure-arity-includes/c 5) output-port?)" , 2 , argc , argv ) ); 
  }
  FUNCCALL(SETUP_XfOrM297(_), scheme_check_proc_arity ("make-output-port" , 0 , 3 , argc , argv ) ); 
  if (argc > 4 ) {
#   define XfOrM304_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM304(x) SETUP_XfOrM297(x)

# 2469 "bc/src/portfun.c"
    if (! (((argv [4 ] ) ) == (scheme_false ) ) 
    && ! (scheme_is_output_port (argv [2 ] ) ) 
    && ! FUNCCALL(SETUP_XfOrM304(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 4 , argc , argv ) )) {
#     define XfOrM305_COUNT (0+XfOrM304_COUNT)
#     define SETUP_XfOrM305(x) SETUP_XfOrM304(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-output-port" , "(or/c (procedure-arity-includes/c 3) output-port?)" , 4 , argc , argv ) ); 
    }
  }
  if (argc > 5 )
    FUNCCALL(SETUP_XfOrM297(_), scheme_check_proc_arity2 ("make-output-port" , 3 , 5 , argc , argv , 1 ) ); 
  if (argc > 6 )
    FUNCCALL(SETUP_XfOrM297(_), scheme_check_proc_arity2 ("make-output-port" , 1 , 6 , argc , argv , 1 ) ); 
  if (argc > 7 )
    FUNCCALL(SETUP_XfOrM297(_), scheme_check_proc_arity2 ("make-output-port" , 0 , 7 , argc , argv , 1 ) ); 
  if (argc > 8 )
    FUNCCALL(SETUP_XfOrM297(_), scheme_check_proc_arity ("make-output-port" , 0 , 8 , argc , argv ) ); 
  if (argc > 9 ) {
#   define XfOrM303_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM303(x) SETUP_XfOrM297(x)

# 2486 "bc/src/portfun.c"
    if (! (((((intptr_t ) (argv [9 ] ) ) & 0x1 ) && (((intptr_t ) (argv [9 ] ) ) >> 1 ) > 0 ) 
    || (((Scheme_Type ) (((((intptr_t ) (argv [9 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [9 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [9 ] ) -> iso ) -> so . keyex & 0x1 ) ) 
    || (((argv [9 ] ) ) == (scheme_false ) ) 
    || FUNCCALL(SETUP_XfOrM303(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 9 , argc , argv ) )
    || (scheme_is_input_port (argv [9 ] ) ) 
    || (scheme_is_output_port (argv [9 ] ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-output-port" , "(or/c exact-positive-integer? port? #f (-> (or/c exact-positive-integer? #f)))" , 9 , argc , argv ) ); 
  }
  if (argc > 10 ) {
#   define XfOrM302_COUNT (0+XfOrM297_COUNT)
#   define SETUP_XfOrM302(x) SETUP_XfOrM297(x)

# 2495 "bc/src/portfun.c"
    if ((! (((argv [10 ] ) ) == (scheme_false ) ) ) 
    && ! FUNCCALL(SETUP_XfOrM302(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 10 , argc , argv ) )
    && ! FUNCCALL(SETUP_XfOrM302(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 10 , argc , argv ) ))
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-output-port" , "(case-> (-> any)  (any/c . -> . any))" , 10 , argc , argv ) ); 
  }


  if ((argc > 6 ) && (((argv [4 ] ) ) == (scheme_false ) ) && ! (((argv [6 ] ) ) == (scheme_false ) ) )
    FUNCCALL_EMPTY(scheme_contract_error ("make-output-port" , "write-special argument is #f, but write-special-evt argument is not" , "write-special evt" , 1 , argv [6 ] , ((void * ) 0 ) ) )


  ; 


  if ((argc > 6 ) && (((argv [5 ] ) ) == (scheme_false ) ) && ! (((argv [6 ] ) ) == (scheme_false ) ) )
    FUNCCALL_EMPTY(scheme_contract_error ("make-output-port" , "write-evt argument is #f, but write-special-evt argument is not" , "write-special evt" , 1 , argv [6 ] , ((void * ) 0 ) ) )


  ; 



  if ((argc > 5 ) && ! (((argv [5 ] ) ) == (scheme_false ) ) 
  && ((argc < 7 ) || (((argv [6 ] ) ) == (scheme_false ) ) ) 
  && ! (((argv [4 ] ) ) == (scheme_false ) ) )
    FUNCCALL_EMPTY(scheme_contract_error ("make-output-port" , "write-special-evt argument is #f, but write-evt argument is not, and write-special argument is not" , "write evt" , 1 , argv [4 ] , "write-special evt" , 1 , argv [6 ] , ((void * ) 0 ) ) )



  ; 
  name = argv [0 ] ; 

  uop = ((User_Output_Port * ) FUNCCALL(SETUP_XfOrM297(_), GC_malloc_one_small_tagged ((((sizeof (User_Output_Port ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  uop -> type = scheme_rt_user_output ; 


  uop -> evt = argv [1 ] ; 
  uop -> write_proc = argv [2 ] ; 
  uop -> close_proc = argv [3 ] ; 
  uop -> write_evt_proc = ((argc > 5 ) ? argv [5 ] : scheme_false ) ; 
  if (((uop -> write_evt_proc ) ) == (scheme_false ) ) 
    uop -> write_evt_proc = ((void * ) 0 ) ; 
  if ((argc < 5 ) || (((argv [4 ] ) ) == (scheme_false ) ) ) {
    uop -> write_special_proc = ((void * ) 0 ) ; 
    uop -> write_special_evt_proc = ((void * ) 0 ) ; 
  }

# 2541 "bc/src/portfun.c"
  else {
    uop -> write_special_proc = argv [4 ] ; 
    uop -> write_special_evt_proc = ((argc > 6 ) ? argv [6 ] : scheme_false ) ; 
    if (((uop -> write_special_evt_proc ) ) == (scheme_false ) ) 
      uop -> write_special_evt_proc = ((void * ) 0 ) ; 
  }
  if ((argc > 7 ) && (! (((argv [7 ] ) ) == (scheme_false ) ) ) )
    uop -> location_proc = argv [7 ] ; 
  if (argc > 8 )
    uop -> count_lines_proc = argv [8 ] ; 
  if ((argc > 10 ) && (! (((argv [10 ] ) ) == (scheme_false ) ) ) )
    uop -> buffer_mode_proc = argv [10 ] ; 

  op = FUNCCALL(SETUP_XfOrM297(_), scheme_make_output_port (scheme_user_output_port_type , uop , name , uop -> write_evt_proc ? user_write_bytes_evt : ((void * ) 0 ) , user_write_bytes , user_write_ready , user_close_output , user_needs_wakeup_output , uop -> write_special_evt_proc ? user_write_special_evt : ((void * ) 0 ) , uop -> write_special_proc ? user_write_special : ((void * ) 0 ) , 0 ) )
# 2564 "bc/src/portfun.c"
  ; 

  if (uop -> location_proc )
    FUNCCALL(SETUP_XfOrM297(_), scheme_set_port_location_fun ((Scheme_Port * ) op , user_output_location ) ); 
  if (uop -> count_lines_proc )
    FUNCCALL(SETUP_XfOrM297(_), scheme_set_port_count_lines_fun ((Scheme_Port * ) op , user_output_count_lines ) ); 

  if (argc > 9 ) {
    if (((intptr_t ) (argv [9 ] ) ) & 0x1 ) 
      op -> p . position = ((((intptr_t ) (argv [9 ] ) ) >> 1 ) - 1 ) ; 
    else if ((((argv [9 ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [9 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [9 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
      op -> p . position = - 1 ; 
    else {
      op -> p . position = 0 ; 
      op -> p . position_redirect = argv [9 ] ; 
    }
  }

  if (uop -> buffer_mode_proc )
    op -> p . buffer_mode_fun = user_output_buffer_mode ; 

  if (op -> p . count_lines && uop -> count_lines_proc )
    FUNCCALL(SETUP_XfOrM297(_), scheme_apply_multi (uop -> count_lines_proc , 0 , ((void * ) 0 ) ) ); 

  RET_VALUE_START ((Scheme_Object * ) op ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2591 "bc/src/portfun.c"
static Scheme_Object * 
open_input_file (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2594 "bc/src/portfun.c"
  return scheme_do_open_input_file ("open-input-file" , 0 , argc , argv , 0 , 0 ) ; 
}

static Scheme_Object * 
open_input_byte_string (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * o ; 
  intptr_t len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1)));
# define XfOrM309_COUNT (2)
# define SETUP_XfOrM309(x) SETUP(XfOrM309_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 2603 "bc/src/portfun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("open-input-bytes" , "bytes?" , 0 , argc , argv ) ); 

  len = (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . tag_val ) ; 
  if (((Scheme_Inclhash_Object * ) (argv [0 ] ) ) -> so . keyex & 0x1 ) 
    len = - len ; 

  o = FUNCCALL(SETUP_XfOrM309(_), scheme_make_sized_byte_string_input_port ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . string_val ) , len ) )
  ; 
  if (argc > 1 )
    ((Scheme_Input_Port * ) o ) -> name = argv [1 ] ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2618 "bc/src/portfun.c"
static Scheme_Object * 
open_input_char_string (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1)));
# define XfOrM310_COUNT (2)
# define SETUP_XfOrM310(x) SETUP(XfOrM310_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 2623 "bc/src/portfun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("open-input-string" , "string?" , 0 , argc , argv ) ); 

  o = FUNCCALL(SETUP_XfOrM310(_), scheme_char_string_to_byte_string (argv [0 ] ) ); 

  o = FUNCCALL_AGAIN(scheme_make_sized_byte_string_input_port ((((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) , - (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . tag_val ) ) )
  ; 

  if (argc > 1 )
    ((Scheme_Input_Port * ) o ) -> name = argv [1 ] ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2637 "bc/src/portfun.c"
static Scheme_Object * 
open_output_file (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2640 "bc/src/portfun.c"
  return scheme_do_open_output_file ("open-output-file" , 0 , argc , argv , 0 , 0 ) ; 
}

static Scheme_Object * 
open_input_output_file (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2646 "bc/src/portfun.c"
  return scheme_do_open_output_file ("open-input-output-file" , 0 , argc , argv , 1 , 0 ) ; 
}

static Scheme_Object * 
open_output_string (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(o, 1)));
# define XfOrM313_COUNT (2)
# define SETUP_XfOrM313(x) SETUP(XfOrM313_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 2654 "bc/src/portfun.c"
  o = FUNCCALL(SETUP_XfOrM313(_), scheme_make_byte_string_output_port () ); 

  if (argc )
    ((Scheme_Output_Port * ) o ) -> name = argv [0 ] ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2662 "bc/src/portfun.c"
Scheme_Object * do_get_output_string (const char * who , int is_byte , 
int argc , Scheme_Object * argv [] ) 
{
  Scheme_Output_Port * op ; 
  char * s ; 
  intptr_t size , startpos , endpos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(who, 1), PUSH(argv, 2), PUSH(op, 3)));
# define XfOrM314_COUNT (4)
# define SETUP_XfOrM314(x) SETUP(XfOrM314_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 2669 "bc/src/portfun.c"
  op = FUNCCALL(SETUP_XfOrM314(_), scheme_output_port_record (argv [0 ] ) ); 
  if (! (scheme_is_output_port (argv [0 ] ) ) 
  || (op -> sub_type != scheme_string_output_port_type ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "(and/c output-port? string-port?)" , 0 , argc , argv ) ); 

  if (argc > 2 ) {
    intptr_t len ; 
    Scheme_Indexed_String * is ; 
#   define XfOrM316_COUNT (0+XfOrM314_COUNT)
#   define SETUP_XfOrM316(x) SETUP_XfOrM314(x)
    is = NULLED_OUT ; 

# 2678 "bc/src/portfun.c"
    is = (Scheme_Indexed_String * ) op -> port_data ; 
    len = is -> index ; 
    if (is -> u . hot > len )
      len = is -> u . hot ; 

    startpos = FUNCCALL(SETUP_XfOrM316(_), scheme_extract_index (who , 2 , argc , argv , len + 1 , 0 ) ); 
    if (argc > 3 ) {
#     define XfOrM319_COUNT (0+XfOrM316_COUNT)
#     define SETUP_XfOrM319(x) SETUP_XfOrM316(x)

# 2685 "bc/src/portfun.c"
      if (((argv [3 ] ) ) == (scheme_false ) ) 
        endpos = len ; 
      else {
#       define XfOrM322_COUNT (0+XfOrM319_COUNT)
#       define SETUP_XfOrM322(x) SETUP_XfOrM319(x)

# 2688 "bc/src/portfun.c"
        endpos = FUNCCALL(SETUP_XfOrM322(_), scheme_extract_index (who , 3 , argc , argv , len + 1 , 1 ) ); 
        if (endpos < 0 )
          endpos = len + 1 ; 
      }

      if (! (startpos <= len ) ) {
#       define XfOrM321_COUNT (0+XfOrM319_COUNT)
#       define SETUP_XfOrM321(x) SETUP_XfOrM319(x)
        FUNCCALL(SETUP_XfOrM321(_), scheme_out_of_range (who , "port" , "starting " , argv [2 ] , argv [0 ] , 0 , len ) )
# 2694 "bc/src/portfun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      if (! (endpos >= startpos && endpos <= len ) ) {
#       define XfOrM320_COUNT (0+XfOrM319_COUNT)
#       define SETUP_XfOrM320(x) SETUP_XfOrM319(x)
        FUNCCALL(SETUP_XfOrM320(_), scheme_out_of_range (who , "port" , "ending " , argv [3 ] , argv [0 ] , startpos , len ) )
# 2698 "bc/src/portfun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 2701 "bc/src/portfun.c"
    else {
#     define XfOrM317_COUNT (0+XfOrM316_COUNT)
#     define SETUP_XfOrM317(x) SETUP_XfOrM316(x)

# 2702 "bc/src/portfun.c"
      if (! (startpos <= len ) ) {
#       define XfOrM318_COUNT (0+XfOrM317_COUNT)
#       define SETUP_XfOrM318(x) SETUP_XfOrM317(x)
        FUNCCALL(SETUP_XfOrM318(_), scheme_out_of_range (who , "port" , "starting " , argv [2 ] , argv [0 ] , 0 , len ) )
# 2703 "bc/src/portfun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      endpos = - 1 ; 
    }
  }

# 2708 "bc/src/portfun.c"
  else {
    startpos = 0 ; 
    endpos = - 1 ; 
  }

  s = FUNCCALL(SETUP_XfOrM314(_), scheme_get_reset_sized_byte_string_output (argv [0 ] , & size , ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) , startpos , endpos ) )

  ; 

  if (is_byte )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string (s , size , 0 ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (s , size ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2723 "bc/src/portfun.c"
static Scheme_Object * 
get_output_byte_string (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2726 "bc/src/portfun.c"
  return do_get_output_string ("get-output-bytes" , 1 , argc , argv ) ; 
}

static Scheme_Object * 
get_output_char_string (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2732 "bc/src/portfun.c"
  return do_get_output_string ("get-output-string" , 0 , argc , argv ) ; 
}

static Scheme_Object * 
string_port_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * p = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(argv, 1)));
# define XfOrM325_COUNT (2)
# define SETUP_XfOrM325(x) SETUP(XfOrM325_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2740 "bc/src/portfun.c"
  if (scheme_is_input_port (p ) )  {
#   define XfOrM328_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM328(x) SETUP_XfOrM325(x)

# 2741 "bc/src/portfun.c"
    if ((FUNCCALL(SETUP_XfOrM328(_), scheme_input_port_record (p ) )-> sub_type ) == (scheme_string_input_port_type ) ) 

    RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  }

# 2744 "bc/src/portfun.c"
  else if (scheme_is_output_port (p ) )  {
#   define XfOrM327_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM327(x) SETUP_XfOrM325(x)

# 2745 "bc/src/portfun.c"
    if ((FUNCCALL(SETUP_XfOrM327(_), scheme_output_port_record (p ) )-> sub_type ) == (scheme_string_output_port_type ) ) 

    RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  }

# 2748 "bc/src/portfun.c"
  else {
#   define XfOrM326_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM326(x) SETUP_XfOrM325(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("string-port?" , "port?" , 0 , argc , argv ) )
# 2749 "bc/src/portfun.c"
    ; 
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2755 "bc/src/portfun.c"
static Scheme_Object * 
close_input_port (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2758 "bc/src/portfun.c"
  if (! scheme_is_input_port (argv [0 ] ) )
    scheme_wrong_contract ("close-input-port" , "input-port?" , 0 , argc , argv ) ; 

  scheme_close_input_port (argv [0 ] ) ; 
  return (scheme_void ) ; 
}

static Scheme_Object * 
close_output_port (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2768 "bc/src/portfun.c"
  if (! scheme_is_output_port (argv [0 ] ) )
    scheme_wrong_contract ("close-output-port" , "output-port?" , 0 , argc , argv ) ; 

  scheme_close_output_port (argv [0 ] ) ; 
  return (scheme_void ) ; 
}

static Scheme_Object * 
call_with_output_file (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * port , * v , * * m ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(p, 1), PUSH(port, 2), PUSH(m, 3), PUSH(argv, 4)));
# define XfOrM331_COUNT (5)
# define SETUP_XfOrM331(x) SETUP(XfOrM331_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 
  v = NULLED_OUT ; 
  m = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM331(_), scheme_check_proc_arity ("call-with-output-file" , 1 , 1 , argc , argv ) )
# 2781 "bc/src/portfun.c"
  ; 

  port = FUNCCALL_AGAIN(scheme_do_open_output_file ("call-with-output-file" , 1 , argc , argv , 0 , 0 ) ); 

  v = FUNCCALL_AGAIN(scheme_do_eval (argv [1 ] , 1 , & port , - 1 ) ); 

  m = p -> ku . multiple . array ; 
  if (v == ((Scheme_Object * ) 0x6 ) ) {
    if ((m ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
  }
  FUNCCALL(SETUP_XfOrM331(_), scheme_close_output_port (port ) )
  ; 

  p -> ku . multiple . array = m ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2800 "bc/src/portfun.c"
static Scheme_Object * 
call_with_input_file (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * port , * v , * * m ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(p, 1), PUSH(port, 2), PUSH(m, 3), PUSH(argv, 4)));
# define XfOrM333_COUNT (5)
# define SETUP_XfOrM333(x) SETUP(XfOrM333_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 
  v = NULLED_OUT ; 
  m = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM333(_), scheme_check_proc_arity ("call-with-input-file" , 1 , 1 , argc , argv ) )
# 2806 "bc/src/portfun.c"
  ; 

  port = FUNCCALL_AGAIN(scheme_do_open_input_file ("call-with-input-file" , 1 , argc , argv , 0 , 0 ) ); 

  v = FUNCCALL_AGAIN(scheme_do_eval (argv [1 ] , 1 , & port , - 1 ) ); 

  m = p -> ku . multiple . array ; 
  if (v == ((Scheme_Object * ) 0x6 ) ) {
    if ((m ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
  }
  FUNCCALL(SETUP_XfOrM333(_), scheme_close_input_port (port ) )
  ; 

  p -> ku . multiple . array = m ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2825 "bc/src/portfun.c"
static Scheme_Object * with_call_thunk (void * d ) 
{
  /* No conversion */

# 2827 "bc/src/portfun.c"
  return scheme_do_eval ((((Scheme_Simple_Object * ) ((Scheme_Object * ) d ) ) -> u . pair_val . car ) , 0 , ((void * ) 0 ) , - 1 ) ; 
}

static void with_close_output (void * d ) 
{
  /* No conversion */

# 2832 "bc/src/portfun.c"
  scheme_close_output_port ((((Scheme_Simple_Object * ) ((Scheme_Object * ) d ) ) -> u . pair_val . cdr ) ) ; 
}


static Scheme_Object * 
with_output_to_file (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port , * v ; 
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Config * config ; 
  Scheme_Config * __funcarg170 = NULLED_OUT ; 
  Scheme_Object * __funcarg169 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(config, 1), PUSH(port, 2), PUSH(cframe.cache, 3), PUSH(argv, 4)));
# define XfOrM337_COUNT (5)
# define SETUP_XfOrM337(x) SETUP(XfOrM337_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 
  v = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  config = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM337(_), scheme_check_proc_arity ("with-output-to-file" , 0 , 1 , argc , argv ) )
# 2843 "bc/src/portfun.c"
  ; 

  port = FUNCCALL_AGAIN(scheme_do_open_output_file ("with-output-to-file" , 1 , argc , argv , 0 , 0 ) ); 

  config = (__funcarg170 = FUNCCALL(SETUP_XfOrM337(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_extend_config (__funcarg170 , MZCONFIG_OUTPUT_PORT , port ) )) 

  ; 
  FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )
  ; 
  FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_parameterization_key , (Scheme_Object * ) config ) ); 

  v = (__funcarg169 = FUNCCALL(SETUP_XfOrM337(_), scheme_make_pair (argv [1 ] , port ) ), FUNCCALL_AGAIN(scheme_dynamic_wind (((void * ) 0 ) , with_call_thunk , with_close_output , ((void * ) 0 ) , __funcarg169 ) )) 



  ; 
  FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) )
  ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2865 "bc/src/portfun.c"
static void with_close_input (void * d ) 
{
  /* No conversion */

# 2867 "bc/src/portfun.c"
  scheme_close_input_port ((((Scheme_Simple_Object * ) ((Scheme_Object * ) d ) ) -> u . pair_val . cdr ) ) ; 
}

static Scheme_Object * 
with_input_from_file (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port , * v ; 
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Config * config ; 
  Scheme_Config * __funcarg172 = NULLED_OUT ; 
  Scheme_Object * __funcarg171 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(config, 1), PUSH(port, 2), PUSH(cframe.cache, 3), PUSH(argv, 4)));
# define XfOrM339_COUNT (5)
# define SETUP_XfOrM339(x) SETUP(XfOrM339_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 
  v = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  config = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM339(_), scheme_check_proc_arity ("with-input-from-file" , 0 , 1 , argc , argv ) )
# 2877 "bc/src/portfun.c"
  ; 

  port = FUNCCALL_AGAIN(scheme_do_open_input_file ("with-input-from-file" , 1 , argc , argv , 0 , 0 ) ); 

  config = (__funcarg172 = FUNCCALL(SETUP_XfOrM339(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_extend_config (__funcarg172 , MZCONFIG_INPUT_PORT , port ) )) 

  ; 
  FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )
  ; 
  FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_parameterization_key , (Scheme_Object * ) config ) ); 

  v = (__funcarg171 = FUNCCALL(SETUP_XfOrM339(_), scheme_make_pair (argv [1 ] , port ) ), FUNCCALL_AGAIN(scheme_dynamic_wind (((void * ) 0 ) , with_call_thunk , with_close_input , ((void * ) 0 ) , __funcarg171 ) )) 



  ; 
  FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) )
  ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2899 "bc/src/portfun.c"
static Scheme_Object * sch_default_read_handler (void * ignore , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * src ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(src, 0), PUSH(argv, 1)));
# define XfOrM340_COUNT (2)
# define SETUP_XfOrM340(x) SETUP(XfOrM340_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  src = NULLED_OUT ; 

# 2903 "bc/src/portfun.c"
  if (! (scheme_is_input_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-port-read-handler" , "input-port?" , 0 , argc , argv ) ); 

  if ((Scheme_Object * ) argv [0 ] == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) )
    FUNCCALL(SETUP_XfOrM340(_), scheme_flush_orig_outputs () ); 

  if (argc > 1 )
    src = argv [1 ] ; 
  else 
  src = ((void * ) 0 ) ; 

  if (src )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_read_syntax (argv [0 ] , src ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_read (argv [0 ] ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2920 "bc/src/portfun.c"
static Scheme_Object * 
do_read_char (char * name , int argc , Scheme_Object * argv [] , int peek , int spec , int is_byte ) 
{
  Scheme_Object * port ; 
  Scheme_Object * skip , * unless_evt , * src , * spec_wrap ; 
  int ch , pos ; 
  Scheme_Config * __funcarg173 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(port, 1), PUSH(skip, 2), PUSH(unless_evt, 3), PUSH(src, 4), PUSH(spec_wrap, 5), PUSH(argv, 6)));
# define XfOrM341_COUNT (7)
# define SETUP_XfOrM341(x) SETUP(XfOrM341_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  port = NULLED_OUT ; 
  skip = NULLED_OUT ; 
  unless_evt = NULLED_OUT ; 
  src = NULLED_OUT ; 
  spec_wrap = NULLED_OUT ; 

# 2927 "bc/src/portfun.c"
  if (argc && ! (scheme_is_input_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "input-port?" , 0 , argc , argv ) ); 

  if (argc )
    port = argv [0 ] ; 
  else 
  port = (__funcarg173 = FUNCCALL(SETUP_XfOrM341(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg173 , MZCONFIG_INPUT_PORT ) )) ; 

  if (peek ) {
#   define XfOrM356_COUNT (0+XfOrM341_COUNT)
#   define SETUP_XfOrM356(x) SETUP_XfOrM341(x)

# 2936 "bc/src/portfun.c"
    unless_evt = ((void * ) 0 ) ; 
    if (argc > 1 ) {
#     define XfOrM357_COUNT (0+XfOrM356_COUNT)
#     define SETUP_XfOrM357(x) SETUP_XfOrM356(x)

# 2938 "bc/src/portfun.c"
      skip = argv [1 ] ; 
      if (! ((((intptr_t ) (skip ) ) & 0x1 ) && ((((intptr_t ) (skip ) ) >> 1 ) >= 0 ) ) 
      && ! (((Scheme_Type ) (((((intptr_t ) (skip ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (skip ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) skip ) -> iso ) -> so . keyex & 0x1 ) ) ) {
#       define XfOrM362_COUNT (0+XfOrM357_COUNT)
#       define SETUP_XfOrM362(x) SETUP_XfOrM357(x)
        FUNCCALL_EMPTY(scheme_wrong_contract (name , "exact-nonnegative-integer?" , 1 , argc , argv ) )
# 2941 "bc/src/portfun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      if (is_byte && (argc > 2 ) ) {
#       define XfOrM358_COUNT (0+XfOrM357_COUNT)
#       define SETUP_XfOrM358(x) SETUP_XfOrM357(x)

# 2945 "bc/src/portfun.c"
        if (! (((argv [2 ] ) ) == (scheme_false ) ) )  {
#         define XfOrM359_COUNT (0+XfOrM358_COUNT)
#         define SETUP_XfOrM359(x) SETUP_XfOrM358(x)

# 2946 "bc/src/portfun.c"
          unless_evt = argv [2 ] ; 
          if (! ((Scheme_Type ) (((((intptr_t ) (unless_evt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (unless_evt ) ) -> type ) ) == (Scheme_Type ) (scheme_progress_evt_type ) ) ) {
#           define XfOrM361_COUNT (0+XfOrM359_COUNT)
#           define SETUP_XfOrM361(x) SETUP_XfOrM359(x)
            FUNCCALL_EMPTY(scheme_wrong_contract (name , "progress-evt?" , 2 , argc , argv ) )
# 2948 "bc/src/portfun.c"
            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          if (! ((port ) == ((((Scheme_Simple_Object * ) (unless_evt ) ) -> u . two_ptr_val . ptr1 ) ) ) ) {
#           define XfOrM360_COUNT (0+XfOrM359_COUNT)
#           define SETUP_XfOrM360(x) SETUP_XfOrM359(x)
            FUNCCALL_EMPTY(scheme_contract_error (name , "evt is not a progress evt for the given port" , "evt" , 1 , unless_evt , "port" , 1 , port , ((void * ) 0 ) ) )

            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
        }
      }
    }

# 2961 "bc/src/portfun.c"
    else 
    skip = ((void * ) 0 ) ; 
  }

# 2963 "bc/src/portfun.c"
  else {
    unless_evt = ((void * ) 0 ) ; 
    skip = ((void * ) 0 ) ; 
  }

  pos = (peek ? (is_byte ? 3 : 2 ) : 1 ) ; 
  if (argc > pos ) {
#   define XfOrM352_COUNT (0+XfOrM341_COUNT)
#   define SETUP_XfOrM352(x) SETUP_XfOrM341(x)

# 2970 "bc/src/portfun.c"
    spec_wrap = argv [pos ] ; 
    if (((spec_wrap ) ) == (scheme_false ) ) 
      spec_wrap = ((void * ) 0 ) ; 
    else if (! (peek && ((spec_wrap ) == (special_symbol ) ) ) 
    && ! (scheme_fast_check_arity (spec_wrap , 1 ) ) ) {
#     define XfOrM353_COUNT (0+XfOrM352_COUNT)
#     define SETUP_XfOrM353(x) SETUP_XfOrM352(x)

# 2975 "bc/src/portfun.c"
      if (! FUNCCALL(SETUP_XfOrM353(_), scheme_check_proc_arity2 (((void * ) 0 ) , 1 , pos , argc , argv , 1 ) )) {
#       define XfOrM354_COUNT (0+XfOrM353_COUNT)
#       define SETUP_XfOrM354(x) SETUP_XfOrM353(x)
        FUNCCALL_EMPTY(scheme_wrong_contract (name , (peek ? "(or/c (any/c -> any/c) #f 'special)" : "(or/c (any/c -> any/c) #f)" ) , pos , argc , argv ) )

        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
    pos ++ ; 
    if (argc > pos )
      src = argv [pos ++ ] ; 
    else 
    src = scheme_false ; 
  }

# 2989 "bc/src/portfun.c"
  else {
    src = scheme_false ; 
    spec_wrap = ((void * ) 0 ) ; 
  }

  if (peek ) {
#   define XfOrM347_COUNT (0+XfOrM341_COUNT)
#   define SETUP_XfOrM347(x) SETUP_XfOrM341(x)

# 2995 "bc/src/portfun.c"
    if (spec ) {
#     define XfOrM349_COUNT (0+XfOrM347_COUNT)
#     define SETUP_XfOrM349(x) SETUP_XfOrM347(x)

# 2996 "bc/src/portfun.c"
      if (is_byte ) {
#       define XfOrM350_COUNT (0+XfOrM349_COUNT)
#       define SETUP_XfOrM350(x) SETUP_XfOrM349(x)

# 2997 "bc/src/portfun.c"
        ch = FUNCCALL(SETUP_XfOrM350(_), scheme_peek_byte_special_ok_skip (port , skip , unless_evt ) ); 
      }

# 2998 "bc/src/portfun.c"
      else 
      ch = FUNCCALL(SETUP_XfOrM349(_), scheme_peekc_special_ok_skip (port , skip ) ); 
    }

# 3000 "bc/src/portfun.c"
    else {
#     define XfOrM348_COUNT (0+XfOrM347_COUNT)
#     define SETUP_XfOrM348(x) SETUP_XfOrM347(x)

# 3001 "bc/src/portfun.c"
      if (is_byte )
        ch = FUNCCALL(SETUP_XfOrM348(_), scheme_peek_byte_skip (port , skip , unless_evt ) ); 
      else 
      ch = FUNCCALL(SETUP_XfOrM348(_), scheme_peekc_skip (port , skip ) ); 
    }
  }

# 3006 "bc/src/portfun.c"
  else {
#   define XfOrM344_COUNT (0+XfOrM341_COUNT)
#   define SETUP_XfOrM344(x) SETUP_XfOrM341(x)

# 3007 "bc/src/portfun.c"
    if (spec ) {
#     define XfOrM346_COUNT (0+XfOrM344_COUNT)
#     define SETUP_XfOrM346(x) SETUP_XfOrM344(x)

# 3008 "bc/src/portfun.c"
      if (is_byte )
        ch = FUNCCALL(SETUP_XfOrM346(_), scheme_get_byte_special_ok (port ) ); 
      else 
      ch = FUNCCALL(SETUP_XfOrM346(_), scheme_getc_special_ok (port ) ); 
    }

# 3012 "bc/src/portfun.c"
    else {
#     define XfOrM345_COUNT (0+XfOrM344_COUNT)
#     define SETUP_XfOrM345(x) SETUP_XfOrM344(x)

# 3013 "bc/src/portfun.c"
      if (is_byte )
        ch = FUNCCALL(SETUP_XfOrM345(_), scheme_get_byte (port ) ); 
      else 
      ch = FUNCCALL(SETUP_XfOrM345(_), scheme_getc (port ) ); 
    }
  }

  if (ch == (- 2 ) ) {
#   define XfOrM342_COUNT (0+XfOrM341_COUNT)
#   define SETUP_XfOrM342(x) SETUP_XfOrM341(x)

# 3021 "bc/src/portfun.c"
    if ((spec_wrap ) == (special_symbol ) ) 
      RET_VALUE_START (special_symbol ) RET_VALUE_END ; 
    src = FUNCCALL(SETUP_XfOrM342(_), scheme_get_ready_special (port , src , peek ) ); 
    if (spec_wrap ) {
      Scheme_Object * a [1 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM342_COUNT)));
#     define XfOrM343_COUNT (3+XfOrM342_COUNT)
#     define SETUP_XfOrM343(x) SETUP(XfOrM343_COUNT)
      a[0] = NULLED_OUT ; 

# 3026 "bc/src/portfun.c"
      a [0 ] = src ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM343(_), scheme_tail_apply (spec_wrap , 1 , a ) )) RET_VALUE_END ; 
    }

# 3028 "bc/src/portfun.c"
    else 
    RET_VALUE_START (src ) RET_VALUE_END ; 
  }

# 3030 "bc/src/portfun.c"
  else if (ch == (- 1 ) )
    RET_VALUE_START (scheme_eof ) RET_VALUE_END ; 
  else if (is_byte )
    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (ch ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (((((mzchar ) ch ) < 256 ) ? scheme_char_constants [(unsigned char ) (ch ) ] : FUNCCALL_EMPTY(scheme_make_char (ch ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3038 "bc/src/portfun.c"
static Scheme_Object * read_char_fast (Scheme_Object * port ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 3040 "bc/src/portfun.c"
  int ch ; 

  ch = scheme_getc (port ) ; 

  if (ch == (- 1 ) )
    return scheme_eof ; 
  else 
  return ((((mzchar ) ch ) < 256 ) ? scheme_char_constants [(unsigned char ) (ch ) ] : scheme_make_char (ch ) ) ; 
}

static Scheme_Object * 
read_char (int argc , Scheme_Object * argv [] ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 3053 "bc/src/portfun.c"
  if (argc && scheme_is_input_port (argv [0 ] ) )
    return read_char_fast (argv [0 ] ) ; 

  return do_read_char ("read-char" , argc , argv , 0 , 0 , 0 ) ; 
}

static Scheme_Object * 
read_char_spec (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3062 "bc/src/portfun.c"
  return do_read_char ("read-char-or-special" , argc , argv , 0 , 1 , 0 ) ; 
}

static Scheme_Object * 
peek_char (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3068 "bc/src/portfun.c"
  return do_read_char ("peek-char" , argc , argv , 1 , 0 , 0 ) ; 
}

static Scheme_Object * 
peek_char_spec (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3074 "bc/src/portfun.c"
  return do_read_char ("peek-char-or-special" , argc , argv , 1 , 1 , 0 ) ; 
}

static Scheme_Object * read_byte_fast (Scheme_Object * port ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 3079 "bc/src/portfun.c"
  int ch ; 

  ch = scheme_get_byte (port ) ; 

  if (ch == (- 1 ) )
    return scheme_eof ; 
  else 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (ch ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * 
read_byte (int argc , Scheme_Object * argv [] ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 3092 "bc/src/portfun.c"
  if (argc && scheme_is_input_port (argv [0 ] ) )
    return read_byte_fast (argv [0 ] ) ; 

  return do_read_char ("read-byte" , argc , argv , 0 , 0 , 1 ) ; 
}

static Scheme_Object * 
read_byte_spec (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3101 "bc/src/portfun.c"
  return do_read_char ("read-byte-or-special" , argc , argv , 0 , 1 , 1 ) ; 
}

static Scheme_Object * 
peek_byte (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3107 "bc/src/portfun.c"
  return do_read_char ("peek-byte" , argc , argv , 1 , 0 , 1 ) ; 
}

static Scheme_Object * 
peek_byte_spec (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3113 "bc/src/portfun.c"
  return do_read_char ("peek-byte-or-special" , argc , argv , 1 , 1 , 1 ) ; 
}

static Scheme_Object * 
do_read_line (int as_bytes , const char * who , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port ; 
  int ch , ascii ; 
  int crlf = 0 , cr = 0 , lf = 1 ; 
  char * buf , * oldbuf , onstack [32 ] ; 
  intptr_t size = 31 , oldsize , i = 0 ; 
  Scheme_Input_Port * ip ; 
  Scheme_Get_String_Fun gs ; 
  Scheme_Config * __funcarg174 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(oldbuf, 0), PUSH(port, 1), PUSH(who, 2), PUSH(ip, 3), PUSH(buf, 4)));
# define XfOrM373_COUNT (5)
# define SETUP_XfOrM373(x) SETUP(XfOrM373_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  port = NULLED_OUT ; 
  buf = NULLED_OUT ; 
  oldbuf = NULLED_OUT ; 
  ip = NULLED_OUT ; 

# 3127 "bc/src/portfun.c"
  if (argc && ! (scheme_is_input_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "input-port?" , 0 , argc , argv ) ); 

  if (argc > 1 ) {
    Scheme_Object * v = argv [1 ] ; 
#   define XfOrM408_COUNT (0+XfOrM373_COUNT)
#   define SETUP_XfOrM408(x) SETUP_XfOrM373(x)

# 3132 "bc/src/portfun.c"
    if ((v ) == (any_symbol ) )  {
      crlf = cr = lf = 1 ; 
    }

# 3134 "bc/src/portfun.c"
    else if ((v ) == (any_one_symbol ) )  {
      crlf = 0 ; 
      cr = lf = 1 ; 
    }

# 3137 "bc/src/portfun.c"
    else if ((v ) == (cr_symbol ) )  {
      crlf = lf = 0 ; 
      cr = 1 ; 
    }

# 3140 "bc/src/portfun.c"
    else if ((v ) == (lf_symbol ) )  {
      crlf = cr = 0 ; 
      lf = 1 ; 
    }

# 3143 "bc/src/portfun.c"
    else if ((v ) == (crlf_symbol ) )  {
      lf = cr = 0 ; 
      crlf = 1 ; 
    }

# 3146 "bc/src/portfun.c"
    else FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c 'any 'cr 'lf 'crlf)" , 1 , argc , argv ) )
    ; 
  }

  if (argc )
    port = argv [0 ] ; 
  else 
  port = (__funcarg174 = FUNCCALL(SETUP_XfOrM373(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg174 , MZCONFIG_INPUT_PORT ) )) ; 

  if ((Scheme_Object * ) port == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) )
    FUNCCALL(SETUP_XfOrM373(_), scheme_flush_orig_outputs () ); 

  buf = onstack ; 

  ip = FUNCCALL(SETUP_XfOrM373(_), scheme_input_port_record (port ) ); 
  gs = ip -> get_string_fun ; 
  ascii = 1 ; 

  while (1 ) {
#   define XfOrM394_COUNT (0+XfOrM373_COUNT)
#   define SETUP_XfOrM394(x) SETUP_XfOrM373(x)

# 3165 "bc/src/portfun.c"
    if (! ip -> slow ) {

      char s [1 ] ; 
#     define XfOrM405_COUNT (0+XfOrM394_COUNT)
#     define SETUP_XfOrM405(x) SETUP_XfOrM394(x)

# 3169 "bc/src/portfun.c"
      ch = FUNCCALL(SETUP_XfOrM405(_), gs (ip , s , 0 , 1 , 0 , ((void * ) 0 ) ) ); 

      if (ch == (- 2 ) ) {
#       define XfOrM407_COUNT (0+XfOrM405_COUNT)
#       define SETUP_XfOrM407(x) SETUP_XfOrM405(x)
        FUNCCALL(SETUP_XfOrM407(_), scheme_bad_time_for_special (who , port ) )
# 3172 "bc/src/portfun.c"
        ; 
      }

# 3173 "bc/src/portfun.c"
      else if (ch ) {
        if (ip -> p . position >= 0 )
          ip -> p . position ++ ; 

        if (ch != (- 1 ) )
          ch = ((unsigned char * ) s ) [0 ] ; 
      }

# 3179 "bc/src/portfun.c"
      else 
      ch = FUNCCALL(SETUP_XfOrM405(_), scheme_get_byte (port ) ); 
    }

# 3181 "bc/src/portfun.c"
    else {
#     define XfOrM404_COUNT (0+XfOrM394_COUNT)
#     define SETUP_XfOrM404(x) SETUP_XfOrM394(x)

# 3182 "bc/src/portfun.c"
      ch = FUNCCALL(SETUP_XfOrM404(_), scheme_get_byte (port ) ); 
    }

    if (ch == (- 1 ) ) {
      if (! i )
        RET_VALUE_START (scheme_eof ) RET_VALUE_END ; 
      break ; 
    }
    if (ch == '\r' ) {
#     define XfOrM399_COUNT (0+XfOrM394_COUNT)
#     define SETUP_XfOrM399(x) SETUP_XfOrM394(x)

# 3191 "bc/src/portfun.c"
      if (crlf ) {
        int ch2 ; 
#       define XfOrM401_COUNT (0+XfOrM399_COUNT)
#       define SETUP_XfOrM401(x) SETUP_XfOrM399(x)

# 3194 "bc/src/portfun.c"
        ch2 = FUNCCALL(SETUP_XfOrM401(_), scheme_peek_byte_skip (port , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) ); 
        if (ch2 == '\n' ) {
#         define XfOrM402_COUNT (0+XfOrM401_COUNT)
#         define SETUP_XfOrM402(x) SETUP_XfOrM401(x)
          FUNCCALL(SETUP_XfOrM402(_), scheme_get_byte (port ) )
# 3196 "bc/src/portfun.c"
          ; 
          break ; 
        }

# 3198 "bc/src/portfun.c"
        else if (cr )
          break ; 
      }

# 3200 "bc/src/portfun.c"
      else {
        if (cr )
          break ; 
      }
    }

# 3204 "bc/src/portfun.c"
    else if (ch == '\n' ) {
      if (lf )
        break ; 
    }

    if (i >= size ) {
#     define XfOrM397_COUNT (0+XfOrM394_COUNT)
#     define SETUP_XfOrM397(x) SETUP_XfOrM394(x)

# 3210 "bc/src/portfun.c"
      oldsize = size ; 
      oldbuf = buf ; 

      size *= 2 ; 
      buf = (char * ) FUNCCALL(SETUP_XfOrM397(_), GC_malloc_atomic (size + 1 ) ); 
      (memcpy (buf , oldbuf , oldsize ) ) ; 
    }
    buf [i ++ ] = ch ; 
    if (ch > 127 )

# 3218 "bc/src/portfun.c"
    ascii = 0 ; 

    {
#     define XfOrM395_COUNT (0+XfOrM394_COUNT)
#     define SETUP_XfOrM395(x) SETUP_XfOrM394(x)

# 3220 "bc/src/portfun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM396_COUNT (0+XfOrM395_COUNT)
#       define SETUP_XfOrM396(x) SETUP_XfOrM395(x)
        FUNCCALL(SETUP_XfOrM396(_), scheme_out_of_fuel () )
# 3220 "bc/src/portfun.c"
        ; 
      }
    }

# 3220 "bc/src/portfun.c"
    ; 
  }

  if (as_bytes ) {
#   define XfOrM379_COUNT (0+XfOrM373_COUNT)
#   define SETUP_XfOrM379(x) SETUP_XfOrM373(x)

# 3224 "bc/src/portfun.c"
    buf [i ] = '\0' ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string (buf , i , buf == (char * ) onstack ) )) RET_VALUE_EMPTY_END ; 
  }

# 3226 "bc/src/portfun.c"
  else {
    int j ; 
#   define XfOrM374_COUNT (0+XfOrM373_COUNT)
#   define SETUP_XfOrM374(x) SETUP_XfOrM373(x)

# 3228 "bc/src/portfun.c"
    if (ascii ) {
      mzchar * us ; 
      BLOCK_SETUP((PUSH(us, 0+XfOrM374_COUNT)));
#     define XfOrM376_COUNT (1+XfOrM374_COUNT)
#     define SETUP_XfOrM376(x) SETUP(XfOrM376_COUNT)
      us = NULLED_OUT ; 

# 3230 "bc/src/portfun.c"
      us = FUNCCALL(SETUP_XfOrM376(_), GC_malloc_atomic (sizeof (mzchar ) * (i + 1 ) ) ); 
      for (j = 0 ; j < i ; j ++ ) {
        us [j ] = ((unsigned char * ) buf ) [j ] ; 
      }
      us [i ] = 0 ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_offset_char_string (us , 0 , i , 0 ) )) RET_VALUE_EMPTY_END ; 
    }

# 3236 "bc/src/portfun.c"
    else {
#     define XfOrM375_COUNT (0+XfOrM374_COUNT)
#     define SETUP_XfOrM375(x) SETUP_XfOrM374(x)

# 3237 "bc/src/portfun.c"
      buf [i ] = '\0' ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (buf , i ) )) RET_VALUE_EMPTY_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3243 "bc/src/portfun.c"
static Scheme_Object * 
read_line (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3246 "bc/src/portfun.c"
  return do_read_line (0 , "read-line" , argc , argv ) ; 
}

static Scheme_Object * 
read_byte_line (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3252 "bc/src/portfun.c"
  return do_read_line (1 , "read-byte-line" , argc , argv ) ; 
}


static Scheme_Object * 
do_general_read_bytes (int as_bytes , 
const char * who , int argc , Scheme_Object * argv [] , 
int alloc_mode , int only_avail , int peek ) 
{
  Scheme_Object * port , * str , * peek_skip , * unless_evt = ((void * ) 0 ) ; 
  intptr_t size , start , finish , got ; 
  int delta , size_too_big = 0 ; 
  Scheme_Config * __funcarg176 = NULLED_OUT ; 
  char * __funcarg175 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(peek_skip, 1), PUSH(port, 2), PUSH(who, 3), PUSH(argv, 4), PUSH(unless_evt, 5)));
# define XfOrM416_COUNT (6)
# define SETUP_XfOrM416(x) SETUP(XfOrM416_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  port = NULLED_OUT ; 
  str = NULLED_OUT ; 
  peek_skip = NULLED_OUT ; 

# 3265 "bc/src/portfun.c"
  if (alloc_mode ) {
#   define XfOrM441_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM441(x) SETUP_XfOrM416(x)

# 3266 "bc/src/portfun.c"
    if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) ) {
      if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
        size = 1 ; 
        size_too_big = 1 ; 
      }

# 3270 "bc/src/portfun.c"
      else 
      size = - 1 ; 
    }

# 3272 "bc/src/portfun.c"
    else 
    size = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

    if (size < 0 ) {
#     define XfOrM442_COUNT (0+XfOrM441_COUNT)
#     define SETUP_XfOrM442(x) SETUP_XfOrM441(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-nonnegative-integer?" , 0 , argc , argv ) )
# 3276 "bc/src/portfun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    str = ((void * ) 0 ) ; 
  }

# 3280 "bc/src/portfun.c"
  else {
#   define XfOrM436_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM436(x) SETUP_XfOrM416(x)

# 3281 "bc/src/portfun.c"
    if (as_bytes ) {
#     define XfOrM439_COUNT (0+XfOrM436_COUNT)
#     define SETUP_XfOrM439(x) SETUP_XfOrM436(x)

# 3282 "bc/src/portfun.c"
      if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) && (! (((Scheme_Inclhash_Object * ) (argv [0 ] ) ) -> so . keyex & 0x1 ) ) ) ) {
#       define XfOrM440_COUNT (0+XfOrM439_COUNT)
#       define SETUP_XfOrM440(x) SETUP_XfOrM439(x)
        FUNCCALL_EMPTY(scheme_wrong_contract (who , "(and/c bytes? (not/c immutable?))" , 0 , argc , argv ) )
# 3283 "bc/src/portfun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 3286 "bc/src/portfun.c"
    else {
#     define XfOrM437_COUNT (0+XfOrM436_COUNT)
#     define SETUP_XfOrM437(x) SETUP_XfOrM436(x)

# 3287 "bc/src/portfun.c"
      if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) && (! (((Scheme_Inclhash_Object * ) (argv [0 ] ) ) -> so . keyex & 0x1 ) ) ) ) {
#       define XfOrM438_COUNT (0+XfOrM437_COUNT)
#       define SETUP_XfOrM438(x) SETUP_XfOrM437(x)
        FUNCCALL_EMPTY(scheme_wrong_contract (who , "(and/c strings? (not/c immutable?))" , 0 , argc , argv ) )
# 3288 "bc/src/portfun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
    str = argv [0 ] ; 
    size = 0 ; 
  }

  if (peek ) {
    Scheme_Object * v ; 
#   define XfOrM431_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM431(x) SETUP_XfOrM416(x)
    v = NULLED_OUT ; 

# 3298 "bc/src/portfun.c"
    v = argv [1 ] ; 
    if ((((intptr_t ) (v ) ) & 0x1 ) && ((((intptr_t ) (v ) ) >> 1 ) >= 0 ) )
      peek_skip = v ; 
    else if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) v ) -> iso ) -> so . keyex & 0x1 ) )
      peek_skip = v ; 
    else {
#     define XfOrM435_COUNT (0+XfOrM431_COUNT)
#     define SETUP_XfOrM435(x) SETUP_XfOrM431(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-nonnegative-integer?" , 1 , argc , argv ) )
# 3304 "bc/src/portfun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (only_avail ) {
#     define XfOrM432_COUNT (0+XfOrM431_COUNT)
#     define SETUP_XfOrM432(x) SETUP_XfOrM431(x)

# 3308 "bc/src/portfun.c"
      if (! (((argv [2 ] ) ) == (scheme_false ) ) )  {
#       define XfOrM433_COUNT (0+XfOrM432_COUNT)
#       define SETUP_XfOrM433(x) SETUP_XfOrM432(x)

# 3309 "bc/src/portfun.c"
        unless_evt = argv [2 ] ; 
        if (! ((Scheme_Type ) (((((intptr_t ) (unless_evt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (unless_evt ) ) -> type ) ) == (Scheme_Type ) (scheme_progress_evt_type ) ) ) {
#         define XfOrM434_COUNT (0+XfOrM433_COUNT)
#         define SETUP_XfOrM434(x) SETUP_XfOrM433(x)
          FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c progress-evt? #f)" , 2 , argc , argv ) )
# 3311 "bc/src/portfun.c"
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      delta = 2 ; 
    }

# 3316 "bc/src/portfun.c"
    else 
    delta = 1 ; 
  }

# 3318 "bc/src/portfun.c"
  else {
    peek_skip = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    delta = 0 ; 
  }

  if ((argc > (1 + delta ) ) && ! (scheme_is_input_port (argv [1 + delta ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "input-port?" , 1 + delta , argc , argv ) ); 

  if (alloc_mode ) {
    start = 0 ; 
    finish = size ; 
  }

# 3329 "bc/src/portfun.c"
  else {
#   define XfOrM428_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM428(x) SETUP_XfOrM416(x)
    FUNCCALL(SETUP_XfOrM428(_), scheme_get_substring_indices (who , str , argc , argv , 2 + delta , 3 + delta , & start , & finish ) ); 

    size = finish - start ; 
  }

  if (argc > (delta + 1 ) )
    port = argv [delta + 1 ] ; 
  else 
  port = (__funcarg176 = FUNCCALL(SETUP_XfOrM416(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg176 , MZCONFIG_INPUT_PORT ) )) ; 

  if (unless_evt ) {
#   define XfOrM426_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM426(x) SETUP_XfOrM416(x)

# 3343 "bc/src/portfun.c"
    if (! ((port ) == ((((Scheme_Simple_Object * ) (unless_evt ) ) -> u . two_ptr_val . ptr1 ) ) ) ) {
#     define XfOrM427_COUNT (0+XfOrM426_COUNT)
#     define SETUP_XfOrM427(x) SETUP_XfOrM426(x)
      FUNCCALL_EMPTY(scheme_contract_error (who , "evt is not a progress evt for the given port" , "evt" , 1 , unless_evt , "port" , 1 , port , ((void * ) 0 ) ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if ((Scheme_Object * ) port == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) )
    FUNCCALL(SETUP_XfOrM416(_), scheme_flush_orig_outputs () ); 

  if (! size ) {
#   define XfOrM424_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM424(x) SETUP_XfOrM416(x)

# 3357 "bc/src/portfun.c"
    if (alloc_mode ) {
#     define XfOrM425_COUNT (0+XfOrM424_COUNT)
#     define SETUP_XfOrM425(x) SETUP_XfOrM424(x)

# 3358 "bc/src/portfun.c"
      if (as_bytes )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string ("" , 0 , 0 ) )) RET_VALUE_EMPTY_END ; 
      else 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_char_string ((mzchar * ) "\0\0\0" , 0 , 0 ) )) RET_VALUE_EMPTY_END ; 
    }

# 3362 "bc/src/portfun.c"
    else 
    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  }

  if (alloc_mode ) {
#   define XfOrM422_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM422(x) SETUP_XfOrM416(x)

# 3367 "bc/src/portfun.c"
    if (size_too_big ) {
#     define XfOrM423_COUNT (0+XfOrM422_COUNT)
#     define SETUP_XfOrM423(x) SETUP_XfOrM422(x)
      (__funcarg175 = FUNCCALL(SETUP_XfOrM423(_), scheme_make_provided_string (argv [0 ] , 0 , ((void * ) 0 ) ) ), FUNCCALL_EMPTY(scheme_raise_out_of_memory (who , "making string of length %s" , __funcarg175 ) )) 
# 3369 "bc/src/portfun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (as_bytes )
      str = FUNCCALL(SETUP_XfOrM422(_), scheme_alloc_byte_string (size , 0 ) ); 
    else 
    str = FUNCCALL(SETUP_XfOrM422(_), scheme_alloc_char_string (size , 0 ) ); 
  }

  if (as_bytes ) {
#   define XfOrM420_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM420(x) SETUP_XfOrM416(x)

# 3379 "bc/src/portfun.c"
    got = FUNCCALL(SETUP_XfOrM420(_), scheme_get_byte_string_special_ok_unless (who , port , (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) , start , size , only_avail , peek , peek_skip , unless_evt ) )



    ; 
    if (got == (- 2 ) ) {
      Scheme_Object * res ; 
      BLOCK_SETUP((PUSH(res, 0+XfOrM420_COUNT)));
#     define XfOrM421_COUNT (1+XfOrM420_COUNT)
#     define SETUP_XfOrM421(x) SETUP(XfOrM421_COUNT)
      res = NULLED_OUT ; 

# 3386 "bc/src/portfun.c"
      res = FUNCCALL(SETUP_XfOrM421(_), scheme_get_special_proc (port ) ); 
      if (! only_avail )
        FUNCCALL(SETUP_XfOrM421(_), scheme_bad_time_for_special (who , port ) ); 
      RET_VALUE_START (res ) RET_VALUE_END ; 
    }
  }

# 3391 "bc/src/portfun.c"
  else {
#   define XfOrM419_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM419(x) SETUP_XfOrM416(x)

# 3392 "bc/src/portfun.c"
    got = FUNCCALL(SETUP_XfOrM419(_), scheme_get_char_string (who , port , (((Scheme_Simple_Object * ) (str ) ) -> u . char_str_val . string_val ) , start , size , peek , peek_skip ) )

    ; 
  }

  if (got == (- 1 ) )
    RET_VALUE_START (scheme_eof ) RET_VALUE_END ; 

  if (alloc_mode ) {
#   define XfOrM417_COUNT (0+XfOrM416_COUNT)
#   define SETUP_XfOrM417(x) SETUP_XfOrM416(x)

# 3401 "bc/src/portfun.c"
    if (got < size ) {
#     define XfOrM418_COUNT (0+XfOrM417_COUNT)
#     define SETUP_XfOrM418(x) SETUP_XfOrM417(x)

# 3403 "bc/src/portfun.c"
      if (as_bytes )
        str = FUNCCALL(SETUP_XfOrM418(_), scheme_make_sized_byte_string ((((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) , got , 1 ) ); 
      else 
      str = FUNCCALL(SETUP_XfOrM418(_), scheme_make_sized_char_string ((((Scheme_Simple_Object * ) (str ) ) -> u . char_str_val . string_val ) , got , 1 ) ); 
    }
    RET_VALUE_START (str ) RET_VALUE_END ; 
  }

# 3409 "bc/src/portfun.c"
  else 
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (got ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3413 "bc/src/portfun.c"
static Scheme_Object * 
sch_read_bytes (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3416 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "read-bytes" , argc , argv , 1 , 0 , 0 ) ; 
}

static Scheme_Object * 
sch_read_bytes_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3422 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "read-bytes!" , argc , argv , 0 , 0 , 0 ) ; 
}

static Scheme_Object * 
sch_peek_bytes (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3428 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "peek-bytes" , argc , argv , 1 , 0 , 1 ) ; 
}

static Scheme_Object * 
sch_peek_bytes_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3434 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "peek-bytes!" , argc , argv , 0 , 0 , 1 ) ; 
}

static Scheme_Object * 
read_bytes_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3440 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "read-bytes-avail!" , argc , argv , 0 , 1 , 0 ) ; 
}

static Scheme_Object * 
read_bytes_bang_nonblock (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3446 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "read-bytes-avail!*" , argc , argv , 0 , 2 , 0 ) ; 
}

static Scheme_Object * 
peeked_read (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port , * unless_evt , * target_evt ; 
  intptr_t size ; 
  int v ; 
  Scheme_Config * __funcarg177 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(target_evt, 1), PUSH(unless_evt, 2)));
# define XfOrM451_COUNT (3)
# define SETUP_XfOrM451(x) SETUP(XfOrM451_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 
  unless_evt = NULLED_OUT ; 
  target_evt = NULLED_OUT ; 

# 3456 "bc/src/portfun.c"
  if (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((intptr_t ) (argv [0 ] ) ) >> 1 ) > 0 ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [0 ] ) -> iso ) -> so . keyex & 0x1 ) ) ) {
    if (((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
      size = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
    else 
    size = 0x7FFFFFFF ; 
  }

# 3462 "bc/src/portfun.c"
  else {
#   define XfOrM455_COUNT (0+XfOrM451_COUNT)
#   define SETUP_XfOrM455(x) SETUP_XfOrM451(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-commit-peeked" , "exact-positive-integer?" , 0 , argc , argv ) )
# 3463 "bc/src/portfun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  unless_evt = argv [1 ] ; 
  target_evt = argv [2 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (unless_evt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (unless_evt ) ) -> type ) ) == (Scheme_Type ) (scheme_progress_evt_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-commit-peeked" , "progress-evt?" , 1 , argc , argv ) ); 
  {
    Scheme_Type t ; 
#   define XfOrM454_COUNT (0+XfOrM451_COUNT)
#   define SETUP_XfOrM454(x) SETUP_XfOrM451(x)

# 3473 "bc/src/portfun.c"
    t = ((((intptr_t ) (target_evt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (target_evt ) ) -> type ) ; 
    if (! ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_sema_type ) ) 
    && ! ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_channel_type ) ) 
    && ! ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_channel_put_type ) ) 
    && ! ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_always_evt_type ) ) 
    && ! ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_never_evt_type ) ) 
    && ! ((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_semaphore_repost_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("port-commit-peeked" , "(or/c channel-put-evt? channel? semaphore? semephore-peek-evt? (one-of/c always-evt never evt))" , 2 , argc , argv ) )

    ; 
  }

  if (argc > 3 ) {
#   define XfOrM453_COUNT (0+XfOrM451_COUNT)
#   define SETUP_XfOrM453(x) SETUP_XfOrM451(x)

# 3486 "bc/src/portfun.c"
    port = argv [3 ] ; 
    if (! (scheme_is_input_port (port ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("port-commit-peeked" , "input-port?" , 3 , argc , argv ) ); 
  }

# 3489 "bc/src/portfun.c"
  else 
  port = (__funcarg177 = FUNCCALL(SETUP_XfOrM451(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg177 , MZCONFIG_INPUT_PORT ) )) ; 

  if (! ((port ) == ((((Scheme_Simple_Object * ) (unless_evt ) ) -> u . two_ptr_val . ptr1 ) ) ) ) {
#   define XfOrM452_COUNT (0+XfOrM451_COUNT)
#   define SETUP_XfOrM452(x) SETUP_XfOrM451(x)
    FUNCCALL_EMPTY(scheme_contract_error ("port-commit-peeked" , "evt is not a progress evt for the given port" , "evt" , 1 , unless_evt , "port" , 1 , port , ((void * ) 0 ) ) )

    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  v = FUNCCALL_EMPTY(scheme_peeked_read (port , size , unless_evt , target_evt ) ); 

  RET_VALUE_START ((v ? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3506 "bc/src/portfun.c"
static Scheme_Object * 
peek_bytes_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3509 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "peek-bytes-avail!" , argc , argv , 0 , 1 , 1 ) ; 
}

static Scheme_Object * 
peek_bytes_bang_nonblock (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3515 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "peek-bytes-avail!*" , argc , argv , 0 , 2 , 1 ) ; 
}

static Scheme_Object * 
sch_read_string (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3521 "bc/src/portfun.c"
  return do_general_read_bytes (0 , "read-string" , argc , argv , 1 , 0 , 0 ) ; 
}

static Scheme_Object * 
sch_read_string_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3527 "bc/src/portfun.c"
  return do_general_read_bytes (0 , "read-string!" , argc , argv , 0 , 0 , 0 ) ; 
}

static Scheme_Object * 
sch_peek_string (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3533 "bc/src/portfun.c"
  return do_general_read_bytes (0 , "peek-string" , argc , argv , 1 , 0 , 1 ) ; 
}

static Scheme_Object * 
sch_peek_string_bang (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3539 "bc/src/portfun.c"
  return do_general_read_bytes (0 , "peek-string!" , argc , argv , 0 , 0 , 1 ) ; 
}

static Scheme_Object * 
read_bytes_bang_break (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3545 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "read-bytes-avail!/enable-break" , argc , argv , 0 , - 1 , 0 ) ; 
}

static Scheme_Object * 
peek_bytes_bang_break (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3551 "bc/src/portfun.c"
  return do_general_read_bytes (1 , "peek-bytes-avail!/enable-break" , argc , argv , 0 , - 1 , 1 ) ; 
}

static Scheme_Object * 
progress_evt (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port , * v ; 
  Scheme_Config * __funcarg178 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(port, 1)));
# define XfOrM465_COUNT (2)
# define SETUP_XfOrM465(x) SETUP(XfOrM465_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 3559 "bc/src/portfun.c"
  if (argc ) {
#   define XfOrM468_COUNT (0+XfOrM465_COUNT)
#   define SETUP_XfOrM468(x) SETUP_XfOrM465(x)

# 3560 "bc/src/portfun.c"
    if (! (scheme_is_input_port (argv [0 ] ) ) ) {
#     define XfOrM469_COUNT (0+XfOrM468_COUNT)
#     define SETUP_XfOrM469(x) SETUP_XfOrM468(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("port-progress-evt" , "input-port?" , 0 , argc , argv ) )
# 3561 "bc/src/portfun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    port = argv [0 ] ; 
  }

# 3565 "bc/src/portfun.c"
  else {
#   define XfOrM467_COUNT (0+XfOrM465_COUNT)
#   define SETUP_XfOrM467(x) SETUP_XfOrM465(x)

# 3566 "bc/src/portfun.c"
    port = (__funcarg178 = FUNCCALL(SETUP_XfOrM467(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg178 , MZCONFIG_INPUT_PORT ) )) ; 
  }

  v = FUNCCALL(SETUP_XfOrM465(_), scheme_progress_evt (port ) ); 

  if (! v ) {
#   define XfOrM466_COUNT (0+XfOrM465_COUNT)
#   define SETUP_XfOrM466(x) SETUP_XfOrM465(x)
    FUNCCALL_EMPTY(scheme_contract_error ("port-progress-evt" , "port does not provide progress evts" , "port" , 1 , port , ((void * ) 0 ) ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 3576 "bc/src/portfun.c"
  else 
  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3580 "bc/src/portfun.c"
static Scheme_Object * 
is_progress_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3583 "bc/src/portfun.c"
  Scheme_Object * v ; 

  v = argv [0 ] ; 

  if (argc > 1 ) {
    if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_progress_evt_type ) ) )
      scheme_wrong_contract ("progress-evt?" , "progress-evt?" , 0 , argc , argv ) ; 
    if (! scheme_is_input_port (argv [1 ] ) )
      scheme_wrong_contract ("progress-evt?" , "input-port?" , 1 , argc , argv ) ; 
    return (((argv [1 ] ) == ((((Scheme_Simple_Object * ) (v ) ) -> u . two_ptr_val . ptr1 ) ) ) 
    ? scheme_true 
    : scheme_false ) ; 
  }

# 3595 "bc/src/portfun.c"
  else {
    return (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_progress_evt_type ) ) 
    ? scheme_true 
    : scheme_false ) ; 
  }
}

static Scheme_Object * make_closed_evt (int already_closed ) 
{
  Scheme_Object * evt , * sema ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sema, 0), PUSH(evt, 1)));
# define XfOrM473_COUNT (2)
# define SETUP_XfOrM473(x) SETUP(XfOrM473_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  evt = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 3606 "bc/src/portfun.c"
  sema = FUNCCALL(SETUP_XfOrM473(_), scheme_make_sema (0 ) ); 
  if (already_closed )
    FUNCCALL(SETUP_XfOrM473(_), scheme_post_sema_all (sema ) ); 
  evt = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM473(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  evt -> type = scheme_port_closed_evt_type ; 
  (((Scheme_Small_Object * ) (evt ) ) -> u . ptr_val ) = sema ; 

  RET_VALUE_START (evt ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3616 "bc/src/portfun.c"
static Scheme_Object * 
closed_evt (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1)));
# define XfOrM474_COUNT (2)
# define SETUP_XfOrM474(x) SETUP(XfOrM474_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3620 "bc/src/portfun.c"
  if (scheme_is_input_port (v ) )  {
    Scheme_Input_Port * ip ; 
    BLOCK_SETUP((PUSH(ip, 0+XfOrM474_COUNT)));
#   define XfOrM478_COUNT (1+XfOrM474_COUNT)
#   define SETUP_XfOrM478(x) SETUP(XfOrM478_COUNT)
    ip = NULLED_OUT ; 

# 3622 "bc/src/portfun.c"
    ip = FUNCCALL(SETUP_XfOrM478(_), scheme_input_port_record (v ) ); 
    if (! ip -> closed_evt ) {
#     define XfOrM479_COUNT (0+XfOrM478_COUNT)
#     define SETUP_XfOrM479(x) SETUP_XfOrM478(x)

# 3624 "bc/src/portfun.c"
      v = FUNCCALL(SETUP_XfOrM479(_), make_closed_evt (ip -> closed ) ); 
      ip -> closed_evt = v ; 
    }

# 3626 "bc/src/portfun.c"
    else 
    v = ip -> closed_evt ; 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

# 3629 "bc/src/portfun.c"
  else if (scheme_is_output_port (v ) )  {
    Scheme_Output_Port * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM474_COUNT)));
#   define XfOrM476_COUNT (1+XfOrM474_COUNT)
#   define SETUP_XfOrM476(x) SETUP(XfOrM476_COUNT)
    op = NULLED_OUT ; 

# 3631 "bc/src/portfun.c"
    op = FUNCCALL(SETUP_XfOrM476(_), scheme_output_port_record (v ) ); 
    if (! op -> closed_evt ) {
#     define XfOrM477_COUNT (0+XfOrM476_COUNT)
#     define SETUP_XfOrM477(x) SETUP_XfOrM476(x)

# 3633 "bc/src/portfun.c"
      v = FUNCCALL(SETUP_XfOrM477(_), make_closed_evt (op -> closed ) ); 
      op -> closed_evt = v ; 
    }

# 3635 "bc/src/portfun.c"
    else 
    v = op -> closed_evt ; 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

# 3638 "bc/src/portfun.c"
  else {
#   define XfOrM475_COUNT (0+XfOrM474_COUNT)
#   define SETUP_XfOrM475(x) SETUP_XfOrM474(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-closed-evt" , "port?" , 0 , argc , argv ) )
# 3639 "bc/src/portfun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3644 "bc/src/portfun.c"
static Scheme_Object * 
do_write_bytes_avail (int as_bytes , const char * who , 
int argc , Scheme_Object * argv [] , 
int rarely_block , int get_evt ) 
{
  Scheme_Object * port , * str ; 
  intptr_t size , start , finish , putten ; 
  Scheme_Config * __funcarg179 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(port, 1), PUSH(who, 2), PUSH(argv, 3)));
# define XfOrM480_COUNT (4)
# define SETUP_XfOrM480(x) SETUP(XfOrM480_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 
  str = NULLED_OUT ; 

# 3652 "bc/src/portfun.c"
  if (as_bytes && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) ) {
#   define XfOrM482_COUNT (0+XfOrM480_COUNT)
#   define SETUP_XfOrM482(x) SETUP_XfOrM480(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "bytes?" , 0 , argc , argv ) )
# 3653 "bc/src/portfun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 3655 "bc/src/portfun.c"
  else if (! as_bytes && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
#   define XfOrM481_COUNT (0+XfOrM480_COUNT)
#   define SETUP_XfOrM481(x) SETUP_XfOrM480(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "string?" , 0 , argc , argv ) )
# 3656 "bc/src/portfun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 3658 "bc/src/portfun.c"
  else 
  str = argv [0 ] ; 
  if ((argc > 1 ) && ! (scheme_is_output_port (argv [1 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "output-port?" , 1 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM480(_), scheme_get_substring_indices (who , str , argc , argv , 2 , 3 , & start , & finish ) )


  ; 

  size = finish - start ; 

  if (argc > 1 )
    port = argv [1 ] ; 
  else 
  port = (__funcarg179 = FUNCCALL(SETUP_XfOrM480(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg179 , MZCONFIG_OUTPUT_PORT ) )) ; 

  if (get_evt )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_write_evt (who , port , ((void * ) 0 ) , (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) , start , size ) )) RET_VALUE_EMPTY_END 
  ; 
  else if (as_bytes )
    putten = FUNCCALL(SETUP_XfOrM480(_), scheme_put_byte_string (who , port , (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) , start , size , rarely_block ) )

  ; 
  else 
  putten = FUNCCALL_EMPTY(scheme_put_char_string (who , port , (((Scheme_Simple_Object * ) (str ) ) -> u . char_str_val . string_val ) , start , size ) )
  ; 

  if (putten < 0 )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (putten ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3691 "bc/src/portfun.c"
static Scheme_Object * 
write_bytes (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3694 "bc/src/portfun.c"
  return do_write_bytes_avail (1 , "write-bytes" , argc , argv , 0 , 0 ) ; 
}

static Scheme_Object * 
write_bytes_avail (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3700 "bc/src/portfun.c"
  return do_write_bytes_avail (1 , "write-bytes-avail" , argc , argv , 1 , 0 ) ; 
}

static Scheme_Object * 
write_bytes_avail_break (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3706 "bc/src/portfun.c"
  return do_write_bytes_avail (1 , "write-bytes-avail" , argc , argv , - 1 , 0 ) ; 
}

static Scheme_Object * 
write_bytes_avail_nonblock (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3712 "bc/src/portfun.c"
  return do_write_bytes_avail (1 , "write-bytes-avail*" , argc , argv , 2 , 0 ) ; 
}

static Scheme_Object * 
write_string (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3718 "bc/src/portfun.c"
  return do_write_bytes_avail (0 , "write-string" , argc , argv , 0 , 0 ) ; 
}

static Scheme_Object * 
write_bytes_avail_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3724 "bc/src/portfun.c"
  return do_write_bytes_avail (1 , "write-bytes-avail-evt" , argc , argv , 1 , 1 ) ; 
}

static Scheme_Object * 
do_write_special (const char * name , int argc , Scheme_Object * argv [] , int nonblock , int get_evt ) 
{
  Scheme_Output_Port * op ; 
  Scheme_Object * port ; 
  int ok ; 
  Scheme_Config * __funcarg180 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(port, 1), PUSH(argv, 2), PUSH(op, 3)));
# define XfOrM489_COUNT (4)
# define SETUP_XfOrM489(x) SETUP(XfOrM489_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  op = NULLED_OUT ; 
  port = NULLED_OUT ; 

# 3734 "bc/src/portfun.c"
  if (argc > 1 ) {
#   define XfOrM496_COUNT (0+XfOrM489_COUNT)
#   define SETUP_XfOrM496(x) SETUP_XfOrM489(x)

# 3735 "bc/src/portfun.c"
    if (! (scheme_is_output_port (argv [1 ] ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "output-port?" , 1 , argc , argv ) ); 
    port = argv [1 ] ; 
  }

# 3738 "bc/src/portfun.c"
  else 
  port = (__funcarg180 = FUNCCALL(SETUP_XfOrM489(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg180 , MZCONFIG_OUTPUT_PORT ) )) ; 

  op = FUNCCALL(SETUP_XfOrM489(_), scheme_output_port_record (port ) ); 

  if (op -> write_special_fun ) {
#   define XfOrM493_COUNT (0+XfOrM489_COUNT)
#   define SETUP_XfOrM493(x) SETUP_XfOrM489(x)

# 3744 "bc/src/portfun.c"
    if (get_evt ) {
#     define XfOrM495_COUNT (0+XfOrM493_COUNT)
#     define SETUP_XfOrM495(x) SETUP_XfOrM493(x)

# 3745 "bc/src/portfun.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_write_evt (name , port , argv [0 ] , ((void * ) 0 ) , 0 , 0 ) )) RET_VALUE_EMPTY_END ; 
    }

# 3746 "bc/src/portfun.c"
    else {
      Scheme_Write_Special_Fun ws = op -> write_special_fun ; 
#     define XfOrM494_COUNT (0+XfOrM493_COUNT)
#     define SETUP_XfOrM494(x) SETUP_XfOrM493(x)

# 3748 "bc/src/portfun.c"
      ok = FUNCCALL(SETUP_XfOrM494(_), ws (op , argv [0 ] , nonblock ) ); 
    }
  }

# 3750 "bc/src/portfun.c"
  else {
#   define XfOrM492_COUNT (0+XfOrM489_COUNT)
#   define SETUP_XfOrM492(x) SETUP_XfOrM489(x)
    FUNCCALL_EMPTY(scheme_contract_error (name , "port does not support special values" , "port" , 1 , port , ((void * ) 0 ) ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (ok ) {
    Scheme_Port * ip ; 
    BLOCK_SETUP((PUSH(ip, 0+XfOrM489_COUNT)));
#   define XfOrM490_COUNT (1+XfOrM489_COUNT)
#   define SETUP_XfOrM490(x) SETUP(XfOrM490_COUNT)
    ip = NULLED_OUT ; 

# 3760 "bc/src/portfun.c"
    ip = FUNCCALL(SETUP_XfOrM490(_), scheme_port_record (port ) ); 
    if (ip -> position >= 0 )
      ip -> position += 1 ; 
    if (ip -> count_lines ) {
      ip -> column += 1 ; 
      ip -> readpos += 1 ; 
      ip -> charsSinceNewline += 1 ; 
      ip -> utf8state = 0 ; 
    }
    RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  }

# 3770 "bc/src/portfun.c"
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3774 "bc/src/portfun.c"
static Scheme_Object * can_write_atomic (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Output_Port * op ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(op, 0)));
# define XfOrM497_COUNT (1)
# define SETUP_XfOrM497(x) SETUP(XfOrM497_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 

# 3778 "bc/src/portfun.c"
  if (! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-writes-atomic?" , "output-port?" , 0 , argc , argv ) ); 

  op = FUNCCALL(SETUP_XfOrM497(_), scheme_output_port_record (argv [0 ] ) ); 
  if (op -> write_string_evt_fun )
    RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3788 "bc/src/portfun.c"
static Scheme_Object * can_provide_progress_evt (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Input_Port * ip ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ip, 0)));
# define XfOrM498_COUNT (1)
# define SETUP_XfOrM498(x) SETUP(XfOrM498_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ip = NULLED_OUT ; 

# 3792 "bc/src/portfun.c"
  if (! (scheme_is_input_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-provides-progress-evt?" , "input-port?" , 0 , argc , argv ) ); 

  ip = FUNCCALL(SETUP_XfOrM498(_), scheme_input_port_record (argv [0 ] ) ); 

  if (ip -> progress_evt_fun )
    RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3803 "bc/src/portfun.c"
static Scheme_Object * 
can_write_special (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Output_Port * op ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(op, 0)));
# define XfOrM499_COUNT (1)
# define SETUP_XfOrM499(x) SETUP(XfOrM499_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 

# 3808 "bc/src/portfun.c"
  if (! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-writes-special?" , "output-port?" , 0 , argc , argv ) ); 

  op = FUNCCALL(SETUP_XfOrM499(_), scheme_output_port_record (argv [0 ] ) ); 

  if (op -> write_special_fun )
    RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3819 "bc/src/portfun.c"
Scheme_Object * 
scheme_write_special (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3822 "bc/src/portfun.c"
  return do_write_special ("write-special" , argc , argv , 0 , 0 ) ; 
}

Scheme_Object * 
scheme_write_special_nonblock (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3828 "bc/src/portfun.c"
  return do_write_special ("write-special-avail*" , argc , argv , 1 , 0 ) ; 
}

static Scheme_Object * 
write_special_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3834 "bc/src/portfun.c"
  return do_write_special ("write-special-evt" , argc , argv , 1 , 1 ) ; 
}


Scheme_Object * 
scheme_call_enable_break (Scheme_Prim * prim , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(cframe.cache, 1), PUSH(argv, 2), PUSH(prim, 3)));
# define XfOrM503_COUNT (4)
# define SETUP_XfOrM503(x) SETUP(XfOrM503_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cframe.cache = NULLED_OUT ; 
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM503(_), scheme_push_break_enable (& cframe , 1 , 1 ) )
# 3844 "bc/src/portfun.c"
  ; 

  v = FUNCCALL_AGAIN(prim (argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe , 0 ) )
  ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3853 "bc/src/portfun.c"
static Scheme_Object * 
eof_object_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3856 "bc/src/portfun.c"
  return ((((argv [0 ] ) ) == (scheme_eof ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
char_ready_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port ; 
  Scheme_Config * __funcarg181 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM505_COUNT (1)
# define SETUP_XfOrM505(x) SETUP(XfOrM505_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 

# 3864 "bc/src/portfun.c"
  if (argc && ! (scheme_is_input_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("char-ready?" , "input-port?" , 0 , argc , argv ) ); 

  if (argc )
    port = argv [0 ] ; 
  else 
  port = (__funcarg181 = FUNCCALL(SETUP_XfOrM505(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg181 , MZCONFIG_INPUT_PORT ) )) ; 

  RET_VALUE_START ((FUNCCALL_EMPTY(scheme_char_ready (port ) )? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3875 "bc/src/portfun.c"
static Scheme_Object * 
byte_ready_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port ; 
  Scheme_Config * __funcarg182 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM506_COUNT (1)
# define SETUP_XfOrM506(x) SETUP(XfOrM506_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 

# 3880 "bc/src/portfun.c"
  if (argc && ! (scheme_is_input_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("byte-ready?" , "input-port?" , 0 , argc , argv ) ); 

  if (argc )
    port = argv [0 ] ; 
  else 
  port = (__funcarg182 = FUNCCALL(SETUP_XfOrM506(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg182 , MZCONFIG_INPUT_PORT ) )) ; 

  RET_VALUE_START ((FUNCCALL_EMPTY(scheme_byte_ready (port ) )? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3891 "bc/src/portfun.c"
static Scheme_Object * sch_default_display_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3893 "bc/src/portfun.c"
  if (! scheme_is_output_port (argv [1 ] ) )
    scheme_wrong_contract ("default-port-display-handler" , "output-port?" , 1 , argc , argv ) ; 

  scheme_internal_display (argv [0 ] , argv [1 ] ) ; 

  return scheme_void ; 
}

static Scheme_Object * sch_default_write_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3903 "bc/src/portfun.c"
  if (! scheme_is_output_port (argv [1 ] ) )
    scheme_wrong_contract ("default-port-write-handler" , "output-port?" , 1 , argc , argv ) ; 

  scheme_internal_write (argv [0 ] , argv [1 ] ) ; 

  return scheme_void ; 
}

static Scheme_Object * sch_default_print_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * __funcarg184 = NULLED_OUT ; 
  Scheme_Object * __funcarg183 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM509_COUNT (1)
# define SETUP_XfOrM509(x) SETUP(XfOrM509_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3913 "bc/src/portfun.c"
  if (! (scheme_is_output_port (argv [1 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-port-print-handler" , "output-port?" , 1 , argc , argv ) ); 
  if ((argc > 2 ) && ! FUNCCALL(SETUP_XfOrM509(_), scheme_nonneg_exact_p (argv [2 ] ) ))
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-port-print-handler" , "exact-nonnegative-integer?" , 2 , argc , argv ) )
  ; 

  RET_VALUE_START ((__funcarg183 = (__funcarg184 = FUNCCALL(SETUP_XfOrM509(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg184 , MZCONFIG_PORT_PRINT_HANDLER ) )) , FUNCCALL_EMPTY(scheme_do_eval (__funcarg183 , argc , argv , 1 ) )) ) RET_VALUE_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3924 "bc/src/portfun.c"
static Scheme_Object * sch_default_global_port_print_handler (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM510_COUNT (1)
# define SETUP_XfOrM510(x) SETUP(XfOrM510_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3926 "bc/src/portfun.c"
  if (! (scheme_is_output_port (argv [1 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-global-port-print-handler" , "output-port?" , 1 , argc , argv ) ); 
  if ((argc > 2 ) 
  && ! ((argv [2 ] ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 
  && ! ((argv [2 ] ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-global-port-print-handler" , "(or/c 0 1)" , 2 , argc , argv ) )
  ; 

  if (argc == 2 ) {
#   define XfOrM512_COUNT (0+XfOrM510_COUNT)
#   define SETUP_XfOrM512(x) SETUP_XfOrM510(x)
    FUNCCALL(SETUP_XfOrM512(_), scheme_internal_print (argv [0 ] , argv [1 ] , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) )
# 3935 "bc/src/portfun.c"
    ; 
  }
  else {
#   define XfOrM511_COUNT (0+XfOrM510_COUNT)
#   define SETUP_XfOrM511(x) SETUP_XfOrM510(x)
    FUNCCALL_EMPTY(scheme_internal_print (argv [0 ] , argv [1 ] , argv [2 ] ) )
# 3938 "bc/src/portfun.c"
    ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3944 "bc/src/portfun.c"
static Scheme_Object * 
display_write (char * name , 
int argc , Scheme_Object * argv [] , int escape ) 
{
  Scheme_Object * port ; 
  Scheme_Output_Port * op ; 
  Scheme_Config * __funcarg185 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(port, 1), PUSH(argv, 2), PUSH(op, 3)));
# define XfOrM513_COUNT (4)
# define SETUP_XfOrM513(x) SETUP(XfOrM513_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  port = NULLED_OUT ; 
  op = NULLED_OUT ; 

# 3951 "bc/src/portfun.c"
  if (argc > 1 ) {
#   define XfOrM524_COUNT (0+XfOrM513_COUNT)
#   define SETUP_XfOrM524(x) SETUP_XfOrM513(x)

# 3952 "bc/src/portfun.c"
    if (! (scheme_is_output_port (argv [1 ] ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "output-port?" , 1 , argc , argv ) ); 
    port = argv [1 ] ; 
  }

# 3955 "bc/src/portfun.c"
  else 
  port = (__funcarg185 = FUNCCALL(SETUP_XfOrM513(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg185 , MZCONFIG_OUTPUT_PORT ) )) ; 

  op = FUNCCALL(SETUP_XfOrM513(_), scheme_output_port_record (port ) ); 

  if (escape > 0 ) {
#   define XfOrM518_COUNT (0+XfOrM513_COUNT)
#   define SETUP_XfOrM518(x) SETUP_XfOrM513(x)

# 3962 "bc/src/portfun.c"
    if (! op -> display_handler ) {
      Scheme_Object * v = argv [0 ] ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM518_COUNT)));
#     define XfOrM520_COUNT (1+XfOrM518_COUNT)
#     define SETUP_XfOrM520(x) SETUP(XfOrM520_COUNT)

# 3964 "bc/src/portfun.c"
      if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
#       define XfOrM523_COUNT (0+XfOrM520_COUNT)
#       define SETUP_XfOrM523(x) SETUP_XfOrM520(x)
        FUNCCALL(SETUP_XfOrM523(_), scheme_put_byte_string (name , port , (((Scheme_Simple_Object * ) (v ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (v ) ) -> u . byte_str_val . tag_val ) , 0 ) ); 
      }

# 3968 "bc/src/portfun.c"
      else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#       define XfOrM522_COUNT (0+XfOrM520_COUNT)
#       define SETUP_XfOrM522(x) SETUP_XfOrM520(x)
        FUNCCALL(SETUP_XfOrM522(_), scheme_put_char_string (name , port , (((Scheme_Simple_Object * ) (v ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (v ) ) -> u . char_str_val . tag_val ) ) )
# 3970 "bc/src/portfun.c"
        ; 
      }

# 3971 "bc/src/portfun.c"
      else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#       define XfOrM521_COUNT (0+XfOrM520_COUNT)
#       define SETUP_XfOrM521(x) SETUP_XfOrM520(x)
        FUNCCALL(SETUP_XfOrM521(_), scheme_put_byte_string (name , port , (char * ) v , ((char * ) ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (v ) ) ) -> s ) ) ) - ((char * ) v ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (v ) ) ) -> len ) , 0 ) )
        ; 
      }

# 3976 "bc/src/portfun.c"
      else FUNCCALL(SETUP_XfOrM520(_), scheme_internal_display (v , port ) )
      ; 
    }

# 3978 "bc/src/portfun.c"
    else {
      Scheme_Object * a [2 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM518_COUNT)));
#     define XfOrM519_COUNT (3+XfOrM518_COUNT)
#     define SETUP_XfOrM519(x) SETUP(XfOrM519_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 

# 3980 "bc/src/portfun.c"
      a [0 ] = argv [0 ] ; 
      a [1 ] = port ; 
      FUNCCALL(SETUP_XfOrM519(_), scheme_do_eval (op -> display_handler , 2 , a , - 1 ) ); 
    }
  }

# 3984 "bc/src/portfun.c"
  else if (! escape ) {

    Scheme_Object * h ; 
    BLOCK_SETUP((PUSH(h, 0+XfOrM513_COUNT)));
#   define XfOrM516_COUNT (1+XfOrM513_COUNT)
#   define SETUP_XfOrM516(x) SETUP(XfOrM516_COUNT)
    h = NULLED_OUT ; 

# 3988 "bc/src/portfun.c"
    h = op -> write_handler ; 

    if (! h )
      FUNCCALL(SETUP_XfOrM516(_), scheme_internal_write (argv [0 ] , port ) ); 
    else {
      Scheme_Object * a [2 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM516_COUNT)));
#     define XfOrM517_COUNT (3+XfOrM516_COUNT)
#     define SETUP_XfOrM517(x) SETUP(XfOrM517_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 

# 3994 "bc/src/portfun.c"
      a [0 ] = argv [0 ] ; 
      a [1 ] = port ; 
      FUNCCALL(SETUP_XfOrM517(_), scheme_do_eval (h , 2 , a , - 1 ) ); 
    }
  }

# 3998 "bc/src/portfun.c"
  else {

    Scheme_Object * h ; 
    Scheme_Object * a [3 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 3, 0+XfOrM513_COUNT), PUSH(h, 3+XfOrM513_COUNT)));
#   define XfOrM514_COUNT (4+XfOrM513_COUNT)
#   define SETUP_XfOrM514(x) SETUP(XfOrM514_COUNT)
    h = NULLED_OUT ; 
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    a[2] = NULLED_OUT ; 

# 4003 "bc/src/portfun.c"
    if (argc > 2 ) {
#     define XfOrM515_COUNT (0+XfOrM514_COUNT)
#     define SETUP_XfOrM515(x) SETUP_XfOrM514(x)

# 4004 "bc/src/portfun.c"
      h = argv [2 ] ; 
      if (! ((h ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) 
      && ! ((h ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ) )
        FUNCCALL(SETUP_XfOrM515(_), scheme_wrong_contract (name , "(or/c 0 1)" , 2 , argc , argv ) ); 
    }

# 4008 "bc/src/portfun.c"
    else 
    h = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

    a [0 ] = argv [0 ] ; 
    a [1 ] = (Scheme_Object * ) port ; 
    a [2 ] = h ; 

    h = op -> print_handler ; 

    if (! h )
      FUNCCALL(SETUP_XfOrM514(_), sch_default_print_handler (3 , a ) ); 
    else FUNCCALL(SETUP_XfOrM514(_), scheme_do_eval (h , 3 , a , - 1 ) )
    ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4026 "bc/src/portfun.c"
static Scheme_Object * 
sch_write (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4029 "bc/src/portfun.c"
  return display_write ("write" , argc , argv , 0 ) ; 
}

static Scheme_Object * 
display (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4035 "bc/src/portfun.c"
  return display_write ("display" , argc , argv , 1 ) ; 
}

static Scheme_Object * 
sch_print (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4041 "bc/src/portfun.c"
  return display_write ("print" , argc , argv , - 1 ) ; 
}

static Scheme_Object * 
newline (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port ; 
  Scheme_Config * __funcarg186 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM528_COUNT (1)
# define SETUP_XfOrM528(x) SETUP(XfOrM528_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 

# 4049 "bc/src/portfun.c"
  if (argc && ! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("newline" , "output-port?" , 0 , argc , argv ) ); 

  if (argc )
    port = argv [0 ] ; 
  else 
  port = (__funcarg186 = FUNCCALL(SETUP_XfOrM528(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg186 , MZCONFIG_OUTPUT_PORT ) )) ; 

  (void ) FUNCCALL_EMPTY(scheme_put_byte_string ("newline" , port , "\n" , 0 , 1 , 0 ) ); 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4062 "bc/src/portfun.c"
static Scheme_Object * 
write_byte_slow (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port ; 
  int v ; 
  unsigned char buffer [1 ] ; 
  Scheme_Config * __funcarg187 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM529_COUNT (1)
# define SETUP_XfOrM529(x) SETUP(XfOrM529_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 

# 4069 "bc/src/portfun.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("write-byte" , "byte?" , 0 , argc , argv ) ); 
  v = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
  if ((v < 0 ) || (v > 255 ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("write-byte" , "byte?" , 0 , argc , argv ) ); 

  if (argc > 1 ) {
#   define XfOrM530_COUNT (0+XfOrM529_COUNT)
#   define SETUP_XfOrM530(x) SETUP_XfOrM529(x)

# 4076 "bc/src/portfun.c"
    if (! (scheme_is_output_port (argv [1 ] ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("write-byte" , "output-port?" , 1 , argc , argv ) ); 
    port = argv [1 ] ; 
  }

# 4079 "bc/src/portfun.c"
  else 
  port = (__funcarg187 = FUNCCALL(SETUP_XfOrM529(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg187 , MZCONFIG_OUTPUT_PORT ) )) ; 

  buffer [0 ] = v ; 
  FUNCCALL_EMPTY(scheme_put_byte_string ("write-byte" , port , (char * ) buffer , 0 , 1 , 0 ) )


  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4091 "bc/src/portfun.c"
static Scheme_Object * 
write_byte (int argc , GC_CAN_IGNORE Scheme_Object * argv [] ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 4094 "bc/src/portfun.c"
  if ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
  && ((((intptr_t ) (argv [0 ] ) ) >> 1 ) >= 0 ) 
  && ((((intptr_t ) (argv [0 ] ) ) >> 1 ) <= 255 ) 
  && (argc > 1 ) 
  && scheme_is_output_port (argv [1 ] ) ) {
    char buffer [1 ] ; 
    buffer [0 ] = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
    scheme_put_byte_string ("write-byte" , argv [1 ] , 
    buffer , 0 , 1 , 
    0 ) ; 
    return scheme_void ; 
  }

# 4105 "bc/src/portfun.c"
  else 
  return write_byte_slow (argc , argv ) ; 
}

static Scheme_Object * 
write_char_slow (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * port ; 
  unsigned char buffer [6 ] ; 
  unsigned int ubuffer [1 ] ; 
  int len ; 
  Scheme_Config * __funcarg188 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(argv, 1)));
# define XfOrM533_COUNT (2)
# define SETUP_XfOrM533(x) SETUP(XfOrM533_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  port = NULLED_OUT ; 

# 4117 "bc/src/portfun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("write-char" , "char?" , 0 , argc , argv ) ); 
  if (argc > 1 ) {
#   define XfOrM534_COUNT (0+XfOrM533_COUNT)
#   define SETUP_XfOrM534(x) SETUP_XfOrM533(x)

# 4120 "bc/src/portfun.c"
    if (! (scheme_is_output_port (argv [1 ] ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("write-char" , "output-port?" , 1 , argc , argv ) ); 
    port = argv [1 ] ; 
  }

# 4123 "bc/src/portfun.c"
  else 
  port = (__funcarg188 = FUNCCALL(SETUP_XfOrM533(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg188 , MZCONFIG_OUTPUT_PORT ) )) ; 

  ubuffer [0 ] = (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . char_val ) ; 
  len = FUNCCALL(SETUP_XfOrM533(_), scheme_utf8_encode_all (ubuffer , 1 , buffer ) ); 
  FUNCCALL_EMPTY(scheme_put_byte_string ("write-char" , port , (char * ) buffer , 0 , len , 0 ) )


  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4136 "bc/src/portfun.c"
static Scheme_Object * 
write_char (int argc , GC_CAN_IGNORE Scheme_Object * argv [] ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 4139 "bc/src/portfun.c"
  if (argc 
  && ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) 
  && ((((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . char_val ) < 128 ) 
  && (argc > 1 ) 
  && scheme_is_output_port (argv [1 ] ) ) {
    char buffer [1 ] ; 
    buffer [0 ] = (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . char_val ) ; 
    scheme_put_byte_string ("write-char" , argv [1 ] , 
    buffer , 0 , 1 , 
    0 ) ; 
    return scheme_void ; 
  }

# 4150 "bc/src/portfun.c"
  else 
  return write_char_slow (argc , argv ) ; 
}

static Scheme_Object * port_read_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Input_Port * ip ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ip, 1)));
# define XfOrM537_COUNT (2)
# define SETUP_XfOrM537(x) SETUP(XfOrM537_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ip = NULLED_OUT ; 

# 4158 "bc/src/portfun.c"
  if (! (scheme_is_input_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-read-handler" , "input-port?" , 0 , argc , argv ) ); 

  ip = FUNCCALL(SETUP_XfOrM537(_), scheme_input_port_record (argv [0 ] ) ); 
  if (argc == 1 ) {
    if (ip -> read_handler )
      RET_VALUE_START (ip -> read_handler ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (default_read_handler ) RET_VALUE_END ; 
  }

# 4167 "bc/src/portfun.c"
  else {
#   define XfOrM538_COUNT (0+XfOrM537_COUNT)
#   define SETUP_XfOrM538(x) SETUP_XfOrM537(x)

# 4168 "bc/src/portfun.c"
    if (argv [1 ] == default_read_handler )
      ip -> read_handler = ((void * ) 0 ) ; 
    else {
#     define XfOrM539_COUNT (0+XfOrM538_COUNT)
#     define SETUP_XfOrM539(x) SETUP_XfOrM538(x)

# 4171 "bc/src/portfun.c"
      if (! FUNCCALL(SETUP_XfOrM539(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 1 , argc , argv ) )
      || ! FUNCCALL(SETUP_XfOrM539(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 1 , argc , argv ) )) {
#       define XfOrM540_COUNT (0+XfOrM539_COUNT)
#       define SETUP_XfOrM540(x) SETUP_XfOrM539(x)
        FUNCCALL_EMPTY(scheme_wrong_contract ("port-read-handler" , "(case-> (any/c . -> . any)  (any/c any/c . -> . any))" , 1 , argc , argv ) ); 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

      ip -> read_handler = argv [1 ] ; 
    }

    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4186 "bc/src/portfun.c"
static Scheme_Object * port_display_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Output_Port * op ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(op, 1)));
# define XfOrM542_COUNT (2)
# define SETUP_XfOrM542(x) SETUP(XfOrM542_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 

# 4190 "bc/src/portfun.c"
  if (! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-display-handler" , "output-port?" , 0 , argc , argv ) ); 

  op = FUNCCALL(SETUP_XfOrM542(_), scheme_output_port_record (argv [0 ] ) ); 
  if (argc == 1 ) {
    if (op -> display_handler )
      RET_VALUE_START (op -> display_handler ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (default_display_handler ) RET_VALUE_END ; 
  }

# 4199 "bc/src/portfun.c"
  else {
#   define XfOrM543_COUNT (0+XfOrM542_COUNT)
#   define SETUP_XfOrM543(x) SETUP_XfOrM542(x)
    FUNCCALL(SETUP_XfOrM543(_), scheme_check_proc_arity ("port-display-handler" , 2 , 1 , argc , argv ) )
# 4200 "bc/src/portfun.c"
    ; 
    if (argv [1 ] == default_display_handler )
      op -> display_handler = ((void * ) 0 ) ; 
    else 
    op -> display_handler = argv [1 ] ; 

    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4210 "bc/src/portfun.c"
static Scheme_Object * port_write_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Output_Port * op ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(op, 1)));
# define XfOrM545_COUNT (2)
# define SETUP_XfOrM545(x) SETUP(XfOrM545_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 

# 4214 "bc/src/portfun.c"
  if (! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-write-handler" , "output-port?" , 0 , argc , argv ) ); 

  op = FUNCCALL(SETUP_XfOrM545(_), scheme_output_port_record (argv [0 ] ) ); 
  if (argc == 1 ) {
    if (op -> write_handler )
      RET_VALUE_START (op -> write_handler ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (default_write_handler ) RET_VALUE_END ; 
  }

# 4223 "bc/src/portfun.c"
  else {
#   define XfOrM546_COUNT (0+XfOrM545_COUNT)
#   define SETUP_XfOrM546(x) SETUP_XfOrM545(x)
    FUNCCALL(SETUP_XfOrM546(_), scheme_check_proc_arity ("port-write-handler" , 2 , 1 , argc , argv ) )
# 4224 "bc/src/portfun.c"
    ; 
    if (argv [1 ] == default_write_handler )
      op -> write_handler = ((void * ) 0 ) ; 
    else 
    op -> write_handler = argv [1 ] ; 

    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4234 "bc/src/portfun.c"
static Scheme_Object * call_print_handler (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */
  return scheme_tail_apply ((Scheme_Object * ) data , 2 , argv ) ; 
}

static Scheme_Object * wrap_print_handler (Scheme_Object * proc ) 
{
  /* No conversion */

# 4242 "bc/src/portfun.c"
  return scheme_make_closed_prim_w_arity (call_print_handler , 
  proc , 
  "wrapped-port-print-handler" , 
  2 , 3 ) ; 
}

static Scheme_Object * port_print_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Output_Port * op ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(op, 1)));
# define XfOrM550_COUNT (2)
# define SETUP_XfOrM550(x) SETUP(XfOrM550_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  op = NULLED_OUT ; 

# 4252 "bc/src/portfun.c"
  if (! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-print-handler" , "output-port?" , 0 , argc , argv ) ); 

  op = FUNCCALL(SETUP_XfOrM550(_), scheme_output_port_record (argv [0 ] ) ); 
  if (argc == 1 ) {
    if (op -> print_handler )
      RET_VALUE_START (op -> print_handler ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (default_print_handler ) RET_VALUE_END ; 
  }

# 4261 "bc/src/portfun.c"
  else {
#   define XfOrM551_COUNT (0+XfOrM550_COUNT)
#   define SETUP_XfOrM551(x) SETUP_XfOrM550(x)
    FUNCCALL(SETUP_XfOrM551(_), scheme_check_proc_arity ("port-print-handler" , 2 , 1 , argc , argv ) )
# 4262 "bc/src/portfun.c"
    ; 
    if (argv [1 ] == default_print_handler )
      op -> print_handler = ((void * ) 0 ) ; 
    else if (! FUNCCALL(SETUP_XfOrM551(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 1 , argc , argv ) )) {
      Scheme_Object * wrapped ; 
      BLOCK_SETUP((PUSH(wrapped, 0+XfOrM551_COUNT)));
#     define XfOrM552_COUNT (1+XfOrM551_COUNT)
#     define SETUP_XfOrM552(x) SETUP(XfOrM552_COUNT)
      wrapped = NULLED_OUT ; 

# 4267 "bc/src/portfun.c"
      wrapped = FUNCCALL(SETUP_XfOrM552(_), wrap_print_handler (argv [1 ] ) ); 
      op -> print_handler = wrapped ; 
    }

# 4269 "bc/src/portfun.c"
    else 
    op -> print_handler = argv [1 ] ; 

    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4276 "bc/src/portfun.c"
static Scheme_Object * filter_print_handler (int argc , Scheme_Object * * argv ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM554_COUNT (1)
# define SETUP_XfOrM554(x) SETUP(XfOrM554_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4278 "bc/src/portfun.c"
  if (FUNCCALL(SETUP_XfOrM554(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 0 , argc , argv ) )) {
#   define XfOrM555_COUNT (0+XfOrM554_COUNT)
#   define SETUP_XfOrM555(x) SETUP_XfOrM554(x)

# 4279 "bc/src/portfun.c"
    if (FUNCCALL(SETUP_XfOrM555(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 0 , argc , argv ) ))
      RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(wrap_print_handler (argv [0 ] ) )) RET_VALUE_EMPTY_END ; 
  }

# 4283 "bc/src/portfun.c"
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4287 "bc/src/portfun.c"
static Scheme_Object * global_port_print_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4289 "bc/src/portfun.c"
  return scheme_param_config2 ("global-port-print-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PORT_PRINT_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , filter_print_handler , "(procedure-arity-includes/c 2)" , 1 ) ; 
}

static Scheme_Object * port_count_lines (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4297 "bc/src/portfun.c"
  if (! scheme_is_input_port (argv [0 ] ) && ! scheme_is_output_port (argv [0 ] ) )
    scheme_wrong_contract ("port-count-lines!" , "port?" , 0 , argc , argv ) ; 

  scheme_count_lines (argv [0 ] ) ; 

  return scheme_void ; 
}

static Scheme_Object * port_counts_lines_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Port * ip ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ip, 0)));
# define XfOrM558_COUNT (1)
# define SETUP_XfOrM558(x) SETUP(XfOrM558_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ip = NULLED_OUT ; 

# 4309 "bc/src/portfun.c"
  if (! (scheme_is_input_port (argv [0 ] ) ) && ! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("port-counts-lines?" , "port?" , 0 , argc , argv ) ); 

  ip = FUNCCALL(SETUP_XfOrM558(_), scheme_port_record (argv [0 ] ) ); 

  RET_VALUE_START ((ip -> count_lines ? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4317 "bc/src/portfun.c"
static Scheme_Object * global_port_count_lines (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4319 "bc/src/portfun.c"
  return scheme_param_config ("port-count-lines-enabled" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PORT_COUNT_LINES ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * port_next_location (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [3 ] ; 
  intptr_t line , col , pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0), PUSH(argv, 3)));
# define XfOrM560_COUNT (4)
# define SETUP_XfOrM560(x) SETUP(XfOrM560_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 4329 "bc/src/portfun.c"
  if (! (scheme_is_input_port (argv [0 ] ) ) && ! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL(SETUP_XfOrM560(_), scheme_wrong_contract ("port-next-location" , "port?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM560(_), scheme_tell_all (argv [0 ] , & line , & col , & pos ) )
  ; 

  a [0 ] = ((line < 0 ) ? scheme_false : FUNCCALL(SETUP_XfOrM560(_), scheme_make_integer_value (line ) )) ; 
  a [1 ] = ((col < 0 ) ? scheme_false : FUNCCALL(SETUP_XfOrM560(_), scheme_make_integer_value (col ) )) ; 
  a [2 ] = ((pos < 0 ) ? scheme_false : FUNCCALL(SETUP_XfOrM560(_), scheme_make_integer_value (pos + 1 ) )) ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM560(_), scheme_values (3 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4341 "bc/src/portfun.c"
static Scheme_Object * set_port_next_location (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4343 "bc/src/portfun.c"
  if (! scheme_is_input_port (argv [0 ] ) && ! scheme_is_output_port (argv [0 ] ) )
    scheme_wrong_contract ("set-port-next-location!" , "port?" , 0 , argc , argv ) ; 

  scheme_set_port_location (argc , argv ) ; 

  return scheme_void ; 
}

static Scheme_Object * filesystem_change_evt (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * e ; 
  int raise_errs = 1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(argv, 1)));
# define XfOrM562_COUNT (2)
# define SETUP_XfOrM562(x) SETUP(XfOrM562_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  e = NULLED_OUT ; 

# 4356 "bc/src/portfun.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("filesystem-change-evt" , "path-string?" , 0 , argc , argv ) ); 
  if (argc > 1 ) {
#   define XfOrM563_COUNT (0+XfOrM562_COUNT)
#   define SETUP_XfOrM563(x) SETUP_XfOrM562(x)

# 4359 "bc/src/portfun.c"
    if (! (((argv [1 ] ) ) == (scheme_false ) ) ) {
#     define XfOrM564_COUNT (0+XfOrM563_COUNT)
#     define SETUP_XfOrM564(x) SETUP_XfOrM563(x)
      FUNCCALL(SETUP_XfOrM564(_), scheme_check_proc_arity2 ("filesystem-change-evt" , 0 , 1 , argc , argv , 1 ) )
# 4360 "bc/src/portfun.c"
      ; 
      raise_errs = 0 ; 
    }
  }

  e = FUNCCALL(SETUP_XfOrM562(_), scheme_filesystem_change_evt (argv [0 ] , 0 , raise_errs ) ); 

  if (! e )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (argv [1 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (e ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4373 "bc/src/portfun.c"
static Scheme_Object * filesystem_change_evt_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4375 "bc/src/portfun.c"
  return (((Scheme_Type ) (scheme_filesystem_change_evt_type ) == (Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * filesystem_change_evt_cancel (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4382 "bc/src/portfun.c"
  if (! ((Scheme_Type ) (scheme_filesystem_change_evt_type ) == (Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) )
    scheme_wrong_contract ("filesystem-change-evt-cancel" , "filesystem-change-evt?" , 0 , argc , argv ) ; 

  scheme_filesystem_change_evt_cancel (argv [0 ] , ((void * ) 0 ) ) ; 

  return scheme_void ; 
}

static Scheme_Object * abs_directory_p (const char * name , Scheme_Object * d ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(d, 1)));
# define XfOrM567_COUNT (2)
# define SETUP_XfOrM567(x) SETUP(XfOrM567_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4392 "bc/src/portfun.c"
  if (! (((d ) ) == (scheme_false ) ) ) {
    char * expanded ; 
    Scheme_Object * ed ; 
    char * s ; 
    int len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM567_COUNT), PUSH(ed, 1+XfOrM567_COUNT), PUSH(expanded, 2+XfOrM567_COUNT)));
#   define XfOrM568_COUNT (3+XfOrM567_COUNT)
#   define SETUP_XfOrM568(x) SETUP(XfOrM568_COUNT)
    expanded = NULLED_OUT ; 
    ed = NULLED_OUT ; 
    s = NULLED_OUT ; 

# 4398 "bc/src/portfun.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (d ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (d ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (d ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (d ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

    ed = (((Scheme_Type ) (((((intptr_t ) (d ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (d ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ? d : FUNCCALL(SETUP_XfOrM568(_), scheme_char_string_to_path (d ) )) ; 
    s = (((Scheme_Simple_Object * ) (ed ) ) -> u . byte_str_val . string_val ) ; 
    len = (((Scheme_Simple_Object * ) (ed ) ) -> u . byte_str_val . tag_val ) ; 

    if (! FUNCCALL(SETUP_XfOrM568(_), scheme_is_complete_path (s , len , scheme_unix_path_type ) ))
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: path is not a complete path\n" "  path: %q" , name , s ) )



    ; 

    expanded = FUNCCALL(SETUP_XfOrM568(_), scheme_expand_string_filename (d , name , ((void * ) 0 ) , 0x10 ) )
    ; 
    ed = FUNCCALL_AGAIN(scheme_make_sized_path (expanded , strlen (expanded ) , 1 ) ); 

    RET_VALUE_START (ed ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4422 "bc/src/portfun.c"
static Scheme_Object * lr_abs_directory_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4424 "bc/src/portfun.c"
  return abs_directory_p ("current-load-relative-directory" , argv [0 ] ) ; 
}

static Scheme_Object * 
current_load_directory (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4430 "bc/src/portfun.c"
  return scheme_param_config2 ("current-load-relative-directory" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_LOAD_DIRECTORY ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , lr_abs_directory_p , 
  "(or/c (and/c path-string? complete-path?) #f)" , 
  1 ) ; 
}

static Scheme_Object * wr_abs_directory_p (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM571_COUNT (1)
# define SETUP_XfOrM571(x) SETUP(XfOrM571_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4440 "bc/src/portfun.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * a , * d , * r ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM571_COUNT), PUSH(d, 1+XfOrM571_COUNT), PUSH(r, 2+XfOrM571_COUNT)));
#   define XfOrM572_COUNT (3+XfOrM571_COUNT)
#   define SETUP_XfOrM572(x) SETUP(XfOrM572_COUNT)
    a = NULLED_OUT ; 
    d = NULLED_OUT ; 
    r = NULLED_OUT ; 

# 4442 "bc/src/portfun.c"
    a = FUNCCALL(SETUP_XfOrM572(_), abs_directory_p ("current-write-relative-directory" , (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . car ) ) ); 
    d = FUNCCALL_AGAIN(abs_directory_p ("current-write-relative-directory" , (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . pair_val . cdr ) ) ); 
    r = FUNCCALL_AGAIN(scheme_extract_relative_to (a , d , ((void * ) 0 ) ) ); 
    if ((a ) == (r ) )  {
#     define XfOrM573_COUNT (0+XfOrM572_COUNT)
#     define SETUP_XfOrM573(x) SETUP_XfOrM572(x)
      FUNCCALL_EMPTY(scheme_contract_error ("current-write-relative-directory" , "first path does not extend second path" , "first path" , 1 , a , "second path" , 1 , d , ((void * ) 0 ) ) )

      ; 
    }
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (a , d ) )) RET_VALUE_EMPTY_END ; 
  }

# 4453 "bc/src/portfun.c"
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(abs_directory_p ("current-write-relative-directory" , argv [0 ] ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4457 "bc/src/portfun.c"
static Scheme_Object * 
current_write_directory (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4460 "bc/src/portfun.c"
  return scheme_param_config2 ("current-write-relative-directory" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_WRITE_DIRECTORY ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , wr_abs_directory_p , 
  "(or/c (and/c path-string? complete-path?)" 
  " (cons/c (and/c path-string? complete-path?)" 
  " (and/c path-string? complete-path?))" 
  " #f)" , 
  1 ) ; 
}


static Scheme_Object * 
load_on_demand_enabled (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4475 "bc/src/portfun.c"
  return scheme_param_config ("load-on-demand-enabled" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_LOAD_DELAY_ENABLED ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}


Scheme_Object * scheme_load (const char * file ) 
{
  Scheme_Object * p [1 ] , * load_proc ; 
  mz_jmp_buf newbuf , * volatile savebuf ; 
  Scheme_Object * volatile val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSHARRAY(p, 1, 1), PUSH(savebuf, 4), PUSH(load_proc, 5)));
# define XfOrM576_COUNT (6)
# define SETUP_XfOrM576(x) SETUP(XfOrM576_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p[0] = NULLED_OUT ; 
  load_proc = NULLED_OUT ; 
  savebuf = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 4487 "bc/src/portfun.c"
  p [0 ] = FUNCCALL(SETUP_XfOrM576(_), scheme_make_path (file ) ); 
  savebuf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 
  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM576_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    val = ((void * ) 0 ) ; 
  }

# 4492 "bc/src/portfun.c"
  else {
#   define XfOrM577_COUNT (0+XfOrM576_COUNT)
#   define SETUP_XfOrM577(x) SETUP_XfOrM576(x)

# 4493 "bc/src/portfun.c"
    load_proc = FUNCCALL(SETUP_XfOrM577(_), scheme_get_startup_export ("load" ) ); 
    val = FUNCCALL(SETUP_XfOrM577(_), scheme_apply_multi (load_proc , 1 , p ) ); 
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = savebuf ; 

  RET_VALUE_START (val ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4501 "bc/src/portfun.c"
static Scheme_Object * 
flush_output (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * op ; 
  Scheme_Config * __funcarg189 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(op, 0)));
# define XfOrM579_COUNT (1)
# define SETUP_XfOrM579(x) SETUP(XfOrM579_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 

# 4506 "bc/src/portfun.c"
  if (argc && ! (scheme_is_output_port (argv [0 ] ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("flush-output" , "output-port?" , 0 , argc , argv ) ); 

  if (argc )
    op = argv [0 ] ; 
  else 
  op = (__funcarg189 = FUNCCALL(SETUP_XfOrM579(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg189 , MZCONFIG_OUTPUT_PORT ) )) ; 
  FUNCCALL_EMPTY(scheme_flush_output (op ) )
  ; 

  RET_VALUE_START ((scheme_void ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

typedef union rktio_sha_ctx_t {
  rktio_sha1_ctx_t sha1 ; 
  rktio_sha2_ctx_t sha2 ; 
}

# 4526 "bc/src/portfun.c"
rktio_sha_ctx_t ; 

static Scheme_Object * sha_bytes (const char * name , int argc , Scheme_Object * * argv , int mode ) 
{
  Scheme_Object * o ; 
  GC_CAN_IGNORE rktio_sha_ctx_t ctx ; 
  int sz ; 
  unsigned char r [32 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(argv, 1), PUSH(o, 2)));
# define XfOrM580_COUNT (3)
# define SETUP_XfOrM580(x) SETUP(XfOrM580_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 

# 4535 "bc/src/portfun.c"
  if (mode == 0 )
    (rktio_sha1_init (& ctx . sha1 ) ) ; 
  else (
  rktio_sha2_init (& ctx . sha2 , mode == 1 ) ) ; 

  o = argv [0 ] ; 
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
    intptr_t start , finish ; 
#   define XfOrM605_COUNT (0+XfOrM580_COUNT)
#   define SETUP_XfOrM605(x) SETUP_XfOrM580(x)
    FUNCCALL(SETUP_XfOrM605(_), scheme_get_substring_indices (name , o , (((argc > 2 ) && (((argv [2 ] ) ) == (scheme_false ) ) ) ? 2 : argc ) , argv , 1 , 2 , & start , & finish ) )
    ; 
    if (mode == 0 )
      (rktio_sha1_update (& ctx . sha1 , (unsigned char * ) (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) , start , finish ) ) ; 
    else (
    rktio_sha2_update (& ctx . sha2 , (unsigned char * ) (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) , start , finish ) ) ; 
  }

# 4551 "bc/src/portfun.c"
  else if (scheme_is_input_port (o ) )  {
    Scheme_Object * skip , * count ; 
    char buf [256 ] ; 
    BLOCK_SETUP((PUSH(count, 0+XfOrM580_COUNT), PUSH(skip, 1+XfOrM580_COUNT)));
#   define XfOrM584_COUNT (2+XfOrM580_COUNT)
#   define SETUP_XfOrM584(x) SETUP(XfOrM584_COUNT)
    skip = NULLED_OUT ; 
    count = NULLED_OUT ; 

# 4555 "bc/src/portfun.c"
    if (argc > 1 ) {
      intptr_t end ; 
#     define XfOrM602_COUNT (0+XfOrM584_COUNT)
#     define SETUP_XfOrM602(x) SETUP_XfOrM584(x)

# 4557 "bc/src/portfun.c"
      (void ) FUNCCALL(SETUP_XfOrM602(_), scheme_extract_index (name , 1 , argc , argv , - 1 , 0 ) ); 
      if ((argc > 2 ) && ! (((argv [2 ] ) ) == (scheme_false ) ) )
        end = FUNCCALL(SETUP_XfOrM602(_), scheme_extract_index (name , 2 , argc , argv , - 1 , 1 ) ); 
      else 
      end = - 1 ; 
      if (end >= 0 ) {
#       define XfOrM603_COUNT (0+XfOrM602_COUNT)
#       define SETUP_XfOrM603(x) SETUP_XfOrM602(x)

# 4563 "bc/src/portfun.c"
        if (FUNCCALL(SETUP_XfOrM603(_), scheme_bin_lt (argv [2 ] , argv [1 ] ) )) {
#         define XfOrM604_COUNT (0+XfOrM603_COUNT)
#         define SETUP_XfOrM604(x) SETUP_XfOrM603(x)
          FUNCCALL_EMPTY(scheme_contract_error (name , "ending index is smaller than starting index" , "starting index" , 1 , argv [1 ] , "ending index" , 1 , argv [2 ] , ((void * ) 0 ) ) )

          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        count = FUNCCALL(SETUP_XfOrM603(_), scheme_bin_minus (argv [2 ] , argv [1 ] ) ); 
      }

# 4572 "bc/src/portfun.c"
      else 
      count = scheme_false ; 
      skip = argv [1 ] ; 
    }

# 4575 "bc/src/portfun.c"
    else {
      skip = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
      count = scheme_false ; 
    }

    while (1 ) {
      intptr_t size = sizeof (buf ) , got ; 
#     define XfOrM593_COUNT (0+XfOrM584_COUNT)
#     define SETUP_XfOrM593(x) SETUP_XfOrM584(x)

# 4583 "bc/src/portfun.c"
      if (((intptr_t ) (count ) ) & 0x1 )  {
        intptr_t c = (((intptr_t ) (count ) ) >> 1 ) ; 
        if (! c )
          break ; 
        if (c < size )
          size = c ; 
      }

      got = FUNCCALL(SETUP_XfOrM593(_), scheme_get_byte_string (name , o , buf , 0 , size , 0 , 0 , ((void * ) 0 ) ) )

      ; 
      if (got == (- 1 ) )
        break ; 

      if (! (((intptr_t ) (skip ) ) & 0x1 ) ) {
#       define XfOrM599_COUNT (0+XfOrM593_COUNT)
#       define SETUP_XfOrM599(x) SETUP_XfOrM593(x)

# 4598 "bc/src/portfun.c"
        skip = FUNCCALL(SETUP_XfOrM599(_), scheme_bin_minus (skip , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (got ) ) ) << 1 ) | 0x1 ) ) ) ); 
      }

# 4599 "bc/src/portfun.c"
      else {
        intptr_t s = (((intptr_t ) (skip ) ) >> 1 ) , delta = 0 ; 
#       define XfOrM594_COUNT (0+XfOrM593_COUNT)
#       define SETUP_XfOrM594(x) SETUP_XfOrM593(x)

# 4602 "bc/src/portfun.c"
        if (s > 0 ) {
          if (s < got ) {
            delta = s ; 
            got -= s ; 
            skip = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
          }

# 4607 "bc/src/portfun.c"
          else {
            got = 0 ; 
            skip = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (s - got ) ) ) << 1 ) | 0x1 ) ) ; 
          }
        }

        if (got > 0 ) {
#         define XfOrM595_COUNT (0+XfOrM594_COUNT)
#         define SETUP_XfOrM595(x) SETUP_XfOrM594(x)

# 4614 "bc/src/portfun.c"
          if (mode == 0 )
            (rktio_sha1_update (& ctx . sha1 , (unsigned char * ) buf , delta , delta + got ) ) ; 
          else (
          rktio_sha2_update (& ctx . sha2 , (unsigned char * ) buf , delta , delta + got ) ) ; 
          if (! (((count ) ) == (scheme_false ) ) )
            count = FUNCCALL(SETUP_XfOrM595(_), scheme_bin_minus (count , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (got ) ) ) << 1 ) | 0x1 ) ) ) ); 
        }
      }
    }
  }

# 4623 "bc/src/portfun.c"
  else {
#   define XfOrM583_COUNT (0+XfOrM580_COUNT)
#   define SETUP_XfOrM583(x) SETUP_XfOrM580(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c bytes? input-port?)" , 0 , argc , argv ) )
# 4624 "bc/src/portfun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (mode == 0 ) {
#   define XfOrM582_COUNT (0+XfOrM580_COUNT)
#   define SETUP_XfOrM582(x) SETUP_XfOrM580(x)
    (
# 4629 "bc/src/portfun.c"
    rktio_sha1_final (& ctx . sha1 , r ) ) ; 
    sz = 20 ; 
  }

# 4631 "bc/src/portfun.c"
  else {
#   define XfOrM581_COUNT (0+XfOrM580_COUNT)
#   define SETUP_XfOrM581(x) SETUP_XfOrM580(x)
    (
# 4632 "bc/src/portfun.c"
    rktio_sha2_final (& ctx . sha2 , r ) ) ; 
    if (mode == 1 )
      sz = 28 ; 
    else 
    sz = 32 ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string ((char * ) r , sz , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4642 "bc/src/portfun.c"
static Scheme_Object * sha1_bytes (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4644 "bc/src/portfun.c"
  return sha_bytes ("sha1-bytes" , argc , argv , 0 ) ; 
}

static Scheme_Object * sha224_bytes (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4649 "bc/src/portfun.c"
  return sha_bytes ("sha224-bytes" , argc , argv , 1 ) ; 
}

static Scheme_Object * sha256_bytes (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4654 "bc/src/portfun.c"
  return sha_bytes ("sha256-bytes" , argc , argv , 2 ) ; 
}

# 3 "bc/src/mzmark_portfun.inc"
static int mark_indexed_string_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_indexed_string_MARK (void * p , struct NewGC * gc ) {

  Scheme_Indexed_String * is = (Scheme_Indexed_String * ) p ; 

  GC_mark2 (& (is -> string ) , gc ) ; 


  return 0 ; 
}






static int mark_indexed_string_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Indexed_String * is = (Scheme_Indexed_String * ) p ; 

  GC_fixup2 (& (is -> string ) , gc ) ; 


  return 0 ; 
}

# 45 "bc/src/mzmark_portfun.inc"
static int mark_user_input_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_user_input_MARK (void * p , struct NewGC * gc ) {

  User_Input_Port * uip = (User_Input_Port * ) p ; 

  GC_mark2 (& (uip -> read_proc ) , gc ) ; 
  GC_mark2 (& (uip -> peek_proc ) , gc ) ; 
  GC_mark2 (& (uip -> progress_evt_proc ) , gc ) ; 
  GC_mark2 (& (uip -> peeked_read_proc ) , gc ) ; 
  GC_mark2 (& (uip -> location_proc ) , gc ) ; 
  GC_mark2 (& (uip -> count_lines_proc ) , gc ) ; 
  GC_mark2 (& (uip -> buffer_mode_proc ) , gc ) ; 
  GC_mark2 (& (uip -> close_proc ) , gc ) ; 
  GC_mark2 (& (uip -> reuse_str ) , gc ) ; 
  GC_mark2 (& (uip -> peeked ) , gc ) ; 
  GC_mark2 (& (uip -> prefix_pipe ) , gc ) ; 

  return 0 ; 
}






static int mark_user_input_FIXUP (void * p , struct NewGC * gc ) {

  User_Input_Port * uip = (User_Input_Port * ) p ; 

  GC_fixup2 (& (uip -> read_proc ) , gc ) ; 
  GC_fixup2 (& (uip -> peek_proc ) , gc ) ; 
  GC_fixup2 (& (uip -> progress_evt_proc ) , gc ) ; 
  GC_fixup2 (& (uip -> peeked_read_proc ) , gc ) ; 
  GC_fixup2 (& (uip -> location_proc ) , gc ) ; 
  GC_fixup2 (& (uip -> count_lines_proc ) , gc ) ; 
  GC_fixup2 (& (uip -> buffer_mode_proc ) , gc ) ; 
  GC_fixup2 (& (uip -> close_proc ) , gc ) ; 
  GC_fixup2 (& (uip -> reuse_str ) , gc ) ; 
  GC_fixup2 (& (uip -> peeked ) , gc ) ; 
  GC_fixup2 (& (uip -> prefix_pipe ) , gc ) ; 

  return 0 ; 
}

# 105 "bc/src/mzmark_portfun.inc"
static int mark_user_output_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_user_output_MARK (void * p , struct NewGC * gc ) {

  User_Output_Port * uop = (User_Output_Port * ) p ; 

  GC_mark2 (& (uop -> evt ) , gc ) ; 
  GC_mark2 (& (uop -> write_evt_proc ) , gc ) ; 
  GC_mark2 (& (uop -> write_proc ) , gc ) ; 
  GC_mark2 (& (uop -> write_special_evt_proc ) , gc ) ; 
  GC_mark2 (& (uop -> write_special_proc ) , gc ) ; 
  GC_mark2 (& (uop -> location_proc ) , gc ) ; 
  GC_mark2 (& (uop -> count_lines_proc ) , gc ) ; 
  GC_mark2 (& (uop -> buffer_mode_proc ) , gc ) ; 
  GC_mark2 (& (uop -> close_proc ) , gc ) ; 
  GC_mark2 (& (uop -> buffer_pipe ) , gc ) ; 

  return 0 ; 
}






static int mark_user_output_FIXUP (void * p , struct NewGC * gc ) {

  User_Output_Port * uop = (User_Output_Port * ) p ; 

  GC_fixup2 (& (uop -> evt ) , gc ) ; 
  GC_fixup2 (& (uop -> write_evt_proc ) , gc ) ; 
  GC_fixup2 (& (uop -> write_proc ) , gc ) ; 
  GC_fixup2 (& (uop -> write_special_evt_proc ) , gc ) ; 
  GC_fixup2 (& (uop -> write_special_proc ) , gc ) ; 
  GC_fixup2 (& (uop -> location_proc ) , gc ) ; 
  GC_fixup2 (& (uop -> count_lines_proc ) , gc ) ; 
  GC_fixup2 (& (uop -> buffer_mode_proc ) , gc ) ; 
  GC_fixup2 (& (uop -> close_proc ) , gc ) ; 
  GC_fixup2 (& (uop -> buffer_pipe ) , gc ) ; 

  return 0 ; 
}

# 4667 "bc/src/portfun.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_indexed_string , mark_indexed_string_SIZE , mark_indexed_string_MARK , mark_indexed_string_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_user_input , mark_user_input_SIZE , mark_user_input_MARK , mark_user_input_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_user_output , mark_user_output_SIZE , mark_user_output_MARK , mark_user_output_FIXUP , 1 , 0 ) ; 
}
