#include "precomp.h"

# 2 "bc/src/schcpt.h"
enum {
  CPT_ESCAPE , 
  CPT_SYMBOL , 
  CPT_SYMREF , 
  CPT_WEIRD_SYMBOL , 
  CPT_KEYWORD , 
  CPT_BYTE_STRING , 
  CPT_CHAR_STRING , 
  CPT_CHAR , 
  CPT_INT , 
  CPT_NULL , 
  CPT_TRUE , 
  CPT_FALSE , 
  CPT_VOID , 
  CPT_BOX , 
  CPT_PAIR , 
  CPT_LIST , 
  CPT_VECTOR , 
  CPT_HASH_TABLE , 
  CPT_LET_ONE_TYPED , 
  CPT_LINKLET , 
  CPT_QUOTE , 
  CPT_REFERENCE , 
  CPT_LOCAL , 
  CPT_LOCAL_UNBOX , 
  CPT_SVECTOR , 
  CPT_APPLICATION , 
  CPT_LET_ONE , 
  CPT_BRANCH , 
  CPT_PATH , 
  CPT_CLOSURE , 
  CPT_DELAY_REF , 
  CPT_PREFAB , 
  CPT_PREFAB_TYPE , 
  CPT_LET_ONE_UNUSED , 
  CPT_SHARED , 
  CPT_TOPLEVEL , 
  CPT_BEGIN , 
  CPT_BEGIN0 , 
  CPT_LET_VALUE , 
  CPT_LET_VOID , 
  CPT_LETREC , 
  CPT_WCM , 
  CPT_DEFINE_VALUES , 
  CPT_SET_BANG , 
  CPT_VARREF , 
  CPT_APPLY_VALUES , 
  CPT_OTHER_FORM , 
  CPT_SRCLOC , 
  _CPT_COUNT_ }
; 

# 46 "/usr/include/ctype.h" 3
enum 
{
  _ISupper = (1 << (0 ) ) , 
  _ISlower = (1 << (1 ) ) , 
  _ISalpha = (1 << (2 ) ) , 
  _ISdigit = (1 << (3 ) ) , 
  _ISxdigit = (1 << (4 ) ) , 
  _ISspace = (1 << (5 ) ) , 
  _ISprint = (1 << (6 ) ) , 
  _ISgraph = (1 << (7 ) ) , 
  _ISblank = (1 << (8 ) ) , 
  _IScntrl = (1 << (9 ) ) , 
  _ISpunct = (1 << (10 ) ) , 
  _ISalnum = (1 << (11 ) ) }
; 

# 81 "/usr/include/ctype.h" 3
extern const __int32_t * * __ctype_tolower_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 
extern const __int32_t * * __ctype_toupper_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 

# 122 "/usr/include/ctype.h" 3
extern int tolower (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 


extern int toupper (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 206 "/usr/include/ctype.h" 3
extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) tolower (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_tolower_loc () ) [__c ] : __c ; 
}

extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) toupper (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_toupper_loc () ) [__c ] : __c ; 
}

# 10 "bc/src/print.c"
int (* scheme_check_print_is_obj ) (Scheme_Object * o ) ; 


; 
; 

; 


static Scheme_Type_Printer * printers ; 
static int printers_count ; 

; 


static char compacts [_CPT_COUNT_ ] ; 

Scheme_Object * quote_symbol ; 
Scheme_Object * quasiquote_symbol ; 
Scheme_Object * unquote_symbol ; 
Scheme_Object * unquote_splicing_symbol ; 
Scheme_Object * syntax_symbol ; 
Scheme_Object * quasisyntax_symbol ; 
Scheme_Object * unsyntax_symbol ; 
Scheme_Object * unsyntax_splicing_symbol ; 
Scheme_Object * qq_ellipses ; 

# 58 "bc/src/print.c"
typedef struct Scheme_Print_Params {
  Scheme_Type type ; 

  char print_struct ; 
  char print_graph ; 
  char print_box ; 
  char print_vec_shorthand ; 
  char print_hash_table ; 
  char print_unreadable ; 
  char print_pair_curly , print_mpair_curly ; 
  char print_reader ; 
  char print_long_bools ; 
  char can_read_pipe_quote ; 
  char case_sens ; 
  Scheme_Object * inspector ; 

  char printing_quoted ; 


  char * print_buffer ; 
  intptr_t print_position ; 
  intptr_t print_allocated ; 
  intptr_t print_maxlen ; 
  intptr_t print_offset ; 
  intptr_t print_syntax ; 
  Scheme_Object * print_port ; 
  mz_jmp_buf * print_escape ; 
  Scheme_Object * depth_delta ; 
  Scheme_Hash_Table * uq_ht ; 
}

# 87 "bc/src/print.c"
PrintParams ; 


static void register_traversers (void ) ; 


static void print_to_port (char * name , Scheme_Object * obj , Scheme_Object * port , 
int notdisplay , intptr_t maxl , Scheme_Object * qq_depth ) ; 
static int print (Scheme_Object * obj , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * p ) ; 
static void print_char_string (const char * s , int l , const mzchar * us , int delta , int ul , 
int notdisplay , PrintParams * pp ) ; 
static void print_byte_string (const char * s , int delta , int l , int notdisplay , PrintParams * pp ) ; 
static void print_pair (Scheme_Object * pair , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
Scheme_Type type , int round_parens , int first_unquoted ) ; 
static void print_vector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) ; 
static void print_flvector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) ; 
static void print_fxvector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) ; 
static void print_char (Scheme_Object * chobj , int notdisplay , PrintParams * pp ) ; 
static char * print_to_string (Scheme_Object * obj , intptr_t * volatile len , int write , 
Scheme_Object * port , intptr_t maxl , 
Scheme_Object * qq_depth , int * _release_to_quick ) ; 

static void custom_write_struct (Scheme_Object * s , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , int notdisplay ) ; 

static int writable_struct_subs (Scheme_Object * s , int for_write , PrintParams * pp , 
int mode , Scheme_Hash_Table * ht , int * counter ) ; 




static Scheme_Object * srcloc_path_to_string (Scheme_Object * p ) ; 

# 176 "bc/src/print.c"
void scheme_init_print (Scheme_Startup_Env * env ) 
{
  /* No conversion */

# 178 "bc/src/print.c"
  int i ; 

  for (i = 0 ; i < _CPT_COUNT_ ; i ++ ) {
    compacts [i ] = i ; 
  }

  scheme_register_static ((void * ) & quote_symbol , sizeof (quote_symbol ) ) ; 
  scheme_register_static ((void * ) & quasiquote_symbol , sizeof (quasiquote_symbol ) ) ; 
  scheme_register_static ((void * ) & unquote_symbol , sizeof (unquote_symbol ) ) ; 
  scheme_register_static ((void * ) & unquote_splicing_symbol , sizeof (unquote_splicing_symbol ) ) ; 
  scheme_register_static ((void * ) & syntax_symbol , sizeof (syntax_symbol ) ) ; 
  scheme_register_static ((void * ) & quasisyntax_symbol , sizeof (quasisyntax_symbol ) ) ; 
  scheme_register_static ((void * ) & unsyntax_symbol , sizeof (unsyntax_symbol ) ) ; 
  scheme_register_static ((void * ) & unsyntax_splicing_symbol , sizeof (unsyntax_splicing_symbol ) ) ; 
  scheme_register_static ((void * ) & qq_ellipses , sizeof (qq_ellipses ) ) ; 
  quote_symbol = scheme_intern_symbol ("quote" ) ; 
  quasiquote_symbol = scheme_intern_symbol ("quasiquote" ) ; 
  unquote_symbol = scheme_intern_symbol ("unquote" ) ; 
  unquote_splicing_symbol = scheme_intern_symbol ("unquote-splicing" ) ; 
  syntax_symbol = scheme_intern_symbol ("syntax" ) ; 
  quasisyntax_symbol = scheme_intern_symbol ("quasisyntax" ) ; 
  unsyntax_symbol = scheme_intern_symbol ("unsyntax" ) ; 
  unsyntax_splicing_symbol = scheme_intern_symbol ("unsyntax-splicing" ) ; 
  qq_ellipses = scheme_make_symbol ("..." ) ; 


  register_traversers () ; 
}


void scheme_init_print_buffers_places () 
{
  /* No conversion */

# 210 "bc/src/print.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) = (char * ) GC_malloc_atomic (100 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) = (char * ) GC_malloc_atomic (256 ) ; 
}

Scheme_Object * scheme_make_svector (mzshort c , mzshort * a ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(a, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 222 "bc/src/print.c"
  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM5(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  o -> type = scheme_svector_type ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . len ) = c ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . vec ) = a ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 231 "bc/src/print.c"
PrintParams * copy_print_params (PrintParams * pp ) 
{
  PrintParams * pp2 ; 
  DECL_RET_SAVE (PrintParams * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(pp2, 1)));
# define XfOrM6_COUNT (2)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pp2 = NULLED_OUT ; 

# 235 "bc/src/print.c"
  pp2 = ((PrintParams * ) FUNCCALL(SETUP_XfOrM6(_), GC_malloc_one_small_tagged ((((sizeof (PrintParams ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (pp2 , pp , sizeof (PrintParams ) ) ) ; 

  pp2 -> type = scheme_rt_print_params ; 

  RET_VALUE_START (pp2 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 243 "bc/src/print.c"
void 
scheme_debug_print (Scheme_Object * obj ) 
{
  /* No conversion */

# 246 "bc/src/print.c"
  scheme_write (obj , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdout_port_ ) ) ; 
  scheme_flush_output (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdout_port_ ) ) ; 
}

static void * print_to_port_k (void ) 
{
  /* No conversion */

# 252 "bc/src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * obj , * port , * depth ; 

  port = (Scheme_Object * ) p -> ku . k . p1 ; 
  obj = (Scheme_Object * ) p -> ku . k . p2 ; 
  depth = (Scheme_Object * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  print_to_port ((p -> ku . k . i2 
  ? ((p -> ku . k . i2 == 2 ) 
  ? "print" 
  : "write" ) 
  : "display" ) , 
  obj , port , 
  p -> ku . k . i2 , p -> ku . k . i1 , 
  depth ) ; 

  return ((void * ) 0 ) ; 
}

static void do_handled_print (Scheme_Object * obj , Scheme_Object * port , 
Scheme_Object * proc , intptr_t maxl ) 
{
  Scheme_Object * a [2 ] ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSHARRAY(a, 2, 1), PUSH(proc, 4)));
# define XfOrM9_COUNT (5)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 280 "bc/src/print.c"
  a [0 ] = obj ; 

  if (maxl > 0 ) {
#   define XfOrM11_COUNT (0+XfOrM9_COUNT)
#   define SETUP_XfOrM11(x) SETUP_XfOrM9(x)

# 283 "bc/src/print.c"
    a [1 ] = FUNCCALL(SETUP_XfOrM11(_), scheme_make_byte_string_output_port () ); 
  }

# 284 "bc/src/print.c"
  else 
  a [1 ] = port ; 
  FUNCCALL(SETUP_XfOrM9(_), scheme_apply_multi (proc , 2 , a ) )
  ; 

  if (maxl > 0 ) {
    char * s ; 
    intptr_t len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM9_COUNT)));
#   define XfOrM10_COUNT (1+XfOrM9_COUNT)
#   define SETUP_XfOrM10(x) SETUP(XfOrM10_COUNT)
    s = NULLED_OUT ; 

# 293 "bc/src/print.c"
    s = FUNCCALL(SETUP_XfOrM10(_), scheme_get_sized_byte_string_output (a [1 ] , & len ) ); 
    if (len > maxl )
      len = maxl ; 
    FUNCCALL(SETUP_XfOrM10(_), scheme_write_byte_string (s , len , port ) )
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 301 "bc/src/print.c"
static int can_print_fast (Scheme_Object * obj ) 
{
  /* No conversion */
  return (((((intptr_t ) (obj ) ) & 0x1 ) || ((((obj ) -> type ) >= scheme_bignum_type ) && (((obj ) -> type ) <= scheme_complex_type ) ) ) 
  || (((obj ) == (scheme_true ) ) || ((obj ) == (scheme_false ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ; 
}

void scheme_write_w_max (Scheme_Object * obj , Scheme_Object * port , intptr_t maxl ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(obj, 1)));
# define XfOrM13_COUNT (2)
# define SETUP_XfOrM13(x) SETUP(XfOrM13_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 311 "bc/src/print.c"
  if (((Scheme_Output_Port * ) port ) -> write_handler )
    FUNCCALL(SETUP_XfOrM13(_), do_handled_print (obj , port , scheme_write_proc , maxl ) ); 
  else if (FUNCCALL(SETUP_XfOrM13(_), can_print_fast (obj ) ))
    FUNCCALL(SETUP_XfOrM13(_), print_to_port ("write" , obj , port , 1 , maxl , ((void * ) 0 ) ) ); 
  else {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM14_COUNT (0+XfOrM13_COUNT)
#   define SETUP_XfOrM14(x) SETUP_XfOrM13(x)

# 318 "bc/src/print.c"
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 1 ; 
    p -> ku . k . p3 = ((void * ) 0 ) ; 

    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 328 "bc/src/print.c"
void scheme_write (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 330 "bc/src/print.c"
  scheme_write_w_max (obj , port , - 1 ) ; 
}

void scheme_display_w_max (Scheme_Object * obj , Scheme_Object * port , intptr_t maxl ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(obj, 1)));
# define XfOrM16_COUNT (2)
# define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 335 "bc/src/print.c"
  if (((Scheme_Output_Port * ) port ) -> display_handler )
    FUNCCALL(SETUP_XfOrM16(_), do_handled_print (obj , port , scheme_display_proc , maxl ) ); 
  else if (FUNCCALL(SETUP_XfOrM16(_), can_print_fast (obj ) ))
    FUNCCALL(SETUP_XfOrM16(_), print_to_port ("display" , obj , port , 0 , maxl , ((void * ) 0 ) ) ); 
  else {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM17_COUNT (0+XfOrM16_COUNT)
#   define SETUP_XfOrM17(x) SETUP_XfOrM16(x)

# 342 "bc/src/print.c"
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 0 ; 
    p -> ku . k . p3 = ((void * ) 0 ) ; 

    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 352 "bc/src/print.c"
void scheme_display (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 354 "bc/src/print.c"
  scheme_display_w_max (obj , port , - 1 ) ; 
}

void scheme_print_w_max (Scheme_Object * obj , Scheme_Object * port , intptr_t maxl ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(obj, 1)));
# define XfOrM19_COUNT (2)
# define SETUP_XfOrM19(x) SETUP(XfOrM19_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 359 "bc/src/print.c"
  if (((Scheme_Output_Port * ) port ) -> print_handler )
    FUNCCALL(SETUP_XfOrM19(_), do_handled_print (obj , port , scheme_print_proc , maxl ) ); 
  else if (FUNCCALL(SETUP_XfOrM19(_), can_print_fast (obj ) ))
    FUNCCALL(SETUP_XfOrM19(_), print_to_port ("print" , obj , port , 2 , maxl , ((void * ) 0 ) ) ); 
  else {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM20_COUNT (0+XfOrM19_COUNT)
#   define SETUP_XfOrM20(x) SETUP_XfOrM19(x)

# 366 "bc/src/print.c"
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 2 ; 
    p -> ku . k . p3 = ((void * ) 0 ) ; 

    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 376 "bc/src/print.c"
void scheme_print (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 378 "bc/src/print.c"
  scheme_print_w_max (obj , port , - 1 ) ; 
}

static void * print_to_string_k (void ) 
{
  /* No conversion */

# 383 "bc/src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * obj , * qq_depth ; 
  intptr_t * len , maxl ; 
  int iswrite ; 

  obj = (Scheme_Object * ) p -> ku . k . p1 ; 
  len = (intptr_t * ) (void * ) p -> ku . k . p2 ; 
  maxl = p -> ku . k . i1 ; 
  iswrite = p -> ku . k . i2 ; 
  qq_depth = (Scheme_Object * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return (void * ) print_to_string (obj , len , iswrite , ((void * ) 0 ) , maxl , qq_depth , ((void * ) 0 ) ) ; 
}

char * scheme_write_to_string_w_max (Scheme_Object * obj , intptr_t * len , intptr_t maxl ) 
{
  /* No conversion */

# 403 "bc/src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 1 ; 
  p -> ku . k . i3 = 0 ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}

char * scheme_write_to_string (Scheme_Object * obj , intptr_t * len ) 
{
  /* No conversion */

# 417 "bc/src/print.c"
  return scheme_write_to_string_w_max (obj , len , - 1 ) ; 
}

char * scheme_display_to_string_w_max (Scheme_Object * obj , intptr_t * len , intptr_t maxl ) 
{
  /* No conversion */

# 422 "bc/src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 0 ; 
  p -> ku . k . i3 = 0 ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}

char * scheme_display_to_string (Scheme_Object * obj , intptr_t * len ) 
{
  /* No conversion */

# 436 "bc/src/print.c"
  return scheme_display_to_string_w_max (obj , len , - 1 ) ; 
}

char * scheme_print_to_string_w_max (Scheme_Object * obj , intptr_t * len , intptr_t maxl ) 
{
  /* No conversion */

# 441 "bc/src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 2 ; 
  p -> ku . k . i3 = 1 ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}

char * scheme_print_to_string (Scheme_Object * obj , intptr_t * len ) 
{
  /* No conversion */

# 455 "bc/src/print.c"
  return scheme_print_to_string_w_max (obj , len , - 1 ) ; 
}

void 
scheme_internal_write (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 461 "bc/src/print.c"
  print_to_port ("write" , obj , port , 1 , - 1 , ((void * ) 0 ) ) ; 
}

void 
scheme_internal_display (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 467 "bc/src/print.c"
  print_to_port ("display" , obj , port , 0 , - 1 , ((void * ) 0 ) ) ; 
}

void 
scheme_internal_print (Scheme_Object * obj , Scheme_Object * port , Scheme_Object * depth ) 
{
  /* No conversion */

# 473 "bc/src/print.c"
  print_to_port ("print" , obj , port , 2 , - 1 , depth ) ; 
}


static int check_cycles (Scheme_Object * , int , Scheme_Hash_Table * ht , PrintParams * ) ; 

static Scheme_Object * check_cycle_k (void ) 
{
  /* No conversion */

# 481 "bc/src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (check_cycles (o , p -> ku . k . i1 , ht , pp ) ) ) ) << 1 ) | 0x1 ) ) ; 
}





static int check_cycles (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , PrintParams * pp ) 


{
  Scheme_Type t ; 
  Scheme_Object * val ; 
  int res , res2 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(ht, 1), PUSH(obj, 2), PUSH(val, 3)));
# define XfOrM33_COUNT (4)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  val = NULLED_OUT ; 

# 506 "bc/src/print.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM67_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM67(x) SETUP_XfOrM33(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 508 "bc/src/print.c"
    {
#     define XfOrM68_COUNT (0+XfOrM67_COUNT)
#     define SETUP_XfOrM68(x) SETUP_XfOrM67(x)

# 509 "bc/src/print.c"
      pp = FUNCCALL(SETUP_XfOrM68(_), copy_print_params (pp ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 = (void * ) obj ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p2 = (void * ) ht ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p3 = (void * ) pp ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . i1 = for_write ; 
      RET_VALUE_START ((((intptr_t ) (FUNCCALL(SETUP_XfOrM68(_), scheme_handle_stack_overflow (check_cycle_k ) )) ) >> 1 ) ) RET_VALUE_END ; 
    }
  }

  {
#   define XfOrM65_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM65(x) SETUP_XfOrM33(x)

# 518 "bc/src/print.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM66_COUNT (0+XfOrM65_COUNT)
#     define SETUP_XfOrM66(x) SETUP_XfOrM65(x)
      FUNCCALL(SETUP_XfOrM66(_), scheme_out_of_fuel () )
# 518 "bc/src/print.c"
      ; 
    }
  }

# 518 "bc/src/print.c"
  ; 

  t = ((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) 
  || (pp -> print_box && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) 
  || (((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && ((pp -> print_struct 
  && (FUNCCALL(SETUP_XfOrM33(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ) 
  || FUNCCALL(SETUP_XfOrM33(_), scheme_is_writable_struct (obj ) )) ) 
  || (pp -> print_hash_table 
  && (((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
  || ((t >= scheme_hash_tree_type ) 
  && (t <= scheme_hash_tree_indirection_type ) ) ) ) ) {
#   define XfOrM64_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM64(x) SETUP_XfOrM33(x)

# 537 "bc/src/print.c"
    val = FUNCCALL(SETUP_XfOrM64(_), scheme_hash_get (ht , obj ) ); 
    if (val )
      RET_VALUE_START ((((intptr_t ) (val ) ) >> 1 ) ) RET_VALUE_END ; 
    FUNCCALL(SETUP_XfOrM64(_), scheme_hash_set (ht , obj , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0x2 ) ) ) << 1 ) | 0x1 ) ) ) ); 
  }

# 541 "bc/src/print.c"
  else 
  RET_VALUE_START (0 ) RET_VALUE_END ; 

  if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#   define XfOrM63_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM63(x) SETUP_XfOrM33(x)

# 545 "bc/src/print.c"
    res = FUNCCALL(SETUP_XfOrM63(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , for_write , ht , pp ) ); 
    if ((for_write < 3 ) && (res & 0x2 ) )
      RET_VALUE_START (res ) RET_VALUE_END ; 
    res2 = FUNCCALL(SETUP_XfOrM63(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , for_write , ht , pp ) ); 
    res |= res2 ; 
  }

# 550 "bc/src/print.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) )  {
#   define XfOrM62_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM62(x) SETUP_XfOrM33(x)

# 551 "bc/src/print.c"
    res = FUNCCALL(SETUP_XfOrM62(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , for_write , ht , pp ) ); 
    if ((for_write < 3 ) && (res & 0x2 ) )
      RET_VALUE_START (res ) RET_VALUE_END ; 
    res2 = FUNCCALL(SETUP_XfOrM62(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , for_write , ht , pp ) ); 
    res |= res2 ; 
    if (for_write >= 3 )
      res |= 0x1 ; 
  }

# 558 "bc/src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) )  {

    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM33_COUNT)));
#   define XfOrM61_COUNT (1+XfOrM33_COUNT)
#   define SETUP_XfOrM61(x) SETUP(XfOrM61_COUNT)
    v = NULLED_OUT ; 

# 561 "bc/src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
      v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
    else 
    v = FUNCCALL(SETUP_XfOrM61(_), scheme_unbox (obj ) ); 
    res = FUNCCALL(SETUP_XfOrM61(_), check_cycles (v , for_write , ht , pp ) ); 
  }

# 566 "bc/src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) )  {
    int i , len ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM33_COUNT)));
#   define XfOrM58_COUNT (1+XfOrM33_COUNT)
#   define SETUP_XfOrM58(x) SETUP(XfOrM58_COUNT)
    v = NULLED_OUT ; 

# 570 "bc/src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
      len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 
    else 
    len = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> size ) ; 
    res = 0 ; 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM60_COUNT (0+XfOrM58_COUNT)
#     define SETUP_XfOrM60(x) SETUP_XfOrM58(x)

# 576 "bc/src/print.c"
      if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
        v = (((Scheme_Vector * ) (obj ) ) -> els ) [i ] ; 
      else 
      v = FUNCCALL(SETUP_XfOrM60(_), scheme_chaperone_vector_ref (obj , i ) ); 
      res2 = FUNCCALL(SETUP_XfOrM60(_), check_cycles (v , for_write , ht , pp ) ); 
      res |= res2 ; 
      if ((for_write < 3 ) && (res & 0x2 ) )
        RET_VALUE_START (res ) RET_VALUE_END ; 
    }
  }

# 585 "bc/src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) ) {
    res = 0x1 ; 
  }

# 588 "bc/src/print.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) )  {
    Scheme_Stencil_Vector * sv = (Scheme_Stencil_Vector * ) obj ; 
    int i , len ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM33_COUNT), PUSH(sv, 1+XfOrM33_COUNT)));
#   define XfOrM54_COUNT (2+XfOrM33_COUNT)
#   define SETUP_XfOrM54(x) SETUP(XfOrM54_COUNT)
    v = NULLED_OUT ; 

# 592 "bc/src/print.c"
    if (for_write > 1 )

# 592 "bc/src/print.c"
    for_write = 1 ; 

    len = (scheme_stencil_vector_popcount (sv -> mask ) ) ; 

    res = 0 ; 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM56_COUNT (0+XfOrM54_COUNT)
#     define SETUP_XfOrM56(x) SETUP_XfOrM54(x)

# 598 "bc/src/print.c"
      v = sv -> els [i ] ; 
      res2 = FUNCCALL(SETUP_XfOrM56(_), check_cycles (v , for_write , ht , pp ) ); 
      res |= res2 ; 
      if (res & 0x2 )
        RET_VALUE_START (res ) RET_VALUE_END ; 
    }
  }

# 604 "bc/src/print.c"
  else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) )  {
#   define XfOrM44_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM44(x) SETUP_XfOrM33(x)

# 605 "bc/src/print.c"
    if (FUNCCALL(SETUP_XfOrM44(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM50_COUNT (0+XfOrM44_COUNT)
#     define SETUP_XfOrM50(x) SETUP_XfOrM44(x)

# 606 "bc/src/print.c"
      if (pp -> print_unreadable ) {
#       define XfOrM51_COUNT (0+XfOrM50_COUNT)
#       define SETUP_XfOrM51(x) SETUP_XfOrM50(x)

# 607 "bc/src/print.c"
        res = FUNCCALL(SETUP_XfOrM51(_), writable_struct_subs (obj , for_write , pp , 1 , ht , ((void * ) 0 ) ) ); 

        if (for_write >= 3 ) {
          Scheme_Object * kind ; 
          BLOCK_SETUP((PUSH(kind, 0+XfOrM51_COUNT)));
#         define XfOrM52_COUNT (1+XfOrM51_COUNT)
#         define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
          kind = NULLED_OUT ; 

# 611 "bc/src/print.c"
          kind = FUNCCALL(SETUP_XfOrM52(_), scheme_print_attribute_ref (obj ) ); 

          if (kind ) {
#           define XfOrM53_COUNT (0+XfOrM52_COUNT)
#           define SETUP_XfOrM53(x) SETUP_XfOrM52(x)

# 614 "bc/src/print.c"
            if (! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "never" ) ) )
              res |= 0x1 ; 
            if (! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "always" ) ) 
            || ! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "self" ) ) )
              res -= (res & 0x1 ) ; 
          }

# 619 "bc/src/print.c"
          else 
          res -= (res & 0x1 ) ; 
        }
      }

# 622 "bc/src/print.c"
      else 
      res = 0 ; 
    }

# 624 "bc/src/print.c"
    else {

      int i ; 
#     define XfOrM45_COUNT (0+XfOrM44_COUNT)
#     define SETUP_XfOrM45(x) SETUP_XfOrM44(x)

# 628 "bc/src/print.c"
      if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        i = ((((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype ) -> num_slots ) ; 
      else 
      i = ((((Scheme_Structure * ) obj ) -> stype ) -> num_slots ) ; 

      if ((for_write >= 3 ) && ! ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) )
        res = 0x1 ; 
      else 
      res = 0 ; 
      while (i -- ) {
#       define XfOrM48_COUNT (0+XfOrM45_COUNT)
#       define SETUP_XfOrM48(x) SETUP_XfOrM45(x)

# 638 "bc/src/print.c"
        if (FUNCCALL(SETUP_XfOrM48(_), scheme_inspector_sees_part (obj , pp -> inspector , i ) )) {
#         define XfOrM49_COUNT (0+XfOrM48_COUNT)
#         define SETUP_XfOrM49(x) SETUP_XfOrM48(x)

# 639 "bc/src/print.c"
          if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
            val = FUNCCALL(SETUP_XfOrM49(_), scheme_struct_ref (obj , i ) ); 
          else 
          val = ((Scheme_Structure * ) obj ) -> slots [i ] ; 
          res2 = FUNCCALL(SETUP_XfOrM49(_), check_cycles (val , for_write , ht , pp ) ); 
          res |= res2 ; 
          if ((for_write < 3 ) && (res & 0x2 ) )
            RET_VALUE_START (res ) RET_VALUE_END ; 
        }
      }
    }
  }

# 650 "bc/src/print.c"
  else if (((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) )  {

    Scheme_Hash_Table * t ; 
    Scheme_Object * * keys , * * vals , * val , * key ; 
    int i , size ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM33_COUNT), PUSH(vals, 1+XfOrM33_COUNT), PUSH(keys, 2+XfOrM33_COUNT), PUSH(t, 3+XfOrM33_COUNT), PUSH(val, 4+XfOrM33_COUNT)));
#   define XfOrM37_COUNT (5+XfOrM33_COUNT)
#   define SETUP_XfOrM37(x) SETUP(XfOrM37_COUNT)
    t = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    key = NULLED_OUT ; 

# 656 "bc/src/print.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      t = (Scheme_Hash_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    t = (Scheme_Hash_Table * ) obj ; 

    keys = t -> keys ; 
    vals = t -> vals ; 
    size = t -> size ; 
    res = 0 ; 
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM41_COUNT (0+XfOrM37_COUNT)
#     define SETUP_XfOrM41(x) SETUP_XfOrM37(x)

# 666 "bc/src/print.c"
      if (vals [i ] ) {
#       define XfOrM42_COUNT (0+XfOrM41_COUNT)
#       define SETUP_XfOrM42(x) SETUP_XfOrM41(x)

# 667 "bc/src/print.c"
        key = keys [i ] ; 
        if (! (((Scheme_Object * ) t ) == (obj ) ) )
          val = FUNCCALL(SETUP_XfOrM42(_), scheme_chaperone_hash_traversal_get (obj , key , & key ) ); 
        else 
        val = vals [i ] ; 
        if (val ) {
#         define XfOrM43_COUNT (0+XfOrM42_COUNT)
#         define SETUP_XfOrM43(x) SETUP_XfOrM42(x)

# 673 "bc/src/print.c"
          res2 = FUNCCALL(SETUP_XfOrM43(_), check_cycles (key , for_write , ht , pp ) ); 
          res |= res2 ; 
          if ((for_write < 3 ) && (res & 0x2 ) )
            RET_VALUE_START (res ) RET_VALUE_END ; 
          res2 = FUNCCALL(SETUP_XfOrM43(_), check_cycles (val , for_write , ht , pp ) ); 
          res |= res2 ; 
          if ((for_write < 3 ) && (res & 0x2 ) )
            RET_VALUE_START (res ) RET_VALUE_END ; 
        }
      }
    }
  }

# 684 "bc/src/print.c"
  else if (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) )  {

    Scheme_Hash_Tree * t ; 
    Scheme_Object * key , * val ; 
    mzlonglong i ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM33_COUNT), PUSH(t, 1+XfOrM33_COUNT), PUSH(val, 2+XfOrM33_COUNT)));
#   define XfOrM34_COUNT (3+XfOrM33_COUNT)
#   define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
    t = NULLED_OUT ; 
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 

# 690 "bc/src/print.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      t = (Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    t = (Scheme_Hash_Tree * ) obj ; 

    res = 0 ; 
    i = (scheme_hash_tree_next (t , - 1 ) ) ; 
    while (i != - 1 ) {
#     define XfOrM36_COUNT (0+XfOrM34_COUNT)
#     define SETUP_XfOrM36(x) SETUP_XfOrM34(x)
      (
# 698 "bc/src/print.c"
      scheme_hash_tree_index (t , i , & key , & val ) ) ; 
      if (! (((Scheme_Object * ) t ) == (obj ) ) )
        val = FUNCCALL(SETUP_XfOrM36(_), scheme_chaperone_hash_traversal_get (obj , key , & key ) ); 
      res2 = FUNCCALL(SETUP_XfOrM36(_), check_cycles (key , for_write , ht , pp ) ); 
      res |= res2 ; 
      if ((for_write < 3 ) && (res & 0x2 ) )
        RET_VALUE_START (res ) RET_VALUE_END ; 
      res2 = FUNCCALL(SETUP_XfOrM36(_), check_cycles (val , for_write , ht , pp ) ); 
      res |= res2 ; 
      if ((for_write < 3 ) && (res & 0x2 ) )
        RET_VALUE_START (res ) RET_VALUE_END ; 
      i = (scheme_hash_tree_next (t , i ) ) ; 
    }
  }

# 711 "bc/src/print.c"
  else 
  res = 0 ; 
  FUNCCALL_EMPTY(scheme_hash_set (ht , obj , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (res ) ) ) << 1 ) | 0x1 ) ) ) )
  ; 

  RET_VALUE_START (res ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 838 "bc/src/print.c"
static void setup_graph_table (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , int * counter , PrintParams * pp ) ; 

static Scheme_Object * setup_graph_k (void ) 
{
  /* No conversion */

# 842 "bc/src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  int * counter = (int * ) p -> ku . k . p3 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p4 ; 
  int for_write = p -> ku . k . i1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  setup_graph_table (o , for_write , ht , counter , pp ) ; 

  return scheme_false ; 
}


static void setup_graph_table (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , 
int * counter , PrintParams * pp ) 
{
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(ht, 1), PUSH(obj, 2), PUSH(counter, 3)));
# define XfOrM70_COUNT (4)
# define SETUP_XfOrM70(x) SETUP(XfOrM70_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 863 "bc/src/print.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) || ((pp ? pp -> print_box : 1 ) && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) || ((pp ? pp -> print_struct && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && (FUNCCALL(SETUP_XfOrM70(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) : 0 ) ) || ((pp ? ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && FUNCCALL(SETUP_XfOrM70(_), scheme_is_writable_struct (obj ) ): 0 ) ) || ((pp ? pp -> print_struct : 1 ) && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) || ((pp ? pp -> print_hash_table : 1 ) && ((((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? (((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> count ) : (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (obj ) ) -> count ) ) ) ) )  {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM70_COUNT)));
#   define XfOrM96_COUNT (1+XfOrM70_COUNT)
#   define SETUP_XfOrM96(x) SETUP(XfOrM96_COUNT)
    v = NULLED_OUT ; 

# 867 "bc/src/print.c"
    {

# 24 "bc/src/mzstkchk.h"
      uintptr_t _stk_pos ; 
#     define XfOrM99_COUNT (0+XfOrM96_COUNT)
#     define SETUP_XfOrM99(x) SETUP_XfOrM96(x)

# 26 "bc/src/mzstkchk.h"
      _stk_pos = (uintptr_t ) & _stk_pos ; 

      if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
      && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 869 "bc/src/print.c"
      {
#       define XfOrM100_COUNT (0+XfOrM99_COUNT)
#       define SETUP_XfOrM100(x) SETUP_XfOrM99(x)

# 870 "bc/src/print.c"
        if (pp )
          pp = FUNCCALL(SETUP_XfOrM100(_), copy_print_params (pp ) ); 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 = (void * ) obj ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p2 = (void * ) ht ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p3 = (void * ) counter ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p4 = (void * ) pp ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . i1 = for_write ; 
        FUNCCALL(SETUP_XfOrM100(_), scheme_handle_stack_overflow (setup_graph_k ) ); 
        RET_NOTHING ; 
      }
    }


    v = FUNCCALL(SETUP_XfOrM96(_), scheme_hash_get (ht , obj ) ); 

    if (! v )
      FUNCCALL(SETUP_XfOrM96(_), scheme_hash_set (ht , obj , (Scheme_Object * ) 0x1 ) ); 
    else {
#     define XfOrM97_COUNT (0+XfOrM96_COUNT)
#     define SETUP_XfOrM97(x) SETUP_XfOrM96(x)

# 888 "bc/src/print.c"
      if ((intptr_t ) v == 1 ) {
#       define XfOrM98_COUNT (0+XfOrM97_COUNT)
#       define SETUP_XfOrM98(x) SETUP_XfOrM97(x)

# 889 "bc/src/print.c"
        (* counter ) += 2 ; 
        FUNCCALL(SETUP_XfOrM98(_), scheme_hash_set (ht , obj , (Scheme_Object * ) (intptr_t ) * counter ) ); 
      }
      RET_NOTHING ; 
    }
  }

# 894 "bc/src/print.c"
  else 
  RET_NOTHING ; 

  {
#   define XfOrM94_COUNT (0+XfOrM70_COUNT)
#   define SETUP_XfOrM94(x) SETUP_XfOrM70(x)

# 897 "bc/src/print.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM95_COUNT (0+XfOrM94_COUNT)
#     define SETUP_XfOrM95(x) SETUP_XfOrM94(x)
      FUNCCALL(SETUP_XfOrM95(_), scheme_out_of_fuel () )
# 897 "bc/src/print.c"
      ; 
    }
  }

# 897 "bc/src/print.c"
  ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) ) {
#   define XfOrM93_COUNT (0+XfOrM70_COUNT)
#   define SETUP_XfOrM93(x) SETUP_XfOrM70(x)
    FUNCCALL(SETUP_XfOrM93(_), setup_graph_table ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , for_write , ht , counter , pp ) )
# 900 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM93(_), setup_graph_table ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , for_write , ht , counter , pp ) ); 
  }

# 902 "bc/src/print.c"
  else if ((! pp || pp -> print_box ) && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM70_COUNT)));
#   define XfOrM92_COUNT (1+XfOrM70_COUNT)
#   define SETUP_XfOrM92(x) SETUP(XfOrM92_COUNT)
    v = NULLED_OUT ; 

# 904 "bc/src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
      v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
    else 
    v = FUNCCALL(SETUP_XfOrM92(_), scheme_unbox (obj ) ); 
    FUNCCALL(SETUP_XfOrM92(_), setup_graph_table (v , for_write , ht , counter , pp ) ); 
  }

# 909 "bc/src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) )  {
    int i , len ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM70_COUNT)));
#   define XfOrM89_COUNT (1+XfOrM70_COUNT)
#   define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
    v = NULLED_OUT ; 

# 913 "bc/src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
      len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 
    else 
    len = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> size ) ; 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM91_COUNT (0+XfOrM89_COUNT)
#     define SETUP_XfOrM91(x) SETUP_XfOrM89(x)

# 918 "bc/src/print.c"
      if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
        v = (((Scheme_Vector * ) (obj ) ) -> els ) [i ] ; 
      else 
      v = FUNCCALL(SETUP_XfOrM91(_), scheme_chaperone_vector_ref (obj , i ) ); 
      FUNCCALL(SETUP_XfOrM91(_), setup_graph_table (v , for_write , ht , counter , pp ) ); 
    }
  }

# 924 "bc/src/print.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) )  {
    Scheme_Stencil_Vector * sv = (Scheme_Stencil_Vector * ) obj ; 
    int i , len ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(sv, 0+XfOrM70_COUNT)));
#   define XfOrM86_COUNT (1+XfOrM70_COUNT)
#   define SETUP_XfOrM86(x) SETUP(XfOrM86_COUNT)
    v = NULLED_OUT ; 

# 929 "bc/src/print.c"
    len = (scheme_stencil_vector_popcount (sv -> mask ) ) ; 
    if (for_write > 1 )

# 930 "bc/src/print.c"
    for_write = 1 ; 

    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM88_COUNT (0+XfOrM86_COUNT)
#     define SETUP_XfOrM88(x) SETUP_XfOrM86(x)
      FUNCCALL(SETUP_XfOrM88(_), setup_graph_table (sv -> els [i ] , for_write , ht , counter , pp ) )
# 933 "bc/src/print.c"
      ; 
    }
  }

# 935 "bc/src/print.c"
  else if (pp && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) ) {
#   define XfOrM81_COUNT (0+XfOrM70_COUNT)
#   define SETUP_XfOrM81(x) SETUP_XfOrM70(x)

# 936 "bc/src/print.c"
    if (FUNCCALL(SETUP_XfOrM81(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM85_COUNT (0+XfOrM81_COUNT)
#     define SETUP_XfOrM85(x) SETUP_XfOrM81(x)

# 937 "bc/src/print.c"
      if (pp -> print_unreadable )
        (void ) FUNCCALL(SETUP_XfOrM85(_), writable_struct_subs (obj , for_write , pp , 2 , ht , counter ) ); 
    }

# 939 "bc/src/print.c"
    else {
      int i ; 
#     define XfOrM82_COUNT (0+XfOrM81_COUNT)
#     define SETUP_XfOrM82(x) SETUP_XfOrM81(x)

# 942 "bc/src/print.c"
      if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        i = ((((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype ) -> num_slots ) ; 
      else 
      i = ((((Scheme_Structure * ) obj ) -> stype ) -> num_slots ) ; 

      while (i -- ) {
#       define XfOrM84_COUNT (0+XfOrM82_COUNT)
#       define SETUP_XfOrM84(x) SETUP_XfOrM82(x)

# 948 "bc/src/print.c"
        if (FUNCCALL(SETUP_XfOrM84(_), scheme_inspector_sees_part (obj , pp -> inspector , i ) ))
          (__funcarg59 = FUNCCALL(SETUP_XfOrM84(_), scheme_struct_ref (obj , i ) ), FUNCCALL_AGAIN(setup_graph_table (__funcarg59 , for_write , ht , counter , pp ) )) ; 
      }
    }
  }

# 952 "bc/src/print.c"
  else if (pp && (((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) ) {
    Scheme_Hash_Table * t ; 
    Scheme_Object * * keys , * * vals , * val , * key ; 
    int i , size ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM70_COUNT), PUSH(vals, 1+XfOrM70_COUNT), PUSH(keys, 2+XfOrM70_COUNT), PUSH(t, 3+XfOrM70_COUNT), PUSH(val, 4+XfOrM70_COUNT)));
#   define XfOrM74_COUNT (5+XfOrM70_COUNT)
#   define SETUP_XfOrM74(x) SETUP(XfOrM74_COUNT)
    t = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    key = NULLED_OUT ; 

# 957 "bc/src/print.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      t = (Scheme_Hash_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    t = (Scheme_Hash_Table * ) obj ; 

    keys = t -> keys ; 
    vals = t -> vals ; 
    size = t -> size ; 
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM78_COUNT (0+XfOrM74_COUNT)
#     define SETUP_XfOrM78(x) SETUP_XfOrM74(x)

# 966 "bc/src/print.c"
      if (vals [i ] ) {
#       define XfOrM79_COUNT (0+XfOrM78_COUNT)
#       define SETUP_XfOrM79(x) SETUP_XfOrM78(x)

# 967 "bc/src/print.c"
        key = keys [i ] ; 
        if (! (((Scheme_Object * ) t ) == (obj ) ) )
          val = FUNCCALL(SETUP_XfOrM79(_), scheme_chaperone_hash_traversal_get (obj , key , & key ) ); 
        else 
        val = vals [i ] ; 
        if (val ) {
#         define XfOrM80_COUNT (0+XfOrM79_COUNT)
#         define SETUP_XfOrM80(x) SETUP_XfOrM79(x)
          FUNCCALL(SETUP_XfOrM80(_), setup_graph_table (key , for_write , ht , counter , pp ) )
# 973 "bc/src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM80(_), setup_graph_table (val , for_write , ht , counter , pp ) ); 
        }
      }
    }
  }

# 978 "bc/src/print.c"
  else if (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) )  {

    Scheme_Hash_Tree * t ; 
    Scheme_Object * key , * val ; 
    mzlonglong i ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM70_COUNT), PUSH(t, 1+XfOrM70_COUNT), PUSH(val, 2+XfOrM70_COUNT)));
#   define XfOrM71_COUNT (3+XfOrM70_COUNT)
#   define SETUP_XfOrM71(x) SETUP(XfOrM71_COUNT)
    t = NULLED_OUT ; 
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 

# 984 "bc/src/print.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      t = (Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    t = (Scheme_Hash_Tree * ) obj ; 

    i = (scheme_hash_tree_next (t , - 1 ) ) ; 
    while (i != - 1 ) {
#     define XfOrM73_COUNT (0+XfOrM71_COUNT)
#     define SETUP_XfOrM73(x) SETUP_XfOrM71(x)
      (
# 991 "bc/src/print.c"
      scheme_hash_tree_index (t , i , & key , & val ) ) ; 
      if (! (((Scheme_Object * ) t ) == (obj ) ) )
        val = FUNCCALL(SETUP_XfOrM73(_), scheme_chaperone_hash_traversal_get (obj , key , & key ) ); 
      FUNCCALL(SETUP_XfOrM73(_), setup_graph_table (key , for_write , ht , counter , pp ) ); 
      FUNCCALL_AGAIN(setup_graph_table (val , for_write , ht , counter , pp ) ); 
      i = (scheme_hash_tree_next (t , i ) ) ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1003 "bc/src/print.c"
static Scheme_Hash_Table * setup_datum_graph (Scheme_Object * o , int for_write , void * for_print ) 
{
  Scheme_Hash_Table * ht ; 
  int counter = 1 ; 
  DECL_RET_SAVE (Scheme_Hash_Table * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(for_print, 0), PUSH(ht, 1), PUSH(o, 2)));
# define XfOrM101_COUNT (3)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 1008 "bc/src/print.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) ) {
    ht = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) = ((void * ) 0 ) ; 
  }

# 1011 "bc/src/print.c"
  else 
  ht = FUNCCALL(SETUP_XfOrM101(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  FUNCCALL(SETUP_XfOrM101(_), setup_graph_table (o , for_write , ht , & counter , (PrintParams * ) for_print ) )
  ; 

  if (counter > 1 )
    RET_VALUE_START (ht ) RET_VALUE_END ; 
  else {
    if (ht -> size < 32 ) {
      int i ; 
      for (i = 0 ; i < ht -> size ; i ++ ) {
        ht -> keys [i ] = ((void * ) 0 ) ; 
        ht -> vals [i ] = ((void * ) 0 ) ; 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) = ht ; 
    }
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1031 "bc/src/print.c"
static char * 
print_to_string (Scheme_Object * obj , 
intptr_t * volatile len , int write , 
Scheme_Object * port , intptr_t maxl , 
Scheme_Object * qq_depth , int * _release_to_quick ) 
{
  Scheme_Hash_Table * ht ; 
  Scheme_Hash_Table * uq_ht ; 
  Scheme_Object * v ; 
  char * ca ; 
  int cycles ; 
  mz_jmp_buf escape ; 
  volatile PrintParams params ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(uq_ht, 0), PUSH(ht, 1), PUSH(_release_to_quick, 2), PUSH(v, 3), PUSH(ca, 4), PUSH(len, 5), PUSH(port, 6), PUSH(qq_depth, 7), PUSH(params.inspector, 8), PUSH(params.print_buffer, 9), PUSH(params.print_port, 10), PUSH(params.print_escape, 11), PUSH(params.depth_delta, 12), PUSH(params.uq_ht, 13), PUSH(obj, 14)));
# define XfOrM107_COUNT (15)
# define SETUP_XfOrM107(x) SETUP(XfOrM107_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ht = NULLED_OUT ; 
  uq_ht = NULLED_OUT ; 
  v = NULLED_OUT ; 
  ca = NULLED_OUT ; 
  params.inspector = NULLED_OUT ; 
  params.print_buffer = NULLED_OUT ; 
  params.print_port = NULLED_OUT ; 
  params.print_escape = NULLED_OUT ; 
  params.depth_delta = NULLED_OUT ; 
  params.uq_ht = NULLED_OUT ; 

# 1045 "bc/src/print.c"
  params . print_allocated = 50 ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) ) {
    ca = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) = ((void * ) 0 ) ; 
  }

# 1049 "bc/src/print.c"
  else 
  ca = (char * ) FUNCCALL(SETUP_XfOrM107(_), GC_malloc_atomic (params . print_allocated ) ); 
  params . print_buffer = ca ; 
  params . print_position = 0 ; 
  params . print_offset = 0 ; 
  params . print_maxlen = maxl ; 
  params . print_port = port ; 
  params . print_syntax = 0 ; 
  params . depth_delta = ((void * ) 0 ) ; 
  params . printing_quoted = 0 ; 



  if (((((intptr_t ) (obj ) ) & 0x1 ) || ((((obj ) -> type ) >= scheme_bignum_type ) && (((obj ) -> type ) <= scheme_complex_type ) ) ) 
  || (! write 
  && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) {
    params . print_graph = 0 ; 
    params . print_box = 0 ; 
    params . print_struct = 0 ; 
    params . print_vec_shorthand = 0 ; 
    params . print_hash_table = 0 ; 
    params . print_unreadable = 1 ; 
    params . print_reader = 1 ; 
    params . print_long_bools = 0 ; 
    params . print_pair_curly = 0 ; 
    params . print_mpair_curly = 1 ; 
    params . can_read_pipe_quote = 1 ; 
    params . case_sens = 1 ; 
    params . inspector = scheme_false ; 
    params . print_syntax = - 1 ; 
  }

# 1081 "bc/src/print.c"
  else {
    Scheme_Config * config ; 
    BLOCK_SETUP((PUSH(config, 0+XfOrM107_COUNT)));
#   define XfOrM112_COUNT (1+XfOrM107_COUNT)
#   define SETUP_XfOrM112(x) SETUP(XfOrM112_COUNT)
    config = NULLED_OUT ; 

# 1084 "bc/src/print.c"
    config = FUNCCALL(SETUP_XfOrM112(_), scheme_current_config () ); 

    v = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_PRINT_GRAPH ) ); 
    params . print_graph = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_PRINT_BOX ) ); 
    params . print_box = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_PRINT_STRUCT ) ); 
    params . print_struct = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_PRINT_VEC_SHORTHAND ) ); 
    params . print_vec_shorthand = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_PRINT_SYNTAX_WIDTH ) ); 
    if (((intptr_t ) (v ) ) & 0x1 ) 
      params . print_syntax = (((intptr_t ) (v ) ) >> 1 ) ; 
    else 
    params . print_syntax = - 1 ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_PRINT_HASH_TABLE ) ); 
    params . print_hash_table = (! (((v ) ) == (scheme_false ) ) ) ; 
    if (write ) {
#     define XfOrM119_COUNT (0+XfOrM112_COUNT)
#     define SETUP_XfOrM119(x) SETUP_XfOrM112(x)

# 1102 "bc/src/print.c"
      if (maxl > 0 )
        params . print_unreadable = 1 ; 
      else {
#       define XfOrM120_COUNT (0+XfOrM119_COUNT)
#       define SETUP_XfOrM120(x) SETUP_XfOrM119(x)

# 1105 "bc/src/print.c"
        v = FUNCCALL(SETUP_XfOrM120(_), scheme_get_param (config , MZCONFIG_PRINT_UNREADABLE ) ); 
        params . print_unreadable = (! (((v ) ) == (scheme_false ) ) ) ; 
      }
    }

# 1108 "bc/src/print.c"
    else 
    params . print_unreadable = 1 ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_PRINT_PAIR_CURLY ) ); 
    params . print_pair_curly = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_PRINT_MPAIR_CURLY ) ); 
    params . print_mpair_curly = (! (((v ) ) == (scheme_false ) ) ) ; 
    if (write > 1 ) {
#     define XfOrM115_COUNT (0+XfOrM112_COUNT)
#     define SETUP_XfOrM115(x) SETUP_XfOrM112(x)

# 1115 "bc/src/print.c"
      v = FUNCCALL(SETUP_XfOrM115(_), scheme_get_param (config , MZCONFIG_PRINT_AS_QQ ) ); 
      if (! (((v ) ) == (scheme_false ) ) )  {
#       define XfOrM116_COUNT (0+XfOrM115_COUNT)
#       define SETUP_XfOrM116(x) SETUP_XfOrM115(x)

# 1117 "bc/src/print.c"
        params . depth_delta = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
        if (qq_depth ) {
#         define XfOrM117_COUNT (0+XfOrM116_COUNT)
#         define SETUP_XfOrM117(x) SETUP_XfOrM116(x)

# 1119 "bc/src/print.c"
          if (FUNCCALL(SETUP_XfOrM117(_), scheme_bin_gt (qq_depth , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((1 << 29 ) ) ) ) << 1 ) | 0x1 ) ) ) )) {
#           define XfOrM118_COUNT (0+XfOrM117_COUNT)
#           define SETUP_XfOrM118(x) SETUP_XfOrM117(x)

# 1120 "bc/src/print.c"
            write = 3 + (1 << 29 ) ; 
            qq_depth = FUNCCALL(SETUP_XfOrM118(_), scheme_bin_minus (qq_depth , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((1 << 29 ) ) ) ) << 1 ) | 0x1 ) ) ) ); 
            params . depth_delta = qq_depth ; 
          }

# 1123 "bc/src/print.c"
          else 
          write = 3 + (((intptr_t ) (qq_depth ) ) >> 1 ) ; 
        }

# 1125 "bc/src/print.c"
        else 
        write = 3 ; 
      }
    }

    if (write > 2 ) {
      params . print_reader = 1 ; 
    }

# 1132 "bc/src/print.c"
    else {
#     define XfOrM113_COUNT (0+XfOrM112_COUNT)
#     define SETUP_XfOrM113(x) SETUP_XfOrM112(x)

# 1133 "bc/src/print.c"
      v = FUNCCALL(SETUP_XfOrM113(_), scheme_get_param (config , MZCONFIG_PRINT_READER ) ); 
      params . print_reader = (! (((v ) ) == (scheme_false ) ) ) ; 
    }
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_CAN_READ_PIPE_QUOTE ) ); 
    params . can_read_pipe_quote = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_CASE_SENS ) ); 
    params . case_sens = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_PRINT_LONG_BOOLEAN ) ); 
    params . print_long_bools = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM112(_), scheme_get_param (config , MZCONFIG_INSPECTOR ) ); 
    params . inspector = v ; 
  }

  uq_ht = ((void * ) 0 ) ; 

  if (params . print_graph && (write < 3 ) )
    cycles = 1 ; 
  else {
#   define XfOrM110_COUNT (0+XfOrM107_COUNT)
#   define SETUP_XfOrM110(x) SETUP_XfOrM107(x)

# 1152 "bc/src/print.c"
    if (FUNCCALL(SETUP_XfOrM110(_), can_print_fast (obj ) ))
      cycles = 0 ; 
    else 
    cycles = - 1 ; 




    if ((cycles == - 1 ) || (cycles && (write >= 3 ) ) ) {
#     define XfOrM111_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM111(x) SETUP_XfOrM110(x)

# 1161 "bc/src/print.c"
      uq_ht = FUNCCALL(SETUP_XfOrM111(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      cycles = FUNCCALL(SETUP_XfOrM111(_), check_cycles (obj , write , uq_ht , (PrintParams * ) & params ) )& 0x2 ; 
    }
    if (! cycles && params . print_graph )
      cycles = 1 ; 
  }

  if (cycles )
    ht = FUNCCALL(SETUP_XfOrM107(_), setup_datum_graph (obj , write , (PrintParams * ) & params ) ); 
  else 
  ht = ((void * ) 0 ) ; 

  if (maxl > 0 )
    params . print_escape = & escape ; 
  else 
  params . print_escape = ((void * ) 0 ) ; 

  params . uq_ht = uq_ht ; 

  if ((maxl < 3 ) 
  || ! ((escape ) . gcvs = (intptr_t ) __gc_var_stack__ , (escape ) . gcvs_cnt = XfOrM107_COUNT , (_setjmp ((escape ) . jb ) ) ) )
    FUNCCALL(SETUP_XfOrM107(_), print (obj , write , 0 , ht , ((void * ) 0 ) , (PrintParams * ) & params ) ); 

  params . print_buffer [params . print_position ] = '\0' ; 

  if (len )
    * len = params . print_position ; 

  params . inspector = ((void * ) 0 ) ; 

  if (_release_to_quick ) {
    * _release_to_quick = 0 ; 
    if (params . print_buffer != ca ) {
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) = ca ; 
    }

# 1196 "bc/src/print.c"
    else 
    * _release_to_quick = 1 ; 
  }

  RET_VALUE_START (params . print_buffer ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1203 "bc/src/print.c"
static void 
print_to_port (char * name , Scheme_Object * obj , Scheme_Object * port , int notdisplay , 
intptr_t maxl , Scheme_Object * qq_depth ) 
{
  Scheme_Output_Port * op ; 
  char * str ; 
  intptr_t len ; 
  int rel ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(qq_depth, 1), PUSH(obj, 2), PUSH(name, 3), PUSH(str, 4), PUSH(op, 5)));
# define XfOrM123_COUNT (6)
# define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 
  str = NULLED_OUT ; 

# 1212 "bc/src/print.c"
  op = FUNCCALL(SETUP_XfOrM123(_), scheme_output_port_record (port ) ); 
  if (op -> closed )
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL , "%s: output port is closed\n" "  port: %V" , name , port ) )

  ; 

  str = FUNCCALL(SETUP_XfOrM123(_), print_to_string (obj , & len , notdisplay , port , maxl , qq_depth , & rel ) ); 
  FUNCCALL_AGAIN(scheme_write_byte_string (str , len , port ) )
  ; 

  if (rel && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) = str ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1226 "bc/src/print.c"
static void print_this_string (PrintParams * pp , const char * str , int offset , int autolen ) 

{
  intptr_t len ; 
  char * oldstr ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(str, 1), PUSH(oldstr, 2)));
# define XfOrM124_COUNT (3)
# define SETUP_XfOrM124(x) SETUP(XfOrM124_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  oldstr = NULLED_OUT ; 

# 1232 "bc/src/print.c"
  if (! autolen ) {
    if (! str )
      len = 0 ; 
    else 
    RET_NOTHING ; 
  }

# 1237 "bc/src/print.c"
  else if (autolen > 0 )
    len = autolen ; 
  else 
  len = strlen (str XFORM_OK_PLUS offset ) ; 

  if (! pp -> print_buffer ) {

    pp -> print_position += len ; 
    pp -> print_offset += len ; 
    RET_NOTHING ; 
  }

  if (len + pp -> print_position + 1 > pp -> print_allocated ) {
#   define XfOrM131_COUNT (0+XfOrM124_COUNT)
#   define SETUP_XfOrM131(x) SETUP_XfOrM124(x)

# 1250 "bc/src/print.c"
    if (len + 1 >= pp -> print_allocated )
      pp -> print_allocated = 2 * pp -> print_allocated + len + 1 ; 
    else 
    pp -> print_allocated = 2 * pp -> print_allocated ; 

    oldstr = pp -> print_buffer ; 
    {
      char * ca ; 
      BLOCK_SETUP((PUSH(ca, 0+XfOrM131_COUNT)));
#     define XfOrM132_COUNT (1+XfOrM131_COUNT)
#     define SETUP_XfOrM132(x) SETUP(XfOrM132_COUNT)
      ca = NULLED_OUT ; 

# 1258 "bc/src/print.c"
      ca = (char * ) FUNCCALL(SETUP_XfOrM132(_), GC_malloc_atomic (pp -> print_allocated ) ); 
      pp -> print_buffer = ca ; 
    }
    (memcpy (pp -> print_buffer , oldstr , pp -> print_position ) ) ; 
  }

  if (len )
    (memcpy (pp -> print_buffer + pp -> print_position , str + offset , len ) ) ; 
  pp -> print_position += len ; 
  pp -> print_offset += len ; 





  {
#   define XfOrM129_COUNT (0+XfOrM124_COUNT)
#   define SETUP_XfOrM129(x) SETUP_XfOrM124(x)

# 1273 "bc/src/print.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM130_COUNT (0+XfOrM129_COUNT)
#     define SETUP_XfOrM130(x) SETUP_XfOrM129(x)
      FUNCCALL(SETUP_XfOrM130(_), scheme_out_of_fuel () )
# 1273 "bc/src/print.c"
      ; 
    }
  }

# 1273 "bc/src/print.c"
  ; 

  if (pp -> print_maxlen >= 3 ) {
    if (pp -> print_position > pp -> print_maxlen ) {
      intptr_t l = pp -> print_maxlen ; 

      pp -> print_buffer [l ] = 0 ; 
      pp -> print_buffer [l - 1 ] = '.' ; 
      pp -> print_buffer [l - 2 ] = '.' ; 
      pp -> print_buffer [l - 3 ] = '.' ; 

      pp -> print_position = l ; 

      (((intptr_t * ) (void * ) ((* pp -> print_escape ) . gcvs ) ) [1 ] = (* pp -> print_escape ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* pp -> print_escape ) . gcvs , longjmp ((* pp -> print_escape ) . jb , 1 ) ) ; 
    }
  }

# 1288 "bc/src/print.c"
  else if ((pp -> print_position > 500 ) || ! str ) {
#   define XfOrM125_COUNT (0+XfOrM124_COUNT)
#   define SETUP_XfOrM125(x) SETUP_XfOrM124(x)

# 1289 "bc/src/print.c"
    if (pp -> print_port ) {
#     define XfOrM126_COUNT (0+XfOrM125_COUNT)
#     define SETUP_XfOrM126(x) SETUP_XfOrM125(x)

# 1290 "bc/src/print.c"
      pp -> print_buffer [pp -> print_position ] = 0 ; 
      FUNCCALL(SETUP_XfOrM126(_), scheme_write_byte_string (pp -> print_buffer , pp -> print_position , pp -> print_port ) ); 

      pp -> print_position = 0 ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1298 "bc/src/print.c"
static void print_utf8_string (PrintParams * pp , const char * str , int offset , int autolen ) 
{
  /* No conversion */

# 1300 "bc/src/print.c"
  print_this_string (pp , str , offset , autolen ) ; 
}

void scheme_print_bytes (Scheme_Print_Params * pp , const char * str , int offset , int len ) 
{
  /* No conversion */

# 1305 "bc/src/print.c"
  print_this_string (pp , str , offset , len ) ; 
}

void scheme_print_utf8 (Scheme_Print_Params * pp , const char * str , int offset , int len ) 
{
  /* No conversion */

# 1310 "bc/src/print.c"
  print_utf8_string (pp , str , offset , len ) ; 
}

static void print_number (PrintParams * pp , intptr_t n ) 
{
  /* No conversion */

# 1315 "bc/src/print.c"
  unsigned char s [4 ] ; 

  s [0 ] = (unsigned char ) (n & 0xFF ) ; 
  s [1 ] = (unsigned char ) ((n >> 8 ) & 0xFF ) ; 
  s [2 ] = (unsigned char ) ((n >> 16 ) & 0xFF ) ; 
  s [3 ] = (unsigned char ) ((n >> 24 ) & 0xFF ) ; 

  print_this_string (pp , (char * ) s , 0 , 4 ) ; 
}

static void print_short_number (PrintParams * pp , intptr_t n ) 
{
  /* No conversion */

# 1327 "bc/src/print.c"
  unsigned char s [2 ] ; 

  s [0 ] = (unsigned char ) (n & 0xFF ) ; 
  s [1 ] = (unsigned char ) ((n >> 8 ) & 0xFF ) ; 

  print_this_string (pp , (char * ) s , 0 , 2 ) ; 
}

static void print_one_byte (PrintParams * pp , int n ) 
{
  /* No conversion */

# 1337 "bc/src/print.c"
  unsigned char s [1 ] ; 

  s [0 ] = n ; 

  print_this_string (pp , (char * ) s , 0 , 1 ) ; 
}

static void print_compact_number (PrintParams * pp , intptr_t n ) 
{
  unsigned char s [2 ] ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pp, 0)));
# define XfOrM141_COUNT (1)
# define SETUP_XfOrM141(x) SETUP(XfOrM141_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1348 "bc/src/print.c"
  if (n < 0 ) {
#   define XfOrM145_COUNT (0+XfOrM141_COUNT)
#   define SETUP_XfOrM145(x) SETUP_XfOrM141(x)

# 1349 "bc/src/print.c"
    if (n > - 32 ) {
#     define XfOrM147_COUNT (0+XfOrM145_COUNT)
#     define SETUP_XfOrM147(x) SETUP_XfOrM145(x)

# 1350 "bc/src/print.c"
      s [0 ] = (unsigned char ) (0xC0 | (- n ) ) ; 
      FUNCCALL(SETUP_XfOrM147(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      RET_NOTHING ; 
    }

# 1353 "bc/src/print.c"
    else {
      n = - n ; 
      s [0 ] = 0xE0 ; 
    }
  }

# 1357 "bc/src/print.c"
  else if (n < 128 ) {
#   define XfOrM144_COUNT (0+XfOrM141_COUNT)
#   define SETUP_XfOrM144(x) SETUP_XfOrM141(x)

# 1358 "bc/src/print.c"
    s [0 ] = (unsigned char ) n ; 
    FUNCCALL(SETUP_XfOrM144(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    RET_NOTHING ; 
  }

# 1361 "bc/src/print.c"
  else if (n < 0x4000 ) {
#   define XfOrM143_COUNT (0+XfOrM141_COUNT)
#   define SETUP_XfOrM143(x) SETUP_XfOrM141(x)

# 1362 "bc/src/print.c"
    s [0 ] = (unsigned char ) (0x80 | (n & 0x3F ) ) ; 
    s [1 ] = (unsigned char ) ((n >> 6 ) & 0xFF ) ; 
    FUNCCALL(SETUP_XfOrM143(_), print_this_string (pp , (char * ) s , 0 , 2 ) ); 
    RET_NOTHING ; 
  }

# 1366 "bc/src/print.c"
  else {
    s [0 ] = 0xF0 ; 
  }
  FUNCCALL(SETUP_XfOrM141(_), print_this_string (pp , (char * ) s , 0 , 1 ) )
  ; 
  FUNCCALL_EMPTY(print_number (pp , n ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1374 "bc/src/print.c"
static void do_print_string (int compact , int notdisplay , 
Scheme_Print_Params * pp , const mzchar * s , int offset , int l ) 
{
  int el , reset ; 
  char * buf ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(s, 1), PUSH(buf, 2)));
# define XfOrM148_COUNT (3)
# define SETUP_XfOrM148(x) SETUP(XfOrM148_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buf = NULLED_OUT ; 

# 1380 "bc/src/print.c"
  el = l * 6 ; 
  if (el <= 256 ) {
#   define XfOrM152_COUNT (0+XfOrM148_COUNT)
#   define SETUP_XfOrM152(x) SETUP_XfOrM148(x)

# 1382 "bc/src/print.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) ) {
      buf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) = ((void * ) 0 ) ; 
    }

# 1385 "bc/src/print.c"
    else 
    buf = (char * ) FUNCCALL(SETUP_XfOrM152(_), GC_malloc_atomic (256 ) ); 
    reset = 1 ; 
  }

# 1388 "bc/src/print.c"
  else {
#   define XfOrM151_COUNT (0+XfOrM148_COUNT)
#   define SETUP_XfOrM151(x) SETUP_XfOrM148(x)

# 1389 "bc/src/print.c"
    buf = (char * ) FUNCCALL(SETUP_XfOrM151(_), GC_malloc_atomic (el ) ); 
    reset = 0 ; 
  }

  el = FUNCCALL(SETUP_XfOrM148(_), scheme_utf8_encode (s , offset , offset + l , (unsigned char * ) buf , 0 , 0 ) ); 

  if (compact ) {
#   define XfOrM150_COUNT (0+XfOrM148_COUNT)
#   define SETUP_XfOrM150(x) SETUP_XfOrM148(x)
    FUNCCALL(SETUP_XfOrM150(_), print_this_string (pp , & compacts [CPT_CHAR_STRING ] , 0 , 1 ) )
# 1396 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM150(_), print_compact_number (pp , el ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , l ) ); 
    FUNCCALL_AGAIN(print_this_string (pp , buf , 0 , el ) ); 
  }

# 1400 "bc/src/print.c"
  else {
#   define XfOrM149_COUNT (0+XfOrM148_COUNT)
#   define SETUP_XfOrM149(x) SETUP_XfOrM148(x)
    FUNCCALL(SETUP_XfOrM149(_), print_char_string (buf , el , s , offset , l , notdisplay , pp ) )
# 1401 "bc/src/print.c"
    ; 
  }

  if (reset )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) = buf ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1408 "bc/src/print.c"
void scheme_print_string (Scheme_Print_Params * pp , const mzchar * s , int offset , int l ) 
{
  /* No conversion */

# 1410 "bc/src/print.c"
  do_print_string (0 , 0 , pp , s , offset , l ) ; 
}

static void print_string_in_angle (PrintParams * pp , const char * start , const char * prefix , int slen ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(start, 1)));
# define XfOrM155_COUNT (2)
# define SETUP_XfOrM155(x) SETUP(XfOrM155_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM155(_), print_utf8_string (pp , prefix , 0 , - 1 ) )
# 1416 "bc/src/print.c"
  ; 
  FUNCCALL_EMPTY(print_utf8_string (pp , start , 0 , slen ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1422 "bc/src/print.c"
static Scheme_Object * print_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p -> ku . k . p3 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p5 ; 
  mz_jmp_buf * volatile save ; 
  mz_jmp_buf newbuf ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(ht, 1), PUSH(save, 2), PUSH(mt, 3), PUSH(p, 4), PUSH(o, 5)));
# define XfOrM156_COUNT (6)
# define SETUP_XfOrM156(x) SETUP(XfOrM156_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  save = NULLED_OUT ; 

# 1432 "bc/src/print.c"
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 

  save = pp -> print_escape ; 
  pp -> print_escape = & newbuf ; 
  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM156_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#   define XfOrM158_COUNT (0+XfOrM156_COUNT)
#   define SETUP_XfOrM158(x) SETUP_XfOrM156(x)
    FUNCCALL(SETUP_XfOrM158(_), scheme_make_pair (scheme_void , scheme_void ) )
# 1441 "bc/src/print.c"
    ; 

    pp -> print_escape = save ; 
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }

# 1445 "bc/src/print.c"
  else {
    int r ; 
#   define XfOrM157_COUNT (0+XfOrM156_COUNT)
#   define SETUP_XfOrM157(x) SETUP_XfOrM156(x)

# 1447 "bc/src/print.c"
    r = FUNCCALL(SETUP_XfOrM157(_), print (o , p -> ku . k . i1 , p -> ku . k . i2 , ht , mt , pp ) )




    ; 
    pp -> print_escape = save ; 
    RET_VALUE_START (r ? scheme_true : scheme_false ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}






static int compare_keys (const void * a , const void * b ) 
{
  /* No conversion */

# 1469 "bc/src/print.c"
  Scheme_Object * av , * bv ; 

# 1481 "bc/src/print.c"
  av = ((Scheme_Object * * ) a ) [0 ] ; 
  bv = ((Scheme_Object * * ) b ) [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((((intptr_t ) (av ) ) & 0x1 ) || ((((av ) -> type ) >= scheme_bignum_type ) && (((av ) -> type ) <= scheme_complex_type ) ) ) )  {
    if (! (((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((((intptr_t ) (bv ) ) & 0x1 ) || ((((bv ) -> type ) >= scheme_bignum_type ) && (((bv ) -> type ) <= scheme_complex_type ) ) ) ) )
      return - 1 ; 
  }

# 1486 "bc/src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((((intptr_t ) (bv ) ) & 0x1 ) || ((((bv ) -> type ) >= scheme_bignum_type ) && (((bv ) -> type ) <= scheme_complex_type ) ) ) ) 
    return 1 ; 

  return ((intptr_t * ) a ) [1 ] - ((intptr_t * ) b ) [1 ] ; 
}

static void sort_referenced_keys (Scheme_Marshal_Tables * mt ) 
{
  intptr_t j , size , pos = 0 ; 
  Scheme_Object * * keys ; 
  Scheme_Hash_Table * key_map ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(keys, 0), PUSH(mt, 1), PUSH(key_map, 2)));
# define XfOrM161_COUNT (3)
# define SETUP_XfOrM161(x) SETUP(XfOrM161_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  keys = NULLED_OUT ; 
  key_map = NULLED_OUT ; 

# 1498 "bc/src/print.c"
  size = mt -> st_refs -> count ; 
  keys = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM161(_), GC_malloc (sizeof (Scheme_Object * ) * ((2 * size ) ) ) )) ; 

  for (j = 0 ; j < mt -> st_refs -> size ; j ++ ) {
    if (mt -> st_refs -> vals [j ] ) {
      keys [pos ] = mt -> st_refs -> keys [j ] ; 
      keys [pos + 1 ] = mt -> st_refs -> vals [j ] ; 
      pos += 2 ; 
    }
  }
  FUNCCALL(SETUP_XfOrM161(_), qsort (keys , size , 2 * sizeof (Scheme_Object * ) , compare_keys ) )
  ; 

  key_map = FUNCCALL(SETUP_XfOrM161(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  for (j = 0 ; j < size ; j ++ ) {
#   define XfOrM163_COUNT (0+XfOrM161_COUNT)
#   define SETUP_XfOrM163(x) SETUP_XfOrM161(x)
    FUNCCALL(SETUP_XfOrM163(_), scheme_hash_set (key_map , keys [(j << 1 ) + 1 ] , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (j + 1 ) ) ) << 1 ) | 0x1 ) ) ) )
# 1513 "bc/src/print.c"
    ; 
  }
  mt -> key_map = key_map ; 

  mt -> sorted_keys = keys ; 
  mt -> sorted_keys_count = size ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1521 "bc/src/print.c"
static void print_table_keys (int notdisplay , int compact , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp ) 
{
  intptr_t j , size , offset ; 
  Scheme_Object * * keys , * key ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(key, 0), PUSH(ht, 1), PUSH(keys, 2), PUSH(mt, 3), PUSH(pp, 4)));
# define XfOrM168_COUNT (5)
# define SETUP_XfOrM168(x) SETUP(XfOrM168_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  keys = NULLED_OUT ; 
  key = NULLED_OUT ; 

# 1528 "bc/src/print.c"
  size = mt -> sorted_keys_count ; 
  keys = mt -> sorted_keys ; 

  for (j = 0 ; j < size ; j ++ ) {
#   define XfOrM170_COUNT (0+XfOrM168_COUNT)
#   define SETUP_XfOrM170(x) SETUP_XfOrM168(x)

# 1532 "bc/src/print.c"
    offset = pp -> print_offset ; 
    mt -> shared_offsets [j ] = offset ; 
    key = keys [j << 1 ] ; 
    mt -> print_now = j + 1 ; 
    FUNCCALL(SETUP_XfOrM170(_), print (key , notdisplay , compact , ht , mt , pp ) ); 
    mt -> print_now = 0 ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1541 "bc/src/print.c"
static int 
print_substring (Scheme_Object * obj , int notdisplay , int compact , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , char * * result , intptr_t * rlen , 
int print_keys , intptr_t * klen ) 
{
  int closed ; 
  intptr_t save_alloc , save_pos , save_off , save_maxl ; 
  char * save_buf ; 
  Scheme_Object * save_port ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(rlen, 0), PUSH(ht, 1), PUSH(save_port, 2), PUSH(mt, 3), PUSH(pp, 4), PUSH(save_buf, 5), PUSH(obj, 6), PUSH(result, 7), PUSH(klen, 8)));
# define XfOrM171_COUNT (9)
# define SETUP_XfOrM171(x) SETUP(XfOrM171_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  save_buf = NULLED_OUT ; 
  save_port = NULLED_OUT ; 

# 1552 "bc/src/print.c"
  save_alloc = pp -> print_allocated ; 
  save_buf = pp -> print_buffer ; 
  save_pos = pp -> print_position ; 
  save_off = pp -> print_offset ; 
  save_maxl = pp -> print_maxlen ; 
  save_port = pp -> print_port ; 


  if (result ) {
    char * ca ; 
    BLOCK_SETUP((PUSH(ca, 0+XfOrM171_COUNT)));
#   define XfOrM175_COUNT (1+XfOrM171_COUNT)
#   define SETUP_XfOrM175(x) SETUP(XfOrM175_COUNT)
    ca = NULLED_OUT ; 

# 1562 "bc/src/print.c"
    pp -> print_allocated = 50 ; 
    ca = (char * ) FUNCCALL(SETUP_XfOrM175(_), GC_malloc_atomic (pp -> print_allocated ) ); 
    pp -> print_buffer = ca ; 
  }

# 1565 "bc/src/print.c"
  else {
    pp -> print_allocated = 0 ; 
    pp -> print_buffer = ((void * ) 0 ) ; 
  }
  pp -> print_position = 0 ; 
  pp -> print_offset = 0 ; 
  pp -> print_port = ((void * ) 0 ) ; 

  if (print_keys < 0 ) {
#   define XfOrM173_COUNT (0+XfOrM171_COUNT)
#   define SETUP_XfOrM173(x) SETUP_XfOrM171(x)
    FUNCCALL(SETUP_XfOrM173(_), print_table_keys (notdisplay , compact , ht , mt , pp ) )
# 1574 "bc/src/print.c"
    ; 
    * klen = pp -> print_offset ; 
  }

  closed = FUNCCALL(SETUP_XfOrM171(_), print (obj , notdisplay , compact , ht , mt , pp ) ); 

  if (print_keys > 0 ) {
#   define XfOrM172_COUNT (0+XfOrM171_COUNT)
#   define SETUP_XfOrM172(x) SETUP_XfOrM171(x)
    FUNCCALL(SETUP_XfOrM172(_), print_table_keys (notdisplay , compact , ht , mt , pp ) )
# 1581 "bc/src/print.c"
    ; 
    * klen = pp -> print_offset ; 
  }

  if (result )
    * result = pp -> print_buffer ; 
  * rlen = pp -> print_position ; 

  pp -> print_allocated = save_alloc ; 
  pp -> print_buffer = save_buf ; 
  pp -> print_position = save_pos ; 
  pp -> print_offset = save_off ; 
  pp -> print_maxlen = save_maxl ; 
  pp -> print_port = save_port ; 

  RET_VALUE_START (closed ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1599 "bc/src/print.c"
static Scheme_Object * get_symtab_idx (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  Scheme_Object * idx ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(mt, 0), PUSH(idx, 1), PUSH(obj, 2)));
# define XfOrM176_COUNT (3)
# define SETUP_XfOrM176(x) SETUP(XfOrM176_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  idx = NULLED_OUT ; 

# 1603 "bc/src/print.c"
  idx = FUNCCALL(SETUP_XfOrM176(_), scheme_hash_get (mt -> symtab , obj ) ); 

  if (idx ) {
#   define XfOrM180_COUNT (0+XfOrM176_COUNT)
#   define SETUP_XfOrM180(x) SETUP_XfOrM176(x)

# 1606 "bc/src/print.c"
    if (! mt -> pass ) {
#     define XfOrM181_COUNT (0+XfOrM180_COUNT)
#     define SETUP_XfOrM181(x) SETUP_XfOrM180(x)
      FUNCCALL(SETUP_XfOrM181(_), scheme_hash_set (mt -> st_refs , obj , idx ) )
# 1608 "bc/src/print.c"
      ; 
    }
  }

# 1610 "bc/src/print.c"
  else {
#   define XfOrM177_COUNT (0+XfOrM176_COUNT)
#   define SETUP_XfOrM177(x) SETUP_XfOrM176(x)

# 1611 "bc/src/print.c"
    if (mt -> pass && mt -> print_now ) {
#     define XfOrM178_COUNT (0+XfOrM177_COUNT)
#     define SETUP_XfOrM178(x) SETUP_XfOrM177(x)

# 1612 "bc/src/print.c"
      idx = FUNCCALL(SETUP_XfOrM178(_), scheme_hash_get (mt -> st_refs , obj ) ); 
      if (idx ) {
#       define XfOrM179_COUNT (0+XfOrM178_COUNT)
#       define SETUP_XfOrM179(x) SETUP_XfOrM178(x)

# 1614 "bc/src/print.c"
        idx = FUNCCALL(SETUP_XfOrM179(_), scheme_hash_get (mt -> key_map , idx ) ); 
        if ((((intptr_t ) (idx ) ) >> 1 ) != mt -> print_now )
          RET_VALUE_START (idx ) RET_VALUE_END ; 

        idx = ((void * ) 0 ) ; 
      }
    }
  }

  RET_VALUE_START (idx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1626 "bc/src/print.c"
static void set_symtab_shared (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  /* No conversion */

# 1628 "bc/src/print.c"
  (void ) get_symtab_idx (mt , obj ) ; 
}

static void print_general_symtab_ref (PrintParams * pp , Scheme_Object * idx , int cpt_id ) 
{
  int l ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(idx, 1)));
# define XfOrM183_COUNT (2)
# define SETUP_XfOrM183(x) SETUP(XfOrM183_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM183(_), print_this_string (pp , & compacts [cpt_id ] , 0 , 1 ) )
# 1634 "bc/src/print.c"
  ; 
  l = (((intptr_t ) (idx ) ) >> 1 ) ; 
  FUNCCALL_EMPTY(print_compact_number (pp , l ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1639 "bc/src/print.c"
static void print_symtab_ref (PrintParams * pp , Scheme_Object * idx ) 
{
  /* No conversion */

# 1641 "bc/src/print.c"
  print_general_symtab_ref (pp , idx , CPT_SYMREF ) ; 
}

static int add_symtab (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(mt, 1)));
# define XfOrM185_COUNT (2)
# define SETUP_XfOrM185(x) SETUP(XfOrM185_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1646 "bc/src/print.c"
  if (mt -> pass < 1 ) {
    int l ; 
#   define XfOrM190_COUNT (0+XfOrM185_COUNT)
#   define SETUP_XfOrM190(x) SETUP_XfOrM185(x)

# 1648 "bc/src/print.c"
    l = mt -> symtab -> count + 1 ; 
    FUNCCALL(SETUP_XfOrM190(_), scheme_hash_set (mt -> symtab , obj , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (l ) ) ) << 1 ) | 0x1 ) ) ) ); 
    RET_VALUE_START (l ) RET_VALUE_END ; 
  }

# 1651 "bc/src/print.c"
  else {
    Scheme_Object * key , * l ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM185_COUNT), PUSH(l, 1+XfOrM185_COUNT)));
#   define XfOrM186_COUNT (2+XfOrM185_COUNT)
#   define SETUP_XfOrM186(x) SETUP(XfOrM186_COUNT)
    key = NULLED_OUT ; 
    l = NULLED_OUT ; 

# 1654 "bc/src/print.c"
    key = FUNCCALL(SETUP_XfOrM186(_), scheme_hash_get (mt -> st_refs , obj ) ); 
    for (l = mt -> st_ref_stack ; ! key && ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM189_COUNT (0+XfOrM186_COUNT)
#     define SETUP_XfOrM189(x) SETUP_XfOrM186(x)

# 1656 "bc/src/print.c"
      key = FUNCCALL(SETUP_XfOrM189(_), scheme_hash_get ((Scheme_Hash_Table * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , obj ) ); 
    }

    if (! key ) {

      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

    key = FUNCCALL(SETUP_XfOrM186(_), scheme_hash_get (mt -> key_map , key ) ); 
    FUNCCALL(SETUP_XfOrM186(_), scheme_hash_set (mt -> symtab , obj , key ) )
    ; 

    RET_VALUE_START ((((intptr_t ) (key ) ) >> 1 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1672 "bc/src/print.c"
static void symtab_set (PrintParams * pp , Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  /* No conversion */

# 1674 "bc/src/print.c"
  (void ) add_symtab (mt , obj ) ; 
}

static void print_symtab_set (PrintParams * pp , Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  int l ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pp, 0)));
# define XfOrM192_COUNT (1)
# define SETUP_XfOrM192(x) SETUP(XfOrM192_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1680 "bc/src/print.c"
  l = FUNCCALL(SETUP_XfOrM192(_), add_symtab (mt , obj ) ); 
  FUNCCALL_EMPTY(print_compact_number (pp , l ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1684 "bc/src/print.c"
static void print_escaped (PrintParams * pp , int notdisplay , 
Scheme_Object * obj , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , int shared ) 
{
  char * r ; 
  intptr_t len ; 
  Scheme_Object * idx ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(idx, 1), PUSH(ht, 2), PUSH(mt, 3), PUSH(r, 4), PUSH(obj, 5)));
# define XfOrM193_COUNT (6)
# define SETUP_XfOrM193(x) SETUP(XfOrM193_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  r = NULLED_OUT ; 
  idx = NULLED_OUT ; 

# 1692 "bc/src/print.c"
  if (shared ) {
#   define XfOrM195_COUNT (0+XfOrM193_COUNT)
#   define SETUP_XfOrM195(x) SETUP_XfOrM193(x)

# 1693 "bc/src/print.c"
    idx = FUNCCALL(SETUP_XfOrM195(_), get_symtab_idx (mt , obj ) ); 
    if (idx ) {
#     define XfOrM196_COUNT (0+XfOrM195_COUNT)
#     define SETUP_XfOrM196(x) SETUP_XfOrM195(x)
      FUNCCALL(SETUP_XfOrM196(_), print_symtab_ref (pp , idx ) )
# 1695 "bc/src/print.c"
      ; 
      RET_NOTHING ; 
    }
  }
  FUNCCALL(SETUP_XfOrM193(_), print_substring (obj , notdisplay , 0 , ht , ((void * ) 0 ) , pp , & r , & len , 0 , ((void * ) 0 ) ) )
  ; 
  FUNCCALL(SETUP_XfOrM193(_), print_this_string (pp , & compacts [CPT_ESCAPE ] , 0 , 1 ) )
  ; 
  FUNCCALL_AGAIN(print_compact_number (pp , len ) ); 
  FUNCCALL_AGAIN(print_this_string (pp , r , 0 , len ) ); 

  if (mt ) {
#   define XfOrM194_COUNT (0+XfOrM193_COUNT)
#   define SETUP_XfOrM194(x) SETUP_XfOrM193(x)
    FUNCCALL(SETUP_XfOrM194(_), symtab_set (pp , mt , obj ) )
# 1707 "bc/src/print.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1711 "bc/src/print.c"
static void cannot_print (PrintParams * pp , int notdisplay , 
Scheme_Object * obj , Scheme_Hash_Table * ht , 
int compact ) 
{
  /* No conversion */

# 1715 "bc/src/print.c"
  scheme_raise_exn (MZEXN_FAIL , 
  ((compact || pp -> printing_quoted ) 
  ? "%s: cannot marshal value that is embedded in compiled code\n  value: %V" 
  : "%s: printing disabled for unreadable value\n  value: %V" ) , 
  notdisplay ? "write" : "display" , 
  obj ) ; 
}

# 1735 "bc/src/print.c"
static void print_named (Scheme_Object * obj , const char * kind , 
const char * s , int len , PrintParams * pp ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(s, 1), PUSH(kind, 2)));
# define XfOrM198_COUNT (3)
# define SETUP_XfOrM198(x) SETUP(XfOrM198_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM198(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 1738 "bc/src/print.c"
  ; 
  FUNCCALL(SETUP_XfOrM198(_), print_utf8_string (pp , kind , 0 , - 1 ) ); 

  if (s ) {
#   define XfOrM199_COUNT (0+XfOrM198_COUNT)
#   define SETUP_XfOrM199(x) SETUP_XfOrM198(x)
    FUNCCALL(SETUP_XfOrM199(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 1742 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM199(_), print_utf8_string (pp , s , 0 , len ) )
    ; 
  }

  ; 
  FUNCCALL_EMPTY(print_utf8_string (pp , ">" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1751 "bc/src/print.c"
static int to_quoted (Scheme_Object * obj , PrintParams * pp , int notdisplay ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(obj, 1)));
# define XfOrM200_COUNT (2)
# define SETUP_XfOrM200(x) SETUP(XfOrM200_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1753 "bc/src/print.c"
  if (notdisplay == 3 ) {
#   define XfOrM201_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM201(x) SETUP_XfOrM200(x)

# 1754 "bc/src/print.c"
    if (! obj || ! pp -> uq_ht )
      obj = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    else {
#     define XfOrM203_COUNT (0+XfOrM201_COUNT)
#     define SETUP_XfOrM203(x) SETUP_XfOrM201(x)

# 1757 "bc/src/print.c"
      obj = FUNCCALL(SETUP_XfOrM203(_), scheme_hash_get (pp -> uq_ht , obj ) ); 
      if (! obj )

# 1758 "bc/src/print.c"
      obj = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    }

    if (! ((((intptr_t ) (obj ) ) >> 1 ) & 0x1 ) ) {
#     define XfOrM202_COUNT (0+XfOrM201_COUNT)
#     define SETUP_XfOrM202(x) SETUP_XfOrM201(x)
      FUNCCALL_EMPTY(print_utf8_string (pp , "'" , 0 , 1 ) )
# 1762 "bc/src/print.c"
      ; 
      RET_VALUE_START (notdisplay + 1 ) RET_VALUE_END ; 
    }

# 1764 "bc/src/print.c"
    else 
    RET_VALUE_START (notdisplay ) RET_VALUE_END ; 
  }

# 1766 "bc/src/print.c"
  else 
  RET_VALUE_START (notdisplay ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1770 "bc/src/print.c"
static int is_graph_point (Scheme_Hash_Table * ht , Scheme_Object * obj ) 
{
  /* No conversion */

# 1772 "bc/src/print.c"
  if (ht ) {
    intptr_t v ; 
    v = (intptr_t ) scheme_hash_get (ht , obj ) ; 
    if ((v == 0 ) || (v == 1 ) )
      return 0 ; 
    return 1 ; 
  }

# 1778 "bc/src/print.c"
  else 
  return 0 ; 
}

static int 
print (Scheme_Object * obj , int notdisplay , int compact , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , PrintParams * pp ) 

{
  int closed = 0 ; 

# 24 "bc/src/mzstkchk.h"
  uintptr_t _stk_pos ; 
  char * __funcarg103 = NULLED_OUT ; 
  char * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Config * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Config * __funcarg95 = NULLED_OUT ; 
  Scheme_Config * __funcarg94 = NULLED_OUT ; 
  char * __funcarg93 = NULLED_OUT ; 
  char * __funcarg92 = NULLED_OUT ; 
  char * __funcarg91 = NULLED_OUT ; 
  char * __funcarg90 = NULLED_OUT ; 
  char * __funcarg89 = NULLED_OUT ; 
  char * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(ht, 1), PUSH(mt, 2), PUSH(pp, 3)));
# define XfOrM206_COUNT (4)
# define SETUP_XfOrM206(x) SETUP(XfOrM206_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 26 "bc/src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 1791 "bc/src/print.c"
  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    PrintParams * pp2 ; 
    BLOCK_SETUP((PUSH(pp2, 0+XfOrM206_COUNT), PUSH(p, 1+XfOrM206_COUNT)));
#   define XfOrM478_COUNT (2+XfOrM206_COUNT)
#   define SETUP_XfOrM478(x) SETUP(XfOrM478_COUNT)
    pp2 = NULLED_OUT ; 

# 1795 "bc/src/print.c"
    pp2 = FUNCCALL(SETUP_XfOrM478(_), copy_print_params (pp ) ); 

    p -> ku . k . p1 = (void * ) obj ; 
    p -> ku . k . i1 = notdisplay ; 
    p -> ku . k . i2 = compact ; 
    p -> ku . k . p2 = (void * ) ht ; 
    p -> ku . k . p3 = mt ; 
    p -> ku . k . p5 = pp2 ; 

    obj = FUNCCALL(SETUP_XfOrM478(_), scheme_handle_stack_overflow (print_k ) ); 
    (
    memcpy (pp , pp2 , sizeof (PrintParams ) ) ) ; 

    if (((obj ) ) == (scheme_void ) )  {
      (((intptr_t * ) (void * ) ((* pp -> print_escape ) . gcvs ) ) [1 ] = (* pp -> print_escape ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* pp -> print_escape ) . gcvs , longjmp ((* pp -> print_escape ) . jb , 1 ) ) ; 
    }

    RET_VALUE_START (closed ) RET_VALUE_END ; 
  }


  if (scheme_check_print_is_obj && ! FUNCCALL(SETUP_XfOrM206(_), scheme_check_print_is_obj (obj ) )) {
#   define XfOrM477_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM477(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM477(_), print_utf8_string (pp , "#<" "???" ">" , 0 , 6 ) )
# 1817 "bc/src/print.c"
    ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }


  if (compact && ((! (((intptr_t ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) >= scheme_prim_type ) && (((obj ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
  || (((obj ) ) == (scheme_eof ) ) 
  || ((scheme_undefined ) == (obj ) ) 
  || ((scheme_parameterization_key ) == (obj ) ) 
  || ((scheme_break_enabled_key ) == (obj ) ) 
  || ((scheme_exn_handler_key ) == (obj ) ) 
  || ((Scheme_Type ) (scheme_always_evt_type ) == (Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) 
  || ((Scheme_Type ) (scheme_never_evt_type ) == (Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) 
  || ((Scheme_Type ) (scheme_struct_property_type ) == (Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) 
  || ((Scheme_Type ) (scheme_ctype_type ) == (Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) 
  || ((scheme_app_mark_impersonator_property ) == (obj ) ) ) ) {

    Scheme_Object * val ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM206_COUNT)));
#   define XfOrM475_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM475(x) SETUP(XfOrM475_COUNT)
    val = NULLED_OUT ; 

# 1836 "bc/src/print.c"
    val = FUNCCALL(SETUP_XfOrM475(_), scheme_hash_get (scheme_startup_env -> primitive_ids_table , obj ) ); 
    if (val ) {
#     define XfOrM476_COUNT (0+XfOrM475_COUNT)
#     define SETUP_XfOrM476(x) SETUP_XfOrM475(x)
      FUNCCALL(SETUP_XfOrM476(_), print_this_string (pp , & compacts [CPT_REFERENCE ] , 0 , 1 ) )
# 1838 "bc/src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM476(_), print_compact_number (pp , (((intptr_t ) (val ) ) >> 1 ) ) ); 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  if (ht && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) || (pp -> print_box && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) || (pp -> print_struct && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && (FUNCCALL(SETUP_XfOrM206(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ) || (((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && FUNCCALL(SETUP_XfOrM206(_), scheme_is_writable_struct (obj ) )) || (pp -> print_struct && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) || (pp -> print_hash_table && ((((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? (((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> count ) : (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (obj ) ) -> count ) ) ) ) ) ) {
    intptr_t val ; 
#   define XfOrM468_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM468(x) SETUP_XfOrM206(x)

# 1847 "bc/src/print.c"
    val = (intptr_t ) FUNCCALL(SETUP_XfOrM468(_), scheme_hash_get (ht , obj ) ); 

    if (val ) {
#     define XfOrM469_COUNT (0+XfOrM468_COUNT)
#     define SETUP_XfOrM469(x) SETUP_XfOrM468(x)

# 1850 "bc/src/print.c"
      if (val != 1 ) {
#       define XfOrM470_COUNT (0+XfOrM469_COUNT)
#       define SETUP_XfOrM470(x) SETUP_XfOrM469(x)

# 1851 "bc/src/print.c"
        if (compact ) {
#         define XfOrM474_COUNT (0+XfOrM470_COUNT)
#         define SETUP_XfOrM474(x) SETUP_XfOrM470(x)
          FUNCCALL(SETUP_XfOrM474(_), print_escaped (pp , notdisplay , obj , ht , mt , 0 ) )
# 1852 "bc/src/print.c"
          ; 
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        }

# 1854 "bc/src/print.c"
        else {
#         define XfOrM471_COUNT (0+XfOrM470_COUNT)
#         define SETUP_XfOrM471(x) SETUP_XfOrM470(x)

# 1855 "bc/src/print.c"
          if (val > 0 ) {
#           define XfOrM473_COUNT (0+XfOrM471_COUNT)
#           define SETUP_XfOrM473(x) SETUP_XfOrM471(x)
            (
# 1856 "bc/src/print.c"
            sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , "#%" "l" "d" "=" , (val - 3 ) >> 1 ) ) ; 
            FUNCCALL(SETUP_XfOrM473(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (ht , obj , (Scheme_Object * ) (- val ) ) ); 
          }

# 1859 "bc/src/print.c"
          else {
#           define XfOrM472_COUNT (0+XfOrM471_COUNT)
#           define SETUP_XfOrM472(x) SETUP_XfOrM471(x)
            (
# 1860 "bc/src/print.c"
            sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , "#%" "l" "d" "#" , ((- val ) - 3 ) >> 1 ) ) ; 
            FUNCCALL(SETUP_XfOrM472(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
      }
    }
  }

  if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) )  {
    if (! (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) )

    obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ) 
  {
    intptr_t l ; 
    Scheme_Object * idx ; 
    int is_kw ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM206_COUNT)));
#   define XfOrM457_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM457(x) SETUP(XfOrM457_COUNT)
    idx = NULLED_OUT ; 

# 1882 "bc/src/print.c"
    is_kw = ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ; 

    if (compact )
      idx = FUNCCALL(SETUP_XfOrM457(_), get_symtab_idx (mt , obj ) ); 
    else 
    idx = ((void * ) 0 ) ; 

    if (idx ) {
#     define XfOrM466_COUNT (0+XfOrM457_COUNT)
#     define SETUP_XfOrM466(x) SETUP_XfOrM457(x)
      FUNCCALL(SETUP_XfOrM466(_), print_symtab_ref (pp , idx ) )
# 1890 "bc/src/print.c"
      ; 
    }

# 1891 "bc/src/print.c"
    else if (compact ) {
      int weird ; 
#     define XfOrM462_COUNT (0+XfOrM457_COUNT)
#     define SETUP_XfOrM462(x) SETUP_XfOrM457(x)

# 1894 "bc/src/print.c"
      weird = ((& ((Scheme_Symbol * ) (obj ) ) -> iso ) -> so . keyex & 0x3 ) ; 
      l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) ; 
      if (! weird && ! is_kw && (l < (92 - 74 ) ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM465_COUNT (0+XfOrM462_COUNT)
#       define SETUP_XfOrM465(x) SETUP_XfOrM462(x)

# 1898 "bc/src/print.c"
        s [0 ] = l + 74 ; 
        FUNCCALL(SETUP_XfOrM465(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }

# 1900 "bc/src/print.c"
      else {
#       define XfOrM463_COUNT (0+XfOrM462_COUNT)
#       define SETUP_XfOrM463(x) SETUP_XfOrM462(x)
        FUNCCALL(SETUP_XfOrM463(_), print_this_string (pp , & compacts [(is_kw ? CPT_KEYWORD : (weird ? CPT_WEIRD_SYMBOL : CPT_SYMBOL ) ) ] , 0 , 1 ) ); 
        if (weird ) {
#         define XfOrM464_COUNT (0+XfOrM463_COUNT)
#         define SETUP_XfOrM464(x) SETUP_XfOrM463(x)
          FUNCCALL(SETUP_XfOrM464(_), print_compact_number (pp , ((& ((Scheme_Symbol * ) (obj ) ) -> iso ) -> so . keyex & 0x1 ) ? 1 : 0 ) )
# 1905 "bc/src/print.c"
          ; 
        }
        FUNCCALL(SETUP_XfOrM463(_), print_compact_number (pp , l ) ); 
      }
      (__funcarg103 = FUNCCALL(SETUP_XfOrM462(_), scheme_symbol_val (obj ) )


      , FUNCCALL_AGAIN(print_this_string (pp , __funcarg103 , 0 , l ) )) ; 
      FUNCCALL(SETUP_XfOrM462(_), symtab_set (pp , mt , obj ) )
      ; 
    }

# 1915 "bc/src/print.c"
    else if (notdisplay ) {
      const char * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM457_COUNT)));
#     define XfOrM459_COUNT (1+XfOrM457_COUNT)
#     define SETUP_XfOrM459(x) SETUP(XfOrM459_COUNT)
      s = NULLED_OUT ; 

# 1918 "bc/src/print.c"
      if (notdisplay >= 3 ) {
#       define XfOrM460_COUNT (0+XfOrM459_COUNT)
#       define SETUP_XfOrM460(x) SETUP_XfOrM459(x)

# 1919 "bc/src/print.c"
        if ((qq_ellipses ) == (obj ) )  {
        }
        else 
        notdisplay = FUNCCALL(SETUP_XfOrM460(_), to_quoted (((void * ) 0 ) , pp , notdisplay ) ); 
      }

      if (is_kw )
        FUNCCALL(SETUP_XfOrM459(_), print_utf8_string (pp , "#:" , 0 , 2 ) ); 
      s = FUNCCALL(SETUP_XfOrM459(_), scheme_symbol_name_and_size (obj , (uintptr_t * ) & l , ((pp -> can_read_pipe_quote ? 0x2 : 0x4 ) | (pp -> case_sens ? 0 : 0x8 ) | (is_kw ? 0x10 : 0 ) ) ) )








      ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , s , 0 , l ) ); 
    }

# 1938 "bc/src/print.c"
    else {
#     define XfOrM458_COUNT (0+XfOrM457_COUNT)
#     define SETUP_XfOrM458(x) SETUP_XfOrM457(x)

# 1939 "bc/src/print.c"
      if (is_kw )
        FUNCCALL(SETUP_XfOrM458(_), print_utf8_string (pp , "#:" , 0 , 2 ) ); 
      FUNCCALL(SETUP_XfOrM458(_), print_utf8_string (pp , (char * ) obj , ((char * ) ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> s ) ) ) - ((char * ) obj ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) ) )
      ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  
  {
#   define XfOrM451_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM451(x) SETUP_XfOrM206(x)

# 1947 "bc/src/print.c"
    if (compact ) {
      int l ; 
      Scheme_Object * idx ; 
      BLOCK_SETUP((PUSH(idx, 0+XfOrM451_COUNT)));
#     define XfOrM454_COUNT (1+XfOrM451_COUNT)
#     define SETUP_XfOrM454(x) SETUP(XfOrM454_COUNT)
      idx = NULLED_OUT ; 

# 1951 "bc/src/print.c"
      idx = FUNCCALL(SETUP_XfOrM454(_), get_symtab_idx (mt , obj ) ); 
      if (idx ) {
#       define XfOrM456_COUNT (0+XfOrM454_COUNT)
#       define SETUP_XfOrM456(x) SETUP_XfOrM454(x)
        FUNCCALL(SETUP_XfOrM456(_), print_symtab_ref (pp , idx ) )
# 1953 "bc/src/print.c"
        ; 
      }

# 1954 "bc/src/print.c"
      else {
#       define XfOrM455_COUNT (0+XfOrM454_COUNT)
#       define SETUP_XfOrM455(x) SETUP_XfOrM454(x)
        FUNCCALL(SETUP_XfOrM455(_), print_this_string (pp , & compacts [CPT_BYTE_STRING ] , 0 , 1 ) )
# 1955 "bc/src/print.c"
        ; 
        l = (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) ; 
        FUNCCALL(SETUP_XfOrM455(_), print_compact_number (pp , l ) ); 
        FUNCCALL_AGAIN(print_this_string (pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , l ) ); 
        FUNCCALL_AGAIN(symtab_set (pp , mt , obj ) )
        ; 
      }
    }

# 1962 "bc/src/print.c"
    else {
#     define XfOrM452_COUNT (0+XfOrM451_COUNT)
#     define SETUP_XfOrM452(x) SETUP_XfOrM451(x)

# 1963 "bc/src/print.c"
      if (notdisplay ) {
#       define XfOrM453_COUNT (0+XfOrM452_COUNT)
#       define SETUP_XfOrM453(x) SETUP_XfOrM452(x)
        FUNCCALL(SETUP_XfOrM453(_), print_utf8_string (pp , "#" , 0 , 1 ) )
# 1964 "bc/src/print.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM452(_), print_byte_string ((((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) , notdisplay , pp ) )


      ; 
      closed = 1 ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  
  {
    Scheme_Object * idx ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM206_COUNT)));
#   define XfOrM448_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM448(x) SETUP(XfOrM448_COUNT)
    idx = NULLED_OUT ; 

# 1977 "bc/src/print.c"
    if (compact )
      idx = FUNCCALL(SETUP_XfOrM448(_), get_symtab_idx (mt , obj ) ); 
    else 
    idx = ((void * ) 0 ) ; 

    if (idx ) {
#     define XfOrM450_COUNT (0+XfOrM448_COUNT)
#     define SETUP_XfOrM450(x) SETUP_XfOrM448(x)
      FUNCCALL(SETUP_XfOrM450(_), print_symtab_ref (pp , idx ) )
# 1983 "bc/src/print.c"
      ; 
    }

# 1984 "bc/src/print.c"
    else {
#     define XfOrM449_COUNT (0+XfOrM448_COUNT)
#     define SETUP_XfOrM449(x) SETUP_XfOrM448(x)
      FUNCCALL(SETUP_XfOrM449(_), do_print_string (compact , notdisplay , pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . tag_val ) ) )
# 1986 "bc/src/print.c"
      ; 
      if (compact )
        FUNCCALL(SETUP_XfOrM449(_), symtab_set (pp , mt , obj ) ); 
    }
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unquoted_printing_string_type ) )  
  {
#   define XfOrM445_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM445(x) SETUP_XfOrM206(x)

# 1994 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM447_COUNT (0+XfOrM445_COUNT)
#     define SETUP_XfOrM447(x) SETUP_XfOrM445(x)
      FUNCCALL(SETUP_XfOrM447(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 1995 "bc/src/print.c"
      ; 
    }

# 1996 "bc/src/print.c"
    else {
#     define XfOrM446_COUNT (0+XfOrM445_COUNT)
#     define SETUP_XfOrM446(x) SETUP_XfOrM445(x)

# 1997 "bc/src/print.c"
      obj = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
      FUNCCALL(SETUP_XfOrM446(_), do_print_string (compact , 0 , pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . tag_val ) ) )
      ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) )  
  {
#   define XfOrM443_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM443(x) SETUP_XfOrM206(x)

# 2004 "bc/src/print.c"
    if (compact ) {
      int cv ; 
#     define XfOrM444_COUNT (0+XfOrM443_COUNT)
#     define SETUP_XfOrM444(x) SETUP_XfOrM443(x)
      FUNCCALL(SETUP_XfOrM444(_), print_this_string (pp , & compacts [CPT_CHAR ] , 0 , 1 ) )
# 2006 "bc/src/print.c"
      ; 
      cv = (((Scheme_Small_Object * ) (obj ) ) -> u . char_val ) ; 
      FUNCCALL(SETUP_XfOrM444(_), print_compact_number (pp , cv ) ); 
    }

# 2009 "bc/src/print.c"
    else FUNCCALL(SETUP_XfOrM443(_), print_char (obj , notdisplay , pp ) )
    ; 
  }
  else if (((intptr_t ) (obj ) ) & 0x1 )  
  {
#   define XfOrM436_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM436(x) SETUP_XfOrM206(x)

# 2014 "bc/src/print.c"
    if (compact ) {
      intptr_t v = (((intptr_t ) (obj ) ) >> 1 ) ; 
#     define XfOrM438_COUNT (0+XfOrM436_COUNT)
#     define SETUP_XfOrM438(x) SETUP_XfOrM436(x)

# 2016 "bc/src/print.c"
      if (v >= 0 && v < (74 - 48 ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM442_COUNT (0+XfOrM438_COUNT)
#       define SETUP_XfOrM442(x) SETUP_XfOrM438(x)

# 2018 "bc/src/print.c"
        s [0 ] = (unsigned char ) (v + 48 ) ; 
        FUNCCALL(SETUP_XfOrM442(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }

# 2020 "bc/src/print.c"
      else {
#       define XfOrM439_COUNT (0+XfOrM438_COUNT)
#       define SETUP_XfOrM439(x) SETUP_XfOrM438(x)

# 2022 "bc/src/print.c"
        if (((v ) >= - 1073741824 ) && ((v ) <= 1073741823 ) )  {
#         define XfOrM441_COUNT (0+XfOrM439_COUNT)
#         define SETUP_XfOrM441(x) SETUP_XfOrM439(x)
          FUNCCALL(SETUP_XfOrM441(_), print_this_string (pp , & compacts [CPT_INT ] , 0 , 1 ) )
# 2023 "bc/src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM441(_), print_compact_number (pp , v ) ); 
        }

# 2025 "bc/src/print.c"
        else {
#         define XfOrM440_COUNT (0+XfOrM439_COUNT)
#         define SETUP_XfOrM440(x) SETUP_XfOrM439(x)
          FUNCCALL(SETUP_XfOrM440(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) )
# 2026 "bc/src/print.c"
          ; 
        }
      }
    }

# 2029 "bc/src/print.c"
    else {
#     define XfOrM437_COUNT (0+XfOrM436_COUNT)
#     define SETUP_XfOrM437(x) SETUP_XfOrM436(x)
      (
# 2030 "bc/src/print.c"
      sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , "%" "l" "d" "" , (((intptr_t ) (obj ) ) >> 1 ) ) ) ; 
      FUNCCALL(SETUP_XfOrM437(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
    }
  }
  else if (((((intptr_t ) (obj ) ) & 0x1 ) || ((((obj ) -> type ) >= scheme_bignum_type ) && (((obj ) -> type ) <= scheme_complex_type ) ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_long_double_type ) ) ) 
  {
#   define XfOrM433_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM433(x) SETUP_XfOrM206(x)

# 2036 "bc/src/print.c"
    if (compact ) {
#     define XfOrM435_COUNT (0+XfOrM433_COUNT)
#     define SETUP_XfOrM435(x) SETUP_XfOrM433(x)
      FUNCCALL(SETUP_XfOrM435(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) )
# 2037 "bc/src/print.c"
      ; 
      closed = 1 ; 
    }

# 2039 "bc/src/print.c"
    else {
#     define XfOrM434_COUNT (0+XfOrM433_COUNT)
#     define SETUP_XfOrM434(x) SETUP_XfOrM433(x)
      (__funcarg102 = FUNCCALL(SETUP_XfOrM434(_), scheme_number_to_string (10 , obj ) )
# 2040 "bc/src/print.c"
      , FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg102 , 0 , - 1 ) )) ; 
    }
  }
  else if ((obj ) == (scheme_null ) )  
  {
#   define XfOrM430_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM430(x) SETUP_XfOrM206(x)

# 2045 "bc/src/print.c"
    if (compact ) {
#     define XfOrM432_COUNT (0+XfOrM430_COUNT)
#     define SETUP_XfOrM432(x) SETUP_XfOrM430(x)
      FUNCCALL(SETUP_XfOrM432(_), print_this_string (pp , & compacts [CPT_NULL ] , 0 , 1 ) )
# 2046 "bc/src/print.c"
      ; 
    }

# 2047 "bc/src/print.c"
    else {
#     define XfOrM431_COUNT (0+XfOrM430_COUNT)
#     define SETUP_XfOrM431(x) SETUP_XfOrM430(x)
      FUNCCALL(SETUP_XfOrM431(_), to_quoted (((void * ) 0 ) , pp , notdisplay ) )
# 2048 "bc/src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM431(_), print_utf8_string (pp , "()" , 0 , 2 ) ); 
      closed = 1 ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  
  {
#   define XfOrM429_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM429(x) SETUP_XfOrM206(x)

# 2055 "bc/src/print.c"
    notdisplay = FUNCCALL(SETUP_XfOrM429(_), to_quoted (obj , pp , notdisplay ) ); 
    FUNCCALL(SETUP_XfOrM429(_), print_pair (obj , notdisplay , compact , ht , mt , pp , scheme_pair_type , ! pp -> print_pair_curly , 0 ) ); 
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) )  
  {
#   define XfOrM428_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM428(x) SETUP_XfOrM206(x)

# 2061 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM428(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    FUNCCALL(SETUP_XfOrM428(_), print_pair (obj , notdisplay , compact , ht , mt , pp , scheme_mutable_pair_type , ! pp -> print_mpair_curly , 0 ) ); 
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) )  
  {
#   define XfOrM427_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM427(x) SETUP_XfOrM206(x)

# 2068 "bc/src/print.c"
    notdisplay = FUNCCALL(SETUP_XfOrM427(_), to_quoted (obj , pp , notdisplay ) ); 
    FUNCCALL(SETUP_XfOrM427(_), print_vector (obj , notdisplay , compact , ht , mt , pp , 0 ) ); 
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) )  
  {
#   define XfOrM426_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM426(x) SETUP_XfOrM206(x)

# 2074 "bc/src/print.c"
    notdisplay = FUNCCALL(SETUP_XfOrM426(_), to_quoted (obj , pp , notdisplay ) ); 
    FUNCCALL(SETUP_XfOrM426(_), print_flvector (obj , notdisplay , compact , ht , mt , pp , 0 ) ); 
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) )  
  {
#   define XfOrM425_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM425(x) SETUP_XfOrM206(x)

# 2080 "bc/src/print.c"
    notdisplay = FUNCCALL(SETUP_XfOrM425(_), to_quoted (obj , pp , notdisplay ) ); 
    FUNCCALL(SETUP_XfOrM425(_), print_fxvector (obj , notdisplay , compact , ht , mt , pp , 0 ) ); 
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) )  
  {
    Scheme_Stencil_Vector * sv = (Scheme_Stencil_Vector * ) obj ; 
    intptr_t len , i ; 
    int sub_notdisplay = ((notdisplay > 1 ) ? 1 : notdisplay ) ; 
    BLOCK_SETUP((PUSH(sv, 0+XfOrM206_COUNT)));
#   define XfOrM422_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM422(x) SETUP(XfOrM422_COUNT)

# 2090 "bc/src/print.c"
    len = (scheme_stencil_vector_popcount (sv -> mask ) ) ; 
    FUNCCALL(SETUP_XfOrM422(_), print_utf8_string (pp , "#<stencil " , 0 , 10 ) )
    ; 
    (sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , "%" "l" "d" "" , sv -> mask ) ) ; 
    FUNCCALL(SETUP_XfOrM422(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
    if (sv -> mask != 0 )
      FUNCCALL(SETUP_XfOrM422(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 

    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM424_COUNT (0+XfOrM422_COUNT)
#     define SETUP_XfOrM424(x) SETUP_XfOrM422(x)
      FUNCCALL(SETUP_XfOrM424(_), print_utf8_string (pp , " " , 0 , 1 ) )
# 2099 "bc/src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM424(_), print (sv -> els [i ] , sub_notdisplay , compact , ht , mt , pp ) ); 
    }
    FUNCCALL(SETUP_XfOrM422(_), print_utf8_string (pp , ">" , 0 , 1 ) )
    ; 
    closed = 1 ; 
  }
  else if ((compact || pp -> print_box ) && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) 
  {
#   define XfOrM418_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM418(x) SETUP_XfOrM206(x)

# 2108 "bc/src/print.c"
    if (compact && ! pp -> print_box ) {
#     define XfOrM421_COUNT (0+XfOrM418_COUNT)
#     define SETUP_XfOrM421(x) SETUP_XfOrM418(x)

# 2109 "bc/src/print.c"
      closed = (__funcarg101 = FUNCCALL(SETUP_XfOrM421(_), scheme_protect_quote (obj ) ), FUNCCALL_AGAIN(print (__funcarg101 , notdisplay , compact , ht , mt , pp ) )) ; 
    }

# 2110 "bc/src/print.c"
    else {
      Scheme_Object * content ; 
      BLOCK_SETUP((PUSH(content, 0+XfOrM418_COUNT)));
#     define XfOrM419_COUNT (1+XfOrM418_COUNT)
#     define SETUP_XfOrM419(x) SETUP(XfOrM419_COUNT)
      content = NULLED_OUT ; 

# 2112 "bc/src/print.c"
      if (compact )
        FUNCCALL(SETUP_XfOrM419(_), print_this_string (pp , & compacts [CPT_BOX ] , 0 , 1 ) ); 
      else {
#       define XfOrM420_COUNT (0+XfOrM419_COUNT)
#       define SETUP_XfOrM420(x) SETUP_XfOrM419(x)

# 2115 "bc/src/print.c"
        notdisplay = FUNCCALL(SETUP_XfOrM420(_), to_quoted (obj , pp , notdisplay ) ); 
        if (notdisplay == 3 )
          FUNCCALL(SETUP_XfOrM420(_), print_utf8_string (pp , "(box " , 0 , 5 ) ); 
        else FUNCCALL(SETUP_XfOrM420(_), print_utf8_string (pp , "#&" , 0 , 2 ) )
        ; 
      }
      if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
        content = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
      else 
      content = FUNCCALL(SETUP_XfOrM419(_), scheme_unbox (obj ) ); 
      closed = FUNCCALL(SETUP_XfOrM419(_), print (content , notdisplay , compact , ht , mt , pp ) ); 
      if (notdisplay == 3 )
        FUNCCALL(SETUP_XfOrM419(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    }
  }
  else if ((compact || pp -> print_hash_table ) 
  && ((((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) || (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) ) ) ) 
  {
    Scheme_Hash_Table * t ; 
    Scheme_Hash_Tree * tr ; 
    Scheme_Object * * keys , * * vals , * val , * key , * orig , * * sorted_keys ; 
    intptr_t i , size , count , vals_size ; 
    int did_one = 0 ; 
    mzlonglong pos ; 
    BLOCK_SETUP((PUSH(vals, 0+XfOrM206_COUNT), PUSH(t, 1+XfOrM206_COUNT), PUSH(sorted_keys, 2+XfOrM206_COUNT), PUSH(val, 3+XfOrM206_COUNT), PUSH(tr, 4+XfOrM206_COUNT), PUSH(key, 5+XfOrM206_COUNT), PUSH(keys, 6+XfOrM206_COUNT), PUSH(orig, 7+XfOrM206_COUNT)));
#   define XfOrM388_COUNT (8+XfOrM206_COUNT)
#   define SETUP_XfOrM388(x) SETUP(XfOrM388_COUNT)
    t = NULLED_OUT ; 
    tr = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    key = NULLED_OUT ; 
    orig = NULLED_OUT ; 
    sorted_keys = NULLED_OUT ; 

# 2140 "bc/src/print.c"
    orig = obj ; 
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 

    if (compact ) {
#     define XfOrM417_COUNT (0+XfOrM388_COUNT)
#     define SETUP_XfOrM417(x) SETUP_XfOrM388(x)
      FUNCCALL(SETUP_XfOrM417(_), print_this_string (pp , & compacts [CPT_HASH_TABLE ] , 0 , 1 ) )
# 2145 "bc/src/print.c"
      ; 
      if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && FUNCCALL(SETUP_XfOrM417(_), scheme_is_hash_table_equal (obj ) )) 
      || (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && FUNCCALL(SETUP_XfOrM417(_), scheme_is_hash_tree_equal (obj ) )) )
        FUNCCALL(SETUP_XfOrM417(_), print_compact_number (pp , 1 ) ); 
      else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && FUNCCALL(SETUP_XfOrM417(_), scheme_is_hash_table_equal_always (obj ) )) 
      || (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && FUNCCALL(SETUP_XfOrM417(_), scheme_is_hash_tree_equal_always (obj ) )) )
        FUNCCALL(SETUP_XfOrM417(_), print_compact_number (pp , 3 ) ); 
      else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && FUNCCALL(SETUP_XfOrM417(_), scheme_is_hash_table_eqv (obj ) )) 
      || (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && FUNCCALL(SETUP_XfOrM417(_), scheme_is_hash_tree_eqv (obj ) )) )
        FUNCCALL(SETUP_XfOrM417(_), print_compact_number (pp , 2 ) ); 
      else FUNCCALL(SETUP_XfOrM417(_), print_compact_number (pp , 0 ) )
      ; 
    }

# 2157 "bc/src/print.c"
    else {
#     define XfOrM412_COUNT (0+XfOrM388_COUNT)
#     define SETUP_XfOrM412(x) SETUP_XfOrM388(x)

# 2158 "bc/src/print.c"
      notdisplay = FUNCCALL(SETUP_XfOrM412(_), to_quoted (obj , pp , notdisplay ) ); 
      if (notdisplay == 3 )
        FUNCCALL(SETUP_XfOrM412(_), print_utf8_string (pp , "(hash" , 0 , 5 ) ); 
      else FUNCCALL(SETUP_XfOrM412(_), print_utf8_string (pp , "#hash" , 0 , 5 ) )
      ; 
      if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
#       define XfOrM415_COUNT (0+XfOrM412_COUNT)
#       define SETUP_XfOrM415(x) SETUP_XfOrM412(x)

# 2164 "bc/src/print.c"
        if (! FUNCCALL(SETUP_XfOrM415(_), scheme_is_hash_table_equal (obj ) )) {
#         define XfOrM416_COUNT (0+XfOrM415_COUNT)
#         define SETUP_XfOrM416(x) SETUP_XfOrM415(x)

# 2165 "bc/src/print.c"
          if (FUNCCALL(SETUP_XfOrM416(_), scheme_is_hash_table_eqv (obj ) ))
            FUNCCALL(SETUP_XfOrM416(_), print_utf8_string (pp , "eqv" , 0 , 3 ) ); 
          else if (FUNCCALL(SETUP_XfOrM416(_), scheme_is_hash_table_equal_always (obj ) ))
            FUNCCALL(SETUP_XfOrM416(_), print_utf8_string (pp , "alw" , 0 , 3 ) ); 
          else FUNCCALL(SETUP_XfOrM416(_), print_utf8_string (pp , "eq" , 0 , 2 ) )
          ; 
        }
      }

# 2172 "bc/src/print.c"
      else {
#       define XfOrM413_COUNT (0+XfOrM412_COUNT)
#       define SETUP_XfOrM413(x) SETUP_XfOrM412(x)

# 2173 "bc/src/print.c"
        if (! FUNCCALL(SETUP_XfOrM413(_), scheme_is_hash_tree_equal (obj ) )) {
#         define XfOrM414_COUNT (0+XfOrM413_COUNT)
#         define SETUP_XfOrM414(x) SETUP_XfOrM413(x)

# 2174 "bc/src/print.c"
          if (FUNCCALL(SETUP_XfOrM414(_), scheme_is_hash_tree_eqv (obj ) ))
            FUNCCALL(SETUP_XfOrM414(_), print_utf8_string (pp , "eqv" , 0 , 3 ) ); 
          else if (FUNCCALL(SETUP_XfOrM414(_), scheme_is_hash_tree_equal_always (obj ) ))
            FUNCCALL(SETUP_XfOrM414(_), print_utf8_string (pp , "alw" , 0 , 3 ) ); 
          else FUNCCALL(SETUP_XfOrM414(_), print_utf8_string (pp , "eq" , 0 , 2 ) )
          ; 
        }
      }
      if (notdisplay == 3 )
        FUNCCALL(SETUP_XfOrM412(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
      if (notdisplay != 3 )
        FUNCCALL(SETUP_XfOrM412(_), print_utf8_string (pp , "(" , 0 , 1 ) ); 
    }

    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
      t = (Scheme_Hash_Table * ) obj ; 
      tr = ((void * ) 0 ) ; 
    }

# 2191 "bc/src/print.c"
    else {
      t = ((void * ) 0 ) ; 
      tr = (Scheme_Hash_Tree * ) obj ; 
    }

    if (t ) {
      keys = t -> keys ; 
      vals = t -> vals ; 
      size = t -> size ; 
      vals_size = size ; 
      count = t -> count ; 
    }

# 2202 "bc/src/print.c"
    else {
      keys = ((void * ) 0 ) ; 
      vals = ((void * ) 0 ) ; 
      vals_size = 0 ; 
      size = tr -> count ; 
      count = size ; 
    }

    if (compact )
      FUNCCALL(SETUP_XfOrM388(_), print_compact_number (pp , count ) ); 


    if ((obj ) == (orig ) )  {
#     define XfOrM407_COUNT (0+XfOrM388_COUNT)
#     define SETUP_XfOrM407(x) SETUP_XfOrM388(x)

# 2215 "bc/src/print.c"
      sorted_keys = FUNCCALL(SETUP_XfOrM407(_), scheme_extract_sorted_keys (obj ) ); 
      if (sorted_keys )
        size = count ; 
    }

# 2218 "bc/src/print.c"
    else 
    sorted_keys = ((void * ) 0 ) ; 

    pos = - 1 ; 
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM398_COUNT (0+XfOrM388_COUNT)
#     define SETUP_XfOrM398(x) SETUP_XfOrM388(x)

# 2223 "bc/src/print.c"
      if (! vals || vals [i ] || sorted_keys ) {
#       define XfOrM399_COUNT (0+XfOrM398_COUNT)
#       define SETUP_XfOrM399(x) SETUP_XfOrM398(x)

# 2224 "bc/src/print.c"
        if (sorted_keys ) {
#         define XfOrM406_COUNT (0+XfOrM399_COUNT)
#         define SETUP_XfOrM406(x) SETUP_XfOrM399(x)

# 2225 "bc/src/print.c"
          key = sorted_keys [i ] ; 
          if (t )
            val = FUNCCALL(SETUP_XfOrM406(_), scheme_hash_get (t , key ) ); 
          else 
          val = FUNCCALL(SETUP_XfOrM406(_), scheme_hash_tree_get (tr , key ) ); 
        }

# 2230 "bc/src/print.c"
        else if (! vals ) {
#         define XfOrM405_COUNT (0+XfOrM399_COUNT)
#         define SETUP_XfOrM405(x) SETUP_XfOrM399(x)

# 2231 "bc/src/print.c"
          pos = (scheme_hash_tree_next (tr , pos ) ) ; 
          (scheme_hash_tree_index (tr , pos , & key , & val ) ) ; 
          if (! ((obj ) == (orig ) ) )
            val = FUNCCALL(SETUP_XfOrM405(_), scheme_chaperone_hash_traversal_get (orig , key , & key ) ); 
        }

# 2235 "bc/src/print.c"
        else {
#         define XfOrM403_COUNT (0+XfOrM399_COUNT)
#         define SETUP_XfOrM403(x) SETUP_XfOrM399(x)

# 2236 "bc/src/print.c"
          if (i < vals_size ) {
#           define XfOrM404_COUNT (0+XfOrM403_COUNT)
#           define SETUP_XfOrM404(x) SETUP_XfOrM403(x)

# 2237 "bc/src/print.c"
            val = vals [i ] ; 
            key = keys [i ] ; 
            if (! ((obj ) == (orig ) ) )
              val = FUNCCALL(SETUP_XfOrM404(_), scheme_chaperone_hash_traversal_get (orig , key , & key ) ); 
          }

# 2241 "bc/src/print.c"
          else 
          val = ((void * ) 0 ) ; 
        }

        if (val ) {
#         define XfOrM400_COUNT (0+XfOrM399_COUNT)
#         define SETUP_XfOrM400(x) SETUP_XfOrM399(x)

# 2246 "bc/src/print.c"
          if (! compact ) {
#           define XfOrM402_COUNT (0+XfOrM400_COUNT)
#           define SETUP_XfOrM402(x) SETUP_XfOrM400(x)

# 2247 "bc/src/print.c"
            if (did_one )
              FUNCCALL(SETUP_XfOrM402(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
            if (notdisplay != 3 )
              FUNCCALL(SETUP_XfOrM402(_), print_utf8_string (pp , "(" , 0 , 1 ) ); 
          }
          FUNCCALL(SETUP_XfOrM400(_), print (key , notdisplay , compact , ht , mt , pp ) ); 
          if (! compact ) {
#           define XfOrM401_COUNT (0+XfOrM400_COUNT)
#           define SETUP_XfOrM401(x) SETUP_XfOrM400(x)

# 2254 "bc/src/print.c"
            if (notdisplay == 3 )
              FUNCCALL(SETUP_XfOrM401(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
            else FUNCCALL(SETUP_XfOrM401(_), print_utf8_string (pp , " . " , 0 , 3 ) )
            ; 
          }
          FUNCCALL(SETUP_XfOrM400(_), print (val , notdisplay , compact , ht , mt , pp ) ); 
          if (! compact && (notdisplay != 3 ) )
            FUNCCALL(SETUP_XfOrM400(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
          did_one ++ ; 
        }
      }
    }

    if (! compact && (notdisplay != 3 ) )
      FUNCCALL(SETUP_XfOrM388(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    if (notdisplay == 3 )
      FUNCCALL(SETUP_XfOrM388(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 

    closed = 1 ; 
  }
  else if ((obj ) == (scheme_true ) )  
  {
#   define XfOrM387_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM387(x) SETUP_XfOrM206(x)

# 2276 "bc/src/print.c"
    if (compact )
      FUNCCALL(SETUP_XfOrM387(_), print_this_string (pp , & compacts [CPT_TRUE ] , 0 , 1 ) ); 
    else if (pp -> print_long_bools )
      FUNCCALL(SETUP_XfOrM387(_), print_utf8_string (pp , "#true" , 0 , 5 ) ); 
    else FUNCCALL(SETUP_XfOrM387(_), print_utf8_string (pp , "#t" , 0 , 2 ) )
    ; 
  }
  else if ((obj ) == (scheme_false ) )  
  {
#   define XfOrM386_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM386(x) SETUP_XfOrM206(x)

# 2285 "bc/src/print.c"
    if (compact )
      FUNCCALL(SETUP_XfOrM386(_), print_this_string (pp , & compacts [CPT_FALSE ] , 0 , 1 ) ); 
    else if (pp -> print_long_bools )
      FUNCCALL(SETUP_XfOrM386(_), print_utf8_string (pp , "#false" , 0 , 6 ) ); 
    else FUNCCALL(SETUP_XfOrM386(_), print_utf8_string (pp , "#f" , 0 , 2 ) )
    ; 
  }
  else if (compact && ((obj ) == (scheme_void ) ) ) 
  {
#   define XfOrM385_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM385(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM385(_), print_this_string (pp , & compacts [CPT_VOID ] , 0 , 1 ) )
# 2294 "bc/src/print.c"
    ; 
  }
  else if (compact && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && FUNCCALL(SETUP_XfOrM206(_), scheme_is_location (obj ) )) 
  {


    int i ; 
    Scheme_Object * src , * rel_src , * dir ; 
    BLOCK_SETUP((PUSH(rel_src, 0+XfOrM206_COUNT), PUSH(dir, 1+XfOrM206_COUNT), PUSH(src, 2+XfOrM206_COUNT)));
#   define XfOrM376_COUNT (3+XfOrM206_COUNT)
#   define SETUP_XfOrM376(x) SETUP(XfOrM376_COUNT)
    src = NULLED_OUT ; 
    rel_src = NULLED_OUT ; 
    dir = NULLED_OUT ; 

# 2303 "bc/src/print.c"
    src = FUNCCALL(SETUP_XfOrM376(_), scheme_struct_ref (obj , 0 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#     define XfOrM381_COUNT (0+XfOrM376_COUNT)
#     define SETUP_XfOrM381(x) SETUP_XfOrM376(x)


      dir = (__funcarg100 = FUNCCALL(SETUP_XfOrM381(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg100 , MZCONFIG_WRITE_DIRECTORY ) )) 
      ; 
      if (! (((dir ) ) == (scheme_false ) ) ) 
        rel_src = FUNCCALL(SETUP_XfOrM381(_), scheme_extract_relative_to (src , dir , mt -> path_cache ) ); 
      else 
      rel_src = src ; 
      if ((Scheme_Type ) (((((intptr_t ) (rel_src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rel_src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#       define XfOrM383_COUNT (0+XfOrM381_COUNT)
#       define SETUP_XfOrM383(x) SETUP_XfOrM381(x)

# 2316 "bc/src/print.c"
        src = (__funcarg99 = FUNCCALL(SETUP_XfOrM383(_), scheme_box (rel_src ) ), FUNCCALL_AGAIN(scheme_hash_get (mt -> path_cache , __funcarg99 ) )) ; 
        if (! src ) {
#         define XfOrM384_COUNT (0+XfOrM383_COUNT)
#         define SETUP_XfOrM384(x) SETUP_XfOrM383(x)

# 2318 "bc/src/print.c"
          src = FUNCCALL(SETUP_XfOrM384(_), srcloc_path_to_string (rel_src ) ); 
          (__funcarg98 = FUNCCALL(SETUP_XfOrM384(_), scheme_box (rel_src ) ), FUNCCALL_AGAIN(scheme_hash_set (mt -> path_cache , __funcarg98 , src ) )) ; 
        }
      }

# 2321 "bc/src/print.c"
      else {
      }
    }
    else if ((((src ) ) == (scheme_false ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    || ((((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) <= scheme_windows_path_type ) ) ) {
    }
    else {
#     define XfOrM379_COUNT (0+XfOrM376_COUNT)
#     define SETUP_XfOrM379(x) SETUP_XfOrM376(x)
      FUNCCALL(SETUP_XfOrM379(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2331 "bc/src/print.c"
      ; 
    }
    FUNCCALL(SETUP_XfOrM376(_), print_this_string (pp , & compacts [CPT_SRCLOC ] , 0 , 1 ) )
    ; 
    FUNCCALL(SETUP_XfOrM376(_), print (src , notdisplay , compact , ht , mt , pp ) ); 
    for (i = 1 ; i < 5 ; i ++ ) {
#     define XfOrM378_COUNT (0+XfOrM376_COUNT)
#     define SETUP_XfOrM378(x) SETUP_XfOrM376(x)
      (__funcarg97 = FUNCCALL(SETUP_XfOrM378(_), scheme_struct_ref (obj , i ) )
# 2337 "bc/src/print.c"
      , FUNCCALL_AGAIN(print (__funcarg97 , notdisplay , compact , ht , mt , pp ) )) ; 
    }

    closed = 1 ; 
  }
  else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) )  
  {
#   define XfOrM357_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM357(x) SETUP_XfOrM206(x)

# 2344 "bc/src/print.c"
    if (compact && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) {
      Scheme_Object * vec , * prefab ; 
      BLOCK_SETUP((PUSH(vec, 0+XfOrM357_COUNT), PUSH(prefab, 1+XfOrM357_COUNT)));
#     define XfOrM375_COUNT (2+XfOrM357_COUNT)
#     define SETUP_XfOrM375(x) SETUP(XfOrM375_COUNT)
      vec = NULLED_OUT ; 
      prefab = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM375(_), print_this_string (pp , & compacts [CPT_PREFAB ] , 0 , 1 ) )
# 2346 "bc/src/print.c"
      ; 
      prefab = (scheme_prefab_struct_key (obj ) ) ; 
      vec = FUNCCALL(SETUP_XfOrM375(_), scheme_struct_to_vector (obj , (notdisplay >= 3 ) ? qq_ellipses : ((void * ) 0 ) , pp -> inspector ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = prefab ; 
      FUNCCALL(SETUP_XfOrM375(_), print_vector (vec , notdisplay , compact , ht , mt , pp , 1 ) ); 
    }

# 2351 "bc/src/print.c"
    else if (compact || (! pp -> print_unreadable && ! ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) ) {
#     define XfOrM374_COUNT (0+XfOrM357_COUNT)
#     define SETUP_XfOrM374(x) SETUP_XfOrM357(x)
      FUNCCALL(SETUP_XfOrM374(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2352 "bc/src/print.c"
      ; 
    }

# 2353 "bc/src/print.c"
    else if (FUNCCALL(SETUP_XfOrM357(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM372_COUNT (0+XfOrM357_COUNT)
#     define SETUP_XfOrM372(x) SETUP_XfOrM357(x)

# 2354 "bc/src/print.c"
      if (notdisplay == 3 ) {
        Scheme_Object * kind ; 
        BLOCK_SETUP((PUSH(kind, 0+XfOrM372_COUNT)));
#       define XfOrM373_COUNT (1+XfOrM372_COUNT)
#       define SETUP_XfOrM373(x) SETUP(XfOrM373_COUNT)
        kind = NULLED_OUT ; 

# 2356 "bc/src/print.c"
        kind = FUNCCALL(SETUP_XfOrM373(_), scheme_print_attribute_ref (obj ) ); 
        if (kind 
        && (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "never" ) ) 
        && (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "self" ) ) )
          notdisplay = FUNCCALL(SETUP_XfOrM373(_), to_quoted (obj , pp , notdisplay ) ); 
      }
      FUNCCALL(SETUP_XfOrM372(_), custom_write_struct (obj , ht , mt , pp , notdisplay ) ); 
    }

# 2363 "bc/src/print.c"
    else {
      int pb ; 
#     define XfOrM358_COUNT (0+XfOrM357_COUNT)
#     define SETUP_XfOrM358(x) SETUP_XfOrM357(x)

# 2366 "bc/src/print.c"
      pb = pp -> print_struct && (FUNCCALL(SETUP_XfOrM358(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ; 

      if (pb ) {
        Scheme_Object * vec , * prefab ; 
        BLOCK_SETUP((PUSH(prefab, 0+XfOrM358_COUNT), PUSH(vec, 1+XfOrM358_COUNT)));
#       define XfOrM369_COUNT (2+XfOrM358_COUNT)
#       define SETUP_XfOrM369(x) SETUP(XfOrM369_COUNT)
        vec = NULLED_OUT ; 
        prefab = NULLED_OUT ; 

# 2370 "bc/src/print.c"
        prefab = (scheme_prefab_struct_key (obj ) ) ; 
        vec = FUNCCALL(SETUP_XfOrM369(_), scheme_struct_to_vector (obj , (notdisplay >= 3 ) ? qq_ellipses : ((void * ) 0 ) , pp -> inspector ) ); 
        if (! (((prefab ) ) == (scheme_false ) ) ) 
          notdisplay = FUNCCALL(SETUP_XfOrM369(_), to_quoted (obj , pp , notdisplay ) ); 
        if (notdisplay == 3 ) {
#         define XfOrM371_COUNT (0+XfOrM369_COUNT)
#         define SETUP_XfOrM371(x) SETUP_XfOrM369(x)

# 2375 "bc/src/print.c"
          if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
            obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 
          vec = FUNCCALL(SETUP_XfOrM371(_), scheme_vector_to_list (vec ) ); 
          vec = FUNCCALL_AGAIN(scheme_make_pair (((((Scheme_Structure * ) obj ) -> stype ) -> name ) , (((Scheme_Simple_Object * ) (vec ) ) -> u . pair_val . cdr ) ) ); 
          FUNCCALL_AGAIN(print_pair (vec , notdisplay , compact , ht , mt , pp , scheme_pair_type , 1 , 1 ) ); 
        }

# 2380 "bc/src/print.c"
        else {
#         define XfOrM370_COUNT (0+XfOrM369_COUNT)
#         define SETUP_XfOrM370(x) SETUP_XfOrM369(x)

# 2381 "bc/src/print.c"
          if (! (((prefab ) ) == (scheme_false ) ) ) 
            (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = prefab ; 
          FUNCCALL(SETUP_XfOrM370(_), print_vector (vec , notdisplay , compact , ht , mt , pp , (! (((prefab ) ) == (scheme_false ) ) ) ) ); 
        }
        closed = 1 ; 
      }

# 2386 "bc/src/print.c"
      else {
        Scheme_Object * src ; 
        int check_object_name ; 
        BLOCK_SETUP((PUSH(src, 0+XfOrM358_COUNT)));
#       define XfOrM359_COUNT (1+XfOrM358_COUNT)
#       define SETUP_XfOrM359(x) SETUP(XfOrM359_COUNT)
        src = NULLED_OUT ; 

# 2390 "bc/src/print.c"
        if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
          obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 

        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) )  {
#         define XfOrM368_COUNT (0+XfOrM359_COUNT)
#         define SETUP_XfOrM368(x) SETUP_XfOrM359(x)

# 2395 "bc/src/print.c"
          src = FUNCCALL(SETUP_XfOrM368(_), scheme_proc_struct_name_source (obj ) ); 
          check_object_name = 1 ; 
        }

# 2397 "bc/src/print.c"
        else {
          src = obj ; 
          check_object_name = 0 ; 
        }

        if ((src ) == (obj ) )  {
          intptr_t l ; 
          const char * s ; 
          Scheme_Object * name ; 
          BLOCK_SETUP((PUSH(s, 0+XfOrM359_COUNT), PUSH(name, 1+XfOrM359_COUNT)));
#         define XfOrM361_COUNT (2+XfOrM359_COUNT)
#         define SETUP_XfOrM361(x) SETUP(XfOrM361_COUNT)
          s = NULLED_OUT ; 
          name = NULLED_OUT ; 
          FUNCCALL(SETUP_XfOrM361(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2407 "bc/src/print.c"
          ; 
          if (check_object_name 
          && scheme_object_name_property 
          && (scheme_struct_type_property_ref (scheme_object_name_property , obj ) ) ) {
#           define XfOrM366_COUNT (0+XfOrM361_COUNT)
#           define SETUP_XfOrM366(x) SETUP_XfOrM361(x)

# 2411 "bc/src/print.c"
            name = FUNCCALL(SETUP_XfOrM366(_), scheme_object_name (obj ) ); 
            if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
              name = FUNCCALL(SETUP_XfOrM366(_), scheme_path_to_char_string (name ) ); 
            FUNCCALL(SETUP_XfOrM366(_), print_utf8_string (pp , "procedure:" , 0 , ((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) ? 10 : 9 ) ) )

            ; 
          }

# 2417 "bc/src/print.c"
          else if (scheme_reduced_procedure_struct 
          && (scheme_is_struct_instance (scheme_reduced_procedure_struct , obj ) ) ) {
#           define XfOrM365_COUNT (0+XfOrM361_COUNT)
#           define SETUP_XfOrM365(x) SETUP_XfOrM361(x)
            FUNCCALL(SETUP_XfOrM365(_), print_utf8_string (pp , "procedure:" , 0 , 10 ) ); 
            name = ((Scheme_Structure * ) obj ) -> slots [2 ] ; 
          }

# 2423 "bc/src/print.c"
          else {
#           define XfOrM364_COUNT (0+XfOrM361_COUNT)
#           define SETUP_XfOrM364(x) SETUP_XfOrM361(x)

# 2424 "bc/src/print.c"
            if (! (((intptr_t ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) >= scheme_prim_type ) && (((obj ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
              FUNCCALL(SETUP_XfOrM364(_), print_utf8_string (pp , "procedure:" , 0 , 10 ) ); 
            name = ((((Scheme_Structure * ) obj ) -> stype ) -> name ) ; 
          }

          if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#           define XfOrM363_COUNT (0+XfOrM361_COUNT)
#           define SETUP_XfOrM363(x) SETUP_XfOrM361(x)

# 2430 "bc/src/print.c"
            s = FUNCCALL(SETUP_XfOrM363(_), scheme_symbol_val (name ) ); 
            l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
            FUNCCALL(SETUP_XfOrM363(_), print_utf8_string (pp , s , 0 , l ) )
            ; 
          }

# 2434 "bc/src/print.c"
          else if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#           define XfOrM362_COUNT (0+XfOrM361_COUNT)
#           define SETUP_XfOrM362(x) SETUP_XfOrM361(x)

# 2435 "bc/src/print.c"
            name = FUNCCALL(SETUP_XfOrM362(_), scheme_char_string_to_byte_string (name ) ); 
            FUNCCALL(SETUP_XfOrM362(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . tag_val ) ) ); 
          }
          ; 
          FUNCCALL(SETUP_XfOrM361(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
        }

# 2440 "bc/src/print.c"
        else {
#         define XfOrM360_COUNT (0+XfOrM359_COUNT)
#         define SETUP_XfOrM360(x) SETUP_XfOrM359(x)

# 2441 "bc/src/print.c"
          closed = FUNCCALL(SETUP_XfOrM360(_), print (src , notdisplay , compact , ht , mt , pp ) ); 
        }
      }
    }

    closed = 1 ; 
  }
  else if ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_windows_path_type ) )  
  {
#   define XfOrM342_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM342(x) SETUP_XfOrM206(x)

# 2450 "bc/src/print.c"
    if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {

      Scheme_Object * idx ; 
      int l ; 
      BLOCK_SETUP((PUSH(idx, 0+XfOrM342_COUNT)));
#     define XfOrM352_COUNT (1+XfOrM342_COUNT)
#     define SETUP_XfOrM352(x) SETUP(XfOrM352_COUNT)
      idx = NULLED_OUT ; 

# 2455 "bc/src/print.c"
      idx = FUNCCALL(SETUP_XfOrM352(_), scheme_hash_get (mt -> intern_map , obj ) ); 
      if (! idx )
        FUNCCALL(SETUP_XfOrM352(_), scheme_hash_set (mt -> intern_map , obj , obj ) ); 
      else 
      obj = idx ; 

      idx = FUNCCALL(SETUP_XfOrM352(_), get_symtab_idx (mt , obj ) ); 
      if (idx ) {
#       define XfOrM356_COUNT (0+XfOrM352_COUNT)
#       define SETUP_XfOrM356(x) SETUP_XfOrM352(x)
        FUNCCALL(SETUP_XfOrM356(_), print_symtab_ref (pp , idx ) )
# 2463 "bc/src/print.c"
        ; 
      }

# 2464 "bc/src/print.c"
      else {
        Scheme_Object * orig_obj = obj , * dir ; 
        BLOCK_SETUP((PUSH(dir, 0+XfOrM352_COUNT), PUSH(orig_obj, 1+XfOrM352_COUNT)));
#       define XfOrM353_COUNT (2+XfOrM352_COUNT)
#       define SETUP_XfOrM353(x) SETUP(XfOrM353_COUNT)
        dir = NULLED_OUT ; 

# 2467 "bc/src/print.c"
        dir = (__funcarg95 = FUNCCALL(SETUP_XfOrM353(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg95 , MZCONFIG_WRITE_DIRECTORY ) )) 
        ; 
        if (! (((dir ) ) == (scheme_false ) ) ) 
          obj = FUNCCALL(SETUP_XfOrM353(_), scheme_extract_relative_to (obj , dir , mt -> path_cache ) ); 
        FUNCCALL(SETUP_XfOrM353(_), print_this_string (pp , & compacts [CPT_PATH ] , 0 , 1 ) )
        ; 
        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#         define XfOrM355_COUNT (0+XfOrM353_COUNT)
#         define SETUP_XfOrM355(x) SETUP_XfOrM353(x)

# 2474 "bc/src/print.c"
          l = (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) ; 
          FUNCCALL(SETUP_XfOrM355(_), print_compact_number (pp , l ) ); 
          FUNCCALL_AGAIN(print_this_string (pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , l ) ); 
        }

# 2477 "bc/src/print.c"
        else {
#         define XfOrM354_COUNT (0+XfOrM353_COUNT)
#         define SETUP_XfOrM354(x) SETUP_XfOrM353(x)
          FUNCCALL(SETUP_XfOrM354(_), print_compact_number (pp , 0 ) )
# 2478 "bc/src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM354(_), print (obj , notdisplay , compact , ht , mt , pp ) ); 
        }
        FUNCCALL(SETUP_XfOrM353(_), symtab_set (pp , mt , orig_obj ) )
        ; 
      }
    }

# 2484 "bc/src/print.c"
    else if (! compact && pp -> printing_quoted ) {



      Scheme_Object * dir ; 
      BLOCK_SETUP((PUSH(dir, 0+XfOrM342_COUNT)));
#     define XfOrM351_COUNT (1+XfOrM342_COUNT)
#     define SETUP_XfOrM351(x) SETUP(XfOrM351_COUNT)
      dir = NULLED_OUT ; 

# 2490 "bc/src/print.c"
      dir = (__funcarg94 = FUNCCALL(SETUP_XfOrM351(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg94 , MZCONFIG_WRITE_DIRECTORY ) )) 
      ; 
      if (! (((dir ) ) == (scheme_false ) ) ) 
        obj = FUNCCALL(SETUP_XfOrM351(_), scheme_extract_relative_to (obj , dir , mt -> path_cache ) ); 
      FUNCCALL(SETUP_XfOrM351(_), print_utf8_string (pp , "#^" , 0 , 2 ) )
      ; 
      obj = FUNCCALL_AGAIN(scheme_make_sized_byte_string ((((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) , 1 ) )

      ; 
      FUNCCALL_AGAIN(print (obj , notdisplay , compact , ht , mt , pp ) ); 

      closed = 1 ; 
    }

# 2502 "bc/src/print.c"
    else if (! pp -> print_unreadable ) {
#     define XfOrM350_COUNT (0+XfOrM342_COUNT)
#     define SETUP_XfOrM350(x) SETUP_XfOrM342(x)
      FUNCCALL(SETUP_XfOrM350(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2503 "bc/src/print.c"
      ; 
    }

# 2504 "bc/src/print.c"
    else {
#     define XfOrM343_COUNT (0+XfOrM342_COUNT)
#     define SETUP_XfOrM343(x) SETUP_XfOrM342(x)

# 2505 "bc/src/print.c"
      if (notdisplay ) {
#       define XfOrM346_COUNT (0+XfOrM343_COUNT)
#       define SETUP_XfOrM346(x) SETUP_XfOrM343(x)

# 2506 "bc/src/print.c"
        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#         define XfOrM349_COUNT (0+XfOrM346_COUNT)
#         define SETUP_XfOrM349(x) SETUP_XfOrM346(x)
          FUNCCALL(SETUP_XfOrM349(_), print_utf8_string (pp , "#<path:" , 0 , 7 ) )
# 2507 "bc/src/print.c"
          ; 
        }

# 2508 "bc/src/print.c"
        else {
#         define XfOrM347_COUNT (0+XfOrM346_COUNT)
#         define SETUP_XfOrM347(x) SETUP_XfOrM346(x)

# 2509 "bc/src/print.c"
          switch (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) {
#           define XfOrM348_COUNT (0+XfOrM347_COUNT)
#           define SETUP_XfOrM348(x) SETUP_XfOrM347(x)

# 2510 "bc/src/print.c"
            case scheme_windows_path_type : FUNCCALL(SETUP_XfOrM348(_), print_utf8_string (pp , "#<windows-path:" , 0 , 15 ) )
            ; 
            break ; 
            default : 
            case scheme_unix_path_type : FUNCCALL(SETUP_XfOrM348(_), print_utf8_string (pp , "#<unix-path:" , 0 , 12 ) )
            ; 
            break ; 
          }
        }
      }
      {
        Scheme_Object * str ; 
        BLOCK_SETUP((PUSH(str, 0+XfOrM343_COUNT)));
#       define XfOrM345_COUNT (1+XfOrM343_COUNT)
#       define SETUP_XfOrM345(x) SETUP(XfOrM345_COUNT)
        str = NULLED_OUT ; 

# 2522 "bc/src/print.c"
        str = FUNCCALL(SETUP_XfOrM345(_), scheme_path_to_char_string (obj ) ); 
        FUNCCALL_AGAIN(print (str , 0 , 0 , ht , mt , pp ) ); 
      }
      if (notdisplay ) {
#       define XfOrM344_COUNT (0+XfOrM343_COUNT)
#       define SETUP_XfOrM344(x) SETUP_XfOrM343(x)

# 2526 "bc/src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM344(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }
    }
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((Scheme_Primitive_Proc * ) obj ) -> name ) 
  {
#   define XfOrM339_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM339(x) SETUP_XfOrM206(x)

# 2533 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM341_COUNT (0+XfOrM339_COUNT)
#     define SETUP_XfOrM341(x) SETUP_XfOrM339(x)
      FUNCCALL(SETUP_XfOrM341(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2534 "bc/src/print.c"
      ; 
    }

# 2535 "bc/src/print.c"
    else {
#     define XfOrM340_COUNT (0+XfOrM339_COUNT)
#     define SETUP_XfOrM340(x) SETUP_XfOrM339(x)
      FUNCCALL(SETUP_XfOrM340(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2536 "bc/src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM340(_), print_string_in_angle (pp , ((Scheme_Primitive_Proc * ) obj ) -> name , "procedure:" , - 1 ) ); 
      ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) && ((Scheme_Closed_Primitive_Proc * ) obj ) -> name ) 
  {
#   define XfOrM335_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM335(x) SETUP_XfOrM206(x)

# 2545 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM335(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    else {
      int kind ; 
#     define XfOrM336_COUNT (0+XfOrM335_COUNT)
#     define SETUP_XfOrM336(x) SETUP_XfOrM335(x)

# 2549 "bc/src/print.c"
      kind = (((Scheme_Primitive_Proc * ) (obj ) ) -> pp . flags & (32 | 64 | 128 | 256 ) ) ; 
      if ((kind == (32 | 256 ) ) 
      || (kind == 128 ) 
      || (kind == 256 ) 
      || (kind == (128 | 256 ) ) 
      || (kind == (32 | 128 ) ) 
      || (kind == 32 ) 
      || (kind == (32 | 64 ) ) ) {
#       define XfOrM338_COUNT (0+XfOrM336_COUNT)
#       define SETUP_XfOrM338(x) SETUP_XfOrM336(x)
        FUNCCALL(SETUP_XfOrM338(_), print_named (obj , "struct-procedure" , ((Scheme_Closed_Primitive_Proc * ) obj ) -> name , - 1 , pp ) ); 
      }

# 2560 "bc/src/print.c"
      else {
#       define XfOrM337_COUNT (0+XfOrM336_COUNT)
#       define SETUP_XfOrM337(x) SETUP_XfOrM336(x)
        FUNCCALL(SETUP_XfOrM337(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2561 "bc/src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM337(_), print_string_in_angle (pp , ((Scheme_Closed_Primitive_Proc * ) obj ) -> name , "procedure:" , - 1 ) ); 
        ; 
        FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }
    }

    closed = 1 ; 
  }
  else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) ) 
  {
#   define XfOrM325_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM325(x) SETUP_XfOrM206(x)

# 2573 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
      int done = 0 ; 
#     define XfOrM327_COUNT (0+XfOrM325_COUNT)
#     define SETUP_XfOrM327(x) SETUP_XfOrM325(x)

# 2575 "bc/src/print.c"
      if (compact ) {
#       define XfOrM328_COUNT (0+XfOrM327_COUNT)
#       define SETUP_XfOrM328(x) SETUP_XfOrM327(x)

# 2576 "bc/src/print.c"
        if (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) == scheme_closure_type ) {
          Scheme_Closure * closure = (Scheme_Closure * ) obj ; 
          BLOCK_SETUP((PUSH(closure, 0+XfOrM328_COUNT)));
#         define XfOrM331_COUNT (1+XfOrM328_COUNT)
#         define SETUP_XfOrM331(x) SETUP(XfOrM331_COUNT)

# 2578 "bc/src/print.c"
          if (! (closure -> code -> closure_size ) ) {


            Scheme_Object * idx ; 
            BLOCK_SETUP((PUSH(idx, 0+XfOrM331_COUNT)));
#           define XfOrM332_COUNT (1+XfOrM331_COUNT)
#           define SETUP_XfOrM332(x) SETUP(XfOrM332_COUNT)
            idx = NULLED_OUT ; 

# 2582 "bc/src/print.c"
            idx = FUNCCALL(SETUP_XfOrM332(_), get_symtab_idx (mt , obj ) ); 
            if (idx ) {
#             define XfOrM334_COUNT (0+XfOrM332_COUNT)
#             define SETUP_XfOrM334(x) SETUP_XfOrM332(x)
              FUNCCALL(SETUP_XfOrM334(_), print_symtab_ref (pp , idx ) )
# 2584 "bc/src/print.c"
              ; 
            }

# 2585 "bc/src/print.c"
            else {
#             define XfOrM333_COUNT (0+XfOrM332_COUNT)
#             define SETUP_XfOrM333(x) SETUP_XfOrM332(x)
              FUNCCALL(SETUP_XfOrM333(_), print_this_string (pp , & compacts [CPT_CLOSURE ] , 0 , 1 ) )
# 2586 "bc/src/print.c"
              ; 
              FUNCCALL(SETUP_XfOrM333(_), print_symtab_set (pp , mt , obj ) ); 
              FUNCCALL_AGAIN(print ((Scheme_Object * ) ((Scheme_Closure * ) closure ) -> code , notdisplay , compact , ht , mt , pp ) ); 
            }
            compact = 1 ; 
            done = 1 ; 
          }
        }

# 2593 "bc/src/print.c"
        else if (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) == scheme_case_closure_type ) {
#         define XfOrM329_COUNT (0+XfOrM328_COUNT)
#         define SETUP_XfOrM329(x) SETUP_XfOrM328(x)

# 2594 "bc/src/print.c"
          obj = FUNCCALL(SETUP_XfOrM329(_), scheme_unclose_case_lambda (obj , 0 ) ); 
          if (! (! (((intptr_t ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) >= scheme_prim_type ) && (((obj ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
#           define XfOrM330_COUNT (0+XfOrM329_COUNT)
#           define SETUP_XfOrM330(x) SETUP_XfOrM329(x)

# 2597 "bc/src/print.c"
            compact = FUNCCALL(SETUP_XfOrM330(_), print (obj , notdisplay , compact , ht , mt , pp ) ); 
            done = 1 ; 
          }
        }
      }
      if (! done )
        FUNCCALL(SETUP_XfOrM327(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }

# 2604 "bc/src/print.c"
    else {
      int len ; 
      const char * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM325_COUNT)));
#     define XfOrM326_COUNT (1+XfOrM325_COUNT)
#     define SETUP_XfOrM326(x) SETUP(XfOrM326_COUNT)
      s = NULLED_OUT ; 

# 2607 "bc/src/print.c"
      s = FUNCCALL(SETUP_XfOrM326(_), scheme_get_proc_name (obj , & len , 0 ) ); 
      FUNCCALL_AGAIN(print_named (obj , "procedure" , s , len , pp ) )
      ; 
    }
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) )  
  {
#   define XfOrM319_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM319(x) SETUP_XfOrM206(x)

# 2615 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM323_COUNT (0+XfOrM319_COUNT)
#     define SETUP_XfOrM323(x) SETUP_XfOrM319(x)

# 2616 "bc/src/print.c"
      if (compact && ((Scheme_Struct_Type * ) obj ) -> prefab_key ) {
#       define XfOrM324_COUNT (0+XfOrM323_COUNT)
#       define SETUP_XfOrM324(x) SETUP_XfOrM323(x)
        FUNCCALL(SETUP_XfOrM324(_), print_this_string (pp , & compacts [CPT_PREFAB_TYPE ] , 0 , 1 ) )
# 2617 "bc/src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM324(_), print ((((Scheme_Simple_Object * ) (((Scheme_Struct_Type * ) obj ) -> prefab_key ) ) -> u . pair_val . cdr ) , notdisplay , compact , ht , mt , pp ) ); 
        FUNCCALL_AGAIN(print_compact_number (pp , ((Scheme_Struct_Type * ) obj ) -> num_slots ) ); 
      }

# 2620 "bc/src/print.c"
      else FUNCCALL(SETUP_XfOrM323(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
      ; 
    }

# 2622 "bc/src/print.c"
    else {
#     define XfOrM320_COUNT (0+XfOrM319_COUNT)
#     define SETUP_XfOrM320(x) SETUP_XfOrM319(x)
      FUNCCALL(SETUP_XfOrM320(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2623 "bc/src/print.c"
      ; 
      if (((Scheme_Struct_Type * ) obj ) -> name ) {
#       define XfOrM322_COUNT (0+XfOrM320_COUNT)
#       define SETUP_XfOrM322(x) SETUP_XfOrM320(x)
        (__funcarg93 = FUNCCALL(SETUP_XfOrM322(_), scheme_symbol_val (((Scheme_Struct_Type * ) obj ) -> name ) )
# 2625 "bc/src/print.c"
        , FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg93 , "struct-type:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (((Scheme_Struct_Type * ) obj ) -> name ) ) ) -> len ) ) )) 

        ; 
      }

# 2628 "bc/src/print.c"
      else {
#       define XfOrM321_COUNT (0+XfOrM320_COUNT)
#       define SETUP_XfOrM321(x) SETUP_XfOrM320(x)
        FUNCCALL(SETUP_XfOrM321(_), print_utf8_string (pp , "struct-type" , 0 , 11 ) )
# 2629 "bc/src/print.c"
        ; 
      }
      ; 
      FUNCCALL(SETUP_XfOrM320(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) )  
  {
#   define XfOrM314_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM314(x) SETUP_XfOrM206(x)

# 2637 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM318_COUNT (0+XfOrM314_COUNT)
#     define SETUP_XfOrM318(x) SETUP_XfOrM314(x)
      FUNCCALL(SETUP_XfOrM318(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2638 "bc/src/print.c"
      ; 
    }

# 2639 "bc/src/print.c"
    else {
#     define XfOrM315_COUNT (0+XfOrM314_COUNT)
#     define SETUP_XfOrM315(x) SETUP_XfOrM314(x)
      FUNCCALL(SETUP_XfOrM315(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2640 "bc/src/print.c"
      ; 
      if (((Scheme_Struct_Property * ) obj ) -> name ) {
#       define XfOrM317_COUNT (0+XfOrM315_COUNT)
#       define SETUP_XfOrM317(x) SETUP_XfOrM315(x)
        (__funcarg92 = FUNCCALL(SETUP_XfOrM317(_), scheme_symbol_val (((Scheme_Struct_Property * ) obj ) -> name ) )
# 2642 "bc/src/print.c"
        , FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg92 , "struct-type-property:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (((Scheme_Struct_Property * ) obj ) -> name ) ) ) -> len ) ) )) 

        ; 
      }

# 2645 "bc/src/print.c"
      else {
#       define XfOrM316_COUNT (0+XfOrM315_COUNT)
#       define SETUP_XfOrM316(x) SETUP_XfOrM315(x)
        FUNCCALL(SETUP_XfOrM316(_), print_utf8_string (pp , "struct-type-property" , 0 , 21 ) )
# 2646 "bc/src/print.c"
        ; 
      }
      ; 
      FUNCCALL(SETUP_XfOrM315(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) && (((Scheme_Thread * ) obj ) -> name ) ) 
  {
#   define XfOrM311_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM311(x) SETUP_XfOrM206(x)

# 2654 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM313_COUNT (0+XfOrM311_COUNT)
#     define SETUP_XfOrM313(x) SETUP_XfOrM311(x)
      FUNCCALL(SETUP_XfOrM313(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2655 "bc/src/print.c"
      ; 
    }

# 2656 "bc/src/print.c"
    else {
      Scheme_Thread * t = (Scheme_Thread * ) obj ; 
      BLOCK_SETUP((PUSH(t, 0+XfOrM311_COUNT)));
#     define XfOrM312_COUNT (1+XfOrM311_COUNT)
#     define SETUP_XfOrM312(x) SETUP(XfOrM312_COUNT)
      FUNCCALL(SETUP_XfOrM312(_), print_utf8_string (pp , "#<thread:" , 0 , 9 ) )
# 2658 "bc/src/print.c"
      ; 
      (__funcarg91 = FUNCCALL(SETUP_XfOrM312(_), scheme_symbol_val (t -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg91 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (t -> name ) ) ) -> len ) ) )) ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) )  
  {
#   define XfOrM305_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM305(x) SETUP_XfOrM206(x)

# 2665 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM310_COUNT (0+XfOrM305_COUNT)
#     define SETUP_XfOrM310(x) SETUP_XfOrM305(x)
      FUNCCALL(SETUP_XfOrM310(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2666 "bc/src/print.c"
      ; 
    }

# 2667 "bc/src/print.c"
    else {
      Scheme_Input_Port * ip ; 
      BLOCK_SETUP((PUSH(ip, 0+XfOrM305_COUNT)));
#     define XfOrM306_COUNT (1+XfOrM305_COUNT)
#     define SETUP_XfOrM306(x) SETUP(XfOrM306_COUNT)
      ip = NULLED_OUT ; 

# 2669 "bc/src/print.c"
      ip = (Scheme_Input_Port * ) obj ; 
      FUNCCALL(SETUP_XfOrM306(_), print_utf8_string (pp , "#<input-port" , 0 , 12 ) ); 
      if (ip -> name ) {
#       define XfOrM307_COUNT (0+XfOrM306_COUNT)
#       define SETUP_XfOrM307(x) SETUP_XfOrM306(x)

# 2672 "bc/src/print.c"
        if ((Scheme_Type ) (((((intptr_t ) (ip -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ip -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#         define XfOrM309_COUNT (0+XfOrM307_COUNT)
#         define SETUP_XfOrM309(x) SETUP_XfOrM307(x)
          FUNCCALL(SETUP_XfOrM309(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 2673 "bc/src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM309(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (ip -> name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (ip -> name ) ) -> u . byte_str_val . tag_val ) ) ); 
        }

# 2675 "bc/src/print.c"
        else if ((Scheme_Type ) (((((intptr_t ) (ip -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ip -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#         define XfOrM308_COUNT (0+XfOrM307_COUNT)
#         define SETUP_XfOrM308(x) SETUP_XfOrM307(x)
          FUNCCALL(SETUP_XfOrM308(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 2676 "bc/src/print.c"
          ; 
          (__funcarg90 = FUNCCALL(SETUP_XfOrM308(_), scheme_symbol_val (ip -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg90 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (ip -> name ) ) ) -> len ) ) )) ; 
        }
      }
      FUNCCALL(SETUP_XfOrM306(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) )  
  {
#   define XfOrM304_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM304(x) SETUP_XfOrM206(x)

# 2686 "bc/src/print.c"
    closed = FUNCCALL(SETUP_XfOrM304(_), print ((((Scheme_Chaperone * ) obj ) -> val ) , notdisplay , compact , ht , mt , pp ) ); 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_regexp_type ) )  
  {
#   define XfOrM300_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM300(x) SETUP_XfOrM206(x)

# 2690 "bc/src/print.c"
    if (compact ) {
#     define XfOrM303_COUNT (0+XfOrM300_COUNT)
#     define SETUP_XfOrM303(x) SETUP_XfOrM300(x)
      FUNCCALL(SETUP_XfOrM303(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) )
# 2691 "bc/src/print.c"
      ; 
    }

# 2692 "bc/src/print.c"
    else {
      Scheme_Object * src ; 
      BLOCK_SETUP((PUSH(src, 0+XfOrM300_COUNT)));
#     define XfOrM301_COUNT (1+XfOrM300_COUNT)
#     define SETUP_XfOrM301(x) SETUP(XfOrM301_COUNT)
      src = NULLED_OUT ; 

# 2694 "bc/src/print.c"
      src = (scheme_regexp_source (obj ) ) ; 
      if (src ) {
#       define XfOrM302_COUNT (0+XfOrM301_COUNT)
#       define SETUP_XfOrM302(x) SETUP_XfOrM301(x)

# 2696 "bc/src/print.c"
        if (FUNCCALL(SETUP_XfOrM302(_), scheme_is_pregexp (obj ) ))
          FUNCCALL(SETUP_XfOrM302(_), print_utf8_string (pp , "#px" , 0 , 3 ) ); 
        else FUNCCALL(SETUP_XfOrM302(_), print_utf8_string (pp , "#rx" , 0 , 3 ) )
        ; 
        FUNCCALL(SETUP_XfOrM302(_), print (src , 1 , 0 , ht , mt , pp ) ); 
      }

# 2701 "bc/src/print.c"
      else if (compact || ! pp -> print_unreadable )
        FUNCCALL(SETUP_XfOrM301(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
      else FUNCCALL(SETUP_XfOrM301(_), print_utf8_string (pp , "#<regexp>" , 0 , 9 ) )
      ; 
      closed = 1 ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) )  
  {
#   define XfOrM294_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM294(x) SETUP_XfOrM206(x)

# 2710 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM299_COUNT (0+XfOrM294_COUNT)
#     define SETUP_XfOrM299(x) SETUP_XfOrM294(x)
      FUNCCALL(SETUP_XfOrM299(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2711 "bc/src/print.c"
      ; 
    }

# 2712 "bc/src/print.c"
    else {
      Scheme_Output_Port * op ; 
      BLOCK_SETUP((PUSH(op, 0+XfOrM294_COUNT)));
#     define XfOrM295_COUNT (1+XfOrM294_COUNT)
#     define SETUP_XfOrM295(x) SETUP(XfOrM295_COUNT)
      op = NULLED_OUT ; 

# 2714 "bc/src/print.c"
      op = (Scheme_Output_Port * ) obj ; 
      FUNCCALL(SETUP_XfOrM295(_), print_utf8_string (pp , "#<output-port" , 0 , 13 ) ); 
      if (op -> name ) {
#       define XfOrM296_COUNT (0+XfOrM295_COUNT)
#       define SETUP_XfOrM296(x) SETUP_XfOrM295(x)

# 2717 "bc/src/print.c"
        if ((Scheme_Type ) (((((intptr_t ) (op -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (op -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#         define XfOrM298_COUNT (0+XfOrM296_COUNT)
#         define SETUP_XfOrM298(x) SETUP_XfOrM296(x)
          FUNCCALL(SETUP_XfOrM298(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 2718 "bc/src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM298(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (op -> name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (op -> name ) ) -> u . byte_str_val . tag_val ) ) ); 
        }

# 2720 "bc/src/print.c"
        else if ((Scheme_Type ) (((((intptr_t ) (op -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (op -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#         define XfOrM297_COUNT (0+XfOrM296_COUNT)
#         define SETUP_XfOrM297(x) SETUP_XfOrM296(x)
          FUNCCALL(SETUP_XfOrM297(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 2721 "bc/src/print.c"
          ; 
          (__funcarg89 = FUNCCALL(SETUP_XfOrM297(_), scheme_symbol_val (op -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg89 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (op -> name ) ) ) -> len ) ) )) ; 
        }
      }
      FUNCCALL(SETUP_XfOrM295(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) 
  && (((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) && ! (compact || ! pp -> print_unreadable ) ) 
  {
#   define XfOrM293_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM293(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM293(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2731 "bc/src/print.c"
    ; 
    (__funcarg88 = FUNCCALL(SETUP_XfOrM293(_), scheme_symbol_val ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ) ), FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg88 , "continuation-prompt-tag:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ) ) ) -> len ) ) )) 

    ; 
    ; 
    FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_cpointer_type ) ) )  
  {
    Scheme_Object * tag = (((Scheme_Cptr * ) (obj ) ) -> type ) ; 
    BLOCK_SETUP((PUSH(tag, 0+XfOrM206_COUNT)));
#   define XfOrM285_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM285(x) SETUP(XfOrM285_COUNT)

# 2741 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM292_COUNT (0+XfOrM285_COUNT)
#     define SETUP_XfOrM292(x) SETUP_XfOrM285(x)
      FUNCCALL(SETUP_XfOrM292(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2742 "bc/src/print.c"
      ; 
    }

# 2743 "bc/src/print.c"
    else if (tag == ((void * ) 0 ) ) {
#     define XfOrM291_COUNT (0+XfOrM285_COUNT)
#     define SETUP_XfOrM291(x) SETUP_XfOrM285(x)
      FUNCCALL(SETUP_XfOrM291(_), print_utf8_string (pp , "#<cpointer>" , 0 , 11 ) )
# 2744 "bc/src/print.c"
      ; 
    }

# 2745 "bc/src/print.c"
    else {
      Scheme_Object * name = tag ; 
      BLOCK_SETUP((PUSH(name, 0+XfOrM285_COUNT)));
#     define XfOrM286_COUNT (1+XfOrM285_COUNT)
#     define SETUP_XfOrM286(x) SETUP(XfOrM286_COUNT)

# 2747 "bc/src/print.c"
      if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 

# 2747 "bc/src/print.c"
      name = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . car ) ; 
      FUNCCALL(SETUP_XfOrM286(_), print_utf8_string (pp , "#<cpointer:" , 0 , 11 ) ); 
      if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#       define XfOrM290_COUNT (0+XfOrM286_COUNT)
#       define SETUP_XfOrM290(x) SETUP_XfOrM286(x)
        FUNCCALL(SETUP_XfOrM290(_), print_this_string (pp , (char * ) name , ((char * ) ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) ) ) - ((char * ) name ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ) )
        ; 
      }

# 2754 "bc/src/print.c"
      else if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
#       define XfOrM289_COUNT (0+XfOrM286_COUNT)
#       define SETUP_XfOrM289(x) SETUP_XfOrM286(x)
        FUNCCALL(SETUP_XfOrM289(_), print_byte_string ((((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . tag_val ) , 0 , pp ) )
        ; 
      }

# 2759 "bc/src/print.c"
      else if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#       define XfOrM288_COUNT (0+XfOrM286_COUNT)
#       define SETUP_XfOrM288(x) SETUP_XfOrM286(x)
        FUNCCALL(SETUP_XfOrM288(_), scheme_print_string (pp , (((Scheme_Simple_Object * ) (name ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (name ) ) -> u . char_str_val . tag_val ) ) )
# 2761 "bc/src/print.c"
        ; 
      }

# 2762 "bc/src/print.c"
      else {
#       define XfOrM287_COUNT (0+XfOrM286_COUNT)
#       define SETUP_XfOrM287(x) SETUP_XfOrM286(x)
        FUNCCALL(SETUP_XfOrM287(_), print_utf8_string (pp , "#" , 0 , 1 ) )
# 2763 "bc/src/print.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM286(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
      closed = 1 ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) )  
  {
#   define XfOrM279_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM279(x) SETUP_XfOrM206(x)

# 2771 "bc/src/print.c"
    if (pp -> print_unreadable ) {
      Scheme_Stx * stx = (Scheme_Stx * ) obj ; 
      BLOCK_SETUP((PUSH(stx, 0+XfOrM279_COUNT)));
#     define XfOrM281_COUNT (1+XfOrM279_COUNT)
#     define SETUP_XfOrM281(x) SETUP(XfOrM281_COUNT)

# 2773 "bc/src/print.c"
      if (stx -> srcloc && ((stx -> srcloc -> line >= 0 ) || (stx -> srcloc -> pos >= 0 ) ) ) {
#       define XfOrM283_COUNT (0+XfOrM281_COUNT)
#       define SETUP_XfOrM283(x) SETUP_XfOrM281(x)
        FUNCCALL(SETUP_XfOrM283(_), print_utf8_string (pp , "#<correlated:" , 0 , 13 ) )
# 2774 "bc/src/print.c"
        ; 
        if (stx -> srcloc -> src && ((Scheme_Type ) (((((intptr_t ) (stx -> srcloc -> src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (stx -> srcloc -> src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#         define XfOrM284_COUNT (0+XfOrM283_COUNT)
#         define SETUP_XfOrM284(x) SETUP_XfOrM283(x)
          FUNCCALL(SETUP_XfOrM284(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (stx -> srcloc -> src ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (stx -> srcloc -> src ) ) -> u . byte_str_val . tag_val ) ) )
# 2776 "bc/src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM284(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
        }
        if ((stx -> srcloc -> line >= 0 ) 
        && (stx -> srcloc -> col >= 0 ) )
          (sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 
        "%" "l" "d" ":%" "l" "d" "" , 
        stx -> srcloc -> line , stx -> srcloc -> col - 1 ) ) ; 
        else if (stx -> srcloc -> pos >= 0 )
          (sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , ":%" "l" "d" "" , 
        stx -> srcloc -> pos ) ) ; 
        FUNCCALL(SETUP_XfOrM283(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
      }

# 2788 "bc/src/print.c"
      else FUNCCALL(SETUP_XfOrM281(_), print_utf8_string (pp , "#<correlated" , 0 , 12 ) )
      ; 
      if (pp -> print_syntax ) {
        intptr_t slen ; 
        char * str ; 
        int rel ; 
        BLOCK_SETUP((PUSH(str, 0+XfOrM281_COUNT)));
#       define XfOrM282_COUNT (1+XfOrM281_COUNT)
#       define SETUP_XfOrM282(x) SETUP(XfOrM282_COUNT)
        str = NULLED_OUT ; 
        FUNCCALL(SETUP_XfOrM282(_), print_utf8_string (pp , " " , 0 , 1 ) )
# 2794 "bc/src/print.c"
        ; 
        str = (__funcarg87 = FUNCCALL(SETUP_XfOrM282(_), scheme_syntax_to_datum ((Scheme_Object * ) stx ) ), FUNCCALL_AGAIN(print_to_string (__funcarg87 , & slen , 1 , ((void * ) 0 ) , pp -> print_syntax , ((void * ) 0 ) , & rel ) )) 
        ; 
        FUNCCALL_AGAIN(print_utf8_string (pp , str , 0 , slen ) ); 
        if (rel && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) )
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) = str ; 
      }
      FUNCCALL(SETUP_XfOrM281(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }

# 2802 "bc/src/print.c"
    else {
#     define XfOrM280_COUNT (0+XfOrM279_COUNT)
#     define SETUP_XfOrM280(x) SETUP_XfOrM279(x)
      FUNCCALL(SETUP_XfOrM280(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2803 "bc/src/print.c"
      ; 
    }
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) ) ) 
  {
    int flags , pos , depth ; 
#   define XfOrM278_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM278(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM278(_), print_this_string (pp , & compacts [CPT_TOPLEVEL ] , 0 , 1 ) )
# 2810 "bc/src/print.c"
    ; 

    flags = ((& ((Scheme_Toplevel * ) (obj ) ) -> iso ) -> so . keyex & 0x3 ) ; 
    pos = (((Scheme_Toplevel * ) (obj ) ) -> position ) ; 
    depth = (((Scheme_Toplevel * ) (obj ) ) -> u . depth ) ; 
    FUNCCALL(SETUP_XfOrM278(_), print_compact_number (pp , flags ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , pos ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , depth ) ); 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) ) ) 
  {
    int flags , pos ; 
#   define XfOrM277_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM277(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM277(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 2824 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM277(_), print_compact_number (pp , scheme_static_toplevel_type ) ); 

    flags = ((& ((Scheme_Toplevel * ) (obj ) ) -> iso ) -> so . keyex & 0x3 ) ; 
    pos = (((Scheme_Toplevel * ) (obj ) ) -> position ) ; 
    FUNCCALL(SETUP_XfOrM277(_), print_compact_number (pp , flags ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , pos ) ); 

    closed = FUNCCALL_AGAIN(print ((Scheme_Object * ) (((Scheme_Toplevel * ) (obj ) ) -> u . prefix ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prefix_type ) ) ) ) 
  {

    Scheme_Object * idx ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM206_COUNT)));
#   define XfOrM274_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM274(x) SETUP(XfOrM274_COUNT)
    idx = NULLED_OUT ; 

# 2839 "bc/src/print.c"
    if (compact )
      idx = FUNCCALL(SETUP_XfOrM274(_), get_symtab_idx (mt , obj ) ); 
    else 
    idx = ((void * ) 0 ) ; 

    if (idx ) {
#     define XfOrM276_COUNT (0+XfOrM274_COUNT)
#     define SETUP_XfOrM276(x) SETUP_XfOrM274(x)
      FUNCCALL(SETUP_XfOrM276(_), print_symtab_ref (pp , idx ) )
# 2845 "bc/src/print.c"
      ; 
    }

# 2846 "bc/src/print.c"
    else if (compact ) {
#     define XfOrM275_COUNT (0+XfOrM274_COUNT)
#     define SETUP_XfOrM275(x) SETUP_XfOrM274(x)
      FUNCCALL(SETUP_XfOrM275(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 2847 "bc/src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM275(_), print_compact_number (pp , scheme_prefix_type ) ); 
      FUNCCALL_AGAIN(print_compact_number (pp , ((Scheme_Prefix * ) obj ) -> num_slots ) ); 
      FUNCCALL_AGAIN(symtab_set (pp , mt , obj ) )
      ; 
    }
  }
  else if (compact 
  && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_unbox_type ) ) ) ) 
  {
    int unbox = ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_unbox_type ) ) ; 
    Scheme_Local * loc = (Scheme_Local * ) obj ; 
    BLOCK_SETUP((PUSH(loc, 0+XfOrM206_COUNT)));
#   define XfOrM270_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM270(x) SETUP(XfOrM270_COUNT)

# 2860 "bc/src/print.c"
    if ((loc -> position < (207 - 192 ) ) 
    && ! ((& ((Scheme_Local * ) (loc ) ) -> iso ) -> so . keyex & ~ 0x2000 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM273_COUNT (0+XfOrM270_COUNT)
#     define SETUP_XfOrM273(x) SETUP_XfOrM270(x)

# 2863 "bc/src/print.c"
      s [0 ] = loc -> position + (unbox 
      ? 207 
      : 192 ) ; 
      FUNCCALL(SETUP_XfOrM273(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }

# 2867 "bc/src/print.c"
    else {
      int flags ; 
#     define XfOrM271_COUNT (0+XfOrM270_COUNT)
#     define SETUP_XfOrM271(x) SETUP_XfOrM270(x)
      FUNCCALL(SETUP_XfOrM271(_), print_this_string (pp , & compacts [unbox ? CPT_LOCAL_UNBOX : CPT_LOCAL ] , 0 , 1 ) )
# 2869 "bc/src/print.c"
      ; 
      flags = ((& ((Scheme_Local * ) (loc ) ) -> iso ) -> so . keyex & ~ 0x2000 ) ; 
      if (flags ) {
#       define XfOrM272_COUNT (0+XfOrM271_COUNT)
#       define SETUP_XfOrM272(x) SETUP_XfOrM271(x)
        FUNCCALL(SETUP_XfOrM272(_), print_compact_number (pp , - (loc -> position + 1 ) ) )
# 2872 "bc/src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM272(_), print_compact_number (pp , flags ) ); 
      }

# 2874 "bc/src/print.c"
      else FUNCCALL(SETUP_XfOrM271(_), print_compact_number (pp , loc -> position ) )
      ; 
    }
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application_type ) ) ) 
  {
    Scheme_App_Rec * app ; 
    int i ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM206_COUNT)));
#   define XfOrM265_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM265(x) SETUP(XfOrM265_COUNT)
    app = NULLED_OUT ; 

# 2883 "bc/src/print.c"
    app = (Scheme_App_Rec * ) obj ; 

    if (app -> num_args < (255 - 247 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM269_COUNT (0+XfOrM265_COUNT)
#     define SETUP_XfOrM269(x) SETUP_XfOrM265(x)

# 2887 "bc/src/print.c"
      s [0 ] = 247 + app -> num_args ; 
      FUNCCALL(SETUP_XfOrM269(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }

# 2889 "bc/src/print.c"
    else {
#     define XfOrM268_COUNT (0+XfOrM265_COUNT)
#     define SETUP_XfOrM268(x) SETUP_XfOrM265(x)
      FUNCCALL(SETUP_XfOrM268(_), print_this_string (pp , & compacts [CPT_APPLICATION ] , 0 , 1 ) )
# 2890 "bc/src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM268(_), print_compact_number (pp , app -> num_args ) ); 
    }

    for (i = 0 ; i < app -> num_args + 1 ; i ++ ) {
#     define XfOrM267_COUNT (0+XfOrM265_COUNT)
#     define SETUP_XfOrM267(x) SETUP_XfOrM265(x)

# 2895 "bc/src/print.c"
      closed = (__funcarg86 = FUNCCALL(SETUP_XfOrM267(_), scheme_protect_quote (app -> args [i ] ) ), FUNCCALL_AGAIN(print (__funcarg86 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    }
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application2_type ) ) ) 
  {
    Scheme_App2_Rec * app ; 
    unsigned char s [1 ] ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM206_COUNT)));
#   define XfOrM264_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM264(x) SETUP(XfOrM264_COUNT)
    app = NULLED_OUT ; 

# 2903 "bc/src/print.c"
    app = (Scheme_App2_Rec * ) obj ; 

    s [0 ] = 247 + 1 ; 
    FUNCCALL(SETUP_XfOrM264(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    (__funcarg84 = FUNCCALL(SETUP_XfOrM264(_), scheme_protect_quote (app -> rator ) )
    , FUNCCALL_AGAIN(print (__funcarg84 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg83 = FUNCCALL(SETUP_XfOrM264(_), scheme_protect_quote (app -> rand ) ), FUNCCALL_AGAIN(print (__funcarg83 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application3_type ) ) ) 
  {
    Scheme_App3_Rec * app ; 
    unsigned char s [1 ] ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM206_COUNT)));
#   define XfOrM263_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM263(x) SETUP(XfOrM263_COUNT)
    app = NULLED_OUT ; 

# 2916 "bc/src/print.c"
    app = (Scheme_App3_Rec * ) obj ; 

    s [0 ] = 247 + 2 ; 
    FUNCCALL(SETUP_XfOrM263(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    (__funcarg82 = FUNCCALL(SETUP_XfOrM263(_), scheme_protect_quote (app -> rator ) )
    , FUNCCALL_AGAIN(print (__funcarg82 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    (__funcarg81 = FUNCCALL(SETUP_XfOrM263(_), scheme_protect_quote (app -> rand1 ) ), FUNCCALL_AGAIN(print (__funcarg81 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg80 = FUNCCALL(SETUP_XfOrM263(_), scheme_protect_quote (app -> rand2 ) ), FUNCCALL_AGAIN(print (__funcarg80 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_sequence_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_begin0_sequence_type ) ) ) ) 
  {
    int i , count ; 
#   define XfOrM260_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM260(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM260(_), print_this_string (pp , & compacts [(((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_sequence_type ) ) ? CPT_BEGIN : CPT_BEGIN0 ) ] , 0 , 1 ) )
    ; 
    count = ((Scheme_Sequence * ) obj ) -> count ; 
    FUNCCALL(SETUP_XfOrM260(_), print_compact_number (pp , count ) ); 

    for (i = 0 ; i < count ; i ++ ) {
#     define XfOrM262_COUNT (0+XfOrM260_COUNT)
#     define SETUP_XfOrM262(x) SETUP_XfOrM260(x)

# 2937 "bc/src/print.c"
      closed = (__funcarg79 = FUNCCALL(SETUP_XfOrM262(_), scheme_protect_quote (((Scheme_Sequence * ) obj ) -> array [i ] ) ), FUNCCALL_AGAIN(print (__funcarg79 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    }
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_let_value_type ) ) ) ) 
  {
    Scheme_Let_Value * lv ; 
    BLOCK_SETUP((PUSH(lv, 0+XfOrM206_COUNT)));
#   define XfOrM259_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
    lv = NULLED_OUT ; 

# 2944 "bc/src/print.c"
    lv = (Scheme_Let_Value * ) obj ; 
    FUNCCALL(SETUP_XfOrM259(_), print_this_string (pp , & compacts [CPT_LET_VALUE ] , 0 , 1 ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , lv -> count ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , lv -> position ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , ((& lv -> iso ) -> so . keyex ? 1 : 0 ) ) ); 
    (__funcarg77 = FUNCCALL(SETUP_XfOrM259(_), scheme_protect_quote (lv -> value ) ), FUNCCALL_AGAIN(print (__funcarg77 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg76 = FUNCCALL(SETUP_XfOrM259(_), scheme_protect_quote (lv -> body ) ), FUNCCALL_AGAIN(print (__funcarg76 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_let_void_type ) ) ) ) 
  {
    Scheme_Let_Void * lv ; 
    BLOCK_SETUP((PUSH(lv, 0+XfOrM206_COUNT)));
#   define XfOrM258_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)
    lv = NULLED_OUT ; 

# 2957 "bc/src/print.c"
    lv = (Scheme_Let_Void * ) obj ; 
    FUNCCALL(SETUP_XfOrM258(_), print_this_string (pp , & compacts [CPT_LET_VOID ] , 0 , 1 ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , lv -> count ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , ((& lv -> iso ) -> so . keyex ? 1 : 0 ) ) ); 
    closed = (__funcarg75 = FUNCCALL(SETUP_XfOrM258(_), scheme_protect_quote (lv -> body ) ), FUNCCALL_AGAIN(print (__funcarg75 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_letrec_type ) ) ) ) 
  {
    Scheme_Letrec * lr = (Scheme_Letrec * ) obj ; 
    int i , count ; 
    BLOCK_SETUP((PUSH(lr, 0+XfOrM206_COUNT)));
#   define XfOrM255_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM255(x) SETUP(XfOrM255_COUNT)

# 2969 "bc/src/print.c"
    count = lr -> count ; 
    FUNCCALL(SETUP_XfOrM255(_), print_this_string (pp , & compacts [CPT_LETREC ] , 0 , 1 ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , count ) ); 

    for (i = 0 ; i < count ; i ++ ) {
#     define XfOrM257_COUNT (0+XfOrM255_COUNT)
#     define SETUP_XfOrM257(x) SETUP_XfOrM255(x)
      (__funcarg74 = FUNCCALL(SETUP_XfOrM257(_), scheme_protect_quote (lr -> procs [i ] ) )
# 2975 "bc/src/print.c"
      , FUNCCALL_AGAIN(print (__funcarg74 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    }

    closed = (__funcarg72 = FUNCCALL(SETUP_XfOrM255(_), scheme_protect_quote (lr -> body ) ), FUNCCALL_AGAIN(print (__funcarg72 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_let_one_type ) ) ) 
  {
    Scheme_Let_One * lo ; 
    BLOCK_SETUP((PUSH(lo, 0+XfOrM206_COUNT)));
#   define XfOrM254_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM254(x) SETUP(XfOrM254_COUNT)
    lo = NULLED_OUT ; 

# 2984 "bc/src/print.c"
    lo = (Scheme_Let_One * ) obj ; 

    if ((& lo -> iso ) -> so . keyex & 0x8 )
      FUNCCALL(SETUP_XfOrM254(_), print_this_string (pp , & compacts [CPT_LET_ONE_UNUSED ] , 0 , 1 ) ); 
    else if ((& lo -> iso ) -> so . keyex >> 4 ) 
      FUNCCALL(SETUP_XfOrM254(_), print_this_string (pp , & compacts [CPT_LET_ONE_TYPED ] , 0 , 1 ) ); 
    else FUNCCALL(SETUP_XfOrM254(_), print_this_string (pp , & compacts [CPT_LET_ONE ] , 0 , 1 ) )
    ; 
    (__funcarg71 = FUNCCALL(SETUP_XfOrM254(_), scheme_protect_quote (lo -> value ) ), FUNCCALL_AGAIN(print (__funcarg71 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg70 = FUNCCALL(SETUP_XfOrM254(_), scheme_protect_quote (lo -> body ) ), FUNCCALL_AGAIN(print (__funcarg70 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    if ((& lo -> iso ) -> so . keyex >> 4 ) 
      FUNCCALL(SETUP_XfOrM254(_), print_compact_number (pp , ((& lo -> iso ) -> so . keyex >> 4 ) ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_branch_type ) ) ) 
  {
    Scheme_Branch_Rec * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM206_COUNT)));
#   define XfOrM253_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM253(x) SETUP(XfOrM253_COUNT)
    b = NULLED_OUT ; 

# 3001 "bc/src/print.c"
    b = (Scheme_Branch_Rec * ) obj ; 
    FUNCCALL(SETUP_XfOrM253(_), print_this_string (pp , & compacts [CPT_BRANCH ] , 0 , 1 ) )
    ; 
    (__funcarg69 = FUNCCALL(SETUP_XfOrM253(_), scheme_protect_quote (b -> test ) ), FUNCCALL_AGAIN(print (__funcarg69 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    (__funcarg68 = FUNCCALL(SETUP_XfOrM253(_), scheme_protect_quote (b -> tbranch ) ), FUNCCALL_AGAIN(print (__funcarg68 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg67 = FUNCCALL(SETUP_XfOrM253(_), scheme_protect_quote (b -> fbranch ) ), FUNCCALL_AGAIN(print (__funcarg67 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_with_cont_mark_type ) ) ) 
  {
    Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) obj ; 
    BLOCK_SETUP((PUSH(wcm, 0+XfOrM206_COUNT)));
#   define XfOrM252_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
    FUNCCALL(SETUP_XfOrM252(_), print_this_string (pp , & compacts [CPT_WCM ] , 0 , 1 ) )
# 3012 "bc/src/print.c"
    ; 
    (__funcarg66 = FUNCCALL(SETUP_XfOrM252(_), scheme_protect_quote (wcm -> key ) ), FUNCCALL_AGAIN(print (__funcarg66 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    (__funcarg65 = FUNCCALL(SETUP_XfOrM252(_), scheme_protect_quote (wcm -> val ) ), FUNCCALL_AGAIN(print (__funcarg65 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg64 = FUNCCALL(SETUP_XfOrM252(_), scheme_protect_quote (wcm -> body ) ), FUNCCALL_AGAIN(print (__funcarg64 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_define_values_type ) ) ) 
  {
    Scheme_Object * e ; 
    BLOCK_SETUP((PUSH(e, 0+XfOrM206_COUNT)));
#   define XfOrM251_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM251(x) SETUP(XfOrM251_COUNT)
    e = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM251(_), print_this_string (pp , & compacts [CPT_DEFINE_VALUES ] , 0 , 1 ) )
# 3021 "bc/src/print.c"
    ; 

    obj = FUNCCALL_AGAIN(scheme_clone_vector (obj , 0 , 0 ) ); 
    e = FUNCCALL_AGAIN(scheme_protect_quote ((((Scheme_Vector * ) (obj ) ) -> els ) [0 ] ) ); 
    (((Scheme_Vector * ) (obj ) ) -> els ) [0 ] = e ; 

    closed = FUNCCALL(SETUP_XfOrM251(_), print (obj , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_set_bang_type ) ) ) 
  {
    Scheme_Set_Bang * sb = (Scheme_Set_Bang * ) obj ; 
    BLOCK_SETUP((PUSH(sb, 0+XfOrM206_COUNT)));
#   define XfOrM250_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM250(x) SETUP(XfOrM250_COUNT)
    FUNCCALL(SETUP_XfOrM250(_), print_this_string (pp , & compacts [CPT_SET_BANG ] , 0 , 1 ) )
# 3033 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM250(_), print_compact_number (pp , sb -> set_undef ? 1 : 0 ) ); 
    FUNCCALL_AGAIN(print (sb -> var , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    closed = (__funcarg63 = FUNCCALL(SETUP_XfOrM250(_), scheme_protect_quote (sb -> val ) ), FUNCCALL_AGAIN(print (__funcarg63 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_boxenv_type ) ) ) 
  {
#   define XfOrM249_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM249(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM249(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 3040 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM249(_), print_compact_number (pp , scheme_boxenv_type ) ); 
    FUNCCALL_AGAIN(print ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr1 ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )
    ; 
    closed = FUNCCALL_AGAIN(print ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr2 ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_varref_form_type ) ) ) 
  {
#   define XfOrM248_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM248(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM248(_), print_this_string (pp , & compacts [CPT_VARREF ] , 0 , 1 ) )
# 3048 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM248(_), print_compact_number (pp , (& ((Scheme_Simple_Object * ) obj ) -> iso ) -> so . keyex & (0x1 | 0x2 ) ) )
    ; 
    FUNCCALL_AGAIN(print ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr1 ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    closed = FUNCCALL_AGAIN(print ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr2 ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_apply_values_type ) ) ) 
  {
#   define XfOrM247_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM247(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM247(_), print_this_string (pp , & compacts [CPT_APPLY_VALUES ] , 0 , 1 ) )
# 3056 "bc/src/print.c"
    ; 
    (__funcarg62 = FUNCCALL(SETUP_XfOrM247(_), scheme_protect_quote ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr1 ) ) )
    , FUNCCALL_AGAIN(print (__funcarg62 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg61 = FUNCCALL(SETUP_XfOrM247(_), scheme_protect_quote ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr2 ) ) ), FUNCCALL_AGAIN(print (__funcarg61 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_with_immed_mark_type ) ) ) 
  {
    Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) obj ; 
    BLOCK_SETUP((PUSH(wcm, 0+XfOrM206_COUNT)));
#   define XfOrM246_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM246(x) SETUP(XfOrM246_COUNT)
    FUNCCALL(SETUP_XfOrM246(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 3065 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM246(_), print_compact_number (pp , scheme_with_immed_mark_type ) ); 
    FUNCCALL_AGAIN(print (wcm -> key , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )
    ; 
    FUNCCALL_AGAIN(print (wcm -> val , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    closed = FUNCCALL_AGAIN(print (wcm -> body , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_inline_variant_type ) ) ) 
  {
#   define XfOrM245_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM245(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM245(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 3074 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM245(_), print_compact_number (pp , scheme_inline_variant_type ) ); 
    FUNCCALL_AGAIN(print ((((Scheme_Vector * ) (obj ) ) -> els ) [0 ] , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )
    ; 
    closed = FUNCCALL_AGAIN(print ((((Scheme_Vector * ) (obj ) ) -> els ) [1 ] , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_case_lambda_sequence_type ) ) ) 
  {
    Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) obj ; 
    int i , count ; 
    BLOCK_SETUP((PUSH(cl, 0+XfOrM206_COUNT)));
#   define XfOrM242_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM242(x) SETUP(XfOrM242_COUNT)
    FUNCCALL(SETUP_XfOrM242(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 3085 "bc/src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM242(_), print_compact_number (pp , scheme_case_lambda_sequence_type ) ); 

    count = cl -> count ; 
    FUNCCALL(SETUP_XfOrM242(_), print_compact_number (pp , count ) ); 
    (__funcarg60 = FUNCCALL(SETUP_XfOrM242(_), scheme_closure_marshal_name (cl -> name ) )
    , FUNCCALL_AGAIN(print (__funcarg60 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 

    for (i = 0 ; i < count ; i ++ ) {
#     define XfOrM244_COUNT (0+XfOrM242_COUNT)
#     define SETUP_XfOrM244(x) SETUP_XfOrM242(x)

# 3094 "bc/src/print.c"
      closed = FUNCCALL(SETUP_XfOrM244(_), print (cl -> array [i ] , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    }
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) ) 
  {
    Scheme_Lambda * data = (Scheme_Lambda * ) obj ; 
    Scheme_Object * name , * ds , * closure_map , * tl_map ; 
    BLOCK_SETUP((PUSH(data, 0+XfOrM206_COUNT), PUSH(ds, 1+XfOrM206_COUNT), PUSH(closure_map, 2+XfOrM206_COUNT), PUSH(name, 3+XfOrM206_COUNT), PUSH(tl_map, 4+XfOrM206_COUNT)));
#   define XfOrM241_COUNT (5+XfOrM206_COUNT)
#   define SETUP_XfOrM241(x) SETUP(XfOrM241_COUNT)
    name = NULLED_OUT ; 
    ds = NULLED_OUT ; 
    closure_map = NULLED_OUT ; 
    tl_map = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM241(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 3102 "bc/src/print.c"
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , scheme_lambda_type ) ); 
    FUNCCALL_AGAIN(scheme_write_lambda (obj , & name , & ds , & closure_map , & tl_map ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , (& (data ) -> iso ) -> so . keyex & 0x7F ) )
    ; 
    if ((& (data ) -> iso ) -> so . keyex & 2 )
      FUNCCALL(SETUP_XfOrM241(_), print_compact_number (pp , data -> closure_size ) ); 
    FUNCCALL(SETUP_XfOrM241(_), print_compact_number (pp , data -> num_params ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , data -> max_let_depth ) ); 
    FUNCCALL_AGAIN(print (name , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )
    ; 
    FUNCCALL_AGAIN(print (ds , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    FUNCCALL_AGAIN(print (closure_map , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    closed = FUNCCALL_AGAIN(print (tl_map , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }

  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_rt_delay_load_info ) )  
  {
    Scheme_Load_Delay * ld ; 
    int l ; 
    BLOCK_SETUP((PUSH(ld, 0+XfOrM206_COUNT)));
#   define XfOrM238_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM238(x) SETUP(XfOrM238_COUNT)
    ld = NULLED_OUT ; 

# 3123 "bc/src/print.c"
    ld = (Scheme_Load_Delay * ) obj ; 
    FUNCCALL(SETUP_XfOrM238(_), print_utf8_string (pp , "#<delay-load-info:" , 0 , 18 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (ld -> path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ld -> path ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#     define XfOrM240_COUNT (0+XfOrM238_COUNT)
#     define SETUP_XfOrM240(x) SETUP_XfOrM238(x)

# 3126 "bc/src/print.c"
      l = (((Scheme_Simple_Object * ) (ld -> path ) ) -> u . byte_str_val . tag_val ) ; 
      FUNCCALL(SETUP_XfOrM240(_), print_this_string (pp , (((Scheme_Simple_Object * ) (ld -> path ) ) -> u . byte_str_val . string_val ) , 0 , l ) ); 
    }
    else {
#     define XfOrM239_COUNT (0+XfOrM238_COUNT)
#     define SETUP_XfOrM239(x) SETUP_XfOrM238(x)
      FUNCCALL(SETUP_XfOrM239(_), print_utf8_string (pp , "???" , 0 , 3 ) )
# 3130 "bc/src/print.c"
      ; 
    }
    FUNCCALL(SETUP_XfOrM238(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
  }


  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_quote_compilation_type ) )  
  {
    Scheme_Hash_Table * q_ht ; 
    Scheme_Object * v ; 
    int counter = 1 , qpht , qpb , qpu ; 
    BLOCK_SETUP((PUSH(q_ht, 0+XfOrM206_COUNT), PUSH(v, 1+XfOrM206_COUNT)));
#   define XfOrM236_COUNT (2+XfOrM206_COUNT)
#   define SETUP_XfOrM236(x) SETUP(XfOrM236_COUNT)
    q_ht = NULLED_OUT ; 
    v = NULLED_OUT ; 

# 3142 "bc/src/print.c"
    v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 




    qpht = pp -> print_hash_table ; 
    qpb = pp -> print_box ; 


    pp -> print_hash_table = 1 ; 
    pp -> print_box = 1 ; 

    q_ht = FUNCCALL(SETUP_XfOrM236(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    FUNCCALL_AGAIN(setup_graph_table (v , notdisplay , q_ht , & counter , pp ) ); 

    if (compact )
      FUNCCALL(SETUP_XfOrM236(_), print_this_string (pp , & compacts [CPT_QUOTE ] , 0 , 1 ) ); 
    else {
#     define XfOrM237_COUNT (0+XfOrM236_COUNT)
#     define SETUP_XfOrM237(x) SETUP_XfOrM236(x)
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: non-compact quote compilation" ) )
# 3161 "bc/src/print.c"
      ; 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }


    qpu = pp -> print_unreadable ; 
    pp -> print_unreadable = 0 ; 
    pp -> printing_quoted = 1 ; 

    compact = FUNCCALL(SETUP_XfOrM236(_), print (v , notdisplay , 1 , q_ht , mt , pp ) ); 

    pp -> printing_quoted = 0 ; 
    pp -> print_unreadable = qpu ; 

    pp -> print_hash_table = qpht ; 
    pp -> print_box = qpb ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_svector_type ) ) ) 
  {
    mzshort l , * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM206_COUNT)));
#   define XfOrM231_COUNT (1+XfOrM206_COUNT)
#   define SETUP_XfOrM231(x) SETUP(XfOrM231_COUNT)
    v = NULLED_OUT ; 

# 3181 "bc/src/print.c"
    l = (((Scheme_Simple_Object * ) (obj ) ) -> u . svector_val . len ) ; 
    v = (mzshort * ) (((Scheme_Simple_Object * ) (obj ) ) -> u . svector_val . vec ) ; 

    if (l < (247 - 222 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM235_COUNT (0+XfOrM231_COUNT)
#     define SETUP_XfOrM235(x) SETUP_XfOrM231(x)

# 3186 "bc/src/print.c"
      s [0 ] = l + 222 ; 
      FUNCCALL(SETUP_XfOrM235(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }

# 3188 "bc/src/print.c"
    else {
#     define XfOrM234_COUNT (0+XfOrM231_COUNT)
#     define SETUP_XfOrM234(x) SETUP_XfOrM231(x)
      FUNCCALL(SETUP_XfOrM234(_), print_this_string (pp , & compacts [CPT_SVECTOR ] , 0 , 1 ) )
# 3189 "bc/src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM234(_), print_compact_number (pp , l ) ); 
    }
    while (l -- ) {
      int n = v [l ] ; 
#     define XfOrM233_COUNT (0+XfOrM231_COUNT)
#     define SETUP_XfOrM233(x) SETUP_XfOrM231(x)
      FUNCCALL(SETUP_XfOrM233(_), print_compact_number (pp , n ) )
# 3194 "bc/src/print.c"
      ; 
    }
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_delay_syntax_type ) ) ) 
  {


    Scheme_Object * idx , * key ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM206_COUNT), PUSH(idx, 1+XfOrM206_COUNT)));
#   define XfOrM223_COUNT (2+XfOrM206_COUNT)
#   define SETUP_XfOrM223(x) SETUP(XfOrM223_COUNT)
    idx = NULLED_OUT ; 
    key = NULLED_OUT ; 

# 3203 "bc/src/print.c"
    if ((& ((Scheme_Small_Object * ) obj ) -> iso ) -> so . keyex & 0x1 ) {
    }
    else {
#     define XfOrM226_COUNT (0+XfOrM223_COUNT)
#     define SETUP_XfOrM226(x) SETUP_XfOrM223(x)

# 3206 "bc/src/print.c"
      key = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 

      if (mt -> pass < 0 ) {
      }
      else if (! mt -> pass ) {
#       define XfOrM227_COUNT (0+XfOrM226_COUNT)
#       define SETUP_XfOrM227(x) SETUP_XfOrM226(x)

# 3211 "bc/src/print.c"
        if (! mt -> delay_map ) {
          Scheme_Hash_Table * delay_map ; 
          BLOCK_SETUP((PUSH(delay_map, 0+XfOrM227_COUNT)));
#         define XfOrM228_COUNT (1+XfOrM227_COUNT)
#         define SETUP_XfOrM228(x) SETUP(XfOrM228_COUNT)
          delay_map = NULLED_OUT ; 

# 3213 "bc/src/print.c"
          delay_map = FUNCCALL(SETUP_XfOrM228(_), scheme_make_hash_table_eqv () ); 
          mt -> delay_map = delay_map ; 
        }
        FUNCCALL(SETUP_XfOrM227(_), scheme_hash_set (mt -> delay_map , key , obj ) ); 
      }

# 3217 "bc/src/print.c"
      else 
      obj = FUNCCALL(SETUP_XfOrM226(_), scheme_hash_get (mt -> delay_map , key ) ); 
    }

    idx = FUNCCALL(SETUP_XfOrM223(_), get_symtab_idx (mt , obj ) ); 

    if (idx ) {
#     define XfOrM225_COUNT (0+XfOrM223_COUNT)
#     define SETUP_XfOrM225(x) SETUP_XfOrM223(x)
      FUNCCALL(SETUP_XfOrM225(_), print_general_symtab_ref (pp , idx , CPT_DELAY_REF ) )
# 3224 "bc/src/print.c"
      ; 
    }

# 3225 "bc/src/print.c"
    else {
#     define XfOrM224_COUNT (0+XfOrM223_COUNT)
#     define SETUP_XfOrM224(x) SETUP_XfOrM223(x)
      FUNCCALL(SETUP_XfOrM224(_), print ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , notdisplay , 1 , ht , mt , pp ) )
# 3226 "bc/src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM224(_), symtab_set (pp , mt , obj ) ); 
      FUNCCALL_AGAIN(set_symtab_shared (mt , obj ) ); 
    }
  }
  else if ((compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_bundle_type ) ) ) 
  {
#   define XfOrM212_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM212(x) SETUP_XfOrM206(x)

# 3234 "bc/src/print.c"
    if (compact ) {
      Scheme_Object * v ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM212_COUNT)));
#     define XfOrM221_COUNT (1+XfOrM212_COUNT)
#     define SETUP_XfOrM221(x) SETUP(XfOrM221_COUNT)
      v = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM221(_), print_this_string (pp , & compacts [CPT_LINKLET ] , 0 , 1 ) )
# 3237 "bc/src/print.c"
      ; 

      if (((Scheme_Linklet * ) obj ) -> static_prefix ) {
#       define XfOrM222_COUNT (0+XfOrM221_COUNT)
#       define SETUP_XfOrM222(x) SETUP_XfOrM221(x)
        FUNCCALL(SETUP_XfOrM222(_), print_compact_number (pp , 1 ) )
# 3240 "bc/src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM222(_), print ((Scheme_Object * ) ((Scheme_Linklet * ) obj ) -> static_prefix , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
      }

# 3242 "bc/src/print.c"
      else FUNCCALL(SETUP_XfOrM221(_), print_compact_number (pp , 0 ) )
      ; 

      v = FUNCCALL(SETUP_XfOrM221(_), scheme_write_linklet (obj ) ); 

      closed = FUNCCALL_AGAIN(print (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    }

# 3248 "bc/src/print.c"
    else {
      Scheme_Hash_Table * st_refs , * symtab , * intern_map , * path_cache ; 
      Scheme_Object * v ; 
      intptr_t * shared_offsets ; 
      intptr_t st_len , j , shared_offset , start_offset ; 
      intptr_t slen ; 
      BLOCK_SETUP((PUSH(symtab, 0+XfOrM212_COUNT), PUSH(st_refs, 1+XfOrM212_COUNT), PUSH(path_cache, 2+XfOrM212_COUNT), PUSH(v, 3+XfOrM212_COUNT), PUSH(shared_offsets, 4+XfOrM212_COUNT), PUSH(intern_map, 5+XfOrM212_COUNT)));
#     define XfOrM213_COUNT (6+XfOrM212_COUNT)
#     define SETUP_XfOrM213(x) SETUP(XfOrM213_COUNT)
      st_refs = NULLED_OUT ; 
      symtab = NULLED_OUT ; 
      intern_map = NULLED_OUT ; 
      path_cache = NULLED_OUT ; 
      v = NULLED_OUT ; 
      shared_offsets = NULLED_OUT ; 

# 3255 "bc/src/print.c"
      ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_bundle_type ) ) ) ? 1 : 0 ) , __extension__ ({
#       define XfOrM220_COUNT (0+XfOrM213_COUNT)
#       define SETUP_XfOrM220(x) SETUP_XfOrM213(x)

# 3255 "bc/src/print.c" 3
        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_bundle_type ) ) 

# 3255 "bc/src/print.c" 3
        ; 

# 3255 "bc/src/print.c" 3
        else FUNCCALL(SETUP_XfOrM220(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(obj)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(obj))->type)) == (Scheme_Type)(scheme_linklet_bundle_type))" , "bc/src/print.c" , 3255 , __extension__ __PRETTY_FUNCTION__ ) ); 
      }
      ) ) 
# 3255 "bc/src/print.c"
      ; 
      v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 

      mt = ((Scheme_Marshal_Tables * ) FUNCCALL(SETUP_XfOrM213(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Marshal_Tables ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      mt -> type = scheme_rt_marshal_info ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_mt = mt ; 

      intern_map = FUNCCALL(SETUP_XfOrM213(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> intern_map = intern_map ; 

      symtab = FUNCCALL(SETUP_XfOrM213(_), scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      path_cache = FUNCCALL(SETUP_XfOrM213(_), scheme_make_hash_table_equal () ); 
      mt -> path_cache = path_cache ; 

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_mt = mt ; 


      st_refs = FUNCCALL(SETUP_XfOrM213(_), scheme_make_hash_table_eqv () ); 
      mt -> st_refs = st_refs ; 
      mt -> st_ref_stack = scheme_null ; 






      symtab = FUNCCALL(SETUP_XfOrM213(_), scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      mt -> pass = 0 ; 
      FUNCCALL(SETUP_XfOrM213(_), scheme_hash_set (symtab , scheme_void , scheme_true ) ); 
      FUNCCALL_AGAIN(print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , 0 , ((void * ) 0 ) ) ); 
      FUNCCALL_AGAIN(sort_referenced_keys (mt ) )
      ; 




      shared_offsets = ((intptr_t * ) FUNCCALL(SETUP_XfOrM213(_), GC_malloc_atomic (sizeof (intptr_t ) * (mt -> st_refs -> count ) ) )) ; 
      mt -> shared_offsets = shared_offsets ; 
      symtab = FUNCCALL(SETUP_XfOrM213(_), scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      mt -> pass = 1 ; 
      FUNCCALL(SETUP_XfOrM213(_), print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , 1 , & st_len ) )
      ; 


      symtab = FUNCCALL_AGAIN(scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      mt -> pass = 2 ; 
      FUNCCALL(SETUP_XfOrM213(_), print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , - 1 , & st_len ) )
      ; 

      if (mt -> st_refs -> count != mt -> sorted_keys_count )
        FUNCCALL_EMPTY(scheme_signal_error ("shared key count somehow changed" ) ); 
      FUNCCALL(SETUP_XfOrM213(_), print_number (pp , mt -> st_refs -> count + 1 ) )
      ; 


      if (mt -> st_refs -> count ) {
        int all_short = shared_offsets [mt -> st_refs -> count - 1 ] < 0xFFFF ; 
#       define XfOrM217_COUNT (0+XfOrM213_COUNT)
#       define SETUP_XfOrM217(x) SETUP_XfOrM213(x)
        FUNCCALL(SETUP_XfOrM217(_), print_one_byte (pp , all_short ) )
# 3316 "bc/src/print.c"
        ; 
        for (j = 0 ; j < mt -> st_refs -> count ; j ++ ) {
#         define XfOrM219_COUNT (0+XfOrM217_COUNT)
#         define SETUP_XfOrM219(x) SETUP_XfOrM217(x)

# 3318 "bc/src/print.c"
          if (all_short )
            FUNCCALL(SETUP_XfOrM219(_), print_short_number (pp , shared_offsets [j ] ) ); 
          else FUNCCALL(SETUP_XfOrM219(_), print_number (pp , shared_offsets [j ] ) )
          ; 
        }
      }

# 3323 "bc/src/print.c"
      else {
#       define XfOrM216_COUNT (0+XfOrM213_COUNT)
#       define SETUP_XfOrM216(x) SETUP_XfOrM213(x)
        FUNCCALL(SETUP_XfOrM216(_), print_one_byte (pp , 1 ) )
# 3324 "bc/src/print.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM213(_), print_number (pp , st_len ) )
      ; 
      FUNCCALL(SETUP_XfOrM213(_), print_number (pp , slen ) ); 



      symtab = FUNCCALL_AGAIN(scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      mt -> pass = 3 ; 

      start_offset = pp -> print_offset ; 
      FUNCCALL(SETUP_XfOrM213(_), print_table_keys (notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )


      ; 
      shared_offset = pp -> print_offset ; 
      closed = FUNCCALL(SETUP_XfOrM213(_), print (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 

      if (shared_offset - start_offset != st_len ) {
#       define XfOrM215_COUNT (0+XfOrM213_COUNT)
#       define SETUP_XfOrM215(x) SETUP_XfOrM213(x)
        FUNCCALL_EMPTY(scheme_signal_error ("compiled code shared printed size changed on third pass:" " %ld versus %ld (total %ld)" , st_len , shared_offset - start_offset , slen ) ); 
      }
      if (pp -> print_offset - start_offset != slen ) {
#       define XfOrM214_COUNT (0+XfOrM213_COUNT)
#       define SETUP_XfOrM214(x) SETUP_XfOrM213(x)
        FUNCCALL_EMPTY(scheme_signal_error ("compiled code printed size changed on third pass:" " %ld versus %ld" , slen , pp -> print_offset - start_offset ) ); 
      }

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_mt = ((void * ) 0 ) ; 
      mt = ((void * ) 0 ) ; 
    }
  }
  else 
  {
#   define XfOrM207_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM207(x) SETUP_XfOrM206(x)

# 3361 "bc/src/print.c"
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM207(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    else if ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) < printers_count ) 
    && printers [((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ] ) {
      Scheme_Type_Printer printer ; 
#     define XfOrM211_COUNT (0+XfOrM207_COUNT)
#     define SETUP_XfOrM211(x) SETUP_XfOrM207(x)

# 3366 "bc/src/print.c"
      printer = printers [((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ] ; 
      FUNCCALL(SETUP_XfOrM211(_), printer (obj , ! notdisplay , pp ) ); 
    }

# 3368 "bc/src/print.c"
    else {
      char * s ; 
      intptr_t len = - 1 ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM207_COUNT)));
#     define XfOrM208_COUNT (1+XfOrM207_COUNT)
#     define SETUP_XfOrM208(x) SETUP(XfOrM208_COUNT)
      s = NULLED_OUT ; 

# 3371 "bc/src/print.c"
      s = FUNCCALL(SETUP_XfOrM208(_), scheme_get_type_name ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) ); 
      FUNCCALL_AGAIN(print_utf8_string (pp , "#" , 0 , 1 ) ); 



      if (! s ) {
        char s [8 ] ; 
#       define XfOrM210_COUNT (0+XfOrM208_COUNT)
#       define SETUP_XfOrM210(x) SETUP_XfOrM208(x)
        FUNCCALL(SETUP_XfOrM210(_), print_utf8_string (pp , "<???:" , 0 , 5 ) )
# 3378 "bc/src/print.c"
        ; 
        (sprintf (s , "%d" , ((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) ; 
        FUNCCALL(SETUP_XfOrM210(_), print_utf8_string (pp , s , 0 , - 1 ) ); 
        FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }

# 3382 "bc/src/print.c"
      else {
#       define XfOrM209_COUNT (0+XfOrM208_COUNT)
#       define SETUP_XfOrM209(x) SETUP_XfOrM208(x)
        FUNCCALL_EMPTY(print_utf8_string (pp , s , 0 , len ) )
# 3383 "bc/src/print.c"
        ; 
      }
    }





    closed = 1 ; 
  }

  RET_VALUE_START ((closed || compact ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3397 "bc/src/print.c"
static void 
print_char_string (const char * str , int len , 
const mzchar * ustr , int delta , int ulen , 
int notdisplay , PrintParams * pp ) 
{
  char minibuf [12 ] , * esc ; 
  int a , i , v , ui , cont_utf8 = 0 , isize ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(esc, 1), PUSH(ustr, 2), PUSH(str, 3)));
# define XfOrM480_COUNT (4)
# define SETUP_XfOrM480(x) SETUP(XfOrM480_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  esc = NULLED_OUT ; 

# 3405 "bc/src/print.c"
  if (notdisplay ) {
#   define XfOrM482_COUNT (0+XfOrM480_COUNT)
#   define SETUP_XfOrM482(x) SETUP_XfOrM480(x)
    FUNCCALL(SETUP_XfOrM482(_), print_utf8_string (pp , "\"" , 0 , 1 ) )
# 3406 "bc/src/print.c"
    ; 

    for (a = i = ui = 0 ; i < len ; i += isize , ui ++ ) {
#     define XfOrM495_COUNT (0+XfOrM482_COUNT)
#     define SETUP_XfOrM495(x) SETUP_XfOrM482(x)

# 3409 "bc/src/print.c"
      v = ((unsigned char * ) str ) [i ] ; 
      isize = 1 ; 

      switch (v ) {
#       define XfOrM499_COUNT (0+XfOrM495_COUNT)
#       define SETUP_XfOrM499(x) SETUP_XfOrM495(x)

# 3413 "bc/src/print.c"
        case '\"' : 
        esc = "\\\"" ; 
        break ; 
        case '\\' : esc = "\\\\" ; 

# 3416 "bc/src/print.c"
        break ; 
        case '\a' : esc = "\\a" ; 

# 3417 "bc/src/print.c"
        break ; 
        case '\b' : esc = "\\b" ; 

# 3418 "bc/src/print.c"
        break ; 
        case 27 : esc = "\\e" ; 

# 3419 "bc/src/print.c"
        break ; 
        case '\f' : esc = "\\f" ; 

# 3420 "bc/src/print.c"
        break ; 
        case '\n' : esc = "\\n" ; 

# 3421 "bc/src/print.c"
        break ; 
        case '\r' : esc = "\\r" ; 

# 3422 "bc/src/print.c"
        break ; 
        case '\t' : esc = "\\t" ; 

# 3423 "bc/src/print.c"
        break ; 
        case '\v' : esc = "\\v" ; 

# 3424 "bc/src/print.c"
        break ; 
        default : 
        if (v > 127 ) {
#         define XfOrM502_COUNT (0+XfOrM499_COUNT)
#         define SETUP_XfOrM502(x) SETUP_XfOrM499(x)

# 3427 "bc/src/print.c"
          if (cont_utf8 ) {
            cont_utf8 -- ; 
            ui -- ; 
            esc = ((void * ) 0 ) ; 
          }

# 3431 "bc/src/print.c"
          else {
            int clen ; 
#           define XfOrM503_COUNT (0+XfOrM502_COUNT)
#           define SETUP_XfOrM503(x) SETUP_XfOrM502(x)

# 3433 "bc/src/print.c"
            clen = FUNCCALL(SETUP_XfOrM503(_), scheme_utf8_encode (ustr , ui + delta , ui + delta + 1 , ((void * ) 0 ) , 0 , 0 ) ); 
            if ((((scheme_uchar_table [(ustr [ui + delta ] >> 8 ) & 0x1FFF ] [ustr [ui + delta ] & 0xFF ] ) ) & 0x800 ) 
            || (((scheme_uchar_table [(ustr [ui + delta ] >> 8 ) & 0x1FFF ] [ustr [ui + delta ] & 0xFF ] ) ) & 0x1 ) ) {
              cont_utf8 = clen - 1 ; 
              esc = ((void * ) 0 ) ; 
            }

# 3438 "bc/src/print.c"
            else {
              esc = minibuf ; 
              isize = clen ; 
            }
          }
        }

# 3443 "bc/src/print.c"
        else if ((((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x800 ) 
        || (((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x1 ) ) {
          esc = ((void * ) 0 ) ; 
        }

# 3446 "bc/src/print.c"
        else {
          esc = minibuf ; 
        }
        break ; 
      }

      if (esc ) {
#       define XfOrM496_COUNT (0+XfOrM495_COUNT)
#       define SETUP_XfOrM496(x) SETUP_XfOrM495(x)

# 3453 "bc/src/print.c"
        if (esc == minibuf ) {
#         define XfOrM497_COUNT (0+XfOrM496_COUNT)
#         define SETUP_XfOrM497(x) SETUP_XfOrM496(x)

# 3454 "bc/src/print.c"
          if (ustr [ui + delta ] > 0xFFFF ) {
#           define XfOrM498_COUNT (0+XfOrM497_COUNT)
#           define SETUP_XfOrM498(x) SETUP_XfOrM497(x)
            (
# 3455 "bc/src/print.c"
            sprintf (minibuf , "\\U%.8X" , ustr [ui + delta ] ) ) ; 
          }

# 3456 "bc/src/print.c"
          else (
          sprintf (minibuf , "\\u%.4X" , ustr [ui + delta ] ) ) ; 
        }

        if (a < i )
          FUNCCALL(SETUP_XfOrM496(_), print_utf8_string (pp , str , a , i - a ) ); 
        FUNCCALL(SETUP_XfOrM496(_), print_utf8_string (pp , esc , 0 , - 1 ) ); 
        a = i + isize ; 
      }
    }
    if (a < i )
      FUNCCALL(SETUP_XfOrM482(_), print_utf8_string (pp , str , a , i - a ) ); 
    FUNCCALL(SETUP_XfOrM482(_), print_utf8_string (pp , "\"" , 0 , 1 ) )
    ; 
  }

# 3470 "bc/src/print.c"
  else if (len ) {
#   define XfOrM481_COUNT (0+XfOrM480_COUNT)
#   define SETUP_XfOrM481(x) SETUP_XfOrM480(x)
    FUNCCALL_EMPTY(print_utf8_string (pp , str , 0 , len ) )
# 3471 "bc/src/print.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3475 "bc/src/print.c"
static void 
print_byte_string (const char * str , int delta , int len , int notdisplay , PrintParams * pp ) 
{
  char minibuf [8 ] , * esc ; 
  int a , i , v ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(esc, 1), PUSH(str, 2)));
# define XfOrM507_COUNT (3)
# define SETUP_XfOrM507(x) SETUP(XfOrM507_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  esc = NULLED_OUT ; 

# 3481 "bc/src/print.c"
  if (notdisplay ) {
#   define XfOrM509_COUNT (0+XfOrM507_COUNT)
#   define SETUP_XfOrM509(x) SETUP_XfOrM507(x)
    FUNCCALL(SETUP_XfOrM509(_), print_utf8_string (pp , "\"" , 0 , 1 ) )
# 3482 "bc/src/print.c"
    ; 

    for (a = i = delta ; i < delta + len ; i ++ ) {
#     define XfOrM517_COUNT (0+XfOrM509_COUNT)
#     define SETUP_XfOrM517(x) SETUP_XfOrM509(x)

# 3486 "bc/src/print.c"
      switch (((unsigned char * ) str ) [i ] ) {
        case '\"' : esc = "\\\"" ; 

# 3487 "bc/src/print.c"
        break ; 
        case '\\' : esc = "\\\\" ; 

# 3488 "bc/src/print.c"
        break ; 
        case '\a' : esc = "\\a" ; 

# 3489 "bc/src/print.c"
        break ; 
        case '\b' : esc = "\\b" ; 

# 3490 "bc/src/print.c"
        break ; 
        case 27 : esc = "\\e" ; 

# 3491 "bc/src/print.c"
        break ; 
        case '\f' : esc = "\\f" ; 

# 3492 "bc/src/print.c"
        break ; 
        case '\n' : esc = "\\n" ; 

# 3493 "bc/src/print.c"
        break ; 
        case '\r' : esc = "\\r" ; 

# 3494 "bc/src/print.c"
        break ; 
        case '\t' : esc = "\\t" ; 

# 3495 "bc/src/print.c"
        break ; 
        case '\v' : esc = "\\v" ; 

# 3496 "bc/src/print.c"
        break ; 
        default : 
        v = ((unsigned char * ) str ) [i ] ; 
        if (v > 127 ) {
          esc = minibuf ; 
        }

# 3501 "bc/src/print.c"
        else if ((((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x800 ) || (((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x1 ) ) {
          esc = ((void * ) 0 ) ; 
        }

# 3503 "bc/src/print.c"
        else {
          esc = minibuf ; 
        }
        break ; 
      }

      if (esc ) {
#       define XfOrM518_COUNT (0+XfOrM517_COUNT)
#       define SETUP_XfOrM518(x) SETUP_XfOrM517(x)

# 3510 "bc/src/print.c"
        if (esc == minibuf ) {
#         define XfOrM519_COUNT (0+XfOrM518_COUNT)
#         define SETUP_XfOrM519(x) SETUP_XfOrM518(x)
          (
# 3511 "bc/src/print.c"
          sprintf (minibuf , 
          ((i + 1 >= len ) || (str [i + 1 ] < '0' ) || (str [i + 1 ] > '7' ) ) ? "\\%o" : "\\%03o" , 
          ((unsigned char * ) str ) [i ] ) ) ; 
        }

        if (a < i )
          FUNCCALL(SETUP_XfOrM518(_), print_utf8_string (pp , str , a , i - a ) ); 
        FUNCCALL(SETUP_XfOrM518(_), print_utf8_string (pp , esc , 0 , - 1 ) ); 
        a = i + 1 ; 
      }
    }
    if (a < i )
      FUNCCALL(SETUP_XfOrM509(_), print_utf8_string (pp , str , a , i - a ) ); 
    FUNCCALL(SETUP_XfOrM509(_), print_utf8_string (pp , "\"" , 0 , 1 ) )
    ; 
  }

# 3526 "bc/src/print.c"
  else if (len ) {
#   define XfOrM508_COUNT (0+XfOrM507_COUNT)
#   define SETUP_XfOrM508(x) SETUP_XfOrM507(x)
    FUNCCALL_EMPTY(print_this_string (pp , str , delta , len ) )
# 3527 "bc/src/print.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3531 "bc/src/print.c"
static int is_special_reader_form (PrintParams * pp , int notdisplay , Scheme_Object * p ) 
{
  /* No conversion */

# 3533 "bc/src/print.c"
  Scheme_Object * v ; 

  if (notdisplay && (notdisplay != 3 ) && pp -> print_reader ) {
    v = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . car ) ; 
    p = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )

# 3538 "bc/src/print.c"
    return 0 ; 
    p = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ; 
    if (! ((p ) == (scheme_null ) ) )

# 3540 "bc/src/print.c"
    return 0 ; 
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
      if (((v ) == (quote_symbol ) ) 
      || ((v ) == (quasiquote_symbol ) ) 
      || ((v ) == (unquote_symbol ) ) 
      || ((v ) == (unquote_splicing_symbol ) ) 
      || ((v ) == (syntax_symbol ) ) 
      || ((v ) == (quasisyntax_symbol ) ) 
      || ((v ) == (unsyntax_symbol ) ) 
      || ((v ) == (unsyntax_splicing_symbol ) ) )
        return 1 ; 
    }
  }

  return 0 ; 
}

static void print_special_reader_form (Scheme_Object * v , PrintParams * pp , int notdisplay ) 
{
  /* No conversion */

# 3559 "bc/src/print.c"
  const char * str ; 
  int len ; 

  if ((v ) == (quote_symbol ) )  {
    str = "'" ; 
    len = 1 ; 
  }

# 3565 "bc/src/print.c"
  else if ((v ) == (quasiquote_symbol ) )  {
    str = "`" ; 
    len = 1 ; 
  }

# 3568 "bc/src/print.c"
  else if ((v ) == (unquote_symbol ) )  {
    str = "," ; 
    len = 1 ; 
  }

# 3571 "bc/src/print.c"
  else if ((v ) == (unquote_splicing_symbol ) )  {
    str = ",@" ; 
    len = 2 ; 
  }

# 3574 "bc/src/print.c"
  else if ((v ) == (syntax_symbol ) )  {
    str = "#'" ; 
    len = 2 ; 
  }

# 3577 "bc/src/print.c"
  else if ((v ) == (quasisyntax_symbol ) )  {
    str = "#`" ; 
    len = 2 ; 
  }

# 3580 "bc/src/print.c"
  else if ((v ) == (unsyntax_symbol ) )  {
    str = "#," ; 
    len = 2 ; 
  }

# 3583 "bc/src/print.c"
  else if ((v ) == (unsyntax_splicing_symbol ) )  {
    str = "#,@" ; 
    len = 3 ; 
  }

# 3586 "bc/src/print.c"
  else {
    str = "???" ; 
    len = 3 ; 
  }

  print_utf8_string (pp , str , 0 , len ) ; 
}

static void 
print_pair (Scheme_Object * pair , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
Scheme_Type pair_type , int round_parens , int first_unquoted ) 
{
  Scheme_Object * cdr ; 
  int super_compact = 0 ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(ht, 1), PUSH(cdr, 2), PUSH(mt, 3), PUSH(pair, 4)));
# define XfOrM537_COUNT (5)
# define SETUP_XfOrM537(x) SETUP(XfOrM537_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cdr = NULLED_OUT ; 

# 3604 "bc/src/print.c"
  if (compact ) {
    int c = 0 ; 
    Scheme_Object * pr ; 
    BLOCK_SETUP((PUSH(pr, 0+XfOrM537_COUNT)));
#   define XfOrM560_COUNT (1+XfOrM537_COUNT)
#   define SETUP_XfOrM560(x) SETUP(XfOrM560_COUNT)
    pr = NULLED_OUT ; 

# 3608 "bc/src/print.c"
    pr = pair ; 
    while (((Scheme_Type ) (((((intptr_t ) (pr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) ) {
#     define XfOrM566_COUNT (0+XfOrM560_COUNT)
#     define SETUP_XfOrM566(x) SETUP_XfOrM560(x)

# 3610 "bc/src/print.c"
      if (ht )
        if (FUNCCALL(SETUP_XfOrM566(_), is_graph_point (ht , pr ) )) {
        c = - 1 ; 
        break ; 
      }
      c ++ ; 
      pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
    }

    if (c > - 1 ) {
#     define XfOrM561_COUNT (0+XfOrM560_COUNT)
#     define SETUP_XfOrM561(x) SETUP_XfOrM560(x)

# 3620 "bc/src/print.c"
      super_compact = 1 ; 
      if (c < (((92 + 50 ) + 50 ) - (92 + 50 ) ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM563_COUNT (0+XfOrM561_COUNT)
#       define SETUP_XfOrM563(x) SETUP_XfOrM561(x)

# 3623 "bc/src/print.c"
        s [0 ] = c + (((pr ) == (scheme_null ) ) 
        ? 92 
        : (92 + 50 ) ) ; 
        FUNCCALL(SETUP_XfOrM563(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }

# 3627 "bc/src/print.c"
      else {
#       define XfOrM562_COUNT (0+XfOrM561_COUNT)
#       define SETUP_XfOrM562(x) SETUP_XfOrM561(x)
        FUNCCALL(SETUP_XfOrM562(_), print_this_string (pp , & compacts [CPT_LIST ] , 0 , 1 ) )
# 3628 "bc/src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM562(_), print_compact_number (pp , c ) ); 
        super_compact = - 1 ; 
      }
    }
  }

  if (compact ) {
#   define XfOrM559_COUNT (0+XfOrM537_COUNT)
#   define SETUP_XfOrM559(x) SETUP_XfOrM537(x)

# 3636 "bc/src/print.c"
    if (! super_compact )
      FUNCCALL(SETUP_XfOrM559(_), print_this_string (pp , & compacts [CPT_PAIR ] , 0 , 1 ) ); 
  }

# 3638 "bc/src/print.c"
  else {
#   define XfOrM551_COUNT (0+XfOrM537_COUNT)
#   define SETUP_XfOrM551(x) SETUP_XfOrM537(x)

# 3639 "bc/src/print.c"
    if (round_parens 
    && ! first_unquoted 
    && FUNCCALL(SETUP_XfOrM551(_), is_special_reader_form (pp , notdisplay , pair ) )) {
#     define XfOrM556_COUNT (0+XfOrM551_COUNT)
#     define SETUP_XfOrM556(x) SETUP_XfOrM551(x)
      FUNCCALL(SETUP_XfOrM556(_), print_special_reader_form ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) , pp , notdisplay ) )
# 3642 "bc/src/print.c"
      ; 




      if (((((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) == (unquote_symbol ) ) 
      || (((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) == (unsyntax_symbol ) ) ) 
      && (((Scheme_Type ) (((((intptr_t ) (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
      && ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) ) ) -> s ) [0 ] == '@' ) ) ) {

        const char * sv ; 
        BLOCK_SETUP((PUSH(sv, 0+XfOrM556_COUNT)));
#       define XfOrM557_COUNT (1+XfOrM556_COUNT)
#       define SETUP_XfOrM557(x) SETUP(XfOrM557_COUNT)
        sv = NULLED_OUT ; 

# 3653 "bc/src/print.c"
        sv = FUNCCALL(SETUP_XfOrM557(_), scheme_symbol_name_and_size (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) , ((void * ) 0 ) , ((pp -> can_read_pipe_quote ? 0x2 : 0x4 ) ) ) )


        ; 
        if (sv [0 ] == '@' ) {
#         define XfOrM558_COUNT (0+XfOrM557_COUNT)
#         define SETUP_XfOrM558(x) SETUP_XfOrM557(x)
          FUNCCALL(SETUP_XfOrM558(_), print_utf8_string (pp , " " , 0 , 1 ) )
# 3659 "bc/src/print.c"
          ; 
        }
      }
      (void ) FUNCCALL(SETUP_XfOrM556(_), print (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) , notdisplay , compact , ht , mt , pp ) ); 
      RET_NOTHING ; 
    }

# 3664 "bc/src/print.c"
    else if ((notdisplay == 3 ) && ! first_unquoted ) {
#     define XfOrM553_COUNT (0+XfOrM551_COUNT)
#     define SETUP_XfOrM553(x) SETUP_XfOrM551(x)

# 3665 "bc/src/print.c"
      if ((Scheme_Type ) (pair_type ) == (Scheme_Type ) (scheme_pair_type ) )  {
#       define XfOrM555_COUNT (0+XfOrM553_COUNT)
#       define SETUP_XfOrM555(x) SETUP_XfOrM553(x)

# 3666 "bc/src/print.c"
        if (scheme_is_list (pair ) ) 
          FUNCCALL(SETUP_XfOrM555(_), print_utf8_string (pp , "(list " , 0 , 6 ) ); 
        else if (! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
        || FUNCCALL(SETUP_XfOrM555(_), is_graph_point (ht , (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ))
          FUNCCALL(SETUP_XfOrM555(_), print_utf8_string (pp , "(cons " , 0 , 6 ) ); 
        else FUNCCALL(SETUP_XfOrM555(_), print_utf8_string (pp , "(list* " , 0 , 7 ) )
        ; 
      }

# 3673 "bc/src/print.c"
      else {
#       define XfOrM554_COUNT (0+XfOrM553_COUNT)
#       define SETUP_XfOrM554(x) SETUP_XfOrM553(x)

# 3674 "bc/src/print.c"
        pair_type = - 1 ; 
        FUNCCALL(SETUP_XfOrM554(_), print_utf8_string (pp , "(mcons " , 0 , 7 ) ); 
      }
      round_parens = 1 ; 
    }

# 3678 "bc/src/print.c"
    else if (round_parens ) {
#     define XfOrM552_COUNT (0+XfOrM551_COUNT)
#     define SETUP_XfOrM552(x) SETUP_XfOrM551(x)
      FUNCCALL(SETUP_XfOrM552(_), print_utf8_string (pp , "(" , 0 , 1 ) )
# 3679 "bc/src/print.c"
      ; 
    }

# 3680 "bc/src/print.c"
    else FUNCCALL(SETUP_XfOrM551(_), print_utf8_string (pp , "{" , 0 , 1 ) )
    ; 
  }
  FUNCCALL(SETUP_XfOrM537(_), print ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) , (first_unquoted ? 1 : notdisplay ) , compact , ht , mt , pp ) )
  ; 

  cdr = (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ; 
  while (((Scheme_Type ) (((((intptr_t ) (cdr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cdr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) 
  && ! FUNCCALL(SETUP_XfOrM537(_), is_special_reader_form (pp , notdisplay , pair ) )) {
#   define XfOrM546_COUNT (0+XfOrM537_COUNT)
#   define SETUP_XfOrM546(x) SETUP_XfOrM537(x)

# 3689 "bc/src/print.c"
    if (ht && ! super_compact ) {
#     define XfOrM547_COUNT (0+XfOrM546_COUNT)
#     define SETUP_XfOrM547(x) SETUP_XfOrM546(x)

# 3690 "bc/src/print.c"
      if (FUNCCALL(SETUP_XfOrM547(_), is_graph_point (ht , cdr ) )) {
#       define XfOrM548_COUNT (0+XfOrM547_COUNT)
#       define SETUP_XfOrM548(x) SETUP_XfOrM547(x)

# 3692 "bc/src/print.c"
        if (! compact ) {
#         define XfOrM550_COUNT (0+XfOrM548_COUNT)
#         define SETUP_XfOrM550(x) SETUP_XfOrM548(x)

# 3693 "bc/src/print.c"
          if (notdisplay == 3 )
            FUNCCALL(SETUP_XfOrM550(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
          else FUNCCALL(SETUP_XfOrM550(_), print_utf8_string (pp , " . " , 0 , 3 ) )
          ; 
        }
        (void ) FUNCCALL(SETUP_XfOrM548(_), print (cdr , notdisplay , compact , ht , mt , pp ) ); 
        if (! compact ) {
#         define XfOrM549_COUNT (0+XfOrM548_COUNT)
#         define SETUP_XfOrM549(x) SETUP_XfOrM548(x)

# 3700 "bc/src/print.c"
          if (round_parens )
            FUNCCALL(SETUP_XfOrM549(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
          else FUNCCALL(SETUP_XfOrM549(_), print_utf8_string (pp , "}" , 0 , 1 ) )
          ; 
        }
        RET_NOTHING ; 
      }
    }
    if (compact && ! super_compact )
      FUNCCALL(SETUP_XfOrM546(_), print_this_string (pp , & compacts [CPT_PAIR ] , 0 , 1 ) ); 
    if (! compact )
      FUNCCALL(SETUP_XfOrM546(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    FUNCCALL(SETUP_XfOrM546(_), print ((((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . car ) , notdisplay , compact , ht , mt , pp ) ); 
    cdr = (((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . cdr ) ; 
  }

  if (! ((cdr ) == (scheme_null ) ) || (pair_type == - 1 ) ) {
#   define XfOrM539_COUNT (0+XfOrM537_COUNT)
#   define SETUP_XfOrM539(x) SETUP_XfOrM537(x)

# 3717 "bc/src/print.c"
    if (! compact ) {
#     define XfOrM540_COUNT (0+XfOrM539_COUNT)
#     define SETUP_XfOrM540(x) SETUP_XfOrM539(x)

# 3718 "bc/src/print.c"
      if (notdisplay == 3 )
        FUNCCALL(SETUP_XfOrM540(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
      else FUNCCALL(SETUP_XfOrM540(_), print_utf8_string (pp , " . " , 0 , 3 ) )
      ; 
    }
    FUNCCALL(SETUP_XfOrM539(_), print (cdr , notdisplay , compact , ht , mt , pp ) ); 
  }

# 3724 "bc/src/print.c"
  else if (compact && (super_compact < 1 ) )
    FUNCCALL(SETUP_XfOrM537(_), print_this_string (pp , & compacts [CPT_NULL ] , 0 , 1 ) ); 

  if (! compact ) {
#   define XfOrM538_COUNT (0+XfOrM537_COUNT)
#   define SETUP_XfOrM538(x) SETUP_XfOrM537(x)

# 3728 "bc/src/print.c"
    if (round_parens )
      FUNCCALL(SETUP_XfOrM538(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    else FUNCCALL_EMPTY(print_utf8_string (pp , "}" , 0 , 1 ) )
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1 "bc/src/print_vector.inc"
static void 
print_vector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) 
{
  int i , size , common = 0 ; 
  Scheme_Object * * elems ; 
  Scheme_Object * elem ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(elem, 1), PUSH(ht, 2), PUSH(mt, 3), PUSH(vec, 4), PUSH(elems, 5)));
# define XfOrM568_COUNT (6)
# define SETUP_XfOrM568(x) SETUP(XfOrM568_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  elems = NULLED_OUT ; 
  elem = NULLED_OUT ; 

# 13 "bc/src/print_vector.inc"
  do {

# 13 "bc/src/print_vector.inc"
    if ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 

# 13 "bc/src/print_vector.inc"
    size = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

# 13 "bc/src/print_vector.inc"
    else size = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) -> size ) ; 
  }

# 13 "bc/src/print_vector.inc"
  while (0 ) ; 
  if (compact ) {
#   define XfOrM591_COUNT (0+XfOrM568_COUNT)
#   define SETUP_XfOrM591(x) SETUP_XfOrM568(x)

# 15 "bc/src/print_vector.inc"
    do {
#     define XfOrM593_COUNT (0+XfOrM591_COUNT)
#     define SETUP_XfOrM593(x) SETUP_XfOrM591(x)
      FUNCCALL(SETUP_XfOrM593(_), print_this_string (pp , & compacts [CPT_VECTOR ] , 0 , 1 ) )
# 15 "bc/src/print_vector.inc"
      ; 
      FUNCCALL(SETUP_XfOrM593(_), print_compact_number (pp , size ) )
# 15 "bc/src/print_vector.inc"
      ; 
    }

# 15 "bc/src/print_vector.inc"
    while (0 ) ; 
  }

# 16 "bc/src/print_vector.inc"
  else {
#   define XfOrM581_COUNT (0+XfOrM568_COUNT)
#   define SETUP_XfOrM581(x) SETUP_XfOrM568(x)

# 17 "bc/src/print_vector.inc"
    do {

# 17 "bc/src/print_vector.inc"
      if ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 

# 17 "bc/src/print_vector.inc"
      elems = (((Scheme_Vector * ) (vec ) ) -> els ) ; 

# 17 "bc/src/print_vector.inc"
      else elems = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) -> els ) ; 
    }

# 17 "bc/src/print_vector.inc"
    while (0 ) ; 
    for (i = size ; i -- ; common ++ ) {
      if (! i || (elems [i ] != elems [i - 1 ] ) )
        break ; 
    }
    elems = ((void * ) 0 ) ; 

    if (as_prefab ) {
#     define XfOrM586_COUNT (0+XfOrM581_COUNT)
#     define SETUP_XfOrM586(x) SETUP_XfOrM581(x)
      FUNCCALL(SETUP_XfOrM586(_), print_utf8_string (pp , "#s(" , 0 , 3 ) )
# 25 "bc/src/print_vector.inc"
      ; 
    }

# 26 "bc/src/print_vector.inc"
    else if (notdisplay && pp -> print_vec_shorthand && (notdisplay != 3 ) ) {
#     define XfOrM583_COUNT (0+XfOrM581_COUNT)
#     define SETUP_XfOrM583(x) SETUP_XfOrM581(x)

# 27 "bc/src/print_vector.inc"
      if (size == 0 ) {
#       define XfOrM585_COUNT (0+XfOrM583_COUNT)
#       define SETUP_XfOrM585(x) SETUP_XfOrM583(x)
        FUNCCALL(SETUP_XfOrM585(_), print_utf8_string (pp , "#0(" , 0 , 3 ) )
# 28 "bc/src/print_vector.inc"
        ; 
      }

# 29 "bc/src/print_vector.inc"
      else {
        char buffer [100 ] ; 
#       define XfOrM584_COUNT (0+XfOrM583_COUNT)
#       define SETUP_XfOrM584(x) SETUP_XfOrM583(x)
        (
# 31 "bc/src/print_vector.inc"
        sprintf (buffer , "#%d(" , size ) ) ; 
        FUNCCALL(SETUP_XfOrM584(_), print_utf8_string (pp , buffer , 0 , - 1 ) ); 
        size -= common ; 
      }
    }

# 35 "bc/src/print_vector.inc"
    else if (notdisplay == 3 ) {
#     define XfOrM582_COUNT (0+XfOrM581_COUNT)
#     define SETUP_XfOrM582(x) SETUP_XfOrM581(x)
      FUNCCALL(SETUP_XfOrM582(_), print_utf8_string (pp , "(vector" , 0 , 7 ) )
# 36 "bc/src/print_vector.inc"
      ; 
      if (size )
        FUNCCALL(SETUP_XfOrM582(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }

# 39 "bc/src/print_vector.inc"
    else FUNCCALL(SETUP_XfOrM581(_), print_utf8_string (pp , "#(" , 0 , 2 ) )
    ; 
  }

  for (i = 0 ; i < size ; i ++ ) {
#   define XfOrM575_COUNT (0+XfOrM568_COUNT)
#   define SETUP_XfOrM575(x) SETUP_XfOrM568(x)

# 44 "bc/src/print_vector.inc"
    do {
#     define XfOrM580_COUNT (0+XfOrM575_COUNT)
#     define SETUP_XfOrM580(x) SETUP_XfOrM575(x)

# 44 "bc/src/print_vector.inc"
      if ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 

# 44 "bc/src/print_vector.inc"
      elem = (((Scheme_Vector * ) (vec ) ) -> els ) [i ] ; 

# 44 "bc/src/print_vector.inc"
      else elem = FUNCCALL(SETUP_XfOrM580(_), scheme_chaperone_vector_ref (vec , i ) ); 
    }

# 44 "bc/src/print_vector.inc"
    while (0 ) ; 
    do {
#     define XfOrM578_COUNT (0+XfOrM575_COUNT)
#     define SETUP_XfOrM578(x) SETUP_XfOrM575(x)
      FUNCCALL(SETUP_XfOrM578(_), print (elem , notdisplay , compact , ht , mt , pp ) )
# 45 "bc/src/print_vector.inc"
      ; 
    }

# 45 "bc/src/print_vector.inc"
    while (0 ) ; 
    if (i < (size - 1 ) ) {
#     define XfOrM576_COUNT (0+XfOrM575_COUNT)
#     define SETUP_XfOrM576(x) SETUP_XfOrM575(x)

# 47 "bc/src/print_vector.inc"
      if (! compact )
        FUNCCALL(SETUP_XfOrM576(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }
  }

  if (! compact )
    FUNCCALL_EMPTY(print_utf8_string (pp , ")" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1 "bc/src/print_vector.inc"
static void 
print_flvector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) 
{
  int i , size , common = 0 ; 
  double * elems ; 
  double elem ; 
  int used_buffer = 0 ; 

# 11 "bc/src/print_vector.inc"
  char buffer [100 ] ; 
  char * __funcarg107 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(ht, 1), PUSH(mt, 2), PUSH(vec, 3), PUSH(elems, 4)));
# define XfOrM596_COUNT (5)
# define SETUP_XfOrM596(x) SETUP(XfOrM596_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  elems = NULLED_OUT ; 

# 13 "bc/src/print_vector.inc"
  size = (((Scheme_Double_Vector * ) (vec ) ) -> size ) ; 
  if (compact ) {
#   define XfOrM613_COUNT (0+XfOrM596_COUNT)
#   define SETUP_XfOrM613(x) SETUP_XfOrM596(x)

# 15 "bc/src/print_vector.inc"
    do {
#     define XfOrM615_COUNT (0+XfOrM613_COUNT)
#     define SETUP_XfOrM615(x) SETUP_XfOrM613(x)
      FUNCCALL(SETUP_XfOrM615(_), print_escaped (pp , notdisplay , vec , ht , mt , 1 ) )
# 15 "bc/src/print_vector.inc"
      ; 

# 15 "bc/src/print_vector.inc"
      RET_NOTHING ; 
    }

# 15 "bc/src/print_vector.inc"
    while (0 ) ; 
  }

# 16 "bc/src/print_vector.inc"
  else {
#   define XfOrM605_COUNT (0+XfOrM596_COUNT)
#   define SETUP_XfOrM605(x) SETUP_XfOrM596(x)

# 17 "bc/src/print_vector.inc"
    elems = (((Scheme_Double_Vector * ) (vec ) ) -> els ) ; 
    for (i = size ; i -- ; common ++ ) {
      if (! i || (elems [i ] != elems [i - 1 ] ) )
        break ; 
    }
    elems = ((void * ) 0 ) ; 

    if (as_prefab ) {
#     define XfOrM610_COUNT (0+XfOrM605_COUNT)
#     define SETUP_XfOrM610(x) SETUP_XfOrM605(x)
      FUNCCALL(SETUP_XfOrM610(_), print_utf8_string (pp , "#s(" , 0 , 3 ) )
# 25 "bc/src/print_vector.inc"
      ; 
    }

# 26 "bc/src/print_vector.inc"
    else if (notdisplay && pp -> print_vec_shorthand && (notdisplay != 3 ) ) {
#     define XfOrM607_COUNT (0+XfOrM605_COUNT)
#     define SETUP_XfOrM607(x) SETUP_XfOrM605(x)

# 27 "bc/src/print_vector.inc"
      if (size == 0 ) {
#       define XfOrM609_COUNT (0+XfOrM607_COUNT)
#       define SETUP_XfOrM609(x) SETUP_XfOrM607(x)
        FUNCCALL(SETUP_XfOrM609(_), print_utf8_string (pp , "#fl0(" , 0 , 5 ) )
# 28 "bc/src/print_vector.inc"
        ; 
      }

# 29 "bc/src/print_vector.inc"
      else {
        char buffer [100 ] ; 
#       define XfOrM608_COUNT (0+XfOrM607_COUNT)
#       define SETUP_XfOrM608(x) SETUP_XfOrM607(x)
        (
# 31 "bc/src/print_vector.inc"
        sprintf (buffer , "#fl%d(" , size ) ) ; 
        FUNCCALL(SETUP_XfOrM608(_), print_utf8_string (pp , buffer , 0 , - 1 ) ); 
        size -= common ; 
      }
    }

# 35 "bc/src/print_vector.inc"
    else if (notdisplay == 3 ) {
#     define XfOrM606_COUNT (0+XfOrM605_COUNT)
#     define SETUP_XfOrM606(x) SETUP_XfOrM605(x)
      FUNCCALL(SETUP_XfOrM606(_), print_utf8_string (pp , "(flvector" , 0 , 9 ) )
# 36 "bc/src/print_vector.inc"
      ; 
      if (size )
        FUNCCALL(SETUP_XfOrM606(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }

# 39 "bc/src/print_vector.inc"
    else FUNCCALL(SETUP_XfOrM605(_), print_utf8_string (pp , "#fl(" , 0 , 4 ) )
    ; 
  }

  for (i = 0 ; i < size ; i ++ ) {
#   define XfOrM601_COUNT (0+XfOrM596_COUNT)
#   define SETUP_XfOrM601(x) SETUP_XfOrM596(x)

# 44 "bc/src/print_vector.inc"
    elem = (((Scheme_Double_Vector * ) (vec ) ) -> els ) [i ] ; 
    do {
#     define XfOrM604_COUNT (0+XfOrM601_COUNT)
#     define SETUP_XfOrM604(x) SETUP_XfOrM601(x)
      (__funcarg107 = FUNCCALL(SETUP_XfOrM604(_), scheme_double_to_string (elem , buffer , 100 , 0 , & used_buffer ) )
# 45 "bc/src/print_vector.inc"
      , FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg107 , 0 , - 1 ) )) ; 
    }

# 45 "bc/src/print_vector.inc"
    while (0 ) ; 
    if (i < (size - 1 ) ) {
#     define XfOrM602_COUNT (0+XfOrM601_COUNT)
#     define SETUP_XfOrM602(x) SETUP_XfOrM601(x)

# 47 "bc/src/print_vector.inc"
      if (! compact )
        FUNCCALL(SETUP_XfOrM602(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }
  }

  if (! compact )
    FUNCCALL_EMPTY(print_utf8_string (pp , ")" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1 "bc/src/print_vector.inc"
static void 
print_fxvector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) 
{
  int i , size , common = 0 ; 
  Scheme_Object * * elems ; 
  Scheme_Object * elem ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(elem, 1), PUSH(ht, 2), PUSH(mt, 3), PUSH(vec, 4), PUSH(elems, 5)));
# define XfOrM616_COUNT (6)
# define SETUP_XfOrM616(x) SETUP(XfOrM616_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  elems = NULLED_OUT ; 
  elem = NULLED_OUT ; 

# 13 "bc/src/print_vector.inc"
  size = (((Scheme_Vector * ) (vec ) ) -> size ) ; 
  if (compact ) {
#   define XfOrM633_COUNT (0+XfOrM616_COUNT)
#   define SETUP_XfOrM633(x) SETUP_XfOrM616(x)

# 15 "bc/src/print_vector.inc"
    do {
#     define XfOrM635_COUNT (0+XfOrM633_COUNT)
#     define SETUP_XfOrM635(x) SETUP_XfOrM633(x)
      FUNCCALL(SETUP_XfOrM635(_), print_escaped (pp , notdisplay , vec , ht , mt , 1 ) )
# 15 "bc/src/print_vector.inc"
      ; 

# 15 "bc/src/print_vector.inc"
      RET_NOTHING ; 
    }

# 15 "bc/src/print_vector.inc"
    while (0 ) ; 
  }

# 16 "bc/src/print_vector.inc"
  else {
#   define XfOrM625_COUNT (0+XfOrM616_COUNT)
#   define SETUP_XfOrM625(x) SETUP_XfOrM616(x)

# 17 "bc/src/print_vector.inc"
    elems = (((Scheme_Vector * ) (vec ) ) -> els ) ; 
    for (i = size ; i -- ; common ++ ) {
      if (! i || (elems [i ] != elems [i - 1 ] ) )
        break ; 
    }
    elems = ((void * ) 0 ) ; 

    if (as_prefab ) {
#     define XfOrM630_COUNT (0+XfOrM625_COUNT)
#     define SETUP_XfOrM630(x) SETUP_XfOrM625(x)
      FUNCCALL(SETUP_XfOrM630(_), print_utf8_string (pp , "#s(" , 0 , 3 ) )
# 25 "bc/src/print_vector.inc"
      ; 
    }

# 26 "bc/src/print_vector.inc"
    else if (notdisplay && pp -> print_vec_shorthand && (notdisplay != 3 ) ) {
#     define XfOrM627_COUNT (0+XfOrM625_COUNT)
#     define SETUP_XfOrM627(x) SETUP_XfOrM625(x)

# 27 "bc/src/print_vector.inc"
      if (size == 0 ) {
#       define XfOrM629_COUNT (0+XfOrM627_COUNT)
#       define SETUP_XfOrM629(x) SETUP_XfOrM627(x)
        FUNCCALL(SETUP_XfOrM629(_), print_utf8_string (pp , "#fx0(" , 0 , 5 ) )
# 28 "bc/src/print_vector.inc"
        ; 
      }

# 29 "bc/src/print_vector.inc"
      else {
        char buffer [100 ] ; 
#       define XfOrM628_COUNT (0+XfOrM627_COUNT)
#       define SETUP_XfOrM628(x) SETUP_XfOrM627(x)
        (
# 31 "bc/src/print_vector.inc"
        sprintf (buffer , "#fx%d(" , size ) ) ; 
        FUNCCALL(SETUP_XfOrM628(_), print_utf8_string (pp , buffer , 0 , - 1 ) ); 
        size -= common ; 
      }
    }

# 35 "bc/src/print_vector.inc"
    else if (notdisplay == 3 ) {
#     define XfOrM626_COUNT (0+XfOrM625_COUNT)
#     define SETUP_XfOrM626(x) SETUP_XfOrM625(x)
      FUNCCALL(SETUP_XfOrM626(_), print_utf8_string (pp , "(fxvector" , 0 , 9 ) )
# 36 "bc/src/print_vector.inc"
      ; 
      if (size )
        FUNCCALL(SETUP_XfOrM626(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }

# 39 "bc/src/print_vector.inc"
    else FUNCCALL(SETUP_XfOrM625(_), print_utf8_string (pp , "#fx(" , 0 , 4 ) )
    ; 
  }

  for (i = 0 ; i < size ; i ++ ) {
#   define XfOrM621_COUNT (0+XfOrM616_COUNT)
#   define SETUP_XfOrM621(x) SETUP_XfOrM616(x)

# 44 "bc/src/print_vector.inc"
    elem = (((Scheme_Vector * ) (vec ) ) -> els ) [i ] ; 
    do {
#     define XfOrM624_COUNT (0+XfOrM621_COUNT)
#     define SETUP_XfOrM624(x) SETUP_XfOrM621(x)
      FUNCCALL(SETUP_XfOrM624(_), print (elem , notdisplay , compact , ht , mt , pp ) )
# 45 "bc/src/print_vector.inc"
      ; 
    }

# 45 "bc/src/print_vector.inc"
    while (0 ) ; 
    if (i < (size - 1 ) ) {
#     define XfOrM622_COUNT (0+XfOrM621_COUNT)
#     define SETUP_XfOrM622(x) SETUP_XfOrM621(x)

# 47 "bc/src/print_vector.inc"
      if (! compact )
        FUNCCALL(SETUP_XfOrM622(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }
  }

  if (! compact )
    FUNCCALL_EMPTY(print_utf8_string (pp , ")" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3810 "bc/src/print.c"
static void 
print_char (Scheme_Object * charobj , int notdisplay , PrintParams * pp ) 
{
  int ch ; 
  char minibuf [10 + 6 ] , * str ; 
  int len = - 1 ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(str, 1)));
# define XfOrM636_COUNT (2)
# define SETUP_XfOrM636(x) SETUP(XfOrM636_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  str = NULLED_OUT ; 

# 3817 "bc/src/print.c"
  ch = (((Scheme_Small_Object * ) (charobj ) ) -> u . char_val ) ; 
  if (notdisplay ) {
#   define XfOrM638_COUNT (0+XfOrM636_COUNT)
#   define SETUP_XfOrM638(x) SETUP_XfOrM636(x)

# 3819 "bc/src/print.c"
    switch (ch ) 
    {
#     define XfOrM639_COUNT (0+XfOrM638_COUNT)
#     define SETUP_XfOrM639(x) SETUP_XfOrM638(x)

# 3821 "bc/src/print.c"
      case '\0' : 
      str = "#\\nul" ; 
      break ; 
      case '\n' : 
      str = "#\\newline" ; 
      break ; 
      case '\t' : 
      str = "#\\tab" ; 
      break ; 
      case 0xb : 
      str = "#\\vtab" ; 
      break ; 
      case ' ' : 
      str = "#\\space" ; 
      break ; 
      case '\r' : 
      str = "#\\return" ; 
      break ; 
      case '\f' : 
      str = "#\\page" ; 
      break ; 
      case '\b' : 
      str = "#\\backspace" ; 
      break ; 
      case 0x7f : 
      str = "#\\rubout" ; 
      break ; 
      default : 
      if (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x800 )  {
#       define XfOrM641_COUNT (0+XfOrM639_COUNT)
#       define SETUP_XfOrM641(x) SETUP_XfOrM639(x)

# 3850 "bc/src/print.c"
        minibuf [0 ] = '#' ; 
        minibuf [1 ] = '\\' ; 
        ch = FUNCCALL(SETUP_XfOrM641(_), scheme_utf8_encode ((unsigned int * ) & ch , 0 , 1 , (unsigned char * ) minibuf , 2 , 0 ) )

        ; 
        minibuf [2 + ch ] = 0 ; 
      }

# 3856 "bc/src/print.c"
      else {
#       define XfOrM640_COUNT (0+XfOrM639_COUNT)
#       define SETUP_XfOrM640(x) SETUP_XfOrM639(x)

# 3857 "bc/src/print.c"
        if (ch > 0xFFFF )
          (sprintf (minibuf , "#\\U%.8X" , ch ) ) ; 
        else (
        sprintf (minibuf , "#\\u%.4X" , ch ) ) ; 
      }
      str = minibuf ; 
      break ; 
    }
  }

# 3865 "bc/src/print.c"
  else {
#   define XfOrM637_COUNT (0+XfOrM636_COUNT)
#   define SETUP_XfOrM637(x) SETUP_XfOrM636(x)

# 3866 "bc/src/print.c"
    len = FUNCCALL(SETUP_XfOrM637(_), scheme_utf8_encode ((unsigned int * ) & ch , 0 , 1 , (unsigned char * ) minibuf , 0 , 0 ) )

    ; 
    minibuf [len ] = 0 ; 
    str = minibuf ; 
  }
  FUNCCALL_EMPTY(print_utf8_string (pp , str , 0 , len ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3878 "bc/src/print.c"
Scheme_Object * scheme_protect_quote (Scheme_Object * expr ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(expr, 0)));
# define XfOrM642_COUNT (1)
# define SETUP_XfOrM642(x) SETUP(XfOrM642_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3880 "bc/src/print.c"
  if (((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_stencil_vector_type ) ) || (1 && (((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) || (0 ) || (0 ) || (1 && ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) expr ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (expr ) ) -> stype -> prefab_key ) ) || (1 && ((((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) expr ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? (((((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) expr ) -> val ) ) -> count ) : (((((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (expr ) ) -> count ) ) ) ) )  {
    Scheme_Object * q ; 
    BLOCK_SETUP((PUSH(q, 0+XfOrM642_COUNT)));
#   define XfOrM643_COUNT (1+XfOrM642_COUNT)
#   define SETUP_XfOrM643(x) SETUP(XfOrM643_COUNT)
    q = NULLED_OUT ; 

# 3882 "bc/src/print.c"
    q = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM643(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    q -> type = scheme_quote_compilation_type ; 
    (((Scheme_Small_Object * ) (q ) ) -> u . ptr_val ) = expr ; 
    RET_VALUE_START (q ) RET_VALUE_END ; 
  }

# 3886 "bc/src/print.c"
  else 
  RET_VALUE_START (expr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

void scheme_set_type_printer (Scheme_Type stype , Scheme_Type_Printer printer ) 
{
  PREPARE_VAR_STACK(1);
# define XfOrM644_COUNT (0)
# define SETUP_XfOrM644(x) SETUP(XfOrM644_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3896 "bc/src/print.c"
  if (! printers ) {
#   define XfOrM646_COUNT (0+XfOrM644_COUNT)
#   define SETUP_XfOrM646(x) SETUP_XfOrM644(x)
    FUNCCALL(SETUP_XfOrM646(_), scheme_register_static ((void * ) & printers , sizeof (printers ) ) )
# 3897 "bc/src/print.c"
    ; 
  }

  if (stype >= printers_count ) {
    Scheme_Type_Printer * naya ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM644_COUNT)));
#   define XfOrM645_COUNT (1+XfOrM644_COUNT)
#   define SETUP_XfOrM645(x) SETUP(XfOrM645_COUNT)
    naya = NULLED_OUT ; 

# 3902 "bc/src/print.c"
    naya = ((Scheme_Type_Printer * ) FUNCCALL(SETUP_XfOrM645(_), GC_malloc (sizeof (Scheme_Type_Printer ) * (stype + 10 ) ) )) ; 
    (memset (naya , 0 , sizeof (Scheme_Type_Printer ) * (stype + 10 ) ) ) ; 
    if (printers_count )
      (memcpy (naya , printers , sizeof (Scheme_Type_Printer ) * printers_count ) ) ; 
    printers_count = stype + 10 ; 
    printers = naya ; 
  }

  printers [stype ] = printer ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * callback_write (void * _p , int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * p = (Scheme_Object * ) _p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM647_COUNT (1)
# define SETUP_XfOrM647(x) SETUP(XfOrM647_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3921 "bc/src/print.c"
  if ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * v = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . car ) ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM647_COUNT)));
#   define XfOrM648_COUNT (1+XfOrM647_COUNT)
#   define SETUP_XfOrM648(x) SETUP(XfOrM648_COUNT)

# 3923 "bc/src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
      int cb_mode = (((intptr_t ) ((((Scheme_Vector * ) (v ) ) -> els ) [0 ] ) ) >> 1 ) ; 
      Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) ((((Scheme_Vector * ) (v ) ) -> els ) [1 ] ) ; 
      int * counter = (int * ) (((Scheme_Simple_Object * ) ((((Scheme_Vector * ) (v ) ) -> els ) [2 ] ) ) -> u . pair_val . car ) ; 
      PrintParams * pp = (PrintParams * ) (((Scheme_Simple_Object * ) ((((Scheme_Vector * ) (v ) ) -> els ) [2 ] ) ) -> u . pair_val . cdr ) ; 
      int mode = (((intptr_t ) ((((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ) ) >> 1 ) ; 
      BLOCK_SETUP((PUSH(pp, 0+XfOrM648_COUNT), PUSH(ht, 1+XfOrM648_COUNT), PUSH(counter, 2+XfOrM648_COUNT)));
#     define XfOrM649_COUNT (3+XfOrM648_COUNT)
#     define SETUP_XfOrM649(x) SETUP(XfOrM649_COUNT)

# 3930 "bc/src/print.c"
      if (argc > 2 )
        mode += (((intptr_t ) (argv [2 ] ) ) >> 1 ) ; 

      if (cb_mode == 1 ) {
        int res ; 
#       define XfOrM651_COUNT (0+XfOrM649_COUNT)
#       define SETUP_XfOrM651(x) SETUP_XfOrM649(x)

# 3935 "bc/src/print.c"
        res = FUNCCALL(SETUP_XfOrM651(_), check_cycles (argv [0 ] , mode , ht , pp ) ); 
        (((Scheme_Vector * ) (v ) ) -> els ) [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (res | (((intptr_t ) ((((Scheme_Vector * ) (v ) ) -> els ) [3 ] ) ) >> 1 ) ) ) ) << 1 ) | 0x1 ) ) ; 
      }

# 3937 "bc/src/print.c"
      else {
#       define XfOrM650_COUNT (0+XfOrM649_COUNT)
#       define SETUP_XfOrM650(x) SETUP_XfOrM649(x)
        FUNCCALL_EMPTY(setup_graph_table (argv [0 ] , mode , ht , counter , pp ) )
# 3938 "bc/src/print.c"
        ; 
      }
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3947 "bc/src/print.c"
static int writable_struct_subs (Scheme_Object * s , int for_write , PrintParams * pp , 
int mode , Scheme_Hash_Table * ht , int * counter ) 
{
  Scheme_Object * v , * o , * a [3 ] , * cb , * pr ; 
  Scheme_Object * d_callback_proc , * w_callback_proc , * p_callback_proc ; 
  Scheme_Output_Port * op ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(p_callback_proc, 0), PUSH(cb, 1), PUSH(pp, 2), PUSH(op, 3), PUSH(pr, 4), PUSH(d_callback_proc, 5), PUSH(ht, 6), PUSH(counter, 7), PUSH(s, 8), PUSH(v, 9), PUSH(w_callback_proc, 10), PUSH(o, 11), PUSHARRAY(a, 3, 12)));
# define XfOrM652_COUNT (15)
# define SETUP_XfOrM652(x) SETUP(XfOrM652_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  o = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  cb = NULLED_OUT ; 
  pr = NULLED_OUT ; 
  d_callback_proc = NULLED_OUT ; 
  w_callback_proc = NULLED_OUT ; 
  p_callback_proc = NULLED_OUT ; 
  op = NULLED_OUT ; 

# 3954 "bc/src/print.c"
  if (for_write >= 3 ) {
    Scheme_Object * kind ; 
    BLOCK_SETUP((PUSH(kind, 0+XfOrM652_COUNT)));
#   define XfOrM653_COUNT (1+XfOrM652_COUNT)
#   define SETUP_XfOrM653(x) SETUP(XfOrM653_COUNT)
    kind = NULLED_OUT ; 

# 3956 "bc/src/print.c"
    kind = FUNCCALL(SETUP_XfOrM653(_), scheme_print_attribute_ref (s ) ); 
    if (kind && ! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "always" ) ) )
      for_write = 4 ; 
  }

  v = FUNCCALL(SETUP_XfOrM652(_), scheme_is_writable_struct (s ) ); 

  o = FUNCCALL(SETUP_XfOrM652(_), scheme_make_null_output_port (pp -> print_port && ((Scheme_Output_Port * ) pp -> print_port ) -> write_special_fun ) )
  ; 

  op = (Scheme_Output_Port * ) o ; 

  cb = FUNCCALL(SETUP_XfOrM652(_), scheme_make_vector (4 , ((void * ) 0 ) ) ); 
  (((Scheme_Vector * ) (cb ) ) -> els ) [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (mode ) ) ) << 1 ) | 0x1 ) ) ; 
  (((Scheme_Vector * ) (cb ) ) -> els ) [1 ] = (Scheme_Object * ) ht ; 
  pr = FUNCCALL(SETUP_XfOrM652(_), scheme_make_raw_pair ((Scheme_Object * ) counter , (Scheme_Object * ) pp ) ); 
  (((Scheme_Vector * ) (cb ) ) -> els ) [2 ] = pr ; 
  (((Scheme_Vector * ) (cb ) ) -> els ) [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

  d_callback_proc = (__funcarg110 = FUNCCALL(SETUP_XfOrM652(_), scheme_make_pair (cb , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) )
  , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (callback_write , __funcarg110 , "custom-display-recur-handler" , 2 , 2 ) )) 

  ; 
  w_callback_proc = (__funcarg109 = FUNCCALL(SETUP_XfOrM652(_), scheme_make_pair (cb , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) )
  , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (callback_write , __funcarg109 , "custom-write-recur-handler" , 2 , 2 ) )) 

  ; 
  p_callback_proc = (__funcarg108 = FUNCCALL(SETUP_XfOrM652(_), scheme_make_pair (cb , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (3 ) ) ) << 1 ) | 0x1 ) ) ) )
  , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (callback_write , __funcarg108 , "custom-print-recur-handler" , 2 , 3 ) )) 

  ; 

  op -> display_handler = d_callback_proc ; 
  op -> write_handler = w_callback_proc ; 
  op -> print_handler = p_callback_proc ; 

  a [0 ] = s ; 
  a [1 ] = o ; 
  a [2 ] = (for_write 
  ? ((for_write >= 3 ) 
  ? ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (for_write - 3 ) ) ) << 1 ) | 0x1 ) ) 
  : scheme_true ) 
  : scheme_false ) ; 
  FUNCCALL(SETUP_XfOrM652(_), scheme_apply_multi (v , 3 , a ) )
  ; 
  FUNCCALL_AGAIN(scheme_close_output_port (o ) )
  ; 

  RET_VALUE_START ((((intptr_t ) ((((Scheme_Vector * ) (cb ) ) -> els ) [3 ] ) ) >> 1 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4007 "bc/src/print.c"
static void flush_from_byte_port (Scheme_Object * orig_port , PrintParams * pp ) 
{
  char * bytes ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(bytes, 1)));
# define XfOrM654_COUNT (2)
# define SETUP_XfOrM654(x) SETUP(XfOrM654_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  bytes = NULLED_OUT ; 

# 4011 "bc/src/print.c"
  bytes = FUNCCALL(SETUP_XfOrM654(_), scheme_get_sized_byte_string_output (orig_port , & len ) ); 
  FUNCCALL_EMPTY(print_this_string (pp , bytes , 0 , len ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4015 "bc/src/print.c"
static Scheme_Object * custom_recur (int notdisplay , void * _vec , int argc , Scheme_Object * * argv ) 
{
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [0 ] ; 
  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [1 ] ; 
  PrintParams * volatile pp = (PrintParams * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [2 ] , * sub_pp ; 
  Scheme_Object * volatile save_port ; 
  mz_jmp_buf escape , * volatile save ; 
  volatile intptr_t save_max ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(sub_pp, 0), PUSH(save_port, 1), PUSH(_vec, 2), PUSH(save, 3), PUSH(pp, 4), PUSH(ht, 5), PUSH(mt, 6), PUSH(argv, 7)));
# define XfOrM655_COUNT (8)
# define SETUP_XfOrM655(x) SETUP(XfOrM655_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  sub_pp = NULLED_OUT ; 
  save_port = NULLED_OUT ; 
  save = NULLED_OUT ; 

# 4024 "bc/src/print.c"
  if (! (scheme_is_output_port (argv [1 ] ) ) ) {
#   define XfOrM669_COUNT (0+XfOrM655_COUNT)
#   define SETUP_XfOrM669(x) SETUP_XfOrM655(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ((notdisplay > 1 ) ? "print/recursive" : (notdisplay ? "write/recursive" : "display/recursive" ) , "output-port?" , 1 , argc , argv ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if ((((Scheme_Vector * ) (_vec ) ) -> els ) [3 ] ) {
#   define XfOrM656_COUNT (0+XfOrM655_COUNT)
#   define SETUP_XfOrM656(x) SETUP_XfOrM655(x)

# 4034 "bc/src/print.c"
    {
#     define XfOrM657_COUNT (0+XfOrM656_COUNT)
#     define SETUP_XfOrM657(x) SETUP_XfOrM656(x)

# 4035 "bc/src/print.c"
      if (pp -> print_escape ) {
        save = pp -> print_escape ; 
        pp -> print_escape = & escape ; 
      }

# 4038 "bc/src/print.c"
      else 
      save = ((void * ) 0 ) ; 

      save_port = pp -> print_port ; 
      save_max = pp -> print_maxlen ; 

      if (! pp -> print_escape 
      || ! ((escape ) . gcvs = (intptr_t ) __gc_var_stack__ , (escape ) . gcvs_cnt = XfOrM657_COUNT , (_setjmp ((escape ) . jb ) ) ) ) {

        Scheme_Object * sp ; 
        BLOCK_SETUP((PUSH(sp, 0+XfOrM657_COUNT)));
#       define XfOrM658_COUNT (1+XfOrM657_COUNT)
#       define SETUP_XfOrM658(x) SETUP(XfOrM658_COUNT)
        sp = NULLED_OUT ; 

# 4048 "bc/src/print.c"
        sp = (((Scheme_Vector * ) (_vec ) ) -> els ) [4 ] ; 
        if (sp ) {
#         define XfOrM667_COUNT (0+XfOrM658_COUNT)
#         define SETUP_XfOrM667(x) SETUP_XfOrM658(x)
          FUNCCALL(SETUP_XfOrM667(_), flush_from_byte_port (sp , pp ) )
# 4050 "bc/src/print.c"
          ; 
          sp = FUNCCALL(SETUP_XfOrM667(_), scheme_make_byte_string_output_port () ); 
          ((Scheme_Output_Port * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [5 ] ) -> port_data = sp ; 
          (((Scheme_Vector * ) (_vec ) ) -> els ) [4 ] = sp ; 
        }



        if (! ((save_port ) == (argv [1 ] ) ) ) {
#         define XfOrM666_COUNT (0+XfOrM658_COUNT)
#         define SETUP_XfOrM666(x) SETUP_XfOrM658(x)
          FUNCCALL(SETUP_XfOrM666(_), print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) )
# 4059 "bc/src/print.c"
          ; 



          pp -> print_maxlen = 0 ; 
        }

        pp -> print_port = argv [1 ] ; 

        if (notdisplay > 1 ) {
#         define XfOrM665_COUNT (0+XfOrM658_COUNT)
#         define SETUP_XfOrM665(x) SETUP_XfOrM658(x)
          FUNCCALL(SETUP_XfOrM665(_), print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) ); 
        }

        if (notdisplay > 1 ) {
#         define XfOrM659_COUNT (0+XfOrM658_COUNT)
#         define SETUP_XfOrM659(x) SETUP_XfOrM658(x)

# 4075 "bc/src/print.c"
          if (argc > 2 ) {
            Scheme_Object * qq_depth = argv [2 ] ; 
            BLOCK_SETUP((PUSH(qq_depth, 0+XfOrM659_COUNT)));
#           define XfOrM662_COUNT (1+XfOrM659_COUNT)
#           define SETUP_XfOrM662(x) SETUP(XfOrM662_COUNT)

# 4077 "bc/src/print.c"
            if (! FUNCCALL(SETUP_XfOrM662(_), scheme_nonneg_exact_p (qq_depth ) ))
              FUNCCALL_EMPTY(scheme_wrong_contract ("print/recursive" , "exact-nonnegative-integer?" , 2 , argc , argv ) ); 
            sub_pp = FUNCCALL(SETUP_XfOrM662(_), copy_print_params (pp ) ); 
            if (FUNCCALL(SETUP_XfOrM662(_), scheme_bin_gt (qq_depth , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((1 << 29 ) ) ) ) << 1 ) | 0x1 ) ) ) )) {
#             define XfOrM664_COUNT (0+XfOrM662_COUNT)
#             define SETUP_XfOrM664(x) SETUP_XfOrM662(x)

# 4081 "bc/src/print.c"
              notdisplay = 3 + (1 << 29 ) ; 
              qq_depth = FUNCCALL(SETUP_XfOrM664(_), scheme_bin_minus (qq_depth , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((1 << 29 ) ) ) ) << 1 ) | 0x1 ) ) ) ); 
              sub_pp -> depth_delta = qq_depth ; 
            }

# 4084 "bc/src/print.c"
            else {
              sub_pp -> depth_delta = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
              notdisplay = 3 + (((intptr_t ) (qq_depth ) ) >> 1 ) ; 
            }
          }

# 4088 "bc/src/print.c"
          else if (pp -> depth_delta ) {
#           define XfOrM660_COUNT (0+XfOrM659_COUNT)
#           define SETUP_XfOrM660(x) SETUP_XfOrM659(x)

# 4089 "bc/src/print.c"
            notdisplay = 3 ; 
            if (! ((pp -> depth_delta ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) ) {
#             define XfOrM661_COUNT (0+XfOrM660_COUNT)
#             define SETUP_XfOrM661(x) SETUP_XfOrM660(x)

# 4091 "bc/src/print.c"
              sub_pp = FUNCCALL(SETUP_XfOrM661(_), copy_print_params (pp ) ); 
              sub_pp -> depth_delta = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
            }

# 4093 "bc/src/print.c"
            else 
            sub_pp = pp ; 
          }

# 4095 "bc/src/print.c"
          else 
          sub_pp = pp ; 
        }

# 4097 "bc/src/print.c"
        else 
        sub_pp = pp ; 
        FUNCCALL(SETUP_XfOrM658(_), print (argv [0 ] , notdisplay , 0 , ht , mt , sub_pp ) )

        ; 
        FUNCCALL_AGAIN(print_this_string (sub_pp , ((void * ) 0 ) , 0 , 0 ) )


        ; 
      }

      pp -> print_port = save_port ; 
      pp -> print_escape = save ; 
      pp -> print_maxlen = save_max ; 
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4117 "bc/src/print.c"
static Scheme_Object * custom_write_recur (void * _vec , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4119 "bc/src/print.c"
  return custom_recur (1 , _vec , argc , argv ) ; 
}

static Scheme_Object * custom_display_recur (void * _vec , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4124 "bc/src/print.c"
  return custom_recur (0 , _vec , argc , argv ) ; 
}

static Scheme_Object * custom_print_recur (void * _vec , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4129 "bc/src/print.c"
  return custom_recur (2 , _vec , argc , argv ) ; 
}

static void custom_write_struct (Scheme_Object * s , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * orig_pp , int notdisplay ) 
{
  Scheme_Object * v , * a [3 ] , * o , * vec , * orig_port ; 
  Scheme_Output_Port * op ; 
  Scheme_Object * recur_write , * recur_display , * recur_print ; 
  PrintParams * pp ; 
  PREPARE_VAR_STACK_ONCE(16);
  BLOCK_SETUP_TOP((PUSH(orig_port, 0), PUSH(op, 1), PUSH(pp, 2), PUSH(orig_pp, 3), PUSH(recur_write, 4), PUSH(mt, 5), PUSH(vec, 6), PUSH(ht, 7), PUSH(recur_display, 8), PUSH(s, 9), PUSH(v, 10), PUSH(recur_print, 11), PUSH(o, 12), PUSHARRAY(a, 3, 13)));
# define XfOrM673_COUNT (16)
# define SETUP_XfOrM673(x) SETUP(XfOrM673_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  o = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  orig_port = NULLED_OUT ; 
  op = NULLED_OUT ; 
  recur_write = NULLED_OUT ; 
  recur_display = NULLED_OUT ; 
  recur_print = NULLED_OUT ; 
  pp = NULLED_OUT ; 

# 4141 "bc/src/print.c"
  v = FUNCCALL(SETUP_XfOrM673(_), scheme_is_writable_struct (s ) ); 


  pp = FUNCCALL_AGAIN(copy_print_params (orig_pp ) ); 

  if (pp -> print_port )
    orig_port = pp -> print_port ; 
  else 
  orig_port = FUNCCALL(SETUP_XfOrM673(_), scheme_make_byte_string_output_port () ); 

  o = FUNCCALL(SETUP_XfOrM673(_), scheme_make_redirect_output_port (orig_port ) ); 

  op = (Scheme_Output_Port * ) o ; 

  vec = FUNCCALL(SETUP_XfOrM673(_), scheme_make_vector (6 , ((void * ) 0 ) ) ); 
  (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = (Scheme_Object * ) ht ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (Scheme_Object * ) mt ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = (Scheme_Object * ) pp ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = scheme_true ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [4 ] = (pp -> print_port ? ((void * ) 0 ) : orig_port ) ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [5 ] = o ; 

  recur_write = FUNCCALL(SETUP_XfOrM673(_), scheme_make_closed_prim_w_arity (custom_write_recur , vec , "custom-write-recur-handler" , 2 , 2 ) )


  ; 
  recur_display = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (custom_display_recur , vec , "custom-display-recur-handler" , 2 , 2 ) )


  ; 
  recur_print = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (custom_print_recur , vec , "custom-print-recur-handler" , 2 , 3 ) )


  ; 

  op -> write_handler = recur_write ; 
  op -> display_handler = recur_display ; 
  op -> print_handler = recur_print ; 



  if (pp -> print_port )
    FUNCCALL(SETUP_XfOrM673(_), print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) ); 

  a [0 ] = s ; 
  a [1 ] = o ; 
  if (notdisplay >= 3 ) {
#   define XfOrM674_COUNT (0+XfOrM673_COUNT)
#   define SETUP_XfOrM674(x) SETUP_XfOrM673(x)

# 4188 "bc/src/print.c"
    a [2 ] = FUNCCALL(SETUP_XfOrM674(_), scheme_bin_plus (pp -> depth_delta , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (notdisplay - 3 ) ) ) << 1 ) | 0x1 ) ) ) ); 
  }

# 4189 "bc/src/print.c"
  else 
  a [2 ] = (notdisplay ? scheme_true : scheme_false ) ; 
  FUNCCALL(SETUP_XfOrM673(_), scheme_apply_multi (v , 3 , a ) )
  ; 
  FUNCCALL_AGAIN(scheme_close_output_port (o ) )
  ; 
  (
  memcpy (orig_pp , pp , sizeof (PrintParams ) ) ) ; 

  (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = ((void * ) 0 ) ; 


  if (! orig_pp -> print_port )
    FUNCCALL(SETUP_XfOrM673(_), flush_from_byte_port ((((Scheme_Vector * ) (vec ) ) -> els ) [4 ] , orig_pp ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4205 "bc/src/print.c"
static Scheme_Object * srcloc_path_to_string (Scheme_Object * p ) 
{
  Scheme_Object * base , * name , * dir_name ; 
  int isdir ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(dir_name, 1), PUSH(base, 2), PUSH(name, 3), PUSH(__funcarg112, 4)));
# define XfOrM675_COUNT (5)
# define SETUP_XfOrM675(x) SETUP(XfOrM675_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  base = NULLED_OUT ; 
  name = NULLED_OUT ; 
  dir_name = NULLED_OUT ; 

# 4210 "bc/src/print.c"
  name = FUNCCALL(SETUP_XfOrM675(_), scheme_split_path ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) , & base , & isdir , scheme_unix_path_type ) ); 
  if ((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) (base ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (base ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#   define XfOrM677_COUNT (0+XfOrM675_COUNT)
#   define SETUP_XfOrM677(x) SETUP_XfOrM675(x)

# 4212 "bc/src/print.c"
    dir_name = FUNCCALL(SETUP_XfOrM677(_), scheme_split_path ((((Scheme_Simple_Object * ) (base ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (base ) ) -> u . byte_str_val . tag_val ) , & base , & isdir , scheme_unix_path_type ) ); 
    if (((base ) ) == (scheme_false ) )  {
#     define XfOrM679_COUNT (0+XfOrM677_COUNT)
#     define SETUP_XfOrM679(x) SETUP_XfOrM677(x)

# 4215 "bc/src/print.c"
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM679(_), scheme_path_to_char_string (p ) )) RET_VALUE_END ; 
    }
    if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
      name = FUNCCALL(SETUP_XfOrM677(_), scheme_path_to_char_string (name ) ); 
    else {
#     define XfOrM678_COUNT (0+XfOrM677_COUNT)
#     define SETUP_XfOrM678(x) SETUP_XfOrM677(x)

# 4221 "bc/src/print.c"
      if (! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) , "up" ) ) )
        name = FUNCCALL(SETUP_XfOrM678(_), scheme_make_utf8_string (".." ) ); 
      else 
      name = FUNCCALL(SETUP_XfOrM678(_), scheme_make_utf8_string ("." ) ); 
    }
    if ((Scheme_Type ) (((((intptr_t ) (dir_name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (dir_name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
      name = (__funcarg112 = FUNCCALL(SETUP_XfOrM677(_), scheme_path_to_char_string (dir_name ) ), __funcarg113 = (__funcarg114 = FUNCCALL(SETUP_XfOrM677(_), scheme_make_utf8_string ("/" ) )
    , FUNCCALL_AGAIN(scheme_append_strings (__funcarg114 , name ) )) , FUNCCALL_AGAIN(scheme_append_strings (__funcarg112 , __funcarg113 ) )) 
    ; 
    RET_VALUE_START ((__funcarg111 = FUNCCALL(SETUP_XfOrM677(_), scheme_make_utf8_string (".../" ) ), FUNCCALL_AGAIN(scheme_append_strings (__funcarg111 , name ) )) ) RET_VALUE_END ; 
  }

# 4231 "bc/src/print.c"
  else if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM675(_), scheme_path_to_char_string (name ) )) RET_VALUE_END ; 
  else {
#   define XfOrM676_COUNT (0+XfOrM675_COUNT)
#   define SETUP_XfOrM676(x) SETUP_XfOrM675(x)

# 4235 "bc/src/print.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM676(_), scheme_path_to_char_string (p ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "bc/src/mzmark_print.inc"
static int mark_print_params_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_print_params_MARK (void * p , struct NewGC * gc ) {

  PrintParams * pp = (PrintParams * ) p ; 
  GC_mark2 (& (pp -> inspector ) , gc ) ; 
  GC_mark2 (& (pp -> print_port ) , gc ) ; 
  GC_mark2 (& (pp -> print_buffer ) , gc ) ; 
  GC_mark2 (& (pp -> depth_delta ) , gc ) ; 
  GC_mark2 (& (pp -> uq_ht ) , gc ) ; 

  return 0 ; 
}






static int mark_print_params_FIXUP (void * p , struct NewGC * gc ) {

  PrintParams * pp = (PrintParams * ) p ; 
  GC_fixup2 (& (pp -> inspector ) , gc ) ; 
  GC_fixup2 (& (pp -> print_port ) , gc ) ; 
  GC_fixup2 (& (pp -> print_buffer ) , gc ) ; 
  GC_fixup2 (& (pp -> depth_delta ) , gc ) ; 
  GC_fixup2 (& (pp -> uq_ht ) , gc ) ; 

  return 0 ; 
}

# 49 "bc/src/mzmark_print.inc"
static int mark_marshal_tables_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_marshal_tables_MARK (void * p , struct NewGC * gc ) {

  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p ; 
  GC_mark2 (& (mt -> symtab ) , gc ) ; 
  GC_mark2 (& (mt -> st_refs ) , gc ) ; 
  GC_mark2 (& (mt -> st_ref_stack ) , gc ) ; 
  GC_mark2 (& (mt -> intern_map ) , gc ) ; 
  GC_mark2 (& (mt -> key_map ) , gc ) ; 
  GC_mark2 (& (mt -> delay_map ) , gc ) ; 
  GC_mark2 (& (mt -> cdata_map ) , gc ) ; 
  GC_mark2 (& (mt -> shared_offsets ) , gc ) ; 
  GC_mark2 (& (mt -> path_cache ) , gc ) ; 
  GC_mark2 (& (mt -> sorted_keys ) , gc ) ; 

  return 0 ; 
}






static int mark_marshal_tables_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p ; 
  GC_fixup2 (& (mt -> symtab ) , gc ) ; 
  GC_fixup2 (& (mt -> st_refs ) , gc ) ; 
  GC_fixup2 (& (mt -> st_ref_stack ) , gc ) ; 
  GC_fixup2 (& (mt -> intern_map ) , gc ) ; 
  GC_fixup2 (& (mt -> key_map ) , gc ) ; 
  GC_fixup2 (& (mt -> delay_map ) , gc ) ; 
  GC_fixup2 (& (mt -> cdata_map ) , gc ) ; 
  GC_fixup2 (& (mt -> shared_offsets ) , gc ) ; 
  GC_fixup2 (& (mt -> path_cache ) , gc ) ; 
  GC_fixup2 (& (mt -> sorted_keys ) , gc ) ; 

  return 0 ; 
}

# 4249 "bc/src/print.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_print_params , mark_print_params_SIZE , mark_print_params_MARK , mark_print_params_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_marshal_info , mark_marshal_tables_SIZE , mark_marshal_tables_MARK , mark_marshal_tables_FIXUP , 1 , 0 ) ; 
}
