#include "precomp.h"

# 2 "bc/src/schcpt.h"
enum {
  CPT_ESCAPE , 
  CPT_SYMBOL , 
  CPT_SYMREF , 
  CPT_WEIRD_SYMBOL , 
  CPT_KEYWORD , 
  CPT_BYTE_STRING , 
  CPT_CHAR_STRING , 
  CPT_CHAR , 
  CPT_INT , 
  CPT_NULL , 
  CPT_TRUE , 
  CPT_FALSE , 
  CPT_VOID , 
  CPT_BOX , 
  CPT_PAIR , 
  CPT_LIST , 
  CPT_VECTOR , 
  CPT_HASH_TABLE , 
  CPT_LET_ONE_TYPED , 
  CPT_LINKLET , 
  CPT_QUOTE , 
  CPT_REFERENCE , 
  CPT_LOCAL , 
  CPT_LOCAL_UNBOX , 
  CPT_SVECTOR , 
  CPT_APPLICATION , 
  CPT_LET_ONE , 
  CPT_BRANCH , 
  CPT_PATH , 
  CPT_CLOSURE , 
  CPT_DELAY_REF , 
  CPT_PREFAB , 
  CPT_PREFAB_TYPE , 
  CPT_LET_ONE_UNUSED , 
  CPT_SHARED , 
  CPT_TOPLEVEL , 
  CPT_BEGIN , 
  CPT_BEGIN0 , 
  CPT_LET_VALUE , 
  CPT_LET_VOID , 
  CPT_LETREC , 
  CPT_WCM , 
  CPT_DEFINE_VALUES , 
  CPT_SET_BANG , 
  CPT_VARREF , 
  CPT_APPLY_VALUES , 
  CPT_OTHER_FORM , 
  CPT_SRCLOC , 
  _CPT_COUNT_ }
; 

# 46 "/usr/include/ctype.h" 3
enum 
{
  _ISupper = (1 << (0 ) ) , 
  _ISlower = (1 << (1 ) ) , 
  _ISalpha = (1 << (2 ) ) , 
  _ISdigit = (1 << (3 ) ) , 
  _ISxdigit = (1 << (4 ) ) , 
  _ISspace = (1 << (5 ) ) , 
  _ISprint = (1 << (6 ) ) , 
  _ISgraph = (1 << (7 ) ) , 
  _ISblank = (1 << (8 ) ) , 
  _IScntrl = (1 << (9 ) ) , 
  _ISpunct = (1 << (10 ) ) , 
  _ISalnum = (1 << (11 ) ) }
; 

# 81 "/usr/include/ctype.h" 3
extern const __int32_t * * __ctype_tolower_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 
extern const __int32_t * * __ctype_toupper_loc (void ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 

# 122 "/usr/include/ctype.h" 3
extern int tolower (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 


extern int toupper (int __c ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 206 "/usr/include/ctype.h" 3
extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) tolower (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_tolower_loc () ) [__c ] : __c ; 
}

extern __inline __attribute__ ((__gnu_inline__ ) ) int 
__attribute__ ((__nothrow__ , __leaf__ ) ) toupper (int __c ) 
{
  return __c >= - 128 && __c < 256 ? (* __ctype_toupper_loc () ) [__c ] : __c ; 
}

# 35 "bc/src/read.c"
int scheme_square_brackets_are_parens = 1 ; 
int scheme_curly_braces_are_parens = 1 ; 

static int use_perma_cache = 1 ; 
static int validate_loaded_linklet = 0 ; 

; 


static unsigned char delim [128 ] ; 
static unsigned char cpt_branch [256 ] ; 


static Scheme_Object * * variable_references ; 
int unsafe_variable_references_start ; 

static Scheme_Object * quote_symbol ; 
static Scheme_Object * quasiquote_symbol ; 
static Scheme_Object * unquote_symbol ; 
static Scheme_Object * unquote_splicing_symbol ; 
static Scheme_Object * syntax_symbol ; 
static Scheme_Object * unsyntax_symbol ; 
static Scheme_Object * unsyntax_splicing_symbol ; 
static Scheme_Object * quasisyntax_symbol ; 


static Scheme_Object * read_case_sensitive (int , Scheme_Object * [] ) ; 
static Scheme_Object * read_accept_pipe_quote (int , Scheme_Object * [] ) ; 

static Scheme_Object * read_delay_load (int , Scheme_Object * [] ) ; 

static Scheme_Object * print_graph (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_struct (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_box (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_vec_shorthand (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_hash_table (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_unreadable (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_pair_curly (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_mpair_curly (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_syntax_width (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_reader (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_as_qq (int , Scheme_Object * [] ) ; 
static Scheme_Object * print_long_bool (int , Scheme_Object * [] ) ; 

# 95 "bc/src/read.c"
typedef struct ReadParams {
  Scheme_Type type ; 
  char skip_zo_vers_check ; 
  char can_read_unsafe ; 
  Scheme_Object * delay_load_info ; 
  Scheme_Object * read_relative_path ; 
  Scheme_Hash_Table * graph_ht ; 
}

# 102 "bc/src/read.c"
ReadParams ; 



static Scheme_Object * read_list (Scheme_Object * port , 
int opener , int closer , 
int shape , int use_stack , 
ReadParams * params ) ; 
static Scheme_Object * read_string (int is_byte , 
Scheme_Object * port , 
ReadParams * params , 
int err_ok ) ; 
static Scheme_Object * read_quote (char * who , Scheme_Object * quote_symbol , int len , 
Scheme_Object * port , 
ReadParams * params ) ; 
static Scheme_Object * read_vector (Scheme_Object * port , 
int opener , char closer , 
ReadParams * params , 
int allow_infix ) ; 
static Scheme_Object * read_number_or_symbol (int init_ch , Scheme_Object * port , 
int is_float , int is_not_float , 
int radix , int radix_set , 
int is_symbol , int is_kw , 
ReadParams * params ) ; 
static Scheme_Object * read_number (int init_ch , 
Scheme_Object * port , 
int , int , int , int , 
ReadParams * params ) ; 
static Scheme_Object * read_symbol (int init_ch , 
Scheme_Object * port , 
ReadParams * params ) ; 
static Scheme_Object * read_keyword (int init_ch , 
Scheme_Object * port , 
ReadParams * params ) ; 
static Scheme_Object * read_delimited_constant (int ch , const mzchar * str , 
Scheme_Object * v , 
Scheme_Object * port , 
ReadParams * params ) ; 
static Scheme_Object * read_character (Scheme_Object * port , 
ReadParams * params ) ; 
static Scheme_Object * read_box (Scheme_Object * port , 
ReadParams * params ) ; 
static Scheme_Object * read_hash (Scheme_Object * port , 
int opener , char closer , int kind , 
ReadParams * params ) ; 
static void unexpected_closer (int ch , 
Scheme_Object * port ) ; 
static int next_is_delim (Scheme_Object * port ) ; 
static int read_graph_index (Scheme_Object * port , int * ch ) ; 
static int skip_whitespace_comments (Scheme_Object * port , 
ReadParams * params ) ; 

static Scheme_Object * read_intern (int argc , Scheme_Object * * argv ) ; 


static void register_traversers (void ) ; 

# 174 "bc/src/read.c"
void scheme_init_read (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM1_COUNT (1)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & quote_symbol , sizeof (quote_symbol ) ) )
# 176 "bc/src/read.c"
  ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & quasiquote_symbol , sizeof (quasiquote_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unquote_symbol , sizeof (unquote_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unquote_splicing_symbol , sizeof (unquote_splicing_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & syntax_symbol , sizeof (syntax_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unsyntax_symbol , sizeof (unsyntax_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & unsyntax_splicing_symbol , sizeof (unsyntax_splicing_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & quasisyntax_symbol , sizeof (quasisyntax_symbol ) ) ); 

  quote_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("quote" ) ); 
  quasiquote_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("quasiquote" ) ); 
  unquote_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unquote" ) ); 
  unquote_splicing_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unquote-splicing" ) ); 
  syntax_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("syntax" ) ); 
  unsyntax_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unsyntax" ) ); 
  unsyntax_splicing_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("unsyntax-splicing" ) ); 
  quasisyntax_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("quasisyntax" ) ); 


  {
    int i ; 

    for (i = 0 ; i < 256 ; i ++ ) {
      cpt_branch [i ] = i ; 
    }





    for (i = 48 ; i < 74 ; i ++ ) {

# 206 "bc/src/read.c"
      cpt_branch [i ] = 48 ; 
    }

# 206 "bc/src/read.c"
    ; 
    for (i = 74 ; i < 92 ; i ++ ) {

# 207 "bc/src/read.c"
      cpt_branch [i ] = 74 ; 
    }

# 207 "bc/src/read.c"
    ; 
    for (i = (92 + 50 ) ; i < ((92 + 50 ) + 50 ) ; i ++ ) {

# 208 "bc/src/read.c"
      cpt_branch [i ] = (92 + 50 ) ; 
    }

# 208 "bc/src/read.c"
    ; 
    for (i = 92 ; i < (92 + 50 ) ; i ++ ) {

# 209 "bc/src/read.c"
      cpt_branch [i ] = 92 ; 
    }

# 209 "bc/src/read.c"
    ; 
    for (i = 192 ; i < 207 ; i ++ ) {

# 210 "bc/src/read.c"
      cpt_branch [i ] = 192 ; 
    }

# 210 "bc/src/read.c"
    ; 
    for (i = 207 ; i < 222 ; i ++ ) {

# 211 "bc/src/read.c"
      cpt_branch [i ] = 207 ; 
    }

# 211 "bc/src/read.c"
    ; 
    for (i = 222 ; i < 247 ; i ++ ) {

# 212 "bc/src/read.c"
      cpt_branch [i ] = 222 ; 
    }

# 212 "bc/src/read.c"
    ; 
    for (i = 247 ; i < 255 ; i ++ ) {

# 213 "bc/src/read.c"
      cpt_branch [i ] = 247 ; 
    }

# 213 "bc/src/read.c"
    ; 


    cpt_branch [248 ] = 248 ; 
    cpt_branch [249 ] = 249 ; 
  }

  {
    int i ; 
    for (i = 0 ; i < 128 ; i ++ ) {
      delim [i ] = 0x1 ; 
    }
    delim ['(' ] -= 0x1 ; 
    delim [')' ] -= 0x1 ; 
    delim ['[' ] -= 0x1 ; 
    delim [']' ] -= 0x1 ; 
    delim ['{' ] -= 0x1 ; 
    delim ['}' ] -= 0x1 ; 
    delim ['"' ] -= 0x1 ; 
    delim ['\'' ] -= 0x1 ; 
    delim [',' ] -= 0x1 ; 
    delim [';' ] -= 0x1 ; 
    delim ['`' ] -= 0x1 ; 
  }
  FUNCCALL(SETUP_XfOrM1(_), register_traversers () )

  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (read_case_sensitive , "read-case-sensitive" , MZCONFIG_CASE_SENS ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-case-sensitive" , __funcarg73 , env ) )) ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (read_accept_pipe_quote , "read-accept-bar-quote" , MZCONFIG_CAN_READ_PIPE_QUOTE ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-accept-bar-quote" , __funcarg72 , env ) )) ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (read_delay_load , "read-on-demand-source" , MZCONFIG_DELAY_LOAD_INFO ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("read-on-demand-source" , __funcarg71 , env ) )) ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_graph , "print-graph" , MZCONFIG_PRINT_GRAPH ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-graph" , __funcarg70 , env ) )) ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_struct , "print-struct" , MZCONFIG_PRINT_STRUCT ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-struct" , __funcarg69 , env ) )) ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_box , "print-box" , MZCONFIG_PRINT_BOX ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-box" , __funcarg68 , env ) )) ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_vec_shorthand , "print-vector-length" , MZCONFIG_PRINT_VEC_SHORTHAND ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-vector-length" , __funcarg67 , env ) )) ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_hash_table , "print-hash-table" , MZCONFIG_PRINT_HASH_TABLE ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-hash-table" , __funcarg66 , env ) )) ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_unreadable , "print-unreadable" , MZCONFIG_PRINT_UNREADABLE ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-unreadable" , __funcarg65 , env ) )) ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_pair_curly , "print-pair-curly-braces" , MZCONFIG_PRINT_PAIR_CURLY ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-pair-curly-braces" , __funcarg64 , env ) )) ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_mpair_curly , "print-mpair-curly-braces" , MZCONFIG_PRINT_MPAIR_CURLY ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-mpair-curly-braces" , __funcarg63 , env ) )) ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_syntax_width , "print-syntax-width" , MZCONFIG_PRINT_SYNTAX_WIDTH ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-syntax-width" , __funcarg62 , env ) )) ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_reader , "print-reader-abbreviations" , MZCONFIG_PRINT_READER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-reader-abbreviations" , __funcarg61 , env ) )) ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_long_bool , "print-boolean-long-form" , MZCONFIG_PRINT_LONG_BOOLEAN ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-boolean-long-form" , __funcarg60 , env ) )) ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM1(_), scheme_register_parameter (print_as_qq , "print-as-expression" , MZCONFIG_PRINT_AS_QQ ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("print-as-expression" , __funcarg59 , env ) )) ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_noncm_prim (read_intern , "datum-intern-literal" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("datum-intern-literal" , __funcarg58 , env ) )) ; 

  if (FUNCCALL_EMPTY(getenv ("PLT_DELAY_FROM_ZO" ) ))
    use_perma_cache = 0 ; 
  if (FUNCCALL_EMPTY(getenv ("PLT_VALIDATE_LOAD" ) ))
    validate_loaded_linklet = 0 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 268 "bc/src/read.c"
void scheme_init_variable_references_constants () 
{
  /* No conversion */

# 270 "bc/src/read.c"
  scheme_register_static ((void * ) & variable_references , sizeof (variable_references ) ) ; 
  variable_references = scheme_make_builtin_references_table (& unsafe_variable_references_start ) ; 
}

Scheme_Object * scheme_position_to_builtin (int l ) 
{
  /* No conversion */

# 276 "bc/src/read.c"
  if (l < 1575 )
    return variable_references [l ] ; 
  else 
  return ((void * ) 0 ) ; 
}








static Scheme_Object * 
read_case_sensitive (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 292 "bc/src/read.c"
  return scheme_param_config ("read-case-sensitive" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_CASE_SENS ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
read_accept_pipe_quote (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 298 "bc/src/read.c"
  return scheme_param_config ("read-accept-pipe-quote" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_CAN_READ_PIPE_QUOTE ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_graph (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 304 "bc/src/read.c"
  return scheme_param_config ("print-graph" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_GRAPH ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_struct (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 310 "bc/src/read.c"
  return scheme_param_config ("print-struct" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_STRUCT ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_box (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 316 "bc/src/read.c"
  return scheme_param_config ("print-box" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_BOX ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_vec_shorthand (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 322 "bc/src/read.c"
  return scheme_param_config ("print-vector-length" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_VEC_SHORTHAND ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_hash_table (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 328 "bc/src/read.c"
  return scheme_param_config ("print-hash-table" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_HASH_TABLE ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_unreadable (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 334 "bc/src/read.c"
  return scheme_param_config ("print-unreadable" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_UNREADABLE ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_pair_curly (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 340 "bc/src/read.c"
  return scheme_param_config ("print-pair-curly" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_PAIR_CURLY ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_mpair_curly (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 346 "bc/src/read.c"
  return scheme_param_config ("print-mpair-curly" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_MPAIR_CURLY ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_reader (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 352 "bc/src/read.c"
  return scheme_param_config ("print-reader-abbreviations" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_READER ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_as_qq (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 358 "bc/src/read.c"
  return scheme_param_config ("print-as-expression" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_AS_QQ ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * 
print_long_bool (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 364 "bc/src/read.c"
  return scheme_param_config ("print-boolean-long-form" , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_LONG_BOOLEAN ) ) ) << 1 ) | 0x1 ) ) , argc , argv , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * good_syntax_width (int c , Scheme_Object * * argv ) 
{
  /* No conversion */

# 369 "bc/src/read.c"
  int ok ; 

  ok = ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
  ? (((((intptr_t ) (argv [0 ] ) ) >> 1 ) > 2 ) 
  || ! (((intptr_t ) (argv [0 ] ) ) >> 1 ) ) 
  : (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
  ? ((& ((Scheme_Bignum * ) argv [0 ] ) -> iso ) -> so . keyex & 0x1 ) 
  : (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_double_type ) ) 
  ? (__builtin_isinf_sign ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) ) && ((((Scheme_Double * ) (argv [0 ] ) ) -> double_val ) > 0 ) ) 
  : 0 ) ) ) ; 

  return ok ? scheme_true : scheme_false ; 
}

static Scheme_Object * 
print_syntax_width (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 386 "bc/src/read.c"
  return scheme_param_config2 ("print-syntax-width" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_SYNTAX_WIDTH ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , good_syntax_width , 
  "(or/c +inf.0 0 (and/c exact-integer? (>=/c 3)))" , 0 ) ; 
}


static Scheme_Object * rdl_check (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 396 "bc/src/read.c"
  Scheme_Object * s = argv [0 ] ; 

  return (((((s ) ) == (scheme_false ) ) 
  || ((scheme_true ) == (s ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
  && scheme_is_complete_path ((((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , 
  (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) , 
  scheme_unix_path_type ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
read_delay_load (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 410 "bc/src/read.c"
  return scheme_param_config2 ("read-on-demand-source" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_DELAY_LOAD_INFO ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , rdl_check , 
  "(or/c #f #t (and/c path? complete-path?))" , 
  0 ) ; 
}







static Scheme_Object * read_inner (Scheme_Object * port , ReadParams * params , int pre_char ) ; 

static Scheme_Object * read_inner_k (void ) 
{
  /* No conversion */

# 428 "bc/src/read.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  ReadParams * params = (ReadParams * ) (((Scheme_Simple_Object * ) ((Scheme_Object * ) p -> ku . k . p4 ) ) -> u . pair_val . cdr ) ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  return read_inner (o , params , p -> ku . k . i2 ) ; 
}

static Scheme_Object * read_inner (Scheme_Object * port , ReadParams * params , int pre_char ) 
{
  int ch , ch2 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(params, 1)));
# define XfOrM44_COUNT (2)
# define SETUP_XfOrM44(x) SETUP(XfOrM44_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 443 "bc/src/read.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM122_COUNT (0+XfOrM44_COUNT)
#   define SETUP_XfOrM122(x) SETUP_XfOrM44(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 445 "bc/src/read.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      ReadParams * params2 ; 
      BLOCK_SETUP((PUSH(params2, 0+XfOrM122_COUNT), PUSH(p, 1+XfOrM122_COUNT)));
#     define XfOrM123_COUNT (2+XfOrM122_COUNT)
#     define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
      params2 = NULLED_OUT ; 

# 450 "bc/src/read.c"
      params2 = ((ReadParams * ) FUNCCALL(SETUP_XfOrM123(_), GC_malloc_one_small_tagged ((((sizeof (ReadParams ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      (memcpy (params2 , params , sizeof (ReadParams ) ) ) ; 

      params2 -> type = scheme_rt_read_params ; 


      p -> ku . k . p1 = (void * ) port ; 
      p -> ku . k . p4 = (void * ) params2 ; 
      p -> ku . k . i2 = pre_char ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (read_inner_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  start_over : 

  {
#   define XfOrM120_COUNT (0+XfOrM44_COUNT)
#   define SETUP_XfOrM120(x) SETUP_XfOrM44(x)

# 466 "bc/src/read.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM121_COUNT (0+XfOrM120_COUNT)
#     define SETUP_XfOrM121(x) SETUP_XfOrM120(x)
      FUNCCALL(SETUP_XfOrM121(_), scheme_out_of_fuel () )
# 466 "bc/src/read.c"
      ; 
    }
  }

# 466 "bc/src/read.c"
  ; 


  while (1 ) {
#   define XfOrM117_COUNT (0+XfOrM44_COUNT)
#   define SETUP_XfOrM117(x) SETUP_XfOrM44(x)

# 470 "bc/src/read.c"
    if (pre_char >= 0 ) {
      ch = pre_char ; 
      pre_char = - 1 ; 
    }

# 473 "bc/src/read.c"
    else 
    ch = FUNCCALL(SETUP_XfOrM117(_), scheme_getc (port ) ); 
    if ((ch ) >= 0 )  {
      if (! (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) )
        break ; 
    }

# 478 "bc/src/read.c"
    else 
    break ; 
  }

  switch (ch ) 
  {
#   define XfOrM45_COUNT (0+XfOrM44_COUNT)
#   define SETUP_XfOrM45(x) SETUP_XfOrM44(x)

# 484 "bc/src/read.c"
    case (- 1 ) : 
    RET_VALUE_START (scheme_eof ) RET_VALUE_END ; 
    case ']' : FUNCCALL(SETUP_XfOrM45(_), unexpected_closer (ch , port ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    case '}' : FUNCCALL(SETUP_XfOrM45(_), unexpected_closer (ch , port ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    case ')' : FUNCCALL(SETUP_XfOrM45(_), unexpected_closer (ch , port ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    case '(' : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_list (port , ch , ')' , 0 , 0 , params ) )) RET_VALUE_EMPTY_END ; 
    case '[' : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_list (port , ch , ']' , 0 , 0 , params ) )) RET_VALUE_EMPTY_END ; 
    case '{' : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_list (port , ch , '}' , 0 , 0 , params ) )) RET_VALUE_EMPTY_END ; 
    case '|' : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_symbol (ch , port , params ) )) RET_VALUE_EMPTY_END ; 
    case '"' : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_string (0 , port , params , 1 ) )) RET_VALUE_EMPTY_END ; 
    case '\'' : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("quoting '" , quote_symbol , 1 , port , params ) )) RET_VALUE_EMPTY_END ; 
    case '`' : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("quasiquoting `" , quasiquote_symbol , 1 , port , params ) )) RET_VALUE_EMPTY_END ; 
    case ',' : 
    {
#     define XfOrM112_COUNT (0+XfOrM45_COUNT)
#     define SETUP_XfOrM112(x) SETUP_XfOrM45(x)

# 511 "bc/src/read.c"
      if (FUNCCALL(SETUP_XfOrM112(_), scheme_peekc (port ) )== '@' ) {
#       define XfOrM113_COUNT (0+XfOrM112_COUNT)
#       define SETUP_XfOrM113(x) SETUP_XfOrM112(x)

# 512 "bc/src/read.c"
        ch = FUNCCALL(SETUP_XfOrM113(_), scheme_getc (port ) ); 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("unquoting ,@" , unquote_splicing_symbol , 2 , port , params ) )) RET_VALUE_EMPTY_END ; 
      }

# 514 "bc/src/read.c"
      else 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("unquoting ," , unquote_symbol , 1 , port , params ) )) RET_VALUE_EMPTY_END ; 
    }
    case ';' : 
    {
#     define XfOrM109_COUNT (0+XfOrM45_COUNT)
#     define SETUP_XfOrM109(x) SETUP_XfOrM45(x)

# 519 "bc/src/read.c"
      while (((ch = FUNCCALL(SETUP_XfOrM109(_), scheme_getc (port ) )) != '\n' ) 
      && ! ((ch == '\n' ) || (ch == '\r' ) || (ch == 0x85 ) || (ch == 0x2028 ) || (ch == 0x2029 ) ) ) {
        if (ch == (- 1 ) )
          RET_VALUE_START (scheme_eof ) RET_VALUE_END ; 
      }
      goto start_over ; 
    }
    case '#' : 
    ch = FUNCCALL(SETUP_XfOrM45(_), scheme_getc (port ) ); 

    switch (ch ) 
    {
#     define XfOrM46_COUNT (0+XfOrM45_COUNT)
#     define SETUP_XfOrM46(x) SETUP_XfOrM45(x)

# 531 "bc/src/read.c"
      case (- 1 ) : FUNCCALL_EMPTY(scheme_read_err (port , "read: bad syntax `#'" ) )
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      case ';' : 
      {
        Scheme_Object * skipped ; 
        BLOCK_SETUP((PUSH(skipped, 0+XfOrM46_COUNT)));
#       define XfOrM108_COUNT (1+XfOrM46_COUNT)
#       define SETUP_XfOrM108(x) SETUP(XfOrM108_COUNT)
        skipped = NULLED_OUT ; 

# 537 "bc/src/read.c"
        skipped = FUNCCALL(SETUP_XfOrM108(_), read_inner (port , params , - 1 ) ); 
        if (((skipped ) ) == (scheme_eof ) ) 
          FUNCCALL_EMPTY(scheme_read_err (port , "read: expected a commented-out element for `#;' (found end-of-file)" ) ); 
        goto start_over ; 
      }
      case '%' : FUNCCALL(SETUP_XfOrM46(_), scheme_ungetc ('%' , port ) )
      ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_symbol ('#' , port , params ) )) RET_VALUE_EMPTY_END ; 
      case ':' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_keyword (- 1 , port , params ) )) RET_VALUE_EMPTY_END ; 
      case '(' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , ch , ')' , params , 0 ) )) RET_VALUE_EMPTY_END ; 
      case '[' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , ch , ']' , params , 0 ) )) RET_VALUE_EMPTY_END ; 
      case '{' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , ch , '}' , params , 0 ) )) RET_VALUE_EMPTY_END ; 
      case '\\' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_character (port , params ) )) RET_VALUE_EMPTY_END ; 
      case 'T' : 
      case 't' : 
      if (FUNCCALL(SETUP_XfOrM46(_), next_is_delim (port ) )) {

        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
      }

# 560 "bc/src/read.c"
      else {
        GC_CAN_IGNORE const mzchar str [] = {

# 561 "bc/src/read.c"
          't' , 'r' , 'u' , 'e' , 0 }

# 561 "bc/src/read.c"
        ; 
#       define XfOrM106_COUNT (0+XfOrM46_COUNT)
#       define SETUP_XfOrM106(x) SETUP_XfOrM46(x)

# 562 "bc/src/read.c"
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_delimited_constant (ch , str , scheme_true , port , params ) )) RET_VALUE_EMPTY_END ; 
      }
      case 'F' : 
      case 'f' : 
      if (FUNCCALL(SETUP_XfOrM46(_), next_is_delim (port ) )) {

        RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
      }

# 569 "bc/src/read.c"
      else {
        GC_CAN_IGNORE const mzchar str [] = {

# 570 "bc/src/read.c"
          'f' , 'a' , 'l' , 's' , 'e' , 0 }

# 570 "bc/src/read.c"
        ; 
#       define XfOrM104_COUNT (0+XfOrM46_COUNT)
#       define SETUP_XfOrM104(x) SETUP_XfOrM46(x)

# 571 "bc/src/read.c"
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_delimited_constant (ch , str , scheme_false , port , params ) )) RET_VALUE_EMPTY_END ; 
      }
      case 's' : 
      case 'S' : 
      {
        int orig_ch = ch ; 
#       define XfOrM100_COUNT (0+XfOrM46_COUNT)
#       define SETUP_XfOrM100(x) SETUP_XfOrM46(x)

# 577 "bc/src/read.c"
        ch = FUNCCALL(SETUP_XfOrM100(_), scheme_getc (port ) ); 
        if ((orig_ch == 's' ) 
        && ((ch == '(' ) 
        || (ch == '[' ) 
        || (ch == '{' ) ) ) {
          Scheme_Object * v ; 
          Scheme_Struct_Type * st ; 
          BLOCK_SETUP((PUSH(v, 0+XfOrM100_COUNT), PUSH(st, 1+XfOrM100_COUNT)));
#         define XfOrM102_COUNT (2+XfOrM100_COUNT)
#         define SETUP_XfOrM102(x) SETUP(XfOrM102_COUNT)
          v = NULLED_OUT ; 
          st = NULLED_OUT ; 

# 585 "bc/src/read.c"
          if (ch == '(' )
            ch = ')' ; 
          else if (ch == '[' )
            ch = ']' ; 
          else if (ch == '{' )
            ch = '}' ; 

          v = FUNCCALL(SETUP_XfOrM102(_), read_vector (port , orig_ch , ch , params , 1 ) ); 

          if (((Scheme_Vector * ) (v ) ) -> size ) 
            st = FUNCCALL(SETUP_XfOrM102(_), scheme_lookup_prefab_type ((((Scheme_Vector * ) (v ) ) -> els ) [0 ] , (((Scheme_Vector * ) (v ) ) -> size ) - 1 ) ); 
          else 
          st = ((void * ) 0 ) ; 

          if (! st || (st -> num_slots != ((((Scheme_Vector * ) (v ) ) -> size ) - 1 ) ) ) {
#           define XfOrM103_COUNT (0+XfOrM102_COUNT)
#           define SETUP_XfOrM103(x) SETUP_XfOrM102(x)
            FUNCCALL_EMPTY(scheme_read_err (port , ((((Scheme_Vector * ) (v ) ) -> size ) ? (st ? ("read: mismatch between structure description" " and number of provided field values in `#s' form" ) : "read: invalid structure description in `#s' form" ) : "read: missing structure description in `#s' form" ) ) )



            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }

          v = FUNCCALL(SETUP_XfOrM102(_), scheme_make_prefab_struct_instance (st , v ) ); 

          RET_VALUE_START (v ) RET_VALUE_END ; 
        }

# 613 "bc/src/read.c"
        else {
#         define XfOrM101_COUNT (0+XfOrM100_COUNT)
#         define SETUP_XfOrM101(x) SETUP_XfOrM100(x)
          FUNCCALL_EMPTY(scheme_read_err (port , "read: expected `x'%s after `#%c'" , (orig_ch == 's' ? "or `('" : "" ) , orig_ch ) )
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      case 'X' : 
      case 'x' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , 0 , 0 , 16 , 1 , params ) )) RET_VALUE_EMPTY_END ; 
      case 'B' : 
      case 'b' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , 0 , 0 , 2 , 1 , params ) )) RET_VALUE_EMPTY_END ; 
      case 'O' : 
      case 'o' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , 0 , 0 , 8 , 1 , params ) )) RET_VALUE_EMPTY_END ; 
      case 'D' : 
      case 'd' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , 0 , 0 , 10 , 1 , params ) )) RET_VALUE_EMPTY_END ; 
      case 'E' : 
      case 'e' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , 0 , 1 , 10 , 0 , params ) )) RET_VALUE_EMPTY_END ; 
      case 'I' : 
      case 'i' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number (- 1 , port , 1 , 0 , 10 , 0 , params ) )) RET_VALUE_EMPTY_END ; 
      case '\'' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("quoting #'" , syntax_symbol , 2 , port , params ) )) RET_VALUE_EMPTY_END ; 
      case '`' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("quasiquoting #`" , quasisyntax_symbol , 2 , port , params ) )) RET_VALUE_EMPTY_END ; 
      case ',' : 
      if (FUNCCALL(SETUP_XfOrM46(_), scheme_peekc (port ) )== '@' ) {
#       define XfOrM99_COUNT (0+XfOrM46_COUNT)
#       define SETUP_XfOrM99(x) SETUP_XfOrM46(x)

# 645 "bc/src/read.c"
        (void ) FUNCCALL(SETUP_XfOrM99(_), scheme_getc (port ) ); 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("unquoting #`@" , unsyntax_splicing_symbol , 3 , port , params ) )) RET_VALUE_EMPTY_END ; 
      }

# 647 "bc/src/read.c"
      else 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_quote ("unquoting #`" , unsyntax_symbol , 2 , port , params ) )) RET_VALUE_EMPTY_END ; 
      case '^' : 
      {
#       define XfOrM92_COUNT (0+XfOrM46_COUNT)
#       define SETUP_XfOrM92(x) SETUP_XfOrM46(x)

# 651 "bc/src/read.c"
        ch = FUNCCALL(SETUP_XfOrM92(_), scheme_getc (port ) ); 
        if (ch == '#' ) {
#         define XfOrM94_COUNT (0+XfOrM92_COUNT)
#         define SETUP_XfOrM94(x) SETUP_XfOrM92(x)

# 653 "bc/src/read.c"
          ch = FUNCCALL(SETUP_XfOrM94(_), scheme_getc (port ) ); 
          if (ch == '"' ) {
            Scheme_Object * str ; 
            BLOCK_SETUP((PUSH(str, 0+XfOrM94_COUNT)));
#           define XfOrM96_COUNT (1+XfOrM94_COUNT)
#           define SETUP_XfOrM96(x) SETUP(XfOrM96_COUNT)
            str = NULLED_OUT ; 

# 657 "bc/src/read.c"
            str = FUNCCALL(SETUP_XfOrM96(_), read_string (1 , port , params , 1 ) ); 

            str -> type = scheme_unix_path_type ; 

            if (FUNCCALL(SETUP_XfOrM96(_), scheme_is_relative_path ((((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) , scheme_unix_path_type ) )) {
#             define XfOrM97_COUNT (0+XfOrM96_COUNT)
#             define SETUP_XfOrM97(x) SETUP_XfOrM96(x)

# 662 "bc/src/read.c"
              if ((Scheme_Type ) (((((intptr_t ) (params -> read_relative_path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params -> read_relative_path ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
                Scheme_Object * a [2 ] ; 
                BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM97_COUNT)));
#               define XfOrM98_COUNT (3+XfOrM97_COUNT)
#               define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
                a[0] = NULLED_OUT ; 
                a[1] = NULLED_OUT ; 

# 664 "bc/src/read.c"
                a [0 ] = params -> read_relative_path ; 
                a [1 ] = str ; 
                str = FUNCCALL(SETUP_XfOrM98(_), scheme_build_path (2 , a ) ); 
                a [0 ] = str ; 
                a [1 ] = scheme_false ; 
                str = FUNCCALL(SETUP_XfOrM98(_), scheme_simplify_path (2 , a ) ); 
              }
            }

            RET_VALUE_START (str ) RET_VALUE_END ; 
          }

# 674 "bc/src/read.c"
          else {
#           define XfOrM95_COUNT (0+XfOrM94_COUNT)
#           define SETUP_XfOrM95(x) SETUP_XfOrM94(x)
            FUNCCALL_EMPTY(scheme_read_err (port , "read: bad syntax `#^#%c'" , ch ) )
# 675 "bc/src/read.c"
            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
        }

# 678 "bc/src/read.c"
        else {
#         define XfOrM93_COUNT (0+XfOrM92_COUNT)
#         define SETUP_XfOrM93(x) SETUP_XfOrM92(x)
          FUNCCALL_EMPTY(scheme_read_err (port , "read: bad syntax `#^%c'" , ch ) )
# 679 "bc/src/read.c"
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      break ; 
      case '|' : 
      {
        intptr_t depth = 0 ; 
#       define XfOrM85_COUNT (0+XfOrM46_COUNT)
#       define SETUP_XfOrM85(x) SETUP_XfOrM46(x)

# 687 "bc/src/read.c"
        ch2 = 0 ; 
        do {
#         define XfOrM89_COUNT (0+XfOrM85_COUNT)
#         define SETUP_XfOrM89(x) SETUP_XfOrM85(x)

# 689 "bc/src/read.c"
          ch = FUNCCALL(SETUP_XfOrM89(_), scheme_getc (port ) ); 

          if (ch == (- 1 ) )
            FUNCCALL_EMPTY(scheme_read_err (port , "read: end of file in #| comment" ) ); 

          if ((ch2 == '|' ) && (ch == '#' ) ) {
            if (! (depth -- ) )
              goto start_over ; 
            ch = 0 ; 
          }

# 698 "bc/src/read.c"
          else if ((ch2 == '#' ) && (ch == '|' ) ) {
            depth ++ ; 
            ch = 0 ; 
          }
          ch2 = ch ; 
        }

# 703 "bc/src/read.c"
        while (1 ) ; 
      }
      break ; 
      case '&' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_box (port , params ) )) RET_VALUE_EMPTY_END ; 
      case 'r' : 
      case 'p' : 
      {
        int orig_ch = ch ; 
        int cnt = 0 , is_byte = 0 ; 
        char * expect ; 
        BLOCK_SETUP((PUSH(expect, 0+XfOrM46_COUNT)));
#       define XfOrM76_COUNT (1+XfOrM46_COUNT)
#       define SETUP_XfOrM76(x) SETUP(XfOrM76_COUNT)
        expect = NULLED_OUT ; 

# 715 "bc/src/read.c"
        ch = FUNCCALL(SETUP_XfOrM76(_), scheme_getc (port ) ); 
        if (ch == 'x' ) {
#         define XfOrM81_COUNT (0+XfOrM76_COUNT)
#         define SETUP_XfOrM81(x) SETUP_XfOrM76(x)

# 717 "bc/src/read.c"
          expect = "x#" ; 
          ch = FUNCCALL(SETUP_XfOrM81(_), scheme_getc (port ) ); 
          cnt ++ ; 
          if (ch == '#' ) {
#           define XfOrM84_COUNT (0+XfOrM81_COUNT)
#           define SETUP_XfOrM84(x) SETUP_XfOrM81(x)

# 721 "bc/src/read.c"
            is_byte = 1 ; 
            cnt ++ ; 
            ch = FUNCCALL(SETUP_XfOrM84(_), scheme_getc (port ) ); 
          }
          if (ch == '"' ) {
            Scheme_Object * str ; 
            int is_err ; 
            BLOCK_SETUP((PUSH(str, 0+XfOrM81_COUNT)));
#           define XfOrM82_COUNT (1+XfOrM81_COUNT)
#           define SETUP_XfOrM82(x) SETUP(XfOrM82_COUNT)
            str = NULLED_OUT ; 

# 729 "bc/src/read.c"
            str = FUNCCALL(SETUP_XfOrM82(_), read_string (is_byte , port , params , 1 ) ); 

            str = FUNCCALL_AGAIN(scheme_make_regexp (str , is_byte , (orig_ch == 'p' ) , & is_err ) ); 

            if (is_err ) {
#             define XfOrM83_COUNT (0+XfOrM82_COUNT)
#             define SETUP_XfOrM83(x) SETUP_XfOrM82(x)
              FUNCCALL_EMPTY(scheme_read_err (port , "read: bad %sregexp string `%s`" , (orig_ch == 'r' ) ? "" : "p" , (char * ) str ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }

            RET_VALUE_START (str ) RET_VALUE_END ; 
          }
        }

# 742 "bc/src/read.c"
        else 
        expect = "" ; 

        {
          mzchar a [6 ] ; 
          int i ; 
#         define XfOrM77_COUNT (0+XfOrM76_COUNT)
#         define SETUP_XfOrM77(x) SETUP_XfOrM76(x)

# 749 "bc/src/read.c"
          for (i = 0 ; i < cnt ; i ++ ) {
            a [i ] = expect [i ] ; 
          }
          if ((ch ) >= 0 )  {
            a [cnt ++ ] = ch ; 
          }
          FUNCCALL_EMPTY(scheme_read_err (port , "read: bad syntax `#%c%u`" , orig_ch , a , (intptr_t ) cnt ) )

          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      break ; 
      case 'h' : 
      {
#       define XfOrM51_COUNT (0+XfOrM46_COUNT)
#       define SETUP_XfOrM51(x) SETUP_XfOrM46(x)

# 764 "bc/src/read.c"
        ch = FUNCCALL(SETUP_XfOrM51(_), scheme_getc (port ) ); 
        if (ch != 'a' ) {
#         define XfOrM75_COUNT (0+XfOrM51_COUNT)
#         define SETUP_XfOrM75(x) SETUP_XfOrM51(x)
          FUNCCALL_EMPTY(scheme_read_err (port , "read: expected `a` after `#h`" ) )
# 766 "bc/src/read.c"
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }

# 768 "bc/src/read.c"
        else {
          GC_CAN_IGNORE const mzchar str1 [] = {

# 769 "bc/src/read.c"
            's' , 'h' , 'e' , 'q' , 'v' , 0 }

# 769 "bc/src/read.c"
          ; 
          GC_CAN_IGNORE const mzchar str2 [] = {

# 770 "bc/src/read.c"
            's' , 'h' , 'a' , 'l' , 'w' , 0 }

# 770 "bc/src/read.c"
          ; 
          int scanpos = 0 , track = 0 , failed = 0 ; 
#         define XfOrM52_COUNT (0+XfOrM51_COUNT)
#         define SETUP_XfOrM52(x) SETUP_XfOrM51(x)

# 773 "bc/src/read.c"
          do {
#           define XfOrM69_COUNT (0+XfOrM52_COUNT)
#           define SETUP_XfOrM69(x) SETUP_XfOrM52(x)

# 774 "bc/src/read.c"
            ch = FUNCCALL(SETUP_XfOrM69(_), scheme_getc (port ) ); 
            if (((mzchar ) ch == str1 [scanpos ] ) && ((mzchar ) ch == str2 [scanpos ] ) ) {
              scanpos ++ ; 
            }

# 777 "bc/src/read.c"
            else if ((track != 2 ) && ((mzchar ) ch == str1 [scanpos ] ) ) {

              scanpos ++ ; 
              track = 1 ; 
            }

# 781 "bc/src/read.c"
            else if ((track != 1 ) && ((mzchar ) ch == str2 [scanpos ] ) ) {

              scanpos ++ ; 
              track = 2 ; 
            }

# 785 "bc/src/read.c"
            else {
              if ((scanpos == 2 ) || (scanpos == 4 ) ) {
                if (! (ch == '(' ) 
                && ! (ch == '[' ) 
                && ! (ch == '{' ) )
                  failed = 1 ; 
              }

# 791 "bc/src/read.c"
              else 
              failed = 1 ; 
              break ; 
            }
          }

# 795 "bc/src/read.c"
          while (str1 [scanpos ] ) ; 

          if (! failed ) {

            int kind ; 
#           define XfOrM57_COUNT (0+XfOrM52_COUNT)
#           define SETUP_XfOrM57(x) SETUP_XfOrM52(x)

# 801 "bc/src/read.c"
            if (scanpos > 4 ) {
#             define XfOrM62_COUNT (0+XfOrM57_COUNT)
#             define SETUP_XfOrM62(x) SETUP_XfOrM57(x)

# 802 "bc/src/read.c"
              ch = FUNCCALL(SETUP_XfOrM62(_), scheme_getc (port ) ); 
            }

            if ((track == 1 ) && (scanpos == 4 ) ) {

              kind = 0 ; 
            }

# 808 "bc/src/read.c"
            else if ((track == 0 ) && (scanpos == 2 ) ) {

              kind = 1 ; 
            }

# 811 "bc/src/read.c"
            else if ((track == 2 ) && (scanpos == 5 ) ) {

              kind = 3 ; 
            }

# 814 "bc/src/read.c"
            else {

              kind = 2 ; 
            }

            if (ch == '(' )
              RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_hash (port , ch , ')' , kind , params ) )) RET_VALUE_EMPTY_END ; 
            if (ch == '[' )
              RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_hash (port , ch , ']' , kind , params ) )) RET_VALUE_EMPTY_END ; 
            if (ch == '{' )
              RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_hash (port , ch , '}' , kind , params ) )) RET_VALUE_EMPTY_END ; 
          }


          {
            mzchar str_part [7 ] , one_more [2 ] ; 
#           define XfOrM53_COUNT (0+XfOrM52_COUNT)
#           define SETUP_XfOrM53(x) SETUP_XfOrM52(x)

# 831 "bc/src/read.c"
            if (track == 2 ) {
#             define XfOrM56_COUNT (0+XfOrM53_COUNT)
#             define SETUP_XfOrM56(x) SETUP_XfOrM53(x)
              (
# 832 "bc/src/read.c"
              memcpy (str_part , str2 , scanpos * sizeof (mzchar ) ) ) ; 
            }

# 833 "bc/src/read.c"
            else {
#             define XfOrM55_COUNT (0+XfOrM53_COUNT)
#             define SETUP_XfOrM55(x) SETUP_XfOrM53(x)
              (
# 834 "bc/src/read.c"
              memcpy (str_part , str1 , scanpos * sizeof (mzchar ) ) ) ; 
            }
            str_part [scanpos ] = 0 ; 
            if ((ch ) >= 0 )  {
              one_more [0 ] = ch ; 
              one_more [1 ] = 0 ; 
            }

# 840 "bc/src/read.c"
            else 
            one_more [0 ] = 0 ; 
            FUNCCALL_EMPTY(scheme_read_err (port , "read: bad syntax `#ha%5%u'" , str_part , one_more , (intptr_t ) (((ch ) >= 0 ) ? 1 : 0 ) ) )


            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
        }
      }
      break ; 
      case '"' : 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_string (1 , port , params , 1 ) )) RET_VALUE_EMPTY_END ; 
      default : 
      if (ch == '(' )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , ch , ')' , params , 0 ) )) RET_VALUE_EMPTY_END ; 
      else if (ch == '[' )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , ch , ']' , params , 0 ) )) RET_VALUE_EMPTY_END ; 
      else if (ch == '{' )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_vector (port , ch , '}' , params , 0 ) )) RET_VALUE_EMPTY_END ; 
      else if ((ch >= '0' ) && (ch <= '9' ) )  {

        int nch = ch , index ; 
        Scheme_Object * val ; 
        BLOCK_SETUP((PUSH(val, 0+XfOrM46_COUNT)));
#       define XfOrM48_COUNT (1+XfOrM46_COUNT)
#       define SETUP_XfOrM48(x) SETUP(XfOrM48_COUNT)
        val = NULLED_OUT ; 

# 865 "bc/src/read.c"
        index = FUNCCALL(SETUP_XfOrM48(_), read_graph_index (port , & nch ) ); 
        switch (nch ) {
#         define XfOrM49_COUNT (0+XfOrM48_COUNT)
#         define SETUP_XfOrM49(x) SETUP_XfOrM48(x)

# 867 "bc/src/read.c"
          case '#' : 
          if (params -> graph_ht )
            val = FUNCCALL(SETUP_XfOrM49(_), scheme_hash_get (params -> graph_ht , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (index ) ) ) << 1 ) | 0x1 ) ) ) ); 
          else 
          val = ((void * ) 0 ) ; 
          if (! val )
            FUNCCALL_EMPTY(scheme_read_err (port , "read: no value for `#%d#`" , index ) )

          ; 
          RET_VALUE_START (val ) RET_VALUE_END ; 
          case '=' : 
          if (! params -> graph_ht ) {
            Scheme_Hash_Table * ht ; 
            BLOCK_SETUP((PUSH(ht, 0+XfOrM49_COUNT)));
#           define XfOrM50_COUNT (1+XfOrM49_COUNT)
#           define SETUP_XfOrM50(x) SETUP(XfOrM50_COUNT)
            ht = NULLED_OUT ; 

# 880 "bc/src/read.c"
            ht = FUNCCALL(SETUP_XfOrM50(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            params -> graph_ht = ht ; 
          }
          if (FUNCCALL(SETUP_XfOrM49(_), scheme_hash_get (params -> graph_ht , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (index ) ) ) << 1 ) | 0x1 ) ) ) ))
            FUNCCALL_EMPTY(scheme_read_err (port , "read: duplicate `#%d=` definition" , index ) )

          ; 
          val = FUNCCALL(SETUP_XfOrM49(_), read_inner (port , params , - 1 ) ); 
          FUNCCALL_AGAIN(scheme_hash_set (params -> graph_ht , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (index ) ) ) << 1 ) | 0x1 ) ) , val ) ); 
          RET_VALUE_START (val ) RET_VALUE_END ; 
          default : FUNCCALL_EMPTY(scheme_read_err (port , "read: expected `=` or `#` after `#%d`, found `%c`" , index , nch ) )


          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      else {
#       define XfOrM47_COUNT (0+XfOrM46_COUNT)
#       define SETUP_XfOrM47(x) SETUP_XfOrM46(x)
        FUNCCALL_EMPTY(scheme_read_err (port , "read: bad syntax `#%c`" , ch ) )
# 898 "bc/src/read.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
    default : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_number_or_symbol (ch , port , 0 , 0 , 10 , 0 , 0 , 0 , params ) )) RET_VALUE_EMPTY_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 908 "bc/src/read.c"
static Scheme_Object * resolve_references (Scheme_Object * obj , 
Scheme_Object * top , 
Scheme_Hash_Table * dht , 
Scheme_Hash_Table * tht , 
Scheme_Hash_Table * self_contained_ht , 
int clone , 
int tail_depth ) ; 

static Scheme_Object * resolve_k (void ) 
{
  /* No conversion */

# 918 "bc/src/read.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * top = (Scheme_Object * ) p -> ku . k . p5 ; 
  Scheme_Hash_Table * dht = (Scheme_Hash_Table * ) p -> ku . k . p3 ; 
  Scheme_Hash_Table * tht = (Scheme_Hash_Table * ) (((Scheme_Simple_Object * ) ((Scheme_Object * ) p -> ku . k . p4 ) ) -> u . pair_val . car ) ; 
  Scheme_Hash_Table * self_contained_ht = (Scheme_Hash_Table * ) (((Scheme_Simple_Object * ) ((Scheme_Object * ) p -> ku . k . p4 ) ) -> u . pair_val . cdr ) ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 

  return resolve_references (o , top , dht , tht , self_contained_ht , p -> ku . k . i1 , p -> ku . k . i2 ) ; 
}


static Scheme_Object * resolve_references (Scheme_Object * obj , 
Scheme_Object * top , 
Scheme_Hash_Table * dht , 
Scheme_Hash_Table * tht , 
Scheme_Hash_Table * self_contained_ht , 
int clone , 
int tail_depth ) 
{
  Scheme_Object * result ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(tht, 0), PUSH(obj, 1), PUSH(result, 2), PUSH(dht, 3), PUSH(self_contained_ht, 4), PUSH(top, 5)));
# define XfOrM125_COUNT (6)
# define SETUP_XfOrM125(x) SETUP(XfOrM125_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  result = NULLED_OUT ; 

# 945 "bc/src/read.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM171_COUNT (0+XfOrM125_COUNT)
#   define SETUP_XfOrM171(x) SETUP_XfOrM125(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 947 "bc/src/read.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      BLOCK_SETUP((PUSH(p, 0+XfOrM171_COUNT)));
#     define XfOrM172_COUNT (1+XfOrM171_COUNT)
#     define SETUP_XfOrM172(x) SETUP(XfOrM172_COUNT)

# 949 "bc/src/read.c"
      p -> ku . k . p1 = (void * ) obj ; 
      p -> ku . k . p5 = (void * ) top ; 
      p -> ku . k . p3 = (void * ) dht ; 
      result = FUNCCALL(SETUP_XfOrM172(_), scheme_make_pair ((Scheme_Object * ) tht , (Scheme_Object * ) self_contained_ht ) )
      ; 
      p -> ku . k . p4 = (void * ) result ; 
      p -> ku . k . i1 = clone ; 
      p -> ku . k . i2 = tail_depth ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (resolve_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  {
#   define XfOrM169_COUNT (0+XfOrM125_COUNT)
#   define SETUP_XfOrM169(x) SETUP_XfOrM125(x)

# 962 "bc/src/read.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM170_COUNT (0+XfOrM169_COUNT)
#     define SETUP_XfOrM170(x) SETUP_XfOrM169(x)
      FUNCCALL(SETUP_XfOrM170(_), scheme_out_of_fuel () )
# 962 "bc/src/read.c"
      ; 
    }
  }

# 962 "bc/src/read.c"
  ; 

  if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_placeholder_type ) )  {
    Scheme_Object * start = obj ; 
#   define XfOrM164_COUNT (0+XfOrM125_COUNT)
#   define SETUP_XfOrM164(x) SETUP_XfOrM125(x)

# 966 "bc/src/read.c"
    while (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_placeholder_type ) ) ) {
#     define XfOrM167_COUNT (0+XfOrM164_COUNT)
#     define SETUP_XfOrM167(x) SETUP_XfOrM164(x)

# 967 "bc/src/read.c"
      obj = (Scheme_Object * ) (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
      if ((start ) == (obj ) )  {
#       define XfOrM168_COUNT (0+XfOrM167_COUNT)
#       define SETUP_XfOrM168(x) SETUP_XfOrM167(x)
        FUNCCALL_EMPTY(scheme_contract_error ("make-reader-graph" , "illegal placeholder cycle in value" , "value" , 1 , top , ((void * ) 0 ) ) )
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
  }

  if (self_contained_ht 
  && FUNCCALL(SETUP_XfOrM125(_), scheme_hash_get (self_contained_ht , obj ) ))
    RET_VALUE_START (obj ) RET_VALUE_END ; 

  result = FUNCCALL(SETUP_XfOrM125(_), scheme_hash_get (dht , obj ) ); 
  if (result ) {
#   define XfOrM162_COUNT (0+XfOrM125_COUNT)
#   define SETUP_XfOrM162(x) SETUP_XfOrM125(x)

# 984 "bc/src/read.c"
    if ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM163_COUNT (0+XfOrM162_COUNT)
#     define SETUP_XfOrM163(x) SETUP_XfOrM162(x)

# 985 "bc/src/read.c"
      obj = FUNCCALL(SETUP_XfOrM163(_), scheme_hash_get (tht , result ) ); 
      if (obj && ((((intptr_t ) (obj ) ) >> 1 ) == tail_depth ) )
        (& ((Scheme_Simple_Object * ) result ) -> iso ) -> so . keyex |= 0x2 ; 
    }
    RET_VALUE_START (result ) RET_VALUE_END ; 
  }

  result = obj ; 

  if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * rr ; 
    BLOCK_SETUP((PUSH(rr, 0+XfOrM125_COUNT)));
#   define XfOrM160_COUNT (1+XfOrM125_COUNT)
#   define SETUP_XfOrM160(x) SETUP(XfOrM160_COUNT)
    rr = NULLED_OUT ; 

# 997 "bc/src/read.c"
    if (clone )
      result = FUNCCALL(SETUP_XfOrM160(_), scheme_make_pair (scheme_false , scheme_false ) ); 
    FUNCCALL(SETUP_XfOrM160(_), scheme_hash_set (dht , obj , result ) ); 

    rr = FUNCCALL_AGAIN(resolve_references ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , top , dht , tht , self_contained_ht , clone , tail_depth + 1 ) )
    ; 
    (((Scheme_Simple_Object * ) (result ) ) -> u . pair_val . car ) = rr ; 
    FUNCCALL(SETUP_XfOrM160(_), scheme_hash_set (tht , result , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (tail_depth ) ) ) << 1 ) | 0x1 ) ) ) )
    ; 

    rr = FUNCCALL_AGAIN(resolve_references ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , top , dht , tht , self_contained_ht , clone , tail_depth ) )
    ; 
    (((Scheme_Simple_Object * ) (result ) ) -> u . pair_val . cdr ) = rr ; 
    FUNCCALL(SETUP_XfOrM160(_), scheme_hash_set (tht , result , ((void * ) 0 ) ) )
    ; 

    if (clone 
    && (((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) ) == ((((Scheme_Simple_Object * ) (result ) ) -> u . pair_val . car ) ) ) 
    && (((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ) == ((((Scheme_Simple_Object * ) (result ) ) -> u . pair_val . cdr ) ) ) ) {
#     define XfOrM161_COUNT (0+XfOrM160_COUNT)
#     define SETUP_XfOrM161(x) SETUP_XfOrM160(x)

# 1017 "bc/src/read.c"
      result = obj ; 
      FUNCCALL(SETUP_XfOrM161(_), scheme_hash_set (dht , obj , result ) ); 
    }
  }

# 1020 "bc/src/read.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) )  {
    Scheme_Object * rr ; 
    BLOCK_SETUP((PUSH(rr, 0+XfOrM125_COUNT)));
#   define XfOrM157_COUNT (1+XfOrM125_COUNT)
#   define SETUP_XfOrM157(x) SETUP(XfOrM157_COUNT)
    rr = NULLED_OUT ; 

# 1023 "bc/src/read.c"
    if (clone ) {
#     define XfOrM159_COUNT (0+XfOrM157_COUNT)
#     define SETUP_XfOrM159(x) SETUP_XfOrM157(x)

# 1024 "bc/src/read.c"
      result = FUNCCALL(SETUP_XfOrM159(_), scheme_box (scheme_false ) ); 
      if (((Scheme_Inclhash_Object * ) (obj ) ) -> so . keyex & 0x1 ) 
        ((((Scheme_Inclhash_Object * ) (result ) ) -> so . keyex |= 0x1 ) ) ; 
    }
    FUNCCALL(SETUP_XfOrM157(_), scheme_hash_set (dht , obj , result ) ); 

    rr = FUNCCALL(SETUP_XfOrM157(_), resolve_references ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , top , dht , tht , self_contained_ht , clone , tail_depth + 1 ) )
    ; 
    (((Scheme_Small_Object * ) (result ) ) -> u . ptr_val ) = rr ; 

    if (clone 
    && (((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ) == ((((Scheme_Small_Object * ) (result ) ) -> u . ptr_val ) ) ) ) {
#     define XfOrM158_COUNT (0+XfOrM157_COUNT)
#     define SETUP_XfOrM158(x) SETUP_XfOrM157(x)

# 1036 "bc/src/read.c"
      result = obj ; 
      FUNCCALL(SETUP_XfOrM158(_), scheme_hash_set (dht , obj , result ) ); 
    }
  }

# 1039 "bc/src/read.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
  || (clone && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) ) ) {
    int i , len , diff = 0 ; 
    Scheme_Object * prev_rr , * prev_v ; 
    BLOCK_SETUP((PUSH(prev_rr, 0+XfOrM125_COUNT), PUSH(prev_v, 1+XfOrM125_COUNT)));
#   define XfOrM148_COUNT (2+XfOrM125_COUNT)
#   define SETUP_XfOrM148(x) SETUP(XfOrM148_COUNT)
    prev_rr = NULLED_OUT ; 
    prev_v = NULLED_OUT ; 

# 1044 "bc/src/read.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      obj = FUNCCALL(SETUP_XfOrM148(_), scheme_chaperone_vector_copy (obj ) ); 

    len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 

    if (clone ) {
#     define XfOrM156_COUNT (0+XfOrM148_COUNT)
#     define SETUP_XfOrM156(x) SETUP_XfOrM148(x)

# 1050 "bc/src/read.c"
      result = FUNCCALL(SETUP_XfOrM156(_), scheme_make_vector (len , scheme_false ) ); 
      if (((Scheme_Inclhash_Object * ) (obj ) ) -> so . keyex & 0x1 ) 
        ((((Scheme_Inclhash_Object * ) (result ) ) -> so . keyex |= 0x1 ) ) ; 
    }
    FUNCCALL(SETUP_XfOrM148(_), scheme_hash_set (dht , obj , result ) ); 

    prev_v = prev_rr = ((void * ) 0 ) ; 
    for (i = 0 ; i < len ; i ++ ) {
      Scheme_Object * rr ; 
      BLOCK_SETUP((PUSH(rr, 0+XfOrM148_COUNT)));
#     define XfOrM153_COUNT (1+XfOrM148_COUNT)
#     define SETUP_XfOrM153(x) SETUP(XfOrM153_COUNT)
      rr = NULLED_OUT ; 

# 1059 "bc/src/read.c"
      if ((((Scheme_Vector * ) (obj ) ) -> els ) [i ] == prev_v ) {
        rr = prev_rr ; 
      }

# 1061 "bc/src/read.c"
      else {
#       define XfOrM154_COUNT (0+XfOrM153_COUNT)
#       define SETUP_XfOrM154(x) SETUP_XfOrM153(x)

# 1062 "bc/src/read.c"
        prev_v = (((Scheme_Vector * ) (obj ) ) -> els ) [i ] ; 
        rr = FUNCCALL(SETUP_XfOrM154(_), resolve_references (prev_v , top , dht , tht , self_contained_ht , clone , tail_depth + 1 ) )
        ; 
        if (! ((prev_v ) == (rr ) ) )
          diff = 1 ; 
        prev_rr = rr ; 
      }
      (((Scheme_Vector * ) (result ) ) -> els ) [i ] = rr ; 
    }

    if (clone && ! diff ) {
#     define XfOrM149_COUNT (0+XfOrM148_COUNT)
#     define SETUP_XfOrM149(x) SETUP_XfOrM148(x)

# 1073 "bc/src/read.c"
      result = obj ; 
      FUNCCALL(SETUP_XfOrM149(_), scheme_hash_set (dht , obj , result ) ); 
    }
  }

# 1076 "bc/src/read.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_table_placeholder_type ) ) 
  || ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
  || (clone && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
  || ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) ) ) {
    Scheme_Hash_Tree * t , * base ; 
    Scheme_Object * a , * key , * val , * lst ; 
    int kind ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM125_COUNT), PUSH(a, 1+XfOrM125_COUNT), PUSH(base, 2+XfOrM125_COUNT), PUSH(key, 3+XfOrM125_COUNT), PUSH(lst, 4+XfOrM125_COUNT), PUSH(val, 5+XfOrM125_COUNT)));
#   define XfOrM141_COUNT (6+XfOrM125_COUNT)
#   define SETUP_XfOrM141(x) SETUP(XfOrM141_COUNT)
    t = NULLED_OUT ; 
    base = NULLED_OUT ; 
    a = NULLED_OUT ; 
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 
    lst = NULLED_OUT ; 

# 1085 "bc/src/read.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      obj = FUNCCALL(SETUP_XfOrM141(_), scheme_chaperone_hash_table_copy (obj ) ); 

    if ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
      mzlonglong i ; 
#     define XfOrM145_COUNT (0+XfOrM141_COUNT)
#     define SETUP_XfOrM145(x) SETUP_XfOrM141(x)

# 1090 "bc/src/read.c"
      if (FUNCCALL(SETUP_XfOrM145(_), scheme_is_hash_tree_equal (obj ) ))
        kind = 1 ; 
      else if (FUNCCALL(SETUP_XfOrM145(_), scheme_is_hash_tree_equal_always (obj ) ))
        kind = 3 ; 
      else if (FUNCCALL(SETUP_XfOrM145(_), scheme_is_hash_tree_eqv (obj ) ))
        kind = 2 ; 
      else 
      kind = 0 ; 
      t = (Scheme_Hash_Tree * ) obj ; 
      lst = scheme_null ; 
      for (i = (scheme_hash_tree_next (t , - 1 ) ) ; i != - 1 ; i = (scheme_hash_tree_next (t , i ) ) ) {
#       define XfOrM147_COUNT (0+XfOrM145_COUNT)
#       define SETUP_XfOrM147(x) SETUP_XfOrM145(x)
        (
# 1101 "bc/src/read.c"
        scheme_hash_tree_index (t , i , & key , & val ) ) ; 
        lst = (__funcarg77 = FUNCCALL(SETUP_XfOrM147(_), scheme_make_pair (key , val ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg77 , lst ) )) ; 
      }
    }

# 1104 "bc/src/read.c"
    else {
      kind = (((Scheme_Simple_Object * ) (obj ) ) -> u . ptr_int_val . pint ) ; 
      lst = (((Scheme_Simple_Object * ) (obj ) ) -> u . ptr_int_val . ptr ) ; 
    }


    base = (scheme_make_hash_tree (kind ) ) ; 
    if ((lst ) == (scheme_null ) ) 
      t = base ; 
    else 
    t = FUNCCALL(SETUP_XfOrM141(_), scheme_make_hash_tree_placeholder (kind ) ); 

    result = (Scheme_Object * ) t ; 
    FUNCCALL(SETUP_XfOrM141(_), scheme_hash_set (dht , obj , result ) ); 

    lst = FUNCCALL_AGAIN(resolve_references (lst , top , dht , tht , self_contained_ht , clone , tail_depth + 1 ) )
    ; 

    for (; ((Scheme_Type ) (((((intptr_t ) (lst ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lst ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; lst = (((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM143_COUNT (0+XfOrM141_COUNT)
#     define SETUP_XfOrM143(x) SETUP_XfOrM141(x)

# 1123 "bc/src/read.c"
      a = (((Scheme_Simple_Object * ) (lst ) ) -> u . pair_val . car ) ; 
      key = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 
      val = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 

      base = FUNCCALL(SETUP_XfOrM143(_), scheme_hash_tree_set (base , key , val ) ); 
    }

    if (base -> count )
      FUNCCALL(SETUP_XfOrM141(_), scheme_hash_tree_tie_placeholder (t , base ) ); 
  }

# 1132 "bc/src/read.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
    int i ; 
    Scheme_Object * key , * val , * l = scheme_null , * orig_l ; 
    Scheme_Hash_Table * t = (Scheme_Hash_Table * ) obj , * t2 ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM125_COUNT), PUSH(val, 1+XfOrM125_COUNT), PUSH(t, 2+XfOrM125_COUNT), PUSH(t2, 3+XfOrM125_COUNT), PUSH(orig_l, 4+XfOrM125_COUNT), PUSH(key, 5+XfOrM125_COUNT)));
#   define XfOrM132_COUNT (6+XfOrM125_COUNT)
#   define SETUP_XfOrM132(x) SETUP(XfOrM132_COUNT)
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 
    orig_l = NULLED_OUT ; 
    t2 = NULLED_OUT ; 

# 1137 "bc/src/read.c"
    t2 = FUNCCALL(SETUP_XfOrM132(_), scheme_clone_hash_table (t ) ); 
    FUNCCALL_AGAIN(scheme_reset_hash_table (t2 , ((void * ) 0 ) ) ); 
    result = (Scheme_Object * ) t2 ; 
    FUNCCALL(SETUP_XfOrM132(_), scheme_hash_set (dht , obj , (Scheme_Object * ) t2 ) )
    ; 

    for (i = t -> size ; i -- ; ) {
#     define XfOrM139_COUNT (0+XfOrM132_COUNT)
#     define SETUP_XfOrM139(x) SETUP_XfOrM132(x)

# 1144 "bc/src/read.c"
      if (t -> vals [i ] ) {
#       define XfOrM140_COUNT (0+XfOrM139_COUNT)
#       define SETUP_XfOrM140(x) SETUP_XfOrM139(x)

# 1145 "bc/src/read.c"
        key = t -> keys [i ] ; 
        val = t -> vals [i ] ; 
        l = (__funcarg75 = FUNCCALL(SETUP_XfOrM140(_), scheme_make_pair (key , val ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg75 , l ) )) ; 
      }
    }

    orig_l = l ; 
    l = FUNCCALL(SETUP_XfOrM132(_), resolve_references (l , top , dht , tht , self_contained_ht , clone , tail_depth + 1 ) )
    ; 

    if ((l ) == (orig_l ) )  {
#     define XfOrM136_COUNT (0+XfOrM132_COUNT)
#     define SETUP_XfOrM136(x) SETUP_XfOrM132(x)

# 1156 "bc/src/read.c"
      result = obj ; 
      FUNCCALL(SETUP_XfOrM136(_), scheme_hash_set (dht , obj , result ) ); 
    }

# 1158 "bc/src/read.c"
    else {
#     define XfOrM133_COUNT (0+XfOrM132_COUNT)
#     define SETUP_XfOrM133(x) SETUP_XfOrM132(x)

# 1159 "bc/src/read.c"
      for (; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#       define XfOrM135_COUNT (0+XfOrM133_COUNT)
#       define SETUP_XfOrM135(x) SETUP_XfOrM133(x)

# 1160 "bc/src/read.c"
        val = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        key = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) ; 
        val = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . cdr ) ; 
        FUNCCALL(SETUP_XfOrM135(_), scheme_hash_set (t2 , key , val ) )
        ; 
      }
    }
  }

# 1167 "bc/src/read.c"
  else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  || (clone && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) ) ) {
    Scheme_Structure * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM125_COUNT)));
#   define XfOrM126_COUNT (1+XfOrM125_COUNT)
#   define SETUP_XfOrM126(x) SETUP(XfOrM126_COUNT)
    s = NULLED_OUT ; 

# 1170 "bc/src/read.c"
    if (clone && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) )
      s = (Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    s = (Scheme_Structure * ) obj ; 
    if (s -> stype -> prefab_key ) {

      int c , i , diff ; 
      Scheme_Object * prev_v , * v ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM126_COUNT), PUSH(prev_v, 1+XfOrM126_COUNT)));
#     define XfOrM127_COUNT (2+XfOrM126_COUNT)
#     define SETUP_XfOrM127(x) SETUP(XfOrM127_COUNT)
      prev_v = NULLED_OUT ; 
      v = NULLED_OUT ; 

# 1179 "bc/src/read.c"
      if (clone ) {
#       define XfOrM131_COUNT (0+XfOrM127_COUNT)
#       define SETUP_XfOrM131(x) SETUP_XfOrM127(x)

# 1180 "bc/src/read.c"
        result = FUNCCALL(SETUP_XfOrM131(_), scheme_clone_prefab_struct_instance ((Scheme_Structure * ) obj ) ); 
      }
      FUNCCALL(SETUP_XfOrM127(_), scheme_hash_set (dht , obj , result ) ); 

      c = s -> stype -> num_slots ; 
      diff = 0 ; 
      for (i = 0 ; i < c ; i ++ ) {
#       define XfOrM130_COUNT (0+XfOrM127_COUNT)
#       define SETUP_XfOrM130(x) SETUP_XfOrM127(x)

# 1187 "bc/src/read.c"
        prev_v = ((Scheme_Structure * ) result ) -> slots [i ] ; 
        v = FUNCCALL(SETUP_XfOrM130(_), resolve_references (prev_v , top , dht , tht , self_contained_ht , clone , tail_depth + 1 ) )
        ; 
        if (! ((prev_v ) == (v ) ) )
          diff = 1 ; 
        ((Scheme_Structure * ) result ) -> slots [i ] = v ; 
      }

      if (clone && ! diff ) {
#       define XfOrM128_COUNT (0+XfOrM127_COUNT)
#       define SETUP_XfOrM128(x) SETUP_XfOrM127(x)

# 1196 "bc/src/read.c"
        result = obj ; 
        FUNCCALL(SETUP_XfOrM128(_), scheme_hash_set (dht , obj , result ) ); 
      }
    }
  }

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1205 "bc/src/read.c"
static Scheme_Object * 
_internal_read (Scheme_Object * port , int crc , int cant_fail , 
int extra_char , 
Scheme_Object * delay_load_info ) 
{
  Scheme_Object * v , * v2 ; 
  ReadParams params ; 
  Scheme_Config * __funcarg81 = NULLED_OUT ; 
  Scheme_Config * __funcarg80 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg79 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg78 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(__funcarg78, 1), PUSH(port, 2), PUSH(v2, 3), PUSH(params.delay_load_info, 4), PUSH(params.read_relative_path, 5), PUSH(params.graph_ht, 6), PUSH(delay_load_info, 7)));
# define XfOrM173_COUNT (8)
# define SETUP_XfOrM173(x) SETUP(XfOrM173_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  v2 = NULLED_OUT ; 
  params.delay_load_info = NULLED_OUT ; 
  params.read_relative_path = NULLED_OUT ; 
  params.graph_ht = NULLED_OUT ; 

# 1213 "bc/src/read.c"
  if (crc >= 0 ) {
    params . can_read_unsafe = 1 ; 
  }

# 1215 "bc/src/read.c"
  else {
#   define XfOrM174_COUNT (0+XfOrM173_COUNT)
#   define SETUP_XfOrM174(x) SETUP_XfOrM173(x)

# 1216 "bc/src/read.c"
    v = (__funcarg81 = FUNCCALL(SETUP_XfOrM174(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg81 , MZCONFIG_CODE_INSPECTOR ) )) ; 
    v2 = (scheme_get_initial_inspector () ) ; 
    params . can_read_unsafe = ((v ) == (v2 ) ) ; 
  }
  params . read_relative_path = ((void * ) 0 ) ; 
  if (! delay_load_info )
    delay_load_info = (__funcarg80 = FUNCCALL(SETUP_XfOrM173(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg80 , MZCONFIG_DELAY_LOAD_INFO ) )) ; 
  if (! (((delay_load_info ) ) == (scheme_false ) ) ) 
    params . delay_load_info = delay_load_info ; 
  else 
  params . delay_load_info = ((void * ) 0 ) ; 
  params . skip_zo_vers_check = cant_fail ; 
  params . graph_ht = ((void * ) 0 ) ; 

  v = FUNCCALL(SETUP_XfOrM173(_), read_inner (port , & params , extra_char ) ); 

  if (params . graph_ht )
    v = (__funcarg78 = FUNCCALL(SETUP_XfOrM173(_), scheme_make_hash_table (SCHEME_hash_ptr ) )
  , __funcarg79 = FUNCCALL(SETUP_XfOrM173(_), scheme_make_hash_table (SCHEME_hash_ptr ) )
  , FUNCCALL_AGAIN(resolve_references (v , ((void * ) 0 ) , __funcarg78 , __funcarg79 , ((void * ) 0 ) , 0 , 0 ) )) 
  ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1241 "bc/src/read.c"
static void * scheme_internal_read_k (void ) 
{
  /* No conversion */

# 1243 "bc/src/read.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * port = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * delay_load_info = (Scheme_Object * ) p -> ku . k . p5 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 

  return (void * ) _internal_read (port , p -> ku . k . i1 , 0 , p -> ku . k . i4 , delay_load_info ) ; 
}

Scheme_Object * 
scheme_internal_read (Scheme_Object * port , int crc , int cantfail , 
int pre_char , 
Scheme_Object * delay_load_info ) 
{
  /* No conversion */

# 1259 "bc/src/read.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (cantfail ) {
    return _internal_read (port , crc , cantfail , - 1 , delay_load_info ) ; 
  }

# 1263 "bc/src/read.c"
  else {
    p -> ku . k . p1 = (void * ) port ; 
    p -> ku . k . i1 = crc ; 
    p -> ku . k . i4 = pre_char ; 
    p -> ku . k . p5 = (void * ) delay_load_info ; 

    return (Scheme_Object * ) scheme_top_level_do (scheme_internal_read_k , 0 ) ; 
  }
}

Scheme_Object * scheme_read (Scheme_Object * port ) 
{
  Scheme_Object * read_proc , * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(read_proc, 0), PUSH(port, 1), PUSHARRAY(a, 1, 2)));
# define XfOrM180_COUNT (5)
# define SETUP_XfOrM180(x) SETUP(XfOrM180_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  read_proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 1276 "bc/src/read.c"
  read_proc = FUNCCALL(SETUP_XfOrM180(_), scheme_get_startup_export ("read" ) ); 
  a [0 ] = port ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM180(_), scheme_apply (read_proc , 1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1281 "bc/src/read.c"
Scheme_Object * scheme_read_syntax (Scheme_Object * port , Scheme_Object * stxsrc ) 
{
  Scheme_Object * read_syntax_proc , * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(stxsrc, 3), PUSH(port, 4), PUSH(read_syntax_proc, 5)));
# define XfOrM181_COUNT (6)
# define SETUP_XfOrM181(x) SETUP(XfOrM181_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  read_syntax_proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1284 "bc/src/read.c"
  read_syntax_proc = FUNCCALL(SETUP_XfOrM181(_), scheme_get_startup_export ("read-syntax" ) ); 
  a [0 ] = stxsrc ; 
  a [1 ] = port ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM181(_), scheme_apply (read_syntax_proc , 2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1290 "bc/src/read.c"
Scheme_Object * scheme_resolve_placeholders (Scheme_Object * obj ) 
{
  Scheme_Hash_Table * __funcarg83 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg82 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(__funcarg82, 1)));
# define XfOrM182_COUNT (2)
# define SETUP_XfOrM182(x) SETUP(XfOrM182_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1292 "bc/src/read.c"
  RET_VALUE_START ((__funcarg82 = FUNCCALL(SETUP_XfOrM182(_), scheme_make_hash_table (SCHEME_hash_ptr ) )
  , __funcarg83 = FUNCCALL(SETUP_XfOrM182(_), scheme_make_hash_table (SCHEME_hash_ptr ) )
  , FUNCCALL_EMPTY(resolve_references (obj , obj , __funcarg82 , __funcarg83 , ((void * ) 0 ) , 1 , 0 ) )) ) 
# 1292 "bc/src/read.c"
  RET_VALUE_END 



  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int next_is_delim (Scheme_Object * port ) 
{
  /* No conversion */

# 1305 "bc/src/read.c"
  int next ; 
  next = scheme_peekc (port ) ; 
  return ((next == (- 1 ) ) 
  || (next == (- 2 ) ) 
  || ((((scheme_uchar_table [(next >> 8 ) & 0x1FFF ] [next & 0xFF ] ) ) & 0x10 ) 
  || (next == '(' ) 
  || (next == ')' ) 
  || (next == '"' ) 
  || (next == ';' ) 
  || (next == '\'' ) 
  || (next == '`' ) 
  || (next == ',' ) 
  || ((next == '[' ) ) 
  || ((next == '{' ) ) 
  || ((next == ']' ) ) 
  || ((next == '}' ) ) ) ) ; 
}


static Scheme_Object * 
read_list (Scheme_Object * port , 
int opener , int closer , int shape , int use_stack , 
ReadParams * params ) 
{
  Scheme_Object * list = ((void * ) 0 ) , * last = ((void * ) 0 ) , * car , * cdr , * pair , * infixed = ((void * ) 0 ) ; 
  int ch = 0 , got_ch_already = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(last, 1), PUSH(infixed, 2), PUSH(car, 3), PUSH(list, 4), PUSH(cdr, 5), PUSH(pair, 6), PUSH(params, 7)));
# define XfOrM184_COUNT (8)
# define SETUP_XfOrM184(x) SETUP(XfOrM184_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  car = NULLED_OUT ; 
  cdr = NULLED_OUT ; 
  pair = NULLED_OUT ; 

# 1332 "bc/src/read.c"
  while (1 ) {
#   define XfOrM206_COUNT (0+XfOrM184_COUNT)
#   define SETUP_XfOrM206(x) SETUP_XfOrM184(x)

# 1333 "bc/src/read.c"
    if (got_ch_already )
      got_ch_already = 0 ; 
    else 
    ch = FUNCCALL(SETUP_XfOrM206(_), skip_whitespace_comments (port , params ) ); 

    if ((ch == (- 1 ) ) && (closer != (- 1 ) ) ) {
#     define XfOrM226_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM226(x) SETUP_XfOrM206(x)
      FUNCCALL_EMPTY(scheme_read_err (port , "read: expected a `%c` to close `%c`" , closer , opener ) )
# 1339 "bc/src/read.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (ch == closer ) {
#     define XfOrM224_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM224(x) SETUP_XfOrM206(x)

# 1344 "bc/src/read.c"
      if (shape == 3 ) {
#       define XfOrM225_COUNT (0+XfOrM224_COUNT)
#       define SETUP_XfOrM225(x) SETUP_XfOrM224(x)
        FUNCCALL_EMPTY(scheme_read_err (port , "read: expected hash pair (with key and value separated by `.`) before `%c`" , ch ) )
# 1345 "bc/src/read.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      if (! list )

# 1348 "bc/src/read.c"
      list = scheme_null ; 
      RET_VALUE_START (list ) RET_VALUE_END ; 
    }

    if (shape == 2 ) {
#     define XfOrM221_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM221(x) SETUP_XfOrM206(x)

# 1354 "bc/src/read.c"
      if (! (ch == '(' ) 
      && ! (ch == '[' ) 
      && ! (ch == '{' ) ) {
#       define XfOrM223_COUNT (0+XfOrM221_COUNT)
#       define SETUP_XfOrM223(x) SETUP_XfOrM221(x)
        FUNCCALL_EMPTY(scheme_read_err (port , "read: expected `(`, `[`, or `{` to start a hash pair" ) )
# 1357 "bc/src/read.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

# 1359 "bc/src/read.c"
      else {
#       define XfOrM222_COUNT (0+XfOrM221_COUNT)
#       define SETUP_XfOrM222(x) SETUP_XfOrM221(x)

# 1361 "bc/src/read.c"
        car = FUNCCALL(SETUP_XfOrM222(_), read_list (port , ch , ((ch == '(' ) ? ')' : ((ch == '[' ) ? ']' : '}' ) ) , 3 , use_stack , params ) )

        ; 
      }
    }
    else {
#     define XfOrM220_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM220(x) SETUP_XfOrM206(x)

# 1367 "bc/src/read.c"
      car = FUNCCALL(SETUP_XfOrM220(_), read_inner (port , params , ch ) ); 
    }


    pair = FUNCCALL(SETUP_XfOrM206(_), scheme_make_pair (car , scheme_null ) ); 

    ch = FUNCCALL(SETUP_XfOrM206(_), skip_whitespace_comments (port , params ) ); 
    if (ch == closer ) {
#     define XfOrM217_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM217(x) SETUP_XfOrM206(x)

# 1375 "bc/src/read.c"
      if (shape == 3 ) {
#       define XfOrM219_COUNT (0+XfOrM217_COUNT)
#       define SETUP_XfOrM219(x) SETUP_XfOrM217(x)
        FUNCCALL_EMPTY(scheme_read_err (port , "read: expected `.` and value for hash before `%c`" , ch ) )
# 1376 "bc/src/read.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

      cdr = pair ; 
      if (! list )
        list = cdr ; 
      else 
      (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = cdr ; 

      if (infixed ) {
#       define XfOrM218_COUNT (0+XfOrM217_COUNT)
#       define SETUP_XfOrM218(x) SETUP_XfOrM217(x)

# 1387 "bc/src/read.c"
        list = FUNCCALL(SETUP_XfOrM218(_), scheme_make_pair (infixed , list ) ); 
      }
      RET_VALUE_START (list ) RET_VALUE_END ; 
    }

# 1390 "bc/src/read.c"
    else if ((ch == '.' ) 
    && FUNCCALL(SETUP_XfOrM206(_), next_is_delim (port ) )) {
#     define XfOrM209_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM209(x) SETUP_XfOrM206(x)

# 1392 "bc/src/read.c"
      if (((shape != 0 ) 
      && (shape != 3 ) 
      && (shape != 4 ) ) 
      || infixed ) {
#       define XfOrM216_COUNT (0+XfOrM209_COUNT)
#       define SETUP_XfOrM216(x) SETUP_XfOrM209(x)
        FUNCCALL_EMPTY(scheme_read_err (port , "read: illegal use of `.`" ) )
# 1396 "bc/src/read.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }


      cdr = FUNCCALL(SETUP_XfOrM209(_), read_inner (port , params , - 1 ) ); 
      ch = FUNCCALL(SETUP_XfOrM209(_), skip_whitespace_comments (port , params ) ); 
      if ((ch != closer ) || (shape == 4 ) ) {
#       define XfOrM211_COUNT (0+XfOrM209_COUNT)
#       define SETUP_XfOrM211(x) SETUP_XfOrM209(x)

# 1404 "bc/src/read.c"
        if ((ch == '.' ) 
        && FUNCCALL(SETUP_XfOrM211(_), next_is_delim (port ) )) {
#         define XfOrM213_COUNT (0+XfOrM211_COUNT)
#         define SETUP_XfOrM213(x) SETUP_XfOrM211(x)
          if (shape == 3 ) {
#           define XfOrM215_COUNT (0+XfOrM213_COUNT)
#           define SETUP_XfOrM215(x) SETUP_XfOrM213(x)
            FUNCCALL_EMPTY(scheme_read_err (port , "read: expected `%c` after hash value" , closer ) )
# 1409 "bc/src/read.c"
            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }

          infixed = cdr ; 

          if (! list )
            list = pair ; 
          else 
          (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pair ; 
          last = pair ; 


          ch = FUNCCALL(SETUP_XfOrM213(_), skip_whitespace_comments (port , params ) ); 
          if ((ch == closer ) || (ch == (- 1 ) ) ) {
#           define XfOrM214_COUNT (0+XfOrM213_COUNT)
#           define SETUP_XfOrM214(x) SETUP_XfOrM213(x)
            FUNCCALL_EMPTY(scheme_read_err (port , "read: illegal use of `%c`" , ch ) )
# 1424 "bc/src/read.c"
            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          got_ch_already = 1 ; 
        }

# 1428 "bc/src/read.c"
        else {
#         define XfOrM212_COUNT (0+XfOrM211_COUNT)
#         define SETUP_XfOrM212(x) SETUP_XfOrM211(x)
          FUNCCALL_EMPTY(scheme_read_err (port , "read: illegal use of `.`" ) )
# 1429 "bc/src/read.c"
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }

# 1432 "bc/src/read.c"
      else {
        (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) = cdr ; 
        cdr = pair ; 
        if (! list )
          list = cdr ; 
        else 
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = cdr ; 


        RET_VALUE_START (list ) RET_VALUE_END ; 
      }
    }

# 1443 "bc/src/read.c"
    else {
#     define XfOrM207_COUNT (0+XfOrM206_COUNT)
#     define SETUP_XfOrM207(x) SETUP_XfOrM206(x)

# 1444 "bc/src/read.c"
      got_ch_already = 1 ; 

      if (shape == 3 ) {
#       define XfOrM208_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM208(x) SETUP_XfOrM207(x)
        FUNCCALL_EMPTY(scheme_read_err (port , "read: expected `.` and value for hash" ) )
# 1447 "bc/src/read.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

      cdr = pair ; 
      if (! list )
        list = cdr ; 
      else 
      (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = cdr ; 
      last = cdr ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


static Scheme_Object * 
read_string (int is_byte , Scheme_Object * port , ReadParams * params , int err_ok ) 
{
  mzchar * buf , * oldbuf , onstack [32 ] ; 
  int i , j , n , n1 , ch , closer = '"' ; 
  intptr_t size = 31 , oldsize ; 
  Scheme_Object * result ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(oldbuf, 0), PUSH(result, 1), PUSH(port, 2), PUSH(buf, 3)));
# define XfOrM227_COUNT (4)
# define SETUP_XfOrM227(x) SETUP(XfOrM227_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  buf = NULLED_OUT ; 
  oldbuf = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 1474 "bc/src/read.c"
  i = 0 ; 
  buf = onstack ; 
  while (1 ) {
#   define XfOrM272_COUNT (0+XfOrM227_COUNT)
#   define SETUP_XfOrM272(x) SETUP_XfOrM227(x)

# 1477 "bc/src/read.c"
    ch = FUNCCALL(SETUP_XfOrM272(_), scheme_getc (port ) ); 
    if (ch == closer )
      break ; 

    if (ch == (- 1 ) ) {
#     define XfOrM312_COUNT (0+XfOrM272_COUNT)
#     define SETUP_XfOrM312(x) SETUP_XfOrM272(x)

# 1482 "bc/src/read.c"
      if (err_ok )
        FUNCCALL_EMPTY(scheme_read_err (port , "read: expected a closing %s%s" , "'\"'" , (ch == (- 1 ) ) ? "" : " after one character" ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }


    if (ch == '\\' ) {
#     define XfOrM276_COUNT (0+XfOrM272_COUNT)
#     define SETUP_XfOrM276(x) SETUP_XfOrM272(x)

# 1491 "bc/src/read.c"
      ch = FUNCCALL(SETUP_XfOrM276(_), scheme_getc (port ) ); 
      if (ch == (- 1 ) ) {
#       define XfOrM311_COUNT (0+XfOrM276_COUNT)
#       define SETUP_XfOrM311(x) SETUP_XfOrM276(x)

# 1493 "bc/src/read.c"
        if (err_ok )
          FUNCCALL_EMPTY(scheme_read_err (port , "read: expected a closing %s" , "'\"'" ) ); 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      switch (ch ) {
#       define XfOrM277_COUNT (0+XfOrM276_COUNT)
#       define SETUP_XfOrM277(x) SETUP_XfOrM276(x)

# 1498 "bc/src/read.c"
        case '\\' : case '\"' : case '\'' : break ; 
        case 'a' : ch = '\a' ; 

# 1499 "bc/src/read.c"
        break ; 
        case 'b' : ch = '\b' ; 

# 1500 "bc/src/read.c"
        break ; 
        case 'e' : ch = 27 ; 

# 1501 "bc/src/read.c"
        break ; 
        case 'f' : ch = '\f' ; 

# 1502 "bc/src/read.c"
        break ; 
        case 'n' : ch = '\n' ; 

# 1503 "bc/src/read.c"
        break ; 
        case 'r' : ch = '\r' ; 

# 1504 "bc/src/read.c"
        break ; 
        case 't' : ch = '\t' ; 

# 1505 "bc/src/read.c"
        break ; 
        case 'v' : ch = '\v' ; 

# 1506 "bc/src/read.c"
        break ; 
        case '\r' : 
        if (FUNCCALL(SETUP_XfOrM277(_), scheme_peekc (port ) )== '\n' )
          FUNCCALL(SETUP_XfOrM277(_), scheme_getc (port ) ); 
        continue ; 
        case '\n' : 
        continue ; 
        case 'x' : 
        ch = FUNCCALL(SETUP_XfOrM277(_), scheme_getc (port ) ); 
        if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#         define XfOrM309_COUNT (0+XfOrM277_COUNT)
#         define SETUP_XfOrM309(x) SETUP_XfOrM277(x)

# 1516 "bc/src/read.c"
          n = ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ; 
          ch = FUNCCALL(SETUP_XfOrM309(_), scheme_peekc (port ) ); 
          if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#           define XfOrM310_COUNT (0+XfOrM309_COUNT)
#           define SETUP_XfOrM310(x) SETUP_XfOrM309(x)

# 1519 "bc/src/read.c"
            n = n * 16 + (ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ) ; 
            FUNCCALL(SETUP_XfOrM310(_), scheme_getc (port ) ); 
          }
          ch = n ; 
        }

# 1523 "bc/src/read.c"
        else {
#         define XfOrM308_COUNT (0+XfOrM277_COUNT)
#         define SETUP_XfOrM308(x) SETUP_XfOrM277(x)

# 1524 "bc/src/read.c"
          if (err_ok )
            FUNCCALL_EMPTY(scheme_read_err (port , "read: no hex digit following \\x in string" ) ); 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        break ; 
        case 'u' : 
        case 'U' : 
        if (! is_byte ) {
          int maxc = ((ch == 'u' ) ? 4 : 8 ) ; 
          char initial [9 ] ; 
#         define XfOrM290_COUNT (0+XfOrM277_COUNT)
#         define SETUP_XfOrM290(x) SETUP_XfOrM277(x)

# 1534 "bc/src/read.c"
          ch = FUNCCALL(SETUP_XfOrM290(_), scheme_getc (port ) ); 
          if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
            int count = 1 ; 
#           define XfOrM292_COUNT (0+XfOrM290_COUNT)
#           define SETUP_XfOrM292(x) SETUP_XfOrM290(x)

# 1537 "bc/src/read.c"
            initial [0 ] = ch ; 
            n = ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ; 
            while (count < maxc ) {
#             define XfOrM306_COUNT (0+XfOrM292_COUNT)
#             define SETUP_XfOrM306(x) SETUP_XfOrM292(x)

# 1540 "bc/src/read.c"
              ch = FUNCCALL(SETUP_XfOrM306(_), scheme_peekc (port ) ); 
              if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#               define XfOrM307_COUNT (0+XfOrM306_COUNT)
#               define SETUP_XfOrM307(x) SETUP_XfOrM306(x)

# 1542 "bc/src/read.c"
                initial [count ] = ch ; 
                n = ((unsigned ) n << 4 ) + (ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ) ; 
                FUNCCALL(SETUP_XfOrM307(_), scheme_getc (port ) ); 
                count ++ ; 
              }

# 1546 "bc/src/read.c"
              else 
              break ; 
            }
            initial [count ] = 0 ; 
            if ((maxc == 4 ) && ((n >= 0xD800 ) && (n <= 0xDBFF ) ) ) {


              int n2 = - 1 , sndp = 0 ; 
              mzchar snd [7 ] ; 
#             define XfOrM295_COUNT (0+XfOrM292_COUNT)
#             define SETUP_XfOrM295(x) SETUP_XfOrM292(x)

# 1555 "bc/src/read.c"
              ch = FUNCCALL(SETUP_XfOrM295(_), scheme_getc (port ) ); 
              if (ch == '\\' ) {
#               define XfOrM297_COUNT (0+XfOrM295_COUNT)
#               define SETUP_XfOrM297(x) SETUP_XfOrM295(x)

# 1557 "bc/src/read.c"
                snd [sndp ++ ] = ch ; 
                ch = FUNCCALL(SETUP_XfOrM297(_), scheme_getc (port ) ); 
                if (ch == 'u' ) {
#                 define XfOrM298_COUNT (0+XfOrM297_COUNT)
#                 define SETUP_XfOrM298(x) SETUP_XfOrM297(x)

# 1560 "bc/src/read.c"
                  snd [sndp ++ ] = ch ; 
                  ch = FUNCCALL(SETUP_XfOrM298(_), scheme_getc (port ) ); 
                  if ((ch == 'd' ) || (ch == 'D' ) ) {
#                   define XfOrM299_COUNT (0+XfOrM298_COUNT)
#                   define SETUP_XfOrM299(x) SETUP_XfOrM298(x)

# 1563 "bc/src/read.c"
                    snd [sndp ++ ] = ch ; 
                    ch = FUNCCALL(SETUP_XfOrM299(_), scheme_getc (port ) ); 
                    if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#                     define XfOrM300_COUNT (0+XfOrM299_COUNT)
#                     define SETUP_XfOrM300(x) SETUP_XfOrM299(x)

# 1566 "bc/src/read.c"
                      snd [sndp ++ ] = ch ; 
                      n2 = ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ; 
                      if ((n2 >= 12 ) && (n2 <= 15 ) ) {
#                       define XfOrM301_COUNT (0+XfOrM300_COUNT)
#                       define SETUP_XfOrM301(x) SETUP_XfOrM300(x)

# 1569 "bc/src/read.c"
                        n2 = 0xD000 | (n2 << 8 ) ; 
                        ch = FUNCCALL(SETUP_XfOrM301(_), scheme_getc (port ) ); 
                        if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#                         define XfOrM302_COUNT (0+XfOrM301_COUNT)
#                         define SETUP_XfOrM302(x) SETUP_XfOrM301(x)

# 1572 "bc/src/read.c"
                          snd [sndp ++ ] = ch ; 
                          n2 |= ((ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ) << 4 ) ; 
                          ch = FUNCCALL(SETUP_XfOrM302(_), scheme_getc (port ) ); 
                          if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
                            n2 |= (ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ) ; 
                            n = (((n - 0xD800 ) << 10 ) + (n2 - 0xDC00 ) ) + 0x10000 ; 
                          }

# 1578 "bc/src/read.c"
                          else 
                          n2 = - 1 ; 
                        }

# 1580 "bc/src/read.c"
                        else 
                        n2 = - 1 ; 
                      }

# 1582 "bc/src/read.c"
                      else 
                      n2 = - 1 ; 
                    }
                  }
                }
              }
              if (n2 < 0 ) {
#               define XfOrM296_COUNT (0+XfOrM295_COUNT)
#               define SETUP_XfOrM296(x) SETUP_XfOrM295(x)

# 1589 "bc/src/read.c"
                if ((ch ) >= 0 ) 
                  snd [sndp ++ ] = ch ; 
                snd [sndp ] = 0 ; 
                if (err_ok )
                  FUNCCALL_EMPTY(scheme_read_err (port , "read: bad or incomplete surrogate-style encoding at `\\u%s%5'" , initial , snd ) )


                ; 
                RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
              }
            }

            if (((n >= 0xD800 ) && (n <= 0xDFFF ) ) 
            || (n > 0x10FFFF ) ) {
              ch = - 1 ; 
            }

# 1604 "bc/src/read.c"
            else {
              ch = n ; 
            }
          }

# 1607 "bc/src/read.c"
          else {
#           define XfOrM291_COUNT (0+XfOrM290_COUNT)
#           define SETUP_XfOrM291(x) SETUP_XfOrM290(x)

# 1608 "bc/src/read.c"
            if (err_ok )
              FUNCCALL_EMPTY(scheme_read_err (port , "read: no hex digit following \\%c in %s" , ((maxc == 4 ) ? 'u' : 'U' ) , "string" ) )


            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          break ; 
        }
        default : 
        if ((ch >= '0' ) && (ch <= '7' ) ) {
#         define XfOrM279_COUNT (0+XfOrM277_COUNT)
#         define SETUP_XfOrM279(x) SETUP_XfOrM277(x)

# 1619 "bc/src/read.c"
          for (n = j = 0 ; j < 3 ; j ++ ) {
#           define XfOrM285_COUNT (0+XfOrM279_COUNT)
#           define SETUP_XfOrM285(x) SETUP_XfOrM279(x)

# 1620 "bc/src/read.c"
            n1 = 8 * n + ch - '0' ; 
            if (n1 > 255 ) {
#             define XfOrM289_COUNT (0+XfOrM285_COUNT)
#             define SETUP_XfOrM289(x) SETUP_XfOrM285(x)

# 1622 "bc/src/read.c"
              if (err_ok )
                FUNCCALL_EMPTY(scheme_read_err (port , "read: escape sequence \\%o out of range in %s" , n1 , "string" ) )

              ; 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
            n = n1 ; 
            if (j < 2 ) {
#             define XfOrM286_COUNT (0+XfOrM285_COUNT)
#             define SETUP_XfOrM286(x) SETUP_XfOrM285(x)

# 1630 "bc/src/read.c"
              ch = FUNCCALL(SETUP_XfOrM286(_), scheme_peekc (port ) ); 
              if (! ((ch >= '0' ) && (ch <= '7' ) ) ) {
                break ; 
              }

# 1633 "bc/src/read.c"
              else {
#               define XfOrM287_COUNT (0+XfOrM286_COUNT)
#               define SETUP_XfOrM287(x) SETUP_XfOrM286(x)
                FUNCCALL(SETUP_XfOrM287(_), scheme_getc (port ) )
# 1634 "bc/src/read.c"
                ; 
              }
            }
          }
          ch = n ; 
        }

# 1639 "bc/src/read.c"
        else {
#         define XfOrM278_COUNT (0+XfOrM277_COUNT)
#         define SETUP_XfOrM278(x) SETUP_XfOrM277(x)

# 1640 "bc/src/read.c"
          if (err_ok )
            FUNCCALL_EMPTY(scheme_read_err (port , "read: unknown escape sequence \\%c in %s%s" , ch , is_byte ? "byte " : "" , "string" ) )


          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        break ; 
      }
    }

# 1649 "bc/src/read.c"
    else if (is_byte && (ch > 255 ) ) {
#     define XfOrM275_COUNT (0+XfOrM272_COUNT)
#     define SETUP_XfOrM275(x) SETUP_XfOrM272(x)

# 1650 "bc/src/read.c"
      if (err_ok )
        FUNCCALL_EMPTY(scheme_read_err (port , "read: out-of-range character in byte string: %c" , ch ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (ch < 0 ) {
#     define XfOrM274_COUNT (0+XfOrM272_COUNT)
#     define SETUP_XfOrM274(x) SETUP_XfOrM272(x)

# 1658 "bc/src/read.c"
      if (err_ok )
        FUNCCALL_EMPTY(scheme_read_err (port , "read: out-of-range character in %sstring" , is_byte ? "byte " : "" ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (i >= size ) {
#     define XfOrM273_COUNT (0+XfOrM272_COUNT)
#     define SETUP_XfOrM273(x) SETUP_XfOrM272(x)

# 1666 "bc/src/read.c"
      oldsize = size ; 
      oldbuf = buf ; 

      size *= 2 ; 
      buf = (mzchar * ) FUNCCALL(SETUP_XfOrM273(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
      (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
    }
    buf [i ++ ] = ch ; 
  }
  buf [i ] = '\0' ; 

  if (! is_byte )
    result = FUNCCALL(SETUP_XfOrM227(_), scheme_make_immutable_sized_char_string (buf , i , i <= 31 ) ); 
  else {


    char * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM227_COUNT)));
#   define XfOrM228_COUNT (1+XfOrM227_COUNT)
#   define SETUP_XfOrM228(x) SETUP(XfOrM228_COUNT)
    s = NULLED_OUT ; 

# 1683 "bc/src/read.c"
    s = (char * ) FUNCCALL(SETUP_XfOrM228(_), GC_malloc_atomic (i + 1 ) ); 
    for (j = 0 ; j < i ; j ++ ) {
      ((unsigned char * ) s ) [j ] = buf [j ] ; 
    }
    s [i ] = 0 ; 
    result = FUNCCALL(SETUP_XfOrM228(_), scheme_make_immutable_sized_byte_string (s , i , 0 ) ); 
  }

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1694 "bc/src/read.c"
Scheme_Object * scheme_read_byte_string (Scheme_Object * port ) 

{
  /* No conversion */

# 1697 "bc/src/read.c"
  return read_string (1 , port , ((void * ) 0 ) , 0 ) ; 
}






static Scheme_Object * 
read_vector (Scheme_Object * port , 
int opener , char closer , 
ReadParams * params , 
int allow_infix ) 
{
  Scheme_Object * lresult , * obj ; 
  Scheme_Object * vec ; 
  int len , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(vec, 1), PUSH(lresult, 2)));
# define XfOrM314_COUNT (3)
# define SETUP_XfOrM314(x) SETUP(XfOrM314_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lresult = NULLED_OUT ; 
  obj = NULLED_OUT ; 
  vec = NULLED_OUT ; 

# 1715 "bc/src/read.c"
  lresult = FUNCCALL(SETUP_XfOrM314(_), read_list (port , opener , closer , (allow_infix ? 4 : 1 ) , 1 , params ) )

  ; 

  obj = lresult ; 

  len = (scheme_list_length (obj ) ) ; 

  vec = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM314(_), scheme_make_vector (len , ((void * ) 0 ) ) ); 
  for (i = 0 ; i < len ; i ++ ) {
    (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = (((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) ; 
    obj = (((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}




typedef int (* Getc_Fun_r ) (Scheme_Object * port ) ; 


static Scheme_Object * 
read_number_or_symbol (int init_ch , Scheme_Object * port , 
int is_float , int is_not_float , 
int radix , int radix_set , 
int is_symbol , int is_kw , 
ReadParams * params ) 
{
  mzchar * buf , * oldbuf , onstack [64 ] ; 
  int size , oldsize ; 
  int i , ch , quoted_ever = 0 , running_quote = 0 ; 
  int running_quote_ch = 0 ; 
  Scheme_Object * o ; 
  int delim_ok ; 
  int ungetc_ok ; 
  int far_char_ok ; 
  int single_escape , multiple_escape ; 
  Getc_Fun_r getc_fun ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(oldbuf, 0), PUSH(o, 1), PUSH(port, 2), PUSH(buf, 3)));
# define XfOrM317_COUNT (4)
# define SETUP_XfOrM317(x) SETUP(XfOrM317_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buf = NULLED_OUT ; 
  oldbuf = NULLED_OUT ; 
  o = NULLED_OUT ; 

# 1760 "bc/src/read.c"
  ungetc_ok = FUNCCALL(SETUP_XfOrM317(_), scheme_peekc_is_ungetc (port ) ); 

  if (ungetc_ok )
    getc_fun = scheme_getc ; 
  else 
  getc_fun = scheme_peekc ; 

  i = 0 ; 
  size = 64 - 1 ; 
  buf = onstack ; 

  if (init_ch < 0 )
    ch = FUNCCALL(SETUP_XfOrM317(_), getc_fun (port ) ); 
  else {

    ch = init_ch ; 
  }

  delim_ok = 0x1 ; 
  far_char_ok = 1 ; 

  while (((ch ) >= 0 ) 
  && (running_quote 
  || (! (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) 
  && (((ch < 128 ) && (delim [ch ] & delim_ok ) ) 
  || ((ch >= 128 ) && far_char_ok ) ) ) ) ) {
#   define XfOrM328_COUNT (0+XfOrM317_COUNT)
#   define SETUP_XfOrM328(x) SETUP_XfOrM317(x)

# 1786 "bc/src/read.c"
    single_escape = (ch == '\\' ) ; 
    multiple_escape = (ch == '|' ) ; 
    if (! ungetc_ok ) {
#     define XfOrM333_COUNT (0+XfOrM328_COUNT)
#     define SETUP_XfOrM333(x) SETUP_XfOrM328(x)

# 1789 "bc/src/read.c"
      if (init_ch < 0 )
        FUNCCALL(SETUP_XfOrM333(_), scheme_getc (port ) ); 
      else 
      init_ch = - 1 ; 
    }
    if (single_escape && ! running_quote ) {
      int esc_ch = ch ; 
#     define XfOrM331_COUNT (0+XfOrM328_COUNT)
#     define SETUP_XfOrM331(x) SETUP_XfOrM328(x)

# 1796 "bc/src/read.c"
      ch = FUNCCALL(SETUP_XfOrM331(_), scheme_getc (port ) ); 
      if (ch == (- 1 ) ) {
#       define XfOrM332_COUNT (0+XfOrM331_COUNT)
#       define SETUP_XfOrM332(x) SETUP_XfOrM331(x)
        FUNCCALL_EMPTY(scheme_read_err (port , "read: EOF following `%c' in %s" , esc_ch , is_kw ? "keyword" : "symbol" ) )
# 1798 "bc/src/read.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      quoted_ever = 1 ; 
    }

# 1802 "bc/src/read.c"
    else if (multiple_escape && (! running_quote || (ch == running_quote_ch ) ) ) {
#     define XfOrM330_COUNT (0+XfOrM328_COUNT)
#     define SETUP_XfOrM330(x) SETUP_XfOrM328(x)

# 1803 "bc/src/read.c"
      quoted_ever = 1 ; 
      running_quote = ! running_quote ; 
      running_quote_ch = ch ; 

      ch = FUNCCALL(SETUP_XfOrM330(_), getc_fun (port ) ); 
      continue ; 
    }

    if (i >= size ) {
#     define XfOrM329_COUNT (0+XfOrM328_COUNT)
#     define SETUP_XfOrM329(x) SETUP_XfOrM328(x)

# 1812 "bc/src/read.c"
      oldsize = size ; 
      oldbuf = buf ; 

      size *= 2 ; 
      buf = (mzchar * ) FUNCCALL(SETUP_XfOrM329(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
      (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
    }

    buf [i ++ ] = ch ; 

    ch = FUNCCALL(SETUP_XfOrM328(_), getc_fun (port ) ); 
  }

  if (ungetc_ok )
    FUNCCALL(SETUP_XfOrM317(_), scheme_ungetc (ch , port ) ); 

  if (running_quote ) {
#   define XfOrM321_COUNT (0+XfOrM317_COUNT)
#   define SETUP_XfOrM321(x) SETUP_XfOrM317(x)
    FUNCCALL_EMPTY(scheme_read_err (port , "read: unbalanced `%c`" , running_quote_ch ) )
# 1829 "bc/src/read.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  buf [i ] = '\0' ; 

  if (! quoted_ever && (i == 1 ) && (buf [0 ] == '.' ) ) {
    intptr_t xl , xc , xp ; 
#   define XfOrM320_COUNT (0+XfOrM317_COUNT)
#   define SETUP_XfOrM320(x) SETUP_XfOrM317(x)
    FUNCCALL(SETUP_XfOrM320(_), scheme_tell_all (port , & xl , & xc , & xp ) )
# 1837 "bc/src/read.c"
    ; 
    FUNCCALL_EMPTY(scheme_read_err (port , "read: illegal use of `.'" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if ((is_symbol || quoted_ever ) && ! is_float && ! is_not_float && ! radix_set )
    o = scheme_false ; 
  else {
#   define XfOrM319_COUNT (0+XfOrM317_COUNT)
#   define SETUP_XfOrM319(x) SETUP_XfOrM317(x)

# 1845 "bc/src/read.c"
    o = FUNCCALL(SETUP_XfOrM319(_), scheme_read_number (buf , i , is_float , is_not_float , 1 , radix , radix_set , port , ((void * ) 0 ) , 0 ) )


    ; 
  }

  if ((o ) == (scheme_false ) )  {
#   define XfOrM318_COUNT (0+XfOrM317_COUNT)
#   define SETUP_XfOrM318(x) SETUP_XfOrM317(x)

# 1852 "bc/src/read.c"
    if (is_kw )
      o = FUNCCALL(SETUP_XfOrM318(_), scheme_intern_exact_char_keyword (buf , i ) ); 
    else 
    o = FUNCCALL(SETUP_XfOrM318(_), scheme_intern_exact_char_symbol (buf , i ) ); 
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1861 "bc/src/read.c"
static Scheme_Object * 
read_number (int init_ch , 
Scheme_Object * port , 
int is_float , int is_not_float , 
int radix , int radix_set , 
ReadParams * params ) 
{
  /* No conversion */

# 1868 "bc/src/read.c"
  return read_number_or_symbol (init_ch , 
  port , 
  is_float , is_not_float , 
  radix , radix_set , 0 , 0 , 
  params ) ; 
}

static Scheme_Object * 
read_symbol (int init_ch , 
Scheme_Object * port , 
ReadParams * params ) 
{
  /* No conversion */

# 1880 "bc/src/read.c"
  return read_number_or_symbol (init_ch , 
  port , 
  0 , 0 , 10 , 0 , 1 , 0 , 
  params ) ; 
}

static Scheme_Object * 
read_keyword (int init_ch , 
Scheme_Object * port , 
ReadParams * params ) 
{
  /* No conversion */

# 1891 "bc/src/read.c"
  return read_number_or_symbol (init_ch , 
  port , 
  0 , 0 , 10 , 0 , 1 , 1 , 
  params ) ; 
}

static Scheme_Object * 
read_delimited_constant (int ch , const mzchar * str , 
Scheme_Object * v , 
Scheme_Object * port , 
ReadParams * params ) 
{
  int first_ch = ch ; 
  int scanpos = 1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(port, 1), PUSH(str, 2)));
# define XfOrM338_COUNT (3)
# define SETUP_XfOrM338(x) SETUP(XfOrM338_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1906 "bc/src/read.c"
  if (ch == str [0 ] ) {
#   define XfOrM343_COUNT (0+XfOrM338_COUNT)
#   define SETUP_XfOrM343(x) SETUP_XfOrM338(x)

# 1907 "bc/src/read.c"
    do {
#     define XfOrM347_COUNT (0+XfOrM343_COUNT)
#     define SETUP_XfOrM347(x) SETUP_XfOrM343(x)

# 1908 "bc/src/read.c"
      ch = FUNCCALL(SETUP_XfOrM347(_), scheme_getc (port ) ); 
      if ((mzchar ) ch == str [scanpos ] ) {
        scanpos ++ ; 
      }

# 1911 "bc/src/read.c"
      else {
        break ; 
      }
    }

# 1914 "bc/src/read.c"
    while (str [scanpos ] ) ; 
  }

# 1915 "bc/src/read.c"
  else {
#   define XfOrM342_COUNT (0+XfOrM338_COUNT)
#   define SETUP_XfOrM342(x) SETUP_XfOrM338(x)

# 1917 "bc/src/read.c"
    ch = FUNCCALL(SETUP_XfOrM342(_), scheme_getc (port ) ); 
  }

  if (str [scanpos ] 
  || ! FUNCCALL(SETUP_XfOrM338(_), next_is_delim (port ) )) {
    mzchar str_part [7 ] , one_more [2 ] ; 
#   define XfOrM339_COUNT (0+XfOrM338_COUNT)
#   define SETUP_XfOrM339(x) SETUP_XfOrM338(x)

# 1924 "bc/src/read.c"
    if (! str [scanpos ] ) {
#     define XfOrM341_COUNT (0+XfOrM339_COUNT)
#     define SETUP_XfOrM341(x) SETUP_XfOrM339(x)

# 1926 "bc/src/read.c"
      ch = FUNCCALL(SETUP_XfOrM341(_), scheme_getc (port ) ); 
    }
    (
    memcpy (str_part , str XFORM_OK_PLUS 1 , (scanpos - 1 ) * sizeof (mzchar ) ) ) ; 
    str_part [scanpos - 1 ] = 0 ; 
    if ((ch ) >= 0 )  {
      one_more [0 ] = ch ; 
      one_more [1 ] = 0 ; 
    }

# 1934 "bc/src/read.c"
    else 
    one_more [0 ] = 0 ; 
    FUNCCALL_EMPTY(scheme_read_err (port , "read: bad syntax `#%c%5%u'" , first_ch , str_part , one_more , (intptr_t ) (((ch ) >= 0 ) ? 1 : 0 ) ) )





    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int u_strcmp (mzchar * s , const char * _t ) 
{
  /* No conversion */

# 1955 "bc/src/read.c"
  int i ; 
  unsigned char * t = (unsigned char * ) _t ; 

  for (i = 0 ; s [i ] && ((s [i ] + scheme_uchar_downs [(scheme_uchar_cases_table [(s [i ] >> 8 ) & 0x1FFF ] [s [i ] & 0xFF ] ) ] ) == ((mzchar ) ((unsigned char * ) t ) [i ] + scheme_uchar_downs [(scheme_uchar_cases_table [((mzchar ) ((unsigned char * ) t ) [i ] >> 8 ) & 0x1FFF ] [(mzchar ) ((unsigned char * ) t ) [i ] & 0xFF ] ) ] ) ) ; i ++ ) {
  }
  if (s [i ] || t [i ] )
    return 1 ; 
  return 0 ; 
}

static Scheme_Object * make_interned_char (int ch , int intern ) 
{
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM353_COUNT (0)
# define SETUP_XfOrM353(x) SETUP(XfOrM353_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1967 "bc/src/read.c"
  if (ch < 256 )
    RET_VALUE_START (((((mzchar ) ch ) < 256 ) ? scheme_char_constants [(unsigned char ) (ch ) ] : FUNCCALL_EMPTY(scheme_make_char (ch ) )) ) RET_VALUE_END ; 
  else if (intern )
    RET_VALUE_START ((__funcarg84 = FUNCCALL_EMPTY(scheme_make_char (ch ) ), FUNCCALL_EMPTY(scheme_intern_literal_number (__funcarg84 ) )) ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (ch ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1976 "bc/src/read.c"
static Scheme_Object * 
read_character (Scheme_Object * port , 
ReadParams * params ) 
{
  int ch , next ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM354_COUNT (1)
# define SETUP_XfOrM354(x) SETUP(XfOrM354_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1982 "bc/src/read.c"
  ch = FUNCCALL(SETUP_XfOrM354(_), scheme_getc (port ) ); 

  next = FUNCCALL(SETUP_XfOrM354(_), scheme_peekc (port ) ); 

  if ((ch >= '0' && ch <= '7' ) && (next >= '0' && next <= '7' ) ) {

    int last ; 
#   define XfOrM368_COUNT (0+XfOrM354_COUNT)
#   define SETUP_XfOrM368(x) SETUP_XfOrM354(x)

# 1990 "bc/src/read.c"
    last = (FUNCCALL(SETUP_XfOrM368(_), scheme_getc (port ) ), FUNCCALL(SETUP_XfOrM368(_), scheme_peekc (port ) )) ; 

    if (last != (- 2 ) )
      FUNCCALL(SETUP_XfOrM368(_), scheme_getc (port ) ); 

    if (last < '0' || last > '7' || ch > '3' ) {
#     define XfOrM369_COUNT (0+XfOrM368_COUNT)
#     define SETUP_XfOrM369(x) SETUP_XfOrM368(x)
      FUNCCALL_EMPTY(scheme_read_err (port , "read: bad character constant #\\%c%c%c" , ch , next , ((last == (- 1 ) ) || (last == (- 2 ) ) ) ? ' ' : last ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    ch = ((ch - '0' ) << 6 ) + ((next - '0' ) << 3 ) + (last - '0' ) ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_interned_char (ch , 0 ) )) RET_VALUE_EMPTY_END ; 
  }

  if (((ch == 'u' ) || (ch == 'U' ) ) && ((next ) >= 0 ) && (((next >= '0' ) && (next <= '9' ) ) || ((next >= 'a' ) && (next <= 'f' ) ) || ((next >= 'A' ) && (next <= 'F' ) ) ) ) {
    int count = 0 , n = 0 , nbuf [10 ] , maxc = ((ch == 'u' ) ? 4 : 8 ) ; 
#   define XfOrM361_COUNT (0+XfOrM354_COUNT)
#   define SETUP_XfOrM361(x) SETUP_XfOrM354(x)

# 2009 "bc/src/read.c"
    while (count < maxc ) {
#     define XfOrM366_COUNT (0+XfOrM361_COUNT)
#     define SETUP_XfOrM366(x) SETUP_XfOrM361(x)

# 2010 "bc/src/read.c"
      ch = FUNCCALL(SETUP_XfOrM366(_), scheme_peekc (port ) ); 
      if (((ch ) >= 0 ) && (((ch >= '0' ) && (ch <= '9' ) ) || ((ch >= 'a' ) && (ch <= 'f' ) ) || ((ch >= 'A' ) && (ch <= 'F' ) ) ) ) {
#       define XfOrM367_COUNT (0+XfOrM366_COUNT)
#       define SETUP_XfOrM367(x) SETUP_XfOrM366(x)

# 2012 "bc/src/read.c"
        nbuf [count ] = ch ; 
        n = ((unsigned ) n << 4 ) + (ch <= '9' ? ch - '0' : ((ch + scheme_uchar_ups [(scheme_uchar_cases_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ] ) - 'A' + 10 ) ) ; 
        FUNCCALL(SETUP_XfOrM367(_), scheme_getc (port ) ); 
        count ++ ; 
      }

# 2016 "bc/src/read.c"
      else 
      break ; 
    }

    if ((n < 0 ) 
    || ((n >= 0xD800 ) && (n <= 0xDFFF ) ) 
    || (n > 0x10FFFF ) ) {
#     define XfOrM363_COUNT (0+XfOrM361_COUNT)
#     define SETUP_XfOrM363(x) SETUP_XfOrM361(x)
      FUNCCALL_EMPTY(scheme_read_err (port , "read: bad character constant #\\%c%u" , (maxc == 4 ) ? 'u' : 'U' , nbuf , (intptr_t ) count ) )
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 2028 "bc/src/read.c"
    else {
      ch = n ; 
    }
  }

# 2031 "bc/src/read.c"
  else if ((ch != (- 1 ) ) && (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x80 ) && ((next ) >= 0 ) && (((scheme_uchar_table [(next >> 8 ) & 0x1FFF ] [next & 0xFF ] ) ) & 0x80 ) ) {
    mzchar * buf , * oldbuf , onstack [32 ] ; 
    int i ; 
    intptr_t size = 31 , oldsize ; 
    BLOCK_SETUP((PUSH(oldbuf, 0+XfOrM354_COUNT), PUSH(buf, 1+XfOrM354_COUNT)));
#   define XfOrM355_COUNT (2+XfOrM354_COUNT)
#   define SETUP_XfOrM355(x) SETUP(XfOrM355_COUNT)
    buf = NULLED_OUT ; 
    oldbuf = NULLED_OUT ; 

# 2036 "bc/src/read.c"
    i = 1 ; 
    buf = onstack ; 
    buf [0 ] = ch ; 
    while ((ch = FUNCCALL(SETUP_XfOrM355(_), scheme_peekc (port ) ), ((ch ) >= 0 ) && (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x80 ) ) ) {
#     define XfOrM359_COUNT (0+XfOrM355_COUNT)
#     define SETUP_XfOrM359(x) SETUP_XfOrM355(x)
      FUNCCALL(SETUP_XfOrM359(_), scheme_getc (port ) )
# 2040 "bc/src/read.c"
      ; 
      if (i >= size ) {
#       define XfOrM360_COUNT (0+XfOrM359_COUNT)
#       define SETUP_XfOrM360(x) SETUP_XfOrM359(x)

# 2042 "bc/src/read.c"
        oldsize = size ; 
        oldbuf = buf ; 

        size *= 2 ; 
        buf = (mzchar * ) FUNCCALL(SETUP_XfOrM360(_), GC_malloc_atomic ((size + 1 ) * sizeof (mzchar ) ) ); 
        (memcpy (buf , oldbuf , oldsize * sizeof (mzchar ) ) ) ; 
      }
      buf [i ++ ] = ch ; 
    }
    buf [i ] = '\0' ; 

    switch ((buf [0 ] + scheme_uchar_downs [(scheme_uchar_cases_table [(buf [0 ] >> 8 ) & 0x1FFF ] [buf [0 ] & 0xFF ] ) ] ) ) {
#     define XfOrM356_COUNT (0+XfOrM355_COUNT)
#     define SETUP_XfOrM356(x) SETUP_XfOrM355(x)

# 2054 "bc/src/read.c"
      case 'n' : 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "newline" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\n' ) )) RET_VALUE_EMPTY_END ; 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "null" ) )|| ! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "nul" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\0' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 's' : 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "space" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (' ' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'r' : 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "rubout" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (0x7f ) )) RET_VALUE_EMPTY_END ; 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "return" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\r' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'p' : 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "page" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\f' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 't' : 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "tab" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\t' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'v' : 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "vtab" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char (0xb ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'b' : 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "backspace" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\b' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case 'l' : 
      if (! FUNCCALL(SETUP_XfOrM356(_), u_strcmp (buf , "linefeed" ) ))
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_char ('\n' ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      default : 
      break ; 
    }
    FUNCCALL_EMPTY(scheme_read_err (port , "read: bad character constant: #\\%5" , buf ) )
    ; 
  }

  if (ch == (- 1 ) )
    FUNCCALL_EMPTY(scheme_read_err (port , "read: expected a character after #\\" ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_interned_char (ch , 0 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


static Scheme_Object * 
read_quote (char * who , Scheme_Object * quote_symbol , int len , 
Scheme_Object * port , ReadParams * params ) 
{
  Scheme_Object * obj , * ret ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(obj, 1), PUSH(ret, 2), PUSH(port, 3), PUSH(quote_symbol, 4)));
# define XfOrM370_COUNT (5)
# define SETUP_XfOrM370(x) SETUP(XfOrM370_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  obj = NULLED_OUT ; 
  ret = NULLED_OUT ; 

# 2114 "bc/src/read.c"
  obj = FUNCCALL(SETUP_XfOrM370(_), read_inner (port , params , - 1 ) ); 
  if (((obj ) ) == (scheme_eof ) ) 
    FUNCCALL_EMPTY(scheme_read_err (port , "read: expected an element for %s (found end-of-file)" , who ) ); 
  ret = quote_symbol ; 
  ret = (__funcarg85 = FUNCCALL(SETUP_XfOrM370(_), scheme_make_pair (obj , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (ret , __funcarg85 ) )) ; 
  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2123 "bc/src/read.c"
static Scheme_Object * read_box (Scheme_Object * port , ReadParams * params ) 
{
  Scheme_Object * o , * bx ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(bx, 0), PUSH(o, 1), PUSH(port, 2)));
# define XfOrM371_COUNT (3)
# define SETUP_XfOrM371(x) SETUP(XfOrM371_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  bx = NULLED_OUT ; 

# 2127 "bc/src/read.c"
  o = FUNCCALL(SETUP_XfOrM371(_), read_inner (port , params , - 1 ) ); 

  if (((o ) ) == (scheme_eof ) ) 
    FUNCCALL_EMPTY(scheme_read_err (port , "read: expected an element for #& box (found end-of-file)" ) ); 

  bx = FUNCCALL(SETUP_XfOrM371(_), scheme_box (o ) ); 

  RET_VALUE_START (bx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


static Scheme_Object * read_hash (Scheme_Object * port , 
int opener , char closer , int kind , 
ReadParams * params ) 
{
  Scheme_Object * l ; 
  Scheme_Object * key , * val ; 
  Scheme_Hash_Tree * t ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(t, 1), PUSH(key, 2), PUSH(val, 3)));
# define XfOrM372_COUNT (4)
# define SETUP_XfOrM372(x) SETUP(XfOrM372_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 2151 "bc/src/read.c"
  l = FUNCCALL(SETUP_XfOrM372(_), read_list (port , opener , closer , 2 , 0 , params ) ); 

  t = (scheme_make_hash_tree (kind ) ) ; 

  for (; (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) l ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) l ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ; l = (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) l ) -> val ) ) -> u . pair_val . cdr ) ) ) {
#   define XfOrM374_COUNT (0+XfOrM372_COUNT)
#   define SETUP_XfOrM374(x) SETUP_XfOrM372(x)

# 2156 "bc/src/read.c"
    val = (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) l ) -> val ) ) -> u . pair_val . car ) ) ; 
    key = (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) val ) -> val ) ) -> u . pair_val . car ) ) ; 
    key = FUNCCALL(SETUP_XfOrM374(_), scheme_syntax_to_datum (key ) ); 
    key = FUNCCALL_AGAIN(scheme_expander_syntax_to_datum (key ) ); 
    val = (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) val ) -> val ) ) -> u . pair_val . cdr ) ) ; 

    t = FUNCCALL(SETUP_XfOrM374(_), scheme_hash_tree_set (t , key , val ) ); 
  }

  RET_VALUE_START ((Scheme_Object * ) t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * read_intern (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2174 "bc/src/read.c"
  return scheme_read_intern (argv [0 ] ) ; 
}

Scheme_Object * scheme_read_intern (Scheme_Object * o ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM376_COUNT (1)
# define SETUP_XfOrM376(x) SETUP(XfOrM376_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2179 "bc/src/read.c"
  if (! (((intptr_t ) (o ) ) & 0x1 ) && ((((intptr_t ) (o ) ) & 0x1 ) || ((((o ) -> type ) >= scheme_bignum_type ) && (((o ) -> type ) <= scheme_complex_type ) ) ) )
    o = FUNCCALL(SETUP_XfOrM376(_), scheme_intern_literal_number (o ) ); 
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#   define XfOrM378_COUNT (0+XfOrM376_COUNT)
#   define SETUP_XfOrM378(x) SETUP_XfOrM376(x)

# 2182 "bc/src/read.c"
    if (! (((Scheme_Inclhash_Object * ) (o ) ) -> so . keyex & 0x1 ) )
      o = FUNCCALL(SETUP_XfOrM378(_), scheme_make_immutable_sized_char_string ((((Scheme_Simple_Object * ) (o ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (o ) ) -> u . char_str_val . tag_val ) , 1 ) )

    ; 
    o = FUNCCALL(SETUP_XfOrM378(_), scheme_intern_literal_string (o ) ); 
  }

# 2187 "bc/src/read.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
#   define XfOrM377_COUNT (0+XfOrM376_COUNT)
#   define SETUP_XfOrM377(x) SETUP_XfOrM376(x)

# 2188 "bc/src/read.c"
    if (! (((Scheme_Inclhash_Object * ) (o ) ) -> so . keyex & 0x1 ) )
      o = FUNCCALL(SETUP_XfOrM377(_), scheme_make_immutable_sized_byte_string ((((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . tag_val ) , 1 ) )

    ; 
    o = FUNCCALL(SETUP_XfOrM377(_), scheme_intern_literal_string (o ) ); 
  }

# 2193 "bc/src/read.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_regexp_type ) ) 
    o = FUNCCALL(SETUP_XfOrM376(_), scheme_intern_literal_string (o ) ); 
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) && ((((Scheme_Small_Object * ) (o ) ) -> u . char_val ) >= 256 ) )
    o = FUNCCALL(SETUP_XfOrM376(_), scheme_intern_literal_number (o ) ); 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int 
skip_whitespace_comments (Scheme_Object * port , 
ReadParams * params ) 
{
  int ch ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(params, 1)));
# define XfOrM379_COUNT (2)
# define SETUP_XfOrM379(x) SETUP(XfOrM379_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2211 "bc/src/read.c"
  start_over : 

  while ((ch = FUNCCALL(SETUP_XfOrM379(_), scheme_getc (port ) ), ((ch ) >= 0 ) && (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x10 ) ) ) {
  }
  if (ch == ';' ) {
#   define XfOrM388_COUNT (0+XfOrM379_COUNT)
#   define SETUP_XfOrM388(x) SETUP_XfOrM379(x)

# 2216 "bc/src/read.c"
    do {
#     define XfOrM390_COUNT (0+XfOrM388_COUNT)
#     define SETUP_XfOrM390(x) SETUP_XfOrM388(x)

# 2217 "bc/src/read.c"
      ch = FUNCCALL(SETUP_XfOrM390(_), scheme_getc (port ) ); 
    }

# 2218 "bc/src/read.c"
    while (! ((ch == '\n' ) || (ch == '\r' ) || (ch == 0x85 ) || (ch == 0x2028 ) || (ch == 0x2029 ) ) && (ch != (- 1 ) ) ) ; 
    goto start_over ; 
  }

  if ((ch == '#' ) 
  && (FUNCCALL(SETUP_XfOrM379(_), scheme_peekc (port ) )== '|' ) ) {
    int depth = 0 ; 
    int ch2 = 0 ; 
#   define XfOrM381_COUNT (0+XfOrM379_COUNT)
#   define SETUP_XfOrM381(x) SETUP_XfOrM379(x)

# 2227 "bc/src/read.c"
    (void ) FUNCCALL(SETUP_XfOrM381(_), scheme_getc (port ) ); 
    do {
#     define XfOrM385_COUNT (0+XfOrM381_COUNT)
#     define SETUP_XfOrM385(x) SETUP_XfOrM381(x)

# 2229 "bc/src/read.c"
      ch = FUNCCALL(SETUP_XfOrM385(_), scheme_getc (port ) ); 

      if (ch == (- 1 ) )
        FUNCCALL_EMPTY(scheme_read_err (port , "read: end of file in #| comment" ) ); 

      if ((ch2 == '|' ) && (ch == '#' ) ) {
        if (! (depth -- ) )
          goto start_over ; 
        ch = 0 ; 
      }

# 2238 "bc/src/read.c"
      else if ((ch2 == '#' ) && (ch == '|' ) ) {
        depth ++ ; 
        ch = 0 ; 
      }
      ch2 = ch ; 
    }

# 2243 "bc/src/read.c"
    while (1 ) ; 

    goto start_over ; 
  }
  if ((ch == '#' ) 
  && (FUNCCALL(SETUP_XfOrM379(_), scheme_peekc (port ) )== ';' ) ) {
    Scheme_Object * skipped ; 
    BLOCK_SETUP((PUSH(skipped, 0+XfOrM379_COUNT)));
#   define XfOrM380_COUNT (1+XfOrM379_COUNT)
#   define SETUP_XfOrM380(x) SETUP(XfOrM380_COUNT)
    skipped = NULLED_OUT ; 

# 2251 "bc/src/read.c"
    (void ) FUNCCALL(SETUP_XfOrM380(_), scheme_getc (port ) ); 

    skipped = FUNCCALL(SETUP_XfOrM380(_), read_inner (port , params , - 1 ) ); 
    if (((skipped ) ) == (scheme_eof ) ) 
      FUNCCALL_EMPTY(scheme_read_err (port , "read: expected a commented-out element for `#;' (found end-of-file)" ) ); 

    goto start_over ; 
  }

  RET_VALUE_START (ch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2263 "bc/src/read.c"
static void unexpected_closer (int ch , Scheme_Object * port ) 
{
  /* No conversion */

# 2265 "bc/src/read.c"
  scheme_read_err (port , "read: unexpected `%c`" , ch ) ; 
}

static int read_graph_index (Scheme_Object * port , int * ch ) 
{
  int digits = 0 , val = 0 , nch ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(ch, 1)));
# define XfOrM394_COUNT (2)
# define SETUP_XfOrM394(x) SETUP(XfOrM394_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2272 "bc/src/read.c"
  while ((((* ch ) ) >= 0 ) && (((* ch ) >= '0' ) && ((* ch ) <= '9' ) ) ) {
#   define XfOrM396_COUNT (0+XfOrM394_COUNT)
#   define SETUP_XfOrM396(x) SETUP_XfOrM394(x)

# 2273 "bc/src/read.c"
    if (digits >= 8 )
      FUNCCALL_EMPTY(scheme_read_err (port , "too many digits after `#%d`" , val ) ); 
    digits ++ ; 

    val = ((val ) * 10 ) + ((* ch ) - 48 ) ; 
    nch = FUNCCALL(SETUP_XfOrM396(_), scheme_getc (port ) ); 
    (* ch ) = nch ; 
  }

  RET_VALUE_START (val ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}






typedef struct CPort {
  Scheme_Type type ; 
  uintptr_t pos , size ; 
  unsigned char * start ; 
  uintptr_t symtab_size ; 
  intptr_t base ; 
  int unsafe_ok ; 
  Scheme_Object * orig_port ; 
  Scheme_Hash_Table * * ht ; 
  Scheme_Object * symtab_refs ; 
  Scheme_Unmarshal_Tables * ut ; 
  Scheme_Object * * symtab ; 
  Scheme_Hash_Table * symtab_entries ; 
  Scheme_Object * relto ; 
  intptr_t * shared_offsets ; 
  Scheme_Load_Delay * delay_info ; 
  mzlonglong bytecode_hash ; 
}

# 2311 "bc/src/read.c"
CPort ; 




typedef void * (* GC_Alloc_Proc ) (size_t ) ; 

static Scheme_Object * read_compact_list (int c , int proper , int use_stack , CPort * port ) ; 
static Scheme_Object * read_compact_quote (CPort * port , int embedded ) ; 

void scheme_ill_formed (struct CPort * port 

, const char * file , int line ) 


{
  /* No conversion */

# 2327 "bc/src/read.c"
  scheme_read_err (port ? port -> orig_port : ((void * ) 0 ) , 
  "read (compiled): ill-formed code" 

  " [%s:%d]" , file , line ) 

  ; 
}

static void make_ut (CPort * port ) 
{
  Scheme_Unmarshal_Tables * ut ; 
  char * decoded ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(ut, 1), PUSH(decoded, 2)));
# define XfOrM398_COUNT (3)
# define SETUP_XfOrM398(x) SETUP(XfOrM398_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ut = NULLED_OUT ; 
  decoded = NULLED_OUT ; 

# 2340 "bc/src/read.c"
  ut = ((Scheme_Unmarshal_Tables * ) FUNCCALL(SETUP_XfOrM398(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Unmarshal_Tables ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  ut -> type = scheme_rt_unmarshal_info ; 
  port -> ut = ut ; 
  ut -> rp = port ; 
  if (port -> delay_info )
    port -> delay_info -> ut = ut ; 

  decoded = (char * ) FUNCCALL(SETUP_XfOrM398(_), GC_malloc_atomic (port -> symtab_size ) ); 
  (memset (decoded , 0 , port -> symtab_size ) ) ; 
  ut -> decoded = decoded ; 

  ut -> bytecode_hash = port -> bytecode_hash ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

__xform_nongcing__ static intptr_t read_compact_number (CPort * port ) 
{
  /* No conversion */

# 2361 "bc/src/read.c"
  intptr_t flag , v , a , b , c , d ; 

  if (! (port -> pos < port -> size ) )

# 2363 "bc/src/read.c"
  return 0 ; 

# 2363 "bc/src/read.c"
  ; 

  flag = ((int ) (port -> start [port -> pos ++ ] ) ) ; 

  if (flag < 128 )
    return flag ; 
  else if (! (flag & 0x40 ) ) {
    if (! (port -> pos < port -> size ) )

# 2370 "bc/src/read.c"
    return 0 ; 

# 2370 "bc/src/read.c"
    ; 

    a = ((int ) (port -> start [port -> pos ++ ] ) ) ; 

    v = (flag & 0x3F ) 
    + (a << 6 ) ; 
    return v ; 
  }

# 2377 "bc/src/read.c"
  else if (! (flag & 0x20 ) ) {
    return - (flag & 0x1F ) ; 
  }

  if (! (port -> pos + 3 < port -> size ) )

# 2381 "bc/src/read.c"
  return 0 ; 

# 2381 "bc/src/read.c"
  ; 

  a = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
  b = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
  c = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
  d = ((int ) (port -> start [port -> pos ++ ] ) ) ; 

  v = a 
  + (b << 8 ) 
  + (c << 16 ) 
  + (d << 24 ) ; 

  if (flag & 0x10 )
    return v ; 
  else 
  return - v ; 
}

static char * read_compact_chars (CPort * port , 
char * buffer , 
int bsize , int l ) 
{

  char * s ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(s, 1)));
# define XfOrM402_COUNT (2)
# define SETUP_XfOrM402(x) SETUP(XfOrM402_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2406 "bc/src/read.c"
  if (l < bsize )
    s = buffer ; 
  else 
  s = (char * ) FUNCCALL(SETUP_XfOrM402(_), GC_malloc_atomic (l + 1 ) ); 
  (
  memcpy (s , port -> start + port -> pos , l ) ) ; 
  port -> pos += l ; 

  s [l ] = 0 ; 

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2419 "bc/src/read.c"
static Scheme_Object * read_compact_svector (CPort * port , int l ) 
{
  Scheme_Object * o ; 
  mzshort * v ; 
  intptr_t __funcarg86 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(o, 1), PUSH(port, 2)));
# define XfOrM403_COUNT (3)
# define SETUP_XfOrM403(x) SETUP(XfOrM403_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 2424 "bc/src/read.c"
  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM403(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_svector_type ; 

  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . len ) = l ; 
  if (l > 0 ) {
#   define XfOrM407_COUNT (0+XfOrM403_COUNT)
#   define SETUP_XfOrM407(x) SETUP_XfOrM403(x)

# 2429 "bc/src/read.c"
    if (l > 4096 ) {
#     define XfOrM409_COUNT (0+XfOrM407_COUNT)
#     define SETUP_XfOrM409(x) SETUP_XfOrM407(x)

# 2430 "bc/src/read.c"
      v = (mzshort * ) (__funcarg86 = FUNCCALL(SETUP_XfOrM409(_), scheme_check_overflow (l , sizeof (mzshort ) , 0 ) ), FUNCCALL_AGAIN(scheme_malloc_fail_ok (GC_malloc_atomic , __funcarg86 ) )) 
      ; 
      if (! v )
        FUNCCALL_EMPTY(scheme_signal_error ("out of memory allocating vector" ) ); 
    }

# 2434 "bc/src/read.c"
    else {
#     define XfOrM408_COUNT (0+XfOrM407_COUNT)
#     define SETUP_XfOrM408(x) SETUP_XfOrM407(x)

# 2435 "bc/src/read.c"
      v = ((mzshort * ) FUNCCALL(SETUP_XfOrM408(_), GC_malloc_atomic (sizeof (mzshort ) * (l ) ) )) ; 
    }
  }

# 2437 "bc/src/read.c"
  else {
    v = ((void * ) 0 ) ; 
    l = 0 ; 
  }
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . vec ) = v ; 

  while (l -- > 0 ) {
    mzshort cn ; 
#   define XfOrM405_COUNT (0+XfOrM403_COUNT)
#   define SETUP_XfOrM405(x) SETUP_XfOrM403(x)

# 2445 "bc/src/read.c"
    cn = (read_compact_number (port ) ) ; 
    v [l ] = cn ; 
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2452 "bc/src/read.c"
static int valid_utf8 (const char * s , int l ) 
{
  /* No conversion */

# 2454 "bc/src/read.c"
  return (scheme_utf8_decode ((const unsigned char * ) s , 0 , l , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) >= 0 ) ; 
}


static Scheme_Object * read_escape_from_string (char * s , intptr_t len , 
Scheme_Object * rel_to , 
Scheme_Hash_Table * * ht , 
Scheme_Object * orig_port ) 
{
  Scheme_Object * ep , * v ; 
  ReadParams params ; 
  Scheme_Input_Port * ep_ip ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(ep_ip, 1), PUSH(ep, 2), PUSH(ht, 3), PUSH(orig_port, 4), PUSH(rel_to, 5), PUSH(params.delay_load_info, 6), PUSH(params.read_relative_path, 7), PUSH(params.graph_ht, 8)));
# define XfOrM411_COUNT (9)
# define SETUP_XfOrM411(x) SETUP(XfOrM411_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ep = NULLED_OUT ; 
  v = NULLED_OUT ; 
  params.delay_load_info = NULLED_OUT ; 
  params.read_relative_path = NULLED_OUT ; 
  params.graph_ht = NULLED_OUT ; 
  ep_ip = NULLED_OUT ; 

# 2467 "bc/src/read.c"
  ep = FUNCCALL(SETUP_XfOrM411(_), scheme_make_sized_byte_string_input_port (s , len ) ); 

  if (orig_port ) {
#   define XfOrM412_COUNT (0+XfOrM411_COUNT)
#   define SETUP_XfOrM412(x) SETUP_XfOrM411(x)

# 2470 "bc/src/read.c"
    v = FUNCCALL(SETUP_XfOrM412(_), scheme_input_port_record (orig_port ) )-> name ; 
    if (v ) {
#     define XfOrM413_COUNT (0+XfOrM412_COUNT)
#     define SETUP_XfOrM413(x) SETUP_XfOrM412(x)

# 2472 "bc/src/read.c"
      ep_ip = FUNCCALL(SETUP_XfOrM413(_), scheme_input_port_record (ep ) ); 
      ep_ip -> name = v ; 
    }
  }

  params . skip_zo_vers_check = 0 ; 
  params . read_relative_path = rel_to ; 
  params . graph_ht = * ht ; 

  v = FUNCCALL(SETUP_XfOrM411(_), read_inner (ep , & params , - 1 ) ); 

  * ht = params . graph_ht ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2488 "bc/src/read.c"
static Scheme_Object * read_compact_escape (CPort * port ) 
{


  char buffer [32 ] ; 

  int len ; 
  char * s ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(s, 1)));
# define XfOrM414_COUNT (2)
# define SETUP_XfOrM414(x) SETUP(XfOrM414_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2497 "bc/src/read.c"
  len = (read_compact_number (port ) ) ; 

  if (! ((unsigned ) len <= port -> size - port -> pos ) )
    FUNCCALL(SETUP_XfOrM414(_), scheme_ill_formed (port , "bc/src/read.c" , 2499 ) )
# 2499 "bc/src/read.c"
  ; 

# 2499 "bc/src/read.c"
  ; 


  s = FUNCCALL(SETUP_XfOrM414(_), read_compact_chars (port , buffer , 32 , len ) ); 
  if (s != buffer )
    len = - len ; 






  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_escape_from_string (s , len , port -> relto , port -> ht , port -> orig_port ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2514 "bc/src/read.c"
static void record_symtab_self_contained (Scheme_Hash_Table * symtab_entries , Scheme_Object * v ) 
{
  /* No conversion */

# 2516 "bc/src/read.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
  || ((((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {



    scheme_hash_set (symtab_entries , v , scheme_true ) ; 
  }
}

static Scheme_Object * resolve_symtab_refs (Scheme_Object * v , CPort * port ) 
{
  Scheme_Object * l ; 
  Scheme_Hash_Table * __funcarg88 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg87 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(v, 1), PUSH(port, 2), PUSH(__funcarg87, 3)));
# define XfOrM417_COUNT (4)
# define SETUP_XfOrM417(x) SETUP(XfOrM417_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 

# 2532 "bc/src/read.c"
  if ((port -> symtab_refs ) == (scheme_null ) ) 
    RET_VALUE_START (v ) RET_VALUE_END ; 

  if (v ) {
#   define XfOrM424_COUNT (0+XfOrM417_COUNT)
#   define SETUP_XfOrM424(x) SETUP_XfOrM417(x)

# 2536 "bc/src/read.c"
    v = FUNCCALL(SETUP_XfOrM424(_), scheme_make_pair (v , port -> symtab_refs ) ); 

    v = (__funcarg87 = FUNCCALL(SETUP_XfOrM424(_), scheme_make_hash_table (SCHEME_hash_ptr ) )
    , __funcarg88 = FUNCCALL(SETUP_XfOrM424(_), scheme_make_hash_table (SCHEME_hash_ptr ) )
    , FUNCCALL_AGAIN(resolve_references (v , port -> orig_port , __funcarg87 , __funcarg88 , port -> symtab_entries , 0 , 0 ) )) 

    ; 

    l = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
  }

# 2545 "bc/src/read.c"
  else 
  l = port -> symtab_refs ; 

  for (; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#   define XfOrM421_COUNT (0+XfOrM417_COUNT)
#   define SETUP_XfOrM421(x) SETUP_XfOrM417(x)

# 2549 "bc/src/read.c"
    if (v ) {
#     define XfOrM423_COUNT (0+XfOrM421_COUNT)
#     define SETUP_XfOrM423(x) SETUP_XfOrM421(x)

# 2550 "bc/src/read.c"
      port -> symtab [(((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) >> 1 ) ] = (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ; 
      FUNCCALL(SETUP_XfOrM423(_), record_symtab_self_contained (port -> symtab_entries , (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) ) ); 
    }

# 2552 "bc/src/read.c"
    else {

      port -> symtab [(((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) ) >> 1 ) ] = ((void * ) 0 ) ; 
    }
  }

  port -> symtab_refs = scheme_null ; 

  if (v )
    RET_VALUE_START ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2566 "bc/src/read.c"
static Scheme_Object * read_compact (CPort * port , int use_stack ) ; 

static Scheme_Object * read_compact_k (void ) 
{
  /* No conversion */

# 2570 "bc/src/read.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  CPort * port = (CPort * ) p -> ku . k . p1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  return read_compact (port , p -> ku . k . i1 ) ; 
}




static Scheme_Object * read_compact (CPort * port , int use_stack ) 
{

  unsigned int l ; 
  char * s , buffer [32 ] ; 
  int ch ; 
  Scheme_Object * v ; 

# 2581 "bc/src/read.c"
  Scheme_Object * __funcarg93 = NULLED_OUT ; 

# 2581 "bc/src/read.c"
  Scheme_Object * __funcarg92 = NULLED_OUT ; 

# 2581 "bc/src/read.c"
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  intptr_t __funcarg90 ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(port, 1), PUSH(s, 2)));
# define XfOrM426_COUNT (3)
# define SETUP_XfOrM426(x) SETUP(XfOrM426_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 2590 "bc/src/read.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM521_COUNT (0+XfOrM426_COUNT)
#   define SETUP_XfOrM521(x) SETUP_XfOrM426(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 2592 "bc/src/read.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM522_COUNT (0+XfOrM521_COUNT)
#     define SETUP_XfOrM522(x) SETUP_XfOrM521(x)

# 2594 "bc/src/read.c"
      p -> ku . k . p1 = (void * ) port ; 
      p -> ku . k . i1 = use_stack ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (read_compact_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  {
#   define XfOrM427_COUNT (0+XfOrM426_COUNT)
#   define SETUP_XfOrM427(x) SETUP_XfOrM426(x)

# 2602 "bc/src/read.c"
    if (! (port -> pos < port -> size ) )
      FUNCCALL(SETUP_XfOrM427(_), scheme_ill_formed (port , "bc/src/read.c" , 2602 ) )
# 2602 "bc/src/read.c"
    ; 

# 2602 "bc/src/read.c"
    ; 
    ch = ((int ) (port -> start [port -> pos ++ ] ) ) ; 

    switch (cpt_branch [ch ] ) {
#     define XfOrM428_COUNT (0+XfOrM427_COUNT)
#     define SETUP_XfOrM428(x) SETUP_XfOrM427(x)

# 2606 "bc/src/read.c"
      case CPT_ESCAPE : 
      v = FUNCCALL(SETUP_XfOrM428(_), read_compact_escape (port ) ); 
      break ; 
      case CPT_SYMBOL : 
      l = (read_compact_number (port ) ) ; 
      if (! (l <= port -> size - port -> pos ) )
        FUNCCALL(SETUP_XfOrM428(_), scheme_ill_formed (port , "bc/src/read.c" , 2611 ) )
# 2611 "bc/src/read.c"
      ; 

# 2611 "bc/src/read.c"
      ; 
      s = FUNCCALL(SETUP_XfOrM428(_), read_compact_chars (port , buffer , 32 , l ) ); 
      if (! FUNCCALL(SETUP_XfOrM428(_), valid_utf8 (s , l ) ))
        FUNCCALL(SETUP_XfOrM428(_), scheme_ill_formed (port , "bc/src/read.c" , 2614 ) ); 
      v = FUNCCALL(SETUP_XfOrM428(_), scheme_intern_exact_symbol (s , l ) ); 
      break ; 
      case CPT_SYMREF : 
      l = (read_compact_number (port ) ) ; 
      if (! ((l > 0 ) && (l < port -> symtab_size ) ) )
        FUNCCALL(SETUP_XfOrM428(_), scheme_ill_formed (port , "bc/src/read.c" , 2619 ) )
# 2619 "bc/src/read.c"
      ; 

# 2619 "bc/src/read.c"
      ; 
      v = port -> symtab [l ] ; 
      if (v == ((Scheme_Object * ) 0x6 ) ) {
#       define XfOrM520_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM520(x) SETUP_XfOrM428(x)
        FUNCCALL(SETUP_XfOrM520(_), scheme_ill_formed (port , "bc/src/read.c" , 2623 ) )
# 2623 "bc/src/read.c"
        ; 
      }
      if (! v ) {
        intptr_t save_pos = port -> pos ; 
#       define XfOrM519_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM519(x) SETUP_XfOrM428(x)

# 2627 "bc/src/read.c"
        port -> symtab [l ] = ((Scheme_Object * ) 0x6 ) ; 
        port -> pos = port -> shared_offsets [l - 1 ] ; 
        v = FUNCCALL(SETUP_XfOrM519(_), read_compact (port , 0 ) ); 
        port -> pos = save_pos ; 
        port -> symtab [l ] = v ; 
      }
      break ; 
      case CPT_WEIRD_SYMBOL : 
      {
        int uninterned ; 
#       define XfOrM518_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM518(x) SETUP_XfOrM428(x)

# 2638 "bc/src/read.c"
        uninterned = (read_compact_number (port ) ) ; 

        l = (read_compact_number (port ) ) ; 
        if (! (l <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM518(_), scheme_ill_formed (port , "bc/src/read.c" , 2641 ) )
# 2641 "bc/src/read.c"
        ; 

# 2641 "bc/src/read.c"
        ; 
        s = FUNCCALL(SETUP_XfOrM518(_), read_compact_chars (port , buffer , 32 , l ) ); 

        if (! FUNCCALL(SETUP_XfOrM518(_), valid_utf8 (s , l ) ))
          FUNCCALL(SETUP_XfOrM518(_), scheme_ill_formed (port , "bc/src/read.c" , 2645 ) ); 

        if (uninterned )
          v = FUNCCALL(SETUP_XfOrM518(_), scheme_make_exact_symbol (s , l ) ); 
        else 
        v = FUNCCALL(SETUP_XfOrM518(_), scheme_intern_exact_parallel_symbol (s , l ) ); 
      }




      break ; 
      case CPT_KEYWORD : 
      l = (read_compact_number (port ) ) ; 
      if (! (l <= port -> size - port -> pos ) )
        FUNCCALL(SETUP_XfOrM428(_), scheme_ill_formed (port , "bc/src/read.c" , 2659 ) )
# 2659 "bc/src/read.c"
      ; 

# 2659 "bc/src/read.c"
      ; 
      s = FUNCCALL(SETUP_XfOrM428(_), read_compact_chars (port , buffer , 32 , l ) ); 
      if (! FUNCCALL(SETUP_XfOrM428(_), valid_utf8 (s , l ) ))
        FUNCCALL(SETUP_XfOrM428(_), scheme_ill_formed (port , "bc/src/read.c" , 2662 ) ); 
      v = FUNCCALL(SETUP_XfOrM428(_), scheme_intern_exact_keyword (s , l ) ); 
      break ; 
      case CPT_BYTE_STRING : 
      l = (read_compact_number (port ) ) ; 
      if (! (l <= port -> size - port -> pos ) )
        FUNCCALL(SETUP_XfOrM428(_), scheme_ill_formed (port , "bc/src/read.c" , 2667 ) )
# 2667 "bc/src/read.c"
      ; 

# 2667 "bc/src/read.c"
      ; 
      s = FUNCCALL(SETUP_XfOrM428(_), read_compact_chars (port , buffer , 32 , l ) ); 
      v = FUNCCALL_AGAIN(scheme_make_immutable_sized_byte_string (s , l , l < 32 ) ); 
      v = FUNCCALL_AGAIN(scheme_intern_literal_string (v ) ); 
      break ; 
      case CPT_CHAR_STRING : 
      {
        unsigned int el ; 
        mzchar * us ; 
        BLOCK_SETUP((PUSH(us, 0+XfOrM428_COUNT)));
#       define XfOrM517_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM517(x) SETUP(XfOrM517_COUNT)
        us = NULLED_OUT ; 

# 2676 "bc/src/read.c"
        el = (read_compact_number (port ) ) ; 
        l = (read_compact_number (port ) ) ; 
        if (! (el <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM517(_), scheme_ill_formed (port , "bc/src/read.c" , 2678 ) )
# 2678 "bc/src/read.c"
        ; 

# 2678 "bc/src/read.c"
        ; 
        s = FUNCCALL(SETUP_XfOrM517(_), read_compact_chars (port , buffer , 32 , el ) ); 
        if (l < 4096 )
          us = (mzchar * ) FUNCCALL(SETUP_XfOrM517(_), GC_malloc_atomic ((l + 1 ) * sizeof (mzchar ) ) ); 
        else 
        us = (mzchar * ) FUNCCALL(SETUP_XfOrM517(_), scheme_malloc_fail_ok (GC_malloc_atomic , (l + 1 ) * sizeof (mzchar ) ) ); 
        if (FUNCCALL(SETUP_XfOrM517(_), scheme_utf8_decode ((const unsigned char * ) s , 0 , el , us , 0 , l , ((void * ) 0 ) , 0 , 0 ) )!= l )
          FUNCCALL(SETUP_XfOrM517(_), scheme_ill_formed (port , "bc/src/read.c" , 2685 ) ); 
        us [l ] = 0 ; 
        v = FUNCCALL(SETUP_XfOrM517(_), scheme_make_immutable_sized_char_string (us , l , 0 ) ); 
        v = FUNCCALL_AGAIN(scheme_intern_literal_string (v ) ); 
      }
      break ; 
      case CPT_CHAR : 
      l = (read_compact_number (port ) ) ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_interned_char (l , 1 ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case CPT_INT : 
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((read_compact_number (port ) ) ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
      break ; 
      case CPT_NULL : 
      RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
      break ; 
      case CPT_TRUE : 
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
      break ; 
      case CPT_FALSE : 
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
      break ; 
      case CPT_VOID : 
      RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
      break ; 
      case CPT_BOX : 
      v = (__funcarg93 = FUNCCALL(SETUP_XfOrM428(_), read_compact (port , 0 ) ), FUNCCALL_AGAIN(scheme_box (__funcarg93 ) )) ; 
      ((((Scheme_Inclhash_Object * ) (v ) ) -> so . keyex |= 0x1 ) ) ; 
      break ; 
      case CPT_PAIR : 
      {
#       define XfOrM516_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM516(x) SETUP_XfOrM428(x)

# 2716 "bc/src/read.c"
        v = FUNCCALL(SETUP_XfOrM516(_), read_compact (port , 0 ) ); 
        RET_VALUE_START ((__funcarg92 = FUNCCALL(SETUP_XfOrM516(_), read_compact (port , 0 ) ), FUNCCALL_EMPTY(scheme_make_pair (v , __funcarg92 ) )) ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_LIST : 
      l = (read_compact_number (port ) ) ; 
      if (l == 1 ) {
#       define XfOrM515_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM515(x) SETUP_XfOrM428(x)

# 2723 "bc/src/read.c"
        v = FUNCCALL(SETUP_XfOrM515(_), read_compact (port , 0 ) ); 
        RET_VALUE_START ((__funcarg91 = FUNCCALL(SETUP_XfOrM515(_), read_compact (port , 0 ) ), FUNCCALL_EMPTY(scheme_make_pair (v , __funcarg91 ) )) ) RET_VALUE_END ; 
      }

# 2725 "bc/src/read.c"
      else 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_compact_list (l , 0 , 0 , port ) )) RET_VALUE_EMPTY_END ; 
      break ; 
      case CPT_VECTOR : 
      {
        Scheme_Object * vec ; 
        unsigned int i ; 
        BLOCK_SETUP((PUSH(vec, 0+XfOrM428_COUNT)));
#       define XfOrM512_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM512(x) SETUP(XfOrM512_COUNT)
        vec = NULLED_OUT ; 

# 2733 "bc/src/read.c"
        l = (read_compact_number (port ) ) ; 
        vec = FUNCCALL(SETUP_XfOrM512(_), scheme_make_vector (l , ((void * ) 0 ) ) ); 

        for (i = 0 ; i < l ; i ++ ) {
#         define XfOrM514_COUNT (0+XfOrM512_COUNT)
#         define SETUP_XfOrM514(x) SETUP_XfOrM512(x)

# 2737 "bc/src/read.c"
          v = FUNCCALL(SETUP_XfOrM514(_), read_compact (port , 0 ) ); 
          (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = v ; 
        }

        ((((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex |= 0x1 ) ) ; 

        RET_VALUE_START (vec ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_HASH_TABLE : 
      {
        Scheme_Hash_Tree * ht ; 
        int kind , len ; 
        Scheme_Object * k ; 
        BLOCK_SETUP((PUSH(ht, 0+XfOrM428_COUNT), PUSH(k, 1+XfOrM428_COUNT)));
#       define XfOrM509_COUNT (2+XfOrM428_COUNT)
#       define SETUP_XfOrM509(x) SETUP(XfOrM509_COUNT)
        ht = NULLED_OUT ; 
        k = NULLED_OUT ; 

# 2752 "bc/src/read.c"
        kind = (read_compact_number (port ) ) ; 
        if ((kind < 0 ) || (kind > 3 ) )
          FUNCCALL(SETUP_XfOrM509(_), scheme_ill_formed (port , "bc/src/read.c" , 2754 ) ); 
        len = (read_compact_number (port ) ) ; 

        ht = (scheme_make_hash_tree (kind ) ) ; 
        while (len -- ) {
#         define XfOrM511_COUNT (0+XfOrM509_COUNT)
#         define SETUP_XfOrM511(x) SETUP_XfOrM509(x)

# 2759 "bc/src/read.c"
          k = FUNCCALL(SETUP_XfOrM511(_), read_compact (port , 0 ) ); 
          v = FUNCCALL(SETUP_XfOrM511(_), read_compact (port , 0 ) ); 
          ht = FUNCCALL_AGAIN(scheme_hash_tree_set (ht , k , v ) ); 
        }

        v = (Scheme_Object * ) ht ; 
      }
      break ; 
      case CPT_LINKLET : 
      {
        int has_prefix ; 
        Scheme_Prefix * pf ; 
        BLOCK_SETUP((PUSH(pf, 0+XfOrM428_COUNT)));
#       define XfOrM508_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM508(x) SETUP(XfOrM508_COUNT)
        pf = NULLED_OUT ; 

# 2772 "bc/src/read.c"
        has_prefix = (read_compact_number (port ) ) ; 
        if (has_prefix )
          pf = (Scheme_Prefix * ) FUNCCALL(SETUP_XfOrM508(_), read_compact (port , 0 ) ); 
        else 
        pf = ((void * ) 0 ) ; 

        v = FUNCCALL(SETUP_XfOrM508(_), read_compact (port , 1 ) ); 
        v = FUNCCALL_AGAIN(scheme_read_linklet (v , port -> unsafe_ok ) ); 
        if (! v )
          FUNCCALL(SETUP_XfOrM508(_), scheme_ill_formed (port , "bc/src/read.c" , 2780 ) )
# 2780 "bc/src/read.c"
        ; 

        ((Scheme_Linklet * ) v ) -> static_prefix = pf ; 

        RET_VALUE_START (v ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_QUOTE : 
      v = FUNCCALL(SETUP_XfOrM428(_), read_compact_quote (port , 1 ) ); 
      break ; 
      case CPT_REFERENCE : 
      l = (read_compact_number (port ) ) ; 
      if (! (l < 1575 ) )
        FUNCCALL(SETUP_XfOrM428(_), scheme_ill_formed (port , "bc/src/read.c" , 2792 ) )
# 2792 "bc/src/read.c"
      ; 

# 2792 "bc/src/read.c"
      ; 
      RET_VALUE_START (variable_references [l ] ) RET_VALUE_END ; 
      break ; 
      case CPT_TOPLEVEL : 
      {
        int flags , pos , depth ; 
#       define XfOrM507_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM507(x) SETUP_XfOrM428(x)

# 2799 "bc/src/read.c"
        flags = (read_compact_number (port ) ) ; 
        pos = (read_compact_number (port ) ) ; 
        depth = (read_compact_number (port ) ) ; 

        if ((depth < 0 ) || (pos < 0 ) )
          FUNCCALL(SETUP_XfOrM507(_), scheme_ill_formed (port , "bc/src/read.c" , 2804 ) ); 

        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_toplevel (depth , pos , flags & 0x3 ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case CPT_LOCAL : 
      {
        int p , flags ; 
#       define XfOrM505_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM505(x) SETUP_XfOrM428(x)

# 2812 "bc/src/read.c"
        p = (read_compact_number (port ) ) ; 
        if (p < 0 ) {
#         define XfOrM506_COUNT (0+XfOrM505_COUNT)
#         define SETUP_XfOrM506(x) SETUP_XfOrM505(x)

# 2814 "bc/src/read.c"
          p = - (p + 1 ) ; 
          flags = (read_compact_number (port ) ) ; 
        }

# 2816 "bc/src/read.c"
        else 
        flags = 0 ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_local (scheme_local_type , p , flags ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case CPT_LOCAL_UNBOX : 
      {
        int p , flags ; 
#       define XfOrM503_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM503(x) SETUP_XfOrM428(x)

# 2824 "bc/src/read.c"
        p = (read_compact_number (port ) ) ; 
        if (p < 0 ) {
#         define XfOrM504_COUNT (0+XfOrM503_COUNT)
#         define SETUP_XfOrM504(x) SETUP_XfOrM503(x)

# 2826 "bc/src/read.c"
          p = - (p + 1 ) ; 
          flags = (read_compact_number (port ) ) ; 
        }

# 2828 "bc/src/read.c"
        else 
        flags = 0 ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_local (scheme_local_unbox_type , p , flags ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case CPT_SVECTOR : 
      {
        int l ; 
#       define XfOrM502_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM502(x) SETUP_XfOrM428(x)

# 2836 "bc/src/read.c"
        l = (read_compact_number (port ) ) ; 
        v = FUNCCALL(SETUP_XfOrM502(_), read_compact_svector (port , l ) ); 
      }
      break ; 
      case CPT_APPLICATION : 
      {
        int c , i ; 
        Scheme_App_Rec * a ; 
        BLOCK_SETUP((PUSH(a, 0+XfOrM428_COUNT)));
#       define XfOrM499_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM499(x) SETUP(XfOrM499_COUNT)
        a = NULLED_OUT ; 

# 2845 "bc/src/read.c"
        c = (read_compact_number (port ) ) + 1 ; 

        a = FUNCCALL(SETUP_XfOrM499(_), scheme_malloc_application (c ) ); 
        for (i = 0 ; i < c ; i ++ ) {
#         define XfOrM501_COUNT (0+XfOrM499_COUNT)
#         define SETUP_XfOrM501(x) SETUP_XfOrM499(x)

# 2849 "bc/src/read.c"
          v = FUNCCALL(SETUP_XfOrM501(_), read_compact (port , 1 ) ); 
          a -> args [i ] = v ; 
        }
        FUNCCALL(SETUP_XfOrM499(_), scheme_finish_application (a ) )
        ; 
        RET_VALUE_START ((Scheme_Object * ) a ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_BEGIN : 
      case CPT_BEGIN0 : 
      {
        Scheme_Sequence * seq ; 
        int i , count ; 
        BLOCK_SETUP((PUSH(seq, 0+XfOrM428_COUNT)));
#       define XfOrM496_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM496(x) SETUP(XfOrM496_COUNT)
        seq = NULLED_OUT ; 

# 2863 "bc/src/read.c"
        count = (read_compact_number (port ) ) ; 
        if (count <= 0 )
          FUNCCALL(SETUP_XfOrM496(_), scheme_ill_formed (port , "bc/src/read.c" , 2864 ) )
# 2864 "bc/src/read.c"
        ; 
        seq = FUNCCALL(SETUP_XfOrM496(_), scheme_malloc_sequence (count ) ); 
        seq -> so . type = ((ch == CPT_BEGIN ) ? scheme_sequence_type : scheme_begin0_sequence_type ) ; 
        seq -> count = count ; 

        for (i = 0 ; i < count ; i ++ ) {
#         define XfOrM498_COUNT (0+XfOrM496_COUNT)
#         define SETUP_XfOrM498(x) SETUP_XfOrM496(x)

# 2870 "bc/src/read.c"
          v = FUNCCALL(SETUP_XfOrM498(_), read_compact (port , 1 ) ); 
          seq -> array [i ] = v ; 
        }

        RET_VALUE_START ((Scheme_Object * ) seq ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_LET_VALUE : 
      {
        Scheme_Let_Value * lv ; 
        int c , p ; 
        BLOCK_SETUP((PUSH(lv, 0+XfOrM428_COUNT)));
#       define XfOrM495_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM495(x) SETUP(XfOrM495_COUNT)
        lv = NULLED_OUT ; 

# 2882 "bc/src/read.c"
        lv = (Scheme_Let_Value * ) FUNCCALL(SETUP_XfOrM495(_), GC_malloc_one_tagged (sizeof (Scheme_Let_Value ) ) ); 
        lv -> iso . so . type = scheme_let_value_type ; 

        c = (read_compact_number (port ) ) ; 
        p = (read_compact_number (port ) ) ; 
        if ((c < 0 ) || (p < 0 ) )
          FUNCCALL(SETUP_XfOrM495(_), scheme_ill_formed (port , "bc/src/read.c" , 2887 ) )
# 2887 "bc/src/read.c"
        ; 

        lv -> count = c ; 
        lv -> position = p ; 
        if (read_compact_number (port ) ) 
          (& lv -> iso ) -> so . keyex = 1 ; 
        v = FUNCCALL(SETUP_XfOrM495(_), read_compact (port , 1 ) ); 
        lv -> value = v ; 
        v = FUNCCALL(SETUP_XfOrM495(_), read_compact (port , 1 ) ); 
        lv -> body = v ; 

        RET_VALUE_START ((Scheme_Object * ) lv ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_LET_VOID : 
      {
        Scheme_Let_Void * lv ; 
        int c ; 
        BLOCK_SETUP((PUSH(lv, 0+XfOrM428_COUNT)));
#       define XfOrM494_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM494(x) SETUP(XfOrM494_COUNT)
        lv = NULLED_OUT ; 

# 2906 "bc/src/read.c"
        lv = (Scheme_Let_Void * ) FUNCCALL(SETUP_XfOrM494(_), GC_malloc_one_tagged (sizeof (Scheme_Let_Void ) ) ); 
        lv -> iso . so . type = scheme_let_void_type ; 

        c = (read_compact_number (port ) ) ; 
        if (c < 0 )
          FUNCCALL(SETUP_XfOrM494(_), scheme_ill_formed (port , "bc/src/read.c" , 2910 ) )
# 2910 "bc/src/read.c"
        ; 

        lv -> count = c ; 
        if (read_compact_number (port ) ) 
          (& lv -> iso ) -> so . keyex = 1 ; 
        v = FUNCCALL(SETUP_XfOrM494(_), read_compact (port , 1 ) ); 
        lv -> body = v ; 

        RET_VALUE_START ((Scheme_Object * ) lv ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_LETREC : 
      {
        Scheme_Letrec * lr ; 
        Scheme_Object * * sa ; 
        int i , c ; 
        BLOCK_SETUP((PUSH(sa, 0+XfOrM428_COUNT), PUSH(lr, 1+XfOrM428_COUNT)));
#       define XfOrM490_COUNT (2+XfOrM428_COUNT)
#       define SETUP_XfOrM490(x) SETUP(XfOrM490_COUNT)
        lr = NULLED_OUT ; 
        sa = NULLED_OUT ; 

# 2927 "bc/src/read.c"
        lr = ((Scheme_Letrec * ) FUNCCALL(SETUP_XfOrM490(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Letrec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        lr -> so . type = scheme_letrec_type ; 

        c = (read_compact_number (port ) ) ; 
        if (c < 0 )
          FUNCCALL(SETUP_XfOrM490(_), scheme_ill_formed (port , "bc/src/read.c" , 2931 ) )
# 2931 "bc/src/read.c"
        ; 

        lr -> count = c ; 
        if (c < 4096 )
          sa = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM490(_), GC_malloc (sizeof (Scheme_Object * ) * (c ) ) )) ; 
        else {
#         define XfOrM493_COUNT (0+XfOrM490_COUNT)
#         define SETUP_XfOrM493(x) SETUP_XfOrM490(x)

# 2937 "bc/src/read.c"
          sa = (__funcarg90 = FUNCCALL(SETUP_XfOrM493(_), scheme_check_overflow (c , sizeof (Scheme_Object * ) , 0 ) ), FUNCCALL_AGAIN(scheme_malloc_fail_ok (GC_malloc , __funcarg90 ) )) ; 
          if (! sa )
            FUNCCALL_EMPTY(scheme_signal_error ("out of memory allocating letrec bytecode" ) )
# 2938 "bc/src/read.c"
          ; 
        }
        lr -> procs = sa ; 

        for (i = 0 ; i < c ; i ++ ) {
#         define XfOrM492_COUNT (0+XfOrM490_COUNT)
#         define SETUP_XfOrM492(x) SETUP_XfOrM490(x)

# 2943 "bc/src/read.c"
          v = FUNCCALL(SETUP_XfOrM492(_), read_compact (port , 1 ) ); 
          sa [i ] = v ; 
        }

        v = FUNCCALL(SETUP_XfOrM490(_), read_compact (port , 1 ) ); 
        lr -> body = v ; 

        RET_VALUE_START ((Scheme_Object * ) lr ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_LET_ONE : 
      case CPT_LET_ONE_TYPED : 
      case CPT_LET_ONE_UNUSED : 
      {
        Scheme_Let_One * lo ; 
        int et ; 
        BLOCK_SETUP((PUSH(lo, 0+XfOrM428_COUNT)));
#       define XfOrM488_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM488(x) SETUP(XfOrM488_COUNT)
        lo = NULLED_OUT ; 

# 2960 "bc/src/read.c"
        lo = (Scheme_Let_One * ) FUNCCALL(SETUP_XfOrM488(_), GC_malloc_one_tagged (sizeof (Scheme_Let_One ) ) ); 
        lo -> iso . so . type = scheme_let_one_type ; 

        v = FUNCCALL(SETUP_XfOrM488(_), read_compact (port , 1 ) ); 
        lo -> value = v ; 
        v = FUNCCALL(SETUP_XfOrM488(_), read_compact (port , 1 ) ); 
        lo -> body = v ; 
        et = FUNCCALL(SETUP_XfOrM488(_), scheme_get_eval_type (lo -> value ) ); 
        if (ch == CPT_LET_ONE_TYPED ) {
          int ty ; 
#         define XfOrM489_COUNT (0+XfOrM488_COUNT)
#         define SETUP_XfOrM489(x) SETUP_XfOrM488(x)

# 2970 "bc/src/read.c"
          ty = (read_compact_number (port ) ) ; 
          et |= (ty << 4 ) ; 
        }

# 2972 "bc/src/read.c"
        else if (ch == CPT_LET_ONE_UNUSED )
          et |= 0x8 ; 
        (& lo -> iso ) -> so . keyex = et ; 

        RET_VALUE_START ((Scheme_Object * ) lo ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_BRANCH : 
      {
        Scheme_Object * test , * tbranch , * fbranch ; 
        BLOCK_SETUP((PUSH(tbranch, 0+XfOrM428_COUNT), PUSH(test, 1+XfOrM428_COUNT), PUSH(fbranch, 2+XfOrM428_COUNT)));
#       define XfOrM487_COUNT (3+XfOrM428_COUNT)
#       define SETUP_XfOrM487(x) SETUP(XfOrM487_COUNT)
        test = NULLED_OUT ; 
        tbranch = NULLED_OUT ; 
        fbranch = NULLED_OUT ; 

# 2982 "bc/src/read.c"
        test = FUNCCALL(SETUP_XfOrM487(_), read_compact (port , 1 ) ); 
        tbranch = FUNCCALL_AGAIN(read_compact (port , 1 ) ); 
        fbranch = FUNCCALL_AGAIN(read_compact (port , 1 ) ); 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_branch (test , tbranch , fbranch ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case CPT_WCM : 
      {
        Scheme_With_Continuation_Mark * wcm ; 
        BLOCK_SETUP((PUSH(wcm, 0+XfOrM428_COUNT)));
#       define XfOrM486_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM486(x) SETUP(XfOrM486_COUNT)
        wcm = NULLED_OUT ; 

# 2992 "bc/src/read.c"
        wcm = ((Scheme_With_Continuation_Mark * ) FUNCCALL(SETUP_XfOrM486(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_With_Continuation_Mark ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        wcm -> so . type = scheme_with_cont_mark_type ; 

        v = FUNCCALL(SETUP_XfOrM486(_), read_compact (port , 1 ) ); 
        wcm -> key = v ; 
        v = FUNCCALL(SETUP_XfOrM486(_), read_compact (port , 1 ) ); 
        wcm -> val = v ; 
        v = FUNCCALL(SETUP_XfOrM486(_), read_compact (port , 1 ) ); 
        wcm -> body = v ; 

        RET_VALUE_START ((Scheme_Object * ) wcm ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_DEFINE_VALUES : 
      {
#       define XfOrM482_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM482(x) SETUP_XfOrM428(x)

# 3007 "bc/src/read.c"
        v = FUNCCALL(SETUP_XfOrM482(_), read_compact (port , 1 ) ); 
        if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
          FUNCCALL(SETUP_XfOrM482(_), scheme_ill_formed (port , "bc/src/read.c" , 3008 ) )
# 3008 "bc/src/read.c"
        ; 
        {
          int i , c = (((Scheme_Vector * ) (v ) ) -> size ) ; 
#         define XfOrM483_COUNT (0+XfOrM482_COUNT)
#         define SETUP_XfOrM483(x) SETUP_XfOrM482(x)

# 3011 "bc/src/read.c"
          if (c < 1 )
            FUNCCALL(SETUP_XfOrM483(_), scheme_ill_formed (port , "bc/src/read.c" , 3011 ) )
# 3011 "bc/src/read.c"
          ; 
          for (i = 1 ; i < c ; i ++ ) {
#           define XfOrM485_COUNT (0+XfOrM483_COUNT)
#           define SETUP_XfOrM485(x) SETUP_XfOrM483(x)

# 3013 "bc/src/read.c"
            if (! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Vector * ) (v ) ) -> els ) [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Vector * ) (v ) ) -> els ) [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
            && ! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Vector * ) (v ) ) -> els ) [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Vector * ) (v ) ) -> els ) [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) )
              FUNCCALL(SETUP_XfOrM485(_), scheme_ill_formed (port , "bc/src/read.c" , 3015 ) ); 
          }
        }
        v -> type = scheme_define_values_type ; 
        RET_VALUE_START (v ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_SET_BANG : 
      {
        Scheme_Set_Bang * sb ; 
        BLOCK_SETUP((PUSH(sb, 0+XfOrM428_COUNT)));
#       define XfOrM481_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM481(x) SETUP(XfOrM481_COUNT)
        sb = NULLED_OUT ; 

# 3026 "bc/src/read.c"
        sb = ((Scheme_Set_Bang * ) FUNCCALL(SETUP_XfOrM481(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Set_Bang ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        sb -> so . type = scheme_set_bang_type ; 

        if (read_compact_number (port ) ) 
          sb -> set_undef = 1 ; 

        v = FUNCCALL(SETUP_XfOrM481(_), read_compact (port , 1 ) ); 
        sb -> var = v ; 
        if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
        && ! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) )
          FUNCCALL(SETUP_XfOrM481(_), scheme_ill_formed (port , "bc/src/read.c" , 3036 ) ); 
        v = FUNCCALL(SETUP_XfOrM481(_), read_compact (port , 1 ) ); 
        sb -> val = v ; 

        RET_VALUE_START ((Scheme_Object * ) sb ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_OTHER_FORM : 
      {
#       define XfOrM463_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM463(x) SETUP_XfOrM428(x)

# 3045 "bc/src/read.c"
        switch ((read_compact_number (port ) ) ) {
#         define XfOrM464_COUNT (0+XfOrM463_COUNT)
#         define SETUP_XfOrM464(x) SETUP_XfOrM463(x)

# 3046 "bc/src/read.c"
          case scheme_static_toplevel_type : 
          {
            Scheme_Object * tl = scheme_false ; 
            Scheme_Prefix * pf ; 
            intptr_t flags , pos , i ; 
            BLOCK_SETUP((PUSH(tl, 0+XfOrM464_COUNT), PUSH(pf, 1+XfOrM464_COUNT)));
#           define XfOrM477_COUNT (2+XfOrM464_COUNT)
#           define SETUP_XfOrM477(x) SETUP(XfOrM477_COUNT)
            pf = NULLED_OUT ; 

# 3052 "bc/src/read.c"
            flags = (read_compact_number (port ) ) ; 
            pos = (read_compact_number (port ) ) ; 


            ch = ((int ) (port -> start [port -> pos ++ ] ) ) ; 
            if (ch == CPT_SYMREF ) {
#             define XfOrM480_COUNT (0+XfOrM477_COUNT)
#             define SETUP_XfOrM480(x) SETUP_XfOrM477(x)

# 3058 "bc/src/read.c"
              l = (read_compact_number (port ) ) ; 
              if (! ((l > 0 ) && (l < port -> symtab_size ) ) )
                FUNCCALL(SETUP_XfOrM480(_), scheme_ill_formed (port , "bc/src/read.c" , 3059 ) )
# 3059 "bc/src/read.c"
              ; 

# 3059 "bc/src/read.c"
              ; 
              pf = (Scheme_Prefix * ) port -> symtab [l ] ; 
            }

# 3061 "bc/src/read.c"
            else {
#             define XfOrM479_COUNT (0+XfOrM477_COUNT)
#             define SETUP_XfOrM479(x) SETUP_XfOrM477(x)

# 3062 "bc/src/read.c"
              -- port -> pos ; 
              pf = (Scheme_Prefix * ) FUNCCALL(SETUP_XfOrM479(_), read_compact (port , 0 ) ); 
            }

            if (! ((Scheme_Type ) (((((intptr_t ) (pf ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pf ) ) -> type ) ) == (Scheme_Type ) (scheme_prefix_type ) ) || (pos < 0 ) || (pos >= pf -> num_slots ) )
              FUNCCALL(SETUP_XfOrM477(_), scheme_ill_formed (port , "bc/src/read.c" , 3067 ) ); 

            flags &= 0x3 ; 
            i = ((pos << 2 ) | flags ) ; 
            if ((i < 0 ) || (i >= (pf -> num_slots * (0x3 + 1 ) ) ) )
              FUNCCALL(SETUP_XfOrM477(_), scheme_ill_formed (port , "bc/src/read.c" , 3072 ) ); 

            tl = ((Scheme_Object * * ) pf -> a [pf -> num_slots - 1 ] ) [i ] ; 
            if (! tl ) {
#             define XfOrM478_COUNT (0+XfOrM477_COUNT)
#             define SETUP_XfOrM478(x) SETUP_XfOrM477(x)

# 3076 "bc/src/read.c"
              tl = (Scheme_Object * ) ((Scheme_Toplevel * ) FUNCCALL(SETUP_XfOrM478(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Toplevel ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
              tl -> type = scheme_static_toplevel_type ; 
              (((Scheme_Toplevel * ) (tl ) ) -> u . prefix ) = pf ; 
              (((Scheme_Toplevel * ) (tl ) ) -> position ) = pos ; 
              (& ((Scheme_Toplevel * ) (tl ) ) -> iso ) -> so . keyex |= flags ; 
              ((Scheme_Object * * ) pf -> a [pf -> num_slots - 1 ] ) [i ] = tl ; 
            }

            RET_VALUE_START (tl ) RET_VALUE_END ; 
          }
          break ; 
          case scheme_prefix_type : 
          {
            intptr_t prefix_size ; 
            Scheme_Object * * a ; 
            BLOCK_SETUP((PUSH(a, 0+XfOrM464_COUNT)));
#           define XfOrM476_COUNT (1+XfOrM464_COUNT)
#           define SETUP_XfOrM476(x) SETUP(XfOrM476_COUNT)
            a = NULLED_OUT ; 

# 3092 "bc/src/read.c"
            prefix_size = (read_compact_number (port ) ) ; 
            if (prefix_size <= 0 )
              FUNCCALL(SETUP_XfOrM476(_), scheme_ill_formed (port , "bc/src/read.c" , 3093 ) )
# 3093 "bc/src/read.c"
            ; 
            if (prefix_size < 4096 )
              v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM476(_), scheme_allocate_prefix (prefix_size ) ); 
            else 
            v = FUNCCALL(SETUP_XfOrM476(_), scheme_malloc_fail_ok ((GC_Alloc_Proc ) scheme_allocate_prefix , prefix_size ) ); 


            a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM476(_), GC_malloc (sizeof (Scheme_Object * ) * (prefix_size * (0x3 + 1 ) ) ) )) ; 
            ((Scheme_Prefix * ) v ) -> a [prefix_size - 1 ] = (Scheme_Object * ) a ; 

            RET_VALUE_START (v ) RET_VALUE_END ; 
          }
          case scheme_boxenv_type : 
          {
            Scheme_Object * data ; 
            BLOCK_SETUP((PUSH(data, 0+XfOrM464_COUNT)));
#           define XfOrM475_COUNT (1+XfOrM464_COUNT)
#           define SETUP_XfOrM475(x) SETUP(XfOrM475_COUNT)
            data = NULLED_OUT ; 

# 3109 "bc/src/read.c"
            data = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM475(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
            data -> type = scheme_boxenv_type ; 

            v = FUNCCALL(SETUP_XfOrM475(_), read_compact (port , 1 ) ); 
            (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) = v ; 
            v = FUNCCALL(SETUP_XfOrM475(_), read_compact (port , 1 ) ); 
            (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) = v ; 

            RET_VALUE_START (data ) RET_VALUE_END ; 
          }
          break ; 
          case scheme_with_immed_mark_type : 
          {
            Scheme_With_Continuation_Mark * wcm ; 
            BLOCK_SETUP((PUSH(wcm, 0+XfOrM464_COUNT)));
#           define XfOrM474_COUNT (1+XfOrM464_COUNT)
#           define SETUP_XfOrM474(x) SETUP(XfOrM474_COUNT)
            wcm = NULLED_OUT ; 

# 3124 "bc/src/read.c"
            wcm = ((Scheme_With_Continuation_Mark * ) FUNCCALL(SETUP_XfOrM474(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_With_Continuation_Mark ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
            wcm -> so . type = scheme_with_immed_mark_type ; 

            v = FUNCCALL(SETUP_XfOrM474(_), read_compact (port , 1 ) ); 
            wcm -> key = v ; 
            v = FUNCCALL(SETUP_XfOrM474(_), read_compact (port , 1 ) ); 
            wcm -> val = v ; 
            v = FUNCCALL(SETUP_XfOrM474(_), read_compact (port , 1 ) ); 
            wcm -> body = v ; 

            RET_VALUE_START ((Scheme_Object * ) wcm ) RET_VALUE_END ; 
          }
          case scheme_inline_variant_type : 
          {
            Scheme_Object * data ; 
            BLOCK_SETUP((PUSH(data, 0+XfOrM464_COUNT)));
#           define XfOrM473_COUNT (1+XfOrM464_COUNT)
#           define SETUP_XfOrM473(x) SETUP(XfOrM473_COUNT)
            data = NULLED_OUT ; 

# 3140 "bc/src/read.c"
            data = FUNCCALL(SETUP_XfOrM473(_), scheme_make_vector (3 , scheme_false ) ); 
            data -> type = scheme_inline_variant_type ; 

            v = FUNCCALL(SETUP_XfOrM473(_), read_compact (port , 1 ) ); 
            (((Scheme_Vector * ) (data ) ) -> els ) [0 ] = v ; 
            v = FUNCCALL(SETUP_XfOrM473(_), read_compact (port , 1 ) ); 
            (((Scheme_Vector * ) (data ) ) -> els ) [1 ] = v ; 


            RET_VALUE_START (data ) RET_VALUE_END ; 
          }
          case scheme_case_lambda_sequence_type : 
          {
            int count , i , all_closed = 1 ; 
            Scheme_Case_Lambda * cl ; 
            BLOCK_SETUP((PUSH(cl, 0+XfOrM464_COUNT)));
#           define XfOrM466_COUNT (1+XfOrM464_COUNT)
#           define SETUP_XfOrM466(x) SETUP(XfOrM466_COUNT)
            cl = NULLED_OUT ; 

# 3156 "bc/src/read.c"
            count = (read_compact_number (port ) ) ; 
            if (count < 0 )
              FUNCCALL(SETUP_XfOrM466(_), scheme_ill_formed (port , "bc/src/read.c" , 3157 ) )
# 3157 "bc/src/read.c"
            ; 

            if (count < 4096 )
              cl = (Scheme_Case_Lambda * ) FUNCCALL(SETUP_XfOrM466(_), GC_malloc_one_tagged (sizeof (Scheme_Case_Lambda ) + (count - 0 ) * sizeof (Scheme_Object * ) ) )
            ; 
            else {
              intptr_t sz ; 
#             define XfOrM472_COUNT (0+XfOrM466_COUNT)
#             define SETUP_XfOrM472(x) SETUP_XfOrM466(x)

# 3164 "bc/src/read.c"
              sz = FUNCCALL(SETUP_XfOrM472(_), scheme_check_overflow ((count - 0 ) , sizeof (Scheme_Object * ) , sizeof (Scheme_Case_Lambda ) ) ); 
              cl = (Scheme_Case_Lambda * ) FUNCCALL(SETUP_XfOrM472(_), scheme_malloc_fail_ok (GC_malloc_one_tagged , sz ) ); 
              if (! cl )
                FUNCCALL_EMPTY(scheme_signal_error ("out of memory allocating procedure bytecode" ) )
# 3166 "bc/src/read.c"
              ; 
            }

            cl -> so . type = scheme_case_lambda_sequence_type ; 
            cl -> count = count ; 

            v = FUNCCALL(SETUP_XfOrM466(_), read_compact (port , 1 ) ); 
            if ((v ) == (scheme_null ) ) 
              cl -> name = ((void * ) 0 ) ; 
            else 
            cl -> name = v ; 

            for (i = 0 ; i < count ; i ++ ) {
#             define XfOrM470_COUNT (0+XfOrM466_COUNT)
#             define SETUP_XfOrM470(x) SETUP_XfOrM466(x)

# 3179 "bc/src/read.c"
              v = FUNCCALL(SETUP_XfOrM470(_), read_compact (port , 1 ) ); 
              cl -> array [i ] = v ; 
              if (! (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
#               define XfOrM471_COUNT (0+XfOrM470_COUNT)
#               define SETUP_XfOrM471(x) SETUP_XfOrM470(x)

# 3182 "bc/src/read.c"
                if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) )
                  FUNCCALL(SETUP_XfOrM471(_), scheme_ill_formed (port , "bc/src/read.c" , 3183 ) ); 
                all_closed = 0 ; 
              }

# 3185 "bc/src/read.c"
              else if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) )
                FUNCCALL(SETUP_XfOrM470(_), scheme_ill_formed (port , "bc/src/read.c" , 3186 ) ); 
            }

            if (all_closed ) {
#             define XfOrM467_COUNT (0+XfOrM466_COUNT)
#             define SETUP_XfOrM467(x) SETUP_XfOrM466(x)


              RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_case_lambda_execute ((Scheme_Object * ) cl ) )) RET_VALUE_EMPTY_END ; 
            }

            RET_VALUE_START ((Scheme_Object * ) cl ) RET_VALUE_END ; 
          }
          break ; 
          case scheme_lambda_type : 
          {
            Scheme_Object * name , * ds , * closure_map , * tl_map ; 
            int flags , closure_size , num_params , max_let_depth ; 
            BLOCK_SETUP((PUSH(closure_map, 0+XfOrM464_COUNT), PUSH(tl_map, 1+XfOrM464_COUNT), PUSH(ds, 2+XfOrM464_COUNT), PUSH(name, 3+XfOrM464_COUNT)));
#           define XfOrM465_COUNT (4+XfOrM464_COUNT)
#           define SETUP_XfOrM465(x) SETUP(XfOrM465_COUNT)
            name = NULLED_OUT ; 
            ds = NULLED_OUT ; 
            closure_map = NULLED_OUT ; 
            tl_map = NULLED_OUT ; 

# 3205 "bc/src/read.c"
            flags = (read_compact_number (port ) ) ; 
            if (flags & 2 )
              closure_size = (read_compact_number (port ) ) ; 
            else 
            closure_size = - 1 ; 
            num_params = (read_compact_number (port ) ) ; 
            max_let_depth = (read_compact_number (port ) ) ; 

            name = FUNCCALL(SETUP_XfOrM465(_), read_compact (port , 1 ) ); 
            ds = FUNCCALL_AGAIN(read_compact (port , 1 ) ); 
            closure_map = FUNCCALL_AGAIN(read_compact (port , 1 ) ); 
            tl_map = FUNCCALL_AGAIN(read_compact (port , 1 ) ); 

            v = FUNCCALL_AGAIN(scheme_read_lambda (flags , closure_size , num_params , max_let_depth , name , ds , closure_map , tl_map ) )
            ; 
            if (! v )
              FUNCCALL(SETUP_XfOrM465(_), scheme_ill_formed (port , "bc/src/read.c" , 3220 ) )
# 3220 "bc/src/read.c"
            ; 

            RET_VALUE_START (v ) RET_VALUE_END ; 
          }
          default : FUNCCALL(SETUP_XfOrM464(_), scheme_ill_formed (port , "bc/src/read.c" , 3225 ) )
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          break ; 
        }
      }
      break ; 
      case CPT_VARREF : 
      {
        Scheme_Object * data ; 
        int flags ; 
        BLOCK_SETUP((PUSH(data, 0+XfOrM428_COUNT)));
#       define XfOrM462_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM462(x) SETUP(XfOrM462_COUNT)
        data = NULLED_OUT ; 

# 3236 "bc/src/read.c"
        data = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM462(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        data -> type = scheme_varref_form_type ; 

        flags = (read_compact_number (port ) ) ; 
        (& ((Scheme_Simple_Object * ) data ) -> iso ) -> so . keyex |= (flags & (0x1 | 0x2 ) ) ; 

        v = FUNCCALL(SETUP_XfOrM462(_), read_compact (port , 1 ) ); 
        (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) = v ; 
        if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
        && ! (((v ) ) == (scheme_false ) ) 
        && ! ((v ) == (scheme_true ) ) 
        && ! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) )
          FUNCCALL(SETUP_XfOrM462(_), scheme_ill_formed (port , "bc/src/read.c" , 3248 ) ); 

        v = FUNCCALL(SETUP_XfOrM462(_), read_compact (port , 1 ) ); 
        (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) = v ; 
        if (! (((v ) ) == (scheme_false ) ) 
        && ! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) )
          FUNCCALL(SETUP_XfOrM462(_), scheme_ill_formed (port , "bc/src/read.c" , 3254 ) ); 

        RET_VALUE_START (data ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_APPLY_VALUES : 
      {
        Scheme_Object * data ; 
        BLOCK_SETUP((PUSH(data, 0+XfOrM428_COUNT)));
#       define XfOrM461_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM461(x) SETUP(XfOrM461_COUNT)
        data = NULLED_OUT ; 

# 3263 "bc/src/read.c"
        data = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM461(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        data -> type = scheme_apply_values_type ; 

        v = FUNCCALL(SETUP_XfOrM461(_), read_compact (port , 1 ) ); 
        (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) = v ; 
        v = FUNCCALL(SETUP_XfOrM461(_), read_compact (port , 1 ) ); 
        (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) = v ; 

        RET_VALUE_START (data ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_PATH : 
      {
#       define XfOrM455_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM455(x) SETUP_XfOrM428(x)

# 3276 "bc/src/read.c"
        l = (read_compact_number (port ) ) ; 
        if (! (l <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM455(_), scheme_ill_formed (port , "bc/src/read.c" , 3277 ) )
# 3277 "bc/src/read.c"
        ; 

# 3277 "bc/src/read.c"
        ; 
        if (l ) {
#         define XfOrM460_COUNT (0+XfOrM455_COUNT)
#         define SETUP_XfOrM460(x) SETUP_XfOrM455(x)

# 3279 "bc/src/read.c"
          s = FUNCCALL(SETUP_XfOrM460(_), read_compact_chars (port , buffer , 32 , l ) ); 
          v = FUNCCALL(SETUP_XfOrM460(_), scheme_make_sized_path (s , l , l < 32 ) ); 
        }

# 3281 "bc/src/read.c"
        else {
          Scheme_Object * elems ; 
          BLOCK_SETUP((PUSH(elems, 0+XfOrM455_COUNT)));
#         define XfOrM456_COUNT (1+XfOrM455_COUNT)
#         define SETUP_XfOrM456(x) SETUP(XfOrM456_COUNT)
          elems = NULLED_OUT ; 

# 3283 "bc/src/read.c"
          elems = FUNCCALL(SETUP_XfOrM456(_), read_compact (port , 0 ) ); 
          if ((Scheme_Type ) (((((intptr_t ) (port -> relto ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (port -> relto ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {

            v = port -> relto ; 
          }

# 3287 "bc/src/read.c"
          else 
          v = FUNCCALL(SETUP_XfOrM456(_), scheme_maybe_build_path (((void * ) 0 ) , scheme_false ) ); 
          while (((Scheme_Type ) (((((intptr_t ) (elems ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (elems ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#           define XfOrM458_COUNT (0+XfOrM456_COUNT)
#           define SETUP_XfOrM458(x) SETUP_XfOrM456(x)

# 3290 "bc/src/read.c"
            v = FUNCCALL(SETUP_XfOrM458(_), scheme_maybe_build_path (v , (((Scheme_Simple_Object * ) (elems ) ) -> u . pair_val . car ) ) ); 
            elems = (((Scheme_Simple_Object * ) (elems ) ) -> u . pair_val . cdr ) ; 
          }
        }
      }
      break ; 
      case CPT_SRCLOC : 
      {
        Scheme_Object * r ; 
        BLOCK_SETUP((PUSH(r, 0+XfOrM428_COUNT)));
#       define XfOrM454_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM454(x) SETUP(XfOrM454_COUNT)
        r = NULLED_OUT ; 

# 3299 "bc/src/read.c"
        r = FUNCCALL(SETUP_XfOrM454(_), scheme_unsafe_make_location () ); 


        v = FUNCCALL_AGAIN(read_compact (port , 0 ) ); 
        ((Scheme_Structure * ) r ) -> slots [0 ] = v ; 
        v = FUNCCALL(SETUP_XfOrM454(_), read_compact (port , 0 ) ); 
        ((Scheme_Structure * ) r ) -> slots [1 ] = v ; 
        v = FUNCCALL(SETUP_XfOrM454(_), read_compact (port , 0 ) ); 
        ((Scheme_Structure * ) r ) -> slots [2 ] = v ; 
        v = FUNCCALL(SETUP_XfOrM454(_), read_compact (port , 0 ) ); 
        ((Scheme_Structure * ) r ) -> slots [3 ] = v ; 
        v = FUNCCALL(SETUP_XfOrM454(_), read_compact (port , 0 ) ); 
        ((Scheme_Structure * ) r ) -> slots [4 ] = v ; 
        RET_VALUE_START (r ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_CLOSURE : 
      {
        Scheme_Closure * cl ; 
        BLOCK_SETUP((PUSH(cl, 0+XfOrM428_COUNT)));
#       define XfOrM452_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM452(x) SETUP(XfOrM452_COUNT)
        cl = NULLED_OUT ; 

# 3318 "bc/src/read.c"
        l = (read_compact_number (port ) ) ; 
        if (! (l < port -> symtab_size ) )
          FUNCCALL(SETUP_XfOrM452(_), scheme_ill_formed (port , "bc/src/read.c" , 3319 ) )
# 3319 "bc/src/read.c"
        ; 

# 3319 "bc/src/read.c"
        ; 
        cl = FUNCCALL(SETUP_XfOrM452(_), scheme_malloc_empty_closure () ); 
        port -> symtab [l ] = (Scheme_Object * ) cl ; 
        v = FUNCCALL(SETUP_XfOrM452(_), read_compact (port , 0 ) ); 
        if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) 
        || ! ((Scheme_Closure * ) v ) -> code 
        || ((Scheme_Closure * ) v ) -> code -> closure_size ) {
#         define XfOrM453_COUNT (0+XfOrM452_COUNT)
#         define SETUP_XfOrM453(x) SETUP_XfOrM452(x)
          FUNCCALL(SETUP_XfOrM453(_), scheme_ill_formed (port , "bc/src/read.c" , 3326 ) )
# 3326 "bc/src/read.c"
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        cl -> code = ((Scheme_Closure * ) v ) -> code ; 
        RET_VALUE_START ((Scheme_Object * ) cl ) RET_VALUE_END ; 
        break ; 
      }
      case CPT_DELAY_REF : 
      {
#       define XfOrM447_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM447(x) SETUP_XfOrM428(x)

# 3335 "bc/src/read.c"
        l = (read_compact_number (port ) ) ; 
        if (! ((l > 0 ) && (l < port -> symtab_size ) ) )
          FUNCCALL(SETUP_XfOrM447(_), scheme_ill_formed (port , "bc/src/read.c" , 3336 ) )
# 3336 "bc/src/read.c"
        ; 

# 3336 "bc/src/read.c"
        ; 
        v = port -> symtab [l ] ; 
        if (! v ) {
#         define XfOrM449_COUNT (0+XfOrM447_COUNT)
#         define SETUP_XfOrM449(x) SETUP_XfOrM447(x)

# 3339 "bc/src/read.c"
          if (port -> delay_info ) {
#           define XfOrM451_COUNT (0+XfOrM449_COUNT)
#           define SETUP_XfOrM451(x) SETUP_XfOrM449(x)
            v = FUNCCALL(SETUP_XfOrM451(_), scheme_make_raw_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (l ) ) ) << 1 ) | 0x1 ) ) , (Scheme_Object * ) port -> delay_info ) )
            ; 
          }

# 3344 "bc/src/read.c"
          else {
            intptr_t save_pos = port -> pos ; 
#           define XfOrM450_COUNT (0+XfOrM449_COUNT)
#           define SETUP_XfOrM450(x) SETUP_XfOrM449(x)

# 3346 "bc/src/read.c"
            port -> symtab [l ] = ((Scheme_Object * ) 0x6 ) ; 
            port -> pos = port -> shared_offsets [l - 1 ] ; 
            v = FUNCCALL(SETUP_XfOrM450(_), read_compact (port , 0 ) ); 
            port -> pos = save_pos ; 
            port -> symtab [l ] = v ; 
          }
        }

# 3352 "bc/src/read.c"
        else if (v == ((Scheme_Object * ) 0x6 ) ) {
#         define XfOrM448_COUNT (0+XfOrM447_COUNT)
#         define SETUP_XfOrM448(x) SETUP_XfOrM447(x)
          FUNCCALL(SETUP_XfOrM448(_), scheme_ill_formed (port , "bc/src/read.c" , 3354 ) )
# 3354 "bc/src/read.c"
          ; 
        }
        RET_VALUE_START (v ) RET_VALUE_END ; 
        break ; 
      }
      case CPT_PREFAB : 
      {
        Scheme_Struct_Type * st ; 
        BLOCK_SETUP((PUSH(st, 0+XfOrM428_COUNT)));
#       define XfOrM444_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM444(x) SETUP(XfOrM444_COUNT)
        st = NULLED_OUT ; 

# 3362 "bc/src/read.c"
        v = FUNCCALL(SETUP_XfOrM444(_), read_compact (port , 0 ) ); 
        if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ! (((Scheme_Vector * ) (v ) ) -> size ) )
          v = ((void * ) 0 ) ; 
        else {
#         define XfOrM445_COUNT (0+XfOrM444_COUNT)
#         define SETUP_XfOrM445(x) SETUP_XfOrM444(x)

# 3366 "bc/src/read.c"
          st = FUNCCALL(SETUP_XfOrM445(_), scheme_lookup_prefab_type ((((Scheme_Vector * ) (v ) ) -> els ) [0 ] , (((Scheme_Vector * ) (v ) ) -> size ) - 1 ) ); 
          if (! st || (st -> num_slots != ((((Scheme_Vector * ) (v ) ) -> size ) - 1 ) ) )
            v = ((void * ) 0 ) ; 
          else {
#           define XfOrM446_COUNT (0+XfOrM445_COUNT)
#           define SETUP_XfOrM446(x) SETUP_XfOrM445(x)

# 3370 "bc/src/read.c"
            v = FUNCCALL(SETUP_XfOrM446(_), scheme_make_prefab_struct_instance (st , v ) ); 
          }
        }
        break ; 
      }
      case CPT_PREFAB_TYPE : 
      {
        intptr_t len ; 
#       define XfOrM443_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM443(x) SETUP_XfOrM428(x)

# 3378 "bc/src/read.c"
        v = FUNCCALL(SETUP_XfOrM443(_), read_compact (port , 0 ) ); 
        len = (read_compact_number (port ) ) ; 
        v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM443(_), scheme_lookup_prefab_type (v , len ) ); 
        break ; 
      }
      case 192 : 
      case 207 : 
      {
        Scheme_Type type ; 
#       define XfOrM440_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM440(x) SETUP_XfOrM428(x)

# 3388 "bc/src/read.c"
        if ((ch >= 207 ) && (ch < 222 ) )  {
          type = scheme_local_unbox_type ; 
          ch -= 207 ; 
        }

# 3391 "bc/src/read.c"
        else {
          type = scheme_local_type ; 
          ch -= 192 ; 
        }
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_local (type , ch , 0 ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case 74 : 
      {
#       define XfOrM439_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM439(x) SETUP_XfOrM428(x)

# 3400 "bc/src/read.c"
        l = ch - 74 ; 
        if (! (l <= port -> size - port -> pos ) )
          FUNCCALL(SETUP_XfOrM439(_), scheme_ill_formed (port , "bc/src/read.c" , 3401 ) )
# 3401 "bc/src/read.c"
        ; 

# 3401 "bc/src/read.c"
        ; 
        s = FUNCCALL(SETUP_XfOrM439(_), read_compact_chars (port , buffer , 32 , l ) ); 
        if (! FUNCCALL(SETUP_XfOrM439(_), valid_utf8 (s , l ) ))
          FUNCCALL(SETUP_XfOrM439(_), scheme_ill_formed (port , "bc/src/read.c" , 3404 ) ); 
        v = FUNCCALL(SETUP_XfOrM439(_), scheme_intern_exact_symbol (s , l ) ); 
      }
      break ; 
      case 48 : 
      {
        l = ch - 48 ; 
        RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (l ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
      }
      break ; 
      case 222 : 
      {
#       define XfOrM437_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM437(x) SETUP_XfOrM428(x)

# 3416 "bc/src/read.c"
        l = ch - 222 ; 
        v = FUNCCALL(SETUP_XfOrM437(_), read_compact_svector (port , l ) ); 
      }
      break ; 
      case 92 : 
      case (92 + 50 ) : 
      {
        int ppr = ((ch >= 92 ) && (ch < (92 + 50 ) ) ) ; 
#       define XfOrM435_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM435(x) SETUP_XfOrM428(x)

# 3424 "bc/src/read.c"
        l = ch - (ppr ? 92 : (92 + 50 ) ) ; 
        if (l == 1 ) {
          Scheme_Object * cdr ; 
          BLOCK_SETUP((PUSH(cdr, 0+XfOrM435_COUNT)));
#         define XfOrM436_COUNT (1+XfOrM435_COUNT)
#         define SETUP_XfOrM436(x) SETUP(XfOrM436_COUNT)
          cdr = NULLED_OUT ; 

# 3427 "bc/src/read.c"
          v = FUNCCALL(SETUP_XfOrM436(_), read_compact (port , 0 ) ); 
          cdr = (ppr 
          ? scheme_null 
          : FUNCCALL(SETUP_XfOrM436(_), read_compact (port , 0 ) )) ; 
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (v , cdr ) )) RET_VALUE_EMPTY_END ; 
        }

# 3432 "bc/src/read.c"
        else 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_compact_list (l , ppr , 0 , port ) )) RET_VALUE_EMPTY_END ; 
      }
      break ; 
      case 247 : 
      {
        int c , i ; 
        Scheme_App_Rec * a ; 
        BLOCK_SETUP((PUSH(a, 0+XfOrM428_COUNT)));
#       define XfOrM432_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM432(x) SETUP(XfOrM432_COUNT)
        a = NULLED_OUT ; 

# 3441 "bc/src/read.c"
        c = (ch - 247 ) + 1 ; 

        a = FUNCCALL(SETUP_XfOrM432(_), scheme_malloc_application (c ) ); 
        for (i = 0 ; i < c ; i ++ ) {
#         define XfOrM434_COUNT (0+XfOrM432_COUNT)
#         define SETUP_XfOrM434(x) SETUP_XfOrM432(x)

# 3445 "bc/src/read.c"
          v = FUNCCALL(SETUP_XfOrM434(_), read_compact (port , 1 ) ); 
          a -> args [i ] = v ; 
        }
        FUNCCALL(SETUP_XfOrM432(_), scheme_finish_application (a ) )
        ; 

        RET_VALUE_START ((Scheme_Object * ) a ) RET_VALUE_END ; 
      }
      break ; 
      case 248 : 
      {
        short et ; 
        Scheme_App2_Rec * app ; 
        BLOCK_SETUP((PUSH(app, 0+XfOrM428_COUNT)));
#       define XfOrM431_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM431(x) SETUP(XfOrM431_COUNT)
        app = NULLED_OUT ; 

# 3459 "bc/src/read.c"
        app = ((Scheme_App2_Rec * ) FUNCCALL(SETUP_XfOrM431(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App2_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        app -> iso . so . type = scheme_application2_type ; 

        v = FUNCCALL(SETUP_XfOrM431(_), read_compact (port , 1 ) ); 
        app -> rator = v ; 
        v = FUNCCALL(SETUP_XfOrM431(_), read_compact (port , 1 ) ); 
        app -> rand = v ; 

        et = FUNCCALL(SETUP_XfOrM431(_), scheme_get_eval_type (app -> rand ) ); 
        et = et << 3 ; 
        et += FUNCCALL(SETUP_XfOrM431(_), scheme_get_eval_type (app -> rator ) ); 
        (& (app ) -> iso ) -> so . keyex = et ; 

        RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
      }
      break ; 
      case 249 : 
      {
        short et ; 
        Scheme_App3_Rec * app ; 
        BLOCK_SETUP((PUSH(app, 0+XfOrM428_COUNT)));
#       define XfOrM430_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM430(x) SETUP(XfOrM430_COUNT)
        app = NULLED_OUT ; 

# 3480 "bc/src/read.c"
        app = ((Scheme_App3_Rec * ) FUNCCALL(SETUP_XfOrM430(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App3_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        app -> iso . so . type = scheme_application3_type ; 

        v = FUNCCALL(SETUP_XfOrM430(_), read_compact (port , 1 ) ); 
        app -> rator = v ; 
        v = FUNCCALL(SETUP_XfOrM430(_), read_compact (port , 1 ) ); 
        app -> rand1 = v ; 
        v = FUNCCALL(SETUP_XfOrM430(_), read_compact (port , 1 ) ); 
        app -> rand2 = v ; 

        et = FUNCCALL(SETUP_XfOrM430(_), scheme_get_eval_type (app -> rand2 ) ); 
        et = et << 3 ; 
        et += FUNCCALL(SETUP_XfOrM430(_), scheme_get_eval_type (app -> rand1 ) ); 
        et = et << 3 ; 
        et += FUNCCALL(SETUP_XfOrM430(_), scheme_get_eval_type (app -> rator ) ); 
        (& (app ) -> iso ) -> so . keyex = et ; 

        RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
      }
      break ; 
      case CPT_SHARED : 
      {
        Scheme_Object * ph ; 
        BLOCK_SETUP((PUSH(ph, 0+XfOrM428_COUNT)));
#       define XfOrM429_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM429(x) SETUP(XfOrM429_COUNT)
        ph = NULLED_OUT ; 

# 3504 "bc/src/read.c"
        if (! port -> ut )
          FUNCCALL(SETUP_XfOrM429(_), make_ut (port ) ); 

        ph = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM429(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        ph -> type = scheme_placeholder_type ; 
        (((Scheme_Small_Object * ) (ph ) ) -> u . ptr_val ) = scheme_false ; 

        l = (read_compact_number (port ) ) ; 
        if (! ((l > 0 ) && (l < port -> symtab_size ) ) )
          FUNCCALL(SETUP_XfOrM429(_), scheme_ill_formed (port , "bc/src/read.c" , 3512 ) )
# 3512 "bc/src/read.c"
        ; 

# 3512 "bc/src/read.c"
        ; 

        port -> symtab [l ] = ph ; 

        v = (__funcarg89 = FUNCCALL(SETUP_XfOrM429(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (l ) ) ) << 1 ) | 0x1 ) ) , ph ) )
        , FUNCCALL_AGAIN(scheme_make_pair (__funcarg89 , port -> symtab_refs ) )) 
        ; 
        port -> symtab_refs = v ; 

        v = FUNCCALL(SETUP_XfOrM429(_), read_compact (port , 0 ) ); 
        (((Scheme_Small_Object * ) (ph ) ) -> u . ptr_val ) = v ; 

        RET_VALUE_START (ph ) RET_VALUE_END ; 
      }
      break ; 
      default : 
      v = ((void * ) 0 ) ; 
      break ; 
    }



    if (! v )
      FUNCCALL(SETUP_XfOrM427(_), scheme_ill_formed (port , "bc/src/read.c" , 3535 ) ); 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3541 "bc/src/read.c"
static Scheme_Object * read_compact_list (int c , int proper , int use_stack , CPort * port ) 
{
  Scheme_Object * v , * first , * last , * pair ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(last, 1), PUSH(v, 2), PUSH(pair, 3), PUSH(first, 4)));
# define XfOrM523_COUNT (5)
# define SETUP_XfOrM523(x) SETUP(XfOrM523_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  first = NULLED_OUT ; 
  last = NULLED_OUT ; 
  pair = NULLED_OUT ; 

# 3545 "bc/src/read.c"
  v = FUNCCALL(SETUP_XfOrM523(_), read_compact (port , 0 ) ); 
  last = FUNCCALL_AGAIN(scheme_make_pair (v , scheme_null ) ); 

  first = last ; 

  while (-- c ) {
#   define XfOrM526_COUNT (0+XfOrM523_COUNT)
#   define SETUP_XfOrM526(x) SETUP_XfOrM523(x)

# 3551 "bc/src/read.c"
    v = FUNCCALL(SETUP_XfOrM526(_), read_compact (port , 0 ) ); 

    pair = FUNCCALL(SETUP_XfOrM526(_), scheme_make_pair (v , scheme_null ) ); 

    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pair ; 
    last = pair ; 
  }

  if (! proper ) {
#   define XfOrM524_COUNT (0+XfOrM523_COUNT)
#   define SETUP_XfOrM524(x) SETUP_XfOrM523(x)

# 3560 "bc/src/read.c"
    v = FUNCCALL(SETUP_XfOrM524(_), read_compact (port , 0 ) ); 
    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3567 "bc/src/read.c"
static Scheme_Object * read_compact_quote (CPort * port , int embedded ) 
{
  Scheme_Hash_Table * * q_ht , * * old_ht ; 
  Scheme_Object * v ; 
  Scheme_Hash_Table * __funcarg95 = NULLED_OUT ; 
  Scheme_Hash_Table * __funcarg94 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(old_ht, 0), PUSH(__funcarg94, 1), PUSH(v, 2), PUSH(port, 3), PUSH(q_ht, 4)));
# define XfOrM527_COUNT (5)
# define SETUP_XfOrM527(x) SETUP(XfOrM527_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  q_ht = NULLED_OUT ; 
  old_ht = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 3574 "bc/src/read.c"
  q_ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM527(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 
  * q_ht = ((void * ) 0 ) ; 

  old_ht = port -> ht ; 
  port -> ht = q_ht ; 

  v = FUNCCALL(SETUP_XfOrM527(_), read_compact (port , 0 ) ); 

  port -> ht = old_ht ; 

  if (* q_ht )
    v = (__funcarg94 = FUNCCALL(SETUP_XfOrM527(_), scheme_make_hash_table (SCHEME_hash_ptr ) )
  , __funcarg95 = FUNCCALL(SETUP_XfOrM527(_), scheme_make_hash_table (SCHEME_hash_ptr ) )
  , FUNCCALL_AGAIN(resolve_references (v , port -> orig_port , __funcarg94 , __funcarg95 , port -> symtab_entries , 0 , 0 ) )) 

  ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3594 "bc/src/read.c"
static intptr_t read_simple_number_from_port (Scheme_Object * port ) 
{
  intptr_t a , b , c , d ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(port, 0)));
# define XfOrM528_COUNT (1)
# define SETUP_XfOrM528(x) SETUP(XfOrM528_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3598 "bc/src/read.c"
  a = (unsigned char ) FUNCCALL(SETUP_XfOrM528(_), scheme_get_byte (port ) ); 
  b = (unsigned char ) FUNCCALL(SETUP_XfOrM528(_), scheme_get_byte (port ) ); 
  c = (unsigned char ) FUNCCALL(SETUP_XfOrM528(_), scheme_get_byte (port ) ); 
  d = (unsigned char ) FUNCCALL_EMPTY(scheme_get_byte (port ) ); 

  RET_VALUE_START ((a 
  + (b << 8 ) 
  + (c << 16 ) 
  + (d << 24 ) ) ) 
# 3603 "bc/src/read.c"
  RET_VALUE_END 


  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3609 "bc/src/read.c"
static Scheme_Object * read_linklet_bundle_hash (Scheme_Object * port , 
int can_read_unsafe , 
Scheme_Object * delay_load_info ) 
{
  Scheme_Object * result ; 
  intptr_t size , shared_size , got , offset ; 
  CPort * rp ; 
  intptr_t symtabsize ; 
  Scheme_Object * * symtab ; 
  intptr_t * so ; 
  Scheme_Load_Delay * delay_info ; 
  Scheme_Hash_Table * * local_ht ; 
  int all_short ; 
  int perma_cache = use_perma_cache ; 
  Scheme_Object * dir ; 
  Scheme_Config * config ; 
  Scheme_Performance_State perf_state ; 
  intptr_t __funcarg96 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(13);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(so, 1), PUSH(rp, 2), PUSH(delay_info, 3), PUSH(symtab, 4), PUSH(delay_load_info, 5), PUSH(result, 6), PUSH(local_ht, 7), PUSH(config, 8), PUSH(dir, 9)));
# define XfOrM529_COUNT (10)
# define SETUP_XfOrM529(x) SETUP(XfOrM529_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  result = NULLED_OUT ; 
  rp = NULLED_OUT ; 
  symtab = NULLED_OUT ; 
  so = NULLED_OUT ; 
  delay_info = NULLED_OUT ; 
  local_ht = NULLED_OUT ; 
  dir = NULLED_OUT ; 
  config = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM529(_), scheme_performance_record_start (& perf_state ) )
# 3627 "bc/src/read.c"
  ; 


  if (delay_load_info ) {
#   define XfOrM555_COUNT (0+XfOrM529_COUNT)
#   define SETUP_XfOrM555(x) SETUP_XfOrM529(x)

# 3631 "bc/src/read.c"
    delay_info = ((Scheme_Load_Delay * ) FUNCCALL(SETUP_XfOrM555(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Load_Delay ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    delay_info -> type = scheme_rt_delay_load_info ; 
    delay_info -> path = delay_load_info ; 
  }

# 3634 "bc/src/read.c"
  else 
  delay_info = ((void * ) 0 ) ; 

  symtabsize = FUNCCALL(SETUP_XfOrM529(_), read_simple_number_from_port (port ) ); 



  all_short = FUNCCALL_AGAIN(scheme_get_byte (port ) ); 
  if (symtabsize < 0 )
    so = ((void * ) 0 ) ; 
  else 
  so = (intptr_t * ) (__funcarg96 = FUNCCALL(SETUP_XfOrM529(_), scheme_check_overflow (symtabsize , sizeof (intptr_t ) , 0 ) ), FUNCCALL_AGAIN(scheme_malloc_fail_ok (GC_malloc_atomic , __funcarg96 ) )) 
  ; 
  if (! so )
    FUNCCALL(SETUP_XfOrM529(_), scheme_read_err (port , "read (compiled): could not allocate symbol table of size %" "l" "d" , symtabsize ) )

  ; 
  if ((got = FUNCCALL(SETUP_XfOrM529(_), scheme_get_bytes (port , (all_short ? 2 : 4 ) * (symtabsize - 1 ) , (char * ) so , 0 ) )) 
  != ((all_short ? 2 : 4 ) * (symtabsize - 1 ) ) )
    FUNCCALL(SETUP_XfOrM529(_), scheme_read_err (port , "read (compiled): ill-formed code (bad table count: %" "l" "d" " != %" "l" "d" ")" , got , (all_short ? 2 : 4 ) * (symtabsize - 1 ) ) )

  ; 
  {


    intptr_t j , v ; 
    unsigned char * so_c = (unsigned char * ) so ; 
    for (j = symtabsize - 1 ; j -- ; ) {
      if (all_short ) {
        v = so_c [j * 2 ] 
        + (so_c [j * 2 + 1 ] << 8 ) ; 
      }

# 3665 "bc/src/read.c"
      else {
        v = so_c [j * 4 ] 
        + (so_c [j * 4 + 1 ] << 8 ) 
        + (so_c [j * 4 + 2 ] << 16 ) 
        + (so_c [j * 4 + 3 ] << 24 ) ; 
      }
      so [j ] = v ; 
    }
  }



  shared_size = FUNCCALL(SETUP_XfOrM529(_), read_simple_number_from_port (port ) ); 
  size = FUNCCALL(SETUP_XfOrM529(_), read_simple_number_from_port (port ) ); 

  if (shared_size >= size ) {
#   define XfOrM547_COUNT (0+XfOrM529_COUNT)
#   define SETUP_XfOrM547(x) SETUP_XfOrM529(x)
    FUNCCALL(SETUP_XfOrM547(_), scheme_read_err (port , "read (compiled): ill-formed code (shared size %ld >= total size %ld)" , shared_size , size ) ); 
  }

  rp = ((CPort * ) FUNCCALL(SETUP_XfOrM529(_), GC_malloc_one_small_tagged ((((sizeof (CPort ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  rp -> type = scheme_rt_compact_port ; 
  {
    unsigned char * st ; 
    BLOCK_SETUP((PUSH(st, 0+XfOrM529_COUNT)));
#   define XfOrM546_COUNT (1+XfOrM529_COUNT)
#   define SETUP_XfOrM546(x) SETUP(XfOrM546_COUNT)
    st = NULLED_OUT ; 

# 3690 "bc/src/read.c"
    st = (unsigned char * ) FUNCCALL(SETUP_XfOrM546(_), scheme_malloc_fail_ok (GC_malloc_atomic , size + 1 ) ); 
    rp -> start = st ; 
  }
  rp -> pos = 0 ; 
  {
    intptr_t base ; 
#   define XfOrM545_COUNT (0+XfOrM529_COUNT)
#   define SETUP_XfOrM545(x) SETUP_XfOrM529(x)
    FUNCCALL(SETUP_XfOrM545(_), scheme_tell_all (port , ((void * ) 0 ) , ((void * ) 0 ) , & base ) )
# 3696 "bc/src/read.c"
    ; 
    rp -> base = base ; 
  }
  offset = (((intptr_t ) (FUNCCALL(SETUP_XfOrM529(_), scheme_file_position (1 , & port ) )) ) >> 1 ) ; 
  rp -> orig_port = port ; 
  rp -> size = size ; 
  if ((got = FUNCCALL(SETUP_XfOrM529(_), scheme_get_bytes (port , size , (char * ) rp -> start , 0 ) )) != size )
    FUNCCALL(SETUP_XfOrM529(_), scheme_read_err (port , "read (compiled): ill-formed code (bad count: %ld != %ld" ", started at %ld)" , got , size , rp -> base ) )


  ; 

  local_ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM529(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 

  symtab = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM529(_), GC_malloc (sizeof (Scheme_Object * ) * (symtabsize ) ) )) ; 
  rp -> symtab_size = symtabsize ; 
  rp -> ht = local_ht ; 
  rp -> symtab = symtab ; 
  rp -> unsafe_ok = can_read_unsafe ; 

  {
    Scheme_Hash_Table * se_ht ; 
    BLOCK_SETUP((PUSH(se_ht, 0+XfOrM529_COUNT)));
#   define XfOrM544_COUNT (1+XfOrM529_COUNT)
#   define SETUP_XfOrM544(x) SETUP(XfOrM544_COUNT)
    se_ht = NULLED_OUT ; 

# 3718 "bc/src/read.c"
    se_ht = FUNCCALL(SETUP_XfOrM544(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    rp -> symtab_entries = se_ht ; 
    if (delay_info )
      delay_info -> symtab_entries = se_ht ; 
  }

  config = FUNCCALL(SETUP_XfOrM529(_), scheme_current_config () ); 

  dir = FUNCCALL(SETUP_XfOrM529(_), scheme_get_param (config , MZCONFIG_LOAD_DIRECTORY ) ); 
  if (! (((dir ) ) == (scheme_false ) ) ) 
    dir = FUNCCALL(SETUP_XfOrM529(_), scheme_path_to_directory_path (dir ) ); 
  rp -> relto = dir ; 

  rp -> shared_offsets = so ; 
  rp -> delay_info = delay_info ; 

  rp -> symtab_refs = scheme_null ; 

  if (! delay_info ) {

    intptr_t j , len ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM529_COUNT)));
#   define XfOrM537_COUNT (1+XfOrM529_COUNT)
#   define SETUP_XfOrM537(x) SETUP(XfOrM537_COUNT)
    v = NULLED_OUT ; 

# 3740 "bc/src/read.c"
    len = symtabsize ; 
    for (j = 1 ; j < len ; j ++ ) {
#     define XfOrM541_COUNT (0+XfOrM537_COUNT)
#     define SETUP_XfOrM541(x) SETUP_XfOrM537(x)

# 3742 "bc/src/read.c"
      if (! symtab [j ] ) {
#       define XfOrM543_COUNT (0+XfOrM541_COUNT)
#       define SETUP_XfOrM543(x) SETUP_XfOrM541(x)

# 3743 "bc/src/read.c"
        v = FUNCCALL(SETUP_XfOrM543(_), read_compact (rp , 0 ) ); 
        v = FUNCCALL(SETUP_XfOrM543(_), resolve_symtab_refs (v , rp ) ); 
        symtab [j ] = v ; 
      }

# 3746 "bc/src/read.c"
      else {
        if (j + 1 < len )
          rp -> pos = so [j ] ; 
        else 
        rp -> pos = shared_size ; 
      }
    }
  }

# 3753 "bc/src/read.c"
  else {
#   define XfOrM535_COUNT (0+XfOrM529_COUNT)
#   define SETUP_XfOrM535(x) SETUP_XfOrM529(x)
    FUNCCALL(SETUP_XfOrM535(_), scheme_reserve_file_descriptor () )
# 3754 "bc/src/read.c"
    ; 
    rp -> pos = shared_size ; 
    delay_info -> file_offset = offset ; 
    delay_info -> size = shared_size ; 
    delay_info -> symtab_size = rp -> symtab_size ; 
    delay_info -> symtab = rp -> symtab ; 
    delay_info -> shared_offsets = rp -> shared_offsets ; 
    delay_info -> relto = rp -> relto ; 
    delay_info -> unsafe_ok = rp -> unsafe_ok ; 
    delay_info -> bytecode_hash = rp -> bytecode_hash ; 

    if ((delay_info -> path ) == (scheme_true ) ) 
      perma_cache = 1 ; 

    if (perma_cache ) {
      unsigned char * cache ; 
      BLOCK_SETUP((PUSH(cache, 0+XfOrM535_COUNT)));
#     define XfOrM536_COUNT (1+XfOrM535_COUNT)
#     define SETUP_XfOrM536(x) SETUP(XfOrM536_COUNT)
      cache = NULLED_OUT ; 

# 3770 "bc/src/read.c"
      cache = (unsigned char * ) FUNCCALL(SETUP_XfOrM536(_), GC_malloc_atomic (shared_size ) ); 
      (memcpy (cache , rp -> start , shared_size ) ) ; 
      delay_info -> cached = cache ; 
      delay_info -> cached_port = port ; 
      delay_info -> perma_cache = 1 ; 
    }
  }


  result = FUNCCALL(SETUP_XfOrM529(_), read_compact (rp , 1 ) ); 

  if (delay_info ) {
    if (delay_info -> ut )
      delay_info -> ut -> rp = ((void * ) 0 ) ; 
  }

  if (* local_ht )
    FUNCCALL(SETUP_XfOrM529(_), scheme_read_err (port , "read (compiled): unexpected graph structure" ) ); 

  if (! ((((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) )
    FUNCCALL(SETUP_XfOrM529(_), scheme_read_err (port , "read (compiled): bundle content is not an immutable hash" ) ); 

  {
    mzlonglong i ; 
    Scheme_Hash_Tree * t = (Scheme_Hash_Tree * ) result ; 
    Scheme_Object * key , * val ; 
    BLOCK_SETUP((PUSH(t, 0+XfOrM529_COUNT), PUSH(key, 1+XfOrM529_COUNT), PUSH(val, 2+XfOrM529_COUNT)));
#   define XfOrM530_COUNT (3+XfOrM529_COUNT)
#   define SETUP_XfOrM530(x) SETUP(XfOrM530_COUNT)
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 

# 3797 "bc/src/read.c"
    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) ) {
#     define XfOrM531_COUNT (0+XfOrM530_COUNT)
#     define SETUP_XfOrM531(x) SETUP_XfOrM530(x)

# 3798 "bc/src/read.c"
      i = (scheme_hash_tree_next (t , - 1 ) ) ; 
      while (i != - 1 ) {
#       define XfOrM533_COUNT (0+XfOrM531_COUNT)
#       define SETUP_XfOrM533(x) SETUP_XfOrM531(x)
        (
# 3800 "bc/src/read.c"
        scheme_hash_tree_index (t , i , & key , & val ) ) ; 
        if (validate_loaded_linklet 
        && ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) 
        && ! ((Scheme_Linklet * ) val ) -> reject_eval )
          FUNCCALL(SETUP_XfOrM533(_), scheme_validate_linklet (rp , (Scheme_Linklet * ) val ) ); 
        i = (scheme_hash_tree_next (t , i ) ) ; 
      }
    }
  }
  FUNCCALL(SETUP_XfOrM529(_), scheme_performance_record_end ("read" , & perf_state ) )


  ; 
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3816 "bc/src/read.c"
Scheme_Object * scheme_read_linklet_bundle_hash (Scheme_Object * port ) 
{
  Scheme_Config * config ; 
  int can_read_unsafe ; 
  Scheme_Object * delay_load_info , * v , * v2 ; 
  Scheme_Config * __funcarg97 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(port, 1), PUSH(v2, 2), PUSH(config, 3), PUSH(delay_load_info, 4)));
# define XfOrM556_COUNT (5)
# define SETUP_XfOrM556(x) SETUP(XfOrM556_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  config = NULLED_OUT ; 
  delay_load_info = NULLED_OUT ; 
  v = NULLED_OUT ; 
  v2 = NULLED_OUT ; 

# 3822 "bc/src/read.c"
  config = FUNCCALL(SETUP_XfOrM556(_), scheme_current_config () ); 

  v = (__funcarg97 = FUNCCALL(SETUP_XfOrM556(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg97 , MZCONFIG_CODE_INSPECTOR ) )) ; 
  v2 = (scheme_get_initial_inspector () ) ; 
  can_read_unsafe = ((v ) == (v2 ) ) ; 

  v = FUNCCALL(SETUP_XfOrM556(_), scheme_get_param (config , MZCONFIG_DELAY_LOAD_INFO ) ); 
  if (! (((v ) ) == (scheme_false ) ) ) 
    delay_load_info = v ; 
  else 
  delay_load_info = ((void * ) 0 ) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(read_linklet_bundle_hash (port , can_read_unsafe , delay_load_info ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3839 "bc/src/read.c"
void scheme_clear_delayed_load_cache () 
{
  /* No conversion */

# 3841 "bc/src/read.c"
  Scheme_Load_Delay * next ; 

  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) ) {
    next = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) -> clear_bytes_next ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) -> cached = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) -> cached_port = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) -> clear_bytes_next = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) -> clear_bytes_prev = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) = next ; 
  }
}

Scheme_Object * scheme_load_delayed_code (int _which , Scheme_Load_Delay * _delay_info ) 
{
  Scheme_Load_Delay * volatile delay_info = _delay_info ; 
  CPort * rp ; 
  CPort * volatile old_rp ; 
  volatile int which = _which ; 
  intptr_t size , got ; 
  unsigned char * st ; 
  Scheme_Object * volatile port ; 
  Scheme_Object * volatile v ; 
  Scheme_Object * volatile v_exn ; 
  Scheme_Hash_Table * * volatile ht ; 
  mz_jmp_buf newbuf , * volatile savebuf ; 
  Scheme_Performance_State perf_state ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(v_exn, 0), PUSH(old_rp, 1), PUSH(rp, 2), PUSH(delay_info, 3), PUSH(v, 4), PUSH(st, 5), PUSH(ht, 6), PUSH(port, 7), PUSH(savebuf, 8)));
# define XfOrM560_COUNT (9)
# define SETUP_XfOrM560(x) SETUP(XfOrM560_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  rp = NULLED_OUT ; 
  old_rp = NULLED_OUT ; 
  st = NULLED_OUT ; 
  port = NULLED_OUT ; 
  v = NULLED_OUT ; 
  v_exn = NULLED_OUT ; 
  ht = NULLED_OUT ; 
  savebuf = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM560(_), scheme_performance_record_start (& perf_state ) )
# 3868 "bc/src/read.c"
  ; 


  if (! delay_info -> perma_cache ) {
    if (delay_info -> clear_bytes_prev )
      delay_info -> clear_bytes_prev -> clear_bytes_next = delay_info -> clear_bytes_next ; 
    else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) == delay_info )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) = delay_info -> clear_bytes_next ; 
    if (delay_info -> clear_bytes_next )
      delay_info -> clear_bytes_next -> clear_bytes_prev = delay_info -> clear_bytes_prev ; 

    delay_info -> clear_bytes_prev = ((void * ) 0 ) ; 
    delay_info -> clear_bytes_next = ((void * ) 0 ) ; 
  }

  size = delay_info -> size ; 


  if (! delay_info -> cached ) {
    Scheme_Object * a [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM560_COUNT)));
#   define XfOrM568_COUNT (3+XfOrM560_COUNT)
#   define SETUP_XfOrM568(x) SETUP(XfOrM568_COUNT)
    a[0] = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM568(_), scheme_start_atomic () )
# 3889 "bc/src/read.c"
    ; 
    FUNCCALL_AGAIN(scheme_release_file_descriptor () ); 

    a [0 ] = delay_info -> path ; 
    port = FUNCCALL(SETUP_XfOrM568(_), scheme_do_open_input_file ("on-demand-loader" , 0 , 1 , a , 1 , 0 ) ); 

    savebuf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 
    if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM568_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#     define XfOrM570_COUNT (0+XfOrM568_COUNT)
#     define SETUP_XfOrM570(x) SETUP_XfOrM568(x)
      FUNCCALL(SETUP_XfOrM570(_), scheme_end_atomic_no_swap () )
# 3898 "bc/src/read.c"
      ; 
      FUNCCALL(SETUP_XfOrM570(_), scheme_close_input_port (port ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = savebuf ; 
      (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 3903 "bc/src/read.c"
    else {
#     define XfOrM569_COUNT (0+XfOrM568_COUNT)
#     define SETUP_XfOrM569(x) SETUP_XfOrM568(x)

# 3904 "bc/src/read.c"
      st = (unsigned char * ) FUNCCALL(SETUP_XfOrM569(_), GC_malloc_atomic (size + 1 ) ); 
      FUNCCALL(SETUP_XfOrM569(_), scheme_set_file_position (port , delay_info -> file_offset ) )
      ; 

      if ((got = FUNCCALL(SETUP_XfOrM569(_), scheme_get_bytes (port , size , (char * ) st , 0 ) )) != size )
        FUNCCALL(SETUP_XfOrM569(_), scheme_read_err (port , "on-demand load: ill-formed code (bad count: %ld != %ld" ", started at %ld)" , got , size , 0 ) )


      ; 
    }
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = savebuf ; 
    FUNCCALL(SETUP_XfOrM568(_), scheme_close_input_port (port ) )
    ; 
    FUNCCALL_AGAIN(scheme_reserve_file_descriptor () ); 
    FUNCCALL_AGAIN(scheme_end_atomic_no_swap () )
    ; 

    delay_info -> cached = st ; 
    delay_info -> cached_port = port ; 
  }

# 3923 "bc/src/read.c"
  else {
    port = delay_info -> cached_port ; 
  }
  FUNCCALL(SETUP_XfOrM560(_), scheme_start_atomic () )





  ; 

  old_rp = delay_info -> current_rp ; 


  rp = ((CPort * ) FUNCCALL(SETUP_XfOrM560(_), GC_malloc_one_small_tagged ((((sizeof (CPort ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  rp -> type = scheme_rt_compact_port ; 
  rp -> start = delay_info -> cached ; 
  rp -> pos = 0 ; 
  rp -> base = 0 ; 
  rp -> orig_port = port ; 
  rp -> size = size ; 
  rp -> ut = delay_info -> ut ; 
  rp -> unsafe_ok = delay_info -> unsafe_ok ; 
  rp -> bytecode_hash = delay_info -> bytecode_hash ; 
  rp -> symtab_entries = delay_info -> symtab_entries ; 
  if (delay_info -> ut )
    delay_info -> ut -> rp = rp ; 

  ht = ((Scheme_Hash_Table * * ) FUNCCALL(SETUP_XfOrM560(_), GC_malloc (sizeof (Scheme_Hash_Table * ) * (1 ) ) )) ; 

  rp -> symtab_size = delay_info -> symtab_size ; 
  rp -> ht = ht ; 
  rp -> symtab = delay_info -> symtab ; 
  rp -> relto = delay_info -> relto ; 
  rp -> shared_offsets = delay_info -> shared_offsets ; 
  rp -> delay_info = delay_info ; 
  rp -> symtab_refs = scheme_null ; 

  rp -> pos = delay_info -> shared_offsets [which - 1 ] ; 


  savebuf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = scheme_true ; 
  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM560_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    v = ((void * ) 0 ) ; 
    v_exn = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed ; 
  }

# 3970 "bc/src/read.c"
  else {
#   define XfOrM564_COUNT (0+XfOrM560_COUNT)
#   define SETUP_XfOrM564(x) SETUP_XfOrM560(x)

# 3971 "bc/src/read.c"
    v = FUNCCALL(SETUP_XfOrM564(_), read_compact (rp , 0 ) ); 
    v_exn = ((void * ) 0 ) ; 
    if (* ht ) {
#     define XfOrM565_COUNT (0+XfOrM564_COUNT)
#     define SETUP_XfOrM565(x) SETUP_XfOrM564(x)
      FUNCCALL_EMPTY(scheme_read_err (rp -> orig_port , "read (compiled): unexpected graph structure" ) )
# 3974 "bc/src/read.c"
      ; 
    }
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = savebuf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = ((void * ) 0 ) ; 


  v = FUNCCALL(SETUP_XfOrM560(_), resolve_symtab_refs (v , rp ) ); 

  delay_info -> current_rp = old_rp ; 
  if (delay_info -> ut )
    delay_info -> ut -> rp = old_rp ; 

  if (! old_rp && ! delay_info -> perma_cache ) {

    delay_info -> clear_bytes_next = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) ; 
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) -> clear_bytes_prev = delay_info ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> clear_bytes_chain_ ) = delay_info ; 
  }
  FUNCCALL(SETUP_XfOrM560(_), scheme_end_atomic_no_swap () )
  ; 
  FUNCCALL(SETUP_XfOrM560(_), scheme_performance_record_end ("demand-read" , & perf_state ) )
  ; 

  if (v ) {




    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

# 4005 "bc/src/read.c"
  else {
#   define XfOrM561_COUNT (0+XfOrM560_COUNT)
#   define SETUP_XfOrM561(x) SETUP_XfOrM560(x)

# 4006 "bc/src/read.c"
    if (v_exn && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cjs . is_kill )
      FUNCCALL_EMPTY(scheme_raise (v_exn ) ); 
    (((intptr_t * ) (void * ) ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs ) ) [1 ] = (* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs , longjmp ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . jb , 1 ) ) ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4013 "bc/src/read.c"
Scheme_Object * scheme_unmarshal_wrap_get (Scheme_Unmarshal_Tables * ut , 
Scheme_Object * wraps_key , 
int * _decoded ) 
{
  intptr_t l ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(ut, 0), PUSH(_decoded, 1)));
# define XfOrM572_COUNT (2)
# define SETUP_XfOrM572(x) SETUP(XfOrM572_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4018 "bc/src/read.c"
  l = (((intptr_t ) (wraps_key ) ) >> 1 ) ; 

  if ((l < 0 ) || ((uintptr_t ) l >= ut -> rp -> symtab_size ) )
    FUNCCALL(SETUP_XfOrM572(_), scheme_ill_formed (ut -> rp , "bc/src/read.c" , 4021 ) ); 
  if ((ut -> rp -> symtab [l ] ) == (((Scheme_Object * ) 0x6 ) ) ) 
    FUNCCALL(SETUP_XfOrM572(_), scheme_ill_formed (ut -> rp , "bc/src/read.c" , 4023 ) ); 

  if (! ut -> rp -> symtab [l ] ) {
    Scheme_Object * v ; 
    intptr_t save_pos ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM572_COUNT)));
#   define XfOrM573_COUNT (1+XfOrM572_COUNT)
#   define SETUP_XfOrM573(x) SETUP(XfOrM573_COUNT)
    v = NULLED_OUT ; 

# 4029 "bc/src/read.c"
    if (! ut -> rp -> delay_info )
      FUNCCALL(SETUP_XfOrM573(_), scheme_ill_formed (ut -> rp , "bc/src/read.c" , 4030 ) ); 

    save_pos = ut -> rp -> pos ; 
    ut -> rp -> pos = ut -> rp -> shared_offsets [l - 1 ] ; 
    v = FUNCCALL(SETUP_XfOrM573(_), read_compact (ut -> rp , 0 ) ); 
    ut -> rp -> pos = save_pos ; 
    ut -> rp -> symtab [l ] = v ; 
  }

  * _decoded = ut -> decoded [l ] ; 
  RET_VALUE_START (ut -> rp -> symtab [l ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4043 "bc/src/read.c"
void scheme_unmarshal_wrap_set (Scheme_Unmarshal_Tables * ut , 
Scheme_Object * wraps_key , 
Scheme_Object * v ) 
{
  /* No conversion */

# 4047 "bc/src/read.c"
  intptr_t l ; 
  l = (((intptr_t ) (wraps_key ) ) >> 1 ) ; 

  ut -> rp -> symtab [l ] = v ; 
  ut -> decoded [l ] = 1 ; 
}

# 3 "bc/src/mzmark_read.inc"
static int mark_indent_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_indent_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int mark_indent_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 37 "bc/src/mzmark_read.inc"
static int mark_cport_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_cport_MARK (void * p , struct NewGC * gc ) {

  CPort * cp = (CPort * ) p ; 
  GC_mark2 (& (cp -> start ) , gc ) ; 
  GC_mark2 (& (cp -> orig_port ) , gc ) ; 
  GC_mark2 (& (cp -> ht ) , gc ) ; 
  GC_mark2 (& (cp -> ut ) , gc ) ; 
  GC_mark2 (& (cp -> symtab ) , gc ) ; 
  GC_mark2 (& (cp -> symtab_entries ) , gc ) ; 
  GC_mark2 (& (cp -> relto ) , gc ) ; 
  GC_mark2 (& (cp -> shared_offsets ) , gc ) ; 
  GC_mark2 (& (cp -> delay_info ) , gc ) ; 
  GC_mark2 (& (cp -> symtab_refs ) , gc ) ; 

  return 0 ; 
}






static int mark_cport_FIXUP (void * p , struct NewGC * gc ) {

  CPort * cp = (CPort * ) p ; 
  GC_fixup2 (& (cp -> start ) , gc ) ; 
  GC_fixup2 (& (cp -> orig_port ) , gc ) ; 
  GC_fixup2 (& (cp -> ht ) , gc ) ; 
  GC_fixup2 (& (cp -> ut ) , gc ) ; 
  GC_fixup2 (& (cp -> symtab ) , gc ) ; 
  GC_fixup2 (& (cp -> symtab_entries ) , gc ) ; 
  GC_fixup2 (& (cp -> relto ) , gc ) ; 
  GC_fixup2 (& (cp -> shared_offsets ) , gc ) ; 
  GC_fixup2 (& (cp -> delay_info ) , gc ) ; 
  GC_fixup2 (& (cp -> symtab_refs ) , gc ) ; 

  return 0 ; 
}

# 93 "bc/src/mzmark_read.inc"
static int mark_read_params_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_read_params_MARK (void * p , struct NewGC * gc ) {

  ReadParams * rp = (ReadParams * ) p ; 
  GC_mark2 (& (rp -> delay_load_info ) , gc ) ; 
  GC_mark2 (& (rp -> read_relative_path ) , gc ) ; 
  GC_mark2 (& (rp -> graph_ht ) , gc ) ; 

  return 0 ; 
}






static int mark_read_params_FIXUP (void * p , struct NewGC * gc ) {

  ReadParams * rp = (ReadParams * ) p ; 
  GC_fixup2 (& (rp -> delay_load_info ) , gc ) ; 
  GC_fixup2 (& (rp -> read_relative_path ) , gc ) ; 
  GC_fixup2 (& (rp -> graph_ht ) , gc ) ; 

  return 0 ; 
}

# 135 "bc/src/mzmark_read.inc"
static int mark_delay_load_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_delay_load_MARK (void * p , struct NewGC * gc ) {

  Scheme_Load_Delay * ld = (Scheme_Load_Delay * ) p ; 
  GC_mark2 (& (ld -> path ) , gc ) ; 
  GC_mark2 (& (ld -> symtab ) , gc ) ; 
  GC_mark2 (& (ld -> symtab_entries ) , gc ) ; 
  GC_mark2 (& (ld -> shared_offsets ) , gc ) ; 
  GC_mark2 (& (ld -> relto ) , gc ) ; 
  GC_mark2 (& (ld -> ut ) , gc ) ; 
  GC_mark2 (& (ld -> current_rp ) , gc ) ; 
  GC_mark2 (& (ld -> cached ) , gc ) ; 
  GC_mark2 (& (ld -> cached_port ) , gc ) ; 

  return 0 ; 
}






static int mark_delay_load_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Load_Delay * ld = (Scheme_Load_Delay * ) p ; 
  GC_fixup2 (& (ld -> path ) , gc ) ; 
  GC_fixup2 (& (ld -> symtab ) , gc ) ; 
  GC_fixup2 (& (ld -> symtab_entries ) , gc ) ; 
  GC_fixup2 (& (ld -> shared_offsets ) , gc ) ; 
  GC_fixup2 (& (ld -> relto ) , gc ) ; 
  GC_fixup2 (& (ld -> ut ) , gc ) ; 
  GC_fixup2 (& (ld -> current_rp ) , gc ) ; 
  GC_fixup2 (& (ld -> cached ) , gc ) ; 
  GC_fixup2 (& (ld -> cached_port ) , gc ) ; 

  return 0 ; 
}

# 189 "bc/src/mzmark_read.inc"
static int mark_unmarshal_tables_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_unmarshal_tables_MARK (void * p , struct NewGC * gc ) {

  Scheme_Unmarshal_Tables * ut = (Scheme_Unmarshal_Tables * ) p ; 
  GC_mark2 (& (ut -> rp ) , gc ) ; 
  GC_mark2 (& (ut -> decoded ) , gc ) ; 

  return 0 ; 
}






static int mark_unmarshal_tables_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Unmarshal_Tables * ut = (Scheme_Unmarshal_Tables * ) p ; 
  GC_fixup2 (& (ut -> rp ) , gc ) ; 
  GC_fixup2 (& (ut -> decoded ) , gc ) ; 

  return 0 ; 
}

# 4064 "bc/src/read.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_indent_type , mark_indent_SIZE , mark_indent_MARK , mark_indent_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_rt_compact_port , mark_cport_SIZE , mark_cport_MARK , mark_cport_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_read_params , mark_read_params_SIZE , mark_read_params_MARK , mark_read_params_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_delay_load_info , mark_delay_load_SIZE , mark_delay_load_MARK , mark_delay_load_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_unmarshal_info , mark_unmarshal_tables_SIZE , mark_unmarshal_tables_MARK , mark_unmarshal_tables_FIXUP , 1 , 0 ) ; 
}
