#include "precomp.h"

# 2 "bc/src/schgencat.h"
enum {
  mzu_Cn , 
  mzu_Cc , 
  mzu_Cf , 
  mzu_Cs , 
  mzu_Co , 
  mzu_Ll , 
  mzu_Lu , 
  mzu_Lt , 
  mzu_Lm , 
  mzu_Lo , 
  mzu_Nd , 
  mzu_Nl , 
  mzu_No , 
  mzu_Ps , 
  mzu_Pe , 
  mzu_Pi , 
  mzu_Pf , 
  mzu_Pc , 
  mzu_Pd , 
  mzu_Po , 
  mzu_Mn , 
  mzu_Mc , 
  mzu_Me , 
  mzu_Sc , 
  mzu_Sk , 
  mzu_Sm , 
  mzu_So , 
  mzu_Zl , 
  mzu_Zp , 
  mzu_Zs }
; 

# 8 "bc/src/schrx.h"
struct Regwork ; 

typedef int (* Scheme_Regexp_Matcher ) (struct Regwork * rw ) ; 

typedef struct regexp {
  Scheme_Type type ; 
  short keyex ; 
  Scheme_Object * source ; 
  intptr_t nsubexp , ncounter , maxlookback ; 
  intptr_t regsize ; 
  short flags ; 
  unsigned char * regstart ; 
  intptr_t regmust ; 
  intptr_t regmlen ; 



  char program [1 ] ; 
}
regexp ; 

# 213 "bc/src/schrx.h"
typedef struct Regwork {
  Scheme_Type type ; 
  char * str ; 
  char * instr ; 
  Scheme_Object * port ; 
  Scheme_Object * unless_evt ; 
  char nonblock , aborted ; 
  rxpos instr_size ; 
  rxpos input_maxend ; 
  rxpos input , input_end , input_start ; 
  rxpos input_min ; 
  rxpos boi ; 
  rxpos * startp ; 
  rxpos * maybep ; 
  rxpos * endp ; 
  int * counters ; 
  Scheme_Object * peekskip ; 
  char * prefix ; 
  rxpos prefix_len , prefix_delta ; 
  struct rx_lazy_str_t * lazy_string ; 

  int non_tail , rewind_stack_size , rewind_stack_count , rewind_stack_prompt ; 
  rxpos * rewind_stack ; 
}

# 236 "bc/src/schrx.h"
Regwork ; 

typedef struct rx_lazy_str_t {
  Scheme_Type type ; 
  intptr_t start , done , end , blen ; 
  mzchar * chars ; 
  char * s ; 
}

# 243 "bc/src/schrx.h"
rx_lazy_str_t ; 

# 62 "bc/src/regexp.c"
static regexp * regcomp (char * , rxpos , int , int , Scheme_Object * ) ; 





; 
; 
; 
; 
; 
; 

; 
; 

; 
; 
; 
; 
; 
; 
; 
; 

; 
; 
; 


; 
; 
; 
; 
; 






static rxpos reg (int , int * , int , int , int ) ; 
static rxpos regbranch (int * , int , int ) ; 
static rxpos regpiece (int * , int , int ) ; 
static rxpos regatom (int * , int , int ) ; 
static rxpos regranges (int parse_flags , int at_start ) ; 
static rxpos regunicode (int invert ) ; 
static int regdigit () ; 
static rxpos regnode (char ) ; 
static void regarg (int ) ; 
static rxpos regnext (rxpos ) ; 
static void regc (char ) ; 
static void reginsert (char , rxpos ) ; 
static rxpos reginsertwithop (char , rxpos , int ) ; 
static rxpos reginsertwithopop (char , rxpos , int , int ) ; 
static void regtail (rxpos , rxpos ) ; 
static void regoptail (rxpos , rxpos ) ; 
static int regstrcspn (char * , char * , char * ) ; 
static unsigned char * extract_regstart (rxpos scan , int * _anch ) ; 

static int check_and_propagate_depends (void ) ; 
static int merge_tables (Scheme_Hash_Table * dest , Scheme_Hash_Table * src ) ; 

static Scheme_Object * empty_byte_string ; 



static void 
regerror (char * s ) 
{
  PREPARE_VAR_STACK(3);
# define XfOrM1_COUNT (0)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 132 "bc/src/regexp.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorval_ ) ) {
#   define XfOrM2_COUNT (0+XfOrM1_COUNT)
#   define SETUP_XfOrM2(x) SETUP_XfOrM1(x)

# 133 "bc/src/regexp.c"
    if (((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorproc_ ) ) ) == (scheme_false ) )  {
      const char * who = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorwho_ ) ; 
#     define XfOrM4_COUNT (0+XfOrM2_COUNT)
#     define SETUP_XfOrM4(x) SETUP_XfOrM2(x)

# 135 "bc/src/regexp.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorwho_ ) = ((void * ) 0 ) ; 
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: %s" , (who ? who : "regexp" ) , s ) )


      ; 
    }

# 140 "bc/src/regexp.c"
    else {
      Scheme_Object * a [1 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM2_COUNT)));
#     define XfOrM3_COUNT (3+XfOrM2_COUNT)
#     define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
      a[0] = NULLED_OUT ; 

# 142 "bc/src/regexp.c"
      a [0 ] = FUNCCALL(SETUP_XfOrM3(_), scheme_make_utf8_string (s ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorval_ ) = FUNCCALL(SETUP_XfOrM3(_), scheme_apply_multi (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorproc_ ) , 1 , a ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 150 "bc/src/regexp.c"
static void 
regcomperror (char * s ) 
{
  /* No conversion */

# 153 "bc/src/regexp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> failure_msg_for_read_ ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> failure_msg_for_read_ ) = s ; 
    (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  }

# 156 "bc/src/regexp.c"
  else 
  regerror (s ) ; 
}

# 175 "bc/src/regexp.c"
static regexp * 
regcomp (char * expstr , rxpos exp , int explen , int pcre , Scheme_Object * handler ) 
{
  regexp * r ; 
  rxpos scan , next ; 
  rxpos longest ; 
  int len , longest_is_ci ; 
  int flags ; 
  DECL_RET_SAVE (regexp * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(r, 0)));
# define XfOrM7_COUNT (1)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  r = NULLED_OUT ; 

# 185 "bc/src/regexp.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) = expstr ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) = exp ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) = exp + explen ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regnpar_ ) = 1 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regncounter_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) = 1 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxbackposn_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorproc_ ) = handler ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorval_ ) = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM7(_), regc ((char ) 156 ) ); 
  if (FUNCCALL(SETUP_XfOrM7(_), reg (0 , & flags , 0 , 0 , 0x1 | 0x4 | (pcre ? 0x2 : 0 ) ) )== 0 ) {
#   define XfOrM64_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM64(x) SETUP_XfOrM7(x)

# 202 "bc/src/regexp.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorval_ ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    {
#     define XfOrM65_COUNT (0+XfOrM64_COUNT)
#     define SETUP_XfOrM65(x) SETUP_XfOrM64(x)
      FUNCCALL(SETUP_XfOrM65(_), regcomperror ("unknown regexp failure" ) )
# 204 "bc/src/regexp.c"
      ; 

# 204 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 204 "bc/src/regexp.c"
    ; 
  }


  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) >= 32767L ) 
  {
#   define XfOrM63_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM63(x) SETUP_XfOrM7(x)
    FUNCCALL(SETUP_XfOrM63(_), regcomperror ("regexp too big" ) )
# 209 "bc/src/regexp.c"
    ; 

# 209 "bc/src/regexp.c"
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 209 "bc/src/regexp.c"
  ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxbackposn_ ) >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regnpar_ ) ) 
  {
#   define XfOrM62_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM62(x) SETUP_XfOrM7(x)
    FUNCCALL(SETUP_XfOrM62(_), regcomperror ("backreference number is larger than the highest-numbered cluster" ) )
# 212 "bc/src/regexp.c"
    ; 

# 212 "bc/src/regexp.c"
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 212 "bc/src/regexp.c"
  ; 


  r = (regexp * ) FUNCCALL(SETUP_XfOrM7(_), GC_malloc_one_tagged (sizeof (regexp ) + (unsigned ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) ) ); 
  r -> type = scheme_regexp_type ; 





  r -> regsize = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) ; 

  r -> nsubexp = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regnpar_ ) ; 
  r -> ncounter = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regncounter_ ) ; 
  r -> maxlookback = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) ; 


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) = exp ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) = exp + explen ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regnpar_ ) = 1 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regncounter_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) ; 




  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) = (char * ) r ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) = (char * ) r -> program - (char * ) r ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) += XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM7(_), regc ((char ) 156 ) ); 
  if (FUNCCALL(SETUP_XfOrM7(_), reg (0 , & flags , 0 , 0 , 0x1 | 0x4 | (pcre ? 0x2 : 0 ) ) )== 0 ) {
#   define XfOrM60_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM7(x)

# 247 "bc/src/regexp.c"
    {
#     define XfOrM61_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM61(x) SETUP_XfOrM60(x)
      FUNCCALL(SETUP_XfOrM61(_), regcomperror ("unknown regexp failure (late)" ) )
# 247 "bc/src/regexp.c"
      ; 

# 247 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 247 "bc/src/regexp.c"
    ; 
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
#   define XfOrM58_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM58(x) SETUP_XfOrM7(x)

# 251 "bc/src/regexp.c"
    {
#     define XfOrM59_COUNT (0+XfOrM58_COUNT)
#     define SETUP_XfOrM59(x) SETUP_XfOrM58(x)
      FUNCCALL(SETUP_XfOrM59(_), regcomperror ("wrote too far" ) )
# 251 "bc/src/regexp.c"
      ; 

# 251 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 251 "bc/src/regexp.c"
    ; 
  }


  r -> regstart = ((void * ) 0 ) ; 
  r -> regmust = - 1 ; 
  r -> regmlen = 0 ; 
  scan = ((r -> program + 1 ) - (char * ) r ) ; 
  {
    unsigned char * rs ; 
    int anch = 0 ; 
    BLOCK_SETUP((PUSH(rs, 0+XfOrM7_COUNT)));
#   define XfOrM57_COUNT (1+XfOrM7_COUNT)
#   define SETUP_XfOrM57(x) SETUP(XfOrM57_COUNT)
    rs = NULLED_OUT ; 

# 262 "bc/src/regexp.c"
    rs = FUNCCALL(SETUP_XfOrM57(_), extract_regstart (scan , & anch ) ); 
    r -> regstart = rs ; 
    if (anch )
      r -> flags |= 0x04 ; 
  }
  next = FUNCCALL(SETUP_XfOrM7(_), regnext (scan ) ); 
  if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [next ] ) == 0 ) {
#   define XfOrM8_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM8(x) SETUP_XfOrM7(x)

# 269 "bc/src/regexp.c"
    scan = ((scan ) + 3 ) ; 








    if (flags & 0x04 ) {
      int prev_op = 0 ; 
#     define XfOrM9_COUNT (0+XfOrM8_COUNT)
#     define SETUP_XfOrM9(x) SETUP_XfOrM8(x)

# 280 "bc/src/regexp.c"
      longest = 0 ; 
      longest_is_ci = 0 ; 
      len = 0 ; 
      for (; scan != 0 ; ) {
        int mscan = scan ; 
#       define XfOrM34_COUNT (0+XfOrM9_COUNT)
#       define SETUP_XfOrM34(x) SETUP_XfOrM9(x)

# 285 "bc/src/regexp.c"
        while (1 ) {
          int mop ; 
          mop = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [mscan ] ) ; 
          if ((mop == 23 ) || (mop == 26 ) ) {

            mscan = mscan + ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((mscan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((mscan ) + 3 ) + 1 ] ) ) ; 
            mscan = (mscan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(mscan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(mscan ) + 2 ] & 255 ) ) ) ; 
          }

# 292 "bc/src/regexp.c"
          else if (((mop == 11 ) || (mop == 12 ) ) 
          && ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((mscan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((mscan ) + 3 ) + 1 ] ) ) >= len ) {

            rxpos ls = (((mscan ) + 3 ) + 2 ) ; 
            int ll = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((mscan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((mscan ) + 3 ) + 1 ] ) ) , i ; 
            for (i = 0 ; i < ll ; i ++ ) {
              if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ls + i ] )
                break ; 
            }
            if (i >= ll ) {
              longest = ls ; 
              len = ll ; 
              longest_is_ci = ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [mscan ] ) == 12 ) ; 
            }
            break ; 
          }

# 307 "bc/src/regexp.c"
          else if ((mop == 6 ) && (1 >= len ) ) {

            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((mscan ) + 3 ) ] ) {
              longest = ((mscan ) + 3 ) ; 
              len = 1 ; 
              longest_is_ci = 0 ; 
            }
            break ; 
          }

# 315 "bc/src/regexp.c"
          else if ((mop == 9 ) && (prev_op != 9 ) ) {
            int mnext ; 
            mnext = (mscan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(mscan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(mscan ) + 2 ] & 255 ) ) ) ; 
            if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [mnext ] ) != 9 ) {

              mscan = ((mscan ) + 3 ) ; 
            }

# 321 "bc/src/regexp.c"
            else 
            break ; 
          }

# 323 "bc/src/regexp.c"
          else 
          break ; 
        }
        prev_op = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [scan ] ) ; 
        if ((prev_op == 23 ) || (prev_op == 26 ) ) {

          scan = scan + ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
          scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
        }

# 331 "bc/src/regexp.c"
        else {
#         define XfOrM35_COUNT (0+XfOrM34_COUNT)
#         define SETUP_XfOrM35(x) SETUP_XfOrM34(x)

# 332 "bc/src/regexp.c"
          scan = FUNCCALL(SETUP_XfOrM35(_), regnext (scan ) ); 
        }
      }
      if (longest ) {
        r -> regmust = longest ; 
        if (longest_is_ci )
          r -> flags |= 0x08 ; 
        r -> regmlen = len ; 
      }
    }
  }






  RET_VALUE_START ((r ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 352 "bc/src/regexp.c"
static unsigned char * map_create (unsigned char * map ) 
{
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM66_COUNT (1)
# define SETUP_XfOrM66(x) SETUP(XfOrM66_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 354 "bc/src/regexp.c"
  if (! map ) {
#   define XfOrM67_COUNT (0+XfOrM66_COUNT)
#   define SETUP_XfOrM67(x) SETUP_XfOrM66(x)

# 355 "bc/src/regexp.c"
    map = (unsigned char * ) FUNCCALL(SETUP_XfOrM67(_), GC_malloc_atomic (32 ) ); 
    (memset (map , 0 , 32 ) ) ; 
  }
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 361 "bc/src/regexp.c"
static unsigned char * map_start (unsigned char * map , int c ) 
{
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM68_COUNT (1)
# define SETUP_XfOrM68(x) SETUP(XfOrM68_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 363 "bc/src/regexp.c"
  map = FUNCCALL(SETUP_XfOrM68(_), map_create (map ) ); 
  map [c >> 3 ] |= ((unsigned char ) 1 << (c & 0x7 ) ) ; 
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 368 "bc/src/regexp.c"
static unsigned char * map_copy (unsigned char * map , char * s , int pos ) 
{
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(map, 0), PUSH(s, 1)));
# define XfOrM69_COUNT (2)
# define SETUP_XfOrM69(x) SETUP(XfOrM69_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 370 "bc/src/regexp.c"
  map = FUNCCALL(SETUP_XfOrM69(_), map_create (map ) ); 
  (memcpy (map , s XFORM_OK_PLUS pos , 32 ) ) ; 
  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 375 "bc/src/regexp.c"
static unsigned char * map_range (unsigned char * map , char * s , int pos , int invert ) 
{
  int rs , re ; 
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM70_COUNT (1)
# define SETUP_XfOrM70(x) SETUP(XfOrM70_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 379 "bc/src/regexp.c"
  rs = ((unsigned char ) (s [pos ++ ] ) ) ; 
  re = ((unsigned char ) (s [pos ++ ] ) ) ; 

  if (! invert ) {
#   define XfOrM76_COUNT (0+XfOrM70_COUNT)
#   define SETUP_XfOrM76(x) SETUP_XfOrM70(x)

# 383 "bc/src/regexp.c"
    while (rs <= re ) {
#     define XfOrM78_COUNT (0+XfOrM76_COUNT)
#     define SETUP_XfOrM78(x) SETUP_XfOrM76(x)

# 384 "bc/src/regexp.c"
      map = FUNCCALL(SETUP_XfOrM78(_), map_start (map , rs ) ); 
      rs ++ ; 
    }
  }

# 387 "bc/src/regexp.c"
  else {
#   define XfOrM71_COUNT (0+XfOrM70_COUNT)
#   define SETUP_XfOrM71(x) SETUP_XfOrM70(x)

# 388 "bc/src/regexp.c"
    while (rs > 0 ) {
#     define XfOrM75_COUNT (0+XfOrM71_COUNT)
#     define SETUP_XfOrM75(x) SETUP_XfOrM71(x)

# 389 "bc/src/regexp.c"
      map = FUNCCALL(SETUP_XfOrM75(_), map_start (map , rs - 1 ) ); 
      -- rs ; 
    }
    while (re < 255 ) {
#     define XfOrM73_COUNT (0+XfOrM71_COUNT)
#     define SETUP_XfOrM73(x) SETUP_XfOrM71(x)

# 393 "bc/src/regexp.c"
      map = FUNCCALL(SETUP_XfOrM73(_), map_start (map , re + 1 ) ); 
      re ++ ; 
    }
  }

  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 401 "bc/src/regexp.c"
static unsigned char * extract_regstart (rxpos scan , int * _anch ) 
{
  rxpos next ; 
  int retry , the_op ; 
  unsigned char * map = ((void * ) 0 ) ; 
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(_anch, 0), PUSH(map, 1)));
# define XfOrM79_COUNT (2)
# define SETUP_XfOrM79(x) SETUP(XfOrM79_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 407 "bc/src/regexp.c"
  do {
#   define XfOrM86_COUNT (0+XfOrM79_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM79(x)

# 408 "bc/src/regexp.c"
    retry = 0 ; 

    the_op = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [scan ] ) ; 
    switch (the_op ) {
#     define XfOrM87_COUNT (0+XfOrM86_COUNT)
#     define SETUP_XfOrM87(x) SETUP_XfOrM86(x)

# 412 "bc/src/regexp.c"
      case 39 : 
      case 40 : 
      case 13 : 
      case 35 : 
      case 36 : 
      case 30 : 
      case 31 : 
      case 32 : 

      scan = FUNCCALL(SETUP_XfOrM87(_), regnext (scan ) ); 
      retry = 1 ; 
      break ; 
      case 22 : 
      case 23 : 
      case 25 : 
      case 26 : 

      scan += ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
      scan = FUNCCALL(SETUP_XfOrM87(_), regnext (scan ) ); 
      retry = 1 ; 
      break ; 
      case 24 : 
      scan = FUNCCALL(SETUP_XfOrM87(_), regnext (scan ) ); 
      retry = 1 ; 
      break ; 
      case 15 : 
      case 17 : 
      scan = ((scan ) + 3 ) ; 
      retry = 1 ; 
      break ; 
      case 18 : 
      case 19 : 
      if (((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) > 0 ) {
        scan = ((scan ) + 7 ) ; 
        retry = 1 ; 
      }
      break ; 
      case 11 : 
      map = FUNCCALL(SETUP_XfOrM87(_), map_start (map , ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [(((scan ) + 3 ) + 2 ) ] ) ) ) ); 
      break ; 
      case 12 : 
      {
        int c = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [(((scan ) + 3 ) + 2 ) ] ) ) ; 
#       define XfOrM90_COUNT (0+XfOrM87_COUNT)
#       define SETUP_XfOrM90(x) SETUP_XfOrM87(x)

# 455 "bc/src/regexp.c"
        map = FUNCCALL(SETUP_XfOrM90(_), map_start (map , c ) ); 
        map = FUNCCALL(SETUP_XfOrM90(_), map_start (map , (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ) ); 
      }
      break ; 
      case 5 : 
      map = FUNCCALL(SETUP_XfOrM87(_), map_copy (map , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) , ((scan ) + 3 ) ) ); 
      break ; 
      case 6 : 
      map = FUNCCALL(SETUP_XfOrM87(_), map_start (map , ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) ] ) ) ) ); 
      break ; 
      case 43 : 
      map = FUNCCALL(SETUP_XfOrM87(_), map_start (map , ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) ] ) ) ) ); 
      map = FUNCCALL(SETUP_XfOrM87(_), map_start (map , ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) + 1 ] ) ) ) ); 
      break ; 
      case 7 : 
      map = FUNCCALL(SETUP_XfOrM87(_), map_range (map , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) , ((scan ) + 3 ) , 0 ) ); 
      break ; 
      case 8 : 
      map = FUNCCALL(SETUP_XfOrM87(_), map_range (map , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) , ((scan ) + 3 ) , 1 ) ); 
      break ; 
      case 1 : 
      if (_anch )
        * _anch = 1 ; 
      break ; 
      case 9 : 
      next = FUNCCALL(SETUP_XfOrM87(_), regnext (scan ) ); 
      if (! next || ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [next ] ) == 0 ) || ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [next ] ) == 27 ) ) {

        scan = ((scan ) + 3 ) ; 
        retry = 1 ; 
      }
      break ; 
      default : 
      if ((the_op == 20 ) || (the_op >= 44 && the_op < 78 ) ) {
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
        retry = 1 ; 
      }
      break ; 
    }
  }

# 494 "bc/src/regexp.c"
  while (retry ) ; 

  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 501 "bc/src/regexp.c"
static Scheme_Object * reg_k (void ) 
{
  /* No conversion */

# 503 "bc/src/regexp.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  int * flagp = (int * ) p -> ku . k . p1 ; 
  int res ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  res = reg (p -> ku . k . i1 , flagp , p -> ku . k . i2 , p -> ku . k . i3 , p -> ku . k . i4 ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (res ) ) ) << 1 ) | 0x1 ) ) ; 
}

# 525 "bc/src/regexp.c"
static rxpos 
reg (int paren , int * flagp , int paren_set , int lookahead , int parse_flags ) 
{
  rxpos ret ; 
  rxpos br ; 
  rxpos ender ; 
  int parno = 0 ; 
  int flags , matchmin , matchmax , maxlookback , brcount ; 
  Scheme_Hash_Table * backdepends ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(backdepends, 0), PUSH(flagp, 1)));
# define XfOrM93_COUNT (2)
# define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  backdepends = NULLED_OUT ; 

# 536 "bc/src/regexp.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM145_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM145(x) SETUP_XfOrM93(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 538 "bc/src/regexp.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      Scheme_Object * ov ; 
      BLOCK_SETUP((PUSH(ov, 0+XfOrM145_COUNT)));
#     define XfOrM146_COUNT (1+XfOrM145_COUNT)
#     define SETUP_XfOrM146(x) SETUP(XfOrM146_COUNT)
      ov = NULLED_OUT ; 

# 541 "bc/src/regexp.c"
      p -> ku . k . i1 = paren ; 
      p -> ku . k . p1 = (void * ) flagp ; 
      p -> ku . k . i2 = paren_set ; 
      p -> ku . k . i3 = lookahead ; 
      p -> ku . k . i4 = parse_flags ; 
      ov = FUNCCALL(SETUP_XfOrM146(_), scheme_handle_stack_overflow (reg_k ) ); 
      RET_VALUE_START ((((intptr_t ) (ov ) ) >> 1 ) ) RET_VALUE_END ; 
    }
  }


  * flagp = 0x01 ; 


  if (paren ) {
#   define XfOrM139_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM139(x) SETUP_XfOrM93(x)

# 556 "bc/src/regexp.c"
    if (lookahead ) {
#     define XfOrM143_COUNT (0+XfOrM139_COUNT)
#     define SETUP_XfOrM143(x) SETUP_XfOrM139(x)

# 557 "bc/src/regexp.c"
      parno = 0 ; 
      ret = FUNCCALL(SETUP_XfOrM143(_), regnode (lookahead ) ); 
      FUNCCALL_AGAIN(regarg (0 ) ); 
      if ((lookahead == 25 ) || (lookahead == 26 ) ) {
#       define XfOrM144_COUNT (0+XfOrM143_COUNT)
#       define SETUP_XfOrM144(x) SETUP_XfOrM143(x)
        FUNCCALL(SETUP_XfOrM144(_), regarg (0 ) )
# 561 "bc/src/regexp.c"
        ; 
        FUNCCALL(SETUP_XfOrM144(_), regarg (0 ) ); 
      }
    }

# 564 "bc/src/regexp.c"
    else if (paren_set ) {
#     define XfOrM140_COUNT (0+XfOrM139_COUNT)
#     define SETUP_XfOrM140(x) SETUP_XfOrM139(x)

# 565 "bc/src/regexp.c"
      parno = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regnpar_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regnpar_ ) ++ ; 
      if (44 + parno >= 78 ) {
#       define XfOrM142_COUNT (0+XfOrM140_COUNT)
#       define SETUP_XfOrM142(x) SETUP_XfOrM140(x)

# 568 "bc/src/regexp.c"
        ret = FUNCCALL(SETUP_XfOrM142(_), regnode (20 ) ); 
        FUNCCALL(SETUP_XfOrM142(_), regarg (parno ) ); 
      }

# 570 "bc/src/regexp.c"
      else {
#       define XfOrM141_COUNT (0+XfOrM140_COUNT)
#       define SETUP_XfOrM141(x) SETUP_XfOrM140(x)

# 571 "bc/src/regexp.c"
        ret = FUNCCALL(SETUP_XfOrM141(_), regnode (44 + parno ) ); 
      }
    }

# 573 "bc/src/regexp.c"
    else 
    ret = 0 ; 
  }

# 575 "bc/src/regexp.c"
  else 
  ret = 0 ; 


  br = FUNCCALL(SETUP_XfOrM93(_), regbranch (& flags , parse_flags , 0 ) ); 
  if (br == 0 ) 
  {
#   define XfOrM138_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM138(x) SETUP_XfOrM93(x)
    FUNCCALL(SETUP_XfOrM138(_), regcomperror ("branch failed!?" ) )
# 581 "bc/src/regexp.c"
    ; 

# 581 "bc/src/regexp.c"
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 581 "bc/src/regexp.c"
  ; 
  if (ret != 0 )
    FUNCCALL(SETUP_XfOrM93(_), regtail (ret , br ) ); 
  else 
  ret = br ; 
  if (! (flags & 0x01 ) ) {
    * flagp &= ~ 0x01 ; 
    backdepends = ((void * ) 0 ) ; 
  }

# 589 "bc/src/regexp.c"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ) {
    backdepends = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = ((void * ) 0 ) ; 
  }

# 592 "bc/src/regexp.c"
  else 
  backdepends = ((void * ) 0 ) ; 
  * flagp |= flags & (0x04 | 0x08 ) ; 
  matchmin = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) ; 
  matchmax = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) ; 
  maxlookback = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) ; 
  brcount = 1 ; 
  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '|' ) {
    brcount ++ ; 
#   define XfOrM131_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM131(x) SETUP_XfOrM93(x)

# 601 "bc/src/regexp.c"
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
    br = FUNCCALL(SETUP_XfOrM131(_), regbranch (& flags , parse_flags , 0 ) ); 
    if (br == 0 ) 
    {
#     define XfOrM135_COUNT (0+XfOrM131_COUNT)
#     define SETUP_XfOrM135(x) SETUP_XfOrM131(x)
      FUNCCALL(SETUP_XfOrM135(_), regcomperror ("next branch failed!?" ) )
# 604 "bc/src/regexp.c"
      ; 

# 604 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 604 "bc/src/regexp.c"
    ; 
    FUNCCALL(SETUP_XfOrM131(_), regtail (ret , br ) ); 
    if (! (flags & 0x01 ) )
      * flagp &= ~ 0x01 ; 
    else if ((* flagp ) & 0x01 ) {
#     define XfOrM133_COUNT (0+XfOrM131_COUNT)
#     define SETUP_XfOrM133(x) SETUP_XfOrM131(x)

# 609 "bc/src/regexp.c"
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ) {
#       define XfOrM134_COUNT (0+XfOrM133_COUNT)
#       define SETUP_XfOrM134(x) SETUP_XfOrM133(x)

# 610 "bc/src/regexp.c"
        if (backdepends )
          FUNCCALL(SETUP_XfOrM134(_), merge_tables (backdepends , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ) ); 
        else 
        backdepends = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = ((void * ) 0 ) ; 
      }

# 615 "bc/src/regexp.c"
      else 
      backdepends = ((void * ) 0 ) ; 
    }
    * flagp |= flags & 0x04 ; 
    if (! (flags & 0x08 ) )
      * flagp &= ~ 0x08 ; 
    else {
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) < matchmin )
        matchmin = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) ; 
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) > matchmax )
        matchmax = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) ; 
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) > maxlookback )
        maxlookback = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) ; 
    }
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = backdepends ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = matchmin ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = matchmax ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) = maxlookback ; 

  if (paren && paren_set ) {
    Scheme_Object * assumed ; 
    BLOCK_SETUP((PUSH(assumed, 0+XfOrM93_COUNT)));
#   define XfOrM119_COUNT (1+XfOrM93_COUNT)
#   define SETUP_XfOrM119(x) SETUP(XfOrM119_COUNT)
    assumed = NULLED_OUT ; 

# 638 "bc/src/regexp.c"
    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) = FUNCCALL(SETUP_XfOrM119(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    assumed = FUNCCALL(SETUP_XfOrM119(_), scheme_hash_get (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (parno ) ) ) << 1 ) | 0x1 ) ) ) ); 

    if (! ((* flagp ) & 0x01 ) ) {
#     define XfOrM123_COUNT (0+XfOrM119_COUNT)
#     define SETUP_XfOrM123(x) SETUP_XfOrM119(x)

# 643 "bc/src/regexp.c"
      if (assumed && ! (((assumed ) ) == (scheme_false ) ) ) {
#       define XfOrM124_COUNT (0+XfOrM123_COUNT)
#       define SETUP_XfOrM124(x) SETUP_XfOrM123(x)

# 644 "bc/src/regexp.c"
        {
#         define XfOrM125_COUNT (0+XfOrM124_COUNT)
#         define SETUP_XfOrM125(x) SETUP_XfOrM124(x)
          FUNCCALL(SETUP_XfOrM125(_), regcomperror ("`*', `+', or `{...,}' operand can be empty due to backreference" ) )
# 644 "bc/src/regexp.c"
          ; 

# 644 "bc/src/regexp.c"
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 644 "bc/src/regexp.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM123(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (parno ) ) ) << 1 ) | 0x1 ) ) , scheme_false ) ); 
    }

# 647 "bc/src/regexp.c"
    else {
#     define XfOrM120_COUNT (0+XfOrM119_COUNT)
#     define SETUP_XfOrM120(x) SETUP_XfOrM119(x)

# 648 "bc/src/regexp.c"
      if (! backdepends )
        FUNCCALL(SETUP_XfOrM120(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (parno ) ) ) << 1 ) | 0x1 ) ) , scheme_true ) ); 
      else {
#       define XfOrM121_COUNT (0+XfOrM120_COUNT)
#       define SETUP_XfOrM121(x) SETUP_XfOrM120(x)

# 651 "bc/src/regexp.c"
        if (assumed ) {
#         define XfOrM122_COUNT (0+XfOrM121_COUNT)
#         define SETUP_XfOrM122(x) SETUP_XfOrM121(x)
          FUNCCALL(SETUP_XfOrM122(_), check_and_propagate_depends () )
# 652 "bc/src/regexp.c"
          ; 
        }

# 653 "bc/src/regexp.c"
        else FUNCCALL(SETUP_XfOrM121(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (parno ) ) ) << 1 ) | 0x1 ) ) , (Scheme_Object * ) backdepends ) )
        ; 
      }
    }
  }

  if ((brcount == 1 ) 
  && paren 
  && (! paren_set || ((flags & 0x08 ) 
  && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) ) 
  && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) < 0x7FFFF ) ) ) 
  && ! lookahead ) {
#   define XfOrM116_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM116(x) SETUP_XfOrM93(x)

# 666 "bc/src/regexp.c"
    if (br + 3 < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
      int top ; 
#     define XfOrM118_COUNT (0+XfOrM116_COUNT)
#     define SETUP_XfOrM118(x) SETUP_XfOrM116(x)

# 668 "bc/src/regexp.c"
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) <= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) )
        top = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 
      else 
      top = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ; 
      (memmove (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) + ret , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) + br + 3 , top - (br + 3 ) ) ) ; 
    }
    * flagp = flags ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) -= (br + 3 - ret ) ; 
    if (paren_set ) {

      * flagp |= 0x10 ; 
      * flagp &= ~ 0x20 ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regsavepos_ ) = parno ; 
    }
  }

# 682 "bc/src/regexp.c"
  else {
#   define XfOrM100_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM100(x) SETUP_XfOrM93(x)

# 683 "bc/src/regexp.c"
    if (lookahead ) {
#     define XfOrM111_COUNT (0+XfOrM100_COUNT)
#     define SETUP_XfOrM111(x) SETUP_XfOrM100(x)

# 684 "bc/src/regexp.c"
      if ((lookahead == 25 ) || (lookahead == 26 ) ) {
#       define XfOrM112_COUNT (0+XfOrM111_COUNT)
#       define SETUP_XfOrM112(x) SETUP_XfOrM111(x)

# 685 "bc/src/regexp.c"
        if (! ((* flagp ) & 0x08 ) ) 
        {
#         define XfOrM115_COUNT (0+XfOrM112_COUNT)
#         define SETUP_XfOrM115(x) SETUP_XfOrM112(x)
          FUNCCALL_EMPTY(regcomperror ("lookbehind pattern does not match a bounded byte width" ) )
# 686 "bc/src/regexp.c"
          ; 

# 686 "bc/src/regexp.c"
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 686 "bc/src/regexp.c"
        ; 
        if (matchmax > 0x7FFF ) 
        {
#         define XfOrM114_COUNT (0+XfOrM112_COUNT)
#         define SETUP_XfOrM114(x) SETUP_XfOrM112(x)
          FUNCCALL_EMPTY(regcomperror ("lookbehind match is potentially too long (more than 32767 bytes)" ) )
# 688 "bc/src/regexp.c"
          ; 

# 688 "bc/src/regexp.c"
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 688 "bc/src/regexp.c"
        ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) = matchmax + maxlookback ; 
        if (ret + 8 < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ret + 5 ] = (matchmin >> 8 ) ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ret + 6 ] = (matchmin & 255 ) ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ret + 7 ] = (matchmax >> 8 ) ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ret + 8 ] = (matchmax & 255 ) ; 
        }
      }
    }


    if (paren ) {
#     define XfOrM105_COUNT (0+XfOrM100_COUNT)
#     define SETUP_XfOrM105(x) SETUP_XfOrM100(x)

# 701 "bc/src/regexp.c"
      if (lookahead ) {
#       define XfOrM109_COUNT (0+XfOrM105_COUNT)
#       define SETUP_XfOrM109(x) SETUP_XfOrM105(x)

# 702 "bc/src/regexp.c"
        ender = FUNCCALL_EMPTY(regnode (27 ) ); 
        if (ret + 4 < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
          int delta = (ender - ret ) ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ret + 3 ] = (delta >> 8 ) ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ret + 4 ] = (delta & 255 ) ; 
        }
      }

# 708 "bc/src/regexp.c"
      else if (paren_set ) {
#       define XfOrM107_COUNT (0+XfOrM105_COUNT)
#       define SETUP_XfOrM107(x) SETUP_XfOrM105(x)

# 709 "bc/src/regexp.c"
        if (44 + parno >= 78 ) {
#         define XfOrM108_COUNT (0+XfOrM107_COUNT)
#         define SETUP_XfOrM108(x) SETUP_XfOrM107(x)

# 710 "bc/src/regexp.c"
          ender = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 
          FUNCCALL_EMPTY(regarg (parno ) ); 
          FUNCCALL_EMPTY(reginsert (21 , ender ) ); 
        }

# 713 "bc/src/regexp.c"
        else 
        ender = FUNCCALL_EMPTY(regnode (78 + parno ) ); 
      }

# 715 "bc/src/regexp.c"
      else {
#       define XfOrM106_COUNT (0+XfOrM105_COUNT)
#       define SETUP_XfOrM106(x) SETUP_XfOrM105(x)

# 716 "bc/src/regexp.c"
        ender = FUNCCALL_EMPTY(regnode (13 ) ); 
      }
    }

# 718 "bc/src/regexp.c"
    else {
#     define XfOrM104_COUNT (0+XfOrM100_COUNT)
#     define SETUP_XfOrM104(x) SETUP_XfOrM100(x)

# 719 "bc/src/regexp.c"
      ender = FUNCCALL_EMPTY(regnode (0 ) ); 
    }
    FUNCCALL_EMPTY(regtail (ret , ender ) ); 


    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
#     define XfOrM101_COUNT (0+XfOrM100_COUNT)
#     define SETUP_XfOrM101(x) SETUP_XfOrM100(x)

# 725 "bc/src/regexp.c"
      for (br = ret ; br != 0 ; br = FUNCCALL_EMPTY(regnext (br ) )) {
#       define XfOrM103_COUNT (0+XfOrM101_COUNT)
#       define SETUP_XfOrM103(x) SETUP_XfOrM101(x)
        FUNCCALL_EMPTY(regoptail (br , ender ) )
# 726 "bc/src/regexp.c"
        ; 
      }
    }
  }


  if (paren && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ] != ')' ) {
#   define XfOrM98_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM98(x) SETUP_XfOrM93(x)

# 733 "bc/src/regexp.c"
    {
#     define XfOrM99_COUNT (0+XfOrM98_COUNT)
#     define SETUP_XfOrM99(x) SETUP_XfOrM98(x)
      FUNCCALL_EMPTY(regcomperror ("missing closing parenthesis in pattern" ) )
# 733 "bc/src/regexp.c"
      ; 

# 733 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 733 "bc/src/regexp.c"
    ; 
  }

# 734 "bc/src/regexp.c"
  else if (! paren && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) {
#   define XfOrM94_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM94(x) SETUP_XfOrM93(x)

# 735 "bc/src/regexp.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == ')' ) {
#     define XfOrM96_COUNT (0+XfOrM94_COUNT)
#     define SETUP_XfOrM96(x) SETUP_XfOrM94(x)

# 736 "bc/src/regexp.c"
      {
#       define XfOrM97_COUNT (0+XfOrM96_COUNT)
#       define SETUP_XfOrM97(x) SETUP_XfOrM96(x)
        FUNCCALL_EMPTY(regcomperror ("extra closing parenthesis in pattern" ) )
# 736 "bc/src/regexp.c"
        ; 

# 736 "bc/src/regexp.c"
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 736 "bc/src/regexp.c"
      ; 
    }

# 737 "bc/src/regexp.c"
    else 
    {
#     define XfOrM95_COUNT (0+XfOrM94_COUNT)
#     define SETUP_XfOrM95(x) SETUP_XfOrM94(x)
      FUNCCALL_EMPTY(regcomperror ("junk on end" ) )
# 738 "bc/src/regexp.c"
      ; 

# 738 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 738 "bc/src/regexp.c"
    ; 
  }


  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


static rxpos 
regbranch (int * flagp , int parse_flags , int without_branch_node ) 
{
  rxpos ret ; 
  rxpos chain , latest ; 
  int flags = 0 , matchmin = 0 , matchmax = 0 , maxlookback = 0 , pcount = 0 , save_flags ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(flagp, 0)));
# define XfOrM147_COUNT (1)
# define SETUP_XfOrM147(x) SETUP(XfOrM147_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 757 "bc/src/regexp.c"
  * flagp = (0 | 0x08 ) ; 

  if (! without_branch_node )
    ret = FUNCCALL(SETUP_XfOrM147(_), regnode (9 ) ); 
  else 
  ret = 0 ; 
  chain = 0 ; 
  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) 
  && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != '|' 
  && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != ')' ) {
#   define XfOrM155_COUNT (0+XfOrM147_COUNT)
#   define SETUP_XfOrM155(x) SETUP_XfOrM147(x)

# 767 "bc/src/regexp.c"
    save_flags = flags ; 
    latest = FUNCCALL(SETUP_XfOrM155(_), regpiece (& flags , parse_flags , ! chain && ! without_branch_node ) ); 
    if (latest == 0 ) 
    {
#     define XfOrM159_COUNT (0+XfOrM155_COUNT)
#     define SETUP_XfOrM159(x) SETUP_XfOrM155(x)
      FUNCCALL(SETUP_XfOrM159(_), regcomperror ("piece failed!?" ) )
# 770 "bc/src/regexp.c"
      ; 

# 770 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 770 "bc/src/regexp.c"
    ; 
    if (flags & 0x20 ) {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) = latest ; 
      flags = save_flags ; 
    }

# 775 "bc/src/regexp.c"
    else {
      pcount ++ ; 
#     define XfOrM156_COUNT (0+XfOrM155_COUNT)
#     define SETUP_XfOrM156(x) SETUP_XfOrM155(x)

# 777 "bc/src/regexp.c"
      * flagp |= flags & 0x01 ; 
      if (chain == 0 ) {
        * flagp |= flags & 0x04 ; 
        if (without_branch_node )
          ret = latest ; 
      }

# 782 "bc/src/regexp.c"
      else FUNCCALL(SETUP_XfOrM156(_), regtail (chain , latest ) )
      ; 
      if (! (flags & 0x08 ) )
        * flagp &= ~ 0x08 ; 
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) - matchmin ) > maxlookback )
        maxlookback = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) - matchmin ; 
      matchmin += XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) ; 
      matchmax += XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) ; 
      if (matchmax > 0x7FFF )
        matchmax = 0x10000 ; 
      chain = latest ; 
    }
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = matchmin ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = matchmax ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) = maxlookback ; 
  if (chain == 0 ) {
#   define XfOrM149_COUNT (0+XfOrM147_COUNT)
#   define SETUP_XfOrM149(x) SETUP_XfOrM147(x)

# 799 "bc/src/regexp.c"
    latest = FUNCCALL(SETUP_XfOrM149(_), regnode (13 ) ); 
    if (without_branch_node )
      ret = latest ; 
    * flagp = 0x02 | 0x20 | 0x08 ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 0 ; 
  }

  if (pcount == 1 ) {
    * flagp = flags ; 
  }

  RET_VALUE_START ((ret ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}






static rxpos 
regpiece (int * flagp , int parse_flags , int at_start ) 
{
  rxpos ret ; 
  char op ; 
  rxpos next ; 
  int flags , greedy ; 
  int minreps = 0 , maxreps = 0 , counter ; 
  int origsavepos , origmatchmin , origmatchmax ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg68 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg67 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg66 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg65 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg64 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg63 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg62 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg61 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg60 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg59 ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg58 ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(flagp, 0)));
# define XfOrM160_COUNT (1)
# define SETUP_XfOrM160(x) SETUP(XfOrM160_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 832 "bc/src/regexp.c"
  ret = FUNCCALL(SETUP_XfOrM160(_), regatom (& flags , parse_flags , at_start ) ); 
  if (ret == 0 ) 
  {
#   define XfOrM215_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM215(x) SETUP_XfOrM160(x)
    FUNCCALL(SETUP_XfOrM215(_), regcomperror ("atom failed!?" ) )
# 834 "bc/src/regexp.c"
    ; 

# 834 "bc/src/regexp.c"
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 834 "bc/src/regexp.c"
  ; 

  origsavepos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regsavepos_ ) ; 
  origmatchmin = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) ; 
  origmatchmax = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) ; 

  op = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ; 
  if (! ((op ) == '*' || (op ) == '+' || (op ) == '?' || ((parse_flags & 0x2 ) && ((op ) == '{' ) ) ) ) {
    * flagp = (flags & ~ 0x10 ) ; 
  }

# 843 "bc/src/regexp.c"
  else {
#   define XfOrM163_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM163(x) SETUP_XfOrM160(x)

# 844 "bc/src/regexp.c"
    if (op == '{' ) {
      int ch , maxspec = 0 ; 
#     define XfOrM187_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM187(x) SETUP_XfOrM163(x)

# 846 "bc/src/regexp.c"
      minreps = maxreps = 0 ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
      do {
#       define XfOrM209_COUNT (0+XfOrM187_COUNT)
#       define SETUP_XfOrM209(x) SETUP_XfOrM187(x)

# 849 "bc/src/regexp.c"
        ch = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ; 
        if ((ch >= '0' ) && (ch <= '9' ) ) {
#         define XfOrM212_COUNT (0+XfOrM209_COUNT)
#         define SETUP_XfOrM212(x) SETUP_XfOrM209(x)

# 851 "bc/src/regexp.c"
          minreps = (minreps * 10 ) + (ch - '0' ) ; 
          if (minreps > 0x7FFF ) 
          {
#           define XfOrM213_COUNT (0+XfOrM212_COUNT)
#           define SETUP_XfOrM213(x) SETUP_XfOrM212(x)
            FUNCCALL(SETUP_XfOrM213(_), regcomperror ("minimum repetition count too large" ) )
# 853 "bc/src/regexp.c"
            ; 

# 853 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 853 "bc/src/regexp.c"
          ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
        }

# 855 "bc/src/regexp.c"
        else if (ch == ',' || ch == '}' )
          break ; 
        else {
#         define XfOrM210_COUNT (0+XfOrM209_COUNT)
#         define SETUP_XfOrM210(x) SETUP_XfOrM209(x)

# 858 "bc/src/regexp.c"
          {
#           define XfOrM211_COUNT (0+XfOrM210_COUNT)
#           define SETUP_XfOrM211(x) SETUP_XfOrM210(x)
            FUNCCALL(SETUP_XfOrM211(_), regcomperror ("expected digit, comma, or `}' to end repetition specification started with `{'" ) )
# 858 "bc/src/regexp.c"
            ; 

# 858 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 858 "bc/src/regexp.c"
          ; 
        }
      }

# 860 "bc/src/regexp.c"
      while (1 ) ; 
      if (ch == ',' ) {
#       define XfOrM193_COUNT (0+XfOrM187_COUNT)
#       define SETUP_XfOrM193(x) SETUP_XfOrM187(x)

# 862 "bc/src/regexp.c"
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
        do {
#         define XfOrM199_COUNT (0+XfOrM193_COUNT)
#         define SETUP_XfOrM199(x) SETUP_XfOrM193(x)

# 864 "bc/src/regexp.c"
          ch = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ; 
          if ((ch >= '0' ) && (ch <= '9' ) ) {
#           define XfOrM202_COUNT (0+XfOrM199_COUNT)
#           define SETUP_XfOrM202(x) SETUP_XfOrM199(x)

# 866 "bc/src/regexp.c"
            maxspec = 1 ; 
            maxreps = (maxreps * 10 ) + (ch - '0' ) ; 
            if (maxreps > 0x7FFF ) 
            {
#             define XfOrM203_COUNT (0+XfOrM202_COUNT)
#             define SETUP_XfOrM203(x) SETUP_XfOrM202(x)
              FUNCCALL(SETUP_XfOrM203(_), regcomperror ("maximum repetition count too large" ) )
# 869 "bc/src/regexp.c"
              ; 

# 869 "bc/src/regexp.c"
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }

# 869 "bc/src/regexp.c"
            ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
          }

# 871 "bc/src/regexp.c"
          else if (ch == '}' )
            break ; 
          else {
#           define XfOrM200_COUNT (0+XfOrM199_COUNT)
#           define SETUP_XfOrM200(x) SETUP_XfOrM199(x)

# 874 "bc/src/regexp.c"
            {
#             define XfOrM201_COUNT (0+XfOrM200_COUNT)
#             define SETUP_XfOrM201(x) SETUP_XfOrM200(x)
              FUNCCALL(SETUP_XfOrM201(_), regcomperror ("expected digit or `}' to end repetition specification started with `{'" ) )
# 874 "bc/src/regexp.c"
              ; 

# 874 "bc/src/regexp.c"
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }

# 874 "bc/src/regexp.c"
            ; 
          }
        }

# 876 "bc/src/regexp.c"
        while (1 ) ; 
      }

# 877 "bc/src/regexp.c"
      else {
        maxspec = 1 ; 
        maxreps = minreps ; 
      }
      if (maxspec && (maxreps < minreps ) ) {
#       define XfOrM190_COUNT (0+XfOrM187_COUNT)
#       define SETUP_XfOrM190(x) SETUP_XfOrM187(x)

# 882 "bc/src/regexp.c"
        {
#         define XfOrM191_COUNT (0+XfOrM190_COUNT)
#         define SETUP_XfOrM191(x) SETUP_XfOrM190(x)
          FUNCCALL(SETUP_XfOrM191(_), regcomperror ("maximum repetition count is less than maximum repetition count" ) )
# 882 "bc/src/regexp.c"
          ; 

# 882 "bc/src/regexp.c"
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 882 "bc/src/regexp.c"
        ; 
      }
      if (maxspec && ! maxreps ) {
#       define XfOrM188_COUNT (0+XfOrM187_COUNT)
#       define SETUP_XfOrM188(x) SETUP_XfOrM187(x)

# 886 "bc/src/regexp.c"
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '?' )
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) == '*' || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) == '+' || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) == '?' || ((parse_flags & 0x2 ) && ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) == '{' ) ) )  
        {
#         define XfOrM189_COUNT (0+XfOrM188_COUNT)
#         define SETUP_XfOrM189(x) SETUP_XfOrM188(x)
          FUNCCALL(SETUP_XfOrM189(_), regcomperror ("nested `*', `?', `+', or `{...}' in pattern" ) )
# 890 "bc/src/regexp.c"
          ; 

# 890 "bc/src/regexp.c"
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 890 "bc/src/regexp.c"
        ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) = ret ; 
        * flagp = 0x08 | 0x20 ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 0 ; 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(regnode (13 ) )) RET_VALUE_EMPTY_END ; 
      }
      op = '*' ; 
      if (maxreps || minreps )
        counter = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regncounter_ ) ++ ; 
      else 
      counter = 0 ; 
    }

# 901 "bc/src/regexp.c"
    else 
    counter = 0 ; 

    if (! (flags & 0x01 ) && (op != '?' ) ) {
#     define XfOrM185_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM185(x) SETUP_XfOrM163(x)

# 905 "bc/src/regexp.c"
      {
#       define XfOrM186_COUNT (0+XfOrM185_COUNT)
#       define SETUP_XfOrM186(x) SETUP_XfOrM185(x)
        FUNCCALL(SETUP_XfOrM186(_), regcomperror ("`*', `+', or `{...}' operand could be empty" ) )
# 905 "bc/src/regexp.c"
        ; 

# 905 "bc/src/regexp.c"
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 905 "bc/src/regexp.c"
      ; 
    }

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ) {
#     define XfOrM184_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM184(x) SETUP_XfOrM163(x)
      FUNCCALL(SETUP_XfOrM184(_), check_and_propagate_depends () )
# 910 "bc/src/regexp.c"
      ; 

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = ((void * ) 0 ) ; 
    }

    if (maxreps || minreps ) {
      if (minreps > 0 )
        * flagp = 0x01 ; 
      if ((flags & 0x08 ) && maxreps ) {
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = (origmatchmin * minreps ) ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = (origmatchmax * maxreps ) ; 
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) > 0x7FFF )
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 0x10000 ; 
        * flagp |= 0x08 ; 
      }
    }

# 925 "bc/src/regexp.c"
    else {
      * flagp = (op != '+' ) ? 0 : 0x01 ; 
      if ((op == '*' ) || (op == '?' ) )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = 0 ; 
    }
    * flagp |= 0x04 ; 
    if ((op == '?' ) && (flags & 0x08 ) ) {
      * flagp |= 0x08 ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = 0 ; 
    }

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '?' ) {
      greedy = 0 ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
    }

# 939 "bc/src/regexp.c"
    else 
    greedy = 1 ; 

    if (op == '*' && (flags & 0x02 ) ) {
#     define XfOrM178_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM178(x) SETUP_XfOrM163(x)

# 943 "bc/src/regexp.c"
      if (! minreps && ! maxreps )
        FUNCCALL(SETUP_XfOrM178(_), reginsert (greedy ? 14 : 16 , ret ) ); 
      else FUNCCALL(SETUP_XfOrM178(_), reginsertwithopop (greedy ? 18 : 19 , ret , minreps , maxreps ) )
      ; 
    }

# 947 "bc/src/regexp.c"
    else if (op == '*' && greedy ) {






      rxpos br , nothing ; 
#     define XfOrM173_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM173(x) SETUP_XfOrM163(x)

# 955 "bc/src/regexp.c"
      if (minreps || maxreps ) {


        rxpos x ; 
#       define XfOrM177_COUNT (0+XfOrM173_COUNT)
#       define SETUP_XfOrM177(x) SETUP_XfOrM173(x)

# 959 "bc/src/regexp.c"
        x = FUNCCALL(SETUP_XfOrM177(_), reginsertwithopop (32 , ret , counter , maxreps ) ); 
        FUNCCALL(SETUP_XfOrM177(_), regtail (ret , x ) ); 
      }
      FUNCCALL(SETUP_XfOrM173(_), reginsert (9 , ret ) ); 
      if (minreps || maxreps ) {
#       define XfOrM176_COUNT (0+XfOrM173_COUNT)
#       define SETUP_XfOrM176(x) SETUP_XfOrM173(x)

# 965 "bc/src/regexp.c"
        br = FUNCCALL(SETUP_XfOrM176(_), reginsertwithop (30 , ret , counter ) ); 
        FUNCCALL(SETUP_XfOrM176(_), regtail (ret , br ) ); 
      }

# 967 "bc/src/regexp.c"
      else 
      br = ret ; 
      (__funcarg68 = FUNCCALL(SETUP_XfOrM173(_), regnode (10 ) ), FUNCCALL_AGAIN(regoptail (br , __funcarg68 ) )) ; 
      FUNCCALL_AGAIN(regoptail (br , br ) ); 
      (__funcarg67 = FUNCCALL(SETUP_XfOrM173(_), regnode (9 ) ), FUNCCALL_AGAIN(regtail (br , __funcarg67 ) )) ; 
      nothing = FUNCCALL_AGAIN(regnode (13 ) ); 
      if (minreps ) {

        rxpos n ; 
#       define XfOrM175_COUNT (0+XfOrM173_COUNT)
#       define SETUP_XfOrM175(x) SETUP_XfOrM173(x)

# 976 "bc/src/regexp.c"
        n = FUNCCALL(SETUP_XfOrM175(_), reginsertwithopop (31 , nothing , counter , minreps ) ); 
        FUNCCALL(SETUP_XfOrM175(_), regtail (nothing , n ) ); 
      }
      if (minreps || maxreps ) {


        rxpos n ; 
#       define XfOrM174_COUNT (0+XfOrM173_COUNT)
#       define SETUP_XfOrM174(x) SETUP_XfOrM173(x)

# 983 "bc/src/regexp.c"
        n = FUNCCALL(SETUP_XfOrM174(_), reginsertwithop (33 , nothing , counter ) ); 
        FUNCCALL(SETUP_XfOrM174(_), regtail (nothing , n ) ); 
      }
      FUNCCALL(SETUP_XfOrM173(_), regtail (br , nothing ) ); 
    }

# 987 "bc/src/regexp.c"
    else if (op == '*' ) {



      rxpos br , nothing , x , next_to_x ; 
#     define XfOrM169_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM169(x) SETUP_XfOrM163(x)

# 992 "bc/src/regexp.c"
      if (minreps || maxreps ) {


        rxpos fail ; 
#       define XfOrM172_COUNT (0+XfOrM169_COUNT)
#       define SETUP_XfOrM172(x) SETUP_XfOrM169(x)

# 996 "bc/src/regexp.c"
        x = FUNCCALL(SETUP_XfOrM172(_), reginsertwithopop (32 , ret , counter , maxreps ) ); 
        FUNCCALL(SETUP_XfOrM172(_), regtail (ret , x ) ); 

        fail = FUNCCALL_AGAIN(regnode (9 ) ); 
        FUNCCALL_AGAIN(regnode (34 ) ); 
        FUNCCALL_AGAIN(regarg (counter ) ); 
        FUNCCALL_AGAIN(reginsert (9 , ret ) ); 
        fail += 3 ; 
        FUNCCALL(SETUP_XfOrM172(_), regtail (ret , fail ) ); 
        x += 3 ; 
      }

# 1006 "bc/src/regexp.c"
      else 
      x = ret ; 
      FUNCCALL(SETUP_XfOrM169(_), reginsert (9 , ret ) ); 
      next = ret ; 
      next_to_x = (x - next ) + 3 ; 
      FUNCCALL(SETUP_XfOrM169(_), reginsert (13 , ret ) ); 
      next += 3 ; 
      nothing = ret ; 
      if (minreps ) {
#       define XfOrM171_COUNT (0+XfOrM169_COUNT)
#       define SETUP_XfOrM171(x) SETUP_XfOrM169(x)

# 1016 "bc/src/regexp.c"
        nothing = FUNCCALL(SETUP_XfOrM171(_), reginsertwithopop (31 , ret , counter , minreps ) ); 
        FUNCCALL(SETUP_XfOrM171(_), regtail (ret , nothing ) ); 
        next += (nothing - ret ) ; 
      }
      FUNCCALL(SETUP_XfOrM169(_), reginsert (9 , ret ) ); 
      next += 3 ; 
      nothing += 3 ; 
      if (minreps || maxreps ) {
#       define XfOrM170_COUNT (0+XfOrM169_COUNT)
#       define SETUP_XfOrM170(x) SETUP_XfOrM169(x)

# 1025 "bc/src/regexp.c"
        br = FUNCCALL(SETUP_XfOrM170(_), reginsertwithop (30 , ret , counter ) ); 
        FUNCCALL(SETUP_XfOrM170(_), regtail (ret , br ) ); 
        next += (br - ret ) ; 
        nothing += (br - ret ) ; 
      }

# 1029 "bc/src/regexp.c"
      else 
      br = ret ; 
      FUNCCALL(SETUP_XfOrM169(_), regtail (br , next ) ); 
      x = next + next_to_x ; 
      (__funcarg66 = FUNCCALL(SETUP_XfOrM169(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (x , __funcarg66 ) )) ; 
      FUNCCALL_AGAIN(regtail (x , br ) ); 
      (__funcarg65 = FUNCCALL(SETUP_XfOrM169(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (next , __funcarg65 ) )) ; 
      FUNCCALL_AGAIN(regtail (next , nothing ) ); 
    }

# 1037 "bc/src/regexp.c"
    else if (op == '+' && (flags & 0x02 ) )
      FUNCCALL(SETUP_XfOrM163(_), reginsert (greedy ? 15 : 17 , ret ) ); 
    else if (op == '+' && greedy ) {
#     define XfOrM168_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM168(x) SETUP_XfOrM163(x)

# 1041 "bc/src/regexp.c"
      next = FUNCCALL(SETUP_XfOrM168(_), regnode (9 ) ); 
      FUNCCALL(SETUP_XfOrM168(_), regtail (ret , next ) ); 
      (__funcarg64 = FUNCCALL(SETUP_XfOrM168(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (__funcarg64 , ret ) )) ; 
      (__funcarg63 = FUNCCALL(SETUP_XfOrM168(_), regnode (9 ) ), FUNCCALL_AGAIN(regtail (next , __funcarg63 ) )) ; 
      (__funcarg62 = FUNCCALL(SETUP_XfOrM168(_), regnode (13 ) ), FUNCCALL_AGAIN(regtail (ret , __funcarg62 ) )) ; 
    }

# 1046 "bc/src/regexp.c"
    else if (op == '+' ) {
#     define XfOrM167_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM167(x) SETUP_XfOrM163(x)

# 1048 "bc/src/regexp.c"
      next = FUNCCALL(SETUP_XfOrM167(_), regnode (9 ) ); 
      FUNCCALL(SETUP_XfOrM167(_), regtail (ret , next ) ); 
      FUNCCALL_AGAIN(regnode (13 ) ); 
      (__funcarg61 = FUNCCALL(SETUP_XfOrM167(_), regnode (9 ) ), FUNCCALL_AGAIN(regtail (next , __funcarg61 ) )) ; 
      (__funcarg60 = FUNCCALL(SETUP_XfOrM167(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (__funcarg60 , ret ) )) ; 
      (__funcarg59 = FUNCCALL(SETUP_XfOrM167(_), regnode (10 ) ), FUNCCALL_AGAIN(regtail (next , __funcarg59 ) )) ; 
      FUNCCALL_AGAIN(regtail (next , next + 3 ) ); 
    }

# 1055 "bc/src/regexp.c"
    else if (op == '?' && greedy ) {
#     define XfOrM166_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM166(x) SETUP_XfOrM163(x)
      FUNCCALL(SETUP_XfOrM166(_), reginsert (9 , ret ) )
# 1057 "bc/src/regexp.c"
      ; 
      (__funcarg58 = FUNCCALL(SETUP_XfOrM166(_), regnode (9 ) ), FUNCCALL_AGAIN(regtail (ret , __funcarg58 ) )) ; 
      next = FUNCCALL_AGAIN(regnode (13 ) ); 
      FUNCCALL_AGAIN(regtail (ret , next ) ); 
      FUNCCALL_AGAIN(regoptail (ret , next ) ); 
    }

# 1062 "bc/src/regexp.c"
    else if (op == '?' ) {
#     define XfOrM165_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM165(x) SETUP_XfOrM163(x)
      FUNCCALL(SETUP_XfOrM165(_), reginsert (9 , ret ) )
# 1064 "bc/src/regexp.c"
      ; 
      FUNCCALL(SETUP_XfOrM165(_), reginsert (13 , ret ) ); 
      FUNCCALL_AGAIN(reginsert (9 , ret ) ); 
      FUNCCALL_AGAIN(regtail (ret , ret + 6 ) ); 
      next = FUNCCALL_AGAIN(regnode (10 ) ); 
      FUNCCALL_AGAIN(regtail (ret + 6 , next ) ); 
      FUNCCALL_AGAIN(regoptail (ret + 6 , next ) ); 
      FUNCCALL_AGAIN(regoptail (ret + 6 , ret + 3 ) ); 
    }
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) == '*' || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) == '+' || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) == '?' || ((parse_flags & 0x2 ) && ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) == '{' ) ) )  
    {
#     define XfOrM164_COUNT (0+XfOrM163_COUNT)
#     define SETUP_XfOrM164(x) SETUP_XfOrM163(x)
      FUNCCALL(SETUP_XfOrM164(_), regcomperror ("nested `*', `?', `+', or `{...}' in pattern" ) )
# 1075 "bc/src/regexp.c"
      ; 

# 1075 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 1075 "bc/src/regexp.c"
    ; 
  }

  if (flags & 0x10 ) {
    rxpos sv ; 
#   define XfOrM161_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM161(x) SETUP_XfOrM160(x)

# 1080 "bc/src/regexp.c"
    sv = FUNCCALL(SETUP_XfOrM161(_), regnode (35 ) ); 
    FUNCCALL(SETUP_XfOrM161(_), regarg (origsavepos ) ); 
    FUNCCALL_AGAIN(regarg (origmatchmax ) ); 
    FUNCCALL_AGAIN(regtail (ret , sv ) ); 
    if (origmatchmax ) {
#     define XfOrM162_COUNT (0+XfOrM161_COUNT)
#     define SETUP_XfOrM162(x) SETUP_XfOrM161(x)

# 1085 "bc/src/regexp.c"
      sv = FUNCCALL(SETUP_XfOrM162(_), reginsertwithop (36 , ret , origsavepos ) ); 
      FUNCCALL(SETUP_XfOrM162(_), regtail (ret , sv ) ); 
    }
    * flagp &= ~ 0x02 ; 
  }

  RET_VALUE_START ((ret ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}





static rxpos 
regatom (int * flagp , int parse_flags , int at_start ) 
{
  rxpos ret ; 
  int flags ; 

# 110 "bc/src/regexp.c"
  rxpos __funcarg69 ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(flagp, 0)));
# define XfOrM216_COUNT (1)
# define SETUP_XfOrM216(x) SETUP(XfOrM216_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1108 "bc/src/regexp.c"
  * flagp = (0 | 0x08 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 1 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) = 0 ; 

  switch (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ] ) {
#   define XfOrM218_COUNT (0+XfOrM216_COUNT)
#   define SETUP_XfOrM218(x) SETUP_XfOrM216(x)

# 1113 "bc/src/regexp.c"
    case '^' : 
    if (parse_flags & 0x4 )
      ret = FUNCCALL(SETUP_XfOrM218(_), regnode (1 ) ); 
    else 
    ret = FUNCCALL(SETUP_XfOrM218(_), regnode (39 ) ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) = 1 ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 0 ; 
    break ; 
    case '$' : 
    if (parse_flags & 0x4 )
      ret = FUNCCALL(SETUP_XfOrM218(_), regnode (2 ) ); 
    else 
    ret = FUNCCALL(SETUP_XfOrM218(_), regnode (40 ) ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 0 ; 
    break ; 
    case '.' : 
    -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ; 
    ret = FUNCCALL(SETUP_XfOrM218(_), regranges (parse_flags , at_start ) ); 
    * flagp |= 0x01 | 0x02 ; 
    break ; 
    case '[' : 
    -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ; 
    ret = FUNCCALL(SETUP_XfOrM218(_), regranges (parse_flags , at_start ) ); 
    * flagp |= 0x01 | 0x02 ; 
    break ; 
    case '(' : 
    {
#     define XfOrM254_COUNT (0+XfOrM218_COUNT)
#     define SETUP_XfOrM254(x) SETUP_XfOrM218(x)

# 1140 "bc/src/regexp.c"
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '?' ) {
        int moded = 0 ; 
#       define XfOrM259_COUNT (0+XfOrM254_COUNT)
#       define SETUP_XfOrM259(x) SETUP_XfOrM254(x)

# 1143 "bc/src/regexp.c"
        while (1 ) {
          if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == 'i' ) {
            parse_flags &= ~ 0x1 ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
            moded = 1 ; 
          }

# 1148 "bc/src/regexp.c"
          else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == 'm' ) {
            parse_flags &= ~ 0x4 ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
            moded = 1 ; 
          }

# 1152 "bc/src/regexp.c"
          else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == 's' ) {
            parse_flags |= 0x4 ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
            moded = 1 ; 
          }

# 1156 "bc/src/regexp.c"
          else if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '-' ) 
          && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 2 ] == 'i' ) ) {
            parse_flags |= 0x1 ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
            moded = 1 ; 
          }

# 1161 "bc/src/regexp.c"
          else if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '-' ) 
          && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 2 ] == 'm' ) ) {
            parse_flags |= 0x4 ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
            moded = 1 ; 
          }

# 1166 "bc/src/regexp.c"
          else if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '-' ) 
          && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 2 ] == 's' ) ) {
            parse_flags &= ~ 0x4 ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
            moded = 1 ; 
          }

# 1171 "bc/src/regexp.c"
          else {
            break ; 
          }
        }

        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == ':' ) {
#         define XfOrM294_COUNT (0+XfOrM259_COUNT)
#         define SETUP_XfOrM294(x) SETUP_XfOrM259(x)

# 1177 "bc/src/regexp.c"
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
          ret = FUNCCALL(SETUP_XfOrM294(_), reg (1 , & flags , 0 , 0 , parse_flags ) ); 
          * flagp = flags ; 
        }

# 1180 "bc/src/regexp.c"
        else if (moded ) {
#         define XfOrM292_COUNT (0+XfOrM259_COUNT)
#         define SETUP_XfOrM292(x) SETUP_XfOrM259(x)

# 1181 "bc/src/regexp.c"
          {
#           define XfOrM293_COUNT (0+XfOrM292_COUNT)
#           define SETUP_XfOrM293(x) SETUP_XfOrM292(x)
            FUNCCALL(SETUP_XfOrM293(_), regcomperror ("expected `:' or another mode after `(?' and a mode sequence (where a mode is `i', `-i', `m', `-m', `s', or `-s')" ) )
# 1181 "bc/src/regexp.c"
            ; 

# 1181 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 1181 "bc/src/regexp.c"
          ; 
        }

# 1182 "bc/src/regexp.c"
        else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '(' ) {
#         define XfOrM268_COUNT (0+XfOrM259_COUNT)
#         define SETUP_XfOrM268(x) SETUP_XfOrM259(x)

# 1184 "bc/src/regexp.c"
          if (((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 2 ] >= '0' ) 
          && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 2 ] <= '9' ) ) 
          || ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 2 ] == '?' ) 
          && ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 3 ] == '=' ) 
          || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 3 ] == '!' ) 
          || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 3 ] == '<' ) ) ) ) {
            rxpos test , tbr , fbr , ender ; 
            int flags , matchmin , matchmax ; 
            Scheme_Hash_Table * backdepends ; 
            BLOCK_SETUP((PUSH(backdepends, 0+XfOrM268_COUNT)));
#           define XfOrM270_COUNT (1+XfOrM268_COUNT)
#           define SETUP_XfOrM270(x) SETUP(XfOrM270_COUNT)
            backdepends = NULLED_OUT ; 

# 1194 "bc/src/regexp.c"
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
            ret = FUNCCALL(SETUP_XfOrM270(_), regnode (42 ) ); 
            FUNCCALL_AGAIN(regarg (0 ) ); 
            FUNCCALL_AGAIN(regarg (0 ) ); 
            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] != '?' ) {
              int posn ; 
#             define XfOrM288_COUNT (0+XfOrM270_COUNT)
#             define SETUP_XfOrM288(x) SETUP_XfOrM270(x)

# 1200 "bc/src/regexp.c"
              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
              posn = FUNCCALL(SETUP_XfOrM288(_), regdigit () ); 
              test = FUNCCALL_AGAIN(regnode (28 ) ); 
              FUNCCALL_AGAIN(regarg (posn ) ); 
              if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == ')' ) {
                XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
              }

# 1206 "bc/src/regexp.c"
              else {
#               define XfOrM289_COUNT (0+XfOrM288_COUNT)
#               define SETUP_XfOrM289(x) SETUP_XfOrM288(x)

# 1207 "bc/src/regexp.c"
                {
#                 define XfOrM290_COUNT (0+XfOrM289_COUNT)
#                 define SETUP_XfOrM290(x) SETUP_XfOrM289(x)
                  FUNCCALL(SETUP_XfOrM290(_), regcomperror ("expected `)' after `(?(' followed by a digit" ) )
# 1207 "bc/src/regexp.c"
                  ; 

# 1207 "bc/src/regexp.c"
                  RET_VALUE_START (0 ) RET_VALUE_END ; 
                }

# 1207 "bc/src/regexp.c"
                ; 
              }
            }

# 1209 "bc/src/regexp.c"
            else {
#             define XfOrM287_COUNT (0+XfOrM270_COUNT)
#             define SETUP_XfOrM287(x) SETUP_XfOrM270(x)

# 1210 "bc/src/regexp.c"
              test = FUNCCALL(SETUP_XfOrM287(_), regatom (& flags , parse_flags , 1 ) ); 
            }
            if (test != ((ret ) + 7 ) ) {
#             define XfOrM285_COUNT (0+XfOrM270_COUNT)
#             define SETUP_XfOrM285(x) SETUP_XfOrM270(x)

# 1213 "bc/src/regexp.c"
              {
#               define XfOrM286_COUNT (0+XfOrM285_COUNT)
#               define SETUP_XfOrM286(x) SETUP_XfOrM285(x)
                FUNCCALL(SETUP_XfOrM286(_), regcomperror ("test went to wrong place!?" ) )
# 1213 "bc/src/regexp.c"
                ; 

# 1213 "bc/src/regexp.c"
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }

# 1213 "bc/src/regexp.c"
              ; 
            }
            (__funcarg69 = FUNCCALL(SETUP_XfOrM270(_), regnode (0 ) ), FUNCCALL_AGAIN(regtail (test , __funcarg69 ) )) ; 
            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == ')' ) {
#             define XfOrM283_COUNT (0+XfOrM270_COUNT)
#             define SETUP_XfOrM283(x) SETUP_XfOrM270(x)

# 1217 "bc/src/regexp.c"
              {
#               define XfOrM284_COUNT (0+XfOrM283_COUNT)
#               define SETUP_XfOrM284(x) SETUP_XfOrM283(x)
                FUNCCALL(SETUP_XfOrM284(_), regcomperror ("expected an expression after test in `(?(...))'" ) )
# 1217 "bc/src/regexp.c"
                ; 

# 1217 "bc/src/regexp.c"
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }

# 1217 "bc/src/regexp.c"
              ; 
            }

            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = ((void * ) 0 ) ; 
            * flagp |= 0x01 ; 

            tbr = FUNCCALL(SETUP_XfOrM270(_), regbranch (& flags , parse_flags , 1 ) ); 

            if (! (flags & 0x01 ) ) {
              * flagp &= ~ 0x01 ; 
              backdepends = ((void * ) 0 ) ; 
            }

# 1228 "bc/src/regexp.c"
            else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ) {
              backdepends = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ; 
              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = ((void * ) 0 ) ; 
            }

# 1231 "bc/src/regexp.c"
            else 
            backdepends = ((void * ) 0 ) ; 

            if (! (flags & 0x08 ) )
              * flagp &= ~ 0x08 ; 
            matchmin = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) ; 
            matchmax = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) ; 

            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == ')' ) {
#             define XfOrM280_COUNT (0+XfOrM270_COUNT)
#             define SETUP_XfOrM280(x) SETUP_XfOrM270(x)

# 1240 "bc/src/regexp.c"
              fbr = FUNCCALL(SETUP_XfOrM280(_), regnode (13 ) ); 
              * flagp &= ~ 0x01 ; 
              matchmin = 0 ; 
            }

# 1243 "bc/src/regexp.c"
            else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != '|' ) {
#             define XfOrM278_COUNT (0+XfOrM270_COUNT)
#             define SETUP_XfOrM278(x) SETUP_XfOrM270(x)

# 1244 "bc/src/regexp.c"
              {
#               define XfOrM279_COUNT (0+XfOrM278_COUNT)
#               define SETUP_XfOrM279(x) SETUP_XfOrM278(x)
                FUNCCALL(SETUP_XfOrM279(_), regcomperror ("expected `)' or `|' after first branch of `(?(...)...)'" ) )
# 1244 "bc/src/regexp.c"
                ; 

# 1244 "bc/src/regexp.c"
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }

# 1244 "bc/src/regexp.c"
              ; 
            }

# 1245 "bc/src/regexp.c"
            else {
#             define XfOrM272_COUNT (0+XfOrM270_COUNT)
#             define SETUP_XfOrM272(x) SETUP_XfOrM270(x)

# 1246 "bc/src/regexp.c"
              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
              fbr = FUNCCALL(SETUP_XfOrM272(_), regbranch (& flags , parse_flags , 1 ) ); 
              if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != ')' ) {
#               define XfOrM276_COUNT (0+XfOrM272_COUNT)
#               define SETUP_XfOrM276(x) SETUP_XfOrM272(x)

# 1249 "bc/src/regexp.c"
                {
#                 define XfOrM277_COUNT (0+XfOrM276_COUNT)
#                 define SETUP_XfOrM277(x) SETUP_XfOrM276(x)
                  FUNCCALL(SETUP_XfOrM277(_), regcomperror ("expected `)' to close `(?(...)...' after second branch" ) )
# 1249 "bc/src/regexp.c"
                  ; 

# 1249 "bc/src/regexp.c"
                  RET_VALUE_START (0 ) RET_VALUE_END ; 
                }

# 1249 "bc/src/regexp.c"
                ; 
              }

              if (! (flags & 0x01 ) ) {
                * flagp &= ~ 0x01 ; 
                backdepends = ((void * ) 0 ) ; 
              }

# 1255 "bc/src/regexp.c"
              else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ) {
#               define XfOrM274_COUNT (0+XfOrM272_COUNT)
#               define SETUP_XfOrM274(x) SETUP_XfOrM272(x)

# 1256 "bc/src/regexp.c"
                if (backdepends )
                  FUNCCALL(SETUP_XfOrM274(_), merge_tables (backdepends , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ) ); 
                else 
                backdepends = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ; 
              }

              if (! (flags & 0x08 ) )
                * flagp &= ~ 0x08 ; 
              else {
                if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) < matchmin )
                  matchmin = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) ; 
                if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) > matchmax )
                  matchmax = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) ; 
              }
            }

            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = matchmax ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = matchmin ; 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = backdepends ; 

            if (((ret ) + 5 ) + 1 < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
              int delta ; 
              delta = tbr - ret ; 
              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((ret ) + 3 ) ] = delta >> 8 ; 
              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((ret ) + 3 ) + 1 ] = delta & 255 ; 
              delta = fbr - ret ; 
              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((ret ) + 5 ) ] = delta >> 8 ; 
              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((ret ) + 5 ) + 1 ] = delta & 255 ; 
            }
            ender = FUNCCALL(SETUP_XfOrM270(_), regnode (13 ) ); 
            FUNCCALL(SETUP_XfOrM270(_), regtail (tbr , ender ) ); 
            FUNCCALL_AGAIN(regtail (fbr , ender ) ); 
            FUNCCALL_AGAIN(regtail (ret , ender ) ); 
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
          }

# 1290 "bc/src/regexp.c"
          else 
          {
#           define XfOrM269_COUNT (0+XfOrM268_COUNT)
#           define SETUP_XfOrM269(x) SETUP_XfOrM268(x)
            FUNCCALL(SETUP_XfOrM269(_), regcomperror ("expected `(?=', `(?!', `(?<', or digit after `(?('" ) )
# 1291 "bc/src/regexp.c"
            ; 

# 1291 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 1291 "bc/src/regexp.c"
          ; 
        }

# 1292 "bc/src/regexp.c"
        else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '>' ) {
#         define XfOrM267_COUNT (0+XfOrM259_COUNT)
#         define SETUP_XfOrM267(x) SETUP_XfOrM259(x)

# 1293 "bc/src/regexp.c"
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
          ret = FUNCCALL(SETUP_XfOrM267(_), reg (1 , & flags , 0 , 24 , parse_flags ) ); 
          * flagp = flags ; 
        }

# 1296 "bc/src/regexp.c"
        else {
#         define XfOrM260_COUNT (0+XfOrM259_COUNT)
#         define SETUP_XfOrM260(x) SETUP_XfOrM259(x)

# 1297 "bc/src/regexp.c"
          if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '=' ) {
#           define XfOrM266_COUNT (0+XfOrM260_COUNT)
#           define SETUP_XfOrM266(x) SETUP_XfOrM260(x)

# 1298 "bc/src/regexp.c"
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
            ret = FUNCCALL(SETUP_XfOrM266(_), reg (1 , & flags , 0 , 22 , parse_flags ) ); 
          }

# 1300 "bc/src/regexp.c"
          else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '!' ) {
#           define XfOrM265_COUNT (0+XfOrM260_COUNT)
#           define SETUP_XfOrM265(x) SETUP_XfOrM260(x)

# 1301 "bc/src/regexp.c"
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
            ret = FUNCCALL(SETUP_XfOrM265(_), reg (1 , & flags , 0 , 23 , parse_flags ) ); 
          }

# 1303 "bc/src/regexp.c"
          else if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '<' ) 
          && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 2 ] == '=' ) ) {
#           define XfOrM264_COUNT (0+XfOrM260_COUNT)
#           define SETUP_XfOrM264(x) SETUP_XfOrM260(x)

# 1305 "bc/src/regexp.c"
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 3 ; 
            ret = FUNCCALL(SETUP_XfOrM264(_), reg (1 , & flags , 0 , 25 , parse_flags ) ); 
          }

# 1307 "bc/src/regexp.c"
          else if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '<' ) 
          && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 2 ] == '!' ) ) {
#           define XfOrM263_COUNT (0+XfOrM260_COUNT)
#           define SETUP_XfOrM263(x) SETUP_XfOrM260(x)

# 1309 "bc/src/regexp.c"
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 3 ; 
            ret = FUNCCALL(SETUP_XfOrM263(_), reg (1 , & flags , 0 , 26 , parse_flags ) ); 
          }

# 1311 "bc/src/regexp.c"
          else {
#           define XfOrM261_COUNT (0+XfOrM260_COUNT)
#           define SETUP_XfOrM261(x) SETUP_XfOrM260(x)

# 1312 "bc/src/regexp.c"
            {
#             define XfOrM262_COUNT (0+XfOrM261_COUNT)
#             define SETUP_XfOrM262(x) SETUP_XfOrM261(x)
              FUNCCALL(SETUP_XfOrM262(_), regcomperror ("expected `:', `=', `!', `<=', `<!', `i', `-i', `m', `-m', `s', or `-s' after `(?'" ) )
# 1312 "bc/src/regexp.c"
              ; 

# 1312 "bc/src/regexp.c"
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }

# 1312 "bc/src/regexp.c"
            ; 
          }
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 0 ; 
          * flagp = 0x08 ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = ((void * ) 0 ) ; 
        }
      }

# 1318 "bc/src/regexp.c"
      else {
#       define XfOrM256_COUNT (0+XfOrM254_COUNT)
#       define SETUP_XfOrM256(x) SETUP_XfOrM254(x)

# 1319 "bc/src/regexp.c"
        ret = FUNCCALL(SETUP_XfOrM256(_), reg (1 , & flags , 1 , 0 , parse_flags ) ); 
        if (flags & 0x10 ) {
          * flagp = flags ; 
        }

# 1322 "bc/src/regexp.c"
        else {
          * flagp |= flags & (0x01 | 0x04 ) ; 
          if (! (flags & 0x08 ) )
            * flagp &= ~ 0x08 ; 
        }
      }

      if (ret == 0 ) 
      {
#       define XfOrM255_COUNT (0+XfOrM254_COUNT)
#       define SETUP_XfOrM255(x) SETUP_XfOrM254(x)
        FUNCCALL(SETUP_XfOrM255(_), regcomperror ("cluster failed!?" ) )
# 1330 "bc/src/regexp.c"
        ; 

# 1330 "bc/src/regexp.c"
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 1330 "bc/src/regexp.c"
      ; 
    }
    break ; 
    case '|' : 
    case ')' : 
    {
#     define XfOrM253_COUNT (0+XfOrM218_COUNT)
#     define SETUP_XfOrM253(x) SETUP_XfOrM218(x)
      FUNCCALL(SETUP_XfOrM253(_), regcomperror ("internal urp" ) )
# 1335 "bc/src/regexp.c"
      ; 

# 1335 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 1335 "bc/src/regexp.c"
    ; 
    break ; 
    case '?' : 
    {
#     define XfOrM252_COUNT (0+XfOrM218_COUNT)
#     define SETUP_XfOrM252(x) SETUP_XfOrM218(x)
      FUNCCALL(SETUP_XfOrM252(_), regcomperror ("`?' follows nothing in pattern" ) )
# 1338 "bc/src/regexp.c"
      ; 

# 1338 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 1338 "bc/src/regexp.c"
    ; 
    break ; 
    case '+' : 
    {
#     define XfOrM251_COUNT (0+XfOrM218_COUNT)
#     define SETUP_XfOrM251(x) SETUP_XfOrM218(x)
      FUNCCALL(SETUP_XfOrM251(_), regcomperror ("`+' follows nothing in pattern" ) )
# 1341 "bc/src/regexp.c"
      ; 

# 1341 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 1341 "bc/src/regexp.c"
    ; 
    break ; 
    case '*' : 
    {
#     define XfOrM250_COUNT (0+XfOrM218_COUNT)
#     define SETUP_XfOrM250(x) SETUP_XfOrM218(x)
      FUNCCALL(SETUP_XfOrM250(_), regcomperror ("`*' follows nothing in pattern" ) )
# 1344 "bc/src/regexp.c"
      ; 

# 1344 "bc/src/regexp.c"
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

# 1344 "bc/src/regexp.c"
    ; 
    break ; 
    case '\\' : 
    {
      int c ; 
#     define XfOrM239_COUNT (0+XfOrM218_COUNT)
#     define SETUP_XfOrM239(x) SETUP_XfOrM218(x)

# 1349 "bc/src/regexp.c"
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) 
      {
#       define XfOrM249_COUNT (0+XfOrM239_COUNT)
#       define SETUP_XfOrM249(x) SETUP_XfOrM239(x)
        FUNCCALL(SETUP_XfOrM249(_), regcomperror ("trailing backslash in pattern" ) )
# 1350 "bc/src/regexp.c"
        ; 

# 1350 "bc/src/regexp.c"
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 1350 "bc/src/regexp.c"
      ; 
      c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ] ; 
      if ((parse_flags & 0x2 ) && (c == 'b' ) ) {
#       define XfOrM248_COUNT (0+XfOrM239_COUNT)
#       define SETUP_XfOrM248(x) SETUP_XfOrM239(x)

# 1353 "bc/src/regexp.c"
        ret = FUNCCALL(SETUP_XfOrM248(_), regnode (37 ) ); 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 0 ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) = 1 ; 
      }

# 1356 "bc/src/regexp.c"
      else if ((parse_flags & 0x2 ) && (c == 'B' ) ) {
#       define XfOrM247_COUNT (0+XfOrM239_COUNT)
#       define SETUP_XfOrM247(x) SETUP_XfOrM239(x)

# 1357 "bc/src/regexp.c"
        ret = FUNCCALL(SETUP_XfOrM247(_), regnode (38 ) ); 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 0 ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxlookback_ ) = 1 ; 
      }

# 1360 "bc/src/regexp.c"
      else if ((parse_flags & 0x2 ) && (c == 'p' ) ) {
#       define XfOrM246_COUNT (0+XfOrM239_COUNT)
#       define SETUP_XfOrM246(x) SETUP_XfOrM239(x)

# 1361 "bc/src/regexp.c"
        ret = FUNCCALL(SETUP_XfOrM246(_), regunicode (0 ) ); 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 6 ; 
        * flagp |= 0x01 ; 
      }

# 1364 "bc/src/regexp.c"
      else if ((parse_flags & 0x2 ) && (c == 'P' ) ) {
#       define XfOrM245_COUNT (0+XfOrM239_COUNT)
#       define SETUP_XfOrM245(x) SETUP_XfOrM239(x)

# 1365 "bc/src/regexp.c"
        ret = FUNCCALL(SETUP_XfOrM245(_), regunicode (1 ) ); 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = 6 ; 
        * flagp |= 0x01 ; 
      }

# 1368 "bc/src/regexp.c"
      else if ((parse_flags & 0x2 ) && (c >= '0' ) && (c <= '9' ) ) {
        int posn ; 
#       define XfOrM241_COUNT (0+XfOrM239_COUNT)
#       define SETUP_XfOrM241(x) SETUP_XfOrM239(x)

# 1370 "bc/src/regexp.c"
        -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ; 
        posn = FUNCCALL(SETUP_XfOrM241(_), regdigit () ); 
        if (parse_flags & 0x1 )
          ret = FUNCCALL(SETUP_XfOrM241(_), regnode (28 ) ); 
        else 
        ret = FUNCCALL(SETUP_XfOrM241(_), regnode (29 ) ); 
        FUNCCALL(SETUP_XfOrM241(_), regarg (posn ) ); 
        * flagp &= ~ 0x08 ; 

        {
          Scheme_Object * f ; 
          BLOCK_SETUP((PUSH(f, 0+XfOrM241_COUNT)));
#         define XfOrM242_COUNT (1+XfOrM241_COUNT)
#         define SETUP_XfOrM242(x) SETUP(XfOrM242_COUNT)
          f = NULLED_OUT ; 

# 1381 "bc/src/regexp.c"
          if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) )
            f = FUNCCALL(SETUP_XfOrM242(_), scheme_hash_get (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (posn ) ) ) << 1 ) | 0x1 ) ) ) ); 
          else 
          f = ((void * ) 0 ) ; 
          if (f ) {
            if (! (((f ) ) == (scheme_false ) ) ) 
              * flagp |= 0x01 ; 
          }

# 1388 "bc/src/regexp.c"
          else {
#           define XfOrM243_COUNT (0+XfOrM242_COUNT)
#           define SETUP_XfOrM243(x) SETUP_XfOrM242(x)

# 1389 "bc/src/regexp.c"
            * flagp |= 0x01 ; 
            if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) )
              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) = FUNCCALL(SETUP_XfOrM243(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            FUNCCALL(SETUP_XfOrM243(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (posn ) ) ) << 1 ) | 0x1 ) ) , scheme_true ) ); 
          }
        }
      }

# 1395 "bc/src/regexp.c"
      else {
#       define XfOrM240_COUNT (0+XfOrM239_COUNT)
#       define SETUP_XfOrM240(x) SETUP_XfOrM239(x)

# 1396 "bc/src/regexp.c"
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) -= 2 ; 
        ret = FUNCCALL(SETUP_XfOrM240(_), regranges (parse_flags , at_start ) ); 
        * flagp |= 0x01 | 0x02 ; 
      }
    }
    break ; 
    default : 
    {
      int len , ilen , c ; 
      char ender ; 
#     define XfOrM219_COUNT (0+XfOrM218_COUNT)
#     define SETUP_XfOrM219(x) SETUP_XfOrM218(x)

# 1407 "bc/src/regexp.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) -- ; 

      if (parse_flags & 0x2 ) {
#       define XfOrM235_COUNT (0+XfOrM219_COUNT)
#       define SETUP_XfOrM235(x) SETUP_XfOrM219(x)

# 1410 "bc/src/regexp.c"
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '{' ) 
        {
#         define XfOrM238_COUNT (0+XfOrM235_COUNT)
#         define SETUP_XfOrM238(x) SETUP_XfOrM235(x)
          FUNCCALL(SETUP_XfOrM238(_), regcomperror ("`{' follows nothing in pattern" ) )
# 1411 "bc/src/regexp.c"
          ; 

# 1411 "bc/src/regexp.c"
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 1411 "bc/src/regexp.c"
        ; 
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '}' ) 
        {
#         define XfOrM237_COUNT (0+XfOrM235_COUNT)
#         define SETUP_XfOrM237(x) SETUP_XfOrM235(x)
          FUNCCALL(SETUP_XfOrM237(_), regcomperror ("unmatched `}' in pattern" ) )
# 1413 "bc/src/regexp.c"
          ; 

# 1413 "bc/src/regexp.c"
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 1413 "bc/src/regexp.c"
        ; 
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == ']' ) 
        {
#         define XfOrM236_COUNT (0+XfOrM235_COUNT)
#         define SETUP_XfOrM236(x) SETUP_XfOrM235(x)
          FUNCCALL(SETUP_XfOrM236(_), regcomperror ("unmatched `]' in pattern" ) )
# 1415 "bc/src/regexp.c"
          ; 

# 1415 "bc/src/regexp.c"
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 1415 "bc/src/regexp.c"
        ; 
      }

      for (len = ilen = 0 ; XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + ilen < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ; len ++ , ilen ++ ) {
#       define XfOrM233_COUNT (0+XfOrM219_COUNT)
#       define SETUP_XfOrM233(x) SETUP_XfOrM219(x)

# 1419 "bc/src/regexp.c"
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + ilen ] == '\\' ) {
          if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + ilen + 1 >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) )
            break ; 
          c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + ilen + 1 ] ; 
          if (((c >= 'a' ) && (c <= 'z' ) ) 
          || ((c >= 'A' ) && (c <= 'Z' ) ) 
          || ((c >= '0' ) && (c <= '9' ) ) )
            break ; 
          ilen ++ ; 
        }

# 1428 "bc/src/regexp.c"
        else if (FUNCCALL(SETUP_XfOrM233(_), regstrcspn (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) + XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + ilen , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) + XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + ilen + 1 , (parse_flags & 0x2 ) ? "^$.[()|?+*\\{}]" : "^$.[()|?+*\\" ) )
        < 1 )
          break ; 
      }
      if (len <= 0 ) 
      {
#       define XfOrM230_COUNT (0+XfOrM219_COUNT)
#       define SETUP_XfOrM230(x) SETUP_XfOrM219(x)
        FUNCCALL(SETUP_XfOrM230(_), regcomperror ("internal disaster" ) )
# 1433 "bc/src/regexp.c"
        ; 

# 1433 "bc/src/regexp.c"
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 1433 "bc/src/regexp.c"
      ; 

      if ((len == 1 ) && at_start ) {
#       define XfOrM229_COUNT (0+XfOrM219_COUNT)
#       define SETUP_XfOrM229(x) SETUP_XfOrM219(x)

# 1437 "bc/src/regexp.c"
        ret = FUNCCALL(SETUP_XfOrM229(_), regranges (parse_flags , at_start ) ); 
        * flagp |= 0x01 | 0x02 ; 
      }

# 1439 "bc/src/regexp.c"
      else {
#       define XfOrM220_COUNT (0+XfOrM219_COUNT)
#       define SETUP_XfOrM220(x) SETUP_XfOrM219(x)

# 1440 "bc/src/regexp.c"
        if (! (parse_flags & 0x1 ) ) {

          int i ; 
          for (i = 0 ; i < ilen ; i ++ ) {
            c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + i ] ; 
            if (((((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) != c ) 
            || ((((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) != c ) ) {
              break ; 
            }
          }
          if (i >= ilen )
            parse_flags |= 0x1 ; 
        }

        ender = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + ilen ] ; 
        if (len > 1 && ((ender ) == '*' || (ender ) == '+' || (ender ) == '?' || ((parse_flags & 0x2 ) && ((ender ) == '{' ) ) ) ) {

          len -- ; 
          ilen -- ; 
          if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + ilen ] == '\\' )
            -- ilen ; 
        }
        * flagp |= 0x01 ; 
        if (len == 1 )
          * flagp |= 0x02 ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmin_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmatchmax_ ) = len ; 
        ret = FUNCCALL_EMPTY(regnode ((parse_flags & 0x1 ) ? 11 : 12 ) ); 
        FUNCCALL_EMPTY(regarg (len ) ); 
        while (len > 0 ) {
#         define XfOrM222_COUNT (0+XfOrM220_COUNT)
#         define SETUP_XfOrM222(x) SETUP_XfOrM220(x)

# 1469 "bc/src/regexp.c"
          c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ] ; 
          if (c == '\\' )
            c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ] ; 
          if (! (parse_flags & 0x1 ) )
            c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
          FUNCCALL_EMPTY(regc (c ) ); 
          len -- ; 
        }
      }
    }
    break ; 
  }

  if (! ret ) 
  {
#   define XfOrM217_COUNT (0+XfOrM216_COUNT)
#   define SETUP_XfOrM217(x) SETUP_XfOrM216(x)
    FUNCCALL_EMPTY(regcomperror ("failed!?" ) )
# 1483 "bc/src/regexp.c"
    ; 

# 1483 "bc/src/regexp.c"
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 1483 "bc/src/regexp.c"
  ; 

  RET_VALUE_START (ret ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1488 "bc/src/regexp.c"
static int regcharclass (int c , char * map , int * _non_ascii ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM311_COUNT (1)
# define SETUP_XfOrM311(x) SETUP(XfOrM311_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1490 "bc/src/regexp.c"
  switch (c ) {
#   define XfOrM312_COUNT (0+XfOrM311_COUNT)
#   define SETUP_XfOrM312(x) SETUP_XfOrM311(x)

# 1491 "bc/src/regexp.c"
    case 'd' : 
    for (c = 0 ; c < 10 ; c ++ ) {
      map ['0' + c ] = 1 ; 
    }
    break ; 
    case 'D' : 
    for (c = 0 ; c < '0' ; c ++ ) {
      map [c ] = 1 ; 
    }
    for (c = '9' + 1 ; c < (_non_ascii ? 128 : 256 ) ; c ++ ) {
      map [c ] = 1 ; 
    }
    if (_non_ascii )
      * _non_ascii = 1 ; 
    break ; 
    case 'w' : 
    for (c = 0 ; c < 26 ; c ++ ) {
      map ['a' + c ] = 1 ; 
      map ['A' + c ] = 1 ; 
    }
    for (c = 0 ; c < 10 ; c ++ ) {
      map ['0' + c ] = 1 ; 
    }
    map ['_' ] = 1 ; 
    break ; 
    case 'W' : 
    for (c = 0 ; c < '0' ; c ++ ) {
      map [c ] = 1 ; 
    }
    for (c = '9' + 1 ; c < 'A' ; c ++ ) {
      map [c ] = 1 ; 
    }
    for (c = 'Z' + 1 ; c < '_' ; c ++ ) {
      map [c ] = 1 ; 
    }
    for (c = 'z' + 1 ; c < (_non_ascii ? 128 : 256 ) ; c ++ ) {
      map [c ] = 1 ; 
    }
    if (_non_ascii )
      * _non_ascii = 1 ; 
    break ; 
    case 's' : 
    map ['\t' ] = 1 ; 
    map ['\n' ] = 1 ; 
    map ['\f' ] = 1 ; 
    map ['\r' ] = 1 ; 
    map [' ' ] = 1 ; 
    break ; 
    case 'S' : 
    for (c = 0 ; c < (_non_ascii ? 128 : 256 ) ; c ++ ) {
      switch (c ) {
        case '\t' : 
        case '\n' : 
        case '\f' : 
        case '\r' : 
        case ' ' : 
        break ; 
        default : 
        map [c ] = 1 ; 
        break ; 
      }
    }
    if (_non_ascii )
      * _non_ascii = 1 ; 
    break ; 
    default : 
    if (((c >= 'a' ) && (c <= 'z' ) ) 
    || ((c >= 'A' ) && (c <= 'Z' ) ) ) {
#     define XfOrM313_COUNT (0+XfOrM312_COUNT)
#     define SETUP_XfOrM313(x) SETUP_XfOrM312(x)

# 1559 "bc/src/regexp.c"
      {
#       define XfOrM314_COUNT (0+XfOrM313_COUNT)
#       define SETUP_XfOrM314(x) SETUP_XfOrM313(x)
        FUNCCALL(SETUP_XfOrM314(_), regcomperror ("illegal alphabetic escape" ) )
# 1559 "bc/src/regexp.c"
        ; 

# 1559 "bc/src/regexp.c"
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 1559 "bc/src/regexp.c"
      ; 
    }
    map [c ] = 1 ; 
    break ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1568 "bc/src/regexp.c"
static int is_posix_char_class (char * str , int pos , int len , char * map ) 
{
  int c ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(map, 1)));
# define XfOrM337_COUNT (2)
# define SETUP_XfOrM337(x) SETUP(XfOrM337_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1572 "bc/src/regexp.c"
  if (pos + 8 <= len ) {
#   define XfOrM344_COUNT (0+XfOrM337_COUNT)
#   define SETUP_XfOrM344(x) SETUP_XfOrM337(x)

# 1573 "bc/src/regexp.c"
    if (! (scheme_strncmp (":alnum:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
#     define XfOrM379_COUNT (0+XfOrM344_COUNT)
#     define SETUP_XfOrM379(x) SETUP_XfOrM344(x)

# 1574 "bc/src/regexp.c"
      if (map ) {
#       define XfOrM380_COUNT (0+XfOrM379_COUNT)
#       define SETUP_XfOrM380(x) SETUP_XfOrM379(x)
        FUNCCALL(SETUP_XfOrM380(_), regcharclass ('d' , map , ((void * ) 0 ) ) )
# 1575 "bc/src/regexp.c"
        ; 
        for (c = 'a' ; c <= 'z' ; c ++ ) {
          map [c ] = 1 ; 
          map [c - ('a' - 'A' ) ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1582 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":alpha:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 'a' ; c <= 'z' ; c ++ ) {
          map [c ] = 1 ; 
          map [c - ('a' - 'A' ) ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1590 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":ascii:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 0 ; c <= 127 ; c ++ ) {
          map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1597 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":blank:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        map [' ' ] = 1 ; 
        map ['\t' ] = 1 ; 
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1603 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":cntrl:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 0 ; c <= 31 ; c ++ ) {
          map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1610 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":digit:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
#     define XfOrM363_COUNT (0+XfOrM344_COUNT)
#     define SETUP_XfOrM363(x) SETUP_XfOrM344(x)

# 1611 "bc/src/regexp.c"
      if (map ) {
#       define XfOrM364_COUNT (0+XfOrM363_COUNT)
#       define SETUP_XfOrM364(x) SETUP_XfOrM363(x)
        FUNCCALL(SETUP_XfOrM364(_), regcharclass ('d' , map , ((void * ) 0 ) ) )
# 1612 "bc/src/regexp.c"
        ; 
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1615 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":graph:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 0 ; c <= 127 ; c ++ ) {
          if (((scheme_uchar_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ) & 0x800 ) 
            map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1623 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":lower:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 'a' ; c <= 'z' ; c ++ ) {
          map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1630 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":print:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 0 ; c <= 127 ; c ++ ) {
          if (((scheme_uchar_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ) & 0x800 ) 
            map [c ] = 1 ; 
        }
        map [' ' ] = 1 ; 
        map ['\t' ] = 1 ; 
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1640 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":space:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
#     define XfOrM349_COUNT (0+XfOrM344_COUNT)
#     define SETUP_XfOrM349(x) SETUP_XfOrM344(x)

# 1641 "bc/src/regexp.c"
      if (map ) {
#       define XfOrM350_COUNT (0+XfOrM349_COUNT)
#       define SETUP_XfOrM350(x) SETUP_XfOrM349(x)
        FUNCCALL(SETUP_XfOrM350(_), regcharclass ('s' , map , ((void * ) 0 ) ) )
# 1642 "bc/src/regexp.c"
        ; 
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 1645 "bc/src/regexp.c"
    else if (! (scheme_strncmp (":upper:]" , str XFORM_OK_PLUS pos , 8 ) ) ) {
      if (map ) {
        for (c = 'A' ; c <= 'Z' ; c ++ ) {
          map [c ] = 1 ; 
        }
      }
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  if ((pos + 7 <= len ) 
  && ! (scheme_strncmp (":word:]" , str XFORM_OK_PLUS pos , 7 ) ) ) {
#   define XfOrM342_COUNT (0+XfOrM337_COUNT)
#   define SETUP_XfOrM342(x) SETUP_XfOrM337(x)

# 1657 "bc/src/regexp.c"
    if (map ) {
#     define XfOrM343_COUNT (0+XfOrM342_COUNT)
#     define SETUP_XfOrM343(x) SETUP_XfOrM342(x)
      FUNCCALL(SETUP_XfOrM343(_), regcharclass ('w' , map , ((void * ) 0 ) ) )
# 1658 "bc/src/regexp.c"
      ; 
    }
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  if ((pos + 9 <= len ) 
  && ! (scheme_strncmp (":xdigit:]" , str XFORM_OK_PLUS pos , 9 ) ) ) {
#   define XfOrM338_COUNT (0+XfOrM337_COUNT)
#   define SETUP_XfOrM338(x) SETUP_XfOrM337(x)

# 1665 "bc/src/regexp.c"
    if (map ) {
#     define XfOrM339_COUNT (0+XfOrM338_COUNT)
#     define SETUP_XfOrM339(x) SETUP_XfOrM338(x)
      FUNCCALL(SETUP_XfOrM339(_), regcharclass ('d' , map , ((void * ) 0 ) ) )
# 1666 "bc/src/regexp.c"
      ; 
      for (c = 'a' ; c <= 'f' ; c ++ ) {
        map [c ] = 1 ; 
        map [c - ('a' - 'A' ) ] = 1 ; 
      }
    }
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1678 "bc/src/regexp.c"
static int is_posix_char_class_in_unicode (mzchar * str , int pos , int len , char * map ) 
{
  /* No conversion */

# 1680 "bc/src/regexp.c"
  int ulen ; 
  int i ; 
  char buf [10 ] ; 

  if (pos + 7 > len )
    return 0 ; 

  ulen = len - pos ; 
  if (ulen > 9 )
    ulen = 9 ; 

  for (i = 0 ; i < ulen ; i ++ ) {
    if (str [pos + i ] > 127 )
      return 0 ; 
    buf [i ] = (char ) str [pos + i ] ; 
  }

  return is_posix_char_class (buf , 0 , ulen , map ) ; 
}

static char * regrange (int parse_flags , char * map ) 

{
  int xclass , c ; 
  int classend , can_range = 0 ; 
  int exclude = 0 ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(map, 0)));
# define XfOrM386_COUNT (1)
# define SETUP_XfOrM386(x) SETUP(XfOrM386_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1707 "bc/src/regexp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '^' ) {
    exclude = 1 ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == ']' || XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '-' ) {
    c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ; 
    map [c ] = 1 ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
  }
  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != ']' ) {
#   define XfOrM418_COUNT (0+XfOrM386_COUNT)
#   define SETUP_XfOrM418(x) SETUP_XfOrM386(x)

# 1718 "bc/src/regexp.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '-' ) {
#     define XfOrM427_COUNT (0+XfOrM418_COUNT)
#     define SETUP_XfOrM427(x) SETUP_XfOrM418(x)

# 1719 "bc/src/regexp.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == ']' || XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) {
        map ['-' ] = 1 ; 
      }

# 1722 "bc/src/regexp.c"
      else {
#       define XfOrM428_COUNT (0+XfOrM427_COUNT)
#       define SETUP_XfOrM428(x) SETUP_XfOrM427(x)

# 1723 "bc/src/regexp.c"
        if (! can_range ) {
#         define XfOrM442_COUNT (0+XfOrM428_COUNT)
#         define SETUP_XfOrM442(x) SETUP_XfOrM428(x)

# 1724 "bc/src/regexp.c"
          {
#           define XfOrM443_COUNT (0+XfOrM442_COUNT)
#           define SETUP_XfOrM443(x) SETUP_XfOrM442(x)
            FUNCCALL(SETUP_XfOrM443(_), regcomperror ("misplaced hyphen within square brackets in pattern" ) )
# 1724 "bc/src/regexp.c"
            ; 

# 1724 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 1724 "bc/src/regexp.c"
          ; 
        }

# 1725 "bc/src/regexp.c"
        else {
#         define XfOrM429_COUNT (0+XfOrM428_COUNT)
#         define SETUP_XfOrM429(x) SETUP_XfOrM428(x)

# 1726 "bc/src/regexp.c"
          xclass = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) - 2 ] ) ) + 1 ; 
          classend = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) ) ; 
          if (classend == '-' ) {
#           define XfOrM440_COUNT (0+XfOrM429_COUNT)
#           define SETUP_XfOrM440(x) SETUP_XfOrM429(x)

# 1729 "bc/src/regexp.c"
            {
#             define XfOrM441_COUNT (0+XfOrM440_COUNT)
#             define SETUP_XfOrM441(x) SETUP_XfOrM440(x)
              FUNCCALL(SETUP_XfOrM441(_), regcomperror ("misplaced hyphen within square brackets in pattern" ) )
# 1729 "bc/src/regexp.c"
              ; 

# 1729 "bc/src/regexp.c"
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }

# 1729 "bc/src/regexp.c"
            ; 
          }
          if ((classend == '\\' ) && (parse_flags & 0x2 ) ) {
#           define XfOrM435_COUNT (0+XfOrM429_COUNT)
#           define SETUP_XfOrM435(x) SETUP_XfOrM429(x)

# 1732 "bc/src/regexp.c"
            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) {
#             define XfOrM438_COUNT (0+XfOrM435_COUNT)
#             define SETUP_XfOrM438(x) SETUP_XfOrM435(x)

# 1733 "bc/src/regexp.c"
              {
#               define XfOrM439_COUNT (0+XfOrM438_COUNT)
#               define SETUP_XfOrM439(x) SETUP_XfOrM438(x)
                FUNCCALL(SETUP_XfOrM439(_), regcomperror ("escaping backslash at end pattern (within square brackets)" ) )
# 1733 "bc/src/regexp.c"
                ; 

# 1733 "bc/src/regexp.c"
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }

# 1733 "bc/src/regexp.c"
              ; 
            }
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
            classend = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) ) ; 
            if (((classend >= 'a' ) && (classend <= 'z' ) ) 
            || ((classend >= 'A' ) && (classend <= 'Z' ) ) ) {
#             define XfOrM436_COUNT (0+XfOrM435_COUNT)
#             define SETUP_XfOrM436(x) SETUP_XfOrM435(x)

# 1739 "bc/src/regexp.c"
              {
#               define XfOrM437_COUNT (0+XfOrM436_COUNT)
#               define SETUP_XfOrM437(x) SETUP_XfOrM436(x)
                FUNCCALL(SETUP_XfOrM437(_), regcomperror ("misplaced hyphen within square brackets in pattern" ) )
# 1739 "bc/src/regexp.c"
                ; 

# 1739 "bc/src/regexp.c"
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }

# 1739 "bc/src/regexp.c"
              ; 
            }
          }
          if (xclass > classend + 1 ) 
          {
#           define XfOrM434_COUNT (0+XfOrM429_COUNT)
#           define SETUP_XfOrM434(x) SETUP_XfOrM429(x)
            FUNCCALL(SETUP_XfOrM434(_), regcomperror ("invalid range within square brackets in pattern" ) )
# 1743 "bc/src/regexp.c"
            ; 

# 1743 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 1743 "bc/src/regexp.c"
          ; 
          for (; xclass <= classend ; xclass ++ ) {
            c = xclass ; 
            map [c ] = 1 ; 
            if (! (parse_flags & 0x1 ) ) {
              c = (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ; 
              map [c ] = 1 ; 
              c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
              map [c ] = 1 ; 
            }
          }
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
        }
      }
      can_range = 0 ; 
    }

# 1758 "bc/src/regexp.c"
    else if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '\\' ) && (parse_flags & 0x2 ) ) {
#     define XfOrM424_COUNT (0+XfOrM418_COUNT)
#     define SETUP_XfOrM424(x) SETUP_XfOrM418(x)

# 1759 "bc/src/regexp.c"
      c = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] ) ) ; 
      if (((c >= 'a' ) && (c <= 'z' ) ) 
      || ((c >= 'A' ) && (c <= 'Z' ) ) ) {
#       define XfOrM426_COUNT (0+XfOrM424_COUNT)
#       define SETUP_XfOrM426(x) SETUP_XfOrM424(x)
        FUNCCALL(SETUP_XfOrM426(_), regcharclass (c , map , ((void * ) 0 ) ) )
# 1762 "bc/src/regexp.c"
        ; 
        can_range = 0 ; 
      }

# 1764 "bc/src/regexp.c"
      else {
        map [c ] = 1 ; 
        can_range = 1 ; 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
    }

# 1769 "bc/src/regexp.c"
    else if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '[' ) 
    && (parse_flags & 0x2 ) 
    && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == ':' ) 
    && FUNCCALL(SETUP_XfOrM418(_), is_posix_char_class (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) , map ) )) {
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += 2 ; 
      while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != ']' ) {
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
      can_range = 0 ; 
    }

# 1779 "bc/src/regexp.c"
    else {
      c = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ] ) ) ; 
      map [c ] = 1 ; 
      if (! (parse_flags & 0x1 ) ) {
        c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
        map [c ] = 1 ; 
        c = (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ; 
        map [c ] = 1 ; 
      }
      can_range = 1 ; 
    }
  }

  if (exclude ) {
    for (c = 0 ; c < 256 ; c ++ ) {
      map [c ] = ! map [c ] ; 
    }
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != ']' ) 
  {
#   define XfOrM387_COUNT (0+XfOrM386_COUNT)
#   define SETUP_XfOrM387(x) SETUP_XfOrM386(x)
    FUNCCALL(SETUP_XfOrM387(_), regcomperror ("missing closing square bracket in pattern" ) )
# 1799 "bc/src/regexp.c"
    ; 

# 1799 "bc/src/regexp.c"
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 1799 "bc/src/regexp.c"
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 

  RET_VALUE_START (map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1805 "bc/src/regexp.c"
static rxpos 
regranges (int parse_flags , int at_start ) 
{
  int c ; 
  rxpos ret , save_regparse = 0 ; 
  int count , off_ranges , on_ranges , now_on , last_on , prev_last_on ; 





  char * new_map = ((void * ) 0 ) , * accum_map = ((void * ) 0 ) ; 
  DECL_RET_SAVE (rxpos ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(accum_map, 0), PUSH(new_map, 1)));
# define XfOrM447_COUNT (2)
# define SETUP_XfOrM447(x) SETUP(XfOrM447_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1818 "bc/src/regexp.c"
  count = 0 ; 
  while (1 ) {
#   define XfOrM520_COUNT (0+XfOrM447_COUNT)
#   define SETUP_XfOrM520(x) SETUP_XfOrM447(x)


    if (! new_map )
      new_map = (char * ) FUNCCALL(SETUP_XfOrM520(_), GC_malloc_atomic (256 ) ); 
    (memset (new_map , 0 , 256 ) ) ; 

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '\\' 
    && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) ) {
#     define XfOrM531_COUNT (0+XfOrM520_COUNT)
#     define SETUP_XfOrM531(x) SETUP_XfOrM520(x)

# 1831 "bc/src/regexp.c"
      c = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [++ XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) ) ; 
      if (parse_flags & 0x2 ) {
#       define XfOrM532_COUNT (0+XfOrM531_COUNT)
#       define SETUP_XfOrM532(x) SETUP_XfOrM531(x)

# 1833 "bc/src/regexp.c"
        if ((c >= '0' ) && (c <= '9' ) )
          break ; 
        if (((c >= 'a' ) && (c <= 'z' ) ) 
        || ((c >= 'A' ) && (c <= 'Z' ) ) ) {
#         define XfOrM533_COUNT (0+XfOrM532_COUNT)
#         define SETUP_XfOrM533(x) SETUP_XfOrM532(x)

# 1837 "bc/src/regexp.c"
          if ((c == 'p' ) || (c == 'P' ) ) {

            break ; 
          }
          FUNCCALL(SETUP_XfOrM533(_), regcharclass (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] , new_map , ((void * ) 0 ) ) ); 
        }
        else 
        new_map [c ] = 1 ; 
      }

# 1845 "bc/src/regexp.c"
      else 
      new_map [c ] = 1 ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
    }

# 1848 "bc/src/regexp.c"
    else if (FUNCCALL(SETUP_XfOrM520(_), regstrcspn (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) + XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) + XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 , (parse_flags & 0x2 ) ? "^$.[()|?+*\\{}]" : "^$.[()|?+*\\" ) )) 
    {

      c = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ) ) ; 
      new_map [c ] = 1 ; 
      if (! (parse_flags & 0x1 ) ) {
        c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
        new_map [c ] = 1 ; 
        c = (((c >= 'a' ) && (c <= 'z' ) ) ? (c - ('a' - 'A' ) ) : c ) ; 
        new_map [c ] = 1 ; 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
    }

# 1860 "bc/src/regexp.c"
    else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '.' ) {

      for (c = 0 ; c < 256 ; c ++ ) {
        new_map [c ] = 1 ; 
      }
      if (! (parse_flags & 0x4 ) )
        new_map ['\n' ] = 0 ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
    }

# 1868 "bc/src/regexp.c"
    else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '[' ) {
#     define XfOrM525_COUNT (0+XfOrM520_COUNT)
#     define SETUP_XfOrM525(x) SETUP_XfOrM520(x)

# 1870 "bc/src/regexp.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
      FUNCCALL(SETUP_XfOrM525(_), regrange (parse_flags , new_map ) ); 
    }

# 1872 "bc/src/regexp.c"
    else 
    break ; 





    if (accum_map 
    && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) 
    && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != '|' ) 
    && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != ')' ) )
      break ; 


    if (accum_map ) {
      for (c = 0 ; c < 256 ; c ++ ) {
        accum_map [c ] |= new_map [c ] ; 
      }
    }

# 1890 "bc/src/regexp.c"
    else {
      accum_map = new_map ; 
      new_map = ((void * ) 0 ) ; 
    }
    save_regparse = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ; 


    if (! at_start 
    || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != '|' ) 
    || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) 
    || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == ')' ) )
      break ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) )
      break ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) = save_regparse ; 

  if (! accum_map ) 
  {
#   define XfOrM504_COUNT (0+XfOrM447_COUNT)
#   define SETUP_XfOrM504(x) SETUP_XfOrM447(x)
    FUNCCALL(SETUP_XfOrM504(_), regcomperror ("should have found one range!" ) )
# 1911 "bc/src/regexp.c"
    ; 

# 1911 "bc/src/regexp.c"
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 1911 "bc/src/regexp.c"
  ; 

  while (1 ) {
#   define XfOrM476_COUNT (0+XfOrM447_COUNT)
#   define SETUP_XfOrM476(x) SETUP_XfOrM447(x)
    count = 0 ; 




    on_ranges = 0 ; 
    off_ranges = 0 ; 
    now_on = 0 ; 
    last_on = - 1 ; 
    prev_last_on = - 1 ; 
    for (c = 0 ; c < 256 ; c ++ ) {
      if (accum_map [c ] ) {
        if (now_on < 0 )
          off_ranges ++ ; 
        now_on = 1 ; 
        count ++ ; 
        prev_last_on = last_on ; 
        last_on = c ; 
      }

# 1946 "bc/src/regexp.c"
      else {
        if (now_on > 0 )
          on_ranges ++ ; 
        now_on = - 1 ; 
      }
    }
    if (now_on > 0 )
      on_ranges ++ ; 
    else 
    off_ranges ++ ; 


    if (count == 256 ) {
#     define XfOrM497_COUNT (0+XfOrM476_COUNT)
#     define SETUP_XfOrM497(x) SETUP_XfOrM476(x)

# 1959 "bc/src/regexp.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(regnode (3 ) )) RET_VALUE_EMPTY_END ; 
    }

# 1960 "bc/src/regexp.c"
    else if ((count == 255 ) && ! accum_map ['\n' ] ) {
#     define XfOrM496_COUNT (0+XfOrM476_COUNT)
#     define SETUP_XfOrM496(x) SETUP_XfOrM476(x)

# 1961 "bc/src/regexp.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(regnode (4 ) )) RET_VALUE_EMPTY_END ; 
    }

# 1962 "bc/src/regexp.c"
    else if (count == 1 ) {
#     define XfOrM495_COUNT (0+XfOrM476_COUNT)
#     define SETUP_XfOrM495(x) SETUP_XfOrM476(x)

# 1963 "bc/src/regexp.c"
      ret = FUNCCALL(SETUP_XfOrM495(_), regnode (6 ) ); 
      FUNCCALL(SETUP_XfOrM495(_), regc (last_on ) ); 
      RET_VALUE_START (ret ) RET_VALUE_END ; 
    }

# 1966 "bc/src/regexp.c"
    else if (count == 2 ) {
#     define XfOrM494_COUNT (0+XfOrM476_COUNT)
#     define SETUP_XfOrM494(x) SETUP_XfOrM476(x)

# 1967 "bc/src/regexp.c"
      ret = FUNCCALL(SETUP_XfOrM494(_), regnode (43 ) ); 
      FUNCCALL(SETUP_XfOrM494(_), regc (last_on ) ); 
      FUNCCALL_AGAIN(regc (prev_last_on ) ); 
      RET_VALUE_START (ret ) RET_VALUE_END ; 
    }

# 1971 "bc/src/regexp.c"
    else if ((on_ranges == 1 ) 
    || (off_ranges == 1 ) ) {
      int rs = 255 , re = 255 , on ; 
#     define XfOrM485_COUNT (0+XfOrM476_COUNT)
#     define SETUP_XfOrM485(x) SETUP_XfOrM476(x)

# 1975 "bc/src/regexp.c"
      if (on_ranges == 1 )
        on = 1 ; 
      else 
      on = 0 ; 

      for (c = 0 ; c < 256 ; c ++ ) {
        if (! ! accum_map [c ] == on ) {
          rs = c ; 
          break ; 
        }
      }
      for (c ++ ; c < 256 ; c ++ ) {
        if ((! accum_map [c ] ) == on ) {
          re = c - 1 ; 
          break ; 
        }
      }

      if (on )
        ret = FUNCCALL(SETUP_XfOrM485(_), regnode (7 ) ); 
      else 
      ret = FUNCCALL(SETUP_XfOrM485(_), regnode (8 ) ); 
      FUNCCALL(SETUP_XfOrM485(_), regc (rs ) ); 
      FUNCCALL_AGAIN(regc (re ) ); 
      RET_VALUE_START (ret ) RET_VALUE_END ; 
    }

# 2000 "bc/src/regexp.c"
    else {
      rxpos a ; 
#     define XfOrM477_COUNT (0+XfOrM476_COUNT)
#     define SETUP_XfOrM477(x) SETUP_XfOrM476(x)

# 2003 "bc/src/regexp.c"
      ret = FUNCCALL(SETUP_XfOrM477(_), regnode (5 ) ); 
      a = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 
      for (c = 0 ; c < 32 ; c ++ ) {
#       define XfOrM484_COUNT (0+XfOrM477_COUNT)
#       define SETUP_XfOrM484(x) SETUP_XfOrM477(x)
        FUNCCALL(SETUP_XfOrM484(_), regc (0 ) )
# 2006 "bc/src/regexp.c"
        ; 
      }

      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) <= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
        for (c = 0 ; c < 256 ; c ++ ) {
          if (accum_map [c ] ) {
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [a + (c >> 3 ) ] |= (1 << (c & 0x7 ) ) ; 
          }
        }
      }

      RET_VALUE_START (ret ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2022 "bc/src/regexp.c"
static const char * prop_names [] = {

# 2022 "bc/src/regexp.c"
  "Cn" , 
  "Cc" , 
  "Cf" , 
  "Cs" , 
  "Co" , 
  "Ll" , 
  "Lu" , 
  "Lt" , 
  "Lm" , 
  "Lo" , 
  "Nd" , 
  "Nl" , 
  "No" , 
  "Ps" , 
  "Pe" , 
  "Pi" , 
  "Pf" , 
  "Pc" , 
  "Pd" , 
  "Po" , 
  "Mn" , 
  "Mc" , 
  "Me" , 
  "Sc" , 
  "Sk" , 
  "Sm" , 
  "So" , 
  "Zl" , 
  "Zp" , 
  "Zs" , 
  ((void * ) 0 ) }

# 2052 "bc/src/regexp.c"
; 

static rxpos 
regunicode (int negate ) 
{
  /* No conversion */

# 2057 "bc/src/regexp.c"
  rxpos ret ; 
  int len , bottom , top , i ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != '{' ) {
    {

# 2061 "bc/src/regexp.c"
      regcomperror ("expected { after \\p or \\P" ) ; 

# 2061 "bc/src/regexp.c"
      return 0 ; 
    }

# 2061 "bc/src/regexp.c"
    ; 
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '^' ) {
    negate = ! negate ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
  }

  len = 0 ; 
  while ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + len ] != '}' ) 
  && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + len < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) ) {
    len ++ ; 
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + len >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) {
    {

# 2076 "bc/src/regexp.c"
      regcomperror ("missing } to close \\p{ or \\P{" ) ; 

# 2076 "bc/src/regexp.c"
      return 0 ; 
    }

# 2076 "bc/src/regexp.c"
    ; 
  }

  bottom = top = - 1 ; 
  if (len == 2 ) {
    for (i = 0 ; prop_names [i ] ; i ++ ) {
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == prop_names [i ] [0 ] ) 
      && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == prop_names [i ] [1 ] ) ) {
        bottom = top = i ; 
        break ; 
      }
    }
    if (bottom == - 1 ) {
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == 'L' ) 
      && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) + 1 ] == '&' ) ) {
        bottom = mzu_Ll ; 
        top = mzu_Lm ; 
      }
    }
  }

# 2095 "bc/src/regexp.c"
  else if (len == 1 ) {
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == '.' ) {
      bottom = 0 ; 
      top = mzu_Zs ; 
    }

# 2099 "bc/src/regexp.c"
    else {
      for (i = 0 ; prop_names [i ] ; i ++ ) {
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] == prop_names [i ] [0 ] ) {
          bottom = i ; 
          while (prop_names [i + 1 ] ) {
            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] != prop_names [i + 1 ] [0 ] )
              break ; 
            i ++ ; 
          }
          top = i ; 
          break ; 
        }
      }
    }
  }

  if (bottom < 0 ) {
    {

# 2116 "bc/src/regexp.c"
      regcomperror ("unrecognized property name in \\p{} or \\P{}" ) ; 

# 2116 "bc/src/regexp.c"
      return 0 ; 
    }

# 2116 "bc/src/regexp.c"
    ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) += len + 1 ; 

  ret = regnode (41 ) ; 

  regarg ((negate << 13 ) | (bottom << 6 ) | top ) ; 

  return ret ; 
}

static int regdigit () 
{
  /* No conversion */

# 2130 "bc/src/regexp.c"
  int posn , c ; 
  c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ] ; 
  posn = c - '0' ; 
  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_end_ ) ) {
    c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ] ; 
    if ((c >= '0' ) && (c <= '9' ) ) {
      posn = (posn * 10 ) + (c - '0' ) ; 
      if (posn > 0x7FFF ) 
      {

# 2138 "bc/src/regexp.c"
        regcomperror ("backreference number is too large" ) ; 

# 2138 "bc/src/regexp.c"
        return 0 ; 
      }

# 2138 "bc/src/regexp.c"
      ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparse_ ) ++ ; 
    }

# 2140 "bc/src/regexp.c"
    else 
    break ; 
  }
  if (posn > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxbackposn_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regmaxbackposn_ ) = posn ; 
  return posn ; 
}




static rxpos 
regnode (char op ) 
{
  /* No conversion */

# 2154 "bc/src/regexp.c"
  rxpos ret ; 
  rxpos ptr ; 

  ret = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) + 3 >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) += 3 ; 
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 
    return ret ; 
  }

  ptr = ret ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ptr ++ ] = op ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ptr ++ ] = '\0' ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [ptr ++ ] = '\0' ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) = ptr ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 

  return ret ; 
}




static void 
regc (char b ) 
{
  /* No conversion */

# 2183 "bc/src/regexp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) + 1 < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ] = b ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ++ ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 
}

static void 
regarg (int v ) 
{
  /* No conversion */

# 2193 "bc/src/regexp.c"
  regc (v >> 8 ) ; 
  regc (v & 255 ) ; 
}






static void 
regshift (int amt , rxpos opnd ) 
{
  /* No conversion */

# 2205 "bc/src/regexp.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) + amt < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
    memmove (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) XFORM_OK_PLUS opnd + amt , 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) XFORM_OK_PLUS opnd , 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) - opnd ) ; 
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) += amt ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodemax_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcode_ ) ; 
}

static void 
reginsert (char op , rxpos opnd ) 
{
  /* No conversion */

# 2218 "bc/src/regexp.c"
  regshift (3 , opnd ) ; 

  if (opnd + 3 >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
    return ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = op ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = '\0' ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = '\0' ; 
}

static rxpos 
reginsertwithop (char op , rxpos opnd , int arg ) 
{
  /* No conversion */

# 2232 "bc/src/regexp.c"
  regshift (5 , opnd ) ; 

  if (opnd + 5 >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
    return opnd + 5 ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = op ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = '\0' ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = '\0' ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = (arg >> 8 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = (arg & 255 ) ; 

  return opnd ; 
}

static rxpos 
reginsertwithopop (char op , rxpos opnd , int arg , int arg2 ) 
{
  /* No conversion */

# 2250 "bc/src/regexp.c"
  regshift (7 , opnd ) ; 

  if (opnd + 7 >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
    return opnd + 7 ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = op ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = '\0' ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = '\0' ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = (arg >> 8 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = (arg & 255 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = (arg2 >> 8 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ++ ] = (arg2 & 255 ) ; 

  return opnd ; 
}




static void 
regtail (rxpos p , rxpos val ) 
{
  /* No conversion */

# 2273 "bc/src/regexp.c"
  rxpos scan ; 
  rxpos temp ; 
  int offset ; 


  scan = p ; 
  for (; ; ) {
    if (scan + 2 >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
      return ; 
    }
    temp = regnext (scan ) ; 
    if (temp == 0 )
      break ; 
    scan = temp ; 
  }

  if (scan + 2 >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) {
    return ; 
  }

  if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [scan ] ) == 10 )
    offset = scan - val ; 
  else 
  offset = val - scan ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [scan + 1 ] = (offset >> 8 ) & 255 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [scan + 2 ] = offset & 255 ; 
}




static void 
regoptail (rxpos p , rxpos val ) 
{
  /* No conversion */
  if (p == 0 || (p >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) ) || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [p ] ) != 9 ) {
    return ; 
  }
  regtail (((p ) + 3 ) , val ) ; 
}

static int merge_tables (Scheme_Hash_Table * dest , Scheme_Hash_Table * src ) 
{
  int i ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(dest, 0), PUSH(src, 1)));
# define XfOrM590_COUNT (2)
# define SETUP_XfOrM590(x) SETUP(XfOrM590_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2318 "bc/src/regexp.c"
  for (i = src -> size ; i -- ; ) {
#   define XfOrM593_COUNT (0+XfOrM590_COUNT)
#   define SETUP_XfOrM593(x) SETUP_XfOrM590(x)

# 2319 "bc/src/regexp.c"
    if (src -> vals [i ] ) {
#     define XfOrM594_COUNT (0+XfOrM593_COUNT)
#     define SETUP_XfOrM594(x) SETUP_XfOrM593(x)
      FUNCCALL(SETUP_XfOrM594(_), scheme_hash_set (dest , src -> keys [i ] , src -> vals [i ] ) )
# 2320 "bc/src/regexp.c"
      ; 
    }
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2327 "bc/src/regexp.c"
static int check_and_propagate_depends (void ) 
{
  int i , j ; 
  Scheme_Hash_Table * backdepends = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) , * ht , * next_ht = ((void * ) 0 ) ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(backdepends, 1), PUSH(ht, 2), PUSH(next_ht, 3)));
# define XfOrM595_COUNT (4)
# define SETUP_XfOrM595(x) SETUP(XfOrM595_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 2333 "bc/src/regexp.c"
  while (backdepends ) {
#   define XfOrM619_COUNT (0+XfOrM595_COUNT)
#   define SETUP_XfOrM619(x) SETUP_XfOrM595(x)

# 2334 "bc/src/regexp.c"
    for (i = backdepends -> size ; i -- ; ) {
#     define XfOrM631_COUNT (0+XfOrM619_COUNT)
#     define SETUP_XfOrM631(x) SETUP_XfOrM619(x)

# 2335 "bc/src/regexp.c"
      if (backdepends -> vals [i ] ) {
#       define XfOrM632_COUNT (0+XfOrM631_COUNT)
#       define SETUP_XfOrM632(x) SETUP_XfOrM631(x)

# 2336 "bc/src/regexp.c"
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) )
          v = FUNCCALL(SETUP_XfOrM632(_), scheme_hash_get (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , backdepends -> keys [i ] ) ); 
        else 
        v = ((void * ) 0 ) ; 
        if (v ) {
#         define XfOrM634_COUNT (0+XfOrM632_COUNT)
#         define SETUP_XfOrM634(x) SETUP_XfOrM632(x)

# 2342 "bc/src/regexp.c"
          if (((v ) ) == (scheme_false ) )  {
#           define XfOrM640_COUNT (0+XfOrM634_COUNT)
#           define SETUP_XfOrM640(x) SETUP_XfOrM634(x)

# 2343 "bc/src/regexp.c"
            {
#             define XfOrM641_COUNT (0+XfOrM640_COUNT)
#             define SETUP_XfOrM641(x) SETUP_XfOrM640(x)
              FUNCCALL(SETUP_XfOrM641(_), regcomperror ("*, +, or {...,} operand could be empty (via empty backreference)" ) )
# 2343 "bc/src/regexp.c"
              ; 

# 2343 "bc/src/regexp.c"
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }

# 2343 "bc/src/regexp.c"
            ; 
          }
          if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
#           define XfOrM635_COUNT (0+XfOrM634_COUNT)
#           define SETUP_XfOrM635(x) SETUP_XfOrM634(x)
            FUNCCALL(SETUP_XfOrM635(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , backdepends -> keys [i ] , scheme_true ) ); 
            if (! next_ht )
              next_ht = FUNCCALL(SETUP_XfOrM635(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            ht = (Scheme_Hash_Table * ) v ; 
            for (j = ht -> size ; j -- ; ) {
#             define XfOrM638_COUNT (0+XfOrM635_COUNT)
#             define SETUP_XfOrM638(x) SETUP_XfOrM635(x)

# 2353 "bc/src/regexp.c"
              if (ht -> vals [j ] ) {
#               define XfOrM639_COUNT (0+XfOrM638_COUNT)
#               define SETUP_XfOrM639(x) SETUP_XfOrM638(x)
                FUNCCALL(SETUP_XfOrM639(_), scheme_hash_set (next_ht , ht -> keys [j ] , ht -> vals [j ] ) )
# 2354 "bc/src/regexp.c"
                ; 
              }
            }
          }
        }

# 2358 "bc/src/regexp.c"
        else {
#         define XfOrM633_COUNT (0+XfOrM632_COUNT)
#         define SETUP_XfOrM633(x) SETUP_XfOrM632(x)

# 2360 "bc/src/regexp.c"
          if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) )
            XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) = FUNCCALL(SETUP_XfOrM633(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
          FUNCCALL(SETUP_XfOrM633(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , backdepends -> keys [i ] , scheme_true ) ); 
        }
      }
    }
    backdepends = next_ht ; 
    next_ht = ((void * ) 0 ) ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2373 "bc/src/regexp.c"
static inline rxpos l_strchr (char * str , rxpos a , int l , int c ) 
{
  /* No conversion */

# 2375 "bc/src/regexp.c"
  int i ; 

  for (i = 0 ; i < l ; i ++ ) {
    if (str [a + i ] == c )
      return a + i ; 
  }

  return - 1 ; 
}

static inline rxpos l_strchr_ci (char * str , rxpos a , int l , int c ) 
{
  /* No conversion */

# 2387 "bc/src/regexp.c"
  int i , ch ; 

  for (i = 0 ; i < l ; i ++ ) {
    ch = str [a + i ] ; 
    ch = (((ch >= 'A' ) && (ch <= 'Z' ) ) ? (ch + ('a' - 'A' ) ) : ch ) ; 
    if (ch == c )
      return a + i ; 
  }

  return - 1 ; 
}

# 2438 "bc/src/regexp.c"
static int regtry (regexp * , char * , int , int , rx_lazy_str_t * , rxpos * , rxpos * , rxpos * , rxpos * , int * , Regwork * rw , rxpos , 
char * , rxpos , rxpos , int ) ; 
static int regtry_port (regexp * , Scheme_Object * , Scheme_Object * , int nonblock , 
rxpos * , rxpos * , rxpos * , rxpos * , int * , 
char * * , rxpos * , rxpos * , rxpos , Scheme_Object * , Scheme_Object * , rxpos , 
char * , rxpos , rxpos , 
int , int * ) ; 
static int regmatch (Regwork * rw , rxpos ) ; 
static int regrepeat (Regwork * rw , rxpos , int ) ; 

static void stack_room (Regwork * rw , int amt ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(rw, 0)));
# define XfOrM648_COUNT (1)
# define SETUP_XfOrM648(x) SETUP(XfOrM648_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2450 "bc/src/regexp.c"
  if (rw -> rewind_stack_count + amt > rw -> rewind_stack_size ) {
    int sz ; 
    rxpos * p ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM648_COUNT)));
#   define XfOrM649_COUNT (1+XfOrM648_COUNT)
#   define SETUP_XfOrM649(x) SETUP(XfOrM649_COUNT)
    p = NULLED_OUT ; 

# 2453 "bc/src/regexp.c"
    sz = rw -> rewind_stack_size * 2 ; 
    if (! sz )

# 2454 "bc/src/regexp.c"
    sz = 24 ; 
    p = (rxpos * ) FUNCCALL(SETUP_XfOrM649(_), GC_malloc_atomic (sizeof (rxpos ) * sz ) ); 
    if (rw -> rewind_stack_size )
      (memcpy (p , rw -> rewind_stack , rw -> rewind_stack_size * sizeof (rxpos ) ) ) ; 
    rw -> rewind_stack = p ; 
    rw -> rewind_stack_size = sz ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2463 "bc/src/regexp.c"
static int match_push (Regwork * rw ) 
{
  /* No conversion */

# 2465 "bc/src/regexp.c"
  if (rw -> non_tail >= 0 ) {
    int pos ; 

    rw -> non_tail ++ ; 
    pos = rw -> rewind_stack_count ; 
    rw -> rewind_stack_prompt = pos ; 

    return pos ; 
  }

# 2473 "bc/src/regexp.c"
  else 
  return 0 ; 
}

static void match_pop (Regwork * rw , int pos , int matched ) 
{
  /* No conversion */

# 2479 "bc/src/regexp.c"
  if (rw -> non_tail >= 0 ) {
    -- rw -> non_tail ; 

    if (matched ) {



      rw -> rewind_stack_prompt = pos ; 
    }

# 2487 "bc/src/regexp.c"
    else {
      int i , no ; 
      for (i = rw -> rewind_stack_count ; i > pos ; i -= 3 ) {
        no = rw -> rewind_stack [i - 3 ] ; 
        if (no < 0 ) {
          rw -> maybep [- no ] = rw -> rewind_stack [i - 2 ] ; 
        }

# 2493 "bc/src/regexp.c"
        else {
          rw -> startp [no ] = rw -> rewind_stack [i - 2 ] ; 
          rw -> endp [no ] = rw -> rewind_stack [i - 1 ] ; 
        }
      }
      rw -> rewind_stack_count = pos ; 
      rw -> rewind_stack_prompt = pos ; 
    }
  }
}

static void match_set (Regwork * rw , int no , rxpos start , rxpos end ) 
{
  int i , count ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(rw, 0)));
# define XfOrM662_COUNT (1)
# define SETUP_XfOrM662(x) SETUP(XfOrM662_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2508 "bc/src/regexp.c"
  if (rw -> non_tail > 0 ) {
#   define XfOrM663_COUNT (0+XfOrM662_COUNT)
#   define SETUP_XfOrM663(x) SETUP_XfOrM662(x)

# 2509 "bc/src/regexp.c"
    count = rw -> rewind_stack_count ; 
    for (i = rw -> rewind_stack_prompt ; i < count ; i += 3 ) {
      if (rw -> rewind_stack [i ] == no )
        break ; 
    }

    if (i >= count ) {
#     define XfOrM664_COUNT (0+XfOrM663_COUNT)
#     define SETUP_XfOrM664(x) SETUP_XfOrM663(x)
      FUNCCALL(SETUP_XfOrM664(_), stack_room (rw , 3 ) )
# 2516 "bc/src/regexp.c"
      ; 
      i = count ; 
      rw -> rewind_stack [i ++ ] = no ; 
      rw -> rewind_stack [i ++ ] = rw -> startp [no ] ; 
      rw -> rewind_stack [i ++ ] = rw -> endp [no ] ; 
      rw -> rewind_stack_count = i ; 
    }
  }

  rw -> startp [no ] = start ; 
  rw -> endp [no ] = end ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2529 "bc/src/regexp.c"
static void match_maybe (Regwork * rw , int no , rxpos pos ) 
{
  int i , count ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(rw, 0)));
# define XfOrM667_COUNT (1)
# define SETUP_XfOrM667(x) SETUP(XfOrM667_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2533 "bc/src/regexp.c"
  if (rw -> non_tail > 0 ) {
#   define XfOrM668_COUNT (0+XfOrM667_COUNT)
#   define SETUP_XfOrM668(x) SETUP_XfOrM667(x)

# 2534 "bc/src/regexp.c"
    count = rw -> rewind_stack_count ; 
    for (i = rw -> rewind_stack_prompt ; i < count ; i += 3 ) {
      if (rw -> rewind_stack [i ] == (- no ) )
        break ; 
    }

    if (i >= count ) {
#     define XfOrM669_COUNT (0+XfOrM668_COUNT)
#     define SETUP_XfOrM669(x) SETUP_XfOrM668(x)
      FUNCCALL(SETUP_XfOrM669(_), stack_room (rw , 3 ) )
# 2541 "bc/src/regexp.c"
      ; 
      i = count ; 
      rw -> rewind_stack [i ++ ] = (- no ) ; 
      rw -> rewind_stack [i ++ ] = rw -> maybep [no ] ; 
      rw -> rewind_stack [i ++ ] = 0 ; 
      rw -> rewind_stack_count = i ; 
    }
  }

  rw -> maybep [no ] = pos ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}







static int 
regexec (const char * who , 
regexp * prog , char * string , 

int stringpos , int stringlen , int stringorigin , 

rx_lazy_str_t * lazy_string , 

rxpos * startp , rxpos * maybep , rxpos * endp , rxpos * match_stack , 

Scheme_Object * port , Scheme_Object * unless_evt , int nonblock , 

char * * stringp , int peek , int get_offsets , intptr_t save_prior , 
Scheme_Object * discard_oport , 
Scheme_Object * portstart , Scheme_Object * portend , Scheme_Object * * _dropped , 
char * prefix , rxpos prefix_len , rxpos prefix_offset ) 
{
  int spos ; 
  int * counters ; 
  Scheme_Object * dropped = ((void * ) 0 ) , * peekskip = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(21);
  BLOCK_SETUP_TOP((PUSH(match_stack, 0), PUSH(stringp, 1), PUSH(who, 2), PUSH(lazy_string, 3), PUSH(prefix, 4), PUSH(prog, 5), PUSH(portstart, 6), PUSH(endp, 7), PUSH(string, 8), PUSH(unless_evt, 9), PUSH(portend, 10), PUSH(port, 11), PUSH(discard_oport, 12), PUSH(dropped, 13), PUSH(peekskip, 14), PUSH(_dropped, 15), PUSH(startp, 16), PUSH(counters, 17), PUSH(maybep, 18)));
# define XfOrM672_COUNT (19)
# define SETUP_XfOrM672(x) SETUP(XfOrM672_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  counters = NULLED_OUT ; 

# 2586 "bc/src/regexp.c"
  if (((unsigned char ) (prog -> program [0 ] ) ) != 156 ) {
#   define XfOrM731_COUNT (0+XfOrM672_COUNT)
#   define SETUP_XfOrM731(x) SETUP_XfOrM672(x)
    FUNCCALL(SETUP_XfOrM731(_), regerror ("corrupted program" ) )
# 2587 "bc/src/regexp.c"
    ; 
    RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
  }


  if (! port && ! lazy_string && (prog -> regmust >= 0 ) ) {
#   define XfOrM714_COUNT (0+XfOrM672_COUNT)
#   define SETUP_XfOrM714(x) SETUP_XfOrM672(x)

# 2593 "bc/src/regexp.c"
    spos = stringpos ; 
    while (1 ) {
      int i , l = prog -> regmlen , ch , pos ; 
      GC_CAN_IGNORE char * p ; 
#     define XfOrM723_COUNT (0+XfOrM714_COUNT)
#     define SETUP_XfOrM723(x) SETUP_XfOrM714(x)

# 2598 "bc/src/regexp.c"
      if ((spos - stringpos ) + l <= stringlen ) {
#       define XfOrM730_COUNT (0+XfOrM723_COUNT)
#       define SETUP_XfOrM730(x) SETUP_XfOrM723(x)

# 2599 "bc/src/regexp.c"
        if (prog -> flags & 0x08 )
          pos = FUNCCALL(SETUP_XfOrM730(_), l_strchr_ci (string , spos , stringlen - (spos - stringpos ) - (l - 1 ) , ((char * ) prog XFORM_OK_PLUS prog -> regmust ) [0 ] ) )
        ; 
        else 
        pos = FUNCCALL(SETUP_XfOrM730(_), l_strchr (string , spos , stringlen - (spos - stringpos ) - (l - 1 ) , ((char * ) prog XFORM_OK_PLUS prog -> regmust ) [0 ] ) )
        ; 
        if (pos == - 1 )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

# 2607 "bc/src/regexp.c"
      else 
      RET_VALUE_START (0 ) RET_VALUE_END ; 


      p = ((char * ) prog XFORM_OK_PLUS prog -> regmust ) ; 
      if (prog -> flags & 0x08 ) {
        for (i = 0 ; i < l ; i ++ ) {
          ch = string [pos + i ] ; 
          ch = (((ch >= 'A' ) && (ch <= 'Z' ) ) ? (ch + ('a' - 'A' ) ) : ch ) ; 
          if (ch != p [i ] )
            break ; 
        }
      }

# 2619 "bc/src/regexp.c"
      else {
        for (i = 0 ; i < l ; i ++ ) {
          if (string [pos + i ] != p [i ] )
            break ; 
        }
      }
      if (i >= l )
        break ; 
      spos = pos + 1 ; 
    }
  }

  if (prog -> ncounter ) {
#   define XfOrM713_COUNT (0+XfOrM672_COUNT)
#   define SETUP_XfOrM713(x) SETUP_XfOrM672(x)

# 2632 "bc/src/regexp.c"
    counters = (int * ) FUNCCALL(SETUP_XfOrM713(_), GC_malloc_atomic (sizeof (int ) * prog -> ncounter ) ); 
  }

# 2633 "bc/src/regexp.c"
  else 
  counters = ((void * ) 0 ) ; 

  if (port ) {
#   define XfOrM702_COUNT (0+XfOrM672_COUNT)
#   define SETUP_XfOrM702(x) SETUP_XfOrM672(x)

# 2637 "bc/src/regexp.c"
    if (peek ) {
#     define XfOrM710_COUNT (0+XfOrM702_COUNT)
#     define SETUP_XfOrM710(x) SETUP_XfOrM702(x)

# 2638 "bc/src/regexp.c"
      peekskip = portstart ; 
      dropped = portstart ; 

      if (! ((peekskip ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) ) {
        char tmp [1 ] ; 
        intptr_t got ; 
#       define XfOrM711_COUNT (0+XfOrM710_COUNT)
#       define SETUP_XfOrM711(x) SETUP_XfOrM710(x)

# 2644 "bc/src/regexp.c"
        got = (__funcarg70 = FUNCCALL(SETUP_XfOrM711(_), scheme_bin_minus (peekskip , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) )

        , FUNCCALL_AGAIN(scheme_get_byte_string_unless ("regexp-match" , port , tmp , 0 , 1 , 1 , 1 , __funcarg70 , unless_evt ) )) 
        ; 
        if (got == (- 1 ) ) {

          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }
      }
    }

# 2653 "bc/src/regexp.c"
    else {

      intptr_t amt , got ; 
#     define XfOrM703_COUNT (0+XfOrM702_COUNT)
#     define SETUP_XfOrM703(x) SETUP_XfOrM702(x)

# 2657 "bc/src/regexp.c"
      if (((intptr_t ) (portstart ) ) & 0x1 )  {
        amt = (((intptr_t ) (portstart ) ) >> 1 ) ; 
        if (amt > 4096 )
          amt = 4096 ; 
      }

# 2661 "bc/src/regexp.c"
      else 
      amt = 4096 ; 

      dropped = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

      if (amt ) {
        char * drain ; 
        BLOCK_SETUP((PUSH(drain, 0+XfOrM703_COUNT)));
#       define XfOrM704_COUNT (1+XfOrM703_COUNT)
#       define SETUP_XfOrM704(x) SETUP(XfOrM704_COUNT)
        drain = NULLED_OUT ; 

# 2669 "bc/src/regexp.c"
        drain = (char * ) FUNCCALL(SETUP_XfOrM704(_), GC_malloc_atomic (amt ) ); 

        do {
#         define XfOrM707_COUNT (0+XfOrM704_COUNT)
#         define SETUP_XfOrM707(x) SETUP_XfOrM704(x)

# 2672 "bc/src/regexp.c"
          got = FUNCCALL(SETUP_XfOrM707(_), scheme_get_byte_string (who , port , drain , 0 , amt , 0 , 0 , 0 ) ); 
          if (got != (- 1 ) ) {
            Scheme_Object * delta ; 
            BLOCK_SETUP((PUSH(delta, 0+XfOrM707_COUNT)));
#           define XfOrM708_COUNT (1+XfOrM707_COUNT)
#           define SETUP_XfOrM708(x) SETUP(XfOrM708_COUNT)
            delta = NULLED_OUT ; 

# 2676 "bc/src/regexp.c"
            if (discard_oport )
              FUNCCALL(SETUP_XfOrM708(_), scheme_put_byte_string (who , discard_oport , drain , 0 , got , 0 ) ); 

            dropped = FUNCCALL(SETUP_XfOrM708(_), scheme_bin_plus (dropped , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (got ) ) ) << 1 ) | 0x1 ) ) ) ); 
            delta = FUNCCALL_AGAIN(scheme_bin_minus (portstart , dropped ) ); 
            if (FUNCCALL(SETUP_XfOrM708(_), scheme_bin_gt (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (amt ) ) ) << 1 ) | 0x1 ) ) , delta ) ))
              amt = (((intptr_t ) (delta ) ) >> 1 ) ; 
          }
        }

# 2684 "bc/src/regexp.c"
        while ((got != (- 1 ) ) && amt ) ; 
        if (amt )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }

    if (portend )
      portend = FUNCCALL(SETUP_XfOrM702(_), scheme_bin_minus (portend , dropped ) ); 
  }


  if (prog -> flags & 0x04 ) {
#   define XfOrM689_COUNT (0+XfOrM672_COUNT)
#   define SETUP_XfOrM689(x) SETUP_XfOrM672(x)

# 2696 "bc/src/regexp.c"
    if (port ) {
      rxpos len = 0 , space = 0 ; 
      int aborted = 0 ; 
#     define XfOrM690_COUNT (0+XfOrM689_COUNT)
#     define SETUP_XfOrM690(x) SETUP_XfOrM689(x)

# 2700 "bc/src/regexp.c"
      * stringp = ((void * ) 0 ) ; 
      if (FUNCCALL(SETUP_XfOrM690(_), regtry_port (prog , port , unless_evt , nonblock , startp , maybep , endp , match_stack , counters , stringp , & len , & space , 0 , portend , peekskip , 0 , prefix , prefix_len , prefix_offset , 0 , & aborted ) )) 


      {
#       define XfOrM700_COUNT (0+XfOrM690_COUNT)
#       define SETUP_XfOrM700(x) SETUP_XfOrM690(x)

# 2705 "bc/src/regexp.c"
        if (! peek ) {

          char * drain ; 
          BLOCK_SETUP((PUSH(drain, 0+XfOrM700_COUNT)));
#         define XfOrM701_COUNT (1+XfOrM700_COUNT)
#         define SETUP_XfOrM701(x) SETUP(XfOrM701_COUNT)
          drain = NULLED_OUT ; 

# 2709 "bc/src/regexp.c"
          if (discard_oport && * startp )
            FUNCCALL(SETUP_XfOrM701(_), scheme_put_byte_string (who , discard_oport , * stringp , 0 , * startp , 0 ) ); 

          if (get_offsets )
            drain = * stringp ; 
          else 

          drain = (char * ) FUNCCALL(SETUP_XfOrM701(_), GC_malloc_atomic (* endp ) ); 
          (void ) FUNCCALL(SETUP_XfOrM701(_), scheme_get_byte_string (who , port , drain , 0 , * endp , 0 , 0 , 0 ) ); 
        }

        * _dropped = dropped ; 

        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }

# 2723 "bc/src/regexp.c"
      else {
#       define XfOrM691_COUNT (0+XfOrM690_COUNT)
#       define SETUP_XfOrM691(x) SETUP_XfOrM690(x)

# 2724 "bc/src/regexp.c"
        if (! peek ) {

          char * drain ; 
          intptr_t got ; 
          BLOCK_SETUP((PUSH(drain, 0+XfOrM691_COUNT)));
#         define XfOrM692_COUNT (1+XfOrM691_COUNT)
#         define SETUP_XfOrM692(x) SETUP(XfOrM692_COUNT)
          drain = NULLED_OUT ; 

# 2729 "bc/src/regexp.c"
          if (portend && (((intptr_t ) (portend ) ) & 0x1 ) && (((intptr_t ) (portend ) ) >> 1 ) < 4096 ) {
            got = (((intptr_t ) (portend ) ) >> 1 ) ; 
          }

# 2731 "bc/src/regexp.c"
          else 
          got = 4096 ; 

          drain = (char * ) FUNCCALL(SETUP_XfOrM692(_), GC_malloc_atomic (got ) ); 

          while ((got = FUNCCALL(SETUP_XfOrM692(_), scheme_get_byte_string (who , port , drain , 0 , got , 0 , 0 , 0 ) )) != (- 1 ) ) {
#           define XfOrM696_COUNT (0+XfOrM692_COUNT)
#           define SETUP_XfOrM696(x) SETUP_XfOrM692(x)

# 2737 "bc/src/regexp.c"
            if (discard_oport )
              FUNCCALL(SETUP_XfOrM696(_), scheme_put_byte_string (who , discard_oport , drain , 0 , got , 0 ) ); 

            if (portend ) {
#             define XfOrM697_COUNT (0+XfOrM696_COUNT)
#             define SETUP_XfOrM697(x) SETUP_XfOrM696(x)

# 2741 "bc/src/regexp.c"
              portend = FUNCCALL(SETUP_XfOrM697(_), scheme_bin_minus (portend , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (got ) ) ) << 1 ) | 0x1 ) ) ) ); 
              if (((intptr_t ) (portend ) ) & 0x1 )  {
                got = (((intptr_t ) (portend ) ) >> 1 ) ; 
                if (! got )
                  break ; 
                else if (got > 4096 )
                  got = 4096 ; 
              }
            }

# 2749 "bc/src/regexp.c"
            else 
            got = 4096 ; 
          }
        }
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
    }

# 2755 "bc/src/regexp.c"
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(regtry (prog , string , stringpos , stringlen , lazy_string , startp , maybep , endp , match_stack , counters , 0 , stringorigin , prefix , prefix_len , prefix_offset , 0 ) )) RET_VALUE_EMPTY_END 

    ; 
  }


  if (port ) {
    rxpos len = 0 , skip = 0 , space = 0 ; 
#   define XfOrM674_COUNT (0+XfOrM672_COUNT)
#   define SETUP_XfOrM674(x) SETUP_XfOrM672(x)

# 2764 "bc/src/regexp.c"
    * stringp = ((void * ) 0 ) ; 

    do {
      int discard = skip - prog -> maxlookback ; 
      int aborted = 0 ; 
#     define XfOrM683_COUNT (0+XfOrM674_COUNT)
#     define SETUP_XfOrM683(x) SETUP_XfOrM674(x)

# 2770 "bc/src/regexp.c"
      if (discard > skip - save_prior )
        discard = skip - save_prior ; 

      if (discard >= 256 ) {
#       define XfOrM686_COUNT (0+XfOrM683_COUNT)
#       define SETUP_XfOrM686(x) SETUP_XfOrM683(x)

# 2774 "bc/src/regexp.c"
        if (! peek ) {
#         define XfOrM688_COUNT (0+XfOrM686_COUNT)
#         define SETUP_XfOrM688(x) SETUP_XfOrM686(x)

# 2775 "bc/src/regexp.c"
          if (discard_oport )
            FUNCCALL(SETUP_XfOrM688(_), scheme_put_byte_string (who , discard_oport , * stringp , 0 , discard , 0 ) ); 
          FUNCCALL(SETUP_XfOrM688(_), scheme_get_byte_string (who , port , * stringp , 0 , discard , 0 , 0 , 0 ) )
          ; 

          if (portend )
            portend = FUNCCALL(SETUP_XfOrM688(_), scheme_bin_minus (portend , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (discard ) ) ) << 1 ) | 0x1 ) ) ) ); 
        }

# 2782 "bc/src/regexp.c"
        else {
#         define XfOrM687_COUNT (0+XfOrM686_COUNT)
#         define SETUP_XfOrM687(x) SETUP_XfOrM686(x)

# 2783 "bc/src/regexp.c"
          peekskip = FUNCCALL(SETUP_XfOrM687(_), scheme_bin_plus (peekskip , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (discard ) ) ) << 1 ) | 0x1 ) ) ) ); 
        }

        dropped = FUNCCALL(SETUP_XfOrM686(_), scheme_bin_plus (dropped , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (discard ) ) ) << 1 ) | 0x1 ) ) ) ); 

        len -= discard ; 
        skip -= discard ; 
        (memmove (* stringp , * stringp + discard , len ) ) ; 

        prefix = ((void * ) 0 ) ; 
        prefix_len = 0 ; 
      }

      if (FUNCCALL(SETUP_XfOrM683(_), regtry_port (prog , port , unless_evt , nonblock , startp , maybep , endp , match_stack , counters , stringp , & len , & space , skip , portend , peekskip , 0 , prefix , prefix_len , prefix_offset , 1 , & aborted ) )) 


      {
#       define XfOrM684_COUNT (0+XfOrM683_COUNT)
#       define SETUP_XfOrM684(x) SETUP_XfOrM683(x)

# 2800 "bc/src/regexp.c"
        if (! peek ) {
          char * drain ; 
          BLOCK_SETUP((PUSH(drain, 0+XfOrM684_COUNT)));
#         define XfOrM685_COUNT (1+XfOrM684_COUNT)
#         define SETUP_XfOrM685(x) SETUP(XfOrM685_COUNT)
          drain = NULLED_OUT ; 

# 2803 "bc/src/regexp.c"
          if (discard_oport && * startp )
            FUNCCALL(SETUP_XfOrM685(_), scheme_put_byte_string (who , discard_oport , * stringp , 0 , * startp , 0 ) ); 

          if (get_offsets )
            drain = * stringp ; 
          else 

          drain = (char * ) FUNCCALL(SETUP_XfOrM685(_), GC_malloc_atomic (* endp ) ); 
          FUNCCALL(SETUP_XfOrM685(_), scheme_get_byte_string (who , port , drain , 0 , * endp , 0 , 0 , 0 ) )
          ; 
        }

        * _dropped = dropped ; 

        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }

# 2818 "bc/src/regexp.c"
      else if (aborted )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      skip ++ ; 
    }

# 2821 "bc/src/regexp.c"
    while (len >= skip ) ; 

    if (! peek ) {
#     define XfOrM675_COUNT (0+XfOrM674_COUNT)
#     define SETUP_XfOrM675(x) SETUP_XfOrM674(x)
      if (len > 0 ) {
#       define XfOrM676_COUNT (0+XfOrM675_COUNT)
#       define SETUP_XfOrM676(x) SETUP_XfOrM675(x)

# 2827 "bc/src/regexp.c"
        if (discard_oport )
          FUNCCALL(SETUP_XfOrM676(_), scheme_put_byte_string (who , discard_oport , * stringp , 0 , len , 0 ) ); 
        FUNCCALL(SETUP_XfOrM676(_), scheme_get_byte_string (who , port , * stringp , 0 , len , 0 , 0 , 0 ) ); 
      }
    }
  }

# 2832 "bc/src/regexp.c"
  else {
#   define XfOrM673_COUNT (0+XfOrM672_COUNT)
#   define SETUP_XfOrM673(x) SETUP_XfOrM672(x)

# 2833 "bc/src/regexp.c"
    if (FUNCCALL_EMPTY(regtry (prog , string , stringpos , stringlen , lazy_string , startp , maybep , endp , match_stack , counters , 0 , stringorigin , prefix , prefix_len , prefix_offset , 1 ) ))


    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }


  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2844 "bc/src/regexp.c"
static void read_more_from_regport (Regwork * rw , rxpos need_total ) ; 




static int 
regtry (regexp * prog , char * string , int stringpos , int stringlen , rx_lazy_str_t * lazy_string , 
rxpos * startp , rxpos * maybep , rxpos * endp , rxpos * match_stack , int * counters , 
Regwork * rw , rxpos stringorigin , 
char * prefix , rxpos prefix_len , rxpos prefix_offset , 
int unanchored ) 




{
  int i ; 
  Regwork _rw ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(19);
  BLOCK_SETUP_TOP((PUSH(startp, 0), PUSH(rw, 1), PUSH(lazy_string, 2), PUSH(prog, 3), PUSH(_rw.str, 4), PUSH(_rw.instr, 5), PUSH(_rw.port, 6), PUSH(_rw.unless_evt, 7), PUSH(_rw.startp, 8), PUSH(_rw.maybep, 9), PUSH(_rw.endp, 10), PUSH(_rw.counters, 11), PUSH(_rw.peekskip, 12), PUSH(_rw.prefix, 13), PUSH(_rw.lazy_string, 14), PUSH(_rw.rewind_stack, 15), PUSH(endp, 16), PUSH(string, 17)));
# define XfOrM732_COUNT (18)
# define SETUP_XfOrM732(x) SETUP(XfOrM732_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  _rw.str = NULLED_OUT ; 
  _rw.instr = NULLED_OUT ; 
  _rw.port = NULLED_OUT ; 
  _rw.unless_evt = NULLED_OUT ; 
  _rw.startp = NULLED_OUT ; 
  _rw.maybep = NULLED_OUT ; 
  _rw.endp = NULLED_OUT ; 
  _rw.counters = NULLED_OUT ; 
  _rw.peekskip = NULLED_OUT ; 
  _rw.prefix = NULLED_OUT ; 
  _rw.lazy_string = NULLED_OUT ; 
  _rw.rewind_stack = NULLED_OUT ; 

# 2863 "bc/src/regexp.c"
  if (! rw ) {
    rw = & _rw ; 
    rw -> port = ((void * ) 0 ) ; 
  }
  rw -> instr = string ; 
  rw -> input = stringpos ; 
  rw -> input_end = stringpos + stringlen ; 
  rw -> input_start = stringorigin ; 
  rw -> input_min = stringorigin - prefix_len ; 
  rw -> startp = startp ; 
  rw -> maybep = maybep ; 
  rw -> endp = endp ; 
  rw -> counters = counters ; 
  rw -> prefix = prefix ; 
  rw -> prefix_len = prefix_len ; 
  rw -> prefix_delta = prefix_len + prefix_offset - stringorigin ; 
  rw -> boi = stringorigin - prefix_len ; 
  rw -> rewind_stack_size = (match_stack ? 24 : 0 ) ; 
  rw -> rewind_stack_count = 0 ; 
  rw -> rewind_stack_prompt = 0 ; 
  rw -> rewind_stack = match_stack ; 
  if (prog -> nsubexp < 2 )
    rw -> non_tail = - 1 ; 
  else 
  rw -> non_tail = 0 ; 
  rw -> lazy_string = lazy_string ; 
  if (lazy_string )
    rw -> port = scheme_true ; 

  for (i = prog -> nsubexp ; i -- ; ) {
    startp [i ] = rw -> input_min - 1 ; 
    endp [i ] = rw -> input_min - 1 ; 
  }




  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) = (char * ) prog ; 


  while (1 ) {
    int found ; 
#   define XfOrM744_COUNT (0+XfOrM732_COUNT)
#   define SETUP_XfOrM744(x) SETUP_XfOrM732(x)

# 2906 "bc/src/regexp.c"
    found = FUNCCALL(SETUP_XfOrM744(_), regmatch (rw , ((prog -> program + 1 ) - (char * ) prog ) ) ); 

    if (found ) {
      startp [0 ] = stringpos ; 
      endp [0 ] = rw -> input ; 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }

# 2912 "bc/src/regexp.c"
    else if (unanchored ) {
#     define XfOrM745_COUNT (0+XfOrM744_COUNT)
#     define SETUP_XfOrM745(x) SETUP_XfOrM744(x)

# 2913 "bc/src/regexp.c"
      if (lazy_string ) {
#       define XfOrM753_COUNT (0+XfOrM745_COUNT)
#       define SETUP_XfOrM753(x) SETUP_XfOrM745(x)

# 2914 "bc/src/regexp.c"
        if (rw -> port && (((stringpos ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM753(_), read_more_from_regport (rw , (stringpos ) + (1 ) ) )
# 2914 "bc/src/regexp.c"
        ; 
        stringlen = rw -> input_end - stringpos ; 
      }
      if (! stringlen )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      stringpos ++ ; 
      -- stringlen ; 
      if (prog -> regstart ) {
        unsigned char * rs = prog -> regstart ; 
        int c ; 
        BLOCK_SETUP((PUSH(rs, 0+XfOrM745_COUNT)));
#       define XfOrM748_COUNT (1+XfOrM745_COUNT)
#       define SETUP_XfOrM748(x) SETUP(XfOrM748_COUNT)

# 2924 "bc/src/regexp.c"
        while (1 ) {
#         define XfOrM751_COUNT (0+XfOrM748_COUNT)
#         define SETUP_XfOrM751(x) SETUP_XfOrM748(x)

# 2925 "bc/src/regexp.c"
          if (lazy_string ) {
#           define XfOrM752_COUNT (0+XfOrM751_COUNT)
#           define SETUP_XfOrM752(x) SETUP_XfOrM751(x)

# 2926 "bc/src/regexp.c"
            if (rw -> port && (((stringpos ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM752(_), read_more_from_regport (rw , (stringpos ) + (1 ) ) )
# 2926 "bc/src/regexp.c"
            ; 
            stringlen = rw -> input_end - stringpos ; 
            string = rw -> instr ; 
          }

          if (! stringlen )
            RET_VALUE_START (0 ) RET_VALUE_END ; 

          c = ((unsigned char ) (string [stringpos ] ) ) ; 
          if (rs [c >> 3 ] & (1 << (c & 0x7 ) ) )
            break ; 
          stringpos ++ ; 
          -- stringlen ; 
        }
      }
      rw -> input = stringpos ; 
      for (i = prog -> nsubexp ; i -- ; ) {
        startp [i ] = rw -> input_min - 1 ; 
        endp [i ] = rw -> input_min - 1 ; 
      }
    }
    else 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2954 "bc/src/regexp.c"
static void read_more_from_lazy_string (Regwork * rw , rxpos need_total ) 
{
  rx_lazy_str_t * ls = rw -> lazy_string ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(ls, 0), PUSH(rw, 1)));
# define XfOrM758_COUNT (2)
# define SETUP_XfOrM758(x) SETUP(XfOrM758_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2958 "bc/src/regexp.c"
  if (ls -> start + ls -> done < ls -> end ) {
    intptr_t amt = ls -> done , blen , tlen ; 
    char * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM758_COUNT)));
#   define XfOrM760_COUNT (1+XfOrM758_COUNT)
#   define SETUP_XfOrM760(x) SETUP(XfOrM760_COUNT)
    s = NULLED_OUT ; 

# 2962 "bc/src/regexp.c"
    amt = amt ? (2 * amt ) : 32 ; 
    if (ls -> done + amt < need_total )
      amt = need_total - ls -> done ; 
    if (ls -> start + ls -> done + amt > ls -> end )
      amt = ls -> end - ls -> start - ls -> done ; 

    blen = FUNCCALL(SETUP_XfOrM760(_), scheme_utf8_encode (ls -> chars , ls -> start + ls -> done , ls -> start + ls -> done + amt , ((void * ) 0 ) , 0 , 0 ) )

    ; 
    tlen = blen + ls -> blen ; 
    s = (char * ) FUNCCALL(SETUP_XfOrM760(_), GC_malloc_atomic (tlen ) ); 
    if (ls -> blen )
      (memcpy (s , ls -> s , ls -> blen ) ) ; 
    FUNCCALL(SETUP_XfOrM760(_), scheme_utf8_encode (ls -> chars , ls -> start + ls -> done , ls -> start + ls -> done + amt , (unsigned char * ) s , ls -> blen , 0 ) )

    ; 

    ls -> blen = tlen ; 
    ls -> s = s ; 
    ls -> done += amt ; 

    rw -> instr = s ; 
    rw -> input_end = tlen ; 
  }

# 2985 "bc/src/regexp.c"
  else {

    rw -> port = ((void * ) 0 ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2991 "bc/src/regexp.c"
static void read_more_from_regport (Regwork * rw , rxpos need_total ) 

{
  intptr_t got ; 
  Scheme_Object * peekskip ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(rw, 0), PUSH(peekskip, 1)));
# define XfOrM761_COUNT (2)
# define SETUP_XfOrM761(x) SETUP(XfOrM761_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  peekskip = NULLED_OUT ; 

# 2997 "bc/src/regexp.c"
  if (rw -> lazy_string ) {
#   define XfOrM775_COUNT (0+XfOrM761_COUNT)
#   define SETUP_XfOrM775(x) SETUP_XfOrM761(x)
    FUNCCALL(SETUP_XfOrM775(_), read_more_from_lazy_string (rw , need_total ) )
# 2998 "bc/src/regexp.c"
    ; 
    RET_NOTHING ; 
  }


  if (need_total > rw -> input_maxend ) {
    need_total = rw -> input_maxend ; 
    if (need_total <= rw -> input_end ) {
      rw -> port = ((void * ) 0 ) ; 
      RET_NOTHING ; 
    }
  }

  if (rw -> instr_size < need_total ) {
    char * naya ; 
    intptr_t size = rw -> instr_size ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM761_COUNT)));
#   define XfOrM772_COUNT (1+XfOrM761_COUNT)
#   define SETUP_XfOrM772(x) SETUP(XfOrM772_COUNT)
    naya = NULLED_OUT ; 

# 3015 "bc/src/regexp.c"
    size = size * 2 ; 
    if (size < need_total )
      size += need_total ; 
    if (size < 16 )
      size = 16 ; 

    naya = (char * ) FUNCCALL(SETUP_XfOrM772(_), GC_malloc_atomic (size ) ); 
    if (rw -> input_end )
      (memcpy (naya , rw -> instr , rw -> input_end ) ) ; 

    rw -> instr = naya ; 
    rw -> instr_size = size ; 
  }

  rw -> str = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ; 

  if (rw -> input_maxend < rw -> instr_size )
    got = rw -> input_maxend - rw -> input_end ; 
  else 
  got = rw -> instr_size - rw -> input_end ; 

  if (rw -> peekskip )
    peekskip = FUNCCALL(SETUP_XfOrM761(_), scheme_bin_plus (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (rw -> input_end ) ) ) << 1 ) | 0x1 ) ) , rw -> peekskip ) ); 
  else 
  peekskip = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (rw -> input_end ) ) ) << 1 ) | 0x1 ) ) ; 


  got = FUNCCALL(SETUP_XfOrM761(_), scheme_get_byte_string_unless ("regexp-match" , rw -> port , rw -> instr , rw -> input_end , got , (rw -> nonblock ? 2 : 1 ) , 1 , peekskip , rw -> unless_evt ) )





  ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) = rw -> str ; 

  if (got < 1 ) {

    if (! got )
      rw -> aborted = 1 ; 
    rw -> port = ((void * ) 0 ) ; 
    rw -> unless_evt = ((void * ) 0 ) ; 
  }

# 3058 "bc/src/regexp.c"
  else {
#   define XfOrM762_COUNT (0+XfOrM761_COUNT)
#   define SETUP_XfOrM762(x) SETUP_XfOrM761(x)

# 3059 "bc/src/regexp.c"
    rw -> input_end += got ; 


    while (need_total > rw -> input_end ) {
#     define XfOrM767_COUNT (0+XfOrM762_COUNT)
#     define SETUP_XfOrM767(x) SETUP_XfOrM762(x)

# 3063 "bc/src/regexp.c"
      if (rw -> peekskip )
        peekskip = FUNCCALL(SETUP_XfOrM767(_), scheme_bin_plus (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (rw -> input_end ) ) ) << 1 ) | 0x1 ) ) , rw -> peekskip ) ); 
      else 
      peekskip = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (rw -> input_end ) ) ) << 1 ) | 0x1 ) ) ; 

      rw -> str = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ; 
      got = FUNCCALL(SETUP_XfOrM767(_), scheme_get_byte_string_unless ("regexp-match" , rw -> port , rw -> instr , rw -> input_end , need_total - rw -> input_end , (rw -> nonblock ? 2 : 0 ) , 1 , peekskip , rw -> unless_evt ) )



      ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) = rw -> str ; 

      if (! got && rw -> nonblock ) {
        rw -> port = ((void * ) 0 ) ; 
        rw -> unless_evt = ((void * ) 0 ) ; 
        rw -> aborted = 1 ; 
        break ; 
      }

# 3081 "bc/src/regexp.c"
      else if (got == (- 1 ) ) {
        rw -> port = ((void * ) 0 ) ; 
        rw -> unless_evt = ((void * ) 0 ) ; 
        break ; 
      }

# 3085 "bc/src/regexp.c"
      else {
        rw -> input_end += got ; 
        if (! rw -> nonblock )
          break ; 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3097 "bc/src/regexp.c"
static int 
regtry_port (regexp * prog , Scheme_Object * port , Scheme_Object * unless_evt , int nonblock , 
rxpos * startp , rxpos * maybep , rxpos * endp , rxpos * match_stack , int * counters , 
char * * work_string , rxpos * len , rxpos * size , rxpos skip , 
Scheme_Object * maxlen , Scheme_Object * peekskip , 
rxpos origin , char * prefix , rxpos prefix_len , rxpos prefix_offset , 
int read_at_least_one , int * _aborted ) 
{
  int m ; 
  Regwork rw ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(17);
  BLOCK_SETUP_TOP((PUSH(size, 0), PUSH(work_string, 1), PUSH(port, 2), PUSH(len, 3), PUSH(rw.str, 4), PUSH(rw.instr, 5), PUSH(rw.port, 6), PUSH(rw.unless_evt, 7), PUSH(rw.startp, 8), PUSH(rw.maybep, 9), PUSH(rw.endp, 10), PUSH(rw.counters, 11), PUSH(rw.peekskip, 12), PUSH(rw.prefix, 13), PUSH(rw.lazy_string, 14), PUSH(rw.rewind_stack, 15), PUSH(_aborted, 16)));
# define XfOrM776_COUNT (17)
# define SETUP_XfOrM776(x) SETUP(XfOrM776_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rw.str = NULLED_OUT ; 
  rw.instr = NULLED_OUT ; 
  rw.port = NULLED_OUT ; 
  rw.unless_evt = NULLED_OUT ; 
  rw.startp = NULLED_OUT ; 
  rw.maybep = NULLED_OUT ; 
  rw.endp = NULLED_OUT ; 
  rw.counters = NULLED_OUT ; 
  rw.peekskip = NULLED_OUT ; 
  rw.prefix = NULLED_OUT ; 
  rw.lazy_string = NULLED_OUT ; 
  rw.rewind_stack = NULLED_OUT ; 

# 3108 "bc/src/regexp.c"
  rw . port = port ; 
  rw . unless_evt = unless_evt ; 
  rw . nonblock = (short ) nonblock ; 
  rw . aborted = 0 ; 
  rw . instr_size = * size ; 
  if (maxlen && (((intptr_t ) (maxlen ) ) & 0x1 ) )
    rw . input_maxend = (((intptr_t ) (maxlen ) ) >> 1 ) ; 
  else 
  rw . input_maxend = 0x7FFFFFFFFFFFFFFF ; 
  rw . peekskip = peekskip ; 

  m = FUNCCALL(SETUP_XfOrM776(_), regtry (prog , * work_string , skip , (* len ) - skip , ((void * ) 0 ) , startp , maybep , endp , match_stack , counters , & rw , origin , prefix , prefix_len , prefix_offset , 0 ) )

  ; 

  if (read_at_least_one 
  && ! rw . aborted 
  && (rw . input_end == skip ) 
  && rw . port ) {
#   define XfOrM778_COUNT (0+XfOrM776_COUNT)
#   define SETUP_XfOrM778(x) SETUP_XfOrM776(x)
    FUNCCALL(SETUP_XfOrM778(_), read_more_from_regport (& rw , rw . input_end + 1 ) )
# 3127 "bc/src/regexp.c"
    ; 
  }

  * work_string = rw . instr ; 
  * len = rw . input_end ; 
  * size = rw . instr_size ; 

  if (rw . aborted ) {
    * _aborted = 1 ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 3137 "bc/src/regexp.c"
  else 
  RET_VALUE_START (m ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3143 "bc/src/regexp.c"
static Scheme_Object * regmatch_k (void ) 
{
  /* No conversion */

# 3145 "bc/src/regexp.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Regwork * rw = (Regwork * ) p -> ku . k . p1 ; 
  int res ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) = rw -> str ; 

  res = regmatch (rw , p -> ku . k . i1 ) ; 

  return (res ? scheme_true : scheme_false ) ; 
}



__xform_nongcing__ static inline char INPUT_REF_S (Regwork * rw , rxpos c , rxpos input_start ) 
{
  /* No conversion */

# 3162 "bc/src/regexp.c"
  if (c < input_start )
    return rw -> prefix [rw -> prefix_delta + c ] ; 
  else 
  return rw -> instr [c ] ; 
}

__xform_nongcing__ static inline char INPUT_REF (Regwork * rw , int c ) 
{
  /* No conversion */

# 3170 "bc/src/regexp.c"
  return INPUT_REF_S (rw , c , rw -> input_start ) ; 
}

# 3183 "bc/src/regexp.c"
static int 
regmatch (Regwork * rw , rxpos prog ) 
{
  rxpos scan ; 
  rxpos is ; 
  int the_op ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(rw, 0)));
# define XfOrM782_COUNT (1)
# define SETUP_XfOrM782(x) SETUP(XfOrM782_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3191 "bc/src/regexp.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM998_COUNT (0+XfOrM782_COUNT)
#   define SETUP_XfOrM998(x) SETUP_XfOrM782(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 3193 "bc/src/regexp.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      Regwork * rw2 ; 
      Scheme_Object * res ; 
      BLOCK_SETUP((PUSH(p, 0+XfOrM998_COUNT), PUSH(res, 1+XfOrM998_COUNT), PUSH(rw2, 2+XfOrM998_COUNT)));
#     define XfOrM999_COUNT (3+XfOrM998_COUNT)
#     define SETUP_XfOrM999(x) SETUP(XfOrM999_COUNT)
      rw2 = NULLED_OUT ; 
      res = NULLED_OUT ; 

# 3200 "bc/src/regexp.c"
      rw2 = ((Regwork * ) FUNCCALL(SETUP_XfOrM999(_), GC_malloc_one_small_tagged ((((sizeof (Regwork ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      (memcpy (rw2 , rw , sizeof (Regwork ) ) ) ; 

      rw2 -> type = scheme_rt_regwork ; 


      rw2 -> str = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ; 
      p -> ku . k . p1 = rw2 ; 
      p -> ku . k . i1 = prog ; 
      res = FUNCCALL(SETUP_XfOrM999(_), scheme_handle_stack_overflow (regmatch_k ) ); 
      (
      memcpy (rw , rw2 , sizeof (Regwork ) ) ) ; 

      RET_VALUE_START ((! (((res ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
    }
  }


  if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
    char * rs ; 
    BLOCK_SETUP((PUSH(rs, 0+XfOrM782_COUNT)));
#   define XfOrM997_COUNT (1+XfOrM782_COUNT)
#   define SETUP_XfOrM997(x) SETUP(XfOrM997_COUNT)
    rs = NULLED_OUT ; 

# 3220 "bc/src/regexp.c"
    rs = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ; 
    FUNCCALL(SETUP_XfOrM997(_), scheme_out_of_fuel () ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) = rs ; 
  }

  is = rw -> input ; 
  scan = prog ; 
  while (scan != 0 ) {
#   define XfOrM890_COUNT (0+XfOrM782_COUNT)
#   define SETUP_XfOrM890(x) SETUP_XfOrM782(x)

# 3228 "bc/src/regexp.c"
    the_op = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [scan ] ) ; 
    switch (the_op ) {
#     define XfOrM891_COUNT (0+XfOrM890_COUNT)
#     define SETUP_XfOrM891(x) SETUP_XfOrM890(x)

# 3230 "bc/src/regexp.c"
      case 1 : 
      if (is != rw -> boi )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 2 : 
      if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM891(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3236 "bc/src/regexp.c"
      ; 
      if (is != rw -> input_end )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 39 : 
      if ((is != rw -> boi ) 
      && ((is <= rw -> input_min ) 
      || ((INPUT_REF (rw , is - 1 ) ) != '\n' ) ) )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 40 : 
      if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM891(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3249 "bc/src/regexp.c"
      ; 
      if (is != rw -> input_end ) {
#       define XfOrM996_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM996(x) SETUP_XfOrM891(x)

# 3251 "bc/src/regexp.c"
        if ((INPUT_REF (rw , is ) ) != '\n' )
          RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      }
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 3 : 
      if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM891(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3257 "bc/src/regexp.c"
      ; 
      if (is == rw -> input_end )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      is ++ ; 
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 4 : 
      if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM891(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3264 "bc/src/regexp.c"
      ; 
      if (is == rw -> input_end )
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      if ((INPUT_REF (rw , is ) ) == '\n' )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      is ++ ; 
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 11 : 
      {
        int len , i ; 
        rxpos opnd ; 
#       define XfOrM989_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM989(x) SETUP_XfOrM891(x)

# 3277 "bc/src/regexp.c"
        opnd = (((scan ) + 3 ) + 2 ) ; 
        len = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        if (rw -> port ) {


          rxpos input_start = rw -> input_start ; 
#         define XfOrM993_COUNT (0+XfOrM989_COUNT)
#         define SETUP_XfOrM993(x) SETUP_XfOrM989(x)

# 3283 "bc/src/regexp.c"
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM995_COUNT (0+XfOrM993_COUNT)
#           define SETUP_XfOrM995(x) SETUP_XfOrM993(x)

# 3284 "bc/src/regexp.c"
            if (rw -> port && (((is + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM995(_), read_more_from_regport (rw , (is + i ) + (1 ) ) )
# 3284 "bc/src/regexp.c"
            ; 
            if (is + i >= rw -> input_end )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + i ] != (INPUT_REF_S (rw , is + i , input_start ) ) )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }

# 3290 "bc/src/regexp.c"
        else {
          rxpos input_start ; 
#         define XfOrM990_COUNT (0+XfOrM989_COUNT)
#         define SETUP_XfOrM990(x) SETUP_XfOrM989(x)

# 3292 "bc/src/regexp.c"
          if (len > rw -> input_end - is )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          input_start = rw -> input_start ; 
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM992_COUNT (0+XfOrM990_COUNT)
#           define SETUP_XfOrM992(x) SETUP_XfOrM990(x)

# 3296 "bc/src/regexp.c"
            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + i ] != (INPUT_REF_S (rw , is + i , input_start ) ) )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        is += len ; 
      }
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 12 : 
      {
        int len , i ; 
        char c ; 
        rxpos opnd ; 
#       define XfOrM982_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM982(x) SETUP_XfOrM891(x)

# 3310 "bc/src/regexp.c"
        opnd = (((scan ) + 3 ) + 2 ) ; 
        len = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        if (rw -> port ) {
#         define XfOrM986_COUNT (0+XfOrM982_COUNT)
#         define SETUP_XfOrM986(x) SETUP_XfOrM982(x)
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM988_COUNT (0+XfOrM986_COUNT)
#           define SETUP_XfOrM988(x) SETUP_XfOrM986(x)

# 3316 "bc/src/regexp.c"
            if (rw -> port && (((is + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM988(_), read_more_from_regport (rw , (is + i ) + (1 ) ) )
# 3316 "bc/src/regexp.c"
            ; 
            if (is + i >= rw -> input_end )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            c = (INPUT_REF (rw , is + i ) ) ; 
            c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + i ] != c )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }

# 3324 "bc/src/regexp.c"
        else {
          rxpos input_start ; 
#         define XfOrM983_COUNT (0+XfOrM982_COUNT)
#         define SETUP_XfOrM983(x) SETUP_XfOrM982(x)

# 3326 "bc/src/regexp.c"
          if (len > rw -> input_end - is )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          input_start = rw -> input_start ; 
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM985_COUNT (0+XfOrM983_COUNT)
#           define SETUP_XfOrM985(x) SETUP_XfOrM983(x)

# 3330 "bc/src/regexp.c"
            c = (INPUT_REF_S (rw , is + i , input_start ) ) ; 
            c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
            if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + i ] != c )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        is += len ; 
      }
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 5 : 
      {
        int c ; 
#       define XfOrM981_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM981(x) SETUP_XfOrM891(x)

# 3343 "bc/src/regexp.c"
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM981(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3343 "bc/src/regexp.c"
        ; 
        if (is == rw -> input_end )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        c = ((unsigned char ) ((INPUT_REF (rw , is ) ) ) ) ; 
        if (! (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) + (c >> 3 ) ] & (1 << (c & 0x7 ) ) ) )
          RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
        is ++ ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 6 : 
      if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM891(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3354 "bc/src/regexp.c"
      ; 
      if (is == rw -> input_end )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      if ((INPUT_REF (rw , is ) ) != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) ] )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      is ++ ; 
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 43 : 
      if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM891(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3363 "bc/src/regexp.c"
      ; 
      if (is == rw -> input_end )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      if ((INPUT_REF (rw , is ) ) != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) ] )
        if ((INPUT_REF (rw , is ) ) != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) + 1 ] )
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      is ++ ; 
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 7 : 
      {
        int c ; 
#       define XfOrM980_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM980(x) SETUP_XfOrM891(x)

# 3375 "bc/src/regexp.c"
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM980(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3375 "bc/src/regexp.c"
        ; 
        if (is == rw -> input_end )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        c = ((unsigned char ) ((INPUT_REF (rw , is ) ) ) ) ; 
        if ((c < ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) ] ) ) ) 
        || (c > ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) + 1 ] ) ) ) )
          RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
        is ++ ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 8 : 
      {
        int c ; 
#       define XfOrM979_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM979(x) SETUP_XfOrM891(x)

# 3389 "bc/src/regexp.c"
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM979(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3389 "bc/src/regexp.c"
        ; 
        if (is == rw -> input_end )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        c = ((unsigned char ) ((INPUT_REF (rw , is ) ) ) ) ; 
        if ((c >= ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) ] ) ) ) 
        && (c <= ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [((scan ) + 3 ) + 1 ] ) ) ) )
          RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
        is ++ ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 13 : 
      scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      break ; 
      case 10 : 
      scan = scan - (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ; 
      break ; 
      case 9 : 
      {
        rxpos delta ; 
        rxpos next ; 
        int stack_pos , ok ; 
#       define XfOrM975_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM975(x) SETUP_XfOrM891(x)

# 3412 "bc/src/regexp.c"
        next = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 

        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [next ] ) != 9 )
          scan = ((scan ) + 3 ) ; 
        else {
#         define XfOrM976_COUNT (0+XfOrM975_COUNT)
#         define SETUP_XfOrM976(x) SETUP_XfOrM975(x)

# 3417 "bc/src/regexp.c"
          do {
#           define XfOrM978_COUNT (0+XfOrM976_COUNT)
#           define SETUP_XfOrM978(x) SETUP_XfOrM976(x)

# 3418 "bc/src/regexp.c"
            rw -> input = is ; 
            stack_pos = FUNCCALL(SETUP_XfOrM978(_), match_push (rw ) ); 
            ok = FUNCCALL_AGAIN(regmatch (rw , ((scan ) + 3 ) ) ); 
            FUNCCALL_AGAIN(match_pop (rw , stack_pos , ok ) ); 

            if (ok )

# 3423 "bc/src/regexp.c"
            RET_VALUE_START ((1 ) ) RET_VALUE_END ; 

            scan = next ; 
            delta = (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ; 
            if (! delta )
              break ; 
            next = scan + delta ; 
          }

# 3430 "bc/src/regexp.c"
          while ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [next ] ) == 9 ) ; 
          scan = ((scan ) + 3 ) ; 
        }
      }
      break ; 
      case 14 : 
      case 15 : 
      case 16 : 
      case 17 : 
      case 18 : 
      case 19 : 
      {
        char nextch ; 
        int no ; 
        rxpos save , body ; 
        int min , maxc ; 
        int nongreedy = (the_op == 16 || the_op == 17 || the_op == 19 ) ; 
        rxpos next ; 
        int stack_pos , ok ; 
#       define XfOrM957_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM957(x) SETUP_XfOrM891(x)



        nextch = '\0' ; 
        next = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [next ] ) == 11 )
          nextch = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [(((next ) + 3 ) + 2 ) ] ; 
        if ((the_op == 18 ) || (the_op == 19 ) ) {
          min = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
          maxc = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) + 1 ] ) ) ; 
          body = ((scan ) + 7 ) ; 
        }

# 3462 "bc/src/regexp.c"
        else {
          body = ((scan ) + 3 ) ; 
          min = ((the_op == 14 ) || (the_op == 16 ) ) ? 0 : 1 ; 
          maxc = 0 ; 
        }
        save = is ; 

        rw -> input = is ; 
        if (nongreedy && rw -> port ) {


          Scheme_Object * saveport ; 
          BLOCK_SETUP((PUSH(saveport, 0+XfOrM957_COUNT)));
#         define XfOrM972_COUNT (1+XfOrM957_COUNT)
#         define SETUP_XfOrM972(x) SETUP(XfOrM972_COUNT)
          saveport = NULLED_OUT ; 

# 3474 "bc/src/regexp.c"
          if (rw -> port && (((save ) + (min ? min : 1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM972(_), read_more_from_regport (rw , (save ) + (min ? min : 1 ) ) )
# 3474 "bc/src/regexp.c"
          ; 
          saveport = rw -> port ; 
          rw -> port = ((void * ) 0 ) ; 
          no = FUNCCALL(SETUP_XfOrM972(_), regrepeat (rw , body , maxc ) ); 
          rw -> port = saveport ; 
          nongreedy = 2 ; 
        }

# 3480 "bc/src/regexp.c"
        else 
        no = FUNCCALL(SETUP_XfOrM957(_), regrepeat (rw , body , maxc ) ); 

        if (! nongreedy ) {
#         define XfOrM967_COUNT (0+XfOrM957_COUNT)
#         define SETUP_XfOrM967(x) SETUP_XfOrM957(x)

# 3484 "bc/src/regexp.c"
          if (nextch )
            if (rw -> port && (((save + no ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM967(_), read_more_from_regport (rw , (save + no ) + (1 ) ) )
# 3485 "bc/src/regexp.c"
          ; 
          while (no >= min ) {
#           define XfOrM970_COUNT (0+XfOrM967_COUNT)
#           define SETUP_XfOrM970(x) SETUP_XfOrM967(x)

# 3488 "bc/src/regexp.c"
            if (nextch == '\0' || ((save + no < rw -> input_end ) 
            && ((INPUT_REF (rw , save + no ) ) == nextch ) ) ) {
#             define XfOrM971_COUNT (0+XfOrM970_COUNT)
#             define SETUP_XfOrM971(x) SETUP_XfOrM970(x)

# 3490 "bc/src/regexp.c"
              rw -> input = is + no ; 
              stack_pos = FUNCCALL(SETUP_XfOrM971(_), match_push (rw ) ); 
              ok = FUNCCALL_AGAIN(regmatch (rw , next ) ); 
              FUNCCALL_AGAIN(match_pop (rw , stack_pos , ok ) ); 
              if (ok )

# 3494 "bc/src/regexp.c"
              RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
            }

            no -- ; 
          }
        }

# 3499 "bc/src/regexp.c"
        else {
          int i ; 
#         define XfOrM958_COUNT (0+XfOrM957_COUNT)
#         define SETUP_XfOrM958(x) SETUP_XfOrM957(x)

# 3501 "bc/src/regexp.c"
          for (i = min ; i <= no ; i ++ ) {
#           define XfOrM963_COUNT (0+XfOrM958_COUNT)
#           define SETUP_XfOrM963(x) SETUP_XfOrM958(x)

# 3503 "bc/src/regexp.c"
            if (nextch )
              if (rw -> port && (((save + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM963(_), read_more_from_regport (rw , (save + i ) + (1 ) ) )
# 3504 "bc/src/regexp.c"
            ; 
            if (nextch == '\0' || ((save + i < rw -> input_end ) 
            && ((INPUT_REF (rw , save + i ) ) == nextch ) ) ) {
#             define XfOrM966_COUNT (0+XfOrM963_COUNT)
#             define SETUP_XfOrM966(x) SETUP_XfOrM963(x)

# 3507 "bc/src/regexp.c"
              rw -> input = save + i ; 
              stack_pos = FUNCCALL(SETUP_XfOrM966(_), match_push (rw ) ); 
              ok = FUNCCALL_AGAIN(regmatch (rw , next ) ); 
              FUNCCALL_AGAIN(match_pop (rw , stack_pos , ok ) ); 
              if (ok )

# 3511 "bc/src/regexp.c"
              RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
            }

            if ((i == no ) && (nongreedy == 2 ) ) {
#             define XfOrM964_COUNT (0+XfOrM963_COUNT)
#             define SETUP_XfOrM964(x) SETUP_XfOrM963(x)
              if ((rw -> input_end - save ) > no ) {

                int moreno ; 
                Scheme_Object * saveport ; 
                BLOCK_SETUP((PUSH(saveport, 0+XfOrM964_COUNT)));
#               define XfOrM965_COUNT (1+XfOrM964_COUNT)
#               define SETUP_XfOrM965(x) SETUP(XfOrM965_COUNT)
                saveport = NULLED_OUT ; 

# 3522 "bc/src/regexp.c"
                saveport = rw -> port ; 
                rw -> port = ((void * ) 0 ) ; 
                is = save + no ; 
                rw -> input = is ; 
                moreno = FUNCCALL(SETUP_XfOrM965(_), regrepeat (rw , body , maxc ? maxc - no : 0 ) ); 
                rw -> port = saveport ; 

                if (! moreno )
                  nongreedy = 1 ; 
                else 
                no += moreno ; 
              }
            }
          }
        }
        RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
      }
      break ; 
      case 0 : 
      case 27 : 
      rw -> input = is ; 
      RET_VALUE_START ((1 ) ) RET_VALUE_END ; 
      break ; 
      case 28 : 
      {
        int no , len , start , i ; 
#       define XfOrM950_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM950(x) SETUP_XfOrM891(x)

# 3548 "bc/src/regexp.c"
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        if (rw -> endp [no ] < rw -> input_min )
          RET_VALUE_START (0 ) RET_VALUE_END ; 

        start = rw -> startp [no ] ; 
        len = rw -> endp [no ] - start ; 

        if (rw -> port ) {


          rxpos input_start = rw -> input_start ; 
#         define XfOrM954_COUNT (0+XfOrM950_COUNT)
#         define SETUP_XfOrM954(x) SETUP_XfOrM950(x)

# 3559 "bc/src/regexp.c"
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM956_COUNT (0+XfOrM954_COUNT)
#           define SETUP_XfOrM956(x) SETUP_XfOrM954(x)

# 3560 "bc/src/regexp.c"
            if (rw -> port && (((is + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM956(_), read_more_from_regport (rw , (is + i ) + (1 ) ) )
# 3560 "bc/src/regexp.c"
            ; 
            if (is + i >= rw -> input_end )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            if ((INPUT_REF_S (rw , start + i , input_start ) ) != (INPUT_REF_S (rw , is + i , input_start ) ) )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }

# 3566 "bc/src/regexp.c"
        else {
          rxpos input_start = rw -> input_start ; 
#         define XfOrM951_COUNT (0+XfOrM950_COUNT)
#         define SETUP_XfOrM951(x) SETUP_XfOrM950(x)

# 3568 "bc/src/regexp.c"
          if (len > rw -> input_end - is )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM953_COUNT (0+XfOrM951_COUNT)
#           define SETUP_XfOrM953(x) SETUP_XfOrM951(x)

# 3571 "bc/src/regexp.c"
            if ((INPUT_REF_S (rw , start + i , input_start ) ) != (INPUT_REF_S (rw , is + i , input_start ) ) )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        is += len ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
        break ; 
      }
      case 29 : 
      {
        int no , len , start , i , c1 , c2 ; 
#       define XfOrM943_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM943(x) SETUP_XfOrM891(x)

# 3582 "bc/src/regexp.c"
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        if (rw -> endp [no ] < rw -> input_min )
          RET_VALUE_START (0 ) RET_VALUE_END ; 

        start = rw -> startp [no ] ; 
        len = rw -> endp [no ] - start ; 

        if (rw -> port ) {


          rxpos input_start = rw -> input_start ; 
#         define XfOrM947_COUNT (0+XfOrM943_COUNT)
#         define SETUP_XfOrM947(x) SETUP_XfOrM943(x)

# 3593 "bc/src/regexp.c"
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM949_COUNT (0+XfOrM947_COUNT)
#           define SETUP_XfOrM949(x) SETUP_XfOrM947(x)

# 3594 "bc/src/regexp.c"
            if (rw -> port && (((is + i ) + (1 ) ) > rw -> input_end ) )
              FUNCCALL(SETUP_XfOrM949(_), read_more_from_regport (rw , (is + i ) + (1 ) ) )
# 3594 "bc/src/regexp.c"
            ; 
            if (is + i >= rw -> input_end )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            c1 = (INPUT_REF_S (rw , start + i , input_start ) ) ; 
            c1 = (((c1 >= 'A' ) && (c1 <= 'Z' ) ) ? (c1 + ('a' - 'A' ) ) : c1 ) ; 
            c2 = (INPUT_REF_S (rw , is + i , input_start ) ) ; 
            c2 = (((c2 >= 'A' ) && (c2 <= 'Z' ) ) ? (c2 + ('a' - 'A' ) ) : c2 ) ; 
            if (c1 != c2 )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }

# 3604 "bc/src/regexp.c"
        else {
          rxpos input_start = rw -> input_start ; 
#         define XfOrM944_COUNT (0+XfOrM943_COUNT)
#         define SETUP_XfOrM944(x) SETUP_XfOrM943(x)

# 3606 "bc/src/regexp.c"
          if (len > rw -> input_end - is )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          for (i = 0 ; i < len ; i ++ ) {
#           define XfOrM946_COUNT (0+XfOrM944_COUNT)
#           define SETUP_XfOrM946(x) SETUP_XfOrM944(x)

# 3609 "bc/src/regexp.c"
            c1 = (INPUT_REF_S (rw , start + i , input_start ) ) ; 
            c1 = (((c1 >= 'A' ) && (c1 <= 'Z' ) ) ? (c1 + ('a' - 'A' ) ) : c1 ) ; 
            c2 = (INPUT_REF_S (rw , is + i , input_start ) ) ; 
            c2 = (((c2 >= 'A' ) && (c2 <= 'Z' ) ) ? (c2 + ('a' - 'A' ) ) : c2 ) ; 
            if (c1 != c2 )
              RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
        is += len ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
        break ; 
      }
      case 22 : 
      case 23 : 
      case 24 : 
      case 25 : 
      case 26 : 
      {
        int t , no , no_start , no_end ; 
        rxpos save , next ; 
        int stack_pos , ok ; 
#       define XfOrM928_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM928(x) SETUP_XfOrM891(x)

# 3630 "bc/src/regexp.c"
        next = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
        t = ((the_op != 23 ) && (the_op != 26 ) ) ; 
        if ((the_op == 25 ) || (the_op == 26 ) ) {
          no_start = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) + 1 ] ) ) ; 
          no_end = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 7 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 7 ) + 1 ] ) ) ; 
        }

# 3635 "bc/src/regexp.c"
        else 
        no_start = no_end = 0 ; 
        save = is ; 
        if (no_end ) {

          int found = 0 ; 
#         define XfOrM932_COUNT (0+XfOrM928_COUNT)
#         define SETUP_XfOrM932(x) SETUP_XfOrM928(x)

# 3641 "bc/src/regexp.c"
          for (no = no_start ; no <= no_end ; no ++ ) {
#           define XfOrM938_COUNT (0+XfOrM932_COUNT)
#           define SETUP_XfOrM938(x) SETUP_XfOrM932(x)

# 3642 "bc/src/regexp.c"
            if (is - rw -> input_min >= no ) {
#             define XfOrM939_COUNT (0+XfOrM938_COUNT)
#             define SETUP_XfOrM939(x) SETUP_XfOrM938(x)

# 3643 "bc/src/regexp.c"
              rw -> input = save - no ; 
              stack_pos = FUNCCALL(SETUP_XfOrM939(_), match_push (rw ) ); 
              ok = FUNCCALL_AGAIN(regmatch (rw , next ) ); 
              FUNCCALL_AGAIN(match_pop (rw , stack_pos , ok ) ); 
              if (ok ) {
                if (rw -> input == save ) {

                  if (! t )

# 3650 "bc/src/regexp.c"
                  RET_VALUE_START (0 ) RET_VALUE_END ; 
                  found = 1 ; 
                  break ; 
                }
              }
            }

# 3655 "bc/src/regexp.c"
            else 
            break ; 
          }
          if (! found ) {

            if (t )

# 3660 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }

# 3662 "bc/src/regexp.c"
        else {
#         define XfOrM929_COUNT (0+XfOrM928_COUNT)
#         define SETUP_XfOrM929(x) SETUP_XfOrM928(x)

# 3664 "bc/src/regexp.c"
          rw -> input = is ; 
          stack_pos = FUNCCALL(SETUP_XfOrM929(_), match_push (rw ) ); 
          ok = FUNCCALL_AGAIN(regmatch (rw , next ) ); 
          FUNCCALL_AGAIN(match_pop (rw , stack_pos , ok ) ); 
          if (ok ) {
            if (! t )

# 3669 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 3670 "bc/src/regexp.c"
          else {
            if (t )

# 3671 "bc/src/regexp.c"
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
          if (the_op == 24 )
            is = rw -> input ; 
        }
        scan = scan + ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 30 : 
      {
        int no ; 
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        rw -> counters [no ] = 0 ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 33 : 
      {
        int no ; 
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        rw -> counters [no ] -= 1 ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 34 : 
      {
        int no ; 
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        rw -> counters [no ] -= 1 ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }
      break ; 
      case 32 : 
      {
        int no , maxreps ; 
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        maxreps = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) + 1 ] ) ) ; 
        rw -> counters [no ] ++ ; 
        if (maxreps && (rw -> counters [no ] > maxreps ) )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 31 : 
      {
        int no , minreps ; 
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        minreps = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) + 1 ] ) ) ; 
        if (rw -> counters [no ] < minreps )
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 35 : 
      {
        int no , len ; 
#       define XfOrM920_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM920(x) SETUP_XfOrM891(x)

# 3728 "bc/src/regexp.c"
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        len = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) + 1 ] ) ) ; 

        if (! len || (is > rw -> maybep [no ] ) ) {
#         define XfOrM922_COUNT (0+XfOrM920_COUNT)
#         define SETUP_XfOrM922(x) SETUP_XfOrM920(x)
          FUNCCALL(SETUP_XfOrM922(_), match_set (rw , no , is - len , is ) )
# 3732 "bc/src/regexp.c"
          ; 
        }

# 3733 "bc/src/regexp.c"
        else {
#         define XfOrM921_COUNT (0+XfOrM920_COUNT)
#         define SETUP_XfOrM921(x) SETUP_XfOrM920(x)
          FUNCCALL(SETUP_XfOrM921(_), match_set (rw , no , rw -> input_min - 1 , rw -> input_min - 1 ) )
# 3734 "bc/src/regexp.c"
          ; 
        }
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 36 : 
      {
        int no ; 
#       define XfOrM919_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM919(x) SETUP_XfOrM891(x)

# 3742 "bc/src/regexp.c"
        no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        FUNCCALL(SETUP_XfOrM919(_), match_maybe (rw , no , is ) ); 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 37 : 
      {
        int c , w1 , w2 ; 
#       define XfOrM916_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM916(x) SETUP_XfOrM891(x)

# 3750 "bc/src/regexp.c"
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM916(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3750 "bc/src/regexp.c"
        ; 
        if (is > rw -> input_min ) {
#         define XfOrM918_COUNT (0+XfOrM916_COUNT)
#         define SETUP_XfOrM918(x) SETUP_XfOrM916(x)

# 3752 "bc/src/regexp.c"
          c = (INPUT_REF (rw , is - 1 ) ) ; 
          w1 = (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) || (c == '_' ) ) ; 
        }

# 3754 "bc/src/regexp.c"
        else 
        w1 = 0 ; 
        if (is < rw -> input_end ) {
#         define XfOrM917_COUNT (0+XfOrM916_COUNT)
#         define SETUP_XfOrM917(x) SETUP_XfOrM916(x)

# 3757 "bc/src/regexp.c"
          c = (INPUT_REF (rw , is ) ) ; 
          w2 = (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) || (c == '_' ) ) ; 
        }

# 3759 "bc/src/regexp.c"
        else 
        w2 = 0 ; 
        if (w1 == w2 )

# 3761 "bc/src/regexp.c"
        RET_VALUE_START (0 ) RET_VALUE_END ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 38 : 
      {
        int c , w1 , w2 ; 
#       define XfOrM913_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM913(x) SETUP_XfOrM891(x)

# 3768 "bc/src/regexp.c"
        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM913(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3768 "bc/src/regexp.c"
        ; 
        if (is > rw -> input_min ) {
#         define XfOrM915_COUNT (0+XfOrM913_COUNT)
#         define SETUP_XfOrM915(x) SETUP_XfOrM913(x)

# 3770 "bc/src/regexp.c"
          c = (INPUT_REF (rw , is - 1 ) ) ; 
          w1 = (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) || (c == '_' ) ) ; 
        }

# 3772 "bc/src/regexp.c"
        else 
        w1 = 0 ; 
        if (is < rw -> input_end ) {
#         define XfOrM914_COUNT (0+XfOrM913_COUNT)
#         define SETUP_XfOrM914(x) SETUP_XfOrM913(x)

# 3775 "bc/src/regexp.c"
          c = (INPUT_REF (rw , is ) ) ; 
          w2 = (((c >= 'a' ) && (c <= 'z' ) ) || ((c >= 'A' ) && (c <= 'Z' ) ) || ((c >= '0' ) && (c <= '9' ) ) || (c == '_' ) ) ; 
        }

# 3777 "bc/src/regexp.c"
        else 
        w2 = 0 ; 
        if (w1 != w2 )

# 3779 "bc/src/regexp.c"
        RET_VALUE_START (0 ) RET_VALUE_END ; 
        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 41 : 
      {
        unsigned char buf [6 ] ; 
        mzchar us [1 ] ; 
        int c , data ; 
        int v , pos ; 
        int negate , bottom , top ; 
#       define XfOrM901_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM901(x) SETUP_XfOrM891(x)

# 3791 "bc/src/regexp.c"
        data = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 

        negate = data >> 13 ; 
        bottom = (data >> 6 ) & 0x3F ; 
        top = data & 0x3F ; 

        if (rw -> port && (((is ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM901(_), read_more_from_regport (rw , (is ) + (1 ) ) )
# 3797 "bc/src/regexp.c"
        ; 
        if (is < rw -> input_end ) {
#         define XfOrM904_COUNT (0+XfOrM901_COUNT)
#         define SETUP_XfOrM904(x) SETUP_XfOrM901(x)

# 3799 "bc/src/regexp.c"
          c = ((unsigned char ) ((INPUT_REF (rw , is ) ) ) ) ; 
          if (c < 128 ) {
            v = c ; 
            pos = 1 ; 
          }

# 3803 "bc/src/regexp.c"
          else {
#           define XfOrM905_COUNT (0+XfOrM904_COUNT)
#           define SETUP_XfOrM905(x) SETUP_XfOrM904(x)

# 3804 "bc/src/regexp.c"
            pos = 1 ; 
            buf [0 ] = c ; 
            while (1 ) {
#             define XfOrM909_COUNT (0+XfOrM905_COUNT)
#             define SETUP_XfOrM909(x) SETUP_XfOrM905(x)

# 3807 "bc/src/regexp.c"
              v = FUNCCALL(SETUP_XfOrM909(_), scheme_utf8_decode_prefix (buf , pos , us , 0 ) ); 
              if (v == 1 ) {
                v = us [0 ] ; 
                break ; 
              }

# 3811 "bc/src/regexp.c"
              else if (v < - 1 )
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              if (rw -> port && (((is ) + (pos + 1 ) ) > rw -> input_end ) )
                FUNCCALL(SETUP_XfOrM909(_), read_more_from_regport (rw , (is ) + (pos + 1 ) ) )
# 3813 "bc/src/regexp.c"
              ; 
              if (is + pos < rw -> input_end ) {
#               define XfOrM910_COUNT (0+XfOrM909_COUNT)
#               define SETUP_XfOrM910(x) SETUP_XfOrM909(x)

# 3815 "bc/src/regexp.c"
                buf [pos ] = (INPUT_REF (rw , is + pos ) ) ; 
                pos ++ ; 
              }

# 3817 "bc/src/regexp.c"
              else 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
          }
        }

# 3821 "bc/src/regexp.c"
        else 
        RET_VALUE_START (0 ) RET_VALUE_END ; 

        is += pos ; 

        v = (((scheme_uchar_cats_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x1F ) ; 

        if (negate ) {
          if ((v >= bottom ) && (v <= top ) )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 3831 "bc/src/regexp.c"
        else {
          if ((v < bottom ) || (v > top ) )
            RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
      case 42 : 
      {
        rxpos test = ((scan ) + 7 ) ; 
        int t ; 
        int stack_pos ; 
#       define XfOrM898_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM898(x) SETUP_XfOrM891(x)

# 3845 "bc/src/regexp.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [test ] ) == 28 ) {
          int no ; 
          no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((test ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((test ) + 3 ) + 1 ] ) ) ; 
          t = (rw -> endp [no ] > rw -> input_min ) ; 
        }

# 3849 "bc/src/regexp.c"
        else {
#         define XfOrM899_COUNT (0+XfOrM898_COUNT)
#         define SETUP_XfOrM899(x) SETUP_XfOrM898(x)

# 3850 "bc/src/regexp.c"
          rw -> input = is ; 
          stack_pos = FUNCCALL(SETUP_XfOrM899(_), match_push (rw ) ); 
          t = FUNCCALL_AGAIN(regmatch (rw , test ) ); 
          FUNCCALL_AGAIN(match_pop (rw , stack_pos , t ) ); 
        }

        if (t )
          scan = scan + ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
        else 
        scan = scan + ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 5 ) + 1 ] ) ) ; 
      }
      break ; 
      default : 
      {
        int isopen ; 
        int no ; 
#       define XfOrM892_COUNT (0+XfOrM891_COUNT)
#       define SETUP_XfOrM892(x) SETUP_XfOrM891(x)

# 3867 "bc/src/regexp.c"
        switch (the_op ) {
          case 20 : 
          isopen = 1 ; 
          no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
          if (! no )
            no = - 1 ; 
          break ; 
          case 21 : 
          isopen = 0 ; 
          no = ((int ) (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) ] << 8 ) | (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [((scan ) + 3 ) + 1 ] ) ) ; 
          if (! no )
            no = - 1 ; 
          break ; 
          default : 
          if (the_op < 78 ) {
            isopen = 1 ; 
            no = the_op - 44 ; 
          }

# 3884 "bc/src/regexp.c"
          else {
            isopen = 0 ; 
            no = the_op - 78 ; 
          }
        }

        if (no < 0 ) {
        }
        else if (isopen ) {
#         define XfOrM893_COUNT (0+XfOrM892_COUNT)
#         define SETUP_XfOrM893(x) SETUP_XfOrM892(x)
          FUNCCALL(SETUP_XfOrM893(_), match_maybe (rw , no , is ) )
          ; 
        }

# 3897 "bc/src/regexp.c"
        else FUNCCALL(SETUP_XfOrM892(_), match_set (rw , no , rw -> maybep [no ] , is ) )
        ; 

        scan = (scan + (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(scan ) + 2 ] & 255 ) ) ) ; 
      }
      break ; 
    }
  }
  FUNCCALL_EMPTY(regerror ("corrupted pointers" ) )




  ; 
  RET_VALUE_START ((0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static int 
regrepeat (Regwork * rw , rxpos p , int maxc ) 
{
  int count = 0 ; 
  rxpos scan ; 
  rxpos opnd ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(rw, 0)));
# define XfOrM1000_COUNT (1)
# define SETUP_XfOrM1000(x) SETUP(XfOrM1000_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3924 "bc/src/regexp.c"
  scan = rw -> input ; 
  opnd = ((p ) + 3 ) ; 
  switch ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [p ] ) ) {
#   define XfOrM1001_COUNT (0+XfOrM1000_COUNT)
#   define SETUP_XfOrM1001(x) SETUP_XfOrM1000(x)

# 3927 "bc/src/regexp.c"
    case 3 : 
    if (rw -> port ) {
#     define XfOrM1062_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1062(x) SETUP_XfOrM1001(x)

# 3929 "bc/src/regexp.c"
      if (maxc ) {
#       define XfOrM1066_COUNT (0+XfOrM1062_COUNT)
#       define SETUP_XfOrM1066(x) SETUP_XfOrM1062(x)

# 3930 "bc/src/regexp.c"
        while (rw -> port && (rw -> input_end < scan + maxc ) ) {
#         define XfOrM1068_COUNT (0+XfOrM1066_COUNT)
#         define SETUP_XfOrM1068(x) SETUP_XfOrM1066(x)
          FUNCCALL(SETUP_XfOrM1068(_), read_more_from_regport (rw , scan + maxc ) )
# 3931 "bc/src/regexp.c"
          ; 
        }
      }

# 3933 "bc/src/regexp.c"
      else {
#       define XfOrM1063_COUNT (0+XfOrM1062_COUNT)
#       define SETUP_XfOrM1063(x) SETUP_XfOrM1062(x)

# 3935 "bc/src/regexp.c"
        while (rw -> port ) {
#         define XfOrM1065_COUNT (0+XfOrM1063_COUNT)
#         define SETUP_XfOrM1065(x) SETUP_XfOrM1063(x)
          FUNCCALL(SETUP_XfOrM1065(_), read_more_from_regport (rw , rw -> input_end + 4096 ) )
# 3936 "bc/src/regexp.c"
          ; 
        }
      }
    }
    count = rw -> input_end - scan ; 
    if (maxc && (count > maxc ) )
      count = maxc ; 
    scan += count ; 
    break ; 
    case 4 : 
    {
      rxpos input_start = rw -> input_start ; 
#     define XfOrM1057_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1057(x) SETUP_XfOrM1001(x)

# 3948 "bc/src/regexp.c"
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM1057(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 3948 "bc/src/regexp.c"
      ; 
      while (scan != rw -> input_end 
      && ((INPUT_REF_S (rw , scan , input_start ) ) != '\n' ) ) {
        count ++ ; 
        scan ++ ; 
#       define XfOrM1060_COUNT (0+XfOrM1057_COUNT)
#       define SETUP_XfOrM1060(x) SETUP_XfOrM1057(x)

# 3953 "bc/src/regexp.c"
        if (maxc ) {

# 3953 "bc/src/regexp.c"
          maxc -- ; 

# 3953 "bc/src/regexp.c"
          if (! maxc )

# 3953 "bc/src/regexp.c"
          break ; 
        }

# 3954 "bc/src/regexp.c"
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1060(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 3954 "bc/src/regexp.c"
        ; 
      }
    }
    break ; 
    case 11 : 
    {
      rxpos input_start = rw -> input_start ; 
      rxpos opnd2 = (opnd + 2 ) ; 
#     define XfOrM1052_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1052(x) SETUP_XfOrM1001(x)

# 3962 "bc/src/regexp.c"
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM1052(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 3962 "bc/src/regexp.c"
      ; 
      while (scan != rw -> input_end 
      && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd2 ] == (INPUT_REF_S (rw , scan , input_start ) ) ) ) {
        count ++ ; 
        scan ++ ; 
#       define XfOrM1055_COUNT (0+XfOrM1052_COUNT)
#       define SETUP_XfOrM1055(x) SETUP_XfOrM1052(x)

# 3967 "bc/src/regexp.c"
        if (maxc ) {

# 3967 "bc/src/regexp.c"
          maxc -- ; 

# 3967 "bc/src/regexp.c"
          if (! maxc )

# 3967 "bc/src/regexp.c"
          break ; 
        }

# 3968 "bc/src/regexp.c"
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1055(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 3968 "bc/src/regexp.c"
        ; 
      }
    }
    break ; 
    case 12 : 
    {
      char c ; 
      rxpos input_start = rw -> input_start ; 
      rxpos opnd2 = (opnd + 2 ) ; 
#     define XfOrM1047_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1047(x) SETUP_XfOrM1001(x)

# 3977 "bc/src/regexp.c"
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM1047(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 3977 "bc/src/regexp.c"
      ; 
      while (scan != rw -> input_end ) {
#       define XfOrM1050_COUNT (0+XfOrM1047_COUNT)
#       define SETUP_XfOrM1050(x) SETUP_XfOrM1047(x)

# 3979 "bc/src/regexp.c"
        c = (INPUT_REF_S (rw , scan , input_start ) ) ; 
        c = (((c >= 'A' ) && (c <= 'Z' ) ) ? (c + ('a' - 'A' ) ) : c ) ; 
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd2 ] != c )
          break ; 
        count ++ ; 
        scan ++ ; 
        if (maxc ) {

# 3985 "bc/src/regexp.c"
          maxc -- ; 

# 3985 "bc/src/regexp.c"
          if (! maxc )

# 3985 "bc/src/regexp.c"
          break ; 
        }

# 3986 "bc/src/regexp.c"
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1050(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 3986 "bc/src/regexp.c"
        ; 
      }
    }
    break ; 
    case 5 : 
    {
      int c ; 
      rxpos input_start = rw -> input_start ; 
      rxpos init = scan ; 
#     define XfOrM1038_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1038(x) SETUP_XfOrM1001(x)

# 3995 "bc/src/regexp.c"
      if (rw -> port || maxc ) {
#       define XfOrM1042_COUNT (0+XfOrM1038_COUNT)
#       define SETUP_XfOrM1042(x) SETUP_XfOrM1038(x)

# 3997 "bc/src/regexp.c"
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1042(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 3997 "bc/src/regexp.c"
        ; 
        while (scan != rw -> input_end ) {
#         define XfOrM1045_COUNT (0+XfOrM1042_COUNT)
#         define SETUP_XfOrM1045(x) SETUP_XfOrM1042(x)

# 3999 "bc/src/regexp.c"
          c = ((unsigned char ) ((INPUT_REF_S (rw , scan , input_start ) ) ) ) ; 
          if (! (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + (c >> 3 ) ] & (1 << (c & 0x7 ) ) ) )
            break ; 
          scan ++ ; 
          if (maxc ) {

# 4003 "bc/src/regexp.c"
            maxc -- ; 

# 4003 "bc/src/regexp.c"
            if (! maxc )

# 4003 "bc/src/regexp.c"
            break ; 
          }

# 4004 "bc/src/regexp.c"
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM1045(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4004 "bc/src/regexp.c"
          ; 
        }
      }

# 4006 "bc/src/regexp.c"
      else {

        int e = rw -> input_end ; 
#       define XfOrM1039_COUNT (0+XfOrM1038_COUNT)
#       define SETUP_XfOrM1039(x) SETUP_XfOrM1038(x)

# 4009 "bc/src/regexp.c"
        while (scan != e ) {
#         define XfOrM1041_COUNT (0+XfOrM1039_COUNT)
#         define SETUP_XfOrM1041(x) SETUP_XfOrM1039(x)

# 4010 "bc/src/regexp.c"
          c = ((unsigned char ) ((INPUT_REF_S (rw , scan , input_start ) ) ) ) ; 
          if (! (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + (c >> 3 ) ] & (1 << (c & 0x7 ) ) ) )
            break ; 
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    case 6 : 
    {
      rxpos init = scan ; 
      rxpos input_start = rw -> input_start ; 
      char c ; 
#     define XfOrM1029_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1029(x) SETUP_XfOrM1001(x)

# 4024 "bc/src/regexp.c"
      c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ] ; 
      if (rw -> port || maxc ) {
#       define XfOrM1033_COUNT (0+XfOrM1029_COUNT)
#       define SETUP_XfOrM1033(x) SETUP_XfOrM1029(x)

# 4027 "bc/src/regexp.c"
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1033(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4027 "bc/src/regexp.c"
        ; 
        while ((scan != rw -> input_end ) 
        && ((INPUT_REF_S (rw , scan , input_start ) ) == c ) ) {
          scan ++ ; 
#         define XfOrM1036_COUNT (0+XfOrM1033_COUNT)
#         define SETUP_XfOrM1036(x) SETUP_XfOrM1033(x)

# 4031 "bc/src/regexp.c"
          if (maxc ) {

# 4031 "bc/src/regexp.c"
            maxc -- ; 

# 4031 "bc/src/regexp.c"
            if (! maxc )

# 4031 "bc/src/regexp.c"
            break ; 
          }

# 4032 "bc/src/regexp.c"
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM1036(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4032 "bc/src/regexp.c"
          ; 
        }
      }

# 4034 "bc/src/regexp.c"
      else {

        int e = rw -> input_end ; 
#       define XfOrM1030_COUNT (0+XfOrM1029_COUNT)
#       define SETUP_XfOrM1030(x) SETUP_XfOrM1029(x)

# 4037 "bc/src/regexp.c"
        while ((scan != e ) 
        && ((INPUT_REF (rw , scan ) ) == c ) ) {
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    case 43 : 
    {
      rxpos init = scan ; 
      rxpos input_start = rw -> input_start ; 
      char c1 , c2 ; 
#     define XfOrM1020_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1020(x) SETUP_XfOrM1001(x)

# 4050 "bc/src/regexp.c"
      c1 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ] ; 
      c2 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + 1 ] ; 
      if (rw -> port || maxc ) {
#       define XfOrM1024_COUNT (0+XfOrM1020_COUNT)
#       define SETUP_XfOrM1024(x) SETUP_XfOrM1020(x)

# 4054 "bc/src/regexp.c"
        if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
          FUNCCALL(SETUP_XfOrM1024(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4054 "bc/src/regexp.c"
        ; 
        while ((scan != rw -> input_end ) 
        && (((INPUT_REF_S (rw , scan , input_start ) ) == c1 ) 
        || ((INPUT_REF_S (rw , scan , input_start ) ) == c2 ) ) ) {
          scan ++ ; 
#         define XfOrM1027_COUNT (0+XfOrM1024_COUNT)
#         define SETUP_XfOrM1027(x) SETUP_XfOrM1024(x)

# 4059 "bc/src/regexp.c"
          if (maxc ) {

# 4059 "bc/src/regexp.c"
            maxc -- ; 

# 4059 "bc/src/regexp.c"
            if (! maxc )

# 4059 "bc/src/regexp.c"
            break ; 
          }

# 4060 "bc/src/regexp.c"
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM1027(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4060 "bc/src/regexp.c"
          ; 
        }
      }

# 4062 "bc/src/regexp.c"
      else {

        int e = rw -> input_end ; 
#       define XfOrM1021_COUNT (0+XfOrM1020_COUNT)
#       define SETUP_XfOrM1021(x) SETUP_XfOrM1020(x)

# 4065 "bc/src/regexp.c"
        while ((scan != e ) 
        && (((INPUT_REF (rw , scan ) ) == c1 ) 
        || ((INPUT_REF (rw , scan ) ) == c2 ) ) ) {
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    case 7 : 
    {
      rxpos init = scan ; 
      rxpos input_start = rw -> input_start ; 
      int c , sr , er ; 
#     define XfOrM1011_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1011(x) SETUP_XfOrM1001(x)

# 4079 "bc/src/regexp.c"
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM1011(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4079 "bc/src/regexp.c"
      ; 
      sr = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ] ) ) ; 
      er = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + 1 ] ) ) ; 
      if (rw -> port || maxc ) {
#       define XfOrM1015_COUNT (0+XfOrM1011_COUNT)
#       define SETUP_XfOrM1015(x) SETUP_XfOrM1011(x)

# 4084 "bc/src/regexp.c"
        while (scan != rw -> input_end ) {
#         define XfOrM1018_COUNT (0+XfOrM1015_COUNT)
#         define SETUP_XfOrM1018(x) SETUP_XfOrM1015(x)

# 4085 "bc/src/regexp.c"
          c = ((unsigned char ) ((INPUT_REF_S (rw , scan , input_start ) ) ) ) ; 
          if ((c < sr ) || (c > er ) )
            break ; 
          scan ++ ; 
          if (maxc ) {

# 4089 "bc/src/regexp.c"
            maxc -- ; 

# 4089 "bc/src/regexp.c"
            if (! maxc )

# 4089 "bc/src/regexp.c"
            break ; 
          }

# 4090 "bc/src/regexp.c"
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM1018(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4090 "bc/src/regexp.c"
          ; 
        }
      }

# 4092 "bc/src/regexp.c"
      else {

        int e = rw -> input_end ; 
#       define XfOrM1012_COUNT (0+XfOrM1011_COUNT)
#       define SETUP_XfOrM1012(x) SETUP_XfOrM1011(x)

# 4095 "bc/src/regexp.c"
        while (scan != e ) {
#         define XfOrM1014_COUNT (0+XfOrM1012_COUNT)
#         define SETUP_XfOrM1014(x) SETUP_XfOrM1012(x)

# 4096 "bc/src/regexp.c"
          c = ((unsigned char ) ((INPUT_REF (rw , scan ) ) ) ) ; 
          if ((c < sr ) || (c > er ) )
            break ; 
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    case 8 : 
    {
      rxpos input_start = rw -> input_start ; 
      rxpos init = scan ; 
      int c , sr , er ; 
#     define XfOrM1002_COUNT (0+XfOrM1001_COUNT)
#     define SETUP_XfOrM1002(x) SETUP_XfOrM1001(x)

# 4110 "bc/src/regexp.c"
      if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
        FUNCCALL(SETUP_XfOrM1002(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4110 "bc/src/regexp.c"
      ; 
      sr = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd ] ) ) ; 
      er = ((unsigned char ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [opnd + 1 ] ) ) ; 
      if (rw -> port || maxc ) {
#       define XfOrM1006_COUNT (0+XfOrM1002_COUNT)
#       define SETUP_XfOrM1006(x) SETUP_XfOrM1002(x)

# 4115 "bc/src/regexp.c"
        while (scan != rw -> input_end ) {
#         define XfOrM1009_COUNT (0+XfOrM1006_COUNT)
#         define SETUP_XfOrM1009(x) SETUP_XfOrM1006(x)

# 4116 "bc/src/regexp.c"
          c = ((unsigned char ) ((INPUT_REF_S (rw , scan , input_start ) ) ) ) ; 
          if ((c >= sr ) && (c <= er ) )
            break ; 
          scan ++ ; 
          if (maxc ) {

# 4120 "bc/src/regexp.c"
            maxc -- ; 

# 4120 "bc/src/regexp.c"
            if (! maxc )

# 4120 "bc/src/regexp.c"
            break ; 
          }

# 4121 "bc/src/regexp.c"
          if (rw -> port && (((scan ) + (1 ) ) > rw -> input_end ) )
            FUNCCALL(SETUP_XfOrM1009(_), read_more_from_regport (rw , (scan ) + (1 ) ) )
# 4121 "bc/src/regexp.c"
          ; 
        }
      }

# 4123 "bc/src/regexp.c"
      else {

        int e = rw -> input_end ; 
#       define XfOrM1003_COUNT (0+XfOrM1002_COUNT)
#       define SETUP_XfOrM1003(x) SETUP_XfOrM1002(x)

# 4126 "bc/src/regexp.c"
        while (scan != e ) {
#         define XfOrM1005_COUNT (0+XfOrM1003_COUNT)
#         define SETUP_XfOrM1005(x) SETUP_XfOrM1003(x)

# 4127 "bc/src/regexp.c"
          c = ((unsigned char ) ((INPUT_REF_S (rw , scan , input_start ) ) ) ) ; 
          if ((c >= sr ) && (c <= er ) )
            break ; 
          scan ++ ; 
        }
      }
      count = scan - init ; 
    }
    break ; 
    default : FUNCCALL(SETUP_XfOrM1001(_), regerror ("internal foulup" ) )
    ; 
    count = 0 ; 
    break ; 
  }
  rw -> input = scan ; 

  RET_VALUE_START ((count ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static rxpos 
regnext (rxpos p ) 
{
  /* No conversion */

# 4152 "bc/src/regexp.c"
  int offset ; 

  if (p + 2 >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regcodesize_ ) )
    return 0 ; 

  offset = (((((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(p ) + 1 ] & 255 ) << 8 ) + (((unsigned char * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) [(p ) + 2 ] & 255 ) ) ; 
  if (offset == 0 )
    return 0 ; 

  if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) [p ] ) == 10 )
    return (p - offset ) ; 
  else 
  return (p + offset ) ; 
}






static int 
regstrcspn (char * s1 , char * e1 , char * s2 ) 
{
  /* No conversion */

# 4175 "bc/src/regexp.c"
  char * scan1 ; 
  char * scan2 ; 
  int count ; 

  count = 0 ; 
  for (scan1 = s1 ; scan1 != e1 ; scan1 ++ ) {
    for (scan2 = s2 ; * scan2 != '\0' ; ) {
      if (* scan1 == * scan2 ++ )
        return (count ) ; 
    }
    count ++ ; 
  }
  return (count ) ; 
}


extern char * strncpy () ; 





static 
char * regsub (regexp * prog , char * src , int sourcelen , intptr_t * lenout , char * insrc , 
rxpos * startp , rxpos * endp , rxpos minpos , 
char * prefix , rxpos prefix_offset ) 
{
  char * dest ; 
  char c ; 
  intptr_t no ; 
  intptr_t len ; 
  intptr_t destalloc , destlen , srcpos ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(prefix, 0), PUSH(startp, 1), PUSH(dest, 2), PUSH(src, 3), PUSH(lenout, 4), PUSH(insrc, 5), PUSH(prog, 6), PUSH(endp, 7)));
# define XfOrM1077_COUNT (8)
# define SETUP_XfOrM1077(x) SETUP(XfOrM1077_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  dest = NULLED_OUT ; 

# 4208 "bc/src/regexp.c"
  destalloc = 2 * sourcelen ; 
  destlen = 0 ; 
  dest = (char * ) FUNCCALL(SETUP_XfOrM1077(_), GC_malloc_atomic (destalloc + 1 ) ); 

  srcpos = 0 ; 
  while (srcpos < sourcelen ) {
#   define XfOrM1090_COUNT (0+XfOrM1077_COUNT)
#   define SETUP_XfOrM1090(x) SETUP_XfOrM1077(x)

# 4214 "bc/src/regexp.c"
    c = src [srcpos ++ ] ; 
    if (c == '&' )
      no = 0 ; 
    else if (c == '\\' ) {
      if (src [srcpos ] == '\\' || src [srcpos ] == '&' )
        no = - 1 ; 
      else if (src [srcpos ] == '$' ) {
        no = prog -> nsubexp + 1 ; 
        srcpos ++ ; 
      }

# 4223 "bc/src/regexp.c"
      else {
        no = 0 ; 
        while ('0' <= src [srcpos ] && src [srcpos ] <= '9' ) {
          no = (no * 10 ) + (src [srcpos ++ ] - '0' ) ; 
        }
      }
    }

# 4229 "bc/src/regexp.c"
    else 
    no = - 1 ; 


    if (no < 0 ) {
#     define XfOrM1095_COUNT (0+XfOrM1090_COUNT)
#     define SETUP_XfOrM1095(x) SETUP_XfOrM1090(x)

# 4234 "bc/src/regexp.c"
      if (c == '\\' && (src [srcpos ] == '\\' || src [srcpos ] == '&' ) )
        c = src [srcpos ++ ] ; 
      if (destlen + 1 >= destalloc ) {
        char * old = dest ; 
        destalloc *= 2 ; 
        BLOCK_SETUP((PUSH(old, 0+XfOrM1095_COUNT)));
#       define XfOrM1096_COUNT (1+XfOrM1095_COUNT)
#       define SETUP_XfOrM1096(x) SETUP(XfOrM1096_COUNT)

# 4239 "bc/src/regexp.c"
        dest = (char * ) FUNCCALL(SETUP_XfOrM1096(_), GC_malloc_atomic (destalloc + 1 ) ); 
        (memcpy (dest , old , destlen ) ) ; 
      }
      dest [destlen ++ ] = c ; 
    }

# 4243 "bc/src/regexp.c"
    else if (no >= prog -> nsubexp ) {
    }
    else if ((startp [no ] >= minpos ) && (endp [no ] >= minpos ) ) {
#     define XfOrM1091_COUNT (0+XfOrM1090_COUNT)
#     define SETUP_XfOrM1091(x) SETUP_XfOrM1090(x)

# 4246 "bc/src/regexp.c"
      len = endp [no ] - startp [no ] ; 
      if (len + destlen >= destalloc ) {
        char * old = dest ; 
        BLOCK_SETUP((PUSH(old, 0+XfOrM1091_COUNT)));
#       define XfOrM1093_COUNT (1+XfOrM1091_COUNT)
#       define SETUP_XfOrM1093(x) SETUP(XfOrM1093_COUNT)

# 4249 "bc/src/regexp.c"
        destalloc = 2 * destalloc + len + destlen ; 
        dest = (char * ) FUNCCALL(SETUP_XfOrM1093(_), GC_malloc_atomic (destalloc + 1 ) ); 
        (memcpy (dest , old , destlen ) ) ; 
      }
      if (startp [no ] >= 0 )
        (memcpy (dest + destlen , insrc + startp [no ] , len ) ) ; 
      else if (endp [no ] <= 0 )
        (memcpy (dest + destlen , prefix + prefix_offset + (startp [no ] - minpos ) , len ) ) ; 
      else {
        intptr_t pre_len = 0 - startp [no ] ; 
#       define XfOrM1092_COUNT (0+XfOrM1091_COUNT)
#       define SETUP_XfOrM1092(x) SETUP_XfOrM1091(x)
        (
# 4259 "bc/src/regexp.c"
        memcpy (dest + destlen , prefix + prefix_offset + (startp [no ] - minpos ) , pre_len ) ) ; 
        (memcpy (dest + destlen + pre_len , insrc , len - pre_len ) ) ; 
      }
      destlen += len ; 
    }
  }
  dest [destlen ] = '\0' ; 

  if (lenout )
    * lenout = destlen ; 

  RET_VALUE_START (dest ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4289 "bc/src/regexp.c"
static int compare_ranges (const void * a , const void * b ) 
{
  /* No conversion */

# 4291 "bc/src/regexp.c"
  unsigned int av , bv ; 
  av = * (unsigned int * ) a ; 
  bv = * (unsigned int * ) b ; 
  if (av == bv )
    return 0 ; 
  else if (av < bv )
    return - 1 ; 
  else 
  return 1 ; 
}




typedef struct {
  int i ; 
  int orig_len ; 
  int size ; 
}

# 4309 "bc/src/regexp.c"
RoomState ; 

static unsigned char * make_room (unsigned char * r , int j , int need_extra , RoomState * rs ) 
{
  int nrs ; 
  unsigned char * nr ; 
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(nr, 1), PUSH(rs, 2)));
# define XfOrM1103_COUNT (3)
# define SETUP_XfOrM1103(x) SETUP(XfOrM1103_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  nr = NULLED_OUT ; 

# 4316 "bc/src/regexp.c"
  if ((rs -> size - j - (rs -> orig_len - rs -> i ) ) < need_extra ) {
#   define XfOrM1104_COUNT (0+XfOrM1103_COUNT)
#   define SETUP_XfOrM1104(x) SETUP_XfOrM1103(x)

# 4317 "bc/src/regexp.c"
    nrs = ((rs -> size ) * 2 ) + need_extra ; 
    nr = (unsigned char * ) FUNCCALL(SETUP_XfOrM1104(_), GC_malloc_atomic (nrs + 1 ) ); 
    (memcpy (nr , r , j ) ) ; 
    r = nr ; 
    rs -> size = nrs ; 
  }

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4327 "bc/src/regexp.c"
static unsigned char * add_byte_range (const unsigned char * lo , const unsigned char * hi , int count , 
unsigned char * r , int * _j , RoomState * rs , 

int did_alt , 

int wrap_alts ) 


{
  int same_chars , j , i ; 
  const unsigned char * lowest = (unsigned char * ) "\200\200\200\200\200" ; 
  const unsigned char * highest = (unsigned char * ) "\277\277\277\277\277" ; 
  unsigned char p , q ; 
  DECL_RET_SAVE (unsigned char * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(lowest, 0), PUSH(_j, 1), PUSH(rs, 2), PUSH(r, 3), PUSH(lo, 4), PUSH(hi, 5), PUSH(highest, 6)));
# define XfOrM1105_COUNT (7)
# define SETUP_XfOrM1105(x) SETUP(XfOrM1105_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4342 "bc/src/regexp.c"
  for (same_chars = 0 ; same_chars < count ; same_chars ++ ) {
    if (lo [same_chars ] != hi [same_chars ] )
      break ; 
  }

  j = * _j ; 


  if (same_chars ) {
#   define XfOrM1123_COUNT (0+XfOrM1105_COUNT)
#   define SETUP_XfOrM1123(x) SETUP_XfOrM1105(x)

# 4351 "bc/src/regexp.c"
    r = FUNCCALL(SETUP_XfOrM1123(_), make_room (r , j , 4 + same_chars , rs ) ); 
    if (! did_alt ) {
      r [j ++ ] = '|' ; 
      did_alt = 1 ; 
    }
    for (i = 0 ; i < same_chars ; i ++ ) {
      r [j ++ ] = lo [i ] ; 
    }
  }

  if (same_chars < count ) {



    int choices = 0 ; 
#   define XfOrM1106_COUNT (0+XfOrM1105_COUNT)
#   define SETUP_XfOrM1106(x) SETUP_XfOrM1105(x)

    for (i = same_chars + 1 ; i < count ; i ++ ) {
      if (lo [i ] != 128 )
        break ; 
    }
    if (i == count )
      p = lo [same_chars ] ; 
    else {
      p = lo [same_chars ] + 1 ; 
      choices ++ ; 
    }



    for (i = same_chars + 1 ; i < count ; i ++ ) {
      if (hi [i ] != 191 )
        break ; 
    }
    if (i == count )
      q = hi [same_chars ] ; 
    else {
      q = hi [same_chars ] - 1 ; 
      choices ++ ; 
    }

    if (p <= q )
      choices ++ ; 

    if ((wrap_alts || same_chars ) && (choices > 1 ) ) {
#     define XfOrM1115_COUNT (0+XfOrM1106_COUNT)
#     define SETUP_XfOrM1115(x) SETUP_XfOrM1106(x)

# 4397 "bc/src/regexp.c"
      r = FUNCCALL(SETUP_XfOrM1115(_), make_room (r , j , 4 , rs ) ); 
      if (! did_alt ) {
        r [j ++ ] = '|' ; 
        did_alt = 1 ; 
      }
      r [j ++ ] = '(' ; 
      r [j ++ ] = '?' ; 
      r [j ++ ] = ':' ; 
    }


    if (p > lo [same_chars ] ) {
#     define XfOrM1114_COUNT (0+XfOrM1106_COUNT)
#     define SETUP_XfOrM1114(x) SETUP_XfOrM1106(x)

# 4409 "bc/src/regexp.c"
      r = FUNCCALL(SETUP_XfOrM1114(_), make_room (r , j , 2 , rs ) ); 
      if (! did_alt )
        r [j ++ ] = '|' ; 
      r [j ++ ] = lo [same_chars ] ; 
      * _j = j ; 
      r = FUNCCALL(SETUP_XfOrM1114(_), add_byte_range (lo XFORM_OK_PLUS same_chars + 1 , highest , count - same_chars - 1 , r , _j , rs , 1 , 1 ) )
      ; 
      j = * _j ; 
      p = lo [same_chars ] + 1 ; 
      did_alt = 0 ; 
    }


    if (q < hi [same_chars ] ) {
#     define XfOrM1113_COUNT (0+XfOrM1106_COUNT)
#     define SETUP_XfOrM1113(x) SETUP_XfOrM1106(x)

# 4423 "bc/src/regexp.c"
      r = FUNCCALL(SETUP_XfOrM1113(_), make_room (r , j , 2 , rs ) ); 
      if (! did_alt )
        r [j ++ ] = '|' ; 
      r [j ++ ] = hi [same_chars ] ; 
      * _j = j ; 
      r = FUNCCALL(SETUP_XfOrM1113(_), add_byte_range (lowest , hi XFORM_OK_PLUS same_chars + 1 , count - same_chars - 1 , r , _j , rs , 1 , 1 ) )
      ; 
      j = * _j ; 
      did_alt = 0 ; 

      q = hi [same_chars ] - 1 ; 
    }


    if (p <= q ) {


      const char * any_str = "[\200-\277]" ; 
      const int any_len = 5 ; 
      BLOCK_SETUP((PUSH(any_str, 0+XfOrM1106_COUNT)));
#     define XfOrM1108_COUNT (1+XfOrM1106_COUNT)
#     define SETUP_XfOrM1108(x) SETUP(XfOrM1108_COUNT)

# 4443 "bc/src/regexp.c"
      r = FUNCCALL(SETUP_XfOrM1108(_), make_room (r , j , 6 + ((count - same_chars - 1 ) * any_len ) , rs ) ); 
      if (! did_alt )
        r [j ++ ] = '|' ; 

      if (p == q ) {
        r [j ++ ] = p ; 
      }

# 4449 "bc/src/regexp.c"
      else {
        r [j ++ ] = '[' ; 
        r [j ++ ] = p ; 
        r [j ++ ] = '-' ; 
        r [j ++ ] = q ; 
        r [j ++ ] = ']' ; 
      }
      for (i = same_chars + 1 ; i < count ; i ++ ) {
#       define XfOrM1110_COUNT (0+XfOrM1108_COUNT)
#       define SETUP_XfOrM1110(x) SETUP_XfOrM1108(x)
        (
# 4457 "bc/src/regexp.c"
        memcpy (r + j , any_str , any_len ) ) ; 
        j += any_len ; 
      }
    }

    if ((wrap_alts || same_chars ) && (choices > 1 ) ) {
#     define XfOrM1107_COUNT (0+XfOrM1106_COUNT)
#     define SETUP_XfOrM1107(x) SETUP_XfOrM1106(x)

# 4464 "bc/src/regexp.c"
      r = FUNCCALL(SETUP_XfOrM1107(_), make_room (r , j , 1 , rs ) ); 
      r [j ++ ] = ')' ; 
    }
  }

  * _j = j ; 
  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4473 "bc/src/regexp.c"
static unsigned char * add_range (unsigned char * r , int * _j , RoomState * rs , 
unsigned int start , unsigned int end , int did_alt ) 
{
  unsigned int top ; 
  int count ; 
  unsigned char lo [6 ] , hi [6 ] ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(_j, 1), PUSH(rs, 2)));
# define XfOrM1129_COUNT (3)
# define SETUP_XfOrM1129(x) SETUP(XfOrM1129_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4482 "bc/src/regexp.c"
  if (start <= 0x7FF ) {
    top = 0x7FF ; 
    count = 2 ; 
  }

# 4485 "bc/src/regexp.c"
  else if (start <= 0xFFFF ) {
    top = 0xFFFF ; 
    count = 3 ; 
  }

# 4488 "bc/src/regexp.c"
  else if (start <= 0x1FFFFF ) {
    top = 0x1FFFFF ; 
    count = 4 ; 
  }

# 4491 "bc/src/regexp.c"
  else if (start <= 0x3FFFFFF ) {
    top = 0x3FFFFFF ; 
    count = 5 ; 
  }

# 4494 "bc/src/regexp.c"
  else {
    top = 0x7FFFFFFF ; 
    count = 6 ; 
  }

  if (end > top ) {
#   define XfOrM1130_COUNT (0+XfOrM1129_COUNT)
#   define SETUP_XfOrM1130(x) SETUP_XfOrM1129(x)

# 4500 "bc/src/regexp.c"
    r = FUNCCALL(SETUP_XfOrM1130(_), add_range (r , _j , rs , top + 1 , end , did_alt ) ); 
    end = top ; 
    did_alt = 0 ; 
  }
  FUNCCALL(SETUP_XfOrM1129(_), scheme_utf8_encode_all (& start , 1 , lo ) )
# 4522 "bc/src/regexp.c"
  ; 
  FUNCCALL(SETUP_XfOrM1129(_), scheme_utf8_encode_all (& end , 1 , hi ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(add_byte_range (lo , hi , count , r , _j , rs , did_alt , 0 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4528 "bc/src/regexp.c"
static int need_ci_alternates (unsigned char * s , int delta , int len ) 
{
  /* No conversion */

# 4530 "bc/src/regexp.c"
  mzchar us [1 ] , c ; 

  scheme_utf8_decode (s , delta , len , us , 0 , 1 , ((void * ) 0 ) , 0 , 0 ) ; 
  c = us [0 ] ; 

  return ((c != (c + scheme_uchar_ups [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ) 
  || (c != (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ) 
  || (c != (c + scheme_uchar_folds [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ) 
  || (c != (c + scheme_uchar_titles [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ) ) ; 
}

static int translate (unsigned char * s , int len , char * * result , int pcre ) 
{
  int j , parse_flags = 0x1 | 0x4 ; 
  RoomState rs ; 
  unsigned char * r ; 
  Scheme_Object * parse_params = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg169 = NULLED_OUT ; 
  Scheme_Object * __funcarg168 = NULLED_OUT ; 
  Scheme_Object * __funcarg167 = NULLED_OUT ; 
  Scheme_Object * __funcarg166 = NULLED_OUT ; 
  Scheme_Object * __funcarg165 = NULLED_OUT ; 
  Scheme_Object * __funcarg164 = NULLED_OUT ; 
  Scheme_Object * __funcarg154 = NULLED_OUT ; 
  Scheme_Object * __funcarg153 = NULLED_OUT ; 
  Scheme_Object * __funcarg152 = NULLED_OUT ; 
  Scheme_Object * __funcarg151 = NULLED_OUT ; 
  Scheme_Object * __funcarg150 = NULLED_OUT ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  Scheme_Object * __funcarg121 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(__funcarg165, 0), PUSH(result, 1), PUSH(r, 2), PUSH(__funcarg168, 3), PUSH(parse_params, 4), PUSH(__funcarg150, 5), PUSH(__funcarg153, 6), PUSH(s, 7)));
# define XfOrM1137_COUNT (8)
# define SETUP_XfOrM1137(x) SETUP(XfOrM1137_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  r = NULLED_OUT ; 

# 4548 "bc/src/regexp.c"
  rs . orig_len = len ; 
  rs . size = len ; 

  r = (unsigned char * ) FUNCCALL(SETUP_XfOrM1137(_), GC_malloc_atomic (rs . size + 1 ) ); 





  for (rs . i = j = 0 ; rs . i < len ; ) {
#   define XfOrM1382_COUNT (0+XfOrM1137_COUNT)
#   define SETUP_XfOrM1382(x) SETUP_XfOrM1137(x)

# 4558 "bc/src/regexp.c"
    if (s [rs . i ] == '[' ) {
      int k = rs . i + 1 , saw_big = 0 ; 
      int not_mode = 0 ; 
#     define XfOrM1448_COUNT (0+XfOrM1382_COUNT)
#     define SETUP_XfOrM1448(x) SETUP_XfOrM1382(x)



      if ((k < len ) && (s [k ] == '^' ) ) {
        not_mode = 1 ; 
        k ++ ; 
      }

      if ((k < len ) && (s [k ] == ']' ) )
        k ++ ; 
      while ((k < len ) && (s [k ] != ']' ) ) {
#       define XfOrM1620_COUNT (0+XfOrM1448_COUNT)
#       define SETUP_XfOrM1620(x) SETUP_XfOrM1448(x)

# 4574 "bc/src/regexp.c"
        if (s [k ] > 127 )
          saw_big = 1 ; 
        else if (pcre && (s [k ] == '\\' ) && (k + 1 < len ) ) {
          if ((s [k + 1 ] == 'D' ) || (s [k + 1 ] == 'W' ) || (s [k + 1 ] == 'S' ) )
            saw_big = 1 ; 
          k ++ ; 
        }

# 4580 "bc/src/regexp.c"
        else if (pcre 
        && (s [k ] == '[' ) 
        && (k + 1 < len ) 
        && (s [k + 1 ] == ':' ) 
        && FUNCCALL(SETUP_XfOrM1620(_), is_posix_char_class ((char * ) s , k + 1 , len , ((void * ) 0 ) ) )) {
          while (s [k ] != ']' ) {
            k ++ ; 
          }
        }
        k ++ ; 
      }
      if ((k >= len ) || (! saw_big && ! not_mode ) ) {

        while (rs . i <= k ) {
          r [j ++ ] = s [rs . i ++ ] ; 
        }
      }

# 4596 "bc/src/regexp.c"
      else {

        char * simple_on ; 
        int non_ascii = 0 ; 
        Scheme_Object * ranges ; 
        unsigned int * us , * range_array ; 
        int ulen , on_count , range_len , rp , p ; 
        BLOCK_SETUP((PUSH(simple_on, 0+XfOrM1448_COUNT), PUSH(range_array, 1+XfOrM1448_COUNT), PUSH(us, 2+XfOrM1448_COUNT), PUSH(ranges, 3+XfOrM1448_COUNT)));
#       define XfOrM1449_COUNT (4+XfOrM1448_COUNT)
#       define SETUP_XfOrM1449(x) SETUP(XfOrM1449_COUNT)
        simple_on = NULLED_OUT ; 
        ranges = NULLED_OUT ; 
        us = NULLED_OUT ; 
        range_array = NULLED_OUT ; 

# 4604 "bc/src/regexp.c"
        ulen = FUNCCALL(SETUP_XfOrM1449(_), scheme_utf8_decode (s , rs . i + 1 , k , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) ); 
        us = (unsigned int * ) FUNCCALL(SETUP_XfOrM1449(_), GC_malloc_atomic (ulen * sizeof (unsigned int ) ) ); 
        FUNCCALL(SETUP_XfOrM1449(_), scheme_utf8_decode (s , rs . i + 1 , k , us , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) ); 




        simple_on = (char * ) FUNCCALL(SETUP_XfOrM1449(_), GC_malloc_atomic (128 ) ); 
        (memset (simple_on , 0 , 128 ) ) ; 

        ranges = scheme_null ; 

        p = 0 ; 
        if (not_mode )
          p ++ ; 
        if (us [p ] == '-' ) {
          simple_on ['-' ] = 1 ; 
          p ++ ; 
        }

        while (p < ulen ) {
#         define XfOrM1550_COUNT (0+XfOrM1449_COUNT)
#         define SETUP_XfOrM1550(x) SETUP_XfOrM1449(x)

# 4625 "bc/src/regexp.c"
          if (((p + 2 ) < ulen ) 
          && us [p + 1 ] == '-' 
          && (! pcre || ((us [p ] != '\\' ) && (us [p + 2 ] != '\\' ) ) ) ) {
            int beg = us [p ] , end = us [p + 2 ] ; 
#           define XfOrM1571_COUNT (0+XfOrM1550_COUNT)
#           define SETUP_XfOrM1571(x) SETUP_XfOrM1550(x)

# 4629 "bc/src/regexp.c"
            if (end == '-' ) {
#             define XfOrM1609_COUNT (0+XfOrM1571_COUNT)
#             define SETUP_XfOrM1609(x) SETUP_XfOrM1571(x)

# 4630 "bc/src/regexp.c"
              {
#               define XfOrM1610_COUNT (0+XfOrM1609_COUNT)
#               define SETUP_XfOrM1610(x) SETUP_XfOrM1609(x)
                FUNCCALL(SETUP_XfOrM1610(_), regcomperror ("misplaced hyphen within square brackets in pattern" ) )
# 4630 "bc/src/regexp.c"
                ; 

# 4630 "bc/src/regexp.c"
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }

# 4630 "bc/src/regexp.c"
              ; 
            }
            if (end < beg ) {
#             define XfOrM1607_COUNT (0+XfOrM1571_COUNT)
#             define SETUP_XfOrM1607(x) SETUP_XfOrM1571(x)

# 4634 "bc/src/regexp.c"
              {
#               define XfOrM1608_COUNT (0+XfOrM1607_COUNT)
#               define SETUP_XfOrM1608(x) SETUP_XfOrM1607(x)
                FUNCCALL(SETUP_XfOrM1608(_), regcomperror ("invalid range within square brackets in pattern" ) )
# 4634 "bc/src/regexp.c"
                ; 

# 4634 "bc/src/regexp.c"
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }

# 4634 "bc/src/regexp.c"
              ; 
            }

            if ((beg > 127 ) || (end > 127 ) ) {
#             define XfOrM1575_COUNT (0+XfOrM1571_COUNT)
#             define SETUP_XfOrM1575(x) SETUP_XfOrM1571(x)

# 4639 "bc/src/regexp.c"
              ranges = (__funcarg167 = (__funcarg168 = FUNCCALL(SETUP_XfOrM1575(_), scheme_make_integer_value_from_unsigned (beg ) ), __funcarg169 = FUNCCALL(SETUP_XfOrM1575(_), scheme_make_integer_value_from_unsigned (end ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg168 , __funcarg169 ) )) 
              , FUNCCALL_AGAIN(scheme_make_pair (__funcarg167 , ranges ) )) 
              ; 
              if (! (parse_flags & 0x1 ) ) {




                int c , beg2 , end2 , c2 , mode ; 
#               define XfOrM1576_COUNT (0+XfOrM1575_COUNT)
#               define SETUP_XfOrM1576(x) SETUP_XfOrM1575(x)

# 4648 "bc/src/regexp.c"
                for (mode = 0 ; mode < 4 ; mode ++ ) {
#                 define XfOrM1592_COUNT (0+XfOrM1576_COUNT)
#                 define SETUP_XfOrM1592(x) SETUP_XfOrM1576(x)

# 4649 "bc/src/regexp.c"
                  for (c = beg ; c <= end ; c ++ ) {
#                   define XfOrM1600_COUNT (0+XfOrM1592_COUNT)
#                   define SETUP_XfOrM1600(x) SETUP_XfOrM1592(x)

# 4650 "bc/src/regexp.c"
                    switch (mode ) {
                      case 0 : 
                      beg2 = (c + scheme_uchar_folds [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                      break ; 
                      case 1 : 
                      beg2 = (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                      break ; 
                      case 2 : 
                      beg2 = (c + scheme_uchar_ups [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                      break ; 
                      case 3 : 
                      default : 
                      beg2 = (c + scheme_uchar_titles [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                      break ; 
                    }
                    if (c != beg2 ) {
#                     define XfOrM1601_COUNT (0+XfOrM1600_COUNT)
#                     define SETUP_XfOrM1601(x) SETUP_XfOrM1600(x)

# 4666 "bc/src/regexp.c"
                      end2 = beg2 ; 
                      for (; c <= end ; c ++ ) {
                        switch (mode ) {
                          case 0 : 
                          c2 = (c + scheme_uchar_folds [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                          break ; 
                          case 1 : 
                          c2 = (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                          break ; 
                          case 2 : 
                          c2 = (c + scheme_uchar_ups [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                          break ; 
                          case 3 : 
                          default : 
                          c2 = (c + scheme_uchar_titles [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                          break ; 
                        }
                        if ((c2 == c ) || (c2 != end2 + 1 ) )
                          break ; 
                      }
                      ranges = (__funcarg164 = (__funcarg165 = FUNCCALL(SETUP_XfOrM1601(_), scheme_make_integer_value_from_unsigned (beg2 ) ), __funcarg166 = FUNCCALL(SETUP_XfOrM1601(_), scheme_make_integer_value_from_unsigned (end2 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg165 , __funcarg166 ) )) 
                      , FUNCCALL_AGAIN(scheme_make_pair (__funcarg164 , ranges ) )) 
                      ; 
                    }
                  }
                }
              }
            }

# 4693 "bc/src/regexp.c"
            else {

              int w ; 
              for (w = beg ; w <= end ; w ++ ) {
                simple_on [w ] = 1 ; 
              }
            }
            p += 3 ; 
          }

# 4701 "bc/src/regexp.c"
          else if (pcre && (us [p ] == '\\' ) ) {
#           define XfOrM1565_COUNT (0+XfOrM1550_COUNT)
#           define SETUP_XfOrM1565(x) SETUP_XfOrM1550(x)

# 4702 "bc/src/regexp.c"
            if ((p + 1 ) < ulen ) {
              int c = us [p + 1 ] ; 
#             define XfOrM1567_COUNT (0+XfOrM1565_COUNT)
#             define SETUP_XfOrM1567(x) SETUP_XfOrM1565(x)

# 4704 "bc/src/regexp.c"
              if (((c >= 'a' ) && (c <= 'z' ) ) 
              || ((c >= 'A' ) && (c <= 'Z' ) ) ) {
#               define XfOrM1570_COUNT (0+XfOrM1567_COUNT)
#               define SETUP_XfOrM1570(x) SETUP_XfOrM1567(x)
                FUNCCALL(SETUP_XfOrM1570(_), regcharclass (c , simple_on , & non_ascii ) )
# 4706 "bc/src/regexp.c"
                ; 
                p += 2 ; 
              }

# 4708 "bc/src/regexp.c"
              else if (c < 128 ) {
                simple_on [c ] = 1 ; 
                p += 2 ; 
              }

# 4711 "bc/src/regexp.c"
              else {


                p ++ ; 
              }
            }

# 4716 "bc/src/regexp.c"
            else 
            {
#             define XfOrM1566_COUNT (0+XfOrM1565_COUNT)
#             define SETUP_XfOrM1566(x) SETUP_XfOrM1565(x)
              FUNCCALL(SETUP_XfOrM1566(_), regcomperror ("trailing \\ in pattern" ) )
# 4717 "bc/src/regexp.c"
              ; 

# 4717 "bc/src/regexp.c"
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }

# 4717 "bc/src/regexp.c"
            ; 
          }

# 4718 "bc/src/regexp.c"
          else if (us [p ] > 127 ) {
            int c = us [p ] ; 
#           define XfOrM1557_COUNT (0+XfOrM1550_COUNT)
#           define SETUP_XfOrM1557(x) SETUP_XfOrM1550(x)

# 4720 "bc/src/regexp.c"
            ranges = (__funcarg152 = (__funcarg153 = FUNCCALL(SETUP_XfOrM1557(_), scheme_make_integer_value_from_unsigned (c ) ), __funcarg154 = FUNCCALL(SETUP_XfOrM1557(_), scheme_make_integer_value_from_unsigned (c ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg153 , __funcarg154 ) )) 
            , FUNCCALL_AGAIN(scheme_make_pair (__funcarg152 , ranges ) )) 
            ; 
            if (! (parse_flags & 0x1 ) ) {
              int mode , c2 ; 
#             define XfOrM1558_COUNT (0+XfOrM1557_COUNT)
#             define SETUP_XfOrM1558(x) SETUP_XfOrM1557(x)

# 4725 "bc/src/regexp.c"
              for (mode = 0 ; mode < 4 ; mode ++ ) {
#               define XfOrM1562_COUNT (0+XfOrM1558_COUNT)
#               define SETUP_XfOrM1562(x) SETUP_XfOrM1558(x)

# 4726 "bc/src/regexp.c"
                switch (mode ) {
                  case 0 : 
                  c2 = (c + scheme_uchar_folds [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                  break ; 
                  case 1 : 
                  c2 = (c + scheme_uchar_downs [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                  break ; 
                  case 2 : 
                  c2 = (c + scheme_uchar_ups [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                  break ; 
                  case 3 : 
                  default : 
                  c2 = (c + scheme_uchar_titles [(scheme_uchar_cases_table [(c >> 8 ) & 0x1FFF ] [c & 0xFF ] ) ] ) ; 
                  break ; 
                }
                if (c2 != c ) {
#                 define XfOrM1563_COUNT (0+XfOrM1562_COUNT)
#                 define SETUP_XfOrM1563(x) SETUP_XfOrM1562(x)

# 4742 "bc/src/regexp.c"
                  ranges = (__funcarg149 = (__funcarg150 = FUNCCALL(SETUP_XfOrM1563(_), scheme_make_integer_value_from_unsigned (c2 ) ), __funcarg151 = FUNCCALL(SETUP_XfOrM1563(_), scheme_make_integer_value_from_unsigned (c2 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg150 , __funcarg151 ) )) 
                  , FUNCCALL_AGAIN(scheme_make_pair (__funcarg149 , ranges ) )) 
                  ; 
                }
              }
            }
            p ++ ; 
          }

# 4749 "bc/src/regexp.c"
          else if (pcre 
          && (us [p ] == '[' ) 
          && ((p + 1 ) < ulen ) 
          && (us [p + 1 ] == ':' ) 
          && FUNCCALL(SETUP_XfOrM1550(_), is_posix_char_class_in_unicode (us , p + 1 , ulen , simple_on ) )) {
            while (us [p ] != ']' ) {
              p ++ ; 
            }
            p ++ ; 
          }

# 4758 "bc/src/regexp.c"
          else {
#           define XfOrM1551_COUNT (0+XfOrM1550_COUNT)
#           define SETUP_XfOrM1551(x) SETUP_XfOrM1550(x)

# 4759 "bc/src/regexp.c"
            if (((p + 1 ) < ulen ) && (us [p ] == '-' ) ) {
#             define XfOrM1552_COUNT (0+XfOrM1551_COUNT)
#             define SETUP_XfOrM1552(x) SETUP_XfOrM1551(x)

# 4760 "bc/src/regexp.c"
              {
#               define XfOrM1553_COUNT (0+XfOrM1552_COUNT)
#               define SETUP_XfOrM1553(x) SETUP_XfOrM1552(x)
                FUNCCALL(SETUP_XfOrM1553(_), regcomperror ("misplaced hyphen within square brackets in pattern" ) )
# 4760 "bc/src/regexp.c"
                ; 

# 4760 "bc/src/regexp.c"
                RET_VALUE_START (0 ) RET_VALUE_END ; 
              }

# 4760 "bc/src/regexp.c"
              ; 
              RET_VALUE_START (0 ) RET_VALUE_END ; 
            }
            simple_on [us [p ] ] = 1 ; 
            p ++ ; 
          }
        }

        if (non_ascii ) {
#         define XfOrM1488_COUNT (0+XfOrM1449_COUNT)
#         define SETUP_XfOrM1488(x) SETUP_XfOrM1449(x)

# 4770 "bc/src/regexp.c"
          ranges = (__funcarg121 = FUNCCALL(SETUP_XfOrM1488(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (128 ) ) ) << 1 ) | 0x1 ) ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0x10FFFF ) ) ) << 1 ) | 0x1 ) ) ) )
          , FUNCCALL_AGAIN(scheme_make_pair (__funcarg121 , scheme_null ) )) 
          ; 
        }


        range_len = (scheme_list_length (ranges ) ) ; 
        range_array = (unsigned int * ) FUNCCALL(SETUP_XfOrM1449(_), GC_malloc_atomic (2 * range_len * sizeof (unsigned int ) ) ); 
        for (rp = 0 ; ((Scheme_Type ) (((((intptr_t ) (ranges ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ranges ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ranges = (((Scheme_Simple_Object * ) (ranges ) ) -> u . pair_val . cdr ) , rp += 2 ) {
          uintptr_t hi , lo ; 
#         define XfOrM1487_COUNT (0+XfOrM1449_COUNT)
#         define SETUP_XfOrM1487(x) SETUP_XfOrM1449(x)
          (
# 4780 "bc/src/regexp.c"
          scheme_get_unsigned_int_val (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (ranges ) ) -> u . pair_val . car ) ) ) -> u . pair_val . car ) ) , & lo ) ) ; 
          (scheme_get_unsigned_int_val ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (ranges ) ) -> u . pair_val . car ) ) ) -> u . pair_val . cdr ) , & hi ) ) ; 
          range_array [rp ] = (unsigned int ) lo ; 
          range_array [rp + 1 ] = (unsigned int ) hi ; 
        }
        range_len *= 2 ; 
        FUNCCALL(SETUP_XfOrM1449(_), qsort (range_array , range_len >> 1 , 2 * sizeof (unsigned int ) , compare_ranges ) )
        ; 


        for (rp = 0 ; rp < range_len ; rp += 2 ) {
          if (range_array [rp ] < 128 ) {
            for (p = range_array [rp ] ; p < 128 ; p ++ ) {
              simple_on [p ] = 1 ; 
            }
            range_array [rp ] = 128 ; 
          }
        }

        if (! (parse_flags & 0x1 ) ) {
          for (p = 'a' ; p <= 'z' ; p ++ ) {
            if (simple_on [p ] )
              simple_on [(((p >= 'a' ) && (p <= 'z' ) ) ? (p - ('a' - 'A' ) ) : p ) ] = 1 ; 
            if (simple_on [(((p >= 'a' ) && (p <= 'z' ) ) ? (p - ('a' - 'A' ) ) : p ) ] )
              simple_on [p ] = 1 ; 
          }
        }


        on_count = 0 ; 
        for (p = 0 ; p < 128 ; p ++ ) {
          if (simple_on [p ] )
            on_count ++ ; 
        }

        if (not_mode ) {


          unsigned int last_end ; 
          int did_alt ; 
#         define XfOrM1459_COUNT (0+XfOrM1449_COUNT)
#         define SETUP_XfOrM1459(x) SETUP_XfOrM1449(x)

# 4820 "bc/src/regexp.c"
          r = FUNCCALL(SETUP_XfOrM1459(_), make_room (r , j , 6 + (128 - on_count ) + ((pcre && ! simple_on ['\\' ] ) ? 1 : 0 ) , & rs ) ); 
          r [j ++ ] = '(' ; 
          r [j ++ ] = '?' ; 
          r [j ++ ] = ':' ; 
          if (on_count < 128 ) {
            if (! on_count ) {
              r [j ++ ] = '[' ; 
              r [j ++ ] = 0 ; 
              r [j ++ ] = '-' ; 
              r [j ++ ] = 127 ; 
              r [j ++ ] = ']' ; 
            }

# 4831 "bc/src/regexp.c"
            else {
              r [j ++ ] = '[' ; 
              if (! simple_on [']' ] )
                r [j ++ ] = ']' ; 
              for (p = 0 ; p < 128 ; p ++ ) {
                if ((p != '-' ) && (p != ']' ) && (! pcre || (p != '\\' ) ) )
                  if (! simple_on [p ] )
                  r [j ++ ] = p ; 
              }
              if (pcre && ! simple_on ['\\' ] ) {
                r [j ++ ] = '\\' ; 
                r [j ++ ] = '\\' ; 
              }
              if (! simple_on ['-' ] )
                r [j ++ ] = '-' ; 
              r [j ++ ] = ']' ; 
            }
            did_alt = 0 ; 
          }

# 4849 "bc/src/regexp.c"
          else 
          did_alt = 1 ; 
          last_end = 128 ; 
          for (rp = 0 ; rp < range_len ; rp += 2 ) {
#           define XfOrM1465_COUNT (0+XfOrM1459_COUNT)
#           define SETUP_XfOrM1465(x) SETUP_XfOrM1459(x)

# 4853 "bc/src/regexp.c"
            if (range_array [rp ] > last_end ) {
#             define XfOrM1466_COUNT (0+XfOrM1465_COUNT)
#             define SETUP_XfOrM1466(x) SETUP_XfOrM1465(x)

# 4854 "bc/src/regexp.c"
              r = FUNCCALL(SETUP_XfOrM1466(_), add_range (r , & j , & rs , last_end , range_array [rp ] - 1 , did_alt ) ); 
              did_alt = 0 ; 
            }
            if ((range_array [rp + 1 ] + 1 ) > last_end )
              last_end = range_array [rp + 1 ] + 1 ; 
          }
          if (last_end <= 0x10FFFF ) {
#           define XfOrM1460_COUNT (0+XfOrM1459_COUNT)
#           define SETUP_XfOrM1460(x) SETUP_XfOrM1459(x)

# 4861 "bc/src/regexp.c"
            if (last_end < 0xD800 ) {
#             define XfOrM1462_COUNT (0+XfOrM1460_COUNT)
#             define SETUP_XfOrM1462(x) SETUP_XfOrM1460(x)

# 4862 "bc/src/regexp.c"
              r = FUNCCALL(SETUP_XfOrM1462(_), add_range (r , & j , & rs , last_end , 0xD7FF , did_alt ) ); 
              did_alt = 0 ; 
              r = FUNCCALL(SETUP_XfOrM1462(_), add_range (r , & j , & rs , 0xE000 , 0x10FFFF , did_alt ) ); 
            }

# 4865 "bc/src/regexp.c"
            else {
#             define XfOrM1461_COUNT (0+XfOrM1460_COUNT)
#             define SETUP_XfOrM1461(x) SETUP_XfOrM1460(x)

# 4866 "bc/src/regexp.c"
              r = FUNCCALL(SETUP_XfOrM1461(_), add_range (r , & j , & rs , last_end , 0x10FFFF , did_alt ) ); 
              did_alt = 0 ; 
            }
          }
          r = FUNCCALL(SETUP_XfOrM1459(_), make_room (r , j , 1 , & rs ) ); 
          r [j ++ ] = ')' ; 
        }

# 4872 "bc/src/regexp.c"
        else {


          int p , did_alt ; 
#         define XfOrM1450_COUNT (0+XfOrM1449_COUNT)
#         define SETUP_XfOrM1450(x) SETUP_XfOrM1449(x)

# 4876 "bc/src/regexp.c"
          r = FUNCCALL(SETUP_XfOrM1450(_), make_room (r , j , 5 + on_count + ((pcre && simple_on ['\\' ] ) ? 1 : 0 ) , & rs ) ); 
          r [j ++ ] = '(' ; 
          r [j ++ ] = '?' ; 
          r [j ++ ] = ':' ; 
          if (on_count ) {
            if (on_count == 128 ) {
              r [j ++ ] = '[' ; 
              r [j ++ ] = 0 ; 
              r [j ++ ] = '-' ; 
              r [j ++ ] = 127 ; 
              r [j ++ ] = ']' ; 
            }

# 4887 "bc/src/regexp.c"
            else {
              r [j ++ ] = '[' ; 
              if (simple_on [']' ] )
                r [j ++ ] = ']' ; 
              for (p = 0 ; p < 128 ; p ++ ) {
                if ((p != '-' ) && (p != ']' ) && (! pcre || (p != '\\' ) ) )
                  if (simple_on [p ] )
                  r [j ++ ] = p ; 
              }
              if (pcre && simple_on ['\\' ] ) {
                r [j ++ ] = '\\' ; 
                r [j ++ ] = '\\' ; 
              }
              if (simple_on ['-' ] )
                r [j ++ ] = '-' ; 
              r [j ++ ] = ']' ; 
            }
            did_alt = 0 ; 
          }

# 4905 "bc/src/regexp.c"
          else 
          did_alt = 1 ; 
          for (rp = 0 ; rp < range_len ; rp += 2 ) {
#           define XfOrM1452_COUNT (0+XfOrM1450_COUNT)
#           define SETUP_XfOrM1452(x) SETUP_XfOrM1450(x)

# 4908 "bc/src/regexp.c"
            r = FUNCCALL(SETUP_XfOrM1452(_), add_range (r , & j , & rs , range_array [rp ] , range_array [rp + 1 ] , did_alt ) ); 
            did_alt = 0 ; 
          }
          r = FUNCCALL(SETUP_XfOrM1450(_), make_room (r , j , 1 , & rs ) ); 
          r [j ++ ] = ')' ; 
        }
      }
      rs . i = k + 1 ; 
    }

# 4916 "bc/src/regexp.c"
    else if (s [rs . i ] == '\\' ) {
#     define XfOrM1433_COUNT (0+XfOrM1382_COUNT)
#     define SETUP_XfOrM1433(x) SETUP_XfOrM1382(x)

# 4917 "bc/src/regexp.c"
      if (pcre 
      && (rs . i + 1 < len ) 
      && ((s [rs . i + 1 ] == 'D' ) 
      || (s [rs . i + 1 ] == 'W' ) 
      || (s [rs . i + 1 ] == 'S' ) ) ) {

        char * simple_on ; 
        int non_ascii ; 
        int n ; 
        BLOCK_SETUP((PUSH(simple_on, 0+XfOrM1433_COUNT)));
#       define XfOrM1438_COUNT (1+XfOrM1433_COUNT)
#       define SETUP_XfOrM1438(x) SETUP(XfOrM1438_COUNT)
        simple_on = NULLED_OUT ; 

# 4927 "bc/src/regexp.c"
        simple_on = (char * ) FUNCCALL(SETUP_XfOrM1438(_), GC_malloc_atomic (128 ) ); 
        (memset (simple_on , 0 , 128 ) ) ; 

        rs . i ++ ; 
        FUNCCALL(SETUP_XfOrM1438(_), regcharclass (s [rs . i ++ ] , simple_on , & non_ascii ) ); 

        r = FUNCCALL_AGAIN(make_room (r , j , 4 , & rs ) ); 
        r [j ++ ] = '(' ; 
        r [j ++ ] = '?' ; 
        r [j ++ ] = ':' ; 
        r [j ++ ] = '[' ; 

        for (n = 0 ; n < 128 ; ) {
#         define XfOrM1444_COUNT (0+XfOrM1438_COUNT)
#         define SETUP_XfOrM1444(x) SETUP_XfOrM1438(x)

# 4940 "bc/src/regexp.c"
          if (simple_on [n ] ) {
            int m ; 
#           define XfOrM1445_COUNT (0+XfOrM1444_COUNT)
#           define SETUP_XfOrM1445(x) SETUP_XfOrM1444(x)

# 4942 "bc/src/regexp.c"
            for (m = n + 1 ; (m < 128 ) && simple_on [m ] ; m ++ ) {
            }
            r = FUNCCALL(SETUP_XfOrM1445(_), make_room (r , j , 3 , & rs ) ); 
            r [j ++ ] = n ; 
            r [j ++ ] = '-' ; 
            r [j ++ ] = m - 1 ; 
            n = m ; 
          }

# 4949 "bc/src/regexp.c"
          else 
          n ++ ; 
        }
        r = FUNCCALL(SETUP_XfOrM1438(_), make_room (r , j , 1 , & rs ) ); 
        r [j ++ ] = ']' ; 

        if (non_ascii ) {
#         define XfOrM1439_COUNT (0+XfOrM1438_COUNT)
#         define SETUP_XfOrM1439(x) SETUP_XfOrM1438(x)

# 4956 "bc/src/regexp.c"
          r = FUNCCALL(SETUP_XfOrM1439(_), add_range (r , & j , & rs , 128 , 0x10FFFF , 0 ) ); 
          r = FUNCCALL(SETUP_XfOrM1439(_), make_room (r , j , 1 , & rs ) ); 
        }
        r [j ++ ] = ')' ; 
      }

# 4960 "bc/src/regexp.c"
      else {

        r [j ++ ] = s [rs . i ++ ] ; 
        if ((rs . i < len ) 
        && (s [rs . i ] > 127 ) ) {
          r [j ++ ] = s [rs . i ++ ] ; 
          while ((rs . i < len ) && ((s [rs . i ] & 0xC0 ) == 0x80 ) ) {
            r [j ++ ] = s [rs . i ++ ] ; 
          }
        }

# 4969 "bc/src/regexp.c"
        else 
        r [j ++ ] = s [rs . i ++ ] ; 
      }
    }

# 4972 "bc/src/regexp.c"
    else if ((s [rs . i ] == '.' ) 
    && (! pcre 
    || (rs . i < 3 ) 
    || (s [rs . i - 1 ] != '{' ) 
    || ((s [rs . i - 2 ] == 'p' ) 
    && (s [rs . i - 2 ] == 'P' ) ) 
    || (s [rs . i - 3 ] != '\\' ) ) ) {
#     define XfOrM1431_COUNT (0+XfOrM1382_COUNT)
#     define SETUP_XfOrM1431(x) SETUP_XfOrM1382(x)

# 4980 "bc/src/regexp.c"
      r = FUNCCALL(SETUP_XfOrM1431(_), make_room (r , j , (parse_flags & 0x4 ) ? 9 : 8 , & rs ) ); 
      r [j ++ ] = '(' ; 
      r [j ++ ] = '?' ; 
      r [j ++ ] = ':' ; 
      r [j ++ ] = '[' ; 
      r [j ++ ] = '\00' ; 
      r [j ++ ] = '-' ; 
      if (! (parse_flags & 0x4 ) ) {
        r [j ++ ] = '\n' - 1 ; 
        r [j ++ ] = '\n' + 1 ; 
        r [j ++ ] = '-' ; 
      }
      r [j ++ ] = '\177' ; 
      r [j ++ ] = ']' ; 
      r = FUNCCALL(SETUP_XfOrM1431(_), add_range (r , & j , & rs , 128 , 0xD7FF , 0 ) ); 
      r = FUNCCALL_AGAIN(add_range (r , & j , & rs , 0xE000 , 0x10FFFF , 0 ) ); 
      r = FUNCCALL_AGAIN(make_room (r , j , 1 , & rs ) ); 
      r [j ++ ] = ')' ; 
      rs . i ++ ; 
    }

# 4999 "bc/src/regexp.c"
    else if (s [rs . i ] > 127 ) {
      int k = rs . i + 1 ; 
#     define XfOrM1407_COUNT (0+XfOrM1382_COUNT)
#     define SETUP_XfOrM1407(x) SETUP_XfOrM1382(x)

# 5002 "bc/src/regexp.c"
      while ((k < len ) && ((s [k ] & 0xC0 ) == 0x80 ) ) {
        k ++ ; 
      }
      if ((k < len ) && ((s [k ] == '+' ) 
      || (s [k ] == '*' ) 
      || (s [k ] == '?' ) 
      || (! (parse_flags & 0x1 ) 
      && FUNCCALL(SETUP_XfOrM1407(_), need_ci_alternates (s , rs . i , k ) )) ) ) {

        int orig_i ; 
#       define XfOrM1411_COUNT (0+XfOrM1407_COUNT)
#       define SETUP_XfOrM1411(x) SETUP_XfOrM1407(x)

# 5012 "bc/src/regexp.c"
        r = FUNCCALL(SETUP_XfOrM1411(_), make_room (r , j , 4 , & rs ) ); 
        r [j ++ ] = '(' ; 
        r [j ++ ] = '?' ; 
        r [j ++ ] = ':' ; 
        orig_i = rs . i ; 
        while (rs . i < k ) {
          r [j ++ ] = s [rs . i ++ ] ; 
        }
        if (! (parse_flags & 0x1 ) ) {

          mzchar us [1 ] , c0 , c1 , wrote [4 ] ; 
          int clen , ci , num_wrote = 1 , mode ; 
          unsigned char s2 [6 ] ; 
#         define XfOrM1412_COUNT (0+XfOrM1411_COUNT)
#         define SETUP_XfOrM1412(x) SETUP_XfOrM1411(x)
          FUNCCALL(SETUP_XfOrM1412(_), scheme_utf8_decode (s , orig_i , k , us , 0 , 1 , ((void * ) 0 ) , 0 , 0 ) )
# 5026 "bc/src/regexp.c"
          ; 
          c0 = us [0 ] ; 
          wrote [0 ] = c0 ; 
          for (mode = 0 ; mode < 4 ; mode ++ ) {
#           define XfOrM1420_COUNT (0+XfOrM1412_COUNT)
#           define SETUP_XfOrM1420(x) SETUP_XfOrM1412(x)

# 5030 "bc/src/regexp.c"
            switch (mode ) {
              case 0 : 
              c1 = (c0 + scheme_uchar_folds [(scheme_uchar_cases_table [(c0 >> 8 ) & 0x1FFF ] [c0 & 0xFF ] ) ] ) ; 
              break ; 
              case 1 : 
              c1 = (c0 + scheme_uchar_downs [(scheme_uchar_cases_table [(c0 >> 8 ) & 0x1FFF ] [c0 & 0xFF ] ) ] ) ; 
              break ; 
              case 2 : 
              c1 = (c0 + scheme_uchar_ups [(scheme_uchar_cases_table [(c0 >> 8 ) & 0x1FFF ] [c0 & 0xFF ] ) ] ) ; 
              break ; 
              case 3 : 
              default : 
              c1 = (c0 + scheme_uchar_titles [(scheme_uchar_cases_table [(c0 >> 8 ) & 0x1FFF ] [c0 & 0xFF ] ) ] ) ; 
              break ; 
            }
            for (ci = 0 ; ci < num_wrote ; ci ++ ) {
              if (c1 == wrote [ci ] )
                break ; 
            }
            if (ci >= num_wrote ) {
#             define XfOrM1421_COUNT (0+XfOrM1420_COUNT)
#             define SETUP_XfOrM1421(x) SETUP_XfOrM1420(x)

# 5050 "bc/src/regexp.c"
              wrote [num_wrote ++ ] = c1 ; 
              us [0 ] = c1 ; 
              clen = FUNCCALL(SETUP_XfOrM1421(_), scheme_utf8_encode (us , 0 , 1 , s2 , 0 , 0 ) ); 
              r = FUNCCALL_AGAIN(make_room (r , j , clen + 1 , & rs ) ); 
              r [j ++ ] = '|' ; 
              for (ci = 0 ; ci < clen ; ci ++ ) {
                r [j ++ ] = s2 [ci ] ; 
              }
            }
          }
        }
        r [j ++ ] = ')' ; 
      }

# 5062 "bc/src/regexp.c"
      else {

        while (rs . i < k ) {
          r [j ++ ] = s [rs . i ++ ] ; 
        }
      }
    }

# 5068 "bc/src/regexp.c"
    else {
#     define XfOrM1383_COUNT (0+XfOrM1382_COUNT)
#     define SETUP_XfOrM1383(x) SETUP_XfOrM1382(x)
      if (s [rs . i ] == '(' ) {
        int old_flags = parse_flags ; 
#       define XfOrM1386_COUNT (0+XfOrM1383_COUNT)
#       define SETUP_XfOrM1386(x) SETUP_XfOrM1383(x)

# 5073 "bc/src/regexp.c"
        if ((rs . i + 1 < len ) && (s [rs . i + 1 ] == '?' ) ) {
          int k ; 
          for (k = rs . i + 2 ; k < len ; k ++ ) {
            if ((s [k ] == ':' ) 
            || (s [k ] == '<' ) 
            || (s [k ] == '>' ) 
            || (s [k ] == '=' ) 
            || (s [k ] == '!' ) )
              break ; 
            if (s [k ] == 'i' ) {
              parse_flags &= ~ 0x1 ; 
            }

# 5084 "bc/src/regexp.c"
            else if (s [k ] == 's' ) {
              parse_flags |= 0x4 ; 
            }

# 5086 "bc/src/regexp.c"
            else if (s [k ] == 'm' ) {
              parse_flags &= ~ 0x4 ; 
            }

# 5088 "bc/src/regexp.c"
            else if (s [k ] == '-' ) {
              if (k + 1 < len ) {
                k ++ ; 
                if (s [k ] == 'i' ) {
                  parse_flags |= 0x1 ; 
                }

# 5093 "bc/src/regexp.c"
                else if (s [k ] == 's' ) {
                  parse_flags &= ~ 0x4 ; 
                }

# 5095 "bc/src/regexp.c"
                else if (s [k ] == 'm' ) {
                  parse_flags |= 0x4 ; 
                }
              }
            }
          }
        }
        if (parse_params || (parse_flags != old_flags ) ) {
#         define XfOrM1387_COUNT (0+XfOrM1386_COUNT)
#         define SETUP_XfOrM1387(x) SETUP_XfOrM1386(x)

# 5103 "bc/src/regexp.c"
          parse_params = FUNCCALL(SETUP_XfOrM1387(_), scheme_make_raw_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (old_flags ) ) ) << 1 ) | 0x1 ) ) , parse_params ) )
          ; 
        }
      }

# 5106 "bc/src/regexp.c"
      else if (s [rs . i ] == ')' ) {
        if (parse_params ) {
          parse_flags = (((intptr_t ) ((((Scheme_Simple_Object * ) (parse_params ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
          parse_params = (((Scheme_Simple_Object * ) (parse_params ) ) -> u . pair_val . cdr ) ; 
        }
      }
      r [j ++ ] = s [rs . i ++ ] ; 
    }
  }

  r [j ] = 0 ; 
  * result = (char * ) r ; 
  RET_VALUE_START (j ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

int scheme_is_pregexp (Scheme_Object * o ) 
{
  /* No conversion */

# 5127 "bc/src/regexp.c"
  return ! ! (((regexp * ) o ) -> flags & 0x02 ) ; 
}

static Scheme_Object * do_make_regexp (const char * who , int is_byte , int pcre , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * re , * bs ; 
  Scheme_Object * handler ; 
  char * s ; 
  int slen ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(bs, 0), PUSH(argv, 1), PUSH(re, 2), PUSH(who, 3), PUSH(handler, 4), PUSH(s, 5)));
# define XfOrM1627_COUNT (6)
# define SETUP_XfOrM1627(x) SETUP(XfOrM1627_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  re = NULLED_OUT ; 
  bs = NULLED_OUT ; 
  handler = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 5137 "bc/src/regexp.c"
  if (is_byte ) {
#   define XfOrM1634_COUNT (0+XfOrM1627_COUNT)
#   define SETUP_XfOrM1634(x) SETUP_XfOrM1627(x)

# 5138 "bc/src/regexp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
      FUNCCALL(SETUP_XfOrM1634(_), scheme_wrong_contract (who , "bytes?" , 0 , argc , argv ) ); 
    bs = argv [0 ] ; 
  }

# 5141 "bc/src/regexp.c"
  else {
#   define XfOrM1633_COUNT (0+XfOrM1627_COUNT)
#   define SETUP_XfOrM1633(x) SETUP_XfOrM1627(x)

# 5142 "bc/src/regexp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
      FUNCCALL(SETUP_XfOrM1633(_), scheme_wrong_contract (who , "string?" , 0 , argc , argv ) ); 
    bs = FUNCCALL(SETUP_XfOrM1633(_), scheme_char_string_to_byte_string (argv [0 ] ) ); 
  }

  if (argc >= 2 ) {
#   define XfOrM1632_COUNT (0+XfOrM1627_COUNT)
#   define SETUP_XfOrM1632(x) SETUP_XfOrM1627(x)

# 5148 "bc/src/regexp.c"
    if (! FUNCCALL(SETUP_XfOrM1632(_), scheme_check_proc_arity2 (who , 1 , 1 , argc , argv , 1 ) ))
      FUNCCALL(SETUP_XfOrM1632(_), scheme_wrong_contract (who , "(or/c #f (string? -> any))" , 1 , argc , argv ) ); 
    handler = argv [1 ] ; 
  }

# 5151 "bc/src/regexp.c"
  else 
  handler = scheme_false ; 

  s = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
  slen = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 

  if (! is_byte ) {
#   define XfOrM1631_COUNT (0+XfOrM1627_COUNT)
#   define SETUP_XfOrM1631(x) SETUP_XfOrM1627(x)

# 5158 "bc/src/regexp.c"
    slen = FUNCCALL(SETUP_XfOrM1631(_), translate ((unsigned char * ) s , slen , & s , pcre ) ); 
  }

# 5174 "bc/src/regexp.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorwho_ ) = who ; 
  re = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM1627(_), regcomp (s , 0 , slen , pcre , handler ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorwho_ ) = ((void * ) 0 ) ; 


  if (! re ) {
    RET_VALUE_START (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorval_ ) ) RET_VALUE_END ; 
  }

  if (! is_byte )
    ((regexp * ) re ) -> flags |= 0x01 ; 
  if (pcre )
    ((regexp * ) re ) -> flags |= 0x02 ; 

  if (((Scheme_Inclhash_Object * ) (argv [0 ] ) ) -> so . keyex & 0x1 ) 
    ((regexp * ) re ) -> source = argv [0 ] ; 
  else if (is_byte ) {
    Scheme_Object * src ; 
    BLOCK_SETUP((PUSH(src, 0+XfOrM1627_COUNT)));
#   define XfOrM1629_COUNT (1+XfOrM1627_COUNT)
#   define SETUP_XfOrM1629(x) SETUP(XfOrM1629_COUNT)
    src = NULLED_OUT ; 

# 5192 "bc/src/regexp.c"
    src = FUNCCALL(SETUP_XfOrM1629(_), scheme_make_immutable_sized_byte_string ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . tag_val ) , 1 ) )

    ; 
    ((regexp * ) re ) -> source = src ; 
  }

# 5196 "bc/src/regexp.c"
  else {
    Scheme_Object * src ; 
    BLOCK_SETUP((PUSH(src, 0+XfOrM1627_COUNT)));
#   define XfOrM1628_COUNT (1+XfOrM1627_COUNT)
#   define SETUP_XfOrM1628(x) SETUP(XfOrM1628_COUNT)
    src = NULLED_OUT ; 

# 5198 "bc/src/regexp.c"
    src = FUNCCALL(SETUP_XfOrM1628(_), scheme_make_immutable_sized_char_string ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . char_str_val . tag_val ) , 1 ) )

    ; 
    ((regexp * ) re ) -> source = src ; 
  }

  RET_VALUE_START (re ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5207 "bc/src/regexp.c"
static Scheme_Object * make_regexp (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5209 "bc/src/regexp.c"
  return do_make_regexp ("byte-regexp" , 1 , 0 , argc , argv ) ; 
}

static Scheme_Object * make_utf8_regexp (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5214 "bc/src/regexp.c"
  return do_make_regexp ("regexp" , 0 , 0 , argc , argv ) ; 
}

static Scheme_Object * make_pregexp (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5219 "bc/src/regexp.c"
  return do_make_regexp ("byte-pregexp" , 1 , 1 , argc , argv ) ; 
}

static Scheme_Object * make_utf8_pregexp (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5224 "bc/src/regexp.c"
  return do_make_regexp ("pregexp" , 0 , 1 , argc , argv ) ; 
}

Scheme_Object * scheme_make_regexp (Scheme_Object * str , int is_byte , int pcre , int * volatile result_is_err_string ) 
{
  mz_jmp_buf * volatile save , newbuf ; 
  Scheme_Object * volatile result ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(save, 0), PUSH(str, 1), PUSH(result, 2), PUSH(result_is_err_string, 3)));
# define XfOrM1639_COUNT (4)
# define SETUP_XfOrM1639(x) SETUP(XfOrM1639_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  save = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 5232 "bc/src/regexp.c"
  * result_is_err_string = 0 ; 


  save = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> failure_msg_for_read_ ) = "yes" ; 
  if (! ((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM1639_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#   define XfOrM1641_COUNT (0+XfOrM1639_COUNT)
#   define SETUP_XfOrM1641(x) SETUP_XfOrM1639(x)

# 5239 "bc/src/regexp.c"
    if (is_byte ) {
#     define XfOrM1643_COUNT (0+XfOrM1641_COUNT)
#     define SETUP_XfOrM1643(x) SETUP_XfOrM1641(x)

# 5240 "bc/src/regexp.c"
      if (pcre )
        result = FUNCCALL(SETUP_XfOrM1643(_), make_pregexp (1 , & str ) ); 
      else 
      result = FUNCCALL(SETUP_XfOrM1643(_), make_regexp (1 , & str ) ); 
    }

# 5244 "bc/src/regexp.c"
    else {
#     define XfOrM1642_COUNT (0+XfOrM1641_COUNT)
#     define SETUP_XfOrM1642(x) SETUP_XfOrM1641(x)

# 5245 "bc/src/regexp.c"
      if (pcre )
        result = FUNCCALL(SETUP_XfOrM1642(_), make_utf8_pregexp (1 , & str ) ); 
      else 
      result = FUNCCALL(SETUP_XfOrM1642(_), make_utf8_regexp (1 , & str ) ); 
    }
  }

# 5250 "bc/src/regexp.c"
  else {
    result = (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> failure_msg_for_read_ ) ; 
    * result_is_err_string = 1 ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> failure_msg_for_read_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = save ; 
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5260 "bc/src/regexp.c"
static regexp * regcomp_object (Scheme_Object * str ) 
{
  DECL_RET_SAVE (regexp * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(str, 0)));
# define XfOrM1644_COUNT (1)
# define SETUP_XfOrM1644(x) SETUP(XfOrM1644_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5262 "bc/src/regexp.c"
  if ((Scheme_Type ) (((((intptr_t ) (str ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (str ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
    RET_VALUE_START ((regexp * ) FUNCCALL(SETUP_XfOrM1644(_), make_regexp (1 , & str ) )) RET_VALUE_END ; 
  else 
  RET_VALUE_START ((regexp * ) FUNCCALL(SETUP_XfOrM1644(_), make_utf8_regexp (1 , & str ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5268 "bc/src/regexp.c"
void scheme_clear_rx_buffers (void ) 
{
  /* No conversion */

# 5270 "bc/src/regexp.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> startp_buffer_cache_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> endp_buffer_cache_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybep_buffer_cache_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> match_stack_buffer_cache_ ) = ((void * ) 0 ) ; 
}

static Scheme_Object * gen_compare (char * name , int pos , 
int argc , Scheme_Object * argv [] , 
int peek , int nonblock , int last_bytes ) 
{
  regexp * r ; 
  char * full_s , * prefix = ((void * ) 0 ) ; 
  rxpos * startp , * maybep , * endp , * match_stack , prefix_len = 0 , prefix_offset = 0 , minpos ; 
  int offset = 0 , orig_offset , endset , m , was_non_byte , last_bytes_count = last_bytes ; 
  Scheme_Object * iport , * oport = ((void * ) 0 ) , * startv = ((void * ) 0 ) , * endv = ((void * ) 0 ) , * dropped , * unless_evt = ((void * ) 0 ) ; 
  Scheme_Object * last_bytes_str = scheme_false , * srcin ; 
  rx_lazy_str_t * lazy_string = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg171 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(22);
  BLOCK_SETUP_TOP((PUSH(oport, 0), PUSH(iport, 1), PUSH(startv, 2), PUSH(match_stack, 3), PUSH(argv, 4), PUSH(lazy_string, 5), PUSH(prefix, 6), PUSH(last_bytes_str, 7), PUSH(endp, 8), PUSH(unless_evt, 9), PUSH(endv, 10), PUSH(startp, 11), PUSH(dropped, 12), PUSH(srcin, 13), PUSH(full_s, 14), PUSH(name, 15), PUSH(r, 16), PUSH(maybep, 17)));
# define XfOrM1646_COUNT (18)
# define SETUP_XfOrM1646(x) SETUP(XfOrM1646_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  r = NULLED_OUT ; 
  full_s = NULLED_OUT ; 
  startp = NULLED_OUT ; 
  maybep = NULLED_OUT ; 
  endp = NULLED_OUT ; 
  match_stack = NULLED_OUT ; 
  iport = NULLED_OUT ; 
  dropped = NULLED_OUT ; 
  srcin = NULLED_OUT ; 

# 5288 "bc/src/regexp.c"
  if (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) != scheme_regexp_type 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL(SETUP_XfOrM1646(_), scheme_wrong_contract (name , "(or/c regexp? byte-regexp? string? bytes?)" , 0 , argc , argv ) ); 
  if ((peek || (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) ) 
  && ! (scheme_is_input_port (argv [1 ] ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) )
    FUNCCALL(SETUP_XfOrM1646(_), scheme_wrong_contract (name , peek ? "input-port?" : "(or/c string? bytes? path? input-port?)" , 1 , argc , argv ) ); 

  srcin = argv [1 ] ; 
  if ((Scheme_Type ) (((((intptr_t ) (srcin ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (srcin ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#   define XfOrM1724_COUNT (0+XfOrM1646_COUNT)
#   define SETUP_XfOrM1724(x) SETUP_XfOrM1646(x)

# 5299 "bc/src/regexp.c"
    if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
    || (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_regexp_type ) ) 
    && ! (((regexp * ) argv [0 ] ) -> flags & 0x01 ) ) )
      srcin = FUNCCALL(SETUP_XfOrM1724(_), scheme_make_sized_byte_string ((((Scheme_Simple_Object * ) (srcin ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (srcin ) ) -> u . byte_str_val . tag_val ) , 1 ) )

    ; 
    else 
    srcin = FUNCCALL(SETUP_XfOrM1724(_), scheme_path_to_char_string (srcin ) ); 
  }

  if ((Scheme_Type ) (((((intptr_t ) (srcin ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (srcin ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
    iport = ((void * ) 0 ) ; 
    endset = (((Scheme_Simple_Object * ) (srcin ) ) -> u . char_str_val . tag_val ) ; 
  }

# 5312 "bc/src/regexp.c"
  else if (scheme_is_input_port (srcin ) )  {
    iport = srcin ; 
    endset = - 2 ; 
  }

# 5315 "bc/src/regexp.c"
  else {
    iport = ((void * ) 0 ) ; 
    endset = (((Scheme_Simple_Object * ) (srcin ) ) -> u . byte_str_val . tag_val ) ; 
  }

  if (argc > 2 ) {
    int len = endset ; 
#   define XfOrM1702_COUNT (0+XfOrM1646_COUNT)
#   define SETUP_XfOrM1702(x) SETUP_XfOrM1646(x)

# 5323 "bc/src/regexp.c"
    offset = FUNCCALL(SETUP_XfOrM1702(_), scheme_extract_index (name , 2 , argc , argv , len + 1 , 0 ) ); 

    if (! iport && (offset > len ) ) {
#     define XfOrM1720_COUNT (0+XfOrM1702_COUNT)
#     define SETUP_XfOrM1720(x) SETUP_XfOrM1702(x)
      FUNCCALL(SETUP_XfOrM1720(_), scheme_out_of_range (name , ((void * ) 0 ) , "offset " , argv [2 ] , srcin , 0 , len ) )
# 5326 "bc/src/regexp.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 5328 "bc/src/regexp.c"
    else if (offset < 0 ) {

      offset = 0x7FFFFFFF ; 
    }
    startv = argv [2 ] ; 

    if (argc > 3 ) {
#     define XfOrM1703_COUNT (0+XfOrM1702_COUNT)
#     define SETUP_XfOrM1703(x) SETUP_XfOrM1702(x)

# 5335 "bc/src/regexp.c"
      if (! (((argv [3 ] ) ) == (scheme_false ) ) ) {
#       define XfOrM1714_COUNT (0+XfOrM1703_COUNT)
#       define SETUP_XfOrM1714(x) SETUP_XfOrM1703(x)

# 5336 "bc/src/regexp.c"
        endset = FUNCCALL(SETUP_XfOrM1714(_), scheme_extract_index (name , 3 , argc , argv , len + 1 , 1 ) ); 

        if (iport ) {
#         define XfOrM1716_COUNT (0+XfOrM1714_COUNT)
#         define SETUP_XfOrM1716(x) SETUP_XfOrM1714(x)

# 5339 "bc/src/regexp.c"
          if (endset < 0 ) {

            endset = 0x7FFFFFFF ; 
          }

          if (FUNCCALL(SETUP_XfOrM1716(_), scheme_bin_lt (argv [3 ] , argv [2 ] ) )) {
#           define XfOrM1717_COUNT (0+XfOrM1716_COUNT)
#           define SETUP_XfOrM1717(x) SETUP_XfOrM1716(x)
            FUNCCALL(SETUP_XfOrM1717(_), scheme_contract_error (name , "ending index is smaller than starting index" , "starting index" , 1 , argv [2 ] , "ending index" , 1 , argv [3 ] , ((void * ) 0 ) ) )

            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
        }

# 5352 "bc/src/regexp.c"
        else if (endset < offset || endset > len ) {
#         define XfOrM1715_COUNT (0+XfOrM1714_COUNT)
#         define SETUP_XfOrM1715(x) SETUP_XfOrM1714(x)
          FUNCCALL(SETUP_XfOrM1715(_), scheme_out_of_range (name , ((void * ) 0 ) , "ending " , argv [3 ] , srcin , offset , len ) )
# 5353 "bc/src/regexp.c"
          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        endv = argv [3 ] ; 
      }

      if (argc > 4 ) {
#       define XfOrM1706_COUNT (0+XfOrM1703_COUNT)
#       define SETUP_XfOrM1706(x) SETUP_XfOrM1703(x)

# 5360 "bc/src/regexp.c"
        if (peek ) {
#         define XfOrM1709_COUNT (0+XfOrM1706_COUNT)
#         define SETUP_XfOrM1709(x) SETUP_XfOrM1706(x)

# 5361 "bc/src/regexp.c"
          if (! (((argv [4 ] ) ) == (scheme_false ) ) ) {
#           define XfOrM1710_COUNT (0+XfOrM1709_COUNT)
#           define SETUP_XfOrM1710(x) SETUP_XfOrM1709(x)

# 5362 "bc/src/regexp.c"
            unless_evt = argv [4 ] ; 
            if (! ((Scheme_Type ) (((((intptr_t ) (unless_evt ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (unless_evt ) ) -> type ) ) == (Scheme_Type ) (scheme_progress_evt_type ) ) ) {
#             define XfOrM1713_COUNT (0+XfOrM1710_COUNT)
#             define SETUP_XfOrM1713(x) SETUP_XfOrM1710(x)
              FUNCCALL(SETUP_XfOrM1713(_), scheme_wrong_contract (name , "(or/c progress-evt? #f)" , 4 , argc , argv ) )
# 5364 "bc/src/regexp.c"
              ; 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
            if (! iport ) {
#             define XfOrM1712_COUNT (0+XfOrM1710_COUNT)
#             define SETUP_XfOrM1712(x) SETUP_XfOrM1710(x)
              FUNCCALL(SETUP_XfOrM1712(_), scheme_contract_error (name , "progress evt cannot be used with string input" , "progress evt" , 1 , unless_evt , ((void * ) 0 ) ) )
              ; 
            }

# 5372 "bc/src/regexp.c"
            else if (! ((iport ) == ((((Scheme_Simple_Object * ) (unless_evt ) ) -> u . two_ptr_val . ptr1 ) ) ) ) {
#             define XfOrM1711_COUNT (0+XfOrM1710_COUNT)
#             define SETUP_XfOrM1711(x) SETUP_XfOrM1710(x)
              FUNCCALL(SETUP_XfOrM1711(_), scheme_contract_error (name , "evt is not a progress evt for the given port" , "progress evt" , 1 , unless_evt , "port" , 1 , iport , ((void * ) 0 ) ) )

              ; 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
          }
        }

# 5381 "bc/src/regexp.c"
        else {
#         define XfOrM1707_COUNT (0+XfOrM1706_COUNT)
#         define SETUP_XfOrM1707(x) SETUP_XfOrM1706(x)

# 5382 "bc/src/regexp.c"
          if (! (((argv [4 ] ) ) == (scheme_false ) ) )  {
#           define XfOrM1708_COUNT (0+XfOrM1707_COUNT)
#           define SETUP_XfOrM1708(x) SETUP_XfOrM1707(x)

# 5383 "bc/src/regexp.c"
            if (! (scheme_is_output_port (argv [4 ] ) ) )
              FUNCCALL(SETUP_XfOrM1708(_), scheme_wrong_contract (name , "(or/c output-port? #f)" , 4 , argc , argv ) ); 
            oport = argv [4 ] ; 
          }
        }
      }

      if (argc > 5 ) {
#       define XfOrM1704_COUNT (0+XfOrM1703_COUNT)
#       define SETUP_XfOrM1704(x) SETUP_XfOrM1703(x)

# 5391 "bc/src/regexp.c"
        if (! ((Scheme_Type ) (((((intptr_t ) (argv [5 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [5 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
          FUNCCALL(SETUP_XfOrM1704(_), scheme_wrong_contract (name , "bytes?" , 5 , argc , argv ) ); 
        prefix = (((Scheme_Simple_Object * ) (argv [5 ] ) ) -> u . byte_str_val . string_val ) ; 
        prefix_len = (((Scheme_Simple_Object * ) (argv [5 ] ) ) -> u . byte_str_val . tag_val ) ; 
        prefix_offset = 0 ; 

        if (argc > 6 ) {
#         define XfOrM1705_COUNT (0+XfOrM1704_COUNT)
#         define SETUP_XfOrM1705(x) SETUP_XfOrM1704(x)

# 5398 "bc/src/regexp.c"
          if (! FUNCCALL(SETUP_XfOrM1705(_), scheme_nonneg_exact_p (argv [6 ] ) ))
            FUNCCALL(SETUP_XfOrM1705(_), scheme_wrong_contract (name , "exact-nonnegative-integer?" , 6 , argc , argv ) ); 
          if (((intptr_t ) (argv [6 ] ) ) & 0x1 ) 
            last_bytes_count = (((intptr_t ) (argv [6 ] ) ) >> 1 ) ; 
          else 
          last_bytes_count = - 1 ; 
        }
      }
    }
  }

  if (iport && ! startv )
    startv = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    r = FUNCCALL(SETUP_XfOrM1646(_), regcomp_object (argv [0 ] ) ); 
  else 
  r = (regexp * ) argv [0 ] ; 

  was_non_byte = 0 ; 
  orig_offset = 0 ; 
  if (! iport ) {
#   define XfOrM1697_COUNT (0+XfOrM1646_COUNT)
#   define SETUP_XfOrM1697(x) SETUP_XfOrM1646(x)

# 5421 "bc/src/regexp.c"
    if ((Scheme_Type ) (((((intptr_t ) (srcin ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (srcin ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
      full_s = (((Scheme_Simple_Object * ) (srcin ) ) -> u . byte_str_val . string_val ) ; 
    else {
#     define XfOrM1698_COUNT (0+XfOrM1697_COUNT)
#     define SETUP_XfOrM1698(x) SETUP_XfOrM1697(x)

# 5425 "bc/src/regexp.c"
      if (endset - offset < 32 ) {

        int blen ; 
#       define XfOrM1701_COUNT (0+XfOrM1698_COUNT)
#       define SETUP_XfOrM1701(x) SETUP_XfOrM1698(x)

# 5428 "bc/src/regexp.c"
        blen = FUNCCALL(SETUP_XfOrM1701(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (srcin ) ) -> u . char_str_val . string_val ) , offset , endset , ((void * ) 0 ) , 0 , 0 ) )

        ; 
        full_s = (char * ) FUNCCALL(SETUP_XfOrM1701(_), GC_malloc_atomic (blen ) ); 
        FUNCCALL(SETUP_XfOrM1701(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (srcin ) ) -> u . char_str_val . string_val ) , offset , endset , (unsigned char * ) full_s , 0 , 0 ) )

        ; 
        orig_offset = offset ; 
        offset = 0 ; 
        endset = blen ; 
      }

# 5438 "bc/src/regexp.c"
      else {
#       define XfOrM1700_COUNT (0+XfOrM1698_COUNT)
#       define SETUP_XfOrM1700(x) SETUP_XfOrM1698(x)

# 5440 "bc/src/regexp.c"
        lazy_string = ((rx_lazy_str_t * ) FUNCCALL(SETUP_XfOrM1700(_), GC_malloc_one_small_tagged ((((sizeof (rx_lazy_str_t ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

        lazy_string -> type = scheme_rt_rx_lazy_string ; 

        lazy_string -> start = offset ; 
        lazy_string -> end = endset ; 
        lazy_string -> done = 0 ; 
        lazy_string -> blen = 0 ; 
        lazy_string -> s = ((void * ) 0 ) ; 
        lazy_string -> chars = (((Scheme_Simple_Object * ) (srcin ) ) -> u . char_str_val . string_val ) ; 
        full_s = ((void * ) 0 ) ; 
        orig_offset = offset ; 
        offset = 0 ; 
        endset = 0 ; 
      }
      if (r -> flags & 0x01 )
        was_non_byte = 1 ; 
      else {
#       define XfOrM1699_COUNT (0+XfOrM1698_COUNT)
#       define SETUP_XfOrM1699(x) SETUP_XfOrM1698(x)

# 5459 "bc/src/regexp.c"
        orig_offset = FUNCCALL(SETUP_XfOrM1699(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (srcin ) ) -> u . char_str_val . string_val ) , 0 , orig_offset , ((void * ) 0 ) , 0 , 0 ) )

        ; 
      }
    }
  }

# 5464 "bc/src/regexp.c"
  else 
  full_s = ((void * ) 0 ) ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> startp_buffer_cache_ ) && (r -> nsubexp <= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> rx_buffer_size_ ) ) ) {
    startp = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> startp_buffer_cache_ ) ; 
    maybep = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybep_buffer_cache_ ) ; 
    endp = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> endp_buffer_cache_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> startp_buffer_cache_ ) = ((void * ) 0 ) ; 
  }

# 5472 "bc/src/regexp.c"
  else {
#   define XfOrM1695_COUNT (0+XfOrM1646_COUNT)
#   define SETUP_XfOrM1695(x) SETUP_XfOrM1646(x)

# 5473 "bc/src/regexp.c"
    startp = ((rxpos * ) FUNCCALL(SETUP_XfOrM1695(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
    maybep = ((void * ) 0 ) ; 
    match_stack = ((void * ) 0 ) ; 
    endp = ((rxpos * ) FUNCCALL(SETUP_XfOrM1695(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
  }
  if ((r -> nsubexp > 1 ) && ! maybep ) {
#   define XfOrM1693_COUNT (0+XfOrM1646_COUNT)
#   define SETUP_XfOrM1693(x) SETUP_XfOrM1646(x)

# 5479 "bc/src/regexp.c"
    maybep = ((rxpos * ) FUNCCALL(SETUP_XfOrM1693(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> match_stack_buffer_cache_ ) ) {
      match_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> match_stack_buffer_cache_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> match_stack_buffer_cache_ ) = ((void * ) 0 ) ; 
    }

# 5484 "bc/src/regexp.c"
    else 
    match_stack = ((rxpos * ) FUNCCALL(SETUP_XfOrM1693(_), GC_malloc_atomic (sizeof (rxpos ) * (24 ) ) )) ; 
  }

# 5486 "bc/src/regexp.c"
  else {
    match_stack = ((void * ) 0 ) ; 
  }

  dropped = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

  m = FUNCCALL(SETUP_XfOrM1646(_), regexec (name , r , full_s , offset , (endset < 0 ? endset : endset - offset ) , offset , lazy_string , startp , maybep , endp , match_stack , iport , unless_evt , nonblock , & full_s , peek , pos , last_bytes_count , oport , startv , endv , & dropped , prefix , prefix_len , prefix_offset ) )






  ; 

  if (lazy_string ) {
    full_s = lazy_string -> s ; 
    endset = lazy_string -> blen ; 
  }

  if (iport ) {
    minpos = - prefix_len ; 
    offset = 0 ; 
  }

# 5509 "bc/src/regexp.c"
  else 
  minpos = offset - prefix_len ; 

  if (m ) {
    int i ; 
    Scheme_Object * l = scheme_null , * rs ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM1646_COUNT), PUSH(rs, 1+XfOrM1646_COUNT)));
#   define XfOrM1651_COUNT (2+XfOrM1646_COUNT)
#   define SETUP_XfOrM1651(x) SETUP(XfOrM1651_COUNT)
    rs = NULLED_OUT ; 

# 5516 "bc/src/regexp.c"
    if (oport && ! iport )
      FUNCCALL(SETUP_XfOrM1651(_), scheme_put_byte_string (name , oport , full_s , 0 , * startp , 0 ) ); 

    if (last_bytes ) {
      rxpos frompos , tooffset ; 
#     define XfOrM1686_COUNT (0+XfOrM1651_COUNT)
#     define SETUP_XfOrM1686(x) SETUP_XfOrM1651(x)

# 5522 "bc/src/regexp.c"
      if ((last_bytes_count < 0 ) 
      || (endp [0 ] - minpos < last_bytes_count ) )
        last_bytes_count = endp [0 ] - minpos ; 

      if (! last_bytes_count ) {
        last_bytes_str = empty_byte_string ; 
      }

# 5528 "bc/src/regexp.c"
      else {
#       define XfOrM1687_COUNT (0+XfOrM1686_COUNT)
#       define SETUP_XfOrM1687(x) SETUP_XfOrM1686(x)

# 5529 "bc/src/regexp.c"
        frompos = endp [0 ] - last_bytes_count ; 
        tooffset = 0 ; 

        last_bytes_str = FUNCCALL(SETUP_XfOrM1687(_), scheme_alloc_byte_string (last_bytes_count , 0 ) ); 
        if (frompos < offset ) {

          rxpos amt = last_bytes_count ; 
#         define XfOrM1688_COUNT (0+XfOrM1687_COUNT)
#         define SETUP_XfOrM1688(x) SETUP_XfOrM1687(x)

# 5536 "bc/src/regexp.c"
          if (frompos + last_bytes_count > offset )
            amt = offset - frompos ; 
          (memcpy ((((Scheme_Simple_Object * ) (last_bytes_str ) ) -> u . byte_str_val . string_val ) XFORM_OK_PLUS tooffset , 
          prefix + prefix_offset + prefix_len - (offset - frompos ) , 
          amt ) ) ; 
          frompos += amt ; 
          tooffset += amt ; 
          last_bytes_count -= amt ; 
        }
        (memcpy ((((Scheme_Simple_Object * ) (last_bytes_str ) ) -> u . byte_str_val . string_val ) XFORM_OK_PLUS tooffset , 
        full_s + frompos , 
        last_bytes_count ) ) ; 
      }
    }

    if (pos > 1 ) {

      dropped = scheme_true ; 
    }

# 5554 "bc/src/regexp.c"
    else {
#     define XfOrM1652_COUNT (0+XfOrM1651_COUNT)
#     define SETUP_XfOrM1652(x) SETUP_XfOrM1651(x)

# 5555 "bc/src/regexp.c"
      for (i = r -> nsubexp ; i -- ; ) {
#       define XfOrM1669_COUNT (0+XfOrM1652_COUNT)
#       define SETUP_XfOrM1669(x) SETUP_XfOrM1652(x)

# 5556 "bc/src/regexp.c"
        if (startp [i ] >= minpos ) {
#         define XfOrM1670_COUNT (0+XfOrM1669_COUNT)
#         define SETUP_XfOrM1670(x) SETUP_XfOrM1669(x)

# 5557 "bc/src/regexp.c"
          if (pos ) {
            Scheme_Object * startpd , * endpd ; 
            BLOCK_SETUP((PUSH(startpd, 0+XfOrM1670_COUNT), PUSH(endpd, 1+XfOrM1670_COUNT)));
#           define XfOrM1677_COUNT (2+XfOrM1670_COUNT)
#           define SETUP_XfOrM1677(x) SETUP(XfOrM1677_COUNT)
            startpd = NULLED_OUT ; 
            endpd = NULLED_OUT ; 

# 5560 "bc/src/regexp.c"
            if (was_non_byte ) {




              int uspd , uepd ; 
#             define XfOrM1680_COUNT (0+XfOrM1677_COUNT)
#             define SETUP_XfOrM1680(x) SETUP_XfOrM1677(x)

# 5566 "bc/src/regexp.c"
              if (startp [i ] >= offset )
                uspd = FUNCCALL(SETUP_XfOrM1680(_), scheme_utf8_decode ((const unsigned char * ) full_s , offset , startp [i ] , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) )

              ; 
              else {
#               define XfOrM1684_COUNT (0+XfOrM1680_COUNT)
#               define SETUP_XfOrM1684(x) SETUP_XfOrM1680(x)

# 5571 "bc/src/regexp.c"
                uspd = FUNCCALL(SETUP_XfOrM1684(_), scheme_utf8_decode ((const unsigned char * ) prefix , prefix_offset + prefix_len + (startp [i ] - offset ) , prefix_offset + prefix_len , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) )



                ; 
                uspd = offset - uspd ; 
              }
              uspd += orig_offset ; 
              startpd = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (uspd ) ) ) << 1 ) | 0x1 ) ) ; 
              if (startp [i ] >= offset ) {
#               define XfOrM1683_COUNT (0+XfOrM1680_COUNT)
#               define SETUP_XfOrM1683(x) SETUP_XfOrM1680(x)

# 5581 "bc/src/regexp.c"
                uepd = FUNCCALL(SETUP_XfOrM1683(_), scheme_utf8_decode ((const unsigned char * ) full_s , startp [i ] , endp [i ] , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) )

                ; 
                uepd += uspd ; 
              }

# 5585 "bc/src/regexp.c"
              else if (endp [i ] <= offset ) {
#               define XfOrM1682_COUNT (0+XfOrM1680_COUNT)
#               define SETUP_XfOrM1682(x) SETUP_XfOrM1680(x)

# 5586 "bc/src/regexp.c"
                uepd = FUNCCALL(SETUP_XfOrM1682(_), scheme_utf8_decode ((const unsigned char * ) prefix , prefix_offset + prefix_len + (endp [i ] - offset ) , prefix_offset + prefix_len , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) )



                ; 
                uepd = offset - uepd ; 
                uepd += orig_offset ; 
              }

# 5593 "bc/src/regexp.c"
              else {
#               define XfOrM1681_COUNT (0+XfOrM1680_COUNT)
#               define SETUP_XfOrM1681(x) SETUP_XfOrM1680(x)

# 5594 "bc/src/regexp.c"
                uepd = FUNCCALL(SETUP_XfOrM1681(_), scheme_utf8_decode ((const unsigned char * ) full_s , 0 , endp [i ] , ((void * ) 0 ) , 0 , - 1 , ((void * ) 0 ) , 0 , 0 ) )

                ; 
                uepd += orig_offset ; 
              }
              endpd = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (uepd ) ) ) << 1 ) | 0x1 ) ) ; 
            }

# 5600 "bc/src/regexp.c"
            else {
              int v ; 
#             define XfOrM1678_COUNT (0+XfOrM1677_COUNT)
#             define SETUP_XfOrM1678(x) SETUP_XfOrM1677(x)

# 5602 "bc/src/regexp.c"
              v = startp [i ] + orig_offset ; 
              startpd = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 
              v = endp [i ] + orig_offset ; 
              endpd = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (v ) ) ) << 1 ) | 0x1 ) ) ; 

              if (iport ) {
#               define XfOrM1679_COUNT (0+XfOrM1678_COUNT)
#               define SETUP_XfOrM1679(x) SETUP_XfOrM1678(x)

# 5609 "bc/src/regexp.c"
                startpd = FUNCCALL(SETUP_XfOrM1679(_), scheme_bin_plus (startpd , dropped ) ); 
                endpd = FUNCCALL(SETUP_XfOrM1679(_), scheme_bin_plus (endpd , dropped ) ); 
              }
            }

            l = (__funcarg171 = FUNCCALL(SETUP_XfOrM1677(_), scheme_make_pair (startpd , endpd ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg171 , l ) )) 
            ; 
          }

# 5616 "bc/src/regexp.c"
          else {
            intptr_t len ; 
#           define XfOrM1671_COUNT (0+XfOrM1670_COUNT)
#           define SETUP_XfOrM1671(x) SETUP_XfOrM1670(x)

# 5618 "bc/src/regexp.c"
            len = endp [i ] - startp [i ] ; 
            if (startp [i ] >= offset ) {
#             define XfOrM1674_COUNT (0+XfOrM1671_COUNT)
#             define SETUP_XfOrM1674(x) SETUP_XfOrM1671(x)

# 5620 "bc/src/regexp.c"
              if (was_non_byte ) {
#               define XfOrM1676_COUNT (0+XfOrM1674_COUNT)
#               define SETUP_XfOrM1676(x) SETUP_XfOrM1674(x)

# 5621 "bc/src/regexp.c"
                rs = FUNCCALL(SETUP_XfOrM1676(_), scheme_make_sized_offset_utf8_string (full_s , startp [i ] , len ) ); 
              }

# 5622 "bc/src/regexp.c"
              else {
#               define XfOrM1675_COUNT (0+XfOrM1674_COUNT)
#               define SETUP_XfOrM1675(x) SETUP_XfOrM1674(x)

# 5623 "bc/src/regexp.c"
                rs = FUNCCALL(SETUP_XfOrM1675(_), scheme_make_sized_offset_byte_string (full_s , startp [i ] , len , 1 ) ); 
              }
            }

# 5625 "bc/src/regexp.c"
            else if (endp [i ] <= offset ) {
#             define XfOrM1673_COUNT (0+XfOrM1671_COUNT)
#             define SETUP_XfOrM1673(x) SETUP_XfOrM1671(x)

# 5627 "bc/src/regexp.c"
              rs = FUNCCALL(SETUP_XfOrM1673(_), scheme_make_sized_offset_byte_string (prefix , prefix_offset + (startp [i ] - minpos ) , endp [i ] - startp [i ] , 1 ) )


              ; 
              if (was_non_byte )
                rs = FUNCCALL(SETUP_XfOrM1673(_), scheme_byte_string_to_char_string (rs ) ); 
            }

# 5633 "bc/src/regexp.c"
            else {

              Scheme_Object * rs2 ; 
              BLOCK_SETUP((PUSH(rs2, 0+XfOrM1671_COUNT)));
#             define XfOrM1672_COUNT (1+XfOrM1671_COUNT)
#             define SETUP_XfOrM1672(x) SETUP(XfOrM1672_COUNT)
              rs2 = NULLED_OUT ; 

# 5636 "bc/src/regexp.c"
              rs = FUNCCALL(SETUP_XfOrM1672(_), scheme_make_sized_offset_byte_string (prefix , prefix_offset + (startp [i ] - minpos ) , offset - startp [i ] , 1 ) )


              ; 
              rs2 = FUNCCALL_AGAIN(scheme_make_sized_offset_byte_string (full_s , offset , endp [i ] - offset , 1 ) ); 
              rs = FUNCCALL_AGAIN(scheme_append_byte_string (rs , rs2 ) ); 
              if (was_non_byte )
                rs = FUNCCALL(SETUP_XfOrM1672(_), scheme_byte_string_to_char_string (rs ) ); 
            }
            l = FUNCCALL(SETUP_XfOrM1671(_), scheme_make_pair (rs , l ) ); 
          }
        }

# 5647 "bc/src/regexp.c"
        else 
        l = FUNCCALL(SETUP_XfOrM1669(_), scheme_make_pair (scheme_false , l ) ); 
      }
      dropped = l ; 
    }
  }

# 5652 "bc/src/regexp.c"
  else {
#   define XfOrM1650_COUNT (0+XfOrM1646_COUNT)
#   define SETUP_XfOrM1650(x) SETUP_XfOrM1646(x)

# 5653 "bc/src/regexp.c"
    if (oport && ! iport )
      FUNCCALL(SETUP_XfOrM1650(_), scheme_put_byte_string (name , oport , full_s , 0 , endset , 0 ) ); 

    dropped = scheme_false ; 
    last_bytes_str = scheme_false ; 
  }

  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> startp_buffer_cache_ ) || (r -> nsubexp > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> rx_buffer_size_ ) ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> rx_buffer_size_ ) = r -> nsubexp ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> startp_buffer_cache_ ) = startp ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybep_buffer_cache_ ) = maybep ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> endp_buffer_cache_ ) = endp ; 
  }

# 5665 "bc/src/regexp.c"
  else if (maybep && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybep_buffer_cache_ ) && (r -> nsubexp == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> rx_buffer_size_ ) ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybep_buffer_cache_ ) = maybep ; 
  }
  if (match_stack && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> match_stack_buffer_cache_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> match_stack_buffer_cache_ ) = match_stack ; 

  if (last_bytes ) {
    Scheme_Object * a [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM1646_COUNT)));
#   define XfOrM1647_COUNT (3+XfOrM1646_COUNT)
#   define SETUP_XfOrM1647(x) SETUP(XfOrM1647_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 

# 5673 "bc/src/regexp.c"
    a [0 ] = dropped ; 
    a [1 ] = last_bytes_str ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1647(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
  }

# 5676 "bc/src/regexp.c"
  else 
  RET_VALUE_START (dropped ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5680 "bc/src/regexp.c"
static Scheme_Object * compare (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5682 "bc/src/regexp.c"
  return gen_compare ("regexp-match" , 0 , argc , argv , 0 , 0 , 0 ) ; 
}

static Scheme_Object * compare_end (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5687 "bc/src/regexp.c"
  return gen_compare ("regexp-match/end" , 0 , argc , argv , 0 , 0 , 1 ) ; 
}

static Scheme_Object * positions (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5692 "bc/src/regexp.c"
  return gen_compare ("regexp-match-positions" , 1 , argc , argv , 0 , 0 , 0 ) ; 
}

static Scheme_Object * positions_end (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5697 "bc/src/regexp.c"
  return gen_compare ("regexp-match-positions/end" , 1 , argc , argv , 0 , 0 , 1 ) ; 
}

static Scheme_Object * compare_bool (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5702 "bc/src/regexp.c"
  return gen_compare ("regexp-match?" , 2 , argc , argv , 0 , 0 , 0 ) ; 
}

int scheme_regexp_match_p (Scheme_Object * regexp , Scheme_Object * target ) 
{
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM1730_COUNT (3)
# define SETUP_XfOrM1730(x) SETUP(XfOrM1730_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 5708 "bc/src/regexp.c"
  a [0 ] = regexp ; 
  a [1 ] = target ; 
  RET_VALUE_START ((! (((FUNCCALL(SETUP_XfOrM1730(_), compare_bool (2 , a ) )) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5713 "bc/src/regexp.c"
static Scheme_Object * compare_peek (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5715 "bc/src/regexp.c"
  return gen_compare ("regexp-match-peek" , 0 , argc , argv , 1 , 0 , 0 ) ; 
}

static Scheme_Object * positions_peek (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5720 "bc/src/regexp.c"
  return gen_compare ("regexp-match-peek-positions" , 1 , argc , argv , 1 , 0 , 0 ) ; 
}

static Scheme_Object * positions_peek_end (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5725 "bc/src/regexp.c"
  return gen_compare ("regexp-match-peek-positions/end" , 1 , argc , argv , 1 , 0 , 1 ) ; 
}

static Scheme_Object * compare_peek_nonblock (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5730 "bc/src/regexp.c"
  return gen_compare ("regexp-match-peek-immediate" , 0 , argc , argv , 1 , 1 , 0 ) ; 
}

static Scheme_Object * positions_peek_nonblock (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5735 "bc/src/regexp.c"
  return gen_compare ("regexp-match-peek-positions-immediate" , 1 , argc , argv , 1 , 1 , 0 ) ; 
}

static Scheme_Object * positions_peek_nonblock_end (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 5740 "bc/src/regexp.c"
  return gen_compare ("regexp-match-peek-positions-immediate/end" , 1 , argc , argv , 1 , 1 , 1 ) ; 
}

static char * build_call_name (const char * n ) 
{
  char * m ; 
  int l ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(n, 0), PUSH(m, 1)));
# define XfOrM1737_COUNT (2)
# define SETUP_XfOrM1737(x) SETUP(XfOrM1737_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  m = NULLED_OUT ; 

# 5747 "bc/src/regexp.c"
  l = strlen (n ) ; 
  m = (char * ) FUNCCALL(SETUP_XfOrM1737(_), GC_malloc_atomic (l + 42 ) ); 
  (memcpy (m , n , l ) ) ; 
  (strcpy (m XFORM_OK_PLUS l , " (calling given filter procedure)" ) ) ; 
  RET_VALUE_START (m ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5754 "bc/src/regexp.c"
static int initial_char_len (unsigned char * source , intptr_t start , intptr_t end ) 
{
  /* No conversion */

# 5756 "bc/src/regexp.c"
  intptr_t i ; 

  for (i = start + 1 ; i <= end ; i ++ ) {
    if (scheme_utf8_decode_count (source , start , i , ((void * ) 0 ) , 1 , 1 ) ) {
      return i - start ; 
    }
  }

  return 1 ; 
}

static Scheme_Object * gen_replace (const char * name , int argc , Scheme_Object * argv [] , int all ) 
{
  Scheme_Object * orig ; 
  regexp * r ; 
  char * source , * prefix = ((void * ) 0 ) , * deststr ; 
  rxpos * startp , * maybep , * endp , minpos ; 
  int prefix_len = 0 , prefix_offset = 0 , sourcelen , srcoffset = 0 , was_non_byte , destlen ; 
  char * result_pre = ((void * ) 0 ) ; 
  int result_pre_len = 0 , result_pre_size = 0 ; 
  int cannot_match_more = 0 ; 

# 5743 "bc/src/regexp.c"
  char * __funcarg175 = NULLED_OUT ; 

# 5743 "bc/src/regexp.c"
  char * __funcarg174 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(18);
  BLOCK_SETUP_TOP((PUSH(result_pre, 0), PUSH(source, 1), PUSH(startp, 2), PUSH(deststr, 3), PUSH(argv, 4), PUSH(prefix, 5), PUSH(orig, 6), PUSH(name, 7), PUSH(r, 8), PUSH(endp, 9), PUSH(maybep, 10)));
# define XfOrM1743_COUNT (11)
# define SETUP_XfOrM1743(x) SETUP(XfOrM1743_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  orig = NULLED_OUT ; 
  r = NULLED_OUT ; 
  source = NULLED_OUT ; 
  deststr = NULLED_OUT ; 
  startp = NULLED_OUT ; 
  maybep = NULLED_OUT ; 
  endp = NULLED_OUT ; 

# 5778 "bc/src/regexp.c"
  if (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) != scheme_regexp_type 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c regexp? byte-regexp? string? bytes?)" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c string? bytes?)" , 1 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
  && ! (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c string? bytes? procedure?)" , 2 , argc , argv ) ); 

  if ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
#   define XfOrM1838_COUNT (0+XfOrM1743_COUNT)
#   define SETUP_XfOrM1838(x) SETUP_XfOrM1743(x)

# 5791 "bc/src/regexp.c"
    if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
    || ((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) 
    && (((regexp * ) argv [0 ] ) -> flags & 0x01 ) ) ) {
#     define XfOrM1839_COUNT (0+XfOrM1838_COUNT)
#     define SETUP_XfOrM1839(x) SETUP_XfOrM1838(x)

# 5794 "bc/src/regexp.c"
      if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#       define XfOrM1840_COUNT (0+XfOrM1839_COUNT)
#       define SETUP_XfOrM1840(x) SETUP_XfOrM1839(x)
        FUNCCALL_EMPTY(scheme_contract_error (name , "cannot replace a string with a byte string" , "string-matching regexp" , 1 , argv [0 ] , "byte string" , 1 , argv [2 ] , ((void * ) 0 ) ) )
        ; 
      }
    }
  }

  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    r = FUNCCALL(SETUP_XfOrM1743(_), regcomp_object (argv [0 ] ) ); 
  else 
  r = (regexp * ) argv [0 ] ; 

  if (0 ) {
#   define XfOrM1835_COUNT (0+XfOrM1743_COUNT)
#   define SETUP_XfOrM1835(x) SETUP_XfOrM1743(x)

    if (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
#     define XfOrM1836_COUNT (0+XfOrM1835_COUNT)
#     define SETUP_XfOrM1836(x) SETUP_XfOrM1835(x)

# 5814 "bc/src/regexp.c"
      if (! FUNCCALL(SETUP_XfOrM1836(_), scheme_check_proc_arity (((void * ) 0 ) , r -> nsubexp , 2 , argc , argv ) )) {
#       define XfOrM1837_COUNT (0+XfOrM1836_COUNT)
#       define SETUP_XfOrM1837(x) SETUP_XfOrM1836(x)
        FUNCCALL_EMPTY(scheme_contract_error (name , "replace procedure's arity does not include regexp's match count" , "regexp" , 1 , r , "regexp match count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (r -> nsubexp ) ) ) << 1 ) | 0x1 ) ) , "replace procedure" , 1 , argv [2 ] , ((void * ) 0 ) ) )


        ; 
      }
    }
  }

  if (argc > 3 ) {
#   define XfOrM1834_COUNT (0+XfOrM1743_COUNT)
#   define SETUP_XfOrM1834(x) SETUP_XfOrM1743(x)

# 5826 "bc/src/regexp.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "bytes?" , 3 , argc , argv ) ); 
    prefix = (((Scheme_Simple_Object * ) (argv [3 ] ) ) -> u . byte_str_val . string_val ) ; 
    prefix_len = (((Scheme_Simple_Object * ) (argv [3 ] ) ) -> u . byte_str_val . tag_val ) ; 
    prefix_offset = 0 ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#   define XfOrM1833_COUNT (0+XfOrM1743_COUNT)
#   define SETUP_XfOrM1833(x) SETUP_XfOrM1743(x)

# 5834 "bc/src/regexp.c"
    orig = FUNCCALL(SETUP_XfOrM1833(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
    if (r -> flags & 0x01 )
      was_non_byte = 1 ; 
    else 
    was_non_byte = 0 ; 
  }

# 5839 "bc/src/regexp.c"
  else {
    orig = argv [1 ] ; 
    was_non_byte = 0 ; 
  }
  source = (((Scheme_Simple_Object * ) (orig ) ) -> u . byte_str_val . string_val ) ; 
  sourcelen = (((Scheme_Simple_Object * ) (orig ) ) -> u . byte_str_val . tag_val ) ; 
  deststr = ((void * ) 0 ) ; 
  destlen = 0 ; 

  startp = ((rxpos * ) FUNCCALL(SETUP_XfOrM1743(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
  if (r -> nsubexp > 1 )
    maybep = ((rxpos * ) FUNCCALL(SETUP_XfOrM1743(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 
  else 
  maybep = ((void * ) 0 ) ; 
  endp = ((rxpos * ) FUNCCALL(SETUP_XfOrM1743(_), GC_malloc_atomic (sizeof (rxpos ) * (r -> nsubexp ) ) )) ; 

  minpos = - prefix_len ; 

  while (1 ) {
    int m ; 
#   define XfOrM1788_COUNT (0+XfOrM1743_COUNT)
#   define SETUP_XfOrM1788(x) SETUP_XfOrM1743(x)

# 5860 "bc/src/regexp.c"
    if (cannot_match_more )
      m = 0 ; 
    else 
    m = FUNCCALL(SETUP_XfOrM1788(_), regexec (name , r , source , srcoffset , sourcelen - srcoffset , 0 , ((void * ) 0 ) , startp , maybep , endp , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 , ((void * ) 0 ) , 0 , 0 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , prefix , prefix_len , prefix_offset ) )



    ; 

    if (m ) {
      char * insert ; 
      intptr_t len , end , startpd , endpd ; 
      BLOCK_SETUP((PUSH(insert, 0+XfOrM1788_COUNT)));
#     define XfOrM1793_COUNT (1+XfOrM1788_COUNT)
#     define SETUP_XfOrM1793(x) SETUP(XfOrM1793_COUNT)
      insert = NULLED_OUT ; 

# 5873 "bc/src/regexp.c"
      if (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
        int i ; 
        Scheme_Object * m , * * args , * quick_args [5 ] ; 
        BLOCK_SETUP((PUSHARRAY(quick_args, 5, 0+XfOrM1793_COUNT), PUSH(m, 3+XfOrM1793_COUNT), PUSH(args, 4+XfOrM1793_COUNT)));
#       define XfOrM1805_COUNT (5+XfOrM1793_COUNT)
#       define SETUP_XfOrM1805(x) SETUP(XfOrM1805_COUNT)
        m = NULLED_OUT ; 
        args = NULLED_OUT ; 
        NULL_OUT_ARRAY (quick_args ) ; 

# 5877 "bc/src/regexp.c"
        if (r -> nsubexp <= 5 ) {
          args = quick_args ; 
        }

# 5879 "bc/src/regexp.c"
        else {
#         define XfOrM1830_COUNT (0+XfOrM1805_COUNT)
#         define SETUP_XfOrM1830(x) SETUP_XfOrM1805(x)

# 5880 "bc/src/regexp.c"
          args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1830(_), GC_malloc (sizeof (Scheme_Object * ) * (r -> nsubexp ) ) )) ; 
        }

        for (i = r -> nsubexp ; i -- ; ) {
#         define XfOrM1820_COUNT (0+XfOrM1805_COUNT)
#         define SETUP_XfOrM1820(x) SETUP_XfOrM1805(x)

# 5884 "bc/src/regexp.c"
          if (startp [i ] < minpos ) {
            args [i ] = scheme_false ; 
          }

# 5886 "bc/src/regexp.c"
          else {
            intptr_t len ; 
#           define XfOrM1821_COUNT (0+XfOrM1820_COUNT)
#           define SETUP_XfOrM1821(x) SETUP_XfOrM1820(x)

# 5888 "bc/src/regexp.c"
            len = endp [i ] - startp [i ] ; 
            if (startp [i ] >= 0 ) {
#             define XfOrM1826_COUNT (0+XfOrM1821_COUNT)
#             define SETUP_XfOrM1826(x) SETUP_XfOrM1821(x)

# 5890 "bc/src/regexp.c"
              if (was_non_byte ) {
#               define XfOrM1828_COUNT (0+XfOrM1826_COUNT)
#               define SETUP_XfOrM1828(x) SETUP_XfOrM1826(x)

# 5891 "bc/src/regexp.c"
                m = FUNCCALL(SETUP_XfOrM1828(_), scheme_make_sized_offset_utf8_string (source , startp [i ] , len ) ); 
              }

# 5892 "bc/src/regexp.c"
              else {
#               define XfOrM1827_COUNT (0+XfOrM1826_COUNT)
#               define SETUP_XfOrM1827(x) SETUP_XfOrM1826(x)

# 5893 "bc/src/regexp.c"
                m = FUNCCALL(SETUP_XfOrM1827(_), scheme_make_sized_offset_byte_string (source , startp [i ] , len , 1 ) ); 
              }
            }

# 5895 "bc/src/regexp.c"
            else {

              int pre_len = len ; 
#             define XfOrM1822_COUNT (0+XfOrM1821_COUNT)
#             define SETUP_XfOrM1822(x) SETUP_XfOrM1821(x)

# 5899 "bc/src/regexp.c"
              if (endp [i ] > 0 )
                pre_len -= endp [i ] ; 
              m = FUNCCALL(SETUP_XfOrM1822(_), scheme_make_sized_offset_byte_string (prefix , prefix_offset + prefix_len + startp [i ] , pre_len , 1 ) )


              ; 
              if (was_non_byte )
                m = FUNCCALL(SETUP_XfOrM1822(_), scheme_byte_string_to_char_string (m ) ); 

              if (endp [i ] > 0 ) {
                Scheme_Object * m2 ; 
                BLOCK_SETUP((PUSH(m2, 0+XfOrM1822_COUNT)));
#               define XfOrM1823_COUNT (1+XfOrM1822_COUNT)
#               define SETUP_XfOrM1823(x) SETUP(XfOrM1823_COUNT)
                m2 = NULLED_OUT ; 

# 5910 "bc/src/regexp.c"
                if (was_non_byte ) {
#                 define XfOrM1825_COUNT (0+XfOrM1823_COUNT)
#                 define SETUP_XfOrM1825(x) SETUP_XfOrM1823(x)

# 5911 "bc/src/regexp.c"
                  m2 = FUNCCALL(SETUP_XfOrM1825(_), scheme_make_sized_offset_utf8_string (source , 0 , endp [i ] ) ); 
                  m = FUNCCALL(SETUP_XfOrM1825(_), scheme_append_char_string (m , m2 ) ); 
                }

# 5913 "bc/src/regexp.c"
                else {
#                 define XfOrM1824_COUNT (0+XfOrM1823_COUNT)
#                 define SETUP_XfOrM1824(x) SETUP_XfOrM1823(x)

# 5914 "bc/src/regexp.c"
                  m2 = FUNCCALL(SETUP_XfOrM1824(_), scheme_make_sized_offset_byte_string (source , 0 , endp [i ] , 1 ) ); 
                  m = FUNCCALL(SETUP_XfOrM1824(_), scheme_append_byte_string (m , m2 ) ); 
                }
              }
            }
            args [i ] = m ; 
          }
        }

        m = FUNCCALL(SETUP_XfOrM1805(_), scheme_do_eval (argv [2 ] , r -> nsubexp , args , 1 ) ); 

        if (! was_non_byte ) {
#         define XfOrM1808_COUNT (0+XfOrM1805_COUNT)
#         define SETUP_XfOrM1808(x) SETUP_XfOrM1805(x)

# 5926 "bc/src/regexp.c"
          if (! ((Scheme_Type ) (((((intptr_t ) (m ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (m ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) ) {
#           define XfOrM1809_COUNT (0+XfOrM1808_COUNT)
#           define SETUP_XfOrM1809(x) SETUP_XfOrM1808(x)

# 5927 "bc/src/regexp.c"
            args [0 ] = m ; 
            (__funcarg175 = FUNCCALL(SETUP_XfOrM1809(_), build_call_name (name ) ), FUNCCALL_AGAIN(scheme_wrong_contract (__funcarg175 , "bytes?" , - 1 , - 1 , args ) )) ; 
          }
          insert = (((Scheme_Simple_Object * ) (m ) ) -> u . byte_str_val . string_val ) ; 
          len = (((Scheme_Simple_Object * ) (m ) ) -> u . byte_str_val . tag_val ) ; 
        }

# 5932 "bc/src/regexp.c"
        else {
#         define XfOrM1806_COUNT (0+XfOrM1805_COUNT)
#         define SETUP_XfOrM1806(x) SETUP_XfOrM1805(x)

# 5933 "bc/src/regexp.c"
          if (! ((Scheme_Type ) (((((intptr_t ) (m ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (m ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) {
#           define XfOrM1807_COUNT (0+XfOrM1806_COUNT)
#           define SETUP_XfOrM1807(x) SETUP_XfOrM1806(x)

# 5934 "bc/src/regexp.c"
            args [0 ] = m ; 
            (__funcarg174 = FUNCCALL(SETUP_XfOrM1807(_), build_call_name (name ) ), FUNCCALL_AGAIN(scheme_wrong_contract (__funcarg174 , "string?" , - 1 , - 1 , args ) )) ; 
          }
          len = FUNCCALL(SETUP_XfOrM1806(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (m ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (m ) ) -> u . char_str_val . tag_val ) , ((void * ) 0 ) , 0 , 0 ) )

          ; 
          insert = (char * ) FUNCCALL(SETUP_XfOrM1806(_), GC_malloc_atomic (len ) ); 
          FUNCCALL(SETUP_XfOrM1806(_), scheme_utf8_encode ((((Scheme_Simple_Object * ) (m ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (m ) ) -> u . char_str_val . tag_val ) , (unsigned char * ) insert , 0 , 0 ) )

          ; 
        }
      }

# 5945 "bc/src/regexp.c"
      else {
#       define XfOrM1801_COUNT (0+XfOrM1793_COUNT)
#       define SETUP_XfOrM1801(x) SETUP_XfOrM1793(x)

# 5946 "bc/src/regexp.c"
        if (! deststr ) {
#         define XfOrM1802_COUNT (0+XfOrM1801_COUNT)
#         define SETUP_XfOrM1802(x) SETUP_XfOrM1801(x)

# 5947 "bc/src/regexp.c"
          if ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
            Scheme_Object * bs ; 
            BLOCK_SETUP((PUSH(bs, 0+XfOrM1802_COUNT)));
#           define XfOrM1804_COUNT (1+XfOrM1802_COUNT)
#           define SETUP_XfOrM1804(x) SETUP(XfOrM1804_COUNT)
            bs = NULLED_OUT ; 

# 5949 "bc/src/regexp.c"
            bs = FUNCCALL(SETUP_XfOrM1804(_), scheme_char_string_to_byte_string (argv [2 ] ) ); 
            deststr = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . string_val ) ; 
            destlen = (((Scheme_Simple_Object * ) (bs ) ) -> u . byte_str_val . tag_val ) ; 
          }

# 5952 "bc/src/regexp.c"
          else {
            deststr = (((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . byte_str_val . string_val ) ; 
            destlen = (((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . byte_str_val . tag_val ) ; 
          }
        }
        insert = FUNCCALL(SETUP_XfOrM1801(_), regsub (r , deststr , destlen , & len , source , startp , endp , minpos , prefix , prefix_offset ) )
        ; 
      }

      end = sourcelen ; 

      startpd = startp [0 ] ; 
      endpd = endp [0 ] ; 

      if (! startpd && (endpd == end ) && ! result_pre && ! all ) {
#       define XfOrM1800_COUNT (0+XfOrM1793_COUNT)
#       define SETUP_XfOrM1800(x) SETUP_XfOrM1793(x)

# 5967 "bc/src/regexp.c"
        if (was_non_byte )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (insert , len ) )) RET_VALUE_EMPTY_END ; 
        else 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string (insert , len , 0 ) )) RET_VALUE_EMPTY_END ; 
      }

# 5971 "bc/src/regexp.c"
      else if (! all ) {
        char * result ; 
        intptr_t total ; 
        BLOCK_SETUP((PUSH(result, 0+XfOrM1793_COUNT)));
#       define XfOrM1799_COUNT (1+XfOrM1793_COUNT)
#       define SETUP_XfOrM1799(x) SETUP(XfOrM1799_COUNT)
        result = NULLED_OUT ; 

# 5975 "bc/src/regexp.c"
        total = len + (startpd - srcoffset ) + (end - endpd ) ; 

        result = (char * ) FUNCCALL(SETUP_XfOrM1799(_), GC_malloc_atomic (total + 1 ) ); 
        (memcpy (result , source + srcoffset , startpd - srcoffset ) ) ; 
        (memcpy (result + (startpd - srcoffset ) , insert , len ) ) ; 
        (memcpy (result + (startpd - srcoffset ) + len , source + endpd , (end - endpd ) + 1 ) ) ; 

        if (was_non_byte )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (result , total ) )) RET_VALUE_EMPTY_END ; 
        else 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string (result , total , 0 ) )) RET_VALUE_EMPTY_END ; 
      }

# 5986 "bc/src/regexp.c"
      else {
        intptr_t total ; 
        int more ; 
#       define XfOrM1794_COUNT (0+XfOrM1793_COUNT)
#       define SETUP_XfOrM1794(x) SETUP_XfOrM1793(x)

# 5990 "bc/src/regexp.c"
        if (startpd == endpd ) {
#         define XfOrM1797_COUNT (0+XfOrM1794_COUNT)
#         define SETUP_XfOrM1797(x) SETUP_XfOrM1794(x)

# 5991 "bc/src/regexp.c"
          if (endpd == end ) {
            more = 0 ; 
            cannot_match_more = 1 ; 
          }

# 5994 "bc/src/regexp.c"
          else if (was_non_byte )
            more = FUNCCALL(SETUP_XfOrM1797(_), initial_char_len ((unsigned char * ) source , startpd , sourcelen ) ); 
          else 
          more = 1 ; 
        }

# 5998 "bc/src/regexp.c"
        else 
        more = 0 ; 

        total = len + (startpd - srcoffset ) + more ; 
        if (! result_pre || (total + result_pre_len > result_pre_size ) ) {
          char * naya ; 
          intptr_t new_size = (2 * ((result_pre_len < total ) ? total : result_pre_len ) ) + 1 ; 
          BLOCK_SETUP((PUSH(naya, 0+XfOrM1794_COUNT)));
#         define XfOrM1796_COUNT (1+XfOrM1794_COUNT)
#         define SETUP_XfOrM1796(x) SETUP(XfOrM1796_COUNT)
          naya = NULLED_OUT ; 

# 6005 "bc/src/regexp.c"
          naya = (char * ) FUNCCALL(SETUP_XfOrM1796(_), GC_malloc_atomic (new_size ) ); 
          if (result_pre_size > 0 )
            (memcpy (naya , result_pre , result_pre_len ) ) ; 
          result_pre = naya ; 
          result_pre_size = new_size ; 
        }
        (
        memcpy (result_pre + result_pre_len , source + srcoffset , startpd - srcoffset ) ) ; 
        (memcpy (result_pre + result_pre_len + (startpd - srcoffset ) , insert , len ) ) ; 
        if (more ) {
#         define XfOrM1795_COUNT (0+XfOrM1794_COUNT)
#         define SETUP_XfOrM1795(x) SETUP_XfOrM1794(x)
          (
# 6015 "bc/src/regexp.c"
          memcpy (result_pre + result_pre_len + (endpd - srcoffset ) + len , source + startpd , more ) ) ; 
        }
        result_pre_len += total ; 

        srcoffset = endpd + more ; 
      }
    }

# 6021 "bc/src/regexp.c"
    else if (! result_pre ) {
      if (was_non_byte )
        RET_VALUE_START (argv [1 ] ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (orig ) RET_VALUE_END ; 
    }

# 6026 "bc/src/regexp.c"
    else {
      char * result ; 
      intptr_t total , slen ; 
      BLOCK_SETUP((PUSH(result, 0+XfOrM1788_COUNT)));
#     define XfOrM1791_COUNT (1+XfOrM1788_COUNT)
#     define SETUP_XfOrM1791(x) SETUP(XfOrM1791_COUNT)
      result = NULLED_OUT ; 

# 6030 "bc/src/regexp.c"
      slen = sourcelen - srcoffset ; 
      total = result_pre_len + slen ; 

      result = (char * ) FUNCCALL(SETUP_XfOrM1791(_), GC_malloc_atomic (total + 1 ) ); 
      (memcpy (result , result_pre , result_pre_len ) ) ; 
      (memcpy (result + result_pre_len , source + srcoffset , slen ) ) ; 
      result [result_pre_len + slen ] = 0 ; 

      if (was_non_byte )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (result , total ) )) RET_VALUE_EMPTY_END ; 
      else 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_byte_string (result , total , 0 ) )) RET_VALUE_EMPTY_END ; 
    }

    {
#     define XfOrM1789_COUNT (0+XfOrM1788_COUNT)
#     define SETUP_XfOrM1789(x) SETUP_XfOrM1788(x)

# 6044 "bc/src/regexp.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM1790_COUNT (0+XfOrM1789_COUNT)
#       define SETUP_XfOrM1790(x) SETUP_XfOrM1789(x)
        FUNCCALL(SETUP_XfOrM1790(_), scheme_out_of_fuel () )
# 6044 "bc/src/regexp.c"
        ; 
      }
    }

# 6044 "bc/src/regexp.c"
    ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6048 "bc/src/regexp.c"
static Scheme_Object * replace (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6050 "bc/src/regexp.c"
  return gen_replace ("regexp-replace" , argc , argv , 0 ) ; 
}

static Scheme_Object * replace_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6055 "bc/src/regexp.c"
  return gen_replace ("regexp-replace*" , argc , argv , 1 ) ; 
}

static Scheme_Object * regexp_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6060 "bc/src/regexp.c"
  return (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) 
  && (((regexp * ) argv [0 ] ) -> flags & 0x01 ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * byte_regexp_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6068 "bc/src/regexp.c"
  return (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) 
  && ! (((regexp * ) argv [0 ] ) -> flags & 0x01 ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * pregexp_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6076 "bc/src/regexp.c"
  return (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) 
  && (((regexp * ) argv [0 ] ) -> flags & 0x01 ) 
  && (((regexp * ) argv [0 ] ) -> flags & 0x02 ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * byte_pregexp_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6085 "bc/src/regexp.c"
  return (((((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) == scheme_regexp_type ) 
  && ! (((regexp * ) argv [0 ] ) -> flags & 0x01 ) 
  && (((regexp * ) argv [0 ] ) -> flags & 0x02 ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

Scheme_Object * regexp_lookbehind (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6094 "bc/src/regexp.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_regexp_type ) ) )
    scheme_wrong_contract ("regexp-max-lookbehind" , "(or/c regexp? byte-regexp?)" , 0 , argc , argv ) ; 
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (((regexp * ) argv [0 ] ) -> maxlookback ) ) ) << 1 ) | 0x1 ) ) ; 
}

Scheme_Object * scheme_regexp_source (Scheme_Object * re ) 
{
  /* No conversion */

# 6101 "bc/src/regexp.c"
  return ((regexp * ) re ) -> source ; 
}

int scheme_regexp_is_byte (Scheme_Object * re ) 
{
  /* No conversion */

# 6106 "bc/src/regexp.c"
  return ! (((regexp * ) re ) -> flags & 0x01 ) ; 
}

int scheme_regexp_is_pregexp (Scheme_Object * re ) 
{
  /* No conversion */

# 6111 "bc/src/regexp.c"
  return ! ! (((regexp * ) re ) -> flags & 0x02 ) ; 
}

# 3 "bc/src/mzmark_regexp.inc"
static int mark_regexp_SIZE (void * p , struct NewGC * gc ) {




  return 0 ; 
}


static int mark_regexp_MARK (void * p , struct NewGC * gc ) {

  regexp * r = (regexp * ) p ; 
  GC_mark2 (& (r -> source ) , gc ) ; 
  GC_mark2 (& (r -> regstart ) , gc ) ; 

  return 0 ; 
}






static int mark_regexp_FIXUP (void * p , struct NewGC * gc ) {

  regexp * r = (regexp * ) p ; 
  GC_fixup2 (& (r -> source ) , gc ) ; 
  GC_fixup2 (& (r -> regstart ) , gc ) ; 

  return 0 ; 
}

# 44 "bc/src/mzmark_regexp.inc"
static int mark_regwork_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_regwork_MARK (void * p , struct NewGC * gc ) {

  Regwork * r = (Regwork * ) p ; 
  GC_mark2 (& (r -> str ) , gc ) ; 
  GC_mark2 (& (r -> instr ) , gc ) ; 
  GC_mark2 (& (r -> port ) , gc ) ; 
  GC_mark2 (& (r -> unless_evt ) , gc ) ; 
  GC_mark2 (& (r -> startp ) , gc ) ; 
  GC_mark2 (& (r -> maybep ) , gc ) ; 
  GC_mark2 (& (r -> endp ) , gc ) ; 
  GC_mark2 (& (r -> counters ) , gc ) ; 
  GC_mark2 (& (r -> peekskip ) , gc ) ; 
  GC_mark2 (& (r -> prefix ) , gc ) ; 
  GC_mark2 (& (r -> lazy_string ) , gc ) ; 
  GC_mark2 (& (r -> rewind_stack ) , gc ) ; 

  return 0 ; 
}






static int mark_regwork_FIXUP (void * p , struct NewGC * gc ) {

  Regwork * r = (Regwork * ) p ; 
  GC_fixup2 (& (r -> str ) , gc ) ; 
  GC_fixup2 (& (r -> instr ) , gc ) ; 
  GC_fixup2 (& (r -> port ) , gc ) ; 
  GC_fixup2 (& (r -> unless_evt ) , gc ) ; 
  GC_fixup2 (& (r -> startp ) , gc ) ; 
  GC_fixup2 (& (r -> maybep ) , gc ) ; 
  GC_fixup2 (& (r -> endp ) , gc ) ; 
  GC_fixup2 (& (r -> counters ) , gc ) ; 
  GC_fixup2 (& (r -> peekskip ) , gc ) ; 
  GC_fixup2 (& (r -> prefix ) , gc ) ; 
  GC_fixup2 (& (r -> lazy_string ) , gc ) ; 
  GC_fixup2 (& (r -> rewind_stack ) , gc ) ; 

  return 0 ; 
}

# 104 "bc/src/mzmark_regexp.inc"
static int mark_lazy_string_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_lazy_string_MARK (void * p , struct NewGC * gc ) {

  rx_lazy_str_t * ls = (rx_lazy_str_t * ) p ; 
  GC_mark2 (& (ls -> s ) , gc ) ; 
  GC_mark2 (& (ls -> chars ) , gc ) ; 

  return 0 ; 
}






static int mark_lazy_string_FIXUP (void * p , struct NewGC * gc ) {

  rx_lazy_str_t * ls = (rx_lazy_str_t * ) p ; 
  GC_fixup2 (& (ls -> s ) , gc ) ; 
  GC_fixup2 (& (ls -> chars ) , gc ) ; 

  return 0 ; 
}

# 6120 "bc/src/regexp.c"
void scheme_regexp_initialize (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg197 = NULLED_OUT ; 
  Scheme_Object * __funcarg196 = NULLED_OUT ; 
  Scheme_Object * __funcarg195 = NULLED_OUT ; 
  Scheme_Object * __funcarg194 = NULLED_OUT ; 
  Scheme_Object * __funcarg193 = NULLED_OUT ; 
  Scheme_Object * __funcarg192 = NULLED_OUT ; 
  Scheme_Object * __funcarg191 = NULLED_OUT ; 
  Scheme_Object * __funcarg190 = NULLED_OUT ; 
  Scheme_Object * __funcarg189 = NULLED_OUT ; 
  Scheme_Object * __funcarg188 = NULLED_OUT ; 
  Scheme_Object * __funcarg187 = NULLED_OUT ; 
  Scheme_Object * __funcarg186 = NULLED_OUT ; 
  Scheme_Object * __funcarg185 = NULLED_OUT ; 
  Scheme_Object * __funcarg184 = NULLED_OUT ; 
  Scheme_Object * __funcarg183 = NULLED_OUT ; 
  Scheme_Object * __funcarg182 = NULLED_OUT ; 
  Scheme_Object * __funcarg181 = NULLED_OUT ; 
  Scheme_Object * __funcarg180 = NULLED_OUT ; 
  Scheme_Object * __funcarg179 = NULLED_OUT ; 
  Scheme_Object * __funcarg178 = NULLED_OUT ; 
  Scheme_Object * __funcarg177 = NULLED_OUT ; 
  Scheme_Object * __funcarg176 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM1851_COUNT (1)
# define SETUP_XfOrM1851(x) SETUP(XfOrM1851_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1851(_), GC_register_traversers2 (scheme_regexp_type , mark_regexp_SIZE , mark_regexp_MARK , mark_regexp_FIXUP , 0 , 0 ) )
# 6123 "bc/src/regexp.c"
  ; 
  FUNCCALL(SETUP_XfOrM1851(_), GC_register_traversers2 (scheme_rt_regwork , mark_regwork_SIZE , mark_regwork_MARK , mark_regwork_FIXUP , 1 , 0 ) ); 
  FUNCCALL_AGAIN(GC_register_traversers2 (scheme_rt_rx_lazy_string , mark_lazy_string_SIZE , mark_lazy_string_MARK , mark_lazy_string_FIXUP , 1 , 0 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & empty_byte_string , sizeof (empty_byte_string ) ) )

  ; 
  empty_byte_string = FUNCCALL_AGAIN(scheme_alloc_byte_string (0 , 0 ) ); 
  (__funcarg197 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (make_regexp , "byte-regexp" , 1 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("byte-regexp" , __funcarg197 , env ) )) ; 
  (__funcarg196 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (make_utf8_regexp , "regexp" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp" , __funcarg196 , env ) )) ; 
  (__funcarg195 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (make_pregexp , "byte-pregexp" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("byte-pregexp" , __funcarg195 , env ) )) ; 
  (__funcarg194 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (make_utf8_pregexp , "pregexp" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("pregexp" , __funcarg194 , env ) )) ; 
  (__funcarg193 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (compare , "regexp-match" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match" , __funcarg193 , env ) )) ; 
  (__funcarg192 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_everything (compare_end , 1 , "regexp-match/end" , 2 , 7 , 0 , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match/end" , __funcarg192 , env ) )) ; 
  (__funcarg191 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (positions , "regexp-match-positions" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match-positions" , __funcarg191 , env ) )) ; 
  (__funcarg190 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_everything (positions_end , 1 , "regexp-match-positions/end" , 2 , 7 , 0 , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match-positions/end" , __funcarg190 , env ) )) ; 
  (__funcarg189 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (compare_bool , "regexp-match?" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match?" , __funcarg189 , env ) )) ; 
  (__funcarg188 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (compare_peek , "regexp-match-peek" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match-peek" , __funcarg188 , env ) )) ; 
  (__funcarg187 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (positions_peek , "regexp-match-peek-positions" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match-peek-positions" , __funcarg187 , env ) )) ; 
  (__funcarg186 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_everything (positions_peek_end , 1 , "regexp-match-peek-positions/end" , 2 , 7 , 0 , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match-peek-positions/end" , __funcarg186 , env ) )) ; 
  (__funcarg185 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (compare_peek_nonblock , "regexp-match-peek-immediate" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match-peek-immediate" , __funcarg185 , env ) )) ; 
  (__funcarg184 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (positions_peek_nonblock , "regexp-match-peek-positions-immediate" , 2 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match-peek-positions-immediate" , __funcarg184 , env ) )) ; 
  (__funcarg183 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_everything (positions_peek_nonblock_end , 1 , "regexp-match-peek-positions-immediate/end" , 2 , 7 , 0 , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-match-peek-positions-immediate/end" , __funcarg183 , env ) )) ; 
  (__funcarg182 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (replace , "regexp-replace" , 3 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-replace" , __funcarg182 , env ) )) ; 
  (__funcarg181 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_prim_w_arity (replace_star , "regexp-replace*" , 3 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-replace*" , __funcarg181 , env ) )) ; 
  (__funcarg180 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_folding_prim (regexp_p , "regexp?" , 1 , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp?" , __funcarg180 , env ) )) ; 
  (__funcarg179 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_folding_prim (byte_regexp_p , "byte-regexp?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("byte-regexp?" , __funcarg179 , env ) )) ; 
  (__funcarg178 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_folding_prim (pregexp_p , "pregexp?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("pregexp?" , __funcarg178 , env ) )) ; 
  (__funcarg177 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_folding_prim (byte_pregexp_p , "byte-pregexp?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("byte-pregexp?" , __funcarg177 , env ) )) ; 
  (__funcarg176 = FUNCCALL(SETUP_XfOrM1851(_), scheme_make_folding_prim (regexp_lookbehind , "regexp-max-lookbehind" , 1 , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("regexp-max-lookbehind" , __funcarg176 , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6157 "bc/src/regexp.c"
void scheme_init_regexp_places () 
{
  /* No conversion */

# 6159 "bc/src/regexp.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regparsestr_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regstr_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackknown_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regbackdepends_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorproc_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorproc_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorval_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> regerrorval_ ) ) ) ; 
}
