#include "precomp.h"

# 19 "bc/src/resolve.c"
struct Resolve_Info 
{
  Scheme_Type type ; 
  char in_module , in_proc , enforce_const , no_lift , need_instance_access ; 
  int current_depth ; 


  int current_lex_depth ; 


  int max_let_depth ; 

  Scheme_Linklet * linklet ; 
  mzshort toplevel_pos ; 

  void * tl_map ; 

  struct Resolve_Info * top ; 

  Scheme_Hash_Tree * redirects ; 

  Scheme_Object * lifts ; 
  struct Resolve_Info * next ; 

  int num_toplevels ; 


  int * toplevel_starts ; 






  int * toplevel_deltas ; 


  Scheme_Hash_Table * toplevel_defns ; 







  Scheme_Hash_Table * static_mode ; 
}

# 65 "bc/src/resolve.c"
; 



static Scheme_Object * resolve_expr (Scheme_Object * expr , Resolve_Info * info ) ; 
static Scheme_Object * resolve_lambda (Scheme_Object * _lam , Resolve_Info * info , 
int can_lift , int convert , int just_compute_lift , 
Scheme_Object * precomputed_lift ) ; 
static Resolve_Info * resolve_info_extend (Resolve_Info * info , int size , int lambda ) ; 
static void resolve_info_add_mapping (Resolve_Info * info , Scheme_IR_Local * var , Scheme_Object * v ) ; 
static int resolve_info_lookup (Resolve_Info * resolve , Scheme_IR_Local * var , Scheme_Object * * lifted , 
int convert_shift , int flags ) ; 
static Scheme_Object * resolve_info_lift_added (Resolve_Info * resolve , Scheme_Object * var , int convert_shift ) ; 
static void resolve_info_set_toplevel_pos (Resolve_Info * info , int pos ) ; 
static void merge_resolve (Resolve_Info * info , Resolve_Info * new_info ) ; 
static void merge_resolve_tl_map (Resolve_Info * info , Resolve_Info * new_info ) ; 
static Scheme_Object * resolve_generate_stub_lift (Resolve_Info * info ) ; 
static int resolve_toplevel_pos (Resolve_Info * info ) ; 
static Scheme_Object * resolve_toplevel (Resolve_Info * info , Scheme_Object * expr , int as_reference ) ; 
static Scheme_Object * resolve_invent_toplevel (Resolve_Info * info ) ; 
static Scheme_Object * resolve_invented_toplevel_to_defn (Resolve_Info * info , Scheme_Object * tl ) ; 
static Scheme_Object * shift_lifted_reference (Scheme_Object * tl , Resolve_Info * info , int delta ) ; 
static Scheme_Object * shift_toplevel (Scheme_Object * expr , int delta ) ; 
static int is_nonconstant_procedure (Scheme_Object * lam , Resolve_Info * info , Scheme_Hash_Tree * exclude_vars ) ; 
static int resolve_is_inside_proc (Resolve_Info * info ) ; 
static int resolve_has_toplevel (Resolve_Info * info ) ; 
static void set_tl_pos_used (Resolve_Info * info , int pos ) ; 
static void install_static_prefix (Scheme_Linklet * linket , Resolve_Info * ri ) ; 
static Scheme_Object * generate_lifted_name (Scheme_Hash_Table * used_names , int search_start ) ; 
static void enable_expression_resolve_lifts (Resolve_Info * ri ) ; 
static void extend_linklet_defns (Scheme_Linklet * linklet , int num_lifts ) ; 
static void prune_unused_imports (Scheme_Linklet * linklet ) ; 
static void prepare_definition_queue (Scheme_Linklet * linklet , Resolve_Info * rslv ) ; 
static void remove_definition_names (Scheme_Object * defn , Scheme_Linklet * linklet ) ; 
static Resolve_Info * resolve_info_create (Scheme_Linklet * rp , int enforce_const , int static_mode ) ; 


static void register_traversers (void ) ; 





void scheme_init_resolve () 
{
  /* No conversion */
  register_traversers () ; 
}






static Scheme_Object * check_converted_rator (Scheme_Object * rator , Resolve_Info * info , Scheme_Object * * new_rator , 
int orig_arg_cnt , int * _rdelta ) 



{
  Scheme_Object * lifted ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(_rdelta, 1), PUSH(lifted, 2), PUSH(rator, 3), PUSH(new_rator, 4)));
# define XfOrM2_COUNT (5)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  lifted = NULLED_OUT ; 

# 127 "bc/src/resolve.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_local_type ) ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  (void ) FUNCCALL(SETUP_XfOrM2(_), resolve_info_lookup (info , ((Scheme_IR_Local * ) rator ) , & lifted , 0 , 0 ) ); 

  if (lifted && ((Scheme_Type ) (((((intptr_t ) (lifted ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lifted ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ) {
    Scheme_Object * vec , * arity ; 
    BLOCK_SETUP((PUSH(vec, 0+XfOrM2_COUNT), PUSH(arity, 1+XfOrM2_COUNT)));
#   define XfOrM3_COUNT (2+XfOrM2_COUNT)
#   define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
    vec = NULLED_OUT ; 
    arity = NULLED_OUT ; 

# 135 "bc/src/resolve.c"
    * new_rator = (((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . car ) ; 
    vec = (((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . cdr ) ; 
    * _rdelta = 0 ; 

    if ((Scheme_Type ) (((((intptr_t ) (* new_rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (* new_rator ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) )  {
      Scheme_Object * tl ; 
      BLOCK_SETUP((PUSH(tl, 0+XfOrM3_COUNT)));
#     define XfOrM10_COUNT (1+XfOrM3_COUNT)
#     define SETUP_XfOrM10(x) SETUP(XfOrM10_COUNT)
      tl = NULLED_OUT ; 

# 141 "bc/src/resolve.c"
      tl = FUNCCALL(SETUP_XfOrM10(_), shift_lifted_reference (* new_rator , info , orig_arg_cnt + (((Scheme_Vector * ) (vec ) ) -> size ) - 1 ) ); 
      * new_rator = tl ; 
    }

    if ((((Scheme_Vector * ) (vec ) ) -> size ) > 1 ) {
#     define XfOrM4_COUNT (0+XfOrM3_COUNT)
#     define SETUP_XfOrM4(x) SETUP_XfOrM3(x)


      arity = (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] ; 
      if (((intptr_t ) (arity ) ) & 0x1 )  {
        if (orig_arg_cnt == (((intptr_t ) (arity ) ) >> 1 ) )
          arity = ((void * ) 0 ) ; 
      }

# 154 "bc/src/resolve.c"
      else {
#       define XfOrM7_COUNT (0+XfOrM4_COUNT)
#       define SETUP_XfOrM7(x) SETUP_XfOrM4(x)

# 155 "bc/src/resolve.c"
        arity = (((Scheme_Small_Object * ) (arity ) ) -> u . ptr_val ) ; 
        if (orig_arg_cnt >= (((intptr_t ) (arity ) ) >> 1 ) )
          arity = ((void * ) 0 ) ; 
        else {
          Scheme_App2_Rec * app ; 
          BLOCK_SETUP((PUSH(app, 0+XfOrM7_COUNT)));
#         define XfOrM8_COUNT (1+XfOrM7_COUNT)
#         define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
          app = NULLED_OUT ; 

# 160 "bc/src/resolve.c"
          app = ((Scheme_App2_Rec * ) FUNCCALL(SETUP_XfOrM8(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App2_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
          app -> iso . so . type = scheme_application2_type ; 
          app -> rator = scheme_make_arity_at_least ; 
          app -> rand = arity ; 
          arity = (Scheme_Object * ) app ; 
          * _rdelta = 1 ; 
        }
      }

      if (arity ) {


        Scheme_Object * old_rator = * new_rator ; 
        BLOCK_SETUP((PUSH(old_rator, 0+XfOrM4_COUNT)));
#       define XfOrM5_COUNT (1+XfOrM4_COUNT)
#       define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)

# 173 "bc/src/resolve.c"
        if ((Scheme_Type ) (((((intptr_t ) (old_rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (old_rator ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) )  {


          int delta ; 
#         define XfOrM6_COUNT (0+XfOrM5_COUNT)
#         define SETUP_XfOrM6(x) SETUP_XfOrM5(x)

# 177 "bc/src/resolve.c"
          delta = 3 - (((Scheme_Vector * ) (vec ) ) -> size ) ; 
          if (delta )
            old_rator = FUNCCALL(SETUP_XfOrM6(_), shift_toplevel (old_rator , delta ) ); 
        }
        vec = FUNCCALL(SETUP_XfOrM5(_), scheme_make_vector (3 , ((void * ) 0 ) ) ); 
        (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
        (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = old_rator ; 
        (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = arity ; 
        * new_rator = scheme_raise_arity_error_proc ; 
      }
    }

    RET_VALUE_START (vec ) RET_VALUE_END ; 
  }

# 190 "bc/src/resolve.c"
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 194 "bc/src/resolve.c"
static Scheme_Object * resolve_application (Scheme_Object * o , Resolve_Info * orig_info , int already_resolved_arg_count ) 
{
  Resolve_Info * info ; 
  Scheme_App_Rec * app ; 
  int i , n , devals ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(orig_info, 0), PUSH(app, 1), PUSH(info, 2)));
# define XfOrM11_COUNT (3)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  info = NULLED_OUT ; 
  app = NULLED_OUT ; 

# 200 "bc/src/resolve.c"
  app = (Scheme_App_Rec * ) o ; 

  n = app -> num_args + 1 ; 

  if (! already_resolved_arg_count ) {

    Scheme_Object * additions = ((void * ) 0 ) , * rator ; 
    int rdelta ; 
    BLOCK_SETUP((PUSH(additions, 0+XfOrM11_COUNT), PUSH(rator, 1+XfOrM11_COUNT)));
#   define XfOrM20_COUNT (2+XfOrM11_COUNT)
#   define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
    rator = NULLED_OUT ; 

# 208 "bc/src/resolve.c"
    additions = FUNCCALL(SETUP_XfOrM20(_), check_converted_rator (app -> args [0 ] , orig_info , & rator , n - 1 , & rdelta ) ); 
    if (additions ) {

      Scheme_App_Rec * app2 ; 
      Scheme_Object * arg ; 
      int m ; 
      BLOCK_SETUP((PUSH(arg, 0+XfOrM20_COUNT), PUSH(app2, 1+XfOrM20_COUNT)));
#     define XfOrM21_COUNT (2+XfOrM20_COUNT)
#     define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
      app2 = NULLED_OUT ; 
      arg = NULLED_OUT ; 

# 214 "bc/src/resolve.c"
      m = (((Scheme_Vector * ) (additions ) ) -> size ) - 1 ; 
      app2 = FUNCCALL(SETUP_XfOrM21(_), scheme_malloc_application (n + m ) ); 
      for (i = 0 ; i < m ; i ++ ) {
#       define XfOrM25_COUNT (0+XfOrM21_COUNT)
#       define SETUP_XfOrM25(x) SETUP_XfOrM21(x)

# 217 "bc/src/resolve.c"
        arg = FUNCCALL(SETUP_XfOrM25(_), resolve_info_lift_added (orig_info , (((Scheme_Vector * ) (additions ) ) -> els ) [i + 1 ] , n - 1 + m ) ); 
        app2 -> args [i + 1 ] = arg ; 
      }
      for (i = 1 ; i < n ; i ++ ) {
        app2 -> args [i + m ] = app -> args [i ] ; 
      }
      app2 -> args [0 ] = rator ; 
      n += m ; 
      app = app2 ; 
      already_resolved_arg_count = m + 1 + rdelta ; 
      (& (app ) -> iso ) -> so . keyex |= (1 << 13 ) ; 
    }
  }

  devals = sizeof (Scheme_App_Rec ) + ((n - 0 ) * sizeof (Scheme_Object * ) ) ; 

  info = FUNCCALL(SETUP_XfOrM11(_), resolve_info_extend (orig_info , n - 1 , 0 ) ); 

  for (i = 0 ; i < n ; i ++ ) {
    Scheme_Object * le ; 
    BLOCK_SETUP((PUSH(le, 0+XfOrM11_COUNT)));
#   define XfOrM17_COUNT (1+XfOrM11_COUNT)
#   define SETUP_XfOrM17(x) SETUP(XfOrM17_COUNT)
    le = NULLED_OUT ; 

# 237 "bc/src/resolve.c"
    if (already_resolved_arg_count ) {
      already_resolved_arg_count -- ; 
    }

# 239 "bc/src/resolve.c"
    else {
#     define XfOrM18_COUNT (0+XfOrM17_COUNT)
#     define SETUP_XfOrM18(x) SETUP_XfOrM17(x)

# 240 "bc/src/resolve.c"
      le = FUNCCALL(SETUP_XfOrM18(_), resolve_expr (app -> args [i ] , info ) ); 
      app -> args [i ] = le ; 
    }
  }
  FUNCCALL(SETUP_XfOrM11(_), merge_resolve (orig_info , info ) )
  ; 

  for (i = 0 ; i < n ; i ++ ) {
    char et ; 
#   define XfOrM13_COUNT (0+XfOrM11_COUNT)
#   define SETUP_XfOrM13(x) SETUP_XfOrM11(x)

# 249 "bc/src/resolve.c"
    et = FUNCCALL(SETUP_XfOrM13(_), scheme_get_eval_type (app -> args [i ] ) ); 
    ((char * ) app XFORM_OK_PLUS devals ) [i ] = et ; 
  }

  RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 256 "bc/src/resolve.c"
static Scheme_Object * resolve_application3 (Scheme_Object * o , Resolve_Info * orig_info , int already_resolved_arg_count ) ; 

static void set_app2_eval_type (Scheme_App2_Rec * app ) 
{
  short et ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(app, 0)));
# define XfOrM26_COUNT (1)
# define SETUP_XfOrM26(x) SETUP(XfOrM26_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 262 "bc/src/resolve.c"
  et = FUNCCALL(SETUP_XfOrM26(_), scheme_get_eval_type (app -> rand ) ); 
  et = et << 3 ; 
  et += FUNCCALL(SETUP_XfOrM26(_), scheme_get_eval_type (app -> rator ) ); 

  (& (app ) -> iso ) -> so . keyex = et | ((& (app ) -> iso ) -> so . keyex & ((1 << 11 ) | (1 << 12 ) | (1 << 13 ) ) ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 269 "bc/src/resolve.c"
void scheme_reset_app2_eval_type (Scheme_App2_Rec * app ) 
{
  /* No conversion */

# 271 "bc/src/resolve.c"
  set_app2_eval_type (app ) ; 
}

static Scheme_Object * resolve_application2 (Scheme_Object * o , Resolve_Info * orig_info , int already_resolved_arg_count ) 
{
  Resolve_Info * info ; 
  Scheme_App2_Rec * app ; 
  Scheme_Object * le , * arg ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(le, 0), PUSH(orig_info, 1), PUSH(app, 2), PUSH(arg, 3), PUSH(info, 4)));
# define XfOrM28_COUNT (5)
# define SETUP_XfOrM28(x) SETUP(XfOrM28_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  info = NULLED_OUT ; 
  app = NULLED_OUT ; 
  le = NULLED_OUT ; 
  arg = NULLED_OUT ; 

# 280 "bc/src/resolve.c"
  app = (Scheme_App2_Rec * ) o ; 

  if (! already_resolved_arg_count ) {

    Scheme_Object * additions = ((void * ) 0 ) , * rator ; 
    int rdelta ; 
    BLOCK_SETUP((PUSH(additions, 0+XfOrM28_COUNT), PUSH(rator, 1+XfOrM28_COUNT)));
#   define XfOrM33_COUNT (2+XfOrM28_COUNT)
#   define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
    rator = NULLED_OUT ; 

# 286 "bc/src/resolve.c"
    additions = FUNCCALL(SETUP_XfOrM33(_), check_converted_rator (app -> rator , orig_info , & rator , 1 , & rdelta ) ); 
    if (additions ) {
      int m ; 
#     define XfOrM34_COUNT (0+XfOrM33_COUNT)
#     define SETUP_XfOrM34(x) SETUP_XfOrM33(x)

# 289 "bc/src/resolve.c"
      m = (((Scheme_Vector * ) (additions ) ) -> size ) - 1 ; 
      if (! m ) {
        app -> rator = rator ; 
        already_resolved_arg_count = 1 + rdelta ; 
      }

# 293 "bc/src/resolve.c"
      else if (m > 1 ) {

        Scheme_App_Rec * app2 ; 
        int i ; 
        BLOCK_SETUP((PUSH(app2, 0+XfOrM34_COUNT)));
#       define XfOrM36_COUNT (1+XfOrM34_COUNT)
#       define SETUP_XfOrM36(x) SETUP(XfOrM36_COUNT)
        app2 = NULLED_OUT ; 

# 297 "bc/src/resolve.c"
        app2 = FUNCCALL(SETUP_XfOrM36(_), scheme_malloc_application (2 + m ) ); 
        for (i = 0 ; i < m ; i ++ ) {
#         define XfOrM38_COUNT (0+XfOrM36_COUNT)
#         define SETUP_XfOrM38(x) SETUP_XfOrM36(x)

# 299 "bc/src/resolve.c"
          arg = FUNCCALL(SETUP_XfOrM38(_), resolve_info_lift_added (orig_info , (((Scheme_Vector * ) (additions ) ) -> els ) [i + 1 ] , 1 + m ) ); 
          app2 -> args [i + 1 ] = arg ; 
        }
        app2 -> args [0 ] = rator ; 
        app2 -> args [m + 1 ] = app -> rand ; 
        (& (app2 ) -> iso ) -> so . keyex |= (1 << 13 ) ; 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM36(_), resolve_application ((Scheme_Object * ) app2 , orig_info , m + 1 + rdelta ) )) RET_VALUE_END ; 
      }

# 306 "bc/src/resolve.c"
      else {
        Scheme_App3_Rec * app2 ; 
        BLOCK_SETUP((PUSH(app2, 0+XfOrM34_COUNT)));
#       define XfOrM35_COUNT (1+XfOrM34_COUNT)
#       define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)
        app2 = NULLED_OUT ; 

# 308 "bc/src/resolve.c"
        app2 = ((Scheme_App3_Rec * ) FUNCCALL(SETUP_XfOrM35(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App3_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        app2 -> iso . so . type = scheme_application3_type ; 
        app2 -> rator = rator ; 
        arg = FUNCCALL(SETUP_XfOrM35(_), resolve_info_lift_added (orig_info , (((Scheme_Vector * ) (additions ) ) -> els ) [1 ] , 1 + 1 ) ); 
        app2 -> rand1 = arg ; 
        app2 -> rand2 = app -> rand ; 
        (& (app2 ) -> iso ) -> so . keyex |= (1 << 13 ) ; 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM35(_), resolve_application3 ((Scheme_Object * ) app2 , orig_info , m + 1 + rdelta ) )) RET_VALUE_END ; 
      }
    }
  }

  info = FUNCCALL(SETUP_XfOrM28(_), resolve_info_extend (orig_info , 1 , 0 ) ); 

  if (! already_resolved_arg_count ) {
#   define XfOrM32_COUNT (0+XfOrM28_COUNT)
#   define SETUP_XfOrM32(x) SETUP_XfOrM28(x)

# 323 "bc/src/resolve.c"
    le = FUNCCALL(SETUP_XfOrM32(_), resolve_expr (app -> rator , info ) ); 
    app -> rator = le ; 
  }

# 325 "bc/src/resolve.c"
  else 
  already_resolved_arg_count -- ; 

  if (! already_resolved_arg_count ) {
#   define XfOrM31_COUNT (0+XfOrM28_COUNT)
#   define SETUP_XfOrM31(x) SETUP_XfOrM28(x)

# 329 "bc/src/resolve.c"
    le = FUNCCALL(SETUP_XfOrM31(_), resolve_expr (app -> rand , info ) ); 
    app -> rand = le ; 
  }

# 331 "bc/src/resolve.c"
  else 
  already_resolved_arg_count -- ; 
  FUNCCALL(SETUP_XfOrM28(_), merge_resolve (orig_info , info ) )
  ; 
  FUNCCALL_AGAIN(set_app2_eval_type (app ) )
  ; 

  if ((app -> rator ) == (scheme_varref_const_p_proc ) )  {
    if ((Scheme_Type ) (((((intptr_t ) (app -> rand ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (app -> rand ) ) -> type ) ) == (Scheme_Type ) (scheme_varref_form_type ) )  {

      (((Scheme_Simple_Object * ) (app -> rand ) ) -> u . two_ptr_val . ptr2 ) = scheme_false ; 
    }
  }

  RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 348 "bc/src/resolve.c"
int eq_testable_constant (Scheme_Object * v ) 
{
  /* No conversion */

# 350 "bc/src/resolve.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) 
  || (((v ) ) == (scheme_false ) ) 
  || ((v ) == (scheme_true ) ) 
  || ((v ) == (scheme_null ) ) 
  || (((v ) ) == (scheme_void ) ) 
  || (((v ) ) == (scheme_eof ) ) )
    return 1 ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) && ((((Scheme_Small_Object * ) (v ) ) -> u . char_val ) < 256 ) )
    return 1 ; 

  if ((((intptr_t ) (v ) ) & 0x1 ) 
  && ((((((intptr_t ) (v ) ) >> 1 ) ) >= - 1073741824 ) && (((((intptr_t ) (v ) ) >> 1 ) ) <= 1073741823 ) ) )
    return 1 ; 

  return 0 ; 
}

static void set_app3_eval_type (Scheme_App3_Rec * app ) 

{
  short et ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(app, 0)));
# define XfOrM41_COUNT (1)
# define SETUP_XfOrM41(x) SETUP(XfOrM41_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 374 "bc/src/resolve.c"
  et = FUNCCALL(SETUP_XfOrM41(_), scheme_get_eval_type (app -> rand2 ) ); 
  et = et << 3 ; 
  et += FUNCCALL(SETUP_XfOrM41(_), scheme_get_eval_type (app -> rand1 ) ); 
  et = et << 3 ; 
  et += FUNCCALL(SETUP_XfOrM41(_), scheme_get_eval_type (app -> rator ) ); 

  (& (app ) -> iso ) -> so . keyex = et | ((& (app ) -> iso ) -> so . keyex & ((1 << 11 ) | (1 << 12 ) | (1 << 13 ) ) ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 383 "bc/src/resolve.c"
void scheme_reset_app3_eval_type (Scheme_App3_Rec * app ) 
{
  /* No conversion */

# 385 "bc/src/resolve.c"
  set_app3_eval_type (app ) ; 
}

static Scheme_Object * resolve_application3 (Scheme_Object * o , Resolve_Info * orig_info , int already_resolved_arg_count ) 
{
  Resolve_Info * info ; 
  Scheme_App3_Rec * app ; 
  Scheme_Object * le ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(le, 0), PUSH(orig_info, 1), PUSH(app, 2), PUSH(info, 3)));
# define XfOrM43_COUNT (4)
# define SETUP_XfOrM43(x) SETUP(XfOrM43_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  info = NULLED_OUT ; 
  app = NULLED_OUT ; 
  le = NULLED_OUT ; 

# 394 "bc/src/resolve.c"
  app = (Scheme_App3_Rec * ) o ; 

  if (! already_resolved_arg_count ) {

    Scheme_Object * additions = ((void * ) 0 ) , * rator ; 
    int rdelta ; 
    BLOCK_SETUP((PUSH(additions, 0+XfOrM43_COUNT), PUSH(rator, 1+XfOrM43_COUNT)));
#   define XfOrM51_COUNT (2+XfOrM43_COUNT)
#   define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
    rator = NULLED_OUT ; 

# 400 "bc/src/resolve.c"
    additions = FUNCCALL(SETUP_XfOrM51(_), check_converted_rator (app -> rator , orig_info , & rator , 2 , & rdelta ) ); 
    if (additions ) {
      int m , i ; 
#     define XfOrM52_COUNT (0+XfOrM51_COUNT)
#     define SETUP_XfOrM52(x) SETUP_XfOrM51(x)

# 403 "bc/src/resolve.c"
      m = (((Scheme_Vector * ) (additions ) ) -> size ) - 1 ; 
      if (m ) {

        Scheme_App_Rec * app2 ; 
        Scheme_Object * arg ; 
        BLOCK_SETUP((PUSH(arg, 0+XfOrM52_COUNT), PUSH(app2, 1+XfOrM52_COUNT)));
#       define XfOrM54_COUNT (2+XfOrM52_COUNT)
#       define SETUP_XfOrM54(x) SETUP(XfOrM54_COUNT)
        app2 = NULLED_OUT ; 
        arg = NULLED_OUT ; 

# 408 "bc/src/resolve.c"
        app2 = FUNCCALL(SETUP_XfOrM54(_), scheme_malloc_application (3 + m ) ); 
        for (i = 0 ; i < m ; i ++ ) {
#         define XfOrM56_COUNT (0+XfOrM54_COUNT)
#         define SETUP_XfOrM56(x) SETUP_XfOrM54(x)

# 410 "bc/src/resolve.c"
          arg = FUNCCALL(SETUP_XfOrM56(_), resolve_info_lift_added (orig_info , (((Scheme_Vector * ) (additions ) ) -> els ) [i + 1 ] , 2 + m ) ); 
          app2 -> args [i + 1 ] = arg ; 
        }
        app2 -> args [0 ] = rator ; 
        app2 -> args [m + 1 ] = app -> rand1 ; 
        app2 -> args [m + 2 ] = app -> rand2 ; 
        (& (app2 ) -> iso ) -> so . keyex |= (1 << 13 ) ; 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM54(_), resolve_application ((Scheme_Object * ) app2 , orig_info , m + 1 + rdelta ) )) RET_VALUE_END ; 
      }

# 418 "bc/src/resolve.c"
      else {
        app -> rator = rator ; 
        already_resolved_arg_count = 1 + rdelta ; 
      }
    }
  }

  info = FUNCCALL(SETUP_XfOrM43(_), resolve_info_extend (orig_info , 2 , 0 ) ); 

  if (already_resolved_arg_count ) {
    already_resolved_arg_count -- ; 
  }

# 429 "bc/src/resolve.c"
  else {
#   define XfOrM49_COUNT (0+XfOrM43_COUNT)
#   define SETUP_XfOrM49(x) SETUP_XfOrM43(x)

# 430 "bc/src/resolve.c"
    le = FUNCCALL(SETUP_XfOrM49(_), resolve_expr (app -> rator , info ) ); 
    app -> rator = le ; 
  }

  if (already_resolved_arg_count ) {
    already_resolved_arg_count -- ; 
  }

# 436 "bc/src/resolve.c"
  else {
#   define XfOrM47_COUNT (0+XfOrM43_COUNT)
#   define SETUP_XfOrM47(x) SETUP_XfOrM43(x)

# 437 "bc/src/resolve.c"
    le = FUNCCALL(SETUP_XfOrM47(_), resolve_expr (app -> rand1 , info ) ); 
    app -> rand1 = le ; 
  }

  if (already_resolved_arg_count ) {
    already_resolved_arg_count -- ; 
  }

# 443 "bc/src/resolve.c"
  else {
#   define XfOrM45_COUNT (0+XfOrM43_COUNT)
#   define SETUP_XfOrM45(x) SETUP_XfOrM43(x)

# 444 "bc/src/resolve.c"
    le = FUNCCALL(SETUP_XfOrM45(_), resolve_expr (app -> rand2 , info ) ); 
    app -> rand2 = le ; 
  }





  if ((((app -> rator ) == (scheme_equal_proc ) ) 
  || ((app -> rator ) == (scheme_eqv_proc ) ) ) 
  && (FUNCCALL(SETUP_XfOrM43(_), eq_testable_constant (app -> rand1 ) )
  || FUNCCALL(SETUP_XfOrM43(_), eq_testable_constant (app -> rand2 ) )) ) {
    app -> rator = scheme_eq_proc ; 
  }
  FUNCCALL(SETUP_XfOrM43(_), set_app3_eval_type (app ) )
  ; 
  FUNCCALL(SETUP_XfOrM43(_), merge_resolve (orig_info , info ) )
  ; 

  RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * resolve_branch (Scheme_Object * o , Resolve_Info * info ) 
{
  Scheme_Branch_Rec * b ; 
  Scheme_Object * t , * tb , * fb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(fb, 0), PUSH(info, 1), PUSH(b, 2), PUSH(t, 3), PUSH(o, 4), PUSH(tb, 5)));
# define XfOrM57_COUNT (6)
# define SETUP_XfOrM57(x) SETUP(XfOrM57_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 
  t = NULLED_OUT ; 
  tb = NULLED_OUT ; 
  fb = NULLED_OUT ; 

# 475 "bc/src/resolve.c"
  b = (Scheme_Branch_Rec * ) o ; 

  t = FUNCCALL(SETUP_XfOrM57(_), resolve_expr (b -> test , info ) ); 
  tb = FUNCCALL_AGAIN(resolve_expr (b -> tbranch , info ) ); 
  fb = FUNCCALL_AGAIN(resolve_expr (b -> fbranch , info ) ); 

  b -> test = t ; 
  b -> tbranch = tb ; 
  b -> fbranch = fb ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 488 "bc/src/resolve.c"
static Scheme_Object * resolve_wcm (Scheme_Object * o , Resolve_Info * info ) 
{
  Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) o ; 
  Scheme_Object * k , * v , * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(b, 1), PUSH(v, 2), PUSH(wcm, 3), PUSH(k, 4)));
# define XfOrM58_COUNT (5)
# define SETUP_XfOrM58(x) SETUP(XfOrM58_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  k = NULLED_OUT ; 
  v = NULLED_OUT ; 
  b = NULLED_OUT ; 

# 493 "bc/src/resolve.c"
  k = FUNCCALL(SETUP_XfOrM58(_), resolve_expr (wcm -> key , info ) ); 
  v = FUNCCALL_AGAIN(resolve_expr (wcm -> val , info ) ); 
  b = FUNCCALL_AGAIN(resolve_expr (wcm -> body , info ) ); 
  wcm -> key = k ; 
  wcm -> val = v ; 
  wcm -> body = b ; 

  RET_VALUE_START ((Scheme_Object * ) wcm ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * look_for_letv_change (Scheme_Sequence * s ) 
{
  int i , start ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM59_COUNT (1)
# define SETUP_XfOrM59(x) SETUP(XfOrM59_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 515 "bc/src/resolve.c"
  start = ((((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) == scheme_begin0_sequence_type ) ? 1 : 0 ) ; 

  for (i = start ; i < s -> count - 1 ; i ++ ) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM59_COUNT)));
#   define XfOrM69_COUNT (1+XfOrM59_COUNT)
#   define SETUP_XfOrM69(x) SETUP(XfOrM69_COUNT)
    v = NULLED_OUT ; 

# 519 "bc/src/resolve.c"
    v = s -> array [i ] ; 
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_let_value_type ) )  {
      Scheme_Let_Value * lv = (Scheme_Let_Value * ) v ; 
      BLOCK_SETUP((PUSH(lv, 0+XfOrM69_COUNT)));
#     define XfOrM70_COUNT (1+XfOrM69_COUNT)
#     define SETUP_XfOrM70(x) SETUP(XfOrM70_COUNT)

# 522 "bc/src/resolve.c"
      if (FUNCCALL(SETUP_XfOrM70(_), scheme_omittable_expr (lv -> body , 1 , - 1 , 0x1 , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
        int esize = s -> count - (i + 1 ) ; 
        int nsize = i + 1 ; 
        Scheme_Object * nv , * ev ; 
        BLOCK_SETUP((PUSH(nv, 0+XfOrM70_COUNT), PUSH(ev, 1+XfOrM70_COUNT)));
#       define XfOrM71_COUNT (2+XfOrM70_COUNT)
#       define SETUP_XfOrM71(x) SETUP(XfOrM71_COUNT)
        nv = NULLED_OUT ; 
        ev = NULLED_OUT ; 

# 527 "bc/src/resolve.c"
        if (nsize > 1 ) {
          Scheme_Sequence * naya ; 
          BLOCK_SETUP((PUSH(naya, 0+XfOrM71_COUNT)));
#         define XfOrM75_COUNT (1+XfOrM71_COUNT)
#         define SETUP_XfOrM75(x) SETUP(XfOrM75_COUNT)
          naya = NULLED_OUT ; 

# 530 "bc/src/resolve.c"
          naya = FUNCCALL(SETUP_XfOrM75(_), scheme_malloc_sequence (nsize ) ); 
          naya -> so . type = s -> so . type ; 
          naya -> count = nsize ; 
          nv = (Scheme_Object * ) naya ; 

          for (i = 0 ; i < nsize ; i ++ ) {
            naya -> array [i ] = s -> array [i ] ; 
          }
        }

# 538 "bc/src/resolve.c"
        else 
        nv = (Scheme_Object * ) lv ; 

        if (esize > 1 ) {
          Scheme_Sequence * e ; 
          BLOCK_SETUP((PUSH(e, 0+XfOrM71_COUNT)));
#         define XfOrM72_COUNT (1+XfOrM71_COUNT)
#         define SETUP_XfOrM72(x) SETUP(XfOrM72_COUNT)
          e = NULLED_OUT ; 

# 543 "bc/src/resolve.c"
          e = FUNCCALL(SETUP_XfOrM72(_), scheme_malloc_sequence (esize ) ); 
          e -> so . type = s -> so . type ; 
          e -> count = esize ; 

          for (i = 0 ; i < esize ; i ++ ) {
            e -> array [i ] = s -> array [i + nsize ] ; 
          }

          ev = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM72(_), look_for_letv_change (e ) ); 
        }

# 552 "bc/src/resolve.c"
        else 
        ev = s -> array [nsize ] ; 

        lv -> body = ev ; 

        RET_VALUE_START (nv ) RET_VALUE_END ; 
      }
    }
  }

  RET_VALUE_START ((Scheme_Object * ) s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 565 "bc/src/resolve.c"
static Scheme_Object * resolve_sequence (Scheme_Object * o , Resolve_Info * info ) 
{
  Scheme_Sequence * s = (Scheme_Sequence * ) o ; 
  int i ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(info, 1)));
# define XfOrM78_COUNT (2)
# define SETUP_XfOrM78(x) SETUP(XfOrM78_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 570 "bc/src/resolve.c"
  for (i = s -> count ; i -- ; ) {
    Scheme_Object * le ; 
    BLOCK_SETUP((PUSH(le, 0+XfOrM78_COUNT)));
#   define XfOrM80_COUNT (1+XfOrM78_COUNT)
#   define SETUP_XfOrM80(x) SETUP(XfOrM80_COUNT)
    le = NULLED_OUT ; 

# 572 "bc/src/resolve.c"
    le = FUNCCALL(SETUP_XfOrM80(_), resolve_expr (s -> array [i ] , info ) ); 
    s -> array [i ] = le ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(look_for_letv_change (s ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * 
define_values_resolve (Scheme_Object * data , Resolve_Info * rslv ) 
{
  intptr_t i , cnt = ((((Scheme_Vector * ) (data ) ) -> size ) - 1 ) ; 
  Scheme_Object * val , * a ; 
  Scheme_IR_Toplevel * var ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(var, 1), PUSH(a, 2), PUSH(rslv, 3), PUSH(data, 4)));
# define XfOrM81_COUNT (5)
# define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  val = NULLED_OUT ; 
  a = NULLED_OUT ; 
  var = NULLED_OUT ; 

# 594 "bc/src/resolve.c"
  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM83_COUNT (0+XfOrM81_COUNT)
#   define SETUP_XfOrM83(x) SETUP_XfOrM81(x)

# 595 "bc/src/resolve.c"
    var = ((Scheme_IR_Toplevel * ) ((((Scheme_Vector * ) (data ) ) -> els ) [(i ) + 1 ] ) ) ; 
    a = FUNCCALL(SETUP_XfOrM83(_), resolve_toplevel (rslv , (Scheme_Object * ) var , 0 ) ); 
    if (rslv -> enforce_const 
    && (! ((& (var ) -> iso ) -> so . keyex & 0x4 ) ) )
      a = FUNCCALL(SETUP_XfOrM83(_), scheme_toplevel_to_flagged_toplevel (a , 0x1 ) ); 
    ((((Scheme_Vector * ) (data ) ) -> els ) [(i ) + 1 ] ) = a ; 
  }

  val = FUNCCALL(SETUP_XfOrM81(_), resolve_expr (((((Scheme_Vector * ) (data ) ) -> els ) [0 ] ) , rslv ) ); 
  ((((Scheme_Vector * ) (data ) ) -> els ) [0 ] ) = val ; 

  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 609 "bc/src/resolve.c"
static void resolve_lift_definition (Resolve_Info * info , Scheme_Object * var , Scheme_Object * rhs ) 
{
  Scheme_Object * decl , * vec , * pr ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(rhs, 0), PUSH(var, 1), PUSH(info, 2), PUSH(vec, 3), PUSH(decl, 4), PUSH(pr, 5)));
# define XfOrM84_COUNT (6)
# define SETUP_XfOrM84(x) SETUP(XfOrM84_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  decl = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  pr = NULLED_OUT ; 

# 613 "bc/src/resolve.c"
  decl = FUNCCALL(SETUP_XfOrM84(_), scheme_make_vector (2 , ((void * ) 0 ) ) ); 
  decl -> type = scheme_define_values_type ; 
  ((((Scheme_Vector * ) (decl ) ) -> els ) [0 ] ) = rhs ; 
  ((((Scheme_Vector * ) (decl ) ) -> els ) [(0 ) + 1 ] ) = var ; 

  vec = info -> lifts ; 
  pr = FUNCCALL(SETUP_XfOrM84(_), scheme_make_pair (decl , (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] ) ); 
  (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = pr ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 623 "bc/src/resolve.c"
static Scheme_Object * 
inline_variant_resolve (Scheme_Object * data , Resolve_Info * rslv ) 
{
  Scheme_Object * a ; 
  char no_lift ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(rslv, 1), PUSH(data, 2)));
# define XfOrM85_COUNT (3)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 629 "bc/src/resolve.c"
  a = (((Scheme_Vector * ) (data ) ) -> els ) [0 ] ; 
  a = FUNCCALL(SETUP_XfOrM85(_), resolve_expr (a , rslv ) ); 
  (((Scheme_Vector * ) (data ) ) -> els ) [0 ] = a ; 




  a = (((Scheme_Vector * ) (data ) ) -> els ) [1 ] ; 
  no_lift = rslv -> no_lift ; 
  rslv -> no_lift = 1 ; 
  a = FUNCCALL(SETUP_XfOrM85(_), resolve_expr (a , rslv ) ); 
  rslv -> no_lift = no_lift ; 
  (((Scheme_Vector * ) (data ) ) -> els ) [1 ] = a ; 

  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 646 "bc/src/resolve.c"
static Scheme_Object * 
set_resolve (Scheme_Object * data , Resolve_Info * rslv ) 
{
  Scheme_Set_Bang * sb = (Scheme_Set_Bang * ) data ; 
  Scheme_Object * var , * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(var, 0), PUSH(sb, 1), PUSH(val, 2), PUSH(rslv, 3)));
# define XfOrM86_COUNT (4)
# define SETUP_XfOrM86(x) SETUP(XfOrM86_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  var = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 652 "bc/src/resolve.c"
  var = sb -> var ; 
  val = sb -> val ; 

  val = FUNCCALL(SETUP_XfOrM86(_), resolve_expr (val , rslv ) ); 

  if ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_local_type ) )  {
    Scheme_Let_Value * lv ; 
    Scheme_Object * cv ; 
    int li ; 
    BLOCK_SETUP((PUSH(cv, 0+XfOrM86_COUNT), PUSH(lv, 1+XfOrM86_COUNT)));
#   define XfOrM87_COUNT (2+XfOrM86_COUNT)
#   define SETUP_XfOrM87(x) SETUP(XfOrM87_COUNT)
    lv = NULLED_OUT ; 
    cv = NULLED_OUT ; 

# 662 "bc/src/resolve.c"
    ((void ) sizeof ((((Scheme_IR_Local * ) var ) -> mutated ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM88_COUNT (0+XfOrM87_COUNT)
#     define SETUP_XfOrM88(x) SETUP_XfOrM87(x)

# 662 "bc/src/resolve.c" 3
      if (((Scheme_IR_Local * ) var ) -> mutated )

# 662 "bc/src/resolve.c" 3
      ; 

# 662 "bc/src/resolve.c" 3
      else FUNCCALL(SETUP_XfOrM88(_), __assert_fail ("((Scheme_IR_Local *)var)->mutated" , "bc/src/resolve.c" , 662 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 662 "bc/src/resolve.c"
    ; 

    cv = FUNCCALL(SETUP_XfOrM87(_), scheme_compiled_void () ); 

    lv = ((Scheme_Let_Value * ) FUNCCALL(SETUP_XfOrM87(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Let_Value ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    lv -> iso . so . type = scheme_let_value_type ; 
    lv -> body = cv ; 
    lv -> count = 1 ; 
    li = FUNCCALL(SETUP_XfOrM87(_), resolve_info_lookup (rslv , ((Scheme_IR_Local * ) var ) , ((void * ) 0 ) , 0 , 0 ) ); 
    lv -> position = li ; 
    (& lv -> iso ) -> so . keyex = 1 ; 
    lv -> value = val ; 

    RET_VALUE_START ((Scheme_Object * ) lv ) RET_VALUE_END ; 
  }

  var = FUNCCALL(SETUP_XfOrM86(_), resolve_expr (var , rslv ) ); 

  sb -> var = var ; 
  sb -> val = val ; 

  RET_VALUE_START ((Scheme_Object * ) sb ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 686 "bc/src/resolve.c"
static Scheme_Object * 
ref_resolve (Scheme_Object * data , Resolve_Info * rslv ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(rslv, 1), PUSH(data, 2)));
# define XfOrM89_COUNT (3)
# define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 691 "bc/src/resolve.c"
  v = FUNCCALL(SETUP_XfOrM89(_), resolve_expr ((((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) , rslv ) ); 
  (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) = v ; 

  v = (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
  || ((v ) == (scheme_false ) ) 
  || ((v ) == (scheme_true ) ) ) {
    if (! (((v ) ) == (scheme_false ) ) ) 
      (& ((Scheme_Simple_Object * ) data ) -> iso ) -> so . keyex |= 0x1 ; 
  }

# 700 "bc/src/resolve.c"
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_local_type ) )  {
#   define XfOrM90_COUNT (0+XfOrM89_COUNT)
#   define SETUP_XfOrM90(x) SETUP_XfOrM89(x)

# 701 "bc/src/resolve.c"
    v = FUNCCALL(SETUP_XfOrM90(_), resolve_expr (v , rslv ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_local_type ) ) 
      (& ((Scheme_Simple_Object * ) data ) -> iso ) -> so . keyex |= 0x1 ; 
    v = scheme_true ; 
  }

# 705 "bc/src/resolve.c"
  else 
  v = FUNCCALL(SETUP_XfOrM89(_), resolve_expr (v , rslv ) ); 
  (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) = v ; 

  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 712 "bc/src/resolve.c"
static Scheme_Object * 
apply_values_resolve (Scheme_Object * data , Resolve_Info * rslv ) 
{
  Scheme_Object * f , * e ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(data, 1), PUSH(rslv, 2), PUSH(f, 3)));
# define XfOrM92_COUNT (4)
# define SETUP_XfOrM92(x) SETUP(XfOrM92_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  f = NULLED_OUT ; 
  e = NULLED_OUT ; 

# 717 "bc/src/resolve.c"
  f = (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) ; 
  e = (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) ; 

  f = FUNCCALL(SETUP_XfOrM92(_), resolve_expr (f , rslv ) ); 
  e = FUNCCALL_AGAIN(resolve_expr (e , rslv ) ); 

  (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr1 ) = f ; 
  (((Scheme_Simple_Object * ) (data ) ) -> u . two_ptr_val . ptr2 ) = e ; 

  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 729 "bc/src/resolve.c"
static void set_resolve_mode (Scheme_IR_Local * var ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(var, 0)));
# define XfOrM93_COUNT (1)
# define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 731 "bc/src/resolve.c"
  ((void ) sizeof ((((Scheme_Type ) (var -> so . type ) == (Scheme_Type ) (scheme_ir_local_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM94_COUNT (0+XfOrM93_COUNT)
#   define SETUP_XfOrM94(x) SETUP_XfOrM93(x)

# 731 "bc/src/resolve.c" 3
    if ((Scheme_Type ) (var -> so . type ) == (Scheme_Type ) (scheme_ir_local_type ) ) 

# 731 "bc/src/resolve.c" 3
    ; 

# 731 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM94(_), __assert_fail ("((Scheme_Type)(var->so.type) == (Scheme_Type)(scheme_ir_local_type))" , "bc/src/resolve.c" , 731 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 731 "bc/src/resolve.c"
  ; 
  (memset (& var -> resolve , 0 , sizeof (var -> resolve ) ) ) ; 
  var -> mode = 4 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 736 "bc/src/resolve.c"
static Scheme_Object * 
with_immed_mark_resolve (Scheme_Object * data , Resolve_Info * orig_rslv ) 
{
  Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) data ; 
  Scheme_Object * e ; 
  Scheme_IR_Local * var ; 
  Resolve_Info * rslv = orig_rslv ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(var, 1), PUSH(data, 2), PUSH(orig_rslv, 3), PUSH(rslv, 4), PUSH(wcm, 5)));
# define XfOrM95_COUNT (6)
# define SETUP_XfOrM95(x) SETUP(XfOrM95_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  e = NULLED_OUT ; 
  var = NULLED_OUT ; 

# 744 "bc/src/resolve.c"
  e = FUNCCALL(SETUP_XfOrM95(_), resolve_expr (wcm -> key , rslv ) ); 
  wcm -> key = e ; 

  e = FUNCCALL(SETUP_XfOrM95(_), resolve_expr (wcm -> val , rslv ) ); 
  wcm -> val = e ; 

  rslv = FUNCCALL(SETUP_XfOrM95(_), resolve_info_extend (rslv , 1 , 0 ) ); 

  var = ((Scheme_IR_Local * ) (((Scheme_Simple_Object * ) (wcm -> body ) ) -> u . pair_val . car ) ) ; 
  FUNCCALL(SETUP_XfOrM95(_), set_resolve_mode (var ) ); 
  var -> resolve . co_depth = rslv -> current_depth ; 
  var -> resolve . lex_depth = rslv -> current_lex_depth ; 

  e = FUNCCALL(SETUP_XfOrM95(_), resolve_expr ((((Scheme_Simple_Object * ) (wcm -> body ) ) -> u . pair_val . cdr ) , rslv ) ); 

  if (var -> mutated ) {
    Scheme_Object * bcode ; 
    BLOCK_SETUP((PUSH(bcode, 0+XfOrM95_COUNT)));
#   define XfOrM96_COUNT (1+XfOrM95_COUNT)
#   define SETUP_XfOrM96(x) SETUP(XfOrM96_COUNT)
    bcode = NULLED_OUT ; 

# 761 "bc/src/resolve.c"
    bcode = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM96(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    bcode -> type = scheme_boxenv_type ; 
    (((Scheme_Simple_Object * ) (bcode ) ) -> u . two_ptr_val . ptr1 ) = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Simple_Object * ) (bcode ) ) -> u . two_ptr_val . ptr2 ) = e ; 
    e = bcode ; 
  }

  wcm -> body = e ; 
  FUNCCALL(SETUP_XfOrM95(_), merge_resolve (orig_rslv , rslv ) )
  ; 

  RET_VALUE_START (data ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 775 "bc/src/resolve.c"
static Scheme_Object * 
case_lambda_resolve (Scheme_Object * expr , Resolve_Info * rslv ) 
{
  int i , all_closed = 1 ; 
  Scheme_Case_Lambda * seq = (Scheme_Case_Lambda * ) expr ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(rslv, 0), PUSH(seq, 1), PUSH(expr, 2)));
# define XfOrM97_COUNT (3)
# define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 781 "bc/src/resolve.c"
  for (i = 0 ; i < seq -> count ; i ++ ) {
    Scheme_Object * le ; 
    BLOCK_SETUP((PUSH(le, 0+XfOrM97_COUNT)));
#   define XfOrM100_COUNT (1+XfOrM97_COUNT)
#   define SETUP_XfOrM100(x) SETUP(XfOrM100_COUNT)
    le = NULLED_OUT ; 

# 783 "bc/src/resolve.c"
    le = seq -> array [i ] ; 
    le = FUNCCALL(SETUP_XfOrM100(_), resolve_lambda (le , rslv , 0 , 0 , 0 , ((void * ) 0 ) ) ); 
    seq -> array [i ] = le ; 
    if (! (! (((intptr_t ) (le ) ) & 0x1 ) && ((((le ) -> type ) >= scheme_prim_type ) && (((le ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      all_closed = 0 ; 
  }

  if (all_closed ) {
#   define XfOrM98_COUNT (0+XfOrM97_COUNT)
#   define SETUP_XfOrM98(x) SETUP_XfOrM97(x)

# 792 "bc/src/resolve.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_case_lambda_execute (expr ) )) RET_VALUE_EMPTY_END ; 
  }

  RET_VALUE_START (expr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int is_lifted_reference (Scheme_Object * v ) 

{
  /* No conversion */

# 805 "bc/src/resolve.c"
  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) 
    return 1 ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) )
    return (((& ((Scheme_Toplevel * ) (v ) ) -> iso ) -> so . keyex & 0x3 ) 
  >= 3 ) ; 

  return 0 ; 
}

static int is_closed_reference (Scheme_Object * v ) 
{
  /* No conversion */


  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) )  {
    v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
    return (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) ; 
  }

  return 0 ; 
}

static Scheme_Object * scheme_resolve_generate_stub_closure () 
{
  Scheme_Closure * cl ; 
  Scheme_Object * ca ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cl, 0), PUSH(ca, 1)));
# define XfOrM104_COUNT (2)
# define SETUP_XfOrM104(x) SETUP(XfOrM104_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cl = NULLED_OUT ; 
  ca = NULLED_OUT ; 

# 834 "bc/src/resolve.c"
  cl = FUNCCALL(SETUP_XfOrM104(_), scheme_malloc_empty_closure () ); 

  ca = FUNCCALL_AGAIN(scheme_make_vector (1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_raw_pair ((Scheme_Object * ) cl , ca ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 841 "bc/src/resolve.c"
static int get_convert_arg_count (Scheme_Object * lift ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(lift, 0)));
# define XfOrM105_COUNT (1)
# define SETUP_XfOrM105(x) SETUP(XfOrM105_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 843 "bc/src/resolve.c"
  if (! lift )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  else if ((Scheme_Type ) (((((intptr_t ) (lift ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lift ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) )  {
#   define XfOrM106_COUNT (0+XfOrM105_COUNT)
#   define SETUP_XfOrM106(x) SETUP_XfOrM105(x)

# 846 "bc/src/resolve.c"
    lift = (((Scheme_Simple_Object * ) (lift ) ) -> u . pair_val . cdr ) ; 
    ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (lift ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lift ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM107_COUNT (0+XfOrM106_COUNT)
#     define SETUP_XfOrM107(x) SETUP_XfOrM106(x)

# 847 "bc/src/resolve.c" 3
      if ((Scheme_Type ) (((((intptr_t ) (lift ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lift ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 

# 847 "bc/src/resolve.c" 3
      ; 

# 847 "bc/src/resolve.c" 3
      else FUNCCALL(SETUP_XfOrM107(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(lift)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(lift))->type)) == (Scheme_Type)(scheme_vector_type))" , "bc/src/resolve.c" , 847 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 847 "bc/src/resolve.c"
    ; 
    RET_VALUE_START ((((Scheme_Vector * ) (lift ) ) -> size ) - 1 ) RET_VALUE_END ; 
  }

# 849 "bc/src/resolve.c"
  else 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 853 "bc/src/resolve.c"
static Scheme_Object * get_convert_arg_map (Scheme_Object * lift ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(lift, 0)));
# define XfOrM108_COUNT (1)
# define SETUP_XfOrM108(x) SETUP(XfOrM108_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 855 "bc/src/resolve.c"
  if (! lift )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  else if ((Scheme_Type ) (((((intptr_t ) (lift ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lift ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) )  {
#   define XfOrM109_COUNT (0+XfOrM108_COUNT)
#   define SETUP_XfOrM109(x) SETUP_XfOrM108(x)

# 858 "bc/src/resolve.c"
    lift = (((Scheme_Simple_Object * ) (lift ) ) -> u . pair_val . cdr ) ; 
    ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (lift ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lift ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM110_COUNT (0+XfOrM109_COUNT)
#     define SETUP_XfOrM110(x) SETUP_XfOrM109(x)

# 859 "bc/src/resolve.c" 3
      if ((Scheme_Type ) (((((intptr_t ) (lift ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lift ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 

# 859 "bc/src/resolve.c" 3
      ; 

# 859 "bc/src/resolve.c" 3
      else FUNCCALL(SETUP_XfOrM110(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(lift)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(lift))->type)) == (Scheme_Type)(scheme_vector_type))" , "bc/src/resolve.c" , 859 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 859 "bc/src/resolve.c"
    ; 
    RET_VALUE_START (lift ) RET_VALUE_END ; 
  }

# 861 "bc/src/resolve.c"
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 865 "bc/src/resolve.c"
static Scheme_Object * drop_zero_value_return (Scheme_Object * expr ) 
{
  /* No conversion */

# 867 "bc/src/resolve.c"
  if ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_sequence_type ) )  {
    if (((Scheme_Sequence * ) expr ) -> count == 2 ) {
      if ((Scheme_Type ) (((((intptr_t ) (((Scheme_Sequence * ) expr ) -> array [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Sequence * ) expr ) -> array [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_application_type ) )  {
        if (((Scheme_App_Rec * ) ((Scheme_Sequence * ) expr ) -> array [1 ] ) -> num_args == 0 ) {
          if ((scheme_values_proc ) == (((Scheme_App_Rec * ) ((Scheme_Sequence * ) expr ) -> array [1 ] ) -> args [0 ] ) )  {
            return ((Scheme_Sequence * ) expr ) -> array [0 ] ; 
          }
        }
      }
    }
  }

  return ((void * ) 0 ) ; 
}



static int check_need_boxed_letrec_rhs (Scheme_IR_Let_Header * head , Scheme_Hash_Tree * binding_vars , Resolve_Info * info , 
int * _num_rec_procs , int * _rec_proc_nonapply ) 





{
  int recbox = 0 ; 
  Scheme_IR_Let_Value * irlv ; 
  int i ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(head, 0), PUSH(_rec_proc_nonapply, 1), PUSH(info, 2), PUSH(irlv, 3), PUSH(_num_rec_procs, 4), PUSH(binding_vars, 5)));
# define XfOrM117_COUNT (6)
# define SETUP_XfOrM117(x) SETUP(XfOrM117_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  irlv = NULLED_OUT ; 

# 896 "bc/src/resolve.c"
  irlv = (Scheme_IR_Let_Value * ) head -> body ; 
  for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
    int is_proc , is_lift ; 
#   define XfOrM129_COUNT (0+XfOrM117_COUNT)
#   define SETUP_XfOrM129(x) SETUP_XfOrM117(x)

# 900 "bc/src/resolve.c"
    if ((irlv -> count == 1 ) 
    && ! irlv -> vars [0 ] -> optimize_used 
    && FUNCCALL(SETUP_XfOrM129(_), scheme_omittable_expr (irlv -> value , irlv -> count , - 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) ) )) {

      irlv -> vars [0 ] -> resolve_omittable = 1 ; 
    }

# 905 "bc/src/resolve.c"
    else {
#     define XfOrM130_COUNT (0+XfOrM129_COUNT)
#     define SETUP_XfOrM130(x) SETUP_XfOrM129(x)

# 906 "bc/src/resolve.c"
      if (irlv -> count == 1 )
        is_proc = FUNCCALL(SETUP_XfOrM130(_), scheme_is_ir_lambda (irlv -> value , 1 , 1 ) ); 
      else 
      is_proc = 0 ; 

      if (is_proc )
        is_lift = 0 ; 
      else if ((& (irlv ) -> iso ) -> so . keyex & 0x2 )
        is_lift = 1 ; 
      else 
      is_lift = FUNCCALL(SETUP_XfOrM130(_), scheme_is_liftable (irlv -> value , binding_vars , 5 , 1 , 0 ) ); 

      if (! is_proc && ! is_lift ) {
        recbox = 1 ; 
        break ; 
      }

# 921 "bc/src/resolve.c"
      else {
#       define XfOrM131_COUNT (0+XfOrM130_COUNT)
#       define SETUP_XfOrM131(x) SETUP_XfOrM130(x)

# 922 "bc/src/resolve.c"
        if (! is_lift ) {

          int j ; 
#         define XfOrM132_COUNT (0+XfOrM131_COUNT)
#         define SETUP_XfOrM132(x) SETUP_XfOrM131(x)

# 926 "bc/src/resolve.c"
          for (j = 0 ; j < irlv -> count ; j ++ ) {
            if (irlv -> vars [j ] -> mutated ) {
              recbox = 1 ; 
              break ; 
            }
          }
          if (recbox )
            break ; 

          if (FUNCCALL(SETUP_XfOrM132(_), is_nonconstant_procedure (irlv -> value , info , binding_vars ) )) {
            (* _num_rec_procs ) ++ ; 
            if (irlv -> vars [0 ] -> non_app_count )
              * _rec_proc_nonapply = 1 ; 
          }
        }
      }
    }
  }

  if (recbox )
    * _num_rec_procs = 0 ; 

  RET_VALUE_START (recbox ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 951 "bc/src/resolve.c"
static Scheme_Object * build_let_one_chain (Scheme_IR_Let_Header * head , Scheme_Object * body , Resolve_Info * info ) 

{
  Scheme_IR_Let_Value * irlv ; 
  Scheme_Let_Value * last = ((void * ) 0 ) ; 
  Scheme_Object * first = ((void * ) 0 ) ; 
  int i , j , num_frames ; 
  Resolve_Info * linfo ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(irlv, 0), PUSH(linfo, 1), PUSH(first, 2), PUSH(last, 3), PUSH(head, 4), PUSH(body, 5), PUSH(info, 6)));
# define XfOrM140_COUNT (7)
# define SETUP_XfOrM140(x) SETUP(XfOrM140_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  irlv = NULLED_OUT ; 
  linfo = NULLED_OUT ; 

# 960 "bc/src/resolve.c"
  j = head -> num_clauses ; 

  irlv = (Scheme_IR_Let_Value * ) head -> body ; 
  for (i = 0 ; i < j ; i ++ , irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
#   define XfOrM159_COUNT (0+XfOrM140_COUNT)
#   define SETUP_XfOrM159(x) SETUP_XfOrM140(x)

# 964 "bc/src/resolve.c"
    if (irlv -> vars [0 ] -> optimize_used ) {
      int aty , pty , involes_k_cross ; 
#     define XfOrM160_COUNT (0+XfOrM159_COUNT)
#     define SETUP_XfOrM160(x) SETUP_XfOrM159(x)

# 966 "bc/src/resolve.c"
      aty = irlv -> vars [0 ] -> arg_type ; 
      pty = FUNCCALL(SETUP_XfOrM160(_), scheme_expr_produces_local_type (irlv -> value , & involes_k_cross ) ); 
      if (pty && ! involes_k_cross && ((pty == aty ) || ((pty ) == 2 ) ) )
        irlv -> vars [0 ] -> val_type = pty ; 
      else 
      irlv -> vars [0 ] -> val_type = 0 ; 
    }
  }

  irlv = (Scheme_IR_Let_Value * ) head -> body ; 
  linfo = info ; 
  num_frames = 0 ; 
  for (i = 0 ; i < head -> num_clauses ; i ++ , irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
    Scheme_Object * le ; 
    BLOCK_SETUP((PUSH(le, 0+XfOrM140_COUNT)));
#   define XfOrM150_COUNT (1+XfOrM140_COUNT)
#   define SETUP_XfOrM150(x) SETUP(XfOrM150_COUNT)
    le = NULLED_OUT ; 

# 981 "bc/src/resolve.c"
    if (! irlv -> vars [0 ] -> optimize_used 
    && FUNCCALL(SETUP_XfOrM150(_), scheme_omittable_expr (irlv -> value , irlv -> count , - 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
    }
    else {
#     define XfOrM151_COUNT (0+XfOrM150_COUNT)
#     define SETUP_XfOrM151(x) SETUP_XfOrM150(x)

# 985 "bc/src/resolve.c"
      linfo = FUNCCALL(SETUP_XfOrM151(_), resolve_info_extend (linfo , 1 , 0 ) ); 
      num_frames ++ ; 
      FUNCCALL(SETUP_XfOrM151(_), set_resolve_mode (irlv -> vars [0 ] ) ); 
      irlv -> vars [0 ] -> resolve . co_depth = linfo -> current_depth ; 
      irlv -> vars [0 ] -> resolve . lex_depth = linfo -> current_lex_depth ; 

      if (! info -> no_lift 
      && ! irlv -> vars [0 ] -> non_app_count 
      && ((Scheme_Type ) (((((intptr_t ) (irlv -> value ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (irlv -> value ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_lambda_type ) ) )
        le = FUNCCALL(SETUP_XfOrM151(_), resolve_lambda (irlv -> value , linfo , 1 , 1 , 0 , ((void * ) 0 ) ) ); 
      else 
      le = FUNCCALL(SETUP_XfOrM151(_), resolve_expr (irlv -> value , linfo ) ); 

      if (FUNCCALL(SETUP_XfOrM151(_), is_lifted_reference (le ) )) {
#       define XfOrM154_COUNT (0+XfOrM151_COUNT)
#       define SETUP_XfOrM154(x) SETUP_XfOrM151(x)

# 999 "bc/src/resolve.c"
        ((void ) sizeof ((! info -> no_lift ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM155_COUNT (0+XfOrM154_COUNT)
#         define SETUP_XfOrM155(x) SETUP_XfOrM154(x)

# 999 "bc/src/resolve.c" 3
          if (! info -> no_lift )

# 999 "bc/src/resolve.c" 3
          ; 

# 999 "bc/src/resolve.c" 3
          else FUNCCALL(SETUP_XfOrM155(_), __assert_fail ("!info->no_lift" , "bc/src/resolve.c" , 999 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 999 "bc/src/resolve.c"
        ; 
        irlv -> vars [0 ] -> resolve . lifted = le ; 

        linfo = linfo -> next ; 
        -- num_frames ; 
      }

# 1004 "bc/src/resolve.c"
      else {
        Scheme_Let_One * lo ; 
        int et ; 
        BLOCK_SETUP((PUSH(lo, 0+XfOrM151_COUNT)));
#       define XfOrM152_COUNT (1+XfOrM151_COUNT)
#       define SETUP_XfOrM152(x) SETUP(XfOrM152_COUNT)
        lo = NULLED_OUT ; 

# 1008 "bc/src/resolve.c"
        irlv -> vars [0 ] -> resolve . lifted = ((void * ) 0 ) ; 

        lo = ((Scheme_Let_One * ) FUNCCALL(SETUP_XfOrM152(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Let_One ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        lo -> iso . so . type = scheme_let_one_type ; 
        ((void ) sizeof ((! ((Scheme_Type ) (((((intptr_t ) (le ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (le ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM153_COUNT (0+XfOrM152_COUNT)
#         define SETUP_XfOrM153(x) SETUP_XfOrM152(x)

# 1012 "bc/src/resolve.c" 3
          if (! ((Scheme_Type ) (((((intptr_t ) (le ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (le ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) )

# 1012 "bc/src/resolve.c" 3
          ; 

# 1012 "bc/src/resolve.c" 3
          else FUNCCALL(SETUP_XfOrM153(_), __assert_fail ("!((Scheme_Type)(((((intptr_t)(le)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(le))->type)) == (Scheme_Type)(scheme_raw_pair_type))" , "bc/src/resolve.c" , 1012 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 1012 "bc/src/resolve.c"
        ; 
        lo -> value = le ; 

        et = FUNCCALL(SETUP_XfOrM152(_), scheme_get_eval_type (lo -> value ) ); 
        if ((irlv -> vars [0 ] ) -> val_type && (! (irlv -> vars [0 ] ) -> escapes_after_k_tick || (((irlv -> vars [0 ] ) -> val_type ) == 2 ) ) ) 
          et |= (irlv -> vars [0 ] -> val_type << 4 ) ; 
        (& lo -> iso ) -> so . keyex = et ; 

        if (last )
          ((Scheme_Let_One * ) last ) -> body = (Scheme_Object * ) lo ; 
        else 
        first = (Scheme_Object * ) lo ; 
        last = (Scheme_Let_Value * ) lo ; 
      }
    }
  }

  body = FUNCCALL(SETUP_XfOrM140(_), resolve_expr (body , linfo ) ); 
  if (last )
    ((Scheme_Let_One * ) last ) -> body = body ; 
  else 
  first = body ; 

  for (i = 0 ; i < num_frames ; i ++ ) {
#   define XfOrM142_COUNT (0+XfOrM140_COUNT)
#   define SETUP_XfOrM142(x) SETUP_XfOrM140(x)
    FUNCCALL(SETUP_XfOrM142(_), merge_resolve (linfo -> next , linfo ) )
# 1036 "bc/src/resolve.c"
    ; 
    linfo = linfo -> next ; 
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1043 "bc/src/resolve.c"
static int all_unused_and_omittable (Scheme_IR_Let_Header * head ) 
{
  Scheme_IR_Let_Value * irlv ; 
  int i , j , any_used = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(head, 0), PUSH(irlv, 1)));
# define XfOrM161_COUNT (2)
# define SETUP_XfOrM161(x) SETUP(XfOrM161_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  irlv = NULLED_OUT ; 

# 1048 "bc/src/resolve.c"
  irlv = (Scheme_IR_Let_Value * ) head -> body ; 
  for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
#   define XfOrM168_COUNT (0+XfOrM161_COUNT)
#   define SETUP_XfOrM168(x) SETUP_XfOrM161(x)

# 1050 "bc/src/resolve.c"
    for (j = irlv -> count ; j -- ; ) {
      if (irlv -> vars [j ] -> optimize_used ) {
        any_used = 1 ; 
        break ; 
      }
    }
    if (((irlv -> count == 1 ) || ! any_used ) 
    && FUNCCALL(SETUP_XfOrM168(_), scheme_omittable_expr (irlv -> value , irlv -> count , - 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
      if ((irlv -> count == 1 ) && ! irlv -> vars [0 ] -> optimize_used )
        irlv -> vars [0 ] -> resolve_omittable = 1 ; 
    }

# 1060 "bc/src/resolve.c"
    else 
    any_used = 1 ; 
  }

  RET_VALUE_START (! any_used ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1067 "bc/src/resolve.c"
static Resolve_Info * compute_possible_lifts (Scheme_IR_Let_Header * head , Resolve_Info * info , Scheme_Hash_Tree * binding_vars , 
int recbox , int num_skips , int num_rec_procs , int rec_proc_nonapply , 
GC_CAN_IGNORE int * _lifted_recs ) 





{
  int resolve_phase ; 
  Resolve_Info * linfo ; 
  int i , pos , rpos , lifted_recs = 0 ; 
  Scheme_IR_Let_Value * irlv ; 
  DECL_RET_SAVE (Resolve_Info * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(head, 0), PUSH(info, 1), PUSH(irlv, 2), PUSH(binding_vars, 3), PUSH(linfo, 4)));
# define XfOrM174_COUNT (5)
# define SETUP_XfOrM174(x) SETUP(XfOrM174_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  linfo = NULLED_OUT ; 
  irlv = NULLED_OUT ; 

# 1081 "bc/src/resolve.c"
  linfo = ((void * ) 0 ) ; 
  for (resolve_phase = ((num_rec_procs && ! rec_proc_nonapply && ! info -> no_lift ) ? 0 : 2 ) ; 
  resolve_phase < 3 ; 
  resolve_phase ++ ) {
#   define XfOrM250_COUNT (0+XfOrM174_COUNT)
#   define SETUP_XfOrM250(x) SETUP_XfOrM174(x)
    if ((resolve_phase == 1 ) && (! FUNCCALL(SETUP_XfOrM250(_), resolve_is_inside_proc (info ) )
    || ! FUNCCALL(SETUP_XfOrM250(_), resolve_has_toplevel (info ) )) )
      resolve_phase = 2 ; 

    if (resolve_phase < 2 ) {
#     define XfOrM324_COUNT (0+XfOrM250_COUNT)
#     define SETUP_XfOrM324(x) SETUP_XfOrM250(x)

# 1092 "bc/src/resolve.c"
      linfo = FUNCCALL(SETUP_XfOrM324(_), resolve_info_extend (info , head -> count - num_rec_procs - num_skips , 0 ) ); 
      lifted_recs = 1 ; 
    }

# 1094 "bc/src/resolve.c"
    else {
#     define XfOrM323_COUNT (0+XfOrM250_COUNT)
#     define SETUP_XfOrM323(x) SETUP_XfOrM250(x)

# 1095 "bc/src/resolve.c"
      linfo = FUNCCALL(SETUP_XfOrM323(_), resolve_info_extend (info , head -> count - num_skips , 0 ) ); 
      lifted_recs = 0 ; 
    }




    irlv = (Scheme_IR_Let_Value * ) head -> body ; 
    pos = ((resolve_phase < 2 ) ? 0 : num_rec_procs ) ; 
    rpos = 0 ; 
    for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
      int j ; 
#     define XfOrM310_COUNT (0+XfOrM250_COUNT)
#     define SETUP_XfOrM310(x) SETUP_XfOrM250(x)

# 1108 "bc/src/resolve.c"
      if ((irlv -> count == 1 ) 
      && ! irlv -> vars [0 ] -> optimize_used 
      && irlv -> vars [0 ] -> resolve_omittable ) {
      }
      else {
#       define XfOrM311_COUNT (0+XfOrM310_COUNT)
#       define SETUP_XfOrM311(x) SETUP_XfOrM310(x)

# 1113 "bc/src/resolve.c"
        for (j = 0 ; j < irlv -> count ; j ++ ) {
          Scheme_Object * lift ; 
          BLOCK_SETUP((PUSH(lift, 0+XfOrM311_COUNT)));
#         define XfOrM317_COUNT (1+XfOrM311_COUNT)
#         define SETUP_XfOrM317(x) SETUP(XfOrM317_COUNT)
          lift = NULLED_OUT ; 
          FUNCCALL(SETUP_XfOrM317(_), set_resolve_mode (irlv -> vars [j ] ) )
# 1116 "bc/src/resolve.c"
          ; 
          if (recbox )
            irlv -> vars [j ] -> mutated = 1 ; 

          if (num_rec_procs 
          && (irlv -> count == 1 ) 
          && FUNCCALL(SETUP_XfOrM317(_), is_nonconstant_procedure (irlv -> value , info , binding_vars ) )) {
#           define XfOrM319_COUNT (0+XfOrM317_COUNT)
#           define SETUP_XfOrM319(x) SETUP_XfOrM317(x)

# 1123 "bc/src/resolve.c"
            ((void ) sizeof ((! recbox ) ? 1 : 0 ) , __extension__ ({
#             define XfOrM321_COUNT (0+XfOrM319_COUNT)
#             define SETUP_XfOrM321(x) SETUP_XfOrM319(x)

# 1123 "bc/src/resolve.c" 3
              if (! recbox )

# 1123 "bc/src/resolve.c" 3
              ; 

# 1123 "bc/src/resolve.c" 3
              else FUNCCALL(SETUP_XfOrM321(_), __assert_fail ("!recbox" , "bc/src/resolve.c" , 1123 , __extension__ __PRETTY_FUNCTION__ ) ); 
            }
            ) ) 
# 1123 "bc/src/resolve.c"
            ; 
            if (resolve_phase == 0 )
              lift = FUNCCALL(SETUP_XfOrM319(_), scheme_resolve_generate_stub_closure () ); 
            else if (resolve_phase == 1 )
              lift = FUNCCALL(SETUP_XfOrM319(_), resolve_generate_stub_lift (info ) ); 
            else 
            lift = ((void * ) 0 ) ; 
            ((void ) sizeof ((! info -> no_lift || ! lift ) ? 1 : 0 ) , __extension__ ({
#             define XfOrM320_COUNT (0+XfOrM319_COUNT)
#             define SETUP_XfOrM320(x) SETUP_XfOrM319(x)

# 1130 "bc/src/resolve.c" 3
              if (! info -> no_lift || ! lift )

# 1130 "bc/src/resolve.c" 3
              ; 

# 1130 "bc/src/resolve.c" 3
              else FUNCCALL(SETUP_XfOrM320(_), __assert_fail ("!info->no_lift || !lift" , "bc/src/resolve.c" , 1130 , __extension__ __PRETTY_FUNCTION__ ) ); 
            }
            ) ) 
# 1130 "bc/src/resolve.c"
            ; 
            irlv -> vars [0 ] -> resolve . lifted = lift ; 
            irlv -> vars [0 ] -> resolve . co_depth = linfo -> current_depth - rpos ; 
            irlv -> vars [0 ] -> resolve . lex_depth = linfo -> current_lex_depth - rpos ; 
            rpos ++ ; 
          }

# 1135 "bc/src/resolve.c"
          else {
            irlv -> vars [j ] -> resolve . lifted = ((void * ) 0 ) ; 
            irlv -> vars [j ] -> resolve . co_depth = linfo -> current_depth - pos ; 
            irlv -> vars [j ] -> resolve . lex_depth = linfo -> current_lex_depth - pos ; 


            irlv -> vars [j ] -> val_type = 0 ; 
            pos ++ ; 
          }
        }
      }
    }

    if (resolve_phase < 2 ) {





      int converted ; 
#     define XfOrM251_COUNT (0+XfOrM250_COUNT)
#     define SETUP_XfOrM251(x) SETUP_XfOrM250(x)

# 1155 "bc/src/resolve.c"
      do {
#       define XfOrM280_COUNT (0+XfOrM251_COUNT)
#       define SETUP_XfOrM280(x) SETUP_XfOrM251(x)

# 1156 "bc/src/resolve.c"
        irlv = (Scheme_IR_Let_Value * ) head -> body ; 
        converted = 0 ; 
        for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
#         define XfOrM289_COUNT (0+XfOrM280_COUNT)
#         define SETUP_XfOrM289(x) SETUP_XfOrM280(x)

# 1159 "bc/src/resolve.c"
          if ((irlv -> count == 1 ) 
          && ! irlv -> vars [0 ] -> optimize_used 
          && irlv -> vars [0 ] -> resolve_omittable ) {
          }
          else if ((irlv -> count == 1 ) 
          && FUNCCALL(SETUP_XfOrM289(_), is_nonconstant_procedure (irlv -> value , info , binding_vars ) )) {
            Scheme_Object * lift , * old_lift ; 
            int old_convert_count ; 
            Scheme_Object * old_convert_map , * convert_map ; 
            BLOCK_SETUP((PUSH(old_lift, 0+XfOrM289_COUNT), PUSH(convert_map, 1+XfOrM289_COUNT), PUSH(old_convert_map, 2+XfOrM289_COUNT), PUSH(lift, 3+XfOrM289_COUNT)));
#           define XfOrM290_COUNT (4+XfOrM289_COUNT)
#           define SETUP_XfOrM290(x) SETUP(XfOrM290_COUNT)
            lift = NULLED_OUT ; 
            old_lift = NULLED_OUT ; 
            old_convert_map = NULLED_OUT ; 
            convert_map = NULLED_OUT ; 

# 1169 "bc/src/resolve.c"
            old_lift = irlv -> vars [0 ] -> resolve . lifted ; 
            old_convert_count = FUNCCALL(SETUP_XfOrM290(_), get_convert_arg_count (old_lift ) ); 
            old_convert_map = FUNCCALL_AGAIN(get_convert_arg_map (old_lift ) ); 

            lift = FUNCCALL_AGAIN(resolve_lambda (irlv -> value , linfo , 1 , 1 , 1 , (resolve_phase ? ((void * ) 0 ) : old_lift ) ) )
            ; 

            if (! info -> no_lift 
            && (FUNCCALL(SETUP_XfOrM290(_), is_closed_reference (lift ) )
            || (FUNCCALL(SETUP_XfOrM290(_), is_lifted_reference (lift ) )&& resolve_phase ) ) ) {
#             define XfOrM292_COUNT (0+XfOrM290_COUNT)
#             define SETUP_XfOrM292(x) SETUP_XfOrM290(x)

# 1179 "bc/src/resolve.c"
              if (! ((old_lift ) == (lift ) ) )
                irlv -> vars [0 ] -> resolve . lifted = lift ; 
              if (FUNCCALL(SETUP_XfOrM292(_), get_convert_arg_count (lift ) )!= old_convert_count )
                converted = 1 ; 
              else if (old_convert_map ) {
                int z ; 
#               define XfOrM293_COUNT (0+XfOrM292_COUNT)
#               define SETUP_XfOrM293(x) SETUP_XfOrM292(x)

# 1185 "bc/src/resolve.c"
                convert_map = FUNCCALL(SETUP_XfOrM293(_), get_convert_arg_map (lift ) ); 
                for (z = 0 ; z < old_convert_count ; z ++ ) {
                  if ((((Scheme_Vector * ) (old_convert_map ) ) -> els ) [z + 1 ] != (((Scheme_Vector * ) (convert_map ) ) -> els ) [z + 1 ] )
                    converted = 1 ; 
                }
              }
            }

# 1191 "bc/src/resolve.c"
            else {
              lifted_recs = 0 ; 
              converted = 0 ; 
              break ; 
            }
          }
        }
      }

# 1198 "bc/src/resolve.c"
      while (converted ) ; 

      if (lifted_recs ) {
#       define XfOrM252_COUNT (0+XfOrM251_COUNT)
#       define SETUP_XfOrM252(x) SETUP_XfOrM251(x)

# 1214 "bc/src/resolve.c"
        irlv = (Scheme_IR_Let_Value * ) head -> body ; 
        for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
#         define XfOrM258_COUNT (0+XfOrM252_COUNT)
#         define SETUP_XfOrM258(x) SETUP_XfOrM252(x)

# 1216 "bc/src/resolve.c"
          if ((irlv -> count == 1 ) 
          && ! irlv -> vars [0 ] -> optimize_used 
          && irlv -> vars [0 ] -> resolve_omittable ) {
          }
          else if ((irlv -> count == 1 ) && FUNCCALL(SETUP_XfOrM258(_), is_nonconstant_procedure (irlv -> value , info , binding_vars ) )) {
            Scheme_Object * lift ; 
            BLOCK_SETUP((PUSH(lift, 0+XfOrM258_COUNT)));
#           define XfOrM259_COUNT (1+XfOrM258_COUNT)
#           define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
            lift = NULLED_OUT ; 

# 1222 "bc/src/resolve.c"
            lift = irlv -> vars [0 ] -> resolve . lifted ; 
            if (FUNCCALL(SETUP_XfOrM259(_), is_closed_reference (lift ) )) {
#             define XfOrM261_COUNT (0+XfOrM259_COUNT)
#             define SETUP_XfOrM261(x) SETUP_XfOrM259(x)

# 1224 "bc/src/resolve.c"
              (void ) FUNCCALL(SETUP_XfOrM261(_), resolve_lambda (irlv -> value , linfo , 1 , 1 , 0 , lift ) ); 





              irlv -> value = ((void * ) 0 ) ; 
            }

# 1231 "bc/src/resolve.c"
            else {
#             define XfOrM260_COUNT (0+XfOrM259_COUNT)
#             define SETUP_XfOrM260(x) SETUP_XfOrM259(x)

# 1232 "bc/src/resolve.c"
              lift = FUNCCALL(SETUP_XfOrM260(_), resolve_lambda (irlv -> value , linfo , 1 , 1 , 2 , ((void * ) 0 ) ) ); 

              irlv -> vars [0 ] -> resolve . lifted = lift ; 
            }
          }
        }

        break ; 
      }
    }
  }

  * _lifted_recs = lifted_recs ; 

  RET_VALUE_START (linfo ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1249 "bc/src/resolve.c"
Scheme_Object * scheme_resolve_lets (Scheme_Object * form , Resolve_Info * info ) 
# 1260 "bc/src/resolve.c"
{
  Resolve_Info * linfo ; 
  Scheme_IR_Let_Header * head = (Scheme_IR_Let_Header * ) form ; 
  Scheme_IR_Let_Value * irlv , * pre_body ; 
  Scheme_Let_Value * lv , * last = ((void * ) 0 ) ; 
  Scheme_Object * first = ((void * ) 0 ) , * body , * last_body = ((void * ) 0 ) , * last_seq = ((void * ) 0 ) ; 
  Scheme_Letrec * letrec ; 
  Scheme_Object * boxes ; 
  int i , j , rpos , recbox , num_rec_procs = 0 , extra_alloc ; 
  int rec_proc_nonapply = 0 ; 
  int num_skips , lifted_recs ; 
  Scheme_Hash_Tree * binding_vars ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(pre_body, 0), PUSH(irlv, 1), PUSH(boxes, 2), PUSH(last, 3), PUSH(head, 4), PUSH(info, 5), PUSH(binding_vars, 6), PUSH(last_seq, 7), PUSH(first, 8), PUSH(letrec, 9), PUSH(last_body, 10), PUSH(linfo, 11), PUSH(lv, 12), PUSH(body, 13)));
# define XfOrM325_COUNT (14)
# define SETUP_XfOrM325(x) SETUP(XfOrM325_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  linfo = NULLED_OUT ; 
  irlv = NULLED_OUT ; 
  pre_body = NULLED_OUT ; 
  lv = NULLED_OUT ; 
  body = NULLED_OUT ; 
  letrec = NULLED_OUT ; 
  boxes = NULLED_OUT ; 
  binding_vars = NULLED_OUT ; 

# 1274 "bc/src/resolve.c"
  body = head -> body ; 
  pre_body = ((void * ) 0 ) ; 
  binding_vars = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
  for (i = head -> num_clauses ; i -- ; ) {
#   define XfOrM389_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM389(x) SETUP_XfOrM325(x)

# 1278 "bc/src/resolve.c"
    pre_body = (Scheme_IR_Let_Value * ) body ; 
    for (j = 0 ; j < pre_body -> count ; j ++ ) {
#     define XfOrM391_COUNT (0+XfOrM389_COUNT)
#     define SETUP_XfOrM391(x) SETUP_XfOrM389(x)

# 1280 "bc/src/resolve.c"
      binding_vars = FUNCCALL(SETUP_XfOrM391(_), scheme_hash_tree_set (binding_vars , (Scheme_Object * ) pre_body -> vars [j ] , scheme_true ) ); 
    }
    body = pre_body -> body ; 
  }

  recbox = 0 ; 
  if ((& head -> iso ) -> so . keyex & 0x1 ) {
#   define XfOrM385_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM385(x) SETUP_XfOrM325(x)

# 1288 "bc/src/resolve.c"
    recbox = FUNCCALL(SETUP_XfOrM385(_), check_need_boxed_letrec_rhs (head , binding_vars , info , & num_rec_procs , & rec_proc_nonapply ) )
    ; 
  }

# 1290 "bc/src/resolve.c"
  else {
#   define XfOrM379_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM379(x) SETUP_XfOrM325(x)
    irlv = (Scheme_IR_Let_Value * ) head -> body ; 
    for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
      if (irlv -> count != 1 )
        break ; 
      if (irlv -> vars [0 ] -> mutated )
        break ; 
    }

    if (i < 0 ) {
#     define XfOrM382_COUNT (0+XfOrM379_COUNT)
#     define SETUP_XfOrM382(x) SETUP_XfOrM379(x)

# 1303 "bc/src/resolve.c"
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM382(_), build_let_one_chain (head , body , info ) )) RET_VALUE_END ; 
    }

# 1304 "bc/src/resolve.c"
    else {
#     define XfOrM380_COUNT (0+XfOrM379_COUNT)
#     define SETUP_XfOrM380(x) SETUP_XfOrM379(x)


      if (FUNCCALL(SETUP_XfOrM380(_), all_unused_and_omittable (head ) )) {
#       define XfOrM381_COUNT (0+XfOrM380_COUNT)
#       define SETUP_XfOrM381(x) SETUP_XfOrM380(x)

# 1311 "bc/src/resolve.c"
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM381(_), resolve_expr (body , info ) )) RET_VALUE_END ; 
      }
    }
  }


  num_skips = 0 ; 
  irlv = (Scheme_IR_Let_Value * ) head -> body ; 
  for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
    if ((irlv -> count == 1 ) && irlv -> vars [0 ] -> resolve_omittable ) {
      num_skips ++ ; 
    }
  }


  linfo = FUNCCALL(SETUP_XfOrM325(_), compute_possible_lifts (head , info , binding_vars , recbox , num_skips , num_rec_procs , rec_proc_nonapply , & lifted_recs ) )

  ; 

  extra_alloc = 0 ; 

  if (num_rec_procs ) {
#   define XfOrM372_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM372(x) SETUP_XfOrM325(x)

# 1333 "bc/src/resolve.c"
    if (! lifted_recs ) {



      Scheme_Object * * sa ; 
      BLOCK_SETUP((PUSH(sa, 0+XfOrM372_COUNT)));
#     define XfOrM374_COUNT (1+XfOrM372_COUNT)
#     define SETUP_XfOrM374(x) SETUP(XfOrM374_COUNT)
      sa = NULLED_OUT ; 

# 1338 "bc/src/resolve.c"
      letrec = ((Scheme_Letrec * ) FUNCCALL(SETUP_XfOrM374(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Letrec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      letrec -> so . type = scheme_letrec_type ; 
      letrec -> count = num_rec_procs ; 
      sa = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM374(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rec_procs ) ) )) ; 
      letrec -> procs = sa ; 
    }

# 1343 "bc/src/resolve.c"
    else {
      extra_alloc = - num_rec_procs ; 
      letrec = ((void * ) 0 ) ; 
    }
  }

# 1347 "bc/src/resolve.c"
  else 
  letrec = ((void * ) 0 ) ; 


  boxes = scheme_null ; 
  irlv = (Scheme_IR_Let_Value * ) head -> body ; 
  rpos = 0 ; 
  for (i = head -> num_clauses ; i -- ; irlv = (Scheme_IR_Let_Value * ) irlv -> body ) {
#   define XfOrM352_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM352(x) SETUP_XfOrM325(x)

# 1355 "bc/src/resolve.c"
    if ((irlv -> count == 1 ) 
    && ! irlv -> vars [0 ] -> optimize_used 
    && irlv -> vars [0 ] -> resolve_omittable ) {
    }
    else {
      int isproc ; 
      Scheme_Object * expr ; 
      BLOCK_SETUP((PUSH(expr, 0+XfOrM352_COUNT)));
#     define XfOrM353_COUNT (1+XfOrM352_COUNT)
#     define SETUP_XfOrM353(x) SETUP(XfOrM353_COUNT)
      expr = NULLED_OUT ; 

# 1362 "bc/src/resolve.c"
      if (! irlv -> value )
        isproc = 1 ; 
      else if (irlv -> count == 1 )
        isproc = FUNCCALL(SETUP_XfOrM353(_), is_nonconstant_procedure (irlv -> value , info , binding_vars ) ); 
      else 
      isproc = 0 ; 
      if (num_rec_procs && isproc ) {
#       define XfOrM366_COUNT (0+XfOrM353_COUNT)
#       define SETUP_XfOrM366(x) SETUP_XfOrM353(x)

# 1369 "bc/src/resolve.c"
        if (! lifted_recs ) {
#         define XfOrM369_COUNT (0+XfOrM366_COUNT)
#         define SETUP_XfOrM369(x) SETUP_XfOrM366(x)

# 1370 "bc/src/resolve.c"
          expr = FUNCCALL(SETUP_XfOrM369(_), resolve_lambda (irlv -> value , linfo , 0 , 0 , 0 , ((void * ) 0 ) ) ); 
          if (! ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) ) {
#           define XfOrM370_COUNT (0+XfOrM369_COUNT)
#           define SETUP_XfOrM370(x) SETUP_XfOrM369(x)
            FUNCCALL(SETUP_XfOrM370(_), scheme_signal_error ("internal error: unexpected empty closure" ) )
# 1372 "bc/src/resolve.c"
            ; 
          }
          letrec -> procs [rpos ++ ] = expr ; 
        }

# 1375 "bc/src/resolve.c"
        else {
#         define XfOrM367_COUNT (0+XfOrM366_COUNT)
#         define SETUP_XfOrM367(x) SETUP_XfOrM366(x)

# 1376 "bc/src/resolve.c"
          if (! FUNCCALL(SETUP_XfOrM367(_), is_closed_reference (irlv -> vars [0 ] -> resolve . lifted ) )) {
#           define XfOrM368_COUNT (0+XfOrM367_COUNT)
#           define SETUP_XfOrM368(x) SETUP_XfOrM367(x)

# 1378 "bc/src/resolve.c"
            (void ) FUNCCALL(SETUP_XfOrM368(_), resolve_lambda (irlv -> value , linfo , 1 , 1 , 0 , irlv -> vars [0 ] -> resolve . lifted ) ); 
          }
          rpos ++ ; 
        }
      }

# 1382 "bc/src/resolve.c"
      else {
        int j ; 
#       define XfOrM354_COUNT (0+XfOrM353_COUNT)
#       define SETUP_XfOrM354(x) SETUP_XfOrM353(x)

# 1385 "bc/src/resolve.c"
        if (! irlv -> count )
          expr = FUNCCALL(SETUP_XfOrM354(_), drop_zero_value_return (irlv -> value ) ); 
        else 
        expr = ((void * ) 0 ) ; 

        if (expr ) {
#         define XfOrM365_COUNT (0+XfOrM354_COUNT)
#         define SETUP_XfOrM365(x) SETUP_XfOrM354(x)

          expr = FUNCCALL(SETUP_XfOrM365(_), resolve_expr (expr , linfo ) ); 
          expr = (__funcarg60 = (__funcarg61 = FUNCCALL(SETUP_XfOrM365(_), scheme_make_pair (scheme_false , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (expr , __funcarg61 ) )) 

          , FUNCCALL_AGAIN(scheme_make_sequence_compilation (__funcarg60 , 0 , 0 ) )) 

          ; 

          if (last )
            last -> body = expr ; 
          else if (last_body )
            (((Scheme_Simple_Object * ) (last_body ) ) -> u . two_ptr_val . ptr2 ) = expr ; 
          else if (last_seq )
            ((Scheme_Sequence * ) last_seq ) -> array [1 ] = expr ; 
          else 
          first = expr ; 
          last = ((void * ) 0 ) ; 
          last_body = ((void * ) 0 ) ; 
          last_seq = expr ; 
        }

# 1412 "bc/src/resolve.c"
        else {
#         define XfOrM355_COUNT (0+XfOrM354_COUNT)
#         define SETUP_XfOrM355(x) SETUP_XfOrM354(x)

# 1413 "bc/src/resolve.c"
          expr = FUNCCALL(SETUP_XfOrM355(_), resolve_expr (irlv -> value , linfo ) ); 

          lv = ((Scheme_Let_Value * ) FUNCCALL(SETUP_XfOrM355(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Let_Value ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
          if (last )
            last -> body = (Scheme_Object * ) lv ; 
          else if (last_body )
            (((Scheme_Simple_Object * ) (last_body ) ) -> u . two_ptr_val . ptr2 ) = (Scheme_Object * ) lv ; 
          else if (last_seq )
            ((Scheme_Sequence * ) last_seq ) -> array [1 ] = (Scheme_Object * ) lv ; 
          else 
          first = (Scheme_Object * ) lv ; 
          last = lv ; 
          last_body = ((void * ) 0 ) ; 
          last_seq = ((void * ) 0 ) ; 

          lv -> iso . so . type = scheme_let_value_type ; 
          lv -> value = expr ; 
          if (irlv -> count ) {
            int li ; 
#           define XfOrM364_COUNT (0+XfOrM355_COUNT)
#           define SETUP_XfOrM364(x) SETUP_XfOrM355(x)

# 1432 "bc/src/resolve.c"
            li = FUNCCALL(SETUP_XfOrM364(_), resolve_info_lookup (linfo , irlv -> vars [0 ] , ((void * ) 0 ) , 0 , 0x1 ) ); 
            lv -> position = li ; 
          }

# 1434 "bc/src/resolve.c"
          else 
          lv -> position = 0 ; 
          lv -> count = irlv -> count ; 
          (& lv -> iso ) -> so . keyex = recbox ; 

          for (j = lv -> count ; j -- ; ) {
#           define XfOrM360_COUNT (0+XfOrM355_COUNT)
#           define SETUP_XfOrM360(x) SETUP_XfOrM355(x)

# 1440 "bc/src/resolve.c"
            if (! recbox && irlv -> vars [j ] -> mutated ) {
              GC_CAN_IGNORE Scheme_Object * pos ; 
#             define XfOrM361_COUNT (0+XfOrM360_COUNT)
#             define SETUP_XfOrM361(x) SETUP_XfOrM360(x)

# 1442 "bc/src/resolve.c"
              pos = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (lv -> position + j ) ) ) << 1 ) | 0x1 ) ) ; 
              if (((& head -> iso ) -> so . keyex & 0x1 ) 
              || irlv -> vars [j ] -> must_allocate_immediately ) {

                Scheme_Object * boxenv ; 
                BLOCK_SETUP((PUSH(boxenv, 0+XfOrM361_COUNT)));
#               define XfOrM363_COUNT (1+XfOrM361_COUNT)
#               define SETUP_XfOrM363(x) SETUP(XfOrM363_COUNT)
                boxenv = NULLED_OUT ; 

# 1448 "bc/src/resolve.c"
                boxenv = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM363(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
                boxenv -> type = scheme_boxenv_type ; 
                (((Scheme_Simple_Object * ) (boxenv ) ) -> u . two_ptr_val . ptr1 ) = pos ; 
                (((Scheme_Simple_Object * ) (boxenv ) ) -> u . two_ptr_val . ptr2 ) = scheme_false ; 

                if (last )
                  last -> body = boxenv ; 
                else if (last_seq )
                  ((Scheme_Sequence * ) last_seq ) -> array [1 ] = boxenv ; 
                else 
                (((Scheme_Simple_Object * ) (last_body ) ) -> u . two_ptr_val . ptr2 ) = boxenv ; 
                last = ((void * ) 0 ) ; 
                last_body = boxenv ; 
                last_seq = ((void * ) 0 ) ; 
              }

# 1462 "bc/src/resolve.c"
              else {
#               define XfOrM362_COUNT (0+XfOrM361_COUNT)
#               define SETUP_XfOrM362(x) SETUP_XfOrM361(x)
                boxes = FUNCCALL(SETUP_XfOrM362(_), scheme_make_pair (pos , boxes ) ); 
              }
            }
          }
        }
      }
    }
  }


  body = FUNCCALL(SETUP_XfOrM325(_), resolve_expr ((Scheme_Object * ) irlv , linfo ) ); 

  while (((Scheme_Type ) (((((intptr_t ) (boxes ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (boxes ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {

    Scheme_Object * bcode ; 
    BLOCK_SETUP((PUSH(bcode, 0+XfOrM325_COUNT)));
#   define XfOrM331_COUNT (1+XfOrM325_COUNT)
#   define SETUP_XfOrM331(x) SETUP(XfOrM331_COUNT)
    bcode = NULLED_OUT ; 

# 1480 "bc/src/resolve.c"
    bcode = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM331(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    bcode -> type = scheme_boxenv_type ; 
    (((Scheme_Simple_Object * ) (bcode ) ) -> u . two_ptr_val . ptr1 ) = (((Scheme_Simple_Object * ) (boxes ) ) -> u . pair_val . car ) ; 
    (((Scheme_Simple_Object * ) (bcode ) ) -> u . two_ptr_val . ptr2 ) = body ; 
    body = bcode ; 
    boxes = (((Scheme_Simple_Object * ) (boxes ) ) -> u . pair_val . cdr ) ; 
  }


  if (letrec ) {
    letrec -> body = body ; 
    if (last )
      last -> body = (Scheme_Object * ) letrec ; 
    else if (last_body )
      (((Scheme_Simple_Object * ) (last_body ) ) -> u . two_ptr_val . ptr2 ) = (Scheme_Object * ) letrec ; 
    else if (last_seq )
      ((Scheme_Sequence * ) last_seq ) -> array [1 ] = (Scheme_Object * ) letrec ; 
    else 
    first = (Scheme_Object * ) letrec ; 
  }

# 1499 "bc/src/resolve.c"
  else if (last )
    last -> body = body ; 
  else if (last_body )
    (((Scheme_Simple_Object * ) (last_body ) ) -> u . two_ptr_val . ptr2 ) = body ; 
  else if (last_seq )
    ((Scheme_Sequence * ) last_seq ) -> array [1 ] = (Scheme_Object * ) body ; 
  else 
  first = body ; 


  if (head -> count + extra_alloc - num_skips ) {
    int cnt ; 
#   define XfOrM326_COUNT (0+XfOrM325_COUNT)
#   define SETUP_XfOrM326(x) SETUP_XfOrM325(x)

# 1512 "bc/src/resolve.c"
    cnt = head -> count + extra_alloc - num_skips ; 

    if (! recbox && (cnt == 1 ) 
    && (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_let_value_type ) ) ) 
    && (((Scheme_Let_Value * ) first ) -> count == 1 ) 
    && (((Scheme_Let_Value * ) first ) -> position == 0 ) ) {

      Scheme_Let_One * lo ; 
      int et ; 
      BLOCK_SETUP((PUSH(lo, 0+XfOrM326_COUNT)));
#     define XfOrM328_COUNT (1+XfOrM326_COUNT)
#     define SETUP_XfOrM328(x) SETUP(XfOrM328_COUNT)
      lo = NULLED_OUT ; 

# 1522 "bc/src/resolve.c"
      lo = ((Scheme_Let_One * ) FUNCCALL(SETUP_XfOrM328(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Let_One ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      lo -> iso . so . type = scheme_let_one_type ; 
      lo -> value = ((Scheme_Let_Value * ) first ) -> value ; 
      lo -> body = ((Scheme_Let_Value * ) first ) -> body ; 

      et = FUNCCALL(SETUP_XfOrM328(_), scheme_get_eval_type (lo -> value ) ); 
      (& lo -> iso ) -> so . keyex = et ; 

      first = (Scheme_Object * ) lo ; 
    }

# 1531 "bc/src/resolve.c"
    else {
      Scheme_Let_Void * lvd ; 
      BLOCK_SETUP((PUSH(lvd, 0+XfOrM326_COUNT)));
#     define XfOrM327_COUNT (1+XfOrM326_COUNT)
#     define SETUP_XfOrM327(x) SETUP(XfOrM327_COUNT)
      lvd = NULLED_OUT ; 

# 1534 "bc/src/resolve.c"
      lvd = ((Scheme_Let_Void * ) FUNCCALL(SETUP_XfOrM327(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Let_Void ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      lvd -> iso . so . type = scheme_let_void_type ; 
      lvd -> body = first ; 
      lvd -> count = cnt ; 
      (& lvd -> iso ) -> so . keyex = recbox ; 

      first = (Scheme_Object * ) lvd ; 
    }
  }
  FUNCCALL(SETUP_XfOrM325(_), merge_resolve (info , linfo ) )
  ; 

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

__xform_nongcing__ int scheme_boxmap_size (int n ) 
{
  /* No conversion */

# 1555 "bc/src/resolve.c"
  return ((4 * n ) + ((8 * sizeof (mzshort ) ) - 1 ) ) / (8 * sizeof (mzshort ) ) ; 
}

void scheme_boxmap_set (mzshort * boxmap , int j , int bit , int delta ) 

{
  /* No conversion */

# 1561 "bc/src/resolve.c"
  j *= 4 ; 
  boxmap [delta + (j / (8 * sizeof (mzshort ) ) ) ] |= ((mzshort ) bit << (j & ((8 * sizeof (mzshort ) ) - 1 ) ) ) ; 
}

int scheme_boxmap_get (mzshort * boxmap , int j , int delta ) 
{
  /* No conversion */

# 1567 "bc/src/resolve.c"
  j *= 4 ; 
  return (boxmap [delta + (j / (8 * sizeof (mzshort ) ) ) ] >> (j & ((8 * sizeof (mzshort ) ) - 1 ) ) 
  & ((1 << 4 ) - 1 ) ) ; 
}

static int is_nonconstant_procedure (Scheme_Object * _lam , Resolve_Info * info , Scheme_Hash_Tree * exclude_vars ) 
{


  Scheme_Lambda * lam ; 
  Scheme_IR_Lambda_Info * cl ; 
  Scheme_Object * lifted ; 
  int i ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(lifted, 0), PUSH(exclude_vars, 1), PUSH(cl, 2), PUSH(info, 3)));
# define XfOrM395_COUNT (4)
# define SETUP_XfOrM395(x) SETUP(XfOrM395_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  lam = NULLED_OUT ; 
  cl = NULLED_OUT ; 
  lifted = NULLED_OUT ; 

# 1581 "bc/src/resolve.c"
  if ((Scheme_Type ) (((((intptr_t ) (_lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (_lam ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_lambda_type ) )  {
#   define XfOrM396_COUNT (0+XfOrM395_COUNT)
#   define SETUP_XfOrM396(x) SETUP_XfOrM395(x)

# 1582 "bc/src/resolve.c"
    lam = (Scheme_Lambda * ) _lam ; 

    cl = lam -> ir_info ; 
    if (cl -> has_tl )
      RET_VALUE_START (1 ) RET_VALUE_END ; 

    for (i = 0 ; i < cl -> base_closure -> size ; i ++ ) {
#     define XfOrM401_COUNT (0+XfOrM396_COUNT)
#     define SETUP_XfOrM401(x) SETUP_XfOrM396(x)

# 1589 "bc/src/resolve.c"
      if (cl -> base_closure -> vals [i ] ) {
        Scheme_IR_Local * var = (Scheme_IR_Local * ) cl -> base_closure -> keys [i ] ; 
        BLOCK_SETUP((PUSH(var, 0+XfOrM401_COUNT)));
#       define XfOrM402_COUNT (1+XfOrM401_COUNT)
#       define SETUP_XfOrM402(x) SETUP(XfOrM402_COUNT)

# 1592 "bc/src/resolve.c"
        if (FUNCCALL(SETUP_XfOrM402(_), scheme_hash_tree_get (exclude_vars , (Scheme_Object * ) var ) ))
          RET_VALUE_START (1 ) RET_VALUE_END ; 

        if (var -> optimize_used ) {
#         define XfOrM403_COUNT (0+XfOrM402_COUNT)
#         define SETUP_XfOrM403(x) SETUP_XfOrM402(x)

# 1596 "bc/src/resolve.c"
          ((void ) sizeof ((var -> mode == 4 ) ? 1 : 0 ) , __extension__ ({
#           define XfOrM404_COUNT (0+XfOrM403_COUNT)
#           define SETUP_XfOrM404(x) SETUP_XfOrM403(x)

# 1596 "bc/src/resolve.c" 3
            if (var -> mode == 4 )

# 1596 "bc/src/resolve.c" 3
            ; 

# 1596 "bc/src/resolve.c" 3
            else FUNCCALL(SETUP_XfOrM404(_), __assert_fail ("var->mode == 4" , "bc/src/resolve.c" , 1596 , __extension__ __PRETTY_FUNCTION__ ) ); 
          }
          ) ) 
# 1596 "bc/src/resolve.c"
          ; 
          (void ) FUNCCALL(SETUP_XfOrM403(_), resolve_info_lookup (info , var , & lifted , 0 , 0 ) ); 
          if (! lifted )
            RET_VALUE_START (1 ) RET_VALUE_END ; 
          if (((Scheme_Type ) (((((intptr_t ) (lifted ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lifted ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
          || ((Scheme_Type ) (((((intptr_t ) (lifted ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lifted ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) 
          || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
          || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) )
            RET_VALUE_START (1 ) RET_VALUE_END ; 
        }
      }
    }

    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1615 "bc/src/resolve.c"
static Scheme_Object * 
resolve_lambda (Scheme_Object * _lam , Resolve_Info * info , 
int can_lift , int convert , int just_compute_lift , 
Scheme_Object * precomputed_lift ) 
{
  Scheme_Lambda * lam ; 
  int i , closure_size , new_params , num_params ; 
  int need_type_map = 0 ; 
  int has_tl , need_lift , using_lifted = 0 ; 
  mzshort * closure_map ; 
  Scheme_IR_Lambda_Info * cl ; 
  Resolve_Info * new_info ; 
  Scheme_Object * lifted , * result , * lifteds = ((void * ) 0 ) ; 
  Scheme_Hash_Table * captured = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(captured, 0), PUSH(new_info, 1), PUSH(result, 2), PUSH(lam, 3), PUSH(closure_map, 4), PUSH(info, 5), PUSH(precomputed_lift, 6), PUSH(cl, 7), PUSH(lifteds, 8), PUSH(lifted, 9)));
# define XfOrM405_COUNT (10)
# define SETUP_XfOrM405(x) SETUP(XfOrM405_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  lam = NULLED_OUT ; 
  closure_map = NULLED_OUT ; 
  cl = NULLED_OUT ; 
  new_info = NULLED_OUT ; 
  lifted = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 1630 "bc/src/resolve.c"
  lam = (Scheme_Lambda * ) _lam ; 
  cl = lam -> ir_info ; 
  if (! just_compute_lift )
    lam -> iso . so . type = scheme_lambda_type ; 

  if (convert || can_lift ) {
#   define XfOrM507_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM507(x) SETUP_XfOrM405(x)

# 1636 "bc/src/resolve.c"
    if (! convert && ! FUNCCALL(SETUP_XfOrM507(_), resolve_is_inside_proc (info ) ))
      can_lift = 0 ; 
    if (! info -> lifts )
      can_lift = 0 ; 
  }


  if (cl -> arg_types ) {
    int at_least_one = 0 ; 
#   define XfOrM502_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM502(x) SETUP_XfOrM405(x)

# 1645 "bc/src/resolve.c"
    for (i = lam -> num_params ; i -- ; ) {
#     define XfOrM505_COUNT (0+XfOrM502_COUNT)
#     define SETUP_XfOrM505(x) SETUP_XfOrM502(x)

# 1646 "bc/src/resolve.c"
      if (cl -> arg_types [i ] ) {
        int ct ; 
#       define XfOrM506_COUNT (0+XfOrM505_COUNT)
#       define SETUP_XfOrM506(x) SETUP_XfOrM505(x)

# 1648 "bc/src/resolve.c"
        ct = (scheme_predicate_to_local_type (cl -> arg_types [i ] ) ) ; 
        if (ct 
        && (cl -> vars [i ] -> arg_type == ct ) 
        && (! cl -> vars [i ] -> escapes_after_k_tick 
        || ((cl -> vars [i ] -> arg_type ) == 2 ) ) )
          at_least_one = 1 ; 
        else 
        cl -> arg_types [i ] = ((void * ) 0 ) ; 
      }
    }
    if (at_least_one )
      need_type_map = 1 ; 
    else 
    cl -> arg_types = ((void * ) 0 ) ; 
  }

  has_tl = (info -> static_mode ? 0 : cl -> has_tl ) ; 





  closure_size = 0 ; 
  captured = FUNCCALL(SETUP_XfOrM405(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  for (i = 0 ; i < cl -> base_closure -> size ; i ++ ) {
#   define XfOrM494_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM494(x) SETUP_XfOrM405(x)

# 1673 "bc/src/resolve.c"
    if (cl -> base_closure -> vals [i ] ) {
      Scheme_IR_Local * var = ((Scheme_IR_Local * ) cl -> base_closure -> keys [i ] ) ; 
      BLOCK_SETUP((PUSH(var, 0+XfOrM494_COUNT)));
#     define XfOrM495_COUNT (1+XfOrM494_COUNT)
#     define SETUP_XfOrM495(x) SETUP(XfOrM495_COUNT)

# 1676 "bc/src/resolve.c"
      if ((var -> mode == 3 ) 
      || ! var -> optimize_used ) {
      }

      else {
#       define XfOrM496_COUNT (0+XfOrM495_COUNT)
#       define SETUP_XfOrM496(x) SETUP_XfOrM495(x)

# 1681 "bc/src/resolve.c"
        (void ) FUNCCALL(SETUP_XfOrM496(_), resolve_info_lookup (info , var , & lifted , 0 , 0 ) ); 
        if (lifted ) {
#         define XfOrM498_COUNT (0+XfOrM496_COUNT)
#         define SETUP_XfOrM498(x) SETUP_XfOrM496(x)

# 1684 "bc/src/resolve.c"
          if (((Scheme_Type ) (((((intptr_t ) (lifted ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lifted ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
          || (((Scheme_Type ) (((((intptr_t ) (lifted ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lifted ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) 
          && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) ) ) {

            has_tl = 1 ; 
          }


          if ((Scheme_Type ) (((((intptr_t ) (lifted ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lifted ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) )  {
#           define XfOrM499_COUNT (0+XfOrM498_COUNT)
#           define SETUP_XfOrM499(x) SETUP_XfOrM498(x)

# 1693 "bc/src/resolve.c"
            lifteds = FUNCCALL(SETUP_XfOrM499(_), scheme_make_raw_pair (lifted , lifteds ) ); 
            using_lifted = 1 ; 
          }
        }

# 1696 "bc/src/resolve.c"
        else {
#         define XfOrM497_COUNT (0+XfOrM496_COUNT)
#         define SETUP_XfOrM497(x) SETUP_XfOrM496(x)
          FUNCCALL(SETUP_XfOrM497(_), scheme_hash_set (captured , (Scheme_Object * ) var , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (closure_size ) ) ) << 1 ) | 0x1 ) ) ) )
# 1697 "bc/src/resolve.c"
          ; 
          closure_size ++ ; 

          if ((var ) -> val_type && (! (var ) -> escapes_after_k_tick || (((var ) -> val_type ) == 2 ) ) ) 
            need_type_map = 1 ; 
        }
      }
    }
  }

  if (has_tl && ! can_lift )
    convert = 0 ; 


  while (lifteds ) {
    int j , cnt ; 
    Scheme_Object * vec ; 
    BLOCK_SETUP((PUSH(vec, 0+XfOrM405_COUNT)));
#   define XfOrM479_COUNT (1+XfOrM405_COUNT)
#   define SETUP_XfOrM479(x) SETUP(XfOrM479_COUNT)
    vec = NULLED_OUT ; 

# 1715 "bc/src/resolve.c"
    lifted = (((Scheme_Simple_Object * ) (lifteds ) ) -> u . pair_val . car ) ; 
    vec = (((Scheme_Simple_Object * ) (lifted ) ) -> u . pair_val . cdr ) ; 
    cnt = (((Scheme_Vector * ) (vec ) ) -> size ) ; 
    -- cnt ; 
    for (j = 0 ; j < cnt ; j ++ ) {
      Scheme_IR_Local * var = (Scheme_IR_Local * ) (((Scheme_Vector * ) (vec ) ) -> els ) [j + 1 ] ; 
      BLOCK_SETUP((PUSH(var, 0+XfOrM479_COUNT)));
#     define XfOrM483_COUNT (1+XfOrM479_COUNT)
#     define SETUP_XfOrM483(x) SETUP(XfOrM483_COUNT)

# 1721 "bc/src/resolve.c"
      if (! FUNCCALL(SETUP_XfOrM483(_), scheme_hash_get (captured , (Scheme_Object * ) var ) )) {
#       define XfOrM484_COUNT (0+XfOrM483_COUNT)
#       define SETUP_XfOrM484(x) SETUP_XfOrM483(x)

# 1723 "bc/src/resolve.c"
        ((void ) sizeof ((! var -> resolve . lifted ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM485_COUNT (0+XfOrM484_COUNT)
#         define SETUP_XfOrM485(x) SETUP_XfOrM484(x)

# 1723 "bc/src/resolve.c" 3
          if (! var -> resolve . lifted )

# 1723 "bc/src/resolve.c" 3
          ; 

# 1723 "bc/src/resolve.c" 3
          else FUNCCALL(SETUP_XfOrM485(_), __assert_fail ("!var->resolve.lifted" , "bc/src/resolve.c" , 1723 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 1723 "bc/src/resolve.c"
        ; 
        FUNCCALL(SETUP_XfOrM484(_), scheme_hash_set (captured , (Scheme_Object * ) var , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (captured -> count ) ) ) << 1 ) | 0x1 ) ) ) ); 
        if ((var ) -> val_type && (! (var ) -> escapes_after_k_tick || (((var ) -> val_type ) == 2 ) ) ) 
          need_type_map = 1 ; 
        closure_size ++ ; 
      }
    }

    lifteds = (((Scheme_Simple_Object * ) (lifteds ) ) -> u . pair_val . cdr ) ; 
  }


  if (closure_size ) {
    Scheme_IR_Local * * c ; 
    int j = 0 ; 
    BLOCK_SETUP((PUSH(c, 0+XfOrM405_COUNT)));
#   define XfOrM465_COUNT (1+XfOrM405_COUNT)
#   define SETUP_XfOrM465(x) SETUP(XfOrM465_COUNT)
    c = NULLED_OUT ; 

# 1738 "bc/src/resolve.c"
    c = ((Scheme_IR_Local * * ) FUNCCALL(SETUP_XfOrM465(_), GC_malloc (sizeof (Scheme_IR_Local * ) * (closure_size ) ) )) ; 
    for (i = 0 ; i < captured -> size ; i ++ ) {
      if (captured -> vals [i ] ) {
        c [j ++ ] = ((Scheme_IR_Local * ) captured -> keys [i ] ) ; 
      }
    }
    FUNCCALL(SETUP_XfOrM465(_), scheme_sort_resolve_ir_local_array (c , closure_size ) ); 
    for (i = 0 ; i < closure_size ; i ++ ) {
#     define XfOrM467_COUNT (0+XfOrM465_COUNT)
#     define SETUP_XfOrM467(x) SETUP_XfOrM465(x)
      FUNCCALL(SETUP_XfOrM467(_), scheme_hash_set (captured , (Scheme_Object * ) c [i ] , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) ) )
# 1746 "bc/src/resolve.c"
      ; 
    }
  }

  if (convert && (closure_size || has_tl || using_lifted ) ) {
    new_params = closure_size ; 
    closure_size = 0 ; 
  }

# 1753 "bc/src/resolve.c"
  else {
    new_params = 0 ; 
    convert = 0 ; 
  }


  if (has_tl ) {



    closure_size ++ ; 
  }



  num_params = lam -> num_params + new_params ; 

  if ((num_params == 1 ) 
  && ! new_params 
  && ((& (lam ) -> iso ) -> so . keyex & 1 ) 
  && ! cl -> vars [0 ] -> optimize_used ) {

    num_params = 0 ; 
  }

  if (! just_compute_lift ) {
#   define XfOrM425_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM425(x) SETUP_XfOrM405(x)

# 1779 "bc/src/resolve.c"
    if (convert && ! need_type_map && new_params ) {


      for (i = 0 ; i < captured -> size ; i ++ ) {
        if (captured -> vals [i ] ) {
          Scheme_IR_Local * var = ((Scheme_IR_Local * ) captured -> keys [i ] ) ; 
          if (var -> mutated ) {
            need_type_map = 1 ; 
            break ; 
          }
        }
      }
    }

    new_info = FUNCCALL(SETUP_XfOrM425(_), resolve_info_extend (info , num_params + closure_size , 1 ) ); 

    lam -> closure_size = closure_size ; 
    if (need_type_map )
      (& (lam ) -> iso ) -> so . keyex |= 2 ; 

    ((void ) sizeof ((need_type_map || ! ((& (lam ) -> iso ) -> so . keyex & 2 ) ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM453_COUNT (0+XfOrM425_COUNT)
#     define SETUP_XfOrM453(x) SETUP_XfOrM425(x)

# 1799 "bc/src/resolve.c" 3
      if (need_type_map || ! ((& (lam ) -> iso ) -> so . keyex & 2 ) )

# 1799 "bc/src/resolve.c" 3
      ; 

# 1799 "bc/src/resolve.c" 3
      else FUNCCALL(SETUP_XfOrM453(_), __assert_fail ("need_type_map || !((&(lam)->iso)->so.keyex & 2)" , "bc/src/resolve.c" , 1799 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 1799 "bc/src/resolve.c"
    ; 


    if (closure_size || need_type_map ) {
      int bmsz ; 
#     define XfOrM452_COUNT (0+XfOrM425_COUNT)
#     define SETUP_XfOrM452(x) SETUP_XfOrM425(x)

# 1804 "bc/src/resolve.c"
      if (need_type_map )
        bmsz = (scheme_boxmap_size (closure_size + num_params ) ) ; 
      else 
      bmsz = 0 ; 
      bmsz += closure_size ; 
      closure_map = (mzshort * ) FUNCCALL(SETUP_XfOrM452(_), GC_malloc_atomic (sizeof (mzshort ) * bmsz ) ); 
      (memset (closure_map + closure_size , 0 , sizeof (mzshort ) * (bmsz - closure_size ) ) ) ; 
    }

# 1811 "bc/src/resolve.c"
    else 
    closure_map = ((void * ) 0 ) ; 

    lam -> closure_map = closure_map ; 
    lam -> num_params = num_params ; 


    for (i = 0 ; i < num_params - new_params ; i ++ ) {
#     define XfOrM448_COUNT (0+XfOrM425_COUNT)
#     define SETUP_XfOrM448(x) SETUP_XfOrM425(x)
      FUNCCALL(SETUP_XfOrM448(_), set_resolve_mode (cl -> vars [i ] ) )
# 1819 "bc/src/resolve.c"
      ; 
      cl -> vars [i ] -> resolve . co_depth = new_info -> current_depth - (i + new_params + closure_size ) ; 
      cl -> vars [i ] -> resolve . lex_depth = new_info -> current_lex_depth - (i + new_params + closure_size ) ; 
      if (convert ) {



        int lt ; 
#       define XfOrM449_COUNT (0+XfOrM448_COUNT)
#       define SETUP_XfOrM449(x) SETUP_XfOrM448(x)

# 1827 "bc/src/resolve.c"
        if (cl -> arg_types ) {
#         define XfOrM451_COUNT (0+XfOrM449_COUNT)
#         define SETUP_XfOrM451(x) SETUP_XfOrM449(x)

# 1828 "bc/src/resolve.c"
          lt = (scheme_predicate_to_local_type (cl -> arg_types [i ] ) ) ; 
          cl -> vars [i ] -> val_type = lt ; 
        }

# 1830 "bc/src/resolve.c"
        else 
        lt = 0 ; 
        if (need_type_map ) {
#         define XfOrM450_COUNT (0+XfOrM449_COUNT)
#         define SETUP_XfOrM450(x) SETUP_XfOrM449(x)

# 1833 "bc/src/resolve.c"
          if (lt )
            (scheme_boxmap_set (closure_map , i + new_params , 
          lt + 1 , 
          closure_size ) ) ; 
        }
      }
    }


    for (i = 0 ; i < captured -> size ; i ++ ) {
#     define XfOrM439_COUNT (0+XfOrM425_COUNT)
#     define SETUP_XfOrM439(x) SETUP_XfOrM425(x)

# 1843 "bc/src/resolve.c"
      if (captured -> vals [i ] ) {
        int pos = (((intptr_t ) (captured -> vals [i ] ) ) >> 1 ) ; 
        Scheme_IR_Local * var = ((Scheme_IR_Local * ) captured -> keys [i ] ) ; 
        BLOCK_SETUP((PUSH(var, 0+XfOrM439_COUNT)));
#       define XfOrM440_COUNT (1+XfOrM439_COUNT)
#       define SETUP_XfOrM440(x) SETUP(XfOrM440_COUNT)
        FUNCCALL(SETUP_XfOrM440(_), resolve_info_add_mapping (new_info , var , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (new_info -> current_depth - pos - (convert ? closure_size : 0 ) ) ) ) << 1 ) | 0x1 ) ) ) )

        ; 
        ((void ) sizeof ((need_type_map || (! ((var ) -> val_type && (! (var ) -> escapes_after_k_tick || (((var ) -> val_type ) == 2 ) ) ) && (! var -> mutated || ! convert ) ) ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM443_COUNT (0+XfOrM440_COUNT)
#         define SETUP_XfOrM443(x) SETUP_XfOrM440(x)

# 1852 "bc/src/resolve.c" 3
          if (need_type_map || (! ((var ) -> val_type && (! (var ) -> escapes_after_k_tick || (((var ) -> val_type ) == 2 ) ) ) && (! var -> mutated || ! convert ) ) )

# 1852 "bc/src/resolve.c" 3
          ; 

# 1852 "bc/src/resolve.c" 3
          else FUNCCALL(SETUP_XfOrM443(_), __assert_fail ("need_type_map || (!((var)->val_type && (!(var)->escapes_after_k_tick || (((var)->val_type) == 2))) && (!var->mutated || !convert))" , "bc/src/resolve.c" , 1852 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 1852 "bc/src/resolve.c"
        ; 
        if (need_type_map ) {
#         define XfOrM442_COUNT (0+XfOrM440_COUNT)
#         define SETUP_XfOrM442(x) SETUP_XfOrM440(x)
          (
# 1854 "bc/src/resolve.c"
          scheme_boxmap_set (closure_map , (pos + (convert ? 0 : num_params ) ) , 
          ((((var ) -> val_type && (! (var ) -> escapes_after_k_tick || (((var ) -> val_type ) == 2 ) ) ) 
          ? (var -> val_type + 1 ) 
          : 0 ) 
          | (convert 
          ? (var -> mutated ? 1 : 0 ) 
          : 0 ) ) , 
          closure_size ) ) ; 
        }
        if (! convert ) {
          int li ; 
#         define XfOrM441_COUNT (0+XfOrM440_COUNT)
#         define SETUP_XfOrM441(x) SETUP_XfOrM440(x)

# 1865 "bc/src/resolve.c"
          li = FUNCCALL(SETUP_XfOrM441(_), resolve_info_lookup (info , var , ((void * ) 0 ) , 0 , 0 ) ); 
          closure_map [pos ] = li ; 
        }
      }
    }

    if (has_tl ) {
#     define XfOrM432_COUNT (0+XfOrM425_COUNT)
#     define SETUP_XfOrM432(x) SETUP_XfOrM425(x)
      FUNCCALL(SETUP_XfOrM432(_), resolve_info_set_toplevel_pos (new_info , closure_size - 1 ) )
# 1873 "bc/src/resolve.c"
      ; 
      if (closure_map ) {
        int li ; 
#       define XfOrM433_COUNT (0+XfOrM432_COUNT)
#       define SETUP_XfOrM433(x) SETUP_XfOrM432(x)

# 1876 "bc/src/resolve.c"
        li = FUNCCALL(SETUP_XfOrM433(_), resolve_toplevel_pos (info ) ); 
        closure_map [closure_size - 1 ] = li ; 
      }
    }

# 1879 "bc/src/resolve.c"
    else FUNCCALL(SETUP_XfOrM425(_), resolve_info_set_toplevel_pos (new_info , - 1 ) )
    ; 


    {
      Scheme_Object * code ; 
      BLOCK_SETUP((PUSH(code, 0+XfOrM425_COUNT)));
#     define XfOrM431_COUNT (1+XfOrM425_COUNT)
#     define SETUP_XfOrM431(x) SETUP(XfOrM431_COUNT)
      code = NULLED_OUT ; 

# 1885 "bc/src/resolve.c"
      code = FUNCCALL(SETUP_XfOrM431(_), resolve_expr (lam -> body , new_info ) ); 
      lam -> body = code ; 
    }

    lam -> max_let_depth = (new_info -> max_let_depth 
    + 5 ) ; 

    lam -> tl_map = new_info -> tl_map ; 
    if (! lam -> tl_map && has_tl ) {


      lam -> tl_map = (void * ) 0x1 ; 
    }


    for (i = 0 ; i < num_params - new_params ; i ++ ) {
#     define XfOrM428_COUNT (0+XfOrM425_COUNT)
#     define SETUP_XfOrM428(x) SETUP_XfOrM425(x)

# 1901 "bc/src/resolve.c"
      if (cl -> vars [i ] -> mutated ) {
        int j = i + closure_size + new_params ; 
        Scheme_Object * bcode ; 
        BLOCK_SETUP((PUSH(bcode, 0+XfOrM428_COUNT)));
#       define XfOrM429_COUNT (1+XfOrM428_COUNT)
#       define SETUP_XfOrM429(x) SETUP(XfOrM429_COUNT)
        bcode = NULLED_OUT ; 

# 1905 "bc/src/resolve.c"
        bcode = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM429(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        bcode -> type = scheme_boxenv_type ; 
        (((Scheme_Simple_Object * ) (bcode ) ) -> u . two_ptr_val . ptr1 ) = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (j ) ) ) << 1 ) | 0x1 ) ) ; 
        (((Scheme_Simple_Object * ) (bcode ) ) -> u . two_ptr_val . ptr2 ) = lam -> body ; 

        lam -> body = bcode ; 
      }
    }
  }

# 1913 "bc/src/resolve.c"
  else {
    new_info = ((void * ) 0 ) ; 
    closure_map = ((void * ) 0 ) ; 
  }

  if ((closure_size == 1 ) 
  && can_lift 
  && has_tl 
  && info -> lifts ) {
    need_lift = 1 ; 
  }

# 1923 "bc/src/resolve.c"
  else 
  need_lift = 0 ; 


  if (! closure_size ) {
#   define XfOrM420_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM420(x) SETUP_XfOrM405(x)

# 1928 "bc/src/resolve.c"
    if (precomputed_lift ) {
      result = (((Scheme_Simple_Object * ) (precomputed_lift ) ) -> u . pair_val . car ) ; 
      if (! just_compute_lift )
        ((Scheme_Closure * ) result ) -> code = lam ; 
    }

# 1932 "bc/src/resolve.c"
    else {
#     define XfOrM421_COUNT (0+XfOrM420_COUNT)
#     define SETUP_XfOrM421(x) SETUP_XfOrM420(x)

# 1933 "bc/src/resolve.c"
      if (just_compute_lift )
        result = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM421(_), scheme_malloc_empty_closure () ); 
      else 
      result = FUNCCALL(SETUP_XfOrM421(_), scheme_make_closure (((void * ) 0 ) , (Scheme_Object * ) lam , 0 ) ); 
    }
  }

# 1938 "bc/src/resolve.c"
  else 
  result = (Scheme_Object * ) lam ; 

  if (need_lift ) {
#   define XfOrM415_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM415(x) SETUP_XfOrM405(x)

# 1942 "bc/src/resolve.c"
    if (just_compute_lift ) {
#     define XfOrM419_COUNT (0+XfOrM415_COUNT)
#     define SETUP_XfOrM419(x) SETUP_XfOrM415(x)

# 1943 "bc/src/resolve.c"
      if (just_compute_lift > 1 )
        result = FUNCCALL(SETUP_XfOrM419(_), resolve_invent_toplevel (info ) ); 
      else 
      result = FUNCCALL(SETUP_XfOrM419(_), resolve_generate_stub_lift (info ) ); 
    }

# 1947 "bc/src/resolve.c"
    else {
      Scheme_Object * tl , * defn_tl ; 
      BLOCK_SETUP((PUSH(defn_tl, 0+XfOrM415_COUNT), PUSH(tl, 1+XfOrM415_COUNT)));
#     define XfOrM416_COUNT (2+XfOrM415_COUNT)
#     define SETUP_XfOrM416(x) SETUP(XfOrM416_COUNT)
      tl = NULLED_OUT ; 
      defn_tl = NULLED_OUT ; 

# 1949 "bc/src/resolve.c"
      if (precomputed_lift ) {
        tl = precomputed_lift ; 
        if ((Scheme_Type ) (((((intptr_t ) (tl ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (tl ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) 
          tl = (((Scheme_Simple_Object * ) (tl ) ) -> u . pair_val . car ) ; 
      }

# 1953 "bc/src/resolve.c"
      else {
#       define XfOrM417_COUNT (0+XfOrM416_COUNT)
#       define SETUP_XfOrM417(x) SETUP_XfOrM416(x)

# 1954 "bc/src/resolve.c"
        tl = FUNCCALL(SETUP_XfOrM417(_), resolve_invent_toplevel (info ) ); 
      }
      defn_tl = FUNCCALL(SETUP_XfOrM416(_), resolve_invented_toplevel_to_defn (info , tl ) ); 
      FUNCCALL(SETUP_XfOrM416(_), resolve_lift_definition (info , defn_tl , result ) ); 
      if (has_tl )
        closure_map [0 ] = 0 ; 
      result = tl ; 
      FUNCCALL(SETUP_XfOrM416(_), merge_resolve_tl_map (new_info -> top , new_info ) ); 
    }
  }

# 1963 "bc/src/resolve.c"
  else if (! just_compute_lift ) {
#   define XfOrM414_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM414(x) SETUP_XfOrM405(x)
    FUNCCALL(SETUP_XfOrM414(_), merge_resolve (info , new_info ) )
# 1964 "bc/src/resolve.c"
    ; 
  }

  if (convert ) {



    Scheme_Object * ca , * arity ; 
    BLOCK_SETUP((PUSH(arity, 0+XfOrM405_COUNT), PUSH(ca, 1+XfOrM405_COUNT)));
#   define XfOrM406_COUNT (2+XfOrM405_COUNT)
#   define SETUP_XfOrM406(x) SETUP(XfOrM406_COUNT)
    ca = NULLED_OUT ; 
    arity = NULLED_OUT ; 

# 1973 "bc/src/resolve.c"
    if ((& (lam ) -> iso ) -> so . keyex & 1 ) 
      arity = FUNCCALL(SETUP_XfOrM406(_), scheme_box (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_params - new_params - 1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
    else 
    arity = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_params - new_params ) ) ) << 1 ) | 0x1 ) ) ; 

    ca = FUNCCALL(SETUP_XfOrM406(_), scheme_make_vector (1 + captured -> count , scheme_false ) ); 
    (((Scheme_Vector * ) (ca ) ) -> els ) [0 ] = arity ; 

    for (i = 0 ; i < captured -> size ; i ++ ) {
#     define XfOrM411_COUNT (0+XfOrM406_COUNT)
#     define SETUP_XfOrM411(x) SETUP_XfOrM406(x)

# 1982 "bc/src/resolve.c"
      if (captured -> vals [i ] ) {
#       define XfOrM412_COUNT (0+XfOrM411_COUNT)
#       define SETUP_XfOrM412(x) SETUP_XfOrM411(x)

# 1983 "bc/src/resolve.c"
        ((void ) sizeof ((((Scheme_Type ) (scheme_ir_local_type ) == (Scheme_Type ) (((((intptr_t ) (captured -> keys [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (captured -> keys [i ] ) ) -> type ) ) ) ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM413_COUNT (0+XfOrM412_COUNT)
#         define SETUP_XfOrM413(x) SETUP_XfOrM412(x)

# 1983 "bc/src/resolve.c" 3
          if ((Scheme_Type ) (scheme_ir_local_type ) == (Scheme_Type ) (((((intptr_t ) (captured -> keys [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (captured -> keys [i ] ) ) -> type ) ) ) 

# 1983 "bc/src/resolve.c" 3
          ; 

# 1983 "bc/src/resolve.c" 3
          else FUNCCALL(SETUP_XfOrM413(_), __assert_fail ("((Scheme_Type)(scheme_ir_local_type) == (Scheme_Type)(((((intptr_t)(captured->keys[i])) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(captured->keys[i]))->type)))" , "bc/src/resolve.c" , 1983 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 1983 "bc/src/resolve.c"
        ; 
        (((Scheme_Vector * ) (ca ) ) -> els ) [1 + (((intptr_t ) (captured -> vals [i ] ) ) >> 1 ) ] = captured -> keys [i ] ; 
      }
    }

    if (precomputed_lift ) {
      (((Scheme_Simple_Object * ) (precomputed_lift ) ) -> u . pair_val . car ) = result ; 
      (((Scheme_Simple_Object * ) (precomputed_lift ) ) -> u . pair_val . cdr ) = (Scheme_Object * ) ca ; 
      result = precomputed_lift ; 
    }

# 1992 "bc/src/resolve.c"
    else 
    result = FUNCCALL(SETUP_XfOrM406(_), scheme_make_raw_pair (result , (Scheme_Object * ) ca ) ); 
  }

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Linklet * scheme_resolve_linklet (Scheme_Linklet * linklet , int enforce_const , int static_mode ) 
{
  Scheme_Object * lift_vec , * body = scheme_null , * new_bodies ; 
  Resolve_Info * rslv ; 
  int i , cnt , num_lifts ; 

# 69 "bc/src/resolve.c"
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Linklet * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(body, 0), PUSH(rslv, 1), PUSH(new_bodies, 2), PUSH(lift_vec, 3), PUSH(linklet, 4)));
# define XfOrM508_COUNT (5)
# define SETUP_XfOrM508(x) SETUP(XfOrM508_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  lift_vec = NULLED_OUT ; 
  new_bodies = NULLED_OUT ; 
  rslv = NULLED_OUT ; 

# 2009 "bc/src/resolve.c"
  rslv = FUNCCALL(SETUP_XfOrM508(_), resolve_info_create (linklet , enforce_const , static_mode ) ); 
  FUNCCALL_AGAIN(enable_expression_resolve_lifts (rslv ) ); 

  if (linklet -> num_exports < (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) ) {
#   define XfOrM529_COUNT (0+XfOrM508_COUNT)
#   define SETUP_XfOrM529(x) SETUP_XfOrM508(x)
    FUNCCALL(SETUP_XfOrM529(_), prepare_definition_queue (linklet , rslv ) ); 
  }

  cnt = (((Scheme_Vector * ) (linklet -> bodies ) ) -> size ) ; 
  for (i = 0 ; i < cnt ; i ++ ) {
    Scheme_Object * e ; 
    BLOCK_SETUP((PUSH(e, 0+XfOrM508_COUNT)));
#   define XfOrM526_COUNT (1+XfOrM508_COUNT)
#   define SETUP_XfOrM526(x) SETUP(XfOrM526_COUNT)
    e = NULLED_OUT ; 

# 2022 "bc/src/resolve.c"
    e = (((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] ; 

    if (! rslv -> toplevel_defns || ! FUNCCALL(SETUP_XfOrM526(_), scheme_hash_get (rslv -> toplevel_defns , e ) )) {
#     define XfOrM527_COUNT (0+XfOrM526_COUNT)
#     define SETUP_XfOrM527(x) SETUP_XfOrM526(x)

# 2025 "bc/src/resolve.c"
      e = FUNCCALL(SETUP_XfOrM527(_), resolve_expr (e , rslv ) ); 




      lift_vec = rslv -> lifts ; 
      if (! (((((Scheme_Vector * ) (lift_vec ) ) -> els ) [0 ] ) == (scheme_null ) ) ) {
#       define XfOrM528_COUNT (0+XfOrM527_COUNT)
#       define SETUP_XfOrM528(x) SETUP_XfOrM527(x)

# 2032 "bc/src/resolve.c"
        body = FUNCCALL(SETUP_XfOrM528(_), scheme_append ((((Scheme_Vector * ) (lift_vec ) ) -> els ) [0 ] , body ) ); 
        (((Scheme_Vector * ) (lift_vec ) ) -> els ) [0 ] = scheme_null ; 
      }
    }

    body = FUNCCALL(SETUP_XfOrM526(_), scheme_make_pair (e , body ) ); 
  }


  if (rslv -> toplevel_defns ) {
    Scheme_Object * l , * e ; 
    BLOCK_SETUP((PUSH(e, 0+XfOrM508_COUNT), PUSH(l, 1+XfOrM508_COUNT)));
#   define XfOrM512_COUNT (2+XfOrM508_COUNT)
#   define SETUP_XfOrM512(x) SETUP(XfOrM512_COUNT)
    l = NULLED_OUT ; 
    e = NULLED_OUT ; 

# 2045 "bc/src/resolve.c"
    while (1 ) {
#     define XfOrM521_COUNT (0+XfOrM512_COUNT)
#     define SETUP_XfOrM521(x) SETUP_XfOrM512(x)

# 2046 "bc/src/resolve.c"
      l = FUNCCALL(SETUP_XfOrM521(_), scheme_hash_get (rslv -> toplevel_defns , scheme_null ) ); 
      if ((l ) == (scheme_null ) ) 
        break ; 
      FUNCCALL(SETUP_XfOrM521(_), scheme_hash_set (rslv -> toplevel_defns , scheme_null , (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) ); 

      l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      e = (__funcarg63 = FUNCCALL(SETUP_XfOrM521(_), resolve_expr (l , rslv ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg63 , scheme_null ) )) ; 
      lift_vec = rslv -> lifts ; 
      if (! (((((Scheme_Vector * ) (lift_vec ) ) -> els ) [0 ] ) == (scheme_null ) ) ) {
#       define XfOrM522_COUNT (0+XfOrM521_COUNT)
#       define SETUP_XfOrM522(x) SETUP_XfOrM521(x)

# 2055 "bc/src/resolve.c"
        e = FUNCCALL(SETUP_XfOrM522(_), scheme_append ((((Scheme_Vector * ) (lift_vec ) ) -> els ) [0 ] , e ) ); 
        (((Scheme_Vector * ) (lift_vec ) ) -> els ) [0 ] = scheme_null ; 
      }
      FUNCCALL(SETUP_XfOrM521(_), scheme_hash_set (rslv -> toplevel_defns , l , e ) ); 
    }


    for (l = body , body = scheme_null ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM516_COUNT (0+XfOrM512_COUNT)
#     define SETUP_XfOrM516(x) SETUP_XfOrM512(x)

# 2063 "bc/src/resolve.c"
      e = FUNCCALL(SETUP_XfOrM516(_), scheme_hash_get (rslv -> toplevel_defns , (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ); 
      if (e ) {
#       define XfOrM517_COUNT (0+XfOrM516_COUNT)
#       define SETUP_XfOrM517(x) SETUP_XfOrM516(x)

# 2065 "bc/src/resolve.c"
        if ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
          body = FUNCCALL(SETUP_XfOrM517(_), scheme_append (e , body ) ); 
        else {
#         define XfOrM518_COUNT (0+XfOrM517_COUNT)
#         define SETUP_XfOrM518(x) SETUP_XfOrM517(x)
          FUNCCALL(SETUP_XfOrM518(_), remove_definition_names ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , linklet ) )
# 2069 "bc/src/resolve.c"
          ; 
        }
      }

# 2071 "bc/src/resolve.c"
      else 
      body = FUNCCALL(SETUP_XfOrM516(_), scheme_make_pair ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , body ) ); 
    }
  }

# 2074 "bc/src/resolve.c"
  else 
  body = FUNCCALL(SETUP_XfOrM508(_), scheme_reverse (body ) ); 

  linklet -> max_let_depth = rslv -> max_let_depth ; 
  linklet -> need_instance_access = rslv -> need_instance_access ; 

  lift_vec = rslv -> lifts ; 
  num_lifts = (((intptr_t ) ((((Scheme_Vector * ) (lift_vec ) ) -> els ) [1 ] ) ) >> 1 ) ; 


  cnt = (scheme_list_length (body ) ) ; 
  new_bodies = FUNCCALL(SETUP_XfOrM508(_), scheme_make_vector (cnt , scheme_false ) ); 
  for (i = 0 ; i < cnt ; i ++ , body = (((Scheme_Simple_Object * ) (body ) ) -> u . pair_val . cdr ) ) {
    (((Scheme_Vector * ) (new_bodies ) ) -> els ) [i ] = (((Scheme_Simple_Object * ) (body ) ) -> u . pair_val . car ) ; 
  }

  linklet -> bodies = new_bodies ; 

  if (num_lifts ) {
#   define XfOrM509_COUNT (0+XfOrM508_COUNT)
#   define SETUP_XfOrM509(x) SETUP_XfOrM508(x)
    FUNCCALL(SETUP_XfOrM509(_), extend_linklet_defns (linklet , num_lifts ) ); 
  }
  FUNCCALL(SETUP_XfOrM508(_), prune_unused_imports (linklet ) )


  ; 

  if (static_mode )
    FUNCCALL(SETUP_XfOrM508(_), install_static_prefix (linklet , rslv ) ); 

  RET_VALUE_START (linklet ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2108 "bc/src/resolve.c"
static void prepare_definition_queue (Scheme_Linklet * linklet , Resolve_Info * rslv ) 
{
  Scheme_Hash_Table * ht ; 
  Scheme_Object * e , * var ; 
  int i , j , cnt , vcnt ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(var, 1), PUSH(rslv, 2), PUSH(ht, 3), PUSH(linklet, 4)));
# define XfOrM530_COUNT (5)
# define SETUP_XfOrM530(x) SETUP(XfOrM530_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 
  e = NULLED_OUT ; 
  var = NULLED_OUT ; 

# 2114 "bc/src/resolve.c"
  ht = FUNCCALL(SETUP_XfOrM530(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  rslv -> toplevel_defns = ht ; 
  FUNCCALL(SETUP_XfOrM530(_), scheme_hash_set (rslv -> toplevel_defns , scheme_null , scheme_null ) )

  ; 

  cnt = (((Scheme_Vector * ) (linklet -> bodies ) ) -> size ) ; 

  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM543_COUNT (0+XfOrM530_COUNT)
#   define SETUP_XfOrM543(x) SETUP_XfOrM530(x)

# 2123 "bc/src/resolve.c"
    e = (((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] ; 

    if ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_define_values_type ) )  {
#     define XfOrM544_COUNT (0+XfOrM543_COUNT)
#     define SETUP_XfOrM544(x) SETUP_XfOrM543(x)

# 2126 "bc/src/resolve.c"
      vcnt = ((((Scheme_Vector * ) (e ) ) -> size ) - 1 ) ; 
      if ((((Scheme_Inclhash_Object * ) (e ) ) -> so . keyex & 0x2 ) 
      || FUNCCALL(SETUP_XfOrM544(_), scheme_omittable_expr (((((Scheme_Vector * ) (e ) ) -> els ) [0 ] ) , vcnt , 5 , 0 , ((void * ) 0 ) , ((void * ) 0 ) ) )) {
#       define XfOrM545_COUNT (0+XfOrM544_COUNT)
#       define SETUP_XfOrM545(x) SETUP_XfOrM544(x)

# 2129 "bc/src/resolve.c"
        for (j = 0 ; j < vcnt ; j ++ ) {
#         define XfOrM552_COUNT (0+XfOrM545_COUNT)
#         define SETUP_XfOrM552(x) SETUP_XfOrM545(x)

# 2130 "bc/src/resolve.c"
          var = ((((Scheme_Vector * ) (e ) ) -> els ) [(j ) + 1 ] ) ; 
          ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) ) ? 1 : 0 ) , __extension__ ({
#           define XfOrM554_COUNT (0+XfOrM552_COUNT)
#           define SETUP_XfOrM554(x) SETUP_XfOrM552(x)

# 2131 "bc/src/resolve.c" 3
            if ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) 

# 2131 "bc/src/resolve.c" 3
            ; 

# 2131 "bc/src/resolve.c" 3
            else FUNCCALL(SETUP_XfOrM554(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(var)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(var))->type)) == (Scheme_Type)(scheme_ir_toplevel_type))" , "bc/src/resolve.c" , 2131 , __extension__ __PRETTY_FUNCTION__ ) ); 
          }
          ) ) 
# 2131 "bc/src/resolve.c"
          ; 
          if ((((Scheme_IR_Toplevel * ) var ) -> variable_pos ) < (1 
          + linklet -> num_total_imports 
          + linklet -> num_exports ) ) {

            break ; 
          }
        }
        if (j >= vcnt ) {
#         define XfOrM546_COUNT (0+XfOrM545_COUNT)
#         define SETUP_XfOrM546(x) SETUP_XfOrM545(x)
          FUNCCALL(SETUP_XfOrM546(_), scheme_hash_set (rslv -> toplevel_defns , e , scheme_true ) )
# 2140 "bc/src/resolve.c"
          ; 
          for (j = 0 ; j < vcnt ; j ++ ) {
            int tl_pos ; 
#           define XfOrM548_COUNT (0+XfOrM546_COUNT)
#           define SETUP_XfOrM548(x) SETUP_XfOrM546(x)

# 2143 "bc/src/resolve.c"
            var = ((((Scheme_Vector * ) (e ) ) -> els ) [(j ) + 1 ] ) ; 
            tl_pos = (((Scheme_IR_Toplevel * ) var ) -> variable_pos ) + 1 + linklet -> num_total_imports ; 
            FUNCCALL(SETUP_XfOrM548(_), scheme_hash_set (rslv -> toplevel_defns , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (tl_pos ) ) ) << 1 ) | 0x1 ) ) , e ) ); 
          }
        }
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2153 "bc/src/resolve.c"
static void remove_definition_names (Scheme_Object * defn , Scheme_Linklet * linklet ) 
{
  int i , cnt ; 
  Scheme_Object * var , * name ; 
  Scheme_Hash_Tree * source_names ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(var, 1), PUSH(source_names, 2), PUSH(defn, 3), PUSH(linklet, 4)));
# define XfOrM555_COUNT (5)
# define SETUP_XfOrM555(x) SETUP(XfOrM555_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  var = NULLED_OUT ; 
  name = NULLED_OUT ; 
  source_names = NULLED_OUT ; 

# 2159 "bc/src/resolve.c"
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (defn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (defn ) ) -> type ) ) == (Scheme_Type ) (scheme_define_values_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM562_COUNT (0+XfOrM555_COUNT)
#   define SETUP_XfOrM562(x) SETUP_XfOrM555(x)

# 2159 "bc/src/resolve.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (defn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (defn ) ) -> type ) ) == (Scheme_Type ) (scheme_define_values_type ) ) 

# 2159 "bc/src/resolve.c" 3
    ; 

# 2159 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM562(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(defn)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(defn))->type)) == (Scheme_Type)(scheme_define_values_type))" , "bc/src/resolve.c" , 2159 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 2159 "bc/src/resolve.c"
  ; 

  cnt = ((((Scheme_Vector * ) (defn ) ) -> size ) - 1 ) ; 
  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM559_COUNT (0+XfOrM555_COUNT)
#   define SETUP_XfOrM559(x) SETUP_XfOrM555(x)

# 2163 "bc/src/resolve.c"
    var = ((((Scheme_Vector * ) (defn ) ) -> els ) [(i ) + 1 ] ) ; 
    ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM561_COUNT (0+XfOrM559_COUNT)
#     define SETUP_XfOrM561(x) SETUP_XfOrM559(x)

# 2164 "bc/src/resolve.c" 3
      if ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) 

# 2164 "bc/src/resolve.c" 3
      ; 

# 2164 "bc/src/resolve.c" 3
      else FUNCCALL(SETUP_XfOrM561(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(var)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(var))->type)) == (Scheme_Type)(scheme_ir_toplevel_type))" , "bc/src/resolve.c" , 2164 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 2164 "bc/src/resolve.c"
    ; 

    name = (((Scheme_Vector * ) (linklet -> defns ) ) -> els ) [(((Scheme_IR_Toplevel * ) var ) -> variable_pos ) ] ; 

    if (linklet -> source_names ) {
#     define XfOrM560_COUNT (0+XfOrM559_COUNT)
#     define SETUP_XfOrM560(x) SETUP_XfOrM559(x)

# 2169 "bc/src/resolve.c"
      source_names = FUNCCALL(SETUP_XfOrM560(_), scheme_hash_tree_set (linklet -> source_names , name , ((void * ) 0 ) ) ); 
      linklet -> source_names = source_names ; 
    }

    (((Scheme_Vector * ) (linklet -> defns ) ) -> els ) [(((Scheme_IR_Toplevel * ) var ) -> variable_pos ) ] = scheme_false ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2177 "bc/src/resolve.c"
static void extend_linklet_defns (Scheme_Linklet * linklet , int num_lifts ) 
{
  int cnt , i ; 
  Scheme_Object * new_defns , * b ; 
  Scheme_Hash_Table * names ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(new_defns, 0), PUSH(b, 1), PUSH(linklet, 2), PUSH(names, 3)));
# define XfOrM563_COUNT (4)
# define SETUP_XfOrM563(x) SETUP(XfOrM563_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  new_defns = NULLED_OUT ; 
  b = NULLED_OUT ; 
  names = NULLED_OUT ; 

# 2183 "bc/src/resolve.c"
  linklet -> num_lifts = num_lifts ; 
  cnt = (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) + num_lifts ; 
  new_defns = FUNCCALL(SETUP_XfOrM563(_), scheme_make_vector (cnt , scheme_false ) ); 
  names = FUNCCALL_AGAIN(scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  for (i = 0 ; i < (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) ; i ++ ) {
#   define XfOrM567_COUNT (0+XfOrM563_COUNT)
#   define SETUP_XfOrM567(x) SETUP_XfOrM563(x)

# 2189 "bc/src/resolve.c"
    (((Scheme_Vector * ) (new_defns ) ) -> els ) [i ] = (((Scheme_Vector * ) (linklet -> defns ) ) -> els ) [i ] ; 
    FUNCCALL(SETUP_XfOrM567(_), scheme_hash_set (names , (((Scheme_Vector * ) (new_defns ) ) -> els ) [i ] , scheme_true ) ); 
  }

  for (; i < cnt ; i ++ ) {
#   define XfOrM565_COUNT (0+XfOrM563_COUNT)
#   define SETUP_XfOrM565(x) SETUP_XfOrM563(x)

# 2194 "bc/src/resolve.c"
    b = FUNCCALL(SETUP_XfOrM565(_), generate_lifted_name (names , i - (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) ) ); 
    (((Scheme_Vector * ) (new_defns ) ) -> els ) [i ] = b ; 
  }

  linklet -> defns = new_defns ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2201 "bc/src/resolve.c"
static void prune_unused_imports (Scheme_Linklet * linklet ) 
{
  int i , new_i = 0 , j ; 
  int num_total_imports ; 
  Scheme_Object * vec , * new_vec , * new_importss ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(new_importss, 0), PUSH(vec, 1), PUSH(linklet, 2), PUSH(new_vec, 3)));
# define XfOrM568_COUNT (4)
# define SETUP_XfOrM568(x) SETUP(XfOrM568_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 
  new_vec = NULLED_OUT ; 
  new_importss = NULLED_OUT ; 

# 2207 "bc/src/resolve.c"
  for (i = (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ; i -- ; ) {
    if (! (((intptr_t ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ) ) & 0x1 ) )
      new_i ++ ; 
  }
  if (new_i != (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ) {
#   define XfOrM596_COUNT (0+XfOrM568_COUNT)
#   define SETUP_XfOrM596(x) SETUP_XfOrM568(x)

# 2212 "bc/src/resolve.c"
    new_importss = FUNCCALL(SETUP_XfOrM596(_), scheme_make_vector (new_i , ((void * ) 0 ) ) ); 
    new_i = 0 ; 
  }

# 2214 "bc/src/resolve.c"
  else 
  new_importss = ((void * ) 0 ) ; 

  num_total_imports = 0 ; 
  for (i = 0 ; i < (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ; i ++ ) {
    int drop = 0 , len , drop_all = 0 ; 
#   define XfOrM584_COUNT (0+XfOrM568_COUNT)
#   define SETUP_XfOrM584(x) SETUP_XfOrM568(x)

# 2220 "bc/src/resolve.c"
    vec = (((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ; 
    if (((intptr_t ) (vec ) ) & 0x1 )  {
      len = (((intptr_t ) (vec ) ) >> 1 ) ; 
      num_total_imports += len ; 
      drop = len ; 
      drop_all = 1 ; 
    }

# 2226 "bc/src/resolve.c"
    else {
      len = (((Scheme_Vector * ) (vec ) ) -> size ) ; 
      num_total_imports += len ; 
      for (j = 0 ; j < len ; j ++ ) {
        if ((((((Scheme_Vector * ) (vec ) ) -> els ) [j ] ) ) == (scheme_false ) ) 
          drop ++ ; 
      }
    }
    if (drop ) {
#     define XfOrM585_COUNT (0+XfOrM584_COUNT)
#     define SETUP_XfOrM585(x) SETUP_XfOrM584(x)

# 2235 "bc/src/resolve.c"
      num_total_imports -= drop ; 
      drop = len - drop ; 
      if (! drop_all ) {
#       define XfOrM586_COUNT (0+XfOrM585_COUNT)
#       define SETUP_XfOrM586(x) SETUP_XfOrM585(x)

# 2238 "bc/src/resolve.c"
        new_vec = FUNCCALL(SETUP_XfOrM586(_), scheme_make_vector (drop , ((void * ) 0 ) ) ); 
        for (j = len ; j -- ; ) {
          if (! ((((((Scheme_Vector * ) (vec ) ) -> els ) [j ] ) ) == (scheme_false ) ) ) {
            (((Scheme_Vector * ) (new_vec ) ) -> els ) [-- drop ] = (((Scheme_Vector * ) (vec ) ) -> els ) [j ] ; 
          }
        }
        ((void ) sizeof ((! drop ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM587_COUNT (0+XfOrM586_COUNT)
#         define SETUP_XfOrM587(x) SETUP_XfOrM586(x)

# 2244 "bc/src/resolve.c" 3
          if (! drop )

# 2244 "bc/src/resolve.c" 3
          ; 

# 2244 "bc/src/resolve.c" 3
          else FUNCCALL(SETUP_XfOrM587(_), __assert_fail ("!drop" , "bc/src/resolve.c" , 2244 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 2244 "bc/src/resolve.c"
        ; 
        (((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] = new_vec ; 
      }
    }
    if (! drop_all && new_importss )
      (((Scheme_Vector * ) (new_importss ) ) -> els ) [new_i ++ ] = (((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ; 
  }

  if (new_importss ) {
#   define XfOrM570_COUNT (0+XfOrM568_COUNT)
#   define SETUP_XfOrM570(x) SETUP_XfOrM568(x)

# 2253 "bc/src/resolve.c"
    ((void ) sizeof ((new_i == (((Scheme_Vector * ) (new_importss ) ) -> size ) ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM571_COUNT (0+XfOrM570_COUNT)
#     define SETUP_XfOrM571(x) SETUP_XfOrM570(x)

# 2253 "bc/src/resolve.c" 3
      if (new_i == (((Scheme_Vector * ) (new_importss ) ) -> size ) )

# 2253 "bc/src/resolve.c" 3
      ; 

# 2253 "bc/src/resolve.c" 3
      else FUNCCALL(SETUP_XfOrM571(_), __assert_fail ("new_i == (((Scheme_Vector *)(new_importss))->size)" , "bc/src/resolve.c" , 2253 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 2253 "bc/src/resolve.c"
    ; 
    linklet -> importss = new_importss ; 
  }

  linklet -> num_total_imports = num_total_imports ; 

  ((void ) sizeof ((! linklet -> import_shapes || (linklet -> num_total_imports == (((Scheme_Vector * ) (linklet -> import_shapes ) ) -> size ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM569_COUNT (0+XfOrM568_COUNT)
#   define SETUP_XfOrM569(x) SETUP_XfOrM568(x)

# 2259 "bc/src/resolve.c" 3
    if (! linklet -> import_shapes || (linklet -> num_total_imports == (((Scheme_Vector * ) (linklet -> import_shapes ) ) -> size ) ) )

# 2259 "bc/src/resolve.c" 3
    ; 

# 2259 "bc/src/resolve.c" 3
    else FUNCCALL_EMPTY(__assert_fail ("!linklet->import_shapes || (linklet->num_total_imports == (((Scheme_Vector *)(linklet->import_shapes))->size))" , "bc/src/resolve.c" , 2259 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 2259 "bc/src/resolve.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2262 "bc/src/resolve.c"
static Scheme_Object * generate_lifted_name (Scheme_Hash_Table * used_names , int search_start ) 
{
  char buf [32 ] ; 
  Scheme_Object * n ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(n, 0), PUSH(used_names, 1)));
# define XfOrM599_COUNT (2)
# define SETUP_XfOrM599(x) SETUP(XfOrM599_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  n = NULLED_OUT ; 

# 2267 "bc/src/resolve.c"
  while (1 ) {
#   define XfOrM602_COUNT (0+XfOrM599_COUNT)
#   define SETUP_XfOrM602(x) SETUP_XfOrM599(x)
    (
# 2268 "bc/src/resolve.c"
    sprintf (buf , "?lifted.%d" , search_start ) ) ; 
    n = FUNCCALL(SETUP_XfOrM602(_), scheme_intern_exact_parallel_symbol (buf , strlen (buf ) ) ); 
    if (! FUNCCALL(SETUP_XfOrM602(_), scheme_hash_get (used_names , n ) )) {
#     define XfOrM603_COUNT (0+XfOrM602_COUNT)
#     define SETUP_XfOrM603(x) SETUP_XfOrM602(x)
      FUNCCALL(SETUP_XfOrM603(_), scheme_hash_set (used_names , n , scheme_true ) )
# 2271 "bc/src/resolve.c"
      ; 
      RET_VALUE_START (n ) RET_VALUE_END ; 
    }
    search_start ++ ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * resolve_k (void ) 
{
  /* No conversion */

# 2284 "bc/src/resolve.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * expr = (Scheme_Object * ) p -> ku . k . p1 ; 
  Resolve_Info * info = (Resolve_Info * ) p -> ku . k . p2 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 

  return resolve_expr (expr , info ) ; 
}

Scheme_Object * resolve_expr (Scheme_Object * expr , Resolve_Info * info ) 
{
  Scheme_Type type = ((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ; 

# 24 "bc/src/mzstkchk.h"
  uintptr_t _stk_pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(expr, 1)));
# define XfOrM605_COUNT (2)
# define SETUP_XfOrM605(x) SETUP(XfOrM605_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 26 "bc/src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 2300 "bc/src/resolve.c"
  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM610_COUNT (0+XfOrM605_COUNT)
#   define SETUP_XfOrM610(x) SETUP_XfOrM605(x)

# 2303 "bc/src/resolve.c"
    p -> ku . k . p1 = (void * ) expr ; 
    p -> ku . k . p2 = (void * ) info ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (resolve_k ) )) RET_VALUE_EMPTY_END ; 
  }


  switch (type ) {
#   define XfOrM606_COUNT (0+XfOrM605_COUNT)
#   define SETUP_XfOrM606(x) SETUP_XfOrM605(x)

# 2311 "bc/src/resolve.c"
    case scheme_ir_local_type : 
    {
      int pos ; 
      Scheme_IR_Local * var = ((Scheme_IR_Local * ) expr ) ; 
      Scheme_Object * lifted ; 
      BLOCK_SETUP((PUSH(var, 0+XfOrM606_COUNT), PUSH(lifted, 1+XfOrM606_COUNT)));
#     define XfOrM607_COUNT (2+XfOrM606_COUNT)
#     define SETUP_XfOrM607(x) SETUP(XfOrM607_COUNT)
      lifted = NULLED_OUT ; 

# 2317 "bc/src/resolve.c"
      pos = FUNCCALL(SETUP_XfOrM607(_), resolve_info_lookup (info , var , & lifted , 0 , 0 ) ); 
      if (lifted ) {
#       define XfOrM609_COUNT (0+XfOrM607_COUNT)
#       define SETUP_XfOrM609(x) SETUP_XfOrM607(x)

# 2320 "bc/src/resolve.c"
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM609(_), shift_lifted_reference (lifted , info , 0 ) )) RET_VALUE_END ; 
      }

# 2321 "bc/src/resolve.c"
      else {
#       define XfOrM608_COUNT (0+XfOrM607_COUNT)
#       define SETUP_XfOrM608(x) SETUP_XfOrM607(x)

# 2322 "bc/src/resolve.c"
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM608(_), scheme_make_local (var -> mutated ? scheme_local_unbox_type : scheme_local_type , pos , (((var ) -> val_type && (! (var ) -> escapes_after_k_tick || (((var ) -> val_type ) == 2 ) ) ) ? (2 + var -> val_type ) : 0 ) ) )) RET_VALUE_END 





        ; 
      }
    }
    case scheme_application_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(resolve_application (expr , info , 0 ) )) RET_VALUE_EMPTY_END ; 
    case scheme_application2_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(resolve_application2 (expr , info , 0 ) )) RET_VALUE_EMPTY_END ; 
    case scheme_application3_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(resolve_application3 (expr , info , 0 ) )) RET_VALUE_EMPTY_END ; 
    case scheme_sequence_type : 
    case scheme_begin0_sequence_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(resolve_sequence (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_branch_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(resolve_branch (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_with_cont_mark_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(resolve_wcm (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_ir_lambda_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(resolve_lambda (expr , info , ! info -> no_lift , 0 , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
    case scheme_ir_let_header_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_resolve_lets (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_ir_toplevel_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(resolve_toplevel (info , expr , 1 ) )) RET_VALUE_EMPTY_END ; 
    case scheme_variable_type : FUNCCALL_EMPTY(scheme_signal_error ("got top-level in wrong place" ) )
    ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
    case scheme_define_values_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(define_values_resolve (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_inline_variant_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(inline_variant_resolve (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_set_bang_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(set_resolve (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_varref_form_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(ref_resolve (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_apply_values_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(apply_values_resolve (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_with_immed_mark_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(with_immed_mark_resolve (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_case_lambda_sequence_type : 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(case_lambda_resolve (expr , info ) )) RET_VALUE_EMPTY_END ; 
    case scheme_boxenv_type : FUNCCALL_EMPTY(scheme_signal_error ("internal error: no boxenv resolve" ) )
    ; 
    default : 
    RET_VALUE_START (expr ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2374 "bc/src/resolve.c"
static Scheme_Object * resolve_info_lift_added (Resolve_Info * resolve , Scheme_Object * v , int convert_shift ) 
{


  Scheme_IR_Local * var ; 
  int pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(var, 0)));
# define XfOrM611_COUNT (1)
# define SETUP_XfOrM611(x) SETUP(XfOrM611_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  var = NULLED_OUT ; 

# 2381 "bc/src/resolve.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_local_type ) ) ) {

    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

  var = ((Scheme_IR_Local * ) v ) ; 

  pos = FUNCCALL(SETUP_XfOrM611(_), resolve_info_lookup (resolve , var , ((void * ) 0 ) , convert_shift , 0x2 ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_local (scheme_local_type , pos , ((! var -> mutated && ((var ) -> val_type && (! (var ) -> escapes_after_k_tick || (((var ) -> val_type ) == 2 ) ) ) ) ? (2 + var -> val_type ) : 0 ) ) )) RET_VALUE_EMPTY_END 



  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2397 "bc/src/resolve.c"
static Scheme_Object * shift_lifted_reference (Scheme_Object * tl , Resolve_Info * info , int delta ) 
{
  int pos = (((Scheme_Toplevel * ) (tl ) ) -> position ) ; 
  int depth ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(tl, 1)));
# define XfOrM613_COUNT (2)
# define SETUP_XfOrM613(x) SETUP(XfOrM613_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2402 "bc/src/resolve.c"
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (tl ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (tl ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM614_COUNT (0+XfOrM613_COUNT)
#   define SETUP_XfOrM614(x) SETUP_XfOrM613(x)

# 2402 "bc/src/resolve.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (tl ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (tl ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 

# 2402 "bc/src/resolve.c" 3
    ; 

# 2402 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM614(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(tl)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(tl))->type)) == (Scheme_Type)(scheme_toplevel_type))" , "bc/src/resolve.c" , 2402 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 2402 "bc/src/resolve.c"
  ; 

  depth = FUNCCALL(SETUP_XfOrM613(_), resolve_toplevel_pos (info ) ); 
  tl = FUNCCALL_AGAIN(scheme_make_toplevel (depth + delta , pos , 3 ) )

  ; 


  if (pos >= info -> num_toplevels )
    FUNCCALL(SETUP_XfOrM613(_), set_tl_pos_used (info , pos ) ); 

  RET_VALUE_START (tl ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Resolve_Info * resolve_info_create (Scheme_Linklet * linklet , int enforce_const , int static_mode ) 
{
  Resolve_Info * naya ; 
  int * toplevel_starts , pos , dpos , i , j ; 
  int * toplevel_deltas ; 
  DECL_RET_SAVE (Resolve_Info * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(toplevel_starts, 0), PUSH(toplevel_deltas, 1), PUSH(naya, 2), PUSH(linklet, 3)));
# define XfOrM615_COUNT (4)
# define SETUP_XfOrM615(x) SETUP(XfOrM615_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  naya = NULLED_OUT ; 
  toplevel_starts = NULLED_OUT ; 
  toplevel_deltas = NULLED_OUT ; 

# 2426 "bc/src/resolve.c"
  naya = ((Resolve_Info * ) FUNCCALL(SETUP_XfOrM615(_), GC_malloc_one_small_tagged ((((sizeof (Resolve_Info ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  naya -> type = scheme_rt_resolve_info ; 

  naya -> current_depth = 1 ; 
  naya -> max_let_depth = naya -> current_depth ; 
  naya -> current_lex_depth = 0 ; 
  naya -> next = ((void * ) 0 ) ; 
  naya -> enforce_const = enforce_const ; 
  naya -> linklet = linklet ; 

  if (static_mode ) {
    Scheme_Hash_Table * ht ; 
    BLOCK_SETUP((PUSH(ht, 0+XfOrM615_COUNT)));
#   define XfOrM626_COUNT (1+XfOrM615_COUNT)
#   define SETUP_XfOrM626(x) SETUP(XfOrM626_COUNT)
    ht = NULLED_OUT ; 

# 2439 "bc/src/resolve.c"
    ht = FUNCCALL(SETUP_XfOrM626(_), scheme_make_hash_table_equal () ); 
    naya -> static_mode = ht ; 
  }

  toplevel_starts = ((int * ) FUNCCALL(SETUP_XfOrM615(_), GC_malloc_atomic (sizeof (int ) * ((((Scheme_Vector * ) (linklet -> importss ) ) -> size ) + 1 ) ) )) ; 
  toplevel_deltas = ((int * ) FUNCCALL(SETUP_XfOrM615(_), GC_malloc_atomic (sizeof (int ) * ((linklet -> num_total_imports + 1 ) ) ) )) ; 
  pos = 1 ; 
  dpos = pos ; 
  for (i = 0 ; i < (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ; i ++ ) {
    toplevel_starts [i + 1 ] = pos ; 
    if (((intptr_t ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ) ) & 0x1 )  {

      pos += (((intptr_t ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ) ) >> 1 ) ; 
    }

# 2452 "bc/src/resolve.c"
    else {
      for (j = 0 ; j < (((Scheme_Vector * ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ) ) -> size ) ; j ++ ) {
        toplevel_deltas [pos ] = (dpos - pos ) ; 
        if ((((((Scheme_Vector * ) ((((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [i ] ) ) -> els ) [j ] ) ) == (scheme_false ) ) 
          toplevel_deltas [pos ] = 0xFFFFFF ; 
        else 
        dpos ++ ; 
        pos ++ ; 
      }
    }
  }
  toplevel_starts [0 ] = dpos ; 

  naya -> num_toplevels = (dpos + (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) ) ; 

  naya -> toplevel_starts = toplevel_starts ; 
  naya -> toplevel_deltas = toplevel_deltas ; 

  naya -> top = naya ; 

  RET_VALUE_START (naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2475 "bc/src/resolve.c"
static void enable_expression_resolve_lifts (Resolve_Info * ri ) 
{
  Scheme_Object * lift_vec ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ri, 0), PUSH(lift_vec, 1)));
# define XfOrM627_COUNT (2)
# define SETUP_XfOrM627(x) SETUP(XfOrM627_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lift_vec = NULLED_OUT ; 

# 2479 "bc/src/resolve.c"
  lift_vec = FUNCCALL(SETUP_XfOrM627(_), scheme_make_vector (2 , ((void * ) 0 ) ) ); 
  (((Scheme_Vector * ) (lift_vec ) ) -> els ) [0 ] = scheme_null ; 
  (((Scheme_Vector * ) (lift_vec ) ) -> els ) [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  ri -> lifts = lift_vec ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2485 "bc/src/resolve.c"
static Resolve_Info * resolve_info_extend (Resolve_Info * info , int size , int lambda ) 

{
  Resolve_Info * naya ; 
  DECL_RET_SAVE (Resolve_Info * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(naya, 1)));
# define XfOrM628_COUNT (2)
# define SETUP_XfOrM628(x) SETUP(XfOrM628_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 2490 "bc/src/resolve.c"
  naya = ((Resolve_Info * ) FUNCCALL(SETUP_XfOrM628(_), GC_malloc_one_small_tagged ((((sizeof (Resolve_Info ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  naya -> type = scheme_rt_resolve_info ; 

  naya -> linklet = info -> linklet ; 
  naya -> next = (lambda ? ((void * ) 0 ) : info ) ; 
  naya -> enforce_const = info -> enforce_const ; 
  naya -> static_mode = info -> static_mode ; 
  naya -> current_depth = (lambda ? 0 : info -> current_depth ) + size ; 
  naya -> current_lex_depth = info -> current_lex_depth + size ; 
  naya -> toplevel_pos = (lambda 
  ? 0 
  : ((info -> toplevel_pos < 0 ) 
  ? - 1 
  : (info -> toplevel_pos + size ) ) ) ; 
  naya -> no_lift = info -> no_lift ; 
  naya -> redirects = info -> redirects ; 
  naya -> max_let_depth = naya -> current_depth ; 
  naya -> in_proc = lambda || info -> in_proc ; 
  naya -> lifts = info -> lifts ; 
  naya -> num_toplevels = info -> num_toplevels ; 
  naya -> toplevel_starts = info -> toplevel_starts ; 
  naya -> toplevel_deltas = info -> toplevel_deltas ; 
  naya -> top = info -> top ; 
  naya -> toplevel_defns = info -> toplevel_defns ; 

  RET_VALUE_START (naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2519 "bc/src/resolve.c"
static void * ensure_tl_map_len (void * old_tl_map , int new_len ) 
{
  int current_len ; 
  void * tl_map ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(old_tl_map, 0), PUSH(tl_map, 1)));
# define XfOrM629_COUNT (2)
# define SETUP_XfOrM629(x) SETUP(XfOrM629_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  tl_map = NULLED_OUT ; 

# 2524 "bc/src/resolve.c"
  if (! old_tl_map )
    current_len = 0 ; 
  else if ((uintptr_t ) old_tl_map & 0x1 )
    current_len = 31 ; 
  else 
  current_len = (* (int * ) old_tl_map ) * 32 ; 

  if (new_len > current_len ) {
#   define XfOrM630_COUNT (0+XfOrM629_COUNT)
#   define SETUP_XfOrM630(x) SETUP_XfOrM629(x)

# 2533 "bc/src/resolve.c"
    if (new_len <= 31 )
      tl_map = (void * ) 0x1 ; 
    else {
      int len = ((new_len + 31 ) / 32 ) ; 
#     define XfOrM634_COUNT (0+XfOrM630_COUNT)
#     define SETUP_XfOrM634(x) SETUP_XfOrM630(x)

# 2537 "bc/src/resolve.c"
      tl_map = FUNCCALL(SETUP_XfOrM634(_), GC_malloc_atomic ((len + 1 ) * sizeof (int ) ) ); 
      (memset (tl_map , 0 , (len + 1 ) * sizeof (int ) ) ) ; 
      * (int * ) tl_map = len ; 
    }

    if (old_tl_map ) {
#     define XfOrM631_COUNT (0+XfOrM630_COUNT)
#     define SETUP_XfOrM631(x) SETUP_XfOrM630(x)

# 2543 "bc/src/resolve.c"
      if ((uintptr_t ) old_tl_map & 0x1 ) {
        ((int * ) tl_map ) [1 ] = ((uintptr_t ) old_tl_map >> 1 ) & 0x7FFFFFFF ; 
      }

# 2545 "bc/src/resolve.c"
      else {
#       define XfOrM632_COUNT (0+XfOrM631_COUNT)
#       define SETUP_XfOrM632(x) SETUP_XfOrM631(x)
        (
# 2546 "bc/src/resolve.c"
        memcpy ((int * ) tl_map + 1 , 
        (int * ) old_tl_map + 1 , 
        sizeof (int ) * (current_len / 32 ) ) ) ; 
      }
    }

    RET_VALUE_START (tl_map ) RET_VALUE_END ; 
  }

# 2553 "bc/src/resolve.c"
  else 
  RET_VALUE_START (old_tl_map ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2557 "bc/src/resolve.c"
static void set_tl_pos_used (Resolve_Info * info , int tl_pos ) 
{
  void * tl_map ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(tl_map, 1)));
# define XfOrM635_COUNT (2)
# define SETUP_XfOrM635(x) SETUP(XfOrM635_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  tl_map = NULLED_OUT ; 

# 2561 "bc/src/resolve.c"
  if (! info -> static_mode ) {
#   define XfOrM639_COUNT (0+XfOrM635_COUNT)
#   define SETUP_XfOrM639(x) SETUP_XfOrM635(x)




    tl_map = FUNCCALL(SETUP_XfOrM639(_), ensure_tl_map_len (info -> tl_map , tl_pos + 1 ) ); 
    info -> tl_map = tl_map ; 

    if ((uintptr_t ) info -> tl_map & 0x1 )
      info -> tl_map = (void * ) ((uintptr_t ) tl_map | ((uintptr_t ) 1 << (tl_pos + 1 ) ) ) ; 
    else 
    ((int * ) tl_map ) [1 + (tl_pos / 32 ) ] |= ((unsigned ) 1 << (tl_pos & 31 ) ) ; 
  }


  if (info -> toplevel_defns 
  && (tl_pos >= (1 
  + info -> linklet -> num_total_imports 
  + info -> linklet -> num_exports ) ) ) {
    Scheme_Object * defn ; 
    BLOCK_SETUP((PUSH(defn, 0+XfOrM635_COUNT)));
#   define XfOrM636_COUNT (1+XfOrM635_COUNT)
#   define SETUP_XfOrM636(x) SETUP(XfOrM636_COUNT)
    defn = NULLED_OUT ; 

# 2583 "bc/src/resolve.c"
    defn = FUNCCALL(SETUP_XfOrM636(_), scheme_hash_get (info -> toplevel_defns , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (tl_pos ) ) ) << 1 ) | 0x1 ) ) ) ); 
    if (defn ) {
#     define XfOrM637_COUNT (0+XfOrM636_COUNT)
#     define SETUP_XfOrM637(x) SETUP_XfOrM636(x)

# 2585 "bc/src/resolve.c"
      if ((scheme_true ) == (FUNCCALL(SETUP_XfOrM637(_), scheme_hash_get (info -> toplevel_defns , defn ) )) )  {
#       define XfOrM638_COUNT (0+XfOrM637_COUNT)
#       define SETUP_XfOrM638(x) SETUP_XfOrM637(x)
        (__funcarg64 = (__funcarg65 = FUNCCALL(SETUP_XfOrM638(_), scheme_hash_get (info -> toplevel_defns , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (defn , __funcarg65 ) )) , FUNCCALL_AGAIN(scheme_hash_set (info -> toplevel_defns , scheme_null , __funcarg64 ) )) 

        ; 
        FUNCCALL(SETUP_XfOrM638(_), scheme_hash_set (info -> toplevel_defns , defn , scheme_false ) )
        ; 
      }
      FUNCCALL_EMPTY(scheme_hash_set (info -> toplevel_defns , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (tl_pos ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2599 "bc/src/resolve.c"
static void * merge_tl_map (void * tl_map , void * new_tl_map ) 
{
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(tl_map, 0), PUSH(new_tl_map, 1)));
# define XfOrM640_COUNT (2)
# define SETUP_XfOrM640(x) SETUP(XfOrM640_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2601 "bc/src/resolve.c"
  if (! tl_map )
    RET_VALUE_START (new_tl_map ) RET_VALUE_END ; 
  else if (! new_tl_map )
    RET_VALUE_START (tl_map ) RET_VALUE_END ; 
  else if (((uintptr_t ) new_tl_map ) & 0x1 ) {
    if (((uintptr_t ) tl_map ) & 0x1 ) {
      RET_VALUE_START ((void * ) ((uintptr_t ) tl_map | (uintptr_t ) new_tl_map ) ) RET_VALUE_END ; 
    }

# 2608 "bc/src/resolve.c"
    else {
      ((int * ) tl_map ) [1 ] |= ((uintptr_t ) new_tl_map >> 1 ) & 0x7FFFFFFF ; 
      RET_VALUE_START (tl_map ) RET_VALUE_END ; 
    }
  }

# 2612 "bc/src/resolve.c"
  else {
    int i , len = * (int * ) new_tl_map ; 
#   define XfOrM641_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM641(x) SETUP_XfOrM640(x)

# 2614 "bc/src/resolve.c"
    tl_map = FUNCCALL(SETUP_XfOrM641(_), ensure_tl_map_len (tl_map , len * 32 ) ); 
    for (i = 0 ; i < len ; i ++ ) {
      ((int * ) tl_map ) [1 + i ] |= ((int * ) new_tl_map ) [1 + i ] ; 
    }
    RET_VALUE_START (tl_map ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2622 "bc/src/resolve.c"
static void merge_resolve_tl_map (Resolve_Info * info , Resolve_Info * new_info ) 
{
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(new_info, 1)));
# define XfOrM647_COUNT (2)
# define SETUP_XfOrM647(x) SETUP(XfOrM647_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2624 "bc/src/resolve.c"
  if (! new_info -> tl_map ) {
  }
  else {
    void * tl_map ; 
    BLOCK_SETUP((PUSH(tl_map, 0+XfOrM647_COUNT)));
#   define XfOrM648_COUNT (1+XfOrM647_COUNT)
#   define SETUP_XfOrM648(x) SETUP(XfOrM648_COUNT)
    tl_map = NULLED_OUT ; 

# 2628 "bc/src/resolve.c"
    tl_map = FUNCCALL(SETUP_XfOrM648(_), merge_tl_map (info -> tl_map , new_info -> tl_map ) ); 
    info -> tl_map = tl_map ; 
  }

  if (new_info -> need_instance_access )
    info -> need_instance_access = 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2636 "bc/src/resolve.c"
static void merge_resolve (Resolve_Info * info , Resolve_Info * new_info ) 
{
  /* No conversion */

# 2638 "bc/src/resolve.c"
  if (new_info -> next 
  && (new_info -> max_let_depth > info -> max_let_depth ) )
    info -> max_let_depth = new_info -> max_let_depth ; 

  merge_resolve_tl_map (info , new_info ) ; 
}

static void resolve_info_add_mapping (Resolve_Info * info , Scheme_IR_Local * var , Scheme_Object * v ) 
{
  Scheme_Hash_Tree * ht ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(ht, 1)));
# define XfOrM651_COUNT (2)
# define SETUP_XfOrM651(x) SETUP(XfOrM651_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 2649 "bc/src/resolve.c"
  if (! info -> redirects ) {
#   define XfOrM652_COUNT (0+XfOrM651_COUNT)
#   define SETUP_XfOrM652(x) SETUP_XfOrM651(x)

# 2650 "bc/src/resolve.c"
    ht = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
    info -> redirects = ht ; 
  }

  ht = FUNCCALL(SETUP_XfOrM651(_), scheme_hash_tree_set (info -> redirects , (Scheme_Object * ) var , v ) ); 
  info -> redirects = ht ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2658 "bc/src/resolve.c"
static void resolve_info_set_toplevel_pos (Resolve_Info * info , int pos ) 
{
  /* No conversion */

# 2660 "bc/src/resolve.c"
  info -> toplevel_pos = pos ; 
}

static int resolve_info_lookup (Resolve_Info * info , Scheme_IR_Local * var , Scheme_Object * * _lifted , 
int convert_shift , int flags ) 
{
  Scheme_Object * v ; 
  int depth ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(var, 0), PUSH(info, 1), PUSH(v, 2), PUSH(_lifted, 3)));
# define XfOrM654_COUNT (4)
# define SETUP_XfOrM654(x) SETUP(XfOrM654_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 2669 "bc/src/resolve.c"
  ((void ) sizeof ((var -> mode == 4 ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM662_COUNT (0+XfOrM654_COUNT)
#   define SETUP_XfOrM662(x) SETUP_XfOrM654(x)

# 2669 "bc/src/resolve.c" 3
    if (var -> mode == 4 )

# 2669 "bc/src/resolve.c" 3
    ; 

# 2669 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM662(_), __assert_fail ("var->mode == 4" , "bc/src/resolve.c" , 2669 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 2669 "bc/src/resolve.c"
  ; 
  ((void ) sizeof (((flags & 0x1 ) || (var -> use_count > 0 ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM661_COUNT (0+XfOrM654_COUNT)
#   define SETUP_XfOrM661(x) SETUP_XfOrM654(x)

# 2670 "bc/src/resolve.c" 3
    if ((flags & 0x1 ) || (var -> use_count > 0 ) )

# 2670 "bc/src/resolve.c" 3
    ; 

# 2670 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM661(_), __assert_fail ("(flags & 0x1) || (var->use_count > 0)" , "bc/src/resolve.c" , 2670 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 2670 "bc/src/resolve.c"
  ; 
  ((void ) sizeof (((flags & 0x1 ) || var -> optimize_used ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM660_COUNT (0+XfOrM654_COUNT)
#   define SETUP_XfOrM660(x) SETUP_XfOrM654(x)

# 2671 "bc/src/resolve.c" 3
    if ((flags & 0x1 ) || var -> optimize_used )

# 2671 "bc/src/resolve.c" 3
    ; 

# 2671 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM660(_), __assert_fail ("(flags & 0x1) || var->optimize_used" , "bc/src/resolve.c" , 2671 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 2671 "bc/src/resolve.c"
  ; 

  if (var -> resolve . lifted && ! (flags & 0x2 ) ) {
#   define XfOrM658_COUNT (0+XfOrM654_COUNT)
#   define SETUP_XfOrM658(x) SETUP_XfOrM654(x)

# 2674 "bc/src/resolve.c"
    ((void ) sizeof ((_lifted ) ? 1 : 0 ) , __extension__ ({
#     define XfOrM659_COUNT (0+XfOrM658_COUNT)
#     define SETUP_XfOrM659(x) SETUP_XfOrM658(x)

# 2674 "bc/src/resolve.c" 3
      if (_lifted )

# 2674 "bc/src/resolve.c" 3
      ; 

# 2674 "bc/src/resolve.c" 3
      else FUNCCALL(SETUP_XfOrM659(_), __assert_fail ("_lifted" , "bc/src/resolve.c" , 2674 , __extension__ __PRETTY_FUNCTION__ ) ); 
    }
    ) ) 
# 2674 "bc/src/resolve.c"
    ; 

    v = var -> resolve . lifted ; 
    * _lifted = v ; 

    RET_VALUE_START (- 1 ) RET_VALUE_END ; 
  }

  depth = var -> resolve . co_depth ; 
  if (info -> redirects ) {
#   define XfOrM655_COUNT (0+XfOrM654_COUNT)
#   define SETUP_XfOrM655(x) SETUP_XfOrM654(x)

# 2684 "bc/src/resolve.c"
    v = FUNCCALL(SETUP_XfOrM655(_), scheme_hash_tree_get (info -> redirects , (Scheme_Object * ) var ) ); 
    if (v ) {
#     define XfOrM656_COUNT (0+XfOrM655_COUNT)
#     define SETUP_XfOrM656(x) SETUP_XfOrM655(x)

# 2686 "bc/src/resolve.c"
      depth = (((intptr_t ) (v ) ) >> 1 ) ; 
      ((void ) sizeof ((var -> val_type <= 0x3 ) ? 1 : 0 ) , __extension__ ({
#       define XfOrM657_COUNT (0+XfOrM656_COUNT)
#       define SETUP_XfOrM657(x) SETUP_XfOrM656(x)

# 2687 "bc/src/resolve.c" 3
        if (var -> val_type <= 0x3 )

# 2687 "bc/src/resolve.c" 3
        ; 

# 2687 "bc/src/resolve.c" 3
        else FUNCCALL(SETUP_XfOrM657(_), __assert_fail ("var->val_type <= 0x3" , "bc/src/resolve.c" , 2687 , __extension__ __PRETTY_FUNCTION__ ) ); 
      }
      ) ) 
# 2687 "bc/src/resolve.c"
      ; 
    }
  }

  if (_lifted )
    * _lifted = ((void * ) 0 ) ; 

  RET_VALUE_START (info -> current_depth - depth + convert_shift ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2697 "bc/src/resolve.c"
static Scheme_Object * make_static_toplevel (Scheme_Hash_Table * static_mode , int pos , int flags , int as_ref ) 
{
  Scheme_Object * key , * tl ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(static_mode, 0), PUSH(key, 1), PUSH(tl, 2)));
# define XfOrM663_COUNT (3)
# define SETUP_XfOrM663(x) SETUP(XfOrM663_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  key = NULLED_OUT ; 
  tl = NULLED_OUT ; 

# 2701 "bc/src/resolve.c"
  if (as_ref )
    key = FUNCCALL(SETUP_XfOrM663(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (flags ) ) ) << 1 ) | 0x1 ) ) ) ); 
  else 
  key = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) ; 

  tl = FUNCCALL(SETUP_XfOrM663(_), scheme_hash_get (static_mode , key ) ); 
  if (! tl ) {
#   define XfOrM664_COUNT (0+XfOrM663_COUNT)
#   define SETUP_XfOrM664(x) SETUP_XfOrM663(x)

# 2708 "bc/src/resolve.c"
    tl = (Scheme_Object * ) ((Scheme_Toplevel * ) FUNCCALL(SETUP_XfOrM664(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Toplevel ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    tl -> type = scheme_static_toplevel_type ; 
    (((Scheme_Toplevel * ) (tl ) ) -> position ) = pos ; 
    (& ((Scheme_Toplevel * ) (tl ) ) -> iso ) -> so . keyex |= flags ; 
    FUNCCALL(SETUP_XfOrM664(_), scheme_hash_set (static_mode , key , tl ) ); 
  }

  RET_VALUE_START (tl ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2718 "bc/src/resolve.c"
static void install_static_prefix (Scheme_Linklet * linklet , Resolve_Info * ri ) 
{
  Scheme_Prefix * pf ; 
  int i ; 
  Scheme_Hash_Table * ht = ri -> static_mode ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(pf, 0), PUSH(ht, 1), PUSH(linklet, 2)));
# define XfOrM665_COUNT (3)
# define SETUP_XfOrM665(x) SETUP(XfOrM665_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pf = NULLED_OUT ; 

# 2726 "bc/src/resolve.c"
  pf = FUNCCALL(SETUP_XfOrM665(_), scheme_allocate_linklet_prefix (linklet , 1 ) ); 
  linklet -> static_prefix = pf ; 

  for (i = 0 ; i < ht -> size ; i ++ ) {
    if (ht -> vals [i ] ) {
      (((Scheme_Toplevel * ) (ht -> vals [i ] ) ) -> u . prefix ) = pf ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2736 "bc/src/resolve.c"
static Scheme_Object * resolve_generate_stub_lift (Resolve_Info * info ) 
{
  /* No conversion */

# 2738 "bc/src/resolve.c"
  if (info -> static_mode )
    return make_static_toplevel (info -> static_mode , 0 , 3 , 0 ) ; 
  else 
  return scheme_make_toplevel (0 , 0 , 3 ) ; 
}

static int resolve_toplevel_pos (Resolve_Info * info ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(info, 0)));
# define XfOrM671_COUNT (1)
# define SETUP_XfOrM671(x) SETUP(XfOrM671_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2746 "bc/src/resolve.c"
  ((void ) sizeof ((info -> toplevel_pos >= 0 ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM672_COUNT (0+XfOrM671_COUNT)
#   define SETUP_XfOrM672(x) SETUP_XfOrM671(x)

# 2746 "bc/src/resolve.c" 3
    if (info -> toplevel_pos >= 0 )

# 2746 "bc/src/resolve.c" 3
    ; 

# 2746 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM672(_), __assert_fail ("info->toplevel_pos >= 0" , "bc/src/resolve.c" , 2746 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 2746 "bc/src/resolve.c"
  ; 
  RET_VALUE_START (info -> toplevel_pos ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2750 "bc/src/resolve.c"
static int resolve_is_inside_proc (Resolve_Info * info ) 
{
  /* No conversion */

# 2752 "bc/src/resolve.c"
  return info -> in_proc ; 
}

static int resolve_has_toplevel (Resolve_Info * info ) 
{
  /* No conversion */

# 2757 "bc/src/resolve.c"
  return (info -> toplevel_pos >= 0 ) || info -> static_mode ; 
}

static Scheme_Object * resolve_toplevel (Resolve_Info * info , Scheme_Object * expr , int as_reference ) 
{
  int skip , pos ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(expr, 1)));
# define XfOrM675_COUNT (2)
# define SETUP_XfOrM675(x) SETUP(XfOrM675_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2764 "bc/src/resolve.c"
  if (info -> static_mode )
    skip = 0 ; 
  else 
  skip = FUNCCALL(SETUP_XfOrM675(_), resolve_toplevel_pos (info ) ); 

  if ((((Scheme_IR_Toplevel * ) expr ) -> instance_pos ) == - 1 ) {
    if ((((Scheme_IR_Toplevel * ) expr ) -> variable_pos ) == - 1 ) {

      pos = 0 ; 
      info -> need_instance_access = 1 ; 
    }

# 2774 "bc/src/resolve.c"
    else 
    pos = info -> toplevel_starts [0 ] + (((Scheme_IR_Toplevel * ) expr ) -> variable_pos ) ; 
  }

# 2776 "bc/src/resolve.c"
  else {
    pos = (info -> toplevel_starts [(((Scheme_IR_Toplevel * ) expr ) -> instance_pos ) + 1 ] + (((Scheme_IR_Toplevel * ) expr ) -> variable_pos ) ) ; 
    pos += info -> toplevel_deltas [pos ] ; 
  }

  if (as_reference )
    FUNCCALL(SETUP_XfOrM675(_), set_tl_pos_used (info , pos ) ); 

  if (info -> static_mode )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_static_toplevel (info -> static_mode , pos , (& ((Scheme_IR_Toplevel * ) expr ) -> iso ) -> so . keyex & 0x3 , as_reference ) )) RET_VALUE_EMPTY_END 

  ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_toplevel (skip , pos , (& ((Scheme_IR_Toplevel * ) expr ) -> iso ) -> so . keyex & 0x3 ) )) RET_VALUE_EMPTY_END 
  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2793 "bc/src/resolve.c"
static Scheme_Object * shift_toplevel (Scheme_Object * expr , int delta ) 
{
  /* No conversion */

# 2795 "bc/src/resolve.c"
  return scheme_make_toplevel ((((Scheme_Toplevel * ) (expr ) ) -> u . depth ) + delta , 
  (((Scheme_Toplevel * ) (expr ) ) -> position ) , 
  (& ((Scheme_Toplevel * ) (expr ) ) -> iso ) -> so . keyex & 0x3 ) ; 
}

static Scheme_Object * resolve_invent_toplevel (Resolve_Info * info ) 
{
  int skip , pos ; 
  Scheme_Object * count ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(count, 1)));
# define XfOrM680_COUNT (2)
# define SETUP_XfOrM680(x) SETUP(XfOrM680_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  count = NULLED_OUT ; 

# 2805 "bc/src/resolve.c"
  skip = FUNCCALL(SETUP_XfOrM680(_), resolve_toplevel_pos (info ) ); 

  count = (((Scheme_Vector * ) (info -> lifts ) ) -> els ) [1 ] ; 
  pos = (int ) ((((intptr_t ) (count ) ) >> 1 ) + info -> num_toplevels ) ; 
  count = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((intptr_t ) (count ) ) >> 1 ) + 1 ) ) ) << 1 ) | 0x1 ) ) ; 
  (((Scheme_Vector * ) (info -> lifts ) ) -> els ) [1 ] = count ; 
  FUNCCALL(SETUP_XfOrM680(_), set_tl_pos_used (info , pos ) )
  ; 

  if (info -> static_mode )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_static_toplevel (info -> static_mode , pos , 3 , 0 ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_toplevel (skip , pos , 3 ) )) RET_VALUE_EMPTY_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2822 "bc/src/resolve.c"
static Scheme_Object * resolve_invented_toplevel_to_defn (Resolve_Info * info , Scheme_Object * tl ) 
{
  /* No conversion */

# 2824 "bc/src/resolve.c"
  if ((Scheme_Type ) (((((intptr_t ) (tl ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (tl ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
    return scheme_make_toplevel (0 , 
  (((Scheme_Toplevel * ) (tl ) ) -> position ) , 
  3 ) ; 
  else 
  return tl ; 
}

# 2848 "bc/src/resolve.c"
typedef struct Unresolve_Info {
  Scheme_Type type ; 
  int comp_flags ; 
  int stack_pos ; 
  int depth ; 
  int stack_size ; 
  Scheme_IR_Local * * vars ; 


  Scheme_Linklet * linklet ; 
  Scheme_Object * linklet_key ; 
  Optimize_Info * opt_info ; 

  Scheme_Hash_Table * closures ; 
  int has_non_leaf , has_tl , body_size ; 

  int inlining ; 

  int num_toplevels ; 
  int num_defns ; 
  int num_extra_toplevels ; 

  Scheme_IR_Toplevel * * toplevels ; 
  Scheme_Object * definitions ; 
  int lift_offset ; 
  Scheme_Hash_Table * ref_lifts ; 
}

# 2874 "bc/src/resolve.c"
Unresolve_Info ; 

static Scheme_Object * unresolve_expr (Scheme_Object * e , Unresolve_Info * ui , int as_rator ) ; 
static void locate_cyclic_closures (Scheme_Object * e , Unresolve_Info * ui ) ; 
static Scheme_IR_Let_Header * make_let_header (int count ) ; 
static Scheme_IR_Let_Value * make_ir_let_value (int count ) ; 

static Unresolve_Info * new_unresolve_info (Scheme_Linklet * linklet , Scheme_Object * linklet_key , Optimize_Info * opt_info , 
int comp_flags ) 
{
  Unresolve_Info * ui ; 
  Scheme_IR_Local * * vars ; 
  Scheme_Hash_Table * ht ; 
  DECL_RET_SAVE (Unresolve_Info * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ui, 0), PUSH(ht, 1), PUSH(vars, 2), PUSH(linklet_key, 3), PUSH(linklet, 4), PUSH(opt_info, 5)));
# define XfOrM682_COUNT (6)
# define SETUP_XfOrM682(x) SETUP(XfOrM682_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ui = NULLED_OUT ; 
  vars = NULLED_OUT ; 
  ht = NULLED_OUT ; 

# 2888 "bc/src/resolve.c"
  ui = ((Unresolve_Info * ) FUNCCALL(SETUP_XfOrM682(_), GC_malloc_one_small_tagged ((((sizeof (Unresolve_Info ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  ui -> type = scheme_rt_unresolve_info ; 

  ui -> linklet = linklet ; 
  ui -> linklet_key = linklet_key ; 
  ui -> opt_info = opt_info ; 

  ui -> stack_pos = 0 ; 
  ui -> stack_size = 10 ; 
  vars = ((Scheme_IR_Local * * ) FUNCCALL(SETUP_XfOrM682(_), GC_malloc (sizeof (Scheme_IR_Local * ) * (ui -> stack_size ) ) )) ; 
  ui -> vars = vars ; 

  ui -> definitions = scheme_null ; 
  ht = FUNCCALL(SETUP_XfOrM682(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  ui -> ref_lifts = ht ; 
  ht = FUNCCALL(SETUP_XfOrM682(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  ui -> closures = ht ; 

  ui -> comp_flags = comp_flags ; 

  ui -> num_defns = (((Scheme_Vector * ) (linklet -> defns ) ) -> size ) ; 
  ui -> num_toplevels = (1 
  + linklet -> num_total_imports 
  + ui -> num_defns ) ; 
  ui -> lift_offset = (ui -> num_toplevels 
  - linklet -> num_lifts ) ; 

  RET_VALUE_START (ui ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2918 "bc/src/resolve.c"
static int unresolve_stack_push (Unresolve_Info * ui , int n , int make_vars ) 
{
  int pos , i ; 
  Scheme_IR_Local * * vars , * var ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(var, 0), PUSH(vars, 1), PUSH(ui, 2)));
# define XfOrM683_COUNT (3)
# define SETUP_XfOrM683(x) SETUP(XfOrM683_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vars = NULLED_OUT ; 
  var = NULLED_OUT ; 

# 2923 "bc/src/resolve.c"
  pos = ui -> stack_pos ; 

  if (pos + n > ui -> stack_size ) {
#   define XfOrM687_COUNT (0+XfOrM683_COUNT)
#   define SETUP_XfOrM687(x) SETUP_XfOrM683(x)

# 2926 "bc/src/resolve.c"
    vars = ((Scheme_IR_Local * * ) FUNCCALL(SETUP_XfOrM687(_), GC_malloc (sizeof (Scheme_IR_Local * ) * (((2 * ui -> stack_size ) + n ) ) ) )) ; 
    (memcpy (vars , ui -> vars , sizeof (Scheme_IR_Local * ) * pos ) ) ; 

    ui -> vars = vars ; 

    ui -> stack_size = (2 * ui -> stack_size ) + n ; 
  }
  if (make_vars ) {
#   define XfOrM684_COUNT (0+XfOrM683_COUNT)
#   define SETUP_XfOrM684(x) SETUP_XfOrM683(x)

# 2934 "bc/src/resolve.c"
    for (i = 0 ; i < n ; i ++ ) {
#     define XfOrM686_COUNT (0+XfOrM684_COUNT)
#     define SETUP_XfOrM686(x) SETUP_XfOrM684(x)

# 2935 "bc/src/resolve.c"
      var = ((Scheme_IR_Local * ) FUNCCALL(SETUP_XfOrM686(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Local ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      var -> so . type = scheme_ir_local_type ; 
      ui -> vars [pos + i ] = var ; 
    }
  }

# 2939 "bc/src/resolve.c"
  else (
  memset (ui -> vars + pos , 0 , sizeof (Scheme_IR_Local * ) * n ) ) ; 

  ui -> stack_pos += n ; 


  ; 

  RET_VALUE_START (pos ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2950 "bc/src/resolve.c"
static Scheme_IR_Local * * unresolve_stack_extract (Unresolve_Info * ui , int pos , int n ) 
{
  Scheme_IR_Local * * vars ; 
  int i ; 
  DECL_RET_SAVE (Scheme_IR_Local * * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ui, 0), PUSH(vars, 1)));
# define XfOrM688_COUNT (2)
# define SETUP_XfOrM688(x) SETUP(XfOrM688_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vars = NULLED_OUT ; 

# 2955 "bc/src/resolve.c"
  if (! n )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  vars = ((Scheme_IR_Local * * ) FUNCCALL(SETUP_XfOrM688(_), GC_malloc (sizeof (Scheme_IR_Local * ) * (n ) ) )) ; 
  for (i = 0 ; i < n ; i ++ ) {
    vars [i ] = ui -> vars [ui -> stack_pos - pos - 1 - i ] ; 
  }

  RET_VALUE_START (vars ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2966 "bc/src/resolve.c"
static Scheme_IR_Local * * unresolve_stack_pop (Unresolve_Info * ui , int pos , int n ) 
{
  Scheme_IR_Local * * vars ; 
  DECL_RET_SAVE (Scheme_IR_Local * * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ui, 0), PUSH(vars, 1)));
# define XfOrM691_COUNT (2)
# define SETUP_XfOrM691(x) SETUP(XfOrM691_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vars = NULLED_OUT ; 

# 2970 "bc/src/resolve.c"
  ((void ) sizeof ((! n || (ui -> stack_pos == pos + n ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM692_COUNT (0+XfOrM691_COUNT)
#   define SETUP_XfOrM692(x) SETUP_XfOrM691(x)

# 2970 "bc/src/resolve.c" 3
    if (! n || (ui -> stack_pos == pos + n ) )

# 2970 "bc/src/resolve.c" 3
    ; 

# 2970 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM692(_), __assert_fail ("!n || (ui->stack_pos == pos + n)" , "bc/src/resolve.c" , 2970 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 2970 "bc/src/resolve.c"
  ; 

  vars = FUNCCALL(SETUP_XfOrM691(_), unresolve_stack_extract (ui , 0 , n ) ); 

  ui -> stack_pos = pos ; 

  RET_VALUE_START (vars ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2979 "bc/src/resolve.c"
static Scheme_IR_Local * unresolve_lookup (Unresolve_Info * ui , int pos , int as_rator ) 
{
  /* No conversion */

# 2981 "bc/src/resolve.c"
  Scheme_IR_Local * var = ui -> vars [ui -> stack_pos - pos - 1 ] ; 

  if (var -> use_count < 7 )
    var -> use_count ++ ; 
  if (! as_rator 
  && ! var -> is_ref_arg 
  && (var -> non_app_count < 7 ) )
    var -> non_app_count ++ ; 

  return var ; 
}

static Scheme_Object * unresolve_lambda (Scheme_Lambda * rlam , Unresolve_Info * ui ) 
{
  Scheme_Lambda * lam ; 
  Scheme_Object * body ; 
  Scheme_IR_Lambda_Info * cl ; 
  int i , pos , lam_pos , init_size , has_non_leaf , has_tl ; 
  Scheme_IR_Local * * vars ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(lam, 0), PUSH(ui, 1), PUSH(body, 2), PUSH(vars, 3), PUSH(cl, 4), PUSH(rlam, 5)));
# define XfOrM694_COUNT (6)
# define SETUP_XfOrM694(x) SETUP(XfOrM694_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lam = NULLED_OUT ; 
  body = NULLED_OUT ; 
  cl = NULLED_OUT ; 
  vars = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM694(_), scheme_delay_load_closure (rlam ) )
# 3001 "bc/src/resolve.c"
  ; 

  lam = ((Scheme_Lambda * ) FUNCCALL(SETUP_XfOrM694(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Lambda ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  lam -> iso . so . type = scheme_ir_lambda_type ; 

  (& (lam ) -> iso ) -> so . keyex = ((& (rlam ) -> iso ) -> so . keyex 
  & (1 | 16 ) ) ; 


  lam -> num_params = rlam -> num_params ; 
  lam -> name = rlam -> name ; 

  pos = FUNCCALL(SETUP_XfOrM694(_), unresolve_stack_push (ui , lam -> num_params , 1 ) ); 
  vars = FUNCCALL_AGAIN(unresolve_stack_extract (ui , 0 , lam -> num_params ) ); 

  if ((& (rlam ) -> iso ) -> so . keyex & 2 ) {
#   define XfOrM698_COUNT (0+XfOrM694_COUNT)
#   define SETUP_XfOrM698(x) SETUP_XfOrM694(x)

# 3017 "bc/src/resolve.c"
    for (i = 0 ; i < lam -> num_params ; i ++ ) {
#     define XfOrM701_COUNT (0+XfOrM698_COUNT)
#     define SETUP_XfOrM701(x) SETUP_XfOrM698(x)

# 3019 "bc/src/resolve.c"
      ; 
      if ((scheme_boxmap_get (rlam -> closure_map , i , rlam -> closure_size ) ) == 1 ) {
        vars [i ] -> is_ref_arg = 1 ; 
      }
    }
  }

  if (rlam -> closure_size ) {
#   define XfOrM695_COUNT (0+XfOrM694_COUNT)
#   define SETUP_XfOrM695(x) SETUP_XfOrM694(x)

# 3027 "bc/src/resolve.c"
    lam_pos = FUNCCALL(SETUP_XfOrM695(_), unresolve_stack_push (ui , rlam -> closure_size , 0 ) ); 
    for (i = rlam -> closure_size ; i -- ; ) {
      Scheme_IR_Local * mp ; 
      mp = NULLED_OUT ; 

# 3030 "bc/src/resolve.c"
      mp = ui -> vars [pos - rlam -> closure_map [i ] - 1 ] ; 
      ui -> vars [ui -> stack_pos - i - 1 ] = mp ; 
    }
  }

# 3033 "bc/src/resolve.c"
  else 
  lam_pos = 0 ; 

  init_size = ui -> body_size ; 
  has_non_leaf = ui -> has_non_leaf ; 
  ui -> has_non_leaf = 0 ; 
  has_tl = ui -> has_tl ; 
  ui -> has_tl = 0 ; 

  body = FUNCCALL(SETUP_XfOrM694(_), unresolve_expr (rlam -> body , ui , 0 ) ); 
  if (! body )

# 3043 "bc/src/resolve.c"
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  lam -> body = body ; 

  cl = ((Scheme_IR_Lambda_Info * ) FUNCCALL(SETUP_XfOrM694(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Lambda_Info ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  cl -> type = scheme_rt_ir_lambda_info ; 
  lam -> ir_info = cl ; 

  cl -> body_size = (ui -> body_size - init_size ) ; 

  cl -> has_nonleaf = ui -> has_non_leaf ; 
  ui -> has_non_leaf = has_non_leaf ; 

  cl -> has_tl = ui -> has_tl ; 
  ui -> has_tl = ui -> has_tl || has_tl ; 

  if (rlam -> closure_size )
    (void ) FUNCCALL(SETUP_XfOrM694(_), unresolve_stack_pop (ui , lam_pos , 0 ) ); 

  (void ) FUNCCALL(SETUP_XfOrM694(_), unresolve_stack_pop (ui , pos , 0 ) ); 
  cl -> vars = vars ; 




  RET_VALUE_START ((Scheme_Object * ) lam ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3071 "bc/src/resolve.c"
static void check_nonleaf_rator (Scheme_Object * rator , Unresolve_Info * ui ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ui, 0)));
# define XfOrM703_COUNT (1)
# define SETUP_XfOrM703(x) SETUP(XfOrM703_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3073 "bc/src/resolve.c"
  if (! FUNCCALL(SETUP_XfOrM703(_), scheme_check_leaf_rator (rator ) ))
    ui -> has_non_leaf = 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3077 "bc/src/resolve.c"
static Scheme_Object * unresolve_toplevel (Scheme_Object * rdata , Unresolve_Info * ui ) 
{
  Scheme_Object * v ; 
  int pos = (((Scheme_Toplevel * ) (rdata ) ) -> position ) ; 
  int flags ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(ui, 0), PUSH(rdata, 1), PUSH(v, 2)));
# define XfOrM704_COUNT (3)
# define SETUP_XfOrM704(x) SETUP(XfOrM704_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 3085 "bc/src/resolve.c"
  ((void ) sizeof ((pos < ui -> num_toplevels ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM716_COUNT (0+XfOrM704_COUNT)
#   define SETUP_XfOrM716(x) SETUP_XfOrM704(x)

# 3085 "bc/src/resolve.c" 3
    if (pos < ui -> num_toplevels )

# 3085 "bc/src/resolve.c" 3
    ; 

# 3085 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM716(_), __assert_fail ("pos < ui->num_toplevels" , "bc/src/resolve.c" , 3085 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 3085 "bc/src/resolve.c"
  ; 

  if (ui -> inlining && (pos > (1 
  + ui -> linklet -> num_total_imports 
  + ui -> linklet -> num_exports ) ) ) {

    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (ui -> inlining ) {
#   define XfOrM708_COUNT (0+XfOrM704_COUNT)
#   define SETUP_XfOrM708(x) SETUP_XfOrM704(x)
    if (pos >= (ui -> linklet -> num_total_imports + 1 ) ) {
#     define XfOrM714_COUNT (0+XfOrM708_COUNT)
#     define SETUP_XfOrM714(x) SETUP_XfOrM708(x)

# 3099 "bc/src/resolve.c"
      pos -= (ui -> linklet -> num_total_imports + 1 ) ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_optimize_add_import_variable (ui -> opt_info , ui -> linklet_key , (((Scheme_Vector * ) (ui -> linklet -> defns ) ) -> els ) [pos ] ) )) RET_VALUE_EMPTY_END 
      ; 
    }

# 3102 "bc/src/resolve.c"
    else {

      int instance_pos = 0 ; 
#     define XfOrM709_COUNT (0+XfOrM708_COUNT)
#     define SETUP_XfOrM709(x) SETUP_XfOrM708(x)

# 3105 "bc/src/resolve.c"
      pos -= 1 ; 
      while (pos >= (((Scheme_Vector * ) ((((Scheme_Vector * ) (ui -> linklet -> importss ) ) -> els ) [instance_pos ] ) ) -> size ) ) {
        pos -= (((Scheme_Vector * ) ((((Scheme_Vector * ) (ui -> linklet -> importss ) ) -> els ) [instance_pos ] ) ) -> size ) ; 
        instance_pos ++ ; 
      }
      ((void ) sizeof ((instance_pos < (((Scheme_Vector * ) (ui -> linklet -> importss ) ) -> size ) ) ? 1 : 0 ) , __extension__ ({
#       define XfOrM711_COUNT (0+XfOrM709_COUNT)
#       define SETUP_XfOrM711(x) SETUP_XfOrM709(x)

# 3110 "bc/src/resolve.c" 3
        if (instance_pos < (((Scheme_Vector * ) (ui -> linklet -> importss ) ) -> size ) )

# 3110 "bc/src/resolve.c" 3
        ; 

# 3110 "bc/src/resolve.c" 3
        else FUNCCALL(SETUP_XfOrM711(_), __assert_fail ("instance_pos < (((Scheme_Vector *)(ui->linklet->importss))->size)" , "bc/src/resolve.c" , 3110 , __extension__ __PRETTY_FUNCTION__ ) ); 
      }
      ) ) 
# 3110 "bc/src/resolve.c"
      ; 



      v = FUNCCALL(SETUP_XfOrM709(_), scheme_optimize_get_import_key (ui -> opt_info , ui -> linklet_key , instance_pos ) ); 
      if (v ) {
#       define XfOrM710_COUNT (0+XfOrM709_COUNT)
#       define SETUP_XfOrM710(x) SETUP_XfOrM709(x)

# 3117 "bc/src/resolve.c"
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_optimize_add_import_variable (ui -> opt_info , v , (((Scheme_Vector * ) ((((Scheme_Vector * ) (ui -> linklet -> importss ) ) -> els ) [instance_pos ] ) ) -> els ) [pos ] ) )) RET_VALUE_EMPTY_END 
        ; 
      }
    }

    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  flags = (& ((Scheme_Toplevel * ) (rdata ) ) -> iso ) -> so . keyex & 0x3 ; 
  switch (flags ) {
    case 3 : 
    break ; 
    case 2 : 
    break ; 
    case 1 : 
    default : 
    if (ui -> inlining ) {


      flags = 1 ; 
    }
  }

  v = (Scheme_Object * ) ui -> toplevels [pos ] ; 
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM705_COUNT (0+XfOrM704_COUNT)
#   define SETUP_XfOrM705(x) SETUP_XfOrM704(x)

# 3141 "bc/src/resolve.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) 

# 3141 "bc/src/resolve.c" 3
    ; 

# 3141 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM705(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(v)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(v))->type)) == (Scheme_Type)(scheme_ir_toplevel_type))" , "bc/src/resolve.c" , 3141 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 3141 "bc/src/resolve.c"
  ; 

  if (flags )
    v = FUNCCALL(SETUP_XfOrM704(_), scheme_ir_toplevel_to_flagged_toplevel (v , flags ) ); 

  ui -> has_tl = 1 ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3151 "bc/src/resolve.c"
static Scheme_Object * unresolve_apply_values (Scheme_Object * e , Unresolve_Info * ui ) 
{
  Scheme_Object * o , * a , * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(ui, 1), PUSH(b, 2), PUSH(a, 3), PUSH(o, 4)));
# define XfOrM717_COUNT (5)
# define SETUP_XfOrM717(x) SETUP(XfOrM717_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  a = NULLED_OUT ; 
  b = NULLED_OUT ; 

# 3155 "bc/src/resolve.c"
  a = (((Scheme_Simple_Object * ) (e ) ) -> u . two_ptr_val . ptr1 ) ; 
  a = FUNCCALL(SETUP_XfOrM717(_), unresolve_expr (a , ui , 0 ) ); 
  if (! a )

# 3157 "bc/src/resolve.c"
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  ; 

  b = (((Scheme_Simple_Object * ) (e ) ) -> u . two_ptr_val . ptr2 ) ; 
  b = FUNCCALL(SETUP_XfOrM717(_), unresolve_expr (b , ui , 0 ) ); 
  if (! b )

# 3162 "bc/src/resolve.c"
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  ; 

  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM717(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = ((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr1 ) = a ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr2 ) = b ; 
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3172 "bc/src/resolve.c"
static Scheme_Object * unresolve_define_values (Scheme_Object * e , Unresolve_Info * ui ) 
{
  Scheme_Object * vec , * val , * tl ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(ui, 1), PUSH(val, 2), PUSH(vec, 3), PUSH(tl, 4)));
# define XfOrM718_COUNT (5)
# define SETUP_XfOrM718(x) SETUP(XfOrM718_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vec = NULLED_OUT ; 
  val = NULLED_OUT ; 
  tl = NULLED_OUT ; 

# 3177 "bc/src/resolve.c"
  vec = FUNCCALL(SETUP_XfOrM718(_), scheme_make_vector ((((Scheme_Vector * ) (e ) ) -> size ) , ((void * ) 0 ) ) ); 
  vec -> type = scheme_define_values_type ; 

  ; 
  for (i = (((Scheme_Vector * ) (e ) ) -> size ) ; -- i ; ) {
#   define XfOrM720_COUNT (0+XfOrM718_COUNT)
#   define SETUP_XfOrM720(x) SETUP_XfOrM718(x)

# 3182 "bc/src/resolve.c"
    ; 
    tl = FUNCCALL(SETUP_XfOrM720(_), unresolve_toplevel ((((Scheme_Vector * ) (e ) ) -> els ) [i ] , ui ) ); 
    if (! tl )

# 3184 "bc/src/resolve.c"
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = tl ; 
  }
  val = FUNCCALL(SETUP_XfOrM718(_), unresolve_expr ((((Scheme_Vector * ) (e ) ) -> els ) [0 ] , ui , 0 ) ); 
  if (! val )

# 3188 "bc/src/resolve.c"
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = val ; 

  RET_VALUE_START (vec ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3194 "bc/src/resolve.c"
static Scheme_IR_Let_Header * make_let_header (int count ) 
{
  Scheme_IR_Let_Header * lh ; 
  DECL_RET_SAVE (Scheme_IR_Let_Header * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(lh, 0)));
# define XfOrM721_COUNT (1)
# define SETUP_XfOrM721(x) SETUP(XfOrM721_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lh = NULLED_OUT ; 

# 3197 "bc/src/resolve.c"
  lh = ((Scheme_IR_Let_Header * ) FUNCCALL(SETUP_XfOrM721(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Let_Header ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  lh -> iso . so . type = scheme_ir_let_header_type ; 
  lh -> count = count ; 
  lh -> num_clauses = 0 ; 
  RET_VALUE_START (lh ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3204 "bc/src/resolve.c"
static Scheme_IR_Let_Value * make_ir_let_value (int count ) 
{
  Scheme_IR_Let_Value * irlv ; 
  DECL_RET_SAVE (Scheme_IR_Let_Value * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(irlv, 0)));
# define XfOrM722_COUNT (1)
# define SETUP_XfOrM722(x) SETUP(XfOrM722_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  irlv = NULLED_OUT ; 

# 3207 "bc/src/resolve.c"
  irlv = ((Scheme_IR_Let_Value * ) FUNCCALL(SETUP_XfOrM722(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Let_Value ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  irlv -> iso . so . type = scheme_ir_let_value_type ; 
  irlv -> count = count ; 
  RET_VALUE_START (irlv ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3213 "bc/src/resolve.c"
typedef struct Unresolve_Let_Void_State {

  Scheme_IR_Let_Header * prev_head ; 
  Scheme_IR_Let_Value * prev_let ; 
  Scheme_Sequence * prev_seq ; 
}

# 3218 "bc/src/resolve.c"
Unresolve_Let_Void_State ; 


static void attach_lv (Scheme_IR_Let_Header * lh , 
Scheme_IR_Let_Value * irlv , 
Scheme_Sequence * seq , 
Scheme_Object * body , 
Unresolve_Let_Void_State * state ) 
{
  /* No conversion */

# 3227 "bc/src/resolve.c"
  Scheme_Object * o ; 
  o = lh ? (Scheme_Object * ) lh : 
  (irlv ? (Scheme_Object * ) irlv : 
  (seq ? (Scheme_Object * ) seq : body ) ) ; 

  if (state -> prev_head ) {
    state -> prev_head -> body = o ; 
  }

# 3234 "bc/src/resolve.c"
  else if (state -> prev_let ) {
    state -> prev_let -> body = o ; 
  }

# 3236 "bc/src/resolve.c"
  else if (state -> prev_seq ) {
    state -> prev_seq -> array [state -> prev_seq -> count - 1 ] = o ; 
  }

  state -> prev_head = lh ; 
  state -> prev_let = irlv ; 
  state -> prev_seq = seq ; 
}

static Scheme_Object * push_to_rhs_sequence (Scheme_Object * push_rhs , Scheme_Object * val ) 

{
  int len , i ; 
  Scheme_Sequence * seq ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(push_rhs, 0), PUSH(val, 1), PUSH(seq, 2)));
# define XfOrM727_COUNT (3)
# define SETUP_XfOrM727(x) SETUP(XfOrM727_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  seq = NULLED_OUT ; 

# 3251 "bc/src/resolve.c"
  len = (scheme_list_length (push_rhs ) ) ; 
  seq = FUNCCALL(SETUP_XfOrM727(_), scheme_malloc_sequence (len + 1 ) ); 
  seq -> so . type = scheme_sequence_type ; 
  seq -> count = len + 1 ; 
  seq -> array [len ] = val ; 

  for (i = len ; i -- ; ) {
    seq -> array [i ] = (((Scheme_Simple_Object * ) (push_rhs ) ) -> u . pair_val . car ) ; 
    push_rhs = (((Scheme_Simple_Object * ) (push_rhs ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) seq ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3265 "bc/src/resolve.c"
static Scheme_Object * unresolve_let_void (Scheme_Object * e , Unresolve_Info * ui ) 
{
  Scheme_Let_Void * lv = (Scheme_Let_Void * ) e ; 
  int i , pos , count ; 
  Scheme_IR_Local * * vars ; 
  Scheme_IR_Let_Header * lh ; 
  Scheme_Object * o , * push_rhs = scheme_null ; 
  Unresolve_Let_Void_State * state ; 

# 2876 "bc/src/resolve.c"
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(state, 0), PUSH(vars, 1), PUSH(o, 2), PUSH(ui, 3), PUSH(push_rhs, 4), PUSH(lv, 5), PUSH(lh, 6)));
# define XfOrM730_COUNT (7)
# define SETUP_XfOrM730(x) SETUP(XfOrM730_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  vars = NULLED_OUT ; 
  lh = NULLED_OUT ; 
  o = NULLED_OUT ; 
  state = NULLED_OUT ; 

# 3274 "bc/src/resolve.c"
  state = FUNCCALL(SETUP_XfOrM730(_), GC_malloc (sizeof (Unresolve_Let_Void_State ) ) ); 

  count = lv -> count ; 
  pos = FUNCCALL(SETUP_XfOrM730(_), unresolve_stack_push (ui , count , 1 ) ); 
  lh = FUNCCALL_AGAIN(make_let_header (count ) ); 

  o = lv -> body ; 
  FUNCCALL(SETUP_XfOrM730(_), attach_lv (lh , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , state ) ); 
  for (i = 0 ; i < count ; ) {
#   define XfOrM748_COUNT (0+XfOrM730_COUNT)
#   define SETUP_XfOrM748(x) SETUP_XfOrM730(x)

# 3283 "bc/src/resolve.c"
    switch (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) {
#     define XfOrM749_COUNT (0+XfOrM748_COUNT)
#     define SETUP_XfOrM749(x) SETUP_XfOrM748(x)

# 3284 "bc/src/resolve.c"
      case scheme_let_value_type : {
        Scheme_Let_Value * lval = (Scheme_Let_Value * ) o ; 
        Scheme_IR_Let_Value * irlv ; 
        Scheme_Object * val ; 
        BLOCK_SETUP((PUSH(irlv, 0+XfOrM749_COUNT), PUSH(val, 1+XfOrM749_COUNT), PUSH(lval, 2+XfOrM749_COUNT)));
#       define XfOrM762_COUNT (3+XfOrM749_COUNT)
#       define SETUP_XfOrM762(x) SETUP(XfOrM762_COUNT)
        irlv = NULLED_OUT ; 
        val = NULLED_OUT ; 

# 3288 "bc/src/resolve.c"
        irlv = FUNCCALL(SETUP_XfOrM762(_), make_ir_let_value (lval -> count ) ); 
        lh -> num_clauses ++ ; 

        vars = FUNCCALL(SETUP_XfOrM762(_), unresolve_stack_extract (ui , lval -> position , lv -> count ) ); 
        irlv -> vars = vars ; 

        if ((& lval -> iso ) -> so . keyex ) {
          (& lh -> iso ) -> so . keyex = 0x1 ; 
        }

        val = FUNCCALL(SETUP_XfOrM762(_), unresolve_expr (lval -> value , ui , 0 ) ); 
        if (! val )

# 3299 "bc/src/resolve.c"
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        if (! ((push_rhs ) == (scheme_null ) ) ) {
#         define XfOrM763_COUNT (0+XfOrM762_COUNT)
#         define SETUP_XfOrM763(x) SETUP_XfOrM762(x)

# 3301 "bc/src/resolve.c"
          val = FUNCCALL(SETUP_XfOrM763(_), push_to_rhs_sequence (push_rhs , val ) ); 
          push_rhs = scheme_null ; 
        }
        irlv -> value = val ; 

        o = lval -> body ; 
        FUNCCALL(SETUP_XfOrM762(_), attach_lv (((void * ) 0 ) , irlv , ((void * ) 0 ) , ((void * ) 0 ) , state ) ); 
        i += lval -> count ; 

        break ; 
      }
      case scheme_boxenv_type : {
        o = (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr2 ) ; 
        break ; 
      }
      case scheme_letrec_type : {
        Scheme_Letrec * lr = (Scheme_Letrec * ) o ; 
        int j ; 
        BLOCK_SETUP((PUSH(lr, 0+XfOrM749_COUNT)));
#       define XfOrM756_COUNT (1+XfOrM749_COUNT)
#       define SETUP_XfOrM756(x) SETUP(XfOrM756_COUNT)

# 3319 "bc/src/resolve.c"
        (& lh -> iso ) -> so . keyex = 0x1 ; 
        for (j = 0 ; j < lr -> count ; j ++ ) {
          Scheme_IR_Let_Value * irlv ; 
          Scheme_Object * val ; 
          Scheme_IR_Local * * vars ; 
          BLOCK_SETUP((PUSH(irlv, 0+XfOrM756_COUNT), PUSH(val, 1+XfOrM756_COUNT), PUSH(vars, 2+XfOrM756_COUNT)));
#         define XfOrM759_COUNT (3+XfOrM756_COUNT)
#         define SETUP_XfOrM759(x) SETUP(XfOrM759_COUNT)
          irlv = NULLED_OUT ; 
          val = NULLED_OUT ; 
          vars = NULLED_OUT ; 

# 3324 "bc/src/resolve.c"
          irlv = FUNCCALL(SETUP_XfOrM759(_), make_ir_let_value (1 ) ); 
          lh -> num_clauses ++ ; 
          vars = FUNCCALL(SETUP_XfOrM759(_), unresolve_stack_extract (ui , j , 1 ) ); 
          val = FUNCCALL_AGAIN(unresolve_expr (lr -> procs [j ] , ui , 0 ) ); 
          if (! val )

# 3328 "bc/src/resolve.c"
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          if (! ((push_rhs ) == (scheme_null ) ) ) {
#           define XfOrM760_COUNT (0+XfOrM759_COUNT)
#           define SETUP_XfOrM760(x) SETUP_XfOrM759(x)

# 3330 "bc/src/resolve.c"
            val = FUNCCALL(SETUP_XfOrM760(_), push_to_rhs_sequence (push_rhs , val ) ); 
            push_rhs = scheme_null ; 
          }
          irlv -> value = val ; 
          irlv -> vars = vars ; 
          FUNCCALL(SETUP_XfOrM759(_), attach_lv (((void * ) 0 ) , irlv , ((void * ) 0 ) , ((void * ) 0 ) , state ) ); 
          i ++ ; 
        }
        o = lr -> body ; 
        break ; 
      }
      case scheme_sequence_type : {
        Scheme_Sequence * seq = (Scheme_Sequence * ) o ; 
        int i ; 
        BLOCK_SETUP((PUSH(seq, 0+XfOrM749_COUNT)));
#       define XfOrM751_COUNT (1+XfOrM749_COUNT)
#       define SETUP_XfOrM751(x) SETUP(XfOrM751_COUNT)

# 3344 "bc/src/resolve.c"
        for (i = 0 ; i < seq -> count - 1 ; i ++ ) {
#         define XfOrM754_COUNT (0+XfOrM751_COUNT)
#         define SETUP_XfOrM754(x) SETUP_XfOrM751(x)

# 3345 "bc/src/resolve.c"
          if (! ((Scheme_Type ) (((((intptr_t ) (seq -> array [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (seq -> array [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_local_type ) ) ) {
#           define XfOrM755_COUNT (0+XfOrM754_COUNT)
#           define SETUP_XfOrM755(x) SETUP_XfOrM754(x)

# 3346 "bc/src/resolve.c"
            push_rhs = (__funcarg69 = FUNCCALL(SETUP_XfOrM755(_), unresolve_expr (seq -> array [i ] , ui , 0 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg69 , push_rhs ) )) ; 
          }
        }
        o = seq -> array [seq -> count - 1 ] ; 
        break ; 
      }
      default : {
#       define XfOrM750_COUNT (0+XfOrM749_COUNT)
#       define SETUP_XfOrM750(x) SETUP_XfOrM749(x)
        FUNCCALL(SETUP_XfOrM750(_), scheme_signal_error ("internal error: unexpected form in let-void: %d" , ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) )
# 3353 "bc/src/resolve.c"
        ; 
      }
    }
  }

  o = FUNCCALL(SETUP_XfOrM730(_), unresolve_expr (o , ui , 0 ) ); 
  if (! o )

# 3359 "bc/src/resolve.c"
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  FUNCCALL(SETUP_XfOrM730(_), attach_lv (((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , o , state ) ); 

  (void ) FUNCCALL(SETUP_XfOrM730(_), unresolve_stack_pop (ui , pos , 0 ) ); 

  RET_VALUE_START ((Scheme_Object * ) lh ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3367 "bc/src/resolve.c"
static Scheme_Object * unresolve_closure (Scheme_Object * e , Unresolve_Info * ui ) 
{
  Scheme_Object * r , * c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(c, 1), PUSH(r, 2), PUSH(ui, 3)));
# define XfOrM765_COUNT (4)
# define SETUP_XfOrM765(x) SETUP(XfOrM765_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  r = NULLED_OUT ; 
  c = NULLED_OUT ; 

# 3371 "bc/src/resolve.c"
  if (ui -> closures )
    c = FUNCCALL(SETUP_XfOrM765(_), scheme_hash_get (ui -> closures , e ) ); 
  else 
  c = ((void * ) 0 ) ; 

  if (ui -> inlining ) {
#   define XfOrM767_COUNT (0+XfOrM765_COUNT)
#   define SETUP_XfOrM767(x) SETUP_XfOrM765(x)

# 3378 "bc/src/resolve.c"
    if (c )

# 3378 "bc/src/resolve.c"
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    if (! ui -> closures ) {
      Scheme_Hash_Table * ht ; 
      BLOCK_SETUP((PUSH(ht, 0+XfOrM767_COUNT)));
#     define XfOrM768_COUNT (1+XfOrM767_COUNT)
#     define SETUP_XfOrM768(x) SETUP(XfOrM768_COUNT)
      ht = NULLED_OUT ; 

# 3381 "bc/src/resolve.c"
      ht = FUNCCALL(SETUP_XfOrM768(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      ui -> closures = ht ; 
    }
    FUNCCALL(SETUP_XfOrM767(_), scheme_hash_set (ui -> closures , e , scheme_true ) ); 
  }

# 3385 "bc/src/resolve.c"
  else {
    if (c && ((Scheme_Type ) (((((intptr_t ) (c ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (c ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) )
      RET_VALUE_START (c ) RET_VALUE_END ; 
  }

  r = FUNCCALL(SETUP_XfOrM765(_), unresolve_lambda (((Scheme_Closure * ) e ) -> code , ui ) ); 

  if (ui -> inlining )
    FUNCCALL(SETUP_XfOrM765(_), scheme_hash_set (ui -> closures , e , ((void * ) 0 ) ) ); 

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3398 "bc/src/resolve.c"
static Scheme_Object * unresolve_let_value (Scheme_Let_Value * lv , Unresolve_Info * ui , 
Scheme_Object * val , Scheme_Object * body ) {
  Scheme_Set_Bang * sb ; 
  Scheme_IR_Local * var ; 
  Scheme_Sequence * seq ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(var, 0), PUSH(sb, 1), PUSH(seq, 2), PUSH(ui, 3), PUSH(body, 4), PUSH(val, 5), PUSH(lv, 6)));
# define XfOrM769_COUNT (7)
# define SETUP_XfOrM769(x) SETUP(XfOrM769_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  sb = NULLED_OUT ; 
  var = NULLED_OUT ; 
  seq = NULLED_OUT ; 

# 3404 "bc/src/resolve.c"
  ; 

  if (! lv -> count ) {

    Scheme_IR_Let_Header * head ; 
    Scheme_IR_Let_Value * irlv ; 
    BLOCK_SETUP((PUSH(head, 0+XfOrM769_COUNT), PUSH(irlv, 1+XfOrM769_COUNT)));
#   define XfOrM771_COUNT (2+XfOrM769_COUNT)
#   define SETUP_XfOrM771(x) SETUP(XfOrM771_COUNT)
    head = NULLED_OUT ; 
    irlv = NULLED_OUT ; 

# 3411 "bc/src/resolve.c"
    head = FUNCCALL(SETUP_XfOrM771(_), make_let_header (0 ) ); 
    head -> num_clauses = 1 ; 
    irlv = FUNCCALL(SETUP_XfOrM771(_), make_ir_let_value (0 ) ); 
    head -> body = (Scheme_Object * ) irlv ; 
    irlv -> value = val ; 
    irlv -> body = body ; 

    RET_VALUE_START ((Scheme_Object * ) head ) RET_VALUE_END ; 
  }

  var = FUNCCALL(SETUP_XfOrM769(_), unresolve_lookup (ui , lv -> position , 0 ) ); 

  if (var -> is_ref_arg ) {
    Scheme_App2_Rec * app2 ; 
    BLOCK_SETUP((PUSH(app2, 0+XfOrM769_COUNT)));
#   define XfOrM770_COUNT (1+XfOrM769_COUNT)
#   define SETUP_XfOrM770(x) SETUP(XfOrM770_COUNT)
    app2 = NULLED_OUT ; 

# 3425 "bc/src/resolve.c"
    app2 = ((Scheme_App2_Rec * ) FUNCCALL(SETUP_XfOrM770(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App2_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    app2 -> iso . so . type = scheme_application2_type ; 
    app2 -> rator = (Scheme_Object * ) var ; 
    app2 -> rand = val ; 
    seq = FUNCCALL(SETUP_XfOrM770(_), scheme_malloc_sequence (2 ) ); 
    seq -> so . type = scheme_sequence_type ; 
    seq -> count = 2 ; 
    seq -> array [0 ] = (Scheme_Object * ) app2 ; 
    seq -> array [1 ] = body ; 
    RET_VALUE_START ((Scheme_Object * ) seq ) RET_VALUE_END ; 
  }

  var -> mutated = 1 ; 

  sb = ((Scheme_Set_Bang * ) FUNCCALL(SETUP_XfOrM769(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Set_Bang ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  sb -> so . type = scheme_set_bang_type ; 
  sb -> var = (Scheme_Object * ) var ; 
  sb -> val = val ; 

  seq = FUNCCALL(SETUP_XfOrM769(_), scheme_malloc_sequence (2 ) ); 
  seq -> so . type = scheme_sequence_type ; 
  seq -> count = 2 ; 
  seq -> array [0 ] = (Scheme_Object * ) sb ; 
  seq -> array [1 ] = body ; 

  RET_VALUE_START ((Scheme_Object * ) seq ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3453 "bc/src/resolve.c"
static Scheme_Object * maybe_unresolve_app_refs (Scheme_Object * rator , 
Scheme_App_Rec * app , 
Scheme_App2_Rec * app2 , 
Scheme_App3_Rec * app3 , 
Unresolve_Info * ui ) 
{
  Scheme_Lambda * lam = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(19);
  BLOCK_SETUP_TOP((PUSH(ui, 0), PUSH(rator, 1), PUSH(app3, 2), PUSH(app, 3), PUSH(lam, 4), PUSH(app2, 5)));
# define XfOrM772_COUNT (6)
# define SETUP_XfOrM772(x) SETUP(XfOrM772_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3461 "bc/src/resolve.c"
  if (((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) 
  && ((& ((((Scheme_Closure * ) rator ) -> code ) ) -> iso ) -> so . keyex & 2 ) ) {
    lam = ((Scheme_Closure * ) rator ) -> code ; 
  }

# 3464 "bc/src/resolve.c"
  else if (((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) ) {
#   define XfOrM786_COUNT (0+XfOrM772_COUNT)
#   define SETUP_XfOrM786(x) SETUP_XfOrM772(x)

# 3466 "bc/src/resolve.c"
    lam = (Scheme_Lambda * ) FUNCCALL(SETUP_XfOrM786(_), scheme_hash_get (ui -> ref_lifts , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((Scheme_Toplevel * ) (rator ) ) -> position ) ) ) ) << 1 ) | 0x1 ) ) ) ); 
  }

  if (lam ) {
    Scheme_App_Rec * new_app = ((void * ) 0 ) ; 
    Scheme_App2_Rec * new_app2 = ((void * ) 0 ) ; 
    Scheme_App3_Rec * new_app3 = ((void * ) 0 ) ; 
    Scheme_Object * arg ; 
    Scheme_Object * new_rator ; 
    int i ; 
    BLOCK_SETUP((PUSH(new_app3, 0+XfOrM772_COUNT), PUSH(new_app2, 1+XfOrM772_COUNT), PUSH(new_app, 2+XfOrM772_COUNT), PUSH(arg, 3+XfOrM772_COUNT), PUSH(new_rator, 4+XfOrM772_COUNT)));
#   define XfOrM773_COUNT (5+XfOrM772_COUNT)
#   define SETUP_XfOrM773(x) SETUP(XfOrM773_COUNT)
    arg = NULLED_OUT ; 
    new_rator = NULLED_OUT ; 

# 3477 "bc/src/resolve.c"
    if (app ) {
#     define XfOrM785_COUNT (0+XfOrM773_COUNT)
#     define SETUP_XfOrM785(x) SETUP_XfOrM773(x)

# 3478 "bc/src/resolve.c"
      if (lam -> num_params != app -> num_args )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      new_app = FUNCCALL(SETUP_XfOrM785(_), scheme_malloc_application (app -> num_args + 1 ) ); 
    }

# 3481 "bc/src/resolve.c"
    else if (app2 ) {
#     define XfOrM784_COUNT (0+XfOrM773_COUNT)
#     define SETUP_XfOrM784(x) SETUP_XfOrM773(x)

# 3482 "bc/src/resolve.c"
      if (lam -> num_params != 1 )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      new_app2 = ((Scheme_App2_Rec * ) FUNCCALL(SETUP_XfOrM784(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App2_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      new_app2 -> iso . so . type = scheme_application2_type ; 
    }

# 3486 "bc/src/resolve.c"
    else {
#     define XfOrM783_COUNT (0+XfOrM773_COUNT)
#     define SETUP_XfOrM783(x) SETUP_XfOrM773(x)

# 3487 "bc/src/resolve.c"
      if (lam -> num_params != 2 )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      new_app3 = ((Scheme_App3_Rec * ) FUNCCALL(SETUP_XfOrM783(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App3_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      new_app3 -> iso . so . type = scheme_application3_type ; 
    }

    ; 
    for (i = 0 ; i < lam -> num_params ; i ++ ) {
#     define XfOrM780_COUNT (0+XfOrM773_COUNT)
#     define SETUP_XfOrM780(x) SETUP_XfOrM773(x)

# 3495 "bc/src/resolve.c"
      if (app )
        arg = app -> args [i + 1 ] ; 
      else if (app2 )
        arg = app2 -> rand ; 
      else if (i )
        arg = app3 -> rand2 ; 
      else 
      arg = app3 -> rand1 ; 
      ; 
      ; 
      if (((scheme_boxmap_get (lam -> closure_map , i , lam -> closure_size ) ) == 1 ) 
      && ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_local_type ) ) 
      && ! ui -> vars [ui -> stack_pos - (((Scheme_Local * ) (arg ) ) -> position ) - 1 ] -> is_ref_arg ) {
        Scheme_Case_Lambda * cl ; 
        Scheme_Lambda * d0 , * d1 ; 
        Scheme_Set_Bang * sb ; 
        Scheme_Object * s ; 
        Scheme_IR_Local * arg_var ; 
        int pos ; 
        Scheme_IR_Local * * vars ; 
        Scheme_IR_Lambda_Info * ci ; 
        BLOCK_SETUP((PUSH(s, 0+XfOrM780_COUNT), PUSH(sb, 1+XfOrM780_COUNT), PUSH(vars, 2+XfOrM780_COUNT), PUSH(arg_var, 3+XfOrM780_COUNT), PUSH(ci, 4+XfOrM780_COUNT), PUSH(d0, 5+XfOrM780_COUNT), PUSH(d1, 6+XfOrM780_COUNT), PUSH(cl, 7+XfOrM780_COUNT)));
#       define XfOrM782_COUNT (8+XfOrM780_COUNT)
#       define SETUP_XfOrM782(x) SETUP(XfOrM782_COUNT)
        cl = NULLED_OUT ; 
        d0 = NULLED_OUT ; 
        d1 = NULLED_OUT ; 
        sb = NULLED_OUT ; 
        s = NULLED_OUT ; 
        arg_var = NULLED_OUT ; 
        vars = NULLED_OUT ; 
        ci = NULLED_OUT ; 

# 3516 "bc/src/resolve.c"
        ; 

        cl = (Scheme_Case_Lambda * ) FUNCCALL(SETUP_XfOrM782(_), GC_malloc_one_tagged (sizeof (Scheme_Case_Lambda ) + ((2 - 0 ) * sizeof (Scheme_Object * ) ) ) )
        ; 

        cl -> so . type = scheme_case_lambda_sequence_type ; 
        cl -> count = 2 ; 
        s = FUNCCALL(SETUP_XfOrM782(_), scheme_make_symbol ("cl" ) ); 
        s = FUNCCALL_AGAIN(scheme_gensym (s ) ); 
        cl -> name = s ; 

        arg_var = FUNCCALL(SETUP_XfOrM782(_), unresolve_lookup (ui , (((Scheme_Local * ) (arg ) ) -> position ) , 0 ) ); 
        arg_var -> mutated = 1 ; 

        d0 = ((Scheme_Lambda * ) FUNCCALL(SETUP_XfOrM782(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Lambda ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        d0 -> iso . so . type = scheme_ir_lambda_type ; 
        d0 -> num_params = 0 ; 
        d0 -> body = (Scheme_Object * ) arg_var ; 
        ci = ((Scheme_IR_Lambda_Info * ) FUNCCALL(SETUP_XfOrM782(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Lambda_Info ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        ci -> type = scheme_rt_ir_lambda_info ; 
        d0 -> ir_info = ci ; 
        s = FUNCCALL(SETUP_XfOrM782(_), scheme_make_symbol ("d0" ) ); 
        s = FUNCCALL_AGAIN(scheme_gensym (s ) ); 
        d0 -> name = s ; 
        cl -> array [0 ] = (Scheme_Object * ) d0 ; 

        pos = FUNCCALL(SETUP_XfOrM782(_), unresolve_stack_push (ui , 1 , 1 ) ); 
        vars = FUNCCALL_AGAIN(unresolve_stack_pop (ui , pos , 1 ) ); 

        d1 = ((Scheme_Lambda * ) FUNCCALL(SETUP_XfOrM782(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Lambda ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        d1 -> iso . so . type = scheme_ir_lambda_type ; 
        d1 -> num_params = 1 ; 

        sb = ((Scheme_Set_Bang * ) FUNCCALL(SETUP_XfOrM782(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Set_Bang ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        sb -> so . type = scheme_set_bang_type ; 
        sb -> var = (Scheme_Object * ) arg_var ; 
        sb -> val = (Scheme_Object * ) vars [0 ] ; 
        d1 -> body = (Scheme_Object * ) sb ; 
        ci = ((Scheme_IR_Lambda_Info * ) FUNCCALL(SETUP_XfOrM782(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Lambda_Info ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        ci -> type = scheme_rt_ir_lambda_info ; 
        ci -> vars = vars ; 
        vars [0 ] -> use_count = 1 ; 
        vars [0 ] -> non_app_count = 1 ; 
        d1 -> ir_info = ci ; 


        s = FUNCCALL(SETUP_XfOrM782(_), scheme_make_symbol ("d1" ) ); 
        s = FUNCCALL_AGAIN(scheme_gensym (s ) ); 
        d1 -> name = s ; 
        cl -> array [1 ] = (Scheme_Object * ) d1 ; 

        arg = (Scheme_Object * ) cl ; 
      }

# 3568 "bc/src/resolve.c"
      else {
#       define XfOrM781_COUNT (0+XfOrM780_COUNT)
#       define SETUP_XfOrM781(x) SETUP_XfOrM780(x)

# 3569 "bc/src/resolve.c"
        arg = FUNCCALL(SETUP_XfOrM781(_), unresolve_expr (arg , ui , 0 ) ); 
      }

      if (new_app )
        new_app -> args [i + 1 ] = arg ; 
      else if (new_app2 )
        new_app2 -> rand = arg ; 
      else if (i )
        new_app3 -> rand2 = arg ; 
      else 
      new_app3 -> rand1 = arg ; 
    }
    new_rator = FUNCCALL(SETUP_XfOrM773(_), unresolve_expr (rator , ui , 0 ) ); 

    if (new_app ) {
      new_app -> args [0 ] = new_rator ; 
      RET_VALUE_START ((Scheme_Object * ) new_app ) RET_VALUE_END ; 
    }

# 3586 "bc/src/resolve.c"
    else if (new_app2 ) {
      new_app2 -> rator = new_rator ; 
      RET_VALUE_START ((Scheme_Object * ) new_app2 ) RET_VALUE_END ; 
    }

# 3589 "bc/src/resolve.c"
    else {
      new_app3 -> rator = new_rator ; 
      RET_VALUE_START ((Scheme_Object * ) new_app3 ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3598 "bc/src/resolve.c"
static Scheme_Object * unresolve_expr_k (void ) 
{
  /* No conversion */

# 3600 "bc/src/resolve.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * e = (Scheme_Object * ) p -> ku . k . p1 ; 
  Unresolve_Info * ui = (Unresolve_Info * ) p -> ku . k . p2 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 

  return unresolve_expr (e , ui , p -> ku . k . i1 ) ; 
}

static Scheme_Object * unresolve_expr (Scheme_Object * e , Unresolve_Info * ui , int as_rator ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(ui, 1)));
# define XfOrM789_COUNT (2)
# define SETUP_XfOrM789(x) SETUP(XfOrM789_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3613 "bc/src/resolve.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM832_COUNT (0+XfOrM789_COUNT)
#   define SETUP_XfOrM832(x) SETUP_XfOrM789(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 3615 "bc/src/resolve.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM833_COUNT (0+XfOrM832_COUNT)
#     define SETUP_XfOrM833(x) SETUP_XfOrM832(x)

# 3618 "bc/src/resolve.c"
      p -> ku . k . p1 = (void * ) e ; 
      p -> ku . k . p2 = (void * ) ui ; 
      p -> ku . k . i1 = as_rator ; 

      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (unresolve_expr_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  ui -> body_size ++ ; 

  switch (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) {
#   define XfOrM790_COUNT (0+XfOrM789_COUNT)
#   define SETUP_XfOrM790(x) SETUP_XfOrM789(x)

# 3630 "bc/src/resolve.c"
    case scheme_local_type : 
    RET_VALUE_START ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM790(_), unresolve_lookup (ui , (((Scheme_Local * ) (e ) ) -> position ) , as_rator ) )) RET_VALUE_END ; 
    case scheme_local_unbox_type : 
    {
      Scheme_IR_Local * var ; 
      BLOCK_SETUP((PUSH(var, 0+XfOrM790_COUNT)));
#     define XfOrM830_COUNT (1+XfOrM790_COUNT)
#     define SETUP_XfOrM830(x) SETUP(XfOrM830_COUNT)
      var = NULLED_OUT ; 

# 3635 "bc/src/resolve.c"
      var = FUNCCALL(SETUP_XfOrM830(_), unresolve_lookup (ui , (((Scheme_Local * ) (e ) ) -> position ) , as_rator ) ); 
      if (var -> is_ref_arg ) {
        Scheme_App_Rec * app ; 
        BLOCK_SETUP((PUSH(app, 0+XfOrM830_COUNT)));
#       define XfOrM831_COUNT (1+XfOrM830_COUNT)
#       define SETUP_XfOrM831(x) SETUP(XfOrM831_COUNT)
        app = NULLED_OUT ; 

# 3638 "bc/src/resolve.c"
        ; 
        app = FUNCCALL(SETUP_XfOrM831(_), scheme_malloc_application (1 ) ); 
        app -> args [0 ] = (Scheme_Object * ) var ; 
        RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
      }
      RET_VALUE_START ((Scheme_Object * ) var ) RET_VALUE_END ; 
    }
    case scheme_sequence_type : 
    case scheme_begin0_sequence_type : 
    {
      Scheme_Sequence * seq = (Scheme_Sequence * ) e , * seq2 ; 
      int i ; 
      BLOCK_SETUP((PUSH(seq2, 0+XfOrM790_COUNT), PUSH(seq, 1+XfOrM790_COUNT)));
#     define XfOrM827_COUNT (2+XfOrM790_COUNT)
#     define SETUP_XfOrM827(x) SETUP(XfOrM827_COUNT)
      seq2 = NULLED_OUT ; 

# 3651 "bc/src/resolve.c"
      seq2 = FUNCCALL(SETUP_XfOrM827(_), scheme_malloc_sequence (seq -> count ) ); 
      seq2 -> so . type = seq -> so . type ; 
      seq2 -> count = seq -> count ; 
      for (i = seq -> count ; i -- ; ) {
#       define XfOrM829_COUNT (0+XfOrM827_COUNT)
#       define SETUP_XfOrM829(x) SETUP_XfOrM827(x)

# 3655 "bc/src/resolve.c"
        e = FUNCCALL(SETUP_XfOrM829(_), unresolve_expr (seq -> array [i ] , ui , 0 ) ); 
        if (! e )

# 3656 "bc/src/resolve.c"
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        seq2 -> array [i ] = e ; 
      }

      RET_VALUE_START ((Scheme_Object * ) seq2 ) RET_VALUE_END ; 
    }
    break ; 
    case scheme_application_type : 
    {
      Scheme_App_Rec * app = (Scheme_App_Rec * ) e , * app2 ; 
      Scheme_Object * a ; 
      int pos , i ; 
      BLOCK_SETUP((PUSH(a, 0+XfOrM790_COUNT), PUSH(app, 1+XfOrM790_COUNT), PUSH(app2, 2+XfOrM790_COUNT)));
#     define XfOrM823_COUNT (3+XfOrM790_COUNT)
#     define SETUP_XfOrM823(x) SETUP(XfOrM823_COUNT)
      app2 = NULLED_OUT ; 
      a = NULLED_OUT ; 

# 3669 "bc/src/resolve.c"
      ui -> body_size += app -> num_args ; 
      FUNCCALL(SETUP_XfOrM823(_), check_nonleaf_rator (app -> args [0 ] , ui ) ); 

      pos = FUNCCALL_AGAIN(unresolve_stack_push (ui , app -> num_args , 0 ) ); 

      e = FUNCCALL_AGAIN(maybe_unresolve_app_refs (app -> args [0 ] , app , ((void * ) 0 ) , ((void * ) 0 ) , ui ) ); 
      if (e ) {
#       define XfOrM826_COUNT (0+XfOrM823_COUNT)
#       define SETUP_XfOrM826(x) SETUP_XfOrM823(x)

# 3676 "bc/src/resolve.c"
        (void ) FUNCCALL(SETUP_XfOrM826(_), unresolve_stack_pop (ui , pos , 0 ) ); 
        RET_VALUE_START (e ) RET_VALUE_END ; 
      }

      app2 = FUNCCALL(SETUP_XfOrM823(_), scheme_malloc_application (app -> num_args + 1 ) ); 

      for (i = app -> num_args + 1 ; i -- ; ) {
#       define XfOrM825_COUNT (0+XfOrM823_COUNT)
#       define SETUP_XfOrM825(x) SETUP_XfOrM823(x)

# 3683 "bc/src/resolve.c"
        a = FUNCCALL(SETUP_XfOrM825(_), unresolve_expr (app -> args [i ] , ui , ! i ) ); 
        if (! a )

# 3684 "bc/src/resolve.c"
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        app2 -> args [i ] = a ; 
      }

      (void ) FUNCCALL(SETUP_XfOrM823(_), unresolve_stack_pop (ui , pos , 0 ) ); 

      RET_VALUE_START ((Scheme_Object * ) app2 ) RET_VALUE_END ; 
    }
    case scheme_application2_type : 
    {
      Scheme_App2_Rec * app = (Scheme_App2_Rec * ) e , * app2 ; 
      Scheme_Object * rator , * rand ; 
      int pos ; 
      BLOCK_SETUP((PUSH(app2, 0+XfOrM790_COUNT), PUSH(app, 1+XfOrM790_COUNT), PUSH(rand, 2+XfOrM790_COUNT), PUSH(rator, 3+XfOrM790_COUNT)));
#     define XfOrM821_COUNT (4+XfOrM790_COUNT)
#     define SETUP_XfOrM821(x) SETUP(XfOrM821_COUNT)
      app2 = NULLED_OUT ; 
      rator = NULLED_OUT ; 
      rand = NULLED_OUT ; 

# 3698 "bc/src/resolve.c"
      ui -> body_size += 1 ; 
      FUNCCALL(SETUP_XfOrM821(_), check_nonleaf_rator (app -> rator , ui ) ); 

      pos = FUNCCALL_AGAIN(unresolve_stack_push (ui , 1 , 0 ) ); 

      e = FUNCCALL_AGAIN(maybe_unresolve_app_refs (app -> rator , ((void * ) 0 ) , app , ((void * ) 0 ) , ui ) ); 
      if (e ) {
#       define XfOrM822_COUNT (0+XfOrM821_COUNT)
#       define SETUP_XfOrM822(x) SETUP_XfOrM821(x)

# 3705 "bc/src/resolve.c"
        (void ) FUNCCALL(SETUP_XfOrM822(_), unresolve_stack_pop (ui , pos , 0 ) ); 
        RET_VALUE_START (e ) RET_VALUE_END ; 
      }

      rator = FUNCCALL(SETUP_XfOrM821(_), unresolve_expr (app -> rator , ui , 1 ) ); 
      if (! rator )

# 3710 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      rand = FUNCCALL(SETUP_XfOrM821(_), unresolve_expr (app -> rand , ui , 0 ) ); 
      if (! rand )

# 3712 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      (void ) FUNCCALL(SETUP_XfOrM821(_), unresolve_stack_pop (ui , pos , 0 ) ); 

      app2 = ((Scheme_App2_Rec * ) FUNCCALL(SETUP_XfOrM821(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App2_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      app2 -> iso . so . type = scheme_application2_type ; 
      app2 -> rator = rator ; 
      app2 -> rand = rand ; 

      RET_VALUE_START ((Scheme_Object * ) app2 ) RET_VALUE_END ; 
    }
    case scheme_application3_type : 
    {
      Scheme_App3_Rec * app = (Scheme_App3_Rec * ) e , * app2 ; 
      Scheme_Object * rator , * rand1 , * rand2 ; 
      int pos ; 
      BLOCK_SETUP((PUSH(rand2, 0+XfOrM790_COUNT), PUSH(rand1, 1+XfOrM790_COUNT), PUSH(app, 2+XfOrM790_COUNT), PUSH(app2, 3+XfOrM790_COUNT), PUSH(rator, 4+XfOrM790_COUNT)));
#     define XfOrM819_COUNT (5+XfOrM790_COUNT)
#     define SETUP_XfOrM819(x) SETUP(XfOrM819_COUNT)
      app2 = NULLED_OUT ; 
      rator = NULLED_OUT ; 
      rand1 = NULLED_OUT ; 
      rand2 = NULLED_OUT ; 

# 3729 "bc/src/resolve.c"
      ui -> body_size += 2 ; 
      FUNCCALL(SETUP_XfOrM819(_), check_nonleaf_rator (app -> rator , ui ) ); 

      pos = FUNCCALL_AGAIN(unresolve_stack_push (ui , 2 , 0 ) ); 

      e = FUNCCALL_AGAIN(maybe_unresolve_app_refs (app -> rator , ((void * ) 0 ) , ((void * ) 0 ) , app , ui ) ); 
      if (e ) {
#       define XfOrM820_COUNT (0+XfOrM819_COUNT)
#       define SETUP_XfOrM820(x) SETUP_XfOrM819(x)

# 3736 "bc/src/resolve.c"
        (void ) FUNCCALL(SETUP_XfOrM820(_), unresolve_stack_pop (ui , pos , 0 ) ); 
        RET_VALUE_START (e ) RET_VALUE_END ; 
      }

      rator = FUNCCALL(SETUP_XfOrM819(_), unresolve_expr (app -> rator , ui , 1 ) ); 
      if (! rator )

# 3741 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      rand1 = FUNCCALL(SETUP_XfOrM819(_), unresolve_expr (app -> rand1 , ui , 0 ) ); 
      if (! rand1 )

# 3743 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      rand2 = FUNCCALL(SETUP_XfOrM819(_), unresolve_expr (app -> rand2 , ui , 0 ) ); 
      if (! rand2 )

# 3745 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      (void ) FUNCCALL(SETUP_XfOrM819(_), unresolve_stack_pop (ui , pos , 0 ) ); 

      app2 = ((Scheme_App3_Rec * ) FUNCCALL(SETUP_XfOrM819(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App3_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      app2 -> iso . so . type = scheme_application3_type ; 
      app2 -> rator = rator ; 
      app2 -> rand1 = rand1 ; 
      app2 -> rand2 = rand2 ; 

      RET_VALUE_START ((Scheme_Object * ) app2 ) RET_VALUE_END ; 
    }
    case scheme_branch_type : 
    {
      Scheme_Branch_Rec * b = (Scheme_Branch_Rec * ) e , * b2 ; 
      Scheme_Object * tst , * thn , * els ; 
      BLOCK_SETUP((PUSH(b, 0+XfOrM790_COUNT), PUSH(tst, 1+XfOrM790_COUNT), PUSH(thn, 2+XfOrM790_COUNT), PUSH(b2, 3+XfOrM790_COUNT), PUSH(els, 4+XfOrM790_COUNT)));
#     define XfOrM818_COUNT (5+XfOrM790_COUNT)
#     define SETUP_XfOrM818(x) SETUP(XfOrM818_COUNT)
      b2 = NULLED_OUT ; 
      tst = NULLED_OUT ; 
      thn = NULLED_OUT ; 
      els = NULLED_OUT ; 

# 3762 "bc/src/resolve.c"
      tst = FUNCCALL(SETUP_XfOrM818(_), unresolve_expr (b -> test , ui , 0 ) ); 
      if (! tst )

# 3763 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      thn = FUNCCALL(SETUP_XfOrM818(_), unresolve_expr (b -> tbranch , ui , 0 ) ); 
      if (! thn )

# 3765 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      els = FUNCCALL(SETUP_XfOrM818(_), unresolve_expr (b -> fbranch , ui , 0 ) ); 
      if (! els )

# 3767 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      b2 = ((Scheme_Branch_Rec * ) FUNCCALL(SETUP_XfOrM818(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Branch_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      b2 -> so . type = scheme_branch_type ; 
      b2 -> test = tst ; 
      b2 -> tbranch = thn ; 
      b2 -> fbranch = els ; 

      RET_VALUE_START ((Scheme_Object * ) b2 ) RET_VALUE_END ; 
    }
    case scheme_with_cont_mark_type : 
    {
      Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) e , * wcm2 ; 
      Scheme_Object * k , * v , * b ; 
      BLOCK_SETUP((PUSH(b, 0+XfOrM790_COUNT), PUSH(wcm2, 1+XfOrM790_COUNT), PUSH(v, 2+XfOrM790_COUNT), PUSH(wcm, 3+XfOrM790_COUNT), PUSH(k, 4+XfOrM790_COUNT)));
#     define XfOrM817_COUNT (5+XfOrM790_COUNT)
#     define SETUP_XfOrM817(x) SETUP(XfOrM817_COUNT)
      wcm2 = NULLED_OUT ; 
      k = NULLED_OUT ; 
      v = NULLED_OUT ; 
      b = NULLED_OUT ; 

# 3782 "bc/src/resolve.c"
      k = FUNCCALL(SETUP_XfOrM817(_), unresolve_expr (wcm -> key , ui , 0 ) ); 
      if (! k )

# 3783 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      v = FUNCCALL(SETUP_XfOrM817(_), unresolve_expr (wcm -> val , ui , 0 ) ); 
      if (! v )

# 3785 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      b = FUNCCALL(SETUP_XfOrM817(_), unresolve_expr (wcm -> body , ui , 0 ) ); 
      if (! b )

# 3787 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      wcm2 = ((Scheme_With_Continuation_Mark * ) FUNCCALL(SETUP_XfOrM817(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_With_Continuation_Mark ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      wcm2 -> so . type = scheme_with_cont_mark_type ; 
      wcm2 -> key = k ; 
      wcm2 -> val = v ; 
      wcm2 -> body = b ; 

      RET_VALUE_START ((Scheme_Object * ) wcm2 ) RET_VALUE_END ; 
    }
    case scheme_with_immed_mark_type : 
    {
      Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) e , * wcm2 ; 
      Scheme_Object * k , * v , * b ; 
      Scheme_IR_Local * * vars ; 
      int pos ; 
      BLOCK_SETUP((PUSH(b, 0+XfOrM790_COUNT), PUSH(vars, 1+XfOrM790_COUNT), PUSH(v, 2+XfOrM790_COUNT), PUSH(wcm, 3+XfOrM790_COUNT), PUSH(wcm2, 4+XfOrM790_COUNT), PUSH(k, 5+XfOrM790_COUNT)));
#     define XfOrM816_COUNT (6+XfOrM790_COUNT)
#     define SETUP_XfOrM816(x) SETUP(XfOrM816_COUNT)
      wcm2 = NULLED_OUT ; 
      k = NULLED_OUT ; 
      v = NULLED_OUT ; 
      b = NULLED_OUT ; 
      vars = NULLED_OUT ; 

# 3804 "bc/src/resolve.c"
      k = FUNCCALL(SETUP_XfOrM816(_), unresolve_expr (wcm -> key , ui , 0 ) ); 
      if (! k )

# 3805 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      v = FUNCCALL(SETUP_XfOrM816(_), unresolve_expr (wcm -> val , ui , 0 ) ); 
      if (! v )

# 3807 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      pos = FUNCCALL(SETUP_XfOrM816(_), unresolve_stack_push (ui , 1 , 1 ) ); 
      vars = FUNCCALL_AGAIN(unresolve_stack_extract (ui , 0 , 1 ) ); 
      b = FUNCCALL_AGAIN(unresolve_expr (wcm -> body , ui , 0 ) ); 
      if (! b )

# 3812 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      (void ) FUNCCALL(SETUP_XfOrM816(_), unresolve_stack_pop (ui , pos , 0 ) ); 

      wcm2 = ((Scheme_With_Continuation_Mark * ) FUNCCALL(SETUP_XfOrM816(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_With_Continuation_Mark ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      wcm2 -> so . type = scheme_with_immed_mark_type ; 
      wcm2 -> key = k ; 
      wcm2 -> val = v ; 
      b = FUNCCALL(SETUP_XfOrM816(_), scheme_make_raw_pair ((Scheme_Object * ) vars [0 ] , b ) ); 
      wcm2 -> body = b ; 

      RET_VALUE_START ((Scheme_Object * ) wcm2 ) RET_VALUE_END ; 
    }
    case scheme_let_void_type : 
    {
#     define XfOrM815_COUNT (0+XfOrM790_COUNT)
#     define SETUP_XfOrM815(x) SETUP_XfOrM790(x)

# 3826 "bc/src/resolve.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unresolve_let_void (e , ui ) )) RET_VALUE_EMPTY_END ; 
    }
    case scheme_let_one_type : 
    {
      Scheme_Let_One * lo = (Scheme_Let_One * ) e ; 
      Scheme_Object * rhs , * body ; 
      Scheme_IR_Let_Header * lh ; 
      Scheme_IR_Let_Value * irlv ; 
      Scheme_IR_Local * * vars ; 
      int pos ; 
      BLOCK_SETUP((PUSH(rhs, 0+XfOrM790_COUNT), PUSH(lo, 1+XfOrM790_COUNT), PUSH(body, 2+XfOrM790_COUNT), PUSH(vars, 3+XfOrM790_COUNT), PUSH(irlv, 4+XfOrM790_COUNT), PUSH(lh, 5+XfOrM790_COUNT)));
#     define XfOrM814_COUNT (6+XfOrM790_COUNT)
#     define SETUP_XfOrM814(x) SETUP(XfOrM814_COUNT)
      rhs = NULLED_OUT ; 
      body = NULLED_OUT ; 
      lh = NULLED_OUT ; 
      irlv = NULLED_OUT ; 
      vars = NULLED_OUT ; 

# 3837 "bc/src/resolve.c"
      pos = FUNCCALL(SETUP_XfOrM814(_), unresolve_stack_push (ui , 1 , 1 ) ); 
      rhs = FUNCCALL_AGAIN(unresolve_expr (lo -> value , ui , 0 ) ); 
      if (! rhs )

# 3839 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      body = FUNCCALL(SETUP_XfOrM814(_), unresolve_expr (lo -> body , ui , 0 ) ); 
      if (! body )

# 3842 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      vars = FUNCCALL(SETUP_XfOrM814(_), unresolve_stack_pop (ui , pos , 1 ) ); 

      lh = ((Scheme_IR_Let_Header * ) FUNCCALL(SETUP_XfOrM814(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Let_Header ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      lh -> iso . so . type = scheme_ir_let_header_type ; 
      lh -> count = 1 ; 
      lh -> num_clauses = 1 ; 

      irlv = ((Scheme_IR_Let_Value * ) FUNCCALL(SETUP_XfOrM814(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Let_Value ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      irlv -> iso . so . type = scheme_ir_let_value_type ; 
      irlv -> count = 1 ; 
      irlv -> value = rhs ; 
      irlv -> vars = vars ; 
      irlv -> body = body ; 

      lh -> body = (Scheme_Object * ) irlv ; 

      RET_VALUE_START ((Scheme_Object * ) lh ) RET_VALUE_END ; 
    }
    case scheme_closure_type : 
    {
#     define XfOrM813_COUNT (0+XfOrM790_COUNT)
#     define SETUP_XfOrM813(x) SETUP_XfOrM790(x)

# 3864 "bc/src/resolve.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unresolve_closure (e , ui ) )) RET_VALUE_EMPTY_END ; 
    }
    case scheme_lambda_type : 
    {
#     define XfOrM812_COUNT (0+XfOrM790_COUNT)
#     define SETUP_XfOrM812(x) SETUP_XfOrM790(x)

# 3868 "bc/src/resolve.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unresolve_lambda ((Scheme_Lambda * ) e , ui ) )) RET_VALUE_EMPTY_END ; 
    }
    case scheme_inline_variant_type : 
    {
      Scheme_Object * a ; 
      BLOCK_SETUP((PUSH(a, 0+XfOrM790_COUNT)));
#     define XfOrM811_COUNT (1+XfOrM790_COUNT)
#     define SETUP_XfOrM811(x) SETUP(XfOrM811_COUNT)
      a = NULLED_OUT ; 

# 3873 "bc/src/resolve.c"
      a = (((Scheme_Vector * ) (e ) ) -> els ) [0 ] ; 
      a = FUNCCALL(SETUP_XfOrM811(_), unresolve_expr (a , ui , 0 ) ); 
      if (! a )

# 3875 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      RET_VALUE_START (a ) RET_VALUE_END ; 
    }
    case scheme_define_values_type : 
    {
#     define XfOrM810_COUNT (0+XfOrM790_COUNT)
#     define SETUP_XfOrM810(x) SETUP_XfOrM790(x)

# 3880 "bc/src/resolve.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unresolve_define_values (e , ui ) )) RET_VALUE_EMPTY_END ; 
    }
    case scheme_set_bang_type : 
    {
      Scheme_Set_Bang * sb = (Scheme_Set_Bang * ) e , * sb2 ; 
      Scheme_Object * var , * val ; 
      BLOCK_SETUP((PUSH(var, 0+XfOrM790_COUNT), PUSH(sb, 1+XfOrM790_COUNT), PUSH(val, 2+XfOrM790_COUNT), PUSH(sb2, 3+XfOrM790_COUNT)));
#     define XfOrM807_COUNT (4+XfOrM790_COUNT)
#     define SETUP_XfOrM807(x) SETUP(XfOrM807_COUNT)
      sb2 = NULLED_OUT ; 
      var = NULLED_OUT ; 
      val = NULLED_OUT ; 

# 3886 "bc/src/resolve.c"
      var = FUNCCALL(SETUP_XfOrM807(_), unresolve_expr (sb -> var , ui , 0 ) ); 
      if (! var )

# 3887 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      if ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) )  {
        if (((Scheme_IR_Toplevel * ) var ) -> instance_pos != - 1 ) {

          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        (& (((Scheme_IR_Toplevel * ) var ) ) -> iso ) -> so . keyex |= 0x4 ; 
      }
      val = FUNCCALL(SETUP_XfOrM807(_), unresolve_expr (sb -> val , ui , 0 ) ); 
      if (! val )

# 3896 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      ; 

      sb2 = ((Scheme_Set_Bang * ) FUNCCALL(SETUP_XfOrM807(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Set_Bang ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      sb2 -> so . type = scheme_set_bang_type ; 
      sb2 -> var = var ; 
      sb2 -> val = val ; 
      sb2 -> set_undef = (ui -> comp_flags & 0x1 ) ; 
      RET_VALUE_START ((Scheme_Object * ) sb2 ) RET_VALUE_END ; 
    }
    case scheme_varref_form_type : 
    {
      Scheme_Object * a , * b , * o ; 
      BLOCK_SETUP((PUSH(b, 0+XfOrM790_COUNT), PUSH(a, 1+XfOrM790_COUNT), PUSH(o, 2+XfOrM790_COUNT)));
#     define XfOrM803_COUNT (3+XfOrM790_COUNT)
#     define SETUP_XfOrM803(x) SETUP(XfOrM803_COUNT)
      a = NULLED_OUT ; 
      b = NULLED_OUT ; 
      o = NULLED_OUT ; 

# 3910 "bc/src/resolve.c"
      a = (((Scheme_Simple_Object * ) (e ) ) -> u . two_ptr_val . ptr1 ) ; 
      a = FUNCCALL(SETUP_XfOrM803(_), unresolve_expr (a , ui , 0 ) ); 
      if (! a )

# 3912 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      ; 

      if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) )  {
        (& ((Scheme_IR_Toplevel * ) a ) -> iso ) -> so . keyex |= 0x4 ; 
      }

      b = (((Scheme_Simple_Object * ) (e ) ) -> u . two_ptr_val . ptr2 ) ; 
      ((void ) sizeof (((((b ) ) == (scheme_false ) ) || (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) && ! (((Scheme_Toplevel * ) (b ) ) -> position ) ) || (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) && ! (((Scheme_Toplevel * ) (b ) ) -> position ) ) ) ? 1 : 0 ) , __extension__ ({
#       define XfOrM805_COUNT (0+XfOrM803_COUNT)
#       define SETUP_XfOrM805(x) SETUP_XfOrM803(x)

# 3920 "bc/src/resolve.c" 3
        if ((((b ) ) == (scheme_false ) ) || (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) && ! (((Scheme_Toplevel * ) (b ) ) -> position ) ) || (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) && ! (((Scheme_Toplevel * ) (b ) ) -> position ) ) )

# 3920 "bc/src/resolve.c" 3
        ; 

# 3920 "bc/src/resolve.c" 3
        else FUNCCALL(SETUP_XfOrM805(_), __assert_fail ("(((b)) == (scheme_false)) || (((Scheme_Type)(((((intptr_t)(b)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(b))->type)) == (Scheme_Type)(scheme_toplevel_type)) && !(((Scheme_Toplevel *)(b))->position)) || (((Scheme_Type)(((((intptr_t)(b)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(b))->type)) == (Scheme_Type)(scheme_static_toplevel_type)) && !(((Scheme_Toplevel *)(b))->position))" , "bc/src/resolve.c" , 3920 , __extension__ __PRETTY_FUNCTION__ ) ); 
      }
      ) ) 

      ; 
      b = FUNCCALL(SETUP_XfOrM803(_), unresolve_expr (b , ui , 0 ) ); 
      if (! b )

# 3926 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      ((void ) sizeof (((((b ) ) == (scheme_false ) ) || (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) && (((Scheme_IR_Toplevel * ) b ) -> instance_pos == - 1 ) && (((Scheme_IR_Toplevel * ) b ) -> variable_pos == - 1 ) ) ) ? 1 : 0 ) , __extension__ ({
#       define XfOrM804_COUNT (0+XfOrM803_COUNT)
#       define SETUP_XfOrM804(x) SETUP_XfOrM803(x)

# 3927 "bc/src/resolve.c" 3
        if ((((b ) ) == (scheme_false ) ) || (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) && (((Scheme_IR_Toplevel * ) b ) -> instance_pos == - 1 ) && (((Scheme_IR_Toplevel * ) b ) -> variable_pos == - 1 ) ) )

# 3927 "bc/src/resolve.c" 3
        ; 

# 3927 "bc/src/resolve.c" 3
        else FUNCCALL(SETUP_XfOrM804(_), __assert_fail ("(((b)) == (scheme_false)) || (((Scheme_Type)(((((intptr_t)(b)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(b))->type)) == (Scheme_Type)(scheme_ir_toplevel_type)) && (((Scheme_IR_Toplevel *)b)->instance_pos == -1) && (((Scheme_IR_Toplevel *)b)->variable_pos == -1))" , "bc/src/resolve.c" , 3927 , __extension__ __PRETTY_FUNCTION__ ) ); 
      }
      ) ) ; 
      ; 

      o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM803(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      o -> type = scheme_varref_form_type ; 
      (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr1 ) = a ; 
      (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr2 ) = b ; 
      RET_VALUE_START (o ) RET_VALUE_END ; 
    }
    case scheme_apply_values_type : 
    {
#     define XfOrM802_COUNT (0+XfOrM790_COUNT)
#     define SETUP_XfOrM802(x) SETUP_XfOrM790(x)

# 3940 "bc/src/resolve.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unresolve_apply_values (e , ui ) )) RET_VALUE_EMPTY_END ; 
    }
    case scheme_boxenv_type : 
    {
#     define XfOrM801_COUNT (0+XfOrM790_COUNT)
#     define SETUP_XfOrM801(x) SETUP_XfOrM790(x)

# 3944 "bc/src/resolve.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unresolve_expr ((((Scheme_Simple_Object * ) (e ) ) -> u . two_ptr_val . ptr2 ) , ui , 0 ) )) RET_VALUE_EMPTY_END ; 
    }
    case scheme_toplevel_type : 
    case scheme_static_toplevel_type : 
    {
#     define XfOrM800_COUNT (0+XfOrM790_COUNT)
#     define SETUP_XfOrM800(x) SETUP_XfOrM790(x)

# 3949 "bc/src/resolve.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unresolve_toplevel (e , ui ) )) RET_VALUE_EMPTY_END ; 
    }
    case scheme_case_lambda_sequence_type : 
    {
      int i , cnt ; 
      Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) e , * cl2 ; 
      BLOCK_SETUP((PUSH(cl2, 0+XfOrM790_COUNT), PUSH(cl, 1+XfOrM790_COUNT)));
#     define XfOrM793_COUNT (2+XfOrM790_COUNT)
#     define SETUP_XfOrM793(x) SETUP(XfOrM793_COUNT)
      cl2 = NULLED_OUT ; 

# 3956 "bc/src/resolve.c"
      cl2 = (Scheme_Case_Lambda * ) FUNCCALL(SETUP_XfOrM793(_), GC_malloc_one_tagged (sizeof (Scheme_Case_Lambda ) + ((cl -> count - 0 ) * sizeof (Scheme_Object * ) ) ) )
      ; 
      cl2 -> so . type = scheme_case_lambda_sequence_type ; 
      cl2 -> count = cl -> count ; 
      cl2 -> name = cl -> name ; 

      cnt = cl -> count ; 

      for (i = 0 ; i < cnt ; i ++ ) {
        Scheme_Object * le ; 
        Scheme_Lambda * lam ; 
        BLOCK_SETUP((PUSH(le, 0+XfOrM793_COUNT), PUSH(lam, 1+XfOrM793_COUNT)));
#       define XfOrM797_COUNT (2+XfOrM793_COUNT)
#       define SETUP_XfOrM797(x) SETUP(XfOrM797_COUNT)
        le = NULLED_OUT ; 
        lam = NULLED_OUT ; 

# 3967 "bc/src/resolve.c"
        if ((Scheme_Type ) (((((intptr_t ) (cl -> array [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cl -> array [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {
          lam = ((Scheme_Closure * ) cl -> array [i ] ) -> code ; 
        }

# 3969 "bc/src/resolve.c"
        else {
          lam = (Scheme_Lambda * ) cl -> array [i ] ; 
        }

        le = FUNCCALL(SETUP_XfOrM797(_), unresolve_lambda (lam , ui ) ); 
        if (! le )

# 3974 "bc/src/resolve.c"
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

        cl2 -> array [i ] = le ; 
      }

      RET_VALUE_START ((Scheme_Object * ) cl2 ) RET_VALUE_END ; 
    }
    case scheme_let_value_type : 
    {
      Scheme_Let_Value * lv = (Scheme_Let_Value * ) e ; 
      Scheme_Object * val , * body ; 
      BLOCK_SETUP((PUSH(body, 0+XfOrM790_COUNT), PUSH(val, 1+XfOrM790_COUNT), PUSH(lv, 2+XfOrM790_COUNT)));
#     define XfOrM792_COUNT (3+XfOrM790_COUNT)
#     define SETUP_XfOrM792(x) SETUP(XfOrM792_COUNT)
      val = NULLED_OUT ; 
      body = NULLED_OUT ; 

# 3985 "bc/src/resolve.c"
      val = FUNCCALL(SETUP_XfOrM792(_), unresolve_expr (lv -> value , ui , 0 ) ); 
      if (! val )

# 3986 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      body = FUNCCALL(SETUP_XfOrM792(_), unresolve_expr (lv -> body , ui , 0 ) ); 
      if (! body )

# 3989 "bc/src/resolve.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(unresolve_let_value (lv , ui , val , body ) )) RET_VALUE_EMPTY_END ; 
    }
    default : 
    if (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) > _scheme_values_types_ ) {
#     define XfOrM791_COUNT (0+XfOrM790_COUNT)
#     define SETUP_XfOrM791(x) SETUP_XfOrM790(x)

# 3995 "bc/src/resolve.c"
      if (FUNCCALL(SETUP_XfOrM791(_), scheme_ir_duplicate_ok (e , 1 ) )|| ! ui -> inlining )
        RET_VALUE_START (e ) RET_VALUE_END ; 
      else if (ui -> inlining )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    FUNCCALL_EMPTY(scheme_signal_error ("internal error: no unresolve for: %d" , ((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4006 "bc/src/resolve.c"
void locate_cyclic_closures (Scheme_Object * e , Unresolve_Info * ui ) 
{
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(ui, 1)));
# define XfOrM834_COUNT (2)
# define SETUP_XfOrM834(x) SETUP(XfOrM834_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4008 "bc/src/resolve.c"
  switch (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) {
#   define XfOrM835_COUNT (0+XfOrM834_COUNT)
#   define SETUP_XfOrM835(x) SETUP_XfOrM834(x)

# 4009 "bc/src/resolve.c"
    case scheme_sequence_type : 
    case scheme_begin0_sequence_type : 
    {
      Scheme_Sequence * seq = (Scheme_Sequence * ) e ; 
      int i ; 
      BLOCK_SETUP((PUSH(seq, 0+XfOrM835_COUNT)));
#     define XfOrM865_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM865(x) SETUP(XfOrM865_COUNT)

# 4014 "bc/src/resolve.c"
      for (i = 0 ; i < seq -> count ; i ++ ) {
#       define XfOrM867_COUNT (0+XfOrM865_COUNT)
#       define SETUP_XfOrM867(x) SETUP_XfOrM865(x)
        FUNCCALL(SETUP_XfOrM867(_), locate_cyclic_closures (seq -> array [i ] , ui ) )
# 4015 "bc/src/resolve.c"
        ; 
      }
    }
    break ; 
    case scheme_application_type : 
    {
      Scheme_App_Rec * app = (Scheme_App_Rec * ) e ; 
      int i ; 
      BLOCK_SETUP((PUSH(app, 0+XfOrM835_COUNT)));
#     define XfOrM862_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM862(x) SETUP(XfOrM862_COUNT)

# 4023 "bc/src/resolve.c"
      for (i = 0 ; i < app -> num_args + 1 ; i ++ ) {
#       define XfOrM864_COUNT (0+XfOrM862_COUNT)
#       define SETUP_XfOrM864(x) SETUP_XfOrM862(x)
        FUNCCALL(SETUP_XfOrM864(_), locate_cyclic_closures (app -> args [i ] , ui ) )
# 4024 "bc/src/resolve.c"
        ; 
      }
    }
    break ; 
    case scheme_application2_type : 
    {
      Scheme_App2_Rec * app = (Scheme_App2_Rec * ) e ; 
      BLOCK_SETUP((PUSH(app, 0+XfOrM835_COUNT)));
#     define XfOrM861_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM861(x) SETUP(XfOrM861_COUNT)
      FUNCCALL(SETUP_XfOrM861(_), locate_cyclic_closures (app -> rator , ui ) )
# 4031 "bc/src/resolve.c"
      ; 
      FUNCCALL(SETUP_XfOrM861(_), locate_cyclic_closures (app -> rand , ui ) ); 
    }
    break ; 
    case scheme_application3_type : 
    {
      Scheme_App3_Rec * app = (Scheme_App3_Rec * ) e ; 
      BLOCK_SETUP((PUSH(app, 0+XfOrM835_COUNT)));
#     define XfOrM860_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM860(x) SETUP(XfOrM860_COUNT)
      FUNCCALL(SETUP_XfOrM860(_), locate_cyclic_closures (app -> rator , ui ) )
# 4038 "bc/src/resolve.c"
      ; 
      FUNCCALL(SETUP_XfOrM860(_), locate_cyclic_closures (app -> rand1 , ui ) ); 
      FUNCCALL_AGAIN(locate_cyclic_closures (app -> rand2 , ui ) ); 
    }
    break ; 
    case scheme_branch_type : 
    {
      Scheme_Branch_Rec * b = (Scheme_Branch_Rec * ) e ; 
      BLOCK_SETUP((PUSH(b, 0+XfOrM835_COUNT)));
#     define XfOrM859_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM859(x) SETUP(XfOrM859_COUNT)
      FUNCCALL(SETUP_XfOrM859(_), locate_cyclic_closures (b -> test , ui ) )
# 4046 "bc/src/resolve.c"
      ; 
      FUNCCALL(SETUP_XfOrM859(_), locate_cyclic_closures (b -> tbranch , ui ) ); 
      FUNCCALL_AGAIN(locate_cyclic_closures (b -> fbranch , ui ) ); 
    }
    break ; 
    case scheme_with_cont_mark_type : 
    case scheme_with_immed_mark_type : 
    {
      Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) e ; 
      BLOCK_SETUP((PUSH(wcm, 0+XfOrM835_COUNT)));
#     define XfOrM858_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM858(x) SETUP(XfOrM858_COUNT)
      FUNCCALL(SETUP_XfOrM858(_), locate_cyclic_closures (wcm -> key , ui ) )
# 4055 "bc/src/resolve.c"
      ; 
      FUNCCALL(SETUP_XfOrM858(_), locate_cyclic_closures (wcm -> val , ui ) ); 
      FUNCCALL_AGAIN(locate_cyclic_closures (wcm -> body , ui ) ); 
    }
    break ; 
    case scheme_let_void_type : 
    {
      Scheme_Let_Void * lv = (Scheme_Let_Void * ) e ; 
#     define XfOrM857_COUNT (0+XfOrM835_COUNT)
#     define SETUP_XfOrM857(x) SETUP_XfOrM835(x)
      FUNCCALL(SETUP_XfOrM857(_), locate_cyclic_closures (lv -> body , ui ) )
# 4063 "bc/src/resolve.c"
      ; 
    }
    break ; 
    case scheme_letrec_type : 
    {
      Scheme_Letrec * lr = (Scheme_Letrec * ) e ; 
      int i ; 
      BLOCK_SETUP((PUSH(lr, 0+XfOrM835_COUNT)));
#     define XfOrM854_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM854(x) SETUP(XfOrM854_COUNT)

# 4070 "bc/src/resolve.c"
      for (i = 0 ; i < lr -> count ; i ++ ) {
#       define XfOrM856_COUNT (0+XfOrM854_COUNT)
#       define SETUP_XfOrM856(x) SETUP_XfOrM854(x)
        FUNCCALL(SETUP_XfOrM856(_), locate_cyclic_closures (lr -> procs [i ] , ui ) )
# 4071 "bc/src/resolve.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM854(_), locate_cyclic_closures (lr -> body , ui ) ); 
    }
    break ; 
    case scheme_let_one_type : 
    {
      Scheme_Let_One * lo = (Scheme_Let_One * ) e ; 
      BLOCK_SETUP((PUSH(lo, 0+XfOrM835_COUNT)));
#     define XfOrM853_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM853(x) SETUP(XfOrM853_COUNT)
      FUNCCALL(SETUP_XfOrM853(_), locate_cyclic_closures (lo -> value , ui ) )
# 4079 "bc/src/resolve.c"
      ; 
      FUNCCALL(SETUP_XfOrM853(_), locate_cyclic_closures (lo -> body , ui ) ); 
    }
    break ; 
    case scheme_closure_type : 
    {
      Scheme_Object * c ; 
      BLOCK_SETUP((PUSH(c, 0+XfOrM835_COUNT)));
#     define XfOrM849_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM849(x) SETUP(XfOrM849_COUNT)
      c = NULLED_OUT ; 

# 4086 "bc/src/resolve.c"
      c = FUNCCALL(SETUP_XfOrM849(_), scheme_hash_get (ui -> closures , e ) ); 

      if ((c ) == (scheme_true ) )  {
        Scheme_IR_Toplevel * tl ; 
        BLOCK_SETUP((PUSH(tl, 0+XfOrM849_COUNT)));
#       define XfOrM852_COUNT (1+XfOrM849_COUNT)
#       define SETUP_XfOrM852(x) SETUP(XfOrM852_COUNT)
        tl = NULLED_OUT ; 

# 4091 "bc/src/resolve.c"
        tl = FUNCCALL(SETUP_XfOrM852(_), scheme_make_ir_toplevel (- 1 , ui -> num_defns + ui -> num_extra_toplevels , 0 ) ); 
        ui -> num_extra_toplevels ++ ; 
        FUNCCALL(SETUP_XfOrM852(_), scheme_hash_set (ui -> closures , e , (Scheme_Object * ) tl ) )
        ; 
      }

# 4095 "bc/src/resolve.c"
      else if (c ) {
      }
      else {
        Scheme_Closure * cl = (Scheme_Closure * ) e ; 
        BLOCK_SETUP((PUSH(cl, 0+XfOrM849_COUNT)));
#       define XfOrM850_COUNT (1+XfOrM849_COUNT)
#       define SETUP_XfOrM850(x) SETUP(XfOrM850_COUNT)
        FUNCCALL(SETUP_XfOrM850(_), scheme_hash_set (ui -> closures , e , scheme_true ) )
# 4099 "bc/src/resolve.c"
        ; 
        FUNCCALL(SETUP_XfOrM850(_), locate_cyclic_closures ((Scheme_Object * ) cl -> code , ui ) ); 
      }
    }
    break ; 
    case scheme_lambda_type : 
    {
      Scheme_Lambda * cd = (Scheme_Lambda * ) e ; 
#     define XfOrM848_COUNT (0+XfOrM835_COUNT)
#     define SETUP_XfOrM848(x) SETUP_XfOrM835(x)
      FUNCCALL(SETUP_XfOrM848(_), locate_cyclic_closures (cd -> body , ui ) )
# 4107 "bc/src/resolve.c"
      ; 
    }
    break ; 
    case scheme_inline_variant_type : 
    {
      Scheme_Object * a ; 
#     define XfOrM847_COUNT (0+XfOrM835_COUNT)
#     define SETUP_XfOrM847(x) SETUP_XfOrM835(x)
      a = NULLED_OUT ; 

# 4113 "bc/src/resolve.c"
      a = (((Scheme_Vector * ) (e ) ) -> els ) [0 ] ; 
      FUNCCALL(SETUP_XfOrM847(_), locate_cyclic_closures (a , ui ) ); 
    }
    break ; 
    case scheme_define_values_type : 
    {
#     define XfOrM843_COUNT (0+XfOrM835_COUNT)
#     define SETUP_XfOrM843(x) SETUP_XfOrM835(x)

# 4119 "bc/src/resolve.c"
      if ((((Scheme_Vector * ) (e ) ) -> size ) == 2 ) {
        int pos = (((Scheme_Toplevel * ) ((((Scheme_Vector * ) (e ) ) -> els ) [1 ] ) ) -> position ) ; 
#       define XfOrM844_COUNT (0+XfOrM843_COUNT)
#       define SETUP_XfOrM844(x) SETUP_XfOrM843(x)

# 4121 "bc/src/resolve.c"
        if (pos >= ui -> lift_offset ) {
          Scheme_Lambda * lam = (Scheme_Lambda * ) (((Scheme_Vector * ) (e ) ) -> els ) [0 ] ; 
#         define XfOrM845_COUNT (0+XfOrM844_COUNT)
#         define SETUP_XfOrM845(x) SETUP_XfOrM844(x)

# 4123 "bc/src/resolve.c"
          if ((& (lam ) -> iso ) -> so . keyex & 2 ) {
#           define XfOrM846_COUNT (0+XfOrM845_COUNT)
#           define SETUP_XfOrM846(x) SETUP_XfOrM845(x)
            FUNCCALL(SETUP_XfOrM846(_), scheme_hash_set (ui -> ref_lifts , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , (Scheme_Object * ) lam ) )
# 4124 "bc/src/resolve.c"
            ; 
          }
        }
      }
      FUNCCALL(SETUP_XfOrM843(_), locate_cyclic_closures ((((Scheme_Vector * ) (e ) ) -> els ) [0 ] , ui ) )
      ; 
    }
    break ; 
    case scheme_set_bang_type : 
    {
      Scheme_Set_Bang * sb = (Scheme_Set_Bang * ) e ; 
      BLOCK_SETUP((PUSH(sb, 0+XfOrM835_COUNT)));
#     define XfOrM842_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM842(x) SETUP(XfOrM842_COUNT)
      FUNCCALL(SETUP_XfOrM842(_), locate_cyclic_closures (sb -> var , ui ) )
# 4135 "bc/src/resolve.c"
      ; 
      FUNCCALL(SETUP_XfOrM842(_), locate_cyclic_closures (sb -> val , ui ) ); 
    }
    break ; 
    case scheme_varref_form_type : 
    case scheme_apply_values_type : 
    {
      Scheme_Object * a , * b ; 
      BLOCK_SETUP((PUSH(b, 0+XfOrM835_COUNT)));
#     define XfOrM841_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM841(x) SETUP(XfOrM841_COUNT)
      a = NULLED_OUT ; 
      b = NULLED_OUT ; 

# 4143 "bc/src/resolve.c"
      a = (((Scheme_Simple_Object * ) (e ) ) -> u . two_ptr_val . ptr1 ) ; 
      FUNCCALL(SETUP_XfOrM841(_), locate_cyclic_closures (a , ui ) ); 
      b = (((Scheme_Simple_Object * ) (e ) ) -> u . two_ptr_val . ptr2 ) ; 
      FUNCCALL(SETUP_XfOrM841(_), locate_cyclic_closures (b , ui ) ); 
    }
    break ; 
    case scheme_boxenv_type : 
    {
#     define XfOrM840_COUNT (0+XfOrM835_COUNT)
#     define SETUP_XfOrM840(x) SETUP_XfOrM835(x)
      FUNCCALL(SETUP_XfOrM840(_), locate_cyclic_closures ((((Scheme_Simple_Object * ) (e ) ) -> u . two_ptr_val . ptr2 ) , ui ) )
# 4151 "bc/src/resolve.c"
      ; 
    }
    break ; 
    case scheme_case_lambda_sequence_type : 
    {
      Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) e ; 
      int i ; 
      BLOCK_SETUP((PUSH(cl, 0+XfOrM835_COUNT)));
#     define XfOrM837_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM837(x) SETUP(XfOrM837_COUNT)

# 4158 "bc/src/resolve.c"
      for (i = 0 ; i < cl -> count ; i ++ ) {
#       define XfOrM839_COUNT (0+XfOrM837_COUNT)
#       define SETUP_XfOrM839(x) SETUP_XfOrM837(x)
        FUNCCALL(SETUP_XfOrM839(_), locate_cyclic_closures (cl -> array [i ] , ui ) )
# 4159 "bc/src/resolve.c"
        ; 
      }
    }
    break ; 
    case scheme_let_value_type : 
    {
      Scheme_Let_Value * lv = (Scheme_Let_Value * ) e ; 
      BLOCK_SETUP((PUSH(lv, 0+XfOrM835_COUNT)));
#     define XfOrM836_COUNT (1+XfOrM835_COUNT)
#     define SETUP_XfOrM836(x) SETUP(XfOrM836_COUNT)
      FUNCCALL(SETUP_XfOrM836(_), locate_cyclic_closures (lv -> value , ui ) )
# 4166 "bc/src/resolve.c"
      ; 
      FUNCCALL_EMPTY(locate_cyclic_closures (lv -> body , ui ) ); 
    }
    break ; 
    default : 
    break ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4175 "bc/src/resolve.c"
static void convert_closures_to_definitions (Unresolve_Info * ui ) 
{
  Scheme_Object * d , * var , * val ; 
  Scheme_Lambda * lam ; 
  int i ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(d, 0), PUSH(var, 1), PUSH(val, 2), PUSH(lam, 3), PUSH(ui, 4)));
# define XfOrM868_COUNT (5)
# define SETUP_XfOrM868(x) SETUP(XfOrM868_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  d = NULLED_OUT ; 
  var = NULLED_OUT ; 
  val = NULLED_OUT ; 
  lam = NULLED_OUT ; 

# 4181 "bc/src/resolve.c"
  for (i = 0 ; i < ui -> closures -> size ; i ++ ) {
#   define XfOrM872_COUNT (0+XfOrM868_COUNT)
#   define SETUP_XfOrM872(x) SETUP_XfOrM868(x)

# 4182 "bc/src/resolve.c"
    if (ui -> closures -> vals [i ] && ! ((ui -> closures -> vals [i ] ) == (scheme_true ) ) ) {
#     define XfOrM873_COUNT (0+XfOrM872_COUNT)
#     define SETUP_XfOrM873(x) SETUP_XfOrM872(x)

# 4183 "bc/src/resolve.c"
      ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (ui -> closures -> vals [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ui -> closures -> vals [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) ) ? 1 : 0 ) , __extension__ ({
#       define XfOrM874_COUNT (0+XfOrM873_COUNT)
#       define SETUP_XfOrM874(x) SETUP_XfOrM873(x)

# 4183 "bc/src/resolve.c" 3
        if ((Scheme_Type ) (((((intptr_t ) (ui -> closures -> vals [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ui -> closures -> vals [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) 

# 4183 "bc/src/resolve.c" 3
        ; 

# 4183 "bc/src/resolve.c" 3
        else FUNCCALL(SETUP_XfOrM874(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(ui->closures->vals[i])) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(ui->closures->vals[i]))->type)) == (Scheme_Type)(scheme_ir_toplevel_type))" , "bc/src/resolve.c" , 4183 , __extension__ __PRETTY_FUNCTION__ ) ); 
      }
      ) ) 
# 4183 "bc/src/resolve.c"
      ; 
      d = FUNCCALL(SETUP_XfOrM873(_), scheme_make_vector (2 , ((void * ) 0 ) ) ); 
      d -> type = scheme_define_values_type ; 
      var = ui -> closures -> vals [i ] ; 
      lam = ((Scheme_Closure * ) ui -> closures -> keys [i ] ) -> code ; 
      val = FUNCCALL(SETUP_XfOrM873(_), unresolve_lambda (lam , ui ) ); 
      (((Scheme_Vector * ) (d ) ) -> els ) [0 ] = val ; 
      (((Scheme_Vector * ) (d ) ) -> els ) [1 ] = var ; 
      d = FUNCCALL(SETUP_XfOrM873(_), scheme_make_pair (d , ui -> definitions ) ); 
      ui -> definitions = d ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4197 "bc/src/resolve.c"
Scheme_Linklet * scheme_unresolve_linklet (Scheme_Linklet * linklet , int comp_flags ) 



{
  Scheme_Linklet * new_linklet ; 
  Scheme_Object * bs , * bs2 , * ds , * imports ; 
  Unresolve_Info * ui ; 
  Scheme_IR_Toplevel * * toplevels , * tl ; 
  int i , j , cnt , len ; 
  DECL_RET_SAVE (Scheme_Linklet * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(bs, 0), PUSH(ds, 1), PUSH(ui, 2), PUSH(new_linklet, 3), PUSH(bs2, 4), PUSH(toplevels, 5), PUSH(linklet, 6), PUSH(imports, 7), PUSH(tl, 8)));
# define XfOrM875_COUNT (9)
# define SETUP_XfOrM875(x) SETUP(XfOrM875_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  new_linklet = NULLED_OUT ; 
  bs = NULLED_OUT ; 
  bs2 = NULLED_OUT ; 
  ds = NULLED_OUT ; 
  imports = NULLED_OUT ; 
  ui = NULLED_OUT ; 
  toplevels = NULLED_OUT ; 
  tl = NULLED_OUT ; 

# 4208 "bc/src/resolve.c"
  new_linklet = ((Scheme_Linklet * ) FUNCCALL(SETUP_XfOrM875(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Linklet ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (new_linklet , linklet , sizeof (Scheme_Linklet ) ) ) ; 

  ui = FUNCCALL(SETUP_XfOrM875(_), new_unresolve_info (new_linklet , ((void * ) 0 ) , ((void * ) 0 ) , comp_flags ) ); 

  cnt = ui -> num_toplevels ; 
  toplevels = ((Scheme_IR_Toplevel * * ) FUNCCALL(SETUP_XfOrM875(_), GC_malloc (sizeof (Scheme_IR_Toplevel * ) * (cnt ) ) )) ; 
  tl = FUNCCALL(SETUP_XfOrM875(_), scheme_make_ir_toplevel (- 1 , - 1 , 0 ) ); 
  i = 0 ; 
  toplevels [i ++ ] = tl ; 
  for (j = 0 ; j < (((Scheme_Vector * ) (linklet -> importss ) ) -> size ) ; j ++ ) {
    int k ; 
#   define XfOrM890_COUNT (0+XfOrM875_COUNT)
#   define SETUP_XfOrM890(x) SETUP_XfOrM875(x)

# 4220 "bc/src/resolve.c"
    imports = (((Scheme_Vector * ) (linklet -> importss ) ) -> els ) [j ] ; 
    for (k = 0 ; k < (((Scheme_Vector * ) (imports ) ) -> size ) ; k ++ ) {
#     define XfOrM892_COUNT (0+XfOrM890_COUNT)
#     define SETUP_XfOrM892(x) SETUP_XfOrM890(x)

# 4222 "bc/src/resolve.c"
      tl = FUNCCALL(SETUP_XfOrM892(_), scheme_make_ir_toplevel (j , k , 0 ) ); 
      toplevels [i ++ ] = tl ; 
    }
  }
  for (j = 0 ; i < cnt ; j ++ ) {
#   define XfOrM886_COUNT (0+XfOrM875_COUNT)
#   define SETUP_XfOrM886(x) SETUP_XfOrM875(x)

# 4227 "bc/src/resolve.c"
    tl = FUNCCALL(SETUP_XfOrM886(_), scheme_make_ir_toplevel (- 1 , j , 0 ) ); 
    toplevels [i ++ ] = tl ; 
  }
  ui -> toplevels = toplevels ; 

  cnt = (((Scheme_Vector * ) (linklet -> bodies ) ) -> size ) ; 
  bs = FUNCCALL(SETUP_XfOrM875(_), scheme_make_vector (cnt , ((void * ) 0 ) ) ); 

  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM884_COUNT (0+XfOrM875_COUNT)
#   define SETUP_XfOrM884(x) SETUP_XfOrM875(x)
    FUNCCALL(SETUP_XfOrM884(_), locate_cyclic_closures ((((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] , ui ) )
# 4236 "bc/src/resolve.c"
    ; 
  }
  FUNCCALL(SETUP_XfOrM875(_), convert_closures_to_definitions (ui ) )
  ; 

  for (i = 0 ; i < cnt ; i ++ ) {
    Scheme_Object * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM875_COUNT)));
#   define XfOrM882_COUNT (1+XfOrM875_COUNT)
#   define SETUP_XfOrM882(x) SETUP(XfOrM882_COUNT)
    b = NULLED_OUT ; 

# 4243 "bc/src/resolve.c"
    b = FUNCCALL(SETUP_XfOrM882(_), unresolve_expr ((((Scheme_Vector * ) (linklet -> bodies ) ) -> els ) [i ] , ui , 0 ) ); 
    if (! b )

# 4244 "bc/src/resolve.c"
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    (((Scheme_Vector * ) (bs ) ) -> els ) [i ] = b ; 
  }
  len = (scheme_list_length (ui -> definitions ) ) ; 
  ds = ui -> definitions ; 
  bs2 = FUNCCALL(SETUP_XfOrM875(_), scheme_make_vector (cnt + len , ((void * ) 0 ) ) ); 
  for (i = 0 ; ((Scheme_Type ) (((((intptr_t ) (ds ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ds ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ds = (((Scheme_Simple_Object * ) (ds ) ) -> u . pair_val . cdr ) , i ++ ) {
    (((Scheme_Vector * ) (bs2 ) ) -> els ) [i ] = (((Scheme_Simple_Object * ) (ds ) ) -> u . pair_val . car ) ; 
  }
  for (i = 0 ; i < cnt ; i ++ ) {
    (((Scheme_Vector * ) (bs2 ) ) -> els ) [i + len ] = (((Scheme_Vector * ) (bs ) ) -> els ) [i ] ; 
  }

  new_linklet -> bodies = bs2 ; 

  if (ui -> num_extra_toplevels ) {
#   define XfOrM876_COUNT (0+XfOrM875_COUNT)
#   define SETUP_XfOrM876(x) SETUP_XfOrM875(x)
    FUNCCALL(SETUP_XfOrM876(_), extend_linklet_defns (new_linklet , ui -> num_extra_toplevels ) )
# 4261 "bc/src/resolve.c"
    ; 
  }

  RET_VALUE_START (new_linklet ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4267 "bc/src/resolve.c"
Scheme_Object * scheme_unresolve (Scheme_Object * iv , int argc , int * _has_cases , 
Scheme_Linklet * linklet , Scheme_Object * linklet_key , Optimize_Info * opt_info ) 



{
  Scheme_Object * o ; 
  Scheme_Lambda * lam = ((void * ) 0 ) ; 
  Unresolve_Info * ui ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(_has_cases, 0), PUSH(lam, 1), PUSH(o, 2), PUSH(iv, 3), PUSH(ui, 4), PUSH(opt_info, 5), PUSH(linklet_key, 6), PUSH(linklet, 7)));
# define XfOrM893_COUNT (8)
# define SETUP_XfOrM893(x) SETUP(XfOrM893_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  ui = NULLED_OUT ; 

# 4277 "bc/src/resolve.c"
  ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (iv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (iv ) ) -> type ) ) == (Scheme_Type ) (scheme_inline_variant_type ) ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM901_COUNT (0+XfOrM893_COUNT)
#   define SETUP_XfOrM901(x) SETUP_XfOrM893(x)

# 4277 "bc/src/resolve.c" 3
    if ((Scheme_Type ) (((((intptr_t ) (iv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (iv ) ) -> type ) ) == (Scheme_Type ) (scheme_inline_variant_type ) ) 

# 4277 "bc/src/resolve.c" 3
    ; 

# 4277 "bc/src/resolve.c" 3
    else FUNCCALL(SETUP_XfOrM901(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(iv)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(iv))->type)) == (Scheme_Type)(scheme_inline_variant_type))" , "bc/src/resolve.c" , 4277 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 4277 "bc/src/resolve.c"
  ; 

  o = (((Scheme_Vector * ) (iv ) ) -> els ) [1 ] ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) 
    lam = ((Scheme_Closure * ) o ) -> code ; 
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) 
    lam = (Scheme_Lambda * ) o ; 
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_case_lambda_sequence_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) ) ) {
    Scheme_Case_Lambda * seqin = (Scheme_Case_Lambda * ) o ; 
    int i , cnt ; 
    cnt = seqin -> count ; 
    if (cnt > 1 )

# 4290 "bc/src/resolve.c"
    * _has_cases = 1 ; 
    for (i = 0 ; i < cnt ; i ++ ) {
      if ((Scheme_Type ) (((((intptr_t ) (seqin -> array [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (seqin -> array [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {

        lam = ((Scheme_Closure * ) seqin -> array [i ] ) -> code ; 
      }

# 4295 "bc/src/resolve.c"
      else {
        lam = (Scheme_Lambda * ) seqin -> array [i ] ; 
      }
      if ((! ((& (lam ) -> iso ) -> so . keyex & 1 ) 
      && (lam -> num_params == argc ) ) 
      || (((& (lam ) -> iso ) -> so . keyex & 1 ) 
      && (lam -> num_params - 1 <= argc ) ) )
        break ; 
      else 
      lam = ((void * ) 0 ) ; 
    }
  }

# 4306 "bc/src/resolve.c"
  else 
  lam = ((void * ) 0 ) ; 

  if (! lam )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  ui = FUNCCALL(SETUP_XfOrM893(_), new_unresolve_info (linklet , linklet_key , opt_info , 0 ) ); 
  ui -> inlining = 1 ; 


  o = FUNCCALL(SETUP_XfOrM893(_), unresolve_lambda (lam , ui ) ); 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "bc/src/mzmark_resolve.inc"
static int mark_resolve_info_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_resolve_info_MARK (void * p , struct NewGC * gc ) {

  Resolve_Info * i = (Resolve_Info * ) p ; 

  GC_mark2 (& (i -> linklet ) , gc ) ; 
  GC_mark2 (& (i -> tl_map ) , gc ) ; 
  GC_mark2 (& (i -> redirects ) , gc ) ; 
  GC_mark2 (& (i -> lifts ) , gc ) ; 
  GC_mark2 (& (i -> top ) , gc ) ; 
  GC_mark2 (& (i -> next ) , gc ) ; 
  GC_mark2 (& (i -> toplevel_starts ) , gc ) ; 
  GC_mark2 (& (i -> toplevel_deltas ) , gc ) ; 
  GC_mark2 (& (i -> toplevel_defns ) , gc ) ; 
  GC_mark2 (& (i -> static_mode ) , gc ) ; 


  return 0 ; 
}






static int mark_resolve_info_FIXUP (void * p , struct NewGC * gc ) {

  Resolve_Info * i = (Resolve_Info * ) p ; 

  GC_fixup2 (& (i -> linklet ) , gc ) ; 
  GC_fixup2 (& (i -> tl_map ) , gc ) ; 
  GC_fixup2 (& (i -> redirects ) , gc ) ; 
  GC_fixup2 (& (i -> lifts ) , gc ) ; 
  GC_fixup2 (& (i -> top ) , gc ) ; 
  GC_fixup2 (& (i -> next ) , gc ) ; 
  GC_fixup2 (& (i -> toplevel_starts ) , gc ) ; 
  GC_fixup2 (& (i -> toplevel_deltas ) , gc ) ; 
  GC_fixup2 (& (i -> toplevel_defns ) , gc ) ; 
  GC_fixup2 (& (i -> static_mode ) , gc ) ; 


  return 0 ; 
}

# 63 "bc/src/mzmark_resolve.inc"
static int mark_unresolve_info_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_unresolve_info_MARK (void * p , struct NewGC * gc ) {

  Unresolve_Info * i = (Unresolve_Info * ) p ; 

  GC_mark2 (& (i -> vars ) , gc ) ; 
  GC_mark2 (& (i -> linklet ) , gc ) ; 
  GC_mark2 (& (i -> linklet_key ) , gc ) ; 
  GC_mark2 (& (i -> opt_info ) , gc ) ; 
  GC_mark2 (& (i -> closures ) , gc ) ; 
  GC_mark2 (& (i -> toplevels ) , gc ) ; 
  GC_mark2 (& (i -> definitions ) , gc ) ; 
  GC_mark2 (& (i -> ref_lifts ) , gc ) ; 


  return 0 ; 
}






static int mark_unresolve_info_FIXUP (void * p , struct NewGC * gc ) {

  Unresolve_Info * i = (Unresolve_Info * ) p ; 

  GC_fixup2 (& (i -> vars ) , gc ) ; 
  GC_fixup2 (& (i -> linklet ) , gc ) ; 
  GC_fixup2 (& (i -> linklet_key ) , gc ) ; 
  GC_fixup2 (& (i -> opt_info ) , gc ) ; 
  GC_fixup2 (& (i -> closures ) , gc ) ; 
  GC_fixup2 (& (i -> toplevels ) , gc ) ; 
  GC_fixup2 (& (i -> definitions ) , gc ) ; 
  GC_fixup2 (& (i -> ref_lifts ) , gc ) ; 


  return 0 ; 
}

# 4331 "bc/src/resolve.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_resolve_info , mark_resolve_info_SIZE , mark_resolve_info_MARK , mark_resolve_info_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_unresolve_info , mark_unresolve_info_SIZE , mark_unresolve_info_MARK , mark_unresolve_info_FIXUP , 1 , 0 ) ; 
}
