#include "precomp.h"

# 7 "bc/src/struct.c"
Scheme_Object * scheme_arity_at_least ; 
Scheme_Object * scheme_date ; 
Scheme_Object * scheme_make_arity_at_least ; 
Scheme_Object * scheme_source_property ; 
Scheme_Object * scheme_input_port_property ; 
Scheme_Object * scheme_output_port_property ; 
Scheme_Object * scheme_cpointer_property ; 
Scheme_Object * scheme_equal_property ; 
Scheme_Object * scheme_no_arity_property ; 
Scheme_Object * scheme_impersonator_of_property ; 
Scheme_Object * scheme_make_struct_type_proc ; 
Scheme_Object * scheme_make_struct_field_accessor_proc ; 
Scheme_Object * scheme_make_struct_field_mutator_proc ; 
Scheme_Object * scheme_make_struct_type_property_proc ; 
Scheme_Object * scheme_struct_type_p_proc ; 
Scheme_Object * scheme_current_inspector_proc ; 
Scheme_Object * scheme_make_inspector_proc ; 
Scheme_Object * scheme_recur_symbol ; 
Scheme_Object * scheme_display_symbol ; 
Scheme_Object * scheme_write_special_symbol ; 
Scheme_Object * scheme_app_mark_impersonator_property ; 
Scheme_Object * scheme_object_name_property ; 
Scheme_Object * scheme_struct_to_vector_proc ; 
Scheme_Object * scheme_authentic_property ; 
Scheme_Object * scheme_sealed_property ; 
Scheme_Object * scheme_unsafe_poller_proc ; 

static Scheme_Object * location_struct ; 
static Scheme_Object * poller_struct ; 
static Scheme_Object * write_property ; 
static Scheme_Object * print_attribute_property ; 
static Scheme_Object * evt_property ; 
static Scheme_Object * proc_property ; 
static Scheme_Object * method_property ; 
static Scheme_Object * scheme_checked_proc_property ; 
static Scheme_Object * struct_info_proc ; 
static Scheme_Object * ellipses_symbol ; 
static Scheme_Object * prefab_symbol ; 



typedef enum {
  SCHEME_CONSTR = 1 , 
  SCHEME_PRED , 
  SCHEME_GETTER , 
  SCHEME_SETTER , 
  SCHEME_GEN_GETTER , 
  SCHEME_GEN_SETTER }
Scheme_ProcT ; 

typedef struct {
  Scheme_Object so ; 
  Scheme_Object * evt ; 
  Scheme_Object * wrapper ; 
}

# 61 "bc/src/struct.c"
Wrapped_Evt ; 

typedef struct {
  Scheme_Object so ; 
  Scheme_Object * maker ; 
}

# 66 "bc/src/struct.c"
Nack_Guard_Evt ; 

typedef struct {
  Scheme_Object so ; 
  int done ; 
  Syncing * syncing ; 
  Scheme_Object * wrapper ; 
  Scheme_Object * orig ; 
}

# 74 "bc/src/struct.c"
Active_Replace_Evt ; 

static Scheme_Object * make_inspector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_sibling_inspector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * inspector_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * inspector_superior_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_inspector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_code_inspector (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_struct_type_property (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_struct_type_property_from_c (int argc , Scheme_Object * argv [] , 
Scheme_Object * * predout , Scheme_Object * * accessout , 
Scheme_Type type ) ; 
static Scheme_Object * struct_type_property_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_property_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_evt_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_object_name_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_equal_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_impersonator_of_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_write_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_print_attribute_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_input_port_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_output_port_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_cpointer_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_checked_proc_property_value_ok (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_struct_type (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_struct_field_accessor (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_struct_field_mutator (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * nack_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * handle_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * replace_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * handle_evt_p (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * struct_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * proc_struct_type_p (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * struct_info (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_info (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_pred (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_constr (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_sealed_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_authentic_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_to_vector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * prefab_struct_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_prefab_struct (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * prefab_struct_type_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * prefab_key_struct_type (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * is_prefab_key (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * struct_setter_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_getter_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_pred_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_constr_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_prop_getter_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_prop_pred_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_prop_getter_p (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_struct_proc (Scheme_Struct_Type * struct_type , char * func_name , 
Scheme_ProcT proc_type , int field_num ) ; 
static Scheme_Object * make_struct_proc_for_realm (Scheme_Struct_Type * struct_type , 
char * func_name , Scheme_Object * realm , Scheme_Object * contract , 
Scheme_ProcT proc_type , int field_num ) ; 

static Scheme_Object * make_name (const char * pre , const char * tn , int tnl , const char * post1 , 
const char * fn , int fnl , const char * post2 , int sym ) ; 
__xform_nongcing__ static void adjust_primitive (Scheme_Object * vi , Scheme_Struct_Type * stype , int flags ) ; 

static void get_struct_type_info (int argc , Scheme_Object * argv [] , Scheme_Object * * a , int always ) ; 


static int evt_struct_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static void evt_struct_needs_wakeup (Scheme_Object * o , void * fds ) ; 
static int is_evt_struct (Scheme_Object * ) ; 

static int wrapped_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int nack_guard_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int nack_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int poll_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int replace_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int active_replace_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static void active_replace_evt_needs_wakeup (Scheme_Object * s , void * fds ) ; 

static int chaperone_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int is_chaperone_evt (Scheme_Object * o ) ; 

static Scheme_Object * check_arity_at_least_fields (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * check_date_fields (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * check_date_star_fields (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * check_location_fields (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * check_exn_source_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * exn_source_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * exn_source_get (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * procedure_extract_target (int argc , Scheme_Object * * argv ) ; 
static Scheme_Struct_Type * hash_prefab (Scheme_Struct_Type * type ) ; 

static Scheme_Object * chaperone_struct (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * impersonate_struct (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * chaperone_struct_type (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * make_chaperone_property (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_chaperone_property_from_c (Scheme_Object * name ) ; 






static void register_traversers (void ) ; 


; 
static Scheme_Object * make_prefab_key (Scheme_Struct_Type * type ) ; 

# 217 "bc/src/struct.c"
static char * pred_name_string (Scheme_Object * sym ) 
{
  char * __funcarg61 = NULLED_OUT ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sym, 0)));
# define XfOrM1_COUNT (1)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 219 "bc/src/struct.c"
  RET_VALUE_START ((char * ) (__funcarg61 = FUNCCALL(SETUP_XfOrM1(_), scheme_symbol_val (sym ) ), FUNCCALL_AGAIN(make_name ("" , __funcarg61 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) , "?" , ((void * ) 0 ) , 0 , "" , 0 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 222 "bc/src/struct.c"
void 
scheme_init_struct (Scheme_Startup_Env * env ) 
{
  Scheme_Object * * as_names ; 
  Scheme_Object * * as_values ; 
  int as_count ; 
  Scheme_Object * * ts_names ; 
  Scheme_Object * * ts_values ; 
  int ts_count ; 
  Scheme_Object * * loc_names ; 
  Scheme_Object * * loc_values ; 
  int loc_count ; 
  int i ; 
  Scheme_Object * guard , * p ; 

  static const char * arity_fields [1 ] = {

# 237 "bc/src/struct.c"
    "value" }

# 237 "bc/src/struct.c"
  ; 
  static const char * date_fields [10 ] = {

# 238 "bc/src/struct.c"
    "second" , "minute" , "hour" , 
    "day" , "month" , "year" , 
    "week-day" , "year-day" , "dst?" , "time-zone-offset" }

# 240 "bc/src/struct.c"
  ; 
  static const char * date_star_fields [2 ] = {

# 241 "bc/src/struct.c"
    "nanosecond" , "time-zone-name" }

# 241 "bc/src/struct.c"
  ; 
  static const char * location_fields [10 ] = {

# 242 "bc/src/struct.c"
    "source" , "line" , "column" , "position" , "span" }

# 242 "bc/src/struct.c"
  ; 
  Scheme_Object * __funcarg126 = NULLED_OUT ; 
  char * __funcarg125 = NULLED_OUT ; 
  Scheme_Object * __funcarg123 = NULLED_OUT ; 
  char * __funcarg122 = NULLED_OUT ; 
  Scheme_Object * __funcarg120 = NULLED_OUT ; 
  char * __funcarg119 = NULLED_OUT ; 
  Scheme_Object * __funcarg117 = NULLED_OUT ; 
  char * __funcarg116 = NULLED_OUT ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(ts_names, 0), PUSH(p, 1), PUSH(loc_names, 2), PUSH(loc_values, 3), PUSH(env, 4), PUSH(as_values, 5), PUSH(ts_values, 6), PUSH(as_names, 7), PUSH(guard, 8)));
# define XfOrM2_COUNT (9)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  as_names = NULLED_OUT ; 
  as_values = NULLED_OUT ; 
  ts_names = NULLED_OUT ; 
  ts_values = NULLED_OUT ; 
  loc_names = NULLED_OUT ; 
  loc_values = NULLED_OUT ; 
  guard = NULLED_OUT ; 
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM2(_), register_traversers () )
# 245 "bc/src/struct.c"
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_arity_at_least , sizeof (scheme_arity_at_least ) ) )


  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_arity_at_least , sizeof (scheme_make_arity_at_least ) ) ); 
  scheme_arity_at_least = (__funcarg126 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (check_arity_at_least_fields , "check_arity_at_least_fields" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("arity-at-least" , ((void * ) 0 ) , 1 , ((void * ) 0 ) , __funcarg126 , 1 ) )) ; 
  as_names = FUNCCALL_AGAIN(scheme_make_struct_names_from_array ("arity-at-least" , 1 , arity_fields , (0x10 | 0x80 | 0x100 | 0x400 ) , & as_count ) )


  ; 
  as_values = FUNCCALL_AGAIN(scheme_make_struct_values (scheme_arity_at_least , as_names , as_count , (0x10 | 0x80 | 0x100 | 0x400 ) ) )
  ; 
  scheme_make_arity_at_least = as_values [1 ] ; 
  for (i = 0 ; i < as_count - 1 ; i ++ ) {
#   define XfOrM26_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM26(x) SETUP_XfOrM2(x)
    (__funcarg125 = FUNCCALL(SETUP_XfOrM26(_), scheme_symbol_val (as_names [i ] ) )
# 261 "bc/src/struct.c"
    , FUNCCALL_AGAIN(scheme_addto_prim_instance (__funcarg125 , as_values [i ] , env ) )) 
    ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_date , sizeof (scheme_date ) ) )

  ; 
  scheme_date = (__funcarg123 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (check_date_fields , "check-date-fields" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("date" , ((void * ) 0 ) , 10 , ((void * ) 0 ) , __funcarg123 , 1 ) )) ; 

  ts_names = FUNCCALL_AGAIN(scheme_make_struct_names_from_array ("date" , 10 , date_fields , (0x10 | 0x80 | 0x100 | 0x400 ) , & ts_count ) )

  ; 

  ts_values = FUNCCALL_AGAIN(scheme_make_struct_values (scheme_date , ts_names , ts_count , (0x10 | 0x80 | 0x100 | 0x400 ) ) )
  ; 
  for (i = 0 ; i < ts_count - 1 ; i ++ ) {
#   define XfOrM24_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM24(x) SETUP_XfOrM2(x)
    (__funcarg122 = FUNCCALL(SETUP_XfOrM24(_), scheme_symbol_val (ts_names [i ] ) )
# 277 "bc/src/struct.c"
    , FUNCCALL_AGAIN(scheme_addto_prim_instance (__funcarg122 , ts_values [i ] , env ) )) 
    ; 
  }

  scheme_date = (__funcarg120 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (check_date_star_fields , "check_date_star_fields" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("date*" , scheme_date , 2 , ((void * ) 0 ) , __funcarg120 , 1 ) )) ; 

  ts_names = FUNCCALL(SETUP_XfOrM2(_), scheme_make_struct_names_from_array ("date*" , 2 , date_star_fields , (0x10 | 0x80 | 0x100 | 0x400 ) , & ts_count ) )

  ; 

  ts_values = FUNCCALL_AGAIN(scheme_make_struct_values (scheme_date , ts_names , ts_count , (0x10 | 0x80 | 0x100 | 0x400 ) ) )
  ; 

  for (i = 0 ; i < ts_count - 1 ; i ++ ) {
#   define XfOrM22_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM22(x) SETUP_XfOrM2(x)
    (__funcarg119 = FUNCCALL(SETUP_XfOrM22(_), scheme_symbol_val (ts_names [i ] ) )
# 292 "bc/src/struct.c"
    , FUNCCALL_AGAIN(scheme_addto_prim_instance (__funcarg119 , ts_values [i ] , env ) )) 
    ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & location_struct , sizeof (location_struct ) ) )


  ; 
  location_struct = (__funcarg117 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (check_location_fields , "check_location_fields" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("srcloc" , ((void * ) 0 ) , 5 , ((void * ) 0 ) , __funcarg117 , 1 ) )) ; 

  loc_names = FUNCCALL_AGAIN(scheme_make_struct_names_from_array ("srcloc" , 5 , location_fields , (0x10 | 0x80 | 0x100 | 0x400 ) , & loc_count ) )

  ; 

  loc_values = FUNCCALL_AGAIN(scheme_make_struct_values (location_struct , loc_names , loc_count , (0x10 | 0x80 | 0x100 | 0x400 ) ) )
  ; 
  for (i = 0 ; i < loc_count - 1 ; i ++ ) {
#   define XfOrM20_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM20(x) SETUP_XfOrM2(x)
    (__funcarg116 = FUNCCALL(SETUP_XfOrM20(_), scheme_symbol_val (loc_names [i ] ) )
# 309 "bc/src/struct.c"
    , FUNCCALL_AGAIN(scheme_addto_prim_instance (__funcarg116 , loc_values [i ] , env ) )) 
    ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & poller_struct , sizeof (poller_struct ) ) )

  ; 
  poller_struct = FUNCCALL(SETUP_XfOrM2(_), scheme_make_struct_type_from_string ("unsafe-poller" , ((void * ) 0 ) , 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_poller_proc , sizeof (scheme_unsafe_poller_proc ) ) ); 
  scheme_unsafe_poller_proc = FUNCCALL_AGAIN(make_struct_proc ((Scheme_Struct_Type * ) poller_struct , "unsafe-poller" , SCHEME_CONSTR , 1 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & write_property , sizeof (write_property ) ) )
  ; 
  {
    Scheme_Object * a [2 ] , * pred , * access ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM2_COUNT), PUSH(pred, 3+XfOrM2_COUNT), PUSH(access, 4+XfOrM2_COUNT)));
#   define XfOrM18_COUNT (5+XfOrM2_COUNT)
#   define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    pred = NULLED_OUT ; 
    access = NULLED_OUT ; 

# 322 "bc/src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM18(_), scheme_make_prim_w_arity (check_write_property_value_ok , "guard-for-prop:custom-write" , 2 , 2 ) )

    ; 

    a [0 ] = FUNCCALL(SETUP_XfOrM18(_), scheme_intern_symbol ("custom-write" ) ); 
    a [1 ] = guard ; 
    write_property = FUNCCALL(SETUP_XfOrM18(_), make_struct_type_property_from_c (2 , a , & pred , & access , scheme_struct_property_type ) )
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:custom-write" , write_property , env ) ); 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("custom-write?" , pred , env ) ); 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("custom-write-accessor" , access , env ) ); 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & print_attribute_property , sizeof (print_attribute_property ) ) )
  ; 
  {
    Scheme_Object * a [2 ] , * pred , * access ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM2_COUNT), PUSH(pred, 3+XfOrM2_COUNT), PUSH(access, 4+XfOrM2_COUNT)));
#   define XfOrM17_COUNT (5+XfOrM2_COUNT)
#   define SETUP_XfOrM17(x) SETUP(XfOrM17_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    pred = NULLED_OUT ; 
    access = NULLED_OUT ; 

# 338 "bc/src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM17(_), scheme_make_prim_w_arity (check_print_attribute_property_value_ok , "guard-for-prop:custom-print-quotable" , 2 , 2 ) )

    ; 

    a [0 ] = FUNCCALL(SETUP_XfOrM17(_), scheme_intern_symbol ("custom-print-quotable" ) ); 
    a [1 ] = guard ; 
    print_attribute_property = FUNCCALL(SETUP_XfOrM17(_), make_struct_type_property_from_c (2 , a , & pred , & access , scheme_struct_property_type ) )
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:custom-print-quotable" , print_attribute_property , env ) ); 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("custom-print-quotable?" , pred , env ) ); 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("custom-print-quotable-accessor" , access , env ) ); 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & evt_property , sizeof (evt_property ) ) )
  ; 
  {
#   define XfOrM16_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM16(x) SETUP_XfOrM2(x)

# 353 "bc/src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM16(_), scheme_make_prim_w_arity (check_evt_property_value_ok , "guard-for-prop:evt" , 2 , 2 ) )

    ; 
    evt_property = (__funcarg114 = FUNCCALL(SETUP_XfOrM16(_), scheme_intern_symbol ("evt" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg114 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:evt" , evt_property , env ) ); 
  }

  {
#   define XfOrM15_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM15(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM15(_), scheme_register_static ((void * ) & proc_property , sizeof (proc_property ) ) )
# 362 "bc/src/struct.c"
    ; 
    proc_property = (__funcarg113 = FUNCCALL(SETUP_XfOrM15(_), scheme_intern_symbol ("procedure" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg113 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:procedure" , proc_property , env ) ); 
  }

  {
#   define XfOrM14_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM14(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM14(_), scheme_register_static ((void * ) & scheme_object_name_property , sizeof (scheme_object_name_property ) ) )
# 368 "bc/src/struct.c"
    ; 
    guard = FUNCCALL(SETUP_XfOrM14(_), scheme_make_prim_w_arity (check_object_name_property_value_ok , "guard-for-prop:object-name" , 2 , 2 ) )

    ; 
    scheme_object_name_property = (__funcarg112 = FUNCCALL(SETUP_XfOrM14(_), scheme_intern_symbol ("object-name" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg112 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:object-name" , scheme_object_name_property , env ) ); 
  }

  {
#   define XfOrM13_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM13(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM13(_), scheme_register_static ((void * ) & scheme_no_arity_property , sizeof (scheme_no_arity_property ) ) )
# 378 "bc/src/struct.c"
    ; 
    scheme_no_arity_property = (__funcarg111 = FUNCCALL(SETUP_XfOrM13(_), scheme_intern_symbol ("incomplete-arity" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg111 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:incomplete-arity" , scheme_no_arity_property , env ) ); 
  }

  {
#   define XfOrM12_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM12(x) SETUP_XfOrM2(x)

# 384 "bc/src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM12(_), scheme_make_prim_w_arity (check_equal_property_value_ok , "guard-for-prop:equal+hash" , 2 , 2 ) )

    ; 
    FUNCCALL(SETUP_XfOrM12(_), scheme_register_static ((void * ) & scheme_equal_property , sizeof (scheme_equal_property ) ) ); 
    scheme_equal_property = (__funcarg110 = FUNCCALL(SETUP_XfOrM12(_), scheme_intern_symbol ("equal+hash" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg110 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:equal+hash" , scheme_equal_property , env ) ); 
  }

  {
#   define XfOrM11_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM11(x) SETUP_XfOrM2(x)

# 394 "bc/src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (check_impersonator_of_property_value_ok , "guard-for-prop:impersonator-of" , 2 , 2 ) )

    ; 
    FUNCCALL(SETUP_XfOrM11(_), scheme_register_static ((void * ) & scheme_impersonator_of_property , sizeof (scheme_impersonator_of_property ) ) ); 
    scheme_impersonator_of_property = (__funcarg109 = FUNCCALL(SETUP_XfOrM11(_), scheme_intern_symbol ("impersonator-of" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg109 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:impersonator-of" , scheme_impersonator_of_property , env ) ); 
  }

  {
#   define XfOrM10_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM10(_), scheme_register_static ((void * ) & scheme_input_port_property , sizeof (scheme_input_port_property ) ) )
# 404 "bc/src/struct.c"
    ; 
    FUNCCALL(SETUP_XfOrM10(_), scheme_register_static ((void * ) & scheme_output_port_property , sizeof (scheme_output_port_property ) ) ); 

    guard = FUNCCALL_AGAIN(scheme_make_prim_w_arity (check_input_port_property_value_ok , "guard-for-prop:input-port" , 2 , 2 ) )

    ; 
    scheme_input_port_property = (__funcarg108 = FUNCCALL(SETUP_XfOrM10(_), scheme_intern_symbol ("input-port" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg108 , guard ) )) 
    ; 

    guard = FUNCCALL_AGAIN(scheme_make_prim_w_arity (check_output_port_property_value_ok , "guard-for-prop:output-port" , 2 , 2 ) )

    ; 
    scheme_output_port_property = (__funcarg107 = FUNCCALL(SETUP_XfOrM10(_), scheme_intern_symbol ("output-port" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg107 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:input-port" , scheme_input_port_property , env ) )
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:output-port" , scheme_output_port_property , env ) ); 
  }

  {
#   define XfOrM9_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM9(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM9(_), scheme_register_static ((void * ) & scheme_cpointer_property , sizeof (scheme_cpointer_property ) ) )
# 424 "bc/src/struct.c"
    ; 

    guard = FUNCCALL(SETUP_XfOrM9(_), scheme_make_prim_w_arity (check_cpointer_property_value_ok , "guard-for-prop:cpointer" , 2 , 2 ) )

    ; 
    scheme_cpointer_property = (__funcarg106 = FUNCCALL(SETUP_XfOrM9(_), scheme_intern_symbol ("cpointer" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg106 , guard ) )) 
    ; 
  }

  {
#   define XfOrM8_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM8(x) SETUP_XfOrM2(x)

# 434 "bc/src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM8(_), scheme_make_prim_w_arity (check_checked_proc_property_value_ok , "guard-for-prop:checked-procedure" , 2 , 2 ) )

    ; 
    FUNCCALL(SETUP_XfOrM8(_), scheme_register_static ((void * ) & scheme_checked_proc_property , sizeof (scheme_checked_proc_property ) ) ); 
    scheme_checked_proc_property = (__funcarg105 = FUNCCALL(SETUP_XfOrM8(_), scheme_intern_symbol ("checked-procedure" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg105 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:checked-procedure" , scheme_checked_proc_property , env ) ); 
  }

  {
#   define XfOrM7_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM7(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM7(_), scheme_register_static ((void * ) & method_property , sizeof (method_property ) ) )
# 444 "bc/src/struct.c"
    ; 
    method_property = (__funcarg104 = FUNCCALL(SETUP_XfOrM7(_), scheme_intern_symbol ("method-arity-error" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg104 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:method-arity-error" , method_property , env ) ); 
  }

  {
#   define XfOrM6_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM6(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM6(_), scheme_register_static ((void * ) & scheme_authentic_property , sizeof (scheme_authentic_property ) ) )
# 450 "bc/src/struct.c"
    ; 
    scheme_authentic_property = (__funcarg103 = FUNCCALL(SETUP_XfOrM6(_), scheme_intern_symbol ("authentic" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg103 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:authentic" , scheme_authentic_property , env ) ); 
  }

  {
#   define XfOrM5_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM5(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM5(_), scheme_register_static ((void * ) & scheme_sealed_property , sizeof (scheme_sealed_property ) ) )
# 456 "bc/src/struct.c"
    ; 
    scheme_sealed_property = (__funcarg102 = FUNCCALL(SETUP_XfOrM5(_), scheme_intern_symbol ("sealed" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg102 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:sealed" , scheme_sealed_property , env ) ); 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_recur_symbol , sizeof (scheme_recur_symbol ) ) )
  ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_display_symbol , sizeof (scheme_display_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_write_special_symbol , sizeof (scheme_write_special_symbol ) ) ); 
  scheme_recur_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("recur" ) ); 
  scheme_display_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("display" ) ); 
  scheme_write_special_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("write-special" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_struct_type_proc , sizeof (scheme_make_struct_type_proc ) ) )


  ; 
  scheme_make_struct_type_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (make_struct_type , 1 , "make-struct-type" , 4 , 11 , 0 , 5 , 5 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-struct-type" , scheme_make_struct_type_proc , env ) )


  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_struct_type_property_proc , sizeof (scheme_make_struct_type_property_proc ) ) )
  ; 
  scheme_make_struct_type_property_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (make_struct_type_property , 1 , "make-struct-type-property" , 1 , 7 , 0 , 3 , 3 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-struct-type-property" , scheme_make_struct_type_property_proc , env ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_struct_field_accessor_proc , sizeof (scheme_make_struct_field_accessor_proc ) ) )
  ; 
  scheme_make_struct_field_accessor_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (make_struct_field_accessor , "make-struct-field-accessor" , 2 , 5 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-struct-field-accessor" , scheme_make_struct_field_accessor_proc , env ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_struct_field_mutator_proc , sizeof (scheme_make_struct_field_mutator_proc ) ) )
  ; 
  scheme_make_struct_field_mutator_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (make_struct_field_mutator , "make-struct-field-mutator" , 2 , 5 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-struct-field-mutator" , scheme_make_struct_field_mutator_proc , env ) )

  ; 
  (__funcarg101 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (scheme_wrap_evt , "wrap-evt" , 2 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("wrap-evt" , __funcarg101 , env ) )) 
  ; 
  (__funcarg100 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (handle_evt , "handle-evt" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("handle-evt" , __funcarg100 , env ) )) 
  ; 
  (__funcarg99 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (replace_evt , "replace-evt" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("replace-evt" , __funcarg99 , env ) )) 
  ; 
  (__funcarg98 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_evt , "chaperone-evt" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-evt" , __funcarg98 , env ) )) 
  ; 
  (__funcarg97 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (nack_evt , "nack-guard-evt" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("nack-guard-evt" , __funcarg97 , env ) )) 
  ; 
  (__funcarg96 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (scheme_poll_evt , "poll-guard-evt" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("poll-guard-evt" , __funcarg96 , env ) )) 
  ; 
  (__funcarg95 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (handle_evt_p , "handle-evt?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("handle-evt?" , __funcarg95 , env ) )) 
  ; 
  (__funcarg94 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (struct_p , "struct?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct?" , __funcarg94 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_struct_type_p_proc , sizeof (scheme_struct_type_p_proc ) ) )
  ; 
  scheme_struct_type_p_proc = FUNCCALL_AGAIN(scheme_make_folding_prim (struct_type_p , "struct-type?" , 1 , 1 , 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type?" , scheme_struct_type_p_proc , env ) ); 
  (__funcarg93 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (struct_type_property_p , "struct-type-property?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-property?" , __funcarg93 , env ) )) 
  ; 
  (__funcarg92 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (proc_struct_type_p , "procedure-struct-type?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-struct-type?" , __funcarg92 , env ) )) 
  ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_extract_target , "procedure-extract-target" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-extract-target" , __funcarg91 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & struct_info_proc , sizeof (struct_info_proc ) ) )


  ; 
  struct_info_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (struct_info , 1 , "struct-info" , 1 , 1 , 0 , 2 , 2 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-info" , struct_info_proc , env ) ); 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (struct_type_info , 1 , "struct-type-info" , 1 , 1 , 0 , 8 , 8 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-info" , __funcarg90 , env ) )) 
  ; 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (struct_type_pred , "struct-type-make-predicate" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-make-predicate" , __funcarg89 , env ) )) 
  ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (struct_type_constr , "struct-type-make-constructor" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-make-constructor" , __funcarg88 , env ) )) 
  ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (struct_type_sealed_p , "struct-type-sealed?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-sealed?" , __funcarg87 , env ) )) 
  ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (struct_type_authentic_p , "struct-type-authentic?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-authentic?" , __funcarg86 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_struct_to_vector_proc , sizeof (scheme_struct_to_vector_proc ) ) )
  ; 
  scheme_struct_to_vector_proc = FUNCCALL_AGAIN(scheme_make_noncm_prim (struct_to_vector , "struct->vector" , 1 , 2 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct->vector" , scheme_struct_to_vector_proc , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (prefab_struct_key , "prefab-struct-key" , 1 , 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("prefab-struct-key" , p , env ) ); 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (prefab_struct_type_key , "prefab-struct-type-key+field-count" , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("prefab-struct-type-key+field-count" , __funcarg85 , env ) )) 
  ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (make_prefab_struct , "make-prefab-struct" , 1 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-prefab-struct" , __funcarg84 , env ) )) 
  ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (prefab_key_struct_type , "prefab-key->struct-type" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("prefab-key->struct-type" , __funcarg83 , env ) )) 
  ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (is_prefab_key , "prefab-key?" , 1 , 1 , 1 ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("prefab-key?" , __funcarg82 , env ) )) 
  ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_setter_p , "struct-mutator-procedure?" , 1 , 1 ) )





  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-mutator-procedure?" , __funcarg81 , env ) )) 
  ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_getter_p , "struct-accessor-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-accessor-procedure?" , __funcarg80 , env ) )) 
  ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_pred_p , "struct-predicate-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-predicate-procedure?" , __funcarg79 , env ) )) 
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_constr_p , "struct-constructor-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-constructor-procedure?" , __funcarg78 , env ) )) 
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_prop_getter_p , "struct-type-property-accessor-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-property-accessor-procedure?" , __funcarg77 , env ) )) 
  ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_prop_pred_p , "struct-type-property-predicate-procedure?" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-property-predicate-procedure?" , __funcarg76 , env ) )) 
  ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (chaperone_prop_getter_p , "impersonator-property-accessor-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonator-property-accessor-procedure?" , __funcarg75 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_inspector_proc , sizeof (scheme_make_inspector_proc ) ) )


  ; 
  scheme_make_inspector_proc = FUNCCALL_AGAIN(scheme_make_immed_prim (make_inspector , "make-inspector" , 0 , 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-inspector" , scheme_make_inspector_proc , env ) ); 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (make_sibling_inspector , "make-sibling-inspector" , 0 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-sibling-inspector" , __funcarg74 , env ) )) 
  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (inspector_p , "inspector?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("inspector?" , __funcarg73 , env ) )) 
  ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (inspector_superior_p , "inspector-superior?" , 2 , 2 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("inspector-superior?" , __funcarg72 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_current_inspector_proc , sizeof (scheme_current_inspector_proc ) ) )
  ; 
  scheme_current_inspector_proc = FUNCCALL_AGAIN(scheme_register_parameter (current_inspector , "current-inspector" , MZCONFIG_INSPECTOR ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-inspector" , scheme_current_inspector_proc , env ) )

  ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_code_inspector , "current-code-inspector" , MZCONFIG_CODE_INSPECTOR ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-code-inspector" , __funcarg71 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & ellipses_symbol , sizeof (ellipses_symbol ) ) )
  ; 
  ellipses_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("..." ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & prefab_symbol , sizeof (prefab_symbol ) ) )
  ; 
  prefab_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("prefab" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_source_property , sizeof (scheme_source_property ) ) )

  ; 
  {
#   define XfOrM4_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM4(x) SETUP_XfOrM2(x)

# 720 "bc/src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM4(_), scheme_make_prim_w_arity (check_exn_source_property_value_ok , "guard-for-prop:exn:srclocs" , 2 , 2 ) )

    ; 
    scheme_source_property = (__funcarg70 = FUNCCALL(SETUP_XfOrM4(_), scheme_intern_symbol ("prop:exn:srclocs" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg70 , guard ) )) 
    ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("prop:exn:srclocs" , scheme_source_property , env ) ); 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (exn_source_p , "exn:srclocs?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("exn:srclocs?" , __funcarg69 , env ) )) 
  ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (exn_source_get , "exn:srclocs-accessor" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("exn:srclocs-accessor" , __funcarg68 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_extract_checked_procedure , "checked-procedure-check-and-extract" , 5 , 5 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 2 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("checked-procedure-check-and-extract" , p , env ) ); 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_struct , "chaperone-struct" , 1 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-struct" , __funcarg67 , env ) )) 
  ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_struct , "impersonate-struct" , 1 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-struct" , __funcarg66 , env ) )) 
  ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_struct_type , "chaperone-struct-type" , 4 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-struct-type" , __funcarg65 , env ) )) 
  ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (make_chaperone_property , 1 , "make-impersonator-property" , 1 , 1 , 0 , 3 , 3 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-impersonator-property" , __funcarg64 , env ) )) 
  ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (chaperone_property_p , "impersonator-property?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonator-property?" , __funcarg63 , env ) )) 
  ; 

  {
#   define XfOrM3_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM3(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM3(_), scheme_register_static ((void * ) & scheme_app_mark_impersonator_property , sizeof (scheme_app_mark_impersonator_property ) ) )
# 772 "bc/src/struct.c"
    ; 
    scheme_app_mark_impersonator_property = (__funcarg62 = FUNCCALL(SETUP_XfOrM3(_), scheme_intern_symbol ("application-mark" ) ), FUNCCALL_AGAIN(make_chaperone_property_from_c (__funcarg62 ) )) ; 
    FUNCCALL_EMPTY(scheme_addto_prim_instance ("impersonator-prop:application-mark" , scheme_app_mark_impersonator_property , env ) )

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 780 "bc/src/struct.c"
void scheme_init_struct_wait () 
{
  /* No conversion */

# 782 "bc/src/struct.c"
  scheme_add_evt (scheme_structure_type , 
  (Scheme_Ready_Fun ) evt_struct_is_ready , 
  (Scheme_Needs_Wakeup_Fun ) evt_struct_needs_wakeup , 
  is_evt_struct , 1 ) ; 
  scheme_add_evt (scheme_proc_struct_type , 
  (Scheme_Ready_Fun ) evt_struct_is_ready , 
  ((void * ) 0 ) , 
  is_evt_struct , 1 ) ; 

  scheme_add_evt (scheme_wrap_evt_type , 
  (Scheme_Ready_Fun ) wrapped_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_handle_evt_type , 
  (Scheme_Ready_Fun ) wrapped_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_replace_evt_type , 
  (Scheme_Ready_Fun ) replace_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_active_replace_evt_type , 
  (Scheme_Ready_Fun ) active_replace_evt_is_ready , 
  active_replace_evt_needs_wakeup , 
  ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_chaperone_type , 
  (Scheme_Ready_Fun ) chaperone_evt_is_ready , 
  ((void * ) 0 ) , 
  is_chaperone_evt , 1 ) ; 
  scheme_add_evt (scheme_proc_chaperone_type , 
  (Scheme_Ready_Fun ) chaperone_evt_is_ready , 
  ((void * ) 0 ) , 
  is_chaperone_evt , 1 ) ; 
  scheme_add_evt (scheme_nack_guard_evt_type , 
  (Scheme_Ready_Fun ) nack_guard_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_nack_evt_type , 
  (Scheme_Ready_Fun ) nack_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_poll_evt_type , 
  (Scheme_Ready_Fun ) poll_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

# 834 "bc/src/struct.c"
Scheme_Object * scheme_make_initial_inspectors (void ) 
{
  Scheme_Inspector * superior , * root ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(superior, 0), PUSH(root, 1)));
# define XfOrM28_COUNT (2)
# define SETUP_XfOrM28(x) SETUP(XfOrM28_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  superior = NULLED_OUT ; 
  root = NULLED_OUT ; 

# 838 "bc/src/struct.c"
  superior = ((Scheme_Inspector * ) FUNCCALL(SETUP_XfOrM28(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Inspector ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  superior -> so . type = scheme_inspector_type ; 
  superior -> depth = 0 ; 

  root = ((Scheme_Inspector * ) FUNCCALL(SETUP_XfOrM28(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Inspector ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  root -> so . type = scheme_inspector_type ; 
  root -> depth = 1 ; 
  root -> superior = superior ; 

  RET_VALUE_START ((Scheme_Object * ) root ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 850 "bc/src/struct.c"
Scheme_Object * scheme_make_inspector (Scheme_Object * superior ) 
{
  Scheme_Inspector * naya ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(superior, 1)));
# define XfOrM29_COUNT (2)
# define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 854 "bc/src/struct.c"
  naya = ((Scheme_Inspector * ) FUNCCALL(SETUP_XfOrM29(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Inspector ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  naya -> so . type = scheme_inspector_type ; 
  naya -> depth = ((Scheme_Inspector * ) superior ) -> depth + 1 ; 
  naya -> superior = (Scheme_Inspector * ) superior ; 

  RET_VALUE_START ((Scheme_Object * ) naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 862 "bc/src/struct.c"
static Scheme_Object * make_inspector (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * superior ; 
  Scheme_Config * __funcarg127 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(superior, 0)));
# define XfOrM30_COUNT (1)
# define SETUP_XfOrM30(x) SETUP(XfOrM30_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  superior = NULLED_OUT ; 

# 866 "bc/src/struct.c"
  if (argc ) {
#   define XfOrM31_COUNT (0+XfOrM30_COUNT)
#   define SETUP_XfOrM31(x) SETUP_XfOrM30(x)

# 867 "bc/src/struct.c"
    superior = argv [0 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (superior ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (superior ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-inspector" , "inspector?" , 0 , argc , argv ) ); 
  }

# 870 "bc/src/struct.c"
  else 
  superior = (__funcarg127 = FUNCCALL(SETUP_XfOrM30(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg127 , MZCONFIG_INSPECTOR ) )) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_inspector (superior ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 876 "bc/src/struct.c"
static Scheme_Object * make_sibling_inspector (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * superior ; 
  Scheme_Config * __funcarg128 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(superior, 0)));
# define XfOrM32_COUNT (1)
# define SETUP_XfOrM32(x) SETUP(XfOrM32_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  superior = NULLED_OUT ; 

# 880 "bc/src/struct.c"
  if (argc ) {
#   define XfOrM33_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM33(x) SETUP_XfOrM32(x)

# 881 "bc/src/struct.c"
    superior = argv [0 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (superior ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (superior ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-sibling-inspector" , "inspector?" , 0 , argc , argv ) ); 
  }

# 884 "bc/src/struct.c"
  else 
  superior = (__funcarg128 = FUNCCALL(SETUP_XfOrM32(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg128 , MZCONFIG_INSPECTOR ) )) ; 

  superior = (Scheme_Object * ) ((Scheme_Inspector * ) superior ) -> superior ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_inspector (superior ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 892 "bc/src/struct.c"
static Scheme_Object * inspector_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 894 "bc/src/struct.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * inspector_superior_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 901 "bc/src/struct.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
    scheme_wrong_contract ("inspector-superior?" , "inspector?" , 0 , argc , argv ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
    scheme_wrong_contract ("inspector-superior?" , "inspector?" , 1 , argc , argv ) ; 

  return ((! ((argv [1 ] ) == (argv [0 ] ) ) && scheme_is_subinspector (argv [1 ] , argv [0 ] ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

int scheme_is_subinspector (Scheme_Object * i , Scheme_Object * sup ) 
{
  /* No conversion */

# 913 "bc/src/struct.c"
  Scheme_Inspector * ins , * superior ; 

  if (((i ) ) == (scheme_false ) ) 
    return 1 ; 
  if (((sup ) ) == (scheme_false ) ) 
    return 0 ; 

  ins = (Scheme_Inspector * ) i ; 
  superior = (Scheme_Inspector * ) sup ; 

  while (ins -> depth > superior -> depth ) {
    if (ins -> superior == superior )
      return 1 ; 
    ins = ins -> superior ; 
  }

  return 0 ; 
}

static Scheme_Object * current_inspector (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 934 "bc/src/struct.c"
  return scheme_param_config ("current-inspector" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_INSPECTOR ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , inspector_p , "inspector" , 0 ) ; 
}

static Scheme_Object * current_code_inspector (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 942 "bc/src/struct.c"
  return scheme_param_config ("current-code-inspector" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_CODE_INSPECTOR ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , inspector_p , "inspector" , 0 ) ; 
}





Scheme_Object * scheme_chaperone_props_get (Scheme_Object * props , Scheme_Object * prop ) 
{
  /* No conversion */

# 954 "bc/src/struct.c"
  if (! props )
    return ((void * ) 0 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
    int i ; 
    for (i = (((Scheme_Vector * ) (props ) ) -> size ) ; i > 0 ; ) {
      i -= 2 ; 
      if (((((Scheme_Vector * ) (props ) ) -> els ) [i ] ) == (prop ) ) 
        return (((Scheme_Vector * ) (props ) ) -> els ) [i + 1 ] ; 
    }
    return ((void * ) 0 ) ; 
  }

# 964 "bc/src/struct.c"
  else 
  return (Scheme_Object * ) scheme_hash_tree_get ((Scheme_Hash_Tree * ) props , prop ) ; 
}

Scheme_Object * scheme_chaperone_props_remove (Scheme_Object * props , Scheme_Object * prop ) 

{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(props, 0), PUSH(prop, 1)));
# define XfOrM45_COUNT (2)
# define SETUP_XfOrM45(x) SETUP(XfOrM45_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 971 "bc/src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
    Scheme_Object * vec ; 
    int i , j ; 
    BLOCK_SETUP((PUSH(vec, 0+XfOrM45_COUNT)));
#   define XfOrM46_COUNT (1+XfOrM45_COUNT)
#   define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
    vec = NULLED_OUT ; 

# 974 "bc/src/struct.c"
    j = (((Scheme_Vector * ) (props ) ) -> size ) ; 
    if (j == 2 )

# 975 "bc/src/struct.c"
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    vec = FUNCCALL(SETUP_XfOrM46(_), scheme_make_vector (j - 2 , ((void * ) 0 ) ) ); 
    for (i = (((Scheme_Vector * ) (props ) ) -> size ) , j = 0 ; i > 0 ; ) {
      i -= 2 ; 
      if (! (((((Scheme_Vector * ) (props ) ) -> els ) [i ] ) == (prop ) ) ) {
        (((Scheme_Vector * ) (vec ) ) -> els ) [j ++ ] = (((Scheme_Vector * ) (props ) ) -> els ) [i ] ; 
        (((Scheme_Vector * ) (vec ) ) -> els ) [j ++ ] = (((Scheme_Vector * ) (props ) ) -> els ) [i + 1 ] ; 
      }
    }
    RET_VALUE_START (vec ) RET_VALUE_END ; 
  }

# 985 "bc/src/struct.c"
  else 
  RET_VALUE_START ((Scheme_Object * ) FUNCCALL_EMPTY(scheme_hash_tree_set ((Scheme_Hash_Tree * ) props , prop , ((void * ) 0 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 989 "bc/src/struct.c"
static Scheme_Object * prop_pred (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * prop = ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] , * v ; 
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(prop, 0), PUSH(px, 1), PUSH(stype, 2), PUSH(v, 3)));
# define XfOrM51_COUNT (4)
# define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  v = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 995 "bc/src/struct.c"
  v = args [0 ] ; 

  while (1 ) {
#   define XfOrM60_COUNT (0+XfOrM51_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM51(x)

# 998 "bc/src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
#     define XfOrM63_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM63(x) SETUP_XfOrM60(x)

# 1000 "bc/src/struct.c"
      px = (Scheme_Chaperone * ) v ; 
      v = FUNCCALL(SETUP_XfOrM63(_), scheme_chaperone_props_get (px -> props , prop ) ); 
      if (v )
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
      v = px -> val ; 
    }

    if ((Scheme_Type ) (((((intptr_t ) (prop ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prop ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) )  {


      Scheme_Object * procs ; 
#     define XfOrM61_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM61(x) SETUP_XfOrM60(x)
      procs = NULLED_OUT ; 

# 1011 "bc/src/struct.c"
      procs = (scheme_struct_type_property_ref (scheme_impersonator_of_property , v ) ) ; 
      if (procs ) {
#       define XfOrM62_COUNT (0+XfOrM61_COUNT)
#       define SETUP_XfOrM62(x) SETUP_XfOrM61(x)

# 1013 "bc/src/struct.c"
        v = FUNCCALL(SETUP_XfOrM62(_), scheme_apply_impersonator_of (0 , procs , v ) ); 
        if (! v )
          RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
      }

# 1016 "bc/src/struct.c"
      else 
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

# 1018 "bc/src/struct.c"
    else 
    break ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
    stype = ((Scheme_Structure * ) v ) -> stype ; 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
    stype = (Scheme_Struct_Type * ) v ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  if (stype -> num_props < 0 ) {
#   define XfOrM55_COUNT (0+XfOrM51_COUNT)
#   define SETUP_XfOrM55(x) SETUP_XfOrM51(x)

# 1030 "bc/src/struct.c"
    if (FUNCCALL(SETUP_XfOrM55(_), scheme_hash_get ((Scheme_Hash_Table * ) stype -> props , prop ) ))
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  }

# 1032 "bc/src/struct.c"
  else {
    int i ; 
    for (i = stype -> num_props ; i -- ; ) {
      if (((((Scheme_Simple_Object * ) (stype -> props [i ] ) ) -> u . pair_val . car ) ) == (prop ) ) 
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1043 "bc/src/struct.c"
__xform_nongcing__ static Scheme_Object * do_prop_accessor (Scheme_Object * prop , Scheme_Object * arg ) 
{
  /* No conversion */

# 1045 "bc/src/struct.c"
  Scheme_Struct_Type * stype ; 

  if (((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
    stype = ((Scheme_Structure * ) arg ) -> stype ; 
  else if ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
    stype = (Scheme_Struct_Type * ) arg ; 
  else 
  stype = ((void * ) 0 ) ; 

  if (stype ) {
    if (stype -> num_props < 0 ) {
      Scheme_Object * v ; 
      v = (Scheme_Object * ) scheme_eq_hash_get ((Scheme_Hash_Table * ) stype -> props , prop ) ; 
      if (v )
        return v ; 
    }

# 1060 "bc/src/struct.c"
    else {
      int i ; 
      for (i = stype -> num_props ; i -- ; ) {
        if (((((Scheme_Simple_Object * ) (stype -> props [i ] ) ) -> u . pair_val . car ) ) == (prop ) ) 
          return (((Scheme_Simple_Object * ) (stype -> props [i ] ) ) -> u . pair_val . cdr ) ; 
      }
    }
  }

  return ((void * ) 0 ) ; 
}

static Scheme_Object * do_chaperone_prop_accessor (const char * who , Scheme_Object * prop , 
Scheme_Object * orig_arg , Scheme_Object * arg ) ; 

static Scheme_Object * chaperone_prop_acc_k (void ) 
{
  /* No conversion */

# 1077 "bc/src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * arg = (Scheme_Object * ) p -> ku . k . p2 ; 
  const char * who = (const char * ) p -> ku . k . p3 ; 
  Scheme_Object * orig_arg = (Scheme_Object * ) p -> ku . k . p4 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  return do_chaperone_prop_accessor (who , o , orig_arg , arg ) ; 
}

static Scheme_Object * chaperone_prop_acc_overflow (const char * who , Scheme_Object * o , 
Scheme_Object * orig_arg , Scheme_Object * arg ) 
{
  /* No conversion */

# 1094 "bc/src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = (void * ) o ; 
  p -> ku . k . p2 = (void * ) arg ; 
  p -> ku . k . p3 = (void * ) who ; 
  p -> ku . k . p4 = (void * ) orig_arg ; 

  return scheme_handle_stack_overflow (chaperone_prop_acc_k ) ; 
}

static Scheme_Object * do_chaperone_prop_accessor (const char * who , Scheme_Object * prop , 
Scheme_Object * orig_arg , Scheme_Object * arg ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(prop, 0), PUSH(who, 1), PUSH(arg, 2), PUSH(orig_arg, 3)));
# define XfOrM72_COUNT (4)
# define SETUP_XfOrM72(x) SETUP(XfOrM72_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1107 "bc/src/struct.c"
  while (1 ) {
#   define XfOrM85_COUNT (0+XfOrM72_COUNT)
#   define SETUP_XfOrM85(x) SETUP_XfOrM72(x)

# 1108 "bc/src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
      Scheme_Chaperone * px = (Scheme_Chaperone * ) arg ; 
      Scheme_Object * a [2 ] , * red , * orig ; 
      Scheme_Object * v ; 
      Scheme_Hash_Tree * ht ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM85_COUNT), PUSH(ht, 3+XfOrM85_COUNT), PUSH(px, 4+XfOrM85_COUNT), PUSH(orig, 5+XfOrM85_COUNT), PUSH(v, 6+XfOrM85_COUNT), PUSH(red, 7+XfOrM85_COUNT)));
#     define XfOrM91_COUNT (8+XfOrM85_COUNT)
#     define SETUP_XfOrM91(x) SETUP(XfOrM91_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      red = NULLED_OUT ; 
      orig = NULLED_OUT ; 
      v = NULLED_OUT ; 
      ht = NULLED_OUT ; 

# 1114 "bc/src/struct.c"
      v = FUNCCALL(SETUP_XfOrM91(_), scheme_chaperone_props_get (px -> props , prop ) ); 
      if (v )
        RET_VALUE_START (v ) RET_VALUE_END ; 

      if (! (((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      || ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ) ) == (scheme_false ) ) )
        arg = px -> prev ; 
      else {
#       define XfOrM92_COUNT (0+XfOrM91_COUNT)
#       define SETUP_XfOrM92(x) SETUP_XfOrM91(x)

# 1122 "bc/src/struct.c"
        ht = (Scheme_Hash_Tree * ) (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ; 
        if (ht )
          red = FUNCCALL(SETUP_XfOrM92(_), scheme_hash_tree_get (ht , prop ) ); 
        else 
        red = ((void * ) 0 ) ; 
        if (! red )
          arg = px -> prev ; 
        else {
#         define XfOrM93_COUNT (0+XfOrM92_COUNT)
#         define SETUP_XfOrM93(x) SETUP_XfOrM92(x)

# 1131 "bc/src/struct.c"
          {

# 24 "bc/src/mzstkchk.h"
            uintptr_t _stk_pos ; 
#           define XfOrM96_COUNT (0+XfOrM93_COUNT)
#           define SETUP_XfOrM96(x) SETUP_XfOrM93(x)

# 26 "bc/src/mzstkchk.h"
            _stk_pos = (uintptr_t ) & _stk_pos ; 

            if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
            && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 1133 "bc/src/struct.c"
            RET_VALUE_START (FUNCCALL(SETUP_XfOrM96(_), chaperone_prop_acc_overflow (who , prop , orig_arg , arg ) )) RET_VALUE_END ; 
          }


          arg = px -> prev ; 
          if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#           define XfOrM95_COUNT (0+XfOrM93_COUNT)
#           define SETUP_XfOrM95(x) SETUP_XfOrM93(x)

            a [0 ] = arg ; 
            orig = FUNCCALL(SETUP_XfOrM95(_), scheme_do_eval ((((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . car ) , 1 , a , 1 ) ); 
            red = (((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . cdr ) ; 
          }

# 1145 "bc/src/struct.c"
          else {
#           define XfOrM94_COUNT (0+XfOrM93_COUNT)
#           define SETUP_XfOrM94(x) SETUP_XfOrM93(x)

# 1146 "bc/src/struct.c"
            orig = FUNCCALL(SETUP_XfOrM94(_), do_chaperone_prop_accessor (who , prop , orig_arg , arg ) ); 
          }

          if (! orig )

# 1149 "bc/src/struct.c"
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

          a [0 ] = orig_arg ; 
          a [1 ] = orig ; 
          v = FUNCCALL(SETUP_XfOrM93(_), scheme_do_eval (red , 2 , a , 1 ) ); 

          if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
            if (! FUNCCALL(SETUP_XfOrM93(_), scheme_chaperone_of (v , orig ) ))
            FUNCCALL(SETUP_XfOrM93(_), scheme_wrong_chaperoned (who , "result" , orig , v ) ); 

          RET_VALUE_START (v ) RET_VALUE_END ; 
        }
      }
    }

# 1162 "bc/src/struct.c"
    else {
#     define XfOrM86_COUNT (0+XfOrM85_COUNT)
#     define SETUP_XfOrM86(x) SETUP_XfOrM85(x)

# 1163 "bc/src/struct.c"
      if ((Scheme_Type ) (((((intptr_t ) (prop ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prop ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) )  {
        Scheme_Object * procs ; 
#       define XfOrM88_COUNT (0+XfOrM86_COUNT)
#       define SETUP_XfOrM88(x) SETUP_XfOrM86(x)
        procs = NULLED_OUT ; 

# 1165 "bc/src/struct.c"
        procs = (scheme_struct_type_property_ref (scheme_impersonator_of_property , arg ) ) ; 
        if (procs ) {
#         define XfOrM90_COUNT (0+XfOrM88_COUNT)
#         define SETUP_XfOrM90(x) SETUP_XfOrM88(x)

# 1167 "bc/src/struct.c"
          arg = FUNCCALL(SETUP_XfOrM90(_), scheme_apply_impersonator_of (0 , procs , arg ) ); 
          if (! arg )
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        else {

          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }

# 1175 "bc/src/struct.c"
      else {
#       define XfOrM87_COUNT (0+XfOrM86_COUNT)
#       define SETUP_XfOrM87(x) SETUP_XfOrM86(x)

# 1176 "bc/src/struct.c"
        RET_VALUE_START ((do_prop_accessor (prop , arg ) ) ) RET_VALUE_END ; 
      }
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1182 "bc/src/struct.c"
static Scheme_Object * prop_accessor (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(args, 1), PUSH(prim, 2)));
# define XfOrM97_COUNT (3)
# define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 1186 "bc/src/struct.c"
  v = args [0 ] ; 
  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) )
    v = FUNCCALL(SETUP_XfOrM97(_), do_chaperone_prop_accessor (((Scheme_Primitive_Proc * ) prim ) -> name , ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] , v , v ) )
  ; 
  else 
  v = (do_prop_accessor (((Scheme_Primitive_Closure * ) prim ) -> val [0 ] , v ) ) ; 

  if (v )
    RET_VALUE_START (v ) RET_VALUE_END ; 
  else if (argc == 1 ) {
    Scheme_Struct_Property * prop = (Scheme_Struct_Property * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
    const char * ctc ; 
    BLOCK_SETUP((PUSH(prop, 0+XfOrM97_COUNT), PUSH(ctc, 1+XfOrM97_COUNT)));
#   define XfOrM99_COUNT (2+XfOrM97_COUNT)
#   define SETUP_XfOrM99(x) SETUP(XfOrM99_COUNT)
    ctc = NULLED_OUT ; 

# 1199 "bc/src/struct.c"
    if (prop -> contract_name ) {
#     define XfOrM100_COUNT (0+XfOrM99_COUNT)
#     define SETUP_XfOrM100(x) SETUP_XfOrM99(x)

# 1200 "bc/src/struct.c"
      if ((Scheme_Type ) (((((intptr_t ) (prop -> contract_name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prop -> contract_name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
        ctc = FUNCCALL(SETUP_XfOrM100(_), scheme_symbol_val (prop -> contract_name ) ); 
      else 
      ctc = (((Scheme_Simple_Object * ) (FUNCCALL(SETUP_XfOrM100(_), scheme_char_string_to_byte_string (prop -> contract_name ) )) ) -> u . byte_str_val . string_val ) ; 
    }

# 1204 "bc/src/struct.c"
    else 
    ctc = FUNCCALL(SETUP_XfOrM99(_), pred_name_string (prop -> name ) ); 
    FUNCCALL_EMPTY(scheme_wrong_contract (((Scheme_Primitive_Proc * ) prim ) -> name , ctc , 0 , 1 , args ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 1208 "bc/src/struct.c"
  else {
#   define XfOrM98_COUNT (0+XfOrM97_COUNT)
#   define SETUP_XfOrM98(x) SETUP_XfOrM97(x)

# 1209 "bc/src/struct.c"
    v = args [1 ] ; 
    if (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (v , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1217 "bc/src/struct.c"
static Scheme_Object * make_struct_type_property_from_c (int argc , Scheme_Object * argv [] , 
Scheme_Object * * predout , Scheme_Object * * accessout , 
Scheme_Type type ) 
{

  Scheme_Struct_Property * p ; 
  Scheme_Object * a [1 ] , * v , * supers = scheme_null ; 
  char * name ; 
  int len ; 
  const char * who ; 
  char can_impersonate = 0 ; 
  Scheme_Object * accessor_name = ((void * ) 0 ) , * contract_name = ((void * ) 0 ) , * realm = scheme_default_realm ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(15);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(realm, 1), PUSH(supers, 2), PUSH(who, 3), PUSH(accessor_name, 4), PUSH(predout, 5), PUSH(contract_name, 6), PUSHARRAY(a, 1, 7), PUSH(v, 10), PUSH(accessout, 11), PUSH(argv, 12), PUSH(p, 13)));
# define XfOrM101_COUNT (14)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  v = NULLED_OUT ; 
  name = NULLED_OUT ; 
  who = NULLED_OUT ; 

# 1230 "bc/src/struct.c"
  if (type == scheme_struct_property_type )
    who = "make-struct-type-property" ; 
  else 
  who = "make-impersonator-property" ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL(SETUP_XfOrM101(_), scheme_wrong_contract (who , "symbol?" , 0 , argc , argv ) ); 
  if (argc > 1 ) {
#   define XfOrM104_COUNT (0+XfOrM101_COUNT)
#   define SETUP_XfOrM104(x) SETUP_XfOrM101(x)

# 1238 "bc/src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    && ! ((& ((Scheme_Symbol * ) (argv [1 ] ) ) -> iso ) -> so . keyex & 0x3 ) 
    && ! (strcmp ("can-impersonate" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [1 ] ) ) ) -> s ) ) ) ) {
      can_impersonate = 1 ; 
    }

# 1242 "bc/src/struct.c"
    else if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) 
    && ! FUNCCALL(SETUP_XfOrM104(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 1 , argc , argv ) ))
      FUNCCALL(SETUP_XfOrM104(_), scheme_wrong_contract (who , "(or/c (any/c any/c . -> . any) #f 'can-impersonate)" , 1 , argc , argv ) ); 

    if (argc > 2 ) {
#     define XfOrM105_COUNT (0+XfOrM104_COUNT)
#     define SETUP_XfOrM105(x) SETUP_XfOrM104(x)

# 1247 "bc/src/struct.c"
      supers = argv [2 ] ; 
      if ((scheme_proper_list_length (supers ) ) < 0 )
        supers = ((void * ) 0 ) ; 
      else {
        Scheme_Object * pr ; 
        BLOCK_SETUP((PUSH(pr, 0+XfOrM105_COUNT)));
#       define XfOrM113_COUNT (1+XfOrM105_COUNT)
#       define SETUP_XfOrM113(x) SETUP(XfOrM113_COUNT)
        pr = NULLED_OUT ; 

# 1252 "bc/src/struct.c"
        for (pr = supers ; supers && ((Scheme_Type ) (((((intptr_t ) (pr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pr ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ) {
#         define XfOrM117_COUNT (0+XfOrM113_COUNT)
#         define SETUP_XfOrM117(x) SETUP_XfOrM113(x)

# 1253 "bc/src/struct.c"
          v = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ; 
          if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
            supers = ((void * ) 0 ) ; 
          }

# 1256 "bc/src/struct.c"
          else {
#           define XfOrM118_COUNT (0+XfOrM117_COUNT)
#           define SETUP_XfOrM118(x) SETUP_XfOrM117(x)

# 1257 "bc/src/struct.c"
            if (! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) )
              supers = ((void * ) 0 ) ; 
            a [0 ] = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
            if (! FUNCCALL(SETUP_XfOrM118(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , a ) ))
              supers = ((void * ) 0 ) ; 
          }
        }
      }

      if (! supers ) {
#       define XfOrM112_COUNT (0+XfOrM105_COUNT)
#       define SETUP_XfOrM112(x) SETUP_XfOrM105(x)
        FUNCCALL(SETUP_XfOrM112(_), scheme_wrong_contract (who , "(listof (cons struct-type-property? (any/c . -> . any)))" , 2 , argc , argv ) ); 
      }

      if (argc > 3 ) {
#       define XfOrM106_COUNT (0+XfOrM105_COUNT)
#       define SETUP_XfOrM106(x) SETUP_XfOrM105(x)

# 1273 "bc/src/struct.c"
        can_impersonate = (! (((argv [3 ] ) ) == (scheme_false ) ) ) ; 

        if (argc > 4 ) {
#         define XfOrM107_COUNT (0+XfOrM106_COUNT)
#         define SETUP_XfOrM107(x) SETUP_XfOrM106(x)

# 1276 "bc/src/struct.c"
          if (! (((argv [4 ] ) ) == (scheme_false ) ) )  {
#           define XfOrM111_COUNT (0+XfOrM107_COUNT)
#           define SETUP_XfOrM111(x) SETUP_XfOrM107(x)

# 1277 "bc/src/struct.c"
            accessor_name = argv [4 ] ; 
            if (! ((Scheme_Type ) (((((intptr_t ) (accessor_name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (accessor_name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
              FUNCCALL(SETUP_XfOrM111(_), scheme_wrong_contract (who , "(or/c symbol? #f)" , 5 , argc , argv ) ); 
          }

          if (argc > 5 ) {
#           define XfOrM108_COUNT (0+XfOrM107_COUNT)
#           define SETUP_XfOrM108(x) SETUP_XfOrM107(x)

# 1283 "bc/src/struct.c"
            if (! (((argv [5 ] ) ) == (scheme_false ) ) )  {
#             define XfOrM110_COUNT (0+XfOrM108_COUNT)
#             define SETUP_XfOrM110(x) SETUP_XfOrM108(x)

# 1284 "bc/src/struct.c"
              contract_name = argv [5 ] ; 
              if (! ((Scheme_Type ) (((((intptr_t ) (contract_name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (contract_name ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (contract_name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (contract_name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
                FUNCCALL(SETUP_XfOrM110(_), scheme_wrong_contract (who , "(or/c string? symbol? #f)" , 5 , argc , argv ) ); 
            }

            if (argc > 6 ) {
#             define XfOrM109_COUNT (0+XfOrM108_COUNT)
#             define SETUP_XfOrM109(x) SETUP_XfOrM108(x)

# 1290 "bc/src/struct.c"
              realm = argv [6 ] ; 
              if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
                FUNCCALL(SETUP_XfOrM109(_), scheme_wrong_contract (who , "symbol?" , 6 , argc , argv ) ); 
            }
          }
        }
      }
    }
  }

  p = ((Scheme_Struct_Property * ) FUNCCALL(SETUP_XfOrM101(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Struct_Property ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  p -> so . type = type ; 
  p -> name = argv [0 ] ; 
  if ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) )
    p -> guard = argv [1 ] ; 
  p -> supers = supers ; 
  p -> can_impersonate = can_impersonate ; 
  p -> contract_name = contract_name ; 
  p -> realm = realm ; 

  a [0 ] = (Scheme_Object * ) p ; 

  len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> len ) ; 
  name = ((char * ) FUNCCALL(SETUP_XfOrM101(_), GC_malloc_atomic (sizeof (char ) * (len + 2 ) ) )) ; 
  (memcpy (name , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> s ) , len ) ) ; 
  name [len ] = '?' ; 
  name [len + 1 ] = 0 ; 

  v = FUNCCALL(SETUP_XfOrM101(_), scheme_make_folding_prim_closure (prop_pred , 1 , a , name , 1 , 1 , 0 ) ); 
  ((Scheme_Closed_Primitive_Proc * ) v ) -> pp . flags |= (64 | 128 | 256 ) ; 
  * predout = v ; 

  if (accessor_name ) {
#   define XfOrM103_COUNT (0+XfOrM101_COUNT)
#   define SETUP_XfOrM103(x) SETUP_XfOrM101(x)

# 1323 "bc/src/struct.c"
    name = FUNCCALL(SETUP_XfOrM103(_), scheme_symbol_val (accessor_name ) ); 
  }

# 1324 "bc/src/struct.c"
  else {
#   define XfOrM102_COUNT (0+XfOrM101_COUNT)
#   define SETUP_XfOrM102(x) SETUP_XfOrM101(x)

# 1325 "bc/src/struct.c"
    name = ((char * ) FUNCCALL(SETUP_XfOrM102(_), GC_malloc_atomic (sizeof (char ) * (len + 10 ) ) )) ; 
    (memcpy (name , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> s ) , len ) ) ; 
    (memcpy (name + len , "-accessor" , 10 ) ) ; 
  }

  v = FUNCCALL(SETUP_XfOrM101(_), scheme_make_prim_closure_w_arity (prop_accessor , 1 , a , name , 1 , 2 ) ); 
  ((Scheme_Closed_Primitive_Proc * ) v ) -> pp . flags |= (64 | 128 ) ; 

  * accessout = v ; 

  RET_VALUE_START (a [0 ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1338 "bc/src/struct.c"
static Scheme_Object * make_struct_type_property (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0)));
# define XfOrM121_COUNT (3)
# define SETUP_XfOrM121(x) SETUP(XfOrM121_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 1341 "bc/src/struct.c"
  a [0 ] = FUNCCALL(SETUP_XfOrM121(_), make_struct_type_property_from_c (argc , argv , & a [1 ] , & a [2 ] , scheme_struct_property_type ) ); 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM121(_), scheme_values (3 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1345 "bc/src/struct.c"
static Scheme_Object * make_chaperone_property (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0)));
# define XfOrM122_COUNT (3)
# define SETUP_XfOrM122(x) SETUP(XfOrM122_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 1348 "bc/src/struct.c"
  a [0 ] = FUNCCALL(SETUP_XfOrM122(_), make_struct_type_property_from_c (argc , argv , & a [1 ] , & a [2 ] , scheme_chaperone_property_type ) ); 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM122(_), scheme_values (3 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1352 "bc/src/struct.c"
static Scheme_Object * make_chaperone_property_from_c (Scheme_Object * name ) 
{
  Scheme_Object * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0)));
# define XfOrM123_COUNT (3)
# define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 1356 "bc/src/struct.c"
  a [0 ] = name ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM123(_), make_struct_type_property_from_c (1 , a , & a [1 ] , & a [2 ] , scheme_chaperone_property_type ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1360 "bc/src/struct.c"
Scheme_Object * scheme_make_struct_type_property_w_guard (Scheme_Object * name , Scheme_Object * guard ) 
{
  Scheme_Object * a [2 ] ; 
  Scheme_Object * pred = ((void * ) 0 ) ; 
  Scheme_Object * access = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(pred, 3), PUSH(access, 4)));
# define XfOrM124_COUNT (5)
# define SETUP_XfOrM124(x) SETUP(XfOrM124_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1366 "bc/src/struct.c"
  a [0 ] = name ; 
  a [1 ] = guard ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM124(_), make_struct_type_property_from_c (2 , a , & pred , & access , scheme_struct_property_type ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1371 "bc/src/struct.c"
Scheme_Object * scheme_make_struct_type_property (Scheme_Object * name ) 
{
  /* No conversion */

# 1373 "bc/src/struct.c"
  return scheme_make_struct_type_property_w_guard (name , scheme_false ) ; 
}

Scheme_Object * scheme_chaperone_struct_type_property_ref (Scheme_Object * prop , Scheme_Object * s ) 
{
  /* No conversion */

# 1378 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    return do_chaperone_prop_accessor ("impersonator-property-ref" , prop , s , s ) ; 
  else 
  return do_prop_accessor (prop , s ) ; 
}

Scheme_Object * scheme_struct_type_property_ref (Scheme_Object * prop , Scheme_Object * s ) 
{
  /* No conversion */

# 1386 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (((Scheme_Chaperone * ) s ) -> val ) ; 
  return do_prop_accessor (prop , s ) ; 
}

static Scheme_Object * struct_type_property_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1393 "bc/src/struct.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * chaperone_property_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1399 "bc/src/struct.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * guard_property (Scheme_Object * prop , Scheme_Object * v , Scheme_Struct_Type * t ) 
{
  Scheme_Struct_Property * p = (Scheme_Struct_Property * ) prop ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(p, 1)));
# define XfOrM130_COUNT (2)
# define SETUP_XfOrM130(x) SETUP(XfOrM130_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1407 "bc/src/struct.c"
  if ((prop ) == (proc_property ) )  {

    Scheme_Object * orig_v = v ; 
#   define XfOrM134_COUNT (0+XfOrM130_COUNT)
#   define SETUP_XfOrM134(x) SETUP_XfOrM130(x)

# 1410 "bc/src/struct.c"
    if ((((intptr_t ) (v ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
      intptr_t pos ; 
#     define XfOrM139_COUNT (0+XfOrM134_COUNT)
#     define SETUP_XfOrM139(x) SETUP_XfOrM134(x)

# 1413 "bc/src/struct.c"
      if (((intptr_t ) (v ) ) & 0x1 ) 
        pos = (((intptr_t ) (v ) ) >> 1 ) ; 
      else if ((& ((Scheme_Bignum * ) v ) -> iso ) -> so . keyex & 0x1 ) 
        pos = t -> num_slots ; 
      else 
      pos = - 1 ; 

      if (pos >= 0 ) {
        Scheme_Struct_Type * parent_type ; 
        intptr_t field_count ; 
#       define XfOrM140_COUNT (0+XfOrM139_COUNT)
#       define SETUP_XfOrM140(x) SETUP_XfOrM139(x)
        parent_type = NULLED_OUT ; 

# 1424 "bc/src/struct.c"
        if (t -> name_pos > 0 )
          parent_type = t -> parent_types [t -> name_pos - 1 ] ; 
        else 
        parent_type = ((void * ) 0 ) ; 

        field_count = (t -> num_islots - (parent_type ? parent_type -> num_islots : 0 ) ) ; 
        if (pos >= field_count ) {
#         define XfOrM142_COUNT (0+XfOrM140_COUNT)
#         define SETUP_XfOrM142(x) SETUP_XfOrM140(x)
          FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "index for procedure >= initialized-field count" , "index" , 1 , v , "field count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (field_count ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )

          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }

        if (parent_type ) {

          pos += parent_type -> num_slots ; 
          v = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) ; 
        }
      }

# 1444 "bc/src/struct.c"
      else 
      v = scheme_false ; 
    }

    if ((((intptr_t ) (v ) ) & 0x1 ) || (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
    }
    else {
#     define XfOrM137_COUNT (0+XfOrM134_COUNT)
#     define SETUP_XfOrM137(x) SETUP_XfOrM134(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "given value did not satisfy the contract for prop:procedure" , "expected" , 0 , "(or/c procedure? exact-nonnegative-integer?)" , "given" , 1 , orig_v , ((void * ) 0 ) ) )

      ; 
    }

    t -> proc_attr = v ; 

    if (((intptr_t ) (v ) ) & 0x1 )  {
      intptr_t pos ; 
#     define XfOrM135_COUNT (0+XfOrM134_COUNT)
#     define SETUP_XfOrM135(x) SETUP_XfOrM134(x)

# 1462 "bc/src/struct.c"
      pos = (((intptr_t ) (orig_v ) ) >> 1 ) ; 
      if (! t -> immutables || ! t -> immutables [pos ] ) {
#       define XfOrM136_COUNT (0+XfOrM135_COUNT)
#       define SETUP_XfOrM136(x) SETUP_XfOrM135(x)
        FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "field is not specified as immutable for a prop:procedure index" , "index" , 1 , orig_v , ((void * ) 0 ) ) )
        ; 
      }
    }

    RET_VALUE_START (orig_v ) RET_VALUE_END ; 
  }

# 1472 "bc/src/struct.c"
  else {
#   define XfOrM131_COUNT (0+XfOrM130_COUNT)
#   define SETUP_XfOrM131(x) SETUP_XfOrM130(x)

# 1474 "bc/src/struct.c"
    if (p -> guard && ! ((Scheme_Type ) (((((intptr_t ) (p -> guard ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p -> guard ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#     define XfOrM132_COUNT (0+XfOrM131_COUNT)
#     define SETUP_XfOrM132(x) SETUP_XfOrM131(x)

# 1475 "bc/src/struct.c"
      if (! scheme_defining_primitives ) {
        Scheme_Object * a [2 ] , * info [8 ] , * l ; 
        BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM132_COUNT), PUSH(l, 3+XfOrM132_COUNT), PUSHARRAY(info, 8, 4+XfOrM132_COUNT)));
#       define XfOrM133_COUNT (7+XfOrM132_COUNT)
#       define SETUP_XfOrM133(x) SETUP(XfOrM133_COUNT)
        a[0] = NULLED_OUT ; 
        a[1] = NULLED_OUT ; 
        NULL_OUT_ARRAY (info ) ; 
        l = NULLED_OUT ; 

# 1478 "bc/src/struct.c"
        a [0 ] = (Scheme_Object * ) t ; 
        FUNCCALL(SETUP_XfOrM133(_), get_struct_type_info (1 , a , info , 1 ) ); 

        l = FUNCCALL_AGAIN(scheme_build_list (8 , info ) ); 

        a [0 ] = v ; 
        a [1 ] = l ; 

        RET_VALUE_START (FUNCCALL(SETUP_XfOrM133(_), scheme_do_eval (p -> guard , 2 , a , 1 ) )) RET_VALUE_END ; 
      }
      else 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

# 1490 "bc/src/struct.c"
    else 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int extract_accessor_offset (Scheme_Object * acc ) 
{
  /* No conversion */

# 1501 "bc/src/struct.c"
  Scheme_Struct_Type * st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) acc ) -> val [0 ] ; 

  if (st -> name_pos )
    return st -> parent_types [st -> name_pos - 1 ] -> num_slots ; 
  else 
  return 0 ; 
}

static char * extract_field_proc_name (Scheme_Object * prim ) 
{
  /* No conversion */

# 1511 "bc/src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (prim ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prim ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) 
    return (char * ) ((Scheme_Closed_Primitive_Proc * ) prim ) -> name ; 
  else 
  return (char * ) ((Scheme_Primitive_Proc * ) prim ) -> name ; 
}

static char * extract_field_proc_name_and_realm (Scheme_Object * st_name , Scheme_Object * prim , char * * _pred_name , Scheme_Object * * _realm ) 
{
  Scheme_Object * name_info ; 
  char * pred_name ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(name_info, 0), PUSH(pred_name, 1), PUSH(_realm, 2), PUSH(prim, 3), PUSH(_pred_name, 4)));
# define XfOrM145_COUNT (5)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name_info = NULLED_OUT ; 
  pred_name = NULLED_OUT ; 

# 1522 "bc/src/struct.c"
  name_info = ((Scheme_Primitive_Closure * ) prim ) -> val [2 ] ; 
  if ((Scheme_Type ) (((((intptr_t ) (name_info ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name_info ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#   define XfOrM148_COUNT (0+XfOrM145_COUNT)
#   define SETUP_XfOrM148(x) SETUP_XfOrM145(x)

# 1524 "bc/src/struct.c"
    * _realm = name_info ; 
    pred_name = FUNCCALL(SETUP_XfOrM148(_), pred_name_string (st_name ) ); 
  }

# 1526 "bc/src/struct.c"
  else {
#   define XfOrM146_COUNT (0+XfOrM145_COUNT)
#   define SETUP_XfOrM146(x) SETUP_XfOrM145(x)

# 1527 "bc/src/struct.c"
    * _realm = (((Scheme_Simple_Object * ) (name_info ) ) -> u . pair_val . car ) ; 
    name_info = (((Scheme_Simple_Object * ) (name_info ) ) -> u . pair_val . cdr ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (name_info ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name_info ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
      pred_name = FUNCCALL(SETUP_XfOrM146(_), scheme_symbol_val (name_info ) ); 
    else {
#     define XfOrM147_COUNT (0+XfOrM146_COUNT)
#     define SETUP_XfOrM147(x) SETUP_XfOrM146(x)

# 1532 "bc/src/struct.c"
      name_info = FUNCCALL(SETUP_XfOrM147(_), scheme_char_string_to_byte_string (name_info ) ); 
      pred_name = (((Scheme_Simple_Object * ) (name_info ) ) -> u . byte_str_val . string_val ) ; 
    }
  }

  * _pred_name = pred_name ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(extract_field_proc_name (prim ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1542 "bc/src/struct.c"
typedef int (* Check_Val_Proc ) (Scheme_Object * ) ; 

static void wrong_property_contract (const char * name , const char * contract , Scheme_Object * v ) 
{
  /* No conversion */

# 1546 "bc/src/struct.c"
  scheme_contract_error (name , 
  "contract violation for given property value" , 
  "expected" , 0 , contract , 
  "given" , 1 , v , 
  ((void * ) 0 ) ) ; 
}

static Scheme_Object * check_indirect_property_value_ok (const char * name , Check_Val_Proc ck , int proc_ok , 
const char * contract , 
int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v , * l , * acc ; 
  int pos , num_islots ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(l, 1), PUSH(argv, 2), PUSH(contract, 3), PUSH(v, 4), PUSH(acc, 5)));
# define XfOrM150_COUNT (6)
# define SETUP_XfOrM150(x) SETUP(XfOrM150_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  l = NULLED_OUT ; 
  acc = NULLED_OUT ; 

# 1560 "bc/src/struct.c"
  v = argv [0 ] ; 

  if (FUNCCALL(SETUP_XfOrM150(_), ck (v ) ))
    RET_VALUE_START (v ) RET_VALUE_END ; 

  if (proc_ok && FUNCCALL(SETUP_XfOrM150(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , & v ) ))
    RET_VALUE_START (v ) RET_VALUE_END ; 

  if (! (((((intptr_t ) (v ) ) & 0x1 ) && ((((intptr_t ) (v ) ) >> 1 ) >= 0 ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) v ) -> iso ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL(SETUP_XfOrM150(_), wrong_property_contract (name , contract , v ) ); 

  l = argv [1 ] ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  num_islots = (((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  acc = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
    pos = num_islots ; 
  else 
  pos = (((intptr_t ) (v ) ) >> 1 ) ; 

  if (pos >= num_islots ) {
#   define XfOrM154_COUNT (0+XfOrM150_COUNT)
#   define SETUP_XfOrM154(x) SETUP_XfOrM150(x)
    FUNCCALL(SETUP_XfOrM154(_), scheme_contract_error (name , "field index >= initialized-field count for structure type" , "field index" , 1 , v , "initialized-field count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_islots ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )

    ; 
  }

  for (; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
    if ((((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) >> 1 ) == pos )
      break ; 
  }

  if (! ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM151_COUNT (0+XfOrM150_COUNT)
#   define SETUP_XfOrM151(x) SETUP_XfOrM150(x)
    FUNCCALL(SETUP_XfOrM151(_), scheme_contract_error (name , "field index not declared immutable" , "field index" , 1 , v , ((void * ) 0 ) ) )
    ; 
  }

  pos += FUNCCALL(SETUP_XfOrM150(_), extract_accessor_offset (acc ) ); 
  v = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1613 "bc/src/struct.c"
static int is_evt_or_poller (Scheme_Object * v ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM155_COUNT (1)
# define SETUP_XfOrM155(x) SETUP(XfOrM155_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1615 "bc/src/struct.c"
  if (FUNCCALL(SETUP_XfOrM155(_), scheme_is_evt (v ) ))
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (scheme_is_struct_instance (poller_struct , v ) ) ) 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1622 "bc/src/struct.c"
static Scheme_Object * check_evt_property_value_ok (int argc , Scheme_Object * argv [] ) 

{
  /* No conversion */

# 1625 "bc/src/struct.c"
  return check_indirect_property_value_ok ("guard-for-prop:evt" , 
  is_evt_or_poller , 1 , 
  "(or/c evt? (any/c . -> . any) exact-nonnegative-integer?)" , 
  argc , argv ) ; 
}

static Scheme_Object * return_wrapped (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1633 "bc/src/struct.c"
  return (Scheme_Object * ) data ; 
}

static Scheme_Object * return_wrapped_multi (void * data , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * * a , * l = (Scheme_Object * ) data ; 
  int i , n ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(l, 1)));
# define XfOrM158_COUNT (2)
# define SETUP_XfOrM158(x) SETUP(XfOrM158_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 1641 "bc/src/struct.c"
  n = (scheme_list_length (l ) ) ; 
  a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM158(_), GC_malloc (sizeof (Scheme_Object * ) * (n ) ) )) ; 
  for (i = 0 ; i < n ; i ++ ) {
    a [i ] = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (n , a ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1651 "bc/src/struct.c"
static int evt_struct_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(sinfo, 1), PUSH(v, 2)));
# define XfOrM161_COUNT (3)
# define SETUP_XfOrM161(x) SETUP(XfOrM161_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 1655 "bc/src/struct.c"
  v = (scheme_struct_type_property_ref (evt_property , o ) ) ; 

  if (! v ) {
#   define XfOrM178_COUNT (0+XfOrM161_COUNT)
#   define SETUP_XfOrM178(x) SETUP_XfOrM161(x)

# 1659 "bc/src/struct.c"
    if (scheme_is_input_port (o ) )  {
#     define XfOrM180_COUNT (0+XfOrM178_COUNT)
#     define SETUP_XfOrM180(x) SETUP_XfOrM178(x)

# 1660 "bc/src/struct.c"
      v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM180(_), scheme_input_port_record (o ) ); 
    }

# 1661 "bc/src/struct.c"
    else {
#     define XfOrM179_COUNT (0+XfOrM178_COUNT)
#     define SETUP_XfOrM179(x) SETUP_XfOrM178(x)

# 1662 "bc/src/struct.c"
      v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM179(_), scheme_output_port_record (o ) ); 
    }
    FUNCCALL(SETUP_XfOrM178(_), scheme_set_sync_target (sinfo , v , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  if (((intptr_t ) (v ) ) & 0x1 ) 
    v = FUNCCALL(SETUP_XfOrM161(_), scheme_struct_ref (o , (((intptr_t ) (v ) ) >> 1 ) ) ); 

  if (FUNCCALL(SETUP_XfOrM161(_), scheme_is_evt (v ) )) {
#   define XfOrM177_COUNT (0+XfOrM161_COUNT)
#   define SETUP_XfOrM177(x) SETUP_XfOrM161(x)
    FUNCCALL(SETUP_XfOrM177(_), scheme_set_sync_target (sinfo , v , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 1672 "bc/src/struct.c"
    ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  if (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
#   define XfOrM171_COUNT (0+XfOrM161_COUNT)
#   define SETUP_XfOrM171(x) SETUP_XfOrM161(x)

# 1677 "bc/src/struct.c"
    if (FUNCCALL(SETUP_XfOrM171(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , & v ) )) {
      Scheme_Object * f = v , * result , * a [1 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM171_COUNT), PUSH(result, 3+XfOrM171_COUNT)));
#     define XfOrM172_COUNT (4+XfOrM171_COUNT)
#     define SETUP_XfOrM172(x) SETUP(XfOrM172_COUNT)
      result = NULLED_OUT ; 
      a[0] = NULLED_OUT ; 

# 1680 "bc/src/struct.c"
      a [0 ] = o ; 
      result = FUNCCALL(SETUP_XfOrM172(_), scheme_apply (f , 1 , a ) ); 

      if (FUNCCALL(SETUP_XfOrM172(_), scheme_is_evt (result ) )) {
#       define XfOrM174_COUNT (0+XfOrM172_COUNT)
#       define SETUP_XfOrM174(x) SETUP_XfOrM172(x)

# 1684 "bc/src/struct.c"
        {
#         define XfOrM175_COUNT (0+XfOrM174_COUNT)
#         define SETUP_XfOrM175(x) SETUP_XfOrM174(x)

# 1684 "bc/src/struct.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM176_COUNT (0+XfOrM175_COUNT)
#           define SETUP_XfOrM176(x) SETUP_XfOrM175(x)
            FUNCCALL(SETUP_XfOrM176(_), scheme_out_of_fuel () )
# 1684 "bc/src/struct.c"
            ; 
          }
        }

# 1684 "bc/src/struct.c"
        ; 
        FUNCCALL(SETUP_XfOrM174(_), scheme_set_sync_target (sinfo , result , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
        ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }




      if (! (((intptr_t ) (o ) ) & 0x1 ) && ((((o ) -> type ) >= scheme_prim_type ) && (((o ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
#       define XfOrM173_COUNT (0+XfOrM172_COUNT)
#       define SETUP_XfOrM173(x) SETUP_XfOrM172(x)

# 1694 "bc/src/struct.c"
        o = FUNCCALL(SETUP_XfOrM173(_), scheme_make_closed_prim_w_arity (return_wrapped , (void * ) o , "wrapper" , 1 , 1 ) ); 
      }
      FUNCCALL(SETUP_XfOrM172(_), scheme_set_sync_target (sinfo , o , o , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) ); 

      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (scheme_is_struct_instance (poller_struct , v ) ) )  {
    Scheme_Thread * p ; 
    Scheme_Object * a [2 ] ; 
    int done ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM161_COUNT), PUSH(p, 3+XfOrM161_COUNT)));
#   define XfOrM162_COUNT (4+XfOrM161_COUNT)
#   define SETUP_XfOrM162(x) SETUP(XfOrM162_COUNT)
    p = NULLED_OUT ; 
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM162(_), scheme_start_in_scheduler () )
# 1707 "bc/src/struct.c"
    ; 
    a [0 ] = o ; 
    a [1 ] = scheme_false ; 
    v = FUNCCALL(SETUP_XfOrM162(_), scheme_do_eval ((((Scheme_Structure * ) (v ) ) -> slots [0 ] ) , 2 , a , - 1 ) ); 

    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    if ((v == ((Scheme_Object * ) 0x6 ) ) 
    && (p -> ku . multiple . count == 2 ) ) {
      if (((p -> ku . multiple . array [0 ] ) ) == (scheme_false ) )  {
        v = p -> ku . multiple . array [1 ] ; 
        if (v == o )

# 1717 "bc/src/struct.c"
        v = ((void * ) 0 ) ; 
        done = 0 ; 
      }

# 1719 "bc/src/struct.c"
      else {
        v = p -> ku . multiple . array [0 ] ; 
        done = 1 ; 
      }
    }

# 1723 "bc/src/struct.c"
    else {

      v = ((void * ) 0 ) ; 
      done = 0 ; 
    }
    FUNCCALL(SETUP_XfOrM162(_), scheme_end_in_scheduler () ); 

    if (v ) {
#     define XfOrM163_COUNT (0+XfOrM162_COUNT)
#     define SETUP_XfOrM163(x) SETUP_XfOrM162(x)

# 1731 "bc/src/struct.c"
      if (done ) {
        int check_proc = 1 ; 
#       define XfOrM164_COUNT (0+XfOrM163_COUNT)
#       define SETUP_XfOrM164(x) SETUP_XfOrM163(x)

# 1733 "bc/src/struct.c"
        if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && (((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ) == (scheme_null ) ) && ! (! (((intptr_t ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) & 0x1 ) && (((((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) -> type ) >= scheme_prim_type ) && ((((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
          v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
        else if (! ((v ) == (scheme_null ) ) && ! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
        }
        else {
#         define XfOrM165_COUNT (0+XfOrM164_COUNT)
#         define SETUP_XfOrM165(x) SETUP_XfOrM164(x)

# 1738 "bc/src/struct.c"
          v = FUNCCALL(SETUP_XfOrM165(_), scheme_make_closed_prim_w_arity (return_wrapped_multi , (void * ) v , "multi-wrapper" , 1 , 1 ) ); 
          check_proc = 0 ; 
        }

        if (check_proc && (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
          v = FUNCCALL(SETUP_XfOrM164(_), scheme_make_closed_prim_w_arity (return_wrapped , (void * ) v , "wrapper" , 1 , 1 ) ); 
      }
      FUNCCALL(SETUP_XfOrM163(_), scheme_set_sync_target (sinfo , v , (done ? v : ((void * ) 0 ) ) , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) ); 
      RET_VALUE_START (done ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1753 "bc/src/struct.c"
void evt_struct_needs_wakeup (Scheme_Object * o , void * fds ) 
{
  Scheme_Object * v ; 
  PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(fds, 1), PUSH(v, 2)));
# define XfOrM181_COUNT (3)
# define SETUP_XfOrM181(x) SETUP(XfOrM181_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 1759 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    RET_NOTHING ; 

  v = (scheme_struct_type_property_ref (evt_property , o ) ) ; 
  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (scheme_is_struct_instance (poller_struct , v ) ) )  {
    Scheme_Object * a [2 ] , * e , * r ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM181_COUNT), PUSHARRAY(a, 2, 1+XfOrM181_COUNT), PUSH(e, 4+XfOrM181_COUNT)));
#   define XfOrM182_COUNT (5+XfOrM181_COUNT)
#   define SETUP_XfOrM182(x) SETUP(XfOrM182_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    e = NULLED_OUT ; 
    r = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM182(_), scheme_start_in_scheduler () )
# 1766 "bc/src/struct.c"
    ; 
    a [0 ] = o ; 
    e = FUNCCALL(SETUP_XfOrM182(_), scheme_make_cptr (fds , scheme_false ) ); 
    a [1 ] = e ; 
    r = FUNCCALL(SETUP_XfOrM182(_), scheme_do_eval ((((Scheme_Structure * ) (v ) ) -> slots [0 ] ) , 2 , a , - 1 ) ); 
    FUNCCALL_AGAIN(scheme_end_in_scheduler () ); 


    if (r == ((Scheme_Object * ) 0x6 ) ) {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM183_COUNT (0+XfOrM182_COUNT)
#     define SETUP_XfOrM183(x) SETUP_XfOrM182(x)

# 1776 "bc/src/struct.c"
      if (p -> ku . multiple . count == 2 ) {
#       define XfOrM184_COUNT (0+XfOrM183_COUNT)
#       define SETUP_XfOrM184(x) SETUP_XfOrM183(x)

# 1777 "bc/src/struct.c"
        if (! (((p -> ku . multiple . array [0 ] ) ) == (scheme_false ) ) ) 
          FUNCCALL(SETUP_XfOrM184(_), scheme_cancel_sleep () ); 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1784 "bc/src/struct.c"
static int is_evt_struct (Scheme_Object * o ) 
{
  /* No conversion */

# 1786 "bc/src/struct.c"
  if (scheme_struct_type_property_ref (evt_property , o ) )
    return 1 ; 
  if (scheme_struct_type_property_ref (scheme_input_port_property , o ) )
    return 1 ; 
  if (scheme_struct_type_property_ref (scheme_output_port_property , o ) )
    return 1 ; 
  return 0 ; 
}







static int is_proc_1 (Scheme_Object * o ) {
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM186_COUNT (1)
# define SETUP_XfOrM186(x) SETUP(XfOrM186_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1801 "bc/src/struct.c"
  RET_VALUE_START (((! (((intptr_t ) (o ) ) & 0x1 ) && ((((o ) -> type ) >= scheme_prim_type ) && (((o ) -> type ) <= scheme_proc_chaperone_type ) ) ) && FUNCCALL(SETUP_XfOrM186(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , - 1 , 0 , & o ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1803 "bc/src/struct.c"
static Scheme_Object * check_object_name_property_value_ok (int argc , Scheme_Object * argv [] ) 

{
  /* No conversion */

# 1806 "bc/src/struct.c"
  return check_indirect_property_value_ok ("guard-for-prop:object-name" , 
  is_proc_1 , 1 , 
  "(or/c (any/c . -> . any) exact-nonnegative-integer?)" , 
  argc , argv ) ; 
}






static int is_input_port (Scheme_Object * v ) {
  /* No conversion */

# 1817 "bc/src/struct.c"
  return scheme_is_input_port (v ) ; 
}

# 1818 "bc/src/struct.c"
static int is_output_port (Scheme_Object * v ) {
  /* No conversion */

# 1818 "bc/src/struct.c"
  return scheme_is_output_port (v ) ; 
}
static Scheme_Object * check_port_property_value_ok (const char * name , int input , int argc , Scheme_Object * argv [] ) 

{
  /* No conversion */

# 1823 "bc/src/struct.c"
  return check_indirect_property_value_ok (name , 
  input ? is_input_port : is_output_port , 0 , 
  (input 
  ? "(or/c input-port? exact-nonnegative-integer?)" 
  : "(or/c output-port? exact-nonnegative-integer?)" ) , 
  argc , argv ) ; 
}

static Scheme_Object * check_input_port_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1833 "bc/src/struct.c"
  return check_port_property_value_ok ("guard-for-prop:input-port" , 1 , argc , argv ) ; 
}

static Scheme_Object * check_output_port_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1838 "bc/src/struct.c"
  return check_port_property_value_ok ("guard-for-prop:output-port" , 0 , argc , argv ) ; 
}





static Scheme_Object * check_cpointer_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1847 "bc/src/struct.c"
  return check_indirect_property_value_ok ("guard-for-prop:cpointer" , 
  scheme_is_cpointer , 1 , 
  "(or/c cpointer? (any/c . -> . any) exact-nonnegative-integer?)" , 
  argc , argv ) ; 
}





static Scheme_Object * check_equal_property_value_ok (int argc , Scheme_Object * argv [] ) 

{
  Scheme_Object * v , * p ; 
  intptr_t len ; 
  Scheme_Object * __funcarg130 = NULLED_OUT ; 
  Scheme_Object * __funcarg129 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1), PUSH(p, 2)));
# define XfOrM194_COUNT (3)
# define SETUP_XfOrM194(x) SETUP(XfOrM194_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 1863 "bc/src/struct.c"
  v = argv [0 ] ; 
  len = (scheme_proper_list_length (v ) ) ; 

  if (len == 2 ) {
#   define XfOrM202_COUNT (0+XfOrM194_COUNT)
#   define SETUP_XfOrM202(x) SETUP_XfOrM194(x)

# 1868 "bc/src/struct.c"
    v = (__funcarg130 = FUNCCALL(SETUP_XfOrM202(_), scheme_make_symbol ("tag" ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg130 , v ) )) ; 
    v = FUNCCALL(SETUP_XfOrM202(_), scheme_list_to_vector (v ) ); 
    p = (((Scheme_Vector * ) (v ) ) -> els ) [1 ] ; 
    if (! FUNCCALL(SETUP_XfOrM202(_), scheme_check_proc_arity (((void * ) 0 ) , 4 , 0 , 1 , & p ) )) {
      v = ((void * ) 0 ) ; 
    }

# 1873 "bc/src/struct.c"
    else {
#     define XfOrM203_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM203(x) SETUP_XfOrM202(x)

# 1874 "bc/src/struct.c"
      p = (((Scheme_Vector * ) (v ) ) -> els ) [2 ] ; 
      if (! FUNCCALL(SETUP_XfOrM203(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 0 , 1 , & p ) )) {
        v = ((void * ) 0 ) ; 
      }
    }
  }

# 1879 "bc/src/struct.c"
  else if (len == 3 ) {
#   define XfOrM196_COUNT (0+XfOrM194_COUNT)
#   define SETUP_XfOrM196(x) SETUP_XfOrM194(x)

# 1881 "bc/src/struct.c"
    v = (__funcarg129 = FUNCCALL(SETUP_XfOrM196(_), scheme_make_symbol ("tag" ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg129 , v ) )) ; 
    v = FUNCCALL(SETUP_XfOrM196(_), scheme_list_to_vector (v ) ); 
    p = (((Scheme_Vector * ) (v ) ) -> els ) [1 ] ; 
    if (! FUNCCALL(SETUP_XfOrM196(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 0 , 1 , & p ) )) {
      v = ((void * ) 0 ) ; 
    }

# 1886 "bc/src/struct.c"
    else {
#     define XfOrM197_COUNT (0+XfOrM196_COUNT)
#     define SETUP_XfOrM197(x) SETUP_XfOrM196(x)

# 1887 "bc/src/struct.c"
      p = (((Scheme_Vector * ) (v ) ) -> els ) [2 ] ; 
      if (! FUNCCALL(SETUP_XfOrM197(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 0 , 1 , & p ) )) {
        v = ((void * ) 0 ) ; 
      }

# 1890 "bc/src/struct.c"
      else {
#       define XfOrM198_COUNT (0+XfOrM197_COUNT)
#       define SETUP_XfOrM198(x) SETUP_XfOrM197(x)

# 1891 "bc/src/struct.c"
        p = (((Scheme_Vector * ) (v ) ) -> els ) [3 ] ; 
        if (! FUNCCALL(SETUP_XfOrM198(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 0 , 1 , & p ) )) {
          v = ((void * ) 0 ) ; 
        }
      }
    }
  }

# 1897 "bc/src/struct.c"
  else 
  v = ((void * ) 0 ) ; 

  if (! v ) {
#   define XfOrM195_COUNT (0+XfOrM194_COUNT)
#   define SETUP_XfOrM195(x) SETUP_XfOrM194(x)
    FUNCCALL(SETUP_XfOrM195(_), wrong_property_contract ("guard-for-prop:equal+hash" , "(or/c (list/c (any/c any/c any/c any/c . -> . any)\n" "              (any/c any/c any/c . -> . any))\n" "      (list/c (any/c any/c any/c . -> . any)\n" "              (any/c any/c . -> . any)\n" "              (any/c any/c . -> . any)))" , argv [0 ] ) )



    ; 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1913 "bc/src/struct.c"
static Scheme_Object * check_impersonator_of_property_value_ok (int argc , Scheme_Object * argv [] ) 
{

  Scheme_Object * v ; 
  Scheme_Object * __funcarg131 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM206_COUNT (1)
# define SETUP_XfOrM206(x) SETUP(XfOrM206_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1918 "bc/src/struct.c"
  v = argv [0 ] ; 

  if (! FUNCCALL(SETUP_XfOrM206(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , argc , argv ) )) {
#   define XfOrM207_COUNT (0+XfOrM206_COUNT)
#   define SETUP_XfOrM207(x) SETUP_XfOrM206(x)
    FUNCCALL(SETUP_XfOrM207(_), wrong_property_contract ("guard-for-prop:impersonator-of" , "(any/c . -> . any)" , v ) ); 
  }


  v = (__funcarg131 = FUNCCALL(SETUP_XfOrM206(_), scheme_make_symbol ("tag" ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg131 , v ) )) ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * check_write_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM208_COUNT (1)
# define SETUP_XfOrM208(x) SETUP(XfOrM208_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1940 "bc/src/struct.c"
  v = argv [0 ] ; 

  if (! FUNCCALL(SETUP_XfOrM208(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 0 , argc , argv ) )) {
#   define XfOrM209_COUNT (0+XfOrM208_COUNT)
#   define SETUP_XfOrM209(x) SETUP_XfOrM208(x)
    FUNCCALL(SETUP_XfOrM209(_), wrong_property_contract ("guard-for-prop:custom-write" , "(any/c any/c any/c . -> . any)" , v ) ); 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1951 "bc/src/struct.c"
static Scheme_Object * check_print_attribute_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1953 "bc/src/struct.c"
  Scheme_Object * s = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! ((& ((Scheme_Symbol * ) (s ) ) -> iso ) -> so . keyex & 0x3 ) ) {
    if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s ) ) ) -> s ) , "self" ) 
    || ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s ) ) ) -> s ) , "never" ) 
    || ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s ) ) ) -> s ) , "always" ) 
    || ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s ) ) ) -> s ) , "maybe" ) )
      return s ; 
  }

  wrong_property_contract ("guard-for-prop:custom-print-quotable" , 
  "(or/c 'self 'never 'always 'maybe)" , 
  s ) ; 

  return ((void * ) 0 ) ; 
}

Scheme_Object * scheme_is_writable_struct (Scheme_Object * s ) 
{
  /* No conversion */

# 1971 "bc/src/struct.c"
  return scheme_struct_type_property_ref (write_property , s ) ; 
}

Scheme_Object * scheme_print_attribute_ref (Scheme_Object * s ) 
{
  /* No conversion */

# 1976 "bc/src/struct.c"
  return scheme_struct_type_property_ref (print_attribute_property , s ) ; 
}





static Scheme_Object * check_checked_proc_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1985 "bc/src/struct.c"
  Scheme_Object * parent , * l ; 
  int num_islots , num_aslots ; 

  l = argv [1 ] ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  num_islots = (((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  num_aslots = (((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  parent = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 

  if (! (((parent ) ) == (scheme_false ) ) )  {
    scheme_contract_error ("prop:checked-procedure" , 
    "not allowed on a structure type with a supertype" , 
    ((void * ) 0 ) ) ; 
  }

  if (num_islots + num_aslots < 2 ) {
    scheme_contract_error ("prop:checked-procedure" , 
    "need at least two fields in the structure type" , 
    ((void * ) 0 ) ) ; 
  }

  return scheme_true ; 
}

Scheme_Object * scheme_extract_checked_procedure (int argc , Scheme_Object * * argv ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * v , * checker , * proc , * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0), PUSH(stype, 3), PUSH(argv, 4), PUSH(checker, 5), PUSH(v, 6), PUSH(proc, 7)));
# define XfOrM217_COUNT (8)
# define SETUP_XfOrM217(x) SETUP(XfOrM217_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  v = NULLED_OUT ; 
  checker = NULLED_OUT ; 
  proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 2019 "bc/src/struct.c"
  v = argv [1 ] ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
    stype = (Scheme_Struct_Type * ) argv [0 ] ; 
  else 
  stype = ((void * ) 0 ) ; 

  if (! stype || ! ((& stype -> iso ) -> so . keyex & 0x2 ) ) {
#   define XfOrM219_COUNT (0+XfOrM217_COUNT)
#   define SETUP_XfOrM219(x) SETUP_XfOrM217(x)
    FUNCCALL(SETUP_XfOrM219(_), scheme_wrong_type ("checked-procedure-check-and-extract" , "unchaperoned structure type with prop:checked-procedure property" , 0 , argc , argv ) )
# 2028 "bc/src/struct.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }


  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (scheme_is_struct_instance ((Scheme_Object * ) stype , v ) ) ) {
#   define XfOrM218_COUNT (0+XfOrM217_COUNT)
#   define SETUP_XfOrM218(x) SETUP_XfOrM217(x)

# 2034 "bc/src/struct.c"
    checker = ((Scheme_Structure * ) v ) -> slots [0 ] ; 
    proc = ((Scheme_Structure * ) v ) -> slots [1 ] ; 

    a [0 ] = argv [3 ] ; 
    a [1 ] = argv [4 ] ; 
    v = FUNCCALL(SETUP_XfOrM218(_), scheme_do_eval (checker , 2 , a , 1 ) ); 

    if (! (((v ) ) == (scheme_false ) ) ) 
      RET_VALUE_START (proc ) RET_VALUE_END ; 
  }

  a [0 ] = argv [1 ] ; 
  a [1 ] = argv [3 ] ; 
  a [2 ] = argv [4 ] ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM217(_), scheme_do_eval (argv [2 ] , 3 , a , 1 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static void wrong_struct_type (Scheme_Object * prim , 
Scheme_Object * expected , 
Scheme_Object * received , 
int which , int argc , 
Scheme_Object * * argv ) 
{
  char * name , * pred_name ; 
  Scheme_Object * realm ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(realm, 1), PUSH(pred_name, 2), PUSH(argv, 3), PUSH(received, 4), PUSH(expected, 5)));
# define XfOrM220_COUNT (6)
# define SETUP_XfOrM220(x) SETUP(XfOrM220_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 
  pred_name = NULLED_OUT ; 
  realm = NULLED_OUT ; 

# 2064 "bc/src/struct.c"
  name = FUNCCALL(SETUP_XfOrM220(_), extract_field_proc_name_and_realm (expected , prim , & pred_name , & realm ) ); 

  if ((expected ) == (received ) )  {
#   define XfOrM221_COUNT (0+XfOrM220_COUNT)
#   define SETUP_XfOrM221(x) SETUP_XfOrM220(x)

# 2067 "bc/src/struct.c"
    pred_name = (char * ) FUNCCALL(SETUP_XfOrM221(_), scheme_contract_realm_adjust (pred_name , realm ) ); 
    FUNCCALL(SETUP_XfOrM221(_), scheme_contract_error (((const char * ) scheme_default_realm ) , "contract violation;\n" " given value instantiates a different structure type with the same name" , name , realm , "expected" , 0 , pred_name , "given" , 1 , argv [which ] , ((void * ) 0 ) ) )





    ; 
  }

# 2075 "bc/src/struct.c"
  else FUNCCALL(SETUP_XfOrM220(_), scheme_wrong_contract_for_realm (name , realm , pred_name , which , argc , argv ) )


  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_is_struct_instance (Scheme_Object * type , Scheme_Object * v ) 
{
  /* No conversion */

# 2087 "bc/src/struct.c"
  Scheme_Struct_Type * stype = (Scheme_Struct_Type * ) type ; 
  Scheme_Structure * s = (Scheme_Structure * ) v ; 

  return ((stype -> name_pos <= s -> stype -> name_pos ) && (stype == s -> stype -> parent_types [stype -> name_pos ] ) ) ; 
}

static Scheme_Object * chaperone_struct_ref (const char * who , Scheme_Object * prim , 
Scheme_Object * orig_o , Scheme_Object * o , int i ) ; 

static Scheme_Object * chaperone_struct_ref_k (void ) 
{
  /* No conversion */

# 2098 "bc/src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * prim = (Scheme_Object * ) p -> ku . k . p3 ; 
  const char * who = (const char * ) p -> ku . k . p2 ; 
  Scheme_Object * orig_o = (Scheme_Object * ) p -> ku . k . p4 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  return chaperone_struct_ref (who , prim , orig_o , o , p -> ku . k . i1 ) ; 
}

static Scheme_Object * chaperone_struct_ref_overflow (const char * who , Scheme_Object * prim , 
Scheme_Object * orig_o , Scheme_Object * o , int i ) 
{
  /* No conversion */

# 2115 "bc/src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = (void * ) o ; 
  p -> ku . k . p2 = (void * ) who ; 
  p -> ku . k . p3 = (void * ) prim ; 
  p -> ku . k . p4 = (void * ) orig_o ; 
  p -> ku . k . i1 = i ; 

  return scheme_handle_stack_overflow (chaperone_struct_ref_k ) ; 
}

static void raise_undefined_error (const char * who , Scheme_Object * prim , Scheme_Object * val , 
const char * short_error , const char * mode , int i ) 
{
  int len ; 
  Scheme_Object * o ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(mode, 1), PUSH(short_error, 2)));
# define XfOrM225_COUNT (3)
# define SETUP_XfOrM225(x) SETUP(XfOrM225_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 2132 "bc/src/struct.c"
  o = (scheme_struct_type_property_ref (scheme_chaperone_undefined_property , val ) ) ; 
  len = (o ? (scheme_proper_list_length (o ) ) : 0 ) ; 
  if (i < len ) {
#   define XfOrM227_COUNT (0+XfOrM225_COUNT)
#   define SETUP_XfOrM227(x) SETUP_XfOrM225(x)

# 2135 "bc/src/struct.c"
    for (i = len - i ; -- i ; ) {
      o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
    }
    o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ; 
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , o , "%S: %s;\n cannot %s field before initialization" , o , short_error , mode ) )


    ; 
  }

# 2143 "bc/src/struct.c"
  else {
#   define XfOrM226_COUNT (0+XfOrM225_COUNT)
#   define SETUP_XfOrM226(x) SETUP_XfOrM225(x)

# 2144 "bc/src/struct.c"
    if (prim )
      who = FUNCCALL(SETUP_XfOrM226(_), extract_field_proc_name (prim ) ); 
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: %s;\n cannot %s field before initialization" , who , short_error , mode ) )



    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2155 "bc/src/struct.c"
static Scheme_Object * chaperone_struct_ref (const char * who , Scheme_Object * prim , 
Scheme_Object * orig_o , Scheme_Object * o , int i ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(who, 1), PUSH(orig_o, 2), PUSH(prim, 3)));
# define XfOrM230_COUNT (4)
# define SETUP_XfOrM230(x) SETUP(XfOrM230_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2158 "bc/src/struct.c"
  while (1 ) {
#   define XfOrM242_COUNT (0+XfOrM230_COUNT)
#   define SETUP_XfOrM242(x) SETUP_XfOrM230(x)

# 2159 "bc/src/struct.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
      RET_VALUE_START (((Scheme_Structure * ) o ) -> slots [i ] ) RET_VALUE_END ; 
    }

# 2161 "bc/src/struct.c"
    else {
      Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
      Scheme_Object * a [2 ] , * red , * orig ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM242_COUNT), PUSH(px, 3+XfOrM242_COUNT), PUSH(orig, 4+XfOrM242_COUNT), PUSH(red, 5+XfOrM242_COUNT)));
#     define XfOrM243_COUNT (6+XfOrM242_COUNT)
#     define SETUP_XfOrM243(x) SETUP(XfOrM243_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      red = NULLED_OUT ; 
      orig = NULLED_OUT ; 

# 2165 "bc/src/struct.c"
      if ((((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      && (((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) == (scheme_undefined ) ) ) {
#       define XfOrM250_COUNT (0+XfOrM243_COUNT)
#       define SETUP_XfOrM250(x) SETUP_XfOrM243(x)

# 2168 "bc/src/struct.c"
        o = px -> prev ; 

        if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) )
          orig = ((Scheme_Structure * ) o ) -> slots [i ] ; 
        else 
        orig = FUNCCALL(SETUP_XfOrM250(_), chaperone_struct_ref (who , prim , orig_o , o , i ) ); 

        if ((orig ) == (scheme_undefined ) )  {
#         define XfOrM251_COUNT (0+XfOrM250_COUNT)
#         define SETUP_XfOrM251(x) SETUP_XfOrM250(x)
          FUNCCALL(SETUP_XfOrM251(_), raise_undefined_error (who , prim , px -> val , "undefined" , "use" , i ) )
# 2176 "bc/src/struct.c"
          ; 
        }

        RET_VALUE_START (orig ) RET_VALUE_END ; 
      }

# 2180 "bc/src/struct.c"
      else if (! (((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      || ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [2 + i ] ) ) == (scheme_false ) ) ) {
        o = px -> prev ; 
      }

# 2183 "bc/src/struct.c"
      else {
#       define XfOrM244_COUNT (0+XfOrM243_COUNT)
#       define SETUP_XfOrM244(x) SETUP_XfOrM243(x)

# 2185 "bc/src/struct.c"
        {

# 24 "bc/src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM248_COUNT (0+XfOrM244_COUNT)
#         define SETUP_XfOrM248(x) SETUP_XfOrM244(x)

# 26 "bc/src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 2187 "bc/src/struct.c"
          RET_VALUE_START (FUNCCALL(SETUP_XfOrM248(_), chaperone_struct_ref_overflow (who , prim , orig_o , o , i ) )) RET_VALUE_END ; 
        }


        red = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [2 + i ] ; 
        if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#         define XfOrM247_COUNT (0+XfOrM244_COUNT)
#         define SETUP_XfOrM247(x) SETUP_XfOrM244(x)

          a [0 ] = px -> prev ; 
          orig = FUNCCALL(SETUP_XfOrM247(_), scheme_do_eval ((((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . car ) , 1 , a , 1 ) ); 
          red = (((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . cdr ) ; 
        }

# 2199 "bc/src/struct.c"
        else 
        orig = FUNCCALL(SETUP_XfOrM244(_), chaperone_struct_ref (who , prim , orig_o , px -> prev , i ) ); 

        a [0 ] = orig_o ; 
        a [1 ] = orig ; 
        if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) )  {
#         define XfOrM245_COUNT (0+XfOrM244_COUNT)
#         define SETUP_XfOrM245(x) SETUP_XfOrM244(x)

# 2205 "bc/src/struct.c"
          o = FUNCCALL(SETUP_XfOrM245(_), _scheme_apply_native (red , 2 , a ) ); 
          if (o == ((Scheme_Object * ) 0x6 ) ) {
            GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#           define XfOrM246_COUNT (0+XfOrM245_COUNT)
#           define SETUP_XfOrM246(x) SETUP_XfOrM245(x)
            FUNCCALL(SETUP_XfOrM246(_), scheme_wrong_return_arity (((void * ) 0 ) , 1 , p -> ku . multiple . count , p -> ku . multiple . array , ((void * ) 0 ) ) ); 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
        }

# 2213 "bc/src/struct.c"
        else 
        o = FUNCCALL(SETUP_XfOrM244(_), scheme_do_eval (red , 2 , a , 1 ) ); 

        if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
          if (! ((o ) == (orig ) ) && ! FUNCCALL(SETUP_XfOrM244(_), scheme_chaperone_of (o , orig ) ))
          FUNCCALL(SETUP_XfOrM244(_), scheme_wrong_chaperoned (who , "result" , orig , o ) ); 

        RET_VALUE_START (o ) RET_VALUE_END ; 
      }
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2226 "bc/src/struct.c"
Scheme_Object * scheme_struct_ref (Scheme_Object * sv , int pos ) 
{
  /* No conversion */

# 2228 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (sv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sv ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (sv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sv ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    return chaperone_struct_ref ("struct-ref" , ((void * ) 0 ) , sv , sv , pos ) ; 
  }

# 2230 "bc/src/struct.c"
  else {
    Scheme_Structure * s = (Scheme_Structure * ) sv ; 

    return s -> slots [pos ] ; 
  }
}

static void chaperone_struct_set (const char * who , Scheme_Object * prim , 
Scheme_Object * o , int i , Scheme_Object * v ) ; 

static Scheme_Object * chaperone_struct_set_k (void ) 
{
  /* No conversion */

# 2242 "bc/src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * prim = (Scheme_Object * ) p -> ku . k . p3 ; 
  const char * who = (const char * ) p -> ku . k . p2 ; 
  Scheme_Object * v = (Scheme_Object * ) p -> ku . k . p4 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  chaperone_struct_set (who , prim , o , p -> ku . k . i1 , v ) ; 

  return scheme_false ; 
}

static void chaperone_struct_set_overflow (const char * who , Scheme_Object * prim , 
Scheme_Object * o , int i , Scheme_Object * v ) 
{
  /* No conversion */

# 2261 "bc/src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = (void * ) o ; 
  p -> ku . k . p2 = (void * ) who ; 
  p -> ku . k . p3 = (void * ) prim ; 
  p -> ku . k . p4 = (void * ) v ; 
  p -> ku . k . i1 = i ; 

  (void ) scheme_handle_stack_overflow (chaperone_struct_set_k ) ; 
}

static void chaperone_struct_set (const char * who , Scheme_Object * prim , 
Scheme_Object * o , int i , Scheme_Object * v ) 
{
  Scheme_Object * orig_o = o ; 

# 24 "bc/src/mzstkchk.h"
  uintptr_t _stk_pos ; 
  PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(who, 1), PUSH(orig_o, 2), PUSH(v, 3), PUSH(prim, 4)));
# define XfOrM258_COUNT (5)
# define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 26 "bc/src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 2279 "bc/src/struct.c"
  {
#   define XfOrM281_COUNT (0+XfOrM258_COUNT)
#   define SETUP_XfOrM281(x) SETUP_XfOrM258(x)
    FUNCCALL(SETUP_XfOrM281(_), chaperone_struct_set_overflow (who , prim , o , i , v ) )
# 2280 "bc/src/struct.c"
    ; 
    RET_NOTHING ; 
  }


  while (1 ) {
#   define XfOrM270_COUNT (0+XfOrM258_COUNT)
#   define SETUP_XfOrM270(x) SETUP_XfOrM258(x)

# 2286 "bc/src/struct.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
      ((Scheme_Structure * ) o ) -> slots [i ] = v ; 
      RET_NOTHING ; 
    }

# 2289 "bc/src/struct.c"
    else {
      Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
      Scheme_Object * a [2 ] , * red ; 
      int half ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM270_COUNT), PUSH(px, 3+XfOrM270_COUNT), PUSH(red, 4+XfOrM270_COUNT)));
#     define XfOrM271_COUNT (5+XfOrM270_COUNT)
#     define SETUP_XfOrM271(x) SETUP(XfOrM271_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      red = NULLED_OUT ; 

# 2294 "bc/src/struct.c"
      o = px -> prev ; 
      if ((((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      && ! (((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) == (scheme_undefined ) ) ) {
#       define XfOrM274_COUNT (0+XfOrM271_COUNT)
#       define SETUP_XfOrM274(x) SETUP_XfOrM271(x)

# 2297 "bc/src/struct.c"
        half = ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) - 2 ) >> 1 ; 
        red = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [2 + half + i ] ; 
        if (! (((red ) ) == (scheme_false ) ) )  {
          Scheme_Object * finish_setter = ((void * ) 0 ) ; 
          BLOCK_SETUP((PUSH(finish_setter, 0+XfOrM274_COUNT)));
#         define XfOrM275_COUNT (1+XfOrM274_COUNT)
#         define SETUP_XfOrM275(x) SETUP(XfOrM275_COUNT)

# 2302 "bc/src/struct.c"
          a [0 ] = orig_o ; 
          a [1 ] = v ; 

          if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
            finish_setter = (((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . car ) ; 
            red = (((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . cdr ) ; 
          }

          if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) )  {
#           define XfOrM277_COUNT (0+XfOrM275_COUNT)
#           define SETUP_XfOrM277(x) SETUP_XfOrM275(x)

# 2311 "bc/src/struct.c"
            v = FUNCCALL(SETUP_XfOrM277(_), _scheme_apply_native (red , 2 , a ) ); 
            if (v == ((Scheme_Object * ) 0x6 ) ) {
              GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#             define XfOrM278_COUNT (0+XfOrM277_COUNT)
#             define SETUP_XfOrM278(x) SETUP_XfOrM277(x)
              FUNCCALL(SETUP_XfOrM278(_), scheme_wrong_return_arity (((void * ) 0 ) , 1 , p -> ku . multiple . count , p -> ku . multiple . array , ((void * ) 0 ) ) ); 
            }
          }

# 2318 "bc/src/struct.c"
          else 
          v = FUNCCALL(SETUP_XfOrM275(_), scheme_do_eval (red , 2 , a , 1 ) ); 

          if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
            if (! ((v ) == (a [1 ] ) ) && ! FUNCCALL(SETUP_XfOrM275(_), scheme_chaperone_of (v , a [1 ] ) ))
            FUNCCALL(SETUP_XfOrM275(_), scheme_wrong_chaperoned (who , "value" , a [1 ] , v ) ); 

          if (finish_setter ) {
#           define XfOrM276_COUNT (0+XfOrM275_COUNT)
#           define SETUP_XfOrM276(x) SETUP_XfOrM275(x)
            a [0 ] = o ; 
            a [1 ] = v ; 
            (void ) FUNCCALL(SETUP_XfOrM276(_), scheme_do_eval (finish_setter , 2 , a , - 1 ) ); 
            RET_NOTHING ; 
          }
        }
      }

# 2334 "bc/src/struct.c"
      else if ((((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      && (((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) == (scheme_undefined ) ) ) {
#       define XfOrM272_COUNT (0+XfOrM271_COUNT)
#       define SETUP_XfOrM272(x) SETUP_XfOrM271(x)

        if ((scheme_undefined ) == (((Scheme_Structure * ) px -> val ) -> slots [i ] ) )  {
          Scheme_Object * m ; 
          BLOCK_SETUP((PUSH(m, 0+XfOrM272_COUNT)));
#         define XfOrM273_COUNT (1+XfOrM272_COUNT)
#         define SETUP_XfOrM273(x) SETUP(XfOrM273_COUNT)
          m = NULLED_OUT ; 

# 2342 "bc/src/struct.c"
          m = FUNCCALL(SETUP_XfOrM273(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_chaperone_undefined_property ) ); 
          if (! m || ! ((m ) == (scheme_undefined ) ) )
            FUNCCALL(SETUP_XfOrM273(_), raise_undefined_error (who , prim , px -> val , "assignment disallowed" , "assign" , i ) ); 
        }
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2351 "bc/src/struct.c"
void scheme_struct_set (Scheme_Object * sv , int pos , Scheme_Object * v ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(sv, 1)));
# define XfOrM282_COUNT (2)
# define SETUP_XfOrM282(x) SETUP(XfOrM282_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2353 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (sv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sv ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (sv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sv ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
#   define XfOrM284_COUNT (0+XfOrM282_COUNT)
#   define SETUP_XfOrM284(x) SETUP_XfOrM282(x)
    FUNCCALL(SETUP_XfOrM284(_), chaperone_struct_set ("struct-set!" , ((void * ) 0 ) , sv , pos , v ) )
# 2354 "bc/src/struct.c"
    ; 
  }

# 2355 "bc/src/struct.c"
  else {
    Scheme_Structure * s = (Scheme_Structure * ) sv ; 

    s -> slots [pos ] = v ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2362 "bc/src/struct.c"
int scheme_is_noninterposing_chaperone (Scheme_Object * o ) 



{
  /* No conversion */

# 2367 "bc/src/struct.c"
  Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
  int i ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    return 0 ; 

  if ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) {

    if ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) ) == (scheme_false ) ) 
      return 1 ; 
    return 0 ; 
  }

  if ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) == 0 ) {

    return 1 ; 
  }

  if (! ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ) ) == (scheme_false ) ) ) 
    return 0 ; 

  for (i = (((Scheme_Vector * ) (px -> redirects ) ) -> size ) ; i -- > 2 ; ) {
    if (! ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [i ] ) ) == (scheme_false ) ) )
      return 0 ; 
  }

  return 1 ; 
}

static Scheme_Object * * apply_guards (Scheme_Struct_Type * stype , int argc , Scheme_Object * * args , 
int * _chaperone_undefined ) 
{
  Scheme_Object * * guard_argv = ((void * ) 0 ) , * v , * prev_guards = ((void * ) 0 ) , * guard ; 
  int p , gcount ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(_chaperone_undefined, 0), PUSH(args, 1), PUSH(guard, 2), PUSH(guard_argv, 3), PUSH(stype, 4), PUSH(v, 5), PUSH(prev_guards, 6)));
# define XfOrM290_COUNT (7)
# define SETUP_XfOrM290(x) SETUP(XfOrM290_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  guard = NULLED_OUT ; 

# 2402 "bc/src/struct.c"
  for (p = stype -> name_pos ; p >= 0 ; p -- ) {
#   define XfOrM306_COUNT (0+XfOrM290_COUNT)
#   define SETUP_XfOrM306(x) SETUP_XfOrM290(x)

# 2403 "bc/src/struct.c"
    if (stype -> parent_types [p ] -> guard || prev_guards ) {
      int got ; 
#     define XfOrM307_COUNT (0+XfOrM306_COUNT)
#     define SETUP_XfOrM307(x) SETUP_XfOrM306(x)

# 2406 "bc/src/struct.c"
      if (! guard_argv ) {
#       define XfOrM320_COUNT (0+XfOrM307_COUNT)
#       define SETUP_XfOrM320(x) SETUP_XfOrM307(x)

# 2407 "bc/src/struct.c"
        guard_argv = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM320(_), GC_malloc (sizeof (Scheme_Object * ) * (argc + 1 ) ) )) ; 
        (memcpy (guard_argv , args , sizeof (Scheme_Object * ) * argc ) ) ; 
        args = guard_argv ; 
      }

      if (! prev_guards )
        prev_guards = scheme_null ; 
      while (prev_guards ) {
#       define XfOrM314_COUNT (0+XfOrM307_COUNT)
#       define SETUP_XfOrM314(x) SETUP_XfOrM307(x)

# 2415 "bc/src/struct.c"
        if ((Scheme_Type ) (((((intptr_t ) (prev_guards ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prev_guards ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
          guard = (((Scheme_Simple_Object * ) (prev_guards ) ) -> u . pair_val . car ) ; 
        else {
          guard = stype -> parent_types [p ] -> guard ; 

          if (guard ) {
            if ((Scheme_Type ) (((((intptr_t ) (guard ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (guard ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 

# 2421 "bc/src/struct.c"
            guard = (((Scheme_Simple_Object * ) (guard ) ) -> u . pair_val . car ) ; 
          }

# 2422 "bc/src/struct.c"
          else 
          guard = scheme_false ; 
        }

        if ((guard ) == (scheme_undefined ) ) 
          * _chaperone_undefined = 1 ; 
        else if (! (((guard ) ) == (scheme_false ) ) ) {
#         define XfOrM315_COUNT (0+XfOrM314_COUNT)
#         define SETUP_XfOrM315(x) SETUP_XfOrM314(x)

# 2429 "bc/src/struct.c"
          gcount = stype -> parent_types [p ] -> num_islots ; 
          guard_argv [argc ] = guard_argv [gcount ] ; 
          guard_argv [gcount ] = stype -> name ; 
          v = FUNCCALL(SETUP_XfOrM315(_), scheme_do_eval (guard , gcount + 1 , guard_argv , - 1 ) ); 
          got = (((v ) == (((Scheme_Object * ) 0x6 ) ) ) ? (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ) : 1 ) ; 
          if (gcount != got ) {
#           define XfOrM317_COUNT (0+XfOrM315_COUNT)
#           define SETUP_XfOrM317(x) SETUP_XfOrM315(x)
            FUNCCALL(SETUP_XfOrM317(_), scheme_wrong_return_arity ("constructor" , gcount , got , (got == 1 ) ? (Scheme_Object * * ) v : (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) , "calling guard procedure" ) )
            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
#           define XfOrM316_COUNT (0+XfOrM315_COUNT)
#           define SETUP_XfOrM316(x) SETUP_XfOrM315(x)

# 2442 "bc/src/struct.c"
            if (gcount )
              (memcpy (guard_argv , (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) , gcount * sizeof (Scheme_Object * ) ) ) ; 
          }

# 2444 "bc/src/struct.c"
          else 
          guard_argv [0 ] = v ; 
          guard_argv [gcount ] = guard_argv [argc ] ; 
        }

        if ((prev_guards ) == (scheme_null ) ) 
          prev_guards = ((void * ) 0 ) ; 
        else 
        prev_guards = (((Scheme_Simple_Object * ) (prev_guards ) ) -> u . pair_val . cdr ) ; 
      }
    }


    if (stype -> parent_types [p ] -> guard 
    && ((Scheme_Type ) (((((intptr_t ) (stype -> parent_types [p ] -> guard ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (stype -> parent_types [p ] -> guard ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      prev_guards = (((Scheme_Simple_Object * ) (stype -> parent_types [p ] -> guard ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (args ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2467 "bc/src/struct.c"
Scheme_Object * 
scheme_make_struct_instance (Scheme_Object * _stype , int argc , Scheme_Object * * args ) 
{
  Scheme_Structure * inst ; 
  Scheme_Struct_Type * stype ; 
  int p , i , j , nis , ns , c ; 
  int chaperone_undefined = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(stype, 1), PUSH(args, 2)));
# define XfOrM321_COUNT (3)
# define SETUP_XfOrM321(x) SETUP(XfOrM321_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 
  stype = NULLED_OUT ; 

# 2475 "bc/src/struct.c"
  stype = (Scheme_Struct_Type * ) _stype ; 

  c = stype -> num_slots ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM321(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) )
  ; 

  inst -> so . type = (stype -> proc_attr ? scheme_proc_struct_type : scheme_structure_type ) ; 
  inst -> stype = stype ; 


  args = FUNCCALL(SETUP_XfOrM321(_), apply_guards (stype , argc , args , & chaperone_undefined ) ); 


  j = c ; 
  i = argc ; 
  for (p = stype -> name_pos ; p >= 0 ; p -- ) {

    if (p ) {
      ns = stype -> parent_types [p ] -> num_slots - stype -> parent_types [p - 1 ] -> num_slots ; 
      nis = stype -> parent_types [p ] -> num_islots - stype -> parent_types [p - 1 ] -> num_islots ; 
    }

# 2495 "bc/src/struct.c"
    else {
      ns = stype -> parent_types [0 ] -> num_slots ; 
      nis = stype -> parent_types [0 ] -> num_islots ; 
    }

    ns -= nis ; 


    while (ns -- ) {
      inst -> slots [-- j ] = stype -> parent_types [p ] -> uninit_val ; 
    }


    while (nis -- ) {
      inst -> slots [-- j ] = args [-- i ] ; 
    }
  }

  if (chaperone_undefined )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_chaperone_not_undefined ((Scheme_Object * ) inst ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2519 "bc/src/struct.c"
Scheme_Object * scheme_make_blank_prefab_struct_instance (Scheme_Struct_Type * stype ) 
{
  Scheme_Structure * inst ; 
  int c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(stype, 1)));
# define XfOrM336_COUNT (2)
# define SETUP_XfOrM336(x) SETUP(XfOrM336_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2524 "bc/src/struct.c"
  c = stype -> num_slots ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM336(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) )
  ; 

  inst -> so . type = scheme_structure_type ; 
  inst -> stype = stype ; 

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2535 "bc/src/struct.c"
Scheme_Object * scheme_make_serialized_struct_instance (Scheme_Object * prefab_key , int num_slots ) 
{
  Scheme_Serialized_Structure * inst ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(prefab_key, 1)));
# define XfOrM337_COUNT (2)
# define SETUP_XfOrM337(x) SETUP(XfOrM337_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2539 "bc/src/struct.c"
  inst = (Scheme_Serialized_Structure * ) FUNCCALL(SETUP_XfOrM337(_), GC_malloc_one_tagged (sizeof (Scheme_Serialized_Structure ) + ((num_slots - 0 ) * sizeof (Scheme_Object * ) ) ) )

  ; 

  inst -> so . type = scheme_serialized_structure_type ; 
  inst -> num_slots = num_slots ; 
  inst -> prefab_key = prefab_key ; 

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2551 "bc/src/struct.c"
Scheme_Object * scheme_make_prefab_struct_instance (Scheme_Struct_Type * stype , 
Scheme_Object * vec ) 
{
  Scheme_Structure * inst ; 
  int i , c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(vec, 1), PUSH(stype, 2)));
# define XfOrM338_COUNT (3)
# define SETUP_XfOrM338(x) SETUP(XfOrM338_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2557 "bc/src/struct.c"
  c = stype -> num_slots ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM338(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) )
  ; 

  inst -> so . type = scheme_structure_type ; 
  inst -> stype = stype ; 

  for (i = 0 ; i < c ; i ++ ) {
    inst -> slots [i ] = (((Scheme_Vector * ) (vec ) ) -> els ) [i + 1 ] ; 
  }

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2571 "bc/src/struct.c"
Scheme_Object * scheme_clone_prefab_struct_instance (Scheme_Structure * s ) 
{
  Scheme_Object * chaperone , * v ; 
  Scheme_Structure * inst ; 
  int c , sz , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(v, 1), PUSH(s, 2), PUSH(chaperone, 3)));
# define XfOrM341_COUNT (4)
# define SETUP_XfOrM341(x) SETUP(XfOrM341_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  chaperone = NULLED_OUT ; 
  v = NULLED_OUT ; 
  inst = NULLED_OUT ; 

# 2577 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    chaperone = (Scheme_Object * ) s ; 
    s = (Scheme_Structure * ) (((Scheme_Chaperone * ) chaperone ) -> val ) ; 
  }

# 2580 "bc/src/struct.c"
  else 
  chaperone = ((void * ) 0 ) ; 

  c = s -> stype -> num_slots ; 
  sz = (sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM341(_), GC_malloc_one_tagged (sz ) ); 
  (memcpy (inst , s , sz ) ) ; 

  if (chaperone ) {
#   define XfOrM342_COUNT (0+XfOrM341_COUNT)
#   define SETUP_XfOrM342(x) SETUP_XfOrM341(x)

# 2589 "bc/src/struct.c"
    for (i = 0 ; i < c ; i ++ ) {
#     define XfOrM344_COUNT (0+XfOrM342_COUNT)
#     define SETUP_XfOrM344(x) SETUP_XfOrM342(x)

# 2590 "bc/src/struct.c"
      v = FUNCCALL(SETUP_XfOrM344(_), scheme_struct_ref (chaperone , i ) ); 
      inst -> slots [i ] = v ; 
    }
  }

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2598 "bc/src/struct.c"
static Scheme_Object * 
make_struct_instance (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  /* No conversion */

# 2601 "bc/src/struct.c"
  return scheme_make_struct_instance (((Scheme_Primitive_Closure * ) prim ) -> val [0 ] , argc , args ) ; 
}

static Scheme_Object * 
make_simple_struct_instance (int argc , Scheme_Object * * args , Scheme_Object * prim ) 

{
  Scheme_Structure * inst ; 
  Scheme_Struct_Type * stype = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
  int i , c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(stype, 1), PUSH(args, 2)));
# define XfOrM347_COUNT (3)
# define SETUP_XfOrM347(x) SETUP(XfOrM347_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2612 "bc/src/struct.c"
  c = stype -> num_slots ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM347(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) )
  ; 

  inst -> so . type = scheme_structure_type ; 
  inst -> stype = stype ; 

  for (i = 0 ; i < argc ; i ++ ) {
    inst -> slots [i ] = args [i ] ; 
  }

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2626 "bc/src/struct.c"
int scheme_is_simple_struct_type (Scheme_Struct_Type * stype ) 
{
  /* No conversion */

# 2628 "bc/src/struct.c"
  int p ; 

  if (stype -> proc_attr )
    return 0 ; 

  for (p = stype -> name_pos ; p >= 0 ; p -- ) {
    if (stype -> parent_types [p ] -> guard )
      return 0 ; 
    if (stype -> parent_types [p ] -> num_slots != stype -> parent_types [p ] -> num_islots )
      return 0 ; 
  }

  return 1 ; 
}

static Scheme_Object * struct_pred (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  /* No conversion */

# 2645 "bc/src/struct.c"
  Scheme_Object * v = args [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 2647 "bc/src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    Scheme_Struct_Type * stype = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
    if ((stype -> name_pos <= ((Scheme_Structure * ) v ) -> stype -> name_pos ) && (stype == ((Scheme_Structure * ) v ) -> stype -> parent_types [stype -> name_pos ] ) ) 
      return scheme_true ; 
  }

  return scheme_false ; 
}

static int parse_pos (const char * who , Scheme_Object * prim , Scheme_Object * * args , int argc ) 
{
  int pos ; 
  Scheme_Struct_Type * st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(st, 0), PUSH(who, 1), PUSH(args, 2), PUSH(prim, 3)));
# define XfOrM355_COUNT (4)
# define SETUP_XfOrM355(x) SETUP(XfOrM355_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2663 "bc/src/struct.c"
  if (! (((intptr_t ) (args [1 ] ) ) & 0x1 ) || ((((intptr_t ) (args [1 ] ) ) >> 1 ) < 0 ) ) {
#   define XfOrM357_COUNT (0+XfOrM355_COUNT)
#   define SETUP_XfOrM357(x) SETUP_XfOrM355(x)

# 2664 "bc/src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) args [1 ] ) -> iso ) -> so . keyex & 0x1 ) ) {
      pos = (32768 + 1 ) ; 
    }

# 2666 "bc/src/struct.c"
    else {
#     define XfOrM358_COUNT (0+XfOrM357_COUNT)
#     define SETUP_XfOrM358(x) SETUP_XfOrM357(x)

# 2667 "bc/src/struct.c"
      if (! who )
        who = FUNCCALL(SETUP_XfOrM358(_), extract_field_proc_name (prim ) ); 
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-nonnegative-integer?" , 1 , argc , args ) )

      ; 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
  }

# 2674 "bc/src/struct.c"
  else 
  pos = (((intptr_t ) (args [1 ] ) ) >> 1 ) ; 

  if ((pos < st -> num_slots ) 
  && st -> name_pos )
    pos += st -> parent_types [st -> name_pos - 1 ] -> num_slots ; 

  if (pos >= st -> num_slots ) {
    int sc ; 
#   define XfOrM356_COUNT (0+XfOrM355_COUNT)
#   define SETUP_XfOrM356(x) SETUP_XfOrM355(x)

# 2684 "bc/src/struct.c"
    if (! who )
      who = FUNCCALL(SETUP_XfOrM356(_), extract_field_proc_name (prim ) ); 

    sc = (st -> name_pos 
    ? (st -> num_slots 
    - st -> parent_types [st -> name_pos - 1 ] -> num_slots ) 
    : st -> num_slots ) ; 
    FUNCCALL_EMPTY(scheme_contract_error (who , "index too large" , "index" , 1 , args [1 ] , "maximum allowed index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (sc - 1 ) ) ) << 1 ) | 0x1 ) ) , "structure" , 1 , args [0 ] , ((void * ) 0 ) ) )





    ; 

    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (pos ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2705 "bc/src/struct.c"
Scheme_Object * scheme_struct_getter (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  Scheme_Structure * inst ; 
  int pos ; 
  Scheme_Struct_Type * st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(st, 0), PUSH(inst, 1), PUSH(args, 2), PUSH(prim, 3)));
# define XfOrM360_COUNT (4)
# define SETUP_XfOrM360(x) SETUP(XfOrM360_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  inst = NULLED_OUT ; 

# 2711 "bc/src/struct.c"
  inst = (Scheme_Structure * ) args [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    inst = (Scheme_Structure * ) (((Scheme_Chaperone * ) (Scheme_Object * ) inst ) -> val ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {
    char * name , * pred_name ; 
    Scheme_Object * realm ; 
    BLOCK_SETUP((PUSH(name, 0+XfOrM360_COUNT), PUSH(realm, 1+XfOrM360_COUNT), PUSH(pred_name, 2+XfOrM360_COUNT)));
#   define XfOrM362_COUNT (3+XfOrM360_COUNT)
#   define SETUP_XfOrM362(x) SETUP(XfOrM362_COUNT)
    name = NULLED_OUT ; 
    pred_name = NULLED_OUT ; 
    realm = NULLED_OUT ; 

# 2718 "bc/src/struct.c"
    name = FUNCCALL(SETUP_XfOrM362(_), extract_field_proc_name_and_realm (st -> name , prim , & pred_name , & realm ) ); 
    FUNCCALL_AGAIN(scheme_wrong_contract_for_realm (name , realm , pred_name , 0 , argc , args ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 2721 "bc/src/struct.c"
  else if (! ((st -> name_pos <= inst -> stype -> name_pos ) && (st == inst -> stype -> parent_types [st -> name_pos ] ) ) ) {
#   define XfOrM361_COUNT (0+XfOrM360_COUNT)
#   define SETUP_XfOrM361(x) SETUP_XfOrM360(x)
    FUNCCALL(SETUP_XfOrM361(_), wrong_struct_type (prim , st -> name , ((((Scheme_Structure * ) inst ) -> stype ) -> name ) , 0 , argc , args ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc == 2 )
    pos = FUNCCALL(SETUP_XfOrM360(_), parse_pos (((void * ) 0 ) , prim , args , argc ) ); 
  else 
  pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) prim ) -> val [1 ] ) ) >> 1 ) ; 

  if (((Scheme_Object * ) inst ) == (args [0 ] ) ) 
    RET_VALUE_START (inst -> slots [pos ] ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(chaperone_struct_ref ("struct-ref" , prim , args [0 ] , args [0 ] , pos ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2740 "bc/src/struct.c"
Scheme_Object * scheme_struct_setter (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  Scheme_Structure * inst ; 
  int pos ; 
  Scheme_Object * v ; 
  Scheme_Struct_Type * st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 

# 1509 "bc/src/struct.c"
  char * __funcarg132 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(st, 0), PUSH(inst, 1), PUSH(v, 2), PUSH(args, 3), PUSH(prim, 4)));
# define XfOrM363_COUNT (5)
# define SETUP_XfOrM363(x) SETUP(XfOrM363_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  inst = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 2747 "bc/src/struct.c"
  inst = (Scheme_Structure * ) args [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    inst = (Scheme_Structure * ) (((Scheme_Chaperone * ) (Scheme_Object * ) inst ) -> val ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {
    char * name , * pred_name ; 
    Scheme_Object * realm ; 
    BLOCK_SETUP((PUSH(name, 0+XfOrM363_COUNT), PUSH(realm, 1+XfOrM363_COUNT), PUSH(pred_name, 2+XfOrM363_COUNT)));
#   define XfOrM369_COUNT (3+XfOrM363_COUNT)
#   define SETUP_XfOrM369(x) SETUP(XfOrM369_COUNT)
    name = NULLED_OUT ; 
    pred_name = NULLED_OUT ; 
    realm = NULLED_OUT ; 

# 2754 "bc/src/struct.c"
    name = FUNCCALL(SETUP_XfOrM369(_), extract_field_proc_name_and_realm (st -> name , prim , & pred_name , & realm ) ); 
    FUNCCALL_AGAIN(scheme_wrong_contract_for_realm (name , realm , pred_name , 0 , argc , args ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (! ((st -> name_pos <= inst -> stype -> name_pos ) && (st == inst -> stype -> parent_types [st -> name_pos ] ) ) ) {
#   define XfOrM368_COUNT (0+XfOrM363_COUNT)
#   define SETUP_XfOrM368(x) SETUP_XfOrM363(x)
    FUNCCALL(SETUP_XfOrM368(_), wrong_struct_type (prim , st -> name , ((((Scheme_Structure * ) inst ) -> stype ) -> name ) , 0 , argc , args ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc == 3 ) {
#   define XfOrM367_COUNT (0+XfOrM363_COUNT)
#   define SETUP_XfOrM367(x) SETUP_XfOrM363(x)

# 2768 "bc/src/struct.c"
    pos = FUNCCALL(SETUP_XfOrM367(_), parse_pos (((void * ) 0 ) , prim , args , argc ) ); 
    v = args [2 ] ; 
  }

# 2770 "bc/src/struct.c"
  else {
    pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) prim ) -> val [1 ] ) ) >> 1 ) ; 
    v = args [1 ] ; 
  }

  if (st -> immutables ) {
    int p = pos ; 
#   define XfOrM364_COUNT (0+XfOrM363_COUNT)
#   define SETUP_XfOrM364(x) SETUP_XfOrM363(x)

# 2778 "bc/src/struct.c"
    if (st -> name_pos )
      p -= st -> parent_types [st -> name_pos - 1 ] -> num_slots ; 

    if (st -> immutables [p ] ) {
#     define XfOrM365_COUNT (0+XfOrM364_COUNT)
#     define SETUP_XfOrM365(x) SETUP_XfOrM364(x)
      (__funcarg132 = FUNCCALL(SETUP_XfOrM365(_), extract_field_proc_name (prim ) )
# 2782 "bc/src/struct.c"
      , FUNCCALL_EMPTY(scheme_contract_error (__funcarg132 , "cannot modify value of immutable field in structure" , "structure" , 1 , args [0 ] , "field index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )) 



      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((Scheme_Object * ) inst ) == (args [0 ] ) ) 
    inst -> slots [pos ] = v ; 
  else FUNCCALL_EMPTY(chaperone_struct_set ("struct-set!" , prim , args [0 ] , pos , v ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2799 "bc/src/struct.c"
static Scheme_Object * 
struct_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v = argv [0 ] ; 
  Scheme_Config * __funcarg133 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM370_COUNT (1)
# define SETUP_XfOrM370(x) SETUP(XfOrM370_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2804 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    Scheme_Object * insp ; 
    BLOCK_SETUP((PUSH(insp, 0+XfOrM370_COUNT)));
#   define XfOrM371_COUNT (1+XfOrM370_COUNT)
#   define SETUP_XfOrM371(x) SETUP(XfOrM371_COUNT)
    insp = NULLED_OUT ; 

# 2809 "bc/src/struct.c"
    insp = (__funcarg133 = FUNCCALL(SETUP_XfOrM371(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg133 , MZCONFIG_INSPECTOR ) )) ; 
    if (FUNCCALL_EMPTY(scheme_inspector_sees_part (v , insp , - 1 ) ))
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }

# 2814 "bc/src/struct.c"
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2818 "bc/src/struct.c"
static Scheme_Object * 
struct_type_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2821 "bc/src/struct.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * proc_struct_type_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2827 "bc/src/struct.c"
  Scheme_Object * v = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) )  {
    if (((Scheme_Struct_Type * ) v ) -> proc_attr )
      return scheme_true ; 
    else 
    return scheme_false ; 
  }
  scheme_wrong_contract ("procedure-struct-type?" , "struct-type?" , 0 , argc , argv ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * apply_chaperones (const char * who , Scheme_Object * procs , int argc , Scheme_Object * * a ) 
{
  Scheme_Object * v , * * vals , * v1 [1 ] ; 
  int cnt , i , is_impersonator ; 
  Scheme_Thread * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(procs, 1), PUSH(who, 2), PUSHARRAY(v1, 1, 3), PUSH(v, 6), PUSH(p, 7), PUSH(vals, 8)));
# define XfOrM375_COUNT (9)
# define SETUP_XfOrM375(x) SETUP(XfOrM375_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  v1[0] = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 2848 "bc/src/struct.c"
  while (((Scheme_Type ) (((((intptr_t ) (procs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (procs ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM384_COUNT (0+XfOrM375_COUNT)
#   define SETUP_XfOrM384(x) SETUP_XfOrM375(x)

# 2849 "bc/src/struct.c"
    v = (((Scheme_Simple_Object * ) (procs ) ) -> u . pair_val . car ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) )  {
      is_impersonator = 1 ; 
      v = (((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) ; 
    }

# 2853 "bc/src/struct.c"
    else 
    is_impersonator = 0 ; 

    v = FUNCCALL(SETUP_XfOrM384(_), scheme_do_eval (v , argc , a , - 1 ) ); 

    if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      cnt = p -> ku . multiple . count ; 
      vals = p -> ku . multiple . array ; 
      p -> ku . multiple . array = ((void * ) 0 ) ; 
      if ((vals ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
      p = ((void * ) 0 ) ; 
    }

# 2866 "bc/src/struct.c"
    else {
      v1 [0 ] = v ; 
      vals = v1 ; 
      cnt = 1 ; 
    }

    if (cnt != argc ) {
#     define XfOrM388_COUNT (0+XfOrM384_COUNT)
#     define SETUP_XfOrM388(x) SETUP_XfOrM384(x)
      FUNCCALL(SETUP_XfOrM388(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "%s: arity mismatch;\n" " received wrong number of values from %s replacement procedure\n" "  expected: %d\n" "  received: %d\n" "  %s: %V\n" , who , is_impersonator ? "an impersonator's" : "a chaperone's" , (((Scheme_Simple_Object * ) (procs ) ) -> u . pair_val . car ) , argc , cnt , is_impersonator ? "impersonator" : "chaperone" ) )







      ; 
    }

    if (! is_impersonator ) {
#     define XfOrM385_COUNT (0+XfOrM384_COUNT)
#     define SETUP_XfOrM385(x) SETUP_XfOrM384(x)

# 2887 "bc/src/struct.c"
      for (i = 0 ; i < argc ; i ++ ) {
#       define XfOrM387_COUNT (0+XfOrM385_COUNT)
#       define SETUP_XfOrM387(x) SETUP_XfOrM385(x)

# 2888 "bc/src/struct.c"
        if (! FUNCCALL(SETUP_XfOrM387(_), scheme_chaperone_of (vals [i ] , a [i ] ) ))
          FUNCCALL(SETUP_XfOrM387(_), scheme_wrong_chaperoned (who , "result" , a [i ] , vals [i ] ) ); 
      }
    }

    a = vals ; 
    procs = (((Scheme_Simple_Object * ) (procs ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM375(_), scheme_values (argc , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2900 "bc/src/struct.c"
static Scheme_Object * struct_info_chaperone (Scheme_Object * o , Scheme_Object * si , Scheme_Object * b ) 
{
  Scheme_Object * procs = scheme_null , * proc , * a [2 ] ; 
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(procs, 3), PUSH(px, 4), PUSH(o, 5), PUSH(si, 6), PUSH(proc, 7), PUSH(b, 8)));
# define XfOrM392_COUNT (9)
# define SETUP_XfOrM392(x) SETUP(XfOrM392_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 2905 "bc/src/struct.c"
  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
#   define XfOrM396_COUNT (0+XfOrM392_COUNT)
#   define SETUP_XfOrM396(x) SETUP_XfOrM392(x)

# 2906 "bc/src/struct.c"
    px = (Scheme_Chaperone * ) o ; 
    if (((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) )  {
#     define XfOrM397_COUNT (0+XfOrM396_COUNT)
#     define SETUP_XfOrM397(x) SETUP_XfOrM396(x)

# 2908 "bc/src/struct.c"
      proc = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ; 
      if ((! (((proc ) ) == (scheme_false ) ) ) && ! ((proc ) == (scheme_undefined ) ) ) {
#       define XfOrM398_COUNT (0+XfOrM397_COUNT)
#       define SETUP_XfOrM398(x) SETUP_XfOrM397(x)

# 2910 "bc/src/struct.c"
        if ((& (px ) -> iso ) -> so . keyex & 0x1 )
          proc = FUNCCALL(SETUP_XfOrM398(_), scheme_box (proc ) ); 
        procs = FUNCCALL(SETUP_XfOrM398(_), scheme_make_pair (proc , procs ) ); 
      }
    }
    o = px -> prev ; 
  }

  a [0 ] = si ; 
  a [1 ] = b ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM392(_), apply_chaperones ("struct-info" , procs , 2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2924 "bc/src/struct.c"
static Scheme_Object * struct_info (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Structure * s ; 
  Scheme_Struct_Type * stype ; 
  int p ; 
  Scheme_Object * insp , * a [2 ] ; 
  Scheme_Object * v = argv [0 ] ; 
  Scheme_Config * __funcarg134 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(argv, 3), PUSH(v, 4), PUSH(stype, 5), PUSH(s, 6), PUSH(insp, 7)));
# define XfOrM399_COUNT (8)
# define SETUP_XfOrM399(x) SETUP(XfOrM399_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  stype = NULLED_OUT ; 
  insp = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 2932 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
#   define XfOrM400_COUNT (0+XfOrM399_COUNT)
#   define SETUP_XfOrM400(x) SETUP_XfOrM399(x)

# 2936 "bc/src/struct.c"
    s = (Scheme_Structure * ) v ; 

    insp = (__funcarg134 = FUNCCALL(SETUP_XfOrM400(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg134 , MZCONFIG_INSPECTOR ) )) ; 

    stype = s -> stype ; 
    p = stype -> name_pos + 1 ; 

    while (p -- ) {
#     define XfOrM403_COUNT (0+XfOrM400_COUNT)
#     define SETUP_XfOrM403(x) SETUP_XfOrM400(x)

# 2944 "bc/src/struct.c"
      stype = stype -> parent_types [p ] ; 
      if (scheme_is_subinspector (stype -> inspector , insp ) )  {
#       define XfOrM404_COUNT (0+XfOrM403_COUNT)
#       define SETUP_XfOrM404(x) SETUP_XfOrM403(x)

# 2946 "bc/src/struct.c"
        a [0 ] = (Scheme_Object * ) stype ; 
        a [1 ] = ((((stype ) == (s -> stype ) ) ) ? scheme_false : scheme_true ) ; 

        if (! ((v ) == (argv [0 ] ) ) )
          RET_VALUE_START (FUNCCALL(SETUP_XfOrM404(_), struct_info_chaperone (argv [0 ] , a [0 ] , a [1 ] ) )) RET_VALUE_END ; 
        else 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM404(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
      }
    }
  }

  a [0 ] = scheme_false ; 
  a [1 ] = scheme_true ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM399(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2963 "bc/src/struct.c"
static Scheme_Object * check_type_and_inspector (const char * who , int always , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * insp , * val ; 
  Scheme_Struct_Type * stype ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(who, 1), PUSH(stype, 2), PUSH(insp, 3)));
# define XfOrM405_COUNT (4)
# define SETUP_XfOrM405(x) SETUP(XfOrM405_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  insp = NULLED_OUT ; 
  val = NULLED_OUT ; 
  stype = NULLED_OUT ; 

# 2968 "bc/src/struct.c"
  val = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "struct-type?" , 0 , argc , argv ) ); 

  stype = (Scheme_Struct_Type * ) val ; 

  insp = FUNCCALL(SETUP_XfOrM405(_), scheme_get_current_inspector () ); 

  if (! always && ! (scheme_is_subinspector (stype -> inspector , insp ) ) ) {
#   define XfOrM406_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM406(x) SETUP_XfOrM405(x)
    FUNCCALL_EMPTY(scheme_contract_error (who , "current inspector cannot extract info for structure type" , "structure type" , 1 , argv [0 ] , ((void * ) 0 ) ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  RET_VALUE_START (insp ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2990 "bc/src/struct.c"
void scheme_force_struct_type_info (Scheme_Struct_Type * stype ) 
{
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0)));
# define XfOrM407_COUNT (1)
# define SETUP_XfOrM407(x) SETUP(XfOrM407_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2993 "bc/src/struct.c"
  if (! stype -> accessor ) {
    Scheme_Object * p ; 
    char * fn ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM407_COUNT), PUSH(fn, 1+XfOrM407_COUNT)));
#   define XfOrM408_COUNT (2+XfOrM407_COUNT)
#   define SETUP_XfOrM408(x) SETUP(XfOrM408_COUNT)
    p = NULLED_OUT ; 
    fn = NULLED_OUT ; 

# 2997 "bc/src/struct.c"
    fn = (char * ) FUNCCALL(SETUP_XfOrM408(_), make_name ("" , (char * ) stype -> name , - 1 , "-ref" , ((void * ) 0 ) , 0 , "" , 0 ) ); 
    p = FUNCCALL(SETUP_XfOrM408(_), make_struct_proc (stype , fn , SCHEME_GEN_GETTER , 0 ) ); 
    stype -> accessor = p ; 
    fn = (char * ) FUNCCALL(SETUP_XfOrM408(_), make_name ("" , (char * ) stype -> name , - 1 , "-set!" , ((void * ) 0 ) , 0 , "" , 0 ) ); 
    p = FUNCCALL(SETUP_XfOrM408(_), make_struct_proc (stype , fn , SCHEME_GEN_SETTER , 0 ) ); 
    stype -> mutator = p ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3006 "bc/src/struct.c"
static void get_struct_type_info (int argc , Scheme_Object * argv [] , Scheme_Object * * a , int always ) 
{
  Scheme_Struct_Type * stype , * parent ; 
  Scheme_Object * insp , * ims ; 
  int p , cnt ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(stype, 1), PUSH(ims, 2), PUSH(parent, 3), PUSH(argv, 4), PUSH(insp, 5)));
# define XfOrM409_COUNT (6)
# define SETUP_XfOrM409(x) SETUP(XfOrM409_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  parent = NULLED_OUT ; 
  insp = NULLED_OUT ; 
  ims = NULLED_OUT ; 

# 3012 "bc/src/struct.c"
  insp = FUNCCALL(SETUP_XfOrM409(_), check_type_and_inspector ("struct-type-info" , always , argc , argv ) ); 
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    stype = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) argv [0 ] ) -> val ) ; 
  else 
  stype = (Scheme_Struct_Type * ) argv [0 ] ; 
  FUNCCALL(SETUP_XfOrM409(_), scheme_force_struct_type_info (stype ) )
  ; 

  if (stype -> name_pos )
    parent = stype -> parent_types [stype -> name_pos - 1 ] ; 
  else 
  parent = ((void * ) 0 ) ; 

  a [0 ] = stype -> name ; 
  cnt = stype -> num_islots - (parent ? parent -> num_islots : 0 ) ; 
  a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cnt ) ) ) << 1 ) | 0x1 ) ) ; 
  a [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stype -> num_slots - (parent ? parent -> num_slots : 0 ) - cnt ) ) ) << 1 ) | 0x1 ) ) ; 
  a [3 ] = stype -> accessor ; 
  a [4 ] = stype -> mutator ; 

  p = stype -> name_pos ; 
  while (-- p >= 0 ) {
#   define XfOrM415_COUNT (0+XfOrM409_COUNT)
#   define SETUP_XfOrM415(x) SETUP_XfOrM409(x)

# 3034 "bc/src/struct.c"
    if (always || (scheme_is_subinspector (stype -> parent_types [p ] -> inspector , insp ) ) ) {
      break ; 
    }
  }

  ims = scheme_null ; 
  if (stype -> immutables ) {
    int i ; 
#   define XfOrM410_COUNT (0+XfOrM409_COUNT)
#   define SETUP_XfOrM410(x) SETUP_XfOrM409(x)

# 3042 "bc/src/struct.c"
    for (i = stype -> num_islots - (parent ? parent -> num_islots : 0 ) ; i -- ; ) {
#     define XfOrM412_COUNT (0+XfOrM410_COUNT)
#     define SETUP_XfOrM412(x) SETUP_XfOrM410(x)

# 3043 "bc/src/struct.c"
      if (stype -> immutables [i ] )
        ims = FUNCCALL(SETUP_XfOrM412(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , ims ) ); 
    }
  }
  a [5 ] = ims ; 

  a [6 ] = ((p >= 0 ) ? (Scheme_Object * ) stype -> parent_types [p ] : scheme_false ) ; 
  a [7 ] = ((p == stype -> name_pos - 1 ) ? scheme_false : scheme_true ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3053 "bc/src/struct.c"
static Scheme_Object * struct_type_info_chaperone (Scheme_Object * o , Scheme_Object * * a ) 
{
  Scheme_Object * procs = scheme_null , * proc ; 
  Scheme_Chaperone * px ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(procs, 1), PUSH(o, 2), PUSH(px, 3), PUSH(proc, 4)));
# define XfOrM417_COUNT (5)
# define SETUP_XfOrM417(x) SETUP(XfOrM417_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  proc = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 3058 "bc/src/struct.c"
  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#   define XfOrM420_COUNT (0+XfOrM417_COUNT)
#   define SETUP_XfOrM420(x) SETUP_XfOrM417(x)

# 3059 "bc/src/struct.c"
    px = (Scheme_Chaperone * ) o ; 
    if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM421_COUNT (0+XfOrM420_COUNT)
#     define SETUP_XfOrM421(x) SETUP_XfOrM420(x)

# 3061 "bc/src/struct.c"
      proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . car ) ; 
      if ((& (px ) -> iso ) -> so . keyex & 0x1 )
        proc = FUNCCALL(SETUP_XfOrM421(_), scheme_box (proc ) ); 
      procs = FUNCCALL(SETUP_XfOrM421(_), scheme_make_pair (proc , procs ) ); 
    }
    o = px -> prev ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(apply_chaperones ("struct-type-info" , procs , 8 , a ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3072 "bc/src/struct.c"
static Scheme_Object * struct_type_info (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [8 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 8, 0), PUSH(argv, 3)));
# define XfOrM422_COUNT (4)
# define SETUP_XfOrM422(x) SETUP(XfOrM422_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (a ) ; 
  FUNCCALL(SETUP_XfOrM422(_), get_struct_type_info (argc , argv , a , 0 ) )
# 3076 "bc/src/struct.c"
  ; 

  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
#   define XfOrM423_COUNT (0+XfOrM422_COUNT)
#   define SETUP_XfOrM423(x) SETUP_XfOrM422(x)

# 3079 "bc/src/struct.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM423(_), struct_type_info_chaperone (argv [0 ] , a ) )) RET_VALUE_END ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM422(_), scheme_values (8 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3085 "bc/src/struct.c"
static Scheme_Object * struct_type_sealed_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 3086 "bc/src/struct.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    scheme_wrong_contract ("struct-type-sealed?" , "struct-type?" , 0 , argc , argv ) ; 

  return ((((Scheme_Struct_Type * ) argv [0 ] ) -> more_flags & 0x8 ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * struct_type_authentic_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 3095 "bc/src/struct.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    scheme_wrong_contract ("struct-type-authentic?" , "struct-type?" , 0 , argc , argv ) ; 

  return ((((Scheme_Struct_Type * ) argv [0 ] ) -> more_flags & 0x4 ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * struct_type_pred (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Struct_Type * stype ; 
  char * name ; 
  char * __funcarg135 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(stype, 1), PUSH(argv, 2)));
# define XfOrM426_COUNT (3)
# define SETUP_XfOrM426(x) SETUP(XfOrM426_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  name = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM426(_), check_type_and_inspector ("struct-type-make-predicate" , 0 , argc , argv ) )
# 3108 "bc/src/struct.c"
  ; 
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    stype = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) argv [0 ] ) -> val ) ; 
  else 
  stype = (Scheme_Struct_Type * ) argv [0 ] ; 

  name = (char * ) (__funcarg135 = FUNCCALL(SETUP_XfOrM426(_), scheme_symbol_val (stype -> name ) ), FUNCCALL_AGAIN(make_name ("" , __funcarg135 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (stype -> name ) ) ) -> len ) , "?" , ((void * ) 0 ) , 0 , "" , 0 ) )) 

  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_struct_proc (stype , name , SCHEME_PRED , stype -> num_slots ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3121 "bc/src/struct.c"
static Scheme_Object * type_constr_chaperone (Scheme_Object * o , Scheme_Object * v ) 
{
  Scheme_Object * procs = scheme_null , * proc , * a [1 ] ; 
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0), PUSH(procs, 3), PUSH(o, 4), PUSH(px, 5), PUSH(v, 6), PUSH(proc, 7)));
# define XfOrM427_COUNT (8)
# define SETUP_XfOrM427(x) SETUP(XfOrM427_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 3126 "bc/src/struct.c"
  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#   define XfOrM430_COUNT (0+XfOrM427_COUNT)
#   define SETUP_XfOrM430(x) SETUP_XfOrM427(x)

# 3127 "bc/src/struct.c"
    px = (Scheme_Chaperone * ) o ; 
    if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM431_COUNT (0+XfOrM430_COUNT)
#     define SETUP_XfOrM431(x) SETUP_XfOrM430(x)

# 3129 "bc/src/struct.c"
      proc = ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ; 
      if ((& (px ) -> iso ) -> so . keyex & 0x1 )
        proc = FUNCCALL(SETUP_XfOrM431(_), scheme_box (proc ) ); 
      procs = FUNCCALL(SETUP_XfOrM431(_), scheme_make_pair (proc , procs ) ); 
    }
    o = px -> prev ; 
  }

  a [0 ] = v ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM427(_), apply_chaperones ("struct-type-make-constructor" , procs , 1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3141 "bc/src/struct.c"
static Scheme_Object * struct_type_constr (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * v ; 
  char * __funcarg137 = NULLED_OUT ; 
  char * __funcarg136 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(stype, 1), PUSH(v, 2)));
# define XfOrM432_COUNT (3)
# define SETUP_XfOrM432(x) SETUP(XfOrM432_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM432(_), check_type_and_inspector ("struct-type-make-constructor" , 0 , argc , argv ) )
# 3146 "bc/src/struct.c"
  ; 
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    stype = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) argv [0 ] ) -> val ) ; 
  else 
  stype = (Scheme_Struct_Type * ) argv [0 ] ; 

  if ((argc < 2 ) || (((argv [1 ] ) ) == (scheme_false ) ) )
    v = (__funcarg137 = FUNCCALL(SETUP_XfOrM432(_), scheme_symbol_val (stype -> name ) ), FUNCCALL_AGAIN(make_name ("make-" , __funcarg137 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (stype -> name ) ) ) -> len ) , "" , ((void * ) 0 ) , 0 , "" , 1 ) )) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    v = argv [1 ] ; 
  else {
#   define XfOrM433_COUNT (0+XfOrM432_COUNT)
#   define SETUP_XfOrM433(x) SETUP_XfOrM432(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("struct-type-make-constructor" , "symbol?" , 1 , argc , argv ) )
# 3157 "bc/src/struct.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  v = (__funcarg136 = FUNCCALL(SETUP_XfOrM432(_), scheme_symbol_val (v ) )
  , FUNCCALL_AGAIN(make_struct_proc (stype , __funcarg136 , SCHEME_CONSTR , stype -> num_slots ) )) 

  ; 

  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(type_constr_chaperone (argv [0 ] , v ) )) RET_VALUE_EMPTY_END ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3172 "bc/src/struct.c"
Scheme_Object * scheme_struct_to_vector (Scheme_Object * _s , Scheme_Object * unknown_val , Scheme_Object * insp ) 
{
  Scheme_Structure * s ; 
  Scheme_Struct_Type * stype ; 
  Scheme_Object * v , * elem , * name ; 
  GC_CAN_IGNORE Scheme_Object * * array ; 
  int i , m , p , n , last_is_unknown ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(_s, 1), PUSH(elem, 2), PUSH(s, 3), PUSH(v, 4), PUSH(unknown_val, 5), PUSH(stype, 6), PUSH(insp, 7)));
# define XfOrM434_COUNT (8)
# define SETUP_XfOrM434(x) SETUP(XfOrM434_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  stype = NULLED_OUT ; 
  v = NULLED_OUT ; 
  elem = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 3180 "bc/src/struct.c"
  if (! unknown_val )
    unknown_val = ellipses_symbol ; 

  if (((Scheme_Type ) (((((intptr_t ) (_s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (_s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (_s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (_s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (Scheme_Structure * ) (((Scheme_Chaperone * ) _s ) -> val ) ; 
  else 
  s = (Scheme_Structure * ) _s ; 

  stype = s -> stype ; 
  p = stype -> name_pos + 1 ; 
  m = 0 ; 
  last_is_unknown = 0 ; 
  while (p -- ) {
#   define XfOrM452_COUNT (0+XfOrM434_COUNT)
#   define SETUP_XfOrM452(x) SETUP_XfOrM434(x)

# 3193 "bc/src/struct.c"
    stype = stype -> parent_types [p ] ; 
    if (! (scheme_is_subinspector (stype -> inspector , insp ) ) ) {
      if (! last_is_unknown )
        m ++ ; 
      last_is_unknown = 1 ; 
    }

# 3198 "bc/src/struct.c"
    else {
      int count ; 
      if (p )
        count = stype -> num_slots - stype -> parent_types [p - 1 ] -> num_slots ; 
      else 
      count = stype -> num_slots ; 
      m += count ; 
      if (count )
        last_is_unknown = 0 ; 
    }
  }

  stype = s -> stype ; 
  p = stype -> name_pos + 1 ; 
  i = stype -> num_slots ; 
  last_is_unknown = 0 ; 

  name = FUNCCALL(SETUP_XfOrM434(_), make_name ("struct:" , (char * ) ((((Scheme_Structure * ) s ) -> stype ) -> name ) , - 1 , "" , ((void * ) 0 ) , 0 , "" , 1 ) ); 




  v = FUNCCALL_AGAIN(scheme_make_vector (m + 1 , ((void * ) 0 ) ) ); 
  array = (((Scheme_Vector * ) (v ) ) -> els ) ; 
  array [0 ] = name ; 
  while (p -- ) {
#   define XfOrM442_COUNT (0+XfOrM434_COUNT)
#   define SETUP_XfOrM442(x) SETUP_XfOrM434(x)

# 3224 "bc/src/struct.c"
    stype = stype -> parent_types [p ] ; 
    if (p )
      n = stype -> num_slots - stype -> parent_types [p - 1 ] -> num_slots ; 
    else 
    n = stype -> num_slots ; 

    if (! (scheme_is_subinspector (stype -> inspector , insp ) ) ) {
      if (! last_is_unknown )
        array [1 + (-- m ) ] = unknown_val ; 
      i -= n ; 
      last_is_unknown = 1 ; 
    }

# 3235 "bc/src/struct.c"
    else {
#     define XfOrM443_COUNT (0+XfOrM442_COUNT)
#     define SETUP_XfOrM443(x) SETUP_XfOrM442(x)

# 3236 "bc/src/struct.c"
      if (n )
        last_is_unknown = 0 ; 
      while (n -- ) {
#       define XfOrM446_COUNT (0+XfOrM443_COUNT)
#       define SETUP_XfOrM446(x) SETUP_XfOrM443(x)

# 3239 "bc/src/struct.c"
        -- i ; 
        if (((Scheme_Object * ) s ) == (_s ) ) 
          elem = s -> slots [i ] ; 
        else {
#         define XfOrM447_COUNT (0+XfOrM446_COUNT)
#         define SETUP_XfOrM447(x) SETUP_XfOrM446(x)

# 3244 "bc/src/struct.c"
          array = ((void * ) 0 ) ; 
          elem = FUNCCALL(SETUP_XfOrM447(_), scheme_struct_ref (_s , i ) ); 
          array = (((Scheme_Vector * ) (v ) ) -> els ) ; 
        }
        array [1 + (-- m ) ] = elem ; 
      }
    }
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3256 "bc/src/struct.c"
static Scheme_Object * struct_to_vector (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * __funcarg139 = NULLED_OUT ; 
  Scheme_Object * __funcarg138 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM455_COUNT (1)
# define SETUP_XfOrM455(x) SETUP(XfOrM455_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3258 "bc/src/struct.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) ) {
    char * tn , * s ; 
    int l ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM455_COUNT), PUSH(v, 1+XfOrM455_COUNT), PUSH(tn, 2+XfOrM455_COUNT)));
#   define XfOrM456_COUNT (3+XfOrM455_COUNT)
#   define SETUP_XfOrM456(x) SETUP(XfOrM456_COUNT)
    tn = NULLED_OUT ; 
    s = NULLED_OUT ; 
    v = NULLED_OUT ; 

# 3263 "bc/src/struct.c"
    tn = FUNCCALL(SETUP_XfOrM456(_), scheme_get_type_name (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ); 
    l = strlen (tn ) - 2 ; 
    s = FUNCCALL(SETUP_XfOrM456(_), GC_malloc_atomic (l + 8 ) ); 
    (strcpy (s , "struct:" ) ) ; 
    (memcpy (s + 7 , tn + 1 , l ) ) ; 
    s [7 + l ] = 0 ; 

    v = FUNCCALL(SETUP_XfOrM456(_), scheme_intern_symbol (s ) ); 
    v = FUNCCALL_AGAIN(scheme_make_vector (2 , v ) ); 
    (((Scheme_Vector * ) (v ) ) -> els ) [1 ] = (argc > 1 ) ? argv [1 ] : ellipses_symbol ; 

    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

  RET_VALUE_START ((__funcarg138 = (__funcarg139 = FUNCCALL(SETUP_XfOrM455(_), scheme_current_config () )

  , FUNCCALL_AGAIN(scheme_get_param (__funcarg139 , MZCONFIG_INSPECTOR ) )) , FUNCCALL_EMPTY(scheme_struct_to_vector (argv [0 ] , (argc > 1 ) ? argv [1 ] : ((void * ) 0 ) , __funcarg138 ) )) ) 
# 3277 "bc/src/struct.c"
  RET_VALUE_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3282 "bc/src/struct.c"
static Scheme_Object * prefab_struct_key (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3284 "bc/src/struct.c"
  return scheme_prefab_struct_key (argv [0 ] ) ; 
}

Scheme_Object * scheme_prefab_struct_key (Scheme_Object * so ) 
{
  /* No conversion */

# 3289 "bc/src/struct.c"
  Scheme_Structure * s = (Scheme_Structure * ) so ; 

  if (((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (Scheme_Structure * ) (((Scheme_Chaperone * ) (Scheme_Object * ) s ) -> val ) ; 

  if ((((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) s ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) s ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) s ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) s ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && s -> stype -> prefab_key ) {
    return (((Scheme_Simple_Object * ) (s -> stype -> prefab_key ) ) -> u . pair_val . cdr ) ; 
  }

  return scheme_false ; 
}

static Scheme_Object * prefab_struct_type_key (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 3302 "bc/src/struct.c"
  Scheme_Object * o ; 
  Scheme_Struct_Type * stype ; 

  o = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    scheme_wrong_contract ("prefab-struct-type-key+field-count" , "struct-type?" , 0 , argc , argv ) ; 

  stype = (Scheme_Struct_Type * ) o ; 
  if (stype -> prefab_key )
    return scheme_make_pair ((((Scheme_Simple_Object * ) (stype -> prefab_key ) ) -> u . pair_val . cdr ) , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stype -> num_slots ) ) ) << 1 ) | 0x1 ) ) ) ; 
  else 
  return scheme_false ; 
}

static Scheme_Object * make_prefab_struct (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * vec ; 
  int i ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(argv, 1), PUSH(vec, 2)));
# define XfOrM461_COUNT (3)
# define SETUP_XfOrM461(x) SETUP(XfOrM461_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  vec = NULLED_OUT ; 

# 3326 "bc/src/struct.c"
  stype = FUNCCALL(SETUP_XfOrM461(_), scheme_lookup_prefab_type (argv [0 ] , argc - 1 ) ); 

  if (! stype )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-prefab-struct" , "prefab-key?" , 0 , argc , argv ) ); 

  if (stype -> num_slots != (argc - 1 ) ) {
#   define XfOrM464_COUNT (0+XfOrM461_COUNT)
#   define SETUP_XfOrM464(x) SETUP_XfOrM461(x)
    FUNCCALL_EMPTY(scheme_contract_error ("make-prefab-struct" , "mismatch between argument count and prefab key" , "number of field arguments" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (argc - 1 ) ) ) << 1 ) | 0x1 ) ) , "prefab key" , 1 , argv [0 ] , ((void * ) 0 ) ) )

    ; 
  }

  vec = FUNCCALL(SETUP_XfOrM461(_), scheme_make_vector (argc , 0 ) ); 
  for (i = 0 ; i < argc ; i ++ ) {
    (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = argv [i ] ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_prefab_struct_instance (stype , vec ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3347 "bc/src/struct.c"
static Scheme_Object * prefab_key_struct_type (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Struct_Type * stype ; 
  int v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(argv, 1)));
# define XfOrM465_COUNT (2)
# define SETUP_XfOrM465(x) SETUP(XfOrM465_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 

# 3352 "bc/src/struct.c"
  if (((intptr_t ) (argv [1 ] ) ) & 0x1 )  {
    v = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
    if (v > 32768 )
      v = - 1 ; 
  }

# 3356 "bc/src/struct.c"
  else 
  v = - 1 ; 

  stype = FUNCCALL(SETUP_XfOrM465(_), scheme_lookup_prefab_type (argv [0 ] , (v >= 0 ) ? v : - 1 ) ); 

  if (! stype )
    FUNCCALL_EMPTY(scheme_wrong_contract ("prefab-key->struct-type" , "prefab-key?" , 0 , argc , argv ) ); 

  if (v < 0 )
    FUNCCALL_EMPTY(scheme_wrong_contract ("prefab-key->struct-type" , "(integer-in 0 " "32768" ")" , 1 , argc , argv ) )

  ; 

  if (stype -> num_slots != v ) {
#   define XfOrM466_COUNT (0+XfOrM465_COUNT)
#   define SETUP_XfOrM466(x) SETUP_XfOrM465(x)
    FUNCCALL_EMPTY(scheme_contract_error ("prefab-key->struct-type" , "mismatch between prefab key and field count" , "prefab key" , 1 , argv [0 ] , "field count" , 1 , argv [1 ] , ((void * ) 0 ) ) )

    ; 
  }

  RET_VALUE_START ((Scheme_Object * ) stype ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3380 "bc/src/struct.c"
static Scheme_Object * is_prefab_key (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3382 "bc/src/struct.c"
  return (scheme_lookup_prefab_type (argv [0 ] , - 1 ) 
  ? scheme_true 
  : scheme_false ) ; 
}

int scheme_inspector_sees_part (Scheme_Object * s , Scheme_Object * insp , int pos ) 


{
  /* No conversion */

# 3391 "bc/src/struct.c"
  Scheme_Struct_Type * stype ; 
  int p ; 

  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (((Scheme_Chaperone * ) s ) -> val ) ; 

  stype = ((Scheme_Structure * ) s ) -> stype ; 

  p = stype -> name_pos ; 

  if (pos == - 1 ) {

    Scheme_Object * prev = ((void * ) 0 ) ; 
    while (p > - 1 ) {
      if (! ((stype -> parent_types [p ] -> inspector ) == (prev ) ) ) {
        prev = stype -> parent_types [p ] -> inspector ; 
        if (scheme_is_subinspector (prev , insp ) )
          return 1 ; 
      }
      p -- ; 
    }

    return 0 ; 
  }

# 3414 "bc/src/struct.c"
  else if (pos == - 2 ) {

    Scheme_Object * prev = ((void * ) 0 ) ; 
    while (p > - 1 ) {
      if (! ((stype -> parent_types [p ] -> inspector ) == (prev ) ) ) {
        prev = stype -> parent_types [p ] -> inspector ; 
        if (! scheme_is_subinspector (prev , insp ) )
          return 0 ; 
      }
      p -- ; 
    }

    return 1 ; 
  }

# 3427 "bc/src/struct.c"
  else {

    while (p && (stype -> parent_types [p - 1 ] -> num_slots > pos ) ) {
      p -- ; 
    }

    return scheme_is_subinspector (stype -> parent_types [p ] -> inspector , insp ) ; 
  }
}

int scheme_struct_is_transparent (Scheme_Object * s ) 
{
  /* No conversion */

# 3439 "bc/src/struct.c"
  Scheme_Struct_Type * stype ; 
  int p ; 

  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (((Scheme_Chaperone * ) s ) -> val ) ; 

  stype = ((Scheme_Structure * ) s ) -> stype ; 

  for (p = stype -> name_pos + 1 ; p -- ; ) {
    if (! (((stype -> parent_types [p ] -> inspector ) ) == (scheme_false ) ) ) 
      return 0 ; 
  }

  return 1 ; 
}





static Scheme_Object * 
struct_setter_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3462 "bc/src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3463 "bc/src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return ((((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((128 | 256 ) ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == (256 ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((32 | 128 ) ) ) ) ) 
  && ! ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & 4 ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
struct_getter_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3474 "bc/src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3475 "bc/src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return ((((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == (32 ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((32 | 256 ) ) ) ) ) 
  && ! ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & 4 ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
struct_pred_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3485 "bc/src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3486 "bc/src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return (((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((32 | 64 ) ) ) ) 
  && ! ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & 4 ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
struct_constr_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3495 "bc/src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3496 "bc/src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return ((((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == (128 ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((32 | 64 | 128 ) ) ) ) ) 
  && ! ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & 4 ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
struct_prop_getter_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3506 "bc/src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3507 "bc/src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return (((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((64 | 128 ) ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) ) 
  ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * 
struct_prop_pred_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3515 "bc/src/struct.c"
  Scheme_Object * v = argv [0 ] , * prop , * prop_t ; 

  if (argc > 1 ) {
    if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) )
      scheme_wrong_contract ("struct-type-property-predicate-procedure?" , "(or/c struct-type-property? #f)" , 1 , argc , argv ) ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3522 "bc/src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (! ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((64 | 128 | 256 ) ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) ) )
    return scheme_false ; 

  if ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) {
    prop = ((Scheme_Primitive_Closure * ) v ) -> val [0 ] ; 
    prop_t = argv [1 ] ; 
    return (((prop ) == (prop_t ) ) ? scheme_true : scheme_false ) ; 
  }

  return scheme_true ; 
}

static Scheme_Object * 
chaperone_prop_getter_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3540 "bc/src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3541 "bc/src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return (((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((64 | 128 ) ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

int scheme_decode_struct_shape (Scheme_Object * expected , intptr_t * _v ) 
{
  /* No conversion */

# 3549 "bc/src/struct.c"
  intptr_t v ; 
  int i ; 

  if (! expected || ! ((Scheme_Type ) (((((intptr_t ) (expected ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expected ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    return 0 ; 

  if (((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [0 ] != 's' ) 
  || ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> len ) < 6 ) )
    return 0 ; 

  for (i = 6 , v = 0 ; (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [i ] ; i ++ ) {
    v = (v * 10 ) + ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [i ] - '0' ) ; 
  }

  * _v = v ; 

  return 1 ; 
}

intptr_t scheme_get_or_check_structure_shape (Scheme_Object * e , Scheme_Object * expected ) 
{
  intptr_t _v , v , want_v ; 
  int i ; 
  Scheme_Struct_Type * st ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(st, 0), PUSH(e, 1), PUSH(expected, 2)));
# define XfOrM498_COUNT (3)
# define SETUP_XfOrM498(x) SETUP(XfOrM498_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  st = NULLED_OUT ; 

# 3574 "bc/src/struct.c"
  if (expected ) {
#   define XfOrM507_COUNT (0+XfOrM498_COUNT)
#   define SETUP_XfOrM507(x) SETUP_XfOrM498(x)

# 3575 "bc/src/struct.c"
    if (! FUNCCALL(SETUP_XfOrM507(_), scheme_decode_struct_shape (expected , & _v ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    v = _v ; 
  }

# 3578 "bc/src/struct.c"
  else 
  v = 0 ; 

  if ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) )  {
    st = (Scheme_Struct_Type * ) e ; 
    if (st -> num_slots != st -> num_islots )
      want_v = 5 ; 
    else 
    want_v = ((st -> num_slots << 7 ) 
    | 0 
    | (((st -> more_flags & 0x4 ) 
    && (! expected || (v & 0x10 ) ) ) 
    ? 0x10 
    : 0 ) 
    | (((st -> more_flags & 0x1 ) 
    && (! expected || (v & 0x20 ) ) ) 
    ? 0x20 
    : 0 ) 
    | ((st -> prefab_key 
    && (! expected || (v & 0x40 ) ) ) 
    ? 0x40 
    : 0 ) ) ; 
  }

# 3600 "bc/src/struct.c"
  else if (! ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) ) {
    want_v = - 1 ; 
  }

# 3602 "bc/src/struct.c"
  else {
    i = (((Scheme_Primitive_Proc * ) e ) -> pp . flags & (32 | 64 | 128 | 256 ) ) ; 
    if ((i == 128 ) 
    || (i == (32 | 64 | 128 ) ) ) {
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) e ) -> val [0 ] ; 
      want_v = ((st -> num_islots << 7 ) 
      | 1 
      | (((st -> more_flags & 0x1 ) 
      && (! expected || (v & 0x20 ) ) ) 
      ? 0x20 
      : 0 ) ) ; 
    }

# 3613 "bc/src/struct.c"
    else if (i == (32 | 64 ) ) {
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) e ) -> val [0 ] ; 
      want_v = (2 
      | (((st -> more_flags & 0x4 ) 
      && (! expected || (v & 0x10 ) ) ) 
      ? 0x10 
      : 0 ) ) ; 
    }

# 3620 "bc/src/struct.c"
    else if (i == (128 | 256 ) ) {
      int pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) e ) -> val [1 ] ) ) >> 1 ) ; 
      int parent_slots ; 
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) e ) -> val [0 ] ; 
      parent_slots = ((st -> name_pos > 0 ) 
      ? st -> parent_types [st -> name_pos - 1 ] -> num_slots 
      : 0 ) ; 
      if ((pos - parent_slots ) < (31 - 7 ) )
        pos ++ ; 
      else 
      pos = 0 ; 
      want_v = ((pos << 7 ) 
      | 4 
      | (((st -> more_flags & 0x4 ) 
      && (! expected || (v & 0x10 ) ) ) 
      ? 0x10 
      : 0 ) ) ; 
    }

# 3637 "bc/src/struct.c"
    else if (i == 32 ) {
      int pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) e ) -> val [1 ] ) ) >> 1 ) ; 
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) e ) -> val [0 ] ; 
      want_v = ((pos << 7 ) 
      | 3 
      | (((st -> more_flags & 0x4 ) 
      && (! expected || (v & 0x10 ) ) ) 
      ? 0x10 
      : 0 ) ) ; 
    }

# 3646 "bc/src/struct.c"
    else if ((i == 256 ) 
    || (i == (32 | 128 ) ) 
    || (i == (32 | 256 ) ) ) {
      want_v = 5 ; 
    }

# 3650 "bc/src/struct.c"
    else 
    want_v = - 1 ; 
  }

  if (expected )
    RET_VALUE_START ((v == want_v ) ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (want_v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3660 "bc/src/struct.c"
int scheme_decode_struct_prop_shape (Scheme_Object * expected , intptr_t * _v ) 
{
  /* No conversion */

# 3662 "bc/src/struct.c"
  intptr_t v ; 
  int i ; 

  if (! expected || ! ((Scheme_Type ) (((((intptr_t ) (expected ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expected ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    return 0 ; 

  if (((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [0 ] != 'p' ) 
  || ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> len ) < 4 ) )
    return 0 ; 

  for (i = 4 , v = 0 ; (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [i ] ; i ++ ) {
    v = (v * 10 ) + ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [i ] - '0' ) ; 
  }

  * _v = v ; 

  return 1 ; 
}

intptr_t scheme_get_or_check_structure_property_shape (Scheme_Object * e , Scheme_Object * expected ) 
{
  intptr_t _v , v , want_v ; 
  int i ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(expected, 1)));
# define XfOrM511_COUNT (2)
# define SETUP_XfOrM511(x) SETUP(XfOrM511_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3686 "bc/src/struct.c"
  if (expected ) {
#   define XfOrM516_COUNT (0+XfOrM511_COUNT)
#   define SETUP_XfOrM516(x) SETUP_XfOrM511(x)

# 3687 "bc/src/struct.c"
    if (! FUNCCALL(SETUP_XfOrM516(_), scheme_decode_struct_prop_shape (expected , & _v ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    v = _v ; 
  }

# 3690 "bc/src/struct.c"
  else 
  v = 0 ; 

  if ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) )  {
    if (((Scheme_Struct_Property * ) e ) -> guard )
      want_v = 1 ; 
    else {
      want_v = 0 ; 
      if (expected )
        RET_VALUE_START (((v == 0 ) 
      || (v == 1 ) ) ) 
# 3699 "bc/src/struct.c"
      RET_VALUE_END 
      ; 
    }
  }

# 3702 "bc/src/struct.c"
  else if (! ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) ) {
    want_v = - 1 ; 
  }

# 3704 "bc/src/struct.c"
  else {
    i = (((Scheme_Primitive_Proc * ) e ) -> pp . flags & (32 | 64 | 128 | 256 ) ) ; 
    if (i == (64 | 128 | 256 ) )
      want_v = 2 ; 
    else if (i == (64 | 128 ) )
      want_v = 3 ; 
    else 
    want_v = - 1 ; 
  }

  if (expected )
    RET_VALUE_START (v == want_v ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (want_v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3720 "bc/src/struct.c"
static Scheme_Object * make_struct_field_xxor (const char * who , int getter , 
int argc , Scheme_Object * argv [] ) 
{
  int pos ; 
  char * name ; 
  const char * fieldstr ; 
  char digitbuf [20 ] ; 
  int fieldstrlen ; 
  Scheme_Struct_Type * st ; 
  Scheme_Object * realm = scheme_default_realm , * contract = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(realm, 1), PUSH(st, 2), PUSH(who, 3), PUSH(contract, 4), PUSH(argv, 5), PUSH(fieldstr, 6)));
# define XfOrM517_COUNT (7)
# define SETUP_XfOrM517(x) SETUP(XfOrM517_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 
  fieldstr = NULLED_OUT ; 
  st = NULLED_OUT ; 

# 3734 "bc/src/struct.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) argv [0 ] ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((getter ? (32 | 256 ) : 256 ) ) ) ) ) 

  {
#   define XfOrM533_COUNT (0+XfOrM517_COUNT)
#   define SETUP_XfOrM533(x) SETUP_XfOrM517(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (who , (getter ? "(and/c struct-accessor-procedure? (lambda (p) (procedure-arity-includes? p 2)))" : "(and/c struct-mutator-procedure? (lambda (p) (procedure-arity-includes? p 2)))" ) , 0 , argc , argv ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  pos = FUNCCALL(SETUP_XfOrM517(_), parse_pos (who , argv [0 ] , argv , argc ) ); 

  if (argc > 2 ) {
#   define XfOrM524_COUNT (0+XfOrM517_COUNT)
#   define SETUP_XfOrM524(x) SETUP_XfOrM517(x)

# 3747 "bc/src/struct.c"
    if (((argv [2 ] ) ) == (scheme_false ) )  {
      fieldstr = ((void * ) 0 ) ; 
      fieldstrlen = 0 ; 
    }

# 3750 "bc/src/struct.c"
    else {
#     define XfOrM530_COUNT (0+XfOrM524_COUNT)
#     define SETUP_XfOrM530(x) SETUP_XfOrM524(x)

# 3751 "bc/src/struct.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#       define XfOrM531_COUNT (0+XfOrM530_COUNT)
#       define SETUP_XfOrM531(x) SETUP_XfOrM530(x)
        FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? #f)" , 2 , argc , argv ) )
# 3752 "bc/src/struct.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      fieldstr = FUNCCALL(SETUP_XfOrM530(_), scheme_symbol_val (argv [2 ] ) ); 
      fieldstrlen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [2 ] ) ) ) -> len ) ; 
    }
    if (argc > 3 ) {
#     define XfOrM526_COUNT (0+XfOrM524_COUNT)
#     define SETUP_XfOrM526(x) SETUP_XfOrM524(x)

# 3759 "bc/src/struct.c"
      if (((argv [3 ] ) ) == (scheme_false ) )  {
        name = ((void * ) 0 ) ; 
      }

# 3761 "bc/src/struct.c"
      else {
#       define XfOrM527_COUNT (0+XfOrM526_COUNT)
#       define SETUP_XfOrM527(x) SETUP_XfOrM526(x)

# 3762 "bc/src/struct.c"
        name = (char * ) fieldstr ; 
        if (! ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? string? #f)" , 3 , argc , argv ) ); 
        contract = argv [3 ] ; 
        if (argc > 4 ) {
#         define XfOrM528_COUNT (0+XfOrM527_COUNT)
#         define SETUP_XfOrM528(x) SETUP_XfOrM527(x)

# 3767 "bc/src/struct.c"
          if (! ((Scheme_Type ) (((((intptr_t ) (argv [4 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [4 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
            FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 4 , argc , argv ) ); 
          realm = argv [4 ] ; 
        }
      }
    }

# 3772 "bc/src/struct.c"
    else {
      name = ((void * ) 0 ) ; 
    }
  }

# 3775 "bc/src/struct.c"
  else {
    fieldstr = ((void * ) 0 ) ; 
    fieldstrlen = 0 ; 
    name = ((void * ) 0 ) ; 
  }

  if (! name && ! fieldstr ) {
#   define XfOrM522_COUNT (0+XfOrM517_COUNT)
#   define SETUP_XfOrM522(x) SETUP_XfOrM517(x)
    (
# 3782 "bc/src/struct.c"
    sprintf (digitbuf , "field%d" , (int ) (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ) ; 
    fieldstr = digitbuf ; 
    fieldstrlen = strlen (fieldstr ) ; 
    name = ((void * ) 0 ) ; 
  }

  st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) argv [0 ] ) -> val [0 ] ; 

  if (! name ) {
#   define XfOrM518_COUNT (0+XfOrM517_COUNT)
#   define SETUP_XfOrM518(x) SETUP_XfOrM517(x)

# 3791 "bc/src/struct.c"
    if (! fieldstr ) {
      if (getter )
        name = "accessor" ; 
      else 
      name = "mutator" ; 
    }

# 3796 "bc/src/struct.c"
    else if (getter ) {
#     define XfOrM520_COUNT (0+XfOrM518_COUNT)
#     define SETUP_XfOrM520(x) SETUP_XfOrM518(x)

# 3797 "bc/src/struct.c"
      name = (char * ) FUNCCALL(SETUP_XfOrM520(_), make_name ("" , (char * ) st -> name , - 1 , "-" , fieldstr , fieldstrlen , "" , 0 ) )
      ; 
    }

# 3799 "bc/src/struct.c"
    else {
#     define XfOrM519_COUNT (0+XfOrM518_COUNT)
#     define SETUP_XfOrM519(x) SETUP_XfOrM518(x)

# 3800 "bc/src/struct.c"
      name = (char * ) FUNCCALL(SETUP_XfOrM519(_), make_name ("set-" , (char * ) st -> name , - 1 , "-" , fieldstr , fieldstrlen , "!" , 0 ) )
      ; 
    }
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_struct_proc_for_realm (st , name , realm , contract , (getter ? SCHEME_GETTER : SCHEME_SETTER ) , pos ) )) RET_VALUE_EMPTY_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3810 "bc/src/struct.c"
static Scheme_Object * make_struct_field_accessor (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3812 "bc/src/struct.c"
  return make_struct_field_xxor ("make-struct-field-accessor" , 1 , argc , argv ) ; 
}


static Scheme_Object * make_struct_field_mutator (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3818 "bc/src/struct.c"
  return make_struct_field_xxor ("make-struct-field-mutator" , 0 , argc , argv ) ; 
}





static Scheme_Object * wrap_evt (const char * who , Scheme_Type ty , int argc , Scheme_Object * argv [] ) 
{
  Wrapped_Evt * ww ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(argv, 1), PUSH(ww, 2)));
# define XfOrM536_COUNT (3)
# define SETUP_XfOrM536(x) SETUP(XfOrM536_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ww = NULLED_OUT ; 

# 3829 "bc/src/struct.c"
  if (! FUNCCALL(SETUP_XfOrM536(_), scheme_is_evt (argv [0 ] ) ))
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "evt?" , 0 , argc , argv ) ); 

  if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "procedure?" , 1 , argc , argv ) ); 

  ww = ((Wrapped_Evt * ) FUNCCALL(SETUP_XfOrM536(_), GC_malloc_one_small_tagged ((((sizeof (Wrapped_Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  ww -> so . type = ty ; 
  ww -> evt = argv [0 ] ; 
  ww -> wrapper = argv [1 ] ; 

  RET_VALUE_START ((Scheme_Object * ) ww ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3843 "bc/src/struct.c"
Scheme_Object * scheme_wrap_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3845 "bc/src/struct.c"
  return wrap_evt ("wrap-evt" , scheme_wrap_evt_type , argc , argv ) ; 
}

Scheme_Object * handle_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3850 "bc/src/struct.c"
  return wrap_evt ("handle-evt" , scheme_handle_evt_type , argc , argv ) ; 
}

Scheme_Object * replace_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3855 "bc/src/struct.c"
  return wrap_evt ("replace-evt" , scheme_replace_evt_type , argc , argv ) ; 
}

Scheme_Object * handle_evt_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3860 "bc/src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_handle_evt_type ) ) 
    return scheme_true ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_evt_set_type ) )  {
    Evt_Set * es = (Evt_Set * ) argv [0 ] ; 
    int i ; 
    for (i = es -> argc ; i -- ; ) {
      if ((Scheme_Type ) (((((intptr_t ) (es -> argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (es -> argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_handle_evt_type ) )  {
        return scheme_true ; 
      }
    }
  }

  if (argc )
    return scheme_false ; 
  else 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * do_chaperone_result_guard_proc (int is_impersonator , void * data , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * proc = (Scheme_Object * ) data , * o , * a [1 ] ; 
  Scheme_Object * * received_vals , * * guard_argv ; 
  int received_cnt , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(received_vals, 0), PUSHARRAY(a, 1, 1), PUSH(proc, 4), PUSH(o, 5), PUSH(argv, 6), PUSH(guard_argv, 7)));
# define XfOrM546_COUNT (8)
# define SETUP_XfOrM546(x) SETUP(XfOrM546_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  received_vals = NULLED_OUT ; 
  guard_argv = NULLED_OUT ; 

# 3886 "bc/src/struct.c"
  guard_argv = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM546(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
  (memcpy (guard_argv , argv , sizeof (Scheme_Object * ) * argc ) ) ; 

  o = FUNCCALL(SETUP_XfOrM546(_), scheme_do_eval (proc , argc , guard_argv , - 1 ) ); 

  if ((o ) == (((Scheme_Object * ) 0x6 ) ) )  {
#   define XfOrM552_COUNT (0+XfOrM546_COUNT)
#   define SETUP_XfOrM552(x) SETUP_XfOrM546(x)

# 3892 "bc/src/struct.c"
    received_cnt = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ) ; 
    received_vals = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) ; 
    FUNCCALL(SETUP_XfOrM552(_), scheme_detach_multple_array (received_vals ) ); 
  }

# 3895 "bc/src/struct.c"
  else {
    a [0 ] = o ; 
    received_vals = a ; 
    received_cnt = 1 ; 
  }

  if (received_cnt != argc ) {
#   define XfOrM550_COUNT (0+XfOrM546_COUNT)
#   define SETUP_XfOrM550(x) SETUP_XfOrM546(x)
    FUNCCALL(SETUP_XfOrM550(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "evt %s: returned wrong number of values\n" "  %s : %V\n" "  expected count: %d\n" "  returned count: %d\n" , is_impersonator ? "impersonator" : "chaperone" , is_impersonator ? "impersonator" : "chaperone" , proc , argc , received_cnt ) )





    ; 
  }

  if (! is_impersonator ) {
#   define XfOrM547_COUNT (0+XfOrM546_COUNT)
#   define SETUP_XfOrM547(x) SETUP_XfOrM546(x)

# 3914 "bc/src/struct.c"
    for (i = 0 ; i < argc ; i ++ ) {
#     define XfOrM549_COUNT (0+XfOrM547_COUNT)
#     define SETUP_XfOrM549(x) SETUP_XfOrM547(x)

# 3915 "bc/src/struct.c"
      if (! FUNCCALL(SETUP_XfOrM549(_), scheme_chaperone_of (received_vals [i ] , argv [i ] ) ))
        FUNCCALL(SETUP_XfOrM549(_), scheme_wrong_chaperoned ("evt result" , "value" , argv [i ] , received_vals [i ] ) ); 
    }
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3923 "bc/src/struct.c"
static Scheme_Object * chaperone_result_guard_proc (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3925 "bc/src/struct.c"
  return do_chaperone_result_guard_proc (0 , data , argc , argv ) ; 
}

static Scheme_Object * impersonator_result_guard_proc (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3930 "bc/src/struct.c"
  return do_chaperone_result_guard_proc (1 , data , argc , argv ) ; 
}

static Scheme_Object * do_chaperone_guard_proc (int is_impersonator , void * data , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * evt = (((Scheme_Simple_Object * ) ((Scheme_Object * ) data ) ) -> u . pair_val . car ) ; 
  Scheme_Object * proc = (((Scheme_Simple_Object * ) ((Scheme_Object * ) data ) ) -> u . pair_val . cdr ) ; 
  Scheme_Object * a [2 ] , * o , * * vals ; 
  int cnt ; 
  Scheme_Thread * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(evt, 3), PUSH(o, 4), PUSH(p, 5), PUSH(vals, 6), PUSH(proc, 7)));
# define XfOrM555_COUNT (8)
# define SETUP_XfOrM555(x) SETUP(XfOrM555_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  o = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 3941 "bc/src/struct.c"
  a [0 ] = evt ; 

  o = FUNCCALL(SETUP_XfOrM555(_), scheme_do_eval (proc , 1 , a , - 1 ) ); 

  if ((o ) == (((Scheme_Object * ) 0x6 ) ) )  {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    cnt = p -> ku . multiple . count ; 
    vals = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
    if ((vals ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
    p = ((void * ) 0 ) ; 
  }

# 3953 "bc/src/struct.c"
  else {
    vals = ((void * ) 0 ) ; 
    cnt = 1 ; 
  }

  if (cnt != 2 )
    FUNCCALL(SETUP_XfOrM555(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "evt %s: returned wrong number of values\n" "  %s: %V\n" "  expected count: 2\n" "  returned count: %d" , (is_impersonator ? "impersonator" : "chaperone" ) , (is_impersonator ? "impersonator" : "chaperone" ) , proc , cnt ) )







  ; 

  if (! is_impersonator )
    if (! FUNCCALL(SETUP_XfOrM555(_), scheme_chaperone_of (vals [0 ] , evt ) ))
    FUNCCALL(SETUP_XfOrM555(_), scheme_wrong_chaperoned ("evt chaperone" , "value" , evt , vals [0 ] ) ); 
  if (! FUNCCALL(SETUP_XfOrM555(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 1 , 1 , vals ) ))
    FUNCCALL(SETUP_XfOrM555(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT , "evt %s: contract violation for second %s result\n" "  expected: (any/c any/c . -> . any)\n" "  received: %V" , (is_impersonator ? "impersonator" : "chaperone" ) , (is_impersonator ? "impersonator" : "chaperone" ) , vals [1 ] ) )





  ; 

  a [0 ] = vals [0 ] ; 
  o = FUNCCALL(SETUP_XfOrM555(_), scheme_make_closed_prim_w_arity ((is_impersonator ? impersonator_result_guard_proc : chaperone_result_guard_proc ) , (void * ) vals [1 ] , "evt-result-chaperone" , 1 , - 1 ) )




  ; 
  a [1 ] = o ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM555(_), scheme_wrap_evt (1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3993 "bc/src/struct.c"
static Scheme_Object * chaperone_guard_proc (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3995 "bc/src/struct.c"
  return do_chaperone_guard_proc (0 , data , argc , argv ) ; 
}

static Scheme_Object * impersonator_guard_proc (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4000 "bc/src/struct.c"
  return do_chaperone_guard_proc (1 , data , argc , argv ) ; 
}

Scheme_Object * scheme_do_chaperone_evt (const char * name , int is_impersonator , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * o , * val , * a [1 ] ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(px, 1), PUSH(o, 2), PUSH(props, 3), PUSH(val, 4), PUSHARRAY(a, 1, 5), PUSH(argv, 8)));
# define XfOrM560_COUNT (9)
# define SETUP_XfOrM560(x) SETUP(XfOrM560_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  o = NULLED_OUT ; 
  val = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 4009 "bc/src/struct.c"
  val = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! FUNCCALL(SETUP_XfOrM560(_), scheme_is_evt (val ) ))
    FUNCCALL(SETUP_XfOrM560(_), scheme_wrong_contract (name , "evt?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM560(_), scheme_check_proc_arity (name , 1 , 1 , argc , argv ) ); 

  props = FUNCCALL_AGAIN(scheme_parse_chaperone_props (name , 2 , argc , argv ) ); 

  o = FUNCCALL_AGAIN(scheme_make_pair (argv [0 ] , argv [1 ] ) ); 
  o = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity ((is_impersonator ? impersonator_guard_proc : chaperone_guard_proc ) , (void * ) o , (is_impersonator ? "chaperone-evt" : "impersonate-evt" ) , 1 , 1 ) )






  ; 
  a [0 ] = o ; 
  o = FUNCCALL(SETUP_XfOrM560(_), nack_evt (1 , a ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM560(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  if (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
    px -> iso . so . type = scheme_proc_chaperone_type ; 
  else 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = o ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4047 "bc/src/struct.c"
static Scheme_Object * chaperone_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4049 "bc/src/struct.c"
  return scheme_do_chaperone_evt ("chaperone-evt" , 0 , argc , argv ) ; 
}

static int chaperone_evt_is_ready (Scheme_Object * obj , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 4054 "bc/src/struct.c"
  Scheme_Object * o = obj ; 
  Scheme_Chaperone * px ; 
  int redirected = 0 ; 

  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
    px = (Scheme_Chaperone * ) o ; 
    if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_nack_guard_evt_type ) )  {
      o = px -> redirects ; 
      redirected = 1 ; 
      break ; 
    }
    o = px -> prev ; 
  }

  if (! redirected && (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {



    return evt_struct_is_ready (obj , sinfo ) ; 
  }

  scheme_set_sync_target (sinfo , o , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) ; 
  return 0 ; 
}

static int is_chaperone_evt (Scheme_Object * o ) 
{
  /* No conversion */

# 4081 "bc/src/struct.c"
  return scheme_is_evt ((((Scheme_Chaperone * ) o ) -> val ) ) ; 
}

static Scheme_Object * nack_evt (int argc , Scheme_Object * argv [] ) 
{
  Nack_Guard_Evt * nw ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(nw, 1)));
# define XfOrM569_COUNT (2)
# define SETUP_XfOrM569(x) SETUP(XfOrM569_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  nw = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM569(_), scheme_check_proc_arity ("nack-guard-evt" , 1 , 0 , argc , argv ) )
# 4088 "bc/src/struct.c"
  ; 

  nw = ((Nack_Guard_Evt * ) FUNCCALL(SETUP_XfOrM569(_), GC_malloc_one_small_tagged ((((sizeof (Nack_Guard_Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  nw -> so . type = scheme_nack_guard_evt_type ; 
  nw -> maker = argv [0 ] ; 

  RET_VALUE_START ((Scheme_Object * ) nw ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4097 "bc/src/struct.c"
Scheme_Object * scheme_poll_evt (int argc , Scheme_Object * argv [] ) 
{
  Nack_Guard_Evt * nw ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(nw, 1)));
# define XfOrM570_COUNT (2)
# define SETUP_XfOrM570(x) SETUP(XfOrM570_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  nw = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM570(_), scheme_check_proc_arity ("poll-guard-evt" , 1 , 0 , argc , argv ) )
# 4101 "bc/src/struct.c"
  ; 

  nw = ((Nack_Guard_Evt * ) FUNCCALL(SETUP_XfOrM570(_), GC_malloc_one_small_tagged ((((sizeof (Nack_Guard_Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  nw -> so . type = scheme_poll_evt_type ; 
  nw -> maker = argv [0 ] ; 

  RET_VALUE_START ((Scheme_Object * ) nw ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4110 "bc/src/struct.c"
static int wrapped_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Wrapped_Evt * ww = (Wrapped_Evt * ) o ; 
  Scheme_Object * wrapper ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(wrapper, 0), PUSH(sinfo, 1), PUSH(ww, 2)));
# define XfOrM571_COUNT (3)
# define SETUP_XfOrM571(x) SETUP(XfOrM571_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  wrapper = NULLED_OUT ; 

# 4115 "bc/src/struct.c"
  if (ww -> so . type == scheme_wrap_evt_type ) {
    wrapper = ww -> wrapper ; 
  }

# 4117 "bc/src/struct.c"
  else {
#   define XfOrM572_COUNT (0+XfOrM571_COUNT)
#   define SETUP_XfOrM572(x) SETUP_XfOrM571(x)

# 4119 "bc/src/struct.c"
    wrapper = FUNCCALL(SETUP_XfOrM572(_), scheme_box (ww -> wrapper ) ); 
  }
  FUNCCALL_EMPTY(scheme_set_sync_target (sinfo , ww -> evt , wrapper , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
  ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4126 "bc/src/struct.c"
static int nack_guard_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Nack_Guard_Evt * nw = (Nack_Guard_Evt * ) o ; 
  Scheme_Object * sema , * a [1 ] , * result ; 
  Scheme_Object * nack ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0), PUSH(o, 3), PUSH(nack, 4), PUSH(sinfo, 5), PUSH(nw, 6), PUSH(result, 7), PUSH(sema, 8)));
# define XfOrM574_COUNT (9)
# define SETUP_XfOrM574(x) SETUP(XfOrM574_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  result = NULLED_OUT ; 
  nack = NULLED_OUT ; 

# 4132 "bc/src/struct.c"
  if (sinfo -> false_positive_ok ) {
    sinfo -> potentially_false_positive = 1 ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  sema = FUNCCALL(SETUP_XfOrM574(_), scheme_make_sema (0 ) ); 
  FUNCCALL(SETUP_XfOrM574(_), scheme_set_sync_target (sinfo , o , ((void * ) 0 ) , sema , 0 , 0 , ((void * ) 0 ) ) )



  ; 


  nack = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM574(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  nack -> type = scheme_nack_evt_type ; 
  (((Scheme_Simple_Object * ) (nack ) ) -> u . two_ptr_val . ptr1 ) = sema ; 
  result = FUNCCALL(SETUP_XfOrM574(_), scheme_get_thread_sync (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ); 
  (((Scheme_Simple_Object * ) (nack ) ) -> u . two_ptr_val . ptr2 ) = result ; 

  a [0 ] = nack ; 
  result = FUNCCALL(SETUP_XfOrM574(_), scheme_apply (nw -> maker , 1 , a ) ); 

  if (FUNCCALL(SETUP_XfOrM574(_), scheme_is_evt (result ) )) {
#   define XfOrM575_COUNT (0+XfOrM574_COUNT)
#   define SETUP_XfOrM575(x) SETUP_XfOrM574(x)
    FUNCCALL(SETUP_XfOrM575(_), scheme_set_sync_target (sinfo , result , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 4155 "bc/src/struct.c"
    ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 4157 "bc/src/struct.c"
  else 
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4161 "bc/src/struct.c"
static int nack_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Object * a [2 ] , * wset ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(o, 3), PUSH(sinfo, 4), PUSH(wset, 5)));
# define XfOrM577_COUNT (6)
# define SETUP_XfOrM577(x) SETUP(XfOrM577_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  wset = NULLED_OUT ; 

# 4165 "bc/src/struct.c"
  wset = (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr1 ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (wset ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (wset ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) )  {
#   define XfOrM578_COUNT (0+XfOrM577_COUNT)
#   define SETUP_XfOrM578(x) SETUP_XfOrM577(x)

# 4168 "bc/src/struct.c"
    a [0 ] = wset ; 
    a [1 ] = (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr2 ) ; 
    wset = FUNCCALL(SETUP_XfOrM578(_), scheme_make_evt_set (2 , a ) ); 
    (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr1 ) = wset ; 
  }
  FUNCCALL(SETUP_XfOrM577(_), scheme_set_sync_target (sinfo , wset , scheme_void , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )

  ; 

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4180 "bc/src/struct.c"
static int poll_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Nack_Guard_Evt * nw = (Nack_Guard_Evt * ) o ; 
  Scheme_Object * a [1 ] , * result ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0), PUSH(sinfo, 3), PUSH(result, 4)));
# define XfOrM579_COUNT (5)
# define SETUP_XfOrM579(x) SETUP(XfOrM579_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 4185 "bc/src/struct.c"
  if (sinfo -> false_positive_ok ) {
    sinfo -> potentially_false_positive = 1 ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  a [0 ] = (sinfo -> is_poll ? scheme_true : scheme_false ) ; 
  result = FUNCCALL(SETUP_XfOrM579(_), scheme_apply (nw -> maker , 1 , a ) ); 

  if (FUNCCALL(SETUP_XfOrM579(_), scheme_is_evt (result ) )) {
#   define XfOrM580_COUNT (0+XfOrM579_COUNT)
#   define SETUP_XfOrM580(x) SETUP_XfOrM579(x)
    FUNCCALL(SETUP_XfOrM580(_), scheme_set_sync_target (sinfo , result , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 4194 "bc/src/struct.c"
    ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 4196 "bc/src/struct.c"
  else 
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4200 "bc/src/struct.c"
static int replace_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Active_Replace_Evt * a ; 
  Syncing * s ; 
  Scheme_Object * argv [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(o, 1), PUSHARRAY(argv, 1, 2), PUSH(s, 5), PUSH(sinfo, 6)));
# define XfOrM582_COUNT (7)
# define SETUP_XfOrM582(x) SETUP(XfOrM582_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 
  s = NULLED_OUT ; 
  argv[0] = NULLED_OUT ; 

# 4206 "bc/src/struct.c"
  argv [0 ] = ((Wrapped_Evt * ) o ) -> evt ; 
  s = FUNCCALL(SETUP_XfOrM582(_), scheme_make_syncing (1 , argv ) ); 

  a = ((Active_Replace_Evt * ) FUNCCALL(SETUP_XfOrM582(_), GC_malloc_one_small_tagged ((((sizeof (Active_Replace_Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  a -> so . type = scheme_active_replace_evt_type ; 
  a -> done = 0 ; 
  a -> wrapper = ((Wrapped_Evt * ) o ) -> wrapper ; 
  a -> syncing = s ; 
  a -> orig = o ; 
  FUNCCALL(SETUP_XfOrM582(_), scheme_set_sync_target (sinfo , (Scheme_Object * ) a , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
  ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4220 "bc/src/struct.c"
static int active_replace_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 
  int nested = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(sinfo, 1)));
# define XfOrM583_COUNT (2)
# define SETUP_XfOrM583(x) SETUP(XfOrM583_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4225 "bc/src/struct.c"
  if (! a -> syncing )
    RET_VALUE_START (0 ) RET_VALUE_END ; 

  do {
#   define XfOrM598_COUNT (0+XfOrM583_COUNT)
#   define SETUP_XfOrM598(x) SETUP_XfOrM583(x)

# 4229 "bc/src/struct.c"
    if (a -> syncing ) {
#     define XfOrM600_COUNT (0+XfOrM598_COUNT)
#     define SETUP_XfOrM600(x) SETUP_XfOrM598(x)

# 4231 "bc/src/struct.c"
      if (a -> done && sinfo -> false_positive_ok ) {
        sinfo -> potentially_false_positive = 1 ; 
        if (nested )
          sinfo -> replace_chain = ((void * ) 0 ) ; 
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }

      if (! a -> done && sinfo -> replace_chain && ! nested ) {




        Scheme_Object * l ; 
        BLOCK_SETUP((PUSH(l, 0+XfOrM600_COUNT)));
#       define XfOrM610_COUNT (1+XfOrM600_COUNT)
#       define SETUP_XfOrM610(x) SETUP(XfOrM610_COUNT)
        l = NULLED_OUT ; 

# 4244 "bc/src/struct.c"
        l = FUNCCALL(SETUP_XfOrM610(_), scheme_make_pair ((Scheme_Object * ) a , sinfo -> replace_chain ) ); 
        sinfo -> replace_chain = l ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

      if (! a -> done && ! sinfo -> replace_chain ) {

        sinfo -> replace_chain = scheme_null ; 
      }

      if (a -> done || FUNCCALL(SETUP_XfOrM600(_), scheme_syncing_ready (a -> syncing , sinfo , 0 ) )) {
#       define XfOrM601_COUNT (0+XfOrM600_COUNT)
#       define SETUP_XfOrM601(x) SETUP_XfOrM600(x)

# 4255 "bc/src/struct.c"
        sinfo -> replace_chain = ((void * ) 0 ) ; 

        if (sinfo -> potentially_false_positive )
          RET_VALUE_START (1 ) RET_VALUE_END ; 

        a -> done = 1 ; 
        if (sinfo -> false_positive_ok ) {
          sinfo -> potentially_false_positive = 1 ; 
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        }

# 4264 "bc/src/struct.c"
        else if (nested ) {




          sinfo -> spin = 1 ; 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 4271 "bc/src/struct.c"
        else {

          Scheme_Object * v , * argv [1 ] , * * args ; 
          Syncing * s = a -> syncing ; 
          int argc ; 
          BLOCK_SETUP((PUSHARRAY(argv, 1, 0+XfOrM601_COUNT), PUSH(v, 3+XfOrM601_COUNT), PUSH(args, 4+XfOrM601_COUNT)));
#         define XfOrM602_COUNT (5+XfOrM601_COUNT)
#         define SETUP_XfOrM602(x) SETUP(XfOrM602_COUNT)
          v = NULLED_OUT ; 
          argv[0] = NULLED_OUT ; 
          args = NULLED_OUT ; 

# 4277 "bc/src/struct.c"
          a -> syncing = ((void * ) 0 ) ; 

          v = FUNCCALL(SETUP_XfOrM602(_), scheme_syncing_result (s , 0 ) ); 

          if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
#           define XfOrM606_COUNT (0+XfOrM602_COUNT)
#           define SETUP_XfOrM606(x) SETUP_XfOrM602(x)

# 4282 "bc/src/struct.c"
            argc = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ) ; 
            args = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) ; 
            FUNCCALL(SETUP_XfOrM606(_), scheme_detach_multple_array (args ) ); 
          }

# 4285 "bc/src/struct.c"
          else {
            argv [0 ] = v ; 
            args = argv ; 
            argc = 1 ; 
          }

          v = FUNCCALL(SETUP_XfOrM602(_), scheme_apply (a -> wrapper , argc , args ) ); 

          if (FUNCCALL(SETUP_XfOrM602(_), scheme_is_evt (v ) )) {
#           define XfOrM604_COUNT (0+XfOrM602_COUNT)
#           define SETUP_XfOrM604(x) SETUP_XfOrM602(x)
            FUNCCALL(SETUP_XfOrM604(_), scheme_set_sync_target (sinfo , v , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 4294 "bc/src/struct.c"
            ; 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 4296 "bc/src/struct.c"
          else {
#           define XfOrM603_COUNT (0+XfOrM602_COUNT)
#           define SETUP_XfOrM603(x) SETUP_XfOrM602(x)
            FUNCCALL(SETUP_XfOrM603(_), scheme_set_sync_target (sinfo , a -> orig , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 4298 "bc/src/struct.c"
            ; 
            RET_VALUE_START (1 ) RET_VALUE_END ; 
          }
        }
      }
    }

    if (sinfo -> replace_chain && ! ((sinfo -> replace_chain ) == (scheme_null ) ) ) {

      a = (Active_Replace_Evt * ) (((Scheme_Simple_Object * ) (sinfo -> replace_chain ) ) -> u . pair_val . car ) ; 
      sinfo -> replace_chain = (((Scheme_Simple_Object * ) (sinfo -> replace_chain ) ) -> u . pair_val . cdr ) ; 
      nested = 1 ; 
    }

# 4310 "bc/src/struct.c"
    else 
    a = ((void * ) 0 ) ; 
  }

# 4312 "bc/src/struct.c"
  while (a ) ; 

  sinfo -> replace_chain = ((void * ) 0 ) ; 

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4319 "bc/src/struct.c"
static void active_replace_evt_needs_wakeup (Scheme_Object * o , void * fds ) 
{
  /* No conversion */

# 4321 "bc/src/struct.c"
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 

  if (a -> syncing && ! a -> done )
    scheme_syncing_needs_wakeup (a -> syncing , fds ) ; 
}

Syncing * scheme_replace_evt_needs_wakeup (Scheme_Object * o ) 
{
  /* No conversion */

# 4329 "bc/src/struct.c"
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 

  if (a -> syncing && ! a -> done )
    return a -> syncing ; 

  return ((void * ) 0 ) ; 
}

Syncing * scheme_replace_evt_nack (Scheme_Object * o ) 
{
  /* No conversion */

# 4339 "bc/src/struct.c"
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 
  Syncing * s = ((void * ) 0 ) ; 

  if (a -> syncing ) {
    s = a -> syncing ; 
    a -> syncing = ((void * ) 0 ) ; 
  }

  return s ; 
}

Syncing * scheme_replace_evt_get (Scheme_Object * o ) 
{
  /* No conversion */

# 4352 "bc/src/struct.c"
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 

  return a -> syncing ; 
}








Scheme_Object * * scheme_make_struct_values (Scheme_Object * type , 
Scheme_Object * * names , 
int count , 
int flags ) 
{
  Scheme_Struct_Type * struct_type ; 
  Scheme_Object * * values ; 
  Scheme_Object * vi ; 
  char * nm ; 
  int slot_num , pos ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(names, 0), PUSH(values, 1), PUSH(vi, 2), PUSH(nm, 3), PUSH(struct_type, 4)));
# define XfOrM617_COUNT (5)
# define SETUP_XfOrM617(x) SETUP(XfOrM617_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  struct_type = NULLED_OUT ; 
  values = NULLED_OUT ; 
  vi = NULLED_OUT ; 
  nm = NULLED_OUT ; 

# 4375 "bc/src/struct.c"
  struct_type = (Scheme_Struct_Type * ) type ; 

  if (flags & 0x80 )
    -- count ; 

  values = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM617(_), GC_malloc (sizeof (Scheme_Object * ) * (count ) ) )) ; 








  pos = 0 ; 
  if (! (flags & 0x01 ) )
    values [pos ++ ] = (Scheme_Object * ) struct_type ; 
  if (! (flags & 0x02 ) ) {
#   define XfOrM627_COUNT (0+XfOrM617_COUNT)
#   define SETUP_XfOrM627(x) SETUP_XfOrM617(x)

# 4393 "bc/src/struct.c"
    nm = ((flags & 0x200 ) 
    ? (char * ) names [pos ] 
    : FUNCCALL(SETUP_XfOrM627(_), scheme_symbol_val (names [pos ] ) )) ; 
    vi = FUNCCALL(SETUP_XfOrM627(_), make_struct_proc (struct_type , nm , SCHEME_CONSTR , struct_type -> num_slots ) )


    ; 
    (adjust_primitive (vi , struct_type , flags ) ) ; 
    values [pos ] = vi ; 
    pos ++ ; 
  }
  if (! (flags & 0x04 ) ) {
#   define XfOrM626_COUNT (0+XfOrM617_COUNT)
#   define SETUP_XfOrM626(x) SETUP_XfOrM617(x)

# 4405 "bc/src/struct.c"
    nm = ((flags & 0x200 ) 
    ? (char * ) names [pos ] 
    : FUNCCALL(SETUP_XfOrM626(_), scheme_symbol_val (names [pos ] ) )) ; 
    vi = FUNCCALL(SETUP_XfOrM626(_), make_struct_proc (struct_type , nm , SCHEME_PRED , 0 ) )


    ; 
    (adjust_primitive (vi , struct_type , flags ) ) ; 
    values [pos ] = vi ; 
    pos ++ ; 
  }

  if (flags & 0x20 )
    -- count ; 
  if (flags & 0x40 )
    -- count ; 

  slot_num = (struct_type -> name_pos 
  ? struct_type -> parent_types [struct_type -> name_pos - 1 ] -> num_slots 
  : 0 ) ; 
  while (pos < count ) {
#   define XfOrM623_COUNT (0+XfOrM617_COUNT)
#   define SETUP_XfOrM623(x) SETUP_XfOrM617(x)

# 4426 "bc/src/struct.c"
    if (! (flags & 0x08 ) ) {
#     define XfOrM625_COUNT (0+XfOrM623_COUNT)
#     define SETUP_XfOrM625(x) SETUP_XfOrM623(x)

# 4427 "bc/src/struct.c"
      nm = ((flags & 0x200 ) 
      ? (char * ) names [pos ] 
      : FUNCCALL(SETUP_XfOrM625(_), scheme_symbol_val (names [pos ] ) )) ; 
      vi = FUNCCALL(SETUP_XfOrM625(_), make_struct_proc (struct_type , nm , SCHEME_GETTER , slot_num ) )


      ; 
      (adjust_primitive (vi , struct_type , flags ) ) ; 
      values [pos ] = vi ; 
      pos ++ ; 
    }

    if (! (flags & 0x10 ) ) {
#     define XfOrM624_COUNT (0+XfOrM623_COUNT)
#     define SETUP_XfOrM624(x) SETUP_XfOrM623(x)

# 4440 "bc/src/struct.c"
      nm = ((flags & 0x200 ) 
      ? (char * ) names [pos ] 
      : FUNCCALL(SETUP_XfOrM624(_), scheme_symbol_val (names [pos ] ) )) ; 
      vi = FUNCCALL(SETUP_XfOrM624(_), make_struct_proc (struct_type , nm , SCHEME_SETTER , slot_num ) )


      ; 
      (adjust_primitive (vi , struct_type , flags ) ) ; 
      values [pos ] = vi ; 
      pos ++ ; 
    }

    slot_num ++ ; 
  }

  if (flags & 0x20 ) {
#   define XfOrM619_COUNT (0+XfOrM617_COUNT)
#   define SETUP_XfOrM619(x) SETUP_XfOrM617(x)

# 4456 "bc/src/struct.c"
    nm = ((flags & 0x200 ) 
    ? (char * ) names [pos ] 
    : FUNCCALL(SETUP_XfOrM619(_), scheme_symbol_val (names [pos ] ) )) ; 
    vi = FUNCCALL(SETUP_XfOrM619(_), make_struct_proc (struct_type , nm , SCHEME_GEN_GETTER , slot_num ) )


    ; 
    values [pos ] = vi ; 
    pos ++ ; 
  }
  if (flags & 0x40 ) {
#   define XfOrM618_COUNT (0+XfOrM617_COUNT)
#   define SETUP_XfOrM618(x) SETUP_XfOrM617(x)

# 4467 "bc/src/struct.c"
    nm = ((flags & 0x200 ) 
    ? (char * ) names [pos ] 
    : FUNCCALL(SETUP_XfOrM618(_), scheme_symbol_val (names [pos ] ) )) ; 
    vi = FUNCCALL(SETUP_XfOrM618(_), make_struct_proc (struct_type , nm , SCHEME_GEN_SETTER , slot_num ) )


    ; 
    values [pos ] = vi ; 
    pos ++ ; 
  }

  RET_VALUE_START (values ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4481 "bc/src/struct.c"
static void adjust_primitive (Scheme_Object * vi , Scheme_Struct_Type * stype , int flags ) {
  /* No conversion */

# 4482 "bc/src/struct.c"
  if (flags & 0x400 ) {


    ((Scheme_Closed_Primitive_Proc * ) vi ) -> pp . flags &= ~ 4 ; 
  }

# 4486 "bc/src/struct.c"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) ) {



    if (! (((stype -> inspector ) ) == (scheme_false ) ) ) 
      ((Scheme_Closed_Primitive_Proc * ) vi ) -> pp . flags |= 4 ; 
  }
}

static Scheme_Object * * _make_struct_names (const char * base , int blen , 
int fcount , 
Scheme_Object * field_symbols , 
const char * * field_strings , 
int flags , int * count_out ) 
{
  Scheme_Object * * names ; 
  const char * field_name ; 
  int count , fnlen ; 
  int slot_num , pos , as_sym ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(base, 0), PUSH(names, 1), PUSH(field_symbols, 2), PUSH(field_strings, 3), PUSH(field_name, 4)));
# define XfOrM631_COUNT (5)
# define SETUP_XfOrM631(x) SETUP(XfOrM631_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  names = NULLED_OUT ; 
  field_name = NULLED_OUT ; 

# 4506 "bc/src/struct.c"
  count = 0 ; 

  if (! (flags & 0x01 ) )
    count ++ ; 
  if (! (flags & 0x02 ) )
    count ++ ; 
  if (! (flags & 0x04 ) )
    count ++ ; 
  if (! (flags & 0x08 ) )
    count += fcount ; 
  if (! (flags & 0x10 ) )
    count += fcount ; 
  if (flags & 0x20 )
    count ++ ; 
  if (flags & 0x40 )
    count ++ ; 
  if (flags & 0x80 )
    count ++ ; 

  if (count_out ) {
    * count_out = count ; 
    count_out = ((void * ) 0 ) ; 
  }

  names = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM631(_), GC_malloc (sizeof (Scheme_Object * ) * (count ) ) )) ; 








  pos = 0 ; 

  as_sym = ((flags & 0x200 ) ? 0 : 1 ) ; 

  if (! (flags & 0x01 ) ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM631_COUNT)));
#   define XfOrM648_COUNT (1+XfOrM631_COUNT)
#   define SETUP_XfOrM648(x) SETUP(XfOrM648_COUNT)
    nm = NULLED_OUT ; 

# 4545 "bc/src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM648(_), make_name ("struct:" , base , blen , "" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }
  if (! (flags & 0x02 ) ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM631_COUNT)));
#   define XfOrM647_COUNT (1+XfOrM631_COUNT)
#   define SETUP_XfOrM647(x) SETUP(XfOrM647_COUNT)
    nm = NULLED_OUT ; 

# 4550 "bc/src/struct.c"
    if (flags & 0x100 )
      nm = FUNCCALL(SETUP_XfOrM647(_), make_name ("" , base , blen , "" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    else 
    nm = FUNCCALL(SETUP_XfOrM647(_), make_name ("make-" , base , blen , "" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }
  if (! (flags & 0x04 ) ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM631_COUNT)));
#   define XfOrM646_COUNT (1+XfOrM631_COUNT)
#   define SETUP_XfOrM646(x) SETUP(XfOrM646_COUNT)
    nm = NULLED_OUT ; 

# 4558 "bc/src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM646(_), make_name ("" , base , blen , "?" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }

  if (fcount ) {
#   define XfOrM635_COUNT (0+XfOrM631_COUNT)
#   define SETUP_XfOrM635(x) SETUP_XfOrM631(x)

# 4563 "bc/src/struct.c"
    for (slot_num = 0 ; slot_num < fcount ; slot_num ++ ) {
#     define XfOrM641_COUNT (0+XfOrM635_COUNT)
#     define SETUP_XfOrM641(x) SETUP_XfOrM635(x)

# 4564 "bc/src/struct.c"
      if (field_symbols ) {
        Scheme_Object * fn = (((Scheme_Simple_Object * ) (field_symbols ) ) -> u . pair_val . car ) ; 
        BLOCK_SETUP((PUSH(fn, 0+XfOrM641_COUNT)));
#       define XfOrM645_COUNT (1+XfOrM641_COUNT)
#       define SETUP_XfOrM645(x) SETUP(XfOrM645_COUNT)

# 4566 "bc/src/struct.c"
        field_symbols = (((Scheme_Simple_Object * ) (field_symbols ) ) -> u . pair_val . cdr ) ; 

        field_name = FUNCCALL(SETUP_XfOrM645(_), scheme_symbol_val (fn ) ); 
        fnlen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (fn ) ) ) -> len ) ; 
      }

# 4570 "bc/src/struct.c"
      else {
        field_name = field_strings [slot_num ] ; 
        fnlen = strlen (field_name ) ; 
      }

      if (! (flags & 0x08 ) ) {
        Scheme_Object * nm ; 
        BLOCK_SETUP((PUSH(nm, 0+XfOrM641_COUNT)));
#       define XfOrM643_COUNT (1+XfOrM641_COUNT)
#       define SETUP_XfOrM643(x) SETUP(XfOrM643_COUNT)
        nm = NULLED_OUT ; 

# 4577 "bc/src/struct.c"
        nm = FUNCCALL(SETUP_XfOrM643(_), make_name ("" , base , blen , "-" , field_name , fnlen , "" , as_sym ) ); 
        names [pos ++ ] = nm ; 
      }
      if (! (flags & 0x10 ) ) {
        Scheme_Object * nm ; 
        BLOCK_SETUP((PUSH(nm, 0+XfOrM641_COUNT)));
#       define XfOrM642_COUNT (1+XfOrM641_COUNT)
#       define SETUP_XfOrM642(x) SETUP(XfOrM642_COUNT)
        nm = NULLED_OUT ; 

# 4582 "bc/src/struct.c"
        nm = FUNCCALL(SETUP_XfOrM642(_), make_name ("set-" , base , blen , "-" , field_name , fnlen , "!" , as_sym ) ); 
        names [pos ++ ] = nm ; 
      }
    }
  }

  if (flags & 0x20 ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM631_COUNT)));
#   define XfOrM634_COUNT (1+XfOrM631_COUNT)
#   define SETUP_XfOrM634(x) SETUP(XfOrM634_COUNT)
    nm = NULLED_OUT ; 

# 4590 "bc/src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM634(_), make_name ("" , base , blen , "-ref" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }
  if (flags & 0x40 ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM631_COUNT)));
#   define XfOrM633_COUNT (1+XfOrM631_COUNT)
#   define SETUP_XfOrM633(x) SETUP(XfOrM633_COUNT)
    nm = NULLED_OUT ; 

# 4595 "bc/src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM633(_), make_name ("" , base , blen , "-set!" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }

  if (flags & 0x80 ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM631_COUNT)));
#   define XfOrM632_COUNT (1+XfOrM631_COUNT)
#   define SETUP_XfOrM632(x) SETUP(XfOrM632_COUNT)
    nm = NULLED_OUT ; 

# 4601 "bc/src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM632(_), make_name ("" , base , blen , "" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }

  RET_VALUE_START (names ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4608 "bc/src/struct.c"
Scheme_Object * * scheme_make_struct_names (Scheme_Object * base , 
Scheme_Object * field_symbols , 
int flags , int * count_out ) 
{
  int len ; 
  char * __funcarg140 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(base, 0), PUSH(field_symbols, 1), PUSH(count_out, 2)));
# define XfOrM650_COUNT (3)
# define SETUP_XfOrM650(x) SETUP(XfOrM650_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4613 "bc/src/struct.c"
  len = field_symbols ? (scheme_list_length (field_symbols ) ) : 0 ; 

  RET_VALUE_START ((__funcarg140 = FUNCCALL(SETUP_XfOrM650(_), scheme_symbol_val (base ) ), FUNCCALL_EMPTY(_make_struct_names (__funcarg140 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (base ) ) ) -> len ) , len , field_symbols , ((void * ) 0 ) , flags , count_out ) )) ) RET_VALUE_END 



  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4622 "bc/src/struct.c"
Scheme_Object * * scheme_make_struct_names_from_array (const char * base , 
int fcount , 
const char * * fields , 
int flags , int * count_out ) 
{
  /* No conversion */

# 4627 "bc/src/struct.c"
  return _make_struct_names (base , 
  strlen (base ) , 
  fcount , 
  ((void * ) 0 ) , fields , 
  flags , count_out ) ; 
}

static Scheme_Object * 
make_struct_proc_for_realm (Scheme_Struct_Type * struct_type , 
char * func_name , Scheme_Object * realm , Scheme_Object * contract , 
Scheme_ProcT proc_type , int field_num ) 
{
  Scheme_Object * p , * a [3 ] ; 
  short flags = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0), PUSH(realm, 3), PUSH(struct_type, 4), PUSH(contract, 5), PUSH(p, 6), PUSH(func_name, 7)));
# define XfOrM652_COUNT (8)
# define SETUP_XfOrM652(x) SETUP(XfOrM652_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 4642 "bc/src/struct.c"
  if (proc_type == SCHEME_CONSTR ) {
    int simple ; 
#   define XfOrM660_COUNT (0+XfOrM652_COUNT)
#   define SETUP_XfOrM660(x) SETUP_XfOrM652(x)

# 4644 "bc/src/struct.c"
    simple = FUNCCALL(SETUP_XfOrM660(_), scheme_is_simple_struct_type (struct_type ) ); 
    a [0 ] = (Scheme_Object * ) struct_type ; 
    p = FUNCCALL(SETUP_XfOrM660(_), scheme_make_folding_prim_closure ((simple ? make_simple_struct_instance : make_struct_instance ) , 1 , a , func_name , struct_type -> num_islots , struct_type -> num_islots , 0 ) )






    ; 
    flags |= (simple 
    ? (32 | 64 | 128 ) 
    : 128 ) ; 
  }

# 4657 "bc/src/struct.c"
  else if (proc_type == SCHEME_PRED ) {
#   define XfOrM659_COUNT (0+XfOrM652_COUNT)
#   define SETUP_XfOrM659(x) SETUP_XfOrM652(x)

# 4658 "bc/src/struct.c"
    a [0 ] = (Scheme_Object * ) struct_type ; 
    p = FUNCCALL(SETUP_XfOrM659(_), scheme_make_folding_prim_closure (struct_pred , 1 , a , func_name , 1 , 1 , 1 ) )


    ; 
    flags |= (32 | 64 ) ; 
  }

# 4664 "bc/src/struct.c"
  else {
    int need_pos ; 
#   define XfOrM653_COUNT (0+XfOrM652_COUNT)
#   define SETUP_XfOrM653(x) SETUP_XfOrM652(x)

# 4667 "bc/src/struct.c"
    if ((proc_type == SCHEME_GEN_GETTER ) 
    || (proc_type == SCHEME_GEN_SETTER ) )
      need_pos = 1 ; 
    else 
    need_pos = 0 ; 

    a [0 ] = (Scheme_Object * ) struct_type ; 
    a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (field_num ) ) ) << 1 ) | 0x1 ) ) ; 
    if (contract )
      realm = FUNCCALL(SETUP_XfOrM653(_), scheme_make_pair (realm , contract ) ); 
    a [2 ] = realm ; 

    if ((proc_type == SCHEME_GETTER ) || (proc_type == SCHEME_GEN_GETTER ) ) {
#     define XfOrM658_COUNT (0+XfOrM653_COUNT)
#     define SETUP_XfOrM658(x) SETUP_XfOrM653(x)

# 4680 "bc/src/struct.c"
      p = FUNCCALL(SETUP_XfOrM658(_), scheme_make_folding_prim_closure (scheme_struct_getter , 3 , a , func_name , 1 + need_pos , 1 + need_pos , 0 ) )


      ; 
      if (need_pos )
        flags |= (32 | 256 ) ; 
      else 
      flags |= 32 ; 
    }


    else {
#     define XfOrM654_COUNT (0+XfOrM653_COUNT)
#     define SETUP_XfOrM654(x) SETUP_XfOrM653(x)

# 4692 "bc/src/struct.c"
      p = FUNCCALL(SETUP_XfOrM654(_), scheme_make_folding_prim_closure (scheme_struct_setter , 3 , a , func_name , 2 + need_pos , 2 + need_pos , 0 ) )


      ; 
      if (need_pos )
        flags |= 256 ; 
      else {
        flags |= (128 | 256 ) ; 

        if (struct_type -> immutables ) {
          if (struct_type -> name_pos )
            field_num -= struct_type -> parent_types [struct_type -> name_pos - 1 ] -> num_slots ; 
          if (struct_type -> immutables [field_num ] ) {
            flags -= (128 | 256 ) ; 
            flags |= (32 | 128 ) ; 
          }
        }
      }
    }
  }



  ((Scheme_Closed_Primitive_Proc * ) p ) -> pp . flags |= flags ; 

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4720 "bc/src/struct.c"
static Scheme_Object * 
make_struct_proc (Scheme_Struct_Type * struct_type , 
char * func_name , 
Scheme_ProcT proc_type , int field_num ) 
{
  /* No conversion */

# 4725 "bc/src/struct.c"
  return make_struct_proc_for_realm (struct_type , 
  func_name , scheme_default_realm , ((void * ) 0 ) , 
  proc_type , field_num ) ; 
}

Scheme_Object * scheme_rename_struct_proc (Scheme_Object * p , Scheme_Object * sym , Scheme_Object * realm ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(realm, 0), PUSH(p, 1)));
# define XfOrM662_COUNT (2)
# define SETUP_XfOrM662(x) SETUP(XfOrM662_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4732 "bc/src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) )  {
    unsigned short flags = ((Scheme_Primitive_Proc * ) p ) -> pp . flags ; 
    int is_getter = ((flags & (32 | 64 | 128 | 256 ) ) == 32 ) ; 
    int is_setter = (((flags & (32 | 64 | 128 | 256 ) ) == (128 | 256 ) ) 
    || ((flags & (32 | 64 | 128 | 256 ) ) == (32 | 128 ) ) ) ; 
#   define XfOrM663_COUNT (0+XfOrM662_COUNT)
#   define SETUP_XfOrM663(x) SETUP_XfOrM662(x)

# 4738 "bc/src/struct.c"
    if (is_getter || is_setter ) {
      const char * func_name ; 
      Scheme_Struct_Type * st ; 
      Scheme_Object * contract ; 
      int field_pos ; 
      BLOCK_SETUP((PUSH(st, 0+XfOrM663_COUNT), PUSH(func_name, 1+XfOrM663_COUNT), PUSH(contract, 2+XfOrM663_COUNT)));
#     define XfOrM664_COUNT (3+XfOrM663_COUNT)
#     define SETUP_XfOrM664(x) SETUP(XfOrM664_COUNT)
      func_name = NULLED_OUT ; 
      st = NULLED_OUT ; 
      contract = NULLED_OUT ; 

# 4744 "bc/src/struct.c"
      func_name = FUNCCALL(SETUP_XfOrM664(_), scheme_symbol_name (sym ) ); 

      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) p ) -> val [0 ] ; 
      field_pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) p ) -> val [1 ] ) ) >> 1 ) ; 

      contract = ((Scheme_Primitive_Closure * ) p ) -> val [2 ] ; 
      if ((Scheme_Type ) (((((intptr_t ) (contract ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (contract ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
        contract = (((Scheme_Simple_Object * ) (contract ) ) -> u . pair_val . cdr ) ; 
      else 
      contract = ((void * ) 0 ) ; 

      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_struct_proc_for_realm (st , (char * ) func_name , realm , contract , is_getter ? SCHEME_GETTER : SCHEME_SETTER , field_pos ) )) RET_VALUE_EMPTY_END 

      ; 
    }
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4764 "bc/src/struct.c"
static Scheme_Object * make_name (const char * pre , const char * tn , int ltn , 
const char * post1 , const char * fn , int lfn , 
const char * post2 , int sym ) 
{
  int total , lp , lp1 , lp2 , xltn , xlfn ; 
  char * name , buffer [256 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(pre, 1), PUSH(post2, 2), PUSH(post1, 3), PUSH(fn, 4), PUSH(tn, 5)));
# define XfOrM665_COUNT (6)
# define SETUP_XfOrM665(x) SETUP(XfOrM665_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 

# 4771 "bc/src/struct.c"
  if (ltn < 0 )
    xltn = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((Scheme_Object * ) tn ) ) ) -> len ) ; 
  else 
  xltn = ltn ; 

  if (lfn < 0 )
    xlfn = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((Scheme_Object * ) fn ) ) ) -> len ) ; 
  else 
  xlfn = lfn ; 

  total = lp = strlen (pre ) ; 
  total += xltn ; 
  total += (lp1 = strlen (post1 ) ) ; 
  total += xlfn ; 
  total += (lp2 = strlen (post2 ) ) ; 

  if (sym && (total < 256 ) )
    name = buffer ; 
  else 
  name = (char * ) FUNCCALL(SETUP_XfOrM665(_), GC_malloc_atomic (sizeof (char ) * (total + 1 ) ) ); 
  (
  memcpy (name , pre , lp ) ) ; 
  total = lp ; 
  if (xltn )
    (memcpy (name + total , (ltn < 0 ) ? (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((Scheme_Object * ) tn ) ) ) -> s ) : tn , xltn ) ) ; 
  total += xltn ; 
  (memcpy (name + total , post1 , lp1 ) ) ; 
  total += lp1 ; 
  if (xlfn )
    (memcpy (name + total , (lfn < 0 ) ? (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((Scheme_Object * ) fn ) ) ) -> s ) : fn , xlfn ) ) ; 
  total += xlfn ; 
  (memcpy (name + total , post2 , lp2 ) ) ; 
  total += lp2 ; 

  name [total ] = 0 ; 

  if (sym )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_intern_exact_symbol (name , total ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START ((Scheme_Object * ) name ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * count_k (void ) ; 

static int count_non_proc_props (Scheme_Object * props ) 
{
  Scheme_Struct_Property * p ; 
  Scheme_Object * v ; 
  int count = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(props, 1), PUSH(v, 2)));
# define XfOrM666_COUNT (3)
# define SETUP_XfOrM666(x) SETUP(XfOrM666_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 4825 "bc/src/struct.c"
  {

# 24 "bc/src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM673_COUNT (0+XfOrM666_COUNT)
#   define SETUP_XfOrM673(x) SETUP_XfOrM666(x)

# 26 "bc/src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 4827 "bc/src/struct.c"
    {
#     define XfOrM674_COUNT (0+XfOrM673_COUNT)
#     define SETUP_XfOrM674(x) SETUP_XfOrM673(x)

# 4828 "bc/src/struct.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 = (void * ) props ; 
      RET_VALUE_START ((((intptr_t ) (FUNCCALL(SETUP_XfOrM674(_), scheme_handle_stack_overflow (count_k ) )) ) >> 1 ) ) RET_VALUE_END ; 
    }
  }
  {
#   define XfOrM671_COUNT (0+XfOrM666_COUNT)
#   define SETUP_XfOrM671(x) SETUP_XfOrM666(x)

# 4832 "bc/src/struct.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM672_COUNT (0+XfOrM671_COUNT)
#     define SETUP_XfOrM672(x) SETUP_XfOrM671(x)
      FUNCCALL(SETUP_XfOrM672(_), scheme_out_of_fuel () )
# 4832 "bc/src/struct.c"
      ; 
    }
  }

# 4832 "bc/src/struct.c"
  ; 

  for (; ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; props = (((Scheme_Simple_Object * ) (props ) ) -> u . pair_val . cdr ) ) {
#   define XfOrM669_COUNT (0+XfOrM666_COUNT)
#   define SETUP_XfOrM669(x) SETUP_XfOrM666(x)

# 4835 "bc/src/struct.c"
    v = (((Scheme_Simple_Object * ) (props ) ) -> u . pair_val . car ) ; 
    p = (Scheme_Struct_Property * ) (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
    if (! (((Scheme_Object * ) p ) == (proc_property ) ) )
      count ++ ; 
    if (p -> supers ) {
#     define XfOrM670_COUNT (0+XfOrM669_COUNT)
#     define SETUP_XfOrM670(x) SETUP_XfOrM669(x)

# 4840 "bc/src/struct.c"
      count += FUNCCALL(SETUP_XfOrM670(_), count_non_proc_props (p -> supers ) ); 
    }
  }

  RET_VALUE_START (count ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4847 "bc/src/struct.c"
static Scheme_Object * count_k (void ) 
{
  /* No conversion */

# 4849 "bc/src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * props = (Scheme_Object * ) p -> ku . k . p1 ; 
  int c ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  c = count_non_proc_props (props ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (c ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * append_super_props (Scheme_Struct_Property * p , Scheme_Object * arg , Scheme_Object * orig ) 
{
  Scheme_Object * first = ((void * ) 0 ) , * last = ((void * ) 0 ) , * props , * pr , * v , * a [1 ] ; 
  Scheme_Object * __funcarg142 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0), PUSH(first, 3), PUSH(arg, 4), PUSH(orig, 5), PUSH(last, 6), PUSH(v, 7), PUSH(pr, 8), PUSH(props, 9)));
# define XfOrM676_COUNT (10)
# define SETUP_XfOrM676(x) SETUP(XfOrM676_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  props = NULLED_OUT ; 
  pr = NULLED_OUT ; 
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 4864 "bc/src/struct.c"
  if (p -> supers ) {
#   define XfOrM678_COUNT (0+XfOrM676_COUNT)
#   define SETUP_XfOrM678(x) SETUP_XfOrM676(x)

# 4865 "bc/src/struct.c"
    props = p -> supers ; 
    for (; ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; props = (((Scheme_Simple_Object * ) (props ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM680_COUNT (0+XfOrM678_COUNT)
#     define SETUP_XfOrM680(x) SETUP_XfOrM678(x)

# 4867 "bc/src/struct.c"
      v = (((Scheme_Simple_Object * ) (props ) ) -> u . pair_val . car ) ; 

      a [0 ] = arg ; 
      v = (__funcarg142 = FUNCCALL(SETUP_XfOrM680(_), scheme_do_eval ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) , 1 , a , 1 ) ), FUNCCALL_AGAIN(scheme_make_pair ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) , __funcarg142 ) )) ; 

      pr = FUNCCALL_AGAIN(scheme_make_pair (v , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pr ; 
      else 
      first = pr ; 
      last = pr ; 
    }
  }

  if (last ) {
    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = orig ; 
    RET_VALUE_START (first ) RET_VALUE_END ; 
  }

# 4884 "bc/src/struct.c"
  else 
  RET_VALUE_START (orig ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4888 "bc/src/struct.c"
static Scheme_Object * add_struct_type_chaperone_guards (Scheme_Object * o , Scheme_Object * orig_guard ) 
{
  Scheme_Object * first = ((void * ) 0 ) , * last = ((void * ) 0 ) , * p ; 
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(first, 0), PUSH(o, 1), PUSH(px, 2), PUSH(orig_guard, 3), PUSH(p, 4), PUSH(last, 5)));
# define XfOrM681_COUNT (6)
# define SETUP_XfOrM681(x) SETUP(XfOrM681_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 4896 "bc/src/struct.c"
  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#   define XfOrM684_COUNT (0+XfOrM681_COUNT)
#   define SETUP_XfOrM684(x) SETUP_XfOrM681(x)

# 4897 "bc/src/struct.c"
    px = (Scheme_Chaperone * ) o ; 
    if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM685_COUNT (0+XfOrM684_COUNT)
#     define SETUP_XfOrM685(x) SETUP_XfOrM684(x)

# 4899 "bc/src/struct.c"
      p = FUNCCALL(SETUP_XfOrM685(_), scheme_make_pair ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = p ; 
      else 
      first = p ; 
      last = p ; 
    }
    o = px -> prev ; 
  }

  if (! last )
    RET_VALUE_START (orig_guard ) RET_VALUE_END ; 

  if (! orig_guard )
    orig_guard = scheme_false ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (orig_guard , first ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4918 "bc/src/struct.c"
static void struct_type_set_if_immutable (Scheme_Struct_Type * struct_type ) {
  /* No conversion */

# 4919 "bc/src/struct.c"
  if (! struct_type -> name_pos 
  || (& struct_type -> parent_types [struct_type -> name_pos - 1 ] -> iso ) -> so . keyex & 0x1 ) {
    int i , size ; 
    size = struct_type -> num_islots ; 
    if (struct_type -> name_pos )
      size -= struct_type -> parent_types [struct_type -> name_pos - 1 ] -> num_islots ; 
    if (! size || struct_type -> immutables ) {
      for (i = 0 ; i < size ; i ++ ) {
        if (! struct_type -> immutables [i ] )
          return ; 
      }
      (& struct_type -> iso ) -> so . keyex |= 0x1 ; 
    }
  }
}

Scheme_Struct_Type * scheme_make_prefab_struct_type_raw (Scheme_Object * base , 
Scheme_Object * parent , 
int num_fields , 
int num_uninit_fields , 
Scheme_Object * uninit_val , 
char * immutable_array ) 
{
  Scheme_Struct_Type * struct_type , * parent_type ; 
  int j , depth ; 
  DECL_RET_SAVE (Scheme_Struct_Type * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(base, 0), PUSH(immutable_array, 1), PUSH(struct_type, 2), PUSH(parent_type, 3), PUSH(uninit_val, 4)));
# define XfOrM691_COUNT (5)
# define SETUP_XfOrM691(x) SETUP(XfOrM691_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  struct_type = NULLED_OUT ; 
  parent_type = NULLED_OUT ; 

# 4945 "bc/src/struct.c"
  parent_type = (Scheme_Struct_Type * ) parent ; 
  depth = parent_type ? (1 + parent_type -> name_pos ) : 0 ; 
  struct_type = (Scheme_Struct_Type * ) FUNCCALL(SETUP_XfOrM691(_), GC_malloc_one_tagged (sizeof (Scheme_Struct_Type ) + ((depth + 1 - 0 ) * sizeof (Scheme_Struct_Type * ) ) ) )

  ; 
  struct_type -> iso . so . type = scheme_struct_type_type ; 

  struct_type -> parent_types [depth ] = struct_type ; 
  for (j = depth ; j -- ; ) {
    struct_type -> parent_types [j ] = parent_type -> parent_types [j ] ; 
  }

  struct_type -> name = base ; 
  struct_type -> num_slots = num_fields + num_uninit_fields + (parent_type ? parent_type -> num_slots : 0 ) ; 
  struct_type -> num_islots = num_fields + (parent_type ? parent_type -> num_islots : 0 ) ; 
  struct_type -> name_pos = depth ; 
  struct_type -> more_flags = 0x1 ; 
  struct_type -> inspector = scheme_false ; 
  struct_type -> uninit_val = uninit_val ; 
  struct_type -> props = ((void * ) 0 ) ; 
  struct_type -> num_props = 0 ; 
  struct_type -> proc_attr = ((void * ) 0 ) ; 
  struct_type -> immutables = immutable_array ; 
  struct_type -> guard = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM691(_), struct_type_set_if_immutable (struct_type ) )
  ; 
  struct_type = FUNCCALL_AGAIN(hash_prefab (struct_type ) ); 

  RET_VALUE_START (struct_type ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4976 "bc/src/struct.c"
static Scheme_Struct_Type * scheme_make_prefab_struct_type (Scheme_Object * name , 
Scheme_Object * parent , 
int num_fields , 
int num_uninit_fields , 
Scheme_Object * uninit_val , 
char * immutable_array ) 
{
  /* No conversion */

# 4983 "bc/src/struct.c"
  return scheme_make_prefab_struct_type_raw (name , 
  parent , 
  num_fields , 
  num_uninit_fields , 
  uninit_val , 
  immutable_array ) ; 
}

static Scheme_Object * _make_struct_type (Scheme_Object * name , 
Scheme_Object * parent , 
Scheme_Object * inspector , 
int num_fields , 
int num_uninit_fields , 
Scheme_Object * uninit_val , 
Scheme_Object * props , 
Scheme_Object * proc_attr , 
char * immutable_array , 
Scheme_Object * guard ) 
{
  Scheme_Struct_Type * struct_type , * parent_type ; 
  int j , depth , checked_proc = 0 , chaperone_undefined = 0 ; 
  Scheme_Config * __funcarg145 = NULLED_OUT ; 
  Scheme_Object * __funcarg144 = NULLED_OUT ; 
  Scheme_Object * __funcarg143 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(19);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(immutable_array, 1), PUSH(struct_type, 2), PUSH(props, 3), PUSH(proc_attr, 4), PUSH(uninit_val, 5), PUSH(inspector, 6), PUSH(parent_type, 7), PUSH(parent, 8), PUSH(guard, 9)));
# define XfOrM695_COUNT (10)
# define SETUP_XfOrM695(x) SETUP(XfOrM695_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  struct_type = NULLED_OUT ; 
  parent_type = NULLED_OUT ; 

# 5005 "bc/src/struct.c"
  if (parent && (((Scheme_Type ) (((((intptr_t ) (parent ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (parent ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) )
    parent_type = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) parent ) -> val ) ; 
  else 
  parent_type = (Scheme_Struct_Type * ) parent ; 

  depth = parent_type ? (1 + parent_type -> name_pos ) : 0 ; 

  struct_type = (Scheme_Struct_Type * ) FUNCCALL(SETUP_XfOrM695(_), GC_malloc_one_tagged (sizeof (Scheme_Struct_Type ) + ((depth + 1 - 0 ) * sizeof (Scheme_Struct_Type * ) ) ) )

  ; 


  depth = parent_type ? (1 + parent_type -> name_pos ) : 0 ; 

  struct_type -> iso . so . type = scheme_struct_type_type ; 

  struct_type -> name_pos = depth ; 
  struct_type -> parent_types [depth ] = struct_type ; 
  for (j = depth ; j -- ; ) {
    struct_type -> parent_types [j ] = parent_type -> parent_types [j ] ; 
  }

  struct_type -> name = name ; 
  struct_type -> more_flags = ((parent_type 
  ? (parent_type -> more_flags & 0x1 ) 
  : 0x1 ) 
  | ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) && inspector ) 
  ? 0x2 
  : 0 ) ) ; 

  struct_type -> num_slots = num_fields + num_uninit_fields + (parent_type ? parent_type -> num_slots : 0 ) ; 
  struct_type -> num_islots = num_fields + (parent_type ? parent_type -> num_islots : 0 ) ; 
  if (parent_type )
    struct_type -> proc_attr = parent_type -> proc_attr ; 


  if ((num_fields < 0 ) || (num_uninit_fields < 0 ) 
  || (num_fields > 32768 ) 
  || (num_uninit_fields > 32768 ) 
  || (num_uninit_fields + num_fields > 32768 ) 
  || (parent_type 
  && ((struct_type -> num_slots < parent_type -> num_slots ) 
  || (struct_type -> num_islots < parent_type -> num_islots ) ) ) ) {
#   define XfOrM751_COUNT (0+XfOrM695_COUNT)
#   define SETUP_XfOrM751(x) SETUP_XfOrM695(x)
    FUNCCALL(SETUP_XfOrM751(_), scheme_raise_exn (MZEXN_FAIL , "too many fields for struct-type\n" "  maximum total field count: " "32768" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (! inspector ) {
#   define XfOrM748_COUNT (0+XfOrM695_COUNT)
#   define SETUP_XfOrM748(x) SETUP_XfOrM695(x)

# 5055 "bc/src/struct.c"
    if (parent_type ) {
      inspector = parent_type -> inspector ; 
      if ((Scheme_Type ) (((((intptr_t ) (inspector ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inspector ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
        inspector = scheme_false ; 
    }

# 5059 "bc/src/struct.c"
    else {
#     define XfOrM749_COUNT (0+XfOrM748_COUNT)
#     define SETUP_XfOrM749(x) SETUP_XfOrM748(x)

# 5060 "bc/src/struct.c"
      inspector = (__funcarg145 = FUNCCALL(SETUP_XfOrM749(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg145 , MZCONFIG_INSPECTOR ) )) ; 
    }
  }
  struct_type -> inspector = inspector ; 

  if (parent_type ) {
    struct_type -> num_props = parent_type -> num_props ; 
    struct_type -> props = parent_type -> props ; 
    if ((& parent_type -> iso ) -> so . keyex & 0x2 )
      checked_proc = 1 ; 
  }




  if (! uninit_val )
    uninit_val = scheme_false ; 
  struct_type -> uninit_val = uninit_val ; 

  if ((struct_type -> proc_attr && (((intptr_t ) (struct_type -> proc_attr ) ) & 0x1 ) ) 
  || (proc_attr && (((intptr_t ) (proc_attr ) ) & 0x1 ) ) ) {
    int n , ni , p ; 
#   define XfOrM742_COUNT (0+XfOrM695_COUNT)
#   define SETUP_XfOrM742(x) SETUP_XfOrM695(x)

# 5083 "bc/src/struct.c"
    n = struct_type -> num_slots ; 
    ni = struct_type -> num_islots ; 
    if (parent_type ) {
      n -= parent_type -> num_slots ; 
      ni -= parent_type -> num_islots ; 
    }

    if (proc_attr && (((intptr_t ) (proc_attr ) ) & 0x1 ) ) {
#     define XfOrM743_COUNT (0+XfOrM742_COUNT)
#     define SETUP_XfOrM743(x) SETUP_XfOrM742(x)

# 5091 "bc/src/struct.c"
      p = (((intptr_t ) (proc_attr ) ) >> 1 ) ; 
      if (p < ni ) {
#       define XfOrM744_COUNT (0+XfOrM743_COUNT)
#       define SETUP_XfOrM744(x) SETUP_XfOrM743(x)

# 5093 "bc/src/struct.c"
        if (! immutable_array ) {
#         define XfOrM745_COUNT (0+XfOrM744_COUNT)
#         define SETUP_XfOrM745(x) SETUP_XfOrM744(x)

# 5094 "bc/src/struct.c"
          immutable_array = (char * ) FUNCCALL(SETUP_XfOrM745(_), GC_malloc_atomic (n ) ); 
          (memset (immutable_array , 0 , n ) ) ; 
        }
        immutable_array [p ] = 1 ; 
      }
    }
  }
  struct_type -> immutables = immutable_array ; 




  if (proc_attr )
    props = (__funcarg143 = (__funcarg144 = FUNCCALL(SETUP_XfOrM695(_), scheme_make_pair (proc_property , proc_attr ) )
  , FUNCCALL_AGAIN(scheme_make_pair (__funcarg144 , scheme_null ) )) , FUNCCALL_AGAIN(scheme_append (props ? props : scheme_null , __funcarg143 ) )) 
  ; 

  if (props ) {
    int num_props , i ; 
    Scheme_Object * proc_prop_set = ((void * ) 0 ) ; 
    Scheme_Hash_Table * can_override ; 
    Scheme_Object * l , * a , * prop , * propv , * oldv ; 
    BLOCK_SETUP((PUSH(proc_prop_set, 0+XfOrM695_COUNT), PUSH(can_override, 1+XfOrM695_COUNT), PUSH(oldv, 2+XfOrM695_COUNT), PUSH(prop, 3+XfOrM695_COUNT), PUSH(propv, 4+XfOrM695_COUNT), PUSH(a, 5+XfOrM695_COUNT), PUSH(l, 6+XfOrM695_COUNT)));
#   define XfOrM701_COUNT (7+XfOrM695_COUNT)
#   define SETUP_XfOrM701(x) SETUP(XfOrM701_COUNT)
    can_override = NULLED_OUT ; 
    l = NULLED_OUT ; 
    a = NULLED_OUT ; 
    prop = NULLED_OUT ; 
    propv = NULLED_OUT ; 
    oldv = NULLED_OUT ; 

# 5117 "bc/src/struct.c"
    can_override = FUNCCALL(SETUP_XfOrM701(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

    num_props = FUNCCALL_AGAIN(count_non_proc_props (props ) ); 
    if ((struct_type -> num_props < 0 ) || (struct_type -> num_props + num_props > 5 ) ) {
      Scheme_Hash_Table * ht ; 
      BLOCK_SETUP((PUSH(ht, 0+XfOrM701_COUNT)));
#     define XfOrM723_COUNT (1+XfOrM701_COUNT)
#     define SETUP_XfOrM723(x) SETUP(XfOrM723_COUNT)
      ht = NULLED_OUT ; 

# 5123 "bc/src/struct.c"
      ht = FUNCCALL(SETUP_XfOrM723(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

      if (struct_type -> num_props >= 0 ) {
#       define XfOrM739_COUNT (0+XfOrM723_COUNT)
#       define SETUP_XfOrM739(x) SETUP_XfOrM723(x)

# 5126 "bc/src/struct.c"
        for (i = 0 ; i < struct_type -> num_props ; i ++ ) {
#         define XfOrM741_COUNT (0+XfOrM739_COUNT)
#         define SETUP_XfOrM741(x) SETUP_XfOrM739(x)

# 5127 "bc/src/struct.c"
          prop = (((Scheme_Simple_Object * ) (struct_type -> props [i ] ) ) -> u . pair_val . car ) ; 
          FUNCCALL(SETUP_XfOrM741(_), scheme_hash_set (ht , prop , (((Scheme_Simple_Object * ) (struct_type -> props [i ] ) ) -> u . pair_val . cdr ) ) ); 
          FUNCCALL_AGAIN(scheme_hash_set (can_override , prop , scheme_true ) ); 
        }
      }

# 5131 "bc/src/struct.c"
      else {

        Scheme_Hash_Table * oht = (Scheme_Hash_Table * ) struct_type -> props ; 
        BLOCK_SETUP((PUSH(oht, 0+XfOrM723_COUNT)));
#       define XfOrM734_COUNT (1+XfOrM723_COUNT)
#       define SETUP_XfOrM734(x) SETUP(XfOrM734_COUNT)

# 5134 "bc/src/struct.c"
        for (i = oht -> size ; i -- ; ) {
#         define XfOrM737_COUNT (0+XfOrM734_COUNT)
#         define SETUP_XfOrM737(x) SETUP_XfOrM734(x)

# 5135 "bc/src/struct.c"
          if (oht -> vals [i ] ) {
#           define XfOrM738_COUNT (0+XfOrM737_COUNT)
#           define SETUP_XfOrM738(x) SETUP_XfOrM737(x)

# 5136 "bc/src/struct.c"
            prop = oht -> keys [i ] ; 
            FUNCCALL(SETUP_XfOrM738(_), scheme_hash_set (ht , prop , oht -> vals [i ] ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (can_override , prop , scheme_true ) ); 
          }
        }
      }


      for (l = props ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ) {
        int skip_supers = 0 ; 
#       define XfOrM729_COUNT (0+XfOrM723_COUNT)
#       define SETUP_XfOrM729(x) SETUP_XfOrM723(x)

# 5147 "bc/src/struct.c"
        a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        prop = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 

        if ((prop ) == (scheme_checked_proc_property ) ) 
          checked_proc = 1 ; 
        if ((prop ) == (scheme_chaperone_undefined_property ) ) 
          chaperone_undefined = 1 ; 
        if ((prop ) == (scheme_authentic_property ) ) 
          struct_type -> more_flags |= 0x4 ; 
        if ((prop ) == (scheme_sealed_property ) ) 
          struct_type -> more_flags |= 0x8 ; 

        propv = FUNCCALL(SETUP_XfOrM729(_), guard_property (prop , (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) , struct_type ) ); 

        if ((prop ) == (proc_property ) )  {
          if (proc_prop_set && ! ((proc_prop_set ) == (propv ) ) )
            break ; 
        }

# 5164 "bc/src/struct.c"
        else {
#         define XfOrM730_COUNT (0+XfOrM729_COUNT)
#         define SETUP_XfOrM730(x) SETUP_XfOrM729(x)

# 5165 "bc/src/struct.c"
          oldv = FUNCCALL(SETUP_XfOrM730(_), scheme_hash_get (ht , prop ) ); 
          if (oldv ) {
#           define XfOrM731_COUNT (0+XfOrM730_COUNT)
#           define SETUP_XfOrM731(x) SETUP_XfOrM730(x)

# 5168 "bc/src/struct.c"
            if (! FUNCCALL(SETUP_XfOrM731(_), scheme_hash_get (can_override , prop ) )) {
              if (! ((oldv ) == (propv ) ) )
                break ; 
              skip_supers = 1 ; 
            }
            FUNCCALL(SETUP_XfOrM731(_), scheme_hash_set (can_override , prop , ((void * ) 0 ) ) )
            ; 
          }
        }

        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        if (! skip_supers )
          l = FUNCCALL(SETUP_XfOrM729(_), append_super_props ((Scheme_Struct_Property * ) prop , propv , l ) ); 

        if ((prop ) == (proc_property ) ) 
          proc_prop_set = propv ; 
        else FUNCCALL(SETUP_XfOrM729(_), scheme_hash_set (ht , prop , propv ) )
        ; 
      }

      struct_type -> props = (Scheme_Object * * ) ht ; 
      struct_type -> num_props = - 1 ; 
    }

# 5190 "bc/src/struct.c"
    else {

      Scheme_Object * * pa ; 
      int j ; 
      BLOCK_SETUP((PUSH(pa, 0+XfOrM701_COUNT)));
#     define XfOrM703_COUNT (1+XfOrM701_COUNT)
#     define SETUP_XfOrM703(x) SETUP(XfOrM703_COUNT)
      pa = NULLED_OUT ; 

# 5196 "bc/src/struct.c"
      for (i = 0 ; i < struct_type -> num_props ; i ++ ) {
#       define XfOrM722_COUNT (0+XfOrM703_COUNT)
#       define SETUP_XfOrM722(x) SETUP_XfOrM703(x)

# 5197 "bc/src/struct.c"
        prop = (((Scheme_Simple_Object * ) (struct_type -> props [i ] ) ) -> u . pair_val . car ) ; 
        FUNCCALL(SETUP_XfOrM722(_), scheme_hash_set (can_override , prop , scheme_true ) ); 
      }

      pa = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM703(_), GC_malloc (sizeof (Scheme_Object * ) * (i + num_props ) ) )) ; 
      if (i )
        (memcpy (pa , struct_type -> props , sizeof (Scheme_Object * ) * i ) ) ; 

      num_props = i ; 

      for (l = props ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ) {
        int skip_supers = 0 ; 
#       define XfOrM713_COUNT (0+XfOrM703_COUNT)
#       define SETUP_XfOrM713(x) SETUP_XfOrM703(x)

# 5210 "bc/src/struct.c"
        a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 

        prop = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 

        if ((prop ) == (scheme_checked_proc_property ) ) 
          checked_proc = 1 ; 
        if ((prop ) == (scheme_chaperone_undefined_property ) ) 
          chaperone_undefined = 1 ; 
        if ((prop ) == (scheme_authentic_property ) ) 
          struct_type -> more_flags |= 0x4 ; 
        if ((prop ) == (scheme_sealed_property ) ) 
          struct_type -> more_flags |= 0x8 ; 

        propv = FUNCCALL(SETUP_XfOrM713(_), guard_property (prop , (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) , struct_type ) ); 


        if ((prop ) == (proc_property ) )  {
          if (proc_prop_set && ! ((proc_prop_set ) == (propv ) ) )
            break ; 
          j = 0 ; 
        }

# 5230 "bc/src/struct.c"
        else {
#         define XfOrM715_COUNT (0+XfOrM713_COUNT)
#         define SETUP_XfOrM715(x) SETUP_XfOrM713(x)

# 5231 "bc/src/struct.c"
          for (j = 0 ; j < num_props ; j ++ ) {
            if (((((Scheme_Simple_Object * ) (pa [j ] ) ) -> u . pair_val . car ) ) == (prop ) ) 
              break ; 
          }
          if (j < num_props ) {
#           define XfOrM716_COUNT (0+XfOrM715_COUNT)
#           define SETUP_XfOrM716(x) SETUP_XfOrM715(x)

# 5237 "bc/src/struct.c"
            if (! FUNCCALL(SETUP_XfOrM716(_), scheme_hash_get (can_override , prop ) )) {
              if (! ((propv ) == ((((Scheme_Simple_Object * ) (pa [j ] ) ) -> u . pair_val . cdr ) ) ) )
                break ; 
              skip_supers = 1 ; 
            }
            FUNCCALL(SETUP_XfOrM716(_), scheme_hash_set (can_override , prop , ((void * ) 0 ) ) )
            ; 
          }

# 5244 "bc/src/struct.c"
          else 
          num_props ++ ; 
        }

        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        if (! skip_supers )
          l = FUNCCALL(SETUP_XfOrM713(_), append_super_props ((Scheme_Struct_Property * ) prop , propv , l ) ); 

        if ((prop ) == (proc_property ) ) 
          proc_prop_set = propv ; 
        else {
#         define XfOrM714_COUNT (0+XfOrM713_COUNT)
#         define SETUP_XfOrM714(x) SETUP_XfOrM713(x)

# 5255 "bc/src/struct.c"
          a = FUNCCALL(SETUP_XfOrM714(_), scheme_make_pair (prop , propv ) ); 
          pa [j ] = a ; 
        }
      }

      if (num_props ) {
        struct_type -> num_props = num_props ; 
        struct_type -> props = pa ; 
      }
    }

    if (! ((l ) == (scheme_null ) ) ) {
#     define XfOrM702_COUNT (0+XfOrM701_COUNT)
#     define SETUP_XfOrM702(x) SETUP_XfOrM701(x)

# 5268 "bc/src/struct.c"
      a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      FUNCCALL(SETUP_XfOrM702(_), scheme_contract_error ("make-struct-type" , "duplicate property binding" , "property" , 1 , a , ((void * ) 0 ) ) )

      ; 
    }
  }

  if (parent_type && ((parent_type -> more_flags & 0x4 ) 
  != (struct_type -> more_flags & 0x4 ) ) ) {
#   define XfOrM700_COUNT (0+XfOrM695_COUNT)
#   define SETUP_XfOrM700(x) SETUP_XfOrM695(x)

# 5277 "bc/src/struct.c"
    if (parent_type -> more_flags & 0x4 )
      FUNCCALL(SETUP_XfOrM700(_), scheme_contract_error ("make-struct-type" , "cannot make a non-authentic subtype of an authentic type" , "type name" , 1 , struct_type -> name , "authentic type" , 1 , parent , ((void * ) 0 ) ) )



    ; 
    else FUNCCALL(SETUP_XfOrM700(_), scheme_contract_error ("make-struct-type" , "cannot make an authentic subtype of a non-authentic type" , "type name" , 1 , struct_type -> name , "non-authentic type" , 1 , parent , ((void * ) 0 ) ) )




    ; 
  }

  if (guard ) {
#   define XfOrM698_COUNT (0+XfOrM695_COUNT)
#   define SETUP_XfOrM698(x) SETUP_XfOrM695(x)

# 5292 "bc/src/struct.c"
    if (! FUNCCALL(SETUP_XfOrM698(_), scheme_check_proc_arity (((void * ) 0 ) , struct_type -> num_islots + 1 , - 1 , 0 , & guard ) )) {
#     define XfOrM699_COUNT (0+XfOrM698_COUNT)
#     define SETUP_XfOrM699(x) SETUP_XfOrM698(x)
      FUNCCALL(SETUP_XfOrM699(_), scheme_contract_error ("make-struct-type" , "guard procedure does not accept correct number of arguments;\n" " should accept one more than the number of constructor arguments" , "guard procedure" , 1 , guard , "expected arity" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (struct_type -> num_islots + 1 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )


      ; 
    }

    struct_type -> guard = guard ; 
    struct_type -> more_flags = 0 ; 
  }

# 5303 "bc/src/struct.c"
  else if (chaperone_undefined ) {
    struct_type -> guard = scheme_undefined ; 
  }

  if (parent && (((Scheme_Type ) (((((intptr_t ) (parent ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (parent ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#   define XfOrM696_COUNT (0+XfOrM695_COUNT)
#   define SETUP_XfOrM696(x) SETUP_XfOrM695(x)

# 5308 "bc/src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM696(_), add_struct_type_chaperone_guards (parent , struct_type -> guard ) ); 
    struct_type -> guard = guard ; 
    struct_type -> more_flags = 0 ; 
  }

  if (checked_proc )
    (& struct_type -> iso ) -> so . keyex |= 0x2 ; 
  FUNCCALL(SETUP_XfOrM695(_), struct_type_set_if_immutable (struct_type ) )

  ; 

  RET_VALUE_START ((Scheme_Object * ) struct_type ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5322 "bc/src/struct.c"
Scheme_Object * scheme_make_struct_type (Scheme_Object * name , 
Scheme_Object * parent , 
Scheme_Object * inspector , 
int num_fields , int num_uninit , 
Scheme_Object * uninit_val , 
Scheme_Object * properties , 
Scheme_Object * guard ) 
{
  /* No conversion */

# 5330 "bc/src/struct.c"
  return _make_struct_type (name , 
  parent , inspector , 
  num_fields , num_uninit , 
  uninit_val , properties , 
  ((void * ) 0 ) , ((void * ) 0 ) , 
  guard ) ; 
}

Scheme_Object * scheme_make_struct_type2 (Scheme_Object * name , 
Scheme_Object * parent , 
Scheme_Object * inspector , 
int num_fields , int num_uninit , 
Scheme_Object * uninit_val , 
Scheme_Object * properties , 
Scheme_Object * proc_attr , 
char * immutable_array , 
Scheme_Object * guard ) 
{
  /* No conversion */

# 5348 "bc/src/struct.c"
  return _make_struct_type (name , 
  parent , inspector , 
  num_fields , num_uninit , 
  uninit_val , properties , 
  proc_attr , immutable_array , 
  guard ) ; 
}

Scheme_Object * scheme_make_struct_type_from_string (const char * name , 
Scheme_Object * parent , 
int num_fields , 
Scheme_Object * props , 
Scheme_Object * guard , 
int immutable ) 
{
  Scheme_Object * namesym , * r ; 
  char * immutable_array = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(immutable_array, 1), PUSH(props, 2), PUSH(namesym, 3), PUSH(r, 4), PUSH(parent, 5), PUSH(guard, 6)));
# define XfOrM756_COUNT (7)
# define SETUP_XfOrM756(x) SETUP(XfOrM756_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  namesym = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 5366 "bc/src/struct.c"
  if (immutable ) {
#   define XfOrM757_COUNT (0+XfOrM756_COUNT)
#   define SETUP_XfOrM757(x) SETUP_XfOrM756(x)

# 5367 "bc/src/struct.c"
    immutable_array = (char * ) FUNCCALL(SETUP_XfOrM757(_), GC_malloc_atomic (num_fields ) ); 
    (memset (immutable_array , 1 , num_fields ) ) ; 
  }

  namesym = FUNCCALL(SETUP_XfOrM756(_), scheme_intern_exact_symbol (name , strlen (name ) ) ); 

  r = FUNCCALL(SETUP_XfOrM756(_), _make_struct_type (namesym , parent , scheme_false , num_fields , 0 , ((void * ) 0 ) , props , ((void * ) 0 ) , immutable_array , guard ) )




  ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) )
    FUNCCALL(SETUP_XfOrM756(_), scheme_force_struct_type_info ((Scheme_Struct_Type * ) r ) )
  ; 

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5387 "bc/src/struct.c"
static Scheme_Struct_Type * lookup_prefab (Scheme_Object * key ) {
  Scheme_Object * a = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Struct_Type * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(a, 0)));
# define XfOrM758_COUNT (1)
# define SETUP_XfOrM758(x) SETUP(XfOrM758_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5390 "bc/src/struct.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) ) {
#   define XfOrM759_COUNT (0+XfOrM758_COUNT)
#   define SETUP_XfOrM759(x) SETUP_XfOrM758(x)

# 5391 "bc/src/struct.c"
    a = FUNCCALL(SETUP_XfOrM759(_), scheme_lookup_in_table (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) , (const char * ) key ) ); 
  }

  if (a )
    RET_VALUE_START ((Scheme_Struct_Type * ) (((Scheme_Small_Object * ) (a ) ) -> u . ptr_val ) ) RET_VALUE_END ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5400 "bc/src/struct.c"
static Scheme_Struct_Type * hash_prefab (Scheme_Struct_Type * type ) 
{
  Scheme_Object * k , * v ; 
  DECL_RET_SAVE (Scheme_Struct_Type * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(k, 0), PUSH(type, 1), PUSH(v, 2)));
# define XfOrM760_COUNT (3)
# define SETUP_XfOrM760(x) SETUP(XfOrM760_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  k = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 5404 "bc/src/struct.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) ) {
#   define XfOrM763_COUNT (0+XfOrM760_COUNT)
#   define SETUP_XfOrM763(x) SETUP_XfOrM760(x)
    FUNCCALL(SETUP_XfOrM763(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) ) ) )
# 5405 "bc/src/struct.c"
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) = FUNCCALL(SETUP_XfOrM763(_), scheme_make_weak_equal_table () ); 
  }

  k = FUNCCALL(SETUP_XfOrM760(_), make_prefab_key (type ) ); 
  type -> prefab_key = k ; 

  v = FUNCCALL(SETUP_XfOrM760(_), scheme_lookup_in_table (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) , (const char * ) k ) ); 

  if (v )
    v = (((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) ; 

  if (v ) {
    type = (Scheme_Struct_Type * ) v ; 
  }

# 5419 "bc/src/struct.c"
  else {
#   define XfOrM761_COUNT (0+XfOrM760_COUNT)
#   define SETUP_XfOrM761(x) SETUP_XfOrM760(x)

# 5420 "bc/src/struct.c"
    v = FUNCCALL(SETUP_XfOrM761(_), scheme_make_weak_box ((Scheme_Object * ) type ) ); 
    FUNCCALL(SETUP_XfOrM761(_), scheme_add_to_table (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) , (const char * ) k , v , 0 ) ); 
  }

  RET_VALUE_START (type ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5427 "bc/src/struct.c"
static char * immutable_pos_list_to_immutable_array (Scheme_Object * immutable_pos_list , int localfieldc ) {
  char * ia ; 
  Scheme_Object * l ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(ia, 1), PUSH(immutable_pos_list, 2)));
# define XfOrM764_COUNT (3)
# define SETUP_XfOrM764(x) SETUP(XfOrM764_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ia = NULLED_OUT ; 
  l = NULLED_OUT ; 

# 5430 "bc/src/struct.c"
  ia = (char * ) FUNCCALL(SETUP_XfOrM764(_), GC_malloc_atomic (localfieldc ) ); 
  (memset (ia , 0 , localfieldc ) ) ; 

  for (l = immutable_pos_list ; l && ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
    int a_val ; 
    Scheme_Object * a ; 
#   define XfOrM769_COUNT (0+XfOrM764_COUNT)
#   define SETUP_XfOrM769(x) SETUP_XfOrM764(x)
    a = NULLED_OUT ; 

# 5436 "bc/src/struct.c"
    a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    if (! (((intptr_t ) (a ) ) & 0x1 ) )
      a_val = - 1 ; 
    else 
    a_val = (((intptr_t ) (a ) ) >> 1 ) ; 
    if (a_val < 0 ) {
#     define XfOrM772_COUNT (0+XfOrM769_COUNT)
#     define SETUP_XfOrM772(x) SETUP_XfOrM769(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "contract violation for index of immutable field" , "expected:" , 0 , "(and/c exact-nonnegative-integer? fixnum?)" , "given" , 1 , a , "in list" , 1 , immutable_pos_list , ((void * ) 0 ) ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (a_val >= localfieldc ) {
#     define XfOrM771_COUNT (0+XfOrM769_COUNT)
#     define SETUP_XfOrM771(x) SETUP_XfOrM769(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "index for immutable field >= initialized-field count" , "index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (a_val ) ) ) << 1 ) | 0x1 ) ) , "initialized-field count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (localfieldc ) ) ) << 1 ) | 0x1 ) ) , "in list" , 1 , immutable_pos_list , ((void * ) 0 ) ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (ia [a_val ] ) {
#     define XfOrM770_COUNT (0+XfOrM769_COUNT)
#     define SETUP_XfOrM770(x) SETUP_XfOrM769(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "redundant immutable field index" , "index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (a_val ) ) ) << 1 ) | 0x1 ) ) , "in list" , 1 , immutable_pos_list , ((void * ) 0 ) ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    ia [a_val ] = 1 ; 
  }

  RET_VALUE_START (ia ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5474 "bc/src/struct.c"
static Scheme_Object * make_struct_type (int argc , Scheme_Object * * argv ) 
{
  int initc , uninitc , num_props = 0 , prefab = 0 ; 
  Scheme_Object * props = scheme_null , * l , * a , * * r , * cstr_name = ((void * ) 0 ) ; 
  Scheme_Object * inspector = ((void * ) 0 ) , * uninit_val ; 
  Scheme_Struct_Type * type ; 
  Scheme_Object * proc_attr = ((void * ) 0 ) , * immutable_pos_list = scheme_null , * guard = ((void * ) 0 ) ; 
  char * immutable_array ; 
  Scheme_Config * __funcarg146 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(13);
  BLOCK_SETUP_TOP((PUSH(cstr_name, 0), PUSH(immutable_array, 1), PUSH(type, 2), PUSH(props, 3), PUSH(proc_attr, 4), PUSH(uninit_val, 5), PUSH(inspector, 6), PUSH(a, 7), PUSH(immutable_pos_list, 8), PUSH(r, 9), PUSH(argv, 10), PUSH(guard, 11)));
# define XfOrM773_COUNT (12)
# define SETUP_XfOrM773(x) SETUP(XfOrM773_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = NULLED_OUT ; 
  a = NULLED_OUT ; 
  r = NULLED_OUT ; 
  uninit_val = NULLED_OUT ; 
  type = NULLED_OUT ; 
  immutable_array = NULLED_OUT ; 

# 5483 "bc/src/struct.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "symbol?" , 0 , argc , argv ) ); 
  if (! (((argv [1 ] ) ) == (scheme_false ) ) 
  && ! (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c struct-type? #f)" , 1 , argc , argv ) ); 

  if (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) || ((((intptr_t ) (argv [2 ] ) ) >> 1 ) < 0 ) ) {
#   define XfOrM804_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM804(x) SETUP_XfOrM773(x)

# 5490 "bc/src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [2 ] ) -> iso ) -> so . keyex & 0x1 ) )
      initc = - 1 ; 
    else {
#     define XfOrM805_COUNT (0+XfOrM804_COUNT)
#     define SETUP_XfOrM805(x) SETUP_XfOrM804(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "exact-nonnegative-integer?" , 2 , argc , argv ) )
# 5493 "bc/src/struct.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 5496 "bc/src/struct.c"
  else 
  initc = (((intptr_t ) (argv [2 ] ) ) >> 1 ) ; 

  if (! (((intptr_t ) (argv [3 ] ) ) & 0x1 ) || ((((intptr_t ) (argv [3 ] ) ) >> 1 ) < 0 ) ) {
#   define XfOrM802_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM802(x) SETUP_XfOrM773(x)

# 5500 "bc/src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [3 ] ) -> iso ) -> so . keyex & 0x1 ) )
      uninitc = - 1 ; 
    else {
#     define XfOrM803_COUNT (0+XfOrM802_COUNT)
#     define SETUP_XfOrM803(x) SETUP_XfOrM802(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "exact-nonnegative-integer?" , 3 , argc , argv ) )
# 5503 "bc/src/struct.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 5506 "bc/src/struct.c"
  else 
  uninitc = (((intptr_t ) (argv [3 ] ) ) >> 1 ) ; 

  if (argc > 4 ) {
#   define XfOrM785_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM785(x) SETUP_XfOrM773(x)

# 5510 "bc/src/struct.c"
    uninit_val = argv [4 ] ; 

    if (argc > 5 ) {
#     define XfOrM786_COUNT (0+XfOrM785_COUNT)
#     define SETUP_XfOrM786(x) SETUP_XfOrM785(x)

# 5513 "bc/src/struct.c"
      props = argv [5 ] ; 
      for (l = props ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
        a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
        || ! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) )
          break ; 
        num_props ++ ; 
      }
      if (! ((l ) == (scheme_null ) ) ) {
#       define XfOrM799_COUNT (0+XfOrM786_COUNT)
#       define SETUP_XfOrM799(x) SETUP_XfOrM786(x)
        FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(listof (cons/c struct-type-property? any/c))" , 5 , argc , argv ) )
# 5522 "bc/src/struct.c"
        ; 
      }

      if (argc > 6 ) {
#       define XfOrM787_COUNT (0+XfOrM786_COUNT)
#       define SETUP_XfOrM787(x) SETUP_XfOrM786(x)

# 5526 "bc/src/struct.c"
        inspector = argv [6 ] ; 
        if ((inspector ) == (prefab_symbol ) )  {
          prefab = 1 ; 
          inspector = scheme_false ; 
        }

# 5530 "bc/src/struct.c"
        else if (! (((inspector ) ) == (scheme_false ) ) ) {
#         define XfOrM797_COUNT (0+XfOrM787_COUNT)
#         define SETUP_XfOrM797(x) SETUP_XfOrM787(x)

# 5531 "bc/src/struct.c"
          if (! ((Scheme_Type ) (((((intptr_t ) (argv [6 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [6 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
            FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c inspector? #f 'prefab)" , 6 , argc , argv ) ); 
        }

        if (argc > 7 ) {
#         define XfOrM788_COUNT (0+XfOrM787_COUNT)
#         define SETUP_XfOrM788(x) SETUP_XfOrM787(x)

# 5536 "bc/src/struct.c"
          if (! (((argv [7 ] ) ) == (scheme_false ) ) ) {
#           define XfOrM795_COUNT (0+XfOrM788_COUNT)
#           define SETUP_XfOrM795(x) SETUP_XfOrM788(x)

# 5537 "bc/src/struct.c"
            proc_attr = argv [7 ] ; 

            if (! (((((intptr_t ) (proc_attr ) ) & 0x1 ) && ((((intptr_t ) (proc_attr ) ) >> 1 ) >= 0 ) ) 
            || (((Scheme_Type ) (((((intptr_t ) (proc_attr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc_attr ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) proc_attr ) -> iso ) -> so . keyex & 0x1 ) ) 
            || (! (((intptr_t ) (proc_attr ) ) & 0x1 ) && ((((proc_attr ) -> type ) >= scheme_prim_type ) && (((proc_attr ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) ) {
#             define XfOrM796_COUNT (0+XfOrM795_COUNT)
#             define SETUP_XfOrM796(x) SETUP_XfOrM795(x)
              FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c exact-nonnegative-integer? procedure? #f)" , 7 , argc , argv ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
          }

          if (argc > 8 ) {
#           define XfOrM789_COUNT (0+XfOrM788_COUNT)
#           define SETUP_XfOrM789(x) SETUP_XfOrM788(x)

# 5550 "bc/src/struct.c"
            l = immutable_pos_list = argv [8 ] ; 

            if ((scheme_proper_list_length (l ) ) < 0 ) {
#             define XfOrM794_COUNT (0+XfOrM789_COUNT)
#             define SETUP_XfOrM794(x) SETUP_XfOrM789(x)
              FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(listof exact-nonnegative-integer?)" , 8 , argc , argv ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }

            if (argc > 9 ) {
#             define XfOrM790_COUNT (0+XfOrM789_COUNT)
#             define SETUP_XfOrM790(x) SETUP_XfOrM789(x)

# 5560 "bc/src/struct.c"
              if (! (((argv [9 ] ) ) == (scheme_false ) ) )  {
#               define XfOrM793_COUNT (0+XfOrM790_COUNT)
#               define SETUP_XfOrM793(x) SETUP_XfOrM790(x)

# 5561 "bc/src/struct.c"
                guard = argv [9 ] ; 
                if (! (! (((intptr_t ) (guard ) ) & 0x1 ) && ((((guard ) -> type ) >= scheme_prim_type ) && (((guard ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
                  FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c procedure? #f)" , 9 , argc , argv ) ); 
              }

              if (argc > 10 ) {
#               define XfOrM791_COUNT (0+XfOrM790_COUNT)
#               define SETUP_XfOrM791(x) SETUP_XfOrM790(x)

# 5567 "bc/src/struct.c"
                if (! (((argv [10 ] ) ) == (scheme_false ) ) ) {
#                 define XfOrM792_COUNT (0+XfOrM791_COUNT)
#                 define SETUP_XfOrM792(x) SETUP_XfOrM791(x)

# 5568 "bc/src/struct.c"
                  if (! ((Scheme_Type ) (((((intptr_t ) (argv [10 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [10 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
                    FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c symbol? #f)" , 10 , argc , argv ) ); 
                  cstr_name = argv [10 ] ; 
                }
              }
            }
          }
        }
      }
    }
  }

# 5578 "bc/src/struct.c"
  else 
  uninit_val = scheme_false ; 

  if (! uninitc )
    uninit_val = scheme_false ; 

  if (! inspector )
    inspector = (__funcarg146 = FUNCCALL(SETUP_XfOrM773(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg146 , MZCONFIG_INSPECTOR ) )) ; 

  immutable_array = FUNCCALL(SETUP_XfOrM773(_), immutable_pos_list_to_immutable_array (immutable_pos_list , initc + uninitc ) ); 

  if (prefab ) {
    const char * bad = ((void * ) 0 ) ; 
    Scheme_Object * parent = argv [1 ] ; 
#   define XfOrM778_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM778(x) SETUP_XfOrM773(x)

# 5592 "bc/src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (parent ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (parent ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
      bad = "chaperoned supertype disallowed for non-generative structure type" ; 
    }

# 5594 "bc/src/struct.c"
    else if (! (((parent ) ) == (scheme_false ) ) && ! ((Scheme_Struct_Type * ) parent ) -> prefab_key ) {
      bad = "generative supertype disallowed for non-generative structure type" ; 
    }

# 5596 "bc/src/struct.c"
    else if (! ((props ) == (scheme_null ) ) ) {
      bad = "properties disallowed for non-generative structure type" ; 
    }

# 5598 "bc/src/struct.c"
    else if (proc_attr ) {
      bad = "procedure specification disallowed for non-generative structure type" ; 
    }

# 5600 "bc/src/struct.c"
    else if (guard ) {
      bad = "guard disallowed for non-generative structure type" ; 
    }
    if (bad ) {
#     define XfOrM779_COUNT (0+XfOrM778_COUNT)
#     define SETUP_XfOrM779(x) SETUP_XfOrM778(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , bad , "structure type name" , 1 , argv [0 ] , ((void * ) 0 ) ) )
      ; 
    }

    type = FUNCCALL(SETUP_XfOrM778(_), scheme_make_prefab_struct_type (argv [0 ] , (((argv [1 ] ) ) == (scheme_false ) ) ? ((void * ) 0 ) : argv [1 ] , initc , uninitc , uninit_val , immutable_array ) )



    ; 
  }

# 5615 "bc/src/struct.c"
  else {
    Scheme_Object * parent = (((argv [1 ] ) ) == (scheme_false ) ) ? ((void * ) 0 ) : argv [1 ] ; 
    Scheme_Struct_Type * parent_type ; 
#   define XfOrM776_COUNT (0+XfOrM773_COUNT)
#   define SETUP_XfOrM776(x) SETUP_XfOrM773(x)
    parent_type = NULLED_OUT ; 

# 5619 "bc/src/struct.c"
    if (parent && (((Scheme_Type ) (((((intptr_t ) (parent ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (parent ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) )
      parent_type = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) parent ) -> val ) ; 
    else 
    parent_type = (Scheme_Struct_Type * ) parent ; 

    if (parent_type && (parent_type -> more_flags & 0x8 ) ) {
#     define XfOrM777_COUNT (0+XfOrM776_COUNT)
#     define SETUP_XfOrM777(x) SETUP_XfOrM776(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "cannot make a subtype of a sealed type" , "type name" , 1 , argv [0 ] , "sealed type" , 1 , parent , ((void * ) 0 ) ) )

      ; 
    }

    type = (Scheme_Struct_Type * ) FUNCCALL(SETUP_XfOrM776(_), _make_struct_type (argv [0 ] , parent , inspector , initc , uninitc , uninit_val , props , proc_attr , immutable_array , guard ) )






    ; 
  }

  {
    int i ; 
    Scheme_Object * * names ; 
    BLOCK_SETUP((PUSH(names, 0+XfOrM773_COUNT)));
#   define XfOrM774_COUNT (1+XfOrM773_COUNT)
#   define SETUP_XfOrM774(x) SETUP(XfOrM774_COUNT)
    names = NULLED_OUT ; 

# 5646 "bc/src/struct.c"
    names = FUNCCALL(SETUP_XfOrM774(_), scheme_make_struct_names (argv [0 ] , ((void * ) 0 ) , (0x20 | 0x40 | 0x200 ) , & i ) )



    ; 
    if (cstr_name ) {
#     define XfOrM775_COUNT (0+XfOrM774_COUNT)
#     define SETUP_XfOrM775(x) SETUP_XfOrM774(x)

# 5652 "bc/src/struct.c"
      a = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM775(_), scheme_symbol_val (cstr_name ) ); 
      names [1 ] = a ; 
    }
    r = FUNCCALL(SETUP_XfOrM774(_), scheme_make_struct_values ((Scheme_Object * ) type , names , i , (0x20 | 0x40 | 0x200 ) ) )

    ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (i , r ) )) RET_VALUE_EMPTY_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5663 "bc/src/struct.c"
static Scheme_Object * make_prefab_key (Scheme_Struct_Type * type ) 
{
  Scheme_Object * key = scheme_null , * stack = scheme_null ; 
  int total_cnt ; 
  Scheme_Object * __funcarg150 = NULLED_OUT ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(type, 1), PUSH(key, 2)));
# define XfOrM806_COUNT (3)
# define SETUP_XfOrM806(x) SETUP(XfOrM806_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5668 "bc/src/struct.c"
  total_cnt = type -> num_slots ; 

  while (type -> name_pos ) {
#   define XfOrM830_COUNT (0+XfOrM806_COUNT)
#   define SETUP_XfOrM830(x) SETUP_XfOrM806(x)

# 5671 "bc/src/struct.c"
    stack = FUNCCALL(SETUP_XfOrM830(_), scheme_make_pair ((Scheme_Object * ) type , stack ) ); 
    type = type -> parent_types [type -> name_pos - 1 ] ; 
  }

  while (type ) {
    int cnt = type -> num_slots ; 
    int icnt = type -> num_islots ; 
#   define XfOrM818_COUNT (0+XfOrM806_COUNT)
#   define SETUP_XfOrM818(x) SETUP_XfOrM806(x)

# 5678 "bc/src/struct.c"
    if (type -> name_pos ) {
      cnt -= type -> parent_types [type -> name_pos - 1 ] -> num_slots ; 
      icnt -= type -> parent_types [type -> name_pos - 1 ] -> num_islots ; 
    }

    if (cnt ) {
      int i ; 
      Scheme_Object * v = scheme_null ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM818_COUNT)));
#     define XfOrM821_COUNT (1+XfOrM818_COUNT)
#     define SETUP_XfOrM821(x) SETUP(XfOrM821_COUNT)

# 5686 "bc/src/struct.c"
      for (i = icnt ; i -- ; ) {
#       define XfOrM826_COUNT (0+XfOrM821_COUNT)
#       define SETUP_XfOrM826(x) SETUP_XfOrM821(x)

# 5687 "bc/src/struct.c"
        if (! type -> immutables || ! type -> immutables [i ] ) {
#         define XfOrM827_COUNT (0+XfOrM826_COUNT)
#         define SETUP_XfOrM827(x) SETUP_XfOrM826(x)

# 5688 "bc/src/struct.c"
          v = FUNCCALL(SETUP_XfOrM827(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , v ) ); 
        }
      }
      if (! ((v ) == (scheme_null ) ) ) {
#       define XfOrM823_COUNT (0+XfOrM821_COUNT)
#       define SETUP_XfOrM823(x) SETUP_XfOrM821(x)

# 5692 "bc/src/struct.c"
        v = FUNCCALL(SETUP_XfOrM823(_), scheme_list_to_vector (v ) ); 
        key = FUNCCALL(SETUP_XfOrM823(_), scheme_make_pair (v , key ) ); 
      }

      if (cnt > icnt ) {
#       define XfOrM822_COUNT (0+XfOrM821_COUNT)
#       define SETUP_XfOrM822(x) SETUP_XfOrM821(x)

# 5697 "bc/src/struct.c"
        key = (__funcarg149 = (__funcarg150 = FUNCCALL(SETUP_XfOrM822(_), scheme_make_pair (type -> uninit_val , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cnt - icnt ) ) ) << 1 ) | 0x1 ) ) , __funcarg150 ) )) 

        , FUNCCALL_AGAIN(scheme_make_pair (__funcarg149 , key ) )) 
        ; 
      }
    }
    if (! ((stack ) == (scheme_null ) ) )
      key = FUNCCALL(SETUP_XfOrM818(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (icnt ) ) ) << 1 ) | 0x1 ) ) , key ) ); 

    key = FUNCCALL(SETUP_XfOrM818(_), scheme_make_pair (type -> name , key ) ); 

    if ((Scheme_Type ) (((((intptr_t ) (stack ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (stack ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
      type = (Scheme_Struct_Type * ) (((Scheme_Simple_Object * ) (stack ) ) -> u . pair_val . car ) ; 
      stack = (((Scheme_Simple_Object * ) (stack ) ) -> u . pair_val . cdr ) ; 
    }

# 5711 "bc/src/struct.c"
    else {
      type = ((void * ) 0 ) ; 
    }
  }

  if (((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  && (((((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ) == (scheme_null ) ) )
    key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 




  key = FUNCCALL(SETUP_XfOrM806(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (total_cnt ) ) ) << 1 ) | 0x1 ) ) , key ) )
  ; 

  RET_VALUE_START (key ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5729 "bc/src/struct.c"
static char * mutability_data_to_immutability_data (int icnt , int ucnt , Scheme_Object * mutables , int * _min_cnt ) 


{
  char * immutable_array = ((void * ) 0 ) , * a2 ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(_min_cnt, 0), PUSH(a2, 1), PUSH(mutables, 2), PUSH(immutable_array, 3)));
# define XfOrM831_COUNT (4)
# define SETUP_XfOrM831(x) SETUP(XfOrM831_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  a2 = NULLED_OUT ; 

# 5735 "bc/src/struct.c"
  if (_min_cnt )
    * _min_cnt = icnt + ucnt ; 

  if ((icnt > 0 ) || _min_cnt ) {
    int sz = icnt + ucnt + 1 ; 
#   define XfOrM832_COUNT (0+XfOrM831_COUNT)
#   define SETUP_XfOrM832(x) SETUP_XfOrM831(x)

# 5740 "bc/src/struct.c"
    immutable_array = (char * ) FUNCCALL(SETUP_XfOrM832(_), GC_malloc_atomic (icnt + ucnt ) ); 
    (memset (immutable_array , 1 , icnt ) ) ; 
    (memset (immutable_array XFORM_OK_PLUS icnt , 0 , ucnt ) ) ; 

    if (mutables ) {
      int i ; 
      int len ; 
#     define XfOrM833_COUNT (0+XfOrM832_COUNT)
#     define SETUP_XfOrM833(x) SETUP_XfOrM832(x)

# 5747 "bc/src/struct.c"
      len = (((Scheme_Vector * ) (mutables ) ) -> size ) ; 
      if ((len > icnt ) && ! _min_cnt )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      for (i = 0 ; i < len ; i ++ ) {
        int a_val ; 
        Scheme_Object * a ; 
        BLOCK_SETUP((PUSH(a, 0+XfOrM833_COUNT)));
#       define XfOrM837_COUNT (1+XfOrM833_COUNT)
#       define SETUP_XfOrM837(x) SETUP(XfOrM837_COUNT)
        a = NULLED_OUT ; 

# 5754 "bc/src/struct.c"
        a = (((Scheme_Vector * ) (mutables ) ) -> els ) [i ] ; 
        if (! (((intptr_t ) (a ) ) & 0x1 ) 
        || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) 
        || (((((intptr_t ) (a ) ) >> 1 ) >= icnt ) 
        && ! _min_cnt ) )
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        a_val = (((intptr_t ) (a ) ) >> 1 ) ; 
        if (_min_cnt && ((a_val + ucnt ) >= * _min_cnt ) ) {
          * _min_cnt = a_val + ucnt + 1 ; 
        }
        if (a_val >= sz ) {
#         define XfOrM838_COUNT (0+XfOrM837_COUNT)
#         define SETUP_XfOrM838(x) SETUP_XfOrM837(x)

# 5765 "bc/src/struct.c"
          a2 = (char * ) FUNCCALL(SETUP_XfOrM838(_), GC_malloc_atomic (a_val * 2 ) ); 
          (memset (a2 , 1 , a_val * 2 ) ) ; 
          (memcpy (a2 , immutable_array , sz ) ) ; 
          sz = a_val * 2 ; 
          immutable_array = a2 ; 
        }
        immutable_array [a_val ] = 0 ; 
      }
    }
  }

  RET_VALUE_START (immutable_array ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5779 "bc/src/struct.c"
Scheme_Struct_Type * scheme_lookup_prefab_type (Scheme_Object * key , int min_field_count ) 
{
  Scheme_Struct_Type * parent = ((void * ) 0 ) ; 
  Scheme_Object * a , * uninit_val , * mutables , * name ; 
  intptr_t ucnt , icnt ; 
  int inferred_size = 0 ; 
  char * immutable_array = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Struct_Type * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(immutable_array, 1), PUSH(mutables, 2), PUSH(uninit_val, 3), PUSH(key, 4), PUSH(a, 5), PUSH(parent, 6)));
# define XfOrM840_COUNT (7)
# define SETUP_XfOrM840(x) SETUP(XfOrM840_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  a = NULLED_OUT ; 
  uninit_val = NULLED_OUT ; 
  mutables = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 5787 "bc/src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    key = FUNCCALL(SETUP_XfOrM840(_), scheme_make_pair (key , scheme_null ) ); 

  if ((scheme_proper_list_length (key ) ) < 0 )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  if (min_field_count > 32768 )
    min_field_count = 32768 ; 

  {
    Scheme_Struct_Type * stype = ((void * ) 0 ) ; 
    BLOCK_SETUP((PUSH(stype, 0+XfOrM840_COUNT)));
#   define XfOrM857_COUNT (1+XfOrM840_COUNT)
#   define SETUP_XfOrM857(x) SETUP(XfOrM857_COUNT)

# 5798 "bc/src/struct.c"
    stype = FUNCCALL(SETUP_XfOrM857(_), lookup_prefab (key ) ); 
    if (stype ) {
      RET_VALUE_START (stype ) RET_VALUE_END ; 
    }
  }


  key = FUNCCALL(SETUP_XfOrM840(_), scheme_reverse (key ) ); 

  while (((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM849_COUNT (0+XfOrM840_COUNT)
#   define SETUP_XfOrM849(x) SETUP_XfOrM840(x)

# 5809 "bc/src/struct.c"
    a = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
      mutables = a ; 
      key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ; 
    }

# 5813 "bc/src/struct.c"
    else 
    mutables = ((void * ) 0 ) ; 


    if (! ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    a = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM855_COUNT (0+XfOrM849_COUNT)
#     define SETUP_XfOrM855(x) SETUP_XfOrM849(x)

# 5821 "bc/src/struct.c"
      if ((scheme_proper_list_length (a ) ) != 2 )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      if (! (((intptr_t ) ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ) ) & 0x1 ) )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      ucnt = (((intptr_t ) ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
      a = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 
      uninit_val = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 
      key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ; 
    }

# 5829 "bc/src/struct.c"
    else {
      ucnt = 0 ; 
      uninit_val = scheme_false ; 
    }


    if (! ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    a = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 
    if (! (((intptr_t ) (a ) ) & 0x1 ) ) {
      if (((((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ) == (scheme_null ) )  {

        icnt = min_field_count - ucnt - (parent 
        ? parent -> num_slots 
        : 0 ) ; 
        if (icnt < 0 )
          icnt = 0 ; 
        inferred_size = 1 ; 
      }

# 5847 "bc/src/struct.c"
      else 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 5849 "bc/src/struct.c"
    else {
      icnt = (((intptr_t ) (a ) ) >> 1 ) ; 
      if (icnt > 32768 )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ; 
    }


    if (! ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    a = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 
    key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ; 

    if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    name = a ; 

    if (icnt || (mutables && (((Scheme_Vector * ) (mutables ) ) -> size ) ) ) {
      int min_cnt ; 
#     define XfOrM850_COUNT (0+XfOrM849_COUNT)
#     define SETUP_XfOrM850(x) SETUP_XfOrM849(x)

# 5868 "bc/src/struct.c"
      immutable_array = FUNCCALL(SETUP_XfOrM850(_), mutability_data_to_immutability_data (icnt , ucnt , mutables , inferred_size ? & min_cnt : ((void * ) 0 ) ) )


      ; 
      if (! immutable_array )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      if (inferred_size && (min_cnt > icnt + ucnt ) )
        icnt = min_cnt - ucnt ; 
    }

    if (parent && (icnt + parent -> num_slots > 32768 ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

    parent = FUNCCALL(SETUP_XfOrM849(_), scheme_make_prefab_struct_type (name , (Scheme_Object * ) parent , icnt , ucnt , uninit_val , immutable_array ) )



    ; 
  }


  if (! ((key ) == (scheme_null ) ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  RET_VALUE_START (parent ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Object * scheme_extract_struct_procedure (Scheme_Object * obj , int num_rands , Scheme_Object * * rands , int * is_method ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * plain_obj , * a , * proc ; 
  int meth_wrap = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(proc, 1), PUSH(obj, 2), PUSH(is_method, 3), PUSH(rands, 4), PUSH(plain_obj, 5)));
# define XfOrM859_COUNT (6)
# define SETUP_XfOrM859(x) SETUP(XfOrM859_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  plain_obj = NULLED_OUT ; 
  a = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 5905 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    plain_obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 
  else 
  plain_obj = obj ; 

  stype = ((Scheme_Structure * ) plain_obj ) -> stype ; 
  a = stype -> proc_attr ; 

  if (((intptr_t ) (a ) ) & 0x1 )  {
#   define XfOrM864_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM864(x) SETUP_XfOrM859(x)

# 5914 "bc/src/struct.c"
    * is_method = 0 ; 
    if (! ((plain_obj ) == (obj ) ) ) {
#     define XfOrM866_COUNT (0+XfOrM864_COUNT)
#     define SETUP_XfOrM866(x) SETUP_XfOrM864(x)

# 5916 "bc/src/struct.c"
      proc = FUNCCALL(SETUP_XfOrM866(_), chaperone_struct_ref ("struct-ref" , ((void * ) 0 ) , obj , obj , (((intptr_t ) (a ) ) >> 1 ) ) ); 
    }

# 5917 "bc/src/struct.c"
    else {
      proc = ((Scheme_Structure * ) obj ) -> slots [(((intptr_t ) (a ) ) >> 1 ) ] ; 
    }
  }

# 5920 "bc/src/struct.c"
  else {
    * is_method = 1 ; 
    proc = a ; 
  }

  if (num_rands >= 0 ) {
#   define XfOrM860_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM860(x) SETUP_XfOrM859(x)

# 5927 "bc/src/struct.c"
    if (! (! (((intptr_t ) (proc ) ) & 0x1 ) && ((((proc ) -> type ) >= scheme_prim_type ) && (((proc ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
    || ! FUNCCALL(SETUP_XfOrM860(_), scheme_check_proc_arity (((void * ) 0 ) , num_rands , - 1 , 0 , & obj ) )) {
#     define XfOrM861_COUNT (0+XfOrM860_COUNT)
#     define SETUP_XfOrM861(x) SETUP_XfOrM860(x)

      if (scheme_reduced_procedure_struct 
      && (scheme_is_struct_instance (scheme_reduced_procedure_struct , plain_obj ) ) )
        meth_wrap = (! (((((Scheme_Structure * ) obj ) -> slots [3 ] ) ) == (scheme_false ) ) ) ; 
      else {
#       define XfOrM862_COUNT (0+XfOrM861_COUNT)
#       define SETUP_XfOrM862(x) SETUP_XfOrM861(x)

# 5936 "bc/src/struct.c"
        a = (do_prop_accessor (method_property , plain_obj ) ) ; 
        if (a && (! (((a ) ) == (scheme_false ) ) ) )
          meth_wrap = 1 ; 
      }
      FUNCCALL(SETUP_XfOrM861(_), scheme_wrong_count_m ((char * ) obj , - 1 , 0 , num_rands , rands , meth_wrap ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (proc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5951 "bc/src/struct.c"
static Scheme_Object * procedure_extract_target (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * v ; 
  int is_method ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM867_COUNT (1)
# define SETUP_XfOrM867(x) SETUP(XfOrM867_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 5956 "bc/src/struct.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-extract-target" , "procedure?" , 0 , argc , argv ) ); 

  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
#   define XfOrM868_COUNT (0+XfOrM867_COUNT)
#   define SETUP_XfOrM868(x) SETUP_XfOrM867(x)

# 5961 "bc/src/struct.c"
    if (scheme_reduced_procedure_struct 
    && (scheme_is_struct_instance (scheme_reduced_procedure_struct , argv [0 ] ) ) )
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

    v = FUNCCALL(SETUP_XfOrM868(_), scheme_extract_struct_procedure (argv [0 ] , - 1 , ((void * ) 0 ) , & is_method ) ); 
    if (v && ! is_method && (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      RET_VALUE_START (v ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int exact_pos_integer (Scheme_Object * o ) 
{
  /* No conversion */

# 5979 "bc/src/struct.c"
  if (((intptr_t ) (o ) ) & 0x1 ) 
    return (((intptr_t ) (o ) ) >> 1 ) > 0 ; 
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
    return ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ; 
  else 
  return 0 ; 
}

static int exact_nneg_integer (Scheme_Object * o ) 
{
  /* No conversion */

# 5989 "bc/src/struct.c"
  if (((intptr_t ) (o ) ) & 0x1 ) 
    return (((intptr_t ) (o ) ) >> 1 ) >= 0 ; 
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
    return ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ; 
  else 
  return 0 ; 
}

Scheme_Object * scheme_make_location (Scheme_Object * src , 
Scheme_Object * line , 
Scheme_Object * col , 
Scheme_Object * pos , 
Scheme_Object * span ) 
{
  Scheme_Object * a [5 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 5, 0)));
# define XfOrM871_COUNT (3)
# define SETUP_XfOrM871(x) SETUP(XfOrM871_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (a ) ; 

# 6004 "bc/src/struct.c"
  a [0 ] = src ; 
  a [1 ] = line ; 
  a [2 ] = col ; 
  a [3 ] = pos ; 
  a [4 ] = span ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM871(_), scheme_make_struct_instance (location_struct , 5 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6012 "bc/src/struct.c"
Scheme_Object * scheme_unsafe_make_location (void ) 
{
  Scheme_Structure * inst ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(inst, 0)));
# define XfOrM872_COUNT (1)
# define SETUP_XfOrM872(x) SETUP(XfOrM872_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 6016 "bc/src/struct.c"
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM872(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((5 ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) ); 

  inst -> so . type = scheme_structure_type ; 
  inst -> stype = (Scheme_Struct_Type * ) location_struct ; 



  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6026 "bc/src/struct.c"
Scheme_Object * scheme_unsafe_make_srcloc (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * srcloc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(srcloc, 1)));
# define XfOrM873_COUNT (2)
# define SETUP_XfOrM873(x) SETUP(XfOrM873_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  srcloc = NULLED_OUT ; 

# 6030 "bc/src/struct.c"
  srcloc = FUNCCALL(SETUP_XfOrM873(_), scheme_unsafe_make_location () ); 

  ((Scheme_Structure * ) srcloc ) -> slots [0 ] = argv [0 ] ; 
  ((Scheme_Structure * ) srcloc ) -> slots [1 ] = argv [1 ] ; 
  ((Scheme_Structure * ) srcloc ) -> slots [2 ] = argv [2 ] ; 
  ((Scheme_Structure * ) srcloc ) -> slots [3 ] = argv [3 ] ; 
  ((Scheme_Structure * ) srcloc ) -> slots [4 ] = argv [4 ] ; 

  RET_VALUE_START (srcloc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6041 "bc/src/struct.c"
int scheme_is_location (Scheme_Object * o ) 
{
  /* No conversion */

# 6043 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  return ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  && scheme_is_struct_instance (location_struct , o ) ) ; 
}

static Scheme_Object * check_location_fields (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM875_COUNT (1)
# define SETUP_XfOrM875(x) SETUP(XfOrM875_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 6052 "bc/src/struct.c"
  if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) && ! FUNCCALL(SETUP_XfOrM875(_), exact_pos_integer (argv [1 ] ) ))
    FUNCCALL(SETUP_XfOrM875(_), scheme_wrong_field_contract (argv [5 ] , "(or/c exact-positive-integer? #f)" , argv [1 ] ) ); 
  if ((! (((argv [2 ] ) ) == (scheme_false ) ) ) && ! FUNCCALL(SETUP_XfOrM875(_), exact_nneg_integer (argv [2 ] ) ))
    FUNCCALL(SETUP_XfOrM875(_), scheme_wrong_field_contract (argv [5 ] , "(or/c exact-nonnegative-integer #f)" , argv [2 ] ) ); 
  if ((! (((argv [3 ] ) ) == (scheme_false ) ) ) && ! FUNCCALL(SETUP_XfOrM875(_), exact_pos_integer (argv [3 ] ) ))
    FUNCCALL(SETUP_XfOrM875(_), scheme_wrong_field_contract (argv [5 ] , "(or/c exact-positive-integer? #f)" , argv [3 ] ) ); 
  if ((! (((argv [4 ] ) ) == (scheme_false ) ) ) && ! FUNCCALL(SETUP_XfOrM875(_), exact_nneg_integer (argv [4 ] ) ))
    FUNCCALL(SETUP_XfOrM875(_), scheme_wrong_field_contract (argv [5 ] , "(or/c exact-nonnegative-integer? #f)" , argv [4 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (5 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * check_arity_at_least_fields (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6070 "bc/src/struct.c"
  Scheme_Object * a ; 

  a = argv [0 ] ; 
  if (((intptr_t ) (a ) ) & 0x1 )  {
    if ((((intptr_t ) (a ) ) >> 1 ) >= 0 )
      return a ; 
  }

# 6076 "bc/src/struct.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
    if ((& ((Scheme_Bignum * ) a ) -> iso ) -> so . keyex & 0x1 ) 
      return a ; 
  }

  scheme_wrong_field_contract (argv [1 ] , "exact-nonnegative-integer?" , a ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * check_date_fields (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * a , * args [10 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(argv, 1), PUSHARRAY(args, 10, 2)));
# define XfOrM879_COUNT (5)
# define SETUP_XfOrM879(x) SETUP(XfOrM879_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 
  NULL_OUT_ARRAY (args ) ; 

# 6089 "bc/src/struct.c"
  a = argv [0 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 60 ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 60)" , a ) ); 
  a = argv [1 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 59 ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 59)" , a ) ); 
  a = argv [2 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 23 ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 23)" , a ) ); 
  a = argv [3 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 1 ) || ((((intptr_t ) (a ) ) >> 1 ) > 31 ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 1 31)" , a ) ); 
  a = argv [4 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 1 ) || ((((intptr_t ) (a ) ) >> 1 ) > 12 ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 1 12)" , a ) ); 
  a = argv [5 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "exact-integer?" , a ) ); 
  a = argv [6 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 6 ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 6)" , a ) ); 
  a = argv [7 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 365 ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 365)" , a ) ); 
  a = argv [9 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL(SETUP_XfOrM879(_), scheme_wrong_field_contract (argv [10 ] , "exact-integer?" , a ) ); 
  (

  memcpy (args , argv , sizeof (Scheme_Object * ) * 10 ) ) ; 
  args [8 ] = ((! (((argv [8 ] ) ) == (scheme_false ) ) ) ? scheme_true : scheme_false ) ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM879(_), scheme_values (10 , args ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6124 "bc/src/struct.c"
static Scheme_Object * check_date_star_fields (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * args [12 ] , * a ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(argv, 1), PUSHARRAY(args, 12, 2)));
# define XfOrM880_COUNT (5)
# define SETUP_XfOrM880(x) SETUP(XfOrM880_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (args ) ; 
  a = NULLED_OUT ; 

# 6128 "bc/src/struct.c"
  a = argv [10 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) 
  || ((((intptr_t ) (a ) ) >> 1 ) > 999999999 ) )
    FUNCCALL(SETUP_XfOrM880(_), scheme_wrong_field_contract (argv [12 ] , "(integer-in 0 999999999)" , a ) ); 

  a = argv [11 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL(SETUP_XfOrM880(_), scheme_wrong_field_contract (argv [12 ] , "string?" , a ) ); 
  (
  memcpy (args , argv , sizeof (Scheme_Object * ) * 12 ) ) ; 
  if (! (((Scheme_Inclhash_Object * ) (argv [11 ] ) ) -> so . keyex & 0x1 ) ) {
#   define XfOrM881_COUNT (0+XfOrM880_COUNT)
#   define SETUP_XfOrM881(x) SETUP_XfOrM880(x)

# 6139 "bc/src/struct.c"
    a = argv [11 ] ; 
    a = FUNCCALL(SETUP_XfOrM881(_), scheme_make_immutable_sized_char_string ((((Scheme_Simple_Object * ) (a ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (a ) ) -> u . char_str_val . tag_val ) , 1 ) )

    ; 
    args [11 ] = a ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM880(_), scheme_values (12 , args ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6151 "bc/src/struct.c"
static Scheme_Object * exn_source_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6153 "bc/src/struct.c"
  return (scheme_struct_type_property_ref (scheme_source_property , argv [0 ] ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * exn_source_get (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6160 "bc/src/struct.c"
  Scheme_Object * v ; 

  v = scheme_struct_type_property_ref (scheme_source_property , argv [0 ] ) ; 
  if (! v )
    scheme_wrong_contract ("exn:srclocs-accessor" , "exn:srclocs?" , 0 , argc , argv ) ; 

  return v ; 
}

static Scheme_Object * check_exn_source_property_value_ok (int argc , Scheme_Object * argv [] ) 

{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM884_COUNT (1)
# define SETUP_XfOrM884(x) SETUP(XfOrM884_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM884(_), scheme_check_proc_arity ("guard-for-prop:exn:srclocs" , 1 , 0 , argc , argv ) )
# 6172 "bc/src/struct.c"
  ; 

  RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6179 "bc/src/struct.c"
static Scheme_Object * do_chaperone_struct (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 

{
  Scheme_Chaperone * px ; 
  Scheme_Struct_Type * stype , * st ; 
  Scheme_Object * val = argv [0 ] , * proc , * props = ((void * ) 0 ) ; 
  Scheme_Object * redirects , * prop , * si_chaperone = scheme_false ; 
  Scheme_Object * a [1 ] , * inspector , * getter_positions = scheme_null ; 
  int i , offset , arity , non_applicable_op , repeat_op ; 
  const char * kind ; 
  Scheme_Hash_Tree * red_props = ((void * ) 0 ) , * empty_red_props = ((void * ) 0 ) , * setter_positions = ((void * ) 0 ) ; 
  intptr_t field_pos ; 
  int empty_si_chaperone = 0 , * empty_redirects = ((void * ) 0 ) , has_redirect = 0 , witnessed = 0 ; 
  Scheme_Config * __funcarg153 = NULLED_OUT ; 
  Scheme_Object * __funcarg152 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(21);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(redirects, 1), PUSH(kind, 2), PUSH(st, 3), PUSH(px, 4), PUSH(prop, 5), PUSH(inspector, 6), PUSH(argv, 7), PUSH(props, 8), PUSH(getter_positions, 9), PUSH(empty_red_props, 10), PUSHARRAY(a, 1, 11), PUSH(si_chaperone, 14), PUSH(val, 15), PUSH(empty_redirects, 16), PUSH(proc, 17), PUSH(red_props, 18), PUSH(setter_positions, 19), PUSH(stype, 20)));
# define XfOrM885_COUNT (21)
# define SETUP_XfOrM885(x) SETUP(XfOrM885_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  stype = NULLED_OUT ; 
  st = NULLED_OUT ; 
  proc = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  prop = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  inspector = NULLED_OUT ; 
  kind = NULLED_OUT ; 

# 6193 "bc/src/struct.c"
  if (argc == 1 )

# 6193 "bc/src/struct.c"
  RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 

  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    props = ((Scheme_Chaperone * ) val ) -> props ; 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
#   define XfOrM960_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM960(x) SETUP_XfOrM885(x)

# 6201 "bc/src/struct.c"
    stype = ((Scheme_Structure * ) val ) -> stype ; 

    redirects = FUNCCALL(SETUP_XfOrM960(_), scheme_make_vector (2 + 2 * stype -> num_slots , scheme_false ) ); 
  }

# 6204 "bc/src/struct.c"
  else {
    stype = ((void * ) 0 ) ; 
    redirects = ((void * ) 0 ) ; 
  }

  if (is_impersonator )
    inspector = (__funcarg153 = FUNCCALL(SETUP_XfOrM885(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg153 , MZCONFIG_INSPECTOR ) )) ; 
  else 
  inspector = ((void * ) 0 ) ; 

  i = 1 ; 

  if ((i < argc ) && (((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
  || ((((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [i ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [i ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) ) ) ) {
#   define XfOrM957_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM957(x) SETUP_XfOrM885(x)

# 6219 "bc/src/struct.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ! (scheme_is_struct_instance (((((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    ? (((Scheme_Chaperone * ) argv [i ] ) -> val ) 
    : argv [i ] ) , 
    val ) ) ) {
#     define XfOrM958_COUNT (0+XfOrM957_COUNT)
#     define SETUP_XfOrM958(x) SETUP_XfOrM957(x)
      FUNCCALL(SETUP_XfOrM958(_), scheme_contract_error (name , "given value is not an instance of the given structure type" , "struct type" , 1 , argv [i ] , "value" , 1 , argv [0 ] , ((void * ) 0 ) ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    i ++ ; 
    witnessed = 1 ; 
  }

  for (; i < argc ; i ++ ) {
#   define XfOrM926_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM926(x) SETUP_XfOrM885(x)

# 6235 "bc/src/struct.c"
    proc = argv [i ] ; 

    if ((i > 1 ) && ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) ) {
#     define XfOrM956_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM956(x) SETUP_XfOrM926(x)

# 6238 "bc/src/struct.c"
      props = FUNCCALL(SETUP_XfOrM956(_), scheme_parse_chaperone_props (name , i , argc , argv ) ); 
      break ; 
    }

    a [0 ] = proc ; 
    if (((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 6243 "bc/src/struct.c"
    proc = (((Scheme_Chaperone * ) proc ) -> val ) ; 
    if (! (((FUNCCALL(SETUP_XfOrM926(_), struct_setter_p (1 , a ) )) ) == (scheme_false ) ) )  {
      kind = "mutator" ; 
      if (stype )
        offset = stype -> num_slots ; 
      else 
      offset = 0 ; 
      witnessed = 1 ; 
    }

# 6251 "bc/src/struct.c"
    else if (! (((FUNCCALL(SETUP_XfOrM926(_), struct_getter_p (1 , a ) )) ) == (scheme_false ) ) )  {
      kind = "accessor" ; 
      offset = 0 ; 
      witnessed = 1 ; 
    }

# 6255 "bc/src/struct.c"
    else if (! (((FUNCCALL(SETUP_XfOrM926(_), struct_prop_getter_p (1 , a ) )) ) == (scheme_false ) ) )  {
      kind = "struct-type property accessor" ; 
      offset = - 1 ; 
      witnessed = 1 ; 
    }

# 6259 "bc/src/struct.c"
    else if (! is_impersonator && ((proc ) == (struct_info_proc ) ) ) {
      kind = "struct-info" ; 
      offset = - 2 ; 
    }

# 6262 "bc/src/struct.c"
    else {
#     define XfOrM951_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM951(x) SETUP_XfOrM926(x)
      FUNCCALL(SETUP_XfOrM951(_), scheme_wrong_contract (name , ((i == 1 ) ? ("(or/c " "struct-type?\n      " "struct-accessor-procedure?\n" "      struct-mutator-procedure?\n" "      struct-type-property-accessor-procedure?\n" "      (one-of/c struct-info))" ) : ("(or/c " "" "struct-accessor-procedure?\n" "      struct-mutator-procedure?\n" "      struct-type-property-accessor-procedure?\n" "      (one-of/c struct-info))" ) ) , i , argc , argv ) )







      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    non_applicable_op = 0 ; 
    repeat_op = 0 ; 

    if (offset == - 2 ) {
#     define XfOrM950_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM950(x) SETUP_XfOrM926(x)

# 6281 "bc/src/struct.c"
      if ((! (((si_chaperone ) ) == (scheme_false ) ) ) || empty_si_chaperone )
        FUNCCALL(SETUP_XfOrM950(_), scheme_contract_error (name , "struct-info procedure supplied a second time" , "procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )


      ; 
      st = ((void * ) 0 ) ; 
      field_pos = 0 ; 
      prop = ((void * ) 0 ) ; 
      arity = 2 ; 
    }

# 6290 "bc/src/struct.c"
    else if (offset == - 1 ) {
#     define XfOrM947_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM947(x) SETUP_XfOrM926(x)

# 6291 "bc/src/struct.c"
      prop = ((Scheme_Primitive_Closure * ) proc ) -> val [0 ] ; 
      st = ((void * ) 0 ) ; 
      field_pos = 0 ; 

      if (is_impersonator 
      && ! ((Scheme_Struct_Property * ) prop ) -> can_impersonate )
        FUNCCALL(SETUP_XfOrM947(_), scheme_contract_error (name , "operation cannot be impersonated" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )



      ; 

      if (! (scheme_struct_type_property_ref (prop , argv [0 ] ) ) ) {
        non_applicable_op = 1 ; 
        arity = 0 ; 
      }

# 6306 "bc/src/struct.c"
      else {
#       define XfOrM948_COUNT (0+XfOrM947_COUNT)
#       define SETUP_XfOrM948(x) SETUP_XfOrM947(x)

# 6307 "bc/src/struct.c"
        if (red_props && FUNCCALL(SETUP_XfOrM948(_), scheme_hash_tree_get (red_props , prop ) ))
          repeat_op = 1 ; 
        if (empty_red_props && FUNCCALL(SETUP_XfOrM948(_), scheme_hash_tree_get (empty_red_props , prop ) ))
          repeat_op = 1 ; 

        arity = 2 ; 
      }
    }

# 6314 "bc/src/struct.c"
    else {
#     define XfOrM939_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM939(x) SETUP_XfOrM926(x)

# 6315 "bc/src/struct.c"
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) proc ) -> val [0 ] ; 
      field_pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) proc ) -> val [1 ] ) ) >> 1 ) ; 
      prop = ((void * ) 0 ) ; 

      if (! (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ! (scheme_is_struct_instance ((Scheme_Object * ) st , val ) ) )
        non_applicable_op = 1 ; 
      else if (! ((((((Scheme_Vector * ) (redirects ) ) -> els ) [2 + offset + field_pos ] ) ) == (scheme_false ) ) ) 
        repeat_op = 1 ; 
      else if (empty_redirects && empty_redirects [offset + field_pos ] )
        repeat_op = 1 ; 
      else {
#       define XfOrM940_COUNT (0+XfOrM939_COUNT)
#       define SETUP_XfOrM940(x) SETUP_XfOrM939(x)

# 6326 "bc/src/struct.c"
        if (is_impersonator ) {
          intptr_t loc_field_pos ; 
#         define XfOrM941_COUNT (0+XfOrM940_COUNT)
#         define SETUP_XfOrM941(x) SETUP_XfOrM940(x)

# 6328 "bc/src/struct.c"
          loc_field_pos = field_pos - (st -> name_pos 
          ? st -> parent_types [st -> name_pos - 1 ] -> num_slots 
          : 0 ) ; 

          if (st -> immutables ) {
#           define XfOrM946_COUNT (0+XfOrM941_COUNT)
#           define SETUP_XfOrM946(x) SETUP_XfOrM941(x)

# 6333 "bc/src/struct.c"
            if (st -> immutables [loc_field_pos ] )
              FUNCCALL(SETUP_XfOrM946(_), scheme_contract_error (name , "cannot replace operation for an immutable field" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )



            ; 
          }
          if (! offset ) {
#           define XfOrM944_COUNT (0+XfOrM941_COUNT)
#           define SETUP_XfOrM944(x) SETUP_XfOrM941(x)

            if (! FUNCCALL(SETUP_XfOrM944(_), scheme_inspector_sees_part (argv [0 ] , inspector , field_pos ) )) {
#             define XfOrM945_COUNT (0+XfOrM944_COUNT)
#             define SETUP_XfOrM945(x) SETUP_XfOrM944(x)

# 6345 "bc/src/struct.c"
              getter_positions = (__funcarg152 = FUNCCALL(SETUP_XfOrM945(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (field_pos ) ) ) << 1 ) | 0x1 ) ) , a [0 ] ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg152 , getter_positions ) )) 
              ; 
            }
          }

# 6348 "bc/src/struct.c"
          else {
#           define XfOrM942_COUNT (0+XfOrM941_COUNT)
#           define SETUP_XfOrM942(x) SETUP_XfOrM941(x)

# 6349 "bc/src/struct.c"
            if (! FUNCCALL(SETUP_XfOrM942(_), scheme_inspector_sees_part (argv [0 ] , inspector , field_pos ) )) {
#             define XfOrM943_COUNT (0+XfOrM942_COUNT)
#             define SETUP_XfOrM943(x) SETUP_XfOrM942(x)

# 6350 "bc/src/struct.c"
              if (! setter_positions )
                setter_positions = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
              setter_positions = FUNCCALL(SETUP_XfOrM943(_), scheme_hash_tree_set (setter_positions , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (field_pos ) ) ) << 1 ) | 0x1 ) ) , scheme_true ) ); 
            }
          }
        }
      }

      arity = 2 ; 
    }

    if (repeat_op )
      FUNCCALL(SETUP_XfOrM926(_), scheme_contract_error (name , "given operation accesses the same value as a previous operation argument" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )



    ; 

    if (non_applicable_op )
      FUNCCALL(SETUP_XfOrM926(_), scheme_contract_error (name , "operation does not apply to given value" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , "value" , 1 , argv [0 ] , ((void * ) 0 ) ) )




    ; 

    i ++ ; 
    if (i >= argc )
      FUNCCALL(SETUP_XfOrM926(_), scheme_contract_error (name , "missing redirection procedure after operation" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )



    ; 

    proc = argv [i ] ; 
    if ((! (((proc ) ) == (scheme_false ) ) ) 
    && ! FUNCCALL(SETUP_XfOrM926(_), scheme_check_proc_arity (((void * ) 0 ) , arity , i , argc , argv ) )) {
      char buf [64 ] ; 
#     define XfOrM938_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM938(x) SETUP_XfOrM926(x)
      (
# 6388 "bc/src/struct.c"
      sprintf (buf , "(or/c (procedure-arity-includes/c %d) #f)" , arity ) ) ; 
      FUNCCALL(SETUP_XfOrM938(_), scheme_contract_error (name , "operation's redirection procedure does not match the expected arity" , "given" , 1 , proc , "expected" , 0 , buf , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )





      ; 
    }



    if ((((Scheme_Type ) (((((intptr_t ) (a [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (! (((proc ) ) == (scheme_false ) ) ) ) {
      Scheme_Chaperone * ppx = (Scheme_Chaperone * ) a [0 ] ; 
#     define XfOrM936_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM936(x) SETUP_XfOrM926(x)

# 6402 "bc/src/struct.c"
      if (! is_impersonator 
      && ((& (ppx ) -> iso ) -> so . keyex & 0x1 ) ) {
#       define XfOrM937_COUNT (0+XfOrM936_COUNT)
#       define SETUP_XfOrM937(x) SETUP_XfOrM936(x)
        FUNCCALL(SETUP_XfOrM937(_), scheme_contract_error (name , "impersonated operation cannot be used to create a chaperone" , "operation" , 1 , a [0 ] , ((void * ) 0 ) ) )
        ; 
      }
      proc = FUNCCALL(SETUP_XfOrM936(_), scheme_make_pair (a [0 ] , proc ) ); 
    }

    if (prop ) {
#     define XfOrM933_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM933(x) SETUP_XfOrM926(x)

# 6413 "bc/src/struct.c"
      if (! (((proc ) ) == (scheme_false ) ) )  {
#       define XfOrM935_COUNT (0+XfOrM933_COUNT)
#       define SETUP_XfOrM935(x) SETUP_XfOrM933(x)

# 6414 "bc/src/struct.c"
        if (! red_props )
          red_props = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
        red_props = FUNCCALL(SETUP_XfOrM935(_), scheme_hash_tree_set (red_props , prop , proc ) ); 
        has_redirect = 1 ; 
      }

# 6418 "bc/src/struct.c"
      else {
#       define XfOrM934_COUNT (0+XfOrM933_COUNT)
#       define SETUP_XfOrM934(x) SETUP_XfOrM933(x)

# 6419 "bc/src/struct.c"
        if (! empty_red_props )
          empty_red_props = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
        empty_red_props = FUNCCALL(SETUP_XfOrM934(_), scheme_hash_tree_set (empty_red_props , prop , proc ) ); 
      }
    }

# 6423 "bc/src/struct.c"
    else if (st ) {
#     define XfOrM929_COUNT (0+XfOrM926_COUNT)
#     define SETUP_XfOrM929(x) SETUP_XfOrM926(x)

# 6424 "bc/src/struct.c"
      if (! (((proc ) ) == (scheme_false ) ) )  {
        (((Scheme_Vector * ) (redirects ) ) -> els ) [2 + offset + field_pos ] = proc ; 
        has_redirect = 1 ; 
      }

# 6427 "bc/src/struct.c"
      else {
#       define XfOrM930_COUNT (0+XfOrM929_COUNT)
#       define SETUP_XfOrM930(x) SETUP_XfOrM929(x)

# 6428 "bc/src/struct.c"
        if (! empty_redirects ) {
#         define XfOrM931_COUNT (0+XfOrM930_COUNT)
#         define SETUP_XfOrM931(x) SETUP_XfOrM930(x)

# 6429 "bc/src/struct.c"
          empty_redirects = ((int * ) FUNCCALL(SETUP_XfOrM931(_), GC_malloc_atomic (sizeof (int ) * (2 * stype -> num_slots ) ) )) ; 
          (memset (empty_redirects , 0 , sizeof (int ) * 2 * stype -> num_slots ) ) ; 
        }
        empty_redirects [offset + field_pos ] = 1 ; 
      }
    }

# 6434 "bc/src/struct.c"
    else {
      if (! (((proc ) ) == (scheme_false ) ) )  {
        si_chaperone = proc ; 
        has_redirect = 1 ; 
      }

# 6438 "bc/src/struct.c"
      else 
      empty_si_chaperone = 1 ; 
    }
  }

  if (is_impersonator ) {
#   define XfOrM890_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM890(x) SETUP_XfOrM885(x)
    getter_positions = FUNCCALL(SETUP_XfOrM890(_), scheme_reverse (getter_positions ) ); 
    while (! ((getter_positions ) == (scheme_null ) ) ) {
#     define XfOrM893_COUNT (0+XfOrM890_COUNT)
#     define SETUP_XfOrM893(x) SETUP_XfOrM890(x)

# 6448 "bc/src/struct.c"
      prop = (((Scheme_Simple_Object * ) (getter_positions ) ) -> u . pair_val . car ) ; 
      if (! setter_positions 
      || ! FUNCCALL(SETUP_XfOrM893(_), scheme_hash_tree_get (setter_positions , (((Scheme_Simple_Object * ) (prop ) ) -> u . pair_val . car ) ) )) {
#       define XfOrM894_COUNT (0+XfOrM893_COUNT)
#       define SETUP_XfOrM894(x) SETUP_XfOrM893(x)
        FUNCCALL(SETUP_XfOrM894(_), scheme_contract_error (name , "accessor redirection for a non-transparent field requires a mutator redirection" , "explanation" , 0 , "a mutator redirection acts as a witness that access is allowed" , "accessor" , 1 , (((Scheme_Simple_Object * ) (prop ) ) -> u . pair_val . cdr ) , "value to impersonate" , 1 , argv [0 ] , ((void * ) 0 ) ) )


        ; 
      }
      getter_positions = (((Scheme_Simple_Object * ) (getter_positions ) ) -> u . pair_val . cdr ) ; 
    }
  }

  if (! has_redirect && ! props )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 

  if (! witnessed ) {
#   define XfOrM889_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM889(x) SETUP_XfOrM885(x)
    FUNCCALL(SETUP_XfOrM889(_), scheme_contract_error (name , (is_impersonator ? "cannot impersonate value as a structure without a witness" : "cannot chaperone value as a structure without a witness" ) , "explanation" , 0 , ("a structure type, accessor, or mutator acts as a witness\n" "   that the given value's representation can be chaperoned or impersonated" ) , "given value" , 1 , argv [0 ] , ((void * ) 0 ) ) )




    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if ((((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && ((Scheme_Structure * ) val ) -> stype -> more_flags & 0x4 ) {
#   define XfOrM888_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM888(x) SETUP_XfOrM885(x)
    FUNCCALL(SETUP_XfOrM888(_), scheme_contract_error (name , (is_impersonator ? "cannot impersonate instance of an authentic structure type" : "cannot chaperone instance of an authentic structure type" ) , "given value" , 1 , val , ((void * ) 0 ) ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (! redirects ) {
#   define XfOrM887_COUNT (0+XfOrM885_COUNT)
#   define SETUP_XfOrM887(x) SETUP_XfOrM885(x)

# 6489 "bc/src/struct.c"
    redirects = FUNCCALL(SETUP_XfOrM887(_), scheme_make_vector (1 , ((void * ) 0 ) ) ); 
  }

# 6490 "bc/src/struct.c"
  else {
    (((Scheme_Vector * ) (redirects ) ) -> els ) [1 ] = si_chaperone ; 
  }

  (((Scheme_Vector * ) (redirects ) ) -> els ) [0 ] = (red_props ? (Scheme_Object * ) red_props : scheme_false ) ; 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM885(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  if (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
    px -> iso . so . type = scheme_proc_chaperone_type ; 
  else 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6512 "bc/src/struct.c"
static Scheme_Object * chaperone_struct (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6514 "bc/src/struct.c"
  return do_chaperone_struct ("chaperone-struct" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_struct (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6519 "bc/src/struct.c"
  return do_chaperone_struct ("impersonate-struct" , 1 , argc , argv ) ; 
}


Scheme_Object * scheme_chaperone_not_undefined (Scheme_Object * orig_val ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val , * redirects ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(redirects, 1), PUSH(props, 2), PUSH(px, 3), PUSH(orig_val, 4)));
# define XfOrM964_COUNT (5)
# define SETUP_XfOrM964(x) SETUP(XfOrM964_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  val = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 6529 "bc/src/struct.c"
  val = orig_val ; 

  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    props = ((Scheme_Chaperone * ) val ) -> props ; 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 
  }

# 6534 "bc/src/struct.c"
  else 
  props = ((void * ) 0 ) ; 

  redirects = FUNCCALL(SETUP_XfOrM964(_), scheme_make_vector (2 , scheme_false ) ); 

  (((Scheme_Vector * ) (redirects ) ) -> els ) [0 ] = scheme_false ; 
  (((Scheme_Vector * ) (redirects ) ) -> els ) [1 ] = scheme_undefined ; 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM964(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  if (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
    px -> iso . so . type = scheme_proc_chaperone_type ; 
  else 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = orig_val ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6556 "bc/src/struct.c"
static Scheme_Object * do_chaperone_struct_type (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects ; 
  Scheme_Object * props ; 
  int arity ; 
  Scheme_Object * __funcarg154 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(redirects, 1), PUSH(val, 2), PUSH(argv, 3), PUSH(props, 4), PUSH(px, 5)));
# define XfOrM966_COUNT (6)
# define SETUP_XfOrM966(x) SETUP(XfOrM966_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 6564 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "struct-type?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM966(_), scheme_check_proc_arity (name , 8 , 1 , argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 1 , 2 , argc , argv ) ); 
  if (! (! (((intptr_t ) (argv [3 ] ) ) & 0x1 ) && ((((argv [3 ] ) -> type ) >= scheme_prim_type ) && (((argv [3 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 3 , argc , argv ) ); 

  arity = ((Scheme_Struct_Type * ) val ) -> num_islots + 1 ; 
  if (! FUNCCALL(SETUP_XfOrM966(_), scheme_check_proc_arity (((void * ) 0 ) , arity , 3 , argc , argv ) ))
    FUNCCALL_EMPTY(scheme_contract_error (name , "guard procedure does not accept correct number of arguments" , "explanation" , 0 , "should accept one more than the number of constructor arguments" , "guard procedure" , 1 , argv [0 ] , "expected arity" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (arity ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )




  ; 

  props = FUNCCALL(SETUP_XfOrM966(_), scheme_parse_chaperone_props (name , 4 , argc , argv ) ); 

  redirects = (__funcarg154 = FUNCCALL(SETUP_XfOrM966(_), scheme_make_pair (argv [2 ] , argv [3 ] ) ), FUNCCALL_AGAIN(scheme_make_pair (argv [1 ] , __funcarg154 ) )) 

  ; 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM966(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> props = props ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6602 "bc/src/struct.c"
static Scheme_Object * chaperone_struct_type (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6604 "bc/src/struct.c"
  return do_chaperone_struct_type ("chaperone-struct-type" , 0 , argc , argv ) ; 
}



Scheme_Object * scheme_parse_chaperone_props (const char * who , int start_at , int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * v , * props ; 
  int pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(v, 1), PUSH(props, 2)));
# define XfOrM968_COUNT (3)
# define SETUP_XfOrM968(x) SETUP(XfOrM968_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 6614 "bc/src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    props = ((Scheme_Chaperone * ) argv [0 ] ) -> props ; 
  else 
  props = ((void * ) 0 ) ; 

  if (start_at < argc ) {
#   define XfOrM969_COUNT (0+XfOrM968_COUNT)
#   define SETUP_XfOrM969(x) SETUP_XfOrM968(x)

# 6621 "bc/src/struct.c"
    for (pos = start_at ; pos < argc ; pos += 2 ) {
#     define XfOrM1004_COUNT (0+XfOrM969_COUNT)
#     define SETUP_XfOrM1004(x) SETUP_XfOrM969(x)

# 6622 "bc/src/struct.c"
      v = argv [pos ] ; 
      if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) )
        FUNCCALL_EMPTY(scheme_wrong_contract (who , "impersonator-property?" , pos , argc , argv ) ); 

      if (pos + 1 >= argc )
        FUNCCALL_EMPTY(scheme_contract_error (who , "missing value after chaperone property" , "chaperone property" , 1 , v , ((void * ) 0 ) ) )


      ; 
    }


    if (props && ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
    && (((argc - start_at ) + (((Scheme_Vector * ) (props ) ) -> size ) ) > (2 * 5 ) ) ) {

      Scheme_Hash_Tree * ht ; 
      int i ; 
      BLOCK_SETUP((PUSH(ht, 0+XfOrM969_COUNT)));
#     define XfOrM1000_COUNT (1+XfOrM969_COUNT)
#     define SETUP_XfOrM1000(x) SETUP(XfOrM1000_COUNT)
      ht = NULLED_OUT ; 

# 6639 "bc/src/struct.c"
      ht = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
      for (i = (((Scheme_Vector * ) (props ) ) -> size ) ; i > 0 ; ) {
#       define XfOrM1002_COUNT (0+XfOrM1000_COUNT)
#       define SETUP_XfOrM1002(x) SETUP_XfOrM1000(x)

# 6641 "bc/src/struct.c"
        i -= 2 ; 
        ht = FUNCCALL(SETUP_XfOrM1002(_), scheme_hash_tree_set (ht , (((Scheme_Vector * ) (props ) ) -> els ) [i ] , (((Scheme_Vector * ) (props ) ) -> els ) [i + 1 ] ) ); 
      }
      props = (Scheme_Object * ) ht ; 
    }

    if (! props || ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {

      int count = 0 , i , len = (props ? (((Scheme_Vector * ) (props ) ) -> size ) : 0 ) ; 
#     define XfOrM973_COUNT (0+XfOrM969_COUNT)
#     define SETUP_XfOrM973(x) SETUP_XfOrM969(x)

# 6651 "bc/src/struct.c"
      for (pos = start_at ; pos < argc ; pos += 2 ) {
        v = argv [pos ] ; 
        if (props ) {
          for (i = 0 ; i < len ; i += 2 ) {
            if ((v ) == ((((Scheme_Vector * ) (props ) ) -> els ) [i ] ) ) 
              break ; 
          }
        }

# 6658 "bc/src/struct.c"
        else 
        i = 0 ; 
        if (i >= len ) {
          for (i = start_at ; i < pos ; i += 2 ) {
            if ((v ) == (argv [i ] ) ) 
              break ; 
          }
          if (i >= pos )
            count ++ ; 
        }
      }

      if (props ) {

        Scheme_Object * old_props = props ; 
        BLOCK_SETUP((PUSH(old_props, 0+XfOrM973_COUNT)));
#       define XfOrM985_COUNT (1+XfOrM973_COUNT)
#       define SETUP_XfOrM985(x) SETUP(XfOrM985_COUNT)

# 6673 "bc/src/struct.c"
        props = FUNCCALL(SETUP_XfOrM985(_), scheme_make_vector ((((Scheme_Vector * ) (old_props ) ) -> size ) + 2 * count , ((void * ) 0 ) ) ); 
        (memcpy ((((Scheme_Vector * ) (props ) ) -> els ) , (((Scheme_Vector * ) (old_props ) ) -> els ) , sizeof (Scheme_Object * ) * (((Scheme_Vector * ) (old_props ) ) -> size ) ) ) ; 
      }

# 6675 "bc/src/struct.c"
      else {
#       define XfOrM984_COUNT (0+XfOrM973_COUNT)
#       define SETUP_XfOrM984(x) SETUP_XfOrM973(x)

# 6676 "bc/src/struct.c"
        props = FUNCCALL(SETUP_XfOrM984(_), scheme_make_vector (2 * count , ((void * ) 0 ) ) ); 
      }
      len = (((Scheme_Vector * ) (props ) ) -> size ) ; 


      for (pos = start_at ; pos < argc ; pos += 2 ) {
        v = argv [pos ] ; 
        for (i = 0 ; i < len ; i += 2 ) {
          if (! (((Scheme_Vector * ) (props ) ) -> els ) [i ] || ((v ) == ((((Scheme_Vector * ) (props ) ) -> els ) [i ] ) ) ) {
            (((Scheme_Vector * ) (props ) ) -> els ) [i ] = v ; 
            (((Scheme_Vector * ) (props ) ) -> els ) [i + 1 ] = argv [pos + 1 ] ; 
            break ; 
          }
        }
      }
    }

# 6691 "bc/src/struct.c"
    else {
#     define XfOrM970_COUNT (0+XfOrM969_COUNT)
#     define SETUP_XfOrM970(x) SETUP_XfOrM969(x)

# 6693 "bc/src/struct.c"
      for (pos = start_at ; pos < argc ; pos += 2 ) {
#       define XfOrM972_COUNT (0+XfOrM970_COUNT)
#       define SETUP_XfOrM972(x) SETUP_XfOrM970(x)

# 6694 "bc/src/struct.c"
        props = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM972(_), scheme_hash_tree_set ((Scheme_Hash_Tree * ) props , argv [pos ] , argv [pos + 1 ] ) ); 
      }
    }
  }

  RET_VALUE_START (props ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4 "bc/src/mzmark_struct.inc"
static int mark_serialized_struct_val_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int mark_serialized_struct_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Serialized_Structure * s = (Scheme_Serialized_Structure * ) p ; 
  int num_slots = s -> num_slots ; 

  int i ; 

  GC_mark2 (& (s -> prefab_key ) , gc ) ; 

  for (i = num_slots ; i -- ; ) 
  GC_mark2 (& (s -> slots [i ] ) , gc ) ; 


  return 0 ; 
}







static int mark_serialized_struct_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Serialized_Structure * s = (Scheme_Serialized_Structure * ) p ; 
  int num_slots = s -> num_slots ; 

  int i ; 

  GC_fixup2 (& (s -> prefab_key ) , gc ) ; 

  for (i = num_slots ; i -- ; ) 
  GC_fixup2 (& (s -> slots [i ] ) , gc ) ; 


  return 0 ; 
}

# 65 "bc/src/mzmark_struct.inc"
static int mark_struct_val_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int mark_struct_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Structure * s = (Scheme_Structure * ) p ; 
  int num_slots = ((Scheme_Struct_Type * ) GC_resolve2 (s -> stype , gc ) ) -> num_slots ; 

  int i ; 

  GC_mark2 (& (s -> stype ) , gc ) ; 

  for (i = num_slots ; i -- ; ) 
  GC_mark2 (& (s -> slots [i ] ) , gc ) ; 


  return 0 ; 
}







static int mark_struct_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Structure * s = (Scheme_Structure * ) p ; 
  int num_slots = ((Scheme_Struct_Type * ) GC_resolve2 (s -> stype , gc ) ) -> num_slots ; 

  int i ; 

  GC_fixup2 (& (s -> stype ) , gc ) ; 

  for (i = num_slots ; i -- ; ) 
  GC_fixup2 (& (s -> slots [i ] ) , gc ) ; 


  return 0 ; 
}

# 125 "bc/src/mzmark_struct.inc"
static int mark_struct_type_val_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int mark_struct_type_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Struct_Type * t = (Scheme_Struct_Type * ) p ; 

  int i ; 
  for (i = t -> name_pos + 1 ; i -- ; ) {
    GC_mark2 (& (t -> parent_types [i ] ) , gc ) ; 
  }
  GC_mark2 (& (t -> name ) , gc ) ; 
  GC_mark2 (& (t -> inspector ) , gc ) ; 
  GC_mark2 (& (t -> accessor ) , gc ) ; 
  GC_mark2 (& (t -> mutator ) , gc ) ; 
  GC_mark2 (& (t -> prefab_key ) , gc ) ; 
  GC_mark2 (& (t -> uninit_val ) , gc ) ; 
  GC_mark2 (& (t -> props ) , gc ) ; 
  GC_mark2 (& (t -> proc_attr ) , gc ) ; 
  GC_mark2 (& (t -> guard ) , gc ) ; 
  GC_mark2 (& (t -> immutables ) , gc ) ; 


  return 0 ; 
}








static int mark_struct_type_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Struct_Type * t = (Scheme_Struct_Type * ) p ; 

  int i ; 
  for (i = t -> name_pos + 1 ; i -- ; ) {
    GC_fixup2 (& (t -> parent_types [i ] ) , gc ) ; 
  }
  GC_fixup2 (& (t -> name ) , gc ) ; 
  GC_fixup2 (& (t -> inspector ) , gc ) ; 
  GC_fixup2 (& (t -> accessor ) , gc ) ; 
  GC_fixup2 (& (t -> mutator ) , gc ) ; 
  GC_fixup2 (& (t -> prefab_key ) , gc ) ; 
  GC_fixup2 (& (t -> uninit_val ) , gc ) ; 
  GC_fixup2 (& (t -> props ) , gc ) ; 
  GC_fixup2 (& (t -> proc_attr ) , gc ) ; 
  GC_fixup2 (& (t -> guard ) , gc ) ; 
  GC_fixup2 (& (t -> immutables ) , gc ) ; 


  return 0 ; 
}

# 201 "bc/src/mzmark_struct.inc"
static int mark_struct_property_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_struct_property_MARK (void * p , struct NewGC * gc ) {

  Scheme_Struct_Property * i = (Scheme_Struct_Property * ) p ; 
  GC_mark2 (& (i -> name ) , gc ) ; 
  GC_mark2 (& (i -> guard ) , gc ) ; 
  GC_mark2 (& (i -> supers ) , gc ) ; 
  GC_mark2 (& (i -> contract_name ) , gc ) ; 
  GC_mark2 (& (i -> realm ) , gc ) ; 

  return 0 ; 
}






static int mark_struct_property_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Struct_Property * i = (Scheme_Struct_Property * ) p ; 
  GC_fixup2 (& (i -> name ) , gc ) ; 
  GC_fixup2 (& (i -> guard ) , gc ) ; 
  GC_fixup2 (& (i -> supers ) , gc ) ; 
  GC_fixup2 (& (i -> contract_name ) , gc ) ; 
  GC_fixup2 (& (i -> realm ) , gc ) ; 

  return 0 ; 
}

# 247 "bc/src/mzmark_struct.inc"
static int mark_wrapped_evt_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_wrapped_evt_MARK (void * p , struct NewGC * gc ) {

  Wrapped_Evt * ww = (Wrapped_Evt * ) p ; 

  GC_mark2 (& (ww -> evt ) , gc ) ; 
  GC_mark2 (& (ww -> wrapper ) , gc ) ; 


  return 0 ; 
}






static int mark_wrapped_evt_FIXUP (void * p , struct NewGC * gc ) {

  Wrapped_Evt * ww = (Wrapped_Evt * ) p ; 

  GC_fixup2 (& (ww -> evt ) , gc ) ; 
  GC_fixup2 (& (ww -> wrapper ) , gc ) ; 


  return 0 ; 
}

# 291 "bc/src/mzmark_struct.inc"
static int mark_nack_guard_evt_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_nack_guard_evt_MARK (void * p , struct NewGC * gc ) {

  Nack_Guard_Evt * nw = (Nack_Guard_Evt * ) p ; 

  GC_mark2 (& (nw -> maker ) , gc ) ; 


  return 0 ; 
}






static int mark_nack_guard_evt_FIXUP (void * p , struct NewGC * gc ) {

  Nack_Guard_Evt * nw = (Nack_Guard_Evt * ) p ; 

  GC_fixup2 (& (nw -> maker ) , gc ) ; 


  return 0 ; 
}

# 333 "bc/src/mzmark_struct.inc"
static int mark_active_replace_evt_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_active_replace_evt_MARK (void * p , struct NewGC * gc ) {

  Active_Replace_Evt * a = (Active_Replace_Evt * ) p ; 

  GC_mark2 (& (a -> syncing ) , gc ) ; 
  GC_mark2 (& (a -> wrapper ) , gc ) ; 
  GC_mark2 (& (a -> orig ) , gc ) ; 


  return 0 ; 
}






static int mark_active_replace_evt_FIXUP (void * p , struct NewGC * gc ) {

  Active_Replace_Evt * a = (Active_Replace_Evt * ) p ; 

  GC_fixup2 (& (a -> syncing ) , gc ) ; 
  GC_fixup2 (& (a -> wrapper ) , gc ) ; 
  GC_fixup2 (& (a -> orig ) , gc ) ; 


  return 0 ; 
}

# 379 "bc/src/mzmark_struct.inc"
static int mark_chaperone_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_chaperone_MARK (void * p , struct NewGC * gc ) {

  Scheme_Chaperone * px = (Scheme_Chaperone * ) p ; 

  GC_mark2 (& (px -> val ) , gc ) ; 
  GC_mark2 (& (px -> prev ) , gc ) ; 
  GC_mark2 (& (px -> props ) , gc ) ; 
  GC_mark2 (& (px -> redirects ) , gc ) ; 


  return 0 ; 
}






static int mark_chaperone_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Chaperone * px = (Scheme_Chaperone * ) p ; 

  GC_fixup2 (& (px -> val ) , gc ) ; 
  GC_fixup2 (& (px -> prev ) , gc ) ; 
  GC_fixup2 (& (px -> props ) , gc ) ; 
  GC_fixup2 (& (px -> redirects ) , gc ) ; 


  return 0 ; 
}

# 6710 "bc/src/struct.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_structure_type , mark_struct_val_SIZE , mark_struct_val_MARK , mark_struct_val_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_serialized_structure_type , mark_serialized_struct_val_SIZE , mark_serialized_struct_val_MARK , mark_serialized_struct_val_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_proc_struct_type , mark_struct_val_SIZE , mark_struct_val_MARK , mark_struct_val_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_struct_type_type , mark_struct_type_val_SIZE , mark_struct_type_val_MARK , mark_struct_type_val_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_struct_property_type , mark_struct_property_SIZE , mark_struct_property_MARK , mark_struct_property_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_chaperone_property_type , mark_struct_property_SIZE , mark_struct_property_MARK , mark_struct_property_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_wrap_evt_type , mark_wrapped_evt_SIZE , mark_wrapped_evt_MARK , mark_wrapped_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_handle_evt_type , mark_wrapped_evt_SIZE , mark_wrapped_evt_MARK , mark_wrapped_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_nack_guard_evt_type , mark_nack_guard_evt_SIZE , mark_nack_guard_evt_MARK , mark_nack_guard_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_poll_evt_type , mark_nack_guard_evt_SIZE , mark_nack_guard_evt_MARK , mark_nack_guard_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_replace_evt_type , mark_wrapped_evt_SIZE , mark_wrapped_evt_MARK , mark_wrapped_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_active_replace_evt_type , mark_active_replace_evt_SIZE , mark_active_replace_evt_MARK , mark_active_replace_evt_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_chaperone_type , mark_chaperone_SIZE , mark_chaperone_MARK , mark_chaperone_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_proc_chaperone_type , mark_chaperone_SIZE , mark_chaperone_MARK , mark_chaperone_FIXUP , 1 , 0 ) ; 
}
