#include "precomp.h"

# 34 "bc/rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 121 "rktio/rktio.h"
typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 191 "rktio/rktio.h"
__xform_nongcing__ extern rktio_fd_t * rktio_system_fd (rktio_t * rktio , intptr_t system_fd , int modes ) ; 




__xform_nongcing__ extern intptr_t rktio_fd_system_fd (rktio_t * rktio , rktio_fd_t * rfd ) ; 

# 256 "rktio/rktio.h"
__xform_nongcing__ extern void rktio_forget (rktio_t * rktio , rktio_fd_t * fd ) ; 

# 320 "rktio/rktio.h"
__xform_nongcing__ extern 
rktio_tri_t rktio_poll_read_ready (rktio_t * rktio , rktio_fd_t * rfd ) ; 
__xform_nongcing__ extern 
rktio_tri_t rktio_poll_write_ready (rktio_t * rktio , rktio_fd_t * rfd ) ; 

# 351 "rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "rktio/rktio.h"
rktio_process_result_t ; 

# 646 "rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "rktio/rktio.h"
rktio_status_t ; 




__xform_nongcing__ extern void rktio_reap_processes (rktio_t * rktio ) ; 

# 669 "rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

__xform_nongcing__ extern rktio_poll_set_t * rktio_make_poll_set (rktio_t * rktio ) ; 
__xform_nongcing__ extern void rktio_poll_set_forget (rktio_t * rktio , rktio_poll_set_t * fds ) ; 

# 726 "rktio/rktio.h"
__xform_nongcing__ extern void rkio_reset_sleep_backoff (rktio_t * rktio ) ; 

# 742 "rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

__xform_nongcing__ extern rktio_ltps_t * rktio_ltps_open (rktio_t * rktio ) ; 

__xform_nongcing__ extern void rktio_ltps_close (rktio_t * rktio , rktio_ltps_t * lt ) ; 





__xform_nongcing__ extern rktio_ltps_handle_t * rktio_ltps_add (rktio_t * rktio , rktio_ltps_t * lt , rktio_fd_t * rfd , int mode ) ; 








enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

__xform_nongcing__ extern void rktio_ltps_handle_set_data (rktio_t * rktio , rktio_ltps_handle_t * h , void * data ) ; 
__xform_nongcing__ extern void * rktio_ltps_handle_get_data (rktio_t * rktio , rktio_ltps_handle_t * h ) ; 

__xform_nongcing__ extern void rktio_ltps_remove_all (rktio_t * rktio , rktio_ltps_t * lt ) ; 


__xform_nongcing__ extern rktio_ok_t rktio_ltps_poll (rktio_t * rktio , rktio_ltps_t * lt ) ; 


__xform_nongcing__ extern rktio_ltps_handle_t * rktio_ltps_get_signaled_handle (rktio_t * rktio , rktio_ltps_t * lt ) ; 









enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "rktio/rktio.h"
rktio_identity_t ; 

# 925 "rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "rktio/rktio.h"
rktio_date_t ; 









__xform_nongcing__ extern double rktio_get_inexact_monotonic_milliseconds (rktio_t * rktio ) ; 

# 1109 "rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 

# 1378 "rktio/rktio.h"
enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 




enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

# 51 "bc/src/thread.c"
extern void scheme_gmp_tls_init (intptr_t * s ) ; 
extern void * scheme_gmp_tls_load (intptr_t * s ) ; 
extern void scheme_gmp_tls_unload (intptr_t * s , void * p ) ; 
extern void scheme_gmp_tls_snapshot (intptr_t * s , intptr_t * save ) ; 
extern void scheme_gmp_tls_restore_snapshot (intptr_t * s , void * data , intptr_t * save , int do_free ) ; 

static void check_ready_break () ; 

; 
; 
; 
; 






int scheme_init_load_on_demand = 1 ; 

# 81 "bc/src/thread.c"
; 

; 
; 
; 
; 

__xform_nongcing__ Scheme_Thread * scheme_get_current_thread () {
  /* No conversion */

# 88 "bc/src/thread.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
}

# 89 "bc/src/thread.c"
__xform_nongcing__ intptr_t scheme_get_multiple_count () {
  /* No conversion */

# 89 "bc/src/thread.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ; 
}

# 90 "bc/src/thread.c"
__xform_nongcing__ Scheme_Object * * scheme_get_multiple_array () {
  /* No conversion */

# 90 "bc/src/thread.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ; 
}

# 91 "bc/src/thread.c"
__xform_nongcing__ void scheme_set_current_thread_ran_some () {
  /* No conversion */

# 91 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
}


; 





; 

; 
; 
; 
; 

; 
; 
; 
; 






; 
; 
; 
; 


; 

; 
; 
static Scheme_Object * initial_inspector ; 

; 

; 

; 









Scheme_At_Exit_Proc replacement_at_exit ; 

Scheme_Object * scheme_parameterization_key ; 
Scheme_Object * scheme_exn_handler_key ; 
Scheme_Object * scheme_break_enabled_key ; 
Scheme_Object * scheme_error_message_adjuster_key ; 

; 

static int gcs_on_exit ; 
; 
; 
; 
; 
; 
static void get_ready_for_GC (void ) ; 
static void done_with_GC (void ) ; 

static void inform_GC (int master_gc , int major_gc , int inc_gc , intptr_t pre_used , intptr_t post_used , 
intptr_t pre_admin , intptr_t post_admin , intptr_t post_child_places_used ) ; 


; 
; 

; 
; 
; 
void (* scheme_sleep ) (float seconds , void * fds ) ; 
void (* scheme_notify_multithread ) (int on ) ; 
void (* scheme_wakeup_on_input ) (void * fds ) ; 
int (* scheme_check_for_break ) (void ) ; 
; 
; 
; 
; 

; 

static Scheme_Object * read_symbol , * write_symbol , * execute_symbol , * delete_symbol , * exists_symbol ; 
static Scheme_Object * client_symbol , * server_symbol ; 
static Scheme_Object * major_symbol , * minor_symbol , * incremental_symbol ; 
static Scheme_Object * cumulative_symbol ; 
static Scheme_Object * gc_symbol , * gc_major_symbol ; 
static Scheme_Object * racket_symbol ; 

; 
; 
; 
; 
; 
; 
; 
; 
; 
; 



; 
; 
; 
; 
; 
; 
; 
; 
; 
; 

; 


extern intptr_t GC_is_place () ; 


typedef struct Thread_Cell {
  Scheme_Object so ; 
  char inherited , assigned ; 
  Scheme_Object * def_val ; 
}

# 224 "bc/src/thread.c"
Thread_Cell ; 





typedef struct {
  short type ; 
  short hash_key ; 
  Scheme_Custodian * val ; 
}

# 234 "bc/src/thread.c"
Scheme_Custodian_Weak_Box ; 

# 251 "bc/src/thread.c"
typedef struct Proc_Global_Rec {
  const char * key ; 
  void * val ; 
  struct Proc_Global_Rec * next ; 
}

# 255 "bc/src/thread.c"
Proc_Global_Rec ; 

static Proc_Global_Rec * process_globals ; 

static mzrt_mutex * process_global_lock ; 


typedef struct {
  Scheme_Object so ; 
  intptr_t size ; 
}

# 265 "bc/src/thread.c"
Scheme_Phantom_Bytes ; 

struct Scheme_Plumber {
  Scheme_Object so ; 
  Scheme_Hash_Table * handles ; 
  Scheme_Bucket_Table * weak_handles ; 
}

# 271 "bc/src/thread.c"
; 


static void register_traversers (void ) ; 


static Scheme_Object * custodian_require_mem (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * custodian_limit_mem (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * custodian_can_mem (int argc , Scheme_Object * args [] ) ; 

static Scheme_Object * collect_garbage (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * current_memory_use (int argc , Scheme_Object * args [] ) ; 

static Scheme_Object * sch_thread (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * sch_thread_nokill (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * sch_sleep (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_running_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_dead_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_wait (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * sch_current (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * kill_thread (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * break_thread (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_suspend (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_resume (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * make_thread_suspend (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * make_thread_resume (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * make_thread_dead (int argc , Scheme_Object * args [] ) ; 
static void register_thread_sync () ; 

static Scheme_Object * sch_sync (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * sch_sync_timeout (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * sch_sync_enable_break (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * sch_sync_timeout_enable_break (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * evt_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * evts_to_evt (int argc , Scheme_Object * args [] ) ; 

static Scheme_Object * make_custodian (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * custodian_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * custodian_close_all (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * custodian_shut_down_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * custodian_to_list (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_custodian (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_custodian_box (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * custodian_box_value (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * custodian_box_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_as_nested_thread (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_thread_at_root (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_make_custodian_at_root (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_custodian_register (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_custodian_unregister (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_add_post_custodian_shutdown (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_register_process_global (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_get_place_table (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_set_on_atomic_timeout (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_add_global_finalizer (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_os_thread_enabled_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_call_in_os_thread (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_make_os_semaphore (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_os_semaphore_wait (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_os_semaphore_post (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * unsafe_add_collect_callbacks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_remove_collect_callbacks (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_plumber (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * plumber_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * plumber_flush_all (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * plumber_add_flush (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * plumber_remove_flush (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * plumber_flush_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_plumber (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * parameter_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * parameter_procedure_eq (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * make_parameter (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * make_derived_parameter (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * parameterization_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * reparameterize (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * make_thread_cell (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_cell_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_cell_get (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_cell_set (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * thread_cell_values (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * is_thread_cell_values (int argc , Scheme_Object * args [] ) ; 

static Scheme_Object * make_security_guard (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * security_guard_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_security_guard (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_make_security_guard_at_root (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * security_guard_check_file (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * security_guard_check_file_link (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * security_guard_check_network (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * cache_configuration (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * make_thread_set (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * thread_set_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_thread_set (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * current_thread_initial_stack_size (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * phantom_bytes_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_phantom_bytes (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * set_phantom_bytes (int argc , Scheme_Object * argv [] ) ; 

static void adjust_custodian_family (void * pr , void * ignored ) ; 

static Scheme_Object * make_will_executor (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * will_executor_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * register_will (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * will_executor_try (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * will_executor_go (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * will_executor_sema (Scheme_Object * w , int * repost ) ; 

static Scheme_Object * check_break_now (int argc , Scheme_Object * args [] ) ; 

static Scheme_Object * memory_order (int argc , Scheme_Object * args [] ) ; 

static Scheme_Object * unsafe_start_atomic (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_end_atomic (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_start_breakable_atomic (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_end_breakable_atomic (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_in_atomic_p (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * unsafe_poll_fd (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_poll_ctx_fd_wakeup (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_poll_ctx_eventmask_wakeup (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_poll_ctx_time_wakeup (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_signal_received (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_make_signal_received (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_set_sleep_in_thread (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * unsafe_make_place_local (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_place_local_ref (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unsafe_place_local_set (int argc , Scheme_Object * * argv ) ; 

static void make_initial_config (Scheme_Thread * p ) ; 

static int do_kill_thread (Scheme_Thread * p ) ; 
static void suspend_thread (Scheme_Thread * p ) ; 

static int check_sleep (int need_activity , int sleep_now ) ; 

static int syncing_ready (Syncing * syncing , Scheme_Schedule_Info * sinfo ) ; 
static void get_outof_or_into_lines (Syncing * syncing , int get_out ) ; 

static void remove_thread (Scheme_Thread * r ) ; 
static void exit_or_escape (Scheme_Thread * p ) ; 

static int resume_suspend_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int dead_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int cust_box_ready (Scheme_Object * o ) ; 

static int can_break_param (Scheme_Thread * p ) ; 

static int post_system_idle () ; 

static Scheme_Object * current_stats (int argc , Scheme_Object * args [] ) ; 

static void log_peak_memory_use () ; 
static char * gc_unscaled_num (char * nums , intptr_t v ) ; 
static char * gc_num (char * nums , intptr_t v ) ; 

static Scheme_Object * * config_map ; 

typedef struct {
  Scheme_Type type ; 
  short is_derived ; 
  Scheme_Object * key ; 
  Scheme_Object * guard ; 
  Scheme_Object * extract_guard ; 
  Scheme_Object * defcell ; 
}

# 451 "bc/src/thread.c"
ParamData ; 

enum {
  CONFIG_DIRECT , 
  CONFIG_INDIRECT }
; 

typedef struct Scheme_Thread_Custodian_Hop {
  Scheme_Object so ; 
  Scheme_Thread * p ; 
}

# 461 "bc/src/thread.c"
Scheme_Thread_Custodian_Hop ; 

static Scheme_Custodian_Extractor * extractors ; 









Scheme_Object * initial_cmdline_vec ; 

# 485 "bc/src/thread.c"
void scheme_init_thread (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg133 = NULLED_OUT ; 
  Scheme_Object * __funcarg132 = NULLED_OUT ; 
  Scheme_Object * __funcarg131 = NULLED_OUT ; 
  Scheme_Object * __funcarg130 = NULLED_OUT ; 
  Scheme_Object * __funcarg129 = NULLED_OUT ; 
  Scheme_Object * __funcarg128 = NULLED_OUT ; 
  Scheme_Object * __funcarg127 = NULLED_OUT ; 
  Scheme_Object * __funcarg126 = NULLED_OUT ; 
  Scheme_Object * __funcarg125 = NULLED_OUT ; 
  Scheme_Object * __funcarg124 = NULLED_OUT ; 
  Scheme_Object * __funcarg123 = NULLED_OUT ; 
  Scheme_Object * __funcarg122 = NULLED_OUT ; 
  Scheme_Object * __funcarg121 = NULLED_OUT ; 
  Scheme_Object * __funcarg120 = NULLED_OUT ; 
  Scheme_Object * __funcarg119 = NULLED_OUT ; 
  Scheme_Object * __funcarg118 = NULLED_OUT ; 
  Scheme_Object * __funcarg117 = NULLED_OUT ; 
  Scheme_Object * __funcarg116 = NULLED_OUT ; 
  Scheme_Object * __funcarg115 = NULLED_OUT ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM5_COUNT (1)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM5(_), register_traversers () )
# 488 "bc/src/thread.c"
  ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_register_static ((void * ) & read_symbol , sizeof (read_symbol ) ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & write_symbol , sizeof (write_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & execute_symbol , sizeof (execute_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & delete_symbol , sizeof (delete_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & exists_symbol , sizeof (exists_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & client_symbol , sizeof (client_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & server_symbol , sizeof (server_symbol ) ) ); 

  read_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("read" ) ); 
  write_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("write" ) ); 
  execute_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("execute" ) ); 
  delete_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("delete" ) ); 
  exists_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("exists" ) ); 
  client_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("client" ) ); 
  server_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("server" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & major_symbol , sizeof (major_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & minor_symbol , sizeof (minor_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & incremental_symbol , sizeof (incremental_symbol ) ) ); 
  major_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("major" ) ); 
  minor_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("minor" ) ); 
  incremental_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("incremental" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & cumulative_symbol , sizeof (cumulative_symbol ) ) )
  ; 
  cumulative_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("cumulative" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & gc_symbol , sizeof (gc_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & gc_major_symbol , sizeof (gc_major_symbol ) ) ); 
  gc_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("GC" ) ); 
  gc_major_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("GC:major" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & racket_symbol , sizeof (racket_symbol ) ) )
  ; 
  racket_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("racket" ) ); 
  (__funcarg133 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (scheme_dump_gc_stats , "dump-memory-stats" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("dump-memory-stats" , __funcarg133 , env ) )) ; 
  (__funcarg132 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (current_stats , "vector-set-performance-stats!" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("vector-set-performance-stats!" , __funcarg132 , env ) )) ; 
  (__funcarg131 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (sch_thread , "thread" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread" , __funcarg131 , env ) )) ; 
  (__funcarg130 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (sch_thread_nokill , "thread/suspend-to-kill" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread/suspend-to-kill" , __funcarg130 , env ) )) ; 
  (__funcarg129 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (sch_sleep , "sleep" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("sleep" , __funcarg129 , env ) )) ; 
  (__funcarg128 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (thread_p , "thread?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread?" , __funcarg128 , env ) )) ; 
  (__funcarg127 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_running_p , "thread-running?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-running?" , __funcarg127 , env ) )) ; 
  (__funcarg126 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_dead_p , "thread-dead?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-dead?" , __funcarg126 , env ) )) ; 
  (__funcarg125 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_wait , "thread-wait" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-wait" , __funcarg125 , env ) )) ; 
  (__funcarg124 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (sch_current , "current-thread" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-thread" , __funcarg124 , env ) )) ; 
  (__funcarg123 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (kill_thread , "kill-thread" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("kill-thread" , __funcarg123 , env ) )) ; 
  (__funcarg122 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (break_thread , "break-thread" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("break-thread" , __funcarg122 , env ) )) ; 
  (__funcarg121 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_suspend , "thread-suspend" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-suspend" , __funcarg121 , env ) )) ; 
  (__funcarg120 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_resume , "thread-resume" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-resume" , __funcarg120 , env ) )) ; 
  (__funcarg119 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_thread_resume , "thread-resume-evt" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-resume-evt" , __funcarg119 , env ) )) ; 
  (__funcarg118 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_thread_suspend , "thread-suspend-evt" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-suspend-evt" , __funcarg118 , env ) )) ; 
  (__funcarg117 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_thread_dead , "thread-dead-evt" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-dead-evt" , __funcarg117 , env ) )) ; 
  FUNCCALL_AGAIN(register_thread_sync () )
  ; 
  FUNCCALL_AGAIN(scheme_add_evt (scheme_thread_suspend_type , (Scheme_Ready_Fun ) resume_suspend_ready , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ); 
  FUNCCALL_AGAIN(scheme_add_evt (scheme_thread_resume_type , (Scheme_Ready_Fun ) resume_suspend_ready , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ); 
  FUNCCALL_AGAIN(scheme_add_evt (scheme_thread_dead_type , (Scheme_Ready_Fun ) dead_ready , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ); 
  FUNCCALL_AGAIN(scheme_add_evt (scheme_cust_box_type , cust_box_ready , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
  (__funcarg116 = FUNCCALL(SETUP_XfOrM5(_), scheme_register_parameter (current_custodian , "current-custodian" , MZCONFIG_CUSTODIAN ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-custodian" , __funcarg116 , env ) )) ; 
  (__funcarg115 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_custodian , "make-custodian" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-custodian" , __funcarg115 , env ) )) ; 
  (__funcarg114 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (custodian_p , "custodian?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian?" , __funcarg114 , env ) )) ; 
  (__funcarg113 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (custodian_close_all , "custodian-shutdown-all" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian-shutdown-all" , __funcarg113 , env ) )) ; 
  (__funcarg112 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (custodian_shut_down_p , "custodian-shut-down?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian-shut-down?" , __funcarg112 , env ) )) ; 
  (__funcarg111 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (custodian_to_list , "custodian-managed-list" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian-managed-list" , __funcarg111 , env ) )) ; 
  (__funcarg110 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_custodian_box , "make-custodian-box" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-custodian-box" , __funcarg110 , env ) )) ; 
  (__funcarg109 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (custodian_box_value , "custodian-box-value" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian-box-value" , __funcarg109 , env ) )) ; 
  (__funcarg108 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (custodian_box_p , "custodian-box?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian-box?" , __funcarg108 , env ) )) ; 
  (__funcarg107 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (call_as_nested_thread , "call-in-nested-thread" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-in-nested-thread" , __funcarg107 , env ) )) ; 
  (__funcarg106 = FUNCCALL(SETUP_XfOrM5(_), scheme_register_parameter (current_plumber , "current-plumber" , MZCONFIG_PLUMBER ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-plumber" , __funcarg106 , env ) )) ; 
  (__funcarg105 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_plumber , "make-plumber" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-plumber" , __funcarg105 , env ) )) ; 
  (__funcarg104 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (plumber_p , "plumber?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("plumber?" , __funcarg104 , env ) )) ; 
  (__funcarg103 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (plumber_flush_all , "plumber-flush-all" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("plumber-flush-all" , __funcarg103 , env ) )) ; 
  (__funcarg102 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (plumber_add_flush , "plumber-add-flush!" , 2 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("plumber-add-flush!" , __funcarg102 , env ) )) ; 
  (__funcarg101 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (plumber_remove_flush , "plumber-flush-handle-remove!" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("plumber-flush-handle-remove!" , __funcarg101 , env ) )) ; 
  (__funcarg100 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (plumber_flush_p , "plumber-flush-handle?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("plumber-flush-handle?" , __funcarg100 , env ) )) ; 
  (__funcarg99 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (security_guard_p , "security-guard?" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("security-guard?" , __funcarg99 , env ) )) ; 
  (__funcarg98 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_security_guard , "make-security-guard" , 3 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-security-guard" , __funcarg98 , env ) )) ; 
  (__funcarg97 = FUNCCALL(SETUP_XfOrM5(_), scheme_register_parameter (current_security_guard , "current-security-guard" , MZCONFIG_SECURITY_GUARD ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-security-guard" , __funcarg97 , env ) )) ; 
  (__funcarg96 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_set_p , "thread-group?" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-group?" , __funcarg96 , env ) )) ; 
  (__funcarg95 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_thread_set , "make-thread-group" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-thread-group" , __funcarg95 , env ) )) ; 
  (__funcarg94 = FUNCCALL(SETUP_XfOrM5(_), scheme_register_parameter (current_thread_set , "current-thread-group" , MZCONFIG_THREAD_SET ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-thread-group" , __funcarg94 , env ) )) ; 
  (__funcarg93 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (parameter_p , "parameter?" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("parameter?" , __funcarg93 , env ) )) ; 
  (__funcarg92 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_parameter , "make-parameter" , 1 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-parameter" , __funcarg92 , env ) )) ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_derived_parameter , "make-derived-parameter" , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-derived-parameter" , __funcarg91 , env ) )) ; 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (parameter_procedure_eq , "parameter-procedure=?" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("parameter-procedure=?" , __funcarg90 , env ) )) ; 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (parameterization_p , "parameterization?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("parameterization?" , __funcarg89 , env ) )) ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_cell_p , "thread-cell?" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-cell?" , __funcarg88 , env ) )) ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_thread_cell , "make-thread-cell" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-thread-cell" , __funcarg87 , env ) )) ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_cell_get , "thread-cell-ref" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-cell-ref" , __funcarg86 , env ) )) ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_cell_set , "thread-cell-set!" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-cell-set!" , __funcarg85 , env ) )) ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (thread_cell_values , "current-preserved-thread-cell-values" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-preserved-thread-cell-values" , __funcarg84 , env ) )) ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (is_thread_cell_values , "thread-cell-values?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("thread-cell-values?" , __funcarg83 , env ) )) ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_will_executor , "make-will-executor" , 0 , 0 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-will-executor" , __funcarg82 , env ) )) ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (will_executor_p , "will-executor?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("will-executor?" , __funcarg81 , env ) )) ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (register_will , "will-register" , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("will-register" , __funcarg80 , env ) )) ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (will_executor_try , "will-try-execute" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("will-try-execute" , __funcarg79 , env ) )) ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (will_executor_go , "will-execute" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("will-execute" , __funcarg78 , env ) )) ; 
  FUNCCALL_AGAIN(scheme_add_evt_through_sema (scheme_will_executor_type , will_executor_sema , ((void * ) 0 ) ) )
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (collect_garbage , "collect-garbage" , 0 , 1 ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("collect-garbage" , __funcarg77 , env ) )) ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (current_memory_use , "current-memory-use" , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-memory-use" , __funcarg76 , env ) )) ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (custodian_require_mem , "custodian-require-memory" , 3 , 3 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian-require-memory" , __funcarg75 , env ) )) ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (custodian_limit_mem , "custodian-limit-memory" , 2 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian-limit-memory" , __funcarg74 , env ) )) ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (custodian_can_mem , "custodian-memory-accounting-available?" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("custodian-memory-accounting-available?" , __funcarg73 , env ) )) ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (memory_order , "memory-order-acquire" , 0 , 0 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("memory-order-acquire" , __funcarg72 , env ) )) ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (memory_order , "memory-order-release" , 0 , 0 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("memory-order-release" , __funcarg71 , env ) )) ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_folding_prim (evt_p , "evt?" , 1 , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("evt?" , __funcarg70 , env ) )) ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_everything (sch_sync , 1 , "sync" , 0 , - 1 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("sync" , __funcarg69 , env ) )) ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_everything (sch_sync_timeout , 1 , "sync/timeout" , 1 , - 1 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("sync/timeout" , __funcarg68 , env ) )) ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_everything (sch_sync_enable_break , 1 , "sync/enable-break" , 0 , - 1 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("sync/enable-break" , __funcarg67 , env ) )) ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_everything (sch_sync_timeout_enable_break , 1 , "sync/timeout/enable-break" , 1 , - 1 , 0 , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("sync/timeout/enable-break" , __funcarg66 , env ) )) ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (evts_to_evt , "choice-evt" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("choice-evt" , __funcarg65 , env ) )) ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM5(_), scheme_register_parameter (current_thread_initial_stack_size , "current-thread-initial-stack-size" , MZCONFIG_THREAD_INIT_STACK_SIZE ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-thread-initial-stack-size" , __funcarg64 , env ) )) ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (phantom_bytes_p , "phantom-bytes?" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("phantom-bytes?" , __funcarg63 , env ) )) ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (make_phantom_bytes , "make-phantom-bytes" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-phantom-bytes" , __funcarg62 , env ) )) ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (set_phantom_bytes , "set-phantom-bytes!" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("set-phantom-bytes!" , __funcarg61 , env ) )) ; 

  if (FUNCCALL_EMPTY(scheme_getenv ("PLT_GCS_ON_EXIT" ) ))
    gcs_on_exit = 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 627 "bc/src/thread.c"
void 
scheme_init_unsafe_thread (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg163 = NULLED_OUT ; 
  Scheme_Object * __funcarg162 = NULLED_OUT ; 
  Scheme_Object * __funcarg161 = NULLED_OUT ; 
  Scheme_Object * __funcarg160 = NULLED_OUT ; 
  Scheme_Object * __funcarg159 = NULLED_OUT ; 
  Scheme_Object * __funcarg158 = NULLED_OUT ; 
  Scheme_Object * __funcarg157 = NULLED_OUT ; 
  Scheme_Object * __funcarg156 = NULLED_OUT ; 
  Scheme_Object * __funcarg155 = NULLED_OUT ; 
  Scheme_Object * __funcarg154 = NULLED_OUT ; 
  Scheme_Object * __funcarg153 = NULLED_OUT ; 
  Scheme_Object * __funcarg152 = NULLED_OUT ; 
  Scheme_Object * __funcarg151 = NULLED_OUT ; 
  Scheme_Object * __funcarg150 = NULLED_OUT ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  Scheme_Object * __funcarg148 = NULLED_OUT ; 
  Scheme_Object * __funcarg147 = NULLED_OUT ; 
  Scheme_Object * __funcarg146 = NULLED_OUT ; 
  Scheme_Object * __funcarg145 = NULLED_OUT ; 
  Scheme_Object * __funcarg144 = NULLED_OUT ; 
  Scheme_Object * __funcarg143 = NULLED_OUT ; 
  Scheme_Object * __funcarg142 = NULLED_OUT ; 
  Scheme_Object * __funcarg141 = NULLED_OUT ; 
  Scheme_Object * __funcarg140 = NULLED_OUT ; 
  Scheme_Object * __funcarg139 = NULLED_OUT ; 
  Scheme_Object * __funcarg138 = NULLED_OUT ; 
  Scheme_Object * __funcarg137 = NULLED_OUT ; 
  Scheme_Object * __funcarg136 = NULLED_OUT ; 
  Scheme_Object * __funcarg135 = NULLED_OUT ; 
  Scheme_Object * __funcarg134 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(env, 1)));
# define XfOrM6_COUNT (2)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  (__funcarg163 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_start_atomic , "unsafe-start-atomic" , 0 , 0 ) )
# 635 "bc/src/thread.c"
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-start-atomic" , __funcarg163 , env ) )) 
  ; 
  (__funcarg162 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_end_atomic , "unsafe-end-atomic" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-end-atomic" , __funcarg162 , env ) )) 
  ; 
  (__funcarg161 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_start_breakable_atomic , "unsafe-start-breakable-atomic" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-start-breakable-atomic" , __funcarg161 , env ) )) 
  ; 
  (__funcarg160 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_end_breakable_atomic , "unsafe-end-breakable-atomic" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-end-breakable-atomic" , __funcarg160 , env ) )) 
  ; 
  (__funcarg159 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_in_atomic_p , "unsafe-in-atomic?" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-in-atomic?" , __funcarg159 , env ) )) 
  ; 
  (__funcarg158 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_thread_at_root , "unsafe-thread-at-root" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-thread-at-root" , __funcarg158 , env ) )) ; 
  (__funcarg157 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_make_custodian_at_root , "unsafe-make-custodian-at-root" , 0 , 0 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-make-custodian-at-root" , __funcarg157 , env ) )) ; 
  (__funcarg156 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_custodian_register , "unsafe-custodian-register" , 5 , 6 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-custodian-register" , __funcarg156 , env ) )) ; 
  (__funcarg155 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_custodian_unregister , "unsafe-custodian-unregister" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-custodian-unregister" , __funcarg155 , env ) )) ; 
  (__funcarg154 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_add_post_custodian_shutdown , "unsafe-add-post-custodian-shutdown" , 1 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-add-post-custodian-shutdown" , __funcarg154 , env ) )) ; 
  (__funcarg153 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_register_process_global , "unsafe-register-process-global" , 2 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-register-process-global" , __funcarg153 , env ) )) ; 
  (__funcarg152 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_get_place_table , "unsafe-get-place-table" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-get-place-table" , __funcarg152 , env ) )) ; 
  (__funcarg151 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_set_on_atomic_timeout , "unsafe-set-on-atomic-timeout!" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-set-on-atomic-timeout!" , __funcarg151 , env ) )) ; 
  (__funcarg150 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_make_security_guard_at_root , "unsafe-make-security-guard-at-root" , 0 , 3 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-make-security-guard-at-root" , __funcarg150 , env ) )) ; 
  (__funcarg149 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_add_global_finalizer , "unsafe-add-global-finalizer" , 2 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-add-global-finalizer" , __funcarg149 , env ) )) ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-poller" , scheme_unsafe_poller_proc , env ) )
  ; 
  (__funcarg148 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_poll_fd , "unsafe-poll-fd" , 2 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-poll-fd" , __funcarg148 , env ) )) ; 
  (__funcarg147 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_poll_ctx_fd_wakeup , "unsafe-poll-ctx-fd-wakeup" , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-poll-ctx-fd-wakeup" , __funcarg147 , env ) )) ; 
  (__funcarg146 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_poll_ctx_eventmask_wakeup , "unsafe-poll-ctx-eventmask-wakeup" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-poll-ctx-eventmask-wakeup" , __funcarg146 , env ) )) ; 
  (__funcarg145 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_poll_ctx_time_wakeup , "unsafe-poll-ctx-milliseconds-wakeup" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-poll-ctx-milliseconds-wakeup" , __funcarg145 , env ) )) ; 
  (__funcarg144 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_signal_received , "unsafe-signal-received" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-signal-received" , __funcarg144 , env ) )) ; 
  (__funcarg143 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_make_signal_received , "unsafe-make-signal-received" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-make-signal-received" , __funcarg143 , env ) )) ; 
  (__funcarg142 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_set_sleep_in_thread , "unsafe-set-sleep-in-thread!" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-set-sleep-in-thread!" , __funcarg142 , env ) )) ; 
  (__funcarg141 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_os_thread_enabled_p , "unsafe-os-thread-enabled?" , 0 , 0 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-os-thread-enabled?" , __funcarg141 , env ) )) ; 
  (__funcarg140 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_call_in_os_thread , "unsafe-call-in-os-thread" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-call-in-os-thread" , __funcarg140 , env ) )) ; 
  (__funcarg139 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_make_os_semaphore , "unsafe-make-os-semaphore" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-make-os-semaphore" , __funcarg139 , env ) )) ; 
  (__funcarg138 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_os_semaphore_wait , "unsafe-os-semaphore-wait" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-os-semaphore-wait" , __funcarg138 , env ) )) ; 
  (__funcarg137 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_os_semaphore_post , "unsafe-os-semaphore-post" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-os-semaphore-post" , __funcarg137 , env ) )) ; 
  (__funcarg136 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_add_collect_callbacks , "unsafe-add-collect-callbacks" , 2 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-add-collect-callbacks" , __funcarg136 , env ) )) ; 
  (__funcarg135 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (unsafe_remove_collect_callbacks , "unsafe-remove-collect-callbacks" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-remove-collect-callbacks" , __funcarg135 , env ) )) ; 


  p = FUNCCALL_AGAIN(scheme_make_prim_w_arity (unsafe_make_place_local , "unsafe-make-place-local" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 5 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM6(_), scheme_addto_prim_instance ("unsafe-make-place-local" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_place_local_ref , "unsafe-place-local-ref" , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 0 ) 
  | (1 << 3 ) 
  | (1 << 4 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM6(_), scheme_addto_prim_instance ("unsafe-place-local-ref" , p , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (unsafe_place_local_set , "unsafe-place-local-set!" , 2 , 2 ) ); 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= (scheme_intern_prim_opt_flags ((1 << 1 ) 
  | (1 << 24 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM6(_), scheme_addto_prim_instance ("unsafe-place-local-set!" , p , env ) ); 
  (__funcarg134 = FUNCCALL(SETUP_XfOrM6(_), scheme_make_prim_w_arity (scheme_unsafe_make_srcloc , "unsafe-make-srcloc" , 5 , 5 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-make-srcloc" , __funcarg134 , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 714 "bc/src/thread.c"
void scheme_init_thread_places (void ) {
  Scheme_Object * __funcarg164 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(0);
# define XfOrM7_COUNT (0)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 715 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) = 20 ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cell_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cell_ ) ) ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) ) ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prepost_callback_descs_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prepost_callback_descs_ ) ) ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_misc_table_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_misc_table_ ) ) ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_info_prefab_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_info_prefab_ ) ) ) ); 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_data_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_data_ ) ) ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_info_prefab_ ) = (__funcarg164 = FUNCCALL_EMPTY(scheme_intern_symbol ("gc-info" ) ), FUNCCALL_EMPTY(scheme_lookup_prefab_type (__funcarg164 , 10 ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 725 "bc/src/thread.c"
void scheme_init_inspector () {
  /* No conversion */

# 726 "bc/src/thread.c"
  scheme_register_static ((void * ) & initial_inspector , sizeof (initial_inspector ) ) ; 
  initial_inspector = scheme_make_initial_inspectors () ; 
}





Scheme_Object * scheme_get_current_inspector () 
XFORM_SKIP_PROC 
{
  Scheme_Config * c ; 

  if (scheme_defining_primitives )
    return initial_inspector ; 

  c = scheme_current_config () ; 
  return scheme_get_param (c , MZCONFIG_INSPECTOR ) ; 
}

Scheme_Object * scheme_get_initial_inspector (void ) 
{
  /* No conversion */

# 748 "bc/src/thread.c"
  return initial_inspector ; 
}

void scheme_init_parameterization () 
{
  /* No conversion */

# 753 "bc/src/thread.c"
  scheme_register_static ((void * ) & scheme_exn_handler_key , sizeof (scheme_exn_handler_key ) ) ; 
  scheme_register_static ((void * ) & scheme_parameterization_key , sizeof (scheme_parameterization_key ) ) ; 
  scheme_register_static ((void * ) & scheme_break_enabled_key , sizeof (scheme_break_enabled_key ) ) ; 
  scheme_exn_handler_key = scheme_make_symbol ("exnh" ) ; 
  scheme_parameterization_key = scheme_make_symbol ("paramz" ) ; 
  scheme_break_enabled_key = scheme_make_symbol ("break-on?" ) ; 
}

void scheme_init_paramz (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg171 = NULLED_OUT ; 
  Scheme_Object * __funcarg170 = NULLED_OUT ; 
  Scheme_Object * __funcarg169 = NULLED_OUT ; 
  Scheme_Object * __funcarg168 = NULLED_OUT ; 
  Scheme_Object * __funcarg167 = NULLED_OUT ; 
  Scheme_Object * __funcarg166 = NULLED_OUT ; 
  Scheme_Object * __funcarg165 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM11_COUNT (1)
# define SETUP_XfOrM11(x) SETUP(XfOrM11_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM11(_), scheme_switch_prim_instance (env , "#%paramz" ) )
# 763 "bc/src/thread.c"
  ; 
  FUNCCALL(SETUP_XfOrM11(_), scheme_addto_prim_instance ("exception-handler-key" , scheme_exn_handler_key , env ) )
  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("parameterization-key" , scheme_parameterization_key , env ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("break-enabled-key" , scheme_break_enabled_key , env ) ); 
  (__funcarg171 = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (scheme_extend_parameterization , "extend-parameterization" , 1 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("extend-parameterization" , __funcarg171 , env ) )) ; 
  (__funcarg170 = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (check_break_now , "check-for-break" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("check-for-break" , __funcarg170 , env ) )) ; 
  (__funcarg169 = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (reparameterize , "reparameterize" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("reparameterize" , __funcarg169 , env ) )) ; 
  (__funcarg168 = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (cache_configuration , "cache-configuration" , 2 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("cache-configuration" , __funcarg168 , env ) )) ; 
  (__funcarg167 = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (security_guard_check_file , "security-guard-check-file" , 3 , 3 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("security-guard-check-file" , __funcarg167 , env ) )) ; 
  (__funcarg166 = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (security_guard_check_file_link , "security-guard-check-file-link" , 3 , 3 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("security-guard-check-file-link" , __funcarg166 , env ) )) ; 
  (__funcarg165 = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (security_guard_check_network , "security-guard-check-network" , 4 , 4 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("security-guard-check-network" , __funcarg165 , env ) )) ; 
  FUNCCALL_EMPTY(scheme_restore_prim_instance (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 782 "bc/src/thread.c"
static Scheme_Object * collect_garbage (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM12_COUNT (1)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 784 "bc/src/thread.c"
  if (argc == 1 && ((minor_symbol ) == (argv [0 ] ) ) ) {
#   define XfOrM16_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM16(x) SETUP_XfOrM12(x)
    FUNCCALL(SETUP_XfOrM16(_), scheme_collect_garbage_minor () )
# 785 "bc/src/thread.c"
    ; 
  }

# 786 "bc/src/thread.c"
  else if ((argc < 1 ) || ((major_symbol ) == (argv [0 ] ) ) ) {
#   define XfOrM15_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM15(x) SETUP_XfOrM12(x)
    FUNCCALL(SETUP_XfOrM15(_), scheme_collect_garbage () )
# 787 "bc/src/thread.c"
    ; 
  }

# 788 "bc/src/thread.c"
  else if ((argc < 1 ) || ((incremental_symbol ) == (argv [0 ] ) ) ) {
#   define XfOrM14_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM14(x) SETUP_XfOrM12(x)
    FUNCCALL(SETUP_XfOrM14(_), GC_request_incremental_mode () )
# 790 "bc/src/thread.c"
    ; 
  }
  else {
#   define XfOrM13_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM13(x) SETUP_XfOrM12(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("collect-garbage" , "(or/c 'major 'minor 'incremental)" , 0 , argc , argv ) ); 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 801 "bc/src/thread.c"
static Scheme_Object * current_memory_use (int argc , Scheme_Object * args [] ) 
{
  Scheme_Object * arg = ((void * ) 0 ) ; 
  int cumulative = 0 ; 
  uintptr_t retval = 0 ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(arg, 0)));
# define XfOrM17_COUNT (1)
# define SETUP_XfOrM17(x) SETUP(XfOrM17_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 807 "bc/src/thread.c"
  if (argc ) {
#   define XfOrM20_COUNT (0+XfOrM17_COUNT)
#   define SETUP_XfOrM20(x) SETUP_XfOrM17(x)

# 808 "bc/src/thread.c"
    if (((args [0 ] ) ) == (scheme_false ) )  {
      arg = args [0 ] ; 
    }

# 810 "bc/src/thread.c"
    else if ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) )  {
      arg = args [0 ] ; 
    }

# 812 "bc/src/thread.c"
    else if ((args [0 ] ) == (cumulative_symbol ) )  {
      cumulative = 1 ; 
      arg = ((void * ) 0 ) ; 
    }

# 815 "bc/src/thread.c"
    else {
#     define XfOrM21_COUNT (0+XfOrM20_COUNT)
#     define SETUP_XfOrM21(x) SETUP_XfOrM20(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("current-memory-use" , "(or/c custodian? 'cumulative #f)" , 0 , argc , args ) ); 
    }
  }

  if (cumulative ) {
#   define XfOrM19_COUNT (0+XfOrM17_COUNT)
#   define SETUP_XfOrM19(x) SETUP_XfOrM17(x)

# 824 "bc/src/thread.c"
    retval = FUNCCALL(SETUP_XfOrM19(_), GC_get_memory_ever_used () ); 
  }


  else {
#   define XfOrM18_COUNT (0+XfOrM17_COUNT)
#   define SETUP_XfOrM18(x) SETUP_XfOrM17(x)

# 830 "bc/src/thread.c"
    retval = FUNCCALL_EMPTY(GC_get_memory_use (arg ) ); 
  }





  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_integer_value_from_unsigned (retval ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 840 "bc/src/thread.c"
static Scheme_Object * cache_configuration (int argc , Scheme_Object * * argv ) 
{
  int pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(1);
# define XfOrM25_COUNT (0)
# define SETUP_XfOrM25(x) SETUP(XfOrM25_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 844 "bc/src/thread.c"
  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  pos = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 

  if ((pos < 0 ) || (pos >= 4 ) )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> configuration_callback_cache_ ) [pos ] ) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM25_COUNT)));
#   define XfOrM26_COUNT (1+XfOrM25_COUNT)
#   define SETUP_XfOrM26(x) SETUP(XfOrM26_COUNT)
    v = NULLED_OUT ; 

# 854 "bc/src/thread.c"
    v = FUNCCALL(SETUP_XfOrM26(_), scheme_do_eval (argv [1 ] , 0 , ((void * ) 0 ) , 1 ) ); 
    FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> configuration_callback_cache_ ) [pos ] , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> configuration_callback_cache_ ) [pos ] ) ) ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> configuration_callback_cache_ ) [pos ] = v ; 
  }

  RET_VALUE_START (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> configuration_callback_cache_ ) [pos ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static void adjust_limit_table (Scheme_Custodian * c ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(c, 0)));
# define XfOrM27_COUNT (1)
# define SETUP_XfOrM27(x) SETUP(XfOrM27_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 872 "bc/src/thread.c"
  if (c -> has_limit ) {
#   define XfOrM28_COUNT (0+XfOrM27_COUNT)
#   define SETUP_XfOrM28(x) SETUP_XfOrM27(x)

# 873 "bc/src/thread.c"
    if (c -> elems || ((Scheme_Custodian_Weak_Box * ) c -> children ) -> val ) {
#     define XfOrM30_COUNT (0+XfOrM28_COUNT)
#     define SETUP_XfOrM30(x) SETUP_XfOrM28(x)

# 874 "bc/src/thread.c"
      if (! c -> recorded ) {
#       define XfOrM31_COUNT (0+XfOrM30_COUNT)
#       define SETUP_XfOrM31(x) SETUP_XfOrM30(x)

# 875 "bc/src/thread.c"
        c -> recorded = 1 ; 
        if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> limited_custodians_ ) )
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> limited_custodians_ ) = FUNCCALL(SETUP_XfOrM31(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
        FUNCCALL(SETUP_XfOrM31(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> limited_custodians_ ) , (Scheme_Object * ) c , scheme_true ) ); 
      }
    }

# 880 "bc/src/thread.c"
    else if (c -> recorded ) {
#     define XfOrM29_COUNT (0+XfOrM28_COUNT)
#     define SETUP_XfOrM29(x) SETUP_XfOrM28(x)

# 881 "bc/src/thread.c"
      c -> recorded = 0 ; 
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> limited_custodians_ ) )
        FUNCCALL_EMPTY(scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> limited_custodians_ ) , (Scheme_Object * ) c , ((void * ) 0 ) ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 888 "bc/src/thread.c"
static Scheme_Object * custodian_require_mem (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 890 "bc/src/thread.c"
  intptr_t lim ; 
  Scheme_Custodian * c1 , * c2 , * cx ; 

  if ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) != (Scheme_Type ) (scheme_custodian_type ) )  {
    scheme_wrong_contract ("custodian-require-memory" , "custodian?" , 0 , argc , args ) ; 
    return ((void * ) 0 ) ; 
  }

  if ((((intptr_t ) (args [1 ] ) ) & 0x1 ) && ((((intptr_t ) (args [1 ] ) ) >> 1 ) > 0 ) ) {
    lim = (((intptr_t ) (args [1 ] ) ) >> 1 ) ; 
  }

# 900 "bc/src/thread.c"
  else if (((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) args [1 ] ) -> iso ) -> so . keyex & 0x1 ) ) {
    lim = 0x3fffffff ; 
  }

# 902 "bc/src/thread.c"
  else {
    scheme_wrong_contract ("custodian-require-memory" , "exact-positive-integer?" , 1 , argc , args ) ; 
    return ((void * ) 0 ) ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (args [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [2 ] ) ) -> type ) ) != (Scheme_Type ) (scheme_custodian_type ) )  {
    scheme_wrong_contract ("custodian-require-memory" , "custodian?" , 2 , argc , args ) ; 
    return ((void * ) 0 ) ; 
  }

  c1 = (Scheme_Custodian * ) args [0 ] ; 
  c2 = (Scheme_Custodian * ) args [2 ] ; 


  if (c1 == c2 ) {
    cx = ((void * ) 0 ) ; 
  }

# 918 "bc/src/thread.c"
  else {
    for (cx = c2 ; cx && ((cx ) != (c1 ) ) ; ) {
      cx = ((Scheme_Custodian_Weak_Box * ) cx -> parent ) -> val ; 
    }
  }
  if (! cx ) {
    scheme_raise_exn (MZEXN_FAIL_CONTRACT , 
    "custodian-require-memory: second custodian is not a sub-custodian of the first custodian" ) ; 
  }


  if (GC_set_account_hook (0 , c1 , lim , c2 ) )
    return scheme_void ; 




  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , 
  "custodian-require-memory: " "unsupported on this platform" ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * custodian_limit_mem (int argc , Scheme_Object * args [] ) 
{
  intptr_t lim ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(args, 0)));
# define XfOrM43_COUNT (1)
# define SETUP_XfOrM43(x) SETUP(XfOrM43_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 944 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) != (Scheme_Type ) (scheme_custodian_type ) )  {
#   define XfOrM50_COUNT (0+XfOrM43_COUNT)
#   define SETUP_XfOrM50(x) SETUP_XfOrM43(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("custodian-limit-memory" , "custodian?" , 0 , argc , args ) )
# 945 "bc/src/thread.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if ((((intptr_t ) (args [1 ] ) ) & 0x1 ) && ((((intptr_t ) (args [1 ] ) ) >> 1 ) > 0 ) ) {
    lim = (((intptr_t ) (args [1 ] ) ) >> 1 ) ; 
  }

# 951 "bc/src/thread.c"
  else if (((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) args [1 ] ) -> iso ) -> so . keyex & 0x1 ) ) {
    lim = 0x3fffffff ; 
  }

# 953 "bc/src/thread.c"
  else {
#   define XfOrM47_COUNT (0+XfOrM43_COUNT)
#   define SETUP_XfOrM47(x) SETUP_XfOrM43(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("custodian-limit-memory" , "exact-positive-integer?" , 1 , argc , args ) )
# 954 "bc/src/thread.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc > 2 ) {
#   define XfOrM45_COUNT (0+XfOrM43_COUNT)
#   define SETUP_XfOrM45(x) SETUP_XfOrM43(x)

# 959 "bc/src/thread.c"
    if ((Scheme_Type ) (((((intptr_t ) (args [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [2 ] ) ) -> type ) ) != (Scheme_Type ) (scheme_custodian_type ) )  {
#     define XfOrM46_COUNT (0+XfOrM45_COUNT)
#     define SETUP_XfOrM46(x) SETUP_XfOrM45(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("custodian-limit-memory" , "custodian?" , 2 , argc , args ) )
# 960 "bc/src/thread.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  ((Scheme_Custodian * ) args [0 ] ) -> has_limit = 1 ; 
  FUNCCALL(SETUP_XfOrM43(_), adjust_limit_table ((Scheme_Custodian * ) args [0 ] ) ); 
  if (argc > 2 ) {
#   define XfOrM44_COUNT (0+XfOrM43_COUNT)
#   define SETUP_XfOrM44(x) SETUP_XfOrM43(x)

# 968 "bc/src/thread.c"
    ((Scheme_Custodian * ) args [2 ] ) -> has_limit = 1 ; 
    FUNCCALL(SETUP_XfOrM44(_), adjust_limit_table ((Scheme_Custodian * ) args [2 ] ) ); 
  }


  if (FUNCCALL_EMPTY(GC_set_account_hook (1 , args [0 ] , lim , (argc > 2 ) ? args [2 ] : args [0 ] ) ))
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "custodian-limit-memory: " "unsupported on this platform" ) )




  ; 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 984 "bc/src/thread.c"
static Scheme_Object * custodian_can_mem (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */
  return (GC_accouting_enabled () ? scheme_true : scheme_false ) ; 
}




static void ensure_custodian_space (Scheme_Custodian * m , int k ) 
{
  int i ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(m, 0)));
# define XfOrM52_COUNT (1)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 997 "bc/src/thread.c"
  if (m -> count + k >= m -> alloc ) {
    Scheme_Object * * * naya_boxes ; 
    Scheme_Custodian_Reference * * naya_mrefs ; 
    Scheme_Close_Custodian_Client * * naya_closers ; 
    void * * naya_data ; 
    BLOCK_SETUP((PUSH(naya_boxes, 0+XfOrM52_COUNT), PUSH(naya_mrefs, 1+XfOrM52_COUNT), PUSH(naya_data, 2+XfOrM52_COUNT), PUSH(naya_closers, 3+XfOrM52_COUNT)));
#   define XfOrM53_COUNT (4+XfOrM52_COUNT)
#   define SETUP_XfOrM53(x) SETUP(XfOrM53_COUNT)
    naya_boxes = NULLED_OUT ; 
    naya_mrefs = NULLED_OUT ; 
    naya_closers = NULLED_OUT ; 
    naya_data = NULLED_OUT ; 

# 1003 "bc/src/thread.c"
    m -> alloc = (m -> alloc ? (2 * m -> alloc ) : 4 ) ; 
    if (m -> alloc < k )
      m -> alloc += k ; 

    naya_boxes = ((Scheme_Object * * * ) FUNCCALL(SETUP_XfOrM53(_), GC_malloc (sizeof (Scheme_Object * * ) * (m -> alloc ) ) )) ; 
    naya_closers = ((Scheme_Close_Custodian_Client * * ) FUNCCALL(SETUP_XfOrM53(_), GC_malloc_atomic (sizeof (Scheme_Close_Custodian_Client * ) * (m -> alloc ) ) )) ; 
    naya_data = ((void * * ) FUNCCALL(SETUP_XfOrM53(_), GC_malloc (sizeof (void * ) * (m -> alloc ) ) )) ; 
    naya_mrefs = ((Scheme_Custodian_Reference * * ) FUNCCALL(SETUP_XfOrM53(_), GC_malloc (sizeof (Scheme_Custodian_Reference * ) * (m -> alloc ) ) )) ; 

    for (i = m -> count ; i -- ; ) {
      naya_boxes [i ] = m -> boxes [i ] ; 
      m -> boxes [i ] = ((void * ) 0 ) ; 
      naya_closers [i ] = m -> closers [i ] ; 
      m -> closers [i ] = ((void * ) 0 ) ; 
      naya_data [i ] = m -> data [i ] ; 
      m -> data [i ] = ((void * ) 0 ) ; 
      naya_mrefs [i ] = m -> mrefs [i ] ; 
      m -> mrefs [i ] = ((void * ) 0 ) ; 
    }

    m -> boxes = naya_boxes ; 
    m -> closers = naya_closers ; 
    m -> data = naya_data ; 
    * m -> data_ptr = naya_data ; 
    m -> mrefs = naya_mrefs ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1031 "bc/src/thread.c"
static void add_managed_box (Scheme_Custodian * m , 
Scheme_Object * * box , Scheme_Custodian_Reference * mref , 
Scheme_Close_Custodian_Client * f , void * data ) 
{
  int i , saw = 0 ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(m, 0), PUSH(mref, 1), PUSH(data, 2), PUSH(f, 3), PUSH(box, 4)));
# define XfOrM56_COUNT (5)
# define SETUP_XfOrM56(x) SETUP(XfOrM56_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1037 "bc/src/thread.c"
  for (i = m -> count ; i -- ; ) {
#   define XfOrM60_COUNT (0+XfOrM56_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM56(x)

# 1038 "bc/src/thread.c"
    if (! m -> boxes [i ] ) {
#     define XfOrM62_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM62(x) SETUP_XfOrM60(x)

# 1039 "bc/src/thread.c"
      m -> boxes [i ] = box ; 
      m -> closers [i ] = f ; 
      m -> data [i ] = data ; 
      m -> mrefs [i ] = mref ; 
      (((Scheme_Custodian_Weak_Box * ) mref ) -> hash_key = (i & 0xFFFF ) ) ; 

      m -> elems ++ ; 
      FUNCCALL(SETUP_XfOrM62(_), adjust_limit_table (m ) ); 

      RET_NOTHING ; 
    }

# 1049 "bc/src/thread.c"
    else {
      saw ++ ; 
      if (i + saw == m -> elems )
        break ; 
    }
  }
  FUNCCALL(SETUP_XfOrM56(_), ensure_custodian_space (m , 1 ) )
  ; 

  m -> boxes [m -> count ] = box ; 
  m -> closers [m -> count ] = f ; 
  m -> data [m -> count ] = data ; 
  m -> mrefs [m -> count ] = mref ; 
  (((Scheme_Custodian_Weak_Box * ) mref ) -> hash_key = (m -> count & 0xFFFF ) ) ; 

  m -> elems ++ ; 
  FUNCCALL(SETUP_XfOrM56(_), adjust_limit_table (m ) ); 

  m -> count ++ ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1070 "bc/src/thread.c"
static void remove_managed (Scheme_Custodian_Reference * mr , Scheme_Object * o , 
Scheme_Close_Custodian_Client * * old_f , void * * old_data ) 
{
  Scheme_Custodian * m ; 
  int i , delta ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(m, 0), PUSH(o, 1), PUSH(old_f, 2), PUSH(old_data, 3)));
# define XfOrM63_COUNT (4)
# define SETUP_XfOrM63(x) SETUP(XfOrM63_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  m = NULLED_OUT ; 

# 1076 "bc/src/thread.c"
  if (! mr )
    RET_NOTHING ; 
  m = ((Scheme_Custodian_Weak_Box * ) mr ) -> val ; 
  if (! m )
    RET_NOTHING ; 

  i = (((Scheme_Custodian_Weak_Box * ) mr ) -> hash_key | ((m -> count ) & ~ 0xFFFF ) ) ; 
  delta = 0x10000 ; 

  while (i >= 0 ) {
#   define XfOrM69_COUNT (0+XfOrM63_COUNT)
#   define SETUP_XfOrM69(x) SETUP_XfOrM63(x)

# 1086 "bc/src/thread.c"
    if (i < m -> count ) {
#     define XfOrM70_COUNT (0+XfOrM69_COUNT)
#     define SETUP_XfOrM70(x) SETUP_XfOrM69(x)

# 1087 "bc/src/thread.c"
      if (m -> boxes [i ] && ((((((Scheme_Small_Object * ) (m -> boxes [i ] ) ) -> u . ptr_val ) ) ) == (o ) ) ) {
#       define XfOrM71_COUNT (0+XfOrM70_COUNT)
#       define SETUP_XfOrM71(x) SETUP_XfOrM70(x)

# 1088 "bc/src/thread.c"
        (((Scheme_Small_Object * ) (m -> boxes [i ] ) ) -> u . ptr_val ) = 0 ; 
        m -> boxes [i ] = ((void * ) 0 ) ; 
        ((Scheme_Custodian_Weak_Box * ) m -> mrefs [i ] ) -> val = 0 ; 
        m -> mrefs [i ] = ((void * ) 0 ) ; 
        if (old_f )
          * old_f = m -> closers [i ] ; 
        if (old_data )
          * old_data = m -> data [i ] ; 
        m -> data [i ] = ((void * ) 0 ) ; 
        -- m -> elems ; 
        FUNCCALL(SETUP_XfOrM71(_), adjust_limit_table (m ) ); 
        break ; 
      }
    }
    i -= delta ; 
  }

  while (m -> count && ! m -> boxes [m -> count - 1 ] ) {
    -- m -> count ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1110 "bc/src/thread.c"
static void adjust_custodian_family (void * mgr , void * skip_move ) 
{





  Scheme_Custodian * r = (Scheme_Custodian * ) mgr , * parent , * m ; 
  int i ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(skip_move, 1), PUSH(parent, 2)));
# define XfOrM72_COUNT (3)
# define SETUP_XfOrM72(x) SETUP(XfOrM72_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  parent = NULLED_OUT ; 
  m = NULLED_OUT ; 

# 1120 "bc/src/thread.c"
  parent = ((Scheme_Custodian_Weak_Box * ) r -> parent ) -> val ; 

  if (parent ) {
#   define XfOrM73_COUNT (0+XfOrM72_COUNT)
#   define SETUP_XfOrM73(x) SETUP_XfOrM72(x)

# 1124 "bc/src/thread.c"
    if (((Scheme_Custodian_Weak_Box * ) parent -> children ) -> val == r ) {
      ((Scheme_Custodian_Weak_Box * ) parent -> children ) -> val = ((Scheme_Custodian_Weak_Box * ) r -> sibling ) -> val ; 
    }

# 1126 "bc/src/thread.c"
    else {
      m = ((Scheme_Custodian_Weak_Box * ) parent -> children ) -> val ; 
      while (m && ((Scheme_Custodian_Weak_Box * ) m -> sibling ) -> val != r ) {
        m = ((Scheme_Custodian_Weak_Box * ) m -> sibling ) -> val ; 
      }
      if (m )
        ((Scheme_Custodian_Weak_Box * ) m -> sibling ) -> val = ((Scheme_Custodian_Weak_Box * ) r -> sibling ) -> val ; 
    }


    if (((Scheme_Custodian_Weak_Box * ) r -> global_next ) -> val )
      ((Scheme_Custodian_Weak_Box * ) ((Scheme_Custodian_Weak_Box * ) r -> global_next ) -> val -> global_prev ) -> val = ((Scheme_Custodian_Weak_Box * ) r -> global_prev ) -> val ; 
    ((Scheme_Custodian_Weak_Box * ) ((Scheme_Custodian_Weak_Box * ) r -> global_prev ) -> val -> global_next ) -> val = ((Scheme_Custodian_Weak_Box * ) r -> global_next ) -> val ; 


    for (m = ((Scheme_Custodian_Weak_Box * ) r -> children ) -> val ; m ; ) {
      Scheme_Custodian * next = ((Scheme_Custodian_Weak_Box * ) m -> sibling ) -> val ; 

      ((Scheme_Custodian_Weak_Box * ) m -> parent ) -> val = parent ; 
      ((Scheme_Custodian_Weak_Box * ) m -> sibling ) -> val = ((Scheme_Custodian_Weak_Box * ) parent -> children ) -> val ; 
      ((Scheme_Custodian_Weak_Box * ) parent -> children ) -> val = m ; 

      m = next ; 
    }
    FUNCCALL(SETUP_XfOrM73(_), adjust_limit_table (parent ) )
    ; 


    if (! skip_move ) {
#     define XfOrM74_COUNT (0+XfOrM73_COUNT)
#     define SETUP_XfOrM74(x) SETUP_XfOrM73(x)

# 1155 "bc/src/thread.c"
      for (i = 0 ; i < r -> count ; i ++ ) {
#       define XfOrM80_COUNT (0+XfOrM74_COUNT)
#       define SETUP_XfOrM80(x) SETUP_XfOrM74(x)

# 1156 "bc/src/thread.c"
        if (r -> boxes [i ] ) {
#         define XfOrM81_COUNT (0+XfOrM80_COUNT)
#         define SETUP_XfOrM81(x) SETUP_XfOrM80(x)

# 1157 "bc/src/thread.c"
          ((Scheme_Custodian_Weak_Box * ) r -> mrefs [i ] ) -> val = parent ; 
          FUNCCALL(SETUP_XfOrM81(_), add_managed_box (parent , r -> boxes [i ] , r -> mrefs [i ] , r -> closers [i ] , r -> data [i ] ) ); 

          {
            Scheme_Object * o ; 
            BLOCK_SETUP((PUSH(o, 0+XfOrM81_COUNT)));
#           define XfOrM82_COUNT (1+XfOrM81_COUNT)
#           define SETUP_XfOrM82(x) SETUP(XfOrM82_COUNT)
            o = NULLED_OUT ; 

# 1162 "bc/src/thread.c"
            o = (((Scheme_Small_Object * ) (r -> boxes [i ] ) ) -> u . ptr_val ) ; 
            if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_hop_type ) )  {
#             define XfOrM84_COUNT (0+XfOrM82_COUNT)
#             define SETUP_XfOrM84(x) SETUP_XfOrM82(x)

# 1164 "bc/src/thread.c"
              o = (((Scheme_Small_Object * ) (((Scheme_Thread_Custodian_Hop * ) o ) -> p ) ) -> u . ptr_val ) ; 
              if (o )
                FUNCCALL(SETUP_XfOrM84(_), GC_register_thread (o , parent ) ); 
            }

# 1167 "bc/src/thread.c"
            else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) )  {
#             define XfOrM83_COUNT (0+XfOrM82_COUNT)
#             define SETUP_XfOrM83(x) SETUP_XfOrM82(x)
              FUNCCALL(SETUP_XfOrM83(_), GC_register_thread (o , parent ) )
# 1168 "bc/src/thread.c"
              ; 
            }
          }
        }
      }
    }
  }


  ((Scheme_Custodian_Weak_Box * ) r -> parent ) -> val = ((void * ) 0 ) ; 
  ((Scheme_Custodian_Weak_Box * ) r -> sibling ) -> val = ((void * ) 0 ) ; 
  if (! skip_move )
    ((Scheme_Custodian_Weak_Box * ) r -> children ) -> val = ((void * ) 0 ) ; 
  ((Scheme_Custodian_Weak_Box * ) r -> global_prev ) -> val = ((void * ) 0 ) ; 
  ((Scheme_Custodian_Weak_Box * ) r -> global_next ) -> val = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1185 "bc/src/thread.c"
static void do_adjust_custodian_family (void * mgr , void * for_retain ) 
{
  /* No conversion */

# 1187 "bc/src/thread.c"
  adjust_custodian_family (mgr , ((void * ) 0 ) ) ; 
}

void insert_custodian (Scheme_Custodian * m , Scheme_Custodian * parent ) 
{
  /* No conversion */
  ((Scheme_Custodian_Weak_Box * ) m -> parent ) -> val = parent ; 
  if (parent ) {
    ((Scheme_Custodian_Weak_Box * ) m -> sibling ) -> val = ((Scheme_Custodian_Weak_Box * ) parent -> children ) -> val ; 
    ((Scheme_Custodian_Weak_Box * ) parent -> children ) -> val = m ; 
  }

# 1197 "bc/src/thread.c"
  else 
  ((Scheme_Custodian_Weak_Box * ) m -> sibling ) -> val = ((void * ) 0 ) ; 




  if (parent ) {
    Scheme_Custodian * next ; 
    next = ((Scheme_Custodian_Weak_Box * ) parent -> global_next ) -> val ; 
    ((Scheme_Custodian_Weak_Box * ) m -> global_next ) -> val = next ; 
    ((Scheme_Custodian_Weak_Box * ) m -> global_prev ) -> val = parent ; 
    ((Scheme_Custodian_Weak_Box * ) parent -> global_next ) -> val = m ; 
    if (next )
      ((Scheme_Custodian_Weak_Box * ) next -> global_prev ) -> val = m ; 
  }

# 1211 "bc/src/thread.c"
  else {
    ((Scheme_Custodian_Weak_Box * ) m -> global_next ) -> val = ((void * ) 0 ) ; 
    ((Scheme_Custodian_Weak_Box * ) m -> global_prev ) -> val = ((void * ) 0 ) ; 
  }

  if (parent )
    adjust_limit_table (parent ) ; 
}

Scheme_Custodian * scheme_make_custodian (Scheme_Custodian * parent ) 
{
  Scheme_Custodian * m ; 
  Scheme_Custodian_Reference * mw ; 
  void * * * data_ptr ; 
  DECL_RET_SAVE (Scheme_Custodian * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(m, 0), PUSH(data_ptr, 1), PUSH(mw, 2), PUSH(parent, 3)));
# define XfOrM96_COUNT (4)
# define SETUP_XfOrM96(x) SETUP(XfOrM96_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  m = NULLED_OUT ; 
  mw = NULLED_OUT ; 
  data_ptr = NULLED_OUT ; 

# 1226 "bc/src/thread.c"
  if (! parent )
    parent = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) ; 

  m = ((Scheme_Custodian * ) FUNCCALL(SETUP_XfOrM96(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Custodian ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  m -> so . type = scheme_custodian_type ; 

  m -> alloc = m -> count = 0 ; 

  mw = (Scheme_Custodian_Reference * ) FUNCCALL(SETUP_XfOrM96(_), scheme_make_late_weak_box (((void * ) 0 ) ) ); 
  m -> parent = mw ; 
  mw = (Scheme_Custodian_Reference * ) FUNCCALL(SETUP_XfOrM96(_), scheme_make_late_weak_box (((void * ) 0 ) ) ); 
  m -> children = mw ; 
  mw = (Scheme_Custodian_Reference * ) FUNCCALL(SETUP_XfOrM96(_), scheme_make_late_weak_box (((void * ) 0 ) ) ); 
  m -> sibling = mw ; 
  mw = (Scheme_Custodian_Reference * ) FUNCCALL(SETUP_XfOrM96(_), scheme_make_late_weak_box (((void * ) 0 ) ) ); 
  m -> global_next = mw ; 
  mw = (Scheme_Custodian_Reference * ) FUNCCALL(SETUP_XfOrM96(_), scheme_make_late_weak_box (((void * ) 0 ) ) ); 
  m -> global_prev = mw ; 

  ((Scheme_Custodian_Weak_Box * ) m -> children ) -> val = ((void * ) 0 ) ; 

  data_ptr = (void * * * ) FUNCCALL(SETUP_XfOrM96(_), GC_malloc (sizeof (void * * ) ) ); 
  m -> data_ptr = data_ptr ; 

  m -> post_callbacks = scheme_null ; 
  FUNCCALL(SETUP_XfOrM96(_), insert_custodian (m , parent ) )
  ; 
  FUNCCALL_AGAIN(scheme_add_finalizer (m , do_adjust_custodian_family , data_ptr ) )
  ; 

  RET_VALUE_START (m ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1260 "bc/src/thread.c"
static void rebox_willdone_object (void * o , void * mr ) 
{
  Scheme_Custodian * m = ((Scheme_Custodian_Weak_Box * ) (Scheme_Custodian_Reference * ) mr ) -> val ; 
  Scheme_Close_Custodian_Client * f ; 
  void * data ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(m, 0), PUSH(o, 1), PUSH(data, 2), PUSH(f, 3), PUSH(mr, 4)));
# define XfOrM97_COUNT (5)
# define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  f = NULLED_OUT ; 
  data = NULLED_OUT ; 

# 1267 "bc/src/thread.c"
  if (m ) {

    Scheme_Object * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM97_COUNT)));
#   define XfOrM98_COUNT (1+XfOrM97_COUNT)
#   define SETUP_XfOrM98(x) SETUP(XfOrM98_COUNT)
    b = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM98(_), remove_managed (mr , o , & f , & data ) ); 


    b = FUNCCALL_AGAIN(scheme_box (((void * ) 0 ) ) ); 



    (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) = o ; 


    ((Scheme_Custodian_Weak_Box * ) (Scheme_Custodian_Reference * ) mr ) -> val = m ; 
    FUNCCALL(SETUP_XfOrM98(_), add_managed_box (m , (Scheme_Object * * ) b , (Scheme_Custodian_Reference * ) mr , f , data ) )
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1290 "bc/src/thread.c"
static void managed_object_gone (void * o , void * mr ) 
{
  /* No conversion */

# 1292 "bc/src/thread.c"
  Scheme_Custodian * m = ((Scheme_Custodian_Weak_Box * ) (Scheme_Custodian_Reference * ) mr ) -> val ; 


  if (m )
    remove_managed (mr , o , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
}

int scheme_custodian_is_available (Scheme_Custodian * m ) XFORM_SKIP_PROC 

{
  if (m -> shut_down )
    return 0 ; 
  return 1 ; 
}

void scheme_custodian_check_available (Scheme_Custodian * m , const char * who , const char * what ) 
{
  Scheme_Config * __funcarg172 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(m, 1)));
# define XfOrM100_COUNT (2)
# define SETUP_XfOrM100(x) SETUP(XfOrM100_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1309 "bc/src/thread.c"
  if (! m )
    m = (Scheme_Custodian * ) (__funcarg172 = FUNCCALL(SETUP_XfOrM100(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg172 , MZCONFIG_CUSTODIAN ) )) ; 

  if (! FUNCCALL(SETUP_XfOrM100(_), scheme_custodian_is_available (m ) ))
    FUNCCALL_EMPTY(scheme_contract_error (who , "the custodian has been shut down" , "custodian" , 1 , m , ((void * ) 0 ) ) )

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1318 "bc/src/thread.c"
Scheme_Custodian_Reference * scheme_add_managed (Scheme_Custodian * m , Scheme_Object * o , 
Scheme_Close_Custodian_Client * f , void * data , 
int must_close ) 
{

  Scheme_Object * b ; 



  Scheme_Custodian_Reference * mr ; 
  Scheme_Config * __funcarg173 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Custodian_Reference * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(m, 0), PUSH(o, 1), PUSH(mr, 2), PUSH(data, 3), PUSH(f, 4), PUSH(b, 5)));
# define XfOrM101_COUNT (6)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 
  mr = NULLED_OUT ; 

# 1329 "bc/src/thread.c"
  if (! m )
    m = (Scheme_Custodian * ) (__funcarg173 = FUNCCALL(SETUP_XfOrM101(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg173 , MZCONFIG_CUSTODIAN ) )) ; 

  if (m -> shut_down ) {
#   define XfOrM102_COUNT (0+XfOrM101_COUNT)
#   define SETUP_XfOrM102(x) SETUP_XfOrM101(x)

    if (f )
      FUNCCALL(SETUP_XfOrM102(_), f (o , data ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }


  b = FUNCCALL(SETUP_XfOrM101(_), scheme_make_late_weak_box (((void * ) 0 ) ) ); 



  (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) = o ; 

  mr = (Scheme_Custodian_Reference * ) FUNCCALL(SETUP_XfOrM101(_), scheme_make_late_weak_box (((void * ) 0 ) ) ); 

  ((Scheme_Custodian_Weak_Box * ) mr ) -> val = m ; 





  if (must_close )
    FUNCCALL(SETUP_XfOrM101(_), scheme_add_finalizer (o , rebox_willdone_object , mr ) ); 
  else FUNCCALL(SETUP_XfOrM101(_), scheme_add_finalizer (o , managed_object_gone , mr ) )
  ; 
  FUNCCALL(SETUP_XfOrM101(_), add_managed_box (m , (Scheme_Object * * ) b , mr , f , data ) )
  ; 

  RET_VALUE_START (mr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1366 "bc/src/thread.c"
static void chain_close_at_exit (Scheme_Object * o , void * _data ) 

{
  /* No conversion */

# 1369 "bc/src/thread.c"
  Scheme_Object * data = (Scheme_Object * ) _data ; 
  Scheme_Close_Custodian_Client * f ; 
  void * * fp ; 

  fp = (void * * ) (((Scheme_Simple_Object * ) (data ) ) -> u . pair_val . car ) ; 

  if (fp ) {
    f = (Scheme_Close_Custodian_Client * ) * fp ; 
    (((Scheme_Simple_Object * ) (data ) ) -> u . pair_val . car ) = ((void * ) 0 ) ; 
    f (o , (((Scheme_Simple_Object * ) (data ) ) -> u . pair_val . cdr ) ) ; 
  }
}

Scheme_Custodian_Reference * scheme_add_managed_close_on_exit (Scheme_Custodian * m , Scheme_Object * o , 
Scheme_Close_Custodian_Client * f , void * data ) 
{
  void * * p ; 
  Scheme_Object * __funcarg174 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Custodian_Reference * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(o, 1), PUSH(m, 2), PUSH(data, 3), PUSH(f, 4)));
# define XfOrM105_COUNT (5)
# define SETUP_XfOrM105(x) SETUP(XfOrM105_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 1387 "bc/src/thread.c"
  p = (void * * ) FUNCCALL(SETUP_XfOrM105(_), GC_malloc_atomic (sizeof (void * ) ) ); 
  * p = f ; 

  RET_VALUE_START ((__funcarg174 = FUNCCALL(SETUP_XfOrM105(_), scheme_make_raw_pair ((Scheme_Object * ) p , (Scheme_Object * ) data ) )

  , FUNCCALL_EMPTY(scheme_add_managed (m , o , chain_close_at_exit , __funcarg174 , 1 ) )) ) 
# 1390 "bc/src/thread.c"
  RET_VALUE_END 


  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1396 "bc/src/thread.c"
void scheme_remove_managed (Scheme_Custodian_Reference * mr , Scheme_Object * o ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(mr, 1)));
# define XfOrM106_COUNT (2)
# define SETUP_XfOrM106(x) SETUP(XfOrM106_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM106(_), scheme_subtract_finalizer (o , managed_object_gone , mr ) )
# 1399 "bc/src/thread.c"
  ; 
  FUNCCALL(SETUP_XfOrM106(_), scheme_subtract_finalizer (o , rebox_willdone_object , mr ) ); 
  FUNCCALL_EMPTY(remove_managed (mr , o , ((void * ) 0 ) , ((void * ) 0 ) ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1405 "bc/src/thread.c"
static void call_registered_callback (Scheme_Object * v , void * callback ) 
{
  Scheme_Object * argv [1 ] ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(argv, 1, 0), PUSH(callback, 3)));
# define XfOrM107_COUNT (4)
# define SETUP_XfOrM107(x) SETUP(XfOrM107_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  argv[0] = NULLED_OUT ; 

# 1409 "bc/src/thread.c"
  argv [0 ] = v ; 
  FUNCCALL(SETUP_XfOrM107(_), scheme_start_in_scheduler () )
  ; 
  FUNCCALL_AGAIN(scheme_do_eval (callback , 1 , argv , - 1 ) ); 
  FUNCCALL_AGAIN(scheme_end_in_scheduler () ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1416 "bc/src/thread.c"
static Scheme_Object * unsafe_custodian_register (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Custodian_Reference * mr ; 
  Scheme_Custodian * custodian = (Scheme_Custodian * ) argv [0 ] ; 
  Scheme_Object * v = argv [1 ] ; 
  Scheme_Object * callback = argv [2 ] ; 
  int at_exit = (! (((argv [3 ] ) ) == (scheme_false ) ) ) ; 
  int init_weak = (! (((argv [4 ] ) ) == (scheme_false ) ) ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(custodian, 1), PUSH(callback, 2), PUSH(mr, 3)));
# define XfOrM108_COUNT (4)
# define SETUP_XfOrM108(x) SETUP(XfOrM108_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  mr = NULLED_OUT ; 

# 1427 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("unsafe-custodian-register" , "custodian?" , 0 , argc , argv ) ); 
  if (! (! (((intptr_t ) (callback ) ) & 0x1 ) && ((((callback ) -> type ) >= scheme_prim_type ) && (((callback ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("unsafe-custodian-register" , "procedure?" , 2 , argc , argv ) ); 

  if (! FUNCCALL(SETUP_XfOrM108(_), scheme_custodian_is_available (custodian ) ))
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  if (at_exit )
    mr = FUNCCALL(SETUP_XfOrM108(_), scheme_add_managed_close_on_exit (custodian , v , call_registered_callback , callback ) ); 
  else 
  mr = FUNCCALL(SETUP_XfOrM108(_), scheme_add_managed (custodian , v , call_registered_callback , callback , ! init_weak ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_cptr (mr , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1443 "bc/src/thread.c"
static Scheme_Object * unsafe_custodian_unregister (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1445 "bc/src/thread.c"
  Scheme_Object * v = argv [0 ] ; 
  Scheme_Custodian_Reference * mr = (Scheme_Custodian_Reference * ) (((Scheme_Cptr * ) (argv [1 ] ) ) -> val ) ; 

  scheme_remove_managed (mr , v ) ; 

  return scheme_void ; 
}

Scheme_Thread * scheme_do_close_managed (Scheme_Custodian * m , Scheme_Exit_Closer_Func cf ) 
{
  Scheme_Thread * kill_self = ((void * ) 0 ) ; 
  Scheme_Custodian * c , * start , * next_m ; 
  int i , is_thread ; 
  Scheme_Thread * the_thread ; 
  Scheme_Object * o ; 
  Scheme_Close_Custodian_Client * f ; 
  void * data ; 
  DECL_RET_SAVE (Scheme_Thread * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(next_m, 0), PUSH(start, 1), PUSH(data, 2), PUSH(m, 3), PUSH(o, 4), PUSH(kill_self, 5), PUSH(the_thread, 6), PUSH(f, 7)));
# define XfOrM110_COUNT (8)
# define SETUP_XfOrM110(x) SETUP(XfOrM110_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  c = NULLED_OUT ; 
  start = NULLED_OUT ; 
  next_m = NULLED_OUT ; 
  the_thread = NULLED_OUT ; 
  o = NULLED_OUT ; 
  f = NULLED_OUT ; 
  data = NULLED_OUT ; 

# 1463 "bc/src/thread.c"
  if (! m )
    m = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) ; 

  if (m -> shut_down )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  m -> shut_down = 1 ; 




  for (c = m ; ((Scheme_Custodian_Weak_Box * ) c -> children ) -> val ; ) {
    for (c = ((Scheme_Custodian_Weak_Box * ) c -> children ) -> val ; ((Scheme_Custodian_Weak_Box * ) c -> sibling ) -> val ; ) {
      c = ((Scheme_Custodian_Weak_Box * ) c -> sibling ) -> val ; 
    }
  }

  start = m ; 
  m = c ; 
  while (1 ) {
#   define XfOrM157_COUNT (0+XfOrM110_COUNT)
#   define SETUP_XfOrM157(x) SETUP_XfOrM110(x)
    for (i = m -> count ; i -- ; ) {
#     define XfOrM184_COUNT (0+XfOrM157_COUNT)
#     define SETUP_XfOrM184(x) SETUP_XfOrM157(x)

# 1486 "bc/src/thread.c"
      if (m -> boxes [i ] ) {
#       define XfOrM185_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM185(x) SETUP_XfOrM184(x)

# 1488 "bc/src/thread.c"
        o = (((Scheme_Small_Object * ) (m -> boxes [i ] ) ) -> u . ptr_val ) ; 

        f = m -> closers [i ] ; 
        data = m -> data [i ] ; 

        if (o && ! cf && (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_hop_type ) ) ) ) {

          is_thread = 1 ; 
          the_thread = (Scheme_Thread * ) (((Scheme_Small_Object * ) (((Scheme_Thread_Custodian_Hop * ) o ) -> p ) ) -> u . ptr_val ) ; 
        }

# 1497 "bc/src/thread.c"
        else {
          is_thread = 0 ; 
          the_thread = ((void * ) 0 ) ; 
        }

        (((Scheme_Small_Object * ) (m -> boxes [i ] ) ) -> u . ptr_val ) = ((void * ) 0 ) ; 
        ((Scheme_Custodian_Weak_Box * ) m -> mrefs [i ] ) -> val = ((void * ) 0 ) ; 



        m -> count = i ; 

        if (! o ) {
        }
        else if (is_thread && ! the_thread ) {
        }
        else if (cf ) {
#         define XfOrM198_COUNT (0+XfOrM185_COUNT)
#         define SETUP_XfOrM198(x) SETUP_XfOrM185(x)
          FUNCCALL(SETUP_XfOrM198(_), cf (o , f , data ) )
# 1514 "bc/src/thread.c"
          ; 
        }

# 1515 "bc/src/thread.c"
        else {
#         define XfOrM186_COUNT (0+XfOrM185_COUNT)
#         define SETUP_XfOrM186(x) SETUP_XfOrM185(x)

# 1516 "bc/src/thread.c"
          if (is_thread ) {
#           define XfOrM188_COUNT (0+XfOrM186_COUNT)
#           define SETUP_XfOrM188(x) SETUP_XfOrM186(x)

# 1517 "bc/src/thread.c"
            if (the_thread ) {
#             define XfOrM189_COUNT (0+XfOrM188_COUNT)
#             define SETUP_XfOrM189(x) SETUP_XfOrM188(x)

# 1519 "bc/src/thread.c"
              if ((the_thread -> extra_mrefs ) == (scheme_null ) )  {
#               define XfOrM197_COUNT (0+XfOrM189_COUNT)
#               define SETUP_XfOrM197(x) SETUP_XfOrM189(x)

# 1520 "bc/src/thread.c"
                if (FUNCCALL(SETUP_XfOrM197(_), do_kill_thread (the_thread ) ))
                  kill_self = the_thread ; 
              }

# 1522 "bc/src/thread.c"
              else {
                Scheme_Custodian_Reference * mref ; 
                BLOCK_SETUP((PUSH(mref, 0+XfOrM189_COUNT)));
#               define XfOrM190_COUNT (1+XfOrM189_COUNT)
#               define SETUP_XfOrM190(x) SETUP(XfOrM190_COUNT)
                mref = NULLED_OUT ; 

# 1525 "bc/src/thread.c"
                mref = m -> mrefs [i ] ; 
                if (mref == the_thread -> mref ) {
#                 define XfOrM196_COUNT (0+XfOrM190_COUNT)
#                 define SETUP_XfOrM196(x) SETUP_XfOrM190(x)

# 1528 "bc/src/thread.c"
                  mref = (Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (the_thread -> extra_mrefs ) ) -> u . pair_val . car ) ; 
                  the_thread -> mref = mref ; 
                  the_thread -> extra_mrefs = (((Scheme_Simple_Object * ) (the_thread -> extra_mrefs ) ) -> u . pair_val . cdr ) ; 
                  FUNCCALL(SETUP_XfOrM196(_), GC_register_thread (the_thread , ((Scheme_Custodian_Weak_Box * ) mref ) -> val ) )
                  ; 
                }
                else {

                  Scheme_Object * l , * prev = ((void * ) 0 ) ; 
                  l = NULLED_OUT ; 

# 1537 "bc/src/thread.c"
                  for (l = the_thread -> extra_mrefs ; 1 ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
                    if (((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) == ((Scheme_Object * ) mref ) )  {
                      if (prev )
                        (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
                      else 
                      the_thread -> extra_mrefs = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
                      break ; 
                    }
                    prev = l ; 
                  }
                }
              }
            }
          }

# 1550 "bc/src/thread.c"
          else if (f ) {
#           define XfOrM187_COUNT (0+XfOrM186_COUNT)
#           define SETUP_XfOrM187(x) SETUP_XfOrM186(x)
            FUNCCALL(SETUP_XfOrM187(_), f (o , data ) )
# 1551 "bc/src/thread.c"
            ; 
          }
        }
      }
    }


    {
      Scheme_Object * pr = m -> cust_boxes , * wb ; 
      Scheme_Custodian_Box * cb ; 
      wb = NULLED_OUT ; 
      cb = NULLED_OUT ; 

# 1561 "bc/src/thread.c"
      while (pr ) {
        wb = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ; 
        cb = (Scheme_Custodian_Box * ) (((Scheme_Small_Object * ) (wb ) ) -> u . ptr_val ) ; 
        if (cb )

# 1564 "bc/src/thread.c"
        cb -> v = ((void * ) 0 ) ; 
        pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
      }
      m -> cust_boxes = ((void * ) 0 ) ; 
    }


    if ((Scheme_Type ) (((((intptr_t ) (m -> post_callbacks ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (m -> post_callbacks ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
      Scheme_Object * proc ; 
      BLOCK_SETUP((PUSH(proc, 0+XfOrM157_COUNT)));
#     define XfOrM159_COUNT (1+XfOrM157_COUNT)
#     define SETUP_XfOrM159(x) SETUP(XfOrM159_COUNT)
      proc = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM159(_), scheme_start_in_scheduler () )
# 1573 "bc/src/thread.c"
      ; 
      while (((Scheme_Type ) (((((intptr_t ) (m -> post_callbacks ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (m -> post_callbacks ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#       define XfOrM161_COUNT (0+XfOrM159_COUNT)
#       define SETUP_XfOrM161(x) SETUP_XfOrM159(x)

# 1575 "bc/src/thread.c"
        proc = (((Scheme_Simple_Object * ) (m -> post_callbacks ) ) -> u . pair_val . car ) ; 
        m -> post_callbacks = (((Scheme_Simple_Object * ) (m -> post_callbacks ) ) -> u . pair_val . cdr ) ; 
        FUNCCALL(SETUP_XfOrM161(_), scheme_do_eval (proc , 0 , ((void * ) 0 ) , - 1 ) ); 
      }
      FUNCCALL(SETUP_XfOrM159(_), scheme_end_in_scheduler () ); 
    }

    m -> count = 0 ; 
    m -> alloc = 0 ; 
    m -> elems = 0 ; 
    m -> boxes = ((void * ) 0 ) ; 
    m -> closers = ((void * ) 0 ) ; 
    m -> data = ((void * ) 0 ) ; 
    * m -> data_ptr = ((void * ) 0 ) ; 
    m -> mrefs = ((void * ) 0 ) ; 
    m -> shut_down = 1 ; 

    if ((m ) == (start ) )  {
#     define XfOrM158_COUNT (0+XfOrM157_COUNT)
#     define SETUP_XfOrM158(x) SETUP_XfOrM157(x)
      FUNCCALL(SETUP_XfOrM158(_), adjust_limit_table (m ) )
# 1593 "bc/src/thread.c"
      ; 
      break ; 
    }
    next_m = ((Scheme_Custodian_Weak_Box * ) m -> global_prev ) -> val ; 
    FUNCCALL(SETUP_XfOrM157(_), adjust_custodian_family (m , m ) )

    ; 
    FUNCCALL_AGAIN(adjust_limit_table (m ) )
    ; 

    m = next_m ; 
  }





  RET_VALUE_START (kill_self ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1613 "bc/src/thread.c"
static void do_close_managed (Scheme_Custodian * m ) 



{
  /* No conversion */

# 1618 "bc/src/thread.c"
  if (scheme_do_close_managed (m , ((void * ) 0 ) ) ) {

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_to_kill )
      suspend_thread (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ; 
    else 
    scheme_thread_block (0.0 ) ; 
  }
}

void scheme_close_managed (Scheme_Custodian * m ) 
{
  /* No conversion */

# 1629 "bc/src/thread.c"
  do_close_managed (m ) ; 


  scheme_thread_block (0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
}

static Scheme_Object * make_custodian (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Custodian * m ; 
  Scheme_Config * __funcarg175 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(m, 0)));
# define XfOrM212_COUNT (1)
# define SETUP_XfOrM212(x) SETUP(XfOrM212_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  m = NULLED_OUT ; 

# 1640 "bc/src/thread.c"
  if (argc ) {
#   define XfOrM213_COUNT (0+XfOrM212_COUNT)
#   define SETUP_XfOrM213(x) SETUP_XfOrM212(x)

# 1641 "bc/src/thread.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-custodian" , "custodian?" , 0 , argc , argv ) ); 
    m = (Scheme_Custodian * ) argv [0 ] ; 
  }

# 1644 "bc/src/thread.c"
  else 
  m = (Scheme_Custodian * ) (__funcarg175 = FUNCCALL(SETUP_XfOrM212(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg175 , MZCONFIG_CUSTODIAN ) )) ; 

  if (m -> shut_down )
    FUNCCALL_EMPTY(scheme_contract_error ("make-custodian" , "the custodian has been shut down" , "custodian" , 1 , m , ((void * ) 0 ) ) )


  ; 

  RET_VALUE_START ((Scheme_Object * ) FUNCCALL_EMPTY(scheme_make_custodian (m ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1656 "bc/src/thread.c"
static Scheme_Object * unsafe_make_custodian_at_root (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1658 "bc/src/thread.c"
  return (Scheme_Object * ) scheme_make_custodian (((void * ) 0 ) ) ; 
}

static Scheme_Object * custodian_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1663 "bc/src/thread.c"
  return ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * custodian_close_all (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1668 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) )
    scheme_wrong_contract ("custodian-shutdown-all" , "custodian?" , 0 , argc , argv ) ; 

  scheme_close_managed ((Scheme_Custodian * ) argv [0 ] ) ; 

  return scheme_void ; 
}

static Scheme_Object * custodian_shut_down_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1678 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) )
    scheme_wrong_contract ("custodian-shut-down?" , "custodian?" , 0 , argc , argv ) ; 

  return (((Scheme_Custodian * ) argv [0 ] ) -> shut_down 
  ? scheme_true 
  : scheme_false ) ; 
}

Scheme_Custodian * scheme_custodian_extract_reference (Scheme_Custodian_Reference * mr ) 
{
  /* No conversion */

# 1688 "bc/src/thread.c"
  return ((Scheme_Custodian_Weak_Box * ) mr ) -> val ; 
}

int scheme_custodian_is_shut_down (Scheme_Custodian * c ) 
{
  /* No conversion */

# 1693 "bc/src/thread.c"
  return c -> shut_down ; 
}

static Scheme_Object * extract_thread (Scheme_Object * o ) 
{
  /* No conversion */

# 1698 "bc/src/thread.c"
  return (Scheme_Object * ) (((Scheme_Small_Object * ) (((Scheme_Thread_Custodian_Hop * ) o ) -> p ) ) -> u . ptr_val ) ; 
}

void scheme_init_custodian_extractors () 
{
  /* No conversion */

# 1703 "bc/src/thread.c"
  if (! extractors ) {
    int n ; 
    n = scheme_num_types () ; 
    scheme_register_static ((void * ) & extractors , sizeof (extractors ) ) ; 
    extractors = ((Scheme_Custodian_Extractor * ) GC_malloc_atomic (sizeof (Scheme_Custodian_Extractor ) * (n ) ) ) ; 
    memset (extractors , 0 , sizeof (Scheme_Custodian_Extractor ) * n ) ; 
    extractors [scheme_thread_hop_type ] = extract_thread ; 
  }
}

void scheme_add_custodian_extractor (Scheme_Type t , Scheme_Custodian_Extractor e ) 
{
  /* No conversion */

# 1715 "bc/src/thread.c"
  if (t ) {
    extractors [t ] = e ; 
  }
}

static Scheme_Object * custodian_to_list (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Custodian * m , * m2 , * c ; 
  Scheme_Object * * hold , * o ; 
  int i , j , cnt , kids ; 
  Scheme_Type type ; 
  Scheme_Custodian_Extractor ex ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(m, 0), PUSH(c, 1), PUSH(o, 2), PUSH(hold, 3)));
# define XfOrM225_COUNT (4)
# define SETUP_XfOrM225(x) SETUP(XfOrM225_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  m = NULLED_OUT ; 
  m2 = NULLED_OUT ; 
  c = NULLED_OUT ; 
  hold = NULLED_OUT ; 
  o = NULLED_OUT ; 

# 1728 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("custodian-managed-list" , "custodian?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("custodian-managed-list" , "custodian?" , 1 , argc , argv ) ); 

  m = (Scheme_Custodian * ) argv [0 ] ; 
  m2 = (Scheme_Custodian * ) argv [1 ] ; 


  c = ((Scheme_Custodian_Weak_Box * ) m -> parent ) -> val ; 
  while (c && ((m2 ) != (c ) ) ) {
    c = ((Scheme_Custodian_Weak_Box * ) c -> parent ) -> val ; 
  }
  if (! c ) {
#   define XfOrM242_COUNT (0+XfOrM225_COUNT)
#   define SETUP_XfOrM242(x) SETUP_XfOrM225(x)
    FUNCCALL_EMPTY(scheme_contract_error ("custodian-managed-list" , "the second custodian does not " "manage the first custodian" , "first custodian" , 1 , argv [0 ] , "second custodian" , 1 , argv [1 ] , ((void * ) 0 ) ) )


    ; 
  }


  kids = 0 ; 
  for (c = ((Scheme_Custodian_Weak_Box * ) m -> children ) -> val ; c ; c = ((Scheme_Custodian_Weak_Box * ) c -> sibling ) -> val ) {
    kids ++ ; 
  }





  do {
#   define XfOrM239_COUNT (0+XfOrM225_COUNT)
#   define SETUP_XfOrM239(x) SETUP_XfOrM225(x)

# 1761 "bc/src/thread.c"
    cnt = m -> count ; 
    hold = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM239(_), GC_malloc (sizeof (Scheme_Object * ) * (cnt + kids ) ) )) ; 
  }

# 1763 "bc/src/thread.c"
  while (cnt < m -> count ) ; 


  for (i = m -> count , j = 0 ; i -- ; ) {
#   define XfOrM233_COUNT (0+XfOrM225_COUNT)
#   define SETUP_XfOrM233(x) SETUP_XfOrM225(x)

# 1767 "bc/src/thread.c"
    if (m -> boxes [i ] ) {
#     define XfOrM234_COUNT (0+XfOrM233_COUNT)
#     define SETUP_XfOrM234(x) SETUP_XfOrM233(x)

# 1768 "bc/src/thread.c"
      o = (((Scheme_Small_Object * ) (m -> boxes [i ] ) ) -> u . ptr_val ) ; 

      if (o ) {
#       define XfOrM235_COUNT (0+XfOrM234_COUNT)
#       define SETUP_XfOrM235(x) SETUP_XfOrM234(x)

# 1771 "bc/src/thread.c"
        type = ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ; 
        ex = extractors [type ] ; 
        if (ex ) {
#         define XfOrM237_COUNT (0+XfOrM235_COUNT)
#         define SETUP_XfOrM237(x) SETUP_XfOrM235(x)

# 1774 "bc/src/thread.c"
          o = FUNCCALL(SETUP_XfOrM237(_), ex (o ) ); 
        }

        if (o ) {
          hold [j ] = o ; 
          j ++ ; 
        }
      }
    }
  }

  for (c = ((Scheme_Custodian_Weak_Box * ) m -> children ) -> val ; c ; c = ((Scheme_Custodian_Weak_Box * ) c -> sibling ) -> val ) {
    hold [j ] = (Scheme_Object * ) c ; 
    j ++ ; 
  }


  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_build_list (j , hold ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1794 "bc/src/thread.c"
static Scheme_Object * current_custodian (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1796 "bc/src/thread.c"
  return scheme_param_config2 ("current-custodian" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_CUSTODIAN ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , custodian_p , "custodian?" , 0 ) ; 
}

Scheme_Custodian * scheme_get_current_custodian () 
{
  /* No conversion */

# 1804 "bc/src/thread.c"
  return (Scheme_Custodian * ) current_custodian (0 , ((void * ) 0 ) ) ; 
}

static Scheme_Object * make_custodian_box (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Custodian_Box * cb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(cb, 1)));
# define XfOrM247_COUNT (2)
# define SETUP_XfOrM247(x) SETUP(XfOrM247_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cb = NULLED_OUT ; 

# 1811 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-custodian-box" , "custodian?" , 0 , argc , argv ) ); 

  cb = ((Scheme_Custodian_Box * ) FUNCCALL(SETUP_XfOrM247(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Custodian_Box ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  cb -> so . type = scheme_cust_box_type ; 
  cb -> cust = (Scheme_Custodian * ) argv [0 ] ; 
  cb -> v = argv [1 ] ; 



  {
    Scheme_Object * wb , * pr , * prev ; 
    BLOCK_SETUP((PUSH(prev, 0+XfOrM247_COUNT), PUSH(pr, 1+XfOrM247_COUNT), PUSH(wb, 2+XfOrM247_COUNT)));
#   define XfOrM248_COUNT (3+XfOrM247_COUNT)
#   define SETUP_XfOrM248(x) SETUP(XfOrM248_COUNT)
    wb = NULLED_OUT ; 
    pr = NULLED_OUT ; 
    prev = NULLED_OUT ; 

# 1823 "bc/src/thread.c"
    wb = FUNCCALL(SETUP_XfOrM248(_), GC_malloc_weak_box (cb , ((void * ) 0 ) , 0 , 1 ) ); 
    pr = FUNCCALL_AGAIN(scheme_make_raw_pair (wb , cb -> cust -> cust_boxes ) ); 
    cb -> cust -> cust_boxes = pr ; 
    cb -> cust -> num_cust_boxes ++ ; 



    if (cb -> cust -> num_cust_boxes > 2 * cb -> cust -> checked_cust_boxes ) {
      prev = pr ; 
      pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
      while (pr ) {
        wb = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ; 
        if (! (((Scheme_Small_Object * ) (pr ) ) -> u . ptr_val ) ) {
          (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
          -- cb -> cust -> num_cust_boxes ; 
        }

# 1838 "bc/src/thread.c"
        else {
          prev = pr ; 
        }
        pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
      }
      cb -> cust -> checked_cust_boxes = cb -> cust -> num_cust_boxes ; 
    }
  }

# 1864 "bc/src/thread.c"
  RET_VALUE_START ((Scheme_Object * ) cb ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1867 "bc/src/thread.c"
static Scheme_Object * custodian_box_value (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1869 "bc/src/thread.c"
  Scheme_Custodian_Box * cb ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cust_box_type ) ) )
    scheme_wrong_contract ("custodian-box-value" , "custodian-box?" , 0 , argc , argv ) ; 

  cb = (Scheme_Custodian_Box * ) argv [0 ] ; 
  if (cb -> cust -> shut_down )
    return scheme_false ; 

  return cb -> v ; 
}

static Scheme_Object * custodian_box_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1883 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cust_box_type ) ) 
    return scheme_true ; 
  else 
  return scheme_false ; 
}

static int cust_box_ready (Scheme_Object * o ) 
{
  /* No conversion */

# 1891 "bc/src/thread.c"
  return ((Scheme_Custodian_Box * ) o ) -> cust -> shut_down ; 
}

# 1938 "bc/src/thread.c"
void scheme_run_atexit_closers (Scheme_Object * o , Scheme_Close_Custodian_Client * f , void * data ) 
{
  Scheme_Object * l ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(l, 1), PUSH(data, 2), PUSH(f, 3)));
# define XfOrM259_COUNT (4)
# define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 

# 1942 "bc/src/thread.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cust_closers_ ) ) {
#   define XfOrM260_COUNT (0+XfOrM259_COUNT)
#   define SETUP_XfOrM260(x) SETUP_XfOrM259(x)

# 1943 "bc/src/thread.c"
    for (l = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cust_closers_ ) ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
      Scheme_Exit_Closer_Func cf ; 
#     define XfOrM262_COUNT (0+XfOrM260_COUNT)
#     define SETUP_XfOrM262(x) SETUP_XfOrM260(x)

# 1945 "bc/src/thread.c"
      cf = (Scheme_Exit_Closer_Func ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      FUNCCALL(SETUP_XfOrM262(_), cf (o , f , data ) ); 
    }
  }

  if (f == chain_close_at_exit )
    FUNCCALL_EMPTY(f (o , data ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1954 "bc/src/thread.c"
void scheme_run_atexit_closers_on_all (Scheme_Exit_Closer_Func alt ) 
{
  mz_jmp_buf newbuf , * savebuf ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(savebuf, 0)));
# define XfOrM263_COUNT (1)
# define SETUP_XfOrM263(x) SETUP(XfOrM263_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  savebuf = NULLED_OUT ; 

# 1964 "bc/src/thread.c"
  if (gcs_on_exit ) {
#   define XfOrM265_COUNT (0+XfOrM263_COUNT)
#   define SETUP_XfOrM265(x) SETUP_XfOrM263(x)
    FUNCCALL(SETUP_XfOrM265(_), scheme_collect_garbage () )
# 1965 "bc/src/thread.c"
    ; 
    FUNCCALL(SETUP_XfOrM265(_), scheme_collect_garbage () ); 
  }
  FUNCCALL(SETUP_XfOrM263(_), log_peak_memory_use () )
  ; 

  savebuf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 
  if (! ((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM263_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#   define XfOrM264_COUNT (0+XfOrM263_COUNT)
#   define SETUP_XfOrM264(x) SETUP_XfOrM263(x)
    FUNCCALL(SETUP_XfOrM264(_), scheme_do_close_managed (((void * ) 0 ) , alt ? alt : scheme_run_atexit_closers ) )
# 1974 "bc/src/thread.c"
    ; 
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = savebuf ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1979 "bc/src/thread.c"
void do_run_atexit_closers_on_all () 
{
  /* No conversion */

# 1981 "bc/src/thread.c"
  scheme_run_atexit_closers_on_all (((void * ) 0 ) ) ; 
}

static Scheme_Object * unsafe_add_post_custodian_shutdown (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Custodian * c ; 
  Scheme_Object * l ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(c, 1), PUSH(l, 2)));
# define XfOrM267_COUNT (3)
# define SETUP_XfOrM267(x) SETUP(XfOrM267_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  c = NULLED_OUT ; 
  l = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM267(_), scheme_check_proc_arity ("unsafe-add-post-custodian-shutdown" , 0 , 0 , argc , argv ) )
# 1989 "bc/src/thread.c"
  ; 

  if ((argc > 1 ) 
  && ! ((((argv [1 ] ) ) == (scheme_false ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("unsafe-add-post-custodian-shutdown" , "custodian?" , 1 , argc , argv ) ); 

  if ((argc > 1 ) && ! (((argv [1 ] ) ) == (scheme_false ) ) )
    c = (Scheme_Custodian * ) argv [1 ] ; 
  else 
  c = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) ; 


  if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) == 0 ) 
  && (c == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) ) )
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 


  l = FUNCCALL(SETUP_XfOrM267(_), scheme_make_pair (argv [0 ] , c -> post_callbacks ) ); 
  c -> post_callbacks = l ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2013 "bc/src/thread.c"
void scheme_set_atexit (Scheme_At_Exit_Proc p ) 
{
  /* No conversion */

# 2015 "bc/src/thread.c"
  replacement_at_exit = p ; 
}

void scheme_add_atexit_closer (Scheme_Exit_Closer_Func f ) 
{
  /* No conversion */

# 2020 "bc/src/thread.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cust_closers_ ) ) {
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) == 0 )  {
      scheme_atexit (do_run_atexit_closers_on_all ) ; 
    }

    scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cust_closers_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cust_closers_ ) ) ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cust_closers_ ) = scheme_null ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cust_closers_ ) = scheme_make_raw_pair ((Scheme_Object * ) f , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cust_closers_ ) ) ; 
}

int scheme_atexit (void (* func ) (void ) ) 
{
  /* No conversion */

# 2034 "bc/src/thread.c"
  if (replacement_at_exit ) {
    return replacement_at_exit (func ) ; 
  }

# 2036 "bc/src/thread.c"
  else {



    return atexit (func ) ; 
  }
}


void scheme_schedule_custodian_close (Scheme_Custodian * c ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(c, 0)));
# define XfOrM275_COUNT (1)
# define SETUP_XfOrM275(x) SETUP(XfOrM275_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2050 "bc/src/thread.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) ) {
#   define XfOrM276_COUNT (0+XfOrM275_COUNT)
#   define SETUP_XfOrM276(x) SETUP_XfOrM275(x)
    FUNCCALL(SETUP_XfOrM276(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) ) ) )
# 2051 "bc/src/thread.c"
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) = scheme_null ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) = FUNCCALL_EMPTY(scheme_make_pair ((Scheme_Object * ) c , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_jit_stack_boundary_ ) = (uintptr_t ) - 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2060 "bc/src/thread.c"
static void check_scheduled_kills () 
{
  int force_gc = 0 ; 
  PREPARE_VAR_STACK(1);
# define XfOrM277_COUNT (0)
# define SETUP_XfOrM277(x) SETUP(XfOrM277_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2064 "bc/src/thread.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) {

    RET_NOTHING ; 
  }

  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) && ! ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) ) == (scheme_null ) ) ) {
    Scheme_Object * k ; 
    BLOCK_SETUP((PUSH(k, 0+XfOrM277_COUNT)));
#   define XfOrM280_COUNT (1+XfOrM277_COUNT)
#   define SETUP_XfOrM280(x) SETUP(XfOrM280_COUNT)
    k = NULLED_OUT ; 

# 2071 "bc/src/thread.c"
    k = (((Scheme_Simple_Object * ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) ) ) -> u . pair_val . car ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) = (((Scheme_Simple_Object * ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheduled_kills_ ) ) ) -> u . pair_val . cdr ) ; 
    FUNCCALL(SETUP_XfOrM280(_), do_close_managed ((Scheme_Custodian * ) k ) ); 
    force_gc = 1 ; 
  }

  if (force_gc ) {
#   define XfOrM278_COUNT (0+XfOrM277_COUNT)
#   define SETUP_XfOrM278(x) SETUP_XfOrM277(x)
    FUNCCALL_EMPTY(scheme_collect_garbage () )


    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2087 "bc/src/thread.c"
static void check_current_custodian_allows (const char * who , Scheme_Thread * p ) 
{
  Scheme_Object * l ; 
  Scheme_Custodian_Reference * mref ; 
  Scheme_Custodian * m , * current ; 
  Scheme_Config * __funcarg176 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(current, 1), PUSH(m, 2), PUSH(l, 3), PUSH(mref, 4), PUSH(p, 5)));
# define XfOrM282_COUNT (6)
# define SETUP_XfOrM282(x) SETUP(XfOrM282_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  mref = NULLED_OUT ; 
  m = NULLED_OUT ; 
  current = NULLED_OUT ; 

# 2094 "bc/src/thread.c"
  current = (Scheme_Custodian * ) (__funcarg176 = FUNCCALL(SETUP_XfOrM282(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg176 , MZCONFIG_CUSTODIAN ) )) ; 

  for (l = p -> extra_mrefs ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
    mref = (Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    m = ((Scheme_Custodian_Weak_Box * ) mref ) -> val ; 
    while (((m ) != (current ) ) ) {
      m = ((Scheme_Custodian_Weak_Box * ) m -> parent ) -> val ; 
      if (! m )
        goto bad ; 
    }
  }

  mref = p -> mref ; 
  if (! mref )
    RET_NOTHING ; 
  m = ((Scheme_Custodian_Weak_Box * ) mref ) -> val ; 
  if (! m )
    RET_NOTHING ; 

  while (((m ) != (current ) ) ) {
    m = ((Scheme_Custodian_Weak_Box * ) m -> parent ) -> val ; 
    if (! m )
      goto bad ; 
  }

  RET_NOTHING ; 

  bad : FUNCCALL_EMPTY(scheme_contract_error (who , "the current custodian does not " "solely manage the specified thread" , "thread" , 1 , p , ((void * ) 0 ) ) )




  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2129 "bc/src/thread.c"
void scheme_free_all (void ) 
{
  /* No conversion */

# 2131 "bc/src/thread.c"
  scheme_do_close_managed (((void * ) 0 ) , ((void * ) 0 ) ) ; 
  scheme_free_dynamic_extensions () ; 

  GC_free_all () ; 
}








Scheme_Object * get_plumber_handles (Scheme_Plumber * p ) 
{
  Scheme_Object * v , * r = scheme_null ; 
  Scheme_Bucket_Table * bt ; 
  Scheme_Hash_Table * ht ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(ht, 1), PUSH(bt, 2), PUSH(r, 3), PUSH(p, 4)));
# define XfOrM292_COUNT (5)
# define SETUP_XfOrM292(x) SETUP(XfOrM292_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  bt = NULLED_OUT ; 
  ht = NULLED_OUT ; 

# 2151 "bc/src/thread.c"
  bt = p -> weak_handles ; 
  if (bt ) {
#   define XfOrM299_COUNT (0+XfOrM292_COUNT)
#   define SETUP_XfOrM299(x) SETUP_XfOrM292(x)

# 2153 "bc/src/thread.c"
    for (i = bt -> size ; i -- ; ) {
#     define XfOrM305_COUNT (0+XfOrM299_COUNT)
#     define SETUP_XfOrM305(x) SETUP_XfOrM299(x)

# 2154 "bc/src/thread.c"
      if (bt -> buckets [i ] ) {
#       define XfOrM306_COUNT (0+XfOrM305_COUNT)
#       define SETUP_XfOrM306(x) SETUP_XfOrM305(x)

# 2155 "bc/src/thread.c"
        v = (Scheme_Object * ) (((Scheme_Small_Object * ) (bt -> buckets [i ] -> key ) ) -> u . ptr_val ) ; 
        if (v ) {
#         define XfOrM307_COUNT (0+XfOrM306_COUNT)
#         define SETUP_XfOrM307(x) SETUP_XfOrM306(x)

# 2157 "bc/src/thread.c"
          r = FUNCCALL(SETUP_XfOrM307(_), scheme_make_pair (v , r ) ); 
          {
#           define XfOrM308_COUNT (0+XfOrM307_COUNT)
#           define SETUP_XfOrM308(x) SETUP_XfOrM307(x)

# 2158 "bc/src/thread.c"
            if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#             define XfOrM309_COUNT (0+XfOrM308_COUNT)
#             define SETUP_XfOrM309(x) SETUP_XfOrM308(x)
              FUNCCALL(SETUP_XfOrM309(_), scheme_out_of_fuel () )
# 2158 "bc/src/thread.c"
              ; 
            }
          }

# 2158 "bc/src/thread.c"
          ; 
        }
      }
    }
  }

  ht = p -> handles ; 
  for (i = ht -> size ; i -- ; ) {
#   define XfOrM296_COUNT (0+XfOrM292_COUNT)
#   define SETUP_XfOrM296(x) SETUP_XfOrM292(x)

# 2166 "bc/src/thread.c"
    if (ht -> vals [i ] )
      r = FUNCCALL(SETUP_XfOrM296(_), scheme_make_pair (ht -> keys [i ] , r ) ); 
    {
#     define XfOrM297_COUNT (0+XfOrM296_COUNT)
#     define SETUP_XfOrM297(x) SETUP_XfOrM296(x)

# 2168 "bc/src/thread.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM298_COUNT (0+XfOrM297_COUNT)
#       define SETUP_XfOrM298(x) SETUP_XfOrM297(x)
        FUNCCALL(SETUP_XfOrM298(_), scheme_out_of_fuel () )
# 2168 "bc/src/thread.c"
        ; 
      }
    }

# 2168 "bc/src/thread.c"
    ; 
  }

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2174 "bc/src/thread.c"
int scheme_flush_managed (Scheme_Plumber * p , int catch_errors ) 
{
  Scheme_Object * r , * h , * o , * a [1 ] ; 
  Scheme_Thread * pt ; 
  mz_jmp_buf * volatile saved_error_buf ; 
  mz_jmp_buf new_error_buf ; 
  volatile int escaped = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(saved_error_buf, 1), PUSH(h, 2), PUSH(r, 3), PUSHARRAY(a, 1, 4), PUSH(o, 7)));
# define XfOrM310_COUNT (8)
# define SETUP_XfOrM310(x) SETUP(XfOrM310_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  r = NULLED_OUT ; 
  h = NULLED_OUT ; 
  o = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  pt = NULLED_OUT ; 
  saved_error_buf = NULLED_OUT ; 

# 2182 "bc/src/thread.c"
  if (! p )

# 2182 "bc/src/thread.c"
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_plumber_ ) ; 

  if (catch_errors ) {
    pt = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    saved_error_buf = pt -> error_buf ; 
    pt -> error_buf = & new_error_buf ; 
  }

# 2188 "bc/src/thread.c"
  else 
  saved_error_buf = ((void * ) 0 ) ; 

  if (! ((new_error_buf ) . gcvs = (intptr_t ) __gc_var_stack__ , (new_error_buf ) . gcvs_cnt = XfOrM310_COUNT , (_setjmp ((new_error_buf ) . jb ) ) ) ) {
#   define XfOrM312_COUNT (0+XfOrM310_COUNT)
#   define SETUP_XfOrM312(x) SETUP_XfOrM310(x)

# 2192 "bc/src/thread.c"
    r = FUNCCALL(SETUP_XfOrM312(_), get_plumber_handles (p ) ); 

    while (! ((r ) == (scheme_null ) ) ) {
#     define XfOrM316_COUNT (0+XfOrM312_COUNT)
#     define SETUP_XfOrM316(x) SETUP_XfOrM312(x)

# 2195 "bc/src/thread.c"
      h = (((Scheme_Simple_Object * ) (r ) ) -> u . pair_val . car ) ; 

      o = (((Scheme_Simple_Object * ) (h ) ) -> u . two_ptr_val . ptr2 ) ; 

      if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) )  {
#       define XfOrM318_COUNT (0+XfOrM316_COUNT)
#       define SETUP_XfOrM318(x) SETUP_XfOrM316(x)
        FUNCCALL(SETUP_XfOrM318(_), scheme_flush_if_output_fds (o ) )
# 2200 "bc/src/thread.c"
        ; 
      }

# 2201 "bc/src/thread.c"
      else {
#       define XfOrM317_COUNT (0+XfOrM316_COUNT)
#       define SETUP_XfOrM317(x) SETUP_XfOrM316(x)

# 2202 "bc/src/thread.c"
        a [0 ] = h ; 
        (void ) FUNCCALL(SETUP_XfOrM317(_), scheme_apply_multi (o , 1 , a ) ); 
      }

      r = (((Scheme_Simple_Object * ) (r ) ) -> u . pair_val . cdr ) ; 
    }
  }

# 2208 "bc/src/thread.c"
  else {
    escaped = 1 ; 
  }

  if (catch_errors )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = saved_error_buf ; 

  RET_VALUE_START (escaped ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2218 "bc/src/thread.c"
static Scheme_Object * make_plumber (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Plumber * p ; 
  Scheme_Hash_Table * ht ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(ht, 1)));
# define XfOrM320_COUNT (2)
# define SETUP_XfOrM320(x) SETUP(XfOrM320_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  ht = NULLED_OUT ; 

# 2223 "bc/src/thread.c"
  p = ((Scheme_Plumber * ) FUNCCALL(SETUP_XfOrM320(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Plumber ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  p -> so . type = scheme_plumber_type ; 

  ht = FUNCCALL(SETUP_XfOrM320(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  p -> handles = ht ; 

  RET_VALUE_START ((Scheme_Object * ) p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2232 "bc/src/thread.c"
static Scheme_Object * plumber_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2234 "bc/src/thread.c"
  return ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_plumber_type ) ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * plumber_flush_all (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2239 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_plumber_type ) ) )
    scheme_wrong_contract ("plumber-flush-all" , "plumber?" , 0 , argc , argv ) ; 

  scheme_flush_managed ((Scheme_Plumber * ) argv [0 ] , 0 ) ; 

  return scheme_void ; 
}

Scheme_Object * scheme_add_flush (Scheme_Plumber * p , Scheme_Object * proc_or_port , int weak_flush ) 
{
  Scheme_Object * h ; 
  Scheme_Config * __funcarg177 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(h, 1), PUSH(proc_or_port, 2)));
# define XfOrM323_COUNT (3)
# define SETUP_XfOrM323(x) SETUP(XfOrM323_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  h = NULLED_OUT ; 

# 2251 "bc/src/thread.c"
  if (! p )
    p = (Scheme_Plumber * ) (__funcarg177 = FUNCCALL(SETUP_XfOrM323(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg177 , MZCONFIG_PLUMBER ) )) ; 

  h = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM323(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  h -> type = scheme_plumber_handle_type ; 
  (((Scheme_Simple_Object * ) (h ) ) -> u . two_ptr_val . ptr1 ) = (Scheme_Object * ) p ; 
  (((Scheme_Simple_Object * ) (h ) ) -> u . two_ptr_val . ptr2 ) = proc_or_port ; 

  if (weak_flush ) {
#   define XfOrM324_COUNT (0+XfOrM323_COUNT)
#   define SETUP_XfOrM324(x) SETUP_XfOrM323(x)

# 2260 "bc/src/thread.c"
    (& ((Scheme_Small_Object * ) h ) -> iso ) -> so . keyex |= 0x1 ; 
    if (! p -> weak_handles ) {
      Scheme_Bucket_Table * bt ; 
      BLOCK_SETUP((PUSH(bt, 0+XfOrM324_COUNT)));
#     define XfOrM325_COUNT (1+XfOrM324_COUNT)
#     define SETUP_XfOrM325(x) SETUP(XfOrM325_COUNT)
      bt = NULLED_OUT ; 

# 2263 "bc/src/thread.c"
      bt = FUNCCALL(SETUP_XfOrM325(_), scheme_make_bucket_table (4 , SCHEME_hash_weak_ptr ) ); 
      p -> weak_handles = bt ; 
    }
    FUNCCALL(SETUP_XfOrM324(_), scheme_add_to_table (p -> weak_handles , (const char * ) h , scheme_true , 0 ) ); 
  }

# 2267 "bc/src/thread.c"
  else FUNCCALL(SETUP_XfOrM323(_), scheme_hash_set (p -> handles , h , scheme_true ) )
  ; 

  RET_VALUE_START (h ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2273 "bc/src/thread.c"
static Scheme_Object * plumber_add_flush (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM326_COUNT (1)
# define SETUP_XfOrM326(x) SETUP(XfOrM326_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2275 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_plumber_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("plumber-add-flush!" , "plumber?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM326(_), scheme_check_proc_arity ("plumber-add-flush!" , 1 , 1 , argc , argv ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_add_flush ((Scheme_Plumber * ) argv [0 ] , argv [1 ] , (argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) )) RET_VALUE_EMPTY_END 
  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2283 "bc/src/thread.c"
void scheme_remove_flush (Scheme_Object * h ) 
{
  Scheme_Plumber * p ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(h, 1)));
# define XfOrM327_COUNT (2)
# define SETUP_XfOrM327(x) SETUP(XfOrM327_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 

# 2287 "bc/src/thread.c"
  p = (Scheme_Plumber * ) (((Scheme_Simple_Object * ) (h ) ) -> u . two_ptr_val . ptr1 ) ; 

  if (p ) {
#   define XfOrM328_COUNT (0+XfOrM327_COUNT)
#   define SETUP_XfOrM328(x) SETUP_XfOrM327(x)

# 2290 "bc/src/thread.c"
    if ((& ((Scheme_Small_Object * ) h ) -> iso ) -> so . keyex & 0x1 ) {
      Scheme_Bucket * b ; 
      BLOCK_SETUP((PUSH(b, 0+XfOrM328_COUNT)));
#     define XfOrM329_COUNT (1+XfOrM328_COUNT)
#     define SETUP_XfOrM329(x) SETUP(XfOrM329_COUNT)
      b = NULLED_OUT ; 

# 2292 "bc/src/thread.c"
      b = FUNCCALL(SETUP_XfOrM329(_), scheme_bucket_or_null_from_table (p -> weak_handles , (char * ) h , 0 ) ); 
      if (b ) {
        (((Scheme_Small_Object * ) (b -> key ) ) -> u . ptr_val ) = ((void * ) 0 ) ; 
        b -> val = ((void * ) 0 ) ; 
      }
    }

# 2297 "bc/src/thread.c"
    else FUNCCALL(SETUP_XfOrM328(_), scheme_hash_set (p -> handles , h , ((void * ) 0 ) ) )
    ; 
    (((Scheme_Simple_Object * ) (h ) ) -> u . two_ptr_val . ptr1 ) = ((void * ) 0 ) ; 
    (((Scheme_Simple_Object * ) (h ) ) -> u . two_ptr_val . ptr2 ) = ((void * ) 0 ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2304 "bc/src/thread.c"
static Scheme_Object * plumber_remove_flush (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2306 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_plumber_handle_type ) ) )
    scheme_wrong_contract ("plumber-flush-handle-remove!" , "plumber-handle?" , 0 , argc , argv ) ; 

  scheme_remove_flush (argv [0 ] ) ; 

  return scheme_void ; 
}

static Scheme_Object * plumber_flush_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2316 "bc/src/thread.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_plumber_handle_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * current_plumber (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2323 "bc/src/thread.c"
  return scheme_param_config2 ("current-plumber" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PLUMBER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , plumber_p , "plumber?" , 0 ) ; 
}







static Scheme_Thread_Set * create_thread_set (Scheme_Thread_Set * parent ) 
{
  Scheme_Thread_Set * t_set ; 
  DECL_RET_SAVE (Scheme_Thread_Set * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(t_set, 0), PUSH(parent, 1)));
# define XfOrM334_COUNT (2)
# define SETUP_XfOrM334(x) SETUP(XfOrM334_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t_set = NULLED_OUT ; 

# 2339 "bc/src/thread.c"
  t_set = ((Scheme_Thread_Set * ) FUNCCALL(SETUP_XfOrM334(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Thread_Set ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  t_set -> so . type = scheme_thread_set_type ; 

  t_set -> parent = parent ; 



  RET_VALUE_START (t_set ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2349 "bc/src/thread.c"
static Scheme_Object * make_thread_set (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread_Set * parent ; 
  Scheme_Config * __funcarg178 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(parent, 0)));
# define XfOrM335_COUNT (1)
# define SETUP_XfOrM335(x) SETUP(XfOrM335_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  parent = NULLED_OUT ; 

# 2353 "bc/src/thread.c"
  if (argc ) {
#   define XfOrM336_COUNT (0+XfOrM335_COUNT)
#   define SETUP_XfOrM336(x) SETUP_XfOrM335(x)

# 2354 "bc/src/thread.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_set_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-thread-group" , "thread-group?" , 0 , argc , argv ) ); 
    parent = (Scheme_Thread_Set * ) argv [0 ] ; 
  }

# 2357 "bc/src/thread.c"
  else 
  parent = (Scheme_Thread_Set * ) (__funcarg178 = FUNCCALL(SETUP_XfOrM335(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg178 , MZCONFIG_THREAD_SET ) )) ; 

  RET_VALUE_START ((Scheme_Object * ) FUNCCALL_EMPTY(create_thread_set (parent ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2363 "bc/src/thread.c"
static Scheme_Object * thread_set_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2365 "bc/src/thread.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_set_type ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * current_thread_set (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2372 "bc/src/thread.c"
  return scheme_param_config2 ("current-thread-group" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_THREAD_SET ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , thread_set_p , "thread-group?" , 0 ) ; 
}

__xform_nongcing__ static inline void set_t_set_next (Scheme_Object * o , Scheme_Object * n ) 
{
  /* No conversion */

# 2380 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) 
    ((Scheme_Thread * ) o ) -> t_set_next = n ; 
  else 
  ((Scheme_Thread_Set * ) o ) -> next = n ; 
}

__xform_nongcing__ static inline void set_t_set_prev (Scheme_Object * o , Scheme_Object * n ) 
{
  /* No conversion */

# 2388 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) 
    ((Scheme_Thread * ) o ) -> t_set_prev = n ; 
  else 
  ((Scheme_Thread_Set * ) o ) -> prev = n ; 
}

__xform_nongcing__ static inline Scheme_Object * get_t_set_next (Scheme_Object * o ) 
{
  /* No conversion */

# 2396 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) 
    return ((Scheme_Thread * ) o ) -> t_set_next ; 
  else 
  return ((Scheme_Thread_Set * ) o ) -> next ; 
}

__xform_nongcing__ static inline Scheme_Object * get_t_set_prev (Scheme_Object * o ) 
{
  /* No conversion */

# 2404 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) 
    return ((Scheme_Thread * ) o ) -> t_set_prev ; 
  else 
  return ((Scheme_Thread_Set * ) o ) -> prev ; 
}

__xform_nongcing__ static void schedule_in_set (Scheme_Object * s , Scheme_Thread_Set * t_set ) 
{
  /* No conversion */

# 2412 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> num_running_threads_ ) += 1 ; 

  while (1 ) {
    set_t_set_next (s , t_set -> first ) ; 
    if (t_set -> first )
      set_t_set_prev (t_set -> first , s ) ; 
    t_set -> first = s ; 
    if (t_set -> current )
      break ; 

    t_set -> current = s ; 

    s = (Scheme_Object * ) t_set ; 
    t_set = t_set -> parent ; 
  }
}

__xform_nongcing__ static void unschedule_in_set (Scheme_Object * s , Scheme_Thread_Set * t_set ) 
{
  /* No conversion */

# 2431 "bc/src/thread.c"
  Scheme_Object * prev ; 
  Scheme_Object * next ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> num_running_threads_ ) -= 1 ; 

  while (1 ) {
    prev = get_t_set_prev (s ) ; 
    next = get_t_set_next (s ) ; 

    if (! prev )
      t_set -> first = next ; 
    else 
    set_t_set_next (prev , next ) ; 
    if (next )
      set_t_set_prev (next , prev ) ; 
    set_t_set_prev (s , ((void * ) 0 ) ) ; 
    set_t_set_next (s , ((void * ) 0 ) ) ; 

    if (t_set -> current == s ) {
      if (next ) {
        t_set -> current = next ; 
      }

# 2452 "bc/src/thread.c"
      else {
        t_set -> current = t_set -> first ; 
      }
    }
    if (t_set -> search_start == s )
      t_set -> search_start = t_set -> current ; 

    if (t_set -> current )
      break ; 

    s = (Scheme_Object * ) t_set ; 
    t_set = t_set -> parent ; 
  }
}





static Scheme_Thread * make_thread (Scheme_Config * config , 
Scheme_Thread_Cell_Table * cells , 
Scheme_Object * init_break_cell , 
Scheme_Custodian * mgr , 
void * stack_base ) 
{
  Scheme_Thread * process ; 
  int prefix = 0 ; 
  DECL_RET_SAVE (Scheme_Thread * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(cells, 0), PUSH(stack_base, 1), PUSH(init_break_cell, 2), PUSH(config, 3), PUSH(mgr, 4), PUSH(process, 5)));
# define XfOrM355_COUNT (6)
# define SETUP_XfOrM355(x) SETUP(XfOrM355_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  process = NULLED_OUT ; 

# 2480 "bc/src/thread.c"
  process = ((Scheme_Thread * ) FUNCCALL(SETUP_XfOrM355(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Thread ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  process -> so . type = scheme_thread_type ; 

  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ) {
#   define XfOrM370_COUNT (0+XfOrM355_COUNT)
#   define SETUP_XfOrM370(x) SETUP_XfOrM355(x)
    FUNCCALL(SETUP_XfOrM370(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ) )
# 2486 "bc/src/thread.c"
    ; 
    FUNCCALL(SETUP_XfOrM370(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ) ) ); 
    FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ) ) ); 
    FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_callbacks_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_callbacks_ ) ) ) ); 
    FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_out_callbacks_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_out_callbacks_ ) ) ) ); 
    FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_target_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_target_ ) ) ) ); 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) = process ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) = process ; 
    process -> prev = ((void * ) 0 ) ; 
    process -> next = ((void * ) 0 ) ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) = process ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gc_prep_chain = process ; 

    process -> suspend_break = 1 ; 

    process -> error_buf = ((void * ) 0 ) ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_callbacks_ ) = scheme_null ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_out_callbacks_ ) = scheme_null ; 
    FUNCCALL(SETUP_XfOrM370(_), GC_set_collect_start_callback (get_ready_for_GC ) )
    ; 
    FUNCCALL_AGAIN(GC_set_collect_end_callback (done_with_GC ) ); 
    FUNCCALL_AGAIN(GC_set_collect_inform_callback (inform_GC ) )
    ; 
    FUNCCALL_AGAIN(GC_set_get_thread_stack_base (scheme_get_current_thread_stack_start ) )







    ; 

    process -> stack_start = stack_base ; 
  }
  else {
    prefix = 1 ; 
  }

  process -> engine_weight = 10000 ; 

  process -> cont_mark_pos = (intptr_t ) 1 ; 
  process -> cont_mark_stack = 0 ; 
  process -> cont_mark_stack_segments = ((void * ) 0 ) ; 
  process -> cont_mark_seg_count = 0 ; 

  if (! config ) {
#   define XfOrM368_COUNT (0+XfOrM355_COUNT)
#   define SETUP_XfOrM368(x) SETUP_XfOrM355(x)
    FUNCCALL(SETUP_XfOrM368(_), make_initial_config (process ) )
# 2536 "bc/src/thread.c"
    ; 
    config = process -> init_config ; 
  }

# 2538 "bc/src/thread.c"
  else {
    process -> init_config = config ; 
    process -> cell_values = cells ; 
  }

  if (init_break_cell ) {
    process -> init_break_cell = init_break_cell ; 
  }

# 2545 "bc/src/thread.c"
  else {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM355_COUNT)));
#   define XfOrM365_COUNT (1+XfOrM355_COUNT)
#   define SETUP_XfOrM365(x) SETUP(XfOrM365_COUNT)
    v = NULLED_OUT ; 

# 2547 "bc/src/thread.c"
    v = FUNCCALL(SETUP_XfOrM365(_), scheme_make_thread_cell (scheme_false , 1 ) ); 
    process -> init_break_cell = v ; 
  }

  if (! mgr )
    mgr = (Scheme_Custodian * ) FUNCCALL(SETUP_XfOrM355(_), scheme_get_param (config , MZCONFIG_CUSTODIAN ) ); 
  FUNCCALL(SETUP_XfOrM355(_), GC_register_new_thread (process , mgr ) )

  ; 


  {
    Scheme_Object * t_set ; 
    BLOCK_SETUP((PUSH(t_set, 0+XfOrM355_COUNT)));
#   define XfOrM364_COUNT (1+XfOrM355_COUNT)
#   define SETUP_XfOrM364(x) SETUP(XfOrM364_COUNT)
    t_set = NULLED_OUT ; 

# 2560 "bc/src/thread.c"
    t_set = FUNCCALL(SETUP_XfOrM364(_), scheme_get_param (config , MZCONFIG_THREAD_SET ) ); 
    process -> t_set_parent = (Scheme_Thread_Set * ) t_set ; 
  }

  if ((process ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ) )  {
#   define XfOrM363_COUNT (0+XfOrM355_COUNT)
#   define SETUP_XfOrM363(x) SETUP_XfOrM355(x)
    FUNCCALL(SETUP_XfOrM363(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_thread_set_top_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_thread_set_top_ ) ) ) )
# 2565 "bc/src/thread.c"
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_thread_set_top_ ) = process -> t_set_parent ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_thread_set_top_ ) -> first = (Scheme_Object * ) process ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_thread_set_top_ ) -> current = (Scheme_Object * ) process ; 
  }

# 2569 "bc/src/thread.c"
  else (
  schedule_in_set ((Scheme_Object * ) process , process -> t_set_parent ) ) ; 
  FUNCCALL(SETUP_XfOrM355(_), scheme_init_jmpup_buf (& process -> jmpup_buf ) )
  ; 

  process -> running = 0x1 ; 

  process -> dw = ((void * ) 0 ) ; 

  process -> block_descriptor = 0 ; 
  process -> block_check = ((void * ) 0 ) ; 
  process -> block_needs_wakeup = ((void * ) 0 ) ; 
  process -> sleep_end = 0 ; 

  process -> external_break = 0 ; 

  process -> ran_some = 1 ; 
  FUNCCALL(SETUP_XfOrM355(_), scheme_gmp_tls_init (process -> gmp_tls ) )
  ; 

  if (prefix ) {
    process -> next = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ; 
    process -> prev = ((void * ) 0 ) ; 
    process -> next -> prev = process ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) = process ; 
  }

  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) = 20 ; 

  {
    Scheme_Object * * tb ; 
    BLOCK_SETUP((PUSH(tb, 0+XfOrM355_COUNT)));
#   define XfOrM361_COUNT (1+XfOrM355_COUNT)
#   define SETUP_XfOrM361(x) SETUP(XfOrM361_COUNT)
    tb = NULLED_OUT ; 

# 2601 "bc/src/thread.c"
    tb = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM361(_), GC_malloc (sizeof (Scheme_Object * ) * (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) ) ) )) ; 
    process -> tail_buffer = tb ; 
  }
  process -> tail_buffer_size = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) ; 

  {
    int init_stack_size ; 
    Scheme_Object * iss ; 
    BLOCK_SETUP((PUSH(iss, 0+XfOrM355_COUNT)));
#   define XfOrM359_COUNT (1+XfOrM355_COUNT)
#   define SETUP_XfOrM359(x) SETUP(XfOrM359_COUNT)
    iss = NULLED_OUT ; 

# 2610 "bc/src/thread.c"
    iss = FUNCCALL(SETUP_XfOrM359(_), scheme_get_thread_param (config , cells , MZCONFIG_THREAD_INIT_STACK_SIZE ) ); 
    if (((intptr_t ) (iss ) ) & 0x1 ) 
      init_stack_size = (((intptr_t ) (iss ) ) >> 1 ) ; 
    else if ((Scheme_Type ) (((((intptr_t ) (iss ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (iss ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
      init_stack_size = 0x7FFFFFFF ; 
    else 
    init_stack_size = 1000 ; 




    if (init_stack_size > 100000 )
      init_stack_size = 100000 ; 
    if (init_stack_size < 5 )
      init_stack_size = 5 ; 

    process -> runstack_size = init_stack_size ; 
    {
      Scheme_Object * * sa ; 
      BLOCK_SETUP((PUSH(sa, 0+XfOrM359_COUNT)));
#     define XfOrM360_COUNT (1+XfOrM359_COUNT)
#     define SETUP_XfOrM360(x) SETUP(XfOrM360_COUNT)
      sa = NULLED_OUT ; 

# 2629 "bc/src/thread.c"
      sa = FUNCCALL(SETUP_XfOrM360(_), scheme_alloc_runstack (init_stack_size ) ); 
      process -> runstack_start = sa ; 
    }
    process -> runstack = process -> runstack_start + init_stack_size ; 
  }

  process -> runstack_saved = ((void * ) 0 ) ; 


  if (! prefix ) {
#   define XfOrM358_COUNT (0+XfOrM355_COUNT)
#   define SETUP_XfOrM358(x) SETUP_XfOrM355(x)
    FUNCCALL(SETUP_XfOrM358(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) ) )

    ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = process -> runstack ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = process -> runstack_start ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = process -> cont_mark_stack ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = process -> cont_mark_pos ; 
  }


  process -> on_kill = ((void * ) 0 ) ; 

  process -> user_tls = ((void * ) 0 ) ; 
  process -> user_tls_size = 0 ; 

  process -> nester = process -> nestee = ((void * ) 0 ) ; 

  process -> mbox_first = ((void * ) 0 ) ; 
  process -> mbox_last = ((void * ) 0 ) ; 
  process -> mbox_sema = ((void * ) 0 ) ; 

  process -> mref = ((void * ) 0 ) ; 
  process -> extra_mrefs = ((void * ) 0 ) ; 

# 2676 "bc/src/thread.c"
  {
    Scheme_Thread_Custodian_Hop * hop ; 
    Scheme_Custodian_Reference * mref ; 
    BLOCK_SETUP((PUSH(mref, 0+XfOrM355_COUNT), PUSH(hop, 1+XfOrM355_COUNT)));
#   define XfOrM356_COUNT (2+XfOrM355_COUNT)
#   define SETUP_XfOrM356(x) SETUP(XfOrM356_COUNT)
    hop = NULLED_OUT ; 
    mref = NULLED_OUT ; 

# 2679 "bc/src/thread.c"
    hop = ((Scheme_Thread_Custodian_Hop * ) FUNCCALL(SETUP_XfOrM356(_), GC_malloc_one_tagged (sizeof (Scheme_Thread_Custodian_Hop ) * (1 ) ) )) ; 
    process -> mr_hop = hop ; 
    hop -> so . type = scheme_thread_hop_type ; 
    {
      Scheme_Thread * wp ; 
      BLOCK_SETUP((PUSH(wp, 0+XfOrM356_COUNT)));
#     define XfOrM357_COUNT (1+XfOrM356_COUNT)
#     define SETUP_XfOrM357(x) SETUP(XfOrM357_COUNT)
      wp = NULLED_OUT ; 

# 2684 "bc/src/thread.c"
      wp = (Scheme_Thread * ) FUNCCALL(SETUP_XfOrM357(_), scheme_make_weak_box ((Scheme_Object * ) process ) ); 
      hop -> p = wp ; 
    }

    mref = FUNCCALL(SETUP_XfOrM356(_), scheme_add_managed (mgr , (Scheme_Object * ) hop , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
    process -> mref = mref ; 
    process -> extra_mrefs = scheme_null ; 
  }





  RET_VALUE_START (process ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2700 "bc/src/thread.c"
Scheme_Thread * scheme_make_thread (void * stack_base ) 
{
  /* No conversion */
  return make_thread (((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , stack_base ) ; 
}

void scheme_realloc_tail_buffer (Scheme_Thread * p ) 
{
  GC_CAN_IGNORE Scheme_Object * * tb ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM372_COUNT (1)
# define SETUP_XfOrM372(x) SETUP(XfOrM372_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2710 "bc/src/thread.c"
  p -> tail_buffer = ((void * ) 0 ) ; 


  if (p -> tail_buffer_size > (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) << 1 ) )
    p -> tail_buffer_size = p -> tail_buffer_size >> 1 ; 

  tb = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM372(_), GC_malloc (sizeof (Scheme_Object * ) * (p -> tail_buffer_size ) ) )) ; 
  p -> tail_buffer = tb ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2720 "bc/src/thread.c"
static void check_tail_buffer_size (Scheme_Thread * p ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM373_COUNT (1)
# define SETUP_XfOrM373(x) SETUP(XfOrM373_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2722 "bc/src/thread.c"
  if (p -> tail_buffer_size < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) ) {
    Scheme_Object * * tb ; 
    BLOCK_SETUP((PUSH(tb, 0+XfOrM373_COUNT)));
#   define XfOrM374_COUNT (1+XfOrM373_COUNT)
#   define SETUP_XfOrM374(x) SETUP(XfOrM374_COUNT)
    tb = NULLED_OUT ; 

# 2724 "bc/src/thread.c"
    tb = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM374(_), GC_malloc (sizeof (Scheme_Object * ) * (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) ) ) )) ; 
    p -> tail_buffer = tb ; 
    p -> tail_buffer_size = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2730 "bc/src/thread.c"
void scheme_set_tail_buffer_size (int s ) 
{
  PREPARE_VAR_STACK(1);
# define XfOrM375_COUNT (0)
# define SETUP_XfOrM375(x) SETUP(XfOrM375_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2732 "bc/src/thread.c"
  if (s > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) ) {
    Scheme_Thread * p ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM375_COUNT)));
#   define XfOrM376_COUNT (1+XfOrM375_COUNT)
#   define SETUP_XfOrM376(x) SETUP(XfOrM376_COUNT)
    p = NULLED_OUT ; 

# 2735 "bc/src/thread.c"
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> buffer_init_size_ ) = s ; 

    for (p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ; p ; p = p -> next ) {
#     define XfOrM378_COUNT (0+XfOrM376_COUNT)
#     define SETUP_XfOrM378(x) SETUP_XfOrM376(x)
      FUNCCALL(SETUP_XfOrM378(_), check_tail_buffer_size (p ) )
# 2738 "bc/src/thread.c"
      ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2743 "bc/src/thread.c"
int scheme_tls_allocate () 
{
  /* No conversion */

# 2745 "bc/src/thread.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> tls_pos_ ) ++ ; 
}

void scheme_tls_set (int pos , void * v ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(v, 1)));
# define XfOrM380_COUNT (2)
# define SETUP_XfOrM380(x) SETUP(XfOrM380_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2752 "bc/src/thread.c"
  if (p -> user_tls_size <= pos ) {
    int oldc = p -> user_tls_size ; 
    void * * old_tls = p -> user_tls , * * va ; 
    BLOCK_SETUP((PUSH(old_tls, 0+XfOrM380_COUNT), PUSH(va, 1+XfOrM380_COUNT)));
#   define XfOrM381_COUNT (2+XfOrM380_COUNT)
#   define SETUP_XfOrM381(x) SETUP(XfOrM381_COUNT)
    va = NULLED_OUT ; 

# 2756 "bc/src/thread.c"
    p -> user_tls_size = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> tls_pos_ ) ; 
    va = ((void * * ) FUNCCALL(SETUP_XfOrM381(_), GC_malloc (sizeof (void * ) * (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> tls_pos_ ) ) ) )) ; 
    p -> user_tls = va ; 
    while (oldc -- ) {
      p -> user_tls [oldc ] = old_tls [oldc ] ; 
    }
  }

  p -> user_tls [pos ] = v ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2767 "bc/src/thread.c"
void * scheme_tls_get (int pos ) 
{
  /* No conversion */

# 2769 "bc/src/thread.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (p -> user_tls_size <= pos )
    return ((void * ) 0 ) ; 
  else 
  return p -> user_tls [pos ] ; 
}

Scheme_Object * * scheme_alloc_runstack (intptr_t len ) 
XFORM_SKIP_PROC 
{

  intptr_t sz ; 
  void * * p ; 
  sz = sizeof (Scheme_Object * ) * (len + 5 ) ; 
  p = (void * * ) GC_malloc_tagged_allow_interior (sz ) ; 
  * (Scheme_Type * ) (void * ) p = scheme_rt_runstack ; 
  ((intptr_t * ) (void * ) p ) [1 ] = ((sz + (1 << 3 ) - 1 ) >> 3 ) ; 
  ((intptr_t * ) (void * ) p ) [2 ] = 0 ; 
  ((intptr_t * ) (void * ) p ) [3 ] = len ; 

  ((intptr_t * ) (void * ) p ) [4 ] = 0xFF77FF77 ; 
  return (Scheme_Object * * ) (p + 5 ) ; 
}




void scheme_set_runstack_limits (Scheme_Object * * rs , intptr_t len , intptr_t start , intptr_t end ) 
XFORM_SKIP_PROC 




{
  scheme_check_runstack_edge (rs ) ; 

  if (((intptr_t * ) (void * ) rs ) [- 3 ] != start )
    ((intptr_t * ) (void * ) rs ) [- 3 ] = start ; 
  if (((intptr_t * ) (void * ) rs ) [- 2 ] != end )
    ((intptr_t * ) (void * ) rs ) [- 2 ] = end ; 
}





void scheme_check_runstack_edge (Scheme_Object * * rs ) 
{
  /* No conversion */
  if (((intptr_t * ) rs ) [- 1 ] != 0xFF77FF77 ) {
    scheme_log_abort ("internal error: runstack overflow detected" ) ; 
    abort () ; 
  }
}


void * scheme_register_process_global (const char * key , void * val ) 
{
  void * old_val = ((void * ) 0 ) ; 
  char * key2 ; 
  Proc_Global_Rec * pg ; 
  intptr_t len ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(key, 1), PUSH(pg, 2), PUSH(key2, 3), PUSH(old_val, 4)));
# define XfOrM387_COUNT (5)
# define SETUP_XfOrM387(x) SETUP(XfOrM387_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  key2 = NULLED_OUT ; 
  pg = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM387(_), scheme_process_global_lock () )
# 2833 "bc/src/thread.c"
  ; 

  for (pg = process_globals ; pg ; pg = pg -> next ) {
#   define XfOrM391_COUNT (0+XfOrM387_COUNT)
#   define SETUP_XfOrM391(x) SETUP_XfOrM387(x)

# 2836 "bc/src/thread.c"
    if (! (strcmp (pg -> key , key ) ) ) {
      old_val = pg -> val ; 
      break ; 
    }
  }

  if (! old_val && val ) {
#   define XfOrM388_COUNT (0+XfOrM387_COUNT)
#   define SETUP_XfOrM388(x) SETUP_XfOrM387(x)

# 2843 "bc/src/thread.c"
    len = strlen (key ) ; 
    key2 = (char * ) malloc (len + 1 ) ; 
    (memcpy (key2 , key , len + 1 ) ) ; 
    pg = (Proc_Global_Rec * ) malloc (sizeof (Proc_Global_Rec ) ) ; 
    pg -> key = key2 ; 
    pg -> val = val ; 
    pg -> next = process_globals ; 
    process_globals = pg ; 
  }
  FUNCCALL(SETUP_XfOrM387(_), scheme_process_global_unlock () )
  ; 

  RET_VALUE_START (old_val ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2858 "bc/src/thread.c"
static Scheme_Object * unsafe_register_process_global (int argc , Scheme_Object * argv [] ) 
{
  void * val ; 
  void * __funcarg179 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(val, 1)));
# define XfOrM393_COUNT (2)
# define SETUP_XfOrM393(x) SETUP(XfOrM393_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  val = NULLED_OUT ; 

# 2862 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("unsafe-register-process-global" , "bytes?" , 0 , argc , argv ) ); 
  if (! FUNCCALL(SETUP_XfOrM393(_), scheme_is_cpointer (argv [1 ] ) ))
    FUNCCALL_EMPTY(scheme_wrong_contract ("unsafe-register-process-global" , "cpointer?" , 1 , argc , argv ) ); 

  val = (__funcarg179 = (
  scheme_extract_pointer (argv [1 ] ) ) , FUNCCALL(SETUP_XfOrM393(_), scheme_register_process_global ((((Scheme_Simple_Object * ) (argv [0 ] ) ) -> u . byte_str_val . string_val ) , __funcarg179 ) )) ; 

  if (val )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_cptr (val , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2876 "bc/src/thread.c"
static Scheme_Object * unsafe_get_place_table (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2878 "bc/src/thread.c"
  return (Scheme_Object * ) scheme_get_place_table () ; 
}

void scheme_init_process_globals (void ) 
{
  /* No conversion */
  mzrt_mutex_create (& process_global_lock ) ; 
}


void scheme_process_global_lock (void ) 
{
  /* No conversion */
  if (process_global_lock )
    mzrt_mutex_lock (process_global_lock ) ; 
}


void scheme_process_global_unlock (void ) 
{
  /* No conversion */
  if (process_global_lock )
    mzrt_mutex_unlock (process_global_lock ) ; 
}


Scheme_Hash_Table * scheme_get_place_table (void ) 
{
  /* No conversion */

# 2906 "bc/src/thread.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_misc_table_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_misc_table_ ) = scheme_make_hash_table (SCHEME_hash_ptr ) ; 
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_local_misc_table_ ) ; 
}





static Scheme_Object * unsafe_os_thread_enabled_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2917 "bc/src/thread.c"
  return scheme_false ; 
}

static Scheme_Object * unsafe_call_in_os_thread (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2922 "bc/src/thread.c"
  scheme_check_proc_arity ("unsafe-call-in-os-thread" , 0 , 0 , argc , argv ) ; 
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-call-in-os-thread: " "unsupported on this platform" ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * unsafe_make_os_semaphore (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2929 "bc/src/thread.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-make-os-semaphore: " "unsupported on this platform" ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * unsafe_os_semaphore_wait (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2935 "bc/src/thread.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-os-semaphore-wait: " "unsupported on this platform" ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * unsafe_os_semaphore_post (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2941 "bc/src/thread.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-os-semaphore-post: " "unsupported on this platform" ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * unsafe_add_global_finalizer (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2947 "bc/src/thread.c"
  scheme_raise_exn (MZEXN_FAIL_UNSUPPORTED , "unsafe-add-global-finalizer: " "unsupported on this platform" ) ; 
  return ((void * ) 0 ) ; 
}





int scheme_in_main_thread (void ) 
{
  /* No conversion */

# 2957 "bc/src/thread.c"
  return ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> next ; 
}

static void stash_current_marks () 
{
  Scheme_Object * m ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(m, 0)));
# define XfOrM406_COUNT (1)
# define SETUP_XfOrM406(x) SETUP(XfOrM406_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  m = NULLED_OUT ; 

# 2963 "bc/src/thread.c"
  m = FUNCCALL(SETUP_XfOrM406(_), scheme_current_continuation_marks_as (((void * ) 0 ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> returned_marks ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> returned_marks = m ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_target_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> return_marks_to ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> return_marks_to = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2969 "bc/src/thread.c"
static void do_swap_thread () 
{
  PREPARE_VAR_STACK(3);
# define XfOrM407_COUNT (0)
# define SETUP_XfOrM407(x) SETUP(XfOrM407_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2971 "bc/src/thread.c"
  start : FUNCCALL(SETUP_XfOrM407(_), scheme_zero_unneeded_rands (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) )

  ; 








  if (FUNCCALL(SETUP_XfOrM407(_), GC_is_using_master () )) {
#   define XfOrM425_COUNT (0+XfOrM407_COUNT)
#   define SETUP_XfOrM425(x) SETUP_XfOrM407(x)
    FUNCCALL(SETUP_XfOrM425(_), scheme_log_abort ("attempted thread swap during master GC use" ) )
# 2983 "bc/src/thread.c"
    ; 
    FUNCCALL(SETUP_XfOrM425(_), abort () ); 
  }


  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_no_setjmp_ ) && FUNCCALL(SETUP_XfOrM407(_), scheme_setjmpup_relative (& XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> jmpup_buf , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> stack_start , ((void * ) 0 ) ) )) {
#   define XfOrM419_COUNT (0+XfOrM407_COUNT)
#   define SETUP_XfOrM419(x) SETUP_XfOrM407(x)
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_count_ ) ++ ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_start ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_stack ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_pos ; 
    FUNCCALL(SETUP_XfOrM419(_), scheme_reset_jmpup_buf (& XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> jmpup_buf ) )
    ; 
    FUNCCALL_AGAIN(scheme_gmp_tls_unload (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls_data ) )


    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls_data = ((void * ) 0 ) ; 

    {
      Scheme_Object * l , * o ; 
      Scheme_Closure_Func f ; 
      BLOCK_SETUP((PUSH(o, 0+XfOrM419_COUNT), PUSH(l, 1+XfOrM419_COUNT)));
#     define XfOrM422_COUNT (2+XfOrM419_COUNT)
#     define SETUP_XfOrM422(x) SETUP(XfOrM422_COUNT)
      l = NULLED_OUT ; 
      o = NULLED_OUT ; 

# 3008 "bc/src/thread.c"
      for (l = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_callbacks_ ) ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#       define XfOrM424_COUNT (0+XfOrM422_COUNT)
#       define SETUP_XfOrM424(x) SETUP_XfOrM422(x)

# 3009 "bc/src/thread.c"
        o = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        f = ((Scheme_Closure_Func ) (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ) ; 
        o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
        FUNCCALL(SETUP_XfOrM424(_), f (o ) ); 
      }
    }
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_owner 
    && ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_owner ) != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ) 
    || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_stack_owner 
    && ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_stack_owner ) != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ) ) {
#     define XfOrM421_COUNT (0+XfOrM419_COUNT)
#     define SETUP_XfOrM421(x) SETUP_XfOrM419(x)
      FUNCCALL(SETUP_XfOrM421(_), scheme_takeover_stacks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) )
# 3019 "bc/src/thread.c"
      ; 
    }

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_start_process_msec = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> process_time_at_swap_ ) ; 

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> return_marks_to ) {
#     define XfOrM420_COUNT (0+XfOrM419_COUNT)
#     define SETUP_XfOrM420(x) SETUP_XfOrM419(x)
      FUNCCALL(SETUP_XfOrM420(_), stash_current_marks () )
# 3025 "bc/src/thread.c"
      ; 
      goto start ; 
    }
  }

# 3028 "bc/src/thread.c"
  else {
    Scheme_Thread * new_thread = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_target_ ) ; 
    BLOCK_SETUP((PUSH(new_thread, 0+XfOrM407_COUNT)));
#   define XfOrM408_COUNT (1+XfOrM407_COUNT)
#   define SETUP_XfOrM408(x) SETUP(XfOrM408_COUNT)

# 3031 "bc/src/thread.c"
    if ((! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) || (++ XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> process_time_skips_ ) >= 100 ) ) {
      intptr_t cpm ; 
#     define XfOrM418_COUNT (0+XfOrM408_COUNT)
#     define SETUP_XfOrM418(x) SETUP_XfOrM408(x)

# 3033 "bc/src/thread.c"
      cpm = (scheme_get_process_milliseconds () ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> accum_process_msec += (cpm - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_start_process_msec ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> process_time_at_swap_ ) = cpm ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> process_time_skips_ ) = 0 ; 
    }

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_target_ ) = ((void * ) 0 ) ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_no_setjmp_ ) = 0 ; 



    {
      Scheme_Object * l , * o ; 
      Scheme_Closure_Func f ; 
      BLOCK_SETUP((PUSH(o, 0+XfOrM408_COUNT), PUSH(l, 1+XfOrM408_COUNT)));
#     define XfOrM415_COUNT (2+XfOrM408_COUNT)
#     define SETUP_XfOrM415(x) SETUP(XfOrM415_COUNT)
      l = NULLED_OUT ; 
      o = NULLED_OUT ; 

# 3048 "bc/src/thread.c"
      for (l = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_out_callbacks_ ) ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#       define XfOrM417_COUNT (0+XfOrM415_COUNT)
#       define SETUP_XfOrM417(x) SETUP_XfOrM415(x)

# 3049 "bc/src/thread.c"
        o = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        f = ((Scheme_Closure_Func ) (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ) ; 
        o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
        FUNCCALL(SETUP_XfOrM417(_), f (o ) ); 
      }
    }

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> init_break_cell ) {
      int cb ; 
#     define XfOrM414_COUNT (0+XfOrM408_COUNT)
#     define SETUP_XfOrM414(x) SETUP_XfOrM408(x)

# 3058 "bc/src/thread.c"
      cb = FUNCCALL(SETUP_XfOrM414(_), can_break_param (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> can_break_at_swap = cb ; 
    }
    {
      GC_CAN_IGNORE void * data ; 
#     define XfOrM413_COUNT (0+XfOrM408_COUNT)
#     define SETUP_XfOrM413(x) SETUP_XfOrM408(x)

# 3063 "bc/src/thread.c"
      data = FUNCCALL(SETUP_XfOrM413(_), scheme_gmp_tls_load (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls_data = data ; 
    }

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 






    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) = new_thread ; 
    if (! new_thread -> gc_prep_chain ) {
      new_thread -> gc_prep_chain = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) = new_thread ; 
    }


    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> return_marks_to ) {
      Scheme_Thread_Set * t_set = new_thread -> t_set_parent ; 
      t_set -> current = (Scheme_Object * ) new_thread ; 
      while (t_set -> parent ) {
        t_set -> parent -> current = (Scheme_Object * ) t_set ; 
        t_set = t_set -> parent ; 
      }
    }
    FUNCCALL_EMPTY(scheme_longjmpup (& XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> jmpup_buf ) )
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3097 "bc/src/thread.c"
void scheme_swap_thread (Scheme_Thread * new_thread ) 
{
  /* No conversion */

# 3099 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_target_ ) = new_thread ; 
  new_thread = ((void * ) 0 ) ; 
  do_swap_thread () ; 
}

static void select_thread () 
{
  Scheme_Thread * new_thread ; 
  Scheme_Object * o ; 
  Scheme_Thread_Set * t_set ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(new_thread, 0), PUSH(o, 1), PUSH(t_set, 2)));
# define XfOrM427_COUNT (3)
# define SETUP_XfOrM427(x) SETUP(XfOrM427_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  new_thread = NULLED_OUT ; 
  o = NULLED_OUT ; 
  t_set = NULLED_OUT ; 

# 3112 "bc/src/thread.c"
  o = (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_thread_set_top_ ) ; 
  while (! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) ) {
#   define XfOrM449_COUNT (0+XfOrM427_COUNT)
#   define SETUP_XfOrM449(x) SETUP_XfOrM427(x)

# 3114 "bc/src/thread.c"
    t_set = (Scheme_Thread_Set * ) o ; 
    o = (get_t_set_next (t_set -> current ) ) ; 
    if (! o )
      o = t_set -> first ; 
  }




  new_thread = (Scheme_Thread * ) o ; 
  do {
#   define XfOrM438_COUNT (0+XfOrM427_COUNT)
#   define SETUP_XfOrM438(x) SETUP_XfOrM427(x)

# 3125 "bc/src/thread.c"
    if (! new_thread )
      new_thread = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ; 


    while (new_thread 
    && (new_thread -> nestee 
    || (new_thread -> running & 0x2 ) 


    || ((new_thread -> running & 0x10 ) 
    && ! (new_thread -> running & 0x20 ) ) ) ) {
      new_thread = new_thread -> next ; 
    }

    if (! new_thread && ! o ) {
#     define XfOrM439_COUNT (0+XfOrM438_COUNT)
#     define SETUP_XfOrM439(x) SETUP_XfOrM438(x)


      new_thread = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ; 
      while (new_thread -> nestee ) {
        new_thread = new_thread -> nestee ; 
      }
      if ((new_thread -> running & 0x10 ) 
      && ! (new_thread -> running & 0x20 ) ) {
#       define XfOrM441_COUNT (0+XfOrM439_COUNT)
#       define SETUP_XfOrM441(x) SETUP_XfOrM439(x)

# 3150 "bc/src/thread.c"
        if (FUNCCALL(SETUP_XfOrM441(_), post_system_idle () )) {
        }
        else {
#         define XfOrM442_COUNT (0+XfOrM441_COUNT)
#         define SETUP_XfOrM442(x) SETUP_XfOrM441(x)
          FUNCCALL(SETUP_XfOrM442(_), scheme_console_printf ("unbreakable deadlock\n" ) )
# 3153 "bc/src/thread.c"
          ; 
          if (scheme_exit )
            FUNCCALL(SETUP_XfOrM442(_), scheme_exit (1 ) ); 
          FUNCCALL_EMPTY(exit (1 ) )
          ; 
        }
      }

# 3159 "bc/src/thread.c"
      else {
#       define XfOrM440_COUNT (0+XfOrM439_COUNT)
#       define SETUP_XfOrM440(x) SETUP_XfOrM439(x)
        FUNCCALL(SETUP_XfOrM440(_), scheme_weak_resume_thread (new_thread ) )
# 3160 "bc/src/thread.c"
        ; 
      }
      break ; 
    }
    o = ((void * ) 0 ) ; 
  }

# 3165 "bc/src/thread.c"
  while (! new_thread ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_target_ ) = new_thread ; 
  new_thread = ((void * ) 0 ) ; 
  o = ((void * ) 0 ) ; 
  t_set = ((void * ) 0 ) ; 
  FUNCCALL_EMPTY(do_swap_thread () ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3174 "bc/src/thread.c"
static void thread_is_dead (Scheme_Thread * r ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(r, 0)));
# define XfOrM450_COUNT (1)
# define SETUP_XfOrM450(x) SETUP(XfOrM450_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3176 "bc/src/thread.c"
  if (r -> dead_box ) {
    Scheme_Object * o ; 
#   define XfOrM453_COUNT (0+XfOrM450_COUNT)
#   define SETUP_XfOrM453(x) SETUP_XfOrM450(x)
    o = NULLED_OUT ; 

# 3178 "bc/src/thread.c"
    o = (((Scheme_Small_Object * ) (r -> dead_box ) ) -> u . ptr_val ) ; 
    FUNCCALL(SETUP_XfOrM453(_), scheme_post_sema_all (o ) ); 
  }
  if (r -> sync_box ) {
#   define XfOrM452_COUNT (0+XfOrM450_COUNT)
#   define SETUP_XfOrM452(x) SETUP_XfOrM450(x)
    FUNCCALL(SETUP_XfOrM452(_), scheme_post_sema_all (r -> sync_box ) )
# 3182 "bc/src/thread.c"
    ; 
    r -> sync_box = ((void * ) 0 ) ; 
  }
  if (r -> running_box ) {
    (((Scheme_Small_Object * ) (r -> running_box ) ) -> u . ptr_val ) = ((void * ) 0 ) ; 
    r -> running_box = ((void * ) 0 ) ; 
  }
  r -> suspended_box = ((void * ) 0 ) ; 
  r -> resumed_box = ((void * ) 0 ) ; 

  r -> t_set_parent = ((void * ) 0 ) ; 
  r -> dw = ((void * ) 0 ) ; 
  r -> init_config = ((void * ) 0 ) ; 
  r -> cell_values = ((void * ) 0 ) ; 
  r -> init_break_cell = ((void * ) 0 ) ; 
  r -> cont_mark_stack_segments = ((void * ) 0 ) ; 
  r -> overflow = ((void * ) 0 ) ; 

  r -> blocker = ((void * ) 0 ) ; 

  r -> transitive_resumes = ((void * ) 0 ) ; 

  r -> error_buf = ((void * ) 0 ) ; 

  r -> spare_runstack = ((void * ) 0 ) ; 

  r -> mbox_first = ((void * ) 0 ) ; 
  r -> mbox_last = ((void * ) 0 ) ; 
  r -> mbox_sema = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3213 "bc/src/thread.c"
static void remove_thread (Scheme_Thread * r ) 
{
  Scheme_Saved_Stack * saved ; 
  Scheme_Object * l ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(l, 1), PUSH(saved, 2)));
# define XfOrM454_COUNT (3)
# define SETUP_XfOrM454(x) SETUP(XfOrM454_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  saved = NULLED_OUT ; 
  l = NULLED_OUT ; 

# 3218 "bc/src/thread.c"
  r -> running = 0 ; 

  if (r -> prev ) {
    r -> prev -> next = r -> next ; 
    r -> next -> prev = r -> prev ; 
  }

# 3223 "bc/src/thread.c"
  else if (r -> next ) {
    r -> next -> prev = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) = r -> next ; 
  }
  r -> next = r -> prev = ((void * ) 0 ) ; 
  (
  unschedule_in_set ((Scheme_Object * ) r , r -> t_set_parent ) ) ; 


  if (r == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
    r -> runstack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = ((void * ) 0 ) ; 
    r -> runstack_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = ((void * ) 0 ) ; 
    r -> cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
    r -> cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 
  }


  if (r -> runstack_owner ) {
#   define XfOrM462_COUNT (0+XfOrM454_COUNT)
#   define SETUP_XfOrM462(x) SETUP_XfOrM454(x)

# 3244 "bc/src/thread.c"
    if (r == * (r -> runstack_owner ) ) {
#     define XfOrM463_COUNT (0+XfOrM462_COUNT)
#     define SETUP_XfOrM463(x) SETUP_XfOrM462(x)

# 3245 "bc/src/thread.c"
      if (r -> runstack_start ) {
#       define XfOrM466_COUNT (0+XfOrM463_COUNT)
#       define SETUP_XfOrM466(x) SETUP_XfOrM463(x)
        FUNCCALL(SETUP_XfOrM466(_), scheme_set_runstack_limits (r -> runstack_start , r -> runstack_size , 0 , 0 ) )
# 3246 "bc/src/thread.c"
        ; 
        r -> runstack_start = ((void * ) 0 ) ; 
      }
      for (saved = r -> runstack_saved ; saved ; saved = saved -> prev ) {
#       define XfOrM465_COUNT (0+XfOrM463_COUNT)
#       define SETUP_XfOrM465(x) SETUP_XfOrM463(x)
        FUNCCALL(SETUP_XfOrM465(_), scheme_set_runstack_limits (saved -> runstack_start , saved -> runstack_size , 0 , 0 ) )
# 3250 "bc/src/thread.c"
        ; 
      }
      r -> runstack_saved = ((void * ) 0 ) ; 
      * (r -> runstack_owner ) = ((void * ) 0 ) ; 
      r -> runstack_owner = ((void * ) 0 ) ; 
    }
  }

# 3256 "bc/src/thread.c"
  else {
#   define XfOrM459_COUNT (0+XfOrM454_COUNT)
#   define SETUP_XfOrM459(x) SETUP_XfOrM454(x)
    (memset (r -> runstack_start , 0 , r -> runstack_size * sizeof (Scheme_Object * ) ) ) ; 
    r -> runstack_start = ((void * ) 0 ) ; 
    for (saved = r -> runstack_saved ; saved ; saved = saved -> prev ) {
#     define XfOrM461_COUNT (0+XfOrM459_COUNT)
#     define SETUP_XfOrM461(x) SETUP_XfOrM459(x)
      (
# 3262 "bc/src/thread.c"
      memset (saved -> runstack_start , 0 , saved -> runstack_size * sizeof (Scheme_Object * ) ) ) ; 
      saved -> runstack_start = ((void * ) 0 ) ; 
    }
  }

  r -> runstack = ((void * ) 0 ) ; 
  r -> runstack_swapped = ((void * ) 0 ) ; 

  if (r -> cont_mark_stack_owner 
  && ((* r -> cont_mark_stack_owner ) == r ) ) {
    * r -> cont_mark_stack_owner = ((void * ) 0 ) ; 
  }

  r -> cont_mark_stack = 0 ; 
  r -> cont_mark_stack_owner = ((void * ) 0 ) ; 
  r -> cont_mark_stack_swapped = ((void * ) 0 ) ; 

  r -> ku . apply . tail_rator = ((void * ) 0 ) ; 
  r -> ku . apply . tail_rands = ((void * ) 0 ) ; 
  r -> tail_buffer = ((void * ) 0 ) ; 
  r -> ku . multiple . array = ((void * ) 0 ) ; 
  r -> values_buffer = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM454(_), thread_is_dead (r ) )
  ; 
  FUNCCALL_AGAIN(scheme_gmp_tls_restore_snapshot (r -> gmp_tls , r -> gmp_tls_data , ((void * ) 0 ) , ((r == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ? 1 : 2 ) ) )


  ; 

  if (r == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_no_setjmp_ ) = 1 ; 
  }

# 3294 "bc/src/thread.c"
  else FUNCCALL(SETUP_XfOrM454(_), scheme_reset_jmpup_buf (& r -> jmpup_buf ) )
  ; 
  FUNCCALL(SETUP_XfOrM454(_), scheme_remove_managed (r -> mref , (Scheme_Object * ) r -> mr_hop ) )
  ; 
  for (l = r -> extra_mrefs ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#   define XfOrM456_COUNT (0+XfOrM454_COUNT)
#   define SETUP_XfOrM456(x) SETUP_XfOrM454(x)
    FUNCCALL(SETUP_XfOrM456(_), scheme_remove_managed ((Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , (Scheme_Object * ) r -> mr_hop ) )
# 3299 "bc/src/thread.c"
    ; 
  }
  r -> extra_mrefs = scheme_null ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3304 "bc/src/thread.c"
void scheme_end_current_thread (void ) 
{
  /* No conversion */

# 3306 "bc/src/thread.c"
  if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ) ) 
    exit_or_escape (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ; 

  remove_thread (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_ended_with_activity_ ) = 1 ; 

  if (scheme_notify_multithread && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) -> next ) {
    scheme_notify_multithread (0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> have_activity_ ) = 0 ; 
  }

  select_thread () ; 
}

static void start_child (Scheme_Thread * volatile child , 
Scheme_Object * volatile child_eval ) 
{
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(child, 0), PUSH(child_eval, 1)));
# define XfOrM472_COUNT (2)
# define SETUP_XfOrM472(x) SETUP(XfOrM472_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3324 "bc/src/thread.c"
  if (FUNCCALL(SETUP_XfOrM472(_), scheme_setjmpup_relative (& child -> jmpup_buf , child , child -> stack_start , ((void * ) 0 ) ) )) {

    Scheme_Object * volatile result = ((void * ) 0 ) ; 
    BLOCK_SETUP((PUSH(result, 0+XfOrM472_COUNT)));
#   define XfOrM473_COUNT (1+XfOrM472_COUNT)
#   define SETUP_XfOrM473(x) SETUP(XfOrM473_COUNT)

# 3328 "bc/src/thread.c"
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_count_ ) ++ ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_start ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_stack ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_pos ; 
    FUNCCALL(SETUP_XfOrM473(_), scheme_gmp_tls_unload (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls_data ) )
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls_data = ((void * ) 0 ) ; 
    {
      Scheme_Object * l , * o ; 
      Scheme_Closure_Func f ; 
      BLOCK_SETUP((PUSH(o, 0+XfOrM473_COUNT), PUSH(l, 1+XfOrM473_COUNT)));
#     define XfOrM486_COUNT (2+XfOrM473_COUNT)
#     define SETUP_XfOrM486(x) SETUP(XfOrM486_COUNT)
      l = NULLED_OUT ; 
      o = NULLED_OUT ; 

# 3340 "bc/src/thread.c"
      for (l = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_callbacks_ ) ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#       define XfOrM488_COUNT (0+XfOrM486_COUNT)
#       define SETUP_XfOrM488(x) SETUP_XfOrM486(x)

# 3341 "bc/src/thread.c"
        o = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        f = ((Scheme_Closure_Func ) (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ) ; 
        o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
        FUNCCALL(SETUP_XfOrM488(_), f (o ) ); 
      }
    }

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_start_process_msec = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> process_time_at_swap_ ) ; 
    FUNCCALL(SETUP_XfOrM473(_), scheme_reset_jmpup_buf (& child -> jmpup_buf ) )
    ; 





    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running & 0x4 ) {
#     define XfOrM485_COUNT (0+XfOrM473_COUNT)
#     define SETUP_XfOrM485(x) SETUP_XfOrM473(x)
      FUNCCALL(SETUP_XfOrM485(_), exit_or_escape (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) )
# 3358 "bc/src/thread.c"
      ; 
    }

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> return_marks_to ) {
#     define XfOrM484_COUNT (0+XfOrM473_COUNT)
#     define SETUP_XfOrM484(x) SETUP_XfOrM473(x)
      FUNCCALL(SETUP_XfOrM484(_), stash_current_marks () )
# 3362 "bc/src/thread.c"
      ; 
      FUNCCALL(SETUP_XfOrM484(_), do_swap_thread () ); 
    }

    {
      mz_jmp_buf newbuf ; 
#     define XfOrM482_COUNT (0+XfOrM473_COUNT)
#     define SETUP_XfOrM482(x) SETUP_XfOrM473(x)

# 3368 "bc/src/thread.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 
      if (! ((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM482_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#       define XfOrM483_COUNT (0+XfOrM482_COUNT)
#       define SETUP_XfOrM483(x) SETUP_XfOrM482(x)
        result = FUNCCALL(SETUP_XfOrM483(_), scheme_apply_thread_thunk (child_eval ) ); 
      }
    }







    while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation ) {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      Scheme_Overflow * oflow ; 
      BLOCK_SETUP((PUSH(p, 0+XfOrM473_COUNT), PUSH(oflow, 1+XfOrM473_COUNT)));
#     define XfOrM478_COUNT (2+XfOrM473_COUNT)
#     define SETUP_XfOrM478(x) SETUP(XfOrM478_COUNT)
      oflow = NULLED_OUT ; 

# 3386 "bc/src/thread.c"
      p -> cjs . val = result ; 

      if (! ((p -> meta_continuation -> prompt_tag ) == (scheme_default_prompt_tag ) ) ) {
#       define XfOrM481_COUNT (0+XfOrM478_COUNT)
#       define SETUP_XfOrM481(x) SETUP_XfOrM478(x)
        FUNCCALL(SETUP_XfOrM481(_), scheme_signal_error ("thread ended with meta continuation that isn't for the default prompt" ) )
# 3389 "bc/src/thread.c"
        ; 
      }

# 3390 "bc/src/thread.c"
      else {
        Scheme_Meta_Continuation * mc ; 
#       define XfOrM479_COUNT (0+XfOrM478_COUNT)
#       define SETUP_XfOrM479(x) SETUP_XfOrM478(x)
        mc = NULLED_OUT ; 

# 3392 "bc/src/thread.c"
        mc = p -> meta_continuation ; 
        oflow = mc -> overflow ; 
        p -> meta_continuation = mc -> next ; 
        if (! oflow -> eot ) {
#         define XfOrM480_COUNT (0+XfOrM479_COUNT)
#         define SETUP_XfOrM480(x) SETUP_XfOrM479(x)

# 3396 "bc/src/thread.c"
          p -> stack_start = oflow -> stack_start ; 
          p -> decompose_mc = mc ; 
          FUNCCALL(SETUP_XfOrM480(_), scheme_longjmpup (& oflow -> jmp -> cont ) ); 
        }
      }
    }
    FUNCCALL(SETUP_XfOrM473(_), scheme_end_current_thread () )
    ; 
    FUNCCALL(SETUP_XfOrM473(_), scheme_signal_error ("bad thread switch" ) )

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3410 "bc/src/thread.c"
void scheme_do_thread_start_child (Scheme_Thread * child , Scheme_Object * child_eval ) 
XFORM_SKIP_PROC 
{
  return start_child (child , child_eval ) ; 
}

static Scheme_Object * make_subprocess (Scheme_Object * child_thunk , 
void * child_start , 
Scheme_Config * config , 
Scheme_Thread_Cell_Table * cells , 
Scheme_Object * break_cell , 
Scheme_Custodian * mgr , 
int normal_kill ) 
{
  Scheme_Thread * child ; 
  int turn_on_multi ; 
  Scheme_Object * name_sym = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(child_start, 0), PUSH(child, 1), PUSH(mgr, 2), PUSH(child_thunk, 3), PUSH(name_sym, 4), PUSH(break_cell, 5), PUSH(config, 6), PUSH(cells, 7)));
# define XfOrM489_COUNT (8)
# define SETUP_XfOrM489(x) SETUP(XfOrM489_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  child = NULLED_OUT ; 

# 3428 "bc/src/thread.c"
  turn_on_multi = ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) -> next ; 

  if (! config )
    config = FUNCCALL(SETUP_XfOrM489(_), scheme_current_config () ); 
  if (! cells )
    cells = FUNCCALL(SETUP_XfOrM489(_), scheme_inherit_cells (((void * ) 0 ) ) ); 
  if (! break_cell ) {
#   define XfOrM496_COUNT (0+XfOrM489_COUNT)
#   define SETUP_XfOrM496(x) SETUP_XfOrM489(x)

# 3435 "bc/src/thread.c"
    break_cell = FUNCCALL(SETUP_XfOrM496(_), scheme_current_break_cell () ); 
    if ((break_cell ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) ) ) 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) = ((void * ) 0 ) ; 
  }




  {
    const char * s ; 
    int len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM489_COUNT)));
#   define XfOrM494_COUNT (1+XfOrM489_COUNT)
#   define SETUP_XfOrM494(x) SETUP(XfOrM494_COUNT)
    s = NULLED_OUT ; 

# 3447 "bc/src/thread.c"
    s = FUNCCALL(SETUP_XfOrM494(_), scheme_get_proc_name (child_thunk , & len , - 1 ) ); 
    if (s ) {
#     define XfOrM495_COUNT (0+XfOrM494_COUNT)
#     define SETUP_XfOrM495(x) SETUP_XfOrM494(x)

# 3449 "bc/src/thread.c"
      if (len < 0 )
        name_sym = (Scheme_Object * ) s ; 
      else 
      name_sym = FUNCCALL(SETUP_XfOrM495(_), scheme_intern_exact_symbol (s , len ) ); 
    }
  }

  child = FUNCCALL(SETUP_XfOrM489(_), make_thread (config , cells , break_cell , mgr , child_start ) ); 
  if (name_sym )
    child -> name = name_sym ; 

  {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM489_COUNT)));
#   define XfOrM493_COUNT (1+XfOrM489_COUNT)
#   define SETUP_XfOrM493(x) SETUP(XfOrM493_COUNT)
    v = NULLED_OUT ; 

# 3462 "bc/src/thread.c"
    v = FUNCCALL(SETUP_XfOrM493(_), scheme_thread_cell_get (break_cell , cells ) ); 
    child -> can_break_at_swap = (! (((v ) ) == (scheme_false ) ) ) ; 
  }

  if (! normal_kill )
    child -> suspend_to_kill = 1 ; 

  child -> stack_start = child_start ; 
  FUNCCALL(SETUP_XfOrM489(_), scheme_thread_start_child (child , child_thunk ) )

  ; 

  if (scheme_notify_multithread && turn_on_multi ) {
#   define XfOrM492_COUNT (0+XfOrM489_COUNT)
#   define SETUP_XfOrM492(x) SETUP_XfOrM489(x)
    FUNCCALL(SETUP_XfOrM492(_), scheme_notify_multithread (1 ) )
# 3475 "bc/src/thread.c"
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> have_activity_ ) = 1 ; 
  }

  {
#   define XfOrM490_COUNT (0+XfOrM489_COUNT)
#   define SETUP_XfOrM490(x) SETUP_XfOrM489(x)

# 3479 "bc/src/thread.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM491_COUNT (0+XfOrM490_COUNT)
#     define SETUP_XfOrM491(x) SETUP_XfOrM490(x)
      FUNCCALL(SETUP_XfOrM491(_), scheme_out_of_fuel () )
# 3479 "bc/src/thread.c"
      ; 
    }
  }

# 3479 "bc/src/thread.c"
  ; 

  RET_VALUE_START ((Scheme_Object * ) child ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3484 "bc/src/thread.c"
Scheme_Object * scheme_thread (Scheme_Object * thunk ) 
{
  /* No conversion */

# 3486 "bc/src/thread.c"
  return scheme_thread_w_details (thunk , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * sch_thread (int argc , Scheme_Object * args [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(args, 0)));
# define XfOrM498_COUNT (1)
# define SETUP_XfOrM498(x) SETUP(XfOrM498_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM498(_), scheme_check_proc_arity ("thread" , 0 , 0 , argc , args ) )
# 3491 "bc/src/thread.c"
  ; 
  FUNCCALL(SETUP_XfOrM498(_), scheme_custodian_check_available (((void * ) 0 ) , "thread" , "thread" ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_thread (args [0 ] ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3497 "bc/src/thread.c"
static Scheme_Object * unsafe_thread_at_root (int argc , Scheme_Object * args [] ) 
{
  Scheme_Thread_Cell_Table * __funcarg181 = NULLED_OUT ; 
  Scheme_Config * __funcarg180 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(__funcarg180, 0), PUSH(args, 1)));
# define XfOrM499_COUNT (2)
# define SETUP_XfOrM499(x) SETUP(XfOrM499_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM499(_), scheme_check_proc_arity ("unsafe-thread-at-root" , 0 , 0 , argc , args ) )
# 3499 "bc/src/thread.c"
  ; 

  RET_VALUE_START ((__funcarg180 = FUNCCALL(SETUP_XfOrM499(_), scheme_minimal_config () )
  , __funcarg181 = FUNCCALL(SETUP_XfOrM499(_), scheme_empty_cell_table () )
  , FUNCCALL_EMPTY(scheme_thread_w_details (args [0 ] , __funcarg180 , __funcarg181 , ((void * ) 0 ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) , 0 ) )) ) 
# 3501 "bc/src/thread.c"
  RET_VALUE_END 




  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3509 "bc/src/thread.c"
static Scheme_Object * sch_thread_nokill (int argc , Scheme_Object * args [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(args, 0)));
# define XfOrM500_COUNT (1)
# define SETUP_XfOrM500(x) SETUP(XfOrM500_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM500(_), scheme_check_proc_arity ("thread/suspend-to-kill" , 0 , 0 , argc , args ) )
# 3511 "bc/src/thread.c"
  ; 
  FUNCCALL(SETUP_XfOrM500(_), scheme_custodian_check_available (((void * ) 0 ) , "thread/suspend-to-kill" , "thread" ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_thread_w_details (args [0 ] , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3517 "bc/src/thread.c"
static Scheme_Object * sch_current (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 3519 "bc/src/thread.c"
  return (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
}

static Scheme_Object * thread_p (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 3524 "bc/src/thread.c"
  return ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * thread_running_p (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 3529 "bc/src/thread.c"
  int running ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    scheme_wrong_contract ("thread-running?" , "thread?" , 0 , argc , args ) ; 

  running = ((Scheme_Thread * ) args [0 ] ) -> running ; 

  return ((((running ) && ! ((running ) & 0x4 ) ) && ! (running & 0x10 ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * thread_dead_p (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 3543 "bc/src/thread.c"
  int running ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    scheme_wrong_contract ("thread-running?" , "thread?" , 0 , argc , args ) ; 

  running = ((Scheme_Thread * ) args [0 ] ) -> running ; 

  return ((running ) && ! ((running ) & 0x4 ) ) ? scheme_false : scheme_true ; 
}

static int thread_wait_done (Scheme_Object * p , Scheme_Schedule_Info * sinfo ) 
{
  int running = ((Scheme_Thread * ) p ) -> running ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(sinfo, 0), PUSH(p, 1)));
# define XfOrM505_COUNT (2)
# define SETUP_XfOrM505(x) SETUP(XfOrM505_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3556 "bc/src/thread.c"
  if ((running ) && ! ((running ) & 0x4 ) )  {


    Scheme_Object * evt ; 
    BLOCK_SETUP((PUSH(evt, 0+XfOrM505_COUNT)));
#   define XfOrM506_COUNT (1+XfOrM505_COUNT)
#   define SETUP_XfOrM506(x) SETUP(XfOrM506_COUNT)
    evt = NULLED_OUT ; 

# 3560 "bc/src/thread.c"
    evt = FUNCCALL(SETUP_XfOrM506(_), scheme_get_thread_dead ((Scheme_Thread * ) p ) ); 
    FUNCCALL_EMPTY(scheme_set_sync_target (sinfo , evt , p , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 3563 "bc/src/thread.c"
  else 
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3567 "bc/src/thread.c"
static Scheme_Object * thread_wait (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 3569 "bc/src/thread.c"
  Scheme_Thread * p ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    scheme_wrong_contract ("thread-wait" , "thread?" , 0 , argc , args ) ; 

  p = (Scheme_Thread * ) args [0 ] ; 

  if ((p -> running ) && ! ((p -> running ) & 0x4 ) )  {
    sch_sync (1 , args ) ; 
  }

  return scheme_void ; 
}

void scheme_thread_wait (Scheme_Object * thread ) {
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(thread, 0)));
# define XfOrM509_COUNT (1)
# define SETUP_XfOrM509(x) SETUP(XfOrM509_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM509(_), thread_wait (1 , & thread ) )
# 3584 "bc/src/thread.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3587 "bc/src/thread.c"
static void register_thread_sync () 
{
  /* No conversion */

# 3589 "bc/src/thread.c"
  scheme_add_evt (scheme_thread_type , 
  (Scheme_Ready_Fun ) thread_wait_done , 
  ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

void scheme_add_swap_callback (Scheme_Closure_Func f , Scheme_Object * data ) 
{
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM511_COUNT (1)
# define SETUP_XfOrM511(x) SETUP(XfOrM511_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 3598 "bc/src/thread.c"
  p = FUNCCALL(SETUP_XfOrM511(_), scheme_make_raw_pair ((Scheme_Object * ) f , data ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_callbacks_ ) = FUNCCALL_EMPTY(scheme_make_raw_pair (p , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_callbacks_ ) ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3602 "bc/src/thread.c"
void scheme_add_swap_out_callback (Scheme_Closure_Func f , Scheme_Object * data ) 
{
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM512_COUNT (1)
# define SETUP_XfOrM512(x) SETUP(XfOrM512_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 3606 "bc/src/thread.c"
  p = FUNCCALL(SETUP_XfOrM512(_), scheme_make_raw_pair ((Scheme_Object * ) f , data ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_out_callbacks_ ) = FUNCCALL_EMPTY(scheme_make_pair (p , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_out_callbacks_ ) ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


int scheme_is_stack_too_shallow () 
{
  /* No conversion */

# 24 "bc/src/mzstkchk.h"
  uintptr_t _stk_pos ; 

  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((((_stk_pos ) - (100000 / 2 ) ) ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 3620 "bc/src/thread.c"
  {
    return 1 ; 
  }
  return 0 ; 
}

static Scheme_Object * thread_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * thunk , * result , * break_cell ; 
  Scheme_Config * config ; 
  Scheme_Custodian * mgr ; 
  Scheme_Thread_Cell_Table * cells ; 
  int suspend_to_kill = p -> ku . k . i1 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(result, 0)));
# define XfOrM515_COUNT (1)
# define SETUP_XfOrM515(x) SETUP(XfOrM515_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  thunk = NULLED_OUT ; 
  result = NULLED_OUT ; 
  break_cell = NULLED_OUT ; 
  config = NULLED_OUT ; 
  mgr = NULLED_OUT ; 
  cells = NULLED_OUT ; 

# 3635 "bc/src/thread.c"
  thunk = (Scheme_Object * ) p -> ku . k . p1 ; 
  config = (Scheme_Config * ) p -> ku . k . p2 ; 
  mgr = (Scheme_Custodian * ) p -> ku . k . p3 ; 
  cells = (Scheme_Thread_Cell_Table * ) (((Scheme_Simple_Object * ) ((Scheme_Object * ) p -> ku . k . p4 ) ) -> u . pair_val . car ) ; 
  break_cell = (((Scheme_Simple_Object * ) ((Scheme_Object * ) p -> ku . k . p4 ) ) -> u . pair_val . cdr ) ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  result = FUNCCALL(SETUP_XfOrM515(_), make_subprocess (thunk , & __gc_var_stack__ , config , cells , break_cell , mgr , ! suspend_to_kill ) )
  ; 




  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3657 "bc/src/thread.c"
Scheme_Object * scheme_thread_w_details (Scheme_Object * thunk , 
Scheme_Config * config , 
Scheme_Thread_Cell_Table * cells , 
Scheme_Object * break_cell , 
Scheme_Custodian * mgr , 
int suspend_to_kill ) 
{
  Scheme_Object * result ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(result, 0), PUSH(break_cell, 1), PUSH(thunk, 2), PUSH(config, 3), PUSH(cells, 4), PUSH(mgr, 5)));
# define XfOrM516_COUNT (6)
# define SETUP_XfOrM516(x) SETUP(XfOrM516_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  result = NULLED_OUT ; 

# 3672 "bc/src/thread.c"
  if (FUNCCALL(SETUP_XfOrM516(_), scheme_is_stack_too_shallow () )) {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM516_COUNT)));
#   define XfOrM517_COUNT (1+XfOrM516_COUNT)
#   define SETUP_XfOrM517(x) SETUP(XfOrM517_COUNT)

# 3675 "bc/src/thread.c"
    p -> ku . k . p1 = thunk ; 
    p -> ku . k . p2 = config ; 
    p -> ku . k . p3 = mgr ; 
    result = FUNCCALL(SETUP_XfOrM517(_), scheme_make_pair ((Scheme_Object * ) cells , break_cell ) ); 
    p -> ku . k . p4 = result ; 
    p -> ku . k . i1 = suspend_to_kill ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (thread_k ) )) RET_VALUE_EMPTY_END ; 
  }


  result = FUNCCALL(SETUP_XfOrM516(_), make_subprocess (thunk , & __gc_var_stack__ , config , cells , break_cell , mgr , ! suspend_to_kill ) )
  ; 




  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * def_nested_exn_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3700 "bc/src/thread.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> nester ) {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    p -> cjs . jumping_to_continuation = (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
    p -> cjs . val = argv [0 ] ; 
    p -> cjs . is_kill = 0 ; 
    p -> cjs . skip_dws = 0 ; 
    (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 
  }

  return scheme_void ; 
}

Scheme_Object * scheme_call_as_nested_thread (int argc , Scheme_Object * argv [] , void * max_bottom ) __attribute__ ((noinline ) ) ; 

Scheme_Object * scheme_call_as_nested_thread (int argc , Scheme_Object * argv [] , void * max_bottom ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Thread * volatile np ; 
  Scheme_Custodian * mgr ; 
  Scheme_Object * volatile v ; 
  mz_jmp_buf newbuf ; 
  volatile int failure ; 
  Scheme_Config * __funcarg182 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(p, 1), PUSH(mgr, 2), PUSH(np, 3), PUSH(v, 4)));
# define XfOrM520_COUNT (5)
# define SETUP_XfOrM520(x) SETUP(XfOrM520_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  np = NULLED_OUT ; 
  mgr = NULLED_OUT ; 
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM520(_), scheme_check_proc_arity ("call-in-nested-thread" , 0 , 0 , argc , argv ) )
# 3724 "bc/src/thread.c"
  ; 
  if (argc > 1 ) {
#   define XfOrM539_COUNT (0+XfOrM520_COUNT)
#   define SETUP_XfOrM539(x) SETUP_XfOrM520(x)

# 3726 "bc/src/thread.c"
    if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) ) 
      mgr = (Scheme_Custodian * ) argv [1 ] ; 
    else {
#     define XfOrM540_COUNT (0+XfOrM539_COUNT)
#     define SETUP_XfOrM540(x) SETUP_XfOrM539(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("call-in-nested-thread" , "custodian?" , 1 , argc , argv ) )
# 3729 "bc/src/thread.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 3732 "bc/src/thread.c"
  else 
  mgr = (Scheme_Custodian * ) (__funcarg182 = FUNCCALL(SETUP_XfOrM520(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg182 , MZCONFIG_CUSTODIAN ) )) ; 
  FUNCCALL(SETUP_XfOrM520(_), scheme_custodian_check_available (mgr , "call-in-nested-thread" , "thread" ) )
  ; 

  {
#   define XfOrM537_COUNT (0+XfOrM520_COUNT)
#   define SETUP_XfOrM537(x) SETUP_XfOrM520(x)

# 3737 "bc/src/thread.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM538_COUNT (0+XfOrM537_COUNT)
#     define SETUP_XfOrM538(x) SETUP_XfOrM537(x)
      FUNCCALL(SETUP_XfOrM538(_), scheme_out_of_fuel () )
# 3737 "bc/src/thread.c"
      ; 
    }
  }

# 3737 "bc/src/thread.c"
  ; 
  FUNCCALL(SETUP_XfOrM520(_), scheme_wait_until_suspend_ok () )
  ; 

  np = ((Scheme_Thread * ) FUNCCALL(SETUP_XfOrM520(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Thread ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  np -> so . type = scheme_thread_type ; 
  FUNCCALL(SETUP_XfOrM520(_), GC_register_new_thread (np , mgr ) )
  ; 

  np -> running = 0x1 ; 
  np -> ran_some = 1 ; 


  p -> runstack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  p -> runstack_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
  p -> cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
  p -> cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 
  FUNCCALL(SETUP_XfOrM520(_), scheme_prepare_this_thread_for_GC (p ) )



  ; 

  if (! p -> runstack_owner ) {
    Scheme_Thread * * owner ; 
    BLOCK_SETUP((PUSH(owner, 0+XfOrM520_COUNT)));
#   define XfOrM536_COUNT (1+XfOrM520_COUNT)
#   define SETUP_XfOrM536(x) SETUP(XfOrM536_COUNT)
    owner = NULLED_OUT ; 

# 3762 "bc/src/thread.c"
    owner = ((Scheme_Thread * * ) FUNCCALL(SETUP_XfOrM536(_), GC_malloc (sizeof (Scheme_Thread * ) * (1 ) ) )) ; 
    p -> runstack_owner = owner ; 
    * owner = p ; 
  }

  np -> runstack = p -> runstack ; 
  np -> runstack_start = p -> runstack_start ; 
  np -> runstack_size = p -> runstack_size ; 
  np -> runstack_saved = p -> runstack_saved ; 
  np -> runstack_owner = p -> runstack_owner ; 
  * np -> runstack_owner = np ; 
  np -> stack_start = p -> stack_start ; 
  np -> engine_weight = p -> engine_weight ; 
  {
    Scheme_Object * * tb ; 
    BLOCK_SETUP((PUSH(tb, 0+XfOrM520_COUNT)));
#   define XfOrM535_COUNT (1+XfOrM520_COUNT)
#   define SETUP_XfOrM535(x) SETUP(XfOrM535_COUNT)
    tb = NULLED_OUT ; 

# 3777 "bc/src/thread.c"
    tb = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM535(_), GC_malloc (sizeof (Scheme_Object * ) * (p -> tail_buffer_size ) ) )) ; 
    np -> tail_buffer = tb ; 
  }
  np -> tail_buffer_size = p -> tail_buffer_size ; 
  FUNCCALL(SETUP_XfOrM520(_), scheme_gmp_tls_init (np -> gmp_tls ) )
  ; 


  np -> next = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) -> prev = np ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) = np ; 

  np -> t_set_parent = p -> t_set_parent ; 
  (schedule_in_set ((Scheme_Object * ) np , np -> t_set_parent ) ) ; 

  {
    Scheme_Thread_Cell_Table * cells ; 
    BLOCK_SETUP((PUSH(cells, 0+XfOrM520_COUNT)));
#   define XfOrM534_COUNT (1+XfOrM520_COUNT)
#   define SETUP_XfOrM534(x) SETUP(XfOrM534_COUNT)
    cells = NULLED_OUT ; 

# 3794 "bc/src/thread.c"
    cells = FUNCCALL(SETUP_XfOrM534(_), scheme_inherit_cells (p -> cell_values ) ); 
    np -> cell_values = cells ; 
  }
  {
    Scheme_Config * config ; 
    BLOCK_SETUP((PUSH(config, 0+XfOrM520_COUNT)));
#   define XfOrM533_COUNT (1+XfOrM520_COUNT)
#   define SETUP_XfOrM533(x) SETUP(XfOrM533_COUNT)
    config = NULLED_OUT ; 

# 3799 "bc/src/thread.c"
    config = FUNCCALL(SETUP_XfOrM533(_), scheme_current_config () ); 
    np -> init_config = config ; 
  }
  {
    int cb ; 
    Scheme_Object * bc ; 
    BLOCK_SETUP((PUSH(bc, 0+XfOrM520_COUNT)));
#   define XfOrM532_COUNT (1+XfOrM520_COUNT)
#   define SETUP_XfOrM532(x) SETUP(XfOrM532_COUNT)
    bc = NULLED_OUT ; 

# 3805 "bc/src/thread.c"
    cb = FUNCCALL(SETUP_XfOrM532(_), scheme_can_break (p ) ); 
    p -> can_break_at_swap = cb ; 
    bc = FUNCCALL(SETUP_XfOrM532(_), scheme_current_break_cell () ); 
    np -> init_break_cell = bc ; 
    if ((bc ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) ) ) 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) = ((void * ) 0 ) ; 
  }
  np -> cont_mark_pos = (intptr_t ) 1 ; 
  FUNCCALL(SETUP_XfOrM520(_), check_ready_break () )

  ; 

  np -> nester = p ; 
  p -> nestee = np ; 
  np -> external_break = p -> external_break ; 
  p -> external_break = 0 ; 

  {
    Scheme_Thread_Custodian_Hop * hop ; 
    Scheme_Custodian_Reference * mref ; 
    BLOCK_SETUP((PUSH(mref, 0+XfOrM520_COUNT), PUSH(hop, 1+XfOrM520_COUNT)));
#   define XfOrM530_COUNT (2+XfOrM520_COUNT)
#   define SETUP_XfOrM530(x) SETUP(XfOrM530_COUNT)
    hop = NULLED_OUT ; 
    mref = NULLED_OUT ; 

# 3825 "bc/src/thread.c"
    hop = ((Scheme_Thread_Custodian_Hop * ) FUNCCALL(SETUP_XfOrM530(_), GC_malloc_one_tagged (sizeof (Scheme_Thread_Custodian_Hop ) * (1 ) ) )) ; 
    np -> mr_hop = hop ; 
    hop -> so . type = scheme_thread_hop_type ; 
    {
      Scheme_Thread * wp ; 
      BLOCK_SETUP((PUSH(wp, 0+XfOrM530_COUNT)));
#     define XfOrM531_COUNT (1+XfOrM530_COUNT)
#     define SETUP_XfOrM531(x) SETUP(XfOrM531_COUNT)
      wp = NULLED_OUT ; 

# 3830 "bc/src/thread.c"
      wp = (Scheme_Thread * ) FUNCCALL(SETUP_XfOrM531(_), scheme_make_weak_box ((Scheme_Object * ) np ) ); 
      hop -> p = wp ; 
    }
    mref = FUNCCALL(SETUP_XfOrM530(_), scheme_add_managed (mgr , (Scheme_Object * ) hop , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
    np -> mref = mref ; 
    np -> extra_mrefs = scheme_null ; 
  }




  np -> gc_prep_chain = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) = np ; 


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = np -> cont_mark_stack ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = np -> cont_mark_pos ; 


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) = np ; 

  if (p != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) )
    FUNCCALL(SETUP_XfOrM520(_), scheme_weak_suspend_thread (p ) ); 

  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> the_nested_exn_handler_ ) ) {
#   define XfOrM529_COUNT (0+XfOrM520_COUNT)
#   define SETUP_XfOrM529(x) SETUP_XfOrM520(x)
    FUNCCALL(SETUP_XfOrM529(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> the_nested_exn_handler_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> the_nested_exn_handler_ ) ) ) )
# 3855 "bc/src/thread.c"
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> the_nested_exn_handler_ ) = FUNCCALL(SETUP_XfOrM529(_), scheme_make_prim_w_arity (def_nested_exn_handler , "nested-thread-exception-handler" , 1 , 1 ) )

    ; 
  }
  FUNCCALL(SETUP_XfOrM520(_), scheme_set_cont_mark (scheme_exn_handler_key , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> the_nested_exn_handler_ ) ) ); 


  np -> error_buf = & newbuf ; 
  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM520_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    if (! np -> cjs . is_kill )
      v = np -> cjs . val ; 
    else 
    v = ((void * ) 0 ) ; 
    failure = 1 ; 
  }

# 3870 "bc/src/thread.c"
  else {
#   define XfOrM527_COUNT (0+XfOrM520_COUNT)
#   define SETUP_XfOrM527(x) SETUP_XfOrM520(x)

# 3871 "bc/src/thread.c"
    v = FUNCCALL(SETUP_XfOrM527(_), scheme_apply_with_prompt (argv [0 ] , 0 , ((void * ) 0 ) ) ); 
    failure = 0 ; 
  }
  FUNCCALL(SETUP_XfOrM520(_), scheme_remove_managed (np -> mref , (Scheme_Object * ) np -> mr_hop ) )
  ; 
  {
    Scheme_Object * l ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM520_COUNT)));
#   define XfOrM524_COUNT (1+XfOrM520_COUNT)
#   define SETUP_XfOrM524(x) SETUP(XfOrM524_COUNT)
    l = NULLED_OUT ; 

# 3878 "bc/src/thread.c"
    for (l = np -> extra_mrefs ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM526_COUNT (0+XfOrM524_COUNT)
#     define SETUP_XfOrM526(x) SETUP_XfOrM524(x)
      FUNCCALL(SETUP_XfOrM526(_), scheme_remove_managed ((Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , (Scheme_Object * ) np -> mr_hop ) )
# 3880 "bc/src/thread.c"
      ; 
    }
  }
  np -> extra_mrefs = scheme_null ; 

  (((Scheme_Small_Object * ) (np -> mr_hop -> p ) ) -> u . ptr_val ) = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM520(_), scheme_remove_all_finalization (np -> mr_hop ) )


  ; 

  if (np -> prev )
    np -> prev -> next = np -> next ; 
  else 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) = np -> next ; 
  np -> next -> prev = np -> prev ; 

  np -> next = ((void * ) 0 ) ; 
  np -> prev = ((void * ) 0 ) ; 
  (
  unschedule_in_set ((Scheme_Object * ) np , np -> t_set_parent ) ) ; 

  if (np -> cont_mark_stack_owner 
  && ((* np -> cont_mark_stack_owner ) == np ) ) {
    * np -> cont_mark_stack_owner = ((void * ) 0 ) ; 
  }

  np -> running = 0 ; 

  * p -> runstack_owner = p ; 

  p -> external_break = np -> external_break ; 
  p -> nestee = ((void * ) 0 ) ; 
  np -> nester = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM520(_), thread_is_dead (np ) )
  ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) = p ; 

  if (! p -> gc_prep_chain ) {
    p -> gc_prep_chain = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) = p ; 
  }

  if (p != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) )
    FUNCCALL(SETUP_XfOrM520(_), scheme_weak_resume_thread (p ) ); 


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = p -> cont_mark_stack ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = p -> cont_mark_pos ; 


  if ((p -> running & 0x4 ) 
  || (p -> running & 0x10 ) )
    FUNCCALL(SETUP_XfOrM520(_), scheme_thread_block (0.0 ) ); 

  if (failure ) {
#   define XfOrM521_COUNT (0+XfOrM520_COUNT)
#   define SETUP_XfOrM521(x) SETUP_XfOrM520(x)

# 3937 "bc/src/thread.c"
    if (! v )
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL , "call-in-nested-thread: the thread was killed, or it exited via the default error escape handler" ) )
    ; 
    else FUNCCALL(SETUP_XfOrM521(_), scheme_raise (v ) )
    ; 
  }
  FUNCCALL(SETUP_XfOrM520(_), scheme_check_break_now () )


  ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3951 "bc/src/thread.c"
static Scheme_Object * call_as_nested_thread (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * result ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(result, 0)));
# define XfOrM541_COUNT (1)
# define SETUP_XfOrM541(x) SETUP(XfOrM541_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  result = NULLED_OUT ; 

# 3954 "bc/src/thread.c"
  result = FUNCCALL(SETUP_XfOrM541(_), scheme_call_as_nested_thread (argc , argv , & __gc_var_stack__ ) ); 
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int check_fd_semaphores () ; 

void scheme_init_fd_semaphores (void ) 
{
  /* No conversion */

# 3966 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) = rktio_ltps_open (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

void scheme_release_fd_semaphores (void ) 
{
  /* No conversion */

# 3971 "bc/src/thread.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) ) {
    rktio_ltps_remove_all (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) ) ; 
    (void ) check_fd_semaphores () ; 
    rktio_ltps_close (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) ) ; 
  }
}

static void log_fd_semaphore_error () 
{
  PREPARE_VAR_STACK(1);
# define XfOrM545_COUNT (0)
# define SETUP_XfOrM545(x) SETUP(XfOrM545_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3980 "bc/src/thread.c"
  {
    Scheme_Logger * logger ; 
    BLOCK_SETUP((PUSH(logger, 0+XfOrM545_COUNT)));
#   define XfOrM546_COUNT (1+XfOrM545_COUNT)
#   define SETUP_XfOrM546(x) SETUP(XfOrM546_COUNT)
    logger = NULLED_OUT ; 

# 3982 "bc/src/thread.c"
    logger = FUNCCALL(SETUP_XfOrM546(_), scheme_get_main_logger () ); 
    FUNCCALL_EMPTY(scheme_log (logger , 3 , 0 , "error for long-term poll set: %R" ) )
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3988 "bc/src/thread.c"
Scheme_Object * scheme_fd_to_semaphore (intptr_t fd , int mode , int is_socket ) 
{
  rktio_fd_t * rfd ; 
  Scheme_Object * sema ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(rfd, 0), PUSH(sema, 1)));
# define XfOrM547_COUNT (2)
# define SETUP_XfOrM547(x) SETUP(XfOrM547_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rfd = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 3993 "bc/src/thread.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  rfd = (rktio_system_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fd , ((1 << 0 ) 
  | (1 << 1 ) 
  | (is_socket ? (1 << 7 ) : 0 ) ) ) ) ; 

  sema = FUNCCALL(SETUP_XfOrM547(_), scheme_rktio_fd_to_semaphore (rfd , mode ) ); 
  (
  rktio_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , rfd ) ) ; 

  RET_VALUE_START (sema ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4007 "bc/src/thread.c"
Scheme_Object * scheme_rktio_fd_to_semaphore (rktio_fd_t * fd , int mode ) 
{
  rktio_ltps_handle_t * h ; 
  void * * ib ; 
  Scheme_Object * __funcarg183 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(h, 0), PUSH(ib, 1)));
# define XfOrM548_COUNT (2)
# define SETUP_XfOrM548(x) SETUP(XfOrM548_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  h = NULLED_OUT ; 
  ib = NULLED_OUT ; 

# 4012 "bc/src/thread.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  switch (mode ) {
    case 1 : 
    mode = RKTIO_LTPS_CREATE_READ ; 
    break ; 
    case 2 : 
    mode = RKTIO_LTPS_CREATE_WRITE ; 
    break ; 
    case 3 : 
    mode = RKTIO_LTPS_CHECK_READ ; 
    break ; 
    case 4 : 
    mode = RKTIO_LTPS_CHECK_WRITE ; 
    break ; 
    case 5 : 
    mode = RKTIO_LTPS_REMOVE ; 
    break ; 
  }

  h = (rktio_ltps_add (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) , fd , mode ) ) ; 

  if (! h ) {
#   define XfOrM550_COUNT (0+XfOrM548_COUNT)
#   define SETUP_XfOrM550(x) SETUP_XfOrM548(x)

# 4036 "bc/src/thread.c"
    if (FUNCCALL(SETUP_XfOrM550(_), scheme_last_error_is_racket (RKTIO_ERROR_LTPS_REMOVED ) )
    || FUNCCALL(SETUP_XfOrM550(_), scheme_last_error_is_racket (RKTIO_ERROR_LTPS_NOT_FOUND ) )) {

      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (! FUNCCALL(SETUP_XfOrM550(_), scheme_last_error_is_racket (RKTIO_ERROR_UNSUPPORTED ) ))
      FUNCCALL(SETUP_XfOrM550(_), log_fd_semaphore_error () ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  ib = (rktio_ltps_handle_get_data (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , h ) ) ; 
  if (! ib ) {
#   define XfOrM549_COUNT (0+XfOrM548_COUNT)
#   define SETUP_XfOrM549(x) SETUP_XfOrM548(x)

# 4048 "bc/src/thread.c"
    ib = (__funcarg183 = FUNCCALL(SETUP_XfOrM549(_), scheme_make_sema (0 ) ), FUNCCALL_AGAIN(scheme_malloc_immobile_box (__funcarg183 ) )) ; 
    (rktio_ltps_handle_set_data (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , h , ib ) ) ; 
  }

  RET_VALUE_START (* (Scheme_Object * * ) ib ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4055 "bc/src/thread.c"
static int check_fd_semaphores () 
{
  rktio_ltps_handle_t * h ; 
  int did = 0 ; 
  void * p ; 
  Scheme_Object * sema ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(sema, 1), PUSH(h, 2)));
# define XfOrM553_COUNT (3)
# define SETUP_XfOrM553(x) SETUP(XfOrM553_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  h = NULLED_OUT ; 
  p = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 4062 "bc/src/thread.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  (
  rktio_ltps_poll (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) ) ) ; 

  while (1 ) {
#   define XfOrM556_COUNT (0+XfOrM553_COUNT)
#   define SETUP_XfOrM556(x) SETUP_XfOrM553(x)

# 4068 "bc/src/thread.c"
    h = (rktio_ltps_get_signaled_handle (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_semaphore_fd_set_ ) ) ) ; 
    if (h ) {
#     define XfOrM557_COUNT (0+XfOrM556_COUNT)
#     define SETUP_XfOrM557(x) SETUP_XfOrM556(x)

# 4070 "bc/src/thread.c"
      p = (rktio_ltps_handle_get_data (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , h ) ) ; 
      FUNCCALL(SETUP_XfOrM557(_), free (h ) ); 

      sema = * (Scheme_Object * * ) p ; 
      FUNCCALL(SETUP_XfOrM557(_), scheme_free_immobile_box (p ) ); 
      FUNCCALL_AGAIN(scheme_post_sema_all (sema ) )
      ; 

      did = 1 ; 
    }

# 4079 "bc/src/thread.c"
    else 
    break ; 
  }

  RET_VALUE_START (did ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4086 "bc/src/thread.c"
void scheme_check_fd_semaphores (void ) 
{
  /* No conversion */

# 4088 "bc/src/thread.c"
  (void ) check_fd_semaphores () ; 
}

typedef struct {
  int running ; 
  double sleep_end ; 
  int block_descriptor ; 
  Scheme_Object * blocker ; 
  Scheme_Ready_Fun block_check ; 
  Scheme_Needs_Wakeup_Fun block_needs_wakeup ; 
  Scheme_Kill_Action_Func private_on_kill ; 
  void * private_kill_data ; 
  void * * private_kill_next ; 
}

# 4101 "bc/src/thread.c"
Thread_Schedule_State_Record ; 

static void save_thread_schedule_state (Scheme_Thread * p , 
Thread_Schedule_State_Record * s , 
int save_kills ) 
{
  /* No conversion */

# 4107 "bc/src/thread.c"
  s -> running = p -> running ; 
  s -> sleep_end = p -> sleep_end ; 
  s -> block_descriptor = p -> block_descriptor ; 
  s -> blocker = p -> blocker ; 
  s -> block_check = p -> block_check ; 
  s -> block_needs_wakeup = p -> block_needs_wakeup ; 

  if (save_kills ) {
    s -> private_on_kill = p -> private_on_kill ; 
    s -> private_kill_data = p -> private_kill_data ; 
    s -> private_kill_next = p -> private_kill_next ; 
  }

  p -> running = 0x1 ; 
  p -> sleep_end = 0.0 ; 
  p -> block_descriptor = 0 ; 
  p -> blocker = ((void * ) 0 ) ; 
  p -> block_check = ((void * ) 0 ) ; 
  p -> block_needs_wakeup = ((void * ) 0 ) ; 
}

static void restore_thread_schedule_state (Scheme_Thread * p , 
Thread_Schedule_State_Record * s , 
int save_kills ) 
{
  /* No conversion */

# 4132 "bc/src/thread.c"
  p -> running = s -> running ; 
  p -> sleep_end = s -> sleep_end ; 
  p -> block_descriptor = s -> block_descriptor ; 
  p -> blocker = s -> blocker ; 
  p -> block_check = s -> block_check ; 
  p -> block_needs_wakeup = s -> block_needs_wakeup ; 

  if (save_kills ) {
    p -> private_on_kill = s -> private_on_kill ; 
    p -> private_kill_data = s -> private_kill_data ; 
    p -> private_kill_next = s -> private_kill_next ; 
  }
}

static int check_sleep (int need_activity , int sleep_now ) 

{
  Scheme_Thread * p , * p2 ; 
  int end_with_act ; 
  void * fds ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(fds, 1)));
# define XfOrM563_COUNT (2)
# define SETUP_XfOrM563(x) SETUP(XfOrM563_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 
  p2 = NULLED_OUT ; 
  fds = NULLED_OUT ; 

# 4153 "bc/src/thread.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )
    RET_VALUE_START (0 ) RET_VALUE_END ; 


  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) ) {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ; 
    while (p ) {
      if (! p -> nestee 
      && (p -> ran_some || p -> block_descriptor == 0 ) 
      && (p -> next || ! (p -> running & 0x10 ) ) )
        break ; 
      p = p -> next ; 
    }
  }

# 4166 "bc/src/thread.c"
  else 
  p = ((void * ) 0 ) ; 

  p2 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ; 
  while (p2 ) {
#   define XfOrM590_COUNT (0+XfOrM563_COUNT)
#   define SETUP_XfOrM590(x) SETUP_XfOrM563(x)

# 4171 "bc/src/thread.c"
    if (p2 -> ran_some ) {
#     define XfOrM591_COUNT (0+XfOrM590_COUNT)
#     define SETUP_XfOrM591(x) SETUP_XfOrM590(x)
      (
# 4172 "bc/src/thread.c"
      rkio_reset_sleep_backoff (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
      p2 -> ran_some = 0 ; 
    }
    p2 = p2 -> next ; 
  }

  end_with_act = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_ended_with_activity_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_ended_with_activity_ ) = 0 ; 

  if (need_activity 
  && ! end_with_act 
  && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) 
  || (! p && ((! sleep_now && scheme_wakeup_on_input ) 
  || (sleep_now && (scheme_sleep || XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_sleep_ ) ) ) ) ) ) ) {
    double max_sleep_time = 0 ; 
#   define XfOrM564_COUNT (0+XfOrM563_COUNT)
#   define SETUP_XfOrM564(x) SETUP_XfOrM563(x)



    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> have_activity_ ) )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_active_but_sleeping_ ) = 1 ; 
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> have_activity_ ) && scheme_notify_multithread )
      FUNCCALL(SETUP_XfOrM564(_), scheme_notify_multithread (0 ) ); 

    fds = (rktio_make_poll_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_cancelled_ ) = 0 ; 

    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ; 
    while (p ) {
      int merge_time = 0 ; 
      double p_time ; 
#     define XfOrM579_COUNT (0+XfOrM564_COUNT)
#     define SETUP_XfOrM579(x) SETUP_XfOrM564(x)

# 4206 "bc/src/thread.c"
      if (p -> nestee ) {
      }
      else if (p -> block_descriptor == - 1 ) {
#       define XfOrM583_COUNT (0+XfOrM579_COUNT)
#       define SETUP_XfOrM583(x) SETUP_XfOrM579(x)

# 4209 "bc/src/thread.c"
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_time_end_ ) = - 1.0 ; 
        if (p -> block_needs_wakeup ) {
          Scheme_Needs_Wakeup_Fun f = p -> block_needs_wakeup ; 
          Scheme_Object * blocker = p -> blocker ; 
          Thread_Schedule_State_Record ssr ; 
          BLOCK_SETUP((PUSH(blocker, 0+XfOrM583_COUNT), PUSH(ssr.blocker, 1+XfOrM583_COUNT), PUSH(ssr.private_kill_data, 2+XfOrM583_COUNT), PUSH(ssr.private_kill_next, 3+XfOrM583_COUNT)));
#         define XfOrM586_COUNT (4+XfOrM583_COUNT)
#         define SETUP_XfOrM586(x) SETUP(XfOrM586_COUNT)
          ssr.blocker = NULLED_OUT ; 
          ssr.private_kill_data = NULLED_OUT ; 
          ssr.private_kill_next = NULLED_OUT ; 
          FUNCCALL(SETUP_XfOrM586(_), save_thread_schedule_state (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , & ssr , 0 ) )
# 4214 "bc/src/thread.c"
          ; 
          FUNCCALL_AGAIN(f (blocker , fds ) ); 
          FUNCCALL_AGAIN(restore_thread_schedule_state (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , & ssr , 0 ) ); 
        }
        p_time = p -> sleep_end ; 
        merge_time = (p_time > 0.0 ) ; 
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_time_end_ ) > 0.0 ) {
          if (! merge_time || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_time_end_ ) < p_time ) ) {
            p_time = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_time_end_ ) ; 
            merge_time = 1 ; 
          }
        }
      }

# 4226 "bc/src/thread.c"
      else if (p -> block_descriptor == 1 ) {
        merge_time = 1 ; 
        p_time = p -> sleep_end ; 
      }

      if (merge_time ) {
        double d ; 
        double t ; 
#       define XfOrM580_COUNT (0+XfOrM579_COUNT)
#       define SETUP_XfOrM580(x) SETUP_XfOrM579(x)

# 4235 "bc/src/thread.c"
        d = (p_time - (rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ) ; 

        t = (d / 1000 ) ; 
        if (t <= 0 ) {
          t = (float ) 0.00001 ; 
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_cancelled_ ) = 1 ; 
        }
        if (! max_sleep_time || (t < max_sleep_time ) )
          max_sleep_time = t ; 
      }
      p = p -> next ; 
    }

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_cancelled_ ) ) {
#     define XfOrM569_COUNT (0+XfOrM564_COUNT)
#     define SETUP_XfOrM569(x) SETUP_XfOrM564(x)
      (
# 4249 "bc/src/thread.c"
      rktio_poll_set_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fds ) ) ; 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

    if (FUNCCALL(SETUP_XfOrM564(_), post_system_idle () )) {
#     define XfOrM568_COUNT (0+XfOrM564_COUNT)
#     define SETUP_XfOrM568(x) SETUP_XfOrM564(x)
      (
# 4254 "bc/src/thread.c"
      rktio_poll_set_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fds ) ) ; 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

    if (sleep_now ) {
      float mst = (float ) max_sleep_time ; 
#     define XfOrM565_COUNT (0+XfOrM564_COUNT)
#     define SETUP_XfOrM565(x) SETUP_XfOrM564(x)
      if (mst && ! ((double ) mst < (2 * max_sleep_time ) ) ) {
        mst = 1000000.0 ; 
      }

      {
        Scheme_Sleep_Proc slp ; 
#       define XfOrM566_COUNT (0+XfOrM565_COUNT)
#       define SETUP_XfOrM566(x) SETUP_XfOrM565(x)

# 4268 "bc/src/thread.c"
        if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_sleep_ ) )
          slp = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_sleep_ ) ; 
        else 
        slp = scheme_sleep ; 
        FUNCCALL(SETUP_XfOrM566(_), slp (mst , fds ) )
        ; 
      }
    }

# 4275 "bc/src/thread.c"
    else if (scheme_wakeup_on_input )
      FUNCCALL(SETUP_XfOrM564(_), scheme_wakeup_on_input (fds ) ); 
    (
    rktio_poll_set_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fds ) ) ; 

    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4286 "bc/src/thread.c"
void scheme_set_wakeup_time (void * fds , double end_time ) 
{
  /* No conversion */
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_time_end_ ) = end_time ; 
}

void scheme_set_place_sleep (Scheme_Sleep_Proc slp ) 
{
  /* No conversion */

# 4294 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_sleep_ ) = slp ; 
}

static int post_system_idle () 
{
  /* No conversion */

# 4299 "bc/src/thread.c"
  return scheme_try_channel_get (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_system_idle_channel_ ) ) ; 
}

void scheme_cancel_sleep () 
{
  /* No conversion */

# 4304 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> needs_sleep_cancelled_ ) = 1 ; 
}

void scheme_check_threads (void ) 
{
  /* No conversion */

# 4309 "bc/src/thread.c"
  double start , now ; 

  start = rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 

  while (1 ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ++ ; 
    scheme_thread_block ((float ) 0 ) ; 
    -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ; 

    if (check_sleep (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> have_activity_ ) , 0 ) )
      break ; 

    now = rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
    if (((now - start ) * 1000 ) > 10000 )
      break ; 
  }
}

void scheme_wake_up (void ) 
{
  /* No conversion */

# 4329 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_active_but_sleeping_ ) = 0 ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> have_activity_ ) && scheme_notify_multithread )
    scheme_notify_multithread (1 ) ; 
}

void scheme_out_of_fuel (void ) 
{
  /* No conversion */

# 4336 "bc/src/thread.c"
  if (scheme_defining_primitives )

# 4336 "bc/src/thread.c"
  return ; 

  scheme_thread_block ((float ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
}

static void init_schedule_info (Scheme_Schedule_Info * sinfo , Scheme_Thread * false_pos_ok , 
int no_redirect , double sleep_end ) 
{
  /* No conversion */

# 4345 "bc/src/thread.c"
  sinfo -> false_positive_ok = false_pos_ok ; 
  sinfo -> potentially_false_positive = 0 ; 
  sinfo -> current_syncing = ((void * ) 0 ) ; 
  sinfo -> spin = 0 ; 
  sinfo -> is_poll = 0 ; 
  sinfo -> no_redirect = no_redirect ; 
  sinfo -> sleep_end = sleep_end ; 
  sinfo -> replace_chain = ((void * ) 0 ) ; 
}

Scheme_Object * scheme_current_break_cell () 
{
  /* No conversion */

# 4357 "bc/src/thread.c"
  return scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_break_enabled_key ) ; 
}

static int can_break_param (Scheme_Thread * p ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM606_COUNT (1)
# define SETUP_XfOrM606(x) SETUP(XfOrM606_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4362 "bc/src/thread.c"
  if (p == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM606_COUNT)));
#   define XfOrM607_COUNT (1+XfOrM606_COUNT)
#   define SETUP_XfOrM607(x) SETUP(XfOrM607_COUNT)
    v = NULLED_OUT ; 

# 4365 "bc/src/thread.c"
    v = FUNCCALL(SETUP_XfOrM607(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_break_enabled_key ) ); 

    v = FUNCCALL_AGAIN(scheme_thread_cell_get (v , p -> cell_values ) ); 

    RET_VALUE_START ((! (((v ) ) == (scheme_false ) ) ) ) RET_VALUE_END ; 
  }

# 4370 "bc/src/thread.c"
  else 
  RET_VALUE_START (p -> can_break_at_swap ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4374 "bc/src/thread.c"
int scheme_can_break (Scheme_Thread * p ) 
{
  /* No conversion */

# 4376 "bc/src/thread.c"
  if (! p -> suspend_break && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_breaks_disabled_ ) && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) {
    return can_break_param (p ) ; 
  }

# 4378 "bc/src/thread.c"
  else 
  return 0 ; 
}

void scheme_set_can_break (int on ) 
{
  Scheme_Object * v ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM610_COUNT (1)
# define SETUP_XfOrM610(x) SETUP(XfOrM610_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 4386 "bc/src/thread.c"
  v = FUNCCALL(SETUP_XfOrM610(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_break_enabled_key ) ); 
  FUNCCALL_AGAIN(scheme_thread_cell_set (v , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values , (on ? scheme_true : scheme_false ) ) )

  ; 

  if ((v ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) ) ) 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4395 "bc/src/thread.c"
void scheme_check_break_now (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM611_COUNT (1)
# define SETUP_XfOrM611(x) SETUP(XfOrM611_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM611(_), check_ready_break () )
# 4399 "bc/src/thread.c"
  ; 

  if (p -> external_break && FUNCCALL(SETUP_XfOrM611(_), scheme_can_break (p ) )) {
#   define XfOrM612_COUNT (0+XfOrM611_COUNT)
#   define SETUP_XfOrM612(x) SETUP_XfOrM611(x)
    FUNCCALL(SETUP_XfOrM612(_), scheme_thread_block (0.0 ) )
# 4402 "bc/src/thread.c"
    ; 
    p -> ran_some = 1 ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4407 "bc/src/thread.c"
static Scheme_Object * check_break_now (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 4409 "bc/src/thread.c"
  scheme_check_break_now () ; 
  return scheme_void ; 
}

void scheme_push_break_enable (Scheme_Cont_Frame_Data * cframe , int on , int post_check ) 
{
  Scheme_Object * v = ((void * ) 0 ) ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(cframe, 1)));
# define XfOrM614_COUNT (2)
# define SETUP_XfOrM614(x) SETUP(XfOrM614_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4417 "bc/src/thread.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cell_ ) ) {
    if (! (! (((((Thread_Cell * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cell_ ) ) -> def_val ) ) == (scheme_false ) ) ) == ! on ) {
      v = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cell_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cell_ ) = ((void * ) 0 ) ; 
    }
  }

  if (! v )
    v = FUNCCALL(SETUP_XfOrM614(_), scheme_make_thread_cell (on ? scheme_true : scheme_false , 1 ) ); 
  FUNCCALL(SETUP_XfOrM614(_), scheme_push_continuation_frame (cframe ) ); 
  FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_break_enabled_key , v ) ); 
  if (post_check )
    FUNCCALL(SETUP_XfOrM614(_), scheme_check_break_now () ); 

  cframe -> cache = v ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) = v ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cc_count_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4436 "bc/src/thread.c"
void scheme_pop_break_enable (Scheme_Cont_Frame_Data * cframe , int post_check ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(cframe, 0)));
# define XfOrM617_COUNT (1)
# define SETUP_XfOrM617(x) SETUP(XfOrM617_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM617(_), scheme_pop_continuation_frame (cframe ) )
# 4438 "bc/src/thread.c"
  ; 
  if (post_check )
    FUNCCALL(SETUP_XfOrM617(_), scheme_check_break_now () ); 

  if (cframe -> cache == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) ) {
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cc_count_ ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> recycle_cell_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) ; 
    }
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> maybe_recycle_cell_ ) = ((void * ) 0 ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4450 "bc/src/thread.c"
static Scheme_Object * raise_user_break (void * data , int argc , Scheme_Object * * volatile argv ) 
{







  mz_jmp_buf * savebuf , newbuf ; 
  intptr_t save [4 ] ; 
  int kind ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(savebuf, 1)));
# define XfOrM620_COUNT (2)
# define SETUP_XfOrM620(x) SETUP(XfOrM620_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  savebuf = NULLED_OUT ; 

# 4463 "bc/src/thread.c"
  kind = (((intptr_t ) ((Scheme_Object * ) data ) ) >> 1 ) ; 

  savebuf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 
  FUNCCALL(SETUP_XfOrM620(_), scheme_gmp_tls_snapshot (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls , save ) ); 

  if (! ((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM620_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#   define XfOrM622_COUNT (0+XfOrM620_COUNT)
#   define SETUP_XfOrM622(x) SETUP_XfOrM620(x)
    FUNCCALL_EMPTY(scheme_raise_exn (kind , argv [0 ] , ((kind == MZEXN_BREAK_TERMINATE ) ? "terminate break" : ((kind == MZEXN_BREAK_HANG_UP ) ? "hang-up break" : "user break" ) ) ) )


    ; 
  }
  else {


    int cont ; 
#   define XfOrM621_COUNT (0+XfOrM620_COUNT)
#   define SETUP_XfOrM621(x) SETUP_XfOrM620(x)

# 4481 "bc/src/thread.c"
    cont = (((Scheme_Object * ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cjs . jumping_to_continuation ) ) == (argv [0 ] ) ) 
    ; 
    FUNCCALL(SETUP_XfOrM621(_), scheme_gmp_tls_restore_snapshot (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls , ((void * ) 0 ) , save , ! cont ) ); 
    (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
  }


  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4491 "bc/src/thread.c"
static void raise_break (Scheme_Thread * p ) 
{
  Thread_Schedule_State_Record ssr ; 
  Scheme_Object * a [1 ] ; 
  Scheme_Cont_Frame_Data cframe ; 
  int kind ; 
  PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(cframe.cache, 1), PUSHARRAY(a, 1, 2), PUSH(ssr.blocker, 5), PUSH(ssr.private_kill_data, 6), PUSH(ssr.private_kill_next, 7)));
# define XfOrM623_COUNT (8)
# define SETUP_XfOrM623(x) SETUP(XfOrM623_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ssr.blocker = NULLED_OUT ; 
  ssr.private_kill_data = NULLED_OUT ; 
  ssr.private_kill_next = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 4498 "bc/src/thread.c"
  kind = p -> external_break ; 
  p -> external_break = 0 ; 

  if (p -> blocker && (p -> block_check == (Scheme_Ready_Fun ) syncing_ready ) ) {
#   define XfOrM625_COUNT (0+XfOrM623_COUNT)
#   define SETUP_XfOrM625(x) SETUP_XfOrM623(x)
    FUNCCALL(SETUP_XfOrM625(_), get_outof_or_into_lines ((Syncing * ) p -> blocker , 1 ) )
    ; 
  }
  FUNCCALL(SETUP_XfOrM623(_), save_thread_schedule_state (p , & ssr , 0 ) )
  ; 
  p -> ran_some = 1 ; 

  a [0 ] = FUNCCALL(SETUP_XfOrM623(_), scheme_make_closed_prim ((Scheme_Closed_Prim * ) raise_user_break , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (kind ) ) ) << 1 ) | 0x1 ) ) ) ); 
  FUNCCALL(SETUP_XfOrM623(_), scheme_push_continuation_frame (& cframe ) )



  ; 
  FUNCCALL_AGAIN(scheme_call_ec (1 , a ) )
  ; 
  FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) )
  ; 
  FUNCCALL_AGAIN(restore_thread_schedule_state (p , & ssr , 0 ) )

  ; 

  if (p -> blocker && (p -> block_check == (Scheme_Ready_Fun ) syncing_ready ) ) {
#   define XfOrM624_COUNT (0+XfOrM623_COUNT)
#   define SETUP_XfOrM624(x) SETUP_XfOrM623(x)
    FUNCCALL(SETUP_XfOrM624(_), get_outof_or_into_lines ((Syncing * ) p -> blocker , 0 ) )
# 4527 "bc/src/thread.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4531 "bc/src/thread.c"
static void escape_to_kill (Scheme_Thread * p ) 
{
  /* No conversion */

# 4533 "bc/src/thread.c"
  p -> cjs . jumping_to_continuation = (Scheme_Object * ) p ; 
  p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
  p -> cjs . is_kill = 1 ; 
  p -> cjs . skip_dws = 1 ; 
  (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 
}

static void exit_or_escape (Scheme_Thread * p ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM627_COUNT (1)
# define SETUP_XfOrM627(x) SETUP(XfOrM627_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4543 "bc/src/thread.c"
  if (p -> nester ) {
#   define XfOrM629_COUNT (0+XfOrM627_COUNT)
#   define SETUP_XfOrM629(x) SETUP_XfOrM627(x)

# 4544 "bc/src/thread.c"
    if (p -> running & 0x4 )
      p -> running -= 0x4 ; 
    FUNCCALL(SETUP_XfOrM629(_), escape_to_kill (p ) ); 
  }

  if ((p ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ) )  {
#   define XfOrM628_COUNT (0+XfOrM627_COUNT)
#   define SETUP_XfOrM628(x) SETUP_XfOrM627(x)

# 4551 "bc/src/thread.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) )
      FUNCCALL(SETUP_XfOrM628(_), escape_to_kill (p ) ); 

    if (scheme_exit )
      FUNCCALL(SETUP_XfOrM628(_), scheme_exit (0 ) ); 
    FUNCCALL_EMPTY(exit (0 ) )

    ; 
  }
  FUNCCALL_EMPTY(remove_thread (p ) )
  ; 
  FUNCCALL_EMPTY(select_thread () ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4565 "bc/src/thread.c"
void scheme_break_kind_main_thread_at (void * p , int kind ) 





XFORM_SKIP_PROC 
{
  if (kind > * (volatile short * ) p )
    * (volatile short * ) p = kind ; 
}

void scheme_break_main_thread_at (void * p ) 
XFORM_SKIP_PROC 
{
  scheme_break_kind_main_thread_at (p , MZEXN_BREAK ) ; 
}

void scheme_break_main_thread () 


{
  /* No conversion */

# 4587 "bc/src/thread.c"
  scheme_break_main_thread_at ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> delayed_break_ready_ ) ) ; 
}

void * scheme_get_main_thread_break_handle () 
{
  /* No conversion */

# 4592 "bc/src/thread.c"
  return (void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> delayed_break_ready_ ) ; 
}

void scheme_set_break_main_target (Scheme_Thread * p ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM632_COUNT (1)
# define SETUP_XfOrM632(x) SETUP(XfOrM632_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4597 "bc/src/thread.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_break_target_thread_ ) ) {
#   define XfOrM633_COUNT (0+XfOrM632_COUNT)
#   define SETUP_XfOrM633(x) SETUP_XfOrM632(x)
    FUNCCALL(SETUP_XfOrM633(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_break_target_thread_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_break_target_thread_ ) ) ) )
# 4598 "bc/src/thread.c"
    ; 
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_break_target_thread_ ) = p ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4603 "bc/src/thread.c"
static void check_ready_break () 
{
  /* No conversion */
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) )
    scheme_place_check_for_interruption () ; 


  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> delayed_break_ready_ ) ) {
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ) {
      int kind = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> delayed_break_ready_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> delayed_break_ready_ ) = 0 ; 
      scheme_break_kind_thread (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_break_target_thread_ ) , kind ) ; 
    }
  }
}

void scheme_break_kind_thread (Scheme_Thread * p , int kind ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM637_COUNT (1)
# define SETUP_XfOrM637(x) SETUP(XfOrM637_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4621 "bc/src/thread.c"
  if (! p ) {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ; 
    if (! p )
      RET_NOTHING ; 
  }


  while (p -> nestee ) {
    p = p -> nestee ; 
  }

  if (kind > p -> external_break )
    p -> external_break = kind ; 

  if (p == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
#   define XfOrM638_COUNT (0+XfOrM637_COUNT)
#   define SETUP_XfOrM638(x) SETUP_XfOrM637(x)

# 4636 "bc/src/thread.c"
    if (FUNCCALL(SETUP_XfOrM638(_), scheme_can_break (p ) )) {
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) = 0 ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_jit_stack_boundary_ ) = (uintptr_t ) - 1 ; 
    }
  }
  FUNCCALL_EMPTY(scheme_weak_resume_thread (p ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4644 "bc/src/thread.c"
void scheme_break_thread (Scheme_Thread * p ) 
{
  /* No conversion */

# 4646 "bc/src/thread.c"
  scheme_break_kind_thread (p , MZEXN_BREAK ) ; 
}

static void call_on_atomic_timeout (int must ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Thread_Schedule_State_Record ssr ; 
  Scheme_On_Atomic_Timeout_Proc oat ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(ssr.blocker, 1), PUSH(ssr.private_kill_data, 2), PUSH(ssr.private_kill_next, 3)));
# define XfOrM644_COUNT (4)
# define SETUP_XfOrM644(x) SETUP(XfOrM644_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ssr.blocker = NULLED_OUT ; 
  ssr.private_kill_data = NULLED_OUT ; 
  ssr.private_kill_next = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM644(_), save_thread_schedule_state (p , & ssr , 1 ) )
# 4657 "bc/src/thread.c"
  ; 




  oat = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_ ) ; 
  FUNCCALL(SETUP_XfOrM644(_), oat (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_data_ ) , must ) ); 
  FUNCCALL_AGAIN(restore_thread_schedule_state (p , & ssr , 1 ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4668 "bc/src/thread.c"
static void find_next_thread (Scheme_Thread * * return_arg ) {
  Scheme_Thread * next ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * next_in_set ; 
  Scheme_Thread_Set * t_set ; 

  double msecs = 0.0 ; 
  PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(t_set, 1), PUSH(next, 2), PUSH(return_arg, 3), PUSH(next_in_set, 4)));
# define XfOrM645_COUNT (5)
# define SETUP_XfOrM645(x) SETUP(XfOrM645_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  next = NULLED_OUT ; 
  next_in_set = NULLED_OUT ; 
  t_set = NULLED_OUT ; 

# 4680 "bc/src/thread.c"
  next_in_set = (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_thread_set_top_ ) ; 
  t_set = ((void * ) 0 ) ; 



  while (1 ) {
#   define XfOrM671_COUNT (0+XfOrM645_COUNT)
#   define SETUP_XfOrM671(x) SETUP_XfOrM645(x)




    while (! ((Scheme_Type ) (((((intptr_t ) (next_in_set ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (next_in_set ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) ) {
#     define XfOrM695_COUNT (0+XfOrM671_COUNT)
#     define SETUP_XfOrM695(x) SETUP_XfOrM671(x)

# 4693 "bc/src/thread.c"
      t_set = (Scheme_Thread_Set * ) next_in_set ; 
      next_in_set = (get_t_set_next (t_set -> current ) ) ; 
      if (! next_in_set )
        next_in_set = t_set -> first ; 
      t_set -> current = next_in_set ; 
      t_set -> search_start = next_in_set ; 
    }



    next = (Scheme_Thread * ) next_in_set ; 



    if ((next ) == (p ) )  {
      next = ((void * ) 0 ) ; 
      break ; 
    }



    if (next -> nestee ) {
    }
    else if (next -> running & 0x10 ) {
      if (next -> next || (next -> running & 0x20 ) ) {



        break ; 
      }
    }

# 4723 "bc/src/thread.c"
    else if (next -> running & 0x4 ) {
#     define XfOrM688_COUNT (0+XfOrM671_COUNT)
#     define SETUP_XfOrM688(x) SETUP_XfOrM671(x)

# 4725 "bc/src/thread.c"
      if ((next -> running & 0x8 ) 
      || next -> nester 
      || ! next -> next ) {

        break ; 
      }

# 4730 "bc/src/thread.c"
      else FUNCCALL(SETUP_XfOrM688(_), remove_thread (next ) )
      ; 
      break ; 
    }

# 4733 "bc/src/thread.c"
    else if (next -> external_break && FUNCCALL(SETUP_XfOrM671(_), scheme_can_break (next ) )) {
      break ; 
    }

# 4735 "bc/src/thread.c"
    else {
#     define XfOrM683_COUNT (0+XfOrM671_COUNT)
#     define SETUP_XfOrM683(x) SETUP_XfOrM671(x)

# 4736 "bc/src/thread.c"
      if (next -> block_descriptor == - 1 ) {
#       define XfOrM685_COUNT (0+XfOrM683_COUNT)
#       define SETUP_XfOrM685(x) SETUP_XfOrM683(x)

# 4737 "bc/src/thread.c"
        if (next -> block_check ) {
          Scheme_Ready_Fun_FPC f = (Scheme_Ready_Fun_FPC ) next -> block_check ; 
          Scheme_Object * blocker = next -> blocker ; 
          Scheme_Schedule_Info sinfo ; 
          Thread_Schedule_State_Record ssr ; 
          int b ; 
          BLOCK_SETUP((PUSH(sinfo.false_positive_ok, 0+XfOrM685_COUNT), PUSH(sinfo.current_syncing, 1+XfOrM685_COUNT), PUSH(sinfo.replace_chain, 2+XfOrM685_COUNT), PUSH(blocker, 3+XfOrM685_COUNT), PUSH(ssr.blocker, 4+XfOrM685_COUNT), PUSH(ssr.private_kill_data, 5+XfOrM685_COUNT), PUSH(ssr.private_kill_next, 6+XfOrM685_COUNT)));
#         define XfOrM686_COUNT (7+XfOrM685_COUNT)
#         define SETUP_XfOrM686(x) SETUP(XfOrM686_COUNT)
          sinfo.false_positive_ok = NULLED_OUT ; 
          sinfo.current_syncing = NULLED_OUT ; 
          sinfo.replace_chain = NULLED_OUT ; 
          ssr.blocker = NULLED_OUT ; 
          ssr.private_kill_data = NULLED_OUT ; 
          ssr.private_kill_next = NULLED_OUT ; 
          FUNCCALL(SETUP_XfOrM686(_), save_thread_schedule_state (p , & ssr , 0 ) )
# 4744 "bc/src/thread.c"
          ; 
          FUNCCALL_AGAIN(init_schedule_info (& sinfo , next , 1 , next -> sleep_end ) )
          ; 
          b = FUNCCALL_AGAIN(f (blocker , & sinfo ) ); 
          FUNCCALL_AGAIN(restore_thread_schedule_state (p , & ssr , 0 ) )
          ; 

          if (b )
            break ; 
          next -> sleep_end = sinfo . sleep_end ; 
          msecs = 0.0 ; 
        }
      }

# 4756 "bc/src/thread.c"
      else if (next -> block_descriptor == 1 ) {
#       define XfOrM684_COUNT (0+XfOrM683_COUNT)
#       define SETUP_XfOrM684(x) SETUP_XfOrM683(x)

# 4757 "bc/src/thread.c"
        if (! msecs )
          msecs = (rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
        if (next -> sleep_end <= msecs )
          break ; 
      }

# 4761 "bc/src/thread.c"
      else 
      break ; 
    }


    if (next -> t_set_next )
      next_in_set = next -> t_set_next ; 
    else 
    next_in_set = t_set -> first ; 



    if ((next_in_set ) == (t_set -> search_start ) )  {
#     define XfOrM673_COUNT (0+XfOrM671_COUNT)
#     define SETUP_XfOrM673(x) SETUP_XfOrM671(x)
      while (1 ) {
#       define XfOrM679_COUNT (0+XfOrM673_COUNT)
#       define SETUP_XfOrM679(x) SETUP_XfOrM673(x)

# 4777 "bc/src/thread.c"
        t_set -> search_start = ((void * ) 0 ) ; 
        t_set = t_set -> parent ; 

        if (t_set ) {
#         define XfOrM680_COUNT (0+XfOrM679_COUNT)
#         define SETUP_XfOrM680(x) SETUP_XfOrM679(x)

# 4781 "bc/src/thread.c"
          next_in_set = (get_t_set_next (t_set -> current ) ) ; 
          if (! next_in_set )
            next_in_set = t_set -> first ; 

          if ((next_in_set ) == (t_set -> search_start ) )  {
            t_set -> search_start = ((void * ) 0 ) ; 
          }
          else {
            t_set -> current = next_in_set ; 
            break ; 
          }
        }

# 4792 "bc/src/thread.c"
        else 
        break ; 
      }

      if (! t_set ) {



        next = ((void * ) 0 ) ; 
        break ; 
      }
    }

# 4803 "bc/src/thread.c"
    else {

      t_set -> current = next_in_set ; 
    }
  }



  p = ((void * ) 0 ) ; 
  next_in_set = ((void * ) 0 ) ; 
  t_set = ((void * ) 0 ) ; 
  * return_arg = next ; 
  next = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4818 "bc/src/thread.c"
static Scheme_Object * do_thread_block () 
{
  /* No conversion */

# 4820 "bc/src/thread.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  float sleep_time = p -> sleep_end ; 
  p -> sleep_end = 0.0 ; 

  scheme_thread_block (sleep_time ) ; 

  return scheme_false ; 
}

void scheme_thread_block (float sleep_time ) 



{
  double sleep_end ; 
  Scheme_Thread * next ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  int skip_sleep ; 
  PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(next, 1)));
# define XfOrM697_COUNT (2)
# define SETUP_XfOrM697(x) SETUP(XfOrM697_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  next = NULLED_OUT ; 

# 4839 "bc/src/thread.c"
  if (p -> return_marks_to )
    RET_NOTHING ; 

  if (p -> running & 0x4 ) {
#   define XfOrM733_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM733(x) SETUP_XfOrM697(x)

# 4844 "bc/src/thread.c"
    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) )
      FUNCCALL(SETUP_XfOrM733(_), exit_or_escape (p ) ); 
  }

  if ((p -> running & 0x10 ) 
  && ! (p -> running & 0x20 ) ) {
#   define XfOrM731_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM731(x) SETUP_XfOrM697(x)
    FUNCCALL(SETUP_XfOrM731(_), scheme_wait_until_suspend_ok () )
# 4851 "bc/src/thread.c"
    ; 
    if (! p -> next ) {
#     define XfOrM732_COUNT (0+XfOrM731_COUNT)
#     define SETUP_XfOrM732(x) SETUP_XfOrM731(x)
      FUNCCALL(SETUP_XfOrM732(_), select_thread () )
# 4854 "bc/src/thread.c"
      ; 
    }

# 4855 "bc/src/thread.c"
    else FUNCCALL(SETUP_XfOrM731(_), scheme_weak_suspend_thread (p ) )
    ; 
  }
  FUNCCALL(SETUP_XfOrM697(_), check_scheduled_kills () )

  ; 
  (

  rktio_reap_processes (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 

  ; 





  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) && FUNCCALL(SETUP_XfOrM697(_), scheme_is_stack_too_shallow () )) {
#   define XfOrM730_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM730(x) SETUP_XfOrM697(x)

# 4872 "bc/src/thread.c"
    p -> sleep_end = sleep_time ; 

    (void ) FUNCCALL(SETUP_XfOrM730(_), scheme_handle_stack_overflow (do_thread_block ) ); 
    RET_NOTHING ; 
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_active_but_sleeping_ ) )
    FUNCCALL(SETUP_XfOrM697(_), scheme_wake_up () ); 

  if (sleep_time > 0 ) {
#   define XfOrM729_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM729(x) SETUP_XfOrM697(x)

# 4882 "bc/src/thread.c"
    sleep_end = (rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
    sleep_end += (sleep_time * 1000.0 ) ; 
  }

# 4884 "bc/src/thread.c"
  else 
  sleep_end = 0 ; 

  start_sleep_check : FUNCCALL(SETUP_XfOrM697(_), check_ready_break () )

  ; 

  if (! p -> external_break && ! p -> next && scheme_check_for_break && FUNCCALL(SETUP_XfOrM697(_), scheme_check_for_break () ))
    p -> external_break = 1 ; 

  if (p -> external_break && ! p -> suspend_break && FUNCCALL(SETUP_XfOrM697(_), scheme_can_break (p ) )) {
#   define XfOrM728_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM728(x) SETUP_XfOrM697(x)
    FUNCCALL(SETUP_XfOrM728(_), raise_break (p ) )
# 4895 "bc/src/thread.c"
    ; 
    goto start_sleep_check ; 
  }

  swap_or_sleep : FUNCCALL(SETUP_XfOrM697(_), check_scheduled_kills () )


  ; 






  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) )
    FUNCCALL(SETUP_XfOrM697(_), scheme_check_foreign_work () ); 


  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) )
    FUNCCALL(SETUP_XfOrM697(_), scheme_check_glib_log_messages () ); 


  skip_sleep = 0 ; 
  if (FUNCCALL(SETUP_XfOrM697(_), check_fd_semaphores () )) {
#   define XfOrM723_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM723(x) SETUP_XfOrM697(x)

# 4920 "bc/src/thread.c"
    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) && (p -> block_descriptor == - 1 ) ) {
#     define XfOrM724_COUNT (0+XfOrM723_COUNT)
#     define SETUP_XfOrM724(x) SETUP_XfOrM723(x)

# 4921 "bc/src/thread.c"
      if (p -> block_check ) {
        Scheme_Ready_Fun_FPC f = (Scheme_Ready_Fun_FPC ) p -> block_check ; 
        Scheme_Object * blocker = p -> blocker ; 
        Scheme_Schedule_Info sinfo ; 
        Thread_Schedule_State_Record ssr ; 
        int b ; 
        BLOCK_SETUP((PUSH(sinfo.false_positive_ok, 0+XfOrM724_COUNT), PUSH(sinfo.current_syncing, 1+XfOrM724_COUNT), PUSH(sinfo.replace_chain, 2+XfOrM724_COUNT), PUSH(blocker, 3+XfOrM724_COUNT), PUSH(ssr.blocker, 4+XfOrM724_COUNT), PUSH(ssr.private_kill_data, 5+XfOrM724_COUNT), PUSH(ssr.private_kill_next, 6+XfOrM724_COUNT)));
#       define XfOrM725_COUNT (7+XfOrM724_COUNT)
#       define SETUP_XfOrM725(x) SETUP(XfOrM725_COUNT)
        sinfo.false_positive_ok = NULLED_OUT ; 
        sinfo.current_syncing = NULLED_OUT ; 
        sinfo.replace_chain = NULLED_OUT ; 
        ssr.blocker = NULLED_OUT ; 
        ssr.private_kill_data = NULLED_OUT ; 
        ssr.private_kill_next = NULLED_OUT ; 
        FUNCCALL(SETUP_XfOrM725(_), save_thread_schedule_state (p , & ssr , 0 ) )
# 4928 "bc/src/thread.c"
        ; 
        FUNCCALL_AGAIN(init_schedule_info (& sinfo , p , 1 , sleep_end ) )
        ; 
        b = FUNCCALL_AGAIN(f (blocker , & sinfo ) ); 
        FUNCCALL_AGAIN(restore_thread_schedule_state (p , & ssr , 0 ) )
        ; 

        if (b ) {
          sleep_end = 0 ; 
          skip_sleep = 1 ; 
        }

# 4938 "bc/src/thread.c"
        else {
          sleep_end = sinfo . sleep_end ; 
        }
      }
    }
  }

  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) && (sleep_end >= 0.0 ) ) {
#   define XfOrM722_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM722(x) SETUP_XfOrM697(x)
    FUNCCALL(SETUP_XfOrM722(_), find_next_thread (& next ) )
# 4946 "bc/src/thread.c"
    ; 
  }

# 4947 "bc/src/thread.c"
  else 
  next = ((void * ) 0 ) ; 

  if (next ) {

    Scheme_Thread_Set * t_set ; 
    t_set = NULLED_OUT ; 

# 4953 "bc/src/thread.c"
    t_set = next -> t_set_parent ; 
    while (t_set ) {
      t_set -> search_start = ((void * ) 0 ) ; 
      t_set = t_set -> parent ; 
    }
    t_set = ((void * ) 0 ) ; 
  }

  if ((sleep_end > 0.0 ) && (p -> block_descriptor == 0 ) ) {
    p -> block_descriptor = 1 ; 
    p -> sleep_end = sleep_end ; 
  }

# 4964 "bc/src/thread.c"
  else if ((sleep_end > 0.0 ) && (p -> block_descriptor == - 1 ) ) {
    p -> sleep_end = sleep_end ; 
  }

  if (next && (! next -> running || (next -> running & 0x2 ) ) ) {



    next = ((void * ) 0 ) ; 
  }

# 4993 "bc/src/thread.c"
  if (next ) {
#   define XfOrM715_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM715(x) SETUP_XfOrM697(x)

# 4995 "bc/src/thread.c"
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> swap_target_ ) = next ; 
    next = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM715(_), do_swap_thread () ); 
  }

# 4998 "bc/src/thread.c"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_ ) 
  && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) < 2 ) ) {
#   define XfOrM712_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM712(x) SETUP_XfOrM697(x)

# 5000 "bc/src/thread.c"
    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) 
    || (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) <= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_atomic_level_ ) ) ) {
#     define XfOrM713_COUNT (0+XfOrM712_COUNT)
#     define SETUP_XfOrM713(x) SETUP_XfOrM712(x)

# 5002 "bc/src/thread.c"
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) ) {
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) ++ ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) = p -> engine_weight ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_jit_stack_boundary_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ; 
      }
      FUNCCALL(SETUP_XfOrM713(_), call_on_atomic_timeout (0 ) ); 
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) > 1 )
        -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) ; 
    }
  }

# 5011 "bc/src/thread.c"
  else {
#   define XfOrM710_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM710(x) SETUP_XfOrM697(x)

# 5013 "bc/src/thread.c"
    if ((p -> block_descriptor != 0 ) && ! skip_sleep ) {
#     define XfOrM711_COUNT (0+XfOrM710_COUNT)
#     define SETUP_XfOrM711(x) SETUP_XfOrM710(x)
      FUNCCALL(SETUP_XfOrM711(_), check_sleep (1 , 1 ) )
# 5014 "bc/src/thread.c"
      ; 
    }
  }

  if (p -> block_descriptor == 1 ) {
    p -> block_descriptor = 0 ; 
  }
  p -> sleep_end = 0.0 ; 


  if (p -> running & 0x4 ) {
#   define XfOrM706_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM706(x) SETUP_XfOrM697(x)

# 5026 "bc/src/thread.c"
    if (p -> running & 0x8 ) {

      RET_NOTHING ; 
    }

# 5029 "bc/src/thread.c"
    else {
#     define XfOrM707_COUNT (0+XfOrM706_COUNT)
#     define SETUP_XfOrM707(x) SETUP_XfOrM706(x)

# 5030 "bc/src/thread.c"
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) )
        FUNCCALL(SETUP_XfOrM707(_), exit_or_escape (p ) ); 
    }
  }


  if ((p -> running & 0x10 ) 
  && ! (p -> running & 0x20 ) ) {
#   define XfOrM705_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM705(x) SETUP_XfOrM697(x)
    FUNCCALL(SETUP_XfOrM705(_), scheme_wait_until_suspend_ok () )
# 5038 "bc/src/thread.c"
    ; 
    if (! p -> next )
      FUNCCALL(SETUP_XfOrM705(_), scheme_thread_block (0.0 ) ); 
    else FUNCCALL(SETUP_XfOrM705(_), scheme_weak_suspend_thread (p ) )
    ; 
  }
  FUNCCALL(SETUP_XfOrM697(_), check_ready_break () )

  ; 
  if (p -> external_break && ! p -> suspend_break && FUNCCALL(SETUP_XfOrM697(_), scheme_can_break (p ) )) {
#   define XfOrM704_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM704(x) SETUP_XfOrM697(x)
    FUNCCALL(SETUP_XfOrM704(_), raise_break (p ) )
# 5048 "bc/src/thread.c"
    ; 
  }



  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) )
    FUNCCALL(SETUP_XfOrM697(_), GC_check_master_gc_request () ); 
  FUNCCALL(SETUP_XfOrM697(_), scheme_place_check_memory_use () )




  ; 
  FUNCCALL_AGAIN(check_scheduled_kills () ); 


  if (sleep_end > 0 ) {
#   define XfOrM698_COUNT (0+XfOrM697_COUNT)
#   define SETUP_XfOrM698(x) SETUP_XfOrM697(x)

# 5065 "bc/src/thread.c"
    if (sleep_end > (rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ) {
#     define XfOrM699_COUNT (0+XfOrM698_COUNT)
#     define SETUP_XfOrM699(x) SETUP_XfOrM698(x)
      if (p -> block_descriptor == - 1 ) {
#       define XfOrM700_COUNT (0+XfOrM699_COUNT)
#       define SETUP_XfOrM700(x) SETUP_XfOrM699(x)

# 5069 "bc/src/thread.c"
        if (p -> block_check ) {
          Scheme_Ready_Fun_FPC f = (Scheme_Ready_Fun_FPC ) p -> block_check ; 
          Scheme_Object * blocker = p -> blocker ; 
          Scheme_Schedule_Info sinfo ; 
          Thread_Schedule_State_Record ssr ; 
          int b ; 
          BLOCK_SETUP((PUSH(sinfo.false_positive_ok, 0+XfOrM700_COUNT), PUSH(sinfo.current_syncing, 1+XfOrM700_COUNT), PUSH(sinfo.replace_chain, 2+XfOrM700_COUNT), PUSH(blocker, 3+XfOrM700_COUNT), PUSH(ssr.blocker, 4+XfOrM700_COUNT), PUSH(ssr.private_kill_data, 5+XfOrM700_COUNT), PUSH(ssr.private_kill_next, 6+XfOrM700_COUNT)));
#         define XfOrM701_COUNT (7+XfOrM700_COUNT)
#         define SETUP_XfOrM701(x) SETUP(XfOrM701_COUNT)
          sinfo.false_positive_ok = NULLED_OUT ; 
          sinfo.current_syncing = NULLED_OUT ; 
          sinfo.replace_chain = NULLED_OUT ; 
          ssr.blocker = NULLED_OUT ; 
          ssr.private_kill_data = NULLED_OUT ; 
          ssr.private_kill_next = NULLED_OUT ; 
          FUNCCALL(SETUP_XfOrM701(_), save_thread_schedule_state (p , & ssr , 0 ) )
# 5076 "bc/src/thread.c"
          ; 
          FUNCCALL_AGAIN(init_schedule_info (& sinfo , p , 1 , sleep_end ) )
          ; 
          b = FUNCCALL_AGAIN(f (blocker , & sinfo ) ); 
          FUNCCALL_AGAIN(restore_thread_schedule_state (p , & ssr , 0 ) )
          ; 

          if (b ) {
            sleep_end = 0 ; 
          }

# 5085 "bc/src/thread.c"
          else {
            sleep_end = sinfo . sleep_end ; 
          }
        }
      }

      if (sleep_end > 0 )
        goto swap_or_sleep ; 
    }
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> missed_context_switch_ ) = 1 ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) = p -> engine_weight ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_jit_stack_boundary_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ; 
  FUNCCALL(SETUP_XfOrM697(_), scheme_kickoff_green_thread_time_slice_timer (10000 ) )
  ; 
  FUNCCALL_AGAIN(check_scheduled_kills () )

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5108 "bc/src/thread.c"
void scheme_making_progress () 
{
  /* No conversion */

# 5110 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
}

int scheme_block_until (Scheme_Ready_Fun _f , Scheme_Needs_Wakeup_Fun fdf , 
Scheme_Object * data , float delay ) 
{
  int result ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Ready_Fun_FPC f = (Scheme_Ready_Fun_FPC ) _f ; 
  Scheme_Schedule_Info sinfo ; 
  double sleep_end ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(sinfo.false_positive_ok, 0), PUSH(sinfo.current_syncing, 1), PUSH(sinfo.replace_chain, 2), PUSH(p, 3), PUSH(data, 4)));
# define XfOrM735_COUNT (5)
# define SETUP_XfOrM735(x) SETUP(XfOrM735_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sinfo.false_positive_ok = NULLED_OUT ; 
  sinfo.current_syncing = NULLED_OUT ; 
  sinfo.replace_chain = NULLED_OUT ; 

# 5122 "bc/src/thread.c"
  if (! delay )
    sleep_end = 0.0 ; 
  else {
#   define XfOrM744_COUNT (0+XfOrM735_COUNT)
#   define SETUP_XfOrM744(x) SETUP_XfOrM735(x)

# 5125 "bc/src/thread.c"
    sleep_end = (rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
    sleep_end += (delay * 1000.0 ) ; 
  }
  FUNCCALL(SETUP_XfOrM735(_), init_schedule_info (& sinfo , ((void * ) 0 ) , 1 , sleep_end ) )


  ; 

  while (! (result = FUNCCALL(SETUP_XfOrM735(_), f ((Scheme_Object * ) data , & sinfo ) )) ) {
    double now_sleep_end = sinfo . sleep_end ; 
#   define XfOrM740_COUNT (0+XfOrM735_COUNT)
#   define SETUP_XfOrM740(x) SETUP_XfOrM735(x)

# 5135 "bc/src/thread.c"
    if (sinfo . spin ) {
#     define XfOrM743_COUNT (0+XfOrM740_COUNT)
#     define SETUP_XfOrM743(x) SETUP_XfOrM740(x)
      FUNCCALL(SETUP_XfOrM743(_), init_schedule_info (& sinfo , ((void * ) 0 ) , 1 , 0.0 ) )
# 5136 "bc/src/thread.c"
      ; 
      FUNCCALL(SETUP_XfOrM743(_), scheme_thread_block (0.0 ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
    }

# 5139 "bc/src/thread.c"
    else {
#     define XfOrM741_COUNT (0+XfOrM740_COUNT)
#     define SETUP_XfOrM741(x) SETUP_XfOrM740(x)

# 5140 "bc/src/thread.c"
      if (now_sleep_end ) {
#       define XfOrM742_COUNT (0+XfOrM741_COUNT)
#       define SETUP_XfOrM742(x) SETUP_XfOrM741(x)

# 5141 "bc/src/thread.c"
        delay = (float ) (now_sleep_end - (rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ) ; 
        delay /= 1000.0 ; 
        if (delay <= 0 )
          delay = (float ) 0.00001 ; 
      }

# 5145 "bc/src/thread.c"
      else 
      delay = 0.0 ; 

      p -> block_descriptor = - 1 ; 
      p -> blocker = (Scheme_Object * ) data ; 
      p -> block_check = (Scheme_Ready_Fun ) f ; 
      p -> block_needs_wakeup = fdf ; 
      FUNCCALL(SETUP_XfOrM741(_), scheme_thread_block (delay ) )
      ; 

      p -> block_descriptor = 0 ; 
      p -> blocker = ((void * ) 0 ) ; 
      p -> block_check = ((void * ) 0 ) ; 
      p -> block_needs_wakeup = ((void * ) 0 ) ; 
    }
    sinfo . sleep_end = sleep_end ; 
  }
  p -> ran_some = 1 ; 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5167 "bc/src/thread.c"
int scheme_block_until_enable_break (Scheme_Ready_Fun _f , Scheme_Needs_Wakeup_Fun fdf , 
Scheme_Object * data , float delay , int enable_break ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(data, 0)));
# define XfOrM745_COUNT (1)
# define SETUP_XfOrM745(x) SETUP(XfOrM745_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5170 "bc/src/thread.c"
  if (enable_break ) {
    int v ; 
    Scheme_Cont_Frame_Data cframe ; 
    BLOCK_SETUP((PUSH(cframe.cache, 0+XfOrM745_COUNT)));
#   define XfOrM746_COUNT (1+XfOrM745_COUNT)
#   define SETUP_XfOrM746(x) SETUP(XfOrM746_COUNT)
    cframe.cache = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM746(_), scheme_push_break_enable (& cframe , 1 , 1 ) )
# 5174 "bc/src/thread.c"
    ; 
    v = FUNCCALL_AGAIN(scheme_block_until (_f , fdf , data , delay ) ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe , 0 ) ); 

    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

# 5179 "bc/src/thread.c"
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_block_until (_f , fdf , data , delay ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5183 "bc/src/thread.c"
static int ready_unless (Scheme_Object * o ) 
{
  /* No conversion */

# 5185 "bc/src/thread.c"
  Scheme_Object * data ; 
  Scheme_Ready_Fun f ; 

  data = (Scheme_Object * ) ((void * * ) o ) [0 ] ; 
  f = (Scheme_Ready_Fun ) ((void * * ) o ) [2 ] ; 

  return f (data ) ; 
}

static void needs_wakeup_unless (Scheme_Object * o , void * fds ) 
{
  /* No conversion */

# 5196 "bc/src/thread.c"
  Scheme_Object * data ; 
  Scheme_Needs_Wakeup_Fun fdf ; 

  data = (Scheme_Object * ) ((void * * ) o ) [0 ] ; 
  fdf = (Scheme_Needs_Wakeup_Fun ) ((void * * ) o ) [3 ] ; 

  fdf (data , fds ) ; 
}


int scheme_block_until_unless (Scheme_Ready_Fun f , Scheme_Needs_Wakeup_Fun fdf , 
Scheme_Object * data , float delay , 
Scheme_Object * unless , 
int enable_break ) 
{
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(unless, 0), PUSH(data, 1)));
# define XfOrM749_COUNT (2)
# define SETUP_XfOrM749(x) SETUP(XfOrM749_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5211 "bc/src/thread.c"
  if (unless ) {
    void * * a ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM749_COUNT)));
#   define XfOrM750_COUNT (1+XfOrM749_COUNT)
#   define SETUP_XfOrM750(x) SETUP(XfOrM750_COUNT)
    a = NULLED_OUT ; 

# 5213 "bc/src/thread.c"
    a = ((void * * ) FUNCCALL(SETUP_XfOrM750(_), GC_malloc (sizeof (void * ) * (4 ) ) )) ; 
    a [0 ] = data ; 
    a [1 ] = unless ; 
    a [2 ] = f ; 
    a [3 ] = fdf ; 

    data = (Scheme_Object * ) (void * ) a ; 
    f = ready_unless ; 
    if (fdf )
      fdf = needs_wakeup_unless ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_block_until_enable_break (f , fdf , data , delay , enable_break ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5228 "bc/src/thread.c"
void scheme_thread_block_enable_break (float sleep_time , int enable_break ) 
{
  PREPARE_VAR_STACK(1);
# define XfOrM751_COUNT (0)
# define SETUP_XfOrM751(x) SETUP(XfOrM751_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5230 "bc/src/thread.c"
  if (enable_break ) {
    Scheme_Cont_Frame_Data cframe ; 
    BLOCK_SETUP((PUSH(cframe.cache, 0+XfOrM751_COUNT)));
#   define XfOrM752_COUNT (1+XfOrM751_COUNT)
#   define SETUP_XfOrM752(x) SETUP(XfOrM752_COUNT)
    cframe.cache = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM752(_), scheme_push_break_enable (& cframe , 1 , 1 ) )
# 5233 "bc/src/thread.c"
    ; 
    FUNCCALL_AGAIN(scheme_thread_block (sleep_time ) ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe , 0 ) ); 
  }

# 5236 "bc/src/thread.c"
  else FUNCCALL_EMPTY(scheme_thread_block (sleep_time ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5240 "bc/src/thread.c"
int scheme_is_atomic (void ) 
{
  /* No conversion */

# 5242 "bc/src/thread.c"
  return ! ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) ; 
}

void scheme_start_atomic (void ) 
{
  /* No conversion */

# 5247 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) ++ ; 
}

void scheme_start_atomic_no_break (void ) 
{
  /* No conversion */

# 5252 "bc/src/thread.c"
  scheme_start_atomic () ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_breaks_disabled_ ) ++ ; 
}

void scheme_end_atomic_no_swap (void ) 
{
  /* No conversion */

# 5258 "bc/src/thread.c"
  int v = -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) ; 
  if (v < 0 ) {
    scheme_log_abort ("unbalanced end-atomic" ) ; 
    abort () ; 
  }
}

void scheme_start_in_scheduler (void ) 
{
  /* No conversion */

# 5267 "bc/src/thread.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) ++ ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ++ ; 
}

void scheme_end_in_scheduler (void ) 
{
  /* No conversion */

# 5273 "bc/src/thread.c"
  int v = -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) ; 
  -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ; 
  if (v < 0 ) {
    scheme_log_abort ("unbalanced end-atomic" ) ; 
    abort () ; 
  }
}

void scheme_end_atomic (void ) 
{
  /* No conversion */

# 5283 "bc/src/thread.c"
  scheme_end_atomic_no_swap () ; 
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> missed_context_switch_ ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> missed_context_switch_ ) = 0 ; 
    scheme_thread_block (0.0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
  }
}

void scheme_end_atomic_can_break (void ) 
{
  /* No conversion */

# 5293 "bc/src/thread.c"
  -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_breaks_disabled_ ) ; 
  scheme_end_atomic () ; 
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_breaks_disabled_ ) )
    scheme_check_break_now () ; 
}

int scheme_wait_until_suspend_ok (void ) 
{
  /* No conversion */

# 5301 "bc/src/thread.c"
  int did = 0 ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_ ) ) {

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_atomic_level_ ) ) {
      scheme_log_abort ("attempted to wait for suspend in nested atomic mode" ) ; 
      abort () ; 
    }
  }

  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_ ) ) {
    did = 1 ; 
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) ++ ; 
    call_on_atomic_timeout (1 ) ; 
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) > 1 )
      -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) ; 
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) ) {
    scheme_log_abort ("about to suspend in atomic mode" ) ; 
    abort () ; 
  }

  return did ; 
}

Scheme_On_Atomic_Timeout_Proc scheme_set_on_atomic_timeout (Scheme_On_Atomic_Timeout_Proc p , void * data ) 
{
  /* No conversion */

# 5330 "bc/src/thread.c"
  Scheme_On_Atomic_Timeout_Proc old ; 

  old = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_ ) = p ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> on_atomic_timeout_data_ ) = data ; 
  if (p ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) = 1 ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_atomic_level_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> do_atomic_ ) ; 
  }

# 5338 "bc/src/thread.c"
  else {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> atomic_timeout_auto_suspend_ ) = 0 ; 
  }

  return old ; 
}

static void call_timeout_callback (void * data , int must_give_up ) 
{
  Scheme_Object * a [1 ] ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0), PUSH(data, 3)));
# define XfOrM773_COUNT (4)
# define SETUP_XfOrM773(x) SETUP(XfOrM773_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 

# 5348 "bc/src/thread.c"
  a [0 ] = (must_give_up ? scheme_true : scheme_false ) ; 
  FUNCCALL(SETUP_XfOrM773(_), scheme_start_in_scheduler () )
  ; 
  FUNCCALL_AGAIN(scheme_do_eval ((Scheme_Object * ) data , 1 , a , - 1 ) ); 
  FUNCCALL_AGAIN(scheme_end_in_scheduler () ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5355 "bc/src/thread.c"
static Scheme_Object * unsafe_set_on_atomic_timeout (int argc , Scheme_Object * argv [] ) 
{
  Scheme_On_Atomic_Timeout_Proc r ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM774_COUNT (1)
# define SETUP_XfOrM774(x) SETUP(XfOrM774_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5359 "bc/src/thread.c"
  if (((argv [0 ] ) ) == (scheme_false ) ) 
    r = FUNCCALL(SETUP_XfOrM774(_), scheme_set_on_atomic_timeout (((void * ) 0 ) , ((void * ) 0 ) ) ); 
  else 
  r = FUNCCALL_EMPTY(scheme_set_on_atomic_timeout (call_timeout_callback , argv [0 ] ) ); 

  RET_VALUE_START ((r ? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5367 "bc/src/thread.c"
static Scheme_Object * unsafe_start_atomic (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5369 "bc/src/thread.c"
  scheme_start_atomic_no_break () ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_end_atomic (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5375 "bc/src/thread.c"
  scheme_end_atomic_can_break () ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_start_breakable_atomic (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5381 "bc/src/thread.c"
  scheme_start_atomic () ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_end_breakable_atomic (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5387 "bc/src/thread.c"
  scheme_end_atomic () ; 
  return scheme_void ; 
}

static Scheme_Object * unsafe_in_atomic_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5393 "bc/src/thread.c"
  return (scheme_is_atomic () ? scheme_true : scheme_false ) ; 
}


void scheme_weak_suspend_thread (Scheme_Thread * r ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(r, 0)));
# define XfOrM780_COUNT (1)
# define SETUP_XfOrM780(x) SETUP(XfOrM780_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5399 "bc/src/thread.c"
  if (r -> running & 0x2 )
    RET_NOTHING ; 

  if (r -> prev ) {
    r -> prev -> next = r -> next ; 
    r -> next -> prev = r -> prev ; 
  }

# 5405 "bc/src/thread.c"
  else {
    r -> next -> prev = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) = r -> next ; 
  }

  r -> next = r -> prev = ((void * ) 0 ) ; 
  (unschedule_in_set ((Scheme_Object * ) r , r -> t_set_parent ) ) ; 

  r -> running |= 0x2 ; 
  FUNCCALL(SETUP_XfOrM780(_), scheme_prepare_this_thread_for_GC (r ) )
  ; 

  if (r == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
#   define XfOrM781_COUNT (0+XfOrM780_COUNT)
#   define SETUP_XfOrM781(x) SETUP_XfOrM780(x)
    FUNCCALL(SETUP_XfOrM781(_), select_thread () )
# 5418 "bc/src/thread.c"
    ; 


    if ((r -> running & 0x4 ) && ! (r -> running & 0x8 ) )
      FUNCCALL_EMPTY(scheme_thread_block (0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5426 "bc/src/thread.c"
void scheme_weak_resume_thread (Scheme_Thread * r ) 


{
  /* No conversion */

# 5430 "bc/src/thread.c"
  if (! (r -> running & 0x10 ) ) {
    if (r -> running & 0x2 ) {
      r -> running -= 0x2 ; 
      r -> next = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) ; 
      r -> prev = ((void * ) 0 ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) = r ; 
      r -> next -> prev = r ; 
      r -> ran_some = 1 ; 
      schedule_in_set ((Scheme_Object * ) r , r -> t_set_parent ) ; 
      check_tail_buffer_size (r ) ; 
    }
  }
}

void scheme_about_to_move_C_stack (void ) 
{
  /* No conversion */
}
static Scheme_Object * 
sch_sleep (int argc , Scheme_Object * args [] ) 
{
  float t ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(args, 0)));
# define XfOrM788_COUNT (1)
# define SETUP_XfOrM788(x) SETUP(XfOrM788_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5453 "bc/src/thread.c"
  if (argc && ! ((((intptr_t ) (args [0 ] ) ) & 0x1 ) || ((((args [0 ] ) -> type ) >= scheme_bignum_type ) && (((args [0 ] ) -> type ) < scheme_complex_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("sleep" , "(>=/c 0.0)" , 0 , argc , args ) ); 

  if (argc ) {
#   define XfOrM789_COUNT (0+XfOrM788_COUNT)
#   define SETUP_XfOrM789(x) SETUP_XfOrM788(x)

# 5457 "bc/src/thread.c"
    t = (float ) FUNCCALL(SETUP_XfOrM789(_), scheme_real_to_double (args [0 ] ) ); 
    if (t < 0 )
      FUNCCALL_EMPTY(scheme_wrong_contract ("sleep" , "(>=/c 0.0)" , 0 , argc , args ) ); 
  }

# 5460 "bc/src/thread.c"
  else 
  t = 0 ; 
  FUNCCALL_EMPTY(scheme_thread_block (t ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5469 "bc/src/thread.c"
Scheme_Object * unsafe_poll_fd (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5471 "bc/src/thread.c"
  intptr_t sfd = 0 ; 
  rktio_fd_t * rfd = ((void * ) 0 ) ; 
  int mode = 0 ; 
  int ready = 0 ; 
  int is_socket = 1 ; 

  if (! scheme_get_int_val (argv [0 ] , & sfd ) )
    scheme_wrong_contract ("unsafe-poll-fd" , "handle-integer?" , 0 , argc , argv ) ; 

  if ((argv [1 ] ) == (read_symbol ) ) 
    mode = (1 << 0 ) ; 
  else if ((argv [1 ] ) == (write_symbol ) ) 
    mode = (1 << 1 ) ; 
  else 
  scheme_wrong_contract ("unsafe-poll-fd" , "(or/c 'read 'write)" , 1 , argc , argv ) ; 

  if (argc > 2 ) {
    is_socket = (! (((argv [2 ] ) ) == (scheme_false ) ) ) ; 
  }

  rfd = rktio_system_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , sfd , (is_socket ? (1 << 7 ) : 0 ) ) ; 

  if (mode == (1 << 0 ) )
    ready = rktio_poll_read_ready (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , rfd ) ; 
  else if (mode == (1 << 1 ) )
    ready = rktio_poll_write_ready (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , rfd ) ; 

  rktio_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , rfd ) ; 
  return (ready == 1 ) ? scheme_true : scheme_false ; 
}

Scheme_Object * unsafe_poll_ctx_fd_wakeup (int argc , Scheme_Object * * argv ) 
{
  void * __funcarg185 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM792_COUNT (0)
# define SETUP_XfOrM792(x) SETUP(XfOrM792_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5504 "bc/src/thread.c"
  if (! (((argv [0 ] ) ) == (scheme_false ) ) )  {
    void * fds = (((Scheme_Cptr * ) (argv [0 ] ) ) -> val ) ; 
    intptr_t fd ; 
    int m ; 
#   define XfOrM793_COUNT (0+XfOrM792_COUNT)
#   define SETUP_XfOrM793(x) SETUP_XfOrM792(x)

# 5509 "bc/src/thread.c"
    if (((intptr_t ) (argv [1 ] ) ) & 0x1 ) 
      fd = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
    else 
    fd = (rktio_fd_system_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , (rktio_fd_t * ) (((Scheme_Cptr * ) (argv [1 ] ) ) -> val ) ) ) ; 

    if ((argv [2 ] ) == (read_symbol ) ) 
      m = 0 ; 
    else if ((argv [2 ] ) == (write_symbol ) ) 
      m = 1 ; 
    else 
    m = 2 ; 
    (__funcarg185 = FUNCCALL_EMPTY(scheme_get_fdset (fds , m ) )
    , FUNCCALL_EMPTY(scheme_fdset (__funcarg185 , fd ) )) ; 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5527 "bc/src/thread.c"
Scheme_Object * unsafe_poll_ctx_eventmask_wakeup (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5529 "bc/src/thread.c"
  if (! (((argv [0 ] ) ) == (scheme_false ) ) )  {
    void * fds = (((Scheme_Cptr * ) (argv [0 ] ) ) -> val ) ; 
    intptr_t mask = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 

    scheme_add_fd_eventmask (fds , mask ) ; 
  }

  return scheme_void ; 
}

Scheme_Object * unsafe_poll_ctx_time_wakeup (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5541 "bc/src/thread.c"
  if (! (((argv [0 ] ) ) == (scheme_false ) ) )  {
    void * fds = (((Scheme_Cptr * ) (argv [0 ] ) ) -> val ) ; 
    double msecs = (((Scheme_Double * ) (argv [1 ] ) ) -> double_val ) ; 

    scheme_set_wakeup_time (fds , msecs ) ; 
  }

  return scheme_void ; 
}

Scheme_Object * unsafe_signal_received (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5553 "bc/src/thread.c"
  scheme_signal_received () ; 
  return scheme_void ; 
}

static Scheme_Object * do_signal_received (int argc , Scheme_Object * * argv , Scheme_Object * self ) 
{
  /* No conversion */

# 5559 "bc/src/thread.c"
  void * h = ((Scheme_Primitive_Closure * ) self ) -> val [0 ] ; 
  scheme_signal_received_at (h ) ; 
  return scheme_void ; 
}

Scheme_Object * unsafe_make_signal_received (int argc , Scheme_Object * * argv ) 
{
  void * h ; 
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(h, 0), PUSHARRAY(a, 1, 1)));
# define XfOrM800_COUNT (4)
# define SETUP_XfOrM800(x) SETUP(XfOrM800_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  h = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 5569 "bc/src/thread.c"
  h = FUNCCALL(SETUP_XfOrM800(_), scheme_get_signal_handle () ); 
  a [0 ] = (Scheme_Object * ) h ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM800(_), scheme_make_prim_closure_w_arity (do_signal_received , 1 , a , "unsafe-signal-received" , 0 , 0 ) )) RET_VALUE_END 
  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5575 "bc/src/thread.c"
static void sleep_via_thread (float seconds , void * fds ) 
{
  /* No conversion */
}







Scheme_Object * unsafe_set_sleep_in_thread (int argc , Scheme_Object * * argv ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM802_COUNT (1)
# define SETUP_XfOrM802(x) SETUP(XfOrM802_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5588 "bc/src/thread.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_sleep_callback_ ) )
    FUNCCALL(SETUP_XfOrM802(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_sleep_callback_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_sleep_callback_ ) ) ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_sleep_callback_ ) = argv [0 ] ; 
  if (((intptr_t ) (argv [1 ] ) ) & 0x1 ) 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_sleep_callback_fd_ ) = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  else 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_sleep_callback_fd_ ) = (rktio_fd_system_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , (rktio_fd_t * ) (((Scheme_Cptr * ) (argv [1 ] ) ) -> val ) ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_sleep_ ) = sleep_via_thread ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5602 "bc/src/thread.c"
static Scheme_Object * break_thread (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 5604 "bc/src/thread.c"
  Scheme_Thread * p ; 
  int kind = MZEXN_BREAK ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    scheme_wrong_contract ("break-thread" , "thread?" , 0 , argc , args ) ; 

  if ((argc > 1 ) && (! (((args [1 ] ) ) == (scheme_false ) ) ) ) {
    if (((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    && ! ((& ((Scheme_Symbol * ) (args [1 ] ) ) -> iso ) -> so . keyex & 0x3 ) 
    && ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (args [1 ] ) ) ) -> s ) , "hang-up" ) )
      kind = MZEXN_BREAK_HANG_UP ; 
    else if (((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    && ! ((& ((Scheme_Symbol * ) (args [1 ] ) ) -> iso ) -> so . keyex & 0x3 ) 
    && ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (args [1 ] ) ) ) -> s ) , "terminate" ) )
      kind = MZEXN_BREAK_TERMINATE ; 
    else 
    scheme_wrong_contract ("break-thread" , "(or/c #f 'hang-up 'terminate)" , 1 , argc , args ) ; 
  }

  p = (Scheme_Thread * ) args [0 ] ; 

  scheme_break_kind_thread (p , kind ) ; 

  scheme_check_break_now () ; 

  return scheme_void ; 
}

static int do_kill_thread (Scheme_Thread * p ) 
{
  int kill_self = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM805_COUNT (1)
# define SETUP_XfOrM805(x) SETUP(XfOrM805_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5636 "bc/src/thread.c"
  if (! ((p -> running ) && ! ((p -> running ) & 0x4 ) ) ) {
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  if (p -> suspend_to_kill ) {
#   define XfOrM818_COUNT (0+XfOrM805_COUNT)
#   define SETUP_XfOrM818(x) SETUP_XfOrM805(x)

# 5641 "bc/src/thread.c"
    if (p == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) )
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    FUNCCALL(SETUP_XfOrM818(_), suspend_thread (p ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  if (p -> nestee )
    FUNCCALL(SETUP_XfOrM805(_), scheme_break_thread (p -> nestee ) ); 

  while (p -> private_on_kill ) {
#   define XfOrM815_COUNT (0+XfOrM805_COUNT)
#   define SETUP_XfOrM815(x) SETUP_XfOrM805(x)
    FUNCCALL(SETUP_XfOrM815(_), p -> private_on_kill (p -> private_kill_data ) )
# 5651 "bc/src/thread.c"
    ; 
    if (p -> private_kill_next ) {
      p -> private_on_kill = (Scheme_Kill_Action_Func ) p -> private_kill_next [0 ] ; 
      p -> private_kill_data = p -> private_kill_next [1 ] ; 
      p -> private_kill_next = (void * * ) p -> private_kill_next [2 ] ; 
    }

# 5656 "bc/src/thread.c"
    else {
      p -> private_on_kill = ((void * ) 0 ) ; 
      p -> private_kill_data = ((void * ) 0 ) ; 
    }
  }

  if (p -> on_kill )
    FUNCCALL(SETUP_XfOrM805(_), p -> on_kill (p ) ); 
  FUNCCALL(SETUP_XfOrM805(_), scheme_remove_managed (p -> mref , (Scheme_Object * ) p -> mr_hop ) )
  ; 
  {
    Scheme_Object * l ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM805_COUNT)));
#   define XfOrM809_COUNT (1+XfOrM805_COUNT)
#   define SETUP_XfOrM809(x) SETUP(XfOrM809_COUNT)
    l = NULLED_OUT ; 

# 5668 "bc/src/thread.c"
    for (l = p -> extra_mrefs ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM811_COUNT (0+XfOrM809_COUNT)
#     define SETUP_XfOrM811(x) SETUP_XfOrM809(x)
      FUNCCALL(SETUP_XfOrM811(_), scheme_remove_managed ((Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , (Scheme_Object * ) p -> mr_hop ) )
# 5670 "bc/src/thread.c"
      ; 
    }
  }

  if (p -> running ) {
#   define XfOrM806_COUNT (0+XfOrM805_COUNT)
#   define SETUP_XfOrM806(x) SETUP_XfOrM805(x)

# 5675 "bc/src/thread.c"
    if (p -> running & 0x10 ) {

      p -> running -= 0x10 ; 
    }

    p -> running |= 0x4 ; 
    if ((p -> running & 0x8 ) 
    || p -> nester )
      FUNCCALL(SETUP_XfOrM806(_), scheme_weak_resume_thread (p ) ); 
    else if (p != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
#     define XfOrM807_COUNT (0+XfOrM806_COUNT)
#     define SETUP_XfOrM807(x) SETUP_XfOrM806(x)

# 5686 "bc/src/thread.c"
      if (p -> next )
        FUNCCALL(SETUP_XfOrM807(_), remove_thread (p ) ); 
    }
  }
  if (p == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) )
    kill_self = 1 ; 

  RET_VALUE_START (kill_self ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5696 "bc/src/thread.c"
void scheme_kill_thread (Scheme_Thread * p ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM820_COUNT (1)
# define SETUP_XfOrM820(x) SETUP(XfOrM820_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5698 "bc/src/thread.c"
  if (FUNCCALL(SETUP_XfOrM820(_), do_kill_thread (p ) )) {
#   define XfOrM821_COUNT (0+XfOrM820_COUNT)
#   define SETUP_XfOrM821(x) SETUP_XfOrM820(x)
    FUNCCALL(SETUP_XfOrM821(_), scheme_wait_until_suspend_ok () )
# 5700 "bc/src/thread.c"
    ; 
    if (p -> suspend_to_kill )
      FUNCCALL_EMPTY(suspend_thread (p ) ); 
    else FUNCCALL_EMPTY(scheme_thread_block (0.0 ) )
    ; 
  }
  FUNCCALL_EMPTY(scheme_thread_block (0.0 ) )

  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ran_some = 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5712 "bc/src/thread.c"
static Scheme_Object * kill_thread (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p = (Scheme_Thread * ) argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM822_COUNT (1)
# define SETUP_XfOrM822(x) SETUP(XfOrM822_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5716 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("kill-thread" , "thread?" , 0 , argc , argv ) ); 

  if (! ((p -> running ) && ! ((p -> running ) & 0x4 ) ) )
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  FUNCCALL(SETUP_XfOrM822(_), check_current_custodian_allows ("kill-thread" , p ) )
  ; 
  FUNCCALL_EMPTY(scheme_kill_thread (p ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5729 "bc/src/thread.c"
void scheme_push_kill_action (Scheme_Kill_Action_Func f , void * d ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(d, 1)));
# define XfOrM823_COUNT (2)
# define SETUP_XfOrM823(x) SETUP(XfOrM823_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5733 "bc/src/thread.c"
  if (p -> private_on_kill ) {



    void * * next ; 
    BLOCK_SETUP((PUSH(next, 0+XfOrM823_COUNT)));
#   define XfOrM824_COUNT (1+XfOrM823_COUNT)
#   define SETUP_XfOrM824(x) SETUP(XfOrM824_COUNT)
    next = NULLED_OUT ; 

# 5738 "bc/src/thread.c"
    next = ((void * * ) FUNCCALL(SETUP_XfOrM824(_), GC_malloc (sizeof (void * ) * (3 ) ) )) ; 
    next [0 ] = (void * ) p -> private_on_kill ; 
    next [1 ] = p -> private_kill_data ; 
    next [2 ] = (void * ) p -> private_kill_next ; 
    p -> private_kill_next = next ; 
  }

  p -> private_on_kill = f ; 
  p -> private_kill_data = d ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5749 "bc/src/thread.c"
void scheme_pop_kill_action () 
{
  /* No conversion */

# 5751 "bc/src/thread.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (p -> private_kill_next ) {
    p -> private_on_kill = (Scheme_Kill_Action_Func ) p -> private_kill_next [0 ] ; 
    p -> private_kill_data = p -> private_kill_next [1 ] ; 
    p -> private_kill_next = (void * * ) p -> private_kill_next [2 ] ; 
  }

# 5757 "bc/src/thread.c"
  else {
    p -> private_on_kill = ((void * ) 0 ) ; 
    p -> private_kill_data = ((void * ) 0 ) ; 
  }
}






static void transitive_resume (Scheme_Object * resumes ) ; 
static void transitive_promote (Scheme_Thread * p , Scheme_Custodian * c ) ; 
static void promote_thread (Scheme_Thread * p , Scheme_Custodian * to_c ) ; 

static Scheme_Object * thread_suspend (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM828_COUNT (1)
# define SETUP_XfOrM828(x) SETUP(XfOrM828_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 5776 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("thread-suspend" , "thread?" , 0 , argc , argv ) ); 

  p = (Scheme_Thread * ) argv [0 ] ; 
  FUNCCALL(SETUP_XfOrM828(_), check_current_custodian_allows ("thread-suspend" , p ) )
  ; 
  FUNCCALL_EMPTY(suspend_thread (p ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5788 "bc/src/thread.c"
static void suspend_thread (Scheme_Thread * p ) 
{
  int running ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM829_COUNT (1)
# define SETUP_XfOrM829(x) SETUP(XfOrM829_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5792 "bc/src/thread.c"
  if (! ((p -> running ) && ! ((p -> running ) & 0x4 ) ) )
    RET_NOTHING ; 

  if (p -> running & 0x10 )
    RET_NOTHING ; 




  running = p -> running ; 

  p -> resumed_box = ((void * ) 0 ) ; 
  if (p -> suspended_box ) {
#   define XfOrM837_COUNT (0+XfOrM829_COUNT)
#   define SETUP_XfOrM837(x) SETUP_XfOrM829(x)

# 5805 "bc/src/thread.c"
    (((Scheme_Simple_Object * ) (p -> suspended_box ) ) -> u . two_ptr_val . ptr2 ) = (Scheme_Object * ) p ; 
    FUNCCALL(SETUP_XfOrM837(_), scheme_post_sema_all ((((Scheme_Simple_Object * ) (p -> suspended_box ) ) -> u . two_ptr_val . ptr1 ) ) ); 
  }
  if (p -> running_box && (! (p -> running & 0x2 ) ) ) {

    (((Scheme_Small_Object * ) (p -> running_box ) ) -> u . ptr_val ) = (Scheme_Object * ) p ; 
  }

  if ((p ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ) )  {
#   define XfOrM834_COUNT (0+XfOrM829_COUNT)
#   define SETUP_XfOrM834(x) SETUP_XfOrM829(x)
    p -> running |= 0x10 ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_was_once_suspended_ ) = 1 ; 
    if (p == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
#     define XfOrM835_COUNT (0+XfOrM834_COUNT)
#     define SETUP_XfOrM835(x) SETUP_XfOrM834(x)
      FUNCCALL(SETUP_XfOrM835(_), scheme_thread_block (0.0 ) )
# 5819 "bc/src/thread.c"
      ; 
      p -> ran_some = 1 ; 
    }
  }

# 5822 "bc/src/thread.c"
  else if ((running & (0x8 
  | 0x20 ) ) 
  && (running & 0x2 ) ) {
#   define XfOrM833_COUNT (0+XfOrM829_COUNT)
#   define SETUP_XfOrM833(x) SETUP_XfOrM829(x)
    FUNCCALL(SETUP_XfOrM833(_), scheme_weak_resume_thread (p ) )
# 5826 "bc/src/thread.c"
    ; 
    p -> running |= 0x10 ; 
  }

# 5828 "bc/src/thread.c"
  else {
#   define XfOrM830_COUNT (0+XfOrM829_COUNT)
#   define SETUP_XfOrM830(x) SETUP_XfOrM829(x)

# 5829 "bc/src/thread.c"
    if (p == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
#     define XfOrM832_COUNT (0+XfOrM830_COUNT)
#     define SETUP_XfOrM832(x) SETUP_XfOrM830(x)
      FUNCCALL(SETUP_XfOrM832(_), scheme_wait_until_suspend_ok () )
# 5830 "bc/src/thread.c"
      ; 
    }
    p -> running |= 0x10 ; 
    FUNCCALL(SETUP_XfOrM830(_), scheme_weak_suspend_thread (p ) ); 
    if (p == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
#     define XfOrM831_COUNT (0+XfOrM830_COUNT)
#     define SETUP_XfOrM831(x) SETUP_XfOrM830(x)
      FUNCCALL_EMPTY(scheme_check_break_now () )
# 5836 "bc/src/thread.c"
      ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5841 "bc/src/thread.c"
static void add_transitive_resume (Scheme_Thread * promote_to , Scheme_Thread * p ) 
{
  Scheme_Object * running_box ; 
  Scheme_Hash_Table * ht ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(ht, 1), PUSH(running_box, 2), PUSH(promote_to, 3)));
# define XfOrM838_COUNT (4)
# define SETUP_XfOrM838(x) SETUP(XfOrM838_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  running_box = NULLED_OUT ; 
  ht = NULLED_OUT ; 

# 5846 "bc/src/thread.c"
  if (! p -> running_box ) {
    Scheme_Object * b , * wb ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM838_COUNT), PUSH(wb, 1+XfOrM838_COUNT)));
#   define XfOrM852_COUNT (2+XfOrM838_COUNT)
#   define SETUP_XfOrM852(x) SETUP(XfOrM852_COUNT)
    b = NULLED_OUT ; 
    wb = NULLED_OUT ; 

# 5848 "bc/src/thread.c"
    if ((p -> running & 0x10 ) 
    && ! (p -> running & 0x2 ) )
      wb = (Scheme_Object * ) p ; 
    else 
    wb = FUNCCALL(SETUP_XfOrM852(_), scheme_make_weak_box ((Scheme_Object * ) p ) ); 
    b = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM852(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    b -> type = scheme_thread_dead_type ; 
    (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) = (Scheme_Object * ) wb ; 
    p -> running_box = b ; 
  }
  running_box = p -> running_box ; 

  if (! promote_to -> transitive_resumes ) {
#   define XfOrM851_COUNT (0+XfOrM838_COUNT)
#   define SETUP_XfOrM851(x) SETUP_XfOrM838(x)

# 5862 "bc/src/thread.c"
    ht = FUNCCALL(SETUP_XfOrM851(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    promote_to -> transitive_resumes = (Scheme_Object * ) ht ; 
  }

# 5864 "bc/src/thread.c"
  else {

    Scheme_Hash_Table * gone = ((void * ) 0 ) ; 
    Scheme_Object * b ; 
    int i ; 
    BLOCK_SETUP((PUSH(gone, 0+XfOrM838_COUNT), PUSH(b, 1+XfOrM838_COUNT)));
#   define XfOrM839_COUNT (2+XfOrM838_COUNT)
#   define SETUP_XfOrM839(x) SETUP(XfOrM839_COUNT)
    b = NULLED_OUT ; 

# 5870 "bc/src/thread.c"
    ht = (Scheme_Hash_Table * ) promote_to -> transitive_resumes ; 
    for (i = ht -> size ; i -- ; ) {
#     define XfOrM848_COUNT (0+XfOrM839_COUNT)
#     define SETUP_XfOrM848(x) SETUP_XfOrM839(x)

# 5872 "bc/src/thread.c"
      if (ht -> vals [i ] ) {
#       define XfOrM849_COUNT (0+XfOrM848_COUNT)
#       define SETUP_XfOrM849(x) SETUP_XfOrM848(x)

# 5873 "bc/src/thread.c"
        b = (((Scheme_Small_Object * ) (ht -> keys [i ] ) ) -> u . ptr_val ) ; 
        if (! b 
        || (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_weak_box_type ) ) 
        && ! (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) ) ) {
#         define XfOrM850_COUNT (0+XfOrM849_COUNT)
#         define SETUP_XfOrM850(x) SETUP_XfOrM849(x)

# 5878 "bc/src/thread.c"
          if (! gone )
            gone = FUNCCALL(SETUP_XfOrM850(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
          FUNCCALL(SETUP_XfOrM850(_), scheme_hash_set (gone , ht -> keys [i ] , scheme_true ) ); 
        }
      }
    }

    if (gone ) {
#     define XfOrM840_COUNT (0+XfOrM839_COUNT)
#     define SETUP_XfOrM840(x) SETUP_XfOrM839(x)

# 5887 "bc/src/thread.c"
      for (i = gone -> size ; i -- ; ) {
#       define XfOrM843_COUNT (0+XfOrM840_COUNT)
#       define SETUP_XfOrM843(x) SETUP_XfOrM840(x)

# 5888 "bc/src/thread.c"
        if (gone -> vals [i ] ) {
#         define XfOrM844_COUNT (0+XfOrM843_COUNT)
#         define SETUP_XfOrM844(x) SETUP_XfOrM843(x)
          FUNCCALL(SETUP_XfOrM844(_), scheme_hash_set (ht , gone -> keys [i ] , ((void * ) 0 ) ) )
# 5889 "bc/src/thread.c"
          ; 
        }
      }
    }
  }
  FUNCCALL_EMPTY(scheme_hash_set (ht , running_box , scheme_true ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5898 "bc/src/thread.c"
static Scheme_Object * transitive_resume_k (void ) 
{
  /* No conversion */

# 5900 "bc/src/thread.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * r = (Scheme_Object * ) p -> ku . k . p1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  transitive_resume (r ) ; 

  return scheme_true ; 
}

static void transitive_resume (Scheme_Object * resumes ) 
{
  Scheme_Hash_Table * ht ; 
  Scheme_Object * a [1 ] ; 
  int i ; 

# 24 "bc/src/mzstkchk.h"
  uintptr_t _stk_pos ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0), PUSH(ht, 3), PUSH(resumes, 4)));
# define XfOrM854_COUNT (5)
# define SETUP_XfOrM854(x) SETUP(XfOrM854_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ht = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 26 "bc/src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 5918 "bc/src/thread.c"
  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM854_COUNT)));
#   define XfOrM861_COUNT (1+XfOrM854_COUNT)
#   define SETUP_XfOrM861(x) SETUP(XfOrM861_COUNT)

# 5921 "bc/src/thread.c"
    p -> ku . k . p1 = resumes ; 

    p -> suspend_break ++ ; 
    FUNCCALL(SETUP_XfOrM861(_), scheme_start_atomic () ); 
    FUNCCALL_AGAIN(scheme_handle_stack_overflow (transitive_resume_k ) ); 
    FUNCCALL_AGAIN(scheme_end_atomic_no_swap () ); 
    -- p -> suspend_break ; 

    RET_NOTHING ; 
  }


  ht = (Scheme_Hash_Table * ) resumes ; 

  for (i = ht -> size ; i -- ; ) {
#   define XfOrM858_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM858(x) SETUP_XfOrM854(x)

# 5936 "bc/src/thread.c"
    if (ht -> vals [i ] ) {
#     define XfOrM859_COUNT (0+XfOrM858_COUNT)
#     define SETUP_XfOrM859(x) SETUP_XfOrM858(x)

# 5937 "bc/src/thread.c"
      a [0 ] = (((Scheme_Small_Object * ) (ht -> keys [i ] ) ) -> u . ptr_val ) ; 
      if (a [0 ] ) {
#       define XfOrM860_COUNT (0+XfOrM859_COUNT)
#       define SETUP_XfOrM860(x) SETUP_XfOrM859(x)

# 5939 "bc/src/thread.c"
        if ((Scheme_Type ) (((((intptr_t ) (a [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_weak_box_type ) ) 
          a [0 ] = (((Scheme_Small_Object * ) (a [0 ] ) ) -> u . ptr_val ) ; 
        if (a [0 ] )
          FUNCCALL(SETUP_XfOrM860(_), thread_resume (1 , a ) ); 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5948 "bc/src/thread.c"
static Scheme_Object * transitive_promote_k (void ) 
{
  /* No conversion */

# 5950 "bc/src/thread.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Thread * pp = (Scheme_Thread * ) p -> ku . k . p1 ; 
  Scheme_Custodian * c = (Scheme_Custodian * ) p -> ku . k . p2 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 

  transitive_promote (pp , c ) ; 

  return scheme_true ; 
}

static void transitive_promote (Scheme_Thread * p , Scheme_Custodian * c ) 
{
  Scheme_Hash_Table * ht ; 
  Scheme_Object * t ; 
  int i ; 

# 24 "bc/src/mzstkchk.h"
  uintptr_t _stk_pos ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(c, 1), PUSH(ht, 2), PUSH(t, 3)));
# define XfOrM863_COUNT (4)
# define SETUP_XfOrM863(x) SETUP(XfOrM863_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ht = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 26 "bc/src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 5970 "bc/src/thread.c"
  {
    Scheme_Thread * pp = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(pp, 0+XfOrM863_COUNT)));
#   define XfOrM868_COUNT (1+XfOrM863_COUNT)
#   define SETUP_XfOrM868(x) SETUP(XfOrM868_COUNT)

# 5973 "bc/src/thread.c"
    pp -> ku . k . p1 = p ; 
    pp -> ku . k . p2 = c ; 

    pp -> suspend_break ++ ; 
    FUNCCALL(SETUP_XfOrM868(_), scheme_start_atomic () ); 
    FUNCCALL_AGAIN(scheme_handle_stack_overflow (transitive_promote_k ) ); 
    FUNCCALL_AGAIN(scheme_end_atomic_no_swap () ); 
    -- pp -> suspend_break ; 

    RET_NOTHING ; 
  }


  if (! p -> transitive_resumes )
    RET_NOTHING ; 

  ht = (Scheme_Hash_Table * ) p -> transitive_resumes ; 

  for (i = ht -> size ; i -- ; ) {
#   define XfOrM866_COUNT (0+XfOrM863_COUNT)
#   define SETUP_XfOrM866(x) SETUP_XfOrM863(x)

# 5992 "bc/src/thread.c"
    if (ht -> vals [i ] ) {
#     define XfOrM867_COUNT (0+XfOrM866_COUNT)
#     define SETUP_XfOrM867(x) SETUP_XfOrM866(x)

# 5993 "bc/src/thread.c"
      t = (((Scheme_Small_Object * ) (ht -> keys [i ] ) ) -> u . ptr_val ) ; 
      if ((Scheme_Type ) (((((intptr_t ) (t ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (t ) ) -> type ) ) == (Scheme_Type ) (scheme_weak_box_type ) ) 
        t = (((Scheme_Small_Object * ) (t ) ) -> u . ptr_val ) ; 
      if (t )
        FUNCCALL(SETUP_XfOrM867(_), promote_thread ((Scheme_Thread * ) t , c ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6002 "bc/src/thread.c"
static void promote_thread (Scheme_Thread * p , Scheme_Custodian * to_c ) 
{
  Scheme_Custodian * c , * cx ; 
  Scheme_Custodian_Reference * mref ; 
  Scheme_Object * l ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(c, 1), PUSH(to_c, 2), PUSH(l, 3), PUSH(mref, 4), PUSH(cx, 5)));
# define XfOrM869_COUNT (6)
# define SETUP_XfOrM869(x) SETUP(XfOrM869_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  c = NULLED_OUT ; 
  cx = NULLED_OUT ; 
  mref = NULLED_OUT ; 
  l = NULLED_OUT ; 

# 6012 "bc/src/thread.c"
  if (! p -> mref || ! ((Scheme_Custodian_Weak_Box * ) p -> mref ) -> val ) {
  }

  else {
#   define XfOrM870_COUNT (0+XfOrM869_COUNT)
#   define SETUP_XfOrM870(x) SETUP_XfOrM869(x)

# 6016 "bc/src/thread.c"
    c = ((Scheme_Custodian_Weak_Box * ) p -> mref ) -> val ; 


    for (cx = to_c ; cx && ((cx ) != (c ) ) ; ) {
      cx = ((Scheme_Custodian_Weak_Box * ) cx -> parent ) -> val ; 
    }
    if (cx )

# 6022 "bc/src/thread.c"
    RET_NOTHING ; 



    for (l = p -> extra_mrefs ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
      mref = (Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      c = ((Scheme_Custodian_Weak_Box * ) mref ) -> val ; 

      for (cx = to_c ; cx && ((cx ) != (c ) ) ; ) {
        cx = ((Scheme_Custodian_Weak_Box * ) cx -> parent ) -> val ; 
      }
      if (cx )

# 6033 "bc/src/thread.c"
      RET_NOTHING ; 
    }


    for (cx = c ; cx && ((cx ) != (to_c ) ) ; ) {
      cx = ((Scheme_Custodian_Weak_Box * ) cx -> parent ) -> val ; 
    }




    if (! cx ) {
#     define XfOrM871_COUNT (0+XfOrM870_COUNT)
#     define SETUP_XfOrM871(x) SETUP_XfOrM870(x)

# 6046 "bc/src/thread.c"
      for (l = p -> extra_mrefs ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#       define XfOrM883_COUNT (0+XfOrM871_COUNT)
#       define SETUP_XfOrM883(x) SETUP_XfOrM871(x)

# 6048 "bc/src/thread.c"
        for (cx = c ; cx && ((cx ) != (to_c ) ) ; ) {
          cx = ((Scheme_Custodian_Weak_Box * ) cx -> parent ) -> val ; 
        }
        if (cx ) {
#         define XfOrM884_COUNT (0+XfOrM883_COUNT)
#         define SETUP_XfOrM884(x) SETUP_XfOrM883(x)

# 6053 "bc/src/thread.c"
          mref = (Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          FUNCCALL(SETUP_XfOrM884(_), scheme_remove_managed (mref , (Scheme_Object * ) p -> mr_hop ) ); 
          mref = FUNCCALL_AGAIN(scheme_add_managed (to_c , (Scheme_Object * ) p -> mr_hop , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
          (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) = (Scheme_Object * ) mref ; 



          {
            Scheme_Object * prev ; 
            prev = NULLED_OUT ; 

# 6062 "bc/src/thread.c"
            prev = l ; 
            for (l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
              mref = (Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
              c = ((Scheme_Custodian_Weak_Box * ) mref ) -> val ; 
              for (cx = c ; cx && ((cx ) != (to_c ) ) ; ) {
                cx = ((Scheme_Custodian_Weak_Box * ) cx -> parent ) -> val ; 
              }
              if (cx )
                (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
            }
          }
          FUNCCALL(SETUP_XfOrM884(_), transitive_promote (p , to_c ) )
          ; 

          RET_NOTHING ; 
        }
      }



      mref = FUNCCALL(SETUP_XfOrM871(_), scheme_add_managed (to_c , (Scheme_Object * ) p -> mr_hop , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
      l = FUNCCALL(SETUP_XfOrM871(_), scheme_make_raw_pair ((Scheme_Object * ) mref , p -> extra_mrefs ) ); 
      p -> extra_mrefs = l ; 
      FUNCCALL(SETUP_XfOrM871(_), transitive_promote (p , to_c ) )
      ; 
      RET_NOTHING ; 
    }
  }
  FUNCCALL(SETUP_XfOrM869(_), scheme_remove_managed (p -> mref , (Scheme_Object * ) p -> mr_hop ) )

  ; 
  mref = FUNCCALL(SETUP_XfOrM869(_), scheme_add_managed (to_c , (Scheme_Object * ) p -> mr_hop , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
  p -> mref = mref ; 
  FUNCCALL(SETUP_XfOrM869(_), GC_register_thread (p , to_c ) )
  ; 
  FUNCCALL_EMPTY(transitive_promote (p , to_c ) )

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6102 "bc/src/thread.c"
static Scheme_Object * thread_resume (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p , * promote_to = ((void * ) 0 ) ; 
  Scheme_Custodian * promote_c = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(promote_to, 1), PUSH(promote_c, 2)));
# define XfOrM905_COUNT (3)
# define SETUP_XfOrM905(x) SETUP(XfOrM905_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 

# 6107 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("thread-resume" , "thread?" , 0 , argc , argv ) ); 

  p = (Scheme_Thread * ) argv [0 ] ; 

  if (argc > 1 ) {
#   define XfOrM914_COUNT (0+XfOrM905_COUNT)
#   define SETUP_XfOrM914(x) SETUP_XfOrM905(x)

# 6113 "bc/src/thread.c"
    if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) 
      promote_to = (Scheme_Thread * ) argv [1 ] ; 
    else if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_custodian_type ) )  {
      promote_c = (Scheme_Custodian * ) argv [1 ] ; 
      if (promote_c -> shut_down )
        promote_c = ((void * ) 0 ) ; 
    }

# 6119 "bc/src/thread.c"
    else {
#     define XfOrM915_COUNT (0+XfOrM914_COUNT)
#     define SETUP_XfOrM915(x) SETUP_XfOrM914(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("thread-resume" , "(or/c thread? custodian?)" , 1 , argc , argv ) )
# 6120 "bc/src/thread.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (! ((p -> running ) && ! ((p -> running ) & 0x4 ) ) )
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 


  if (promote_to ) {
    Scheme_Object * l ; 
    Scheme_Custodian_Reference * mref ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM905_COUNT), PUSH(mref, 1+XfOrM905_COUNT)));
#   define XfOrM910_COUNT (2+XfOrM905_COUNT)
#   define SETUP_XfOrM910(x) SETUP(XfOrM910_COUNT)
    l = NULLED_OUT ; 
    mref = NULLED_OUT ; 

# 6135 "bc/src/thread.c"
    if (promote_to -> mref && ((Scheme_Custodian_Weak_Box * ) promote_to -> mref ) -> val ) {
#     define XfOrM911_COUNT (0+XfOrM910_COUNT)
#     define SETUP_XfOrM911(x) SETUP_XfOrM910(x)
      FUNCCALL(SETUP_XfOrM911(_), promote_thread (p , ((Scheme_Custodian_Weak_Box * ) promote_to -> mref ) -> val ) )
# 6136 "bc/src/thread.c"
      ; 

      for (l = p -> extra_mrefs ; ! ((l ) == (scheme_null ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#       define XfOrM913_COUNT (0+XfOrM911_COUNT)
#       define SETUP_XfOrM913(x) SETUP_XfOrM911(x)

# 6139 "bc/src/thread.c"
        mref = (Scheme_Custodian_Reference * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        FUNCCALL(SETUP_XfOrM913(_), promote_thread (p , ((Scheme_Custodian_Weak_Box * ) mref ) -> val ) ); 
      }
    }
  }
  if (promote_c )
    FUNCCALL(SETUP_XfOrM905(_), promote_thread (p , promote_c ) ); 


  if (promote_to 
  && ((promote_to -> running ) && ! ((promote_to -> running ) & 0x4 ) ) 
  && ! ((promote_to ) == (p ) ) )
    FUNCCALL(SETUP_XfOrM905(_), add_transitive_resume (promote_to , p ) ); 


  {
    Scheme_Custodian * c ; 
    c = NULLED_OUT ; 
    if (p -> mref )
      c = ((Scheme_Custodian_Weak_Box * ) p -> mref ) -> val ; 
    else 
    c = ((void * ) 0 ) ; 

    if (! c || c -> shut_down )
      RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }

  if (p -> running & 0x10 ) {
#   define XfOrM906_COUNT (0+XfOrM905_COUNT)
#   define SETUP_XfOrM906(x) SETUP_XfOrM905(x)

# 6167 "bc/src/thread.c"
    p -> suspended_box = ((void * ) 0 ) ; 
    if (p -> resumed_box ) {
#     define XfOrM908_COUNT (0+XfOrM906_COUNT)
#     define SETUP_XfOrM908(x) SETUP_XfOrM906(x)

# 6169 "bc/src/thread.c"
      (((Scheme_Simple_Object * ) (p -> resumed_box ) ) -> u . two_ptr_val . ptr2 ) = (Scheme_Object * ) p ; 
      FUNCCALL(SETUP_XfOrM908(_), scheme_post_sema_all ((((Scheme_Simple_Object * ) (p -> resumed_box ) ) -> u . two_ptr_val . ptr1 ) ) ); 
    }

    if (p -> running_box && ! (p -> running & 0x2 ) ) {

      Scheme_Object * wb ; 
      BLOCK_SETUP((PUSH(wb, 0+XfOrM906_COUNT)));
#     define XfOrM907_COUNT (1+XfOrM906_COUNT)
#     define SETUP_XfOrM907(x) SETUP(XfOrM907_COUNT)
      wb = NULLED_OUT ; 

# 6176 "bc/src/thread.c"
      wb = FUNCCALL(SETUP_XfOrM907(_), scheme_make_weak_box ((Scheme_Object * ) p ) ); 
      (((Scheme_Small_Object * ) (p -> running_box ) ) -> u . ptr_val ) = wb ; 
    }

    p -> running -= 0x10 ; 
    FUNCCALL(SETUP_XfOrM906(_), scheme_weak_resume_thread (p ) )
    ; 

    if (p -> transitive_resumes )
      FUNCCALL_EMPTY(transitive_resume (p -> transitive_resumes ) ); 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6191 "bc/src/thread.c"
static Scheme_Object * make_thread_suspend (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6193 "bc/src/thread.c"
  Scheme_Thread * p ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    scheme_wrong_contract ("thread-suspend-evt" , "thread?" , 0 , argc , argv ) ; 

  p = (Scheme_Thread * ) argv [0 ] ; 

  return scheme_get_thread_suspend (p ) ; 
}

Scheme_Object * scheme_get_thread_suspend (Scheme_Thread * p ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM918_COUNT (1)
# define SETUP_XfOrM918(x) SETUP(XfOrM918_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 6205 "bc/src/thread.c"
  if (! p -> suspended_box ) {
    Scheme_Object * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM918_COUNT)));
#   define XfOrM919_COUNT (1+XfOrM918_COUNT)
#   define SETUP_XfOrM919(x) SETUP(XfOrM919_COUNT)
    b = NULLED_OUT ; 

# 6207 "bc/src/thread.c"
    b = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM919(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    b -> type = scheme_thread_suspend_type ; 
    if (((p -> running ) && ! ((p -> running ) & 0x4 ) ) && (p -> running & 0x10 ) )
      (((Scheme_Simple_Object * ) (b ) ) -> u . two_ptr_val . ptr2 ) = (Scheme_Object * ) p ; 
    else {
      Scheme_Object * sema ; 
      BLOCK_SETUP((PUSH(sema, 0+XfOrM919_COUNT)));
#     define XfOrM920_COUNT (1+XfOrM919_COUNT)
#     define SETUP_XfOrM920(x) SETUP(XfOrM920_COUNT)
      sema = NULLED_OUT ; 

# 6213 "bc/src/thread.c"
      sema = FUNCCALL(SETUP_XfOrM920(_), scheme_make_sema (0 ) ); 
      (((Scheme_Simple_Object * ) (b ) ) -> u . two_ptr_val . ptr1 ) = sema ; 
    }
    p -> suspended_box = b ; 
  }

  RET_VALUE_START (p -> suspended_box ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6222 "bc/src/thread.c"
static Scheme_Object * make_thread_resume (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM921_COUNT (1)
# define SETUP_XfOrM921(x) SETUP(XfOrM921_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 

# 6226 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("thread-resume-evt" , "thread?" , 0 , argc , argv ) ); 

  p = (Scheme_Thread * ) argv [0 ] ; 

  if (! p -> resumed_box ) {
    Scheme_Object * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM921_COUNT)));
#   define XfOrM922_COUNT (1+XfOrM921_COUNT)
#   define SETUP_XfOrM922(x) SETUP(XfOrM922_COUNT)
    b = NULLED_OUT ; 

# 6233 "bc/src/thread.c"
    b = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM922(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    b -> type = scheme_thread_resume_type ; 
    if (((p -> running ) && ! ((p -> running ) & 0x4 ) ) && ! (p -> running & 0x10 ) )
      (((Scheme_Simple_Object * ) (b ) ) -> u . two_ptr_val . ptr2 ) = (Scheme_Object * ) p ; 
    else {
      Scheme_Object * sema ; 
      BLOCK_SETUP((PUSH(sema, 0+XfOrM922_COUNT)));
#     define XfOrM923_COUNT (1+XfOrM922_COUNT)
#     define SETUP_XfOrM923(x) SETUP(XfOrM923_COUNT)
      sema = NULLED_OUT ; 

# 6239 "bc/src/thread.c"
      sema = FUNCCALL(SETUP_XfOrM923(_), scheme_make_sema (0 ) ); 
      (((Scheme_Simple_Object * ) (b ) ) -> u . two_ptr_val . ptr1 ) = sema ; 
    }
    p -> resumed_box = b ; 
  }

  RET_VALUE_START (p -> resumed_box ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6248 "bc/src/thread.c"
static int resume_suspend_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Object * t ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(sinfo, 0), PUSH(o, 1)));
# define XfOrM924_COUNT (2)
# define SETUP_XfOrM924(x) SETUP(XfOrM924_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  t = NULLED_OUT ; 

# 6252 "bc/src/thread.c"
  t = (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr2 ) ; 
  if (t ) {
#   define XfOrM925_COUNT (0+XfOrM924_COUNT)
#   define SETUP_XfOrM925(x) SETUP_XfOrM924(x)
    FUNCCALL(SETUP_XfOrM925(_), scheme_set_sync_target (sinfo , o , t , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) )
# 6254 "bc/src/thread.c"
    ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  FUNCCALL_EMPTY(scheme_set_sync_target (sinfo , (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr1 ) , o , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
  ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6262 "bc/src/thread.c"
static Scheme_Object * make_thread_dead (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6264 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    scheme_wrong_contract ("thread-dead-evt" , "thread?" , 0 , argc , argv ) ; 

  return scheme_get_thread_dead ((Scheme_Thread * ) argv [0 ] ) ; 
}

Scheme_Object * scheme_get_thread_dead (Scheme_Thread * p ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM927_COUNT (1)
# define SETUP_XfOrM927(x) SETUP(XfOrM927_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 6272 "bc/src/thread.c"
  if (! p -> dead_box ) {
    Scheme_Object * b ; 
    Scheme_Object * sema ; 
    BLOCK_SETUP((PUSH(sema, 0+XfOrM927_COUNT), PUSH(b, 1+XfOrM927_COUNT)));
#   define XfOrM928_COUNT (2+XfOrM927_COUNT)
#   define SETUP_XfOrM928(x) SETUP(XfOrM928_COUNT)
    b = NULLED_OUT ; 
    sema = NULLED_OUT ; 

# 6276 "bc/src/thread.c"
    b = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM928(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    b -> type = scheme_thread_dead_type ; 
    sema = FUNCCALL(SETUP_XfOrM928(_), scheme_make_sema (0 ) ); 
    (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) = sema ; 
    if (! ((p -> running ) && ! ((p -> running ) & 0x4 ) ) )
      FUNCCALL(SETUP_XfOrM928(_), scheme_post_sema_all (sema ) ); 

    p -> dead_box = b ; 
  }

  RET_VALUE_START (p -> dead_box ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6289 "bc/src/thread.c"
static int dead_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 6291 "bc/src/thread.c"
  scheme_set_sync_target (sinfo , (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) , o , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) ; 
  return 0 ; 
}

Scheme_Object * scheme_get_thread_sync (Scheme_Thread * p ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM930_COUNT (1)
# define SETUP_XfOrM930(x) SETUP(XfOrM930_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 6297 "bc/src/thread.c"
  if (! p -> sync_box ) {
    Scheme_Object * sema ; 
    BLOCK_SETUP((PUSH(sema, 0+XfOrM930_COUNT)));
#   define XfOrM931_COUNT (1+XfOrM930_COUNT)
#   define SETUP_XfOrM931(x) SETUP(XfOrM931_COUNT)
    sema = NULLED_OUT ; 

# 6299 "bc/src/thread.c"
    sema = FUNCCALL(SETUP_XfOrM931(_), scheme_make_sema (0 ) ); 
    p -> sync_box = sema ; 
  }

  RET_VALUE_START (p -> sync_box ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6306 "bc/src/thread.c"
void scheme_clear_thread_sync (Scheme_Thread * p ) 
{
  /* No conversion */

# 6308 "bc/src/thread.c"
  if (p -> sync_box )
    p -> sync_box = ((void * ) 0 ) ; 
}





static Evt_Set * make_evt_set (const char * name , int argc , Scheme_Object * * argv , int delta , int flatten ) ; 

typedef struct Evt {
  Scheme_Type type ; 
  Scheme_Type sync_type ; 
  Scheme_Ready_Fun_FPC ready ; 
  Scheme_Needs_Wakeup_Fun needs_wakeup ; 
  Scheme_Sync_Sema_Fun get_sema ; 
  Scheme_Sync_Filter_Fun filter ; 
  int can_redirect ; 
}

# 6326 "bc/src/thread.c"
Evt ; 



static int evts_array_size ; 
static Evt * * evts ; 

; 
; 


void scheme_add_evt_worker (Evt * * * evt_array , 
int * evt_size , 
Scheme_Type type , 
Scheme_Ready_Fun ready , 
Scheme_Needs_Wakeup_Fun wakeup , 
Scheme_Sync_Filter_Fun filter , 
int can_redirect ) 
{
  Evt * naya ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(evt_size, 0), PUSH(naya, 1), PUSH(evt_array, 2)));
# define XfOrM933_COUNT (3)
# define SETUP_XfOrM933(x) SETUP(XfOrM933_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  naya = NULLED_OUT ; 

# 6347 "bc/src/thread.c"
  if (* evt_size <= type ) {
    Evt * * nevts ; 
    int new_size ; 
    BLOCK_SETUP((PUSH(nevts, 0+XfOrM933_COUNT)));
#   define XfOrM934_COUNT (1+XfOrM933_COUNT)
#   define SETUP_XfOrM934(x) SETUP(XfOrM934_COUNT)
    nevts = NULLED_OUT ; 

# 6350 "bc/src/thread.c"
    new_size = type + 1 ; 
    if (new_size < _scheme_last_type_ )
      new_size = _scheme_last_type_ ; 
    nevts = ((Evt * * ) FUNCCALL(SETUP_XfOrM934(_), GC_malloc (sizeof (Evt * ) * (new_size ) ) )) ; 
    if (* evt_size )
      (memcpy (nevts , (* evt_array ) , (* evt_size ) * sizeof (Evt * ) ) ) ; 
    (* evt_array ) = nevts ; 
    (* evt_size ) = new_size ; 
  }

  naya = ((Evt * ) FUNCCALL(SETUP_XfOrM933(_), GC_malloc_one_small_tagged ((((sizeof (Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  naya -> type = scheme_rt_evt ; 

  naya -> sync_type = type ; 
  naya -> ready = (Scheme_Ready_Fun_FPC ) ready ; 
  naya -> needs_wakeup = wakeup ; 
  naya -> filter = filter ; 
  naya -> can_redirect = can_redirect ; 

  (* evt_array ) [type ] = naya ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6373 "bc/src/thread.c"
void scheme_add_evt (Scheme_Type type , 
Scheme_Ready_Fun ready , 
Scheme_Needs_Wakeup_Fun wakeup , 
Scheme_Sync_Filter_Fun filter , 
int can_redirect ) 
{
  /* No conversion */
  if (GC_is_place () ) {
    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_evts_ ) ) {
      scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_evts_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_evts_ ) ) ) ; 
    }
    scheme_add_evt_worker (& XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_evts_ ) , & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_evts_array_size_ ) , type , ready , wakeup , filter , can_redirect ) ; 
  }
  else {

    if (! evts ) {
      scheme_register_static ((void * ) & evts , sizeof (evts ) ) ; 
    }
    scheme_add_evt_worker (& evts , & evts_array_size , type , ready , wakeup , filter , can_redirect ) ; 
  }
}



void scheme_add_evt_through_sema (Scheme_Type type , 
Scheme_Sync_Sema_Fun get_sema , 
Scheme_Sync_Filter_Fun filter ) 
{
  /* No conversion */

# 6401 "bc/src/thread.c"
  scheme_add_evt (type , ((void * ) 0 ) , ((void * ) 0 ) , filter , 0 ) ; 
  evts [type ] -> get_sema = get_sema ; 
}

static Evt * find_evt (Scheme_Object * o ) 
{
  Scheme_Type t ; 
  Evt * w = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Evt * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(w, 0)));
# define XfOrM941_COUNT (1)
# define SETUP_XfOrM941(x) SETUP(XfOrM941_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 6410 "bc/src/thread.c"
  t = ((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ; 
  if (t < evts_array_size )
    w = evts [t ] ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_evts_ ) && w == ((void * ) 0 ) )
    w = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_evts_ ) [t ] ; 


  if (w && w -> filter ) {
    Scheme_Sync_Filter_Fun filter ; 
#   define XfOrM942_COUNT (0+XfOrM941_COUNT)
#   define SETUP_XfOrM942(x) SETUP_XfOrM941(x)

# 6420 "bc/src/thread.c"
    filter = w -> filter ; 
    if (! FUNCCALL(SETUP_XfOrM942(_), filter (o ) ))
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  RET_VALUE_START (w ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6427 "bc/src/thread.c"
int scheme_is_evt (Scheme_Object * o ) 
{
  /* No conversion */

# 6429 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_evt_set_type ) ) 
    return 1 ; 

  return ! ! find_evt (o ) ; 
}

static Syncing * make_syncing (Evt_Set * evt_set , float timeout , double start_time ) 
{
  Syncing * syncing ; 
  int pos ; 
  DECL_RET_SAVE (Syncing * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(syncing, 0), PUSH(evt_set, 1)));
# define XfOrM944_COUNT (2)
# define SETUP_XfOrM944(x) SETUP(XfOrM944_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  syncing = NULLED_OUT ; 

# 6440 "bc/src/thread.c"
  syncing = ((Syncing * ) FUNCCALL(SETUP_XfOrM944(_), GC_malloc_one_small_tagged ((((sizeof (Syncing ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  syncing -> type = scheme_rt_syncing ; 

  syncing -> set = evt_set ; 
  syncing -> timeout = timeout ; 
  if (timeout >= 0 )
    syncing -> sleep_end = start_time + (timeout * 1000 ) ; 
  else 
  syncing -> sleep_end = 0.0 ; 

  if (evt_set -> argc > 1 ) {
    Scheme_Config * config ; 
    Scheme_Object * rand_state ; 
    BLOCK_SETUP((PUSH(rand_state, 0+XfOrM944_COUNT), PUSH(config, 1+XfOrM944_COUNT)));
#   define XfOrM945_COUNT (2+XfOrM944_COUNT)
#   define SETUP_XfOrM945(x) SETUP(XfOrM945_COUNT)
    config = NULLED_OUT ; 
    rand_state = NULLED_OUT ; 

# 6454 "bc/src/thread.c"
    config = FUNCCALL(SETUP_XfOrM945(_), scheme_current_config () ); 
    rand_state = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_SCHEDULER_RANDOM_STATE ) ); 
    pos = FUNCCALL_AGAIN(scheme_rand ((Scheme_Random_State * ) rand_state ) ); 
    syncing -> start_pos = (pos % evt_set -> argc ) ; 
  }
  syncing -> thread = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  RET_VALUE_START (syncing ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6464 "bc/src/thread.c"
Syncing * scheme_make_syncing (int argc , Scheme_Object * * argv ) 
{
  Evt_Set * evt_set ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(evt_set, 0)));
# define XfOrM946_COUNT (1)
# define SETUP_XfOrM946(x) SETUP(XfOrM946_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  evt_set = NULLED_OUT ; 

# 6468 "bc/src/thread.c"
  evt_set = FUNCCALL(SETUP_XfOrM946(_), make_evt_set ("sync" , argc , argv , 0 , 1 ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_syncing (evt_set , - 1.0 , 0 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6473 "bc/src/thread.c"
static void * splice_ptr_array (void * * a , int al , void * * b , int bl , int i ) 
{
  void * * r ; 
  int j ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(a, 1), PUSH(r, 2)));
# define XfOrM947_COUNT (3)
# define SETUP_XfOrM947(x) SETUP(XfOrM947_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  r = NULLED_OUT ; 

# 6478 "bc/src/thread.c"
  ((void ) sizeof ((a != ((void * ) 0 ) || b != ((void * ) 0 ) ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM951_COUNT (0+XfOrM947_COUNT)
#   define SETUP_XfOrM951(x) SETUP_XfOrM947(x)

# 6478 "bc/src/thread.c" 3
    if (a != ((void * ) 0 ) || b != ((void * ) 0 ) )

# 6478 "bc/src/thread.c" 3
    ; 

# 6478 "bc/src/thread.c" 3
    else FUNCCALL(SETUP_XfOrM951(_), __assert_fail ("a != ((void *)0) || b != ((void *)0)" , "bc/src/thread.c" , 6478 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 6478 "bc/src/thread.c"
  ; 

  r = ((void * * ) FUNCCALL(SETUP_XfOrM947(_), GC_malloc (sizeof (void * ) * (al + bl - 1 ) ) )) ; 

  if (a )
    (memcpy (r , a , i * sizeof (void * ) ) ) ; 
  if (b )
    (memcpy (r + i , b , bl * sizeof (void * ) ) ) ; 
  else {
    for (j = 0 ; j < bl ; j ++ ) {
      r [i + j ] = a [i ] ; 
    }
  }
  if (a )
    (memcpy (r + (i + bl ) , a + (i + 1 ) , (al - i - 1 ) * sizeof (void * ) ) ) ; 

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6497 "bc/src/thread.c"
static void set_sync_target (Syncing * syncing , int i , Scheme_Object * target , 
Scheme_Object * wrap , Scheme_Object * nack , 
int repost , int retry , Scheme_Accept_Sync accept ) 

{
  Evt_Set * evt_set = syncing -> set ; 
  PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(wrap, 0), PUSH(nack, 1), PUSH(syncing, 2), PUSH(target, 3), PUSH(evt_set, 4)));
# define XfOrM952_COUNT (5)
# define SETUP_XfOrM952(x) SETUP(XfOrM952_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 6504 "bc/src/thread.c"
  if (wrap ) {
#   define XfOrM972_COUNT (0+XfOrM952_COUNT)
#   define SETUP_XfOrM972(x) SETUP_XfOrM952(x)

# 6505 "bc/src/thread.c"
    if (! syncing -> wrapss ) {
      Scheme_Object * * wrapss ; 
      BLOCK_SETUP((PUSH(wrapss, 0+XfOrM972_COUNT)));
#     define XfOrM973_COUNT (1+XfOrM972_COUNT)
#     define SETUP_XfOrM973(x) SETUP(XfOrM973_COUNT)
      wrapss = NULLED_OUT ; 

# 6507 "bc/src/thread.c"
      wrapss = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM973(_), GC_malloc (sizeof (Scheme_Object * ) * (evt_set -> argc ) ) )) ; 
      syncing -> wrapss = wrapss ; 
    }
    if (! syncing -> wrapss [i ] )
      syncing -> wrapss [i ] = scheme_null ; 
    wrap = FUNCCALL(SETUP_XfOrM972(_), scheme_make_pair (wrap , syncing -> wrapss [i ] ) ); 
    syncing -> wrapss [i ] = wrap ; 
  }

  if (nack ) {
#   define XfOrM970_COUNT (0+XfOrM952_COUNT)
#   define SETUP_XfOrM970(x) SETUP_XfOrM952(x)

# 6517 "bc/src/thread.c"
    if (! syncing -> nackss ) {
      Scheme_Object * * nackss ; 
      BLOCK_SETUP((PUSH(nackss, 0+XfOrM970_COUNT)));
#     define XfOrM971_COUNT (1+XfOrM970_COUNT)
#     define SETUP_XfOrM971(x) SETUP(XfOrM971_COUNT)
      nackss = NULLED_OUT ; 

# 6519 "bc/src/thread.c"
      nackss = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM971(_), GC_malloc (sizeof (Scheme_Object * ) * (evt_set -> argc ) ) )) ; 
      syncing -> nackss = nackss ; 
    }
    if (! syncing -> nackss [i ] )
      syncing -> nackss [i ] = scheme_null ; 
    nack = FUNCCALL(SETUP_XfOrM970(_), scheme_make_pair (nack , syncing -> nackss [i ] ) ); 
    syncing -> nackss [i ] = nack ; 
  }

  if (repost ) {
#   define XfOrM968_COUNT (0+XfOrM952_COUNT)
#   define SETUP_XfOrM968(x) SETUP_XfOrM952(x)

# 6529 "bc/src/thread.c"
    if (! syncing -> reposts ) {
      char * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM968_COUNT)));
#     define XfOrM969_COUNT (1+XfOrM968_COUNT)
#     define SETUP_XfOrM969(x) SETUP(XfOrM969_COUNT)
      s = NULLED_OUT ; 

# 6531 "bc/src/thread.c"
      s = (char * ) FUNCCALL(SETUP_XfOrM969(_), GC_malloc_atomic (evt_set -> argc ) ); 
      (memset (s , 0 , evt_set -> argc ) ) ; 
      syncing -> reposts = s ; 
    }
    syncing -> reposts [i ] = 1 ; 
  }

  if (accept ) {
#   define XfOrM966_COUNT (0+XfOrM952_COUNT)
#   define SETUP_XfOrM966(x) SETUP_XfOrM952(x)

# 6539 "bc/src/thread.c"
    if (! syncing -> accepts ) {
      Scheme_Accept_Sync * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM966_COUNT)));
#     define XfOrM967_COUNT (1+XfOrM966_COUNT)
#     define SETUP_XfOrM967(x) SETUP(XfOrM967_COUNT)
      s = NULLED_OUT ; 

# 6541 "bc/src/thread.c"
      s = (Scheme_Accept_Sync * ) FUNCCALL(SETUP_XfOrM967(_), GC_malloc_atomic (sizeof (Scheme_Accept_Sync ) * evt_set -> argc ) ); 
      (memset (s , 0 , evt_set -> argc * sizeof (Scheme_Accept_Sync ) ) ) ; 
      syncing -> accepts = s ; 
    }
    syncing -> accepts [i ] = accept ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (target ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (target ) ) -> type ) ) == (Scheme_Type ) (scheme_evt_set_type ) ) && retry ) {

    Evt_Set * wts ; 
    BLOCK_SETUP((PUSH(wts, 0+XfOrM952_COUNT)));
#   define XfOrM954_COUNT (1+XfOrM952_COUNT)
#   define SETUP_XfOrM954(x) SETUP(XfOrM954_COUNT)
    wts = NULLED_OUT ; 

# 6552 "bc/src/thread.c"
    if (((Scheme_Inclhash_Object * ) (target ) ) -> so . keyex & 0x1 )  {
      Scheme_Object * a [1 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM954_COUNT)));
#     define XfOrM965_COUNT (3+XfOrM954_COUNT)
#     define SETUP_XfOrM965(x) SETUP(XfOrM965_COUNT)
      a[0] = NULLED_OUT ; 

# 6554 "bc/src/thread.c"
      a [0 ] = target ; 
      wts = FUNCCALL(SETUP_XfOrM965(_), make_evt_set ("sync" , 1 , a , 0 , 1 ) ); 
    }

# 6556 "bc/src/thread.c"
    else 
    wts = (Evt_Set * ) target ; 

    if (wts -> argc == 1 ) {

      evt_set -> argv [i ] = wts -> argv [0 ] ; 
      evt_set -> ws [i ] = wts -> ws [0 ] ; 
    }

# 6563 "bc/src/thread.c"
    else {

      Scheme_Object * * argv ; 
      Evt * * ws ; 
      BLOCK_SETUP((PUSH(argv, 0+XfOrM954_COUNT), PUSH(ws, 1+XfOrM954_COUNT)));
#     define XfOrM955_COUNT (2+XfOrM954_COUNT)
#     define SETUP_XfOrM955(x) SETUP(XfOrM955_COUNT)
      argv = NULLED_OUT ; 
      ws = NULLED_OUT ; 

# 6568 "bc/src/thread.c"
      if (syncing -> result > i + 1 )
        syncing -> result += wts -> argc - 1 ; 

      argv = (Scheme_Object * * ) FUNCCALL(SETUP_XfOrM955(_), splice_ptr_array ((void * * ) evt_set -> argv , evt_set -> argc , (void * * ) wts -> argv , wts -> argc , i ) )



      ; 
      ws = (Evt * * ) FUNCCALL(SETUP_XfOrM955(_), splice_ptr_array ((void * * ) evt_set -> ws , evt_set -> argc , (void * * ) wts -> ws , wts -> argc , i ) )



      ; 

      evt_set -> argv = argv ; 
      evt_set -> ws = ws ; 

      if (syncing -> wrapss ) {
#       define XfOrM963_COUNT (0+XfOrM955_COUNT)
#       define SETUP_XfOrM963(x) SETUP_XfOrM955(x)

# 6586 "bc/src/thread.c"
        argv = (Scheme_Object * * ) FUNCCALL(SETUP_XfOrM963(_), splice_ptr_array ((void * * ) syncing -> wrapss , evt_set -> argc , (void * * ) ((void * ) 0 ) , wts -> argc , i ) )



        ; 
        syncing -> wrapss = argv ; 
      }
      if (syncing -> nackss ) {
#       define XfOrM962_COUNT (0+XfOrM955_COUNT)
#       define SETUP_XfOrM962(x) SETUP_XfOrM955(x)

# 6594 "bc/src/thread.c"
        argv = (Scheme_Object * * ) FUNCCALL(SETUP_XfOrM962(_), splice_ptr_array ((void * * ) syncing -> nackss , evt_set -> argc , (void * * ) ((void * ) 0 ) , wts -> argc , i ) )



        ; 
        syncing -> nackss = argv ; 
      }
      if (syncing -> reposts ) {
        char * s ; 
        int len ; 
        BLOCK_SETUP((PUSH(s, 0+XfOrM955_COUNT)));
#       define XfOrM961_COUNT (1+XfOrM955_COUNT)
#       define SETUP_XfOrM961(x) SETUP(XfOrM961_COUNT)
        s = NULLED_OUT ; 

# 6605 "bc/src/thread.c"
        len = evt_set -> argc + wts -> argc - 1 ; 

        s = (char * ) FUNCCALL(SETUP_XfOrM961(_), GC_malloc_atomic (len ) ); 
        (memset (s , 0 , len ) ) ; 
        (
        memcpy (s , syncing -> reposts , i ) ) ; 
        (memcpy (s + i + wts -> argc , syncing -> reposts + i + 1 , evt_set -> argc - i - 1 ) ) ; 
        syncing -> reposts = s ; 
      }
      if (syncing -> accepts ) {
        Scheme_Accept_Sync * s ; 
        int len ; 
        BLOCK_SETUP((PUSH(s, 0+XfOrM955_COUNT)));
#       define XfOrM960_COUNT (1+XfOrM955_COUNT)
#       define SETUP_XfOrM960(x) SETUP(XfOrM960_COUNT)
        s = NULLED_OUT ; 

# 6618 "bc/src/thread.c"
        len = evt_set -> argc + wts -> argc - 1 ; 

        s = (Scheme_Accept_Sync * ) FUNCCALL(SETUP_XfOrM960(_), GC_malloc_atomic (len * sizeof (Scheme_Accept_Sync ) ) ); 
        (memset (s , 0 , len * sizeof (Scheme_Accept_Sync ) ) ) ; 
        (
        memcpy (s , syncing -> accepts , i * sizeof (Scheme_Accept_Sync ) ) ) ; 
        (memcpy (s + i + wts -> argc , syncing -> accepts + i + 1 , (evt_set -> argc - i - 1 ) * sizeof (Scheme_Accept_Sync ) ) ) ; 
        syncing -> accepts = s ; 
      }

      evt_set -> argc += (wts -> argc - 1 ) ; 



      argv = evt_set -> argv ; 
      for (i = evt_set -> argc ; i -- ; ) {
        if ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_syncer_type ) )  {
          ((Scheme_Channel_Syncer * ) argv [i ] ) -> syncing_i = i ; 
        }
      }
    }
  }
  else {
    Evt * ww ; 
    BLOCK_SETUP((PUSH(ww, 0+XfOrM952_COUNT)));
#   define XfOrM953_COUNT (1+XfOrM952_COUNT)
#   define SETUP_XfOrM953(x) SETUP(XfOrM953_COUNT)
    ww = NULLED_OUT ; 

# 6642 "bc/src/thread.c"
    evt_set -> argv [i ] = target ; 
    ww = FUNCCALL(SETUP_XfOrM953(_), find_evt (target ) ); 
    evt_set -> ws [i ] = ww ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6648 "bc/src/thread.c"
void scheme_set_sync_target (Scheme_Schedule_Info * sinfo , Scheme_Object * target , 
Scheme_Object * wrap , Scheme_Object * nack , 
int repost , int retry , Scheme_Accept_Sync accept ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sinfo, 0)));
# define XfOrM974_COUNT (1)
# define SETUP_XfOrM974(x) SETUP(XfOrM974_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM974(_), set_sync_target ((Syncing * ) sinfo -> current_syncing , sinfo -> w_i , target , wrap , nack , repost , retry , accept ) )
# 6653 "bc/src/thread.c"
  ; 
  if (retry ) {


    sinfo -> w_i -- ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6661 "bc/src/thread.c"
int scheme_syncing_ready (Syncing * syncing , Scheme_Schedule_Info * sinfo , int can_suspend ) 
{
  int i , redirections = 0 , all_semas = 1 , j , result = 0 ; 
  Evt * w ; 
  Scheme_Object * o ; 
  Scheme_Schedule_Info r_sinfo ; 
  Evt_Set * evt_set ; 
  int is_poll ; 
  double sleep_end ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(w, 0), PUSH(sinfo, 1), PUSH(syncing, 2), PUSH(r_sinfo.false_positive_ok, 3), PUSH(r_sinfo.current_syncing, 4), PUSH(r_sinfo.replace_chain, 5), PUSH(evt_set, 6), PUSH(o, 7)));
# define XfOrM976_COUNT (8)
# define SETUP_XfOrM976(x) SETUP(XfOrM976_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  w = NULLED_OUT ; 
  o = NULLED_OUT ; 
  r_sinfo.false_positive_ok = NULLED_OUT ; 
  r_sinfo.current_syncing = NULLED_OUT ; 
  r_sinfo.replace_chain = NULLED_OUT ; 
  evt_set = NULLED_OUT ; 

# 6671 "bc/src/thread.c"
  sleep_end = syncing -> sleep_end ; 

  if (syncing -> result ) {
    result = 1 ; 
    goto set_sleep_end_and_return ; 
  }






  evt_set = syncing -> set ; 

  is_poll = (syncing -> timeout == 0.0 ) ; 


  for (j = 0 ; j < evt_set -> argc ; j ++ ) {
    Scheme_Ready_Fun_FPC ready ; 
#   define XfOrM991_COUNT (0+XfOrM976_COUNT)
#   define SETUP_XfOrM991(x) SETUP_XfOrM976(x)

# 6691 "bc/src/thread.c"
    i = (j + syncing -> start_pos ) % evt_set -> argc ; 

    o = evt_set -> argv [i ] ; 
    w = evt_set -> ws [i ] ; 
    ready = w -> ready ; 

    if (! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) 
    && ! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_put_type ) ) 
    && ! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_syncer_type ) ) 
    && ! ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_never_evt_type ) ) )
      all_semas = 0 ; 

    if (ready ) {
      int yep ; 
#     define XfOrM993_COUNT (0+XfOrM991_COUNT)
#     define SETUP_XfOrM993(x) SETUP_XfOrM991(x)
      FUNCCALL(SETUP_XfOrM993(_), init_schedule_info (& r_sinfo , sinfo -> false_positive_ok , 0 , sleep_end ) )
# 6706 "bc/src/thread.c"
      ; 

      r_sinfo . current_syncing = (Scheme_Object * ) syncing ; 
      r_sinfo . w_i = i ; 
      r_sinfo . is_poll = is_poll ; 
      r_sinfo . replace_chain = sinfo -> replace_chain ; 

      yep = FUNCCALL(SETUP_XfOrM993(_), ready (o , & r_sinfo ) ); 

      sleep_end = r_sinfo . sleep_end ; 
      sinfo -> replace_chain = r_sinfo . replace_chain ; 



      if (syncing -> result ) {
        result = 1 ; 
        goto set_sleep_end_and_return ; 
      }

      if ((i > r_sinfo . w_i ) && sinfo -> false_positive_ok ) {


        redirections ++ ; 
        if (redirections > 10 ) {
          sinfo -> potentially_false_positive = 1 ; 
          result = 1 ; 
          goto set_sleep_end_and_return ; 
        }
      }

      j += (r_sinfo . w_i - i ) ; 

      if (yep ) {
#       define XfOrM995_COUNT (0+XfOrM993_COUNT)
#       define SETUP_XfOrM995(x) SETUP_XfOrM993(x)

        if (! r_sinfo . potentially_false_positive ) {
#         define XfOrM997_COUNT (0+XfOrM995_COUNT)
#         define SETUP_XfOrM997(x) SETUP_XfOrM995(x)

# 6743 "bc/src/thread.c"
          syncing -> result = i + 1 ; 
          if (syncing -> disable_break )
            syncing -> disable_break -> suspend_break ++ ; 
          if (syncing -> reposts && syncing -> reposts [i ] )
            FUNCCALL(SETUP_XfOrM997(_), scheme_post_sema (o ) ); 
          if (syncing -> accepts && syncing -> accepts [i ] )
            FUNCCALL(SETUP_XfOrM997(_), scheme_accept_sync (syncing , i ) ); 
          FUNCCALL(SETUP_XfOrM997(_), scheme_post_syncing_nacks (syncing ) ); 
          result = 1 ; 
          goto set_sleep_end_and_return ; 
        }

# 6753 "bc/src/thread.c"
        else {
          sinfo -> potentially_false_positive = 1 ; 
          result = 1 ; 
          goto set_sleep_end_and_return ; 
        }
      }

# 6758 "bc/src/thread.c"
      else if (r_sinfo . spin ) {
        sinfo -> spin = 1 ; 
      }
    }

# 6761 "bc/src/thread.c"
    else if (w -> get_sema ) {
      int repost = 0 ; 
      Scheme_Sync_Sema_Fun get_sema = w -> get_sema ; 
      Scheme_Object * sema ; 
      BLOCK_SETUP((PUSH(sema, 0+XfOrM991_COUNT)));
#     define XfOrM992_COUNT (1+XfOrM991_COUNT)
#     define SETUP_XfOrM992(x) SETUP(XfOrM992_COUNT)
      sema = NULLED_OUT ; 

# 6766 "bc/src/thread.c"
      sema = FUNCCALL(SETUP_XfOrM992(_), get_sema (o , & repost ) ); 
      FUNCCALL_AGAIN(set_sync_target (syncing , i , sema , o , ((void * ) 0 ) , repost , 1 , ((void * ) 0 ) ) ); 
      j -- ; 
    }

    if (syncing -> result )
      FUNCCALL(SETUP_XfOrM991(_), scheme_signal_error ("internal error: sync result set unexpectedly" ) ); 
  }

  if (syncing -> timeout >= 0.0 ) {
#   define XfOrM980_COUNT (0+XfOrM976_COUNT)
#   define SETUP_XfOrM980(x) SETUP_XfOrM976(x)

# 6776 "bc/src/thread.c"
    if (syncing -> sleep_end <= (rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) )
      result = 1 ; 
  }

# 6778 "bc/src/thread.c"
  else if (all_semas && can_suspend ) {
#   define XfOrM977_COUNT (0+XfOrM976_COUNT)
#   define SETUP_XfOrM977(x) SETUP_XfOrM976(x)

# 6780 "bc/src/thread.c"
    if (sinfo -> false_positive_ok ) {

      sinfo -> potentially_false_positive = 1 ; 
      result = 1 ; 
    }

# 6784 "bc/src/thread.c"
    else {
#     define XfOrM978_COUNT (0+XfOrM977_COUNT)
#     define SETUP_XfOrM978(x) SETUP_XfOrM977(x)
      FUNCCALL(SETUP_XfOrM978(_), scheme_wait_semas_chs (syncing -> set -> argc , syncing -> set -> argv , 0 , syncing ) ); 
      FUNCCALL(SETUP_XfOrM978(_), scheme_check_break_now () )


      ; 

      result = 1 ; 
    }
  }

  set_sleep_end_and_return : 

  if (sleep_end 
  && (! sinfo -> sleep_end 
  || (sinfo -> sleep_end > sleep_end ) ) )
    sinfo -> sleep_end = sleep_end ; 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6807 "bc/src/thread.c"
static int syncing_ready (Syncing * syncing , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 6809 "bc/src/thread.c"
  return scheme_syncing_ready (syncing , sinfo , 1 ) ; 
}

void scheme_accept_sync (Syncing * syncing , int i ) 
{

  Scheme_Accept_Sync accept ; 
  Scheme_Object * v , * pr ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(syncing, 1), PUSH(pr, 2)));
# define XfOrM1003_COUNT (3)
# define SETUP_XfOrM1003(x) SETUP(XfOrM1003_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  pr = NULLED_OUT ; 

# 6818 "bc/src/thread.c"
  accept = syncing -> accepts [i ] ; 
  syncing -> accepts [i ] = ((void * ) 0 ) ; 
  pr = syncing -> wrapss [i ] ; 

  v = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ; 
  pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 

  v = FUNCCALL(SETUP_XfOrM1003(_), accept (v ) ); 

  pr = FUNCCALL_AGAIN(scheme_make_pair (v , pr ) ); 
  syncing -> wrapss [i ] = pr ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6831 "bc/src/thread.c"
void scheme_syncing_needs_wakeup (Syncing * s , void * fds ) 
{
  int i ; 
  Scheme_Object * o , * syncs = ((void * ) 0 ) ; 
  Syncing * next ; 
  Evt * w ; 
  Evt_Set * evt_set ; 
  PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(next, 0), PUSH(fds, 1), PUSH(evt_set, 2), PUSH(syncs, 3), PUSH(w, 4), PUSH(o, 5), PUSH(s, 6)));
# define XfOrM1004_COUNT (7)
# define SETUP_XfOrM1004(x) SETUP(XfOrM1004_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  next = NULLED_OUT ; 
  w = NULLED_OUT ; 
  evt_set = NULLED_OUT ; 

# 6839 "bc/src/thread.c"
  do {
#   define XfOrM1013_COUNT (0+XfOrM1004_COUNT)
#   define SETUP_XfOrM1013(x) SETUP_XfOrM1004(x)

# 6840 "bc/src/thread.c"
    evt_set = s -> set ; 

    for (i = 0 ; i < evt_set -> argc ; i ++ ) {
#     define XfOrM1018_COUNT (0+XfOrM1013_COUNT)
#     define SETUP_XfOrM1018(x) SETUP_XfOrM1013(x)

# 6843 "bc/src/thread.c"
      o = evt_set -> argv [i ] ; 
      w = evt_set -> ws [i ] ; 

      if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_active_replace_evt_type ) )  {
#       define XfOrM1020_COUNT (0+XfOrM1018_COUNT)
#       define SETUP_XfOrM1020(x) SETUP_XfOrM1018(x)

# 6848 "bc/src/thread.c"
        next = FUNCCALL(SETUP_XfOrM1020(_), scheme_replace_evt_needs_wakeup (o ) ); 
        if (next )
          syncs = FUNCCALL(SETUP_XfOrM1020(_), scheme_make_raw_pair ((Scheme_Object * ) next , syncs ) ); 
      }

# 6851 "bc/src/thread.c"
      else if (w -> needs_wakeup ) {
        Scheme_Needs_Wakeup_Fun nw = w -> needs_wakeup ; 
#       define XfOrM1019_COUNT (0+XfOrM1018_COUNT)
#       define SETUP_XfOrM1019(x) SETUP_XfOrM1018(x)
        FUNCCALL(SETUP_XfOrM1019(_), nw (o , fds ) )
# 6854 "bc/src/thread.c"
        ; 
      }
    }

    if (! syncs )
      s = ((void * ) 0 ) ; 
    else {
      s = (Syncing * ) (((Scheme_Simple_Object * ) (syncs ) ) -> u . pair_val . car ) ; 
      syncs = (((Scheme_Simple_Object * ) (syncs ) ) -> u . pair_val . cdr ) ; 
    }
  }

# 6864 "bc/src/thread.c"
  while (s ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6867 "bc/src/thread.c"
static Scheme_Object * evt_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6869 "bc/src/thread.c"
  return (scheme_is_evt (argv [0 ] ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static int evt_set_flatten (Evt_Set * e , int pos , Scheme_Object * * args , Evt * * ws ) 
{
  Scheme_Object * stack = scheme_null ; 
  int i ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(ws, 1), PUSH(e, 2), PUSH(args, 3)));
# define XfOrM1022_COUNT (4)
# define SETUP_XfOrM1022(x) SETUP(XfOrM1022_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 6879 "bc/src/thread.c"
  while (1 ) {
#   define XfOrM1031_COUNT (0+XfOrM1022_COUNT)
#   define SETUP_XfOrM1031(x) SETUP_XfOrM1022(x)

# 6880 "bc/src/thread.c"
    for (i = e -> argc ; i -- ; ) {
#     define XfOrM1036_COUNT (0+XfOrM1031_COUNT)
#     define SETUP_XfOrM1036(x) SETUP_XfOrM1031(x)

# 6881 "bc/src/thread.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (e -> argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e -> argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_evt_set_type ) ) ) {
        if (args ) {
          args [pos ] = e -> argv [i ] ; 
          ws [pos ] = e -> ws [i ] ; 
        }
        pos ++ ; 
      }

# 6887 "bc/src/thread.c"
      else 
      stack = FUNCCALL(SETUP_XfOrM1036(_), scheme_make_pair (e -> argv [i ] , stack ) ); 
    }

    if (! ((stack ) == (scheme_null ) ) ) {
      e = (Evt_Set * ) (((Scheme_Simple_Object * ) (stack ) ) -> u . pair_val . car ) ; 
      stack = (((Scheme_Simple_Object * ) (stack ) ) -> u . pair_val . cdr ) ; 
    }

# 6894 "bc/src/thread.c"
    else 
    break ; 
  }

  RET_VALUE_START (pos ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6901 "bc/src/thread.c"
static Evt_Set * make_evt_set (const char * name , int argc , Scheme_Object * * argv , int delta , int flatten ) 
{
  Evt * w , * * iws , * * ws ; 
  Evt_Set * evt_set , * subset ; 
  Scheme_Object * * args ; 
  int i , j , count = 0 , reuse = 1 , unflattened = 0 ; 
  DECL_RET_SAVE (Evt_Set * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(evt_set, 1), PUSH(iws, 2), PUSH(args, 3), PUSH(w, 4), PUSH(subset, 5), PUSH(ws, 6), PUSH(name, 7)));
# define XfOrM1039_COUNT (8)
# define SETUP_XfOrM1039(x) SETUP(XfOrM1039_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  w = NULLED_OUT ; 
  iws = NULLED_OUT ; 
  ws = NULLED_OUT ; 
  evt_set = NULLED_OUT ; 
  subset = NULLED_OUT ; 
  args = NULLED_OUT ; 

# 6908 "bc/src/thread.c"
  iws = ((Evt * * ) FUNCCALL(SETUP_XfOrM1039(_), GC_malloc (sizeof (Evt * ) * (argc - delta ) ) )) ; 


  for (i = 0 ; i < (argc - delta ) ; i ++ ) {
#   define XfOrM1061_COUNT (0+XfOrM1039_COUNT)
#   define SETUP_XfOrM1061(x) SETUP_XfOrM1039(x)

# 6912 "bc/src/thread.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [i + delta ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + delta ] ) ) -> type ) ) == (Scheme_Type ) (scheme_evt_set_type ) ) ) {
#     define XfOrM1066_COUNT (0+XfOrM1061_COUNT)
#     define SETUP_XfOrM1066(x) SETUP_XfOrM1061(x)

# 6913 "bc/src/thread.c"
      w = FUNCCALL(SETUP_XfOrM1066(_), find_evt (argv [i + delta ] ) ); 
      if (! w ) {
#       define XfOrM1067_COUNT (0+XfOrM1066_COUNT)
#       define SETUP_XfOrM1067(x) SETUP_XfOrM1066(x)
        FUNCCALL_EMPTY(scheme_wrong_contract (name , "evt?" , i + delta , argc , argv ) )
# 6915 "bc/src/thread.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      iws [i ] = w ; 
      count ++ ; 
    }

# 6920 "bc/src/thread.c"
    else if (flatten ) {
      int n ; 
#     define XfOrM1063_COUNT (0+XfOrM1061_COUNT)
#     define SETUP_XfOrM1063(x) SETUP_XfOrM1061(x)

# 6922 "bc/src/thread.c"
      if (((Scheme_Inclhash_Object * ) (argv [i + delta ] ) ) -> so . keyex & 0x1 )  {
#       define XfOrM1065_COUNT (0+XfOrM1063_COUNT)
#       define SETUP_XfOrM1065(x) SETUP_XfOrM1063(x)

# 6923 "bc/src/thread.c"
        n = FUNCCALL(SETUP_XfOrM1065(_), evt_set_flatten ((Evt_Set * ) argv [i + delta ] , 0 , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
      }

# 6924 "bc/src/thread.c"
      else {
        n = ((Evt_Set * ) argv [i + delta ] ) -> argc ; 
      }
      if (n != 1 )
        reuse = 0 ; 
      count += n ; 
    }

# 6930 "bc/src/thread.c"
    else {
      count ++ ; 
      unflattened = 1 ; 
    }
  }

  evt_set = ((Evt_Set * ) FUNCCALL(SETUP_XfOrM1039(_), GC_malloc_one_small_tagged ((((sizeof (Evt_Set ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  evt_set -> iso . so . type = scheme_evt_set_type ; 
  evt_set -> argc = count ; 
  if (unflattened )
    ((((Scheme_Inclhash_Object * ) (evt_set ) ) -> so . keyex |= 0x1 ) ) ; 

  if (reuse && (count == (argc - delta ) ) )
    ws = iws ; 
  else 
  ws = ((Evt * * ) FUNCCALL(SETUP_XfOrM1039(_), GC_malloc (sizeof (Evt * ) * (count ) ) )) ; 

  args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1039(_), GC_malloc (sizeof (Scheme_Object * ) * (count ) ) )) ; 
  for (i = delta , j = 0 ; i < argc ; i ++ , j ++ ) {
#   define XfOrM1047_COUNT (0+XfOrM1039_COUNT)
#   define SETUP_XfOrM1047(x) SETUP_XfOrM1039(x)

# 6949 "bc/src/thread.c"
    if (flatten && ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_evt_set_type ) ) ) {
#     define XfOrM1049_COUNT (0+XfOrM1047_COUNT)
#     define SETUP_XfOrM1049(x) SETUP_XfOrM1047(x)

# 6950 "bc/src/thread.c"
      if (((Scheme_Inclhash_Object * ) (argv [i ] ) ) -> so . keyex & 0x1 )  {
#       define XfOrM1053_COUNT (0+XfOrM1049_COUNT)
#       define SETUP_XfOrM1053(x) SETUP_XfOrM1049(x)

# 6951 "bc/src/thread.c"
        j = FUNCCALL(SETUP_XfOrM1053(_), evt_set_flatten ((Evt_Set * ) argv [i ] , j , args , ws ) ); 
        j -- ; 
      }

# 6953 "bc/src/thread.c"
      else {
        int k , n ; 
        subset = (Evt_Set * ) argv [i ] ; 
        n = subset -> argc ; 
        for (k = 0 ; k < n ; k ++ , j ++ ) {
          args [j ] = subset -> argv [k ] ; 
          ws [j ] = subset -> ws [k ] ; 
        }
        -- j ; 
      }
    }

# 6963 "bc/src/thread.c"
    else {
      ws [j ] = iws [i - delta ] ; 
      args [j ] = argv [i ] ; 
    }
  }

  evt_set -> ws = ws ; 
  evt_set -> argv = args ; 

  RET_VALUE_START (evt_set ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6975 "bc/src/thread.c"
Scheme_Object * scheme_make_evt_set (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6977 "bc/src/thread.c"
  return (Scheme_Object * ) make_evt_set ("internal-make-evt-set" , argc , argv , 0 , 1 ) ; 
}

static Scheme_Object * get_members (Scheme_Object * skip_nacks ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(skip_nacks, 0)));
# define XfOrM1069_COUNT (1)
# define SETUP_XfOrM1069(x) SETUP(XfOrM1069_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 6982 "bc/src/thread.c"
  if (! skip_nacks )
    RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
  else if ((scheme_list_length (skip_nacks ) ) > 5 ) {
    Scheme_Hash_Tree * ht ; 
    BLOCK_SETUP((PUSH(ht, 0+XfOrM1069_COUNT)));
#   define XfOrM1070_COUNT (1+XfOrM1069_COUNT)
#   define SETUP_XfOrM1070(x) SETUP(XfOrM1070_COUNT)
    ht = NULLED_OUT ; 

# 6986 "bc/src/thread.c"
    ht = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
    for (; ((Scheme_Type ) (((((intptr_t ) (skip_nacks ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (skip_nacks ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; skip_nacks = (((Scheme_Simple_Object * ) (skip_nacks ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM1072_COUNT (0+XfOrM1070_COUNT)
#     define SETUP_XfOrM1072(x) SETUP_XfOrM1070(x)

# 6988 "bc/src/thread.c"
      ht = FUNCCALL(SETUP_XfOrM1072(_), scheme_hash_tree_set (ht , (((Scheme_Simple_Object * ) (skip_nacks ) ) -> u . pair_val . car ) , scheme_true ) ); 
    }
    RET_VALUE_START ((Scheme_Object * ) ht ) RET_VALUE_END ; 
  }

# 6991 "bc/src/thread.c"
  else 
  RET_VALUE_START (skip_nacks ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6995 "bc/src/thread.c"
__xform_nongcing__ static int is_member (Scheme_Object * a , Scheme_Object * l ) 
{
  /* No conversion */

# 6997 "bc/src/thread.c"
  if ((((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) <= scheme_hash_tree_indirection_type ) )  {
    if (scheme_eq_hash_tree_get ((Scheme_Hash_Tree * ) l , a ) )
      return 1 ; 
  }

# 7000 "bc/src/thread.c"
  else {
    for (; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
      if ((a ) == ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) 
        return 1 ; 
    }
  }

  return 0 ; 
}

static void post_syncing_nacks (Syncing * syncing , int as_escape ) 

{
  int i , c ; 
  Scheme_Object * l , * syncs = ((void * ) 0 ) , * skip_nacks = ((void * ) 0 ) ; 
  Syncing * next ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(next, 0), PUSH(syncing, 1), PUSH(l, 2), PUSH(syncs, 3), PUSH(skip_nacks, 4)));
# define XfOrM1078_COUNT (5)
# define SETUP_XfOrM1078(x) SETUP(XfOrM1078_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = NULLED_OUT ; 
  next = NULLED_OUT ; 

# 7017 "bc/src/thread.c"
  do {
#   define XfOrM1105_COUNT (0+XfOrM1078_COUNT)
#   define SETUP_XfOrM1105(x) SETUP_XfOrM1078(x)

# 7018 "bc/src/thread.c"
    if (as_escape ) {
      Scheme_Thread * p = syncing -> thread ; 
      BLOCK_SETUP((PUSH(p, 0+XfOrM1105_COUNT)));
#     define XfOrM1129_COUNT (1+XfOrM1105_COUNT)
#     define SETUP_XfOrM1129(x) SETUP(XfOrM1129_COUNT)

# 7021 "bc/src/thread.c"
      syncing -> thread = ((void * ) 0 ) ; 

      if (p && p -> sync_box )
        FUNCCALL(SETUP_XfOrM1129(_), scheme_post_sema_all (p -> sync_box ) ); 


      if (p && p -> place_channel_msg_in_flight ) {
#       define XfOrM1130_COUNT (0+XfOrM1129_COUNT)
#       define SETUP_XfOrM1130(x) SETUP_XfOrM1129(x)
        FUNCCALL(SETUP_XfOrM1130(_), GC_destroy_orphan_msg_memory (p -> place_channel_msg_in_flight ) )
# 7028 "bc/src/thread.c"
        ; 
        p -> place_channel_msg_in_flight = ((void * ) 0 ) ; 
      }
    }


    if (syncing -> thread && syncing -> thread -> sync_box )
      syncing -> thread -> sync_box = ((void * ) 0 ) ; 

    if (syncing -> set ) {
#     define XfOrM1108_COUNT (0+XfOrM1105_COUNT)
#     define SETUP_XfOrM1108(x) SETUP_XfOrM1105(x)

# 7038 "bc/src/thread.c"
      c = syncing -> set -> argc ; 

      for (i = 0 ; i < c ; i ++ ) {
#       define XfOrM1119_COUNT (0+XfOrM1108_COUNT)
#       define SETUP_XfOrM1119(x) SETUP_XfOrM1108(x)

# 7041 "bc/src/thread.c"
        if ((Scheme_Type ) (((((intptr_t ) (syncing -> set -> argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (syncing -> set -> argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_syncer_type ) ) 
          FUNCCALL(SETUP_XfOrM1119(_), scheme_get_outof_line ((Scheme_Channel_Syncer * ) syncing -> set -> argv [i ] ) ); 
        else if ((Scheme_Type ) (((((intptr_t ) (syncing -> set -> argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (syncing -> set -> argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_active_replace_evt_type ) )  {
#         define XfOrM1127_COUNT (0+XfOrM1119_COUNT)
#         define SETUP_XfOrM1127(x) SETUP_XfOrM1119(x)

# 7045 "bc/src/thread.c"
          next = FUNCCALL(SETUP_XfOrM1127(_), scheme_replace_evt_nack (syncing -> set -> argv [i ] ) ); 
          if (next ) {
#           define XfOrM1128_COUNT (0+XfOrM1127_COUNT)
#           define SETUP_XfOrM1128(x) SETUP_XfOrM1127(x)

# 7047 "bc/src/thread.c"
            syncs = FUNCCALL(SETUP_XfOrM1128(_), scheme_make_raw_pair ((Scheme_Object * ) next , syncs ) ); 
            if ((i + 1 ) != syncing -> result )
              syncs = FUNCCALL(SETUP_XfOrM1128(_), scheme_make_raw_pair (scheme_true , syncs ) ); 
          }
        }

        if (syncing -> nackss ) {
#         define XfOrM1120_COUNT (0+XfOrM1119_COUNT)
#         define SETUP_XfOrM1120(x) SETUP_XfOrM1119(x)

# 7054 "bc/src/thread.c"
          if ((i + 1 ) != syncing -> result ) {
#           define XfOrM1121_COUNT (0+XfOrM1120_COUNT)
#           define SETUP_XfOrM1121(x) SETUP_XfOrM1120(x)

# 7055 "bc/src/thread.c"
            l = syncing -> nackss [i ] ; 
            if (l ) {
#             define XfOrM1122_COUNT (0+XfOrM1121_COUNT)
#             define SETUP_XfOrM1122(x) SETUP_XfOrM1121(x)

# 7057 "bc/src/thread.c"
              if (! skip_nacks ) {
#               define XfOrM1125_COUNT (0+XfOrM1122_COUNT)
#               define SETUP_XfOrM1125(x) SETUP_XfOrM1122(x)

# 7058 "bc/src/thread.c"
                if (syncing -> result ) {
#                 define XfOrM1126_COUNT (0+XfOrM1125_COUNT)
#                 define SETUP_XfOrM1126(x) SETUP_XfOrM1125(x)
                  skip_nacks = FUNCCALL(SETUP_XfOrM1126(_), get_members (syncing -> nackss [syncing -> result - 1 ] ) ); 
                }

# 7062 "bc/src/thread.c"
                else 
                skip_nacks = scheme_null ; 
              }
              for (; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#               define XfOrM1124_COUNT (0+XfOrM1122_COUNT)
#               define SETUP_XfOrM1124(x) SETUP_XfOrM1122(x)

# 7066 "bc/src/thread.c"
                if (! (is_member ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , skip_nacks ) ) )
                  FUNCCALL(SETUP_XfOrM1124(_), scheme_post_sema_all ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ); 
              }
            }
            syncing -> nackss [i ] = ((void * ) 0 ) ; 
          }
        }
      }
    }

    if (! syncs )
      syncing = ((void * ) 0 ) ; 
    else {
      if ((scheme_true ) == ((((Scheme_Simple_Object * ) (syncs ) ) -> u . pair_val . car ) ) )  {
        as_escape = 1 ; 
        syncs = (((Scheme_Simple_Object * ) (syncs ) ) -> u . pair_val . cdr ) ; 
      }

# 7082 "bc/src/thread.c"
      else 
      as_escape = 0 ; 

      syncing = (Syncing * ) (((Scheme_Simple_Object * ) (syncs ) ) -> u . pair_val . car ) ; 
      syncs = (((Scheme_Simple_Object * ) (syncs ) ) -> u . pair_val . cdr ) ; 
    }
  }

# 7088 "bc/src/thread.c"
  while (syncing ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7091 "bc/src/thread.c"
static void get_outof_or_into_lines (Syncing * syncing , int get_out ) 
{
  int i , c ; 
  Scheme_Object * syncs = ((void * ) 0 ) ; 
  Syncing * next ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(next, 0), PUSH(syncing, 1), PUSH(syncs, 2)));
# define XfOrM1131_COUNT (3)
# define SETUP_XfOrM1131(x) SETUP(XfOrM1131_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  next = NULLED_OUT ; 

# 7097 "bc/src/thread.c"
  if (syncing -> result ) {

    RET_NOTHING ; 
  }

  do {
#   define XfOrM1141_COUNT (0+XfOrM1131_COUNT)
#   define SETUP_XfOrM1141(x) SETUP_XfOrM1131(x)

# 7103 "bc/src/thread.c"
    if (syncing -> set ) {
#     define XfOrM1143_COUNT (0+XfOrM1141_COUNT)
#     define SETUP_XfOrM1143(x) SETUP_XfOrM1141(x)

# 7104 "bc/src/thread.c"
      c = syncing -> set -> argc ; 

      for (i = 0 ; i < c ; i ++ ) {
#       define XfOrM1147_COUNT (0+XfOrM1143_COUNT)
#       define SETUP_XfOrM1147(x) SETUP_XfOrM1143(x)

# 7107 "bc/src/thread.c"
        if ((Scheme_Type ) (((((intptr_t ) (syncing -> set -> argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (syncing -> set -> argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_syncer_type ) )  {
#         define XfOrM1149_COUNT (0+XfOrM1147_COUNT)
#         define SETUP_XfOrM1149(x) SETUP_XfOrM1147(x)

# 7108 "bc/src/thread.c"
          if (get_out )
            FUNCCALL(SETUP_XfOrM1149(_), scheme_get_outof_line ((Scheme_Channel_Syncer * ) syncing -> set -> argv [i ] ) ); 
          else FUNCCALL(SETUP_XfOrM1149(_), scheme_get_back_into_line ((Scheme_Channel_Syncer * ) syncing -> set -> argv [i ] ) )
          ; 
        }
        else if ((Scheme_Type ) (((((intptr_t ) (syncing -> set -> argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (syncing -> set -> argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_active_replace_evt_type ) )  {
#         define XfOrM1148_COUNT (0+XfOrM1147_COUNT)
#         define SETUP_XfOrM1148(x) SETUP_XfOrM1147(x)

# 7115 "bc/src/thread.c"
          next = FUNCCALL(SETUP_XfOrM1148(_), scheme_replace_evt_get (syncing -> set -> argv [i ] ) ); 
          if (next )
            syncs = FUNCCALL(SETUP_XfOrM1148(_), scheme_make_raw_pair ((Scheme_Object * ) next , syncs ) ); 
        }
      }
    }

    if (! syncs )
      syncing = ((void * ) 0 ) ; 
    else {
      syncing = (Syncing * ) (((Scheme_Simple_Object * ) (syncs ) ) -> u . pair_val . car ) ; 
      syncs = (((Scheme_Simple_Object * ) (syncs ) ) -> u . pair_val . cdr ) ; 
    }
  }

# 7128 "bc/src/thread.c"
  while (syncing ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7131 "bc/src/thread.c"
void scheme_post_syncing_nacks (Syncing * syncing ) 
{
  /* No conversion */

# 7133 "bc/src/thread.c"
  post_syncing_nacks (syncing , 0 ) ; 
}

void scheme_escape_during_sync (Syncing * syncing ) 
{
  /* No conversion */

# 7138 "bc/src/thread.c"
  post_syncing_nacks (syncing , 1 ) ; 
}

Scheme_Object * scheme_syncing_result (Syncing * syncing , int tailok ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
# define XfOrM1153_COUNT (0)
# define SETUP_XfOrM1153(x) SETUP(XfOrM1153_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 7143 "bc/src/thread.c"
  if (syncing -> result ) {

    Scheme_Object * o , * l , * a , * to_call = ((void * ) 0 ) , * args [1 ] , * * mv = ((void * ) 0 ) ; 
    int to_call_is_handle = 0 , rc = 1 ; 
    Scheme_Cont_Frame_Data cframe ; 
    BLOCK_SETUP((PUSH(to_call, 0+XfOrM1153_COUNT), PUSH(a, 1+XfOrM1153_COUNT), PUSH(l, 2+XfOrM1153_COUNT), PUSH(cframe.cache, 3+XfOrM1153_COUNT), PUSH(o, 4+XfOrM1153_COUNT), PUSHARRAY(args, 1, 5+XfOrM1153_COUNT), PUSH(mv, 8+XfOrM1153_COUNT)));
#   define XfOrM1154_COUNT (9+XfOrM1153_COUNT)
#   define SETUP_XfOrM1154(x) SETUP(XfOrM1154_COUNT)
    o = NULLED_OUT ; 
    l = NULLED_OUT ; 
    a = NULLED_OUT ; 
    args[0] = NULLED_OUT ; 
    cframe.cache = NULLED_OUT ; 

# 7149 "bc/src/thread.c"
    o = syncing -> set -> argv [syncing -> result - 1 ] ; 
    if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_channel_syncer_type ) )  {

      o = ((Scheme_Channel_Syncer * ) o ) -> obj ; 
    }
    if (syncing -> wrapss ) {
#     define XfOrM1155_COUNT (0+XfOrM1154_COUNT)
#     define SETUP_XfOrM1155(x) SETUP_XfOrM1154(x)

# 7155 "bc/src/thread.c"
      l = syncing -> wrapss [syncing -> result - 1 ] ; 
      if (l ) {
#       define XfOrM1156_COUNT (0+XfOrM1155_COUNT)
#       define SETUP_XfOrM1156(x) SETUP_XfOrM1155(x)

# 7157 "bc/src/thread.c"
        for (; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#         define XfOrM1173_COUNT (0+XfOrM1156_COUNT)
#         define SETUP_XfOrM1173(x) SETUP_XfOrM1156(x)

# 7158 "bc/src/thread.c"
          a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          if (to_call ) {
#           define XfOrM1178_COUNT (0+XfOrM1173_COUNT)
#           define SETUP_XfOrM1178(x) SETUP_XfOrM1173(x)

# 7160 "bc/src/thread.c"
            if (rc == 1 ) {
              mv = args ; 
              args [0 ] = o ; 
            }
            FUNCCALL(SETUP_XfOrM1178(_), scheme_push_break_enable (& cframe , 0 , 0 ) )

            ; 

            o = FUNCCALL(SETUP_XfOrM1178(_), scheme_apply_multi (to_call , rc , mv ) ); 

            if ((o ) == (((Scheme_Object * ) 0x6 ) ) )  {
#             define XfOrM1180_COUNT (0+XfOrM1178_COUNT)
#             define SETUP_XfOrM1180(x) SETUP_XfOrM1178(x)

# 7171 "bc/src/thread.c"
              rc = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ) ; 
              mv = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) ; 
              FUNCCALL(SETUP_XfOrM1180(_), scheme_detach_multple_array (mv ) ); 
            }

# 7174 "bc/src/thread.c"
            else {
              rc = 1 ; 
              mv = ((void * ) 0 ) ; 
            }
            FUNCCALL(SETUP_XfOrM1178(_), scheme_pop_break_enable (& cframe , 0 ) )
            ; 

            to_call = ((void * ) 0 ) ; 
          }
          if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || (! (((intptr_t ) (a ) ) & 0x1 ) && ((((a ) -> type ) >= scheme_prim_type ) && (((a ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
            if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) )  {
              a = (((Scheme_Small_Object * ) (a ) ) -> u . ptr_val ) ; 
              to_call_is_handle = 1 ; 
            }
            to_call = a ; 
          }

# 7189 "bc/src/thread.c"
          else if (((Scheme_Type ) (scheme_thread_suspend_type ) == (Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) ) 
          || ((Scheme_Type ) (scheme_thread_resume_type ) == (Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) ) ) {
            o = (((Scheme_Simple_Object * ) (a ) ) -> u . two_ptr_val . ptr2 ) ; 
            rc = 1 ; 
          }

# 7193 "bc/src/thread.c"
          else {
            o = a ; 
            rc = 1 ; 
          }
        }

        if (to_call ) {
#         define XfOrM1157_COUNT (0+XfOrM1156_COUNT)
#         define SETUP_XfOrM1157(x) SETUP_XfOrM1156(x)

# 7200 "bc/src/thread.c"
          if (rc == 1 ) {
            mv = args ; 
            args [0 ] = o ; 
          }



          if (! to_call_is_handle ) {
#           define XfOrM1162_COUNT (0+XfOrM1157_COUNT)
#           define SETUP_XfOrM1162(x) SETUP_XfOrM1157(x)
            FUNCCALL(SETUP_XfOrM1162(_), scheme_push_break_enable (& cframe , 0 , 0 ) )
# 7208 "bc/src/thread.c"
            ; 
            tailok = 0 ; 
          }

          if (tailok ) {
#           define XfOrM1161_COUNT (0+XfOrM1157_COUNT)
#           define SETUP_XfOrM1161(x) SETUP_XfOrM1157(x)

# 7213 "bc/src/thread.c"
            RET_VALUE_START (FUNCCALL(SETUP_XfOrM1161(_), scheme_tail_apply (to_call , rc , mv ) )) RET_VALUE_END ; 
          }

# 7214 "bc/src/thread.c"
          else {
#           define XfOrM1158_COUNT (0+XfOrM1157_COUNT)
#           define SETUP_XfOrM1158(x) SETUP_XfOrM1157(x)

# 7215 "bc/src/thread.c"
            o = FUNCCALL(SETUP_XfOrM1158(_), scheme_apply_multi (to_call , rc , mv ) ); 

            if ((o ) == (((Scheme_Object * ) 0x6 ) ) )  {
#             define XfOrM1160_COUNT (0+XfOrM1158_COUNT)
#             define SETUP_XfOrM1160(x) SETUP_XfOrM1158(x)

# 7218 "bc/src/thread.c"
              rc = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ) ; 
              mv = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) ; 
              FUNCCALL(SETUP_XfOrM1160(_), scheme_detach_multple_array (mv ) ); 
              if (! to_call_is_handle )
                FUNCCALL(SETUP_XfOrM1160(_), scheme_pop_break_enable (& cframe , 1 ) ); 
              RET_VALUE_START (FUNCCALL(SETUP_XfOrM1160(_), scheme_values (rc , mv ) )) RET_VALUE_END ; 
            }

# 7224 "bc/src/thread.c"
            else {
#             define XfOrM1159_COUNT (0+XfOrM1158_COUNT)
#             define SETUP_XfOrM1159(x) SETUP_XfOrM1158(x)

# 7225 "bc/src/thread.c"
              if (! to_call_is_handle )
                FUNCCALL(SETUP_XfOrM1159(_), scheme_pop_break_enable (& cframe , 1 ) ); 
              RET_VALUE_START (o ) RET_VALUE_END ; 
            }
          }
        }
      }
    }
    RET_VALUE_START (o ) RET_VALUE_END ; 
  }

# 7234 "bc/src/thread.c"
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7238 "bc/src/thread.c"
static Scheme_Object * do_sync (const char * name , int argc , Scheme_Object * argv [] , 
int with_break , int with_timeout , int _tailok ) 
{
  volatile int tailok = _tailok ; 
  Evt_Set * volatile evt_set ; 
  Syncing * volatile syncing ; 
  volatile float timeout = - 1.0 ; 
  double start_time ; 
  Scheme_Cont_Frame_Data cframe ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(name, 1), PUSH(syncing, 2), PUSH(evt_set, 3), PUSH(cframe.cache, 4)));
# define XfOrM1183_COUNT (5)
# define SETUP_XfOrM1183(x) SETUP(XfOrM1183_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  evt_set = NULLED_OUT ; 
  syncing = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 7248 "bc/src/thread.c"
  if (with_timeout ) {
#   define XfOrM1208_COUNT (0+XfOrM1183_COUNT)
#   define SETUP_XfOrM1208(x) SETUP_XfOrM1183(x)

# 7249 "bc/src/thread.c"
    if (! (((argv [0 ] ) ) == (scheme_false ) ) ) {
#     define XfOrM1209_COUNT (0+XfOrM1208_COUNT)
#     define SETUP_XfOrM1209(x) SETUP_XfOrM1208(x)

# 7250 "bc/src/thread.c"
      if ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) || ((((argv [0 ] ) -> type ) >= scheme_bignum_type ) && (((argv [0 ] ) -> type ) < scheme_complex_type ) ) ) 
        timeout = (float ) FUNCCALL(SETUP_XfOrM1209(_), scheme_real_to_double (argv [0 ] ) ); 
      else if (FUNCCALL(SETUP_XfOrM1209(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 0 , argc , argv ) ))
        timeout = 0.0 ; 

      if (timeout < 0.0 ) {
#       define XfOrM1210_COUNT (0+XfOrM1209_COUNT)
#       define SETUP_XfOrM1210(x) SETUP_XfOrM1209(x)
        FUNCCALL(SETUP_XfOrM1210(_), scheme_wrong_contract (name , "(>=/c 0.0)" , 0 , argc , argv ) )
# 7256 "bc/src/thread.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

      start_time = (rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
    }

# 7261 "bc/src/thread.c"
    else 
    start_time = 0 ; 
  }

# 7263 "bc/src/thread.c"
  else {
    start_time = 0 ; 
  }


  if (argc == (with_timeout + 1 ) && ! start_time && ((Scheme_Type ) (((((intptr_t ) (argv [with_timeout ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [with_timeout ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) ) {
#   define XfOrM1206_COUNT (0+XfOrM1183_COUNT)
#   define SETUP_XfOrM1206(x) SETUP_XfOrM1183(x)
    FUNCCALL(SETUP_XfOrM1206(_), scheme_wait_sema (argv [with_timeout ] , with_break ? - 1 : 0 ) )
# 7269 "bc/src/thread.c"
    ; 
    RET_VALUE_START (argv [with_timeout ] ) RET_VALUE_END ; 
  }

  evt_set = ((void * ) 0 ) ; 


  if ((argc == (with_timeout + 1 ) ) 
  && ((Scheme_Type ) (((((intptr_t ) (argv [with_timeout ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [with_timeout ] ) ) -> type ) ) == (Scheme_Type ) (scheme_evt_set_type ) ) 
  && ! (((Scheme_Inclhash_Object * ) (argv [with_timeout ] ) ) -> so . keyex & 0x1 ) ) {
    int i ; 
    evt_set = (Evt_Set * ) argv [with_timeout ] ; 
    for (i = evt_set -> argc ; i -- ; ) {
      if (evt_set -> ws [i ] -> can_redirect ) {

        evt_set = ((void * ) 0 ) ; 
        break ; 
      }
    }
  }

  if (! evt_set )
    evt_set = FUNCCALL(SETUP_XfOrM1183(_), make_evt_set (name , argc , argv , with_timeout , 1 ) ); 

  if (with_break ) {
#   define XfOrM1200_COUNT (0+XfOrM1183_COUNT)
#   define SETUP_XfOrM1200(x) SETUP_XfOrM1183(x)
    FUNCCALL(SETUP_XfOrM1200(_), scheme_push_break_enable (& cframe , 1 , 1 ) )
# 7294 "bc/src/thread.c"
    ; 
  }




  if (timeout < 0.0 ) {
    int i ; 
#   define XfOrM1194_COUNT (0+XfOrM1183_COUNT)
#   define SETUP_XfOrM1194(x) SETUP_XfOrM1183(x)

# 7302 "bc/src/thread.c"
    for (i = evt_set -> argc ; i -- ; ) {
      if (! ((Scheme_Type ) (((((intptr_t ) (evt_set -> argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (evt_set -> argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) )
        break ; 
    }
    if (i < 0 ) {
#     define XfOrM1195_COUNT (0+XfOrM1194_COUNT)
#     define SETUP_XfOrM1195(x) SETUP_XfOrM1194(x)

# 7308 "bc/src/thread.c"
      i = FUNCCALL(SETUP_XfOrM1195(_), scheme_wait_semas_chs (evt_set -> argc , evt_set -> argv , 0 , ((void * ) 0 ) ) ); 

      if (with_break ) {
#       define XfOrM1197_COUNT (0+XfOrM1195_COUNT)
#       define SETUP_XfOrM1197(x) SETUP_XfOrM1195(x)
        FUNCCALL(SETUP_XfOrM1197(_), scheme_pop_break_enable (& cframe , 1 ) )
# 7311 "bc/src/thread.c"
        ; 
      }

# 7312 "bc/src/thread.c"
      else {
#       define XfOrM1196_COUNT (0+XfOrM1195_COUNT)
#       define SETUP_XfOrM1196(x) SETUP_XfOrM1195(x)
        FUNCCALL(SETUP_XfOrM1196(_), scheme_check_break_now () ); 
      }

      if (i )
        RET_VALUE_START (evt_set -> argv [i - 1 ] ) RET_VALUE_END ; 
      else 
      RET_VALUE_START ((tailok ? scheme_false : ((void * ) 0 ) ) ) RET_VALUE_END ; 
    }
  }

  syncing = FUNCCALL(SETUP_XfOrM1183(_), make_syncing (evt_set , timeout , start_time ) ); 

  if (timeout < 0.0 )
    timeout = 0.0 ; 

  if (with_break ) {

    syncing -> disable_break = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  }

  {

# 7335 "bc/src/thread.c"
    mz_jmp_buf * volatile savebuf , newbuf ; 

# 7335 "bc/src/thread.c"
    Scheme_Thread * thread ; 
    BLOCK_SETUP((PUSH(savebuf, 0+XfOrM1183_COUNT), PUSH(thread, 1+XfOrM1183_COUNT)));
#   define XfOrM1189_COUNT (2+XfOrM1183_COUNT)
#   define SETUP_XfOrM1189(x) SETUP(XfOrM1189_COUNT)
    savebuf = NULLED_OUT ; 
    thread = NULLED_OUT ; 

# 7335 "bc/src/thread.c"
    thread = (scheme_get_current_thread () ) ; 
    FUNCCALL(SETUP_XfOrM1189(_), scheme_push_kill_action ((Scheme_Kill_Action_Func ) scheme_escape_during_sync , (void * ) syncing ) )
# 7335 "bc/src/thread.c"
    ; 

# 7335 "bc/src/thread.c"
    savebuf = thread -> error_buf ; 

# 7335 "bc/src/thread.c"
    thread -> error_buf = & newbuf ; 

# 7335 "bc/src/thread.c"
    thread = ((void * ) 0 ) ; 

# 7335 "bc/src/thread.c"
    if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM1189_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#     define XfOrM1191_COUNT (0+XfOrM1189_COUNT)
#     define SETUP_XfOrM1191(x) SETUP_XfOrM1189(x)
      FUNCCALL(SETUP_XfOrM1191(_), scheme_pop_kill_action () )
# 7335 "bc/src/thread.c"
      ; 

# 7335 "bc/src/thread.c"
      thread = (scheme_get_current_thread () ) ; 

# 7335 "bc/src/thread.c"
      if (! thread -> cjs . skip_dws ) {
#       define XfOrM1192_COUNT (0+XfOrM1191_COUNT)
#       define SETUP_XfOrM1192(x) SETUP_XfOrM1191(x)
        FUNCCALL(SETUP_XfOrM1192(_), scheme_escape_during_sync (syncing ) )
# 7335 "bc/src/thread.c"
        ; 
      }

# 7335 "bc/src/thread.c"
      (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
    }

# 7335 "bc/src/thread.c"
    else {
#     define XfOrM1190_COUNT (0+XfOrM1189_COUNT)
#     define SETUP_XfOrM1190(x) SETUP_XfOrM1189(x)

# 7335 "bc/src/thread.c"
      ; 
      FUNCCALL(SETUP_XfOrM1190(_), scheme_block_until ((Scheme_Ready_Fun ) syncing_ready , (Scheme_Needs_Wakeup_Fun ) scheme_syncing_needs_wakeup , (Scheme_Object * ) syncing , timeout ) )

      ; 
      thread = (scheme_get_current_thread () ) ; 
      FUNCCALL(SETUP_XfOrM1190(_), scheme_pop_kill_action () )
# 7339 "bc/src/thread.c"
      ; 

# 7339 "bc/src/thread.c"
      thread -> error_buf = savebuf ; 

# 7339 "bc/src/thread.c"
      thread = ((void * ) 0 ) ; 
    }
  }

# 7339 "bc/src/thread.c"
  ; 

  if (! syncing -> result )
    FUNCCALL(SETUP_XfOrM1183(_), scheme_post_syncing_nacks (syncing ) ); 

  if (with_break ) {
#   define XfOrM1188_COUNT (0+XfOrM1183_COUNT)
#   define SETUP_XfOrM1188(x) SETUP_XfOrM1183(x)
    FUNCCALL(SETUP_XfOrM1188(_), scheme_pop_break_enable (& cframe , 0 ) )
# 7345 "bc/src/thread.c"
    ; 
  }

  if (with_break ) {

    -- syncing -> disable_break -> suspend_break ; 
  }

  if (syncing -> result ) {
#   define XfOrM1186_COUNT (0+XfOrM1183_COUNT)
#   define SETUP_XfOrM1186(x) SETUP_XfOrM1183(x)

# 7354 "bc/src/thread.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1186(_), scheme_syncing_result (syncing , tailok ) )) RET_VALUE_END ; 
  }

# 7355 "bc/src/thread.c"
  else {
#   define XfOrM1184_COUNT (0+XfOrM1183_COUNT)
#   define SETUP_XfOrM1184(x) SETUP_XfOrM1183(x)

# 7356 "bc/src/thread.c"
    if (with_timeout && (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
#     define XfOrM1185_COUNT (0+XfOrM1184_COUNT)
#     define SETUP_XfOrM1185(x) SETUP_XfOrM1184(x)

# 7357 "bc/src/thread.c"
      if (tailok )
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM1185(_), scheme_tail_apply (argv [0 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_END ; 
      else 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1185(_), scheme_do_eval (argv [0 ] , 0 , ((void * ) 0 ) , 1 ) )) RET_VALUE_END ; 
    }

# 7361 "bc/src/thread.c"
    else if (tailok )
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7368 "bc/src/thread.c"
static Scheme_Object * sch_sync (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7370 "bc/src/thread.c"
  return do_sync ("sync" , argc , argv , 0 , 0 , 1 ) ; 
}

static Scheme_Object * sch_sync_timeout (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7375 "bc/src/thread.c"
  return do_sync ("sync/timeout" , argc , argv , 0 , 1 , 1 ) ; 
}

Scheme_Object * scheme_sync (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7380 "bc/src/thread.c"
  return do_sync ("sync" , argc , argv , 0 , 0 , 0 ) ; 
}

Scheme_Object * scheme_sync_timeout (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7385 "bc/src/thread.c"
  return do_sync ("sync/timeout" , argc , argv , 0 , 1 , 0 ) ; 
}

static Scheme_Object * do_scheme_sync_enable_break (const char * who , int with_timeout , int tailok , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * sema ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(sema, 1), PUSH(argv, 2)));
# define XfOrM1215_COUNT (3)
# define SETUP_XfOrM1215(x) SETUP(XfOrM1215_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 

# 7392 "bc/src/thread.c"
  if (with_timeout && (argc == 2 ) && (((argv [0 ] ) ) == (scheme_false ) ) && ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) )
    sema = argv [1 ] ; 
  else if (! with_timeout && (argc == 1 ) && ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) )
    sema = argv [0 ] ; 
  else 
  sema = ((void * ) 0 ) ; 

  if (sema ) {
#   define XfOrM1216_COUNT (0+XfOrM1215_COUNT)
#   define SETUP_XfOrM1216(x) SETUP_XfOrM1215(x)
    FUNCCALL(SETUP_XfOrM1216(_), scheme_wait_sema (sema , - 1 ) )
# 7400 "bc/src/thread.c"
    ; 
    RET_VALUE_START (sema ) RET_VALUE_END ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_sync (who , argc , argv , 1 , with_timeout , tailok ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7407 "bc/src/thread.c"
Scheme_Object * scheme_sync_enable_break (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7409 "bc/src/thread.c"
  return do_scheme_sync_enable_break ("sync/enable-break" , 0 , 0 , argc , argv ) ; 
}

static Scheme_Object * sch_sync_enable_break (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7414 "bc/src/thread.c"
  return do_scheme_sync_enable_break ("sync/enable-break" , 0 , 1 , argc , argv ) ; 
}

static Scheme_Object * sch_sync_timeout_enable_break (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7419 "bc/src/thread.c"
  return do_scheme_sync_enable_break ("sync/timeout/enable-break" , 1 , 1 , argc , argv ) ; 
}

static Scheme_Object * evts_to_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7424 "bc/src/thread.c"
  return (Scheme_Object * ) make_evt_set ("choice-evt" , argc , argv , 0 , 0 ) ; 
}





static Scheme_Object * unsafe_make_place_local (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7433 "bc/src/thread.c"
  return scheme_box (argv [0 ] ) ; 
}

static Scheme_Object * unsafe_place_local_ref (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7438 "bc/src/thread.c"
  return (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) ; 
}

static Scheme_Object * unsafe_place_local_set (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7443 "bc/src/thread.c"
  (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) = argv [1 ] ; 
  return scheme_void ; 
}







Scheme_Object * scheme_make_thread_cell (Scheme_Object * def_val , int inherited ) 
{
  Thread_Cell * c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(c, 0), PUSH(def_val, 1)));
# define XfOrM1224_COUNT (2)
# define SETUP_XfOrM1224(x) SETUP(XfOrM1224_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  c = NULLED_OUT ; 

# 7457 "bc/src/thread.c"
  c = ((Thread_Cell * ) FUNCCALL(SETUP_XfOrM1224(_), GC_malloc_one_small_tagged ((((sizeof (Thread_Cell ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  c -> so . type = scheme_thread_cell_type ; 
  c -> def_val = def_val ; 
  c -> inherited = ! ! inherited ; 

  RET_VALUE_START ((Scheme_Object * ) c ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7465 "bc/src/thread.c"
static Scheme_Object * do_thread_cell_get (Scheme_Object * cell , Scheme_Thread_Cell_Table * cells ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(cell, 1)));
# define XfOrM1225_COUNT (2)
# define SETUP_XfOrM1225(x) SETUP(XfOrM1225_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 7469 "bc/src/thread.c"
  if (((Thread_Cell * ) cell ) -> assigned ) {
#   define XfOrM1226_COUNT (0+XfOrM1225_COUNT)
#   define SETUP_XfOrM1226(x) SETUP_XfOrM1225(x)

# 7470 "bc/src/thread.c"
    v = FUNCCALL(SETUP_XfOrM1226(_), scheme_lookup_in_table (cells , (const char * ) cell ) ); 
    if (v )
      RET_VALUE_START ((scheme_ephemeron_value (v ) ) ) RET_VALUE_END ; 
  }

  RET_VALUE_START (((Thread_Cell * ) cell ) -> def_val ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7478 "bc/src/thread.c"
Scheme_Object * scheme_thread_cell_get (Scheme_Object * cell , Scheme_Thread_Cell_Table * cells ) 
{
  /* No conversion */

# 7480 "bc/src/thread.c"
  if (! ((Thread_Cell * ) cell ) -> assigned )
    return ((Thread_Cell * ) cell ) -> def_val ; 
  else 
  return do_thread_cell_get (cell , cells ) ; 
}

void scheme_thread_cell_set (Scheme_Object * cell , Scheme_Thread_Cell_Table * cells , Scheme_Object * v ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(cells, 1), PUSH(cell, 2)));
# define XfOrM1228_COUNT (3)
# define SETUP_XfOrM1228(x) SETUP(XfOrM1228_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 7488 "bc/src/thread.c"
  if (! ((Thread_Cell * ) cell ) -> assigned )
    ((Thread_Cell * ) cell ) -> assigned = 1 ; 
  v = FUNCCALL(SETUP_XfOrM1228(_), scheme_make_ephemeron (cell , v ) ); 
  FUNCCALL_EMPTY(scheme_add_to_table (cells , (const char * ) cell , (void * ) v , 0 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7494 "bc/src/thread.c"
Scheme_Thread_Cell_Table * scheme_empty_cell_table (void ) 
{
  /* No conversion */

# 7496 "bc/src/thread.c"
  return scheme_make_bucket_table (20 , SCHEME_hash_weak_ptr ) ; 
}

static Scheme_Thread_Cell_Table * inherit_cells (Scheme_Thread_Cell_Table * cells , 
Scheme_Thread_Cell_Table * t , 
int inherited ) 
{
  Scheme_Bucket * bucket ; 
  Scheme_Object * cell , * v ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Thread_Cell_Table * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(bucket, 0), PUSH(t, 1), PUSH(v, 2), PUSH(cells, 3), PUSH(cell, 4)));
# define XfOrM1230_COUNT (5)
# define SETUP_XfOrM1230(x) SETUP(XfOrM1230_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  bucket = NULLED_OUT ; 
  cell = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 7507 "bc/src/thread.c"
  if (! cells )
    cells = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values ; 

  if (! t )
    t = FUNCCALL(SETUP_XfOrM1230(_), scheme_empty_cell_table () ); 

  for (i = cells -> size ; i -- ; ) {
#   define XfOrM1234_COUNT (0+XfOrM1230_COUNT)
#   define SETUP_XfOrM1234(x) SETUP_XfOrM1230(x)

# 7514 "bc/src/thread.c"
    bucket = cells -> buckets [i ] ; 
    if (bucket && bucket -> val && bucket -> key ) {
#     define XfOrM1235_COUNT (0+XfOrM1234_COUNT)
#     define SETUP_XfOrM1235(x) SETUP_XfOrM1234(x)

# 7516 "bc/src/thread.c"
      cell = (Scheme_Object * ) (((Scheme_Small_Object * ) (bucket -> key ) ) -> u . ptr_val ) ; 
      if (cell && (((Thread_Cell * ) cell ) -> inherited == inherited ) ) {
#       define XfOrM1236_COUNT (0+XfOrM1235_COUNT)
#       define SETUP_XfOrM1236(x) SETUP_XfOrM1235(x)

# 7518 "bc/src/thread.c"
        v = (Scheme_Object * ) bucket -> val ; 
        FUNCCALL(SETUP_XfOrM1236(_), scheme_add_to_table (t , (char * ) cell , v , 0 ) ); 
      }
    }
  }

  RET_VALUE_START (t ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7527 "bc/src/thread.c"
Scheme_Thread_Cell_Table * scheme_inherit_cells (Scheme_Thread_Cell_Table * cells ) 
{
  /* No conversion */

# 7529 "bc/src/thread.c"
  return inherit_cells (cells , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * thread_cell_values (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM1238_COUNT (1)
# define SETUP_XfOrM1238(x) SETUP(XfOrM1238_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 7534 "bc/src/thread.c"
  if (argc == 1 ) {
    Scheme_Thread_Cell_Table * naya ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM1238_COUNT)));
#   define XfOrM1240_COUNT (1+XfOrM1238_COUNT)
#   define SETUP_XfOrM1240(x) SETUP(XfOrM1240_COUNT)
    naya = NULLED_OUT ; 

# 7537 "bc/src/thread.c"
    if (! ((Scheme_Type ) (scheme_thread_cell_values_type ) == (Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) ) {
#     define XfOrM1241_COUNT (0+XfOrM1240_COUNT)
#     define SETUP_XfOrM1241(x) SETUP_XfOrM1240(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("current-preserved-thread-cell-values" , "thread-cell-values?" , 0 , argc , argv ) )
# 7538 "bc/src/thread.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    naya = FUNCCALL(SETUP_XfOrM1240(_), inherit_cells (((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
    FUNCCALL(SETUP_XfOrM1240(_), inherit_cells ((Scheme_Thread_Cell_Table * ) (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) , naya , 1 ) ); 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values = naya ; 

    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }

# 7548 "bc/src/thread.c"
  else {
    Scheme_Object * o , * ht ; 
    BLOCK_SETUP((PUSH(o, 0+XfOrM1238_COUNT), PUSH(ht, 1+XfOrM1238_COUNT)));
#   define XfOrM1239_COUNT (2+XfOrM1238_COUNT)
#   define SETUP_XfOrM1239(x) SETUP(XfOrM1239_COUNT)
    o = NULLED_OUT ; 
    ht = NULLED_OUT ; 

# 7551 "bc/src/thread.c"
    ht = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM1239(_), inherit_cells (((void * ) 0 ) , ((void * ) 0 ) , 1 ) ); 

    o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM1239(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    o -> type = scheme_thread_cell_values_type ; 
    (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) = ht ; 

    RET_VALUE_START (o ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7561 "bc/src/thread.c"
static Scheme_Object * is_thread_cell_values (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7563 "bc/src/thread.c"
  return (((Scheme_Type ) (scheme_thread_cell_values_type ) == (Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * make_thread_cell (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7570 "bc/src/thread.c"
  return scheme_make_thread_cell (argv [0 ] , (argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) ; 
}

static Scheme_Object * thread_cell_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7575 "bc/src/thread.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_cell_type ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * thread_cell_get (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7582 "bc/src/thread.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_cell_type ) ) ) )
    scheme_wrong_contract ("thread-cell-ref" , "thread-cell?" , 0 , argc , argv ) ; 
  return scheme_thread_cell_get (argv [0 ] , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values ) ; 
}

static Scheme_Object * thread_cell_set (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7589 "bc/src/thread.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_cell_type ) ) ) )
    scheme_wrong_contract ("thread-cell-set!" , "thread-cell?" , 0 , argc , argv ) ; 
  scheme_thread_cell_set (argv [0 ] , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values , argv [1 ] ) ; 
  return scheme_void ; 
}






static int max_configs = __MZCONFIG_BUILTIN_COUNT__ ; 
static Scheme_Object * do_param (int argc , Scheme_Object * argv [] , Scheme_Object * self ) ; 

static Scheme_Config * config_fail () 
{
  /* No conversion */
  (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  return ((void * ) 0 ) ; 
}

Scheme_Config * scheme_current_config () 
{
  /* No conversion */

# 7612 "bc/src/thread.c"
  GC_CAN_IGNORE Scheme_Object * v ; 

  v = scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_parameterization_key ) ; 

  if (! ((Scheme_Type ) (scheme_config_type ) == (Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) ) ) {




    return config_fail () ; 
  }

  return (Scheme_Config * ) v ; 
}

static Scheme_Config * do_extend_config (Scheme_Config * c , Scheme_Object * key , Scheme_Object * val ) 
{
  Scheme_Config * naya ; 
  Scheme_Hash_Tree * ht ; 

# 7453 "bc/src/thread.c"
  Scheme_Object * __funcarg186 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Config * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(c, 1), PUSH(key, 2), PUSH(ht, 3), PUSH(naya, 4)));
# define XfOrM1250_COUNT (5)
# define SETUP_XfOrM1250(x) SETUP(XfOrM1250_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 
  ht = NULLED_OUT ; 

# 7637 "bc/src/thread.c"
  naya = ((Scheme_Config * ) FUNCCALL(SETUP_XfOrM1250(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Config ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  naya -> so . type = scheme_config_type ; 
  ht = (__funcarg186 = FUNCCALL(SETUP_XfOrM1250(_), scheme_make_thread_cell (val , 1 ) ), FUNCCALL_AGAIN(scheme_hash_tree_set (c -> ht , key , __funcarg186 ) )) ; 
  naya -> ht = ht ; 
  naya -> root = c -> root ; 

  RET_VALUE_START (naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7646 "bc/src/thread.c"
Scheme_Config * scheme_extend_config (Scheme_Config * c , int pos , Scheme_Object * init_val ) 
{
  /* No conversion */

# 7648 "bc/src/thread.c"
  return do_extend_config (c , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , init_val ) ; 
}

void scheme_install_config (Scheme_Config * config ) 
{
  /* No conversion */

# 7653 "bc/src/thread.c"
  scheme_set_cont_mark (scheme_parameterization_key , (Scheme_Object * ) config ) ; 
}

Scheme_Object * find_param_cell (Scheme_Config * c , Scheme_Object * k , int force_cell ) 
{
  /* No conversion */

# 7658 "bc/src/thread.c"
  Scheme_Object * v ; 
  Scheme_Parameterization * p ; 

  v = scheme_eq_hash_tree_get (c -> ht , k ) ; 
  if (v )
    return v ; 

  p = c -> root ; 
  if (((intptr_t ) (k ) ) & 0x1 ) 
    return p -> prims [(((intptr_t ) (k ) ) >> 1 ) ] ; 
  else {
    if (p -> extensions )
      return scheme_lookup_in_table (p -> extensions , (const char * ) k ) ; 
    else 
    return ((void * ) 0 ) ; 
  }
}

Scheme_Object * scheme_get_thread_param (Scheme_Config * c , Scheme_Thread_Cell_Table * cells , int pos ) 
{
  Scheme_Object * cell ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cells, 0), PUSH(cell, 1)));
# define XfOrM1255_COUNT (2)
# define SETUP_XfOrM1255(x) SETUP(XfOrM1255_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cell = NULLED_OUT ; 

# 7680 "bc/src/thread.c"
  cell = FUNCCALL(SETUP_XfOrM1255(_), find_param_cell (c , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , 0 ) ); 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_thread_cell_get (cell , cells ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7684 "bc/src/thread.c"
Scheme_Object * scheme_get_param (Scheme_Config * c , int pos ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(c, 0)));
# define XfOrM1256_COUNT (1)
# define SETUP_XfOrM1256(x) SETUP(XfOrM1256_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 7686 "bc/src/thread.c"
  if (pos == MZCONFIG_ENV )
    RET_VALUE_START ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM1256(_), scheme_get_current_namespace_as_env () )) RET_VALUE_END ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_get_thread_param (c , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values , pos ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7692 "bc/src/thread.c"
void scheme_set_thread_param (Scheme_Config * c , Scheme_Thread_Cell_Table * cells , int pos , Scheme_Object * o ) 
{

# 7656 "bc/src/thread.c"
  Scheme_Object * __funcarg187 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(cells, 1)));
# define XfOrM1257_COUNT (2)
# define SETUP_XfOrM1257(x) SETUP(XfOrM1257_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  (__funcarg187 = FUNCCALL(SETUP_XfOrM1257(_), find_param_cell (c , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , 1 ) )
# 7694 "bc/src/thread.c"
  , FUNCCALL_AGAIN(scheme_thread_cell_set (__funcarg187 , cells , o ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7697 "bc/src/thread.c"
void scheme_set_param (Scheme_Config * c , int pos , Scheme_Object * o ) 
{

# 7656 "bc/src/thread.c"
  Scheme_Object * __funcarg188 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(c, 0), PUSH(o, 1)));
# define XfOrM1258_COUNT (2)
# define SETUP_XfOrM1258(x) SETUP(XfOrM1258_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 7699 "bc/src/thread.c"
  if (pos == MZCONFIG_ENV ) {
#   define XfOrM1259_COUNT (0+XfOrM1258_COUNT)
#   define SETUP_XfOrM1259(x) SETUP_XfOrM1258(x)
    FUNCCALL(SETUP_XfOrM1259(_), scheme_set_current_namespace_as_env ((Scheme_Env * ) o ) )
# 7700 "bc/src/thread.c"
    ; 
    RET_NOTHING ; 
  }
  (__funcarg188 = FUNCCALL(SETUP_XfOrM1258(_), find_param_cell (c , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , 1 ) )
  , FUNCCALL_AGAIN(scheme_thread_cell_set (__funcarg188 , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values , o ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7708 "bc/src/thread.c"
static Scheme_Parameterization * malloc_paramz () 
{
  /* No conversion */

# 7710 "bc/src/thread.c"
  return (Scheme_Parameterization * ) GC_malloc_one_tagged (sizeof (Scheme_Parameterization ) + 
  (max_configs - 0 ) * sizeof (Scheme_Object * ) ) ; 
}

void scheme_flatten_config (Scheme_Config * orig_c ) 
{
  /* No conversion */
}
static Scheme_Object * parameterization_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7720 "bc/src/thread.c"
  Scheme_Object * v = argv [0 ] ; 

  return (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_config_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}






Scheme_Object * scheme_extend_parameterization (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * key , * a [2 ] , * param ; 
  Scheme_Config * c ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(c, 1), PUSH(key, 2), PUSH(param, 3), PUSHARRAY(a, 2, 4)));
# define XfOrM1263_COUNT (7)
# define SETUP_XfOrM1263(x) SETUP(XfOrM1263_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  key = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  param = NULLED_OUT ; 
  c = NULLED_OUT ; 

# 7738 "bc/src/thread.c"
  c = (Scheme_Config * ) argv [0 ] ; 

  if (argc < 2 ) {
#   define XfOrM1287_COUNT (0+XfOrM1263_COUNT)
#   define SETUP_XfOrM1287(x) SETUP_XfOrM1263(x)
    FUNCCALL(SETUP_XfOrM1287(_), scheme_flatten_config (c ) )
# 7741 "bc/src/thread.c"
    ; 
  }

# 7742 "bc/src/thread.c"
  else if (((Scheme_Type ) (((((intptr_t ) (c ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (c ) ) -> type ) ) == (Scheme_Type ) (scheme_config_type ) ) && (argc & 1 ) ) {
#   define XfOrM1264_COUNT (0+XfOrM1263_COUNT)
#   define SETUP_XfOrM1264(x) SETUP_XfOrM1263(x)

# 7743 "bc/src/thread.c"
    for (i = 1 ; i < argc ; i += 2 ) {
#     define XfOrM1276_COUNT (0+XfOrM1264_COUNT)
#     define SETUP_XfOrM1276(x) SETUP_XfOrM1264(x)

# 7744 "bc/src/thread.c"
      param = argv [i ] ; 
      if (! ((((Scheme_Type ) (((((intptr_t ) (param ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (param ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) || ((Scheme_Type ) (((((intptr_t ) (param ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (param ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) ) && ((((Scheme_Primitive_Proc * ) param ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 64 ) ) 
      && ! ((((Scheme_Type ) (((((intptr_t ) (param ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (param ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (param ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (param ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && ((((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) param ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) param ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) param ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) param ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) ) && ((((Scheme_Primitive_Proc * ) (((Scheme_Chaperone * ) param ) -> val ) ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 64 ) ) ) ) {
#       define XfOrM1286_COUNT (0+XfOrM1276_COUNT)
#       define SETUP_XfOrM1286(x) SETUP_XfOrM1276(x)

# 7747 "bc/src/thread.c"
        a [0 ] = param ; 
        FUNCCALL(SETUP_XfOrM1286(_), scheme_wrong_contract ("parameterize" , "parameter?" , - 2 , 1 , a ) ); 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      key = argv [i + 1 ] ; 
      if (((Scheme_Type ) (((((intptr_t ) (param ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (param ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (param ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (param ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
#       define XfOrM1285_COUNT (0+XfOrM1276_COUNT)
#       define SETUP_XfOrM1285(x) SETUP_XfOrM1276(x)

# 7753 "bc/src/thread.c"
        a [0 ] = key ; 
        key = FUNCCALL(SETUP_XfOrM1285(_), scheme_apply_chaperone (param , 1 , a , scheme_void , 0x3 ) ); 
        param = (((Scheme_Chaperone * ) param ) -> val ) ; 
      }
      a [0 ] = key ; 
      a [1 ] = scheme_false ; 
      while (1 ) {
#       define XfOrM1281_COUNT (0+XfOrM1276_COUNT)
#       define SETUP_XfOrM1281(x) SETUP_XfOrM1276(x)

# 7760 "bc/src/thread.c"
        if (! (((Scheme_Primitive_Proc * ) param ) -> pp . flags & 16 ) ) {
          Scheme_Prim * proc ; 
#         define XfOrM1284_COUNT (0+XfOrM1281_COUNT)
#         define SETUP_XfOrM1284(x) SETUP_XfOrM1281(x)
          proc = NULLED_OUT ; 

# 7762 "bc/src/thread.c"
          proc = (Scheme_Prim * ) ((Scheme_Primitive_Proc * ) param ) -> prim_val ; 
          key = FUNCCALL(SETUP_XfOrM1284(_), proc (2 , a ) ); 
          break ; 
        }

# 7765 "bc/src/thread.c"
        else {
#         define XfOrM1282_COUNT (0+XfOrM1281_COUNT)
#         define SETUP_XfOrM1282(x) SETUP_XfOrM1281(x)

# 7767 "bc/src/thread.c"
          key = FUNCCALL(SETUP_XfOrM1282(_), do_param (2 , a , param ) ); 
          if ((((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) || ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) ) && ((((Scheme_Primitive_Proc * ) key ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 64 ) )  {
            param = key ; 
            a [0 ] = a [1 ] ; 
          }

# 7771 "bc/src/thread.c"
          else 
          break ; 
        }
      }
      c = FUNCCALL(SETUP_XfOrM1276(_), do_extend_config (c , key , a [1 ] ) ); 
    }
  }

  RET_VALUE_START ((Scheme_Object * ) c ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7782 "bc/src/thread.c"
static Scheme_Object * reparameterize (int argc , Scheme_Object * * argv ) 
{



  Scheme_Config * c , * naya ; 
  Scheme_Parameterization * pz , * npz ; 
  Scheme_Object * v ; 
  Scheme_Hash_Tree * ht ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(c, 1), PUSH(ht, 2), PUSH(npz, 3), PUSH(pz, 4), PUSH(naya, 5)));
# define XfOrM1288_COUNT (6)
# define SETUP_XfOrM1288(x) SETUP(XfOrM1288_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  c = NULLED_OUT ; 
  naya = NULLED_OUT ; 
  pz = NULLED_OUT ; 
  npz = NULLED_OUT ; 
  v = NULLED_OUT ; 
  ht = NULLED_OUT ; 

# 7793 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_config_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("reparameterize" , "parameterization?" , 0 , argc , argv ) ); 

  c = (Scheme_Config * ) argv [0 ] ; 
  FUNCCALL(SETUP_XfOrM1288(_), scheme_flatten_config (c ) ); 

  pz = c -> root ; 
  npz = FUNCCALL(SETUP_XfOrM1288(_), malloc_paramz () ); 
  (memcpy (npz , pz , sizeof (Scheme_Parameterization ) ) ) ; 

  naya = ((Scheme_Config * ) FUNCCALL(SETUP_XfOrM1288(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Config ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  naya -> so . type = scheme_config_type ; 
  ht = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
  naya -> ht = ht ; 
  naya -> root = npz ; 

  for (i = 0 ; i < max_configs ; i ++ ) {
#   define XfOrM1290_COUNT (0+XfOrM1288_COUNT)
#   define SETUP_XfOrM1290(x) SETUP_XfOrM1288(x)

# 7810 "bc/src/thread.c"
    v = FUNCCALL(SETUP_XfOrM1290(_), scheme_thread_cell_get (pz -> prims [i ] , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values ) ); 
    v = FUNCCALL(SETUP_XfOrM1290(_), scheme_make_thread_cell (v , 1 ) ); 
    npz -> prims [i ] = v ; 
  }

  RET_VALUE_START ((Scheme_Object * ) naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7818 "bc/src/thread.c"
int scheme_is_parameter (Scheme_Object * v ) 
{
  /* No conversion */

# 7820 "bc/src/thread.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 7820 "bc/src/thread.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  return ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 64 ) ) ; 
}

static Scheme_Object * parameter_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7827 "bc/src/thread.c"
  return (scheme_is_parameter (argv [0 ] ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * do_param (int argc , Scheme_Object * argv [] , Scheme_Object * self ) 
{
  Scheme_Object * guard , * * argv2 , * pos [2 ] ; 
  ParamData * data = (ParamData * ) ((Scheme_Primitive_Closure * ) self ) -> val [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSHARRAY(pos, 2, 1), PUSH(argv2, 4), PUSH(data, 5)));
# define XfOrM1293_COUNT (6)
# define SETUP_XfOrM1293(x) SETUP(XfOrM1293_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  guard = NULLED_OUT ; 
  argv2 = NULLED_OUT ; 
  pos[0] = NULLED_OUT ; 
  pos[1] = NULLED_OUT ; 

# 7837 "bc/src/thread.c"
  if (argc && argv [0 ] ) {
#   define XfOrM1297_COUNT (0+XfOrM1293_COUNT)
#   define SETUP_XfOrM1297(x) SETUP_XfOrM1293(x)

# 7838 "bc/src/thread.c"
    guard = data -> guard ; 
    if (guard ) {
      Scheme_Object * v ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM1297_COUNT)));
#     define XfOrM1299_COUNT (1+XfOrM1297_COUNT)
#     define SETUP_XfOrM1299(x) SETUP(XfOrM1299_COUNT)
      v = NULLED_OUT ; 

# 7842 "bc/src/thread.c"
      v = FUNCCALL(SETUP_XfOrM1299(_), scheme_apply (guard , 1 , argv ) ); 

      if (argc == 2 ) {

        argv [1 ] = v ; 
        RET_VALUE_START (data -> key ) RET_VALUE_END ; 
      }

      argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1299(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
      (memcpy (argv2 , argv , argc * sizeof (Scheme_Object * ) ) ) ; 
      argv2 [0 ] = v ; 
    }

# 7853 "bc/src/thread.c"
    else if (argc == 2 ) {

      argv [1 ] = argv [0 ] ; 
      RET_VALUE_START (data -> key ) RET_VALUE_END ; 
    }

# 7857 "bc/src/thread.c"
    else 
    argv2 = argv ; 
  }

# 7859 "bc/src/thread.c"
  else 
  argv2 = argv ; 

  if (data -> is_derived ) {
#   define XfOrM1294_COUNT (0+XfOrM1293_COUNT)
#   define SETUP_XfOrM1294(x) SETUP_XfOrM1293(x)

# 7863 "bc/src/thread.c"
    if (! argc ) {
      Scheme_Object * v ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM1294_COUNT)));
#     define XfOrM1296_COUNT (1+XfOrM1294_COUNT)
#     define SETUP_XfOrM1296(x) SETUP(XfOrM1296_COUNT)
      v = NULLED_OUT ; 

# 7865 "bc/src/thread.c"
      v = FUNCCALL(SETUP_XfOrM1296(_), scheme_do_eval (data -> key , argc , argv2 , 1 ) ); 
      pos [0 ] = v ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1296(_), scheme_tail_apply (data -> extract_guard , 1 , pos ) )) RET_VALUE_END ; 
    }

# 7868 "bc/src/thread.c"
    else {
#     define XfOrM1295_COUNT (0+XfOrM1294_COUNT)
#     define SETUP_XfOrM1295(x) SETUP_XfOrM1294(x)

# 7869 "bc/src/thread.c"
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1295(_), scheme_tail_apply (data -> key , argc , argv2 ) )) RET_VALUE_END ; 
    }
  }

  pos [0 ] = data -> key ; 
  pos [1 ] = data -> defcell ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1293(_), scheme_param_config ("parameter-procedure" , (Scheme_Object * ) (void * ) pos , argc , argv2 , - 2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) )) RET_VALUE_END 


  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7882 "bc/src/thread.c"
static Scheme_Object * extract_param (Scheme_Config * config , Scheme_Object * key , Scheme_Object * defcell ) 
{
  Scheme_Object * cell ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(defcell, 0), PUSH(cell, 1)));
# define XfOrM1301_COUNT (2)
# define SETUP_XfOrM1301(x) SETUP(XfOrM1301_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cell = NULLED_OUT ; 

# 7886 "bc/src/thread.c"
  cell = FUNCCALL(SETUP_XfOrM1301(_), find_param_cell (config , key , 0 ) ); 
  if (! cell )
    cell = defcell ; 

  if (((Scheme_Type ) (((((intptr_t ) (cell ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cell ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_cell_type ) ) ) 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_thread_cell_get (cell , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (cell ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7896 "bc/src/thread.c"
static Scheme_Object * do_param_fast (int argc , Scheme_Object * argv [] , Scheme_Object * self ) 
{
  ParamData * data = (ParamData * ) ((Scheme_Primitive_Closure * ) self ) -> val [0 ] ; 

# 7610 "bc/src/thread.c"
  Scheme_Config * __funcarg189 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(self, 1), PUSH(data, 2)));
# define XfOrM1302_COUNT (3)
# define SETUP_XfOrM1302(x) SETUP(XfOrM1302_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 7900 "bc/src/thread.c"
  if (! argc && ! data -> is_derived )
    RET_VALUE_START ((__funcarg189 = FUNCCALL(SETUP_XfOrM1302(_), scheme_current_config () ), FUNCCALL_EMPTY(extract_param (__funcarg189 , data -> key , data -> defcell ) )) ) RET_VALUE_END ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_param (argc , argv , self ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7906 "bc/src/thread.c"
static Scheme_Object * make_parameter (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * p , * cell , * a [2 ] , * realm = scheme_default_realm ; 
  ParamData * data ; 
  void * k ; 
  const char * name ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSHARRAY(a, 2, 1), PUSH(k, 4), PUSH(data, 5), PUSH(p, 6), PUSH(name, 7), PUSH(realm, 8), PUSH(cell, 9)));
# define XfOrM1303_COUNT (10)
# define SETUP_XfOrM1303(x) SETUP(XfOrM1303_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  cell = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  data = NULLED_OUT ; 
  k = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 7913 "bc/src/thread.c"
  k = FUNCCALL(SETUP_XfOrM1303(_), scheme_make_pair (scheme_true , scheme_false ) ); 

  if (argc > 1 )
    FUNCCALL(SETUP_XfOrM1303(_), scheme_check_proc_arity2 ("make-parameter" , 1 , 1 , argc , argv , 1 ) ); 
  if (argc > 2 ) {
#   define XfOrM1304_COUNT (0+XfOrM1303_COUNT)
#   define SETUP_XfOrM1304(x) SETUP_XfOrM1303(x)

# 7918 "bc/src/thread.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL(SETUP_XfOrM1304(_), scheme_wrong_contract ("make-parameter" , "parameter?" , 2 , argc , argv ) ); 
    name = FUNCCALL(SETUP_XfOrM1304(_), scheme_symbol_val (argv [2 ] ) ); 
    if (argc > 3 ) {
#     define XfOrM1305_COUNT (0+XfOrM1304_COUNT)
#     define SETUP_XfOrM1305(x) SETUP_XfOrM1304(x)

# 7922 "bc/src/thread.c"
      realm = argv [3 ] ; 
      if (! ((Scheme_Type ) (((((intptr_t ) (realm ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (realm ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
        FUNCCALL(SETUP_XfOrM1305(_), scheme_wrong_contract ("make-parameter" , "parameter?" , 3 , argc , argv ) ); 
    }
  }

# 7926 "bc/src/thread.c"
  else 
  name = "parameter-procedure" ; 

  data = ((ParamData * ) FUNCCALL(SETUP_XfOrM1303(_), GC_malloc_one_small_tagged ((((sizeof (ParamData ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  data -> type = scheme_rt_param_data ; 

  data -> key = (Scheme_Object * ) k ; 
  cell = FUNCCALL(SETUP_XfOrM1303(_), scheme_make_thread_cell (argv [0 ] , 1 ) ); 
  data -> defcell = cell ; 
  data -> guard = (((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) ? argv [1 ] : ((void * ) 0 ) ) ; 

  a [0 ] = (Scheme_Object * ) data ; 
  a [1 ] = realm ; 
  p = FUNCCALL(SETUP_XfOrM1303(_), scheme_make_prim_closure_w_arity (do_param_fast , 2 , a , name , 0 , 1 ) )
  ; 
  ((Scheme_Primitive_Proc * ) p ) -> pp . flags |= 64 ; 

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7947 "bc/src/thread.c"
static Scheme_Object * make_derived_parameter (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * p , * a [2 ] , * realm = scheme_default_realm ; 
  ParamData * data ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSHARRAY(a, 2, 1), PUSH(realm, 4), PUSH(p, 5), PUSH(data, 6)));
# define XfOrM1306_COUNT (7)
# define SETUP_XfOrM1306(x) SETUP(XfOrM1306_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  data = NULLED_OUT ; 

# 7952 "bc/src/thread.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) ) && ((((Scheme_Primitive_Proc * ) argv [0 ] ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 64 ) ) )
    FUNCCALL(SETUP_XfOrM1306(_), scheme_wrong_contract ("make-derived-parameter" , "(and/c parameter? (not/c impersonator?))" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM1306(_), scheme_check_proc_arity ("make-derived-parameter" , 1 , 1 , argc , argv ) )
  ; 
  FUNCCALL_AGAIN(scheme_check_proc_arity ("make-derived-parameter" , 1 , 2 , argc , argv ) ); 

  data = ((ParamData * ) FUNCCALL(SETUP_XfOrM1306(_), GC_malloc_one_small_tagged ((((sizeof (ParamData ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  data -> type = scheme_rt_param_data ; 

  data -> is_derived = 1 ; 
  data -> key = argv [0 ] ; 
  data -> guard = argv [1 ] ; 
  data -> extract_guard = argv [2 ] ; 

  a [0 ] = (Scheme_Object * ) data ; 
  a [1 ] = realm ; 
  p = FUNCCALL(SETUP_XfOrM1306(_), scheme_make_prim_closure_w_arity (do_param , 2 , a , "parameter-procedure" , 0 , 1 ) )
  ; 
  ((Scheme_Primitive_Proc * ) p ) -> pp . flags |= 64 ; 

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7976 "bc/src/thread.c"
static Scheme_Object * parameter_procedure_eq (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7978 "bc/src/thread.c"
  Scheme_Object * a , * b ; 

  a = argv [0 ] ; 
  b = argv [1 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 7983 "bc/src/thread.c"
  a = (((Scheme_Chaperone * ) a ) -> val ) ; 
  if (((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 7984 "bc/src/thread.c"
  b = (((Scheme_Chaperone * ) b ) -> val ) ; 

  if (! ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) ) && ((((Scheme_Primitive_Proc * ) a ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 64 ) ) )
    scheme_wrong_contract ("parameter-procedure=?" , "parameter?" , 0 , argc , argv ) ; 
  if (! ((((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) || ((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) ) && ((((Scheme_Primitive_Proc * ) b ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == 64 ) ) )
    scheme_wrong_contract ("parameter-procedure=?" , "parameter?" , 1 , argc , argv ) ; 

  return (((a ) == (b ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

void scheme_set_command_line_arguments (Scheme_Object * vec ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(vec, 0)));
# define XfOrM1308_COUNT (1)
# define SETUP_XfOrM1308(x) SETUP(XfOrM1308_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 7998 "bc/src/thread.c"
  if (! initial_cmdline_vec )
    FUNCCALL(SETUP_XfOrM1308(_), scheme_register_static ((void * ) & initial_cmdline_vec , sizeof (initial_cmdline_vec ) ) ); 
  initial_cmdline_vec = vec ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8003 "bc/src/thread.c"
int scheme_new_param (void ) 
{
  /* No conversion */

# 8005 "bc/src/thread.c"
  return max_configs ++ ; 
}

static void init_param (Scheme_Thread_Cell_Table * cells , 
Scheme_Parameterization * params , 
int pos , 
Scheme_Object * v ) 
{
  Scheme_Object * cell ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cell, 0), PUSH(params, 1)));
# define XfOrM1310_COUNT (2)
# define SETUP_XfOrM1310(x) SETUP(XfOrM1310_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cell = NULLED_OUT ; 

# 8014 "bc/src/thread.c"
  cell = FUNCCALL(SETUP_XfOrM1310(_), scheme_make_thread_cell (v , 1 ) ); 
  params -> prims [pos ] = cell ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8018 "bc/src/thread.c"
void scheme_set_root_param (int p , Scheme_Object * v ) 
{
  /* No conversion */

# 8020 "bc/src/thread.c"
  Scheme_Parameterization * paramz ; 
  paramz = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> init_config -> root ; 
  ((Thread_Cell * ) (paramz -> prims [p ] ) ) -> def_val = v ; 
}

static void make_initial_config (Scheme_Thread * p ) 
{
  Scheme_Thread_Cell_Table * cells ; 
  Scheme_Parameterization * paramz ; 
  Scheme_Config * config ; 
  char * __funcarg193 = NULLED_OUT ; 
  uintptr_t __funcarg192 ; 
  uintptr_t __funcarg191 ; 
  Scheme_Object * __funcarg190 = NULLED_OUT ; 
  PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(paramz, 1), PUSH(config, 2), PUSH(cells, 3)));
# define XfOrM1312_COUNT (4)
# define SETUP_XfOrM1312(x) SETUP(XfOrM1312_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cells = NULLED_OUT ; 
  paramz = NULLED_OUT ; 
  config = NULLED_OUT ; 

# 8031 "bc/src/thread.c"
  cells = FUNCCALL(SETUP_XfOrM1312(_), scheme_make_bucket_table (5 , SCHEME_hash_weak_ptr ) ); 
  p -> cell_values = cells ; 

  paramz = FUNCCALL(SETUP_XfOrM1312(_), malloc_paramz () ); 

  paramz -> type = scheme_rt_parameterization ; 


  config = ((Scheme_Config * ) FUNCCALL(SETUP_XfOrM1312(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Config ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  config -> so . type = scheme_config_type ; 
  config -> root = paramz ; 
  {
    Scheme_Hash_Tree * ht ; 
#   define XfOrM1329_COUNT (0+XfOrM1312_COUNT)
#   define SETUP_XfOrM1329(x) SETUP_XfOrM1312(x)
    ht = NULLED_OUT ; 

# 8044 "bc/src/thread.c"
    ht = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
    config -> ht = ht ; 
  }

  p -> init_config = config ; 
  FUNCCALL(SETUP_XfOrM1312(_), init_param (cells , paramz , MZCONFIG_CASE_SENS , (scheme_case_sensitive ? scheme_true : scheme_false ) ) )
  ; 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_CAN_READ_PIPE_QUOTE , scheme_true ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_LOAD_DELAY_ENABLED , scheme_init_load_on_demand ? scheme_true : scheme_false ) )
  ; 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_DELAY_LOAD_INFO , scheme_false ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_GRAPH , scheme_false ) )
  ; 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_STRUCT , scheme_true ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_BOX , scheme_true ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_VEC_SHORTHAND , scheme_false ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_HASH_TABLE , scheme_true ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_UNREADABLE , scheme_true ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_PAIR_CURLY , scheme_false ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_MPAIR_CURLY , scheme_true ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_READER , scheme_false ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_LONG_BOOLEAN , scheme_false ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_AS_QQ , scheme_true ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_SYNTAX_WIDTH , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (256 ) ) ) << 1 ) | 0x1 ) ) ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_COMPILE_MODULE_CONSTS , scheme_true ) )
  ; 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_USE_JIT , scheme_startup_use_jit ? scheme_true : scheme_false ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_COMPILE_TARGET_MACHINE , scheme_startup_compile_machine_independent ? scheme_false : racket_symbol ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_COMPILE_REALM , scheme_default_realm ) ); 

  {
    Scheme_Object * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM1312_COUNT)));
#   define XfOrM1328_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1328(x) SETUP(XfOrM1328_COUNT)
    s = NULLED_OUT ; 

# 8076 "bc/src/thread.c"
    s = FUNCCALL(SETUP_XfOrM1328(_), scheme_make_immutable_sized_utf8_string ("" , 0 ) ); 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_LOCALE , s ) ); 
  }
  FUNCCALL(SETUP_XfOrM1312(_), init_param (cells , paramz , MZCONFIG_ERROR_PRINT_WIDTH , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (256 ) ) ) << 1 ) | 0x1 ) ) ) )
  ; 
  FUNCCALL(SETUP_XfOrM1312(_), init_param (cells , paramz , MZCONFIG_ERROR_PRINT_CONTEXT_LENGTH , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (16 ) ) ) << 1 ) | 0x1 ) ) ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_ERROR_PRINT_SRCLOC , scheme_true ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> limited_custodians_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> limited_custodians_ ) ) ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) = FUNCCALL(SETUP_XfOrM1312(_), scheme_make_custodian (((void * ) 0 ) ) ); 
  FUNCCALL(SETUP_XfOrM1312(_), GC_register_root_custodian (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) ) )
  ; 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_CUSTODIAN , (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> main_custodian_ ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_plumber_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_plumber_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_plumber_ ) = (Scheme_Plumber * ) FUNCCALL(SETUP_XfOrM1312(_), make_plumber (0 , ((void * ) 0 ) ) ); 
  FUNCCALL(SETUP_XfOrM1312(_), init_param (cells , paramz , MZCONFIG_PLUMBER , (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_plumber_ ) ) ); 
  FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_ALLOW_SET_UNDEFINED , (scheme_allow_set_undefined ? scheme_true : scheme_false ) ) )


  ; 

  {
    Scheme_Security_Guard * sg ; 
    BLOCK_SETUP((PUSH(sg, 0+XfOrM1312_COUNT)));
#   define XfOrM1327_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1327(x) SETUP(XfOrM1327_COUNT)
    sg = NULLED_OUT ; 

# 8103 "bc/src/thread.c"
    sg = ((Scheme_Security_Guard * ) FUNCCALL(SETUP_XfOrM1327(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Security_Guard ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    sg -> so . type = scheme_security_guard_type ; 
    FUNCCALL(SETUP_XfOrM1327(_), init_param (cells , paramz , MZCONFIG_SECURITY_GUARD , (Scheme_Object * ) sg ) ); 
  }

  {
    Scheme_Object * s ; 
    char * pwd ; 
    BLOCK_SETUP((PUSH(pwd, 0+XfOrM1312_COUNT), PUSH(s, 1+XfOrM1312_COUNT)));
#   define XfOrM1323_COUNT (2+XfOrM1312_COUNT)
#   define SETUP_XfOrM1323(x) SETUP(XfOrM1323_COUNT)
    s = NULLED_OUT ; 
    pwd = NULLED_OUT ; 

# 8111 "bc/src/thread.c"
    s = (__funcarg193 = FUNCCALL(SETUP_XfOrM1323(_), scheme_os_getcwd (((void * ) 0 ) , 0 , ((void * ) 0 ) , 1 ) ), FUNCCALL_AGAIN(scheme_make_path (__funcarg193 ) )) ; 
    s = FUNCCALL_AGAIN(scheme_path_to_directory_path (s ) ); 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_CURRENT_DIRECTORY , s ) ); 

    pwd = FUNCCALL_AGAIN(scheme_getenv ("PWD" ) ); 
    if (pwd ) {
      Scheme_Object * id1 , * id2 , * a [2 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM1323_COUNT), PUSH(id1, 3+XfOrM1323_COUNT), PUSH(id2, 4+XfOrM1323_COUNT)));
#     define XfOrM1324_COUNT (5+XfOrM1323_COUNT)
#     define SETUP_XfOrM1324(x) SETUP(XfOrM1324_COUNT)
      id1 = NULLED_OUT ; 
      id2 = NULLED_OUT ; 
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 

# 8118 "bc/src/thread.c"
      id1 = FUNCCALL(SETUP_XfOrM1324(_), scheme_get_fd_identity (((void * ) 0 ) , 0 , pwd , 1 ) ); 
      if (id1 ) {
#       define XfOrM1325_COUNT (0+XfOrM1324_COUNT)
#       define SETUP_XfOrM1325(x) SETUP_XfOrM1324(x)

# 8120 "bc/src/thread.c"
        id2 = FUNCCALL(SETUP_XfOrM1325(_), scheme_get_fd_identity (((void * ) 0 ) , 0 , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , 1 ) ); 
        if (id2 && (scheme_eqv (id1 , id2 ) ) ) {
#         define XfOrM1326_COUNT (0+XfOrM1325_COUNT)
#         define SETUP_XfOrM1326(x) SETUP_XfOrM1325(x)

# 8122 "bc/src/thread.c"
          s = FUNCCALL(SETUP_XfOrM1326(_), scheme_make_path (pwd ) ); 
          a [0 ] = s ; 
          a [1 ] = scheme_true ; 
          s = FUNCCALL(SETUP_XfOrM1326(_), scheme_simplify_path (2 , a ) ); 
          s = FUNCCALL_AGAIN(scheme_path_to_directory_path (s ) ); 
          FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_CURRENT_DIRECTORY , s ) ); 
        }
      }
    }
    FUNCCALL(SETUP_XfOrM1323(_), init_param (cells , paramz , MZCONFIG_CURRENT_USER_DIRECTORY , s ) )
    ; 
    FUNCCALL(SETUP_XfOrM1323(_), scheme_set_original_dir (s ) ); 
  }

  {
    Scheme_Object * ev ; 
    BLOCK_SETUP((PUSH(ev, 0+XfOrM1312_COUNT)));
#   define XfOrM1322_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1322(x) SETUP(XfOrM1322_COUNT)
    ev = NULLED_OUT ; 

# 8138 "bc/src/thread.c"
    ev = FUNCCALL(SETUP_XfOrM1322(_), scheme_make_environment_variables (((void * ) 0 ) ) ); 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_CURRENT_ENV_VARS , ev ) ); 
  }
  FUNCCALL(SETUP_XfOrM1312(_), init_param (cells , paramz , MZCONFIG_FORCE_DELETE_PERMS , scheme_true ) )
  ; 

  {
    Scheme_Object * rs ; 
    BLOCK_SETUP((PUSH(rs, 0+XfOrM1312_COUNT)));
#   define XfOrM1321_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1321(x) SETUP(XfOrM1321_COUNT)
    rs = NULLED_OUT ; 

# 8146 "bc/src/thread.c"
    rs = (__funcarg192 = (scheme_get_milliseconds () ) , FUNCCALL(SETUP_XfOrM1321(_), scheme_make_random_state (__funcarg192 ) )) ; 
    FUNCCALL(SETUP_XfOrM1321(_), init_param (cells , paramz , MZCONFIG_RANDOM_STATE , rs ) ); 
    rs = (__funcarg191 = (scheme_get_milliseconds () ) , FUNCCALL(SETUP_XfOrM1321(_), scheme_make_random_state (__funcarg191 ) )) ; 
    FUNCCALL(SETUP_XfOrM1321(_), init_param (cells , paramz , MZCONFIG_SCHEDULER_RANDOM_STATE , rs ) ); 
  }

  {
    Scheme_Object * ph ; 
    BLOCK_SETUP((PUSH(ph, 0+XfOrM1312_COUNT)));
#   define XfOrM1320_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1320(x) SETUP(XfOrM1320_COUNT)
    ph = NULLED_OUT ; 

# 8155 "bc/src/thread.c"
    ph = FUNCCALL(SETUP_XfOrM1320(_), scheme_make_prim_w_arity (scheme_default_print_handler , "default-print-handler" , 1 , 1 ) )

    ; 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PRINT_HANDLER , ph ) ); 

    ph = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_default_prompt_read_handler , "default-prompt-read-handler" , 0 , 0 ) )

    ; 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_PROMPT_READ_HANDLER , ph ) ); 

    ph = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_default_read_input_port_handler , "default-get-interaction-input-port" , 0 , 0 ) )

    ; 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_READ_INPUT_PORT_HANDLER , ph ) ); 

    ph = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_default_read_get_evt , "default-get-interaction-evt" , 0 , 0 ) )

    ; 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_READ_GET_EVT , ph ) ); 

    ph = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_default_read_handler , "default-read-interaction-handler" , 2 , 2 ) )

    ; 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_READ_HANDLER , ph ) ); 
  }
  FUNCCALL(SETUP_XfOrM1312(_), init_param (cells , paramz , MZCONFIG_PORT_COUNT_LINES , scheme_false ) ); 

  {
    Scheme_Object * lh ; 
    BLOCK_SETUP((PUSH(lh, 0+XfOrM1312_COUNT)));
#   define XfOrM1319_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1319(x) SETUP(XfOrM1319_COUNT)
    lh = NULLED_OUT ; 

# 8184 "bc/src/thread.c"
    lh = FUNCCALL(SETUP_XfOrM1319(_), scheme_make_prim_w_everything (scheme_default_load_extension , 1 , "default-load-extension-handler" , 2 , 2 , 0 , 0 , - 1 ) )


    ; 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_LOAD_EXTENSION_HANDLER , lh ) ); 
  }

  {
    Scheme_Object * ins = initial_inspector ; 
    BLOCK_SETUP((PUSH(ins, 0+XfOrM1312_COUNT)));
#   define XfOrM1318_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1318(x) SETUP(XfOrM1318_COUNT)
    FUNCCALL(SETUP_XfOrM1318(_), init_param (cells , paramz , MZCONFIG_INSPECTOR , ins ) )
# 8193 "bc/src/thread.c"
    ; 
    FUNCCALL(SETUP_XfOrM1318(_), init_param (cells , paramz , MZCONFIG_CODE_INSPECTOR , ins ) ); 
  }

  {
    Scheme_Object * zlv ; 
    BLOCK_SETUP((PUSH(zlv, 0+XfOrM1312_COUNT)));
#   define XfOrM1317_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1317(x) SETUP(XfOrM1317_COUNT)
    zlv = NULLED_OUT ; 

# 8199 "bc/src/thread.c"
    if (initial_cmdline_vec )
      zlv = initial_cmdline_vec ; 
    else 
    zlv = FUNCCALL(SETUP_XfOrM1317(_), scheme_make_vector (0 , ((void * ) 0 ) ) ); 
    FUNCCALL(SETUP_XfOrM1317(_), init_param (cells , paramz , MZCONFIG_CMDLINE_ARGS , zlv ) ); 
  }

  {
    Scheme_Thread_Set * t_set ; 
    BLOCK_SETUP((PUSH(t_set, 0+XfOrM1312_COUNT)));
#   define XfOrM1316_COUNT (1+XfOrM1312_COUNT)
#   define SETUP_XfOrM1316(x) SETUP(XfOrM1316_COUNT)
    t_set = NULLED_OUT ; 

# 8208 "bc/src/thread.c"
    t_set = FUNCCALL(SETUP_XfOrM1316(_), create_thread_set (((void * ) 0 ) ) ); 
    FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_THREAD_SET , (Scheme_Object * ) t_set ) ); 
  }
  FUNCCALL(SETUP_XfOrM1312(_), init_param (cells , paramz , MZCONFIG_THREAD_INIT_STACK_SIZE , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1000 ) ) ) << 1 ) | 0x1 ) ) ) )
  ; 
  (__funcarg190 = FUNCCALL(SETUP_XfOrM1312(_), scheme_intern_symbol ("inherited" ) ), FUNCCALL_AGAIN(init_param (cells , paramz , MZCONFIG_SUBPROC_KEEP_FDS , __funcarg190 ) )) 
  ; 

  {
    int i ; 
#   define XfOrM1313_COUNT (0+XfOrM1312_COUNT)
#   define SETUP_XfOrM1313(x) SETUP_XfOrM1312(x)

# 8218 "bc/src/thread.c"
    for (i = 0 ; i < max_configs ; i ++ ) {
#     define XfOrM1315_COUNT (0+XfOrM1313_COUNT)
#     define SETUP_XfOrM1315(x) SETUP_XfOrM1313(x)

# 8219 "bc/src/thread.c"
      if (! paramz -> prims [i ] )
        FUNCCALL(SETUP_XfOrM1315(_), init_param (cells , paramz , i , scheme_false ) ); 
    }
  }
  FUNCCALL(SETUP_XfOrM1312(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_config_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_config_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_config_ ) = config ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8228 "bc/src/thread.c"
Scheme_Config * scheme_minimal_config (void ) 
{
  /* No conversion */

# 8230 "bc/src/thread.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> initial_config_ ) ; 
}

Scheme_Object * scheme_compile_target_check (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 8235 "bc/src/thread.c"
  if ((((argv [0 ] ) ) == (scheme_false ) ) || ((argv [0 ] ) == (racket_symbol ) ) )
    return scheme_true ; 
  else 
  return scheme_false ; 
}

void scheme_set_startup_load_on_demand (int on ) 
{
  /* No conversion */

# 8243 "bc/src/thread.c"
  scheme_init_load_on_demand = on ; 
}

Scheme_Object * scheme_register_parameter (Scheme_Prim * function , char * name , int which ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(function, 0), PUSH(o, 1), PUSH(name, 2)));
# define XfOrM1333_COUNT (3)
# define SETUP_XfOrM1333(x) SETUP(XfOrM1333_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 8250 "bc/src/thread.c"
  if (! config_map ) {
#   define XfOrM1334_COUNT (0+XfOrM1333_COUNT)
#   define SETUP_XfOrM1334(x) SETUP_XfOrM1333(x)
    FUNCCALL(SETUP_XfOrM1334(_), scheme_register_static ((void * ) & config_map , sizeof (config_map ) ) )
# 8251 "bc/src/thread.c"
    ; 
    config_map = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1334(_), GC_malloc (sizeof (Scheme_Object * ) * (max_configs ) ) )) ; 
  }

  if (config_map [which ] )
    RET_VALUE_START (config_map [which ] ) RET_VALUE_END ; 

  o = FUNCCALL(SETUP_XfOrM1333(_), scheme_make_prim_w_arity (function , name , 0 , 1 ) ); 
  ((Scheme_Primitive_Proc * ) o ) -> pp . flags |= 64 ; 

  config_map [which ] = o ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8266 "bc/src/thread.c"
typedef Scheme_Object * (* PCheck_Proc ) (int , Scheme_Object * * , Scheme_Config * ) ; 

static Scheme_Object * do_param_config (char * name , Scheme_Object * pos , 
int argc , Scheme_Object * * argv , 
int arity , 






Scheme_Object * (* check ) (int , Scheme_Object * * ) , 

char * expected , 
int isboolorfilter , 
int expected_is_contract ) 
{
  Scheme_Config * config ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(name, 1), PUSH(config, 2), PUSH(pos, 3), PUSH(expected, 4)));
# define XfOrM1335_COUNT (5)
# define SETUP_XfOrM1335(x) SETUP(XfOrM1335_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  config = NULLED_OUT ; 

# 8285 "bc/src/thread.c"
  config = FUNCCALL(SETUP_XfOrM1335(_), scheme_current_config () ); 

  if (argc == 0 ) {
#   define XfOrM1343_COUNT (0+XfOrM1335_COUNT)
#   define SETUP_XfOrM1343(x) SETUP_XfOrM1335(x)

# 8288 "bc/src/thread.c"
    if (arity == - 2 ) {
#     define XfOrM1346_COUNT (0+XfOrM1343_COUNT)
#     define SETUP_XfOrM1346(x) SETUP_XfOrM1343(x)

# 8289 "bc/src/thread.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(extract_param (config , ((Scheme_Object * * ) pos ) [0 ] , ((Scheme_Object * * ) pos ) [1 ] ) )) RET_VALUE_EMPTY_END ; 
    }

# 8290 "bc/src/thread.c"
    else {
      Scheme_Object * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM1343_COUNT)));
#     define XfOrM1344_COUNT (1+XfOrM1343_COUNT)
#     define SETUP_XfOrM1344(x) SETUP(XfOrM1344_COUNT)
      s = NULLED_OUT ; 

# 8292 "bc/src/thread.c"
      s = FUNCCALL(SETUP_XfOrM1344(_), scheme_get_param (config , (((intptr_t ) (pos ) ) >> 1 ) ) ); 
      if (arity == - 3 ) {
        Scheme_Object * a [1 ] ; 
        PCheck_Proc checkp = (PCheck_Proc ) check ; 
        BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM1344_COUNT)));
#       define XfOrM1345_COUNT (3+XfOrM1344_COUNT)
#       define SETUP_XfOrM1345(x) SETUP(XfOrM1345_COUNT)
        a[0] = NULLED_OUT ; 

# 8296 "bc/src/thread.c"
        a [0 ] = s ; 
        s = FUNCCALL(SETUP_XfOrM1345(_), checkp (1 , a , config ) ); 
      }
      RET_VALUE_START (s ) RET_VALUE_END ; 
    }
  }

# 8301 "bc/src/thread.c"
  else {
    Scheme_Object * naya = argv [0 ] ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM1335_COUNT)));
#   define XfOrM1336_COUNT (1+XfOrM1335_COUNT)
#   define SETUP_XfOrM1336(x) SETUP(XfOrM1336_COUNT)

# 8304 "bc/src/thread.c"
    if (arity != - 2 ) {
#     define XfOrM1338_COUNT (0+XfOrM1336_COUNT)
#     define SETUP_XfOrM1338(x) SETUP_XfOrM1336(x)

# 8305 "bc/src/thread.c"
      if (arity < 0 ) {
#       define XfOrM1340_COUNT (0+XfOrM1338_COUNT)
#       define SETUP_XfOrM1340(x) SETUP_XfOrM1338(x)

# 8306 "bc/src/thread.c"
        if (check ) {
          PCheck_Proc checkp = (PCheck_Proc ) check ; 
          Scheme_Object * r ; 
          BLOCK_SETUP((PUSH(r, 0+XfOrM1340_COUNT)));
#         define XfOrM1341_COUNT (1+XfOrM1340_COUNT)
#         define SETUP_XfOrM1341(x) SETUP(XfOrM1341_COUNT)
          r = NULLED_OUT ; 

# 8310 "bc/src/thread.c"
          r = FUNCCALL(SETUP_XfOrM1341(_), checkp (1 , argv , config ) ); 

          if (! isboolorfilter && (((r ) ) == (scheme_false ) ) )
            r = ((void * ) 0 ) ; 

          if (! r ) {
#           define XfOrM1342_COUNT (0+XfOrM1341_COUNT)
#           define SETUP_XfOrM1342(x) SETUP_XfOrM1341(x)

# 8316 "bc/src/thread.c"
            if (expected_is_contract )
              FUNCCALL_EMPTY(scheme_wrong_contract (name , expected , 0 , 1 , argv ) ); 
            else FUNCCALL_EMPTY(scheme_wrong_type (name , expected , 0 , 1 , argv ) )
            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }

          if (isboolorfilter )
            naya = r ; 
        }
      }

# 8326 "bc/src/thread.c"
      else FUNCCALL(SETUP_XfOrM1338(_), scheme_check_proc_arity (name , arity , 0 , argc , argv ) )
      ; 

      if (isboolorfilter && ! check )
        naya = (((! (((naya ) ) == (scheme_false ) ) ) ) ? scheme_true : scheme_false ) ; 

      if (argc == 2 ) {

        argv [1 ] = naya ; 
        RET_VALUE_START (pos ) RET_VALUE_END ; 
      }

# 8336 "bc/src/thread.c"
      else FUNCCALL(SETUP_XfOrM1338(_), scheme_set_param (config , (((intptr_t ) (pos ) ) >> 1 ) , naya ) )
      ; 
    }

# 8338 "bc/src/thread.c"
    else {
      Scheme_Object * cell ; 
      BLOCK_SETUP((PUSH(cell, 0+XfOrM1336_COUNT)));
#     define XfOrM1337_COUNT (1+XfOrM1336_COUNT)
#     define SETUP_XfOrM1337(x) SETUP(XfOrM1337_COUNT)
      cell = NULLED_OUT ; 

# 8341 "bc/src/thread.c"
      cell = FUNCCALL(SETUP_XfOrM1337(_), find_param_cell (config , ((Scheme_Object * * ) pos ) [0 ] , 1 ) ); 
      if (! cell )
        cell = ((Scheme_Object * * ) pos ) [1 ] ; 
      FUNCCALL_EMPTY(scheme_thread_cell_set (cell , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cell_values , naya ) )
      ; 
    }

    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8352 "bc/src/thread.c"
Scheme_Object * scheme_param_config (char * name , Scheme_Object * pos , 
int argc , Scheme_Object * * argv , 
int arity , 
Scheme_Object * (* check ) (int , Scheme_Object * * ) , 
char * expected_type , 
int isboolorfilter ) 
{
  /* No conversion */

# 8359 "bc/src/thread.c"
  return do_param_config (name , pos , argc , argv , arity , check , 
  expected_type , isboolorfilter , 0 ) ; 
}

Scheme_Object * scheme_param_config2 (char * name , Scheme_Object * pos , 
int argc , Scheme_Object * * argv , 
int arity , 
Scheme_Object * (* check ) (int , Scheme_Object * * ) , 
char * expected_contract , 
int isboolorfilter ) 
{
  /* No conversion */

# 8370 "bc/src/thread.c"
  return do_param_config (name , pos , argc , argv , arity , check , 
  expected_contract , isboolorfilter , 1 ) ; 
}

static Scheme_Object * 
exact_positive_integer_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8377 "bc/src/thread.c"
  Scheme_Object * n = argv [argc - 1 ] ; 
  if ((((intptr_t ) (n ) ) & 0x1 ) && ((((intptr_t ) (n ) ) >> 1 ) > 0 ) )
    return scheme_true ; 
  if (((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) n ) -> iso ) -> so . keyex & 0x1 ) )
    return scheme_true ; 

  return scheme_false ; 
}

static Scheme_Object * current_thread_initial_stack_size (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8388 "bc/src/thread.c"
  return scheme_param_config2 ("current-thread-initial-stack-size" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_THREAD_INIT_STACK_SIZE ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , exact_positive_integer_p , "exact-positive-integer?" , 0 ) ; 
}

static Scheme_Object * phantom_bytes_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8396 "bc/src/thread.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_phantom_bytes_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * make_phantom_bytes (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Phantom_Bytes * pb ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(pb, 1)));
# define XfOrM1352_COUNT (2)
# define SETUP_XfOrM1352(x) SETUP(XfOrM1352_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pb = NULLED_OUT ; 

# 8405 "bc/src/thread.c"
  if (! FUNCCALL(SETUP_XfOrM1352(_), scheme_nonneg_exact_p (argv [0 ] ) ))
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-phantom-bytes" , "exact-nonnegative-integer?" , 0 , argc , argv ) ); 

  if (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) )
    FUNCCALL_EMPTY(scheme_raise_out_of_memory ("make-phantom-bytes" , ((void * ) 0 ) ) ); 

  pb = ((Scheme_Phantom_Bytes * ) FUNCCALL(SETUP_XfOrM1352(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Phantom_Bytes ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  pb -> so . type = scheme_phantom_bytes_type ; 
  pb -> size = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 


  if (! FUNCCALL(SETUP_XfOrM1352(_), GC_allocate_phantom_bytes (pb , pb -> size ) )) {
#   define XfOrM1353_COUNT (0+XfOrM1352_COUNT)
#   define SETUP_XfOrM1353(x) SETUP_XfOrM1352(x)

# 8417 "bc/src/thread.c"
    pb -> size = 0 ; 
    FUNCCALL_EMPTY(scheme_raise_out_of_memory ("make-phantom-bytes" , ((void * ) 0 ) ) ); 
  }


  RET_VALUE_START ((Scheme_Object * ) pb ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8425 "bc/src/thread.c"
static Scheme_Object * set_phantom_bytes (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Phantom_Bytes * pb ; 
  intptr_t amt ; 

  intptr_t old_size ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(pb, 1)));
# define XfOrM1354_COUNT (2)
# define SETUP_XfOrM1354(x) SETUP(XfOrM1354_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pb = NULLED_OUT ; 

# 8433 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_phantom_bytes_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("set-phantom-bytes!" , "phantom-bytes?" , 0 , argc , argv ) ); 
  if (! FUNCCALL(SETUP_XfOrM1354(_), scheme_nonneg_exact_p (argv [1 ] ) ))
    FUNCCALL_EMPTY(scheme_wrong_contract ("set-phantom-bytes!" , "exact-nonnegative-integer?" , 1 , argc , argv ) ); 

  pb = (Scheme_Phantom_Bytes * ) argv [0 ] ; 
  amt = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 


  old_size = pb -> size ; 


  pb -> size = amt ; 


  if (! FUNCCALL(SETUP_XfOrM1354(_), GC_allocate_phantom_bytes (pb , amt - old_size ) )) {
#   define XfOrM1355_COUNT (0+XfOrM1354_COUNT)
#   define SETUP_XfOrM1355(x) SETUP_XfOrM1354(x)

# 8449 "bc/src/thread.c"
    pb -> size = old_size ; 
    FUNCCALL_EMPTY(scheme_raise_out_of_memory ("make-phantom-bytes" , ((void * ) 0 ) ) ); 
  }


  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Env * scheme_get_env (Scheme_Config * c ) 
XFORM_SKIP_PROC 
{
  Scheme_Object * o ; 

  if (! c )
    c = scheme_current_config () ; 

  o = scheme_get_param (c , MZCONFIG_ENV ) ; 
  return (Scheme_Env * ) o ; 
}





static Scheme_Object * make_security_guard (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Security_Guard * sg ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(sg, 1)));
# define XfOrM1356_COUNT (2)
# define SETUP_XfOrM1356(x) SETUP(XfOrM1356_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sg = NULLED_OUT ; 

# 8481 "bc/src/thread.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_security_guard_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-security-guard" , "security-guard?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM1356(_), scheme_check_proc_arity ("make-security-guard" , 3 , 1 , argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity ("make-security-guard" , 4 , 2 , argc , argv ) ); 
  if (argc > 3 )
    FUNCCALL(SETUP_XfOrM1356(_), scheme_check_proc_arity2 ("make-security-guard" , 3 , 3 , argc , argv , 1 ) ); 

  sg = ((Scheme_Security_Guard * ) FUNCCALL(SETUP_XfOrM1356(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Security_Guard ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  sg -> so . type = scheme_security_guard_type ; 
  sg -> parent = (Scheme_Security_Guard * ) argv [0 ] ; 
  sg -> file_proc = argv [1 ] ; 
  sg -> network_proc = argv [2 ] ; 
  if ((argc > 3 ) && (! (((argv [3 ] ) ) == (scheme_false ) ) ) )
    sg -> link_proc = argv [3 ] ; 

  RET_VALUE_START ((Scheme_Object * ) sg ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8499 "bc/src/thread.c"
static Scheme_Object * unsafe_make_security_guard_at_root (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Security_Guard * sg ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(sg, 1)));
# define XfOrM1357_COUNT (2)
# define SETUP_XfOrM1357(x) SETUP(XfOrM1357_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sg = NULLED_OUT ; 

# 8503 "bc/src/thread.c"
  if (argc > 0 )
    FUNCCALL(SETUP_XfOrM1357(_), scheme_check_proc_arity ("unsafe-make-security-guard-at-root" , 3 , 0 , argc , argv ) ); 
  if (argc > 1 )
    FUNCCALL(SETUP_XfOrM1357(_), scheme_check_proc_arity ("unsafe-make-security-guard-at-root" , 4 , 1 , argc , argv ) ); 
  if (argc > 2 )
    FUNCCALL(SETUP_XfOrM1357(_), scheme_check_proc_arity2 ("unsafe-make-security-guard-at-root" , 3 , 2 , argc , argv , 1 ) ); 

  sg = ((Scheme_Security_Guard * ) FUNCCALL(SETUP_XfOrM1357(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Security_Guard ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  sg -> so . type = scheme_security_guard_type ; 
  sg -> parent = ((void * ) 0 ) ; 
  sg -> file_proc = ((argc > 0 ) ? argv [0 ] : ((void * ) 0 ) ) ; 
  sg -> network_proc = ((argc > 1 ) ? argv [1 ] : ((void * ) 0 ) ) ; 
  sg -> link_proc = ((argc > 2 ) ? argv [2 ] : ((void * ) 0 ) ) ; 

  RET_VALUE_START ((Scheme_Object * ) sg ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8520 "bc/src/thread.c"
static Scheme_Object * security_guard_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8522 "bc/src/thread.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_security_guard_type ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * current_security_guard (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8529 "bc/src/thread.c"
  return scheme_param_config2 ("current-security-guard" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_SECURITY_GUARD ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , security_guard_p , "security-guard?" , 0 ) ; 
}

static Scheme_Object * security_guard_check_file (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * l , * a ; 
  int guards = 0 ; 
  char * __funcarg194 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(a, 1)));
# define XfOrM1360_COUNT (2)
# define SETUP_XfOrM1360(x) SETUP(XfOrM1360_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  a = NULLED_OUT ; 

# 8540 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-file" , "symbol?" , 0 , argc , argv ) ); 

  if (! (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-file" , "path-string?" , 1 , argc , argv ) ); 

  l = argv [2 ] ; 
  while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
    a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    if ((a ) == (exists_symbol ) ) 
      guards |= 0x10 ; 
    else if ((a ) == (delete_symbol ) ) 
      guards |= 0x8 ; 
    else if ((a ) == (execute_symbol ) ) 
      guards |= 0x4 ; 
    else if ((a ) == (write_symbol ) ) 
      guards |= 0x2 ; 
    else if ((a ) == (read_symbol ) ) 
      guards |= 0x1 ; 
    else 
    break ; 

    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  if (! ((l ) == (scheme_null ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-file" , "(listof (or/c 'read 'write 'execute 'delete 'exists))" , 2 , argc , argv ) )

  ; 

  a = argv [1 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) )
    a = FUNCCALL(SETUP_XfOrM1360(_), scheme_char_string_to_path (a ) ); 
  (__funcarg194 = FUNCCALL(SETUP_XfOrM1360(_), scheme_symbol_val (argv [0 ] ) )
  , FUNCCALL_AGAIN(scheme_security_check_file (__funcarg194 , (((Scheme_Simple_Object * ) (a ) ) -> u . byte_str_val . string_val ) , guards ) )) 

  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8581 "bc/src/thread.c"
static Scheme_Object * security_guard_check_file_link (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a , * b ; 
  char * __funcarg195 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(a, 1), PUSH(b, 2)));
# define XfOrM1363_COUNT (3)
# define SETUP_XfOrM1363(x) SETUP(XfOrM1363_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 
  b = NULLED_OUT ; 

# 8585 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-file-link" , "symbol?" , 0 , argc , argv ) ); 

  if (! (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-file-link" , "path-string?" , 1 , argc , argv ) ); 

  if (! (((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-file-link" , "path-string?" , 2 , argc , argv ) ); 

  a = argv [1 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) )
    a = FUNCCALL(SETUP_XfOrM1363(_), scheme_char_string_to_path (a ) ); 

  b = argv [2 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (b ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (b ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) )
    b = FUNCCALL(SETUP_XfOrM1363(_), scheme_char_string_to_path (b ) ); 
  (__funcarg195 = FUNCCALL(SETUP_XfOrM1363(_), scheme_symbol_val (argv [0 ] ) )
  , FUNCCALL_AGAIN(scheme_security_check_file_link (__funcarg195 , (((Scheme_Simple_Object * ) (a ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (b ) ) -> u . byte_str_val . string_val ) ) )) ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8607 "bc/src/thread.c"
static Scheme_Object * security_guard_check_network (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a ; 
  char * __funcarg196 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(a, 1)));
# define XfOrM1364_COUNT (2)
# define SETUP_XfOrM1364(x) SETUP(XfOrM1364_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 8611 "bc/src/thread.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-network" , "symbol?" , 0 , argc , argv ) ); 

  if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-network" , "(or/c string? #f)" , 1 , argc , argv ) ); 

  if ((! (((argv [2 ] ) ) == (scheme_false ) ) ) 
  && (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) 
  || ((((intptr_t ) (argv [2 ] ) ) >> 1 ) < 1 ) 
  || ((((intptr_t ) (argv [2 ] ) ) >> 1 ) > 65535 ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-network" , "(or/c (integer-in 1 65535) #f)" , 2 , argc , argv ) ); 

  if (! ((argv [3 ] ) == (client_symbol ) ) && ! ((argv [3 ] ) == (server_symbol ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("security-guard-check-network" , "(or/c 'client'server)" , 3 , argc , argv ) ); 

  if (! (((argv [1 ] ) ) == (scheme_false ) ) ) 
    a = FUNCCALL(SETUP_XfOrM1364(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
  else 
  a = ((void * ) 0 ) ; 
  (__funcarg196 = FUNCCALL(SETUP_XfOrM1364(_), scheme_symbol_val (argv [0 ] ) )
  , FUNCCALL_AGAIN(scheme_security_check_network (__funcarg196 , a ? (((Scheme_Simple_Object * ) (a ) ) -> u . byte_str_val . string_val ) : ((void * ) 0 ) , (! (((argv [2 ] ) ) == (scheme_false ) ) ) ? (((intptr_t ) (argv [2 ] ) ) >> 1 ) : 0 , ((argv [3 ] ) == (client_symbol ) ) ) )) 


  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8639 "bc/src/thread.c"
void scheme_security_check_file (const char * who , const char * filename , int guards ) 
{
  Scheme_Security_Guard * sg ; 

# 7610 "bc/src/thread.c"
  Scheme_Config * __funcarg197 = NULLED_OUT ; 
  PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(filename, 1), PUSH(sg, 2)));
# define XfOrM1365_COUNT (3)
# define SETUP_XfOrM1365(x) SETUP(XfOrM1365_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  sg = NULLED_OUT ; 

# 8643 "bc/src/thread.c"
  sg = (Scheme_Security_Guard * ) (__funcarg197 = FUNCCALL(SETUP_XfOrM1365(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg197 , MZCONFIG_SECURITY_GUARD ) )) ; 

  if (sg -> file_proc ) {
    Scheme_Object * l = scheme_null , * a [3 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 3, 0+XfOrM1365_COUNT), PUSH(l, 3+XfOrM1365_COUNT)));
#   define XfOrM1366_COUNT (4+XfOrM1365_COUNT)
#   define SETUP_XfOrM1366(x) SETUP(XfOrM1366_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    a[2] = NULLED_OUT ; 

# 8648 "bc/src/thread.c"
    if (guards & 0x10 )
      l = FUNCCALL(SETUP_XfOrM1366(_), scheme_make_pair (exists_symbol , l ) ); 
    if (guards & 0x8 )
      l = FUNCCALL(SETUP_XfOrM1366(_), scheme_make_pair (delete_symbol , l ) ); 
    if (guards & 0x4 )
      l = FUNCCALL(SETUP_XfOrM1366(_), scheme_make_pair (execute_symbol , l ) ); 
    if (guards & 0x2 )
      l = FUNCCALL(SETUP_XfOrM1366(_), scheme_make_pair (write_symbol , l ) ); 
    if (guards & 0x1 )
      l = FUNCCALL(SETUP_XfOrM1366(_), scheme_make_pair (read_symbol , l ) ); 

    a [0 ] = FUNCCALL(SETUP_XfOrM1366(_), scheme_intern_symbol (who ) ); 
    a [1 ] = (filename ? FUNCCALL(SETUP_XfOrM1366(_), scheme_make_sized_path ((char * ) filename , - 1 , 1 ) ): scheme_false ) ; 
    a [2 ] = l ; 

    while (sg -> parent ) {
#     define XfOrM1368_COUNT (0+XfOrM1366_COUNT)
#     define SETUP_XfOrM1368(x) SETUP_XfOrM1366(x)
      FUNCCALL(SETUP_XfOrM1368(_), scheme_apply (sg -> file_proc , 3 , a ) )
# 8664 "bc/src/thread.c"
      ; 
      sg = sg -> parent ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8670 "bc/src/thread.c"
void scheme_security_check_file_link (const char * who , const char * filename , const char * content ) 
{
  Scheme_Security_Guard * sg ; 

# 7610 "bc/src/thread.c"
  Scheme_Config * __funcarg198 = NULLED_OUT ; 
  PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(content, 1), PUSH(filename, 2), PUSH(sg, 3)));
# define XfOrM1369_COUNT (4)
# define SETUP_XfOrM1369(x) SETUP(XfOrM1369_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  sg = NULLED_OUT ; 

# 8674 "bc/src/thread.c"
  sg = (Scheme_Security_Guard * ) (__funcarg198 = FUNCCALL(SETUP_XfOrM1369(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg198 , MZCONFIG_SECURITY_GUARD ) )) ; 

  if (sg -> file_proc ) {
    Scheme_Object * a [3 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 3, 0+XfOrM1369_COUNT)));
#   define XfOrM1370_COUNT (3+XfOrM1369_COUNT)
#   define SETUP_XfOrM1370(x) SETUP(XfOrM1370_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    a[2] = NULLED_OUT ; 

# 8679 "bc/src/thread.c"
    a [0 ] = FUNCCALL(SETUP_XfOrM1370(_), scheme_intern_symbol (who ) ); 
    a [1 ] = FUNCCALL(SETUP_XfOrM1370(_), scheme_make_sized_path ((char * ) filename , - 1 , 1 ) ); 
    a [2 ] = FUNCCALL(SETUP_XfOrM1370(_), scheme_make_sized_path ((char * ) content , - 1 , 1 ) ); 

    while (sg -> parent ) {
#     define XfOrM1373_COUNT (0+XfOrM1370_COUNT)
#     define SETUP_XfOrM1373(x) SETUP_XfOrM1370(x)

# 8684 "bc/src/thread.c"
      if (sg -> link_proc )
        FUNCCALL(SETUP_XfOrM1373(_), scheme_apply (sg -> link_proc , 3 , a ) ); 
      else {
#       define XfOrM1374_COUNT (0+XfOrM1373_COUNT)
#       define SETUP_XfOrM1374(x) SETUP_XfOrM1373(x)
        FUNCCALL(SETUP_XfOrM1374(_), scheme_signal_error ("%s: security guard does not allow any link operation; attempted from: %s to: %s" , who , filename , content ) )
        ; 
      }
      sg = sg -> parent ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8697 "bc/src/thread.c"
void scheme_security_check_network (const char * who , const char * host , int port , int client ) 
{
  Scheme_Security_Guard * sg ; 

# 7610 "bc/src/thread.c"
  Scheme_Config * __funcarg199 = NULLED_OUT ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(sg, 1), PUSH(host, 2)));
# define XfOrM1375_COUNT (3)
# define SETUP_XfOrM1375(x) SETUP(XfOrM1375_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  sg = NULLED_OUT ; 

# 8701 "bc/src/thread.c"
  sg = (Scheme_Security_Guard * ) (__funcarg199 = FUNCCALL(SETUP_XfOrM1375(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg199 , MZCONFIG_SECURITY_GUARD ) )) ; 

  if (sg -> network_proc ) {
    Scheme_Object * a [4 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 4, 0+XfOrM1375_COUNT)));
#   define XfOrM1376_COUNT (3+XfOrM1375_COUNT)
#   define SETUP_XfOrM1376(x) SETUP(XfOrM1376_COUNT)
    NULL_OUT_ARRAY (a ) ; 

# 8706 "bc/src/thread.c"
    a [0 ] = FUNCCALL(SETUP_XfOrM1376(_), scheme_intern_symbol (who ) ); 
    a [1 ] = (host ? FUNCCALL(SETUP_XfOrM1376(_), scheme_make_sized_utf8_string ((char * ) host , - 1 ) ): scheme_false ) ; 
    a [2 ] = ((port < 1 ) ? scheme_false : ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (port ) ) ) << 1 ) | 0x1 ) ) ) ; 
    a [3 ] = (client ? client_symbol : server_symbol ) ; 

    while (sg -> parent ) {
#     define XfOrM1378_COUNT (0+XfOrM1376_COUNT)
#     define SETUP_XfOrM1378(x) SETUP_XfOrM1376(x)
      FUNCCALL(SETUP_XfOrM1378(_), scheme_apply (sg -> network_proc , 4 , a ) )
# 8712 "bc/src/thread.c"
      ; 
      sg = sg -> parent ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
typedef struct ActiveWill {
  Scheme_Type type ; 
  Scheme_Object * o ; 
  Scheme_Object * proc ; 
  struct WillExecutor * w ; 
  struct ActiveWill * next ; 
}

# 8728 "bc/src/thread.c"
ActiveWill ; 

typedef struct WillExecutor {
  Scheme_Object so ; 
  Scheme_Object * sema ; 
  ActiveWill * first , * last ; 
  int is_late ; 
}

# 8735 "bc/src/thread.c"
WillExecutor ; 

static void activate_will (void * o , void * data ) 
{
  ActiveWill * a ; 
  WillExecutor * w ; 
  Scheme_Object * proc ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(w, 0), PUSH(o, 1), PUSH(a, 2), PUSH(proc, 3)));
# define XfOrM1379_COUNT (4)
# define SETUP_XfOrM1379(x) SETUP(XfOrM1379_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 
  w = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 8743 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (data ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (data ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    w = (WillExecutor * ) (((Scheme_Simple_Object * ) (data ) ) -> u . pair_val . car ) ; 
    proc = (((Scheme_Simple_Object * ) (data ) ) -> u . pair_val . cdr ) ; 
  }

# 8746 "bc/src/thread.c"
  else {
#   define XfOrM1383_COUNT (0+XfOrM1379_COUNT)
#   define SETUP_XfOrM1383(x) SETUP_XfOrM1379(x)

# 8747 "bc/src/thread.c"
    w = (WillExecutor * ) (scheme_ephemeron_key (data ) ) ; 
    proc = (scheme_ephemeron_value (data ) ) ; 
  }

  if (w ) {
#   define XfOrM1380_COUNT (0+XfOrM1379_COUNT)
#   define SETUP_XfOrM1380(x) SETUP_XfOrM1379(x)

# 8752 "bc/src/thread.c"
    a = ((ActiveWill * ) FUNCCALL(SETUP_XfOrM1380(_), GC_malloc_one_small_tagged ((((sizeof (ActiveWill ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    a -> type = scheme_rt_will ; 

    a -> o = (Scheme_Object * ) o ; 
    a -> proc = proc ; 

    if (w -> last )
      w -> last -> next = a ; 
    else 
    w -> first = a ; 
    w -> last = a ; 
    FUNCCALL(SETUP_XfOrM1380(_), scheme_post_sema (w -> sema ) ); 

    if (w -> is_late ) {
#     define XfOrM1381_COUNT (0+XfOrM1380_COUNT)
#     define SETUP_XfOrM1381(x) SETUP_XfOrM1380(x)
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> late_will_executors_with_pending_ ) ) {
#       define XfOrM1382_COUNT (0+XfOrM1381_COUNT)
#       define SETUP_XfOrM1382(x) SETUP_XfOrM1381(x)
        FUNCCALL(SETUP_XfOrM1382(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> late_will_executors_with_pending_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> late_will_executors_with_pending_ ) ) ) )
# 8770 "bc/src/thread.c"
        ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> late_will_executors_with_pending_ ) = FUNCCALL(SETUP_XfOrM1382(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      }
      FUNCCALL_EMPTY(scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> late_will_executors_with_pending_ ) , (Scheme_Object * ) w , scheme_true ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8778 "bc/src/thread.c"
static Scheme_Object * do_next_will (WillExecutor * w ) 
{
  ActiveWill * a ; 
  Scheme_Object * o [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSHARRAY(o, 1, 1)));
# define XfOrM1385_COUNT (4)
# define SETUP_XfOrM1385(x) SETUP(XfOrM1385_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 
  o[0] = NULLED_OUT ; 

# 8783 "bc/src/thread.c"
  a = w -> first ; 
  w -> first = a -> next ; 
  if (! w -> first ) {
#   define XfOrM1386_COUNT (0+XfOrM1385_COUNT)
#   define SETUP_XfOrM1386(x) SETUP_XfOrM1385(x)

# 8786 "bc/src/thread.c"
    w -> last = ((void * ) 0 ) ; 
    if (w -> is_late )
      FUNCCALL(SETUP_XfOrM1386(_), scheme_hash_set (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> late_will_executors_with_pending_ ) , (Scheme_Object * ) w , ((void * ) 0 ) ) ); 
  }

  o [0 ] = a -> o ; 
  a -> o = ((void * ) 0 ) ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1385(_), scheme_apply_multi (a -> proc , 1 , o ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8797 "bc/src/thread.c"
static Scheme_Object * make_will_executor (int argc , Scheme_Object * * argv ) 
{
  WillExecutor * w ; 
  Scheme_Object * sema ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(w, 0), PUSH(sema, 1)));
# define XfOrM1387_COUNT (2)
# define SETUP_XfOrM1387(x) SETUP(XfOrM1387_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  w = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 8802 "bc/src/thread.c"
  w = ((WillExecutor * ) FUNCCALL(SETUP_XfOrM1387(_), GC_malloc_one_small_tagged ((((sizeof (WillExecutor ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  sema = FUNCCALL(SETUP_XfOrM1387(_), scheme_make_sema (0 ) ); 

  w -> so . type = scheme_will_executor_type ; 
  w -> first = ((void * ) 0 ) ; 
  w -> last = ((void * ) 0 ) ; 
  w -> sema = sema ; 
  w -> is_late = 0 ; 

  RET_VALUE_START ((Scheme_Object * ) w ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8814 "bc/src/thread.c"
Scheme_Object * scheme_make_late_will_executor () 
{
  WillExecutor * w ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(w, 0)));
# define XfOrM1388_COUNT (1)
# define SETUP_XfOrM1388(x) SETUP(XfOrM1388_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  w = NULLED_OUT ; 

# 8818 "bc/src/thread.c"
  w = (WillExecutor * ) FUNCCALL(SETUP_XfOrM1388(_), make_will_executor (0 , ((void * ) 0 ) ) ); 
  w -> is_late = 1 ; 

  RET_VALUE_START ((Scheme_Object * ) w ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8824 "bc/src/thread.c"
static Scheme_Object * will_executor_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 8826 "bc/src/thread.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_will_executor_type ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * register_will (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * e ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(e, 1)));
# define XfOrM1390_COUNT (2)
# define SETUP_XfOrM1390(x) SETUP(XfOrM1390_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  e = NULLED_OUT ; 

# 8835 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) != (Scheme_Type ) (scheme_will_executor_type ) ) 
    FUNCCALL_EMPTY(scheme_wrong_contract ("will-register" , "will-executor?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM1390(_), scheme_check_proc_arity ("will-register" , 1 , 2 , argc , argv ) ); 

  if (((WillExecutor * ) argv [0 ] ) -> is_late ) {
#   define XfOrM1392_COUNT (0+XfOrM1390_COUNT)
#   define SETUP_XfOrM1392(x) SETUP_XfOrM1390(x)

# 8840 "bc/src/thread.c"
    e = FUNCCALL(SETUP_XfOrM1392(_), scheme_make_pair (argv [0 ] , argv [2 ] ) ); 
    FUNCCALL(SETUP_XfOrM1392(_), scheme_add_finalizer (argv [1 ] , activate_will , e ) ); 
  }

# 8842 "bc/src/thread.c"
  else {
#   define XfOrM1391_COUNT (0+XfOrM1390_COUNT)
#   define SETUP_XfOrM1391(x) SETUP_XfOrM1390(x)

# 8844 "bc/src/thread.c"
    e = FUNCCALL(SETUP_XfOrM1391(_), scheme_make_ephemeron (argv [0 ] , argv [2 ] ) ); 
    FUNCCALL_EMPTY(scheme_add_scheme_finalizer (argv [1 ] , activate_will , e ) ); 
  }


  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8852 "bc/src/thread.c"
static Scheme_Object * will_executor_try (int argc , Scheme_Object * * argv ) 
{
  WillExecutor * w ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(w, 0), PUSH(argv, 1)));
# define XfOrM1393_COUNT (2)
# define SETUP_XfOrM1393(x) SETUP(XfOrM1393_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  w = NULLED_OUT ; 

# 8856 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) != (Scheme_Type ) (scheme_will_executor_type ) ) 
    FUNCCALL_EMPTY(scheme_wrong_contract ("will-try-execute" , "will-executor?" , 0 , argc , argv ) ); 

  w = (WillExecutor * ) argv [0 ] ; 

  if (FUNCCALL(SETUP_XfOrM1393(_), scheme_wait_sema (w -> sema , 1 ) ))
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_next_will (w ) )) RET_VALUE_EMPTY_END ; 
  else if (argc > 1 )
    RET_VALUE_START (argv [1 ] ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8869 "bc/src/thread.c"
static Scheme_Object * will_executor_go (int argc , Scheme_Object * * argv ) 
{
  WillExecutor * w ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(w, 0)));
# define XfOrM1394_COUNT (1)
# define SETUP_XfOrM1394(x) SETUP(XfOrM1394_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  w = NULLED_OUT ; 

# 8873 "bc/src/thread.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) != (Scheme_Type ) (scheme_will_executor_type ) ) 
    FUNCCALL_EMPTY(scheme_wrong_contract ("will-execute" , "will-executor?" , 0 , argc , argv ) ); 

  w = (WillExecutor * ) argv [0 ] ; 
  FUNCCALL(SETUP_XfOrM1394(_), scheme_wait_sema (w -> sema , 0 ) )
  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_next_will (w ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8883 "bc/src/thread.c"
static Scheme_Object * will_executor_sema (Scheme_Object * w , int * repost ) 
{
  /* No conversion */

# 8885 "bc/src/thread.c"
  * repost = 1 ; 
  return ((WillExecutor * ) w ) -> sema ; 
}









static Scheme_Object * memory_order (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 8899 "bc/src/thread.c"
  return scheme_void ; 
}





typedef struct Scheme_GC_Pre_Post_Callback_Desc {

  Scheme_Object * boxed_key ; 
  Scheme_Object * pre_desc ; 
  Scheme_Object * post_desc ; 
  struct Scheme_GC_Pre_Post_Callback_Desc * prev ; 
  struct Scheme_GC_Pre_Post_Callback_Desc * next ; 
}

# 8913 "bc/src/thread.c"
Scheme_GC_Pre_Post_Callback_Desc ; 


Scheme_Object * scheme_add_gc_callback (Scheme_Object * pre , Scheme_Object * post ) 
{
  Scheme_GC_Pre_Post_Callback_Desc * desc ; 
  Scheme_Object * key , * boxed ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(pre, 0), PUSH(boxed, 1), PUSH(key, 2), PUSH(desc, 3), PUSH(post, 4)));
# define XfOrM1397_COUNT (5)
# define SETUP_XfOrM1397(x) SETUP(XfOrM1397_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  desc = NULLED_OUT ; 
  key = NULLED_OUT ; 
  boxed = NULLED_OUT ; 

# 8921 "bc/src/thread.c"
  desc = (Scheme_GC_Pre_Post_Callback_Desc * ) FUNCCALL(SETUP_XfOrM1397(_), GC_malloc (sizeof (Scheme_GC_Pre_Post_Callback_Desc ) ) ); 
  desc -> pre_desc = pre ; 
  desc -> post_desc = post ; 

  key = FUNCCALL(SETUP_XfOrM1397(_), scheme_make_vector (1 , scheme_false ) ); 
  boxed = FUNCCALL_AGAIN(scheme_make_weak_box (key ) ); 
  desc -> boxed_key = boxed ; 

  desc -> next = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prepost_callback_descs_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prepost_callback_descs_ ) = desc ; 

  RET_VALUE_START (key ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8935 "bc/src/thread.c"
void scheme_remove_gc_callback (Scheme_Object * key ) 
{
  /* No conversion */

# 8937 "bc/src/thread.c"
  Scheme_GC_Pre_Post_Callback_Desc * prev = ((void * ) 0 ) , * desc ; 

  desc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prepost_callback_descs_ ) ; 
  while (desc ) {
    if (((((Scheme_Small_Object * ) (desc -> boxed_key ) ) -> u . ptr_val ) ) == (key ) )  {
      if (prev )
        prev -> next = desc -> next ; 
      else 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prepost_callback_descs_ ) = desc -> next ; 
      if (desc -> next )
        desc -> next -> prev = desc -> prev ; 
    }
    prev = desc ; 
    desc = desc -> next ; 
  }
}

static Scheme_Object * unsafe_add_collect_callbacks (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8956 "bc/src/thread.c"
  return scheme_add_gc_callback (argv [0 ] , argv [1 ] ) ; 
}

static Scheme_Object * unsafe_remove_collect_callbacks (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8961 "bc/src/thread.c"
  scheme_remove_gc_callback (argv [0 ] ) ; 
  return scheme_void ; 
}







typedef void (* gccb_Int_to_Void ) (int ) ; 
typedef void (* gccb_Ptr_Ptr_Ptr_Int_to_Void ) (void * , void * , void * , int ) ; 
typedef void (* gccb_Ptr_Ptr_Ptr_to_Void ) (void * , void * , void * ) ; 
typedef void * (* gccb_Ptr_Ptr_to_Ptr ) (void * , void * ) ; 
typedef void (* gccb_Ptr_Ptr_to_Void ) (void * , void * ) ; 
typedef void (* gccb_Ptr_Ptr_Float_to_Void ) (void * , void * , float ) ; 
typedef void (* gccb_Ptr_Ptr_Double_to_Void ) (void * , void * , double ) ; 
typedef void (* gccb_Float_Float_Float_Float_to_Void ) (float , float , float , float ) ; 
typedef void (* gccb_Ptr_Ptr_Ptr_Nine_Ints ) (void * , void * , void * , int , int , int , int , int , int , int , int , int ) ; 
typedef void (* gccb_OSapi_Ptr_Int_to_Void ) (void * , int ) ; 
typedef void (* gccb_OSapi_Ptr_Ptr_to_Void ) (void * , void * ) ; 
typedef void (* gccb_OSapi_Ptr_Four_Ints_Ptr_Int_Int_Long_to_Void ) (void * , int , int , int , int , 
void * , int , int , long ) ; 





static void run_gc_callbacks (int pre ) 
XFORM_SKIP_PROC 
{
  Scheme_GC_Pre_Post_Callback_Desc * prev = ((void * ) 0 ) , * desc ; 
  Scheme_Object * acts , * act , * protocol ; 
  void * save = ((void * ) 0 ) ; 
  int j ; 

  desc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prepost_callback_descs_ ) ; 
  while (desc ) {
    if (! (((Scheme_Small_Object * ) (desc -> boxed_key ) ) -> u . ptr_val ) ) {
      if (prev )
        prev -> next = desc -> next ; 
      else 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prepost_callback_descs_ ) = desc -> next ; 
      if (desc -> next )
        desc -> next -> prev = desc -> prev ; 
    }

# 9006 "bc/src/thread.c"
    else {
      if (pre )
        acts = desc -> pre_desc ; 
      else 
      acts = desc -> post_desc ; 
      for (j = 0 ; j < (((Scheme_Vector * ) (acts ) ) -> size ) ; j ++ ) {
        act = (((Scheme_Vector * ) (acts ) ) -> els ) [j ] ; 
        protocol = (((Scheme_Vector * ) (act ) ) -> els ) [0 ] ; 


        if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "int->void" ) ) {
          gccb_Int_to_Void proc ; 
          int i ; 

          proc = (gccb_Int_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          i = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ) >> 1 ) ; 

          proc (i ) ; 
        }

# 9024 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "ptr_ptr_ptr_int->void" ) ) {
          gccb_Ptr_Ptr_Ptr_Int_to_Void proc ; 
          void * a , * b , * c ; 
          int i ; 

          proc = (gccb_Ptr_Ptr_Ptr_Int_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ; 
          c = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [4 ] ) ; 
          i = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [5 ] ) ) >> 1 ) ; 

          proc (a , b , c , i ) ; 
        }

# 9036 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "ptr_ptr->save" ) ) {
          gccb_Ptr_Ptr_to_Ptr proc ; 
          void * a , * b ; 

          proc = (gccb_Ptr_Ptr_to_Ptr ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ; 

          save = proc (a , b ) ; 
        }

# 9045 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "save!_ptr->void" ) ) {
          if (save ) {
            gccb_Ptr_Ptr_to_Void proc ; 
            void * b ; 

            proc = (gccb_Ptr_Ptr_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
            b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 

            proc (save , b ) ; 
          }
        }

# 9055 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "ptr_ptr_ptr->void" ) ) {
          gccb_Ptr_Ptr_Ptr_to_Void proc ; 
          void * a , * b , * c ; 

          proc = (gccb_Ptr_Ptr_Ptr_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ; 
          c = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [4 ] ) ; 

          proc (a , b , c ) ; 
        }

# 9065 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "ptr_ptr_float->void" ) ) {
          gccb_Ptr_Ptr_Float_to_Void proc ; 
          void * a , * b ; 
          float f ; 

          proc = (gccb_Ptr_Ptr_Float_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ; 
          f = (((Scheme_Double * ) ((((Scheme_Vector * ) (act ) ) -> els ) [4 ] ) ) -> double_val ) ; 

          proc (a , b , f ) ; 
        }

# 9076 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "ptr_ptr_double->void" ) ) {
          gccb_Ptr_Ptr_Double_to_Void proc ; 
          void * a , * b ; 
          double d ; 

          proc = (gccb_Ptr_Ptr_Double_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ; 
          d = (((Scheme_Double * ) ((((Scheme_Vector * ) (act ) ) -> els ) [4 ] ) ) -> double_val ) ; 

          proc (a , b , d ) ; 
        }

# 9087 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "float_float_float_float->void" ) ) {
          gccb_Float_Float_Float_Float_to_Void proc ; 
          double d1 , d2 , d3 , d4 ; 

          proc = (gccb_Float_Float_Float_Float_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          d1 = (((Scheme_Double * ) ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ) -> double_val ) ; 
          d2 = (((Scheme_Double * ) ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ) -> double_val ) ; 
          d3 = (((Scheme_Double * ) ((((Scheme_Vector * ) (act ) ) -> els ) [4 ] ) ) -> double_val ) ; 
          d4 = (((Scheme_Double * ) ((((Scheme_Vector * ) (act ) ) -> els ) [5 ] ) ) -> double_val ) ; 

          proc (d1 , d2 , d3 , d4 ) ; 
        }

# 9098 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "ptr_ptr_ptr_int_int_int_int_int_int_int_int_int->void" ) ) {
          gccb_Ptr_Ptr_Ptr_Nine_Ints proc ; 
          void * a , * b , * c ; 
          int i1 , i2 , i3 , i4 , i5 , i6 , i7 , i8 , i9 ; 

          proc = (gccb_Ptr_Ptr_Ptr_Nine_Ints ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ; 
          c = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [4 ] ) ; 
          i1 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [5 ] ) ) >> 1 ) ; 
          i2 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [6 ] ) ) >> 1 ) ; 
          i3 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [7 ] ) ) >> 1 ) ; 
          i4 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [8 ] ) ) >> 1 ) ; 
          i5 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [9 ] ) ) >> 1 ) ; 
          i6 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [10 ] ) ) >> 1 ) ; 
          i7 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [11 ] ) ) >> 1 ) ; 
          i8 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [12 ] ) ) >> 1 ) ; 
          i9 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [13 ] ) ) >> 1 ) ; 

          proc (a , b , c , i1 , i2 , i3 , i4 , i5 , i6 , i7 , i8 , i9 ) ; 
        }

# 9118 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "osapi_ptr_ptr->void" ) ) {
          gccb_OSapi_Ptr_Ptr_to_Void proc ; 
          void * a , * b ; 

          proc = (gccb_OSapi_Ptr_Ptr_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ; 

          proc (a , b ) ; 
        }

# 9127 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "osapi_ptr_int->void" ) ) {
          gccb_OSapi_Ptr_Int_to_Void proc ; 
          void * a ; 
          int i ; 

          proc = (gccb_OSapi_Ptr_Int_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          i = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ) >> 1 ) ; 

          proc (a , i ) ; 
        }

# 9137 "bc/src/thread.c"
        else if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (protocol ) ) ) -> s ) , "osapi_ptr_int_int_int_int_ptr_int_int_long->void" ) ) {
          gccb_OSapi_Ptr_Four_Ints_Ptr_Int_Int_Long_to_Void proc ; 
          void * a , * b ; 
          int i1 , i2 , i3 , i4 , i5 , i6 ; 
          long l1 ; 

          proc = (gccb_OSapi_Ptr_Four_Ints_Ptr_Int_Int_Long_to_Void ) scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [1 ] ) ; 
          a = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [2 ] ) ; 
          i1 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [3 ] ) ) >> 1 ) ; 
          i2 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [4 ] ) ) >> 1 ) ; 
          i3 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [5 ] ) ) >> 1 ) ; 
          i4 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [6 ] ) ) >> 1 ) ; 
          b = scheme_extract_pointer ((((Scheme_Vector * ) (act ) ) -> els ) [7 ] ) ; 
          i5 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [8 ] ) ) >> 1 ) ; 
          i6 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [9 ] ) ) >> 1 ) ; 
          l1 = (((intptr_t ) ((((Scheme_Vector * ) (act ) ) -> els ) [10 ] ) ) >> 1 ) ; 

          proc (a , i1 , i2 , i3 , i4 , b , i5 , i6 , l1 ) ; 
        }
        prev = desc ; 
      }
    }
    desc = desc -> next ; 
  }
}





void scheme_zero_unneeded_rands (Scheme_Thread * p ) 
{
}



static void prepare_thread_for_GC (Scheme_Object * t ) 
{
  Scheme_Thread * p = (Scheme_Thread * ) t ; 

  if (! p -> running )

# 9177 "bc/src/thread.c"
  return ; 



  if (! p -> nestee ) {
    Scheme_Saved_Stack * saved ; 

    ; 

    if ((! p -> runstack_owner 
    || (p == * p -> runstack_owner ) ) 
    && p -> runstack_start ) {
      intptr_t rs_end ; 
      Scheme_Object * * rs_start ; 


      if (p -> meta_prompt && (scheme_prompt_runstack_boundary_start (p -> meta_prompt ) == p -> runstack_start ) ) {
        rs_end = p -> meta_prompt -> runstack_boundary_offset ; 
      }

# 9195 "bc/src/thread.c"
      else {
        rs_end = p -> runstack_size ; 
      }

      if ((p -> runstack_tmp_keep >= p -> runstack_start ) 
      && (p -> runstack_tmp_keep < p -> runstack ) )
        rs_start = p -> runstack_tmp_keep ; 
      else 
      rs_start = p -> runstack ; 

      scheme_set_runstack_limits (p -> runstack_start , 
      p -> runstack_size , 
      rs_start - p -> runstack_start , 
      rs_end ) ; 

      ; 

      for (saved = p -> runstack_saved ; saved ; saved = saved -> prev ) {
        ; 

        if (p -> meta_prompt && (scheme_prompt_runstack_boundary_start (p -> meta_prompt ) == saved -> runstack_start ) ) {
          rs_end = p -> meta_prompt -> runstack_boundary_offset ; 
        }

# 9217 "bc/src/thread.c"
        else {
          rs_end = saved -> runstack_size ; 
        }

        if (saved -> runstack_start )
          scheme_set_runstack_limits (saved -> runstack_start , 
        saved -> runstack_size , 
        saved -> runstack_offset , 
        rs_end ) ; 
      }
    }

    ; 

    if (p -> tail_buffer && (p -> tail_buffer != p -> runstack_tmp_keep ) ) {
      int i ; 
      for (i = 0 ; i < p -> tail_buffer_size ; i ++ ) {
        p -> tail_buffer [i ] = ((void * ) 0 ) ; 
      }
    }
  }

  if ((! p -> cont_mark_stack_owner 
  || (p == * p -> cont_mark_stack_owner ) ) 
  && p -> cont_mark_stack ) {
    int segcount , i , segpos ; 


    if (p -> cont_mark_stack )
      segcount = ((intptr_t ) (p -> cont_mark_stack - 1 ) >> 6 ) + 1 ; 
    else 
    segcount = 0 ; 
    for (i = segcount ; i < p -> cont_mark_seg_count ; i ++ ) {
      p -> cont_mark_stack_segments [i ] = ((void * ) 0 ) ; 
    }
    if (segcount < p -> cont_mark_seg_count )
      p -> cont_mark_seg_count = segcount ; 


    segpos = ((intptr_t ) p -> cont_mark_stack >> 6 ) ; 

    if (segpos < p -> cont_mark_seg_count ) {
      Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [segpos ] ; 
      int stackpos = ((intptr_t ) p -> cont_mark_stack & ((1 << 6 ) - 1 ) ) ; 
      if (seg ) {
        for (i = stackpos ; i < (1 << 6 ) ; i ++ ) {
          if (seg [i ] . key ) {
            seg [i ] . key = ((void * ) 0 ) ; 
            seg [i ] . val = ((void * ) 0 ) ; 
            seg [i ] . cache = ((void * ) 0 ) ; 
          }

# 9267 "bc/src/thread.c"
          else {

            break ; 
          }
        }
      }
    }

    {
      intptr_t pos ; 

      for (pos = 0 ; pos < p -> cont_mark_stack_bottom ; pos ++ ) {
        Scheme_Cont_Mark * seg ; 
        int stackpos ; 
        segpos = ((intptr_t ) pos >> 6 ) ; 
        seg = p -> cont_mark_stack_segments [segpos ] ; 
        if (seg ) {
          stackpos = ((intptr_t ) pos & ((1 << 6 ) - 1 ) ) ; 
          seg [stackpos ] . key = ((void * ) 0 ) ; 
          seg [stackpos ] . val = ((void * ) 0 ) ; 
          seg [stackpos ] . cache = ((void * ) 0 ) ; 
        }
      }
    }
  }

  if (p -> values_buffer ) {
    if (p -> values_buffer_size > 128 )
      p -> values_buffer = ((void * ) 0 ) ; 
    else {
      memset (p -> values_buffer , 0 , sizeof (Scheme_Object * ) * p -> values_buffer_size ) ; 
    }
  }

  p -> spare_runstack = ((void * ) 0 ) ; 
}

void scheme_prepare_this_thread_for_GC (Scheme_Thread * p ) 
{
  if (p == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 
  }

  prepare_thread_for_GC ((Scheme_Object * ) p ) ; 
}

static void get_ready_for_GC () 
{
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> start_this_gc_real_time_ ) = scheme_get_inexact_milliseconds () ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> start_this_gc_time_ ) = scheme_get_process_milliseconds () ; 

# 9334 "bc/src/thread.c"
  run_gc_callbacks (1 ) ; 

  scheme_zero_unneeded_rands (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ; 

  scheme_clear_prompt_cache () ; 
  scheme_clear_rx_buffers () ; 
  scheme_clear_bignum_cache () ; 
  scheme_clear_delayed_load_cache () ; 

  scheme_clear_place_ifs_stack () ; 



  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 
  }



  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) ) {
    Scheme_Thread * p , * next ; 
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) ; 
    while (p != p -> gc_prep_chain ) {
      prepare_thread_for_GC ((Scheme_Object * ) p ) ; 
      next = p -> gc_prep_chain ; 
      p -> gc_prep_chain = ((void * ) 0 ) ; 
      p = next ; 
    }
    prepare_thread_for_GC ((Scheme_Object * ) p ) ; 
    p -> gc_prep_chain = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) = ((void * ) 0 ) ; 
  }


  scheme_flush_stack_copy_cache () ; 


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_jit_stack_boundary_ ) = (uintptr_t ) - 1 ; 





  {
    GC_CAN_IGNORE void * data ; 
    data = scheme_gmp_tls_load (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls_data = data ; 
  }







  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_did_gc_count_ ) ++ ; 
}

extern int GC_words_allocd ; 

static void done_with_GC () 
{
  scheme_gmp_tls_unload (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls_data ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gmp_tls_data = ((void * ) 0 ) ; 



  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> running ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_start ; 
  }






  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> end_this_gc_time_ ) = scheme_get_process_milliseconds () ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> end_this_gc_real_time_ ) = scheme_get_inexact_milliseconds () ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) += (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> end_this_gc_time_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> start_this_gc_time_ ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_prep_thread_chain_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> gc_prep_chain = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  run_gc_callbacks (0 ) ; 
}

# 9478 "bc/src/thread.c"
static void inform_GC (int master_gc , int major_gc , int inc_gc , 
intptr_t pre_used , intptr_t post_used , 
intptr_t pre_admin , intptr_t post_admin , 
intptr_t post_child_places_used ) 
{
  Scheme_Logger * logger ; 
  int debug_gc = 0 , debug_gc_major = 0 ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(logger, 0)));
# define XfOrM1405_COUNT (1)
# define SETUP_XfOrM1405(x) SETUP(XfOrM1405_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  logger = NULLED_OUT ; 

# 9486 "bc/src/thread.c"
  if (! master_gc ) {
    if ((pre_used > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_gc_pre_used_bytes_ ) ) 
    && (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_gc_pre_used_bytes_ ) >= 0 ) )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_gc_pre_used_bytes_ ) = pre_used ; 
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_code_page_total_ ) )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_code_page_total_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) ; 
  }

  if (major_gc )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> num_major_garbage_collections_ ) ++ ; 
  else 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> num_minor_garbage_collections_ ) ++ ; 

  logger = FUNCCALL(SETUP_XfOrM1405(_), scheme_get_gc_logger () ); 
  if (logger && FUNCCALL(SETUP_XfOrM1405(_), scheme_log_level_topic_p (logger , 5 , gc_symbol ) ))
    debug_gc = 1 ; 
  if (logger && major_gc && FUNCCALL(SETUP_XfOrM1405(_), scheme_log_level_topic_p (logger , 5 , gc_major_symbol ) ))
    debug_gc_major = 1 ; 

  if (debug_gc || debug_gc_major ) {



    char buf [256 ] , nums [128 ] ; 
    intptr_t buflen , delta , admin_delta ; 
    Scheme_Object * vec , * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM1405_COUNT), PUSH(vec, 1+XfOrM1405_COUNT)));
#   define XfOrM1407_COUNT (2+XfOrM1405_COUNT)
#   define SETUP_XfOrM1407(x) SETUP(XfOrM1407_COUNT)
    vec = NULLED_OUT ; 
    v = NULLED_OUT ; 

# 9513 "bc/src/thread.c"
    vec = scheme_false ; 
    if (! master_gc && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_info_prefab_ ) ) {
#     define XfOrM1408_COUNT (0+XfOrM1407_COUNT)
#     define SETUP_XfOrM1408(x) SETUP_XfOrM1407(x)

# 9515 "bc/src/thread.c"
      vec = FUNCCALL(SETUP_XfOrM1408(_), scheme_make_vector (11 , scheme_false ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (major_gc 
      ? major_symbol 
      : (inc_gc ? incremental_symbol : minor_symbol ) ) ; 
      (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pre_used ) ) ) << 1 ) | 0x1 ) ) ; 
      (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pre_admin ) ) ) << 1 ) | 0x1 ) ) ; 
      (((Scheme_Vector * ) (vec ) ) -> els ) [4 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) ) ) ) << 1 ) | 0x1 ) ) ; 
      (((Scheme_Vector * ) (vec ) ) -> els ) [5 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (post_used ) ) ) << 1 ) | 0x1 ) ) ; 
      (((Scheme_Vector * ) (vec ) ) -> els ) [6 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (post_admin ) ) ) << 1 ) | 0x1 ) ) ; 
      v = FUNCCALL(SETUP_XfOrM1408(_), scheme_make_integer_value (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> start_this_gc_time_ ) ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [7 ] = v ; 
      v = FUNCCALL(SETUP_XfOrM1408(_), scheme_make_integer_value (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> end_this_gc_time_ ) ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [8 ] = v ; 
      v = FUNCCALL(SETUP_XfOrM1408(_), scheme_make_double (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> start_this_gc_real_time_ ) ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [9 ] = v ; 
      v = FUNCCALL(SETUP_XfOrM1408(_), scheme_make_double (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> end_this_gc_real_time_ ) ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [10 ] = v ; 
      vec = FUNCCALL(SETUP_XfOrM1408(_), scheme_make_prefab_struct_instance (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> gc_info_prefab_ ) , vec ) ); 
    }



    memset (nums , 0 , sizeof (nums ) ) ; 

    delta = pre_used - post_used ; 
    admin_delta = (pre_admin - post_admin ) - delta ; 
    sprintf (buf , 
    "GC: " "%d:" "%s @ %sK(+%sK)[+%sK];" 
    " free %sK(%s%sK) %" "l" "d" "ms @ %" "l" "d" , 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) , 

    (master_gc ? "MST" : (major_gc ? "MAJ" : (inc_gc ? "mIn" : "min" ) ) ) , 
    gc_num (nums , pre_used ) , gc_num (nums , pre_admin - pre_used ) , 
    gc_num (nums , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) ) , 
    gc_num (nums , delta ) , ((admin_delta < 0 ) ? "" : "+" ) , gc_num (nums , admin_delta ) , 
    (master_gc ? 0 : (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> end_this_gc_time_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> start_this_gc_time_ ) ) ) , 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> start_this_gc_time_ ) ) ; 
    buflen = strlen (buf ) ; 



    if (debug_gc )
      FUNCCALL(SETUP_XfOrM1407(_), scheme_log_name_pfx_message (logger , 5 , gc_symbol , buf , buflen , vec , 0 ) ); 
    if (debug_gc_major )
      FUNCCALL_EMPTY(scheme_log_name_pfx_message (logger , 5 , gc_major_symbol , buf , buflen , vec , 0 ) ); 
  }


  if (! master_gc ) {
#   define XfOrM1406_COUNT (0+XfOrM1405_COUNT)
#   define SETUP_XfOrM1406(x) SETUP_XfOrM1405(x)
    FUNCCALL_EMPTY(scheme_place_set_memory_use (post_used + post_child_places_used ) )
# 9565 "bc/src/thread.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9571 "bc/src/thread.c"
static void log_peak_memory_use () 
{
  PREPARE_VAR_STACK(6);
# define XfOrM1410_COUNT (0)
# define SETUP_XfOrM1410(x) SETUP(XfOrM1410_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 9573 "bc/src/thread.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_gc_pre_used_bytes_ ) > 0 ) {
    Scheme_Logger * logger ; 
    int debug_gc = 0 , debug_gc_major = 0 ; 
    BLOCK_SETUP((PUSH(logger, 0+XfOrM1410_COUNT)));
#   define XfOrM1411_COUNT (1+XfOrM1410_COUNT)
#   define SETUP_XfOrM1411(x) SETUP(XfOrM1411_COUNT)
    logger = NULLED_OUT ; 

# 9577 "bc/src/thread.c"
    logger = FUNCCALL(SETUP_XfOrM1411(_), scheme_get_gc_logger () ); 
    if (logger && FUNCCALL(SETUP_XfOrM1411(_), scheme_log_level_topic_p (logger , 4 , gc_symbol ) ))
      debug_gc = 1 ; 
    if (logger && FUNCCALL(SETUP_XfOrM1411(_), scheme_log_level_topic_p (logger , 4 , gc_major_symbol ) ))
      debug_gc_major = 1 ; 

    if (debug_gc || debug_gc_major ) {
      char buf [256 ] , nums [128 ] , * num , * numc , * numt , * num2 , * numa ; 
      intptr_t buflen , allocated_bytes , max_bytes ; 
      BLOCK_SETUP((PUSH(num, 0+XfOrM1411_COUNT), PUSH(numc, 1+XfOrM1411_COUNT), PUSH(num2, 2+XfOrM1411_COUNT), PUSH(numt, 3+XfOrM1411_COUNT), PUSH(numa, 4+XfOrM1411_COUNT)));
#     define XfOrM1412_COUNT (5+XfOrM1411_COUNT)
#     define SETUP_XfOrM1412(x) SETUP(XfOrM1412_COUNT)
      num = NULLED_OUT ; 
      numc = NULLED_OUT ; 
      numt = NULLED_OUT ; 
      num2 = NULLED_OUT ; 
      numa = NULLED_OUT ; 

# 9587 "bc/src/thread.c"
      allocated_bytes = FUNCCALL(SETUP_XfOrM1412(_), GC_get_memory_ever_used () ); 




      max_bytes = FUNCCALL_AGAIN(GC_get_memory_max_allocated () ); 
      (


      memset (nums , 0 , sizeof (nums ) ) ) ; 
      num = FUNCCALL(SETUP_XfOrM1412(_), gc_num (nums , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_gc_pre_used_bytes_ ) ) ); 
      numa = FUNCCALL_AGAIN(gc_num (nums , max_bytes - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_gc_pre_used_bytes_ ) ) ); 
      numc = FUNCCALL_AGAIN(gc_num (nums , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_code_page_total_ ) ) ); 
      numt = FUNCCALL_AGAIN(gc_num (nums , allocated_bytes ) ); 
      num2 = FUNCCALL_AGAIN(gc_unscaled_num (nums , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ) ); 
      (sprintf (buf , 
      "GC: " "%d:" "atexit peak %sK(+%sK)[+%sK]; alloc %sK; major %d; minor %d; %sms" , 

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) , 

      num , 
      numa , 
      numc , 
      numt , 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> num_major_garbage_collections_ ) , 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> num_minor_garbage_collections_ ) , 
      num2 ) ) ; 
      buflen = strlen (buf ) ; 

      if (debug_gc )
        FUNCCALL(SETUP_XfOrM1412(_), scheme_log_name_pfx_message (logger , 4 , gc_symbol , buf , buflen , scheme_false , 0 ) ); 
      if (debug_gc_major )
        FUNCCALL_EMPTY(scheme_log_name_pfx_message (logger , 4 , gc_major_symbol , buf , buflen , scheme_false , 0 ) ); 


      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_gc_pre_used_bytes_ ) = - 1 ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9627 "bc/src/thread.c"
static char * gc_unscaled_num (char * nums , intptr_t v ) 

{
  /* No conversion */

# 9630 "bc/src/thread.c"
  int i , j , len , clen , c , d ; 
  for (i = 0 ; nums [i ] || nums [i + 1 ] ; i ++ ) {
  }
  i ++ ; 

  sprintf (nums + i , "%" "l" "d" , v ) ; 
  for (len = 0 ; nums [i + len ] ; len ++ ) {
  }

# 9637 "bc/src/thread.c"
  clen = len + ((len + ((nums [i ] == '-' ) ? - 2 : - 1 ) ) / 3 ) ; 

  c = 0 ; 
  d = (clen - len ) ; 
  for (j = i + clen - 1 ; j > i ; j -- ) {
    if (c == 3 ) {
      nums [j ] = ',' ; 
      d -- ; 
      c = 0 ; 
    }

# 9646 "bc/src/thread.c"
    else {
      nums [j ] = nums [j - d ] ; 
      c ++ ; 
    }
  }

  return nums + i ; 
}

static char * gc_num (char * nums , intptr_t v ) 
{
  /* No conversion */

# 9657 "bc/src/thread.c"
  return gc_unscaled_num (nums , v / 1024 ) ; 
}





static void set_perf_vector (Scheme_Object * v , Scheme_Object * ov , int i , Scheme_Object * a ) 
{
  /* No conversion */

# 9666 "bc/src/thread.c"
  if ((v ) == (ov ) ) 
    (((Scheme_Vector * ) (v ) ) -> els ) [i ] = a ; 
  else 
  scheme_chaperone_vector_set (ov , i , a ) ; 
}

static Scheme_Object * current_stats (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v , * ov ; 
  Scheme_Thread * t = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(ov, 1), PUSH(v, 2), PUSH(t, 3)));
# define XfOrM1426_COUNT (4)
# define SETUP_XfOrM1426(x) SETUP(XfOrM1426_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  ov = NULLED_OUT ; 

# 9677 "bc/src/thread.c"
  v = argv [0 ] ; 

  ov = v ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (! (((Scheme_Inclhash_Object * ) (v ) ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL(SETUP_XfOrM1426(_), scheme_wrong_contract ("vector-set-performance-stats!" , "(and/c vector? (not/c immutable?))" , 0 , argc , argv ) ); 
  if (argc > 1 ) {
#   define XfOrM1446_COUNT (0+XfOrM1426_COUNT)
#   define SETUP_XfOrM1446(x) SETUP_XfOrM1426(x)

# 9686 "bc/src/thread.c"
    if (! (((argv [1 ] ) ) == (scheme_false ) ) ) {
#     define XfOrM1447_COUNT (0+XfOrM1446_COUNT)
#     define SETUP_XfOrM1447(x) SETUP_XfOrM1446(x)

# 9687 "bc/src/thread.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
        FUNCCALL(SETUP_XfOrM1447(_), scheme_wrong_contract ("vector-set-performance-stats!" , "(or/c thread? #f)" , 0 , argc , argv ) ); 
      t = (Scheme_Thread * ) argv [1 ] ; 
    }
  }

  if (t ) {
#   define XfOrM1429_COUNT (0+XfOrM1426_COUNT)
#   define SETUP_XfOrM1429(x) SETUP_XfOrM1426(x)

# 9694 "bc/src/thread.c"
    switch ((((Scheme_Vector * ) (v ) ) -> size ) ) {
#     define XfOrM1430_COUNT (0+XfOrM1429_COUNT)
#     define SETUP_XfOrM1430(x) SETUP_XfOrM1429(x)

# 9695 "bc/src/thread.c"
      default : 
      case 4 : 
      {

        intptr_t sz = 0 ; 
#       define XfOrM1433_COUNT (0+XfOrM1430_COUNT)
#       define SETUP_XfOrM1433(x) SETUP_XfOrM1430(x)

# 9701 "bc/src/thread.c"
        if ((t -> running ) && ! ((t -> running ) & 0x4 ) )  {
          Scheme_Overflow * overflow ; 
          Scheme_Saved_Stack * runstack_saved ; 
          overflow = NULLED_OUT ; 
          runstack_saved = NULLED_OUT ; 
          if (t == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
            void * stk_start , * stk_end ; 
            stk_start = NULLED_OUT ; 
            stk_end = NULLED_OUT ; 

# 9708 "bc/src/thread.c"
            stk_start = t -> stack_start ; 
            stk_end = (void * ) & stk_end ; 




            sz = (intptr_t ) stk_start XFORM_OK_MINUS (intptr_t ) stk_end ; 
          }
          else {
            if (t -> jmpup_buf . stack_copy )
              sz = t -> jmpup_buf . stack_size ; 
          }
          for (overflow = t -> overflow ; overflow ; overflow = overflow -> prev ) {
            sz += overflow -> jmp -> cont . stack_size ; 
          }


          {
            int ssz ; 
            if (t == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
              ssz = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + t -> runstack_size ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
            }

# 9729 "bc/src/thread.c"
            else {
              ssz = (t -> runstack_start + t -> runstack_size ) - t -> runstack ; 
            }
            for (runstack_saved = t -> runstack_saved ; runstack_saved ; runstack_saved = runstack_saved -> prev ) {
              ssz += runstack_saved -> runstack_size ; 
            }
            sz += sizeof (Scheme_Object * ) * ssz ; 
          }


          if (t == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
            sz += ((intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) >> 1 ) * sizeof (Scheme_Cont_Mark ) ; 
          }

# 9741 "bc/src/thread.c"
          else {
            sz += ((intptr_t ) t -> cont_mark_pos >> 1 ) * sizeof (Scheme_Cont_Mark ) ; 
          }
        }
        FUNCCALL(SETUP_XfOrM1433(_), set_perf_vector (v , ov , 3 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (sz ) ) ) << 1 ) | 0x1 ) ) ) )
        ; 
      }
      case 3 : FUNCCALL(SETUP_XfOrM1430(_), set_perf_vector (v , ov , 2 , (t -> block_descriptor ? scheme_true : ((t -> running & 0x2 ) ? scheme_true : scheme_false ) ) ) )




      ; 
      case 2 : 
      {
        Scheme_Object * dp ; 
        BLOCK_SETUP((PUSH(dp, 0+XfOrM1430_COUNT)));
#       define XfOrM1432_COUNT (1+XfOrM1430_COUNT)
#       define SETUP_XfOrM1432(x) SETUP(XfOrM1432_COUNT)
        dp = NULLED_OUT ; 

# 9757 "bc/src/thread.c"
        dp = FUNCCALL(SETUP_XfOrM1432(_), thread_dead_p (1 , (Scheme_Object * * ) (void * ) & t ) ); 
        FUNCCALL_AGAIN(set_perf_vector (v , ov , 1 , dp ) ); 
      }
      case 1 : 
      {
        Scheme_Object * rp ; 
        BLOCK_SETUP((PUSH(rp, 0+XfOrM1430_COUNT)));
#       define XfOrM1431_COUNT (1+XfOrM1430_COUNT)
#       define SETUP_XfOrM1431(x) SETUP(XfOrM1431_COUNT)
        rp = NULLED_OUT ; 

# 9763 "bc/src/thread.c"
        rp = FUNCCALL(SETUP_XfOrM1431(_), thread_running_p (1 , (Scheme_Object * * ) (void * ) & t ) ); 
        FUNCCALL_AGAIN(set_perf_vector (v , ov , 0 , rp ) ); 
      }
      case 0 : 
      break ; 
    }
  }

# 9769 "bc/src/thread.c"
  else {
    intptr_t cpuend , end , gcend ; 
#   define XfOrM1427_COUNT (0+XfOrM1426_COUNT)
#   define SETUP_XfOrM1427(x) SETUP_XfOrM1426(x)

# 9772 "bc/src/thread.c"
    cpuend = (scheme_get_process_milliseconds () ) ; 
    end = (scheme_get_milliseconds () ) ; 
    gcend = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ; 

    switch ((((Scheme_Vector * ) (v ) ) -> size ) ) {
#     define XfOrM1428_COUNT (0+XfOrM1427_COUNT)
#     define SETUP_XfOrM1428(x) SETUP_XfOrM1427(x)

# 9777 "bc/src/thread.c"
      default : 
      case 12 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 11 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> max_gc_pre_used_bytes_ ) ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 11 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 10 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 10 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 9 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_hash_iteration_count_ ) ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 9 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 8 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_hash_request_count_ ) ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 8 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 7 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_num_read_syntax_objects_ ) ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 7 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 6 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> num_running_threads_ ) + 1 ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 6 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 5 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_count_ ) ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 5 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 4 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> thread_swap_count_ ) ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 4 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 3 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_did_gc_count_ ) ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 3 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 2 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (gcend ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 2 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (end ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 1 : FUNCCALL(SETUP_XfOrM1428(_), set_perf_vector (v , ov , 0 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cpuend ) ) ) << 1 ) | 0x1 ) ) ) )
      ; 
      case 0 : 
      break ; 
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}









void * scheme_malloc_gmp (uintptr_t amt , void * * mem_pool ) 
{
  void * p , * mp ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(mem_pool, 0), PUSH(p, 1), PUSH(mp, 2)));
# define XfOrM1448_COUNT (3)
# define SETUP_XfOrM1448(x) SETUP(XfOrM1448_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  mp = NULLED_OUT ; 

# 9826 "bc/src/thread.c"
  p = FUNCCALL(SETUP_XfOrM1448(_), GC_malloc_atomic_allow_interior (amt ) ); 

  mp = FUNCCALL_AGAIN(scheme_make_raw_pair (p , * mem_pool ) ); 
  * mem_pool = mp ; 

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9834 "bc/src/thread.c"
void scheme_free_gmp (void * p , void * * mem_pool ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(mem_pool, 0)));
# define XfOrM1449_COUNT (1)
# define SETUP_XfOrM1449(x) SETUP(XfOrM1449_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 9836 "bc/src/thread.c"
  if (p != (((Scheme_Simple_Object * ) (* mem_pool ) ) -> u . pair_val . car ) )
    FUNCCALL(SETUP_XfOrM1449(_), scheme_log (((void * ) 0 ) , 1 , 0 , "bad GMP memory free" ) )


  ; 
  * mem_pool = (((Scheme_Simple_Object * ) (* mem_pool ) ) -> u . pair_val . cdr ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Jumpup_Buf_Holder * scheme_new_jmpupbuf_holder (void ) 




{
  Scheme_Jumpup_Buf_Holder * h ; 
  DECL_RET_SAVE (Scheme_Jumpup_Buf_Holder * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(h, 0)));
# define XfOrM1450_COUNT (1)
# define SETUP_XfOrM1450(x) SETUP(XfOrM1450_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  h = NULLED_OUT ; 

# 9856 "bc/src/thread.c"
  h = ((Scheme_Jumpup_Buf_Holder * ) FUNCCALL(SETUP_XfOrM1450(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Jumpup_Buf_Holder ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  h -> type = scheme_rt_buf_holder ; 


  RET_VALUE_START (h ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9865 "bc/src/thread.c"
uintptr_t scheme_get_current_thread_stack_start (void ) 
{
  /* No conversion */

# 9867 "bc/src/thread.c"
  Scheme_Thread * p ; 
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  return (uintptr_t ) p -> stack_start ; 
}

# 3 "bc/src/mzmark_thread.inc"
static int mark_parameterization_SIZE (void * p , struct NewGC * gc ) {




  return 0 ; 
}


static int mark_parameterization_MARK (void * p , struct NewGC * gc ) {

  Scheme_Parameterization * c = (Scheme_Parameterization * ) p ; 
  int i ; 

  for (i = max_configs ; i -- ; ) {
    GC_mark2 (& (c -> prims [i ] ) , gc ) ; 
  }
  GC_mark2 (& (c -> extensions ) , gc ) ; 


  return 0 ; 
}







static int mark_parameterization_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Parameterization * c = (Scheme_Parameterization * ) p ; 
  int i ; 

  for (i = max_configs ; i -- ; ) {
    GC_fixup2 (& (c -> prims [i ] ) , gc ) ; 
  }
  GC_fixup2 (& (c -> extensions ) , gc ) ; 


  return 0 ; 
}

# 56 "bc/src/mzmark_thread.inc"
static int mark_config_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_config_MARK (void * p , struct NewGC * gc ) {

  Scheme_Config * config = (Scheme_Config * ) p ; 
  GC_mark2 (& (config -> ht ) , gc ) ; 
  GC_mark2 (& (config -> root ) , gc ) ; 

  return 0 ; 
}






static int mark_config_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Config * config = (Scheme_Config * ) p ; 
  GC_fixup2 (& (config -> ht ) , gc ) ; 
  GC_fixup2 (& (config -> root ) , gc ) ; 

  return 0 ; 
}

# 96 "bc/src/mzmark_thread.inc"
static int mark_will_executor_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_will_executor_val_MARK (void * p , struct NewGC * gc ) {

  WillExecutor * e = (WillExecutor * ) p ; 

  GC_mark2 (& (e -> sema ) , gc ) ; 
  GC_mark2 (& (e -> first ) , gc ) ; 
  GC_mark2 (& (e -> last ) , gc ) ; 


  return 0 ; 
}






static int mark_will_executor_val_FIXUP (void * p , struct NewGC * gc ) {

  WillExecutor * e = (WillExecutor * ) p ; 

  GC_fixup2 (& (e -> sema ) , gc ) ; 
  GC_fixup2 (& (e -> first ) , gc ) ; 
  GC_fixup2 (& (e -> last ) , gc ) ; 


  return 0 ; 
}

# 142 "bc/src/mzmark_thread.inc"
static int mark_custodian_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_custodian_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Custodian * m = (Scheme_Custodian * ) p ; 

  GC_mark2 (& (m -> boxes ) , gc ) ; 
  GC_mark2 (& (m -> mrefs ) , gc ) ; 
  GC_mark2 (& (m -> closers ) , gc ) ; 
  GC_mark2 (& (m -> data ) , gc ) ; 
  GC_mark2 (& (m -> data_ptr ) , gc ) ; 
  GC_mark2 (& (m -> post_callbacks ) , gc ) ; 

  GC_mark2 (& (m -> parent ) , gc ) ; 
  GC_mark2 (& (m -> sibling ) , gc ) ; 
  GC_mark2 (& (m -> children ) , gc ) ; 

  GC_mark2 (& (m -> global_next ) , gc ) ; 
  GC_mark2 (& (m -> global_prev ) , gc ) ; 

  GC_mark2 (& (m -> cust_boxes ) , gc ) ; 


  return 0 ; 
}






static int mark_custodian_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Custodian * m = (Scheme_Custodian * ) p ; 

  GC_fixup2 (& (m -> boxes ) , gc ) ; 
  GC_fixup2 (& (m -> mrefs ) , gc ) ; 
  GC_fixup2 (& (m -> closers ) , gc ) ; 
  GC_fixup2 (& (m -> data ) , gc ) ; 
  GC_fixup2 (& (m -> data_ptr ) , gc ) ; 
  GC_fixup2 (& (m -> post_callbacks ) , gc ) ; 

  GC_fixup2 (& (m -> parent ) , gc ) ; 
  GC_fixup2 (& (m -> sibling ) , gc ) ; 
  GC_fixup2 (& (m -> children ) , gc ) ; 

  GC_fixup2 (& (m -> global_next ) , gc ) ; 
  GC_fixup2 (& (m -> global_prev ) , gc ) ; 

  GC_fixup2 (& (m -> cust_boxes ) , gc ) ; 


  return 0 ; 
}

# 212 "bc/src/mzmark_thread.inc"
static int mark_custodian_box_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_custodian_box_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Custodian_Box * b = (Scheme_Custodian_Box * ) p ; 
  int sd = ((Scheme_Custodian * ) GC_resolve2 (b -> cust , gc ) ) -> shut_down ; 

  GC_mark2 (& (b -> cust ) , gc ) ; 
  if (! sd ) {
    GC_mark2 (& (b -> v ) , gc ) ; 
  }


  return 0 ; 
}






static int mark_custodian_box_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Custodian_Box * b = (Scheme_Custodian_Box * ) p ; 
  int sd = ((Scheme_Custodian * ) GC_resolve2 (b -> cust , gc ) ) -> shut_down ; 

  GC_fixup2 (& (b -> cust ) , gc ) ; 
  if (! sd ) {
    GC_fixup2 (& (b -> v ) , gc ) ; 
  }


  return 0 ; 
}

# 262 "bc/src/mzmark_thread.inc"
static int mark_thread_hop_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_thread_hop_MARK (void * p , struct NewGC * gc ) {

  Scheme_Thread_Custodian_Hop * hop = (Scheme_Thread_Custodian_Hop * ) p ; 

  GC_mark2 (& (hop -> p ) , gc ) ; 


  return 0 ; 
}






static int mark_thread_hop_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Thread_Custodian_Hop * hop = (Scheme_Thread_Custodian_Hop * ) p ; 

  GC_fixup2 (& (hop -> p ) , gc ) ; 


  return 0 ; 
}

# 304 "bc/src/mzmark_thread.inc"
static int mark_param_data_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_param_data_MARK (void * p , struct NewGC * gc ) {

  ParamData * d = (ParamData * ) p ; 

  GC_mark2 (& (d -> key ) , gc ) ; 
  GC_mark2 (& (d -> guard ) , gc ) ; 
  GC_mark2 (& (d -> extract_guard ) , gc ) ; 
  GC_mark2 (& (d -> defcell ) , gc ) ; 


  return 0 ; 
}






static int mark_param_data_FIXUP (void * p , struct NewGC * gc ) {

  ParamData * d = (ParamData * ) p ; 

  GC_fixup2 (& (d -> key ) , gc ) ; 
  GC_fixup2 (& (d -> guard ) , gc ) ; 
  GC_fixup2 (& (d -> extract_guard ) , gc ) ; 
  GC_fixup2 (& (d -> defcell ) , gc ) ; 


  return 0 ; 
}

# 352 "bc/src/mzmark_thread.inc"
static int mark_will_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_will_MARK (void * p , struct NewGC * gc ) {

  ActiveWill * w = (ActiveWill * ) p ; 

  GC_mark2 (& (w -> o ) , gc ) ; 
  GC_mark2 (& (w -> proc ) , gc ) ; 
  GC_mark2 (& (w -> w ) , gc ) ; 
  GC_mark2 (& (w -> next ) , gc ) ; 


  return 0 ; 
}






static int mark_will_FIXUP (void * p , struct NewGC * gc ) {

  ActiveWill * w = (ActiveWill * ) p ; 

  GC_fixup2 (& (w -> o ) , gc ) ; 
  GC_fixup2 (& (w -> proc ) , gc ) ; 
  GC_fixup2 (& (w -> w ) , gc ) ; 
  GC_fixup2 (& (w -> next ) , gc ) ; 


  return 0 ; 
}

# 400 "bc/src/mzmark_thread.inc"
static int mark_evt_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_evt_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int mark_evt_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 434 "bc/src/mzmark_thread.inc"
static int mark_syncing_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_syncing_MARK (void * p , struct NewGC * gc ) {

  Syncing * w = (Syncing * ) p ; 

  GC_mark2 (& (w -> set ) , gc ) ; 
  GC_mark2 (& (w -> wrapss ) , gc ) ; 
  GC_mark2 (& (w -> nackss ) , gc ) ; 
  GC_mark2 (& (w -> reposts ) , gc ) ; 
  GC_mark2 (& (w -> accepts ) , gc ) ; 
  GC_mark2 (& (w -> disable_break ) , gc ) ; 
  GC_mark2 (& (w -> thread ) , gc ) ; 


  return 0 ; 
}






static int mark_syncing_FIXUP (void * p , struct NewGC * gc ) {

  Syncing * w = (Syncing * ) p ; 

  GC_fixup2 (& (w -> set ) , gc ) ; 
  GC_fixup2 (& (w -> wrapss ) , gc ) ; 
  GC_fixup2 (& (w -> nackss ) , gc ) ; 
  GC_fixup2 (& (w -> reposts ) , gc ) ; 
  GC_fixup2 (& (w -> accepts ) , gc ) ; 
  GC_fixup2 (& (w -> disable_break ) , gc ) ; 
  GC_fixup2 (& (w -> thread ) , gc ) ; 


  return 0 ; 
}

# 488 "bc/src/mzmark_thread.inc"
static int mark_evt_set_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_evt_set_MARK (void * p , struct NewGC * gc ) {

  Evt_Set * w = (Evt_Set * ) p ; 

  GC_mark2 (& (w -> ws ) , gc ) ; 
  GC_mark2 (& (w -> argv ) , gc ) ; 


  return 0 ; 
}






static int mark_evt_set_FIXUP (void * p , struct NewGC * gc ) {

  Evt_Set * w = (Evt_Set * ) p ; 

  GC_fixup2 (& (w -> ws ) , gc ) ; 
  GC_fixup2 (& (w -> argv ) , gc ) ; 


  return 0 ; 
}

# 532 "bc/src/mzmark_thread.inc"
static int mark_thread_set_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_thread_set_MARK (void * p , struct NewGC * gc ) {

  Scheme_Thread_Set * ts = (Scheme_Thread_Set * ) p ; 

  GC_mark2 (& (ts -> parent ) , gc ) ; 
  GC_mark2 (& (ts -> first ) , gc ) ; 
  GC_mark2 (& (ts -> next ) , gc ) ; 
  GC_mark2 (& (ts -> prev ) , gc ) ; 
  GC_mark2 (& (ts -> search_start ) , gc ) ; 
  GC_mark2 (& (ts -> current ) , gc ) ; 


  return 0 ; 
}






static int mark_thread_set_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Thread_Set * ts = (Scheme_Thread_Set * ) p ; 

  GC_fixup2 (& (ts -> parent ) , gc ) ; 
  GC_fixup2 (& (ts -> first ) , gc ) ; 
  GC_fixup2 (& (ts -> next ) , gc ) ; 
  GC_fixup2 (& (ts -> prev ) , gc ) ; 
  GC_fixup2 (& (ts -> search_start ) , gc ) ; 
  GC_fixup2 (& (ts -> current ) , gc ) ; 


  return 0 ; 
}

# 584 "bc/src/mzmark_thread.inc"
static int mark_thread_cell_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_thread_cell_MARK (void * p , struct NewGC * gc ) {

  Thread_Cell * c = (Thread_Cell * ) p ; 

  GC_mark2 (& (c -> def_val ) , gc ) ; 


  return 0 ; 
}






static int mark_thread_cell_FIXUP (void * p , struct NewGC * gc ) {

  Thread_Cell * c = (Thread_Cell * ) p ; 

  GC_fixup2 (& (c -> def_val ) , gc ) ; 


  return 0 ; 
}

# 626 "bc/src/mzmark_thread.inc"
static int mark_plumber_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_plumber_MARK (void * p , struct NewGC * gc ) {

  Scheme_Plumber * pl = (Scheme_Plumber * ) p ; 

  GC_mark2 (& (pl -> handles ) , gc ) ; 
  GC_mark2 (& (pl -> weak_handles ) , gc ) ; 


  return 0 ; 
}






static int mark_plumber_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Plumber * pl = (Scheme_Plumber * ) p ; 

  GC_fixup2 (& (pl -> handles ) , gc ) ; 
  GC_fixup2 (& (pl -> weak_handles ) , gc ) ; 


  return 0 ; 
}

# 9879 "bc/src/thread.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_will_executor_type , mark_will_executor_val_SIZE , mark_will_executor_val_MARK , mark_will_executor_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_custodian_type , mark_custodian_val_SIZE , mark_custodian_val_MARK , mark_custodian_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_cust_box_type , mark_custodian_box_val_SIZE , mark_custodian_box_val_MARK , mark_custodian_box_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_thread_hop_type , mark_thread_hop_SIZE , mark_thread_hop_MARK , mark_thread_hop_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_evt_set_type , mark_evt_set_SIZE , mark_evt_set_MARK , mark_evt_set_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_thread_set_type , mark_thread_set_SIZE , mark_thread_set_MARK , mark_thread_set_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_config_type , mark_config_SIZE , mark_config_MARK , mark_config_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_thread_cell_type , mark_thread_cell_SIZE , mark_thread_cell_MARK , mark_thread_cell_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_plumber_type , mark_plumber_SIZE , mark_plumber_MARK , mark_plumber_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_rt_param_data , mark_param_data_SIZE , mark_param_data_MARK , mark_param_data_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_will , mark_will_SIZE , mark_will_MARK , mark_will_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_evt , mark_evt_SIZE , mark_evt_MARK , mark_evt_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_rt_syncing , mark_syncing_SIZE , mark_syncing_MARK , mark_syncing_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_parameterization , mark_parameterization_SIZE , mark_parameterization_MARK , mark_parameterization_FIXUP , 0 , 0 ) ; 
}
